/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ne=function(X){for(var e=[],S=0,R=X.length;S<R;S++)e[S]=ie[X[S]];return e};define(ie[134],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function S(m,b,$){const u=R(m,b);if(u!==-1)return m[u]}e.$fb=S;function R(m,b,$=m.length-1){for(let u=$;u>=0;u--){const l=m[u];if(b(l))return u}return-1}e.$gb=R;function s(m,b){const $=O(m,b);return $===-1?void 0:m[$]}e.$hb=s;function O(m,b,$=0,u=m.length){let l=$,E=u;for(;l<E;){const h=Math.floor((l+E)/2);b(m[h])?l=h+1:E=h}return l-1}e.$ib=O;function C(m,b){const $=P(m,b);return $===m.length?void 0:m[$]}e.$jb=C;function P(m,b,$=0,u=m.length){let l=$,E=u;for(;l<E;){const h=Math.floor((l+E)/2);b(m[h])?E=h:l=h+1}return l}e.$kb=P;function f(m,b,$=0,u=m.length){const l=P(m,b,$,u);return l===m.length?-1:l}e.$lb=f;class a{static{this.assertInvariants=!1}constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(a.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!b(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const $=O(this.e,b,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=a;function g(m,b){if(m.length===0)return;let $=m[0];for(let u=1;u<m.length;u++){const l=m[u];b(l,$)>0&&($=l)}return $}e.$nb=g;function w(m,b){if(m.length===0)return;let $=m[0];for(let u=1;u<m.length;u++){const l=m[u];b(l,$)>=0&&($=l)}return $}e.$ob=w;function y(m,b){return g(m,($,u)=>-b($,u))}e.$pb=y;function d(m,b){if(m.length===0)return-1;let $=0;for(let u=1;u<m.length;u++){const l=m[u];b(l,m[$])>0&&($=u)}return $}e.$qb=d;function v(m,b){for(const $ of m){const u=b($);if(u!==void 0)return u}}e.$rb=v}),define(ie[135],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function S(C,P){const f=Object.create(null);for(const a of C){const g=P(a);let w=f[g];w||(w=f[g]=[]),w.push(a)}return f}e.$J=S;function R(C,P){const f=[],a=[];for(const g of C)P.has(g)||f.push(g);for(const g of P)C.has(g)||a.push(g);return{removed:f,added:a}}e.$K=R;function s(C,P){const f=[],a=[];for(const[g,w]of C)P.has(g)||f.push(w);for(const[g,w]of P)C.has(g)||a.push(w);return{removed:f,added:a}}e.$L=s;function O(C,P){const f=new Set;for(const a of P)C.has(a)&&f.add(a);return f}e.$M=O}),define(ie[136],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.$Xs=e.$Ws=e.$Vs=void 0;function S(P,f){const a=Math.pow(10,f);return Math.round(P*a)/a}class R{constructor(f,a,g,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=S(Math.max(Math.min(1,w),0),3)}static equals(f,a){return f.r===a.r&&f.g===a.g&&f.b===a.b&&f.a===a.a}}e.$Vs=R;class s{constructor(f,a,g,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,a),0),3),this.l=S(Math.max(Math.min(1,g),0),3),this.a=S(Math.max(Math.min(1,w),0),3)}static equals(f,a){return f.h===a.h&&f.s===a.s&&f.l===a.l&&f.a===a.a}static fromRGBA(f){const a=f.r/255,g=f.g/255,w=f.b/255,y=f.a,d=Math.max(a,g,w),v=Math.min(a,g,w);let m=0,b=0;const $=(v+d)/2,u=d-v;if(u>0){switch(b=Math.min($<=.5?u/(2*$):u/(2-2*$),1),d){case a:m=(g-w)/u+(g<w?6:0);break;case g:m=(w-a)/u+2;break;case w:m=(a-g)/u+4;break}m*=60,m=Math.round(m)}return new s(m,b,$,y)}static i(f,a,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?f+(a-f)*6*g:g<1/2?a:g<2/3?f+(a-f)*(2/3-g)*6:f}static toRGBA(f){const a=f.h/360,{s:g,l:w,a:y}=f;let d,v,m;if(g===0)d=v=m=w;else{const b=w<.5?w*(1+g):w+g-w*g,$=2*w-b;d=s.i($,b,a+1/3),v=s.i($,b,a),m=s.i($,b,a-1/3)}return new R(Math.round(d*255),Math.round(v*255),Math.round(m*255),y)}}e.$Ws=s;class O{constructor(f,a,g,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,a),0),3),this.v=S(Math.max(Math.min(1,g),0),3),this.a=S(Math.max(Math.min(1,w),0),3)}static equals(f,a){return f.h===a.h&&f.s===a.s&&f.v===a.v&&f.a===a.a}static fromRGBA(f){const a=f.r/255,g=f.g/255,w=f.b/255,y=Math.max(a,g,w),d=Math.min(a,g,w),v=y-d,m=y===0?0:v/y;let b;return v===0?b=0:y===a?b=((g-w)/v%6+6)%6:y===g?b=(w-a)/v+2:b=(a-g)/v+4,new O(Math.round(b*60),m,y,f.a)}static toRGBA(f){const{h:a,s:g,v:w,a:y}=f,d=w*g,v=d*(1-Math.abs(a/60%2-1)),m=w-d;let[b,$,u]=[0,0,0];return a<60?(b=d,$=v):a<120?(b=v,$=d):a<180?($=d,u=v):a<240?($=v,u=d):a<300?(b=v,u=d):a<=360&&(b=d,u=v),b=Math.round((b+m)*255),$=Math.round(($+m)*255),u=Math.round((u+m)*255),new R(b,$,u,y)}}e.$Xs=O;class C{static fromHex(f){return C.Format.CSS.parseHex(f)||C.red}static equals(f,a){return!f&&!a?!0:!f||!a?!1:f.equals(a)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof R)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof O)this.j=f,this.rgba=O.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&R.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&O.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=C.k(this.rgba.r),a=C.k(this.rgba.g),g=C.k(this.rgba.b),w=.2126*f+.7152*a+.0722*g;return S(w,4)}static k(f){const a=f/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(f){const a=this.getRelativeLuminance(),g=f.getRelativeLuminance();return a>g?(a+.05)/(g+.05):(g+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const a=this.getRelativeLuminance(),g=f.getRelativeLuminance();return a>g}isDarkerThan(f){const a=this.getRelativeLuminance(),g=f.getRelativeLuminance();return a<g}lighten(f){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:a,g,b:w,a:y}=this.rgba;return new C(new R(a,g,w,y*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const a=f.rgba,g=this.rgba.a,w=a.a,y=g+w*(1-g);if(y<1e-6)return C.transparent;const d=this.rgba.r*g/y+a.r*w*(1-g)/y,v=this.rgba.g*g/y+a.g*w*(1-g)/y,m=this.rgba.b*g/y+a.b*w*(1-g)/y;return new C(new R(d,v,m,y))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:a,g,b:w,a:y}=this.rgba;return new C(new R(f.rgba.r-y*(f.rgba.r-a),f.rgba.g-y*(f.rgba.g-g),f.rgba.b-y*(f.rgba.b-w),1))}flatten(...f){const a=f.reduceRight((g,w)=>C.o(w,g));return C.o(this,a)}static o(f,a){const g=1-f.rgba.a;return new C(new R(g*a.rgba.r+f.rgba.a*f.rgba.r,g*a.rgba.g+f.rgba.a*f.rgba.g,g*a.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(f,a,g){if(f.isLighterThan(a))return f;g=g||.5;const w=f.getRelativeLuminance(),y=a.getRelativeLuminance();return g=g*(y-w)/y,f.lighten(g)}static getDarkerColor(f,a,g){if(f.isDarkerThan(a))return f;g=g||.5;const w=f.getRelativeLuminance(),y=a.getRelativeLuminance();return g=g*(w-y)/w,f.darken(g)}static{this.white=new C(new R(255,255,255,1))}static{this.black=new C(new R(0,0,0,1))}static{this.red=new C(new R(255,0,0,1))}static{this.blue=new C(new R(0,0,255,1))}static{this.green=new C(new R(0,255,0,1))}static{this.cyan=new C(new R(0,255,255,1))}static{this.lightgrey=new C(new R(211,211,211,1))}static{this.transparent=new C(new R(0,0,0,0))}}e.$Ys=C,function(P){let f;(function(a){let g;(function(w){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:P.Format.CSS.formatRGBA(i)}w.formatRGB=y;function d(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}w.formatRGBA=d;function v(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(i)}w.formatHSL=v;function m(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}w.formatHSLA=m;function b(i){const c=i.toString(16);return c.length!==2?"0"+c:c}function $(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}w.formatHex=$;function u(i,c=!1){return c&&i.rgba.a===1?P.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}w.formatHexA=u;function l(i){return i.isOpaque()?P.Format.CSS.formatHex(i):P.Format.CSS.formatRGBA(i)}w.format=l;function E(i){const c=i.length;if(c===0||i.charCodeAt(0)!==35)return null;if(c===7){const o=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),t=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),n=16*h(i.charCodeAt(5))+h(i.charCodeAt(6));return new P(new R(o,t,n,1))}if(c===9){const o=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),t=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),n=16*h(i.charCodeAt(5))+h(i.charCodeAt(6)),r=16*h(i.charCodeAt(7))+h(i.charCodeAt(8));return new P(new R(o,t,n,r/255))}if(c===4){const o=h(i.charCodeAt(1)),t=h(i.charCodeAt(2)),n=h(i.charCodeAt(3));return new P(new R(16*o+o,16*t+t,16*n+n))}if(c===5){const o=h(i.charCodeAt(1)),t=h(i.charCodeAt(2)),n=h(i.charCodeAt(3)),r=h(i.charCodeAt(4));return new P(new R(16*o+o,16*t+t,16*n+n,(16*r+r)/255))}return null}w.parseHex=E;function h(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=a.CSS||(a.CSS={}))})(f=P.Format||(P.Format={}))}(C||(e.$Ys=C={}))}),define(ie[54],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function S(C){return(P,f,a)=>{let g=null,w=null;if(typeof a.value=="function"?(g="value",w=a.value):typeof a.get=="function"&&(g="get",w=a.get),!w)throw new Error("not supported");a[g]=C(w,f)}}function R(C,P,f){let a=null,g=null;if(typeof f.value=="function"?(a="value",g=f.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(a="get",g=f.get),!g)throw new Error("not supported");const w=`$memoize$${P}`;f[a]=function(...y){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,y)}),this[w]}}e.$hh=R;function s(C,P,f){return S((a,g)=>{const w=`$debounce$${g}`,y=`$debounce$result$${g}`;return function(...d){this[y]||(this[y]=f?f():void 0),clearTimeout(this[w]),P&&(this[y]=P(this[y],...d),d=[this[y]]),this[w]=setTimeout(()=>{a.apply(this,d),this[y]=f?f():void 0},C)}})}e.$ih=s;function O(C,P,f){return S((a,g)=>{const w=`$throttle$timer$${g}`,y=`$throttle$result$${g}`,d=`$throttle$lastRun$${g}`,v=`$throttle$pending$${g}`;return function(...m){if(this[y]||(this[y]=f?f():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...m)),this[v])return;const b=this[d]+C;b<=Date.now()?(this[d]=Date.now(),a.apply(this,[this[y]]),this[y]=f?f():void 0):(this[v]=!0,this[w]=setTimeout(()=>{this[v]=!1,this[d]=Date.now(),a.apply(this,[this[y]]),this[y]=f?f():void 0},b-Date.now()))}})}e.$jh=O}),define(ie[14],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class S{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(c=>{c(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=S,e.$X=new S;function R(h){e.$X.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=R;function s(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function O(h){a(h)||e.$X.onUnexpectedError(h)}e.$1=O;function C(h){a(h)||e.$X.onUnexpectedExternalError(h)}e.$2=C;function P(h){if(h instanceof Error){const{name:i,message:c}=h,o=h.stacktrace||h.stack;return{$isError:!0,name:i,message:c,stack:o,noTelemetry:l.isErrorNoTelemetry(h)}}return h}e.$3=P;const f="Canceled";function a(h){return h instanceof g?!0:h instanceof Error&&h.name===f&&h.message===f}e.$4=a;class g extends Error{constructor(){super(f),this.name=this.message}}e.$5=g;function w(){const h=new Error(f);return h.name=h.message,h}e.$6=w;function y(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$7=y;function d(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$8=d;class v extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function m(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$0=m;class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=b;class $ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=$;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const c=new l;return c.message=i.message,c.stack=i.stack,c}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=l;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$cb=E}),define(ie[23],ne([0,1,14,134]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(L,V=0){return L[L.length-(1+V)]}e.$sb=s;function O(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.$tb=O;function C(L,V,J=(oe,le)=>oe===le){if(L===V)return!0;if(!L||!V||L.length!==V.length)return!1;for(let oe=0,le=L.length;oe<le;oe++)if(!J(L[oe],V[oe]))return!1;return!0}e.$ub=C;function P(L,V){const J=L.length-1;V<J&&(L[V]=L[J]),L.pop()}e.$vb=P;function f(L,V,J){return a(L.length,oe=>J(L[oe],V))}e.$wb=f;function a(L,V){let J=0,oe=L-1;for(;J<=oe;){const le=(J+oe)/2|0,de=V(le);if(de<0)J=le+1;else if(de>0)oe=le-1;else return le}return-(J+1)}e.$xb=a;function g(L,V,J){if(L=L|0,L>=V.length)throw new TypeError("invalid index");const oe=V[Math.floor(V.length*Math.random())],le=[],de=[],fe=[];for(const ve of V){const me=J(ve,oe);me<0?le.push(ve):me>0?de.push(ve):fe.push(ve)}return L<le.length?g(L,le,J):L<le.length+fe.length?fe[0]:g(L-(le.length+fe.length),de,J)}e.$yb=g;function w(L,V){const J=[];let oe;for(const le of L.slice(0).sort(V))!oe||V(oe[0],le)!==0?(oe=[le],J.push(oe)):oe.push(le);return J}e.$zb=w;function*y(L,V){let J,oe;for(const le of L)oe!==void 0&&V(oe,le)?J.push(le):(J&&(yield J),J=[le]),oe=le;J&&(yield J)}e.$Ab=y;function d(L,V){for(let J=0;J<=L.length;J++)V(J===0?void 0:L[J-1],J===L.length?void 0:L[J])}e.$Bb=d;function v(L,V){for(let J=0;J<L.length;J++)V(J===0?void 0:L[J-1],L[J],J+1===L.length?void 0:L[J+1])}e.$Cb=v;function m(L,V,J){const oe=[];function le(ve,me,ye){if(me===0&&ye.length===0)return;const Oe=oe[oe.length-1];Oe&&Oe.start+Oe.deleteCount===ve?(Oe.deleteCount+=me,Oe.toInsert.push(...ye)):oe.push({start:ve,deleteCount:me,toInsert:ye})}let de=0,fe=0;for(;;){if(de===L.length){le(de,0,V.slice(fe));break}if(fe===V.length){le(de,L.length-de,[]);break}const ve=L[de],me=V[fe],ye=J(ve,me);ye===0?(de+=1,fe+=1):ye<0?(le(de,1,[]),de+=1):ye>0&&(le(de,0,[me]),fe+=1)}return oe}e.$Db=m;function b(L,V,J){const oe=m(L,V,J),le=[],de=[];for(const fe of oe)le.push(...L.slice(fe.start,fe.start+fe.deleteCount)),de.push(...fe.toInsert);return{removed:le,added:de}}e.$Eb=b;function $(L,V,J){if(J===0)return[];const oe=L.slice(0,J).sort(V);return l(L,V,oe,J,L.length),oe}e.top=$;function u(L,V,J,oe,le){return J===0?Promise.resolve([]):new Promise((de,fe)=>{(async()=>{const ve=L.length,me=L.slice(0,J).sort(V);for(let ye=J,Oe=Math.min(J+oe,ve);ye<ve;ye=Oe,Oe=Math.min(Oe+oe,ve)){if(ye>J&&await new Promise(Me=>setTimeout(Me)),le&&le.isCancellationRequested)throw new S.$5;l(L,V,me,ye,Oe)}return me})().then(de,fe)})}e.$Gb=u;function l(L,V,J,oe,le){for(const de=J.length;oe<le;oe++){const fe=L[oe];if(V(fe,J[de-1])<0){J.pop();const ve=(0,R.$kb)(J,me=>V(fe,me)<0);J.splice(ve,0,fe)}}}function E(L){return L.filter(V=>!!V)}e.$Hb=E;function h(L){let V=0;for(let J=0;J<L.length;J++)L[J]&&(L[V]=L[J],V+=1);L.length=V}e.$Ib=h;function i(L,V,J){L.splice(J,0,L.splice(V,1)[0])}e.$Jb=i;function c(L){return!Array.isArray(L)||L.length===0}e.$Kb=c;function o(L){return Array.isArray(L)&&L.length>0}e.$Lb=o;function t(L,V=J=>J){const J=new Set;return L.filter(oe=>{const le=V(oe);return J.has(le)?!1:(J.add(le),!0)})}e.$Mb=t;function n(L){const V=new Set;return J=>{const oe=L(J);return V.has(oe)?!1:(V.add(oe),!0)}}e.$Nb=n;function r(L,V){return L.length>0?L[0]:V}e.$Ob=r;function p(L,V){return L.length>0?L[L.length-1]:V}e.$Pb=p;function A(L,V,J=(oe,le)=>oe===le){let oe=0;for(let le=0,de=Math.min(L.length,V.length);le<de&&J(L[le],V[le]);le++)oe++;return oe}e.$Qb=A;function D(L){return[].concat(...L)}e.$Rb=D;function k(L,V){let J=typeof V=="number"?L:0;typeof V=="number"?J=L:(J=0,V=L);const oe=[];if(J<=V)for(let le=J;le<V;le++)oe.push(le);else for(let le=J;le>V;le--)oe.push(le);return oe}e.$Sb=k;function I(L,V,J){return L.reduce((oe,le)=>(oe[V(le)]=J?J(le):le,oe),Object.create(null))}e.$Tb=I;function j(L,V){return L.push(V),()=>N(L,V)}e.$Ub=j;function N(L,V){const J=L.indexOf(V);if(J>-1)return L.splice(J,1),V}e.$Vb=N;function z(L,V,J){const oe=L.slice(0,V),le=L.slice(V);return oe.concat(J,le)}e.$Wb=z;function _(L,V){let J;if(typeof V=="number"){let oe=V;J=()=>{const le=Math.sin(oe++)*179426549;return le-Math.floor(le)}}else J=Math.random;for(let oe=L.length-1;oe>0;oe-=1){const le=Math.floor(J()*(oe+1)),de=L[oe];L[oe]=L[le],L[le]=de}}e.$Xb=_;function Y(L,V){const J=L.indexOf(V);J>-1&&(L.splice(J,1),L.unshift(V))}e.$Yb=Y;function ce(L,V){const J=L.indexOf(V);J>-1&&(L.splice(J,1),L.push(V))}e.$Zb=ce;function re(L,V){for(const J of V)L.push(J)}e.$1b=re;function ae(L,V){return Array.isArray(L)?L.map(V):V(L)}e.$2b=ae;function Z(L){return Array.isArray(L)?L:[L]}e.$3b=Z;function Q(L){return L[Math.floor(Math.random()*L.length)]}e.$4b=Q;function G(L,V,J){const oe=T(L,V),le=L.length,de=J.length;L.length=le+de;for(let fe=le-1;fe>=oe;fe--)L[fe+de]=L[fe];for(let fe=0;fe<de;fe++)L[fe+oe]=J[fe]}e.$5b=G;function q(L,V,J,oe){const le=T(L,V);let de=L.splice(le,J);return de===void 0&&(de=[]),G(L,le,oe),de}e.$6b=q;function T(L,V){return V<0?Math.max(V+L.length,0):Math.min(V,L.length)}var K;(function(L){function V(de){return de<0}L.isLessThan=V;function J(de){return de<=0}L.isLessThanOrEqual=J;function oe(de){return de>0}L.isGreaterThan=oe;function le(de){return de===0}L.isNeitherLessOrGreaterThan=le,L.greaterThan=1,L.lessThan=-1,L.neitherLessOrGreaterThan=0})(K||(e.CompareResult=K={}));function H(L,V){return(J,oe)=>V(L(J),L(oe))}e.$7b=H;function x(...L){return(V,J)=>{for(const oe of L){const le=oe(V,J);if(!K.isNeitherLessOrGreaterThan(le))return le}return K.neitherLessOrGreaterThan}}e.$8b=x;const B=(L,V)=>L-V;e.$9b=B;const F=(L,V)=>(0,e.$9b)(L?1:0,V?1:0);e.$0b=F;function M(L){return(V,J)=>-L(V,J)}e.$$b=M;class U{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let J=this.c;for(;J<this.g.length&&V(this.g[J]);)J++;const oe=J===this.c?null:this.g.slice(this.c,J);return this.c=J,oe}takeFromEndWhile(V){let J=this.d;for(;J>=0&&V(this.g[J]);)J--;const oe=J===this.d?null:this.g.slice(J+1,this.d+1);return this.d=J,oe}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const J=this.g.slice(this.c,this.c+V);return this.c+=V,J}}e.$_b=U;class W{static{this.empty=new W(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(J=>(V(J),!0))}toArray(){const V=[];return this.iterate(J=>(V.push(J),!0)),V}filter(V){return new W(J=>this.iterate(oe=>V(oe)?J(oe):!0))}map(V){return new W(J=>this.iterate(oe=>J(V(oe))))}some(V){let J=!1;return this.iterate(oe=>(J=V(oe),!J)),J}findFirst(V){let J;return this.iterate(oe=>V(oe)?(J=oe,!1):!0),J}findLast(V){let J;return this.iterate(oe=>(V(oe)&&(J=oe),!0)),J}findLastMaxBy(V){let J,oe=!0;return this.iterate(le=>((oe||K.isGreaterThan(V(le,J)))&&(oe=!1,J=le),!0)),J}}e.$ac=W}),define(ie[137],ne([0,1,14]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function R(f,a){if(!f)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=R;function s(f,a="Unreachable"){throw new Error(a)}e.$4c=s;function O(f){if(!f)throw new S.$cb("Assertion Failed")}e.$5c=O;function C(f){if(!f()){debugger;f(),(0,S.$1)(new S.$cb("Assertion Failed"))}}e.$6c=C;function P(f,a){let g=0;for(;g<f.length-1;){const w=f[g],y=f[g+1];if(!a(w,y))return!1;g++}return!0}e.$7c=P}),define(ie[83],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function S(R){const s=this;let O=!1,C;return function(){return O||(O=!0,C=R.apply(s,arguments)),C}}e.$db=S}),define(ie[70],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(R){function s(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}R.is=s;const O=Object.freeze([]);function C(){return O}R.empty=C;function*P(h){yield h}R.single=P;function f(h){return s(h)?h:P(h)}R.wrap=f;function a(h){return h||O}R.from=a;function*g(h){for(let i=h.length-1;i>=0;i--)yield h[i]}R.reverse=g;function w(h){return!h||h[Symbol.iterator]().next().done===!0}R.isEmpty=w;function y(h){return h[Symbol.iterator]().next().value}R.first=y;function d(h,i){for(const c of h)if(i(c))return!0;return!1}R.some=d;function v(h,i){for(const c of h)if(i(c))return c}R.find=v;function*m(h,i){for(const c of h)i(c)&&(yield c)}R.filter=m;function*b(h,i){let c=0;for(const o of h)yield i(o,c++)}R.map=b;function*$(...h){for(const i of h)for(const c of i)yield c}R.concat=$;function u(h,i,c){let o=c;for(const t of h)o=i(o,t);return o}R.reduce=u;function*l(h,i,c=h.length){for(i<0&&(i+=h.length),c<0?c+=h.length:c>h.length&&(c=h.length);i<c;i++)yield h[i]}R.slice=l;function E(h,i=Number.POSITIVE_INFINITY){const c=[];if(i===0)return[c,h];const o=h[Symbol.iterator]();for(let t=0;t<i;t++){const n=o.next();if(n.done)return[c,R.empty()];c.push(n.value)}return[c,{[Symbol.iterator](){return o}}]}R.consume=E})(S||(e.Iterable=S={}))}),define(ie[44],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function C(i,c=!1){let o=0;const t=i.length;let n="",r=0,p=16,A=0;function D(Y){let ce=0,re=0;for(;ce<Y;){const ae=i.charCodeAt(o);if(ae>=48&&ae<=57)re=re*16+ae-48;else if(ae>=65&&ae<=70)re=re*16+ae-65+10;else if(ae>=97&&ae<=102)re=re*16+ae-97+10;else break;o++,ce++}return ce<Y&&(re=-1),re}function k(Y){o=Y,n="",r=0,p=16,A=0}function I(){const Y=o;if(i.charCodeAt(o)===48)o++;else for(o++;o<i.length&&a(i.charCodeAt(o));)o++;if(o<i.length&&i.charCodeAt(o)===46)if(o++,o<i.length&&a(i.charCodeAt(o)))for(o++;o<i.length&&a(i.charCodeAt(o));)o++;else return A=3,i.substring(Y,o);let ce=o;if(o<i.length&&(i.charCodeAt(o)===69||i.charCodeAt(o)===101))if(o++,(o<i.length&&i.charCodeAt(o)===43||i.charCodeAt(o)===45)&&o++,o<i.length&&a(i.charCodeAt(o))){for(o++;o<i.length&&a(i.charCodeAt(o));)o++;ce=o}else A=3;return i.substring(Y,ce)}function j(){let Y="",ce=o;for(;;){if(o>=t){Y+=i.substring(ce,o),A=2;break}const re=i.charCodeAt(o);if(re===34){Y+=i.substring(ce,o),o++;break}if(re===92){if(Y+=i.substring(ce,o),o++,o>=t){A=2;break}switch(i.charCodeAt(o++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const Z=D(4);Z>=0?Y+=String.fromCharCode(Z):A=4;break}default:A=5}ce=o;continue}if(re>=0&&re<=31)if(f(re)){Y+=i.substring(ce,o),A=2;break}else A=6;o++}return Y}function N(){if(n="",A=0,r=o,o>=t)return r=t,p=17;let Y=i.charCodeAt(o);if(P(Y)){do o++,n+=String.fromCharCode(Y),Y=i.charCodeAt(o);while(P(Y));return p=15}if(f(Y))return o++,n+=String.fromCharCode(Y),Y===13&&i.charCodeAt(o)===10&&(o++,n+=`
`),p=14;switch(Y){case 123:return o++,p=1;case 125:return o++,p=2;case 91:return o++,p=3;case 93:return o++,p=4;case 58:return o++,p=6;case 44:return o++,p=5;case 34:return o++,n=j(),p=10;case 47:{const ce=o-1;if(i.charCodeAt(o+1)===47){for(o+=2;o<t&&!f(i.charCodeAt(o));)o++;return n=i.substring(ce,o),p=12}if(i.charCodeAt(o+1)===42){o+=2;const re=t-1;let ae=!1;for(;o<re;){if(i.charCodeAt(o)===42&&i.charCodeAt(o+1)===47){o+=2,ae=!0;break}o++}return ae||(o++,A=1),n=i.substring(ce,o),p=13}return n+=String.fromCharCode(Y),o++,p=16}case 45:if(n+=String.fromCharCode(Y),o++,o===t||!a(i.charCodeAt(o)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),p=11;default:for(;o<t&&z(Y);)o++,Y=i.charCodeAt(o);if(r!==o){switch(n=i.substring(r,o),n){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return n+=String.fromCharCode(Y),o++,p=16}}function z(Y){if(P(Y)||f(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let Y;do Y=N();while(Y>=12&&Y<=15);return Y}return{setPosition:k,getPosition:()=>o,scan:c?_:N,getToken:()=>p,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>o-r,getTokenError:()=>A}}e.$Um=C;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var g;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(g||(g={}));function w(i,c){const o=[],t=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function A(D,k,I,j){r.value=D,r.offset=k,r.length=I,r.type=j,r.colonOffset=void 0,n=r}try{l(i,{onObjectBegin:(D,k)=>{if(c<=D)throw t;n=void 0,p=c>D,o.push("")},onObjectProperty:(D,k,I)=>{if(c<k||(A(D,k,I,"property"),o[o.length-1]=D,c<=k+I))throw t},onObjectEnd:(D,k)=>{if(c<=D)throw t;n=void 0,o.pop()},onArrayBegin:(D,k)=>{if(c<=D)throw t;n=void 0,o.push(0)},onArrayEnd:(D,k)=>{if(c<=D)throw t;n=void 0,o.pop()},onLiteralValue:(D,k,I)=>{if(c<k||(A(D,k,I,h(D)),c<=k+I))throw t},onSeparator:(D,k,I)=>{if(c<=k)throw t;if(D===":"&&n&&n.type==="property")n.colonOffset=k,p=!1,n=void 0;else if(D===","){const j=o[o.length-1];typeof j=="number"?o[o.length-1]=j+1:(p=!0,o[o.length-1]=""),n=void 0}}})}catch(D){if(D!==t)throw D}return{path:o,previousNode:n,isAtPropertyKey:p,matches:D=>{let k=0;for(let I=0;k<D.length&&I<o.length;I++)if(D[k]===o[I]||D[k]==="*")k++;else if(D[k]!=="**")return!1;return k===D.length}}}e.$Vm=w;function y(i,c=[],o=O.DEFAULT){let t=null,n=[];const r=[];function p(D){Array.isArray(n)?n.push(D):t!==null&&(n[t]=D)}return l(i,{onObjectBegin:()=>{const D={};p(D),r.push(n),n=D,t=null},onObjectProperty:D=>{t=D},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const D=[];p(D),r.push(n),n=D,t=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:p,onError:(D,k,I)=>{c.push({error:D,offset:k,length:I})}},o),n[0]}e.$Wm=y;function d(i,c=[],o=O.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(D){t.type==="property"&&(t.length=D-t.offset,t=t.parent)}function r(D){return t.children.push(D),D}l(i,{onObjectBegin:D=>{t=r({type:"object",offset:D,length:-1,parent:t,children:[]})},onObjectProperty:(D,k,I)=>{t=r({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:D,offset:k,length:I,parent:t})},onObjectEnd:(D,k)=>{t.length=D+k-t.offset,t=t.parent,n(D+k)},onArrayBegin:(D,k)=>{t=r({type:"array",offset:D,length:-1,parent:t,children:[]})},onArrayEnd:(D,k)=>{t.length=D+k-t.offset,t=t.parent,n(D+k)},onLiteralValue:(D,k,I)=>{r({type:h(D),offset:k,length:I,parent:t,value:D}),n(k+I)},onSeparator:(D,k,I)=>{t.type==="property"&&(D===":"?t.colonOffset=k:D===","&&n(k))},onError:(D,k,I)=>{c.push({error:D,offset:k,length:I})}},o);const A=t.children[0];return A&&delete A.parent,A}e.$Xm=d;function v(i,c){if(!i)return;let o=i;for(const t of c)if(typeof t=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let n=!1;for(const r of o.children)if(Array.isArray(r.children)&&r.children[0].value===t){o=r.children[1],n=!0;break}if(!n)return}else{const n=t;if(o.type!=="array"||n<0||!Array.isArray(o.children)||n>=o.children.length)return;o=o.children[n]}return o}e.$Ym=v;function m(i){if(!i.parent||!i.parent.children)return[];const c=m(i.parent);if(i.parent.type==="property"){const o=i.parent.children[0].value;c.push(o)}else if(i.parent.type==="array"){const o=i.parent.children.indexOf(i);o!==-1&&c.push(o)}return c}e.$Zm=m;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const c=Object.create(null);for(const o of i.children){const t=o.children[1];t&&(c[o.children[0].value]=b(t))}return c}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$1m=b;function $(i,c,o=!1){return c>=i.offset&&c<i.offset+i.length||o&&c===i.offset+i.length}e.$2m=$;function u(i,c,o=!1){if($(i,c,o)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=c;n++){const r=u(t[n],c,o);if(r)return r}return i}}e.$3m=u;function l(i,c,o=O.DEFAULT){const t=C(i,!1);function n(H){return H?()=>H(t.getTokenOffset(),t.getTokenLength()):()=>!0}function r(H){return H?x=>H(x,t.getTokenOffset(),t.getTokenLength()):()=>!0}const p=n(c.onObjectBegin),A=r(c.onObjectProperty),D=n(c.onObjectEnd),k=n(c.onArrayBegin),I=n(c.onArrayEnd),j=r(c.onLiteralValue),N=r(c.onSeparator),z=n(c.onComment),_=r(c.onError),Y=o&&o.disallowComments,ce=o&&o.allowTrailingComma;function re(){for(;;){const H=t.scan();switch(t.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:Y||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(H){case 12:case 13:Y?ae(10):z();break;case 16:ae(1);break;case 15:case 14:break;default:return H}}}function ae(H,x=[],B=[]){if(_(H),x.length+B.length>0){let F=t.getToken();for(;F!==17;){if(x.indexOf(F)!==-1){re();break}else if(B.indexOf(F)!==-1)break;F=re()}}}function Z(H){const x=t.getTokenValue();return H?j(x):A(x),re(),!0}function Q(){switch(t.getToken()){case 11:{let H=0;try{H=JSON.parse(t.getTokenValue()),typeof H!="number"&&(ae(2),H=0)}catch{ae(2)}j(H);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return re(),!0}function G(){return t.getToken()!==10?(ae(3,[],[2,5]),!1):(Z(!1),t.getToken()===6?(N(":"),re(),K()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function q(){p(),re();let H=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(H||ae(4,[],[]),N(","),re(),t.getToken()===2&&ce)break}else H&&ae(6,[],[]);G()||ae(4,[],[2,5]),H=!0}return D(),t.getToken()!==2?ae(7,[2],[]):re(),!0}function T(){k(),re();let H=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(H||ae(4,[],[]),N(","),re(),t.getToken()===4&&ce)break}else H&&ae(6,[],[]);K()||ae(4,[],[4,5]),H=!0}return I(),t.getToken()!==4?ae(8,[4],[]):re(),!0}function K(){switch(t.getToken()){case 3:return T();case 1:return q();case 10:return Z(!0);default:return Q()}}return re(),t.getToken()===17?o.allowEmptyContent?!0:(ae(4,[],[]),!1):K()?(t.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$4m=l;function E(i,c){const o=C(i),t=[];let n,r=0,p;do switch(p=o.getPosition(),n=o.scan(),n){case 12:case 13:case 17:r!==p&&t.push(i.substring(r,p)),c!==void 0&&t.push(o.getTokenValue().replace(/[^\r\n]/g,c)),r=o.getPosition();break}while(n!==17);return t.join("")}e.$5m=E;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=h}),define(ie[138],ne([0,1,44]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2S=e.$1S=e.$ZS=e.$YS=void 0;function R(a,g,w){let y,d,v,m,b;if(g){for(m=g.offset,b=m+g.length,v=m;v>0&&!f(a,v-1);)v--;let p=b;for(;p<a.length&&!f(a,p);)p++;d=a.substring(v,p),y=C(d,w)}else d=a,y=0,v=0,m=0,b=a.length;const $=P(w,a);let u=!1,l=0,E;w.insertSpaces?E=O(" ",w.tabSize||4):E="	";const h=(0,S.$Um)(d,!1);let i=!1;function c(){return $+O(E,y+l)}function o(){let p=h.scan();for(u=!1;p===15||p===14;)u=u||p===14,p=h.scan();return i=p===16||h.getTokenError()!==0,p}const t=[];function n(p,A,D){!i&&A<b&&D>m&&a.substring(A,D)!==p&&t.push({offset:A,length:D-A,content:p})}let r=o();if(r!==17){const p=h.getTokenOffset()+v,A=O(E,y);n(A,v,p)}for(;r!==17;){let p=h.getTokenOffset()+h.getTokenLength()+v,A=o(),D="";for(;!u&&(A===12||A===13);){const I=h.getTokenOffset()+v;n(" ",p,I),p=h.getTokenOffset()+h.getTokenLength()+v,D=A===12?c():"",A=o()}if(A===2)r!==1&&(l--,D=c());else if(A===4)r!==3&&(l--,D=c());else{switch(r){case 3:case 1:l++,D=c();break;case 5:case 12:D=c();break;case 13:u?D=c():D=" ";break;case 6:D=" ";break;case 10:if(A===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?D=" ":A!==5&&A!==17&&(i=!0);break;case 16:i=!0;break}u&&(A===12||A===13)&&(D=c())}const k=h.getTokenOffset()+v;n(D,p,k),r=A}return t}e.$YS=R;function s(a,g){const w=JSON.stringify(a,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?w.replace(/\r\n|\r|\n/g,g.eol):w}e.$ZS=s;function O(a,g){let w="";for(let y=0;y<g;y++)w+=a;return w}function C(a,g){let w=0,y=0;const d=g.tabSize||4;for(;w<a.length;){const v=a.charAt(w);if(v===" ")y++;else if(v==="	")y+=d;else break;w++}return Math.floor(y/d)}function P(a,g){for(let w=0;w<g.length;w++){const y=g.charAt(w);if(y==="\r")return w+1<g.length&&g.charAt(w+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}e.$1S=P;function f(a,g){return`\r
`.indexOf(a.charAt(g))!==-1}e.$2S=f}),define(ie[139],ne([0,1,44,138]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7S=e.$6S=e.$5S=e.$4S=e.$3S=void 0;function s(a,g,w){return O(a,g,void 0,w)}e.$3S=s;function O(a,g,w,y,d){const v=g.slice(),m=[],b=(0,S.$Xm)(a,m);let $,u;for(;v.length>0&&(u=v.pop(),$=(0,S.$Ym)(b,v),$===void 0&&w!==void 0);)typeof u=="string"?w={[u]:w}:w=[w];if($)if($.type==="object"&&typeof u=="string"&&Array.isArray($.children)){const l=(0,S.$Ym)($,[u]);if(l!==void 0)if(w===void 0){if(!l.parent)throw new Error("Malformed AST");const E=$.children.indexOf(l.parent);let h,i=l.parent.offset+l.parent.length;if(E>0){const c=$.children[E-1];h=c.offset+c.length}else h=$.offset+1,$.children.length>1&&(i=$.children[1].offset);return C(a,{offset:h,length:i-h,content:""},y)}else return C(a,{offset:l.offset,length:l.length,content:JSON.stringify(w)},y);else{if(w===void 0)return[];const E=`${JSON.stringify(u)}: ${JSON.stringify(w)}`,h=d?d($.children.map(c=>c.children[0].value)):$.children.length;let i;if(h>0){const c=$.children[h-1];i={offset:c.offset+c.length,length:0,content:","+E}}else $.children.length===0?i={offset:$.offset+1,length:0,content:E}:i={offset:$.offset+1,length:0,content:E+","};return C(a,i,y)}}else if($.type==="array"&&typeof u=="number"&&Array.isArray($.children))if(w!==void 0){const l=`${JSON.stringify(w)}`;let E;if($.children.length===0||u===0)E={offset:$.offset+1,length:0,content:$.children.length===0?l:l+","};else{const h=u===-1||u>$.children.length?$.children.length:u,i=$.children[h-1];E={offset:i.offset+i.length,length:0,content:","+l}}return C(a,E,y)}else{const l=u,E=$.children[l];let h;if($.children.length===1)h={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===l){const i=$.children[l-1],c=i.offset+i.length,o=$.offset+$.length;h={offset:c,length:o-2-c,content:""}}else h={offset:E.offset,length:$.children[l+1].offset-E.offset,content:""};return C(a,h,y)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${$.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return C(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(w)},y)}}e.$4S=O;function C(a,g,w){let y=P(a,g),d=g.offset,v=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;d>0&&!(0,R.$2S)(y,d-1);)d--;for(;v<y.length&&!(0,R.$2S)(y,v);)v++}const m=(0,R.$YS)(y,{offset:d,length:v-d},w);for(let $=m.length-1;$>=0;$--){const u=m[$];y=P(y,u),d=Math.min(d,u.offset),v=Math.max(v,u.offset+u.length),v+=u.content.length-u.length}const b=a.length-(y.length-v)-d;return[{offset:d,length:b,content:y.substring(d,v)}]}e.$5S=C;function P(a,g){return a.substring(0,g.offset)+g.content+a.substring(g.offset+g.length)}e.$6S=P;function f(a,g){const w=g.slice(0).sort((d,v)=>{const m=d.offset-v.offset;return m===0?d.length-v.length:m});let y=a.length;for(let d=w.length-1;d>=0;d--){const v=w[d];if(v.offset+v.length<=y)a=P(a,v);else throw new Error("Overlapping edit");y=v.offset}return a}e.$7S=f}),define(ie[71],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=S}),define(ie[101],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(O){this.element=O,this.next=S.Undefined,this.prev=S.Undefined}}class R{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let O=this.a;for(;O!==S.Undefined;){const C=O.next;O.prev=S.Undefined,O.next=S.Undefined,O=C}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,C){const P=new S(O);if(this.a===S.Undefined)this.a=P,this.b=P;else if(C){const a=this.b;this.b=P,P.prev=a,a.next=P}else{const a=this.a;this.a=P,P.next=a,a.prev=P}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==S.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==S.Undefined&&O.next!==S.Undefined){const C=O.prev;C.next=O.next,O.next.prev=C}else O.prev===S.Undefined&&O.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):O.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):O.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==S.Undefined;)yield O.element,O=O.next}}e.$2c=R}),define(ie[31],ne([0,1]),function(X,e){"use strict";var S,R,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function O(u,l,E){let h=u.get(l);return h===void 0&&(h=E,u.set(l,h)),h}e.$xc=O;function C(u){const l=[];return u.forEach((E,h)=>{l.push(`${h} => ${E}`)}),`Map(${u.size}) {${l.join(", ")}}`}e.$yc=C;function P(u){const l=[];return u.forEach(E=>{l.push(E)}),`Set(${u.size}) {${l.join(", ")}}`}e.$zc=P;class f{constructor(l,E){this.uri=l,this.value=E}}function a(u){return Array.isArray(u)}class g{static{this.a=l=>l.toString()}constructor(l,E){if(this[S]="ResourceMap",l instanceof g)this.b=new Map(l.b),this.c=E??g.a;else if(a(l)){this.b=new Map,this.c=E??g.a;for(const[h,i]of l)this.set(h,i)}else this.b=new Map,this.c=l??g.a}set(l,E){return this.b.set(this.c(l),new f(l,E)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,E){typeof E<"u"&&(l=l.bind(E));for(const[h,i]of this.b)l(i.value,i.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}e.$Ac=g;class w{constructor(l,E){this[R]="ResourceSet",!l||typeof l=="function"?this.a=new g(l):(this.a=new g(E),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,E){this.a.forEach((h,i)=>l.call(E,i,i,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=w;var y;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class d{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,E=0){const h=this.a.get(l);if(h)return E!==0&&this.j(h,E),h.value}set(l,E,h=0){let i=this.a.get(l);if(i)i.value=E,h!==0&&this.j(i,h);else{switch(i={key:l,value:E,next:void 0,previous:void 0},h){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(l,i),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const E=this.a.get(l);if(E)return this.a.delete(l),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,E){const h=this.e;let i=this.b;for(;i;){if(E?l.bind(E)(i.value,i.key,this):l(i.value,i.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const l=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:h.key,done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return i}values(){const l=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:h.value,done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return i}entries(){const l=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:[h.key,h.value],done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let E=this.b,h=this.size;for(;E&&h>l;)this.a.delete(E.key),E=E.next,h--;this.b=E,this.d=h,E&&(E.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const E=l.next,h=l.previous;if(!E||!h)throw new Error("Invalid list");E.previous=h,h.next=E}l.next=void 0,l.previous=void 0,this.e++}j(l,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(l===this.b)return;const h=l.next,i=l.previous;l===this.c?(i.next=void 0,this.c=i):(h.previous=i,i.next=h),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if(E===2){if(l===this.c)return;const h=l.next,i=l.previous;l===this.b?(h.previous=void 0,this.b=h):(h.previous=i,i.next=h),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach((E,h)=>{l.push([h,E])}),l}fromJSON(l){this.clear();for(const[E,h]of l)this.set(E,h)}}e.$Cc=d;class v extends d{constructor(l,E=1){super(),this.k=l,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,E=2){return super.get(l,E)}peek(l){return super.get(l,0)}set(l,E){return super.set(l,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=v;class m{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let E=this.a.get(l)||0;return E===0?!1:(E--,E===0?this.a.delete(l):this.a.set(l,E),!0)}has(l){return this.a.has(l)}}e.$Ec=m;class b{constructor(l){if(this.a=new Map,this.b=new Map,l)for(const[E,h]of l)this.set(E,h)}clear(){this.a.clear(),this.b.clear()}set(l,E){this.a.set(l,E),this.b.set(E,l)}get(l){return this.a.get(l)}getKey(l){return this.b.get(l)}delete(l){const E=this.a.get(l);return E===void 0?!1:(this.a.delete(l),this.b.delete(E),!0)}forEach(l,E){this.a.forEach((h,i)=>{l.call(E,h,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=b;class ${constructor(){this.a=new Map}add(l,E){let h=this.a.get(l);h||(h=new Set,this.a.set(l,h)),h.add(E)}delete(l,E){const h=this.a.get(l);h&&(h.delete(E),h.size===0&&this.a.delete(l))}forEach(l,E){const h=this.a.get(l);h&&h.forEach(E)}get(l){const E=this.a.get(l);return E||new Set}}e.$Gc=$}),define(ie[2],ne([0,1,23,135,31,83,70]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const P=!1;let f=null;class a{constructor(){this.b=new Map}static{this.a=0}c(I){let j=this.b.get(I);return j||(j={parent:null,source:null,isSingleton:!1,value:I,idx:a.a++},this.b.set(I,j)),j}trackDisposable(I){const j=this.c(I);j.source||(j.source=new Error().stack)}setParent(I,j){const N=this.c(I);N.parent=j}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,j){const N=j.get(I);if(N)return N;const z=I.parent?this.f(this.c(I.parent),j):I;return j.set(I,z),z}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,I).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(I=10,j){let N;if(j)N=j;else{const re=new Map,ae=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,re).isSingleton);if(ae.length===0)return;const Z=new Set(ae.map(Q=>Q.value));if(N=ae.filter(Q=>!(Q.parent&&Z.has(Q.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function z(re){function ae(Q,G){for(;Q.length>0&&G.some(q=>typeof q=="string"?q===Q[0]:Q[0].match(q));)Q.shift()}const Z=re.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return ae(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const _=new s.$Gc;for(const re of N){const ae=z(re);for(let Z=0;Z<=ae.length;Z++)_.add(ae.slice(0,Z).join(`
`),re)}N.sort((0,S.$7b)(re=>re.idx,S.$9b));let Y="",ce=0;for(const re of N.slice(0,I)){ce++;const ae=z(re),Z=[];for(let Q=0;Q<ae.length;Q++){let G=ae[Q];G=`(shared with ${_.get(ae.slice(0,Q+1).join(`
`)).size}/${N.length} leaks) at ${G}`;const T=_.get(ae.slice(0,Q).join(`
`)),K=(0,R.$J)([...T].map(H=>z(H)[Q]),H=>H);delete K[ae[Q]];for(const[H,x]of Object.entries(K))Z.unshift(`    - stacktraces of ${x.length} other leaks continue with ${H}`);Z.unshift(G)}Y+=`


==================== Leaking disposable ${ce}/${N.length}: ${re.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return N.length>I&&(Y+=`


... and ${N.length-I} more leaking disposables

`),{leaks:N,details:Y}}}e.$Hc=a;function g(k){f=k}if(e.$Ic=g,P){const k="__is_disposable_tracked__";g(new class{trackDisposable(I){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[k]||console.log(j)},3e3)}setParent(I,j){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsDisposed(I){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsSingleton(I){}})}function w(k){return f?.trackDisposable(k),k}e.$Jc=w;function y(k){f?.markAsDisposed(k)}e.$Kc=y;function d(k,I){f?.setParent(k,I)}function v(k,I){if(f)for(const j of k)f.setParent(j,I)}function m(k){return f?.markAsSingleton(k),k}e.$Lc=m;function b(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Mc=b;function $(k){if(C.Iterable.is(k)){const I=[];for(const j of k)if(j)try{j.dispose()}catch(N){I.push(N)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Nc=$;function u(k){for(const I of k)b(I)&&I.dispose();return[]}e.$Oc=u;function l(...k){const I=E(()=>$(k));return v(k,I),I}e.$Pc=l;function E(k){const I=w({dispose:(0,O.$db)(()=>{y(I),k()})});return I}e.$Qc=E;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return d(I,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),d(I,null))}}e.$Rc=h;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,w(this),d(this.q,this)}dispose(){y(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Sc=i;class c{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&d(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&d(I,null),I}}e.$Tc=c;class o{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=o;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(I){let j=I;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,y(this))},this}}e.$Vc=t;class n{constructor(){this.a=new Map}acquire(I,...j){let N=this.a.get(I);N||(N={counter:0,object:this.b(I,...j)},this.a.set(I,N));const{object:z}=N,_=(0,O.$db)(()=>{--N.counter===0&&(this.c(I,N.object),this.a.delete(I))});return N.counter++,{object:z,dispose:_}}}e.$Wc=n;class r{constructor(I){this.a=I}async acquire(I,...j){const N=this.a.acquire(I,...j);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(z){throw N.dispose(),z}}}e.$Xc=r;class p{constructor(I){this.object=I}dispose(){}}e.$Yc=p;function A(k){const I=new h;try{k(I)}finally{I.dispose()}}e.$Zc=A;class D{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,j,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(I)?.dispose(),this.a.set(I,j)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=D}),define(ie[84],ne([0,1,31]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=void 0;const R=new S.$Dc(1e4);function s(a){return f(a,"NFC",R)}e.$ol=s;const O=new S.$Dc(1e4);function C(a){return f(a,"NFD",O)}e.$pl=C;const P=/[^\u0000-\u0080]/;function f(a,g,w){if(!a)return a;const y=w.get(a);if(y)return y;let d;return P.test(a)?d=a.normalize(g):d=a,w.set(a,d),d}e.$ql=function(){const a=/[\u0300-\u036f]/g;return function(g){return C(g).replace(a,"")}}()}),define(ie[140],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function S(P,f,a){return Math.min(Math.max(P,f),a)}e.$Ol=S;function R(P,f){return(f+P%f)%f}e.rot=R;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=s;class O{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=O;class C{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const a=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=C}),function(){function X(s){const O=[];typeof s=="number"&&O.push("code/timeOrigin",s);function C(f){O.push(f,Date.now())}function P(){const f=[];for(let a=0;a<O.length;a+=2)f.push({name:O[a],startTime:O[a+1]});return f}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const C of performance.getEntriesByType("mark"))O.push({name:C.name,startTime:Math.round(s+C.startTime)});return O}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=S(R))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var R in S)(typeof exports=="object"?exports:X)[R]=S[R]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function S(R){if(e[R])return e[R].exports;var s=e[R]={i:R,l:!1,exports:{}};return X[R].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=X,S.c=e,S.d=function(R,s,O){S.o(R,s)||Object.defineProperty(R,s,{enumerable:!0,get:O})},S.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},S.t=function(R,s){if(1&s&&(R=S(R)),8&s||4&s&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(S.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&s&&typeof R!="string")for(var C in R)S.d(O,C,function(P){return R[P]}.bind(null,C));return O},S.n=function(R){var s=R&&R.__esModule?function(){return R.default}:function(){return R};return S.d(s,"a",s),s},S.o=function(R,s){return Object.prototype.hasOwnProperty.call(R,s)},S.p="",S(S.s=0)}([function(X,e,S){(function(R){var s;e=X.exports=B,s=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],f=e.src=[],a=0,g=a++;f[g]="0|[1-9]\\d*";var w=a++;f[w]="[0-9]+";var y=a++;f[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=a++;f[d]="("+f[g]+")\\.("+f[g]+")\\.("+f[g]+")";var v=a++;f[v]="("+f[w]+")\\.("+f[w]+")\\.("+f[w]+")";var m=a++;f[m]="(?:"+f[g]+"|"+f[y]+")";var b=a++;f[b]="(?:"+f[w]+"|"+f[y]+")";var $=a++;f[$]="(?:-("+f[m]+"(?:\\."+f[m]+")*))";var u=a++;f[u]="(?:-?("+f[b]+"(?:\\."+f[b]+")*))";var l=a++;f[l]="[0-9A-Za-z-]+";var E=a++;f[E]="(?:\\+("+f[l]+"(?:\\."+f[l]+")*))";var h=a++,i="v?"+f[d]+f[$]+"?"+f[E]+"?";f[h]="^"+i+"$";var c="[v=\\s]*"+f[v]+f[u]+"?"+f[E]+"?",o=a++;f[o]="^"+c+"$";var t=a++;f[t]="((?:<|>)?=?)";var n=a++;f[n]=f[w]+"|x|X|\\*";var r=a++;f[r]=f[g]+"|x|X|\\*";var p=a++;f[p]="[v=\\s]*("+f[r]+")(?:\\.("+f[r]+")(?:\\.("+f[r]+")(?:"+f[$]+")?"+f[E]+"?)?)?";var A=a++;f[A]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[u]+")?"+f[E]+"?)?)?";var D=a++;f[D]="^"+f[t]+"\\s*"+f[p]+"$";var k=a++;f[k]="^"+f[t]+"\\s*"+f[A]+"$";var I=a++;f[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=a++;f[j]="(?:~>?)";var N=a++;f[N]="(\\s*)"+f[j]+"\\s+",P[N]=new RegExp(f[N],"g");var z=a++;f[z]="^"+f[j]+f[p]+"$";var _=a++;f[_]="^"+f[j]+f[A]+"$";var Y=a++;f[Y]="(?:\\^)";var ce=a++;f[ce]="(\\s*)"+f[Y]+"\\s+",P[ce]=new RegExp(f[ce],"g");var re=a++;f[re]="^"+f[Y]+f[p]+"$";var ae=a++;f[ae]="^"+f[Y]+f[A]+"$";var Z=a++;f[Z]="^"+f[t]+"\\s*("+c+")$|^$";var Q=a++;f[Q]="^"+f[t]+"\\s*("+i+")$|^$";var G=a++;f[G]="(\\s*)"+f[t]+"\\s*("+c+"|"+f[p]+")",P[G]=new RegExp(f[G],"g");var q=a++;f[q]="^\\s*("+f[p]+")\\s+-\\s+("+f[p]+")\\s*$";var T=a++;f[T]="^\\s*("+f[A]+")\\s+-\\s+("+f[A]+")\\s*$";var K=a++;f[K]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)s(H,f[H]),P[H]||(P[H]=new RegExp(f[H]));function x(se,ue){if(se instanceof B)return se;if(typeof se!="string"||se.length>O||!(ue?P[o]:P[h]).test(se))return null;try{return new B(se,ue)}catch{return null}}function B(se,ue){if(se instanceof B){if(se.loose===ue)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof B))return new B(se,ue);s("SemVer",se,ue),this.loose=ue;var ge=se.trim().match(ue?P[o]:P[h]);if(!ge)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var De=+Ie;if(De>=0&&De<C)return De}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=x,e.valid=function(se,ue){var ge=x(se,ue);return ge?ge.version:null},e.clean=function(se,ue){var ge=x(se.trim().replace(/^[=v]+/,""),ue);return ge?ge.version:null},e.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(se){return s("SemVer.compare",this.version,this.loose,se),se instanceof B||(se=new B(se,this.loose)),this.compareMain(se)||this.comparePre(se)},B.prototype.compareMain=function(se){return se instanceof B||(se=new B(se,this.loose)),M(this.major,se.major)||M(this.minor,se.minor)||M(this.patch,se.patch)},B.prototype.comparePre=function(se){if(se instanceof B||(se=new B(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var ue=0;do{var ge=this.prerelease[ue],Ie=se.prerelease[ue];if(s("prerelease compare",ue,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return M(ge,Ie)}while(++ue)},B.prototype.inc=function(se,ue){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,ue,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new B(se,ge).inc(ue,Ie).version}catch{return null}},e.diff=function(se,ue){if(V(se,ue))return null;var ge=x(se),Ie=x(ue);if(ge.prerelease.length||Ie.prerelease.length){for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Ie[De])return"pre"+De;return"prerelease"}for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Ie[De])return De},e.compareIdentifiers=M;var F=/^[0-9]+$/;function M(se,ue){var ge=F.test(se),Ie=F.test(ue);return ge&&Ie&&(se=+se,ue=+ue),ge&&!Ie?-1:Ie&&!ge?1:se<ue?-1:se>ue?1:0}function U(se,ue,ge){return new B(se,ge).compare(new B(ue,ge))}function W(se,ue,ge){return U(se,ue,ge)>0}function L(se,ue,ge){return U(se,ue,ge)<0}function V(se,ue,ge){return U(se,ue,ge)===0}function J(se,ue,ge){return U(se,ue,ge)!==0}function oe(se,ue,ge){return U(se,ue,ge)>=0}function le(se,ue,ge){return U(se,ue,ge)<=0}function de(se,ue,ge,Ie){var De;switch(ue){case"===":typeof se=="object"&&(se=se.version),typeof ge=="object"&&(ge=ge.version),De=se===ge;break;case"!==":typeof se=="object"&&(se=se.version),typeof ge=="object"&&(ge=ge.version),De=se!==ge;break;case"":case"=":case"==":De=V(se,ge,Ie);break;case"!=":De=J(se,ge,Ie);break;case">":De=W(se,ge,Ie);break;case">=":De=oe(se,ge,Ie);break;case"<":De=L(se,ge,Ie);break;case"<=":De=le(se,ge,Ie);break;default:throw new TypeError("Invalid operator: "+ue)}return De}function fe(se,ue){if(se instanceof fe){if(se.loose===ue)return se;se=se.value}if(!(this instanceof fe))return new fe(se,ue);s("comparator",se,ue),this.loose=ue,this.parse(se),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(se,ue){return M(ue,se)},e.major=function(se,ue){return new B(se,ue).major},e.minor=function(se,ue){return new B(se,ue).minor},e.patch=function(se,ue){return new B(se,ue).patch},e.compare=U,e.compareLoose=function(se,ue){return U(se,ue,!0)},e.rcompare=function(se,ue,ge){return U(ue,se,ge)},e.sort=function(se,ue){return se.sort(function(ge,Ie){return e.compare(ge,Ie,ue)})},e.rsort=function(se,ue){return se.sort(function(ge,Ie){return e.rcompare(ge,Ie,ue)})},e.gt=W,e.lt=L,e.eq=V,e.neq=J,e.gte=oe,e.lte=le,e.cmp=de,e.Comparator=fe;var ve={};function me(se,ue){if(se instanceof me)return se.loose===ue?se:new me(se.raw,ue);if(se instanceof fe)return new me(se.value,ue);if(!(this instanceof me))return new me(se,ue);if(this.loose=ue,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function ye(se){return!se||se.toLowerCase()==="x"||se==="*"}function Oe(se,ue,ge,Ie,De,Ne,Re,qe,ze,ee,he,$e,ke){return((ue=ye(ge)?"":ye(Ie)?">="+ge+".0.0":ye(De)?">="+ge+"."+Ie+".0":">="+ue)+" "+(qe=ye(ze)?"":ye(ee)?"<"+(+ze+1)+".0.0":ye(he)?"<"+ze+"."+(+ee+1)+".0":$e?"<="+ze+"."+ee+"."+he+"-"+$e:"<="+qe)).trim()}function Me(se,ue){for(var ge=0;ge<se.length;ge++)if(!se[ge].test(ue))return!1;if(ue.prerelease.length){for(ge=0;ge<se.length;ge++)if(s(se[ge].semver),se[ge].semver!==ve&&se[ge].semver.prerelease.length>0){var Ie=se[ge].semver;if(Ie.major===ue.major&&Ie.minor===ue.minor&&Ie.patch===ue.patch)return!0}return!1}return!0}function we(se,ue,ge){try{ue=new me(ue,ge)}catch{return!1}return ue.test(se)}function pe(se,ue,ge,Ie){var De,Ne,Re,qe,ze;switch(se=new B(se,Ie),ue=new me(ue,Ie),ge){case">":De=W,Ne=le,Re=L,qe=">",ze=">=";break;case"<":De=L,Ne=oe,Re=W,qe="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(se,ue,Ie))return!1;for(var ee=0;ee<ue.set.length;++ee){var he=ue.set[ee],$e=null,ke=null;if(he.forEach(function(Ae){Ae.semver===ve&&(Ae=new fe(">=0.0.0")),$e=$e||Ae,ke=ke||Ae,De(Ae.semver,$e.semver,Ie)?$e=Ae:Re(Ae.semver,ke.semver,Ie)&&(ke=Ae)}),$e.operator===qe||$e.operator===ze||(!ke.operator||ke.operator===qe)&&Ne(se,ke.semver)||ke.operator===ze&&Re(se,ke.semver))return!1}return!0}fe.prototype.parse=function(se){var ue=this.loose?P[Z]:P[Q],ge=se.match(ue);if(!ge)throw new TypeError("Invalid comparator: "+se);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new B(ge[2],this.loose):this.semver=ve},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(se){return s("Comparator.test",se,this.loose),this.semver===ve||(typeof se=="string"&&(se=new B(se,this.loose)),de(se,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(se,ue){if(!(se instanceof fe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new me(se.value,ue),we(this.value,ge,ue);if(se.operator==="")return ge=new me(this.value,ue),we(se.semver,ge,ue);var Ie=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),Ne=this.semver.version===se.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),qe=de(this.semver,"<",se.semver,ue)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),ze=de(this.semver,">",se.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return Ie||De||Ne&&Re||qe||ze},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(se){var ue=this.loose;se=se.trim(),s("range",se,ue);var ge=ue?P[T]:P[q];se=se.replace(ge,Oe),s("hyphen replace",se),se=se.replace(P[G],"$1$2$3"),s("comparator trim",se,P[G]),se=(se=(se=se.replace(P[N],"$1~")).replace(P[ce],"$1^")).split(/\s+/).join(" ");var Ie=ue?P[Z]:P[Q],De=se.split(" ").map(function(Ne){return function(Re,qe){return s("comp",Re),Re=function(ze,ee){return ze.trim().split(/\s+/).map(function(he){return function($e,ke){s("caret",$e,ke);var Ae=ke?P[ae]:P[re];return $e.replace(Ae,function(We,Le,Ue,He,Ve){var Ge;return s("caret",$e,We,Le,Ue,He,Ve),ye(Le)?Ge="":ye(Ue)?Ge=">="+Le+".0.0 <"+(+Le+1)+".0.0":ye(He)?Ge=Le==="0"?">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+".0 <"+(+Le+1)+".0.0":Ve?(s("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=Le==="0"?Ue==="0"?">="+Le+"."+Ue+"."+He+Ve+" <"+Le+"."+Ue+"."+(+He+1):">="+Le+"."+Ue+"."+He+Ve+" <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+"."+He+Ve+" <"+(+Le+1)+".0.0"):(s("no pr"),Ge=Le==="0"?Ue==="0"?">="+Le+"."+Ue+"."+He+" <"+Le+"."+Ue+"."+(+He+1):">="+Le+"."+Ue+"."+He+" <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+"."+He+" <"+(+Le+1)+".0.0"),s("caret return",Ge),Ge})}(he,ee)}).join(" ")}(Re,qe),s("caret",Re),Re=function(ze,ee){return ze.trim().split(/\s+/).map(function(he){return function($e,ke){var Ae=ke?P[_]:P[z];return $e.replace(Ae,function(We,Le,Ue,He,Ve){var Ge;return s("tilde",$e,We,Le,Ue,He,Ve),ye(Le)?Ge="":ye(Ue)?Ge=">="+Le+".0.0 <"+(+Le+1)+".0.0":ye(He)?Ge=">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0":Ve?(s("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=">="+Le+"."+Ue+"."+He+Ve+" <"+Le+"."+(+Ue+1)+".0"):Ge=">="+Le+"."+Ue+"."+He+" <"+Le+"."+(+Ue+1)+".0",s("tilde return",Ge),Ge})}(he,ee)}).join(" ")}(Re,qe),s("tildes",Re),Re=function(ze,ee){return s("replaceXRanges",ze,ee),ze.split(/\s+/).map(function(he){return function($e,ke){$e=$e.trim();var Ae=ke?P[k]:P[D];return $e.replace(Ae,function(We,Le,Ue,He,Ve,Ge){s("xRange",$e,We,Le,Ue,He,Ve,Ge);var xe=ye(Ue),Ye=xe||ye(He),it=Ye||ye(Ve);return Le==="="&&it&&(Le=""),xe?We=Le===">"||Le==="<"?"<0.0.0":"*":Le&&it?(Ye&&(He=0),it&&(Ve=0),Le===">"?(Le=">=",Ye?(Ue=+Ue+1,He=0,Ve=0):it&&(He=+He+1,Ve=0)):Le==="<="&&(Le="<",Ye?Ue=+Ue+1:He=+He+1),We=Le+Ue+"."+He+"."+Ve):Ye?We=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":it&&(We=">="+Ue+"."+He+".0 <"+Ue+"."+(+He+1)+".0"),s("xRange return",We),We})}(he,ee)}).join(" ")}(Re,qe),s("xrange",Re),Re=function(ze,ee){return s("replaceStars",ze,ee),ze.trim().replace(P[K],"")}(Re,qe),s("stars",Re),Re}(Ne,ue)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Ne){return!!Ne.match(Ie)})),De=De.map(function(Ne){return new fe(Ne,ue)})},me.prototype.intersects=function(se,ue){if(!(se instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return se.set.some(function(De){return De.every(function(Ne){return Ie.intersects(Ne,ue)})})})})},e.toComparators=function(se,ue){return new me(se,ue).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},me.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new B(se,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Me(this.set[ue],se))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(se,ue,ge){var Ie=null,De=null;try{var Ne=new me(ue,ge)}catch{return null}return se.forEach(function(Re){Ne.test(Re)&&(Ie&&De.compare(Re)!==-1||(De=new B(Ie=Re,ge)))}),Ie},e.minSatisfying=function(se,ue,ge){var Ie=null,De=null;try{var Ne=new me(ue,ge)}catch{return null}return se.forEach(function(Re){Ne.test(Re)&&(Ie&&De.compare(Re)!==1||(De=new B(Ie=Re,ge)))}),Ie},e.validRange=function(se,ue){try{return new me(se,ue).range||"*"}catch{return null}},e.ltr=function(se,ue,ge){return pe(se,ue,"<",ge)},e.gtr=function(se,ue,ge){return pe(se,ue,">",ge)},e.outside=pe,e.prerelease=function(se,ue){var ge=x(se,ue);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(se,ue,ge){return se=new me(se,ge),ue=new me(ue,ge),se.intersects(ue)},e.coerce=function(se){if(se instanceof B)return se;if(typeof se!="string")return null;var ue=se.match(P[I]);return ue==null?null:x((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,S(1))},function(X,e){var S,R,s=X.exports={};function O(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(b){if(S===setTimeout)return setTimeout(b,0);if((S===O||!S)&&setTimeout)return S=setTimeout,setTimeout(b,0);try{return S(b,0)}catch{try{return S.call(null,b,0)}catch{return S.call(this,b,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:O}catch{S=O}try{R=typeof clearTimeout=="function"?clearTimeout:C}catch{R=C}})();var f,a=[],g=!1,w=-1;function y(){g&&f&&(g=!1,f.length?a=f.concat(a):w=-1,a.length&&d())}function d(){if(!g){var b=P(y);g=!0;for(var $=a.length;$;){for(f=a,a=[];++w<$;)f&&f[w].run();w=-1,$=a.length}f=null,g=!1,function(u){if(R===clearTimeout)return clearTimeout(u);if((R===C||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(u);try{R(u)}catch{try{return R.call(null,u)}catch{return R.call(this,u)}}}(b)}}function v(b,$){this.fun=b,this.array=$}function m(){}s.nextTick=function(b){var $=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)$[u-1]=arguments[u];a.push(new v(b,$)),a.length!==1||g||P(d)},v.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=m,s.addListener=m,s.once=m,s.off=m,s.removeListener=m,s.removeAllListeners=m,s.emit=m,s.prependListener=m,s.prependOnceListener=m,s.listeners=function(b){return[]},s.binding=function(b){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(b){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ie[141],ne([0,1]),function(X,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class R{constructor(P,f,a){this.level=P,this.key=f,this.value=a,this.forward=[]}}const s=void 0;class O{constructor(P,f=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new R(this.c,s,s)}get size(){return this.f}clear(){this.e=new R(this.c,s,s),this.f=0}has(P){return!!O.g(this,P,this.comparator)}get(P){return O.g(this,P,this.comparator)?.value}set(P,f){return O.h(this,P,f,this.comparator)&&(this.f+=1),this}delete(P){const f=O.k(this,P,this.comparator);return f&&(this.f-=1),f}forEach(P,f){let a=this.e.forward[0];for(;a;)P.call(f,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",f=this.e.forward[0];for(;f;)P+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return P}static g(P,f,a){let g=P.e;for(let w=P.d-1;w>=0;w--)for(;g.forward[w]&&a(g.forward[w].key,f)<0;)g=g.forward[w];if(g=g.forward[0],g&&a(g.key,f)===0)return g}static h(P,f,a,g){const w=[];let y=P.e;for(let d=P.d-1;d>=0;d--){for(;y.forward[d]&&g(y.forward[d].key,f)<0;)y=y.forward[d];w[d]=y}if(y=y.forward[0],y&&g(y.key,f)===0)return y.value=a,!1;{const d=O.j(P);if(d>P.d){for(let v=P.d;v<d;v++)w[v]=P.e;P.d=d}y=new R(d,f,a);for(let v=0;v<d;v++)y.forward[v]=w[v].forward[v],w[v].forward[v]=y;return!0}}static j(P,f=.5){let a=1;for(;Math.random()<f&&a<P.c;)a+=1;return a}static k(P,f,a){const g=[];let w=P.e;for(let y=P.d-1;y>=0;y--){for(;w.forward[y]&&a(w.forward[y].key,f)<0;)w=w.forward[y];g[y]=w}if(w=w.forward[0],!w||a(w.key,f)!==0)return!1;for(let y=0;y<P.d&&g[y].forward[y]===w;y++)g[y].forward[y]=w.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$zr=O}),define(ie[72],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(O){return new R(O)}constructor(O){this.c=S&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=R}),define(ie[3],ne([0,1,14,83,2,101,72]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const P=!1,f=!1;var a;(function(D){D.None=()=>s.$Sc.None;function k(de){if(f){const{onDidAddListener:fe}=de,ve=v.create();let me=0;de.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),fe?.()}}}function I(de,fe){return Q(de,()=>{},0,void 0,!0,void 0,fe)}D.defer=I;function j(de){return(fe,ve=null,me)=>{let ye=!1,Oe;return Oe=de(Me=>{if(!ye)return Oe?Oe.dispose():ye=!0,fe.call(ve,Me)},null,me),ye&&Oe.dispose(),Oe}}D.once=j;function N(de,fe,ve){return ae((me,ye=null,Oe)=>de(Me=>me.call(ye,fe(Me)),null,Oe),ve)}D.map=N;function z(de,fe,ve){return ae((me,ye=null,Oe)=>de(Me=>{fe(Me),me.call(ye,Me)},null,Oe),ve)}D.forEach=z;function _(de,fe,ve){return ae((me,ye=null,Oe)=>de(Me=>fe(Me)&&me.call(ye,Me),null,Oe),ve)}D.filter=_;function Y(de){return de}D.signal=Y;function ce(...de){return(fe,ve=null,me)=>{const ye=(0,s.$Pc)(...de.map(Oe=>Oe(Me=>fe.call(ve,Me))));return Z(ye,me)}}D.any=ce;function re(de,fe,ve,me){let ye=ve;return N(de,Oe=>(ye=fe(ye,Oe),ye),me)}D.reduce=re;function ae(de,fe){let ve;const me={onWillAddFirstListener(){ve=de(ye.fire,ye)},onDidRemoveLastListener(){ve?.dispose()}};fe||k(me);const ye=new l(me);return fe?.add(ye),ye.event}function Z(de,fe){return fe instanceof Array?fe.push(de):fe&&fe.add(de),de}function Q(de,fe,ve=100,me=!1,ye=!1,Oe,Me){let we,pe,se,ue=0,ge;const Ie={leakWarningThreshold:Oe,onWillAddFirstListener(){we=de(Ne=>{ue++,pe=fe(pe,Ne),me&&!se&&(De.fire(pe),pe=void 0),ge=()=>{const Re=pe;pe=void 0,se=void 0,(!me||ue>1)&&De.fire(Re),ue=0},typeof ve=="number"?(clearTimeout(se),se=setTimeout(ge,ve)):se===void 0&&(se=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&ue>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,we.dispose()}};Me||k(Ie);const De=new l(Ie);return Me?.add(De),De.event}D.debounce=Q;function G(de,fe=0,ve){return D.debounce(de,(me,ye)=>me?(me.push(ye),me):[ye],fe,void 0,!0,void 0,ve)}D.accumulate=G;function q(de,fe=(me,ye)=>me===ye,ve){let me=!0,ye;return _(de,Oe=>{const Me=me||!fe(Oe,ye);return me=!1,ye=Oe,Me},ve)}D.latch=q;function T(de,fe,ve){return[D.filter(de,fe,ve),D.filter(de,me=>!fe(me),ve)]}D.split=T;function K(de,fe=!1,ve=[],me){let ye=ve.slice(),Oe=de(pe=>{ye?ye.push(pe):we.fire(pe)});me&&me.add(Oe);const Me=()=>{ye?.forEach(pe=>we.fire(pe)),ye=null},we=new l({onWillAddFirstListener(){Oe||(Oe=de(pe=>we.fire(pe)),me&&me.add(Oe))},onDidAddFirstListener(){ye&&(fe?setTimeout(Me):Me())},onDidRemoveLastListener(){Oe&&Oe.dispose(),Oe=null}});return me&&me.add(we),we.event}D.buffer=K;function H(de,fe){return(me,ye,Oe)=>{const Me=fe(new B);return de(function(we){const pe=Me.evaluate(we);pe!==x&&me.call(ye,pe)},void 0,Oe)}}D.chain=H;const x=Symbol("HaltChainable");class B{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ve=>(fe(ve),ve)),this}filter(fe){return this.f.push(ve=>fe(ve)?ve:x),this}reduce(fe,ve){let me=ve;return this.f.push(ye=>(me=fe(me,ye),me)),this}latch(fe=(ve,me)=>ve===me){let ve=!0,me;return this.f.push(ye=>{const Oe=ve||!fe(ye,me);return ve=!1,me=ye,Oe?ye:x}),this}evaluate(fe){for(const ve of this.f)if(fe=ve(fe),fe===x)break;return fe}}function F(de,fe,ve=me=>me){const me=(...we)=>Me.fire(ve(...we)),ye=()=>de.on(fe,me),Oe=()=>de.removeListener(fe,me),Me=new l({onWillAddFirstListener:ye,onDidRemoveLastListener:Oe});return Me.event}D.fromNodeEventEmitter=F;function M(de,fe,ve=me=>me){const me=(...we)=>Me.fire(ve(...we)),ye=()=>de.addEventListener(fe,me),Oe=()=>de.removeEventListener(fe,me),Me=new l({onWillAddFirstListener:ye,onDidRemoveLastListener:Oe});return Me.event}D.fromDOMEventEmitter=M;function U(de){return new Promise(fe=>j(de)(fe))}D.toPromise=U;function W(de){const fe=new l;return de.then(ve=>{fe.fire(ve)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}D.fromPromise=W;function L(de,fe){return fe(void 0),de(ve=>fe(ve))}D.runAndSubscribe=L;function V(de,fe){let ve=null;function me(Oe){ve?.dispose(),ve=new s.$Rc,fe(Oe,ve)}me(void 0);const ye=de(Oe=>me(Oe));return(0,s.$Qc)(()=>{ye.dispose(),ve?.dispose()})}D.runAndSubscribeWithStore=V;class J{constructor(fe,ve){this._observable=fe,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ve||k(me),this.emitter=new l(me),ve&&ve.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ve){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function oe(de,fe){return new J(de,fe).emitter.event}D.fromObservable=oe;function le(de){return fe=>{let ve=0,me=!1;const ye={beginUpdate(){ve++},endUpdate(){ve--,ve===0&&(de.reportChanges(),me&&(me=!1,fe()))},handlePossibleChange(){},handleChange(){me=!0}};return de.addObserver(ye),de.reportChanges(),{dispose(){de.removeObserver(ye)}}}}D.fromObservableLight=le})(a||(e.Event=a={}));class g{static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${g.f++}`,g.all.add(this)}start(k){this.g=new C.$Jd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Ld=g;let w=-1;function y(D){const k=w;return w=D,{dispose(){w=k}}}e.$Md=y;class d{constructor(k,I=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=I,this.g=0}dispose(){this.f?.clear()}check(k,I){const j=this.threshold;if(j<=0||I<j)return;this.f||(this.f=new Map);const N=this.f.get(k.value)||0;if(this.f.set(k.value,N+1),this.g-=1,this.g<=0){this.g=j*.5;let z,_=0;for(const[Y,ce]of this.f)(!z||_<ce)&&(z=Y,_=ce);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${_}):`),console.warn(z)}return()=>{const z=this.f.get(k.value)||0;this.f.set(k.value,z-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class b{constructor(k){this.value=k,this.id=m++}}const $=2,u=(D,k)=>{if(D instanceof b)k(D);else for(let I=0;I<D.length;I++){const j=D[I];j&&k(j)}};class l{constructor(k){this.w=0,this.f=k,this.g=w>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const k=this.t;queueMicrotask(()=>{u(k,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,I,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Sc.None;if(this.m)return s.$Sc.None;I&&(k=k.bind(I));const N=new b(k);let z,_;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=v.create(),z=this.g.check(N.stack,this.w+1)),P&&(N.stack=_??v.create()),this.t?this.t instanceof b?(this.u??=new h,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const Y=(0,s.$Qc)(()=>{z?.(),this.x(N)});return j instanceof s.$Rc?j.add(Y):Array.isArray(j)&&j.push(Y),Y},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,j=I.indexOf(k);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[j]=void 0;const N=this.u.current===this;if(this.w*$<=I.length){let z=0;for(let _=0;_<I.length;_++)I[_]?I[z++]=I[_]:N&&(this.u.end--,z<this.u.i&&this.u.i--);I.length=z}}y(k,I){if(!k)return;const j=this.f?.onListenerError||S.$1;if(!j){k.value(I);return}try{k.value(I)}catch(N){j(N)}}z(k){const I=k.current.t;for(;k.i<k.end;)this.y(I[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,k);else{const I=this.u;I.enqueue(this,k,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=l;const E=()=>new h;e.$Od=E;class h{constructor(){this.i=-1,this.end=0}enqueue(k,I,j){this.i=0,this.end=j,this.current=k,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends l{async fireAsync(k,I,j){if(this.t)for(this.h||(this.h=new O.$2c),u(this.t,N=>this.h.push([N.value,k]));this.h.size>0&&!I.isCancellationRequested;){const[N,z]=this.h.shift(),_=[],Y={...z,token:I,waitUntil:ce=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");j&&(ce=j(ce,N)),_.push(ce)}};try{N(Y)}catch(ce){(0,S.$1)(ce);continue}Object.freeze(_),await Promise.allSettled(_).then(ce=>{for(const re of ce)re.status==="rejected"&&(0,S.$1)(re.reason)})}}}e.$Pd=i;class c extends l{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new O.$2c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Qd=c;class o extends c{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Rd=o;class t extends l{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Sd=t;class n{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const I={event:k,listener:null};this.h.push(I),this.g&&this.m(I);const j=()=>{this.g&&this.o(I);const N=this.h.indexOf(I);this.h.splice(N,1)};return(0,s.$Qc)((0,R.$db)(j))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(I=>this.f.fire(I))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Td=n;class r{constructor(k,I,j,N){this.f=new s.$Rc;const z=this.f.add(new n),_=this.f.add(new s.$1c);function Y(ce){_.set(ce,z.add(N(ce)))}for(const ce of k)Y(ce);this.f.add(I(ce=>{Y(ce)})),this.f.add(j(ce=>{_.deleteAndDispose(ce)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Ud=r;class p{constructor(){this.f=[]}wrapEvent(k){return(I,j,N)=>k(z=>{const _=this.f[this.f.length-1];_?_.push(()=>I.call(j,z)):I.call(j,z)},void 0,N)}bufferEvents(k){const I=[];this.f.push(I);const j=k();return this.f.pop(),I.forEach(N=>N()),j}}e.$Vd=p;class A{constructor(){this.f=!1,this.g=a.None,this.h=s.$Sc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=A}),define(ie[22],ne([0,1,3]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const R=Object.freeze(function(P,f){const a=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(a)}}});var s;(function(P){function f(a){return a===P.None||a===P.Cancelled||a instanceof O?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(s||(e.CancellationToken=s={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new S.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=s.None}}e.$Xd=C}),define(ie[142],ne([0,1,22]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class R{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$Xd,f=this.b(P.token);return this.a={promise:f,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$we=R;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const f=JSON.stringify(P);return this.b!==f&&(this.b=f,this.a=this.c(P)),this.a}}e.$xe=s;class O{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const f=this.b(P);return this.a.set(P,f),f}}e.$ye=O}),define(ie[61],ne([0,1,14,2]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function s(E){const h=E;return h?typeof h.read=="function":!1}e.$Yd=s;function O(E){const h=E;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$Zd=O;function C(E){const h=E;return h?O(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$1d=C;function P(E,h){return new f(E,h)}e.$2d=P;class f{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,S.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let c;switch(h){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const o=c.indexOf(i);o>=0&&c.splice(o,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(E,h){const i=[];let c;for(;(c=E.read())!==null;)i.push(c);return h(i)}e.$3d=a;function g(E,h,i){const c=[];let o;for(;(o=E.read())!==null&&c.length<i;)c.push(o);return o===null&&c.length>0?h(c):{read:()=>{if(c.length>0)return c.shift();if(typeof o<"u"){const t=o;return o=void 0,t}return E.read()}}}e.$4d=g;function w(E,h){return new Promise((i,c)=>{const o=[];y(E,{onData:t=>{h&&o.push(t)},onError:t=>{h?c(t):i(void 0)},onEnd:()=>{i(h?h(o):void 0)}})})}e.$5d=w;function y(E,h,i){E.on("error",c=>{i?.isCancellationRequested||h.onError(c)}),E.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),E.on("data",c=>{i?.isCancellationRequested||h.onData(c)})}e.$6d=y;function d(E,h){return new Promise((i,c)=>{const o=new R.$Rc,t=[],n=A=>{if(t.push(A),t.length>h)return o.dispose(),E.pause(),i({stream:E,buffer:t,ended:!1})},r=A=>(o.dispose(),c(A)),p=()=>(o.dispose(),i({stream:E,buffer:t,ended:!0}));o.add((0,R.$Qc)(()=>E.removeListener("error",r))),E.on("error",r),o.add((0,R.$Qc)(()=>E.removeListener("end",p))),E.on("end",p),o.add((0,R.$Qc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$7d=d;function v(E,h){const i=P(h);return i.end(E),i}e.$8d=v;function m(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.$9d=m;function b(E){let h=!1;return{read:()=>h?null:(h=!0,E)}}e.$0d=b;function $(E,h,i){const c=P(i);return y(E,{onData:o=>c.write(h.data(o)),onError:o=>c.error(h.error?h.error(o):o),onEnd:()=>c.end()}),c}e.$$d=$;function u(E,h,i){let c=!1;return{read:()=>{const o=h.read();return c?o:(c=!0,o!==null?i([E,o]):E)}}}e.$_d=u;function l(E,h,i){let c=!1;const o=P(i);return y(h,{onData:t=>c?o.write(t):(c=!0,o.write(i([E,t]))),onError:t=>o.error(t),onEnd:()=>{c||(c=!0,o.write(E)),o.end()}}),o}e.$ae=l}),define(ie[17],ne([0,1,71,61]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const s=typeof Buffer<"u",O=new S.$V(()=>new Uint8Array(256));let C,P;class f{static alloc(I){return s?new f(Buffer.allocUnsafe(I)):new f(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new f(I)}static fromString(I,j){return!(j?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(I)):(C||(C=new TextEncoder),new f(C.encode(I)))}static fromByteArray(I){const j=f.alloc(I.length);for(let N=0,z=I.length;N<z;N++)j.buffer[N]=I[N];return j}static concat(I,j){if(typeof j>"u"){j=0;for(let _=0,Y=I.length;_<Y;_++)j+=I[_].byteLength}const N=f.alloc(j);let z=0;for(let _=0,Y=I.length;_<Y;_++){const ce=I[_];N.set(ce,z),z+=ce.byteLength}return N}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=f.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(I,j){return new f(this.buffer.subarray(I,j))}set(I,j){if(I instanceof f)this.buffer.set(I.buffer,j);else if(I instanceof Uint8Array)this.buffer.set(I,j);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),j);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return y(this.buffer,I)}writeUInt32BE(I,j){d(this.buffer,I,j)}readUInt32LE(I){return v(this.buffer,I)}writeUInt32LE(I,j){m(this.buffer,I,j)}readUInt8(I){return b(this.buffer,I)}writeUInt8(I,j){$(this.buffer,I,j)}indexOf(I,j=0){return a(this.buffer,I instanceof f?I.buffer:I,j)}}e.$be=f;function a(k,I,j=0){const N=I.byteLength,z=k.byteLength;if(N===0)return 0;if(N===1)return k.indexOf(I[0]);if(N>z-j)return-1;const _=O.value;_.fill(I.length);for(let ae=0;ae<I.length;ae++)_[I[ae]]=I.length-ae-1;let Y=j+I.length-1,ce=Y,re=-1;for(;Y<z;)if(k[Y]===I[ce]){if(ce===0){re=Y;break}Y--,ce--}else Y+=Math.max(I.length-ce,_[k[Y]]),ce=I.length-1;return re}e.$ce=a;function g(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0}e.$de=g;function w(k,I,j){k[j+0]=I&255,I=I>>>8,k[j+1]=I&255}e.$ee=w;function y(k,I){return k[I]*2**24+k[I+1]*2**16+k[I+2]*2**8+k[I+3]}e.$fe=y;function d(k,I,j){k[j+3]=I,I=I>>>8,k[j+2]=I,I=I>>>8,k[j+1]=I,I=I>>>8,k[j]=I}e.$ge=d;function v(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0|k[I+2]<<16>>>0|k[I+3]<<24>>>0}e.$he=v;function m(k,I,j){k[j+0]=I&255,I=I>>>8,k[j+1]=I&255,I=I>>>8,k[j+2]=I&255,I=I>>>8,k[j+3]=I&255}e.$ie=m;function b(k,I){return k[I]}e.$je=b;function $(k,I,j){k[j]=I}e.$ke=$;function u(k){return R.$3d(k,I=>f.concat(I))}e.$le=u;function l(k){return R.$0d(k)}e.$me=l;function E(k){return R.$5d(k,I=>f.concat(I))}e.$ne=E;async function h(k){return k.ended?f.concat(k.buffer):f.concat([...k.buffer,await E(k.stream)])}e.$oe=h;function i(k){return R.$8d(k,I=>f.concat(I))}e.$pe=i;function c(k){return R.$$d(k,{data:I=>typeof I=="string"?f.fromString(I):f.wrap(I)},I=>f.concat(I))}e.$qe=c;function o(k){return R.$2d(I=>f.concat(I),k)}e.$re=o;function t(k,I){return R.$_d(k,I,j=>f.concat(j))}e.$se=t;function n(k,I){return R.$ae(k,I,j=>f.concat(j))}e.$te=n;function r(k){let I=0,j=0,N=0;const z=new Uint8Array(Math.floor(k.length/4*3)),_=ce=>{switch(j){case 3:z[N++]=I|ce,j=0;break;case 2:z[N++]=I|ce>>>2,I=ce<<6,j=3;break;case 1:z[N++]=I|ce>>>4,I=ce<<4,j=2;break;default:I=ce<<2,j=1}};for(let ce=0;ce<k.length;ce++){const re=k.charCodeAt(ce);if(re>=65&&re<=90)_(re-65);else if(re>=97&&re<=122)_(re-97+26);else if(re>=48&&re<=57)_(re-48+52);else if(re===43||re===45)_(62);else if(re===47||re===95)_(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ce]}`)}}const Y=N;for(;j>0;)_(0);return f.wrap(z).slice(0,Y)}e.$ue=r;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:k},I=!0,j=!1){const N=j?A:p;let z="";const _=k.byteLength%3;let Y=0;for(;Y<k.byteLength-_;Y+=3){const ce=k[Y+0],re=k[Y+1],ae=k[Y+2];z+=N[ce>>>2],z+=N[(ce<<4|re>>>4)&63],z+=N[(re<<2|ae>>>6)&63],z+=N[ae&63]}if(_===1){const ce=k[Y+0];z+=N[ce>>>2],z+=N[ce<<4&63],I&&(z+="==")}else if(_===2){const ce=k[Y+0],re=k[Y+1];z+=N[ce>>>2],z+=N[(ce<<4|re>>>4)&63],z+=N[re<<2&63],I&&(z+="=")}return z}e.$ve=D}),define(ie[27],ne([0,1,142,71]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function s(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.$Be=s;const O=/{(\d+)}/g;function C(ee,...he){return he.length===0?ee:ee.replace(O,function($e,ke){const Ae=parseInt(ke,10);return isNaN(Ae)||Ae<0||Ae>=he.length?$e:he[Ae]})}e.$Ce=C;const P=/{([^}]+)}/g;function f(ee,he){return ee.replace(P,($e,ke)=>he[ke]??$e)}e.$De=f;function a(ee){return ee.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$Ee=a;function g(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=g;function w(ee,he){let $e=0;const ke=he.charCodeAt(0);for(let Ae=ee.length-1;Ae>=0;Ae--)ee.charCodeAt(Ae)===ke&&$e++;return $e}e.$Ge=w;function y(ee,he,$e="\u2026"){return ee.length<=he?ee:`${ee.substr(0,he)}${$e}`}e.$He=y;function d(ee,he=" "){const $e=v(ee,he);return m($e,he)}e.$Ie=d;function v(ee,he){if(!ee||!he)return ee;const $e=he.length;if($e===0||ee.length===0)return ee;let ke=0;for(;ee.indexOf(he,ke)===ke;)ke=ke+$e;return ee.substring(ke)}e.$Je=v;function m(ee,he){if(!ee||!he)return ee;const $e=he.length,ke=ee.length;if($e===0||ke===0)return ee;let Ae=ke,We=-1;for(;We=ee.lastIndexOf(he,Ae-1),!(We===-1||We+$e!==Ae);){if(We===0)return"";Ae=We}return ee.substring(0,Ae)}e.$Ke=m;function b(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=b;function $(ee){return ee.replace(/\*/g,"")}e.$Me=$;function u(ee,he,$e={}){if(!ee)throw new Error("Cannot create regex from empty string");he||(ee=g(ee)),$e.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ke="";return $e.global&&(ke+="g"),$e.matchCase||(ke+="i"),$e.multiline&&(ke+="m"),$e.unicode&&(ke+="u"),new RegExp(ee,ke)}e.$Ne=u;function l(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.$Oe=l;function E(ee){return ee.split(/\r\n|\r|\n/)}e.$Pe=E;function h(ee){for(let he=0,$e=ee.length;he<$e;he++){const ke=ee.charCodeAt(he);if(ke!==32&&ke!==9)return he}return-1}e.$Qe=h;function i(ee,he=0,$e=ee.length){for(let ke=he;ke<$e;ke++){const Ae=ee.charCodeAt(ke);if(Ae!==32&&Ae!==9)return ee.substring(he,ke)}return ee.substring(he,$e)}e.$Re=i;function c(ee,he=ee.length-1){for(let $e=he;$e>=0;$e--){const ke=ee.charCodeAt($e);if(ke!==32&&ke!==9)return $e}return-1}e.$Se=c;function o(ee,he,$e){const ke=[];let Ae=0;for(const We of ee.matchAll(he)){if(ke.push(ee.slice(Ae,We.index)),We.index===void 0)throw new Error("match.index should be defined");Ae=We.index+We[0].length,ke.push($e(We[0],...We.slice(1),We.index,ee,We.groups))}return ke.push(ee.slice(Ae)),Promise.all(ke).then(We=>We.join(""))}e.$Te=o;function t(ee,he){return ee<he?-1:ee>he?1:0}e.$Ue=t;function n(ee,he,$e=0,ke=ee.length,Ae=0,We=he.length){for(;$e<ke&&Ae<We;$e++,Ae++){const He=ee.charCodeAt($e),Ve=he.charCodeAt(Ae);if(He<Ve)return-1;if(He>Ve)return 1}const Le=ke-$e,Ue=We-Ae;return Le<Ue?-1:Le>Ue?1:0}e.$Ve=n;function r(ee,he){return p(ee,he,0,ee.length,0,he.length)}e.$We=r;function p(ee,he,$e=0,ke=ee.length,Ae=0,We=he.length){for(;$e<ke&&Ae<We;$e++,Ae++){let He=ee.charCodeAt($e),Ve=he.charCodeAt(Ae);if(He===Ve)continue;if(He>=128||Ve>=128)return n(ee.toLowerCase(),he.toLowerCase(),$e,ke,Ae,We);D(He)&&(He-=32),D(Ve)&&(Ve-=32);const Ge=He-Ve;if(Ge!==0)return Ge}const Le=ke-$e,Ue=We-Ae;return Le<Ue?-1:Le>Ue?1:0}e.$Xe=p;function A(ee){return ee>=48&&ee<=57}e.$Ye=A;function D(ee){return ee>=97&&ee<=122}e.$Ze=D;function k(ee){return ee>=65&&ee<=90}e.$1e=k;function I(ee,he){return ee.length===he.length&&p(ee,he)===0}e.$2e=I;function j(ee,he){const $e=he.length;return he.length>ee.length?!1:p(ee,he,0,$e)===0}e.$3e=j;function N(ee,he){const $e=Math.min(ee.length,he.length);let ke;for(ke=0;ke<$e;ke++)if(ee.charCodeAt(ke)!==he.charCodeAt(ke))return ke;return $e}e.$4e=N;function z(ee,he){const $e=Math.min(ee.length,he.length);let ke;const Ae=ee.length-1,We=he.length-1;for(ke=0;ke<$e;ke++)if(ee.charCodeAt(Ae-ke)!==he.charCodeAt(We-ke))return ke;return $e}e.$5e=z;function _(ee){return 55296<=ee&&ee<=56319}e.$6e=_;function Y(ee){return 56320<=ee&&ee<=57343}e.$7e=Y;function ce(ee,he){return(ee-55296<<10)+(he-56320)+65536}e.$8e=ce;function re(ee,he,$e){const ke=ee.charCodeAt($e);if(_(ke)&&$e+1<he){const Ae=ee.charCodeAt($e+1);if(Y(Ae))return ce(ke,Ae)}return ke}e.$9e=re;function ae(ee,he){const $e=ee.charCodeAt(he-1);if(Y($e)&&he>1){const ke=ee.charCodeAt(he-2);if(_(ke))return ce(ke,$e)}return $e}class Z{get offset(){return this.e}constructor(he,$e=0){this.c=he,this.d=he.length,this.e=$e}setOffset(he){this.e=he}prevCodePoint(){const he=ae(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=re(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$0e=Z;class Q{get offset(){return this.c.offset}constructor(he,$e=0){this.c=new Z(he,$e)}nextGraphemeLength(){const he=ue.getInstance(),$e=this.c,ke=$e.offset;let Ae=he.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const We=$e.offset,Le=he.getGraphemeBreakType($e.nextCodePoint());if(pe(Ae,Le)){$e.setOffset(We);break}Ae=Le}return $e.offset-ke}prevGraphemeLength(){const he=ue.getInstance(),$e=this.c,ke=$e.offset;let Ae=he.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const We=$e.offset,Le=he.getGraphemeBreakType($e.prevCodePoint());if(pe(Le,Ae)){$e.setOffset(We);break}Ae=Le}return ke-$e.offset}eol(){return this.c.eol()}}e.$$e=Q;function G(ee,he){return new Q(ee,he).nextGraphemeLength()}e.$_e=G;function q(ee,he){return new Q(ee,he).prevGraphemeLength()}e.$af=q;function T(ee,he){he>0&&Y(ee.charCodeAt(he))&&he--;const $e=he+G(ee,he);return[$e-q(ee,$e),$e]}e.$bf=T;function K(ee){const he=new Q(ee);let $e=0;for(;!he.eol();)$e++,he.nextGraphemeLength();return $e}e.$cf=K;let H;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(ee){return H||(H=x()),H.test(ee)}e.$df=B;const F=/^[\t\n\r\x20-\x7E]*$/;function M(ee){return F.test(ee)}e.$ef=M,e.$ff=/[\u2028\u2029]/;function U(ee){return e.$ff.test(ee)}e.$gf=U;function W(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.$hf=W;function L(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.$if=L;function V(ee,he){if(ee.length<he)return ee;const $e=/\b/g;let ke=0;for(;$e.test(ee)&&!(ee.length-$e.lastIndex<he);)ke=$e.lastIndex,$e.lastIndex+=1;return ee.substring(ke).replace(/^\s/,"")}e.$jf=V;const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,oe=/\x1b\].*?\x07/g;function le(ee){return ee&&(ee=ee.replace(J,"").replace(oe,"")),ee}e.$kf=le,e.$lf=String.fromCharCode(65279);function de(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.$mf=de;function fe(ee){return de(ee)?ee.substr(1):ee}e.$nf=fe;function ve(ee,he){if(!ee||!he||ee.length<he.length)return!1;const $e=he.length,ke=ee.toLowerCase();let Ae=0,We=-1;for(;Ae<$e;){const Le=ke.indexOf(he[Ae],We+1);if(Le<0)return!1;We=Le,Ae++}return!0}e.$of=ve;function me(ee,he=!1){return ee?(he&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.$pf=me;function ye(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.$qf=ye;function Oe(ee,he=1){if(he===0)return"";let $e=-1;do $e=ee.indexOf(`
`,$e+1),he--;while(he>0&&$e>=0);return $e===-1?ee:(ee[$e-1]==="\r"&&$e--,ee.substr(0,$e))}e.$rf=Oe;function Me(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.$sf=Me;function we(ee){return ue.getInstance().getGraphemeBreakType(ee)}e.$tf=we;function pe(ee,he){return ee===0?he!==5&&he!==7:ee===2&&he===3?!1:ee===4||ee===2||ee===3||he===4||he===2||he===3?!0:!(ee===8&&(he===8||he===9||he===11||he===12)||(ee===11||ee===9)&&(he===9||he===10)||(ee===12||ee===10)&&he===10||he===5||he===13||he===7||ee===1||ee===13&&he===14||ee===6&&he===6)}var se;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(se||(e.GraphemeBreakType=se={}));class ue{static{this.c=null}static getInstance(){return ue.c||(ue.c=new ue),ue.c}constructor(){this.d=ge()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const $e=this.d,ke=$e.length/3;let Ae=1;for(;Ae<=ke;)if(he<$e[3*Ae])Ae=2*Ae;else if(he>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(ee,he){if(ee===0)return 0;const $e=De(ee,he);if($e!==void 0)return $e;const ke=new Z(he,ee);return ke.prevCodePoint(),ke.offset}e.$uf=Ie;function De(ee,he){const $e=new Z(he,ee);let ke=$e.prevCodePoint();for(;Ne(ke)||ke===65039||ke===8419;){if($e.offset===0)return;ke=$e.prevCodePoint()}if(!L(ke))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===8205&&(Ae=$e.offset),Ae}function Ne(ee){return 127995<=ee&&ee<=127999}var Re;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={})),e.$vf="\xA0";class qe{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$xe(he=>{function $e(Ge){const xe=new Map;for(let Ye=0;Ye<Ge.length;Ye+=2)xe.set(Ge[Ye],Ge[Ye+1]);return xe}function ke(Ge,xe){const Ye=new Map(Ge);for(const[it,nt]of xe)Ye.set(it,nt);return Ye}function Ae(Ge,xe){if(!Ge)return xe;const Ye=new Map;for(const[it,nt]of Ge)xe.has(it)&&Ye.set(it,nt);return Ye}const We=this.c.value;let Le=he.filter(Ge=>!Ge.startsWith("_")&&Ge in We);Le.length===0&&(Le=["_default"]);let Ue;for(const Ge of Le){const xe=$e(We[Ge]);Ue=Ae(Ue,xe)}const He=$e(We._common),Ve=ke(He,Ue);return new qe(Ve)})}static getInstance(he){return qe.d.get(Array.from(he))}static{this.e=new R.$V(()=>Object.keys(qe.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return qe.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=qe;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(he){return ze.e().has(he)}static get codePoints(){return ze.e()}}e.$xf=ze}),define(ie[55],ne([0,1,27]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function R($){return s($,0)}e.$Di=R;function s($,u){switch(typeof $){case"object":return $===null?O(349,u):Array.isArray($)?f($,u):a($,u);case"string":return P($,u);case"boolean":return C($,u);case"number":return O($,u);case"undefined":return O(937,u);default:return O(617,u)}}e.$Ei=s;function O($,u){return(u<<5)-u+$|0}e.$Fi=O;function C($,u){return O($?433:863,u)}function P($,u){u=O(149417,u);for(let l=0,E=$.length;l<E;l++)u=O($.charCodeAt(l),u);return u}e.$Gi=P;function f($,u){return u=O(104579,u),$.reduce((l,E)=>s(E,l),u)}function a($,u){return u=O(181387,u),Object.keys($).sort().reduce((l,E)=>(l=P(E,l),s($[E],l)),u)}class g{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=s(u,this.g),this.g}}e.$Hi=g;var w;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function y($,u,l=32){const E=l-u,h=~((1<<E)-1);return($<<u|(h&$)>>>E)>>>0}function d($,u=0,l=$.byteLength,E=0){for(let h=0;h<l;h++)$[u+h]=E}function v($,u,l="0"){for(;$.length<u;)$=l+$;return $}function m($,u=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(l=>l.toString(16).padStart(2,"0")).join(""):v(($>>>0).toString(16),u/4)}e.$Ii=m;class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const l=u.length;if(l===0)return;const E=this.p;let h=this.r,i=this.u,c,o;for(i!==0?(c=i,o=-1,i=0):(c=u.charCodeAt(0),o=0);;){let t=c;if(S.$6e(c))if(o+1<l){const n=u.charCodeAt(o+1);S.$7e(n)?(o++,t=S.$8e(c,n)):t=65533}else{i=c;break}else S.$7e(c)&&(t=65533);if(h=this.w(E,h,t),o++,o<l)c=u.charCodeAt(o);else break}this.r=h,this.u=i}w(u,l,E){return E<128?u[l++]=E:E<2048?(u[l++]=192|(E&1984)>>>6,u[l++]=128|(E&63)>>>0):E<65536?(u[l++]=224|(E&61440)>>>12,u[l++]=128|(E&4032)>>>6,u[l++]=128|(E&63)>>>0):(u[l++]=240|(E&1835008)>>>18,u[l++]=128|(E&258048)>>>12,u[l++]=128|(E&4032)>>>6,u[l++]=128|(E&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=b.g,l=this.q;for(let p=0;p<64;p+=4)u.setUint32(p,l.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)u.setUint32(p,y(u.getUint32(p-12,!1)^u.getUint32(p-32,!1)^u.getUint32(p-56,!1)^u.getUint32(p-64,!1),1),!1);let E=this.h,h=this.l,i=this.m,c=this.n,o=this.o,t,n,r;for(let p=0;p<80;p++)p<20?(t=h&i|~h&c,n=1518500249):p<40?(t=h^i^c,n=1859775393):p<60?(t=h&i|h&c|i&c,n=2400959708):(t=h^i^c,n=3395469782),r=y(E,5)+t+o+n+u.getUint32(p*4,!1)&4294967295,o=c,c=i,i=y(h,30),h=E,E=r;this.h=this.h+E&4294967295,this.l=this.l+h&4294967295,this.m=this.m+i&4294967295,this.n=this.n+c&4294967295,this.o=this.o+o&4294967295}}e.$Ji=b}),define(ie[73],ne([0,1,27]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(R||(R={})),function(s){const O="error",C="warning",P="warn",f="info",a="ignore";function g(y){return y?S.$2e(O,y)?s.Error:S.$2e(C,y)||S.$2e(P,y)?s.Warning:S.$2e(f,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=g;function w(y){switch(y){case s.Error:return O;case s.Warning:return C;case s.Info:return f;default:return a}}s.toString=w}(R||(R={})),e.default=R}),define(ie[143],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(ie[56],ne([0,1,23,27]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class s{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const v=d.charCodeAt(0),m=this.b.charCodeAt(this.c);return v-m}value(){return this.b[this.c]}}e.$Rh=s;class O{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,R.$Ve)(d,this.b,0,d.length,this.c,this.d):(0,R.$Xe)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=O;class C{constructor(d=!0,v=!0){this.f=d,this.g=v}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let v=d.length-1;v>=0;v--,this.c--){const m=this.b.charCodeAt(v);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,R.$Ve)(d,this.b,0,d.length,this.d,this.e):(0,R.$Xe)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=C;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class f{constructor(d,v){this.f=d,this.g=v,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,R.$We)(d,this.c.scheme);if(this.d[this.e]===2)return(0,R.$We)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,R.$Ue)(d,this.c.query);if(this.d[this.e]===5)return(0,R.$Ue)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=f;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(g||(g={}));class w{static forUris(d=()=>!1,v=()=>!1){return new w(new f(d,v))}static forPaths(d=!1){return new w(new C(void 0,!d))}static forStrings(){return new w(new s)}static forConfigKeys(){return new w(new O)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,v){if(v){const m=v.slice(0);(0,S.$Xb)(m);for(const b of m)this.set(b,d)}else{const m=d.slice(0);(0,S.$Xb)(m);for(const b of m)this.set(b[0],b[1])}}set(d,v){const m=this.b.reset(d);let b;this.c||(this.c=new a,this.c.segment=m.value());const $=[];for(b=this.c;;){const l=m.cmp(b.segment);if(l>0)b.left||(b.left=new a,b.left.segment=m.value()),$.push([-1,b]),b=b.left;else if(l<0)b.right||(b.right=new a,b.right.segment=m.value()),$.push([1,b]),b=b.right;else if(m.hasNext())m.next(),b.mid||(b.mid=new a,b.mid.segment=m.value()),$.push([0,b]),b=b.mid;else break}const u=b.value;b.value=v,b.key=d;for(let l=$.length-1;l>=0;l--){const E=$[l][1];E.updateHeight();const h=E.balanceFactor();if(h<-1||h>1){const i=$[l][0],c=$[l+1][0];if(i===1&&c===1)$[l][1]=E.rotateLeft();else if(i===-1&&c===-1)$[l][1]=E.rotateRight();else if(i===1&&c===-1)E.right=$[l+1][1]=$[l+1][1].rotateRight(),$[l][1]=E.rotateLeft();else if(i===-1&&c===1)E.left=$[l+1][1]=$[l+1][1].rotateLeft(),$[l][1]=E.rotateRight();else throw new Error;if(l>0)switch($[l-1][0]){case-1:$[l-1][1].left=$[l][1];break;case 1:$[l-1][1].right=$[l][1];break;case 0:$[l-1][1].mid=$[l][1];break}else this.c=$[0][1]}}return u}get(d){return this.d(d)?.value}d(d){const v=this.b.reset(d);let m=this.c;for(;m;){const b=v.cmp(m.segment);if(b>0)m=m.left;else if(b<0)m=m.right;else if(v.hasNext())v.next(),m=m.mid;else break}return m}has(d){const v=this.d(d);return!(v?.value===void 0&&v?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,v){const m=this.b.reset(d),b=[];let $=this.c;for(;$;){const u=m.cmp($.segment);if(u>0)b.push([-1,$]),$=$.left;else if(u<0)b.push([1,$]),$=$.right;else if(m.hasNext())m.next(),b.push([0,$]),$=$.mid;else break}if($){if(v?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const u=this.f($.right);if(u.key){const{key:l,value:E,segment:h}=u;this.e(u.key,!1),$.key=l,$.value=E,$.segment=h}}else{const u=$.left??$.right;if(b.length>0){const[l,E]=b[b.length-1];switch(l){case-1:E.left=u;break;case 0:E.mid=u;break;case 1:E.right=u;break}}else this.c=u}for(let u=b.length-1;u>=0;u--){const l=b[u][1];l.updateHeight();const E=l.balanceFactor();if(E>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),b[u][1]=l.rotateLeft()):E<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),b[u][1]=l.rotateRight()),u>0)switch(b[u-1][0]){case-1:b[u-1][1].left=b[u][1];break;case 1:b[u-1][1].right=b[u][1];break;case 0:b[u-1][1].mid=b[u][1];break}else this.c=b[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const v=this.b.reset(d);let m=this.c,b;for(;m;){const $=v.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(v.hasNext())v.next(),b=m.value||b,m=m.mid;else break}return m&&m.value||b}findSuperstr(d){return this.g(d,!1)}g(d,v){const m=this.b.reset(d);let b=this.c;for(;b;){const $=m.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(m.hasNext())m.next(),b=b.mid;else return b.mid?this.h(b.mid):v?b.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[v,m]of this)d(m,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const v=[];return this.j(d,v),v[Symbol.iterator]()}j(d,v){d&&(d.left&&this.j(d.left,v),d.value&&v.push([d.key,d.value]),d.mid&&this.j(d.mid,v),d.right&&this.j(d.right,v))}_isBalanced(){const d=v=>{if(!v)return!0;const m=v.balanceFactor();return m<-1||m>1?!1:d(v.left)&&d(v.right)};return d(this.c)}}e.$Vh=w}),define(ie[12],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function S(h){return typeof h=="string"}e.$yf=S;function R(h){return Array.isArray(h)&&h.every(i=>S(i))}e.$zf=R;function s(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$Af=s;function O(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}e.$Bf=O;function C(h){return typeof h=="number"&&!isNaN(h)}e.$Cf=C;function P(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Df=P;function f(h){return h===!0||h===!1}e.$Ef=f;function a(h){return typeof h>"u"}e.$Ff=a;function g(h){return!w(h)}e.$Gf=g;function w(h){return a(h)||h===null}e.$Hf=w;function y(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$If=y;function d(h){if(w(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$Jf=d;function v(...h){const i=[];for(let c=0;c<h.length;c++){const o=h[c];if(w(o))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);i.push(o)}return i}e.$Kf=v;const m=Object.prototype.hasOwnProperty;function b(h){if(!s(h))return!1;for(const i in h)if(m.call(h,i))return!1;return!0}e.$Lf=b;function $(h){return typeof h=="function"}e.$Mf=$;function u(...h){return h.length>0&&h.every($)}e.$Nf=u;function l(h,i){const c=Math.min(h.length,i.length);for(let o=0;o<c;o++)E(h[o],i[o])}e.$Of=l;function E(h,i){if(S(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if($(i)){try{if(h instanceof i)return}catch{}if(!w(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=E}),define(ie[74],ne([0,1,12]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=void 0;const R=Object.create(null);function s(P,f){if((0,S.$yf)(f)){const a=R[f];if(a===void 0)throw new Error(`${P} references an unknown codicon: ${f}`);f=a}return R[P]=f,{id:P}}function O(){return R}e.$Sj=O;function C(){return Object.values(e.$Uj)}e.$Tj=C,e.$Uj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ie[37],ne([0,1,12]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function R($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const u=Array.isArray($)?[]:{};return Object.entries($).forEach(([l,E])=>{u[l]=E&&typeof E=="object"?R(E):E}),u}e.$7m=R;function s($){if(!$||typeof $!="object")return $;const u=[$];for(;u.length>0;){const l=u.shift();Object.freeze(l);for(const E in l)if(O.call(l,E)){const h=l[E];typeof h=="object"&&!Object.isFrozen(h)&&!(0,S.$Bf)(h)&&u.push(h)}}return $}e.$8m=s;const O=Object.prototype.hasOwnProperty;function C($,u){return P($,u,new Set)}e.$9m=C;function P($,u,l){if((0,S.$Hf)($))return $;const E=u($);if(typeof E<"u")return E;if(Array.isArray($)){const h=[];for(const i of $)h.push(P(i,u,l));return h}if((0,S.$Af)($)){if(l.has($))throw new Error("Cannot clone recursive data-structure");l.add($);const h={};for(const i in $)O.call($,i)&&(h[i]=P($[i],u,l));return l.delete($),h}return $}function f($,u,l=!0){return(0,S.$Af)($)?((0,S.$Af)(u)&&Object.keys(u).forEach(E=>{E in $?l&&((0,S.$Af)($[E])&&(0,S.$Af)(u[E])?f($[E],u[E],l):$[E]=u[E]):$[E]=u[E]}),$):u}e.$0m=f;function a($,u){if($===u)return!0;if($==null||u===null||u===void 0||typeof $!=typeof u||typeof $!="object"||Array.isArray($)!==Array.isArray(u))return!1;let l,E;if(Array.isArray($)){if($.length!==u.length)return!1;for(l=0;l<$.length;l++)if(!a($[l],u[l]))return!1}else{const h=[];for(E in $)h.push(E);h.sort();const i=[];for(E in u)i.push(E);if(i.sort(),!a(h,i))return!1;for(l=0;l<h.length;l++)if(!a($[h[l]],u[h[l]]))return!1}return!0}e.$$m=a;function g($){const u=new Set;return JSON.stringify($,(l,E)=>{if((0,S.$Af)(E)||Array.isArray(E)){if(u.has(E))return"[Circular]";u.add(E)}return E})}e.$_m=g;function w($,u){const l=Object.create(null);return!$||!u||Object.keys(u).forEach(h=>{const i=$[h],c=u[h];a(i,c)||(l[h]=c)}),l}e.$an=w;function y($,u){const l=u.toLowerCase(),E=Object.keys($).find(h=>h.toLowerCase()===l);return E?$[E]:$[u]}e.$bn=y;function d($,u){const l=Object.create(null);for(const[E,h]of Object.entries($))u(E,h)&&(l[E]=h);return l}e.$cn=d;function v($){let u=[];for(;Object.prototype!==$;)u=u.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return u}e.$dn=v;function m($){const u=[];for(const l of v($))typeof $[l]=="function"&&u.push(l);return u}e.$en=m;function b($,u){const l=h=>function(){const i=Array.prototype.slice.call(arguments,0);return u(h,i)},E={};for(const h of $)E[h]=l(h);return E}e.$fn=b}),define(ie[102],ne([0,1,74]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var R;(function(C){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"}C.isThemeColor=P})(R||(e.ThemeColor=R={}));function s(C){return{id:C}}e.$Vj=s;var O;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function f(u){const l=P.exec(u.id);if(!l)return f(S.$Uj.error);const[,E,h]=l,i=["codicon","codicon-"+E];return h&&i.push("codicon-modifier-"+h.substring(1)),i}C.asClassNameArray=f;function a(u){return f(u).join(" ")}C.asClassName=a;function g(u){return"."+f(u).join(".")}C.asCSSSelector=g;function w(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||R.isThemeColor(u.color))}C.isThemeIcon=w;const y=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function d(u){const l=y.exec(u);if(!l)return;const[,E]=l;return{id:E}}C.fromString=d;function v(u){return{id:u}}C.fromId=v;function m(u,l){let E=u.id;const h=E.lastIndexOf("~");return h!==-1&&(E=E.substring(0,h)),l&&(E=`${E}~${l}`),{id:E}}C.modify=m;function b(u){const l=u.id.lastIndexOf("~");if(l!==-1)return u.id.substring(l+1)}C.getModifier=b;function $(u,l){return u.id===l.id&&u.color?.id===l.color?.id}C.isEqual=$})(O||(e.ThemeIcon=O={}))}),define(ie[32],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(s){return S.test(s)}e.$dg=R,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let f=0;f<P.length;f++)P[f]=Math.floor(Math.random()*256);return P};const O=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){s(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let f=0,a="";return a+=C[O[f++]],a+=C[O[f++]],a+=C[O[f++]],a+=C[O[f++]],a+="-",a+=C[O[f++]],a+=C[O[f++]],a+="-",a+=C[O[f++]],a+=C[O[f++]],a+="-",a+=C[O[f++]],a+=C[O[f++]],a+="-",a+=C[O[f++]],a+=C[O[f++]],a+=C[O[f++]],a+=C[O[f++]],a+=C[O[f++]],a+=C[O[f++]],a}}()}),define(ie[144],ne([0,1,85,45,83]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eT=void 0;async function O(C,P){if(await new Promise((g,w)=>{const y=R.createReadStream(C),d=S.createHash("sha1");y.pipe(d);const v=(0,s.$db)((m,b)=>{y.removeAllListeners(),d.removeAllListeners(),m?w(m):g(b)});y.once("error",v),y.once("end",v),d.once("error",v),d.once("data",m=>v(void 0,m.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$eT=O}),define(ie[145],ne([0,1,28]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(C){const P=C.replace(/\-/g,":").toLowerCase();return!R.has(P)}function O(){const C=(0,S.networkInterfaces)();for(const P in C){const f=C[P];if(f){for(const{mac:a}of f)if(s(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Qm=O}),define(ie[103],ne([0,1,86]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function R(P,f,a,g=1){let w=!1;return new Promise(y=>{const d=setTimeout(()=>{if(!w)return w=!0,y(0)},a);s(P,f,g,v=>{if(!w)return w=!0,clearTimeout(d),y(v)})})}e.$gg=R;function s(P,f,a,g){if(f===0)return g(0);const w=new S.Socket;w.once("connect",()=>(C(w),s(P+a,f-1,a,g))),w.once("data",()=>{}),w.once("error",y=>(C(w),y.code!=="ECONNREFUSED"?s(P+a,f-1,a,g):g(P))),w.connect(P,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(P,f,a,g="127.0.0.1"){let w=!1,y,d=1;const v=S.createServer({pauseOnConnect:!0});function m(b,$){w||(w=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),$(b))}return new Promise(b=>{y=setTimeout(()=>{m(0,b)},a),v.on("listening",()=>{m(P,b)}),v.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&d<f?(P++,d++,v.listen(P,g)):m(0,b)}),v.on("close",()=>{m(0,b)}),v.listen(P,g)})}e.$ig=O;function C(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),function(){function X(){function e(){return process.uncHostAllowlist}function S(f){const a=new Set;if(Array.isArray(f))for(const g of f)typeof g=="string"&&a.add(g);return Array.from(a)}function R(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const a=e();if(a)if(typeof f=="string")a.add(f.toLowerCase());else for(const g of S(f))s(g)}function O(f){if(typeof f!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const w of a){if(f.indexOf(w)!==0)continue;const d=f.indexOf("\\",w.length);if(d===-1)continue;const v=f.substring(w.length,d);if(v){g=v;break}}return g}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:s,getUNCHost:O,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return X()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=X():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ie[146],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iT=e.$hT=void 0,e.$hT="vscode:contextmenu",e.$iT="vscode:onCloseContextMenu"}),define(ie[147],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pT=void 0;class S{constructor(s,O){this.a=s,this.onMessage=O}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$pT=S}),define(ie[148],ne([11,10]),function(X,e){return X.create("vs/base/common/date",e)}),define(ie[149],ne([0,1,148]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const R=60,s=R*60,O=s*24,C=O*7,P=O*30,f=O*365;function a(w,y,d,v){typeof w!="number"&&(w=w.getTime());const m=Math.round((new Date().getTime()-w)/1e3);if(m<-30)return(0,S.localize)(0,null,a(new Date().getTime()+m*1e3,!1));if(!v&&m<30)return(0,S.localize)(1,null);let b;return m<R?(b=m,y?b===1?d?(0,S.localize)(2,null,b):(0,S.localize)(3,null,b):d?(0,S.localize)(4,null,b):(0,S.localize)(5,null,b):b===1?d?(0,S.localize)(6,null,b):(0,S.localize)(7,null,b):d?(0,S.localize)(8,null,b):(0,S.localize)(9,null,b)):m<s?(b=Math.floor(m/R),y?b===1?d?(0,S.localize)(10,null,b):(0,S.localize)(11,null,b):d?(0,S.localize)(12,null,b):(0,S.localize)(13,null,b):b===1?d?(0,S.localize)(14,null,b):(0,S.localize)(15,null,b):d?(0,S.localize)(16,null,b):(0,S.localize)(17,null,b)):m<O?(b=Math.floor(m/s),y?b===1?d?(0,S.localize)(18,null,b):(0,S.localize)(19,null,b):d?(0,S.localize)(20,null,b):(0,S.localize)(21,null,b):b===1?d?(0,S.localize)(22,null,b):(0,S.localize)(23,null,b):d?(0,S.localize)(24,null,b):(0,S.localize)(25,null,b)):m<C?(b=Math.floor(m/O),y?b===1?(0,S.localize)(26,null,b):(0,S.localize)(27,null,b):b===1?(0,S.localize)(28,null,b):(0,S.localize)(29,null,b)):m<P?(b=Math.floor(m/C),y?b===1?d?(0,S.localize)(30,null,b):(0,S.localize)(31,null,b):d?(0,S.localize)(32,null,b):(0,S.localize)(33,null,b):b===1?d?(0,S.localize)(34,null,b):(0,S.localize)(35,null,b):d?(0,S.localize)(36,null,b):(0,S.localize)(37,null,b)):m<f?(b=Math.floor(m/P),y?b===1?d?(0,S.localize)(38,null,b):(0,S.localize)(39,null,b):d?(0,S.localize)(40,null,b):(0,S.localize)(41,null,b):b===1?d?(0,S.localize)(42,null,b):(0,S.localize)(43,null,b):d?(0,S.localize)(44,null,b):(0,S.localize)(45,null,b)):(b=Math.floor(m/f),y?b===1?d?(0,S.localize)(46,null,b):(0,S.localize)(47,null,b):d?(0,S.localize)(48,null,b):(0,S.localize)(49,null,b):b===1?d?(0,S.localize)(50,null,b):(0,S.localize)(51,null,b):d?(0,S.localize)(52,null,b):(0,S.localize)(53,null,b))}e.$dm=a;function g(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=g}),define(ie[150],ne([11,10]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ie[49],ne([0,1,23,12,150]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function O(w,y){return y&&(w.stack||w.stacktrace)?s.localize(0,null,P(w),C(w.stack)||C(w.stacktrace)):P(w)}function C(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?s.localize(1,null,w.message):w.message||s.localize(2,null)}function f(w=null,y=!1){if(!w)return s.localize(3,null);if(Array.isArray(w)){const d=S.$Hb(w),v=f(d[0],y);return d.length>1?s.localize(4,null,v,d.length):v}if(R.$yf(w))return w;if(w.detail){const d=w.detail;if(d.error)return O(d.error,y);if(d.exception)return O(d.exception,y)}return w.stack?O(w,y):w.message?w.message:s.localize(5,null)}e.$Ai=f;function a(w){const y=w;return y instanceof Error&&Array.isArray(y.actions)}e.$Bi=a;function g(w,y){let d;return typeof w=="string"?d=new Error(w):d=w,d.actions=y,d}e.$Ci=g}),define(ie[151],ne([11,10]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ie[152],ne([0,1,151]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function R(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$xp=R}),define(ie[153],ne([11,10]),function(X,e){return X.create("vs/base/common/platform",e)}),define(ie[4],ne([0,1,153]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let R=!1,s=!1,O=!1,C=!1,P=!1,f=!1,a=!1,g=!1,w=!1,y=!1,d,v=e.$g,m=e.$g,b,$;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?u=e.$h.vscode.process:typeof process<"u"&&(u=process);const l=typeof u?.versions?.electron=="string",E=l&&u?.type==="renderer";if(typeof navigator=="object"&&!E)$=navigator.userAgent,R=$.indexOf("Windows")>=0,s=$.indexOf("Macintosh")>=0,g=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=$.indexOf("Linux")>=0,y=$?.indexOf("Mobi")>=0,f=!0,d=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$g,v=d,m=navigator.language;else if(typeof u=="object"){R=u.platform==="win32",s=u.platform==="darwin",O=u.platform==="linux",C=O&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,a=l,w=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$g,v=e.$g;const A=u.env.VSCODE_NLS_CONFIG;if(A)try{const D=JSON.parse(A),k=D.availableLanguages["*"];d=D.locale,m=D.osLocale,v=k||e.$g,b=D._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var h;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(h||(e.Platform=h={}));function i(A){switch(A){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=i;let c=0;s?c=1:R?c=3:O&&(c=2),e.$j=R,e.$k=s,e.$l=O,e.$m=C,e.$n=P,e.$o=a,e.$p=f,e.$q=f&&typeof e.$h.importScripts=="function",e.$r=g,e.$s=y,e.$t=w,e.$u=c,e.$v=$,e.$w=v;var o;(function(A){function D(){return e.$w}A.value=D;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}A.isDefaultVariant=k;function I(){return e.$w==="en"}A.isDefault=I})(o||(e.Language=o={})),e.$x=d,e.$y=m,e.$z=b,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const A=[];e.$h.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let I=0,j=A.length;I<j;I++){const N=A[I];if(N.id===k.data.vscodeScheduleAsyncWork){A.splice(I,1),N.callback();return}}});let D=0;return k=>{const I=++D;A.push({id:I,callback:k}),e.$h.postMessage({vscodeScheduleAsyncWork:I},"*")}}return A=>setTimeout(A)})();var t;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=s||g?2:R?1:3;let n=!0,r=!1;function p(){if(!r){r=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,n=new Uint16Array(A.buffer)[0]===(2<<8)+1}return n}e.$D=p,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ie[35],ne([0,1,4]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;if(typeof S.$h.vscode<"u"&&typeof S.$h.vscode.process<"u"){const s=S.$h.vscode.process;R={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return S.$j?"win32":S.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(ie[9],ne([0,1,35]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,s=97,O=90,C=122,P=46,f=47,a=92,g=58,w=63;class y extends Error{constructor(c,o,t){let n;typeof o=="string"&&o.indexOf("not ")===0?(n="must not be",o=o.replace(/^not /,"")):n="must be";const r=c.indexOf(".")!==-1?"property":"argument";let p=`The "${c}" ${r} ${n} of type ${o}`;p+=`. Received type ${typeof t}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function d(i,c){if(i===null||typeof i!="object")throw new y(c,"Object",i)}function v(i,c){if(typeof i!="string")throw new y(c,"string",i)}const m=S.$dc==="win32";function b(i){return i===f||i===a}function $(i){return i===f}function u(i){return i>=R&&i<=O||i>=s&&i<=C}function l(i,c,o,t){let n="",r=0,p=-1,A=0,D=0;for(let k=0;k<=i.length;++k){if(k<i.length)D=i.charCodeAt(k);else{if(t(D))break;D=f}if(t(D)){if(!(p===k-1||A===1))if(A===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const I=n.lastIndexOf(o);I===-1?(n="",r=0):(n=n.slice(0,I),r=n.length-1-n.lastIndexOf(o)),p=k,A=0;continue}else if(n.length!==0){n="",r=0,p=k,A=0;continue}}c&&(n+=n.length>0?`${o}..`:"..",r=2)}else n.length>0?n+=`${o}${i.slice(p+1,k)}`:n=i.slice(p+1,k),r=k-p-1;p=k,A=0}else D===P&&A!==-1?++A:A=-1}return n}function E(i,c){d(c,"pathObject");const o=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return o?o===c.root?`${o}${t}`:`${o}${i}${t}`:t}e.$fc={resolve(...i){let c="",o="",t=!1;for(let n=i.length-1;n>=-1;n--){let r;if(n>=0){if(r=i[n],v(r,"path"),r.length===0)continue}else c.length===0?r=S.cwd():(r=S.env[`=${c}`]||S.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===a)&&(r=`${c}\\`));const p=r.length;let A=0,D="",k=!1;const I=r.charCodeAt(0);if(p===1)b(I)&&(A=1,k=!0);else if(b(I))if(k=!0,b(r.charCodeAt(1))){let j=2,N=j;for(;j<p&&!b(r.charCodeAt(j));)j++;if(j<p&&j!==N){const z=r.slice(N,j);for(N=j;j<p&&b(r.charCodeAt(j));)j++;if(j<p&&j!==N){for(N=j;j<p&&!b(r.charCodeAt(j));)j++;(j===p||j!==N)&&(D=`\\\\${z}\\${r.slice(N,j)}`,A=j)}}}else A=1;else u(I)&&r.charCodeAt(1)===g&&(D=r.slice(0,2),A=2,p>2&&b(r.charCodeAt(2))&&(k=!0,A=3));if(D.length>0)if(c.length>0){if(D.toLowerCase()!==c.toLowerCase())continue}else c=D;if(t){if(c.length>0)break}else if(o=`${r.slice(A)}\\${o}`,t=k,k&&c.length>0)break}return o=l(o,!t,"\\",b),t?`${c}\\${o}`:`${c}${o}`||"."},normalize(i){v(i,"path");const c=i.length;if(c===0)return".";let o=0,t,n=!1;const r=i.charCodeAt(0);if(c===1)return $(r)?"\\":i;if(b(r))if(n=!0,b(i.charCodeAt(1))){let A=2,D=A;for(;A<c&&!b(i.charCodeAt(A));)A++;if(A<c&&A!==D){const k=i.slice(D,A);for(D=A;A<c&&b(i.charCodeAt(A));)A++;if(A<c&&A!==D){for(D=A;A<c&&!b(i.charCodeAt(A));)A++;if(A===c)return`\\\\${k}\\${i.slice(D)}\\`;A!==D&&(t=`\\\\${k}\\${i.slice(D,A)}`,o=A)}}}else o=1;else u(r)&&i.charCodeAt(1)===g&&(t=i.slice(0,2),o=2,c>2&&b(i.charCodeAt(2))&&(n=!0,o=3));let p=o<c?l(i.slice(o),!n,"\\",b):"";return p.length===0&&!n&&(p="."),p.length>0&&b(i.charCodeAt(c-1))&&(p+="\\"),t===void 0?n?`\\${p}`:p:n?`${t}\\${p}`:`${t}${p}`},isAbsolute(i){v(i,"path");const c=i.length;if(c===0)return!1;const o=i.charCodeAt(0);return b(o)||c>2&&u(o)&&i.charCodeAt(1)===g&&b(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let c,o;for(let r=0;r<i.length;++r){const p=i[r];v(p,"path"),p.length>0&&(c===void 0?c=o=p:c+=`\\${p}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof o=="string"&&b(o.charCodeAt(0))){++n;const r=o.length;r>1&&b(o.charCodeAt(1))&&(++n,r>2&&(b(o.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&b(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.$fc.normalize(c)},relative(i,c){if(v(i,"from"),v(c,"to"),i===c)return"";const o=e.$fc.resolve(i),t=e.$fc.resolve(c);if(o===t||(i=o.toLowerCase(),c=t.toLowerCase(),i===c))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===a;)n++;let r=i.length;for(;r-1>n&&i.charCodeAt(r-1)===a;)r--;const p=r-n;let A=0;for(;A<c.length&&c.charCodeAt(A)===a;)A++;let D=c.length;for(;D-1>A&&c.charCodeAt(D-1)===a;)D--;const k=D-A,I=p<k?p:k;let j=-1,N=0;for(;N<I;N++){const _=i.charCodeAt(n+N);if(_!==c.charCodeAt(A+N))break;_===a&&(j=N)}if(N!==I){if(j===-1)return t}else{if(k>I){if(c.charCodeAt(A+N)===a)return t.slice(A+N+1);if(N===2)return t.slice(A+N)}p>I&&(i.charCodeAt(n+N)===a?j=N:N===2&&(j=3)),j===-1&&(j=0)}let z="";for(N=n+j+1;N<=r;++N)(N===r||i.charCodeAt(N)===a)&&(z+=z.length===0?"..":"\\..");return A+=j,z.length>0?`${z}${t.slice(A,D)}`:(t.charCodeAt(A)===a&&++A,t.slice(A,D))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const c=e.$fc.resolve(i);if(c.length<=2)return i;if(c.charCodeAt(0)===a){if(c.charCodeAt(1)===a){const o=c.charCodeAt(2);if(o!==w&&o!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(u(c.charCodeAt(0))&&c.charCodeAt(1)===g&&c.charCodeAt(2)===a)return`\\\\?\\${c}`;return i},dirname(i){v(i,"path");const c=i.length;if(c===0)return".";let o=-1,t=0;const n=i.charCodeAt(0);if(c===1)return b(n)?i:".";if(b(n)){if(o=t=1,b(i.charCodeAt(1))){let A=2,D=A;for(;A<c&&!b(i.charCodeAt(A));)A++;if(A<c&&A!==D){for(D=A;A<c&&b(i.charCodeAt(A));)A++;if(A<c&&A!==D){for(D=A;A<c&&!b(i.charCodeAt(A));)A++;if(A===c)return i;A!==D&&(o=t=A+1)}}}}else u(n)&&i.charCodeAt(1)===g&&(o=c>2&&b(i.charCodeAt(2))?3:2,t=o);let r=-1,p=!0;for(let A=c-1;A>=t;--A)if(b(i.charCodeAt(A))){if(!p){r=A;break}}else p=!1;if(r===-1){if(o===-1)return".";r=o}return i.slice(0,r)},basename(i,c){c!==void 0&&v(c,"ext"),v(i,"path");let o=0,t=-1,n=!0,r;if(i.length>=2&&u(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(o=2),c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let p=c.length-1,A=-1;for(r=i.length-1;r>=o;--r){const D=i.charCodeAt(r);if(b(D)){if(!n){o=r+1;break}}else A===-1&&(n=!1,A=r+1),p>=0&&(D===c.charCodeAt(p)?--p===-1&&(t=r):(p=-1,t=A))}return o===t?t=A:t===-1&&(t=i.length),i.slice(o,t)}for(r=i.length-1;r>=o;--r)if(b(i.charCodeAt(r))){if(!n){o=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":i.slice(o,t)},extname(i){v(i,"path");let c=0,o=-1,t=0,n=-1,r=!0,p=0;i.length>=2&&i.charCodeAt(1)===g&&u(i.charCodeAt(0))&&(c=t=2);for(let A=i.length-1;A>=c;--A){const D=i.charCodeAt(A);if(b(D)){if(!r){t=A+1;break}continue}n===-1&&(r=!1,n=A+1),D===P?o===-1?o=A:p!==1&&(p=1):o!==-1&&(p=-1)}return o===-1||n===-1||p===0||p===1&&o===n-1&&o===t+1?"":i.slice(o,n)},format:E.bind(null,"\\"),parse(i){v(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const o=i.length;let t=0,n=i.charCodeAt(0);if(o===1)return b(n)?(c.root=c.dir=i,c):(c.base=c.name=i,c);if(b(n)){if(t=1,b(i.charCodeAt(1))){let j=2,N=j;for(;j<o&&!b(i.charCodeAt(j));)j++;if(j<o&&j!==N){for(N=j;j<o&&b(i.charCodeAt(j));)j++;if(j<o&&j!==N){for(N=j;j<o&&!b(i.charCodeAt(j));)j++;j===o?t=j:j!==N&&(t=j+1)}}}}else if(u(n)&&i.charCodeAt(1)===g){if(o<=2)return c.root=c.dir=i,c;if(t=2,b(i.charCodeAt(2))){if(o===3)return c.root=c.dir=i,c;t=3}}t>0&&(c.root=i.slice(0,t));let r=-1,p=t,A=-1,D=!0,k=i.length-1,I=0;for(;k>=t;--k){if(n=i.charCodeAt(k),b(n)){if(!D){p=k+1;break}continue}A===-1&&(D=!1,A=k+1),n===P?r===-1?r=k:I!==1&&(I=1):r!==-1&&(I=-1)}return A!==-1&&(r===-1||I===0||I===1&&r===A-1&&r===p+1?c.base=c.name=i.slice(p,A):(c.name=i.slice(p,r),c.base=i.slice(p,A),c.ext=i.slice(r,A))),p>0&&p!==t?c.dir=i.slice(0,p-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(m){const i=/\\/g;return()=>{const c=S.cwd().replace(i,"/");return c.slice(c.indexOf("/"))}}return()=>S.cwd()})();e.$gc={resolve(...i){let c="",o=!1;for(let t=i.length-1;t>=-1&&!o;t--){const n=t>=0?i[t]:h();v(n,"path"),n.length!==0&&(c=`${n}/${c}`,o=n.charCodeAt(0)===f)}return c=l(c,!o,"/",$),o?`/${c}`:c.length>0?c:"."},normalize(i){if(v(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===f,o=i.charCodeAt(i.length-1)===f;return i=l(i,!c,"/",$),i.length===0?c?"/":o?"./":".":(o&&(i+="/"),c?`/${i}`:i)},isAbsolute(i){return v(i,"path"),i.length>0&&i.charCodeAt(0)===f},join(...i){if(i.length===0)return".";let c;for(let o=0;o<i.length;++o){const t=i[o];v(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.$gc.normalize(c)},relative(i,c){if(v(i,"from"),v(c,"to"),i===c||(i=e.$gc.resolve(i),c=e.$gc.resolve(c),i===c))return"";const o=1,t=i.length,n=t-o,r=1,p=c.length-r,A=n<p?n:p;let D=-1,k=0;for(;k<A;k++){const j=i.charCodeAt(o+k);if(j!==c.charCodeAt(r+k))break;j===f&&(D=k)}if(k===A)if(p>A){if(c.charCodeAt(r+k)===f)return c.slice(r+k+1);if(k===0)return c.slice(r+k)}else n>A&&(i.charCodeAt(o+k)===f?D=k:k===0&&(D=0));let I="";for(k=o+D+1;k<=t;++k)(k===t||i.charCodeAt(k)===f)&&(I+=I.length===0?"..":"/..");return`${I}${c.slice(r+D)}`},toNamespacedPath(i){return i},dirname(i){if(v(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===f;let o=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===f){if(!t){o=n;break}}else t=!1;return o===-1?c?"/":".":c&&o===1?"//":i.slice(0,o)},basename(i,c){c!==void 0&&v(c,"ext"),v(i,"path");let o=0,t=-1,n=!0,r;if(c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let p=c.length-1,A=-1;for(r=i.length-1;r>=0;--r){const D=i.charCodeAt(r);if(D===f){if(!n){o=r+1;break}}else A===-1&&(n=!1,A=r+1),p>=0&&(D===c.charCodeAt(p)?--p===-1&&(t=r):(p=-1,t=A))}return o===t?t=A:t===-1&&(t=i.length),i.slice(o,t)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===f){if(!n){o=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":i.slice(o,t)},extname(i){v(i,"path");let c=-1,o=0,t=-1,n=!0,r=0;for(let p=i.length-1;p>=0;--p){const A=i.charCodeAt(p);if(A===f){if(!n){o=p+1;break}continue}t===-1&&(n=!1,t=p+1),A===P?c===-1?c=p:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||t===-1||r===0||r===1&&c===t-1&&c===o+1?"":i.slice(c,t)},format:E.bind(null,"/"),parse(i){v(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const o=i.charCodeAt(0)===f;let t;o?(c.root="/",t=1):t=0;let n=-1,r=0,p=-1,A=!0,D=i.length-1,k=0;for(;D>=t;--D){const I=i.charCodeAt(D);if(I===f){if(!A){r=D+1;break}continue}p===-1&&(A=!1,p=D+1),I===P?n===-1?n=D:k!==1&&(k=1):n!==-1&&(k=-1)}if(p!==-1){const I=r===0&&o?1:r;n===-1||k===0||k===1&&n===p-1&&n===r+1?c.base=c.name=i.slice(I,p):(c.name=i.slice(I,n),c.base=i.slice(I,p),c.ext=i.slice(n,p))}return r>0?c.dir=i.slice(0,r-1):o&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=m?e.$fc.normalize:e.$gc.normalize,e.$ic=m?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=m?e.$fc.join:e.$gc.join,e.$kc=m?e.$fc.resolve:e.$gc.resolve,e.$lc=m?e.$fc.relative:e.$gc.relative,e.$mc=m?e.$fc.dirname:e.$gc.dirname,e.$nc=m?e.$fc.basename:e.$gc.basename,e.$oc=m?e.$fc.extname:e.$gc.extname,e.$pc=m?e.$fc.format:e.$gc.format,e.$qc=m?e.$fc.parse:e.$gc.parse,e.$rc=m?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=m?e.$fc.sep:e.$gc.sep,e.$tc=m?e.$fc.delimiter:e.$gc.delimiter}),define(ie[33],ne([0,1,9,4,27,12]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function C(r){return r===47||r===92}e.$Qf=C;function P(r){return r.replace(/[\\/]/g,S.$gc.sep)}e.$Rf=P;function f(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Sf=f;function a(r,p=S.$gc.sep){if(!r)return"";const A=r.length,D=r.charCodeAt(0);if(C(D)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let I=3;const j=I;for(;I<A&&!C(r.charCodeAt(I));I++);if(j!==I&&!C(r.charCodeAt(I+1))){for(I+=1;I<A;I++)if(C(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,p)}}return p}else if($(D)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+p:r.slice(0,2);let k=r.indexOf("://");if(k!==-1){for(k+=3;k<A;k++)if(C(r.charCodeAt(k)))return r.slice(0,k+1)}return""}e.$Tf=a;function g(r){if(!R.$j||!r||r.length<5)return!1;let p=r.charCodeAt(0);if(p!==92||(p=r.charCodeAt(1),p!==92))return!1;let A=2;const D=A;for(;A<r.length&&(p=r.charCodeAt(A),p!==92);A++);return!(D===A||(p=r.charCodeAt(A+1),isNaN(p)||p===92))}e.$Uf=g;const w=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(r,p=R.$j){const A=p?w:y;return!(!r||r.length===0||/^\s+$/.test(r)||(A.lastIndex=0,A.test(r))||p&&d.test(r)||r==="."||r===".."||p&&r[r.length-1]==="."||p&&r.length!==r.trim().length||r.length>255)}e.$Vf=v;function m(r,p,A){const D=r===p;return!A||D?D:!r||!p?!1:(0,s.$2e)(r,p)}e.$Wf=m;function b(r,p,A,D=S.sep){if(r===p)return!0;if(!r||!p||p.length>r.length)return!1;if(A){if(!(0,s.$3e)(r,p))return!1;if(p.length===r.length)return!0;let I=p.length;return p.charAt(p.length-1)===D&&I--,r.charAt(I)===D}return p.charAt(p.length-1)!==D&&(p+=D),r.indexOf(p)===0}e.$Xf=b;function $(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Yf=$;function u(r,p){return R.$j&&r.endsWith(":")&&(r+=S.sep),(0,S.$ic)(r)||(r=(0,S.$jc)(p,r)),r=(0,S.$hc)(r),R.$j?(r=(0,s.$Ke)(r,S.sep),r.endsWith(":")&&(r+=S.sep)):(r=(0,s.$Ke)(r,S.sep),r||(r=S.sep)),r}e.$Zf=u;function l(r){const p=(0,S.$hc)(r);return R.$j?r.length>3?!1:E(p)&&(r.length===2||p.charCodeAt(2)===92):p===S.$gc.sep}e.$1f=l;function E(r,p=R.$j){return p?$(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$2f=E;function h(r,p=R.$j){return E(r,p)?r[0]:void 0}e.$3f=h;function i(r,p,A){return p.length>r.length?-1:r===p?0:(A&&(r=r.toLowerCase(),p=p.toLowerCase()),r.indexOf(p))}e.$4f=i;function c(r){const p=r.split(":");let A,D,k;for(const I of p){const j=Number(I);(0,O.$Cf)(j)?D===void 0?D=j:k===void 0&&(k=j):A=A?[A,I].join(":"):I}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:D!==void 0?D:void 0,column:k!==void 0?k:D!==void 0?1:void 0}}e.$5f=c;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(r,p,A=8){let D="";for(let I=0;I<A;I++){let j;I===0&&R.$j&&!p&&(A===3||A===4)?j=t:j=o,D+=j.charAt(Math.floor(Math.random()*j.length))}let k;return p?k=`${p}-${D}`:k=D,r?(0,S.$jc)(r,k):k}e.$6f=n}),define(ie[75],ne([0,1,4]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R||(e.Source=R={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function O(P,...f){const a=f.reduce((y,d)=>(y[d]=!0,y),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!a[y]).forEach(y=>{for(let d=0;d<g.length;d++)if(y.search(g[d])!==-1){delete P[y];break}})}e.$zl=O;function C(P){P&&(delete P.DEBUG,S.$k&&delete P.DYLD_LIBRARY_PATH,S.$l&&delete P.LD_PRELOAD)}e.$Al=C}),define(ie[7],ne([0,1,9,4]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,O=/^\//,C=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!O.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(t,n){return!t&&!n?"file":t}function a(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const g="",w="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,r,p,A,D,k=!1){typeof n=="object"?(this.scheme=n.scheme||g,this.authority=n.authority||g,this.path=n.path||g,this.query=n.query||g,this.fragment=n.fragment||g):(this.scheme=f(n,k),this.authority=r||g,this.path=a(this.scheme,p||g),this.query=A||g,this.fragment=D||g,P(this,k))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:p,path:A,query:D,fragment:k}=n;return r===void 0?r=this.scheme:r===null&&(r=g),p===void 0?p=this.authority:p===null&&(p=g),A===void 0?A=this.path:A===null&&(A=g),D===void 0?D=this.query:D===null&&(D=g),k===void 0?k=this.fragment:k===null&&(k=g),r===this.scheme&&p===this.authority&&A===this.path&&D===this.query&&k===this.fragment?this:new b(r,p,A,D,k)}static parse(n,r=!1){const p=y.exec(n);return p?new b(p[2]||g,o(p[4]||g),o(p[5]||g),o(p[7]||g),o(p[9]||g),r):new b(g,g,g,g,g)}static file(n){let r=g;if(R.$j&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const p=n.indexOf(w,2);p===-1?(r=n.substring(2),n=w):(r=n.substring(2,p),n=n.substring(p)||w)}return new b("file",r,n,g,g)}static from(n,r){return new b(n.scheme,n.authority,n.path,n.query,n.fragment,r)}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return R.$j&&n.scheme==="file"?p=d.file(S.$fc.join(E(n,!0),...r)).path:p=S.$gc.join(n.path,...r),n.with({path:p})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const r=new b(n);return r._formatted=n.external??null,r._fsPath=n._sep===m?n.fsPath??null:null,r}}else return n}}e.URI=d;function v(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$vc=v;const m=R.$j?1:void 0;class b extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,n,r){let p,A=-1;for(let D=0;D<t.length;D++){const k=t.charCodeAt(D);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||r&&k===91||r&&k===93||r&&k===58)A!==-1&&(p+=encodeURIComponent(t.substring(A,D)),A=-1),p!==void 0&&(p+=t.charAt(D));else{p===void 0&&(p=t.substr(0,D));const I=$[k];I!==void 0?(A!==-1&&(p+=encodeURIComponent(t.substring(A,D)),A=-1),p+=I):A===-1&&(A=D)}}return A!==-1&&(p+=encodeURIComponent(t.substring(A))),p!==void 0?p:t}function l(t){let n;for(let r=0;r<t.length;r++){const p=t.charCodeAt(r);p===35||p===63?(n===void 0&&(n=t.substr(0,r)),n+=$[p]):n!==void 0&&(n+=t[r])}return n!==void 0?n:t}function E(t,n){let r;return t.authority&&t.path.length>1&&t.scheme==="file"?r=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?r=t.path.substr(1):r=t.path[1].toLowerCase()+t.path.substr(2):r=t.path,R.$j&&(r=r.replace(/\//g,"\\")),r}e.$wc=E;function h(t,n){const r=n?l:u;let p="",{scheme:A,authority:D,path:k,query:I,fragment:j}=t;if(A&&(p+=A,p+=":"),(D||A==="file")&&(p+=w,p+=w),D){let N=D.indexOf("@");if(N!==-1){const z=D.substr(0,N);D=D.substr(N+1),N=z.lastIndexOf(":"),N===-1?p+=r(z,!1,!1):(p+=r(z.substr(0,N),!1,!1),p+=":",p+=r(z.substr(N+1),!1,!0)),p+="@"}D=D.toLowerCase(),N=D.lastIndexOf(":"),N===-1?p+=r(D,!1,!0):(p+=r(D.substr(0,N),!1,!0),p+=D.substr(N))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const N=k.charCodeAt(1);N>=65&&N<=90&&(k=`/${String.fromCharCode(N+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const N=k.charCodeAt(0);N>=65&&N<=90&&(k=`${String.fromCharCode(N+32)}:${k.substr(2)}`)}p+=r(k,!0,!1)}return I&&(p+="?",p+=r(I,!1,!1)),j&&(p+="#",p+=n?j:u(j,!1,!1)),p}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(c)?t.replace(c,n=>i(n)):t}}),define(ie[154],ne([0,1,7]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$1p=e.$Zp=e.$Yp=void 0;function R(a){const g=a;return g&&typeof g.type=="string"&&typeof g.severity=="string"}e.$Yp=R;function s(a){const g=[];let w;try{const y=JSON.parse(a.arguments),d=y[y.length-1];d&&d.__$stack&&(y.pop(),w=d.__$stack),g.push(...y)}catch{g.push("Unable to log remote console arguments",a.arguments)}return{args:g,stack:w}}e.$Zp=s;function O(a){if(typeof a!="string")return O(s(a).stack);const g=a;if(g){const w=C(g),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$1p=O;function C(a){if(!a)return a;const g=a.indexOf(`
`);return g===-1?a:a.substring(0,g)}function P(a,g){const{args:w,stack:y}=s(a),d=typeof w[0]=="string"&&w.length===1;let v=C(y);v&&(v=`(${v.trim()})`);let m=[];if(typeof w[0]=="string"?v&&d?m=[`%c[${g}] %c${w[0]} %c${v}`,f("blue"),f(""),f("grey")]:m=[`%c[${g}] %c${w[0]}`,f("blue"),f(""),...w.slice(1)]:m=[`%c[${g}]%`,f("blue"),...w],v&&!d&&m.push(v),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,m)}e.log=P;function f(a){return`color: ${a}`}}),define(ie[76],ne([0,1,17,7]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function s(f){return JSON.stringify(f,C)}e.$kh=s;function O(f){let a=JSON.parse(f);return a=P(a),a}e.$lh=O;function C(f,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function P(f,a=0){if(!f||a>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return R.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$be||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let g=0;g<f.length;++g)f[g]=P(f[g],a+1);else for(const g in f)Object.hasOwnProperty.call(f,g)&&(f[g]=P(f[g],a+1))}return f}e.$mh=P}),define(ie[13],ne([0,1,14,4,7]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var O;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$7f="vscode-tkn",e.$8f="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g){this.f=`${g}/${O.vscodeRemoteResource}`}set(g,w,y){this.a[g]=w,this.b[g]=y}setConnectionToken(g,w){this.c[g]=w}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(b){return S.$1(b),g}const w=g.authority;let y=this.a[w];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const d=this.b[w],v=this.c[w];let m=`path=${encodeURIComponent(g.path)}`;return typeof v=="string"&&(m+=`&${e.$8f}=${encodeURIComponent(v)}`),s.URI.from({scheme:R.$p?this.d:O.vscodeRemoteResource,authority:`${y}:${d}`,path:this.f,query:m})}}e.$9f=new C,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class P{static{this.a=e.$bg}asBrowserUri(g){const w=this.b(g,X);return this.uriToBrowserUri(w)}uriToBrowserUri(g){return g.scheme===O.vscodeRemote?e.$9f.rewrite(g):g.scheme===O.file&&(R.$n||R.$q&&R.$h.origin===`${O.vscodeFileResource}://${P.a}`)?g.with({scheme:O.vscodeFileResource,authority:g.authority||P.a,query:null,fragment:null}):g}asFileUri(g){const w=this.b(g,X);return this.uriToFileUri(w)}uriToFileUri(g){return g.scheme===O.vscodeFileResource?g.with({scheme:O.file,authority:g.authority!==P.a?g.authority:null,query:null,fragment:null}):g}b(g,w){return s.URI.isUri(g)?g:s.URI.parse(w.toUrl(g))}}e.$cg=new P;var f;(function(a){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(g.get("3"));const w="vscode-coi";function y(v){let m;typeof v=="string"?m=new URL(v).searchParams:v instanceof URL?m=v.searchParams:s.URI.isUri(v)&&(m=new URL(v.toString(!0)).searchParams);const b=m?.get(w);if(b)return g.get(b)}a.getHeadersFromQuery=y;function d(v,m,b){if(!globalThis.crossOriginIsolated)return;const $=m&&b?"3":b?"2":"1";v instanceof URLSearchParams?v.set(w,$):v[w]=$}a.addSearchParam=d})(f||(e.COI=f={}))}),define(ie[19],ne([0,1,33,13,9,4,27,7]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function f(d){return(0,P.$wc)(d,!0)}e.$jg=f;class a{constructor(v){this.a=v}compare(v,m,b=!1){return v===m?0:(0,C.$Ue)(this.getComparisonKey(v,b),this.getComparisonKey(m,b))}isEqual(v,m,b=!1){return v===m?!0:!v||!m?!1:this.getComparisonKey(v,b)===this.getComparisonKey(m,b)}getComparisonKey(v,m=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,m,b=!1){if(v.scheme===m.scheme){if(v.scheme===R.Schemas.file)return S.$Xf(f(v),f(m),this.a(v))&&v.query===m.query&&(b||v.fragment===m.fragment);if((0,e.$Ag)(v.authority,m.authority))return S.$Xf(v.path,m.path,this.a(v),"/")&&v.query===m.query&&(b||v.fragment===m.fragment)}return!1}joinPath(v,...m){return P.URI.joinPath(v,...m)}basenameOrAuthority(v){return(0,e.$sg)(v)||v.authority}basename(v){return s.$gc.basename(v.path)}extname(v){return s.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let m;return v.scheme===R.Schemas.file?m=P.URI.file(s.$mc(f(v))).path:(m=s.$gc.dirname(v.path),v.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),m="/")),v.with({path:m})}normalizePath(v){if(!v.path.length)return v;let m;return v.scheme===R.Schemas.file?m=P.URI.file(s.$hc(f(v))).path:m=s.$gc.normalize(v.path),v.with({path:m})}relativePath(v,m){if(v.scheme!==m.scheme||!(0,e.$Ag)(v.authority,m.authority))return;if(v.scheme===R.Schemas.file){const u=s.$lc(f(v),f(m));return O.$j?S.$Rf(u):u}let b=v.path||"/";const $=m.path||"/";if(this.a(v)){let u=0;for(const l=Math.min(b.length,$.length);u<l&&!(b.charCodeAt(u)!==$.charCodeAt(u)&&b.charAt(u).toLowerCase()!==$.charAt(u).toLowerCase());u++);b=$.substr(0,u)+b.substr(u)}return s.$gc.relative(b,$)}resolvePath(v,m){if(v.scheme===R.Schemas.file){const b=P.URI.file(s.$kc(f(v),m));return v.with({authority:b.authority,path:b.path})}return m=S.$Sf(m),v.with({path:s.$gc.resolve(v.path,m)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,m){return v===m||v!==void 0&&m!==void 0&&(0,C.$2e)(v,m)}hasTrailingPathSeparator(v,m=s.sep){if(v.scheme===R.Schemas.file){const b=f(v);return b.length>S.$Tf(b).length&&b[b.length-1]===m}else{const b=v.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,m=s.sep){return(0,e.$Bg)(v,m)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,m=s.sep){let b=!1;if(v.scheme===R.Schemas.file){const $=f(v);b=$!==void 0&&$.length===S.$Tf($).length&&$[$.length-1]===m}else{m="/";const $=v.path;b=$.length===1&&$.charCodeAt($.length-1)===47}return!b&&!(0,e.$Bg)(v,m)?v.with({path:v.path+"/"}):v}}e.$kg=a,e.$lg=new a(()=>!1),e.$mg=new a(d=>d.scheme===R.Schemas.file?!O.$l:!0),e.$ng=new a(d=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function g(d,v){const m=[];for(let b=0;b<d.length;b++){const $=v(d[b]);d.some((u,l)=>l===b?!1:(0,e.$pg)($,v(u)))||m.push(d[b])}return m}e.$Eg=g;var w;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function v(m){const b=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(l=>{const[E,h]=l.split(":");E&&h&&b.set(E,h)});const u=m.path.substring(0,m.path.indexOf(";"));return u&&b.set(d.META_DATA_MIME,u),b}d.parseMetaData=v})(w||(e.DataUri=w={}));function y(d,v,m){if(v){let b=d.path;return b&&b[0]!==s.$gc.sep&&(b=s.$gc.sep+b),d.with({scheme:m,authority:v,path:b})}return d.with({scheme:m})}e.$Fg=y}),define(ie[8],ne([0,1,22,14,3,2,19,4,143]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function a(U){return!!U&&typeof U.then=="function"}e.$Gg=a;function g(U){const W=new S.$Xd,L=U(W.token),V=new Promise((J,oe)=>{const le=W.token.onCancellationRequested(()=>{le.dispose(),W.dispose(),oe(new R.$5)});Promise.resolve(L).then(de=>{le.dispose(),W.dispose(),J(de)},de=>{le.dispose(),W.dispose(),oe(de)})});return new class{cancel(){W.cancel()}then(J,oe){return V.then(J,oe)}catch(J){return this.then(void 0,J)}finally(J){return V.finally(J)}}}e.$Hg=g;function w(U,W,L){return new Promise((V,J)=>{const oe=W.onCancellationRequested(()=>{oe.dispose(),V(L)});U.then(V,J).finally(()=>oe.dispose())})}e.$Ig=w;function y(U,W){return new Promise((L,V)=>{const J=W.onCancellationRequested(()=>{J.dispose(),V(new R.$5)});U.then(L,V).finally(()=>J.dispose())})}e.$Jg=y;async function d(U){let W=-1;const L=U.map((V,J)=>V.then(oe=>(W=J,oe)));try{return await Promise.race(L)}finally{U.forEach((V,J)=>{J!==W&&V.cancel()})}}e.$Kg=d;function v(U,W,L){let V;const J=setTimeout(()=>{V?.(void 0),L?.()},W);return Promise.race([U.finally(()=>clearTimeout(J)),new Promise(oe=>V=oe)])}e.$Lg=v;function m(U){return new Promise((W,L)=>{const V=U();a(V)?V.then(W,L):W(V)})}e.$Mg=m;class b{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(W){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=W,!this.b){const L=()=>{if(this.b=null,this.f)return;const V=this.queue(this.d);return this.d=null,V};this.b=new Promise(V=>{this.a.then(L,L).then(V)})}return new Promise((L,V)=>{this.b.then(L,V)})}return this.a=W(),new Promise((L,V)=>{this.a.then(J=>{this.a=null,L(J)},J=>{this.a=null,V(J)})})}dispose(){this.f=!0}}e.$Ng=b;class ${constructor(){this.a=Promise.resolve(null)}queue(W){return this.a=this.a.then(()=>W(),()=>W())}}e.$Og=$;class u{constructor(){this.a=new Map}queue(W,L){const J=(this.a.get(W)??Promise.resolve()).catch(()=>{}).then(L).finally(()=>{this.a.get(W)===J&&this.a.delete(W)});return this.a.set(W,J),J}}e.$Pg=u;const l=(U,W)=>{let L=!0;const V=setTimeout(()=>{L=!1,W()},U);return{isTriggered:()=>L,dispose:()=>{clearTimeout(V),L=!1}}},E=U=>{let W=!0;return queueMicrotask(()=>{W&&(W=!1,U())}),{isTriggered:()=>W,dispose:()=>{W=!1}}};class h{constructor(W){this.defaultDelay=W,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(W,L=this.defaultDelay){this.g=W,this.h(),this.b||(this.b=new Promise((J,oe)=>{this.d=J,this.f=oe}).then(()=>{if(this.b=null,this.d=null,this.g){const J=this.g;return this.g=null,J()}}));const V=()=>{this.a=null,this.d?.(null)};return this.a=L===f.$Kd?E(V):l(L,V),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=h;class i{constructor(W){this.a=new h(W),this.b=new b}trigger(W,L){return this.a.trigger(()=>this.b.queue(W),L)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=i;class c{constructor(){this.a=!1,this.b=new Promise((W,L)=>{this.d=W})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=c;class o extends c{constructor(W){super(),this.f=setTimeout(()=>this.open(),W)}open(){clearTimeout(this.f),super.open()}}e.$Tg=o;function t(U,W){return W?new Promise((L,V)=>{const J=setTimeout(()=>{oe.dispose(),L()},U),oe=W.onCancellationRequested(()=>{clearTimeout(J),oe.dispose(),V(new R.$5)})}):g(L=>t(U,L))}e.$Ug=t;function n(U,W=0,L){const V=setTimeout(()=>{U(),L&&J.dispose()},W),J=(0,O.$Qc)(()=>{clearTimeout(V),L?.deleteAndLeak(J)});return L?.add(J),J}e.$Vg=n;function r(U){const W=[];let L=0;const V=U.length;function J(){return L<V?U[L++]():null}function oe(le){le!=null&&W.push(le);const de=J();return de?de.then(oe):Promise.resolve(W)}return Promise.resolve(null).then(oe)}e.$Wg=r;function p(U,W=V=>!!V,L=null){let V=0;const J=U.length,oe=()=>{if(V>=J)return Promise.resolve(L);const le=U[V++];return Promise.resolve(le()).then(fe=>W(fe)?Promise.resolve(fe):oe())};return oe()}e.$Xg=p;function A(U,W=V=>!!V,L=null){if(U.length===0)return Promise.resolve(L);let V=U.length;const J=()=>{V=-1;for(const oe of U)oe.cancel?.()};return new Promise((oe,le)=>{for(const de of U)de.then(fe=>{--V>=0&&W(fe)?(J(),oe(fe)):V===0&&oe(L)}).catch(fe=>{--V>=0&&(J(),le(fe))})})}e.$Yg=A;class D{constructor(W){this.a=0,this.d=W,this.f=[],this.b=0,this.g=new s.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(W){return this.a++,new Promise((L,V)=>{this.f.push({factory:W,c:L,e:V}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const W=this.f.shift();this.b++;const L=W.factory();L.then(W.c,W.e),L.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=D;class k extends D{constructor(){super(1)}}e.$1g=k;class I{constructor(){this.a=new Q,this.b=0}queue(W){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,W())):this.a.run(this.b++,W())}}e.$2g=I;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const W=new T;return this.b.add(W),W.p}g(){for(const[,W]of this.a)if(W.size>0)return!1;return!0}queueFor(W,L=C.$lg){const V=L.getComparisonKey(W);let J=this.a.get(V);if(!J){J=new k;const oe=this.f++,le=s.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(V),this.h(),this.d?.deleteAndDispose(oe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$1c),this.d.set(oe,le),this.a.set(V,J)}return J}h(){this.g()&&this.j()}j(){for(const W of this.b)W.complete();this.b.clear()}dispose(){for(const[,W]of this.a)W.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=j;class N{constructor(W,L){this.a=-1,typeof W=="function"&&typeof L=="number"&&this.setIfNotSet(W,L)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(W,L){this.cancel(),this.a=setTimeout(()=>{this.a=-1,W()},L)}setIfNotSet(W,L){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,W()},L))}}e.$4g=N;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(W,L){this.cancel(),this.a=setInterval(()=>{W()},L)}}e.$5g=z;class _{constructor(W,L){this.b=-1,this.a=W,this.d=L,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(W=this.d){this.cancel(),this.b=setTimeout(this.f,W)}get delay(){return this.d}set delay(W){this.d=W}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=_;class Y{constructor(W,L){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.a=W,this.b=L,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(W=this.b){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(W/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=Y;class ce extends _{constructor(W,L){super(W,L),this.j=[]}work(W){this.j.push(W),this.isScheduled()||this.schedule()}h(){const W=this.j;this.j=[],this.a?.(W)}dispose(){this.j=[],super.dispose()}}e.$8g=ce;class re extends O.$Sc{constructor(W,L){super(),this.g=W,this.h=L,this.a=[],this.b=this.B(new O.$Tc),this.f=!1}get pending(){return this.a.length}work(W){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+W.length>this.g.maxBufferedWork)return!1}else if(this.pending+W.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const L of W)this.a.push(L);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=U=>{(0,P.$B)(()=>{if(W)return;const L=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,L-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.$0g=(U,W)=>{const L=requestIdleCallback(U,typeof W=="number"?{timeout:W}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(L))}}}}();class ae{constructor(W){this.d=!1,this.a=()=>{try{this.f=W()}catch(L){this.g=L}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=ae;async function Z(U,W,L){let V;for(let J=0;J<L;J++)try{return await U()}catch(oe){V=oe,await t(W)}throw V}e.$_g=Z;class Q{isRunning(W){return typeof W=="number"?this.a?.taskId===W:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(W,L,V){return this.a={taskId:W,cancel:()=>V?.(),promise:L},L.then(()=>this.d(W),()=>this.d(W)),L}d(W){this.a&&W===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const W=this.b;this.b=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}queue(W){if(this.b)this.b.run=W;else{let L,V;const J=new Promise((oe,le)=>{L=oe,V=le});this.b={run:W,promise:J,promiseResolve:L,promiseReject:V}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=Q;class G{constructor(W,L=()=>Date.now()){this.d=W,this.f=L,this.a=0,this.b=0}increment(){const W=this.f();return W-this.a>this.d&&(this.a=W,this.b=0),this.b++,this.b}}e.$bh=G;var q;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(q||(q={}));class T{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((W,L)=>{this.a=W,this.b=L})}complete(W){return new Promise(L=>{this.a(W),this.d={outcome:0,value:W},L()})}error(W){return new Promise(L=>{this.b(W),this.d={outcome:1,value:W},L()})}cancel(){return this.error(new R.$5)}}e.$ch=T;var K;(function(U){async function W(V){let J;const oe=await Promise.all(V.map(le=>le.then(de=>de,de=>{J||(J=de)})));if(typeof J<"u")throw J;return oe}U.settled=W;function L(V){return new Promise(async(J,oe)=>{try{await V(J,oe)}catch(le){oe(le)}})}U.withAsyncBody=L})(K||(e.Promises=K={}));var H;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(H||(H={}));class x{static fromArray(W){return new x(L=>{L.emitMany(W)})}static fromPromise(W){return new x(async L=>{L.emitMany(await W)})}static fromPromises(W){return new x(async L=>{await Promise.all(W.map(async V=>L.emitOne(await V)))})}static merge(W){return new x(async L=>{await Promise.all(W.map(async V=>{for await(const J of V)L.emitOne(J)}))})}static{this.EMPTY=x.fromArray([])}constructor(W){this.a=0,this.b=[],this.d=null,this.f=new s.$Nd,queueMicrotask(async()=>{const L={emitOne:V=>this.g(V),emitMany:V=>this.h(V),reject:V=>this.k(V)};try{await Promise.resolve(W(L)),this.j()}catch(V){this.k(V)}finally{L.emitOne=void 0,L.emitMany=void 0,L.reject=void 0}})}[Symbol.asyncIterator](){let W=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(W<this.b.length)return{done:!1,value:this.b[W++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(W,L){return new x(async V=>{for await(const J of W)V.emitOne(L(J))})}map(W){return x.map(this,W)}static filter(W,L){return new x(async V=>{for await(const J of W)L(J)&&V.emitOne(J)})}filter(W){return x.filter(this,W)}static coalesce(W){return x.filter(W,L=>!!L)}coalesce(){return x.coalesce(this)}static async toPromise(W){const L=[];for await(const V of W)L.push(V);return L}toPromise(){return x.toPromise(this)}g(W){this.a===0&&(this.b.push(W),this.f.fire())}h(W){this.a===0&&(this.b=this.b.concat(W),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(W){this.a===0&&(this.a=2,this.d=W,this.f.fire())}}e.$dh=x;class B extends x{constructor(W,L){super(L),this.l=W}cancel(){this.l.cancel()}}e.$eh=B;function F(U){const W=new S.$Xd,L=U(W.token);return new B(W,async V=>{const J=W.token.onCancellationRequested(()=>{J.dispose(),W.dispose(),V.reject(new R.$5)});try{for await(const oe of L){if(W.token.isCancellationRequested)return;V.emitOne(oe)}J.dispose(),W.dispose()}catch(oe){J.dispose(),W.dispose(),V.reject(oe)}})}e.$fh=F;class M{constructor(){this.a=new T,this.b=new x(V=>{if(W){V.reject(W);return}return L&&V.emitMany(L),this.d=J=>V.reject(J),this.f=J=>V.emitOne(J),this.a.p});let W,L;this.f=V=>{L||(L=[]),L.push(V)},this.d=V=>{W||(W=V)}}get asyncIterable(){return this.b}complete(){this.a.complete()}error(W){this.d(W),this.a.complete()}emit(W){this.f(W)}}e.$gh=M}),define(ie[104],ne([0,1,23,8,33,31,9,4,27]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function a(){return Object.create(null)}e.$rj=a,e.$sj="**",e.$tj="/";const g="[/\\\\]",w="[^/\\\\]",y=/\//g;function d(Q,G){switch(Q){case 0:return"";case 1:return`${w}*?`;default:return`(?:${g}|${w}+${g}${G?`|${g}${w}+`:""})*?`}}function v(Q,G){if(!Q)return[];const q=[];let T=!1,K=!1,H="";for(const x of Q){switch(x){case G:if(!T&&!K){q.push(H),H="";continue}break;case"{":T=!0;break;case"}":T=!1;break;case"[":K=!0;break;case"]":K=!1;break}H+=x}return H&&q.push(H),q}e.$uj=v;function m(Q){if(!Q)return"";let G="";const q=v(Q,e.$tj);if(q.every(T=>T===e.$sj))G=".*";else{let T=!1;q.forEach((K,H)=>{if(K===e.$sj){if(T)return;G+=d(2,H===q.length-1)}else{let x=!1,B="",F=!1,M="";for(const U of K){if(U!=="}"&&x){B+=U;continue}if(F&&(U!=="]"||!M)){let W;U==="-"?W=U:(U==="^"||U==="!")&&!M?W="^":U===e.$tj?W="":W=(0,f.$Fe)(U),M+=W;continue}switch(U){case"{":x=!0;continue;case"[":F=!0;continue;case"}":{const L=`(?:${v(B,",").map(V=>m(V)).join("|")})`;G+=L,x=!1,B="";break}case"]":{G+="["+M+"]",F=!1,M="";break}case"?":G+=w;continue;case"*":G+=d(1);continue;default:G+=(0,f.$Fe)(U)}}H<q.length-1&&(q[H+1]!==e.$sj||H+2<q.length)&&(G+=g)}T=K===e.$sj})}return G}const b=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.$Dc(1e4),c=function(){return!1},o=function(){return null};function t(Q,G){if(!Q)return o;let q;typeof Q!="string"?q=Q.pattern:q=Q,q=q.trim();const T=`${q}_${!!G.trimForExclusions}`;let K=i.get(T);if(K)return n(K,Q);let H;return b.test(q)?K=p(q.substr(4),q):(H=$.exec(r(q,G)))?K=A(H[1],q):(G.trimForExclusions?l:u).test(q)?K=D(q,G):(H=E.exec(r(q,G)))?K=k(H[1].substr(1),q,!0):(H=h.exec(r(q,G)))?K=k(H[1],q,!1):K=I(q),i.set(T,K),n(K,Q)}function n(Q,G){if(typeof G=="string")return Q;const q=function(T,K){return(0,s.$Xf)(T,G.base,!P.$l)?Q((0,f.$Je)(T.substr(G.base.length),C.sep),K):null};return q.allBasenames=Q.allBasenames,q.allPaths=Q.allPaths,q.basenames=Q.basenames,q.patterns=Q.patterns,q}function r(Q,G){return G.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function p(Q,G){return function(q,T){return typeof q=="string"&&q.endsWith(Q)?G:null}}function A(Q,G){const q=`/${Q}`,T=`\\${Q}`,K=function(x,B){return typeof x!="string"?null:B?B===Q?G:null:x===Q||x.endsWith(q)||x.endsWith(T)?G:null},H=[Q];return K.basenames=H,K.patterns=[G],K.allBasenames=H,K}function D(Q,G){const q=ae(Q.slice(1,-1).split(",").map(B=>t(B,G)).filter(B=>B!==o),Q),T=q.length;if(!T)return o;if(T===1)return q[0];const K=function(B,F){for(let M=0,U=q.length;M<U;M++)if(q[M](B,F))return Q;return null},H=q.find(B=>!!B.allBasenames);H&&(K.allBasenames=H.allBasenames);const x=q.reduce((B,F)=>F.allPaths?B.concat(F.allPaths):B,[]);return x.length&&(K.allPaths=x),K}function k(Q,G,q){const T=C.sep===C.$gc.sep,K=T?Q:Q.replace(y,C.sep),H=C.sep+K,x=C.$gc.sep+Q;let B;return q?B=function(F,M){return typeof F=="string"&&(F===K||F.endsWith(H)||!T&&(F===Q||F.endsWith(x)))?G:null}:B=function(F,M){return typeof F=="string"&&(F===K||!T&&F===Q)?G:null},B.allPaths=[(q?"*/":"./")+Q],B}function I(Q){try{const G=new RegExp(`^${m(Q)}$`);return function(q){return G.lastIndex=0,typeof q=="string"&&G.test(q)?Q:null}}catch{return o}}function j(Q,G,q){return!Q||typeof G!="string"?!1:N(Q)(G,void 0,q)}e.$vj=j;function N(Q,G={}){if(!Q)return c;if(typeof Q=="string"||z(Q)){const q=t(Q,G);if(q===o)return c;const T=function(K,H){return!!q(K,H)};return q.allBasenames&&(T.allBasenames=q.allBasenames),q.allPaths&&(T.allPaths=q.allPaths),T}return ce(Q,G)}e.$wj=N;function z(Q){const G=Q;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$xj=z;function _(Q){return Q.allBasenames||[]}e.$yj=_;function Y(Q){return Q.allPaths||[]}e.$zj=Y;function ce(Q,G){const q=ae(Object.getOwnPropertyNames(Q).map(B=>re(B,Q[B],G)).filter(B=>B!==o)),T=q.length;if(!T)return o;if(!q.some(B=>!!B.requiresSiblings)){if(T===1)return q[0];const B=function(U,W){let L;for(let V=0,J=q.length;V<J;V++){const oe=q[V](U,W);if(typeof oe=="string")return oe;(0,R.$Gg)(oe)&&(L||(L=[]),L.push(oe))}return L?(async()=>{for(const V of L){const J=await V;if(typeof J=="string")return J}return null})():null},F=q.find(U=>!!U.allBasenames);F&&(B.allBasenames=F.allBasenames);const M=q.reduce((U,W)=>W.allPaths?U.concat(W.allPaths):U,[]);return M.length&&(B.allPaths=M),B}const K=function(B,F,M){let U,W;for(let L=0,V=q.length;L<V;L++){const J=q[L];J.requiresSiblings&&M&&(F||(F=(0,C.$nc)(B)),U||(U=F.substr(0,F.length-(0,C.$oc)(B).length)));const oe=J(B,F,U,M);if(typeof oe=="string")return oe;(0,R.$Gg)(oe)&&(W||(W=[]),W.push(oe))}return W?(async()=>{for(const L of W){const V=await L;if(typeof V=="string")return V}return null})():null},H=q.find(B=>!!B.allBasenames);H&&(K.allBasenames=H.allBasenames);const x=q.reduce((B,F)=>F.allPaths?B.concat(F.allPaths):B,[]);return x.length&&(K.allPaths=x),K}function re(Q,G,q){if(G===!1)return o;const T=t(Q,q);if(T===o)return o;if(typeof G=="boolean")return T;if(G){const K=G.when;if(typeof K=="string"){const H=(x,B,F,M)=>{if(!M||!T(x,B))return null;const U=K.replace("$(basename)",()=>F),W=M(U);return(0,R.$Gg)(W)?W.then(L=>L?Q:null):W?Q:null};return H.requiresSiblings=!0,H}}return T}function ae(Q,G){const q=Q.filter(B=>!!B.basenames);if(q.length<2)return Q;const T=q.reduce((B,F)=>{const M=F.basenames;return M?B.concat(M):B},[]);let K;if(G){K=[];for(let B=0,F=T.length;B<F;B++)K.push(G)}else K=q.reduce((B,F)=>{const M=F.patterns;return M?B.concat(M):B},[]);const H=function(B,F){if(typeof B!="string")return null;if(!F){let U;for(U=B.length;U>0;U--){const W=B.charCodeAt(U-1);if(W===47||W===92)break}F=B.substr(U)}const M=T.indexOf(F);return M!==-1?K[M]:null};H.basenames=T,H.patterns=K,H.allBasenames=T;const x=Q.filter(B=>!B.basenames);return x.push(H),x}function Z(Q,G){return(0,S.$ub)(Q,G,(q,T)=>typeof q=="string"&&typeof T=="string"?q===T:typeof q!="string"&&typeof T!="string"?q.base===T.base&&q.pattern===T.pattern:!1)}e.$Aj=Z}),define(ie[46],ne([0,1,23,33,9,4,19,27]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=void 0;function f(t,n){const{os:r,tildify:p,relative:A}=n;if(A){const I=a(t,A,r);if(typeof I=="string")return I}let D=t.fsPath;if(r===1&&!O.$j?D=D.replace(/\//g,"\\"):r!==1&&O.$j&&(D=D.replace(/\\/g,"/")),r!==1&&p?.userHome){const I=p.userHome.fsPath;let j;t.scheme!==p.userHome.scheme&&t.path.startsWith(s.$gc.sep)?j=p.userHome.with({path:t.path}).fsPath:j=t.fsPath,D=y(j,I,r)}return(r===1?s.$fc:s.$gc).normalize(g(D,r===1))}e.$rv=f;function a(t,n,r){const p=r===1?s.$fc:s.$gc,A=r===3?C.$lg:C.$ng,D=n.getWorkspace(),k=(0,S.$Ob)(D.folders);if(!k)return;t.scheme!==k.uri.scheme&&t.path.startsWith(s.$gc.sep)&&(t=k.uri.with({path:t.path}));const I=n.getWorkspaceFolder(t);if(!I)return;let j;if(A.isEqual(I.uri,t)?j="":j=A.relativePath(I.uri,t)??"",j&&(j=p.normalize(j)),D.folders.length>1&&!n.noPrefix){const N=I.name?I.name:A.basenameOrAuthority(I.uri);j=j?`${N} \u2022 ${j}`:N}return j}function g(t,n=O.$j){return(0,R.$2f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$sv=g;let w=Object.create(null);function y(t,n,r=O.OS){if(r===1||!t||!n)return t;let p=w.original===n?w.normalized:void 0;p||(p=n,O.$j&&(p=(0,R.$Rf)(p)),p=`${(0,P.$Ke)(p,s.$gc.sep)}${s.$gc.sep}`,w={original:n,normalized:p});let A=t;return O.$j&&(A=(0,R.$Rf)(A)),(r===3?A.startsWith(p):(0,P.$3e)(A,p))?`~/${A.substr(p.length)}`:t}e.$tv=y;function d(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$uv=d;const v="\u2026",m="\\\\",b="~";function $(t,n=s.sep){const r=new Array(t.length);let p=!1;for(let A=0;A<t.length;A++){const D=t[A];if(D===""){r[A]=`.${n}`;continue}if(!D){r[A]=D;continue}p=!0;let k="",I=D;I.indexOf(m)===0?(k=I.substr(0,I.indexOf(m)+m.length),I=I.substr(I.indexOf(m)+m.length)):I.indexOf(n)===0?(k=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf(b)===0&&(k=I.substr(0,I.indexOf(b)+b.length),I=I.substr(I.indexOf(b)+b.length));const j=I.split(n);for(let N=1;p&&N<=j.length;N++)for(let z=j.length-N;p&&z>=0;z--){p=!1;let _=j.slice(z,z+N).join(n);for(let Y=0;!p&&Y<t.length;Y++)if(Y!==A&&t[Y]&&t[Y].indexOf(_)>-1){const ce=z+N===j.length,re=z>0&&t[Y].indexOf(n)>-1?n+_:_,ae=t[Y].endsWith(re);p=!ce||ae}if(!p){let Y="";(j[0].endsWith(":")||k!=="")&&(z===1&&(z=0,N++,_=j[0]+n+_),z>0&&(Y=j[0]+n),Y=k+Y),z>0&&(Y=Y+v+n),Y=Y+_,z+N<j.length&&(Y=Y+n+v),r[A]=Y}}p&&(r[A]=D)}return r}e.$vv=$;var u;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function l(t,n=Object.create(null)){const r=[];let p=!1,A="";for(const D of t)if(D==="$"||p&&D==="{")A&&r.push({value:A,type:u.TEXT}),A="",p=!0;else if(D==="}"&&p){const k=n[A];if(typeof k=="string")k.length&&r.push({value:k,type:u.VARIABLE});else if(k){const I=r[r.length-1];(!I||I.type!==u.SEPARATOR)&&r.push({value:k.label,type:u.SEPARATOR})}A="",p=!1}else A+=D;return A&&!p&&r.push({value:A,type:u.TEXT}),r.filter((D,k)=>{if(D.type===u.SEPARATOR){const I=r[k-1],j=r[k+1];return[I,j].every(N=>N&&(N.type===u.VARIABLE||N.type===u.TEXT)&&N.value.length>0)}return!0}).map(D=>D.value).join("")}e.$wv=l;function E(t,n){return O.$k||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$k?"&":"&&"):t.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.$xv=E;function h(t,n){return O.$k||n?t.replace(/\(&&\w\)|&&/g,""):O.$j?t.replace(/&&|&/g,r=>r==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$yv=h;function i(t){return t.replace(/&/g,"&&")}e.$zv=i;function c(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const r=o(t.substring(0,n));return{name:r.name,parentPath:r.parentPath+t.substring(n)}}}return o(t)}e.$Av=c;function o(t){const n=t.indexOf("/")!==-1?s.$gc:s.$fc,r=n.basename(t),p=n.dirname(t);return r.length?{name:r,parentPath:p}:{name:p,parentPath:""}}}),define(ie[155],ne([0,1,17,7]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function s(w){return w.toJSON()}class O{constructor(y){this.a=y}transformIncoming(y){const d=this.a.transformIncoming(y);return d===y?y:s(R.URI.from(d))}transformOutgoing(y){const d=this.a.transformOutgoing(y);return d===y?y:s(R.URI.from(d))}transformOutgoingURI(y){const d=this.a.transformOutgoing(y);return d===y?y:R.URI.from(d)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Lm=O,e.$Mm=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function C(w,y,d){if(!w||d>200)return null;if(typeof w=="object"){if(w instanceof R.URI)return y.transformOutgoing(w);for(const v in w)if(Object.hasOwnProperty.call(w,v)){const m=C(w[v],y,d+1);m!==null&&(w[v]=m)}}return null}function P(w,y){const d=C(w,y,0);return d===null?w:d}e.$Nm=P;function f(w,y,d,v){if(!w||v>200)return null;if(typeof w=="object"){if(w.$mid===1)return d?R.URI.revive(y.transformIncoming(w)):y.transformIncoming(w);if(w instanceof S.$be)return null;for(const m in w)if(Object.hasOwnProperty.call(w,m)){const b=f(w[m],y,d,v+1);b!==null&&(w[m]=b)}}return null}function a(w,y){const d=f(w,y,!1,0);return d===null?w:d}e.$Om=a;function g(w,y){const d=f(w,y,!0,0);return d===null?w:d}e.$Pm=g}),define(ie[87],ne([0,1,28,56,32,145,4]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=new class{c(y){return this.a||(this.a=R.$Vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,d=0;const v=(0,S.networkInterfaces)();for(const m in v){const b=v[m];if(b)for(const{mac:$,internal:u}of b)u||(d+=1,this.c($.toUpperCase())&&(y+=1))}this.b=d>0?y/d:0}return this.b}};let P;async function f(y){return P||(P=(async()=>await a(y)||s.$eg())()),P}e.$Sm=f;async function a(y){try{const d=await new Promise((m,b)=>{X(["crypto"],m,b)}),v=(0,O.$Qm)();return d.createHash("sha256").update(v,"utf8").digest("hex")}catch(d){y(d);return}}const g="Software\\Microsoft\\SQMClient";async function w(y){if(C.$j){const d=await new Promise((v,m)=>{X(["@vscode/windows-registry"],v,m)});try{return d.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(v){return y(v),""}}return""}e.$Tm=w}),define(ie[21],ne([0,1,45,28,156,8,33,84,9,4,19,7]),function(X,e,S,R,s,O,C,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function d(re,ae=y.UNLINK,Z){if((0,C.$1f)(re))throw new Error("rimraf - will refuse to recursively delete root");return ae===y.UNLINK?m(re):v(re,Z)}async function v(re,ae=(0,C.$6f)((0,R.tmpdir)())){try{try{await S.promises.rename(re,ae)}catch(Z){return Z.code==="ENOENT"?void 0:m(re)}m(ae).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function m(re){return(0,s.promisify)(S.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function b(re){if((0,C.$1f)(re))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function $(re,ae){return E(await(ae?u(re):(0,s.promisify)(S.readdir)(re)))}async function u(re){try{return await(0,s.promisify)(S.readdir)(re,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const ae=[],Z=await $(re);for(const Q of Z){let G=!1,q=!1,T=!1;try{const K=await e.Promises.lstat((0,f.$jc)(re,Q));G=K.isFile(),q=K.isDirectory(),T=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}ae.push({name:Q,isFile:()=>G,isDirectory:()=>q,isSymbolicLink:()=>T})}return ae}function l(re){return E(S.readdirSync(re))}e.readdirSync=l;function E(re){return re.map(ae=>typeof ae=="string"?a.$k?(0,P.$ol)(ae):ae:(ae.name=a.$k?(0,P.$ol)(ae.name):ae.name,ae))}async function h(re){const ae=await $(re),Z=[];for(const Q of ae)await c.existsDirectory((0,f.$jc)(re,Q))&&Z.push(Q);return Z}function i(re,ae=1e3){return new Promise(Z=>{let Q=!1;const G=setInterval(()=>{Q||(Q=!0,S.access(re,q=>{Q=!1,q&&(clearInterval(G),Z(void 0))}))},ae)})}e.whenDeleted=i;var c;(function(re){async function ae(G){let q;try{if(q=await e.Promises.lstat(G),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(a.$j&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw K}throw T}}re.stat=ae;async function Z(G){try{const{stat:q,symbolicLink:T}=await re.stat(G);return q.isFile()&&T?.dangling!==!0}catch{}return!1}re.existsFile=Z;async function Q(G){try{const{stat:q,symbolicLink:T}=await re.stat(G);return q.isDirectory()&&T?.dangling!==!0}catch{}return!1}re.existsDirectory=Q})(c||(e.SymlinkSupport=c={}));const o=new O.$3g;function t(re,ae,Z){return o.queueFor(w.URI.file(re),g.$mg).queue(()=>{const Q=D(Z);return new Promise((G,q)=>p(re,ae,Q,T=>T?q(T):G()))})}let n=!0;function r(re){n=re}e.configureFlushOnWrite=r;function p(re,ae,Z,Q){if(!n)return S.writeFile(re,ae,{mode:Z.mode,flag:Z.flag},Q);S.open(re,Z.flag,Z.mode,(G,q)=>{if(G)return Q(G);S.writeFile(q,ae,T=>{if(T)return S.close(q,()=>Q(T));S.fdatasync(q,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),r(!1)),S.close(q,H=>Q(H))))})})}function A(re,ae,Z){const Q=D(Z);if(!n)return S.writeFileSync(re,ae,{mode:Q.mode,flag:Q.flag});const G=S.openSync(re,Q.flag,Q.mode);try{S.writeFileSync(G,ae);try{S.fdatasyncSync(G)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r(!1)}}finally{S.closeSync(G)}}e.writeFileSync=A;function D(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function k(re,ae,Z=6e4){if(re!==ae)try{a.$j&&typeof Z=="number"?await I(re,ae,Date.now(),Z):await(0,s.promisify)(S.rename)(re,ae)}catch(Q){if(re.toLowerCase()!==ae.toLowerCase()&&Q.code==="EXDEV"||re.endsWith("."))await j(re,ae,{preserveSymlinks:!1}),await d(re,y.MOVE);else throw Q}}async function I(re,ae,Z,Q,G=0){try{return await(0,s.promisify)(S.rename)(re,ae)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-Z>=Q)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${q}`),q;if(G===0){let T=!1;try{const{stat:K}=await c.stat(ae);K.isFile()||(T=!0)}catch{}if(T)throw q}return await(0,O.$Ug)(Math.min(100,G*10)),I(re,ae,Z,Q,G+1)}}async function j(re,ae,Z){return z(re,ae,{root:{source:re,target:ae},options:Z,handledSourcePaths:new Set})}const N=511;async function z(re,ae,Z){if(Z.handledSourcePaths.has(re))return;Z.handledSourcePaths.add(re);const{stat:Q,symbolicLink:G}=await c.stat(re);if(G){if(Z.options.preserveSymlinks)try{return await ce(re,ae,Z)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(G.dangling)return}return Q.isDirectory()?_(re,ae,Q.mode&N,Z):Y(re,ae,Q.mode&N)}async function _(re,ae,Z,Q){await e.Promises.mkdir(ae,{recursive:!0,mode:Z});const G=await $(re);for(const q of G)await z((0,f.$jc)(re,q),(0,f.$jc)(ae,q),Q)}async function Y(re,ae,Z){await e.Promises.copyFile(re,ae),await e.Promises.chmod(ae,Z)}async function ce(re,ae,Z){let Q=await e.Promises.readlink(re);(0,C.$Xf)(Q,Z.root.source,!a.$l)&&(Q=(0,f.$jc)(Z.root.target,Q.substr(Z.root.source.length+1))),await e.Promises.symlink(Q,ae)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(re,ae,Z,Q,G)=>new Promise((q,T)=>{S.read(re,ae,Z,Q,G,(K,H,x)=>K?T(K):q({bytesRead:H,buffer:x}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(re,ae,Z,Q,G)=>new Promise((q,T)=>{S.write(re,ae,Z,Q,G,(K,H,x)=>K?T(K):q({bytesWritten:H,buffer:x}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return h}get writeFile(){return t}get rm(){return d}get rename(){return k}get copy(){return j}}}),define(ie[105],ne([0,1,45,9,4,27,21]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=void 0;function P(y){if(s.$l)return y;const d=(0,R.$mc)(y);if(y===d)return y;const v=((0,R.$nc)(y)||y).toLowerCase();try{const b=(0,C.readdirSync)(d).filter($=>$.toLowerCase()===v);if(b.length===1){const $=P(d);if($)return(0,R.$jc)($,b[0])}else if(b.length>1){const $=b.indexOf(v);if($>=0){const u=P(d);if(u)return(0,R.$jc)(u,b[$])}}}catch{}return null}e.$6p=P;async function f(y){if(s.$l)return y;const d=(0,R.$mc)(y);if(y===d)return y;const v=((0,R.$nc)(y)||y).toLowerCase();try{const b=(await C.Promises.readdir(d)).filter($=>$.toLowerCase()===v);if(b.length===1){const $=await f(d);if($)return(0,R.$jc)($,b[0])}else if(b.length>1){const $=b.indexOf(v);if($>=0){const u=await f(d);if(u)return(0,R.$jc)(u,b[$])}}}catch{}return null}e.$7p=f;async function a(y){try{return await C.Promises.realpath(y)}catch{const v=w(y);return await C.Promises.access(v,S.constants.R_OK),v}}e.$8p=a;function g(y){try{return S.realpathSync(y)}catch{const v=w(y);return S.accessSync(v,S.constants.R_OK),v}}e.$9p=g;function w(y){return(0,O.$Ke)((0,R.$hc)(y),R.sep)}}),define(ie[106],ne([0,1,28,9,21]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0;const O=/^\d+$/,C=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(f||(f={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class w{constructor(h,i,c){this.exePath=h,this.displayName=i,this.a=c}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:E=!1}={}){return E?a===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:E=!1,findPreview:h=!1}={}){const i=y({useAlternateBitness:E});if(!i)return null;const c=R.$jc(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(c))return null;let o=-1,t=null;for(const p of await s.Promises.readdir(c)){let A=-1;if(h){const k=p.indexOf("-");if(k<0)continue;const I=p.substring(0,k);if(!O.test(I)||p.substring(k+1)!=="preview")continue;A=parseInt(I,10)}else{if(!O.test(p))continue;A=parseInt(p,10)}if(A<=o)continue;const D=R.$jc(c,p,"pwsh.exe");await s.SymlinkSupport.existsFile(D)&&(t=D,o=A)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",r=h?" Preview":"";return new w(t,`PowerShell${r}${n}`,!0)}async function v({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const h=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:i,pwshMsixName:c}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const o of await s.Promises.readdir(h))if(i.test(o)){const t=R.$jc(h,o,"pwsh.exe");return new w(t,c)}return null}function m(){const E=R.$jc(S.homedir(),".dotnet","tools","pwsh.exe");return new w(E,".NET Core PowerShell Global Tool")}function b(){const E=R.$jc(process.env.windir,a===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(E,"Windows PowerShell",!0)}async function*$(){let E=await d();E&&(yield E),E=await d({useAlternateBitness:!0}),E&&(yield E),E=await v(),E&&(yield E),E=m(),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await v({findPreview:!0}),E&&(yield E),E=await d({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=b(),E&&(yield E)}async function*u(){for await(const E of $())await E.exists()&&(yield E)}e.$xl=u;async function l(){for await(const E of u())return E;return null}e.$yl=l}),define(ie[88],ne([0,1,9,4,35,75,12,21]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function f(w=s.env){return w.comspec||"cmd.exe"}e.$Bl=f;function a(w){let y=[],d=!1;const v=function(m){if(d){y.push(m);return}(!w.send(m,$=>{if($&&console.error($),d=!1,y.length>0){const u=y.slice(0);y=[],u.forEach(l=>v(l))}})||R.$j)&&(d=!0)};return{send:v}}e.$Cl=a;var g;(function(w){async function y(d,v,m){if(S.$ic(d))return d;if(v===void 0&&(v=s.cwd()),S.$mc(d)!=="."||(m===void 0&&C.$yf(s.env.PATH)&&(m=s.env.PATH.split(S.$tc)),m===void 0||m.length===0))return S.$jc(v,d);async function $(u){if(await P.Promises.exists(u)){let l;try{l=await P.Promises.stat(u)}catch(E){E.message.startsWith("EACCES")&&(l=await P.Promises.lstat(u))}return l?!l.isDirectory():!1}return!1}for(const u of m){let l;if(S.$ic(u)?l=S.$jc(u,d):l=S.$jc(v,u,d),await $(l))return l;let E=l+".com";if(await $(E)||(E=l+".exe",await $(E)))return E}return S.$jc(v,d)}w.findExecutable=y})(g||(e.win32=g={}))}),define(ie[107],ne([0,1,47,13]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;function s(C){return new Promise((P,f)=>{let a;const g=new Map;function w(d,v,m,b,$){const u=g.get(v);if(d===C||u){const l={name:y(m),cmd:m,pid:d,ppid:v,load:b,mem:$};g.set(d,l),d===C&&(a=l),u&&(u.children||(u.children=[]),u.children.push(l),u.children.length>1&&(u.children=u.children.sort((E,h)=>E.pid-h.pid)))}}function y(d){const v=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,b=/--crashes-directory/i,$=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if(b.exec(d))return"electron-crash-reporter";if($.exec(d))return"winpty-agent";if(u.exec(d))return"conpty-agent";let E=l.exec(d);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?v.exec(d)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const h=/[a-zA-Z-]+\.js/g;let i="";do E=h.exec(d),E&&(i+=E+" ");while(E);return i&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${i})`:m.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,m)=>{X(["@vscode/windows-process-tree"],v,m)}).then(v=>{v.getProcessList(C,m=>{if(!m){f(new Error(`Root process ${C} not found`));return}v.getProcessCpuUsage(m,b=>{const $=new Map;b.forEach(u=>{const l=d(u.commandLine||"");$.set(u.pid,{name:y(l),cmd:l,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),a=$.get(C),a?($.forEach(u=>{const l=$.get(u.ppid);l&&(l.children||(l.children=[]),l.children.push(u))}),$.forEach(u=>{u.children&&(u.children=u.children.sort((l,E)=>l.pid-E.pid))}),P(a)):f(new Error(`Root process ${C} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let d=function(){let v=[a];const m=[];for(;v.length;){const $=v.shift();$&&(m.push($.pid),$.children&&(v=v.concat($.children)))}let b=JSON.stringify(R.$cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+m.join(" "),(0,S.exec)(b,{},($,u,l)=>{if($||l)f($||new Error(l.toString()));else{const E=u.toString().split(`
`);for(let h=0;h<m.length;h++){const i=g.get(m[h]);i.load=parseFloat(E[h])}if(!a){f(new Error(`Root process ${C} not found`));return}P(a)}})};(0,S.exec)("which ps",{},(v,m,b)=>{if(v||b)if(process.platform!=="linux")f(v||new Error(b.toString()));else{const $=JSON.stringify(R.$cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)($,{},(u,l,E)=>{u||E?f(u||new Error(E.toString())):(O(l,w),d())})}else{const $=m.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${$} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,E,h)=>{l||h&&!h.includes("screen size is bogus")?f(l||new Error(h.toString())):(O(E,w),process.platform==="linux"?d():a?P(a):f(new Error(`Root process ${C} not found`)))})}})}})}e.$Dr=s;function O(C,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=C.toString().split(`
`);for(const g of a){const w=f.exec(g.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ie[108],ne([0,1,28,4,106,88]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=void 0;async function C(w,y){return w===1?R.$j?g():O.$Bl(y):f(w,y)}e.$Dl=C;let P=null;function f(w,y){if(R.$l&&w===2||R.$k&&w===3)return"/bin/bash";if(!P){let d;if(R.$j)d="/bin/bash";else{if(d=y.SHELL,!d)try{d=(0,S.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}P=d}return P}let a=null;async function g(){return a||(a=(await(0,s.$yl)()).exePath),a}});var Ee=this&&this.__decorate||function(X,e,S,R){var s=arguments.length,O=s<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,S):R,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(X,e,S,R);else for(var P=X.length-1;P>=0;P--)(C=X[P])&&(O=(s<3?C(O):s>3?C(e,S,O):C(e,S))||O);return s>3&&O&&Object.defineProperty(e,S,O),O};define(ie[42],ne([0,1,23,8,17,22,54,14,3,2,76,27,12]),function(X,e,S,R,s,O,C,P,f,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var d;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(d||(d={}));function v(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(m||(m={}));function b(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})($||($={}));function u(G){let q=0;for(let T=0;;T+=7){const K=G.read(1);if(q|=(K.buffer[0]&127)<<T,!(K.buffer[0]&128))return q}}const l=o(0);function E(G,q){if(q===0){G.write(l);return}let T=0;for(let H=q;H!==0;H=H>>>7)T++;const K=s.$be.alloc(T);for(let H=0;q!==0;H++)K.buffer[H]=q&127,q=q>>>7,q>0&&(K.buffer[H]|=128);G.write(K)}class h{constructor(q){this.b=q,this.a=0}read(q){const T=this.b.slice(this.a,this.a+q);return this.a+=T.byteLength,T}}e.$nh=h;class i{constructor(){this.a=[]}get buffer(){return s.$be.concat(this.a)}write(q){this.a.push(q)}}e.$oh=i;var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(c||(c={}));function o(G){const q=s.$be.alloc(1);return q.writeUInt8(G,0),q}const t={Undefined:o(c.Undefined),String:o(c.String),Buffer:o(c.Buffer),VSBuffer:o(c.VSBuffer),Array:o(c.Array),Object:o(c.Object),Uint:o(c.Int)},n=typeof Buffer<"u";function r(G,q){if(typeof q>"u")G.write(t.Undefined);else if(typeof q=="string"){const T=s.$be.fromString(q);G.write(t.String),E(G,T.byteLength),G.write(T)}else if(n&&Buffer.isBuffer(q)){const T=s.$be.wrap(q);G.write(t.Buffer),E(G,T.byteLength),G.write(T)}else if(q instanceof s.$be)G.write(t.VSBuffer),E(G,q.byteLength),G.write(q);else if(Array.isArray(q)){G.write(t.Array),E(G,q.length);for(const T of q)r(G,T)}else if(typeof q=="number"&&(q|0)===q)G.write(t.Uint),E(G,q);else{const T=s.$be.fromString(JSON.stringify(q));G.write(t.Object),E(G,T.byteLength),G.write(T)}}e.$ph=r;function p(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(u(G)).toString();case c.Buffer:return G.read(u(G)).buffer;case c.VSBuffer:return G.read(u(G));case c.Array:{const T=u(G),K=[];for(let H=0;H<T;H++)K.push(p(G));return K}case c.Object:return JSON.parse(G.read(u(G)).toString());case c.Int:return u(G)}}e.$qh=p;class A{constructor(q,T,K=null,H=1e3){this.h=q,this.j=T,this.k=K,this.l=H,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(q,T){this.b.set(q,T),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const T=this.o([q.type]);this.k?.logOutgoing(T,0,1,b(q.type));return}case 201:case 202:case 204:case 203:{const T=this.o([q.type,q.id],q.data);this.k?.logOutgoing(T,q.id,1,b(q.type),q.data);return}}}o(q,T=void 0){const K=new i;return r(K,q),r(K,T),this.p(K.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const T=new h(q),K=p(T),H=p(T),x=K[0];switch(x){case 100:return this.k?.logIncoming(q.byteLength,K[1],1,`${v(x)}: ${K[2]}.${K[3]}`,H),this.s({type:x,id:K[1],channelName:K[2],name:K[3],arg:H});case 102:return this.k?.logIncoming(q.byteLength,K[1],1,`${v(x)}: ${K[2]}.${K[3]}`,H),this.t({type:x,id:K[1],channelName:K[2],name:K[3],arg:H});case 101:return this.k?.logIncoming(q.byteLength,K[1],1,`${v(x)}`),this.u({type:x,id:K[1]});case 103:return this.k?.logIncoming(q.byteLength,K[1],1,`${v(x)}`),this.u({type:x,id:K[1]})}}s(q){const T=this.b.get(q.channelName);if(!T){this.v(q);return}const K=new O.$Xd;let H;try{H=T.call(this.j,q.name,q.arg,K.token)}catch(F){H=Promise.reject(F)}const x=q.id;H.then(F=>{this.m({id:x,data:F,type:201})},F=>{F instanceof Error?this.m({id:x,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:x,data:F,type:203})}).finally(()=>{B.dispose(),this.d.delete(q.id)});const B=(0,a.$Qc)(()=>K.cancel());this.d.set(q.id,B)}t(q){const T=this.b.get(q.channelName);if(!T){this.v(q);return}const K=q.id,x=T.listen(this.j,q.name,q.arg)(B=>this.m({id:K,data:B,type:204}));this.d.set(q.id,x)}u(q){const T=this.d.get(q.id);T&&(T.dispose(),this.d.delete(q.id))}v(q){let T=this.g.get(q.channelName);T||(T=[],this.g.set(q.channelName,T));const K=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:q,timeoutTimer:K})}w(q){const T=this.g.get(q);if(T){for(const K of T)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Nc)(this.d.values()),this.d.clear()}}e.$rh=A;var D;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class k{constructor(q,T=null){this.l=q,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=T}getChannel(q){const T=this;return{call(K,H,x){return T.a?Promise.reject(new P.$5):T.m(q,K,H,x)},listen(K,H){return T.a?f.Event.None:T.o(q,K,H)}}}m(q,T,K,H=O.CancellationToken.None){const x=this.g++,F={id:x,type:100,channelName:q,name:T,arg:K};if(H.isCancellationRequested)return Promise.reject(new P.$5);let M;return new Promise((W,L)=>{if(H.isCancellationRequested)return L(new P.$5);const V=()=>{const de=fe=>{switch(fe.type){case 201:this.f.delete(x),W(fe.data);break;case 202:{this.f.delete(x);const ve=new Error(fe.data.message);ve.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ve.name=fe.data.name,L(ve);break}case 203:this.f.delete(x),L(fe.data);break}};this.f.set(x,de),this.p(F)};let J=null;this.b===$.Idle?V():(J=(0,R.$Hg)(de=>this.u()),J.then(()=>{J=null,V()}));const oe=()=>{J?(J.cancel(),J=null):this.p({id:x,type:101}),L(new P.$5)},le=H.onCancellationRequested(oe);M=(0,a.$Pc)((0,a.$Qc)(oe),le),this.d.add(M)}).finally(()=>{M.dispose(),this.d.delete(M)})}o(q,T,K){const H=this.g++,B={id:H,type:102,channelName:q,name:T,arg:K};let F=null;const M=new f.$Nd({onWillAddFirstListener:()=>{F=(0,R.$Hg)(W=>this.u()),F.then(()=>{F=null,this.d.add(M),this.p(B)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(M),this.p({id:H,type:103}))}}),U=W=>M.fire(W.data);return this.f.set(H,U),M.event}p(q){switch(q.type){case 100:case 102:{const T=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(T,q.id,0,`${v(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const T=this.q([q.type,q.id]);this.j?.logOutgoing(T,q.id,0,v(q.type));return}}}q(q,T=void 0){const K=new i;return r(K,q),r(K,T),this.r(K.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const T=new h(q),K=p(T),H=p(T),x=K[0];switch(x){case 200:return this.j?.logIncoming(q.byteLength,0,0,b(x)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,K[1],0,b(x),H),this.t({type:K[0],id:K[1],data:H})}}t(q){if(q.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Nc)(this.d.values()),this.d.clear()}}e.$sh=k,Ee([C.$hh],k.prototype,"onDidInitializePromise",null);class I{get connections(){const q=[];return this.f.forEach(T=>q.push(T)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new f.$Nd,this.onDidAddConnection=this.g.event,this.h=new f.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new a.$Rc,this.j.add(q(({protocol:T,onDidClientDisconnect:K})=>{const H=f.Event.once(T.onMessage);this.j.add(H(x=>{const B=new h(x),F=p(B),M=new A(T,F),U=new k(T);this.a.forEach((L,V)=>M.registerChannel(V,L));const W={channelServer:M,channelClient:U,ctx:F};this.f.add(W),this.g.fire(W),this.j.add(K(()=>{M.dispose(),U.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(q,T){const K=this;return{call(H,x,B){let F;if((0,y.$Mf)(T)){const U=(0,S.$4b)(K.connections.filter(T));F=U?Promise.resolve(U):f.Event.toPromise(f.Event.filter(K.onDidAddConnection,T))}else F=T.routeCall(K,H,x);const M=F.then(U=>U.channelClient.getChannel(q));return N(M).call(H,x,B)},listen(H,x){if((0,y.$Mf)(T))return K.k(q,T,H,x);const B=T.routeEvent(K,H,x).then(F=>F.channelClient.getChannel(q));return N(B).listen(H,x)}}}k(q,T,K,H){const x=this;let B;const F=new f.$Nd({onWillAddFirstListener:()=>{B=new a.$Rc;const M=new f.$Td,U=new Map,W=V=>{const oe=V.channelClient.getChannel(q).listen(K,H),le=M.add(oe);U.set(V,le)},L=V=>{const J=U.get(V);J&&(J.dispose(),U.delete(V))};x.connections.filter(T).forEach(W),f.Event.filter(x.onDidAddConnection,T)(W,void 0,B),x.onDidRemoveConnection(L,void 0,B),M.event(F.fire,F,B),B.add(M)},onDidRemoveLastListener:()=>{B?.dispose(),B=void 0}});return F.event}registerChannel(q,T){this.a.set(q,T);for(const K of this.f)K.channelServer.registerChannel(q,T)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=I;class j{constructor(q,T,K=null){const H=new i;r(H,T),q.send(H.buffer),this.a=new k(q,K),this.d=new A(q,T,K)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,T){this.d.registerChannel(q,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=j;function N(G){return{call(q,T,K){return G.then(H=>H.call(q,T,K))},listen(q,T){const K=new f.$Wd;return G.then(H=>K.input=H.listen(q,T)),K.event}}}e.$vh=N;function z(G){let q=!1;return{call(T,K,H){return q?G.call(T,K,H):(0,R.$Ug)(0).then(()=>q=!0).then(()=>G.call(T,K,H))},listen(T,K){if(q)return G.listen(T,K);const H=new f.$Wd;return(0,R.$Ug)(0).then(()=>q=!0).then(()=>H.input=G.listen(T,K)),H.event}}}e.$wh=z;class _{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const T of q.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await f.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$xh=_;var Y;(function(G){function q(x,B,F){const M=x,U=F&&F.disableMarshalling,W=new Map;for(const L in M)K(L)&&W.set(L,f.Event.buffer(M[L],!0,void 0,B));return new class{listen(L,V,J){const oe=W.get(V);if(oe)return oe;if(H(V)){const le=M[V];if(typeof le=="function")return le.call(M,J)}throw new P.$bb(`Event not found: ${V}`)}call(L,V,J){const oe=M[V];if(typeof oe=="function"){if(!U&&Array.isArray(J))for(let de=0;de<J.length;de++)J[de]=(0,g.$mh)(J[de]);let le=oe.apply(M,J);return le instanceof Promise||(le=Promise.resolve(le)),le}throw new P.$bb(`Method not found: ${V}`)}}}G.fromService=q;function T(x,B){const F=B&&B.disableMarshalling;return new Proxy({},{get(M,U){if(typeof U=="string")return B?.properties?.has(U)?B.properties.get(U):H(U)?function(W){return x.listen(U,W)}:K(U)?x.listen(U):async function(...W){let L;B&&!(0,y.$Hf)(B.context)?L=[B.context,...W]:L=W;const V=await x.call(U,L);return F?V:(0,g.$mh)(V)};throw new P.$bb(`Property not found: ${String(U)}`)}})}G.toService=T;function K(x){return x[0]==="o"&&x[1]==="n"&&w.$1e(x.charCodeAt(2))}function H(x){return/^onDynamic/.test(x)&&w.$1e(x.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const q=G.toString();if(q!=="[object Object]")return q}return G}function ae(G){return Array.isArray(G)?G.map(re):re(G)}function Z(G,q,T,K,H,x,B){B=ae(B);const F=ce[H],M=F[K%F.length];let U=[`%c[${G}]%c[${String(q).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(x)?(U=U.concat(B),U.push(")")):U.push(B),console.log.apply(console,U)}class Q{constructor(q,T){this.d=q,this.f=T,this.a=0,this.b=0}logOutgoing(q,T,K,H,x){this.b+=q,Z(this.d,this.b,q,T,K,H,x)}logIncoming(q,T,K,H,x){this.a+=q,Z(this.f,this.a,q,T,K,H,x)}}e.$yh=Q}),define(ie[157],ne([0,1,17,3,42]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nT=e.$mT=void 0;class O{constructor(f){this.a=f,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",a=>S.$be.wrap(a.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$mT=O;class C extends s.$uh{constructor(f,a){const g=new O(f);super(g,a),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$nT=C}),define(ie[109],ne([0,1,17,3,2,42]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.ProtocolConstants=e.$zh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var P;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let r=0;function p(D,k){if(!n.has(D)){const I=String(++r);n.set(D,I)}return n.get(D)}function A(D,k,I,j){if(!t.enableDiagnostics)return;const N=p(D,k);if(j instanceof S.$be||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const z=S.$be.alloc(j.byteLength);z.set(j),t.records.push({timestamp:Date.now(),id:N,label:k,type:I,buff:z})}else t.records.push({timestamp:Date.now(),id:N,label:k,type:I,data:j})}t.traceSocketEvent=A})(P||(e.SocketDiagnostics=P={}));var f;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let a=null;function g(){return a||(a=S.$be.alloc(0)),a}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,r){if(n===0)return g();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return r&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return r&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const p=S.$be.alloc(n);let A=0,D=0;for(;n>0;){const k=this.a[D];if(k.byteLength>n){const I=k.slice(0,n);p.set(I,A),A+=n,r&&(this.a[D]=k.slice(n),this.b-=n),n-=n}else p.set(k,A),A+=k.byteLength,r?(this.a.shift(),this.b-=k.byteLength):D++,n-=k.byteLength}return p}}e.$zh=w;var y;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(y||(y={}));function d(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class m{constructor(n,r,p,A){this.type=n,this.id=r,this.ack=p,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends s.$Sc{constructor(n){super(),this.f=this.B(new R.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new w,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,A=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new m(p,A,D,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=S.$be.alloc(13);r.writeUInt8(n.type,0),r.writeUInt32BE(n.id,1),r.writeUInt32BE(n.ack,5),r.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(r,n.data)}g(n,r){const p=this.f===0;return this.d.push(n,r),this.f+=n.byteLength+r.byteLength,p}h(){const n=S.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,r){this.g(n,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class u extends s.$Sc{constructor(n){super(),this.f=new R.$Nd,this.onMessage=this.f.event,this.g=new R.$Nd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new $(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$Ah=u;class l extends O.$uh{static fromSocket(n,r){return new l(new u(n),r)}get onDidDispose(){return this.b.onDidDispose}constructor(n,r,p=null){super(n,r,p),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Bh=l;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Ch=E;class h{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,r=this.a;for(;r;)r=r.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let r=0,p=this.a;for(;p;)n[r++]=p.data,p=p.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const r=new h(n);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class c{static{this.a=10}static{this.b=null}static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const n=Date.now();for(let r=0;r<c.a;r++)this.c[r]=n-1e3*r;setInterval(()=>{for(let r=c.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),r=(1+c.a)*1e3;let p=0;for(let A=0;A<c.a;A++)n-this.c[A]<=r&&p++;return 1-p/c.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??c.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Rc,this.o=n.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,g());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,g());this.p.write(n)}sendResume(){const n=new m(8,0,0,g());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,r){this.a=!0,this.r.dispose(),this.r=new s.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,g());this.p.write(n);const r=this.b.toArray();for(let p=0,A=r.length;p<A;p++)this.p.write(r[p]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const r=this.b.peek();if(r&&r.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new m(6,0,0,g())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let p=0,A=r.length;p<A;p++)this.p.write(r[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const r=++this.c;this.h=this.g;const p=new m(1,r,this.h,n);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(n){const r=new m(2,0,0,n);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),r=Date.now()-n.writtenTime,p=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(r>=2e4&&p>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:p});return}const D=Math.max(2e4-r,2e4-p,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,g());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,g());this.p.write(n)}}e.$Dh=o}),define(ie[38],ne([0,1,15,14,13]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jT=void 0;class O{constructor(){this.a=new WeakMap}on(P,f){const a=(g,...w)=>{this.b(P,g)&&f(g,...w)};return this.a.set(f,a),S.ipcMain.on(P,a),this}once(P,f){return S.ipcMain.once(P,(a,...g)=>{this.b(P,a)&&f(a,...g)}),this}handle(P,f){return S.ipcMain.handle(P,(a,...g)=>this.b(P,a)?f(a,...g):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,f){const a=this.a.get(f);return a&&(S.ipcMain.removeListener(P,a),this.a.delete(f)),this}b(P,f){if(!P||!P.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const a=f.senderFrame,g=a.url;if(!g||g==="about:blank")return!0;let w="unknown";try{w=new URL(g).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${g}'.`),!1}return w!==s.$bg?((0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${w}'.`),!1):a.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${w}' is not a main frame.`),!1):!0}}e.$jT=new O}),define(ie[158],ne([0,1,15,38,146]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kT=void 0;function O(){R.$jT.on(s.$hT,(P,f,a,g,w)=>{const y=C(P,g,a);y.popup({x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{y&&P.sender.send(s.$iT,f)}})})}e.$kT=O;function C(P,f,a){const g=new S.Menu;return a.forEach(w=>{let y;w.type==="separator"?y=new S.MenuItem({type:w.type}):Array.isArray(w.submenu)?y=new S.MenuItem({submenu:C(P,f,w.submenu),label:w.label}):y=new S.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(d,v,m)=>P.sender.send(f,w.id,m)}),g.append(y)}),g}}),define(ie[159],ne([0,1,38,17,3,2,42,147]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qT=void 0;function f(g,w){const y=s.Event.fromNodeEventEmitter(S.$jT,w,(v,m)=>({event:v,message:m})),d=s.Event.filter(y,({event:v})=>v.sender.id===g);return s.Event.map(d,({message:v})=>v&&R.$be.wrap(v))}class a extends C.$th{static{this.b=new Map}static d(){const w=s.Event.fromNodeEventEmitter(S.$jT,"vscode:hello",({sender:y})=>y);return s.Event.map(w,y=>{const d=y.id;a.b.get(d)?.dispose();const m=new s.$Nd;a.b.set(d,(0,O.$Qc)(()=>m.fire()));const b=f(d,"vscode:message"),$=s.Event.any(s.Event.signal(f(d,"vscode:disconnect")),m.event);return{protocol:new P.$pT(y,b),onDidClientDisconnect:$}})}constructor(){super(a.d())}}e.$qT=a}),define(ie[110],ne([0,1,38,3,32,157]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sT=e.$rT=void 0;class C extends O.$nT{constructor(a,g){super({addEventListener:(w,y)=>a.addListener(w,y),removeEventListener:(w,y)=>a.removeListener(w,y),postMessage:w=>a.postMessage(w),start:()=>a.start(),close:()=>a.close()},g)}}e.$rT=C;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,s.$eg)();f.webContents.send("vscode:createMessageChannel",a);const g=R.Event.fromNodeEventEmitter(S.$jT,"vscode:createMessageChannelResult",(y,d)=>({nonce:d,port:y.ports[0]})),{port:w}=await R.Event.toPromise(R.Event.once(R.Event.filter(g,y=>y.nonce===a)));return w}e.$sT=P}),define(ie[160],ne([0,1,47,8,17,22,154,14,3,2,37,88,75,42]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;class v extends d.$rh{constructor($){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>s.$be.wrap(Buffer.from(u,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$3p=v;class m{constructor($,u){this.i=$,this.j=u,this.c=new Set,this.g=new Map,this.h=new f.$Nd,this.onDidProcessExit=this.h.event;const l=u&&u.timeout?u.timeout:6e4;this.b=new R.$Qg(l),this.d=null,this.f=null}getChannel($){const u=this;return{call(l,E,h){return u.k($,l,E,h)},listen(l,E){return u.l($,l,E)}}}k($,u,l,E=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const h=this.n($),i=(0,R.$Hg)(t=>h.call(u,l,t)),c=E.onCancellationRequested(()=>i.cancel()),o=(0,a.$Qc)(()=>i.cancel());return this.c.add(o),i.finally(()=>{c.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l($,u,l){if(!this.b)return f.Event.None;this.b.cancel();let E;const h=new f.$Nd({onWillAddFirstListener:()=>{E=this.n($).listen(u,l)(h.fire,h),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,g.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$Al)(u.env),this.d=(0,S.fork)(this.i,$,u);const l=new f.$Nd;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,C.$Yp)(n)){(0,C.log)(n,`IPC Library: ${this.j.serverName}`);return}l.fire(s.$be.wrap(Buffer.from(n,"base64")))});const h=this.j.useQueue?(0,w.$Cl)(this.d):this.d,i=n=>this.d&&this.d.connected&&h.send(n.buffer.toString("base64")),c=l.event,o={send:i,onMessage:c};this.f=new d.$sh(o);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",t),this.c.forEach(p=>(0,a.$Nc)(p)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n($){let u=this.g.get($);return u||(u=this.m.getChannel($),this.g.set($,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$4p=m}),define(ie[111],ne([0,1,8,3,2,76,12]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.StorageState=e.$2o=e.StorageHint=void 0;var P;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function f(y){const d=y;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$2o=f;var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class g extends s.$Sc{static{this.a=100}constructor(d,v=Object.create(null)){super(),this.r=d,this.s=v,this.b=this.B(new R.$Qd),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Rg(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((v,m)=>this.w(m,v)),d.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(d,v){if(this.c===a.Closed)return;let m=!1;(0,C.$Hf)(v)?m=this.f.delete(d):this.f.get(d)!==v&&(this.f.set(d,v),m=!0),m&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,v){const m=this.f.get(d);return(0,C.$Hf)(m)?v:m}getBoolean(d,v){const m=this.get(d);return(0,C.$Hf)(m)?v:m==="true"}getNumber(d,v){const m=this.get(d);return(0,C.$Hf)(m)?v:parseInt(m,10)}getObject(d,v){const m=this.get(d);return(0,C.$Hf)(m)?v:(0,O.$lh)(m)}async set(d,v,m=!1){if(this.c===a.Closed)return;if((0,C.$Hf)(v))return this.delete(d,m);const b=(0,C.$Af)(v)||Array.isArray(v)?(0,O.$kh)(v):String(v);if(this.f.get(d)!==b)return this.f.set(d,b),this.j.set(d,b),this.h.delete(d),this.b.fire({key:d,external:m}),this.D()}async delete(d,v=!1){if(!(this.c===a.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:v}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$3o=g;class w{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((v,m)=>this.a.set(m,v)),d.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$4o=w}),define(ie[161],ne([0,1,8,3,31,9,21]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OT=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(g,w=Object.create(null)){this.g=g,this.h=w,this.c=(0,O.$nc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const g=await this.f,w=new Map;return(await this.s(g,"SELECT * FROM ItemTable")).forEach(d=>w.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${w.size} rows`),w}async updateItems(g){const w=await this.f;return this.j(w,g)}j(g,w){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${w.insert?(0,s.$yc)(w.insert):"0"}), delete(${w.delete?(0,s.$zc)(w.delete):"0"})`),this.t(g,()=>{const y=w.insert,d=w.delete;if(y&&y.size>0){const v=[];v.push([]);let m=0;y.forEach((b,$)=>{let u=v[m];u.length>P.b&&(m++,u=[],v.push(u)),u.push($,b)}),v.forEach(b=>{this.u(g,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,$=>$.run(b),()=>{const $=[];let u=0;return y.forEach((l,E)=>{$.push(E),u+=l.length}),`Keys: ${$.join(", ")} Length: ${u}`})})}if(d&&d.size){const v=[];v.push([]);let m=0;d.forEach(b=>{let $=v[m];$.length>P.b&&(m++,$=[],v.push($)),$.push(b)}),v.forEach(b=>{this.u(g,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,$=>$.run(b),()=>{const $=[];return d.forEach(u=>{$.push(u)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const g=await this.f;return this.q(g,"VACUUM")}async close(g){this.d.trace(`[storage ${this.c}] close()`);const w=await this.f;return this.k(w,g)}k(g,w){return new Promise((y,d)=>{g.db.close(v=>(v&&this.o(g,`[storage ${this.c}] close(): ${v}`),this.g===P.IN_MEMORY_PATH?y():!g.isErroneous&&!g.isInMemory?this.l().then(y,m=>(this.d.error(`[storage ${this.c}] backup(): ${m}`),y())):typeof w=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(m=>{const b=()=>this.k(m,void 0);return this.j(m,{insert:w()}).then(()=>b(),$=>(b(),Promise.reject($)))})).then(y,d):d(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const g=this.m(this.g);return C.Promises.copy(this.g,g,{preserveSymlinks:!1})}m(g){return`${g}.backup`}async checkIntegrity(g){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${g})`);const w=await this.f,y=await this.r(w,g?"PRAGMA integrity_check":"PRAGMA quick_check"),d=g?y.integrity_check:y.quick_check;return w.isErroneous?`${d} (last error: ${w.lastError})`:w.isInMemory?`${d} (in-memory!)`:d}async n(g,w=!0){this.d.trace(`[storage ${this.c}] open(${g}, retryOnBusy: ${w})`);try{return await this.p(g)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&w)return await(0,S.$Ug)(P.a),this.n(g,!1);try{await C.Promises.unlink(g);try{await C.Promises.rename(this.m(g),g,!1)}catch{}return await this.p(g)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(P.IN_MEMORY_PATH)}}}o(g,w){g.isErroneous=!0,g.lastError=w,this.d.error(w)}p(g){return new Promise((w,y)=>{new Promise((d,v)=>{X(["@vscode/sqlite3"],d,v)}).then(d=>{const v={db:new(this.d.isTracing?d.verbose().Database:d.Database)(g,m=>m?v.db&&m.code!=="SQLITE_CANTOPEN"?v.db.close(()=>y(m)):y(m):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>w(v),b=>v.db.close(()=>y(b)))),isInMemory:g===P.IN_MEMORY_PATH};v.db.on("error",m=>this.o(v,`[storage ${this.c}] Error (event): ${m}`)),this.d.isTracing&&v.db.on("trace",m=>this.d.trace(`[storage ${this.c}] Trace (event): ${m}`))},y)})}q(g,w){return new Promise((y,d)=>{g.db.exec(w,v=>v?(this.o(g,`[storage ${this.c}] exec(): ${v}`),d(v)):y())})}r(g,w){return new Promise((y,d)=>{g.db.get(w,(v,m)=>v?(this.o(g,`[storage ${this.c}] get(): ${v}`),d(v)):y(m))})}s(g,w){return new Promise((y,d)=>{g.db.all(w,(v,m)=>v?(this.o(g,`[storage ${this.c}] all(): ${v}`),d(v)):y(m))})}t(g,w){return new Promise((y,d)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),w(),g.db.run("END TRANSACTION",v=>v?(this.o(g,`[storage ${this.c}] transaction(): ${v}`),d(v)):y())})})}u(g,w,y,d){const v=g.db.prepare(w),m=b=>{this.o(g,`[storage ${this.c}] prepare(): ${b} (${w}). Details: ${d()}`)};v.on("error",m),y(v),v.finalize(b=>{b&&m(b),v.removeListener("error",m)})}}e.$OT=P;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[f.a]&&(this.b=g.logTrace),g&&typeof g.logError=="function"&&(this.c=g.logError)}get isTracing(){return!!this.b}trace(g){this.b?.(g)}error(g){this.c?.(g)}}}),define(ie[162],ne([11,10]),function(X,e){return X.create("vs/code/electron-main/app",e)}),define(ie[163],ne([11,10]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[164],ne([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[165],ne([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(ie[166],ne([11,10]),function(X,e){return X.create("vs/platform/dialogs/common/dialogs",e)}),define(ie[167],ne([11,10]),function(X,e){return X.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ie[168],ne([11,10]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(ie[169],ne([11,10]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(ie[170],ne([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[171],ne([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[172],ne([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[173],ne([11,10]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[174],ne([11,10]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ie[175],ne([11,10]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ie[176],ne([11,10]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ie[177],ne([11,10]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ie[178],ne([11,10]),function(X,e){return X.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ie[179],ne([11,10]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[180],ne([11,10]),function(X,e){return X.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ie[181],ne([11,10]),function(X,e){return X.create("vs/platform/menubar/electron-main/menubar",e)}),define(ie[182],ne([11,10]),function(X,e){return X.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ie[183],ne([11,10]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ie[184],ne([11,10]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ie[185],ne([11,10]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[186],ne([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ie[187],ne([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ie[188],ne([11,10]),function(X,e){return X.create("vs/platform/update/common/update.config.contribution",e)}),define(ie[189],ne([11,10]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[190],ne([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ie[191],ne([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ie[192],ne([11,10]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ie[193],ne([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ie[194],ne([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ie[195],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FU=e.$EU=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$EU=S;function R(s){return s&&s.hasOwnProperty("workspace")}e.$FU=R}),define(ie[196],ne([0,1,7]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=e.$t6b=e.$s6b=void 0;function R(C){return typeof C?.backupFolder=="string"}e.$s6b=R;function s(C){let P=[];try{Array.isArray(C.workspaces)&&(P=C.workspaces.map(f=>({workspace:{id:f.id,configPath:S.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$t6b=s;function O(C){let P=[];try{Array.isArray(C.folders)&&(P=C.folders.map(f=>({folderUri:S.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$u6b=O}),define(ie[197],ne([0,1,14,165]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var s;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(s||(e.TokenType=s={}));function O(...a){switch(a.length){case 1:return(0,R.localize)(0,null,a[0]);case 2:return(0,R.localize)(1,null,a[0],a[1]);case 3:return(0,R.localize)(2,null,a[0],a[1],a[2]);default:return}}const C=(0,R.localize)(3,null),P=(0,R.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const w=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:w})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const w=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:w})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const w=this.d,y=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:y};this.g.push({offset:w,lexeme:y,additionalInfo:g}),this.f.push(d)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const w=this.c.substring(this.d,this.e),y=f.b.get(w);y?this.k(y):this.f.push({type:17,lexeme:w,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,w=!1,y=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(P);return}const v=this.c.charCodeAt(g);if(w)w=!1;else if(v===47&&!y){g++;break}else v===91?y=!0:v===92?w=!0:v===93&&(y=!1);g++}for(;g<this.c.length&&f.a.has(this.c.charCodeAt(g));)g++;this.e=g;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=f}),define(ie[198],ne([0,1,3,2]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0;class s{constructor(){this.a=new S.$Nd,this.b=new S.$Nd,this.c=new S.$Nd,this.d=new S.$Nd}static{this.ChannelName="extensionhostdebugservice"}call(P,f,a){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(P,f,a){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Mn=s;class O extends R.$Sc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,f,a){this.b.call("attach",[P,f,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,f){this.b.call("terminate",[P,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.b.call("openExtensionDevelopmentHostWindow",[P,f])}}e.$Nn=O}),define(ie[199],ne([0,1,149,54,13,9,35,19,7]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,O.$mc)(s.$cg.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,O.$jc)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,P.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,S.$em)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$jc)(this.userDataPath,"logs",d)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$vg)(f.URI.file((0,O.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=C.env.VSCODE_PORTABLE;return d?f.URI.file((0,O.$jc)(d,"argv.json")):(0,P.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,O.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,O.$kc)(d):(0,O.$hc)((0,O.$jc)(s.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?f.URI.file((0,O.$kc)(d)):f.URI.file((0,O.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,O.$kc)(d);const v=C.env.VSCODE_EXTENSIONS;if(v)return v;const m=C.env.VSCODE_PORTABLE;return m?(0,O.$jc)(m,"extensions"):(0,P.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(v=>/^[^:/?#]+?:\/\//.test(v)?f.URI.parse(v):f.URI.file((0,O.$hc)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,O.$hc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$fm.test(d))}get extensionLogLevel(){const d=[];for(const v of this.args.log||[]){const m=e.$fm.exec(v);m&&m[1]&&m[2]&&d.push([m[1],m[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,P.$vg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=C.env.VSCODE_PORTABLE;return d?f.URI.file((0,O.$jc)(d,"policy.json")):(0,P.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,v,m){this.a=d,this.b=v,this.c=m,this.editSessionId=this.args.editSessionId}}e.$gm=a,Ee([R.$hh],a.prototype,"appRoot",null),Ee([R.$hh],a.prototype,"userHome",null),Ee([R.$hh],a.prototype,"userDataPath",null),Ee([R.$hh],a.prototype,"appSettingsHome",null),Ee([R.$hh],a.prototype,"tmpDir",null),Ee([R.$hh],a.prototype,"cacheHome",null),Ee([R.$hh],a.prototype,"stateResource",null),Ee([R.$hh],a.prototype,"userRoamingDataHome",null),Ee([R.$hh],a.prototype,"userDataSyncHome",null),Ee([R.$hh],a.prototype,"sync",null),Ee([R.$hh],a.prototype,"machineSettingsResource",null),Ee([R.$hh],a.prototype,"workspaceStorageHome",null),Ee([R.$hh],a.prototype,"localHistoryHome",null),Ee([R.$hh],a.prototype,"keyboardLayoutResource",null),Ee([R.$hh],a.prototype,"argvResource",null),Ee([R.$hh],a.prototype,"isExtensionDevelopment",null),Ee([R.$hh],a.prototype,"untitledWorkspacesHome",null),Ee([R.$hh],a.prototype,"builtinExtensionsPath",null),Ee([R.$hh],a.prototype,"extensionsPath",null),Ee([R.$hh],a.prototype,"extensionDevelopmentLocationURI",null),Ee([R.$hh],a.prototype,"extensionDevelopmentKind",null),Ee([R.$hh],a.prototype,"extensionTestsLocationURI",null),Ee([R.$hh],a.prototype,"debugExtensionHost",null),Ee([R.$hh],a.prototype,"logLevel",null),Ee([R.$hh],a.prototype,"extensionLogLevel",null),Ee([R.$hh],a.prototype,"serviceMachineIdResource",null),Ee([R.$hh],a.prototype,"disableTelemetry",null),Ee([R.$hh],a.prototype,"disableWorkspaceTrust",null),Ee([R.$hh],a.prototype,"useInMemorySecretStorage",null),Ee([R.$hh],a.prototype,"policyFile",null);function g(y,d){return w(y["inspect-extensions"],y["inspect-brk-extensions"],5870,d,y.debugId,y.extensionEnvironment)}e.$hm=g;function w(y,d,v,m,b,$){const l=Number(d||y)||(m?null:v),E=l?!!d:!1;let h;if($)try{h=JSON.parse($)}catch{}return{port:l,break:E,debugId:b,env:h}}e.$im=w}),define(ie[112],ne([0,1,309,4,168]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=void 0;const O={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$El=["tunnel","serve-web"],e.$Fl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,b,$=C){const u=m.find(r=>r.length>0&&r[0]!=="-"),l={},E=["_"],h=[],i={};let c;for(const r in b){const p=b[r];p.type==="subcommand"?r===u&&(c=p):(p.alias&&(l[r]=p.alias),p.type==="string"||p.type==="string[]"?(E.push(r),p.deprecates&&E.push(...p.deprecates)):p.type==="boolean"&&(h.push(r),p.deprecates&&h.push(...p.deprecates)),p.global&&(i[r]=p))}if(c&&u){const r=i;for(const k in c.options)r[k]=c.options[k];const p=m.filter(k=>k!==u),A=$.getSubcommandReporter?$.getSubcommandReporter(u):void 0,D=P(p,r,A);return{[u]:D,_:[]}}const o=S(m,{string:E,boolean:h,alias:l}),t={},n=o;t._=o._.map(r=>String(r)).filter(r=>r.length>0),delete n._;for(const r in b){const p=b[r];if(p.type==="subcommand")continue;p.alias&&delete n[p.alias];let A=n[r];if(p.deprecates)for(const D of p.deprecates)n.hasOwnProperty(D)&&(A||(A=n[D],A&&$.onDeprecatedOption(D,p.deprecationMessage||(0,s.localize)(37,null,r))),delete n[D]);if(typeof A<"u"){if(p.type==="string[]"){if(Array.isArray(A)||(A=[A]),!p.allowEmptyValue){const D=A.filter(k=>k.length>0);D.length!==A.length&&($.onEmptyValue(r),A=D.length>0?D:void 0)}}else p.type==="string"&&(Array.isArray(A)?(A=A.pop(),$.onMultipleValues(r,A)):!A&&!p.allowEmptyValue&&($.onEmptyValue(r),A=void 0));t[r]=A,p.deprecationMessage&&$.onDeprecatedOption(r,p.deprecationMessage)}delete n[r]}for(const r in n)$.onUnknownOption(r);return t}e.$Gl=P;function f(m,b){let $="";return b.args&&(Array.isArray(b.args)?$=` <${b.args.join("> <")}>`:$=` <${b.args}>`),b.alias?`-${b.alias} --${m}${$}`:`--${m}${$}`}function a(m,b){const $=[];for(const u in m){const l=m[u],E=f(u,l);$.push([E,l.description])}return g($,b)}e.$Hl=a;function g(m,b){const u=m.reduce((h,i)=>Math.max(h,i[0].length),12)+2+1;if(b-u<25)return m.reduce((h,i)=>h.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const l=b-u-1,E=[];for(const h of m){const i=h[0],c=y(h[1],l),o=w(u-i.length-2);E.push("  "+i+o+c[0]);for(let t=1;t<c.length;t++)E.push(w(u)+c[t])}return E}function w(m){return" ".repeat(m)}function y(m,b){const $=[];for(;m.length;){const u=m.length<b?m.length:m.lastIndexOf(" ",b),l=m.slice(0,u).trim();m=m.slice(u),$.push(l)}return $}function d(m,b,$,u,l){const E=process.stdout.isTTY&&process.stdout.columns||80,h=l?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${m} ${$}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${b} [${(0,s.localize)(40,null)}]${h}`),i.push(""),l?.noPipe!==!0&&(R.$j?i.push((0,s.localize)(41,null,b)):i.push((0,s.localize)(42,null,b)),i.push(""));const c={},o=[];for(const t in u){const n=u[t];if(n.type==="subcommand")n.description&&o.push({command:t,description:n.description});else if(n.description&&n.cat){let r=c[n.cat];r||(c[n.cat]=r={}),r[t]=n}}for(const t in c){const n=t,r=c[n];r&&(i.push(O[n]),i.push(...a(r,E)),i.push(""))}return o.length&&(i.push((0,s.localize)(43,null)),i.push(...g(o.map(t=>[t.command,t.description]),E)),i.push("")),i.join(`
`)}e.$Il=d;function v(m,b){return`${m||(0,s.localize)(44,null)}
${b||(0,s.localize)(45,null)}
${process.arch}`}e.$Jl=v}),define(ie[200],ne([0,1,86,198,112]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B6b=void 0;class O extends R.$Mn{constructor(P){super(),this.f=P}call(P,f,a){return f==="openExtensionDevelopmentHostWindow"?this.g(a[0],a[1]):super.call(P,f,a)}async g(P,f){const a=(0,s.$Gl)(P,s.$Fl);a.debugRenderer=f;const g=a.extensionDevelopmentPath;if(!g)return{success:!1};const[w]=await this.f.openExtensionDevelopmentHostWindow(g,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!f)return{success:!0};const y=w.win;if(!y)return{success:!0};const d=y.webContents.debugger;let v=d.isAttached()?1/0:0;const m=(0,S.createServer)(b=>{v++===0&&d.attach();let $=!1;const u=h=>{$||b.write(JSON.stringify(h)+"\0")},l=(h,i,c,o)=>u({method:i,params:c,sessionId:o});y.on("close",()=>{d.removeListener("message",l),b.end(),$=!0}),d.addListener("message",l);let E=Buffer.alloc(0);b.on("data",h=>{E=Buffer.concat([E,h]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let c;try{const o=E.slice(0,i).toString("utf8");E=E.slice(i+1),c=JSON.parse(o)}catch(o){console.error("error reading cdp line",o)}d.sendCommand(c.method,c.params,c.sessionId).then(o=>u({id:c.id,sessionId:c.sessionId,result:o})).catch(o=>u({id:c.id,sessionId:c.sessionId,error:{code:0,message:o.message}}))}}),b.on("error",h=>{console.error("error on cdp pipe:",h)}),b.on("close",()=>{$=!0,--v===0&&d.detach()})});return await new Promise(b=>m.listen(0,b)),y.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.$B6b=O}),define(ie[62],ne([0,1,310,169,112]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Ll=e.$Kl=void 0;function O(w,y){const d=(l,E)=>{console.warn((0,R.localize)(0,null,l,E))},v=l=>{console.warn((0,R.localize)(1,null,l))},m=(l,E)=>{console.warn((0,R.localize)(2,null,l,E))},b=l=>({onUnknownOption:E=>{s.$El.includes(l)||console.warn((0,R.localize)(3,null,E,l))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:m,getSubcommandReporter:s.$El.includes(l)?b:void 0}),$={onUnknownOption:l=>{console.warn((0,R.localize)(4,null,l))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:m,getSubcommandReporter:b},u=(0,s.$Gl)(w,s.$Fl,y?$:void 0);return u.goto&&u._.forEach(l=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,R.localize)(5,null))),u}function C(w){const y=w.findIndex(d=>!/^-/.test(d));if(y>-1)return[...w.slice(0,y),...w.slice(y+1)]}function P(w){let[,...y]=w;process.env.VSCODE_DEV&&(y=C(y)||[]);const d=!g(process.env);return O(y,d)}e.$Kl=P;function f(w){let[,,...y]=w;return process.env.VSCODE_DEV&&(y=C(y)||[]),O(y,!0)}e.$Ll=f;function a(w,...y){const d=w.indexOf("--");return d===-1?w.push(...y):w.splice(d,0,...y),w}e.$Ml=a;function g(w){return w.VSCODE_CLI==="1"}e.$Nl=g}),function(){"use strict";function X(e,S,R){function s(C,P){const f=O(C,P),a=[f];return e.isAbsolute(f)||a.unshift(R),e.resolve(...a)}function O(C,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const g=C["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(w,"AppData","Roaming")}break;case"darwin":a=e.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:s}}if(typeof define=="function")define(ie[201],ne([113,28,35]),function(e,S,R){return X(e,S,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=X(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[89],ne([0,1,28,199,201]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=void 0;class O extends R.$gm{constructor(a,g){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(a,g.nameShort)},g)}}e.$jm=O;function C(f,a){return(0,R.$im)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,a,f.extensionEnvironment)}e.$km=C;function P(f,a){return(0,R.$im)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,a,f.extensionEnvironment)}e.$lm=P}),define(ie[202],ne([0,1,45,28,33]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=void 0;function O(C){const P=(0,s.$6f)((0,R.tmpdir)());try{return(0,S.writeFileSync)(P,""),C&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){C&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$87b=O}),define(ie[203],ne([0,1,12,171]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;function s(C,P,f,a){try{O(C,P,f,a)}catch(g){C.error(g?.message??g)}return P}e.$yp=s;function O(C,P,f,a){const g=(w,y,d)=>{const v=w[y];if((0,S.$yf)(v)){const m=v,b=m.length;if(b>1&&m[0]==="%"&&m[b-1]==="%"){const $=m.substr(1,b-2);let u=f[$];u===void 0&&a&&(u=a[$]);const l=typeof u=="string"?u:u?.message,E=a?.[$],h=typeof E=="string"?E:E?.message;if(!l){h||C.warn(`[${P.name}]: ${(0,R.localize)(0,null,$)}`);return}if(d&&(y==="title"||y==="category")&&h&&h!==l){const i={value:l,original:h};w[y]=i}else w[y]=l}}else if((0,S.$Af)(v))for(const m in v)v.hasOwnProperty(m)&&(m==="commands"?g(v,m,!0):g(v,m,d));else if(Array.isArray(v))for(let m=0;m<v.length;m++)g(v,m,d)};for(const w in P)P.hasOwnProperty(w)&&g(P,w)}}),define(ie[204],ne([0,1,19,73,173,205]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function f($){return $=$.trim(),$==="*"||C.test($)}e.$Mo=f;function a($){if(!f($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=$.match(C);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$No=a;function g($){if(!$)return null;const u=$.majorBase,l=$.majorMustEqual,E=$.minorBase;let h=$.minorMustEqual;const i=$.patchBase;let c=$.patchMustEqual;$.hasCaret&&(u===0||(h=!1),c=!1);let o=0;if($.preRelease){const t=P.exec($.preRelease);if(t){const[,n,r,p]=t;o=Date.UTC(Number(n),Number(r)-1,Number(p))}}return{majorBase:u,majorMustEqual:l,minorBase:E,minorMustEqual:h,patchBase:i,patchMustEqual:c,isMinimum:$.hasGreaterEquals,notBefore:o}}e.$Oo=g;function w($,u,l){let E;typeof $=="string"?E=g(a($)):E=$;let h;u instanceof Date?h=u.getTime():typeof u=="string"&&(h=new Date(u).getTime());let i;if(typeof l=="string"?i=g(a(l)):i=l,!E||!i)return!1;const c=E.majorBase,o=E.minorBase,t=E.patchBase;let n=i.majorBase,r=i.minorBase,p=i.patchBase;const A=i.notBefore;let D=i.majorMustEqual,k=i.minorMustEqual,I=i.patchMustEqual;return i.isMinimum?c>n?!0:c<n?!1:o>r?!0:o<r||h&&h<A?!1:t>=p:(c===1&&n===0&&(!D||!k||!I)&&(n=1,r=0,p=0,D=!0,k=!1,I=!1),c<n?!1:c>n?!D:o<r?!1:o>r?!k:t<p?!1:t>p?!I:!(h&&h<A))}e.$Po=w;function y($,u,l,E,h){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([R.default.Error,s.localize(0,null)]),i;if(typeof E.name!="string")return i.push([R.default.Error,s.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([R.default.Error,s.localize(2,null,"version")]),i;if(!E.engines)return i.push([R.default.Error,s.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([R.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!b(E.extensionDependencies))return i.push([R.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!b(E.activationEvents))return i.push([R.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([R.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([R.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([R.default.Error,s.localize(9,null,"main")]),i;{const t=(0,S.$vg)(l,E.main);(0,S.$pg)(t,l)||i.push([R.default.Warning,s.localize(10,null,t.path,l.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([R.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,S.$vg)(l,E.browser);(0,S.$pg)(t,l)||i.push([R.default.Warning,s.localize(12,null,t.path,l.path)])}}if(!O.valid(E.version))return i.push([R.default.Error,s.localize(13,null)]),i;const c=[];if(!d($,u,E,h,c))for(const t of c)i.push([R.default.Error,t]);return i}e.$Qo=y;function d($,u,l,E,h){return E||typeof l.main>"u"&&typeof l.browser>"u"?!0:m($,u,l.engines.vscode,h)}e.$Ro=d;function v($,u,l){return $==="*"||m(u,l,$)}e.$So=v;function m($,u,l,E=[]){const h=g(a(l));if(!h)return E.push(s.localize(14,null,l)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return E.push(s.localize(15,null,l)),!1}else if(!h.majorMustEqual)return E.push(s.localize(16,null,l)),!1;return w($,u,h)?!0:(E.push(s.localize(17,null,$,l)),!1)}function b($){if(!Array.isArray($))return!1;for(let u=0,l=$.length;u<l;u++)if(typeof $[u]!="string")return!1;return!0}}),define(ie[206],ne([0,1,17,32]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;async function s(O,C,P){let f=P&&P.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const g=(await C.readFile(O.serviceMachineIdResource)).value.toString();f=(0,R.$dg)(g)?g:null}catch{f=null}if(!f){f=(0,R.$eg)();try{await C.writeFile(O.serviceMachineIdResource,S.$be.fromString(f))}catch{}}return P?.store("storage.serviceMachineId",f,-1,1),f}e.$ap=s}),define(ie[77],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class S{constructor(s,O=[],C=!1){this.ctor=s,this.staticArguments=O,this.supportsDelayedInstantiation=C}}e.$Mh=S}),define(ie[207],ne([0,1,77]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.InstantiationType=void 0;const R=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function O(P,f,a){f instanceof S.$Mh||(f=new S.$Mh(f,[],!!a)),R.push([P,f])}e.$xr=O;function C(){return R}e.$yr=C}),define(ie[208],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class S{constructor(O,C){this.key=O,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$cq=S;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const C of this.a.values())C.outgoing.size===0&&O.push(C);return O}insertEdge(O,C){const P=this.lookupOrInsertNode(O),f=this.lookupOrInsertNode(C);P.outgoing.set(f.key,f),f.incoming.set(P.key,P)}removeNode(O){const C=this.b(O);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(O){const C=this.b(O);let P=this.a.get(C);return P||(P=new S(C,O),this.a.set(C,P)),P}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[C,P]of this.a)O.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,C]of this.a){const P=new Set([O]),f=this.c(C,P);if(f)return f}}c(O,C){for(const[P,f]of O.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const a=this.c(f,C);if(a)return a;C.delete(P)}}}e.$dq=R}),define(ie[5],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var S;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(S||(e._util=S={})),e.$Oh=s("instantiationService");function R(C,P,f){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:C,index:f}):(P[S.DI_DEPENDENCIES]=[{id:C,index:f}],P[S.DI_TARGET]=P)}function s(C){if(S.serviceIds.has(C))return S.serviceIds.get(C);const P=function(f,a,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,f,g)};return P.toString=()=>C,S.serviceIds.set(C,P),P}e.$Ph=s;function O(C){return C}e.$Qh=O}),define(ie[114],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=void 0,e.$76b=(0,S.$Ph)("auxiliaryWindowsMainService")}),define(ie[63],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v6b=void 0,e.$v6b=(0,S.$Ph)("backupMainService")}),define(ie[18],ne([0,1,12,7,5]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,s.$Ph)("configurationService");function O($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof R.URI)}e.$ki=O;function C($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof R.URI)}e.$li=C;var P;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function f($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=f;function a($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}e.$ni=a;function g($,u){const l=Object.create(null);for(const E in $)w(l,E,$[E],u);return l}e.$oi=g;function w($,u,l,E){const h=u.split("."),i=h.pop();let c=$;for(let o=0;o<h.length;o++){const t=h[o];let n=c[t];switch(typeof n){case"undefined":n=c[t]=Object.create(null);break;case"object":break;default:E(`Ignoring ${u} as ${h.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}c=n}if(typeof c=="object"&&c!==null)try{c[i]=l}catch{E(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(c)}`)}else E(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(c)}`)}e.$pi=w;function y($,u){const l=u.split(".");d($,l)}e.$qi=y;function d($,u){const l=u.shift();if(u.length===0){delete $[l];return}if(Object.keys($).indexOf(l)!==-1){const E=$[l];typeof E=="object"&&!Array.isArray(E)&&(d(E,u),Object.keys(E).length===0&&delete $[l])}}function v($,u,l){function E(c,o){let t=c;for(const n of o){if(typeof t!="object"||t===null)return;t=t[n]}return t}const h=u.split("."),i=E($,h);return typeof i>"u"?l:i}e.$ri=v;function m($,u,l){Object.keys(u).forEach(E=>{E!=="__proto__"&&(E in $?S.$Af($[E])&&S.$Af(u[E])?m($[E],u[E],l):l&&($[E]=u[E]):$[E]=u[E])})}e.$si=m;function b($){return $.replace(/[\[\]]/g,"")}e.$ti=b}),define(ie[115],ne([0,1,4,27,197,5,164,14]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$k),f.set("isLinux",S.$l),f.set("isWindows",S.$j),f.set("isWeb",S.$p),f.set("isMacNative",S.$k&&!S.$p),f.set("isEdge",S.$H),f.set("isFirefox",S.$F),f.set("isChrome",S.$E),f.set("isSafari",S.$G);function a(F,M){if(f.get(F)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(F,M)}e.$Li=a;const g=Object.prototype.hasOwnProperty;var w;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const y={regexParsingWithErrorRecovery:!0},d=(0,C.localize)(0,null),v=(0,C.localize)(1,null),m=(0,C.localize)(2,null),b=(0,C.localize)(3,null),$=(0,C.localize)(4,null),u=(0,C.localize)(5,null),l=(0,C.localize)(6,null),E=(0,C.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=y){this.k=M,this.d=new s.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const W=this.D(),L=W.type===17?u:void 0;throw this.h.push({message:$,offset:W.offset,lexeme:s.$Ki.getLexeme(W),additionalInfo:L}),h.c}return U}catch(U){if(U!==h.c)throw U;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(16);){const U=this.o();M.push(U)}return M.length===1?M[0]:i.or(...M)}o(){const M=[this.s()];for(;this.y(15);){const U=this.s();M.push(U)}return M.length===1?M[0]:i.and(...M)}s(){if(this.y(2)){const M=this.D();switch(M.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,b),U?.negate()}case 17:return this.z(),j.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const U=this.l();return this.A(1,b),U}case 17:{const U=M.lexeme;if(this.z(),this.y(9)){const L=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),L.type!==10)throw this.B("REGEX",L);const V=L.lexeme,J=V.lastIndexOf("/"),oe=J===V.length-1?void 0:this.w(V.substring(J+1));let le;try{le=new RegExp(V.substring(1,J),oe)}catch{throw this.B("REGEX",L)}return re.create(U,le)}switch(L.type){case 10:case 19:{const V=[L.lexeme];this.z();let J=this.D(),oe=0;for(let me=0;me<L.lexeme.length;me++)L.lexeme.charCodeAt(me)===40?oe++:L.lexeme.charCodeAt(me)===41&&oe--;for(;!this.E()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let me=0;me<J.lexeme.length;me++)J.lexeme.charCodeAt(me)===40?oe++:L.lexeme.charCodeAt(me)===41&&oe--}if(oe<0)break;V.push(s.$Ki.getLexeme(J)),this.z(),J=this.D()}const le=V.join(""),de=le.lastIndexOf("/"),fe=de===le.length-1?void 0:this.w(le.substring(de+1));let ve;try{ve=new RegExp(le.substring(1,de),fe)}catch{throw this.B("REGEX",L)}return i.regex(U,ve)}case 18:{const V=L.lexeme;this.z();let J=null;if(!(0,R.$Be)(V)){const oe=V.indexOf("/"),le=V.lastIndexOf("/");if(oe!==le&&oe>=0){const de=V.slice(oe+1,le),fe=V[le+1]==="i"?"i":"";try{J=new RegExp(de,fe)}catch{throw this.B("REGEX",L)}}}if(J===null)throw this.B("REGEX",L);return re.create(U,J)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const L=this.u();return i.notIn(U,L)}switch(this.D().type){case 3:{this.z();const L=this.u();if(this.x().type===18)return i.equals(U,L);switch(L){case"true":return i.has(U);case"false":return i.not(U);default:return i.equals(U,L)}}case 4:{this.z();const L=this.u();if(this.x().type===18)return i.notEquals(U,L);switch(L){case"true":return i.not(U);case"false":return i.has(U);default:return i.notEquals(U,L)}}case 5:return this.z(),Y.create(U,this.u());case 6:return this.z(),ce.create(U,this.u());case 7:return this.z(),z.create(U,this.u());case 8:return this.z(),_.create(U,this.u());case 13:return this.z(),i.in(U,this.u());default:return i.has(U)}}case 20:throw this.h.push({message:l,offset:M.offset,lexeme:"",additionalInfo:E}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case 17:case 18:return this.z(),M.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,U){if(this.C(M))return this.z();throw this.B(U,this.D())}B(M,U,W){const L=(0,C.localize)(8,null,M,s.$Ki.getLexeme(U)),V=U.offset,J=s.$Ki.getLexeme(U);return this.h.push({message:L,offset:V,lexeme:J,additionalInfo:W}),h.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=h;class i{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(M){return p.create(M)}static equals(M,U){return A.create(M,U)}static notEquals(M,U){return I.create(M,U)}static regex(M,U){return re.create(M,U)}static in(M,U){return D.create(M,U)}static notIn(M,U){return k.create(M,U)}static not(M){return j.create(M)}static and(...M){return Q.create(M,null,!0)}static or(...M){return G.create(M,null,!0)}static greater(M,U){return z.create(M,U)}static greaterEquals(M,U){return _.create(M,U)}static smaller(M,U){return Y.create(M,U)}static smallerEquals(M,U){return ce.create(M,U)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Ni=i;function c(F){const M=new h({regexParsingWithErrorRecovery:!1});return F.map(U=>(M.parse(U),M.lexingErrors.length>0?M.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,C.localize)(9,null,W.additionalInfo):(0,C.localize)(10,null),offset:W.offset,length:W.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}e.$Oi=c;function o(F,M){const U=F?F.substituteConstants():void 0,W=M?M.substituteConstants():void 0;return!U&&!W?!0:!U||!W?!1:U.equals(W)}e.$Pi=o;function t(F,M){return F.cmp(M)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return r.INSTANCE}}e.$Qi=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return n.INSTANCE}}e.$Ri=r;class p{static create(M,U=null){const W=f.get(M);return typeof W=="boolean"?W?r.INSTANCE:n.INSTANCE:new p(M,U)}constructor(M,U){this.key=M,this.c=U,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:T(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=f.get(this.key);return typeof M=="boolean"?M?r.INSTANCE:n.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Si=p;class A{static create(M,U,W=null){if(typeof U=="boolean")return U?p.create(M,W):j.create(M,W);const L=f.get(M);return typeof L=="boolean"?U===(L?"true":"false")?r.INSTANCE:n.INSTANCE:new A(M,U,W)}constructor(M,U,W){this.c=M,this.d=U,this.f=W,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:K(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=f.get(this.c);if(typeof M=="boolean"){const U=M?"true":"false";return this.d===U?r.INSTANCE:n.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ti=A;class D{static create(M,U){return new D(M,U)}constructor(M,U){this.d=M,this.f=U,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:K(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const U=M.getValue(this.f),W=M.getValue(this.d);return Array.isArray(U)?U.includes(W):typeof W=="string"&&typeof U=="object"&&U!==null?g.call(U,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Ui=D;class k{static create(M,U){return new k(M,U)}constructor(M,U){this.d=M,this.f=U,this.type=11,this.c=D.create(M,U)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=k;class I{static create(M,U,W=null){if(typeof U=="boolean")return U?j.create(M,W):p.create(M,W);const L=f.get(M);return typeof L=="boolean"?U===(L?"true":"false")?n.INSTANCE:r.INSTANCE:new I(M,U,W)}constructor(M,U,W){this.c=M,this.d=U,this.f=W,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:K(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=f.get(this.c);if(typeof M=="boolean"){const U=M?"true":"false";return this.d===U?n.INSTANCE:r.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Wi=I;class j{static create(M,U=null){const W=f.get(M);return typeof W=="boolean"?W?n.INSTANCE:r.INSTANCE:new j(M,U)}constructor(M,U){this.c=M,this.d=U,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:T(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=f.get(this.c);return typeof M=="boolean"?M?n.INSTANCE:r.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Xi=j;function N(F,M){if(typeof F=="string"){const U=parseFloat(F);isNaN(U)||(F=U)}return typeof F=="string"||typeof F=="number"?M(F):n.INSTANCE}class z{static create(M,U,W=null){return N(U,L=>new z(M,L,W))}constructor(M,U,W){this.c=M,this.d=U,this.f=W,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:K(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Yi=z;class _{static create(M,U,W=null){return N(U,L=>new _(M,L,W))}constructor(M,U,W){this.c=M,this.d=U,this.f=W,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:K(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Zi=_;class Y{static create(M,U,W=null){return N(U,L=>new Y(M,L,W))}constructor(M,U,W){this.c=M,this.d=U,this.f=W,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:K(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$1i=Y;class ce{static create(M,U,W=null){return N(U,L=>new ce(M,L,W))}constructor(M,U,W){this.c=M,this.d=U,this.f=W,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:K(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$2i=ce;class re{static create(M,U){return new re(M,U)}constructor(M,U){this.d=M,this.f=U,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const U=this.f?this.f.source:"",W=M.f?M.f.source:"";return U<W?-1:U>W?1:0}equals(M){if(M.type===this.type){const U=this.f?this.f.source:"",W=M.f?M.f.source:"";return this.d===M.d&&U===W}return!1}substituteConstants(){return this}evaluate(M){const U=M.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$3i=re;class ae{static create(M){return new ae(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new ae(this.c.map(M))}negate(){return this.c}}e.$4i=ae;function Z(F){let M=null;for(let U=0,W=F.length;U<W;U++){const L=F[U].substituteConstants();if(F[U]!==L&&M===null){M=[];for(let V=0;V<U;V++)M[V]=F[V]}M!==null&&(M[U]=L)}return M===null?F:M}class Q{static create(M,U,W){return Q.d(M,U,W)}constructor(M,U){this.expr=M,this.c=U,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let U=0,W=this.expr.length;U<W;U++){const L=t(this.expr[U],M.expr[U]);if(L!==0)return L}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let U=0,W=this.expr.length;U<W;U++)if(!this.expr[U].equals(M.expr[U]))return!1;return!0}return!1}substituteConstants(){const M=Z(this.expr);return M===this.expr?this:Q.create(M,this.c,!1)}evaluate(M){for(let U=0,W=this.expr.length;U<W;U++)if(!this.expr[U].evaluate(M))return!1;return!0}static d(M,U,W){const L=[];let V=!1;for(const J of M)if(J){if(J.type===1){V=!0;continue}if(J.type===0)return n.INSTANCE;if(J.type===6){L.push(...J.expr);continue}L.push(J)}if(L.length===0&&V)return r.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(t);for(let J=1;J<L.length;J++)L[J-1].equals(L[J])&&(L.splice(J,1),J--);if(L.length===1)return L[0];for(;L.length>1;){const J=L[L.length-1];if(J.type!==9)break;L.pop();const oe=L.pop(),le=L.length===0,de=G.create(J.expr.map(fe=>Q.create([fe,oe],null,W)),null,le);de&&(L.push(de),L.sort(t))}if(L.length===1)return L[0];if(W){for(let J=0;J<L.length;J++)for(let oe=J+1;oe<L.length;oe++)if(L[J].negate().equals(L[oe]))return n.INSTANCE;if(L.length===1)return L[0]}return new Q(L,U)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const U of this.expr)M.push(...U.keys());return M}map(M){return new Q(this.expr.map(U=>U.map(M)),null)}negate(){if(!this.c){const M=[];for(const U of this.expr)M.push(U.negate());this.c=G.create(M,this,!0)}return this.c}}e.$5i=Q;class G{static create(M,U,W){return G.d(M,U,W)}constructor(M,U){this.expr=M,this.c=U,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let U=0,W=this.expr.length;U<W;U++){const L=t(this.expr[U],M.expr[U]);if(L!==0)return L}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let U=0,W=this.expr.length;U<W;U++)if(!this.expr[U].equals(M.expr[U]))return!1;return!0}return!1}substituteConstants(){const M=Z(this.expr);return M===this.expr?this:G.create(M,this.c,!1)}evaluate(M){for(let U=0,W=this.expr.length;U<W;U++)if(this.expr[U].evaluate(M))return!0;return!1}static d(M,U,W){let L=[],V=!1;if(M){for(let J=0,oe=M.length;J<oe;J++){const le=M[J];if(le){if(le.type===0){V=!0;continue}if(le.type===1)return r.INSTANCE;if(le.type===9){L=L.concat(le.expr);continue}L.push(le)}}if(L.length===0&&V)return n.INSTANCE;L.sort(t)}if(L.length!==0){if(L.length===1)return L[0];for(let J=1;J<L.length;J++)L[J-1].equals(L[J])&&(L.splice(J,1),J--);if(L.length===1)return L[0];if(W){for(let J=0;J<L.length;J++)for(let oe=J+1;oe<L.length;oe++)if(L[J].negate().equals(L[oe]))return r.INSTANCE;if(L.length===1)return L[0]}return new G(L,U)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const U of this.expr)M.push(...U.keys());return M}map(M){return new G(this.expr.map(U=>U.map(M)),null)}negate(){if(!this.c){const M=[];for(const U of this.expr)M.push(U.negate());for(;M.length>1;){const U=M.shift(),W=M.shift(),L=[];for(const V of B(U))for(const J of B(W))L.push(Q.create([V,J],null,!1));M.unshift(G.create(L,null,!1))}this.c=G.create(M,this,!0)}return this.c}}e.$6i=G;class q extends p{static{this.d=[]}static all(){return q.d.values()}constructor(M,U,W){super(M,null),this.f=U,typeof W=="object"?q.d.push({...W,key:M}):W!==!0&&q.d.push({key:M,description:W,type:U!=null?typeof U:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return A.create(this.key,M)}notEqualsTo(M){return I.create(this.key,M)}}e.$7i=q,e.$8i=(0,O.$Ph)("contextKeyService");function T(F,M){return F<M?-1:F>M?1:0}function K(F,M,U,W){return F<U?-1:F>U?1:M<W?-1:M>W?1:0}function H(F,M){if(F.type===0||M.type===1)return!0;if(F.type===9)return M.type===9?x(F.expr,M.expr):!1;if(M.type===9){for(const U of M.expr)if(H(F,U))return!0;return!1}if(F.type===6){if(M.type===6)return x(M.expr,F.expr);for(const U of F.expr)if(H(U,M))return!0;return!1}return F.equals(M)}e.$9i=H;function x(F,M){let U=0,W=0;for(;U<F.length&&W<M.length;){const L=F[U].cmp(M[W]);if(L<0)return!1;L===0&&U++,W++}return U===F.length}function B(F){return F.type===9?F.expr:[F]}}),define(ie[90],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.ID=void 0,e.ID="diagnosticsService",e.$qm=(0,S.$Ph)(e.ID);function R(O){return!!O.hostName&&!!O.errorMessage}e.$rm=R;class s{async getPerformanceInfo(C,P){return{}}async getSystemInfo(C,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,P){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$sm=s}),define(ie[116],ne([0,1,19,73,166,5,46,4,37]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.ConfirmResult=e.$Dv=e.$Cv=e.$Bv=void 0,e.$Bv=(0,O.$Ph)("dialogService");var a;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(a||(a={}));class g{a(b){return this.d(b,a.Confirmation)}b(b){return this.d(b,a.Prompt)}c(b){return this.d(b,a.Input)}d(b,$){const u=[];switch($){case a.Confirmation:{const l=b;l.primaryButton?u.push(l.primaryButton):u.push((0,s.localize)(0,null)),l.cancelButton?u.push(l.cancelButton):u.push((0,s.localize)(1,null));break}case a.Prompt:{const l=b;Array.isArray(l.buttons)&&l.buttons.length>0&&u.push(...l.buttons.map(E=>E.label)),l.cancelButton&&(l.cancelButton===!0?u.push((0,s.localize)(2,null)):typeof l.cancelButton=="string"?u.push(l.cancelButton):l.cancelButton.label?u.push(l.cancelButton.label):u.push((0,s.localize)(3,null))),u.length===0&&u.push((0,s.localize)(4,null));break}case a.Input:{const l=b;l.primaryButton?u.push(l.primaryButton):u.push((0,s.localize)(5,null)),l.cancelButton?u.push(l.cancelButton):u.push((0,s.localize)(6,null));break}}return u}e(b){if(typeof b=="string")return b;if(typeof b=="number")return b===R.default.Info?"info":b===R.default.Error?"error":b===R.default.Warning?"warning":"none"}f(b,$,u){const l=[...b.buttons??[]];b.cancelButton&&typeof b.cancelButton!="string"&&typeof b.cancelButton!="boolean"&&l.push(b.cancelButton);let E=l[$]?.run({checkboxChecked:u});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:u}}}e.$Cv=g,e.$Dv=(0,O.$Ph)("fileDialogService");var w;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(w||(e.ConfirmResult=w={}));const y=10;function d(m){const b=[];return b.push(...m.slice(0,y).map($=>typeof $=="string"?$:(0,S.$sg)($))),m.length>y&&(m.length-y===1?b.push((0,s.localize)(7,null)):b.push((0,s.localize)(8,null,m.length-y))),b.push(""),b.join(`
`)}e.$Ev=d;function v(m,b){const $=(0,f.$7m)(m);let u=($.buttons??[]).map(i=>(0,C.$yv)(i)),l=(m.buttons||[]).map((i,c)=>c),E=0,h=$.cancelId??u.length-1;if(u.length>1){const i=typeof h=="number"?u[h]:void 0;if(P.$l||P.$k){if(typeof i=="string"&&u.length>1&&h!==1){u.splice(h,1),u.splice(1,0,i);const c=l[h];l.splice(h,1),l.splice(1,0,c),h=1}P.$l&&u.length>1&&(u=u.reverse(),l=l.reverse(),E=u.length-1,typeof i=="string"&&(h=E-1))}else if(P.$j&&typeof i=="string"&&u.length>1&&h!==u.length-1){u.splice(h,1),u.push(i);const c=l[h];l.splice(h,1),l.push(c),h=u.length-1}}return $.buttons=u,$.defaultId=E,$.cancelId=h,$.noLink=!0,$.title=$.title||b.nameLong,{options:$,buttonIndeces:l}}e.$Fv=v}),define(ie[117],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6T=e.$5T=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$4T=e.$3T=void 0,e.$3T=(0,S.$Ph)("encryptionService"),e.$4T=(0,S.$Ph)("encryptionMainService");var R;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function O(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$5T=O;function C(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$6T=C}),define(ie[36],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,S.$Ph)("environmentService"),e.$Xh=(0,S.$Qh)(e.$Wh)}),define(ie[118],ne([0,1,170,5]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$$n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function s(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=s;function O(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=O;function C(u,l){switch(u){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=C;function P(u,l){return l==="web"&&!u.includes("web")}e.$7n=P;function f(u,l,E){return P(l,E)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===E?!0:a(E).includes(u)}e.$8n=f;function a(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$9n=a;function g(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$0n=g;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var v;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$$n=(0,R.$Ph)("extensionGalleryService");var m;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var b;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(b||(e.ExtensionSignaturetErrorCode=b={}));class $ extends Error{constructor(l,E){super(l),this.code=E,this.name=E}}e.$_n=$,e.$ao=(0,R.$Ph)("extensionManagementService"),e.$bo="extensionsIdentifiers/disabled",e.$co="extensionsIdentifiers/enabled",e.$do=(0,R.$Ph)("IGlobalExtensionEnablementService"),e.$eo=(0,R.$Ph)("IExtensionTipsService"),e.$fo=(0,S.localize)(0,null),e.$go={value:e.$fo,original:"Extensions"},e.$ho={value:(0,S.localize)(1,null),original:"Preferences"}}),define(ie[209],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=e.$P6b=void 0,e.$P6b=(0,S.$Ph)("extensionHostStarter"),e.$Q6b="extensionHostStarter"}),define(ie[210],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Xb=e.$7Xb=void 0,e.$7Xb=(0,S.$Ph)("externalTerminal"),e.$8Xb="Terminal.app"}),define(ie[211],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=void 0,e.$S6b=(0,S.$Ph)("externalTerminal")}),define(ie[212],ne([0,1,47,13,9,4,75,21,88,174,210]),function(X,e,S,R,s,O,C,P,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=e.$U6b=e.$T6b=void 0;const w=a.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends y{static{this.b="cmd.exe"}openTerminal(E,h){return this.spawnTerminal(S,E,f.$Bl(),h)}spawnTerminal(E,h,i,c){const o=h.windowsExec||d.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const t=s.$nc(o,".exe").toLowerCase();if(t==="cmder")return E.spawn(o,c?[c]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return o.indexOf(" ")>=0&&n.push('""'),n.push(o),t==="wt"&&n.push("-d ."),new Promise((r,p)=>{const A=b(process),D=E.spawn(i,n,{cwd:c,env:A});D.on("error",p),D.on("exit",()=>r())})}runInTerminal(E,h,i,c,o){const t="windowsExec"in o&&o.windowsExec?o.windowsExec:d.getDefaultTerminalWindows();return new Promise((n,r)=>{const p=`"${h} - ${w}"`,A=`""${i.join('" "')}" & pause"`,D=Object.assign({},b(process),c);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const k={cwd:h,env:D,windowsVerbatimArguments:!0};let I,j;s.$nc(t,".exe")==="wt"?(I=t,j=["-d",".",d.b,"/c",A]):(I=d.b,j=["/c","start",p,"/wait",t,"/c",A]),S.spawn(I,j,k).on("error",z=>{r($(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return d.d}}e.$T6b=d;class v extends y{static{this.b="/usr/bin/osascript"}openTerminal(E,h){return this.spawnTerminal(S,E,h)}runInTerminal(E,h,i,c,o){const t=o.osxExec||g.$8Xb;return new Promise((n,r)=>{if(t===g.$8Xb||t==="iTerm.app"){const p=t===g.$8Xb?"TerminalHelper":"iTermHelper",D=[R.$cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`).fsPath,"-t",E||w,"-w",h];for(const j of i)D.push("-a"),D.push(j);if(c){const j=Object.assign({},b(process),c);for(const N in j){const z=j[N];z===null?(D.push("-u"),D.push(N)):(D.push("-e"),D.push(`${N}=${z}`))}}let k="";const I=S.spawn(v.b,D);I.on("error",j=>{r($(j))}),I.stderr.on("data",j=>{k+=j.toString()}),I.on("exit",j=>{if(j===0)n(void 0);else if(k){const N=k.split(`
`,1);r(new Error(N[0]))}else r(new Error(a.localize(1,null,p,j)))})}else r(new Error(a.localize(2,null,t)))})}spawnTerminal(E,h,i){const c=h.osxExec||g.$8Xb;return new Promise((o,t)=>{const n=["-a",c];i&&n.push(i);const r=b(process),p=E.spawn("/usr/bin/open",n,{cwd:i,env:r});p.on("error",t),p.on("exit",()=>o())})}}e.$U6b=v;class m extends y{static{this.b=a.localize(3,null)}openTerminal(E,h){return this.spawnTerminal(S,E,h)}runInTerminal(E,h,i,c,o){const t=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,r)=>{const p=[];t.then(A=>{A.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const D=`${u(i)}; echo; read -p "${m.b}" -n1;`;p.push(`''${D}''`);const k=Object.assign({},b(process),c);Object.keys(k).filter(z=>k[z]===null).forEach(z=>delete k[z]);const I={cwd:h,env:k};let j="";const N=S.spawn(A,p,I);N.on("error",z=>{r($(z))}),N.stderr.on("data",z=>{j+=z.toString()}),N.on("exit",z=>{if(z===0)n(void 0);else if(j){const _=j.split(`
`,1);r(new Error(_[0]))}else r(new Error(a.localize(4,null,A,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!O.$l)m.d=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");m.d=new Promise(h=>{E?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return m.d}spawnTerminal(E,h,i){const c=h.linuxExec?Promise.resolve(h.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((o,t)=>{c.then(n=>{const r=b(process),p=E.spawn(n,[],{cwd:i,env:r});p.on("error",t),p.on("exit",()=>o())})})}}e.$V6b=m;function b(l){const E={...l.env};return(0,C.$zl)(E),E}function $(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(a.localize(5,null,l.path)):l}function u(l){let E="";for(const h of l)h.indexOf(" ")>=0?E+='"'+h+'"':E+=h,E+=" ";return E}}),define(ie[16],ne([0,1,56,9,27,12,7,176,5,4,13,71]),function(X,e,S,R,s,O,C,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,f.$Ph)("fileService");function y(H){return H.create===!0}e.$_j=y;var d;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var v;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function m(H){const x=H;return!!x&&typeof x.onDidChange=="function"}e.$ak=m;var b;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function $(H){return!!(H.capabilities&2)}e.$bk=$;function u(H){return!!(H.capabilities&8)}e.$ck=u;function l(H){return!!(H.capabilities&131072)}e.$dk=l;function E(H){return!!(H.capabilities&4)}e.$ek=E;function h(H){return!!(H.capabilities&16)}e.$fk=h;function i(H){return $(H)?!!(H.capabilities&16384):!1}e.$gk=i;function c(H){return $(H)?!!(H.capabilities&32768):!1}e.$hk=c;function o(H){return!!(H.capabilities&65536)}e.$ik=o;function t(H){return!!(H.capabilities&2048)}e.$jk=t;var n;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class r extends Error{static create(x,B){const F=new r(x.toString(),B);return D(F,B),F}constructor(x,B){super(x),this.code=B}}e.$kk=r;function p(H,x){return r.create(H,x)}e.$lk=p;function A(H){return H||p((0,P.localize)(0,null),n.Unknown)}e.$mk=A;function D(H,x){return H.name=x?`${x} (FileSystemError)`:"FileSystemError",H}e.$nk=D;function k(H){if(!H)return n.Unknown;if(H instanceof r)return H.code;const x=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!x)return n.Unknown;switch(x[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$ok=k;function I(H){if(H instanceof ce)return H.fileOperationResult;switch(k(H)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$pk=I;var j;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class N{constructor(x,B,F){this.resource=x,this.operation=B,this.target=F}isOperation(x){return this.operation===x}}e.$qk=N;var z;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class _{static{this.a=null}constructor(x,B){this.c=B,this.b=void 0,this.d=new w.$V(()=>{const F=S.$Vh.forUris(()=>this.c);return F.fill(this.rawAdded.map(M=>[M,!0])),F}),this.f=new w.$V(()=>{const F=S.$Vh.forUris(()=>this.c);return F.fill(this.rawUpdated.map(M=>[M,!0])),F}),this.g=new w.$V(()=>{const F=S.$Vh.forUris(()=>this.c);return F.fill(this.rawDeleted.map(M=>[M,!0])),F}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const F of x){switch(F.type){case 1:this.rawAdded.push(F.resource);break;case 0:this.rawUpdated.push(F.resource);break;case 2:this.rawDeleted.push(F.resource);break}this.b!==_.a&&(typeof F.cId=="number"?this.b===void 0?this.b=F.cId:this.b!==F.cId&&(this.b=_.a):this.b!==void 0&&(this.b=_.a))}}contains(x,...B){return this.h(x,{includeChildren:!1},...B)}affects(x,...B){return this.h(x,{includeChildren:!0},...B)}h(x,B,...F){if(!x)return!1;const M=F.length>0;return!!((!M||F.includes(1))&&(this.d.value.get(x)||B.includeChildren&&this.d.value.findSuperstr(x))||(!M||F.includes(0))&&(this.f.value.get(x)||B.includeChildren&&this.f.value.findSuperstr(x))||(!M||F.includes(2))&&(this.g.value.findSubstr(x)||B.includeChildren&&this.g.value.findSuperstr(x)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(x){return this.b===x}hasCorrelation(){return typeof this.b=="number"}}e.$rk=_;function Y(H,x,B){return!H||!x||H===x||x.length>H.length?!1:(x.charAt(x.length-1)!==R.sep&&(x+=R.sep),B?(0,s.$3e)(H,x):H.indexOf(x)===0)}e.$sk=Y;class ce extends Error{constructor(x,B,F){super(x),this.fileOperationResult=B,this.options=F}}e.$tk=ce;class re extends ce{constructor(x,B,F,M){super(x,B,M),this.fileOperationResult=B,this.size=F}}e.$uk=re;class ae extends ce{constructor(x,B,F){super(x,2,F),this.stat=B}}e.$vk=ae;var Z;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var Q;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Dk="";function G(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$Ek=G;async function q(H,x){if(!x.hasProvider(C.URI.from({scheme:H.scheme})))return new Promise(B=>{const F=x.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===H.scheme&&M.added&&(F.dispose(),B())})})}e.$Fk=q;class T{static{this.KB=1024}static{this.MB=T.KB*T.KB}static{this.GB=T.MB*T.KB}static{this.TB=T.GB*T.KB}static formatSize(x){return(0,O.$Cf)(x)||(x=0),x<T.KB?(0,P.localize)(1,null,x.toFixed(0)):x<T.MB?(0,P.localize)(2,null,(x/T.KB).toFixed(2)):x<T.GB?(0,P.localize)(3,null,(x/T.MB).toFixed(2)):x<T.TB?(0,P.localize)(4,null,(x/T.GB).toFixed(2)):(0,P.localize)(5,null,(x/T.TB).toFixed(2))}}e.$Gk=T;function K(H){const x=typeof H=="string"||H?.scheme===g.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===g.Schemas.file?1024*T.MB:x?10*T.MB:a.$p?50*T.MB:1024*T.MB}e.$Hk=K}),define(ie[119],ne([0,1,17,14,177,16]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;async function C(g,w,y,d,v,m){let b;try{await P(g,w,y,d,v,m)}catch($){b=$}finally{b&&v.errorTransformer&&(b=v.errorTransformer(b)),typeof b<"u"&&y.error(b),y.end()}}e.$Np=C;async function P(g,w,y,d,v,m){f(m);const b=await g.open(w,{create:!1});try{f(m);let $=0,u=0,l=v&&typeof v.length=="number"?v.length:void 0,E=S.$be.alloc(Math.min(v.bufferSize,typeof l=="number"?l:v.bufferSize)),h=v&&typeof v.position=="number"?v.position:0,i=0;do u=await g.read(b,h,E.buffer,i,E.byteLength-i),h+=u,i+=u,$+=u,typeof l=="number"&&(l-=u),i===E.byteLength&&(await y.write(d(E)),E=S.$be.alloc(Math.min(v.bufferSize,typeof l=="number"?l:v.bufferSize)),i=0);while(u>0&&(typeof l!="number"||l>0)&&f(m)&&a($,v));if(i>0){let c=i;typeof l=="number"&&(c=Math.min(i,l)),y.write(d(E.slice(0,c)))}}catch($){throw(0,O.$mk)($)}finally{await g.close(b)}}function f(g){if(g.isCancellationRequested)throw(0,R.$6)();return!0}function a(g,w){if(typeof w?.limits?.size=="number"&&g>w.limits.size)throw(0,O.$lk)((0,s.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[64],ne([0,1,104,2,9,4,7,16]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=e.$Qp=e.$Pp=void 0;function f($){return $.recursive===!0}e.$Pp=f;class a extends R.$Sc{static{this.a=5}constructor(u,l,E,h){super(),this.h=u,this.j=l,this.m=E,this.n=h,this.c=this.B(new R.$Tc),this.f=void 0,this.g=0}s(){const u=new R.$Rc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(l=>this.h(l))),u.add(this.b.onDidLogMessage(l=>this.j(l))),u.add(this.b.onDidError(l=>this.t(l)))}t(u){this.n.restartOnError?this.g<a.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Qp=a;class g extends a{constructor(u,l,E){super(u,l,E,{type:"node.js",restartOnError:!1})}}e.$Rp=g;class w extends a{constructor(u,l,E){super(u,l,E,{type:"universal",restartOnError:!0})}}e.$Sp=w;function y($){return $.map(u=>({type:u.type,resource:C.URI.revive(u.resource),cId:u.cId}))}e.$Tp=y;function d($){const u=new b;for(const l of $)u.processEvent(l);return u.coalesce()}e.$Up=d;function v($,u){return typeof u=="string"&&!u.startsWith(S.$sj)&&!(0,s.$ic)(u)?{base:$,pattern:u}:u}e.$Vp=v;function m($,u){const l=[];for(const E of u)l.push((0,S.$wj)(v($,E)));return l}e.$Wp=m;class b{constructor(){this.a=new Set,this.b=new Map}c(u){return O.$l?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const l=this.b.get(this.c(u));let E=!1;if(l){const h=l.type,i=u.type;l.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?E=!0:h===1&&i===2?(this.b.delete(this.c(u)),this.a.delete(l)):h===2&&i===1?l.type=0:h===1&&i===0||(l.type=i)}else E=!0;E&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],l=[];return Array.from(this.a).filter(E=>E.type!==2?(u.push(E),!1):!0).sort((E,h)=>E.resource.fsPath.length-h.resource.fsPath.length).filter(E=>l.some(h=>(0,P.$sk)(E.resource.fsPath,h,!O.$l))?!1:(l.push(E.resource.fsPath),!0)).concat(u)}}}),define(ie[213],ne([0,1,17,49,14,3,2,61,32,16,64]),function(X,e,S,R,s,O,C,P,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.$mN=void 0,e.$mN="localFilesystem";class w extends C.$Sc{constructor(d,v){super(),this.a=d,this.b=v,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$Nd),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$Nd),this.onDidWatchError=this.g.event,this.h=(0,f.$eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,v){const{buffer:m}=await this.a.call("readFile",[d,v]);return m}readFileStream(d,v,m){const b=(0,P.$2d)(u=>S.$be.concat(u.map(l=>S.$be.wrap(l))).buffer),$=new C.$Rc;return $.add(this.a.listen("readFileStream",[d,v])(u=>{if(u instanceof S.$be)b.write(u.buffer);else{if(u==="end")b.end();else{let l;if(u instanceof Error)l=u;else{const E=u;l=(0,a.$lk)(E.message??(0,R.$Ai)(E),E.code??a.FileSystemProviderErrorCode.Unknown)}b.error(l),b.end()}$.dispose()}})),$.add(m.onCancellationRequested(()=>{b.error((0,s.$6)()),b.end(),$.dispose()})),b}writeFile(d,v,m){return this.a.call("writeFile",[d,S.$be.wrap(v),m])}open(d,v){return this.a.call("open",[d,v])}close(d){return this.a.call("close",[d])}async read(d,v,m,b,$){const[u,l]=await this.a.call("read",[d,v,$]);return m.set(u.buffer.slice(0,l),b),l}write(d,v,m,b,$){return this.a.call("write",[d,v,S.$be.wrap(m),b,$])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,v){return this.a.call("delete",[d,v])}rename(d,v,m){return this.a.call("rename",[d,v,m])}copy(d,v,m){return this.a.call("copy",[d,v,m])}cloneFile(d,v){return this.a.call("cloneFile",[d,v])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const v=d;this.f.fire((0,g.$Tp)(v))}else{const v=d;this.g.fire(v)}}))}watch(d,v){const m=(0,f.$eg)();return this.a.call("watch",[this.h,m,d,v]),(0,C.$Qc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$nN=w}),define(ie[214],ne([0,1,45,8,22,33,2,84,9,4,19,7,105,21,64]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class m extends C.$Sc{static{this.a=100}static{this.b=75}constructor(u,l,E,h){super(),this.m=u,this.n=l,this.r=E,this.s=h,this.c=this.B(new R.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new R.$8g(i=>this.z(i),m.b)),this.g=(0,v.$Wp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Wp)(this.m.path,this.m.includes):void 0,this.j=new s.$Xd,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await d.Promises.stat(u);this.B(await this.w(u,l.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let l=u.path;try{l=await d.Promises.realpath(u.path),u.path===l&&(l=await(0,y.$7p)(u.path)??u.path),u.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${l})`)}catch{}return l}async w(u,l){if(a.$k&&(0,O.$Xf)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Sc.None;const E=new s.$Xd(this.j.token),h=new C.$Rc;try{const i=w.URI.file(this.m.path),c=(0,f.$nc)(u),o=(0,S.watch)(u);h.add((0,C.$Qc)(()=>{o.removeAllListeners(),o.close()})),this.G(`Started watching: '${u}'`);const t=new Set;if(l)try{for(const r of await d.Promises.readdir(u))t.add(r)}catch(r){this.D(r)}const n=new Map;h.add((0,C.$Qc)(()=>{for(const[,r]of n)r.dispose();n.clear()})),o.on("error",(r,p)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${p})`),this.dispose()}),o.on("change",(r,p)=>{if(E.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${p}`);let A="";if(p&&(A=p.toString(),a.$k&&(A=(0,P.$ol)(A))),!(!A||r!=="change"&&r!=="rename"))if(l)if(r==="rename"){n.get(A)?.dispose();const D=setTimeout(async()=>{if(n.delete(A),A===c&&!await d.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,f.$jc)(u,A));if(E.token.isCancellationRequested)return;let I;k?t.has(A)?I=0:(I=1,t.add(A)):(t.delete(A),I=2),this.y({resource:(0,g.$vg)(i,A),type:I,cId:this.m.correlationId})},m.a);n.set(A,(0,C.$Qc)(()=>clearTimeout(D)))}else{let D;t.has(A)?D=0:(D=1,t.add(A)),this.y({resource:(0,g.$vg)(i,A),type:D,cId:this.m.correlationId})}else if(r==="rename"||A!==c){const D=setTimeout(async()=>{const k=await d.Promises.exists(u);E.token.isCancellationRequested||(k?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),h.add(await this.w(u,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},m.a);h.clear(),h.add((0,C.$Qc)(()=>clearTimeout(D)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await d.Promises.exists(u)&&!E.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${i.toString()})`)}return(0,C.$Qc)(()=>{E.dispose(!0),h.dispose()})}y(u,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!l&&this.g.some(E=>E(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(E=>E(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const l=(0,v.$Up)(u);if(l.length>0){if(this.s)for(const h of l)this.G(` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(a.$l)return d.Promises.exists(u);try{const l=(0,f.$nc)(u);return(await d.Promises.readdir((0,f.$mc)(u))).some(h=>h===l)}catch(l){return this.G(l),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$0p=m;async function b($,u,l,E,h=512){const i=await d.Promises.open($,"r"),c=Buffer.allocUnsafe(h),o=new s.$Xd(E);let t,n=!1;const r={path:$,excludes:[],recursive:!1},p=new m(r,A=>{(async()=>{for(const{type:D}of A)if(D===0){if(n)return;n=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:k}=await d.Promises.read(i,c,0,h,null);if(!k||o.token.isCancellationRequested)break;u(c.slice(0,k))}}catch(k){t=new Error(k),o.dispose(!0)}finally{n=!1}}})()});return await p.ready,l(),new Promise((A,D)=>{o.token.onCancellationRequested(async()=>{p.dispose();try{await d.Promises.close(i)}catch(k){t=new Error(k)}t?D(t):A()})})}e.$$p=b}),define(ie[215],ne([0,1,3,104,2,4,214]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class P extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new S.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(a){const g=this.j(a),w=g.filter(d=>{const v=this.c.get(d.path);return v?!(0,R.$Aj)(v.request.excludes,d.excludes)||!(0,R.$Aj)(v.request.includes,d.includes):!0}),y=Array.from(this.c.values()).filter(({request:d})=>!g.find(v=>v.path===d.path&&(0,R.$Aj)(v.excludes,d.excludes)&&(0,R.$Aj)(v.includes,d.includes))).map(({request:d})=>d.path);w.length&&this.m(`Request to start watching: ${w.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const d of y)this.h(d);for(const d of w)this.g(d)}g(a){const g=new C.$0p(a,y=>this.a.fire(y),y=>this.b.fire(y),this.f),w={request:a,instance:g};this.c.set(a.path,w)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const g=this.c.get(a);g&&(this.c.delete(a),g.instance.dispose())}j(a){const g=new Map;for(const w of a){const y=O.$l?w.path:w.path.toLowerCase();let d=g.get(w.correlationId);d||(d=new Map,g.set(w.correlationId,d)),d.set(y,w)}return Array.from(g.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,g]of this.c)g.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,g){return g?`[File Watcher (node.js)] ${a} (path: ${g.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$_p=P}),define(ie[216],ne([0,1,64,215]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;class s extends S.$Rp{constructor(C,P,f){super(C,P,f),this.s()}r(C){return C.add(new R.$_p)}}e.$aq=s}),define(ie[217],ne([0,1,13,42,160,64]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;class C extends O.$Sp{constructor(f,a,g){super(f,a,g),this.s()}r(f){const a=f.add(new s.$4p(S.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(a.onDidProcessExit(({code:g,signal:w})=>this.t(`terminated by itself with code ${g}, signal: ${w}`))),R.ProxyChannel.toService((0,R.$wh)(a.getChannel("watcher")))}}e.$5p=C}),define(ie[91],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class S{constructor(...s){this.a=new Map;for(const[O,C]of s)this.set(O,C)}set(s,O){const C=this.a.get(s);return this.a.set(s,O),C}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Nh=S}),define(ie[218],ne([0,1,8,14,2,77,208,5,91,101]),function(X,e,S,R,s,O,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;const g=!1;class w extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class y{constructor(b=new f.$Nh,$=!1,u,l=g){this.f=b,this.g=$,this.h=u,this.i=l,this.o=new Set,this.f.set(P.$Oh,this),this._globalGraph=l?u?._globalGraph??new C.$dq(E=>E):void 0}createChild(b){return new y(b,this.g,this,this.i)}invokeFunction(b,...$){const u=v.traceInvocation(this.i,b);let l=!1;try{return b({get:h=>{if(l)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,u);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...$)}finally{l=!0,u.stop()}}createInstance(b,...$){let u,l;return b instanceof O.$Mh?(u=v.traceCreation(this.i,b.ctor),l=this.j(b.ctor,b.staticArguments.concat($),u)):(u=v.traceCreation(this.i,b),l=this.j(b,$,u)),u.stop(),l}j(b,$=[],u){const l=P._util.getServiceDependencies(b).sort((i,c)=>i.index-c.index),E=[];for(const i of l){const c=this.m(i.id,u);c||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(c)}const h=l.length>0?l[0].index:$.length;if($.length!==h){console.trace(`[createInstance] First service dependency of ${b.name} at position ${h+1} conflicts with ${$.length} static arguments`);const i=h-$.length;i>0?$=$.concat(new Array(i)):$=$.slice(0,h)}return Reflect.construct(b,$.concat(E))}k(b,$){if(this.f.get(b)instanceof O.$Mh)this.f.set(b,$);else if(this.h)this.h.k(b,$);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const $=this.f.get(b);return!$&&this.h?this.h.l(b):$}m(b,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const u=this.l(b);return u instanceof O.$Mh?this.q(b,u,$.branch(b,!0)):($.branch(b,!1),u)}q(b,$,u){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,$,u)}finally{this.o.delete(b)}}r(b,$,u){const l=new C.$dq(i=>i.id.toString());let E=0;const h=[{id:b,desc:$,_trace:u}];for(;h.length;){const i=h.pop();if(l.lookupOrInsertNode(i),E++>1e3)throw new w(l);for(const c of P._util.getServiceDependencies(i.desc.ctor)){const o=this.l(c.id);if(o||this.u(`[createInstance] ${b} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(c.id)),o instanceof O.$Mh){const t={id:c.id,desc:o,_trace:i._trace.branch(c.id,!0)};l.insertEdge(i,t),h.push(t)}}}for(;;){const i=l.roots();if(i.length===0){if(!l.isEmpty())throw new w(l);break}for(const{data:c}of i){if(this.l(c.id)instanceof O.$Mh){const t=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,t)}l.removeNode(c)}}return this.l(b)}s(b,$,u=[],l,E){if(this.f.get(b)instanceof O.$Mh)return this.t(b,$,u,l,E);if(this.h)return this.h.s(b,$,u,l,E);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}t(b,$,u=[],l,E){if(l){const h=new y(void 0,this.g,this,this.i);h.c=String(b);const i=new Map,c=new S.$$g(()=>{const o=h.j($,u,E);for(const[t,n]of i){const r=o[t];if(typeof r=="function")for(const p of n)r.apply(o,p)}return i.clear(),o});return new Proxy(Object.create(null),{get(o,t){if(!c.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let p=i.get(t);return p||(p=new a.$2c,i.set(t,p)),(D,k,I)=>{const j=p.push([D,k,I]);return(0,s.$Qc)(j)}}if(t in o)return o[t];const n=c.value;let r=n[t];return typeof r!="function"||(r=r.bind(n),o[t]=r),r},set(o,t,n){return c.value[t]=n,!0},getPrototypeOf(o){return $.prototype}})}else return this.j($,u,E)}u(b,$){if($&&console.warn(b),this.g)throw new Error(b)}}e.$eq=y;var d;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(d||(d={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(b,$){return b?new v(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(b,$){return b?new v(1,$.name):v.c}static{this.f=0}constructor(b,$){this.type=b,this.name=$,this.g=Date.now(),this.h=[]}branch(b,$){const u=new v(3,b.toString());return this.h.push([b,$,u]),u}stop(){const b=Date.now()-this.g;v.f+=b;let $=!1;function u(E,h){const i=[],c=new Array(E+1).join("	");for(const[o,t,n]of h.h)if(t&&n){$=!0,i.push(`${c}CREATES -> ${o}`);const r=u(E+1,n);r&&i.push(r)}else i.push(`${c}uses -> ${o}`);return i.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(b>2||$)&&v.all.add(l.join(`
`))}}e.$fq=v}),define(ie[219],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5wb=e.IssueType=void 0;var R;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$5wb=(0,S.$Ph)("issueService")}),define(ie[6],ne([0,1,49,3,55,2,31,4,19,12,7,115,5]),function(X,e,S,R,s,O,C,P,f,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,y.$Ph)("logService"),e.$$i=(0,y.$Ph)("loggerService");function d(){return new Date().toISOString()}function v(D){return(0,a.$Cf)(D)}e.$_i=v;var m;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$aj=m.Info;function b(D,k,I){switch(k){case m.Trace:D.trace(I);break;case m.Debug:D.debug(I);break;case m.Info:D.info(I);break;case m.Warning:D.warn(I);break;case m.Error:D.error(I);break;case m.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=b;function $(D,k=!1){let I="";for(let j=0;j<D.length;j++){let N=D[j];if(N instanceof Error&&(N=(0,S.$Ai)(N,k)),typeof N=="object")try{N=JSON.stringify(N)}catch{}I+=(j>0?" ":"")+N}return I}class u extends O.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new R.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==m.Off&&this.b<=k}}e.$cj=u;class l extends u{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...I){this.f(m.Trace)&&this.g(m.Trace,$([k,...I],!0))}debug(k,...I){this.f(m.Debug)&&this.g(m.Debug,$([k,...I]))}info(k,...I){this.f(m.Info)&&this.g(m.Info,$([k,...I]))}warn(k,...I){this.f(m.Warning)&&this.g(m.Warning,$([k,...I]))}error(k,...I){if(this.f(m.Error))if(k instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=k.stack,this.g(m.Error,$(j))}else this.g(m.Error,$([k,...I]))}flush(){}}e.$dj=l;class E extends u{constructor(k=e.$aj){super(),this.setLevel(k),this.g=!P.$j}trace(k,...I){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}debug(k,...I){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}info(k,...I){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}warn(k,...I){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,k,...I):console.warn(`[main ${d()}]`,k,...I))}error(k,...I){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,k,...I):console.error(`[main ${d()}]`,k,...I))}dispose(){}flush(){}}e.$ej=E;class h extends u{constructor(k=e.$aj,I=!0){super(),this.g=I,this.setLevel(k)}trace(k,...I){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...I):console.log(k,...I))}debug(k,...I){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...I):console.log(k,...I))}info(k,...I){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...I):console.log(k,...I))}warn(k,...I){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...I):console.log(k,...I))}error(k,...I){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...I):console.error(k,...I))}dispose(){}flush(){}}e.$fj=h;class i extends u{constructor(k,I=e.$aj){super(),this.g=k,this.setLevel(I)}trace(k,...I){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(k),...I])}debug(k,...I){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(k),...I])}info(k,...I){this.f(m.Info)&&this.g.log(m.Info,[this.h(k),...I])}warn(k,...I){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(k),...I])}error(k,...I){this.f(m.Error)&&this.g.log(m.Error,[this.h(k),...I])}h(k){return typeof k=="string"?k:(0,S.$Ai)(k,this.f(m.Trace))}dispose(){}flush(){}}e.$gj=i;class c extends u{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const I of this.g)I.setLevel(k);super.setLevel(k)}trace(k,...I){for(const j of this.g)j.trace(k,...I)}debug(k,...I){for(const j of this.g)j.debug(k,...I)}info(k,...I){for(const j of this.g)j.info(k,...I)}warn(k,...I){for(const j of this.g)j.warn(k,...I)}error(k,...I){for(const j of this.g)j.error(k,...I)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$hj=c;class o extends O.$Sc{constructor(k,I,j){if(super(),this.h=k,this.j=I,this.b=new C.$Ac,this.c=this.B(new R.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Nd),this.onDidChangeVisibility=this.g.event,j)for(const N of j)this.b.set(N.resource,{logger:void 0,info:N})}m(k){return(0,a.$yf)(k)?[...this.b.values()].find(I=>I.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,I){const j=this.n(k),N=(0,a.$yf)(k)?k:I?.id??(0,s.$Di)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const _=I?.logLevel==="always"?m.Trace:I?.logLevel;z||(z=this.s(j,_??this.getLogLevel(j)??this.h,{...I,id:N}));const Y={logger:z,info:{resource:j,id:N,logLevel:_,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(Y.info),this.b.set(j,Y),z}n(k){return(0,a.$yf)(k)?(0,f.$vg)(this.j,`${k}.log`):k}setLogLevel(k,I){if(g.URI.isUri(k)){const j=k,N=I,z=this.b.get(j);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.h?void 0:N,z.logger?.setLevel(N),this.b.set(z.info.resource,z),this.f.fire([j,N]))}else{this.h=k;for(const[j,N]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,I){const j=this.m(k);j&&I!==!j.info.hidden&&(j.info.hidden=!I,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,I]))}getLogLevel(k){let I;return k&&(I=this.b.get(k)?.info.logLevel),I??this.h}registerLogger(k){const I=this.b.get(k.resource);I?I.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const I=this.b.get(k);I&&(I.logger&&I.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=o;class t{constructor(){this.onDidChangeLogLevel=new R.$Nd().event}setLevel(k){}getLevel(){return m.Info}trace(k,...I){}debug(k,...I){}info(k,...I){}warn(k,...I){}error(k,...I){}critical(k,...I){}dispose(){}flush(){}}e.$jj=t;class n extends t{}e.$kj=n;function r(D){if(D.verbose)return m.Trace;if(typeof D.logLevel=="string"){const k=A(D.logLevel.toLowerCase());if(k!==void 0)return k}return e.$aj}e.$lj=r;function p(D){switch(D){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$mj=p;function A(D){switch(D){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$nj=A,e.$oj=new w.$7i("logLevel",p(m.Info))});var te=this&&this.__param||function(X,e){return function(S,R){e(S,R,X)}};define(ie[220],ne([0,1,15,4,6]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=void 0;const O=S.safeStorage;let C=class{constructor(f){this.a=f,S.app.commandLine.getSwitchValue("password-store")==="basic"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(O.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.a.error(a),a}}async decrypt(f){let a;try{if(a=JSON.parse(f),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const g=Buffer.from(a.data);this.a.trace("[EncryptionMainService] Decrypting value.");const w=O.decryptString(g);return this.a.trace("[EncryptionMainService] Decrypted value."),w}catch(g){throw this.a.error(g),g}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$j)return Promise.resolve("dpapi");if(R.$k)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const f=O.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.$O6b=C,e.$O6b=C=Ee([te(0,s.$0i)],C)}),define(ie[221],ne([0,1,23,8,14,3,2,9,64,6]),function(X,e,S,R,s,O,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class g extends C.$Sc{constructor(y,d){super(),this.a=y,this.b=d,this.c=this.B(new O.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Rg(0)),this.w=[],this.y=this.B(new R.$Rg(0))}watch(y,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(y,d):this.z(y,d)}n(y,d){const v={path:this.H(y),excludes:d.excludes,includes:d.includes,recursive:d.recursive,correlationId:d.correlationId},m=(0,S.$Ub)(this.j,v);return this.r(),(0,C.$Qc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$1)(y))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,f.$Tp)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const d of this.j)(0,f.$Pp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const d of this.j)(0,f.$Pp)(d)&&y.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,d){const v={path:this.H(y),excludes:d.excludes,includes:d.includes,recursive:!1,correlationId:d.correlationId},m=(0,S.$Ub)(this.w,v);return this.C(),(0,C.$Qc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,f.$Tp)(y)),y=>this.G(y),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,P.$hc)(y.fsPath)}}e.$Xp=g}),define(ie[222],ne([0,1,23,8,17,22,3,55,70,2,56,13,65,19,61,175,16,119,6,14]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;let h=class extends a.$Sc{static{E=this}constructor(c){super(),this.b=c,this.a=256*1024,this.c=this.B(new C.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$Nd),this.Y=this.B(new C.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$3g)}registerProvider(c,o){if(this.h.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${c}`);const t=new a.$Rc;return this.h.set(c,o),this.c.fire({added:!0,scheme:c,provider:o}),t.add(o.onDidChangeFile(n=>{const r=new b.$rk(n,!this.S(o));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof o.onDidWatchError=="function"&&t.add(o.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:c}))),(0,a.$Qc)(()=>{this.c.fire({added:!1,scheme:c,provider:o}),this.h.delete(c),(0,a.$Nc)(t)})}getProvider(c){return this.h.get(c)}async activateProvider(c){const o=[];this.f.fire({scheme:c,join(t){o.push(t)}}),!this.h.has(c)&&await R.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.h.has(c.scheme)}hasCapability(c,o){const t=this.h.get(c.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return f.Iterable.map(this.h,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async j(c){if(!(0,d.$zg)(c))throw new b.$tk((0,m.localize)(0,null,this.sb(c)),8);await this.activateProvider(c.scheme);const o=this.h.get(c.scheme);if(!o){const t=new l.$bb;throw t.message=(0,m.localize)(1,null,c.toString()),t}return o}async m(c){const o=await this.j(c);if((0,b.$ek)(o)||(0,b.$bk)(o)||(0,b.$fk)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(c){const o=await this.j(c);if((0,b.$ek)(o)||(0,b.$bk)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.s(c,o)}catch(t){throw(0,b.$ok)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.$tk((0,m.localize)(2,null,this.sb(c)),1):(0,b.$mk)(t)}}async s(c,o){const t=await this.j(c),n=this.S(t),r=o?.resolveTo,p=o?.resolveSingleChildDescendants,A=o?.resolveMetadata,D=await t.stat(c);let k;return this.t(t,c,D,void 0,!!A,(I,j)=>(k||(k=g.$Vh.forUris(()=>!n),k.set(c,!0),r&&k.fill(!0,r)),k.get(I.resource)||k.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&p?j===1:!1))}async t(c,o,t,n,r,p){const{providerExtUri:A}=this.R(c),D={resource:o,name:A.basename(o),isFile:(t.type&b.FileType.File)!==0,isDirectory:(t.type&b.FileType.Directory)!==0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&b.FilePermission.Readonly)||!!(c.capabilities&2048),locked:!!((t.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Ek)({mtime:t.mtime,size:t.size}),children:void 0};if(D.isDirectory&&p(D,n)){try{const k=await c.readdir(o),I=await R.Promises.settled(k.map(async([j,N])=>{try{const z=A.joinPath(o,j),_=r?await c.stat(z):{type:N};return await this.t(c,z,_,k.length,r,p)}catch(z){return this.b.trace(z),null}}));D.children=(0,S.$Hb)(I)}catch(k){this.b.trace(k),D.children=[]}return D}return D}async resolveAll(c){return R.Promises.settled(c.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(c){const o=await this.j(c),t=await o.stat(c);return this.t(o,c,t,void 0,!0,()=>!1)}async exists(c){const o=await this.j(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.u(c,o)}catch(t){return t}return!0}async u(c,o){if(!o?.overwrite&&await this.exists(c))throw new b.$tk((0,m.localize)(3,null,this.sb(c)),3,o)}async createFile(c,o=s.$be.fromString(""),t){await this.u(c,t);const n=await this.writeFile(c,o);return this.r.fire(new b.$qk(c,0,n)),n}async writeFile(c,o,t){const n=this.qb(await this.n(c),c),{providerExtUri:r}=this.R(n);let p=t;if((0,b.$hk)(n)&&!p?.atomic){const A=n.enforceAtomicWriteFile?.(c);A&&(p={...t,atomic:A})}try{await this.w(n,c,p)||await this.U(n,r.dirname(c));let D;if((0,b.$bk)(n)&&!(o instanceof s.$be))if((0,v.$Zd)(o)){const k=await(0,v.$7d)(o,3);k.ended?D=s.$be.concat(k.buffer):D=k}else D=(0,v.$4d)(o,k=>s.$be.concat(k),3);else D=o;!(0,b.$ek)(n)||(0,b.$bk)(n)&&D instanceof s.$be||(0,b.$bk)(n)&&(0,b.$hk)(n)&&p?.atomic?await this.hb(n,c,p,D):await this.db(n,c,p,D instanceof s.$be?(0,s.$me)(D):D),this.r.fire(new b.$qk(c,4))}catch(A){throw new b.$tk((0,m.localize)(4,null,this.sb(c),(0,b.$mk)(A).toString()),(0,b.$pk)(A),p)}return this.resolve(c,{resolveMetadata:!0})}async w(c,o,t){const n=!!t?.unlock;if(n&&!(c.capabilities&8192))throw new Error((0,m.localize)(5,null,this.sb(o)));if(!!t?.atomic){if(!(c.capabilities&32768))throw new Error((0,m.localize)(6,null,this.sb(o)));if(!(c.capabilities&2))throw new Error((0,m.localize)(7,null,this.sb(o)));if(n)throw new Error((0,m.localize)(8,null,this.sb(o)))}let p;try{p=await c.stat(o)}catch{return}if(p.type&b.FileType.Directory)throw new b.$tk((0,m.localize)(9,null,this.sb(o)),0,t);if(this.rb(o,p),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.$Dk&&typeof p.mtime=="number"&&typeof p.size=="number"&&t.mtime<p.mtime&&t.etag!==(0,b.$Ek)({mtime:t.mtime,size:p.size}))throw new b.$tk((0,m.localize)(10,null),3,t);return p}async readFile(c,o,t){const n=await this.m(c);return o?.atomic?this.z(n,c,o,t):this.C(n,c,o,t)}async z(c,o,t,n){return new Promise((r,p)=>{this.cb.queueFor(o,this.R(c).providerExtUri).queue(async()=>{try{const A=await this.C(c,o,t,n);r(A)}catch(A){p(A)}})})}async C(c,o,t,n){const r=await this.D(c,o,{...t,preferUnbuffered:!0},n);return{...r,value:await(0,s.$ne)(r.value)}}async readFileStream(c,o,t){const n=await this.m(c);return this.D(n,c,o,t)}async D(c,o,t,n){const r=new O.$Xd(n);let p=t;(0,b.$gk)(c)&&c.enforceAtomicReadFile?.(o)&&(p={...t,atomic:!0});const A=this.J(o,p).then(k=>k,k=>{throw r.dispose(!0),k});let D;try{return typeof p?.etag=="string"&&p.etag!==b.$Dk&&await A,p?.atomic&&(0,b.$gk)(c)||!((0,b.$ek)(c)||(0,b.$fk)(c))||(0,b.$bk)(c)&&p?.preferUnbuffered?D=this.I(c,o,p):(0,b.$fk)(c)?D=this.G(c,o,r.token,p):D=this.H(c,o,r.token,p),D.on("end",()=>r.dispose()),D.on("error",()=>r.dispose()),{...await A,value:D}}catch(k){throw D&&await(0,v.$5d)(D),this.F(k,o,p)}}F(c,o,t){const n=(0,m.localize)(11,null,this.sb(o),(0,b.$mk)(c).toString());return c instanceof b.$vk?new b.$vk(n,c.stat,t):c instanceof b.$uk?new b.$uk(n,c.fileOperationResult,c.size,c.options):new b.$tk(n,(0,b.$pk)(c),t)}G(c,o,t,n=Object.create(null)){const r=c.readFileStream(o,n,t);return(0,v.$$d)(r,{data:p=>p instanceof s.$be?p:s.$be.wrap(p),error:p=>this.F(p,o,n)},p=>s.$be.concat(p))}H(c,o,t,n=Object.create(null)){const r=(0,s.$re)();return(0,$.$Np)(c,o,r,p=>p,{...n,bufferSize:this.a,errorTransformer:p=>this.F(p,o,n)},t),r}I(c,o,t){const n=(0,v.$2d)(r=>s.$be.concat(r));return(async()=>{try{let r;t?.atomic&&(0,b.$gk)(c)?r=await c.readFile(o,{atomic:!0}):r=await c.readFile(o),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(o,r.byteLength,t),n.end(s.$be.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(c,o){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new b.$tk((0,m.localize)(12,null,this.sb(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==b.$Dk&&o.etag===t.etag)throw new b.$vk((0,m.localize)(13,null),t,o);return this.L(c,t.size,o),t}L(c,o,t){if(typeof t?.limits?.size=="number"&&o>t.limits.size)throw new b.$uk((0,m.localize)(14,null,this.sb(c)),7,o,t)}async canMove(c,o,t){return this.M(c,o,"move",t)}async canCopy(c,o,t){return this.M(c,o,"copy",t)}async M(c,o,t,n){if(c.toString()!==o.toString())try{const r=t==="move"?this.qb(await this.n(c),c):await this.m(c),p=this.qb(await this.n(o),o);await this.Q(r,c,p,o,t,n)}catch(r){return r}return!0}async move(c,o,t){const n=this.qb(await this.n(c),c),r=this.qb(await this.n(o),o),p=await this.N(n,c,r,o,"move",!!t),A=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new b.$qk(c,p==="move"?2:3,A)),A}async copy(c,o,t){const n=await this.m(c),r=this.qb(await this.n(o),o),p=await this.N(n,c,r,o,"copy",!!t),A=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new b.$qk(c,p==="copy"?3:2,A)),A}async N(c,o,t,n,r,p){if(o.toString()===n.toString())return r;const{exists:A,isSameResourceWithDifferentPathCase:D}=await this.Q(c,o,t,n,r,p);if(A&&!D&&p&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),r==="copy"){if(c===t&&(0,b.$ck)(c))await c.copy(o,n,{overwrite:p});else{const k=await this.resolve(o);k.isDirectory?await this.P(c,k,t,n):await this.O(c,o,t,n)}return r}else return c===t?(await c.rename(o,n,{overwrite:p}),r):(await this.N(c,o,t,n,"copy",p),await this.del(o,{recursive:!0}),"copy")}async O(c,o,t,n){if((0,b.$ek)(c)&&(0,b.$ek)(t))return this.jb(c,o,t,n);if((0,b.$ek)(c)&&(0,b.$bk)(t))return this.pb(c,o,t,n);if((0,b.$bk)(c)&&(0,b.$ek)(t))return this.nb(c,o,t,n);if((0,b.$bk)(c)&&(0,b.$bk)(t))return this.lb(c,o,t,n)}async P(c,o,t,n){await t.mkdir(n),Array.isArray(o.children)&&await R.Promises.settled(o.children.map(async r=>{const p=this.R(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(c,await this.resolve(r.resource),t,p):this.O(c,r.resource,t,p)}))}async Q(c,o,t,n,r,p){let A=!1;if(c===t){const{providerExtUri:k,isPathCaseSensitive:I}=this.R(c);if(I||(A=k.isEqual(o,n)),A&&r==="copy")throw new Error((0,m.localize)(15,null,this.sb(o),this.sb(n)));if(!A&&k.isEqualOrParent(n,o))throw new Error((0,m.localize)(16,null,this.sb(o),this.sb(n)))}const D=await this.exists(n);if(D&&!A){if(!p)throw new b.$tk((0,m.localize)(17,null,this.sb(o),this.sb(n)),4);if(c===t){const{providerExtUri:k}=this.R(c);if(k.isEqualOrParent(o,n))throw new Error((0,m.localize)(18,null,this.sb(o),this.sb(n)))}}return{exists:D,isSameResourceWithDifferentPathCase:A}}R(c){const o=this.S(c);return{providerExtUri:o?d.$lg:d.$ng,isPathCaseSensitive:o}}S(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.qb(await this.j(c),c);await this.U(o,c);const t=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new b.$qk(c,0,t)),t}async U(c,o){const t=[],{providerExtUri:n}=this.R(c);for(;!n.isEqual(o,n.dirname(o));)try{if(!((await c.stat(o)).type&b.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(o)));break}catch(r){if((0,b.$ok)(r)!==b.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(o)),o=n.dirname(o)}for(let r=t.length-1;r>=0;r--){o=n.joinPath(o,t[r]);try{await c.mkdir(o)}catch(p){if((0,b.$ok)(p)!==b.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(c,o){try{await this.W(c,o)}catch(t){return t}return!0}async W(c,o){const t=this.qb(await this.j(c),c),n=!!o?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,m.localize)(20,null,this.sb(c)));const r=o?.atomic;if(r&&!(t.capabilities&65536))throw new Error((0,m.localize)(21,null,this.sb(c)));if(n&&r)throw new Error((0,m.localize)(22,null,this.sb(c)));let p;try{p=await t.stat(c)}catch{}if(p)this.rb(c,p);else throw new b.$tk((0,m.localize)(23,null,this.sb(c)),1);if(!!!o?.recursive){const D=await this.resolve(c);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(c)))}return t}async del(c,o){const t=await this.W(c,o);let n=o;if((0,b.$ik)(t)&&!n?.atomic){const D=t.enforceAtomicDelete?.(c);D&&(n={...o,atomic:D})}const r=!!n?.useTrash,p=!!n?.recursive,A=n?.atomic??!1;await t.delete(c,{recursive:p,useTrash:r,atomic:A}),this.r.fire(new b.$qk(c,1))}async cloneFile(c,o){const t=await this.j(c),n=this.qb(await this.n(o),o);if(t===n&&this.R(t).providerExtUri.isEqual(c,o))return;if(t===n&&(0,b.$dk)(t))return t.cloneFile(c,o);await this.U(n,this.R(n).providerExtUri.dirname(o));const r=this.cb.queueFor(c,this.R(t).providerExtUri);return t===n&&(0,b.$ck)(t)?r.queue(()=>t.copy(c,o,{overwrite:!0})):r.queue(()=>this.O(t,c,n,o))}static{this.ab=0}createWatcher(c,o){return this.watch(c,{...o,correlationId:E.ab++})}watch(c,o={recursive:!1,excludes:[]}){const t=new a.$Rc;let n=!1,r=()=>{n=!0};t.add((0,a.$Qc)(()=>r())),(async()=>{try{const A=await this.bb(c,o);n?(0,a.$Nc)(A):r=()=>(0,a.$Nc)(A)}catch(A){this.b.error(A)}})();const p=o.correlationId;if(typeof p=="number"){const A=t.add(new C.$Nd);return t.add(this.X.event(k=>{k.correlates(p)&&A.fire(k)})),{onDidChange:A.event,dispose:()=>t.dispose()}}return t}async bb(c,o){const t=await this.j(c),n=(0,P.$Di)([this.R(t).providerExtUri.getComparisonKey(c),o]);let r=this.$.get(n);return r||(r={count:0,disposable:t.watch(c,o)},this.$.set(n,r)),r.count+=1,(0,a.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,a.$Nc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,c]of this.$)(0,a.$Nc)(c.disposable);this.$.clear()}async db(c,o,t,n){return this.cb.queueFor(o,this.R(c).providerExtUri).queue(async()=>{const r=await c.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,v.$Zd)(n)||(0,v.$1d)(n)?await this.eb(c,r,n):await this.fb(c,r,n)}catch(p){throw(0,b.$mk)(p)}finally{await c.close(r)}})}async eb(c,o,t){let n=0,r;if((0,v.$1d)(t)){if(t.buffer.length>0){const p=s.$be.concat(t.buffer);await this.gb(c,o,p,p.byteLength,n,0),n+=p.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((p,A)=>{(0,v.$6d)(r,{onData:async D=>{r.pause();try{await this.gb(c,o,D,D.byteLength,n,0)}catch(k){return A(k)}n+=D.byteLength,setTimeout(()=>r.resume())},onError:D=>A(D),onEnd:()=>p()})})}async fb(c,o,t){let n=0,r;for(;(r=t.read())!==null;)await this.gb(c,o,r,r.byteLength,n,0),n+=r.byteLength}async gb(c,o,t,n,r,p){let A=0;for(;A<n;){const D=await c.write(o,r+A,t.buffer,p+A,n-A);A+=D}}async hb(c,o,t,n){return this.cb.queueFor(o,this.R(c).providerExtUri).queue(()=>this.ib(c,o,t,n))}async ib(c,o,t,n){let r;n instanceof s.$be?r=n:(0,v.$Zd)(n)?r=await(0,s.$ne)(n):(0,v.$1d)(n)?r=await(0,s.$oe)(n):r=(0,s.$le)(n),await c.writeFile(o,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(c,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(c,o,t,n))}async kb(c,o,t,n){let r,p;try{r=await c.open(o,{create:!1}),p=await t.open(n,{create:!0,unlock:!1});const A=s.$be.alloc(this.a);let D=0,k=0,I=0;do I=await c.read(r,D,A.buffer,k,A.byteLength-k),await this.gb(t,p,A,I,D,k),D+=I,k+=I,k===A.byteLength&&(k=0);while(I>0)}catch(A){throw(0,b.$mk)(A)}finally{await R.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof p=="number"?t.close(p):Promise.resolve()])}}async lb(c,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(c,o,t,n))}async mb(c,o,t,n){return t.writeFile(n,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(c,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(c,o,t,n))}async ob(c,o,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const p=await c.readFile(o);await this.gb(t,r,s.$be.wrap(p),p.byteLength,0,0)}catch(p){throw(0,b.$mk)(p)}finally{await t.close(r)}}async pb(c,o,t,n){const r=await(0,s.$ne)(this.H(c,o,O.CancellationToken.None));await this.hb(t,n,void 0,r)}qb(c,o){if(c.capabilities&2048)throw new b.$tk((0,m.localize)(25,null,this.sb(o)),6);return c}rb(c,o){if((o.permissions??0)&b.FilePermission.Readonly)throw new b.$tk((0,m.localize)(26,null,this.sb(c)),6)}sb(c){return c.scheme===w.Schemas.file?c.fsPath:c.toString(!0)}};e.$Op=h,e.$Op=h=E=Ee([te(0,u.$0i)],h)}),define(ie[92],ne([0,1,45,311,8,31,17,3,33,2,9,4,19,61,21,179,16,119,221,49,217,216]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0,(()=>{try{(0,R.gracefulify)(S)}catch(c){console.error(`Error enabling graceful-fs: ${(0,l.$Ai)(c)}`)}})();class i extends u.$Xp{static{this.I=!1}constructor(o,t){super(o,t),this.onDidChangeCapabilities=P.Event.None,this.N=new O.$Ac(n=>y.$mg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,w.$l&&(this.J|=1024)),this.J}async stat(o){try{const{stat:t,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(o));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:b.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const t=await v.Promises.readdir(this.H(o),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async r=>{try{let p;r.isSymbolicLink()?p=(await this.stat((0,y.$vg)(o,r.name))).type:p=this.M(r),n.push([r.name,p])}catch(p){this.a.trace(p)}})),n}catch(t){throw this.fb(t)}}M(o,t){let n;return t?.dangling?n=b.FileType.Unknown:o.isFile()?n=b.FileType.File:o.isDirectory()?n=b.FileType.Directory:n=b.FileType.Unknown,t&&(n|=b.FileType.SymbolicLink),n}async O(o){const t=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const r=new s.$Sg;return this.N.set(o,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,a.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(o)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),r.open()})}async readFile(o,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),n=await this.O(o));const r=this.H(o);return await v.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(o){i.I&&this.a.trace(o)}readFileStream(o,t,n){const r=(0,d.$2d)(p=>C.$be.concat(p.map(A=>C.$be.wrap(A))).buffer);return(0,$.$Np)(this,o,r,p=>p.buffer,{...t,bufferSize:256*1024},n),r}async writeFile(o,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,y.$vg)((0,y.$ug)(o),`${(0,y.$sg)(o)}${n.atomic.postfix}`),t,n):this.S(o,t,n)}async Q(o){try{const t=this.H(o),{symbolicLink:n}=await v.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(o,t,n,r){const p=new a.$Rc;try{p.add(await this.O(o)),p.add(await this.O(t)),await this.S(t,n,r,!0);try{await this.rename(t,o,{overwrite:!0})}catch(A){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{p.dispose()}}async S(o,t,n,r){let p;try{const A=this.H(o);if(!n.create||!n.overwrite){if(await v.Promises.exists(A)){if(!n.overwrite)throw(0,b.$lk)((0,m.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,b.$lk)((0,m.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(o,{create:!0,unlock:n.unlock},r),await this.write(p,0,t,0,t.byteLength)}catch(A){throw await this.gb(o,A)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(o){i.Y=o}async open(o,t,n){const r=this.H(o);let p;(0,b.$_j)(t)&&!n&&(p=await this.O(o));let A;try{if((0,b.$_j)(t)&&t.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(r);k.mode&128||await v.Promises.chmod(r,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let D;if((0,b.$_j)(t)){if(w.$j)try{await v.Promises.truncate(r,0),D="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}D||(D="w")}else D="r";A=await v.Promises.open(r,D)}catch(D){throw p?.dispose(),(0,b.$_j)(t)?await this.gb(o,D):this.fb(D)}if(this.U.set(A,0),(0,b.$_j)(t)&&this.X.set(A,o),p){const D=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${r})`),this.W.set(A,p),D&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${r})`),D.dispose())}return A}async close(o){const t=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&i.Y)try{await v.Promises.fdatasync(o)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(o)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(o)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),t.dispose())}}async read(o,t,n,r,p){const A=this.Z(o,t);let D=null;try{D=(await v.Promises.read(o,n,r,p,A)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(o,A,D)}return D}Z(o,t){return t===this.U.get(o)?null:t}$(o,t,n){const r=this.U.get(o);typeof r=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(o,r+n):this.U.delete(o)))}async write(o,t,n,r,p){return(0,s.$_g)(()=>this.ab(o,t,n,r,p),100,3)}async ab(o,t,n,r,p){const A=this.Z(o,t);let D=null;try{D=(await v.Promises.write(o,n,r,p,A)).bytesWritten}catch(k){throw await this.gb(this.X.get(o),k)}finally{this.$(o,A,D)}return D}async mkdir(o){try{await v.Promises.mkdir(this.H(o))}catch(t){throw this.fb(t)}}async delete(o,t){try{const n=this.H(o);if(t.recursive){let r;t?.atomic!==!1&&t.atomic.postfix&&(r=(0,g.$jc)((0,g.$mc)(n),`${(0,g.$nc)(n)}${t.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,r)}else try{await v.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let p=!1;try{const{stat:A,symbolicLink:D}=await v.SymlinkSupport.stat(n);p=A.isDirectory()&&!D}catch{}if(p)await v.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(o,t,n){const r=this.H(o),p=this.H(t);if(r!==p)try{await this.bb(o,t,"move",n.overwrite),await v.Promises.rename(r,p)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,m.localize)(2,null,(0,g.$nc)(r),(0,g.$nc)((0,g.$mc)(p)),A.toString()))),this.fb(A)}}async copy(o,t,n){const r=this.H(o),p=this.H(t);if(r!==p)try{await this.bb(o,t,"copy",n.overwrite),await v.Promises.copy(r,p,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,m.localize)(3,null,(0,g.$nc)(r),(0,g.$nc)((0,g.$mc)(p)),A.toString()))),this.fb(A)}}async bb(o,t,n,r){const p=this.H(o),A=this.H(t);let D=!1;if(!!(this.capabilities&1024)||(D=(0,f.$Wf)(p,A,!0)),D){if(n==="copy")throw(0,b.$lk)((0,m.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(o);if(!I)throw(0,b.$lk)((0,m.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(t);if(j){if(!r)throw(0,b.$lk)((0,m.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);I.type&b.FileType.File&&j.type&b.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,t){return this.cb(o,t,!1)}async cb(o,t,n){const r=this.H(o),p=this.H(t),A=!!(this.capabilities&1024);if((0,f.$Wf)(r,p,!A))return;const D=new a.$Rc;try{D.add(await this.O(o)),D.add(await this.O(t)),n&&await v.Promises.mkdir((0,g.$mc)(p),{recursive:!0}),await v.Promises.copyFile(r,p)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(o,t,!0);throw this.fb(k)}finally{D.dispose()}}t(o,t,n){return new E.$5p(r=>o(r),r=>t(r),n)}F(o,t,n){return new h.$aq(r=>o(r),r=>t(r),n)}fb(o){if(o instanceof b.$kk)return o;let t=o,n;switch(o.code){case"ENOENT":n=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=b.FileSystemProviderErrorCode.Unknown;break;default:n=b.FileSystemProviderErrorCode.Unknown}return(0,b.$lk)(t,n)}async gb(o,t){let n=this.fb(t);if(o&&n.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await v.SymlinkSupport.stat(this.H(o));r.mode&128||(n=(0,b.$lk)(t,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$bq=i}),define(ie[223],ne([0,1,3,92,2,17,61,22]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=void 0;class f extends s.$Sc{constructor(w,y){super(),this.a=w,this.b=y,this.F=new Map,this.G=new Map}call(w,y,d){const v=this.c(w);switch(y){case"stat":return this.g(v,d[0]);case"readdir":return this.h(v,d[0]);case"open":return this.r(v,d[0],d[1]);case"close":return this.s(d[0]);case"read":return this.t(d[0],d[1],d[2]);case"readFile":return this.j(v,d[0],d[1]);case"write":return this.u(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.n(v,d[0],d[1],d[2]);case"rename":return this.z(v,d[0],d[1],d[2]);case"copy":return this.C(v,d[0],d[1],d[2]);case"cloneFile":return this.D(v,d[0],d[1]);case"mkdir":return this.w(v,d[0]);case"delete":return this.y(v,d[0],d[1]);case"watch":return this.I(v,d[0],d[1],d[2],d[3]);case"unwatch":return this.J(d[0],d[1])}throw new Error(`IPC Command ${y} not found`)}listen(w,y,d){const v=this.c(w);switch(y){case"fileChange":return this.H(v,d[0]);case"readFileStream":return this.m(v,d[0],d[1])}throw new Error(`Unknown event ${y}`)}g(w,y){const d=this.f(w,y,!0);return this.a.stat(d)}h(w,y){const d=this.f(w,y);return this.a.readdir(d)}async j(w,y,d){const v=this.f(w,y,!0),m=await this.a.readFile(v,d);return O.$be.wrap(m)}m(w,y,d){const v=this.f(w,y,!0),m=new P.$Xd,b=new S.$Nd({onDidRemoveLastListener:()=>{m.cancel()}}),$=this.a.readFileStream(v,d,m.token);return(0,C.$6d)($,{onData:u=>b.fire(O.$be.wrap(u)),onError:u=>b.fire(u),onEnd:()=>{b.fire("end"),b.dispose(),m.dispose()}}),b.event}n(w,y,d,v){const m=this.f(w,y);return this.a.writeFile(m,d.buffer,v)}r(w,y,d){const v=this.f(w,y,!0);return this.a.open(v,d)}s(w){return this.a.close(w)}async t(w,y,d){const v=O.$be.alloc(d),m=0,b=await this.a.read(w,y,v.buffer,m,d);return[v,b]}u(w,y,d,v,m){return this.a.write(w,y,d.buffer,v,m)}w(w,y){const d=this.f(w,y);return this.a.mkdir(d)}y(w,y,d){const v=this.f(w,y);return this.a.delete(v,d)}z(w,y,d,v){const m=this.f(w,y),b=this.f(w,d);return this.a.rename(m,b,v)}C(w,y,d,v){const m=this.f(w,y),b=this.f(w,d);return this.a.copy(m,b,v)}D(w,y,d){const v=this.f(w,y),m=this.f(w,d);return this.a.cloneFile(v,m)}H(w,y){const d=new S.$Nd({onWillAddFirstListener:()=>{this.F.set(y,this.L(w,d))},onDidRemoveLastListener:()=>{(0,s.$Nc)(this.F.get(y)),this.F.delete(y)}});return d.event}async I(w,y,d,v,m){const b=this.F.get(y);if(b){const $=this.f(w,v),u=b.watch(d,$,m);this.G.set(y+d,u)}}async J(w,y){const d=w+y,v=this.G.get(d);v&&((0,s.$Nc)(v),this.G.delete(d))}dispose(){super.dispose();for(const[,w]of this.G)w.dispose();this.G.clear();for(const[,w]of this.F)w.dispose();this.F.clear()}}e.$Jr=f;class a extends s.$Sc{constructor(w,y,d,v){super(),this.c=w,this.f=d,this.g=v,this.a=new Map,this.b=this.B(new R.$bq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(w){const y=this.B(new S.$Nd);this.B(y.event(d=>{w.fire(d.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type,cId:v.cId})))})),this.B(this.b.onDidChangeFile(d=>y.fire(d))),this.B(this.b.onDidWatchError(d=>w.fire(d)))}j(w){}m(w){}watch(w,y,d){const v=this.m(this.g);return Array.isArray(v)&&(d.excludes=[...d.excludes,...v]),this.a.set(w,this.b.watch(y,d)),(0,s.$Qc)(()=>{(0,s.$Nc)(this.a.get(w)),this.a.delete(w)})}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),super.dispose()}}e.$Kr=a}),define(ie[224],ne([0,1,15,178,4,7,16,9,223,155]),function(X,e,S,R,s,O,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W6b=void 0;class g extends f.$Jr{constructor(d,v,m){super(d,v),this.M=m}c(d){return a.$Mm}f(d,v){return O.URI.revive(v)}async y(d,v,m){if(!m.useTrash)return super.y(d,v,m);const b=this.f(d,v),$=(0,P.$hc)(b.fsPath);try{await S.shell.trashItem($)}catch{throw(0,C.$lk)(s.$j?(0,R.localize)(0,null,(0,P.$nc)($)):(0,R.localize)(1,null,(0,P.$nc)($)),C.FileSystemProviderErrorCode.Unknown)}}L(d,v){return new w(d,v,this.b,this.M)}}e.$W6b=g;class w extends f.$Kr{watch(d,v,m){if(m.recursive)throw(0,C.$lk)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(d,v,m)}}}),define(ie[225],ne([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U3b=void 0;class R extends S.$dj{constructor(O=S.$aj){super(),this.m=[],this.n=void 0,this.setLevel(O),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(O){this.n=O;for(const{level:C,message:P}of this.m)(0,S.log)(O,C,P);this.m=[]}g(O,C){this.n?(0,S.log)(this.n,O,C):this.getLevel()<=O&&this.m.push({level:O,message:C})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$U3b=R}),define(ie[226],ne([0,1,7,3,6,2]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=void 0;class C extends s.$ij{constructor(w,y,d,v,m){super(y,d,v),this.r=w,this.t=m,this.B(m.listen("onDidChangeLogLevel",w)(b=>{(0,s.$_i)(b)?super.setLogLevel(b):super.setLogLevel(S.URI.revive(b[0]),b[1])})),this.B(m.listen("onDidChangeVisibility",w)(([b,$])=>super.setVisibility(S.URI.revive(b),$))),this.B(m.listen("onDidChangeLoggers",w)(({added:b,removed:$})=>{for(const u of b)super.registerLogger({...u,resource:S.URI.revive(u.resource)});for(const u of $)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new s.$gj({log:(w,y)=>{this.t.call("consoleLog",[w,y])}})}registerLogger(w){super.registerLogger(w),this.t.call("registerLogger",[w,this.r])}deregisterLogger(w){super.deregisterLogger(w),this.t.call("deregisterLogger",[w,this.r])}setLogLevel(w,y){super.setLogLevel(w,y),this.t.call("setLogLevel",[w,y])}setVisibility(w,y){super.setVisibility(w,y),this.t.call("setVisibility",[this.n(w),y])}s(w,y,d){return new P(this.t,w,y,d,this.r)}static setLogLevel(w,y,d){return w.call("setLogLevel",[y,d])}}e.$_q=C;class P extends s.$dj{constructor(w,y,d,v,m){super(v?.logLevel==="always"),this.r=w,this.s=y,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[y,v,m]).then(()=>{this.u(this.n),this.m=!0})}g(w,y){const d=[[w,y]];this.m?this.u(d):this.n.push(...d)}u(w){this.r.call("log",[this.s,w])}}class f{constructor(w,y){this.a=w,this.b=y}listen(w,y){const d=this.b(w);switch(y){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(m=>this.c(m,d)),removed:[...v.removed].map(m=>this.c(m,d))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,v=>[d.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,v=>(0,s.$_i)(v)?v:[d.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${y}`)}async call(w,y,d){const v=this.b(w);switch(y){case"setLogLevel":return(0,s.$_i)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(S.URI.revive(v.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,v)))}throw new Error(`Call not found: ${y}`)}c(w,y){return{...w,resource:y.transformOutgoingURI(w.resource)}}}e.$ar=f;class a extends O.$Sc{constructor(w,y){super(),y.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(d=>y.call("setLogLevel",[d]))),y.call("getRegisteredLoggers").then(d=>{for(const v of d)w.registerLogger({...v,resource:S.URI.revive(v.resource)})}),this.B(y.listen("onDidChangeVisibility")(([d,v])=>w.setVisibility(S.URI.revive(d),v))),this.B(y.listen("onDidChangeLoggers")(({added:d,removed:v})=>{for(const m of d)w.registerLogger({...m,resource:S.URI.revive(m.resource)});for(const m of v)w.deregisterLogger(m.resource)}))}}e.$br=a}),define(ie[227],ne([0,1,2,6]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;class s extends S.$Sc{constructor(C,P=[]){super(),this.a=new R.$hj([C,...P]),this.B(C.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.$EN=s}),define(ie[228],ne([0,1,31,7,6]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=void 0;class O{constructor(P){this.b=P,this.a=new S.$Ac}listen(P,f,a){switch(f){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(P,f,a){switch(f){case"createLogger":this.c(R.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(R.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,s.$_i)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(R.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:R.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(a[0]))}throw new Error(`Call not found: ${f}`)}c(P,f,a){this.a.set(P,this.b.createLogger(P,f,a))}d(P,f){let a=console.log;switch(P){case s.LogLevel.Error:a=console.error;break;case s.LogLevel.Warning:a=console.warn;break;case s.LogLevel.Info:a=console.info;break}a.call(console,...f)}e(P,f){const a=this.a.get(P);if(!a)throw new Error("Create the logger before logging");for(const[g,w]of f)(0,s.log)(a,g,w)}}e.$X7b=O}),define(ie[229],ne([0,1,16,6]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=void 0;var s;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(s||(s={}));async function O(a,g,w,y,d){try{const v=await new Promise((b,$)=>{X(["@vscode/spdlog"],b,$)});v.setFlushOn(s.Trace);const m=await v.createAsyncRotatingLogger(a,g,w,y);return d?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(v){console.error(v)}return null}function C(a,g,w){switch(g){case R.LogLevel.Trace:a.trace(w);break;case R.LogLevel.Debug:a.debug(w);break;case R.LogLevel.Info:a.info(w);break;case R.LogLevel.Warning:a.warn(w);break;case R.LogLevel.Error:a.error(w);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function P(a,g){switch(g){case R.LogLevel.Trace:a.setLevel(s.Trace);break;case R.LogLevel.Debug:a.setLevel(s.Debug);break;case R.LogLevel.Info:a.setLevel(s.Info);break;case R.LogLevel.Warning:a.setLevel(s.Warning);break;case R.LogLevel.Error:a.setLevel(s.Error);break;case R.LogLevel.Off:a.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class f extends R.$dj{constructor(g,w,y,d,v){super(),this.m=[],this.setLevel(v),this.n=this.s(g,w,y,d),this.B(this.onDidChangeLogLevel(m=>{this.r&&P(this.r,m)}))}async s(g,w,y,d){const v=y?6:1,m=30/v*S.$Gk.MB,b=await O(g,w,m,v,d);if(b){this.r=b,P(this.r,this.getLevel());for(const{level:$,message:u}of this.m)C(this.r,$,u);this.m=[]}}g(g,w){this.r?C(this.r,g,w):this.getLevel()<=g&&this.m.push({level:g,message:w})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$tN=f}),define(ie[230],ne([0,1,32,6,229]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;class O extends R.$ij{s(P,f,a){return new s.$tN((0,S.$eg)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,f)}}e.$uN=O}),define(ie[66],ne([0,1,31,3,5,6,230]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=e.$26b=void 0,e.$26b=(0,s.$Qh)(O.$$i);class P extends C.$uN{constructor(){super(...arguments),this.u=new S.$Ac}createLogger(a,g,w){w!==void 0&&this.u.set(this.n(a),w);try{return super.createLogger(a,g)}catch(y){throw this.u.delete(this.n(a)),y}}registerLogger(a,g){g!==void 0&&this.u.set(a.resource,g),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const g=[];for(const w of super.getRegisteredLoggers())a===this.u.get(w.resource)&&g.push(w);return g}getOnDidChangeLogLevelEvent(a){return R.Event.filter(this.onDidChangeLogLevel,g=>(0,O.$_i)(g)||this.w(g[0],a))}getOnDidChangeVisibilityEvent(a){return R.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,a))}getOnDidChangeLoggersEvent(a){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(y=>this.w(y.resource,a)),removed:[...g.removed].filter(y=>this.w(y.resource,a))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(a){for(const[g,w]of this.u)w===a&&this.deregisterLogger(g)}w(a,g){const w=this.u.get(a);return w===void 0||w===g}dispose(){super.dispose(),this.u.clear()}}e.$36b=P}),define(ie[231],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=e.$f7b=e.$e7b=e.$d7b=void 0;function S(C){return C.submenu!==void 0}e.$d7b=S;function R(C){return C.id==="vscode.menubar.separator"}e.$e7b=R;function s(C){return C.uri!==void 0}e.$f7b=s;function O(C){return!S(C)&&!R(C)&&!s(C)}e.$g7b=O}),define(ie[39],ne([0,1,3,70,2,5]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=void 0,e.$in=(0,O.$Ph)("policy");class C extends s.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const g=Object.keys(this.f).length;return this.f={...a,...this.f},g!==Object.keys(this.f).length&&await this.j(a),R.Iterable.reduce(this.g.entries(),(w,[y,d])=>({...w,[y]:d}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(a,[g,w])=>({...a,[g]:{definition:w,value:this.g.get(g)}}),{})}}e.$jn=C;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$kn=P}),define(ie[232],ne([0,1,8,3,70,12,16,6,39]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=void 0;function a(w,y){const d=[];for(const v of new Set(s.Iterable.concat(w.keys(),y.keys())))w.get(v)!==y.get(v)&&d.push(v);return d}let g=class extends f.$jn{constructor(y,d,v){super(),this.m=y,this.n=d,this.s=v,this.c=this.B(new S.$Rg(500));const m=R.Event.filter(d.onDidFilesChange,b=>b.affects(y));this.B(d.watch(y)),this.B(m(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const d=await this.n.readFile(this.m),v=JSON.parse(d.value.toString());if(!(0,O.$Af)(v))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(v))this.f[m]&&y.set(m,v[m])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return y}async w(){const y=await this.u(),d=a(this.g,y);this.g=y,d.length>0&&this.h.fire(d)}};e.$e8b=g,e.$e8b=g=Ee([te(1,C.$$j),te(2,P.$0i)],g)}),define(ie[233],ne([0,1,3,2,39]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=e.$O7b=void 0;class O{constructor(f){this.b=f,this.a=new R.$Rc}listen(f,a){switch(a){case"onDidChange":return S.Event.map(this.b.onDidChange,g=>g.reduce((w,y)=>({...w,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(f,a,g){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$O7b=O;class C extends s.$jn{constructor(f,a){super(),this.a=a;for(const g in f){const{definition:w,value:y}=f[g];this.f[g]=w,y!==void 0&&this.g.set(g,y)}this.a.listen("onDidChange")(g=>{for(const w in g){const y=g[w];y===null?this.g.delete(w):this.g.set(w,y)}this.h.fire(Object.keys(g))})}async j(f){const a=await this.a.call("updatePolicyDefinitions",f);for(const g in a)this.g.set(g,a[g])}}e.$P7b=C}),define(ie[234],ne([0,1,39,8,312,2,6]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=void 0;let P=class extends S.$jn{constructor(a,g){super(),this.m=a,this.n=g,this.a=new R.$Ng,this.b=this.B(new O.$Tc)}async j(a){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.a.queue(()=>new Promise((g,w)=>{try{this.b.value=(0,s.createWatcher)(this.n,a,y=>{this.t(y),g()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),w(y)}}))}t(a){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const g in a){const w=a[g];w===void 0?this.g.delete(g):this.g.set(g,w)}this.h.fire(Object.keys(a))}};e.$d8b=P,e.$d8b=P=Ee([te(0,C.$0i)],P)}),define(ie[78],ne([0,1,4,35]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof S.$h.vscode<"u"&&typeof S.$h.vscode.context<"u"){const O=S.$h.vscode.context.configuration();if(O)s=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:O.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ie[24],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,S.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"}),define(ie[235],ne([0,1,8,6]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z6b=void 0;let s=class{constructor(C,P,f){this.a=C,this.b=P,this.c=f}async inspect(C){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$Ug)(C);const f=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$Z6b=s,e.$Z6b=s=Ee([te(2,R.$0i)],s)}),define(ie[79],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=void 0,e.$16b=(0,S.$Ph)("protocolMainService")}),define(ie[43],ne([0,1,137,12]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class s{constructor(){this.a=new Map}add(C,P){S.ok(R.$yf(C)),S.ok(R.$Af(P)),S.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$gn=new s}),define(ie[236],ne([0,1,3,43]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class O{constructor(){this.b=new S.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,a){this.a[s(f)]=a,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const C=new O;R.$gn.add(e.$hn.JSONContribution,C)}),define(ie[57],ne([0,1,23,3,12,163,18,236,43]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var a;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$ln={Configuration:"base.contributions.configuration"};var g;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const w=f.$gn.as(P.$hn.JSONContribution);class y{constructor(){this.h=new Set,this.i=new R.$Nd,this.onDidSchemaChange=this.i.event,this.j=new R.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(i,c=!0){this.registerConfigurations([i],c)}registerConfigurations(i,c=!0){const o=new Set;this.n(i,c,o),w.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(i){const c=new Set;this.o(i,c),w.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:i,remove:c}){const o=new Set;this.o(c,o),this.n(i,!1,o),w.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(i){const c=new Set;this.k(i,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(i,c){const o=[];for(const{overrides:t,source:n}of i)for(const r in t)if(c.add(r),e.$vn.test(r)){const p=this.a.get(r),A=p?.valuesSources??new Map;if(n)for(const j of Object.keys(t[r]))A.set(j,n);const D={...p?.value||{},...t[r]};this.a.set(r,{source:n,value:D,valuesSources:A});const k=(0,C.$ti)(r),I={type:"object",default:D,description:O.localize(1,null,k),$ref:e.$sn,defaultDefaultValue:D,source:s.$yf(n)?void 0:n,defaultValueSource:n};o.push(...m(r)),this.d[r]=I,this.b.properties[r]=I}else{this.a.set(r,{value:t[r],source:n});const p=this.d[r];p&&(this.w(r,p),this.r(r,p))}this.m(o)}deregisterDefaultConfigurations(i){const c=new Set;this.l(i,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(i,c){for(const{overrides:o,source:t}of i)for(const n in o){const r=this.a.get(n),p=s.$yf(t)?t:t?.id,A=s.$yf(r?.source)?r?.source:r?.source?.id;if(p===A)if(c.add(n),this.a.delete(n),e.$vn.test(n))delete this.d[n],delete this.b.properties[n];else{const D=this.d[n];D&&(this.w(n,D),this.r(n,D))}}this.u()}deltaConfiguration(i){let c=!1;const o=new Set;i.removedDefaults&&(this.l(i.removedDefaults,o),c=!0),i.addedDefaults&&(this.k(i.addedDefaults,o),c=!0),i.removedConfigurations&&this.o(i.removedConfigurations,o),i.addedConfigurations&&this.n(i.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const c of i)this.h.add(c);this.u()}n(i,c,o){i.forEach(t=>{this.p(t,c,t.extensionInfo,t.restrictedProperties,void 0,o),this.c.push(t),this.q(t)})}o(i,c){const o=t=>{if(t.properties)for(const n in t.properties){c.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>o(n))};for(const t of i){o(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,c=!0,o,t,n=3,r){n=s.$Hf(i.scope)?n:i.scope;const p=i.properties;if(p)for(const D in p){const k=p[D];if(c&&l(D,k)){delete p[D];continue}if(k.source=o,k.defaultDefaultValue=p[D].default,this.w(D,k),e.$vn.test(D)?k.scope=void 0:(k.scope=s.$Hf(k.scope)?n:k.scope,k.restricted=s.$Hf(k.restricted)?!!t?.includes(D):k.restricted),p[D].hasOwnProperty("included")&&!p[D].included){this.f[D]=p[D],delete p[D];continue}else this.d[D]=p[D],p[D].policy?.name&&this.e.set(p[D].policy.name,D);!p[D].deprecationMessage&&p[D].markdownDeprecationMessage&&(p[D].deprecationMessage=p[D].markdownDeprecationMessage),r.add(D)}const A=i.allOf;if(A)for(const D of A)this.p(D,c,o,t,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const c=o=>{const t=o.properties;if(t)for(const r in t)this.r(r,t[r]);o.allOf?.forEach(c)};c(i)}r(i,c){switch(e.$mn.properties[i]=c,c.scope){case 1:e.$nn.properties[i]=c;break;case 2:e.$on.properties[i]=c;break;case 6:e.$pn.properties[i]=c;break;case 3:e.$qn.properties[i]=c;break;case 4:e.$rn.properties[i]=c;break;case 5:e.$rn.properties[i]=c,this.g.properties[i]=c;break}}s(i,c){switch(delete e.$mn.properties[i],c.scope){case 1:delete e.$nn.properties[i];break;case 2:delete e.$on.properties[i];break;case 6:delete e.$pn.properties[i];break;case 3:delete e.$qn.properties[i];break;case 4:case 5:delete e.$rn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const c=`[${i}]`,o={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$sn};this.w(c,o),e.$mn.properties[c]=o,e.$nn.properties[c]=o,e.$on.properties[c]=o,e.$pn.properties[c]=o,e.$qn.properties[c]=o,e.$rn.properties[c]=o}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=i,e.$nn.patternProperties[e.$un]=i,e.$on.patternProperties[e.$un]=i,e.$pn.patternProperties[e.$un]=i,e.$qn.patternProperties[e.$un]=i,e.$rn.patternProperties[e.$un]=i,this.i.fire()}w(i,c){const o=this.a.get(i);let t=o?.value,n=o?.source;s.$Ff(t)&&(t=c.defaultDefaultValue,n=void 0),s.$Ff(t)&&(t=$(c.type)),c.default=t,c.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",v=new RegExp(d,"g");e.$un=`^(${d})+$`,e.$vn=new RegExp(e.$un);function m(h){const i=[];if(e.$vn.test(h)){let c=v.exec(h);for(;c?.length;){const o=c[1].trim();o&&i.push(o),c=v.exec(h)}}return(0,S.$Mb)(i)}e.$wn=m;function b(h){return h.reduce((i,c)=>`${i}[${c}]`,"")}e.$xn=b;function $(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=$;const u=new y;f.$gn.add(e.$ln.Configuration,u);function l(h,i){return h.trim()?e.$vn.test(h)?O.localize(7,null,h):u.getConfigurationProperties()[h]!==void 0?O.localize(8,null,h):i.policy?.name&&u.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,h,i.policy?.name,u.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}e.$zn=l;function E(){const h=[],i=u.getConfigurationProperties();for(const c of Object.keys(i))h.push([c,i[c].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$An=E}),define(ie[120],ne([0,1,23,3,44,2,31,37,12,7,18,57,43]),function(X,e,S,R,s,O,C,P,f,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function d(c){return Object.isFrozen(c)?c:P.$8m(c)}class v{constructor(o={},t=[],n=[],r){this.b=o,this.c=t,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(t=>{if(t instanceof v)return t;const n=new m("");return n.parseRaw(t),n.configurationModel});this.f=o.reduce((t,n)=>n===t?n:t.merge(n),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,g.$ri)(this.contents,o):this.contents}inspect(o,t){const n=this.rawConfiguration.getValue(o),r=t?this.rawConfiguration.getOverrideValue(o,t):void 0,p=t?this.rawConfiguration.override(t).getValue(o):n;return{value:n,override:r,merged:p}}getOverrideValue(o,t){const n=this.i(t);return n?o?(0,g.$ri)(n,o):n:void 0}getKeysForOverrideIdentifier(o){const t=[];for(const n of this.overrides)n.identifiers.includes(o)&&t.push(...n.keys);return S.$Mb(t)}getAllOverrideIdentifiers(){const o=[];for(const t of this.overrides)o.push(...t.identifiers);return S.$Mb(o)}override(o){let t=this.a.get(o);return t||(t=this.g(o),this.a.set(o,t)),t}merge(...o){const t=P.$7m(this.contents),n=P.$7m(this.overrides),r=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const A of o)if(p.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(t,A.contents);for(const D of A.overrides){const[k]=n.filter(I=>S.$ub(I.identifiers,D.identifiers));k?(this.h(k.contents,D.contents),k.keys.push(...D.keys),k.keys=S.$Mb(k.keys)):n.push(P.$7m(D))}for(const D of A.keys)r.indexOf(D)===-1&&r.push(D)}return new v(t,r,n,p.every(A=>A instanceof v)?void 0:p)}g(o){const t=this.i(o);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const r of S.$Mb([...Object.keys(this.contents),...Object.keys(t)])){let p=this.contents[r];const A=t[r];A&&(typeof p=="object"&&typeof A=="object"?(p=P.$7m(p),this.h(p,A)):p=A),n[r]=p}return new v(n,this.keys,this.overrides)}h(o,t){for(const n of Object.keys(t)){if(n in o&&f.$Af(o[n])&&f.$Af(t[n])){this.h(o[n],t[n]);continue}o[n]=P.$7m(t[n])}}i(o){let t=null,n=null;const r=p=>{p&&(n?this.h(n,p):n=P.$7m(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===o?t=p.contents:p.identifiers.includes(o)&&r(p.contents);return r(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,t){this.j(o,t,!0)}setValue(o,t){this.j(o,t,!1)}removeValue(o){const t=this.keys.indexOf(o);t!==-1&&(this.keys.splice(t,1),(0,g.$qi)(this.contents,o),w.$vn.test(o)&&this.overrides.splice(this.overrides.findIndex(n=>S.$ub(n.identifiers,(0,w.$wn)(o))),1))}j(o,t,n){(0,g.$pi)(this.contents,o,t,r=>console.error(r)),n=n||this.keys.indexOf(o)===-1,n&&this.keys.push(o),w.$vn.test(o)&&this.overrides.push({identifiers:(0,w.$wn)(o),keys:Object.keys(this.contents[o]),contents:(0,g.$oi)(this.contents[o],r=>console.error(r))})}}e.$Bn=v;class m{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,t){if(!f.$Hf(o)){const n=this.g(o);this.parseRaw(n,t)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,t){this.a=o;const{contents:n,keys:r,overrides:p,restricted:A,hasExcludedProperties:D}=this.h(o,t);this.b=new v(n,r,p,D?[o]:void 0),this.c=A||[]}g(o){let t={},n=null,r=[];const p=[],A=[];function D(I){Array.isArray(r)?r.push(I):n!==null&&(r[n]=I)}const k={onObjectBegin:()=>{const I={};D(I),p.push(r),r=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{r=p.pop()},onArrayBegin:()=>{const I=[];D(I),p.push(r),r=I,n=null},onArrayEnd:()=>{r=p.pop()},onLiteralValue:D,onError:(I,j,N)=>{A.push({error:I,offset:j,length:N})}};if(o)try{s.$4m(o,k),t=r[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return t}h(o,t){const n=y.$gn.as(w.$ln.Configuration).getConfigurationProperties(),r=this.i(o,n,!0,t);o=r.raw;const p=(0,g.$oi)(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),A=Object.keys(o),D=this.j(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:p,keys:A,overrides:D,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(o,t,n,r){let p=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:p};const A={},D=[];for(const k in o)if(w.$vn.test(k)&&n){const I=this.i(o[k],t,!1,r);A[k]=I.raw,p=p||I.hasExcludedProperties,D.push(...I.restricted)}else{const I=t[k],j=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&D.push(k),!r.exclude?.includes(k)&&(r.include?.includes(k)||(j===void 0||r.scopes===void 0||r.scopes.includes(j))&&!(r.skipRestricted&&I?.restricted))?A[k]=o[k]:p=!0}return{raw:A,restricted:D,hasExcludedProperties:p}}j(o,t){const n=[];for(const r of Object.keys(o))if(w.$vn.test(r)){const p={};for(const A in o[r])p[A]=o[r][A];n.push({identifiers:(0,w.$wn)(r),keys:Object.keys(p),contents:(0,g.$oi)(p,t)})}return n}}e.$Cn=m;class b extends O.$Sc{constructor(o,t,n,r){super(),this.c=o,this.f=t,this.g=r,this.b=this.B(new R.$Nd),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&n.isEqual(p.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=b;class ${constructor(o,t,n,r,p,A,D,k,I,j,N,z,_){this.a=o,this.b=t,this.c=n,this.overrideIdentifiers=r,this.d=p,this.f=A,this.g=D,this.h=k,this.i=I,this.j=j,this.k=N,this.l=z,this.m=_}get value(){return d(this.c)}n(o,t,n){const r=o.inspect(t,n);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(o,t,n,r,p=new v,A=new v,D=new C.$Ac,k=new v,I=new C.$Ac){this.c=o,this.d=t,this.f=n,this.g=r,this.h=p,this.i=A,this.j=D,this.l=k,this.m=I,this.a=null,this.b=new C.$Ac,this.n=null}getValue(o,t,n){return this.q(o,t,n).getValue(o)}updateValue(o,t,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new v,this.m.set(n.resource,r))):r=this.l,t===void 0?r.removeValue(o):r.setValue(o,t),n.resource||(this.a=null)}inspect(o,t,n){const r=this.q(o,t,n),p=this.u(t.resource,n),A=t.resource?this.m.get(t.resource)||this.l:this.l,D=new Set;for(const k of r.overrides)for(const I of k.identifiers)r.getOverrideValue(o,I)!==void 0&&D.add(I);return new $(o,t,r.getValue(o),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,p||void 0,A)}keys(o){const t=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,t){this.j.set(o,t),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,t){const n=[];if(!t){const{added:r,updated:p,removed:A}=h(this.c,o);t=[...r,...p,...A]}for(const r of t)for(const p of(0,w.$wn)(r)){const A=this.c.getKeysForOverrideIdentifier(p),D=o.getKeysForOverrideIdentifier(p),k=[...D.filter(I=>A.indexOf(I)===-1),...A.filter(I=>D.indexOf(I)===-1),...A.filter(I=>!P.$$m(this.c.override(p).getValue(I),o.override(p).getValue(I)))];n.push([p,k])}return this.updateDefaultConfiguration(o),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(o){const{added:t,updated:n,removed:r}=h(this.d,o),p=[...t,...n,...r];return p.length&&this.updatePolicyConfiguration(o),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.applicationConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateApplicationConfiguration(o),{keys:A,overrides:p}}compareAndUpdateLocalUserConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.localUserConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateLocalUserConfiguration(o),{keys:A,overrides:p}}compareAndUpdateRemoteUserConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.remoteUserConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateRemoteUserConfiguration(o),{keys:A,overrides:p}}compareAndUpdateWorkspaceConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.workspaceConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateWorkspaceConfiguration(o),{keys:A,overrides:p}}compareAndUpdateFolderConfiguration(o,t){const n=this.p.get(o),{added:r,updated:p,removed:A,overrides:D}=h(n,t),k=[...r,...p,...A];return(k.length||!n)&&this.updateFolderConfiguration(o,t),{keys:k,overrides:D}}compareAndDeleteFolderConfiguration(o){const t=this.p.get(o);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:n,updated:r,removed:p,overrides:A}=h(t,void 0);return{keys:[...n,...r,...p],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,t,n){let r=this.r(t,n);return t.overrideIdentifier&&(r=r.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(r=r.merge(this.d)),r}r({resource:o},t){let n=this.s();if(t&&o){const r=t.getFolder(o);r&&(n=this.t(r.uri)||n);const p=this.m.get(o);p&&(n=n.merge(p))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let t=this.b.get(o);if(!t){const n=this.s(),r=this.j.get(o);r?(t=n.merge(r),this.b.set(o,t)):t=n}return t}u(o,t){if(t&&o){const n=t.getFolder(o);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,t)=>{const{contents:n,overrides:r,keys:p}=this.j.get(t);return o.push([t,{contents:n,overrides:r,keys:p}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(t=>o.add(t)),this.userConfiguration.keys.forEach(t=>o.add(t)),this.i.keys.forEach(t=>o.add(t)),this.j.forEach(t=>t.keys.forEach(n=>o.add(n))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>o.add(n))),[...o.values()]}w(o){const t=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r))),[...t.values()]}static parse(o){const t=this.x(o.defaults),n=this.x(o.policy),r=this.x(o.application),p=this.x(o.user),A=this.x(o.workspace),D=o.folders.reduce((k,I)=>(k.set(a.URI.revive(I[0]),this.x(I[1])),k),new C.$Ac);return new u(t,n,r,p,new v,A,D,new v,new C.$Ac)}static x(o){return new v(o.contents,o.keys,o.overrides)}}e.$En=u;function l(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const o=new Set,t=new Map;for(const r of c)r.keys.forEach(p=>o.add(p)),r.overrides.forEach(([p,A])=>{const D=(0,C.$xc)(t,p,new Set);A.forEach(k=>D.add(k))});const n=[];return t.forEach((r,p)=>n.push([p,[...r.values()]])),{keys:[...o.values()],overrides:n}}e.$Fn=l;class E{constructor(o,t,n,r){this.change=o,this.f=t,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const p of o.keys)this.affectedKeys.add(p);for(const[,p]of o.overrides)for(const A of p)this.affectedKeys.add(A);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(o,t){const n=this.a+o,r=this.d.indexOf(n);if(r<0)return!1;const p=r+n.length;if(p>=this.d.length)return!1;const A=this.d.charCodeAt(p);if(A!==this.b&&A!==this.c)return!1;if(t){const D=this.previousConfiguration?this.previousConfiguration.getValue(o,t,this.f?.workspace):void 0,k=this.g.getValue(o,t,this.h);return!P.$$m(D,k)}return!0}}e.$Gn=E;function h(c,o){const{added:t,removed:n,updated:r}=i(o?.rawConfiguration,c?.rawConfiguration),p=[],A=c?.getAllOverrideIdentifiers()||[],D=o?.getAllOverrideIdentifiers()||[];if(o){const k=D.filter(I=>!A.includes(I));for(const I of k)p.push([I,o.getKeysForOverrideIdentifier(I)])}if(c){const k=A.filter(I=>!D.includes(I));for(const I of k)p.push([I,c.getKeysForOverrideIdentifier(I)])}if(o&&c){for(const k of A)if(D.includes(k)){const I=i({contents:c.getOverrideValue(void 0,k)||{},keys:c.getKeysForOverrideIdentifier(k)},{contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)});p.push([k,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:n,updated:r,overrides:p}}function i(c,o){const t=c?o?c.keys.filter(p=>o.keys.indexOf(p)===-1):[...c.keys]:[],n=o?c?o.keys.filter(p=>c.keys.indexOf(p)===-1):[...o.keys]:[],r=[];if(c&&o){for(const p of o.keys)if(c.keys.indexOf(p)!==-1){const A=(0,g.$ri)(o.contents,p),D=(0,g.$ri)(c.contents,p);P.$$m(A,D)||r.push(p)}}return{added:t,removed:n,updated:r}}}),define(ie[237],ne([0,1,23,3,2,37,12,120,57,6,39,43]),function(X,e,S,R,s,O,C,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=void 0;class y extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Bn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.$gn.as(f.$ln.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:$})=>this.c(Array.from(b),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(b,$){this.h(b,w.$gn.as(f.$ln.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}g(){this.b=new P.$Bn;const b=w.$gn.as(f.$ln.Configuration).getConfigurationProperties();this.h(Object.keys(b),b)}h(b,$){const u=this.f();for(const l of b){const E=u[l],h=$[l];E!==void 0?this.b.addValue(l,E):h?this.b.addValue(l,h.default):this.b.removeValue(l)}}}e.$Hn=y;class d{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new P.$Bn}async initialize(){return this.configurationModel}}e.$In=d;let v=class extends s.$Sc{get configurationModel(){return this.b}constructor(b,$,u){super(),this.c=b,this.f=$,this.g=u,this.a=this.B(new R.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Bn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const $={},u=[],l=w.$gn.as(f.$ln.Configuration).getConfigurationProperties();for(const E of b){const h=l[E];if(!h){u.push(E);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.g.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}u.push(E),$[h.policy.name]={type:h.type}}}return(0,C.$Lf)($)||await this.f.updatePolicyDefinitions($),u}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const $=w.$gn.as(f.$ln.Configuration).getPolicyConfigurations(),u=(0,S.$Hb)(b.map(l=>$.get(l)));this.m(u,!0)}m(b,$){this.g.trace("PolicyConfiguration#update",b);const u=w.$gn.as(f.$ln.Configuration).getConfigurationProperties(),l=[],E=this.b.isEmpty();for(const h of b){const i=u[h]?.policy?.name;if(i){const c=this.f.getPolicyValue(i);(E?c!==void 0:!(0,O.$$m)(this.b.getValue(h),c))&&l.push([h,c])}else this.b.getValue(h)!==void 0&&l.push([h,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const h=this.b;this.b=new P.$Bn;for(const i of h.keys)this.b.setValue(i,h.getValue(i));for(const[i,c]of l)c===void 0?this.b.removeValue(i):this.b.setValue(i,c);$&&this.a.fire(this.b)}}};e.$Jn=v,e.$Jn=v=Ee([te(1,g.$in),te(2,a.$0i)],v)}),define(ie[238],ne([0,1,8,3,2,19,18,120,237,39]),function(X,e,S,R,s,O,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class g extends s.$Sc{constructor(y,d,v,m){super(),this.j=y,this.h=this.B(new R.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$Hn),this.c=v instanceof a.$kn?new f.$In:this.B(new f.$Jn(this.b,v,m)),this.f=this.B(new P.$Dn(this.j,{},O.$mg,d)),this.a=new P.$En(this.b.configurationModel,this.c.configurationModel,new P.$Bn,new P.$Bn),this.g=this.B(new S.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:b,properties:$})=>this.n(b,$))),this.B(this.c.onDidChangeConfiguration(b=>this.r(b))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,d,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$En(y,d,new P.$Bn,v)}getConfigurationData(){return this.a.toData()}getValue(y,d){const v=typeof y=="string"?y:void 0,m=(0,C.$ki)(y)?y:(0,C.$ki)(d)?d:{};return this.a.getValue(v,m,void 0)}updateValue(y,d,v,m){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.m(y)}m(y){const d=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(y);this.s(v,d,2)}n(y,d){const v=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(y,d);this.s(m,v,7)}r(y){const d=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(y);this.s(v,d,7)}s(y,d,v){const m=new P.$Gn(y,{data:d},this.a);m.source=v,m.sourceConfig=this.t(v),this.h.fire(m)}t(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Kn=g}),define(ie[239],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=e.$47b=e.$37b=void 0,e.$37b="request",e.$47b="remoteResourceHandler";class S{async routeCall(s,O,C){if(O!==e.$37b)throw new Error(`Call not found: ${O}`);const P=C[0];if(P?.authority){const f=s.connections.find(a=>a.ctx===P.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,O){throw new Error(`Event not found: ${O}`)}}e.$57b=S}),define(ie[240],ne([0,1,14,5]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,R.$Ph)("remoteAuthorityResolverService");var s;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class O{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=O;class C{constructor(w,y){this.host=w,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=C;var P;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class f extends S.$bb{static isNotAvailable(w){return w instanceof f&&w._code===P.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof f&&w._code===P.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof f&&w._code===P.NoResolverFound}static isInvalidAuthority(w){return w instanceof f&&w._code===P.InvalidAuthority}static isHandled(w){return w instanceof f&&w.isHandled}constructor(w,y=P.Unknown,d){super(w),this._message=w,this._code=y,this._detail=d,this.isHandled=y===P.NotAvailable&&d===!0,Object.setPrototypeOf(this,f.prototype)}}e.$Sk=f;function a(g){const w=g.indexOf("+");return w===-1?g:g.substring(0,w)}e.$Tk=a}),define(ie[58],ne([0,1,13]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function R(a){return a.scheme===S.Schemas.vscodeRemote?a.authority:void 0}e.$Uk=R;function s(a){if(!a)return;const g=a.indexOf("+");return g<0?a:a.substr(0,g)}e.$Vk=s;function O(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$Wk=O;function C(a){const{host:g,port:w}=f(a);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:g,port:w}}e.$Xk=C;function P(a,g){let{host:w,port:y}=f(a);return typeof y>"u"&&(y=g),{host:w,port:y}}e.$Yk=P;function f(a){const g=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const w=a.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const y=a.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:a,port:void 0}}}),define(ie[121],ne([0,1,27,5,58]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function O(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$4l=O,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(C||(e.ExtensionType=C={}));var P;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class f{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,$){if(typeof b>"u"||b===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof b=="string"||typeof $=="string"){const u=typeof b=="string"?b:b.value,l=typeof $=="string"?$:$.value;return S.$2e(u,l)}return b._lower===$._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$6l=f;class a{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const $ of b)this.add($)}add(b){this.c.add(f.toKey(b))}delete(b){return this.c.delete(f.toKey(b))}has(b){return this.c.has(f.toKey(b))}}e.$7l=a;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(f.toKey(b))}get(b){return this.c.get(f.toKey(b))}has(b){return this.c.has(f.toKey(b))}set(b,$){this.c.set(f.toKey(b),$)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=g;function w(m){return y(m)}e.$9l=w;function y(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$0l=y;function d(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$$l=d;function v(m,b){if(b){const $=`onResolveRemoteAuthority:${(0,s.$Vk)(b)}`;return!!m.activationEvents?.includes($)}return!1}e.$_l=v,e.$am=(0,R.$Ph)("IBuiltinExtensionsScannerService")}),define(ie[241],ne([0,1,8,17,22,14,3,2,65,72,32,109,240,58]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.PersistentConnectionEventType=e.$6k=e.$5k=e.$4k=e.ConnectionType=void 0;const v=30*1e3;var m;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function b(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(F){const M=new s.$Xd;return setTimeout(()=>M.cancel(),F),M.token}function u(F,M){if(F.isCancellationRequested||M.isCancellationRequested)return s.CancellationToken.Cancelled;const U=new s.$Xd;return F.onCancellationRequested(()=>U.cancel()),M.onCancellationRequested(()=>U.cancel()),U.token}class l{get didTimeout(){return this.c==="timedout"}constructor(M){this.c="pending",this.d=new P.$Rc,this.promise=new Promise((U,W)=>{this.f=U,this.g=W}),M.isCancellationRequested?this.h():this.d.add(M.onCancellationRequested(()=>this.h()))}registerDisposable(M){this.c==="pending"?this.d.add(M):M.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const M=new Error("Time limit reached");return M.code="ETIMEDOUT",M.syscall="connect",M}resolve(M){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(M))}reject(M){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(M))}}function E(F,M){const U=new l(M);return U.registerDisposable(F.onControlMessage(W=>{const L=JSON.parse(W.toString()),V=q(L);V?U.reject(V):U.resolve(L)})),U.promise}function h(F,M,U,W,L,V,J,oe){const le=new l(oe),de=a.$Jd.create(!1);return F.info(`Creating a socket (${J})...`),f.mark(`code/willCreateSocket/${V}`),M.connect(U,W,L,J).then(fe=>{le.didTimeout?(f.mark(`code/didCreateSocketError/${V}`),F.info(`Creating a socket (${J}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(f.mark(`code/didCreateSocketOK/${V}`),F.info(`Creating a socket (${J}) was successful after ${de.elapsed()} ms.`),le.resolve(fe))},fe=>{f.mark(`code/didCreateSocketError/${V}`),F.info(`Creating a socket (${J}) returned an error after ${de.elapsed()} ms.`),F.error(fe),le.reject(fe)}),le.promise}function i(F,M){const U=new l(M);return F.then(W=>{U.didTimeout||U.resolve(W)},W=>{U.didTimeout||U.reject(W)}),U.promise}async function c(F,M,U,W){const L=x(F,M);F.logService.trace(`${L} 1/6. invoking socketFactory.connect().`);let V;try{V=await h(F.logService,F.remoteSocketFactoryService,F.connectTo,(0,d.$Wk)(F),`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,b(M),`renderer-${b(M)}-${F.reconnectionToken}`,W)}catch(fe){throw F.logService.error(`${L} socketFactory.connect() failed or timed out. Error:`),F.logService.error(fe),fe}F.logService.trace(`${L} 2/6. socketFactory.connect() was successful.`);let J,oe;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(V,null),J=F.reconnectionProtocol,oe=!1):(J=new w.$Dh({socket:V}),oe=!0),F.logService.trace(`${L} 3/6. sending AuthRequest control message.`);const le=await i(F.signService.createNewMessage((0,g.$eg)()),W),de={type:"auth",auth:F.connectionToken||"00000000000000000000",data:le.data};J.sendControl(R.$be.fromString(JSON.stringify(de)));try{const fe=await E(J,u(W,$(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Oe=new Error("Unexpected handshake message");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}if(F.logService.trace(`${L} 4/6. received SignRequest control message.`),!await i(F.signService.validate(le,fe.signedData),W)){const Oe=new Error("Refused to connect to unsupported server");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}const me=await i(F.signService.sign(fe.data),W),ye={type:"connectionType",commit:F.commit,signedData:me,desiredConnectionType:M};return U&&(ye.args=U),F.logService.trace(`${L} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(R.$be.fromString(JSON.stringify(ye))),{protocol:J,ownsProtocol:oe}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(F.logService.error(`${L} the handshake timed out. Error:`),F.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${L} received error control message when negotiating connection. Error:`),F.logService.error(fe)),oe&&G(J),fe}}async function o(F,M,U,W){const L=Date.now(),V=x(F,M),{protocol:J,ownsProtocol:oe}=await c(F,M,U,W),le=new l(W);return le.registerDisposable(J.onControlMessage(de=>{const fe=JSON.parse(de.toString()),ve=q(fe);ve?(F.logService.error(`${V} received error control message when negotiating connection. Error:`),F.logService.error(ve),oe&&G(J),le.reject(ve)):(F.reconnectionProtocol?.endAcceptReconnection(),F.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${B(L)}!`),le.resolve({protocol:J,firstMessage:fe}))})),le.promise}async function t(F,M){const{protocol:U}=await o(F,1,void 0,M);return{protocol:U}}async function n(F,M,U){const{protocol:W,firstMessage:L}=await o(F,2,M,U),V=L&&L.debugPort;return{protocol:W,debugPort:V}}async function r(F,M,U){const W=Date.now(),L=x(F,3),{protocol:V}=await c(F,3,M,U);return F.logService.trace(`${L} 6/6. handshake finished, connection is up and running after ${B(W)}!`),V}async function p(F,M,U){const{connectTo:W,connectionToken:L}=await F.addressProvider.getAddress();return{commit:F.commit,quality:F.quality,connectTo:W,connectionToken:L,reconnectionToken:M,reconnectionProtocol:U,remoteSocketFactoryService:F.remoteSocketFactoryService,signService:F.signService,logService:F.logService}}async function A(F,M,U){return k(F,async W=>{const{protocol:L}=await t(W,s.CancellationToken.None);return new Z(F,M,U,W.reconnectionToken,L)})}e.$4k=A;async function D(F,M){return k(F,async U=>{const{protocol:W,debugPort:L}=await n(U,M,s.CancellationToken.None);return new Q(F,M,U.reconnectionToken,W,L)})}e.$5k=D;async function k(F,M){for(let W=1;;W++)try{const L=(0,g.$eg)(),V=await p(F,L,null);return await M(V)}catch(L){if(W<5)F.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),F.logService.error(L);else throw F.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),F.logService.error(L),ae.triggerPermanentFailure(0,0,y.$Sk.isHandled(L)),L}}async function I(F,M,U){const W=await p(F,(0,g.$eg)(),null);return await r(W,{host:M,port:U},s.CancellationToken.None)}e.$6k=I;function j(F){return(0,S.$Hg)(M=>new Promise((U,W)=>{const L=setTimeout(U,F*1e3);M.onCancellationRequested(()=>{clearTimeout(L),U()})}))}var N;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class z{constructor(M,U){this.reconnectionToken=M,this.millisSinceLastIncomingData=U,this.type=0}}e.$7k=z;class _{constructor(M,U,W,L){this.reconnectionToken=M,this.millisSinceLastIncomingData=U,this.durationSeconds=W,this.c=L,this.type=1}skipWait(){this.c.cancel()}}e.$8k=_;class Y{constructor(M,U,W){this.reconnectionToken=M,this.millisSinceLastIncomingData=U,this.attempt=W,this.type=2}}e.$9k=Y;class ce{constructor(M,U,W){this.reconnectionToken=M,this.millisSinceLastIncomingData=U,this.attempt=W,this.type=4}}e.$0k=ce;class re{constructor(M,U,W,L){this.reconnectionToken=M,this.millisSinceLastIncomingData=U,this.attempt=W,this.handled=L,this.type=3}}e.$$k=re;class ae extends P.$Sc{static triggerPermanentFailure(M,U,W){this._permanentFailure=!0,this.f=M,this.g=U,this.h=W,this.j.forEach(L=>L.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(M=>M.y())}static debugPauseSocketWriting(){this.j.forEach(M=>M.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ae._permanentFailure}constructor(M,U,W,L,V){super(),this.t=M,this.u=U,this.reconnectionToken=W,this.protocol=L,this.w=V,this.m=this.B(new C.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ce(this.reconnectionToken,0,0)),this.B(L.onSocketClose(J=>{const oe=H(this.t,this.reconnectionToken,!0);J?J.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${J.hadError}).`),J.error&&this.u.logService.error(J.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.u.logService.error(J.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(L.onSocketTimeout(J=>{const oe=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.y()})),ae.j.push(this),this.B((0,P.$Qc)(()=>{const J=ae.j.indexOf(this);J>=0&&ae.j.splice(J,1)})),this.n&&this.D(ae.f,ae.g,ae.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const M=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${M} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const L=W<U.length?U[W]:U[U.length-1];try{if(L>0){const J=j(L);this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),L,J)),this.u.logService.info(`${M} waiting for ${L} seconds before reconnecting...`);try{await J}catch{}}if(this.n){this.u.logService.error(`${M} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this.u.logService.info(`${M} resolving connection...`);const V=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${M} connecting to ${V.connectTo}...`),await this.G(V,$(v)),this.u.logService.info(`${M} reconnected!`),this.m.fire(new ce(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${M} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this.u.logService.error(`${M} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(y.$Sk.isTemporarilyNotAvailable(V)){this.u.logService.info(`${M} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this.u.logService.info(`${M} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((0,O.$4)(V)){this.u.logService.info(`${M} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if(V instanceof y.$Sk){this.u.logService.error(`${M} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,y.$Sk.isHandled(V));break}this.u.logService.error(`${M} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this.n&&!this.s)}C(M,U,W){this.w?ae.triggerPermanentFailure(M,U,W):this.D(M,U,W)}D(M,U,W){this.m.fire(new re(this.reconnectionToken,M,U,W)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_k=ae;class Z extends ae{constructor(M,U,W,L,V){super(1,M,L,V,!0),this.client=this.B(new w.$Bh(V,{remoteAuthority:U,clientId:W},M.ipcLogger))}async G(M,U){await t(M,U)}}e.$al=Z;class Q extends ae{constructor(M,U,W,L,V){super(2,M,W,L,!1),this.H=U,this.debugPort=V}async G(M,U){await n(M,this.H,U)}}e.$bl=Q;function G(F){try{F.acceptDisconnect();const M=F.getSocket();F.dispose(),M.dispose()}catch(M){(0,O.$1)(M)}}function q(F){if(F&&F.type==="error"){const M=new Error(`Connection error: ${F.reason}`);return M.code="VSCODE_CONNECTION_ERROR",M}return null}function T(F,M){for(;F.length<M;)F+=" ";return F}function K(F,M){return`[remote-connection][${T(b(F),13)}][${M.substr(0,5)}\u2026]`}function H(F,M,U){return`${K(F,M)}[${U?"reconnect":"initial"}]`}function x(F,M){return`${H(M,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.connectTo}]`}function B(F){return`${Date.now()-F} ms`}}),define(ie[242],ne([0,1,2,5]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk=(0,R.$Ph)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(C,P){return this.a[C]??=[],this.a[C].push(P),(0,S.$Qc)(()=>{const f=this.a[C]?.indexOf(P);typeof f=="number"&&f>=0&&this.a[C]?.splice(f,1)})}b(C){return(this.a[C.type]||[]).find(f=>f.supports(C))}connect(C,P,f,a){const g=this.b(C);if(!g)throw new Error(`No socket factory found for ${C}`);return g.connect(C,P,f,a)}}e.$1k=s}),define(ie[243],ne([0,1,28,47,21,113]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=void 0;let C;async function P(d=!1){return(C===void 0||d)&&(C=f()),C}e.$Y6b=P;async function f(){const d=a();if(d===void 0)return!1;if(d>=22e3){const v=w();if(v)return new Promise(m=>{R.execFile(v,["--status"],b=>m(!b))})}else{const v=y();if(v)try{if((await s.Promises.stat(v)).isFile())return!0}catch{}}return!1}function a(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(d)return parseInt(d[3])}function g(d){const v=process.env.SystemRoot;if(v){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(v,m?"Sysnative":"System32",d)}}function w(){return g("wsl.exe")}function y(){return g("lxss\\LxssManager.dll")}}),define(ie[50],ne([0,1,17,14,2,183,57,5,6,43]),function(X,e,S,R,s,O,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$To=(0,P.$Ph)("requestService");class g{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?h[i]="*****":h[i]=this.b[i];this.a=h}return this.a}}class w extends s.$Sc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,O.localize)(0,null),when:f.$oj.isEqualTo((0,f.$mj)(f.LogLevel.Trace)).serialize()})}async c(h,i,c){const o=`${h} #${++this.b}: ${i.url}`;this.a.trace(`${o} - begin`,i.type,new g(i.headers??{}));try{const t=await c();return this.a.trace(`${o} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${o} - error`,i.type,(0,R.$0)(t)),t}}}e.$Uo=w;function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Vo=y;function d(E){return E.res.statusCode===204}e.$Wo=d;async function v(E){return d(E)?null:(await(0,S.$ne)(E.stream)).toString()}e.$Xo=v;async function m(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return v(E)}e.$Yo=m;async function b(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(d(E))return null;const i=(await(0,S.$ne)(E.stream)).toString();try{return JSON.parse(i)}catch(c){throw c.message+=`:
`+i,c}}e.$Zo=b;function $(E){l(E)}e.$1o=$;let u;function l(E){const h=a.$gn.as(C.$ln.Configuration),i=u;u={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[u],remove:i?[i]:[]})}l(1)}),define(ie[244],ne([0,1,17,22]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class s{constructor(P){this.a=P}listen(P,f){throw new Error("Invalid listen")}call(P,f,a,g=R.CancellationToken.None){switch(f){case"request":return this.a.request(a[0],g).then(async({res:w,stream:y})=>{const d=await(0,S.$ne)(y);return[{statusCode:w.statusCode,headers:w.headers},d]});case"resolveProxy":return this.a.resolveProxy(a[0])}throw new Error("Invalid call")}}e.$Wq=s;class O{constructor(P){this.a=P}async request(P,f){const[a,g]=await this.a.call("request",[P],f);return{res:a,stream:(0,S.$pe)(g)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$Xq=O}),define(ie[245],ne([0,1,246,12]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;function s(C,P){return C.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:C.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function O(C,P,f={}){const a=(0,S.parse)(C),g=f.proxyUrl||s(a,P);if(!g)return null;const w=(0,S.parse)(g);if(!/^https?:$/.test(w.protocol||""))return null;const y={host:w.hostname||"",port:(w.port?+w.port:0)||(w.protocol==="https"?443:80),auth:w.auth,rejectUnauthorized:(0,R.$Ef)(f.strictSSL)?f.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((d,v)=>{X(["http-proxy-agent"],d,v)})).HttpProxyAgent(g,y):new(await new Promise((d,v)=>{X(["https-proxy-agent"],d,v)})).HttpsProxyAgent(g,y)}e.$Yq=O}),define(ie[247],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=e.$n7b=e.$m7b=void 0,e.$m7b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$n7b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$o7b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ie[93],ne([0,1,47,9,184,22,49,14,4,32,108,62,8,140]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=void 0;let v;async function m($,u,l,E){return l["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$j?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.$Nl)(E)&&!l["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.$Nl)(E)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=y.Promises.withAsyncBody(async(h,i)=>{const c=new O.$Xd;let o=1e4;const t=$.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(o=(0,d.$Ol)(t,1,120)*1e3);const n=setTimeout(()=>{c.dispose(!0),i(new Error((0,s.localize)(0,null)))},o);try{h(await b(u,c.token))}catch(r){!(0,P.$4)(r)&&!c.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,C.$Ai)(r)))):h({})}finally{clearTimeout(n),c.dispose()}})),v)}e.$Tl=m;async function b($,u){const l=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",l);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",E);const h=(0,a.$eg)().replace(/-/g,"").substr(0,12),i=new RegExp(h+"({.*})"+h),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",c);const o=await(0,g.$Dl)(f.OS,c);return $.trace("getUnixShellEnvironment#shell",o),new Promise((t,n)=>{if(u.isCancellationRequested)return n(new P.$5);const r=(0,R.$nc)(o);let p,A;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(p=`& '${process.execPath}' ${D} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,A=["-Login","-Command"]):r==="nu"?(p=`^'${process.execPath}' ${D} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,A=["-i","-l","-c"]):(p=`'${process.execPath}' ${D} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,r==="tcsh"||r==="csh"?A=["-ic"]:A=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),p);const k=(0,S.spawn)(o,[...A,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});u.onCancellationRequested(()=>(k.kill(),n(new P.$5))),k.on("error",N=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,C.$Ai)(N)),n(N)});const I=[];k.stdout.on("data",N=>I.push(N));const j=[];k.stderr.on("data",N=>j.push(N)),k.on("close",(N,z)=>{const _=Buffer.concat(I).toString("utf8");$.trace("getUnixShellEnvironment#raw",_);const Y=Buffer.concat(j).toString("utf8");if(Y.trim()&&$.trace("getUnixShellEnvironment#stderr",Y),N||z)return n(new Error((0,s.localize)(2,null,N,z)));const ce=i.exec(_),re=ce?ce[1]:"{}";try{const ae=JSON.parse(re);l?ae.ELECTRON_RUN_AS_NODE=l:delete ae.ELECTRON_RUN_AS_NODE,E?ae.ELECTRON_NO_ATTACH_CONSOLE=E:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",ae),t(ae)}catch(ae){$.error("getUnixShellEnvironment#errorCaught",(0,C.$Ai)(ae)),n(ae)}})})}}),define(ie[248],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j3b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const O=await this.c();if(O){const C=String(S.a++);return this.b.set(C,O),{id:C,data:O.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,O){if(!s.id)return!0;const C=this.b.get(s.id);if(!C)return!1;this.b.delete(s.id);try{return C.validate(O)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$j3b=S}),define(ie[94],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=void 0,e.$2k="signService",e.$3k=(0,S.$Ph)(e.$2k)}),define(ie[249],ne([0,1,248]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c8b=void 0;class R extends S.$j3b{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(C=>new C.signer().sign(O))}h(){return new Promise((O,C)=>X(["vsda"],O,C))}}e.$c8b=R}),define(ie[34],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0,e.$vN=(0,S.$Ph)("stateReadService"),e.$wN=(0,S.$Ph)("stateService")}),define(ie[122],ne([0,1,8,17,2,12,36,16,6]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=e.$xN=e.SaveStrategy=void 0;var a;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class g extends s.$Sc{constructor(v,m,b,$){super(),this.h=v,this.j=b,this.m=$,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=m===0?void 0:this.B(new S.$Rg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.j.error(v)}}getItem(v,m){const b=this.a[v];return(0,O.$Hf)(b)?m:b}setItem(v,m){this.setItems([{key:v,data:m}])}setItems(v){let m=!1;for(const{key:b,data:$}of v)this.a[b]!==$&&((0,O.$Hf)($)?(0,O.$Ff)(this.a[b])||(this.a[b]=void 0,m=!0):(this.a[b]=$,m=!0));m&&this.r()}removeItem(v){(0,O.$Ff)(this.a[v])||(this.a[v]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.m.writeFile(this.h,R.$be.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(m){this.j.error(m)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$xN=g;let w=class extends s.$Sc{constructor(v,m,b,$){super(),this.a=this.B(new g(m.stateResource,v,b,$))}async init(){await this.a.init()}getItem(v,m){return this.a.getItem(v,m)}};e.$yN=w,e.$yN=w=Ee([te(1,C.$Wh),te(2,f.$0i),te(3,P.$$j)],w);class y extends w{setItem(v,m){this.a.setItem(v,m)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$zN=y}),define(ie[123],ne([0,1,4,35,32]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=void 0;function O(f){if(S.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function C(f,a,g,w,y,d,v,m,b){const $=Object.create(null);$["common.machineId"]=d,$["common.sqmId"]=v,$.sessionID=(0,s.$eg)()+Date.now(),$.commitHash=w,$.version=y,$["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,S.$i)(S.$u),$["common.nodePlatform"]=R.$dc,$["common.nodeArch"]=g,$["common.product"]=b||"desktop",m&&($["common.msftInternal"]=m);let u=0;const l=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),S.$m&&($["common.snap"]="true");const E=O(a);return E&&($["common.platformDetail"]=E),$}e.$io=C;function P(f){const a=R.env.USERDNSDOMAIN;if(!a)return!1;const g=a.toLowerCase();return f.some(w=>g===w)}e.$jo=P}),define(ie[26],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,S.$Ph)("telemetryService"),e.$dl=(0,S.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var s;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ie[250],ne([0,1,28,8,44,13,9,4,7,87,21,107,90,16,24,26]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=e.$Fr=e.$Er=void 0;const b=new Map;async function $(i,c){const o=`${i}::${c.join(":")}`,t=b.get(o);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,p=new Map,A=2e4;function D(I,j,N,z){const _=j.substring(I.length+1);return R.Promises.withAsyncBody(async Y=>{let ce;try{ce=await g.Promises.readdir(j,{withFileTypes:!0})}catch{Y();return}if(z.count>=A){z.count+=ce.length,z.maxReached=!0,Y();return}let re=ce.length;if(re===0){Y();return}let ae=ce;z.count+ce.length>A&&(z.maxReached=!0,re=A-z.count,ae=ce.slice(0,re)),z.count+=ce.length;for(const Z of ae)if(Z.isDirectory()){if(N.includes(Z.name)||await D(I,(0,C.$jc)(j,Z.name),N,z),--re===0){Y();return}}else{const Q=Z.name.lastIndexOf(".");if(Q>=0){const G=Z.name.substring(Q+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of n)G.relativePathPattern?.test(_)!==!1&&G.filePattern.test(Z.name)&&p.set(G.tag,(p.get(G.tag)??0)+1);if(--re===0){Y();return}}})}const k=R.Promises.withAsyncBody(async I=>{const j={count:0,maxReached:!1};await D(i,i,c,j);const N=await E(i);I({configFiles:u(p),fileTypes:u(r),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:N})});return b.set(o,k),k}e.$Er=$;function u(i){return Array.from(i.entries(),([c,o])=>({name:c,count:o})).sort((c,o)=>o.count-c.count)}function l(){const i={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/d.$Gk.GB).toFixed(2)}GB (${(S.freemem()/d.$Gk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.$Rm.value()*100)}%`},c=S.cpus();return c&&c.length>0&&(i.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),i}e.$Fr=l;async function E(i){try{const c=new Map,o=(0,C.$jc)(i,".vscode","launch.json"),t=await g.Promises.readFile(o),n=[],r=(0,s.$Wm)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${o}`),[];if((0,s.$6m)(r)==="object"&&r.configurations)for(const p of r.configurations){const A=p.type;A&&(c.has(A)?c.set(A,c.get(A)+1):c.set(A,1))}return u(c)}catch{return[]}}e.$Gr=E;let h=class{constructor(c,o){this.c=c,this.d=o}f(c){const o=[];return o.push(`OS Version:       ${c.os}`),o.push(`CPUs:             ${c.cpus}`),o.push(`Memory (System):  ${c.memory}`),o.push(`VM:               ${c.vmHint}`),o.join(`
`)}g(c){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const t=S.cpus();return t&&t.length>0&&o.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),o.push(`Memory (System):  ${(S.totalmem()/d.$Gk.GB).toFixed(2)}GB (${(S.freemem()/d.$Gk.GB).toFixed(2)}GB free)`),P.$j||o.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),o.push(`VM:               ${Math.round(a.$Rm.value()*100)}%`),o.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${c.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(c,o){return Promise.all([(0,w.$Dr)(c.mainPID),this.k(c)]).then(async t=>{let[n,r]=t,p=this.m(c,n);return o.forEach(A=>{if((0,y.$rm)(A))p+=`
${A.errorMessage}`,r+=`
${A.errorMessage}`;else if(p+=`

Remote: ${A.hostName}`,A.processes&&(p+=`
${this.m(c,A.processes)}`),A.workspaceMetadata){r+=`
|  Remote: ${A.hostName}`;for(const D of Object.keys(A.workspaceMetadata)){const k=A.workspaceMetadata[D];let I=`${k.fileCount} files`;k.maxFilesReached&&(I=`more than ${I}`),r+=`|    Folder (${D}): ${I}`,r+=this.h(k)}}}),{processInfo:p,workspaceInfo:r}})}async getSystemInfo(c,o){const{memory:t,vmHint:n,os:r,cpus:p}=l(),A={os:r,memory:t,cpus:p,vmHint:n,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:o};return P.$j||(A.load=`${S.loadavg().map(D=>Math.round(D)).join(", ")}`),P.$l&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(c,o){const t=[];return(0,w.$Dr)(c.mainPID).then(async n=>(t.push(""),t.push(this.g(c)),t.push(""),t.push(this.m(c,n)),c.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(c))),o.forEach(r=>{if((0,y.$rm)(r))t.push(`
${r.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${r.hostName}`),t.push(this.f(r.machineInfo)),r.processes&&t.push(this.m(c,r.processes)),r.workspaceMetadata)for(const p of Object.keys(r.workspaceMetadata)){const A=r.workspaceMetadata[p];let D=`${A.fileCount} files`;A.maxFilesReached&&(D=`more than ${D}`),t.push(`Folder (${p}): ${D}`),t.push(this.h(A))}}),t.push(""),t.push(""),t.join(`
`)))}h(c){const o=[];let n=0;const r=(k,I)=>{const j=` ${k}(${I})`;n+j.length>60?(o.push(p),p="|                 ",n=p.length):n+=j.length,p+=j};let p="|      File types:";const A=10,D=c.fileTypes.length>A?A:c.fileTypes.length;for(let k=0;k<D;k++){const I=c.fileTypes[k];r(I.name,I.count)}if(o.push(p),c.configFiles.length>=0&&(p="|      Conf files:",n=0,c.configFiles.forEach(k=>{r(k.name,k.count)}),o.push(p)),c.launchConfigFiles.length>0){let k="|      Launch Configs:";c.launchConfigFiles.forEach(I=>{const j=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;k+=j}),o.push(k)}return o.join(`
`)}j(c){const o=Math.max(...Object.keys(c).map(t=>t.length));return Object.keys(c).map(t=>`${t}:  ${" ".repeat(o-t.length)}  ${c[t]}`).join(`
                  `)}k(c){const o=[],t=[];return c.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(o.push(`|  Window (${n.title})`),n.folderURIs.forEach(r=>{const p=f.URI.revive(r);if(p.scheme===O.Schemas.file){const A=p.fsPath;t.push($(A,["node_modules",".git"]).then(D=>{let k=`${D.fileCount} files`;D.maxFilesReached&&(k=`more than ${k}`),o.push(`|    Folder (${(0,C.$nc)(A)}): ${k}`),o.push(this.h(D))}).catch(D=>{o.push(`|      Error: Unable to collect workspace stats for folder ${A} (${D.toString()})`)}))}else o.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>o.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(c,o){const t=new Map;c.windows.forEach(r=>t.set(r.pid,`window [${r.id}] (${r.title})`)),c.pidToNames.forEach(({pid:r,name:p})=>t.set(r,p));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),o&&this.n(c.mainPID,t,n,o,0),n.join(`
`)}n(c,o,t,n,r){const p=r===0;let A;p?A=n.pid===c?`${this.d.applicationName} main`:"remote agent":o.has(n.pid)?A=o.get(n.pid):A=`${"  ".repeat(r)} ${n.name}`;const D=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(D/d.$Gk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(c,o,t,k,r+1))}async getWorkspaceFileExtensions(c){const o=new Set;for(const{uri:t}of c.folders){const n=f.URI.revive(t);if(n.scheme!==O.Schemas.file)continue;const r=n.fsPath;try{(await $(r,["node_modules",".git"])).fileTypes.forEach(A=>o.add(A.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(c){for(const{uri:o}of c.folders){const t=f.URI.revive(o);if(t.scheme!==O.Schemas.file)continue;const n=t.fsPath;try{const r=await $(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),r.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:p.name,count:p.count})}),r.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:p.name,count:p.count})}),r.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$Hr=h,e.$Hr=h=Ee([te(0,m.$cl),te(1,v.$pj)],h)}),define(ie[251],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=void 0;class S{constructor(O){this.b=O}listen(O,C){throw new Error(`Event not found: ${C}`)}call(O,C,{eventName:P,data:f}){return this.b.forEach(a=>a.log(P,f)),Promise.resolve(null)}}e.$r7b=S;class R{constructor(O){this.b=O}log(O,C){return this.b.call("log",{eventName:O,data:C}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$s7b=R}),define(ie[51],ne([0,1,37,12,3,18,58,123,26]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$ko=a;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$lo=g,e.$mo=new g;class w{async publicLog(n,r,p){}async publicLogError(n,r,p){}}e.$no=w,e.$oo="telemetry",e.$po="extensionTelemetryLog",e.$qo={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(p,A)=>{const D=p?new Set([...p.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:D}},1e3,!0)(p=>{p.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,O.$mi)(p.source),configurationKeys:Array.from(p.affectedKeys)})})}e.$ro=y;function d(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$so=d;function v(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$to=v;function m(t){const n=t.getValue(f.$kl),r=t.getValue(f.$ll);if(t.getValue(f.$ml)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$uo=m;function b(t){const n={},r={},p={};l(t,p);for(let A in p){A=A.length>150?A.substr(A.length-149):A;const D=p[A];typeof D=="number"?r[A]=D:typeof D=="boolean"?r[A]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${D.length}`),n[A]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(n[A]=D)}return{properties:n,measurements:r}}e.$vo=b;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const n=(0,C.$Vk)(t);return $.has(n)?n:"other"}e.$wo=u;function l(t,n,r=0,p){if(t)for(const A of Object.getOwnPropertyNames(t)){const D=t[A],k=p?p+A:A;Array.isArray(D)?n[k]=(0,S.$_m)(D):D instanceof Date?n[k]=D.toISOString():(0,R.$Af)(D)?r<2?l(D,n,r+1,k+"."):n[k]=(0,S.$_m)(D):n[k]=D}}function E(t,n){const r=t.msftInternalDomains||[],p=n.getValue("telemetry.internalTesting");return(0,P.$jo)(r)||p}e.$xo=E;function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$yo=h;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const p=[];for(const I of n)for(;;){const j=I.exec(t);if(!j)break;p.push([j.index,I.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(r="";;){const I=D.exec(t);if(!I)break;const j=p.some(([N,z])=>I.index<z&&N<D.lastIndex);!A.test(I[0])&&!j&&(r+=t.substring(k,I.index)+"<REDACTED: user-file-path>",k=D.lastIndex)}return k<t.length&&(r+=t.substr(k)),r}function c(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function o(t,n){return(0,S.$9m)(t,r=>{if(r instanceof a||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let p=r.replaceAll("%20"," ");p=i(p,n);for(const A of n)p=p.replace(A,"");return p=c(p),p}})}e.$zo=o}),define(ie[124],ne([0,1,27,118,121,4,7,14,35,51]),function(X,e,S,R,s,O,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;function g(o,t){return o.uuid&&t.uuid?o.uuid===t.uuid:o.id===t.id?!0:(0,S.$We)(o.id,t.id)===0}e.$Ao=g;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(t){const n=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new y(t.identifier,n,r)}static parse(t){const n=w.exec(t);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof y?g(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Bo=y;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const t=d.exec(o);return t&&t[1]?[b(t[1]),t[2]]:[b(o),void 0]}e.$Co=v;function m(o,t){return`${o}.${t}`}e.$Do=m;function b(o){return o.toLowerCase()}e.$Eo=b;function $(o,t){return b(m(o??s.$2l,t))}e.$Fo=$;function u(o,t){const n=[],r=p=>{for(const A of n)if(A.some(D=>g(t(D),t(p))))return A;return null};for(const p of o){const A=r(p);A?A.push(p):n.push([p])}return n}e.$Go=u;function l(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$Ho=l;function E(o){return{id:new a.$ko(o.identifier.id),name:new a.$ko(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Io=E,e.$Jo=new s.$6l("pprice.better-merge");function h(o,t){const n=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const p=r.shift();if(p&&n.every(A=>!g(A.identifier,{id:p}))){const A=o.filter(D=>g(D.identifier,{id:p}));A.length===1&&(n.push(A[0]),r.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Ko=h;async function i(o,t){if(!O.$l)return!1;let n;try{n=(await o.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){t.debug("Error while getting the os-release file.",(0,P.$0)(p))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(o,t){const n=await i(o,t),r=(0,R.$6n)(n?"alpine":O.$u,f.$ec);return t.debug("ComputeTargetPlatform:",r),r}e.$Lo=c}),define(ie[252],ne([0,1,206,51]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=void 0;async function s(O,C,P,f,a,g,w){const y={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${C.nameShort})`};if((0,R.$so)(C,P)&&(0,R.$uo)(f)===3){const d=await(0,S.$ap)(P,a,g);y["X-Market-User-Id"]=d,y["VSCode-SessionId"]=w.machineId||d}return y}e.$bp=s}),define(ie[253],ne([0,1,2,37,4,27,185,18,57,78,24,43,26,51]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,u,l){this.k=u,this.l=l,this.d={},this.i=new S.$Rc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,O.$Fe)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$Fe)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.$kl)||E.affectsConfiguration(y.$ml)||E.affectsConfiguration(y.$ll))&&this.m()}))}setExperimentProperty($,u){this.d[$]=u}m(){let $=(0,d.$uo)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const l=u.usage?3:u.error?2:0;$=Math.min($,l)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,u,l){this.g<u||(l=(0,R.$0m)(l,this.d),l=(0,d.$zo)(l,this.j),l=(0,R.$0m)(l,this.c),this.b.forEach(E=>E.log($,l)))}publicLog($,u){this.n($,3,u)}publicLog2($,u){this.publicLog($,u)}publicLogError($,u){this.h&&this.n($,2,u)}publicLogError2($,u){this.publicLogError($,u)}};e.$2q=v,e.$2q=v=Ee([te(1,P.$ji),te(2,g.$pj)],v);function m(){const b=(0,C.localize)(0,null,a.default.nameLong),$=a.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=s.$p?"":(0,C.localize)(3,null),l=(0,C.localize)(4,null),E=(0,C.localize)(5,null),h=(0,C.localize)(6,null),i=(0,C.localize)(7,null),c=`
|       | ${l} | ${E} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,C.localize)(8,null);return`
${b} ${$} ${u}

&nbsp;

${i}
${c}

&nbsp;

${o}
`}w.$gn.as(f.$ln.Configuration).registerConfiguration({id:y.$jl,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[y.$kl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.$gn.as(f.$ln.Configuration).registerConfiguration({id:y.$jl,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[y.$ml]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,C.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,C.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${y.$kl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[254],ne([0,1,4,87,26]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=e.$T7b=void 0;async function O(P,f){let a=P.getItem(s.$hl);return(typeof a!="string"||S.$k&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,R.$Sm)(f.error.bind(f))),a}e.$T7b=O;async function C(P,f){let a=P.getItem(s.$il);return typeof a!="string"&&(a=await(0,R.$Tm)(f.error.bind(f))),a}e.$U7b=C}),define(ie[255],ne([0,1,26,254]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=e.$V7b=void 0;async function s(C,P){const f=await(0,R.$T7b)(C,P);return C.setItem(S.$hl,f),f}e.$V7b=s;async function O(C,P){const f=await(0,R.$U7b)(C,P);return C.setItem(S.$il,f),f}e.$W7b=O}),define(ie[125],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(ie[256],ne([0,1,4,125]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;const s=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((w,y)=>{this.d(w,y);const d=w.map.entries();let v=d.next();for(;!v.done;){const m=v.value[1],b=v.value[0];let $=this.a.get(b);if($||($=[],this.a.set(b,$)),$.length>0&&$[0].type===R.EnvironmentVariableMutatorType.Replace){v=d.next();continue}const u={extensionIdentifier:y,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};u.scope||delete u.scope,$.unshift(u),v=d.next()}})}async applyToProcessEnvironment(g,w,y){let d;S.$j&&(d={},Object.keys(g).forEach(v=>d[v.toLowerCase()]=v));for(const[v,m]of this.getVariableMap(w)){const b=S.$j&&d[v.toLowerCase()]||v;for(const $ of m){const u=y?await y($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case R.EnvironmentVariableMutatorType.Append:g[b]=(g[b]||"")+u;break;case R.EnvironmentVariableMutatorType.Prepend:g[b]=u+(g[b]||"");break;case R.EnvironmentVariableMutatorType.Replace:g[b]=u;break}if($.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${s.get($.type)}`;g[l]=(g[l]?g[l]+":":"")+v+"="+this.c(u)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,w){const y=new Map,d=new Map,v=new Map;if(g.getVariableMap(w).forEach((m,b)=>{const $=this.getVariableMap(w).get(b),u=P(m,$);u&&y.set(b,u)}),this.getVariableMap(w).forEach((m,b)=>{const $=g.getVariableMap(w).get(b),u=P(m,$);u&&v.set(b,u)}),this.getVariableMap(w).forEach((m,b)=>{const $=g.getVariableMap(w).get(b),u=f(m,$);u&&d.set(b,u)}),!(y.size===0&&d.size===0&&v.size===0))return{added:y,changed:d,removed:v}}getVariableMap(g){const w=new Map;for(const y of this.a.values()){const d=y.filter(v=>C(v,g));d.length>0&&w.set(d[0].variable,d)}return w}getDescriptionMap(g){const w=new Map;for(const y of this.b.values()){const d=y.filter(v=>C(v,g,!0));for(const v of d)w.set(v.extensionIdentifier,v.description)}return w}d(g,w){if(!g.descriptionMap)return;const y=g.descriptionMap.entries();let d=y.next();for(;!d.done;){const v=d.value[1],m=d.value[0];let b=this.b.get(m);b||(b=[],this.b.set(m,b));const $={extensionIdentifier:w,scope:v.scope,description:v.description};$.scope||delete $.scope,b.push($),d=y.next()}}}e.$rr=O;function C(a,g,w=!1){return a.scope?!!(a.scope.workspaceFolder&&g?.workspaceFolder&&a.scope.workspaceFolder.index===g.workspaceFolder.index):w?g===a.scope:!0}function P(a,g){if(!g)return a;const w=new Set;g.forEach(d=>w.add(d.extensionIdentifier));const y=[];return a.forEach(d=>{w.has(d.extensionIdentifier)||y.push(d)}),y.length===0?void 0:y}function f(a,g){if(!g)return;const w=new Map;g.forEach(d=>w.set(d.extensionIdentifier,d));const y=[];return a.forEach(d=>{const v=w.get(d.extensionIdentifier);v&&(d.type!==v.type||d.value!==v.value||d.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&y.push(v)}),y.length===0?void 0:y}}),define(ie[257],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.$or=e.$nr=e.$mr=e.$lr=void 0;function S(f){return[...f.entries()]}e.$lr=S;function R(f){return f?[...f.entries()]:[]}e.$mr=R;function s(f){return new Map(f)}e.$nr=s;function O(f){return new Map(f??[])}e.$or=O;function C(f){return Array.from(f.entries()).map(a=>[a[0],S(a[1].map),R(a[1].descriptionMap)])}e.$pr=C;function P(f){return new Map(f.map(a=>[a[0],{map:s(a[1]),descriptionMap:O(a[2])}]))}e.$qr=P}),define(ie[258],ne([0,1,8,22,3,2,6]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;let P=class extends O.$Sc{constructor(a,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Nd),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,O.$Qc)(()=>{for(const w of this.f.values())(0,O.$Nc)(w)}))}createRequest(a){return new Promise((g,w)=>{const y=++this.a;this.c.set(y,g),this.g.fire({requestId:y,...a});const d=new R.$Xd;(0,S.$Ug)(this.b,d.token).then(()=>w(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,O.$Qc)(()=>d.cancel())])})}acceptReply(a,g){const w=this.c.get(a);w?(this.c.delete(a),(0,O.$Nc)(this.f.get(a)||[]),this.f.delete(a),w(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$cr=P,e.$cr=P=Ee([te(1,C.$0i)],P)}),define(ie[126],ne([0,1,5,115,43]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.$9q=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$8q=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$7q=void 0,e.$7q=new R.$7i("terminalTabFocusMode",!1,!0);var O;(function(h){h.AutomationProfile="terminal.integrated.automationProfile.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var C;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var P;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(P||(e.PosixShellType=P={}));var f;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var a;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var g;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var w;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.$8q=(0,S.$Ph)("ptyService");var y;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var d;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var v;(function(h){h.TerminalView="view",h.Editor="editor"})(v||(e.TerminalLocationString=v={}));var m;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var b;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var $;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var u;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(u||(e.ShellIntegrationStatus=u={}));var l;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$9q={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const c=this.b(i.remoteAuthority);if(this.a.has(c))throw new Error(`A terminal backend with remote authority '${c}' was already registered.`);this.a.set(c,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$gn.add(e.$9q.Backend,new E),e.$0q=(0,S.$Ph)("localPtyService"),e.$$q=(0,S.$Ph)("terminalLogService")}),define(ie[259],ne([0,1,74,7,187,102]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=e.$dr=void 0;function C(y,d){const v=[{name:null,description:(0,s.localize)(0,null)}];return v.push(...y.map(m=>({name:m.profileName,description:P(m)}))),d&&v.push(...d.map(m=>({name:m.title,description:f(m)}))),{values:v.map(m=>m.name),markdownDescriptions:v.map(m=>m.description)}}e.$dr=C;function P(y){let d=`$(${O.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$Uj.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?d+=`
- args: "${y.args}"`:d+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(d+=`
- overrideName: ${y.overrideName}`),y.color&&(d+=`
- color: ${y.color}`),y.env&&(d+=`
- env: ${JSON.stringify(y.env)}`),d}function f(y){return`$(${O.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$Uj.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function a(y,d){if(!y&&!d)return!0;if(typeof y=="string"&&typeof d=="string")return y===d;if(Array.isArray(y)&&Array.isArray(d)){if(y.length!==d.length)return!1;for(let v=0;v<y.length;v++)if(y[v]!==d[v])return!1;return!0}return!1}e.$er=a;function g(y,d){if(!y&&!d)return!0;if(!y||!d)return!1;if(O.ThemeIcon.isThemeIcon(y)&&O.ThemeIcon.isThemeIcon(d))return y.id===d.id&&y.color===d.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof d=="object"&&"light"in d&&"dark"in d){const v=y,m=d;if((R.URI.isUri(v.light)||w(v.light))&&(R.URI.isUri(v.dark)||w(v.dark))&&(R.URI.isUri(m.light)||w(m.light))&&(R.URI.isUri(m.dark)||w(m.dark)))return v.light.path===m.light.path&&v.dark.path===m.dark.path}if(R.URI.isUri(y)&&R.URI.isUri(d)||w(y)||w(d)){const v=y,m=d;return v.path===m.path&&v.scheme===m.scheme}return!1}e.$fr=g;function w(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$gr=w}),define(ie[260],ne([0,1,74,4,186,57,43,259]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.$ir=e.$hr=void 0,e.$hr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$ir={type:"string",enum:Array.from((0,S.$Tj)(),b=>b.id),markdownEnumDescriptions:Array.from((0,S.$Tj)(),b=>`$(${b.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$ir},color:{description:(0,s.localize)(3,null),...e.$hr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},g={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function w(b){const $=b===2?"linux":b===1?"osx":"windows";return(0,s.localize)(7,null,(0,R.$i)(b),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:w(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:w(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:w(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){C.$gn.as(O.$ln.Configuration).registerConfiguration(y),m()}e.$jr=d;let v;function m(b,$){const u=C.$gn.as(O.$ln.Configuration);let l;b&&(l=(0,P.$dr)(b?.profiles,$));const E=v;v={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:b?.os===3?l?.values:void 0,markdownEnumDescriptions:b?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:b?.os===2?l?.values:void 0,markdownEnumDescriptions:b?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:b?.os===1?l?.values:void 0,markdownEnumDescriptions:b?.os===1?l?.markdownDescriptions:void 0}}},u.updateConfigurations({add:[v],remove:E?[E]:[]})}e.$kr=m}),define(ie[261],ne([0,1,28,13,37,9,4,35,27,12,21,125,257,256]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=void 0;function v(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$sr=v;async function m(t,n,r,p=P.env,A=g.Promises.exists){if(O.$ic(t))return await A(t)?t:void 0;if(n===void 0&&(n=P.cwd()),O.$mc(t)!=="."){const j=O.$jc(n,t);return await A(j)?j:void 0}const k=(0,s.$bn)(p,"PATH");if(r===void 0&&(0,a.$yf)(k)&&(r=k.split(O.$tc)),r===void 0||r.length===0){const j=O.$jc(n,t);return await A(j)?j:void 0}for(const j of r){let N;if(O.$ic(j)?N=O.$jc(j,t):N=O.$jc(n,j,t),await A(N))return N;if(C.$j){let z=N+".com";if(await A(z)||(z=N+".exe",await A(z)))return z}}const I=O.$jc(n,t);return await A(I)?I:void 0}e.$tr=m;function b(t,n,r,p,A){const D=C.$j&&(!n.windowsEnableConpty||v()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||D)return;const k=t.args,I=P.$dc==="win32"?O.$nc(t.executable).toLowerCase():O.$nc(t.executable),j=O.$mc(R.$cg.asFileUri("").fsPath);let N;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),C.$j){if(I==="pwsh.exe"||I==="powershell.exe")return!k||c(k)?N=l.get(u.WindowsPwsh):i(k)&&(N=l.get(u.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,f.$Ce)(N[N.length-1],j,""),{newArgs:N,envMixin:z}):void 0;p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(I){case"bash":return!k||k.length===0?N=l.get(u.Bash):o(k)&&(z.VSCODE_SHELL_LOGIN="1",$(n,z),N=l.get(u.Bash)),N?(N=[...N],N[N.length-1]=(0,f.$Ce)(N[N.length-1],j),{newArgs:N,envMixin:z}):void 0;case"fish":{const _=r?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Y=O.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${_}:${Y}`,$(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!k||c(k)?N=l.get(u.Pwsh):i(k)&&(N=l.get(u.PwshLogin)),N?(N=[...N],N[N.length-1]=(0,f.$Ce)(N[N.length-1],j,""),{newArgs:N,envMixin:z}):void 0;case"zsh":{if(!k||k.length===0?N=l.get(u.Zsh):o(k)?(N=l.get(u.ZshLogin),$(n,z)):(k===l.get(u.Zsh)||k===l.get(u.ZshLogin))&&(N=k),!N)return;N=[...N],N[N.length-1]=(0,f.$Ce)(N[N.length-1],j);let _;try{_=S.userInfo().username}catch{_="unknown"}const Y=O.$jc(S.tmpdir(),`${_}-${A.applicationName}-zsh`);z.ZDOTDIR=Y;const ce=r?.ZDOTDIR??S.homedir()??"~";z.USER_ZDOTDIR=ce;const re=[];return re.push({source:O.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.$jc(Y,".zshrc")}),re.push({source:O.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.$jc(Y,".zprofile")}),re.push({source:O.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.$jc(Y,".zshenv")}),re.push({source:O.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.$jc(Y,".zlogin")}),{newArgs:N,envMixin:z,filesToCopy:re}}}p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$ur=b;function $(t,n){if(C.$k&&t.environmentVariableCollections){const r=(0,y.$qr)(t.environmentVariableCollections),A=new d.$rr(r).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),D=[];if(A)for(const k of A)k.type===w.EnvironmentVariableMutatorType.Prepend&&D.push(k.value);D.length>0&&(n.VSCODE_PATH_PREFIX=D.join(""))}}var u;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(u||(u={}));const l=new Map;l.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(u.Zsh,["-i"]),l.set(u.ZshLogin,["-il"]),l.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],h=["-nol","-nologo"];function i(t){return typeof t=="string"?E.includes(t.toLowerCase()):t.length===1&&E.includes(t[0].toLowerCase())||t.length===2&&(E.includes(t[0].toLowerCase())||E.includes(t[1].toLowerCase()))&&(h.includes(t[0].toLowerCase())||h.includes(t[1].toLowerCase()))}function c(t){return typeof t=="string"?h.includes(t.toLowerCase()):t.length===0||t?.length===1&&h.includes(t[0].toLowerCase())}function o(t){return t==="string"&&E.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&E.includes(t[0].toLowerCase())}}),define(ie[262],ne([0,1,47,74,9,4,12,21,106,261,113]),function(X,e,S,R,s,O,C,P,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;let w,y=!0;function d(n,r,p,A,D=process.env,k,I,j,N){return k=k||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},O.$j?v(p,k,D,I,A.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:A.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:A.getValue("terminal.integrated.defaultProfile.windows"),N,j):c(k,I,p,n&&typeof n=="object"?{...n}:A.getValue(O.$l?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:A.getValue(O.$l?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,j,D)}e.$vr=d;async function v(n,r,p,A,D,k,I,j,N){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let Y=!1;(0,a.$sr)()>=16299&&(Y=!0),await u(j);const ce=new Map;if(n){ce.set("PowerShell",{source:"PowerShell",icon:R.$Uj.terminalPowershell,isAutoDetected:!0}),ce.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Uj.terminalPowershell,isAutoDetected:!0}),ce.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ce.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:R.$Uj.terminalCmd,isAutoDetected:!0}),ce.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ce.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$Uj.terminalBash,isAutoDetected:!0});const ae=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ce.set("Cmder",{path:`${_}\\cmd.exe`,args:["/K",ae],requiresPath:process.env.CMDER_ROOT?ae:{path:ae,isUnsafe:!0},isAutoDetected:!0})}o(k,ce);const re=await m(ce.entries(),I,r,p,A,N);if(n&&D)try{const ae=await h(`${_}\\${Y?"wsl":"bash"}.exe`,I);for(const Z of ae)(!k||!(Z.profileName in k))&&re.push(Z)}catch{y&&(A?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return re}async function m(n,r,p,A=process.env,D,k){const I=[];for(const[j,N]of n)I.push(b(j,N,r,p,A,D,k));return(await Promise.all(I)).filter(j=>!!j)}async function b(n,r,p,A,D=process.env,k,I){if(r===null)return;let j,N,z;if("source"in r&&!("path"in r)){const re=w?.get(r.source);if(!re)return;j=re.paths,N=r.args||re.args,r.icon?z=$(r.icon):re.icon&&(z=re.icon)}else j=Array.isArray(r.path)?r.path:[r.path],N=O.$j||Array.isArray(r.args)?r.args:void 0,z=$(r.icon);let _;if(I){const re=j.map(Z=>typeof Z=="string"?Z:Z.path),ae=await I(re);_=new Array(j.length);for(let Z=0;Z<j.length;Z++)typeof j[Z]=="string"?_[Z]=ae[Z]:_[Z]={path:ae[Z],isUnsafe:!0}}else _=j.slice();let Y;if(r.requiresPath){let re;if((0,C.$yf)(r.requiresPath)?re=r.requiresPath:(re=r.requiresPath.path,r.requiresPath.isUnsafe&&(Y=re)),!await A.existsFile(re))return}const ce=await t(n,p,_,A,D,N,r.env,r.overrideName,r.isAutoDetected,Y);if(!ce){k?.debug("Terminal profile not validated",n,j);return}return ce.isAutoDetected=r.isAutoDetected,ce.icon=z,ce.color=r.color,ce}function $(n){return typeof n=="string"?{id:n}:n}async function u(n){if(w&&!n)return;const[r,p]=await Promise.all([l(),n||E()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:r,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:p,icon:R.$Uj.terminalPowershell})}async function l(){const n=new Set,r=await(0,a.$tr)("git.exe");if(r){const D=(0,g.dirname)(r);n.add((0,g.resolve)(D,"../.."))}function p(D,k){k&&D.add(k)}p(n,process.env.ProgramW6432),p(n,process.env.ProgramFiles),p(n,process.env["ProgramFiles(X86)"]),p(n,`${process.env.LocalAppData}\\Program`);const A=[];for(const D of n)A.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function E(){const n=[];for await(const r of(0,f.$xl)())n.push(r.exePath);return n}async function h(n,r){const p=[],A=await new Promise((I,j)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,z)=>{if(N)return j("Problem occurred when getting wsl distros");I(z)})});if(!A)return[];const D=new RegExp(/[\r?\n]/),k=A.split(D).filter(I=>I.trim().length>0&&I!=="");for(const I of k){if(I===""||I.startsWith("docker-desktop"))continue;const j=`${I} (WSL)`,N={profileName:j,path:n,args:["-d",`${I}`],isDefault:j===r,icon:i(I),isAutoDetected:!1};p.push(N)}return p}function i(n){return n.includes("Ubuntu")?R.$Uj.terminalUbuntu:n.includes("Debian")?R.$Uj.terminalDebian:R.$Uj.terminalLinux}async function c(n,r,p,A,D,k,I,j){const N=new Map;if(p){const z=(await n.readFile("/etc/shells")).toString(),_=(k||z.split(`
`)).map(ce=>{const re=ce.indexOf("#");return re===-1?ce:ce.substring(0,re)}).filter(ce=>ce.trim().length>0),Y=new Map;for(const ce of _){let re=(0,s.$nc)(ce),ae=Y.get(re)||0;ae++,ae>1&&(re=`${re} (${ae})`),Y.set(re,ae),N.set(re,{path:ce,isAutoDetected:!0})}}return o(A,N),await m(N.entries(),D,n,j,r,I)}function o(n,r){if(n)for(const[p,A]of Object.entries(n))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?r.delete(p):(A.icon=A.icon||r.get(p)?.icon,r.set(p,A))}async function t(n,r,p,A,D,k,I,j,N,z){if(p.length===0)return Promise.resolve(void 0);const _=p.shift();if(_==="")return t(n,r,p,A,D,k,I,j,N);const Y=typeof _!="string"&&_.isUnsafe,ce=typeof _=="string"?_:_.path,re={profileName:n,path:ce,args:k,env:I,overrideName:j,isAutoDetected:N,isDefault:n===r,isUnsafePath:Y,requiresUnsafePath:z};if((0,s.$nc)(ce)===ce){const Z=D.PATH?D.PATH.split(s.$tc):void 0,Q=await(0,a.$tr)(ce,void 0,Z,void 0,A.existsFile);return Q?(re.path=Q,re.isFromPath=!0,re):t(n,r,p,A,D,k)}return await A.existsFile((0,s.$hc)(ce))?re:t(n,r,p,A,D,k,I,j,N)}}),define(ie[263],ne([0,1,3,2,4,42,18,6,226,93,258,126,260,262,108,72]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;var b;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let $=class extends R.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,E,h,i){super(),this.M=l,this.N=E,this.O=h,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Nd),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Nd),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Nd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Nd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Nd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Nd),this.onProcessData=this.D.event,this.F=this.B(new S.$Nd),this.onProcessReady=this.F.event,this.G=this.B(new S.$Nd),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Nd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Nd),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Nd),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Nd),this.onProcessExit=this.L.event,(0,y.$jr)(),this.B(this.M),this.B((0,R.$Qc)(()=>this.W())),this.j=this.B(new g.$cr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$j)return process.env;try{return await(0,a.$Tl)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),E=l.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),O.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(c=>{this.u.fire(c.code),!this.m&&!this.q.isDisposed&&(this.n<=b.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${c.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))}));const i=O.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(c=>this.D.fire(c))),this.B(i.onProcessReady(c=>this.F.fire(c))),this.B(i.onProcessExit(c=>this.L.fire(c))),this.B(i.onDidChangeProperty(c=>this.J.fire(c))),this.B(i.onProcessReplay(c=>this.G.fire(c))),this.B(i.onProcessOrphanQuestion(c=>this.H.fire(c))),this.B(i.onDidRequestDetach(c=>this.I.fire(c))),this.B(new f.$br(this.P,E.getChannel(w.TerminalIpcChannels.Logger))),this.a=l,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,i]}async createProcess(l,E,h,i,c,o,t,n,r,p,A){const D=setTimeout(()=>this.$(),w.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(l,E,h,i,c,o,t,n,r,p,A);return clearTimeout(D),k}updateTitle(l,E,h){return this.f.updateTitle(l,E,h)}updateIcon(l,E,h,i){return this.f.updateIcon(l,E,h,i)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,E){return this.f.detachFromProcess(l,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,E){return this.f.shutdown(l,E)}input(l,E){return this.f.input(l,E)}processBinary(l,E){return this.f.processBinary(l,E)}resize(l,E,h){return this.f.resize(l,E,h)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,E){return this.f.acknowledgeDataEvent(l,E)}setUnicodeVersion(l,E){return this.f.setUnicodeVersion(l,E)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new m.$Jd,E=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...E]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,E){return this.f.installAutoReply(l,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,v.$Dl)(l??s.OS,process.env)}async getProfiles(l,E,h,i=!1){const c=await this.S();return(0,d.$vr)(E,h,i,this.N,c,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,E){return this.f.getWslPath(l,E)}getRevivedPtyNewId(l,E){return this.f.getRevivedPtyNewId(l,E)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,E){return this.f.requestDetachInstance(l,E)}async acceptDetachInstanceReply(l,E){return this.f.acceptDetachInstanceReply(l,E)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,E,h){return this.f.reviveTerminalProcesses(l,E,h)}async refreshProperty(l,E){return this.f.refreshProperty(l,E)}async updateProperty(l,E,h){return this.f.updateProperty(l,E,h)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,E){return this.j.createRequest({workspaceId:l,originalText:E})}async acceptPtyHostResolvedVariables(l,E){this.j.acceptReply(l,E)}};e.$wr=$,e.$wr=$=Ee([te(1,C.$ji),te(2,P.$0i),te(3,P.$$i)],$)}),define(ie[67],ne([0,1,15,3,2,4,18,5,34]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o6b=e.$n6b=void 0;const a="#FFFFFF",g="#1E1E1E",w="#000000",y="#FFFFFF",d="theme",v="themeBackground",m="windowSplash";e.$n6b=(0,P.$Ph)("themeMainService");let b=class extends s.$Sc{constructor(u,l){super(),this.b=u,this.c=l,this.a=this.B(new R.$Nd),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(O.$j){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.$k){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.$l&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const u=this.getColorScheme();if(u.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return u.dark?w:y;let l=this.b.getItem(v,null);if(!l)switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":l=a;break;case"hc-black":l=w;break;case"hc-light":l=y;break;default:l=g}return O.$k&&l.toUpperCase()===g&&(l="#171717"),l}saveWindowSplash(u,l){this.b.setItems([{key:d,data:l.baseTheme},{key:v,data:l.colorInfo.background},{key:m,data:l}]),typeof u=="number"&&this.f(u,l)}f(u,l){for(const E of S.BrowserWindow.getAllWindows())if(E.id===u){E.setBackgroundColor(l.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(m)}};e.$o6b=b,e.$o6b=b=Ee([te(0,f.$wN),te(1,C.$ji)],b)}),define(ie[127],ne([0,1,3,18,5,6]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.ProvidedOnAutoForward=e.$_u=e.TunnelPrivacyId=e.TunnelProtocol=e.$$u=e.$0u=void 0,e.$0u=(0,s.$Ph)("tunnelService"),e.$$u=(0,s.$Ph)("sharedTunnelsService");var C;(function(b){b.Http="http",b.Https="https"})(C||(e.TunnelProtocol=C={}));var P;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(P||(e.TunnelPrivacyId=P={}));function f(b){return!!b.forwardPort}e.$_u=f;var a;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function g(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const $=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if($)return{address:$[1],port:+$[2]}}e.$av=g,e.$bv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(b){return e.$bv.indexOf(b)>=0}e.$cv=w,e.$dv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(b){return e.$dv.indexOf(b)>=0}e.$ev=y;function d(b,$,u,l){if(u===1)return!1;if(u===2&&y($)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(E?.length===4&&parseInt(E[1])>=18)return!1}return b<1024}e.$fv=d;class v{constructor($,u,l){this.remoteAddress=$,this.localAddress=u,this.b=l,this.a=new S.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$gv=v;let m=class{constructor($,u){this.j=$,this.k=u,this.a=new S.$Nd,this.onTunnelOpened=this.a.event,this.b=new S.$Nd,this.onTunnelClosed=this.b.event,this.c=new S.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const $=this.k.getValue("remote.localPortHost");return!$||$==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider($){return this.f=$,$?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures($){this.g=$.elevation,this.h=$.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const $=[],u=Array.from(this.e.values());for(const l of u){const E=Array.from(l.values());for(const h of E){const i=await h.value;i&&typeof i!="string"&&$.push(i)}}return $}async dispose(){for(const $ of this.e.values()){for(const{value:u}of $.values())await u.then(l=>typeof l!="string"?l?.dispose():void 0);$.clear()}this.e.clear()}setEnvironmentTunnel($,u,l,E,h){this.p($,u,Promise.resolve({tunnelRemoteHost:$,tunnelRemotePort:u,localAddress:l,privacy:E,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel($,u){(y($)||w($))&&($=e.$bv[0]);const l=this.r($,u);if(l)return++l.refcount,l.value}openTunnel($,u,l,E,h,i=!1,c,o){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${l} on local port ${h}.`);const t=this.f??$;if(!t)return;if(u||(u="localhost"),E||(E=this.l),this.f&&this.i.has(l)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,u,l,E,h,i,c,o);return n?n.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,l),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,l);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.n(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==l)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&r.privacy!==c&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n($){return{tunnelRemotePort:$.tunnelRemotePort,tunnelRemoteHost:$.tunnelRemoteHost,tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress,privacy:$.privacy,protocol:$.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${$.tunnelRemoteHost}:${$.tunnelRemotePort} `);const u=this.e.get($.tunnelRemoteHost);if(u){const l=u.get($.tunnelRemotePort);l&&(l.refcount--,await this.o($.tunnelRemoteHost,$.tunnelRemotePort,l))}}}}async o($,u,l){if(l.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${$}:${u}.`);const E=l.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has($)&&this.e.get($).delete(u),E}}async closeTunnel($,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${$}:${u} `);const l=this.e.get($);if(l&&l.has(u)){const E=l.get(u);E.refcount=0,await this.o($,u,E)}}p($,u,l){this.e.has($)||this.e.set($,new Map),this.e.get($).set(u,{refcount:1,value:l})}async q($,u){const l=this.e.get($);if(l){const E=l.get(u),h=E?await E.value:void 0;(!h||typeof h=="string")&&l.delete(u),l.size===0&&this.e.delete($)}}r($,u){const l=[$];w($)?(l.push(...e.$bv),l.push(...e.$dv)):y($)&&l.push(...e.$dv);const E=l.map(h=>this.e.get(h));for(const h of E){const i=h?.get(u);if(i)return i}}canTunnel($){return!!g($)}t($,u,l,E,h,i,c){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${l} on local port ${E}.`);const o=l;this.i.add(o);const t=E===void 0?l:E,n={elevationRequired:h?this.isPortPrivileged(t):!1},r={remoteAddress:{host:u,port:l},localAddressPort:E,privacy:i,public:i?i!==P.Private:void 0,protocol:c},p=$.forwardPort(r,n);return p?(this.p(u,l,p),p.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(o)})):this.i.delete(o),p}};e.$hv=m,e.$hv=m=Ee([te(0,O.$0i),te(1,R.$ji)],m)}),define(ie[48],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jU=e.$iU=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(R||(e.StateType=R={}));var s;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var O;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(O||(e.DisablementReason=O={})),e.$iU={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,P)=>({type:"idle",updateType:C,error:P}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$jU=(0,S.$Ph)("updateService")}),define(ie[264],ne([0,1,4,188,57,43]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.$gn.as(s.$ln.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:S.$j&&!S.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ie[265],ne([0,1,3,48]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=e.$t7b=void 0;class s{constructor(P){this.a=P}listen(P,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,a){switch(f){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${f}`)}}e.$t7b=s;class O{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Nd,this.onStateChange=this.a.event,this.b=R.$iU.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$u7b=O}),define(ie[40],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,S.$Ph)("IUriIdentityService")}),define(ie[266],ne([0,1,40,207,16,19,141,3,2]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let g=class{constructor(y){this.g=y,this.c=new f.$Rc,this.f=2**16;const d=new Map,v=m=>{let b=d.get(m.scheme);return b===void 0&&(b=y.hasProvider(m)&&!this.g.hasCapability(m,1024),d.set(m.scheme,b)),b};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(m=>{d.delete(m.scheme)})),this.extUri=new O.$kg(v),this.d=new C.$zr((m,b)=>this.extUri.compare(m,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,O.$wg)(y));const d=this.d.get(y);return d?d.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new a(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((v,m)=>v[1].time<m[1].time?1:v[1].time>m[1].time?-1:0);a._clock=0,this.d.clear();const d=this.f*.5;for(let v=0;v<d;v++)this.d.set(y[v][0],y[v][1].touch())}};e.$Ar=g,e.$Ar=g=Ee([te(0,s.$$j)],g),(0,R.$xr)(S.$Ik,g,1)}),define(ie[128],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0T=void 0,e.$0T=(0,S.$Ph)("urlService")}),define(ie[267],ne([0,1,7]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=e.$C7b=e.$B7b=void 0;class R{constructor(P){this.a=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,a){switch(f){case"handleURL":return this.a.handleURL(S.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${f}`)}}e.$B7b=R;class s{constructor(P){this.a=P}handleURL(P,f){return this.a.call("handleURL",[P.toJSON(),f])}}e.$C7b=s;class O{constructor(P,f){this.a=P,this.b=f}async routeCall(P,f,a,g){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(a)&&a.length>0){const w=S.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",w.toString(!0)),w.query){const y=/\bwindowId=(\d+)/.exec(w.query);if(y){const d=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,w.toString(!0));const v=new RegExp(`window:${d}`),m=P.connections.find(b=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",b.ctx),v.test(b.ctx)));if(m)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",w.toString(!0)),m;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",w.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",w.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,f,a,g)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.$D7b=O}),define(ie[268],ne([0,1,8,2,7,24]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_T=e.$$T=void 0;class C extends R.$Sc{constructor(){super(...arguments),this.a=new Set}open(a,g){const w=[...this.a.values()];return(0,S.$Xg)(w.map(y=>()=>y.handleURL(a,g)),void 0,!1).then(y=>y||!1)}registerHandler(a){return this.a.add(a),(0,R.$Qc)(()=>this.a.delete(a))}}e.$$T=C;let P=class extends C{constructor(a){super(),this.b=a}create(a){let{authority:g,path:w,query:y,fragment:d}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&w&&w.indexOf("/")!==0&&(w=`/${w}`),s.URI.from({scheme:this.b.urlProtocol,authority:g,path:w,query:y,fragment:d})}};e.$_T=P,e.$_T=P=Ee([te(0,O.$pj)],P)}),define(ie[269],ne([0,1,15,8,3,2,4,7]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7b=void 0;class f extends O.$Sc{constructor(g,w,y,d,v,m){if(super(),this.c=w,this.f=m,this.a=[],this.b=0,g&&(m.trace("ElectronURLListener initialUrisToHandle:",g.map(u=>u.originalUrl)),this.a=g),C.$j){const u=d.isBuilt?[]:[`"${d.appRoot}"`];u.push("--open-url","--"),S.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,u)}const b=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(u,l)=>({event:u,url:l})),({event:u,url:l})=>(u.preventDefault(),l));this.B(b(u=>{const l=this.g(u);l&&this.c.open(l,{originalUrl:u})})),y.getWindows().filter(u=>u.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return P.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const w of this.a)await this.c.open(w.uri,{originalUrl:w.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",w.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",w.originalUrl),g.push(w));g.length!==0&&(this.a=g,(0,R.$Vg)(()=>this.h(),500,this.q))}}e.$E7b=f}),define(ie[270],ne([0,1,3,2,16,56,31]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0;class P extends R.$Sc{constructor(a,g,w,y,d,v){super(),this.f=a,this.g=g,this.h=w,this.j=y,this.m=d,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Nd),this.onDidChangeFile=this.a.event,this.b=O.$Vh.forUris(()=>!(this.capabilities&1024)),this.c=new C.$Bc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,g){return this.g.open(this.t(a),g)}close(a){return this.g.close(a)}read(a,g,w,y,d){return this.g.read(a,g,w,y,d)}write(a,g,w,y,d){return this.g.write(a,g,w,y,d)}watch(a,g){this.b.set(a,a);const w=this.g.watch(this.t(a),g);return(0,R.$Qc)(()=>{this.b.delete(a),w.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,g,w){return this.g.rename(this.t(a),this.t(g),w)}readFile(a,g){return this.g.readFile(this.t(a),g)}readFileStream(a,g,w){return this.g.readFileStream(this.t(a),g,w)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,g,w){return this.g.writeFile(this.t(a),g,w)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,g){return this.g.delete(this.t(a),g)}copy(a,g,w){if((0,s.$ck)(this.g))return this.g.copy(this.t(a),this.t(g),w);throw new Error("copy not supported")}cloneFile(a,g){if((0,s.$dk)(this.g))return this.g.cloneFile(this.t(a),this.t(g));throw new Error("clone not supported")}s(a){const g=[];for(const w of a){if(w.resource.scheme!==this.f)continue;const y=this.u(w.resource);this.b.findSubstr(y)&&g.push({resource:y,type:w.type,cId:w.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$f8b=P}),define(ie[271],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0,e.$Y7b="utilityProcessWorker"}),define(ie[272],ne([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0,e.$F7b=(0,S.$Ph)("webviewManagerService")}),define(ie[273],ne([0,1,15,2,13,7]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;class C extends R.$Sc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,a){try{const g=O.URI.parse(f.url),w=C.a.get(g.path);if(typeof w=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${w}`,d=s.$cg.asFileUri(y);return a({path:d.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$G7b=C}),define(ie[68],ne([0,1,4]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=e.$3C=e.$2C=void 0,e.$2C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(g){return!!g.workspaceUri}e.$3C=R;function s(g){return!!g.folderUri}e.$4C=s;function O(g){return!!g.fileUri}e.$5C=O;function C(g){const w=P(g),y=g.getValue("window.menuBarVisibility");return y==="default"||w==="native"&&y==="compact"||S.$k&&S.$n?"classic":y}e.$6C=C;function P(g){if(S.$p)return"custom";const w=g.getValue("window");if(w){if(S.$k&&w.nativeTabs===!0||S.$k&&w.nativeFullScreen===!1)return"native";const v=w.titleBarStyle;if(v==="native"||v==="custom")return v}return S.$l?"native":"custom"}e.$7C=P;function f(g){return!(!S.$j||S.$p||P(g)==="native")}e.$8C=f;function a(g=0){return Math.pow(1.2,g)}e.$9C=a}),define(ie[95],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$$5b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var R;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(R||(e.UnloadReason=R={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$$5b=s;var O;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(O||(e.WindowMode=O={}));var C;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(C||(e.WindowError=C={}))}),define(ie[274],ne([0,1,8,3,2]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=void 0;class O extends s.$Sc{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:a}){super(),this.a=this.B(new s.$Rc),R.Event.latch(R.Event.any(P,f))(this.f,this,this.a),this.b=(0,S.$Hg)(()=>a()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$M7b=O}),define(ie[29],ne([0,1,192,9,56,19,7,5,13]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,P.$Ph)("contextService");function a(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}e.$Zh=a;function g(t){return typeof t?.id=="string"&&!a(t)&&!y(t)}e.$1h=g,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function w(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,R.$nc)(t)}:n?e.$2h:e.$3h;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$4h=w;function y(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}e.$5h=y;function d(t){const n=t;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:C.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}e.$6h=d;var v;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function m(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$7h=m;function b(t){const n=t;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$8h=b;class ${constructor(n,r,p,A,D){this.h=n,this.j=p,this.k=A,this.l=D,this.c=s.$Vh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Vh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=$;class u{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.$vg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=u;function l(t){return new u({uri:t,index:0,name:(0,O.$rg)(t)},{uri:t.toString()})}e.$$h=l,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,S.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function E(t,n){return O.$mg.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$di=E;function h(t){let n;return C.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===f.Schemas.tmp}e.$ei=h,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$fi}e.$gi=i;function c(t,n){return!E(t,n)&&!h(t)}e.$hi=c;function o(t){return(typeof t=="string"?(0,R.$oc)(t):(0,O.$tg)(t))===e.$ai}e.$ii=o}),define(ie[59],ne([0,1,15,8,55,46,2,84,4,21,167,116,5,6,24,29]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=e.$C6b=void 0,e.$C6b=(0,y.$Ph)("dialogMainService");let b=class{constructor(u,l){this.d=u,this.e=l,this.a=new Map,this.b=new Map,this.c=new R.$1g}pickFileFolder(u,l){return this.f({...u,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},l)}pickFolder(u,l){return this.f({...u,pickFolders:!0,title:(0,g.localize)(1,null)},l)}pickFile(u,l){return this.f({...u,pickFiles:!0,title:(0,g.localize)(2,null)},l)}pickWorkspace(u,l){const E=(0,g.localize)(3,null),h=(0,O.$yv)((0,g.localize)(4,null)),i=m.$bi;return this.f({...u,pickFiles:!0,title:E,filters:i,buttonLabel:h},l)}async f(u,l){const E={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(E.properties=void 0,u.pickFiles&&u.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$k&&E.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(E,(l||S.BrowserWindow.getFocusedWindow())??void 0);if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}g(u){if(u){let l=this.b.get(u.id);return l||(l=new R.$1g,this.b.set(u.id,l)),l}else return this.c}showMessageBox(u,l){return this.g(l).queue(async()=>{const{options:E,buttonIndeces:h}=(0,w.$Fv)(u,this.e);let i;return l?i=await S.dialog.showMessageBox(l,E):i=await S.dialog.showMessageBox(E),{response:h[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(u,l){const E=this.j(u,l);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(l).queue(async()=>{let h;return l?h=await S.dialog.showSaveDialog(l,u):h=await S.dialog.showSaveDialog(u),h.filePath=this.h(h.filePath),h})}finally{(0,C.$Nc)(E)}}h(u){return u&&f.$k&&(u=(0,P.$ol)(u)),u}i(u){return u.map(l=>this.h(l))}async showOpenDialog(u,l){u.defaultPath&&(await a.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const E=this.j(u,l);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(l).queue(async()=>{let h;return l?h=await S.dialog.showOpenDialog(l,u):h=await S.dialog.showOpenDialog(u),h.filePaths=this.i(h.filePaths),h})}finally{(0,C.$Nc)(E)}}j(u,l){if(!l)return C.$Sc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let E=this.a.get(l.id);E||(E=new Set,this.a.set(l.id,E));const h=(0,s.$Di)(u);if(!E.has(h))return this.d.trace("[DialogMainService]: new file dialog lock created",u),E.add(h),(0,C.$Qc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),E?.delete(h),E?.size===0&&this.a.delete(l.id)})}};e.$D6b=b,e.$D6b=b=Ee([te(0,d.$0i),te(1,v.$pj)],b)}),define(ie[275],ne([0,1,3,2,76,29]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0;class C extends R.$Sc{static{this.a=100}constructor(f,a){super(),this.f=f,this.g=a,this.b=this.B(new S.$Nd),this.c=new Map,this.h(a.applicationStorage,this.b)}h(f,a){this.B(S.Event.debounce(f.onDidChangeStorage,(g,w)=>(g?g.push(w):g=[w],g),C.a)(g=>{g.length&&a.fire(this.j(g,f))}))}j(f,a){const g=new Map,w=new Set;return f.forEach(y=>{const d=a.get(y.key);typeof d=="string"?g.set(y.key,d):w.add(y.key)}),{changed:Array.from(g.entries()),deleted:Array.from(w.values())}}listen(f,a,g){switch(a){case"onDidChangeStorage":{const w=g.profile?(0,s.$mh)(g.profile):void 0;if(!w)return this.b.event;let y=this.c.get(w.id);return y||(y=this.B(new S.$Nd),this.h(this.g.profileStorage(w),y),this.c.set(w.id,y)),y.event}}throw new Error(`Event not found: ${a}`)}async call(f,a,g){const w=g.profile?(0,s.$mh)(g.profile):void 0,y=(0,O.$6h)(g.workspace),d=await this.m(w,y);switch(a){case"getItems":return Array.from(d.items.entries());case"updateItems":{const v=g;if(v.insert)for(const[m,b]of v.insert)d.set(m,b);v.delete?.forEach(m=>d.delete(m));break}case"optimize":return d.optimize();case"isUsed":{const v=g.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${a}`)}}async m(f,a){let g;a?g=this.g.workspaceStorage(a):f?g=this.g.profileStorage(f):g=this.g.applicationStorage;try{await g.init()}catch(w){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":f?"profile":"application"} storage due to ${w}`)}return g}}e.$q7b=C}),define(ie[41],ne([0,1,55,3,2,19,7,189,36,16,5,6,29,31,40,8,32,27,12]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var l;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function E(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Jk=E,e.$Kk=(0,g.$Ph)("IUserDataProfilesService");function h(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:C.URI.revive(t.location).with({scheme:n}),globalStorageHome:C.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Lk=h;function i(t,n,r,p,A,D){return{id:t,name:n,location:r,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:D&&A?.useDefaultFlags?.globalState?D.globalStorageHome:(0,O.$vg)(r,"globalStorage"),settingsResource:D&&A?.useDefaultFlags?.settings?D.settingsResource:(0,O.$vg)(r,"settings.json"),keybindingsResource:D&&A?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,O.$vg)(r,"keybindings.json"),tasksResource:D&&A?.useDefaultFlags?.tasks?D.tasksResource:(0,O.$vg)(r,"tasks.json"),snippetsHome:D&&A?.useDefaultFlags?.snippets?D.snippetsHome:(0,O.$vg)(r,"snippets"),extensionsResource:D&&A?.useDefaultFlags?.extensions?D.extensionsResource:(0,O.$vg)(r,"extensions.json"),cacheHome:(0,O.$vg)(p,t),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$Mk=i;let c=class extends s.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,p,A){super(),this.t=n,this.u=r,this.w=p,this.y=A,this.f=!0,this.h=this.B(new R.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$Ac,emptyWindows:new Map},this.profilesHome=(0,O.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,u.$yf)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}r.push(i((0,O.$sg)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},n))}}catch(D){this.y.error(D)}const p=new d.$Ac,A=new Map;if(r.length)try{const D=this.Q();if(D.workspaces)for(const[k,I]of Object.entries(D.workspaces)){const j=C.URI.parse(k),N=r.find(z=>z.id===I);N&&p.set(j,N)}if(D.emptyWindows)for(const[k,I]of Object.entries(D.emptyWindows)){const j=r.find(N=>N.id===I);j&&A.set(k,j)}}catch(D){this.y.error(D)}this.z={profiles:r,workspaces:p,emptyWindows:A}}return this.z}D(){const n=i("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",p=new RegExp(`${(0,$.$Fe)(r)}\\s(\\d+)`);let A=0;for(const k of this.profiles){const I=p.exec(k.name),j=I?parseInt(I[1]):0;A=j>A?j:A}const D=`${r} ${A+1}`;return this.createProfile((0,S.$Di)((0,b.$eg)()).toString(16),D,{transient:!0},n)}async createNamedProfile(n,r,p){return this.createProfile((0,S.$Di)((0,b.$eg)()).toString(16),n,r,p)}async createProfile(n,r,p,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(n,r,p);return A&&await this.setProfileForWorkspace(A,D),D}async F(n,r,p){if(!(0,u.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(r);return A||(A=(async()=>{try{const D=this.profiles.find(j=>j.name===r||j.id===n);if(D)return D;const k=i(n,r,(0,O.$vg)(this.profilesHome,n),this.g,p,this.defaultProfile);await this.u.createFolder(k.location);const I=[];return this.j.fire({profile:k,join(j){I.push(j)}}),await m.Promises.settled(I),this.I([k],[],[]),k}finally{this.r.delete(r)}})(),this.r.set(r,A)),A}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(A=>A.id===n.id);if(!p)throw new Error(`Profile '${n.name}' does not exist`);return p=i(p.id,r.name??p.name,p.location,this.g,{shortName:r.shortName??p.shortName,icon:r.icon===null?void 0:r.icon??p.icon,transient:r.transient??p.isTransient,useDefaultFlags:r.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(A=>A.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const p=[];this.m.fire({profile:r,join(A){p.push(A)}});try{await Promise.allSettled(p)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(A){(0,a.$pk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(A=>A.id===r.id);if(!p)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,p)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return C.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,y.$Zh)(n)?n.uri:(0,y.$5h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,p){const A=[...this.profiles,...n],D=[];this.s.profiles=[];for(let k of A)k.isDefault||r.some(I=>k.id===I.id)||(k=p.find(I=>k.id===I.id)??k,k.isTransient?this.s.profiles.push(k):D.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(D),this.z=void 0,this.J(n,r,p)}J(n,r,p){this.h.fire({added:n,removed:r,updated:p,all:this.profiles})}L(n,r,p){p=r?.isTransient?!0:p,p||this.L(n,void 0,!0);const A=this.G(n),D=p?this.s:this.C;C.URI.isUri(A)?(D.workspaces.delete(A),r&&D.workspaces.set(A,r)):(D.emptyWindows.delete(A),r&&D.emptyWindows.set(A,r)),p||this.M()}M(){const n={};for(const[p,A]of this.C.workspaces.entries())n[p.toString()]=A.id;const r={};for(const[p,A]of this.C.emptyWindows.entries())r[p.toString()]=A.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},p=this.D();if(n.workspaces)for(const[D,k]of Object.entries(n.workspaces)){const I=C.URI.parse(k);r[D]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}const A={};if(n.emptyWindows)for(const[D,k]of Object.entries(n.emptyWindows)){const I=C.URI.parse(k);A[D]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}return{workspaces:r,emptyWindows:A}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Nk=c,e.$Nk=c=Ee([te(0,f.$Wh),te(1,a.$$j),te(2,v.$Ik),te(3,w.$0i)],c);class o extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ok=o}),define(ie[80],ne([0,1,8,17,2,3,31,7,118,124,16,5,6,41,40,12,14,26]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class l extends Error{constructor(o,t){super(o),this.code=t}}e.$up=l,e.$vp=(0,w.$Ph)("IExtensionsProfileScannerService");let E=class extends s.$Sc{constructor(o,t,n,r,p,A){super(),this.j=o,this.m=t,this.n=n,this.r=r,this.s=p,this.t=A,this.b=this.B(new O.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new O.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Ac}scanProfileExtensions(o,t){return this.u(o,void 0,t)}async addExtensionsToProfile(o,t){const n=[],r=[];try{return await this.u(t,p=>{const A=[];for(const D of p)o.some(([k])=>(0,a.$Ao)(k.identifier,D.identifier)&&k.manifest.version!==D.version)?n.push(D):A.push(D);for(const[D,k]of o){const I=A.findIndex(N=>(0,a.$Ao)(N.identifier,D.identifier)&&N.version===D.manifest.version),j={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:k};I===-1?(r.push(j),A.push(j)):A.splice(I,1,j)}return r.length&&this.b.fire({extensions:r,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),A}),r.length&&this.c.fire({extensions:r,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),r}catch(p){throw r.length&&this.c.fire({extensions:r,error:p,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:p,profileLocation:t}),p}}async updateMetadata(o,t){const n=[];return await this.u(t,r=>{const p=[];for(const A of r){const D=o.find(([k])=>(0,a.$Ao)(k.identifier,A.identifier)&&k.manifest.version===A.version);D&&(A.metadata={...A.metadata,...D[1]},n.push(A)),p.push(A)}return p}),n}async removeExtensionFromProfile(o,t){const n=[];try{await this.u(t,r=>{const p=[];for(const A of r)(0,a.$Ao)(A.identifier,o.identifier)?n.push(A):p.push(A);return n.length&&this.f.fire({extensions:n,profileLocation:t}),p}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:t}),r}}async u(o,t,n){return this.F(o).queue(async()=>{let r=[],p;try{const A=await this.m.readFile(o);p=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,g.$pk)(A)!==1)throw A;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&n?.bailOutWhenFileNotFound)throw new l((0,b.$0)(A),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(o);let A=!1;for(const D of p){h(D)||this.w(o);let k;if((0,m.$yf)(D.relativeLocation)&&D.relativeLocation)k=this.z(D.relativeLocation);else if((0,m.$yf)(D.location))k=this.z(D.location),A=!0,D.relativeLocation=D.location,D.location=k.toJSON();else{k=P.URI.revive(D.location);const I=this.y(k);I&&(A=!0,D.relativeLocation=I)}r.push({identifier:D.identifier,location:k,version:D.version,metadata:D.metadata})}A&&await this.m.writeFile(o,R.$be.fromString(JSON.stringify(p)))}if(t){r=t(r);const A=r.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(o,R.$be.fromString(JSON.stringify(A)))}return r})}w(o){const t=new l(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(o)).value.toString()}catch(p){if((0,g.$pk)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",o.toString());let r;try{const p=JSON.parse(n);Array.isArray(p)&&p.every(A=>h(A))?r=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,g.$pk)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(o)}catch(p){(0,g.$pk)(p)!==1&&this.t.error(p)}try{await this.m.del(t)}catch(p){(0,g.$pk)(p)!==1&&this.t.error(p)}return r})()),this.C}F(o){let t=this.h.get(o);return t||(t=new S.$1g,this.h.set(o,t)),t}};e.$wp=E,e.$wp=E=Ee([te(1,g.$$j),te(2,d.$Kk),te(3,v.$Ik),te(4,$.$cl),te(5,y.$0i)],E);function h(c){return(0,m.$Af)(c)&&(0,f.$0n)(c.identifier)&&(i(c.location)||(0,m.$yf)(c.location)&&c.location)&&((0,m.$Ff)(c.relativeLocation)||(0,m.$yf)(c.relativeLocation))&&c.version&&(0,m.$yf)(c.version)}function i(c){return c?(0,m.$yf)(c.path)&&(0,m.$yf)(c.scheme):!1}}),define(ie[129],ne([0,1,23,8,37,17,14,44,152,2,13,9,4,19,205,73,12,7,172,36,124,121,204,16,5,6,24,3,76,80,41,40,203]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h,i,c,o,t,n,r,p,A,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.Translations=void 0;var j;(function(ae){function Z(Q,G){if(Q===G)return!0;const q=Object.keys(Q),T=new Set;for(const K of Object.keys(G))T.add(K);if(q.length!==T.size)return!1;for(const K of q){if(Q[K]!==G[K])return!1;T.delete(K)}return T.size===0}ae.equals=Z})(j||(e.Translations=j={})),e.$zp=(0,o.$Ph)("IExtensionsScannerService");let N=class extends a.$Sc{constructor(Z,Q,G,q,T,K,H,x,B,F,M,U){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=Q,this.r=G,this.s=q,this.t=T,this.u=K,this.w=H,this.y=x,this.z=B,this.C=F,this.D=M,this.F=U,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,d.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Y,this.s,this.h)),this.m=this.B(this.F.createInstance(Y,this.s,this.h)),this.n=this.B(this.F.createInstance(_,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Lo)(this.w,this.y)),this.G}async scanAllExtensions(Z,Q,G){const[q,T]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(Q)]),K=G?await this.scanExtensionsUnderDevelopment(Z,[...q,...T]):[];return this.L(q,T,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const Q=[];Q.push(this.M(!!Z.useCache,Z.language)),Q.push(this.N(Z.language,!!Z.checkControlFile));const[G,q]=await Promise.all(Q);return this.J([...G,...q],0,Z,!1)}async scanUserExtensions(Z){const Q=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const G=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(Q,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,G),T=Z.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let K;try{K=await T.scanExtensions(q)}catch(H){if(H instanceof A.$up&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),K=await T.scanExtensions(q);else throw H}return K=await this.J(K,1,Z,!0),this.y.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(Z,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===g.Schemas.file).map(async q=>{const T=await this.P(q,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(T)).map(H=>(H.type=Q.find(x=>(0,E.$Ao)(x.identifier,H.identifier))?.type??H.type,this.n.validate(H,T)))}))).flat();return this.J(G,"development",Z,!0)}return[]}async scanExistingExtension(Z,Q,G){const q=await this.P(Z,!1,Q,!0,G.language,!0,void 0),T=await this.n.scanExtension(q);return!T||!G.includeInvalid&&!T.isValid?null:T}async scanOneOrMultipleExtensions(Z,Q,G){const q=await this.P(Z,!1,Q,!0,G.language,!0,void 0),T=await this.n.scanOneOrMultipleExtensions(q);return this.J(T,Q,G,!0)}async scanMetadata(Z){const Q=(0,d.$vg)(Z,"package.json"),G=(await this.w.readFile(Q)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(Z,Q){const G=(0,d.$vg)(Z,"package.json"),q=(await this.w.readFile(G)).value.toString(),T=JSON.parse(q);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,T.__metadata={...T.__metadata,...Q},await this.w.writeFile((0,d.$vg)(Z,"package.json"),O.$be.fromString(JSON.stringify(T,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof A.$up&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$be.fromString(JSON.stringify([])))}catch(Q){(0,c.$pk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,Q,G,q){return G.includeAllVersions||(Z=this.L(Q===0?Z:void 0,Q===1?Z:void 0,Q==="development"?Z:void 0,await this.getTargetPlatform(),q)),G.includeInvalid||(Z=Z.filter(T=>T.isValid)),Z.sort((T,K)=>{const H=w.$nc(T.location.fsPath),x=w.$nc(K.location.fsPath);return H<x?-1:H>x?1:0})}L(Z,Q,G,q,T){const K=(x,B,F)=>{if(x.isValid&&!B.isValid)return!1;if(x.isValid===B.isValid){if(T&&v.gt(x.manifest.version,B.manifest.version))return this.y.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(v.eq(x.manifest.version,B.manifest.version)){if(x.type===0)return this.y.debug(`Skipping extension ${B.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===q)return this.y.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${x.location.path} with ${B.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${B.location.path}.`),!0},H=new h.$8l;return Z?.forEach(x=>{const B=H.get(x.identifier.id);(!B||K(B,x,!1))&&H.set(x.identifier.id,x)}),Q?.forEach(x=>{const B=H.get(x.identifier.id);if(!B&&Z&&x.type===0){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!B||K(B,x,!1))&&H.set(x.identifier.id,x)}),G?.forEach(x=>{const B=H.get(x.identifier.id);(!B||K(B,x,!0))&&H.set(x.identifier.id,x),H.set(x.identifier.id,x)}),[...H.values()]}async M(Z,Q){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),T=await(Z&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",T.length),T}async N(Z,Q){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const q=Q?await this.O():{},T=[],K=$.URI.file(w.$hc(w.$jc(g.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of G){const B=q[x.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":T.push((0,d.$vg)(K,x.name));break;default:T.push($.URI.file(B));break}}const H=await Promise.all(T.map(async x=>this.n.scanExtension(await this.P(x,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",H.length),(0,S.$Hb)(H)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,Q,G,q,T,K,H){const x=await this.f(T??y.$w),B=await this.Q(Z),F=Q&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=F?await this.Q(F):void 0;return new z(Z,B,F,M,Q,H,G,q,K,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,T,x)}async Q(Z){try{const Q=await this.w.stat(Z);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$Ap=N,e.$Ap=N=Ee([te(4,D.$Kk),te(5,A.$vp),te(6,c.$$j),te(7,t.$0i),te(8,l.$Wh),te(9,n.$pj),te(10,k.$Ik),te(11,o.$Oh)],N);class z{constructor(Z,Q,G,q,T,K,H,x,B,F,M,U,W,L,V){this.location=Z,this.mtime=Q,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=q,this.profile=T,this.profileScanOptions=K,this.type=H,this.excludeObsolete=x,this.validate=B,this.productVersion=F,this.productDate=M,this.productCommit=U,this.devMode=W,this.language=L,this.translations=V}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,Q){return(0,d.$og)(Z.location,Q.location)&&Z.mtime===Q.mtime&&(0,d.$og)(Z.applicationExtensionslocation,Q.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&Z.profile===Q.profile&&s.$$m(Z.profileScanOptions,Q.profileScanOptions)&&Z.type===Q.type&&Z.excludeObsolete===Q.excludeObsolete&&Z.validate===Q.validate&&Z.productVersion===Q.productVersion&&Z.productDate===Q.productDate&&Z.productCommit===Q.productCommit&&Z.devMode===Q.devMode&&Z.language===Q.language&&j.equals(Z.translations,Q.translations)}}e.$Bp=z;let _=class extends a.$Sc{constructor(Z,Q,G,q,T){super(),this.f=Z,this.g=Q,this.h=G,this.j=q,this.m=T}async scanExtensions(Z){const Q=Z.profile?await this.r(Z):await this.n(Z);let G={};if(Z.excludeObsolete&&Z.type===1)try{const q=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(q)}catch{}return(0,b.$Lf)(G)?Q:Q.filter(q=>!G[E.$Bo.create(q).toString()])}async n(Z){const Q=await this.j.resolve(Z.location);if(!Q.children?.length)return[];const G=await Promise.all(Q.children.map(async q=>{if(!q.isDirectory||Z.type===1&&(0,d.$sg)(q.resource).indexOf(".")===0)return null;const T=new z(q.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(T)}));return(0,S.$Hb)(G).sort((q,T)=>q.location.path<T.location.path?-1:1)}async r(Z){let Q=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){Q=Q.filter(q=>!q.metadata?.isApplicationScoped);const G=await this.s(Z.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,Z);Q.push(...G)}return Q}async s(Z,Q,G){const q=await this.g.scanProfileExtensions(Z,G.profileScanOptions);if(!q.length)return[];const T=await Promise.all(q.map(async K=>{if(Q(K)){const H=new z(K.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(H,K.metadata)}return null}));return(0,S.$Hb)(T)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,d.$vg)(Z.location,"package.json"))){const Q=await this.scanExtension(Z);return Q?[Q]:[]}else return await this.scanExtensions(Z)}catch(Q){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,C.$0)(Q)),[]}}async scanExtension(Z,Q){try{let G=await this.scanExtensionManifest(Z.location);if(G){G.publisher||(G.publisher=h.$2l),Q=Q??G.__metadata,delete G.__metadata;const q=(0,E.$Fo)(G.publisher,G.name),T=Q?.id?{id:q,uuid:Q.id}:{id:q},K=Q?.isSystem?0:Z.type,H=K===0||!!Q?.isBuiltin;G=await this.t(Z.location,G,z.createNlsConfiguration(Z));const x={type:K,identifier:T,manifest:G,location:Z.location,isBuiltin:H,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return Z.validate?this.validate(x,Z):x}}catch(G){Z.type!==0&&this.m.error(G)}return null}validate(Z,Q){let G=!0;const q=(0,i.$Qo)(Q.productVersion,Q.productDate,Q.location,Z.manifest,Z.isBuiltin);for(const[T,K]of q)T===m.default.Error&&(G=!1,this.m.error(this.z(Q.location,K)));return Z.isValid=G,Z.validations=q,Z}async scanExtensionManifest(Z){const Q=(0,d.$vg)(Z,"package.json");let G;try{G=(await this.j.readFile(Q)).value.toString()}catch(T){return(0,c.$pk)(T)!==1&&this.m.error(this.z(Z,(0,u.localize)(0,null,Q.path,T.message))),null}let q;try{q=JSON.parse(G)}catch{const K=[];(0,P.$Wm)(G,K);for(const H of K)this.m.error(this.z(Z,(0,u.localize)(1,null,Q.path,H.offset,H.length,(0,f.$xp)(H.error))));return null}return(0,P.$6m)(q)!=="object"?(this.m.error(this.z(Z,(0,u.localize)(2,null,Q.path))),null):q}async t(Z,Q,G){const q=await this.u(Z,Q,G);if(q)try{const T=[],K=await this.w(q.default,T);if(T.length>0)return T.forEach(x=>{this.m.error(this.z(Z,(0,u.localize)(3,null,q.default?.path,(0,f.$xp)(x.error))))}),Q;if((0,P.$6m)(q)!=="object")return this.m.error(this.z(Z,(0,u.localize)(4,null,q.default?.path))),Q;const H=q.values||Object.create(null);return(0,I.$yp)(this.m,Q,H,K)}catch{}return Q}async u(Z,Q,G){const q=(0,d.$vg)(Z,"package.nls.json"),T=(B,F)=>{F.forEach(M=>{this.m.error(this.z(Z,(0,u.localize)(5,null,B?.path,(0,f.$xp)(M.error))))})},K=B=>{this.m.error(this.z(Z,(0,u.localize)(6,null,B?.path)))},H=`${Q.publisher}.${Q.name}`,x=G.translations[H];if(x)try{const B=$.URI.file(x),F=(await this.j.readFile(B)).value.toString(),M=[],U=(0,P.$Wm)(F,M);return M.length>0?(T(B,M),{values:void 0,default:q}):(0,P.$6m)(U)!=="object"?(K(B),{values:void 0,default:q}):{values:U.contents?U.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.j.exists(q))return;let F;try{F=await this.y(Z,G)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const M=(await this.j.readFile(F.localized)).value.toString(),U=[],W=(0,P.$Wm)(M,U);return U.length>0?(T(F.localized,U),{values:void 0,default:F.original}):(0,P.$6m)(W)!=="object"?(K(F.localized),{values:void 0,default:F.original}):{values:W,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(Z,Q){if(Z)try{const G=(await this.j.readFile(Z)).value.toString();return(0,P.$Wm)(G,Q)}catch{}}y(Z,Q){return new Promise((G,q)=>{const T=K=>{const H=(0,d.$vg)(Z,`package.nls.${K}.json`);this.j.exists(H).then(x=>{x&&G({localized:H,original:(0,d.$vg)(Z,"package.nls.json")});const B=K.lastIndexOf("-");B===-1?G({localized:(0,d.$vg)(Z,"package.nls.json"),original:null}):(K=K.substring(0,B),T(K))})};if(Q.devMode||Q.pseudo||!Q.language)return G({localized:(0,d.$vg)(Z,"package.nls.json"),original:null});T(Q.language)})}z(Z,Q){return`[${Z.path}]: ${Q}`}};_=Ee([te(1,A.$vp),te(2,k.$Ik),te(3,c.$$j),te(4,t.$0i)],_);let Y=class extends _{constructor(Z,Q,G,q,T,K,H){super(Q,q,T,K,H),this.G=Z,this.H=G,this.D=this.B(new R.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const Q=this.M(Z),G=await this.I(Q);if(this.C=Z,G&&G.input&&z.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),G.result.map(T=>(T.location=$.URI.revive(T.location),T));const q=await super.scanExtensions(Z);return await this.J(Q,{input:Z,result:q}),q}async I(Z){try{const Q=await this.j.readFile(Z),G=JSON.parse(Q.value.toString());return{result:G.result,input:(0,p.$mh)(G.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",Z.path,(0,C.$0)(Q))}return null}async J(Z,Q){try{await this.j.writeFile(Z,O.$be.fromString(JSON.stringify(Q)))}catch(G){this.m.debug("Error while writing the extension cache file:",Z.path,(0,C.$0)(G))}}async L(){if(!this.C)return;const Z=this.M(this.C),Q=await this.I(Z);if(!Q)return;const G=Q.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$$m(q,G))try{this.m.info("Invalidating Cache",G,q),await this.j.del(Z),this.F.fire()}catch(T){this.m.error(T)}}M(Z){const Q=this.N(Z);return this.h.extUri.joinPath(Q.cacheHome,Z.type===0?h.$1l:h.$Zl)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(Z.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};Y=Ee([te(2,D.$Kk),te(3,A.$vp),te(4,k.$Ik),te(5,c.$$j),te(6,t.$0i)],Y);function ce(ae,Z){const Q=(0,E.$Do)(ae.manifest.publisher,ae.manifest.name);return{id:Q,identifier:new h.$6l(Q),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:Z,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$Cp=ce;class re extends N{constructor(Z,Q,G,q,T,K,H,x,B,F,M,U){super(Z,Q,(0,d.$vg)(G,".vscode-oss-dev","extensions","control.json"),q,T,K,H,x,B,F,M,U),this.R=(async()=>{if(y.$z)try{const W=await this.w.readFile($.URI.file(y.$z));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$Dp=re}),define(ie[276],ne([0,1,6,41,40,26,80,16,36,7]),function(X,e,S,R,s,O,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;let g=class extends C.$wp{constructor(y,d,v,m,b,$){super(a.URI.file(y.extensionsPath),d,v,m,b,$)}};e.$DN=g,e.$DN=g=Ee([te(0,f.$Xh),te(1,P.$$j),te(2,R.$Kk),te(3,s.$Ik),te(4,O.$cl),te(5,S.$0i)],g)}),define(ie[277],ne([0,1,7,36,80,129,16,5,6,24,40,41]),function(X,e,S,R,s,O,C,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q7b=void 0;let y=class extends O.$Dp{constructor(v,m,b,$,u,l,E,h){super(S.URI.file(u.builtinExtensionsPath),S.URI.file(u.extensionsPath),u.userHome,v.defaultProfile,v,m,b,$,u,l,E,h)}};e.$Q7b=y,e.$Q7b=y=Ee([te(0,w.$Kk),te(1,s.$vp),te(2,C.$$j),te(3,f.$0i),te(4,R.$Xh),te(5,a.$pj),te(6,g.$Ik),te(7,P.$Oh)],y)}),define(ie[278],ne([0,1,15,2,13,9,4,56,7,32,38,36,6,41]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97b=void 0;let v=class extends R.$Sc{constructor(b,$,u){super(),this.c=b,this.f=u,this.a=P.$Vh.forPaths(!C.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(b.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:b}=S.session;b.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,($,u)=>this.j($,u)),b.protocol.interceptFileProtocol(s.Schemas.file,($,u)=>this.h($,u)),this.B((0,R.$Qc)(()=>{b.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(b){const $=(0,O.$hc)(b);return this.a.get($)?R.$Sc.None:(this.a.set($,!0),(0,R.$Qc)(()=>this.a.delete($)))}h(b,$){const u=f.URI.parse(b.url);return this.f.error(`Refused to load resource ${u.fsPath} from ${s.Schemas.file}: protocol (original URL: ${b.url})`),$({error:-3})}j(b,$){const u=this.m(b);let l;return this.c.crossOriginIsolated&&((0,O.$nc)(u)==="workbench.html"||(0,O.$nc)(u)==="workbench-dev.html"?l=s.COI.CoopAndCoep:l=s.COI.getHeadersFromQuery(b.url)),this.a.findSubstr(u)?$({path:u,headers:l}):this.b.has((0,O.$oc)(u).toLowerCase())?$({path:u}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${u} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),$({error:-3}))}m(b){const $=f.URI.parse(b.url),u=s.$cg.uriToFileUri($);return(0,O.$hc)(u.fsPath)}createIPCObjectUrl(){let b;const $=f.URI.from({scheme:"vscode",path:(0,a.$eg)()}),u=$.toString(),l=async()=>b;return g.$jT.handle(u,l),this.f.trace(`IPC Object URL: Registered new channel ${u}.`),{resource:$,update:E=>b=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${u}.`),g.$jT.removeHandler(u)}}}};e.$97b=v,e.$97b=v=Ee([te(0,w.$Xh),te(1,d.$Kk),te(2,y.$0i)],v)}),define(ie[96],ne([0,1,8,3,2,65,12,111,5,41]),function(X,e,S,R,s,O,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7o=e.$6o=e.$5o=void 0,e.$5o="__$__isNewStorageMarker",e.$6o="__$__targetStorageMarker",e.$7o=(0,f.$Ph)("storageService");var g;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var w;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var y;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function d(u){const l=u.get(e.$6o);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.$8o=d;class v extends s.$Sc{static{this.a=60*1e3}constructor(l={flushInterval:v.a}){super(),this.m=l,this.b=this.B(new R.$Qd),this.c=this.B(new R.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new S.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,E,h){return R.Event.filter(this.b.event,i=>i.scope===l&&(E===void 0||i.key===E),h)}n(){this.j.value=(0,S.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,E){const{key:h,external:i}=E;if(h===e.$6o){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:h,target:this.J(l)[h],external:i})}w(l){this.f.fire({reason:l})}get(l,E,h){return this.P(E)?.get(l,h)}getBoolean(l,E,h){return this.P(E)?.getBoolean(l,h)}getNumber(l,E,h){return this.P(E)?.getNumber(l,h)}getObject(l,E,h){return this.P(E)?.getObject(l,h)}storeAll(l,E){this.y(()=>{for(const h of l)this.store(h.key,h.value,h.scope,h.target,E)})}store(l,E,h,i,c=!1){if((0,C.$Hf)(E)){this.remove(l,h,c);return}this.y(()=>{this.z(l,h,i),this.P(h)?.set(l,E,c)})}remove(l,E,h=!1){this.y(()=>{this.z(l,E,void 0),this.P(E)?.delete(l,h)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,E){const h=[],i=this.J(l);for(const c of Object.keys(i))i[c]===E&&h.push(c);return h}z(l,E,h,i=!1){const c=this.J(E);typeof h=="number"?c[l]!==h&&(c[l]=h,this.P(E)?.set(e.$6o,JSON.stringify(c),i)):typeof c[l]=="number"&&(delete c[l],this.P(E)?.set(e.$6o,JSON.stringify(c),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const E=this.P(l);return E?d(E):Object.create(null)}isNew(l){return this.getBoolean(e.$5o,l)===!0}async flush(l=g.NONE){this.f.fire({reason:l});const E=this.P(-1),h=this.P(0),i=this.P(1);switch(l){case g.NONE:await S.Promises.settled([E?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await S.Promises.settled([E?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return $(l,E,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,E){return this.w(g.NONE),(0,a.$Jk)(l)?this.R(l,E):this.S(l,E)}M(l,E){return!(l.id===E.id||m(E)&&m(l))}N(l,E,h){this.y(()=>{const i=new Set;for(const[c,o]of l)i.add(c),E.get(c)!==o&&this.u(h,{key:c,external:!0});for(const[c]of E.items)i.has(c)||this.u(h,{key:c,external:!0})})}}e.$9o=v;function m(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$0o=m;class b extends v{constructor(){super(),this.U=this.B(new P.$3o(new P.$4o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$3o(new P.$4o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$3o(new P.$4o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$$o=b;async function $(u,l,E,h,i,c){const o=j=>{try{return JSON.parse(j)}catch{return j}},t=new Map,n=new Map;u.forEach((j,N)=>{t.set(N,j),n.set(N,o(j))});const r=new Map,p=new Map;l.forEach((j,N)=>{r.set(N,j),p.set(N,o(j))});const A=new Map,D=new Map;E.forEach((j,N)=>{A.set(N,j),D.set(N,o(j))}),console.group(h!==i?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const k=[];if(t.forEach((j,N)=>{k.push({key:N,value:j})}),console.table(k),console.groupEnd(),console.log(n),h!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const j=[];r.forEach((N,z)=>{j.push({key:z,value:N})}),console.table(j),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${c})`);const I=[];A.forEach((j,N)=>{I.push({key:N,value:j})}),console.table(I),console.groupEnd(),console.log(D)}e.$_o=$}),define(ie[279],ne([0,1,23,8,3,2,9,72,7,21,111,161,6,96,26,29,13]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=e.$f6b=e.$e6b=e.$d6b=void 0;class $ extends O.$Sc{static{this.a=2e3}get storage(){return this.f}constructor(o,t){super(),this.m=o,this.n=t,this.b=this.B(new s.$Nd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Nd),this.onDidCloseStorage=this.c.event,this.f=this.B(new g.$3o(new g.$4o,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$ch,this.whenInit=this.h.p,this.j=g.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===g.StorageState.None)try{const o=this.B(await this.t());this.f.dispose(),this.f=o,this.B(o.onDidChangeStorage(n=>this.b.fire(n))),await this.s(o);const t=o.getBoolean(d.$5o);t===void 0?o.set(d.$5o,!0):t&&o.set(d.$5o,!1)}catch(o){this.m.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.j=g.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?o=>this.m.trace(o):void 0,logError:o=>this.m.error(o)}}s(o){return o.init()}get items(){return this.f.items}get(o,t){return this.f.get(o,t)}set(o,t){return this.f.set(o,t)}delete(o){return this.f.delete(o)}optimize(){return this.f.optimize()}async close(){const o=new P.$Jd(!1);await this.w(),o.stop(),o.elapsed()>$.a&&await this.u(o),this.c.fire()}async u(o){if(this.path)try{const t=(0,S.top)(Array.from(this.f.items.entries()).map(([r,p])=>({key:r,length:p.length})),(r,p)=>p.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=g.StorageState.Closed,await this.f.close()}}class u extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$jc)(this.z.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,u.y)}constructor(o,t,n,r){super(n,r),this.z=o,this.C=t}async t(){return new g.$3o(new w.$OT(this.path??w.$OT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class l extends u{constructor(o,t,n,r){super(o,t,n,r)}}e.$d6b=l;class E extends u{constructor(o,t,n,r){super(t.defaultProfile,o,n,r)}async s(o){await super.s(o),this.G(o)}G(o){o.get(v.$fl,void 0)===void 0&&o.set(v.$fl,new Date().toUTCString());const n=o.get(v.$el,void 0),r=new Date().toUTCString();o.set(v.$gl,typeof n>"u"?null:n),o.set(v.$el,r)}}e.$e6b=E;class h extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$jc)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id,h.y)}constructor(o,t,n,r,p){super(n,p),this.C=o,this.D=t,this.F=r}async t(){const{storageFilePath:o,wasCreated:t}=await this.H();return new g.$3o(new w.$OT(o,{logging:this.r()}),{hint:this.D.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:t?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:w.$OT.IN_MEMORY_PATH,wasCreated:!0};const o=(0,C.$jc)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id),t=(0,C.$jc)(o,h.y);return await a.Promises.exists(o)?{storageFilePath:t,wasCreated:!1}:(await a.Promises.mkdir(o,{recursive:!0}),this.I(o),{storageFilePath:t,wasCreated:!0})}async I(o){let t;if((0,m.$Zh)(this.C)?t={folder:this.C.uri.toString()}:(0,m.$5h)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,C.$jc)(o,h.z);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$f6b=h;class i extends ${get path(){}async t(){return new g.$3o(new g.$4o,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.$g6b=i}),define(ie[280],ne([0,1,3,2,96]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=void 0;class O extends R.$Sc{constructor(P,f,a){super(),this.b=P,this.c=f,this.f=a;const g=this.B(new R.$Tc);this.a=this.B(new S.$Nd({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new R.$Rc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,a)=>(f?f.push(a.key):f=[a.key],f),100)(f=>this.h(f))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(f,a)=>{f||(f=new Map);let g=f.get(a.profile.id);return g||f.set(a.profile.id,g={profile:a.profile,keys:[],storage:a.storage}),g.keys.push(a.key),f},100)(f=>this.j(f))),P}h(P){const f=P.includes(s.$6o)?[this.c.defaultProfile]:[],a=[];if(P=P.filter(g=>g!==s.$6o),P.length){const g=(0,s.$8o)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:P.map(w=>({key:w,scope:0,target:g[w]}))})}this.m(f,a)}j(P){const f=[],a=new Map;for(const[g,w]of P.entries()){w.keys.includes(s.$6o)&&f.push(w.profile);const y=w.keys.filter(d=>d!==s.$6o);if(y.length){const d=(0,s.$8o)(w.storage.storage);a.set(g,{profile:w.profile,changes:y.map(v=>({key:v,scope:0,target:d[v]}))})}}this.m(f,[...a.values()])}m(P,f){(P.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:P})}listen(P,f,a){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(P,f){throw new Error(`Call not found: ${f}`)}}e.$S7b=O}),define(ie[281],ne([0,1,7,36,16,6,34,40,41,12,122]),function(X,e,S,R,s,O,C,P,f,a,g){"use strict";var w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=e.$BN=e.$AN=void 0;let d=class extends f.$Nk{static{w=this}static{this.a="profileAssociationsMigration"}constructor($,u,l,E,h){super(l,E,u,h),this.U=$,this.W=l}O(){return this.U.getItem(w.b,[]).map(u=>({...u,location:(0,a.$yf)(u.location)?this.w.extUri.joinPath(this.profilesHome,u.location):S.URI.revive(u.location)}))}Q(){const $=this.U.getItem(w.c,{});return this.U.getItem(w.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$AN=d,e.$AN=d=w=Ee([te(0,C.$vN),te(1,P.$Ik),te(2,R.$Xh),te(3,s.$$j),te(4,O.$0i)],d);let v=y=class extends d{constructor($,u,l,E,h){super($,u,l,E,h),this.$=$}P($){$.length?this.$.setItem(y.b,$.map(u=>({...u,location:this.w.extUri.basename(u.location)}))):this.$.removeItem(y.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(y.c,$):this.$.removeItem(y.c)}Q(){const $="workspaceAndProfileInfo",u=this.$.getItem($,void 0);if(u){this.$.removeItem($);const E=u.reduce((h,{workspace:i,profile:c})=>(h[S.URI.revive(i).toString()]=S.URI.revive(c).toString(),h),{});this.$.setItem(y.c,{workspaces:E})}const l=super.Q();return this.$.getItem(y.a,!1)||(this.R(l),this.$.setItem(y.a,!0)),l}};e.$BN=v,e.$BN=v=y=Ee([te(0,C.$wN),te(1,P.$Ik),te(2,R.$Xh),te(3,s.$$j),te(4,O.$0i)],v);let m=class extends v{constructor($,u,l,E){super(new g.$zN(0,u,E,l),$,u,l,E)}async init(){return await this.$.init(),super.init()}};e.$CN=m,e.$CN=m=Ee([te(0,P.$Ik),te(1,R.$Xh),te(2,s.$$j),te(3,O.$0i)],m)}),define(ie[52],ne([0,1,36,16,5,6,40,41,281,34]),function(X,e,S,R,s,O,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i6b=e.$h6b=void 0,e.$h6b=(0,s.$Qh)(P.$Kk);let g=class extends f.$BN{constructor(y,d,v,m,b){super(y,d,v,m,b)}getAssociatedEmptyWindows(){const y=[];for(const d of this.C.emptyWindows.keys())y.push({id:d});return y}};e.$i6b=g,e.$i6b=g=Ee([te(0,a.$wN),te(1,C.$Ik),te(2,S.$Xh),te(3,R.$$j),te(4,O.$0i)],g)}),define(ie[130],ne([0,1,19,7,29]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=e.$F6b=e.$E6b=void 0;async function O(f,a,g){for(const y of f){const d=y.openedWorkspace;if((0,s.$5h)(d)){const v=await g(d);if(v){if(v.folders.some(m=>S.$mg.isEqualOrParent(a,m.uri)))return y}else if(S.$mg.isEqualOrParent(a,d.configPath))return y}}const w=f.filter(y=>(0,s.$Zh)(y.openedWorkspace)&&S.$mg.isEqualOrParent(a,y.openedWorkspace.uri));if(w.length)return w.sort((y,d)=>-(y.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.$E6b=O;function C(f,a){for(const g of f)if((0,s.$5h)(g.openedWorkspace)&&S.$mg.isEqual(g.openedWorkspace.configPath,a)||(0,s.$Zh)(g.openedWorkspace)&&S.$mg.isEqual(g.openedWorkspace.uri,a))return g}e.$F6b=C;function P(f,a){const g=w=>a.some(y=>S.$mg.isEqual(R.URI.file(y),R.URI.file(w)));for(const w of f)if(w.config?.extensionDevelopmentPath?.some(y=>g(y)))return w}e.$G6b=P}),define(ie[97],ne([0,1,33,44,139,46,13,9,4,19,7,5,58,29]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PU=e.$OU=e.$NU=e.$MU=e.$LU=e.$KU=e.$JU=e.$IU=e.$HU=e.$GU=void 0,e.$GU=(0,w.$Ph)("workspacesService");function v(D){return D.hasOwnProperty("workspace")}e.$HU=v;function m(D){return D.hasOwnProperty("folderUri")}e.$IU=m;function b(D){return D.hasOwnProperty("fileUri")}e.$JU=b;function $(D){return u(D)||l(D)}e.$KU=$;function u(D){const k=D;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function l(D){const k=D;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function E(D,k,I,j,N){if(D.scheme!==j.scheme)return{name:I,uri:D.toString(!0)};let z=k?void 0:N.relativePath(j,D);if(z!==void 0)z.length===0?z=".":f.$j&&(z=h(z));else if(D.scheme===C.Schemas.file)z=D.fsPath,f.$j&&(z=h(z));else if(N.isEqualAuthority(D.authority,j.authority))z=D.path;else return{name:I,uri:D.toString(!0)};return{name:I,path:z}}e.$LU=E;function h(D){return D=(0,O.$sv)(D),(0,S.$Uf)(D)||(D=(0,S.$Rf)(D)),D}function i(D,k,I){const j=[],N=new Set,z=I.dirname(k);for(const _ of D){let Y;if(u(_))_.path&&(Y=I.resolvePath(z,_.path));else if(l(_))try{Y=g.URI.parse(_.uri),Y.path[0]!==P.$gc.sep&&(Y=Y.with({path:P.$gc.sep+Y.path}))}catch(ce){console.warn(ce)}if(Y){const ce=I.getComparisonKey(Y);if(!N.has(ce)){N.add(ce);const re=_.name||I.basenameOrAuthority(Y);j.push(new d.$0h({uri:Y,name:re,index:j.length},_))}}}return j}e.$MU=i;function c(D,k,I,j,N){const z=o(k,D),_=N.dirname(k),Y=N.dirname(j),ce=[];for(const Q of z.folders){const G=u(Q)?N.resolvePath(_,Q.path):g.URI.parse(Q.uri);let q;I?q=!1:q=!u(Q)||(0,P.$ic)(Q.path),ce.push(E(G,q,Q.name,Y,N))}const re={insertSpaces:!1,tabSize:4,eol:f.$l||f.$k?`
`:`\r
`},ae=s.$4S(D,["folders"],ce,re);let Z=s.$7S(D,ae);return(0,a.$Ag)(z.remoteAuthority,(0,y.$Uk)(j))&&(Z=s.$7S(Z,s.$3S(Z,["remoteAuthority"],re))),Z}e.$NU=c;function o(D,k){const I=R.$Wm(k);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(j=>$(j));else throw new Error(`${D} looks like an invalid workspace file.`);return I}function t(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function n(D){return typeof D.folderUri=="string"}function r(D){return typeof D.fileUri=="string"}function p(D,k){const I={workspaces:[],files:[]};if(D){const j=function(z,_){for(let Y=0;Y<z.length;Y++)try{_(z[Y],Y)}catch(ce){k.warn(`Error restoring recent entry ${JSON.stringify(z[Y])}: ${ce.toString()}. Skip entry.`)}},N=D;Array.isArray(N.entries)&&j(N.entries,z=>{const _=z.label,Y=z.remoteAuthority;t(z)?I.workspaces.push({label:_,remoteAuthority:Y,workspace:{id:z.workspace.id,configPath:g.URI.parse(z.workspace.configPath)}}):n(z)?I.workspaces.push({label:_,remoteAuthority:Y,folderUri:g.URI.parse(z.folderUri)}):r(z)&&I.files.push({label:_,remoteAuthority:Y,fileUri:g.URI.parse(z.fileUri)})})}return I}e.$OU=p;function A(D){const k={entries:[]};for(const I of D.workspaces)m(I)?k.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):k.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of D.files)k.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return k}e.$PU=A}),define(ie[98],ne([0,1,85,13,4,19]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=e.$y6b=e.$x6b=e.$w6b=void 0,e.$w6b=128/4;function C(a){function g(){let w=a.scheme===R.Schemas.file?(0,O.$jg)(a):a.toString();return s.$l||(w=w.toLowerCase()),(0,S.createHash)("md5").update(w).digest("hex")}return{id:g(),configPath:a}}e.$x6b=C;function P(a,g){function w(){if(a.scheme!==R.Schemas.file)return(0,S.createHash)("md5").update(a.toString()).digest("hex");if(!g)return;let d;return s.$l?d=g.ino:s.$k?d=g.birthtime.getTime():s.$j&&(typeof g.birthtimeMs=="number"?d=Math.floor(g.birthtimeMs):d=g.birthtime.getTime()),(0,S.createHash)("md5").update(a.fsPath).update(d?String(d):"").digest("hex")}const y=w();if(typeof y=="string")return{id:y,uri:a}}e.$y6b=P;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$z6b=f}),define(ie[99],ne([0,1,85,86,28,282,17,14,3,2,9,4,32,42,109]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;class m{traceSocketEvent(k,I){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,I)}constructor(k,I=""){this.f=!0,this.debugLabel=I,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,P.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const I=j=>{this.traceSocketEvent("read",j),k(C.$be.wrap(j))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(k){const I=j=>{k({type:0,hadError:j,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(k){const I=()=>{k()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,P.$1)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,P.$1)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Eh=m;var b;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var $;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})($||($={}));class u extends a.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,I){this.socket.traceSocketEvent(k,I)}constructor(k,I,j,N){super(),this.f=this.B(new f.$Nd),this.g=this.B(new f.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:j?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new l(this,I,j,N,this.f,(z,_)=>this.m(z,_))),this.B(this.a.onError(z=>{console.error(z),(0,P.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$zh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let I=0;for(;I<k.byteLength;)this.a.writeMessage(k.slice(I,Math.min(I+262144,k.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(k,{compressed:I,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let N=2;k.byteLength<126?N+=0:k.byteLength<2**16?N+=2:N+=8;const z=C.$be.alloc(N),_=I?64:0,Y=j&15;if(z.writeUInt8(128|_|Y,0),k.byteLength<126)z.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){z.writeUInt8(126,1);let ce=1;z.writeUInt8(k.byteLength>>>8&255,++ce),z.writeUInt8(k.byteLength>>>0&255,++ce)}else{z.writeUInt8(127,1);let ce=1;z.writeUInt8(0,++ce),z.writeUInt8(0,++ce),z.writeUInt8(0,++ce),z.writeUInt8(0,++ce),z.writeUInt8(k.byteLength>>>24&255,++ce),z.writeUInt8(k.byteLength>>>16&255,++ce),z.writeUInt8(k.byteLength>>>8&255,++ce),z.writeUInt8(k.byteLength>>>0&255,++ce)}this.socket.write(C.$be.concat([z,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),j=I.readUInt8(0),N=(j&128)>>>7,z=(j&64)>>>6,_=j&15,Y=I.readUInt8(1),ce=(Y&128)>>>7,re=Y&127;this.j.state=2,this.j.readLen=2+(ce?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=_,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),j=I.readUInt8(1),N=(j&128)>>>7;let z=j&127,_=1;z===126?z=I.readUInt8(++_)*2**8+I.readUInt8(++_):z===127&&(z=I.readUInt8(++_)*0+I.readUInt8(++_)*0+I.readUInt8(++_)*0+I.readUInt8(++_)*0+I.readUInt8(++_)*2**24+I.readUInt8(++_)*2**16+I.readUInt8(++_)*2**8+I.readUInt8(++_));let Y=0;N&&(Y=I.readUInt8(++_)*2**24+I.readUInt8(++_)*2**16+I.readUInt8(++_)*2**8+I.readUInt8(++_)),this.j.state=3,this.j.readLen=z,this.j.mask=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),i(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Fh=u;class l extends a.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$be.alloc(0)}constructor(k,I,j,N,z,_){super(),this.n=k,this.r=z,this.s=_,this.a=this.B(new f.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new E(this.n,N,j,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(Y=>this.a.fire(Y))),this.B(this.f.onError(Y=>this.a.fire(Y)))):(this.b=null,this.f=null)}writeMessage(k,I){this.g.push({data:k,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:I}=this.g.shift();if(this.f&&I.compressed){const j=await this.w(this.f,k);this.s(j,I)}else this.s(k,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,I){return new Promise((j,N)=>{k.write(I),k.flush(z=>j(z))})}acceptFrame(k,I,j){this.h.push({data:k,isCompressed:I,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const I=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,I,j){return new Promise((N,z)=>{k.write(I),j&&k.write(C.$be.fromByteArray([0,0,255,255])),k.flush(_=>N(_))})}}class E extends a.$Sc{get recordedInflateBytes(){return this.j?C.$be.concat(this.f):C.$be.alloc(0)}constructor(k,I,j,N){super(),this.h=k,this.j=I,this.a=this.B(new f.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(N),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(C.$be.wrap(z))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=C.$be.concat(this.g);this.g.length=0,k(I)})}}class h extends a.$Sc{constructor(k,I){super(),this.g=k,this.a=this.B(new f.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(C.$be.wrap(j))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=C.$be.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),k(I)})}}function i(D,k){if(k===0)return;const I=D.byteLength>>>2;for(let ce=0;ce<I;ce++){const re=D.readUInt32BE(ce*4);D.writeUInt32BE(re^k,ce*4)}const j=I*4,N=D.byteLength-j,z=k>>>24&255,_=k>>>16&255,Y=k>>>8&255;N>=1&&D.writeUInt8(D.readUInt8(j)^z,j),N>=2&&D.writeUInt8(D.readUInt8(j+1)^_,j+1),N>=3&&D.writeUInt8(D.readUInt8(j+2)^Y,j+2)}e.$Gh=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function o(){const D=(0,y.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const k=process.platform!=="darwin"&&e.$Gh?e.$Gh:(0,s.tmpdir)(),I=(0,g.$jc)(k,`vscode-ipc-${D}.sock`);return n(I),I}e.$Hh=o;function t(D,k,I){const j=(0,S.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${I}-${k}-sock`;const N=I.substr(0,4),z=k.substr(0,6),_=j.substr(0,8);let Y;return process.platform!=="darwin"&&e.$Gh&&!process.env.VSCODE_PORTABLE?Y=(0,g.$jc)(e.$Gh,`vscode-${_}-${N}-${z}.sock`):Y=(0,g.$jc)(D,`${N}-${z}.sock`),n(Y),Y}e.$Ih=t;function n(D){const k=c[w.$u];typeof k=="number"&&D.length>=k&&console.warn(`WARNING: IPC handle "${D}" is longer than ${k} chars, try a shorter --user-data-dir`)}class r extends d.$th{static b(k){const I=f.Event.fromNodeEventEmitter(k,"connection");return f.Event.map(I,j=>({protocol:new v.$Ah(new m(j,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(j,"close"))}))}constructor(k){super(r.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Jh=r;function p(D){return new Promise((k,I)=>{const j=(0,R.createServer)();j.on("error",I),j.listen(D,()=>{j.removeListener("error",I),k(new r(j))})})}e.$Kh=p;function A(D,k){return new Promise((I,j)=>{const N=(0,R.createConnection)(D,()=>{N.removeListener("error",j),I(v.$Bh.fromSocket(new m(N,`ipc-client${k}`),k))});N.once("error",j)})}e.$Lh=A}),define(ie[25],ne([0,1,54,9,4,99,36,89,5]),function(X,e,S,R,s,O,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a6b=e.$_5b=void 0,e.$_5b=(0,f.$Qh)(C.$Wh);class a extends P.$jm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.$Ih)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$l){for(const w in process.env)if(w.endsWith("_VSCODE_SNAP_ORIG")){const y=w.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[w]?process.env[y]=process.env[w]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$l)for(const w in this.d)process.env[w]=this.d[w],delete this.d[w]}}e.$a6b=a,Ee([S.$hh],a.prototype,"cachedLanguagesPath",null),Ee([S.$hh],a.prototype,"backupHome",null),Ee([S.$hh],a.prototype,"mainIPCHandle",null),Ee([S.$hh],a.prototype,"mainLockfile",null),Ee([S.$hh],a.prototype,"disableUpdates",null),Ee([S.$hh],a.prototype,"crossOriginIsolated",null),Ee([S.$hh],a.prototype,"codeCachePath",null),Ee([S.$hh],a.prototype,"useCodeCache",null)}),define(ie[283],ne([0,1,85,33,13,9,4,19,21,196,18,25,34,16,6,195,29,98]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;let l=class{static{u=this}static{this.a="backupWorkspaces"}constructor(h,i,c,o){this.j=h,this.k=i,this.l=c,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$mg,this.i={isEqual:(t,n)=>(0,R.$Wf)(t,n,!C.$l)}}async initialize(){const h=this.m.getItem(u.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(h.emptyWindows),this.d=await this.u((0,a.$t6b)(h)),this.e=await this.v((0,a.$u6b)(h)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.$xk.OFF}q(){return this.s()===d.$xk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.$xk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(h,i){this.d.some(o=>h.workspace.id===o.workspace.id)||(this.d.push(h),this.C());const c=(0,O.$jc)(this.c,h.workspace.id);return i?this.t(c,i).then(()=>c):c}async t(h,i){if(await f.Promises.exists(h)&&await this.z(h),await f.Promises.exists(i))try{await f.Promises.rename(i,h,!1)}catch(c){this.l.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}registerFolderBackup(h){return this.e.some(i=>this.h.isEqual(h.folderUri,i.folderUri))||(this.e.push(h),this.C()),(0,O.$jc)(this.c,this.D(h))}registerEmptyWindowBackup(h){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,h.backupFolder))||(this.g.push(h),this.C()),(0,O.$jc)(this.c,h.backupFolder)}async u(h){if(!Array.isArray(h))return[];const i=new Set,c=[];for(const o of h){const t=o.workspace;if(!(0,b.$5h)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,O.$jc)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await f.Promises.exists(t.configPath.fsPath)?c.push(o):await this.z(n):await this.x(n)}}return c}async v(h){if(!Array.isArray(h))return[];const i=[],c=new Set;for(const o of h){const t=o.folderUri,n=this.h.getComparisonKey(t);if(!c.has(n)){c.add(n);const r=(0,O.$jc)(this.c,this.D(o));await this.B(r)?t.scheme!==s.Schemas.file||await f.Promises.exists(t.fsPath)?i.push(o):await this.z(r):await this.x(r)}}return i}async w(h){if(!Array.isArray(h))return[];const i=[],c=new Set;for(const o of h){const t=o.backupFolder;if(typeof t!="string")return[];if(!c.has(t)){c.add(t);const n=(0,O.$jc)(this.c,t);await this.B(n)?i.push(o):await this.x(n)}}return i}async x(h){try{await f.Promises.rm(h,f.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let h=(0,$.$z6b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,h.id));)h=(0,$.$z6b)();return{backupFolder:h.id}}async z(h){const i=this.y(),c=(0,O.$jc)(this.c,i.backupFolder);try{await f.Promises.rename(h,c,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const h=[];for(const i of this.d)await this.A(i)&&h.push(i);for(const i of this.e)await this.A(i)&&h.push(i);return h}A(h){let i;return(0,a.$s6b)(h)?i=(0,O.$jc)(this.c,h.backupFolder):(0,m.$EU)(h)?i=(0,O.$jc)(this.c,this.D(h)):i=(0,O.$jc)(this.c,h.workspace.id),this.B(i)}async B(h){try{const i=await f.Promises.readdir(h);for(const c of i)try{if((await f.Promises.readdir((0,O.$jc)(h,c))).length>0)return!0}catch{}}catch{}return!1}C(){const h={workspaces:this.d.map(({workspace:i,remoteAuthority:c})=>{const o={id:i.id,configURIPath:i.configPath.toString()};return c&&(o.remoteAuthority=c),o}),folders:this.e.map(({folderUri:i,remoteAuthority:c})=>{const o={folderUri:i.toString()};return c&&(o.remoteAuthority=c),o}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:c})=>{const o={backupFolder:i};return c&&(o.remoteAuthority=c),o})};this.m.setItem(u.a,h)}D(h){const i=h.folderUri;let c;return i.scheme===s.Schemas.file?c=C.$l?i.fsPath:i.fsPath.toLowerCase():c=i.toString().toLowerCase(),(0,S.createHash)("md5").update(c).digest("hex")}};e.$A6b=l,e.$A6b=l=u=Ee([te(0,w.$_5b),te(1,g.$ji),te(2,v.$0i),te(3,y.$wN)],l)}),define(ie[20],ne([0,1,15,38,8,3,2,4,35,12,5,6,34,25]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.LifecycleMainPhase=e.ShutdownReason=e.$b6b=void 0,e.$b6b=(0,g.$Ph)("lifecycleMainService");var m;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(m||(e.ShutdownReason=m={}));var b;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let $=class extends C.$Sc{static{v=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(l,E,h){super(),this.F=l,this.G=E,this.H=h,this.c=this.B(new O.$Nd),this.onBeforeShutdown=this.c.event,this.f=this.B(new O.$Nd),this.onWillShutdown=this.f.event,this.g=this.B(new O.$Nd),this.onWillLoadWindow=this.g.event,this.h=this.B(new O.$Nd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(v.b),this.m&&this.G.removeItem(v.b)}J(){const l=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$k&&this.t===0&&this.L(1))};S.app.addListener("before-quit",l);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$k)&&S.app.quit()};S.app.addListener("window-all-closed",E),S.app.once("will-quit",h=>{this.S("Lifecycle#app.on(will-quit) - begin"),h.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",l),S.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(l){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const h=[];return this.f.fire({reason:l,join(i,c){E.trace(`Lifecycle#onWillShutdown - begin '${i}'`),h.push(c.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(h)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===l)return;this.S(`lifecycle (main): phase changed (value: ${l})`),this.n=l;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(l){if(l<=this.n)return;let E=this.C.get(l);E||(E=new s.$Sg,this.C.set(l,E)),await E.wait()}registerWindow(l){const E=new C.$Rc;this.t++,E.add(l.onWillLoad(i=>this.g.fire({window:l,workspace:i.workspace,reason:i.reason})));const h=(0,a.$Jf)(l.win);h.on("close",i=>{const c=l.id;if(this.r.has(c)){this.r.delete(c);return}this.S(`Lifecycle#window.on('close') - window ID ${l.id}`),i.preventDefault(),this.unload(l,1).then(o=>{if(o){this.r.delete(c);return}this.r.add(c),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this.h.fire(l),l.close()})}),h.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.t--,E.dispose(),this.t===0&&(!P.$k||this.j)&&this.L(1)})}async reload(l,E){await this.unload(l,3)||l.reload(E)}unload(l,E){const h=this.z.get(l.id);if(h)return h;const i=this.M(l,E).finally(()=>{this.z.delete(l.id)});return this.z.set(l.id,i),i}async M(l,E){if(!l.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${l.id}`);const h=this.j?2:E,i=await this.P(l,h);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.N(i)):(await this.Q(l,h),!1)}N(l){return l?(this.O(!0),this.j=!1,!0):!1}O(l){this.w&&(this.w(l),this.w=void 0,this.u=void 0)}P(l,E){return new Promise(h=>{const i=this.s++,c=`vscode:ok${i}`,o=`vscode:cancel${i}`;R.$jT.once(c,()=>{h(!1)}),R.$jT.once(o,()=>{h(!0)}),l.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:o,reason:E})})}Q(l,E){return new Promise(h=>{const c=`vscode:reply${this.s++}`;R.$jT.once(c,()=>h()),l.send("vscode:onWillUnload",{replyChannel:c,reason:E})})}quit(l){return this.R(l).then(E=>{if(!E&&l)try{if(P.$j){const h=(0,f.cwd)();h!==process.cwd()&&process.chdir(h)}}catch(h){this.F.error(h)}return E})}R(l){return this.S(`Lifecycle#quit() - begin (willRestart: ${l})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(l&&this.G.setItem(v.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(l){this.H.args["enable-smoke-test-driver"]?this.F.info(l):this.F.trace(l)}setRelaunchHandler(l){this.D=l}async relaunch(l){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(l?.addArgs&&E.push(...l.addArgs),l?.removeArgs)for(const c of l.removeArgs){const o=E.indexOf(c);o>=0&&E.splice(o,1)}const h=()=>{this.D?.handleRelaunch(l)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:E}))};S.app.once("quit",h),await this.quit(!0)&&S.app.removeListener("quit",h)}async kill(l){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Ug)(1e3),(async()=>{for(const E of S.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let h;E.webContents&&!E.webContents.isDestroyed()?h=new Promise(i=>E.once("closed",i)):h=Promise.resolve(),E.destroy(),await h}})()]),S.app.exit(l)}};e.$c6b=$,e.$c6b=$=v=Ee([te(0,w.$0i),te(1,y.$wN),te(2,d.$_5b)],$)}),define(ie[284],ne([0,1,4,3,2,5,20]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=e.$$6b=void 0,e.$$6b=(0,O.$Ph)("keyboardLayoutMainService");let P=class extends s.$Sc{constructor(g){super(),this.a=this.B(new R.$Nd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((w,y)=>{X(["native-keymap"],w,y)});this.c=f(g),S.$t||g.onDidChangeKeyboardLayout(()=>{this.c=f(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$_6b=P,e.$_6b=P=Ee([te(0,C.$b6b)],P);function f(a){const g=a.getKeyMap(),w=a.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:w}}}),define(ie[285],ne([0,1,246,8,17,14,12,18,36,93,6,50,245,282]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;let v=class extends w.$Uo{constructor(u,l,E,h){super(h),this.m=u,this.n=l,this.r=E,this.s(),this.B(u.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const u=this.m.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,l){const{f:E,g:h}=this;let i;try{i=await(0,a.$Tl)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,O.$0)(t)))}const c={...process.env,...i},o=u.agent?u.agent:await(0,y.$Yq)(u.url||"",c,{proxyUrl:E,strictSSL:h});return u.agent=o,u.strictSSL=h,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>b(u,l))}async resolveProxy(u){}};e.$Zq=v,e.$Zq=v=Ee([te(0,P.$ji),te(1,f.$Xh),te(2,g.$0i),te(3,g.$$i)],v);async function m($){return((0,S.parse)($.url).protocol==="https:"?await new Promise((E,h)=>{X(["https"],E,h)}):await new Promise((E,h)=>{X(["http"],E,h)})).request}async function b($,u){return R.Promises.withAsyncBody(async(l,E)=>{const h=(0,S.parse)($.url),i=$.getRawRequest?$.getRawRequest($):await m($),c={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,C.$Ef)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(c.auth=$.user+":"+$.password);const o=i(c,t=>{const n=(0,C.$Cf)($.followRedirects)?$.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)b({...$,url:t.headers.location,followRedirects:n-1},u).then(l,E);else{let r=t;!$.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(r=t.pipe((0,d.createGunzip)())),l({res:t,stream:(0,s.$qe)(r)})}});o.on("error",E),$.timeout&&o.setTimeout($.timeout),$.isChromiumNetwork&&o.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&o.write($.data),o.end(),u.onCancellationRequested(()=>{o.abort(),E(new O.$5)})})}e.$1q=b}),define(ie[286],ne([0,1,15,285]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b8b=void 0;function s(C){return S.net.request}class O extends R.$Zq{request(P,f){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$b8b=O}),define(ie[81],ne([0,1,7,3,2,36,16,5,20,6,96,279,41,52,40,13]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m6b=e.$l6b=e.$k6b=e.$j6b=void 0,e.$j6b=(0,P.$Ph)("storageMainService");let b=class extends s.$Sc{constructor(l,E,h,i,c,o){super(),this.c=l,this.f=E,this.g=h,this.h=i,this.j=c,this.m=o,this.a=void 0,this.b=this.B(new R.$Nd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(l=>{l.window.profile&&this.profileStorage(l.window.profile).init(),l.workspace&&this.workspaceStorage(l.workspace).init()})),this.B(this.h.onWillShutdown(l=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=l.reason,l.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)l.join("profileStorage",E.close());for(const[,E]of this.w)l.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(l=>{l.join((async()=>{await this.j.exists(l.profile.globalStorageHome)||await this.j.createFolder(l.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(l=>{const E=this.t.get(l.profile.id);E&&l.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const l=new w.$e6b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(l.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),l}profileStorage(l){if((0,g.$0o)(l))return this.applicationStorage;let E=this.t.get(l.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${l.name})`),E=this.B(this.u(l)),this.t.set(l.id,E);const h=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:l})));this.B(R.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${l.name})`),this.t.delete(l.id),h.dispose()}))}return E}u(l){return this.a===2?new w.$g6b(this.c,this.j):new w.$d6b(l,this.n(),this.c,this.j)}workspaceStorage(l){let E=this.w.get(l.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${l.id})`),E=this.B(this.y(l)),this.w.set(l.id,E),this.B(R.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${l.id})`),this.w.delete(l.id)}))),E}y(l){return this.a===2?new w.$g6b(this.c,this.j):new w.$f6b(l,this.n(),this.c,this.f,this.j)}isUsed(l){const E=S.URI.file(l);for(const h of[this.applicationStorage,...this.t.values(),...this.w.values()])if(h.path&&this.m.extUri.isEqualOrParent(S.URI.file(h.path),E))return!0;return!1}};e.$k6b=b,e.$k6b=b=Ee([te(0,a.$0i),te(1,O.$Wh),te(2,d.$h6b),te(3,f.$b6b),te(4,C.$$j),te(5,v.$Ik)],b),e.$l6b=(0,P.$Ph)("applicationStorageMainService");let $=class extends g.$9o{constructor(l,E){super(),this.s=l,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(l){if(l===-1)return this.U.applicationStorage.storage}Q(l){if(l===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$m6b=$,e.$m6b=$=Ee([te(0,y.$Kk),te(1,e.$j6b)],$)}),define(ie[287],ne([0,1,86,28,103,99,8,2,4,18,6,24,241,242,94,127,17]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=e.$_7b=e.$$7b=e.$07b=void 0;async function $(i,c,o,t,n){let r;for(let p=3;p&&(r?.dispose(),r=await new u(i,c,o,t,n).waitForReady(),!(n&&s.$hg[n]||!s.$hg[r.tunnelLocalPort]));p--);return r}class u extends P.$Sc{constructor(c,o,t,n,r){super(),this.m=o,this.n=r,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=c,this.b=S.createServer(),this.c=new C.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const c=this.n??this.tunnelRemotePort,o=(0,m.$ev)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$ig)(c,2,1e3,o),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(c){c.pause();const o=(0,m.$cv)(this.tunnelRemoteHost)||(0,m.$ev)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,y.$6k)(this.a,o,this.tunnelRemotePort),n=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&c.write(r.buffer),c.on("end",()=>{c.localAddress&&this.j.delete(c.localAddress),n.end()}),c.on("close",()=>n.end()),c.on("error",()=>{c.localAddress&&this.j.delete(c.localAddress),n instanceof O.$Eh?n.socket.destroy():n.end()}),n instanceof O.$Eh?this.t(c,n):this.s(c,n),c.localAddress&&this.j.set(c.localAddress,()=>{c.end(),n.end()})}s(c,o){o.onClose(()=>c.destroy()),o.onEnd(()=>c.end()),o.onData(t=>c.write(t.buffer)),c.on("data",t=>o.write(b.$be.wrap(t))),c.resume()}t(c,o){const t=o.socket;t.on("end",()=>c.end()),t.on("close",()=>c.end()),t.on("error",()=>{c.destroy()}),t.pipe(c),c.pipe(t)}}e.$07b=u;let l=class extends m.$hv{constructor(c,o,t,n,r){super(o,r),this.u=c,this.v=t,this.w=n}isPortPrivileged(c){return(0,m.$fv)(c,this.l,f.OS,R.release())}s(c,o,t,n,r,p,A,D){const k=this.r(o,t);if(k)return++k.refcount,k.value;if((0,m.$_u)(c))return this.t(c,o,t,r,p,A,D);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${t} on local port ${r}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:c,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=$(I,n,o,t,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(o,t,j),j}}};e.$$7b=l,e.$$7b=l=Ee([te(0,d.$Zk),te(1,g.$0i),te(2,v.$3k),te(3,w.$pj),te(4,a.$ji)],l);let E=class extends l{constructor(c,o,t,n,r){super(c,o,t,n,r)}};e.$_7b=E,e.$_7b=E=Ee([te(0,d.$Zk),te(1,g.$0i),te(2,v.$3k),te(3,w.$pj),te(4,a.$ji)],E);let h=class extends P.$Sc{constructor(c,o,t,n,r){super(),this.b=c,this.c=o,this.f=t,this.g=n,this.h=r,this.a=new Map}async openTunnel(c,o,t,n,r,p,A,D,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${p}.`),!this.a.has(c)){const I=new E(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(c,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(o,t,n,r,p,A,D,k)}};e.$a8b=h,e.$a8b=h=Ee([te(0,d.$Zk),te(1,g.$0i),te(2,w.$pj),te(3,v.$3k),te(4,a.$ji)],h)}),define(ie[100],ne([0,1,8,22,3,18,25,20,6,24,50,48]),function(X,e,S,R,s,O,C,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=e.$v7b=void 0;function y(v,m,b){return`${b.updateUrl}/api/update/${v}/${m}/${b.commit}`}e.$v7b=y;let d=class{get state(){return this.b}d(m){this.j.info("update#setState",m.type),this.b=m,this.c.fire(m)}constructor(m,b,$,u,l,E){this.f=m,this.g=b,this.h=$,this.i=u,this.j=l,this.k=E,this.b=w.$iU.Uninitialized,this.c=new s.$Nd,this.onStateChange=this.c.event,m.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(w.$iU.Disabled(0));return}if(this.h.disableUpdates){this.d(w.$iU.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(w.$iU.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.g.getValue("update.mode"),b=this.m(m);if(!b){this.d(w.$iU.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(b),!this.a){this.d(w.$iU.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(w.$iU.Idle(this.q())),m==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(m){return m==="none"?void 0:this.k.quality}n(m=60*60*1e3){return(0,S.$Ug)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(m){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(m)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(m){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch(b){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(b);return}}async _applySpecificUpdate(m){}q(){return 1}r(){}};e.$w7b=d,e.$w7b=d=Ee([te(0,P.$b6b),te(1,O.$ji),te(2,C.$_5b),te(3,g.$To),te(4,f.$0i),te(5,a.$pj)],d)}),define(ie[288],ne([0,1,15,54,3,2,18,25,20,6,24,50,26,48,100]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=void 0;let m=class extends v.$w7b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",($,u)=>u)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",($,u,l)=>({url:u,version:l,productVersion:l}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",($,u,l,E)=>({releaseNotes:u,version:l,productVersion:l,date:E}))}constructor($,u,l,E,h,i,c){super($,u,E,h,i,c),this.z=l,this.u=new O.$Rc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.j.error("UpdateService error:",$);const u=this.state.type==="checking for updates"&&this.state.explicit?$:void 0;this.d(d.$iU.Idle(1,u))}s($){let u;this.k.darwinUniversalAssetId?u=this.k.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,v.$v7b)(u,$,this.k);try{S.autoUpdater.setFeedURL({url:l})}catch(E){this.j.error("Failed to set update feed URL",E);return}return l}t($){this.d(d.$iU.CheckingForUpdates($)),S.autoUpdater.checkForUpdates()}E($){this.state.type==="checking for updates"&&this.d(d.$iU.Downloading($))}F($){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:$.version}),this.d(d.$iU.Ready($)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.$iU.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$x7b=m,Ee([R.$hh],m.prototype,"v",null),Ee([R.$hh],m.prototype,"w",null),Ee([R.$hh],m.prototype,"x",null),Ee([R.$hh],m.prototype,"y",null),e.$x7b=m=Ee([te(0,f.$b6b),te(1,C.$ji),te(2,y.$cl),te(3,P.$_5b),te(4,w.$To),te(5,a.$0i),te(6,g.$pj)],m)}),define(ie[289],ne([0,1,47,45,8,3,9,25,20,6,26,48]),function(X,e,S,R,s,O,C,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;let y=class{get state(){return this.a}d(m){this.g.info("update#setState",m.type),this.a=m,this.b.fire(m)}constructor(m,b,$){if(this.f=m,this.g=$,this.a=w.$iU.Uninitialized,this.b=new O.$Nd,this.onStateChange=this.b.event,b.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(w.$iU.Idle(this.k())),this.h(30*1e3).then(void 0,u=>this.g.error(u))}h(m=60*60*1e3){return(0,s.$Ug)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(m){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(m)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(m){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(m){}};y=Ee([te(0,f.$b6b),te(1,P.$_5b),te(2,a.$0i)],y);let d=class extends y{constructor(m,b,$,u,l,E){super($,u,l),this.o=m,this.p=b,this.q=E;const h=(0,R.watch)(C.$mc(this.o)),i=O.Event.fromNodeEventEmitter(h,"change",(n,r)=>r),c=O.Event.filter(i,n=>n==="current"),t=O.Event.debounce(c,(n,r)=>r,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{t.dispose(),h.close()})}m(){this.d(w.$iU.CheckingForUpdates(!1)),this.u().then(m=>{m?this.d(w.$iU.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$iU.Idle(2)))},m=>{this.g.error(m),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$iU.Idle(2,m.message||m))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+C.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const m=await new Promise(($,u)=>(0,R.realpath)(`${C.$mc(this.o)}/current`,(l,E)=>l?u(l):$(E))),b=C.$nc(m);return this.p!==b}isLatestVersion(){return this.u().then(void 0,m=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$z7b=d,e.$z7b=d=Ee([te(2,f.$b6b),te(3,P.$_5b),te(4,a.$0i),te(5,g.$cl)],d)}),define(ie[30],ne([0,1,4,5,95,68,67,24,18,25,9]),function(X,e,S,R,s,O,C,P,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=e.OpenContext=e.$p6b=void 0,e.$p6b=(0,R.$Ph)("windowsMainService");var w;(function(d){d[d.CLI=0]="CLI",d[d.DOCK=1]="DOCK",d[d.MENU=2]="MENU",d[d.DIALOG=3]="DIALOG",d[d.DESKTOP=4]="DESKTOP",d[d.API=5]="API"})(w||(e.OpenContext=w={}));function y(d,v=(0,s.$$5b)(),m){const b=d.get(C.$n6b),$=d.get(P.$pj),u=d.get(f.$ji),l=d.get(a.$_5b),E=u.getValue("window"),h={width:v.width,height:v.height,x:v.x,y:v.y,backgroundColor:b.getBackgroundColor(),minWidth:O.$2C.WIDTH,minHeight:O.$2C.HEIGHT,title:$.nameLong,...m,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,O.$9C)(E?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...m?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return S.$l?h.icon=(0,g.$jc)(l.appRoot,"resources/linux/code.png"):S.$j&&!l.isBuilt&&(h.icon=(0,g.$jc)(l.appRoot,"resources/win32/code_150x150.png")),S.$k&&(h.acceptFirstMouse=!0,E?.clickThroughInactive===!1&&(h.acceptFirstMouse=!1)),h}e.$q6b=y}),define(ie[290],ne([0,1,15,22,3,55,2,32,117,6,81,30]),function(X,e,S,R,s,O,C,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends C.$Sc{constructor(m,b,$,u){super(),this.g=m,this.h=b,this.j=$,this.m=u,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const m=s.Event.fromNodeEventEmitter(S.app,"login",(b,$,u,l,E)=>({event:b,webContents:$,req:u,authInfo:l,callback:E}));this.B(m(this.r,this))}async r({event:m,authInfo:b,req:$,callback:u}){if(!b.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let l;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(b);try{l=await this.b}finally{this.b=void 0}}u(l?.username,l?.password)}async s(m){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.t(m);if(b)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(m){this.g.trace("auth#doResolveProxyCredentials - enter",m);const b=String((0,O.$Di)({scheme:m.scheme,host:m.host,port:m.port}));let $,u;try{const i=this.m.get(this.a+b,-1);if(i){const c=JSON.parse(await this.j.decrypt(i));$=c.username,u=c.password}}catch(i){this.g.error(i)}if(this.c!==y.StoredCredentialsUsed&&typeof $=="string"&&typeof u=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:$,password:u};const l=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!l){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const E={authInfo:m,username:this.f?.username??$,password:this.f?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,P.$eg)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,E),this.c=y.LoginDialogShown;const h=await new Promise(i=>{const c=async(o,t,n)=>{if(t===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",c),n){const r={username:n.username,password:n.password};try{if(n.remember){const p=await this.j.encrypt(JSON.stringify(r));this.m.store(this.a+b,p,-1,1)}else this.m.remove(this.a+b,-1)}catch(p){this.g.error(p)}i({username:r.username,password:r.password})}else i(void 0)};l.win?.webContents.on("ipc-message",c)});return this.f=h,h}};e.$r6b=d,e.$r6b=d=Ee([te(0,a.$0i),te(1,w.$p6b),te(2,f.$4T),te(3,g.$l6b)],d)}),define(ie[291],ne([0,1,15,23,4,7,21,18,62,5,6,128,30]),function(X,e,S,R,s,O,C,P,f,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=e.$b7b=e.ID=void 0,e.ID="launchMainService",e.$b7b=(0,a.$Ph)(e.ID);let d=class{constructor(m,b,$,u){this.a=m,this.b=b,this.c=$,this.d=u}async start(m,b){this.a.trace("Received data from other instance: ",m,b),s.$k&&S.app.focus({steal:!0});const $=this.e(m);if($.length){let u=Promise.resolve();if(this.b.getWindowCount()===0){const l=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));l&&(u=l.ready())}u.then(()=>{for(const{uri:l,originalUrl:E}of $)this.c.open(l,{originalUrl:E})})}else return this.f(m,b)}e(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,R.$Hb)(m._urls.map(b=>{try{return{uri:O.URI.parse(b),originalUrl:b}}catch{return null}})):[]}async f(m,b){const $=(0,f.$Nl)(b)?0:4;let u=[];const l=m.wait&&m.waitMarkerFilePath?O.URI.file(m.waitMarkerFilePath):void 0,E=m.remote||void 0,h={context:$,cli:m,userEnv:b,waitMarkerFileURI:l,remoteAuthority:E,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,h);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let i=!1;if(m["new-window"]||m["unity-launch"]||h.forceProfile||h.forceTempProfile)i=!0;else if(m["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$k}if(i)u=await this.b.open({...h,forceNewWindow:!0,forceEmpty:!0});else{const c=this.b.getLastActiveWindow();c?(this.b.openExistingWindow(c,h),u=[c]):u=await this.b.open({...h,forceEmpty:!0})}}else u=await this.b.open({...h,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(l&&u.length===1&&u[0])return Promise.race([u[0].whenClosedOrLoaded,(0,C.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$c7b=d,e.$c7b=d=Ee([te(0,g.$0i),te(1,y.$p6b),te(2,w.$0T),te(3,P.$ji)],d)}),define(ie[292],ne([0,1,2,20,52,29,8,30]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R7b=void 0;let f=class extends S.$Sc{constructor(g,w,y){super(),this.a=w,this.b=y,this.B(g.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.B(g.onBeforeCloseWindow(d=>this.c(d))),this.B(new C.$6g(()=>this.g(),30*1e3)).schedule()}async c(g){const w=this.f(g),y=this.a.getProfileForWorkspace(w);y?.isTransient&&(this.a.unsetWorkspace(w,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(g){return g.openedWorkspace??(0,O.$4h)(g.backupPath,g.isExtensionDevelopmentHost)}g(){const g=this.a.getAssociatedEmptyWindows();if(g.length===0)return;const w=this.b.getWindows().map(y=>this.f(y));for(const y of g)w.some(d=>d.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$R7b=f,e.$R7b=f=Ee([te(0,R.$b6b),te(1,s.$h6b),te(2,P.$p6b)],f)}),define(ie[60],ne([0,1,15,2,3,6,313,8,13,30,73,26,20,75,37,4,131]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=e.$J6b=void 0;function u(h){return typeof h.responseWindowId=="number"}let l=class extends R.$Sc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(i,c,o){super(),this.t=i,this.u=c,this.w=o,this.c=String(++$.a),this.f=this.B(new s.$Nd),this.onStdout=this.f.event,this.g=this.B(new s.$Nd),this.onStderr=this.g.event,this.h=this.B(new s.$Nd),this.onMessage=this.h.event,this.j=this.B(new s.$Nd),this.onExit=this.j.event,this.m=this.B(new s.$Nd),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(i,c){let o;switch(this.s?.correlationId?o=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`:o=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`,c){case g.default.Error:this.t.error(o);break;case g.default.Warning:this.t.warn(o);break;case g.default.Info:this.t.trace(o);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(i){const c=this.C(i);return c&&i.payload&&this.postMessage(i.payload),c}C(i){if(!this.z())return!1;this.s=i;const c=`${this.s.type}-${this.c}`,o=f.$cg.asFileUri("bootstrap-fork.js").fsPath,t=this.s.args??[],n=this.s.execArgv??[],r=this.s.allowLoadingUnsignedLibraries,p=this.s.forceAllocationsToV8Sandbox,A="pipe",D=this.D(i);return this.y("creating new...",g.default.Info),this.n=S.utilityProcess.fork(o,t,{serviceName:c,env:D,execArgv:n,allowLoadingUnsignedLibraries:r,forceAllocationsToV8Sandbox:p,stdio:A}),this.F(this.n,this.s,c),!0}D(i){const c=i.env?{...i.env}:{...(0,v.$7m)(process.env)};c.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(c.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),c.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,m.$j&&((0,b.isUNCAccessRestrictionsDisabled)()?c.NODE_DISABLE_UNC_ACCESS_CHECKS="1":c.NODE_UNC_HOST_ALLOWLIST=(0,b.getUNCHostAllowlist)().join("\\")),(0,d.$Al)(c);for(const o of Object.keys(c))c[o]=String(c[o]);return c}F(i,c,o){if(i.stdout){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.r=i.pid,typeof i.pid=="number"&&$.b.set(i.pid,{pid:i.pid,name:u(c)?`${c.type} [${c.responseWindowId}]`:c.type}),this.y("successfully created",g.default.Info)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.y(`received exit event with code ${t}`,g.default.Info),this.j.fire({pid:this.r,code:t,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===o&&(this.y(`crashed with code ${t.exitCode} and reason '${t.reason}'`,g.default.Error),this.u.publicLog2("utilityprocesscrash",{type:c.type,reason:t.reason,code:t.exitCode}),this.m.fire({pid:this.r,code:t.exitCode,reason:t.reason}),this.G())}))}once(i,c){const o=this.B(this.h.event(t=>{t===i&&(o.dispose(),c())}))}postMessage(i,c){this.n&&this.n.postMessage(i,c)}connect(i){const{port1:c,port2:o}=new S.MessageChannelMain;return this.postMessage(i,[o]),c}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",g.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",g.default.Info),this.n.kill()?(this.y("successfully killed the process",g.default.Info),this.G()):this.y("unable to kill the process",g.default.Warning)}G(){typeof this.r=="number"&&$.b.delete(this.r),this.n=void 0}async waitForExit(i){this.n&&(this.y("waiting to exit...",g.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$Ug)(i)]),this.n&&(this.y(`did not exit within ${i}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$J6b=l,e.$J6b=l=$=Ee([te(0,O.$0i),te(1,w.$cl),te(2,y.$b6b)],l);let E=class extends l{constructor(i,c,o,t){super(i,o,t),this.H=c}start(i){const c=this.H.getWindowById(i.responseWindowId);if(!c?.win||c.win.isDestroyed()||c.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.C(i))return!1;this.I(c.win,i);const t=this.connect(i.payload);return c.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}I(i,c){c.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,o=>o.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$K6b=E,e.$K6b=E=Ee([te(0,O.$0i),te(1,a.$p6b),te(2,w.$cl),te(3,y.$b6b)],E)}),define(ie[293],ne([0,1,14,6,20,8,60,30,26]),function(X,e,S,R,s,O,C,P,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$R6b=void 0;let g=class{static{a=this}static{this.a=0}constructor(y,d,v,m){this.d=y,this.f=d,this.g=v,this.h=m,this.b=new Map,this.c=!1,this.f.onWillShutdown(b=>{this.c=!0,b.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(y){const d=this.b.get(y);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(y){return this.i(y).onStdout}onDynamicStderr(y){return this.i(y).onStderr}onDynamicMessage(y){return this.i(y).onMessage}onDynamicExit(y){return this.i(y).onExit}async createExtensionHost(){if(this.c)throw(0,S.$6)();const y=String(++a.a),d=new C.$K6b(this.d,this.g,this.h,this.f);return this.b.set(y,d),d.onExit(({pid:v,code:m,signal:b})=>{this.d.info(`Extension host with pid ${v} exited with code: ${m}, signal: ${b}.`),setTimeout(()=>{d.dispose(),this.b.delete(y)})}),{id:y}}async start(y,d){if(this.c)throw(0,S.$6)();this.i(y).start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y})}async enableInspectPort(y){if(this.c)throw(0,S.$6)();const d=this.b.get(y);return d?d.enableInspectPort():!1}async kill(y){if(this.c)throw(0,S.$6)();const d=this.b.get(y);d&&d.kill()}async _killAllNow(){for(const[,y]of this.b)y.kill()}async _waitForAllExit(y){const d=[];for(const[,v]of this.b)d.push(v.waitForExit(y));return O.Promises.settled(d).then(()=>{})}};e.$R6b=g,e.$R6b=g=a=Ee([te(0,R.$0i),te(1,s.$b6b),te(2,P.$p6b),te(3,f.$cl)],g)}),define(ie[294],ne([0,1,38,8,2,25,20,6,41,39,66,60,51,89,12,247,24]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=void 0;let $=class extends s.$Sc{constructor(l,E,h,i,c,o,t,n,r){super(),this.c=l,this.f=E,this.g=h,this.h=i,this.j=c,this.m=o,this.n=t,this.r=n,this.s=r,this.a=new R.$Sg,this.b=void 0,this.y=void 0,this.z=void 0,this.t()}t(){S.$jT.on(m.$n7b.request,(l,E)=>this.u(l,E,m.$n7b.response)),S.$jT.on(m.$o7b.request,(l,E)=>this.u(l,E,m.$o7b.response)),this.B(this.j.onWillShutdown(()=>this.w()))}async u(l,E,h){this.m.trace(`[SharedProcess] onWindowConnection for: ${h}`),this.a.isOpen()||this.a.open(),await this.whenReady();const i=await this.connect(h);if(l.sender.isDestroyed())return i.close();l.sender.postMessage(h,E,[i])}w(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(m.$m7b.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const l=new R.$ch;this.b?this.b.once(m.$m7b.initDone,()=>l.complete()):S.$jT.once(m.$m7b.initDone,()=>l.complete()),await l.p,this.m.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const l=new R.$ch;this.b?this.b.once(m.$m7b.ipcReady,()=>l.complete()):S.$jT.once(m.$m7b.ipcReady,()=>l.complete()),await l.p,this.m.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new w.$J6b(this.m,y.$mo,this.j));const l=(0,d.$lm)(this.g.args,this.g.isBuilt);let E;l.port&&(E=["--nolazy"],l.break?E.push(`--inspect-brk=${l.port}`):E.push(`--inspect=${l.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:E,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.s.quality!=="stable"})}F(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(l){return await this.C,(0,v.$Jf)(this.b).connect(l)}};e.$p7b=$,e.$p7b=$=Ee([te(2,O.$_5b),te(3,f.$Kk),te(4,C.$b6b),te(5,P.$0i),te(6,g.$26b),te(7,a.$in),te(8,b.$pj)],$)}),define(ie[295],ne([0,1,25,89,20,6,51,60,110,38,2,3,37,18,13]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;let m=class extends g.$Sc{constructor($,u,l,E,h){super(),this.f=$,this.g=u,this.h=l,this.j=E,this.m=h,this.a=void 0,this.b=new w.$Nd,this.onRequestConnection=this.b.event,this.c=new w.$Nd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),a.$jT.on("vscode:createPtyHostMessageChannel",(i,c)=>this.r(i,c)),this.B((0,g.$Qc)(()=>{a.$jT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$J6b(this.m,C.$mo,this.j);const $=(0,R.$km)(this.h.args,this.h.isBuilt),u=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:u,args:["--logsPath",this.h.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this.n()});const l=this.a.connect(),E=new f.$rT(l,"ptyHost"),h=new g.$Rc;return h.add(E),h.add((0,g.$Qc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:h,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,y.$7m)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},u=this.g.getValue("terminal.integrated.developer.ptyHost.latency");u&&typeof u=="number"&&($.VSCODE_LATENCY=String(u));const l=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&($.VSCODE_STARTUP_DELAY=String(l)),this.h.restoreSnapExportedVariables(),$}r($,u){this.b.fire();const l=this.a.connect();if($.sender.isDestroyed()){l.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",u,[l])}};e.$27b=m,e.$27b=m=Ee([te(1,d.$ji),te(2,S.$_5b),te(3,s.$b6b),te(4,O.$0i)],m)}),define(ie[296],ne([0,1,2,5,6,30,60,26,55,3,8,20]),function(X,e,S,R,s,O,C,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=e.$Z7b=void 0,e.$Z7b=(0,R.$Ph)("utilityProcessWorker");let y=class extends S.$Sc{constructor(m,b,$,u){super(),this.b=m,this.c=b,this.f=$,this.g=u,this.a=new Map}async createWorker(m){const b=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${b})`);const $=this.h(m);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${b})`),this.disposeWorker(m));const u=new d(this.b,this.c,this.f,this.g,m);if(!u.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,u);const l=new g.$ch;return a.Event.once(u.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete($),l.complete({reason:E})}),l.p}h(m){return(0,f.$Di)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const b=this.h(m),$=this.a.get(b);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),$.kill(),this.a.delete(b))}};e.$17b=y,e.$17b=y=Ee([te(0,s.$0i),te(1,O.$p6b),te(2,P.$cl),te(3,w.$b6b)],y);let d=class extends S.$Sc{constructor(m,b,$,u,l){super(),this.c=m,this.f=b,this.g=$,this.h=u,this.j=l,this.a=this.B(new a.$Nd),this.onDidTerminate=this.a.event,this.b=new C.$K6b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(m=>this.a.fire({code:m.code,signal:m.signal}))),this.B(this.b.onCrash(m=>this.a.fire({code:m.code,signal:"ECRASH"})))}spawn(){const b=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:b,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};d=Ee([te(0,s.$0i),te(1,O.$p6b),te(2,P.$cl),te(3,w.$b6b)],d)}),define(ie[297],ne([0,1,15,3,2,273,30]),function(X,e,S,R,s,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7b=void 0;let P=class extends s.$Sc{constructor(a){super(),this.b=a,this.a=this.B(new R.$Nd),this.onFoundInFrame=this.a.event,this.B(new O.$G7b)}async setIgnoreMenuShortcuts(a,g){let w;if(typeof a.windowId=="number"){const{windowId:y}=a,d=this.b.getWindowById(y);if(!d?.win)throw new Error(`Invalid windowId: ${y}`);w=d.win.webContents}else{const{webContentsId:y}=a;if(w=S.webContents.fromId(y),!w)throw new Error(`Invalid webContentsId: ${y}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts(g)}async findInFrame(a,g,w,y){const v=this.c(a,g);if(typeof v.findInFrame=="function"){v.findInFrame(w,{findNext:y.findNext,forward:y.forward});const m=(b,$)=>{$.finalUpdate&&(this.a.fire($),v.removeListener("found-in-frame",m))};v.on("found-in-frame",m)}}async stopFindInFrame(a,g,w){const d=this.c(a,g);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(w.keepSelection?"keepSelection":"clearSelection")}c(a,g){const w=this.b.getWindowById(a.windowId);if(!w?.win)throw new Error(`Invalid windowId: ${a}`);const y=w.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===g);if(!y)throw new Error(`Unknown frame: ${g}`);return y}};e.$H7b=P,e.$H7b=P=Ee([te(0,C.$p6b)],P)}),define(ie[298],ne([0,1,15,2,4,19,7,18,20,6,34,30,95,29]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$K7b=e.$J7b=e.$I7b=void 0;let m=class extends R.$Sc{static{v=this}static{this.a="windowsState"}get state(){return this.b}constructor(h,i,c,o,t){super(),this.g=h,this.h=i,this.j=c,this.m=o,this.n=t,this.b=b(this.h.getItem(v.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(h=>this.u(h)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(h=>this.u(h))}s(){this.f=!0,this.t()}t(){const h=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&h.add(i.lastActiveWindow.uiState.display))}const c=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);c&&(i.lastPluginDevelopmentHostWindow=this.w(c),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$k&&!c.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(h.has(n.uiState.display)?s.$k&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):h.add(n.uiState.display)),n}));const o=u(i);this.h.setItem(v.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(h){if(this.j.quitRequested)return;const i=this.w(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this.b.openedWindows.forEach(c=>{const o=(0,d.$5h)(h.openedWorkspace)&&c.workspace?.id===h.openedWorkspace.id,t=(0,d.$Zh)(h.openedWorkspace)&&c.folderUri&&O.$mg.isEqual(c.folderUri,h.openedWorkspace.uri);(o||t)&&(c.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(h){return{windowId:h.id,workspace:(0,d.$5h)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,d.$Zh)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const i=this.z(h),c=this.n.getValue("window");if(i.mode===3){let o;i.hasDefaultState?o=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||c?.restoreFullscreen),o||(i.mode=1)}return i}z(h){const i=this.g.getLastActiveWindow();if(!h.extensionTestsPath){if(h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const p=h.workspace;if((0,d.$5h)(p)){const D=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===p.id).map(k=>k.uiState);if(D.length)return D[0]}if((0,d.$Zh)(p)){const D=this.state.openedWindows.filter(k=>k.folderUri&&O.$mg.isEqual(k.folderUri,p.uri)).map(k=>k.uiState);if(D.length)return D[0]}else if(h.backupPath){const D=this.state.openedWindows.filter(k=>k.backupPath===h.backupPath).map(k=>k.uiState);if(D.length)return D[0]}const A=this.c||this.state.lastActiveWindow;if(!i&&A)return A.uiState}let c;const o=S.screen.getAllDisplays();if(o.length===1)c=o[0];else{if(s.$k){const p=S.screen.getCursorScreenPoint();c=S.screen.getDisplayNearestPoint(p)}!c&&i&&(c=S.screen.getDisplayMatching(i.getBounds())),c||(c=S.screen.getPrimaryDisplay()||o[0])}let t=(0,y.$$5b)();t.x=Math.round(c.bounds.x+c.bounds.width/2-t.width/2),t.y=Math.round(c.bounds.y+c.bounds.height/2-t.height/2);const n=this.n.getValue("window");let r=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,r=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,r=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const p=i.serializeWindowState();p.mode===3?t.mode=3:t=p,r=t.mode!==3&&n.newWindowDimensions==="offset"}}return r&&(t=this.C(t)),t.hasDefaultState=!0,t}C(h){if(this.g.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const i=this.g.getWindows().map(c=>c.getBounds());for(;i.some(c=>c.x===h.x||c.y===h.y);)h.x+=30,h.y+=30;return h}};e.$I7b=m,e.$I7b=m=v=Ee([te(0,w.$p6b),te(1,g.$wN),te(2,f.$b6b),te(3,a.$0i),te(4,P.$ji)],m);function b(E){const h={openedWindows:[]},i=E||{openedWindows:[]};return i.lastActiveWindow&&(h.lastActiveWindow=$(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=$(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(h.openedWindows=i.openedWindows.map(c=>$(c))),h}e.$J7b=b;function $(E){const h={uiState:E.uiState};return E.backupPath&&(h.backupPath=E.backupPath),E.remoteAuthority&&(h.remoteAuthority=E.remoteAuthority),E.folder&&(h.folderUri=C.URI.parse(E.folder)),E.workspaceIdentifier&&(h.workspace={id:E.workspaceIdentifier.id,configPath:C.URI.parse(E.workspaceIdentifier.configURIPath)}),h}function u(E){return{lastActiveWindow:E.lastActiveWindow&&l(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&l(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(h=>l(h))}}e.$K7b=u;function l(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(ie[53],ne([0,1,15,3,44,2,13,9,19,21,194,63,59,25,5,6,52,130,29,97,98]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=e.$H6b=void 0,e.$H6b=(0,v.$Ph)("workspacesManagementMainService");let h=class extends O.$Sc{constructor(c,o,t,n,r){super(),this.g=c,this.h=o,this.j=t,this.m=n,this.n=r,this.a=this.B(new R.$Nd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$Nd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const c=(await a.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(o=>(0,f.$vg)(this.c,o,u.$ci));for(const o of c){const t=(0,E.$x6b)(o),n=await this.resolveLocalWorkspace(o);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(c){c.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${c}).`)}}resolveLocalWorkspace(c){return this.r(c,o=>a.Promises.readFile(o,"utf8"))}r(c,o){if(this.s(c)&&c.scheme===C.Schemas.file)try{const t=o(c.fsPath);return t instanceof Promise?t.then(n=>this.t(c,n),n=>{}):this.t(c,t)}catch{return}}s(c){return(0,u.$di)(c,this.g)||(0,u.$ii)(c)}t(c,o){try{const t=this.u(c,o),n=(0,E.$x6b)(c);return{id:n.id,configPath:n.configPath,folders:(0,l.$MU)(t.folders,n.configPath,f.$mg),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(c,o){const t=(0,s.$Wm)(o);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,l.$KU)(n));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(c,o){const{workspace:t,storedWorkspace:n}=this.w(c,o),r=t.configPath.fsPath;return await a.Promises.mkdir((0,P.$mc)(r),{recursive:!0}),await a.Promises.writeFile(r,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:o}),t}w(c=[],o){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$vg)(this.c,t),r=(0,f.$vg)(n,u.$ci),p=[];for(const A of c)p.push((0,l.$LU)(A.uri,!0,A.name,n,f.$mg));return{workspace:(0,E.$x6b)(r),storedWorkspace:{folders:p,remoteAuthority:o}}}async getWorkspaceIdentifier(c){return(0,E.$x6b)(c)}isUntitledWorkspace(c){return(0,u.$di)(c.configPath,this.g)}async deleteUntitledWorkspace(c){this.isUntitledWorkspace(c)&&(await this.y(c),this.j.isEnabled()&&this.j.unsetWorkspace(c),this.a.fire(c))}async y(c){const o=(0,f.$jg)(c.configPath);try{await a.Promises.rm((0,P.$mc)(o));const t=(0,P.$jc)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,c.id);await a.Promises.exists(t)&&await a.Promises.writeFile((0,P.$jc)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==c.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${o} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(c,o,t){if(!c||!c.win||!c.isReady||!await this.z(c,o,t))return;const r=await this.C(c,(0,E.$x6b)(t));if(r)return this.b.fire({window:c,workspace:r.workspace}),r}async z(c,o,t){return t?(0,u.$5h)(c.openedWorkspace)&&f.$mg.isEqual(c.openedWorkspace.configPath,t)?!1:(0,$.$F6b)(o,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,f.$sg)(t)),detail:(0,g.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(c,o){if(!c.config)return;c.focus();let t;return c.config.extensionDevelopmentPath||(c.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:o,remoteAuthority:c.remoteAuthority},c.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:o,remoteAuthority:c.remoteAuthority})),(0,u.$5h)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&await this.deleteUntitledWorkspace(c.openedWorkspace),c.config.workspace=o,c.config.backupPath=t,{workspace:o,backupPath:t}}};e.$I6b=h,e.$I6b=h=Ee([te(0,d.$_5b),te(1,m.$0i),te(2,b.$h6b),te(3,w.$v6b),te(4,y.$C6b)],h)}),define(ie[132],ne([0,1,15,38,22,5,30,29,53,12,6,60]),function(X,e,S,R,s,O,C,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=e.$M6b=e.ID=void 0,e.ID="diagnosticsMainService",e.$M6b=(0,O.$Ph)(e.ID);let y=class{constructor(v,m,b){this.a=v,this.b=m,this.c=b}async getRemoteDiagnostics(v){const m=this.a.getWindows();return(await Promise.all(m.map(async $=>{const u=$.remoteAuthority;if(!u)return;const l=`vscode:getDiagnosticInfoResponse${$.id}`,E={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(h=>{$.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:l,args:E}),R.$jT.once(l,(i,c)=>{c||h({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),h(c)}),setTimeout(()=>{h({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const b of S.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(b.id);$?v.push(await this.d($)):v.push(this.e(b))}const m=[];for(const{pid:b,name:$}of w.$J6b.getAll())m.push({pid:b,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:m,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(v){const m=await this.f(v),b=(0,a.$Jf)(v.win);return this.e(b,m,v.remoteAuthority)}e(v,m=[],b){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:m,remoteAuthority:b}}async f(v){const m=[],b=v.openedWorkspace;if((0,P.$Zh)(b))m.push(b.uri);else if((0,P.$5h)(b)){const $=await this.b.resolveLocalWorkspace(b.configPath);$&&$.folders.forEach(l=>{m.push(l.uri)})}return m}};e.$N6b=y,e.$N6b=y=Ee([te(0,C.$p6b),te(1,f.$H6b),te(2,g.$0i)],y)}),define(ie[69],ne([0,1,47,15,28,156,54,3,2,13,9,4,7,105,87,21,103,182,59,25,5,20,6,24,67,30,29,53,17,243,235,114]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h,i,c,o,t,n,r,p,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=e.$86b=void 0,e.$86b=(0,E.$Ph)("nativeHostMainService");let I=class extends f.$Sc{constructor(N,z,_,Y,ce,re,ae,Z,Q){super(),this.a=N,this.b=z,this.c=_,this.f=Y,this.g=ce,this.h=re,this.j=ae,this.m=Z,this.n=Q,this.onDidOpenWindow=P.Event.map(this.a.onDidOpenWindow,G=>G.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:G,x:q,y:T})=>({windowId:G.id,x:q,y:T})),({windowId:G})=>!!this.a.getWindowById(G)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-maximize",(G,q)=>q.id),G=>!!this.a.getWindowById(G)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-unmaximize",(G,q)=>q.id),G=>!!this.a.getWindowById(G)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(G,q)=>q.id),G=>!!this.a.getWindowById(G)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),G=>!!G),G=>G.id),P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(G,q)=>q.id),G=>!!this.a.getWindowById(G))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new P.$Nd),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(G,q,T)=>T),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),P.Event.fromNodeEventEmitter(R.screen,"display-added"),P.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(z=>({id:z.id,workspace:z.openedWorkspace??(0,n.$4h)(z.backupPath,z.isExtensionDevelopmentHost),title:z.win?.getTitle()??"",filename:z.getRepresentedFilename(),dirty:z.isDocumentEdited()}))}async getWindowCount(N){return this.a.getWindowCount()}async getActiveWindowId(N){const z=R.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(z)return z.id}openWindow(N,z,_){return Array.isArray(z)?this.s(N,z,_):this.t(N,z)}async s(N,z,_=Object.create(null)){z.length>0&&await this.a.open({context:5,contextWindowId:N,urisToOpen:z,cli:this.g.args,forceNewWindow:_.forceNewWindow,forceReuseWindow:_.forceReuseWindow,preferNewWindow:_.preferNewWindow,diffMode:_.diffMode,mergeMode:_.mergeMode,addMode:_.addMode,gotoLineMode:_.gotoLineMode,noRecentEntry:_.noRecentEntry,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:_.remoteAuthority||void 0,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile})}async t(N,z){await this.a.openEmptyWindow({context:5,contextWindowId:N},z)}async toggleFullScreen(N){this.D(N)?.toggleFullScreen()}async handleTitleDoubleClick(N){this.D(N)?.handleTitleDoubleClick()}async isMaximized(N){const z=this.D(N);return z?.win?z.win.isMaximized():!1}async maximizeWindow(N){const z=this.D(N);z?.win&&z.win.maximize()}async unmaximizeWindow(N){const z=this.D(N);z?.win&&z.win.unmaximize()}async minimizeWindow(N){const z=this.D(N);z?.win&&z.win.minimize()}async moveWindowTop(N,z){const _=this.C(z?.targetWindowId)??this.D(N);_?.win&&_.win.moveTop()}async updateWindowControls(N,z){const _=this.D(N);_&&_.updateWindowControls(z)}async focusWindow(N,z){(this.C(z?.targetWindowId)??this.D(N))?.focus({force:z?.force??!1})}async setMinimumSize(N,z,_){const Y=this.D(N);if(Y?.win){const[ce,re]=Y.win.getSize(),[ae,Z]=Y.win.getMinimumSize(),[Q,G]=[z??ae,_??Z],[q,T]=[Math.max(ce,Q),Math.max(re,G)];(ae!==Q||Z!==G)&&Y.win.setMinimumSize(Q,G),(ce!==q||re!==T)&&Y.win.setSize(q,T)}}async saveWindowSplash(N,z){this.m.saveWindowSplash(N,z)}async installShellCommand(N){const{source:z,target:_}=await this.u();try{const{symbolicLink:Y}=await m.SymlinkSupport.stat(z);if(Y&&!Y.dangling){const ce=await(0,d.$8p)(z);if(_===ce)return}await m.Promises.unlink(z)}catch(Y){if(Y.code!=="ENOENT")throw Y}try{await m.Promises.symlink(_,z)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="ENOENT")throw Y;const{response:ce}=await this.showMessageBox(N,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(ce===0)try{const re=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${_}' '${z}'\\" with administrator privileges"`;await(0,O.promisify)(S.exec)(re)}catch{throw new Error((0,$.localize)(3,null,z))}}}async uninstallShellCommand(N){const{source:z}=await this.u();try{await m.Promises.unlink(z)}catch(_){switch(_.code){case"EACCES":{const{response:Y}=await this.showMessageBox(N,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(Y===0)try{const ce=`osascript -e "do shell script \\"rm '${z}'\\" with administrator privileges"`;await(0,O.promisify)(S.exec)(ce)}catch{throw new Error((0,$.localize)(7,null,z))}break}case"ENOENT":break;default:throw _}}}async u(){const N=(0,g.$kc)(this.g.appRoot,"bin","code"),z=`/usr/local/bin/${this.j.applicationName}`;if(!await m.Promises.exists(N))throw new Error((0,$.localize)(8,null,N));return{source:z,target:N}}async showMessageBox(N,z){const _=this.G()??this.D(N);return this.c.showMessageBox(z,_?.win??void 0)}async showSaveDialog(N,z){const _=this.G()??this.D(N);return this.c.showSaveDialog(z,_?.win??void 0)}async showOpenDialog(N,z){const _=this.G()??this.D(N);return this.c.showOpenDialog(z,_?.win??void 0)}async pickFileFolderAndOpen(N,z){const _=await this.c.pickFileFolder(z);_&&await this.w(await Promise.all(_.map(async Y=>await m.SymlinkSupport.existsDirectory(Y)?{folderUri:y.URI.file(Y)}:{fileUri:y.URI.file(Y)})),z,N)}async pickFolderAndOpen(N,z){const _=await this.c.pickFolder(z);_&&await this.w(_.map(Y=>({folderUri:y.URI.file(Y)})),z,N)}async pickFileAndOpen(N,z){const _=await this.c.pickFile(z);_&&await this.w(_.map(Y=>({fileUri:y.URI.file(Y)})),z,N)}async pickWorkspaceAndOpen(N,z){const _=await this.c.pickWorkspace(z);_&&await this.w(_.map(Y=>({workspaceUri:y.URI.file(Y)})),z,N)}async w(N,z,_){await this.a.open({context:3,contextWindowId:_,cli:this.g.args,urisToOpen:N,forceNewWindow:z.forceNewWindow})}async showItemInFolder(N,z){R.shell.showItemInFolder(z)}async setRepresentedFilename(N,z){this.D(N)?.setRepresentedFilename(z)}async setDocumentEdited(N,z){this.D(N)?.setDocumentEdited(z)}async openExternal(N,z){return this.g.unsetSnapExportedVariables(),R.shell.openExternal(z),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(N,z){return R.shell.trashItem(z)}async isAdmin(){let N;return w.$j?N=(await new Promise((z,_)=>{X(["native-is-elevated"],z,_)}))():N=process.getuid?.()===0,N}async writeElevated(N,z,_,Y){const ce=await new Promise((re,ae)=>{X(["@vscode/sudo-prompt"],re,ae)});return new Promise((re,ae)=>{const Z=[`"${this.z}"`];Y?.unlock&&Z.push("--file-chmod"),Z.push("--file-write",`"${z.fsPath}"`,`"${_.fsPath}"`);const Q={name:this.j.nameLong.replace("-",""),icns:w.$k&&this.g.isBuilt?(0,g.$jc)((0,g.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ce.exec(Z.join(" "),Q,(G,q,T)=>{q&&this.h.trace(`[sudo-prompt] received stdout: ${q}`),T&&this.h.trace(`[sudo-prompt] received stderr: ${T}`),G?ae(G):re(void 0)})})}async isRunningUnderARM64Translation(){return w.$l||w.$j?!1:R.app.runningUnderARM64Translation}get z(){return w.$j?this.g.isBuilt?(0,g.$jc)((0,g.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.bat"):w.$l?this.g.isBuilt?(0,g.$jc)((0,g.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,g.$jc)(this.g.appRoot,"bin","code"):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return v.$Rm.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return w.$j&&(0,A.$Y6b)()}async killProcess(N,z,_){process.kill(z,_)}async readClipboardText(N,z){return R.clipboard.readText(z)}async writeClipboardText(N,z,_){return R.clipboard.writeText(z,_)}async readClipboardFindText(N){return R.clipboard.readFindText()}async writeClipboardFindText(N,z){return R.clipboard.writeFindText(z)}async writeClipboardBuffer(N,z,_,Y){return R.clipboard.writeBuffer(z,Buffer.from(_.buffer),Y)}async readClipboardBuffer(N,z){return p.$be.wrap(R.clipboard.readBuffer(z))}async hasClipboard(N,z,_){return R.clipboard.has(z,_)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(N,z){this.D(N)?.updateTouchBar(z)}async notifyReady(N){this.D(N)?.setReady()}async relaunch(N,z){return this.f.relaunch(z)}async reload(N,z){const _=this.D(N);if(_){if((0,n.$5h)(_.openedWorkspace)){const Y=_.openedWorkspace.configPath;if(Y.scheme===a.Schemas.file&&(await this.n.resolveLocalWorkspace(Y))?.transient)return this.openWindow(_.id,{forceReuseWindow:!0})}return this.f.reload(_,z?.disableExtensions!==void 0?{_:[],"disable-extensions":z.disableExtensions}:void 0)}}async closeWindow(N){this.closeWindowById(N,N)}async closeWindowById(N,z){return(this.C(z)??this.D(z))?.win?.close()}async quit(N){const z=this.a.getLastActiveWindow();z?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&z.win?z.win.close():this.f.quit()}async exit(N,z){await this.f.kill(z)}async resolveProxy(N,z){return this.D(N)?.win?.webContents?.session?.resolveProxy(z)}findFreePort(N,z,_,Y,ce=1){return(0,b.$gg)(z,_,Y,ce)}async openDevTools(N,z){(this.G()??this.D(N))?.win?.webContents.openDevTools(z)}async toggleDevTools(N){(this.G()??this.D(N))?.win?.webContents.toggleDevTools()}async sendInputEvent(N,z){const _=this.D(N);_?.win&&(z.type==="mouseDown"||z.type==="mouseUp")&&_.win.webContents.sendInputEvent(z)}async profileRenderer(N,z,_){const Y=this.D(N);if(!Y||!Y.win)throw new Error;return await new D.$Z6b(Y.win,z,this.h).inspect(_)}async windowsGetStringRegKey(N,z,_,Y){if(!w.$j)return;const ce=await new Promise((re,ae)=>{X(["@vscode/windows-registry"],re,ae)});try{return ce.GetStringRegKey(z,_,Y)}catch{return}}C(N){return this.D(N)??this.F(N)}D(N){if(typeof N=="number")return this.a.getWindowById(N)}F(N){if(typeof N=="number")return this.b.getWindowById(N)}G(){return this.a.getFocusedWindow()??this.b.getFocusedWindow()}};e.$96b=I,Ee([C.$hh],I.prototype,"z",null),e.$96b=I=Ee([te(0,t.$p6b),te(1,k.$76b),te(2,u.$C6b),te(3,h.$b6b),te(4,l.$_5b),te(5,i.$0i),te(6,c.$pj),te(7,o.$n6b),te(8,r.$H6b)],I)}),define(ie[299],ne([0,1,15,38,28,2,13,4,107,180,90,132,59,25,6,69,78,24,79,68,33,34,60,22,7,30,8]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h,i,c,o,t,n){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$06b=void 0;const p="issue.processExplorerWindowState";let A=class{static{r=this}static{this.a="#1E1E1E"}constructor(I,j,N,z,_,Y,ce,re,ae,Z,Q){this.g=I,this.h=j,this.i=N,this.j=z,this.k=_,this.l=Y,this.m=ce,this.n=re,this.o=ae,this.p=Z,this.q=Q,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){R.$jT.on("vscode:listProcesses",async I=>{const j=[];try{j.push({name:(0,a.localize)(0,null),rootProcess:await(0,f.$Dr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,g.$rm)(z)?j.push({name:z.hostName,rootProcess:z}):z.processes&&j.push({name:z.hostName,rootProcess:z.processes})})}catch(N){this.i.error(`Listing processes failed: ${N}`)}this.t(I,"vscode:listProcessesResponse",j)}),R.$jT.on("vscode:workbenchCommand",(I,j)=>{const{id:N,from:z,args:_}=j;let Y;switch(z){case"processExplorer":Y=this.f;break;default:throw new Error(`Unexpected command source: ${z}`)}Y?.webContents.send("vscode:runAction",{id:N,from:z,args:_})}),R.$jT.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),R.$jT.on("vscode:pidToNameRequest",async I=>{const j=await this.k.getMainDiagnostics(),N=[];for(const z of j.windows)N.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:_}of i.$J6b.getAll())N.push([z,_]);this.t(I,"vscode:pidToNameResponse",N)})}async openReporter(I){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const j=new O.$Rc,N=j.add(this.n.createIPCObjectUrl()),z=this.v(this.c,700,800);this.b=this.u(z,N,{backgroundColor:I.styles.backgroundColor,title:(0,a.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),N.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:b.default}),this.b.loadURL(C.$cg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const j=new O.$Rc,N=j.add(this.n.createIPCObjectUrl()),z=this.p.getItem(p,void 0),_=D(z)?z:this.v(this.f,800,500);this.d=this.u(_,N,{backgroundColor:I.styles.backgroundColor,title:(0,a.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),N.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:b.default}),this.d.loadURL(C.$cg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const Y=()=>{if(!this.d)return;const ce=this.d.getSize(),re=this.d.getPosition();if(!ce||!re)return;const ae={width:ce[0],height:ce[1],x:re[0],y:re[1]};this.p.setItem(p,ae)};this.d.on("moved",Y),this.d.on("resized",Y)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await S.contentTracing.stopRecording(`${(0,E.$6f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,a.localize)(3,null),detail:(0,a.localize)(4,null,I),buttons:[(0,a.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,j)}async $getSystemInfo(){const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,j)}async $getPerformanceInfo(){try{const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,j)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,a.localize)(6,null),buttons:[(0,a.localize)(7,null),(0,a.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,a.localize)(9,null),buttons:[(0,a.localize)(10,null),(0,a.localize)(11,null)]},this.b);return I===0}return!1}async $getIssueReporterUri(I){if(!this.c)throw new Error("Issue reporter window not available");const j=this.q.getWindowById(this.c.id);if(!j)throw new Error("Window not found");const N=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return n.Promises.withAsyncBody(async(z,_)=>{const Y=new c.$Xd;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",Y.token,{replyChannel:N,extensionId:I}),R.$jT.once(N,(ce,re)=>{z(o.URI.parse(re))});try{await(0,n.$Ug)(5e3),Y.cancel(),_(new Error("Timed out waiting for issue reporter URI"))}finally{R.$jT.removeHandler(N)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,j,...N){I.sender.isDestroyed()||I.sender.send(j,...N)}u(I,j,N,z){const _=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:N.title,backgroundColor:N.backgroundColor||r.a,webPreferences:{preload:C.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.$9C)(N.zoomLevel),sandbox:!0},alwaysOnTop:N.alwaysOnTop,experimentalDarkMode:!0});return _.setMenuBarVisibility(!1),_}v(I,j,N){let z;const _=S.screen.getAllDisplays();if(_.length===1)z=_[0];else{if(P.$k){const re=S.screen.getCursorScreenPoint();z=S.screen.getDisplayNearestPoint(re)}!z&&I&&(z=S.screen.getDisplayMatching(I.getBounds())),z||(z=S.screen.getPrimaryDisplay()||_[0])}const Y=z.bounds,ce={width:j,height:N,x:Y.x+Y.width/2-j/2,y:Y.y+Y.height/2-N/2};return Y.width>0&&Y.height>0&&(ce.x<Y.x&&(ce.x=Y.x),ce.y<Y.y&&(ce.y=Y.y),ce.x>Y.x+Y.width&&(ce.x=Y.x),ce.y>Y.y+Y.height&&(ce.y=Y.y),ce.width>Y.width&&(ce.width=Y.width),ce.height>Y.height&&(ce.height=Y.height)),ce}};e.$06b=A,e.$06b=A=r=Ee([te(1,d.$_5b),te(2,v.$0i),te(3,g.$qm),te(4,w.$M6b),te(5,y.$C6b),te(6,m.$86b),te(7,u.$16b),te(8,$.$pj),te(9,h.$wN),te(10,t.$p6b)],A);function D(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(ie[300],ne([0,1,22,18,25,20,6,69,24,50,26,48,100]),function(X,e,S,R,s,O,C,P,f,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=void 0;let d=class extends y.$w7b{constructor(m,b,$,u,l,E,h,i){super(m,b,u,l,E,i),this.e=$,this.u=h}s(m){return(0,y.$v7b)(`linux-${process.arch}`,m,this.k)}t(m){this.a&&(this.d(w.$iU.CheckingForUpdates(m)),this.i.request({url:this.a},S.CancellationToken.None).then(a.$Zo).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!m}),this.d(w.$iU.Idle(1))):this.d(w.$iU.AvailableForDownload(b))}).then(void 0,b=>{this.j.error(b),this.e.publicLog2("update:notAvailable",{explicit:!!m});const $=m?b.message||b:void 0;this.d(w.$iU.Idle(1,$))}))}async o(m){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):m.update.url&&this.u.openExternal(void 0,m.update.url),this.d(w.$iU.Idle(1))}};e.$y7b=d,e.$y7b=d=Ee([te(0,O.$b6b),te(1,R.$ji),te(2,g.$cl),te(3,s.$_5b),te(4,a.$To),te(5,C.$0i),te(6,P.$86b),te(7,f.$pj)],d)}),define(ie[301],ne([0,1,47,45,28,8,22,54,9,7,144,21,18,25,16,20,6,69,24,50,26,48,100]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A7b=void 0;async function c(r,p=1e3){for(;!r();)await(0,O.$Ug)(p)}let o;function t(){return typeof o>"u"&&(o=R.existsSync(f.$jc(f.$mc(process.execPath),"unins000.exe"))?0:1),o}let n=class extends i.$w7b{get cachePath(){const p=f.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return w.Promises.mkdir(p,{recursive:!0}).then(()=>p)}constructor(p,A,D,k,I,j,N,z,_){super(p,A,k,I,j,_),this.u=D,this.v=N,this.w=z,p.setRelaunchHandler(this)}handleRelaunch(p){return p?.addArgs||p?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(h.$iU.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(p){let A="win32";return process.arch!=="ia32"&&(A+=`-${process.arch}`),t()===1?A+="-archive":this.k.target==="user"&&(A+="-user"),(0,i.$v7b)(A,p,this.k)}t(p){this.a&&(this.d(h.$iU.CheckingForUpdates(p)),this.i.request({url:this.a},C.CancellationToken.None).then(l.$Zo).then(A=>{const D=t();return!A||!A.url||!A.version||!A.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!p}),this.d(h.$iU.Idle(D)),Promise.resolve(null)):D===1?(this.d(h.$iU.AvailableForDownload(A)),Promise.resolve(null)):(this.d(h.$iU.Downloading(A)),this.C(A.version).then(()=>this.B(A.version).then(k=>w.Promises.exists(k).then(I=>{if(I)return Promise.resolve(k);const j=A.url,N=A.hash,z=`${k}.tmp`;return this.i.request({url:j},C.CancellationToken.None).then(_=>this.v.writeFile(a.URI.file(z),_.stream)).then(N?()=>(0,g.$eT)(z,A.hash):()=>{}).then(()=>w.Promises.rename(z,k,!1)).then(()=>k)})).then(k=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(h.$iU.Downloaded(A)):this.d(h.$iU.Ready(A))})))}).then(void 0,A=>{this.j.error(A),this.u.publicLog2("update:notAvailable",{explicit:!!p});const D=p?A.message||A:void 0;this.d(h.$iU.Idle(t(),D))}))}async o(p){p.update.url&&this.w.openExternal(void 0,p.update.url),this.d(h.$iU.Idle(t()))}async B(p){const A=await this.cachePath;return f.$jc(A,`CodeSetup-${this.k.quality}-${p}.exe`)}async C(p=null){const A=p?j=>!new RegExp(`${this.k.quality}-${p}\\.exe$`).test(j):()=>!0,D=await this.cachePath,I=(await w.Promises.readdir(D)).filter(A).map(async j=>{try{await w.Promises.unlink(f.$jc(D,j))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const p=this.state.update;this.d(h.$iU.Updating(p));const A=await this.cachePath;this.e.updateFilePath=f.$jc(A,`CodeSetup-${this.k.quality}-${p.version}.flag`),await w.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(h.$iU.Idle(t()))});const k=`${this.k.win32MutexName}-ready`,I=await new Promise((j,N)=>{X(["@vscode/windows-mutex"],j,N)});c(()=>I.isActive(k)).then(()=>this.d(h.$iU.Ready(p)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return t()}async _applySpecificUpdate(p){if(this.state.type!=="idle")return;const A=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown"};this.d(h.$iU.Downloading(D)),this.e={packagePath:p},A?this.k.target==="user"?this.p():this.d(h.$iU.Downloaded(D)):this.d(h.$iU.Ready(D))}};e.$A7b=n,Ee([P.$hh],n.prototype,"cachePath",null),e.$A7b=n=Ee([te(0,m.$b6b),te(1,y.$ji),te(2,E.$cl),te(3,d.$_5b),te(4,l.$To),te(5,b.$0i),te(6,v.$$j),te(7,$.$86b),te(8,u.$pj)],n)}),define(ie[133],ne([0,1,15,8,22,49,3,2,13,65,4,7,190,63,18,59,25,62,16,20,6,24,79,252,81,26,102,67,68,30,29,53,95,136,39,34,52,66,23,5]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h,i,c,o,t,n,r,p,A,D,k,I,j,N,z,_,Y,ce,re){"use strict";var ae;Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=e.$46b=void 0;var Z;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(Z||(Z={}));class Q extends P.$Sc{focus(T){g.$k&&T?.force&&S.app.focus({steal:!0});const K=this.a();K&&(K.isMinimized()&&K.restore(),K.focus())}}e.$46b=Q;let G=class extends Q{static{ae=this}static{this.b="windowControlHeight"}get id(){return this.m}get win(){return this.n}a(){return this.n}get lastFocusTime(){return this.s}get backupPath(){return this.t?.backupPath}get openedWorkspace(){return this.t?.workspace}get profile(){if(!this.config)return;const T=this.U.profiles.find(K=>K.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&T?T:this.U.getProfileForWorkspace(this.config.workspace??(0,D.$4h)(this.backupPath,this.isExtensionDevelopmentHost))??this.U.defaultProfile}get remoteAuthority(){return this.t?.remoteAuthority}get config(){return this.t}get isExtensionDevelopmentHost(){return!!this.t?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.t?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.t?.debugId}constructor(T,K,H,x,B,F,M,U,W,L,V,J,oe,le,de,fe,ve,me,ye,Oe,Me){super(),this.P=K,this.Q=H,this.R=x,this.S=B,this.U=F,this.W=M,this.X=U,this.Y=W,this.Z=L,this.$=V,this.ab=J,this.bb=oe,this.db=le,this.eb=de,this.fb=fe,this.gb=ve,this.hb=me,this.ib=ye,this.jb=Oe,this.c=this.B(new C.$Nd),this.onWillLoad=this.c.event,this.f=this.B(new C.$Nd),this.onDidSignalReady=this.f.event,this.g=this.B(new C.$Nd),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new C.$Nd),this.onDidClose=this.h.event,this.j=this.B(new C.$Nd),this.onDidDestroy=this.j.event,this.s=-1,this.z=void 0,this.C=void 0,this.G=!1,this.H=[],this.I=[],this.J=void 0,this.L=void 0,this.M=this.B(this.hb.createIPCObjectUrl()),this.O=!1,this.lb=0;{const[we,pe]=this.vb(T.state);this.u=we,this.P.trace("window#ctor: using window state",we);const se=this.u.mode===0||this.u.mode===3,ue=this.Z.getValue("window"),ge=Me.invokeFunction(A.$q6b,this.u,{show:!se,webPreferences:{preload:f.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.M.resource.toString()}`],v8CacheOptions:this.R.useCodeCache?"bypassHeatCheck":"none"}});g.$k&&!this.Cb()&&(ge.fullscreenable=!1);const Ie=g.$k&&ue?.nativeTabs===!0;Ie&&(ge.tabbingIdentifier=this.gb.nameShort);const De=(0,p.$7C)(this.Z)==="custom";if(De&&(ge.titleBarStyle="hidden",g.$k||(ge.frame=!1),(0,p.$8C)(this.Z))){const Ne=this.$.getWindowSplash()?.colorInfo.titleBarBackground??this.$.getBackgroundColor(),Re=j.$Ys.fromHex(Ne).isDarker()?"#FFFFFF":"#000000";ge.titleBarOverlay={height:29,color:Ne,symbolColor:Re},this.G=!0}if((0,a.mark)("code/willCreateCodeBrowserWindow"),this.n=new S.BrowserWindow(ge),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.m=this.n.id,g.$k&&De&&this.n.setSheetOffset(22),De&&(g.$j&&(0,p.$8C)(this.Z)||g.$k)){const Ne=this.jb.getItem(ae.b);Ne&&this.updateWindowControls({height:Ne})}g.$j&&De&&this.n.hookWindowMessage(278,()=>{const[Re,qe]=this.n.getPosition(),ze=S.screen.getCursorScreenPoint(),ee=ze.x-Re,he=ze.y-qe;return(()=>!(ee>30&&he>=0&&he<=Math.max(this.n.getBounds().height*.15,35)))()||(this.n.setEnabled(!1),this.n.setEnabled(!0),this.g.fire({x:ee,y:he})),0}),(g.$k||g.$j)&&pe&&(!Ie||S.BrowserWindow.getAllWindows().length===1)&&[this.u.width,this.u.height,this.u.x,this.u.y].every(Ne=>typeof Ne=="number")&&this.n.setBounds({width:this.u.width,height:this.u.height,x:this.u.x,y:this.u.y}),se&&((0,a.mark)("code/willMaximizeCodeWindow"),this.n.maximize(),this.u.mode===3?(this.kb("WindowMode.Fullscreen"),this.yb(!0)):this.kb("WindowMode.Maximized"),this.n.show(),(0,a.mark)("code/didMaximizeCodeWindow")),this.s=Date.now()}this.R.args["open-devtools"]===!0&&this.n.webContents.openDevTools(),this.sb(),this.Gb(),this.mb()}kb(T){this.Z.getValue("window.logFullScreenTransitions")&&this.P.info(`window-fullscreen-bug: ${T})`)}setRepresentedFilename(T){g.$k?this.n.setRepresentedFilename(T):this.D=T}getRepresentedFilename(){return g.$k?this.n.getRepresentedFilename():this.D}setDocumentEdited(T){g.$k&&this.n.setDocumentEdited(T),this.F=T}isDocumentEdited(){return g.$k?this.n.isDocumentEdited():!!this.F}setReady(){for(this.P.trace(`window#load: window reported ready (id: ${this.m})`),this.lb=2;this.H.length;)this.H.pop()(this);this.f.fire()}ready(){return new Promise(T=>{if(this.isReady)return T(this);this.H.push(T)})}get isReady(){return this.lb===2}get whenClosedOrLoaded(){return new Promise(T=>{function K(){H.dispose(),x.dispose(),T()}const H=this.onDidClose(()=>K()),x=this.onWillLoad(()=>K())})}mb(){this.n.on("unresponsive",()=>this.pb(1)),this.n.webContents.on("render-process-gone",(K,H)=>this.pb(2,{...H})),this.n.webContents.on("did-fail-load",(K,H,x)=>this.pb(3,{reason:x,exitCode:H})),this.n.webContents.on("will-prevent-unload",K=>{K.preventDefault()}),this.n.on("closed",()=>{this.h.fire(),this.dispose()}),this.n.webContents.on("did-finish-load",()=>{this.N&&(this.t=this.N,this.N=void 0)}),this.n.on("focus",()=>{this.s=Date.now()}),this.n.on("maximize",K=>{this.t&&(this.t.maximized=!0),S.app.emit("browser-window-maximize",K,this.n)}),this.n.on("unmaximize",K=>{this.t&&(this.t.maximized=!1),S.app.emit("browser-window-unmaximize",K,this.n)}),this.n.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.kb(`enter-full-screen: ${Date.now()}`),this.C?.complete(),this.C=void 0}),this.n.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.kb(`leave-full-screen: ${Date.now()}`),this.C?.complete(),this.C=void 0}),this.B(this.Z.onDidChangeConfiguration(K=>this.sb(K))),this.B(this.ab.onDidDeleteUntitledWorkspace(K=>this.rb(K)));const T=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.n.webContents.session.webRequest.onBeforeSendHeaders({urls:T},async(K,H)=>{const x=await this.ob();H({cancel:!1,requestHeaders:Object.assign(K.requestHeaders,x)})})}ob(){return this.nb||(this.nb=(0,c.$bp)(this.gb.version,this.gb,this.R,this.Z,this.W,this.X,this.db)),this.nb}async pb(T,K){switch(T){case 2:this.P.error(`CodeWindow: renderer process gone (reason: ${K?.reason||"<unknown>"}, code: ${K?.exitCode||"<unknown>"})`);break;case 1:this.P.error("CodeWindow: detected unresponsive");break;case 3:this.P.error(`CodeWindow: failed to load (reason: ${K?.reason||"<unknown>"}, code: ${K?.exitCode||"<unknown>"})`);break}switch(this.db.publicLog2("windowerror",{type:T,reason:K?.reason,code:K?.exitCode}),T){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.fb.kill(1);return}if(this.R.args["enable-smoke-test-driver"]){await this.qb(!1,!1),this.fb.quit();return}if(T===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.n&&this.n.webContents&&this.n.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:x}=await this.eb.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this.t?.workspace?(0,y.localize)(5,null):void 0},this.n);if(H!==2){const B=H===0;await this.qb(B,x)}}else if(T===2){let H;K?H=(0,y.localize)(7,null,K.reason,K.exitCode??"<unknown>"):H=(0,y.localize)(6,null);const{response:x,checkboxChecked:B}=await this.eb.showMessageBox({type:"warning",buttons:[this.t?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:H,detail:this.t?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this.t?.workspace?(0,y.localize)(13,null):void 0},this.n),F=x===0;await this.qb(F,B)}break}}async qb(T,K){const H=this.t?.workspace;if(K&&H)try{const x=this.Y.workspaceStorage(H);await x.init(),x.delete("memento/workbench.parts.editor"),await x.close()}catch(x){this.P.error(x)}if(this.j.fire(),this.n?.destroy(),T&&this.t){let x,B;(0,D.$Zh)(H)?x={folderUri:H.uri}:(0,D.$5h)(H)?x={workspaceUri:H.configPath}:B=!0,(0,ce.$Ob)(await this.ib.open({context:5,userEnv:this.t.userEnv,cli:{...this.R.args,_:[]},urisToOpen:x?[x]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}rb(T){this.t?.workspace?.id===T.id&&(this.t.workspace=void 0)}sb(T){if(!T||T.affectsConfiguration("window.menuBarVisibility")){const K=this.Db();K!==this.w&&(this.w=K,this.Eb(K))}if(!T||T.affectsConfiguration("http.proxy")){let K=(this.Z.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;K?.endsWith("/")&&(K=K.substr(0,K.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((K||"").indexOf("@")===-1&&(K!==this.J||H!==this.L)){this.J=K,this.L=H;const x=K||"",B=H?`${H},<local>`:"<local>";this.P.trace(`Setting proxy to '${x}', bypassing '${B}'`),this.n.webContents.session.setProxy({proxyRules:x,proxyBypassRules:B,pacScript:""})}}}addTabbedWindow(T){g.$k&&T.win&&this.n.addTabbedWindow(T.win)}load(T,K=Object.create(null)){this.P.trace(`window#load: attempt to load window (id: ${this.m})`),this.isDocumentEdited()&&(!K.isReload||!this.bb.isHotExitEnabled())&&this.setDocumentEdited(!1),K.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.n.setTitle(this.gb.nameLong)),this.tb(T,K),this.lb===0?this.t=T:this.N=T,this.lb=1,this.n.loadURL(f.$cg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.R.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.O;this.O=!0,!this.R.isBuilt&&!this.R.extensionTestsLocationURI&&this.B(new R.$6g(()=>{this.n&&!this.n.isVisible()&&!this.n.isMinimized()&&(this.n.show(),this.focus({force:!0}),this.n.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:T.workspace,reason:K.isReload?3:H?2:1})}tb(T,K){const H=(this.t??this.N)?.userEnv;if(H){const x=(0,$.$Nl)(H)&&!(0,$.$Nl)(T.userEnv),B=this.isExtensionDevelopmentHost;(x||B)&&(T.userEnv={...H,...T.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(T.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),K.disableExtensions!==void 0&&(T["disable-extensions"]=K.disableExtensions),T.fullscreen=this.isFullScreen,T.maximized=this.n.isMaximized(),T.partsSplash=this.$.getWindowSplash(),(0,a.mark)("code/willOpenNewWindow"),T.perfMarks=(0,a.getMarks)(),this.M.update(T)}async reload(T){const K=Object.assign({},this.t);K.workspace=await this.ub(K),delete K.filesToOpenOrCreate,delete K.filesToDiff,delete K.filesToMerge,delete K.filesToWait,this.isExtensionDevelopmentHost&&T&&(K.verbose=T.verbose,K.debugId=T.debugId,K.extensionEnvironment=T.extensionEnvironment,K["inspect-extensions"]=T["inspect-extensions"],K["inspect-brk-extensions"]=T["inspect-brk-extensions"],K["extensions-dir"]=T["extensions-dir"]),K.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),K.isInitialStartup=!1,K.policiesData=this.S.serialize(),K.continueOn=this.R.continueOn,K.profiles={all:this.U.profiles,profile:this.profile||this.U.defaultProfile,home:this.U.profilesHome},K.logLevel=this.Q.getLogLevel(),K.loggers={window:this.Q.getRegisteredLoggers(this.id),global:this.Q.getRegisteredLoggers()},this.load(K,{isReload:!0,disableExtensions:T?.["disable-extensions"]})}async ub(T){if((0,D.$5h)(T.workspace)){const K=T.workspace.configPath;if(K.scheme===f.Schemas.file&&!await this.W.exists(K))return}else if((0,D.$Zh)(T.workspace)){const K=T.workspace.uri;if(K.scheme===f.Schemas.file&&!await this.W.exists(K))return}return T.workspace}serializeWindowState(){if(!this.n)return(0,I.$$5b)();if(this.isFullScreen){let H;try{H=S.screen.getDisplayMatching(this.getBounds())}catch{}const x=(0,I.$$5b)();return{mode:3,display:H?H.id:void 0,width:this.u.width||x.width,height:this.u.height||x.height,x:this.u.x||0,y:this.u.y||0}}const T=Object.create(null);let K;if(!g.$k&&this.n.isMaximized()?K=0:K=1,K===0?T.mode=0:T.mode=1,K===1||K===0){let H;K===1?H=this.getBounds():H=this.n.getNormalBounds(),T.x=H.x,T.y=H.y,T.width=H.width,T.height=H.height}return T}updateWindowControls(T){if(T.height&&this.jb.setItem(ae.b,T.height),g.$j&&this.G)this.n.setTitleBarOverlay({color:T.backgroundColor?.trim()===""?void 0:T.backgroundColor,symbolColor:T.foregroundColor?.trim()===""?void 0:T.foregroundColor,height:T.height?T.height-1:void 0});else if(g.$k&&T.height!==void 0){const K=(T.height-15)/2;K?this.n.setWindowButtonPosition({x:K,y:K}):this.n.setWindowButtonPosition(null)}}vb(T){(0,a.mark)("code/willRestoreCodeWindowState");let K=!1;if(T)try{const H=S.screen.getAllDisplays();K=H.length>1,T=this.wb(T,H)}catch(H){this.P.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,a.mark)("code/didRestoreCodeWindowState"),[T||(0,I.$$5b)(),K]}wb(T,K){if(this.P.trace(`window#validateWindowState: validating window state on ${K.length} display(s)`,T),typeof T.x!="number"||typeof T.y!="number"||typeof T.width!="number"||typeof T.height!="number"){this.P.trace("window#validateWindowState: unexpected type of state values");return}if(T.width<=0||T.height<=0){this.P.trace("window#validateWindowState: unexpected negative values");return}if(K.length===1){const B=this.xb(K[0]);if(B){let F=function(){!T||typeof T.x!="number"||typeof T.y!="number"||!B||(T.x<B.x&&(T.x=B.x),T.y<B.y&&(T.y=B.y))};this.P.trace("window#validateWindowState: 1 monitor working area",B),F(),T.width>B.width&&(T.width=B.width),T.height>B.height&&(T.height=B.height),T.x>B.x+B.width-128&&(T.x=B.x+B.width-T.width),T.y>B.y+B.height-128&&(T.y=B.y+B.height-T.height),F()}return T}if(T.display&&T.mode===3){const B=K.find(F=>F.id===T.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.P.trace("window#validateWindowState: restoring fullscreen to previous display");const F=(0,I.$$5b)(3);return F.x=B.bounds.x,F.y=B.bounds.y,F}}let H,x;try{H=S.screen.getDisplayMatching({x:T.x,y:T.y,width:T.width,height:T.height}),x=this.xb(H)}catch{}if(H&&x&&T.x+T.width>x.x&&T.y+T.height>x.y&&T.x<x.x+x.width&&T.y<x.y+x.height)return this.P.trace("window#validateWindowState: multi-monitor working area",x),T}xb(T){if(T.workArea.width>0&&T.workArea.height>0)return T.workArea;if(T.bounds.width>0&&T.bounds.height>0)return T.bounds}getBounds(){const[T,K]=this.n.getPosition(),[H,x]=this.n.getSize();return{x:T,y:K,width:H,height:x}}toggleFullScreen(){this.yb(!this.isFullScreen)}yb(T){this.Cb()?this.zb(T):this.Bb(T),this.sendWhenReady(T?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.w&&this.Eb(this.w,!1)}get isFullScreen(){if(this.kb(`isFullScreen(): begin at ${Date.now()}`),g.$k&&typeof this.z=="boolean")return this.kb(`isFullScreen(): returning transientIsNativeFullScreen = ${this.z}`),this.z;const T=this.n.isFullScreen(),K=this.n.isSimpleFullScreen();return this.kb(`isFullScreen(): returning natively, isFullScreen = ${T}, isSimpleFullScreen = ${K}`),T||K}zb(T){this.n.isSimpleFullScreen()&&this.n.setSimpleFullScreen(!1),this.Ab(T)}Ab(T){g.$k&&(this.kb(`doSetNativeFullScreen(${T}): begin at ${Date.now()}`),this.z=T,this.C=new R.$ch,Promise.race([this.C.p,(0,R.$Ug)(1e3)]).finally(()=>{this.kb(`doSetNativeFullScreen(${T}): finish at ${Date.now()}`),this.z=void 0})),this.n.setFullScreen(T)}Bb(T){this.n.isFullScreen()&&this.Ab(!1),this.n.setSimpleFullScreen(T),this.n.webContents.focus()}Cb(){const T=this.Z.getValue("window");return!T||typeof T.nativeFullScreen!="boolean"||T.nativeTabs?!0:T.nativeFullScreen!==!1}isMinimized(){return this.n.isMinimized()}Db(){let T=(0,p.$6C)(this.Z);return["visible","toggle","hidden"].indexOf(T)<0&&(T="classic"),T}Eb(T,K=!0){g.$k||(T==="toggle"&&K&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),T==="hidden"?setTimeout(()=>{this.Fb(T)}):this.Fb(T))}Fb(T){const K=this.isFullScreen;switch(T){case"classic":this.n.setMenuBarVisibility(!K),this.n.autoHideMenuBar=K;break;case"visible":this.n.setMenuBarVisibility(!0),this.n.autoHideMenuBar=!1;break;case"toggle":this.n.setMenuBarVisibility(!1),this.n.autoHideMenuBar=!0;break;case"hidden":this.n.setMenuBarVisibility(!1),this.n.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.$k)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.n.minimize();break;case"None":break;case"Maximize":default:this.n.isMaximized()?this.n.unmaximize():this.n.maximize()}else this.n.isMaximized()?this.n.unmaximize():this.n.maximize()}close(){this.n?.close()}sendWhenReady(T,K,...H){this.isReady?this.send(T,...H):this.ready().then(()=>{K.isCancellationRequested||this.send(T,...H)})}send(T,...K){if(this.n){if(this.n.isDestroyed()||this.n.webContents.isDestroyed()){this.P.warn(`Sending IPC message to channel '${T}' for window that is destroyed`);return}try{this.n.webContents.send(T,...K)}catch(H){this.P.warn(`Error sending IPC message to channel '${T}' of window ${this.m}: ${(0,O.$Ai)(H)}`)}}}updateTouchBar(T){g.$k&&this.I.forEach((K,H)=>{const x=T[H];K.segments=this.Ib(x)})}Gb(){if(g.$k){for(let T=0;T<10;T++){const K=this.Hb();this.I.push(K)}this.n.setTouchBar(new S.TouchBar({items:this.I}))}}Hb(T=[]){const K=this.Ib(T),H=new S.TouchBar.TouchBarSegmentedControl({segments:K,mode:"buttons",segmentStyle:"automatic",change:x=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:H.segments[x].id,from:"touchbar"})}});return H}Ib(T=[]){return T.map(H=>{let x;H.icon&&!n.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===f.Schemas.file&&(x=S.nativeImage.createFromPath(w.URI.revive(H.icon.dark).fsPath),x.isEmpty()&&(x=void 0));let B;return typeof H.title=="string"?B=H.title:B=H.title.value,{id:H.id,label:x?void 0:B,icon:x}})}dispose(){super.dispose(),this.Q.deregisterLoggers(this.id),this.n=null}};e.$56b=G,e.$56b=G=ae=Ee([te(1,E.$0i),te(2,Y.$26b),te(3,b.$_5b),te(4,N.$in),te(5,_.$h6b),te(6,u.$$j),te(7,o.$l6b),te(8,o.$j6b),te(9,v.$ji),te(10,r.$n6b),te(11,k.$H6b),te(12,d.$v6b),te(13,t.$cl),te(14,m.$C6b),te(15,l.$b6b),te(16,h.$pj),te(17,i.$16b),te(18,A.$p6b),te(19,z.$wN),te(20,re.$Oh)],G)}),define(ie[302],ne([0,1,15,3,25,133]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=void 0;let C=class extends O.$46b{get win(){if(!this.c){const f=S.BrowserWindow.fromWebContents(this.g);f&&(this.c=f,this.m(f))}return this.c}a(){return this.win}constructor(f,a){super(),this.g=f,this.h=a,this.id=this.g.id,this.b=this.B(new R.$Nd),this.onDidClose=this.b.event,this.c=null,this.j()}j(){this.h.args["open-devtools"]===!0&&this.g.openDevTools({mode:"bottom"})}m(f){f.on("closed",()=>{this.b.fire(),this.dispose()})}};e.$66b=C,e.$66b=C=Ee([te(1,s.$_5b)],C)}),define(ie[303],ne([0,1,15,3,13,302,5,30]),function(X,e,S,R,s,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67b=void 0;let f=class{constructor(g){this.b=g,this.a=new Map}createWindow(){return this.b.invokeFunction(P.$q6b,void 0,{webPreferences:{preload:s.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-slim.js").fsPath}})}registerWindow(g){const w=this.b.createInstance(O.$66b,g);this.a.set(w.id,w),R.Event.once(w.onDidClose)(()=>this.a.delete(w.id))}getWindowById(g){return this.a.get(g)}getFocusedWindow(){const g=S.BrowserWindow.getFocusedWindow();if(g)return this.getWindowById(g.id)}};e.$67b=f,e.$67b=f=Ee([te(0,C.$Oh)],f)}),define(ie[82],ne([0,1,15,23,8,3,46,2,13,4,19,7,21,193,5,20,6,81,97,29,53,31]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=e.$h7b=void 0,e.$h7b=(0,v.$Ph)("workspacesHistoryMainService");let c=class extends P.$Sc{static{i=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(t,n,r,p){super(),this.f=t,this.g=n,this.h=r,this.j=p,this.c=this.B(new O.$Nd),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Rg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(t=>this.addRecentlyOpened([{workspace:t.workspace,remoteAuthority:t.window.remoteAuthority}])))}async addRecentlyOpened(t){let n=[],r=[];for(const A of t)if((0,u.$HU)(A))!this.g.isUntitledWorkspace(A.workspace)&&!this.u(n,A.workspace)&&n.push(A);else if((0,u.$IU)(A))this.w(n,A.folderUri)||n.push(A);else{const D=this.y(r,A.fileUri),k=A.fileUri.scheme===f.Schemas.file&&i.F.indexOf((0,g.$sg)(A.fileUri))>=0;!D&&!k&&(r.push(A),a.$j&&A.fileUri.scheme===f.Schemas.file&&S.app.addRecentDocument(A.fileUri.fsPath))}const p=await this.n({workspaces:n,files:r});n=p.workspaces,r=p.files,n.length>i.a&&(n.length=i.a),r.length>i.a&&(r.length=i.a),await this.s({workspaces:n,files:r}),this.c.fire(),a.$k&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(t){const n=D=>{const k=this.t(D);for(const I of t)if(g.$mg.isEqual(I,k))return!1;return!0},r=await this.getRecentlyOpened(),p=r.workspaces.filter(n),A=r.files.filter(n);(p.length!==r.workspaces.length||A.length!==r.files.length)&&(await this.s({files:A,workspaces:p}),this.c.fire(),a.$k&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(t){const n=new h.$Ac(A=>g.$mg.getComparisonKey(A));if(t?.workspaces)for(const A of t.workspaces)n.set(this.t(A),A);const r=new h.$Ac(A=>g.$mg.getComparisonKey(A));if(t?.files)for(const A of t.files)r.set(this.t(A),A);const p=await this.r();for(const A of p.workspaces){const D=n.get(this.t(A));D?D.label=D.label??A.label:n.set(this.t(A),A)}for(const A of p.files){const D=r.get(this.t(A));D?D.label=D.label??A.label:r.set(this.t(A),A)}return{workspaces:[...n.values()],files:[...r.values()]}}async r(){await this.j.whenReady;let t;const n=this.j.get(i.b,-1);if(typeof n=="string")try{t=JSON.parse(n)}catch(r){this.f.error("Unexpected error parsing opened paths list",r)}return(0,u.$OU)(t,this.f)}async s(t){await this.j.whenReady,this.j.store(i.b,JSON.stringify((0,u.$PU)(t)),-1,1)}t(t){return(0,u.$IU)(t)?t.folderUri:(0,u.$JU)(t)?t.fileUri:t.workspace.configPath}u(t,n){return!!t.find(r=>(0,u.$HU)(r)&&r.workspace.id===n.id)}w(t,n){return!!t.find(r=>(0,u.$IU)(r)&&g.$mg.isEqual(r.folderUri,n))}y(t,n){return!!t.find(r=>g.$mg.isEqual(r.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){a.$j&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!a.$j)return;const t=[];if(t.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const A of S.app.getJumpListSettings().removedItems){const D=A.args;if(D){const k=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);k&&n.push(w.URI.parse(k[2]))}}await this.removeRecentlyOpened(n);let r=!1;const p=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,i.D).map(A=>{const D=(0,u.$HU)(A)?A.workspace:A.folderUri,{title:k,description:I}=this.J(D,A.label);let j;return w.URI.isUri(D)?j=`--folder-uri "${D.toString()}"`:(r=!0,j=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:k.substr(0,255),description:I.substr(0,255),program:process.execPath,args:j,iconPath:"explorer.exe",iconIndex:0}}));p.length>0&&t.push({type:"custom",name:r?(0,d.localize)(2,null):(0,d.localize)(3,null),items:p})}t.push({type:"recent"});try{const n=S.app.setJumpList(t);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(t,n){if(n)return{title:(0,C.$Av)(n).name,description:n};if(w.URI.isUri(t))return{title:(0,g.$sg)(t),description:this.L(t)};if(this.g.isUntitledWorkspace(t))return{title:(0,d.localize)(4,null),description:""};let r=(0,g.$sg)(t.configPath);return r.endsWith(l.$_h)&&(r=r.substr(0,r.length-l.$_h.length-1)),{title:(0,d.localize)(5,null,r),description:this.L(t.configPath)}}L(t){return t.scheme==="file"?(0,C.$sv)(t.fsPath):t.toString()}async M(){if(!a.$k)return;S.app.clearRecentDocuments();const t=await this.getRecentlyOpened(),n=[];let r=0;for(let A=0;A<t.workspaces.length&&r<i.z;A++){const D=this.t(t.workspaces[A]);if(D.scheme===f.Schemas.file){const k=(0,g.$jg)(D);await y.Promises.exists(k)&&(n.push(k),r++)}}const p=[];for(let A=0;A<t.files.length&&r<i.C;A++){const D=this.t(t.files[A]);if(D.scheme===f.Schemas.file){const k=(0,g.$jg)(D);if(i.F.includes((0,g.$sg)(D))||n.includes(k))continue;await y.Promises.exists(k)&&(p.push(k),r++)}}p.reverse().forEach(A=>S.app.addRecentDocument(A)),n.reverse().forEach(A=>S.app.addRecentDocument(A))}};e.$i7b=c,e.$i7b=c=i=Ee([te(0,b.$0i),te(1,E.$H6b),te(2,m.$b6b),te(3,$.$l6b)],c)}),define(ie[304],ne([0,1,15,8,22,46,4,7,181,18,25,20,6,231,69,24,34,26,48,68,30,82]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=void 0;const c="menu";let o=class{static{i=this}static{this.a="lastKnownMenubarData"}constructor(r,p,A,D,k,I,j,N,z,_,Y){this.n=r,this.o=p,this.p=A,this.q=D,this.r=k,this.s=I,this.t=j,this.u=N,this.v=z,this.w=_,this.x=Y,this.m=Object.create(null),this.g=new R.$6g(()=>this.E(),0),this.h=new R.$6g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$k||(0,l.$7C)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const r=this.t.getItem(i.a);r&&(r.menus&&(this.k=r.menus),r.keybindings&&(this.l=r.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(I,j,N)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.newWindow"]=(I,j,N)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.files.openFileFolder"]=(I,j,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:c}}),this.m["workbench.action.files.openFolder"]=(I,j,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:c}}),this.m["workbench.action.openWorkspace"]=(I,j,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:c}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const r=this.x.youTubeUrl;r&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(r,"openYouTubeUrl"));const p=this.x.requestFeatureUrl;p&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(p,"openUserVoiceUrl"));const A=this.x.reportIssueUrl;A&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(A,"openReportIssues"));const D=this.x.licenseUrl;D&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$w){const I=D.indexOf("?")>0?"&":"?";this.Z(`${D}${I}lang=${C.$w}`,"openLicenseUrl")}else this.Z(D,"openLicenseUrl")});const k=this.x.privacyStatementUrl;k&&D&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(k,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(r=>this.F(r)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const r=this.o.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get C(){if(!C.$k)return!1;const r=this.o.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,p){this.k=r.menus,this.l=r.keybindings,this.t.setItem(i.a,r),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(r){C.$k&&(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.d=r.newCount===0,this.D())}G(){C.$k&&(this.f=!S.BrowserWindow.getFocusedWindow(),this.D())}H(){const r=S.Menu.getApplicationMenu();if(r&&this.j.push(r),Object.keys(this.k).length===0){S.Menu.setApplicationMenu(C.$k?new S.Menu:null);return}const p=new S.Menu;let A;if(C.$k){const k=new S.Menu;A=new S.MenuItem({label:this.x.nameShort,submenu:k}),this.I(k),p.append(A)}if(C.$k&&!this.c){this.c=!0;const k=new S.Menu;k.append(new S.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(k)}if(this.K("File")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(1,null)),submenu:k});this.M(k,"File"),p.append(I)}if(this.K("Edit")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(2,null)),submenu:k});this.M(k,"Edit"),p.append(I)}if(this.K("Selection")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(3,null)),submenu:k});this.M(k,"Selection"),p.append(I)}if(this.K("View")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(4,null)),submenu:k});this.M(k,"View"),p.append(I)}if(this.K("Go")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(5,null)),submenu:k});this.M(k,"Go"),p.append(I)}if(this.K("Run")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(6,null)),submenu:k});this.M(k,"Run"),p.append(I)}if(this.K("Terminal")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(7,null)),submenu:k});this.M(k,"Terminal"),p.append(I)}let D;if(this.K("Window")){const k=new S.Menu;D=new S.MenuItem({label:this.ab(f.localize(8,null)),submenu:k,role:"window"}),this.S(k)}if(D&&p.append(D),this.K("Help")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(9,null)),submenu:k,role:"help"});this.M(k,"Help"),p.append(I)}p.items&&p.items.length>0?S.Menu.setApplicationMenu(p):S.Menu.setApplicationMenu(null),this.h.schedule()}I(r){const p=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),A=this.T();let D;if(this.K("Preferences")){const ce=new S.Menu;this.M(ce,"Preferences"),D=new S.MenuItem({label:this.ab(f.localize(11,null)),submenu:ce})}const k=new S.Menu,I=new S.MenuItem({label:f.localize(12,null),role:"services",submenu:k}),j=new S.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new S.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new S.MenuItem({label:f.localize(15,null),role:"unhide"}),_=new S.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ce,re,ae)=>{const Z=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||Z?.isMinimized())&&await this.J(ae)&&this.w.quit(void 0)}})),Y=[p];Y.push(...A),D&&Y.push(t(),D),Y.push(t(),I,t(),j,N,z,t(),_),Y.forEach(ce=>r.append(ce))}async J(r){if(this.p.getWindowCount()===0)return!0;const p=this.o.getValue("window.confirmBeforeClose");if(p==="always"||p==="keyboardOnly"&&this.Q(r)){const{response:A}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return A===0}return!0}K(r){if(!C.$k&&(0,l.$7C)(this.o)==="custom")return!1;switch(r){case"File":case"Help":if(C.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[r];case"Window":if(C.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[r]}}L(r,p){p.forEach(A=>{if((0,d.$e7b)(A))r.append(t());else if((0,d.$d7b)(A)){const D=new S.Menu,k=new S.MenuItem({label:this.ab(A.label),submenu:D});this.L(D,A.submenu.items),r.append(k)}else(0,d.$f7b)(A)?r.append(this.O(A)):(0,d.$g7b)(A)&&(A.id==="workbench.action.showAboutDialog"&&this.N(r),C.$k?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[A.id]?r.append(new S.MenuItem(this.Y(A.id,{label:this.ab(A.label),click:this.m[A.id]}))):r.append(this.U(A.label,A.id,!1,A.checked)):r.append(this.U(A.label,A.id,A.enabled!==!1,!!A.checked)):r.append(this.U(A.label,A.id,A.enabled!==!1,!!A.checked)))})}M(r,p){this.k&&this.k[p]&&this.L(r,this.k[p].items)}N(r){const p=this.T();p.length&&(p.forEach(A=>r.append(A)),r.append(t()))}O(r){const p=P.URI.revive(r.uri),A=r.id,D=A==="openRecentFile"?{fileUri:p}:A==="openRecentWorkspace"?{workspaceUri:p}:{folderUri:p};return new S.MenuItem(this.Y(A,{label:r.label,click:async(k,I,j)=>{const N=this.P(j);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[D],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([p])}},!1))}P(r){return!!(r&&(!C.$k&&(r.ctrlKey||r.shiftKey)||C.$k&&(r.metaKey||r.altKey)))}Q(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}R(r,p,A){const D={label:this.ab(r),role:A,enabled:!0};return new S.MenuItem(this.X(p,D))}S(r){const p=new S.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),A=new S.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),D=new S.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),k=this.U(f.localize(23,null),"workbench.action.switchWindow"),I=[];this.C&&(I.push(t()),I.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),I.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),I.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),I.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),I.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[p,A,t(),k,...I,t(),D].forEach(j=>r.append(j))}T(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(r,p,A,D){const k=this.ab(r),I=typeof p=="function"?p:(Y,ce,re)=>{const ae=Y?Y.userSettingsLabel:null;let Z=p;Array.isArray(p)&&(Z=this.P(re)?p[1]:p[0]),ae&&re.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ae}):this.W({type:"commandId",commandId:Z})},j=typeof A=="boolean"?A:this.p.getWindowCount()>0,N=typeof D=="boolean"?D:!1,z={label:k,click:I,enabled:j};N&&(z.type="checkbox",z.checked=N);let _;return typeof p=="string"?_=p:Array.isArray(p)&&(_=p[0]),C.$k&&(_==="editor.action.clipboardCutAction"?z.role="cut":_==="editor.action.clipboardCopyAction"?z.role="copy":_==="editor.action.clipboardPasteAction"&&(z.role="paste"),_==="undo"?z.click=this.V(I,{inDevTools:Y=>Y.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):_==="redo"?z.click=this.V(I,{inDevTools:Y=>Y.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):_==="editor.action.selectAll"&&(z.click=this.V(I,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.X(_,z))}V(r,p){return(A,D,k)=>{const I=S.BrowserWindow.getFocusedWindow();if(!I)return p.inNoWindow();if(I.webContents.isDevToolsFocused()&&I.webContents.devToolsWebContents)return p.inDevTools(I.webContents.devToolsWebContents);r(A,D||I,k)}}W(r){let p=S.BrowserWindow.getFocusedWindow();if(!p){const D=this.p.getLastActiveWindow();D?.isMinimized()&&(p=D.win)}const A=p?this.p.getWindowById(p.id):void 0;if(A){if(this.v.trace("menubar#runActionInRenderer",r),C.$k&&!this.q.isBuilt&&!A.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const D={id:r.commandId,from:"menu"};A.sendWhenReady("vscode:runAction",s.CancellationToken.None,D)}else{const D={userSettingsLabel:r.userSettingsLabel};A.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,D)}}else this.v.trace("menubar#runActionInRenderer: no active window found",r)}X(r,p){const A=typeof r=="string"?this.l[r]:void 0;if(A?.label){if(A.isNative!==!1)p.accelerator=A.label,p.userSettingsLabel=A.userSettingsLabel;else if(typeof p.label=="string"){const D=p.label.indexOf("[");D>=0?p.label=`${p.label.substr(0,D)} [${A.label}]`:p.label=`${p.label} [${A.label}]`}}else p.accelerator=void 0;return p}Y(r,p,A=!p.accelerator){A&&(p=this.X(r,p));const D=p.click;return p.click=(k,I,j)=>{this.$(r),D?.(k,I,j)},p}Z(r,p){this.w.openExternal(void 0,r),this.$(p)}$(r){this.r.publicLog2("workbenchActionExecuted",{id:r,from:c})}ab(r){return(0,O.$xv)(r,!this.B)}};e.$j7b=o,e.$j7b=o=i=Ee([te(0,u.$jU),te(1,a.$ji),te(2,E.$p6b),te(3,g.$_5b),te(4,$.$cl),te(5,h.$h7b),te(6,b.$wN),te(7,w.$b6b),te(8,y.$0i),te(9,v.$86b),te(10,m.$pj)],o);function t(){return new S.MenuItem({type:"separator"})}}),define(ie[305],ne([0,1,5,20,6,304]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l7b=e.$k7b=void 0,e.$k7b=(0,S.$Ph)("menubarMainService");let C=class{constructor(f,a,g){this.b=f,this.c=a,this.d=g,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(O.$j7b)}async updateMenubar(f,a){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(a,f)}};e.$l7b=C,e.$l7b=C=Ee([te(0,S.$Oh),te(1,R.$b6b),te(2,s.$0i)],C)}),define(ie[306],ne([0,1,15,21,131,28,23,22,3,33,46,2,13,9,65,4,35,19,12,7,191,63,18,59,25,16,5,20,6,78,79,58,34,68,133,130,298,29,98,82,53,67,39,52,66]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h,i,c,o,t,n,r,p,A,D,k,I,j,N,z,_,Y,ce,re,ae,Z,Q,G,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=void 0;function T(x){return(0,Y.$5h)(x?.workspace)}function K(x){return(0,Y.$Zh)(x?.workspace)}let H=class extends w.$Sc{constructor(B,F,M,U,W,L,V,J,oe,le,de,fe,ve,me,ye,Oe,Me,we,pe){super(),this.m=B,this.n=F,this.r=M,this.s=U,this.t=W,this.u=L,this.w=V,this.z=J,this.C=oe,this.D=le,this.F=de,this.G=fe,this.H=ve,this.I=me,this.J=ye,this.L=Oe,this.M=Me,this.N=we,this.O=pe,this.a=this.B(new f.$Nd),this.onDidOpenWindow=this.a.event,this.b=this.B(new f.$Nd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new f.$Nd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new f.$Nd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new f.$Nd),this.onDidTriggerSystemContextMenu=this.g.event,this.h=new Map,this.j=this.B(new _.$I7b(this,this.u,this.D,this.s,this.G)),this.P()}P(){this.B(this.I.onDidEnterWorkspace(B=>this.b.fire(B.window))),this.B(this.onDidSignalReadyWindow(B=>{if(B.config?.extensionDevelopmentPath||B.config?.extensionTestsPath){const F=new w.$Rc;if(F.add(f.Event.any(B.onDidClose,B.onDidDestroy)(()=>F.dispose())),B.config.extensionDevelopmentPath)for(const M of B.config.extensionDevelopmentPath)F.add(this.N.addValidFileRoot(M));B.config.extensionTestsPath&&F.add(this.N.addValidFileRoot(B.config.extensionTestsPath))}}))}openEmptyWindow(B,F){const M=this.z.args,U=F?.remoteAuthority||void 0,W=!0,L=F?.forceReuseWindow,V=!L;return this.open({...B,cli:M,forceEmpty:W,forceNewWindow:V,forceReuseWindow:L,remoteAuthority:U})}openExistingWindow(B,F){B.focus(),this.Q(F,[B])}async open(B){this.s.trace("windowsManager#open"),B.addMode&&(B.initialStartup||!this.getLastActiveWindow())&&(B.addMode=!1);const F=[],M=[],U=[],W=[],L=[];let V,J=0;const oe=await this.Y(B);this.s.trace("windowsManager#open pathsToOpen",oe);for(const me of oe)K(me)?B.addMode?F.push(me):M.push(me):T(me)?U.push(me):me.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:me.remoteAuthority}),V.filesToOpenOrCreate.push(me)):me.backupPath?L.push({backupFolder:(0,d.$nc)(me.backupPath),remoteAuthority:me.remoteAuthority}):J++;B.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),B.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&B.waitMarkerFileURI&&(V.filesToWait={paths:(0,C.$Hb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:B.waitMarkerFileURI}),B.initialStartup?(W.push(...this.I.getUntitledWorkspaces()),U.push(...W),L.push(...this.F.getEmptyWindowBackups())):L.length=0;const{windows:le,filesOpenedInWindow:de}=await this.R(B,U,M,L,J,V,F);if(this.s.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${U.length}, foldersToOpen: ${M.length}, emptyToRestore: ${L.length}, emptyToOpen: ${J})`),le.length>1)if(de)de.focus();else{const me=this.j.state.lastActiveWindow&&!B.forceEmpty&&!B.cli._.length&&!B.cli["file-uri"]&&!B.cli["folder-uri"]&&!(B.urisToOpen&&B.urisToOpen.length);let ye=!0,Oe=!0;if(me){const Me=le.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);Me.length&&(Me[0].focus(),ye=!1,Oe=!1)}if(ye)for(let Me=le.length-1;Me>=0;Me--){const we=le[Me];if(!(we.openedWorkspace&&W.some(pe=>we.openedWorkspace&&pe.workspace.id===we.openedWorkspace.id)||we.backupPath&&L.some(pe=>we.backupPath&&pe.backupFolder===(0,d.$nc)(we.backupPath)))){we.focus(),Oe=!1;break}}Oe&&le[le.length-1].focus()}const fe=V&&V.filesToDiff.length>0,ve=V&&V.filesToMerge.length>0;if(!le.some(me=>me.isExtensionDevelopmentHost)&&!fe&&!ve&&!B.noRecentEntry){const me=[];for(const ye of oe)T(ye)&&!ye.transient?me.push({label:ye.label,workspace:ye.workspace,remoteAuthority:ye.remoteAuthority}):K(ye)?me.push({label:ye.label,folderUri:ye.workspace.uri,remoteAuthority:ye.remoteAuthority}):ye.fileUri&&me.push({label:ye.label,fileUri:ye.fileUri,remoteAuthority:ye.remoteAuthority});this.H.addRecentlyOpened(me)}return this.Q(B,le),le}Q(B,F){const M=B.waitMarkerFileURI;B.context===0&&M&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.M.del(M)}catch{}})()}async R(B,F,M,U,W,L,V){const J=[];let oe;function le(Me,we){J.push(Me),we&&(oe=Me,L=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:fe}=this.jb(B);if(!B.initialStartup&&V.length>0){const Me=V[0].remoteAuthority,we=this.ob(Me);we&&le(this.U(we,V.map(pe=>pe.workspace.uri)))}const ve=M.length+F.length+U.length;if(L&&ve===0){const Me=L.filesToOpenOrCreate[0]||L.filesToDiff[0]||L.filesToMerge[3],we=this.getWindows().filter(se=>L&&(0,$.$Ag)(se.remoteAuthority,L.remoteAuthority));let pe;Me?.fileUri&&!fe&&((B.context===4||B.context===0||B.context===1)&&(pe=await(0,z.$E6b)(we,Me.fileUri,async se=>se.configPath.scheme===y.Schemas.file?this.I.resolveLocalWorkspace(se.configPath):void 0)),pe||(pe=this.pb(we))),pe?(0,Y.$5h)(pe.openedWorkspace)?F.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,Y.$Zh)(pe.openedWorkspace)?M.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):le(this.S(B,pe,L),!0):le(await this.kb({userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,filesToOpen:L,forceNewWindow:!0,remoteAuthority:L.remoteAuthority,forceNewTabbedWindow:B.forceNewTabbedWindow,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile}),!0)}const me=(0,C.$Mb)(F,Me=>Me.workspace.id);if(me.length>0){const Me=(0,C.$Hb)(me.map(we=>(0,z.$F6b)(this.getWindows(),we.workspace.configPath)));if(Me.length>0){const we=Me[0],pe=(0,$.$Ag)(L?.remoteAuthority,we.remoteAuthority)?L:void 0;le(this.S(B,we,pe),!!pe),de=!0}for(const we of me){if(Me.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===we.workspace.id))continue;const pe=we.remoteAuthority,se=(0,$.$Ag)(L?.remoteAuthority,pe)?L:void 0;le(await this.X(B,we,de,se),!!se),de=!0}}const ye=(0,C.$Mb)(M,Me=>$.$mg.getComparisonKey(Me.workspace.uri));if(ye.length>0){const Me=(0,C.$Hb)(ye.map(we=>(0,z.$F6b)(this.getWindows(),we.workspace.uri)));if(Me.length>0){const we=Me[0],pe=(0,$.$Ag)(L?.remoteAuthority,we.remoteAuthority)?L:void 0;le(this.S(B,we,pe),!!pe),de=!0}for(const we of ye){if(Me.some(ue=>(0,Y.$Zh)(ue.openedWorkspace)&&$.$mg.isEqual(ue.openedWorkspace.uri,we.workspace.uri)))continue;const pe=we.remoteAuthority,se=(0,$.$Ag)(L?.remoteAuthority,pe)?L:void 0;le(await this.X(B,we,de,se),!!se),de=!0}}const Oe=(0,C.$Mb)(U,Me=>Me.backupFolder);if(Oe.length>0)for(const Me of Oe){const we=Me.remoteAuthority,pe=(0,$.$Ag)(L?.remoteAuthority,we)?L:void 0;le(await this.W(B,!0,we,pe,Me),!!pe),de=!0}if(J.length===0||L){L&&!W&&W++;const Me=L?L.remoteAuthority:B.remoteAuthority;for(let we=0;we<W;we++)le(await this.W(B,de,Me,L),!!L),de=!0}return{windows:(0,C.$Mb)(J),filesOpenedInWindow:oe}}S(B,F,M){this.s.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:M}),F.focus();const U={filesToOpenOrCreate:M?.filesToOpenOrCreate,filesToDiff:M?.filesToDiff,filesToMerge:M?.filesToMerge,filesToWait:M?.filesToWait,termProgram:B?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",P.CancellationToken.None,U),F}U(B,F){this.s.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),B.focus();const M={foldersToAdd:F};return B.sendWhenReady("vscode:addFolders",P.CancellationToken.None,M),B}W(B,F,M,U,W){this.s.trace("windowsManager#doOpenEmpty",{restore:!!W,remoteAuthority:M,filesToOpen:U,forceNewWindow:F});let L;return!F&&typeof B.contextWindowId=="number"&&(L=this.getWindowById(B.contextWindowId)),this.kb({userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,remoteAuthority:M,forceNewWindow:F,forceNewTabbedWindow:B.forceNewTabbedWindow,filesToOpen:U,windowToUse:L,emptyWindowBackupInfo:W,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}X(B,F,M,U,W){return this.s.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:U}),!M&&!W&&typeof B.contextWindowId=="number"&&(W=this.getWindowById(B.contextWindowId)),this.kb({workspace:F.workspace,userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:M,forceNewTabbedWindow:B.forceNewTabbedWindow,filesToOpen:U,windowToUse:W,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async Y(B){let F,M=!1,U=!1;if(B.urisToOpen&&B.urisToOpen.length>0?(F=await this.Z(B),M=!0):B.forceEmpty?F=[Object.create(null)]:B.cli._.length||B.cli["folder-uri"]||B.cli["file-uri"]?(F=await this.$(B.cli),F.length===0&&F.push(Object.create(null)),M=!0):(F=await this.bb(),F.length===0&&F.push(Object.create(null)),U=!0),!B.addMode&&M){const W=F.filter(L=>K(L));if(W.length>1){const L=W[0].remoteAuthority;if(W.every(V=>(0,$.$Ag)(V.remoteAuthority,L))){const V=await this.I.createUntitledWorkspace(W.map(J=>({uri:J.workspace.uri})));F.push({workspace:V,remoteAuthority:L}),F=F.filter(J=>!K(J))}}}if(B.initialStartup&&!U&&this.G.getValue("window")?.restoreWindows==="preserve"){const W=await this.bb();F.unshift(...W.filter(L=>T(L)||K(L)||L.backupPath))}return F}async Z(B){const F={gotoLineMode:B.gotoLineMode,remoteAuthority:B.remoteAuthority},M=await Promise.all((0,C.$Hb)(B.urisToOpen||[]).map(async U=>{const W=await this.db(U,F);if(W)return W.label=U.label,W;const L=this.fb(U);this.L.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:L.scheme===y.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:L.scheme===y.Schemas.file?(0,E.localize)(3,null,(0,g.$rv)(L,{os:m.OS,tildify:this.z})):(0,E.localize)(4,null,L.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Hb)(M)}async $(B){const F=[],M={ignoreFileNotFound:!0,gotoLineMode:B.goto,remoteAuthority:B.remote||void 0,forceOpenWorkspaceAsFile:B.diff&&B._.length===2||B.merge&&B._.length===4},U=B["folder-uri"];if(U){const V=await Promise.all(U.map(J=>{const oe=this.ab(J);if(oe)return this.db({folderUri:oe},M)}));F.push(...(0,C.$Hb)(V))}const W=B["file-uri"];if(W){const V=await Promise.all(W.map(J=>{const oe=this.ab(J);if(oe)return this.db((0,Y.$ii)(J)?{workspaceUri:oe}:{fileUri:oe},M)}));F.push(...(0,C.$Hb)(V))}const L=await Promise.all(B._.map(V=>M.remoteAuthority?this.ib(V,M):this.gb(V,M)));return F.push(...(0,C.$Hb)(L)),F}ab(B){try{const F=l.URI.parse(B);if(!F.scheme){this.s.error(`Invalid URI input string, scheme missing: ${B}`);return}return F.path?F:F.with({path:"/"})}catch(F){this.s.error(`Invalid URI input string: ${B}, ${F.message}`)}}async bb(){const B=this.cb();switch(B){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];B!=="one"&&F.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&F.push(this.j.state.lastActiveWindow);const M=await Promise.all(F.map(async U=>{if(U.workspace){const W=await this.db({workspaceUri:U.workspace.configPath},{remoteAuthority:U.remoteAuthority,rejectTransientWorkspaces:!0});if(T(W))return W}else if(U.folderUri){const W=await this.db({folderUri:U.folderUri},{remoteAuthority:U.remoteAuthority});if(K(W))return W}else if(B!=="folders"&&U.backupPath)return{backupPath:U.backupPath,remoteAuthority:U.remoteAuthority}}));return(0,C.$Hb)(M)}}}cb(){let B;return this.D.wasRestarted?B="all":(B=this.G.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(B)||(B="all")),B}async db(B,F=Object.create(null)){const M=this.fb(B);return M.scheme===y.Schemas.file?((0,j.$5C)(B)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.gb(M.fsPath,F)):this.eb(B,F)}eb(B,F){let M=this.fb(B);const U=(0,k.$Uk)(M)||F.remoteAuthority;if(M=(0,$.$Cg)((0,$.$wg)(M)),(0,j.$5C)(B)){if(F.gotoLineMode){const{path:W,line:L,column:V}=(0,a.$5f)(M.path);return{fileUri:M.with({path:W}),options:{selection:L?{startLineNumber:L,startColumn:V||1}:void 0},remoteAuthority:U}}return{fileUri:M,remoteAuthority:U}}else if((0,j.$3C)(B))return{workspace:(0,ce.$x6b)(M),remoteAuthority:U};return{workspace:(0,ce.$y6b)(M),remoteAuthority:U}}fb(B){return(0,j.$3C)(B)?B.workspaceUri:(0,j.$4C)(B)?B.folderUri:B.fileUri}async gb(B,F,M){let U,W;F.gotoLineMode&&({path:B,line:U,column:W}=(0,a.$5f)(B)),B=(0,a.$Zf)((0,d.$hc)(B),(0,b.cwd)());try{const L=await R.Promises.stat(B);if(L.isFile()){if(!F.forceOpenWorkspaceAsFile){const V=await this.I.resolveLocalWorkspace(l.URI.file(B));if(V)return V.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:t.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:l.URI.file(B),type:t.FileType.File,exists:!0,options:{selection:U?{startLineNumber:U,startColumn:W||1}:void 0}}}else{if(L.isDirectory())return{workspace:(0,ce.$y6b)(l.URI.file(B),L),type:t.FileType.Directory,exists:!0};if(!m.$j&&B==="/dev/null")return{fileUri:l.URI.file(B),type:t.FileType.File,exists:!0}}}catch(L){if(L.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!M)return this.hb(B,F);const V=l.URI.file(B);if(this.H.removeRecentlyOpened([V]),F.ignoreFileNotFound)return{fileUri:V,type:t.FileType.File,exists:!1}}}async hb(B,F){const M=l.URI.file(B),{response:U,checkboxChecked:W}=await this.L.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,M.authority),detail:(0,E.localize)(9,null,(0,g.$rv)(M,{os:m.OS,tildify:this.z})),checkboxLabel:(0,E.localize)(10,null,M.authority),cancelId:1});if(U===0){if((0,s.addUNCHostToAllowlist)(M.authority),W){const L={channel:"vscode:configureAllowedUNCHost",args:M.authority};this.sendToFocused(L.channel,L.args),this.sendToOpeningWindow(L.channel,L.args)}return this.gb(B,F,!0)}if(U===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.hb(B,F)}ib(B,F){const M=B.charCodeAt(0),U=F.remoteAuthority;let W,L;F.gotoLineMode&&({path:B,line:W,column:L}=(0,a.$5f)(B)),M!==47&&((0,a.$Yf)(M)&&B.charCodeAt(B.charCodeAt(1))===58&&(B=(0,a.$Rf)(B)),B=`/${B}`);const V=l.URI.from({scheme:y.Schemas.vscodeRemote,authority:U,path:B});if(B.charCodeAt(B.length-1)!==47){if((0,Y.$ii)(B))return F.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:W?{startLineNumber:W,startColumn:L||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,ce.$x6b)(V),remoteAuthority:U};if(F.gotoLineMode||d.$gc.basename(B).indexOf(".")!==-1)return{fileUri:V,options:{selection:W?{startLineNumber:W,startColumn:L||1}:void 0},remoteAuthority:U}}return{workspace:(0,ce.$y6b)(V),remoteAuthority:U}}jb(B){const F=this.G.getValue("window"),M=F?.openFoldersInNewWindow||"default",U=F?.openFilesInNewWindow||"off";let W=(B.preferNewWindow||B.forceNewWindow)&&!B.forceReuseWindow;!B.forceNewWindow&&!B.forceReuseWindow&&(M==="on"||M==="off")&&(W=M==="on");let L=!1;return B.forceNewWindow||B.forceReuseWindow?L=!!B.forceNewWindow&&!B.forceReuseWindow:(m.$k?B.context===1&&(L=!0):B.context!==3&&B.context!==2&&!(B.userEnv&&B.userEnv.TERM_PROGRAM==="vscode")&&(L=!0),!B.cli.extensionDevelopmentPath&&(U==="on"||U==="off")&&(L=U==="on")),{openFolderInNewWindow:!!W,openFilesInNewWindow:L}}async openExtensionDevelopmentHostWindow(B,F){const M=(0,z.$G6b)(this.getWindows(),B);if(M)return this.D.reload(M,F.cli),M.focus(),[M];let U=F.cli["folder-uri"]||[],W=F.cli["file-uri"]||[],L=F.cli._;if(!L.length&&!U.length&&!W.length&&!F.cli.extensionTestsPath){const oe=this.j.state.lastPluginDevelopmentHostWindow,le=oe?.workspace??oe?.folderUri;le&&(l.URI.isUri(le)?le.scheme===y.Schemas.file?L=[le.fsPath]:U=[le.toString()]:le.configPath.scheme===y.Schemas.file?L=[(0,$.$jg)(le.configPath)]:W=[le.configPath.toString()])}let V=F.remoteAuthority;for(const oe of B)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=l.URI.parse(oe),de=(0,k.$Uk)(le);de&&(V?(0,$.$Ag)(de,V)||this.s.error("more than one extension development path authority"):V=de)}L=L.filter(oe=>{const le=l.URI.file(oe);return(0,z.$F6b)(this.getWindows(),le)?!1:(0,$.$Ag)((0,k.$Uk)(le),V)}),U=U.filter(oe=>{const le=this.ab(oe);return le&&(0,z.$F6b)(this.getWindows(),le)?!1:le?(0,$.$Ag)((0,k.$Uk)(le),V):!1}),W=W.filter(oe=>{const le=this.ab(oe);return le&&(0,z.$F6b)(this.getWindows(),le)?!1:le?(0,$.$Ag)((0,k.$Uk)(le),V):!1}),F.cli._=L,F.cli["folder-uri"]=U,F.cli["file-uri"]=W;const J={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!L.length&&!U.length&&!W.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:V,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(J)}async kb(B){const F=this.G.getValue("window"),M=this.getLastActiveWindow(),U=M?.profile??this.C.defaultProfile;let W;!B.forceNewWindow&&!B.forceNewTabbedWindow&&(W=B.windowToUse||M,W&&W.focus());const L={...this.z.args,...B.cli,machineId:this.m,sqmId:this.n,windowId:-1,mainPid:process.pid,appRoot:this.z.appRoot,execPath:process.execPath,codeCachePath:this.z.codeCachePath,backupPath:B.emptyWindowBackupInfo?(0,d.$jc)(this.z.backupHome,B.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.C.profilesHome,all:this.C.profiles,profile:U},homeDir:this.z.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.z.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.z.userDataPath,remoteAuthority:B.remoteAuthority,workspace:B.workspace,userEnv:{...this.r,...B.userEnv},filesToOpenOrCreate:B.filesToOpen?.filesToOpenOrCreate,filesToDiff:B.filesToOpen?.filesToDiff,filesToMerge:B.filesToOpen?.filesToMerge,filesToWait:B.filesToOpen?.filesToWait,logLevel:this.t.getLogLevel(),loggers:{window:[],global:this.t.getRegisteredLoggers()},logsPath:this.z.logsHome.with({scheme:y.Schemas.file}).fsPath,product:A.default,isInitialStartup:B.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)(),arch:(0,O.arch)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.O.getColorScheme(),policiesData:this.w.serialize(),continueOn:this.z.continueOn};if(W){const V=W.config;!L.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(L.extensionDevelopmentPath=V.extensionDevelopmentPath,L.extensionDevelopmentKind=V.extensionDevelopmentKind,L["enable-proposed-api"]=V["enable-proposed-api"],L.verbose=V.verbose,L["inspect-extensions"]=V["inspect-extensions"],L["inspect-brk-extensions"]=V["inspect-brk-extensions"],L.debugId=V.debugId,L.extensionEnvironment=V.extensionEnvironment,L["extensions-dir"]=V["extensions-dir"],L["disable-extensions"]=V["disable-extensions"]),L.loggers={global:L.loggers.global,window:V?.loggers.window??L.loggers.window}}else{const V=this.j.getNewWindowState(L);(0,v.mark)("code/willCreateCodeWindow");const J=W=this.J.createInstance(N.$56b,{state:V,extensionDevelopmentPath:L.extensionDevelopmentPath,isExtensionTestHost:!!L.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),B.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(J),this.h.set(J.id,J),this.a.fire(J),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const oe=new w.$Rc;oe.add(J.onDidSignalReady(()=>this.b.fire(J))),oe.add(f.Event.once(J.onDidClose)(()=>this.nb(J,oe))),oe.add(f.Event.once(J.onDidDestroy)(()=>this.c.fire(J))),oe.add(J.onDidTriggerSystemContextMenu(({x:de,y:fe})=>this.g.fire({window:J,x:de,y:fe})));const le=(0,u.$Jf)(J.win?.webContents);le.removeAllListeners("devtools-reload-page"),le.on("devtools-reload-page",()=>this.D.reload(J)),this.D.registerWindow(J)}return L.windowId=W.id,W.isReady?this.D.unload(W,4).then(async V=>{V||await this.lb(W,L,B,U)}):await this.lb(W,L,B,U),W}async lb(B,F,M,U){if(F.extensionDevelopmentPath||((0,Y.$5h)(F.workspace)?F.backupPath=this.F.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,Y.$Zh)(F.workspace)?F.backupPath=this.F.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.F.registerEmptyWindowBackup({backupFolder:M.emptyWindowBackupInfo?.backupFolder??(0,ce.$z6b)().id,remoteAuthority:F.remoteAuthority})),this.C.isEnabled()){const W=F.workspace??(0,Y.$4h)(F.backupPath,!1),L=this.mb(M,W,U),V=L instanceof Promise?await L:L;F.profiles.profile=V,F.extensionDevelopmentPath||await this.C.setProfileForWorkspace(W,V)}B.load(F)}mb(B,F,M){return B.forceProfile?this.C.profiles.find(U=>U.name===B.forceProfile)??this.C.createNamedProfile(B.forceProfile):B.forceTempProfile?this.C.createTransientProfile():this.C.getProfileForWorkspace(F)??M}nb(B,F){this.h.delete(B.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),F.dispose()}getFocusedWindow(){const B=S.BrowserWindow.getFocusedWindow();if(B)return this.getWindowById(B.id)}getLastActiveWindow(){return this.pb(this.getWindows())}ob(B){return this.pb(this.getWindows().filter(F=>(0,$.$Ag)(F.remoteAuthority,B)))}pb(B){const F=Math.max.apply(Math,B.map(M=>M.lastFocusTime));return B.find(M=>M.lastFocusTime===F)}sendToFocused(B,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(B,P.CancellationToken.None,...F)}sendToOpeningWindow(B,...F){this.B(f.Event.once(this.onDidSignalReadyWindow)(M=>{M.sendWhenReady(B,P.CancellationToken.None,...F)}))}sendToAll(B,F,M){for(const U of this.getWindows())M&&M.indexOf(U.id)>=0||U.sendWhenReady(B,P.CancellationToken.None,F)}getWindows(){return Array.from(this.h.values())}getWindowCount(){return this.h.size}getWindowById(B){return this.h.get(B)}getWindowByWebContents(B){const F=S.BrowserWindow.fromWebContents(B);if(F)return this.getWindowById(F.id)}};e.$L7b=H,e.$L7b=H=Ee([te(3,p.$0i),te(4,q.$26b),te(5,I.$wN),te(6,Q.$in),te(7,o.$_5b),te(8,G.$h6b),te(9,r.$b6b),te(10,h.$v6b),te(11,i.$ji),te(12,re.$h7b),te(13,ae.$H6b),te(14,n.$Oh),te(15,c.$C6b),te(16,t.$$j),te(17,D.$16b),te(18,Z.$n6b)],H)}),define(ie[307],ne([0,1,63,30,82,53]),function(X,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N7b=void 0;let C=class{constructor(f,a,g,w){this.a=f,this.b=a,this.c=g,this.d=w,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,a){const g=this.b.getWindowById(f);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),a)}createUntitledWorkspace(f,a,g){return this.a.createUntitledWorkspace(a,g)}deleteUntitledWorkspace(f,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(f,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(f,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$N7b=C,e.$N7b=C=Ee([te(0,O.$H6b),te(1,R.$p6b),te(2,s.$h7b),te(3,S.$v6b)],C)}),define(ie[308],ne([0,1,15,131,38,28,17,49,14,33,3,44,46,2,13,9,4,12,7,32,158,42,159,110,290,162,63,283,18,200,90,132,59,117,220,25,62,93,209,293,211,212,213,16,224,92,77,5,91,219,299,284,291,20,6,305,69,24,58,294,94,34,275,81,123,26,251,253,51,48,265,288,300,289,301,128,267,268,269,272,297,30,306,274,29,97,82,307,53,39,233,52,244,50,80,129,277,292,280,8,255,276,228,66,296,271,23,126,295,263,239,71,114,303]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h,i,c,o,t,n,r,p,A,D,k,I,j,N,z,_,Y,ce,re,ae,Z,Q,G,q,T,K,H,x,B,F,M,U,W,L,V,J,oe,le,de,fe,ve,me,ye,Oe,Me,we,pe,se,ue,ge,Ie,De,Ne,Re,qe,ze,ee,he,$e,ke,Ae,We,Le,Ue,He,Ve,Ge,xe,Ye,it,nt,wt,bt,pt,yt,vt,kt,Et,rt,ht,St,Pt,It,ot,At,ft,at,Dt,Ct,ct,Rt,dt,Ot){"use strict";var lt;Object.defineProperty(e,"__esModule",{value:!0}),e.$77b=void 0;let ut=class extends d.$Sc{static{lt=this}static{this.a={[v.Schemas.file]:"security.promptForLocalFileProtocolHandling",[v.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Se,Pe,Ce,be,je,Fe,Be,Xe,Ze,Te,Ke,Je){super(),this.g=Se,this.h=Pe,this.j=Ce,this.m=be,this.n=je,this.s=Fe,this.t=Be,this.u=Xe,this.w=Ze,this.y=Te,this.z=Ke,this.C=Je,this.D(),this.F()}D(){const Se=Te=>Te?.startsWith(`${v.Schemas.vscodeWebview}://`),Pe=new Set(this.z.quality==="stable"?[]:["media"]),Ce=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Te,Ke,Je,Qe)=>Se(Qe.requestingUrl)?Je(Ce.has(Ke)):Qe.isMainFrame&&Qe.securityOrigin===`${v.Schemas.vscodeFileResource}://${v.$bg}/`?Je(Pe.has(Ke)):Je(!1)),S.session.defaultSession.setPermissionCheckHandler((Te,Ke,Je,Qe)=>Se(Qe.requestingUrl)?Ce.has(Ke):Qe.isMainFrame&&Qe.securityOrigin===`${v.Schemas.vscodeFileResource}://${v.$bg}/`?Pe.has(Ke):!1);const be=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),je=Te=>{for(let Ke=Te;Ke;Ke=Ke.parent)if(Ke.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Te=>Te.resourceType==="xhr"||je(Te.frame),Be=Te=>{const Ke=Te.frame;if(!Ke||!this.b)return!1;const Je=S.BrowserWindow.getAllWindows();for(const Qe of Je)if(Ke.processId===Qe.webContents.mainFrame.processId)return!0;return!1},Xe=(Te,Ke)=>{if(Te.path!=="/index.html")return!0;const Je=Ke.frame;if(!Je||!this.b)return!1;for(const Qe of this.b.getWindows())if(Qe.win&&Je.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Te,Ke)=>{const Je=u.URI.parse(Te.url);return Je.scheme===v.Schemas.vscodeWebview&&!Xe(Je,Te)?(this.m.error("Blocked vscode-webview request",Te.url),Ke({cancel:!0})):Je.scheme===v.Schemas.vscodeFileResource&&!Be(Te)?(this.m.error("Blocked vscode-file request",Te.url),Ke({cancel:!0})):Je.path.endsWith(".svg")&&!be.has(Je.scheme)?Ke({cancel:!Fe(Te)}):Ke({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Te,Ke)=>{const Je=Te.responseHeaders,Qe=Je["content-type"]||Je["Content-Type"];if(Qe&&Array.isArray(Qe)){const _e=u.URI.parse(Te.url);if(_e.path.endsWith(".svg")&&be.has(_e.scheme))return Je["Content-Type"]=["image/svg+xml"],Ke({cancel:!1,responseHeaders:Je});if(!_e.path.endsWith(v.Schemas.vscodeRemoteResource)&&Qe.some(et=>et.toLowerCase().includes("image/svg")))return Ke({cancel:!Fe(Te)})}return Ke({cancel:!1})});const Ze=S.session.defaultSession;typeof Ze.setCodeCachePath=="function"&&this.s.codeCachePath&&Ze.setCodeCachePath((0,m.$jc)(this.s.codeCachePath,"chrome")),b.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,f.setUnexpectedErrorHandler)(Ce=>this.H(Ce)),process.on("uncaughtException",Ce=>{(0,f.$Z)(Ce)||(0,f.$1)(Ce)}),process.on("unhandledRejection",Ce=>(0,f.$1)(Ce)),this.t.onWillShutdown(()=>this.dispose()),(0,E.$kT)(),S.app.on("accessibility-support-changed",(Ce,be)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",be)}),S.app.on("activate",async(Ce,be)=>{this.m.trace("app#activate"),be||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Ce,be)=>{be?.opener?.url.startsWith(`${v.Schemas.vscodeFileResource}://${v.$bg}/`)&&this.c?.registerWindow(be),be.on("will-navigate",Fe=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),be.setWindowOpenHandler(Fe=>Fe.url==="about:blank"?(this.m.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Fe.url}}`),this.f?.openExternal(void 0,Fe.url),{action:"deny"}))});let Se=[],Pe;S.app.on("open-file",(Ce,be)=>{this.m.trace("app#open-file: ",be),Ce.preventDefault(),Se.push((0,Ue.$ii)(be)?{workspaceUri:u.URI.file(be)}:{fileUri:u.URI.file(be)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Se,gotoLineMode:!1,preferNewWindow:!0}),Se=[],Pe=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$jT.handle("vscode:getWindowId",Ce=>Promise.resolve(Ce.sender.id)),s.$jT.handle("vscode:fetchShellEnv",Ce=>{const be=this.b?.getWindowByWebContents(Ce.sender);let je,Fe;return be?.config?(je=be.config,Fe={...process.env,...be.config.userEnv}):(je=this.s.args,Fe=process.env),this.X(je,Fe,!1)}),s.$jT.handle("vscode:writeNlsFile",(Ce,be,je)=>{const Fe=this.G([be]);if(!Fe||typeof je!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Fe,C.$be.fromString(je))}),s.$jT.handle("vscode:readNlsFile",async(Ce,...be)=>{const je=this.G(be);if(!je)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(je)).value.toString()}),s.$jT.on("vscode:toggleDevTools",Ce=>Ce.sender.toggleDevTools()),s.$jT.on("vscode:openDevTools",Ce=>Ce.sender.openDevTools()),s.$jT.on("vscode:reloadWindow",Ce=>Ce.sender.reload())}G(Se){let Pe;for(const Ce of Se)typeof Ce=="string"&&(typeof Pe!="string"?Pe=Ce:Pe=(0,m.$jc)(Pe,Ce));if(!(typeof Pe!="string"||!(0,m.$ic)(Pe)||!(0,a.$Xf)(Pe,this.s.cachedLanguagesPath,!b.$l)))return u.URI.file(Pe)}H(Se){if(Se){const Pe={message:`[uncaught exception in main]: ${Se.message}`,stack:Se.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.m.error(`[uncaught exception in main]: ${Se}`),Se.stack&&this.m.error(Se.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Se=this.z.win32AppUserModelId;b.$j&&Se&&S.app.setAppUserModelId(Se);try{b.$k&&this.u.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.m.error(Te)}const Pe=new i.$qT;this.t.onWillShutdown(Te=>{Te.reason===2&&Pe.dispose()}),this.m.trace("Resolving machine identifier...");const[Ce,be]=await Promise.all([(0,ht.$V7b)(this.w,this.m),(0,ht.$W7b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ce}`);const{sharedProcessReady:je,sharedProcessClient:Fe}=this.P(Ce,be),Be=await this.Q(Ce,be,je);this.B(Be.createInstance(o.$r6b)),this.B(Be.createInstance(kt.$R7b)),Be.invokeFunction(Te=>this.R(Te,Pe,Fe));const Xe=await Be.invokeFunction(Te=>this.I(Te,Pe));this.J(Pe),this.t.phase=2,await Be.invokeFunction(Te=>this.S(Te,Xe)),this.t.phase=3,this.U(),this.B(new rt.$6g(()=>{this.B((0,rt.$0g)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Se,Pe){const Ce=this.b=Se.get(Ae.$p6b),be=Se.get(qe.$0T),je=this.f=Se.get(J.$86b),Fe=Se.get(I.$C6b),Be=this;be.registerHandler({async handleURL(Qe,_e){return Be.O(Ce,Fe,be,Qe,_e)}});const Xe=this.B(new Le.$M7b({onDidOpenWindow:je.onDidOpenWindow,onDidFocusWindow:je.onDidFocusWindow,getActiveWindowId:()=>je.getActiveWindowId(-1)})),Ze=new h.$xh(Qe=>Xe.getActiveClientId().then(_e=>Qe===_e)),Te=new ze.$D7b(Ze,this.m),Ke=Pe.getChannel("urlHandler",Te);be.registerHandler(new ze.$C7b(Ke));const Je=await this.L(Ce,Fe);return this.B(new he.$E7b(Je?.urls,be,Ce,this.s,this.z,this.m)),Je}J(Se){const Pe=()=>({statusCode:404,data:"Not found"}),Ce=new Rt.$V(()=>Se.getChannel(ct.$47b,new ct.$57b));S.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(be,je)=>{const Fe=u.URI.parse(be.url);if(!Fe.authority.startsWith("window:"))return je(Pe());Ce.value.call(ct.$37b,[Fe]).then(Be=>je({...Be,data:Buffer.from(Be.body,"base64")}),Be=>{this.m.warn("error dispatching remote resource call",Be),je({statusCode:500,data:String(Be)})})})}async L(Se,Pe){const Ce=this.s.args["open-url"]?this.s.args._urls||[]:[];Ce.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ce);const be=global.getOpenUrls()||[];if(be.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",be),Ce.length+be.length===0)return;const je=[...Ce,...be].map(Xe=>{try{return{uri:u.URI.parse(Xe),originalUrl:Xe}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Xe);return}}),Fe=[],Be=[];for(const Xe of je){if(!Xe)continue;if(await this.M(Xe.uri,Se,Pe)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Xe.uri.toString(!0));continue}const Ze=this.N(Xe.uri);Ze?(this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Xe.uri.toString(!0),Ze),Fe.push(Ze)):(this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Xe.uri.toString(!0)),Be.push(Xe))}return{urls:Be,openables:Fe}}async M(Se,Pe,Ce){if(Se.authority!==v.Schemas.file&&Se.authority!==v.Schemas.vscodeRemote||this.u.getValue(lt.a[Se.authority])===!1)return!1;const{response:je,checkboxChecked:Fe}=await Ce.showMessageBox({type:"warning",buttons:[(0,t.localize)(0,null),(0,t.localize)(1,null)],message:(0,t.localize)(2,null,Se.authority===v.Schemas.file?(0,y.$rv)(Se,{os:b.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort),detail:(0,t.localize)(3,null),checkboxLabel:(0,t.localize)(4,null),cancelId:1});if(je!==0)return!0;if(Fe){const Be={channel:"vscode:disablePromptForProtocolHandling",args:Se.authority===v.Schemas.file?"local":"remote"};Pe.sendToFocused(Be.channel,Be.args),Pe.sendToOpeningWindow(Be.channel,Be.args)}return!1}N(Se){if(Se.path){if(Se.authority===v.Schemas.file){const Pe=u.URI.file(Se.fsPath);return(0,Ue.$ii)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Se.authority===v.Schemas.vscodeRemote){const Pe=Se.path.indexOf(m.$gc.sep,1);if(Pe!==-1){const Ce=Se.path.substring(1,Pe),be=Se.path.substring(Pe);let je=Se.query;const Fe=new URLSearchParams(Se.query);Fe.get("windowId")==="_blank"&&(Fe.delete("windowId"),je=Fe.toString());const Be=u.URI.from({scheme:v.Schemas.vscodeRemote,authority:Ce,path:be,query:je,fragment:Se.fragment});return(0,Ue.$ii)(be)?{workspaceUri:Be}:/:[\d]+$/.test(be)?{fileUri:Be}:{folderUri:Be}}}}}async O(Se,Pe,Ce,be,je){if(this.m.trace("app#handleProtocolUrl():",be.toString(!0),je),be.scheme===this.z.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:u.URI.parse(be.query).path,query:""})),await this.M(be,Se,Pe))return this.m.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0;let Fe=!1;const Be=new URLSearchParams(be.query);Be.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),Be.delete("windowId"),be=be.with({query:Be.toString()}),Fe=!0):b.$k&&Se.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),Fe=!0);const Xe=Be.get("continueOn");Xe!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),Be.delete("continueOn"),be=be.with({query:Be.toString()}),this.s.continueOn=Xe??void 0);const Ze=this.N(be);return Ze?(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ze,be.toString(!0)),(0,ft.$Ob)(await Se.open({context:5,cli:{...this.s.args},urisToOpen:[Ze],forceNewWindow:Fe,gotoLineMode:!0}))?.focus(),!0):Fe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,ft.$Ob)(await Se.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,le.$Uk)(be)}))?.ready(),Ce.open(be,je)):(this.m.trace("app#handleProtocolUrl(): not handled",be.toString(!0),je),!1)}P(Se,Pe){const Ce=this.B(this.j.createInstance(de.$p7b,Se,Pe)),be=(async()=>{this.m.trace("Main->SharedProcess#connect");const Fe=await Ce.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new c.$rT(Fe,"main")})();return{sharedProcessReady:(async()=>(await Ce.whenReady(),be))(),sharedProcessClient:be}}async Q(Se,Pe,Ce){const be=new x.$Nh;switch(process.platform){case"win32":be.set(ue.$jU,new K.$Mh(Re.$A7b));break;case"linux":b.$m?be.set(ue.$jU,new K.$Mh(Ne.$z7b,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(ue.$jU,new K.$Mh(De.$y7b));break;case"darwin":be.set(ue.$jU,new K.$Mh(Ie.$x7b));break}be.set(Ae.$p6b,new K.$Mh(We.$L7b,[Se,Pe,this.h],!1)),be.set(dt.$76b,new K.$Mh(Ot.$67b,void 0,!1));const je=new I.$D6b(this.m,this.z);be.set(I.$C6b,je),be.set(U.$b7b,new K.$Mh(U.$c7b,void 0,!1)),be.set(k.$M6b,new K.$Mh(k.$N6b,void 0,!1)),be.set(D.$qm,h.ProxyChannel.toService((0,h.$vh)(Ce.then(Te=>Te.getChannel("diagnostics"))))),be.set(B.$5wb,new K.$Mh(F.$06b,[this.h])),be.set(j.$4T,new K.$Mh(N.$O6b)),be.set(M.$$6b,new K.$Mh(M.$_6b)),be.set(J.$86b,new K.$Mh(J.$96b,void 0,!1)),be.set($e.$F7b,new K.$Mh(ke.$H7b)),be.set(V.$k7b,new K.$Mh(V.$l7b)),be.set(ce.$P6b,new K.$Mh(re.$R6b)),be.set(ye.$j6b,new K.$Mh(ye.$k6b)),be.set(ye.$l6b,new K.$Mh(ye.$m6b));const Fe=new Dt.$27b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Be=new Ct.$wr(Fe,this.u,this.m,this.n);be.set(at.$0q,Be),b.$j?be.set(ae.$S6b,new K.$Mh(Z.$T6b)):b.$k?be.set(ae.$S6b,new K.$Mh(Z.$U6b)):b.$l&&be.set(ae.$S6b,new K.$Mh(Z.$V6b));const Xe=new r.$A6b(this.s,this.u,this.m,this.w);be.set(n.$v6b,Xe);const Ze=new xe.$I6b(this.s,this.m,this.C,Xe,je);if(be.set(xe.$H6b,Ze),be.set(He.$GU,new K.$Mh(Ge.$N7b,void 0,!1)),be.set(Ve.$h7b,new K.$Mh(Ve.$i7b,void 0,!1)),be.set(qe.$0T,new K.$Mh(ee.$_T,void 0,!1)),(0,se.$so)(this.z,this.s)){const Te=(0,se.$xo)(this.z,this.u),Ke=(0,h.$vh)(Ce.then(st=>st.getChannel("telemetryAppender"))),Je=new we.$s7b(Ke),Qe=(0,Oe.$io)((0,O.release)(),(0,O.hostname)(),process.arch,this.z.commit,this.z.version,Se,Pe,Te),_e=(0,se.$yo)(this.s),et={appenders:[Je],commonProperties:Qe,piiPaths:_e,sendErrorTelemetry:!0};be.set(Me.$cl,new K.$Mh(pe.$2q,[et],!1))}else be.set(Me.$cl,se.$mo);return be.set(pt.$vp,new K.$Mh(St.$DN,void 0,!0)),be.set(yt.$zp,new K.$Mh(vt.$Q7b,void 0,!0)),be.set(ot.$Z7b,new K.$Mh(ot.$17b,void 0,!0)),await rt.Promises.settled([Xe.initialize(),Ze.initialize()]),this.j.createChild(be)}R(Se,Pe,Ce){const be=this.B(new d.$Rc),je=h.ProxyChannel.fromService(Se.get(U.$b7b),be,{disableMarshalling:!0});this.g.registerChannel("launch",je);const Fe=h.ProxyChannel.fromService(Se.get(k.$M6b),be,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Fe);const Be=new it.$O7b(Se.get(Ye.$in));Pe.registerChannel("policy",Be),Ce.then(tt=>tt.registerChannel("policy",Be));const Xe=this.y.getProvider(v.Schemas.file);(0,$.$If)(Xe instanceof T.$bq);const Ze=new q.$W6b(Xe,this.m,this.s);Pe.registerChannel(Q.$mN,Ze),Ce.then(tt=>tt.registerChannel(Q.$mN,Ze));const Te=h.ProxyChannel.fromService(Se.get(nt.$h6b),be);Pe.registerChannel("userDataProfiles",Te),Ce.then(tt=>tt.registerChannel("userDataProfiles",Te));const Ke=new wt.$Wq(Se.get(bt.$To));Ce.then(tt=>tt.registerChannel("request",Ke));const Je=new ge.$t7b(Se.get(ue.$jU));Pe.registerChannel("update",Je);const Qe=h.ProxyChannel.fromService(Se.get(B.$5wb),be);Pe.registerChannel("issue",Qe);const _e=h.ProxyChannel.fromService(Se.get(j.$4T),be);Pe.registerChannel("encryption",_e);const et=h.ProxyChannel.fromService(Se.get(fe.$3k),be);Pe.registerChannel("sign",et);const st=h.ProxyChannel.fromService(Se.get(M.$$6b),be);Pe.registerChannel("keyboardLayout",st),this.f=Se.get(J.$86b);const gt=h.ProxyChannel.fromService(this.f,be);Pe.registerChannel("nativeHost",gt),Ce.then(tt=>tt.registerChannel("nativeHost",gt));const Mt=h.ProxyChannel.fromService(Se.get(He.$GU),be);Pe.registerChannel("workspaces",Mt);const jt=h.ProxyChannel.fromService(Se.get(V.$k7b),be);Pe.registerChannel("menubar",jt);const Lt=h.ProxyChannel.fromService(Se.get(qe.$0T),be);Pe.registerChannel("url",Lt);const Nt=h.ProxyChannel.fromService(Se.get($e.$F7b),be);Pe.registerChannel("webview",Nt);const $t=this.B(new me.$q7b(this.m,Se.get(ye.$j6b)));Pe.registerChannel("storage",$t),Ce.then(tt=>tt.registerChannel("storage",$t));const Ut=this.B(new Et.$S7b(Se.get(ye.$j6b),Se.get(nt.$h6b),this.m));Ce.then(tt=>tt.registerChannel("profileStorageListener",Ut));const Ft=h.ProxyChannel.fromService(Se.get(at.$0q),be);Pe.registerChannel(at.TerminalIpcChannels.LocalPty,Ft);const Wt=h.ProxyChannel.fromService(Se.get(ae.$S6b),be);Pe.registerChannel("externalTerminal",Wt);const mt=new Pt.$X7b(Se.get(It.$26b));Pe.registerChannel("logger",mt),Ce.then(tt=>tt.registerChannel("logger",mt));const Tt=new A.$B6b(Se.get(Ae.$p6b));Pe.registerChannel("extensionhostdebugservice",Tt);const zt=h.ProxyChannel.fromService(Se.get(ce.$P6b),be);Pe.registerChannel(ce.$Q6b,zt);const Bt=h.ProxyChannel.fromService(Se.get(ot.$Z7b),be);Pe.registerChannel(At.$Y7b,Bt)}async S(Se,Pe){const Ce=this.b=Se.get(Ae.$p6b);this.c=Se.get(dt.$76b);const be=(0,_.$Nl)(process.env)?0:4,je=this.s.args;if(Pe){if(Pe.openables.length>0)return Ce.open({context:be,cli:je,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const et of Pe.urls){const st=new URLSearchParams(et.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:st.toString()}),Ce.open({context:be,cli:je,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Fe=global.macOpenFiles,Be=je._.length,Xe=!!je["folder-uri"],Ze=!!je["file-uri"],Te=je["skip-add-to-recently-opened"]===!0,Ke=je.wait&&je.waitMarkerFilePath?u.URI.file(je.waitMarkerFilePath):void 0,Je=je.remote||void 0,Qe=je.profile,_e=je["profile-temp"];if(!Be&&!Xe&&!Ze){if(je["new-window"]||Qe||_e)return Ce.open({context:be,cli:je,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Te,waitMarkerFileURI:Ke,initialStartup:!0,remoteAuthority:Je,forceProfile:Qe,forceTempProfile:_e});if(Fe.length)return Ce.open({context:1,cli:je,urisToOpen:Fe.map(et=>(0,Ue.$ii)(et)?{workspaceUri:u.URI.file(et)}:{fileUri:u.URI.file(et)}),noRecentEntry:Te,waitMarkerFileURI:Ke,initialStartup:!0})}return Ce.open({context:be,cli:je,forceNewWindow:je["new-window"]||!Be&&je["unity-launch"],diffMode:je.diff,mergeMode:je.merge,noRecentEntry:Te,waitMarkerFileURI:Ke,gotoLineMode:je.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:Qe,forceTempProfile:_e})}U(){this.W(),S.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Se,Pe)=>{Pe({url:Se.url.replace(/^vscode-remote-resource:/,"http:"),method:Se.method})}),this.X(this.s.args,process.env,!0),this.Y(),b.$k&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Se=this.z.win32MutexName;if(b.$j&&Se)try{const Pe=await new Promise((be,je)=>{X(["@vscode/windows-mutex"],be,je)}),Ce=new Pe.Mutex(Se);g.Event.once(this.t.onWillShutdown)(()=>Ce.release())}catch(Pe){this.m.error(Pe)}}async X(Se,Pe,Ce){try{return await(0,Y.$Tl)(this.u,this.m,Se,Pe)}catch(be){const je=(0,P.$Ai)(be);Ce?this.b?.sendToFocused("vscode:showResolveShellEnvError",je):this.m.error(je)}return{}}async Y(){try{const Pe=(await this.y.readFile(this.s.argvResource)).value.toString(),Ce=JSON.parse((0,w.$5m)(Pe)),je=(0,se.$uo)(this.u)>=1;if(Ce["enable-crash-reporter"]===void 0){const Fe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${je},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.$eg)()}"`,"}"],Be=Pe.substring(0,Pe.length-2).concat(`,
`,Fe.join(`
`));await this.y.writeFile(this.s.argvResource,C.$be.fromString(Be))}else{const Fe=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${je},`);Fe!==Pe&&await this.y.writeFile(this.s.argvResource,C.$be.fromString(Fe))}}catch(Se){this.m.error(Se)}}};e.$77b=ut,e.$77b=ut=lt=Ee([te(2,H.$Oh),te(3,L.$0i),te(4,L.$$i),te(5,z.$_5b),te(6,W.$b6b),te(7,p.$ji),te(8,ve.$wN),te(9,G.$$j),te(10,oe.$pj),te(11,nt.$h6b)],ut)}),define(ie[314],ne([0,1,15,45,7,23,8,49,14,33,3,46,13,9,65,4,35,27,21,42,99,308,10,18,238,250,25,62,202,16,222,92,77,218,91,20,225,6,78,24,79,278,127,287,50,286,94,249,34,51,67,52,39,234,232,2,40,266,66,227,116,122,270,264]),function(X,e,S,R,s,O,C,P,f,a,g,w,y,d,v,m,b,$,u,l,E,h,i,c,o,t,n,r,p,A,D,k,I,j,N,z,_,Y,ce,re,ae,Z,Q,G,q,T,K,H,x,B,F,M,U,W,L,V,J,oe,le,de,fe,ve,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch(we){console.error(we.message),S.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Re=>console.error(Re));const[we,pe,se,ue,ge,Ie,De,Ne]=this.b();try{try{await this.d(se,Ne,ue,ge,De)}catch(Re){throw this.f(se,De,Re),Re}await we.invokeFunction(async Re=>{const qe=Re.get(Y.$0i),ze=Re.get(z.$b6b),ee=Re.get(A.$$j),he=Re.get(Y.$$i),$e=await this.e(qe,se,ze,we,De,!0);return u.Promises.writeFile(se.mainLockfile,String(process.pid)).catch(ke=>{qe.warn(`app#startup(): Error writing main lockfile: ${ke.stack}`)}),Ie.logger=he.createLogger("main",{name:(0,i.localize)(0,null)}),g.Event.once(ze.onWillShutdown)(ke=>{ee.dispose(),ue.dispose(),ke.join("instanceLockfile",u.Promises.unlink(se.mainLockfile).catch(()=>{}))}),we.createInstance(h.$77b,$e,pe).startup()})}catch(Re){we.invokeFunction(this.i,Re)}}b(){const we=new N.$Nh,pe=new V.$Rc;process.once("exit",()=>pe.dispose());const se={_serviceBrand:void 0,...ce.default};we.set(re.$pj,se);const ue=new n.$a6b(this.j(),se),ge=this.c(ue);we.set(n.$_5b,ue);const Ie=new le.$36b((0,Y.$lj)(ue),ue.logsHome);we.set(le.$26b,Ie);const De=new _.$U3b(Ie.getLogLevel()),Ne=pe.add(new de.$EN(De,[new Y.$ej(Ie.getLogLevel())]));we.set(Y.$0i,Ne);const Re=new D.$Op(Ne);we.set(A.$$j,Re);const qe=new k.$bq(Ne);Re.registerProvider(y.Schemas.file,qe);const ze=new oe.$Ar(Re);we.set(J.$Ik,ze);const ee=new ve.$zN(1,ue,Ne,Re);we.set(x.$vN,ee),we.set(x.$wN,ee);const he=new M.$i6b(ee,ze,ue,Re,Ne);we.set(M.$h6b,he),Re.registerProvider(y.Schemas.vscodeUserData,new me.$f8b(y.Schemas.file,qe,y.Schemas.vscodeUserData,he,ze,Ne));const $e=m.$j&&se.win32RegValueName?pe.add(new W.$d8b(Ne,se.win32RegValueName)):ue.policyFile?pe.add(new L.$e8b(ue.policyFile,Re,Ne)):new U.$kn;we.set(U.$in,$e);const ke=new o.$Kn(he.defaultProfile.settingsResource,Re,$e,Ne);return we.set(c.$ji,ke),we.set(z.$b6b,new I.$Mh(z.$c6b,void 0,!1)),we.set(q.$To,new I.$Mh(T.$b8b,void 0,!0)),we.set(F.$n6b,new I.$Mh(F.$o6b)),we.set(K.$3k,new I.$Mh(H.$c8b,void 0,!1)),we.set(Q.$0u,new I.$Mh(G.$_7b)),we.set(ae.$16b,new Z.$97b(ue,he,Ne)),[new j.$eq(we,!0),ge,ue,ke,ee,De,se,he]}c(we){const pe={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(se=>{const ue=process.env[se];typeof ue=="string"&&(pe[se]=ue)}),Object.assign(process.env,pe),pe}async d(we,pe,se,ue,ge){await C.Promises.settled([Promise.all([we.extensionsPath,we.codeCachePath,we.logsHome.with({scheme:y.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,we.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,we.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,we.backupHome].map(Ie=>Ie?u.Promises.mkdir(Ie,{recursive:!0}):void 0)),ue.init(),se.initialize()]),pe.init()}async e(we,pe,se,ue,ge,Ie){let De;try{(0,v.mark)("code/willStartMainServer"),De=await(0,E.$Kh)(pe.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),g.Event.once(se.onWillShutdown)(()=>De.dispose())}catch(Ne){if(Ne.code!=="EADDRINUSE")throw this.f(pe,ge,Ne),Ne;let Re;try{Re=await(0,E.$Lh)(pe.mainIPCHandle,"main")}catch(he){if(!Ie||m.$j||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),he;try{(0,R.unlinkSync)(pe.mainIPCHandle)}catch($e){throw we.warn("Could not delete obsolete instance handle",$e),$e}return this.e(we,pe,se,ue,ge,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw we.error(he),Re.dispose(),new Error(he)}let qe;!pe.args.wait&&!pe.args.status&&(qe=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const ze=l.ProxyChannel.toService(Re.getChannel("launch"),{disableMarshalling:!0}),ee=l.ProxyChannel.toService(Re.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ue.invokeFunction(async()=>{const he=new t.$Hr(B.$mo,ge),$e=await ee.getMainDiagnostics(),ke=await ee.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ae=await he.getDiagnostics($e,ke);throw console.log(Ae),new f.$ab});throw m.$j&&await this.h(ze,we),we.trace("Sending env to running instance..."),await ze.start(pe.args,process.env),Re.dispose(),qe&&clearTimeout(qe),new f.$ab("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new f.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),De}f(we,pe,se){if(se.code==="EACCES"||se.code==="EPERM"){const ue=(0,O.$Hb)([we.userDataPath,we.extensionsPath,E.$Gh]).map(ge=>(0,w.$rv)(s.URI.file(ge),{os:m.OS,tildify:we}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,P.$Ai)(se),ue.join(`
`)),pe)}}g(we,pe,se){S.dialog.showMessageBoxSync((0,fe.$Fv)({type:"warning",buttons:[(0,i.localize)(8,null)],message:we,detail:pe},se).options)}async h(we,pe){if(m.$j){const se=await we.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",se);try{(await new Promise((ue,ge)=>{X(["windows-foreground-love"],ue,ge)})).allowSetForegroundWindow(se)}catch(ue){pe.error(ue)}}}i(we,pe){const se=we.get(Y.$0i),ue=we.get(z.$b6b);let ge=0;pe&&(pe.isExpected?pe.message&&se.trace(pe.message):(ge=1,pe.stack?se.error(pe.stack):se.error(`Startup error: ${pe.toString()}`))),ue.kill(ge)}j(){const we=this.k((0,r.$Kl)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const pe=(0,p.$87b)(we.verbose);pe&&((0,r.$Ml)(process.argv,"--waitMarkerFilePath",pe),we.waitMarkerFilePath=pe)}return we}k(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const pe=this.l(we._,we.goto);we._=pe}return we}l(we,pe){const se=(0,b.cwd)(),ue=we.map(De=>{let Ne=String(De),Re;pe&&(Re=(0,a.$5f)(Ne),Ne=Re.path),Ne&&(Ne=this.m(se,Ne));const qe=(0,a.$Zf)(Ne,se),ze=(0,d.$nc)(qe);return ze&&!(0,a.$Vf)(ze)?null:pe&&Re?(Re.path=qe,this.n(Re)):qe}),ge=m.$j||m.$k,Ie=(0,O.$Mb)(ue,De=>De&&ge?De.toLowerCase():De||"");return(0,O.$Hb)(Ie)}m(we,pe){return m.$j&&(pe=(0,$.$Ke)(pe,'"')),pe=(0,$.$Ie)((0,$.$Ie)(pe," "),"	"),m.$j&&(pe=(0,d.$kc)(we,pe),pe=(0,$.$Ke)(pe,".")),pe}n(we){const pe=[we.path];return typeof we.line=="number"&&pe.push(String(we.line)),typeof we.column=="number"&&pe.push(String(we.column)),pe.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c36b92c82064882a228487040187cfc13669c0f/core/vs/code/electron-main/main.js.map
