/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(re){for(var t=[],D=0,O=re.length;D<O;D++)t[D]=be[re[D]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:jt,isFrozen:Jt,getPrototypeOf:Zt,getOwnPropertyDescriptor:ei}=Object;let{freeze:tt,seal:at,create:ti}=Object,{apply:Nt,construct:Ft}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,D,O){return t.apply(D,O)}),tt||(tt=function(t){return t}),at||(at=function(t){return t}),Ft||(Ft=function(t,D){return new t(...D)});const ii=rt(Array.prototype.forEach),zt=rt(Array.prototype.pop),bt=rt(Array.prototype.push),vt=rt(String.prototype.toLowerCase),Pt=rt(String.prototype.toString),ni=rt(String.prototype.match),ht=rt(String.prototype.replace),si=rt(String.prototype.indexOf),ri=rt(String.prototype.trim),st=rt(RegExp.prototype.test),$t=oi(TypeError);function rt(re){return function(t){for(var D=arguments.length,O=new Array(D>1?D-1:0),i=1;i<D;i++)O[i-1]=arguments[i];return Nt(re,t,O)}}function oi(re){return function(){for(var t=arguments.length,D=new Array(t),O=0;O<t;O++)D[O]=arguments[O];return Ft(re,D)}}function Be(re,t,D){var O;D=(O=D)!==null&&O!==void 0?O:vt,jt&&jt(re,null);let i=t.length;for(;i--;){let _=t[i];if(typeof _=="string"){const p=D(_);p!==_&&(Jt(t)||(t[i]=p),_=p)}re[_]=!0}return re}function gt(re){const t=ti(null);for(const[D,O]of Bt(re))t[D]=O;return t}function Dt(re,t){for(;re!==null;){const O=ei(re,t);if(O){if(O.get)return rt(O.get);if(typeof O.value=="function")return rt(O.value)}re=Zt(re)}function D(O){return console.warn("fallback value for",O),null}return D}const Ht=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ot=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Tt=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),li=tt(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Lt=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),ai=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ut=tt(["#text"]),Wt=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),hi=at(/\{\{[\w\W]*|[\w\W]*\}\}/gm),ui=at(/<%[\w\W]*|[\w\W]*%>/gm),ci=at(/\${[\w\W]*}/gm),fi=at(/^data-[\-\w.\u00B7-\uFFFF]/),di=at(/^aria-[\-\w]+$/),qt=at(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),gi=at(/^(?:\w+script|data):/i),mi=at(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=at(/^html$/i);var xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:hi,ERB_EXPR:ui,TMPLIT_EXPR:ci,DATA_ATTR:fi,ARIA_ATTR:di,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:gi,ATTR_WHITESPACE:mi,DOCTYPE_NAME:Vt});const bi=()=>typeof window>"u"?null:window,$i=function(t,D){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let O=null;const i="data-tt-policy-suffix";D&&D.hasAttribute(i)&&(O=D.getAttribute(i));const _="dompurify"+(O?"#"+O:"");try{return t.createPolicy(_,{createHTML(p){return p},createScriptURL(p){return p}})}catch{return console.warn("TrustedTypes policy "+_+" could not be created."),null}};function Kt(){let re=arguments.length>0&&arguments[0]!==void 0?arguments[0]:bi();const t=Le=>Kt(Le);if(t.version="3.0.5",t.removed=[],!re||!re.document||re.document.nodeType!==9)return t.isSupported=!1,t;const D=re.document,O=D.currentScript;let{document:i}=re;const{DocumentFragment:_,HTMLTemplateElement:p,Node:v,Element:h,NodeFilter:f,NamedNodeMap:d=re.NamedNodeMap||re.MozNamedAttrMap,HTMLFormElement:T,DOMParser:s,trustedTypes:a}=re,e=h.prototype,u=Dt(e,"cloneNode"),l=Dt(e,"nextSibling"),g=Dt(e,"childNodes"),n=Dt(e,"parentNode");if(typeof p=="function"){const Le=i.createElement("template");Le.content&&Le.content.ownerDocument&&(i=Le.content.ownerDocument)}let r,b="";const{implementation:c,createNodeIterator:o,createDocumentFragment:F,getElementsByTagName:H}=i,{importNode:R}=D;let m={};t.isSupported=typeof Bt=="function"&&typeof n=="function"&&c&&c.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:w,ERB_EXPR:j,TMPLIT_EXPR:z,DATA_ATTR:q,ARIA_ATTR:L,IS_SCRIPT_OR_DATA:P,ATTR_WHITESPACE:J}=xt;let{IS_ALLOWED_URI:ee}=xt,ne=null;const ue=Be({},[...Ht,...Ot,...Tt,...Lt,...Ut]);let le=null;const oe=Be({},[...Wt,...It,..._t,...yt]);let me=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Se=null,Te=null,Pe=!0,de=!0,ie=!1,fe=!0,Y=!1,V=!1,G=!1,k=!1,x=!1,$=!1,I=!1,M=!0,N=!1;const A="user-content-";let E=!0,W=!1,S={},B=null;const y=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let C=null;const U=Be({},["audio","video","img","source","image","track"]);let K=null;const te=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",ge="http://www.w3.org/2000/svg",we="http://www.w3.org/1999/xhtml";let Ne=we,Ae=!1,ve=null;const Ie=Be({},[se,ge,we],Pt);let Oe;const qe=["application/xhtml+xml","text/html"],je="text/html";let Re,Ge=null;const Z=i.createElement("form"),ae=function(ce){return ce instanceof RegExp||ce instanceof Function},pe=function(ce){if(!(Ge&&Ge===ce)){if((!ce||typeof ce!="object")&&(ce={}),ce=gt(ce),Oe=qe.indexOf(ce.PARSER_MEDIA_TYPE)===-1?Oe=je:Oe=ce.PARSER_MEDIA_TYPE,Re=Oe==="application/xhtml+xml"?Pt:vt,ne="ALLOWED_TAGS"in ce?Be({},ce.ALLOWED_TAGS,Re):ue,le="ALLOWED_ATTR"in ce?Be({},ce.ALLOWED_ATTR,Re):oe,ve="ALLOWED_NAMESPACES"in ce?Be({},ce.ALLOWED_NAMESPACES,Pt):Ie,K="ADD_URI_SAFE_ATTR"in ce?Be(gt(te),ce.ADD_URI_SAFE_ATTR,Re):te,C="ADD_DATA_URI_TAGS"in ce?Be(gt(U),ce.ADD_DATA_URI_TAGS,Re):U,B="FORBID_CONTENTS"in ce?Be({},ce.FORBID_CONTENTS,Re):y,Se="FORBID_TAGS"in ce?Be({},ce.FORBID_TAGS,Re):{},Te="FORBID_ATTR"in ce?Be({},ce.FORBID_ATTR,Re):{},S="USE_PROFILES"in ce?ce.USE_PROFILES:!1,Pe=ce.ALLOW_ARIA_ATTR!==!1,de=ce.ALLOW_DATA_ATTR!==!1,ie=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,fe=ce.ALLOW_SELF_CLOSE_IN_ATTR!==!1,Y=ce.SAFE_FOR_TEMPLATES||!1,V=ce.WHOLE_DOCUMENT||!1,x=ce.RETURN_DOM||!1,$=ce.RETURN_DOM_FRAGMENT||!1,I=ce.RETURN_TRUSTED_TYPE||!1,k=ce.FORCE_BODY||!1,M=ce.SANITIZE_DOM!==!1,N=ce.SANITIZE_NAMED_PROPS||!1,E=ce.KEEP_CONTENT!==!1,W=ce.IN_PLACE||!1,ee=ce.ALLOWED_URI_REGEXP||qt,Ne=ce.NAMESPACE||we,me=ce.CUSTOM_ELEMENT_HANDLING||{},ce.CUSTOM_ELEMENT_HANDLING&&ae(ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(me.tagNameCheck=ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&ae(ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(me.attributeNameCheck=ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&typeof ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(me.allowCustomizedBuiltInElements=ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),Y&&(de=!1),$&&(x=!0),S&&(ne=Be({},[...Ut]),le=[],S.html===!0&&(Be(ne,Ht),Be(le,Wt)),S.svg===!0&&(Be(ne,Ot),Be(le,It),Be(le,yt)),S.svgFilters===!0&&(Be(ne,Tt),Be(le,It),Be(le,yt)),S.mathMl===!0&&(Be(ne,Lt),Be(le,_t),Be(le,yt))),ce.ADD_TAGS&&(ne===ue&&(ne=gt(ne)),Be(ne,ce.ADD_TAGS,Re)),ce.ADD_ATTR&&(le===oe&&(le=gt(le)),Be(le,ce.ADD_ATTR,Re)),ce.ADD_URI_SAFE_ATTR&&Be(K,ce.ADD_URI_SAFE_ATTR,Re),ce.FORBID_CONTENTS&&(B===y&&(B=gt(B)),Be(B,ce.FORBID_CONTENTS,Re)),E&&(ne["#text"]=!0),V&&Be(ne,["html","head","body"]),ne.table&&(Be(ne,["tbody"]),delete Se.tbody),ce.TRUSTED_TYPES_POLICY){if(typeof ce.TRUSTED_TYPES_POLICY.createHTML!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ce.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=ce.TRUSTED_TYPES_POLICY,b=r.createHTML("")}else r===void 0&&(r=$i(a,O)),r!==null&&typeof b=="string"&&(b=r.createHTML(""));tt&&tt(ce),Ge=ce}},De=Be({},["mi","mo","mn","ms","mtext"]),Ce=Be({},["foreignobject","desc","title","annotation-xml"]),Me=Be({},["title","style","font","a","script"]),ze=Be({},Ot);Be(ze,Tt),Be(ze,li);const Xe=Be({},Lt);Be(Xe,ai);const Ke=function(ce){let ye=n(ce);(!ye||!ye.tagName)&&(ye={namespaceURI:Ne,tagName:"template"});const Fe=vt(ce.tagName),_e=vt(ye.tagName);return ve[ce.namespaceURI]?ce.namespaceURI===ge?ye.namespaceURI===we?Fe==="svg":ye.namespaceURI===se?Fe==="svg"&&(_e==="annotation-xml"||De[_e]):!!ze[Fe]:ce.namespaceURI===se?ye.namespaceURI===we?Fe==="math":ye.namespaceURI===ge?Fe==="math"&&Ce[_e]:!!Xe[Fe]:ce.namespaceURI===we?ye.namespaceURI===ge&&!Ce[_e]||ye.namespaceURI===se&&!De[_e]?!1:!Xe[Fe]&&(Me[Fe]||!ze[Fe]):!!(Oe==="application/xhtml+xml"&&ve[ce.namespaceURI]):!1},Ve=function(ce){bt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{ce.remove()}},We=function(ce,ye){try{bt(t.removed,{attribute:ye.getAttributeNode(ce),from:ye})}catch{bt(t.removed,{attribute:null,from:ye})}if(ye.removeAttribute(ce),ce==="is"&&!le[ce])if(x||$)try{Ve(ye)}catch{}else try{ye.setAttribute(ce,"")}catch{}},et=function(ce){let ye,Fe;if(k)ce="<remove></remove>"+ce;else{const nt=ni(ce,/^[\r\n\t ]+/);Fe=nt&&nt[0]}Oe==="application/xhtml+xml"&&Ne===we&&(ce='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ce+"</body></html>");const _e=r?r.createHTML(ce):ce;if(Ne===we)try{ye=new s().parseFromString(_e,Oe)}catch{}if(!ye||!ye.documentElement){ye=c.createDocument(Ne,"template",null);try{ye.documentElement.innerHTML=Ae?b:_e}catch{}}const Je=ye.body||ye.documentElement;return ce&&Fe&&Je.insertBefore(i.createTextNode(Fe),Je.childNodes[0]||null),Ne===we?H.call(ye,V?"html":"body")[0]:V?ye.documentElement:Je},it=function(ce){return o.call(ce.ownerDocument||ce,ce,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},ft=function(ce){return ce instanceof T&&(typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof d)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"||typeof ce.hasChildNodes!="function")},ut=function(ce){return typeof v=="object"?ce instanceof v:ce&&typeof ce=="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},ct=function(ce,ye,Fe){m[ce]&&ii(m[ce],_e=>{_e.call(t,ye,Fe,Ge)})},Et=function(ce){let ye;if(ct("beforeSanitizeElements",ce,null),ft(ce))return Ve(ce),!0;const Fe=Re(ce.nodeName);if(ct("uponSanitizeElement",ce,{tagName:Fe,allowedTags:ne}),ce.hasChildNodes()&&!ut(ce.firstElementChild)&&(!ut(ce.content)||!ut(ce.content.firstElementChild))&&st(/<[/\w]/g,ce.innerHTML)&&st(/<[/\w]/g,ce.textContent))return Ve(ce),!0;if(!ne[Fe]||Se[Fe]){if(!Se[Fe]&&kt(Fe)&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,Fe)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Fe)))return!1;if(E&&!B[Fe]){const _e=n(ce)||ce.parentNode,Je=g(ce)||ce.childNodes;if(Je&&_e){const nt=Je.length;for(let xe=nt-1;xe>=0;--xe)_e.insertBefore(u(Je[xe],!0),l(ce))}}return Ve(ce),!0}return ce instanceof h&&!Ke(ce)||(Fe==="noscript"||Fe==="noembed"||Fe==="noframes")&&st(/<\/no(script|embed|frames)/i,ce.innerHTML)?(Ve(ce),!0):(Y&&ce.nodeType===3&&(ye=ce.textContent,ye=ht(ye,w," "),ye=ht(ye,j," "),ye=ht(ye,z," "),ce.textContent!==ye&&(bt(t.removed,{element:ce.cloneNode()}),ce.textContent=ye)),ct("afterSanitizeElements",ce,null),!1)},At=function(ce,ye,Fe){if(M&&(ye==="id"||ye==="name")&&(Fe in i||Fe in Z))return!1;if(!(de&&!Te[ye]&&st(q,ye))){if(!(Pe&&st(L,ye))){if(!le[ye]||Te[ye]){if(!(kt(ce)&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,ce)||me.tagNameCheck instanceof Function&&me.tagNameCheck(ce))&&(me.attributeNameCheck instanceof RegExp&&st(me.attributeNameCheck,ye)||me.attributeNameCheck instanceof Function&&me.attributeNameCheck(ye))||ye==="is"&&me.allowCustomizedBuiltInElements&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,Fe)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Fe))))return!1}else if(!K[ye]){if(!st(ee,ht(Fe,J,""))){if(!((ye==="src"||ye==="xlink:href"||ye==="href")&&ce!=="script"&&si(Fe,"data:")===0&&C[ce])){if(!(ie&&!st(P,ht(Fe,J,"")))){if(Fe)return!1}}}}}}return!0},kt=function(ce){return ce.indexOf("-")>0},St=function(ce){let ye,Fe,_e,Je;ct("beforeSanitizeAttributes",ce,null);const{attributes:nt}=ce;if(!nt)return;const xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:le};for(Je=nt.length;Je--;){ye=nt[Je];const{name:ot,namespaceURI:pt}=ye;if(Fe=ot==="value"?ye.value:ri(ye.value),_e=Re(ot),xe.attrName=_e,xe.attrValue=Fe,xe.keepAttr=!0,xe.forceKeepAttr=void 0,ct("uponSanitizeAttribute",ce,xe),Fe=xe.attrValue,xe.forceKeepAttr||(We(ot,ce),!xe.keepAttr))continue;if(!fe&&st(/\/>/i,Fe)){We(ot,ce);continue}Y&&(Fe=ht(Fe,w," "),Fe=ht(Fe,j," "),Fe=ht(Fe,z," "));const dt=Re(ce.nodeName);if(At(dt,_e,Fe)){if(N&&(_e==="id"||_e==="name")&&(We(ot,ce),Fe=A+Fe),r&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!pt)switch(a.getAttributeType(dt,_e)){case"TrustedHTML":{Fe=r.createHTML(Fe);break}case"TrustedScriptURL":{Fe=r.createScriptURL(Fe);break}}try{pt?ce.setAttributeNS(pt,ot,Fe):ce.setAttribute(ot,Fe),zt(t.removed)}catch{}}}ct("afterSanitizeAttributes",ce,null)},Rt=function Le(ce){let ye;const Fe=it(ce);for(ct("beforeSanitizeShadowDOM",ce,null);ye=Fe.nextNode();)ct("uponSanitizeShadowNode",ye,null),!Et(ye)&&(ye.content instanceof _&&Le(ye.content),St(ye));ct("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Le){let ce=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ye,Fe,_e,Je;if(Ae=!Le,Ae&&(Le="<!-->"),typeof Le!="string"&&!ut(Le))if(typeof Le.toString=="function"){if(Le=Le.toString(),typeof Le!="string")throw $t("dirty is not a string, aborting")}else throw $t("toString is not a function");if(!t.isSupported)return Le;if(G||pe(ce),t.removed=[],typeof Le=="string"&&(W=!1),W){if(Le.nodeName){const ot=Re(Le.nodeName);if(!ne[ot]||Se[ot])throw $t("root node is forbidden and cannot be sanitized in-place")}}else if(Le instanceof v)ye=et("<!---->"),Fe=ye.ownerDocument.importNode(Le,!0),Fe.nodeType===1&&Fe.nodeName==="BODY"||Fe.nodeName==="HTML"?ye=Fe:ye.appendChild(Fe);else{if(!x&&!Y&&!V&&Le.indexOf("<")===-1)return r&&I?r.createHTML(Le):Le;if(ye=et(Le),!ye)return x?null:I?b:""}ye&&k&&Ve(ye.firstChild);const nt=it(W?Le:ye);for(;_e=nt.nextNode();)Et(_e)||(_e.content instanceof _&&Rt(_e.content),St(_e));if(W)return Le;if(x){if($)for(Je=F.call(ye.ownerDocument);ye.firstChild;)Je.appendChild(ye.firstChild);else Je=ye;return(le.shadowroot||le.shadowrootmode)&&(Je=R.call(D,Je,!0)),Je}let xe=V?ye.outerHTML:ye.innerHTML;return V&&ne["!doctype"]&&ye.ownerDocument&&ye.ownerDocument.doctype&&ye.ownerDocument.doctype.name&&st(Vt,ye.ownerDocument.doctype.name)&&(xe="<!DOCTYPE "+ye.ownerDocument.doctype.name+`>
`+xe),Y&&(xe=ht(xe,w," "),xe=ht(xe,j," "),xe=ht(xe,z," ")),r&&I?r.createHTML(xe):xe},t.setConfig=function(Le){pe(Le),G=!0},t.clearConfig=function(){Ge=null,G=!1},t.isValidAttribute=function(Le,ce,ye){Ge||pe({});const Fe=Re(Le),_e=Re(ce);return At(Fe,_e,ye)},t.addHook=function(Le,ce){typeof ce=="function"&&(m[Le]=m[Le]||[],bt(m[Le],ce))},t.removeHook=function(Le){if(m[Le])return zt(m[Le])},t.removeHooks=function(Le){m[Le]&&(m[Le]=[])},t.removeAllHooks=function(){m={}},t}var pi=Kt();define("vs/base/browser/dompurify/dompurify",function(){return pi}),define(be[40],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8P=t.$7P=void 0;class D{constructor(p){this.domNode=p,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(p){const v=O(p);this.a!==v&&(this.a=v,this.domNode.style.maxWidth=this.a)}setWidth(p){const v=O(p);this.b!==v&&(this.b=v,this.domNode.style.width=this.b)}setHeight(p){const v=O(p);this.c!==v&&(this.c=v,this.domNode.style.height=this.c)}setTop(p){const v=O(p);this.d!==v&&(this.d=v,this.domNode.style.top=this.d)}setLeft(p){const v=O(p);this.e!==v&&(this.e=v,this.domNode.style.left=this.e)}setBottom(p){const v=O(p);this.f!==v&&(this.f=v,this.domNode.style.bottom=this.f)}setRight(p){const v=O(p);this.g!==v&&(this.g=v,this.domNode.style.right=this.g)}setPaddingTop(p){const v=O(p);this.h!==v&&(this.h=v,this.domNode.style.paddingTop=this.h)}setPaddingLeft(p){const v=O(p);this.i!==v&&(this.i=v,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(p){const v=O(p);this.j!==v&&(this.j=v,this.domNode.style.paddingBottom=this.j)}setPaddingRight(p){const v=O(p);this.k!==v&&(this.k=v,this.domNode.style.paddingRight=this.k)}setFontFamily(p){this.l!==p&&(this.l=p,this.domNode.style.fontFamily=this.l)}setFontWeight(p){this.m!==p&&(this.m=p,this.domNode.style.fontWeight=this.m)}setFontSize(p){const v=O(p);this.n!==v&&(this.n=v,this.domNode.style.fontSize=this.n)}setFontStyle(p){this.o!==p&&(this.o=p,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(p){this.p!==p&&(this.p=p,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(p){this.q!==p&&(this.q=p,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(p){this.r!==p&&(this.r=p,this.domNode.style.textDecoration=this.r)}setLineHeight(p){const v=O(p);this.s!==v&&(this.s=v,this.domNode.style.lineHeight=this.s)}setLetterSpacing(p){const v=O(p);this.t!==v&&(this.t=v,this.domNode.style.letterSpacing=this.t)}setClassName(p){this.u!==p&&(this.u=p,this.domNode.className=this.u)}toggleClassName(p,v){this.domNode.classList.toggle(p,v),this.u=this.domNode.className}setDisplay(p){this.v!==p&&(this.v=p,this.domNode.style.display=this.v)}setPosition(p){this.w!==p&&(this.w=p,this.domNode.style.position=this.w)}setVisibility(p){this.x!==p&&(this.x=p,this.domNode.style.visibility=this.x)}setColor(p){this.y!==p&&(this.y=p,this.domNode.style.color=this.y)}setBackgroundColor(p){this.z!==p&&(this.z=p,this.domNode.style.backgroundColor=this.z)}setLayerHinting(p){this.A!==p&&(this.A=p,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(p){this.C!==p&&(this.C=p,this.domNode.style.boxShadow=p)}setContain(p){this.B!==p&&(this.B=p,this.domNode.style.contain=this.B)}setAttribute(p,v){this.domNode.setAttribute(p,v)}removeAttribute(p){this.domNode.removeAttribute(p)}appendChild(p){this.domNode.appendChild(p.domNode)}removeChild(p){this.domNode.removeChild(p.domNode)}}t.$7P=D;function O(_){return typeof _=="number"?`${_}px`:_}function i(_){return new D(_)}t.$8P=i}),define(be[67],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xO=t.$wO=void 0;let D=!1,O=null;function i(h){if(!h.parent||h.parent===h)return null;try{const f=h.location,d=h.parent.location;if(f.origin!=="null"&&d.origin!=="null"&&f.origin!==d.origin)return D=!0,null}catch{return D=!0,null}return h.parent}class _{static getSameOriginWindowChain(){if(!O){O=[];let f=window,d;do d=i(f),d?O.push({window:f,iframeElement:f.frameElement||null}):O.push({window:f,iframeElement:null}),f=d;while(f)}return O.slice(0)}static hasDifferentOriginAncestor(){return O||this.getSameOriginWindowChain(),D}static getPositionOfChildWindowRelativeToAncestorWindow(f,d){if(!d||f===d)return{top:0,left:0};let T=0,s=0;const a=this.getSameOriginWindowChain();for(const e of a){if(T+=e.window.scrollY,s+=e.window.scrollX,e.window===d||!e.iframeElement)break;const u=e.iframeElement.getBoundingClientRect();T+=u.top,s+=u.left}return{top:T,left:s}}}t.$wO=_;async function p(h,f){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const d=JSON.stringify({parentOrigin:h,salt:f}),s=new TextEncoder().encode(d),a=await crypto.subtle.digest("sha-256",s);return v(a)}t.$xO=p;function v(h){const d=Array.from(new Uint8Array(h)).map(T=>T.toString(16).padStart(2,"0")).join("");return BigInt(`0x${d}`).toString(32).padStart(52,"0")}}),define(be[68],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EQ=t.$DQ=t.$CQ=t.ListDragOverEffect=void 0;var D;(function(_){_[_.Copy=0]="Copy",_[_.Move=1]="Move"})(D||(t.ListDragOverEffect=D={})),t.$CQ={reject(){return{accept:!1}},accept(){return{accept:!0}}};class O extends Error{constructor(p,v){super(`ListError [${p}] ${v}`)}}t.$DQ=O;class i{constructor(){this.c=new WeakMap}getHeight(p){return this.c.get(p)??this.d(p)}setDynamicHeight(p,v){v>0&&this.c.set(p,v)}}t.$EQ=i}),define(be[69],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BQ=void 0;class D{constructor(i){this.a=i}splice(i,_,p){this.a.forEach(v=>v.splice(i,_,p))}}t.$BQ=D}),define(be[41],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aQ=void 0;const D=20;class O{constructor(_,p,v,h,f,d){this.a=Math.round(p),this.b=Math.round(v),this.c=Math.round(_),this.d=h,this.e=f,this.f=d,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new O(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(_){const p=Math.round(_);return this.d!==p?(this.d=p,this.m(),!0):!1}setScrollSize(_){const p=Math.round(_);return this.e!==p?(this.e=p,this.m(),!0):!1}setScrollPosition(_){const p=Math.round(_);return this.f!==p?(this.f=p,this.m(),!0):!1}setScrollbarSize(_){this.a=Math.round(_)}setOppositeScrollbarSize(_){this.b=Math.round(_)}static l(_,p,v,h,f){const d=Math.max(0,v-_),T=Math.max(0,d-2*p),s=h>0&&h>v;if(!s)return{computedAvailableSize:Math.round(d),computedIsNeeded:s,computedSliderSize:Math.round(T),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(D,Math.floor(v*T/h))),e=(T-a)/(h-v),u=f*e;return{computedAvailableSize:Math.round(d),computedIsNeeded:s,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(u)}}m(){const _=O.l(this.b,this.c,this.d,this.e,this.f);this.g=_.computedAvailableSize,this.h=_.computedIsNeeded,this.i=_.computedSliderSize,this.j=_.computedSliderRatio,this.k=_.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(_){if(!this.h)return 0;const p=_-this.c-this.i/2;return Math.round(p/this.j)}getDesiredScrollPositionFromOffsetPaged(_){if(!this.h)return 0;const p=_-this.c;let v=this.f;return p<this.k?v-=this.d:v+=this.d,v}getDesiredScrollPositionFromDelta(_){if(!this.h)return 0;const p=this.k+_;return Math.round(p/this.j)}}t.$aQ=O}),define(be[24],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yS=t.$xS=t.$wS=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var D;(function(h){h[h.Hidden=0]="Hidden",h[h.Visible=1]="Visible",h[h.Recurse=2]="Recurse"})(D||(t.TreeVisibility=D={}));var O;(function(h){h[h.Expanded=0]="Expanded",h[h.Collapsed=1]="Collapsed",h[h.PreserveOrExpanded=2]="PreserveOrExpanded",h[h.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(O||(t.ObjectTreeElementCollapseState=O={}));var i;(function(h){h[h.Unknown=0]="Unknown",h[h.Twistie=1]="Twistie",h[h.Element=2]="Element",h[h.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var _;(function(h){h[h.Down=0]="Down",h[h.Up=1]="Up"})(_||(t.TreeDragOverBubble=_={})),t.$wS={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(h=!1){return{accept:!0,bubble:0,autoExpand:h}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(h=!1){return{accept:!0,bubble:0,effect:0,autoExpand:h}}};class p extends Error{constructor(f,d){super(`TreeError [${f}] ${d}`)}}t.$xS=p;class v{constructor(f){this.a=f,this.b=new WeakMap}map(f){let d=this.b.get(f);return d||(d=this.a(f),this.b.set(f,d)),d}}t.$yS=v}),define(be[70],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function D(u,l,g){const n=O(u,l);if(n!==-1)return u[n]}t.$fb=D;function O(u,l,g=u.length-1){for(let n=g;n>=0;n--){const r=u[n];if(l(r))return n}return-1}t.$gb=O;function i(u,l){const g=_(u,l);return g===-1?void 0:u[g]}t.$hb=i;function _(u,l,g=0,n=u.length){let r=g,b=n;for(;r<b;){const c=Math.floor((r+b)/2);l(u[c])?r=c+1:b=c}return r-1}t.$ib=_;function p(u,l){const g=v(u,l);return g===u.length?void 0:u[g]}t.$jb=p;function v(u,l,g=0,n=u.length){let r=g,b=n;for(;r<b;){const c=Math.floor((r+b)/2);l(u[c])?b=c:r=c+1}return r}t.$kb=v;function h(u,l,g=0,n=u.length){const r=v(u,l,g,n);return r===u.length?-1:r}t.$lb=h;class f{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(f.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!l(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const g=_(this.e,l,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}t.$mb=f;function d(u,l){if(u.length===0)return;let g=u[0];for(let n=1;n<u.length;n++){const r=u[n];l(r,g)>0&&(g=r)}return g}t.$nb=d;function T(u,l){if(u.length===0)return;let g=u[0];for(let n=1;n<u.length;n++){const r=u[n];l(r,g)>=0&&(g=r)}return g}t.$ob=T;function s(u,l){return d(u,(g,n)=>-l(g,n))}t.$pb=s;function a(u,l){if(u.length===0)return-1;let g=0;for(let n=1;n<u.length;n++){const r=u[n];l(r,u[g])>0&&(g=n)}return g}t.$qb=a;function e(u,l){for(const g of u){const n=l(g);if(n!==void 0)return n}}t.$rb=e}),define(be[71],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function D(p,v){const h=Object.create(null);for(const f of p){const d=v(f);let T=h[d];T||(T=h[d]=[]),T.push(f)}return h}t.$J=D;function O(p,v){const h=[],f=[];for(const d of p)v.has(d)||h.push(d);for(const d of v)p.has(d)||f.push(d);return{removed:h,added:f}}t.$K=O;function i(p,v){const h=[],f=[];for(const[d,T]of p)v.has(d)||h.push(T);for(const[d,T]of v)p.has(d)||f.push(T);return{removed:h,added:f}}t.$L=i;function _(p,v){const h=new Set;for(const f of v)p.has(f)&&h.add(f);return h}t.$M=_}),define(be[72],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ys=t.$Xs=t.$Ws=t.$Vs=void 0;function D(v,h){const f=Math.pow(10,h);return Math.round(v*f)/f}class O{constructor(h,f,d,T=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=D(Math.max(Math.min(1,T),0),3)}static equals(h,f){return h.r===f.r&&h.g===f.g&&h.b===f.b&&h.a===f.a}}t.$Vs=O;class i{constructor(h,f,d,T){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=D(Math.max(Math.min(1,f),0),3),this.l=D(Math.max(Math.min(1,d),0),3),this.a=D(Math.max(Math.min(1,T),0),3)}static equals(h,f){return h.h===f.h&&h.s===f.s&&h.l===f.l&&h.a===f.a}static fromRGBA(h){const f=h.r/255,d=h.g/255,T=h.b/255,s=h.a,a=Math.max(f,d,T),e=Math.min(f,d,T);let u=0,l=0;const g=(e+a)/2,n=a-e;if(n>0){switch(l=Math.min(g<=.5?n/(2*g):n/(2-2*g),1),a){case f:u=(d-T)/n+(d<T?6:0);break;case d:u=(T-f)/n+2;break;case T:u=(f-d)/n+4;break}u*=60,u=Math.round(u)}return new i(u,l,g,s)}static i(h,f,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?h+(f-h)*6*d:d<1/2?f:d<2/3?h+(f-h)*(2/3-d)*6:h}static toRGBA(h){const f=h.h/360,{s:d,l:T,a:s}=h;let a,e,u;if(d===0)a=e=u=T;else{const l=T<.5?T*(1+d):T+d-T*d,g=2*T-l;a=i.i(g,l,f+1/3),e=i.i(g,l,f),u=i.i(g,l,f-1/3)}return new O(Math.round(a*255),Math.round(e*255),Math.round(u*255),s)}}t.$Ws=i;class _{constructor(h,f,d,T){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=D(Math.max(Math.min(1,f),0),3),this.v=D(Math.max(Math.min(1,d),0),3),this.a=D(Math.max(Math.min(1,T),0),3)}static equals(h,f){return h.h===f.h&&h.s===f.s&&h.v===f.v&&h.a===f.a}static fromRGBA(h){const f=h.r/255,d=h.g/255,T=h.b/255,s=Math.max(f,d,T),a=Math.min(f,d,T),e=s-a,u=s===0?0:e/s;let l;return e===0?l=0:s===f?l=((d-T)/e%6+6)%6:s===d?l=(T-f)/e+2:l=(f-d)/e+4,new _(Math.round(l*60),u,s,h.a)}static toRGBA(h){const{h:f,s:d,v:T,a:s}=h,a=T*d,e=a*(1-Math.abs(f/60%2-1)),u=T-a;let[l,g,n]=[0,0,0];return f<60?(l=a,g=e):f<120?(l=e,g=a):f<180?(g=a,n=e):f<240?(g=e,n=a):f<300?(l=e,n=a):f<=360&&(l=a,n=e),l=Math.round((l+u)*255),g=Math.round((g+u)*255),n=Math.round((n+u)*255),new O(l,g,n,s)}}t.$Xs=_;class p{static fromHex(h){return p.Format.CSS.parseHex(h)||p.red}static equals(h,f){return!h&&!f?!0:!h||!f?!1:h.equals(f)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:_.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof O)this.rgba=h;else if(h instanceof i)this.i=h,this.rgba=i.toRGBA(h);else if(h instanceof _)this.j=h,this.rgba=_.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&O.equals(this.rgba,h.rgba)&&i.equals(this.hsla,h.hsla)&&_.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=p.k(this.rgba.r),f=p.k(this.rgba.g),d=p.k(this.rgba.b),T=.2126*h+.7152*f+.0722*d;return D(T,4)}static k(h){const f=h/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f>d?(f+.05)/(d+.05):(d+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f>d}isDarkerThan(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f<d}lighten(h){return new p(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new p(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:f,g:d,b:T,a:s}=this.rgba;return new p(new O(f,d,T,s*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new p(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const f=h.rgba,d=this.rgba.a,T=f.a,s=d+T*(1-d);if(s<1e-6)return p.transparent;const a=this.rgba.r*d/s+f.r*T*(1-d)/s,e=this.rgba.g*d/s+f.g*T*(1-d)/s,u=this.rgba.b*d/s+f.b*T*(1-d)/s;return new p(new O(a,e,u,s))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:f,g:d,b:T,a:s}=this.rgba;return new p(new O(h.rgba.r-s*(h.rgba.r-f),h.rgba.g-s*(h.rgba.g-d),h.rgba.b-s*(h.rgba.b-T),1))}flatten(...h){const f=h.reduceRight((d,T)=>p.o(T,d));return p.o(this,f)}static o(h,f){const d=1-h.rgba.a;return new p(new O(d*f.rgba.r+h.rgba.a*h.rgba.r,d*f.rgba.g+h.rgba.a*h.rgba.g,d*f.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=p.Format.CSS.format(this)),this.u}static getLighterColor(h,f,d){if(h.isLighterThan(f))return h;d=d||.5;const T=h.getRelativeLuminance(),s=f.getRelativeLuminance();return d=d*(s-T)/s,h.lighten(d)}static getDarkerColor(h,f,d){if(h.isDarkerThan(f))return h;d=d||.5;const T=h.getRelativeLuminance(),s=f.getRelativeLuminance();return d=d*(T-s)/T,h.darken(d)}static{this.white=new p(new O(255,255,255,1))}static{this.black=new p(new O(0,0,0,1))}static{this.red=new p(new O(255,0,0,1))}static{this.blue=new p(new O(0,0,255,1))}static{this.green=new p(new O(0,255,0,1))}static{this.cyan=new p(new O(0,255,255,1))}static{this.lightgrey=new p(new O(211,211,211,1))}static{this.transparent=new p(new O(0,0,0,0))}}t.$Ys=p,function(v){let h;(function(f){let d;(function(T){function s(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:v.Format.CSS.formatRGBA(o)}T.formatRGB=s;function a(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}T.formatRGBA=a;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(o)}T.formatHSL=e;function u(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}T.formatHSLA=u;function l(o){const F=o.toString(16);return F.length!==2?"0"+F:F}function g(o){return`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}`}T.formatHex=g;function n(o,F=!1){return F&&o.rgba.a===1?v.Format.CSS.formatHex(o):`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}${l(Math.round(o.rgba.a*255))}`}T.formatHexA=n;function r(o){return o.isOpaque()?v.Format.CSS.formatHex(o):v.Format.CSS.formatRGBA(o)}T.format=r;function b(o){const F=o.length;if(F===0||o.charCodeAt(0)!==35)return null;if(F===7){const H=16*c(o.charCodeAt(1))+c(o.charCodeAt(2)),R=16*c(o.charCodeAt(3))+c(o.charCodeAt(4)),m=16*c(o.charCodeAt(5))+c(o.charCodeAt(6));return new v(new O(H,R,m,1))}if(F===9){const H=16*c(o.charCodeAt(1))+c(o.charCodeAt(2)),R=16*c(o.charCodeAt(3))+c(o.charCodeAt(4)),m=16*c(o.charCodeAt(5))+c(o.charCodeAt(6)),w=16*c(o.charCodeAt(7))+c(o.charCodeAt(8));return new v(new O(H,R,m,w/255))}if(F===4){const H=c(o.charCodeAt(1)),R=c(o.charCodeAt(2)),m=c(o.charCodeAt(3));return new v(new O(16*H+H,16*R+R,16*m+m))}if(F===5){const H=c(o.charCodeAt(1)),R=c(o.charCodeAt(2)),m=c(o.charCodeAt(3)),w=c(o.charCodeAt(4));return new v(new O(16*H+H,16*R+R,16*m+m,(16*w+w)/255))}return null}T.parseHex=b;function c(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=f.CSS||(f.CSS={}))})(h=v.Format||(v.Format={}))}(p||(t.$Ys=p={}))}),define(be[25],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jh=t.$ih=t.$hh=void 0;function D(p){return(v,h,f)=>{let d=null,T=null;if(typeof f.value=="function"?(d="value",T=f.value):typeof f.get=="function"&&(d="get",T=f.get),!T)throw new Error("not supported");f[d]=p(T,h)}}function O(p,v,h){let f=null,d=null;if(typeof h.value=="function"?(f="value",d=h.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(f="get",d=h.get),!d)throw new Error("not supported");const T=`$memoize$${v}`;h[f]=function(...s){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,s)}),this[T]}}t.$hh=O;function i(p,v,h){return D((f,d)=>{const T=`$debounce$${d}`,s=`$debounce$result$${d}`;return function(...a){this[s]||(this[s]=h?h():void 0),clearTimeout(this[T]),v&&(this[s]=v(this[s],...a),a=[this[s]]),this[T]=setTimeout(()=>{f.apply(this,a),this[s]=h?h():void 0},p)}})}t.$ih=i;function _(p,v,h){return D((f,d)=>{const T=`$throttle$timer$${d}`,s=`$throttle$result$${d}`,a=`$throttle$lastRun$${d}`,e=`$throttle$pending$${d}`;return function(...u){if(this[s]||(this[s]=h?h():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),v&&(this[s]=v(this[s],...u)),this[e])return;const l=this[a]+p;l<=Date.now()?(this[a]=Date.now(),f.apply(this,[this[s]]),this[s]=h?h():void 0):(this[e]=!0,this[T]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),f.apply(this,[this[s]]),this[s]=h?h():void 0},l-Date.now()))}})}t.$jh=_}),define(be[73],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xs=void 0;class D{constructor(i,_,p,v){this.originalStart=i,this.originalLength=_,this.modifiedStart=p,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$xs=D}),define(be[6],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class D{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?r.isErrorNoTelemetry(o)?new r(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(F=>{F(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}t.$W=D,t.$X=new D;function O(c){t.$X.setUnexpectedErrorHandler(c)}t.setUnexpectedErrorHandler=O;function i(c){if(!c||typeof c!="object")return!1;const o=c;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}t.$Z=i;function _(c){f(c)||t.$X.onUnexpectedError(c)}t.$1=_;function p(c){f(c)||t.$X.onUnexpectedExternalError(c)}t.$2=p;function v(c){if(c instanceof Error){const{name:o,message:F}=c,H=c.stacktrace||c.stack;return{$isError:!0,name:o,message:F,stack:H,noTelemetry:r.isErrorNoTelemetry(c)}}return c}t.$3=v;const h="Canceled";function f(c){return c instanceof d?!0:c instanceof Error&&c.name===h&&c.message===h}t.$4=f;class d extends Error{constructor(){super(h),this.name=this.message}}t.$5=d;function T(){const c=new Error(h);return c.name=c.message,c}t.$6=T;function s(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.$7=s;function a(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.$8=a;class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function u(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}t.$0=u;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.$$=l;class g extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.$_=g;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=n;class r extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof r)return o;const F=new r;return F.message=o.message,F.stack=o.stack,F}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.$bb=r;class b extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$cb=b}),define(be[11],$e([1,0,6,70]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function i(N,A=0){return N[N.length-(1+A)]}t.$sb=i;function _(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}t.$tb=_;function p(N,A,E=(W,S)=>W===S){if(N===A)return!0;if(!N||!A||N.length!==A.length)return!1;for(let W=0,S=N.length;W<S;W++)if(!E(N[W],A[W]))return!1;return!0}t.$ub=p;function v(N,A){const E=N.length-1;A<E&&(N[A]=N[E]),N.pop()}t.$vb=v;function h(N,A,E){return f(N.length,W=>E(N[W],A))}t.$wb=h;function f(N,A){let E=0,W=N-1;for(;E<=W;){const S=(E+W)/2|0,B=A(S);if(B<0)E=S+1;else if(B>0)W=S-1;else return S}return-(E+1)}t.$xb=f;function d(N,A,E){if(N=N|0,N>=A.length)throw new TypeError("invalid index");const W=A[Math.floor(A.length*Math.random())],S=[],B=[],y=[];for(const C of A){const U=E(C,W);U<0?S.push(C):U>0?B.push(C):y.push(C)}return N<S.length?d(N,S,E):N<S.length+y.length?y[0]:d(N-(S.length+y.length),B,E)}t.$yb=d;function T(N,A){const E=[];let W;for(const S of N.slice(0).sort(A))!W||A(W[0],S)!==0?(W=[S],E.push(W)):W.push(S);return E}t.$zb=T;function*s(N,A){let E,W;for(const S of N)W!==void 0&&A(W,S)?E.push(S):(E&&(yield E),E=[S]),W=S;E&&(yield E)}t.$Ab=s;function a(N,A){for(let E=0;E<=N.length;E++)A(E===0?void 0:N[E-1],E===N.length?void 0:N[E])}t.$Bb=a;function e(N,A){for(let E=0;E<N.length;E++)A(E===0?void 0:N[E-1],N[E],E+1===N.length?void 0:N[E+1])}t.$Cb=e;function u(N,A,E){const W=[];function S(C,U,K){if(U===0&&K.length===0)return;const te=W[W.length-1];te&&te.start+te.deleteCount===C?(te.deleteCount+=U,te.toInsert.push(...K)):W.push({start:C,deleteCount:U,toInsert:K})}let B=0,y=0;for(;;){if(B===N.length){S(B,0,A.slice(y));break}if(y===A.length){S(B,N.length-B,[]);break}const C=N[B],U=A[y],K=E(C,U);K===0?(B+=1,y+=1):K<0?(S(B,1,[]),B+=1):K>0&&(S(B,0,[U]),y+=1)}return W}t.$Db=u;function l(N,A,E){const W=u(N,A,E),S=[],B=[];for(const y of W)S.push(...N.slice(y.start,y.start+y.deleteCount)),B.push(...y.toInsert);return{removed:S,added:B}}t.$Eb=l;function g(N,A,E){if(E===0)return[];const W=N.slice(0,E).sort(A);return r(N,A,W,E,N.length),W}t.top=g;function n(N,A,E,W,S){return E===0?Promise.resolve([]):new Promise((B,y)=>{(async()=>{const C=N.length,U=N.slice(0,E).sort(A);for(let K=E,te=Math.min(E+W,C);K<C;K=te,te=Math.min(te+W,C)){if(K>E&&await new Promise(se=>setTimeout(se)),S&&S.isCancellationRequested)throw new D.$5;r(N,A,U,K,te)}return U})().then(B,y)})}t.$Gb=n;function r(N,A,E,W,S){for(const B=E.length;W<S;W++){const y=N[W];if(A(y,E[B-1])<0){E.pop();const C=(0,O.$kb)(E,U=>A(y,U)<0);E.splice(C,0,y)}}}function b(N){return N.filter(A=>!!A)}t.$Hb=b;function c(N){let A=0;for(let E=0;E<N.length;E++)N[E]&&(N[A]=N[E],A+=1);N.length=A}t.$Ib=c;function o(N,A,E){N.splice(E,0,N.splice(A,1)[0])}t.$Jb=o;function F(N){return!Array.isArray(N)||N.length===0}t.$Kb=F;function H(N){return Array.isArray(N)&&N.length>0}t.$Lb=H;function R(N,A=E=>E){const E=new Set;return N.filter(W=>{const S=A(W);return E.has(S)?!1:(E.add(S),!0)})}t.$Mb=R;function m(N){const A=new Set;return E=>{const W=N(E);return A.has(W)?!1:(A.add(W),!0)}}t.$Nb=m;function w(N,A){return N.length>0?N[0]:A}t.$Ob=w;function j(N,A){return N.length>0?N[N.length-1]:A}t.$Pb=j;function z(N,A,E=(W,S)=>W===S){let W=0;for(let S=0,B=Math.min(N.length,A.length);S<B&&E(N[S],A[S]);S++)W++;return W}t.$Qb=z;function q(N){return[].concat(...N)}t.$Rb=q;function L(N,A){let E=typeof A=="number"?N:0;typeof A=="number"?E=N:(E=0,A=N);const W=[];if(E<=A)for(let S=E;S<A;S++)W.push(S);else for(let S=E;S>A;S--)W.push(S);return W}t.$Sb=L;function P(N,A,E){return N.reduce((W,S)=>(W[A(S)]=E?E(S):S,W),Object.create(null))}t.$Tb=P;function J(N,A){return N.push(A),()=>ee(N,A)}t.$Ub=J;function ee(N,A){const E=N.indexOf(A);if(E>-1)return N.splice(E,1),A}t.$Vb=ee;function ne(N,A,E){const W=N.slice(0,A),S=N.slice(A);return W.concat(E,S)}t.$Wb=ne;function ue(N,A){let E;if(typeof A=="number"){let W=A;E=()=>{const S=Math.sin(W++)*179426549;return S-Math.floor(S)}}else E=Math.random;for(let W=N.length-1;W>0;W-=1){const S=Math.floor(E()*(W+1)),B=N[W];N[W]=N[S],N[S]=B}}t.$Xb=ue;function le(N,A){const E=N.indexOf(A);E>-1&&(N.splice(E,1),N.unshift(A))}t.$Yb=le;function oe(N,A){const E=N.indexOf(A);E>-1&&(N.splice(E,1),N.push(A))}t.$Zb=oe;function me(N,A){for(const E of A)N.push(E)}t.$1b=me;function Se(N,A){return Array.isArray(N)?N.map(A):A(N)}t.$2b=Se;function Te(N){return Array.isArray(N)?N:[N]}t.$3b=Te;function Pe(N){return N[Math.floor(Math.random()*N.length)]}t.$4b=Pe;function de(N,A,E){const W=fe(N,A),S=N.length,B=E.length;N.length=S+B;for(let y=S-1;y>=W;y--)N[y+B]=N[y];for(let y=0;y<B;y++)N[y+W]=E[y]}t.$5b=de;function ie(N,A,E,W){const S=fe(N,A);let B=N.splice(S,E);return B===void 0&&(B=[]),de(N,S,W),B}t.$6b=ie;function fe(N,A){return A<0?Math.max(A+N.length,0):Math.min(A,N.length)}var Y;(function(N){function A(B){return B<0}N.isLessThan=A;function E(B){return B<=0}N.isLessThanOrEqual=E;function W(B){return B>0}N.isGreaterThan=W;function S(B){return B===0}N.isNeitherLessOrGreaterThan=S,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Y||(t.CompareResult=Y={}));function V(N,A){return(E,W)=>A(N(E),N(W))}t.$7b=V;function G(...N){return(A,E)=>{for(const W of N){const S=W(A,E);if(!Y.isNeitherLessOrGreaterThan(S))return S}return Y.neitherLessOrGreaterThan}}t.$8b=G;const k=(N,A)=>N-A;t.$9b=k;const x=(N,A)=>(0,t.$9b)(N?1:0,A?1:0);t.$0b=x;function $(N){return(A,E)=>-N(A,E)}t.$$b=$;class I{constructor(A){this.g=A,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(A){let E=this.c;for(;E<this.g.length&&A(this.g[E]);)E++;const W=E===this.c?null:this.g.slice(this.c,E);return this.c=E,W}takeFromEndWhile(A){let E=this.d;for(;E>=0&&A(this.g[E]);)E--;const W=E===this.d?null:this.g.slice(E+1,this.d+1);return this.d=E,W}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const A=this.g[this.c];return this.c++,A}removeLast(){const A=this.g[this.d];return this.d--,A}takeCount(A){const E=this.g.slice(this.c,this.c+A);return this.c+=A,E}}t.$_b=I;class M{static{this.empty=new M(A=>{})}constructor(A){this.iterate=A}forEach(A){this.iterate(E=>(A(E),!0))}toArray(){const A=[];return this.iterate(E=>(A.push(E),!0)),A}filter(A){return new M(E=>this.iterate(W=>A(W)?E(W):!0))}map(A){return new M(E=>this.iterate(W=>E(A(W))))}some(A){let E=!1;return this.iterate(W=>(E=A(W),!E)),E}findFirst(A){let E;return this.iterate(W=>A(W)?(E=W,!1):!0),E}findLast(A){let E;return this.iterate(W=>(A(W)&&(E=W),!0)),E}findLastMaxBy(A){let E,W=!0;return this.iterate(S=>((W||Y.isGreaterThan(A(S,E)))&&(W=!1,E=S),!0)),E}}t.$ac=M}),define(be[74],$e([1,0,6]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=t.$6c=t.$5c=t.$4c=t.ok=void 0;function O(h,f){if(!h)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}t.ok=O;function i(h,f="Unreachable"){throw new Error(f)}t.$4c=i;function _(h){if(!h)throw new D.$cb("Assertion Failed")}t.$5c=_;function p(h){if(!h()){debugger;h(),(0,D.$1)(new D.$cb("Assertion Failed"))}}t.$6c=p;function v(h,f){let d=0;for(;d<h.length-1;){const T=h[d],s=h[d+1];if(!f(T,s))return!1;d++}return!0}t.$7c=v}),define(be[42],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function D(O){const i=this;let _=!1,p;return function(){return _||(_=!0,p=O.apply(i,arguments)),p}}t.$db=D}),define(be[75],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nM=t.$mM=void 0;class D{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$mM=D,t.$nM=new D("id#")}),define(be[26],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var D;(function(O){function i(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}O.is=i;const _=Object.freeze([]);function p(){return _}O.empty=p;function*v(c){yield c}O.single=v;function h(c){return i(c)?c:v(c)}O.wrap=h;function f(c){return c||_}O.from=f;function*d(c){for(let o=c.length-1;o>=0;o--)yield c[o]}O.reverse=d;function T(c){return!c||c[Symbol.iterator]().next().done===!0}O.isEmpty=T;function s(c){return c[Symbol.iterator]().next().value}O.first=s;function a(c,o){for(const F of c)if(o(F))return!0;return!1}O.some=a;function e(c,o){for(const F of c)if(o(F))return F}O.find=e;function*u(c,o){for(const F of c)o(F)&&(yield F)}O.filter=u;function*l(c,o){let F=0;for(const H of c)yield o(H,F++)}O.map=l;function*g(...c){for(const o of c)for(const F of o)yield F}O.concat=g;function n(c,o,F){let H=F;for(const R of c)H=o(H,R);return H}O.reduce=n;function*r(c,o,F=c.length){for(o<0&&(o+=c.length),F<0?F+=c.length:F>c.length&&(F=c.length);o<F;o++)yield c[o]}O.slice=r;function b(c,o=Number.POSITIVE_INFINITY){const F=[];if(o===0)return[F,c];const H=c[Symbol.iterator]();for(let R=0;R<o;R++){const m=H.next();if(m.done)return[F,O.empty()];F.push(m.value)}return[F,{[Symbol.iterator](){return H}}]}O.consume=b})(D||(t.Iterable=D={}))}),define(be[43],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gq=t.KeyMod=t.KeyCodeUtils=t.$Fq=t.$Eq=t.$Dq=t.$Cq=t.$Bq=t.ScanCode=t.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(D||(t.KeyCode=D={}));var O;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(O||(t.ScanCode=O={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,l){this._keyCodeToStr[u]=l,this._strToKeyCode[l.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const _=new i,p=new i,v=new i;t.$Bq=new Array(230),t.$Cq={};const h=[],f=Object.create(null),d=Object.create(null);t.$Dq={lowerCaseToEnum:e=>d[e]||0,toEnum:e=>f[e]||0,toString:e=>h[e]||"None"},t.$Eq=[],t.$Fq=[];for(let e=0;e<=193;e++)t.$Eq[e]=-1;for(let e=0;e<=132;e++)t.$Fq[e]=-1;(function(){const e="",u=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],l=[],g=[];for(const n of u){const[r,b,c,o,F,H,R,m,w]=n;if(g[b]||(g[b]=!0,h[b]=c,f[c]=b,d[c.toLowerCase()]=b,r&&(t.$Eq[b]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.$Fq[o]=b))),!l[o]){if(l[o]=!0,!F)throw new Error(`String representation missing for key code ${o} around scan code ${c}`);_.define(o,F),p.define(o,m||F),v.define(o,w||m||F)}H&&(t.$Bq[H]=o),R&&(t.$Cq[R]=o)}t.$Fq[3]=46})();var T;(function(e){function u(c){return _.keyCodeToStr(c)}e.toString=u;function l(c){return _.strToKeyCode(c)}e.fromString=l;function g(c){return p.keyCodeToStr(c)}e.toUserSettingsUS=g;function n(c){return v.keyCodeToStr(c)}e.toUserSettingsGeneral=n;function r(c){return p.strToKeyCode(c)||v.strToKeyCode(c)}e.fromUserSettings=r;function b(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return _.keyCodeToStr(c)}e.toElectronAccelerator=b})(T||(t.KeyCodeUtils=T={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function a(e,u){const l=(u&65535)<<16>>>0;return(e|l)>>>0}t.$Gq=a}),define(be[76],$e([1,0,6]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nq=t.$Mq=t.$Lq=t.$Kq=t.$Jq=t.$Iq=t.$Hq=void 0;var O;(function(T){T[T.CtrlCmd=2048]="CtrlCmd",T[T.Shift=1024]="Shift",T[T.Alt=512]="Alt",T[T.WinCtrl=256]="WinCtrl",T[T.KeyCode=255]="KeyCode"})(O||(O={}));function i(T,s){if(typeof T=="number"){if(T===0)return null;const a=(T&65535)>>>0,e=(T&4294901760)>>>16;return e!==0?new h([_(a,s),_(e,s)]):new h([_(a,s)])}else{const a=[];for(let e=0;e<T.length;e++)a.push(_(T[e],s));return new h(a)}}t.$Hq=i;function _(T,s){const a=!!(T&2048),e=!!(T&256),u=s===2?e:a,l=!!(T&1024),g=!!(T&512),n=s===2?a:e,r=T&255;return new p(u,l,g,n,r)}t.$Iq=_;class p{constructor(s,a,e,u,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.keyCode=l}equals(s){return s instanceof p&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",u=this.metaKey?"1":"0";return`K${s}${a}${e}${u}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new h([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Jq=p;class v{constructor(s,a,e,u,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.scanCode=l}equals(s){return s instanceof v&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",u=this.metaKey?"1":"0";return`S${s}${a}${e}${u}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Kq=v;class h{constructor(s){if(s.length===0)throw(0,D.$7)("chords");this.chords=s}getHashCode(){let s="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(s+=";"),s+=this.chords[a].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(s.chords[a]))return!1;return!0}}t.$Lq=h;class f{constructor(s,a,e,u,l,g){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.keyLabel=l,this.keyAriaLabel=g}}t.$Mq=f;class d{}t.$Nq=d}),define(be[27],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class D{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=D}),define(be[44],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(_){this.element=_,this.next=D.Undefined,this.prev=D.Undefined}}class O{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let _=this.a;for(;_!==D.Undefined;){const p=_.next;_.prev=D.Undefined,_.next=D.Undefined,_=p}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(_){return this.d(_,!1)}push(_){return this.d(_,!0)}d(_,p){const v=new D(_);if(this.a===D.Undefined)this.a=v,this.b=v;else if(p){const f=this.b;this.b=v,v.prev=f,f.next=v}else{const f=this.a;this.a=v,v.next=f,f.prev=v}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(v))}}shift(){if(this.a!==D.Undefined){const _=this.a.element;return this.e(this.a),_}}pop(){if(this.b!==D.Undefined){const _=this.b.element;return this.e(this.b),_}}e(_){if(_.prev!==D.Undefined&&_.next!==D.Undefined){const p=_.prev;p.next=_.next,_.next.prev=p}else _.prev===D.Undefined&&_.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):_.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):_.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let _=this.a;for(;_!==D.Undefined;)yield _.element,_=_.next}}t.$2c=O}),define(be[31],$e([1,0]),function(re,t){"use strict";var D,O,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function _(n,r,b){let c=n.get(r);return c===void 0&&(c=b,n.set(r,c)),c}t.$xc=_;function p(n){const r=[];return n.forEach((b,c)=>{r.push(`${c} => ${b}`)}),`Map(${n.size}) {${r.join(", ")}}`}t.$yc=p;function v(n){const r=[];return n.forEach(b=>{r.push(b)}),`Set(${n.size}) {${r.join(", ")}}`}t.$zc=v;class h{constructor(r,b){this.uri=r,this.value=b}}function f(n){return Array.isArray(n)}class d{static{this.a=r=>r.toString()}constructor(r,b){if(this[D]="ResourceMap",r instanceof d)this.b=new Map(r.b),this.c=b??d.a;else if(f(r)){this.b=new Map,this.c=b??d.a;for(const[c,o]of r)this.set(c,o)}else this.b=new Map,this.c=r??d.a}set(r,b){return this.b.set(this.c(r),new h(r,b)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,b){typeof b<"u"&&(r=r.bind(b));for(const[c,o]of this.b)r(o.value,o.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$Ac=d;class T{constructor(r,b){this[O]="ResourceSet",!r||typeof r=="function"?this.a=new d(r):(this.a=new d(b),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,b){this.a.forEach((c,o)=>r.call(b,o,o,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=T;var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class a{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,b=0){const c=this.a.get(r);if(c)return b!==0&&this.j(c,b),c.value}set(r,b,c=0){let o=this.a.get(r);if(o)o.value=b,c!==0&&this.j(o,c);else{switch(o={key:r,value:b,next:void 0,previous:void 0},c){case 0:this.h(o);break;case 1:this.g(o);break;case 2:this.h(o);break;default:this.h(o);break}this.a.set(r,o),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const b=this.a.get(r);if(b)return this.a.delete(r),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,b){const c=this.e;let o=this.b;for(;o;){if(b?r.bind(b)(o.value,o.key,this):r(o.value,o.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const r=this,b=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(c){const F={value:c.key,done:!1};return c=c.next,F}else return{value:void 0,done:!0}}};return o}values(){const r=this,b=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(c){const F={value:c.value,done:!1};return c=c.next,F}else return{value:void 0,done:!0}}};return o}entries(){const r=this,b=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(c){const F={value:[c.key,c.value],done:!1};return c=c.next,F}else return{value:void 0,done:!0}}};return o}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let b=this.b,c=this.size;for(;b&&c>r;)this.a.delete(b.key),b=b.next,c--;this.b=b,this.d=c,b&&(b.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const b=r.next,c=r.previous;if(!b||!c)throw new Error("Invalid list");b.previous=c,c.next=b}r.next=void 0,r.previous=void 0,this.e++}j(r,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(r===this.b)return;const c=r.next,o=r.previous;r===this.c?(o.next=void 0,this.c=o):(c.previous=o,o.next=c),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(b===2){if(r===this.c)return;const c=r.next,o=r.previous;r===this.b?(c.previous=void 0,this.b=c):(c.previous=o,o.next=c),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((b,c)=>{r.push([c,b])}),r}fromJSON(r){this.clear();for(const[b,c]of r)this.set(b,c)}}t.$Cc=a;class e extends a{constructor(r,b=1){super(),this.k=r,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,b=2){return super.get(r,b)}peek(r){return super.get(r,0)}set(r,b){return super.set(r,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Dc=e;class u{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let b=this.a.get(r)||0;return b===0?!1:(b--,b===0?this.a.delete(r):this.a.set(r,b),!0)}has(r){return this.a.has(r)}}t.$Ec=u;class l{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[b,c]of r)this.set(b,c)}clear(){this.a.clear(),this.b.clear()}set(r,b){this.a.set(r,b),this.b.set(b,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const b=this.a.get(r);return b===void 0?!1:(this.a.delete(r),this.b.delete(b),!0)}forEach(r,b){this.a.forEach((c,o)=>{r.call(b,c,o,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Fc=l;class g{constructor(){this.a=new Map}add(r,b){let c=this.a.get(r);c||(c=new Set,this.a.set(r,c)),c.add(b)}delete(r,b){const c=this.a.get(r);c&&(c.delete(b),c.size===0&&this.a.delete(r))}forEach(r,b){const c=this.a.get(r);c&&c.forEach(b)}get(r){const b=this.a.get(r);return b||new Set}}t.$Gc=g}),define(be[2],$e([1,0,11,71,31,42,26]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=void 0;const v=!1;let h=null;class f{constructor(){this.b=new Map}static{this.a=0}c(P){let J=this.b.get(P);return J||(J={parent:null,source:null,isSingleton:!1,value:P,idx:f.a++},this.b.set(P,J)),J}trackDisposable(P){const J=this.c(P);J.source||(J.source=new Error().stack)}setParent(P,J){const ee=this.c(P);ee.parent=J}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,J){const ee=J.get(P);if(ee)return ee;const ne=P.parent?this.f(this.c(P.parent),J):P;return J.set(P,ne),ne}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,ee])=>ee.source!==null&&!this.f(ee,P).isSingleton).flatMap(([ee])=>ee)}computeLeakingDisposables(P=10,J){let ee;if(J)ee=J;else{const me=new Map,Se=[...this.b.values()].filter(Pe=>Pe.source!==null&&!this.f(Pe,me).isSingleton);if(Se.length===0)return;const Te=new Set(Se.map(Pe=>Pe.value));if(ee=Se.filter(Pe=>!(Pe.parent&&Te.has(Pe.parent))),ee.length===0)throw new Error("There are cyclic diposable chains!")}if(!ee)return;function ne(me){function Se(Pe,de){for(;Pe.length>0&&de.some(ie=>typeof ie=="string"?ie===Pe[0]:Pe[0].match(ie));)Pe.shift()}const Te=me.source.split(`
`).map(Pe=>Pe.trim().replace("at ","")).filter(Pe=>Pe!=="");return Se(Te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Te.reverse()}const ue=new i.$Gc;for(const me of ee){const Se=ne(me);for(let Te=0;Te<=Se.length;Te++)ue.add(Se.slice(0,Te).join(`
`),me)}ee.sort((0,D.$7b)(me=>me.idx,D.$9b));let le="",oe=0;for(const me of ee.slice(0,P)){oe++;const Se=ne(me),Te=[];for(let Pe=0;Pe<Se.length;Pe++){let de=Se[Pe];de=`(shared with ${ue.get(Se.slice(0,Pe+1).join(`
`)).size}/${ee.length} leaks) at ${de}`;const fe=ue.get(Se.slice(0,Pe).join(`
`)),Y=(0,O.$J)([...fe].map(V=>ne(V)[Pe]),V=>V);delete Y[Se[Pe]];for(const[V,G]of Object.entries(Y))Te.unshift(`    - stacktraces of ${G.length} other leaks continue with ${V}`);Te.unshift(de)}le+=`


==================== Leaking disposable ${oe}/${ee.length}: ${me.value.constructor.name} ====================
${Te.join(`
`)}
============================================================

`}return ee.length>P&&(le+=`


... and ${ee.length-P} more leaking disposables

`),{leaks:ee,details:le}}}t.$Hc=f;function d(L){h=L}if(t.$Ic=d,v){const L="__is_disposable_tracked__";d(new class{trackDisposable(P){const J=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[L]||console.log(J)},3e3)}setParent(P,J){if(P&&P!==o.None)try{P[L]=!0}catch{}}markAsDisposed(P){if(P&&P!==o.None)try{P[L]=!0}catch{}}markAsSingleton(P){}})}function T(L){return h?.trackDisposable(L),L}t.$Jc=T;function s(L){h?.markAsDisposed(L)}t.$Kc=s;function a(L,P){h?.setParent(L,P)}function e(L,P){if(h)for(const J of L)h.setParent(J,P)}function u(L){return h?.markAsSingleton(L),L}t.$Lc=u;function l(L){return typeof L.dispose=="function"&&L.dispose.length===0}t.$Mc=l;function g(L){if(p.Iterable.is(L)){const P=[];for(const J of L)if(J)try{J.dispose()}catch(ee){P.push(ee)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}t.$Nc=g;function n(L){for(const P of L)l(P)&&P.dispose();return[]}t.$Oc=n;function r(...L){const P=b(()=>g(L));return e(L,P),P}t.$Pc=r;function b(L){const P=T({dispose:(0,_.$db)(()=>{s(P),L()})});return P}t.$Qc=b;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,T(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return a(P,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),a(P,null))}}t.$Rc=c;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,T(this),a(this.q,this)}dispose(){s(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}t.$Sc=o;class F{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&a(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&a(P,null),P}}t.$Tc=F;class H{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Uc=H;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(P){let J=P;return this.unset=()=>J=void 0,this.isset=()=>J!==void 0,this.dispose=()=>{J&&(J(),J=void 0,s(this))},this}}t.$Vc=R;class m{constructor(){this.a=new Map}acquire(P,...J){let ee=this.a.get(P);ee||(ee={counter:0,object:this.b(P,...J)},this.a.set(P,ee));const{object:ne}=ee,ue=(0,_.$db)(()=>{--ee.counter===0&&(this.c(P,ee.object),this.a.delete(P))});return ee.counter++,{object:ne,dispose:ue}}}t.$Wc=m;class w{constructor(P){this.a=P}async acquire(P,...J){const ee=this.a.acquire(P,...J);try{return{object:await ee.object,dispose:()=>ee.dispose()}}catch(ne){throw ee.dispose(),ne}}}t.$Xc=w;class j{constructor(P){this.object=P}dispose(){}}t.$Yc=j;function z(L){const P=new c;try{L(P)}finally{P.dispose()}}t.$Zc=z;class q{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,J,ee=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ee||this.a.get(P)?.dispose(),this.a.set(P,J)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$1c=q}),function(re,t){typeof define=="function"&&define.amd?define(be[77],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(re=typeof globalThis<"u"?globalThis:re||self,t(re.marked={}))}(this,function(re){"use strict";function t(A,E){for(var W=0;W<E.length;W++){var S=E[W];S.enumerable=S.enumerable||!1,S.configurable=!0,"value"in S&&(S.writable=!0),Object.defineProperty(A,S.key,S)}}function D(A,E,W){return E&&t(A.prototype,E),W&&t(A,W),Object.defineProperty(A,"prototype",{writable:!1}),A}function O(A,E){if(A){if(typeof A=="string")return i(A,E);var W=Object.prototype.toString.call(A).slice(8,-1);if(W==="Object"&&A.constructor&&(W=A.constructor.name),W==="Map"||W==="Set")return Array.from(A);if(W==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(W))return i(A,E)}}function i(A,E){(E==null||E>A.length)&&(E=A.length);for(var W=0,S=new Array(E);W<E;W++)S[W]=A[W];return S}function _(A,E){var W=typeof Symbol<"u"&&A[Symbol.iterator]||A["@@iterator"];if(W)return(W=W.call(A)).next.bind(W);if(Array.isArray(A)||(W=O(A))||E&&A&&typeof A.length=="number"){W&&(A=W);var S=0;return function(){return S>=A.length?{done:!0}:{done:!1,value:A[S++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function p(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=p();function v(A){re.defaults=A}var h=/[&<>"']/,f=/[&<>"']/g,d=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(E){return s[E]};function e(A,E){if(E){if(h.test(A))return A.replace(f,a)}else if(d.test(A))return A.replace(T,a);return A}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(A){return A.replace(u,function(E,W){return W=W.toLowerCase(),W==="colon"?":":W.charAt(0)==="#"?W.charAt(1)==="x"?String.fromCharCode(parseInt(W.substring(2),16)):String.fromCharCode(+W.substring(1)):""})}var g=/(^|[^\[])\^/g;function n(A,E){A=typeof A=="string"?A:A.source,E=E||"";var W={replace:function(B,y){return y=y.source||y,y=y.replace(g,"$1"),A=A.replace(B,y),W},getRegex:function(){return new RegExp(A,E)}};return W}var r=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(A,E,W){if(A){var S;try{S=decodeURIComponent(l(W)).replace(r,"").toLowerCase()}catch{return null}if(S.indexOf("javascript:")===0||S.indexOf("vbscript:")===0||S.indexOf("data:")===0)return null}E&&!b.test(W)&&(W=m(E,W));try{W=encodeURI(W).replace(/%25/g,"%")}catch{return null}return W}var o={},F=/^[^:]+:\/*[^/]*$/,H=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(A,E){o[" "+A]||(F.test(A)?o[" "+A]=A+"/":o[" "+A]=q(A,"/",!0)),A=o[" "+A];var W=A.indexOf(":")===-1;return E.substring(0,2)==="//"?W?E:A.replace(H,"$1")+E:E.charAt(0)==="/"?W?E:A.replace(R,"$1")+E:A+E}var w={exec:function(){}};function j(A){for(var E=1,W,S;E<arguments.length;E++){W=arguments[E];for(S in W)Object.prototype.hasOwnProperty.call(W,S)&&(A[S]=W[S])}return A}function z(A,E){var W=A.replace(/\|/g,function(y,C,U){for(var K=!1,te=C;--te>=0&&U[te]==="\\";)K=!K;return K?"|":" |"}),S=W.split(/ \|/),B=0;if(S[0].trim()||S.shift(),S.length>0&&!S[S.length-1].trim()&&S.pop(),S.length>E)S.splice(E);else for(;S.length<E;)S.push("");for(;B<S.length;B++)S[B]=S[B].trim().replace(/\\\|/g,"|");return S}function q(A,E,W){var S=A.length;if(S===0)return"";for(var B=0;B<S;){var y=A.charAt(S-B-1);if(y===E&&!W)B++;else if(y!==E&&W)B++;else break}return A.slice(0,S-B)}function L(A,E){if(A.indexOf(E[1])===-1)return-1;for(var W=A.length,S=0,B=0;B<W;B++)if(A[B]==="\\")B++;else if(A[B]===E[0])S++;else if(A[B]===E[1]&&(S--,S<0))return B;return-1}function P(A){A&&A.sanitize&&!A.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function J(A,E){if(E<1)return"";for(var W="";E>1;)E&1&&(W+=A),E>>=1,A+=A;return W+A}function ee(A,E,W,S){var B=E.href,y=E.title?e(E.title):null,C=A[1].replace(/\\([\[\]])/g,"$1");if(A[0].charAt(0)!=="!"){S.state.inLink=!0;var U={type:"link",raw:W,href:B,title:y,text:C,tokens:S.inlineTokens(C)};return S.state.inLink=!1,U}return{type:"image",raw:W,href:B,title:y,text:e(C)}}function ne(A,E){var W=A.match(/^(\s+)(?:```)/);if(W===null)return E;var S=W[1];return E.split(`
`).map(function(B){var y=B.match(/^\s+/);if(y===null)return B;var C=y[0];return C.length>=S.length?B.slice(S.length):B}).join(`
`)}var ue=function(){function A(W){this.options=W||re.defaults}var E=A.prototype;return E.space=function(S){var B=this.rules.block.newline.exec(S);if(B&&B[0].length>0)return{type:"space",raw:B[0]}},E.code=function(S){var B=this.rules.block.code.exec(S);if(B){var y=B[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:B[0],codeBlockStyle:"indented",text:this.options.pedantic?y:q(y,`
`)}}},E.fences=function(S){var B=this.rules.block.fences.exec(S);if(B){var y=B[0],C=ne(y,B[3]||"");return{type:"code",raw:y,lang:B[2]?B[2].trim():B[2],text:C}}},E.heading=function(S){var B=this.rules.block.heading.exec(S);if(B){var y=B[2].trim();if(/#$/.test(y)){var C=q(y,"#");(this.options.pedantic||!C||/ $/.test(C))&&(y=C.trim())}return{type:"heading",raw:B[0],depth:B[1].length,text:y,tokens:this.lexer.inline(y)}}},E.hr=function(S){var B=this.rules.block.hr.exec(S);if(B)return{type:"hr",raw:B[0]}},E.blockquote=function(S){var B=this.rules.block.blockquote.exec(S);if(B){var y=B[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:B[0],tokens:this.lexer.blockTokens(y,[]),text:y}}},E.list=function(S){var B=this.rules.block.list.exec(S);if(B){var y,C,U,K,te,se,ge,we,Ne,Ae,ve,Ie,Oe=B[1].trim(),qe=Oe.length>1,je={type:"list",raw:"",ordered:qe,start:qe?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=qe?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=qe?Oe:"[*+-]");for(var Re=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");S&&(Ie=!1,!(!(B=Re.exec(S))||this.rules.block.hr.test(S)));){if(y=B[0],S=S.substring(y.length),we=B[2].split(`
`,1)[0],Ne=S.split(`
`,1)[0],this.options.pedantic?(K=2,ve=we.trimLeft()):(K=B[2].search(/[^ ]/),K=K>4?1:K,ve=we.slice(K),K+=B[1].length),se=!1,!we&&/^ *$/.test(Ne)&&(y+=Ne+`
`,S=S.substring(Ne.length+1),Ie=!0),!Ie)for(var Ge=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Z=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ae=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),pe=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");S&&(Ae=S.split(`
`,1)[0],we=Ae,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ae.test(we)||pe.test(we)||Ge.test(we)||Z.test(S)));){if(we.search(/[^ ]/)>=K||!we.trim())ve+=`
`+we.slice(K);else if(!se)ve+=`
`+we;else break;!se&&!we.trim()&&(se=!0),y+=Ae+`
`,S=S.substring(Ae.length+1)}je.loose||(ge?je.loose=!0:/\n *\n *$/.test(y)&&(ge=!0)),this.options.gfm&&(C=/^\[[ xX]\] /.exec(ve),C&&(U=C[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:y,task:!!C,checked:U,loose:!1,text:ve}),je.raw+=y}je.items[je.items.length-1].raw=y.trimRight(),je.items[je.items.length-1].text=ve.trimRight(),je.raw=je.raw.trimRight();var De=je.items.length;for(te=0;te<De;te++){this.lexer.state.top=!1,je.items[te].tokens=this.lexer.blockTokens(je.items[te].text,[]);var Ce=je.items[te].tokens.filter(function(ze){return ze.type==="space"}),Me=Ce.every(function(ze){for(var Xe=ze.raw.split(""),Ke=0,Ve=_(Xe),We;!(We=Ve()).done;){var et=We.value;if(et===`
`&&(Ke+=1),Ke>1)return!0}return!1});!je.loose&&Ce.length&&Me&&(je.loose=!0,je.items[te].loose=!0)}return je}},E.html=function(S){var B=this.rules.block.html.exec(S);if(B){var y={type:"html",raw:B[0],pre:!this.options.sanitizer&&(B[1]==="pre"||B[1]==="script"||B[1]==="style"),text:B[0]};if(this.options.sanitize){var C=this.options.sanitizer?this.options.sanitizer(B[0]):e(B[0]);y.type="paragraph",y.text=C,y.tokens=this.lexer.inline(C)}return y}},E.def=function(S){var B=this.rules.block.def.exec(S);if(B){B[3]&&(B[3]=B[3].substring(1,B[3].length-1));var y=B[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:y,raw:B[0],href:B[2],title:B[3]}}},E.table=function(S){var B=this.rules.block.table.exec(S);if(B){var y={type:"table",header:z(B[1]).map(function(ge){return{text:ge}}),align:B[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:B[3]&&B[3].trim()?B[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(y.header.length===y.align.length){y.raw=B[0];var C=y.align.length,U,K,te,se;for(U=0;U<C;U++)/^ *-+: *$/.test(y.align[U])?y.align[U]="right":/^ *:-+: *$/.test(y.align[U])?y.align[U]="center":/^ *:-+ *$/.test(y.align[U])?y.align[U]="left":y.align[U]=null;for(C=y.rows.length,U=0;U<C;U++)y.rows[U]=z(y.rows[U],y.header.length).map(function(ge){return{text:ge}});for(C=y.header.length,K=0;K<C;K++)y.header[K].tokens=this.lexer.inline(y.header[K].text);for(C=y.rows.length,K=0;K<C;K++)for(se=y.rows[K],te=0;te<se.length;te++)se[te].tokens=this.lexer.inline(se[te].text);return y}}},E.lheading=function(S){var B=this.rules.block.lheading.exec(S);if(B)return{type:"heading",raw:B[0],depth:B[2].charAt(0)==="="?1:2,text:B[1],tokens:this.lexer.inline(B[1])}},E.paragraph=function(S){var B=this.rules.block.paragraph.exec(S);if(B){var y=B[1].charAt(B[1].length-1)===`
`?B[1].slice(0,-1):B[1];return{type:"paragraph",raw:B[0],text:y,tokens:this.lexer.inline(y)}}},E.text=function(S){var B=this.rules.block.text.exec(S);if(B)return{type:"text",raw:B[0],text:B[0],tokens:this.lexer.inline(B[0])}},E.escape=function(S){var B=this.rules.inline.escape.exec(S);if(B)return{type:"escape",raw:B[0],text:e(B[1])}},E.tag=function(S){var B=this.rules.inline.tag.exec(S);if(B)return!this.lexer.state.inLink&&/^<a /i.test(B[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(B[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(B[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(B[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:B[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):e(B[0]):B[0]}},E.link=function(S){var B=this.rules.inline.link.exec(S);if(B){var y=B[2].trim();if(!this.options.pedantic&&/^</.test(y)){if(!/>$/.test(y))return;var C=q(y.slice(0,-1),"\\");if((y.length-C.length)%2===0)return}else{var U=L(B[2],"()");if(U>-1){var K=B[0].indexOf("!")===0?5:4,te=K+B[1].length+U;B[2]=B[2].substring(0,U),B[0]=B[0].substring(0,te).trim(),B[3]=""}}var se=B[2],ge="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);we&&(se=we[1],ge=we[3])}else ge=B[3]?B[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(y)?se=se.slice(1):se=se.slice(1,-1)),ee(B,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},B[0],this.lexer)}},E.reflink=function(S,B){var y;if((y=this.rules.inline.reflink.exec(S))||(y=this.rules.inline.nolink.exec(S))){var C=(y[2]||y[1]).replace(/\s+/g," ");if(C=B[C.toLowerCase()],!C||!C.href){var U=y[0].charAt(0);return{type:"text",raw:U,text:U}}return ee(y,C,y[0],this.lexer)}},E.emStrong=function(S,B,y){y===void 0&&(y="");var C=this.rules.inline.emStrong.lDelim.exec(S);if(C&&!(C[3]&&y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=C[1]||C[2]||"";if(!U||U&&(y===""||this.rules.inline.punctuation.exec(y))){var K=C[0].length-1,te,se,ge=K,we=0,Ne=C[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,B=B.slice(-1*S.length+K);(C=Ne.exec(B))!=null;)if(te=C[1]||C[2]||C[3]||C[4]||C[5]||C[6],!!te){if(se=te.length,C[3]||C[4]){ge+=se;continue}else if((C[5]||C[6])&&K%3&&!((K+se)%3)){we+=se;continue}if(ge-=se,!(ge>0)){if(se=Math.min(se,se+ge+we),Math.min(K,se)%2){var Ae=S.slice(1,K+C.index+se);return{type:"em",raw:S.slice(0,K+C.index+se+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var ve=S.slice(2,K+C.index+se-1);return{type:"strong",raw:S.slice(0,K+C.index+se+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},E.codespan=function(S){var B=this.rules.inline.code.exec(S);if(B){var y=B[2].replace(/\n/g," "),C=/[^ ]/.test(y),U=/^ /.test(y)&&/ $/.test(y);return C&&U&&(y=y.substring(1,y.length-1)),y=e(y,!0),{type:"codespan",raw:B[0],text:y}}},E.br=function(S){var B=this.rules.inline.br.exec(S);if(B)return{type:"br",raw:B[0]}},E.del=function(S){var B=this.rules.inline.del.exec(S);if(B)return{type:"del",raw:B[0],text:B[2],tokens:this.lexer.inlineTokens(B[2])}},E.autolink=function(S,B){var y=this.rules.inline.autolink.exec(S);if(y){var C,U;return y[2]==="@"?(C=e(this.options.mangle?B(y[1]):y[1]),U="mailto:"+C):(C=e(y[1]),U=C),{type:"link",raw:y[0],text:C,href:U,tokens:[{type:"text",raw:C,text:C}]}}},E.url=function(S,B){var y;if(y=this.rules.inline.url.exec(S)){var C,U;if(y[2]==="@")C=e(this.options.mangle?B(y[0]):y[0]),U="mailto:"+C;else{var K;do K=y[0],y[0]=this.rules.inline._backpedal.exec(y[0])[0];while(K!==y[0]);C=e(y[0]),y[1]==="www."?U="http://"+C:U=C}return{type:"link",raw:y[0],text:C,href:U,tokens:[{type:"text",raw:C,text:C}]}}},E.inlineText=function(S,B){var y=this.rules.inline.text.exec(S);if(y){var C;return this.lexer.state.inRawBlock?C=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(y[0]):e(y[0]):y[0]:C=e(this.options.smartypants?B(y[0]):y[0]),{type:"text",raw:y[0],text:C}}},A}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:w,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=n(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=n(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=n(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=n(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=n(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=j({},le),le.gfm=j({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=n(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=j({},le.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:w,paragraph:n(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:w,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:w,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=n(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=n(le._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=n(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=n(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=n(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=n(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=n(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=n(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=n(oe.reflink).replace("label",oe._label).replace("ref",le._label).getRegex(),oe.nolink=n(oe.nolink).replace("ref",le._label).getRegex(),oe.reflinkSearch=n(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=j({},oe),oe.pedantic=j({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=j({},oe.normal,{escape:n(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=n(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=j({},oe.gfm,{br:n(oe.br).replace("{2,}","*").getRegex(),text:n(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function me(A){return A.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Se(A){var E="",W,S,B=A.length;for(W=0;W<B;W++)S=A.charCodeAt(W),Math.random()>.5&&(S="x"+S.toString(16)),E+="&#"+S+";";return E}var Te=function(){function A(W){this.tokens=[],this.tokens.links=Object.create(null),this.options=W||re.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var S={block:le.normal,inline:oe.normal};this.options.pedantic?(S.block=le.pedantic,S.inline=oe.pedantic):this.options.gfm&&(S.block=le.gfm,this.options.breaks?S.inline=oe.breaks:S.inline=oe.gfm),this.tokenizer.rules=S}A.lex=function(S,B){var y=new A(B);return y.lex(S)},A.lexInline=function(S,B){var y=new A(B);return y.inlineTokens(S)};var E=A.prototype;return E.lex=function(S){S=S.replace(/\r\n|\r/g,`
`),this.blockTokens(S,this.tokens);for(var B;B=this.inlineQueue.shift();)this.inlineTokens(B.src,B.tokens);return this.tokens},E.blockTokens=function(S,B){var y=this;B===void 0&&(B=[]),this.options.pedantic?S=S.replace(/\t/g,"    ").replace(/^ +$/gm,""):S=S.replace(/^( *)(\t+)/gm,function(ge,we,Ne){return we+"    ".repeat(Ne.length)});for(var C,U,K,te;S;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(C=ge.call({lexer:y},S,B))?(S=S.substring(C.raw.length),B.push(C),!0):!1}))){if(C=this.tokenizer.space(S)){S=S.substring(C.raw.length),C.raw.length===1&&B.length>0?B[B.length-1].raw+=`
`:B.push(C);continue}if(C=this.tokenizer.code(S)){S=S.substring(C.raw.length),U=B[B.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+C.raw,U.text+=`
`+C.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):B.push(C);continue}if(C=this.tokenizer.fences(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.heading(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.hr(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.blockquote(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.list(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.html(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.def(S)){S=S.substring(C.raw.length),U=B[B.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+C.raw,U.text+=`
`+C.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[C.tag]||(this.tokens.links[C.tag]={href:C.href,title:C.title});continue}if(C=this.tokenizer.table(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.lheading(S)){S=S.substring(C.raw.length),B.push(C);continue}if(K=S,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,we=S.slice(1),Ne=void 0;y.options.extensions.startBlock.forEach(function(Ae){Ne=Ae.call({lexer:this},we),typeof Ne=="number"&&Ne>=0&&(ge=Math.min(ge,Ne))}),ge<1/0&&ge>=0&&(K=S.substring(0,ge+1))}(),this.state.top&&(C=this.tokenizer.paragraph(K))){U=B[B.length-1],te&&U.type==="paragraph"?(U.raw+=`
`+C.raw,U.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):B.push(C),te=K.length!==S.length,S=S.substring(C.raw.length);continue}if(C=this.tokenizer.text(S)){S=S.substring(C.raw.length),U=B[B.length-1],U&&U.type==="text"?(U.raw+=`
`+C.raw,U.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):B.push(C);continue}if(S){var se="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,B},E.inline=function(S,B){return B===void 0&&(B=[]),this.inlineQueue.push({src:S,tokens:B}),B},E.inlineTokens=function(S,B){var y=this;B===void 0&&(B=[]);var C,U,K,te=S,se,ge,we;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)Ne.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,se.index)+"["+J("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,se.index)+"["+J("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,se.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;S;)if(ge||(we=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(C=ve.call({lexer:y},S,B))?(S=S.substring(C.raw.length),B.push(C),!0):!1}))){if(C=this.tokenizer.escape(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.tag(S)){S=S.substring(C.raw.length),U=B[B.length-1],U&&C.type==="text"&&U.type==="text"?(U.raw+=C.raw,U.text+=C.text):B.push(C);continue}if(C=this.tokenizer.link(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.reflink(S,this.tokens.links)){S=S.substring(C.raw.length),U=B[B.length-1],U&&C.type==="text"&&U.type==="text"?(U.raw+=C.raw,U.text+=C.text):B.push(C);continue}if(C=this.tokenizer.emStrong(S,te,we)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.codespan(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.br(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.del(S)){S=S.substring(C.raw.length),B.push(C);continue}if(C=this.tokenizer.autolink(S,Se)){S=S.substring(C.raw.length),B.push(C);continue}if(!this.state.inLink&&(C=this.tokenizer.url(S,Se))){S=S.substring(C.raw.length),B.push(C);continue}if(K=S,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ie=S.slice(1),Oe=void 0;y.options.extensions.startInline.forEach(function(qe){Oe=qe.call({lexer:this},Ie),typeof Oe=="number"&&Oe>=0&&(ve=Math.min(ve,Oe))}),ve<1/0&&ve>=0&&(K=S.substring(0,ve+1))}(),C=this.tokenizer.inlineText(K,me)){S=S.substring(C.raw.length),C.raw.slice(-1)!=="_"&&(we=C.raw.slice(-1)),ge=!0,U=B[B.length-1],U&&U.type==="text"?(U.raw+=C.raw,U.text+=C.text):B.push(C);continue}if(S){var Ae="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return B},D(A,null,[{key:"rules",get:function(){return{block:le,inline:oe}}}]),A}(),Pe=function(){function A(W){this.options=W||re.defaults}var E=A.prototype;return E.code=function(S,B,y){var C=(B||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(S,C);U!=null&&U!==S&&(y=!0,S=U)}return S=S.replace(/\n$/,"")+`
`,C?'<pre><code class="'+this.options.langPrefix+e(C,!0)+'">'+(y?S:e(S,!0))+`</code></pre>
`:"<pre><code>"+(y?S:e(S,!0))+`</code></pre>
`},E.blockquote=function(S){return`<blockquote>
`+S+`</blockquote>
`},E.html=function(S){return S},E.heading=function(S,B,y,C){if(this.options.headerIds){var U=this.options.headerPrefix+C.slug(y);return"<h"+B+' id="'+U+'">'+S+"</h"+B+`>
`}return"<h"+B+">"+S+"</h"+B+`>
`},E.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},E.list=function(S,B,y){var C=B?"ol":"ul",U=B&&y!==1?' start="'+y+'"':"";return"<"+C+U+`>
`+S+"</"+C+`>
`},E.listitem=function(S){return"<li>"+S+`</li>
`},E.checkbox=function(S){return"<input "+(S?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},E.paragraph=function(S){return"<p>"+S+`</p>
`},E.table=function(S,B){return B&&(B="<tbody>"+B+"</tbody>"),`<table>
<thead>
`+S+`</thead>
`+B+`</table>
`},E.tablerow=function(S){return`<tr>
`+S+`</tr>
`},E.tablecell=function(S,B){var y=B.header?"th":"td",C=B.align?"<"+y+' align="'+B.align+'">':"<"+y+">";return C+S+("</"+y+`>
`)},E.strong=function(S){return"<strong>"+S+"</strong>"},E.em=function(S){return"<em>"+S+"</em>"},E.codespan=function(S){return"<code>"+S+"</code>"},E.br=function(){return this.options.xhtml?"<br/>":"<br>"},E.del=function(S){return"<del>"+S+"</del>"},E.link=function(S,B,y){if(S=c(this.options.sanitize,this.options.baseUrl,S),S===null)return y;var C='<a href="'+e(S)+'"';return B&&(C+=' title="'+B+'"'),C+=">"+y+"</a>",C},E.image=function(S,B,y){if(S=c(this.options.sanitize,this.options.baseUrl,S),S===null)return y;var C='<img src="'+S+'" alt="'+y+'"';return B&&(C+=' title="'+B+'"'),C+=this.options.xhtml?"/>":">",C},E.text=function(S){return S},A}(),de=function(){function A(){}var E=A.prototype;return E.strong=function(S){return S},E.em=function(S){return S},E.codespan=function(S){return S},E.del=function(S){return S},E.html=function(S){return S},E.text=function(S){return S},E.link=function(S,B,y){return""+y},E.image=function(S,B,y){return""+y},E.br=function(){return""},A}(),ie=function(){function A(){this.seen={}}var E=A.prototype;return E.serialize=function(S){return S.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},E.getNextSafeSlug=function(S,B){var y=S,C=0;if(this.seen.hasOwnProperty(y)){C=this.seen[S];do C++,y=S+"-"+C;while(this.seen.hasOwnProperty(y))}return B||(this.seen[S]=C,this.seen[y]=0),y},E.slug=function(S,B){B===void 0&&(B={});var y=this.serialize(S);return this.getNextSafeSlug(y,B.dryrun)},A}(),fe=function(){function A(W){this.options=W||re.defaults,this.options.renderer=this.options.renderer||new Pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ie}A.parse=function(S,B){var y=new A(B);return y.parse(S)},A.parseInline=function(S,B){var y=new A(B);return y.parseInline(S)};var E=A.prototype;return E.parse=function(S,B){B===void 0&&(B=!0);var y="",C,U,K,te,se,ge,we,Ne,Ae,ve,Ie,Oe,qe,je,Re,Ge,Z,ae,pe,De=S.length;for(C=0;C<De;C++){if(ve=S[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(pe=this.options.extensions.renderers[ve.type].call({parser:this},ve),pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){y+=pe||"";continue}switch(ve.type){case"space":continue;case"hr":{y+=this.renderer.hr();continue}case"heading":{y+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,l(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{y+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ne="",we="",te=ve.header.length,U=0;U<te;U++)we+=this.renderer.tablecell(this.parseInline(ve.header[U].tokens),{header:!0,align:ve.align[U]});for(Ne+=this.renderer.tablerow(we),Ae="",te=ve.rows.length,U=0;U<te;U++){for(ge=ve.rows[U],we="",se=ge.length,K=0;K<se;K++)we+=this.renderer.tablecell(this.parseInline(ge[K].tokens),{header:!1,align:ve.align[K]});Ae+=this.renderer.tablerow(we)}y+=this.renderer.table(Ne,Ae);continue}case"blockquote":{Ae=this.parse(ve.tokens),y+=this.renderer.blockquote(Ae);continue}case"list":{for(Ie=ve.ordered,Oe=ve.start,qe=ve.loose,te=ve.items.length,Ae="",U=0;U<te;U++)Re=ve.items[U],Ge=Re.checked,Z=Re.task,je="",Re.task&&(ae=this.renderer.checkbox(Ge),qe?Re.tokens.length>0&&Re.tokens[0].type==="paragraph"?(Re.tokens[0].text=ae+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=ae+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:ae}):je+=ae),je+=this.parse(Re.tokens,qe),Ae+=this.renderer.listitem(je,Z,Ge);y+=this.renderer.list(Ae,Ie,Oe);continue}case"html":{y+=this.renderer.html(ve.text);continue}case"paragraph":{y+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ae=ve.tokens?this.parseInline(ve.tokens):ve.text;C+1<De&&S[C+1].type==="text";)ve=S[++C],Ae+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);y+=B?this.renderer.paragraph(Ae):Ae;continue}default:{var Ce='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return y},E.parseInline=function(S,B){B=B||this.renderer;var y="",C,U,K,te=S.length;for(C=0;C<te;C++){if(U=S[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(K=this.options.extensions.renderers[U.type].call({parser:this},U),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){y+=K||"";continue}switch(U.type){case"escape":{y+=B.text(U.text);break}case"html":{y+=B.html(U.text);break}case"link":{y+=B.link(U.href,U.title,this.parseInline(U.tokens,B));break}case"image":{y+=B.image(U.href,U.title,U.text);break}case"strong":{y+=B.strong(this.parseInline(U.tokens,B));break}case"em":{y+=B.em(this.parseInline(U.tokens,B));break}case"codespan":{y+=B.codespan(U.text);break}case"br":{y+=B.br();break}case"del":{y+=B.del(this.parseInline(U.tokens,B));break}case"text":{y+=B.text(U.text);break}default:{var se='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return y},A}();function Y(A,E,W){if(typeof A>"u"||A===null)throw new Error("marked(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");if(typeof E=="function"&&(W=E,E=null),E=j({},Y.defaults,E||{}),P(E),W){var S=E.highlight,B;try{B=Te.lex(A,E)}catch(te){return W(te)}var y=function(se){var ge;if(!se)try{E.walkTokens&&Y.walkTokens(B,E.walkTokens),ge=fe.parse(B,E)}catch(we){se=we}return E.highlight=S,se?W(se):W(null,ge)};if(!S||S.length<3||(delete E.highlight,!B.length))return y();var C=0;Y.walkTokens(B,function(te){te.type==="code"&&(C++,setTimeout(function(){S(te.text,te.lang,function(se,ge){if(se)return y(se);ge!=null&&ge!==te.text&&(te.text=ge,te.escaped=!0),C--,C===0&&y()})},0))}),C===0&&y();return}function U(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(te.message+"",!0)+"</pre>";throw te}try{var K=Te.lex(A,E);if(E.walkTokens){if(E.async)return Promise.all(Y.walkTokens(K,E.walkTokens)).then(function(){return fe.parse(K,E)}).catch(U);Y.walkTokens(K,E.walkTokens)}return fe.parse(K,E)}catch(te){U(te)}}Y.options=Y.setOptions=function(A){return j(Y.defaults,A),v(Y.defaults),Y},Y.getDefaults=p,Y.defaults=re.defaults,Y.use=function(){for(var A=arguments.length,E=new Array(A),W=0;W<A;W++)E[W]=arguments[W];var S=j.apply(void 0,[{}].concat(E)),B=Y.defaults.extensions||{renderers:{},childTokens:{}},y;E.forEach(function(C){if(C.extensions&&(y=!0,C.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var te=B.renderers?B.renderers[K.name]:null;te?B.renderers[K.name]=function(){for(var se=arguments.length,ge=new Array(se),we=0;we<se;we++)ge[we]=arguments[we];var Ne=K.renderer.apply(this,ge);return Ne===!1&&(Ne=te.apply(this,ge)),Ne}:B.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");B[K.level]?B[K.level].unshift(K.tokenizer):B[K.level]=[K.tokenizer],K.start&&(K.level==="block"?B.startBlock?B.startBlock.push(K.start):B.startBlock=[K.start]:K.level==="inline"&&(B.startInline?B.startInline.push(K.start):B.startInline=[K.start]))}K.childTokens&&(B.childTokens[K.name]=K.childTokens)})),C.renderer&&function(){var K=Y.defaults.renderer||new Pe,te=function(we){var Ne=K[we];K[we]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Ie=0;Ie<Ae;Ie++)ve[Ie]=arguments[Ie];var Oe=C.renderer[we].apply(K,ve);return Oe===!1&&(Oe=Ne.apply(K,ve)),Oe}};for(var se in C.renderer)te(se);S.renderer=K}(),C.tokenizer&&function(){var K=Y.defaults.tokenizer||new ue,te=function(we){var Ne=K[we];K[we]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Ie=0;Ie<Ae;Ie++)ve[Ie]=arguments[Ie];var Oe=C.tokenizer[we].apply(K,ve);return Oe===!1&&(Oe=Ne.apply(K,ve)),Oe}};for(var se in C.tokenizer)te(se);S.tokenizer=K}(),C.walkTokens){var U=Y.defaults.walkTokens;S.walkTokens=function(K){var te=[];return te.push(C.walkTokens.call(this,K)),U&&(te=te.concat(U.call(this,K))),te}}y&&(S.extensions=B),Y.setOptions(S)})},Y.walkTokens=function(A,E){for(var W=[],S=function(){var U=y.value;switch(W=W.concat(E.call(Y,U)),U.type){case"table":{for(var K=_(U.header),te;!(te=K()).done;){var se=te.value;W=W.concat(Y.walkTokens(se.tokens,E))}for(var ge=_(U.rows),we;!(we=ge()).done;)for(var Ne=we.value,Ae=_(Ne),ve;!(ve=Ae()).done;){var Ie=ve.value;W=W.concat(Y.walkTokens(Ie.tokens,E))}break}case"list":{W=W.concat(Y.walkTokens(U.items,E));break}default:Y.defaults.extensions&&Y.defaults.extensions.childTokens&&Y.defaults.extensions.childTokens[U.type]?Y.defaults.extensions.childTokens[U.type].forEach(function(Oe){W=W.concat(Y.walkTokens(U[Oe],E))}):U.tokens&&(W=W.concat(Y.walkTokens(U.tokens,E)))}},B=_(A),y;!(y=B()).done;)S();return W},Y.parseInline=function(A,E){if(typeof A>"u"||A===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");E=j({},Y.defaults,E||{}),P(E);try{var W=Te.lexInline(A,E);return E.walkTokens&&Y.walkTokens(W,E.walkTokens),fe.parseInline(W,E)}catch(S){if(S.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(S.message+"",!0)+"</pre>";throw S}},Y.Parser=fe,Y.parser=fe.parse,Y.Renderer=Pe,Y.TextRenderer=de,Y.Lexer=Te,Y.lexer=Te.lex,Y.Tokenizer=ue,Y.Slugger=ie,Y.parse=Y;var V=Y.options,G=Y.setOptions,k=Y.use,x=Y.walkTokens,$=Y.parseInline,I=Y,M=fe.parse,N=Te.lex;re.Lexer=Te,re.Parser=fe,re.Renderer=Pe,re.Slugger=ie,re.TextRenderer=de,re.Tokenizer=ue,re.getDefaults=p,re.lexer=N,re.marked=Y,re.options=V,re.parse=I,re.parseInline=$,re.parser=M,re.setOptions=G,re.use=k,re.walkTokens=x,Object.defineProperty(re,"__esModule",{value:!0})}),define(be[78],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PR=void 0;class D{constructor(i,_=0,p=i.length,v=_-1){this.a=i,this.b=_,this.c=p,this.d=v}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$PR=D}),define(be[79],$e([1,0,78]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RR=t.$QR=void 0;class O{constructor(p=[],v=10){this.h(p),this.b=v,this.d()}getHistory(){return this.j}add(p){this.a.delete(p),this.a.add(p),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(p){return this.a.has(p)}clear(){this.h([]),this.d()}d(){this.f();const p=this.j;this.c=new D.$PR(p,0,p.length,p.length)}f(){const p=this.j;p.length>this.b&&this.h(p.slice(p.length-this.b))}g(){const p=this.c.current();return p?this.j.indexOf(p):-1}h(p){this.a=new Set;for(const v of p)this.a.add(v)}get j(){const p=[];return this.a.forEach(v=>p.push(v)),p}}t.$QR=O;class i{get size(){return this.f}constructor(p,v=10){if(this.g=v,p.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:p[0],previous:void 0,next:void 0},this.a=new Set([p[0]]);for(let h=1;h<p.length;h++)this.add(p[h])}add(p){const v={value:p,previous:this.c,next:void 0};for(this.c.next=v,this.c=v,this.d=this.c,this.f++,this.a.has(p)?this.h(p):this.a.add(p);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(p){if(this.c.value===p)return p;const v=this.c.value;return this.a.delete(v),this.c.value=p,this.a.has(p)?this.h(p):this.a.add(p),v}prepend(p){if(this.f===this.g||this.a.has(p))return;const v={value:p,previous:void 0,next:this.b};this.b.previous=v,this.b=v,this.f++,this.a.add(p)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(p){return this.a.has(p)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let p=this.b;for(;p;)yield p.value,p=p.next}h(p){let v=this.b;for(;v!==this.c;)v.value===p&&(v===this.b?(this.b=this.b.next,this.b.previous=void 0):(v.previous.next=v.next,v.next.previous=v.previous),this.f--),v=v.next}}t.$RR=i}),define(be[45],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sl=t.$Rl=t.$Ql=t.rot=t.$Ol=void 0;function D(v,h,f){return Math.min(Math.max(v,h),f)}t.$Ol=D;function O(v,h){return(h+v%h)%h}t.rot=O;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Ql=i;class _{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Rl=_;class p{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const f=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Sl=p}),define(be[46],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var D;(function(O){function i(h,f){if(h.start>=f.end||f.start>=h.end)return{start:0,end:0};const d=Math.max(h.start,f.start),T=Math.min(h.end,f.end);return T-d<=0?{start:0,end:0}:{start:d,end:T}}O.intersect=i;function _(h){return h.end-h.start<=0}O.isEmpty=_;function p(h,f){return!_(i(h,f))}O.intersects=p;function v(h,f){const d=[],T={start:h.start,end:Math.min(f.start,h.end)},s={start:Math.max(f.end,h.start),end:h.end};return _(T)||d.push(T),_(s)||d.push(s),d}O.relativeComplement=v})(D||(t.Range=D={}))}),define(be[80],$e([1,0,46]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IQ=t.$HQ=t.$GQ=t.$FQ=void 0;function O(h,f){const d=[];for(const T of f){if(h.start>=T.range.end)continue;if(h.end<T.range.start)break;const s=D.Range.intersect(h,T.range);D.Range.isEmpty(s)||d.push({range:s,size:T.size})}return d}t.$FQ=O;function i({start:h,end:f},d){return{start:h+d,end:f+d}}t.$GQ=i;function _(h){const f=[];let d=null;for(const T of h){const s=T.range.start,a=T.range.end,e=T.size;if(d&&e===d.size){d.range.end=a;continue}d={range:{start:s,end:a},size:e},f.push(d)}return f}t.$HQ=_;function p(...h){return _(h.reduce((f,d)=>f.concat(d),[]))}class v{get paddingTop(){return this.c}set paddingTop(f){this.b=this.b+f-this.c,this.c=f}constructor(f){this.a=[],this.b=0,this.c=0,this.c=f??0,this.b=this.c}splice(f,d,T=[]){const s=T.length-d,a=O({start:0,end:f},this.a),e=O({start:f+d,end:Number.POSITIVE_INFINITY},this.a).map(l=>({range:i(l.range,s),size:l.size})),u=T.map((l,g)=>({range:{start:f+g,end:f+g+1},size:l.size}));this.a=p(a,u,e),this.b=this.c+this.a.reduce((l,g)=>l+g.size*(g.range.end-g.range.start),0)}get count(){const f=this.a.length;return f?this.a[f-1].range.end:0}get size(){return this.b}indexAt(f){if(f<0)return-1;if(f<this.c)return 0;let d=0,T=this.c;for(const s of this.a){const a=s.range.end-s.range.start,e=T+a*s.size;if(f<e)return d+Math.floor((f-T)/s.size);d+=a,T=e}return d}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let d=0,T=0;for(const s of this.a){const a=s.range.end-s.range.start,e=T+a;if(f<e)return this.c+d+(f-T)*s.size;d+=a*s.size,T=e}return-1}}t.$IQ=v}),define(be[81],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(_){return new O(_)}constructor(_){this.c=D&&_===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Jd=O}),define(be[4],$e([1,0,6,42,2,44,81]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.Event=void 0;const v=!1,h=!1;var f;(function(q){q.None=()=>i.$Sc.None;function L(B){if(h){const{onDidAddListener:y}=B,C=e.create();let U=0;B.onDidAddListener=()=>{++U===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),C.print()),y?.()}}}function P(B,y){return Pe(B,()=>{},0,void 0,!0,void 0,y)}q.defer=P;function J(B){return(y,C=null,U)=>{let K=!1,te;return te=B(se=>{if(!K)return te?te.dispose():K=!0,y.call(C,se)},null,U),K&&te.dispose(),te}}q.once=J;function ee(B,y,C){return Se((U,K=null,te)=>B(se=>U.call(K,y(se)),null,te),C)}q.map=ee;function ne(B,y,C){return Se((U,K=null,te)=>B(se=>{y(se),U.call(K,se)},null,te),C)}q.forEach=ne;function ue(B,y,C){return Se((U,K=null,te)=>B(se=>y(se)&&U.call(K,se),null,te),C)}q.filter=ue;function le(B){return B}q.signal=le;function oe(...B){return(y,C=null,U)=>{const K=(0,i.$Pc)(...B.map(te=>te(se=>y.call(C,se))));return Te(K,U)}}q.any=oe;function me(B,y,C,U){let K=C;return ee(B,te=>(K=y(K,te),K),U)}q.reduce=me;function Se(B,y){let C;const U={onWillAddFirstListener(){C=B(K.fire,K)},onDidRemoveLastListener(){C?.dispose()}};y||L(U);const K=new r(U);return y?.add(K),K.event}function Te(B,y){return y instanceof Array?y.push(B):y&&y.add(B),B}function Pe(B,y,C=100,U=!1,K=!1,te,se){let ge,we,Ne,Ae=0,ve;const Ie={leakWarningThreshold:te,onWillAddFirstListener(){ge=B(qe=>{Ae++,we=y(we,qe),U&&!Ne&&(Oe.fire(we),we=void 0),ve=()=>{const je=we;we=void 0,Ne=void 0,(!U||Ae>1)&&Oe.fire(je),Ae=0},typeof C=="number"?(clearTimeout(Ne),Ne=setTimeout(ve,C)):Ne===void 0&&(Ne=0,queueMicrotask(ve))})},onWillRemoveListener(){K&&Ae>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,ge.dispose()}};se||L(Ie);const Oe=new r(Ie);return se?.add(Oe),Oe.event}q.debounce=Pe;function de(B,y=0,C){return q.debounce(B,(U,K)=>U?(U.push(K),U):[K],y,void 0,!0,void 0,C)}q.accumulate=de;function ie(B,y=(U,K)=>U===K,C){let U=!0,K;return ue(B,te=>{const se=U||!y(te,K);return U=!1,K=te,se},C)}q.latch=ie;function fe(B,y,C){return[q.filter(B,y,C),q.filter(B,U=>!y(U),C)]}q.split=fe;function Y(B,y=!1,C=[],U){let K=C.slice(),te=B(we=>{K?K.push(we):ge.fire(we)});U&&U.add(te);const se=()=>{K?.forEach(we=>ge.fire(we)),K=null},ge=new r({onWillAddFirstListener(){te||(te=B(we=>ge.fire(we)),U&&U.add(te))},onDidAddFirstListener(){K&&(y?setTimeout(se):se())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return U&&U.add(ge),ge.event}q.buffer=Y;function V(B,y){return(U,K,te)=>{const se=y(new k);return B(function(ge){const we=se.evaluate(ge);we!==G&&U.call(K,we)},void 0,te)}}q.chain=V;const G=Symbol("HaltChainable");class k{constructor(){this.f=[]}map(y){return this.f.push(y),this}forEach(y){return this.f.push(C=>(y(C),C)),this}filter(y){return this.f.push(C=>y(C)?C:G),this}reduce(y,C){let U=C;return this.f.push(K=>(U=y(U,K),U)),this}latch(y=(C,U)=>C===U){let C=!0,U;return this.f.push(K=>{const te=C||!y(K,U);return C=!1,U=K,te?K:G}),this}evaluate(y){for(const C of this.f)if(y=C(y),y===G)break;return y}}function x(B,y,C=U=>U){const U=(...ge)=>se.fire(C(...ge)),K=()=>B.on(y,U),te=()=>B.removeListener(y,U),se=new r({onWillAddFirstListener:K,onDidRemoveLastListener:te});return se.event}q.fromNodeEventEmitter=x;function $(B,y,C=U=>U){const U=(...ge)=>se.fire(C(...ge)),K=()=>B.addEventListener(y,U),te=()=>B.removeEventListener(y,U),se=new r({onWillAddFirstListener:K,onDidRemoveLastListener:te});return se.event}q.fromDOMEventEmitter=$;function I(B){return new Promise(y=>J(B)(y))}q.toPromise=I;function M(B){const y=new r;return B.then(C=>{y.fire(C)},()=>{y.fire(void 0)}).finally(()=>{y.dispose()}),y.event}q.fromPromise=M;function N(B,y){return y(void 0),B(C=>y(C))}q.runAndSubscribe=N;function A(B,y){let C=null;function U(te){C?.dispose(),C=new i.$Rc,y(te,C)}U(void 0);const K=B(te=>U(te));return(0,i.$Qc)(()=>{K.dispose(),C?.dispose()})}q.runAndSubscribeWithStore=A;class E{constructor(y,C){this._observable=y,this.f=0,this.g=!1;const U={onWillAddFirstListener:()=>{y.addObserver(this)},onDidRemoveLastListener:()=>{y.removeObserver(this)}};C||L(U),this.emitter=new r(U),C&&C.add(this.emitter)}beginUpdate(y){this.f++}handlePossibleChange(y){}handleChange(y,C){this.g=!0}endUpdate(y){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function W(B,y){return new E(B,y).emitter.event}q.fromObservable=W;function S(B){return y=>{let C=0,U=!1;const K={beginUpdate(){C++},endUpdate(){C--,C===0&&(B.reportChanges(),U&&(U=!1,y()))},handlePossibleChange(){},handleChange(){U=!0}};return B.addObserver(K),B.reportChanges(),{dispose(){B.removeObserver(K)}}}}q.fromObservableLight=S})(f||(t.Event=f={}));class d{static{this.all=new Set}static{this.f=0}constructor(L){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${L}_${d.f++}`,d.all.add(this)}start(L){this.g=new p.$Jd,this.listenerCount=L}stop(){if(this.g){const L=this.g.elapsed();this.durations.push(L),this.elapsedOverall+=L,this.invocationCount+=1,this.g=void 0}}}t.$Ld=d;let T=-1;function s(q){const L=T;return T=q,{dispose(){T=L}}}t.$Md=s;class a{constructor(L,P=Math.random().toString(18).slice(2,5)){this.threshold=L,this.name=P,this.g=0}dispose(){this.f?.clear()}check(L,P){const J=this.threshold;if(J<=0||P<J)return;this.f||(this.f=new Map);const ee=this.f.get(L.value)||0;if(this.f.set(L.value,ee+1),this.g-=1,this.g<=0){this.g=J*.5;let ne,ue=0;for(const[le,oe]of this.f)(!ne||ue<oe)&&(ne=le,ue=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${ue}):`),console.warn(ne)}return()=>{const ne=this.f.get(L.value)||0;this.f.set(L.value,ne-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(L){this.value=L}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class l{constructor(L){this.value=L,this.id=u++}}const g=2,n=(q,L)=>{if(q instanceof l)L(q);else for(let P=0;P<q.length;P++){const J=q[P];J&&L(J)}};class r{constructor(L){this.w=0,this.f=L,this.g=T>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??T):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(v){const L=this.t;queueMicrotask(()=>{n(L,P=>P.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(L,P,J)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Sc.None;if(this.m)return i.$Sc.None;P&&(L=L.bind(P));const ee=new l(L);let ne,ue;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=e.create(),ne=this.g.check(ee.stack,this.w+1)),v&&(ee.stack=ue??e.create()),this.t?this.t instanceof l?(this.u??=new c,this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const le=(0,i.$Qc)(()=>{ne?.(),this.x(ee)});return J instanceof i.$Rc?J.add(le):Array.isArray(J)&&J.push(le),le},this.q}x(L){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const P=this.t,J=P.indexOf(L);if(J===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,P[J]=void 0;const ee=this.u.current===this;if(this.w*g<=P.length){let ne=0;for(let ue=0;ue<P.length;ue++)P[ue]?P[ne++]=P[ue]:ee&&(this.u.end--,ne<this.u.i&&this.u.i--);P.length=ne}}y(L,P){if(!L)return;const J=this.f?.onListenerError||D.$1;if(!J){L.value(P);return}try{L.value(P)}catch(ee){J(ee)}}z(L){const P=L.current.t;for(;L.i<L.end;)this.y(P[L.i++],L.value);L.reset()}fire(L){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,L);else{const P=this.u;P.enqueue(this,L,this.t.length),this.z(P)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Nd=r;const b=()=>new c;t.$Od=b;class c{constructor(){this.i=-1,this.end=0}enqueue(L,P,J){this.i=0,this.end=J,this.current=L,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends r{async fireAsync(L,P,J){if(this.t)for(this.h||(this.h=new _.$2c),n(this.t,ee=>this.h.push([ee.value,L]));this.h.size>0&&!P.isCancellationRequested;){const[ee,ne]=this.h.shift(),ue=[],le={...ne,token:P,waitUntil:oe=>{if(Object.isFrozen(ue))throw new Error("waitUntil can NOT be called asynchronous");J&&(oe=J(oe,ee)),ue.push(oe)}};try{ee(le)}catch(oe){(0,D.$1)(oe);continue}Object.freeze(ue),await Promise.allSettled(ue).then(oe=>{for(const me of oe)me.status==="rejected"&&(0,D.$1)(me.reason)})}}}t.$Pd=o;class F extends r{get isPaused(){return this.h!==0}constructor(L){super(L),this.h=0,this.s=new _.$2c,this.A=L?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const L=Array.from(this.s);this.s.clear(),super.fire(this.A(L))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(L){this.w&&(this.h!==0?this.s.push(L):super.fire(L))}}t.$Qd=F;class H extends F{constructor(L){super(L),this.k=L.delay??100}fire(L){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(L)}}t.$Rd=H;class R extends r{constructor(L){super(L),this.h=[],this.k=L?.merge}fire(L){this.hasListeners()&&(this.h.push(L),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(P=>super.fire(P)),this.h=[]}))}}t.$Sd=R;class m{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(L){const P={event:L,listener:null};this.h.push(P),this.g&&this.m(P);const J=()=>{this.g&&this.o(P);const ee=this.h.indexOf(P);this.h.splice(ee,1)};return(0,i.$Qc)((0,O.$db)(J))}j(){this.g=!0,this.h.forEach(L=>this.m(L))}k(){this.g=!1,this.h.forEach(L=>this.o(L))}m(L){L.listener=L.event(P=>this.f.fire(P))}o(L){L.listener&&L.listener.dispose(),L.listener=null}dispose(){this.f.dispose()}}t.$Td=m;class w{constructor(L,P,J,ee){this.f=new i.$Rc;const ne=this.f.add(new m),ue=this.f.add(new i.$1c);function le(oe){ue.set(oe,ne.add(ee(oe)))}for(const oe of L)le(oe);this.f.add(P(oe=>{le(oe)})),this.f.add(J(oe=>{ue.deleteAndDispose(oe)})),this.event=ne.event}dispose(){this.f.dispose()}}t.$Ud=w;class j{constructor(){this.f=[]}wrapEvent(L){return(P,J,ee)=>L(ne=>{const ue=this.f[this.f.length-1];ue?ue.push(()=>P.call(J,ne)):P.call(J,ne)},void 0,ee)}bufferEvents(L){const P=[];this.f.push(P);const J=L();return this.f.pop(),P.forEach(ee=>ee()),J}}t.$Vd=j;class z{constructor(){this.f=!1,this.g=f.None,this.h=i.$Sc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(L){this.g=L,this.f&&(this.h.dispose(),this.h=L(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Wd=z}),define(be[16],$e([1,0,4,2]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uO=t.$tO=t.$sO=t.$rO=t.$qO=t.$pO=t.$oO=t.$nO=t.$mO=t.$lO=t.$kO=t.$jO=t.$iO=t.$hO=t.$gO=t.$fO=t.$eO=t.$dO=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new D.$Nd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new i}getZoomLevel(){return this.a}setZoomLevel(b){this.a!==b&&(this.a=b)}getZoomFactor(){return this.b}setZoomFactor(b){this.b=b}setFullscreen(b){this.c!==b&&(this.c=b,this.d.fire())}isFullscreen(){return this.c}}class _ extends O.$Sc{constructor(){super(),this.a=this.B(new D.$Nd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(b){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),b&&this.a.fire()}}class p extends O.$Sc{get value(){return this.b}constructor(){super(),this.a=this.B(new D.$Nd),this.onDidChange=this.a.event,this.b=this.c();const b=this.B(new _);this.B(b.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const b=document.createElement("canvas").getContext("2d"),c=window.devicePixelRatio||1,o=b.webkitBackingStorePixelRatio||b.mozBackingStorePixelRatio||b.msBackingStorePixelRatio||b.oBackingStorePixelRatio||b.backingStorePixelRatio||1;return c/o}}class v{constructor(){this.a=null}b(){return this.a||(this.a=(0,O.$Lc)(new p)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function h(r,b){typeof r=="string"&&(r=window.matchMedia(r)),r.addEventListener("change",b)}t.$dO=h,t.$eO=new v;function f(r){i.INSTANCE.setZoomLevel(r)}t.$fO=f;function d(){return i.INSTANCE.getZoomLevel()}t.$gO=d;function T(){return i.INSTANCE.getZoomFactor()}t.$hO=T;function s(r){i.INSTANCE.setZoomFactor(r)}t.$iO=s;function a(r){i.INSTANCE.setFullscreen(r)}t.$jO=a;function e(){return i.INSTANCE.isFullscreen()}t.$kO=e,t.$lO=i.INSTANCE.onDidChangeFullscreen;const u=navigator.userAgent;t.$mO=u.indexOf("Firefox")>=0,t.$nO=u.indexOf("AppleWebKit")>=0,t.$oO=u.indexOf("Chrome")>=0,t.$pO=!t.$oO&&u.indexOf("Safari")>=0,t.$qO=!t.$oO&&!t.$pO&&t.$nO,t.$rO=u.indexOf("Electron/")>=0,t.$sO=u.indexOf("Android")>=0;let l=!1;if(window.matchMedia){const r=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),b=window.matchMedia("(display-mode: fullscreen)");l=r.matches,h(r,({matches:c})=>{l&&b.matches||(l=c)})}function g(){return l}t.$tO=g;function n(){return navigator?.windowControlsOverlay?.visible}t.$uO=n}),define(be[21],$e([1,0,4]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xQ=void 0;class O{get event(){return this.a.event}constructor(_,p,v){const h=f=>this.a.fire(f);this.a=new D.$Nd({onWillAddFirstListener:()=>_.addEventListener(p,h,v),onDidRemoveLastListener:()=>_.removeEventListener(p,h,v)})}dispose(){this.a.dispose()}}t.$xQ=O}),define(be[28],$e([1,0,4]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xd=t.CancellationToken=void 0;const O=Object.freeze(function(v,h){const f=setTimeout(v.bind(h),0);return{dispose(){clearTimeout(f)}}});var i;(function(v){function h(f){return f===v.None||f===v.Cancelled||f instanceof _?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}v.isCancellationToken=h,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(i||(t.CancellationToken=i={}));class _{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new D.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class p{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new _),this.f}cancel(){this.f?this.f instanceof _&&this.f.cancel():this.f=i.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof _&&this.f.dispose():this.f=i.None}}t.$Xd=p}),define(be[82],$e([1,0,28]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.$we=void 0;class O{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new D.$Xd,h=this.b(v.token);return this.a={promise:h,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}t.$we=O;class i{constructor(v){this.c=v,this.a=void 0,this.b=void 0}get(v){const h=JSON.stringify(v);return this.b!==h&&(this.b=h,this.a=this.c(v)),this.a}}t.$xe=i;class _{get cachedValues(){return this.a}constructor(v){this.b=v,this.a=new Map}get(v){if(this.a.has(v))return this.a.get(v);const h=this.b(v);return this.a.set(v,h),h}}t.$ye=_}),define(be[47],$e([1,0,4,2]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yr=t.$Xr=t.$Wr=t.$Vr=t.ScrollbarVisibility=void 0;var i;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class _{constructor(e,u,l,g,n,r,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(u=u|0,l=l|0,g=g|0,n=n|0,r=r|0,b=b|0),this.rawScrollLeft=g,this.rawScrollTop=b,u<0&&(u=0),g+u>l&&(g=l-u),g<0&&(g=0),n<0&&(n=0),b+n>r&&(b=r-n),b<0&&(b=0),this.width=u,this.scrollWidth=l,this.scrollLeft=g,this.height=n,this.scrollHeight=r,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,u){return new _(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,u?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,u?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new _(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,u){const l=this.width!==e.width,g=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,c=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:u,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:g,scrollLeftChanged:n,heightChanged:r,scrollHeightChanged:b,scrollTopChanged:c}}}t.$Vr=_;class p extends O.$Sc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new D.$Nd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new _(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,u){const l=this.g.withScrollDimensions(e,u);this.n(l,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const u=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(u,!1)}setScrollPositionSmooth(e,u){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const l=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let g;u?g=new d(this.h.from,l,this.h.startTime,this.h.duration):g=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=g}else{const l=this.g.withScrollPosition(e);this.h=d.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),u=this.g.withScrollPosition(e);if(this.n(u,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,u){const l=this.g;l.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(l,u)))}}t.$Wr=p;class v{constructor(e,u,l){this.scrollLeft=e,this.scrollTop=u,this.isDone=l}}t.$Xr=v;function h(a,e){const u=e-a;return function(l){return a+u*s(l)}}function f(a,e,u){return function(l){return l<u?a(l/u):e((l-u)/(1-u))}}class d{constructor(e,u,l,g){this.from=e,this.to=u,this.duration=g,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,u,l){if(Math.abs(e-u)>2.5*l){let n,r;return e<u?(n=e+.75*l,r=u-.75*l):(n=e-.75*l,r=u+.75*l),f(h(e,n),h(r,u),.33)}return h(e,u)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const u=(e-this.startTime)/this.duration;if(u<1){const l=this.c(u),g=this.d(u);return new v(l,g,!1)}return new v(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,u,l){return d.start(e,u,l)}static start(e,u,l){l=l+10;const g=Date.now()-10;return new d(e,u,g,l)}}t.$Yr=d;function T(a){return Math.pow(a,3)}function s(a){return 1-T(1-a)}}),define(be[83],$e([1,0,6,2]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=void 0;function i(b){const c=b;return c?typeof c.read=="function":!1}t.$Yd=i;function _(b){const c=b;return c?[c.on,c.pause,c.resume,c.destroy].every(o=>typeof o=="function"):!1}t.$Zd=_;function p(b){const c=b;return c?_(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}t.$1d=p;function v(b,c){return new h(b,c)}t.$2d=v;class h{constructor(c,o){this.e=c,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(o=>o(c))}h(c){this.c.error.length===0?(0,D.$1)(c):this.c.error.slice(0).forEach(o=>o(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,o){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(c,o){if(this.a.destroyed)return;let F;switch(c){case"data":F=this.c.data;break;case"end":F=this.c.end;break;case"error":F=this.c.error;break}if(F){const H=F.indexOf(o);H>=0&&F.splice(H,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(F=>F())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(b,c){const o=[];let F;for(;(F=b.read())!==null;)o.push(F);return c(o)}t.$3d=f;function d(b,c,o){const F=[];let H;for(;(H=b.read())!==null&&F.length<o;)F.push(H);return H===null&&F.length>0?c(F):{read:()=>{if(F.length>0)return F.shift();if(typeof H<"u"){const R=H;return H=void 0,R}return b.read()}}}t.$4d=d;function T(b,c){return new Promise((o,F)=>{const H=[];s(b,{onData:R=>{c&&H.push(R)},onError:R=>{c?F(R):o(void 0)},onEnd:()=>{o(c?c(H):void 0)}})})}t.$5d=T;function s(b,c,o){b.on("error",F=>{o?.isCancellationRequested||c.onError(F)}),b.on("end",()=>{o?.isCancellationRequested||c.onEnd()}),b.on("data",F=>{o?.isCancellationRequested||c.onData(F)})}t.$6d=s;function a(b,c){return new Promise((o,F)=>{const H=new O.$Rc,R=[],m=z=>{if(R.push(z),R.length>c)return H.dispose(),b.pause(),o({stream:b,buffer:R,ended:!1})},w=z=>(H.dispose(),F(z)),j=()=>(H.dispose(),o({stream:b,buffer:R,ended:!0}));H.add((0,O.$Qc)(()=>b.removeListener("error",w))),b.on("error",w),H.add((0,O.$Qc)(()=>b.removeListener("end",j))),b.on("end",j),H.add((0,O.$Qc)(()=>b.removeListener("data",m))),b.on("data",m)})}t.$7d=a;function e(b,c){const o=v(c);return o.end(b),o}t.$8d=e;function u(){const b=v(()=>{throw new Error("not supported")});return b.end(),b}t.$9d=u;function l(b){let c=!1;return{read:()=>c?null:(c=!0,b)}}t.$0d=l;function g(b,c,o){const F=v(o);return s(b,{onData:H=>F.write(c.data(H)),onError:H=>F.error(c.error?c.error(H):H),onEnd:()=>F.end()}),F}t.$$d=g;function n(b,c,o){let F=!1;return{read:()=>{const H=c.read();return F?H:(F=!0,H!==null?o([b,H]):b)}}}t.$_d=n;function r(b,c,o){let F=!1;const H=v(o);return s(c,{onData:R=>F?H.write(R):(F=!0,H.write(o([b,R]))),onError:R=>H.error(R),onEnd:()=>{F||(F=!0,H.write(b)),H.end()}}),H}t.$ae=r}),define(be[32],$e([1,0,27,83]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=void 0;const i=typeof Buffer<"u",_=new D.$V(()=>new Uint8Array(256));let p,v;class h{static alloc(P){return i?new h(Buffer.allocUnsafe(P)):new h(new Uint8Array(P))}static wrap(P){return i&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new h(P)}static fromString(P,J){return!(J?.dontUseNodeBuffer||!1)&&i?new h(Buffer.from(P)):(p||(p=new TextEncoder),new h(p.encode(P)))}static fromByteArray(P){const J=h.alloc(P.length);for(let ee=0,ne=P.length;ee<ne;ee++)J.buffer[ee]=P[ee];return J}static concat(P,J){if(typeof J>"u"){J=0;for(let ue=0,le=P.length;ue<le;ue++)J+=P[ue].byteLength}const ee=h.alloc(J);let ne=0;for(let ue=0,le=P.length;ue<le;ue++){const oe=P[ue];ee.set(oe,ne),ne+=oe.byteLength}return ee}constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}clone(){const P=h.alloc(this.byteLength);return P.set(this),P}toString(){return i?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(P,J){return new h(this.buffer.subarray(P,J))}set(P,J){if(P instanceof h)this.buffer.set(P.buffer,J);else if(P instanceof Uint8Array)this.buffer.set(P,J);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),J);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),J);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return s(this.buffer,P)}writeUInt32BE(P,J){a(this.buffer,P,J)}readUInt32LE(P){return e(this.buffer,P)}writeUInt32LE(P,J){u(this.buffer,P,J)}readUInt8(P){return l(this.buffer,P)}writeUInt8(P,J){g(this.buffer,P,J)}indexOf(P,J=0){return f(this.buffer,P instanceof h?P.buffer:P,J)}}t.$be=h;function f(L,P,J=0){const ee=P.byteLength,ne=L.byteLength;if(ee===0)return 0;if(ee===1)return L.indexOf(P[0]);if(ee>ne-J)return-1;const ue=_.value;ue.fill(P.length);for(let Se=0;Se<P.length;Se++)ue[P[Se]]=P.length-Se-1;let le=J+P.length-1,oe=le,me=-1;for(;le<ne;)if(L[le]===P[oe]){if(oe===0){me=le;break}le--,oe--}else le+=Math.max(P.length-oe,ue[L[le]]),oe=P.length-1;return me}t.$ce=f;function d(L,P){return L[P+0]<<0>>>0|L[P+1]<<8>>>0}t.$de=d;function T(L,P,J){L[J+0]=P&255,P=P>>>8,L[J+1]=P&255}t.$ee=T;function s(L,P){return L[P]*2**24+L[P+1]*2**16+L[P+2]*2**8+L[P+3]}t.$fe=s;function a(L,P,J){L[J+3]=P,P=P>>>8,L[J+2]=P,P=P>>>8,L[J+1]=P,P=P>>>8,L[J]=P}t.$ge=a;function e(L,P){return L[P+0]<<0>>>0|L[P+1]<<8>>>0|L[P+2]<<16>>>0|L[P+3]<<24>>>0}t.$he=e;function u(L,P,J){L[J+0]=P&255,P=P>>>8,L[J+1]=P&255,P=P>>>8,L[J+2]=P&255,P=P>>>8,L[J+3]=P&255}t.$ie=u;function l(L,P){return L[P]}t.$je=l;function g(L,P,J){L[J]=P}t.$ke=g;function n(L){return O.$3d(L,P=>h.concat(P))}t.$le=n;function r(L){return O.$0d(L)}t.$me=r;function b(L){return O.$5d(L,P=>h.concat(P))}t.$ne=b;async function c(L){return L.ended?h.concat(L.buffer):h.concat([...L.buffer,await b(L.stream)])}t.$oe=c;function o(L){return O.$8d(L,P=>h.concat(P))}t.$pe=o;function F(L){return O.$$d(L,{data:P=>typeof P=="string"?h.fromString(P):h.wrap(P)},P=>h.concat(P))}t.$qe=F;function H(L){return O.$2d(P=>h.concat(P),L)}t.$re=H;function R(L,P){return O.$_d(L,P,J=>h.concat(J))}t.$se=R;function m(L,P){return O.$ae(L,P,J=>h.concat(J))}t.$te=m;function w(L){let P=0,J=0,ee=0;const ne=new Uint8Array(Math.floor(L.length/4*3)),ue=oe=>{switch(J){case 3:ne[ee++]=P|oe,J=0;break;case 2:ne[ee++]=P|oe>>>2,P=oe<<6,J=3;break;case 1:ne[ee++]=P|oe>>>4,P=oe<<4,J=2;break;default:P=oe<<2,J=1}};for(let oe=0;oe<L.length;oe++){const me=L.charCodeAt(oe);if(me>=65&&me<=90)ue(me-65);else if(me>=97&&me<=122)ue(me-97+26);else if(me>=48&&me<=57)ue(me-48+52);else if(me===43||me===45)ue(62);else if(me===47||me===95)ue(63);else{if(me===61)break;throw new SyntaxError(`Unexpected base64 character ${L[oe]}`)}}const le=ee;for(;J>0;)ue(0);return h.wrap(ne).slice(0,le)}t.$ue=w;const j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function q({buffer:L},P=!0,J=!1){const ee=J?z:j;let ne="";const ue=L.byteLength%3;let le=0;for(;le<L.byteLength-ue;le+=3){const oe=L[le+0],me=L[le+1],Se=L[le+2];ne+=ee[oe>>>2],ne+=ee[(oe<<4|me>>>4)&63],ne+=ee[(me<<2|Se>>>6)&63],ne+=ee[Se&63]}if(ue===1){const oe=L[le+0];ne+=ee[oe>>>2],ne+=ee[oe<<4&63],P&&(ne+="==")}else if(ue===2){const oe=L[le+0],me=L[le+1];ne+=ee[oe>>>2],ne+=ee[(oe<<4|me>>>4)&63],ne+=ee[me<<2&63],P&&(ne+="=")}return ne}t.$ve=q}),define(be[12],$e([1,0,82,27]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xf=t.$wf=t.$vf=t.$uf=t.GraphemeBreakType=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=void 0;function i(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}t.$Be=i;const _=/{(\d+)}/g;function p(Z,...ae){return ae.length===0?Z:Z.replace(_,function(pe,De){const Ce=parseInt(De,10);return isNaN(Ce)||Ce<0||Ce>=ae.length?pe:ae[Ce]})}t.$Ce=p;const v=/{([^}]+)}/g;function h(Z,ae){return Z.replace(v,(pe,De)=>ae[De]??pe)}t.$De=h;function f(Z){return Z.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}t.$Ee=f;function d(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Fe=d;function T(Z,ae){let pe=0;const De=ae.charCodeAt(0);for(let Ce=Z.length-1;Ce>=0;Ce--)Z.charCodeAt(Ce)===De&&pe++;return pe}t.$Ge=T;function s(Z,ae,pe="\u2026"){return Z.length<=ae?Z:`${Z.substr(0,ae)}${pe}`}t.$He=s;function a(Z,ae=" "){const pe=e(Z,ae);return u(pe,ae)}t.$Ie=a;function e(Z,ae){if(!Z||!ae)return Z;const pe=ae.length;if(pe===0||Z.length===0)return Z;let De=0;for(;Z.indexOf(ae,De)===De;)De=De+pe;return Z.substring(De)}t.$Je=e;function u(Z,ae){if(!Z||!ae)return Z;const pe=ae.length,De=Z.length;if(pe===0||De===0)return Z;let Ce=De,Me=-1;for(;Me=Z.lastIndexOf(ae,Ce-1),!(Me===-1||Me+pe!==Ce);){if(Me===0)return"";Ce=Me}return Z.substring(0,Ce)}t.$Ke=u;function l(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Le=l;function g(Z){return Z.replace(/\*/g,"")}t.$Me=g;function n(Z,ae,pe={}){if(!Z)throw new Error("Cannot create regex from empty string");ae||(Z=d(Z)),pe.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let De="";return pe.global&&(De+="g"),pe.matchCase||(De+="i"),pe.multiline&&(De+="m"),pe.unicode&&(De+="u"),new RegExp(Z,De)}t.$Ne=n;function r(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}t.$Oe=r;function b(Z){return Z.split(/\r\n|\r|\n/)}t.$Pe=b;function c(Z){for(let ae=0,pe=Z.length;ae<pe;ae++){const De=Z.charCodeAt(ae);if(De!==32&&De!==9)return ae}return-1}t.$Qe=c;function o(Z,ae=0,pe=Z.length){for(let De=ae;De<pe;De++){const Ce=Z.charCodeAt(De);if(Ce!==32&&Ce!==9)return Z.substring(ae,De)}return Z.substring(ae,pe)}t.$Re=o;function F(Z,ae=Z.length-1){for(let pe=ae;pe>=0;pe--){const De=Z.charCodeAt(pe);if(De!==32&&De!==9)return pe}return-1}t.$Se=F;function H(Z,ae,pe){const De=[];let Ce=0;for(const Me of Z.matchAll(ae)){if(De.push(Z.slice(Ce,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Ce=Me.index+Me[0].length,De.push(pe(Me[0],...Me.slice(1),Me.index,Z,Me.groups))}return De.push(Z.slice(Ce)),Promise.all(De).then(Me=>Me.join(""))}t.$Te=H;function R(Z,ae){return Z<ae?-1:Z>ae?1:0}t.$Ue=R;function m(Z,ae,pe=0,De=Z.length,Ce=0,Me=ae.length){for(;pe<De&&Ce<Me;pe++,Ce++){const Ke=Z.charCodeAt(pe),Ve=ae.charCodeAt(Ce);if(Ke<Ve)return-1;if(Ke>Ve)return 1}const ze=De-pe,Xe=Me-Ce;return ze<Xe?-1:ze>Xe?1:0}t.$Ve=m;function w(Z,ae){return j(Z,ae,0,Z.length,0,ae.length)}t.$We=w;function j(Z,ae,pe=0,De=Z.length,Ce=0,Me=ae.length){for(;pe<De&&Ce<Me;pe++,Ce++){let Ke=Z.charCodeAt(pe),Ve=ae.charCodeAt(Ce);if(Ke===Ve)continue;if(Ke>=128||Ve>=128)return m(Z.toLowerCase(),ae.toLowerCase(),pe,De,Ce,Me);q(Ke)&&(Ke-=32),q(Ve)&&(Ve-=32);const We=Ke-Ve;if(We!==0)return We}const ze=De-pe,Xe=Me-Ce;return ze<Xe?-1:ze>Xe?1:0}t.$Xe=j;function z(Z){return Z>=48&&Z<=57}t.$Ye=z;function q(Z){return Z>=97&&Z<=122}t.$Ze=q;function L(Z){return Z>=65&&Z<=90}t.$1e=L;function P(Z,ae){return Z.length===ae.length&&j(Z,ae)===0}t.$2e=P;function J(Z,ae){const pe=ae.length;return ae.length>Z.length?!1:j(Z,ae,0,pe)===0}t.$3e=J;function ee(Z,ae){const pe=Math.min(Z.length,ae.length);let De;for(De=0;De<pe;De++)if(Z.charCodeAt(De)!==ae.charCodeAt(De))return De;return pe}t.$4e=ee;function ne(Z,ae){const pe=Math.min(Z.length,ae.length);let De;const Ce=Z.length-1,Me=ae.length-1;for(De=0;De<pe;De++)if(Z.charCodeAt(Ce-De)!==ae.charCodeAt(Me-De))return De;return pe}t.$5e=ne;function ue(Z){return 55296<=Z&&Z<=56319}t.$6e=ue;function le(Z){return 56320<=Z&&Z<=57343}t.$7e=le;function oe(Z,ae){return(Z-55296<<10)+(ae-56320)+65536}t.$8e=oe;function me(Z,ae,pe){const De=Z.charCodeAt(pe);if(ue(De)&&pe+1<ae){const Ce=Z.charCodeAt(pe+1);if(le(Ce))return oe(De,Ce)}return De}t.$9e=me;function Se(Z,ae){const pe=Z.charCodeAt(ae-1);if(le(pe)&&ae>1){const De=Z.charCodeAt(ae-2);if(ue(De))return oe(De,pe)}return pe}class Te{get offset(){return this.e}constructor(ae,pe=0){this.c=ae,this.d=ae.length,this.e=pe}setOffset(ae){this.e=ae}prevCodePoint(){const ae=Se(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=me(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}t.$0e=Te;class Pe{get offset(){return this.c.offset}constructor(ae,pe=0){this.c=new Te(ae,pe)}nextGraphemeLength(){const ae=Ae.getInstance(),pe=this.c,De=pe.offset;let Ce=ae.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Me=pe.offset,ze=ae.getGraphemeBreakType(pe.nextCodePoint());if(we(Ce,ze)){pe.setOffset(Me);break}Ce=ze}return pe.offset-De}prevGraphemeLength(){const ae=Ae.getInstance(),pe=this.c,De=pe.offset;let Ce=ae.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Me=pe.offset,ze=ae.getGraphemeBreakType(pe.prevCodePoint());if(we(ze,Ce)){pe.setOffset(Me);break}Ce=ze}return De-pe.offset}eol(){return this.c.eol()}}t.$$e=Pe;function de(Z,ae){return new Pe(Z,ae).nextGraphemeLength()}t.$_e=de;function ie(Z,ae){return new Pe(Z,ae).prevGraphemeLength()}t.$af=ie;function fe(Z,ae){ae>0&&le(Z.charCodeAt(ae))&&ae--;const pe=ae+de(Z,ae);return[pe-ie(Z,pe),pe]}t.$bf=fe;function Y(Z){const ae=new Pe(Z);let pe=0;for(;!ae.eol();)pe++,ae.nextGraphemeLength();return pe}t.$cf=Y;let V;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function k(Z){return V||(V=G()),V.test(Z)}t.$df=k;const x=/^[\t\n\r\x20-\x7E]*$/;function $(Z){return x.test(Z)}t.$ef=$,t.$ff=/[\u2028\u2029]/;function I(Z){return t.$ff.test(Z)}t.$gf=I;function M(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}t.$hf=M;function N(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}t.$if=N;function A(Z,ae){if(Z.length<ae)return Z;const pe=/\b/g;let De=0;for(;pe.test(Z)&&!(Z.length-pe.lastIndex<ae);)De=pe.lastIndex,pe.lastIndex+=1;return Z.substring(De).replace(/^\s/,"")}t.$jf=A;const E=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,W=/\x1b\].*?\x07/g;function S(Z){return Z&&(Z=Z.replace(E,"").replace(W,"")),Z}t.$kf=S,t.$lf=String.fromCharCode(65279);function B(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}t.$mf=B;function y(Z){return B(Z)?Z.substr(1):Z}t.$nf=y;function C(Z,ae){if(!Z||!ae||Z.length<ae.length)return!1;const pe=ae.length,De=Z.toLowerCase();let Ce=0,Me=-1;for(;Ce<pe;){const ze=De.indexOf(ae[Ce],Me+1);if(ze<0)return!1;Me=ze,Ce++}return!0}t.$of=C;function U(Z,ae=!1){return Z?(ae&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}t.$pf=U;function K(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}t.$qf=K;function te(Z,ae=1){if(ae===0)return"";let pe=-1;do pe=Z.indexOf(`
`,pe+1),ae--;while(ae>0&&pe>=0);return pe===-1?Z:(Z[pe-1]==="\r"&&pe--,Z.substr(0,pe))}t.$rf=te;function se(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}t.$sf=se;function ge(Z){return Ae.getInstance().getGraphemeBreakType(Z)}t.$tf=ge;function we(Z,ae){return Z===0?ae!==5&&ae!==7:Z===2&&ae===3?!1:Z===4||Z===2||Z===3||ae===4||ae===2||ae===3?!0:!(Z===8&&(ae===8||ae===9||ae===11||ae===12)||(Z===11||Z===9)&&(ae===9||ae===10)||(Z===12||Z===10)&&ae===10||ae===5||ae===13||ae===7||Z===1||Z===13&&ae===14||Z===6&&ae===6)}var Ne;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(t.GraphemeBreakType=Ne={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=ve()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const pe=this.d,De=pe.length/3;let Ce=1;for(;Ce<=De;)if(ae<pe[3*Ce])Ce=2*Ce;else if(ae>pe[3*Ce+1])Ce=2*Ce+1;else return pe[3*Ce+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(Z,ae){if(Z===0)return 0;const pe=Oe(Z,ae);if(pe!==void 0)return pe;const De=new Te(ae,Z);return De.prevCodePoint(),De.offset}t.$uf=Ie;function Oe(Z,ae){const pe=new Te(ae,Z);let De=pe.prevCodePoint();for(;qe(De)||De===65039||De===8419;){if(pe.offset===0)return;De=pe.prevCodePoint()}if(!N(De))return;let Ce=pe.offset;return Ce>0&&pe.prevCodePoint()===8205&&(Ce=pe.offset),Ce}function qe(Z){return 127995<=Z&&Z<=127999}var je;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),t.$vf="\xA0";class Re{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$xe(ae=>{function pe(We){const et=new Map;for(let it=0;it<We.length;it+=2)et.set(We[it],We[it+1]);return et}function De(We,et){const it=new Map(We);for(const[ft,ut]of et)it.set(ft,ut);return it}function Ce(We,et){if(!We)return et;const it=new Map;for(const[ft,ut]of We)et.has(ft)&&it.set(ft,ut);return it}const Me=this.c.value;let ze=ae.filter(We=>!We.startsWith("_")&&We in Me);ze.length===0&&(ze=["_default"]);let Xe;for(const We of ze){const et=pe(Me[We]);Xe=Ce(Xe,et)}const Ke=pe(Me._common),Ve=De(Ke,Xe);return new Re(Ve)})}static getInstance(ae){return Re.d.get(Array.from(ae))}static{this.e=new O.$V(()=>Object.keys(Re.c.value).filter(ae=>!ae.startsWith("_")))}static getLocales(){return Re.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$wf=Re;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(ae){return Ge.e().has(ae)}static get codePoints(){return Ge.e()}}t.$xf=Ge}),define(be[33],$e([1,0,31,12]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.FuzzyScore=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Cj=t.or=void 0;function i(...y){return function(C,U){for(let K=0,te=y.length;K<te;K++){const se=y[K](C,U);if(se)return se}return null}}t.or=i,t.$Cj=_.bind(void 0,!1),t.$Dj=_.bind(void 0,!0);function _(y,C,U){if(!U||U.length<C.length)return null;let K;return y?K=O.$3e(U,C):K=U.indexOf(C)===0,K?C.length>0?[{start:0,end:C.length}]:[]:null}function p(y,C){const U=C.toLowerCase().indexOf(y.toLowerCase());return U===-1?null:[{start:U,end:U+y.length}]}t.$Ej=p;function v(y,C){return h(y.toLowerCase(),C.toLowerCase(),0,0)}t.$Fj=v;function h(y,C,U,K){if(U===y.length)return[];if(K===C.length)return null;if(y[U]===C[K]){let te=null;return(te=h(y,C,U+1,K+1))?g({start:K,end:K+1},te):null}return h(y,C,U,K+1)}function f(y){return 97<=y&&y<=122}function d(y){return 65<=y&&y<=90}t.$Gj=d;function T(y){return 48<=y&&y<=57}function s(y){return y===32||y===9||y===10||y===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(y=>a.add(y.charCodeAt(0)));function e(y){return s(y)||a.has(y)}function u(y,C){return y===C||e(y)&&e(C)}function l(y){return f(y)||d(y)||T(y)}function g(y,C){return C.length===0?C=[y]:y.end===C[0].start?C[0].start=y.start:C.unshift(y),C}function n(y,C){for(let U=C;U<y.length;U++){const K=y.charCodeAt(U);if(d(K)||T(K)||U>0&&!l(y.charCodeAt(U-1)))return U}return y.length}function r(y,C,U,K){if(U===y.length)return[];if(K===C.length)return null;if(y[U]!==C[K].toLowerCase())return null;{let te=null,se=K+1;for(te=r(y,C,U+1,K+1);!te&&(se=n(C,se))<C.length;)te=r(y,C,U+1,se),se++;return te===null?null:g({start:K,end:K+1},te)}}function b(y){let C=0,U=0,K=0,te=0,se=0;for(let ve=0;ve<y.length;ve++)se=y.charCodeAt(ve),d(se)&&C++,f(se)&&U++,l(se)&&K++,T(se)&&te++;const ge=C/y.length,we=U/y.length,Ne=K/y.length,Ae=te/y.length;return{upperPercent:ge,lowerPercent:we,alphaPercent:Ne,numericPercent:Ae}}function c(y){const{upperPercent:C,lowerPercent:U}=y;return U===0&&C>.6}function o(y){const{upperPercent:C,lowerPercent:U,alphaPercent:K,numericPercent:te}=y;return U>.2&&C<.8&&K>.6&&te<.2}function F(y){let C=0,U=0,K=0,te=0;for(let se=0;se<y.length;se++)K=y.charCodeAt(se),d(K)&&C++,f(K)&&U++,s(K)&&te++;return(C===0||U===0)&&te===0?y.length<=30:C<=5}function H(y,C){if(!C||(C=C.trim(),C.length===0)||!F(y)||C.length>60)return null;const U=b(C);if(!o(U)){if(!c(U))return null;C=C.toLowerCase()}let K=null,te=0;for(y=y.toLowerCase();te<C.length&&(K=r(y,C,0,te))===null;)te=n(C,te+1);return K}t.$Hj=H;function R(y,C,U=!1){if(!C||C.length===0)return null;let K=null,te=0;for(y=y.toLowerCase(),C=C.toLowerCase();te<C.length&&(K=m(y,C,0,te,U))===null;)te=w(C,te+1);return K}t.$Ij=R;function m(y,C,U,K,te){if(U===y.length)return[];if(K===C.length)return null;if(u(y.charCodeAt(U),C.charCodeAt(K))){let se=null,ge=K+1;if(se=m(y,C,U+1,K+1,te),!te)for(;!se&&(ge=w(C,ge))<C.length;)se=m(y,C,U+1,ge,te),ge++;return se?y.charCodeAt(U)!==C.charCodeAt(K)?se:g({start:K,end:K+1},se):null}else return null}function w(y,C){for(let U=C;U<y.length;U++)if(e(y.charCodeAt(U))||U>0&&e(y.charCodeAt(U-1)))return U;return y.length}const j=i(t.$Dj,H,p),z=i(t.$Dj,H,v),q=new D.$Dc(1e4);function L(y,C,U=!1){if(typeof y!="string"||typeof C!="string")return null;let K=q.get(y);K||(K=new RegExp(O.$Le(y),"i"),q.set(y,K));const te=K.exec(C);return te?[{start:te.index,end:te.index+te[0].length}]:U?z(y,C):j(y,C)}t.$Jj=L;function P(y,C){const U=M(y,y.toLowerCase(),0,C,C.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?ee(U):null}t.$Kj=P;function J(y,C,U,K,te,se){const ge=Math.min(13,y.length);for(;U<ge;U++){const we=M(y,C,U,K,te,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,se]}t.$Lj=J;function ee(y){if(typeof y>"u")return[];const C=[],U=y[1];for(let K=y.length-1;K>1;K--){const te=y[K]+U,se=C[C.length-1];se&&se.end===te?se.end=te+1:C.push({start:te,end:te+1})}return C}t.$Mj=ee;const ne=128;function ue(){const y=[],C=[];for(let U=0;U<=ne;U++)C[U]=0;for(let U=0;U<=ne;U++)y.push(C.slice(0));return y}function le(y){const C=[];for(let U=0;U<=y;U++)C[U]=0;return C}const oe=le(2*ne),me=le(2*ne),Se=ue(),Te=ue(),Pe=ue(),de=!1;function ie(y,C,U,K,te){function se(we,Ne,Ae=" "){for(;we.length<Ne;)we=Ae+we;return we}let ge=` |   |${K.split("").map(we=>se(we,3)).join("|")}
`;for(let we=0;we<=U;we++)we===0?ge+=" |":ge+=`${C[we-1]}|`,ge+=y[we].slice(0,te+1).map(Ne=>se(Ne.toString(),3)).join("|")+`
`;return ge}function fe(y,C,U,K){y=y.substr(C),U=U.substr(K),console.log(ie(Te,y,y.length,U,U.length)),console.log(ie(Pe,y,y.length,U,U.length)),console.log(ie(Se,y,y.length,U,U.length))}function Y(y,C){if(C<0||C>=y.length)return!1;const U=y.codePointAt(C);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$if(U)}}function V(y,C){if(C<0||C>=y.length)return!1;switch(y.charCodeAt(C)){case 32:case 9:return!0;default:return!1}}function G(y,C,U){return C[y]!==U[y]}function k(y,C,U,K,te,se,ge=!1){for(;C<U&&te<se;)y[C]===K[te]&&(ge&&(oe[C]=te),C+=1),te+=1;return C===U}t.$Nj=k;var x;(function(y){y[y.Diag=1]="Diag",y[y.Left=2]="Left",y[y.LeftLeft=3]="LeftLeft"})(x||(x={}));var $;(function(y){y.Default=[-100,0];function C(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}y.isDefault=C})($||(t.FuzzyScore=$={}));class I{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(C,U){this.firstMatchCanBeWeak=C,this.boostFullMatch=U}}t.$Oj=I;function M(y,C,U,K,te,se,ge=I.default){const we=y.length>ne?ne:y.length,Ne=K.length>ne?ne:K.length;if(U>=we||se>=Ne||we-U>Ne-se||!k(C,U,we,te,se,Ne,!0))return;N(we,Ne,U,se,C,te);let Ae=1,ve=1,Ie=U,Oe=se;const qe=[!1];for(Ae=1,Ie=U;Ie<we;Ae++,Ie++){const ae=oe[Ie],pe=me[Ie],De=Ie+1<we?me[Ie+1]:Ne;for(ve=ae-se+1,Oe=ae;Oe<De;ve++,Oe++){let Ce=Number.MIN_SAFE_INTEGER,Me=!1;Oe<=pe&&(Ce=A(y,C,Ie,U,K,te,Oe,Ne,se,Se[Ae-1][ve-1]===0,qe));let ze=0;Ce!==Number.MAX_SAFE_INTEGER&&(Me=!0,ze=Ce+Te[Ae-1][ve-1]);const Xe=Oe>ae,Ke=Xe?Te[Ae][ve-1]+(Se[Ae][ve-1]>0?-5:0):0,Ve=Oe>ae+1&&Se[Ae][ve-1]>0,We=Ve?Te[Ae][ve-2]+(Se[Ae][ve-2]>0?-5:0):0;if(Ve&&(!Xe||We>=Ke)&&(!Me||We>=ze))Te[Ae][ve]=We,Pe[Ae][ve]=3,Se[Ae][ve]=0;else if(Xe&&(!Me||Ke>=ze))Te[Ae][ve]=Ke,Pe[Ae][ve]=2,Se[Ae][ve]=0;else if(Me)Te[Ae][ve]=ze,Pe[Ae][ve]=1,Se[Ae][ve]=Se[Ae-1][ve-1]+1;else throw new Error("not possible")}}if(de&&fe(y,U,K,se),!qe[0]&&!ge.firstMatchCanBeWeak)return;Ae--,ve--;const je=[Te[Ae][ve],se];let Re=0,Ge=0;for(;Ae>=1;){let ae=ve;do{const pe=Pe[Ae][ae];if(pe===3)ae=ae-2;else if(pe===2)ae=ae-1;else break}while(ae>=1);Re>1&&C[U+Ae-1]===te[se+ve-1]&&!G(ae+se-1,K,te)&&Re+1>Se[Ae][ae]&&(ae=ve),ae===ve?Re++:Re=1,Ge||(Ge=ae),Ae--,ve=ae-1,je.push(ve)}Ne===we&&ge.boostFullMatch&&(je[0]+=2);const Z=Ge-we;return je[0]-=Z,je}t.$Pj=M;function N(y,C,U,K,te,se){let ge=y-1,we=C-1;for(;ge>=U&&we>=K;)te[ge]===se[we]&&(me[ge]=we,ge--),we--}function A(y,C,U,K,te,se,ge,we,Ne,Ae,ve){if(C[U]!==se[ge])return Number.MIN_SAFE_INTEGER;let Ie=1,Oe=!1;return ge===U-K?Ie=y[U]===te[ge]?7:5:G(ge,te,se)&&(ge===0||!G(ge-1,te,se))?(Ie=y[U]===te[ge]?7:5,Oe=!0):Y(se,ge)&&(ge===0||!Y(se,ge-1))?Ie=5:(Y(se,ge-1)||V(se,ge-1))&&(Ie=5,Oe=!0),Ie>1&&U===K&&(ve[0]=!0),Oe||(Oe=G(ge,te,se)||Y(se,ge-1)||V(se,ge-1)),U===K?ge>Ne&&(Ie-=Oe?3:5):Ae?Ie+=Oe?2:0:Ie+=Oe?0:1,ge+1===we&&(Ie-=Oe?3:5),Ie}function E(y,C,U,K,te,se,ge){return S(y,C,U,K,te,se,!0,ge)}t.$Qj=E;function W(y,C,U,K,te,se,ge){return S(y,C,U,K,te,se,!1,ge)}t.$Rj=W;function S(y,C,U,K,te,se,ge,we){let Ne=M(y,C,U,K,te,se,we);if(Ne&&!ge)return Ne;if(y.length>=3){const Ae=Math.min(7,y.length-1);for(let ve=U+1;ve<Ae;ve++){const Ie=B(y,ve);if(Ie){const Oe=M(Ie,Ie.toLowerCase(),U,K,te,se,we);Oe&&(Oe[0]-=3,(!Ne||Oe[0]>Ne[0])&&(Ne=Oe))}}}return Ne}function B(y,C){if(C+1>=y.length)return;const U=y[C],K=y[C+1];if(U!==K)return y.slice(0,C)+K+U+y.slice(C+2)}}),define(be[84],$e([1,0,12]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ji=t.$Ii=t.$Hi=t.$Gi=t.$Fi=t.$Ei=t.$Di=void 0;function O(g){return i(g,0)}t.$Di=O;function i(g,n){switch(typeof g){case"object":return g===null?_(349,n):Array.isArray(g)?h(g,n):f(g,n);case"string":return v(g,n);case"boolean":return p(g,n);case"number":return _(g,n);case"undefined":return _(937,n);default:return _(617,n)}}t.$Ei=i;function _(g,n){return(n<<5)-n+g|0}t.$Fi=_;function p(g,n){return _(g?433:863,n)}function v(g,n){n=_(149417,n);for(let r=0,b=g.length;r<b;r++)n=_(g.charCodeAt(r),n);return n}t.$Gi=v;function h(g,n){return n=_(104579,n),g.reduce((r,b)=>i(b,r),n)}function f(g,n){return n=_(181387,n),Object.keys(g).sort().reduce((r,b)=>(r=v(b,r),i(g[b],r)),n)}class d{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$Hi=d;var T;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function s(g,n,r=32){const b=r-n,c=~((1<<b)-1);return(g<<n|(c&g)>>>b)>>>0}function a(g,n=0,r=g.byteLength,b=0){for(let c=0;c<r;c++)g[n+c]=b}function e(g,n,r="0"){for(;g.length<n;)g=r+g;return g}function u(g,n=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((g>>>0).toString(16),n/4)}t.$Ii=u;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const r=n.length;if(r===0)return;const b=this.p;let c=this.r,o=this.u,F,H;for(o!==0?(F=o,H=-1,o=0):(F=n.charCodeAt(0),H=0);;){let R=F;if(D.$6e(F))if(H+1<r){const m=n.charCodeAt(H+1);D.$7e(m)?(H++,R=D.$8e(F,m)):R=65533}else{o=F;break}else D.$7e(F)&&(R=65533);if(c=this.w(b,c,R),H++,H<r)F=n.charCodeAt(H);else break}this.r=c,this.u=o}w(n,r,b){return b<128?n[r++]=b:b<2048?(n[r++]=192|(b&1984)>>>6,n[r++]=128|(b&63)>>>0):b<65536?(n[r++]=224|(b&61440)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0):(n[r++]=240|(b&1835008)>>>18,n[r++]=128|(b&258048)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=l.g,r=this.q;for(let j=0;j<64;j+=4)n.setUint32(j,r.getUint32(j,!1),!1);for(let j=64;j<320;j+=4)n.setUint32(j,s(n.getUint32(j-12,!1)^n.getUint32(j-32,!1)^n.getUint32(j-56,!1)^n.getUint32(j-64,!1),1),!1);let b=this.h,c=this.l,o=this.m,F=this.n,H=this.o,R,m,w;for(let j=0;j<80;j++)j<20?(R=c&o|~c&F,m=1518500249):j<40?(R=c^o^F,m=1859775393):j<60?(R=c&o|c&F|o&F,m=2400959708):(R=c^o^F,m=3395469782),w=s(b,5)+R+H+m+n.getUint32(j*4,!1)&4294967295,H=F,F=o,o=s(c,30),c=b,b=w;this.h=this.h+b&4294967295,this.l=this.l+c&4294967295,this.m=this.m+o&4294967295,this.n=this.n+F&4294967295,this.o=this.o+H&4294967295}}t.$Ji=l}),define(be[85],$e([1,0,73,84]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$As=t.$zs=t.$ys=void 0;class i{constructor(s){this.a=s}getElements(){const s=this.a,a=new Int32Array(s.length);for(let e=0,u=s.length;e<u;e++)a[e]=s.charCodeAt(e);return a}}t.$ys=i;function _(T,s,a){return new d(new i(T),new i(s)).ComputeDiff(a).changes}t.$zs=_;class p{static Assert(s,a){if(!s)throw new Error(a)}}class v{static Copy(s,a,e,u,l){for(let g=0;g<l;g++)e[u+g]=s[a+g]}static Copy2(s,a,e,u,l){for(let g=0;g<l;g++)e[u+g]=s[a+g]}}var h;(function(T){T[T.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(h||(h={}));class f{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new D.$xs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class d{constructor(s,a,e=null){this.a=e,this.b=s,this.c=a;const[u,l,g]=d.o(s),[n,r,b]=d.o(a);this.d=g&&b,this.e=u,this.f=l,this.g=n,this.h=r,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const a=s.getElements();if(d.n(a)){const e=new Int32Array(a.length);for(let u=0,l=a.length;u<l;u++)e[u]=(0,O.$Gi)(a[u],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(s,a){return this.f[s]!==this.h[a]?!1:this.d?this.e[s]===this.g[a]:!0}q(s,a){if(!this.p(s,a))return!1;const e=d.r(this.b,s),u=d.r(this.c,a);return e===u}static r(s,a){return typeof s.getStrictElement=="function"?s.getStrictElement(a):null}s(s,a){return this.f[s]!==this.f[a]?!1:this.d?this.e[s]===this.e[a]:!0}u(s,a){return this.h[s]!==this.h[a]?!1:this.d?this.g[s]===this.g[a]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,a,e,u,l){const g=[!1];let n=this.w(s,a,e,u,g);return l&&(n=this.z(n)),{quitEarly:g[0],changes:n}}w(s,a,e,u,l){for(l[0]=!1;s<=a&&e<=u&&this.p(s,e);)s++,e++;for(;a>=s&&u>=e&&this.p(a,u);)a--,u--;if(s>a||e>u){let o;return e<=u?(p.Assert(s===a+1,"originalStart should only be one more than originalEnd"),o=[new D.$xs(s,0,e,u-e+1)]):s<=a?(p.Assert(e===u+1,"modifiedStart should only be one more than modifiedEnd"),o=[new D.$xs(s,a-s+1,e,0)]):(p.Assert(s===a+1,"originalStart should only be one more than originalEnd"),p.Assert(e===u+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const g=[0],n=[0],r=this.y(s,a,e,u,g,n,l),b=g[0],c=n[0];if(r!==null)return r;if(!l[0]){const o=this.w(s,b,e,c,l);let F=[];return l[0]?F=[new D.$xs(b+1,a-(b+1)+1,c+1,u-(c+1)+1)]:F=this.w(b+1,a,c+1,u,l),this.H(o,F)}return[new D.$xs(s,a-s+1,e,u-e+1)]}x(s,a,e,u,l,g,n,r,b,c,o,F,H,R,m,w,j,z){let q=null,L=null,P=new f,J=a,ee=e,ne=H[0]-w[0]-u,ue=-1073741824,le=this.k.length-1;do{const oe=ne+s;oe===J||oe<ee&&b[oe-1]<b[oe+1]?(o=b[oe+1],R=o-ne-u,o<ue&&P.MarkNextChange(),ue=o,P.AddModifiedElement(o+1,R),ne=oe+1-s):(o=b[oe-1]+1,R=o-ne-u,o<ue&&P.MarkNextChange(),ue=o-1,P.AddOriginalElement(o,R+1),ne=oe-1-s),le>=0&&(b=this.k[le],s=b[0],J=1,ee=b.length-1)}while(--le>=-1);if(q=P.getReverseChanges(),z[0]){let oe=H[0]+1,me=w[0]+1;if(q!==null&&q.length>0){const Se=q[q.length-1];oe=Math.max(oe,Se.getOriginalEnd()),me=Math.max(me,Se.getModifiedEnd())}L=[new D.$xs(oe,F-oe+1,me,m-me+1)]}else{P=new f,J=g,ee=n,ne=H[0]-w[0]-r,ue=1073741824,le=j?this.m.length-1:this.m.length-2;do{const oe=ne+l;oe===J||oe<ee&&c[oe-1]>=c[oe+1]?(o=c[oe+1]-1,R=o-ne-r,o>ue&&P.MarkNextChange(),ue=o+1,P.AddOriginalElement(o+1,R+1),ne=oe+1-l):(o=c[oe-1],R=o-ne-r,o>ue&&P.MarkNextChange(),ue=o,P.AddModifiedElement(o+1,R+1),ne=oe-1-l),le>=0&&(c=this.m[le],l=c[0],J=1,ee=c.length-1)}while(--le>=-1);L=P.getChanges()}return this.H(q,L)}y(s,a,e,u,l,g,n){let r=0,b=0,c=0,o=0,F=0,H=0;s--,e--,l[0]=0,g[0]=0,this.k=[],this.m=[];const R=a-s+(u-e),m=R+1,w=new Int32Array(m),j=new Int32Array(m),z=u-e,q=a-s,L=s-e,P=a-u,ee=(q-z)%2===0;w[z]=s,j[q]=a,n[0]=!1;for(let ne=1;ne<=R/2+1;ne++){let ue=0,le=0;c=this.J(z-ne,ne,z,m),o=this.J(z+ne,ne,z,m);for(let me=c;me<=o;me+=2){me===c||me<o&&w[me-1]<w[me+1]?r=w[me+1]:r=w[me-1]+1,b=r-(me-z)-L;const Se=r;for(;r<a&&b<u&&this.p(r+1,b+1);)r++,b++;if(w[me]=r,r+b>ue+le&&(ue=r,le=b),!ee&&Math.abs(me-q)<=ne-1&&r>=j[me])return l[0]=r,g[0]=b,Se<=j[me]&&1447>0&&ne<=1447+1?this.x(z,c,o,L,q,F,H,P,w,j,r,a,l,b,u,g,ee,n):null}const oe=(ue-s+(le-e)-ne)/2;if(this.a!==null&&!this.a(ue,oe))return n[0]=!0,l[0]=ue,g[0]=le,oe>0&&1447>0&&ne<=1447+1?this.x(z,c,o,L,q,F,H,P,w,j,r,a,l,b,u,g,ee,n):(s++,e++,[new D.$xs(s,a-s+1,e,u-e+1)]);F=this.J(q-ne,ne,q,m),H=this.J(q+ne,ne,q,m);for(let me=F;me<=H;me+=2){me===F||me<H&&j[me-1]>=j[me+1]?r=j[me+1]-1:r=j[me-1],b=r-(me-q)-P;const Se=r;for(;r>s&&b>e&&this.p(r,b);)r--,b--;if(j[me]=r,ee&&Math.abs(me-z)<=ne&&r<=w[me])return l[0]=r,g[0]=b,Se>=w[me]&&1447>0&&ne<=1447+1?this.x(z,c,o,L,q,F,H,P,w,j,r,a,l,b,u,g,ee,n):null}if(ne<=1447){let me=new Int32Array(o-c+2);me[0]=z-c+1,v.Copy2(w,c,me,1,o-c+1),this.k.push(me),me=new Int32Array(H-F+2),me[0]=q-F+1,v.Copy2(j,F,me,1,H-F+1),this.m.push(me)}}return this.x(z,c,o,L,q,F,H,P,w,j,r,a,l,b,u,g,ee,n)}z(s){for(let a=0;a<s.length;a++){const e=s[a],u=a<s.length-1?s[a+1].originalStart:this.f.length,l=a<s.length-1?s[a+1].modifiedStart:this.h.length,g=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<u&&e.modifiedStart+e.modifiedLength<l&&(!g||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const r=[null];if(a<s.length-1&&this.I(s[a],s[a+1],r)){s[a]=r[0],s.splice(a+1,1),a--;continue}}for(let a=s.length-1;a>=0;a--){const e=s[a];let u=0,l=0;if(a>0){const o=s[a-1];u=o.originalStart+o.originalLength,l=o.modifiedStart+o.modifiedLength}const g=e.originalLength>0,n=e.modifiedLength>0;let r=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const F=e.originalStart-o,H=e.modifiedStart-o;if(F<u||H<l||g&&!this.s(F,F+e.originalLength)||n&&!this.u(H,H+e.modifiedLength))break;const m=(F===u&&H===l?5:0)+this.G(F,e.originalLength,H,e.modifiedLength);m>b&&(b=m,r=o)}e.originalStart-=r,e.modifiedStart-=r;const c=[null];if(a>0&&this.I(s[a-1],s[a],c)){s[a-1]=c[0],s.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=s.length;a<e;a++){const u=s[a-1],l=s[a],g=l.originalStart-u.originalStart-u.originalLength,n=u.originalStart,r=l.originalStart+l.originalLength,b=r-n,c=u.modifiedStart,o=l.modifiedStart+l.modifiedLength,F=o-c;if(g<5&&b<20&&F<20){const H=this.A(n,b,c,F,g);if(H){const[R,m]=H;(R!==u.originalStart+u.originalLength||m!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=R-u.originalStart,u.modifiedLength=m-u.modifiedStart,l.originalStart=R+g,l.modifiedStart=m+g,l.originalLength=r-l.originalStart,l.modifiedLength=o-l.modifiedStart)}}}return s}A(s,a,e,u,l){if(a<l||u<l)return null;const g=s+a-l+1,n=e+u-l+1;let r=0,b=0,c=0;for(let o=s;o<g;o++)for(let F=e;F<n;F++){const H=this.B(o,F,l);H>0&&H>r&&(r=H,b=o,c=F)}return r>0?[b,c]:null}B(s,a,e){let u=0;for(let l=0;l<e;l++){if(!this.p(s+l,a+l))return 0;u+=this.e[s+l].length}return u}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,a){if(this.C(s)||this.C(s-1))return!0;if(a>0){const e=s+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,a){if(this.E(s)||this.E(s-1))return!0;if(a>0){const e=s+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,a,e,u){const l=this.D(s,a)?1:0,g=this.F(e,u)?1:0;return l+g}H(s,a){const e=[];if(s.length===0||a.length===0)return a.length>0?a:s;if(this.I(s[s.length-1],a[0],e)){const u=new Array(s.length+a.length-1);return v.Copy(s,0,u,0,s.length-1),u[s.length-1]=e[0],v.Copy(a,1,u,s.length,a.length-1),u}else{const u=new Array(s.length+a.length);return v.Copy(s,0,u,0,s.length),v.Copy(a,0,u,s.length,a.length),u}}I(s,a,e){if(p.Assert(s.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),p.Assert(s.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=a.originalStart||s.modifiedStart+s.modifiedLength>=a.modifiedStart){const u=s.originalStart;let l=s.originalLength;const g=s.modifiedStart;let n=s.modifiedLength;return s.originalStart+s.originalLength>=a.originalStart&&(l=a.originalStart+a.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=a.modifiedStart&&(n=a.modifiedStart+a.modifiedLength-s.modifiedStart),e[0]=new D.$xs(u,l,g,n),!0}else return e[0]=null,!1}J(s,a,e,u){if(s>=0&&s<u)return s;const l=e,g=u-e-1,n=a%2===0;if(s<0){const r=l%2===0;return n===r?0:1}else{const r=g%2===0;return n===r?u-1:u-2}}}t.$As=d}),define(be[48],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0,t.$Kd=Symbol("MicrotaskDelay")}),define(be[86],$e([1,0,11,12]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vh=t.$Uh=t.$Th=t.$Sh=t.$Rh=void 0;class i{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),u=this.b.charCodeAt(this.c);return e-u}value(){return this.b[this.c]}}t.$Rh=i;class _{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,O.$Ve)(a,this.b,0,a.length,this.c,this.d):(0,O.$Xe)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Sh=_;class p{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const u=this.b.charCodeAt(e);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,O.$Ve)(a,this.b,0,a.length,this.d,this.e):(0,O.$Xe)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Th=p;var v;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new p(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,O.$We)(a,this.c.scheme);if(this.d[this.e]===2)return(0,O.$We)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,O.$Ue)(a,this.c.query);if(this.d[this.e]===5)return(0,O.$Ue)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Uh=h;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(d||(d={}));class T{static forUris(a=()=>!1,e=()=>!1){return new T(new h(a,e))}static forPaths(a=!1){return new T(new p(void 0,!a))}static forStrings(){return new T(new i)}static forConfigKeys(){return new T(new _)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const u=e.slice(0);(0,D.$Xb)(u);for(const l of u)this.set(l,a)}else{const u=a.slice(0);(0,D.$Xb)(u);for(const l of u)this.set(l[0],l[1])}}set(a,e){const u=this.b.reset(a);let l;this.c||(this.c=new f,this.c.segment=u.value());const g=[];for(l=this.c;;){const r=u.cmp(l.segment);if(r>0)l.left||(l.left=new f,l.left.segment=u.value()),g.push([-1,l]),l=l.left;else if(r<0)l.right||(l.right=new f,l.right.segment=u.value()),g.push([1,l]),l=l.right;else if(u.hasNext())u.next(),l.mid||(l.mid=new f,l.mid.segment=u.value()),g.push([0,l]),l=l.mid;else break}const n=l.value;l.value=e,l.key=a;for(let r=g.length-1;r>=0;r--){const b=g[r][1];b.updateHeight();const c=b.balanceFactor();if(c<-1||c>1){const o=g[r][0],F=g[r+1][0];if(o===1&&F===1)g[r][1]=b.rotateLeft();else if(o===-1&&F===-1)g[r][1]=b.rotateRight();else if(o===1&&F===-1)b.right=g[r+1][1]=g[r+1][1].rotateRight(),g[r][1]=b.rotateLeft();else if(o===-1&&F===1)b.left=g[r+1][1]=g[r+1][1].rotateLeft(),g[r][1]=b.rotateRight();else throw new Error;if(r>0)switch(g[r-1][0]){case-1:g[r-1][1].left=g[r][1];break;case 1:g[r-1][1].right=g[r][1];break;case 0:g[r-1][1].mid=g[r][1];break}else this.c=g[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let u=this.c;for(;u;){const l=e.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(e.hasNext())e.next(),u=u.mid;else break}return u}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const u=this.b.reset(a),l=[];let g=this.c;for(;g;){const n=u.cmp(g.segment);if(n>0)l.push([-1,g]),g=g.left;else if(n<0)l.push([1,g]),g=g.right;else if(u.hasNext())u.next(),l.push([0,g]),g=g.mid;else break}if(g){if(e?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const n=this.f(g.right);if(n.key){const{key:r,value:b,segment:c}=n;this.e(n.key,!1),g.key=r,g.value=b,g.segment=c}}else{const n=g.left??g.right;if(l.length>0){const[r,b]=l[l.length-1];switch(r){case-1:b.left=n;break;case 0:b.mid=n;break;case 1:b.right=n;break}}else this.c=n}for(let n=l.length-1;n>=0;n--){const r=l[n][1];r.updateHeight();const b=r.balanceFactor();if(b>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),l[n][1]=r.rotateLeft()):b<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),l[n][1]=r.rotateRight()),n>0)switch(l[n-1][0]){case-1:l[n-1][1].left=l[n][1];break;case 1:l[n-1][1].right=l[n][1];break;case 0:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let u=this.c,l;for(;u;){const g=e.cmp(u.segment);if(g>0)u=u.left;else if(g<0)u=u.right;else if(e.hasNext())e.next(),l=u.value||l,u=u.mid;else break}return u&&u.value||l}findSuperstr(a){return this.g(a,!1)}g(a,e){const u=this.b.reset(a);let l=this.c;for(;l;){const g=u.cmp(l.segment);if(g>0)l=l.left;else if(g<0)l=l.right;else if(u.hasNext())u.next(),l=l.mid;else return l.mid?this.h(l.mid):e?l.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,u]of this)a(u,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const u=e.balanceFactor();return u<-1||u>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$Vh=T}),define(be[7],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=void 0;function D(c){return typeof c=="string"}t.$yf=D;function O(c){return Array.isArray(c)&&c.every(o=>D(o))}t.$zf=O;function i(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$Af=i;function _(c){const o=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof o}t.$Bf=_;function p(c){return typeof c=="number"&&!isNaN(c)}t.$Cf=p;function v(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$Df=v;function h(c){return c===!0||c===!1}t.$Ef=h;function f(c){return typeof c>"u"}t.$Ff=f;function d(c){return!T(c)}t.$Gf=d;function T(c){return f(c)||c===null}t.$Hf=T;function s(c,o){if(!c)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.$If=s;function a(c){if(T(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$Jf=a;function e(...c){const o=[];for(let F=0;F<c.length;F++){const H=c[F];if(T(H))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);o.push(H)}return o}t.$Kf=e;const u=Object.prototype.hasOwnProperty;function l(c){if(!i(c))return!1;for(const o in c)if(u.call(c,o))return!1;return!0}t.$Lf=l;function g(c){return typeof c=="function"}t.$Mf=g;function n(...c){return c.length>0&&c.every(g)}t.$Nf=n;function r(c,o){const F=Math.min(c.length,o.length);for(let H=0;H<F;H++)b(c[H],o[H])}t.$Of=r;function b(c,o){if(D(o)){if(typeof c!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(g(o)){try{if(c instanceof o)return}catch{}if(!T(c)&&c.constructor===o||o.length===1&&o.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Pf=b}),define(be[17],$e([1,0,7]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=t.$Tj=t.$Sj=void 0;const O=Object.create(null);function i(v,h){if((0,D.$yf)(h)){const f=O[h];if(f===void 0)throw new Error(`${v} references an unknown codicon: ${h}`);h=f}return O[v]=h,{id:v}}function _(){return O}t.$Sj=_;function p(){return Object.values(t.$Uj)}t.$Tj=p,t.$Uj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(be[49],$e([1,0,7]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fn=t.$en=t.$dn=t.$cn=t.$bn=t.$an=t.$_m=t.$$m=t.$0m=t.$9m=t.$8m=t.$7m=void 0;function O(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const n=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([r,b])=>{n[r]=b&&typeof b=="object"?O(b):b}),n}t.$7m=O;function i(g){if(!g||typeof g!="object")return g;const n=[g];for(;n.length>0;){const r=n.shift();Object.freeze(r);for(const b in r)if(_.call(r,b)){const c=r[b];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.$Bf)(c)&&n.push(c)}}return g}t.$8m=i;const _=Object.prototype.hasOwnProperty;function p(g,n){return v(g,n,new Set)}t.$9m=p;function v(g,n,r){if((0,D.$Hf)(g))return g;const b=n(g);if(typeof b<"u")return b;if(Array.isArray(g)){const c=[];for(const o of g)c.push(v(o,n,r));return c}if((0,D.$Af)(g)){if(r.has(g))throw new Error("Cannot clone recursive data-structure");r.add(g);const c={};for(const o in g)_.call(g,o)&&(c[o]=v(g[o],n,r));return r.delete(g),c}return g}function h(g,n,r=!0){return(0,D.$Af)(g)?((0,D.$Af)(n)&&Object.keys(n).forEach(b=>{b in g?r&&((0,D.$Af)(g[b])&&(0,D.$Af)(n[b])?h(g[b],n[b],r):g[b]=n[b]):g[b]=n[b]}),g):n}t.$0m=h;function f(g,n){if(g===n)return!0;if(g==null||n===null||n===void 0||typeof g!=typeof n||typeof g!="object"||Array.isArray(g)!==Array.isArray(n))return!1;let r,b;if(Array.isArray(g)){if(g.length!==n.length)return!1;for(r=0;r<g.length;r++)if(!f(g[r],n[r]))return!1}else{const c=[];for(b in g)c.push(b);c.sort();const o=[];for(b in n)o.push(b);if(o.sort(),!f(c,o))return!1;for(r=0;r<c.length;r++)if(!f(g[c[r]],n[c[r]]))return!1}return!0}t.$$m=f;function d(g){const n=new Set;return JSON.stringify(g,(r,b)=>{if((0,D.$Af)(b)||Array.isArray(b)){if(n.has(b))return"[Circular]";n.add(b)}return b})}t.$_m=d;function T(g,n){const r=Object.create(null);return!g||!n||Object.keys(n).forEach(c=>{const o=g[c],F=n[c];f(o,F)||(r[c]=F)}),r}t.$an=T;function s(g,n){const r=n.toLowerCase(),b=Object.keys(g).find(c=>c.toLowerCase()===r);return b?g[b]:g[n]}t.$bn=s;function a(g,n){const r=Object.create(null);for(const[b,c]of Object.entries(g))n(b,c)&&(r[b]=c);return r}t.$cn=a;function e(g){let n=[];for(;Object.prototype!==g;)n=n.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return n}t.$dn=e;function u(g){const n=[];for(const r of e(g))typeof g[r]=="function"&&n.push(r);return n}t.$en=u;function l(g,n){const r=c=>function(){const o=Array.prototype.slice.call(arguments,0);return n(c,o)},b={};for(const c of g)b[c]=r(c);return b}t.$fn=l}),define(be[18],$e([1,0,17]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Vj=t.ThemeColor=void 0;var O;(function(p){function v(h){return h&&typeof h=="object"&&typeof h.id=="string"}p.isThemeColor=v})(O||(t.ThemeColor=O={}));function i(p){return{id:p}}t.$Vj=i;var _;(function(p){p.iconNameSegment="[A-Za-z0-9]+",p.iconNameExpression="[A-Za-z0-9-]+",p.iconModifierExpression="~[A-Za-z]+",p.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${p.iconNameExpression})(${p.iconModifierExpression})?$`);function h(n){const r=v.exec(n.id);if(!r)return h(D.$Uj.error);const[,b,c]=r,o=["codicon","codicon-"+b];return c&&o.push("codicon-modifier-"+c.substring(1)),o}p.asClassNameArray=h;function f(n){return h(n).join(" ")}p.asClassName=f;function d(n){return"."+h(n).join(".")}p.asCSSSelector=d;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}p.isThemeIcon=T;const s=new RegExp(`^\\$\\((${p.iconNameExpression}(?:${p.iconModifierExpression})?)\\)$`);function a(n){const r=s.exec(n);if(!r)return;const[,b]=r;return{id:b}}p.fromString=a;function e(n){return{id:n}}p.fromId=e;function u(n,r){let b=n.id;const c=b.lastIndexOf("~");return c!==-1&&(b=b.substring(0,c)),r&&(b=`${b}~${r}`),{id:b}}p.modify=u;function l(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}p.getModifier=l;function g(n,r){return n.id===r.id&&n.color?.id===r.color?.id}p.isEqual=g})(_||(t.ThemeIcon=_={}))}),define(be[34],$e([1,0,33,12,18]),function(re,t,D,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=void 0;const _="$(",p=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${p.source}`,"g");function h(g){return g.replace(v,(n,r)=>r?n:`\\${n}`)}t.$Wj=h;const f=new RegExp(`\\\\${p.source}`,"g");function d(g){return g.replace(f,n=>`\\${n}`)}t.$Xj=d;const T=new RegExp(`(\\s)?(\\\\)?${p.source}(\\s)?`,"g");function s(g){return g.indexOf(_)===-1?g:g.replace(T,(n,r,b,c)=>b?n:r||c||"")}t.$Yj=s;function a(g){return g?g.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}t.$Zj=a;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(g){e.lastIndex=0;let n="";const r=[];let b=0;for(;;){const c=e.lastIndex,o=e.exec(g),F=g.substring(c,o?.index);if(F.length>0){n+=F;for(let H=0;H<F.length;H++)r.push(b)}if(!o)break;b+=o[0].length}return{text:n,iconOffsets:r}}t.$1j=u;function l(g,n,r=!1){const{text:b,iconOffsets:c}=n;if(!c||c.length===0)return(0,D.$Jj)(g,b,r);const o=(0,O.$Je)(b," "),F=b.length-o.length,H=(0,D.$Jj)(g,o,r);if(H)for(const R of H){const m=c[R.start+F]+F;R.start+=m,R.end+=m}return H}t.$2j=l}),define(be[87],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iT=t.$hT=void 0,t.$hT="vscode:contextmenu",t.$iT="vscode:onCloseContextMenu"}),define(be[88],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pT=void 0;class D{constructor(i,_){this.a=i,this.onMessage=_}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$pT=D}),define(be[50],$e([8]),{}),define(be[89],$e([8]),{}),define(be[90],$e([8]),{}),define(be[91],$e([8]),{}),define(be[92],$e([1,0,90,91]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[93],$e([8]),{}),define(be[94],$e([8]),{}),define(be[95],$e([8]),{}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[103],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[104],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[105],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[106],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[107],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[108],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[109],$e([13,10]),function(re,t){return re.create("vs/base/common/actions",t)}),define(be[35],$e([1,0,4,2,109]),function(re,t,D,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zi=t.$yi=t.$xi=t.$wi=t.$vi=t.$ui=void 0;class _ extends O.$Sc{constructor(s,a="",e="",u=!0,l){super(),this.h=this.B(new D.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=a,this.u=e,this.w=u,this.C=l}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,a){this.C&&await this.C(s)}}t.$ui=_;class p extends O.$Sc{constructor(){super(...arguments),this.f=this.B(new D.$Nd),this.onWillRun=this.f.event,this.m=this.B(new D.$Nd),this.onDidRun=this.m.event}async run(s,a){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,a)}catch(u){e=u}this.m.fire({action:s,error:e})}async u(s,a){await s.run(a)}}t.$vi=p;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let a=[];for(const e of s)e.length&&(a.length?a=[...a,new v,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$wi=v;class h{get actions(){return this.a}constructor(s,a,e,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=a,this.class=u,this.a=e}async run(){}}t.$xi=h;class f extends _{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,i.localize(0,null),void 0,!1)}}t.$yi=f;function d(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async(...s)=>T.run(...s),tooltip:T.label}}t.$zi=d}),define(be[110],$e([13,10]),function(re,t){return re.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,110]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$h=t.$g=void 0,t.$g="en";let O=!1,i=!1,_=!1,p=!1,v=!1,h=!1,f=!1,d=!1,T=!1,s=!1,a,e=t.$g,u=t.$g,l,g;t.$h=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof t.$h.vscode<"u"&&typeof t.$h.vscode.process<"u"?n=t.$h.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",b=r&&n?.type==="renderer";if(typeof navigator=="object"&&!b)g=navigator.userAgent,O=g.indexOf("Windows")>=0,i=g.indexOf("Macintosh")>=0,d=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=g.indexOf("Linux")>=0,s=g?.indexOf("Mobi")>=0,h=!0,a=D.getConfiguredDefaultLocale(D.localize(0,null))||t.$g,e=a,u=navigator.language;else if(typeof n=="object"){O=n.platform==="win32",i=n.platform==="darwin",_=n.platform==="linux",p=_&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,f=r,T=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$g,e=t.$g;const z=n.env.VSCODE_NLS_CONFIG;if(z)try{const q=JSON.parse(z),L=q.availableLanguages["*"];a=q.locale,u=q.osLocale,e=L||t.$g,l=q._translationsConfigFile}catch{}v=!0}else console.error("Unable to resolve platform.");var c;(function(z){z[z.Web=0]="Web",z[z.Mac=1]="Mac",z[z.Linux=2]="Linux",z[z.Windows=3]="Windows"})(c||(t.Platform=c={}));function o(z){switch(z){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$i=o;let F=0;i?F=1:O?F=3:_&&(F=2),t.$j=O,t.$k=i,t.$l=_,t.$m=p,t.$n=v,t.$o=f,t.$p=h,t.$q=h&&typeof t.$h.importScripts=="function",t.$r=d,t.$s=s,t.$t=T,t.$u=F,t.$v=g,t.$w=e;var H;(function(z){function q(){return t.$w}z.value=q;function L(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}z.isDefaultVariant=L;function P(){return t.$w==="en"}z.isDefault=P})(H||(t.Language=H={})),t.$x=a,t.$y=u,t.$z=l,t.$A=typeof t.$h.postMessage=="function"&&!t.$h.importScripts,t.$B=(()=>{if(t.$A){const z=[];t.$h.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let P=0,J=z.length;P<J;P++){const ee=z[P];if(ee.id===L.data.vscodeScheduleAsyncWork){z.splice(P,1),ee.callback();return}}});let q=0;return L=>{const P=++q;z.push({id:P,callback:L}),t.$h.postMessage({vscodeScheduleAsyncWork:P},"*")}}return z=>setTimeout(z)})();var R;(function(z){z[z.Windows=1]="Windows",z[z.Macintosh=2]="Macintosh",z[z.Linux=3]="Linux"})(R||(t.OperatingSystem=R={})),t.OS=i||d?2:O?1:3;let m=!0,w=!1;function j(){if(!w){w=!0;const z=new Uint8Array(2);z[0]=1,z[1]=2,m=new Uint16Array(z.buffer)[0]===(2<<8)+1}return m}t.$D=j,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define(be[111],$e([1,0,16,5]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vO=t.KeyboardSupport=void 0;var i;(function(_){_[_.Always=0]="Always",_[_.FullScreen=1]="FullScreen",_[_.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.$vO={clipboard:{writeText:O.$n||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:O.$n||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>O.$n||D.$tO()?0:navigator.keyboard||D.$pO?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,43,76,5]),function(re,t,D,O,i,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DO=t.$CO=t.$BO=void 0;function p(e){if(e.charCode){const l=String.fromCharCode(e.charCode).toUpperCase();return O.KeyCodeUtils.fromString(l)}const u=e.keyCode;if(u===3)return 7;if(D.$mO)switch(u){case 59:return 85;case 60:if(_.$l)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(_.$k)return 57;break}else if(D.$nO){if(_.$k&&u===93)return 57;if(!_.$k&&u===92)return 57}return O.$Bq[u]||0}const v=_.$k?256:2048,h=512,f=1024,d=_.$k?2048:256;function T(e){const u=[];return e.ctrlKey&&u.push("ctrl"),e.shiftKey&&u.push("shift"),e.altKey&&u.push("alt"),e.metaKey&&u.push("meta"),`modifiers: [${u.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$BO=T;function s(e){const u=[];return e.ctrlKey&&u.push("ctrl"),e.shiftKey&&u.push("shift"),e.altKey&&u.push("alt"),e.metaKey&&u.push("meta"),`modifiers: [${u.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${O.KeyCodeUtils.toString(e.keyCode)}')`}t.$CO=s;class a{constructor(u){this._standardKeyboardEventBrand=!0;const l=u;this.browserEvent=l,this.target=l.target,this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,this.altGraphKey=l.getModifierState("AltGraph"),this.keyCode=p(l),this.code=l.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(u){return this.a===u}c(){let u=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(u=this.keyCode);let l=0;return this.ctrlKey&&(l|=v),this.altKey&&(l|=h),this.shiftKey&&(l|=f),this.metaKey&&(l|=d),l|=u,l}d(){let u=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(u=this.keyCode),new i.$Jq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,u)}}t.$DO=a}),define(be[19],$e([1,0,16,67,5]),function(re,t,D,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AO=t.$zO=t.$yO=void 0;class _{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=f.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const d=O.$wO.getPositionOfChildWindowRelativeToAncestorWindow(window,f.view);this.posx-=d.left,this.posy-=d.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$yO=_;class p extends _{constructor(f){super(f),this.dataTransfer=f.dataTransfer}}t.$zO=p;class v{constructor(f,d=0,T=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=T,this.deltaX=d,f){const s=f,a=f;if(typeof s.wheelDeltaY<"u")this.deltaY=s.wheelDeltaY/120;else if(typeof a.VERTICAL_AXIS<"u"&&a.axis===a.VERTICAL_AXIS)this.deltaY=-a.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?D.$mO&&!i.$k?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof s.wheelDeltaX<"u")D.$pO&&i.$j?this.deltaX=-(s.wheelDeltaX/120):this.deltaX=s.wheelDeltaX/120;else if(typeof a.HORIZONTAL_AXIS<"u"&&a.axis===a.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?D.$mO&&!i.$k?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$AO=v}),define(be[112],$e([1,0,5]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let O;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.process<"u"){const i=D.$h.vscode.process;O={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return D.$j?"win32":D.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=O.cwd,t.env=O.env,t.$dc=O.platform,t.$ec=O.arch}),define(be[22],$e([1,0,112]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const O=65,i=97,_=90,p=122,v=46,h=47,f=92,d=58,T=63;class s extends Error{constructor(F,H,R){let m;typeof H=="string"&&H.indexOf("not ")===0?(m="must not be",H=H.replace(/^not /,"")):m="must be";const w=F.indexOf(".")!==-1?"property":"argument";let j=`The "${F}" ${w} ${m} of type ${H}`;j+=`. Received type ${typeof R}`,super(j),this.code="ERR_INVALID_ARG_TYPE"}}function a(o,F){if(o===null||typeof o!="object")throw new s(F,"Object",o)}function e(o,F){if(typeof o!="string")throw new s(F,"string",o)}const u=D.$dc==="win32";function l(o){return o===h||o===f}function g(o){return o===h}function n(o){return o>=O&&o<=_||o>=i&&o<=p}function r(o,F,H,R){let m="",w=0,j=-1,z=0,q=0;for(let L=0;L<=o.length;++L){if(L<o.length)q=o.charCodeAt(L);else{if(R(q))break;q=h}if(R(q)){if(!(j===L-1||z===1))if(z===2){if(m.length<2||w!==2||m.charCodeAt(m.length-1)!==v||m.charCodeAt(m.length-2)!==v){if(m.length>2){const P=m.lastIndexOf(H);P===-1?(m="",w=0):(m=m.slice(0,P),w=m.length-1-m.lastIndexOf(H)),j=L,z=0;continue}else if(m.length!==0){m="",w=0,j=L,z=0;continue}}F&&(m+=m.length>0?`${H}..`:"..",w=2)}else m.length>0?m+=`${H}${o.slice(j+1,L)}`:m=o.slice(j+1,L),w=L-j-1;j=L,z=0}else q===v&&z!==-1?++z:z=-1}return m}function b(o,F){a(F,"pathObject");const H=F.dir||F.root,R=F.base||`${F.name||""}${F.ext||""}`;return H?H===F.root?`${H}${R}`:`${H}${o}${R}`:R}t.$fc={resolve(...o){let F="",H="",R=!1;for(let m=o.length-1;m>=-1;m--){let w;if(m>=0){if(w=o[m],e(w,"path"),w.length===0)continue}else F.length===0?w=D.cwd():(w=D.env[`=${F}`]||D.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==F.toLowerCase()&&w.charCodeAt(2)===f)&&(w=`${F}\\`));const j=w.length;let z=0,q="",L=!1;const P=w.charCodeAt(0);if(j===1)l(P)&&(z=1,L=!0);else if(l(P))if(L=!0,l(w.charCodeAt(1))){let J=2,ee=J;for(;J<j&&!l(w.charCodeAt(J));)J++;if(J<j&&J!==ee){const ne=w.slice(ee,J);for(ee=J;J<j&&l(w.charCodeAt(J));)J++;if(J<j&&J!==ee){for(ee=J;J<j&&!l(w.charCodeAt(J));)J++;(J===j||J!==ee)&&(q=`\\\\${ne}\\${w.slice(ee,J)}`,z=J)}}}else z=1;else n(P)&&w.charCodeAt(1)===d&&(q=w.slice(0,2),z=2,j>2&&l(w.charCodeAt(2))&&(L=!0,z=3));if(q.length>0)if(F.length>0){if(q.toLowerCase()!==F.toLowerCase())continue}else F=q;if(R){if(F.length>0)break}else if(H=`${w.slice(z)}\\${H}`,R=L,L&&F.length>0)break}return H=r(H,!R,"\\",l),R?`${F}\\${H}`:`${F}${H}`||"."},normalize(o){e(o,"path");const F=o.length;if(F===0)return".";let H=0,R,m=!1;const w=o.charCodeAt(0);if(F===1)return g(w)?"\\":o;if(l(w))if(m=!0,l(o.charCodeAt(1))){let z=2,q=z;for(;z<F&&!l(o.charCodeAt(z));)z++;if(z<F&&z!==q){const L=o.slice(q,z);for(q=z;z<F&&l(o.charCodeAt(z));)z++;if(z<F&&z!==q){for(q=z;z<F&&!l(o.charCodeAt(z));)z++;if(z===F)return`\\\\${L}\\${o.slice(q)}\\`;z!==q&&(R=`\\\\${L}\\${o.slice(q,z)}`,H=z)}}}else H=1;else n(w)&&o.charCodeAt(1)===d&&(R=o.slice(0,2),H=2,F>2&&l(o.charCodeAt(2))&&(m=!0,H=3));let j=H<F?r(o.slice(H),!m,"\\",l):"";return j.length===0&&!m&&(j="."),j.length>0&&l(o.charCodeAt(F-1))&&(j+="\\"),R===void 0?m?`\\${j}`:j:m?`${R}\\${j}`:`${R}${j}`},isAbsolute(o){e(o,"path");const F=o.length;if(F===0)return!1;const H=o.charCodeAt(0);return l(H)||F>2&&n(H)&&o.charCodeAt(1)===d&&l(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let F,H;for(let w=0;w<o.length;++w){const j=o[w];e(j,"path"),j.length>0&&(F===void 0?F=H=j:F+=`\\${j}`)}if(F===void 0)return".";let R=!0,m=0;if(typeof H=="string"&&l(H.charCodeAt(0))){++m;const w=H.length;w>1&&l(H.charCodeAt(1))&&(++m,w>2&&(l(H.charCodeAt(2))?++m:R=!1))}if(R){for(;m<F.length&&l(F.charCodeAt(m));)m++;m>=2&&(F=`\\${F.slice(m)}`)}return t.$fc.normalize(F)},relative(o,F){if(e(o,"from"),e(F,"to"),o===F)return"";const H=t.$fc.resolve(o),R=t.$fc.resolve(F);if(H===R||(o=H.toLowerCase(),F=R.toLowerCase(),o===F))return"";let m=0;for(;m<o.length&&o.charCodeAt(m)===f;)m++;let w=o.length;for(;w-1>m&&o.charCodeAt(w-1)===f;)w--;const j=w-m;let z=0;for(;z<F.length&&F.charCodeAt(z)===f;)z++;let q=F.length;for(;q-1>z&&F.charCodeAt(q-1)===f;)q--;const L=q-z,P=j<L?j:L;let J=-1,ee=0;for(;ee<P;ee++){const ue=o.charCodeAt(m+ee);if(ue!==F.charCodeAt(z+ee))break;ue===f&&(J=ee)}if(ee!==P){if(J===-1)return R}else{if(L>P){if(F.charCodeAt(z+ee)===f)return R.slice(z+ee+1);if(ee===2)return R.slice(z+ee)}j>P&&(o.charCodeAt(m+ee)===f?J=ee:ee===2&&(J=3)),J===-1&&(J=0)}let ne="";for(ee=m+J+1;ee<=w;++ee)(ee===w||o.charCodeAt(ee)===f)&&(ne+=ne.length===0?"..":"\\..");return z+=J,ne.length>0?`${ne}${R.slice(z,q)}`:(R.charCodeAt(z)===f&&++z,R.slice(z,q))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const F=t.$fc.resolve(o);if(F.length<=2)return o;if(F.charCodeAt(0)===f){if(F.charCodeAt(1)===f){const H=F.charCodeAt(2);if(H!==T&&H!==v)return`\\\\?\\UNC\\${F.slice(2)}`}}else if(n(F.charCodeAt(0))&&F.charCodeAt(1)===d&&F.charCodeAt(2)===f)return`\\\\?\\${F}`;return o},dirname(o){e(o,"path");const F=o.length;if(F===0)return".";let H=-1,R=0;const m=o.charCodeAt(0);if(F===1)return l(m)?o:".";if(l(m)){if(H=R=1,l(o.charCodeAt(1))){let z=2,q=z;for(;z<F&&!l(o.charCodeAt(z));)z++;if(z<F&&z!==q){for(q=z;z<F&&l(o.charCodeAt(z));)z++;if(z<F&&z!==q){for(q=z;z<F&&!l(o.charCodeAt(z));)z++;if(z===F)return o;z!==q&&(H=R=z+1)}}}}else n(m)&&o.charCodeAt(1)===d&&(H=F>2&&l(o.charCodeAt(2))?3:2,R=H);let w=-1,j=!0;for(let z=F-1;z>=R;--z)if(l(o.charCodeAt(z))){if(!j){w=z;break}}else j=!1;if(w===-1){if(H===-1)return".";w=H}return o.slice(0,w)},basename(o,F){F!==void 0&&e(F,"ext"),e(o,"path");let H=0,R=-1,m=!0,w;if(o.length>=2&&n(o.charCodeAt(0))&&o.charCodeAt(1)===d&&(H=2),F!==void 0&&F.length>0&&F.length<=o.length){if(F===o)return"";let j=F.length-1,z=-1;for(w=o.length-1;w>=H;--w){const q=o.charCodeAt(w);if(l(q)){if(!m){H=w+1;break}}else z===-1&&(m=!1,z=w+1),j>=0&&(q===F.charCodeAt(j)?--j===-1&&(R=w):(j=-1,R=z))}return H===R?R=z:R===-1&&(R=o.length),o.slice(H,R)}for(w=o.length-1;w>=H;--w)if(l(o.charCodeAt(w))){if(!m){H=w+1;break}}else R===-1&&(m=!1,R=w+1);return R===-1?"":o.slice(H,R)},extname(o){e(o,"path");let F=0,H=-1,R=0,m=-1,w=!0,j=0;o.length>=2&&o.charCodeAt(1)===d&&n(o.charCodeAt(0))&&(F=R=2);for(let z=o.length-1;z>=F;--z){const q=o.charCodeAt(z);if(l(q)){if(!w){R=z+1;break}continue}m===-1&&(w=!1,m=z+1),q===v?H===-1?H=z:j!==1&&(j=1):H!==-1&&(j=-1)}return H===-1||m===-1||j===0||j===1&&H===m-1&&H===R+1?"":o.slice(H,m)},format:b.bind(null,"\\"),parse(o){e(o,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return F;const H=o.length;let R=0,m=o.charCodeAt(0);if(H===1)return l(m)?(F.root=F.dir=o,F):(F.base=F.name=o,F);if(l(m)){if(R=1,l(o.charCodeAt(1))){let J=2,ee=J;for(;J<H&&!l(o.charCodeAt(J));)J++;if(J<H&&J!==ee){for(ee=J;J<H&&l(o.charCodeAt(J));)J++;if(J<H&&J!==ee){for(ee=J;J<H&&!l(o.charCodeAt(J));)J++;J===H?R=J:J!==ee&&(R=J+1)}}}}else if(n(m)&&o.charCodeAt(1)===d){if(H<=2)return F.root=F.dir=o,F;if(R=2,l(o.charCodeAt(2))){if(H===3)return F.root=F.dir=o,F;R=3}}R>0&&(F.root=o.slice(0,R));let w=-1,j=R,z=-1,q=!0,L=o.length-1,P=0;for(;L>=R;--L){if(m=o.charCodeAt(L),l(m)){if(!q){j=L+1;break}continue}z===-1&&(q=!1,z=L+1),m===v?w===-1?w=L:P!==1&&(P=1):w!==-1&&(P=-1)}return z!==-1&&(w===-1||P===0||P===1&&w===z-1&&w===j+1?F.base=F.name=o.slice(j,z):(F.name=o.slice(j,w),F.base=o.slice(j,z),F.ext=o.slice(w,z))),j>0&&j!==R?F.dir=o.slice(0,j-1):F.dir=F.root,F},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(u){const o=/\\/g;return()=>{const F=D.cwd().replace(o,"/");return F.slice(F.indexOf("/"))}}return()=>D.cwd()})();t.$gc={resolve(...o){let F="",H=!1;for(let R=o.length-1;R>=-1&&!H;R--){const m=R>=0?o[R]:c();e(m,"path"),m.length!==0&&(F=`${m}/${F}`,H=m.charCodeAt(0)===h)}return F=r(F,!H,"/",g),H?`/${F}`:F.length>0?F:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const F=o.charCodeAt(0)===h,H=o.charCodeAt(o.length-1)===h;return o=r(o,!F,"/",g),o.length===0?F?"/":H?"./":".":(H&&(o+="/"),F?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===h},join(...o){if(o.length===0)return".";let F;for(let H=0;H<o.length;++H){const R=o[H];e(R,"path"),R.length>0&&(F===void 0?F=R:F+=`/${R}`)}return F===void 0?".":t.$gc.normalize(F)},relative(o,F){if(e(o,"from"),e(F,"to"),o===F||(o=t.$gc.resolve(o),F=t.$gc.resolve(F),o===F))return"";const H=1,R=o.length,m=R-H,w=1,j=F.length-w,z=m<j?m:j;let q=-1,L=0;for(;L<z;L++){const J=o.charCodeAt(H+L);if(J!==F.charCodeAt(w+L))break;J===h&&(q=L)}if(L===z)if(j>z){if(F.charCodeAt(w+L)===h)return F.slice(w+L+1);if(L===0)return F.slice(w+L)}else m>z&&(o.charCodeAt(H+L)===h?q=L:L===0&&(q=0));let P="";for(L=H+q+1;L<=R;++L)(L===R||o.charCodeAt(L)===h)&&(P+=P.length===0?"..":"/..");return`${P}${F.slice(w+q)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const F=o.charCodeAt(0)===h;let H=-1,R=!0;for(let m=o.length-1;m>=1;--m)if(o.charCodeAt(m)===h){if(!R){H=m;break}}else R=!1;return H===-1?F?"/":".":F&&H===1?"//":o.slice(0,H)},basename(o,F){F!==void 0&&e(F,"ext"),e(o,"path");let H=0,R=-1,m=!0,w;if(F!==void 0&&F.length>0&&F.length<=o.length){if(F===o)return"";let j=F.length-1,z=-1;for(w=o.length-1;w>=0;--w){const q=o.charCodeAt(w);if(q===h){if(!m){H=w+1;break}}else z===-1&&(m=!1,z=w+1),j>=0&&(q===F.charCodeAt(j)?--j===-1&&(R=w):(j=-1,R=z))}return H===R?R=z:R===-1&&(R=o.length),o.slice(H,R)}for(w=o.length-1;w>=0;--w)if(o.charCodeAt(w)===h){if(!m){H=w+1;break}}else R===-1&&(m=!1,R=w+1);return R===-1?"":o.slice(H,R)},extname(o){e(o,"path");let F=-1,H=0,R=-1,m=!0,w=0;for(let j=o.length-1;j>=0;--j){const z=o.charCodeAt(j);if(z===h){if(!m){H=j+1;break}continue}R===-1&&(m=!1,R=j+1),z===v?F===-1?F=j:w!==1&&(w=1):F!==-1&&(w=-1)}return F===-1||R===-1||w===0||w===1&&F===R-1&&F===H+1?"":o.slice(F,R)},format:b.bind(null,"/"),parse(o){e(o,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return F;const H=o.charCodeAt(0)===h;let R;H?(F.root="/",R=1):R=0;let m=-1,w=0,j=-1,z=!0,q=o.length-1,L=0;for(;q>=R;--q){const P=o.charCodeAt(q);if(P===h){if(!z){w=q+1;break}continue}j===-1&&(z=!1,j=q+1),P===v?m===-1?m=q:L!==1&&(L=1):m!==-1&&(L=-1)}if(j!==-1){const P=w===0&&H?1:w;m===-1||L===0||L===1&&m===j-1&&m===w+1?F.base=F.name=o.slice(P,j):(F.name=o.slice(P,m),F.base=o.slice(P,j),F.ext=o.slice(m,j))}return w>0?F.dir=o.slice(0,w-1):H&&(F.dir="/"),F},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=u?t.$fc.normalize:t.$gc.normalize,t.$ic=u?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=u?t.$fc.join:t.$gc.join,t.$kc=u?t.$fc.resolve:t.$gc.resolve,t.$lc=u?t.$fc.relative:t.$gc.relative,t.$mc=u?t.$fc.dirname:t.$gc.dirname,t.$nc=u?t.$fc.basename:t.$gc.basename,t.$oc=u?t.$fc.extname:t.$gc.extname,t.$pc=u?t.$fc.format:t.$gc.format,t.$qc=u?t.$fc.parse:t.$gc.parse,t.$rc=u?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=u?t.$fc.sep:t.$gc.sep,t.$tc=u?t.$fc.delimiter:t.$gc.delimiter}),define(be[113],$e([1,0,22,5,12,7]),function(re,t,D,O,i,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=void 0;function p(w){return w===47||w===92}t.$Qf=p;function v(w){return w.replace(/[\\/]/g,D.$gc.sep)}t.$Rf=v;function h(w){return w.indexOf("/")===-1&&(w=v(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}t.$Sf=h;function f(w,j=D.$gc.sep){if(!w)return"";const z=w.length,q=w.charCodeAt(0);if(p(q)){if(p(w.charCodeAt(1))&&!p(w.charCodeAt(2))){let P=3;const J=P;for(;P<z&&!p(w.charCodeAt(P));P++);if(J!==P&&!p(w.charCodeAt(P+1))){for(P+=1;P<z;P++)if(p(w.charCodeAt(P)))return w.slice(0,P+1).replace(/[\\/]/g,j)}}return j}else if(g(q)&&w.charCodeAt(1)===58)return p(w.charCodeAt(2))?w.slice(0,2)+j:w.slice(0,2);let L=w.indexOf("://");if(L!==-1){for(L+=3;L<z;L++)if(p(w.charCodeAt(L)))return w.slice(0,L+1)}return""}t.$Tf=f;function d(w){if(!O.$j||!w||w.length<5)return!1;let j=w.charCodeAt(0);if(j!==92||(j=w.charCodeAt(1),j!==92))return!1;let z=2;const q=z;for(;z<w.length&&(j=w.charCodeAt(z),j!==92);z++);return!(q===z||(j=w.charCodeAt(z+1),isNaN(j)||j===92))}t.$Uf=d;const T=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(w,j=O.$j){const z=j?T:s;return!(!w||w.length===0||/^\s+$/.test(w)||(z.lastIndex=0,z.test(w))||j&&a.test(w)||w==="."||w===".."||j&&w[w.length-1]==="."||j&&w.length!==w.trim().length||w.length>255)}t.$Vf=e;function u(w,j,z){const q=w===j;return!z||q?q:!w||!j?!1:(0,i.$2e)(w,j)}t.$Wf=u;function l(w,j,z,q=D.sep){if(w===j)return!0;if(!w||!j||j.length>w.length)return!1;if(z){if(!(0,i.$3e)(w,j))return!1;if(j.length===w.length)return!0;let P=j.length;return j.charAt(j.length-1)===q&&P--,w.charAt(P)===q}return j.charAt(j.length-1)!==q&&(j+=q),w.indexOf(j)===0}t.$Xf=l;function g(w){return w>=65&&w<=90||w>=97&&w<=122}t.$Yf=g;function n(w,j){return O.$j&&w.endsWith(":")&&(w+=D.sep),(0,D.$ic)(w)||(w=(0,D.$jc)(j,w)),w=(0,D.$hc)(w),O.$j?(w=(0,i.$Ke)(w,D.sep),w.endsWith(":")&&(w+=D.sep)):(w=(0,i.$Ke)(w,D.sep),w||(w=D.sep)),w}t.$Zf=n;function r(w){const j=(0,D.$hc)(w);return O.$j?w.length>3?!1:b(j)&&(w.length===2||j.charCodeAt(2)===92):j===D.$gc.sep}t.$1f=r;function b(w,j=O.$j){return j?g(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}t.$2f=b;function c(w,j=O.$j){return b(w,j)?w[0]:void 0}t.$3f=c;function o(w,j,z){return j.length>w.length?-1:w===j?0:(z&&(w=w.toLowerCase(),j=j.toLowerCase()),w.indexOf(j))}t.$4f=o;function F(w){const j=w.split(":");let z,q,L;for(const P of j){const J=Number(P);(0,_.$Cf)(J)?q===void 0?q=J:L===void 0&&(L=J):z=z?[z,P].join(":"):P}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:q!==void 0?q:void 0,column:L!==void 0?L:q!==void 0?1:void 0}}t.$5f=F;const H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(w,j,z=8){let q="";for(let P=0;P<z;P++){let J;P===0&&O.$j&&!j&&(z===3||z===4)?J=R:J=H,q+=J.charAt(Math.floor(Math.random()*J.length))}let L;return j?L=`${j}-${q}`:L=q,w?(0,D.$jc)(w,L):L}t.$6f=m}),define(be[114],$e([1,0,22]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ur=t.$Tr=t.$Sr=t.$Rr=t.$Qr=void 0,t.$Qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function _(d){const T=(0,D.$oc)(d),s=O[T.toLowerCase()];return s!==void 0?s:p(d)}t.$Rr=_;function p(d){const T=(0,D.$oc)(d);return i[T.toLowerCase()]}t.$Sr=p;function v(d){for(const T in i)if(i[T]===d)return T}t.$Tr=v;const h=/^(.+)\/(.+?)(;.+)?$/;function f(d,T){const s=h.exec(d);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:T?void 0:d}t.$Ur=f}),define(be[15],$e([1,0,22,5]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,_=/^\//,p=/^\/\//;function v(R,m){if(!R.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!i.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!_.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(R,m){return!R&&!m?"file":R}function f(R,m){switch(R){case"https":case"http":case"file":m?m[0]!==T&&(m=T+m):m=T;break}return m}const d="",T="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(m){return m instanceof a?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,w,j,z,q,L=!1){typeof m=="object"?(this.scheme=m.scheme||d,this.authority=m.authority||d,this.path=m.path||d,this.query=m.query||d,this.fragment=m.fragment||d):(this.scheme=h(m,L),this.authority=w||d,this.path=f(this.scheme,j||d),this.query=z||d,this.fragment=q||d,v(this,L))}get fsPath(){return b(this,!1)}with(m){if(!m)return this;let{scheme:w,authority:j,path:z,query:q,fragment:L}=m;return w===void 0?w=this.scheme:w===null&&(w=d),j===void 0?j=this.authority:j===null&&(j=d),z===void 0?z=this.path:z===null&&(z=d),q===void 0?q=this.query:q===null&&(q=d),L===void 0?L=this.fragment:L===null&&(L=d),w===this.scheme&&j===this.authority&&z===this.path&&q===this.query&&L===this.fragment?this:new l(w,j,z,q,L)}static parse(m,w=!1){const j=s.exec(m);return j?new l(j[2]||d,H(j[4]||d),H(j[5]||d),H(j[7]||d),H(j[9]||d),w):new l(d,d,d,d,d)}static file(m){let w=d;if(O.$j&&(m=m.replace(/\\/g,T)),m[0]===T&&m[1]===T){const j=m.indexOf(T,2);j===-1?(w=m.substring(2),m=T):(w=m.substring(2,j),m=m.substring(j)||T)}return new l("file",w,m,d,d)}static from(m,w){return new l(m.scheme,m.authority,m.path,m.query,m.fragment,w)}static joinPath(m,...w){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let j;return O.$j&&m.scheme==="file"?j=a.file(D.$fc.join(b(m,!0),...w)).path:j=D.$gc.join(m.path,...w),m.with({path:j})}toString(m=!1){return c(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof a)return m;{const w=new l(m);return w._formatted=m.external??null,w._fsPath=m._sep===u?m.fsPath??null:null,w}}else return m}}t.URI=a;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$vc=e;const u=O.$j?1:void 0;class l extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(m=!1){return m?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=u),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(R,m,w){let j,z=-1;for(let q=0;q<R.length;q++){const L=R.charCodeAt(q);if(L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57||L===45||L===46||L===95||L===126||m&&L===47||w&&L===91||w&&L===93||w&&L===58)z!==-1&&(j+=encodeURIComponent(R.substring(z,q)),z=-1),j!==void 0&&(j+=R.charAt(q));else{j===void 0&&(j=R.substr(0,q));const P=g[L];P!==void 0?(z!==-1&&(j+=encodeURIComponent(R.substring(z,q)),z=-1),j+=P):z===-1&&(z=q)}}return z!==-1&&(j+=encodeURIComponent(R.substring(z))),j!==void 0?j:R}function r(R){let m;for(let w=0;w<R.length;w++){const j=R.charCodeAt(w);j===35||j===63?(m===void 0&&(m=R.substr(0,w)),m+=g[j]):m!==void 0&&(m+=R[w])}return m!==void 0?m:R}function b(R,m){let w;return R.authority&&R.path.length>1&&R.scheme==="file"?w=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?m?w=R.path.substr(1):w=R.path[1].toLowerCase()+R.path.substr(2):w=R.path,O.$j&&(w=w.replace(/\//g,"\\")),w}t.$wc=b;function c(R,m){const w=m?r:n;let j="",{scheme:z,authority:q,path:L,query:P,fragment:J}=R;if(z&&(j+=z,j+=":"),(q||z==="file")&&(j+=T,j+=T),q){let ee=q.indexOf("@");if(ee!==-1){const ne=q.substr(0,ee);q=q.substr(ee+1),ee=ne.lastIndexOf(":"),ee===-1?j+=w(ne,!1,!1):(j+=w(ne.substr(0,ee),!1,!1),j+=":",j+=w(ne.substr(ee+1),!1,!0)),j+="@"}q=q.toLowerCase(),ee=q.lastIndexOf(":"),ee===-1?j+=w(q,!1,!0):(j+=w(q.substr(0,ee),!1,!0),j+=q.substr(ee))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const ee=L.charCodeAt(1);ee>=65&&ee<=90&&(L=`/${String.fromCharCode(ee+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const ee=L.charCodeAt(0);ee>=65&&ee<=90&&(L=`${String.fromCharCode(ee+32)}:${L.substr(2)}`)}j+=w(L,!0,!1)}return P&&(j+="?",j+=w(P,!1,!1)),J&&(j+="#",j+=m?J:n(J,!1,!1)),j}function o(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+o(R.substr(3)):R}}const F=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function H(R){return R.match(F)?R.replace(F,m=>o(m)):R}}),define(be[51],$e([1,0,32,15]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mh=t.$lh=t.$kh=void 0;function i(h){return JSON.stringify(h,p)}t.$kh=i;function _(h){let f=JSON.parse(h);return f=v(f),f}t.$lh=_;function p(h,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function v(h,f=0){if(!h||f>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return O.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof D.$be||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let d=0;d<h.length;++d)h[d]=v(h[d],f+1);else for(const d in h)Object.hasOwnProperty.call(h,d)&&(h[d]=v(h[d],f+1))}return h}t.$mh=v}),define(be[29],$e([1,0,6,5,15]),function(re,t,D,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.Schemas=void 0;var _;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(_||(t.Schemas=_={})),t.$7f="vscode-tkn",t.$8f="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${_.vscodeRemoteResource}`}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d){this.f=`${d}/${_.vscodeRemoteResource}`}set(d,T,s){this.a[d]=T,this.b[d]=s}setConnectionToken(d,T){this.c[d]=T}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(l){return D.$1(l),d}const T=d.authority;let s=this.a[T];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[T],e=this.c[T];let u=`path=${encodeURIComponent(d.path)}`;return typeof e=="string"&&(u+=`&${t.$8f}=${encodeURIComponent(e)}`),i.URI.from({scheme:O.$p?this.d:_.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:u})}}t.$9f=new p,t.$0f="vs/../../extensions",t.$$f="vs/../../node_modules",t.$_f="vs/../../node_modules.asar",t.$ag="vs/../../node_modules.asar.unpacked",t.$bg="vscode-app";class v{static{this.a=t.$bg}asBrowserUri(d){const T=this.b(d,re);return this.uriToBrowserUri(T)}uriToBrowserUri(d){return d.scheme===_.vscodeRemote?t.$9f.rewrite(d):d.scheme===_.file&&(O.$n||O.$q&&O.$h.origin===`${_.vscodeFileResource}://${v.a}`)?d.with({scheme:_.vscodeFileResource,authority:d.authority||v.a,query:null,fragment:null}):d}asFileUri(d){const T=this.b(d,re);return this.uriToFileUri(T)}uriToFileUri(d){return d.scheme===_.vscodeFileResource?d.with({scheme:_.file,authority:d.authority!==v.a?d.authority:null,query:null,fragment:null}):d}b(d,T){return i.URI.isUri(d)?d:i.URI.parse(T.toUrl(d))}}t.$cg=new v;var h;(function(f){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(d.get("3"));const T="vscode-coi";function s(e){let u;typeof e=="string"?u=new URL(e).searchParams:e instanceof URL?u=e.searchParams:i.URI.isUri(e)&&(u=new URL(e.toString(!0)).searchParams);const l=u?.get(T);if(l)return d.get(l)}f.getHeadersFromQuery=s;function a(e,u,l){if(!globalThis.crossOriginIsolated)return;const g=u&&l?"3":l?"2":"1";e instanceof URLSearchParams?e.set(T,g):e[T]=g}f.addSearchParam=a})(h||(t.COI=h={}))}),define(be[36],$e([1,0,113,29,22,5,12,15]),function(re,t,D,O,i,_,p,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fg=t.DataUri=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=void 0;function h(a){return(0,v.$wc)(a,!0)}t.$jg=h;class f{constructor(e){this.a=e}compare(e,u,l=!1){return e===u?0:(0,p.$Ue)(this.getComparisonKey(e,l),this.getComparisonKey(u,l))}isEqual(e,u,l=!1){return e===u?!0:!e||!u?!1:this.getComparisonKey(e,l)===this.getComparisonKey(u,l)}getComparisonKey(e,u=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,u,l=!1){if(e.scheme===u.scheme){if(e.scheme===O.Schemas.file)return D.$Xf(h(e),h(u),this.a(e))&&e.query===u.query&&(l||e.fragment===u.fragment);if((0,t.$Ag)(e.authority,u.authority))return D.$Xf(e.path,u.path,this.a(e),"/")&&e.query===u.query&&(l||e.fragment===u.fragment)}return!1}joinPath(e,...u){return v.URI.joinPath(e,...u)}basenameOrAuthority(e){return(0,t.$sg)(e)||e.authority}basename(e){return i.$gc.basename(e.path)}extname(e){return i.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let u;return e.scheme===O.Schemas.file?u=v.URI.file(i.$mc(h(e))).path:(u=i.$gc.dirname(e.path),e.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),u="/")),e.with({path:u})}normalizePath(e){if(!e.path.length)return e;let u;return e.scheme===O.Schemas.file?u=v.URI.file(i.$hc(h(e))).path:u=i.$gc.normalize(e.path),e.with({path:u})}relativePath(e,u){if(e.scheme!==u.scheme||!(0,t.$Ag)(e.authority,u.authority))return;if(e.scheme===O.Schemas.file){const n=i.$lc(h(e),h(u));return _.$j?D.$Rf(n):n}let l=e.path||"/";const g=u.path||"/";if(this.a(e)){let n=0;for(const r=Math.min(l.length,g.length);n<r&&!(l.charCodeAt(n)!==g.charCodeAt(n)&&l.charAt(n).toLowerCase()!==g.charAt(n).toLowerCase());n++);l=g.substr(0,n)+l.substr(n)}return i.$gc.relative(l,g)}resolvePath(e,u){if(e.scheme===O.Schemas.file){const l=v.URI.file(i.$kc(h(e),u));return e.with({authority:l.authority,path:l.path})}return u=D.$Sf(u),e.with({path:i.$gc.resolve(e.path,u)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,u){return e===u||e!==void 0&&u!==void 0&&(0,p.$2e)(e,u)}hasTrailingPathSeparator(e,u=i.sep){if(e.scheme===O.Schemas.file){const l=h(e);return l.length>D.$Tf(l).length&&l[l.length-1]===u}else{const l=e.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,u=i.sep){return(0,t.$Bg)(e,u)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,u=i.sep){let l=!1;if(e.scheme===O.Schemas.file){const g=h(e);l=g!==void 0&&g.length===D.$Tf(g).length&&g[g.length-1]===u}else{u="/";const g=e.path;l=g.length===1&&g.charCodeAt(g.length-1)===47}return!l&&!(0,t.$Bg)(e,u)?e.with({path:e.path+"/"}):e}}t.$kg=f,t.$lg=new f(()=>!1),t.$mg=new f(a=>a.scheme===O.Schemas.file?!_.$l:!0),t.$ng=new f(a=>!0),t.$og=t.$lg.isEqual.bind(t.$lg),t.$pg=t.$lg.isEqualOrParent.bind(t.$lg),t.$qg=t.$lg.getComparisonKey.bind(t.$lg),t.$rg=t.$lg.basenameOrAuthority.bind(t.$lg),t.$sg=t.$lg.basename.bind(t.$lg),t.$tg=t.$lg.extname.bind(t.$lg),t.$ug=t.$lg.dirname.bind(t.$lg),t.$vg=t.$lg.joinPath.bind(t.$lg),t.$wg=t.$lg.normalizePath.bind(t.$lg),t.$xg=t.$lg.relativePath.bind(t.$lg),t.$yg=t.$lg.resolvePath.bind(t.$lg),t.$zg=t.$lg.isAbsolutePath.bind(t.$lg),t.$Ag=t.$lg.isEqualAuthority.bind(t.$lg),t.$Bg=t.$lg.hasTrailingPathSeparator.bind(t.$lg),t.$Cg=t.$lg.removeTrailingPathSeparator.bind(t.$lg),t.$Dg=t.$lg.addTrailingPathSeparator.bind(t.$lg);function d(a,e){const u=[];for(let l=0;l<a.length;l++){const g=e(a[l]);a.some((n,r)=>r===l?!1:(0,t.$pg)(g,e(n)))||u.push(a[l])}return u}t.$Eg=d;var T;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(u){const l=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(r=>{const[b,c]=r.split(":");b&&c&&l.set(b,c)});const n=u.path.substring(0,u.path.indexOf(";"));return n&&l.set(a.META_DATA_MIME,n),l}a.parseMetaData=e})(T||(t.DataUri=T={}));function s(a,e,u){if(e){let l=a.path;return l&&l[0]!==i.$gc.sep&&(l=i.$gc.sep+l),a.with({scheme:u,authority:e,path:l})}return a.with({scheme:u})}t.$Fg=s}),define(be[9],$e([1,0,28,6,4,2,36,5,48]),function(re,t,D,O,i,_,p,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gh=t.$fh=t.$eh=t.$dh=t.Promises=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=void 0;function f(I){return!!I&&typeof I.then=="function"}t.$Gg=f;function d(I){const M=new D.$Xd,N=I(M.token),A=new Promise((E,W)=>{const S=M.token.onCancellationRequested(()=>{S.dispose(),M.dispose(),W(new O.$5)});Promise.resolve(N).then(B=>{S.dispose(),M.dispose(),E(B)},B=>{S.dispose(),M.dispose(),W(B)})});return new class{cancel(){M.cancel()}then(E,W){return A.then(E,W)}catch(E){return this.then(void 0,E)}finally(E){return A.finally(E)}}}t.$Hg=d;function T(I,M,N){return new Promise((A,E)=>{const W=M.onCancellationRequested(()=>{W.dispose(),A(N)});I.then(A,E).finally(()=>W.dispose())})}t.$Ig=T;function s(I,M){return new Promise((N,A)=>{const E=M.onCancellationRequested(()=>{E.dispose(),A(new O.$5)});I.then(N,A).finally(()=>E.dispose())})}t.$Jg=s;async function a(I){let M=-1;const N=I.map((A,E)=>A.then(W=>(M=E,W)));try{return await Promise.race(N)}finally{I.forEach((A,E)=>{E!==M&&A.cancel()})}}t.$Kg=a;function e(I,M,N){let A;const E=setTimeout(()=>{A?.(void 0),N?.()},M);return Promise.race([I.finally(()=>clearTimeout(E)),new Promise(W=>A=W)])}t.$Lg=e;function u(I){return new Promise((M,N)=>{const A=I();f(A)?A.then(M,N):M(A)})}t.$Mg=u;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(M){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=M,!this.b){const N=()=>{if(this.b=null,this.f)return;const A=this.queue(this.d);return this.d=null,A};this.b=new Promise(A=>{this.a.then(N,N).then(A)})}return new Promise((N,A)=>{this.b.then(N,A)})}return this.a=M(),new Promise((N,A)=>{this.a.then(E=>{this.a=null,N(E)},E=>{this.a=null,A(E)})})}dispose(){this.f=!0}}t.$Ng=l;class g{constructor(){this.a=Promise.resolve(null)}queue(M){return this.a=this.a.then(()=>M(),()=>M())}}t.$Og=g;class n{constructor(){this.a=new Map}queue(M,N){const E=(this.a.get(M)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.a.get(M)===E&&this.a.delete(M)});return this.a.set(M,E),E}}t.$Pg=n;const r=(I,M)=>{let N=!0;const A=setTimeout(()=>{N=!1,M()},I);return{isTriggered:()=>N,dispose:()=>{clearTimeout(A),N=!1}}},b=I=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,I())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class c{constructor(M){this.defaultDelay=M,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(M,N=this.defaultDelay){this.g=M,this.h(),this.b||(this.b=new Promise((E,W)=>{this.d=E,this.f=W}).then(()=>{if(this.b=null,this.d=null,this.g){const E=this.g;return this.g=null,E()}}));const A=()=>{this.a=null,this.d?.(null)};return this.a=N===h.$Kd?b(A):r(N,A),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Qg=c;class o{constructor(M){this.a=new c(M),this.b=new l}trigger(M,N){return this.a.trigger(()=>this.b.queue(M),N)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Rg=o;class F{constructor(){this.a=!1,this.b=new Promise((M,N)=>{this.d=M})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Sg=F;class H extends F{constructor(M){super(),this.f=setTimeout(()=>this.open(),M)}open(){clearTimeout(this.f),super.open()}}t.$Tg=H;function R(I,M){return M?new Promise((N,A)=>{const E=setTimeout(()=>{W.dispose(),N()},I),W=M.onCancellationRequested(()=>{clearTimeout(E),W.dispose(),A(new O.$5)})}):d(N=>R(I,N))}t.$Ug=R;function m(I,M=0,N){const A=setTimeout(()=>{I(),N&&E.dispose()},M),E=(0,_.$Qc)(()=>{clearTimeout(A),N?.deleteAndLeak(E)});return N?.add(E),E}t.$Vg=m;function w(I){const M=[];let N=0;const A=I.length;function E(){return N<A?I[N++]():null}function W(S){S!=null&&M.push(S);const B=E();return B?B.then(W):Promise.resolve(M)}return Promise.resolve(null).then(W)}t.$Wg=w;function j(I,M=A=>!!A,N=null){let A=0;const E=I.length,W=()=>{if(A>=E)return Promise.resolve(N);const S=I[A++];return Promise.resolve(S()).then(y=>M(y)?Promise.resolve(y):W())};return W()}t.$Xg=j;function z(I,M=A=>!!A,N=null){if(I.length===0)return Promise.resolve(N);let A=I.length;const E=()=>{A=-1;for(const W of I)W.cancel?.()};return new Promise((W,S)=>{for(const B of I)B.then(y=>{--A>=0&&M(y)?(E(),W(y)):A===0&&W(N)}).catch(y=>{--A>=0&&(E(),S(y))})})}t.$Yg=z;class q{constructor(M){this.a=0,this.d=M,this.f=[],this.b=0,this.g=new i.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(M){return this.a++,new Promise((N,A)=>{this.f.push({factory:M,c:N,e:A}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const M=this.f.shift();this.b++;const N=M.factory();N.then(M.c,M.e),N.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$Zg=q;class L extends q{constructor(){super(1)}}t.$1g=L;class P{constructor(){this.a=new Pe,this.b=0}queue(M){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,M())):this.a.run(this.b++,M())}}t.$2g=P;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const M=new fe;return this.b.add(M),M.p}g(){for(const[,M]of this.a)if(M.size>0)return!1;return!0}queueFor(M,N=p.$lg){const A=N.getComparisonKey(M);let E=this.a.get(A);if(!E){E=new L;const W=this.f++,S=i.Event.once(E.onDrained)(()=>{E?.dispose(),this.a.delete(A),this.h(),this.d?.deleteAndDispose(W),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new _.$1c),this.d.set(W,S),this.a.set(A,E)}return E}h(){this.g()&&this.j()}j(){for(const M of this.b)M.complete();this.b.clear()}dispose(){for(const[,M]of this.a)M.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$3g=J;class ee{constructor(M,N){this.a=-1,typeof M=="function"&&typeof N=="number"&&this.setIfNotSet(M,N)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(M,N){this.cancel(),this.a=setTimeout(()=>{this.a=-1,M()},N)}setIfNotSet(M,N){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,M()},N))}}t.$4g=ee;class ne{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(M,N){this.cancel(),this.a=setInterval(()=>{M()},N)}}t.$5g=ne;class ue{constructor(M,N){this.b=-1,this.a=M,this.d=N,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(M=this.d){this.cancel(),this.b=setTimeout(this.f,M)}get delay(){return this.d}set delay(M){this.d=M}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$6g=ue;class le{constructor(M,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.a=M,this.b=N,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(M=this.b){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(M/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$7g=le;class oe extends ue{constructor(M,N){super(M,N),this.j=[]}work(M){this.j.push(M),this.isScheduled()||this.schedule()}h(){const M=this.j;this.j=[],this.a?.(M)}dispose(){this.j=[],super.dispose()}}t.$8g=oe;class me extends _.$Sc{constructor(M,N){super(),this.g=M,this.h=N,this.a=[],this.b=this.B(new _.$Tc),this.f=!1}get pending(){return this.a.length}work(M){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+M.length>this.g.maxBufferedWork)return!1}else if(this.pending+M.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const N of M)this.a.push(N);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ue(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$9g=me,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$0g=I=>{(0,v.$B)(()=>{if(M)return;const N=Date.now()+15;I(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:t.$0g=(I,M)=>{const N=requestIdleCallback(I,typeof M=="number"?{timeout:M}:void 0);let A=!1;return{dispose(){A||(A=!0,cancelIdleCallback(N))}}}}();class Se{constructor(M){this.d=!1,this.a=()=>{try{this.f=M()}catch(N){this.g=N}finally{this.d=!0}},this.b=(0,t.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$$g=Se;async function Te(I,M,N){let A;for(let E=0;E<N;E++)try{return await I()}catch(W){A=W,await R(M)}throw A}t.$_g=Te;class Pe{isRunning(M){return typeof M=="number"?this.a?.taskId===M:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(M,N,A){return this.a={taskId:M,cancel:()=>A?.(),promise:N},N.then(()=>this.d(M),()=>this.d(M)),N}d(M){this.a&&M===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const M=this.b;this.b=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}queue(M){if(this.b)this.b.run=M;else{let N,A;const E=new Promise((W,S)=>{N=W,A=S});this.b={run:M,promise:E,promiseResolve:N,promiseReject:A}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$ah=Pe;class de{constructor(M,N=()=>Date.now()){this.d=M,this.f=N,this.a=0,this.b=0}increment(){const M=this.f();return M-this.a>this.d&&(this.a=M,this.b=0),this.b++,this.b}}t.$bh=de;var ie;(function(I){I[I.Resolved=0]="Resolved",I[I.Rejected=1]="Rejected"})(ie||(ie={}));class fe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((M,N)=>{this.a=M,this.b=N})}complete(M){return new Promise(N=>{this.a(M),this.d={outcome:0,value:M},N()})}error(M){return new Promise(N=>{this.b(M),this.d={outcome:1,value:M},N()})}cancel(){return this.error(new O.$5)}}t.$ch=fe;var Y;(function(I){async function M(A){let E;const W=await Promise.all(A.map(S=>S.then(B=>B,B=>{E||(E=B)})));if(typeof E<"u")throw E;return W}I.settled=M;function N(A){return new Promise(async(E,W)=>{try{await A(E,W)}catch(S){W(S)}})}I.withAsyncBody=N})(Y||(t.Promises=Y={}));var V;(function(I){I[I.Initial=0]="Initial",I[I.DoneOK=1]="DoneOK",I[I.DoneError=2]="DoneError"})(V||(V={}));class G{static fromArray(M){return new G(N=>{N.emitMany(M)})}static fromPromise(M){return new G(async N=>{N.emitMany(await M)})}static fromPromises(M){return new G(async N=>{await Promise.all(M.map(async A=>N.emitOne(await A)))})}static merge(M){return new G(async N=>{await Promise.all(M.map(async A=>{for await(const E of A)N.emitOne(E)}))})}static{this.EMPTY=G.fromArray([])}constructor(M){this.a=0,this.b=[],this.d=null,this.f=new i.$Nd,queueMicrotask(async()=>{const N={emitOne:A=>this.g(A),emitMany:A=>this.h(A),reject:A=>this.k(A)};try{await Promise.resolve(M(N)),this.j()}catch(A){this.k(A)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(M<this.b.length)return{done:!1,value:this.b[M++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(M,N){return new G(async A=>{for await(const E of M)A.emitOne(N(E))})}map(M){return G.map(this,M)}static filter(M,N){return new G(async A=>{for await(const E of M)N(E)&&A.emitOne(E)})}filter(M){return G.filter(this,M)}static coalesce(M){return G.filter(M,N=>!!N)}coalesce(){return G.coalesce(this)}static async toPromise(M){const N=[];for await(const A of M)N.push(A);return N}toPromise(){return G.toPromise(this)}g(M){this.a===0&&(this.b.push(M),this.f.fire())}h(M){this.a===0&&(this.b=this.b.concat(M),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(M){this.a===0&&(this.a=2,this.d=M,this.f.fire())}}t.$dh=G;class k extends G{constructor(M,N){super(N),this.l=M}cancel(){this.l.cancel()}}t.$eh=k;function x(I){const M=new D.$Xd,N=I(M.token);return new k(M,async A=>{const E=M.token.onCancellationRequested(()=>{E.dispose(),M.dispose(),A.reject(new O.$5)});try{for await(const W of N){if(M.token.isCancellationRequested)return;A.emitOne(W)}E.dispose(),M.dispose()}catch(W){E.dispose(),M.dispose(),A.reject(W)}})}t.$fh=x;class ${constructor(){this.a=new fe,this.b=new G(A=>{if(M){A.reject(M);return}return N&&A.emitMany(N),this.d=E=>A.reject(E),this.f=E=>A.emitOne(E),this.a.p});let M,N;this.f=A=>{N||(N=[]),N.push(A)},this.d=A=>{M||(M=A)}}get asyncIterable(){return this.b}complete(){this.a.complete()}error(M){this.d(M),this.a.complete()}emit(M){this.f(M)}}t.$gh=$}),define(be[3],$e([1,0,16,111,14,19,9,6,4,115,2,29,5,15]),function(re,t,D,O,i,_,p,v,h,f,d,T,s,a){"use strict";var e;Object.defineProperty(t,"__esModule",{value:!0}),t.$2P=t.$1P=t.h=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.DetectedFullscreenMode=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$=t.Namespace=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$TO=t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.onDidRegisterWindow=t.getWindows=t.registerWindow=void 0,e=function(){const X=new Set([window]),Q=new h.$Nd;return{onDidRegisterWindow:Q.event,registerWindow(he){if(X.has(he))return d.$Sc.None;X.add(he);const Ee=new d.$Rc;return Ee.add((0,d.$Qc)(()=>{X.delete(he)})),Q.fire({window:he,disposableStore:Ee}),Ee},getWindows(){return X}}}(),t.registerWindow=e.registerWindow,t.getWindows=e.getWindows,t.onDidRegisterWindow=e.onDidRegisterWindow;function u(X){for(;X.firstChild;)X.firstChild.remove()}t.$FO=u;class l{constructor(Q,he,Ee,ke){this.f=Q,this.g=he,this.d=Ee,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function g(X,Q,he,Ee){return new l(X,Q,he,Ee)}t.$GO=g;function n(X){return function(Q){return X(new _.$yO(Q))}}function r(X){return function(Q){return X(new i.$DO(Q))}}const b=function(Q,he,Ee,ke){let He=Ee;return he==="click"||he==="mousedown"?He=n(Ee):(he==="keydown"||he==="keypress"||he==="keyup")&&(He=r(Ee)),g(Q,he,He,ke)};t.$HO=b;const c=function(Q,he,Ee){const ke=n(he);return F(Q,ke,Ee)};t.$IO=c;const o=function(Q,he,Ee){const ke=n(he);return R(Q,ke,Ee)};t.$JO=o;function F(X,Q,he){return g(X,s.$r&&O.$vO.pointerEvents?t.$pP.POINTER_DOWN:t.$pP.MOUSE_DOWN,Q,he)}t.$KO=F;function H(X,Q,he){return g(X,s.$r&&O.$vO.pointerEvents?t.$pP.POINTER_MOVE:t.$pP.MOUSE_MOVE,Q,he)}t.$LO=H;function R(X,Q,he){return g(X,s.$r&&O.$vO.pointerEvents?t.$pP.POINTER_UP:t.$pP.MOUSE_UP,Q,he)}t.$MO=R;class m{constructor(Q,he=0){this.d=Q,this.priority=he,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,v.$1)(Q)}}static sort(Q,he){return he.priority-Q.priority}}(function(){let X=[],Q=null,he=!1,Ee=!1;const ke=()=>{for(he=!1,Q=X,X=[],Ee=!0;Q.length>0;)Q.sort(m.sort),Q.shift().execute();Ee=!1};t.$OO=(He,Ue=0)=>{const Ze=new m(He,Ue);return X.push(Ze),he||(he=!0,requestAnimationFrame(ke)),Ze},t.$NO=(He,Ue)=>{if(Ee){const Ze=new m(He,Ue);return Q.push(Ze),Ze}else return(0,t.$OO)(He,Ue)}})();function w(X){return(0,t.$OO)(X,1e4)}t.$PO=w;function j(X){return(0,t.$OO)(X,-1e4)}t.$QO=j;const z=8,q=function(X,Q){return Q};class L extends d.$Sc{constructor(Q,he,Ee,ke=q,He=z){super();let Ue=null,Ze=0;const lt=this.B(new p.$4g),Ye=()=>{Ze=new Date().getTime(),Ee(Ue),Ue=null};this.B(g(Q,he,wt=>{Ue=ke(Ue,wt);const Ct=new Date().getTime()-Ze;Ct>=He?(lt.cancel(),Ye()):lt.setIfNotSet(Ye,He-Ct)}))}}function P(X,Q,he,Ee,ke){return new L(X,Q,he,Ee,ke)}t.$RO=P;function J(X){return X.ownerDocument.defaultView.getComputedStyle(X,null)}t.$SO=J;function ee(X){const Q=X.ownerDocument,he=Q.defaultView?.window;if(X!==Q.body)return new ue(X.clientWidth,X.clientHeight);if(s.$r&&he?.visualViewport)return new ue(he.visualViewport.width,he.visualViewport.height);if(he?.innerWidth&&he.innerHeight)return new ue(he.innerWidth,he.innerHeight);if(Q.body&&Q.body.clientWidth&&Q.body.clientHeight)return new ue(Q.body.clientWidth,Q.body.clientHeight);if(Q.documentElement&&Q.documentElement.clientWidth&&Q.documentElement.clientHeight)return new ue(Q.documentElement.clientWidth,Q.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$TO=ee;class ne{static d(Q,he){return parseFloat(he)||0}static f(Q,he,Ee){const ke=J(Q),He=ke?ke.getPropertyValue(he):"0";return ne.d(Q,He)}static getBorderLeftWidth(Q){return ne.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return ne.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return ne.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return ne.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return ne.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return ne.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return ne.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return ne.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return ne.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return ne.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return ne.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return ne.f(Q,"margin-bottom","marginBottom")}}class ue{static{this.None=new ue(0,0)}constructor(Q,he){this.width=Q,this.height=he}with(Q=this.width,he=this.height){return Q!==this.width||he!==this.height?new ue(Q,he):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof ue?Q:new ue(Q.width,Q.height)}static equals(Q,he){return Q===he?!0:!Q||!he?!1:Q.width===he.width&&Q.height===he.height}}t.$UO=ue;function le(X){let Q=X.offsetParent,he=X.offsetTop,Ee=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==X.ownerDocument.body&&X!==X.ownerDocument.documentElement;){he-=X.scrollTop;const ke=E(X)?null:J(X);ke&&(Ee-=ke.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===Q&&(Ee+=ne.getBorderLeftWidth(X),he+=ne.getBorderTopWidth(X),he+=X.offsetTop,Ee+=X.offsetLeft,Q=X.offsetParent)}return{left:Ee,top:he}}t.$VO=le;function oe(X,Q,he){typeof Q=="number"&&(X.style.width=`${Q}px`),typeof he=="number"&&(X.style.height=`${he}px`)}t.$WO=oe;function me(X,Q,he,Ee,ke,He="absolute"){typeof Q=="number"&&(X.style.top=`${Q}px`),typeof he=="number"&&(X.style.right=`${he}px`),typeof Ee=="number"&&(X.style.bottom=`${Ee}px`),typeof ke=="number"&&(X.style.left=`${ke}px`),X.style.position=He}t.$XO=me;function Se(X){const Q=X.getBoundingClientRect();return{left:Q.left+(X.ownerDocument.defaultView?.scrollX??0),top:Q.top+(X.ownerDocument.defaultView?.scrollY??0),width:Q.width,height:Q.height}}t.$YO=Se;function Te(X){let Q=X,he=1;do{const Ee=J(Q).zoom;Ee!=null&&Ee!=="1"&&(he*=Ee),Q=Q.parentElement}while(Q!==null&&Q!==Q.ownerDocument.documentElement);return he}t.$ZO=Te;function Pe(X){const Q=ne.getMarginLeft(X)+ne.getMarginRight(X);return X.offsetWidth+Q}t.$1O=Pe;function de(X){const Q=ne.getBorderLeftWidth(X)+ne.getBorderRightWidth(X),he=ne.getPaddingLeft(X)+ne.getPaddingRight(X);return X.offsetWidth-Q-he}t.$2O=de;function ie(X){const Q=ne.getMarginLeft(X)+ne.getMarginRight(X);return X.scrollWidth+Q}t.$3O=ie;function fe(X){const Q=ne.getBorderTopWidth(X)+ne.getBorderBottomWidth(X),he=ne.getPaddingTop(X)+ne.getPaddingBottom(X);return X.offsetHeight-Q-he}t.$4O=fe;function Y(X){const Q=ne.getMarginTop(X)+ne.getMarginBottom(X);return X.offsetHeight+Q}t.$5O=Y;function V(X,Q){if(X===null)return 0;const he=le(X),Ee=le(Q);return he.left-Ee.left}function G(X,Q){const he=Q.map(ke=>Math.max(ie(ke),Pe(ke))+V(ke,X)||0);return Math.max(...he)}t.$6O=G;function k(X,Q){for(;X;){if(X===Q)return!0;X=X.parentNode}return!1}t.$7O=k;const x="parentFlowToElementId";function $(X,Q){X.dataset[x]=Q.id}t.$8O=$;function I(X){const Q=X.dataset[x];return typeof Q=="string"?X.ownerDocument.getElementById(Q):null}function M(X,Q){let he=X;for(;he;){if(he===Q)return!0;if(he instanceof HTMLElement){const Ee=I(he);if(Ee){he=Ee;continue}}he=he.parentNode}return!1}t.$9O=M;function N(X,Q,he){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(Q))return X;if(he){if(typeof he=="string"){if(X.classList.contains(he))return null}else if(X===he)return null}X=X.parentNode}return null}t.$0O=N;function A(X,Q,he){return!!N(X,Q,he)}t.$$O=A;function E(X){return X&&!!X.host&&!!X.mode}t.$_O=E;function W(X){return!!S(X)}t.$aP=W;function S(X){for(;X.parentNode;){if(X===X.ownerDocument?.body)return null;X=X.parentNode}return E(X)?X:null}t.$bP=S;function B(){let X=y().activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.$cP=B;function y(){return Array.from((0,t.getWindows)()).map(Q=>Q.document).find(Q=>Q.hasFocus())??document}t.$dP=y;function C(){return y().defaultView?.window??window}t.$eP=C;function U(X){const Q=X;if(Q?.ownerDocument?.defaultView)return Q.ownerDocument.defaultView.window;const he=X;return he?.view?he.view.window:window}t.$fP=U;function K(X){const Q=U(X);Q!==C()&&Q.focus()}t.$gP=K;function te(X=document.getElementsByTagName("head")[0],Q){const he=document.createElement("style");return he.type="text/css",he.media="screen",Q?.(he),X.appendChild(he),he}t.$hP=te;function se(X=document.getElementsByTagName("head")[0]){const Q=document.createElement("meta");return X.appendChild(Q),Q}t.$iP=se;let ge=null;function we(){return ge||(ge=te()),ge}function Ne(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function Ae(X,Q,he=we()){!he||!Q||he.sheet.insertRule(X+"{"+Q+"}",0)}t.$jP=Ae;function ve(X,Q=we()){if(!Q)return;const he=Ne(Q),Ee=[];for(let ke=0;ke<he.length;ke++)he[ke].selectorText.indexOf(X)!==-1&&Ee.push(ke);for(let ke=Ee.length-1;ke>=0;ke--)Q.sheet.deleteRule(Ee[ke])}t.$kP=ve;function Ie(X){return X instanceof MouseEvent||X instanceof U(X).MouseEvent}t.$lP=Ie;function Oe(X){return X instanceof KeyboardEvent||X instanceof U(X).KeyboardEvent}t.$mP=Oe;function qe(X){return X instanceof PointerEvent||X instanceof U(X).PointerEvent}t.$nP=qe;function je(X){return X instanceof DragEvent||X instanceof U(X).DragEvent}t.$oP=je,t.$pP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:D.$nO?"webkitAnimationStart":"animationstart",ANIMATION_END:D.$nO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:D.$nO?"webkitAnimationIteration":"animationiteration"};function Re(X){const Q=X;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.$qP=Re,t.$rP={stop:(X,Q)=>(X.preventDefault(),Q&&X.stopPropagation(),X)};function Ge(X){const Q=[];for(let he=0;X&&X.nodeType===X.ELEMENT_NODE;he++)Q[he]=X.scrollTop,X=X.parentNode;return Q}t.$sP=Ge;function Z(X,Q){for(let he=0;X&&X.nodeType===X.ELEMENT_NODE;he++)X.scrollTop!==Q[he]&&(X.scrollTop=Q[he]),X=X.parentNode}t.$tP=Z;class ae extends d.$Sc{static m(Q){if(Q instanceof HTMLElement){const he=S(Q),Ee=he?he.activeElement:Q.ownerDocument.activeElement;return k(Ee,Q)}else return k(window.document.activeElement,window.document)}constructor(Q){super(),this.f=this.B(new h.$Nd),this.onDidFocus=this.f.event,this.g=this.B(new h.$Nd),this.onDidBlur=this.g.event;let he=ae.m(Q),Ee=!1;const ke=()=>{Ee=!1,he||(he=!0,this.f.fire())},He=()=>{he&&(Ee=!0,window.setTimeout(()=>{Ee&&(Ee=!1,he=!1,this.g.fire())},0))};this.j=()=>{ae.m(Q)!==he&&(he?He():ke())},this.B(g(Q,t.$pP.FOCUS,ke,!0)),this.B(g(Q,t.$pP.BLUR,He,!0)),Q instanceof HTMLElement&&(this.B(g(Q,t.$pP.FOCUS_IN,()=>this.j())),this.B(g(Q,t.$pP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function pe(X){return new ae(X)}t.$uP=pe;function De(X,Q){return X.after(Q),Q}t.$vP=De;function Ce(X,...Q){if(X.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}t.$wP=Ce;function Me(X,Q){return X.insertBefore(Q,X.firstChild),Q}t.$xP=Me;function ze(X,...Q){X.innerText="",Ce(X,...Q)}t.$yP=ze;const Xe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ke;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(Ke||(t.Namespace=Ke={}));function Ve(X,Q,he,...Ee){const ke=Xe.exec(Q);if(!ke)throw new Error("Bad use of emmet");const He=ke[1]||"div";let Ue;return X!==Ke.HTML?Ue=document.createElementNS(X,He):Ue=document.createElement(He),ke[3]&&(Ue.id=ke[3]),ke[4]&&(Ue.className=ke[4].replace(/\./g," ").trim()),he&&Object.entries(he).forEach(([Ze,lt])=>{typeof lt>"u"||(/^on\w+$/.test(Ze)?Ue[Ze]=lt:Ze==="selected"?lt&&Ue.setAttribute(Ze,"true"):Ue.setAttribute(Ze,lt))}),Ue.append(...Ee),Ue}function We(X,Q,...he){return Ve(Ke.HTML,X,Q,...he)}t.$=We,We.SVG=function(X,Q,...he){return Ve(Ke.SVG,X,Q,...he)};function et(X,Q){const he=[];return X.forEach((Ee,ke)=>{ke>0&&(Q instanceof Node?he.push(Q.cloneNode()):he.push(document.createTextNode(Q))),he.push(Ee)}),he}t.$AP=et;function it(X,...Q){X?ft(...Q):ut(...Q)}t.$BP=it;function ft(...X){for(const Q of X)Q.style.display="",Q.removeAttribute("aria-hidden")}t.$CP=ft;function ut(...X){for(const Q of X)Q.style.display="none",Q.setAttribute("aria-hidden","true")}t.$DP=ut;function ct(X,Q){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(Q))return X;X=X.parentNode}return null}function Et(X){!X||!X.hasAttribute("tabIndex")||(X.ownerDocument.activeElement===X&&ct(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.$EP=Et;function At(X){return Q=>{Q.preventDefault(),Q.stopPropagation(),X(Q)}}t.$FP=At;function kt(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.$GP=kt;function St(X){const Q=window.devicePixelRatio*X;return Math.max(1,Math.floor(Q))/window.devicePixelRatio}t.$HP=St;function Rt(X){window.open(X,"_blank","noopener")}t.$IP=Rt;const Le=780,ce=640;function ye(X){const Q=Math.floor(window.screenLeft+window.innerWidth/2-Le/2),he=Math.floor(window.screenTop+window.innerHeight/2-ce/2);window.open(X,"_blank",`width=${Le},height=${ce},top=${he},left=${Q}`)}t.$JP=ye;function Fe(X,Q=!0){const he=window.open();return he?(Q&&(he.opener=null),he.location.href=X,!0):!1}t.$KP=Fe;function _e(X){const Q=()=>{X(),he=(0,t.$OO)(Q)};let he=(0,t.$OO)(Q);return(0,d.$Qc)(()=>he.dispose())}t.$LP=_e,T.$9f.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Je(X){return X?`url('${T.$cg.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$MP=Je;function nt(X){return`'${X.replace(/'/g,"%27")}'`}t.$NP=nt;function xe(X,Q){if(X!==void 0){const he=X.match(/^\s*var\((.+)\)$/);if(he){const Ee=he[1].split(",",2);return Ee.length===2&&(Q=xe(Ee[1].trim(),Q)),`var(${Ee[0]}, ${Q})`}return X}return Q}t.$OP=xe;function ot(X,Q){let he;if(a.URI.isUri(X))he=X.toString(!0);else{const ke=new Blob([X]);he=URL.createObjectURL(ke),setTimeout(()=>URL.revokeObjectURL(he))}const Ee=document.createElement("a");document.body.appendChild(Ee),Ee.download=Q,Ee.href=he,Ee.click(),setTimeout(()=>document.body.removeChild(Ee))}t.$PP=ot;function pt(){return new Promise(X=>{const Q=document.createElement("input");document.body.appendChild(Q),Q.type="file",Q.multiple=!0,h.Event.once(h.Event.fromDOMEventEmitter(Q,"input"))(()=>{X(Q.files??void 0)}),Q.click(),setTimeout(()=>document.body.removeChild(Q))})}t.$QP=pt;var dt;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(dt||(t.DetectedFullscreenMode=dt={}));function Qt(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(s.$k||s.$l)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.$RP=Qt;function Gt(X,Q=!1){const he=document.createElement("a");return f.addHook("afterSanitizeAttributes",Ee=>{for(const ke of["href","src"])if(Ee.hasAttribute(ke)){const He=Ee.getAttribute(ke);if(ke==="href"&&He.startsWith("#"))continue;if(he.href=He,!X.includes(he.protocol.replace(/:$/,""))){if(Q&&ke==="src"&&he.href.startsWith("data:"))continue;Ee.removeAttribute(ke)}}}),(0,d.$Qc)(()=>{f.removeHook("afterSanitizeAttributes")})}t.$SP=Gt;const vi=[T.Schemas.http,T.Schemas.https,T.Schemas.command];t.$TP=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Di=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function yi(X,Q){const he=Gt(vi);try{const Ee=f.sanitize(Q,Di);X.innerHTML=Ee}finally{he.dispose()}}t.$UP=yi;function Ei(X){const Q=new Uint16Array(X.length);for(let ke=0;ke<Q.length;ke++)Q[ke]=X.charCodeAt(ke);let he="";const Ee=new Uint8Array(Q.buffer);for(let ke=0;ke<Ee.length;ke++)he+=String.fromCharCode(Ee[ke]);return he}function Ai(X){return btoa(Ei(X))}t.$VP=Ai;class mt extends h.$Nd{constructor(){super(),this.o=new d.$Rc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(g(window,"keydown",Q=>{if(Q.defaultPrevented)return;const he=new i.$DO(Q);if(!(he.keyCode===6&&Q.repeat)){if(Q.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(Q.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(Q.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(Q.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(he.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=Q.altKey,this.s.ctrlKey=Q.ctrlKey,this.s.metaKey=Q.metaKey,this.s.shiftKey=Q.shiftKey,this.s.lastKeyPressed&&(this.s.event=Q,this.fire(this.s))}},!0)),this.o.add(g(window,"keyup",Q=>{Q.defaultPrevented||(!Q.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!Q.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!Q.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!Q.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=Q.altKey,this.s.ctrlKey=Q.ctrlKey,this.s.metaKey=Q.metaKey,this.s.shiftKey=Q.shiftKey,this.s.lastKeyReleased&&(this.s.event=Q,this.fire(this.s)))},!0)),this.o.add(g(document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),this.o.add(g(document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),this.o.add(g(document.body,"mousemove",Q=>{Q.buttons&&(this.s.lastKeyPressed=void 0)},!0)),this.o.add(g(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.B(),this.fire(this.s)}B(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return mt.A||(mt.A=new mt),mt.A}dispose(){super.dispose(),this.o.dispose()}}t.$WP=mt;function ki(X){const Q=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}t.$XP=ki;class Si extends d.$Sc{constructor(Q,he){super(),this.j=Q,this.m=he,this.f=0,this.g=0,this.n()}n(){this.B(g(this.j,t.$pP.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.m.onDragEnter(Q)})),this.B(g(this.j,t.$pP.DRAG_OVER,Q=>{Q.preventDefault(),this.m.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B(g(this.j,t.$pP.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(Q))})),this.B(g(this.j,t.$pP.DRAG_END,Q=>{this.f=0,this.g=0,this.m.onDragEnd(Q)})),this.B(g(this.j,t.$pP.DROP,Q=>{this.f=0,this.g=0,this.m.onDrop(Q)}))}}t.$YP=Si;const Ci=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Ni(X,...Q){let he,Ee;Array.isArray(Q[0])?(he={},Ee=Q[0]):(he=Q[0]||{},Ee=Q[1]);const ke=Ci.exec(X);if(!ke||!ke.groups)throw new Error("Bad use of h");const He=ke.groups.tag||"div",Ue=document.createElement(He);ke.groups.id&&(Ue.id=ke.groups.id);const Ze=[];if(ke.groups.class)for(const Ye of ke.groups.class.split("."))Ye!==""&&Ze.push(Ye);if(he.className!==void 0)for(const Ye of he.className.split("."))Ye!==""&&Ze.push(Ye);Ze.length>0&&(Ue.className=Ze.join(" "));const lt={};if(ke.groups.name&&(lt[ke.groups.name]=Ue),Ee)for(const Ye of Ee)Ye instanceof HTMLElement?Ue.appendChild(Ye):typeof Ye=="string"?Ue.append(Ye):"root"in Ye&&(Object.assign(lt,Ye),Ue.appendChild(Ye.root));for(const[Ye,wt]of Object.entries(he))if(Ye!=="className")if(Ye==="style")for(const[Ct,Mt]of Object.entries(wt))Ue.style.setProperty(Xt(Ct),typeof Mt=="number"?Mt+"px":""+Mt);else Ye==="tabIndex"?Ue.tabIndex=wt:Ue.setAttribute(Xt(Ye),wt.toString());return lt.root=Ue,lt}t.h=Ni;function Xt(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function Fi(X,Q){const he=new h.$Nd,Ee=new MutationObserver(ke=>{for(const He of ke)He.type==="attributes"&&He.attributeName&&he.fire(He.attributeName)});return Ee.observe(X,{attributes:!0,attributeFilter:Q}),{onDidChangeAttribute:he.event,dispose:()=>{Ee.disconnect(),he.dispose()}}}function Yt(X,Q){for(const{name:he,value:Ee}of X.attributes)Q.setAttribute(he,Ee)}t.$1P=Yt;function Pi(X,Q,he){const Ee=X.getAttribute(he);Ee?Q.setAttribute(he,Ee):Q.removeAttribute(he)}function Oi(X,Q,he){Yt(X,Q);const Ee=Fi(X,he);return(0,d.$Pc)(Ee,Ee.onDidChangeAttribute(ke=>Pi(X,Q,ke)))}t.$2P=Oi}),define(be[52],$e([1,0,3,2,114]),function(re,t,D,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5P=t.$4P=t.$3P=void 0;class _ extends O.$Sc{constructor(h,f){super(),this.B((0,D.$GO)(h,"dragover",d=>{d.preventDefault(),this.a||(this.a=setTimeout(()=>{f(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(d=>{this.B((0,D.$GO)(h,d,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$3P=_,t.$4P={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Qr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function p(v,h,f,d,T){const s=document.createElement("div");s.className=f,s.textContent=h,T&&(s.style.color=T),d&&(s.style.background=d),v.dataTransfer&&(document.body.appendChild(s),v.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>document.body.removeChild(s),0))}t.$5P=p}),define(be[53],$e([1,0,3]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wQ=t.$vQ=t.$uQ=void 0;function O(s,a={}){const e=_(a);return e.textContent=s,e}t.$uQ=O;function i(s,a={}){const e=_(a);return h(e,f(s,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$vQ=i;function _(s){const a=s.inline?"span":"div",e=document.createElement(a);return s.className&&(e.className=s.className),e}t.$wQ=_;class p{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var v;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(v||(v={}));function h(s,a,e,u){let l;if(a.type===2)l=document.createTextNode(a.content||"");else if(a.type===3)l=document.createElement("b");else if(a.type===4)l=document.createElement("i");else if(a.type===7&&u)l=document.createElement("code");else if(a.type===5&&e){const g=document.createElement("a");e.disposables.add(D.$HO(g,"click",n=>{e.callback(String(a.index),n)})),l=g}else a.type===8?l=document.createElement("br"):a.type===1&&(l=s);l&&s!==l&&s.appendChild(l),l&&Array.isArray(a.children)&&a.children.forEach(g=>{h(l,g,e,u)})}function f(s,a){const e={type:1,children:[]};let u=0,l=e;const g=[],n=new p(s);for(;!n.eos();){let r=n.next();const b=r==="\\"&&T(n.peek(),a)!==0;if(b&&(r=n.next()),!b&&d(r,a)&&r===n.peek()){n.advance(),l.type===2&&(l=g.pop());const c=T(r,a);if(l.type===c||l.type===5&&c===6)l=g.pop();else{const o={type:c,children:[]};c===5&&(o.index=u,u++),l.children.push(o),g.push(l),l=o}}else if(r===`
`)l.type===2&&(l=g.pop()),l.children.push({type:8});else if(l.type!==2){const c={type:2,content:r};l.children.push(c),g.push(l),l=c}else l.content+=r}return l.type===2&&(l=g.pop()),g.length,e}function d(s,a){return T(s,a)!==0}function T(s,a){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define(be[54],$e([1,0,3,2]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9P=void 0;class i{constructor(){this.a=new O.$Rc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(p,v){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const h=this.c;this.c=null,p&&h&&h(v)}isMonitoring(){return!!this.b}startMonitoring(p,v,h,f,d){this.isMonitoring()&&this.stopMonitoring(!1),this.b=f,this.c=d;let T=p;try{p.setPointerCapture(v),this.a.add((0,O.$Qc)(()=>{try{p.releasePointerCapture(v)}catch{}}))}catch{T=window}this.a.add(D.$GO(T,D.$pP.POINTER_MOVE,s=>{if(s.buttons!==h){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(D.$GO(T,D.$pP.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$9P=i});var Qe=this&&this.__decorate||function(re,t,D,O){var i=arguments.length,_=i<3?t:O===null?O=Object.getOwnPropertyDescriptor(t,D):O,p;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(re,t,D,O);else for(var v=re.length-1;v>=0;v--)(p=re[v])&&(_=(i<3?p(_):i>3?p(t,D,_):p(t,D))||_);return i>3&&_&&Object.defineProperty(t,D,_),_};define(be[23],$e([1,0,3,11,25,2,44]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6P=t.EventType=void 0;var v;(function(f){f.Tap="-monaco-gesturetap",f.Change="-monaco-gesturechange",f.Start="-monaco-gesturestart",f.End="-monaco-gesturesend",f.Contextmenu="-monaco-gesturecontextmenu"})(v||(t.EventType=v={}));class h extends _.$Sc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new p.$2c,this.h=new p.$2c,this.m={},this.j=null,this.n=0,this.B(D.$GO(document,"touchstart",d=>this.s(d),{passive:!1})),this.B(D.$GO(document,"touchend",d=>this.u(d))),this.B(D.$GO(document,"touchmove",d=>this.D(d),{passive:!1}))}static addTarget(d){if(!h.isTouchDevice())return _.$Sc.None;h.b||(h.b=(0,_.$Lc)(new h));const T=h.b.g.push(d);return(0,_.$Qc)(T)}static ignoreTarget(d){if(!h.isTouchDevice())return _.$Sc.None;h.b||(h.b=(0,_.$Lc)(new h));const T=h.b.h.push(d);return(0,_.$Qc)(T)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(d){const T=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let s=0,a=d.targetTouches.length;s<a;s++){const e=d.targetTouches.item(s);this.m[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:T,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[T],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const u=this.w(v.Start,e.target);u.pageX=e.pageX,u.pageY=e.pageY,this.z(u)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}u(d){const T=Date.now(),s=Object.keys(this.m).length;for(let a=0,e=d.changedTouches.length;a<e;a++){const u=d.changedTouches.item(a);if(!this.m.hasOwnProperty(String(u.identifier))){console.warn("move of an UNKNOWN touch",u);continue}const l=this.m[u.identifier],g=Date.now()-l.initialTimeStamp;if(g<h.c&&Math.abs(l.initialPageX-O.$sb(l.rollingPageX))<30&&Math.abs(l.initialPageY-O.$sb(l.rollingPageY))<30){const n=this.w(v.Tap,l.initialTarget);n.pageX=O.$sb(l.rollingPageX),n.pageY=O.$sb(l.rollingPageY),this.z(n)}else if(g>=h.c&&Math.abs(l.initialPageX-O.$sb(l.rollingPageX))<30&&Math.abs(l.initialPageY-O.$sb(l.rollingPageY))<30){const n=this.w(v.Contextmenu,l.initialTarget);n.pageX=O.$sb(l.rollingPageX),n.pageY=O.$sb(l.rollingPageY),this.z(n)}else if(s===1){const n=O.$sb(l.rollingPageX),r=O.$sb(l.rollingPageY),b=O.$sb(l.rollingTimestamps)-l.rollingTimestamps[0],c=n-l.rollingPageX[0],o=r-l.rollingPageY[0],F=[...this.g].filter(H=>l.initialTarget instanceof Node&&H.contains(l.initialTarget));this.C(F,T,Math.abs(c)/b,c>0?1:-1,n,Math.abs(o)/b,o>0?1:-1,r)}this.z(this.w(v.End,l.initialTarget)),delete this.m[u.identifier]}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}w(d,T){const s=document.createEvent("CustomEvent");return s.initEvent(d,!1,!0),s.initialTarget=T,s.tapCount=0,s}z(d){if(d.type===v.Tap){const T=new Date().getTime();let s=0;T-this.n>h.r?s=1:s=2,this.n=T,d.tapCount=s}else(d.type===v.Change||d.type===v.Contextmenu)&&(this.n=0);if(d.initialTarget instanceof Node){for(const T of this.h)if(T.contains(d.initialTarget))return;for(const T of this.g)T.contains(d.initialTarget)&&(T.dispatchEvent(d),this.f=!0)}}C(d,T,s,a,e,u,l,g){this.j=D.$OO(()=>{const n=Date.now(),r=n-T;let b=0,c=0,o=!0;s+=h.a*r,u+=h.a*r,s>0&&(o=!1,b=a*s*r),u>0&&(o=!1,c=l*u*r);const F=this.w(v.Change);F.translationX=b,F.translationY=c,d.forEach(H=>H.dispatchEvent(F)),o||this.C(d,n,s,a,e+b,u,l,g+c)})}D(d){const T=Date.now();for(let s=0,a=d.changedTouches.length;s<a;s++){const e=d.changedTouches.item(s);if(!this.m.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const u=this.m[e.identifier],l=this.w(v.Change,u.initialTarget);l.translationX=e.pageX-O.$sb(u.rollingPageX),l.translationY=e.pageY-O.$sb(u.rollingPageY),l.pageX=e.pageX,l.pageY=e.pageY,this.z(l),u.rollingPageX.length>3&&(u.rollingPageX.shift(),u.rollingPageY.shift(),u.rollingTimestamps.shift()),u.rollingPageX.push(e.pageX),u.rollingPageY.push(e.pageY),u.rollingTimestamps.push(T)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}}t.$6P=h,Qe([i.$hh],h,"isTouchDevice",null)}),define(be[55],$e([1,0,3,89]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AQ=t.$zQ=t.$yQ=void 0;const O=2e4;let i,_,p,v,h;function f(a){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};_=e(),p=e();const u=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};v=u(),h=u(),a.appendChild(i)}t.$yQ=f;function d(a){i&&(_.textContent!==a?(D.$FO(p),s(_,a)):(D.$FO(_),s(p,a)))}t.$zQ=d;function T(a){i&&(v.textContent!==a?(D.$FO(h),s(v,a)):(D.$FO(v),s(h,a)))}t.$AQ=T;function s(a,e){D.$FO(a),e.length>O&&(e=e.substr(0,O)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define(be[116],$e([1,0,3,18]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZQ=t.$YQ=void 0;const i=new RegExp(`(\\\\)?\\$\\((${O.ThemeIcon.iconNameExpression}(?:${O.ThemeIcon.iconModifierExpression})?)\\)`,"g");function _(v){const h=new Array;let f,d=0,T=0;for(;(f=i.exec(v))!==null;){T=f.index||0,d<T&&h.push(v.substring(d,T)),d=(f.index||0)+f[0].length;const[,s,a]=f;h.push(s?`$(${a})`:p({id:a}))}return d<v.length&&h.push(v.substring(d)),h}t.$YQ=_;function p(v){const h=D.$("span");return h.classList.add(...O.ThemeIcon.asClassNameArray(v)),h}t.$ZQ=p}),define(be[117],$e([1,0,3]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JQ=void 0;function O(_){try{_.parentElement?.removeChild(_)}catch{}}class i{constructor(p){this.d=p,this.a=new Map,this.b=new Set,this.c=!1}alloc(p){let v=this.h(p).pop(),h=!1;if(v)h=this.b.has(v.domNode),h&&this.b.delete(v.domNode);else{const f=(0,D.$)(".monaco-list-row"),T=this.i(p).renderTemplate(f);v={domNode:f,templateId:p,templateData:T}}return{row:v,isReusingConnectedDomNode:h}}release(p){p&&this.f(p)}transact(p){if(this.c)throw new Error("Already in transaction");this.c=!0;try{p()}finally{for(const v of this.b)this.g(v);this.b.clear(),this.c=!1}}f(p){const{domNode:v,templateId:h}=p;v&&(this.c?this.b.add(v):this.g(v)),this.h(h).push(p)}g(p){p.classList.remove("scrolling"),O(p)}h(p){let v=this.a.get(p);return v||(v=[],this.a.set(p,v)),v}dispose(){this.a.forEach((p,v)=>{for(const h of p)this.i(v).disposeTemplate(h.templateData),h.templateData=null}),this.a.clear(),this.b.clear()}i(p){const v=this.d.get(p);if(!v)throw new Error(`No renderer found for ${p}`);return v}}t.$JQ=i}),define(be[118],$e([1,0,9,2]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bQ=void 0;class i extends O.$Sc{constructor(p,v,h){super(),this.a=p,this.b=v,this.c=h,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new D.$4g)}setVisibility(p){this.a!==p&&(this.a=p,this.s())}setShouldBeVisible(p){this.g=p,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const p=this.r();this.h!==p&&(this.h=p,this.ensureVisibility())}setIsNeeded(p){this.j!==p&&(this.j=p,this.ensureVisibility())}setDomNode(p){this.f=p,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(p){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(p?" fade":"")))}}t.$bQ=i}),define(be[119],$e([1,0,3,23,11,4,2,5]),function(re,t,D,O,i,_,p,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Q=void 0;class h extends p.$Sc{constructor(d,T,s,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new _.$Nd),this.h=s,this.j(),this.setOptions(d,T)}j(){this.B(O.$6P.addTarget(this.a)),[O.EventType.Tap].forEach(d=>{this.B(D.$GO(this.a,d,T=>{this.a.focus()}))}),this.B(D.$HO(this.a,"click",d=>{D.$rP.stop(d,!0)})),this.B(D.$HO(this.a,"change",d=>{this.a.title=d.target.value,this.g.fire({index:d.target.selectedIndex,selected:d.target.value})})),this.B(D.$HO(this.a,"keydown",d=>{let T=!1;v.$k?(d.keyCode===18||d.keyCode===16||d.keyCode===10)&&(T=!0):(d.keyCode===18&&d.altKey||d.keyCode===10||d.keyCode===3)&&(T=!0),T&&d.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(d,T){(!this.c||!i.$ub(this.c,d))&&(this.c=d,this.a.options.length=0,this.c.forEach((s,a)=>{this.a.add(this.m(s.text,a,s.isDisabled))})),T!==void 0&&this.select(T)}select(d){this.c.length===0?this.f=0:d>=0&&d<this.c.length?this.f=d:d>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(d){this.b.ariaLabel=d,this.a.setAttribute("aria-label",d)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(d){this.a.tabIndex=d?0:-1}render(d){d.classList.add("select-container"),d.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(d){this.h=d,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(d,T,s){const a=document.createElement("option");return a.value=d,a.text=d,a.disabled=!!s,a}}t.$7Q=h}),define(be[56],$e([1,0,24,11,9,48,85,4,26]),function(re,t,D,O,i,_,p,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BS=t.$AS=t.$zS=void 0;function f(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$zS=f;function d(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$AS=d;function T(a){return typeof a.collapsible=="boolean"}class s{constructor(e,u,l,g={}){this.o=e,this.p=u,this.rootRef=[],this.d=new v.$Vd,this.f=new v.$Nd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new v.$Nd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new v.$Nd,this.onDidSplice=this.l.event,this.m=new i.$Qg(_.$Kd),this.h=typeof g.collapseByDefault>"u"?!1:g.collapseByDefault,this.j=g.filter,this.k=typeof g.autoExpandSingleChildren>"u"?!1:g.autoExpandSingleChildren,this.c={parent:void 0,element:l,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,u,l=h.Iterable.empty(),g={}){if(e.length===0)throw new D.$xS(this.o,"Invalid tree location");g.diffIdentityProvider?this.q(g.diffIdentityProvider,e,u,l,g):this.s(e,u,l,g)}q(e,u,l,g=h.Iterable.empty(),n,r=n.diffDepth??0){const{parentNode:b}=this.G(u);if(!b.lastDiffIds)return this.s(u,l,g,n);const c=[...g],o=u[u.length-1],F=new p.$As({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,o),...c,...b.children.slice(o+l)].map(j=>e.getId(j.element).toString())}).ComputeDiff(!1);if(F.quitEarly)return b.lastDiffIds=void 0,this.s(u,l,c,n);const H=u.slice(0,-1),R=(j,z,q)=>{if(r>0)for(let L=0;L<q;L++)j--,z--,this.q(e,[...H,j,0],Number.MAX_SAFE_INTEGER,c[z].children,n,r-1)};let m=Math.min(b.children.length,o+l),w=c.length;for(const j of F.changes.sort((z,q)=>q.originalStart-z.originalStart))R(m,w,m-(j.originalStart+j.originalLength)),m=j.originalStart,w=j.modifiedStart-o,this.s([...H,m],j.originalLength,h.Iterable.slice(c,w,w+j.modifiedLength),n);R(m,w,m)}s(e,u,l=h.Iterable.empty(),{onDidCreateNode:g,onDidDeleteNode:n,diffIdentityProvider:r}){const{parentNode:b,listIndex:c,revealed:o,visible:F}=this.G(e),H=[],R=h.Iterable.map(l,ue=>this.w(ue,b,b.visible?1:0,o,H,g)),m=e[e.length-1],w=b.children.length>0;let j=0;for(let ue=m;ue>=0&&ue<b.children.length;ue--){const le=b.children[ue];if(le.visible){j=le.visibleChildIndex;break}}const z=[];let q=0,L=0;for(const ue of R)z.push(ue),L+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=j+q++);const P=(0,O.$6b)(b.children,m,u,z);r?b.lastDiffIds?(0,O.$6b)(b.lastDiffIds,m,u,z.map(ue=>r.getId(ue.element).toString())):b.lastDiffIds=b.children.map(ue=>r.getId(ue.element).toString()):b.lastDiffIds=void 0;let J=0;for(const ue of P)ue.visible&&J++;if(J!==0)for(let ue=m+z.length;ue<b.children.length;ue++){const le=b.children[ue];le.visible&&(le.visibleChildIndex-=J)}if(b.visibleChildrenCount+=q-J,o&&F){const ue=P.reduce((le,oe)=>le+(oe.visible?oe.renderNodeCount:0),0);this.B(b,L-ue),this.p.splice(c,ue,H)}if(P.length>0&&n){const ue=le=>{n(le),le.children.forEach(ue)};P.forEach(ue)}this.l.fire({insertedNodes:z,deletedNodes:P});const ee=b.children.length>0;w!==ee&&this.setCollapsible(e.slice(0,-1),ee);let ne=b;for(;ne;){if(ne.visibility===2){this.m.trigger(()=>this.refilter());break}ne=ne.parent}}rerender(e){if(e.length===0)throw new D.$xS(this.o,"Invalid tree location");const{node:u,listIndex:l,revealed:g}=this.F(e);u.visible&&g&&this.p.splice(l,1,[u])}updateElementHeight(e,u){if(e.length===0)throw new D.$xS(this.o,"Invalid tree location");const{listIndex:l}=this.F(e);this.p.updateElementHeight(l,u)}has(e){return this.D(e)}getListIndex(e){const{listIndex:u,visible:l,revealed:g}=this.F(e);return l&&g?u:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,u){const l=this.E(e);typeof u>"u"&&(u=!l.collapsible);const g={collapsible:u};return this.d.bufferEvents(()=>this.t(e,g))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,u,l){const g=this.E(e);typeof u>"u"&&(u=!g.collapsed);const n={collapsed:u,recursive:l||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,u){const{node:l,listIndex:g,revealed:n}=this.F(e),r=this.u(l,g,n,u);if(l!==this.c&&this.k&&r&&!T(u)&&l.collapsible&&!l.collapsed&&!u.recursive){let b=-1;for(let c=0;c<l.children.length;c++)if(l.children[c].visible)if(b>-1){b=-1;break}else b=c;b>-1&&this.t([...e,b],u)}return r}u(e,u,l,g){const n=this.v(e,g,!1);if(!l||!e.visible||!n)return n;const r=e.renderNodeCount,b=this.x(e),c=r-(u===-1?0:1);return this.p.splice(u+1,c,b.slice(1)),n}v(e,u,l){let g;if(e===this.c?g=!1:(T(u)?(g=e.collapsible!==u.collapsible,e.collapsible=u.collapsible):e.collapsible?(g=e.collapsed!==u.collapsed,e.collapsed=u.collapsed):g=!1,g&&this.f.fire({node:e,deep:l})),!T(u)&&u.recursive)for(const n of e.children)g=this.v(n,u,!0)||g;return g}expandTo(e){this.d.bufferEvents(()=>{let u=this.E(e);for(;u.parent;)u=u.parent,e=e.slice(0,e.length-1),u.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,u=this.z(this.c);this.p.splice(0,e,u),this.m.cancel()}w(e,u,l,g,n,r){const b={parent:u,element:e.element,children:[],depth:u.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},c=this.C(b,l);b.visibility=c,g&&n.push(b);const o=e.children||h.Iterable.empty(),F=g&&c!==0&&!b.collapsed;let H=0,R=1;for(const m of o){const w=this.w(m,b,c,F,n,r);b.children.push(w),R+=w.renderNodeCount,w.visible&&(w.visibleChildIndex=H++)}return b.collapsible=b.collapsible||b.children.length>0,b.visibleChildrenCount=H,b.visible=c===2?H>0:c===1,b.visible?b.collapsed||(b.renderNodeCount=R):(b.renderNodeCount=0,g&&n.pop()),r?.(b),b}x(e){const u=e.renderNodeCount,l=[];return this.y(e,l),this.B(e.parent,l.length-u),l}y(e,u){if(e.visible===!1)return 0;if(u.push(e),e.renderNodeCount=1,!e.collapsed)for(const l of e.children)e.renderNodeCount+=this.y(l,u);return this.g.fire(e),e.renderNodeCount}z(e){const u=e.renderNodeCount,l=[];return this.A(e,e.visible?1:0,l),this.B(e.parent,l.length-u),l}A(e,u,l,g=!0){let n;if(e!==this.c){if(n=this.C(e,u),n===0)return e.visible=!1,e.renderNodeCount=0,!1;g&&l.push(e)}const r=l.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||n!==0){let c=0;for(const o of e.children)b=this.A(o,n,l,g&&!e.collapsed)||b,o.visible&&(o.visibleChildIndex=c++);e.visibleChildrenCount=c}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?b:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=l.length-r):(e.renderNodeCount=0,g&&l.pop()),this.g.fire(e),e.visible}B(e,u){if(u!==0)for(;e;)e.renderNodeCount+=u,this.g.fire(e),e=e.parent}C(e,u){const l=this.j?this.j.filter(e.element,u):1;return typeof l=="boolean"?(e.filterData=void 0,l?1:0):f(l)?(e.filterData=l.data,d(l.visibility)):(e.filterData=void 0,d(l))}D(e,u=this.c){if(!e||e.length===0)return!0;const[l,...g]=e;return l<0||l>u.children.length?!1:this.D(g,u.children[l])}E(e,u=this.c){if(!e||e.length===0)return u;const[l,...g]=e;if(l<0||l>u.children.length)throw new D.$xS(this.o,"Invalid tree location");return this.E(g,u.children[l])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:u,listIndex:l,revealed:g,visible:n}=this.G(e),r=e[e.length-1];if(r<0||r>u.children.length)throw new D.$xS(this.o,"Invalid tree location");const b=u.children[r];return{node:b,listIndex:l,revealed:g,visible:n&&b.visible}}G(e,u=this.c,l=0,g=!0,n=!0){const[r,...b]=e;if(r<0||r>u.children.length)throw new D.$xS(this.o,"Invalid tree location");for(let c=0;c<r;c++)l+=u.children[c].renderNodeCount;return g=g&&!u.collapsed,n=n&&u.visible,b.length===0?{parentNode:u,listIndex:l,revealed:g,visible:n}:this.G(b,u.children[r],l+1,g,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const u=[];let l=e;for(;l.parent;)u.push(l.parent.children.indexOf(l)),l=l.parent;return u.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,O.$tb)(e)[0]}getFirstElementChild(e){const u=this.E(e);if(u.children.length!==0)return u.children[0].element}getLastElementAncestor(e=[]){const u=this.E(e);if(u.children.length!==0)return this.H(u)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$BS=s}),define(be[120],$e([1,0,56,24,26]),function(re,t,D,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HS=void 0;class _{get size(){return this.d.size}constructor(v,h,f={}){this.k=v,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new D.$BS(v,h,null,f),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,f.sorter&&(this.j={compare(d,T){return f.sorter.compare(d.element,T.element)}}),this.h=f.identityProvider}setChildren(v,h=i.Iterable.empty(),f={}){const d=this.o(v);this.l(d,this.m(h),f)}l(v,h=i.Iterable.empty(),f){const d=new Set,T=new Set,s=e=>{if(e.element===null)return;const u=e;if(d.add(u.element),this.d.set(u.element,u),this.h){const l=this.h.getId(u.element).toString();T.add(l),this.f.set(l,u)}f.onDidCreateNode?.(u)},a=e=>{if(e.element===null)return;const u=e;if(d.has(u.element)||this.d.delete(u.element),this.h){const l=this.h.getId(u.element).toString();T.has(l)||this.f.delete(l)}f.onDidDeleteNode?.(u)};this.c.splice([...v,0],Number.MAX_VALUE,h,{...f,onDidCreateNode:s,onDidDeleteNode:a})}m(v=i.Iterable.empty()){return this.j&&(v=[...v].sort(this.j.compare.bind(this.j))),i.Iterable.map(v,h=>{let f=this.d.get(h.element);if(!f&&this.h){const s=this.h.getId(h.element).toString();f=this.f.get(s)}if(!f){let s;return typeof h.collapsed>"u"?s=void 0:h.collapsed===O.ObjectTreeElementCollapseState.Collapsed||h.collapsed===O.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:h.collapsed===O.ObjectTreeElementCollapseState.Expanded||h.collapsed===O.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!h.collapsed,{...h,children:this.m(h.children),collapsed:s}}const d=typeof h.collapsible=="boolean"?h.collapsible:f.collapsible;let T;return typeof h.collapsed>"u"||h.collapsed===O.ObjectTreeElementCollapseState.PreserveOrCollapsed||h.collapsed===O.ObjectTreeElementCollapseState.PreserveOrExpanded?T=f.collapsed:h.collapsed===O.ObjectTreeElementCollapseState.Collapsed?T=!0:h.collapsed===O.ObjectTreeElementCollapseState.Expanded?T=!1:T=!!h.collapsed,{...h,collapsible:d,collapsed:T,children:this.m(h.children)}})}rerender(v){const h=this.o(v);this.c.rerender(h)}updateElementHeight(v,h){const f=this.o(v);this.c.updateElementHeight(f,h)}resort(v=null,h=!0){if(!this.j)return;const f=this.o(v),d=this.c.getNode(f);this.l(f,this.n(d,h),{})}n(v,h,f=!0){let d=[...v.children];return(h||f)&&(d=d.sort(this.j.compare.bind(this.j))),i.Iterable.map(d,T=>({element:T.element,collapsible:T.collapsible,collapsed:T.collapsed,children:this.n(T,h,!1)}))}getFirstElementChild(v=null){const h=this.o(v);return this.c.getFirstElementChild(h)}getLastElementAncestor(v=null){const h=this.o(v);return this.c.getLastElementAncestor(h)}has(v){return this.d.has(v)}getListIndex(v){const h=this.o(v);return this.c.getListIndex(h)}getListRenderCount(v){const h=this.o(v);return this.c.getListRenderCount(h)}isCollapsible(v){const h=this.o(v);return this.c.isCollapsible(h)}setCollapsible(v,h){const f=this.o(v);return this.c.setCollapsible(f,h)}isCollapsed(v){const h=this.o(v);return this.c.isCollapsed(h)}setCollapsed(v,h,f){const d=this.o(v);return this.c.setCollapsed(d,h,f)}expandTo(v){const h=this.o(v);this.c.expandTo(h)}refilter(){this.c.refilter()}getNode(v=null){if(v===null)return this.c.getNode(this.c.rootRef);const h=this.d.get(v);if(!h)throw new O.$xS(this.k,`Tree element not found: ${v}`);return h}getNodeLocation(v){return v.element}getParentNodeLocation(v){if(v===null)throw new O.$xS(this.k,"Invalid getParentNodeLocation call");const h=this.d.get(v);if(!h)throw new O.$xS(this.k,`Tree element not found: ${v}`);const f=this.c.getNodeLocation(h),d=this.c.getParentNodeLocation(f);return this.c.getNode(d).element}o(v){if(v===null)return[];const h=this.d.get(v);if(!h)throw new O.$xS(this.k,`Tree element not found: ${v}`);return this.c.getNodeLocation(h)}}t.$HS=_}),define(be[20],$e([1,0,3,14,19,23,2]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0P=void 0;class v extends p.$Sc{f(f,d){this.B(D.$GO(f,D.$pP.CLICK,T=>d(new i.$yO(T))))}j(f,d){this.B(D.$GO(f,D.$pP.MOUSE_DOWN,T=>d(new i.$yO(T))))}m(f,d){this.B(D.$GO(f,D.$pP.MOUSE_OVER,T=>d(new i.$yO(T))))}u(f,d){this.B(D.$GO(f,D.$pP.MOUSE_LEAVE,T=>d(new i.$yO(T))))}z(f,d){this.B(D.$GO(f,D.$pP.KEY_DOWN,T=>d(new O.$DO(T))))}C(f,d){this.B(D.$GO(f,D.$pP.KEY_UP,T=>d(new O.$DO(T))))}D(f,d){this.B(D.$GO(f,D.$pP.INPUT,d))}F(f,d){this.B(D.$GO(f,D.$pP.BLUR,d))}G(f,d){this.B(D.$GO(f,D.$pP.FOCUS,d))}H(f,d){this.B(D.$GO(f,D.$pP.CHANGE,d))}I(f){return _.$6P.ignoreTarget(f)}}t.$0P=v}),define(be[37],$e([1,0,54,20,9,18,3]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_P=t.$$P=void 0,t.$$P=11;class v extends O.$0P{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(..._.ThemeIcon.asClassNameArray(f.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$$P+"px",this.domNode.style.height=t.$$P+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new D.$9P),this.B(p.$HO(this.bgDomNode,p.$pP.POINTER_DOWN,d=>this.h(d))),this.B(p.$HO(this.domNode,p.$pP.POINTER_DOWN,d=>this.h(d))),this.b=this.B(new i.$5g),this.c=this.B(new i.$4g)}h(f){if(!f.target||!(f.target instanceof Element))return;const d=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(d,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,T=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.$_P=v}),define(be[57],$e([1,0,3,40,54,37,118,20,5]),function(re,t,D,O,i,_,p,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cQ=void 0;const f=140;class d extends v.$0P{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new p.$bQ(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$9P),this.s=!0,this.domNode=(0,O.$8P)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(D.$GO(this.domNode.domNode,D.$pP.POINTER_DOWN,a=>this.M(a)))}t(s){const a=this.B(new _.$_P(s));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(s,a,e,u){this.slider=(0,O.$8P)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof u=="number"&&this.slider.setHeight(u),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(D.$GO(this.slider.domNode,D.$pP.POINTER_DOWN,l=>{l.button===0&&(l.preventDefault(),this.O(l))})),this.f(this.slider.domNode,l=>{l.leftButton&&l.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),u=a+this.h.getSliderPosition()+this.h.getSliderSize(),l=this.U(s);e<=l&&l<=u?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let a,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")a=s.offsetX,e=s.offsetY;else{const l=D.$YO(this.domNode.domNode);a=s.pageX-l.left,e=s.pageY-l.top}const u=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(u):this.h.getDesiredScrollPositionFromOffset(u)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const a=this.U(s),e=this.W(s),u=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,l=>{const g=this.W(l),n=Math.abs(g-e);if(h.$j&&n>f){this.P(u.getScrollPosition());return}const b=this.U(l)-a;this.P(u.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const a={};this.writeScrollPosition(a,s),this.b.setScrollPositionNow(a)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$cQ=d}),define(be[121],$e([1,0,19,57,37,41,17]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dQ=void 0;class v extends O.$cQ{constructor(f,d,T){const s=f.getScrollDimensions(),a=f.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:T,scrollbarState:new _.$aQ(d.horizontalHasArrows?d.arrowSize:0,d.horizontal===2?0:d.horizontalScrollbarSize,d.vertical===2?0:d.verticalScrollbarSize,s.width,s.scrollWidth,a.scrollLeft),visibility:d.horizontal,extraScrollbarClassName:"horizontal",scrollable:f,scrollByPage:d.scrollByPage}),d.horizontalHasArrows){const e=(d.arrowSize-i.$$P)/2,u=(d.horizontalScrollbarSize-i.$$P)/2;this.t({className:"scra",icon:p.$Uj.scrollbarButtonLeft,top:u,left:e,bottom:void 0,right:void 0,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new D.$AO(null,1,0))}),this.t({className:"scra",icon:p.$Uj.scrollbarButtonRight,top:u,left:void 0,bottom:void 0,right:e,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new D.$AO(null,-1,0))})}this.w(Math.floor((d.horizontalScrollbarSize-d.horizontalSliderSize)/2),0,void 0,d.horizontalSliderSize)}R(f,d){this.slider.setWidth(f),this.slider.setLeft(d)}Q(f,d){this.domNode.setWidth(f),this.domNode.setHeight(d),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(f){return this.s=this.J(f.scrollWidth)||this.s,this.s=this.L(f.scrollLeft)||this.s,this.s=this.y(f.width)||this.s,this.s}S(f,d){return f}U(f){return f.pageX}W(f){return f.pageY}X(f){this.slider.setHeight(f)}writeScrollPosition(f,d){f.scrollLeft=d}updateOptions(f){this.updateScrollbarSize(f.horizontal===2?0:f.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.n.setVisibility(f.horizontal),this.c=f.scrollByPage}}t.$dQ=v}),define(be[122],$e([1,0,19,57,37,41,17]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eQ=void 0;class v extends O.$cQ{constructor(f,d,T){const s=f.getScrollDimensions(),a=f.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:T,scrollbarState:new _.$aQ(d.verticalHasArrows?d.arrowSize:0,d.vertical===2?0:d.verticalScrollbarSize,0,s.height,s.scrollHeight,a.scrollTop),visibility:d.vertical,extraScrollbarClassName:"vertical",scrollable:f,scrollByPage:d.scrollByPage}),d.verticalHasArrows){const e=(d.arrowSize-i.$$P)/2,u=(d.verticalScrollbarSize-i.$$P)/2;this.t({className:"scra",icon:p.$Uj.scrollbarButtonUp,top:e,left:u,bottom:void 0,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new D.$AO(null,0,1))}),this.t({className:"scra",icon:p.$Uj.scrollbarButtonDown,top:void 0,left:u,bottom:e,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new D.$AO(null,0,-1))})}this.w(0,Math.floor((d.verticalScrollbarSize-d.verticalSliderSize)/2),d.verticalSliderSize,void 0)}R(f,d){this.slider.setHeight(f),this.slider.setTop(d)}Q(f,d){this.domNode.setWidth(d),this.domNode.setHeight(f),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(f){return this.s=this.J(f.scrollHeight)||this.s,this.s=this.L(f.scrollTop)||this.s,this.s=this.y(f.height)||this.s,this.s}S(f,d){return d}U(f){return f.pageY}W(f){return f.pageX}X(f){this.slider.setWidth(f)}writeScrollPosition(f,d){f.scrollTop=d}updateOptions(f){this.updateScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(f.vertical),this.c=f.scrollByPage}}t.$eQ=v}),define(be[58],$e([1,0,16,3,40,19,121,122,20,9,4,2,5,47,96]),function(re,t,D,O,i,_,p,v,h,f,d,T,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=void 0;const e=500,u=50,l=!0;class g{constructor(R,m,w){this.timestamp=R,this.deltaX=m,this.deltaY=w,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,m=0,w=1,j=this.d;do{const z=j===this.c?R:Math.pow(2,-w);if(R-=z,m+=this.b[j].score*z,j===this.c)break;j=(this.a+j-1)%this.a,w++}while(!0);return m<=.5}acceptStandardWheelEvent(R){const m=window.devicePixelRatio/(0,D.$hO)();s.$j||s.$l?this.accept(Date.now(),R.deltaX/m,R.deltaY/m):this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,m,w){const j=new g(R,m,w);j.score=this.f(j),this.c===-1&&this.d===-1?(this.b[0]=j,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=j)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let m=.5;const w=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(m+=.25),Math.min(Math.max(m,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$fQ=n;class r extends h.$0P{get options(){return this.a}constructor(R,m,w){super(),this.O=this.B(new d.$Nd),this.onScroll=this.O.event,this.P=this.B(new d.$Nd),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=F(m),this.b=w,this.B(this.b.onScroll(z=>{this.P.fire(z),this.S(z),this.O.fire(z)}));const j={onMouseWheel:z=>this.R(z),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new v.$eQ(this.b,this.a,j)),this.g=this.B(new p.$dQ(this.b,this.a,j)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$8P)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$8P)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$8P)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,z=>this.Z(z)),this.u(this.t,z=>this.Y(z)),this.L=this.B(new f.$4g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,T.$Nc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,s.$k&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new _.$AO(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,T.$Nc)(this.w),R)){const w=j=>{this.R(new _.$AO(j))};this.w.push(O.$GO(this.t,O.$pP.MOUSE_WHEEL,w,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const m=n.INSTANCE;l&&m.acceptStandardWheelEvent(R);let w=!1;if(R.deltaY||R.deltaX){let z=R.deltaY*this.a.mouseWheelScrollSensitivity,q=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&q+z===0?q=z=0:Math.abs(z)>=Math.abs(q)?q=0:z=0),this.a.flipAxes&&([z,q]=[q,z]);const L=!s.$k&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||L)&&!q&&(q=z,z=0),R.browserEvent&&R.browserEvent.altKey&&(q=q*this.a.fastScrollSensitivity,z=z*this.a.fastScrollSensitivity);const P=this.b.getFutureScrollPosition();let J={};if(z){const ee=u*z,ne=P.scrollTop-(ee<0?Math.floor(ee):Math.ceil(ee));this.c.writeScrollPosition(J,ne)}if(q){const ee=u*q,ne=P.scrollLeft-(ee<0?Math.floor(ee):Math.ceil(ee));this.g.writeScrollPosition(J,ne)}J=this.b.validateScrollPosition(J),(P.scrollLeft!==J.scrollLeft||P.scrollTop!==J.scrollTop)&&(l&&this.a.mouseWheelSmoothScroll&&m.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(J):this.b.setScrollPositionNow(J),w=!0)}let j=w;!j&&this.a.alwaysConsumeMouseWheel&&(j=!0),!j&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(j=!0),j&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),m=R.scrollTop>0,w=R.scrollLeft>0,j=w?" left":"",z=m?" top":"",q=w||m?" top-left-corner":"";this.n.setClassName(`shadow${j}`),this.r.setClassName(`shadow${z}`),this.s.setClassName(`shadow${q}${z}${j}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$gQ=r;class b extends r{constructor(R,m){m=m||{},m.mouseWheelSmoothScroll=!1;const w=new a.$Wr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:j=>O.$OO(j)});super(R,m,w),this.B(w)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$hQ=b;class c extends r{constructor(R,m,w){super(R,m,w)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$iQ=c;class o extends r{constructor(R,m){m=m||{},m.mouseWheelSmoothScroll=!1;const w=new a.$Wr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:j=>O.$OO(j)});super(R,m,w),this.B(w),this.cb=R,this.B(this.onScroll(j=>{j.scrollTopChanged&&(this.cb.scrollTop=j.scrollTop),j.scrollLeftChanged&&(this.cb.scrollLeft=j.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$jQ=o;function F(H){const R={lazyRender:typeof H.lazyRender<"u"?H.lazyRender:!1,className:typeof H.className<"u"?H.className:"",useShadows:typeof H.useShadows<"u"?H.useShadows:!0,handleMouseWheel:typeof H.handleMouseWheel<"u"?H.handleMouseWheel:!0,flipAxes:typeof H.flipAxes<"u"?H.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof H.consumeMouseWheelIfScrollbarIsNeeded<"u"?H.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof H.alwaysConsumeMouseWheel<"u"?H.alwaysConsumeMouseWheel:!1,scrollYToX:typeof H.scrollYToX<"u"?H.scrollYToX:!1,mouseWheelScrollSensitivity:typeof H.mouseWheelScrollSensitivity<"u"?H.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof H.fastScrollSensitivity<"u"?H.fastScrollSensitivity:5,scrollPredominantAxis:typeof H.scrollPredominantAxis<"u"?H.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof H.mouseWheelSmoothScroll<"u"?H.mouseWheelSmoothScroll:!0,arrowSize:typeof H.arrowSize<"u"?H.arrowSize:11,listenOnDomNode:typeof H.listenOnDomNode<"u"?H.listenOnDomNode:null,horizontal:typeof H.horizontal<"u"?H.horizontal:1,horizontalScrollbarSize:typeof H.horizontalScrollbarSize<"u"?H.horizontalScrollbarSize:10,horizontalSliderSize:typeof H.horizontalSliderSize<"u"?H.horizontalSliderSize:0,horizontalHasArrows:typeof H.horizontalHasArrows<"u"?H.horizontalHasArrows:!1,vertical:typeof H.vertical<"u"?H.vertical:1,verticalScrollbarSize:typeof H.verticalScrollbarSize<"u"?H.verticalScrollbarSize:10,verticalHasArrows:typeof H.verticalHasArrows<"u"?H.verticalHasArrows:!1,verticalSliderSize:typeof H.verticalSliderSize<"u"?H.verticalSliderSize:0,scrollByPage:typeof H.scrollByPage<"u"?H.scrollByPage:!1};return R.horizontalSliderSize=typeof H.horizontalSliderSize<"u"?H.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof H.verticalSliderSize<"u"?H.verticalSliderSize:R.verticalScrollbarSize,s.$k&&(R.className+=" mac"),R}}),define(be[59],$e([1,0,52,3,21,23,58,11,9,25,4,2,46,47,80,117,6]),function(re,t,D,O,i,_,p,v,h,f,d,T,s,a,e,u,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NQ=t.$MQ=t.$LQ=t.$KQ=void 0;const g={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(R){return[R]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(m){this.d=m}constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.$KQ=r;class b{constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.$LQ=b;class c{constructor(){this.types=[],this.files=[]}update(m){if(m.types&&this.types.splice(0,this.types.length,...m.types),m.files){this.files.splice(0,this.files.length);for(let w=0;w<m.files.length;w++){const j=m.files.item(w);j&&(j.size||j.type)&&this.files.push(j)}}}getData(){return{types:this.types,files:this.files}}}t.$MQ=c;function o(R,m){return Array.isArray(R)&&Array.isArray(m)?(0,v.$ub)(R,m):R===m}class F{constructor(m){m?.getSetSize?this.getSetSize=m.getSetSize.bind(m):this.getSetSize=(w,j,z)=>z,m?.getPosInSet?this.getPosInSet=m.getPosInSet.bind(m):this.getPosInSet=(w,j)=>j+1,m?.getRole?this.getRole=m.getRole.bind(m):this.getRole=w=>"listitem",m?.isChecked?this.isChecked=m.isChecked.bind(m):this.isChecked=w=>{}}}class H{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(m){if(m!==this.O){if(m&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=m,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const w of this.d)this.Y(w);this.V(),this.q.setScrollDimensions({width:(0,O.$2O)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(m,w,j,z=n){if(this.Q=w,this.domId=`list_id_${++H.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new h.$Qg(50),this.v=!1,this.x=T.$Sc.None,this.y=0,this.G=!1,this.J=T.$Sc.None,this.K=T.$Sc.None,this.L=new T.$Rc,this.M=new d.$Nd,this.N=new d.$Nd,this.onDidChangeContentHeight=d.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=d.Event.latch(this.N.event,void 0,this.L),this.O=!1,z.horizontalScrolling&&z.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$IQ(z.paddingTop??0);for(const L of j)this.j.set(L.templateId,L);this.h=this.L.add(new u.$JQ(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof z.mouseSupport=="boolean"?z.mouseSupport:!0),this.O=z.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof z.paddingBottom>"u"?0:z.paddingBottom,this.D=new F(z.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(z.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(_.$6P.addTarget(this.o)),this.p=this.L.add(new a.$Wr({forceIntegerValues:!0,smoothScrollDuration:z.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:L=>(0,O.$OO)(L)})),this.q=this.L.add(new p.$iQ(this.o,{alwaysConsumeMouseWheel:z.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:z.verticalScrollMode??n.verticalScrollMode,useShadows:z.useShadows??n.useShadows,mouseWheelScrollSensitivity:z.mouseWheelScrollSensitivity,fastScrollSensitivity:z.fastScrollSensitivity,scrollByPage:z.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),m.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,O.$GO)(this.o,_.EventType.Change,L=>this.hb(L))),this.L.add((0,O.$GO)(this.q.getDomNode(),"scroll",L=>L.target.scrollTop=0)),this.L.add((0,O.$GO)(this.domNode,"dragover",L=>this.jb(this.fb(L)))),this.L.add((0,O.$GO)(this.domNode,"drop",L=>this.lb(this.fb(L)))),this.L.add((0,O.$GO)(this.domNode,"dragleave",L=>this.kb(this.fb(L)))),this.L.add((0,O.$GO)(this.domNode,"dragend",L=>this.mb(L))),this.z=z.setRowLineHeight??n.setRowLineHeight,this.A=z.setRowHeight??n.setRowHeight,this.B=z.supportDynamicHeights??n.supportDynamicHeights,this.F=z.dnd??this.L.add(n.dnd),this.layout(z.initialSize?.height,z.initialSize?.width)}updateOptions(m){m.paddingBottom!==void 0&&(this.C=m.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),m.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(m.smoothScrolling?125:0),m.horizontalScrolling!==void 0&&(this.P=m.horizontalScrolling);let w;if(m.scrollByPage!==void 0&&(w={...w??{},scrollByPage:m.scrollByPage}),m.mouseWheelScrollSensitivity!==void 0&&(w={...w??{},mouseWheelScrollSensitivity:m.mouseWheelScrollSensitivity}),m.fastScrollSensitivity!==void 0&&(w={...w??{},fastScrollSensitivity:m.fastScrollSensitivity}),w&&this.q.updateOptions(w),m.paddingTop!==void 0&&m.paddingTop!==this.g.paddingTop){const j=this.sb(this.k,this.m),z=m.paddingTop-this.g.paddingTop;this.g.paddingTop=m.paddingTop,this.W(j,Math.max(0,this.k+z),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(m){this.q.delegateScrollFromMouseWheelEvent(m)}delegateVerticalScrollbarPointerDown(m){this.q.delegateVerticalScrollbarPointerDown(m)}updateElementHeight(m,w,j){if(m<0||m>=this.d.length)return;const z=this.d[m].size;if(typeof w>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[m].lastDynamicHeightWidth=void 0,w=z+this.ub(m)}if(z===w)return;const q=this.sb(this.k,this.m);let L=0;m<q.start||j!==null&&j>m&&j<q.end?L=w-z:L=0,this.g.splice(m,1,[{size:w}]),this.d[m].size=w,this.W(q,Math.max(0,this.k+L),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(m,w,j=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(m,w,j)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(m,w,j=[]){const z=this.sb(this.k,this.m),q={start:m,end:m+w},L=s.Range.intersect(z,q),P=new Map;for(let V=L.end-1;V>=L.start;V--){const G=this.d[V];if(G.dragStartDisposable.dispose(),G.checkedDisposable.dispose(),G.row){let k=P.get(G.templateId);k||(k=[],P.set(G.templateId,k));const x=this.j.get(G.templateId);x&&x.disposeElement&&x.disposeElement(G.element,V,G.row.templateData,G.size),k.push(G.row)}G.row=null}const J={start:m+w,end:this.d.length},ee=s.Range.intersect(J,z),ne=s.Range.relativeComplement(J,z),ue=j.map(V=>({id:String(this.f++),element:V,templateId:this.Q.getTemplateId(V),size:this.Q.getHeight(V),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:T.$Sc.None,checkedDisposable:T.$Sc.None}));let le;m===0&&w>=this.d.length?(this.g=new e.$IQ(this.g.paddingTop),this.g.splice(0,0,ue),le=this.d,this.d=ue):(this.g.splice(m,w,ue),le=this.d.splice(m,w,...ue));const oe=j.length-w,me=this.sb(this.k,this.m),Se=(0,e.$GQ)(ee,oe),Te=s.Range.intersect(me,Se);for(let V=Te.start;V<Te.end;V++)this.Z(this.d[V],V);const Pe=s.Range.relativeComplement(Se,me);for(const V of Pe)for(let G=V.start;G<V.end;G++)this.ab(G);const de=ne.map(V=>(0,e.$GQ)(V,oe)),fe=[{start:m,end:m+j.length},...de].map(V=>s.Range.intersect(me,V)),Y=this.vb(fe);for(const V of fe)for(let G=V.start;G<V.end;G++){const k=this.d[G],$=P.get(k.templateId)?.pop();this.X(G,Y,$)}for(const V of P.values())for(const G of V)this.h.release(G);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),le.map(V=>V.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,O.$OO)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let m=0;for(const w of this.d)typeof w.width<"u"&&(m=Math.max(m,w.width));this.E=m,this.q.setScrollDimensions({scrollWidth:m===0?0:m+10}),this.N.fire(this.E)}updateWidth(m){if(!this.P||typeof this.E>"u")return;const w=this.d[m];this.Y(w),typeof w.width<"u"&&w.width>this.E&&(this.E=w.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const m of this.d)m.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const m=this.sb(this.k,this.m),w=this.g.positionAt(m.start),j=this.g.positionAt(m.start+1);return j!==-1&&(j-w)/2+w<this.scrollTop?m.start+1:m.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(m){return this.d[m].element}indexOf(m){return this.d.findIndex(w=>w.element===m)}domElement(m){const w=this.d[m].row;return w&&w.domNode}elementHeight(m){return this.d[m].size}elementTop(m){return this.g.positionAt(m)}indexAt(m){return this.g.indexAt(m)}indexAfter(m){return this.g.indexAfter(m)}layout(m,w){const j={height:typeof m=="number"?m:(0,O.$4O)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,j.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(j),typeof w<"u"&&(this.n=w,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof w=="number"?w:(0,O.$2O)(this.domNode)})}W(m,w,j,z,q,L=!1){const P=this.sb(w,j),J=s.Range.relativeComplement(P,m),ee=s.Range.relativeComplement(m,P),ne=this.vb(J);if(L){const ue=s.Range.intersect(m,P);for(let le=ue.start;le<ue.end;le++)this.Z(this.d[le],le)}this.h.transact(()=>{for(const ue of ee)for(let le=ue.start;le<ue.end;le++)this.ab(le);for(const ue of J)for(let le=ue.start;le<ue.end;le++)this.X(le,ne)}),z!==void 0&&(this.o.style.left=`-${z}px`),this.o.style.top=`-${w}px`,this.P&&q!==void 0&&(this.o.style.width=`${Math.max(q,this.n)}px`),this.k=w,this.m=j}X(m,w,j){const z=this.d[m];let q=!1;if(!z.row)if(j)z.row=j;else{const ne=this.h.alloc(z.templateId);z.row=ne.row,q=ne.isReusingConnectedDomNode}const L=this.D.getRole(z.element)||"listitem";z.row.domNode.setAttribute("role",L);const P=this.D.isChecked(z.element);if(typeof P=="boolean")z.row.domNode.setAttribute("aria-checked",String(!!P));else if(P){const ne=ue=>z.row.domNode.setAttribute("aria-checked",String(!!ue));ne(P.value),z.checkedDisposable=P.onDidChange(ne)}(q||!z.row.domNode.parentElement)&&(w?this.o.insertBefore(z.row.domNode,w):this.o.appendChild(z.row.domNode)),this.Z(z,m);const J=this.j.get(z.templateId);if(!J)throw new Error(`No renderer found for template id ${z.templateId}`);J?.renderElement(z.element,m,z.row.templateData,z.size);const ee=this.F.getDragURI(z.element);z.dragStartDisposable.dispose(),z.row.domNode.draggable=!!ee,ee&&(z.dragStartDisposable=(0,O.$GO)(z.row.domNode,"dragstart",ne=>this.ib(z.element,ee,ne))),this.P&&(this.Y(z),this.U())}Y(m){if(!m.row||!m.row.domNode)return;m.row.domNode.style.width="fit-content",m.width=(0,O.$2O)(m.row.domNode);const w=window.getComputedStyle(m.row.domNode);w.paddingLeft&&(m.width+=parseFloat(w.paddingLeft)),w.paddingRight&&(m.width+=parseFloat(w.paddingRight)),m.row.domNode.style.width=""}Z(m,w){m.row.domNode.style.top=`${this.elementTop(w)}px`,this.A&&(m.row.domNode.style.height=`${m.size}px`),this.z&&(m.row.domNode.style.lineHeight=`${m.size}px`),m.row.domNode.setAttribute("data-index",`${w}`),m.row.domNode.setAttribute("data-last-element",w===this.length-1?"true":"false"),m.row.domNode.setAttribute("data-parity",w%2===0?"even":"odd"),m.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(m.element,w,this.length))),m.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(m.element,w))),m.row.domNode.setAttribute("id",this.getElementDomId(w)),m.row.domNode.classList.toggle("drop-target",m.dropTarget)}ab(m){const w=this.d[m];if(w.dragStartDisposable.dispose(),w.checkedDisposable.dispose(),w.row){const j=this.j.get(w.templateId);j&&j.disposeElement&&j.disposeElement(w.element,m,w.row.templateData,w.size),this.h.release(w.row),w.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(m,w){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:m,reuseAnimation:w})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(m){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:m})}get scrollTop(){return this.getScrollTop()}set scrollTop(m){this.setScrollTop(m)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return d.Event.map(this.L.add(new i.$xQ(this.domNode,"click")).event,m=>this.bb(m),this.L)}get onMouseDblClick(){return d.Event.map(this.L.add(new i.$xQ(this.domNode,"dblclick")).event,m=>this.bb(m),this.L)}get onMouseMiddleClick(){return d.Event.filter(d.Event.map(this.L.add(new i.$xQ(this.domNode,"auxclick")).event,m=>this.bb(m),this.L),m=>m.browserEvent.button===1,this.L)}get onMouseUp(){return d.Event.map(this.L.add(new i.$xQ(this.domNode,"mouseup")).event,m=>this.bb(m),this.L)}get onMouseDown(){return d.Event.map(this.L.add(new i.$xQ(this.domNode,"mousedown")).event,m=>this.bb(m),this.L)}get onMouseOver(){return d.Event.map(this.L.add(new i.$xQ(this.domNode,"mouseover")).event,m=>this.bb(m),this.L)}get onMouseMove(){return d.Event.map(this.L.add(new i.$xQ(this.domNode,"mousemove")).event,m=>this.bb(m),this.L)}get onMouseOut(){return d.Event.map(this.L.add(new i.$xQ(this.domNode,"mouseout")).event,m=>this.bb(m),this.L)}get onContextMenu(){return d.Event.any(d.Event.map(this.L.add(new i.$xQ(this.domNode,"contextmenu")).event,m=>this.bb(m),this.L),d.Event.map(this.L.add(new i.$xQ(this.domNode,_.EventType.Contextmenu)).event,m=>this.eb(m),this.L))}get onTouchStart(){return d.Event.map(this.L.add(new i.$xQ(this.domNode,"touchstart")).event,m=>this.db(m),this.L)}get onTap(){return d.Event.map(this.L.add(new i.$xQ(this.o,_.EventType.Tap)).event,m=>this.eb(m),this.L)}bb(m){const w=this.rb(m.target||null),j=typeof w>"u"?void 0:this.d[w],z=j&&j.element;return{browserEvent:m,index:w,element:z}}db(m){const w=this.rb(m.target||null),j=typeof w>"u"?void 0:this.d[w],z=j&&j.element;return{browserEvent:m,index:w,element:z}}eb(m){const w=this.rb(m.initialTarget||null),j=typeof w>"u"?void 0:this.d[w],z=j&&j.element;return{browserEvent:m,index:w,element:z}}fb(m){const w=this.rb(m.target||null),j=typeof w>"u"?void 0:this.d[w],z=j&&j.element;return{browserEvent:m,index:w,element:z}}gb(m){try{const w=this.sb(this.k,this.m);this.W(w,m.scrollTop,m.height,m.scrollLeft,m.scrollWidth),this.B&&this.tb(m.scrollTop,m.height,m.inSmoothScrolling)}catch(w){throw console.error("Got bad scroll event:",m),w}}hb(m){m.preventDefault(),m.stopPropagation(),this.scrollTop-=m.translationY}ib(m,w,j){if(!j.dataTransfer)return;const z=this.F.getDragElements(m);if(j.dataTransfer.effectAllowed="copyMove",j.dataTransfer.setData(D.$4P.TEXT,w),j.dataTransfer.setDragImage){let q;this.F.getDragLabel&&(q=this.F.getDragLabel(z,j)),typeof q>"u"&&(q=String(z.length));const L=(0,O.$)(".monaco-drag-image");L.textContent=q;const J=(ee=>{for(;ee&&!ee.classList.contains("monaco-workbench");)ee=ee.parentElement;return ee||document.body})(this.domNode);J.appendChild(L),j.dataTransfer.setDragImage(L,-10,-10),setTimeout(()=>J.removeChild(L),0)}this.domNode.classList.add("dragging"),this.H=new r(z),g.CurrentDragAndDropData=new b(z),this.F.onDragStart?.(this.H,j)}jb(m){if(m.browserEvent.preventDefault(),this.K.dispose(),g.CurrentDragAndDropData&&g.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(m.browserEvent),!m.browserEvent.dataTransfer))return!1;if(!this.H)if(g.CurrentDragAndDropData)this.H=g.CurrentDragAndDropData;else{if(!m.browserEvent.dataTransfer.types)return!1;this.H=new c}const w=this.F.onDragOver(this.H,m.element,m.index,m.browserEvent);if(this.G=typeof w=="boolean"?w:w.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;m.browserEvent.dataTransfer.dropEffect=typeof w!="boolean"&&w.effect===0?"copy":"move";let j;if(typeof w!="boolean"&&w.feedback?j=w.feedback:typeof m.index>"u"?j=[-1]:j=[m.index],j=(0,v.$Mb)(j).filter(z=>z>=-1&&z<this.length).sort((z,q)=>z-q),j=j[0]===-1?[-1]:j,o(this.I,j))return!0;if(this.I=j,this.J.dispose(),j[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,T.$Qc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const z of j){const q=this.d[z];q.dropTarget=!0,q.row?.domNode.classList.add("drop-target")}this.J=(0,T.$Qc)(()=>{for(const z of j){const q=this.d[z];q.dropTarget=!1,q.row?.domNode.classList.remove("drop-target")}})}return!0}kb(m){this.K.dispose(),this.K=(0,h.$Vg)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,m.element,m.index,m.browserEvent)}lb(m){if(!this.G)return;const w=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,g.CurrentDragAndDropData=void 0,!(!w||!m.browserEvent.dataTransfer)&&(m.browserEvent.preventDefault(),w.update(m.browserEvent.dataTransfer),this.F.drop(w,m.element,m.index,m.browserEvent))}mb(m){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,g.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(m)}nb(){this.I=void 0,this.J.dispose(),this.J=T.$Sc.None}ob(m){if(!this.w){const w=(0,O.$VO)(this.domNode).top;this.w=(0,O.$LP)(this.pb.bind(this,w))}this.x.dispose(),this.x=(0,h.$Vg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=m.pageY}pb(m){if(this.y===void 0)return;const w=this.y-m,j=this.renderHeight-35;w<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(w-35))):w>j&&(this.scrollTop+=Math.min(14,Math.floor(.3*(w-j))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(m){const w=this.q.getDomNode();let j=m;for(;j instanceof HTMLElement&&j!==this.o&&w.contains(j);){const z=j.getAttribute("data-index");if(z){const q=Number(z);if(!isNaN(q))return q}j=j.parentElement}}sb(m,w){return{start:this.g.indexAt(m),end:this.g.indexAfter(m+w-1)}}tb(m,w,j){const z=this.sb(m,w);let q,L;m===this.elementTop(z.start)?(q=z.start,L=0):z.end-z.start>1&&(q=z.start+1,L=this.elementTop(q)-m);let P=0;for(;;){const J=this.sb(m,w);let ee=!1;for(let ne=J.start;ne<J.end;ne++){const ue=this.ub(ne);ue!==0&&this.g.splice(ne,1,[this.d[ne]]),P+=ue,ee=ee||ue!==0}if(!ee){P!==0&&this.S();const ne=s.Range.relativeComplement(z,J);for(const le of ne)for(let oe=le.start;oe<le.end;oe++)this.d[oe].row&&this.ab(oe);const ue=s.Range.relativeComplement(J,z);for(const le of ue)for(let oe=le.start;oe<le.end;oe++){const me=oe+1,Se=me<this.d.length?this.d[me].row:null,Te=Se?Se.domNode:null;this.X(oe,Te)}for(let le=J.start;le<J.end;le++)this.d[le].row&&this.Z(this.d[le],le);if(typeof q=="number"){const le=this.p.getFutureScrollPosition().scrollTop-m,oe=this.elementTop(q)-L+le;this.setScrollTop(oe,j)}this.M.fire(this.contentHeight);return}}}ub(m){const w=this.d[m];if(this.Q.getDynamicHeight){const L=this.Q.getDynamicHeight(w.element);if(L!==null){const P=w.size;return w.size=L,w.lastDynamicHeightWidth=this.n,L-P}}if(!w.hasDynamicHeight||w.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(w.element))return 0;const j=w.size;if(w.row)return w.row.domNode.style.height="",w.size=w.row.domNode.offsetHeight,w.lastDynamicHeightWidth=this.n,w.size-j;const{row:z}=this.h.alloc(w.templateId);z.domNode.style.height="",this.o.appendChild(z.domNode);const q=this.j.get(w.templateId);if(!q)throw new l.$cb("Missing renderer for templateId: "+w.templateId);return q.renderElement(w.element,m,z.templateData,void 0),w.size=z.domNode.offsetHeight,q.disposeElement?.(w.element,m,z.templateData,void 0),this.Q.setDynamicHeight?.(w.element,w.size),w.lastDynamicHeightWidth=this.n,this.o.removeChild(z.domNode),this.h.release(z),w.size-j}vb(m){const w=m[m.length-1];if(!w)return null;const j=this.d[w.end];return!j||!j.row?null:j.row.domNode}getElementDomId(m){return`${this.domId}_${m}`}dispose(){for(const m of this.d)if(m.dragStartDisposable.dispose(),m.checkedDisposable.dispose(),m.row){const w=this.j.get(m.row.templateId);w&&(w.disposeElement?.(m.element,-1,m.row.templateData,void 0),w.disposeTemplate(m.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$NQ=H,Qe([f.$hh],H.prototype,"onMouseClick",null),Qe([f.$hh],H.prototype,"onMouseDblClick",null),Qe([f.$hh],H.prototype,"onMouseMiddleClick",null),Qe([f.$hh],H.prototype,"onMouseUp",null),Qe([f.$hh],H.prototype,"onMouseDown",null),Qe([f.$hh],H.prototype,"onMouseOver",null),Qe([f.$hh],H.prototype,"onMouseMove",null),Qe([f.$hh],H.prototype,"onMouseOut",null),Qe([f.$hh],H.prototype,"onContextMenu",null),Qe([f.$hh],H.prototype,"onTouchStart",null),Qe([f.$hh],H.prototype,"onTap",null)}),define(be[38],$e([1,0,3,21,14,23,55,69,11,9,72,25,4,33,2,45,5,7,68,59,19,95]),function(re,t,D,O,i,_,p,v,h,f,d,T,s,a,e,u,l,g,n,r,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XQ=t.$WQ=t.$VQ=t.$UQ=t.$TQ=t.$SQ=t.$RQ=t.TypeNavigationMode=t.$QQ=t.$PQ=t.$OQ=void 0;class c{constructor(k){this.d=k,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(k){return k}renderElement(k,x,$){const I=this.c.findIndex(M=>M.templateData===$);if(I>=0){const M=this.c[I];this.d.unrender($),M.index=x}else{const M={index:x,templateData:$};this.c.push(M)}this.d.renderIndex(x,$)}splice(k,x,$){const I=[];for(const M of this.c)M.index<k?I.push(M):M.index>=k+x&&I.push({index:M.index+$-x,templateData:M.templateData});this.c=I}renderIndexes(k){for(const{index:x,templateData:$}of this.c)k.indexOf(x)>-1&&this.d.renderIndex(x,$)}disposeTemplate(k){const x=this.c.findIndex($=>$.templateData===k);x<0||this.c.splice(x,1)}}class o{get name(){return this.h}get renderer(){return new c(this)}constructor(k){this.h=k,this.c=0,this.d=[],this.f=[],this.g=new s.$Nd,this.onChange=this.g.event}splice(k,x,$){x=Math.max(0,Math.min(x,this.c-k));const I=$.length-x,M=k+x,N=[];let A=0;for(;A<this.f.length&&this.f[A]<k;)N.push(this.f[A++]);for(let W=0;W<$.length;W++)$[W]&&N.push(W+k);for(;A<this.f.length&&this.f[A]>=M;)N.push(this.f[A++]+I);const E=this.c+I;if(this.f.length>0&&N.length===0&&E>0){const W=this.f.find(S=>S>=k)??E-1;N.push(Math.min(W,E-1))}this.renderer.splice(k,x,$.length),this.k(N,N),this.c=E}renderIndex(k,x){x.classList.toggle(this.h,this.contains(k))}unrender(k){k.classList.remove(this.h)}set(k,x){return this.k(k,[...k].sort(de),x)}k(k,x,$){const I=this.d,M=this.f;this.d=k,this.f=x;const N=Te(M,k);return this.renderer.renderIndexes(N),this.g.fire({indexes:k,browserEvent:$}),I}get(){return this.d}contains(k){return(0,h.$wb)(this.f,k,de)>=0}dispose(){(0,e.$Nc)(this.g)}}Qe([T.$hh],o.prototype,"renderer",null);class F extends o{constructor(k){super("selected"),this.l=k}renderIndex(k,x){super.renderIndex(k,x),this.l&&(this.contains(k)?x.setAttribute("aria-selected","true"):x.setAttribute("aria-selected","false"))}}class H{constructor(k,x,$){this.c=k,this.d=x,this.f=$}splice(k,x,$){if(!this.f)return this.c.splice(k,x,new Array($.length).fill(!1));const I=this.c.get().map(A=>this.f.getId(this.d.element(A)).toString());if(I.length===0)return this.c.splice(k,x,new Array($.length).fill(!1));const M=new Set(I),N=$.map(A=>M.has(this.f.getId(A).toString()));this.c.splice(k,x,N)}}function R(G){return G.tagName==="INPUT"||G.tagName==="TEXTAREA"}t.$OQ=R;function m(G){return G.classList.contains("monaco-editor")?!0:G.classList.contains("monaco-list")||!G.parentElement?!1:m(G.parentElement)}t.$PQ=m;function w(G){return G.tagName==="A"&&G.classList.contains("monaco-button")||G.tagName==="DIV"&&G.classList.contains("monaco-button-dropdown")?!0:G.classList.contains("monaco-list")||!G.parentElement?!1:w(G.parentElement)}t.$QQ=w;class j{get g(){return s.Event.chain(this.c.add(new O.$xQ(this.k.domNode,"keydown")).event,k=>k.filter(x=>!R(x.target)).map(x=>new i.$DO(x)))}constructor(k,x,$){this.h=k,this.k=x,this.c=new e.$Rc,this.d=new e.$Rc,this.f=$.multipleSelectionSupport,this.c.add(this.g(I=>{switch(I.keyCode){case 3:return this.l(I);case 16:return this.o(I);case 18:return this.p(I);case 11:return this.q(I);case 12:return this.s(I);case 9:return this.u(I);case 31:this.f&&(l.$k?I.metaKey:I.ctrlKey)&&this.t(I)}}))}updateOptions(k){k.multipleSelectionSupport!==void 0&&(this.f=k.multipleSelectionSupport)}l(k){k.preventDefault(),k.stopPropagation(),this.h.setSelection(this.h.getFocus(),k.browserEvent)}o(k){k.preventDefault(),k.stopPropagation(),this.h.focusPrevious(1,!1,k.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}p(k){k.preventDefault(),k.stopPropagation(),this.h.focusNext(1,!1,k.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}q(k){k.preventDefault(),k.stopPropagation(),this.h.focusPreviousPage(k.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}s(k){k.preventDefault(),k.stopPropagation(),this.h.focusNextPage(k.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}t(k){k.preventDefault(),k.stopPropagation(),this.h.setSelection((0,h.$Sb)(this.h.length),k.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(k){this.h.getSelection().length&&(k.preventDefault(),k.stopPropagation(),this.h.setSelection([],k.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Qe([T.$hh],j.prototype,"g",null);var z;(function(G){G[G.Automatic=0]="Automatic",G[G.Trigger=1]="Trigger"})(z||(t.TypeNavigationMode=z={}));var q;(function(G){G[G.Idle=0]="Idle",G[G.Typing=1]="Typing"})(q||(q={})),t.$RQ=new class{mightProducePrintableCharacter(G){return G.ctrlKey||G.metaKey||G.altKey?!1:G.keyCode>=31&&G.keyCode<=56||G.keyCode>=21&&G.keyCode<=30||G.keyCode>=98&&G.keyCode<=107||G.keyCode>=85&&G.keyCode<=95}};class L{constructor(k,x,$,I,M){this.o=k,this.p=x,this.q=$,this.s=I,this.t=M,this.c=!1,this.d=q.Idle,this.f=z.Automatic,this.g=!1,this.h=-1,this.k=new e.$Rc,this.l=new e.$Rc,this.updateOptions(k.options)}updateOptions(k){k.typeNavigationEnabled??!0?this.u():this.v(),this.f=k.typeNavigationMode??z.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let k=!1;const x=s.Event.chain(this.k.add(new O.$xQ(this.p.domNode,"keydown")).event,M=>M.filter(N=>!R(N.target)).filter(()=>this.f===z.Automatic||this.g).map(N=>new i.$DO(N)).filter(N=>k||this.s(N)).filter(N=>this.t.mightProducePrintableCharacter(N)).forEach(N=>D.$rP.stop(N,!0)).map(N=>N.browserEvent.key)),$=s.Event.debounce(x,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(x,$),(M,N)=>N===null?null:(M||"")+N,void 0,this.k)(this.x,this,this.k),$(this.w,this,this.k),x(()=>k=!0,void 0,this.k),$(()=>k=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const k=this.o.getFocus();if(k.length>0&&k[0]===this.h){const x=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(k[0]));x&&(0,p.$zQ)(x)}this.h=-1}x(k){if(!k){this.d=q.Idle,this.g=!1;return}const x=this.o.getFocus(),$=x.length>0?x[0]:0,I=this.d===q.Idle?1:0;this.d=q.Typing;for(let M=0;M<this.o.length;M++){const N=($+M+I)%this.o.length,A=this.q.getKeyboardNavigationLabel(this.p.element(N)),E=A&&A.toString();if(this.o.options.typeNavigationEnabled){if(typeof E<"u"){if((0,a.$Dj)(k,E)){this.h=$,this.o.setFocus([N]),this.o.reveal(N);return}const W=(0,a.$Kj)(k,E);if(W&&W[0].end-W[0].start>1&&W.length===1){this.h=$,this.o.setFocus([N]),this.o.reveal(N);return}}}else if(typeof E>"u"||(0,a.$Dj)(k,E)){this.h=$,this.o.setFocus([N]),this.o.reveal(N);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class P{constructor(k,x){this.d=k,this.f=x,this.c=new e.$Rc;const $=s.Event.chain(this.c.add(new O.$xQ(x.domNode,"keydown")).event,M=>M.filter(N=>!R(N.target)).map(N=>new i.$DO(N)));s.Event.chain($,M=>M.filter(N=>N.keyCode===2&&!N.ctrlKey&&!N.metaKey&&!N.shiftKey&&!N.altKey))(this.g,this,this.c)}g(k){if(k.target!==this.f.domNode)return;const x=this.d.getFocus();if(x.length===0)return;const $=this.f.domElement(x[0]);if(!$)return;const I=$.querySelector("[tabIndex]");if(!I||!(I instanceof HTMLElement)||I.tabIndex===-1)return;const M=window.getComputedStyle(I);M.visibility==="hidden"||M.display==="none"||(k.preventDefault(),k.stopPropagation(),I.focus())}dispose(){this.c.dispose()}}function J(G){return l.$k?G.browserEvent.metaKey:G.browserEvent.ctrlKey}t.$SQ=J;function ee(G){return G.browserEvent.shiftKey}t.$TQ=ee;function ne(G){return(0,D.$lP)(G)&&G.button===2}const ue={isSelectionSingleChangeEvent:J,isSelectionRangeChangeEvent:ee};class le{constructor(k){this.k=k,this.f=new e.$Rc,this.g=new s.$Nd,this.onPointer=this.g.event,k.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ue),this.d=typeof k.options.mouseSupport>"u"||!!k.options.mouseSupport,this.d&&(k.onMouseDown(this.s,this,this.f),k.onContextMenu(this.t,this,this.f),k.onMouseDblClick(this.v,this,this.f),k.onTouchStart(this.s,this,this.f),this.f.add(_.$6P.addTarget(k.getHTMLElement()))),s.Event.any(k.onMouseClick,k.onMouseMiddleClick,k.onTap)(this.u,this,this.f)}updateOptions(k){k.multipleSelectionSupport!==void 0&&(this.c=void 0,k.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ue))}o(k){return this.c?this.c.isSelectionSingleChangeEvent(k):!1}p(k){return this.c?this.c.isSelectionRangeChangeEvent(k):!1}q(k){return this.o(k)||this.p(k)}s(k){m(k.browserEvent.target)||(0,D.$cP)()!==k.browserEvent.target&&this.k.domFocus()}t(k){if(R(k.browserEvent.target)||m(k.browserEvent.target))return;const x=typeof k.index>"u"?[]:[k.index];this.k.setFocus(x,k.browserEvent)}u(k){if(!this.d||R(k.browserEvent.target)||m(k.browserEvent.target)||k.browserEvent.isHandledByList)return;k.browserEvent.isHandledByList=!0;const x=k.index;if(typeof x>"u"){this.k.setFocus([],k.browserEvent),this.k.setSelection([],k.browserEvent),this.k.setAnchor(void 0);return}if(this.q(k))return this.w(k);this.k.setFocus([x],k.browserEvent),this.k.setAnchor(x),ne(k.browserEvent)||this.k.setSelection([x],k.browserEvent),this.g.fire(k)}v(k){if(R(k.browserEvent.target)||m(k.browserEvent.target)||this.q(k)||k.browserEvent.isHandledByList)return;k.browserEvent.isHandledByList=!0;const x=this.k.getFocus();this.k.setSelection(x,k.browserEvent)}w(k){const x=k.index;let $=this.k.getAnchor();if(this.p(k)){typeof $>"u"&&($=this.k.getFocus()[0]??x,this.k.setAnchor($));const I=Math.min($,x),M=Math.max($,x),N=(0,h.$Sb)(I,M+1),A=this.k.getSelection(),E=Se(Te(A,[$]),$);if(E.length===0)return;const W=Te(N,Pe(A,E));this.k.setSelection(W,k.browserEvent),this.k.setFocus([x],k.browserEvent)}else if(this.o(k)){const I=this.k.getSelection(),M=I.filter(N=>N!==x);this.k.setFocus([x]),this.k.setAnchor(x),I.length===M.length?this.k.setSelection([...M,x],k.browserEvent):this.k.setSelection(M,k.browserEvent)}}dispose(){this.f.dispose()}}t.$UQ=le;class oe{constructor(k,x){this.c=k,this.d=x}style(k){const x=this.d&&`.${this.d}`,$=[];k.listBackground&&$.push(`.monaco-list${x} .monaco-list-rows { background: ${k.listBackground}; }`),k.listFocusBackground&&($.push(`.monaco-list${x}:focus .monaco-list-row.focused { background-color: ${k.listFocusBackground}; }`),$.push(`.monaco-list${x}:focus .monaco-list-row.focused:hover { background-color: ${k.listFocusBackground}; }`)),k.listFocusForeground&&$.push(`.monaco-list${x}:focus .monaco-list-row.focused { color: ${k.listFocusForeground}; }`),k.listActiveSelectionBackground&&($.push(`.monaco-list${x}:focus .monaco-list-row.selected { background-color: ${k.listActiveSelectionBackground}; }`),$.push(`.monaco-list${x}:focus .monaco-list-row.selected:hover { background-color: ${k.listActiveSelectionBackground}; }`)),k.listActiveSelectionForeground&&$.push(`.monaco-list${x}:focus .monaco-list-row.selected { color: ${k.listActiveSelectionForeground}; }`),k.listActiveSelectionIconForeground&&$.push(`.monaco-list${x}:focus .monaco-list-row.selected .codicon { color: ${k.listActiveSelectionIconForeground}; }`),k.listFocusAndSelectionBackground&&$.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { background-color: ${k.listFocusAndSelectionBackground}; }
			`),k.listFocusAndSelectionForeground&&$.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { color: ${k.listFocusAndSelectionForeground}; }
			`),k.listInactiveFocusForeground&&($.push(`.monaco-list${x} .monaco-list-row.focused { color:  ${k.listInactiveFocusForeground}; }`),$.push(`.monaco-list${x} .monaco-list-row.focused:hover { color:  ${k.listInactiveFocusForeground}; }`)),k.listInactiveSelectionIconForeground&&$.push(`.monaco-list${x} .monaco-list-row.focused .codicon { color:  ${k.listInactiveSelectionIconForeground}; }`),k.listInactiveFocusBackground&&($.push(`.monaco-list${x} .monaco-list-row.focused { background-color:  ${k.listInactiveFocusBackground}; }`),$.push(`.monaco-list${x} .monaco-list-row.focused:hover { background-color:  ${k.listInactiveFocusBackground}; }`)),k.listInactiveSelectionBackground&&($.push(`.monaco-list${x} .monaco-list-row.selected { background-color:  ${k.listInactiveSelectionBackground}; }`),$.push(`.monaco-list${x} .monaco-list-row.selected:hover { background-color:  ${k.listInactiveSelectionBackground}; }`)),k.listInactiveSelectionForeground&&$.push(`.monaco-list${x} .monaco-list-row.selected { color: ${k.listInactiveSelectionForeground}; }`),k.listHoverBackground&&$.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${k.listHoverBackground}; }`),k.listHoverForeground&&$.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${k.listHoverForeground}; }`);const I=(0,D.$OP)(k.listFocusAndSelectionOutline,(0,D.$OP)(k.listSelectionOutline,k.listFocusOutline??""));I&&$.push(`.monaco-list${x}:focus .monaco-list-row.focused.selected { outline: 1px solid ${I}; outline-offset: -1px;}`),k.listFocusOutline&&$.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.focused { outline: 1px solid ${k.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${x}.last-focused .monaco-list-row.focused { outline: 1px solid ${k.listFocusOutline}; outline-offset: -1px; }
			`);const M=(0,D.$OP)(k.listSelectionOutline,k.listInactiveFocusOutline??"");M&&$.push(`.monaco-list${x} .monaco-list-row.focused.selected { outline: 1px dotted ${M}; outline-offset: -1px; }`),k.listSelectionOutline&&$.push(`.monaco-list${x} .monaco-list-row.selected { outline: 1px dotted ${k.listSelectionOutline}; outline-offset: -1px; }`),k.listInactiveFocusOutline&&$.push(`.monaco-list${x} .monaco-list-row.focused { outline: 1px dotted ${k.listInactiveFocusOutline}; outline-offset: -1px; }`),k.listHoverOutline&&$.push(`.monaco-list${x} .monaco-list-row:hover { outline: 1px dashed ${k.listHoverOutline}; outline-offset: -1px; }`),k.listDropBackground&&$.push(`
				.monaco-list${x}.drop-target,
				.monaco-list${x} .monaco-list-rows.drop-target,
				.monaco-list${x} .monaco-list-row.drop-target { background-color: ${k.listDropBackground} !important; color: inherit !important; }
			`),k.tableColumnsBorder&&$.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${k.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),k.tableOddRowsBackgroundColor&&$.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${k.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=$.join(`
`)}}t.$VQ=oe,t.$WQ={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:d.$Ys.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:d.$Ys.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:d.$Ys.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const me={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Se(G,k){const x=G.indexOf(k);if(x===-1)return[];const $=[];let I=x-1;for(;I>=0&&G[I]===k-(x-I);)$.push(G[I--]);for($.reverse(),I=x;I<G.length&&G[I]===k+(I-x);)$.push(G[I++]);return $}function Te(G,k){const x=[];let $=0,I=0;for(;$<G.length||I<k.length;)if($>=G.length)x.push(k[I++]);else if(I>=k.length)x.push(G[$++]);else if(G[$]===k[I]){x.push(G[$]),$++,I++;continue}else G[$]<k[I]?x.push(G[$++]):x.push(k[I++]);return x}function Pe(G,k){const x=[];let $=0,I=0;for(;$<G.length||I<k.length;)if($>=G.length)x.push(k[I++]);else if(I>=k.length)x.push(G[$++]);else if(G[$]===k[I]){$++,I++;continue}else G[$]<k[I]?x.push(G[$++]):I++;return x}const de=(G,k)=>G-k;class ie{constructor(k,x){this.c=k,this.d=x}get templateId(){return this.c}renderTemplate(k){return this.d.map(x=>x.renderTemplate(k))}renderElement(k,x,$,I){let M=0;for(const N of this.d)N.renderElement(k,x,$[M++],I)}disposeElement(k,x,$,I){let M=0;for(const N of this.d)N.disposeElement?.(k,x,$[M],I),M+=1}disposeTemplate(k){let x=0;for(const $ of this.d)$.disposeTemplate(k[x++])}}class fe{constructor(k){this.c=k,this.templateId="a18n"}renderTemplate(k){return k}renderElement(k,x,$){const I=this.c.getAriaLabel(k);I?$.setAttribute("aria-label",I):$.removeAttribute("aria-label");const M=this.c.getAriaLevel&&this.c.getAriaLevel(k);typeof M=="number"?$.setAttribute("aria-level",`${M}`):$.removeAttribute("aria-level")}disposeTemplate(k){}}class Y{constructor(k,x){this.c=k,this.d=x}getDragElements(k){const x=this.c.getSelectedElements();return x.indexOf(k)>-1?x:[k]}getDragURI(k){return this.d.getDragURI(k)}getDragLabel(k,x){if(this.d.getDragLabel)return this.d.getDragLabel(k,x)}onDragStart(k,x){this.d.onDragStart?.(k,x)}onDragOver(k,x,$,I){return this.d.onDragOver(k,x,$,I)}onDragLeave(k,x,$,I){this.d.onDragLeave?.(k,x,$,I)}onDragEnd(k){this.d.onDragEnd?.(k)}drop(k,x,$,I){this.d.drop(k,x,$,I)}dispose(){this.d.dispose()}}class V{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),k=>this.G(k),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),k=>this.G(k),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let k=!1;const x=s.Event.chain(this.y.add(new O.$xQ(this.k.domNode,"keydown")).event,M=>M.map(N=>new i.$DO(N)).filter(N=>k=N.keyCode===58||N.shiftKey&&N.keyCode===68).map(N=>D.$rP.stop(N,!0)).filter(()=>!1)),$=s.Event.chain(this.y.add(new O.$xQ(this.k.domNode,"keyup")).event,M=>M.forEach(()=>k=!1).map(N=>new i.$DO(N)).filter(N=>N.keyCode===58||N.shiftKey&&N.keyCode===68).map(N=>D.$rP.stop(N,!0)).map(({browserEvent:N})=>{const A=this.getFocus(),E=A.length?A[0]:void 0,W=typeof E<"u"?this.k.element(E):void 0,S=typeof E<"u"?this.k.domElement(E):this.k.domNode;return{index:E,element:W,anchor:S,browserEvent:N}})),I=s.Event.chain(this.k.onContextMenu,M=>M.filter(N=>!k).map(({element:N,index:A,browserEvent:E})=>({element:N,index:A,anchor:new b.$yO(E),browserEvent:E})));return s.Event.any(x,$,I)}get onKeyDown(){return this.y.add(new O.$xQ(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new O.$xQ(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new O.$xQ(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new O.$xQ(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new O.$xQ(this.k.domNode,"blur",!0)).event)}constructor(k,x,$,I,M=me){this.A=k,this.B=M,this.c=new o("focused"),this.f=new o("anchor"),this.g=new s.$Vd,this.x="",this.y=new e.$Rc,this.z=new s.$Nd,this.onDidDispose=this.z.event;const N=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new F(N!=="listbox");const A=[this.c.renderer,this.d.renderer];this.u=M.accessibilityProvider,this.u&&(A.push(new fe(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),I=I.map(W=>new ie(W.templateId,[...A,W]));const E={...M,dnd:M.dnd&&new Y(this,M.dnd)};if(this.k=this.C(x,$,I,E),this.k.domNode.setAttribute("role",N),M.styleController)this.q=M.styleController(this.k.domId);else{const W=(0,D.$hP)(this.k.domNode);this.q=new oe(W,this.k.domId)}if(this.o=new v.$BQ([new H(this.c,this.k,M.identityProvider),new H(this.d,this.k,M.identityProvider),new H(this.f,this.k,M.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new P(this,this.k)),(typeof M.keyboardSupport!="boolean"||M.keyboardSupport)&&(this.v=new j(this,this.k,M),this.y.add(this.v)),M.keyboardNavigationLabelProvider){const W=M.keyboardNavigationDelegate||t.$RQ;this.t=new L(this,this.k,M.keyboardNavigationLabelProvider,M.keyboardNavigationEventFilter??(()=>!0),W),this.y.add(this.t)}this.w=this.D(M),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(k,x,$,I){return new r.$NQ(k,x,$,I)}D(k){return new le(this)}updateOptions(k={}){this.B={...this.B,...k},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(k),this.v?.updateOptions(k),this.k.updateOptions(k)}get options(){return this.B}splice(k,x,$=[]){if(k<0||k>this.k.length)throw new n.$DQ(this.A,`Invalid start index: ${k}`);if(x<0)throw new n.$DQ(this.A,`Invalid delete count: ${x}`);x===0&&$.length===0||this.g.bufferEvents(()=>this.o.splice(k,x,$))}updateWidth(k){this.k.updateWidth(k)}updateElementHeight(k,x){this.k.updateElementHeight(k,x,null)}rerender(){this.k.rerender()}element(k){return this.k.element(k)}indexOf(k){return this.k.indexOf(k)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(k){this.k.setScrollTop(k)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(k){this.k.setScrollLeft(k)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(k){this.x=k,this.k.domNode.setAttribute("aria-label",k)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(k,x){this.k.layout(k,x)}triggerTypeNavigation(){this.t?.trigger()}setSelection(k,x){for(const $ of k)if($<0||$>=this.length)throw new n.$DQ(this.A,`Invalid index ${$}`);this.d.set(k,x)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(k=>this.k.element(k))}setAnchor(k){if(typeof k>"u"){this.f.set([]);return}if(k<0||k>=this.length)throw new n.$DQ(this.A,`Invalid index ${k}`);this.f.set([k])}getAnchor(){return(0,h.$Ob)(this.f.get(),void 0)}getAnchorElement(){const k=this.getAnchor();return typeof k>"u"?void 0:this.element(k)}setFocus(k,x){for(const $ of k)if($<0||$>=this.length)throw new n.$DQ(this.A,`Invalid index ${$}`);this.c.set(k,x)}focusNext(k=1,x=!1,$,I){if(this.length===0)return;const M=this.c.get(),N=this.E(M.length>0?M[0]+k:0,x,I);N>-1&&this.setFocus([N],$)}focusPrevious(k=1,x=!1,$,I){if(this.length===0)return;const M=this.c.get(),N=this.F(M.length>0?M[0]-k:0,x,I);N>-1&&this.setFocus([N],$)}async focusNextPage(k,x){let $=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);$=$===0?0:$-1;const I=this.getFocus()[0];if(I!==$&&(I===void 0||$>I)){const M=this.F($,!1,x);M>-1&&I!==M?this.setFocus([M],k):this.setFocus([$],k)}else{const M=this.k.getScrollTop();let N=M+this.k.renderHeight;$>I&&(N-=this.k.elementHeight($)),this.k.setScrollTop(N),this.k.getScrollTop()!==M&&(this.setFocus([]),await(0,f.$Ug)(0),await this.focusNextPage(k,x))}}async focusPreviousPage(k,x){let $;const I=this.k.getScrollTop();I===0?$=this.k.indexAt(I):$=this.k.indexAfter(I-1);const M=this.getFocus()[0];if(M!==$&&(M===void 0||M>=$)){const N=this.E($,!1,x);N>-1&&M!==N?this.setFocus([N],k):this.setFocus([$],k)}else{const N=I;this.k.setScrollTop(I-this.k.renderHeight),this.k.getScrollTop()!==N&&(this.setFocus([]),await(0,f.$Ug)(0),await this.focusPreviousPage(k,x))}}focusLast(k,x){if(this.length===0)return;const $=this.F(this.length-1,!1,x);$>-1&&this.setFocus([$],k)}focusFirst(k,x){this.focusNth(0,k,x)}focusNth(k,x,$){if(this.length===0)return;const I=this.E(k,!1,$);I>-1&&this.setFocus([I],x)}E(k,x=!1,$){for(let I=0;I<this.length;I++){if(k>=this.length&&!x)return-1;if(k=k%this.length,!$||$(this.element(k)))return k;k++}return-1}F(k,x=!1,$){for(let I=0;I<this.length;I++){if(k<0&&!x)return-1;if(k=(this.length+k%this.length)%this.length,!$||$(this.element(k)))return k;k--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(k=>this.k.element(k))}reveal(k,x){if(k<0||k>=this.length)throw new n.$DQ(this.A,`Invalid index ${k}`);const $=this.k.getScrollTop(),I=this.k.elementTop(k),M=this.k.elementHeight(k);if((0,g.$Cf)(x)){const N=M-this.k.renderHeight;this.k.setScrollTop(N*(0,u.$Ol)(x,0,1)+I)}else{const N=I+M,A=$+this.k.renderHeight;I<$&&N>=A||(I<$||N>=A&&M>=this.k.renderHeight?this.k.setScrollTop(I):N>=A&&this.k.setScrollTop(N-this.k.renderHeight))}}getRelativeTop(k){if(k<0||k>=this.length)throw new n.$DQ(this.A,`Invalid index ${k}`);const x=this.k.getScrollTop(),$=this.k.elementTop(k),I=this.k.elementHeight(k);if($<x||$+I>x+this.k.renderHeight)return null;const M=I-this.k.renderHeight;return Math.abs((x-$)/M)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(k){return this.k.getElementDomId(k)}style(k){this.q.style(k)}G({indexes:k,browserEvent:x}){return{indexes:k,elements:k.map($=>this.k.element($)),browserEvent:x}}H(){const k=this.c.get();this.k.domNode.classList.toggle("element-focused",k.length>0),this.I()}I(){const k=this.c.get();if(k.length>0){let x;this.u?.getActiveDescendantId&&(x=this.u.getActiveDescendantId(this.k.element(k[0]))),this.k.domNode.setAttribute("aria-activedescendant",x||this.k.getElementDomId(k[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const k=this.d.get();this.k.domNode.classList.toggle("selection-none",k.length===0),this.k.domNode.classList.toggle("selection-single",k.length===1),this.k.domNode.classList.toggle("selection-multiple",k.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$XQ=V,Qe([T.$hh],V.prototype,"onDidChangeFocus",null),Qe([T.$hh],V.prototype,"onDidChangeSelection",null),Qe([T.$hh],V.prototype,"onContextMenu",null),Qe([T.$hh],V.prototype,"onKeyDown",null),Qe([T.$hh],V.prototype,"onKeyUp",null),Qe([T.$hh],V.prototype,"onKeyPress",null),Qe([T.$hh],V.prototype,"onDidFocus",null),Qe([T.$hh],V.prototype,"onDidBlur",null)}),define(be[60],$e([1,0,6,34,36,12,15]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0j=t.$9j=t.$8j=t.$7j=t.$6j=t.$5j=t.$4j=t.$3j=t.MarkdownStringTextNewlineStyle=void 0;var v;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(v||(t.MarkdownStringTextNewlineStyle=v={}));class h{constructor(g="",n=!1){if(this.value=g,typeof this.value!="string")throw(0,D.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(g,n=0){return this.value+=s(this.supportThemeIcons?(0,O.$Wj)(g):g).replace(/([ \t]+)/g,(r,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,n){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(g,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(g),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(g,n){const r=new RegExp((0,_.$Fe)(n),"g");return g.replace(r,(b,c)=>g.charAt(c-1)!=="\\"?`\\${b}`:b)}}t.$3j=h;function f(l){return d(l)?!l.value:Array.isArray(l)?l.every(f):!0}t.$4j=f;function d(l){return l instanceof h?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}t.$5j=d;function T(l,g){return l===g?!0:!l||!g?!1:l.value===g.value&&l.isTrusted===g.isTrusted&&l.supportThemeIcons===g.supportThemeIcons&&l.supportHtml===g.supportHtml&&(l.baseUri===g.baseUri||!!l.baseUri&&!!g.baseUri&&(0,i.$og)(p.URI.from(l.baseUri),p.URI.from(g.baseUri)))}t.$6j=T;function s(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$7j=s;function a(l){return l.replace(/"/g,"&quot;")}t.$8j=a;function e(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$9j=e;function u(l){const g=[],n=l.split("|").map(b=>b.trim());l=n[0];const r=n[1];if(r){const b=/height=(\d+)/.exec(r),c=/width=(\d+)/.exec(r),o=b?b[1]:"",F=c?c[1]:"",H=isFinite(parseInt(F)),R=isFinite(parseInt(o));H&&g.push(`width="${F}"`),R&&g.push(`height="${o}"`)}return{href:l,dimensions:g}}t.$0j=u}),define(be[123],$e([1,0,3,115,21,53,14,19,116,6,4,60,34,75,27,2,77,51,29,49,36,12,15]),function(re,t,D,O,i,_,p,v,h,f,d,T,s,a,e,u,l,g,n,r,b,c,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Q=t.$4Q=t.$3Q=t.$2Q=t.$1Q=void 0;const F=Object.freeze({image:(Y,V,G)=>{let k=[],x=[];return Y&&({href:Y,dimensions:k}=(0,T.$0j)(Y),x.push(`src="${(0,T.$8j)(Y)}"`)),G&&x.push(`alt="${(0,T.$8j)(G)}"`),V&&x.push(`title="${(0,T.$8j)(V)}"`),k.length&&(x=x.concat(k)),"<img "+x.join(" ")+">"},paragraph:Y=>`<p>${Y}</p>`,link:(Y,V,G)=>typeof Y!="string"?"":(Y===G&&(G=(0,T.$9j)(G)),V=typeof V=="string"?(0,T.$8j)((0,T.$9j)(V)):"",Y=(0,T.$9j)(Y),Y=Y.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Y}" title="${V||Y}">${G}</a>`)});function H(Y,V={},G={}){const k=new u.$Rc;let x=!1;const $=(0,_.$wQ)(V),I=function(C){let U;try{U=(0,g.$lh)(decodeURIComponent(C))}catch{}return U?(U=(0,r.$9m)(U,K=>{if(Y.uris&&Y.uris[K])return o.URI.revive(Y.uris[K])}),encodeURIComponent(JSON.stringify(U))):C},M=function(C,U){const K=Y.uris&&Y.uris[C];let te=o.URI.revive(K);return U?C.startsWith(n.Schemas.data+":")?C:(te||(te=o.URI.parse(C)),n.$cg.uriToBrowserUri(te).toString(!0)):!te||o.URI.parse(C).toString()===te.toString()?C:(te.query&&(te=te.with({query:I(te.query)})),te.toString())},N=new l.marked.Renderer;N.image=F.image,N.link=F.link,N.paragraph=F.paragraph;const A=[],E=[];if(V.codeBlockRendererSync?N.code=(C,U)=>{const K=a.$nM.nextId(),te=V.codeBlockRendererSync(R(U),C);return E.push([K,te]),`<div class="code" data-code="${K}">${(0,c.$Ee)(C)}</div>`}:V.codeBlockRenderer&&(N.code=(C,U)=>{const K=a.$nM.nextId(),te=V.codeBlockRenderer(R(U),C);return A.push(te.then(se=>[K,se])),`<div class="code" data-code="${K}">${(0,c.$Ee)(C)}</div>`}),V.actionHandler){const C=function(te){let se=te.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let ge=se.dataset.href;ge&&(Y.baseUri&&(ge=m(o.URI.from(Y.baseUri),ge)),V.actionHandler.callback(ge,te))}catch(ge){(0,f.$1)(ge)}finally{te.preventDefault()}},U=V.actionHandler.disposables.add(new i.$xQ($,"click")),K=V.actionHandler.disposables.add(new i.$xQ($,"auxclick"));V.actionHandler.disposables.add(d.Event.any(U.event,K.event)(te=>{const se=new v.$yO(te);!se.leftButton&&!se.middleButton||C(se)})),V.actionHandler.disposables.add(D.$GO($,"keydown",te=>{const se=new p.$DO(te);!se.equals(10)&&!se.equals(3)||C(se)}))}Y.supportHtml||(G.sanitizer=C=>(Y.isTrusted?C.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?C:"",G.sanitize=!0,G.silent=!0),G.renderer=N;let W=Y.value??"";W.length>1e5&&(W=`${W.substr(0,1e5)}\u2026`),Y.supportThemeIcons&&(W=(0,s.$Xj)(W));let S;if(V.fillInIncompleteTokens){const C={...l.marked.defaults,...G},U=l.marked.lexer(W,C),K=ne(U);S=l.marked.parser(K,C)}else S=l.marked.parse(W,G);Y.supportThemeIcons&&(S=(0,h.$YQ)(S).map(U=>typeof U=="string"?U:U.outerHTML).join(""));const y=new DOMParser().parseFromString(w(Y,S),"text/html");if(y.body.querySelectorAll("img").forEach(C=>{const U=C.getAttribute("src");if(U){let K=U;try{Y.baseUri&&(K=m(o.URI.from(Y.baseUri),K))}catch{}C.src=M(K,!0)}}),y.body.querySelectorAll("a").forEach(C=>{const U=C.getAttribute("href");if(C.setAttribute("href",""),!U||/^data:|javascript:/i.test(U)||/^command:/i.test(U)&&!Y.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(U))C.replaceWith(...C.childNodes);else{let K=M(U,!1);Y.baseUri&&(K=m(o.URI.from(Y.baseUri),U)),C.dataset.href=K}}),$.innerHTML=w(Y,y.body.innerHTML),A.length>0)Promise.all(A).then(C=>{if(x)return;const U=new Map(C),K=$.querySelectorAll("div[data-code]");for(const te of K){const se=U.get(te.dataset.code??"");se&&D.$yP(te,se)}V.asyncRenderCallback?.()});else if(E.length>0){const C=new Map(E),U=$.querySelectorAll("div[data-code]");for(const K of U){const te=C.get(K.dataset.code??"");te&&D.$yP(K,te)}}if(V.asyncRenderCallback)for(const C of $.getElementsByTagName("img")){const U=k.add(D.$GO(C,"load",()=>{U.dispose(),V.asyncRenderCallback()}))}return{element:$,dispose:()=>{x=!0,k.dispose()}}}t.$1Q=H;function R(Y){if(!Y)return"";const V=Y.split(/[\s+|:|,|\{|\?]/,1);return V.length?V[0]:Y}function m(Y,V){return/^\w[\w\d+.-]*:/.test(V)?V:Y.path.endsWith("/")?(0,b.$yg)(Y,V).toString():(0,b.$yg)((0,b.$ug)(Y),V).toString()}function w(Y,V){const{config:G,allowedSchemes:k}=j(Y);O.addHook("uponSanitizeAttribute",($,I)=>{if(I.attrName==="style"||I.attrName==="class"){if($.tagName==="SPAN"){if(I.attrName==="style"){I.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(I.attrValue);return}else if(I.attrName==="class"){I.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(I.attrValue);return}}I.keepAttr=!1;return}});const x=D.$SP(k);try{return O.sanitize(V,{...G,RETURN_TRUSTED_TYPE:!0})}finally{O.removeHook("uponSanitizeAttribute"),x.dispose()}}t.$2Q=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function j(Y){const V=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return Y.isTrusted&&V.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...D.$TP],ALLOWED_ATTR:t.$2Q,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:V}}function z(Y){return typeof Y=="string"?Y:q(Y)}t.$3Q=z;function q(Y){let V=Y.value??"";V.length>1e5&&(V=`${V.substr(0,1e5)}\u2026`);const G=l.marked.parse(V,{renderer:P.value}).replace(/&(#\d+|[a-zA-Z]+);/g,k=>L.get(k)??k);return w({isTrusted:!1},G).toString()}t.$4Q=q;const L=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),P=new e.$V(()=>{const Y=new l.marked.Renderer;return Y.code=V=>V,Y.blockquote=V=>V,Y.html=V=>"",Y.heading=(V,G,k)=>V+`
`,Y.hr=()=>"",Y.list=(V,G)=>V,Y.listitem=V=>V+`
`,Y.paragraph=V=>V+`
`,Y.table=(V,G)=>V+G+`
`,Y.tablerow=V=>V,Y.tablecell=(V,G)=>V+" ",Y.strong=V=>V,Y.em=V=>V,Y.codespan=V=>V,Y.br=()=>`
`,Y.del=V=>V,Y.image=(V,G,k)=>"",Y.text=V=>V,Y.link=(V,G,k)=>k,Y});function J(Y){let V="";return Y.forEach(G=>{V+=G.raw}),V}function ee(Y){for(const V of Y.tokens)if(V.type==="text"){const G=V.raw.split(`
`),k=G[G.length-1];if(k.includes("`"))return le(Y);if(k.includes("**"))return Pe(Y);if(k.match(/\*\w/))return oe(Y);if(k.match(/(^|\s)__\w/))return de(Y);if(k.match(/(^|\s)_\w/))return me(Y);if(k.match(/(^|\s)\[.*\]\(\w*/))return Se(Y);if(k.match(/(^|\s)\[\w/))return Te(Y)}}function ne(Y){let V,G;for(V=0;V<Y.length;V++){const k=Y[V];if(k.type==="paragraph"&&k.raw.match(/(\n|^)```/)){G=ue(Y.slice(V));break}if(k.type==="paragraph"&&k.raw.match(/(\n|^)\|/)){G=fe(Y.slice(V));break}if(V===Y.length-1&&k.type==="paragraph"){const x=ee(k);if(x){G=[x];break}}}if(G){const k=[...Y.slice(0,V),...G];return k.links=Y.links,k}return Y}t.$5Q=ne;function ue(Y){const V=J(Y);return l.marked.lexer(V+"\n```")}function le(Y){return ie(Y,"`")}function oe(Y){return ie(Y,"*")}function me(Y){return ie(Y,"_")}function Se(Y){return ie(Y,")")}function Te(Y){return ie(Y,"](about:blank)")}function Pe(Y){return ie(Y,"**")}function de(Y){return ie(Y,"__")}function ie(Y,V){const G=J(Array.isArray(Y)?Y:[Y]);return l.marked.lexer(G+V)[0]}function fe(Y){const V=J(Y),G=V.split(`
`);let k,x=!1;for(let $=0;$<G.length;$++){const I=G[$].trim();if(typeof k>"u"&&I.match(/^\s*\|/)){const M=I.match(/(\|[^\|]+)(?=\||$)/g);M&&(k=M.length)}else if(typeof k=="number")if(I.match(/^\s*\|/)){if($!==G.length-1)return;x=!0}else return}if(typeof k=="number"&&k>0){const $=x?G.slice(0,-1).join(`
`):V,I=!!$.match(/\|\s*$/),M=$+(I?"":"|")+`
|${" --- |".repeat(k)}`;return l.marked.lexer(M)}}}),define(be[124],$e([1,0,3,9,28,60,34,2,7,105]),function(re,t,D,O,i,_,p,v,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oQ=t.$nQ=void 0;function d(a,e){(0,h.$yf)(e)?a.title=(0,p.$Yj)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$nQ=d;class T{constructor(e,u,l){this.c=e,this.d=u,this.f=l}async update(e,u,l){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let g;if(e===void 0||(0,h.$yf)(e)||e instanceof HTMLElement)g=e;else if(!(0,h.$Mf)(e.markdown))g=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,f.localize)(0,null),u),this.b=new i.$Xd;const n=this.b.token;if(g=await e.markdown(n),g===void 0&&(g=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(g,u,l)}g(e,u,l){const g=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!g,...l};this.a=this.c.showHover(n,u)}g?.dispose()}h(e){return e?(0,_.$5j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(a,e,u,l){let g,n;const r=(H,R)=>{const m=n!==void 0;H&&(n?.dispose(),n=void 0),R&&(g?.dispose(),g=void 0),m&&a.onDidHideHover?.()},b=(H,R,m)=>new O.$4g(async()=>{(!n||n.isDisposed)&&(n=new T(a,m||e,H>0),await n.update(u,R,l))},H),c=()=>{if(g)return;const H=new v.$Rc,R=j=>r(!1,j.fromElement===e);H.add(D.$GO(e,D.$pP.MOUSE_LEAVE,R,!0));const m=()=>r(!0,!0);H.add(D.$GO(e,D.$pP.MOUSE_DOWN,m,!0));const w={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const j=z=>{w.x=z.x+10,z.target instanceof HTMLElement&&z.target.classList.contains("action-label")&&r(!0,!0)};H.add(D.$GO(e,D.$pP.MOUSE_MOVE,j,!0))}H.add(b(a.delay,!1,w)),g=H},o=D.$GO(e,D.$pP.MOUSE_OVER,c,!0);return{show:H=>{r(!1,!0),b(0,H)},hide:()=>{r(!0,!0)},update:async(H,R)=>{u=H,await n?.update(u,void 0,R)},dispose:()=>{o.dispose(),r(!0,!0)}}}t.$oQ=s}),define(be[125],$e([1,0,3,21,14,123,38,11,4,43,2,5,107,98]),function(re,t,D,O,i,_,p,v,h,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6Q=void 0;const a=D.$,e="selectOption.entry.template";class u{get templateId(){return e}renderTemplate(n){const r=Object.create(null);return r.root=n,r.text=D.$wP(n,a(".option-text")),r.detail=D.$wP(n,a(".option-detail")),r.decoratorRight=D.$wP(n,a(".option-decorator-right")),r}renderElement(n,r,b){const c=b,o=n.text,F=n.detail,H=n.decoratorRight,R=n.isDisabled;c.text.textContent=o,c.detail.textContent=F||"",c.decoratorRight.innerText=H||"",R?c.root.classList.add("option-disabled"):c.root.classList.remove("option-disabled")}disposeTemplate(n){}}class l extends d.$Sc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,r,b,c,o){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=c,this.g=o||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=l.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new h.$Nd,this.B(this.r),this.O(),this.N(b),this.n=r||0,n&&this.setOptions(n,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=D.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=D.$wP(this.w,a(".select-box-details-pane"));const r=D.$wP(this.w,a(".select-box-dropdown-container-width-control")),b=D.$wP(r,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",D.$wP(b,this.D),this.G=0,this.y=D.$hP(this.w),this.w.setAttribute("draggable","true"),this.B(D.$GO(this.w,D.$pP.DRAG_START,c=>{D.$rP.stop(c,!0)}))}O(){this.B(D.$HO(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(D.$GO(this.h,D.$pP.CLICK,r=>{D.$rP.stop(r),this.f?this.X(!0):this.W()})),this.B(D.$GO(this.h,D.$pP.MOUSE_DOWN,r=>{D.$rP.stop(r)}));let n;this.B(D.$GO(this.h,"touchstart",r=>{n=this.f})),this.B(D.$GO(this.h,"touchend",r=>{D.$rP.stop(r),n?this.X(!0):this.W()})),this.B(D.$GO(this.h,D.$pP.KEY_DOWN,r=>{const b=new i.$DO(r);let c=!1;T.$k?(b.keyCode===18||b.keyCode===16||b.keyCode===10||b.keyCode===3)&&(c=!0):(b.keyCode===18&&b.altKey||b.keyCode===16&&b.altKey||b.keyCode===10||b.keyCode===3)&&(c=!0),c&&(this.W(),D.$rP.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,r){v.$ub(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,c)=>{this.h.add(this.U(b.text,c,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",r=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=r,this.h.style.borderColor=b}S(){const n=this.s.selectBackground??"",r=D.$OP(this.s.selectListBackground,n);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,r,b){const c=document.createElement("option");return c.value=n,c.text=n,c.disabled=!!b,c}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,r){return n.appendChild(this.w),this.ab(r),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((r,b)=>{this.hb(b),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=D.$YO(this.h),b=getComputedStyle(this.h),c=parseFloat(b.getPropertyValue("--dropdown-padding-top"))+parseFloat(b.getPropertyValue("--dropdown-padding-bottom")),o=window.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),F=r.top-l.b,H=this.h.offsetWidth,R=this.bb(this.D),m=Math.max(R,Math.round(H)).toString()+"px";this.w.style.width=m,this.z.getHTMLElement().style.height="",this.z.layout();let w=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const j=this.H?this.L:0,z=w+c+j,q=Math.floor((o-c-j)/this.getHeight()),L=Math.floor((F-c-j)/this.getHeight());if(n)return r.top+r.height>window.innerHeight-22||r.top<l.b||q<1&&L<1?!1:(q<l.c&&L>q&&this.m.length>q?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>window.innerHeight-22||r.top<l.b||this.G===0&&q<1||this.G===1&&L<1)return this.X(!0),!1;if(this.G===0){if(this.f&&q+L<1)return this.X(!0),!1;z>o&&(w=q*this.getHeight())}else z>F&&(w=L*this.getHeight());return this.z.layout(w),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=w+c+"px",this.w.style.height=""):this.w.style.height=w+c+"px",this.hb(this.n),this.w.style.width=m,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let r=0;if(n){let b=0,c=0;this.m.forEach((o,F)=>{const H=o.detail?o.detail.length:0,R=o.decoratorRight?o.decoratorRight.length:0,m=o.text.length+H+R;m>c&&(b=F,c=m)}),n.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),r=D.$1O(n)}return r}cb(n){if(this.z)return;this.C=D.$wP(n,a(".select-box-dropdown-list-container")),this.t=new u,this.z=new p.$XQ("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:c=>{let o=c.text;return c.detail&&(o+=`. ${c.detail}`),c.decoratorRight&&(o+=`. ${c.decoratorRight}`),c.description&&(o+=`. ${c.description}`),o},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>T.$k?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new O.$xQ(this.C,"keydown")),b=h.Event.chain(r.event,c=>c.filter(()=>this.z.length>0).map(o=>new i.$DO(o)));this.B(h.Event.chain(b,c=>c.filter(o=>o.keyCode===3))(this.jb,this)),this.B(h.Event.chain(b,c=>c.filter(o=>o.keyCode===2))(this.jb,this)),this.B(h.Event.chain(b,c=>c.filter(o=>o.keyCode===9))(this.ib,this)),this.B(h.Event.chain(b,c=>c.filter(o=>o.keyCode===16))(this.lb,this)),this.B(h.Event.chain(b,c=>c.filter(o=>o.keyCode===18))(this.kb,this)),this.B(h.Event.chain(b,c=>c.filter(o=>o.keyCode===12))(this.nb,this)),this.B(h.Event.chain(b,c=>c.filter(o=>o.keyCode===11))(this.mb,this)),this.B(h.Event.chain(b,c=>c.filter(o=>o.keyCode===14))(this.ob,this)),this.B(h.Event.chain(b,c=>c.filter(o=>o.keyCode===13))(this.pb,this)),this.B(h.Event.chain(b,c=>c.filter(o=>o.keyCode>=21&&o.keyCode<=56||o.keyCode>=85&&o.keyCode<=113))(this.qb,this)),this.B(D.$GO(this.z.getHTMLElement(),D.$pP.POINTER_UP,c=>this.db(c))),this.B(this.z.onMouseOver(c=>typeof c.index<"u"&&this.z.setFocus([c.index]))),this.B(this.z.onDidChangeFocus(c=>this.gb(c))),this.B(D.$GO(this.w,D.$pP.FOCUS_OUT,c=>{!this.f||D.$7O(c.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;D.$rP.stop(n);const r=n.target;if(!r||r.classList.contains("slider"))return;const b=r.closest(".monaco-list-row");if(!b)return;const c=Number(b.getAttribute("data-index")),o=b.classList.contains("option-disabled");c>=0&&c<this.m.length&&!o&&(this.n=c,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,r){const b=o=>{for(let F=0;F<o.childNodes.length;F++){const H=o.childNodes.item(F);(H.tagName&&H.tagName.toLowerCase())==="img"?o.removeChild(H):b(H)}},c=(0,_.$1Q)({value:n,supportThemeIcons:!0},{actionHandler:r});return c.element.classList.add("select-box-description-markdown"),b(c.element),c.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const r=this.m[n],b=r?.description??"",c=r?.descriptionIsMarkdown??!1;if(b){if(c){const o=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(b,o))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){D.$rP.stop(n),this.select(this.F),this.X(!0)}jb(n){D.$rP.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){D.$rP.stop(n,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(D.$rP.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){D.$rP.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){D.$rP.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){D.$rP.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){D.$rP.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const r=f.KeyCodeUtils.toString(n.keyCode);let b=-1;for(let c=0;c<this.m.length-1;c++)if(b=(c+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===r&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),D.$rP.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$6Q=l}),define(be[126],$e([1,0,38,125,119,20,5,97]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9Q=t.$8Q=void 0,t.$8Q={...D.$WQ,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class v extends _.$0P{constructor(f,d,T,s,a){super(),p.$k&&!a?.useCustomDrawn?this.a=new i.$7Q(f,d,s,a):this.a=new O.$6Q(f,d,T,s,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,d){this.a.setOptions(f,d)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}render(f){this.a.render(f)}}t.$9Q=v}),define(be[61],$e([1,0,16,52,3,23,124,126,35,2,5,7,102,50]),function(re,t,D,O,i,_,p,v,h,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=t.$cR=t.$bR=void 0;class a extends f.$Sc{get action(){return this._action}constructor(g,n,r={}){super(),this.m=r,this._context=g||this,this._action=n,n instanceof h.$ui&&this.B(n.onDidChange(b=>{this.element&&this.t(b)}))}t(g){g.enabled!==void 0&&this.u(),g.checked!==void 0&&this.G(),g.class!==void 0&&this.F(),g.label!==void 0&&(this.w(),this.C()),g.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new h.$vi)),this.j}set actionRunner(g){this.j=g}isEnabled(){return this._action.enabled}setActionContext(g){this._context=g}render(g){const n=this.element=g;this.B(_.$6P.addTarget(g));const r=this.m&&this.m.draggable;r&&(g.draggable=!0,D.$mO&&this.B((0,i.$GO)(g,i.$pP.DRAG_START,b=>b.dataTransfer?.setData(O.$4P.TEXT,this._action.label)))),this.B((0,i.$GO)(n,_.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,i.$GO)(n,i.$pP.MOUSE_DOWN,b=>{r||i.$rP.stop(b,!0),this._action.enabled&&b.button===0&&n.classList.add("active")})),d.$k&&this.B((0,i.$GO)(n,i.$pP.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,i.$GO)(n,i.$pP.CLICK,b=>{i.$rP.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,i.$GO)(n,i.$pP.DBLCLICK,b=>{i.$rP.stop(b,!0)})),[i.$pP.MOUSE_UP,i.$pP.MOUSE_OUT].forEach(b=>{this.B((0,i.$GO)(n,b,c=>{i.$rP.stop(c),n.classList.remove("active")}))})}onClick(g,n=!1){i.$rP.stop(g,!0);const r=T.$Hf(this._context)?this.m?.useEventAsContext?g:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(g){this.element&&(this.element.tabIndex=g?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const g=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(g):(this.f=(0,p.$oQ)(this.m.hoverDelegate,this.element,g),this.q.add(this.f))):this.element.title=g}D(){if(this.element){const g=this.z()??"";this.element.setAttribute("aria-label",g)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$bR=a;class e extends a{constructor(g,n,r){super(g,n,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(g){super.render(g),T.$If(this.element);const n=document.createElement("a");if(n.classList.add("action-label"),n.setAttribute("role",this.L()),this.H=n,this.element.appendChild(n),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===h.$wi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(g){this.H&&(this.H.tabIndex=g?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let g=null;return this.action.tooltip?g=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(g=this.action.label,this.m.keybinding&&(g=s.localize(0,null,g,this.m.keybinding))),g??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const g=this.z()??"";this.H.setAttribute("aria-label",g)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$cR=e;class u extends a{constructor(g,n,r,b,c,o,F){super(g,n),this.b=new v.$9Q(r,b,c,o,F),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(g,n){this.b.setOptions(g,n)}select(g){this.b.select(g)}g(){this.B(this.b.onDidSelect(g=>this.n(g.selected,g.index)))}n(g,n){this.actionRunner.run(this._action,this.r(g,n))}r(g,n){return g}setFocusable(g){this.b.setFocusable(g)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(g){this.b.render(g)}}t.$dR=u}),define(be[62],$e([1,0,3,14,61,35,4,2,7,50]),function(re,t,D,O,i,_,p,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qQ=t.$pQ=t.ActionsOrientation=void 0;var f;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(f||(t.ActionsOrientation=f={}));class d extends v.$Sc{constructor(a,e={}){super(),this.g=this.B(new v.$Rc),this.r=this.B(new v.$1c),this.w=!1,this.y=!0,this.C=this.B(new p.$Nd),this.onDidBlur=this.C.event,this.D=this.B(new p.$Nd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new p.$Nd),this.onDidRun=this.G.event,this.H=this.B(new p.$Nd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new _.$vi,this.g.add(this.f)),this.g.add(this.f.onDidRun(g=>this.G.fire(g))),this.g.add(this.f.onWillRun(g=>this.H.fire(g))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let u,l;switch(this.m){case 0:u=[15],l=[17];break;case 1:u=[16],l=[18],this.domNode.className+=" vertical";break}this.B(D.$GO(this.domNode,D.$pP.KEY_DOWN,g=>{const n=new O.$DO(g);let r=!0;const b=typeof this.t=="number"?this.viewItems[this.t]:void 0;u&&(n.equals(u[0])||n.equals(u[1]))?r=this.P():l&&(n.equals(l[0])||n.equals(l[1]))?r=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?r=this.M():n.equals(13)?r=this.N():n.equals(2)&&b instanceof i.$bR&&b.trapsArrowNavigation?r=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:r=!1,r&&(n.preventDefault(),n.stopPropagation())})),this.B(D.$GO(this.domNode,D.$pP.KEY_UP,g=>{const n=new O.$DO(g);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(D.$uP(this.domNode)),this.B(this.u.onDidBlur(()=>{(D.$cP()===this.domNode||!D.$7O(D.$cP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(u=>u instanceof i.$bR&&u.isEnabled());e instanceof i.$bR&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$bR&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(u=>{e=e||a.equals(u)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(D.$7O(D.$cP(),e)){this.t=a;break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const u=Array.isArray(a)?a:[a];let l=h.$Cf(e.index)?e.index:null;u.forEach(g=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let r;const b={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(g,b)),r||(r=new i.$cR(this.context,g,b)),this.b.allowContextMenu||this.r.set(r,D.$GO(n,D.$pP.CONTEXT_MENU,c=>{D.$rP.stop(c,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(n),this.y&&r instanceof i.$bR&&this.viewItems.length===0&&r.setFocusable(!0),l===null||l<0||l>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(r)):(this.z.insertBefore(n,this.z.children[l]),this.viewItems.splice(l,0,r),l++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,v.$Nc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,v.$Nc)(this.viewItems),this.r.clearAndDisposeAll(),D.$FO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,u;if(a===void 0?e=!0:typeof a=="number"?u=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const l=this.viewItems.findIndex(g=>g.isEnabled());this.t=l===-1?void 0:l,this.Q(void 0,void 0,!0)}else u!==void 0&&(this.t=u),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let u;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,u=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!u.isEnabled()||u.action.id===_.$wi.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let u;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}u=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!u.isEnabled()||u.action.id===_.$wi.ID));return this.Q(!0),!0}Q(a,e,u=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const l=this.t!==void 0&&this.viewItems[this.t];if(l){let g=!0;h.$Mf(l.focus)||(g=!1),this.b.focusOnlyEnabledItems&&h.$Mf(l.isEnabled)&&!l.isEnabled()&&(g=!1),l.action.id===_.$wi.ID&&(g=!1),g?(u||this.s!==this.t)&&(l.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$bR){const u=e._context===null||e._context===void 0?a:e._context;this.run(e._action,u)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,v.$Nc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$pQ=d;function T(s){if(!s.length)return s;let a=-1;for(let u=0;u<s.length;u++)if(s[u].id!==_.$wi.ID){a=u;break}if(a===-1)return[];s=s.slice(a);for(let u=s.length-1;u>=0&&s[u].id===_.$wi.ID;u--)s.splice(u,1);let e=!1;for(let u=s.length-1;u>=0;u--){const l=s[u].id===_.$wi.ID;l&&!e?s.splice(u,1):l?l&&(e=!1):e=!0}return s}t.$qQ=T}),define(be[63],$e([1,0,3,21,53,62,55,58,20,4,79,49,106,94]),function(re,t,D,O,i,_,p,v,h,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UR=t.$TR=t.$SR=t.MessageType=void 0;const a=D.$;var e;(function(g){g[g.INFO=1]="INFO",g[g.WARNING=2]="WARNING",g[g.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$SR={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class u extends h.$0P{constructor(n,r,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new f.$Nd),this.onDidChange=this.O.event,this.P=this.B(new f.$Nd),this.onDidHeightChange=this.P.event,this.a=r,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=D.$wP(n,a(".monaco-inputbox.idle"));const c=this.g.flexibleHeight?"textarea":"input",o=D.$wP(this.element,a(".ibwrapper"));if(this.b=D.$wP(o,a(c+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=D.$wP(o,a("div.mirror")),this.y.innerText="\xA0",this.N=new v.$hQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),D.$wP(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const F=this.B(new O.$xQ(document,"selectionchange")),H=f.Event.filter(F.event,()=>document.getSelection()?.anchorNode===o);this.B(H(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new _.$pQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:D.$5O(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return D.$1O(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,c=parseFloat(this.y.style.paddingRight||"")||0;r=b+c}this.b.style.width=n-r+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,r=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:r}),this.N.setScrollPosition({scrollTop:b})}showMessage(n,r){if(this.w==="open"&&(0,T.$$m)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${D.$OP(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const r=this.g.inputBoxStyles;switch(n){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const r=()=>n.style.width=D.$1O(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:c=>{if(!this.h)return null;n=D.$wP(c,a(".monaco-inputbox-container")),r();const o={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,i.$vQ)(this.h.content,o):(0,i.$uQ)(this.h.content,o);F.classList.add(this.U(this.h.type));const H=this.stylesForType(this.h.type);return F.style.backgroundColor=H.background??"",F.style.color=H.foreground??"",F.style.border=H.border?`1px solid ${H.border}`:"",D.$wP(n,F),null},onHide:()=>{this.w="closed"},layout:r});let b;this.h.type===3?b=s.localize(0,null,this.h.content):this.h.type===2?b=s.localize(1,null,this.h.content):b=s.localize(2,null,this.h.content),p.$zQ(b),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,b=n.charCodeAt(n.length-1)===10?" ":"";(n+b).replace(/\u000c/g,"")?this.y.textContent=n+b:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,r=n.inputBackground??"",b=n.inputForeground??"",c=n.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${D.$OP(c,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=D.$5O(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const r=this.inputElement,b=r.selectionStart,c=r.selectionEnd,o=r.value;b!==null&&c!==null&&(this.value=o.substr(0,b)+n+o.substr(c),r.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$TR=u;class l extends u{constructor(n,r,b){const c=s.localize(3,null),o=` or \u21C5 ${c}`,F=` (\u21C5 ${c})`;super(n,r,b),this.db=this.B(new f.$Nd),this.onDidFocus=this.db.event,this.eb=this.B(new f.$Nd),this.onDidBlur=this.eb.event,this.bb=new d.$QR(b.history,100);const H=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(o)&&!this.n.endsWith(F)&&this.bb.getHistory().length){const R=this.n.endsWith(")")?o:F,m=this.n+R;b.showPlaceholderOnFocus&&document.activeElement!==this.b?this.n=m:this.setPlaceHolder(m)}};this.cb=new MutationObserver((R,m)=>{R.forEach(w=>{w.target.textContent||H()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>H()),this.F(this.b,()=>{const R=m=>{if(this.n.endsWith(m)){const w=this.n.slice(0,this.n.length-m.length);return b.showPlaceholderOnFocus?this.n=w:this.setPlaceHolder(w),!0}else return!1};R(F)||R(o)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const r=this.getHistory();this.clearHistory(),n.forEach(b=>{this.bb.add(b)}),r.forEach(b=>{this.bb.add(b)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",p.$AQ(this.value?this.value:s.localize(4,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,p.$AQ(this.value))}clearHistory(){this.bb.clear()}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$UR=l}),define(be[64],$e([1,0,61,20,17,18,4,99]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aR=t.$_Q=t.$$Q=t.$0Q=void 0,t.$0Q={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class v extends D.$bR{constructor(T,s,a){super(T,s,a),this.a=this.B(new h({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:a.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:a.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:a.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(T){this.element=T,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(T){this.a.domNode.tabIndex=T?0:-1}}t.$$Q=v;class h extends O.$0P{constructor(T){super(),this.a=this.B(new p.$Nd),this.onChange=this.a.event,this.b=this.B(new p.$Nd),this.onKeyDown=this.b.event,this.c=T,this.s=this.c.isChecked;const s=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,s.push(..._.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&s.push(...this.c.actionClassName.split(" ")),this.s&&s.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...s),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,a=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),a.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,a=>{if(a.keyCode===10||a.keyCode===3){this.checked=!this.s,this.a.fire(!0),a.preventDefault(),a.stopPropagation();return}this.b.fire(a)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(T){this.s=T,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(T){this.g&&this.domNode.classList.remove(..._.ThemeIcon.asClassNameArray(this.g)),this.g=T,this.g&&this.domNode.classList.add(..._.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(T){this.domNode.title=T,this.domNode.setAttribute("aria-label",T)}}t.$_Q=h;class f extends O.$0P{constructor(T,s,a){super(),this.c=T,this.g=s,this.a=new h({title:this.c,isChecked:this.g,icon:i.$Uj.check,actionClassName:"monaco-checkbox",...t.$0Q}),this.domNode=this.a.domNode,this.b=a,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(T){this.a.checked=T,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$aR=f}),define(be[127],$e([1,0,64,17,104]),function(re,t,D,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8R=t.$7R=t.$6R=void 0;const _=i.localize(0,null),p=i.localize(1,null),v=i.localize(2,null);class h extends D.$_Q{constructor(s){super({icon:O.$Uj.caseSensitive,title:_+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$6R=h;class f extends D.$_Q{constructor(s){super({icon:O.$Uj.wholeWord,title:p+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$7R=f;class d extends D.$_Q{constructor(s){super({icon:O.$Uj.regex,title:v+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$8R=d}),define(be[128],$e([1,0,3,127,63,20,4,103,2,93]),function(re,t,D,O,i,_,p,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9R=void 0;const f=v.localize(0,null);class d extends _.$0P{static{this.OPTION_CHANGE="optionChange"}constructor(s,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new h.$Tc),this.N=[],this.O=this.B(new p.$Nd),this.onDidOptionChange=this.O.event,this.P=this.B(new p.$Nd),this.onKeyDown=this.P.event,this.Q=this.B(new p.$Nd),this.onMouseDown=this.Q.event,this.R=this.B(new p.$Nd),this.onInput=this.R.event,this.S=this.B(new p.$Nd),this.onKeyUp=this.S.event,this.U=this.B(new p.$Nd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new p.$Nd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||f,this.h=!!e.showCommonFindToggles;const u=e.appendCaseSensitiveLabel||"",l=e.appendWholeWordsLabel||"",g=e.appendRegexLabel||"",n=e.history||[],r=!!e.flexibleHeight,b=!!e.flexibleWidth,c=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$UR(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:b,flexibleMaxHeight:c,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new O.$8R({appendTitle:g,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new O.$7R({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new O.$6R({appendTitle:u,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const o=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const H=o.indexOf(document.activeElement);if(H>=0){let R=-1;F.equals(17)?R=(H+1)%o.length:F.equals(15)&&(H===0?R=o.length-1:R=H-1),F.equals(9)?(o[H].blur(),this.inputBox.focus()):R>=0&&o[R].focus(),D.$rP.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(D.$GO(this.inputBox.inputElement,"compositionstart",o=>{this.s=!0})),this.B(D.$GO(this.inputBox.inputElement,"compositionend",o=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,o=>this.P.fire(o)),this.C(this.inputBox.inputElement,o=>this.S.fire(o)),this.D(this.inputBox.inputElement,o=>this.R.fire()),this.j(this.inputBox.inputElement,o=>this.Q.fire(o))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new h.$Rc;for(const a of s??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$9R=d}),define(be[129],$e([1,0,3,21,14,62,128,63,59,38,64,56,24,35,11,9,17,18,31,4,33,2,45,7,108,100]),function(re,t,D,O,i,_,p,v,h,f,d,T,s,a,e,u,l,g,n,r,b,c,o,F,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GS=t.TreeFindMatchType=t.TreeFindMode=t.$FS=t.$ES=t.RenderIndentGuides=t.$DS=t.$CS=void 0;class R extends h.$KQ{set context($){this.c.context=$}get context(){return this.c.context}constructor($){super($.elements.map(I=>I.element)),this.c=$}}function m(x){return x instanceof h.$KQ?new R(x):x}class w{constructor($,I){this.d=$,this.f=I,this.b=c.$Sc.None,this.c=new c.$Rc}getDragURI($){return this.f.getDragURI($.element)}getDragLabel($,I){if(this.f.getDragLabel)return this.f.getDragLabel($.map(M=>M.element),I)}onDragStart($,I){this.f.onDragStart?.(m($),I)}onDragOver($,I,M,N,A=!0){const E=this.f.onDragOver(m($),I&&I.element,M,N),W=this.a!==I;if(W&&(this.b.dispose(),this.a=I),typeof I>"u")return E;if(W&&typeof E!="boolean"&&E.autoExpand&&(this.b=(0,u.$Vg)(()=>{const U=this.d(),K=U.getNodeLocation(I);U.isCollapsed(K)&&U.setCollapsed(K,!1),this.a=void 0},500,this.c)),typeof E=="boolean"||!E.accept||typeof E.bubble>"u"||E.feedback){if(!A){const U=typeof E=="boolean"?E:E.accept,K=typeof E=="boolean"?void 0:E.effect;return{accept:U,effect:K,feedback:[M]}}return E}if(E.bubble===1){const U=this.d(),K=U.getNodeLocation(I),te=U.getParentNodeLocation(K),se=U.getNode(te),ge=te&&U.getListIndex(te);return this.onDragOver($,se,ge,N,!1)}const S=this.d(),B=S.getNodeLocation(I),y=S.getListIndex(B),C=S.getListRenderCount(B);return{...E,feedback:(0,e.$Sb)(y,y+C)}}drop($,I,M,N){this.b.dispose(),this.a=void 0,this.f.drop(m($),I&&I.element,M,N)}onDragEnd($){this.f.onDragEnd?.($)}dispose(){this.c.dispose(),this.f.dispose()}}function j(x,$){return $&&{...$,identityProvider:$.identityProvider&&{getId(I){return $.identityProvider.getId(I.element)}},dnd:$.dnd&&new w(x,$.dnd),multipleSelectionController:$.multipleSelectionController&&{isSelectionSingleChangeEvent(I){return $.multipleSelectionController.isSelectionSingleChangeEvent({...I,element:I.element})},isSelectionRangeChangeEvent(I){return $.multipleSelectionController.isSelectionRangeChangeEvent({...I,element:I.element})}},accessibilityProvider:$.accessibilityProvider&&{...$.accessibilityProvider,getSetSize(I){const M=x(),N=M.getNodeLocation(I),A=M.getParentNodeLocation(N);return M.getNode(A).visibleChildrenCount},getPosInSet(I){return I.visibleChildIndex+1},isChecked:$.accessibilityProvider&&$.accessibilityProvider.isChecked?I=>$.accessibilityProvider.isChecked(I.element):void 0,getRole:$.accessibilityProvider&&$.accessibilityProvider.getRole?I=>$.accessibilityProvider.getRole(I.element):()=>"treeitem",getAriaLabel(I){return $.accessibilityProvider.getAriaLabel(I.element)},getWidgetAriaLabel(){return $.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:$.accessibilityProvider&&$.accessibilityProvider.getWidgetRole?()=>$.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:$.accessibilityProvider&&$.accessibilityProvider.getAriaLevel?I=>$.accessibilityProvider.getAriaLevel(I.element):I=>I.depth,getActiveDescendantId:$.accessibilityProvider.getActiveDescendantId&&(I=>$.accessibilityProvider.getActiveDescendantId(I.element))},keyboardNavigationLabelProvider:$.keyboardNavigationLabelProvider&&{...$.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(I){return $.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(I.element)}}}}class z{constructor($){this.a=$}getHeight($){return this.a.getHeight($.element)}getTemplateId($){return this.a.getTemplateId($.element)}hasDynamicHeight($){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight($.element)}setDynamicHeight($,I){this.a.setDynamicHeight?.($.element,I)}}t.$CS=z;class q{static lift($){return $ instanceof q?$:new q($)}static empty($=0){return new q({focus:[],selection:[],expanded:Object.create(null),scrollTop:$})}constructor($){if(this.focus=new Set($.focus),this.selection=new Set($.selection),$.expanded instanceof Array){this.expanded=Object.create(null);for(const I of $.expanded)this.expanded[I]=1}else this.expanded=$.expanded;this.expanded=$.expanded,this.scrollTop=$.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$DS=q;var L;(function(x){x.None="none",x.OnHover="onHover",x.Always="always"})(L||(t.RenderIndentGuides=L={}));class P{get elements(){return this.b}constructor($,I=[]){this.b=I,this.a=new c.$Rc,this.onDidChange=r.Event.forEach($,M=>this.b=M,this.a)}dispose(){this.a.dispose()}}class J{static{this.a=8}constructor($,I,M,N,A,E={}){this.o=$,this.p=I,this.q=N,this.s=A,this.b=new Map,this.c=new Map,this.d=J.a,this.f=!1,this.g=!1,this.j=new Set,this.k=c.$Sc.None,this.m=new c.$Rc,this.templateId=$.templateId,this.updateOptions(E),r.Event.map(M,W=>W.node)(this.u,this,this.m),$.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions($={}){if(typeof $.indent<"u"){const I=(0,o.$Ol)($.indent,0,40);if(I!==this.d){this.d=I;for(const[M,N]of this.c)this.v(M,N)}}if(typeof $.renderIndentGuides<"u"){const I=$.renderIndentGuides!==L.None;if(I!==this.g){this.g=I;for(const[M,N]of this.c)this.w(M,N);if(this.k.dispose(),I){const M=new c.$Rc;this.q.onDidChange(this.x,this,M),this.k=M,this.x(this.q.elements)}}}typeof $.hideTwistiesOfChildlessElements<"u"&&(this.f=$.hideTwistiesOfChildlessElements)}renderTemplate($){const I=(0,D.$wP)($,(0,D.$)(".monaco-tl-row")),M=(0,D.$wP)(I,(0,D.$)(".monaco-tl-indent")),N=(0,D.$wP)(I,(0,D.$)(".monaco-tl-twistie")),A=(0,D.$wP)(I,(0,D.$)(".monaco-tl-contents")),E=this.o.renderTemplate(A);return{container:$,indent:M,twistie:N,indentGuidesDisposable:c.$Sc.None,templateData:E}}renderElement($,I,M,N){this.c.set($,M),this.b.set($.element,$),this.v($,M),this.o.renderElement($,I,M.templateData,N)}disposeElement($,I,M,N){M.indentGuidesDisposable.dispose(),this.o.disposeElement?.($,I,M.templateData,N),typeof N=="number"&&(this.c.delete($),this.b.delete($.element))}disposeTemplate($){this.o.disposeTemplate($.templateData)}t($){const I=this.b.get($);I&&this.u(I)}u($){const I=this.c.get($);I&&(this.x(this.q.elements),this.v($,I))}v($,I){const M=J.a+($.depth-1)*this.d;I.twistie.style.paddingLeft=`${M}px`,I.indent.style.width=`${M+this.d-16}px`,$.collapsible?I.container.setAttribute("aria-expanded",String(!$.collapsed)):I.container.removeAttribute("aria-expanded"),I.twistie.classList.remove(...g.ThemeIcon.asClassNameArray(l.$Uj.treeItemExpanded));let N=!1;this.o.renderTwistie&&(N=this.o.renderTwistie($.element,I.twistie)),$.collapsible&&(!this.f||$.visibleChildrenCount>0)?(N||I.twistie.classList.add(...g.ThemeIcon.asClassNameArray(l.$Uj.treeItemExpanded)),I.twistie.classList.add("collapsible"),I.twistie.classList.toggle("collapsed",$.collapsed)):I.twistie.classList.remove("collapsible","collapsed"),this.w($,I)}w($,I){if((0,D.$FO)(I.indent),I.indentGuidesDisposable.dispose(),!this.g)return;const M=new c.$Rc,N=this.p();for(;;){const A=N.getNodeLocation($),E=N.getParentNodeLocation(A);if(!E)break;const W=N.getNode(E),S=(0,D.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(W)&&S.classList.add("active"),I.indent.childElementCount===0?I.indent.appendChild(S):I.indent.insertBefore(S,I.indent.firstElementChild),this.s.add(W,S),M.add((0,c.$Qc)(()=>this.s.delete(W,S))),$=W}I.indentGuidesDisposable=M}x($){if(!this.g)return;const I=new Set,M=this.p();$.forEach(N=>{const A=M.getNodeLocation(N);try{const E=M.getParentNodeLocation(A);N.collapsible&&N.children.length>0&&!N.collapsed?I.add(N):E&&I.add(M.getNode(E))}catch{}}),this.j.forEach(N=>{I.has(N)||this.s.forEach(N,A=>A.classList.remove("active"))}),I.forEach(N=>{this.j.has(N)||this.s.forEach(N,A=>A.classList.add("active"))}),this.j=I}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,c.$Nc)(this.m)}}class ee{get totalCount(){return this.a}get matchCount(){return this.b}set pattern($){this.c=$,this.d=$.toLowerCase()}constructor($,I,M){this.g=$,this.j=I,this.k=M,this.a=0,this.b=0,this.c="",this.d="",this.f=new c.$Rc,$.onWillRefilter(this.m,this,this.f)}filter($,I){let M=1;if(this.k){const E=this.k.filter($,I);if(typeof E=="boolean"?M=E?1:0:(0,T.$zS)(E)?M=(0,T.$AS)(E.visibility):M=E,M===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:M};const N=this.j.getKeyboardNavigationLabel($),A=Array.isArray(N)?N:[N];for(const E of A){const W=E&&E.toString();if(typeof W>"u")return{data:b.FuzzyScore.Default,visibility:M};let S;if(this.g.findMatchType===me.Contiguous){const B=W.toLowerCase().indexOf(this.d);if(B>-1){S=[Number.MAX_SAFE_INTEGER,0];for(let y=this.d.length;y>0;y--)S.push(B+y-1)}}else S=(0,b.$Pj)(this.c,this.d,0,W,W.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(S)return this.b++,A.length===1?{data:S,visibility:M}:{data:{label:W,score:S},visibility:M}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility($):2:{data:b.FuzzyScore.Default,visibility:M}}m(){this.a=0,this.b=0}dispose(){(0,c.$Nc)(this.f)}}class ne extends d.$_Q{constructor($){super({icon:l.$Uj.listFilter,title:(0,H.localize)(0,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$ES=ne;class ue extends d.$_Q{constructor($){super({icon:l.$Uj.searchFuzzy,title:(0,H.localize)(1,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$FS=ue;const le={inputBoxStyles:v.$SR,toggleStyles:d.$0Q,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(x){x[x.Highlight=0]="Highlight",x[x.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var me;(function(x){x[x.Fuzzy=0]="Fuzzy",x[x.Contiguous=1]="Contiguous"})(me||(t.TreeFindMatchType=me={}));class Se extends c.$Sc{set mode($){this.b.checked=$===oe.Filter,this.f.inputBox.setPlaceHolder($===oe.Filter?(0,H.localize)(2,null):(0,H.localize)(3,null))}set matchType($){this.c.checked=$===me.Fuzzy}get value(){return this.f.inputBox.value}set value($){this.f.inputBox.value=$}constructor($,I,M,N,A,E){super(),this.t=I,this.a=(0,D.h)(".monaco-tree-type-filter",[(0,D.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,D.h)(".monaco-tree-type-filter-input@findInput"),(0,D.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Nd,this.onDidDisable=this._onDidDisable.event,$.appendChild(this.a.root),this.B((0,c.$Qc)(()=>$.removeChild(this.a.root)));const W=E?.styles??le;W.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=W.listFilterWidgetBackground),W.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${W.listFilterWidgetShadow}`),this.b=this.B(new ne({...W.toggleStyles,isChecked:N===oe.Filter})),this.c=this.B(new ue({...W.toggleStyles,isChecked:A===me.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?me.Fuzzy:me.Contiguous,this.q),this.f=this.B(new p.$9R(this.a.findInput,M,{label:(0,H.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:W.inputBoxStyles,toggleStyles:W.toggleStyles,history:E?.history})),this.g=this.B(new _.$pQ(this.a.actionbar)),this.mode=N;const S=this.B(new O.$xQ(this.f.inputBox.inputElement,"keydown")),B=r.Event.chain(S.event,K=>K.map(te=>new i.$DO(te)));this.B(B(K=>{if(K.equals(3)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(K.equals(18)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(K.equals(16)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const y=this.B(new a.$ui("close",(0,H.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(y,{icon:!0,label:!1});const C=this.B(new O.$xQ(this.a.grab,"mousedown"));this.B(C.event(K=>{const te=new c.$Rc,se=te.add(new O.$xQ(window,"mousemove")),ge=te.add(new O.$xQ(window,"mouseup")),we=this.m,Ne=K.pageX,Ae=this.s,ve=K.pageY;this.a.grab.classList.add("grabbing");const Ie=this.a.root.style.transition;this.a.root.style.transition="unset";const Oe=qe=>{const je=qe.pageX-Ne;this.m=we-je;const Re=qe.pageY-ve;this.s=Ae+Re,this.layout()};te.add(se.event(Oe)),te.add(ge.event(qe=>{Oe(qe),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ie,te.dispose()}))}));const U=r.Event.chain(this.B(new O.$xQ(this.a.grab,"keydown")).event,K=>K.map(te=>new i.$DO(te)));this.B(U(K=>{let te,se;if(K.keyCode===15?te=Number.POSITIVE_INFINITY:K.keyCode===17?te=0:K.keyCode===10&&(te=this.m===0?Number.POSITIVE_INFINITY:0),K.keyCode===16?se=0:K.keyCode===18&&(se=Number.POSITIVE_INFINITY),te!==void 0&&(K.preventDefault(),K.stopPropagation(),this.m=te,this.layout()),se!==void 0){K.preventDefault(),K.stopPropagation(),this.s=se;const ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout($=this.j){this.j=$,this.m=(0,o.$Ol)(this.m,0,Math.max(0,$-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,o.$Ol)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage($){this.f.showMessage($)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,u.$Ug)(300),super.dispose()}}class Te{get pattern(){return this.b}get mode(){return this.d}set mode($){$!==this.d&&(this.d=$,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire($))}get matchType(){return this.f}set matchType($){$!==this.f&&(this.f=$,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire($))}constructor($,I,M,N,A,E={}){this.t=$,this.u=M,this.v=N,this.w=A,this.x=E,this.b="",this.c="",this.j=0,this.k=new r.$Nd,this.onDidChangeMode=this.k.event,this.m=new r.$Nd,this.onDidChangeMatchType=this.m.event,this.o=new r.$Nd,this.onDidChangePattern=this.o.event,this.p=new r.$Nd,this.onDidChangeOpenState=this.p.event,this.q=new c.$Rc,this.s=new c.$Rc,this.d=$.options.defaultFindMode??oe.Highlight,this.f=$.options.defaultFindMatchType??me.Fuzzy,I.onDidSplice(this.z,this,this.s)}updateOptions($={}){$.defaultFindMode!==void 0&&(this.mode=$.defaultFindMode),$.defaultFindMatchType!==void 0&&(this.matchType=$.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Se(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode($=>this.mode=$,void 0,this.q),this.g.onDidChangeMatchType($=>this.matchType=$,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y($){this.b=$,this.o.fire($),this.v.pattern=$,this.t.refilter(),$&&this.t.focusNext(0,!0,void 0,M=>!b.FuzzyScore.isDefault(M.filterData));const I=this.t.getFocus();if(I.length>0){const M=I[0];this.t.getRelativeTop(M)===null&&this.t.reveal(M,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const $=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&$?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,H.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus($){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault($.filterData)}layout($){this.j=$,this.g?.layout($)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Pe(x){let $=s.TreeMouseEventTarget.Unknown;return(0,D.$$O)(x.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?$=s.TreeMouseEventTarget.Twistie:(0,D.$$O)(x.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?$=s.TreeMouseEventTarget.Element:(0,D.$$O)(x.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&($=s.TreeMouseEventTarget.Filter),{browserEvent:x.browserEvent,element:x.element?x.element.element:null,target:$}}function de(x){return{element:x.element?x.element.element:null,browserEvent:x.browserEvent,anchor:x.anchor}}function ie(x,$){$(x),x.children.forEach(I=>ie(I,$))}class fe{get f(){return this.d||(this.d=this.m()),this.d}constructor($,I){this.g=$,this.j=I,this.a=[],this.c=new r.$Nd,this.onDidChange=this.c.event}set($,I){!I?.__forceEvent&&(0,e.$ub)(this.a,$)||this.k($,!1,I)}k($,I,M){if(this.a=[...$],this.b=void 0,this.d=void 0,!I){const N=this;this.c.fire({get elements(){return N.get()},browserEvent:M})}}get(){return this.b||(this.b=this.a.map($=>$.element)),[...this.b]}getNodes(){return this.a}has($){return this.f.has($)}onDidModelSplice({insertedNodes:$,deletedNodes:I}){if(!this.j){const S=this.m(),B=y=>S.delete(y);I.forEach(y=>ie(y,B)),this.set([...S.values()]);return}const M=new Set,N=S=>M.add(this.j.getId(S.element).toString());I.forEach(S=>ie(S,N));const A=new Map,E=S=>A.set(this.j.getId(S.element).toString(),S);$.forEach(S=>ie(S,E));const W=[];for(const S of this.a){const B=this.j.getId(S.element).toString();if(!M.has(B))W.push(S);else{const C=A.get(B);C&&C.visible&&W.push(C)}}if(this.a.length>0&&W.length===0){const S=this.g();S&&W.push(S)}this.k(W,!0)}m(){const $=new Set;for(const I of this.a)$.add(I);return $}}class Y extends f.$UQ{constructor($,I){super($),this.x=I}u($){if((0,f.$QQ)($.browserEvent.target)||(0,f.$OQ)($.browserEvent.target)||(0,f.$PQ)($.browserEvent.target)||$.browserEvent.isHandledByList)return;const I=$.element;if(!I)return super.u($);if(this.p($)||this.o($))return super.u($);const M=$.browserEvent.target,N=M.classList.contains("monaco-tl-twistie")||M.classList.contains("monaco-icon-label")&&M.classList.contains("folder-icon")&&$.browserEvent.offsetX<16;let A=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?A=this.x.expandOnlyOnTwistieClick(I.element):A=!!this.x.expandOnlyOnTwistieClick,A&&!N&&$.browserEvent.detail!==2)return super.u($);if(!this.x.expandOnDoubleClick&&$.browserEvent.detail===2)return super.u($);if(I.collapsible){const E=this.x.getNodeLocation(I),W=$.browserEvent.altKey;if(this.x.setFocus([E]),this.x.toggleCollapsed(E,W),A&&N){$.browserEvent.isHandledByList=!0;return}}super.u($)}v($){$.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||$.browserEvent.isHandledByList||super.v($)}}class V extends f.$XQ{constructor($,I,M,N,A,E,W,S){super($,I,M,N,S),this.p=A,this.s=E,this.K=W}D($){return new Y(this,$.tree)}splice($,I,M=[]){if(super.splice($,I,M),M.length===0)return;const N=[],A=[];let E;M.forEach((W,S)=>{this.p.has(W)&&N.push($+S),this.s.has(W)&&A.push($+S),this.K.has(W)&&(E=$+S)}),N.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...N])),A.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...A])),typeof E=="number"&&super.setAnchor(E)}setFocus($,I,M=!1){super.setFocus($,I),M||this.p.set($.map(N=>this.element(N)),I)}setSelection($,I,M=!1){super.setSelection($,I),M||this.s.set($.map(N=>this.element(N)),I)}setAnchor($,I=!1){super.setAnchor($),I||(typeof $>"u"?this.K.set([]):this.K.set([this.element($)]))}}class G{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Pe)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Pe),$=>$.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Pe)}get onPointer(){return r.Event.map(this.j.onPointer,Pe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode($){this.x&&(this.x.mode=$)}get findMatchType(){return this.x?.matchType??me.Fuzzy}set findMatchType($){this.x&&(this.x.matchType=$)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor($,I,M,N,A={}){this.D=$,this.E=A,this.w=new r.$Vd,this.onDidChangeFindOpenState=r.Event.None,this.A=new c.$Rc,this.B=new r.$Nd,this.onWillRefilter=this.B.event,this.C=new r.$Nd,this.onDidUpdateOptions=this.C.event;const E=new z(M),W=new r.$Wd,S=new r.$Wd,B=this.A.add(new P(S.event)),y=new n.$Gc;this.k=N.map(se=>new J(se,()=>this.o,W.event,B,y,A));for(const se of this.k)this.A.add(se);let C;A.keyboardNavigationLabelProvider&&(C=new ee(this,A.keyboardNavigationLabelProvider,A.filter),A={...A,filter:C},this.A.add(C)),this.p=new fe(()=>this.j.getFocusedElements()[0],A.identityProvider),this.q=new fe(()=>this.j.getSelectedElements()[0],A.identityProvider),this.u=new fe(()=>this.j.getAnchorElement(),A.identityProvider),this.j=new V($,I,E,this.k,this.p,this.q,this.u,{...j(()=>this.o,A),tree:this}),this.o=this.I($,this.j,A),W.input=this.o.onDidChangeCollapseState;const U=r.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);U(()=>null,null,this.A);const K=this.A.add(new r.$Nd),te=this.A.add(new u.$Qg(0));if(this.A.add(r.Event.any(U,this.p.onDidChange,this.q.onDidChange)(()=>{te.trigger(()=>{const se=new Set;for(const ge of this.p.getNodes())se.add(ge);for(const ge of this.q.getNodes())se.add(ge);K.fire([...se.values()])})})),S.input=K.event,A.keyboardSupport!==!1){const se=r.Event.chain(this.j.onKeyDown,ge=>ge.filter(we=>!(0,f.$OQ)(we.target)).map(we=>new i.$DO(we)));r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===15))(this.F,this,this.A),r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===17))(this.G,this,this.A),r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===10))(this.H,this,this.A)}if((A.findWidgetEnabled??!0)&&A.keyboardNavigationLabelProvider&&A.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Te(this,this.o,this.j,C,A.contextViewProvider,se),this.y=ge=>this.x.shouldAllowFocus(ge),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,D.$hP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===L.Always)}updateOptions($={}){this.E={...this.E,...$};for(const I of this.k)I.updateOptions($);this.j.updateOptions(this.E),this.x?.updateOptions($),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===L.Always)}get options(){return this.E}updateWidth($){const I=this.o.getListIndex($);I!==-1&&this.j.updateWidth(I)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop($){this.j.scrollTop=$}get scrollLeft(){return this.j.scrollLeft}set scrollLeft($){this.j.scrollLeft=$}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const $=this.j.firstVisibleIndex;return $<0||$>=this.j.length?void 0:this.j.element($).element}get lastVisibleElement(){const $=this.j.lastVisibleIndex;return this.j.element($).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel($){this.j.ariaLabel=$}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout($,I){this.j.layout($,I),(0,F.$Cf)(I)&&this.x?.layout(I)}style($){const I=`.${this.j.domId}`,M=[];$.treeIndentGuidesStroke&&(M.push(`.monaco-list${I}:hover .monaco-tl-indent > .indent-guide, .monaco-list${I}.always .monaco-tl-indent > .indent-guide  { border-color: ${$.treeInactiveIndentGuidesStroke}; }`),M.push(`.monaco-list${I} .monaco-tl-indent > .indent-guide.active { border-color: ${$.treeIndentGuidesStroke}; }`)),this.z.textContent=M.join(`
`),this.j.style($)}getParentElement($){const I=this.o.getParentNodeLocation($);return this.o.getNode(I).element}getFirstElementChild($){return this.o.getFirstElementChild($)}getNode($){return this.o.getNode($)}getNodeLocation($){return this.o.getNodeLocation($)}collapse($,I=!1){return this.o.setCollapsed($,!0,I)}expand($,I=!1){return this.o.setCollapsed($,!1,I)}toggleCollapsed($,I=!1){return this.o.setCollapsed($,void 0,I)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible($){return this.o.isCollapsible($)}setCollapsible($,I){return this.o.setCollapsible($,I)}isCollapsed($){return this.o.isCollapsed($)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor($){if(typeof $>"u")return this.j.setAnchor(void 0);const I=this.o.getNode($);this.u.set([I]);const M=this.o.getListIndex($);M>-1&&this.j.setAnchor(M,!0)}getAnchor(){return(0,e.$Ob)(this.u.get(),void 0)}setSelection($,I){const M=$.map(A=>this.o.getNode(A));this.q.set(M,I);const N=$.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setSelection(N,I,!0)}getSelection(){return this.q.get()}setFocus($,I){const M=$.map(A=>this.o.getNode(A));this.p.set(M,I);const N=$.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setFocus(N,I,!0)}focusNext($=1,I=!1,M,N=this.y){this.j.focusNext($,I,M,N)}focusPrevious($=1,I=!1,M,N=this.y){this.j.focusPrevious($,I,M,N)}focusNextPage($,I=this.y){return this.j.focusNextPage($,I)}focusPreviousPage($,I=this.y){return this.j.focusPreviousPage($,I)}focusLast($,I=this.y){this.j.focusLast($,I)}focusFirst($,I=this.y){this.j.focusFirst($,I)}getFocus(){return this.p.get()}reveal($,I){this.o.expandTo($);const M=this.o.getListIndex($);M!==-1&&this.j.reveal(M,I)}getRelativeTop($){const I=this.o.getListIndex($);return I===-1?null:this.j.getRelativeTop(I)}getViewState($=this.options.identityProvider){if(!$)throw new s.$xS(this.D,"Can't get tree view state without an identity provider");const I=E=>$.getId(E).toString(),M=q.empty(this.scrollTop);for(const E of this.getFocus())M.focus.add(I(E));for(const E of this.getSelection())M.selection.add(I(E));const N=this.o.getNode(),A=[N];for(;A.length>0;){const E=A.shift();E!==N&&E.collapsible&&(M.expanded[I(E.element)]=E.collapsed?0:1),A.push(...E.children)}return M}F($){$.preventDefault(),$.stopPropagation();const I=this.j.getFocusedElements();if(I.length===0)return;const M=I[0],N=this.o.getNodeLocation(M);if(!this.o.setCollapsed(N,!0)){const E=this.o.getParentNodeLocation(N);if(!E)return;const W=this.o.getListIndex(E);this.j.reveal(W),this.j.setFocus([W])}}G($){$.preventDefault(),$.stopPropagation();const I=this.j.getFocusedElements();if(I.length===0)return;const M=I[0],N=this.o.getNodeLocation(M);if(!this.o.setCollapsed(N,!1)){if(!M.children.some(S=>S.visible))return;const[E]=this.j.getFocus(),W=E+1;this.j.reveal(W),this.j.setFocus([W])}}H($){$.preventDefault(),$.stopPropagation();const I=this.j.getFocusedElements();if(I.length===0)return;const M=I[0],N=this.o.getNodeLocation(M),A=$.browserEvent.altKey;this.o.setCollapsed(N,void 0,A)}navigate($){return new k(this.j,this.o,$)}dispose(){(0,c.$Nc)(this.A),this.j.dispose()}}t.$GS=G;class k{constructor($,I,M){this.b=$,this.c=I,M?this.a=this.c.getListIndex(M):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[130],$e([1,0,129,120,24,26]),function(re,t,D,O,i,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RS=void 0;class p extends D.$GS{constructor(h,f,d,T,s,a={}){super(h,f,d,T,a),this.f=h,this.g=s,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(h,f){if(f&&!this.c)throw new i.$xS(this.f,"Can't restore tree view state without an identity provider");if(this.b=h,!h){this.d.clear(),this.o.setChildren(null,_.Iterable.empty());return}if(!f){this.m(h);return}const d=[],T=[],s=e=>{const u=this.c.getId(e).toString();return!f.expanded[u]},a=e=>{const u=this.c.getId(e.element).toString();f.focus.has(u)&&d.push(e.element),f.selection.has(u)&&T.push(e.element)};this.m(h,s,a),this.setFocus(d),this.setSelection(T),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(h=this.b){if(typeof this.b>"u")throw new i.$xS(this.f,"Tree input not set");let f;this.c&&(f=d=>{const T=this.c.getId(d).toString(),s=this.d.get(T);if(s)return s.collapsed}),this.m(h,f)}resort(h=this.b,f=!0){this.o.resort(h===this.b?null:h,f)}refresh(h){if(h===void 0){this.j.rerender();return}this.o.rerender(h)}m(h,f,d){let T;if(this.c){const s=new Set,a=d;d=e=>{const u=this.c.getId(e.element).toString();s.add(u),this.d.set(u,e),a?.(e)},T=e=>{const u=this.c.getId(e.element).toString();s.has(u)||this.d.delete(u)}}this.o.setChildren(h===this.b?null:h,this.s(h,f).elements,{onDidCreateNode:d,onDidDeleteNode:T})}s(h,f){const d=[...this.g.getChildren(h)];return{elements:_.Iterable.map(d,s=>{const{elements:a,size:e}=this.s(s,f),u=this.g.hasChildren?this.g.hasChildren(s):void 0,l=e===0?void 0:f&&f(s);return{element:s,children:a,collapsible:u,collapsed:l}}),size:d.length}}I(h,f,d){return new O.$HS(h,f,d)}}t.$RS=p}),define(be[65],$e([1,0,11,9,32,28,25,6,4,2,51,12,7]),function(re,t,D,O,i,_,p,v,h,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yh=t.ProxyChannel=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=t.$sh=t.RequestInitiator=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=void 0;var a;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(a||(a={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(u||(u={}));function l(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(g||(g={}));function n(de){let ie=0;for(let fe=0;;fe+=7){const Y=de.read(1);if(ie|=(Y.buffer[0]&127)<<fe,!(Y.buffer[0]&128))return ie}}const r=H(0);function b(de,ie){if(ie===0){de.write(r);return}let fe=0;for(let V=ie;V!==0;V=V>>>7)fe++;const Y=i.$be.alloc(fe);for(let V=0;ie!==0;V++)Y.buffer[V]=ie&127,ie=ie>>>7,ie>0&&(Y.buffer[V]|=128);de.write(Y)}class c{constructor(ie){this.b=ie,this.a=0}read(ie){const fe=this.b.slice(this.a,this.a+ie);return this.a+=fe.byteLength,fe}}t.$nh=c;class o{constructor(){this.a=[]}get buffer(){return i.$be.concat(this.a)}write(ie){this.a.push(ie)}}t.$oh=o;var F;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(F||(F={}));function H(de){const ie=i.$be.alloc(1);return ie.writeUInt8(de,0),ie}const R={Undefined:H(F.Undefined),String:H(F.String),Buffer:H(F.Buffer),VSBuffer:H(F.VSBuffer),Array:H(F.Array),Object:H(F.Object),Uint:H(F.Int)},m=typeof Buffer<"u";function w(de,ie){if(typeof ie>"u")de.write(R.Undefined);else if(typeof ie=="string"){const fe=i.$be.fromString(ie);de.write(R.String),b(de,fe.byteLength),de.write(fe)}else if(m&&Buffer.isBuffer(ie)){const fe=i.$be.wrap(ie);de.write(R.Buffer),b(de,fe.byteLength),de.write(fe)}else if(ie instanceof i.$be)de.write(R.VSBuffer),b(de,ie.byteLength),de.write(ie);else if(Array.isArray(ie)){de.write(R.Array),b(de,ie.length);for(const fe of ie)w(de,fe)}else if(typeof ie=="number"&&(ie|0)===ie)de.write(R.Uint),b(de,ie);else{const fe=i.$be.fromString(JSON.stringify(ie));de.write(R.Object),b(de,fe.byteLength),de.write(fe)}}t.$ph=w;function j(de){switch(de.read(1).readUInt8(0)){case F.Undefined:return;case F.String:return de.read(n(de)).toString();case F.Buffer:return de.read(n(de)).buffer;case F.VSBuffer:return de.read(n(de));case F.Array:{const fe=n(de),Y=[];for(let V=0;V<fe;V++)Y.push(j(de));return Y}case F.Object:return JSON.parse(de.read(n(de)).toString());case F.Int:return n(de)}}t.$qh=j;class z{constructor(ie,fe,Y=null,V=1e3){this.h=ie,this.j=fe,this.k=Y,this.l=V,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(ie,fe){this.b.set(ie,fe),setTimeout(()=>this.w(ie),0)}m(ie){switch(ie.type){case 200:{const fe=this.o([ie.type]);this.k?.logOutgoing(fe,0,1,l(ie.type));return}case 201:case 202:case 204:case 203:{const fe=this.o([ie.type,ie.id],ie.data);this.k?.logOutgoing(fe,ie.id,1,l(ie.type),ie.data);return}}}o(ie,fe=void 0){const Y=new o;return w(Y,ie),w(Y,fe),this.p(Y.buffer)}p(ie){try{return this.h.send(ie),ie.byteLength}catch{return 0}}q(ie){const fe=new c(ie),Y=j(fe),V=j(fe),G=Y[0];switch(G){case 100:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}: ${Y[2]}.${Y[3]}`,V),this.s({type:G,id:Y[1],channelName:Y[2],name:Y[3],arg:V});case 102:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}: ${Y[2]}.${Y[3]}`,V),this.t({type:G,id:Y[1],channelName:Y[2],name:Y[3],arg:V});case 101:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}`),this.u({type:G,id:Y[1]});case 103:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}`),this.u({type:G,id:Y[1]})}}s(ie){const fe=this.b.get(ie.channelName);if(!fe){this.v(ie);return}const Y=new _.$Xd;let V;try{V=fe.call(this.j,ie.name,ie.arg,Y.token)}catch(x){V=Promise.reject(x)}const G=ie.id;V.then(x=>{this.m({id:G,data:x,type:201})},x=>{x instanceof Error?this.m({id:G,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:G,data:x,type:203})}).finally(()=>{k.dispose(),this.d.delete(ie.id)});const k=(0,f.$Qc)(()=>Y.cancel());this.d.set(ie.id,k)}t(ie){const fe=this.b.get(ie.channelName);if(!fe){this.v(ie);return}const Y=ie.id,G=fe.listen(this.j,ie.name,ie.arg)(k=>this.m({id:Y,data:k,type:204}));this.d.set(ie.id,G)}u(ie){const fe=this.d.get(ie.id);fe&&(fe.dispose(),this.d.delete(ie.id))}v(ie){let fe=this.g.get(ie.channelName);fe||(fe=[],this.g.set(ie.channelName,fe));const Y=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.m({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);fe.push({request:ie,timeoutTimer:Y})}w(ie){const fe=this.g.get(ie);if(fe){for(const Y of fe)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(ie)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Nc)(this.d.values()),this.d.clear()}}t.$rh=z;var q;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(q||(t.RequestInitiator=q={}));class L{constructor(ie,fe=null){this.l=ie,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=fe}getChannel(ie){const fe=this;return{call(Y,V,G){return fe.a?Promise.reject(new v.$5):fe.m(ie,Y,V,G)},listen(Y,V){return fe.a?h.Event.None:fe.o(ie,Y,V)}}}m(ie,fe,Y,V=_.CancellationToken.None){const G=this.g++,x={id:G,type:100,channelName:ie,name:fe,arg:Y};if(V.isCancellationRequested)return Promise.reject(new v.$5);let $;return new Promise((M,N)=>{if(V.isCancellationRequested)return N(new v.$5);const A=()=>{const B=y=>{switch(y.type){case 201:this.f.delete(G),M(y.data);break;case 202:{this.f.delete(G);const C=new Error(y.data.message);C.stack=Array.isArray(y.data.stack)?y.data.stack.join(`
`):y.data.stack,C.name=y.data.name,N(C);break}case 203:this.f.delete(G),N(y.data);break}};this.f.set(G,B),this.p(x)};let E=null;this.b===g.Idle?A():(E=(0,O.$Hg)(B=>this.u()),E.then(()=>{E=null,A()}));const W=()=>{E?(E.cancel(),E=null):this.p({id:G,type:101}),N(new v.$5)},S=V.onCancellationRequested(W);$=(0,f.$Pc)((0,f.$Qc)(W),S),this.d.add($)}).finally(()=>{$.dispose(),this.d.delete($)})}o(ie,fe,Y){const V=this.g++,k={id:V,type:102,channelName:ie,name:fe,arg:Y};let x=null;const $=new h.$Nd({onWillAddFirstListener:()=>{x=(0,O.$Hg)(M=>this.u()),x.then(()=>{x=null,this.d.add($),this.p(k)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete($),this.p({id:V,type:103}))}}),I=M=>$.fire(M.data);return this.f.set(V,I),$.event}p(ie){switch(ie.type){case 100:case 102:{const fe=this.q([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.j?.logOutgoing(fe,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const fe=this.q([ie.type,ie.id]);this.j?.logOutgoing(fe,ie.id,0,e(ie.type));return}}}q(ie,fe=void 0){const Y=new o;return w(Y,ie),w(Y,fe),this.r(Y.buffer)}r(ie){try{return this.l.send(ie),ie.byteLength}catch{return 0}}s(ie){const fe=new c(ie),Y=j(fe),V=j(fe),G=Y[0];switch(G){case 200:return this.j?.logIncoming(ie.byteLength,0,0,l(G)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ie.byteLength,Y[1],0,l(G),V),this.t({type:Y[0],id:Y[1],data:V})}}t(ie){if(ie.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(ie.id)?.(ie)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Nc)(this.d.values()),this.d.clear()}}t.$sh=L,Qe([p.$hh],L.prototype,"onDidInitializePromise",null);class P{get connections(){const ie=[];return this.f.forEach(fe=>ie.push(fe)),ie}constructor(ie){this.a=new Map,this.f=new Set,this.g=new h.$Nd,this.onDidAddConnection=this.g.event,this.h=new h.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new f.$Rc,this.j.add(ie(({protocol:fe,onDidClientDisconnect:Y})=>{const V=h.Event.once(fe.onMessage);this.j.add(V(G=>{const k=new c(G),x=j(k),$=new z(fe,x),I=new L(fe);this.a.forEach((N,A)=>$.registerChannel(A,N));const M={channelServer:$,channelClient:I,ctx:x};this.f.add(M),this.g.fire(M),this.j.add(Y(()=>{$.dispose(),I.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(ie,fe){const Y=this;return{call(V,G,k){let x;if((0,s.$Mf)(fe)){const I=(0,D.$4b)(Y.connections.filter(fe));x=I?Promise.resolve(I):h.Event.toPromise(h.Event.filter(Y.onDidAddConnection,fe))}else x=fe.routeCall(Y,V,G);const $=x.then(I=>I.channelClient.getChannel(ie));return ee($).call(V,G,k)},listen(V,G){if((0,s.$Mf)(fe))return Y.k(ie,fe,V,G);const k=fe.routeEvent(Y,V,G).then(x=>x.channelClient.getChannel(ie));return ee(k).listen(V,G)}}}k(ie,fe,Y,V){const G=this;let k;const x=new h.$Nd({onWillAddFirstListener:()=>{k=new f.$Rc;const $=new h.$Td,I=new Map,M=A=>{const W=A.channelClient.getChannel(ie).listen(Y,V),S=$.add(W);I.set(A,S)},N=A=>{const E=I.get(A);E&&(E.dispose(),I.delete(A))};G.connections.filter(fe).forEach(M),h.Event.filter(G.onDidAddConnection,fe)(M,void 0,k),G.onDidRemoveConnection(N,void 0,k),$.event(x.fire,x,k),k.add($)},onDidRemoveLastListener:()=>{k?.dispose(),k=void 0}});return x.event}registerChannel(ie,fe){this.a.set(ie,fe);for(const Y of this.f)Y.channelServer.registerChannel(ie,fe)}dispose(){this.j.dispose();for(const ie of this.f)ie.channelClient.dispose(),ie.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$th=P;class J{constructor(ie,fe,Y=null){const V=new o;w(V,fe),ie.send(V.buffer),this.a=new L(ie,Y),this.d=new z(ie,fe,Y)}getChannel(ie){return this.a.getChannel(ie)}registerChannel(ie,fe){this.d.registerChannel(ie,fe)}dispose(){this.a.dispose(),this.d.dispose()}}t.$uh=J;function ee(de){return{call(ie,fe,Y){return de.then(V=>V.call(ie,fe,Y))},listen(ie,fe){const Y=new h.$Wd;return de.then(V=>Y.input=V.listen(ie,fe)),Y.event}}}t.$vh=ee;function ne(de){let ie=!1;return{call(fe,Y,V){return ie?de.call(fe,Y,V):(0,O.$Ug)(0).then(()=>ie=!0).then(()=>de.call(fe,Y,V))},listen(fe,Y){if(ie)return de.listen(fe,Y);const V=new h.$Wd;return(0,O.$Ug)(0).then(()=>ie=!0).then(()=>V.input=de.listen(fe,Y)),V.event}}}t.$wh=ne;class ue{constructor(ie){this.a=ie}routeCall(ie){return this.b(ie)}routeEvent(ie){return this.b(ie)}async b(ie){for(const fe of ie.connections)if(await Promise.resolve(this.a(fe.ctx)))return Promise.resolve(fe);return await h.Event.toPromise(ie.onDidAddConnection),await this.b(ie)}}t.$xh=ue;var le;(function(de){function ie(G,k,x){const $=G,I=x&&x.disableMarshalling,M=new Map;for(const N in $)Y(N)&&M.set(N,h.Event.buffer($[N],!0,void 0,k));return new class{listen(N,A,E){const W=M.get(A);if(W)return W;if(V(A)){const S=$[A];if(typeof S=="function")return S.call($,E)}throw new v.$bb(`Event not found: ${A}`)}call(N,A,E){const W=$[A];if(typeof W=="function"){if(!I&&Array.isArray(E))for(let B=0;B<E.length;B++)E[B]=(0,d.$mh)(E[B]);let S=W.apply($,E);return S instanceof Promise||(S=Promise.resolve(S)),S}throw new v.$bb(`Method not found: ${A}`)}}}de.fromService=ie;function fe(G,k){const x=k&&k.disableMarshalling;return new Proxy({},{get($,I){if(typeof I=="string")return k?.properties?.has(I)?k.properties.get(I):V(I)?function(M){return G.listen(I,M)}:Y(I)?G.listen(I):async function(...M){let N;k&&!(0,s.$Hf)(k.context)?N=[k.context,...M]:N=M;const A=await G.call(I,N);return x?A:(0,d.$mh)(A)};throw new v.$bb(`Property not found: ${String(I)}`)}})}de.toService=fe;function Y(G){return G[0]==="o"&&G[1]==="n"&&T.$1e(G.charCodeAt(2))}function V(G){return/^onDynamic/.test(G)&&T.$1e(G.charCodeAt(9))}})(le||(t.ProxyChannel=le={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ie=de.toString();if(ie!=="[object Object]")return ie}return de}function Se(de){return Array.isArray(de)?de.map(me):me(de)}function Te(de,ie,fe,Y,V,G,k){k=Se(k);const x=oe[V],$=x[Y%x.length];let I=[`%c[${de}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(fe).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(G)?(I=I.concat(k),I.push(")")):I.push(k),console.log.apply(console,I)}class Pe{constructor(ie,fe){this.d=ie,this.f=fe,this.a=0,this.b=0}logOutgoing(ie,fe,Y,V,G){this.b+=ie,Te(this.d,this.b,ie,fe,Y,V,G)}logIncoming(ie,fe,Y,V,G){this.a+=ie,Te(this.f,this.a,ie,fe,Y,V,G)}}t.$yh=Pe}),define(be[30],$e([1,0,5]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=t.$N=void 0,t.$N=D.$h.vscode.ipcRenderer,t.$O=D.$h.vscode.ipcMessagePort,t.$P=D.$h.vscode.webFrame,t.$Q=D.$h.vscode.process,t.$R=D.$h.vscode.context;function O(i){if(i===window)return{ipcRenderer:t.$N,webFrame:t.$P};const _=i;if(_?.vscode?.ipcRenderer&&_?.vscode?.webFrame)return _.vscode}t.$S=O}),define(be[131],$e([1,0,87,30]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=void 0;let i=0;function _(v,h,f){const d=[],T=i++,s=`vscode:onContextMenu${T}`,a=(e,u,l)=>{d[u].click?.(l)};O.$N.once(s,a),O.$N.once(D.$iT,(e,u)=>{u===T&&(O.$N.removeListener(s,a),f?.())}),O.$N.send(D.$hT,T,v.map(e=>p(e,d)),s,h)}t.$lT=_;function p(v,h){const f={id:h.length,label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:typeof v.enabled=="boolean"?v.enabled:!0,visible:typeof v.visible=="boolean"?v.visible:!0};return h.push(v),Array.isArray(v.submenu)&&(f.submenu=v.submenu.map(d=>p(d,h))),f}}),define(be[132],$e([1,0,32,4,65,88,30]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tT=void 0;class v extends i.$uh{static f(){const f=O.Event.fromNodeEventEmitter(p.$N,"vscode:message",(d,T)=>D.$be.wrap(T));return p.$N.send("vscode:hello"),new _.$pT(p.$N,f)}constructor(f){const d=v.f();super(d,f),this.b=d}dispose(){this.b.disconnect()}}t.$tT=v}),define(be[133],$e([13,10]),function(re,t){return re.create("vs/platform/files/common/files",t)}),define(be[134],$e([13,10]),function(re,t){return re.create("vs/platform/theme/common/iconRegistry",t)}),define(be[39],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qh=t.$Ph=t.$Oh=t._util=void 0;var D;(function(p){p.serviceIds=new Map,p.DI_TARGET="$di$target",p.DI_DEPENDENCIES="$di$dependencies";function v(h){return h[p.DI_DEPENDENCIES]||[]}p.getServiceDependencies=v})(D||(t._util=D={})),t.$Oh=i("instantiationService");function O(p,v,h){v[D.DI_TARGET]===v?v[D.DI_DEPENDENCIES].push({id:p,index:h}):(v[D.DI_DEPENDENCIES]=[{id:p,index:h}],v[D.DI_TARGET]=v)}function i(p){if(D.serviceIds.has(p))return D.serviceIds.get(p);const v=function(h,f,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(v,h,d)};return v.toString=()=>p,D.serviceIds.set(p,v),v}t.$Ph=i;function _(p){return p}t.$Qh=_}),define(be[135],$e([1,0,39]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sm=t.$rm=t.$qm=t.ID=void 0,t.ID="diagnosticsService",t.$qm=(0,D.$Ph)(t.ID);function O(_){return!!_.hostName&&!!_.errorMessage}t.$rm=O;class i{async getPerformanceInfo(p,v){return{}}async getSystemInfo(p,v){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(p,v){return""}async getWorkspaceFileExtensions(p){return{extensions:[]}}async reportWorkspaceStats(p){}}t.$sm=i}),define(be[136],$e([1,0,86,22,12,7,15,133,39,5,29,27]),function(re,t,D,O,i,_,p,v,h,f,d,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hk=t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.FileKind=t.$Ck=t.$Bk=t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.FileOperationResult=t.$vk=t.$uk=t.$tk=t.$sk=t.$rk=t.FileChangeType=t.$qk=t.FileOperation=t.$pk=t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.FileSystemProviderErrorCode=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=t.FileSystemProviderCapabilities=t.$ak=t.FilePermission=t.FileType=t.$_j=t.$$j=void 0,t.$$j=(0,h.$Ph)("fileService");function s(V){return V.create===!0}t.$_j=s;var a;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(a||(t.FileType=a={}));var e;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function u(V){const G=V;return!!G&&typeof G.onDidChange=="function"}t.$ak=u;var l;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function g(V){return!!(V.capabilities&2)}t.$bk=g;function n(V){return!!(V.capabilities&8)}t.$ck=n;function r(V){return!!(V.capabilities&131072)}t.$dk=r;function b(V){return!!(V.capabilities&4)}t.$ek=b;function c(V){return!!(V.capabilities&16)}t.$fk=c;function o(V){return g(V)?!!(V.capabilities&16384):!1}t.$gk=o;function F(V){return g(V)?!!(V.capabilities&32768):!1}t.$hk=F;function H(V){return!!(V.capabilities&65536)}t.$ik=H;function R(V){return!!(V.capabilities&2048)}t.$jk=R;var m;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(m||(t.FileSystemProviderErrorCode=m={}));class w extends Error{static create(G,k){const x=new w(G.toString(),k);return q(x,k),x}constructor(G,k){super(G),this.code=k}}t.$kk=w;function j(V,G){return w.create(V,G)}t.$lk=j;function z(V){return V||j((0,v.localize)(0,null),m.Unknown)}t.$mk=z;function q(V,G){return V.name=G?`${G} (FileSystemError)`:"FileSystemError",V}t.$nk=q;function L(V){if(!V)return m.Unknown;if(V instanceof w)return V.code;const G=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!G)return m.Unknown;switch(G[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}t.$ok=L;function P(V){if(V instanceof oe)return V.fileOperationResult;switch(L(V)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 9;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileTooLarge:return 7;default:return 10}}t.$pk=P;var J;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(J||(t.FileOperation=J={}));class ee{constructor(G,k,x){this.resource=G,this.operation=k,this.target=x}isOperation(G){return this.operation===G}}t.$qk=ee;var ne;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(ne||(t.FileChangeType=ne={}));class ue{static{this.a=null}constructor(G,k){this.c=k,this.b=void 0,this.d=new T.$V(()=>{const x=D.$Vh.forUris(()=>this.c);return x.fill(this.rawAdded.map($=>[$,!0])),x}),this.f=new T.$V(()=>{const x=D.$Vh.forUris(()=>this.c);return x.fill(this.rawUpdated.map($=>[$,!0])),x}),this.g=new T.$V(()=>{const x=D.$Vh.forUris(()=>this.c);return x.fill(this.rawDeleted.map($=>[$,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of G){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.b!==ue.a&&(typeof x.cId=="number"?this.b===void 0?this.b=x.cId:this.b!==x.cId&&(this.b=ue.a):this.b!==void 0&&(this.b=ue.a))}}contains(G,...k){return this.h(G,{includeChildren:!1},...k)}affects(G,...k){return this.h(G,{includeChildren:!0},...k)}h(G,k,...x){if(!G)return!1;const $=x.length>0;return!!((!$||x.includes(1))&&(this.d.value.get(G)||k.includeChildren&&this.d.value.findSuperstr(G))||(!$||x.includes(0))&&(this.f.value.get(G)||k.includeChildren&&this.f.value.findSuperstr(G))||(!$||x.includes(2))&&(this.g.value.findSubstr(G)||k.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}t.$rk=ue;function le(V,G,k){return!V||!G||V===G||G.length>V.length?!1:(G.charAt(G.length-1)!==O.sep&&(G+=O.sep),k?(0,i.$3e)(V,G):V.indexOf(G)===0)}t.$sk=le;class oe extends Error{constructor(G,k,x){super(G),this.fileOperationResult=k,this.options=x}}t.$tk=oe;class me extends oe{constructor(G,k,x,$){super(G,k,$),this.fileOperationResult=k,this.size=x}}t.$uk=me;class Se extends oe{constructor(G,k,x){super(G,2,x),this.stat=k}}t.$vk=Se;var Te;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Te||(t.FileOperationResult=Te={})),t.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$yk="files.associations",t.$zk="files.exclude",t.$Ak="files.readonlyInclude",t.$Bk="files.readonlyExclude",t.$Ck="files.readonlyFromPermissions";var Pe;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(Pe||(t.FileKind=Pe={})),t.$Dk="";function de(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}t.$Ek=de;async function ie(V,G){if(!G.hasProvider(p.URI.from({scheme:V.scheme})))return new Promise(k=>{const x=G.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===V.scheme&&$.added&&(x.dispose(),k())})})}t.$Fk=ie;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(G){return(0,_.$Cf)(G)||(G=0),G<fe.KB?(0,v.localize)(1,null,G.toFixed(0)):G<fe.MB?(0,v.localize)(2,null,(G/fe.KB).toFixed(2)):G<fe.GB?(0,v.localize)(3,null,(G/fe.MB).toFixed(2)):G<fe.TB?(0,v.localize)(4,null,(G/fe.GB).toFixed(2)):(0,v.localize)(5,null,(G/fe.TB).toFixed(2))}}t.$Gk=fe;function Y(V){const G=typeof V=="string"||V?.scheme===d.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===d.Schemas.file?1024*fe.MB:G?10*fe.MB:f.$p?50*fe.MB:1024*fe.MB}t.$Hk=Y}),define(be[137],$e([1,0,39]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$h8b=t.$g8b=void 0,t.$g8b=(0,D.$Ph)("mainProcessService");class O{constructor(_,p){this.a=_,this.b=p}getChannel(_){return this.a.getChannel(_,this.b)}registerChannel(_,p){this.a.registerChannel(_,p)}}t.$h8b=O}),define(be[138],$e([1,0,2,132]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$i8b=void 0;class i extends D.$Sc{constructor(p){super(),this.a=this.B(new O.$tT(`window:${p}`))}getChannel(p){return this.a.getChannel(p)}registerChannel(p,v){this.a.registerChannel(p,v)}}t.$i8b=i});var wi=this&&this.__param||function(re,t){return function(D,O){t(D,O,re)}};define(be[139],$e([1,0,65,137]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$j8b=void 0;let i=class{constructor(p,v){return this.windowId=p,D.ProxyChannel.toService(v.getChannel("nativeHost"),{context:p,properties:(()=>{const h=new Map;return h.set("windowId",p),h})()})}};t.$j8b=i,t.$j8b=i=Qe([wi(1,O.$g8b)],i)}),define(be[66],$e([1,0,74,7]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gn=void 0;class i{constructor(){this.a=new Map}add(p,v){D.ok(O.$yf(p)),D.ok(O.$Af(v)),D.ok(!this.a.has(p),"There is already an extension with this id"),this.a.set(p,v)}knows(p){return this.a.has(p)}as(p){return this.a.get(p)||null}}t.$gn=new i}),define(be[140],$e([1,0,4,66]),function(re,t,D,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hn=void 0,t.$hn={JSONContribution:"base.contributions.json"};function i(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class _{constructor(){this.b=new D.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,f){this.a[i(h)]=f,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const p=new _;O.$gn.add(t.$hn.JSONContribution,p)}),define(be[141],$e([1,0,9,17,18,4,7,15,134,140,66]),function(re,t,D,O,i,_,p,v,h,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aw=t.$_v=t.$$v=t.$0v=t.$9v=t.$8v=t.$7v=t.$6v=t.IconFontDefinition=t.IconContribution=t.$5v=void 0,t.$5v={IconContribution:"base.contributions.icons"};var T;(function(b){function c(o,F){let H=o.defaults;for(;i.ThemeIcon.isThemeIcon(H);){const R=e.getIcon(H.id);if(!R)return;H=R.defaults}return H}b.getDefinition=c})(T||(t.IconContribution=T={}));var s;(function(b){function c(F){return{weight:F.weight,style:F.style,src:F.src.map(H=>({format:H.format,location:H.location.toString()}))}}b.toJSONObject=c;function o(F){const H=R=>(0,p.$yf)(R)?R:void 0;if(F&&Array.isArray(F.src)&&F.src.every(R=>(0,p.$yf)(R.format)&&(0,p.$yf)(R.location)))return{weight:H(F.weight),style:H(F.style),src:F.src.map(R=>({format:R.format,location:v.URI.parse(R.location)}))}}b.fromJSONObject=o})(s||(t.IconFontDefinition=s={}));class a{constructor(){this.a=new _.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,h.localize)(0,null)},fontCharacter:{type:"string",description:(0,h.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,o,F,H){const R=this.b[c];if(R){if(F&&!R.description){R.description=F,this.d.properties[c].markdownDescription=`${F} $(${c})`;const j=this.e.enum.indexOf(c);j!==-1&&(this.e.enumDescriptions[j]=F),this.a.fire()}return R}const m={id:c,description:F,defaults:o,deprecationMessage:H};this.b[c]=m;const w={$ref:"#/definitions/icons"};return H&&(w.deprecationMessage=H),F&&(w.markdownDescription=`${F}: $(${c})`),this.d.properties[c]=w,this.e.enum.push(c),this.e.enumDescriptions.push(F||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const o=this.e.enum.indexOf(c);o!==-1&&(this.e.enum.splice(o,1),this.e.enumDescriptions.splice(o,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,o){const F=this.f[c];return F||(this.f[c]=o,this.a.fire(),o)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=(R,m)=>R.id.localeCompare(m.id),o=R=>{for(;i.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const H=Object.keys(this.b).map(R=>this.b[R]);for(const R of H.filter(m=>!!m.description).sort(c))F.push(`|<i class="${o(R)}"></i>|${R.id}|${i.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const R of H.filter(m=>!i.ThemeIcon.isThemeIcon(m.defaults)).sort(c))F.push(`|<i class="${o(R)}"></i>|${R.id}|`);return F.join(`
`)}}const e=new a;d.$gn.add(t.$5v.IconContribution,e);function u(b,c,o,F){return e.registerIcon(b,c,o,F)}t.$6v=u;function l(){return e}t.$7v=l;function g(){const b=(0,O.$Sj)();for(const c in b){const o="\\"+b[c].toString(16);e.registerIcon(c,{fontCharacter:o})}}g(),t.$8v="vscode://schemas/icons";const n=d.$gn.as(f.$hn.JSONContribution);n.registerSchema(t.$8v,e.getIconSchema());const r=new D.$6g(()=>n.notifySchemaChanged(t.$8v),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$9v=u("widget-close",O.$Uj.close,(0,h.localize)(2,null)),t.$0v=u("goto-previous-location",O.$Uj.arrowUp,(0,h.localize)(3,null)),t.$$v=u("goto-next-location",O.$Uj.arrowDown,(0,h.localize)(4,null)),t.$_v=i.ThemeIcon.modify(O.$Uj.sync,"spin"),t.$aw=i.ThemeIcon.modify(O.$Uj.loading,"spin")}),define(be[142],$e([1,0,3,4,2,18,141]),function(re,t,D,O,i,_,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xCb=t.$wCb=void 0;function v(f){const d=new i.$Rc,T=d.add(new O.$Nd),s=(0,p.$7v)();return d.add(s.onDidChange(()=>T.fire())),f&&d.add(f.onDidProductIconThemeChange(()=>T.fire())),{dispose:()=>d.dispose(),onDidChange:T.event,getCSS(){const a=f?f.getProductIconTheme():new h,e={},u=g=>{const n=a.getIcon(g);if(!n)return;const r=n.font;return r?(e[r.id]=r.definition,`.codicon-${g.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,D.$NP)(r.id)}; }`):`.codicon-${g.id}:before { content: '${n.fontCharacter}'; }`},l=[];for(const g of s.getIcons()){const n=u(g);n&&l.push(n)}for(const g in e){const n=e[g],r=n.weight?`font-weight: ${n.weight};`:"",b=n.style?`font-style: ${n.style};`:"",c=n.src.map(o=>`${(0,D.$MP)(o.location)} format('${o.format}')`).join(", ");l.push(`@font-face { src: ${c}; font-family: ${(0,D.$NP)(g)};${r}${b} font-display: block; }`)}return l.join(`
`)}}}t.$wCb=v;class h{getIcon(d){const T=(0,p.$7v)();let s=d.defaults;for(;_.ThemeIcon.isThemeIcon(s);){const a=T.getIcon(s.id);if(!a)return;s=a.defaults}return s}}t.$xCb=h}),define(be[143],$e([1,0,5]),function(re,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9C=t.$8C=t.$7C=t.$6C=t.$5C=t.$4C=t.$3C=t.$2C=void 0,t.$2C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function O(d){return!!d.workspaceUri}t.$3C=O;function i(d){return!!d.folderUri}t.$4C=i;function _(d){return!!d.fileUri}t.$5C=_;function p(d){const T=v(d),s=d.getValue("window.menuBarVisibility");return s==="default"||T==="native"&&s==="compact"||D.$k&&D.$n?"classic":s}t.$6C=p;function v(d){if(D.$p)return"custom";const T=d.getValue("window");if(T){if(D.$k&&T.nativeTabs===!0||D.$k&&T.nativeFullScreen===!1)return"native";const e=T.titleBarStyle;if(e==="native"||e==="custom")return e}return D.$l?"native":"custom"}t.$7C=v;function h(d){return!(!D.$j||D.$p||v(d)==="native")}t.$8C=h;function f(d=0){return Math.pow(1.2,d)}t.$9C=f}),define(be[144],$e([1,0,16,3,30,143]),function(re,t,D,O,i,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$n8b=t.$m8b=t.$l8b=void 0;function p(f){for(const d of(0,O.getWindows)())(0,i.$S)(d)?.webFrame?.setZoomLevel(f);(0,D.$iO)((0,_.$9C)(f)),(0,D.$fO)(f)}t.$l8b=p;function v(){p((0,D.$gO)()+1)}t.$m8b=v;function h(){p((0,D.$gO)()-1)}t.$n8b=h}),define(be[145],$e([1,0,10,3,130,9,131,30,135,136,138,139,142,144,14,101,92]),function(re,t,D,O,i,_,p,v,h,f,d,T,s,a,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const u=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class g{getHeight(q){return 22}getTemplateId(q){return R(q)?"process":F(q)?"machine":(0,h.$rm)(q)?"error":H(q)?"header":""}}class n{hasChildren(q){return(0,h.$rm)(q)?!1:R(q)?!!q.children?.length:!0}getChildren(q){return R(q)?q.children?q.children:[]:(0,h.$rm)(q)?[]:H(q)?q.processRoots.length>1?q.processRoots:[q.processRoots[0].rootProcess]:F(q)?[q.rootProcess]:[q.processes]}}class r{constructor(){this.templateId="header"}renderTemplate(q){const L=(0,O.$wP)(q,(0,O.$)(".row")),P=(0,O.$wP)(L,(0,O.$)(".nameLabel")),J=(0,O.$wP)(L,(0,O.$)(".cpu")),ee=(0,O.$wP)(L,(0,O.$)(".memory")),ne=(0,O.$wP)(L,(0,O.$)(".pid"));return{name:P,CPU:J,memory:ee,PID:ne}}renderElement(q,L,P,J){P.name.textContent=(0,D.localize)(0,null),P.CPU.textContent=(0,D.localize)(1,null),P.PID.textContent=(0,D.localize)(2,null),P.memory.textContent=(0,D.localize)(3,null)}disposeTemplate(q){}}class b{constructor(){this.templateId="machine"}renderTemplate(q){const L=Object.create(null),P=(0,O.$wP)(q,(0,O.$)(".row"));return L.name=(0,O.$wP)(P,(0,O.$)(".nameLabel")),L}renderElement(q,L,P,J){P.name.textContent=q.element.name}disposeTemplate(q){}}class c{constructor(){this.templateId="error"}renderTemplate(q){const L=Object.create(null),P=(0,O.$wP)(q,(0,O.$)(".row"));return L.name=(0,O.$wP)(P,(0,O.$)(".nameLabel")),L}renderElement(q,L,P,J){P.name.textContent=q.element.errorMessage}disposeTemplate(q){}}class o{constructor(q,L,P){this.a=q,this.b=L,this.c=P,this.templateId="process"}renderTemplate(q){const L=(0,O.$wP)(q,(0,O.$)(".row")),P=(0,O.$wP)(L,(0,O.$)(".nameLabel")),J=(0,O.$wP)(L,(0,O.$)(".cpu")),ee=(0,O.$wP)(L,(0,O.$)(".memory")),ne=(0,O.$wP)(L,(0,O.$)(".pid"));return{name:P,CPU:J,PID:ne,memory:ee}}renderElement(q,L,P,J){const{element:ee}=q,ne=ee.pid.toFixed(0);let ue=ee.name;this.c.has(ee.pid)&&(ue=this.c.get(ee.pid)),P.name.textContent=ue,P.name.title=ee.cmd,P.CPU.textContent=ee.load.toFixed(0),P.PID.textContent=ne,P.PID.parentElement.id=`pid-${ne}`;const le=this.a==="win32"?ee.mem:this.b*(ee.mem/100);P.memory.textContent=(le/f.$Gk.MB).toFixed(0)}disposeTemplate(q){}}function F(z){return!!z.name&&!!z.rootProcess}function H(z){return!!z.processRoots}function R(z){return!!z.pid}class m{constructor(q,L){this.f=L,this.b=new Map;const P=new d.$i8b(q);this.c=new T.$j8b(q,P),this.k(L.styles),this.g(L),v.$N.on("vscode:pidToNameResponse",(J,ee)=>{this.b=new Map;for(const[ne,ue]of ee)this.b.set(ne,ue)}),v.$N.on("vscode:listProcessesResponse",async(J,ee)=>{ee.forEach((ne,ue)=>{R(ne.rootProcess)&&(ne.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ee}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ee),this.m(0)}),this.a=Date.now(),v.$N.send("vscode:pidToNameRequest"),v.$N.send("vscode:listProcesses")}g(q){document.onkeydown=L=>{const P=q.platform==="darwin"?L.metaKey:L.ctrlKey;P&&L.keyCode===87&&(L.stopPropagation(),L.preventDefault(),v.$N.send("vscode:closeProcessExplorer")),P&&L.keyCode===187&&(0,a.$m8b)(),P&&L.keyCode===189&&(0,a.$n8b)()}}async h(q){const L=document.getElementById("process-list");if(!L)return;const{totalmem:P}=await this.c.getOSStatistics(),J=[new o(this.f.platform,P,this.b),new r,new b,new c];this.d=new i.$RS("processExplorer",L,new g,J,new n,{identityProvider:{getId:ee=>R(ee)?ee.pid.toString():(0,h.$rm)(ee)?ee.hostName:H(ee)?"processes":F(ee)?ee.name:"header"}}),this.d.setInput({processes:{processRoots:q}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ee=>{const ne=new e.$DO(ee);if(ne.keyCode===35&&ne.altKey){const ue=this.n();Promise.all(ue.map(le=>this.c.killProcess(le,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ee=>{R(ee.element)&&this.l(ee.element,!0)}),L.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{L.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(q){const L=u.exec(q);return L&&L.groups.port!=="0"||q.indexOf("node ")>=0||q.indexOf("node.exe")>=0}j(q){const L={type:"node",request:"attach",name:`process ${q.pid}`};let P=u.exec(q.cmd);P?L.port=Number(P.groups.port):L.processId=String(q.pid),P=l.exec(q.cmd),P&&(L.port=Number(P.groups.port)),v.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[L]})}k(q){const L=(0,O.$hP)(),P=[];q.listFocusBackground&&(P.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${q.listFocusBackground}; }`),P.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${q.listFocusBackground}; }`)),q.listFocusForeground&&P.push(`.monaco-list:focus .monaco-list-row.focused { color: ${q.listFocusForeground}; }`),q.listActiveSelectionBackground&&(P.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${q.listActiveSelectionBackground}; }`),P.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${q.listActiveSelectionBackground}; }`)),q.listActiveSelectionForeground&&P.push(`.monaco-list:focus .monaco-list-row.selected { color: ${q.listActiveSelectionForeground}; }`),q.listHoverBackground&&P.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${q.listHoverBackground}; }`),q.listHoverForeground&&P.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${q.listHoverForeground}; }`),q.listFocusOutline&&P.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${q.listFocusOutline}; outline-offset: -1px; }`),q.listHoverOutline&&P.push(`.monaco-list-row:hover { outline: 1px dashed ${q.listHoverOutline}; outline-offset: -1px; }`),q.scrollbarShadowColor&&P.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${q.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${q.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${q.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),q.scrollbarSliderBackgroundColor&&P.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${q.scrollbarSliderBackgroundColor};
				}
			`),q.scrollbarSliderHoverBackgroundColor&&P.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${q.scrollbarSliderHoverBackgroundColor};
				}
			`),q.scrollbarSliderActiveBackgroundColor&&P.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${q.scrollbarSliderActiveBackgroundColor};
				}
			`),L.textContent=P.join(`
`),q.color&&(document.body.style.color=q.color)}l(q,L){const P=[],J=Number(q.pid);L&&(P.push({accelerator:"Alt+E",label:(0,D.localize)(4,null),click:()=>{this.c.killProcess(J,"SIGTERM")}}),P.push({label:(0,D.localize)(5,null),click:()=>{this.c.killProcess(J,"SIGKILL")}}),P.push({type:"separator"})),P.push({label:(0,D.localize)(6,null),click:()=>{const ee=this.n();ee?.includes(J)||(ee.length=0,ee.push(J));const ne=ee?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(ne){const ue=ne.map(le=>le.innerText).filter(le=>!!le);this.c.writeClipboardText(ue.join(`
`))}}}),P.push({label:(0,D.localize)(7,null),click:()=>{const ee=document.getElementById("process-list");ee&&this.c.writeClipboardText(ee.innerText)}}),q&&L&&this.i(q.cmd)&&(P.push({type:"separator"}),P.push({label:(0,D.localize)(8,null),click:()=>{this.j(q)}})),(0,p.$lT)(P)}m(q){setTimeout(()=>{const L=Date.now(),P=q+L-this.a;this.a=L,P>1e3?(v.$N.send("vscode:pidToNameRequest"),v.$N.send("vscode:listProcesses")):this.m(P)},200)}n(){return this.d?.getSelection()?.map(q=>{if(!(!q||!("pid"in q)))return q.pid}).filter(q=>!!q)}}function w(){const z=(0,O.$hP)();z.id="codiconStyles";const q=(0,s.$wCb)(void 0);function L(){z.textContent=q.getCSS()}const P=new _.$6g(L,0);q.onDidChange(()=>P.schedule()),P.schedule()}function j(z){const q=z.data.platform==="win32"?"windows":z.data.platform==="linux"?"linux":"mac";document.body.classList.add(q),w(),(0,a.$l8b)(z.data.zoomLevel),new m(z.windowId,z.data)}t.startup=j})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c36b92c82064882a228487040187cfc13669c0f/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
