/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(G){for(var e=[],L=0,R=G.length;L<R;L++)e[L]=ne[G[L]];return e};define(ne[70],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const A=new Map,j=new Map,D=new Map,b=new Map;function u(d,E){d.has(E.detail)||d.set(E.detail,-E.timestamp)}function c(d,E){const v=d.get(E.detail);v&&(v>=0||d.set(E.detail,v+E.timestamp))}let S=[];typeof G=="function"&&typeof G.getStats=="function"&&(S=G.getStats().slice(0).sort((d,E)=>d.timestamp-E.timestamp));for(const d of S)switch(d.type){case 10:u(A,d);break;case 11:case 12:c(A,d);break;case 21:u(j,d);break;case 22:c(j,d);break;case 33:u(D,d);break;case 34:c(D,d);break;case 31:u(b,d);break;case 32:c(b,d);break}let N=0;D.forEach(d=>N+=d);function g(d){const E=[];return d.forEach((v,$)=>E.push([$,v])),E}return{amdLoad:g(A),amdInvoke:g(j),nodeRequire:g(D),nodeEval:g(b),nodeRequireTotal:N}}static toMarkdownTable(A,j){let D="";const b=[];return A.forEach((u,c)=>{b[c]=u.length}),j.forEach(u=>{u.forEach((c,S)=>{typeof c>"u"&&(c=u[S]="-");const N=c.toString().length;b[S]=Math.max(N,b[S])})}),A.forEach((u,c)=>{D+=`| ${u+" ".repeat(b[c]-u.toString().length)} `}),D+=`|
`,A.forEach((u,c)=>{D+=`| ${"-".repeat(b[c])} `}),D+=`|
`,j.forEach(u=>{u.forEach((c,S)=>{typeof c<"u"&&(D+=`| ${c+" ".repeat(b[S]-c.toString().length)} `)}),D+=`|
`}),D}}e.$U=L}),define(ne[52],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function L(D){return(b,u,c)=>{let S=null,N=null;if(typeof c.value=="function"?(S="value",N=c.value):typeof c.get=="function"&&(S="get",N=c.get),!N)throw new Error("not supported");c[S]=D(N,u)}}function R(D,b,u){let c=null,S=null;if(typeof u.value=="function"?(c="value",S=u.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",S=u.get),!S)throw new Error("not supported");const N=`$memoize$${b}`;u[c]=function(...g){return this.hasOwnProperty(N)||Object.defineProperty(this,N,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,g)}),this[N]}}e.$hh=R;function A(D,b,u){return L((c,S)=>{const N=`$debounce$${S}`,g=`$debounce$result$${S}`;return function(...d){this[g]||(this[g]=u?u():void 0),clearTimeout(this[N]),b&&(this[g]=b(this[g],...d),d=[this[g]]),this[N]=setTimeout(()=>{c.apply(this,d),this[g]=u?u():void 0},D)}})}e.$ih=A;function j(D,b,u){return L((c,S)=>{const N=`$throttle$timer$${S}`,g=`$throttle$result$${S}`,d=`$throttle$lastRun$${S}`,E=`$throttle$pending$${S}`;return function(...v){if(this[g]||(this[g]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),b&&(this[g]=b(this[g],...v)),this[E])return;const $=this[d]+D;$<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0):(this[E]=!0,this[N]=setTimeout(()=>{this[E]=!1,this[d]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0},$-Date.now()))}})}e.$jh=j}),define(ne[71],re([0,1,9]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function R(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=R;function A(u,c="Unreachable"){throw new Error(c)}e.$4c=A;function j(u){if(!u)throw new L.$cb("Assertion Failed")}e.$5c=j;function D(u){if(!u()){debugger;u(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$6c=D;function b(u,c){let S=0;for(;S<u.length-1;){const N=u[S],g=u[S+1];if(!c(N,g))return!1;S++}return!0}e.$7c=b}),define(ne[53],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var R;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var A;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var j;(function(s){s.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function D(s,o=!1){let t=0;const i=s.length;let n="",r=0,l=16,P=0;function y(te){let ae=0,le=0;for(;ae<te;){const ie=s.charCodeAt(t);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;t++,ae++}return ae<te&&(le=-1),le}function w(te){t=te,n="",r=0,l=16,P=0}function O(){const te=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return P=3,s.substring(te,t);let ae=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ae=t}else P=3;return s.substring(te,ae)}function H(){let te="",ae=t;for(;;){if(t>=i){te+=s.substring(ae,t),P=2;break}const le=s.charCodeAt(t);if(le===34){te+=s.substring(ae,t),t++;break}if(le===92){if(te+=s.substring(ae,t),t++,t>=i){P=2;break}switch(s.charCodeAt(t++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const q=y(4);q>=0?te+=String.fromCharCode(q):P=4;break}default:P=5}ae=t;continue}if(le>=0&&le<=31)if(u(le)){te+=s.substring(ae,t),P=2;break}else P=6;t++}return te}function _(){if(n="",P=0,r=t,t>=i)return r=i,l=17;let te=s.charCodeAt(t);if(b(te)){do t++,n+=String.fromCharCode(te),te=s.charCodeAt(t);while(b(te));return l=15}if(u(te))return t++,n+=String.fromCharCode(te),te===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),l=14;switch(te){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,n=H(),l=10;case 47:{const ae=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!u(s.charCodeAt(t));)t++;return n=s.substring(ae,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const le=i-1;let ie=!1;for(;t<le;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,ie=!0;break}t++}return ie||(t++,P=1),n=s.substring(ae,t),l=13}return n+=String.fromCharCode(te),t++,l=16}case 45:if(n+=String.fromCharCode(te),t++,t===i||!c(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=O(),l=11;default:for(;t<i&&x(te);)t++,te=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(te),t++,l=16}}function x(te){if(b(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=_();while(te>=12&&te<=15);return te}return{setPosition:w,getPosition:()=>t,scan:o?ue:_,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>P}}e.$Um=D;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function u(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var S;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(S||(S={}));function N(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(y,w,O,H){r.value=y,r.offset=w,r.length=O,r.type=H,r.colonOffset=void 0,n=r}try{I(s,{onObjectBegin:(y,w)=>{if(o<=y)throw i;n=void 0,l=o>y,t.push("")},onObjectProperty:(y,w,O)=>{if(o<w||(P(y,w,O,"property"),t[t.length-1]=y,o<=w+O))throw i},onObjectEnd:(y,w)=>{if(o<=y)throw i;n=void 0,t.pop()},onArrayBegin:(y,w)=>{if(o<=y)throw i;n=void 0,t.push(0)},onArrayEnd:(y,w)=>{if(o<=y)throw i;n=void 0,t.pop()},onLiteralValue:(y,w,O)=>{if(o<w||(P(y,w,O,k(y)),o<=w+O))throw i},onSeparator:(y,w,O)=>{if(o<=w)throw i;if(y===":"&&n&&n.type==="property")n.colonOffset=w,l=!1,n=void 0;else if(y===","){const H=t[t.length-1];typeof H=="number"?t[t.length-1]=H+1:(l=!0,t[t.length-1]=""),n=void 0}}})}catch(y){if(y!==i)throw y}return{path:t,previousNode:n,isAtPropertyKey:l,matches:y=>{let w=0;for(let O=0;w<y.length&&O<t.length;O++)if(y[w]===t[O]||y[w]==="*")w++;else if(y[w]!=="**")return!1;return w===y.length}}}e.$Vm=N;function g(s,o=[],t=j.DEFAULT){let i=null,n=[];const r=[];function l(y){Array.isArray(n)?n.push(y):i!==null&&(n[i]=y)}return I(s,{onObjectBegin:()=>{const y={};l(y),r.push(n),n=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const y=[];l(y),r.push(n),n=y,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:l,onError:(y,w,O)=>{o.push({error:y,offset:w,length:O})}},t),n[0]}e.$Wm=g;function d(s,o=[],t=j.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function r(y){return i.children.push(y),y}I(s,{onObjectBegin:y=>{i=r({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,w,O)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:w,length:O,parent:i})},onObjectEnd:(y,w)=>{i.length=y+w-i.offset,i=i.parent,n(y+w)},onArrayBegin:(y,w)=>{i=r({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,w)=>{i.length=y+w-i.offset,i=i.parent,n(y+w)},onLiteralValue:(y,w,O)=>{r({type:k(y),offset:w,length:O,parent:i,value:y}),n(w+O)},onSeparator:(y,w,O)=>{i.type==="property"&&(y===":"?i.colonOffset=w:y===","&&n(w))},onError:(y,w,O)=>{o.push({error:y,offset:w,length:O})}},t);const P=i.children[0];return P&&delete P.parent,P}e.$Xm=d;function E(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$Ym=E;function v(s){if(!s.parent||!s.parent.children)return[];const o=v(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$Zm=v;function $(s){switch(s.type){case"array":return s.children.map($);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=$(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$1m=$;function h(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$2m=h;function f(s,o,t=!1){if(h(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=f(i[n],o,t);if(r)return r}return s}}e.$3m=f;function I(s,o,t=j.DEFAULT){const i=D(s,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Q){return Q?K=>Q(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(o.onObjectBegin),P=r(o.onObjectProperty),y=n(o.onObjectEnd),w=n(o.onArrayBegin),O=n(o.onArrayEnd),H=r(o.onLiteralValue),_=r(o.onSeparator),x=n(o.onComment),ue=r(o.onError),te=t&&t.disallowComments,ae=t&&t.allowTrailingComma;function le(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Q){case 12:case 13:te?ie(10):x();break;case 16:ie(1);break;case 15:case 14:break;default:return Q}}}function ie(Q,K=[],M=[]){if(ue(Q),K.length+M.length>0){let z=i.getToken();for(;z!==17;){if(K.indexOf(z)!==-1){le();break}else if(M.indexOf(z)!==-1)break;z=le()}}}function q(Q){const K=i.getTokenValue();return Q?H(K):P(K),le(),!0}function J(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(ie(2),Q=0)}catch{ie(2)}H(Q);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return le(),!0}function T(){return i.getToken()!==10?(ie(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(_(":"),le(),X()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function U(){l(),le();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||ie(4,[],[]),_(","),le(),i.getToken()===2&&ae)break}else Q&&ie(6,[],[]);T()||ie(4,[],[2,5]),Q=!0}return y(),i.getToken()!==2?ie(7,[2],[]):le(),!0}function B(){w(),le();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||ie(4,[],[]),_(","),le(),i.getToken()===4&&ae)break}else Q&&ie(6,[],[]);X()||ie(4,[],[4,5]),Q=!0}return O(),i.getToken()!==4?ie(8,[4],[]):le(),!0}function X(){switch(i.getToken()){case 3:return B();case 1:return U();case 10:return q(!0);default:return J()}}return le(),i.getToken()===17?t.allowEmptyContent?!0:(ie(4,[],[]),!1):X()?(i.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$4m=I;function p(s,o){const t=D(s),i=[];let n,r=0,l;do switch(l=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==l&&i.push(s.substring(r,l)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$5m=p;function k(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=k}),define(ne[72],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function L(b,u,c){return Math.min(Math.max(b,u),c)}e.$Ol=L;function R(b,u){return(u+b%u)%u}e.rot=R;class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=A;class j{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=j;class D{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=D}),function(){function G(A){const j=[];typeof A=="number"&&j.push("code/timeOrigin",A);function D(u){j.push(u,Date.now())}function b(){const u=[];for(let c=0;c<j.length;c+=2)u.push({name:j[c],startTime:j[c+1]});return u}return{mark:D,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const D of performance.getEntriesByType("mark"))j.push({name:D.name,startTime:Math.round(A+D.startTime)});return j}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function L(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=L(R))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var R in L)(typeof exports=="object"?exports:G)[R]=L[R]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function L(R){if(e[R])return e[R].exports;var A=e[R]={i:R,l:!1,exports:{}};return G[R].call(A.exports,A,A.exports,L),A.l=!0,A.exports}return L.m=G,L.c=e,L.d=function(R,A,j){L.o(R,A)||Object.defineProperty(R,A,{enumerable:!0,get:j})},L.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},L.t=function(R,A){if(1&A&&(R=L(R)),8&A||4&A&&typeof R=="object"&&R&&R.__esModule)return R;var j=Object.create(null);if(L.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:R}),2&A&&typeof R!="string")for(var D in R)L.d(j,D,function(b){return R[b]}.bind(null,D));return j},L.n=function(R){var A=R&&R.__esModule?function(){return R.default}:function(){return R};return L.d(A,"a",A),A},L.o=function(R,A){return Object.prototype.hasOwnProperty.call(R,A)},L.p="",L(L.s=0)}([function(G,e,L){(function(R){var A;e=G.exports=M,A=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],u=e.src=[],c=0,S=c++;u[S]="0|[1-9]\\d*";var N=c++;u[N]="[0-9]+";var g=c++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;u[d]="("+u[S]+")\\.("+u[S]+")\\.("+u[S]+")";var E=c++;u[E]="("+u[N]+")\\.("+u[N]+")\\.("+u[N]+")";var v=c++;u[v]="(?:"+u[S]+"|"+u[g]+")";var $=c++;u[$]="(?:"+u[N]+"|"+u[g]+")";var h=c++;u[h]="(?:-("+u[v]+"(?:\\."+u[v]+")*))";var f=c++;u[f]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var I=c++;u[I]="[0-9A-Za-z-]+";var p=c++;u[p]="(?:\\+("+u[I]+"(?:\\."+u[I]+")*))";var k=c++,s="v?"+u[d]+u[h]+"?"+u[p]+"?";u[k]="^"+s+"$";var o="[v=\\s]*"+u[E]+u[f]+"?"+u[p]+"?",t=c++;u[t]="^"+o+"$";var i=c++;u[i]="((?:<|>)?=?)";var n=c++;u[n]=u[N]+"|x|X|\\*";var r=c++;u[r]=u[S]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var P=c++;u[P]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var y=c++;u[y]="^"+u[i]+"\\s*"+u[l]+"$";var w=c++;u[w]="^"+u[i]+"\\s*"+u[P]+"$";var O=c++;u[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=c++;u[H]="(?:~>?)";var _=c++;u[_]="(\\s*)"+u[H]+"\\s+",b[_]=new RegExp(u[_],"g");var x=c++;u[x]="^"+u[H]+u[l]+"$";var ue=c++;u[ue]="^"+u[H]+u[P]+"$";var te=c++;u[te]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[te]+"\\s+",b[ae]=new RegExp(u[ae],"g");var le=c++;u[le]="^"+u[te]+u[l]+"$";var ie=c++;u[ie]="^"+u[te]+u[P]+"$";var q=c++;u[q]="^"+u[i]+"\\s*("+o+")$|^$";var J=c++;u[J]="^"+u[i]+"\\s*("+s+")$|^$";var T=c++;u[T]="(\\s*)"+u[i]+"\\s*("+o+"|"+u[l]+")",b[T]=new RegExp(u[T],"g");var U=c++;u[U]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var B=c++;u[B]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var X=c++;u[X]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)A(Q,u[Q]),b[Q]||(b[Q]=new RegExp(u[Q]));function K(V,Y){if(V instanceof M)return V;if(typeof V!="string"||V.length>j||!(Y?b[t]:b[k]).test(V))return null;try{return new M(V,Y)}catch{return null}}function M(V,Y){if(V instanceof M){if(V.loose===Y)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof M))return new M(V,Y);A("SemVer",V,Y),this.loose=Y;var ee=V.trim().match(Y?b[t]:b[k]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<D)return ye}return $e}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=K,e.valid=function(V,Y){var ee=K(V,Y);return ee?ee.version:null},e.clean=function(V,Y){var ee=K(V.trim().replace(/^[=v]+/,""),Y);return ee?ee.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(V){return A("SemVer.compare",this.version,this.loose,V),V instanceof M||(V=new M(V,this.loose)),this.compareMain(V)||this.comparePre(V)},M.prototype.compareMain=function(V){return V instanceof M||(V=new M(V,this.loose)),a(this.major,V.major)||a(this.minor,V.minor)||a(this.patch,V.patch)},M.prototype.comparePre=function(V){if(V instanceof M||(V=new M(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Y=0;do{var ee=this.prerelease[Y],$e=V.prerelease[Y];if(A("prerelease compare",Y,ee,$e),ee===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ee===void 0)return-1;if(ee!==$e)return a(ee,$e)}while(++Y)},M.prototype.inc=function(V,Y){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Y,ee,$e){typeof ee=="string"&&($e=ee,ee=void 0);try{return new M(V,ee).inc(Y,$e).version}catch{return null}},e.diff=function(V,Y){if(Z(V,Y))return null;var ee=K(V),$e=K(Y);if(ee.prerelease.length||$e.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var z=/^[0-9]+$/;function a(V,Y){var ee=z.test(V),$e=z.test(Y);return ee&&$e&&(V=+V,Y=+Y),ee&&!$e?-1:$e&&!ee?1:V<Y?-1:V>Y?1:0}function m(V,Y,ee){return new M(V,ee).compare(new M(Y,ee))}function F(V,Y,ee){return m(V,Y,ee)>0}function C(V,Y,ee){return m(V,Y,ee)<0}function Z(V,Y,ee){return m(V,Y,ee)===0}function W(V,Y,ee){return m(V,Y,ee)!==0}function ce(V,Y,ee){return m(V,Y,ee)>=0}function oe(V,Y,ee){return m(V,Y,ee)<=0}function me(V,Y,ee,$e){var ye;switch(Y){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=Z(V,ee,$e);break;case"!=":ye=W(V,ee,$e);break;case">":ye=F(V,ee,$e);break;case">=":ye=ce(V,ee,$e);break;case"<":ye=C(V,ee,$e);break;case"<=":ye=oe(V,ee,$e);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(V,Y){if(V instanceof de){if(V.loose===Y)return V;V=V.value}if(!(this instanceof de))return new de(V,Y);A("comparator",V,Y),this.loose=Y,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(V,Y){return a(Y,V)},e.major=function(V,Y){return new M(V,Y).major},e.minor=function(V,Y){return new M(V,Y).minor},e.patch=function(V,Y){return new M(V,Y).patch},e.compare=m,e.compareLoose=function(V,Y){return m(V,Y,!0)},e.rcompare=function(V,Y,ee){return m(Y,V,ee)},e.sort=function(V,Y){return V.sort(function(ee,$e){return e.compare(ee,$e,Y)})},e.rsort=function(V,Y){return V.sort(function(ee,$e){return e.rcompare(ee,$e,Y)})},e.gt=F,e.lt=C,e.eq=Z,e.neq=W,e.gte=ce,e.lte=oe,e.cmp=me,e.Comparator=de;var ge={};function fe(V,Y){if(V instanceof fe)return V.loose===Y?V:new fe(V.raw,Y);if(V instanceof de)return new fe(V.value,Y);if(!(this instanceof fe))return new fe(V,Y);if(this.loose=Y,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Y,ee,$e,ye,Ae,Se,Le,Ie,De,Ue,Ne,Re){return((Y=he(ee)?"":he($e)?">="+ee+".0.0":he(ye)?">="+ee+"."+$e+".0":">="+Y)+" "+(Le=he(Ie)?"":he(De)?"<"+(+Ie+1)+".0.0":he(Ue)?"<"+Ie+"."+(+De+1)+".0":Ne?"<="+Ie+"."+De+"."+Ue+"-"+Ne:"<="+Le)).trim()}function be(V,Y){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(Y))return!1;if(Y.prerelease.length){for(ee=0;ee<V.length;ee++)if(A(V[ee].semver),V[ee].semver!==ge&&V[ee].semver.prerelease.length>0){var $e=V[ee].semver;if($e.major===Y.major&&$e.minor===Y.minor&&$e.patch===Y.patch)return!0}return!1}return!0}function ke(V,Y,ee){try{Y=new fe(Y,ee)}catch{return!1}return Y.test(V)}function Me(V,Y,ee,$e){var ye,Ae,Se,Le,Ie;switch(V=new M(V,$e),Y=new fe(Y,$e),ee){case">":ye=F,Ae=oe,Se=C,Le=">",Ie=">=";break;case"<":ye=C,Ae=ce,Se=F,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(V,Y,$e))return!1;for(var De=0;De<Y.set.length;++De){var Ue=Y.set[De],Ne=null,Re=null;if(Ue.forEach(function(ze){ze.semver===ge&&(ze=new de(">=0.0.0")),Ne=Ne||ze,Re=Re||ze,ye(ze.semver,Ne.semver,$e)?Ne=ze:Se(ze.semver,Re.semver,$e)&&(Re=ze)}),Ne.operator===Le||Ne.operator===Ie||(!Re.operator||Re.operator===Le)&&Ae(V,Re.semver)||Re.operator===Ie&&Se(V,Re.semver))return!1}return!0}de.prototype.parse=function(V){var Y=this.loose?b[q]:b[J],ee=V.match(Y);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new M(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return A("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new M(V,this.loose)),me(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Y){if(!(V instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,Y),ke(this.value,ee,Y);if(V.operator==="")return ee=new fe(this.value,Y),ke(V.semver,ee,Y);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ae=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=me(this.semver,"<",V.semver,Y)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=me(this.semver,">",V.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||Ae&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Y=this.loose;V=V.trim(),A("range",V,Y);var ee=Y?b[B]:b[U];V=V.replace(ee,we),A("hyphen replace",V),V=V.replace(b[T],"$1$2$3"),A("comparator trim",V,b[T]),V=(V=(V=V.replace(b[_],"$1~")).replace(b[ae],"$1^")).split(/\s+/).join(" ");var $e=Y?b[q]:b[J],ye=V.split(" ").map(function(Ae){return function(Se,Le){return A("comp",Se),Se=function(Ie,De){return Ie.trim().split(/\s+/).map(function(Ue){return function(Ne,Re){A("caret",Ne,Re);var ze=Re?b[ie]:b[le];return Ne.replace(ze,function(je,ve,Ee,Pe,Oe){var Fe;return A("caret",Ne,je,ve,Ee,Pe,Oe),he(ve)?Fe="":he(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Fe=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Oe?(A("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Oe+" <"+(+ve+1)+".0.0"):(A("no pr"),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),A("caret return",Fe),Fe})}(Ue,De)}).join(" ")}(Se,Le),A("caret",Se),Se=function(Ie,De){return Ie.trim().split(/\s+/).map(function(Ue){return function(Ne,Re){var ze=Re?b[ue]:b[x];return Ne.replace(ze,function(je,ve,Ee,Pe,Oe){var Fe;return A("tilde",Ne,je,ve,Ee,Pe,Oe),he(ve)?Fe="":he(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Fe=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Oe?(A("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Fe=">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+(+Ee+1)+".0"):Fe=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",A("tilde return",Fe),Fe})}(Ue,De)}).join(" ")}(Se,Le),A("tildes",Se),Se=function(Ie,De){return A("replaceXRanges",Ie,De),Ie.split(/\s+/).map(function(Ue){return function(Ne,Re){Ne=Ne.trim();var ze=Re?b[w]:b[y];return Ne.replace(ze,function(je,ve,Ee,Pe,Oe,Fe){A("xRange",Ne,je,ve,Ee,Pe,Oe,Fe);var qe=he(Ee),Ce=qe||he(Pe),Te=Ce||he(Oe);return ve==="="&&Te&&(ve=""),qe?je=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ce&&(Pe=0),Te&&(Oe=0),ve===">"?(ve=">=",Ce?(Ee=+Ee+1,Pe=0,Oe=0):Te&&(Pe=+Pe+1,Oe=0)):ve==="<="&&(ve="<",Ce?Ee=+Ee+1:Pe=+Pe+1),je=ve+Ee+"."+Pe+"."+Oe):Ce?je=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(je=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),A("xRange return",je),je})}(Ue,De)}).join(" ")}(Se,Le),A("xrange",Se),Se=function(Ie,De){return A("replaceStars",Ie,De),Ie.trim().replace(b[X],"")}(Se,Le),A("stars",Se),Se}(Ae,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Ae){return!!Ae.match($e)})),ye=ye.map(function(Ae){return new de(Ae,Y)})},fe.prototype.intersects=function(V,Y){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function($e){return V.set.some(function(ye){return ye.every(function(Ae){return $e.intersects(Ae,Y)})})})})},e.toComparators=function(V,Y){return new fe(V,Y).set.map(function(ee){return ee.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new M(V,this.loose));for(var Y=0;Y<this.set.length;Y++)if(be(this.set[Y],V))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(V,Y,ee){var $e=null,ye=null;try{var Ae=new fe(Y,ee)}catch{return null}return V.forEach(function(Se){Ae.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new M($e=Se,ee)))}),$e},e.minSatisfying=function(V,Y,ee){var $e=null,ye=null;try{var Ae=new fe(Y,ee)}catch{return null}return V.forEach(function(Se){Ae.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new M($e=Se,ee)))}),$e},e.validRange=function(V,Y){try{return new fe(V,Y).range||"*"}catch{return null}},e.ltr=function(V,Y,ee){return Me(V,Y,"<",ee)},e.gtr=function(V,Y,ee){return Me(V,Y,">",ee)},e.outside=Me,e.prerelease=function(V,Y){var ee=K(V,Y);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,Y,ee){return V=new fe(V,ee),Y=new fe(Y,ee),V.intersects(Y)},e.coerce=function(V){if(V instanceof M)return V;if(typeof V!="string")return null;var Y=V.match(b[O]);return Y==null?null:K((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,L(1))},function(G,e){var L,R,A=G.exports={};function j(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function b($){if(L===setTimeout)return setTimeout($,0);if((L===j||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:j}catch{L=j}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var u,c=[],S=!1,N=-1;function g(){S&&u&&(S=!1,u.length?c=u.concat(c):N=-1,c.length&&d())}function d(){if(!S){var $=b(g);S=!0;for(var h=c.length;h;){for(u=c,c=[];++N<h;)u&&u[N].run();N=-1,h=c.length}u=null,S=!1,function(f){if(R===clearTimeout)return clearTimeout(f);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(f);try{R(f)}catch{try{return R.call(null,f)}catch{return R.call(this,f)}}}($)}}function E($,h){this.fun=$,this.array=h}function v(){}A.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];c.push(new E($,h)),c.length!==1||S||b(d)},E.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=v,A.addListener=v,A.once=v,A.off=v,A.removeListener=v,A.removeAllListeners=v,A.emit=v,A.prependListener=v,A.prependOnceListener=v,A.listeners=function($){return[]},A.binding=function($){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function($){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(G,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class R{constructor(b,u,c){this.level=b,this.key=u,this.value=c,this.forward=[]}}const A=void 0;class j{constructor(b,u=2**16){this.comparator=b,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new R(this.c,A,A)}get size(){return this.f}clear(){this.e=new R(this.c,A,A),this.f=0}has(b){return!!j.g(this,b,this.comparator)}get(b){return j.g(this,b,this.comparator)?.value}set(b,u){return j.h(this,b,u,this.comparator)&&(this.f+=1),this}delete(b){const u=j.k(this,b,this.comparator);return u&&(this.f-=1),u}forEach(b,u){let c=this.e.forward[0];for(;c;)b.call(u,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",u=this.e.forward[0];for(;u;)b+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return b}static g(b,u,c){let S=b.e;for(let N=b.d-1;N>=0;N--)for(;S.forward[N]&&c(S.forward[N].key,u)<0;)S=S.forward[N];if(S=S.forward[0],S&&c(S.key,u)===0)return S}static h(b,u,c,S){const N=[];let g=b.e;for(let d=b.d-1;d>=0;d--){for(;g.forward[d]&&S(g.forward[d].key,u)<0;)g=g.forward[d];N[d]=g}if(g=g.forward[0],g&&S(g.key,u)===0)return g.value=c,!1;{const d=j.j(b);if(d>b.d){for(let E=b.d;E<d;E++)N[E]=b.e;b.d=d}g=new R(d,u,c);for(let E=0;E<d;E++)g.forward[E]=N[E].forward[E],N[E].forward[E]=g;return!0}}static j(b,u=.5){let c=1;for(;Math.random()<u&&c<b.c;)c+=1;return c}static k(b,u,c){const S=[];let N=b.e;for(let g=b.d-1;g>=0;g--){for(;N.forward[g]&&c(N.forward[g].key,u)<0;)N=N.forward[g];S[g]=N}if(N=N.forward[0],!N||c(N.key,u)!==0)return!1;for(let g=0;g<b.d&&S[g].forward[g]===N;g++)S[g].forward[g]=N.forward[g];for(;b.d>0&&b.e.forward[b.d-1]===A;)b.d-=1;return!0}}e.$zr=j}),define(ne[45],re([0,1,9,2]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function A(p){const k=p;return k?typeof k.read=="function":!1}e.$Yd=A;function j(p){const k=p;return k?[k.on,k.pause,k.resume,k.destroy].every(s=>typeof s=="function"):!1}e.$Zd=j;function D(p){const k=p;return k?j(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$1d=D;function b(p,k){return new u(p,k)}e.$2d=b;class u{constructor(k,s){this.e=k,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(s=>s(k))}h(k){this.c.error.length===0?(0,L.$1)(k):this.c.error.slice(0).forEach(s=>s(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,s){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(k,s){if(this.a.destroyed)return;let o;switch(k){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,k){const s=[];let o;for(;(o=p.read())!==null;)s.push(o);return k(s)}e.$3d=c;function S(p,k,s){const o=[];let t;for(;(t=p.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?k(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return p.read()}}}e.$4d=S;function N(p,k){return new Promise((s,o)=>{const t=[];g(p,{onData:i=>{k&&t.push(i)},onError:i=>{k?o(i):s(void 0)},onEnd:()=>{s(k?k(t):void 0)}})})}e.$5d=N;function g(p,k,s){p.on("error",o=>{s?.isCancellationRequested||k.onError(o)}),p.on("end",()=>{s?.isCancellationRequested||k.onEnd()}),p.on("data",o=>{s?.isCancellationRequested||k.onData(o)})}e.$6d=g;function d(p,k){return new Promise((s,o)=>{const t=new R.$Rc,i=[],n=P=>{if(i.push(P),i.length>k)return t.dispose(),p.pause(),s({stream:p,buffer:i,ended:!1})},r=P=>(t.dispose(),o(P)),l=()=>(t.dispose(),s({stream:p,buffer:i,ended:!0}));t.add((0,R.$Qc)(()=>p.removeListener("error",r))),p.on("error",r),t.add((0,R.$Qc)(()=>p.removeListener("end",l))),p.on("end",l),t.add((0,R.$Qc)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$7d=d;function E(p,k){const s=b(k);return s.end(p),s}e.$8d=E;function v(){const p=b(()=>{throw new Error("not supported")});return p.end(),p}e.$9d=v;function $(p){let k=!1;return{read:()=>k?null:(k=!0,p)}}e.$0d=$;function h(p,k,s){const o=b(s);return g(p,{onData:t=>o.write(k.data(t)),onError:t=>o.error(k.error?k.error(t):t),onEnd:()=>o.end()}),o}e.$$d=h;function f(p,k,s){let o=!1;return{read:()=>{const t=k.read();return o?t:(o=!0,t!==null?s([p,t]):p)}}}e.$_d=f;function I(p,k,s){let o=!1;const t=b(s);return g(k,{onData:i=>o?t.write(i):(o=!0,t.write(s([p,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(p)),t.end()}}),t}e.$ae=I}),define(ne[14],re([0,1,164,45]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const A=typeof Buffer<"u",j=new L.$V(()=>new Uint8Array(256));let D,b;class u{static alloc(O){return A?new u(Buffer.allocUnsafe(O)):new u(new Uint8Array(O))}static wrap(O){return A&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new u(O)}static fromString(O,H){return!(H?.dontUseNodeBuffer||!1)&&A?new u(Buffer.from(O)):(D||(D=new TextEncoder),new u(D.encode(O)))}static fromByteArray(O){const H=u.alloc(O.length);for(let _=0,x=O.length;_<x;_++)H.buffer[_]=O[_];return H}static concat(O,H){if(typeof H>"u"){H=0;for(let ue=0,te=O.length;ue<te;ue++)H+=O[ue].byteLength}const _=u.alloc(H);let x=0;for(let ue=0,te=O.length;ue<te;ue++){const ae=O[ue];_.set(ae,x),x+=ae.byteLength}return _}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=u.alloc(this.byteLength);return O.set(this),O}toString(){return A?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(O,H){return new u(this.buffer.subarray(O,H))}set(O,H){if(O instanceof u)this.buffer.set(O.buffer,H);else if(O instanceof Uint8Array)this.buffer.set(O,H);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),H);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return g(this.buffer,O)}writeUInt32BE(O,H){d(this.buffer,O,H)}readUInt32LE(O){return E(this.buffer,O)}writeUInt32LE(O,H){v(this.buffer,O,H)}readUInt8(O){return $(this.buffer,O)}writeUInt8(O,H){h(this.buffer,O,H)}indexOf(O,H=0){return c(this.buffer,O instanceof u?O.buffer:O,H)}}e.$be=u;function c(w,O,H=0){const _=O.byteLength,x=w.byteLength;if(_===0)return 0;if(_===1)return w.indexOf(O[0]);if(_>x-H)return-1;const ue=j.value;ue.fill(O.length);for(let ie=0;ie<O.length;ie++)ue[O[ie]]=O.length-ie-1;let te=H+O.length-1,ae=te,le=-1;for(;te<x;)if(w[te]===O[ae]){if(ae===0){le=te;break}te--,ae--}else te+=Math.max(O.length-ae,ue[w[te]]),ae=O.length-1;return le}e.$ce=c;function S(w,O){return w[O+0]<<0>>>0|w[O+1]<<8>>>0}e.$de=S;function N(w,O,H){w[H+0]=O&255,O=O>>>8,w[H+1]=O&255}e.$ee=N;function g(w,O){return w[O]*2**24+w[O+1]*2**16+w[O+2]*2**8+w[O+3]}e.$fe=g;function d(w,O,H){w[H+3]=O,O=O>>>8,w[H+2]=O,O=O>>>8,w[H+1]=O,O=O>>>8,w[H]=O}e.$ge=d;function E(w,O){return w[O+0]<<0>>>0|w[O+1]<<8>>>0|w[O+2]<<16>>>0|w[O+3]<<24>>>0}e.$he=E;function v(w,O,H){w[H+0]=O&255,O=O>>>8,w[H+1]=O&255,O=O>>>8,w[H+2]=O&255,O=O>>>8,w[H+3]=O&255}e.$ie=v;function $(w,O){return w[O]}e.$je=$;function h(w,O,H){w[H]=O}e.$ke=h;function f(w){return R.$3d(w,O=>u.concat(O))}e.$le=f;function I(w){return R.$0d(w)}e.$me=I;function p(w){return R.$5d(w,O=>u.concat(O))}e.$ne=p;async function k(w){return w.ended?u.concat(w.buffer):u.concat([...w.buffer,await p(w.stream)])}e.$oe=k;function s(w){return R.$8d(w,O=>u.concat(O))}e.$pe=s;function o(w){return R.$$d(w,{data:O=>typeof O=="string"?u.fromString(O):u.wrap(O)},O=>u.concat(O))}e.$qe=o;function t(w){return R.$2d(O=>u.concat(O),w)}e.$re=t;function i(w,O){return R.$_d(w,O,H=>u.concat(H))}e.$se=i;function n(w,O){return R.$ae(w,O,H=>u.concat(H))}e.$te=n;function r(w){let O=0,H=0,_=0;const x=new Uint8Array(Math.floor(w.length/4*3)),ue=ae=>{switch(H){case 3:x[_++]=O|ae,H=0;break;case 2:x[_++]=O|ae>>>2,O=ae<<6,H=3;break;case 1:x[_++]=O|ae>>>4,O=ae<<4,H=2;break;default:O=ae<<2,H=1}};for(let ae=0;ae<w.length;ae++){const le=w.charCodeAt(ae);if(le>=65&&le<=90)ue(le-65);else if(le>=97&&le<=122)ue(le-97+26);else if(le>=48&&le<=57)ue(le-48+52);else if(le===43||le===45)ue(62);else if(le===47||le===95)ue(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${w[ae]}`)}}const te=_;for(;H>0;)ue(0);return u.wrap(x).slice(0,te)}e.$ue=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:w},O=!0,H=!1){const _=H?P:l;let x="";const ue=w.byteLength%3;let te=0;for(;te<w.byteLength-ue;te+=3){const ae=w[te+0],le=w[te+1],ie=w[te+2];x+=_[ae>>>2],x+=_[(ae<<4|le>>>4)&63],x+=_[(le<<2|ie>>>6)&63],x+=_[ie&63]}if(ue===1){const ae=w[te+0];x+=_[ae>>>2],x+=_[ae<<4&63],O&&(x+="==")}else if(ue===2){const ae=w[te+0],le=w[te+1];x+=_[ae>>>2],x+=_[(ae<<4|le>>>4)&63],x+=_[le<<2&63],O&&(x+="=")}return x}e.$ve=y}),define(ne[41],re([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function R(h){return A(h,0)}e.$Di=R;function A(h,f){switch(typeof h){case"object":return h===null?j(349,f):Array.isArray(h)?u(h,f):c(h,f);case"string":return b(h,f);case"boolean":return D(h,f);case"number":return j(h,f);case"undefined":return j(937,f);default:return j(617,f)}}e.$Ei=A;function j(h,f){return(f<<5)-f+h|0}e.$Fi=j;function D(h,f){return j(h?433:863,f)}function b(h,f){f=j(149417,f);for(let I=0,p=h.length;I<p;I++)f=j(h.charCodeAt(I),f);return f}e.$Gi=b;function u(h,f){return f=j(104579,f),h.reduce((I,p)=>A(p,I),f)}function c(h,f){return f=j(181387,f),Object.keys(h).sort().reduce((I,p)=>(I=b(p,I),A(h[p],I)),f)}class S{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=A(f,this.g),this.g}}e.$Hi=S;var N;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function g(h,f,I=32){const p=I-f,k=~((1<<p)-1);return(h<<f|(k&h)>>>p)>>>0}function d(h,f=0,I=h.byteLength,p=0){for(let k=0;k<I;k++)h[f+k]=p}function E(h,f,I="0"){for(;h.length<f;)h=I+h;return h}function v(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(I=>I.toString(16).padStart(2,"0")).join(""):E((h>>>0).toString(16),f/4)}e.$Ii=v;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const I=f.length;if(I===0)return;const p=this.p;let k=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=f.charCodeAt(0),t=0);;){let i=o;if(L.$6e(o))if(t+1<I){const n=f.charCodeAt(t+1);L.$7e(n)?(t++,i=L.$8e(o,n)):i=65533}else{s=o;break}else L.$7e(o)&&(i=65533);if(k=this.w(p,k,i),t++,t<I)o=f.charCodeAt(t);else break}this.r=k,this.u=s}w(f,I,p){return p<128?f[I++]=p:p<2048?(f[I++]=192|(p&1984)>>>6,f[I++]=128|(p&63)>>>0):p<65536?(f[I++]=224|(p&61440)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0):(f[I++]=240|(p&1835008)>>>18,f[I++]=128|(p&258048)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=$.g,I=this.q;for(let l=0;l<64;l+=4)f.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,g(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let p=this.h,k=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let l=0;l<80;l++)l<20?(i=k&s|~k&o,n=1518500249):l<40?(i=k^s^o,n=1859775393):l<60?(i=k&s|k&o|s&o,n=2400959708):(i=k^s^o,n=3395469782),r=g(p,5)+i+t+n+f.getUint32(l*4,!1)&4294967295,t=o,o=s,s=g(k,30),k=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+k&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Ji=$}),define(ne[54],re([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(R||(R={})),function(A){const j="error",D="warning",b="warn",u="info",c="ignore";function S(g){return g?L.$2e(j,g)?A.Error:L.$2e(D,g)||L.$2e(b,g)?A.Warning:L.$2e(u,g)?A.Info:A.Ignore:A.Ignore}A.fromValue=S;function N(g){switch(g){case A.Error:return j;case A.Warning:return D;case A.Info:return u;default:return c}}A.toString=N}(R||(R={})),e.default=R}),define(ne[30],re([0,1,3]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function R(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([I,p])=>{f[I]=p&&typeof p=="object"?R(p):p}),f}e.$7m=R;function A(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const I=f.shift();Object.freeze(I);for(const p in I)if(j.call(I,p)){const k=I[p];typeof k=="object"&&!Object.isFrozen(k)&&!(0,L.$Bf)(k)&&f.push(k)}}return h}e.$8m=A;const j=Object.prototype.hasOwnProperty;function D(h,f){return b(h,f,new Set)}e.$9m=D;function b(h,f,I){if((0,L.$Hf)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const k=[];for(const s of h)k.push(b(s,f,I));return k}if((0,L.$Af)(h)){if(I.has(h))throw new Error("Cannot clone recursive data-structure");I.add(h);const k={};for(const s in h)j.call(h,s)&&(k[s]=b(h[s],f,I));return I.delete(h),k}return h}function u(h,f,I=!0){return(0,L.$Af)(h)?((0,L.$Af)(f)&&Object.keys(f).forEach(p=>{p in h?I&&((0,L.$Af)(h[p])&&(0,L.$Af)(f[p])?u(h[p],f[p],I):h[p]=f[p]):h[p]=f[p]}),h):f}e.$0m=u;function c(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let I,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(I=0;I<h.length;I++)if(!c(h[I],f[I]))return!1}else{const k=[];for(p in h)k.push(p);k.sort();const s=[];for(p in f)s.push(p);if(s.sort(),!c(k,s))return!1;for(I=0;I<k.length;I++)if(!c(h[k[I]],f[k[I]]))return!1}return!0}e.$$m=c;function S(h){const f=new Set;return JSON.stringify(h,(I,p)=>{if((0,L.$Af)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.$_m=S;function N(h,f){const I=Object.create(null);return!h||!f||Object.keys(f).forEach(k=>{const s=h[k],o=f[k];c(s,o)||(I[k]=o)}),I}e.$an=N;function g(h,f){const I=f.toLowerCase(),p=Object.keys(h).find(k=>k.toLowerCase()===I);return p?h[p]:h[f]}e.$bn=g;function d(h,f){const I=Object.create(null);for(const[p,k]of Object.entries(h))f(p,k)&&(I[p]=k);return I}e.$cn=d;function E(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$dn=E;function v(h){const f=[];for(const I of E(h))typeof h[I]=="function"&&f.push(I);return f}e.$en=v;function $(h,f){const I=k=>function(){const s=Array.prototype.slice.call(arguments,0);return f(k,s)},p={};for(const k of h)p[k]=I(k);return p}e.$fn=$}),define(ne[28],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(A){return L.test(A)}e.$dg=R,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(b){for(let u=0;u<b.length;u++)b[u]=Math.floor(Math.random()*256);return b};const j=new Uint8Array(16),D=[];for(let b=0;b<256;b++)D.push(b.toString(16).padStart(2,"0"));return function(){A(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let u=0,c="";return c+=D[j[u++]],c+=D[j[u++]],c+=D[j[u++]],c+=D[j[u++]],c+="-",c+=D[j[u++]],c+=D[j[u++]],c+="-",c+=D[j[u++]],c+=D[j[u++]],c+="-",c+=D[j[u++]],c+=D[j[u++]],c+="-",c+=D[j[u++]],c+=D[j[u++]],c+=D[j[u++]],c+=D[j[u++]],c+=D[j[u++]],c+=D[j[u++]],c}}()}),define(ne[74],re([0,1,33]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(D){const b=D.replace(/\-/g,":").toLowerCase();return!R.has(b)}function j(){const D=(0,L.networkInterfaces)();for(const b in D){const u=D[b];if(u){for(const{mac:c}of u)if(A(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Qm=j}),define(ne[75],re([7,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(ne[76],re([0,1,75]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const R=60,A=R*60,j=A*24,D=j*7,b=j*30,u=j*365;function c(N,g,d,E){typeof N!="number"&&(N=N.getTime());const v=Math.round((new Date().getTime()-N)/1e3);if(v<-30)return(0,L.localize)(0,null,c(new Date().getTime()+v*1e3,!1));if(!E&&v<30)return(0,L.localize)(1,null);let $;return v<R?($=v,g?$===1?d?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):d?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?d?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):d?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):v<A?($=Math.floor(v/R),g?$===1?d?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):d?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?d?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):d?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):v<j?($=Math.floor(v/A),g?$===1?d?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):d?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?d?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):d?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):v<D?($=Math.floor(v/j),g?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):v<b?($=Math.floor(v/D),g?$===1?d?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):d?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?d?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):d?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):v<u?($=Math.floor(v/b),g?$===1?d?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):d?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?d?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):d?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(v/u),g?$===1?d?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):d?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?d?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):d?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$dm=c;function S(N){return N.getFullYear()+"-"+String(N.getMonth()+1).padStart(2,"0")+"-"+String(N.getDate()).padStart(2,"0")+"T"+String(N.getHours()).padStart(2,"0")+":"+String(N.getMinutes()).padStart(2,"0")+":"+String(N.getSeconds()).padStart(2,"0")+"."+(N.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=S}),define(ne[77],re([7,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,77]),function(G,e,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function j(N,g){return g&&(N.stack||N.stacktrace)?A.localize(0,null,b(N),D(N.stack)||D(N.stacktrace)):b(N)}function D(N){return Array.isArray(N)?N.join(`
`):N}function b(N){return N.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${N.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof N.code=="string"&&typeof N.errno=="number"&&typeof N.syscall=="string"?A.localize(1,null,N.message):N.message||A.localize(2,null)}function u(N=null,g=!1){if(!N)return A.localize(3,null);if(Array.isArray(N)){const d=L.$Hb(N),E=u(d[0],g);return d.length>1?A.localize(4,null,E,d.length):E}if(R.$yf(N))return N;if(N.detail){const d=N.detail;if(d.error)return j(d.error,g);if(d.exception)return j(d.exception,g)}return N.stack?j(N,g):N.message?N.message:A.localize(5,null)}e.$Ai=u;function c(N){const g=N;return g instanceof Error&&Array.isArray(g.actions)}e.$Bi=c;function S(N,g){let d;return typeof N=="string"?d=new Error(N):d=N,d.actions=g,d}e.$Ci=S}),define(ne[78],re([7,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ne[79],re([0,1,78]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function R(A){switch(A){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$xp=R}),define(ne[55],re([0,1,13]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var R;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(R||(e.Source=R={}));var A;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function j(b,...u){const c=u.reduce((g,d)=>(g[d]=!0,g),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(g=>!c[g]).forEach(g=>{for(let d=0;d<S.length;d++)if(g.search(S[d])!==-1){delete b[g];break}})}e.$zl=j;function D(b){b&&(delete b.DEBUG,L.$k&&delete b.DYLD_LIBRARY_PATH,L.$l&&delete b.LD_PRELOAD)}e.$Al=D}),define(ne[80],re([0,1,11]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$1p=e.$Zp=e.$Yp=void 0;function R(c){const S=c;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.$Yp=R;function A(c){const S=[];let N;try{const g=JSON.parse(c.arguments),d=g[g.length-1];d&&d.__$stack&&(g.pop(),N=d.__$stack),S.push(...g)}catch{S.push("Unable to log remote console arguments",c.arguments)}return{args:S,stack:N}}e.$Zp=A;function j(c){if(typeof c!="string")return j(A(c).stack);const S=c;if(S){const N=D(S),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(N||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$1p=j;function D(c){if(!c)return c;const S=c.indexOf(`
`);return S===-1?c:c.substring(0,S)}function b(c,S){const{args:N,stack:g}=A(c),d=typeof N[0]=="string"&&N.length===1;let E=D(g);E&&(E=`(${E.trim()})`);let v=[];if(typeof N[0]=="string"?E&&d?v=[`%c[${S}] %c${N[0]} %c${E}`,u("blue"),u(""),u("grey")]:v=[`%c[${S}] %c${N[0]}`,u("blue"),u(""),...N.slice(1)]:v=[`%c[${S}]%`,u("blue"),...N],E&&!d&&v.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}e.log=b;function u(c){return`color: ${c}`}}),define(ne[46],re([0,1,14,11]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function A(u){return JSON.stringify(u,D)}e.$kh=A;function j(u){let c=JSON.parse(u);return c=b(c),c}e.$lh=j;function D(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function b(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return R.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$be||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let S=0;S<u.length;++S)u[S]=b(u[S],c+1);else for(const S in u)Object.hasOwnProperty.call(u,S)&&(u[S]=b(u[S],c+1))}return u}e.$mh=b}),define(ne[81],re([0,1,70,15,13,11]),function(G,e,L,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=void 0;class D{constructor(g,d,E){this.id=g,this.dependencies=d,this.callback=E}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,d,E)=>{typeof g!="string"&&(E=d,d=g,g=null),(typeof d!="object"||!Array.isArray(d))&&(E=d,d=null),this.c.push(new D(g,d,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const d=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!d)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(g){return new Promise((d,E)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const $=()=>{v.removeEventListener("load",h),v.removeEventListener("error",f)},h=I=>{$(),d(this.c.pop())},f=I=>{$(),E(I)};v.addEventListener("load",h),v.addEventListener("error",f),this.f&&(g=this.f.createScriptURL(g)),v.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(v)})}i(g){return new Promise((d,E)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),d(this.c.pop())}catch(v){E(v)}})}async j(g){try{const d=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,$=j.URI.parse(g).fsPath,h=d.readFileSync($).toString(),f=v.wrap(h.replace(/^#!.*/,""));return new E.Script(f).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function S(N,g,d){if(L.$T){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[N]&&(N=c[N]);const E=`${N}/${g}`;if(u.has(E))return u.get(E);let v;if(/^\w[\w\d+.-]*:\/\//.test(E))v=E;else{const I=`${d&&!A.$p?R.$_f:R.$$f}/${E}`;v=R.$cg.asBrowserUri(I).toString(!0)}const $=b.INSTANCE.load(v);return u.set(E,$),$}else return await new Promise((E,v)=>{G([N],E,v)})}e.$mC=S}),define(ne[82],re([0,1,33,47,28,74,13]),function(G,e,L,R,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=new class{c(g){return this.a||(this.a=R.$Vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,d=0;const E=(0,L.networkInterfaces)();for(const v in E){const $=E[v];if($)for(const{mac:h,internal:f}of $)f||(d+=1,this.c(h.toUpperCase())&&(g+=1))}this.b=d>0?g/d:0}return this.b}};let b;async function u(g){return b||(b=(async()=>await c(g)||A.$eg())()),b}e.$Sm=u;async function c(g){try{const d=await new Promise((v,$)=>{G(["crypto"],v,$)}),E=(0,j.$Qm)();return d.createHash("sha256").update(E,"utf8").digest("hex")}catch(d){g(d);return}}const S="Software\\Microsoft\\SQMClient";async function N(g){if(D.$j){const d=await new Promise((E,v)=>{G(["@vscode/windows-registry"],E,v)});try{return d.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(E){return g(E),""}}return""}e.$Tm=N}),define(ne[83],re([0,1,33,16,24]),function(G,e,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0;const j=/^\d+$/,D=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class N{constructor(k,s,o){this.exePath=k,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await A.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:k=!1}={}){const s=g({useAlternateBitness:p});if(!s)return null;const o=R.$jc(s,"PowerShell");if(!await A.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const l of await A.Promises.readdir(o)){let P=-1;if(k){const w=l.indexOf("-");if(w<0)continue;const O=l.substring(0,w);if(!j.test(O)||l.substring(w+1)!=="preview")continue;P=parseInt(O,10)}else{if(!j.test(l))continue;P=parseInt(l,10)}if(P<=t)continue;const y=R.$jc(o,l,"pwsh.exe");await A.SymlinkSupport.existsFile(y)&&(i=y,t=P)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=k?" Preview":"";return new N(i,`PowerShell${r}${n}`,!0)}async function E({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const k=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await A.SymlinkSupport.existsDirectory(k))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=p?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const t of await A.Promises.readdir(k))if(s.test(t)){const i=R.$jc(k,t,"pwsh.exe");return new N(i,o)}return null}function v(){const p=R.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new N(p,".NET Core PowerShell Global Tool")}function $(){const p=R.$jc(process.env.windir,c===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new N(p,"Windows PowerShell",!0)}async function*h(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await E(),p&&(yield p),p=v(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await E({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*f(){for await(const p of h())await p.exists()&&(yield p)}e.$xl=f;async function I(){for await(const p of f())return p;return null}e.$yl=I}),define(ne[56],re([0,1,16,13,35,55,3,24]),function(G,e,L,R,A,j,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function u(N=A.env){return N.comspec||"cmd.exe"}e.$Bl=u;function c(N){let g=[],d=!1;const E=function(v){if(d){g.push(v);return}(!N.send(v,h=>{if(h&&console.error(h),d=!1,g.length>0){const f=g.slice(0);g=[],f.forEach(I=>E(I))}})||R.$j)&&(d=!0)};return{send:E}}e.$Cl=c;var S;(function(N){async function g(d,E,v){if(L.$ic(d))return d;if(E===void 0&&(E=A.cwd()),L.$mc(d)!=="."||(v===void 0&&D.$yf(A.env.PATH)&&(v=A.env.PATH.split(L.$tc)),v===void 0||v.length===0))return L.$jc(E,d);async function h(f){if(await b.Promises.exists(f)){let I;try{I=await b.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(I=await b.Promises.lstat(f))}return I?!I.isDirectory():!1}return!1}for(const f of v){let I;if(L.$ic(f)?I=L.$jc(f,d):I=L.$jc(E,f,d),await h(I))return I;let p=I+".com";if(await h(p)||(p=I+".exe",await h(p)))return p}return L.$jc(E,d)}N.findExecutable=g})(S||(e.win32=S={}))}),define(ne[84],re([0,1,33,13,83,56]),function(G,e,L,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=void 0;async function D(N,g){return N===1?R.$j?S():j.$Bl(g):u(N,g)}e.$Dl=D;let b=null;function u(N,g){if(R.$l&&N===2||R.$k&&N===3)return"/bin/bash";if(!b){let d;if(R.$j)d="/bin/bash";else{if(d=g.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}b=d}return b}let c=null;async function S(){return c||(c=(await(0,A.$yl)()).exePath),c}});var pe=this&&this.__decorate||function(G,e,L,R){var A=arguments.length,j=A<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,L):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(G,e,L,R);else for(var b=G.length-1;b>=0;b--)(D=G[b])&&(j=(A<3?D(j):A>3?D(e,L,j):D(e,L))||j);return A>3&&j&&Object.defineProperty(e,L,j),j};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(G,e,L,R,A,j,D,b,u,c,S,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var d;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(d||(d={}));function E(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(v||(v={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(h||(h={}));function f(T){let U=0;for(let B=0;;B+=7){const X=T.read(1);if(U|=(X.buffer[0]&127)<<B,!(X.buffer[0]&128))return U}}const I=t(0);function p(T,U){if(U===0){T.write(I);return}let B=0;for(let Q=U;Q!==0;Q=Q>>>7)B++;const X=A.$be.alloc(B);for(let Q=0;U!==0;Q++)X.buffer[Q]=U&127,U=U>>>7,U>0&&(X.buffer[Q]|=128);T.write(X)}class k{constructor(U){this.b=U,this.a=0}read(U){const B=this.b.slice(this.a,this.a+U);return this.a+=B.byteLength,B}}e.$nh=k;class s{constructor(){this.a=[]}get buffer(){return A.$be.concat(this.a)}write(U){this.a.push(U)}}e.$oh=s;var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(o||(o={}));function t(T){const U=A.$be.alloc(1);return U.writeUInt8(T,0),U}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(T,U){if(typeof U>"u")T.write(i.Undefined);else if(typeof U=="string"){const B=A.$be.fromString(U);T.write(i.String),p(T,B.byteLength),T.write(B)}else if(n&&Buffer.isBuffer(U)){const B=A.$be.wrap(U);T.write(i.Buffer),p(T,B.byteLength),T.write(B)}else if(U instanceof A.$be)T.write(i.VSBuffer),p(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(i.Array),p(T,U.length);for(const B of U)r(T,B)}else if(typeof U=="number"&&(U|0)===U)T.write(i.Uint),p(T,U);else{const B=A.$be.fromString(JSON.stringify(U));T.write(i.Object),p(T,B.byteLength),T.write(B)}}e.$ph=r;function l(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read(f(T)).toString();case o.Buffer:return T.read(f(T)).buffer;case o.VSBuffer:return T.read(f(T));case o.Array:{const B=f(T),X=[];for(let Q=0;Q<B;Q++)X.push(l(T));return X}case o.Object:return JSON.parse(T.read(f(T)).toString());case o.Int:return f(T)}}e.$qh=l;class P{constructor(U,B,X=null,Q=1e3){this.h=U,this.j=B,this.k=X,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(U,B){this.b.set(U,B),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const B=this.o([U.type]);this.k?.logOutgoing(B,0,1,$(U.type));return}case 201:case 202:case 204:case 203:{const B=this.o([U.type,U.id],U.data);this.k?.logOutgoing(B,U.id,1,$(U.type),U.data);return}}}o(U,B=void 0){const X=new s;return r(X,U),r(X,B),this.p(X.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const B=new k(U),X=l(B),Q=l(B),K=X[0];switch(K){case 100:return this.k?.logIncoming(U.byteLength,X[1],1,`${E(K)}: ${X[2]}.${X[3]}`,Q),this.s({type:K,id:X[1],channelName:X[2],name:X[3],arg:Q});case 102:return this.k?.logIncoming(U.byteLength,X[1],1,`${E(K)}: ${X[2]}.${X[3]}`,Q),this.t({type:K,id:X[1],channelName:X[2],name:X[3],arg:Q});case 101:return this.k?.logIncoming(U.byteLength,X[1],1,`${E(K)}`),this.u({type:K,id:X[1]});case 103:return this.k?.logIncoming(U.byteLength,X[1],1,`${E(K)}`),this.u({type:K,id:X[1]})}}s(U){const B=this.b.get(U.channelName);if(!B){this.v(U);return}const X=new j.$Xd;let Q;try{Q=B.call(this.j,U.name,U.arg,X.token)}catch(z){Q=Promise.reject(z)}const K=U.id;Q.then(z=>{this.m({id:K,data:z,type:201})},z=>{z instanceof Error?this.m({id:K,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:K,data:z,type:203})}).finally(()=>{M.dispose(),this.d.delete(U.id)});const M=(0,c.$Qc)(()=>X.cancel());this.d.set(U.id,M)}t(U){const B=this.b.get(U.channelName);if(!B){this.v(U);return}const X=U.id,K=B.listen(this.j,U.name,U.arg)(M=>this.m({id:X,data:M,type:204}));this.d.set(U.id,K)}u(U){const B=this.d.get(U.id);B&&(B.dispose(),this.d.delete(U.id))}v(U){let B=this.g.get(U.channelName);B||(B=[],this.g.set(U.channelName,B));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:U,timeoutTimer:X})}w(U){const B=this.g.get(U);if(B){for(const X of B)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$rh=P;var y;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class w{constructor(U,B=null){this.l=U,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=B}getChannel(U){const B=this;return{call(X,Q,K){return B.a?Promise.reject(new b.$5):B.m(U,X,Q,K)},listen(X,Q){return B.a?u.Event.None:B.o(U,X,Q)}}}m(U,B,X,Q=j.CancellationToken.None){const K=this.g++,z={id:K,type:100,channelName:U,name:B,arg:X};if(Q.isCancellationRequested)return Promise.reject(new b.$5);let a;return new Promise((F,C)=>{if(Q.isCancellationRequested)return C(new b.$5);const Z=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(K),F(de.data);break;case 202:{this.f.delete(K);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,C(ge);break}case 203:this.f.delete(K),C(de.data);break}};this.f.set(K,me),this.p(z)};let W=null;this.b===h.Idle?Z():(W=(0,R.$Hg)(me=>this.u()),W.then(()=>{W=null,Z()}));const ce=()=>{W?(W.cancel(),W=null):this.p({id:K,type:101}),C(new b.$5)},oe=Q.onCancellationRequested(ce);a=(0,c.$Pc)((0,c.$Qc)(ce),oe),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(U,B,X){const Q=this.g++,M={id:Q,type:102,channelName:U,name:B,arg:X};let z=null;const a=new u.$Nd({onWillAddFirstListener:()=>{z=(0,R.$Hg)(F=>this.u()),z.then(()=>{z=null,this.d.add(a),this.p(M)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(a),this.p({id:Q,type:103}))}}),m=F=>a.fire(F.data);return this.f.set(Q,m),a.event}p(U){switch(U.type){case 100:case 102:{const B=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(B,U.id,0,`${E(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const B=this.q([U.type,U.id]);this.j?.logOutgoing(B,U.id,0,E(U.type));return}}}q(U,B=void 0){const X=new s;return r(X,U),r(X,B),this.r(X.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const B=new k(U),X=l(B),Q=l(B),K=X[0];switch(K){case 200:return this.j?.logIncoming(U.byteLength,0,0,$(K)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,X[1],0,$(K),Q),this.t({type:X[0],id:X[1],data:Q})}}t(U){if(U.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$sh=w,pe([D.$hh],w.prototype,"onDidInitializePromise",null);class O{get connections(){const U=[];return this.f.forEach(B=>U.push(B)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new u.$Nd,this.onDidAddConnection=this.g.event,this.h=new u.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Rc,this.j.add(U(({protocol:B,onDidClientDisconnect:X})=>{const Q=u.Event.once(B.onMessage);this.j.add(Q(K=>{const M=new k(K),z=l(M),a=new P(B,z),m=new w(B);this.a.forEach((C,Z)=>a.registerChannel(Z,C));const F={channelServer:a,channelClient:m,ctx:z};this.f.add(F),this.g.fire(F),this.j.add(X(()=>{a.dispose(),m.dispose(),this.f.delete(F),this.h.fire(F)}))}))}))}getChannel(U,B){const X=this;return{call(Q,K,M){let z;if((0,g.$Mf)(B)){const m=(0,L.$4b)(X.connections.filter(B));z=m?Promise.resolve(m):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,B))}else z=B.routeCall(X,Q,K);const a=z.then(m=>m.channelClient.getChannel(U));return _(a).call(Q,K,M)},listen(Q,K){if((0,g.$Mf)(B))return X.k(U,B,Q,K);const M=B.routeEvent(X,Q,K).then(z=>z.channelClient.getChannel(U));return _(M).listen(Q,K)}}}k(U,B,X,Q){const K=this;let M;const z=new u.$Nd({onWillAddFirstListener:()=>{M=new c.$Rc;const a=new u.$Td,m=new Map,F=Z=>{const ce=Z.channelClient.getChannel(U).listen(X,Q),oe=a.add(ce);m.set(Z,oe)},C=Z=>{const W=m.get(Z);W&&(W.dispose(),m.delete(Z))};K.connections.filter(B).forEach(F),u.Event.filter(K.onDidAddConnection,B)(F,void 0,M),K.onDidRemoveConnection(C,void 0,M),a.event(z.fire,z,M),M.add(a)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return z.event}registerChannel(U,B){this.a.set(U,B);for(const X of this.f)X.channelServer.registerChannel(U,B)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=O;class H{constructor(U,B,X=null){const Q=new s;r(Q,B),U.send(Q.buffer),this.a=new w(U,X),this.d=new P(U,B,X)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,B){this.d.registerChannel(U,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=H;function _(T){return{call(U,B,X){return T.then(Q=>Q.call(U,B,X))},listen(U,B){const X=new u.$Wd;return T.then(Q=>X.input=Q.listen(U,B)),X.event}}}e.$vh=_;function x(T){let U=!1;return{call(B,X,Q){return U?T.call(B,X,Q):(0,R.$Ug)(0).then(()=>U=!0).then(()=>T.call(B,X,Q))},listen(B,X){if(U)return T.listen(B,X);const Q=new u.$Wd;return(0,R.$Ug)(0).then(()=>U=!0).then(()=>Q.input=T.listen(B,X)),Q.event}}}e.$wh=x;class ue{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const B of U.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await u.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$xh=ue;var te;(function(T){function U(K,M,z){const a=K,m=z&&z.disableMarshalling,F=new Map;for(const C in a)X(C)&&F.set(C,u.Event.buffer(a[C],!0,void 0,M));return new class{listen(C,Z,W){const ce=F.get(Z);if(ce)return ce;if(Q(Z)){const oe=a[Z];if(typeof oe=="function")return oe.call(a,W)}throw new b.$bb(`Event not found: ${Z}`)}call(C,Z,W){const ce=a[Z];if(typeof ce=="function"){if(!m&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,S.$mh)(W[me]);let oe=ce.apply(a,W);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new b.$bb(`Method not found: ${Z}`)}}}T.fromService=U;function B(K,M){const z=M&&M.disableMarshalling;return new Proxy({},{get(a,m){if(typeof m=="string")return M?.properties?.has(m)?M.properties.get(m):Q(m)?function(F){return K.listen(m,F)}:X(m)?K.listen(m):async function(...F){let C;M&&!(0,g.$Hf)(M.context)?C=[M.context,...F]:C=F;const Z=await K.call(m,C);return z?Z:(0,S.$mh)(Z)};throw new b.$bb(`Property not found: ${String(m)}`)}})}T.toService=B;function X(K){return K[0]==="o"&&K[1]==="n"&&N.$1e(K.charCodeAt(2))}function Q(K){return/^onDynamic/.test(K)&&N.$1e(K.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function ie(T){return Array.isArray(T)?T.map(le):le(T)}function q(T,U,B,X,Q,K,M){M=ie(M);const z=ae[Q],a=z[X%z.length];let m=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(K)?(m=m.concat(M),m.push(")")):m.push(M),console.log.apply(console,m)}class J{constructor(U,B){this.d=U,this.f=B,this.a=0,this.b=0}logOutgoing(U,B,X,Q,K){this.b+=U,q(this.d,this.b,U,B,X,Q,K)}logIncoming(U,B,X,Q,K){this.a+=U,q(this.f,this.a,U,B,X,Q,K)}}e.$yh=J}),define(ne[85],re([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;class E extends d.$rh{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>A.$be.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$3p=E;class v{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$Nd,this.onDidProcessExit=this.h.event;const I=f&&f.timeout?f.timeout:6e4;this.b=new R.$Qg(I),this.d=null,this.f=null}getChannel(h){const f=this;return{call(I,p,k){return f.k(h,I,p,k)},listen(I,p){return f.l(h,I,p)}}}k(h,f,I,p=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const k=this.n(h),s=(0,R.$Hg)(i=>k.call(f,I,i)),o=p.onCancellationRequested(()=>s.cancel()),t=(0,c.$Qc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(h,f,I){if(!this.b)return u.Event.None;this.b.cancel();let p;const k=new u.$Nd({onWillAddFirstListener:()=>{p=this.n(h).listen(f,I)(k.fire,k),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,S.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,g.$Al)(f.env),this.d=(0,L.fork)(this.i,h,f);const I=new u.$Nd;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$Yp)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}I.fire(A.$be.wrap(Buffer.from(n,"base64")))});const k=this.j.useQueue?(0,N.$Cl)(this.d):this.d,s=n=>this.d&&this.d.connected&&k.send(n.buffer.toString("base64")),o=I.event,t={send:s,onMessage:o};this.f=new d.$sh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.$Nc)(l)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$4p=v}),define(ne[86],re([0,1,8,4,2,46,3]),function(G,e,L,R,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.StorageState=e.$2o=e.StorageHint=void 0;var b;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function u(g){const d=g;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$2o=u;var c;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(c||(e.StorageState=c={}));class S extends A.$Sc{static{this.a=100}constructor(d,E=Object.create(null)){super(),this.r=d,this.s=E,this.b=this.B(new R.$Qd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Rg(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((E,v)=>this.w(v,E)),d.deleted?.forEach(E=>this.w(E,void 0))}finally{this.b.resume()}}w(d,E){if(this.c===c.Closed)return;let v=!1;(0,D.$Hf)(E)?v=this.f.delete(d):this.f.get(d)!==E&&(this.f.set(d,E),v=!0),v&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,E){const v=this.f.get(d);return(0,D.$Hf)(v)?E:v}getBoolean(d,E){const v=this.get(d);return(0,D.$Hf)(v)?E:v==="true"}getNumber(d,E){const v=this.get(d);return(0,D.$Hf)(v)?E:parseInt(v,10)}getObject(d,E){const v=this.get(d);return(0,D.$Hf)(v)?E:(0,j.$lh)(v)}async set(d,E,v=!1){if(this.c===c.Closed)return;if((0,D.$Hf)(E))return this.delete(d,v);const $=(0,D.$Af)(E)||Array.isArray(E)?(0,j.$kh)(E):String(E);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:v}),this.D()}async delete(d,E=!1){if(!(this.c===c.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:E}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$3o=S;class N{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((E,v)=>this.a.set(v,E)),d.delete?.forEach(E=>this.a.delete(E))}async optimize(){}async close(){}}e.$4o=N}),define(ne[87],re([7,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var A;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(A||(e.TokenType=A={}));function j(...c){switch(c.length){case 1:return(0,R.localize)(0,null,c[0]);case 2:return(0,R.localize)(1,null,c[0],c[1]);case 3:return(0,R.localize)(2,null,c[0],c[1],c[2]);default:return}}const D=(0,R.localize)(3,null),b=(0,R.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return S.isTripleEq?"===":"==";case 4:return S.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const N=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:N})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const N=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:N})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const N=this.d,g=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:g};this.g.push({offset:N,lexeme:g,additionalInfo:S}),this.f.push(d)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const N=this.c.substring(this.d,this.e),g=u.b.get(N);g?this.k(g):this.f.push({type:17,lexeme:N,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,N=!1,g=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(b);return}const E=this.c.charCodeAt(S);if(N)N=!1;else if(E===47&&!g){S++;break}else E===91?g=!0:E===92?N=!0:E===93&&(g=!1);S++}for(;S<this.c.length&&u.a.has(this.c.charCodeAt(S));)S++;this.e=S;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=u}),define(ne[109],re([0,1,76,52,15,16,35,17,11]),function(G,e,L,R,A,j,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,j.$mc)(A.$cg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,j.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,b.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.$em)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$jc)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.$vg)(u.URI.file((0,j.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=D.env.VSCODE_PORTABLE;return d?u.URI.file((0,j.$jc)(d,"argv.json")):(0,b.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,j.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,j.$kc)(d):(0,j.$hc)((0,j.$jc)(A.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,j.$kc)(d)):u.URI.file((0,j.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,j.$kc)(d);const E=D.env.VSCODE_EXTENSIONS;if(E)return E;const v=D.env.VSCODE_PORTABLE;return v?(0,j.$jc)(v,"extensions"):(0,b.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(E=>/^[^:/?#]+?:\/\//.test(E)?u.URI.parse(E):u.URI.file((0,j.$hc)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,j.$hc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$fm.test(d))}get extensionLogLevel(){const d=[];for(const E of this.args.log||[]){const v=e.$fm.exec(E);v&&v[1]&&v[2]&&d.push([v[1],v[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,b.$vg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=D.env.VSCODE_PORTABLE;return d?u.URI.file((0,j.$jc)(d,"policy.json")):(0,b.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,E,v){this.a=d,this.b=E,this.c=v,this.editSessionId=this.args.editSessionId}}e.$gm=c,pe([R.$hh],c.prototype,"appRoot",null),pe([R.$hh],c.prototype,"userHome",null),pe([R.$hh],c.prototype,"userDataPath",null),pe([R.$hh],c.prototype,"appSettingsHome",null),pe([R.$hh],c.prototype,"tmpDir",null),pe([R.$hh],c.prototype,"cacheHome",null),pe([R.$hh],c.prototype,"stateResource",null),pe([R.$hh],c.prototype,"userRoamingDataHome",null),pe([R.$hh],c.prototype,"userDataSyncHome",null),pe([R.$hh],c.prototype,"sync",null),pe([R.$hh],c.prototype,"machineSettingsResource",null),pe([R.$hh],c.prototype,"workspaceStorageHome",null),pe([R.$hh],c.prototype,"localHistoryHome",null),pe([R.$hh],c.prototype,"keyboardLayoutResource",null),pe([R.$hh],c.prototype,"argvResource",null),pe([R.$hh],c.prototype,"isExtensionDevelopment",null),pe([R.$hh],c.prototype,"untitledWorkspacesHome",null),pe([R.$hh],c.prototype,"builtinExtensionsPath",null),pe([R.$hh],c.prototype,"extensionsPath",null),pe([R.$hh],c.prototype,"extensionDevelopmentLocationURI",null),pe([R.$hh],c.prototype,"extensionDevelopmentKind",null),pe([R.$hh],c.prototype,"extensionTestsLocationURI",null),pe([R.$hh],c.prototype,"debugExtensionHost",null),pe([R.$hh],c.prototype,"logLevel",null),pe([R.$hh],c.prototype,"extensionLogLevel",null),pe([R.$hh],c.prototype,"serviceMachineIdResource",null),pe([R.$hh],c.prototype,"disableTelemetry",null),pe([R.$hh],c.prototype,"disableWorkspaceTrust",null),pe([R.$hh],c.prototype,"useInMemorySecretStorage",null),pe([R.$hh],c.prototype,"policyFile",null);function S(g,d){return N(g["inspect-extensions"],g["inspect-brk-extensions"],5870,d,g.debugId,g.extensionEnvironment)}e.$hm=S;function N(g,d,E,v,$,h){const I=Number(d||g)||(v?null:E),p=I?!!d:!1;let k;if(h)try{k=JSON.parse(h)}catch{}return{port:I,break:p,debugId:$,env:k}}e.$im=N}),function(){"use strict";function G(e,L,R){function A(D,b){const u=j(D,b),c=[u];return e.isAbsolute(u)||c.unshift(R),e.resolve(...c)}function j(D,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const S=D["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const N=process.env.USERPROFILE;if(typeof N!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(N,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:A}}if(typeof define=="function")define(ne[110],re([165,33,35]),function(e,L,R){return G(e,L,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=G(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,33,109,110]),function(G,e,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=void 0;class j extends R.$gm{constructor(c,S){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,A.getUserDataPath)(c,S.nameShort)},S)}}e.$jm=j;function D(u,c){return(0,R.$im)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$km=D;function b(u,c){return(0,R.$im)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$lm=b}),define(ne[112],re([0,1,3,94]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;function A(D,b,u,c){try{j(D,b,u,c)}catch(S){D.error(S?.message??S)}return b}e.$yp=A;function j(D,b,u,c){const S=(N,g,d)=>{const E=N[g];if((0,L.$yf)(E)){const v=E,$=v.length;if($>1&&v[0]==="%"&&v[$-1]==="%"){const h=v.substr(1,$-2);let f=u[h];f===void 0&&c&&(f=c[h]);const I=typeof f=="string"?f:f?.message,p=c?.[h],k=typeof p=="string"?p:p?.message;if(!I){k||D.warn(`[${b.name}]: ${(0,R.localize)(0,null,h)}`);return}if(d&&(g==="title"||g==="category")&&k&&k!==I){const s={value:I,original:k};N[g]=s}else N[g]=I}}else if((0,L.$Af)(E))for(const v in E)E.hasOwnProperty(v)&&(v==="commands"?S(E,v,!0):S(E,v,d));else if(Array.isArray(E))for(let v=0;v<E.length;v++)S(E,v,d)};for(const N in b)b.hasOwnProperty(N)&&S(b,N)}}),define(ne[48],re([0,1,17,54,98,42]),function(G,e,L,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||D.test(h)}e.$Mo=u;function c(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(D);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$No=c;function S(h){if(!h)return null;const f=h.majorBase,I=h.majorMustEqual,p=h.minorBase;let k=h.minorMustEqual;const s=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(f===0||(k=!1),o=!1);let t=0;if(h.preRelease){const i=b.exec(h.preRelease);if(i){const[,n,r,l]=i;t=Date.UTC(Number(n),Number(r)-1,Number(l))}}return{majorBase:f,majorMustEqual:I,minorBase:p,minorMustEqual:k,patchBase:s,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:t}}e.$Oo=S;function N(h,f,I){let p;typeof h=="string"?p=S(c(h)):p=h;let k;f instanceof Date?k=f.getTime():typeof f=="string"&&(k=new Date(f).getTime());let s;if(typeof I=="string"?s=S(c(I)):s=I,!p||!s)return!1;const o=p.majorBase,t=p.minorBase,i=p.patchBase;let n=s.majorBase,r=s.minorBase,l=s.patchBase;const P=s.notBefore;let y=s.majorMustEqual,w=s.minorMustEqual,O=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||k&&k<P?!1:i>=l:(o===1&&n===0&&(!y||!w||!O)&&(n=1,r=0,l=0,y=!0,w=!1,O=!1),o<n?!1:o>n?!y:t<r?!1:t>r?!w:i<l?!1:i>l?!O:!(k&&k<P))}e.$Po=N;function g(h,f,I,p,k){const s=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return s.push([R.default.Error,A.localize(0,null)]),s;if(typeof p.name!="string")return s.push([R.default.Error,A.localize(1,null,"name")]),s;if(typeof p.version!="string")return s.push([R.default.Error,A.localize(2,null,"version")]),s;if(!p.engines)return s.push([R.default.Error,A.localize(3,null,"engines")]),s;if(typeof p.engines.vscode!="string")return s.push([R.default.Error,A.localize(4,null,"engines.vscode")]),s;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return s.push([R.default.Error,A.localize(5,null,"extensionDependencies")]),s;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return s.push([R.default.Error,A.localize(6,null,"activationEvents")]),s;if(typeof p.main>"u"&&typeof p.browser>"u")return s.push([R.default.Error,A.localize(7,null,"activationEvents","main","browser")]),s}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&s.push([R.default.Warning,A.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return s.push([R.default.Error,A.localize(9,null,"main")]),s;{const i=(0,L.$vg)(I,p.main);(0,L.$pg)(i,I)||s.push([R.default.Warning,A.localize(10,null,i.path,I.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return s.push([R.default.Error,A.localize(11,null,"browser")]),s;{const i=(0,L.$vg)(I,p.browser);(0,L.$pg)(i,I)||s.push([R.default.Warning,A.localize(12,null,i.path,I.path)])}}if(!j.valid(p.version))return s.push([R.default.Error,A.localize(13,null)]),s;const o=[];if(!d(h,f,p,k,o))for(const i of o)s.push([R.default.Error,i]);return s}e.$Qo=g;function d(h,f,I,p,k){return p||typeof I.main>"u"&&typeof I.browser>"u"?!0:v(h,f,I.engines.vscode,k)}e.$Ro=d;function E(h,f,I){return h==="*"||v(f,I,h)}e.$So=E;function v(h,f,I,p=[]){const k=S(c(I));if(!k)return p.push(A.localize(14,null,I)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return p.push(A.localize(15,null,I)),!1}else if(!k.majorMustEqual)return p.push(A.localize(16,null,I)),!1;return N(h,f,k)?!0:(p.push(A.localize(17,null,h,I)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let f=0,I=h.length;f<I;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;async function A(j,D,b){let u=b&&b.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const S=(await D.readFile(j.serviceMachineIdResource)).value.toString();u=(0,R.$dg)(S)?S:null}catch{u=null}if(!u){u=(0,R.$eg)();try{await D.writeFile(j.serviceMachineIdResource,L.$be.fromString(u))}catch{}}return b?.store("storage.serviceMachineId",u,-1,1),u}e.$ap=A}),define(ne[49],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class L{constructor(A,j=[],D=!1){this.ctor=A,this.staticArguments=j,this.supportsDelayedInstantiation=D}}e.$Mh=L}),define(ne[114],re([0,1,49]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.InstantiationType=void 0;const R=[];var A;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function j(b,u,c){u instanceof L.$Mh||(u=new L.$Mh(u,[],!!c)),R.push([b,u])}e.$xr=j;function D(){return R}e.$yr=D}),define(ne[115],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class L{constructor(j,D){this.key=j,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$cq=L;class R{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const D of this.a.values())D.outgoing.size===0&&j.push(D);return j}insertEdge(j,D){const b=this.lookupOrInsertNode(j),u=this.lookupOrInsertNode(D);b.outgoing.set(u.key,u),u.incoming.set(b.key,b)}removeNode(j){const D=this.b(j);this.a.delete(D);for(const b of this.a.values())b.outgoing.delete(D),b.incoming.delete(D)}lookupOrInsertNode(j){const D=this.b(j);let b=this.a.get(D);return b||(b=new L(D,j),this.a.set(D,b)),b}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[D,b]of this.a)j.push(`${D}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,D]of this.a){const b=new Set([j]),u=this.c(D,b);if(u)return u}}c(j,D){for(const[b,u]of j.outgoing){if(D.has(b))return[...D,b].join(" -> ");D.add(b);const c=this.c(u,D);if(c)return c;D.delete(b)}}}e.$dq=R}),define(ne[25],re([0,1,3,11,10]),function(G,e,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,A.$Ph)("configurationService");function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof R.URI)}e.$ki=j;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof R.URI)}e.$li=D;var b;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=u;function c(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$ni=c;function S(h,f){const I=Object.create(null);for(const p in h)N(I,p,h[p],f);return I}e.$oi=S;function N(h,f,I,p){const k=f.split("."),s=k.pop();let o=h;for(let t=0;t<k.length;t++){const i=k[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${k.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=I}catch{p(`Ignoring ${f} as ${k.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${f} as ${k.join(".")} is ${JSON.stringify(o)}`)}e.$pi=N;function g(h,f){const I=f.split(".");d(h,I)}e.$qi=g;function d(h,f){const I=f.shift();if(f.length===0){delete h[I];return}if(Object.keys(h).indexOf(I)!==-1){const p=h[I];typeof p=="object"&&!Array.isArray(p)&&(d(p,f),Object.keys(p).length===0&&delete h[I])}}function E(h,f,I){function p(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const k=f.split("."),s=p(h,k);return typeof s>"u"?I:s}e.$ri=E;function v(h,f,I){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in h?L.$Af(h[p])&&L.$Af(f[p])?v(h[p],f[p],I):I&&(h[p]=f[p]):h[p]=f[p])})}e.$si=v;function $(h){return h.replace(/[\[\]]/g,"")}e.$ti=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(G,e,L,R,A,j,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$k),u.set("isLinux",L.$l),u.set("isWindows",L.$j),u.set("isWeb",L.$p),u.set("isMacNative",L.$k&&!L.$p),u.set("isEdge",L.$H),u.set("isFirefox",L.$F),u.set("isChrome",L.$E),u.set("isSafari",L.$G);function c(z,a){if(u.get(z)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,a)}e.$Li=c;const S=Object.prototype.hasOwnProperty;var N;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(N||(e.ContextKeyExprType=N={}));const g={regexParsingWithErrorRecovery:!0},d=(0,D.localize)(0,null),E=(0,D.localize)(1,null),v=(0,D.localize)(2,null),$=(0,D.localize)(3,null),h=(0,D.localize)(4,null),f=(0,D.localize)(5,null),I=(0,D.localize)(6,null),p=(0,D.localize)(7,null);class k{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=g){this.k=a,this.d=new A.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:E});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const F=this.D(),C=F.type===17?f:void 0;throw this.h.push({message:h,offset:F.offset,lexeme:A.$Ki.getLexeme(F),additionalInfo:C}),k.c}return m}catch(m){if(m!==k.c)throw m;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const m=this.o();a.push(m)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const m=this.s();a.push(m)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,$),m?.negate()}case 17:return this.z(),H.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const m=this.l();return this.A(1,$),m}case 17:{const m=a.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const Z=C.lexeme,W=Z.lastIndexOf("/"),ce=W===Z.length-1?void 0:this.w(Z.substring(W+1));let oe;try{oe=new RegExp(Z.substring(1,W),ce)}catch{throw this.B("REGEX",C)}return le.create(m,oe)}switch(C.type){case 10:case 19:{const Z=[C.lexeme];this.z();let W=this.D(),ce=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--}if(ce<0)break;Z.push(A.$Ki.getLexeme(W)),this.z(),W=this.D()}const oe=Z.join(""),me=oe.lastIndexOf("/"),de=me===oe.length-1?void 0:this.w(oe.substring(me+1));let ge;try{ge=new RegExp(oe.substring(1,me),de)}catch{throw this.B("REGEX",C)}return s.regex(m,ge)}case 18:{const Z=C.lexeme;this.z();let W=null;if(!(0,R.$Be)(Z)){const ce=Z.indexOf("/"),oe=Z.lastIndexOf("/");if(ce!==oe&&ce>=0){const me=Z.slice(ce+1,oe),de=Z[oe+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",C)}}}if(W===null)throw this.B("REGEX",C);return le.create(m,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const C=this.u();return s.notIn(m,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return s.equals(m,C);switch(C){case"true":return s.has(m);case"false":return s.not(m);default:return s.equals(m,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return s.notEquals(m,C);switch(C){case"true":return s.not(m);case"false":return s.has(m);default:return s.notEquals(m,C)}}case 5:return this.z(),te.create(m,this.u());case 6:return this.z(),ae.create(m,this.u());case 7:return this.z(),x.create(m,this.u());case 8:return this.z(),ue.create(m,this.u());case 13:return this.z(),s.in(m,this.u());default:return s.has(m)}}case 20:throw this.h.push({message:I,offset:a.offset,lexeme:"",additionalInfo:p}),k.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,m){if(this.C(a))return this.z();throw this.B(m,this.D())}B(a,m,F){const C=(0,D.localize)(8,null,a,A.$Ki.getLexeme(m)),Z=m.offset,W=A.$Ki.getLexeme(m);return this.h.push({message:C,offset:Z,lexeme:W,additionalInfo:F}),k.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=k;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return l.create(a)}static equals(a,m){return P.create(a,m)}static notEquals(a,m){return O.create(a,m)}static regex(a,m){return le.create(a,m)}static in(a,m){return y.create(a,m)}static notIn(a,m){return w.create(a,m)}static not(a){return H.create(a)}static and(...a){return J.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,m){return x.create(a,m)}static greaterEquals(a,m){return ue.create(a,m)}static smaller(a,m){return te.create(a,m)}static smallerEquals(a,m){return ae.create(a,m)}static{this.c=new k({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Ni=s;function o(z){const a=new k({regexParsingWithErrorRecovery:!1});return z.map(m=>(a.parse(m),a.lexingErrors.length>0?a.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,D.localize)(9,null,F.additionalInfo):(0,D.localize)(10,null),offset:F.offset,length:F.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.$Oi=o;function t(z,a){const m=z?z.substituteConstants():void 0,F=a?a.substituteConstants():void 0;return!m&&!F?!0:!m||!F?!1:m.equals(F)}e.$Pi=t;function i(z,a){return z.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$Qi=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$Ri=r;class l{static create(a,m=null){const F=u.get(a);return typeof F=="boolean"?F?r.INSTANCE:n.INSTANCE:new l(a,m)}constructor(a,m){this.key=a,this.c=m,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=u.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$Si=l;class P{static create(a,m,F=null){if(typeof m=="boolean")return m?l.create(a,F):H.create(a,F);const C=u.get(a);return typeof C=="boolean"?m===(C?"true":"false")?r.INSTANCE:n.INSTANCE:new P(a,m,F)}constructor(a,m,F){this.c=a,this.d=m,this.f=F,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:X(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ti=P;class y{static create(a,m){return new y(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:X(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.f),F=a.getValue(this.d);return Array.isArray(m)?m.includes(F):typeof F=="string"&&typeof m=="object"&&m!==null?S.call(m,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Ui=y;class w{static create(a,m){return new w(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=11,this.c=y.create(a,m)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=w;class O{static create(a,m,F=null){if(typeof m=="boolean")return m?H.create(a,F):l.create(a,F);const C=u.get(a);return typeof C=="boolean"?m===(C?"true":"false")?n.INSTANCE:r.INSTANCE:new O(a,m,F)}constructor(a,m,F){this.c=a,this.d=m,this.f=F,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:X(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Wi=O;class H{static create(a,m=null){const F=u.get(a);return typeof F=="boolean"?F?n.INSTANCE:r.INSTANCE:new H(a,m)}constructor(a,m){this.c=a,this.d=m,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:B(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=u.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Xi=H;function _(z,a){if(typeof z=="string"){const m=parseFloat(z);isNaN(m)||(z=m)}return typeof z=="string"||typeof z=="number"?a(z):n.INSTANCE}class x{static create(a,m,F=null){return _(m,C=>new x(a,C,F))}constructor(a,m,F){this.c=a,this.d=m,this.f=F,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:X(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Yi=x;class ue{static create(a,m,F=null){return _(m,C=>new ue(a,C,F))}constructor(a,m,F){this.c=a,this.d=m,this.f=F,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:X(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Zi=ue;class te{static create(a,m,F=null){return _(m,C=>new te(a,C,F))}constructor(a,m,F){this.c=a,this.d=m,this.f=F,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:X(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$1i=te;class ae{static create(a,m,F=null){return _(m,C=>new ae(a,C,F))}constructor(a,m,F){this.c=a,this.d=m,this.f=F,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:X(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$2i=ae;class le{static create(a,m){return new le(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const m=this.f?this.f.source:"",F=a.f?a.f.source:"";return m<F?-1:m>F?1:0}equals(a){if(a.type===this.type){const m=this.f?this.f.source:"",F=a.f?a.f.source:"";return this.d===a.d&&m===F}return!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$3i=le;class ie{static create(a){return new ie(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new ie(this.c.map(a))}negate(){return this.c}}e.$4i=ie;function q(z){let a=null;for(let m=0,F=z.length;m<F;m++){const C=z[m].substituteConstants();if(z[m]!==C&&a===null){a=[];for(let Z=0;Z<m;Z++)a[Z]=z[Z]}a!==null&&(a[m]=C)}return a===null?z:a}class J{static create(a,m,F){return J.d(a,m,F)}constructor(a,m){this.expr=a,this.c=m,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,F=this.expr.length;m<F;m++){const C=i(this.expr[m],a.expr[m]);if(C!==0)return C}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:J.create(a,this.c,!1)}evaluate(a){for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].evaluate(a))return!1;return!0}static d(a,m,F){const C=[];let Z=!1;for(const W of a)if(W){if(W.type===1){Z=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){C.push(...W.expr);continue}C.push(W)}if(C.length===0&&Z)return r.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(i);for(let W=1;W<C.length;W++)C[W-1].equals(C[W])&&(C.splice(W,1),W--);if(C.length===1)return C[0];for(;C.length>1;){const W=C[C.length-1];if(W.type!==9)break;C.pop();const ce=C.pop(),oe=C.length===0,me=T.create(W.expr.map(de=>J.create([de,ce],null,F)),null,oe);me&&(C.push(me),C.sort(i))}if(C.length===1)return C[0];if(F){for(let W=0;W<C.length;W++)for(let ce=W+1;ce<C.length;ce++)if(C[W].negate().equals(C[ce]))return n.INSTANCE;if(C.length===1)return C[0]}return new J(C,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new J(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());this.c=T.create(a,this,!0)}return this.c}}e.$5i=J;class T{static create(a,m,F){return T.d(a,m,F)}constructor(a,m){this.expr=a,this.c=m,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,F=this.expr.length;m<F;m++){const C=i(this.expr[m],a.expr[m]);if(C!==0)return C}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let m=0,F=this.expr.length;m<F;m++)if(this.expr[m].evaluate(a))return!0;return!1}static d(a,m,F){let C=[],Z=!1;if(a){for(let W=0,ce=a.length;W<ce;W++){const oe=a[W];if(oe){if(oe.type===0){Z=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&Z)return n.INSTANCE;C.sort(i)}if(C.length!==0){if(C.length===1)return C[0];for(let W=1;W<C.length;W++)C[W-1].equals(C[W])&&(C.splice(W,1),W--);if(C.length===1)return C[0];if(F){for(let W=0;W<C.length;W++)for(let ce=W+1;ce<C.length;ce++)if(C[W].negate().equals(C[ce]))return r.INSTANCE;if(C.length===1)return C[0]}return new T(C,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new T(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());for(;a.length>1;){const m=a.shift(),F=a.shift(),C=[];for(const Z of M(m))for(const W of M(F))C.push(J.create([Z,W],null,!1));a.unshift(T.create(C,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$6i=T;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(a,m,F){super(a,null),this.f=m,typeof F=="object"?U.d.push({...F,key:a}):F!==!0&&U.d.push({key:a,description:F,type:m!=null?typeof m:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return P.create(this.key,a)}notEqualsTo(a){return O.create(this.key,a)}}e.$7i=U,e.$8i=(0,j.$Ph)("contextKeyService");function B(z,a){return z<a?-1:z>a?1:0}function X(z,a,m,F){return z<m?-1:z>m?1:a<F?-1:a>F?1:0}function Q(z,a){if(z.type===0||a.type===1)return!0;if(z.type===9)return a.type===9?K(z.expr,a.expr):!1;if(a.type===9){for(const m of a.expr)if(Q(z,m))return!0;return!1}if(z.type===6){if(a.type===6)return K(a.expr,z.expr);for(const m of z.expr)if(Q(m,a))return!0;return!1}return z.equals(a)}e.$9i=Q;function K(z,a){let m=0,F=0;for(;m<z.length&&F<a.length;){const C=z[m].cmp(a[F]);if(C<0)return!1;C===0&&m++,F++}return m===z.length}function M(z){return z.type===9?z.expr:[z]}}),define(ne[59],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$On=(0,L.$Ph)("downloadService")}),define(ne[18],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,L.$Ph)("environmentService"),e.$Xh=(0,L.$Qh)(e.$Wh)}),define(ne[21],re([0,1,92,10]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$$n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function A(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=A;function j(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=j;function D(f,I){switch(f){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=D;function b(f,I){return I==="web"&&!f.includes("web")}e.$7n=b;function u(f,I,p){return b(I,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:c(p).includes(f)}e.$8n=u;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$9n=c;function S(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$0n=S;var N;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(N||(e.SortBy=N={}));var g;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var E;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$$n=(0,R.$Ph)("extensionGalleryService");var v;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var $;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class h extends Error{constructor(I,p){super(I),this.code=p,this.name=p}}e.$_n=h,e.$ao=(0,R.$Ph)("extensionManagementService"),e.$bo="extensionsIdentifiers/disabled",e.$co="extensionsIdentifiers/enabled",e.$do=(0,R.$Ph)("IGlobalExtensionEnablementService"),e.$eo=(0,R.$Ph)("IExtensionTipsService"),e.$fo=(0,L.localize)(0,null),e.$go={value:e.$fo,original:"Extensions"},e.$ho={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=void 0,e.$fp=(0,L.$Ph)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((j,D)=>G(["node-vsce-sign"],async b=>j(b),D))),this.a}async verify(j,D,b){let u;try{u=await this.b()}catch{return!1}return u.verify(j,D,b)}}e.$gp=R}),define(ne[61],re([0,1,14,9,100,12]),function(G,e,L,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;async function D(S,N,g,d,E,v){let $;try{await b(S,N,g,d,E,v)}catch(h){$=h}finally{$&&E.errorTransformer&&($=E.errorTransformer($)),typeof $<"u"&&g.error($),g.end()}}e.$Np=D;async function b(S,N,g,d,E,v){u(v);const $=await S.open(N,{create:!1});try{u(v);let h=0,f=0,I=E&&typeof E.length=="number"?E.length:void 0,p=L.$be.alloc(Math.min(E.bufferSize,typeof I=="number"?I:E.bufferSize)),k=E&&typeof E.position=="number"?E.position:0,s=0;do f=await S.read($,k,p.buffer,s,p.byteLength-s),k+=f,s+=f,h+=f,typeof I=="number"&&(I-=f),s===p.byteLength&&(await g.write(d(p)),p=L.$be.alloc(Math.min(E.bufferSize,typeof I=="number"?I:E.bufferSize)),s=0);while(f>0&&(typeof I!="number"||I>0)&&u(v)&&c(h,E));if(s>0){let o=s;typeof I=="number"&&(o=Math.min(s,I)),g.write(d(p.slice(0,o)))}}catch(h){throw(0,j.$mk)(h)}finally{await S.close($)}}function u(S){if(S.isCancellationRequested)throw(0,R.$6)();return!0}function c(S,N){if(typeof N?.limits?.size=="number"&&S>N.limits.size)throw(0,j.$lk)((0,A.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(G,e,L,R,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class b extends A.$Sc{constructor(){super(...arguments),this.a=this.B(new L.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const S=this.j(c),N=S.filter(d=>{const E=this.c.get(d.path);return E?!(0,R.$Aj)(E.request.excludes,d.excludes)||!(0,R.$Aj)(E.request.includes,d.includes):!0}),g=Array.from(this.c.values()).filter(({request:d})=>!S.find(E=>E.path===d.path&&(0,R.$Aj)(E.excludes,d.excludes)&&(0,R.$Aj)(E.includes,d.includes))).map(({request:d})=>d.path);N.length&&this.m(`Request to start watching: ${N.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const d of g)this.h(d);for(const d of N)this.g(d)}g(c){const S=new D.$0p(c,g=>this.a.fire(g),g=>this.b.fire(g),this.f),N={request:c,instance:S};this.c.set(c.path,N)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const S=this.c.get(c);S&&(this.c.delete(c),S.instance.dispose())}j(c){const S=new Map;for(const N of c){const g=j.$l?N.path:N.path.toLowerCase();let d=S.get(N.correlationId);d||(d=new Map,S.set(N.correlationId,d)),d.set(g,N)}return Array.from(S.values()).map(N=>Array.from(N.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,S]of this.c)S.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,S){return S?`[File Watcher (node.js)] ${c} (path: ${S.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$_p=b}),define(ne[118],re([0,1,62,117]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;class A extends L.$Rp{constructor(D,b,u){super(D,b,u),this.s()}r(D){return D.add(new R.$_p)}}e.$aq=A}),define(ne[119],re([0,1,15,57,85,62]),function(G,e,L,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;class D extends j.$Sp{constructor(u,c,S){super(u,c,S),this.s()}r(u){const c=u.add(new A.$4p(L.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:S,signal:N})=>this.t(`terminated by itself with code ${S}, signal: ${N}`))),R.ProxyChannel.toService((0,R.$wh)(c.getChannel("watcher")))}}e.$5p=D}),define(ne[63],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class L{constructor(...A){this.a=new Map;for(const[j,D]of A)this.set(j,D)}set(A,j){const D=this.a.get(A);return this.a.set(A,j),D}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Nh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(G,e,L,R,A,j,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;const S=!1;class N extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class g{constructor($=new u.$Nh,h=!1,f,I=S){this.f=$,this.g=h,this.h=f,this.i=I,this.o=new Set,this.f.set(b.$Oh,this),this._globalGraph=I?f?._globalGraph??new D.$dq(p=>p):void 0}createChild($){return new g($,this.g,this,this.i)}invokeFunction($,...h){const f=E.traceInvocation(this.i,$);let I=!1;try{return $({get:k=>{if(I)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(k,f);if(!s)throw new Error(`[invokeFunction] unknown service '${k}'`);return s}},...h)}finally{I=!0,f.stop()}}createInstance($,...h){let f,I;return $ instanceof j.$Mh?(f=E.traceCreation(this.i,$.ctor),I=this.j($.ctor,$.staticArguments.concat(h),f)):(f=E.traceCreation(this.i,$),I=this.j($,h,f)),f.stop(),I}j($,h=[],f){const I=b._util.getServiceDependencies($).sort((s,o)=>s.index-o.index),p=[];for(const s of I){const o=this.m(s.id,f);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${s.id}.`,!1),p.push(o)}const k=I.length>0?I[0].index:h.length;if(h.length!==k){console.trace(`[createInstance] First service dependency of ${$.name} at position ${k+1} conflicts with ${h.length} static arguments`);const s=k-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,k)}return Reflect.construct($,h.concat(p))}k($,h){if(this.f.get($)instanceof j.$Mh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const f=this.l($);return f instanceof j.$Mh?this.q($,f,h.branch($,!0)):(h.branch($,!1),f)}q($,h,f){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,f)}finally{this.o.delete($)}}r($,h,f){const I=new D.$dq(s=>s.id.toString());let p=0;const k=[{id:$,desc:h,_trace:f}];for(;k.length;){const s=k.pop();if(I.lookupOrInsertNode(s),p++>1e3)throw new N(I);for(const o of b._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof j.$Mh){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};I.insertEdge(s,i),k.push(i)}}}for(;;){const s=I.roots();if(s.length===0){if(!I.isEmpty())throw new N(I);break}for(const{data:o}of s){if(this.l(o.id)instanceof j.$Mh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}I.removeNode(o)}}return this.l($)}s($,h,f=[],I,p){if(this.f.get($)instanceof j.$Mh)return this.t($,h,f,I,p);if(this.h)return this.h.s($,h,f,I,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,f=[],I,p){if(I){const k=new g(void 0,this.g,this,this.i);k.c=String($);const s=new Map,o=new L.$$g(()=>{const t=k.j(h,f,p);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const l of n)r.apply(t,l)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=s.get(i);return l||(l=new c.$2c,s.set(i,l)),(y,w,O)=>{const H=l.push([y,w,O]);return(0,A.$Qc)(H)}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return h.prototype}})}else return this.j(h,f,p)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$eq=g;var d;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(d||(d={}));class E{static{this.all=new Set}static{this.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new E(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation($,h){return $?new E(1,h.name):E.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const f=new E(3,$.toString());return this.h.push([$,h,f]),f}stop(){const $=Date.now()-this.g;E.f+=$;let h=!1;function f(p,k){const s=[],o=new Array(p+1).join("	");for(const[t,i,n]of k.h)if(i&&n){h=!0,s.push(`${o}CREATES -> ${t}`);const r=f(p+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];($>2||h)&&E.all.add(I.join(`
`))}}e.$fq=E});var se=this&&this.__param||function(G,e){return function(L,R){e(L,R,G)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(G,e,L,R,A,j,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=void 0;function u(S){return S.tags.find(N=>N.startsWith("lp-"))?.split("lp-")[1]}e.$Sq=u,e.$Tq=(0,b.$Ph)("languagePackService");let c=class extends R.$Sc{constructor(N){super(),this.c=N}async getAvailableLanguages(){const N=new L.$Xd;setTimeout(()=>N.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},N.token)}catch{return[]}const E=g.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some($=>$.startsWith("lp-"))).map(v=>{const $=v.properties.localizedLanguages?.[0],h=u(v);return{...this.f(h,$,v),extensionId:v.identifier.id,galleryExtension:v}});return E.push(this.f("en","English")),E}f(N,g,d){const E=g??N;let v;if(E!==N&&(v=`(${N})`),N.toLowerCase()===A.$w.toLowerCase()&&(v??="",v+=(0,j.localize)(0,null)),d?.installCount){v??="";const $=d.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),v+=` $(cloud-download) ${h}`}return{id:N,label:E,description:v}}};e.$Uq=c,e.$Uq=c=pe([se(0,D.$$n)],c)}),define(ne[6],re([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(G,e,L,R,A,j,D,b,u,c,S,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,g.$Ph)("logService"),e.$$i=(0,g.$Ph)("loggerService");function d(){return new Date().toISOString()}function E(y){return(0,c.$Cf)(y)}e.$_i=E;var v;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$aj=v.Info;function $(y,w,O){switch(w){case v.Trace:y.trace(O);break;case v.Debug:y.debug(O);break;case v.Info:y.info(O);break;case v.Warning:y.warn(O);break;case v.Error:y.error(O);break;case v.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=$;function h(y,w=!1){let O="";for(let H=0;H<y.length;H++){let _=y[H];if(_ instanceof Error&&(_=(0,L.$Ai)(_,w)),typeof _=="object")try{_=JSON.stringify(_)}catch{}O+=(H>0?" ":"")+_}return O}class f extends j.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new R.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==v.Off&&this.b<=w}}e.$cj=f;class I extends f{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...O){this.f(v.Trace)&&this.g(v.Trace,h([w,...O],!0))}debug(w,...O){this.f(v.Debug)&&this.g(v.Debug,h([w,...O]))}info(w,...O){this.f(v.Info)&&this.g(v.Info,h([w,...O]))}warn(w,...O){this.f(v.Warning)&&this.g(v.Warning,h([w,...O]))}error(w,...O){if(this.f(v.Error))if(w instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=w.stack,this.g(v.Error,h(H))}else this.g(v.Error,h([w,...O]))}flush(){}}e.$dj=I;class p extends f{constructor(w=e.$aj){super(),this.setLevel(w),this.g=!b.$j}trace(w,...O){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...O):console.log(`[main ${d()}]`,w,...O))}debug(w,...O){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...O):console.log(`[main ${d()}]`,w,...O))}info(w,...O){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...O):console.log(`[main ${d()}]`,w,...O))}warn(w,...O){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...O):console.warn(`[main ${d()}]`,w,...O))}error(w,...O){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...O):console.error(`[main ${d()}]`,w,...O))}dispose(){}flush(){}}e.$ej=p;class k extends f{constructor(w=e.$aj,O=!0){super(),this.g=O,this.setLevel(w)}trace(w,...O){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...O):console.log(w,...O))}debug(w,...O){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...O):console.log(w,...O))}info(w,...O){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...O):console.log(w,...O))}warn(w,...O){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...O):console.log(w,...O))}error(w,...O){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...O):console.error(w,...O))}dispose(){}flush(){}}e.$fj=k;class s extends f{constructor(w,O=e.$aj){super(),this.g=w,this.setLevel(O)}trace(w,...O){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(w),...O])}debug(w,...O){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(w),...O])}info(w,...O){this.f(v.Info)&&this.g.log(v.Info,[this.h(w),...O])}warn(w,...O){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(w),...O])}error(w,...O){this.f(v.Error)&&this.g.log(v.Error,[this.h(w),...O])}h(w){return typeof w=="string"?w:(0,L.$Ai)(w,this.f(v.Trace))}dispose(){}flush(){}}e.$gj=s;class o extends f{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const O of this.g)O.setLevel(w);super.setLevel(w)}trace(w,...O){for(const H of this.g)H.trace(w,...O)}debug(w,...O){for(const H of this.g)H.debug(w,...O)}info(w,...O){for(const H of this.g)H.info(w,...O)}warn(w,...O){for(const H of this.g)H.warn(w,...O)}error(w,...O){for(const H of this.g)H.error(w,...O)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$hj=o;class t extends j.$Sc{constructor(w,O,H){if(super(),this.h=w,this.j=O,this.b=new D.$Ac,this.c=this.B(new R.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Nd),this.onDidChangeVisibility=this.g.event,H)for(const _ of H)this.b.set(_.resource,{logger:void 0,info:_})}m(w){return(0,c.$yf)(w)?[...this.b.values()].find(O=>O.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,O){const H=this.n(w),_=(0,c.$yf)(w)?w:O?.id??(0,A.$Di)(H.toString()).toString(16);let x=this.b.get(H)?.logger;const ue=O?.logLevel==="always"?v.Trace:O?.logLevel;x||(x=this.s(H,ue??this.getLogLevel(H)??this.h,{...O,id:_}));const te={logger:x,info:{resource:H,id:_,logLevel:ue,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(te.info),this.b.set(H,te),x}n(w){return(0,c.$yf)(w)?(0,u.$vg)(this.j,`${w}.log`):w}setLogLevel(w,O){if(S.URI.isUri(w)){const H=w,_=O,x=this.b.get(H);x&&_!==x.info.logLevel&&(x.info.logLevel=_===this.h?void 0:_,x.logger?.setLevel(_),this.b.set(x.info.resource,x),this.f.fire([H,_]))}else{this.h=w;for(const[H,_]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,O){const H=this.m(w);H&&O!==!H.info.hidden&&(H.info.hidden=!O,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,O]))}getLogLevel(w){let O;return w&&(O=this.b.get(w)?.info.logLevel),O??this.h}registerLogger(w){const O=this.b.get(w.resource);O?O.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const O=this.b.get(w);O&&(O.logger&&O.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=t;class i{constructor(){this.onDidChangeLogLevel=new R.$Nd().event}setLevel(w){}getLevel(){return v.Info}trace(w,...O){}debug(w,...O){}info(w,...O){}warn(w,...O){}error(w,...O){}critical(w,...O){}dispose(){}flush(){}}e.$jj=i;class n extends i{}e.$kj=n;function r(y){if(y.verbose)return v.Trace;if(typeof y.logLevel=="string"){const w=P(y.logLevel.toLowerCase());if(w!==void 0)return w}return e.$aj}e.$lj=r;function l(y){switch(y){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$mj=l;function P(y){switch(y){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$nj=P,e.$oj=new N.$7i("logLevel",l(v.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(G,e,L,R,A,j,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class S extends D.$Sc{constructor(g,d){super(),this.a=g,this.b=d,this.c=this.B(new j.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Rg(0)),this.w=[],this.y=this.B(new R.$Rg(0))}watch(g,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(g,d):this.z(g,d)}n(g,d){const E={path:this.H(g),excludes:d.excludes,includes:d.includes,recursive:d.recursive,correlationId:d.correlationId},v=(0,L.$Ub)(this.j,E);return this.r(),(0,D.$Qc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,A.$1)(g))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,u.$Tp)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const d of this.j)(0,u.$Pp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const d of this.j)(0,u.$Pp)(d)&&g.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,d){const E={path:this.H(g),excludes:d.excludes,includes:d.includes,recursive:!1,correlationId:d.correlationId},v=(0,L.$Ub)(this.w,E);return this.C(),(0,D.$Qc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,A.$1)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,u.$Tp)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,b.$hc)(g.fsPath)}}e.$Xp=S}),define(ne[122],re([0,1,19,8,14,20,4,41,65,2,47,15,123,17,45,99,12,61,6,9]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E,v,$,h,f,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;let k=class extends c.$Sc{static{p=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Nd),this.Y=this.B(new D.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$3g)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${o}`);const i=new c.$Rc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new $.$rk(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Nc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await R.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,d.$zg)(o))throw new $.$tk((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new I.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,$.$ek)(t)||(0,$.$bk)(t)||(0,$.$fk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,$.$ek)(t)||(0,$.$bk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,$.$ok)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$tk((0,v.localize)(2,null,this.sb(o)),1):(0,$.$mk)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,l=t?.resolveSingleChildDescendants,P=t?.resolveMetadata,y=await i.stat(o);let w;return this.t(i,o,y,void 0,!!P,(O,H)=>(w||(w=S.$Vh.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(O.resource)||w.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&l?H===1:!1))}async t(o,t,i,n,r,l){const{providerExtUri:P}=this.R(o),y={resource:t,name:P.basename(t),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Ek)({mtime:i.mtime,size:i.size}),children:void 0};if(y.isDirectory&&l(y,n)){try{const w=await o.readdir(t),O=await R.Promises.settled(w.map(async([H,_])=>{try{const x=P.joinPath(t,H),ue=r?await o.stat(x):{type:_};return await this.t(o,x,ue,w.length,r,l)}catch(x){return this.b.trace(x),null}}));y.children=(0,L.$Hb)(O)}catch(w){this.b.trace(w),y.children=[]}return y}return y}async resolveAll(o){return R.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new $.$tk((0,v.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=A.$be.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new $.$qk(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let l=i;if((0,$.$hk)(n)&&!l?.atomic){const P=n.enforceAtomicWriteFile?.(o);P&&(l={...i,atomic:P})}try{await this.w(n,o,l)||await this.U(n,r.dirname(o));let y;if((0,$.$bk)(n)&&!(t instanceof A.$be))if((0,E.$Zd)(t)){const w=await(0,E.$7d)(t,3);w.ended?y=A.$be.concat(w.buffer):y=w}else y=(0,E.$4d)(t,w=>A.$be.concat(w),3);else y=t;!(0,$.$ek)(n)||(0,$.$bk)(n)&&y instanceof A.$be||(0,$.$bk)(n)&&(0,$.$hk)(n)&&l?.atomic?await this.hb(n,o,l,y):await this.db(n,o,l,y instanceof A.$be?(0,A.$me)(y):y),this.r.fire(new $.$qk(o,4))}catch(P){throw new $.$tk((0,v.localize)(4,null,this.sb(o),(0,$.$mk)(P).toString()),(0,$.$pk)(P),l)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(t)));if(n)throw new Error((0,v.localize)(8,null,this.sb(t)))}let l;try{l=await o.stat(t)}catch{return}if(l.type&$.FileType.Directory)throw new $.$tk((0,v.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Dk&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,$.$Ek)({mtime:i.mtime,size:l.size}))throw new $.$tk((0,v.localize)(10,null),3,i);return l}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,l)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const P=await this.C(o,t,i,n);r(P)}catch(P){l(P)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,A.$ne)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new j.$Xd(n);let l=i;(0,$.$gk)(o)&&o.enforceAtomicReadFile?.(t)&&(l={...i,atomic:!0});const P=this.J(t,l).then(w=>w,w=>{throw r.dispose(!0),w});let y;try{return typeof l?.etag=="string"&&l.etag!==$.$Dk&&await P,l?.atomic&&(0,$.$gk)(o)||!((0,$.$ek)(o)||(0,$.$fk)(o))||(0,$.$bk)(o)&&l?.preferUnbuffered?y=this.I(o,t,l):(0,$.$fk)(o)?y=this.G(o,t,r.token,l):y=this.H(o,t,r.token,l),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await P,value:y}}catch(w){throw y&&await(0,E.$5d)(y),this.F(w,t,l)}}F(o,t,i){const n=(0,v.localize)(11,null,this.sb(t),(0,$.$mk)(o).toString());return o instanceof $.$vk?new $.$vk(n,o.stat,i):o instanceof $.$uk?new $.$uk(n,o.fileOperationResult,o.size,o.options):new $.$tk(n,(0,$.$pk)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,E.$$d)(r,{data:l=>l instanceof A.$be?l:A.$be.wrap(l),error:l=>this.F(l,t,n)},l=>A.$be.concat(l))}H(o,t,i,n=Object.create(null)){const r=(0,A.$re)();return(0,h.$Np)(o,t,r,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,t,n)},i),r}I(o,t,i){const n=(0,E.$2d)(r=>A.$be.concat(r));return(async()=>{try{let r;i?.atomic&&(0,$.$gk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(A.$be.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new $.$tk((0,v.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==$.$Dk&&t.etag===i.etag)throw new $.$vk((0,v.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new $.$uk((0,v.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),l=this.qb(await this.n(t),t);await this.Q(r,o,l,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"move",!!i),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$qk(o,l==="move"?2:3,P)),P}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"copy",!!i),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$qk(o,l==="copy"?3:2,P)),P}async N(o,t,i,n,r,l){if(t.toString()===n.toString())return r;const{exists:P,isSameResourceWithDifferentPathCase:y}=await this.Q(o,t,i,n,r,l);if(P&&!y&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,$.$ck)(o))await o.copy(t,n,{overwrite:l});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:l}),r):(await this.N(o,t,i,n,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,$.$ek)(o)&&(0,$.$ek)(i))return this.jb(o,t,i,n);if((0,$.$ek)(o)&&(0,$.$bk)(i))return this.pb(o,t,i,n);if((0,$.$bk)(o)&&(0,$.$ek)(i))return this.nb(o,t,i,n);if((0,$.$bk)(o)&&(0,$.$bk)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await R.Promises.settled(t.children.map(async r=>{const l=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,l):this.O(o,r.resource,i,l)}))}async Q(o,t,i,n,r,l){let P=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:O}=this.R(o);if(O||(P=w.isEqual(t,n)),P&&r==="copy")throw new Error((0,v.localize)(15,null,this.sb(t),this.sb(n)));if(!P&&w.isEqualOrParent(n,t))throw new Error((0,v.localize)(16,null,this.sb(t),this.sb(n)))}const y=await this.exists(n);if(y&&!P){if(!l)throw new $.$tk((0,v.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,v.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:y,isSameResourceWithDifferentPathCase:P}}R(o){const t=this.S(o);return{providerExtUri:t?d.$lg:d.$ng,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$qk(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&$.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(t)));break}catch(r){if((0,$.$ok)(r)!==$.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(l){if((0,$.$ok)(l)!==$.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,v.localize)(22,null,this.sb(o)));let l;try{l=await i.stat(o)}catch{}if(l)this.rb(o,l);else throw new $.$tk((0,v.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const y=await this.resolve(o);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,$.$ik)(i)&&!n?.atomic){const y=i.enforceAtomicDelete?.(o);y&&(n={...t,atomic:y})}const r=!!n?.useTrash,l=!!n?.recursive,P=n?.atomic??!1;await i.delete(o,{recursive:l,useTrash:r,atomic:P}),this.r.fire(new $.$qk(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,$.$dk)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,$.$ck)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:p.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new c.$Rc;let n=!1,r=()=>{n=!0};i.add((0,c.$Qc)(()=>r())),(async()=>{try{const P=await this.bb(o,t);n?(0,c.$Nc)(P):r=()=>(0,c.$Nc)(P)}catch(P){this.b.error(P)}})();const l=t.correlationId;if(typeof l=="number"){const P=i.add(new D.$Nd);return i.add(this.X.event(w=>{w.correlates(l)&&P.fire(w)})),{onDidChange:P.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,b.$Di)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,c.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Nc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Nc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,E.$Zd)(n)||(0,E.$1d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(l){throw(0,$.$mk)(l)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,E.$1d)(i)){if(i.buffer.length>0){const l=A.$be.concat(i.buffer);await this.gb(o,t,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,P)=>{(0,E.$6d)(r,{onData:async y=>{r.pause();try{await this.gb(o,t,y,y.byteLength,n,0)}catch(w){return P(w)}n+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>P(y),onEnd:()=>l()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,l){let P=0;for(;P<n;){const y=await o.write(t,r+P,i.buffer,l+P,n-P);P+=y}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof A.$be?r=n:(0,E.$Zd)(n)?r=await(0,A.$ne)(n):(0,E.$1d)(n)?r=await(0,A.$oe)(n):r=(0,A.$le)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,l;try{r=await o.open(t,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const P=A.$be.alloc(this.a);let y=0,w=0,O=0;do O=await o.read(r,y,P.buffer,w,P.byteLength-w),await this.gb(i,l,P,O,y,w),y+=O,w+=O,w===P.byteLength&&(w=0);while(O>0)}catch(P){throw(0,$.$mk)(P)}finally{await R.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await o.readFile(t);await this.gb(i,r,A.$be.wrap(l),l.byteLength,0,0)}catch(l){throw(0,$.$mk)(l)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,A.$ne)(this.H(o,t,j.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new $.$tk((0,v.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&$.FilePermission.Readonly)throw new $.$tk((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===N.Schemas.file?o.fsPath:o.toString(!0)}};e.$Op=k,e.$Op=k=p=pe([se(0,f.$0i)],k)}),define(ne[124],re([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E,v,$,h,f,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0,(()=>{try{(0,R.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,I.$Ai)(o)}`)}})();class s extends f.$Xp{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=b.Event.None,this.N=new j.$Ac(n=>g.$mg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,N.$l&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await E.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await E.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,g.$vg)(t,r.name))).type:l=this.M(r),n.push([r.name,l])}catch(l){this.a.trace(l)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=$.FileType.Unknown:t.isFile()?n=$.FileType.File:t.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new A.$Sg;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await E.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,d.$2d)(l=>D.$be.concat(l.map(P=>D.$be.wrap(P))).buffer);return(0,h.$Np)(this,t,r,l=>l.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,g.$vg)((0,g.$ug)(t),`${(0,g.$sg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await E.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const l=new c.$Rc;try{l.add(await this.O(t)),l.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(P){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{l.dispose()}}async S(t,i,n,r){let l;try{const P=this.H(t);if(!n.create||!n.overwrite){if(await E.Promises.exists(P)){if(!n.overwrite)throw(0,$.$lk)((0,v.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$lk)((0,v.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(l,0,i,0,i.byteLength)}catch(P){throw await this.gb(t,P)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let l;(0,$.$_j)(i)&&!n&&(l=await this.O(t));let P;try{if((0,$.$_j)(i)&&i.unlock)try{const{stat:w}=await E.SymlinkSupport.stat(r);w.mode&128||await E.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let y;if((0,$.$_j)(i)){if(N.$j)try{await E.Promises.truncate(r,0),y="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}y||(y="w")}else y="r";P=await E.Promises.open(r,y)}catch(y){throw l?.dispose(),(0,$.$_j)(i)?await this.gb(t,y):this.fb(y)}if(this.U.set(P,0),(0,$.$_j)(i)&&this.X.set(P,t),l){const y=this.W.get(P);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${r})`),this.W.set(P,l),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${r})`),y.dispose())}return P}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await E.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await E.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,l){const P=this.Z(t,i);let y=null;try{y=(await E.Promises.read(t,n,r,l,P)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,P,y)}return y}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,l){return(0,A.$_g)(()=>this.ab(t,i,n,r,l),100,3)}async ab(t,i,n,r,l){const P=this.Z(t,i);let y=null;try{y=(await E.Promises.write(t,n,r,l,P)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,P,y)}return y}async mkdir(t){try{await E.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,S.$jc)((0,S.$mc)(n),`${(0,S.$nc)(n)}${i.atomic.postfix}`)),await E.Promises.rm(n,E.RimRafMode.MOVE,r)}else try{await E.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:P,symbolicLink:y}=await E.SymlinkSupport.stat(n);l=P.isDirectory()&&!y}catch{}if(l)await E.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"move",n.overwrite),await E.Promises.rename(r,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,v.localize)(2,null,(0,S.$nc)(r),(0,S.$nc)((0,S.$mc)(l)),P.toString()))),this.fb(P)}}async copy(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"copy",n.overwrite),await E.Promises.copy(r,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,v.localize)(3,null,(0,S.$nc)(r),(0,S.$nc)((0,S.$mc)(l)),P.toString()))),this.fb(P)}}async bb(t,i,n,r){const l=this.H(t),P=this.H(i);let y=!1;if(!!(this.capabilities&1024)||(y=(0,u.$Wf)(l,P,!0)),y){if(n==="copy")throw(0,$.$lk)((0,v.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const O=await this.L(t);if(!O)throw(0,$.$lk)((0,v.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(i);if(H){if(!r)throw(0,$.$lk)((0,v.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);O.type&$.FileType.File&&H.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),l=this.H(i),P=!!(this.capabilities&1024);if((0,u.$Wf)(r,l,!P))return;const y=new c.$Rc;try{y.add(await this.O(t)),y.add(await this.O(i)),n&&await E.Promises.mkdir((0,S.$mc)(l),{recursive:!0}),await E.Promises.copyFile(r,l)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{y.dispose()}}t(t,i,n){return new p.$5p(r=>t(r),r=>i(r),n)}F(t,i,n){return new k.$aq(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof $.$kk)return t;let i=t,n;switch(t.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$lk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await E.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,$.$lk)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$bq=s}),define(ne[126],re([0,1,2,6]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;class A extends L.$Sc{constructor(D,b=[]){super(),this.a=new R.$hj([D,...b]),this.B(D.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...b){this.a.trace(D,...b)}debug(D,...b){this.a.debug(D,...b)}info(D,...b){this.a.info(D,...b)}warn(D,...b){this.a.warn(D,...b)}error(D,...b){this.a.error(D,...b)}flush(){this.a.flush()}}e.$EN=A}),define(ne[127],re([0,1,12,6]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=void 0;var A;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(A||(A={}));async function j(c,S,N,g,d){try{const E=await new Promise(($,h)=>{G(["@vscode/spdlog"],$,h)});E.setFlushOn(A.Trace);const v=await E.createAsyncRotatingLogger(c,S,N,g);return d?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(E){console.error(E)}return null}function D(c,S,N){switch(S){case R.LogLevel.Trace:c.trace(N);break;case R.LogLevel.Debug:c.debug(N);break;case R.LogLevel.Info:c.info(N);break;case R.LogLevel.Warning:c.warn(N);break;case R.LogLevel.Error:c.error(N);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function b(c,S){switch(S){case R.LogLevel.Trace:c.setLevel(A.Trace);break;case R.LogLevel.Debug:c.setLevel(A.Debug);break;case R.LogLevel.Info:c.setLevel(A.Info);break;case R.LogLevel.Warning:c.setLevel(A.Warning);break;case R.LogLevel.Error:c.setLevel(A.Error);break;case R.LogLevel.Off:c.setLevel(A.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class u extends R.$dj{constructor(S,N,g,d,E){super(),this.m=[],this.setLevel(E),this.n=this.s(S,N,g,d),this.B(this.onDidChangeLogLevel(v=>{this.r&&b(this.r,v)}))}async s(S,N,g,d){const E=g?6:1,v=30/E*L.$Gk.MB,$=await j(S,N,v,E,d);if($){this.r=$,b(this.r,this.getLevel());for(const{level:h,message:f}of this.m)D(this.r,h,f);this.m=[]}}g(S,N){this.r?D(this.r,S,N):this.getLevel()<=S&&this.m.push({level:S,message:N})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$tN=u}),define(ne[128],re([0,1,28,6,127]),function(G,e,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;class j extends R.$ij{s(b,u,c){return new A.$tN((0,L.$eg)(),b.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$uN=j}),define(ne[38],re([0,1,4,65,2,10]),function(G,e,L,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=void 0,e.$in=(0,j.$Ph)("policy");class D extends A.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const S=Object.keys(this.f).length;return this.f={...c,...this.f},S!==Object.keys(this.f).length&&await this.j(c),R.Iterable.reduce(this.g.entries(),(N,[g,d])=>({...N,[g]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(c,[S,N])=>({...c,[S]:{definition:N,value:this.g.get(S)}}),{})}}e.$jn=D;class b{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$kn=b}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(G,e,L,R,A,j,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=void 0;function c(N,g){const d=[];for(const E of new Set(A.Iterable.concat(N.keys(),g.keys())))N.get(E)!==g.get(E)&&d.push(E);return d}let S=class extends u.$jn{constructor(g,d,E){super(),this.m=g,this.n=d,this.s=E,this.c=this.B(new L.$Rg(500));const v=R.Event.filter(d.onDidFilesChange,$=>$.affects(g));this.B(d.watch(g)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const d=await this.n.readFile(this.m),E=JSON.parse(d.value.toString());if(!(0,j.$Af)(E))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(E))this.f[v]&&g.set(v,E[v])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return g}async w(){const g=await this.u(),d=c(this.g,g);this.g=g,d.length>0&&this.h.fire(d)}};e.$e8b=S,e.$e8b=S=pe([se(1,D.$$j),se(2,b.$0i)],S)}),define(ne[130],re([0,1,38,8,171,2,6]),function(G,e,L,R,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=void 0;let b=class extends L.$jn{constructor(c,S){super(),this.m=c,this.n=S,this.a=new R.$Ng,this.b=this.B(new j.$Tc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((S,N)=>{try{this.b.value=(0,A.createWatcher)(this.n,c,g=>{this.t(g),S()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),N(g)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const S in c){const N=c[S];N===void 0?this.g.delete(S):this.g.set(S,N)}this.h.fire(Object.keys(c))}};e.$d8b=b,e.$d8b=b=pe([se(0,D.$0i)],b)}),define(ne[32],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,L.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class A{constructor(){this.a=new Map}add(D,b){L.ok(R.$yf(D)),L.ok(R.$Af(b)),L.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,b)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$gn=new A}),define(ne[131],re([0,1,4,36]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function A(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class j{constructor(){this.b=new L.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[A(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const D=new j;R.$gn.add(e.$hn.JSONContribution,D)}),define(ne[43],re([0,1,19,4,3,88,25,131,36]),function(G,e,L,R,A,j,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var c;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$ln={Configuration:"base.contributions.configuration"};var S;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const N=u.$gn.as(b.$hn.JSONContribution);class g{constructor(){this.h=new Set,this.i=new R.$Nd,this.onDidSchemaChange=this.i.event,this.j=new R.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},N.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),N.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),N.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),N.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$vn.test(r)){const l=this.a.get(r),P=l?.valuesSources??new Map;if(n)for(const H of Object.keys(i[r]))P.set(H,n);const y={...l?.value||{},...i[r]};this.a.set(r,{source:n,value:y,valuesSources:P});const w=(0,D.$ti)(r),O={type:"object",default:y,description:j.localize(1,null,w),$ref:e.$sn,defaultDefaultValue:y,source:A.$yf(n)?void 0:n,defaultValueSource:n};t.push(...v(r)),this.d[r]=O,this.b.properties[r]=O}else{this.a.set(r,{value:i[r],source:n});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),l=A.$yf(i)?i:i?.id,P=A.$yf(r?.source)?r?.source:r?.source?.id;if(l===P)if(o.add(n),this.a.delete(n),e.$vn.test(n))delete this.d[n],delete this.b.properties[n];else{const y=this.d[n];y&&(this.w(n,y),this.r(n,y))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=A.$Hf(s.scope)?n:s.scope;const l=s.properties;if(l)for(const y in l){const w=l[y];if(o&&I(y,w)){delete l[y];continue}if(w.source=t,w.defaultDefaultValue=l[y].default,this.w(y,w),e.$vn.test(y)?w.scope=void 0:(w.scope=A.$Hf(w.scope)?n:w.scope,w.restricted=A.$Hf(w.restricted)?!!i?.includes(y):w.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.f[y]=l[y],delete l[y];continue}else this.d[y]=l[y],l[y].policy?.name&&this.e.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),r.add(y)}const P=s.allOf;if(P)for(const y of P)this.p(y,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$mn.properties[s]=o,o.scope){case 1:e.$nn.properties[s]=o;break;case 2:e.$on.properties[s]=o;break;case 6:e.$pn.properties[s]=o;break;case 3:e.$qn.properties[s]=o;break;case 4:e.$rn.properties[s]=o;break;case 5:e.$rn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$mn.properties[s],o.scope){case 1:delete e.$nn.properties[s];break;case 2:delete e.$on.properties[s];break;case 6:delete e.$pn.properties[s];break;case 3:delete e.$qn.properties[s];break;case 4:case 5:delete e.$rn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$sn};this.w(o,t),e.$mn.properties[o]=t,e.$nn.properties[o]=t,e.$on.properties[o]=t,e.$pn.properties[o]=t,e.$qn.properties[o]=t,e.$rn.properties[o]=t}}v(){const s={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=s,e.$nn.patternProperties[e.$un]=s,e.$on.patternProperties[e.$un]=s,e.$pn.patternProperties[e.$un]=s,e.$qn.patternProperties[e.$un]=s,e.$rn.patternProperties[e.$un]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;A.$Ff(i)&&(i=o.defaultDefaultValue,n=void 0),A.$Ff(i)&&(i=h(o.type)),o.default=i,o.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",E=new RegExp(d,"g");e.$un=`^(${d})+$`,e.$vn=new RegExp(e.$un);function v(k){const s=[];if(e.$vn.test(k)){let o=E.exec(k);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=E.exec(k)}}return(0,L.$Mb)(s)}e.$wn=v;function $(k){return k.reduce((s,o)=>`${s}[${o}]`,"")}e.$xn=$;function h(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=h;const f=new g;u.$gn.add(e.$ln.Configuration,f);function I(k,s){return k.trim()?e.$vn.test(k)?j.localize(7,null,k):f.getConfigurationProperties()[k]!==void 0?j.localize(8,null,k):s.policy?.name&&f.getPolicyConfigurations().get(s.policy?.name)!==void 0?j.localize(9,null,k,s.policy?.name,f.getPolicyConfigurations().get(s.policy?.name)):null:j.localize(6,null)}e.$zn=I;function p(){const k=[],s=f.getConfigurationProperties();for(const o of Object.keys(s))k.push([o,s[o].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.$An=p}),define(ne[66],re([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(G,e,L,R,A,j,D,b,u,c,S,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function d(o){return Object.isFrozen(o)?o:b.$8m(o)}class E{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof E)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,S.$ri)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:l}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,S.$ri)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=b.$7m(this.contents),n=b.$7m(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const P of t)if(l.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(i,P.contents);for(const y of P.overrides){const[w]=n.filter(O=>L.$ub(O.identifiers,y.identifiers));w?(this.h(w.contents,y.contents),w.keys.push(...y.keys),w.keys=L.$Mb(w.keys)):n.push(b.$7m(y))}for(const y of P.keys)r.indexOf(y)===-1&&r.push(y)}return new E(i,r,n,l.every(P=>P instanceof E)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r];const P=i[r];P&&(typeof l=="object"&&typeof P=="object"?(l=b.$7m(l),this.h(l,P)):l=P),n[r]=l}return new E(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&u.$Af(t[n])&&u.$Af(i[n])){this.h(t[n],i[n]);continue}t[n]=b.$7m(i[n])}}i(t){let i=null,n=null;const r=l=>{l&&(n?this.h(n,l):n=b.$7m(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?i=l.contents:l.identifiers.includes(t)&&r(l.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,S.$qi)(this.contents,t),N.$vn.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$ub(n.identifiers,(0,N.$wn)(t))),1))}j(t,i,n){(0,S.$pi)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),N.$vn.test(t)&&this.overrides.push({identifiers:(0,N.$wn)(t),keys:Object.keys(this.contents[t]),contents:(0,S.$oi)(this.contents[t],r=>console.error(r))})}}e.$Bn=E;class v{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!u.$Hf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:l,restricted:P,hasExcludedProperties:y}=this.h(t,i);this.b=new E(n,r,l,y?[t]:void 0),this.c=P||[]}g(t){let i={},n=null,r=[];const l=[],P=[];function y(O){Array.isArray(r)?r.push(O):n!==null&&(r[n]=O)}const w={onObjectBegin:()=>{const O={};y(O),l.push(r),r=O,n=null},onObjectProperty:O=>{n=O},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const O=[];y(O),l.push(r),r=O,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:y,onError:(O,H,_)=>{P.push({error:O,offset:H,length:_})}};if(t)try{A.$4m(t,w),i=r[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}h(t,i){const n=g.$gn.as(N.$ln.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const l=(0,S.$oi)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),P=Object.keys(t),y=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:l,keys:P,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const P={},y=[];for(const w in t)if(N.$vn.test(w)&&n){const O=this.i(t[w],i,!1,r);P[w]=O.raw,l=l||O.hasExcludedProperties,y.push(...O.restricted)}else{const O=i[w],H=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&y.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&O?.restricted))?P[w]=t[w]:l=!0}return{raw:P,restricted:y,hasExcludedProperties:l}}j(t,i){const n=[];for(const r of Object.keys(t))if(N.$vn.test(r)){const l={};for(const P in t[r])l[P]=t[r][P];n.push({identifiers:(0,N.$wn)(r),keys:Object.keys(l),contents:(0,S.$oi)(l,i)})}return n}}e.$Cn=v;class $ extends j.$Sc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new R.$Nd),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new E}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=$;class h{constructor(t,i,n,r,l,P,y,w,O,H,_,x,ue){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=l,this.f=P,this.g=y,this.h=w,this.i=O,this.j=H,this.k=_,this.l=x,this.m=ue}get value(){return d(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(t,i,n,r,l=new E,P=new E,y=new D.$Ac,w=new E,O=new D.$Ac){this.c=t,this.d=i,this.f=n,this.g=r,this.h=l,this.i=P,this.j=y,this.l=w,this.m=O,this.a=null,this.b=new D.$Ac,this.n=null}getValue(t,i,n){return this.q(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new E,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.q(t,i,n),l=this.u(i.resource,n),P=i.resource?this.m.get(i.resource)||this.l:this.l,y=new Set;for(const w of r.overrides)for(const O of w.identifiers)r.getOverrideValue(t,O)!==void 0&&y.add(O);return new h(t,i,r.getValue(t),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,P)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:l,removed:P}=k(this.c,t);i=[...r,...l,...P]}for(const r of i)for(const l of(0,N.$wn)(r)){const P=this.c.getKeysForOverrideIdentifier(l),y=t.getKeysForOverrideIdentifier(l),w=[...y.filter(O=>P.indexOf(O)===-1),...P.filter(O=>y.indexOf(O)===-1),...P.filter(O=>!b.$$m(this.c.override(l).getValue(O),t.override(l).getValue(O)))];n.push([l,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=k(this.d,t),l=[...i,...n,...r];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=k(this.applicationConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateApplicationConfiguration(t),{keys:P,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=k(this.localUserConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateLocalUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=k(this.remoteUserConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateRemoteUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=k(this.workspaceConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateWorkspaceConfiguration(t),{keys:P,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const n=this.p.get(t),{added:r,updated:l,removed:P,overrides:y}=k(n,i),w=[...r,...l,...P];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:y}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:P}=k(i,void 0);return{keys:[...n,...r,...l],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,n){let r=this.r(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}r({resource:t},i){let n=this.s();if(i&&t){const r=i.getFolder(t);r&&(n=this.t(r.uri)||n);const l=this.m.get(t);l&&(n=n.merge(l))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const n=this.s(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}u(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:l}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.x(t.defaults),n=this.x(t.policy),r=this.x(t.application),l=this.x(t.user),P=this.x(t.workspace),y=t.folders.reduce((w,O)=>(w.set(c.URI.revive(O[0]),this.x(O[1])),w),new D.$Ac);return new f(i,n,r,l,new E,P,y,new E,new D.$Ac)}static x(t){return new E(t.contents,t.keys,t.overrides)}}e.$En=f;function I(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,P])=>{const y=(0,D.$xc)(i,l,new Set);P.forEach(w=>y.add(w))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Fn=I;class p{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const P of l)this.affectedKeys.add(P);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const l=r+n.length;if(l>=this.d.length)return!1;const P=this.d.charCodeAt(l);if(P!==this.b&&P!==this.c)return!1;if(i){const y=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!b.$$m(y,w)}return!0}}e.$Gn=p;function k(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),l=[],P=o?.getAllOverrideIdentifiers()||[],y=t?.getAllOverrideIdentifiers()||[];if(t){const w=y.filter(O=>!P.includes(O));for(const O of w)l.push([O,t.getKeysForOverrideIdentifier(O)])}if(o){const w=P.filter(O=>!y.includes(O));for(const O of w)l.push([O,o.getKeysForOverrideIdentifier(O)])}if(t&&o){for(const w of P)if(y.includes(w)){const O=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});l.push([w,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:n,updated:r,overrides:l}}function s(o,t){const i=o?t?o.keys.filter(l=>t.keys.indexOf(l)===-1):[...o.keys]:[],n=t?o?t.keys.filter(l=>o.keys.indexOf(l)===-1):[...t.keys]:[],r=[];if(o&&t){for(const l of t.keys)if(o.keys.indexOf(l)!==-1){const P=(0,S.$ri)(t.contents,l),y=(0,S.$ri)(o.contents,l);b.$$m(P,y)||r.push(l)}}return{added:i,removed:n,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,43,6,38,36]),function(G,e,L,R,A,j,D,b,u,c,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=void 0;class g extends A.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Bn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(N.$gn.as(u.$ln.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,N.$gn.as(u.$ln.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new b.$Bn;const $=N.$gn.as(u.$ln.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const f=this.f();for(const I of $){const p=f[I],k=h[I];p!==void 0?this.b.addValue(I,p):k?this.b.addValue(I,k.default):this.b.removeValue(I)}}}e.$Hn=g;class d{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new b.$Bn}async initialize(){return this.configurationModel}}e.$In=d;let E=class extends A.$Sc{get configurationModel(){return this.b}constructor($,h,f){super(),this.c=$,this.f=h,this.g=f,this.a=this.B(new R.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Bn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},f=[],I=N.$gn.as(u.$ln.Configuration).getConfigurationProperties();for(const p of $){const k=I[p];if(!k){f.push(p);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}f.push(p),h[k.policy.name]={type:k.type}}}return(0,D.$Lf)(h)||await this.f.updatePolicyDefinitions(h),f}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=N.$gn.as(u.$ln.Configuration).getPolicyConfigurations(),f=(0,L.$Hb)($.map(I=>h.get(I)));this.m(f,!0)}m($,h){this.g.trace("PolicyConfiguration#update",$);const f=N.$gn.as(u.$ln.Configuration).getConfigurationProperties(),I=[],p=this.b.isEmpty();for(const k of $){const s=f[k]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(p?o!==void 0:!(0,j.$$m)(this.b.getValue(k),o))&&I.push([k,o])}else this.b.getValue(k)!==void 0&&I.push([k,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const k=this.b;this.b=new b.$Bn;for(const s of k.keys)this.b.setValue(s,k.getValue(s));for(const[s,o]of I)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);h&&this.a.fire(this.b)}}};e.$Jn=E,e.$Jn=E=pe([se(1,S.$in),se(2,c.$0i)],E)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(G,e,L,R,A,j,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class S extends A.$Sc{constructor(g,d,E,v){super(),this.j=g,this.h=this.B(new R.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$Hn),this.c=E instanceof c.$kn?new u.$In:this.B(new u.$Jn(this.b,E,v)),this.f=this.B(new b.$Dn(this.j,{},j.$mg,d)),this.a=new b.$En(this.b.configurationModel,this.c.configurationModel,new b.$Bn,new b.$Bn),this.g=this.B(new L.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.n($,h))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,d,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.$En(g,d,new b.$Bn,E)}getConfigurationData(){return this.a.toData()}getValue(g,d){const E=typeof g=="string"?g:void 0,v=(0,D.$ki)(g)?g:(0,D.$ki)(d)?d:{};return this.a.getValue(E,v,void 0)}updateValue(g,d,E,v){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.m(g)}m(g){const d=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(g);this.s(E,d,2)}n(g,d){const E=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(g,d);this.s(v,E,7)}r(g){const d=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(g);this.s(E,d,7)}s(g,d,E){const v=new b.$Gn(g,{data:d},this.a);v.source=E,v.sourceConfig=this.t(E),this.h.fire(v)}t(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Kn=S}),define(ne[67],re([0,1,15]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function R(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$Uk=R;function A(c){if(!c)return;const S=c.indexOf("+");return S<0?c:c.substr(0,S)}e.$Vk=A;function j(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Wk=j;function D(c){const{host:S,port:N}=u(c);if(typeof N>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:N}}e.$Xk=D;function b(c,S){let{host:N,port:g}=u(c);return typeof g>"u"&&(g=S),{host:N,port:g}}e.$Yk=b;function u(c){const S=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const N=c.match(/^(\[[0-9a-z:]+\])$/);if(N)return{host:N[1],port:void 0};const g=c.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(G,e,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function j(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$4l=j,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(D||(e.ExtensionType=D={}));var b;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const f=typeof $=="string"?$:$.value,I=typeof h=="string"?h:h.value;return L.$2e(f,I)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$6l=u;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$7l=c;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=S;function N(v){return g(v)}e.$9l=N;function g(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$0l=g;function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$$l=d;function E(v,$){if($){const h=`onResolveRemoteAuthority:${(0,A.$Vk)($)}`;return!!v.activationEvents?.includes(h)}return!1}e.$_l=E,e.$am=(0,R.$Ph)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(G,e,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;class j extends L.$Sc{constructor(b,u,c,S,N){super(),this.a=b,this.b=u,this.c=c,this.f=N,this.B(S.onDidInstallExtensions(g=>this.g(g))),this.B(S.onDidUninstallExtension(g=>this.h(g)))}g(b){for(const u of b)u.local&&this.invalidate(u.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,b)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,R.$Zl))}catch(u){(0,A.$pk)(u)!==1&&this.f.error(u)}}}e.$Hp=j}),define(ne[44],re([0,1,14,9,2,103,43,10,6,36]),function(G,e,L,R,A,j,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$To=(0,b.$Ph)("requestService");class S{constructor(k){this.b=k}toJSON(){if(!this.a){const k=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?k[s]="*****":k[s]=this.b[s];this.a=k}return this.a}}class N extends A.$Sc{constructor(k){super(),this.b=0,this.a=k.createLogger("network",{name:(0,j.localize)(0,null),when:u.$oj.isEqualTo((0,u.$mj)(u.LogLevel.Trace)).serialize()})}async c(k,s,o){const t=`${k} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new S(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,R.$0)(i)),i}}}e.$Uo=N;function g(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Vo=g;function d(p){return p.res.statusCode===204}e.$Wo=d;async function E(p){return d(p)?null:(await(0,L.$ne)(p.stream)).toString()}e.$Xo=E;async function v(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);return E(p)}e.$Yo=v;async function $(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const s=(await(0,L.$ne)(p.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$Zo=$;function h(p){I(p)}e.$1o=h;let f;function I(p){const k=c.$gn.as(D.$ln.Configuration),s=f;f={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},k.updateConfigurations({add:[f],remove:s?[s]:[]})}I(1)}),define(ne[135],re([0,1,20,15,12,44]),function(G,e,L,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;let D=class{constructor(u,c){this.a=u,this.b=c}async download(u,c,S=L.CancellationToken.None){if(u.scheme===R.Schemas.file||u.scheme===R.Schemas.vscodeRemote){await this.b.copy(u,c);return}const N={type:"GET",url:u.toString(!0)},g=await this.a.request(N,S);if(g.res.statusCode===200)await this.b.writeFile(c,g.stream);else{const d=await(0,j.$Yo)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${d}`)}}};e.$TN=D,e.$TN=D=pe([se(0,j.$To),se(1,A.$$j)],D)}),define(ne[136],re([0,1,137,3]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;function A(D,b){return D.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:D.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function j(D,b,u={}){const c=(0,L.parse)(D),S=u.proxyUrl||A(c,b);if(!S)return null;const N=(0,L.parse)(S);if(!/^https?:$/.test(N.protocol||""))return null;const g={host:N.hostname||"",port:(N.port?+N.port:0)||(N.protocol==="https"?443:80),auth:N.auth,rejectUnauthorized:(0,R.$Ef)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,E)=>{G(["http-proxy-agent"],d,E)})).HttpProxyAgent(S,g):new(await new Promise((d,E)=>{G(["https-proxy-agent"],d,E)})).HttpsProxyAgent(S,g)}e.$Yq=j}),define(ne[138],re([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=void 0;let E;async function v(h,f,I,p){return I["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$j?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,N.$Nl)(p)&&!I["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,N.$Nl)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=g.Promises.withAsyncBody(async(k,s)=>{const o=new j.$Xd;let t=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,d.$Ol)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,A.localize)(0,null)))},t);try{k(await $(f,o.token))}catch(r){!(0,b.$4)(r)&&!o.token.isCancellationRequested?s(new Error((0,A.localize)(1,null,(0,D.$Ai)(r)))):k({})}finally{clearTimeout(n),o.dispose()}})),E)}e.$Tl=v;async function $(h,f){const I=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",I);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const k=(0,c.$eg)().replace(/-/g,"").substr(0,12),s=new RegExp(k+"({.*})"+k),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",o);const t=await(0,S.$Dl)(u.OS,o);return h.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if(f.isCancellationRequested)return n(new b.$5);const r=(0,R.$nc)(t);let l,P;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${y} -p '''${k}'' + JSON.stringify(process.env) + ''${k}'''`,P=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${y} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,P=["-i","-l","-c"]):(l=`'${process.execPath}' ${y} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,r==="tcsh"||r==="csh"?P=["-ic"]:P=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const w=(0,L.spawn)(t,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(w.kill(),n(new b.$5))),w.on("error",_=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,D.$Ai)(_)),n(_)});const O=[];w.stdout.on("data",_=>O.push(_));const H=[];w.stderr.on("data",_=>H.push(_)),w.on("close",(_,x)=>{const ue=Buffer.concat(O).toString("utf8");h.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat(H).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),_||x)return n(new Error((0,A.localize)(2,null,_,x)));const ae=s.exec(ue),le=ae?ae[1]:"{}";try{const ie=JSON.parse(le);I?ie.ELECTRON_RUN_AS_NODE=I:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),i(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,D.$Ai)(ie)),n(ie)}})})}}),define(ne[139],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0,e.$vN=(0,L.$Ph)("stateReadService"),e.$wN=(0,L.$Ph)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(G,e,L,R,A,j,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=e.$xN=e.SaveStrategy=void 0;var c;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class S extends A.$Sc{constructor(E,v,$,h){super(),this.h=E,this.j=$,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=v===0?void 0:this.B(new L.$Rg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(E){E.fileOperationResult!==1&&this.j.error(E)}}getItem(E,v){const $=this.a[E];return(0,j.$Hf)($)?v:$}setItem(E,v){this.setItems([{key:E,data:v}])}setItems(E){let v=!1;for(const{key:$,data:h}of E)this.a[$]!==h&&((0,j.$Hf)(h)?(0,j.$Ff)(this.a[$])||(this.a[$]=void 0,v=!0):(this.a[$]=h,v=!0));v&&this.r()}removeItem(E){(0,j.$Ff)(this.a[E])||(this.a[E]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const E=JSON.stringify(this.a,null,4);if(E!==this.b)try{await this.m.writeFile(this.h,R.$be.fromString(E),{atomic:{postfix:".vsctmp"}}),this.b=E}catch(v){this.j.error(v)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$xN=S;let N=class extends A.$Sc{constructor(E,v,$,h){super(),this.a=this.B(new S(v.stateResource,E,$,h))}async init(){await this.a.init()}getItem(E,v){return this.a.getItem(E,v)}};e.$yN=N,e.$yN=N=pe([se(1,D.$Wh),se(2,u.$0i),se(3,b.$$j)],N);class g extends N{setItem(E,v){this.a.setItem(E,v)}setItems(E){this.a.setItems(E)}removeItem(E){this.a.removeItem(E)}close(){return this.a.close()}}e.$zN=g}),define(ne[69],re([0,1,13,35,28]),function(G,e,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=void 0;function j(u){if(L.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function D(u,c,S,N,g,d,E,v,$){const h=Object.create(null);h["common.machineId"]=d,h["common.sqmId"]=E,h.sessionID=(0,A.$eg)()+Date.now(),h.commitHash=N,h.version=g,h["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,L.$i)(L.$u),h["common.nodePlatform"]=R.$dc,h["common.nodeArch"]=S,h["common.product"]=$||"desktop",v&&(h["common.msftInternal"]=v);let f=0;const I=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),L.$m&&(h["common.snap"]="true");const p=j(c);return p&&(h["common.platformDetail"]=p),h}e.$io=D;function b(u){const c=R.env.USERDNSDOMAIN;if(!c)return!1;const S=c.toLowerCase();return u.some(N=>S===N)}e.$jo=b}),define(ne[26],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,L.$Ph)("telemetryService"),e.$dl=(0,L.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var R;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var A;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(G,e,L,R,A,j,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$ko=c;class S{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$lo=S,e.$mo=new S;class N{async publicLog(n,r,l){}async publicLogError(n,r,l){}}e.$no=N,e.$oo="telemetry",e.$po="extensionTelemetryLog",e.$qo={log:()=>null,flush:()=>Promise.resolve(null)};function g(i,n){return A.Event.debounce(n.onDidChangeConfiguration,(l,P)=>{const y=l?new Set([...l.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:y}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,j.$mi)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$ro=g;function d(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$so=d;function E(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$to=E;function v(i){const n=i.getValue(u.$kl),r=i.getValue(u.$ll);if(i.getValue(u.$ml)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$uo=v;function $(i){const n={},r={},l={};I(i,l);for(let P in l){P=P.length>150?P.substr(P.length-149):P;const y=l[P];typeof y=="number"?r[P]=y:typeof y=="boolean"?r[P]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${y.length}`),n[P]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(n[P]=y)}return{properties:n,measurements:r}}e.$vo=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(i){if(!i)return"none";const n=(0,D.$Vk)(i);return h.has(n)?n:"other"}e.$wo=f;function I(i,n,r=0,l){if(i)for(const P of Object.getOwnPropertyNames(i)){const y=i[P],w=l?l+P:P;Array.isArray(y)?n[w]=(0,L.$_m)(y):y instanceof Date?n[w]=y.toISOString():(0,R.$Af)(y)?r<2?I(y,n,r+1,w+"."):n[w]=(0,L.$_m)(y):n[w]=y}}function p(i,n){const r=i.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,b.$jo)(r)||l}e.$xo=p;function k(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$yo=k;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const l=[];for(const O of n)for(;;){const H=O.exec(i);if(!H)break;l.push([H.index,O.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const O=y.exec(i);if(!O)break;const H=l.some(([_,x])=>O.index<x&&_<y.lastIndex);!P.test(O[0])&&!H&&(r+=i.substring(w,O.index)+"<REDACTED: user-file-path>",w=y.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$9m)(i,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=s(l,n);for(const P of n)l=l.replace(P,"");return l=o(l),l}})}e.$zo=t}),define(ne[27],re([0,1,29,21,37,13,11,9,35,39]),function(G,e,L,R,A,j,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;function S(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$We)(t.id,i.id)===0}e.$Ao=S;const N=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new g(i.identifier,n,r)}static parse(i){const n=N.exec(i);return n&&n[1]&&n[2]?new g({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof g?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Bo=g;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(t){const i=d.exec(t);return i&&i[1]?[$(i[1]),i[2]]:[$(t),void 0]}e.$Co=E;function v(t,i){return`${t}.${i}`}e.$Do=v;function $(t){return t.toLowerCase()}e.$Eo=$;function h(t,i){return $(v(t??A.$2l,i))}e.$Fo=h;function f(t,i){const n=[],r=l=>{for(const P of n)if(P.some(y=>S(i(y),i(l))))return P;return null};for(const l of t){const P=r(l);P?P.push(l):n.push([l])}return n}e.$Go=f;function I(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Ho=I;function p(t){return{id:new c.$ko(t.identifier.id),name:new c.$ko(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Io=p,e.$Jo=new A.$6l("pprice.better-merge");function k(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&n.every(P=>!S(P.identifier,{id:l}))){const P=t.filter(y=>S(y.identifier,{id:l}));P.length===1&&(n.push(P[0]),r.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Ko=k;async function s(t,i){if(!j.$l)return!1;let n;try{n=(await t.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,b.$0)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,R.$6n)(n?"alpine":j.$u,u.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$Lo=o}),define(ne[140],re([0,1,20,9,15,17,42,11,93,21,27,37]),function(G,e,L,R,A,j,D,b,u,c,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=void 0;const g=$=>(0,u.localize)(0,null,$),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function E($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let v=class{constructor(h,f,I){this.a=h,this.b=f,this.d=I}get f(){}async listExtensions(h,f,I){let p=await this.b.getInstalled(1,I);const k=N.$5l.map(o=>o.toLowerCase());if(f&&f!==""){if(k.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),k.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let s;for(const o of p)s!==o.identifier.id&&(s=o.identifier.id,this.a.info(E(o.manifest,h)))}async installExtensions(h,f,I,p){const k=[];try{const s=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const o=[];let t=[];const i=(r,l,P)=>{t.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...I,isBuiltin:P,installPreReleaseVersion:l==="prerelease"||I.installPreReleaseVersion}})};for(const r of h)if(r instanceof b.URI)o.push({vsix:r,installOptions:I});else{const[l,P]=(0,S.$Co)(r);i(l,P,!1)}for(const r of f)if(r instanceof b.URI)o.push({vsix:r,installOptions:{...I,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,P]=(0,S.$Co)(r);i(l,P,!0)}const n=await this.b.getInstalled(1,I.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:l})=>{try{const P=await this.g(r,l,p,n);P&&s.push(P)}catch(P){this.a.error(P),k.push(r.toString())}})),t.length&&(t=t.filter(({id:r,version:l})=>{const P=n.find(y=>(0,S.$Ao)(y.identifier,{id:r}));if(P){if(!p&&(!l||l==="prerelease"&&P.preRelease))return this.a.info((0,u.localize)(5,null,r,P.manifest.version,r)),!1;if(l&&P.manifest.version===l)return this.a.info((0,u.localize)(6,null,`${r}@${l}`)),!1}return!0}),t.length)){const r=await this.h(t);await Promise.all(t.map(async l=>{const P=r.get(l.id.toLowerCase());if(P)try{const y=await this.j(l,P,n);y&&s.push(y)}catch(y){this.a.error(y.message||y.stack||y),k.push(l.id)}else this.a.error(`${g(l.version?`${l.id}@${l.version}`:l.id)}
${d}`),k.push(l.id)}))}}catch(s){throw this.a.error((0,u.localize)(7,null,(0,R.$0)(s))),s}if(k.length)throw new Error((0,u.localize)(8,null,k.join(", ")))}async g(h,f,I,p){const k=await this.b.getManifest(h);if(!k)throw new Error("Invalid vsix");if(await this.l(k,I,f.profileLocation,p))try{return await this.b.install(h,f),this.a.info((0,u.localize)(9,null,(0,j.$sg)(h))),k}catch(o){if((0,R.$4)(o))return this.a.info((0,u.localize)(10,null,(0,j.$sg)(h))),null;throw o}return null}async h(h){const f=new Map,I=h.some(s=>s.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),k=[];for(const s of h)c.$Yn.test(s.id)&&k.push({...s,preRelease:I});if(k.length){const s=await this.d.getExtensions(k,{targetPlatform:p},L.CancellationToken.None);for(const o of s)f.set(o.identifier.id.toLowerCase(),o)}return f}async j({id:h,version:f,installOptions:I},p,k){const s=await this.d.getManifest(p,L.CancellationToken.None);if(s&&!this.k(s))return null;const o=k.find(t=>(0,S.$Ao)(t.identifier,p.identifier));if(o){if(p.version===o.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.a.info((0,u.localize)(12,null,h,p.version))}try{I.isBuiltin?this.a.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.a.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const t=await this.b.installFromGallery(p,{...I,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,h,t.manifest.version)),s}catch(t){if((0,R.$4)(t))return this.a.info((0,u.localize)(18,null,h)),null;throw t}}k(h){return!0}async l(h,f,I,p){if(!f){const k={id:(0,S.$Fo)(h.publisher,h.name)},s=p.find(o=>(0,S.$Ao)(k,o.identifier)&&(0,D.gt)(o.manifest.version,h.version));if(s)return this.a.info((0,u.localize)(19,null,s.identifier.id,s.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,f,I){const p=async s=>{if(s instanceof b.URI){const o=await this.b.getManifest(s);return E(o)}return s},k=[];for(const s of h){const o=await p(s),i=(await this.b.getInstalled(void 0,I)).filter(n=>(0,S.$Ao)(n.identifier,{id:o}));if(!i.length)throw new Error(`${this.m(o)}
${d}`);if(i.some(n=>n.type===0)){this.a.info((0,u.localize)(20,null,o));return}if(!f&&i.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(21,null,o));return}this.a.info((0,u.localize)(22,null,o));for(const n of i)await this.b.uninstall(n,{profileLocation:I}),k.push(n);this.f?this.a.info((0,u.localize)(23,null,o,this.f)):this.a.info((0,u.localize)(24,null,o))}}async locateExtension(h){const f=await this.b.getInstalled();h.forEach(I=>{f.forEach(p=>{if(p.identifier.id===I&&p.location.scheme===A.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$hp=v,e.$hp=v=pe([se(1,c.$ao),se(2,c.$$n)],v)}),define(ne[141],re([0,1,4,2,31,27,37]),function(G,e,L,R,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;class b extends R.$Sc{constructor(c,S,N,g,d,E,v){super(),this.f=c,this.g=S,this.h=N,this.j=g,this.m=d,this.n=E,this.r=v,this.a=this.B(new L.$Nd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.$1c),this.s().then(null,$=>v.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(S=>(this.c.set(S.id,(0,R.$Pc)(this.n.watch(this.m.extUri.dirname(S.extensionsResource)),this.n.watch(S.extensionsResource))),this.G(S.extensionsResource))))}catch(S){throw this.r.error(S),S}}async w(c){for(const S of c.extensions)this.I(this.L(S.identifier,S.version),c.profileLocation)}async y(c){for(const S of c.extensions){const N=this.L(S.identifier,S.version);c.error?this.J(N,c.profileLocation):this.I(N,c.profileLocation)}}async z(c){for(const S of c.extensions)this.J(this.L(S.identifier,S.version),c.profileLocation)}async C(c){const S=[],N=[];for(const g of c.extensions){const d=this.L(g.identifier,g.version);c.error?this.I(d,c.profileLocation):(this.J(d,c.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),N.push(this.f.scanInstalledExtensionAtLocation(g.location).then(E=>{E?S.push(E):this.r.info("Extension not found at the location",g.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(N),S.length&&await this.H(S)}catch(g){this.r.error(g)}}D(c){for(const S of this.h.profiles)c.contains(S.extensionsResource,0,1)&&this.F(S.extensionsResource)}async F(c){const S=[],N=[],g=await this.j.scanProfileExtensions(c),d=new Set,E=new Set;for(const[v,$]of this.b)$.has(c)&&E.add(v);for(const v of g){const $=this.L(v.identifier,v.version);d.add($),E.has($)||(S.push(v.identifier),this.I($,c))}for(const v of E)if(!d.has(v)){const $=this.M(v);$&&(N.push($.identifier),this.J(v,c))}(S.length||N.length)&&this.a.fire({added:S.length?{extensions:S,profileLocation:c}:void 0,removed:N.length?{extensions:N,profileLocation:c}:void 0})}async G(c){const S=await this.j.scanProfileExtensions(c);for(const N of S)this.I(this.L(N.identifier,N.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(N=>!this.b.has(this.L(N.identifier,N.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,S){let N=this.b.get(c);N||this.b.set(c,N=new A.$Bc(g=>this.m.extUri.getComparisonKey(g))),N.add(S)}J(c,S){const N=this.b.get(c);N&&N.delete(S),N?.size||this.b.delete(c)}L(c,S){return`${D.$6l.toKey(c.id)}@${S}`}M(c){const[S,N]=(0,j.$Co)(c);return N?{identifier:{id:S},version:N}:void 0}}e.$Ip=b}),define(ne[142],re([0,1,113,39]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=void 0;async function A(j,D,b,u,c,S,N){const g={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${D.nameShort})`};if((0,R.$so)(D,b)&&(0,R.$uo)(u)===3){const d=await(0,L.$ap)(b,c,S);g["X-Market-User-Id"]=d,g["VSCode-SessionId"]=N.machineId||d}return g}e.$bp=A}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let v=class extends d.$Uq{constructor(I,p,k,s){super(k),this.h=I,this.j=s,this.g=this.B(new $(p,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(I,p){const s=(await this.g.getLanguagePacks())[p];if(!s){this.j.warn(`No language pack found for ${p}`);return}const o=s.translations[I];return o?E.URI.file(o):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),p=Object.keys(I).map(k=>{const s=I[k];return{...this.f(k,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((k,s)=>k.label.localeCompare(s.label)),p}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const p=await this.g.getLanguagePacks();Object.keys(p).some(k=>p[k]&&p[k].extensions.some(s=>(0,N.$Ao)(s.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),k=await this.g.update(p);return!(0,R.$ub)(Object.keys(I),Object.keys(k))}};e.$Vq=v,e.$Vq=v=pe([se(0,S.$ao),se(1,c.$Xh),se(2,S.$$n),se(3,g.$0i)],v);let $=class extends j.$Sc{constructor(I,p){super(),this.j=p,this.c={},this.f=(0,b.$jc)(I.userDataPath,"languagepacks.json"),this.g=new A.$1g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(p=>{Object.keys(p).forEach(k=>delete p[k]),this.m(p,...I)}).then(()=>this.c)}m(I,...p){for(const k of p)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.n(I,k);Object.keys(I).forEach(k=>this.r(I[k]))}n(I,p){const k=p.identifier,s=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of s)if(p.location.scheme===D.Schemas.file&&h(o)){let t=I[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},I[o.languageId]=t);const i=t.extensions.filter(n=>(0,N.$Ao)(n.extensionIdentifier,k))[0];i?i.version=p.manifest.version:t.extensions.push({extensionIdentifier:k,version:p.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,b.$jc)(p.location.fsPath,n.path)}}r(I){if(I){const p=(0,L.createHash)("md5");for(const k of I.extensions)p.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);I.hash=p.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(p=I(k),k)).then(k=>{for(const o of Object.keys(k))k[o]||delete k[o];this.c=k,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),u.Promises.writeFile(this.f,s)}).then(()=>p,k=>this.j.error(k))})}};$=pe([se(0,c.$Xh),se(1,g.$0i)],$);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const I of f.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,81,9,30,39]),function(G,e,L,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",b="https://mobile.events.data.microsoft.com/ping";async function u(S,N,g){const d=await(0,L.$mC)("@microsoft/1ds-core-js","dist/ms.core.js"),E=await(0,L.$mC)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new d.AppInsightsCore,$=new E.PostChannel,h={instrumentationKey:S,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(g){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:g};h.extensionConfig[$.identifier]=f}return v.initialize(h,[]),v.addTelemetryInitializer(f=>{N&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),v}class c{constructor(N,g,d,E,v){this.e=N,this.f=g,this.g=d,this.h=v,this.c=D,this.d=b,this.g||(this.g={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}i(N){if(this.a){if(typeof this.a!="string"){N(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(g=>{N(g)},g=>{(0,R.$1)(g),console.error(g)})}}log(N,g){if(!this.a)return;g=(0,A.$0m)(g,this.g),g=(0,j.$vo)(g);const d=this.f+"/"+N;try{this.i(E=>{E.pluginVersionString=g?.properties.version??"Unknown",E.track({name:d,baseData:{name:d,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(N=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,N(void 0)})})}):Promise.resolve(void 0)}}e.$rN=c}),define(ne[145],re([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let E=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,I){this.k=f,this.l=I,this.d={},this.i=new L.$Rc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,j.$Fe)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Fe)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(g.$kl)||p.affectsConfiguration(g.$ml)||p.affectsConfiguration(g.$ll))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,d.$uo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const I=f.usage?3:f.error?2:0;h=Math.min(h,I)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,I){this.g<f||(I=(0,R.$0m)(I,this.d),I=(0,d.$zo)(I,this.j),I=(0,R.$0m)(I,this.c),this.b.forEach(p=>p.log(h,I)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$2q=E,e.$2q=E=pe([se(1,b.$ji),se(2,S.$pj)],E);function v(){const $=(0,D.localize)(0,null,c.default.nameLong),h=c.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=A.$p?"":(0,D.localize)(3,null),I=(0,D.localize)(4,null),p=(0,D.localize)(5,null),k=(0,D.localize)(6,null),s=(0,D.localize)(7,null),o=`
|       | ${I} | ${p} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,D.localize)(8,null);return`
${$} ${h} ${f}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}N.$gn.as(u.$ln.Configuration).registerConfiguration({id:g.$jl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[g.$kl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),N.$gn.as(u.$ln.Configuration).registerConfiguration({id:g.$jl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[g.$ml]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,D.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,D.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${g.$kl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(G,e,L,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;async function D(S,N){const g=await N.request(S,R.CancellationToken.None),d=(await(0,L.$ne)(g.stream)).toString(),E=g.res.statusCode??200;return{headers:g.res.headers,statusCode:E,responseData:d}}async function b(S){const N={method:S.type,headers:S.headers};return new Promise((d,E)=>{const v=A.request(S.url??"",N,$=>{$.on("data",function(h){d({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){E(h)})});v.write(S.data,$=>{$&&E($)}),v.end()})}async function u(S,N,g){const d=typeof N.data=="string"?N.data:new TextDecoder().decode(N.data),E={type:"POST",headers:{...N.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(N.data).toString()},url:N.urlString,data:d};try{const v=S?await D(E,S):await b(E);g(v.statusCode,v.headers,v.responseData)}catch{g(0,{})}}class c extends j.$rN{constructor(N,g,d,E,v){const $={sendPOST:(h,f)=>{u(N,h,f)}};super(g,d,E,v,$)}}e.$sN=c}),define(ne[148],re([0,1,16,24]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B8b=void 0;async function A(j,D){const b=Object.create(null),u=(S,N)=>{const g=JSON.parse(S);b[N]=g};if(D){const S=[],N=await R.Promises.readdir(D);for(const d of N)try{(await R.Promises.stat((0,L.$jc)(D,d))).isDirectory()&&S.push(d)}catch{}const g=[];for(const d of S)(await R.Promises.readdir((0,L.$jc)(D,d))).filter(v=>v==="telemetry.json").length===1&&g.push(d);for(const d of g){const E=(await R.Promises.readFile((0,L.$jc)(D,d,"telemetry.json"))).toString();u(E,d)}}let c=(await R.Promises.readFile((0,L.$jc)(j,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await R.Promises.readFile((0,L.$jc)(j,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.$B8b=A}),define(ne[149],re([0,1,13,82,26]),function(G,e,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=e.$T7b=void 0;async function j(b,u){let c=b.getItem(A.$hl);return(typeof c!="string"||L.$k&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,R.$Sm)(u.error.bind(u))),c}e.$T7b=j;async function D(b,u){let c=b.getItem(A.$il);return typeof c!="string"&&(c=await(0,R.$Tm)(u.error.bind(u))),c}e.$U7b=D}),define(ne[22],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,L.$Ph)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(G,e,L,R,A,j,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;class c{static{this._clock=0}constructor(g){this.uri=g,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let S=class{constructor(g){this.g=g,this.c=new u.$Rc,this.f=2**16;const d=new Map,E=v=>{let $=d.get(v.scheme);return $===void 0&&($=g.hasProvider(v)&&!this.g.hasCapability(v,1024),d.set(v.scheme,$)),$};this.c.add(b.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(v=>{d.delete(v.scheme)})),this.extUri=new j.$kg(E),this.d=new D.$zr((v,$)=>this.extUri.compare(v,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,j.$wg)(g));const d=this.d.get(g);return d?d.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new c(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((E,v)=>E[1].time<v[1].time?1:E[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let E=0;E<d;E++)this.d.set(g[E][0],g[E][1].touch())}};e.$Ar=S,e.$Ar=S=pe([se(0,A.$$j)],S),(0,R.$xr)(L.$Ik,S,1)}),define(ne[151],re([0,1,4,2,12,47,31]),function(G,e,L,R,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0;class b extends R.$Sc{constructor(c,S,N,g,d,E){super(),this.f=c,this.g=S,this.h=N,this.j=g,this.m=d,this.n=E,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Nd),this.onDidChangeFile=this.a.event,this.b=j.$Vh.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,S){return this.g.open(this.t(c),S)}close(c){return this.g.close(c)}read(c,S,N,g,d){return this.g.read(c,S,N,g,d)}write(c,S,N,g,d){return this.g.write(c,S,N,g,d)}watch(c,S){this.b.set(c,c);const N=this.g.watch(this.t(c),S);return(0,R.$Qc)(()=>{this.b.delete(c),N.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,S,N){return this.g.rename(this.t(c),this.t(S),N)}readFile(c,S){return this.g.readFile(this.t(c),S)}readFileStream(c,S,N){return this.g.readFileStream(this.t(c),S,N)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,S,N){return this.g.writeFile(this.t(c),S,N)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,S){return this.g.delete(this.t(c),S)}copy(c,S,N){if((0,A.$ck)(this.g))return this.g.copy(this.t(c),this.t(S),N);throw new Error("copy not supported")}cloneFile(c,S){if((0,A.$dk)(this.g))return this.g.cloneFile(this.t(c),this.t(S));throw new Error("clone not supported")}s(c){const S=[];for(const N of c){if(N.resource.scheme!==this.f)continue;const g=this.u(N.resource);this.b.findSubstr(g)&&S.push({resource:g,type:N.type,cId:N.cId})}S.length&&(this.n.debug("User data changed"),this.a.fire(S))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$f8b=b}),define(ne[152],re([0,1,107,16,47,17,11,10,15]),function(G,e,L,R,A,j,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,b.$Ph)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$Zh=c;function S(i){return typeof i?.id=="string"&&!c(i)&&!g(i)}e.$1h=S,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function N(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$nc)(i)}:n?e.$2h:e.$3h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$4h=N;function g(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$5h=g;function d(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$6h=d;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$7h=v;function $(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$8h=$;class h{constructor(n,r,l,P,y){this.h=n,this.j=l,this.k=P,this.l=y,this.c=A.$Vh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=A.$Vh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=h;class f{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,j.$vg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=f;function I(i){return new f({uri:i,index:0,name:(0,j.$rg)(i)},{uri:i.toString()})}e.$$h=I,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,L.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function p(i,n){return j.$mg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$di=p;function k(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===u.Schemas.tmp}e.$ei=k,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$fi}e.$gi=s;function o(i,n){return!p(i,n)&&!k(i)}e.$hi=o;function t(i){return(typeof i=="string"?(0,R.$oc)(i):(0,j.$tg)(i))===e.$ai}e.$ii=t}),define(ne[23],re([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E,v,$,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var I;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Jk=p,e.$Kk=(0,S.$Ph)("IUserDataProfilesService");function k(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Lk=k;function s(i,n,r,l,P,y){return{id:i,name:n,location:r,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:y&&P?.useDefaultFlags?.globalState?y.globalStorageHome:(0,j.$vg)(r,"globalStorage"),settingsResource:y&&P?.useDefaultFlags?.settings?y.settingsResource:(0,j.$vg)(r,"settings.json"),keybindingsResource:y&&P?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,j.$vg)(r,"keybindings.json"),tasksResource:y&&P?.useDefaultFlags?.tasks?y.tasksResource:(0,j.$vg)(r,"tasks.json"),snippetsHome:y&&P?.useDefaultFlags?.snippets?y.snippetsHome:(0,j.$vg)(r,"snippets"),extensionsResource:y&&P?.useDefaultFlags?.extensions?y.extensionsResource:(0,j.$vg)(r,"extensions.json"),cacheHome:(0,j.$vg)(l,i),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$Mk=s;let o=class extends A.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,l,P){super(),this.t=n,this.u=r,this.w=l,this.y=P,this.f=!0,this.h=this.B(new R.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$Ac,emptyWindows:new Map},this.profilesHome=(0,j.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,f.$yf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(s((0,j.$sg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},n))}}catch(y){this.y.error(y)}const l=new d.$Ac,P=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[w,O]of Object.entries(y.workspaces)){const H=D.URI.parse(w),_=r.find(x=>x.id===O);_&&l.set(H,_)}if(y.emptyWindows)for(const[w,O]of Object.entries(y.emptyWindows)){const H=r.find(_=>_.id===O);H&&P.set(w,H)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:l,emptyWindows:P}}return this.z}D(){const n=s("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,h.$Fe)(r)}\\s(\\d+)`);let P=0;for(const w of this.profiles){const O=l.exec(w.name),H=O?parseInt(O[1]):0;P=H>P?H:P}const y=`${r} ${P+1}`;return this.createProfile((0,L.$Di)((0,$.$eg)()).toString(16),y,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,L.$Di)((0,$.$eg)()).toString(16),n,r,l)}async createProfile(n,r,l,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(n,r,l);return P&&await this.setProfileForWorkspace(P,y),y}async F(n,r,l){if(!(0,f.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(r);return P||(P=(async()=>{try{const y=this.profiles.find(H=>H.name===r||H.id===n);if(y)return y;const w=s(n,r,(0,j.$vg)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(w.location);const O=[];return this.j.fire({profile:w,join(H){O.push(H)}}),await v.Promises.settled(O),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,P)),P}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(P=>P.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=s(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(P=>P.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:r,join(P){l.push(P)}});try{await Promise.allSettled(l)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(P){(0,c.$pk)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(P=>P.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,g.$Zh)(n)?n.uri:(0,g.$5h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,l){const P=[...this.profiles,...n],y=[];this.s.profiles=[];for(let w of P)w.isDefault||r.some(O=>w.id===O.id)||(w=l.find(O=>w.id===O.id)??w,w.isTransient?this.s.profiles.push(w):y.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(y),this.z=void 0,this.J(n,r,l)}J(n,r,l){this.h.fire({added:n,removed:r,updated:l,all:this.profiles})}L(n,r,l){l=r?.isTransient?!0:l,l||this.L(n,void 0,!0);const P=this.G(n),y=l?this.s:this.C;D.URI.isUri(P)?(y.workspaces.delete(P),r&&y.workspaces.set(P,r)):(y.emptyWindows.delete(P),r&&y.emptyWindows.set(P,r)),l||this.M()}M(){const n={};for(const[l,P]of this.C.workspaces.entries())n[l.toString()]=P.id;const r={};for(const[l,P]of this.C.emptyWindows.entries())r[l.toString()]=P.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},l=this.D();if(n.workspaces)for(const[y,w]of Object.entries(n.workspaces)){const O=D.URI.parse(w);r[y]=this.w.extUri.isEqual(O,l.location)?l.id:this.w.extUri.basename(O)}const P={};if(n.emptyWindows)for(const[y,w]of Object.entries(n.emptyWindows)){const O=D.URI.parse(w);P[y]=this.w.extUri.isEqual(O,l.location)?l.id:this.w.extUri.basename(O)}return{workspaces:r,emptyWindows:P}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Nk=o,e.$Nk=o=pe([se(0,u.$Wh),se(1,c.$$j),se(2,E.$Ik),se(3,N.$0i)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ok=t}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E,v,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=void 0;let p=class extends b.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,l,P,y,w){super(),this.z=n,this.C=r,this.D=l,this.F=P,this.G=y,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$Nd),this.s=this.B(new D.$Nd),this.t=this.B(new D.$Nd),this.u=this.B(new D.$Nd),this.w=this.B(new D.$Nd),this.y=[],this.B((0,b.$Qc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,g.$8n)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const P=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:y})=>(0,d.$Ao)(y,n.identifier));if(P?.local)return P?.local;throw P?.error?P.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new g.$_n(N.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(n.map(async({extension:P,options:y})=>{try{const w=await this.O(P,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);l.push({...w,options:y})}catch(w){r.push({identifier:P.identifier,operation:2,source:P,error:w})}})),l.length&&r.push(...await this.I(l));for(const P of r)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!S.URI.isUri(P.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,d.$Io)(P.source),error:P.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,E.$9l)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const P of this.H.profiles){const y=(await this.getInstalled(1,P.extensionsResource)).find(w=>(0,d.$Ao)(w.identifier,n.identifier));y?this.w.fire(y):this.u.fire({identifier:n.identifier,profileLocation:P.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async l=>{try{const P=await this.J(l);r.push(...P)}catch(P){r.push({identifier:{id:(0,d.$Fo)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:P})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:l}){const P=l.isApplicationScoped||l.isBuiltin||(0,E.$9l)(n),y={...l,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:P,profileLocation:P?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},w=te=>`${d.$Bo.create(te).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!S.URI.isUri(r)){const te=this.j.get(w(r));if(te)return this.F.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const O=[],H=[],_=[],x=this.Z(n,r,y);S.URI.isUri(r)||this.j.set(w(r),{task:x,waitingTasks:[]}),this.n.fire({identifier:x.identifier,source:r,profileLocation:y.profileLocation}),this.F.info("Installing extension:",x.identifier.id),O.push({task:x,manifest:n});let ue=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",x.identifier.id);else try{const ae=await this.N(x.identifier,n,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),le=await this.getInstalled(void 0,y.profileLocation),ie={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[g.$3n]:!0}};for(const{gallery:q,manifest:J}of(0,L.$Mb)(ae,({gallery:T})=>T.identifier.id)){ue=ue||!!J.extensionDependencies?.some(B=>(0,d.$Ao)({id:B},x.identifier));const T=w(q),U=this.j.get(T);if(U){if(this.L(x,U.task)){const B=U.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,x.identifier.id),U.waitingTasks.push(x),H.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,X=>X.some(Q=>(0,d.$Ao)(Q.identifier,B)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,x.identifier.id),!X.find(K=>(0,d.$Ao)(K.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!le.some(({identifier:B})=>(0,d.$Ao)(B,q.identifier))){const B=this.Z(J,q,ie);this.j.set(T,{task:B,waitingTasks:[x]}),this.n.fire({identifier:B.identifier,source:q,profileLocation:y.profileLocation}),this.F.info("Installing extension:",B.identifier.id,x.identifier.id),O.push({task:B,manifest:J})}}}catch(ae){if(S.URI.isUri(x.source))(0,L.$Lb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",x.identifier.id,ae.message),(0,L.$Lb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",x.identifier.id,ae.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",x.identifier.id),ae}const te=O.reduce((ae,{task:le,manifest:ie})=>(ae.set(le.identifier.id.toLowerCase(),{task:le,manifest:ie}),ae),new Map);for(;te.size;){let ae;const le=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(q=>te.has(q.toLowerCase())));le.length?ae=te.size===1?le:le.filter(({task:ie})=>!(ie===x&&!ue)):(this.F.info("Found extensions with circular dependencies",le.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.M(ae.map(async({task:ie})=>{const q=new Date().getTime();try{const J=await ie.run();if(await this.M(this.y.map(T=>T.postInstall(J,ie.source,y,A.CancellationToken.None))),!S.URI.isUri(ie.source)){const T=ie.operation===3,U=T?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(o(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$Io)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:U}),u.$p&&ie.operation!==3)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}_.push({local:J,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw S.URI.isUri(ie.source)||o(this.C,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$Io)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,error:J}),this.F.error("Error while installing the extension:",ie.identifier.id),J}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return H.length&&await this.M(H),_.forEach(({identifier:ae})=>this.F.info("Extension installed successfully:",ae.id)),_}catch(te){if(O.forEach(({task:ae})=>ae.cancel()),_.length)try{const ae=await Promise.allSettled(_.map(({local:le})=>this.$(le,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let le=0;le<ae.length;le++){const ie=ae[le],{identifier:q}=_[le];ie.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",q.id):this.F.warn("Rollback: Error while uninstalling extension",q.id,(0,j.$0)(ie.reason))}}catch(ae){this.F.warn("Error while rolling back extensions",(0,j.$0)(ae),_.map(({identifier:le})=>le.id))}return O.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:y.context,profileLocation:y.profileLocation,error:te}))}finally{for(const{task:te}of O)te.source&&!S.URI.isUri(te.source)&&this.j.delete(w(te.source))}}L(n,r){for(const[,{task:l,waitingTasks:P}]of this.j.entries())if(l===n&&(P.includes(r)||P.some(y=>this.L(y,r)))||l===r&&P[0]&&!this.L(n,P[0]))return!1;return!0}async M(n){const r=[],l=[],P=await Promise.allSettled(n);for(const y of P)y.status==="fulfilled"?r.push(y.value):l.push(y.reason);if(l.length)throw k(l);return r}async N(n,r,l,P,y){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,y),O=[],H=[],_=async(x,ue)=>{O.push(x);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const le=l?w.find(ie=>(0,d.$Ao)(ie.identifier,x)):void 0;for(const ie of ue.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(q=>(0,d.$Ao)({id:q},{id:ie}))||ae.every(q=>!(0,d.$Ao)({id:q},{id:ie}))&&ae.push(ie)}if(ae.length){const le=ae.filter(ie=>O.every(q=>!(0,d.$Ao)(q,{id:ie})));if(le.length){const ie=await this.z.getExtensions(le.map(q=>({id:q,preRelease:P})),A.CancellationToken.None);for(const q of ie){if(O.find(U=>(0,d.$Ao)(U,q.identifier)))continue;const J=te.some(U=>(0,d.$Ao)({id:U},q.identifier));let T;try{T=await this.O(q,!1,P)}catch(U){if(J)throw U;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,j.$0)(U));continue}H.push({gallery:T.extension,manifest:T.manifest}),await _(T.extension.identifier,T.manifest)}}}};return await _(n,r),H}async O(n,r,l){let P;const y=await this.getExtensionsControlManifest();if(y.malicious.some(H=>(0,d.$Ao)(n.identifier,H)))throw new g.$_n(N.localize(1,null,n.identifier.id),g.ExtensionManagementErrorCode.Malicious);const w=y.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),P=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!P)throw new g.$_n(N.localize(2,null,n.identifier.id,w.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new g.$_n(N.localize(3,null,n.identifier.id,this.G.nameLong,(0,g.$4n)(H)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.P(n,r,l),!P)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],A.CancellationToken.None))[0]?new g.$_n(N.localize(4,null,n.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$_n(N.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",P.identifier.id);const O=await this.z.getManifest(P,A.CancellationToken.None);if(O===null)throw new g.$_n(`Missing manifest for extension ${P.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(O.version!==P.version)throw new g.$_n(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:O}}async P(n,r,l){const P=await this.getTargetPlatform();let y=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(y=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:P,compatible:!0},A.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(n,l,P)&&(y=n),y||(r?y=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:P,compatible:!0},A.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(n,l,P)),y}async Q(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},P=x=>`${x.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,y=this.m.get(P(n.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),y.waitUntilTaskIsFinished();const w=x=>{const ue=this.$(x,l);return this.m.set(P(ue.extension.identifier),ue),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${x.identifier.id}@${x.manifest.version}`),this.t.fire({identifier:x.identifier,profileLocation:l.profileLocation,applicationScoped:x.isApplicationScoped}),ue},O=(x,ue)=>{ue?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,l.profileLocation.toString(),ue.message):this.F.error("Failed to uninstall extension:",`${x.identifier.id}@${x.manifest.version}`,ue.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${x.identifier.id}@${x.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${x.identifier.id}@${x.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,d.$Ho)(x),error:ue}),this.u.fire({identifier:x.identifier,error:ue?.code,profileLocation:l.profileLocation,applicationScoped:x.isApplicationScoped})},H=[],_=[];try{H.push(w(n));const x=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ue=this.U(n,x);for(const te of ue)this.m.has(P(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):H.push(w(te))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(H.map(ue=>ue.extension),x,n),await this.M(H.map(async ue=>{try{if(await ue.run(),await this.M(this.y.map(te=>te.postUninstall(ue.extension,l,A.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.z.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}O(ue.extension)}catch(te){const ae=te instanceof g.$_n?te:new g.$_n((0,j.$0)(te),g.ExtensionManagementErrorCode.Internal);throw O(ue.extension,ae),ae}finally{_.push(ue)}}))}catch(x){const ue=x instanceof g.$_n?x:new g.$_n((0,j.$0)(x),g.ExtensionManagementErrorCode.Internal);for(const te of H){try{te.cancel()}catch{}_.includes(te)||O(te.extension,ue)}throw ue}finally{for(const x of H)this.m.delete(P(x.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",x.extension.identifier.id)}}R(n,r,l){for(const P of n){const y=this.W(P,r);if(y.length){const w=y.filter(O=>!n.some(H=>(0,d.$Ao)(H.identifier,O.identifier)));if(w.length)throw new Error(this.S(P,w,l))}}}S(n,r,l){return l===n?r.length===1?N.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?N.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):N.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?N.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?N.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):N.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const P=n.manifest.extensionPack?n.manifest.extensionPack:[];if(P.length){const y=r.filter(O=>!O.isBuiltin&&P.some(H=>(0,d.$Ao)({id:H},O.identifier))),w=[];for(const O of y)w.push(...this.U(O,r,l));return[...y,...w]}return[]}W(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(P=>(0,d.$Ao)({id:P},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$qp=p,e.$qp=p=pe([se(0,g.$$n),se(1,h.$cl),se(2,f.$Ik),se(3,v.$0i),se(4,$.$pj),se(5,I.$Kk)],p);function k(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$rp=k;function s(i){if(i instanceof g.$_n)return i;const n=new g.$_n(i.message,g.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$sp=s;function o(i,n,{extensionData:r,verificationStatus:l,duration:P,error:y,durationSinceUpdate:w}){let O,H;(0,c.$Gf)(l)&&(l===!0?l="Verified":(l===!1||(O=g.ExtensionManagementErrorCode.Signature,H=l),l="Unverified")),y&&(y instanceof g.$_n?(O=y.code,y.code===g.ExtensionManagementErrorCode.Signature&&(H=y.message)):O=g.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:l,success:!y,duration:P,errorcode:O,errorcodeDetail:H,durationSinceUpdate:w})}class t{constructor(){this.d=new R.$Sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.$Hg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.$Hg)(n=>new Promise((r,l)=>{const P=n.onCancellationRequested(()=>{P.dispose(),l(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$tp=t}),define(ne[40],re([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E,v,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class I extends Error{constructor(t,i){super(t),this.code=i}}e.$up=I,e.$vp=(0,N.$Ph)("IExtensionsProfileScannerService");let p=class extends A.$Sc{constructor(t,i,n,r,l,P){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=l,this.t=P,this.b=this.B(new j.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,l=>{const P=[];for(const y of l)t.some(([w])=>(0,c.$Ao)(w.identifier,y.identifier)&&w.manifest.version!==y.version)?n.push(y):P.push(y);for(const[y,w]of t){const O=P.findIndex(_=>(0,c.$Ao)(_.identifier,y.identifier)&&_.version===y.manifest.version),H={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:w};O===-1?(r.push(H),P.push(H)):P.splice(O,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),P}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const l=[];for(const P of r){const y=t.find(([w])=>(0,c.$Ao)(w.identifier,P.identifier)&&w.manifest.version===P.version);y&&(P.metadata={...P.metadata,...y[1]},n.push(P)),l.push(P)}return l}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const l=[];for(const P of r)(0,c.$Ao)(P.identifier,t.identifier)?n.push(P):l.push(P);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],l;try{const P=await this.m.readFile(t);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,S.$pk)(P)!==1)throw P;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new I((0,$.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let P=!1;for(const y of l){k(y)||this.w(t);let w;if((0,v.$yf)(y.relativeLocation)&&y.relativeLocation)w=this.z(y.relativeLocation);else if((0,v.$yf)(y.location))w=this.z(y.location),P=!0,y.relativeLocation=y.location,y.location=w.toJSON();else{w=b.URI.revive(y.location);const O=this.y(w);O&&(P=!0,y.relativeLocation=O)}r.push({identifier:y.identifier,location:w,version:y.version,metadata:y.metadata})}P&&await this.m.writeFile(t,R.$be.fromString(JSON.stringify(l)))}if(i){r=i(r);const P=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(t,R.$be.fromString(JSON.stringify(P)))}return r})}w(t){const i=new I(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(l){if((0,S.$pk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(P=>k(P))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,S.$pk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,S.$pk)(l)!==1&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,S.$pk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$1g,this.h.set(t,i)),i}};e.$wp=p,e.$wp=p=pe([se(1,S.$$j),se(2,d.$Kk),se(3,E.$Ik),se(4,h.$cl),se(5,g.$0i)],p);function k(o){return(0,v.$Af)(o)&&(0,u.$0n)(o.identifier)&&(s(o.location)||(0,v.$yf)(o.location)&&o.location)&&((0,v.$Ff)(o.relativeLocation)||(0,v.$yf)(o.relativeLocation))&&o.version&&(0,v.$yf)(o.version)}function s(o){return o?(0,v.$yf)(o.path)&&(0,v.$yf)(o.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,46,40,23,22,112]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E,v,$,h,f,I,p,k,s,o,t,i,n,r,l,P,y,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.Translations=void 0;var H;(function(ie){function q(J,T){if(J===T)return!0;const U=Object.keys(J),B=new Set;for(const X of Object.keys(T))B.add(X);if(U.length!==B.size)return!1;for(const X of U){if(J[X]!==T[X])return!1;B.delete(X)}return B.size===0}ie.equals=q})(H||(e.Translations=H={})),e.$zp=(0,t.$Ph)("IExtensionsScannerService");let _=class extends c.$Sc{constructor(q,J,T,U,B,X,Q,K,M,z,a,m){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=J,this.r=T,this.s=U,this.t=B,this.u=X,this.w=Q,this.y=K,this.z=M,this.C=z,this.D=a,this.F=m,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,d.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ue,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Lo)(this.w,this.y)),this.G}async scanAllExtensions(q,J,T){const[U,B]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(J)]),X=T?await this.scanExtensionsUnderDevelopment(q,[...U,...B]):[];return this.L(U,B,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const J=[];J.push(this.M(!!q.useCache,q.language)),J.push(this.N(q.language,!!q.checkControlFile));const[T,U]=await Promise.all(J);return this.J([...T,...U],0,q,!1)}async scanUserExtensions(q){const J=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(J,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),B=q.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let X;try{X=await B.scanExtensions(U)}catch(Q){if(Q instanceof P.$up&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await B.scanExtensions(U);else throw Q}return X=await this.J(X,1,q,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(q,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===S.Schemas.file).map(async U=>{const B=await this.P(U,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(B)).map(Q=>(Q.type=J.find(K=>(0,p.$Ao)(K.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,B)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,J,T){const U=await this.P(q,!1,J,!0,T.language,!0,void 0),B=await this.n.scanExtension(U);return!B||!T.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(q,J,T){const U=await this.P(q,!1,J,!0,T.language,!0,void 0),B=await this.n.scanOneOrMultipleExtensions(U);return this.J(B,J,T,!0)}async scanMetadata(q){const J=(0,d.$vg)(q,"package.json"),T=(await this.w.readFile(J)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,J){const T=(0,d.$vg)(q,"package.json"),U=(await this.w.readFile(T)).value.toString(),B=JSON.parse(U);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,B.__metadata={...B.__metadata,...J},await this.w.writeFile((0,d.$vg)(q,"package.json"),j.$be.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof P.$up&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$be.fromString(JSON.stringify([])))}catch(J){(0,o.$pk)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,J,T,U){return T.includeAllVersions||(q=this.L(J===0?q:void 0,J===1?q:void 0,J==="development"?q:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(q=q.filter(B=>B.isValid)),q.sort((B,X)=>{const Q=N.$nc(B.location.fsPath),K=N.$nc(X.location.fsPath);return Q<K?-1:Q>K?1:0})}L(q,J,T,U,B){const X=(K,M,z)=>{if(K.isValid&&!M.isValid)return!1;if(K.isValid===M.isValid){if(B&&E.gt(K.manifest.version,M.manifest.version))return this.y.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(E.eq(K.manifest.version,M.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${M.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===U)return this.y.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${K.location.path} with ${M.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${M.location.path}.`),!0},Q=new k.$8l;return q?.forEach(K=>{const M=Q.get(K.identifier.id);(!M||X(M,K,!1))&&Q.set(K.identifier.id,K)}),J?.forEach(K=>{const M=Q.get(K.identifier.id);if(!M&&q&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!M||X(M,K,!1))&&Q.set(K.identifier.id,K)}),T?.forEach(K=>{const M=Q.get(K.identifier.id);(!M||X(M,K,!0))&&Q.set(K.identifier.id,K),Q.set(K.identifier.id,K)}),[...Q.values()]}async M(q,J){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0),B=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",B.length),B}async N(q,J){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const U=J?await this.O():{},B=[],X=h.URI.file(N.$hc(N.$jc(S.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of T){const M=U[K.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":B.push((0,d.$vg)(X,K.name));break;default:B.push(h.URI.file(M));break}}const Q=await Promise.all(B.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,L.$Hb)(Q)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,J,T,U,B,X,Q){const K=await this.f(B??g.$w),M=await this.Q(q),z=J&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=z?await this.Q(z):void 0;return new x(q,M,z,a,J,Q,T,U,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,B,K)}async Q(q){try{const J=await this.w.stat(q);if(typeof J.mtime=="number")return J.mtime}catch{}}};e.$Ap=_,e.$Ap=_=pe([se(4,y.$Kk),se(5,P.$vp),se(6,o.$$j),se(7,i.$0i),se(8,I.$Wh),se(9,n.$pj),se(10,w.$Ik),se(11,t.$Oh)],_);class x{constructor(q,J,T,U,B,X,Q,K,M,z,a,m,F,C,Z){this.location=q,this.mtime=J,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=B,this.profileScanOptions=X,this.type=Q,this.excludeObsolete=K,this.validate=M,this.productVersion=z,this.productDate=a,this.productCommit=m,this.devMode=F,this.language=C,this.translations=Z}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,J){return(0,d.$og)(q.location,J.location)&&q.mtime===J.mtime&&(0,d.$og)(q.applicationExtensionslocation,J.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&q.profile===J.profile&&A.$$m(q.profileScanOptions,J.profileScanOptions)&&q.type===J.type&&q.excludeObsolete===J.excludeObsolete&&q.validate===J.validate&&q.productVersion===J.productVersion&&q.productDate===J.productDate&&q.productCommit===J.productCommit&&q.devMode===J.devMode&&q.language===J.language&&H.equals(q.translations,J.translations)}}e.$Bp=x;let ue=class extends c.$Sc{constructor(q,J,T,U,B){super(),this.f=q,this.g=J,this.h=T,this.j=U,this.m=B}async scanExtensions(q){const J=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,$.$Lf)(T)?J:J.filter(U=>!T[p.$Bo.create(U).toString()])}async n(q){const J=await this.j.resolve(q.location);if(!J.children?.length)return[];const T=await Promise.all(J.children.map(async U=>{if(!U.isDirectory||q.type===1&&(0,d.$sg)(U.resource).indexOf(".")===0)return null;const B=new x(U.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B)}));return(0,L.$Hb)(T).sort((U,B)=>U.location.path<B.location.path?-1:1)}async r(q){let J=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){J=J.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,q);J.push(...T)}return J}async s(q,J,T){const U=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!U.length)return[];const B=await Promise.all(U.map(async X=>{if(J(X)){const Q=new x(X.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Q,X.metadata)}return null}));return(0,L.$Hb)(B)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,d.$vg)(q.location,"package.json"))){const J=await this.scanExtension(q);return J?[J]:[]}else return await this.scanExtensions(q)}catch(J){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,D.$0)(J)),[]}}async scanExtension(q,J){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=k.$2l),J=J??T.__metadata,delete T.__metadata;const U=(0,p.$Fo)(T.publisher,T.name),B=J?.id?{id:U,uuid:J.id}:{id:U},X=J?.isSystem?0:q.type,Q=X===0||!!J?.isBuiltin;T=await this.t(q.location,T,x.createNlsConfiguration(q));const K={type:X,identifier:B,manifest:T,location:q.location,isBuiltin:Q,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return q.validate?this.validate(K,q):K}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,J){let T=!0;const U=(0,s.$Qo)(J.productVersion,J.productDate,J.location,q.manifest,q.isBuiltin);for(const[B,X]of U)B===v.default.Error&&(T=!1,this.m.error(this.z(J.location,X)));return q.isValid=T,q.validations=U,q}async scanExtensionManifest(q){const J=(0,d.$vg)(q,"package.json");let T;try{T=(await this.j.readFile(J)).value.toString()}catch(B){return(0,o.$pk)(B)!==1&&this.m.error(this.z(q,(0,f.localize)(0,null,J.path,B.message))),null}let U;try{U=JSON.parse(T)}catch{const X=[];(0,b.$Wm)(T,X);for(const Q of X)this.m.error(this.z(q,(0,f.localize)(1,null,J.path,Q.offset,Q.length,(0,u.$xp)(Q.error))));return null}return(0,b.$6m)(U)!=="object"?(this.m.error(this.z(q,(0,f.localize)(2,null,J.path))),null):U}async t(q,J,T){const U=await this.u(q,J,T);if(U)try{const B=[],X=await this.w(U.default,B);if(B.length>0)return B.forEach(K=>{this.m.error(this.z(q,(0,f.localize)(3,null,U.default?.path,(0,u.$xp)(K.error))))}),J;if((0,b.$6m)(U)!=="object")return this.m.error(this.z(q,(0,f.localize)(4,null,U.default?.path))),J;const Q=U.values||Object.create(null);return(0,O.$yp)(this.m,J,Q,X)}catch{}return J}async u(q,J,T){const U=(0,d.$vg)(q,"package.nls.json"),B=(M,z)=>{z.forEach(a=>{this.m.error(this.z(q,(0,f.localize)(5,null,M?.path,(0,u.$xp)(a.error))))})},X=M=>{this.m.error(this.z(q,(0,f.localize)(6,null,M?.path)))},Q=`${J.publisher}.${J.name}`,K=T.translations[Q];if(K)try{const M=h.URI.file(K),z=(await this.j.readFile(M)).value.toString(),a=[],m=(0,b.$Wm)(z,a);return a.length>0?(B(M,a),{values:void 0,default:U}):(0,b.$6m)(m)!=="object"?(X(M),{values:void 0,default:U}):{values:m.contents?m.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let z;try{z=await this.y(q,T)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const a=(await this.j.readFile(z.localized)).value.toString(),m=[],F=(0,b.$Wm)(a,m);return m.length>0?(B(z.localized,m),{values:void 0,default:z.original}):(0,b.$6m)(F)!=="object"?(X(z.localized),{values:void 0,default:z.original}):{values:F,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(q,J){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,b.$Wm)(T,J)}catch{}}y(q,J){return new Promise((T,U)=>{const B=X=>{const Q=(0,d.$vg)(q,`package.nls.${X}.json`);this.j.exists(Q).then(K=>{K&&T({localized:Q,original:(0,d.$vg)(q,"package.nls.json")});const M=X.lastIndexOf("-");M===-1?T({localized:(0,d.$vg)(q,"package.nls.json"),original:null}):(X=X.substring(0,M),B(X))})};if(J.devMode||J.pseudo||!J.language)return T({localized:(0,d.$vg)(q,"package.nls.json"),original:null});B(J.language)})}z(q,J){return`[${q.path}]: ${J}`}};ue=pe([se(1,P.$vp),se(2,w.$Ik),se(3,o.$$j),se(4,i.$0i)],ue);let te=class extends ue{constructor(q,J,T,U,B,X,Q){super(J,U,B,X,Q),this.G=q,this.H=T,this.D=this.B(new R.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const J=this.M(q),T=await this.I(J);if(this.C=q,T&&T.input&&x.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(B=>(B.location=h.URI.revive(B.location),B));const U=await super.scanExtensions(q);return await this.J(J,{input:q,result:U}),U}async I(q){try{const J=await this.j.readFile(q),T=JSON.parse(J.value.toString());return{result:T.result,input:(0,l.$mh)(T.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",q.path,(0,D.$0)(J))}return null}async J(q,J){try{await this.j.writeFile(q,j.$be.fromString(JSON.stringify(J)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,D.$0)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),J=await this.I(q);if(!J)return;const T=J.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$$m(U,T))try{this.m.info("Invalidating Cache",T,U),await this.j.del(q),this.F.fire()}catch(B){this.m.error(B)}}M(q){const J=this.N(q);return this.h.extUri.joinPath(J.cacheHome,q.type===0?k.$1l:k.$Zl)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(q.location,J.extensionsResource))??this.G:this.H.defaultProfile}};te=pe([se(2,y.$Kk),se(3,P.$vp),se(4,w.$Ik),se(5,o.$$j),se(6,i.$0i)],te);function ae(ie,q){const J=(0,p.$Do)(ie.manifest.publisher,ie.manifest.name);return{id:J,identifier:new k.$6l(J),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:q,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$Cp=ae;class le extends _{constructor(q,J,T,U,B,X,Q,K,M,z,a,m){super(q,J,(0,d.$vg)(T,".vscode-oss-dev","extensions","control.json"),U,B,X,Q,K,M,z,a,m),this.R=(async()=>{if(g.$z)try{const F=await this.w.readFile(h.URI.file(g.$z));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$Dp=le}),define(ne[154],re([0,1,58,8,34,4,2,15,16,24,6,23]),function(G,e,L,R,A,j,D,b,u,c,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;let g=class extends D.$Sc{constructor(E,v){super(),this.b=E,this.f=v,this.a=new R.$Zg(5)}async postUninstall(E){const v=this.g(E,"uninstall");v&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,E),this.f.info("Finished running post uninstall script",E.identifier.id,E.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",E.identifier.id,E.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(E))}catch($){this.f.error("Error while removing extension storage path",E.identifier.id),this.f.error($)}}g(E,v){const $=`vscode:${v}`;if(E.location.scheme===b.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[$]=="string"){const h=E.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${$} should be a node script`),null):{script:(0,u.$jc)(E.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(E,v,$,h,f){return new Promise((I,p)=>{const k=this.j(E,v,$,f);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?p(t):I(void 0)};k.on("error",t=>{o((0,A.$Ai)(t)||"Unknown")}),k.on("exit",(t,i)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),h&&(s=setTimeout(()=>{s=null,k.kill(),p("timed out")},5e3))})}j(E,v,$,h){const f={silent:!0,execArgv:void 0},I=(0,L.fork)(E,[`--type=extension-post-${v}`,...$],f);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const p=j.Event.fromNodeEventEmitter(I.stdout,"data"),k=j.Event.fromNodeEventEmitter(I.stderr,"data");p(t=>this.f.info(h.identifier.id,h.manifest.version,`post-${v}`,t)),k(t=>this.f.error(h.identifier.id,h.manifest.version,`post-${v}`,t));const s=j.Event.any(j.Event.map(p,t=>({data:`%c${t}`,format:[""]})),j.Event.map(k,t=>({data:`%c${t}`,format:["color: red"]})));return j.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(h.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),I}m(E){return(0,u.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};e.$Fp=g,e.$Fp=g=pe([se(0,N.$Kk),se(1,S.$0i)],g)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(G,e,L,R,A,j,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;let S=class extends D.$wp{constructor(g,d,E,v,$,h){super(c.URI.file(g.extensionsPath),d,E,v,$,h)}};e.$DN=S,e.$DN=S=pe([se(0,u.$Xh),se(1,b.$$j),se(2,R.$Kk),se(3,A.$Ik),se(4,j.$cl),se(5,L.$0i)],S)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,32,22,23]),function(G,e,L,R,A,j,D,b,u,c,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q7b=void 0;let g=class extends j.$Dp{constructor(E,v,$,h,f,I,p,k){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,E.defaultProfile,E,v,$,h,f,I,p,k)}};e.$Q7b=g,e.$Q7b=g=pe([se(0,N.$Kk),se(1,A.$vp),se(2,D.$$j),se(3,u.$0i),se(4,R.$Xh),se(5,c.$pj),se(6,S.$Ik),se(7,b.$Oh)],g)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(G,e,L,R,A,j,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7o=e.$6o=e.$5o=void 0,e.$5o="__$__isNewStorageMarker",e.$6o="__$__targetStorageMarker",e.$7o=(0,u.$Ph)("storageService");var S;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var N;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(N||(e.StorageScope=N={}));var g;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function d(f){const I=f.get(e.$6o);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$8o=d;class E extends A.$Sc{static{this.a=60*1e3}constructor(I={flushInterval:E.a}){super(),this.m=I,this.b=this.B(new R.$Qd),this.c=this.B(new R.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,p,k){return R.Event.filter(this.b.event,s=>s.scope===I&&(p===void 0||s.key===p),k)}n(){this.j.value=(0,L.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,p){const{key:k,external:s}=p;if(k===e.$6o){switch(I){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:k,target:this.J(I)[k],external:s})}w(I){this.f.fire({reason:I})}get(I,p,k){return this.P(p)?.get(I,k)}getBoolean(I,p,k){return this.P(p)?.getBoolean(I,k)}getNumber(I,p,k){return this.P(p)?.getNumber(I,k)}getObject(I,p,k){return this.P(p)?.getObject(I,k)}storeAll(I,p){this.y(()=>{for(const k of I)this.store(k.key,k.value,k.scope,k.target,p)})}store(I,p,k,s,o=!1){if((0,D.$Hf)(p)){this.remove(I,k,o);return}this.y(()=>{this.z(I,k,s),this.P(k)?.set(I,p,o)})}remove(I,p,k=!1){this.y(()=>{this.z(I,p,void 0),this.P(p)?.delete(I,k)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,p){const k=[],s=this.J(I);for(const o of Object.keys(s))s[o]===p&&k.push(o);return k}z(I,p,k,s=!1){const o=this.J(p);typeof k=="number"?o[I]!==k&&(o[I]=k,this.P(p)?.set(e.$6o,JSON.stringify(o),s)):typeof o[I]=="number"&&(delete o[I],this.P(p)?.set(e.$6o,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(I){switch(I){case-1:return this.I;case 0:return this.G;default:return this.D}}L(I){const p=this.P(I);return p?d(p):Object.create(null)}isNew(I){return this.getBoolean(e.$5o,I)===!0}async flush(I=S.NONE){this.f.fire({reason:I});const p=this.P(-1),k=this.P(0),s=this.P(1);switch(I){case S.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,k=this.P(1)?.items??new Map;return h(I,p,k,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,p){return this.w(S.NONE),(0,c.$Jk)(I)?this.R(I,p):this.S(I,p)}M(I,p){return!(I.id===p.id||v(p)&&v(I))}N(I,p,k){this.y(()=>{const s=new Set;for(const[o,t]of I)s.add(o),p.get(o)!==t&&this.u(k,{key:o,external:!0});for(const[o]of p.items)s.has(o)||this.u(k,{key:o,external:!0})})}}e.$9o=E;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$0o=v;class $ extends E{constructor(){super(),this.U=this.B(new b.$3o(new b.$4o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$3o(new b.$4o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$3o(new b.$4o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(1,I))),this.B(this.W.onDidChangeStorage(I=>this.u(0,I))),this.B(this.U.onDidChangeStorage(I=>this.u(-1,I)))}P(I){switch(I){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$$o=$;async function h(f,I,p,k,s,o){const t=H=>{try{return JSON.parse(H)}catch{return H}},i=new Map,n=new Map;f.forEach((H,_)=>{i.set(_,H),n.set(_,t(H))});const r=new Map,l=new Map;I.forEach((H,_)=>{r.set(_,H),l.set(_,t(H))});const P=new Map,y=new Map;p.forEach((H,_)=>{P.set(_,H),y.set(_,t(H))}),console.group(k!==s?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const w=[];if(i.forEach((H,_)=>{w.push({key:_,value:H})}),console.table(w),console.groupEnd(),console.log(n),k!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const H=[];r.forEach((_,x)=>{H.push({key:x,value:_})}),console.table(H),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const O=[];P.forEach((H,_)=>{O.push({key:_,value:H})}),console.table(O),console.groupEnd(),console.log(y)}e.$_o=h}),define(ne[158],re([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E,v,$,h,f,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=void 0;const s=j.$p?"web":(0,N.$6n)(j.$u,D.$ec),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((m,F)=>m|F,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(m=y){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,F=this.d.pageSize){return new w({...this.d,pageNumber:m,pageSize:F})}withFilter(m,...F){const C=[...this.d.criteria,...F.length?F.map(Z=>({filterType:m,value:Z})):[{filterType:m}]];return new w({...this.d,criteria:C})}withSortBy(m){return new w({...this.d,sortBy:m})}withSortOrder(m){return new w({...this.d,sortOrder:m})}withFlags(...m){return new w({...this.d,flags:m.reduce((F,C)=>F|C,0)})}withAssetTypes(...m){return new w({...this.d,assetTypes:m})}withSource(m){return new w({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:F,pageSize:C,sortBy:Z,sortOrder:W,flags:ce,assetTypes:oe}=this.d;return{filters:[{criteria:m,pageNumber:F,pageSize:C,sortBy:Z,sortOrder:W}],assetTypes:oe,flags:ce}}get searchText(){const m=this.d.criteria.filter(F=>F.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(a,m){const F=(a||[]).filter(C=>C.statisticName===m)[0];return F?F.value:0}function H(a){const m="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(C=>C.assetType.indexOf(m)===0).reduce((C,Z)=>{const W=ue(a,Z.assetType);return W&&C.push([Z.assetType.substring(m.length),W]),C},[])}function _(a){if(a.properties){const m=a.properties.filter(Z=>Z.key===r.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),C=m.filter(Z=>F.test(Z.value))[0];return C?{uri:C.value,fallbackUri:C.value}:null}return ue(a,r.Repository)}function x(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function ue(a,m){return a.files.filter(C=>C.assetType===m)[0]?{uri:`${a.assetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function te(a,m){const F=a.properties?a.properties.filter(Z=>Z.key===m):[],C=F.length>0&&F[0].value;return C?C.split(",").map(Z=>(0,g.$Eo)(Z)):[]}function ae(a){const m=a.properties?a.properties.filter(F=>F.key===l.Engine):[];return m.length>0&&m[0].value||""}function le(a){const m=a.properties?a.properties.filter(F=>F.key===l.PreRelease):[];return m.length>0&&m[0].value==="true"}function ie(a){const m=a.properties?a.properties.filter(C=>C.key===l.LocalizedLanguages):[],F=m.length>0&&m[0].value||"";return F?F.split(","):[]}function q(a){return a.properties?.find(m=>m.key===l.SponsorLink)?.value}function J(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,N.$5n)(a.targetPlatform):"undefined"}function U(a){const m=(0,L.$Mb)(a.versions.map(T)),F=!!a.tags?.includes(N.$Zn),C=m.indexOf("web");return F?C===-1&&m.push("web"):C!==-1&&m.splice(C,1),m}function B(a,m){const F=(0,N.$9n)(m);for(let C=0;C<a.length;C++){const Z=a[C];if(Z.version===a[C-1]?.version){let W=C;const ce=T(Z);if(ce===m)for(;W>0&&a[W-1].version===Z.version;)W--;else if(F.includes(ce))for(;W>0&&a[W-1].version===Z.version&&T(a[W-1])!==m;)W--;W!==C&&(a.splice(C,1),a.splice(W,0,Z))}}return a}e.$cp=B;function X(a,m,F){a.telemetryData={index:m,querySource:F,queryActivityId:a.queryContext?.[o]}}function Q(a,m,F,C){const Z=a.versions[0],W={manifest:ue(m,r.Manifest),readme:ue(m,r.Details),changelog:ue(m,r.Changelog),license:ue(m,r.License),repository:_(m),download:x(m),icon:ue(m,r.Icon),signature:ue(m,r.Signature),coreTranslations:H(m)};return{identifier:{id:(0,g.$Fo)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:m.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Z),description:a.shortDescription||"",installCount:O(a.statistics,"install"),rating:O(a.statistics,"averagerating"),ratingCount:O(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:F,assets:W,properties:{dependencies:te(m,l.Dependency),extensionPack:te(m,l.ExtensionPack),engine:ae(m),localizedLanguages:ie(m),targetPlatform:T(m),isPreReleaseVersion:le(m)},hasPreReleaseVersion:le(Z),hasReleaseVersion:!0,preview:J(a.flags),isSigned:!!W.signature,queryContext:C}}let K=class{constructor(m,F,C,Z,W,ce,oe,me){this.k=F,this.l=C,this.n=Z,this.o=W,this.q=ce,this.u=oe,this.w=me;const de=oe.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$bp)(oe.version,oe,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,F,C){const Z=R.CancellationToken.isCancellationToken(F)?{}:F,W=R.CancellationToken.isCancellationToken(F)?F:C,ce=[],oe=[],me=[],de=[];let ge=!0;for(const we of m){we.uuid?oe.push(we.uuid):ce.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!oe.length&&!ce.length)return[];let fe=new w().withPage(1,m.length);oe.length&&(fe=fe.withFilter(n.ExtensionId,...oe)),ce.length&&(fe=fe.withFilter(n.ExtensionName,...ce)),(Z.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),Z.source&&(fe=fe.withSource(Z.source));const{extensions:he}=await this.z(fe,{targetPlatform:Z.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!Z.compatible},W);return Z.source&&he.forEach((we,be)=>X(we,be,Z.source)),he}async getCompatibleExtension(m,F,C){if((0,N.$7n)(m.allTargetPlatforms,C))return null;if(await this.isExtensionCompatible(m,F,C))return m;const Z=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:W}=await this.z(Z,{targetPlatform:C,compatible:!0,includePreRelease:F},R.CancellationToken.None);return W[0]||null}async isExtensionCompatible(m,F,C){if(!(0,N.$8n)(m.properties.targetPlatform,m.allTargetPlatforms,C)||!F&&m.properties.isPreReleaseVersion)return!1;let Z=m.properties.engine;if(!Z){const W=await this.getManifest(m,R.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Z=W.engines.vscode}return(0,d.$So)(Z,this.u.version,this.u.date)}async y(m,F,C,Z,W){if(!(0,N.$8n)(T(m),Z,W)||F!=="any"&&le(m)!==(F==="prerelease"))return!1;if(C)try{const ce=await this.E(m);if(!(0,d.$So)(ce,this.u.version,this.u.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,A.$0)(ce)),!1}return!0}async query(m,F){let C=m.text||"";const Z=m.pageSize??50;let W=new w().withPage(1,Z);C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),W=W.withFilter(n.SearchText,C)),W=W.withSortBy(0)):m.ids?W=W.withFilter(n.ExtensionId,...m.ids):m.names?W=W.withFilter(n.ExtensionName,...m.names):W=W.withSortBy(4),typeof m.sortBy=="number"&&(W=W.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(W=W.withSortOrder(m.sortOrder)),m.source&&(W=W.withSource(m.source));const ce=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,ke)=>X(be,(ge.pageNumber-1)*ge.pageSize+ke,m.source)),{extensions:he,total:we}},{extensions:oe,total:me}=await ce(W,F),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new A.$5;const{extensions:he}=await ce(W.withPage(ge+1),fe);return he};return{firstPage:oe,total:me,pageSize:W.pageSize,getPage:de}}async z(m,F,C){const Z=m.flags;m.flags&t.IncludeLatestVersionOnly&&m.flags&t.IncludeVersions&&(m=m.withFlags(m.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(m.flags&t.IncludeLatestVersionOnly)&&!(m.flags&t.IncludeVersions)&&(m=m.withFlags(m.flags,t.IncludeLatestVersionOnly)),F.versions?.length&&(m=m.withFlags(m.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),m=m.withFlags(m.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:ce,context:oe}=await this.B(m,C);if(!(m.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,F,oe);we&&fe.push(we)}return{extensions:fe,total:ce}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,g.$Fo)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,b.$Ef)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(Me=>(0,g.$Ao)(Me,we))?.includePreRelease;if(F.compatible&&(0,N.$7n)(U(he),F.targetPlatform))continue;const ke=await this.A(he,F,oe);!ke||ke.properties.isPreReleaseVersion&&(!be||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==F.targetPlatform&&ke.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,ke])}if(ge.size){const fe=new k.$Jd,he=new w().withFlags(Z&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,F,C);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const ke=ge.get(be.identifier.uuid);de.push([ke,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:ce}}async A(m,F,C){const Z={id:(0,g.$Fo)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},W=F.versions?.find(de=>(0,g.$Ao)(de,Z))?.version,ce=(0,b.$Ef)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(de=>(0,g.$Ao)(de,Z))?.includePreRelease,oe=U(m),me=B(m.versions,F.targetPlatform);if(F.compatible&&(0,N.$7n)(oe,F.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,ce?"any":"release",F.compatible,oe,F.targetPlatform))return Q(m,ge,oe,C);if(W&&ge.version===W)return null}}return W||F.compatible?null:Q(m,m.versions[0],oe)}async B(m,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const C=await this.j,Z=JSON.stringify(m.raw),W={...C,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},ce=new k.$Jd;let oe,me,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Z,headers:W},F),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,h.$Zo)(oe);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(Z.length),duration:ce.elapsed(),success:!!oe&&(0,h.$Vo)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:me?(0,A.$4)(me)?"canceled":(0,A.$0)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,F,C,Z){if(!this.isEnabled())return;const W=j.$p?this.x(`/itemName/${m}.${F}/version/${C}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${F}/${C}/stats?statType=${Z}`),ce=j.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:W,headers:me},R.CancellationToken.None)}catch{}}async download(m,F,C){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const Z=(0,g.$Io)(m),W=new Date().getTime(),ce=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Z,duration:fe}),oe=C===2?"install":C===3?"update":"",me=oe?{uri:`${m.assets.download.uri}${u.URI.parse(m.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${m.assets.download.fallbackUri}${u.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:m.assets.download,de=m.queryContext?.[o]?{[o]:m.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(F,ge.stream),ce(new Date().getTime()-W)}async downloadSignatureArchive(m,F){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const C=await this.D(m.assets.signature);await this.q.writeFile(F,C.stream)}async getReadme(m,F){if(m.assets.readme){const C=await this.D(m.assets.readme,{},F);return await(0,h.$Yo)(C)||""}return""}async getManifest(m,F){if(m.assets.manifest){const C=await this.D(m.assets.manifest,{},F),Z=await(0,h.$Yo)(C);return Z?JSON.parse(Z):null}return null}async C(m,F){const C=ue(m,r.Manifest);if(!C)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},W=await this.D(C,{headers:Z});return await(0,h.$Zo)(W)}async getCoreTranslation(m,F){const C=m.assets.coreTranslations.filter(Z=>Z[0]===F.toUpperCase())[0];if(C){const Z=await this.D(C[1]),W=await(0,h.$Yo)(Z);return W?JSON.parse(W):null}return null}async getChangelog(m,F){if(m.assets.changelog){const C=await this.D(m.assets.changelog,{},F);return await(0,h.$Yo)(C)||""}return""}async getAllCompatibleVersions(m,F,C){let Z=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?Z=Z.withFilter(n.ExtensionId,m.identifier.uuid):Z=Z.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:W}=await this.B(Z,R.CancellationToken.None);if(!W.length)return[];const ce=U(W[0]);if((0,N.$7n)(ce,C))return[];const oe=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,F?"any":"release",!0,ce,C)&&oe.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of B(oe,C))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return me}async D(m,F={},C=R.CancellationToken.None){const Z=await this.j,W={type:"GET"},ce={...Z,...F.headers||{}};F={...F,...W,headers:ce};const oe=m.uri,me=m.fallbackUri,de={...F,url:oe};try{const ge=await this.k.request(de,C);if(ge.res.statusCode===200)return ge;const fe=await(0,h.$Yo)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,A.$4)(ge))throw ge;const fe=(0,A.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...F,url:me};return this.k.request(he,C)}}async E(m){let F=ae(m);if(!F){const C=await this.C(m,R.CancellationToken.None);if(!C)throw new Error("Manifest was not found");F=C.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,h.$Zo)(m),C=[],Z={},W=[];if(F){for(const ce of F.malicious)C.push({id:ce});if(F.migrateToPreRelease)for(const[ce,oe]of Object.entries(F.migrateToPreRelease))(!oe.engine||(0,d.$So)(oe.engine,this.u.version,this.u.date))&&(Z[ce.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[ce,oe]of Object.entries(F.deprecated))oe&&(Z[ce.toLowerCase()]=(0,b.$Ef)(oe)?{}:oe);if(F.search)for(const ce of F.search)W.push(ce)}return{malicious:C,deprecated:Z,search:W}}};K=pe([se(1,h.$To),se(2,v.$0i),se(3,S.$Wh),se(4,p.$cl),se(5,E.$$j),se(6,$.$pj),se(7,c.$ji)],K);let M=class extends K{constructor(m,F,C,Z,W,ce,oe,me){super(m,F,C,Z,W,ce,oe,me)}};e.$dp=M,e.$dp=M=pe([se(0,I.$7o),se(1,h.$To),se(2,v.$0i),se(3,S.$Wh),se(4,p.$cl),se(5,E.$$j),se(6,$.$pj),se(7,c.$ji)],M);let z=class extends K{constructor(m,F,C,Z,W,ce,oe){super(void 0,m,F,C,Z,W,ce,oe)}};e.$ep=z,e.$ep=z=pe([se(0,h.$To),se(1,v.$0i),se(2,S.$Wh),se(3,p.$cl),se(4,E.$$j),se(5,$.$pj),se(6,c.$ji)],z)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(G,e,L,R,A,j,D,b,u,c,S){"use strict";var N,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=e.$BN=e.$AN=void 0;let d=class extends u.$Nk{static{N=this}static{this.a="profileAssociationsMigration"}constructor(h,f,I,p,k){super(I,p,f,k),this.U=h,this.W=I}O(){return this.U.getItem(N.b,[]).map(f=>({...f,location:(0,c.$yf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):L.URI.revive(f.location)}))}Q(){const h=this.U.getItem(N.c,{});return this.U.getItem(N.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$AN=d,e.$AN=d=N=pe([se(0,D.$vN),se(1,b.$Ik),se(2,R.$Xh),se(3,A.$$j),se(4,j.$0i)],d);let E=g=class extends d{constructor(h,f,I,p,k){super(h,f,I,p,k),this.$=h}P(h){h.length?this.$.setItem(g.b,h.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(g.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(g.c,h):this.$.removeItem(g.c)}Q(){const h="workspaceAndProfileInfo",f=this.$.getItem(h,void 0);if(f){this.$.removeItem(h);const p=f.reduce((k,{workspace:s,profile:o})=>(k[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),k),{});this.$.setItem(g.c,{workspaces:p})}const I=super.Q();return this.$.getItem(g.a,!1)||(this.R(I),this.$.setItem(g.a,!0)),I}};e.$BN=E,e.$BN=E=g=pe([se(0,D.$wN),se(1,b.$Ik),se(2,R.$Xh),se(3,A.$$j),se(4,j.$0i)],E);let v=class extends E{constructor(h,f,I,p){super(new S.$zN(0,f,p,I),h,f,I,p)}async init(){return await this.$.init(),super.init()}};e.$CN=v,e.$CN=v=pe([se(0,b.$Ik),se(1,R.$Xh),se(2,A.$$j),se(3,j.$0i)],v)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(G,e,L,R,A,j,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.zip=e.$mp=e.$lp=void 0,e.$lp="end of central directory record signature not found";const S=new RegExp(e.$lp);class N extends Error{constructor(o,t){let i=t.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=t}}e.$mp=N;function g(s){const o=s.externalFileAttributes>>16||33188;return[448,56,7].map(t=>o&t).reduce((t,i)=>t+i,o&61440)}function d(s){if(s instanceof N)return s;let o;return S.test(s.message)&&(o="CorruptZip"),new N(o,s)}function E(s,o,t,i,n,r){const l=A.$mc(o),P=A.$jc(i,l);if(!P.startsWith(i))return Promise.reject(new Error(b.localize(0,null,o)));const y=A.$jc(i,o);let w;return r.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(D.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((O,H)=>{if(!r.isCancellationRequested)try{w=(0,L.createWriteStream)(y,{mode:t}),w.once("close",()=>O()),w.once("error",H),s.once("error",H),s.pipe(w)}catch(_){H(_)}}))}function v(s,o,t,i){let n=(0,R.$Hg)(()=>Promise.resolve()),r=0;const l=i.onCancellationRequested(()=>{n.cancel(),s.close()});return new Promise((P,y)=>{const w=new R.$Og,O=H=>{H.isCancellationRequested||(r++,s.readEntry())};s.once("error",y),s.once("close",()=>n.then(()=>{i.isCancellationRequested||s.entryCount===r?P():y(new N("Incomplete",new Error(b.localize(1,null,r,s.entryCount))))},y)),s.readEntry(),s.on("entry",H=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(H.fileName)){O(i);return}const _=H.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(_)){const te=A.$jc(o,_);n=(0,R.$Hg)(ae=>D.Promises.mkdir(te,{recursive:!0}).then(()=>O(ae)).then(void 0,y));return}const x=h(s,H),ue=g(H);n=(0,R.$Hg)(te=>w.queue(()=>x.then(ae=>E(ae,_,ue,o,t,te).then(()=>O(te)))).then(null,y))})}).finally(()=>l.dispose())}function $(s,o=!1){return new Promise((t,i)=>{(0,u.open)(s,o?{lazyEntries:!0}:void 0,(n,r)=>{n?i(d(n)):t((0,j.$Jf)(r))})})}function h(s,o){return new Promise((t,i)=>{s.openReadStream(o,(n,r)=>{n?i(d(n)):t((0,j.$Jf)(r))})})}function f(s,o){return new Promise((t,i)=>{const n=new c.ZipFile;o.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const r=(0,L.createWriteStream)(s);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>t(s))})}e.zip=f;function I(s,o,t={},i){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let r=$(s,!0);return t.overwrite&&(r=r.then(l=>D.Promises.rm(o).then(()=>l))),r.then(l=>v(l,o,{sourcePathRegex:n},i))}e.$op=I;function p(s,o){return $(s).then(t=>new Promise((i,n)=>{t.on("entry",r=>{r.fileName===o&&h(t,r).then(l=>i(l),l=>n(l))}),t.once("close",()=>n(new Error(b.localize(2,null,o))))}))}function k(s,o){return p(s,o).then(t=>new Promise((i,n)=>{const r=[];t.once("error",n),t.on("data",l=>r.push(l)),t.on("end",()=>i(Buffer.concat(r)))}))}e.$pp=k}),define(ne[160],re([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E,v,$,h,f){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;let p=class extends A.$Sc{static{I=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,D.$vg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new E.$_n(r.message,E.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(l){const P=l;if(n=P.code,P.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${P.output}`),n===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new E.$_n(N.$lp,E.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,u.$Ef)(o)?o:!0}async u(s){await this.g;const o=(0,D.$vg)(this.extensionsDownloadDir,`${this.z(s)}${I.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await t(o);return}const i=(0,D.$vg)(this.extensionsDownloadDir,`.${(0,c.$eg)()}`);await this.h.exists(i)||await t(i);try{await S.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,R.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const l of s.children)if(l.name.endsWith(I.c))i.push(l.resource);else{const P=v.$Bo.parse(l.name);P&&t.push([P,l])}const n=(0,v.$Go)(t,([l])=>l),r=[];for(const l of n)l.sort((P,y)=>b.rcompare(P[0].version,y[0].version)),o.push(...l.slice(1).map(P=>P[1].resource)),r.push(l[0][1]);r.sort((l,P)=>l.mtime-P.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),o.push(...i),await L.Promises.settled(o.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?v.$Bo.create(s).toString().toLowerCase():(0,c.$eg)()}};e.$Ep=p,e.$Ep=p=I=pe([se(0,d.$Xh),se(1,h.$$j),se(2,E.$$n),se(3,g.$ji),se(4,$.$fp),se(5,f.$0i)],p)}),define(ne[161],re([0,1,51,97]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;function A(j){return(0,L.$pp)(j,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.$Gp=A}),define(ne[162],re([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E,v,$,h,f,I,p,k,s,o,t,i,n,r,l,P,y,w,O,H,_,x,ue,te,ae,le,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Jp=(0,x.$Qh)(t.$ao);const q=".vsctmp";let J=class extends o.$qp{constructor(M,z,a,m,F,C,Z,W,ce,oe,me,de){super(M,z,me,a,oe,de),this.fb=F,this.gb=C,this.hb=Z,this.ib=ce,this.eb=new Map,this.rb=new S.$Bc;const ge=this.B(W.createInstance(P.$Fp));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new w.$Hp(de,ce,me,this,this.F)),this.db=this.B(W.createInstance(l.$Ep));const fe=this.B(new O.$Ip(this,this.fb,de,C,me,ce,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Lo)(this.ib,this.F)),this.jb}async zip(M){this.F.trace("ExtensionManagementService#zip",M.identifier.id);const z=await this.pb(M),a=await(0,I.zip)((0,d.$vg)(this.db.extensionsDownloadDir,(0,h.$eg)()).fsPath,z);return $.URI.file(a)}async unzip(M){return this.F.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:z,cleanup:a}=await this.lb(M),m=g.$kc(z.fsPath);try{return await(0,y.$Gp)(m)}finally{await a()}}getInstalled(M,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(M??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.bb.scanUserExtensionAtLocation(M)}async install(M,z={}){this.F.trace("ExtensionManagementService#install",M.toString());const{location:a,cleanup:m}=await this.lb(M);try{const F=await(0,y.$Gp)(g.$kc(a.fsPath)),C=(0,i.$Fo)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,H.$So)(F.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,C,this.G.version));const W=(await this.I([{manifest:F,extension:a,options:z}])).find(({identifier:ce})=>(0,i.$Ao)(ce,{id:C}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$sp)(new Error(`Unknown error while installing extension ${C}`))}finally{await m()}}async installFromLocation(M,z){this.F.trace("ExtensionManagementService#installFromLocation",M.toString());const a=await this.bb.scanUserExtensionAtLocation(M);if(!a)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.ub([[a,void 0]],z),this.F.info("Successfully installed extension",a.identifier.id,z.toString()),a}async installExtensionsFromProfile(M,z,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",M,z.toString(),a.toString());const m=(await this.bb.scanExtensions(1,z)).filter(F=>M.some(C=>(0,i.$Ao)(C,F.identifier)));if(m.length){const F=await Promise.all(m.map(C=>this.bb.scanMetadata(C,z)));await this.ub(m.map((C,Z)=>[C,F[Z]]),a),this.F.info("Successfully installed extensions",m.map(C=>C.identifier.id),a.toString())}return m}async updateMetadata(M,z,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",M.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),M=await this.bb.updateMetadata(M,z,a),this.cb.invalidate(a),this.w.fire(M),M}async reinstallFromGallery(M){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:z,compatible:!0},A.CancellationToken.None);if(!a)throw new Error(p.localize(2,null));await this.bb.setUninstalled(M);try{await this.bb.removeUninstalledExtension(M)}catch(m){throw new Error(p.localize(3,null,(0,j.$Ai)(m)))}return this.installFromGallery(a)}ab(M,z,a,m){return this.bb.copyExtension(M,z,a,m)}copyExtensions(M,z){return this.bb.copyExtensions(M,z)}markAsUninstalled(...M){return this.bb.setUninstalled(...M)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(M){this.F.error(M)}}async download(M,z,a){const{location:m}=await this.db.download(M,z,!a);return m}async lb(M){if(M.scheme===N.Schemas.file)return{location:M,async cleanup(){}};this.F.trace("Downloading extension from",M.toString());const z=(0,d.$vg)(this.db.extensionsDownloadDir,(0,h.$eg)());return await this.hb.download(M,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(m){this.F.error(m)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(M,z,a){if($.URI.isUri(z))return new X(M,z,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const m=i.$Bo.create(z).toString();let F=this.eb.get(m);return F||(this.eb.set(m,F=new B(M,z,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),F.waitUntilTaskIsFinished().finally(()=>this.eb.delete(m))),F}$(M,z){return new Q(M,z.profileLocation,this.gb)}async pb(M){const z=async m=>{let F=await f.Promises.readdir(m);F=F.map(W=>g.$jc(m,W));const C=await Promise.all(F.map(W=>f.Promises.stat(W)));let Z=Promise.resolve([]);return C.forEach((W,ce)=>{const oe=F[ce];W.isFile()&&(Z=Z.then(me=>[...me,oe])),W.isDirectory()&&(Z=Z.then(me=>z(oe).then(de=>[...me,...de])))}),Z};return(await z(M.location.fsPath)).map(m=>({path:`extension/${g.$lc(M.location.fsPath,m)}`,localPath:m}))}async qb({added:M,removed:z}){if(z){const a=M&&this.D.extUri.isEqual(z.profileLocation,M.profileLocation)?z.extensions.filter(m=>M.extensions.every(F=>!(0,i.$Ao)(F,m))):z.extensions;for(const m of a)this.F.info("Extensions removed from another source",m.id,z.profileLocation.toString()),this.u.fire({identifier:m,profileLocation:z.profileLocation})}if(M){const m=(await this.bb.scanExtensions(1,M.profileLocation)).filter(F=>M.extensions.some(C=>(0,i.$Ao)(C,F.identifier)));this.s.fire(m.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,M.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:M.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const M=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of M.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(M){if(!M.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const a of M.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const m=await this.bb.scanUserExtensionAtLocation(a);m&&m.installedTimestamp===void 0&&(this.rb.add(a),z.push(m))}z.length&&(await this.ub(z.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(a=>a.identifier.id)))}async ub(M,z){const a=M.map(m=>m[0]);await this.vb(a),await this.gb.addExtensionsToProfile(M,z),this.s.fire(a.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:z})))}async vb(M){const z=await this.bb.getUninstalledExtensions();for(const a of M){const m=i.$Bo.create(a);z[m.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",m.id),await this.bb.setInstalled(m),this.F.info("Removed the extension from uninstalled list:",m.id))}}};e.$Kp=J,e.$Kp=J=pe([se(0,t.$$n),se(1,ae.$cl),se(2,ue.$0i),se(3,s.$Xh),se(4,r.$zp),se(5,n.$vp),se(6,k.$On),se(7,x.$Oh),se(8,_.$$j),se(9,te.$pj),se(10,le.$Ik),se(11,ie.$Kk)],J);let T=class extends c.$Sc{constructor(M,z,a,m,F,C){super(),this.j=M,this.m=z,this.n=a,this.s=m,this.t=F,this.u=C,this.h=this.B(new b.$Nd),this.onExtract=this.h.event,this.c=(0,d.$vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$1g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(M,z){const a={includeInvalid:!0,profileLocation:z};let m=[];return M===null||M===0?m.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):M===1&&m.push(...await this.n.scanUserExtensions(a)),m=M!==null?m.filter(F=>F.type===M):m,Promise.all(m.map(F=>this.F(F)))}async scanAllUserExtensions(M){const z=await this.n.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(z.map(a=>this.F(a)))}async scanUserExtensionAtLocation(M){try{const z=await this.n.scanExistingExtension(M,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(M,z,a,m,F){const C=M.toString(),Z=$.URI.file(g.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$eg)()}`)),W=$.URI.file(g.$jc(this.n.userExtensionsLocation.fsPath,C));let ce=await this.m.exists(W);if(ce&&m){try{await this.y(M.id,W,"removeExisting")}catch{throw new t.$_n(p.localize(4,null,W.fsPath,M.id),t.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.u.trace(`Started extracting the extension from ${z} to ${W.fsPath}`),await(0,I.$op)(z,Z.fsPath,{sourcePath:"extension",overwrite:!0},F),this.u.info(`Extracted extension to ${W}:`,M.id)}catch(oe){let me=t.ExtensionManagementErrorCode.Extract;throw oe instanceof I.$mp&&(oe.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$_n(oe.message,me)}await this.n.updateMetadata(Z,a);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${W.fsPath}`),await this.C(Z.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(oe)}. Deleted from extracted location`,Z),oe}this.h.fire(W)}catch(oe){try{await this.m.del(Z,{recursive:!0})}catch{}throw oe}return this.D(W,1)}async scanMetadata(M,z){return z?(await this.w(M,z))?.metadata:this.n.scanMetadata(M.location)}async w(M,z){return(await this.s.scanProfileExtensions(z)).find(m=>(0,i.$Ao)(m.identifier,M.identifier))}async updateMetadata(M,z,a){return a?await this.s.updateMetadata([[M,z]],a):await this.n.updateMetadata(M.location,z),this.D(M.location,M.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...M){const z=M.map(a=>i.$Bo.create(a));await this.z(a=>z.forEach(m=>{a[m.toString()]=!0,this.u.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(M){await this.z(z=>delete z[M.toString()])}async removeExtension(M,z){if(this.t.extUri.isEqualOrParent(M.location,this.n.userExtensionsLocation))return this.y(M.identifier.id,M.location,z)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.z(z=>delete z[i.$Bo.create(M).toString()])}async copyExtension(M,z,a,m){const F=await this.w(M,z),C=await this.w(M,a);return m={...F?.metadata,...m},C?await this.s.updateMetadata([[M,{...C.metadata,...m}]],a):await this.s.addExtensionsToProfile([[M,m]],a),this.D(M.location,M.type,a)}async copyExtensions(M,z){const a=await this.scanExtensions(1,M),m=await Promise.all(a.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,M)]));await this.s.addExtensionsToProfile(m,z)}async y(M,z,a){this.u.trace(`Deleting ${a} extension from disk`,M,z.fsPath);const m=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,u.$Di)((0,h.$eg)()).toString(16)}${q}`);await this.C(z.fsPath,m.fsPath),await this.m.del(m,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,M,z.fsPath)}async z(M){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,_.$pk)(m)!==1)throw m}let a={};if(z)try{a=JSON.parse(z)}catch{}return M&&(M(a),Object.keys(a).length?await this.m.writeFile(this.c,R.$be.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(M,z){try{await f.Promises.rename(M,z,2*60*1e3)}catch(a){throw new t.$_n(a.message||p.localize(5,null,M,z),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(M,z,a){if(a){const F=(await this.n.scanUserExtensions({profileLocation:a})).find(C=>this.t.extUri.isEqual(C.location,M));if(F)return this.F(F)}else{const m=await this.n.scanExistingExtension(M,z,{includeInvalid:!0});if(m)return this.F(m)}throw new Error(p.localize(6,null,M.path))}async F(M){const z=await this.m.resolve(M.location);let a,m;return z.children&&(a=z.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,m=z.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:a,changelogUrl:m,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned}}async G(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(M));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const F of z)M[i.$Bo.create(F).toString()]||a.add(F.identifier.id.toLowerCase());try{const F=(0,i.$Go)(z,C=>C.identifier);await L.Promises.settled(F.map(async C=>{const Z=C.sort((W,ce)=>E.rcompare(W.manifest.version,ce.manifest.version))[0];a.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(F){this.u.error(F)}const m=z.filter(F=>F.metadata&&M[i.$Bo.create(F).toString()]);await Promise.allSettled(m.map(F=>this.removeUninstalledExtension(F)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let M;try{M=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,_.$pk)(z)!==1&&this.u.error(z);return}if(M?.children)try{await Promise.allSettled(M.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(a){(0,_.$pk)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Lp=T,e.$Lp=T=pe([se(1,_.$$j),se(2,r.$zp),se(3,n.$vp),se(4,le.$Ik),se(5,ue.$0i)],T);class U extends o.$tp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$Ff)(this.options.operation)?this.l:this.options.operation}constructor(M,z,a,m,F,C,Z,W,ce){super(),this.identifier=M,this.source=z,this.options=a,this.m=m,this.n=F,this.o=C,this.p=Z,this.q=W,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(M){const[z,a]=await this.x(M);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,a]],this.j),z}async u({zipPath:M,key:z,metadata:a},m,F){let C=await this.v(z);return C||(this.s.trace("Extracting extension...",z.id),C=await this.m.extractUserExtension(z,M,a,m,F),this.s.info("Extracting extension completed.",z.id)),C}async v(M){return await this.w(M)?(this.s.trace("Removing the extension from uninstalled list:",M.id),await this.m.setInstalled(M),this.s.info("Removed the extension from uninstalled list:",M.id),(await this.m.scanAllUserExtensions(!0)).find(m=>i.$Bo.create(m).equals(M))):void 0}async w(M){return!!(await this.m.getUninstalledExtensions())[M.toString()]}}class B extends U{constructor(M,z,a,m,F,C,Z,W,ce,oe){super(z.identifier,z,a,F,C,Z,W,ce,oe),this.y=z,this.z=m}async x(M){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Z=>(0,i.$Ao)(Z.identifier,this.y.identifier));a&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,v.$Ef)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,m),m];const{location:F,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(F.fsPath),[await this.u({zipPath:F.fsPath,key:i.$Bo.create(this.y),metadata:m},!1,M),m]}catch(Z){try{await this.z.delete(F)}catch(W){this.s.warn("Error while deleting the downloaded file",F.toString(),(0,D.$0)(W))}throw Z}}async B(M){try{await(0,y.$Gp)(M)}catch(z){throw new t.$_n((0,o.$rp)(z).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Mp=B;class X extends U{constructor(M,z,a,m,F,C,Z,W,ce,oe){super({id:(0,i.$Fo)(M.publisher,M.name)},z,a,F,C,Z,W,ce,oe),this.y=M,this.z=z,this.A=m}async h(M){const z=await super.h(M);return this.D(z,M),z}async x(M){const z=new i.$Bo(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,i.$Ao)(this.identifier,Z.identifier)),F={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this.l=3,z.equals(new i.$Bo(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&E.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const Z=await this.v(z);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$kc(this.z.fsPath),key:z,metadata:F},!0,M),F]}async D(M,z){try{let[a]=await this.A.getExtensions([{id:M.identifier.id,version:M.manifest.version}],z);if(a||([a]=await this.A.getExtensions([{id:M.identifier.id}],z)),a){const m={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(M,m,this.options.profileLocation)}}catch{}}}class Q extends o.$tp{constructor(M,z,a){super(),this.extension=M,this.j=z,this.k=a}async h(M){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;let E=class extends N.$Uo{constructor(f,I,p,k){super(k),this.m=f,this.n=I,this.r=p,this.s(),this.B(f.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,I){const{f:p,g:k}=this;let s;try{s=await(0,c.$Tl)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,j.$0)(i)))}const o={...process.env,...s},t=f.agent?f.agent:await(0,g.$Yq)(f.url||"",o,{proxyUrl:p,strictSSL:k});return f.agent=t,f.strictSSL=k,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>$(f,I))}async resolveProxy(f){}};e.$Zq=E,e.$Zq=E=pe([se(0,b.$ji),se(1,u.$Xh),se(2,S.$0i),se(3,S.$$i)],E);async function v(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((p,k)=>{G(["https"],p,k)}):await new Promise((p,k)=>{G(["http"],p,k)})).request}async function $(h,f){return R.Promises.withAsyncBody(async(I,p)=>{const k=(0,L.parse)(h.url),s=h.getRawRequest?h.getRawRequest(h):await v(h),o={hostname:k.hostname,port:k.port?parseInt(k.port):k.protocol==="https:"?443:80,protocol:k.protocol,path:k.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,D.$Ef)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(o.auth=h.user+":"+h.password);const t=s(o,i=>{const n=(0,D.$Cf)(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...h,url:i.headers.location,followRedirects:n-1},f).then(I,p);else{let r=i;!h.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,d.createGunzip)())),I({res:i,stream:(0,A.$qe)(r)})}});t.on("error",p),h.timeout&&t.setTimeout(h.timeout),h.isChromiumNetwork&&t.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&t.write(h.data),t.end(),f.onCancellationRequested(()=>{t.abort(),p(new j.$5)})})}e.$1q=$}),define(ne[179],re([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(G,e,L,R,A,j,D,b,u,c,S,N,g,d,E,v,$,h,f,I,p,k,s,o,t,i,n,r,l,P,y,w,O,H,_,x,ue,te,ae,le,ie,q,J,T,U,B,X,Q,K,M,z,a,m,F,C,Z,W,ce,oe,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends D.$Sc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const ke=be.get(x.$0i),Me=be.get(r.$$j),V=be.get(h.$Xh),Y=be.get(m.$Kk);ke.info("CLI main",this.b),this.g(ke),await this.h(V,Me,Y,he),await Promise.all(we.map(ee=>{(0,R.$Lg)(ee.flush(),1e3)}))})}async f(){const he=new O.$Nh,we={_serviceBrand:void 0,...le.default};he.set(ie.$pj,we);const be=new f.$jm(this.b,we);he.set(h.$Xh,be),await Promise.all([be.appSettingsHome.with({scheme:b.Schemas.file}).fsPath,be.extensionsPath].map(je=>je?g.Promises.mkdir(je,{recursive:!0}):void 0));const ke=new ce.$uN((0,x.$lj)(be),be.logsHome);he.set(x.$$i,ke);const Me=this.B(ke.createLogger("cli",{name:(0,oe.localize)(0,null)})),V=[];ke.getLogLevel()===x.LogLevel.Trace&&V.push(new x.$fj(ke.getLogLevel()));const Y=this.B(new W.$EN(Me,V));he.set(x.$0i,Y);const ee=this.B(new l.$Op(Y));he.set(r.$$j,ee);const $e=this.B(new P.$bq(Y));ee.registerProvider(b.Schemas.file,$e);const ye=new a.$Ar(ee);he.set(z.$Ik,ye);const Ae=new T.$yN(1,be,Y,ee),Se=new F.$AN(Ae,ye,be,ee,Y);he.set(m.$Kk,Se),ee.registerProvider(b.Schemas.vscodeUserData,new me.$f8b(b.Schemas.file,$e,b.Schemas.vscodeUserData,Se,ye,Y));const Le=c.$j&&we.win32RegValueName?this.B(new ae.$d8b(Y,we.win32RegValueName)):be.policyFile?this.B(new ue.$e8b(be.policyFile,ee,Y)):new te.$kn;he.set(te.$in,Le);const Ie=this.B(new E.$Kn(Se.defaultProfile.settingsResource,ee,Le,Y));he.set(d.$ji,Ie),await Promise.all([Ae.init(),Ie.initialize()]);let De;try{De=await(0,C.$T7b)(Ae,Y)}catch(je){je.code!=="ENOENT"&&Y.error(je)}const Ue=await(0,C.$U7b)(Ae,Y);Se.init(),he.set(z.$Ik,new a.$Ar(ee));const Ne=new J.$Zq(Ie,be,Y,ke);he.set(q.$To,Ne),he.set(v.$On,new y.$Mh($.$TN,void 0,!0)),he.set(o.$vp,new y.$Mh(Z.$DN,void 0,!0)),he.set(t.$zp,new y.$Mh(n.$Q7b,void 0,!0)),he.set(k.$fp,new y.$Mh(k.$gp,void 0,!0)),he.set(i.$Jp,new y.$Mh(i.$Kp,void 0,!0)),he.set(p.$$n,new y.$Mh(I.$ep,void 0,!0)),he.set(H.$Tq,new y.$Mh(_.$Vq,void 0,!1));const Re=[],ze=(0,Q.$xo)(we,Ie);if((0,Q.$so)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Re.push(new K.$sN(Ne,ze,"monacoworkbench",null,we.aiConfig.ariaKey));const je={appenders:Re,sendErrorTelemetry:!1,commonProperties:(0,U.$io)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,De,Ue,ze),piiPaths:(0,Q.$yo)(be)};he.set(B.$cl,new y.$Mh(X.$2q,[je],!1))}else he.set(B.$cl,Q.$mo);return[new w.$eq(he),Re]}g(he){(0,j.setUnexpectedErrorHandler)(we=>{const be=(0,A.$Ai)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,j.$Z)(we)||(0,j.$1)(we)}),process.on("unhandledRejection",we=>(0,j.$1)(we))}async h(he,we,be,ke){let Me;if(he.args.profile&&(Me=be.profiles.find(Y=>Y.name===he.args.profile),!Me))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Me??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(s.$hp,new x.$fj(x.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Y={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return ke.createInstance(s.$hp,new x.$fj(x.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Y,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(s.$hp,new x.$fj(x.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return ke.createInstance(s.$hp,new x.$fj(x.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,M.$B8b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?N.URI.file((0,u.$ic)(we)?we:(0,u.$jc)((0,S.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c36b92c82064882a228487040187cfc13669c0f/core/vs/code/node/cliProcessMain.js.map
