/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],I=0,L=te.length;I<L;I++)e[I]=oe[te[I]];return e};define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const A=new Map,N=new Map,D=new Map,R=new Map;function k(l,d){l.has(d.detail)||l.set(d.detail,-d.timestamp)}function g(l,d){const p=l.get(d.detail);p&&(p>=0||l.set(d.detail,p+d.timestamp))}let C=[];typeof te=="function"&&typeof te.getStats=="function"&&(C=te.getStats().slice(0).sort((l,d)=>l.timestamp-d.timestamp));for(const l of C)switch(l.type){case 10:k(A,l);break;case 11:case 12:g(A,l);break;case 21:k(N,l);break;case 22:g(N,l);break;case 33:k(D,l);break;case 34:g(D,l);break;case 31:k(R,l);break;case 32:g(R,l);break}let E=0;D.forEach(l=>E+=l);function b(l){const d=[];return l.forEach((p,y)=>d.push([y,p])),d}return{amdLoad:b(A),amdInvoke:b(N),nodeRequire:b(D),nodeEval:b(R),nodeRequireTotal:E}}static toMarkdownTable(A,N){let D="";const R=[];return A.forEach((k,g)=>{R[g]=k.length}),N.forEach(k=>{k.forEach((g,C)=>{typeof g>"u"&&(g=k[C]="-");const E=g.toString().length;R[C]=Math.max(E,R[C])})}),A.forEach((k,g)=>{D+=`| ${k+" ".repeat(R[g]-k.toString().length)} `}),D+=`|
`,A.forEach((k,g)=>{D+=`| ${"-".repeat(R[g])} `}),D+=`|
`,N.forEach(k=>{k.forEach((g,C)=>{typeof g<"u"&&(D+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),D+=`|
`}),D}}e.$U=I}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function I(p,y,f){const c=L(p,y);if(c!==-1)return p[c]}e.$fb=I;function L(p,y,f=p.length-1){for(let c=f;c>=0;c--){const h=p[c];if(y(h))return c}return-1}e.$gb=L;function A(p,y){const f=N(p,y);return f===-1?void 0:p[f]}e.$hb=A;function N(p,y,f=0,c=p.length){let h=f,m=c;for(;h<m;){const S=Math.floor((h+m)/2);y(p[S])?h=S+1:m=S}return h-1}e.$ib=N;function D(p,y){const f=R(p,y);return f===p.length?void 0:p[f]}e.$jb=D;function R(p,y,f=0,c=p.length){let h=f,m=c;for(;h<m;){const S=Math.floor((h+m)/2);y(p[S])?m=S:h=S+1}return h}e.$kb=R;function k(p,y,f=0,c=p.length){const h=R(p,y,f,c);return h===p.length?-1:h}e.$lb=k;class g{static{this.assertInvariants=!1}constructor(y){this.e=y,this.c=0}findLastMonotonous(y){if(g.assertInvariants){if(this.d){for(const c of this.e)if(this.d(c)&&!y(c))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=y}const f=N(this.e,y,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$mb=g;function C(p,y){if(p.length===0)return;let f=p[0];for(let c=1;c<p.length;c++){const h=p[c];y(h,f)>0&&(f=h)}return f}e.$nb=C;function E(p,y){if(p.length===0)return;let f=p[0];for(let c=1;c<p.length;c++){const h=p[c];y(h,f)>=0&&(f=h)}return f}e.$ob=E;function b(p,y){return C(p,(f,c)=>-y(f,c))}e.$pb=b;function l(p,y){if(p.length===0)return-1;let f=0;for(let c=1;c<p.length;c++){const h=p[c];y(h,p[f])>0&&(f=c)}return f}e.$qb=l;function d(p,y){for(const f of p){const c=y(f);if(c!==void 0)return c}}e.$rb=d}),define(oe[126],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function I(D,R){const k=Object.create(null);for(const g of D){const C=R(g);let E=k[C];E||(E=k[C]=[]),E.push(g)}return k}e.$J=I;function L(D,R){const k=[],g=[];for(const C of D)R.has(C)||k.push(C);for(const C of R)D.has(C)||g.push(C);return{removed:k,added:g}}e.$K=L;function A(D,R){const k=[],g=[];for(const[C,E]of D)R.has(C)||k.push(E);for(const[C,E]of R)D.has(C)||g.push(E);return{removed:k,added:g}}e.$L=A;function N(D,R){const k=new Set;for(const g of R)D.has(g)&&k.add(g);return k}e.$M=N}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function I(D){return(R,k,g)=>{let C=null,E=null;if(typeof g.value=="function"?(C="value",E=g.value):typeof g.get=="function"&&(C="get",E=g.get),!E)throw new Error("not supported");g[C]=D(E,k)}}function L(D,R,k){let g=null,C=null;if(typeof k.value=="function"?(g="value",C=k.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(g="get",C=k.get),!C)throw new Error("not supported");const E=`$memoize$${R}`;k[g]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,b)}),this[E]}}e.$hh=L;function A(D,R,k){return I((g,C)=>{const E=`$debounce$${C}`,b=`$debounce$result$${C}`;return function(...l){this[b]||(this[b]=k?k():void 0),clearTimeout(this[E]),R&&(this[b]=R(this[b],...l),l=[this[b]]),this[E]=setTimeout(()=>{g.apply(this,l),this[b]=k?k():void 0},D)}})}e.$ih=A;function N(D,R,k){return I((g,C)=>{const E=`$throttle$timer$${C}`,b=`$throttle$result$${C}`,l=`$throttle$lastRun$${C}`,d=`$throttle$pending$${C}`;return function(...p){if(this[b]||(this[b]=k?k():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),R&&(this[b]=R(this[b],...p)),this[d])return;const y=this[l]+D;y<=Date.now()?(this[l]=Date.now(),g.apply(this,[this[b]]),this[b]=k?k():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[l]=Date.now(),g.apply(this,[this[b]]),this[b]=k?k():void 0},y-Date.now()))}})}e.$jh=N}),define(oe[8],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class I{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?h.isErrorNoTelemetry(s)?new h(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(a=>{a(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$W=I,e.$X=new I;function L(S){e.$X.setUnexpectedErrorHandler(S)}e.setUnexpectedErrorHandler=L;function A(S){if(!S||typeof S!="object")return!1;const s=S;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Z=A;function N(S){g(S)||e.$X.onUnexpectedError(S)}e.$1=N;function D(S){g(S)||e.$X.onUnexpectedExternalError(S)}e.$2=D;function R(S){if(S instanceof Error){const{name:s,message:a}=S,n=S.stacktrace||S.stack;return{$isError:!0,name:s,message:a,stack:n,noTelemetry:h.isErrorNoTelemetry(S)}}return S}e.$3=R;const k="Canceled";function g(S){return S instanceof C?!0:S instanceof Error&&S.name===k&&S.message===k}e.$4=g;class C extends Error{constructor(){super(k),this.name=this.message}}e.$5=C;function E(){const S=new Error(k);return S.name=S.message,S}e.$6=E;function b(S){return S?new Error(`Illegal argument: ${S}`):new Error("Illegal argument")}e.$7=b;function l(S){return S?new Error(`Illegal state: ${S}`):new Error("Illegal state")}e.$8=l;class d extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=d;function p(S){return S?S.message?S.message:S.stack?S.stack.split(`
`)[0]:String(S):"Error"}e.$0=p;class y extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$$=y;class f extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$_=f;class c extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=c;class h extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof h)return s;const a=new h;return a.message=s.message,a.stack=s.stack,a}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$bb=h;class m extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$cb=m}),define(oe[18],ae([0,1,8,125]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function A(F,V=0){return F[F.length-(1+V)]}e.$sb=A;function N(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$tb=N;function D(F,V,G=(re,ce)=>re===ce){if(F===V)return!0;if(!F||!V||F.length!==V.length)return!1;for(let re=0,ce=F.length;re<ce;re++)if(!G(F[re],V[re]))return!1;return!0}e.$ub=D;function R(F,V){const G=F.length-1;V<G&&(F[V]=F[G]),F.pop()}e.$vb=R;function k(F,V,G){return g(F.length,re=>G(F[re],V))}e.$wb=k;function g(F,V){let G=0,re=F-1;for(;G<=re;){const ce=(G+re)/2|0,ue=V(ce);if(ue<0)G=ce+1;else if(ue>0)re=ce-1;else return ce}return-(G+1)}e.$xb=g;function C(F,V,G){if(F=F|0,F>=V.length)throw new TypeError("invalid index");const re=V[Math.floor(V.length*Math.random())],ce=[],ue=[],he=[];for(const $e of V){const de=G($e,re);de<0?ce.push($e):de>0?ue.push($e):he.push($e)}return F<ce.length?C(F,ce,G):F<ce.length+he.length?he[0]:C(F-(ce.length+he.length),ue,G)}e.$yb=C;function E(F,V){const G=[];let re;for(const ce of F.slice(0).sort(V))!re||V(re[0],ce)!==0?(re=[ce],G.push(re)):re.push(ce);return G}e.$zb=E;function*b(F,V){let G,re;for(const ce of F)re!==void 0&&V(re,ce)?G.push(ce):(G&&(yield G),G=[ce]),re=ce;G&&(yield G)}e.$Ab=b;function l(F,V){for(let G=0;G<=F.length;G++)V(G===0?void 0:F[G-1],G===F.length?void 0:F[G])}e.$Bb=l;function d(F,V){for(let G=0;G<F.length;G++)V(G===0?void 0:F[G-1],F[G],G+1===F.length?void 0:F[G+1])}e.$Cb=d;function p(F,V,G){const re=[];function ce($e,de,we){if(de===0&&we.length===0)return;const Ee=re[re.length-1];Ee&&Ee.start+Ee.deleteCount===$e?(Ee.deleteCount+=de,Ee.toInsert.push(...we)):re.push({start:$e,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===F.length){ce(ue,0,V.slice(he));break}if(he===V.length){ce(ue,F.length-ue,[]);break}const $e=F[ue],de=V[he],we=G($e,de);we===0?(ue+=1,he+=1):we<0?(ce(ue,1,[]),ue+=1):we>0&&(ce(ue,0,[de]),he+=1)}return re}e.$Db=p;function y(F,V,G){const re=p(F,V,G),ce=[],ue=[];for(const he of re)ce.push(...F.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:ce,added:ue}}e.$Eb=y;function f(F,V,G){if(G===0)return[];const re=F.slice(0,G).sort(V);return h(F,V,re,G,F.length),re}e.top=f;function c(F,V,G,re,ce){return G===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const $e=F.length,de=F.slice(0,G).sort(V);for(let we=G,Ee=Math.min(G+re,$e);we<$e;we=Ee,Ee=Math.min(Ee+re,$e)){if(we>G&&await new Promise(Ie=>setTimeout(Ie)),ce&&ce.isCancellationRequested)throw new I.$5;h(F,V,de,we,Ee)}return de})().then(ue,he)})}e.$Gb=c;function h(F,V,G,re,ce){for(const ue=G.length;re<ce;re++){const he=F[re];if(V(he,G[ue-1])<0){G.pop();const $e=(0,L.$kb)(G,de=>V(he,de)<0);G.splice($e,0,he)}}}function m(F){return F.filter(V=>!!V)}e.$Hb=m;function S(F){let V=0;for(let G=0;G<F.length;G++)F[G]&&(F[V]=F[G],V+=1);F.length=V}e.$Ib=S;function s(F,V,G){F.splice(G,0,F.splice(V,1)[0])}e.$Jb=s;function a(F){return!Array.isArray(F)||F.length===0}e.$Kb=a;function n(F){return Array.isArray(F)&&F.length>0}e.$Lb=n;function i(F,V=G=>G){const G=new Set;return F.filter(re=>{const ce=V(re);return G.has(ce)?!1:(G.add(ce),!0)})}e.$Mb=i;function t(F){const V=new Set;return G=>{const re=F(G);return V.has(re)?!1:(V.add(re),!0)}}e.$Nb=t;function r(F,V){return F.length>0?F[0]:V}e.$Ob=r;function o(F,V){return F.length>0?F[F.length-1]:V}e.$Pb=o;function v(F,V,G=(re,ce)=>re===ce){let re=0;for(let ce=0,ue=Math.min(F.length,V.length);ce<ue&&G(F[ce],V[ce]);ce++)re++;return re}e.$Qb=v;function w(F){return[].concat(...F)}e.$Rb=w;function u(F,V){let G=typeof V=="number"?F:0;typeof V=="number"?G=F:(G=0,V=F);const re=[];if(G<=V)for(let ce=G;ce<V;ce++)re.push(ce);else for(let ce=G;ce>V;ce--)re.push(ce);return re}e.$Sb=u;function $(F,V,G){return F.reduce((re,ce)=>(re[V(ce)]=G?G(ce):ce,re),Object.create(null))}e.$Tb=$;function j(F,V){return F.push(V),()=>M(F,V)}e.$Ub=j;function M(F,V){const G=F.indexOf(V);if(G>-1)return F.splice(G,1),V}e.$Vb=M;function U(F,V,G){const re=F.slice(0,V),ce=F.slice(V);return re.concat(G,ce)}e.$Wb=U;function z(F,V){let G;if(typeof V=="number"){let re=V;G=()=>{const ce=Math.sin(re++)*179426549;return ce-Math.floor(ce)}}else G=Math.random;for(let re=F.length-1;re>0;re-=1){const ce=Math.floor(G()*(re+1)),ue=F[re];F[re]=F[ce],F[ce]=ue}}e.$Xb=z;function q(F,V){const G=F.indexOf(V);G>-1&&(F.splice(G,1),F.unshift(V))}e.$Yb=q;function Z(F,V){const G=F.indexOf(V);G>-1&&(F.splice(G,1),F.push(V))}e.$Zb=Z;function X(F,V){for(const G of V)F.push(G)}e.$1b=X;function x(F,V){return Array.isArray(F)?F.map(V):V(F)}e.$2b=x;function H(F){return Array.isArray(F)?F:[F]}e.$3b=H;function Q(F){return F[Math.floor(Math.random()*F.length)]}e.$4b=Q;function J(F,V,G){const re=ee(F,V),ce=F.length,ue=G.length;F.length=ce+ue;for(let he=ce-1;he>=re;he--)F[he+ue]=F[he];for(let he=0;he<ue;he++)F[he+re]=G[he]}e.$5b=J;function W(F,V,G,re){const ce=ee(F,V);let ue=F.splice(ce,G);return ue===void 0&&(ue=[]),J(F,ce,re),ue}e.$6b=W;function ee(F,V){return V<0?Math.max(V+F.length,0):Math.min(V,F.length)}var ne;(function(F){function V(ue){return ue<0}F.isLessThan=V;function G(ue){return ue<=0}F.isLessThanOrEqual=G;function re(ue){return ue>0}F.isGreaterThan=re;function ce(ue){return ue===0}F.isNeitherLessOrGreaterThan=ce,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function _(F,V){return(G,re)=>V(F(G),F(re))}e.$7b=_;function ie(...F){return(V,G)=>{for(const re of F){const ce=re(V,G);if(!ne.isNeitherLessOrGreaterThan(ce))return ce}return ne.neitherLessOrGreaterThan}}e.$8b=ie;const K=(F,V)=>F-V;e.$9b=K;const B=(F,V)=>(0,e.$9b)(F?1:0,V?1:0);e.$0b=B;function P(F){return(V,G)=>-F(V,G)}e.$$b=P;class O{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let G=this.c;for(;G<this.g.length&&V(this.g[G]);)G++;const re=G===this.c?null:this.g.slice(this.c,G);return this.c=G,re}takeFromEndWhile(V){let G=this.d;for(;G>=0&&V(this.g[G]);)G--;const re=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,re}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const G=this.g.slice(this.c,this.c+V);return this.c+=V,G}}e.$_b=O;class T{static{this.empty=new T(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(G=>(V(G),!0))}toArray(){const V=[];return this.iterate(G=>(V.push(G),!0)),V}filter(V){return new T(G=>this.iterate(re=>V(re)?G(re):!0))}map(V){return new T(G=>this.iterate(re=>G(V(re))))}some(V){let G=!1;return this.iterate(re=>(G=V(re),!G)),G}findFirst(V){let G;return this.iterate(re=>V(re)?(G=re,!1):!0),G}findLast(V){let G;return this.iterate(re=>(V(re)&&(G=re),!0)),G}findLastMaxBy(V){let G,re=!0;return this.iterate(ce=>((re||ne.isGreaterThan(V(ce,G)))&&(re=!1,G=ce),!0)),G}}e.$ac=T}),define(oe[127],ae([0,1,8]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function L(k,g){if(!k)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=L;function A(k,g="Unreachable"){throw new Error(g)}e.$4c=A;function N(k){if(!k)throw new I.$cb("Assertion Failed")}e.$5c=N;function D(k){if(!k()){debugger;k(),(0,I.$1)(new I.$cb("Assertion Failed"))}}e.$6c=D;function R(k,g){let C=0;for(;C<k.length-1;){const E=k[C],b=k[C+1];if(!g(E,b))return!1;C++}return!0}e.$7c=R}),define(oe[85],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function I(L){const A=this;let N=!1,D;return function(){return N||(N=!0,D=L.apply(A,arguments)),D}}e.$db=I}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(L){function A(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}L.is=A;const N=Object.freeze([]);function D(){return N}L.empty=D;function*R(S){yield S}L.single=R;function k(S){return A(S)?S:R(S)}L.wrap=k;function g(S){return S||N}L.from=g;function*C(S){for(let s=S.length-1;s>=0;s--)yield S[s]}L.reverse=C;function E(S){return!S||S[Symbol.iterator]().next().done===!0}L.isEmpty=E;function b(S){return S[Symbol.iterator]().next().value}L.first=b;function l(S,s){for(const a of S)if(s(a))return!0;return!1}L.some=l;function d(S,s){for(const a of S)if(s(a))return a}L.find=d;function*p(S,s){for(const a of S)s(a)&&(yield a)}L.filter=p;function*y(S,s){let a=0;for(const n of S)yield s(n,a++)}L.map=y;function*f(...S){for(const s of S)for(const a of s)yield a}L.concat=f;function c(S,s,a){let n=a;for(const i of S)n=s(n,i);return n}L.reduce=c;function*h(S,s,a=S.length){for(s<0&&(s+=S.length),a<0?a+=S.length:a>S.length&&(a=S.length);s<a;s++)yield S[s]}L.slice=h;function m(S,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,S];const n=S[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[a,L.empty()];a.push(t.value)}return[a,{[Symbol.iterator](){return n}}]}L.consume=m})(I||(e.Iterable=I={}))}),define(oe[35],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var L;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var A;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var N;(function(s){s.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function D(s,a=!1){let n=0;const i=s.length;let t="",r=0,o=16,v=0;function w(q){let Z=0,X=0;for(;Z<q;){const x=s.charCodeAt(n);if(x>=48&&x<=57)X=X*16+x-48;else if(x>=65&&x<=70)X=X*16+x-65+10;else if(x>=97&&x<=102)X=X*16+x-97+10;else break;n++,Z++}return Z<q&&(X=-1),X}function u(q){n=q,t="",r=0,o=16,v=0}function $(){const q=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&g(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&g(s.charCodeAt(n)))for(n++;n<s.length&&g(s.charCodeAt(n));)n++;else return v=3,s.substring(q,n);let Z=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&g(s.charCodeAt(n))){for(n++;n<s.length&&g(s.charCodeAt(n));)n++;Z=n}else v=3;return s.substring(q,Z)}function j(){let q="",Z=n;for(;;){if(n>=i){q+=s.substring(Z,n),v=2;break}const X=s.charCodeAt(n);if(X===34){q+=s.substring(Z,n),n++;break}if(X===92){if(q+=s.substring(Z,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const H=w(4);H>=0?q+=String.fromCharCode(H):v=4;break}default:v=5}Z=n;continue}if(X>=0&&X<=31)if(k(X)){q+=s.substring(Z,n),v=2;break}else v=6;n++}return q}function M(){if(t="",v=0,r=n,n>=i)return r=i,o=17;let q=s.charCodeAt(n);if(R(q)){do n++,t+=String.fromCharCode(q),q=s.charCodeAt(n);while(R(q));return o=15}if(k(q))return n++,t+=String.fromCharCode(q),q===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),o=14;switch(q){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,t=j(),o=10;case 47:{const Z=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!k(s.charCodeAt(n));)n++;return t=s.substring(Z,n),o=12}if(s.charCodeAt(n+1)===42){n+=2;const X=i-1;let x=!1;for(;n<X;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Z,n),o=13}return t+=String.fromCharCode(q),n++,o=16}case 45:if(t+=String.fromCharCode(q),n++,n===i||!g(s.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=$(),o=11;default:for(;n<i&&U(q);)n++,q=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return t+=String.fromCharCode(q),n++,o=16}}function U(q){if(R(q)||k(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let q;do q=M();while(q>=12&&q<=15);return q}return{setPosition:u,getPosition:()=>n,scan:a?z:M,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$Um=D;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function k(s){return s===10||s===13||s===8232||s===8233}function g(s){return s>=48&&s<=57}var C;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(C||(C={}));function E(s,a){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v(w,u,$,j){r.value=w,r.offset=u,r.length=$,r.type=j,r.colonOffset=void 0,t=r}try{h(s,{onObjectBegin:(w,u)=>{if(a<=w)throw i;t=void 0,o=a>w,n.push("")},onObjectProperty:(w,u,$)=>{if(a<u||(v(w,u,$,"property"),n[n.length-1]=w,a<=u+$))throw i},onObjectEnd:(w,u)=>{if(a<=w)throw i;t=void 0,n.pop()},onArrayBegin:(w,u)=>{if(a<=w)throw i;t=void 0,n.push(0)},onArrayEnd:(w,u)=>{if(a<=w)throw i;t=void 0,n.pop()},onLiteralValue:(w,u,$)=>{if(a<u||(v(w,u,$,S(w)),a<=u+$))throw i},onSeparator:(w,u,$)=>{if(a<=u)throw i;if(w===":"&&t&&t.type==="property")t.colonOffset=u,o=!1,t=void 0;else if(w===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(w){if(w!==i)throw w}return{path:n,previousNode:t,isAtPropertyKey:o,matches:w=>{let u=0;for(let $=0;u<w.length&&$<n.length;$++)if(w[u]===n[$]||w[u]==="*")u++;else if(w[u]!=="**")return!1;return u===w.length}}}e.$Vm=E;function b(s,a=[],n=N.DEFAULT){let i=null,t=[];const r=[];function o(w){Array.isArray(t)?t.push(w):i!==null&&(t[i]=w)}return h(s,{onObjectBegin:()=>{const w={};o(w),r.push(t),t=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const w=[];o(w),r.push(t),t=w,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:o,onError:(w,u,$)=>{a.push({error:w,offset:u,length:$})}},n),t[0]}e.$Wm=b;function l(s,a=[],n=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function r(w){return i.children.push(w),w}h(s,{onObjectBegin:w=>{i=r({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,u,$)=>{i=r({type:"property",offset:u,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:u,length:$,parent:i})},onObjectEnd:(w,u)=>{i.length=w+u-i.offset,i=i.parent,t(w+u)},onArrayBegin:(w,u)=>{i=r({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,u)=>{i.length=w+u-i.offset,i=i.parent,t(w+u)},onLiteralValue:(w,u,$)=>{r({type:S(w),offset:u,length:$,parent:i,value:w}),t(u+$)},onSeparator:(w,u,$)=>{i.type==="property"&&(w===":"?i.colonOffset=u:w===","&&t(u))},onError:(w,u,$)=>{a.push({error:w,offset:u,length:$})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$Xm=l;function d(s,a){if(!s)return;let n=s;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$Ym=d;function p(s){if(!s.parent||!s.parent.children)return[];const a=p(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;a.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&a.push(n)}return a}e.$Zm=p;function y(s){switch(s.type){case"array":return s.children.map(y);case"object":{const a=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(a[n.children[0].value]=y(i))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$1m=y;function f(s,a,n=!1){return a>=s.offset&&a<s.offset+s.length||n&&a===s.offset+s.length}e.$2m=f;function c(s,a,n=!1){if(f(s,a,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=a;t++){const r=c(i[t],a,n);if(r)return r}return s}}e.$3m=c;function h(s,a,n=N.DEFAULT){const i=D(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?ie=>_(ie,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=t(a.onObjectBegin),v=r(a.onObjectProperty),w=t(a.onObjectEnd),u=t(a.onArrayBegin),$=t(a.onArrayEnd),j=r(a.onLiteralValue),M=r(a.onSeparator),U=t(a.onComment),z=r(a.onError),q=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function X(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:q||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:q?x(10):U();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,ie=[],K=[]){if(z(_),ie.length+K.length>0){let B=i.getToken();for(;B!==17;){if(ie.indexOf(B)!==-1){X();break}else if(K.indexOf(B)!==-1)break;B=X()}}}function H(_){const ie=i.getTokenValue();return _?j(ie):v(ie),X(),!0}function Q(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}j(_);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return X(),!0}function J(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(M(":"),X(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function W(){o(),X();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),M(","),X(),i.getToken()===2&&Z)break}else _&&x(6,[],[]);J()||x(4,[],[2,5]),_=!0}return w(),i.getToken()!==2?x(7,[2],[]):X(),!0}function ee(){u(),X();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),M(","),X(),i.getToken()===4&&Z)break}else _&&x(6,[],[]);ne()||x(4,[],[4,5]),_=!0}return $(),i.getToken()!==4?x(8,[4],[]):X(),!0}function ne(){switch(i.getToken()){case 3:return ee();case 1:return W();case 10:return H(!0);default:return Q()}}return X(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$4m=h;function m(s,a){const n=D(s),i=[];let t,r=0,o;do switch(o=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==o&&i.push(s.substring(r,o)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$5m=m;function S(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=S}),define(oe[41],ae([0,1,35]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2S=e.$1S=e.$ZS=e.$YS=void 0;function L(g,C,E){let b,l,d,p,y;if(C){for(p=C.offset,y=p+C.length,d=p;d>0&&!k(g,d-1);)d--;let o=y;for(;o<g.length&&!k(g,o);)o++;l=g.substring(d,o),b=D(l,E)}else l=g,b=0,d=0,p=0,y=g.length;const f=R(E,g);let c=!1,h=0,m;E.insertSpaces?m=N(" ",E.tabSize||4):m="	";const S=(0,I.$Um)(l,!1);let s=!1;function a(){return f+N(m,b+h)}function n(){let o=S.scan();for(c=!1;o===15||o===14;)c=c||o===14,o=S.scan();return s=o===16||S.getTokenError()!==0,o}const i=[];function t(o,v,w){!s&&v<y&&w>p&&g.substring(v,w)!==o&&i.push({offset:v,length:w-v,content:o})}let r=n();if(r!==17){const o=S.getTokenOffset()+d,v=N(m,b);t(v,d,o)}for(;r!==17;){let o=S.getTokenOffset()+S.getTokenLength()+d,v=n(),w="";for(;!c&&(v===12||v===13);){const $=S.getTokenOffset()+d;t(" ",o,$),o=S.getTokenOffset()+S.getTokenLength()+d,w=v===12?a():"",v=n()}if(v===2)r!==1&&(h--,w=a());else if(v===4)r!==3&&(h--,w=a());else{switch(r){case 3:case 1:h++,w=a();break;case 5:case 12:w=a();break;case 13:c?w=a():w=" ";break;case 6:w=" ";break;case 10:if(v===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?w=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}c&&(v===12||v===13)&&(w=a())}const u=S.getTokenOffset()+d;t(w,o,u),r=v}return i}e.$YS=L;function A(g,C){const E=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}e.$ZS=A;function N(g,C){let E="";for(let b=0;b<C;b++)E+=g;return E}function D(g,C){let E=0,b=0;const l=C.tabSize||4;for(;E<g.length;){const d=g.charAt(E);if(d===" ")b++;else if(d==="	")b+=l;else break;E++}return Math.floor(b/l)}function R(g,C){for(let E=0;E<C.length;E++){const b=C.charAt(E);if(b==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return g&&g.eol||`
`}e.$1S=R;function k(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}e.$2S=k}),define(oe[86],ae([0,1,35,41]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7S=e.$6S=e.$5S=e.$4S=e.$3S=void 0;function A(g,C,E){return N(g,C,void 0,E)}e.$3S=A;function N(g,C,E,b,l){const d=C.slice(),p=[],y=(0,I.$Xm)(g,p);let f,c;for(;d.length>0&&(c=d.pop(),f=(0,I.$Ym)(y,d),f===void 0&&E!==void 0);)typeof c=="string"?E={[c]:E}:E=[E];if(f)if(f.type==="object"&&typeof c=="string"&&Array.isArray(f.children)){const h=(0,I.$Ym)(f,[c]);if(h!==void 0)if(E===void 0){if(!h.parent)throw new Error("Malformed AST");const m=f.children.indexOf(h.parent);let S,s=h.parent.offset+h.parent.length;if(m>0){const a=f.children[m-1];S=a.offset+a.length}else S=f.offset+1,f.children.length>1&&(s=f.children[1].offset);return D(g,{offset:S,length:s-S,content:""},b)}else return D(g,{offset:h.offset,length:h.length,content:JSON.stringify(E)},b);else{if(E===void 0)return[];const m=`${JSON.stringify(c)}: ${JSON.stringify(E)}`,S=l?l(f.children.map(a=>a.children[0].value)):f.children.length;let s;if(S>0){const a=f.children[S-1];s={offset:a.offset+a.length,length:0,content:","+m}}else f.children.length===0?s={offset:f.offset+1,length:0,content:m}:s={offset:f.offset+1,length:0,content:m+","};return D(g,s,b)}}else if(f.type==="array"&&typeof c=="number"&&Array.isArray(f.children))if(E!==void 0){const h=`${JSON.stringify(E)}`;let m;if(f.children.length===0||c===0)m={offset:f.offset+1,length:0,content:f.children.length===0?h:h+","};else{const S=c===-1||c>f.children.length?f.children.length:c,s=f.children[S-1];m={offset:s.offset+s.length,length:0,content:","+h}}return D(g,m,b)}else{const h=c,m=f.children[h];let S;if(f.children.length===1)S={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===h){const s=f.children[h-1],a=s.offset+s.length,n=f.offset+f.length;S={offset:a,length:n-2-a,content:""}}else S={offset:m.offset,length:f.children[h+1].offset-m.offset,content:""};return D(g,S,b)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${f.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return D(g,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(E)},b)}}e.$4S=N;function D(g,C,E){let b=R(g,C),l=C.offset,d=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;l>0&&!(0,L.$2S)(b,l-1);)l--;for(;d<b.length&&!(0,L.$2S)(b,d);)d++}const p=(0,L.$YS)(b,{offset:l,length:d-l},E);for(let f=p.length-1;f>=0;f--){const c=p[f];b=R(b,c),l=Math.min(l,c.offset),d=Math.max(d,c.offset+c.length),d+=c.content.length-c.length}const y=g.length-(b.length-d)-l;return[{offset:l,length:y,content:b.substring(l,d)}]}e.$5S=D;function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}e.$6S=R;function k(g,C){const E=C.slice(0).sort((l,d)=>{const p=l.offset-d.offset;return p===0?l.length-d.length:p});let b=g.length;for(let l=E.length-1;l>=0;l--){const d=E[l];if(d.offset+d.length<=b)g=R(g,d);else throw new Error("Overlapping edit");b=d.offset}return g}e.$7S=k}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class I{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=I}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(N){this.element=N,this.next=I.Undefined,this.prev=I.Undefined}}class L{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let N=this.a;for(;N!==I.Undefined;){const D=N.next;N.prev=I.Undefined,N.next=I.Undefined,N=D}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(N){return this.d(N,!1)}push(N){return this.d(N,!0)}d(N,D){const R=new I(N);if(this.a===I.Undefined)this.a=R,this.b=R;else if(D){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const N=this.a.element;return this.e(this.a),N}}pop(){if(this.b!==I.Undefined){const N=this.b.element;return this.e(this.b),N}}e(N){if(N.prev!==I.Undefined&&N.next!==I.Undefined){const D=N.prev;D.next=N.next,N.next.prev=D}else N.prev===I.Undefined&&N.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):N.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):N.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let N=this.a;for(;N!==I.Undefined;)yield N.element,N=N.next}}e.$2c=L}),define(oe[34],ae([0,1]),function(te,e){"use strict";var I,L,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function N(c,h,m){let S=c.get(h);return S===void 0&&(S=m,c.set(h,S)),S}e.$xc=N;function D(c){const h=[];return c.forEach((m,S)=>{h.push(`${S} => ${m}`)}),`Map(${c.size}) {${h.join(", ")}}`}e.$yc=D;function R(c){const h=[];return c.forEach(m=>{h.push(m)}),`Set(${c.size}) {${h.join(", ")}}`}e.$zc=R;class k{constructor(h,m){this.uri=h,this.value=m}}function g(c){return Array.isArray(c)}class C{static{this.a=h=>h.toString()}constructor(h,m){if(this[I]="ResourceMap",h instanceof C)this.b=new Map(h.b),this.c=m??C.a;else if(g(h)){this.b=new Map,this.c=m??C.a;for(const[S,s]of h)this.set(S,s)}else this.b=new Map,this.c=h??C.a}set(h,m){return this.b.set(this.c(h),new k(h,m)),this}get(h){return this.b.get(this.c(h))?.value}has(h){return this.b.has(this.c(h))}get size(){return this.b.size}clear(){this.b.clear()}delete(h){return this.b.delete(this.c(h))}forEach(h,m){typeof m<"u"&&(h=h.bind(m));for(const[S,s]of this.b)h(s.value,s.uri,this)}*values(){for(const h of this.b.values())yield h.value}*keys(){for(const h of this.b.values())yield h.uri}*entries(){for(const h of this.b.values())yield[h.uri,h.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.b)yield[h.uri,h.value]}}e.$Ac=C;class E{constructor(h,m){this[L]="ResourceSet",!h||typeof h=="function"?this.a=new C(h):(this.a=new C(m),h.forEach(this.add,this))}get size(){return this.a.size}add(h){return this.a.set(h,h),this}clear(){this.a.clear()}delete(h){return this.a.delete(h)}forEach(h,m){this.a.forEach((S,s)=>h.call(m,s,s,this))}has(h){return this.a.has(h)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=E;var b;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class l{constructor(){this[A]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(h){return this.a.has(h)}get(h,m=0){const S=this.a.get(h);if(S)return m!==0&&this.j(S,m),S.value}set(h,m,S=0){let s=this.a.get(h);if(s)s.value=m,S!==0&&this.j(s,S);else{switch(s={key:h,value:m,next:void 0,previous:void 0},S){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(h,s),this.d++}return this}delete(h){return!!this.remove(h)}remove(h){const m=this.a.get(h);if(m)return this.a.delete(h),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const h=this.b;return this.a.delete(h.key),this.i(h),this.d--,h.value}forEach(h,m){const S=this.e;let s=this.b;for(;s;){if(m?h.bind(m)(s.value,s.key,this):h(s.value,s.key,this),this.e!==S)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const h=this,m=this.e;let S=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==m)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:S.key,done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return s}values(){const h=this,m=this.e;let S=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==m)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:S.value,done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return s}entries(){const h=this,m=this.e;let S=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==m)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:[S.key,S.value],done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return s}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(h){if(h>=this.size)return;if(h===0){this.clear();return}let m=this.b,S=this.size;for(;m&&S>h;)this.a.delete(m.key),m=m.next,S--;this.b=m,this.d=S,m&&(m.previous=void 0),this.e++}g(h){if(!this.b&&!this.c)this.c=h;else if(this.b)h.next=this.b,this.b.previous=h;else throw new Error("Invalid list");this.b=h,this.e++}h(h){if(!this.b&&!this.c)this.b=h;else if(this.c)h.previous=this.c,this.c.next=h;else throw new Error("Invalid list");this.c=h,this.e++}i(h){if(h===this.b&&h===this.c)this.b=void 0,this.c=void 0;else if(h===this.b){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.b=h.next}else if(h===this.c){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.c=h.previous}else{const m=h.next,S=h.previous;if(!m||!S)throw new Error("Invalid list");m.previous=S,S.next=m}h.next=void 0,h.previous=void 0,this.e++}j(h,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(h===this.b)return;const S=h.next,s=h.previous;h===this.c?(s.next=void 0,this.c=s):(S.previous=s,s.next=S),h.previous=void 0,h.next=this.b,this.b.previous=h,this.b=h,this.e++}else if(m===2){if(h===this.c)return;const S=h.next,s=h.previous;h===this.b?(S.previous=void 0,this.b=S):(S.previous=s,s.next=S),h.next=void 0,h.previous=this.c,this.c.next=h,this.c=h,this.e++}}}toJSON(){const h=[];return this.forEach((m,S)=>{h.push([S,m])}),h}fromJSON(h){this.clear();for(const[m,S]of h)this.set(m,S)}}e.$Cc=l;class d extends l{constructor(h,m=1){super(),this.k=h,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(h){this.k=h,this.m()}get ratio(){return this.l}set ratio(h){this.l=Math.min(Math.max(0,h),1),this.m()}get(h,m=2){return super.get(h,m)}peek(h){return super.get(h,0)}set(h,m){return super.set(h,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=d;class p{constructor(){this.a=new Map}add(h){return this.a.set(h,(this.a.get(h)||0)+1),this}delete(h){let m=this.a.get(h)||0;return m===0?!1:(m--,m===0?this.a.delete(h):this.a.set(h,m),!0)}has(h){return this.a.has(h)}}e.$Ec=p;class y{constructor(h){if(this.a=new Map,this.b=new Map,h)for(const[m,S]of h)this.set(m,S)}clear(){this.a.clear(),this.b.clear()}set(h,m){this.a.set(h,m),this.b.set(m,h)}get(h){return this.a.get(h)}getKey(h){return this.b.get(h)}delete(h){const m=this.a.get(h);return m===void 0?!1:(this.a.delete(h),this.b.delete(m),!0)}forEach(h,m){this.a.forEach((S,s)=>{h.call(m,S,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=y;class f{constructor(){this.a=new Map}add(h,m){let S=this.a.get(h);S||(S=new Set,this.a.set(h,S)),S.add(m)}delete(h,m){const S=this.a.get(h);S&&(S.delete(m),S.size===0&&this.a.delete(h))}forEach(h,m){const S=this.a.get(h);S&&S.forEach(m)}get(h){const m=this.a.get(h);return m||new Set}}e.$Gc=f}),define(oe[2],ae([0,1,18,126,34,85,59]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const R=!1;let k=null;class g{constructor(){this.b=new Map}static{this.a=0}c($){let j=this.b.get($);return j||(j={parent:null,source:null,isSingleton:!1,value:$,idx:g.a++},this.b.set($,j)),j}trackDisposable($){const j=this.c($);j.source||(j.source=new Error().stack)}setParent($,j){const M=this.c($);M.parent=j}markAsDisposed($){this.b.delete($)}markAsSingleton($){this.c($).isSingleton=!0}f($,j){const M=j.get($);if(M)return M;const U=$.parent?this.f(this.c($.parent),j):$;return j.set($,U),U}getTrackedDisposables(){const $=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,$).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables($=10,j){let M;if(j)M=j;else{const X=new Map,x=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,X).isSingleton);if(x.length===0)return;const H=new Set(x.map(Q=>Q.value));if(M=x.filter(Q=>!(Q.parent&&H.has(Q.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function U(X){function x(Q,J){for(;Q.length>0&&J.some(W=>typeof W=="string"?W===Q[0]:Q[0].match(W));)Q.shift()}const H=X.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return x(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const z=new A.$Gc;for(const X of M){const x=U(X);for(let H=0;H<=x.length;H++)z.add(x.slice(0,H).join(`
`),X)}M.sort((0,I.$7b)(X=>X.idx,I.$9b));let q="",Z=0;for(const X of M.slice(0,$)){Z++;const x=U(X),H=[];for(let Q=0;Q<x.length;Q++){let J=x[Q];J=`(shared with ${z.get(x.slice(0,Q+1).join(`
`)).size}/${M.length} leaks) at ${J}`;const ee=z.get(x.slice(0,Q).join(`
`)),ne=(0,L.$J)([...ee].map(_=>U(_)[Q]),_=>_);delete ne[x[Q]];for(const[_,ie]of Object.entries(ne))H.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${_}`);H.unshift(J)}q+=`


==================== Leaking disposable ${Z}/${M.length}: ${X.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return M.length>$&&(q+=`


... and ${M.length-$} more leaking disposables

`),{leaks:M,details:q}}}e.$Hc=g;function C(u){k=u}if(e.$Ic=C,R){const u="__is_disposable_tracked__";C(new class{trackDisposable($){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{$[u]||console.log(j)},3e3)}setParent($,j){if($&&$!==s.None)try{$[u]=!0}catch{}}markAsDisposed($){if($&&$!==s.None)try{$[u]=!0}catch{}}markAsSingleton($){}})}function E(u){return k?.trackDisposable(u),u}e.$Jc=E;function b(u){k?.markAsDisposed(u)}e.$Kc=b;function l(u,$){k?.setParent(u,$)}function d(u,$){if(k)for(const j of u)k.setParent(j,$)}function p(u){return k?.markAsSingleton(u),u}e.$Lc=p;function y(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.$Mc=y;function f(u){if(D.Iterable.is(u)){const $=[];for(const j of u)if(j)try{j.dispose()}catch(M){$.push(M)}if($.length===1)throw $[0];if($.length>1)throw new AggregateError($,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.$Nc=f;function c(u){for(const $ of u)y($)&&$.dispose();return[]}e.$Oc=c;function h(...u){const $=m(()=>f(u));return d(u,$),$}e.$Pc=h;function m(u){const $=E({dispose:(0,N.$db)(()=>{b($),u()})});return $}e.$Qc=m;class S{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add($){if(!$)return $;if($===this)throw new Error("Cannot register a disposable on itself!");return l($,this),this.g?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add($),$}delete($){if($){if($===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete($),$.dispose()}}deleteAndLeak($){$&&this.f.has($)&&(this.f.delete($),l($,null))}}e.$Rc=S;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new S,E(this),l(this.q,this)}dispose(){b(this),this.q.dispose()}B($){if($===this)throw new Error("Cannot register a disposable on itself!");return this.q.add($)}}e.$Sc=s;class a{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value($){this.b||$===this.a||(this.a?.dispose(),$&&l($,this),this.a=$)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const $=this.a;return this.a=void 0,$&&l($,null),$}}e.$Tc=a;class n{constructor($){this.b=$,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set($){let j=$;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,b(this))},this}}e.$Vc=i;class t{constructor(){this.a=new Map}acquire($,...j){let M=this.a.get($);M||(M={counter:0,object:this.b($,...j)},this.a.set($,M));const{object:U}=M,z=(0,N.$db)(()=>{--M.counter===0&&(this.c($,M.object),this.a.delete($))});return M.counter++,{object:U,dispose:z}}}e.$Wc=t;class r{constructor($){this.a=$}async acquire($,...j){const M=this.a.acquire($,...j);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(U){throw M.dispose(),U}}}e.$Xc=r;class o{constructor($){this.object=$}dispose(){}}e.$Yc=o;function v(u){const $=new S;try{u($)}finally{$.dispose()}}e.$Zc=v;class w{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has($){return this.a.has($)}get size(){return this.a.size}get($){return this.a.get($)}set($,j,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get($)?.dispose(),this.a.set($,j)}deleteAndDispose($){this.a.get($)?.dispose(),this.a.delete($)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=w}),define(oe[88],ae([0,1,34]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=void 0;const L=new I.$Dc(1e4);function A(g){return k(g,"NFC",L)}e.$ol=A;const N=new I.$Dc(1e4);function D(g){return k(g,"NFD",N)}e.$pl=D;const R=/[^\u0000-\u0080]/;function k(g,C,E){if(!g)return g;const b=E.get(g);if(b)return b;let l;return R.test(g)?l=g.normalize(C):l=g,E.set(g,l),l}e.$ql=function(){const g=/[\u0300-\u036f]/g;return function(C){return D(C).replace(g,"")}}()}),function(){function te(A){const N=[];typeof A=="number"&&N.push("code/timeOrigin",A);function D(k){N.push(k,Date.now())}function R(){const k=[];for(let g=0;g<N.length;g+=2)k.push({name:N[g],startTime:N[g+1]});return k}return{mark:D,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const D of performance.getEntriesByType("mark"))N.push({name:D.name,startTime:Math.round(A+D.startTime)});return N}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function I(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:te)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function I(L){if(e[L])return e[L].exports;var A=e[L]={i:L,l:!1,exports:{}};return te[L].call(A.exports,A,A.exports,I),A.l=!0,A.exports}return I.m=te,I.c=e,I.d=function(L,A,N){I.o(L,A)||Object.defineProperty(L,A,{enumerable:!0,get:N})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,A){if(1&A&&(L=I(L)),8&A||4&A&&typeof L=="object"&&L&&L.__esModule)return L;var N=Object.create(null);if(I.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:L}),2&A&&typeof L!="string")for(var D in L)I.d(N,D,function(R){return L[R]}.bind(null,D));return N},I.n=function(L){var A=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(A,"a",A),A},I.o=function(L,A){return Object.prototype.hasOwnProperty.call(L,A)},I.p="",I(I.s=0)}([function(te,e,I){(function(L){var A;e=te.exports=K,A=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],k=e.src=[],g=0,C=g++;k[C]="0|[1-9]\\d*";var E=g++;k[E]="[0-9]+";var b=g++;k[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=g++;k[l]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var d=g++;k[d]="("+k[E]+")\\.("+k[E]+")\\.("+k[E]+")";var p=g++;k[p]="(?:"+k[C]+"|"+k[b]+")";var y=g++;k[y]="(?:"+k[E]+"|"+k[b]+")";var f=g++;k[f]="(?:-("+k[p]+"(?:\\."+k[p]+")*))";var c=g++;k[c]="(?:-?("+k[y]+"(?:\\."+k[y]+")*))";var h=g++;k[h]="[0-9A-Za-z-]+";var m=g++;k[m]="(?:\\+("+k[h]+"(?:\\."+k[h]+")*))";var S=g++,s="v?"+k[l]+k[f]+"?"+k[m]+"?";k[S]="^"+s+"$";var a="[v=\\s]*"+k[d]+k[c]+"?"+k[m]+"?",n=g++;k[n]="^"+a+"$";var i=g++;k[i]="((?:<|>)?=?)";var t=g++;k[t]=k[E]+"|x|X|\\*";var r=g++;k[r]=k[C]+"|x|X|\\*";var o=g++;k[o]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[f]+")?"+k[m]+"?)?)?";var v=g++;k[v]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[c]+")?"+k[m]+"?)?)?";var w=g++;k[w]="^"+k[i]+"\\s*"+k[o]+"$";var u=g++;k[u]="^"+k[i]+"\\s*"+k[v]+"$";var $=g++;k[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=g++;k[j]="(?:~>?)";var M=g++;k[M]="(\\s*)"+k[j]+"\\s+",R[M]=new RegExp(k[M],"g");var U=g++;k[U]="^"+k[j]+k[o]+"$";var z=g++;k[z]="^"+k[j]+k[v]+"$";var q=g++;k[q]="(?:\\^)";var Z=g++;k[Z]="(\\s*)"+k[q]+"\\s+",R[Z]=new RegExp(k[Z],"g");var X=g++;k[X]="^"+k[q]+k[o]+"$";var x=g++;k[x]="^"+k[q]+k[v]+"$";var H=g++;k[H]="^"+k[i]+"\\s*("+a+")$|^$";var Q=g++;k[Q]="^"+k[i]+"\\s*("+s+")$|^$";var J=g++;k[J]="(\\s*)"+k[i]+"\\s*("+a+"|"+k[o]+")",R[J]=new RegExp(k[J],"g");var W=g++;k[W]="^\\s*("+k[o]+")\\s+-\\s+("+k[o]+")\\s*$";var ee=g++;k[ee]="^\\s*("+k[v]+")\\s+-\\s+("+k[v]+")\\s*$";var ne=g++;k[ne]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)A(_,k[_]),R[_]||(R[_]=new RegExp(k[_]));function ie(le,ge){if(le instanceof K)return le;if(typeof le!="string"||le.length>N||!(ge?R[n]:R[S]).test(le))return null;try{return new K(le,ge)}catch{return null}}function K(le,ge){if(le instanceof K){if(le.loose===ge)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof K))return new K(le,ge);A("SemVer",le,ge),this.loose=ge;var be=le.trim().match(ge?R[n]:R[S]);if(!be)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Pe=+ke;if(Pe>=0&&Pe<D)return Pe}return ke}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ie,e.valid=function(le,ge){var be=ie(le,ge);return be?be.version:null},e.clean=function(le,ge){var be=ie(le.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(le){return A("SemVer.compare",this.version,this.loose,le),le instanceof K||(le=new K(le,this.loose)),this.compareMain(le)||this.comparePre(le)},K.prototype.compareMain=function(le){return le instanceof K||(le=new K(le,this.loose)),P(this.major,le.major)||P(this.minor,le.minor)||P(this.patch,le.patch)},K.prototype.comparePre=function(le){if(le instanceof K||(le=new K(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],ke=le.prerelease[ge];if(A("prerelease compare",ge,be,ke),be===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(be===void 0)return-1;if(be!==ke)return P(be,ke)}while(++ge)},K.prototype.inc=function(le,ge){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ge,be,ke){typeof be=="string"&&(ke=be,be=void 0);try{return new K(le,be).inc(ge,ke).version}catch{return null}},e.diff=function(le,ge){if(V(le,ge))return null;var be=ie(le),ke=ie(ge);if(be.prerelease.length||ke.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return Pe},e.compareIdentifiers=P;var B=/^[0-9]+$/;function P(le,ge){var be=B.test(le),ke=B.test(ge);return be&&ke&&(le=+le,ge=+ge),be&&!ke?-1:ke&&!be?1:le<ge?-1:le>ge?1:0}function O(le,ge,be){return new K(le,be).compare(new K(ge,be))}function T(le,ge,be){return O(le,ge,be)>0}function F(le,ge,be){return O(le,ge,be)<0}function V(le,ge,be){return O(le,ge,be)===0}function G(le,ge,be){return O(le,ge,be)!==0}function re(le,ge,be){return O(le,ge,be)>=0}function ce(le,ge,be){return O(le,ge,be)<=0}function ue(le,ge,be,ke){var Pe;switch(ge){case"===":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le===be;break;case"!==":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le!==be;break;case"":case"=":case"==":Pe=V(le,be,ke);break;case"!=":Pe=G(le,be,ke);break;case">":Pe=T(le,be,ke);break;case">=":Pe=re(le,be,ke);break;case"<":Pe=F(le,be,ke);break;case"<=":Pe=ce(le,be,ke);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function he(le,ge){if(le instanceof he){if(le.loose===ge)return le;le=le.value}if(!(this instanceof he))return new he(le,ge);A("comparator",le,ge),this.loose=ge,this.parse(le),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(le,ge){return P(ge,le)},e.major=function(le,ge){return new K(le,ge).major},e.minor=function(le,ge){return new K(le,ge).minor},e.patch=function(le,ge){return new K(le,ge).patch},e.compare=O,e.compareLoose=function(le,ge){return O(le,ge,!0)},e.rcompare=function(le,ge,be){return O(ge,le,be)},e.sort=function(le,ge){return le.sort(function(be,ke){return e.compare(be,ke,ge)})},e.rsort=function(le,ge){return le.sort(function(be,ke){return e.rcompare(be,ke,ge)})},e.gt=T,e.lt=F,e.eq=V,e.neq=G,e.gte=re,e.lte=ce,e.cmp=ue,e.Comparator=he;var $e={};function de(le,ge){if(le instanceof de)return le.loose===ge?le:new de(le.raw,ge);if(le instanceof he)return new de(le.value,ge);if(!(this instanceof de))return new de(le,ge);if(this.loose=ge,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function we(le){return!le||le.toLowerCase()==="x"||le==="*"}function Ee(le,ge,be,ke,Pe,Ue,je,ze,Fe,se,fe,me,pe){return((ge=we(be)?"":we(ke)?">="+be+".0.0":we(Pe)?">="+be+"."+ke+".0":">="+ge)+" "+(ze=we(Fe)?"":we(se)?"<"+(+Fe+1)+".0.0":we(fe)?"<"+Fe+"."+(+se+1)+".0":me?"<="+Fe+"."+se+"."+fe+"-"+me:"<="+ze)).trim()}function Ie(le,ge){for(var be=0;be<le.length;be++)if(!le[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<le.length;be++)if(A(le[be].semver),le[be].semver!==$e&&le[be].semver.prerelease.length>0){var ke=le[be].semver;if(ke.major===ge.major&&ke.minor===ge.minor&&ke.patch===ge.patch)return!0}return!1}return!0}function Le(le,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(le)}function Te(le,ge,be,ke){var Pe,Ue,je,ze,Fe;switch(le=new K(le,ke),ge=new de(ge,ke),be){case">":Pe=T,Ue=ce,je=F,ze=">",Fe=">=";break;case"<":Pe=F,Ue=re,je=T,ze="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(le,ge,ke))return!1;for(var se=0;se<ge.set.length;++se){var fe=ge.set[se],me=null,pe=null;if(fe.forEach(function(Se){Se.semver===$e&&(Se=new he(">=0.0.0")),me=me||Se,pe=pe||Se,Pe(Se.semver,me.semver,ke)?me=Se:je(Se.semver,pe.semver,ke)&&(pe=Se)}),me.operator===ze||me.operator===Fe||(!pe.operator||pe.operator===ze)&&Ue(le,pe.semver)||pe.operator===Fe&&je(le,pe.semver))return!1}return!0}he.prototype.parse=function(le){var ge=this.loose?R[H]:R[Q],be=le.match(ge);if(!be)throw new TypeError("Invalid comparator: "+le);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new K(be[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(le){return A("Comparator.test",le,this.loose),this.semver===$e||(typeof le=="string"&&(le=new K(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},he.prototype.intersects=function(le,ge){if(!(le instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(le.value,ge),Le(this.value,be,ge);if(le.operator==="")return be=new de(this.value,ge),Le(le.semver,be,ge);var ke=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Ue=this.semver.version===le.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),ze=ue(this.semver,"<",le.semver,ge)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Fe=ue(this.semver,">",le.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return ke||Pe||Ue&&je||ze||Fe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var ge=this.loose;le=le.trim(),A("range",le,ge);var be=ge?R[ee]:R[W];le=le.replace(be,Ee),A("hyphen replace",le),le=le.replace(R[J],"$1$2$3"),A("comparator trim",le,R[J]),le=(le=(le=le.replace(R[M],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var ke=ge?R[H]:R[Q],Pe=le.split(" ").map(function(Ue){return function(je,ze){return A("comp",je),je=function(Fe,se){return Fe.trim().split(/\s+/).map(function(fe){return function(me,pe){A("caret",me,pe);var Se=pe?R[x]:R[X];return me.replace(Se,function(Re,Ce,De,Oe,Ne){var Me;return A("caret",me,Re,Ce,De,Oe,Ne),we(Ce)?Me="":we(De)?Me=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Me=Ce==="0"?">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+".0 <"+(+Ce+1)+".0.0":Ne?(A("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Me=Ce==="0"?De==="0"?">="+Ce+"."+De+"."+Oe+Ne+" <"+Ce+"."+De+"."+(+Oe+1):">="+Ce+"."+De+"."+Oe+Ne+" <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+"."+Oe+Ne+" <"+(+Ce+1)+".0.0"):(A("no pr"),Me=Ce==="0"?De==="0"?">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+De+"."+(+Oe+1):">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+"."+Oe+" <"+(+Ce+1)+".0.0"),A("caret return",Me),Me})}(fe,se)}).join(" ")}(je,ze),A("caret",je),je=function(Fe,se){return Fe.trim().split(/\s+/).map(function(fe){return function(me,pe){var Se=pe?R[z]:R[U];return me.replace(Se,function(Re,Ce,De,Oe,Ne){var Me;return A("tilde",me,Re,Ce,De,Oe,Ne),we(Ce)?Me="":we(De)?Me=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Me=">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0":Ne?(A("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Me=">="+Ce+"."+De+"."+Oe+Ne+" <"+Ce+"."+(+De+1)+".0"):Me=">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+(+De+1)+".0",A("tilde return",Me),Me})}(fe,se)}).join(" ")}(je,ze),A("tildes",je),je=function(Fe,se){return A("replaceXRanges",Fe,se),Fe.split(/\s+/).map(function(fe){return function(me,pe){me=me.trim();var Se=pe?R[u]:R[w];return me.replace(Se,function(Re,Ce,De,Oe,Ne,Me){A("xRange",me,Re,Ce,De,Oe,Ne,Me);var Be=we(De),qe=Be||we(Oe),Ve=qe||we(Ne);return Ce==="="&&Ve&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ve?(qe&&(Oe=0),Ve&&(Ne=0),Ce===">"?(Ce=">=",qe?(De=+De+1,Oe=0,Ne=0):Ve&&(Oe=+Oe+1,Ne=0)):Ce==="<="&&(Ce="<",qe?De=+De+1:Oe=+Oe+1),Re=Ce+De+"."+Oe+"."+Ne):qe?Re=">="+De+".0.0 <"+(+De+1)+".0.0":Ve&&(Re=">="+De+"."+Oe+".0 <"+De+"."+(+Oe+1)+".0"),A("xRange return",Re),Re})}(fe,se)}).join(" ")}(je,ze),A("xrange",je),je=function(Fe,se){return A("replaceStars",Fe,se),Fe.trim().replace(R[ne],"")}(je,ze),A("stars",je),je}(Ue,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ue){return!!Ue.match(ke)})),Pe=Pe.map(function(Ue){return new he(Ue,ge)})},de.prototype.intersects=function(le,ge){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(ke){return le.set.some(function(Pe){return Pe.every(function(Ue){return ke.intersects(Ue,ge)})})})})},e.toComparators=function(le,ge){return new de(le,ge).set.map(function(be){return be.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new K(le,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],le))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(le,ge,be){var ke=null,Pe=null;try{var Ue=new de(ge,be)}catch{return null}return le.forEach(function(je){Ue.test(je)&&(ke&&Pe.compare(je)!==-1||(Pe=new K(ke=je,be)))}),ke},e.minSatisfying=function(le,ge,be){var ke=null,Pe=null;try{var Ue=new de(ge,be)}catch{return null}return le.forEach(function(je){Ue.test(je)&&(ke&&Pe.compare(je)!==1||(Pe=new K(ke=je,be)))}),ke},e.validRange=function(le,ge){try{return new de(le,ge).range||"*"}catch{return null}},e.ltr=function(le,ge,be){return Te(le,ge,"<",be)},e.gtr=function(le,ge,be){return Te(le,ge,">",be)},e.outside=Te,e.prerelease=function(le,ge){var be=ie(le,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(le,ge,be){return le=new de(le,be),ge=new de(ge,be),le.intersects(ge)},e.coerce=function(le){if(le instanceof K)return le;if(typeof le!="string")return null;var ge=le.match(R[$]);return ge==null?null:ie((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,I(1))},function(te,e){var I,L,A=te.exports={};function N(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function R(y){if(I===setTimeout)return setTimeout(y,0);if((I===N||!I)&&setTimeout)return I=setTimeout,setTimeout(y,0);try{return I(y,0)}catch{try{return I.call(null,y,0)}catch{return I.call(this,y,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:N}catch{I=N}try{L=typeof clearTimeout=="function"?clearTimeout:D}catch{L=D}})();var k,g=[],C=!1,E=-1;function b(){C&&k&&(C=!1,k.length?g=k.concat(g):E=-1,g.length&&l())}function l(){if(!C){var y=R(b);C=!0;for(var f=g.length;f;){for(k=g,g=[];++E<f;)k&&k[E].run();E=-1,f=g.length}k=null,C=!1,function(c){if(L===clearTimeout)return clearTimeout(c);if((L===D||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(c);try{L(c)}catch{try{return L.call(null,c)}catch{return L.call(this,c)}}}(y)}}function d(y,f){this.fun=y,this.array=f}function p(){}A.nextTick=function(y){var f=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)f[c-1]=arguments[c];g.push(new d(y,f)),g.length!==1||C||R(l)},d.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=p,A.addListener=p,A.once=p,A.off=p,A.removeListener=p,A.removeAllListeners=p,A.emit=p,A.prependListener=p,A.prependOnceListener=p,A.listeners=function(y){return[]},A.binding=function(y){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(y){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(oe[128],ae([0,1]),function(te,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class L{constructor(R,k,g){this.level=R,this.key=k,this.value=g,this.forward=[]}}const A=void 0;class N{constructor(R,k=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new L(this.c,A,A)}get size(){return this.f}clear(){this.e=new L(this.c,A,A),this.f=0}has(R){return!!N.g(this,R,this.comparator)}get(R){return N.g(this,R,this.comparator)?.value}set(R,k){return N.h(this,R,k,this.comparator)&&(this.f+=1),this}delete(R){const k=N.k(this,R,this.comparator);return k&&(this.f-=1),k}forEach(R,k){let g=this.e.forward[0];for(;g;)R.call(k,g.value,g.key,this),g=g.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",k=this.e.forward[0];for(;k;)R+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return R}static g(R,k,g){let C=R.e;for(let E=R.d-1;E>=0;E--)for(;C.forward[E]&&g(C.forward[E].key,k)<0;)C=C.forward[E];if(C=C.forward[0],C&&g(C.key,k)===0)return C}static h(R,k,g,C){const E=[];let b=R.e;for(let l=R.d-1;l>=0;l--){for(;b.forward[l]&&C(b.forward[l].key,k)<0;)b=b.forward[l];E[l]=b}if(b=b.forward[0],b&&C(b.key,k)===0)return b.value=g,!1;{const l=N.j(R);if(l>R.d){for(let d=R.d;d<l;d++)E[d]=R.e;R.d=l}b=new L(l,k,g);for(let d=0;d<l;d++)b.forward[d]=E[d].forward[d],E[d].forward[d]=b;return!0}}static j(R,k=.5){let g=1;for(;Math.random()<k&&g<R.c;)g+=1;return g}static k(R,k,g){const C=[];let E=R.e;for(let b=R.d-1;b>=0;b--){for(;E.forward[b]&&g(E.forward[b].key,k)<0;)E=E.forward[b];C[b]=E}if(E=E.forward[0],!E||g(E.key,k)!==0)return!1;for(let b=0;b<R.d&&C[b].forward[b]===E;b++)C[b].forward[b]=E.forward[b];for(;R.d>0&&R.e.forward[R.d-1]===A;)R.d-=1;return!0}}e.$zr=N}),define(oe[61],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(N){return new L(N)}constructor(N){this.c=I&&N===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=L}),define(oe[3],ae([0,1,8,85,2,87,61]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const R=!1,k=!1;var g;(function(w){w.None=()=>A.$Sc.None;function u(ue){if(k){const{onDidAddListener:he}=ue,$e=d.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function $(ue,he){return Q(ue,()=>{},0,void 0,!0,void 0,he)}w.defer=$;function j(ue){return(he,$e=null,de)=>{let we=!1,Ee;return Ee=ue(Ie=>{if(!we)return Ee?Ee.dispose():we=!0,he.call($e,Ie)},null,de),we&&Ee.dispose(),Ee}}w.once=j;function M(ue,he,$e){return x((de,we=null,Ee)=>ue(Ie=>de.call(we,he(Ie)),null,Ee),$e)}w.map=M;function U(ue,he,$e){return x((de,we=null,Ee)=>ue(Ie=>{he(Ie),de.call(we,Ie)},null,Ee),$e)}w.forEach=U;function z(ue,he,$e){return x((de,we=null,Ee)=>ue(Ie=>he(Ie)&&de.call(we,Ie),null,Ee),$e)}w.filter=z;function q(ue){return ue}w.signal=q;function Z(...ue){return(he,$e=null,de)=>{const we=(0,A.$Pc)(...ue.map(Ee=>Ee(Ie=>he.call($e,Ie))));return H(we,de)}}w.any=Z;function X(ue,he,$e,de){let we=$e;return M(ue,Ee=>(we=he(we,Ee),we),de)}w.reduce=X;function x(ue,he){let $e;const de={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};he||u(de);const we=new h(de);return he?.add(we),we.event}function H(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function Q(ue,he,$e=100,de=!1,we=!1,Ee,Ie){let Le,Te,le,ge=0,be;const ke={leakWarningThreshold:Ee,onWillAddFirstListener(){Le=ue(Ue=>{ge++,Te=he(Te,Ue),de&&!le&&(Pe.fire(Te),Te=void 0),be=()=>{const je=Te;Te=void 0,le=void 0,(!de||ge>1)&&Pe.fire(je),ge=0},typeof $e=="number"?(clearTimeout(le),le=setTimeout(be,$e)):le===void 0&&(le=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Le.dispose()}};Ie||u(ke);const Pe=new h(ke);return Ie?.add(Pe),Pe.event}w.debounce=Q;function J(ue,he=0,$e){return w.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,$e)}w.accumulate=J;function W(ue,he=(de,we)=>de===we,$e){let de=!0,we;return z(ue,Ee=>{const Ie=de||!he(Ee,we);return de=!1,we=Ee,Ie},$e)}w.latch=W;function ee(ue,he,$e){return[w.filter(ue,he,$e),w.filter(ue,de=>!he(de),$e)]}w.split=ee;function ne(ue,he=!1,$e=[],de){let we=$e.slice(),Ee=ue(Te=>{we?we.push(Te):Le.fire(Te)});de&&de.add(Ee);const Ie=()=>{we?.forEach(Te=>Le.fire(Te)),we=null},Le=new h({onWillAddFirstListener(){Ee||(Ee=ue(Te=>Le.fire(Te)),de&&de.add(Ee))},onDidAddFirstListener(){we&&(he?setTimeout(Ie):Ie())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Le),Le.event}w.buffer=ne;function _(ue,he){return(de,we,Ee)=>{const Ie=he(new K);return ue(function(Le){const Te=Ie.evaluate(Le);Te!==ie&&de.call(we,Te)},void 0,Ee)}}w.chain=_;const ie=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:ie),this}reduce(he,$e){let de=$e;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const Ee=$e||!he(we,de);return $e=!1,de=we,Ee?we:ie}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===ie)break;return he}}function B(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.on(he,de),Ee=()=>ue.removeListener(he,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Ie.event}w.fromNodeEventEmitter=B;function P(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.addEventListener(he,de),Ee=()=>ue.removeEventListener(he,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Ie.event}w.fromDOMEventEmitter=P;function O(ue){return new Promise(he=>j(ue)(he))}w.toPromise=O;function T(ue){const he=new h;return ue.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}w.fromPromise=T;function F(ue,he){return he(void 0),ue($e=>he($e))}w.runAndSubscribe=F;function V(ue,he){let $e=null;function de(Ee){$e?.dispose(),$e=new A.$Rc,he(Ee,$e)}de(void 0);const we=ue(Ee=>de(Ee));return(0,A.$Qc)(()=>{we.dispose(),$e?.dispose()})}w.runAndSubscribeWithStore=V;class G{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||u(de),this.emitter=new h(de),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function re(ue,he){return new G(ue,he).emitter.event}w.fromObservable=re;function ce(ue){return he=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}w.fromObservableLight=ce})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${C.f++}`,C.all.add(this)}start(u){this.g=new D.$Jd,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$Ld=C;let E=-1;function b(w){const u=E;return E=w,{dispose(){E=u}}}e.$Md=b;class l{constructor(u,$=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=$,this.g=0}dispose(){this.f?.clear()}check(u,$){const j=this.threshold;if(j<=0||$<j)return;this.f||(this.f=new Map);const M=this.f.get(u.value)||0;if(this.f.set(u.value,M+1),this.g-=1,this.g<=0){this.g=j*.5;let U,z=0;for(const[q,Z]of this.f)(!U||z<Z)&&(U=q,z=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${$} listeners already. MOST frequent listener (${z}):`),console.warn(U)}return()=>{const U=this.f.get(u.value)||0;this.f.set(u.value,U-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class y{constructor(u){this.value=u,this.id=p++}}const f=2,c=(w,u)=>{if(w instanceof y)u(w);else for(let $=0;$<w.length;$++){const j=w[$];j&&u(j)}};class h{constructor(u){this.w=0,this.f=u,this.g=E>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const u=this.t;queueMicrotask(()=>{c(u,$=>$.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,$,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.$Sc.None;if(this.m)return A.$Sc.None;$&&(u=u.bind($));const M=new y(u);let U,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(M.stack=d.create(),U=this.g.check(M.stack,this.w+1)),R&&(M.stack=z??d.create()),this.t?this.t instanceof y?(this.u??=new S,this.t=[this.t,M]):this.t.push(M):(this.f?.onWillAddFirstListener?.(this),this.t=M,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,A.$Qc)(()=>{U?.(),this.x(M)});return j instanceof A.$Rc?j.add(q):Array.isArray(j)&&j.push(q),q},this.q}x(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const $=this.t,j=$.indexOf(u);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,$[j]=void 0;const M=this.u.current===this;if(this.w*f<=$.length){let U=0;for(let z=0;z<$.length;z++)$[z]?$[U++]=$[z]:M&&(this.u.end--,U<this.u.i&&this.u.i--);$.length=U}}y(u,$){if(!u)return;const j=this.f?.onListenerError||I.$1;if(!j){u.value($);return}try{u.value($)}catch(M){j(M)}}z(u){const $=u.current.t;for(;u.i<u.end;)this.y($[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof y)this.y(this.t,u);else{const $=this.u;$.enqueue(this,u,this.t.length),this.z($)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=h;const m=()=>new S;e.$Od=m;class S{constructor(){this.i=-1,this.end=0}enqueue(u,$,j){this.i=0,this.end=j,this.current=u,this.value=$}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends h{async fireAsync(u,$,j){if(this.t)for(this.h||(this.h=new N.$2c),c(this.t,M=>this.h.push([M.value,u]));this.h.size>0&&!$.isCancellationRequested;){const[M,U]=this.h.shift(),z=[],q={...U,token:$,waitUntil:Z=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");j&&(Z=j(Z,M)),z.push(Z)}};try{M(q)}catch(Z){(0,I.$1)(Z);continue}Object.freeze(z),await Promise.allSettled(z).then(Z=>{for(const X of Z)X.status==="rejected"&&(0,I.$1)(X.reason)})}}}e.$Pd=s;class a extends h{get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new N.$2c,this.A=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.A(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.w&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$Qd=a;class n extends a{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$Rd=n;class i extends h{constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach($=>super.fire($)),this.h=[]}))}}e.$Sd=i;class t{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const $={event:u,listener:null};this.h.push($),this.g&&this.m($);const j=()=>{this.g&&this.o($);const M=this.h.indexOf($);this.h.splice(M,1)};return(0,A.$Qc)((0,L.$db)(j))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event($=>this.f.fire($))}o(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.f.dispose()}}e.$Td=t;class r{constructor(u,$,j,M){this.f=new A.$Rc;const U=this.f.add(new t),z=this.f.add(new A.$1c);function q(Z){z.set(Z,U.add(M(Z)))}for(const Z of u)q(Z);this.f.add($(Z=>{q(Z)})),this.f.add(j(Z=>{z.deleteAndDispose(Z)})),this.event=U.event}dispose(){this.f.dispose()}}e.$Ud=r;class o{constructor(){this.f=[]}wrapEvent(u){return($,j,M)=>u(U=>{const z=this.f[this.f.length-1];z?z.push(()=>$.call(j,U)):$.call(j,U)},void 0,M)}bufferEvents(u){const $=[];this.f.push($);const j=u();return this.f.pop(),$.forEach(M=>M()),j}}e.$Vd=o;class v{constructor(){this.f=!1,this.g=g.None,this.h=A.$Sc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=v}),define(oe[26],ae([0,1,3]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const L=Object.freeze(function(R,k){const g=setTimeout(R.bind(k),0);return{dispose(){clearTimeout(g)}}});var A;(function(R){function k(g){return g===R.None||g===R.Cancelled||g instanceof N?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=k,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(A||(e.CancellationToken=A={}));class N{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new I.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new N),this.f}cancel(){this.f?this.f instanceof N&&this.f.cancel():this.f=A.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof N&&this.f.dispose():this.f=A.None}}e.$Xd=D}),define(oe[129],ae([0,1,26]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class L{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$Xd,k=this.b(R.token);return this.a={promise:k,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$we=L;class A{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const k=JSON.stringify(R);return this.b!==k&&(this.b=k,this.a=this.c(R)),this.a}}e.$xe=A;class N{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const k=this.b(R);return this.a.set(R,k),k}}e.$ye=N}),define(oe[46],ae([0,1,8,2]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function A(m){const S=m;return S?typeof S.read=="function":!1}e.$Yd=A;function N(m){const S=m;return S?[S.on,S.pause,S.resume,S.destroy].every(s=>typeof s=="function"):!1}e.$Zd=N;function D(m){const S=m;return S?N(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$1d=D;function R(m,S){return new k(m,S)}e.$2d=R;class k{constructor(S,s){this.e=S,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(s=>s(S))}h(S){this.c.error.length===0?(0,I.$1)(S):this.c.error.slice(0).forEach(s=>s(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,s){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(S,s){if(this.a.destroyed)return;let a;switch(S){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(s);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(m,S){const s=[];let a;for(;(a=m.read())!==null;)s.push(a);return S(s)}e.$3d=g;function C(m,S,s){const a=[];let n;for(;(n=m.read())!==null&&a.length<s;)a.push(n);return n===null&&a.length>0?S(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return m.read()}}}e.$4d=C;function E(m,S){return new Promise((s,a)=>{const n=[];b(m,{onData:i=>{S&&n.push(i)},onError:i=>{S?a(i):s(void 0)},onEnd:()=>{s(S?S(n):void 0)}})})}e.$5d=E;function b(m,S,s){m.on("error",a=>{s?.isCancellationRequested||S.onError(a)}),m.on("end",()=>{s?.isCancellationRequested||S.onEnd()}),m.on("data",a=>{s?.isCancellationRequested||S.onData(a)})}e.$6d=b;function l(m,S){return new Promise((s,a)=>{const n=new L.$Rc,i=[],t=v=>{if(i.push(v),i.length>S)return n.dispose(),m.pause(),s({stream:m,buffer:i,ended:!1})},r=v=>(n.dispose(),a(v)),o=()=>(n.dispose(),s({stream:m,buffer:i,ended:!0}));n.add((0,L.$Qc)(()=>m.removeListener("error",r))),m.on("error",r),n.add((0,L.$Qc)(()=>m.removeListener("end",o))),m.on("end",o),n.add((0,L.$Qc)(()=>m.removeListener("data",t))),m.on("data",t)})}e.$7d=l;function d(m,S){const s=R(S);return s.end(m),s}e.$8d=d;function p(){const m=R(()=>{throw new Error("not supported")});return m.end(),m}e.$9d=p;function y(m){let S=!1;return{read:()=>S?null:(S=!0,m)}}e.$0d=y;function f(m,S,s){const a=R(s);return b(m,{onData:n=>a.write(S.data(n)),onError:n=>a.error(S.error?S.error(n):n),onEnd:()=>a.end()}),a}e.$$d=f;function c(m,S,s){let a=!1;return{read:()=>{const n=S.read();return a?n:(a=!0,n!==null?s([m,n]):m)}}}e.$_d=c;function h(m,S,s){let a=!1;const n=R(s);return b(S,{onData:i=>a?n.write(i):(a=!0,n.write(s([m,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(m)),n.end()}}),n}e.$ae=h}),define(oe[15],ae([0,1,60,46]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const A=typeof Buffer<"u",N=new I.$V(()=>new Uint8Array(256));let D,R;class k{static alloc($){return A?new k(Buffer.allocUnsafe($)):new k(new Uint8Array($))}static wrap($){return A&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new k($)}static fromString($,j){return!(j?.dontUseNodeBuffer||!1)&&A?new k(Buffer.from($)):(D||(D=new TextEncoder),new k(D.encode($)))}static fromByteArray($){const j=k.alloc($.length);for(let M=0,U=$.length;M<U;M++)j.buffer[M]=$[M];return j}static concat($,j){if(typeof j>"u"){j=0;for(let z=0,q=$.length;z<q;z++)j+=$[z].byteLength}const M=k.alloc(j);let U=0;for(let z=0,q=$.length;z<q;z++){const Z=$[z];M.set(Z,U),U+=Z.byteLength}return M}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=k.alloc(this.byteLength);return $.set(this),$}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice($,j){return new k(this.buffer.subarray($,j))}set($,j){if($ instanceof k)this.buffer.set($.buffer,j);else if($ instanceof Uint8Array)this.buffer.set($,j);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),j);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return b(this.buffer,$)}writeUInt32BE($,j){l(this.buffer,$,j)}readUInt32LE($){return d(this.buffer,$)}writeUInt32LE($,j){p(this.buffer,$,j)}readUInt8($){return y(this.buffer,$)}writeUInt8($,j){f(this.buffer,$,j)}indexOf($,j=0){return g(this.buffer,$ instanceof k?$.buffer:$,j)}}e.$be=k;function g(u,$,j=0){const M=$.byteLength,U=u.byteLength;if(M===0)return 0;if(M===1)return u.indexOf($[0]);if(M>U-j)return-1;const z=N.value;z.fill($.length);for(let x=0;x<$.length;x++)z[$[x]]=$.length-x-1;let q=j+$.length-1,Z=q,X=-1;for(;q<U;)if(u[q]===$[Z]){if(Z===0){X=q;break}q--,Z--}else q+=Math.max($.length-Z,z[u[q]]),Z=$.length-1;return X}e.$ce=g;function C(u,$){return u[$+0]<<0>>>0|u[$+1]<<8>>>0}e.$de=C;function E(u,$,j){u[j+0]=$&255,$=$>>>8,u[j+1]=$&255}e.$ee=E;function b(u,$){return u[$]*2**24+u[$+1]*2**16+u[$+2]*2**8+u[$+3]}e.$fe=b;function l(u,$,j){u[j+3]=$,$=$>>>8,u[j+2]=$,$=$>>>8,u[j+1]=$,$=$>>>8,u[j]=$}e.$ge=l;function d(u,$){return u[$+0]<<0>>>0|u[$+1]<<8>>>0|u[$+2]<<16>>>0|u[$+3]<<24>>>0}e.$he=d;function p(u,$,j){u[j+0]=$&255,$=$>>>8,u[j+1]=$&255,$=$>>>8,u[j+2]=$&255,$=$>>>8,u[j+3]=$&255}e.$ie=p;function y(u,$){return u[$]}e.$je=y;function f(u,$,j){u[j]=$}e.$ke=f;function c(u){return L.$3d(u,$=>k.concat($))}e.$le=c;function h(u){return L.$0d(u)}e.$me=h;function m(u){return L.$5d(u,$=>k.concat($))}e.$ne=m;async function S(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await m(u.stream)])}e.$oe=S;function s(u){return L.$8d(u,$=>k.concat($))}e.$pe=s;function a(u){return L.$$d(u,{data:$=>typeof $=="string"?k.fromString($):k.wrap($)},$=>k.concat($))}e.$qe=a;function n(u){return L.$2d($=>k.concat($),u)}e.$re=n;function i(u,$){return L.$_d(u,$,j=>k.concat(j))}e.$se=i;function t(u,$){return L.$ae(u,$,j=>k.concat(j))}e.$te=t;function r(u){let $=0,j=0,M=0;const U=new Uint8Array(Math.floor(u.length/4*3)),z=Z=>{switch(j){case 3:U[M++]=$|Z,j=0;break;case 2:U[M++]=$|Z>>>2,$=Z<<6,j=3;break;case 1:U[M++]=$|Z>>>4,$=Z<<4,j=2;break;default:$=Z<<2,j=1}};for(let Z=0;Z<u.length;Z++){const X=u.charCodeAt(Z);if(X>=65&&X<=90)z(X-65);else if(X>=97&&X<=122)z(X-97+26);else if(X>=48&&X<=57)z(X-48+52);else if(X===43||X===45)z(62);else if(X===47||X===95)z(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Z]}`)}}const q=M;for(;j>0;)z(0);return k.wrap(U).slice(0,q)}e.$ue=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:u},$=!0,j=!1){const M=j?v:o;let U="";const z=u.byteLength%3;let q=0;for(;q<u.byteLength-z;q+=3){const Z=u[q+0],X=u[q+1],x=u[q+2];U+=M[Z>>>2],U+=M[(Z<<4|X>>>4)&63],U+=M[(X<<2|x>>>6)&63],U+=M[x&63]}if(z===1){const Z=u[q+0];U+=M[Z>>>2],U+=M[Z<<4&63],$&&(U+="==")}else if(z===2){const Z=u[q+0],X=u[q+1];U+=M[Z>>>2],U+=M[(Z<<4|X>>>4)&63],U+=M[X<<2&63],$&&(U+="=")}return U}e.$ve=w}),define(oe[27],ae([0,1,129,60]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function A(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.$Be=A;const N=/{(\d+)}/g;function D(se,...fe){return fe.length===0?se:se.replace(N,function(me,pe){const Se=parseInt(pe,10);return isNaN(Se)||Se<0||Se>=fe.length?me:fe[Se]})}e.$Ce=D;const R=/{([^}]+)}/g;function k(se,fe){return se.replace(R,(me,pe)=>fe[pe]??me)}e.$De=k;function g(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ee=g;function C(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=C;function E(se,fe){let me=0;const pe=fe.charCodeAt(0);for(let Se=se.length-1;Se>=0;Se--)se.charCodeAt(Se)===pe&&me++;return me}e.$Ge=E;function b(se,fe,me="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${me}`}e.$He=b;function l(se,fe=" "){const me=d(se,fe);return p(me,fe)}e.$Ie=l;function d(se,fe){if(!se||!fe)return se;const me=fe.length;if(me===0||se.length===0)return se;let pe=0;for(;se.indexOf(fe,pe)===pe;)pe=pe+me;return se.substring(pe)}e.$Je=d;function p(se,fe){if(!se||!fe)return se;const me=fe.length,pe=se.length;if(me===0||pe===0)return se;let Se=pe,Re=-1;for(;Re=se.lastIndexOf(fe,Se-1),!(Re===-1||Re+me!==Se);){if(Re===0)return"";Se=Re}return se.substring(0,Se)}e.$Ke=p;function y(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=y;function f(se){return se.replace(/\*/g,"")}e.$Me=f;function c(se,fe,me={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=C(se)),me.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(se,pe)}e.$Ne=c;function h(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.$Oe=h;function m(se){return se.split(/\r\n|\r|\n/)}e.$Pe=m;function S(se){for(let fe=0,me=se.length;fe<me;fe++){const pe=se.charCodeAt(fe);if(pe!==32&&pe!==9)return fe}return-1}e.$Qe=S;function s(se,fe=0,me=se.length){for(let pe=fe;pe<me;pe++){const Se=se.charCodeAt(pe);if(Se!==32&&Se!==9)return se.substring(fe,pe)}return se.substring(fe,me)}e.$Re=s;function a(se,fe=se.length-1){for(let me=fe;me>=0;me--){const pe=se.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Se=a;function n(se,fe,me){const pe=[];let Se=0;for(const Re of se.matchAll(fe)){if(pe.push(se.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,se,Re.groups))}return pe.push(se.slice(Se)),Promise.all(pe).then(Re=>Re.join(""))}e.$Te=n;function i(se,fe){return se<fe?-1:se>fe?1:0}e.$Ue=i;function t(se,fe,me=0,pe=se.length,Se=0,Re=fe.length){for(;me<pe&&Se<Re;me++,Se++){const Oe=se.charCodeAt(me),Ne=fe.charCodeAt(Se);if(Oe<Ne)return-1;if(Oe>Ne)return 1}const Ce=pe-me,De=Re-Se;return Ce<De?-1:Ce>De?1:0}e.$Ve=t;function r(se,fe){return o(se,fe,0,se.length,0,fe.length)}e.$We=r;function o(se,fe,me=0,pe=se.length,Se=0,Re=fe.length){for(;me<pe&&Se<Re;me++,Se++){let Oe=se.charCodeAt(me),Ne=fe.charCodeAt(Se);if(Oe===Ne)continue;if(Oe>=128||Ne>=128)return t(se.toLowerCase(),fe.toLowerCase(),me,pe,Se,Re);w(Oe)&&(Oe-=32),w(Ne)&&(Ne-=32);const Me=Oe-Ne;if(Me!==0)return Me}const Ce=pe-me,De=Re-Se;return Ce<De?-1:Ce>De?1:0}e.$Xe=o;function v(se){return se>=48&&se<=57}e.$Ye=v;function w(se){return se>=97&&se<=122}e.$Ze=w;function u(se){return se>=65&&se<=90}e.$1e=u;function $(se,fe){return se.length===fe.length&&o(se,fe)===0}e.$2e=$;function j(se,fe){const me=fe.length;return fe.length>se.length?!1:o(se,fe,0,me)===0}e.$3e=j;function M(se,fe){const me=Math.min(se.length,fe.length);let pe;for(pe=0;pe<me;pe++)if(se.charCodeAt(pe)!==fe.charCodeAt(pe))return pe;return me}e.$4e=M;function U(se,fe){const me=Math.min(se.length,fe.length);let pe;const Se=se.length-1,Re=fe.length-1;for(pe=0;pe<me;pe++)if(se.charCodeAt(Se-pe)!==fe.charCodeAt(Re-pe))return pe;return me}e.$5e=U;function z(se){return 55296<=se&&se<=56319}e.$6e=z;function q(se){return 56320<=se&&se<=57343}e.$7e=q;function Z(se,fe){return(se-55296<<10)+(fe-56320)+65536}e.$8e=Z;function X(se,fe,me){const pe=se.charCodeAt(me);if(z(pe)&&me+1<fe){const Se=se.charCodeAt(me+1);if(q(Se))return Z(pe,Se)}return pe}e.$9e=X;function x(se,fe){const me=se.charCodeAt(fe-1);if(q(me)&&fe>1){const pe=se.charCodeAt(fe-2);if(z(pe))return Z(pe,me)}return me}class H{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=x(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=X(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$0e=H;class Q{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new H(fe,me)}nextGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let Se=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.nextCodePoint());if(Te(Se,Ce)){me.setOffset(Re);break}Se=Ce}return me.offset-pe}prevGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let Se=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.prevCodePoint());if(Te(Ce,Se)){me.setOffset(Re);break}Se=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$$e=Q;function J(se,fe){return new Q(se,fe).nextGraphemeLength()}e.$_e=J;function W(se,fe){return new Q(se,fe).prevGraphemeLength()}e.$af=W;function ee(se,fe){fe>0&&q(se.charCodeAt(fe))&&fe--;const me=fe+J(se,fe);return[me-W(se,me),me]}e.$bf=ee;function ne(se){const fe=new Q(se);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$cf=ne;let _;function ie(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(se){return _||(_=ie()),_.test(se)}e.$df=K;const B=/^[\t\n\r\x20-\x7E]*$/;function P(se){return B.test(se)}e.$ef=P,e.$ff=/[\u2028\u2029]/;function O(se){return e.$ff.test(se)}e.$gf=O;function T(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.$hf=T;function F(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.$if=F;function V(se,fe){if(se.length<fe)return se;const me=/\b/g;let pe=0;for(;me.test(se)&&!(se.length-me.lastIndex<fe);)pe=me.lastIndex,me.lastIndex+=1;return se.substring(pe).replace(/^\s/,"")}e.$jf=V;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function ce(se){return se&&(se=se.replace(G,"").replace(re,"")),se}e.$kf=ce,e.$lf=String.fromCharCode(65279);function ue(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.$mf=ue;function he(se){return ue(se)?se.substr(1):se}e.$nf=he;function $e(se,fe){if(!se||!fe||se.length<fe.length)return!1;const me=fe.length,pe=se.toLowerCase();let Se=0,Re=-1;for(;Se<me;){const Ce=pe.indexOf(fe[Se],Re+1);if(Ce<0)return!1;Re=Ce,Se++}return!0}e.$of=$e;function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.$pf=de;function we(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.$qf=we;function Ee(se,fe=1){if(fe===0)return"";let me=-1;do me=se.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?se:(se[me-1]==="\r"&&me--,se.substr(0,me))}e.$rf=Ee;function Ie(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.$sf=Ie;function Le(se){return ge.getInstance().getGraphemeBreakType(se)}e.$tf=Le;function Te(se,fe){return se===0?fe!==5&&fe!==7:se===2&&fe===3?!1:se===4||se===2||se===3||fe===4||fe===2||fe===3?!0:!(se===8&&(fe===8||fe===9||fe===11||fe===12)||(se===11||se===9)&&(fe===9||fe===10)||(se===12||se===10)&&fe===10||fe===5||fe===13||fe===7||se===1||se===13&&fe===14||se===6&&fe===6)}var le;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,pe=me.length/3;let Se=1;for(;Se<=pe;)if(fe<me[3*Se])Se=2*Se;else if(fe>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(se,fe){if(se===0)return 0;const me=Pe(se,fe);if(me!==void 0)return me;const pe=new H(fe,se);return pe.prevCodePoint(),pe.offset}e.$uf=ke;function Pe(se,fe){const me=new H(fe,se);let pe=me.prevCodePoint();for(;Ue(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!F(pe))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function Ue(se){return 127995<=se&&se<=127999}var je;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$vf="\xA0";class ze{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$xe(fe=>{function me(Me){const Be=new Map;for(let qe=0;qe<Me.length;qe+=2)Be.set(Me[qe],Me[qe+1]);return Be}function pe(Me,Be){const qe=new Map(Me);for(const[Ve,_e]of Be)qe.set(Ve,_e);return qe}function Se(Me,Be){if(!Me)return Be;const qe=new Map;for(const[Ve,_e]of Me)Be.has(Ve)&&qe.set(Ve,_e);return qe}const Re=this.c.value;let Ce=fe.filter(Me=>!Me.startsWith("_")&&Me in Re);Ce.length===0&&(Ce=["_default"]);let De;for(const Me of Ce){const Be=me(Re[Me]);De=Se(De,Be)}const Oe=me(Re._common),Ne=pe(Oe,De);return new ze(Ne)})}static getInstance(fe){return ze.d.get(Array.from(fe))}static{this.e=new L.$V(()=>Object.keys(ze.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return ze.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=ze;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(fe){return Fe.e().has(fe)}static get codePoints(){return Fe.e()}}e.$xf=Fe}),define(oe[52],ae([0,1,27]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function L(f){return A(f,0)}e.$Di=L;function A(f,c){switch(typeof f){case"object":return f===null?N(349,c):Array.isArray(f)?k(f,c):g(f,c);case"string":return R(f,c);case"boolean":return D(f,c);case"number":return N(f,c);case"undefined":return N(937,c);default:return N(617,c)}}e.$Ei=A;function N(f,c){return(c<<5)-c+f|0}e.$Fi=N;function D(f,c){return N(f?433:863,c)}function R(f,c){c=N(149417,c);for(let h=0,m=f.length;h<m;h++)c=N(f.charCodeAt(h),c);return c}e.$Gi=R;function k(f,c){return c=N(104579,c),f.reduce((h,m)=>A(m,h),c)}function g(f,c){return c=N(181387,c),Object.keys(f).sort().reduce((h,m)=>(h=R(m,h),A(f[m],h)),c)}class C{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=A(c,this.g),this.g}}e.$Hi=C;var E;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(f,c,h=32){const m=h-c,S=~((1<<m)-1);return(f<<c|(S&f)>>>m)>>>0}function l(f,c=0,h=f.byteLength,m=0){for(let S=0;S<h;S++)f[c+S]=m}function d(f,c,h="0"){for(;f.length<c;)f=h+f;return f}function p(f,c=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((f>>>0).toString(16),c/4)}e.$Ii=p;class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const h=c.length;if(h===0)return;const m=this.p;let S=this.r,s=this.u,a,n;for(s!==0?(a=s,n=-1,s=0):(a=c.charCodeAt(0),n=0);;){let i=a;if(I.$6e(a))if(n+1<h){const t=c.charCodeAt(n+1);I.$7e(t)?(n++,i=I.$8e(a,t)):i=65533}else{s=a;break}else I.$7e(a)&&(i=65533);if(S=this.w(m,S,i),n++,n<h)a=c.charCodeAt(n);else break}this.r=S,this.u=s}w(c,h,m){return m<128?c[h++]=m:m<2048?(c[h++]=192|(m&1984)>>>6,c[h++]=128|(m&63)>>>0):m<65536?(c[h++]=224|(m&61440)>>>12,c[h++]=128|(m&4032)>>>6,c[h++]=128|(m&63)>>>0):(c[h++]=240|(m&1835008)>>>18,c[h++]=128|(m&258048)>>>12,c[h++]=128|(m&4032)>>>6,c[h++]=128|(m&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=y.g,h=this.q;for(let o=0;o<64;o+=4)c.setUint32(o,h.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)c.setUint32(o,b(c.getUint32(o-12,!1)^c.getUint32(o-32,!1)^c.getUint32(o-56,!1)^c.getUint32(o-64,!1),1),!1);let m=this.h,S=this.l,s=this.m,a=this.n,n=this.o,i,t,r;for(let o=0;o<80;o++)o<20?(i=S&s|~S&a,t=1518500249):o<40?(i=S^s^a,t=1859775393):o<60?(i=S&s|S&a|s&a,t=2400959708):(i=S^s^a,t=3395469782),r=b(m,5)+i+n+t+c.getUint32(o*4,!1)&4294967295,n=a,a=s,s=b(S,30),S=m,m=r;this.h=this.h+m&4294967295,this.l=this.l+S&4294967295,this.m=this.m+s&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}e.$Ji=y}),define(oe[89],ae([0,1,27]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(L||(L={})),function(A){const N="error",D="warning",R="warn",k="info",g="ignore";function C(b){return b?I.$2e(N,b)?A.Error:I.$2e(D,b)||I.$2e(R,b)?A.Warning:I.$2e(k,b)?A.Info:A.Ignore:A.Ignore}A.fromValue=C;function E(b){switch(b){case A.Error:return N;case A.Warning:return D;case A.Info:return k;default:return g}}A.toString=E}(L||(L={})),e.default=L}),define(oe[130],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const d=l.charCodeAt(0),p=this.b.charCodeAt(this.c);return d-p}value(){return this.b[this.c]}}e.$Rh=A;class N{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,L.$Ve)(l,this.b,0,l.length,this.c,this.d):(0,L.$Xe)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=N;class D{constructor(l=!0,d=!0){this.f=l,this.g=d}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let d=l.length-1;d>=0;d--,this.c--){const p=this.b.charCodeAt(d);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,L.$Ve)(l,this.b,0,l.length,this.d,this.e):(0,L.$Xe)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=D;var R;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(R||(R={}));class k{constructor(l,d){this.f=l,this.g=d,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,L.$We)(l,this.c.scheme);if(this.d[this.e]===2)return(0,L.$We)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,L.$Ue)(l,this.c.query);if(this.d[this.e]===5)return(0,L.$Ue)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=k;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(C||(C={}));class E{static forUris(l=()=>!1,d=()=>!1){return new E(new k(l,d))}static forPaths(l=!1){return new E(new D(void 0,!l))}static forStrings(){return new E(new A)}static forConfigKeys(){return new E(new N)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,d){if(d){const p=d.slice(0);(0,I.$Xb)(p);for(const y of p)this.set(y,l)}else{const p=l.slice(0);(0,I.$Xb)(p);for(const y of p)this.set(y[0],y[1])}}set(l,d){const p=this.b.reset(l);let y;this.c||(this.c=new g,this.c.segment=p.value());const f=[];for(y=this.c;;){const h=p.cmp(y.segment);if(h>0)y.left||(y.left=new g,y.left.segment=p.value()),f.push([-1,y]),y=y.left;else if(h<0)y.right||(y.right=new g,y.right.segment=p.value()),f.push([1,y]),y=y.right;else if(p.hasNext())p.next(),y.mid||(y.mid=new g,y.mid.segment=p.value()),f.push([0,y]),y=y.mid;else break}const c=y.value;y.value=d,y.key=l;for(let h=f.length-1;h>=0;h--){const m=f[h][1];m.updateHeight();const S=m.balanceFactor();if(S<-1||S>1){const s=f[h][0],a=f[h+1][0];if(s===1&&a===1)f[h][1]=m.rotateLeft();else if(s===-1&&a===-1)f[h][1]=m.rotateRight();else if(s===1&&a===-1)m.right=f[h+1][1]=f[h+1][1].rotateRight(),f[h][1]=m.rotateLeft();else if(s===-1&&a===1)m.left=f[h+1][1]=f[h+1][1].rotateLeft(),f[h][1]=m.rotateRight();else throw new Error;if(h>0)switch(f[h-1][0]){case-1:f[h-1][1].left=f[h][1];break;case 1:f[h-1][1].right=f[h][1];break;case 0:f[h-1][1].mid=f[h][1];break}else this.c=f[0][1]}}return c}get(l){return this.d(l)?.value}d(l){const d=this.b.reset(l);let p=this.c;for(;p;){const y=d.cmp(p.segment);if(y>0)p=p.left;else if(y<0)p=p.right;else if(d.hasNext())d.next(),p=p.mid;else break}return p}has(l){const d=this.d(l);return!(d?.value===void 0&&d?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,d){const p=this.b.reset(l),y=[];let f=this.c;for(;f;){const c=p.cmp(f.segment);if(c>0)y.push([-1,f]),f=f.left;else if(c<0)y.push([1,f]),f=f.right;else if(p.hasNext())p.next(),y.push([0,f]),f=f.mid;else break}if(f){if(d?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const c=this.f(f.right);if(c.key){const{key:h,value:m,segment:S}=c;this.e(c.key,!1),f.key=h,f.value=m,f.segment=S}}else{const c=f.left??f.right;if(y.length>0){const[h,m]=y[y.length-1];switch(h){case-1:m.left=c;break;case 0:m.mid=c;break;case 1:m.right=c;break}}else this.c=c}for(let c=y.length-1;c>=0;c--){const h=y[c][1];h.updateHeight();const m=h.balanceFactor();if(m>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),y[c][1]=h.rotateLeft()):m<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),y[c][1]=h.rotateRight()),c>0)switch(y[c-1][0]){case-1:y[c-1][1].left=y[c][1];break;case 1:y[c-1][1].right=y[c][1];break;case 0:y[c-1][1].mid=y[c][1];break}else this.c=y[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const d=this.b.reset(l);let p=this.c,y;for(;p;){const f=d.cmp(p.segment);if(f>0)p=p.left;else if(f<0)p=p.right;else if(d.hasNext())d.next(),y=p.value||y,p=p.mid;else break}return p&&p.value||y}findSuperstr(l){return this.g(l,!1)}g(l,d){const p=this.b.reset(l);let y=this.c;for(;y;){const f=p.cmp(y.segment);if(f>0)y=y.left;else if(f<0)y=y.right;else if(p.hasNext())p.next(),y=y.mid;else return y.mid?this.h(y.mid):d?y.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[d,p]of this)l(p,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const d=[];return this.j(l,d),d[Symbol.iterator]()}j(l,d){l&&(l.left&&this.j(l.left,d),l.value&&d.push([l.key,l.value]),l.mid&&this.j(l.mid,d),l.right&&this.j(l.right,d))}_isBalanced(){const l=d=>{if(!d)return!0;const p=d.balanceFactor();return p<-1||p>1?!1:l(d.left)&&l(d.right)};return l(this.c)}}e.$Vh=E}),define(oe[12],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function I(S){return typeof S=="string"}e.$yf=I;function L(S){return Array.isArray(S)&&S.every(s=>I(s))}e.$zf=L;function A(S){return typeof S=="object"&&S!==null&&!Array.isArray(S)&&!(S instanceof RegExp)&&!(S instanceof Date)}e.$Af=A;function N(S){const s=Object.getPrototypeOf(Uint8Array);return typeof S=="object"&&S instanceof s}e.$Bf=N;function D(S){return typeof S=="number"&&!isNaN(S)}e.$Cf=D;function R(S){return!!S&&typeof S[Symbol.iterator]=="function"}e.$Df=R;function k(S){return S===!0||S===!1}e.$Ef=k;function g(S){return typeof S>"u"}e.$Ff=g;function C(S){return!E(S)}e.$Gf=C;function E(S){return g(S)||S===null}e.$Hf=E;function b(S,s){if(!S)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$If=b;function l(S){if(E(S))throw new Error("Assertion Failed: argument is undefined or null");return S}e.$Jf=l;function d(...S){const s=[];for(let a=0;a<S.length;a++){const n=S[a];if(E(n))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);s.push(n)}return s}e.$Kf=d;const p=Object.prototype.hasOwnProperty;function y(S){if(!A(S))return!1;for(const s in S)if(p.call(S,s))return!1;return!0}e.$Lf=y;function f(S){return typeof S=="function"}e.$Mf=f;function c(...S){return S.length>0&&S.every(f)}e.$Nf=c;function h(S,s){const a=Math.min(S.length,s.length);for(let n=0;n<a;n++)m(S[n],s[n])}e.$Of=h;function m(S,s){if(I(s)){if(typeof S!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(f(s)){try{if(S instanceof s)return}catch{}if(!E(S)&&S.constructor===s||s.length===1&&s.call(void 0,S)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=m}),define(oe[30],ae([0,1,12]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function L(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const c=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([h,m])=>{c[h]=m&&typeof m=="object"?L(m):m}),c}e.$7m=L;function A(f){if(!f||typeof f!="object")return f;const c=[f];for(;c.length>0;){const h=c.shift();Object.freeze(h);for(const m in h)if(N.call(h,m)){const S=h[m];typeof S=="object"&&!Object.isFrozen(S)&&!(0,I.$Bf)(S)&&c.push(S)}}return f}e.$8m=A;const N=Object.prototype.hasOwnProperty;function D(f,c){return R(f,c,new Set)}e.$9m=D;function R(f,c,h){if((0,I.$Hf)(f))return f;const m=c(f);if(typeof m<"u")return m;if(Array.isArray(f)){const S=[];for(const s of f)S.push(R(s,c,h));return S}if((0,I.$Af)(f)){if(h.has(f))throw new Error("Cannot clone recursive data-structure");h.add(f);const S={};for(const s in f)N.call(f,s)&&(S[s]=R(f[s],c,h));return h.delete(f),S}return f}function k(f,c,h=!0){return(0,I.$Af)(f)?((0,I.$Af)(c)&&Object.keys(c).forEach(m=>{m in f?h&&((0,I.$Af)(f[m])&&(0,I.$Af)(c[m])?k(f[m],c[m],h):f[m]=c[m]):f[m]=c[m]}),f):c}e.$0m=k;function g(f,c){if(f===c)return!0;if(f==null||c===null||c===void 0||typeof f!=typeof c||typeof f!="object"||Array.isArray(f)!==Array.isArray(c))return!1;let h,m;if(Array.isArray(f)){if(f.length!==c.length)return!1;for(h=0;h<f.length;h++)if(!g(f[h],c[h]))return!1}else{const S=[];for(m in f)S.push(m);S.sort();const s=[];for(m in c)s.push(m);if(s.sort(),!g(S,s))return!1;for(h=0;h<S.length;h++)if(!g(f[S[h]],c[S[h]]))return!1}return!0}e.$$m=g;function C(f){const c=new Set;return JSON.stringify(f,(h,m)=>{if((0,I.$Af)(m)||Array.isArray(m)){if(c.has(m))return"[Circular]";c.add(m)}return m})}e.$_m=C;function E(f,c){const h=Object.create(null);return!f||!c||Object.keys(c).forEach(S=>{const s=f[S],a=c[S];g(s,a)||(h[S]=a)}),h}e.$an=E;function b(f,c){const h=c.toLowerCase(),m=Object.keys(f).find(S=>S.toLowerCase()===h);return m?f[m]:f[c]}e.$bn=b;function l(f,c){const h=Object.create(null);for(const[m,S]of Object.entries(f))c(m,S)&&(h[m]=S);return h}e.$cn=l;function d(f){let c=[];for(;Object.prototype!==f;)c=c.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return c}e.$dn=d;function p(f){const c=[];for(const h of d(f))typeof f[h]=="function"&&c.push(h);return c}e.$en=p;function y(f,c){const h=S=>function(){const s=Array.prototype.slice.call(arguments,0);return c(S,s)},m={};for(const S of f)m[S]=h(S);return m}e.$fn=y}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(A){return I.test(A)}e.$dg=L,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(R){for(let k=0;k<R.length;k++)R[k]=Math.floor(Math.random()*256);return R};const N=new Uint8Array(16),D=[];for(let R=0;R<256;R++)D.push(R.toString(16).padStart(2,"0"));return function(){A(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let k=0,g="";return g+=D[N[k++]],g+=D[N[k++]],g+=D[N[k++]],g+=D[N[k++]],g+="-",g+=D[N[k++]],g+=D[N[k++]],g+="-",g+=D[N[k++]],g+=D[N[k++]],g+="-",g+=D[N[k++]],g+=D[N[k++]],g+="-",g+=D[N[k++]],g+=D[N[k++]],g+=D[N[k++]],g+=D[N[k++]],g+=D[N[k++]],g+=D[N[k++]],g}}()}),define(oe[131],ae([0,1,36]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(D){const R=D.replace(/\-/g,":").toLowerCase();return!L.has(R)}function N(){const D=(0,I.networkInterfaces)();for(const R in D){const k=D[R];if(k){for(const{mac:g}of k)if(A(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Qm=N}),define(oe[132],ae([0,1,268,15]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fT=void 0;class A extends I.Transform{constructor(D){if(super(),typeof D=="number")this.b=D,this.c=1;else{const R=Buffer.isBuffer(D)?D:Buffer.from(D);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(D,R,k){this.a?this.a=Buffer.concat([this.a,D]):this.a=D;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,L.$ce)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),k()}_flush(D){this.a&&this.push(this.a),D()}}e.$fT=A}),define(oe[133],ae([0,1,62]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function L(R,k,g,C=1){let E=!1;return new Promise(b=>{const l=setTimeout(()=>{if(!E)return E=!0,b(0)},g);A(R,k,C,d=>{if(!E)return E=!0,clearTimeout(l),b(d)})})}e.$gg=L;function A(R,k,g,C){if(k===0)return C(0);const E=new I.Socket;E.once("connect",()=>(D(E),A(R+g,k-1,g,C))),E.once("data",()=>{}),E.once("error",b=>(D(E),b.code!=="ECONNREFUSED"?A(R+g,k-1,g,C):C(R))),E.connect(R,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function N(R,k,g,C="127.0.0.1"){let E=!1,b,l=1;const d=I.createServer({pauseOnConnect:!0});function p(y,f){E||(E=!0,d.removeAllListeners(),d.close(),b&&clearTimeout(b),f(y))}return new Promise(y=>{b=setTimeout(()=>{p(0,y)},g),d.on("listening",()=>{p(R,y)}),d.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&l<k?(R++,l++,d.listen(R,C)):p(0,y)}),d.on("close",()=>{p(0,y)}),d.listen(R,C)})}e.$ig=N;function D(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(k){console.error(k)}}}),define(oe[134],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vT=void 0;function I(L){return!!L.parentPort}e.$vT=I}),define(oe[135],ae([13,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[63],ae([0,1,135]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const L=60,A=L*60,N=A*24,D=N*7,R=N*30,k=N*365;function g(E,b,l,d){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,I.localize)(0,null,g(new Date().getTime()+p*1e3,!1));if(!d&&p<30)return(0,I.localize)(1,null);let y;return p<L?(y=p,b?y===1?l?(0,I.localize)(2,null,y):(0,I.localize)(3,null,y):l?(0,I.localize)(4,null,y):(0,I.localize)(5,null,y):y===1?l?(0,I.localize)(6,null,y):(0,I.localize)(7,null,y):l?(0,I.localize)(8,null,y):(0,I.localize)(9,null,y)):p<A?(y=Math.floor(p/L),b?y===1?l?(0,I.localize)(10,null,y):(0,I.localize)(11,null,y):l?(0,I.localize)(12,null,y):(0,I.localize)(13,null,y):y===1?l?(0,I.localize)(14,null,y):(0,I.localize)(15,null,y):l?(0,I.localize)(16,null,y):(0,I.localize)(17,null,y)):p<N?(y=Math.floor(p/A),b?y===1?l?(0,I.localize)(18,null,y):(0,I.localize)(19,null,y):l?(0,I.localize)(20,null,y):(0,I.localize)(21,null,y):y===1?l?(0,I.localize)(22,null,y):(0,I.localize)(23,null,y):l?(0,I.localize)(24,null,y):(0,I.localize)(25,null,y)):p<D?(y=Math.floor(p/N),b?y===1?(0,I.localize)(26,null,y):(0,I.localize)(27,null,y):y===1?(0,I.localize)(28,null,y):(0,I.localize)(29,null,y)):p<R?(y=Math.floor(p/D),b?y===1?l?(0,I.localize)(30,null,y):(0,I.localize)(31,null,y):l?(0,I.localize)(32,null,y):(0,I.localize)(33,null,y):y===1?l?(0,I.localize)(34,null,y):(0,I.localize)(35,null,y):l?(0,I.localize)(36,null,y):(0,I.localize)(37,null,y)):p<k?(y=Math.floor(p/R),b?y===1?l?(0,I.localize)(38,null,y):(0,I.localize)(39,null,y):l?(0,I.localize)(40,null,y):(0,I.localize)(41,null,y):y===1?l?(0,I.localize)(42,null,y):(0,I.localize)(43,null,y):l?(0,I.localize)(44,null,y):(0,I.localize)(45,null,y)):(y=Math.floor(p/k),b?y===1?l?(0,I.localize)(46,null,y):(0,I.localize)(47,null,y):l?(0,I.localize)(48,null,y):(0,I.localize)(49,null,y):y===1?l?(0,I.localize)(50,null,y):(0,I.localize)(51,null,y):l?(0,I.localize)(52,null,y):(0,I.localize)(53,null,y))}e.$dm=g;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=C}),define(oe[136],ae([13,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,12,136]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function N(E,b){return b&&(E.stack||E.stacktrace)?A.localize(0,null,R(E),D(E.stack)||D(E.stacktrace)):R(E)}function D(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?A.localize(1,null,E.message):E.message||A.localize(2,null)}function k(E=null,b=!1){if(!E)return A.localize(3,null);if(Array.isArray(E)){const l=I.$Hb(E),d=k(l[0],b);return l.length>1?A.localize(4,null,d,l.length):d}if(L.$yf(E))return E;if(E.detail){const l=E.detail;if(l.error)return N(l.error,b);if(l.exception)return N(l.exception,b)}return E.stack?N(E,b):E.message?E.message:A.localize(5,null)}e.$Ai=k;function g(E){const b=E;return b instanceof Error&&Array.isArray(b.actions)}e.$Bi=g;function C(E,b){let l;return typeof E=="string"?l=new Error(E):l=E,l.actions=b,l}e.$Ci=C}),define(oe[137],ae([13,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[138],ae([0,1,137]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function L(A){switch(A){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.$xp=L}),define(oe[139],ae([13,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,139]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let L=!1,A=!1,N=!1,D=!1,R=!1,k=!1,g=!1,C=!1,E=!1,b=!1,l,d=e.$g,p=e.$g,y,f;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?c=e.$h.vscode.process:typeof process<"u"&&(c=process);const h=typeof c?.versions?.electron=="string",m=h&&c?.type==="renderer";if(typeof navigator=="object"&&!m)f=navigator.userAgent,L=f.indexOf("Windows")>=0,A=f.indexOf("Macintosh")>=0,C=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,N=f.indexOf("Linux")>=0,b=f?.indexOf("Mobi")>=0,k=!0,l=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,d=l,p=navigator.language;else if(typeof c=="object"){L=c.platform==="win32",A=c.platform==="darwin",N=c.platform==="linux",D=N&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,g=h,E=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,d=e.$g;const v=c.env.VSCODE_NLS_CONFIG;if(v)try{const w=JSON.parse(v),u=w.availableLanguages["*"];l=w.locale,p=w.osLocale,d=u||e.$g,y=w._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var S;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(S||(e.Platform=S={}));function s(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=s;let a=0;A?a=1:L?a=3:N&&(a=2),e.$j=L,e.$k=A,e.$l=N,e.$m=D,e.$n=R,e.$o=g,e.$p=k,e.$q=k&&typeof e.$h.importScripts=="function",e.$r=C,e.$s=b,e.$t=E,e.$u=a,e.$v=f,e.$w=d;var n;(function(v){function w(){return e.$w}v.value=w;function u(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=u;function $(){return e.$w==="en"}v.isDefault=$})(n||(e.Language=n={})),e.$x=l,e.$y=p,e.$z=y,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const v=[];e.$h.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let $=0,j=v.length;$<j;$++){const M=v[$];if(M.id===u.data.vscodeScheduleAsyncWork){v.splice($,1),M.callback();return}}});let w=0;return u=>{const $=++w;v.push({id:$,callback:u}),e.$h.postMessage({vscodeScheduleAsyncWork:$},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=A||C?2:L?1:3;let t=!0,r=!1;function o(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,t=new Uint16Array(v.buffer)[0]===(2<<8)+1}return t}e.$D=o,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(oe[37],ae([0,1,5]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.process<"u"){const A=I.$h.vscode.process;L={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return I.$j?"win32":I.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(oe[16],ae([0,1,37]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,A=97,N=90,D=122,R=46,k=47,g=92,C=58,E=63;class b extends Error{constructor(a,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${t} of type ${n}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function l(s,a){if(s===null||typeof s!="object")throw new b(a,"Object",s)}function d(s,a){if(typeof s!="string")throw new b(a,"string",s)}const p=I.$dc==="win32";function y(s){return s===k||s===g}function f(s){return s===k}function c(s){return s>=L&&s<=N||s>=A&&s<=D}function h(s,a,n,i){let t="",r=0,o=-1,v=0,w=0;for(let u=0;u<=s.length;++u){if(u<s.length)w=s.charCodeAt(u);else{if(i(w))break;w=k}if(i(w)){if(!(o===u-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const $=t.lastIndexOf(n);$===-1?(t="",r=0):(t=t.slice(0,$),r=t.length-1-t.lastIndexOf(n)),o=u,v=0;continue}else if(t.length!==0){t="",r=0,o=u,v=0;continue}}a&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(o+1,u)}`:t=s.slice(o+1,u),r=u-o-1;o=u,v=0}else w===R&&v!==-1?++v:v=-1}return t}function m(s,a){l(a,"pathObject");const n=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return n?n===a.root?`${n}${i}`:`${n}${s}${i}`:i}e.$fc={resolve(...s){let a="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],d(r,"path"),r.length===0)continue}else a.length===0?r=I.cwd():(r=I.env[`=${a}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${a}\\`));const o=r.length;let v=0,w="",u=!1;const $=r.charCodeAt(0);if(o===1)y($)&&(v=1,u=!0);else if(y($))if(u=!0,y(r.charCodeAt(1))){let j=2,M=j;for(;j<o&&!y(r.charCodeAt(j));)j++;if(j<o&&j!==M){const U=r.slice(M,j);for(M=j;j<o&&y(r.charCodeAt(j));)j++;if(j<o&&j!==M){for(M=j;j<o&&!y(r.charCodeAt(j));)j++;(j===o||j!==M)&&(w=`\\\\${U}\\${r.slice(M,j)}`,v=j)}}}else v=1;else c($)&&r.charCodeAt(1)===C&&(w=r.slice(0,2),v=2,o>2&&y(r.charCodeAt(2))&&(u=!0,v=3));if(w.length>0)if(a.length>0){if(w.toLowerCase()!==a.toLowerCase())continue}else a=w;if(i){if(a.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=u,u&&a.length>0)break}return n=h(n,!i,"\\",y),i?`${a}\\${n}`:`${a}${n}`||"."},normalize(s){d(s,"path");const a=s.length;if(a===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(a===1)return f(r)?"\\":s;if(y(r))if(t=!0,y(s.charCodeAt(1))){let v=2,w=v;for(;v<a&&!y(s.charCodeAt(v));)v++;if(v<a&&v!==w){const u=s.slice(w,v);for(w=v;v<a&&y(s.charCodeAt(v));)v++;if(v<a&&v!==w){for(w=v;v<a&&!y(s.charCodeAt(v));)v++;if(v===a)return`\\\\${u}\\${s.slice(w)}\\`;v!==w&&(i=`\\\\${u}\\${s.slice(w,v)}`,n=v)}}}else n=1;else c(r)&&s.charCodeAt(1)===C&&(i=s.slice(0,2),n=2,a>2&&y(s.charCodeAt(2))&&(t=!0,n=3));let o=n<a?h(s.slice(n),!t,"\\",y):"";return o.length===0&&!t&&(o="."),o.length>0&&y(s.charCodeAt(a-1))&&(o+="\\"),i===void 0?t?`\\${o}`:o:t?`${i}\\${o}`:`${i}${o}`},isAbsolute(s){d(s,"path");const a=s.length;if(a===0)return!1;const n=s.charCodeAt(0);return y(n)||a>2&&c(n)&&s.charCodeAt(1)===C&&y(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,n;for(let r=0;r<s.length;++r){const o=s[r];d(o,"path"),o.length>0&&(a===void 0?a=n=o:a+=`\\${o}`)}if(a===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&y(n.charCodeAt(0))){++t;const r=n.length;r>1&&y(n.charCodeAt(1))&&(++t,r>2&&(y(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<a.length&&y(a.charCodeAt(t));)t++;t>=2&&(a=`\\${a.slice(t)}`)}return e.$fc.normalize(a)},relative(s,a){if(d(s,"from"),d(a,"to"),s===a)return"";const n=e.$fc.resolve(s),i=e.$fc.resolve(a);if(n===i||(s=n.toLowerCase(),a=i.toLowerCase(),s===a))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===g;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===g;)r--;const o=r-t;let v=0;for(;v<a.length&&a.charCodeAt(v)===g;)v++;let w=a.length;for(;w-1>v&&a.charCodeAt(w-1)===g;)w--;const u=w-v,$=o<u?o:u;let j=-1,M=0;for(;M<$;M++){const z=s.charCodeAt(t+M);if(z!==a.charCodeAt(v+M))break;z===g&&(j=M)}if(M!==$){if(j===-1)return i}else{if(u>$){if(a.charCodeAt(v+M)===g)return i.slice(v+M+1);if(M===2)return i.slice(v+M)}o>$&&(s.charCodeAt(t+M)===g?j=M:M===2&&(j=3)),j===-1&&(j=0)}let U="";for(M=t+j+1;M<=r;++M)(M===r||s.charCodeAt(M)===g)&&(U+=U.length===0?"..":"\\..");return v+=j,U.length>0?`${U}${i.slice(v,w)}`:(i.charCodeAt(v)===g&&++v,i.slice(v,w))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=e.$fc.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===g){if(a.charCodeAt(1)===g){const n=a.charCodeAt(2);if(n!==E&&n!==R)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(c(a.charCodeAt(0))&&a.charCodeAt(1)===C&&a.charCodeAt(2)===g)return`\\\\?\\${a}`;return s},dirname(s){d(s,"path");const a=s.length;if(a===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(a===1)return y(t)?s:".";if(y(t)){if(n=i=1,y(s.charCodeAt(1))){let v=2,w=v;for(;v<a&&!y(s.charCodeAt(v));)v++;if(v<a&&v!==w){for(w=v;v<a&&y(s.charCodeAt(v));)v++;if(v<a&&v!==w){for(w=v;v<a&&!y(s.charCodeAt(v));)v++;if(v===a)return s;v!==w&&(n=i=v+1)}}}}else c(t)&&s.charCodeAt(1)===C&&(n=a>2&&y(s.charCodeAt(2))?3:2,i=n);let r=-1,o=!0;for(let v=a-1;v>=i;--v)if(y(s.charCodeAt(v))){if(!o){r=v;break}}else o=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,a){a!==void 0&&d(a,"ext"),d(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&c(s.charCodeAt(0))&&s.charCodeAt(1)===C&&(n=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=n;--r){const w=s.charCodeAt(r);if(y(w)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(w===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(y(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){d(s,"path");let a=0,n=-1,i=0,t=-1,r=!0,o=0;s.length>=2&&s.charCodeAt(1)===C&&c(s.charCodeAt(0))&&(a=i=2);for(let v=s.length-1;v>=a;--v){const w=s.charCodeAt(v);if(y(w)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),w===R?n===-1?n=v:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||t===-1||o===0||o===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:m.bind(null,"\\"),parse(s){d(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return y(t)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(y(t)){if(i=1,y(s.charCodeAt(1))){let j=2,M=j;for(;j<n&&!y(s.charCodeAt(j));)j++;if(j<n&&j!==M){for(M=j;j<n&&y(s.charCodeAt(j));)j++;if(j<n&&j!==M){for(M=j;j<n&&!y(s.charCodeAt(j));)j++;j===n?i=j:j!==M&&(i=j+1)}}}}else if(c(t)&&s.charCodeAt(1)===C){if(n<=2)return a.root=a.dir=s,a;if(i=2,y(s.charCodeAt(2))){if(n===3)return a.root=a.dir=s,a;i=3}}i>0&&(a.root=s.slice(0,i));let r=-1,o=i,v=-1,w=!0,u=s.length-1,$=0;for(;u>=i;--u){if(t=s.charCodeAt(u),y(t)){if(!w){o=u+1;break}continue}v===-1&&(w=!1,v=u+1),t===R?r===-1?r=u:$!==1&&($=1):r!==-1&&($=-1)}return v!==-1&&(r===-1||$===0||$===1&&r===v-1&&r===o+1?a.base=a.name=s.slice(o,v):(a.name=s.slice(o,r),a.base=s.slice(o,v),a.ext=s.slice(r,v))),o>0&&o!==i?a.dir=s.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(p){const s=/\\/g;return()=>{const a=I.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>I.cwd()})();e.$gc={resolve(...s){let a="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:S();d(t,"path"),t.length!==0&&(a=`${t}/${a}`,n=t.charCodeAt(0)===k)}return a=h(a,!n,"/",f),n?`/${a}`:a.length>0?a:"."},normalize(s){if(d(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===k,n=s.charCodeAt(s.length-1)===k;return s=h(s,!a,"/",f),s.length===0?a?"/":n?"./":".":(n&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return d(s,"path"),s.length>0&&s.charCodeAt(0)===k},join(...s){if(s.length===0)return".";let a;for(let n=0;n<s.length;++n){const i=s[n];d(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.$gc.normalize(a)},relative(s,a){if(d(s,"from"),d(a,"to"),s===a||(s=e.$gc.resolve(s),a=e.$gc.resolve(a),s===a))return"";const n=1,i=s.length,t=i-n,r=1,o=a.length-r,v=t<o?t:o;let w=-1,u=0;for(;u<v;u++){const j=s.charCodeAt(n+u);if(j!==a.charCodeAt(r+u))break;j===k&&(w=u)}if(u===v)if(o>v){if(a.charCodeAt(r+u)===k)return a.slice(r+u+1);if(u===0)return a.slice(r+u)}else t>v&&(s.charCodeAt(n+u)===k?w=u:u===0&&(w=0));let $="";for(u=n+w+1;u<=i;++u)(u===i||s.charCodeAt(u)===k)&&($+=$.length===0?"..":"/..");return`${$}${a.slice(r+w)}`},toNamespacedPath(s){return s},dirname(s){if(d(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===k;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===k){if(!i){n=t;break}}else i=!1;return n===-1?a?"/":".":a&&n===1?"//":s.slice(0,n)},basename(s,a){a!==void 0&&d(a,"ext"),d(s,"path");let n=0,i=-1,t=!0,r;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=0;--r){const w=s.charCodeAt(r);if(w===k){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(w===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===k){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){d(s,"path");let a=-1,n=0,i=-1,t=!0,r=0;for(let o=s.length-1;o>=0;--o){const v=s.charCodeAt(o);if(v===k){if(!t){n=o+1;break}continue}i===-1&&(t=!1,i=o+1),v===R?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||i===-1||r===0||r===1&&a===i-1&&a===n+1?"":s.slice(a,i)},format:m.bind(null,"/"),parse(s){d(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.charCodeAt(0)===k;let i;n?(a.root="/",i=1):i=0;let t=-1,r=0,o=-1,v=!0,w=s.length-1,u=0;for(;w>=i;--w){const $=s.charCodeAt(w);if($===k){if(!v){r=w+1;break}continue}o===-1&&(v=!1,o=w+1),$===R?t===-1?t=w:u!==1&&(u=1):t!==-1&&(u=-1)}if(o!==-1){const $=r===0&&n?1:r;t===-1||u===0||u===1&&t===o-1&&t===r+1?a.base=a.name=s.slice($,o):(a.name=s.slice($,t),a.base=s.slice($,o),a.ext=s.slice(t,o))}return r>0?a.dir=s.slice(0,r-1):n&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(oe[48],ae([0,1,16,5,27,12]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function D(r){return r===47||r===92}e.$Qf=D;function R(r){return r.replace(/[\\/]/g,I.$gc.sep)}e.$Rf=R;function k(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Sf=k;function g(r,o=I.$gc.sep){if(!r)return"";const v=r.length,w=r.charCodeAt(0);if(D(w)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let $=3;const j=$;for(;$<v&&!D(r.charCodeAt($));$++);if(j!==$&&!D(r.charCodeAt($+1))){for($+=1;$<v;$++)if(D(r.charCodeAt($)))return r.slice(0,$+1).replace(/[\\/]/g,o)}}return o}else if(f(w)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<v;u++)if(D(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$Tf=g;function C(r){if(!L.$j||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let v=2;const w=v;for(;v<r.length&&(o=r.charCodeAt(v),o!==92);v++);return!(w===v||(o=r.charCodeAt(v+1),isNaN(o)||o===92))}e.$Uf=C;const E=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,o=L.$j){const v=o?E:b;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||o&&l.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.$Vf=d;function p(r,o,v){const w=r===o;return!v||w?w:!r||!o?!1:(0,A.$2e)(r,o)}e.$Wf=p;function y(r,o,v,w=I.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(v){if(!(0,A.$3e)(r,o))return!1;if(o.length===r.length)return!0;let $=o.length;return o.charAt(o.length-1)===w&&$--,r.charAt($)===w}return o.charAt(o.length-1)!==w&&(o+=w),r.indexOf(o)===0}e.$Xf=y;function f(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Yf=f;function c(r,o){return L.$j&&r.endsWith(":")&&(r+=I.sep),(0,I.$ic)(r)||(r=(0,I.$jc)(o,r)),r=(0,I.$hc)(r),L.$j?(r=(0,A.$Ke)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,A.$Ke)(r,I.sep),r||(r=I.sep)),r}e.$Zf=c;function h(r){const o=(0,I.$hc)(r);return L.$j?r.length>3?!1:m(o)&&(r.length===2||o.charCodeAt(2)===92):o===I.$gc.sep}e.$1f=h;function m(r,o=L.$j){return o?f(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$2f=m;function S(r,o=L.$j){return m(r,o)?r[0]:void 0}e.$3f=S;function s(r,o,v){return o.length>r.length?-1:r===o?0:(v&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.$4f=s;function a(r){const o=r.split(":");let v,w,u;for(const $ of o){const j=Number($);(0,N.$Cf)(j)?w===void 0?w=j:u===void 0&&(u=j):v=v?[v,$].join(":"):$}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:w!==void 0?w:void 0,column:u!==void 0?u:w!==void 0?1:void 0}}e.$5f=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,o,v=8){let w="";for(let $=0;$<v;$++){let j;$===0&&L.$j&&!o&&(v===3||v===4)?j=i:j=n,w+=j.charAt(Math.floor(Math.random()*j.length))}let u;return o?u=`${o}-${w}`:u=w,r?(0,I.$jc)(r,u):u}e.$6f=t}),define(oe[140],ae([0,1,16]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=e.$Rr=e.$Qr=void 0,e.$Qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(C){const E=(0,I.$oc)(C),b=L[E.toLowerCase()];return b!==void 0?b:D(C)}e.$Rr=N;function D(C){const E=(0,I.$oc)(C);return A[E.toLowerCase()]}e.$Sr=D;function R(C){for(const E in A)if(A[E]===C)return E}e.$Tr=R;const k=/^(.+)\/(.+?)(;.+)?$/;function g(C,E){const b=k.exec(C);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:E?void 0:C}e.$Ur=g}),define(oe[90],ae([0,1,5]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var L;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(L||(e.Source=L={}));var A;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function N(R,...k){const g=k.reduce((b,l)=>(b[l]=!0,b),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(b=>!g[b]).forEach(b=>{for(let l=0;l<C.length;l++)if(b.search(C[l])!==-1){delete R[b];break}})}e.$zl=N;function D(R){R&&(delete R.DEBUG,I.$k&&delete R.DYLD_LIBRARY_PATH,I.$l&&delete R.LD_PRELOAD)}e.$Al=D}),define(oe[10],ae([0,1,16,5]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,N=/^\//,D=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!A.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!N.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(i,t){return!i&&!t?"file":i}function g(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const C="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(t){return t instanceof l?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,o,v,w,u=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=k(t,u),this.authority=r||C,this.path=g(this.scheme,o||C),this.query=v||C,this.fragment=w||C,R(this,u))}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:o,path:v,query:w,fragment:u}=t;return r===void 0?r=this.scheme:r===null&&(r=C),o===void 0?o=this.authority:o===null&&(o=C),v===void 0?v=this.path:v===null&&(v=C),w===void 0?w=this.query:w===null&&(w=C),u===void 0?u=this.fragment:u===null&&(u=C),r===this.scheme&&o===this.authority&&v===this.path&&w===this.query&&u===this.fragment?this:new y(r,o,v,w,u)}static parse(t,r=!1){const o=b.exec(t);return o?new y(o[2]||C,n(o[4]||C),n(o[5]||C),n(o[7]||C),n(o[9]||C),r):new y(C,C,C,C,C)}static file(t){let r=C;if(L.$j&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(r=t.substring(2),t=E):(r=t.substring(2,o),t=t.substring(o)||E)}return new y("file",r,t,C,C)}static from(t,r){return new y(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return L.$j&&t.scheme==="file"?o=l.file(I.$fc.join(m(t,!0),...r)).path:o=I.$gc.join(t.path,...r),t.with({path:o})}toString(t=!1){return S(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof l)return t;{const r=new y(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=l;function d(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=d;const p=L.$j?1:void 0;class y extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(i,t,r){let o,v=-1;for(let w=0;w<i.length;w++){const u=i.charCodeAt(w);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47||r&&u===91||r&&u===93||r&&u===58)v!==-1&&(o+=encodeURIComponent(i.substring(v,w)),v=-1),o!==void 0&&(o+=i.charAt(w));else{o===void 0&&(o=i.substr(0,w));const $=f[u];$!==void 0?(v!==-1&&(o+=encodeURIComponent(i.substring(v,w)),v=-1),o+=$):v===-1&&(v=w)}}return v!==-1&&(o+=encodeURIComponent(i.substring(v))),o!==void 0?o:i}function h(i){let t;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(t===void 0&&(t=i.substr(0,r)),t+=f[o]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function m(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,L.$j&&(r=r.replace(/\//g,"\\")),r}e.$wc=m;function S(i,t){const r=t?h:c;let o="",{scheme:v,authority:w,path:u,query:$,fragment:j}=i;if(v&&(o+=v,o+=":"),(w||v==="file")&&(o+=E,o+=E),w){let M=w.indexOf("@");if(M!==-1){const U=w.substr(0,M);w=w.substr(M+1),M=U.lastIndexOf(":"),M===-1?o+=r(U,!1,!1):(o+=r(U.substr(0,M),!1,!1),o+=":",o+=r(U.substr(M+1),!1,!0)),o+="@"}w=w.toLowerCase(),M=w.lastIndexOf(":"),M===-1?o+=r(w,!1,!0):(o+=r(w.substr(0,M),!1,!0),o+=w.substr(M))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const M=u.charCodeAt(1);M>=65&&M<=90&&(u=`/${String.fromCharCode(M+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const M=u.charCodeAt(0);M>=65&&M<=90&&(u=`${String.fromCharCode(M+32)}:${u.substr(2)}`)}o+=r(u,!0,!1)}return $&&(o+="?",o+=r($,!1,!1)),j&&(o+="#",o+=t?j:c(j,!1,!1)),o}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(a)?i.replace(a,t=>s(t)):i}}),define(oe[141],ae([0,1,10]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$1p=e.$Zp=e.$Yp=void 0;function L(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$Yp=L;function A(g){const C=[];let E;try{const b=JSON.parse(g.arguments),l=b[b.length-1];l&&l.__$stack&&(b.pop(),E=l.__$stack),C.push(...b)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:E}}e.$Zp=A;function N(g){if(typeof g!="string")return N(A(g).stack);const C=g;if(C){const E=D(C),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:I.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$1p=N;function D(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:E,stack:b}=A(g),l=typeof E[0]=="string"&&E.length===1;let d=D(b);d&&(d=`(${d.trim()})`);let p=[];if(typeof E[0]=="string"?d&&l?p=[`%c[${C}] %c${E[0]} %c${d}`,k("blue"),k(""),k("grey")]:p=[`%c[${C}] %c${E[0]}`,k("blue"),k(""),...E.slice(1)]:p=[`%c[${C}]%`,k("blue"),...E],d&&!l&&p.push(d),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,p)}e.log=R;function k(g){return`color: ${g}`}}),define(oe[64],ae([0,1,15,10]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function A(k){return JSON.stringify(k,D)}e.$kh=A;function N(k){let g=JSON.parse(k);return g=R(g),g}e.$lh=N;function D(k,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(k,g=0){if(!k||g>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return L.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof I.$be||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=R(k[C],g+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=R(k[C],g+1))}return k}e.$mh=R}),define(oe[23],ae([0,1,8,5,10]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var N;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(N||(e.Schemas=N={})),e.$7f="vscode-tkn",e.$8f="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${N.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${N.vscodeRemoteResource}`}set(C,E,b){this.a[C]=E,this.b[C]=b}setConnectionToken(C,E){this.c[C]=E}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(y){return I.$1(y),C}const E=C.authority;let b=this.a[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const l=this.b[E],d=this.c[E];let p=`path=${encodeURIComponent(C.path)}`;return typeof d=="string"&&(p+=`&${e.$8f}=${encodeURIComponent(d)}`),A.URI.from({scheme:L.$p?this.d:N.vscodeRemoteResource,authority:`${b}:${l}`,path:this.f,query:p})}}e.$9f=new D,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class R{static{this.a=e.$bg}asBrowserUri(C){const E=this.b(C,te);return this.uriToBrowserUri(E)}uriToBrowserUri(C){return C.scheme===N.vscodeRemote?e.$9f.rewrite(C):C.scheme===N.file&&(L.$n||L.$q&&L.$h.origin===`${N.vscodeFileResource}://${R.a}`)?C.with({scheme:N.vscodeFileResource,authority:C.authority||R.a,query:null,fragment:null}):C}asFileUri(C){const E=this.b(C,te);return this.uriToFileUri(E)}uriToFileUri(C){return C.scheme===N.vscodeFileResource?C.with({scheme:N.file,authority:C.authority!==R.a?C.authority:null,query:null,fragment:null}):C}b(C,E){return A.URI.isUri(C)?C:A.URI.parse(E.toUrl(C))}}e.$cg=new R;var k;(function(g){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(C.get("3"));const E="vscode-coi";function b(d){let p;typeof d=="string"?p=new URL(d).searchParams:d instanceof URL?p=d.searchParams:A.URI.isUri(d)&&(p=new URL(d.toString(!0)).searchParams);const y=p?.get(E);if(y)return C.get(y)}g.getHeadersFromQuery=b;function l(d,p,y){if(!globalThis.crossOriginIsolated)return;const f=p&&y?"3":y?"2":"1";d instanceof URLSearchParams?d.set(E,f):d[E]=f}g.addSearchParam=l})(k||(e.COI=k={}))}),define(oe[142],ae([0,1,124,23,5,10]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=void 0;class D{constructor(b,l,d){this.id=b,this.dependencies=l,this.callback=d}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,l,d)=>{typeof b!="string"&&(d=l,l=b,b=null),(typeof l!="object"||!Array.isArray(l))&&(d=l,l=null),this.c.push(new D(b,l,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const l=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!l)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(b){return new Promise((l,d)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const y=()=>{p.removeEventListener("load",f),p.removeEventListener("error",c)},f=h=>{y(),l(this.c.pop())},c=h=>{y(),d(h)};p.addEventListener("load",f),p.addEventListener("error",c),this.f&&(b=this.f.createScriptURL(b)),p.setAttribute("src",b),document.getElementsByTagName("head")[0].appendChild(p)})}i(b){return new Promise((l,d)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),l(this.c.pop())}catch(p){d(p)}})}async j(b){try{const l=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,y=N.URI.parse(b).fsPath,f=l.readFileSync(y).toString(),c=p.wrap(f.replace(/^#!.*/,""));return new d.Script(c).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const k=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(E,b,l){if(I.$T){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[E]&&(E=g[E]);const d=`${E}/${b}`;if(k.has(d))return k.get(d);let p;if(/^\w[\w\d+.-]*:\/\//.test(d))p=d;else{const h=`${l&&!A.$p?L.$_f:L.$$f}/${d}`;p=L.$cg.asBrowserUri(h).toString(!0)}const y=R.INSTANCE.load(p);return k.set(d,y),y}else return await new Promise((d,p)=>{te([E],d,p)})}e.$mC=C}),define(oe[19],ae([0,1,48,23,16,5,27,10]),function(te,e,I,L,A,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function k(l){return(0,R.$wc)(l,!0)}e.$jg=k;class g{constructor(d){this.a=d}compare(d,p,y=!1){return d===p?0:(0,D.$Ue)(this.getComparisonKey(d,y),this.getComparisonKey(p,y))}isEqual(d,p,y=!1){return d===p?!0:!d||!p?!1:this.getComparisonKey(d,y)===this.getComparisonKey(p,y)}getComparisonKey(d,p=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,p,y=!1){if(d.scheme===p.scheme){if(d.scheme===L.Schemas.file)return I.$Xf(k(d),k(p),this.a(d))&&d.query===p.query&&(y||d.fragment===p.fragment);if((0,e.$Ag)(d.authority,p.authority))return I.$Xf(d.path,p.path,this.a(d),"/")&&d.query===p.query&&(y||d.fragment===p.fragment)}return!1}joinPath(d,...p){return R.URI.joinPath(d,...p)}basenameOrAuthority(d){return(0,e.$sg)(d)||d.authority}basename(d){return A.$gc.basename(d.path)}extname(d){return A.$gc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let p;return d.scheme===L.Schemas.file?p=R.URI.file(A.$mc(k(d))).path:(p=A.$gc.dirname(d.path),d.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),p="/")),d.with({path:p})}normalizePath(d){if(!d.path.length)return d;let p;return d.scheme===L.Schemas.file?p=R.URI.file(A.$hc(k(d))).path:p=A.$gc.normalize(d.path),d.with({path:p})}relativePath(d,p){if(d.scheme!==p.scheme||!(0,e.$Ag)(d.authority,p.authority))return;if(d.scheme===L.Schemas.file){const c=A.$lc(k(d),k(p));return N.$j?I.$Rf(c):c}let y=d.path||"/";const f=p.path||"/";if(this.a(d)){let c=0;for(const h=Math.min(y.length,f.length);c<h&&!(y.charCodeAt(c)!==f.charCodeAt(c)&&y.charAt(c).toLowerCase()!==f.charAt(c).toLowerCase());c++);y=f.substr(0,c)+y.substr(c)}return A.$gc.relative(y,f)}resolvePath(d,p){if(d.scheme===L.Schemas.file){const y=R.URI.file(A.$kc(k(d),p));return d.with({authority:y.authority,path:y.path})}return p=I.$Sf(p),d.with({path:A.$gc.resolve(d.path,p)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,p){return d===p||d!==void 0&&p!==void 0&&(0,D.$2e)(d,p)}hasTrailingPathSeparator(d,p=A.sep){if(d.scheme===L.Schemas.file){const y=k(d);return y.length>I.$Tf(y).length&&y[y.length-1]===p}else{const y=d.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,p=A.sep){return(0,e.$Bg)(d,p)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,p=A.sep){let y=!1;if(d.scheme===L.Schemas.file){const f=k(d);y=f!==void 0&&f.length===I.$Tf(f).length&&f[f.length-1]===p}else{p="/";const f=d.path;y=f.length===1&&f.charCodeAt(f.length-1)===47}return!y&&!(0,e.$Bg)(d,p)?d.with({path:d.path+"/"}):d}}e.$kg=g,e.$lg=new g(()=>!1),e.$mg=new g(l=>l.scheme===L.Schemas.file?!N.$l:!0),e.$ng=new g(l=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function C(l,d){const p=[];for(let y=0;y<l.length;y++){const f=d(l[y]);l.some((c,h)=>h===y?!1:(0,e.$pg)(f,d(c)))||p.push(l[y])}return p}e.$Eg=C;var E;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function d(p){const y=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(h=>{const[m,S]=h.split(":");m&&S&&y.set(m,S)});const c=p.path.substring(0,p.path.indexOf(";"));return c&&y.set(l.META_DATA_MIME,c),y}l.parseMetaData=d})(E||(e.DataUri=E={}));function b(l,d,p){if(d){let y=l.path;return y&&y[0]!==A.$gc.sep&&(y=A.$gc.sep+y),l.with({scheme:p,authority:d,path:y})}return l.with({scheme:p})}e.$Fg=b}),define(oe[6],ae([0,1,26,8,3,2,19,5,130]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function g(O){return!!O&&typeof O.then=="function"}e.$Gg=g;function C(O){const T=new I.$Xd,F=O(T.token),V=new Promise((G,re)=>{const ce=T.token.onCancellationRequested(()=>{ce.dispose(),T.dispose(),re(new L.$5)});Promise.resolve(F).then(ue=>{ce.dispose(),T.dispose(),G(ue)},ue=>{ce.dispose(),T.dispose(),re(ue)})});return new class{cancel(){T.cancel()}then(G,re){return V.then(G,re)}catch(G){return this.then(void 0,G)}finally(G){return V.finally(G)}}}e.$Hg=C;function E(O,T,F){return new Promise((V,G)=>{const re=T.onCancellationRequested(()=>{re.dispose(),V(F)});O.then(V,G).finally(()=>re.dispose())})}e.$Ig=E;function b(O,T){return new Promise((F,V)=>{const G=T.onCancellationRequested(()=>{G.dispose(),V(new L.$5)});O.then(F,V).finally(()=>G.dispose())})}e.$Jg=b;async function l(O){let T=-1;const F=O.map((V,G)=>V.then(re=>(T=G,re)));try{return await Promise.race(F)}finally{O.forEach((V,G)=>{G!==T&&V.cancel()})}}e.$Kg=l;function d(O,T,F){let V;const G=setTimeout(()=>{V?.(void 0),F?.()},T);return Promise.race([O.finally(()=>clearTimeout(G)),new Promise(re=>V=re)])}e.$Lg=d;function p(O){return new Promise((T,F)=>{const V=O();g(V)?V.then(T,F):T(V)})}e.$Mg=p;class y{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=T,!this.b){const F=()=>{if(this.b=null,this.f)return;const V=this.queue(this.d);return this.d=null,V};this.b=new Promise(V=>{this.a.then(F,F).then(V)})}return new Promise((F,V)=>{this.b.then(F,V)})}return this.a=T(),new Promise((F,V)=>{this.a.then(G=>{this.a=null,F(G)},G=>{this.a=null,V(G)})})}dispose(){this.f=!0}}e.$Ng=y;class f{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$Og=f;class c{constructor(){this.a=new Map}queue(T,F){const G=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(T)===G&&this.a.delete(T)});return this.a.set(T,G),G}}e.$Pg=c;const h=(O,T)=>{let F=!0;const V=setTimeout(()=>{F=!1,T()},O);return{isTriggered:()=>F,dispose:()=>{clearTimeout(V),F=!1}}},m=O=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,O())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class S{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,F=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((G,re)=>{this.d=G,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const G=this.g;return this.g=null,G()}}));const V=()=>{this.a=null,this.d?.(null)};return this.a=F===k.$Kd?m(V):h(F,V),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=S;class s{constructor(T){this.a=new S(T),this.b=new y}trigger(T,F){return this.a.trigger(()=>this.b.queue(T),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=s;class a{constructor(){this.a=!1,this.b=new Promise((T,F)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=a;class n extends a{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$Tg=n;function i(O,T){return T?new Promise((F,V)=>{const G=setTimeout(()=>{re.dispose(),F()},O),re=T.onCancellationRequested(()=>{clearTimeout(G),re.dispose(),V(new L.$5)})}):C(F=>i(O,F))}e.$Ug=i;function t(O,T=0,F){const V=setTimeout(()=>{O(),F&&G.dispose()},T),G=(0,N.$Qc)(()=>{clearTimeout(V),F?.deleteAndLeak(G)});return F?.add(G),G}e.$Vg=t;function r(O){const T=[];let F=0;const V=O.length;function G(){return F<V?O[F++]():null}function re(ce){ce!=null&&T.push(ce);const ue=G();return ue?ue.then(re):Promise.resolve(T)}return Promise.resolve(null).then(re)}e.$Wg=r;function o(O,T=V=>!!V,F=null){let V=0;const G=O.length,re=()=>{if(V>=G)return Promise.resolve(F);const ce=O[V++];return Promise.resolve(ce()).then(he=>T(he)?Promise.resolve(he):re())};return re()}e.$Xg=o;function v(O,T=V=>!!V,F=null){if(O.length===0)return Promise.resolve(F);let V=O.length;const G=()=>{V=-1;for(const re of O)re.cancel?.()};return new Promise((re,ce)=>{for(const ue of O)ue.then(he=>{--V>=0&&T(he)?(G(),re(he)):V===0&&re(F)}).catch(he=>{--V>=0&&(G(),ce(he))})})}e.$Yg=v;class w{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new A.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((F,V)=>{this.f.push({factory:T,c:F,e:V}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const F=T.factory();F.then(T.c,T.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=w;class u extends w{constructor(){super(1)}}e.$1g=u;class ${constructor(){this.a=new Q,this.b=0}queue(T){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,T())):this.a.run(this.b++,T())}}e.$2g=$;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const T=new ee;return this.b.add(T),T.p}g(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,F=D.$lg){const V=F.getComparisonKey(T);let G=this.a.get(V);if(!G){G=new u;const re=this.f++,ce=A.Event.once(G.onDrained)(()=>{G?.dispose(),this.a.delete(V),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$1c),this.d.set(re,ce),this.a.set(V,G)}return G}h(){this.g()&&this.j()}j(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=j;class M{constructor(T,F){this.a=-1,typeof T=="function"&&typeof F=="number"&&this.setIfNotSet(T,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},F)}setIfNotSet(T,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},F))}}e.$4g=M;class U{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,F){this.cancel(),this.a=setInterval(()=>{T()},F)}}e.$5g=U;class z{constructor(T,F){this.b=-1,this.a=T,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=z;class q{constructor(T,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=T,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=q;class Z extends z{constructor(T,F){super(T,F),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$8g=Z;class X extends N.$Sc{constructor(T,F){super(),this.g=T,this.h=F,this.a=[],this.b=this.B(new N.$Tc),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of T)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=X,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=O=>{(0,R.$B)(()=>{if(T)return;const F=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.$0g=(O,T)=>{const F=requestIdleCallback(O,typeof T=="number"?{timeout:T}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(F))}}}}();class x{constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=x;async function H(O,T,F){let V;for(let G=0;G<F;G++)try{return await O()}catch(re){V=re,await i(T)}throw V}e.$_g=H;class Q{isRunning(T){return typeof T=="number"?this.a?.taskId===T:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(T,F,V){return this.a={taskId:T,cancel:()=>V?.(),promise:F},F.then(()=>this.d(T),()=>this.d(T)),F}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this.b)this.b.run=T;else{let F,V;const G=new Promise((re,ce)=>{F=re,V=ce});this.b={run:T,promise:G,promiseResolve:F,promiseReject:V}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=Q;class J{constructor(T,F=()=>Date.now()){this.d=T,this.f=F,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$bh=J;var W;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(W||(W={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,F)=>{this.a=T,this.b=F})}complete(T){return new Promise(F=>{this.a(T),this.d={outcome:0,value:T},F()})}error(T){return new Promise(F=>{this.b(T),this.d={outcome:1,value:T},F()})}cancel(){return this.error(new L.$5)}}e.$ch=ee;var ne;(function(O){async function T(V){let G;const re=await Promise.all(V.map(ce=>ce.then(ue=>ue,ue=>{G||(G=ue)})));if(typeof G<"u")throw G;return re}O.settled=T;function F(V){return new Promise(async(G,re)=>{try{await V(G,re)}catch(ce){re(ce)}})}O.withAsyncBody=F})(ne||(e.Promises=ne={}));var _;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(_||(_={}));class ie{static fromArray(T){return new ie(F=>{F.emitMany(T)})}static fromPromise(T){return new ie(async F=>{F.emitMany(await T)})}static fromPromises(T){return new ie(async F=>{await Promise.all(T.map(async V=>F.emitOne(await V)))})}static merge(T){return new ie(async F=>{await Promise.all(T.map(async V=>{for await(const G of V)F.emitOne(G)}))})}static{this.EMPTY=ie.fromArray([])}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new A.$Nd,queueMicrotask(async()=>{const F={emitOne:V=>this.g(V),emitMany:V=>this.h(V),reject:V=>this.k(V)};try{await Promise.resolve(T(F)),this.j()}catch(V){this.k(V)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(T,F){return new ie(async V=>{for await(const G of T)V.emitOne(F(G))})}map(T){return ie.map(this,T)}static filter(T,F){return new ie(async V=>{for await(const G of T)F(G)&&V.emitOne(G)})}filter(T){return ie.filter(this,T)}static coalesce(T){return ie.filter(T,F=>!!F)}coalesce(){return ie.coalesce(this)}static async toPromise(T){const F=[];for await(const V of T)F.push(V);return F}toPromise(){return ie.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.$dh=ie;class K extends ie{constructor(T,F){super(F),this.l=T}cancel(){this.l.cancel()}}e.$eh=K;function B(O){const T=new I.$Xd,F=O(T.token);return new K(T,async V=>{const G=T.token.onCancellationRequested(()=>{G.dispose(),T.dispose(),V.reject(new L.$5)});try{for await(const re of F){if(T.token.isCancellationRequested)return;V.emitOne(re)}G.dispose(),T.dispose()}catch(re){G.dispose(),T.dispose(),V.reject(re)}})}e.$fh=B;class P{constructor(){this.a=new ee,this.b=new ie(V=>{if(T){V.reject(T);return}return F&&V.emitMany(F),this.d=G=>V.reject(G),this.f=G=>V.emitOne(G),this.a.p});let T,F;this.f=V=>{F||(F=[]),F.push(V)},this.d=V=>{T||(T=V)}}get asyncIterable(){return this.b}complete(){this.a.complete()}error(T){this.d(T),this.a.complete()}emit(T){this.f(T)}}e.$gh=P}),define(oe[91],ae([0,1,18,6,48,34,16,5,27]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function g(){return Object.create(null)}e.$rj=g,e.$sj="**",e.$tj="/";const C="[/\\\\]",E="[^/\\\\]",b=/\//g;function l(Q,J){switch(Q){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${J?`|${C}${E}+`:""})*?`}}function d(Q,J){if(!Q)return[];const W=[];let ee=!1,ne=!1,_="";for(const ie of Q){switch(ie){case J:if(!ee&&!ne){W.push(_),_="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}_+=ie}return _&&W.push(_),W}e.$uj=d;function p(Q){if(!Q)return"";let J="";const W=d(Q,e.$tj);if(W.every(ee=>ee===e.$sj))J=".*";else{let ee=!1;W.forEach((ne,_)=>{if(ne===e.$sj){if(ee)return;J+=l(2,_===W.length-1)}else{let ie=!1,K="",B=!1,P="";for(const O of ne){if(O!=="}"&&ie){K+=O;continue}if(B&&(O!=="]"||!P)){let T;O==="-"?T=O:(O==="^"||O==="!")&&!P?T="^":O===e.$tj?T="":T=(0,k.$Fe)(O),P+=T;continue}switch(O){case"{":ie=!0;continue;case"[":B=!0;continue;case"}":{const F=`(?:${d(K,",").map(V=>p(V)).join("|")})`;J+=F,ie=!1,K="";break}case"]":{J+="["+P+"]",B=!1,P="";break}case"?":J+=E;continue;case"*":J+=l(1);continue;default:J+=(0,k.$Fe)(O)}}_<W.length-1&&(W[_+1]!==e.$sj||_+2<W.length)&&(J+=C)}ee=ne===e.$sj})}return J}const y=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new N.$Dc(1e4),a=function(){return!1},n=function(){return null};function i(Q,J){if(!Q)return n;let W;typeof Q!="string"?W=Q.pattern:W=Q,W=W.trim();const ee=`${W}_${!!J.trimForExclusions}`;let ne=s.get(ee);if(ne)return t(ne,Q);let _;return y.test(W)?ne=o(W.substr(4),W):(_=f.exec(r(W,J)))?ne=v(_[1],W):(J.trimForExclusions?h:c).test(W)?ne=w(W,J):(_=m.exec(r(W,J)))?ne=u(_[1].substr(1),W,!0):(_=S.exec(r(W,J)))?ne=u(_[1],W,!1):ne=$(W),s.set(ee,ne),t(ne,Q)}function t(Q,J){if(typeof J=="string")return Q;const W=function(ee,ne){return(0,A.$Xf)(ee,J.base,!R.$l)?Q((0,k.$Je)(ee.substr(J.base.length),D.sep),ne):null};return W.allBasenames=Q.allBasenames,W.allPaths=Q.allPaths,W.basenames=Q.basenames,W.patterns=Q.patterns,W}function r(Q,J){return J.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function o(Q,J){return function(W,ee){return typeof W=="string"&&W.endsWith(Q)?J:null}}function v(Q,J){const W=`/${Q}`,ee=`\\${Q}`,ne=function(ie,K){return typeof ie!="string"?null:K?K===Q?J:null:ie===Q||ie.endsWith(W)||ie.endsWith(ee)?J:null},_=[Q];return ne.basenames=_,ne.patterns=[J],ne.allBasenames=_,ne}function w(Q,J){const W=x(Q.slice(1,-1).split(",").map(K=>i(K,J)).filter(K=>K!==n),Q),ee=W.length;if(!ee)return n;if(ee===1)return W[0];const ne=function(K,B){for(let P=0,O=W.length;P<O;P++)if(W[P](K,B))return Q;return null},_=W.find(K=>!!K.allBasenames);_&&(ne.allBasenames=_.allBasenames);const ie=W.reduce((K,B)=>B.allPaths?K.concat(B.allPaths):K,[]);return ie.length&&(ne.allPaths=ie),ne}function u(Q,J,W){const ee=D.sep===D.$gc.sep,ne=ee?Q:Q.replace(b,D.sep),_=D.sep+ne,ie=D.$gc.sep+Q;let K;return W?K=function(B,P){return typeof B=="string"&&(B===ne||B.endsWith(_)||!ee&&(B===Q||B.endsWith(ie)))?J:null}:K=function(B,P){return typeof B=="string"&&(B===ne||!ee&&B===Q)?J:null},K.allPaths=[(W?"*/":"./")+Q],K}function $(Q){try{const J=new RegExp(`^${p(Q)}$`);return function(W){return J.lastIndex=0,typeof W=="string"&&J.test(W)?Q:null}}catch{return n}}function j(Q,J,W){return!Q||typeof J!="string"?!1:M(Q)(J,void 0,W)}e.$vj=j;function M(Q,J={}){if(!Q)return a;if(typeof Q=="string"||U(Q)){const W=i(Q,J);if(W===n)return a;const ee=function(ne,_){return!!W(ne,_)};return W.allBasenames&&(ee.allBasenames=W.allBasenames),W.allPaths&&(ee.allPaths=W.allPaths),ee}return Z(Q,J)}e.$wj=M;function U(Q){const J=Q;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$xj=U;function z(Q){return Q.allBasenames||[]}e.$yj=z;function q(Q){return Q.allPaths||[]}e.$zj=q;function Z(Q,J){const W=x(Object.getOwnPropertyNames(Q).map(K=>X(K,Q[K],J)).filter(K=>K!==n)),ee=W.length;if(!ee)return n;if(!W.some(K=>!!K.requiresSiblings)){if(ee===1)return W[0];const K=function(O,T){let F;for(let V=0,G=W.length;V<G;V++){const re=W[V](O,T);if(typeof re=="string")return re;(0,L.$Gg)(re)&&(F||(F=[]),F.push(re))}return F?(async()=>{for(const V of F){const G=await V;if(typeof G=="string")return G}return null})():null},B=W.find(O=>!!O.allBasenames);B&&(K.allBasenames=B.allBasenames);const P=W.reduce((O,T)=>T.allPaths?O.concat(T.allPaths):O,[]);return P.length&&(K.allPaths=P),K}const ne=function(K,B,P){let O,T;for(let F=0,V=W.length;F<V;F++){const G=W[F];G.requiresSiblings&&P&&(B||(B=(0,D.$nc)(K)),O||(O=B.substr(0,B.length-(0,D.$oc)(K).length)));const re=G(K,B,O,P);if(typeof re=="string")return re;(0,L.$Gg)(re)&&(T||(T=[]),T.push(re))}return T?(async()=>{for(const F of T){const V=await F;if(typeof V=="string")return V}return null})():null},_=W.find(K=>!!K.allBasenames);_&&(ne.allBasenames=_.allBasenames);const ie=W.reduce((K,B)=>B.allPaths?K.concat(B.allPaths):K,[]);return ie.length&&(ne.allPaths=ie),ne}function X(Q,J,W){if(J===!1)return n;const ee=i(Q,W);if(ee===n)return n;if(typeof J=="boolean")return ee;if(J){const ne=J.when;if(typeof ne=="string"){const _=(ie,K,B,P)=>{if(!P||!ee(ie,K))return null;const O=ne.replace("$(basename)",()=>B),T=P(O);return(0,L.$Gg)(T)?T.then(F=>F?Q:null):T?Q:null};return _.requiresSiblings=!0,_}}return ee}function x(Q,J){const W=Q.filter(K=>!!K.basenames);if(W.length<2)return Q;const ee=W.reduce((K,B)=>{const P=B.basenames;return P?K.concat(P):K},[]);let ne;if(J){ne=[];for(let K=0,B=ee.length;K<B;K++)ne.push(J)}else ne=W.reduce((K,B)=>{const P=B.patterns;return P?K.concat(P):K},[]);const _=function(K,B){if(typeof K!="string")return null;if(!B){let O;for(O=K.length;O>0;O--){const T=K.charCodeAt(O-1);if(T===47||T===92)break}B=K.substr(O)}const P=ee.indexOf(B);return P!==-1?ne[P]:null};_.basenames=ee,_.patterns=ne,_.allBasenames=ee;const ie=Q.filter(K=>!K.basenames);return ie.push(_),ie}function H(Q,J){return(0,I.$ub)(Q,J,(W,ee)=>typeof W=="string"&&typeof ee=="string"?W===ee:typeof W!="string"&&typeof ee!="string"?W.base===ee.base&&W.pattern===ee.pattern:!1)}e.$Aj=H}),define(oe[92],ae([0,1,15,10]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function A(E){return E.toJSON()}class N{constructor(b){this.a=b}transformIncoming(b){const l=this.a.transformIncoming(b);return l===b?b:A(L.URI.from(l))}transformOutgoing(b){const l=this.a.transformOutgoing(b);return l===b?b:A(L.URI.from(l))}transformOutgoingURI(b){const l=this.a.transformOutgoing(b);return l===b?b:L.URI.from(l)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Lm=N,e.$Mm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function D(E,b,l){if(!E||l>200)return null;if(typeof E=="object"){if(E instanceof L.URI)return b.transformOutgoing(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const p=D(E[d],b,l+1);p!==null&&(E[d]=p)}}return null}function R(E,b){const l=D(E,b,0);return l===null?E:l}e.$Nm=R;function k(E,b,l,d){if(!E||d>200)return null;if(typeof E=="object"){if(E.$mid===1)return l?L.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);if(E instanceof I.$be)return null;for(const p in E)if(Object.hasOwnProperty.call(E,p)){const y=k(E[p],b,l,d+1);y!==null&&(E[p]=y)}}return null}function g(E,b){const l=k(E,b,!1,0);return l===null?E:l}e.$Om=g;function C(E,b){const l=k(E,b,!0,0);return l===null?E:l}e.$Pm=C}),define(oe[143],ae([0,1,36,47,32,131,5]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=new class{c(b){return this.a||(this.a=L.$Vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,l=0;const d=(0,I.networkInterfaces)();for(const p in d){const y=d[p];if(y)for(const{mac:f,internal:c}of y)c||(l+=1,this.c(f.toUpperCase())&&(b+=1))}this.b=l>0?b/l:0}return this.b}};let R;async function k(b){return R||(R=(async()=>await g(b)||A.$eg())()),R}e.$Sm=k;async function g(b){try{const l=await new Promise((p,y)=>{te(["crypto"],p,y)}),d=(0,N.$Qm)();return l.createHash("sha256").update(d,"utf8").digest("hex")}catch(l){b(l);return}}const C="Software\\Microsoft\\SQMClient";async function E(b){if(D.$j){const l=await new Promise((d,p)=>{te(["@vscode/windows-registry"],d,p)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch(d){return b(d),""}}return""}e.$Tm=E}),define(oe[31],ae([0,1,53,36,269,6,48,88,16,5,19,10]),function(te,e,I,L,A,N,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function l(X,x=b.UNLINK,H){if((0,D.$1f)(X))throw new Error("rimraf - will refuse to recursively delete root");return x===b.UNLINK?p(X):d(X,H)}async function d(X,x=(0,D.$6f)((0,L.tmpdir)())){try{try{await I.promises.rename(X,x)}catch(H){return H.code==="ENOENT"?void 0:p(X)}p(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function p(X){return(0,A.promisify)(I.rm)(X,{recursive:!0,force:!0,maxRetries:3})}function y(X){if((0,D.$1f)(X))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function f(X,x){return m(await(x?c(X):(0,A.promisify)(I.readdir)(X)))}async function c(X){try{return await(0,A.promisify)(I.readdir)(X,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],H=await f(X);for(const Q of H){let J=!1,W=!1,ee=!1;try{const ne=await e.Promises.lstat((0,k.$jc)(X,Q));J=ne.isFile(),W=ne.isDirectory(),ee=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:Q,isFile:()=>J,isDirectory:()=>W,isSymbolicLink:()=>ee})}return x}function h(X){return m(I.readdirSync(X))}e.readdirSync=h;function m(X){return X.map(x=>typeof x=="string"?g.$k?(0,R.$ol)(x):x:(x.name=g.$k?(0,R.$ol)(x.name):x.name,x))}async function S(X){const x=await f(X),H=[];for(const Q of x)await a.existsDirectory((0,k.$jc)(X,Q))&&H.push(Q);return H}function s(X,x=1e3){return new Promise(H=>{let Q=!1;const J=setInterval(()=>{Q||(Q=!0,I.access(X,W=>{Q=!1,W&&(clearInterval(J),H(void 0))}))},x)})}e.whenDeleted=s;var a;(function(X){async function x(J){let W;try{if(W=await e.Promises.lstat(J),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(g.$j&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ne}throw ee}}X.stat=x;async function H(J){try{const{stat:W,symbolicLink:ee}=await X.stat(J);return W.isFile()&&ee?.dangling!==!0}catch{}return!1}X.existsFile=H;async function Q(J){try{const{stat:W,symbolicLink:ee}=await X.stat(J);return W.isDirectory()&&ee?.dangling!==!0}catch{}return!1}X.existsDirectory=Q})(a||(e.SymlinkSupport=a={}));const n=new N.$3g;function i(X,x,H){return n.queueFor(E.URI.file(X),C.$mg).queue(()=>{const Q=w(H);return new Promise((J,W)=>o(X,x,Q,ee=>ee?W(ee):J()))})}let t=!0;function r(X){t=X}e.configureFlushOnWrite=r;function o(X,x,H,Q){if(!t)return I.writeFile(X,x,{mode:H.mode,flag:H.flag},Q);I.open(X,H.flag,H.mode,(J,W)=>{if(J)return Q(J);I.writeFile(W,x,ee=>{if(ee)return I.close(W,()=>Q(ee));I.fdatasync(W,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),I.close(W,_=>Q(_))))})})}function v(X,x,H){const Q=w(H);if(!t)return I.writeFileSync(X,x,{mode:Q.mode,flag:Q.flag});const J=I.openSync(X,Q.flag,Q.mode);try{I.writeFileSync(J,x);try{I.fdatasyncSync(J)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{I.closeSync(J)}}e.writeFileSync=v;function w(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function u(X,x,H=6e4){if(X!==x)try{g.$j&&typeof H=="number"?await $(X,x,Date.now(),H):await(0,A.promisify)(I.rename)(X,x)}catch(Q){if(X.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||X.endsWith("."))await j(X,x,{preserveSymlinks:!1}),await l(X,b.MOVE);else throw Q}}async function $(X,x,H,Q,J=0){try{return await(0,A.promisify)(I.rename)(X,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-H>=Q)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${W}`),W;if(J===0){let ee=!1;try{const{stat:ne}=await a.stat(x);ne.isFile()||(ee=!0)}catch{}if(ee)throw W}return await(0,N.$Ug)(Math.min(100,J*10)),$(X,x,H,Q,J+1)}}async function j(X,x,H){return U(X,x,{root:{source:X,target:x},options:H,handledSourcePaths:new Set})}const M=511;async function U(X,x,H){if(H.handledSourcePaths.has(X))return;H.handledSourcePaths.add(X);const{stat:Q,symbolicLink:J}=await a.stat(X);if(J){if(H.options.preserveSymlinks)try{return await Z(X,x,H)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(J.dangling)return}return Q.isDirectory()?z(X,x,Q.mode&M,H):q(X,x,Q.mode&M)}async function z(X,x,H,Q){await e.Promises.mkdir(x,{recursive:!0,mode:H});const J=await f(X);for(const W of J)await U((0,k.$jc)(X,W),(0,k.$jc)(x,W),Q)}async function q(X,x,H){await e.Promises.copyFile(X,x),await e.Promises.chmod(x,H)}async function Z(X,x,H){let Q=await e.Promises.readlink(X);(0,D.$Xf)(Q,H.root.source,!g.$l)&&(Q=(0,k.$jc)(H.root.target,Q.substr(H.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,A.promisify)(I.access)}get stat(){return(0,A.promisify)(I.stat)}get lstat(){return(0,A.promisify)(I.lstat)}get utimes(){return(0,A.promisify)(I.utimes)}get read(){return(X,x,H,Q,J)=>new Promise((W,ee)=>{I.read(X,x,H,Q,J,(ne,_,ie)=>ne?ee(ne):W({bytesRead:_,buffer:ie}))})}get readFile(){return(0,A.promisify)(I.readFile)}get write(){return(X,x,H,Q,J)=>new Promise((W,ee)=>{I.write(X,x,H,Q,J,(ne,_,ie)=>ne?ee(ne):W({bytesWritten:_,buffer:ie}))})}get appendFile(){return(0,A.promisify)(I.appendFile)}get fdatasync(){return(0,A.promisify)(I.fdatasync)}get truncate(){return(0,A.promisify)(I.truncate)}get copyFile(){return(0,A.promisify)(I.copyFile)}get open(){return(0,A.promisify)(I.open)}get close(){return(0,A.promisify)(I.close)}get symlink(){return(0,A.promisify)(I.symlink)}get readlink(){return(0,A.promisify)(I.readlink)}get chmod(){return(0,A.promisify)(I.chmod)}get mkdir(){return(0,A.promisify)(I.mkdir)}get unlink(){return(0,A.promisify)(I.unlink)}get rmdir(){return(0,A.promisify)(I.rmdir)}get realpath(){return(0,A.promisify)(I.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return S}get writeFile(){return i}get rm(){return l}get rename(){return u}get copy(){return j}}}),define(oe[144],ae([0,1,53,16,5,27,31]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=void 0;function R(b){if(A.$l)return b;const l=(0,L.$mc)(b);if(b===l)return b;const d=((0,L.$nc)(b)||b).toLowerCase();try{const y=(0,D.readdirSync)(l).filter(f=>f.toLowerCase()===d);if(y.length===1){const f=R(l);if(f)return(0,L.$jc)(f,y[0])}else if(y.length>1){const f=y.indexOf(d);if(f>=0){const c=R(l);if(c)return(0,L.$jc)(c,y[f])}}}catch{}return null}e.$6p=R;async function k(b){if(A.$l)return b;const l=(0,L.$mc)(b);if(b===l)return b;const d=((0,L.$nc)(b)||b).toLowerCase();try{const y=(await D.Promises.readdir(l)).filter(f=>f.toLowerCase()===d);if(y.length===1){const f=await k(l);if(f)return(0,L.$jc)(f,y[0])}else if(y.length>1){const f=y.indexOf(d);if(f>=0){const c=await k(l);if(c)return(0,L.$jc)(c,y[f])}}}catch{}return null}e.$7p=k;async function g(b){try{return await D.Promises.realpath(b)}catch{const d=E(b);return await D.Promises.access(d,I.constants.R_OK),d}}e.$8p=g;function C(b){try{return I.realpathSync(b)}catch{const d=E(b);return I.accessSync(d,I.constants.R_OK),d}}e.$9p=C;function E(b){return(0,N.$Ke)((0,L.$hc)(b),L.sep)}}),define(oe[145],ae([0,1,16,5,37,90,12,31]),function(te,e,I,L,A,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function k(E=A.env){return E.comspec||"cmd.exe"}e.$Bl=k;function g(E){let b=[],l=!1;const d=function(p){if(l){b.push(p);return}(!E.send(p,f=>{if(f&&console.error(f),l=!1,b.length>0){const c=b.slice(0);b=[],c.forEach(h=>d(h))}})||L.$j)&&(l=!0)};return{send:d}}e.$Cl=g;var C;(function(E){async function b(l,d,p){if(I.$ic(l))return l;if(d===void 0&&(d=A.cwd()),I.$mc(l)!=="."||(p===void 0&&D.$yf(A.env.PATH)&&(p=A.env.PATH.split(I.$tc)),p===void 0||p.length===0))return I.$jc(d,l);async function f(c){if(await R.Promises.exists(c)){let h;try{h=await R.Promises.stat(c)}catch(m){m.message.startsWith("EACCES")&&(h=await R.Promises.lstat(c))}return h?!h.isDirectory():!1}return!1}for(const c of p){let h;if(I.$ic(c)?h=I.$jc(c,l):h=I.$jc(d,c,l),await f(h))return h;let m=h+".com";if(await f(m)||(m=h+".exe",await f(m)))return m}return I.$jc(d,l)}E.findExecutable=b})(C||(e.win32=C={}))}),define(oe[146],ae([0,1,65,23]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;function A(D){return new Promise((R,k)=>{let g;const C=new Map;function E(l,d,p,y,f){const c=C.get(d);if(l===D||c){const h={name:b(p),cmd:p,pid:l,ppid:d,load:y,mem:f};C.set(l,h),l===D&&(g=h),c&&(c.children||(c.children=[]),c.children.push(h),c.children.length>1&&(c.children=c.children.sort((m,S)=>m.pid-S.pid)))}}function b(l){const d=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,y=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,c=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(y.exec(l))return"electron-crash-reporter";if(f.exec(l))return"winpty-agent";if(c.exec(l))return"conpty-agent";let m=h.exec(l);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?d.exec(l)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const S=/[a-zA-Z-]+\.js/g;let s="";do m=S.exec(l),m&&(s+=m+" ");while(m);return s&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${s})`:p.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,p)=>{te(["@vscode/windows-process-tree"],d,p)}).then(d=>{d.getProcessList(D,p=>{if(!p){k(new Error(`Root process ${D} not found`));return}d.getProcessCpuUsage(p,y=>{const f=new Map;y.forEach(c=>{const h=l(c.commandLine||"");f.set(c.pid,{name:b(h),cmd:h,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),g=f.get(D),g?(f.forEach(c=>{const h=f.get(c.ppid);h&&(h.children||(h.children=[]),h.children.push(c))}),f.forEach(c=>{c.children&&(c.children=c.children.sort((h,m)=>h.pid-m.pid))}),R(g)):k(new Error(`Root process ${D} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let l=function(){let d=[g];const p=[];for(;d.length;){const f=d.shift();f&&(p.push(f.pid),f.children&&(d=d.concat(f.children)))}let y=JSON.stringify(L.$cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+p.join(" "),(0,I.exec)(y,{},(f,c,h)=>{if(f||h)k(f||new Error(h.toString()));else{const m=c.toString().split(`
`);for(let S=0;S<p.length;S++){const s=C.get(p[S]);s.load=parseFloat(m[S])}if(!g){k(new Error(`Root process ${D} not found`));return}R(g)}})};(0,I.exec)("which ps",{},(d,p,y)=>{if(d||y)if(process.platform!=="linux")k(d||new Error(y.toString()));else{const f=JSON.stringify(L.$cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(f,{},(c,h,m)=>{c||m?k(c||new Error(m.toString())):(N(h,E),l())})}else{const f=p.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${f} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,m,S)=>{h||S&&!S.includes("screen size is bogus")?k(h||new Error(S.toString())):(N(m,E),process.platform==="linux"?l():g?R(g):k(new Error(`Root process ${D} not found`)))})}})}})}e.$Dr=A;function N(D,R){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=D.toString().split(`
`);for(const C of g){const E=k.exec(C.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var ye=this&&this.__decorate||function(te,e,I,L){var A=arguments.length,N=A<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(te,e,I,L);else for(var R=te.length-1;R>=0;R--)(D=te[R])&&(N=(A<3?D(N):A>3?D(e,I,N):D(e,I))||N);return A>3&&N&&Object.defineProperty(e,I,N),N};define(oe[42],ae([0,1,18,6,15,26,84,8,3,2,64,27,12]),function(te,e,I,L,A,N,D,R,k,g,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var l;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(l||(l={}));function d(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(p||(p={}));function y(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(f||(f={}));function c(J){let W=0;for(let ee=0;;ee+=7){const ne=J.read(1);if(W|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return W}}const h=n(0);function m(J,W){if(W===0){J.write(h);return}let ee=0;for(let _=W;_!==0;_=_>>>7)ee++;const ne=A.$be.alloc(ee);for(let _=0;W!==0;_++)ne.buffer[_]=W&127,W=W>>>7,W>0&&(ne.buffer[_]|=128);J.write(ne)}class S{constructor(W){this.b=W,this.a=0}read(W){const ee=this.b.slice(this.a,this.a+W);return this.a+=ee.byteLength,ee}}e.$nh=S;class s{constructor(){this.a=[]}get buffer(){return A.$be.concat(this.a)}write(W){this.a.push(W)}}e.$oh=s;var a;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(a||(a={}));function n(J){const W=A.$be.alloc(1);return W.writeUInt8(J,0),W}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},t=typeof Buffer<"u";function r(J,W){if(typeof W>"u")J.write(i.Undefined);else if(typeof W=="string"){const ee=A.$be.fromString(W);J.write(i.String),m(J,ee.byteLength),J.write(ee)}else if(t&&Buffer.isBuffer(W)){const ee=A.$be.wrap(W);J.write(i.Buffer),m(J,ee.byteLength),J.write(ee)}else if(W instanceof A.$be)J.write(i.VSBuffer),m(J,W.byteLength),J.write(W);else if(Array.isArray(W)){J.write(i.Array),m(J,W.length);for(const ee of W)r(J,ee)}else if(typeof W=="number"&&(W|0)===W)J.write(i.Uint),m(J,W);else{const ee=A.$be.fromString(JSON.stringify(W));J.write(i.Object),m(J,ee.byteLength),J.write(ee)}}e.$ph=r;function o(J){switch(J.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return J.read(c(J)).toString();case a.Buffer:return J.read(c(J)).buffer;case a.VSBuffer:return J.read(c(J));case a.Array:{const ee=c(J),ne=[];for(let _=0;_<ee;_++)ne.push(o(J));return ne}case a.Object:return JSON.parse(J.read(c(J)).toString());case a.Int:return c(J)}}e.$qh=o;class v{constructor(W,ee,ne=null,_=1e3){this.h=W,this.j=ee,this.k=ne,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.q(ie)),this.m({type:200})}registerChannel(W,ee){this.b.set(W,ee),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const ee=this.o([W.type]);this.k?.logOutgoing(ee,0,1,y(W.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([W.type,W.id],W.data);this.k?.logOutgoing(ee,W.id,1,y(W.type),W.data);return}}}o(W,ee=void 0){const ne=new s;return r(ne,W),r(ne,ee),this.p(ne.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const ee=new S(W),ne=o(ee),_=o(ee),ie=ne[0];switch(ie){case 100:return this.k?.logIncoming(W.byteLength,ne[1],1,`${d(ie)}: ${ne[2]}.${ne[3]}`,_),this.s({type:ie,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 102:return this.k?.logIncoming(W.byteLength,ne[1],1,`${d(ie)}: ${ne[2]}.${ne[3]}`,_),this.t({type:ie,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 101:return this.k?.logIncoming(W.byteLength,ne[1],1,`${d(ie)}`),this.u({type:ie,id:ne[1]});case 103:return this.k?.logIncoming(W.byteLength,ne[1],1,`${d(ie)}`),this.u({type:ie,id:ne[1]})}}s(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=new N.$Xd;let _;try{_=ee.call(this.j,W.name,W.arg,ne.token)}catch(B){_=Promise.reject(B)}const ie=W.id;_.then(B=>{this.m({id:ie,data:B,type:201})},B=>{B instanceof Error?this.m({id:ie,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:ie,data:B,type:203})}).finally(()=>{K.dispose(),this.d.delete(W.id)});const K=(0,g.$Qc)(()=>ne.cancel());this.d.set(W.id,K)}t(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=W.id,ie=ee.listen(this.j,W.name,W.arg)(K=>this.m({id:ne,data:K,type:204}));this.d.set(W.id,ie)}u(W){const ee=this.d.get(W.id);ee&&(ee.dispose(),this.d.delete(W.id))}v(W){let ee=this.g.get(W.channelName);ee||(ee=[],this.g.set(W.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:W,timeoutTimer:ne})}w(W){const ee=this.g.get(W);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Nc)(this.d.values()),this.d.clear()}}e.$rh=v;var w;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class u{constructor(W,ee=null){this.l=W,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(W){const ee=this;return{call(ne,_,ie){return ee.a?Promise.reject(new R.$5):ee.m(W,ne,_,ie)},listen(ne,_){return ee.a?k.Event.None:ee.o(W,ne,_)}}}m(W,ee,ne,_=N.CancellationToken.None){const ie=this.g++,B={id:ie,type:100,channelName:W,name:ee,arg:ne};if(_.isCancellationRequested)return Promise.reject(new R.$5);let P;return new Promise((T,F)=>{if(_.isCancellationRequested)return F(new R.$5);const V=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(ie),T(he.data);break;case 202:{this.f.delete(ie);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,F($e);break}case 203:this.f.delete(ie),F(he.data);break}};this.f.set(ie,ue),this.p(B)};let G=null;this.b===f.Idle?V():(G=(0,L.$Hg)(ue=>this.u()),G.then(()=>{G=null,V()}));const re=()=>{G?(G.cancel(),G=null):this.p({id:ie,type:101}),F(new R.$5)},ce=_.onCancellationRequested(re);P=(0,g.$Pc)((0,g.$Qc)(re),ce),this.d.add(P)}).finally(()=>{P.dispose(),this.d.delete(P)})}o(W,ee,ne){const _=this.g++,K={id:_,type:102,channelName:W,name:ee,arg:ne};let B=null;const P=new k.$Nd({onWillAddFirstListener:()=>{B=(0,L.$Hg)(T=>this.u()),B.then(()=>{B=null,this.d.add(P),this.p(K)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(P),this.p({id:_,type:103}))}}),O=T=>P.fire(T.data);return this.f.set(_,O),P.event}p(W){switch(W.type){case 100:case 102:{const ee=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(ee,W.id,0,`${d(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const ee=this.q([W.type,W.id]);this.j?.logOutgoing(ee,W.id,0,d(W.type));return}}}q(W,ee=void 0){const ne=new s;return r(ne,W),r(ne,ee),this.r(ne.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const ee=new S(W),ne=o(ee),_=o(ee),ie=ne[0];switch(ie){case 200:return this.j?.logIncoming(W.byteLength,0,0,y(ie)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,ne[1],0,y(ie),_),this.t({type:ne[0],id:ne[1],data:_})}}t(W){if(W.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Nc)(this.d.values()),this.d.clear()}}e.$sh=u,ye([D.$hh],u.prototype,"onDidInitializePromise",null);class ${get connections(){const W=[];return this.f.forEach(ee=>W.push(ee)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new k.$Nd,this.onDidAddConnection=this.g.event,this.h=new k.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Rc,this.j.add(W(({protocol:ee,onDidClientDisconnect:ne})=>{const _=k.Event.once(ee.onMessage);this.j.add(_(ie=>{const K=new S(ie),B=o(K),P=new v(ee,B),O=new u(ee);this.a.forEach((F,V)=>P.registerChannel(V,F));const T={channelServer:P,channelClient:O,ctx:B};this.f.add(T),this.g.fire(T),this.j.add(ne(()=>{P.dispose(),O.dispose(),this.f.delete(T),this.h.fire(T)}))}))}))}getChannel(W,ee){const ne=this;return{call(_,ie,K){let B;if((0,b.$Mf)(ee)){const O=(0,I.$4b)(ne.connections.filter(ee));B=O?Promise.resolve(O):k.Event.toPromise(k.Event.filter(ne.onDidAddConnection,ee))}else B=ee.routeCall(ne,_,ie);const P=B.then(O=>O.channelClient.getChannel(W));return M(P).call(_,ie,K)},listen(_,ie){if((0,b.$Mf)(ee))return ne.k(W,ee,_,ie);const K=ee.routeEvent(ne,_,ie).then(B=>B.channelClient.getChannel(W));return M(K).listen(_,ie)}}}k(W,ee,ne,_){const ie=this;let K;const B=new k.$Nd({onWillAddFirstListener:()=>{K=new g.$Rc;const P=new k.$Td,O=new Map,T=V=>{const re=V.channelClient.getChannel(W).listen(ne,_),ce=P.add(re);O.set(V,ce)},F=V=>{const G=O.get(V);G&&(G.dispose(),O.delete(V))};ie.connections.filter(ee).forEach(T),k.Event.filter(ie.onDidAddConnection,ee)(T,void 0,K),ie.onDidRemoveConnection(F,void 0,K),P.event(B.fire,B,K),K.add(P)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return B.event}registerChannel(W,ee){this.a.set(W,ee);for(const ne of this.f)ne.channelServer.registerChannel(W,ee)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=$;class j{constructor(W,ee,ne=null){const _=new s;r(_,ee),W.send(_.buffer),this.a=new u(W,ne),this.d=new v(W,ee,ne)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,ee){this.d.registerChannel(W,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=j;function M(J){return{call(W,ee,ne){return J.then(_=>_.call(W,ee,ne))},listen(W,ee){const ne=new k.$Wd;return J.then(_=>ne.input=_.listen(W,ee)),ne.event}}}e.$vh=M;function U(J){let W=!1;return{call(ee,ne,_){return W?J.call(ee,ne,_):(0,L.$Ug)(0).then(()=>W=!0).then(()=>J.call(ee,ne,_))},listen(ee,ne){if(W)return J.listen(ee,ne);const _=new k.$Wd;return(0,L.$Ug)(0).then(()=>W=!0).then(()=>_.input=J.listen(ee,ne)),_.event}}}e.$wh=U;class z{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const ee of W.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await k.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$xh=z;var q;(function(J){function W(ie,K,B){const P=ie,O=B&&B.disableMarshalling,T=new Map;for(const F in P)ne(F)&&T.set(F,k.Event.buffer(P[F],!0,void 0,K));return new class{listen(F,V,G){const re=T.get(V);if(re)return re;if(_(V)){const ce=P[V];if(typeof ce=="function")return ce.call(P,G)}throw new R.$bb(`Event not found: ${V}`)}call(F,V,G){const re=P[V];if(typeof re=="function"){if(!O&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,C.$mh)(G[ue]);let ce=re.apply(P,G);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new R.$bb(`Method not found: ${V}`)}}}J.fromService=W;function ee(ie,K){const B=K&&K.disableMarshalling;return new Proxy({},{get(P,O){if(typeof O=="string")return K?.properties?.has(O)?K.properties.get(O):_(O)?function(T){return ie.listen(O,T)}:ne(O)?ie.listen(O):async function(...T){let F;K&&!(0,b.$Hf)(K.context)?F=[K.context,...T]:F=T;const V=await ie.call(O,F);return B?V:(0,C.$mh)(V)};throw new R.$bb(`Property not found: ${String(O)}`)}})}J.toService=ee;function ne(ie){return ie[0]==="o"&&ie[1]==="n"&&E.$1e(ie.charCodeAt(2))}function _(ie){return/^onDynamic/.test(ie)&&E.$1e(ie.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const W=J.toString();if(W!=="[object Object]")return W}return J}function x(J){return Array.isArray(J)?J.map(X):X(J)}function H(J,W,ee,ne,_,ie,K){K=x(K);const B=Z[_],P=B[ne%B.length];let O=[`%c[${J}]%c[${String(W).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(ie)?(O=O.concat(K),O.push(")")):O.push(K),console.log.apply(console,O)}class Q{constructor(W,ee){this.d=W,this.f=ee,this.a=0,this.b=0}logOutgoing(W,ee,ne,_,ie){this.b+=W,H(this.d,this.b,W,ee,ne,_,ie)}logIncoming(W,ee,ne,_,ie){this.a+=W,H(this.f,this.a,W,ee,ne,_,ie)}}e.$yh=Q}),define(oe[66],ae([0,1,15,3,2,42]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.ProtocolConstants=e.$zh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function o(w,u){if(!t.has(w)){const $=String(++r);t.set(w,$)}return t.get(w)}function v(w,u,$,j){if(!i.enableDiagnostics)return;const M=o(w,u);if(j instanceof I.$be||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const U=I.$be.alloc(j.byteLength);U.set(j),i.records.push({timestamp:Date.now(),id:M,label:u,type:$,buff:U})}else i.records.push({timestamp:Date.now(),id:M,label:u,type:$,data:j})}i.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var k;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let g=null;function C(){return g||(g=I.$be.alloc(0)),g}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const u=this.a[0];return r&&(this.a.shift(),this.b-=t),u}if(this.a[0].byteLength>t){const u=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),u}const o=I.$be.alloc(t);let v=0,w=0;for(;t>0;){const u=this.a[w];if(u.byteLength>t){const $=u.slice(0,t);o.set($,v),v+=t,r&&(this.a[w]=u.slice(t),this.b-=t),t-=t}else o.set(u,v),v+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):w++,t-=u.byteLength}return o}}e.$zh=E;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function l(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class p{constructor(t,r,o,v){this.type=t,this.id=r,this.ack=o,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends A.$Sc{constructor(t){super(),this.f=this.B(new L.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,v=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(o,v,w,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$be.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const o=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,o}h(){const t=I.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class c extends A.$Sc{constructor(t){super(),this.f=new L.$Nd,this.onMessage=this.f.event,this.g=new L.$Nd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new f(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new p(1,0,0,t))}}e.$Ah=c;class h extends N.$uh{static fromSocket(t,r){return new h(new c(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,o=null){super(t,r,o),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Bh=h;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Ch=m;class S{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,o=this.a;for(;o;)t[r++]=o.data,o=o.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new S(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<a.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+a.a)*1e3;let o=0;for(let v=0;v<a.a;v++)t-this.c[v]<=r&&o++;return 1-o/a.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??a.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Rc,this.o=t.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new p(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new p(7,0,0,C());this.p.write(t)}sendResume(){const t=new p(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new A.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new p(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const o=new p(1,r,this.h,t);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(t){const r=new p(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,o=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&o>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const w=Math.max(2e4-r,2e4-o,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new p(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new p(9,0,this.h,C());this.p.write(t)}}e.$Dh=n}),define(oe[93],ae([0,1,65,6,15,26,141,8,3,2,30,145,90,42]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;class d extends l.$rh{constructor(f){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",c=>A.$be.wrap(Buffer.from(c,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$3p=d;class p{constructor(f,c){this.i=f,this.j=c,this.c=new Set,this.g=new Map,this.h=new k.$Nd,this.onDidProcessExit=this.h.event;const h=c&&c.timeout?c.timeout:6e4;this.b=new L.$Qg(h),this.d=null,this.f=null}getChannel(f){const c=this;return{call(h,m,S){return c.k(f,h,m,S)},listen(h,m){return c.l(f,h,m)}}}k(f,c,h,m=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const S=this.n(f),s=(0,L.$Hg)(i=>S.call(c,h,i)),a=m.onCancellationRequested(()=>s.cancel()),n=(0,g.$Qc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(f,c,h){if(!this.b)return k.Event.None;this.b.cancel();let m;const S=new k.$Nd({onWillAddFirstListener:()=>{m=this.n(f).listen(c,h)(S.fire,S),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return S.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,C.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,b.$Al)(c.env),this.d=(0,I.fork)(this.i,f,c);const h=new k.$Nd;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,D.$Yp)(t)){(0,D.log)(t,`IPC Library: ${this.j.serverName}`);return}h.fire(A.$be.wrap(Buffer.from(t,"base64")))});const S=this.j.useQueue?(0,E.$Cl)(this.d):this.d,s=t=>this.d&&this.d.connected&&S.send(t.buffer.toString("base64")),a=h.event,n={send:s,onMessage:a};this.f=new l.$sh(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(o=>(0,g.$Nc)(o)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(f){let c=this.g.get(f);return c||(c=this.m.getChannel(f),this.g.set(f,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$4p=p}),define(oe[147],ae([0,1,134,15,42,3,12,18]),function(te,e,I,L,A,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xT=e.$wT=void 0;class k{constructor(b){this.a=b,this.onMessage=N.Event.fromNodeEventEmitter(this.a,"message",l=>L.$be.wrap(l.data)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}class g extends A.$th{static b(b){(0,D.$If)((0,I.$vT)(process),"Electron Utility Process");const l=new N.$Nd;return process.parentPort.on("message",d=>{if(b?.handledClientConnection(d))return;const p=(0,R.$Ob)(d.ports);p&&l.fire(p)}),N.Event.map(l.event,d=>({protocol:new k(d),onDidClientDisconnect:N.Event.fromNodeEventEmitter(d,"close")}))}constructor(b){super(g.b(b))}}e.$wT=g;function C(E,b,l){const d=p=>{p.data===b&&(E.removeListener("message",d),l())};E.on("message",d)}e.$xT=C}),define(oe[67],ae([0,1,6,3,2,64,12]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.StorageState=e.$2o=e.StorageHint=void 0;var R;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k(b){const l=b;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$2o=k;var g;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends A.$Sc{static{this.a=100}constructor(l,d=Object.create(null)){super(),this.r=l,this.s=d,this.b=this.B(new L.$Qd),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new I.$Rg(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((d,p)=>this.w(p,d)),l.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(l,d){if(this.c===g.Closed)return;let p=!1;(0,D.$Hf)(d)?p=this.f.delete(l):this.f.get(l)!==d&&(this.f.set(l,d),p=!0),p&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,d){const p=this.f.get(l);return(0,D.$Hf)(p)?d:p}getBoolean(l,d){const p=this.get(l);return(0,D.$Hf)(p)?d:p==="true"}getNumber(l,d){const p=this.get(l);return(0,D.$Hf)(p)?d:parseInt(p,10)}getObject(l,d){const p=this.get(l);return(0,D.$Hf)(p)?d:(0,N.$lh)(p)}async set(l,d,p=!1){if(this.c===g.Closed)return;if((0,D.$Hf)(d))return this.delete(l,p);const y=(0,D.$Af)(d)||Array.isArray(d)?(0,N.$kh)(d):String(d);if(this.f.get(l)!==y)return this.f.set(l,y),this.j.set(l,y),this.h.delete(l),this.b.fire({key:l,external:p}),this.D()}async delete(l,d=!1){if(!(this.c===g.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:d}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$3o=C;class E{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((d,p)=>this.a.set(p,d)),l.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$4o=E}),define(oe[148],ae([13,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[149],ae([13,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[150],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[151],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[152],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[153],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[154],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[155],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[156],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[157],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[158],ae([13,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[159],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[160],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[161],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[162],ae([13,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[163],ae([13,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[164],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[165],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[166],ae([13,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[167],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[168],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[169],ae([13,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[170],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[171],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[172],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[173],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[174],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[175],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[176],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[177],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[178],ae([13,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[179],ae([0,1,8,151]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var A;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(A||(e.TokenType=A={}));function N(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const D=(0,L.localize)(3,null),R=(0,L.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const E=this.d,b=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:b};this.g.push({offset:E,lexeme:b,additionalInfo:C}),this.f.push(l)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const E=this.c.substring(this.d,this.e),b=k.b.get(E);b?this.k(b):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,E=!1,b=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const d=this.c.charCodeAt(C);if(E)E=!1;else if(d===47&&!b){C++;break}else d===91?b=!0:d===92?E=!0:d===93&&(b=!1);C++}for(;C<this.c.length&&k.a.has(this.c.charCodeAt(C));)C++;this.e=C;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=k}),define(oe[180],ae([0,1,63,84,23,16,37,19,10]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm=/^([^.]+\..+):(.+)$/;class g{get appRoot(){return(0,N.$mc)(A.$cg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,R.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,I.$em)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",l)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$vg)(k.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?k.URI.file((0,N.$jc)(l,"argv.json")):(0,R.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,N.$kc)(l):(0,N.$hc)((0,N.$jc)(A.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?k.URI.file((0,N.$kc)(l)):k.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,N.$kc)(l);const d=D.env.VSCODE_EXTENSIONS;if(d)return d;const p=D.env.VSCODE_PORTABLE;return p?(0,N.$jc)(p,"extensions"):(0,R.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(d=>/^[^:/?#]+?:\/\//.test(d)?k.URI.parse(d):k.URI.file((0,N.$hc)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?k.URI.parse(l):k.URI.file((0,N.$hc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$fm.test(l))}get extensionLogLevel(){const l=[];for(const d of this.args.log||[]){const p=e.$fm.exec(d);p&&p[1]&&p[2]&&l.push([p[1],p[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,R.$vg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=D.env.VSCODE_PORTABLE;return l?k.URI.file((0,N.$jc)(l,"policy.json")):(0,R.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,d,p){this.a=l,this.b=d,this.c=p,this.editSessionId=this.args.editSessionId}}e.$gm=g,ye([L.$hh],g.prototype,"appRoot",null),ye([L.$hh],g.prototype,"userHome",null),ye([L.$hh],g.prototype,"userDataPath",null),ye([L.$hh],g.prototype,"appSettingsHome",null),ye([L.$hh],g.prototype,"tmpDir",null),ye([L.$hh],g.prototype,"cacheHome",null),ye([L.$hh],g.prototype,"stateResource",null),ye([L.$hh],g.prototype,"userRoamingDataHome",null),ye([L.$hh],g.prototype,"userDataSyncHome",null),ye([L.$hh],g.prototype,"sync",null),ye([L.$hh],g.prototype,"machineSettingsResource",null),ye([L.$hh],g.prototype,"workspaceStorageHome",null),ye([L.$hh],g.prototype,"localHistoryHome",null),ye([L.$hh],g.prototype,"keyboardLayoutResource",null),ye([L.$hh],g.prototype,"argvResource",null),ye([L.$hh],g.prototype,"isExtensionDevelopment",null),ye([L.$hh],g.prototype,"untitledWorkspacesHome",null),ye([L.$hh],g.prototype,"builtinExtensionsPath",null),ye([L.$hh],g.prototype,"extensionsPath",null),ye([L.$hh],g.prototype,"extensionDevelopmentLocationURI",null),ye([L.$hh],g.prototype,"extensionDevelopmentKind",null),ye([L.$hh],g.prototype,"extensionTestsLocationURI",null),ye([L.$hh],g.prototype,"debugExtensionHost",null),ye([L.$hh],g.prototype,"logLevel",null),ye([L.$hh],g.prototype,"extensionLogLevel",null),ye([L.$hh],g.prototype,"serviceMachineIdResource",null),ye([L.$hh],g.prototype,"disableTelemetry",null),ye([L.$hh],g.prototype,"disableWorkspaceTrust",null),ye([L.$hh],g.prototype,"useInMemorySecretStorage",null),ye([L.$hh],g.prototype,"policyFile",null);function C(b,l){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,l,b.debugId,b.extensionEnvironment)}e.$hm=C;function E(b,l,d,p,y,f){const h=Number(l||b)||(p?null:d),m=h?!!l:!1;let S;if(f)try{S=JSON.parse(f)}catch{}return{port:h,break:m,debugId:y,env:S}}e.$im=E}),function(){"use strict";function te(e,I,L){function A(D,R){const k=N(D,R),g=[k];return e.isAbsolute(k)||g.unshift(L),e.resolve(...g)}function N(D,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=D["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(E,"AppData","Roaming")}break;case"darwin":g=e.join(I.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:A}}if(typeof define=="function")define(oe[181],ae([270,36,37]),function(e,I,L){return te(e,I,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=te(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[182],ae([0,1,36,180,181]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=void 0;class N extends L.$gm{constructor(g,C){super(g,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,A.getUserDataPath)(g,C.nameShort)},C)}}e.$jm=N;function D(k,g){return(0,L.$im)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,g,k.extensionEnvironment)}e.$km=D;function R(k,g){return(0,L.$im)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,g,k.extensionEnvironment)}e.$lm=R}),define(oe[183],ae([0,1,12,154]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;function A(D,R,k,g){try{N(D,R,k,g)}catch(C){D.error(C?.message??C)}return R}e.$yp=A;function N(D,R,k,g){const C=(E,b,l)=>{const d=E[b];if((0,I.$yf)(d)){const p=d,y=p.length;if(y>1&&p[0]==="%"&&p[y-1]==="%"){const f=p.substr(1,y-2);let c=k[f];c===void 0&&g&&(c=g[f]);const h=typeof c=="string"?c:c?.message,m=g?.[f],S=typeof m=="string"?m:m?.message;if(!h){S||D.warn(`[${R.name}]: ${(0,L.localize)(0,null,f)}`);return}if(l&&(b==="title"||b==="category")&&S&&S!==h){const s={value:h,original:S};E[b]=s}else E[b]=h}}else if((0,I.$Af)(d))for(const p in d)d.hasOwnProperty(p)&&(p==="commands"?C(d,p,!0):C(d,p,l));else if(Array.isArray(d))for(let p=0;p<d.length;p++)C(d,p,l)};for(const E in R)R.hasOwnProperty(E)&&C(R,E)}}),define(oe[184],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a9b=e.$_8b=void 0;class I{constructor(N){this.a=N}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(N){return this.a.call("promptImportantExtensionsInstallNotification",[N])}promptWorkspaceRecommendations(N){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$_8b=I;class L{constructor(N){this.a=N}listen(N,D){throw new Error(`Event not found: ${D}`)}call(N,D,R){switch(D){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${D}`)}}e.$a9b=L}),define(oe[68],ae([0,1,19,89,158,54]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(f){return f=f.trim(),f==="*"||D.test(f)}e.$Mo=k;function g(f){if(!k(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=f.match(D);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$No=g;function C(f){if(!f)return null;const c=f.majorBase,h=f.majorMustEqual,m=f.minorBase;let S=f.minorMustEqual;const s=f.patchBase;let a=f.patchMustEqual;f.hasCaret&&(c===0||(S=!1),a=!1);let n=0;if(f.preRelease){const i=R.exec(f.preRelease);if(i){const[,t,r,o]=i;n=Date.UTC(Number(t),Number(r)-1,Number(o))}}return{majorBase:c,majorMustEqual:h,minorBase:m,minorMustEqual:S,patchBase:s,patchMustEqual:a,isMinimum:f.hasGreaterEquals,notBefore:n}}e.$Oo=C;function E(f,c,h){let m;typeof f=="string"?m=C(g(f)):m=f;let S;c instanceof Date?S=c.getTime():typeof c=="string"&&(S=new Date(c).getTime());let s;if(typeof h=="string"?s=C(g(h)):s=h,!m||!s)return!1;const a=m.majorBase,n=m.minorBase,i=m.patchBase;let t=s.majorBase,r=s.minorBase,o=s.patchBase;const v=s.notBefore;let w=s.majorMustEqual,u=s.minorMustEqual,$=s.patchMustEqual;return s.isMinimum?a>t?!0:a<t?!1:n>r?!0:n<r||S&&S<v?!1:i>=o:(a===1&&t===0&&(!w||!u||!$)&&(t=1,r=0,o=0,w=!0,u=!1,$=!1),a<t?!1:a>t?!w:n<r?!1:n>r?!u:i<o?!1:i>o?!$:!(S&&S<v))}e.$Po=E;function b(f,c,h,m,S){const s=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return s.push([L.default.Error,A.localize(0,null)]),s;if(typeof m.name!="string")return s.push([L.default.Error,A.localize(1,null,"name")]),s;if(typeof m.version!="string")return s.push([L.default.Error,A.localize(2,null,"version")]),s;if(!m.engines)return s.push([L.default.Error,A.localize(3,null,"engines")]),s;if(typeof m.engines.vscode!="string")return s.push([L.default.Error,A.localize(4,null,"engines.vscode")]),s;if(typeof m.extensionDependencies<"u"&&!y(m.extensionDependencies))return s.push([L.default.Error,A.localize(5,null,"extensionDependencies")]),s;if(typeof m.activationEvents<"u"){if(!y(m.activationEvents))return s.push([L.default.Error,A.localize(6,null,"activationEvents")]),s;if(typeof m.main>"u"&&typeof m.browser>"u")return s.push([L.default.Error,A.localize(7,null,"activationEvents","main","browser")]),s}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&s.push([L.default.Warning,A.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return s.push([L.default.Error,A.localize(9,null,"main")]),s;{const i=(0,I.$vg)(h,m.main);(0,I.$pg)(i,h)||s.push([L.default.Warning,A.localize(10,null,i.path,h.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return s.push([L.default.Error,A.localize(11,null,"browser")]),s;{const i=(0,I.$vg)(h,m.browser);(0,I.$pg)(i,h)||s.push([L.default.Warning,A.localize(12,null,i.path,h.path)])}}if(!N.valid(m.version))return s.push([L.default.Error,A.localize(13,null)]),s;const a=[];if(!l(f,c,m,S,a))for(const i of a)s.push([L.default.Error,i]);return s}e.$Qo=b;function l(f,c,h,m,S){return m||typeof h.main>"u"&&typeof h.browser>"u"?!0:p(f,c,h.engines.vscode,S)}e.$Ro=l;function d(f,c,h){return f==="*"||p(c,h,f)}e.$So=d;function p(f,c,h,m=[]){const S=C(g(h));if(!S)return m.push(A.localize(14,null,h)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return m.push(A.localize(15,null,h)),!1}else if(!S.majorMustEqual)return m.push(A.localize(16,null,h)),!1;return E(f,c,S)?!0:(m.push(A.localize(17,null,f,h)),!1)}function y(f){if(!Array.isArray(f))return!1;for(let c=0,h=f.length;c<h;c++)if(typeof f[c]!="string")return!1;return!0}}),define(oe[43],ae([0,1,15,32]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;async function A(N,D,R){let k=R&&R.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const C=(await D.readFile(N.serviceMachineIdResource)).value.toString();k=(0,L.$dg)(C)?C:null}catch{k=null}if(!k){k=(0,L.$eg)();try{await D.writeFile(N.serviceMachineIdResource,I.$be.fromString(k))}catch{}}return R?.store("storage.serviceMachineId",k,-1,1),k}e.$ap=A}),define(oe[69],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class I{constructor(A,N=[],D=!1){this.ctor=A,this.staticArguments=N,this.supportsDelayedInstantiation=D}}e.$Mh=I}),define(oe[185],ae([0,1,69]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.InstantiationType=void 0;const L=[];var A;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function N(R,k,g){k instanceof I.$Mh||(k=new I.$Mh(k,[],!!g)),L.push([R,k])}e.$xr=N;function D(){return L}e.$yr=D}),define(oe[186],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class I{constructor(N,D){this.key=N,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$cq=I;class L{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const D of this.a.values())D.outgoing.size===0&&N.push(D);return N}insertEdge(N,D){const R=this.lookupOrInsertNode(N),k=this.lookupOrInsertNode(D);R.outgoing.set(k.key,k),k.incoming.set(R.key,R)}removeNode(N){const D=this.b(N);this.a.delete(D);for(const R of this.a.values())R.outgoing.delete(D),R.incoming.delete(D)}lookupOrInsertNode(N){const D=this.b(N);let R=this.a.get(D);return R||(R=new I(D,N),this.a.set(D,R)),R}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[D,R]of this.a)N.push(`${D}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,D]of this.a){const R=new Set([N]),k=this.c(D,R);if(k)return k}}c(N,D){for(const[R,k]of N.outgoing){if(D.has(R))return[...D,R].join(" -> ");D.add(R);const g=this.c(k,D);if(g)return g;D.delete(R)}}}e.$dq=L}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var I;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function R(k){return k[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=R})(I||(e._util=I={})),e.$Oh=A("instantiationService");function L(D,R,k){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:D,index:k}):(R[I.DI_DEPENDENCIES]=[{id:D,index:k}],R[I.DI_TARGET]=R)}function A(D){if(I.serviceIds.has(D))return I.serviceIds.get(D);const R=function(k,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(R,k,C)};return R.toString=()=>D,I.serviceIds.set(D,R),R}e.$Ph=A;function N(D){return D}e.$Qh=N}),define(oe[187],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I8b=void 0,e.$I8b=(0,I.$Ph)("checksumService")}),define(oe[20],ae([0,1,12,10,4]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,A.$Ph)("configurationService");function N(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof L.URI)}e.$ki=N;function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof L.URI)}e.$li=D;var R;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function k(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=k;function g(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}e.$ni=g;function C(f,c){const h=Object.create(null);for(const m in f)E(h,m,f[m],c);return h}e.$oi=C;function E(f,c,h,m){const S=c.split("."),s=S.pop();let a=f;for(let n=0;n<S.length;n++){const i=S[n];let t=a[i];switch(typeof t){case"undefined":t=a[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${c} as ${S.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[s]=h}catch{m(`Ignoring ${c} as ${S.join(".")} is ${JSON.stringify(a)}`)}else m(`Ignoring ${c} as ${S.join(".")} is ${JSON.stringify(a)}`)}e.$pi=E;function b(f,c){const h=c.split(".");l(f,h)}e.$qi=b;function l(f,c){const h=c.shift();if(c.length===0){delete f[h];return}if(Object.keys(f).indexOf(h)!==-1){const m=f[h];typeof m=="object"&&!Array.isArray(m)&&(l(m,c),Object.keys(m).length===0&&delete f[h])}}function d(f,c,h){function m(a,n){let i=a;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const S=c.split("."),s=m(f,S);return typeof s>"u"?h:s}e.$ri=d;function p(f,c,h){Object.keys(c).forEach(m=>{m!=="__proto__"&&(m in f?I.$Af(f[m])&&I.$Af(c[m])?p(f[m],c[m],h):h&&(f[m]=c[m]):f[m]=c[m])})}e.$si=p;function y(f){return f.replace(/[\[\]]/g,"")}e.$ti=y}),define(oe[94],ae([0,1,5,27,179,4,150,8]),function(te,e,I,L,A,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",I.$k),k.set("isLinux",I.$l),k.set("isWindows",I.$j),k.set("isWeb",I.$p),k.set("isMacNative",I.$k&&!I.$p),k.set("isEdge",I.$H),k.set("isFirefox",I.$F),k.set("isChrome",I.$E),k.set("isSafari",I.$G);function g(B,P){if(k.get(B)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(B,P)}e.$Li=g;const C=Object.prototype.hasOwnProperty;var E;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const b={regexParsingWithErrorRecovery:!0},l=(0,D.localize)(0,null),d=(0,D.localize)(1,null),p=(0,D.localize)(2,null),y=(0,D.localize)(3,null),f=(0,D.localize)(4,null),c=(0,D.localize)(5,null),h=(0,D.localize)(6,null),m=(0,D.localize)(7,null);class S{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=b){this.k=P,this.d=new A.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const O=this.l();if(!this.E()){const T=this.D(),F=T.type===17?c:void 0;throw this.h.push({message:f,offset:T.offset,lexeme:A.$Ki.getLexeme(T),additionalInfo:F}),S.c}return O}catch(O){if(O!==S.c)throw O;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const O=this.o();P.push(O)}return P.length===1?P[0]:s.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const O=this.s();P.push(O)}return P.length===1?P[0]:s.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const O=this.l();return this.A(1,y),O?.negate()}case 17:return this.z(),j.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const O=this.l();return this.A(1,y),O}case 17:{const O=P.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const V=F.lexeme,G=V.lastIndexOf("/"),re=G===V.length-1?void 0:this.w(V.substring(G+1));let ce;try{ce=new RegExp(V.substring(1,G),re)}catch{throw this.B("REGEX",F)}return X.create(O,ce)}switch(F.type){case 10:case 19:{const V=[F.lexeme];this.z();let G=this.D(),re=0;for(let de=0;de<F.lexeme.length;de++)F.lexeme.charCodeAt(de)===40?re++:F.lexeme.charCodeAt(de)===41&&re--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let de=0;de<G.lexeme.length;de++)G.lexeme.charCodeAt(de)===40?re++:F.lexeme.charCodeAt(de)===41&&re--}if(re<0)break;V.push(A.$Ki.getLexeme(G)),this.z(),G=this.D()}const ce=V.join(""),ue=ce.lastIndexOf("/"),he=ue===ce.length-1?void 0:this.w(ce.substring(ue+1));let $e;try{$e=new RegExp(ce.substring(1,ue),he)}catch{throw this.B("REGEX",F)}return s.regex(O,$e)}case 18:{const V=F.lexeme;this.z();let G=null;if(!(0,L.$Be)(V)){const re=V.indexOf("/"),ce=V.lastIndexOf("/");if(re!==ce&&re>=0){const ue=V.slice(re+1,ce),he=V[ce+1]==="i"?"i":"";try{G=new RegExp(ue,he)}catch{throw this.B("REGEX",F)}}}if(G===null)throw this.B("REGEX",F);return X.create(O,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const F=this.u();return s.notIn(O,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return s.equals(O,F);switch(F){case"true":return s.has(O);case"false":return s.not(O);default:return s.equals(O,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return s.notEquals(O,F);switch(F){case"true":return s.not(O);case"false":return s.has(O);default:return s.notEquals(O,F)}}case 5:return this.z(),q.create(O,this.u());case 6:return this.z(),Z.create(O,this.u());case 7:return this.z(),U.create(O,this.u());case 8:return this.z(),z.create(O,this.u());case 13:return this.z(),s.in(O,this.u());default:return s.has(O)}}case 20:throw this.h.push({message:h,offset:P.offset,lexeme:"",additionalInfo:m}),S.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,O){if(this.C(P))return this.z();throw this.B(O,this.D())}B(P,O,T){const F=(0,D.localize)(8,null,P,A.$Ki.getLexeme(O)),V=O.offset,G=A.$Ki.getLexeme(O);return this.h.push({message:F,offset:V,lexeme:G,additionalInfo:T}),S.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=S;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(P){return o.create(P)}static equals(P,O){return v.create(P,O)}static notEquals(P,O){return $.create(P,O)}static regex(P,O){return X.create(P,O)}static in(P,O){return w.create(P,O)}static notIn(P,O){return u.create(P,O)}static not(P){return j.create(P)}static and(...P){return Q.create(P,null,!0)}static or(...P){return J.create(P,null,!0)}static greater(P,O){return U.create(P,O)}static greaterEquals(P,O){return z.create(P,O)}static smaller(P,O){return q.create(P,O)}static smallerEquals(P,O){return Z.create(P,O)}static{this.c=new S({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.$Ni=s;function a(B){const P=new S({regexParsingWithErrorRecovery:!1});return B.map(O=>(P.parse(O),P.lexingErrors.length>0?P.lexingErrors.map(T=>({errorMessage:T.additionalInfo?(0,D.localize)(9,null,T.additionalInfo):(0,D.localize)(10,null),offset:T.offset,length:T.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(T=>({errorMessage:T.additionalInfo?`${T.message}. ${T.additionalInfo}`:T.message,offset:T.offset,length:T.lexeme.length})):[]))}e.$Oi=a;function n(B,P){const O=B?B.substituteConstants():void 0,T=P?P.substituteConstants():void 0;return!O&&!T?!0:!O||!T?!1:O.equals(T)}e.$Pi=n;function i(B,P){return B.cmp(P)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.$Qi=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return t.INSTANCE}}e.$Ri=r;class o{static create(P,O=null){const T=k.get(P);return typeof T=="boolean"?T?r.INSTANCE:t.INSTANCE:new o(P,O)}constructor(P,O){this.key=P,this.c=O,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=k.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:t.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Si=o;class v{static create(P,O,T=null){if(typeof O=="boolean")return O?o.create(P,T):j.create(P,T);const F=k.get(P);return typeof F=="boolean"?O===(F?"true":"false")?r.INSTANCE:t.INSTANCE:new v(P,O,T)}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=k.get(this.c);if(typeof P=="boolean"){const O=P?"true":"false";return this.d===O?r.INSTANCE:t.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=$.create(this.c,this.d,this)),this.f}}e.$Ti=v;class w{static create(P,O){return new w(P,O)}constructor(P,O){this.d=P,this.f=O,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const O=P.getValue(this.f),T=P.getValue(this.d);return Array.isArray(O)?O.includes(T):typeof T=="string"&&typeof O=="object"&&O!==null?C.call(O,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$Ui=w;class u{static create(P,O){return new u(P,O)}constructor(P,O){this.d=P,this.f=O,this.type=11,this.c=w.create(P,O)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=u;class ${static create(P,O,T=null){if(typeof O=="boolean")return O?j.create(P,T):o.create(P,T);const F=k.get(P);return typeof F=="boolean"?O===(F?"true":"false")?t.INSTANCE:r.INSTANCE:new $(P,O,T)}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=k.get(this.c);if(typeof P=="boolean"){const O=P?"true":"false";return this.d===O?t.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Wi=$;class j{static create(P,O=null){const T=k.get(P);return typeof T=="boolean"?T?t.INSTANCE:r.INSTANCE:new j(P,O)}constructor(P,O){this.c=P,this.d=O,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=k.get(this.c);return typeof P=="boolean"?P?t.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.$Xi=j;function M(B,P){if(typeof B=="string"){const O=parseFloat(B);isNaN(O)||(B=O)}return typeof B=="string"||typeof B=="number"?P(B):t.INSTANCE}class U{static create(P,O,T=null){return M(O,F=>new U(P,F,T))}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Yi=U;class z{static create(P,O,T=null){return M(O,F=>new z(P,F,T))}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Zi=z;class q{static create(P,O,T=null){return M(O,F=>new q(P,F,T))}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$1i=q;class Z{static create(P,O,T=null){return M(O,F=>new Z(P,F,T))}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$2i=Z;class X{static create(P,O){return new X(P,O)}constructor(P,O){this.d=P,this.f=O,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const O=this.f?this.f.source:"",T=P.f?P.f.source:"";return O<T?-1:O>T?1:0}equals(P){if(P.type===this.type){const O=this.f?this.f.source:"",T=P.f?P.f.source:"";return this.d===P.d&&O===T}return!1}substituteConstants(){return this}evaluate(P){const O=P.getValue(this.d);return this.f?this.f.test(O):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$3i=X;class x{static create(P){return new x(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new x(this.c.map(P))}negate(){return this.c}}e.$4i=x;function H(B){let P=null;for(let O=0,T=B.length;O<T;O++){const F=B[O].substituteConstants();if(B[O]!==F&&P===null){P=[];for(let V=0;V<O;V++)P[V]=B[V]}P!==null&&(P[O]=F)}return P===null?B:P}class Q{static create(P,O,T){return Q.d(P,O,T)}constructor(P,O){this.expr=P,this.c=O,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let O=0,T=this.expr.length;O<T;O++){const F=i(this.expr[O],P.expr[O]);if(F!==0)return F}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let O=0,T=this.expr.length;O<T;O++)if(!this.expr[O].equals(P.expr[O]))return!1;return!0}return!1}substituteConstants(){const P=H(this.expr);return P===this.expr?this:Q.create(P,this.c,!1)}evaluate(P){for(let O=0,T=this.expr.length;O<T;O++)if(!this.expr[O].evaluate(P))return!1;return!0}static d(P,O,T){const F=[];let V=!1;for(const G of P)if(G){if(G.type===1){V=!0;continue}if(G.type===0)return t.INSTANCE;if(G.type===6){F.push(...G.expr);continue}F.push(G)}if(F.length===0&&V)return r.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(i);for(let G=1;G<F.length;G++)F[G-1].equals(F[G])&&(F.splice(G,1),G--);if(F.length===1)return F[0];for(;F.length>1;){const G=F[F.length-1];if(G.type!==9)break;F.pop();const re=F.pop(),ce=F.length===0,ue=J.create(G.expr.map(he=>Q.create([he,re],null,T)),null,ce);ue&&(F.push(ue),F.sort(i))}if(F.length===1)return F[0];if(T){for(let G=0;G<F.length;G++)for(let re=G+1;re<F.length;re++)if(F[G].negate().equals(F[re]))return t.INSTANCE;if(F.length===1)return F[0]}return new Q(F,O)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const O of this.expr)P.push(...O.keys());return P}map(P){return new Q(this.expr.map(O=>O.map(P)),null)}negate(){if(!this.c){const P=[];for(const O of this.expr)P.push(O.negate());this.c=J.create(P,this,!0)}return this.c}}e.$5i=Q;class J{static create(P,O,T){return J.d(P,O,T)}constructor(P,O){this.expr=P,this.c=O,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let O=0,T=this.expr.length;O<T;O++){const F=i(this.expr[O],P.expr[O]);if(F!==0)return F}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let O=0,T=this.expr.length;O<T;O++)if(!this.expr[O].equals(P.expr[O]))return!1;return!0}return!1}substituteConstants(){const P=H(this.expr);return P===this.expr?this:J.create(P,this.c,!1)}evaluate(P){for(let O=0,T=this.expr.length;O<T;O++)if(this.expr[O].evaluate(P))return!0;return!1}static d(P,O,T){let F=[],V=!1;if(P){for(let G=0,re=P.length;G<re;G++){const ce=P[G];if(ce){if(ce.type===0){V=!0;continue}if(ce.type===1)return r.INSTANCE;if(ce.type===9){F=F.concat(ce.expr);continue}F.push(ce)}}if(F.length===0&&V)return t.INSTANCE;F.sort(i)}if(F.length!==0){if(F.length===1)return F[0];for(let G=1;G<F.length;G++)F[G-1].equals(F[G])&&(F.splice(G,1),G--);if(F.length===1)return F[0];if(T){for(let G=0;G<F.length;G++)for(let re=G+1;re<F.length;re++)if(F[G].negate().equals(F[re]))return r.INSTANCE;if(F.length===1)return F[0]}return new J(F,O)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const O of this.expr)P.push(...O.keys());return P}map(P){return new J(this.expr.map(O=>O.map(P)),null)}negate(){if(!this.c){const P=[];for(const O of this.expr)P.push(O.negate());for(;P.length>1;){const O=P.shift(),T=P.shift(),F=[];for(const V of K(O))for(const G of K(T))F.push(Q.create([V,G],null,!1));P.unshift(J.create(F,null,!1))}this.c=J.create(P,this,!0)}return this.c}}e.$6i=J;class W extends o{static{this.d=[]}static all(){return W.d.values()}constructor(P,O,T){super(P,null),this.f=O,typeof T=="object"?W.d.push({...T,key:P}):T!==!0&&W.d.push({key:P,description:T,type:O!=null?typeof O:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return v.create(this.key,P)}notEqualsTo(P){return $.create(this.key,P)}}e.$7i=W,e.$8i=(0,N.$Ph)("contextKeyService");function ee(B,P){return B<P?-1:B>P?1:0}function ne(B,P,O,T){return B<O?-1:B>O?1:P<T?-1:P>T?1:0}function _(B,P){if(B.type===0||P.type===1)return!0;if(B.type===9)return P.type===9?ie(B.expr,P.expr):!1;if(P.type===9){for(const O of P.expr)if(_(B,O))return!0;return!1}if(B.type===6){if(P.type===6)return ie(P.expr,B.expr);for(const O of B.expr)if(_(O,P))return!0;return!1}return B.equals(P)}e.$9i=_;function ie(B,P){let O=0,T=0;for(;O<B.length&&T<P.length;){const F=B[O].cmp(P[T]);if(F<0)return!1;F===0&&O++,T++}return O===B.length}function K(B){return B.type===9?B.expr:[B]}}),define(oe[95],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.ID=void 0,e.ID="diagnosticsService",e.$qm=(0,I.$Ph)(e.ID);function L(N){return!!N.hostName&&!!N.errorMessage}e.$rm=L;class A{async getPerformanceInfo(D,R){return{}}async getSystemInfo(D,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,R){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$sm=A}),define(oe[96],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$On=(0,I.$Ph)("downloadService")}),define(oe[14],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,I.$Ph)("environmentService"),e.$Xh=(0,I.$Qh)(e.$Wh)}),define(oe[29],ae([0,1,153,4]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$$n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function A(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=A;function N(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=N;function D(c,h){switch(c){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=D;function R(c,h){return h==="web"&&!c.includes("web")}e.$7n=R;function k(c,h,m){return R(h,m)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===m?!0:g(m).includes(c)}e.$8n=k;function g(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$9n=g;function C(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$0n=C;var E;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var b;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var l;(function(c){c.Install="install",c.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var d;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$$n=(0,L.$Ph)("extensionGalleryService");var p;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var y;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class f extends Error{constructor(h,m){super(h),this.code=m,this.name=m}}e.$_n=f,e.$ao=(0,L.$Ph)("extensionManagementService"),e.$bo="extensionsIdentifiers/disabled",e.$co="extensionsIdentifiers/enabled",e.$do=(0,L.$Ph)("IGlobalExtensionEnablementService"),e.$eo=(0,L.$Ph)("IExtensionTipsService"),e.$fo=(0,I.localize)(0,null),e.$go={value:e.$fo,original:"Extensions"},e.$ho={value:(0,I.localize)(1,null),original:"Preferences"}}),define(oe[188],ae([0,1,3,2,30,10,92,29]),function(te,e,I,L,A,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=void 0;function k(y,f){return y?N.URI.revive(f?f.transformIncoming(y):y):void 0}function g(y,f){return f?f.transformOutgoingURI(y):y}function C(y,f){f=f||D.$Mm;const c=y.manifest;return{...(0,D.$Pm)({...y,manifest:void 0},f),manifest:c}}function E(y,f){return y?.profileLocation?(0,D.$Pm)(y,f??D.$Mm):y}function b(y,f){return f?(0,A.$9m)(y,c=>c instanceof N.URI?f.transformOutgoingURI(c):void 0):y}class l{constructor(f,c){this.a=f,this.b=c,this.onInstallExtension=I.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,c){const h=this.b(f);switch(c){case"onInstallExtension":return I.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?g(m.profileLocation,h):m.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,m=>m.map(S=>({...S,local:S.local?b(S.local,h):S.local,profileLocation:S.profileLocation?g(S.profileLocation,h):S.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?g(m.profileLocation,h):m.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?g(m.profileLocation,h):m.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,m=>b(m,h))}throw new Error("Invalid listen")}async call(f,c,h){const m=this.b(f);switch(c){case"zip":{const S=C(h[0],m),s=await this.a.zip(S);return g(s,m)}case"unzip":return this.a.unzip(k(h[0],m));case"install":return this.a.install(k(h[0],m),E(h[1],m));case"installFromLocation":return this.a.installFromLocation(k(h[0],m),k(h[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],k(h[1],m),k(h[2],m));case"getManifest":return this.a.getManifest(k(h[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],E(h[1],m));case"installGalleryExtensions":{const S=h[0];return this.a.installGalleryExtensions(S.map(({extension:s,options:a})=>({extension:s,options:E(a,m)??{}})))}case"uninstall":return this.a.uninstall(C(h[0],m),E(h[1],m));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(h[0],m));case"getInstalled":return(await this.a.getInstalled(h[0],k(h[1],m))).map(s=>b(s,m));case"toggleAppliationScope":{const S=await this.a.toggleAppliationScope(C(h[0],m),k(h[1],m));return b(S,m)}case"copyExtensions":return this.a.copyExtensions(k(h[0],m),k(h[1],m));case"updateMetadata":{const S=await this.a.updateMetadata(C(h[0],m),h[1],k(h[2],m));return b(S,m)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$ip=l;class d extends L.$Sc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new I.$Nd),this.f=this.B(new I.$Nd),this.g=this.B(new I.$Nd),this.h=this.B(new I.$Nd),this.j=this.B(new I.$Nd),this.B(this.m.listen("onInstallExtension")(c=>this.n(this.c,{...c,source:this.r(c.source)?N.URI.revive(c.source):c.source,profileLocation:N.URI.revive(c.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(c=>this.n(this.f,c.map(h=>({...h,local:h.local?C(h.local,null):h.local,source:this.r(h.source)?N.URI.revive(h.source):h.source,profileLocation:N.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(c=>this.n(this.g,{...c,profileLocation:N.URI.revive(c.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(c=>this.n(this.h,{...c,profileLocation:N.URI.revive(c.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(c=>this.j.fire(C(c,null))))}n(f,c){f.fire(c)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const c=await this.getTargetPlatform();return f.allTargetPlatforms.some(h=>(0,R.$8n)(h,f.allTargetPlatforms,c))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(c=>N.URI.revive(c)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,c){return Promise.resolve(this.m.call("install",[f,c])).then(h=>C(h,null))}installFromLocation(f,c){return Promise.resolve(this.m.call("installFromLocation",[f,c])).then(h=>C(h,null))}async installExtensionsFromProfile(f,c,h){return(await this.m.call("installExtensionsFromProfile",[f,c,h])).map(S=>C(S,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,c){return Promise.resolve(this.m.call("installFromGallery",[f,c])).then(h=>C(h,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(h=>({...h,local:h.local?C(h.local,null):h.local,source:this.r(h.source)?N.URI.revive(h.source):h.source,profileLocation:N.URI.revive(h.profileLocation)}))}uninstall(f,c){return Promise.resolve(this.m.call("uninstall",[f,c]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(c=>C(c,null))}getInstalled(f=null,c){return Promise.resolve(this.m.call("getInstalled",[f,c])).then(h=>h.map(m=>C(m,null)))}updateMetadata(f,c,h){return Promise.resolve(this.m.call("updateMetadata",[f,c,h])).then(m=>C(m,null))}toggleAppliationScope(f,c){return this.m.call("toggleAppliationScope",[f,c]).then(h=>C(h,null))}copyExtensions(f,c){return this.m.call("copyExtensions",[f,c])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,c,h){const m=await this.m.call("download",[f,c,h]);return N.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$jp=d;class p{constructor(f){this.a=f}listen(f,c){throw new Error("Invalid listen")}call(f,c,h){switch(c){case"getConfigBasedTips":return this.a.getConfigBasedTips(N.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$kp=p}),define(oe[97],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=void 0,e.$fp=(0,I.$Ph)("IExtensionSignatureVerificationService");class L{b(){return this.a||(this.a=new Promise((N,D)=>te(["node-vsce-sign"],async R=>N(R),D))),this.a}async verify(N,D,R){let k;try{k=await this.b()}catch{return!1}return k.verify(N,D,R)}}e.$gp=L}),define(oe[98],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HVb=e.RecommendationsNotificationResult=e.$GVb=e.RecommendationSource=void 0;var L;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(L||(e.RecommendationSource=L={}));function A(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$GVb=A;var N;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(N||(e.RecommendationsNotificationResult=N={})),e.$HVb=(0,I.$Ph)("IExtensionRecommendationNotificationService")}),define(oe[11],ae([0,1,47,16,27,12,10,160,4,5,23,60]),function(te,e,I,L,A,N,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,k.$Ph)("fileService");function b(_){return _.create===!0}e.$_j=b;var l;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var d;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function p(_){const ie=_;return!!ie&&typeof ie.onDidChange=="function"}e.$ak=p;var y;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function f(_){return!!(_.capabilities&2)}e.$bk=f;function c(_){return!!(_.capabilities&8)}e.$ck=c;function h(_){return!!(_.capabilities&131072)}e.$dk=h;function m(_){return!!(_.capabilities&4)}e.$ek=m;function S(_){return!!(_.capabilities&16)}e.$fk=S;function s(_){return f(_)?!!(_.capabilities&16384):!1}e.$gk=s;function a(_){return f(_)?!!(_.capabilities&32768):!1}e.$hk=a;function n(_){return!!(_.capabilities&65536)}e.$ik=n;function i(_){return!!(_.capabilities&2048)}e.$jk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ie,K){const B=new r(ie.toString(),K);return w(B,K),B}constructor(ie,K){super(ie),this.code=K}}e.$kk=r;function o(_,ie){return r.create(_,ie)}e.$lk=o;function v(_){return _||o((0,R.localize)(0,null),t.Unknown)}e.$mk=v;function w(_,ie){return _.name=ie?`${ie} (FileSystemError)`:"FileSystemError",_}e.$nk=w;function u(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const ie=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ie)return t.Unknown;switch(ie[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$ok=u;function $(_){if(_ instanceof Z)return _.fileOperationResult;switch(u(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$pk=$;var j;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class M{constructor(ie,K,B){this.resource=ie,this.operation=K,this.target=B}isOperation(ie){return this.operation===ie}}e.$qk=M;var U;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class z{static{this.a=null}constructor(ie,K){this.c=K,this.b=void 0,this.d=new E.$V(()=>{const B=I.$Vh.forUris(()=>this.c);return B.fill(this.rawAdded.map(P=>[P,!0])),B}),this.f=new E.$V(()=>{const B=I.$Vh.forUris(()=>this.c);return B.fill(this.rawUpdated.map(P=>[P,!0])),B}),this.g=new E.$V(()=>{const B=I.$Vh.forUris(()=>this.c);return B.fill(this.rawDeleted.map(P=>[P,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of ie){switch(B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}this.b!==z.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(ie,...K){return this.h(ie,{includeChildren:!1},...K)}affects(ie,...K){return this.h(ie,{includeChildren:!0},...K)}h(ie,K,...B){if(!ie)return!1;const P=B.length>0;return!!((!P||B.includes(1))&&(this.d.value.get(ie)||K.includeChildren&&this.d.value.findSuperstr(ie))||(!P||B.includes(0))&&(this.f.value.get(ie)||K.includeChildren&&this.f.value.findSuperstr(ie))||(!P||B.includes(2))&&(this.g.value.findSubstr(ie)||K.includeChildren&&this.g.value.findSuperstr(ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ie){return this.b===ie}hasCorrelation(){return typeof this.b=="number"}}e.$rk=z;function q(_,ie,K){return!_||!ie||_===ie||ie.length>_.length?!1:(ie.charAt(ie.length-1)!==L.sep&&(ie+=L.sep),K?(0,A.$3e)(_,ie):_.indexOf(ie)===0)}e.$sk=q;class Z extends Error{constructor(ie,K,B){super(ie),this.fileOperationResult=K,this.options=B}}e.$tk=Z;class X extends Z{constructor(ie,K,B,P){super(ie,K,P),this.fileOperationResult=K,this.size=B}}e.$uk=X;class x extends Z{constructor(ie,K,B){super(ie,2,B),this.stat=K}}e.$vk=x;var H;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var Q;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Dk="";function J(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Ek=J;async function W(_,ie){if(!ie.hasProvider(D.URI.from({scheme:_.scheme})))return new Promise(K=>{const B=ie.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===_.scheme&&P.added&&(B.dispose(),K())})})}e.$Fk=W;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ie){return(0,N.$Cf)(ie)||(ie=0),ie<ee.KB?(0,R.localize)(1,null,ie.toFixed(0)):ie<ee.MB?(0,R.localize)(2,null,(ie/ee.KB).toFixed(2)):ie<ee.GB?(0,R.localize)(3,null,(ie/ee.MB).toFixed(2)):ie<ee.TB?(0,R.localize)(4,null,(ie/ee.GB).toFixed(2)):(0,R.localize)(5,null,(ie/ee.TB).toFixed(2))}}e.$Gk=ee;function ne(_){const ie=typeof _=="string"||_?.scheme===C.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===C.Schemas.file?1024*ee.MB:ie?10*ee.MB:g.$p?50*ee.MB:1024*ee.MB}e.$Hk=ne});var Y=this&&this.__param||function(te,e){return function(I,L){e(I,L,te)}};define(oe[189],ae([0,1,70,46,11]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J8b=void 0;let N=class{constructor(R){this.a=R}async checksum(R){const k=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const E=(0,I.createHash)("md5");(0,L.$6d)(k,{onData:b=>E.update(b.buffer),onError:b=>C(b),onEnd:()=>g(E.digest("base64").replace(/=+$/,""))})})}};e.$J8b=N,e.$J8b=N=ye([Y(0,A.$$j)],N)}),define(oe[99],ae([0,1,15,8,161,11]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;async function D(C,E,b,l,d,p){let y;try{await R(C,E,b,l,d,p)}catch(f){y=f}finally{y&&d.errorTransformer&&(y=d.errorTransformer(y)),typeof y<"u"&&b.error(y),b.end()}}e.$Np=D;async function R(C,E,b,l,d,p){k(p);const y=await C.open(E,{create:!1});try{k(p);let f=0,c=0,h=d&&typeof d.length=="number"?d.length:void 0,m=I.$be.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),S=d&&typeof d.position=="number"?d.position:0,s=0;do c=await C.read(y,S,m.buffer,s,m.byteLength-s),S+=c,s+=c,f+=c,typeof h=="number"&&(h-=c),s===m.byteLength&&(await b.write(l(m)),m=I.$be.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),s=0);while(c>0&&(typeof h!="number"||h>0)&&k(p)&&g(f,d));if(s>0){let a=s;typeof h=="number"&&(a=Math.min(s,h)),b.write(l(m.slice(0,a)))}}catch(f){throw(0,N.$mk)(f)}finally{await C.close(y)}}function k(C){if(C.isCancellationRequested)throw(0,L.$6)();return!0}function g(C,E){if(typeof E?.limits?.size=="number"&&C>E.limits.size)throw(0,N.$lk)((0,A.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[49],ae([0,1,91,2,16,5,10,11]),function(te,e,I,L,A,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=e.$Qp=e.$Pp=void 0;function k(f){return f.recursive===!0}e.$Pp=k;class g extends L.$Sc{static{this.a=5}constructor(c,h,m,S){super(),this.h=c,this.j=h,this.m=m,this.n=S,this.c=this.B(new L.$Tc),this.f=void 0,this.g=0}s(){const c=new L.$Rc;this.c.value=c,this.b=this.r(c),this.b.setVerboseLogging(this.m),c.add(this.b.onDidChangeFile(h=>this.h(h))),c.add(this.b.onDidLogMessage(h=>this.j(h))),c.add(this.b.onDidError(h=>this.t(h)))}t(c){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${c}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${c}`):this.w(c)}u(c){this.g++,this.s(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.m=c,await this.b?.setVerboseLogging(c)}w(c){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${c}`})}y(c){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Qp=g;class C extends g{constructor(c,h,m){super(c,h,m,{type:"node.js",restartOnError:!1})}}e.$Rp=C;class E extends g{constructor(c,h,m){super(c,h,m,{type:"universal",restartOnError:!0})}}e.$Sp=E;function b(f){return f.map(c=>({type:c.type,resource:D.URI.revive(c.resource),cId:c.cId}))}e.$Tp=b;function l(f){const c=new y;for(const h of f)c.processEvent(h);return c.coalesce()}e.$Up=l;function d(f,c){return typeof c=="string"&&!c.startsWith(I.$sj)&&!(0,A.$ic)(c)?{base:f,pattern:c}:c}e.$Vp=d;function p(f,c){const h=[];for(const m of c)h.push((0,I.$wj)(d(f,m)));return h}e.$Wp=p;class y{constructor(){this.a=new Set,this.b=new Map}c(c){return N.$l?c.resource.fsPath:c.resource.fsPath.toLowerCase()}processEvent(c){const h=this.b.get(this.c(c));let m=!1;if(h){const S=h.type,s=c.type;h.resource.fsPath!==c.resource.fsPath&&(c.type===2||c.type===1)?m=!0:S===1&&s===2?(this.b.delete(this.c(c)),this.a.delete(h)):S===2&&s===1?h.type=0:S===1&&s===0||(h.type=s)}else m=!0;m&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],h=[];return Array.from(this.a).filter(m=>m.type!==2?(c.push(m),!1):!0).sort((m,S)=>m.resource.fsPath.length-S.resource.fsPath.length).filter(m=>h.some(S=>(0,R.$sk)(m.resource.fsPath,S,!N.$l))?!1:(h.push(m.resource.fsPath),!0)).concat(c)}}}),define(oe[190],ae([0,1,15,38,8,3,2,46,32,11,49]),function(te,e,I,L,A,N,D,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.$mN=void 0,e.$mN="localFilesystem";class E extends D.$Sc{constructor(l,d){super(),this.a=l,this.b=d,this.onDidChangeCapabilities=N.Event.None,this.f=this.B(new N.$Nd),this.onDidChangeFile=this.f.event,this.g=this.B(new N.$Nd),this.onDidWatchError=this.g.event,this.h=(0,k.$eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,d){const{buffer:p}=await this.a.call("readFile",[l,d]);return p}readFileStream(l,d,p){const y=(0,R.$2d)(c=>I.$be.concat(c.map(h=>I.$be.wrap(h))).buffer),f=new D.$Rc;return f.add(this.a.listen("readFileStream",[l,d])(c=>{if(c instanceof I.$be)y.write(c.buffer);else{if(c==="end")y.end();else{let h;if(c instanceof Error)h=c;else{const m=c;h=(0,g.$lk)(m.message??(0,L.$Ai)(m),m.code??g.FileSystemProviderErrorCode.Unknown)}y.error(h),y.end()}f.dispose()}})),f.add(p.onCancellationRequested(()=>{y.error((0,A.$6)()),y.end(),f.dispose()})),y}writeFile(l,d,p){return this.a.call("writeFile",[l,I.$be.wrap(d),p])}open(l,d){return this.a.call("open",[l,d])}close(l){return this.a.call("close",[l])}async read(l,d,p,y,f){const[c,h]=await this.a.call("read",[l,d,f]);return p.set(c.buffer.slice(0,h),y),h}write(l,d,p,y,f){return this.a.call("write",[l,d,I.$be.wrap(p),y,f])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,d){return this.a.call("delete",[l,d])}rename(l,d,p){return this.a.call("rename",[l,d,p])}copy(l,d,p){return this.a.call("copy",[l,d,p])}cloneFile(l,d){return this.a.call("cloneFile",[l,d])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const d=l;this.f.fire((0,C.$Tp)(d))}else{const d=l;this.g.fire(d)}}))}watch(l,d){const p=(0,k.$eg)();return this.a.call("watch",[this.h,p,l,d]),(0,D.$Qc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$nN=E}),define(oe[191],ae([0,1,53,6,26,48,2,88,16,5,19,10,144,31,49]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class p extends D.$Sc{static{this.a=100}static{this.b=75}constructor(c,h,m,S){super(),this.m=c,this.n=h,this.r=m,this.s=S,this.c=this.B(new L.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new L.$8g(s=>this.z(s),p.b)),this.g=(0,d.$Wp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,d.$Wp)(this.m.path,this.m.includes):void 0,this.j=new A.$Xd,this.ready=this.t()}async t(){try{const c=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await l.Promises.stat(c);this.B(await this.w(c,h.isDirectory()))}catch(c){c.code!=="ENOENT"?this.D(c):this.G(c)}}async u(c){let h=c.path;try{h=await l.Promises.realpath(c.path),c.path===h&&(h=await(0,b.$7p)(c.path)??c.path),c.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${h})`)}catch{}return h}async w(c,h){if(g.$k&&(0,N.$Xf)(c,"/Volumes/",!0))return this.D(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Sc.None;const m=new A.$Xd(this.j.token),S=new D.$Rc;try{const s=E.URI.file(this.m.path),a=(0,k.$nc)(c),n=(0,I.watch)(c);S.add((0,D.$Qc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${c}'`);const i=new Set;if(h)try{for(const r of await l.Promises.readdir(c))i.add(r)}catch(r){this.D(r)}const t=new Map;S.add((0,D.$Qc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,o)=>{this.D(`Failed to watch ${c} for changes using fs.watch() (${r}, ${o})`),this.dispose()}),n.on("change",(r,o)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${o}`);let v="";if(o&&(v=o.toString(),g.$k&&(v=(0,R.$ol)(v))),!(!v||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){t.get(v)?.dispose();const w=setTimeout(async()=>{if(t.delete(v),v===a&&!await l.Promises.exists(c)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.C((0,k.$jc)(c,v));if(m.token.isCancellationRequested)return;let $;u?i.has(v)?$=0:($=1,i.add(v)):(i.delete(v),$=2),this.y({resource:(0,C.$vg)(s,v),type:$,cId:this.m.correlationId})},p.a);t.set(v,(0,D.$Qc)(()=>clearTimeout(w)))}else{let w;i.has(v)?w=0:(w=1,i.add(v)),this.y({resource:(0,C.$vg)(s,v),type:w,cId:this.m.correlationId})}else if(r==="rename"||v!==a){const w=setTimeout(async()=>{const u=await l.Promises.exists(c);m.token.isCancellationRequested||(u?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),S.add(await this.w(c,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);S.clear(),S.add((0,D.$Qc)(()=>clearTimeout(w)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await l.Promises.exists(c)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${c} for changes using fs.watch() (${s.toString()})`)}return(0,D.$Qc)(()=>{m.dispose(!0),S.dispose()})}y(c,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`),!h&&this.g.some(m=>m(c.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${c.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(m=>m(c.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${c.resource.fsPath}`):this.f.work(c))}z(c){const h=(0,d.$Up)(c);if(h.length>0){if(this.s)for(const S of h)this.G(` >> normalized ${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(c){if(g.$l)return l.Promises.exists(c);try{const h=(0,k.$nc)(c);return(await l.Promises.readdir((0,k.$mc)(c))).some(S=>S===h)}catch(h){return this.G(h),!1}}setVerboseLogging(c){this.s=c}D(c){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}F(c){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}G(c){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$0p=p;async function y(f,c,h,m,S=512){const s=await l.Promises.open(f,"r"),a=Buffer.allocUnsafe(S),n=new A.$Xd(m);let i,t=!1;const r={path:f,excludes:[],recursive:!1},o=new p(r,v=>{(async()=>{for(const{type:w}of v)if(w===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:u}=await l.Promises.read(s,a,0,S,null);if(!u||n.token.isCancellationRequested)break;c(a.slice(0,u))}}catch(u){i=new Error(u),n.dispose(!0)}finally{t=!1}}})()});return await o.ready,h(),new Promise((v,w)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await l.Promises.close(s)}catch(u){i=new Error(u)}i?w(i):v()})})}e.$$p=y}),define(oe[192],ae([0,1,3,91,2,5,191]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class R extends A.$Sc{constructor(){super(...arguments),this.a=this.B(new I.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.j(g),E=C.filter(l=>{const d=this.c.get(l.path);return d?!(0,L.$Aj)(d.request.excludes,l.excludes)||!(0,L.$Aj)(d.request.includes,l.includes):!0}),b=Array.from(this.c.values()).filter(({request:l})=>!C.find(d=>d.path===l.path&&(0,L.$Aj)(d.excludes,l.excludes)&&(0,L.$Aj)(d.includes,l.includes))).map(({request:l})=>l.path);E.length&&this.m(`Request to start watching: ${E.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const l of b)this.h(l);for(const l of E)this.g(l)}g(g){const C=new D.$0p(g,b=>this.a.fire(b),b=>this.b.fire(b),this.f),E={request:g,instance:C};this.c.set(g.path,E)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}j(g){const C=new Map;for(const E of g){const b=N.$l?E.path:E.path.toLowerCase();let l=C.get(E.correlationId);l||(l=new Map,C.set(E.correlationId,l)),l.set(b,E)}return Array.from(C.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$_p=R}),define(oe[193],ae([0,1,49,192]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;class A extends I.$Rp{constructor(D,R,k){super(D,R,k),this.s()}r(D){return D.add(new L.$_p)}}e.$aq=A}),define(oe[194],ae([0,1,23,42,93,49]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;class D extends N.$Sp{constructor(k,g,C){super(k,g,C),this.s()}r(k){const g=k.add(new A.$4p(I.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(g.onDidProcessExit(({code:C,signal:E})=>this.t(`terminated by itself with code ${C}, signal: ${E}`))),L.ProxyChannel.toService((0,L.$wh)(g.getChannel("watcher")))}}e.$5p=D}),define(oe[71],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class I{constructor(...A){this.a=new Map;for(const[N,D]of A)this.set(N,D)}set(A,N){const D=this.a.get(A);return this.a.set(A,N),D}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Nh=I}),define(oe[195],ae([0,1,6,8,2,69,186,4,71,87]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;const C=!1;class E extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class b{constructor(y=new k.$Nh,f=!1,c,h=C){this.f=y,this.g=f,this.h=c,this.i=h,this.o=new Set,this.f.set(R.$Oh,this),this._globalGraph=h?c?._globalGraph??new D.$dq(m=>m):void 0}createChild(y){return new b(y,this.g,this,this.i)}invokeFunction(y,...f){const c=d.traceInvocation(this.i,y);let h=!1;try{return y({get:S=>{if(h)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(S,c);if(!s)throw new Error(`[invokeFunction] unknown service '${S}'`);return s}},...f)}finally{h=!0,c.stop()}}createInstance(y,...f){let c,h;return y instanceof N.$Mh?(c=d.traceCreation(this.i,y.ctor),h=this.j(y.ctor,y.staticArguments.concat(f),c)):(c=d.traceCreation(this.i,y),h=this.j(y,f,c)),c.stop(),h}j(y,f=[],c){const h=R._util.getServiceDependencies(y).sort((s,a)=>s.index-a.index),m=[];for(const s of h){const a=this.m(s.id,c);a||this.u(`[createInstance] ${y.name} depends on UNKNOWN service ${s.id}.`,!1),m.push(a)}const S=h.length>0?h[0].index:f.length;if(f.length!==S){console.trace(`[createInstance] First service dependency of ${y.name} at position ${S+1} conflicts with ${f.length} static arguments`);const s=S-f.length;s>0?f=f.concat(new Array(s)):f=f.slice(0,S)}return Reflect.construct(y,f.concat(m))}k(y,f){if(this.f.get(y)instanceof N.$Mh)this.f.set(y,f);else if(this.h)this.h.k(y,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(y){const f=this.f.get(y);return!f&&this.h?this.h.l(y):f}m(y,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const c=this.l(y);return c instanceof N.$Mh?this.q(y,c,f.branch(y,!0)):(f.branch(y,!1),c)}q(y,f,c){if(this.o.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.o.add(y);try{return this.r(y,f,c)}finally{this.o.delete(y)}}r(y,f,c){const h=new D.$dq(s=>s.id.toString());let m=0;const S=[{id:y,desc:f,_trace:c}];for(;S.length;){const s=S.pop();if(h.lookupOrInsertNode(s),m++>1e3)throw new E(h);for(const a of R._util.getServiceDependencies(s.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${y} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(a.id)),n instanceof N.$Mh){const i={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};h.insertEdge(s,i),S.push(i)}}}for(;;){const s=h.roots();if(s.length===0){if(!h.isEmpty())throw new E(h);break}for(const{data:a}of s){if(this.l(a.id)instanceof N.$Mh){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}h.removeNode(a)}}return this.l(y)}s(y,f,c=[],h,m){if(this.f.get(y)instanceof N.$Mh)return this.t(y,f,c,h,m);if(this.h)return this.h.s(y,f,c,h,m);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(y,f,c=[],h,m){if(h){const S=new b(void 0,this.g,this,this.i);S.c=String(y);const s=new Map,a=new I.$$g(()=>{const n=S.j(f,c,m);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const o of t)r.apply(n,o)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let o=s.get(i);return o||(o=new g.$2c,s.set(i,o)),(w,u,$)=>{const j=o.push([w,u,$]);return(0,A.$Qc)(j)}}if(i in n)return n[i];const t=a.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return a.value[i]=t,!0},getPrototypeOf(n){return f.prototype}})}else return this.j(f,c,m)}u(y,f){if(f&&console.warn(y),this.g)throw new Error(y)}}e.$eq=b;var l;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(l||(l={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(y,f){return y?new d(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(y,f){return y?new d(1,f.name):d.c}static{this.f=0}constructor(y,f){this.type=y,this.name=f,this.g=Date.now(),this.h=[]}branch(y,f){const c=new d(3,y.toString());return this.h.push([y,f,c]),c}stop(){const y=Date.now()-this.g;d.f+=y;let f=!1;function c(m,S){const s=[],a=new Array(m+1).join("	");for(const[n,i,t]of S.h)if(i&&t){f=!0,s.push(`${a}CREATES -> ${n}`);const r=c(m+1,t);r&&s.push(r)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(y>2||f)&&d.all.add(h.join(`
`))}}e.$fq=d}),define(oe[72],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h8b=e.$g8b=void 0,e.$g8b=(0,I.$Ph)("mainProcessService");class L{constructor(N,D){this.a=N,this.b=D}getChannel(N){return this.a.getChannel(N,this.b)}registerChannel(N,D){this.a.registerChannel(N,D)}}e.$h8b=L}),define(oe[73],ae([0,1,26,2,5,163,29,4]),function(te,e,I,L,A,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=void 0;function k(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Sq=k,e.$Tq=(0,R.$Ph)("languagePackService");let g=class extends L.$Sc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new I.$Xd;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const d=b.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(y=>y.startsWith("lp-"))).map(p=>{const y=p.properties.localizedLanguages?.[0],f=k(p);return{...this.f(f,y,p),extensionId:p.identifier.id,galleryExtension:p}});return d.push(this.f("en","English")),d}f(E,b,l){const d=b??E;let p;if(d!==E&&(p=`(${E})`),E.toLowerCase()===A.$w.toLowerCase()&&(p??="",p+=(0,N.localize)(0,null)),l?.installCount){p??="";const y=l.installCount;let f;y>1e6?f=`${Math.floor(y/1e5)/10}M`:y>1e3?f=`${Math.floor(y/1e3)}K`:f=String(y),p+=` $(cloud-download) ${f}`}return{id:E,label:d,description:p}}};e.$Uq=g,e.$Uq=g=ye([Y(0,D.$$n)],g)}),define(oe[196],ae([0,1,2,73]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F8b=void 0;let A=class extends I.$Sc{constructor(D){super(),this.a=D,this.b()}b(){this.a.update()}};e.$F8b=A,e.$F8b=A=ye([Y(0,L.$Tq)],A)}),define(oe[7],ae([0,1,38,3,52,2,34,5,19,12,10,94,4]),function(te,e,I,L,A,N,D,R,k,g,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,b.$Ph)("logService"),e.$$i=(0,b.$Ph)("loggerService");function l(){return new Date().toISOString()}function d(w){return(0,g.$Cf)(w)}e.$_i=d;var p;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$aj=p.Info;function y(w,u,$){switch(u){case p.Trace:w.trace($);break;case p.Debug:w.debug($);break;case p.Info:w.info($);break;case p.Warning:w.warn($);break;case p.Error:w.error($);break;case p.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=y;function f(w,u=!1){let $="";for(let j=0;j<w.length;j++){let M=w[j];if(M instanceof Error&&(M=(0,I.$Ai)(M,u)),typeof M=="object")try{M=JSON.stringify(M)}catch{}$+=(j>0?" ":"")+M}return $}class c extends N.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new L.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==p.Off&&this.b<=u}}e.$cj=c;class h extends c{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...$){this.f(p.Trace)&&this.g(p.Trace,f([u,...$],!0))}debug(u,...$){this.f(p.Debug)&&this.g(p.Debug,f([u,...$]))}info(u,...$){this.f(p.Info)&&this.g(p.Info,f([u,...$]))}warn(u,...$){this.f(p.Warning)&&this.g(p.Warning,f([u,...$]))}error(u,...$){if(this.f(p.Error))if(u instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=u.stack,this.g(p.Error,f(j))}else this.g(p.Error,f([u,...$]))}flush(){}}e.$dj=h;class m extends c{constructor(u=e.$aj){super(),this.setLevel(u),this.g=!R.$j}trace(u,...$){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...$):console.log(`[main ${l()}]`,u,...$))}debug(u,...$){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...$):console.log(`[main ${l()}]`,u,...$))}info(u,...$){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...$):console.log(`[main ${l()}]`,u,...$))}warn(u,...$){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,u,...$):console.warn(`[main ${l()}]`,u,...$))}error(u,...$){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,u,...$):console.error(`[main ${l()}]`,u,...$))}dispose(){}flush(){}}e.$ej=m;class S extends c{constructor(u=e.$aj,$=!0){super(),this.g=$,this.setLevel(u)}trace(u,...$){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...$):console.log(u,...$))}debug(u,...$){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...$):console.log(u,...$))}info(u,...$){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...$):console.log(u,...$))}warn(u,...$){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...$):console.log(u,...$))}error(u,...$){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...$):console.error(u,...$))}dispose(){}flush(){}}e.$fj=S;class s extends c{constructor(u,$=e.$aj){super(),this.g=u,this.setLevel($)}trace(u,...$){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(u),...$])}debug(u,...$){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(u),...$])}info(u,...$){this.f(p.Info)&&this.g.log(p.Info,[this.h(u),...$])}warn(u,...$){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(u),...$])}error(u,...$){this.f(p.Error)&&this.g.log(p.Error,[this.h(u),...$])}h(u){return typeof u=="string"?u:(0,I.$Ai)(u,this.f(p.Trace))}dispose(){}flush(){}}e.$gj=s;class a extends c{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const $ of this.g)$.setLevel(u);super.setLevel(u)}trace(u,...$){for(const j of this.g)j.trace(u,...$)}debug(u,...$){for(const j of this.g)j.debug(u,...$)}info(u,...$){for(const j of this.g)j.info(u,...$)}warn(u,...$){for(const j of this.g)j.warn(u,...$)}error(u,...$){for(const j of this.g)j.error(u,...$)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.$hj=a;class n extends N.$Sc{constructor(u,$,j){if(super(),this.h=u,this.j=$,this.b=new D.$Ac,this.c=this.B(new L.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Nd),this.onDidChangeVisibility=this.g.event,j)for(const M of j)this.b.set(M.resource,{logger:void 0,info:M})}m(u){return(0,g.$yf)(u)?[...this.b.values()].find($=>$.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,$){const j=this.n(u),M=(0,g.$yf)(u)?u:$?.id??(0,A.$Di)(j.toString()).toString(16);let U=this.b.get(j)?.logger;const z=$?.logLevel==="always"?p.Trace:$?.logLevel;U||(U=this.s(j,z??this.getLogLevel(j)??this.h,{...$,id:M}));const q={logger:U,info:{resource:j,id:M,logLevel:z,name:$?.name,hidden:$?.hidden,extensionId:$?.extensionId,when:$?.when}};return this.registerLogger(q.info),this.b.set(j,q),U}n(u){return(0,g.$yf)(u)?(0,k.$vg)(this.j,`${u}.log`):u}setLogLevel(u,$){if(C.URI.isUri(u)){const j=u,M=$,U=this.b.get(j);U&&M!==U.info.logLevel&&(U.info.logLevel=M===this.h?void 0:M,U.logger?.setLevel(M),this.b.set(U.info.resource,U),this.f.fire([j,M]))}else{this.h=u;for(const[j,M]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,$){const j=this.m(u);j&&$!==!j.info.hidden&&(j.info.hidden=!$,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,$]))}getLogLevel(u){let $;return u&&($=this.b.get(u)?.info.logLevel),$??this.h}registerLogger(u){const $=this.b.get(u.resource);$?$.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const $=this.b.get(u);$&&($.logger&&$.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[$.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=n;class i{constructor(){this.onDidChangeLogLevel=new L.$Nd().event}setLevel(u){}getLevel(){return p.Info}trace(u,...$){}debug(u,...$){}info(u,...$){}warn(u,...$){}error(u,...$){}critical(u,...$){}dispose(){}flush(){}}e.$jj=i;class t extends i{}e.$kj=t;function r(w){if(w.verbose)return p.Trace;if(typeof w.logLevel=="string"){const u=v(w.logLevel.toLowerCase());if(u!==void 0)return u}return e.$aj}e.$lj=r;function o(w){switch(w){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$mj=o;function v(w){switch(w){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$nj=v,e.$oj=new E.$7i("logLevel",o(p.Info))}),define(oe[197],ae([0,1,6,8,2,23,16,19,31,14,7]),function(te,e,I,L,A,N,D,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=void 0;let E=class extends A.$Sc{constructor(l,d){super(),this.a=l,this.b=d,this.B(new I.$6g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,R.$sg)(this.a.logsHome),d=(0,R.$ug)(this.a.logsHome.with({scheme:N.Schemas.file})).fsPath,f=(await k.Promises.readdir(d)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==l),c=f.slice(0,Math.max(0,f.length-9));c.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(h=>k.Promises.rm((0,D.$jc)(d,h)))))}catch(l){(0,L.$1)(l)}}};e.$G8b=E,e.$G8b=E=ye([Y(0,g.$Wh),Y(1,C.$0i)],E)}),define(oe[198],ae([0,1,18,6,8,3,2,16,49,7]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class C extends D.$Sc{constructor(b,l){super(),this.a=b,this.b=l,this.c=this.B(new N.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$Rg(0)),this.w=[],this.y=this.B(new L.$Rg(0))}watch(b,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(b,l):this.z(b,l)}n(b,l){const d={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},p=(0,I.$Ub)(this.j,d);return this.r(),(0,D.$Qc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,A.$1)(b))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,k.$Tp)(l)),l=>this.G(l),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const l of this.j)(0,k.$Pp)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const l of this.j)(0,k.$Pp)(l)&&b.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,l){const d={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},p=(0,I.$Ub)(this.w,d);return this.C(),(0,D.$Qc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,A.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,k.$Tp)(b)),b=>this.G(b),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,R.$hc)(b.fsPath)}}e.$Xp=C}),define(oe[199],ae([0,1,18,6,15,26,3,52,59,2,47,23,100,19,46,159,11,99,7,8]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;let S=class extends g.$Sc{static{m=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new D.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Nd),this.Y=this.B(new D.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new L.$3g)}registerProvider(a,n){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${a}`);const i=new g.$Rc;return this.h.set(a,n),this.c.fire({added:!0,scheme:a,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new y.$rk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:a}))),(0,g.$Qc)(()=>{this.c.fire({added:!1,scheme:a,provider:n}),this.h.delete(a),(0,g.$Nc)(i)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const n=[];this.f.fire({scheme:a,join(i){n.push(i)}}),!this.h.has(a)&&await L.Promises.settled(n)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,n){const i=this.h.get(a.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return k.Iterable.map(this.h,([a,n])=>({scheme:a,capabilities:n.capabilities}))}async j(a){if(!(0,l.$zg)(a))throw new y.$tk((0,p.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const n=this.h.get(a.scheme);if(!n){const i=new h.$bb;throw i.message=(0,p.localize)(1,null,a.toString()),i}return n}async m(a){const n=await this.j(a);if((0,y.$ek)(n)||(0,y.$bk)(n)||(0,y.$fk)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const n=await this.j(a);if((0,y.$ek)(n)||(0,y.$bk)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,n){try{return await this.s(a,n)}catch(i){throw(0,y.$ok)(i)===y.FileSystemProviderErrorCode.FileNotFound?new y.$tk((0,p.localize)(2,null,this.sb(a)),1):(0,y.$mk)(i)}}async s(a,n){const i=await this.j(a),t=this.S(i),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,w=await i.stat(a);let u;return this.t(i,a,w,void 0,!!v,($,j)=>(u||(u=C.$Vh.forUris(()=>!t),u.set(a,!0),r&&u.fill(!0,r)),u.get($.resource)||u.findSuperstr($.resource.with({query:null,fragment:null}))?!0:$.isDirectory&&o?j===1:!1))}async t(a,n,i,t,r,o){const{providerExtUri:v}=this.R(a),w={resource:n,name:v.basename(n),isFile:(i.type&y.FileType.File)!==0,isDirectory:(i.type&y.FileType.Directory)!==0,isSymbolicLink:(i.type&y.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&y.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((i.permissions??0)&y.FilePermission.Locked),etag:(0,y.$Ek)({mtime:i.mtime,size:i.size}),children:void 0};if(w.isDirectory&&o(w,t)){try{const u=await a.readdir(n),$=await L.Promises.settled(u.map(async([j,M])=>{try{const U=v.joinPath(n,j),z=r?await a.stat(U):{type:M};return await this.t(a,U,z,u.length,r,o)}catch(U){return this.b.trace(U),null}}));w.children=(0,I.$Hb)($)}catch(u){this.b.trace(u),w.children=[]}return w}return w}async resolveAll(a){return L.Promises.settled(a.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(a){const n=await this.j(a),i=await n.stat(a);return this.t(n,a,i,void 0,!0,()=>!1)}async exists(a){const n=await this.j(a);try{return!!await n.stat(a)}catch{return!1}}async canCreateFile(a,n){try{await this.u(a,n)}catch(i){return i}return!0}async u(a,n){if(!n?.overwrite&&await this.exists(a))throw new y.$tk((0,p.localize)(3,null,this.sb(a)),3,n)}async createFile(a,n=A.$be.fromString(""),i){await this.u(a,i);const t=await this.writeFile(a,n);return this.r.fire(new y.$qk(a,0,t)),t}async writeFile(a,n,i){const t=this.qb(await this.n(a),a),{providerExtUri:r}=this.R(t);let o=i;if((0,y.$hk)(t)&&!o?.atomic){const v=t.enforceAtomicWriteFile?.(a);v&&(o={...i,atomic:v})}try{await this.w(t,a,o)||await this.U(t,r.dirname(a));let w;if((0,y.$bk)(t)&&!(n instanceof A.$be))if((0,d.$Zd)(n)){const u=await(0,d.$7d)(n,3);u.ended?w=A.$be.concat(u.buffer):w=u}else w=(0,d.$4d)(n,u=>A.$be.concat(u),3);else w=n;!(0,y.$ek)(t)||(0,y.$bk)(t)&&w instanceof A.$be||(0,y.$bk)(t)&&(0,y.$hk)(t)&&o?.atomic?await this.hb(t,a,o,w):await this.db(t,a,o,w instanceof A.$be?(0,A.$me)(w):w),this.r.fire(new y.$qk(a,4))}catch(v){throw new y.$tk((0,p.localize)(4,null,this.sb(a),(0,y.$mk)(v).toString()),(0,y.$pk)(v),o)}return this.resolve(a,{resolveMetadata:!0})}async w(a,n,i){const t=!!i?.unlock;if(t&&!(a.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(a.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(a.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(t)throw new Error((0,p.localize)(8,null,this.sb(n)))}let o;try{o=await a.stat(n)}catch{return}if(o.type&y.FileType.Directory)throw new y.$tk((0,p.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==y.$Dk&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,y.$Ek)({mtime:i.mtime,size:o.size}))throw new y.$tk((0,p.localize)(10,null),3,i);return o}async readFile(a,n,i){const t=await this.m(a);return n?.atomic?this.z(t,a,n,i):this.C(t,a,n,i)}async z(a,n,i,t){return new Promise((r,o)=>{this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{try{const v=await this.C(a,n,i,t);r(v)}catch(v){o(v)}})})}async C(a,n,i,t){const r=await this.D(a,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,A.$ne)(r.value)}}async readFileStream(a,n,i){const t=await this.m(a);return this.D(t,a,n,i)}async D(a,n,i,t){const r=new N.$Xd(t);let o=i;(0,y.$gk)(a)&&a.enforceAtomicReadFile?.(n)&&(o={...i,atomic:!0});const v=this.J(n,o).then(u=>u,u=>{throw r.dispose(!0),u});let w;try{return typeof o?.etag=="string"&&o.etag!==y.$Dk&&await v,o?.atomic&&(0,y.$gk)(a)||!((0,y.$ek)(a)||(0,y.$fk)(a))||(0,y.$bk)(a)&&o?.preferUnbuffered?w=this.I(a,n,o):(0,y.$fk)(a)?w=this.G(a,n,r.token,o):w=this.H(a,n,r.token,o),w.on("end",()=>r.dispose()),w.on("error",()=>r.dispose()),{...await v,value:w}}catch(u){throw w&&await(0,d.$5d)(w),this.F(u,n,o)}}F(a,n,i){const t=(0,p.localize)(11,null,this.sb(n),(0,y.$mk)(a).toString());return a instanceof y.$vk?new y.$vk(t,a.stat,i):a instanceof y.$uk?new y.$uk(t,a.fileOperationResult,a.size,a.options):new y.$tk(t,(0,y.$pk)(a),i)}G(a,n,i,t=Object.create(null)){const r=a.readFileStream(n,t,i);return(0,d.$$d)(r,{data:o=>o instanceof A.$be?o:A.$be.wrap(o),error:o=>this.F(o,n,t)},o=>A.$be.concat(o))}H(a,n,i,t=Object.create(null)){const r=(0,A.$re)();return(0,f.$Np)(a,n,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>this.F(o,n,t)},i),r}I(a,n,i){const t=(0,d.$2d)(r=>A.$be.concat(r));return(async()=>{try{let r;i?.atomic&&(0,y.$gk)(a)?r=await a.readFile(n,{atomic:!0}):r=await a.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(A.$be.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(a,n){const i=await this.resolve(a,{resolveMetadata:!0});if(i.isDirectory)throw new y.$tk((0,p.localize)(12,null,this.sb(a)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.$Dk&&n.etag===i.etag)throw new y.$vk((0,p.localize)(13,null),i,n);return this.L(a,i.size,n),i}L(a,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new y.$uk((0,p.localize)(14,null,this.sb(a)),7,n,i)}async canMove(a,n,i){return this.M(a,n,"move",i)}async canCopy(a,n,i){return this.M(a,n,"copy",i)}async M(a,n,i,t){if(a.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(a),a):await this.m(a),o=this.qb(await this.n(n),n);await this.Q(r,a,o,n,i,t)}catch(r){return r}return!0}async move(a,n,i){const t=this.qb(await this.n(a),a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new y.$qk(a,o==="move"?2:3,v)),v}async copy(a,n,i){const t=await this.m(a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new y.$qk(a,o==="copy"?3:2,v)),v}async N(a,n,i,t,r,o){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:w}=await this.Q(a,n,i,t,r,o);if(v&&!w&&o&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(a===i&&(0,y.$ck)(a))await a.copy(n,t,{overwrite:o});else{const u=await this.resolve(n);u.isDirectory?await this.P(a,u,i,t):await this.O(a,n,i,t)}return r}else return a===i?(await a.rename(n,t,{overwrite:o}),r):(await this.N(a,n,i,t,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(a,n,i,t){if((0,y.$ek)(a)&&(0,y.$ek)(i))return this.jb(a,n,i,t);if((0,y.$ek)(a)&&(0,y.$bk)(i))return this.pb(a,n,i,t);if((0,y.$bk)(a)&&(0,y.$ek)(i))return this.nb(a,n,i,t);if((0,y.$bk)(a)&&(0,y.$bk)(i))return this.lb(a,n,i,t)}async P(a,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await L.Promises.settled(n.children.map(async r=>{const o=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(a,await this.resolve(r.resource),i,o):this.O(a,r.resource,i,o)}))}async Q(a,n,i,t,r,o){let v=!1;if(a===i){const{providerExtUri:u,isPathCaseSensitive:$}=this.R(a);if($||(v=u.isEqual(n,t)),v&&r==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&u.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(t)))}const w=await this.exists(t);if(w&&!v){if(!o)throw new y.$tk((0,p.localize)(17,null,this.sb(n),this.sb(t)),4);if(a===i){const{providerExtUri:u}=this.R(a);if(u.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:w,isSameResourceWithDifferentPathCase:v}}R(a){const n=this.S(a);return{providerExtUri:n?l.$lg:l.$ng,isPathCaseSensitive:n}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const n=this.qb(await this.j(a),a);await this.U(n,a);const i=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new y.$qk(a,0,i)),i}async U(a,n){const i=[],{providerExtUri:t}=this.R(a);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await a.stat(n)).type&y.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(r){if((0,y.$ok)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await a.mkdir(n)}catch(o){if((0,y.$ok)(o)!==y.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,n){try{await this.W(a,n)}catch(i){return i}return!0}async W(a,n){const i=this.qb(await this.j(a),a),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(a)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(a)));if(t&&r)throw new Error((0,p.localize)(22,null,this.sb(a)));let o;try{o=await i.stat(a)}catch{}if(o)this.rb(a,o);else throw new y.$tk((0,p.localize)(23,null,this.sb(a)),1);if(!!!n?.recursive){const w=await this.resolve(a);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(a)))}return i}async del(a,n){const i=await this.W(a,n);let t=n;if((0,y.$ik)(i)&&!t?.atomic){const w=i.enforceAtomicDelete?.(a);w&&(t={...n,atomic:w})}const r=!!t?.useTrash,o=!!t?.recursive,v=t?.atomic??!1;await i.delete(a,{recursive:o,useTrash:r,atomic:v}),this.r.fire(new y.$qk(a,1))}async cloneFile(a,n){const i=await this.j(a),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(a,n))return;if(i===t&&(0,y.$dk)(i))return i.cloneFile(a,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(a,this.R(i).providerExtUri);return i===t&&(0,y.$ck)(i)?r.queue(()=>i.copy(a,n,{overwrite:!0})):r.queue(()=>this.O(i,a,t,n))}static{this.ab=0}createWatcher(a,n){return this.watch(a,{...n,correlationId:m.ab++})}watch(a,n={recursive:!1,excludes:[]}){const i=new g.$Rc;let t=!1,r=()=>{t=!0};i.add((0,g.$Qc)(()=>r())),(async()=>{try{const v=await this.bb(a,n);t?(0,g.$Nc)(v):r=()=>(0,g.$Nc)(v)}catch(v){this.b.error(v)}})();const o=n.correlationId;if(typeof o=="number"){const v=i.add(new D.$Nd);return i.add(this.X.event(u=>{u.correlates(o)&&v.fire(u)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(a,n){const i=await this.j(a),t=(0,R.$Di)([this.R(i).providerExtUri.getComparisonKey(a),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(a,n)},this.$.set(t,r)),r.count+=1,(0,g.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Nc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,g.$Nc)(a.disposable);this.$.clear()}async db(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{const r=await a.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,d.$Zd)(t)||(0,d.$1d)(t)?await this.eb(a,r,t):await this.fb(a,r,t)}catch(o){throw(0,y.$mk)(o)}finally{await a.close(r)}})}async eb(a,n,i){let t=0,r;if((0,d.$1d)(i)){if(i.buffer.length>0){const o=A.$be.concat(i.buffer);await this.gb(a,n,o,o.byteLength,t,0),t+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,v)=>{(0,d.$6d)(r,{onData:async w=>{r.pause();try{await this.gb(a,n,w,w.byteLength,t,0)}catch(u){return v(u)}t+=w.byteLength,setTimeout(()=>r.resume())},onError:w=>v(w),onEnd:()=>o()})})}async fb(a,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(a,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(a,n,i,t,r,o){let v=0;for(;v<t;){const w=await a.write(n,r+v,i.buffer,o+v,t-v);v+=w}}async hb(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(()=>this.ib(a,n,i,t))}async ib(a,n,i,t){let r;t instanceof A.$be?r=t:(0,d.$Zd)(t)?r=await(0,A.$ne)(t):(0,d.$1d)(t)?r=await(0,A.$oe)(t):r=(0,A.$le)(t),await a.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(a,n,i,t))}async kb(a,n,i,t){let r,o;try{r=await a.open(n,{create:!1}),o=await i.open(t,{create:!0,unlock:!1});const v=A.$be.alloc(this.a);let w=0,u=0,$=0;do $=await a.read(r,w,v.buffer,u,v.byteLength-u),await this.gb(i,o,v,$,w,u),w+=$,u+=$,u===v.byteLength&&(u=0);while($>0)}catch(v){throw(0,y.$mk)(v)}finally{await L.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async lb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(a,n,i,t))}async mb(a,n,i,t){return i.writeFile(t,await a.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(a,n,i,t))}async ob(a,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const o=await a.readFile(n);await this.gb(i,r,A.$be.wrap(o),o.byteLength,0,0)}catch(o){throw(0,y.$mk)(o)}finally{await i.close(r)}}async pb(a,n,i,t){const r=await(0,A.$ne)(this.H(a,n,N.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(a,n){if(a.capabilities&2048)throw new y.$tk((0,p.localize)(25,null,this.sb(n)),6);return a}rb(a,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.$tk((0,p.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===E.Schemas.file?a.fsPath:a.toString(!0)}};e.$Op=S,e.$Op=S=m=ye([Y(0,c.$0i)],S)}),define(oe[200],ae([0,1,53,271,6,34,15,3,48,2,16,5,19,46,31,162,11,99,198,38,194,193]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0,(()=>{try{(0,L.gracefulify)(I)}catch(a){console.error(`Error enabling graceful-fs: ${(0,h.$Ai)(a)}`)}})();class s extends c.$Xp{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=R.Event.None,this.N=new N.$Ac(t=>b.$mg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$l&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await d.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:y.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await d.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,b.$vg)(n,r.name))).type:o=this.M(r),t.push([r.name,o])}catch(o){this.a.trace(o)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=y.FileType.Unknown:n.isFile()?t=y.FileType.File:n.isDirectory()?t=y.FileType.Directory:t=y.FileType.Unknown,i&&(t|=y.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new A.$Sg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await d.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,l.$2d)(o=>D.$be.concat(o.map(v=>D.$be.wrap(v))).buffer);return(0,f.$Np)(this,n,r,o=>o.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,b.$vg)((0,b.$ug)(n),`${(0,b.$sg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await d.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const o=new g.$Rc;try{o.add(await this.O(n)),o.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{o.dispose()}}async S(n,i,t,r){let o;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await d.Promises.exists(v)){if(!t.overwrite)throw(0,y.$lk)((0,p.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,y.$lk)((0,p.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(o,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof o=="number"&&await this.close(o)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let o;(0,y.$_j)(i)&&!t&&(o=await this.O(n));let v;try{if((0,y.$_j)(i)&&i.unlock)try{const{stat:u}=await d.SymlinkSupport.stat(r);u.mode&128||await d.Promises.chmod(r,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let w;if((0,y.$_j)(i)){if(E.$j)try{await d.Promises.truncate(r,0),w="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}w||(w="w")}else w="r";v=await d.Promises.open(r,w)}catch(w){throw o?.dispose(),(0,y.$_j)(i)?await this.gb(n,w):this.fb(w)}if(this.U.set(v,0),(0,y.$_j)(i)&&this.X.set(v,n),o){const w=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,o),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),w.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await d.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await d.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,o){const v=this.Z(n,i);let w=null;try{w=(await d.Promises.read(n,t,r,o,v)).bytesRead}catch(u){throw this.fb(u)}finally{this.$(n,v,w)}return w}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,o){return(0,A.$_g)(()=>this.ab(n,i,t,r,o),100,3)}async ab(n,i,t,r,o){const v=this.Z(n,i);let w=null;try{w=(await d.Promises.write(n,t,r,o,v)).bytesWritten}catch(u){throw await this.gb(this.X.get(n),u)}finally{this.$(n,v,w)}return w}async mkdir(n){try{await d.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,C.$jc)((0,C.$mc)(t),`${(0,C.$nc)(t)}${i.atomic.postfix}`)),await d.Promises.rm(t,d.RimRafMode.MOVE,r)}else try{await d.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let o=!1;try{const{stat:v,symbolicLink:w}=await d.SymlinkSupport.stat(t);o=v.isDirectory()&&!w}catch{}if(o)await d.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"move",t.overwrite),await d.Promises.rename(r,o)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(o)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"copy",t.overwrite),await d.Promises.copy(r,o,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(o)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const o=this.H(n),v=this.H(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.$Wf)(o,v,!0)),w){if(t==="copy")throw(0,y.$lk)((0,p.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const $=await this.L(n);if(!$)throw(0,y.$lk)((0,p.localize)(5,null),y.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!r)throw(0,y.$lk)((0,p.localize)(6,null),y.FileSystemProviderErrorCode.FileExists);$.type&y.FileType.File&&j.type&y.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),o=this.H(i),v=!!(this.capabilities&1024);if((0,k.$Wf)(r,o,!v))return;const w=new g.$Rc;try{w.add(await this.O(n)),w.add(await this.O(i)),t&&await d.Promises.mkdir((0,C.$mc)(o),{recursive:!0}),await d.Promises.copyFile(r,o)}catch(u){if(u.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(u)}finally{w.dispose()}}t(n,i,t){return new m.$5p(r=>n(r),r=>i(r),t)}F(n,i,t){return new S.$aq(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof y.$kk)return n;let i=n,t;switch(n.code){case"ENOENT":t=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=y.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=y.FileSystemProviderErrorCode.Unknown;break;default:t=y.FileSystemProviderErrorCode.Unknown}return(0,y.$lk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await d.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,y.$lk)(i,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$bq=s}),define(oe[101],ae([0,1,3,2,4,7]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$08b=e.$98b=void 0,e.$98b=(0,A.$Ph)("sharedProcessLifecycleService");let D=class extends L.$Sc{constructor(k){super(),this.b=k,this.a=this.B(new I.$Nd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$08b=D,e.$08b=D=ye([Y(0,N.$0i)],D)}),define(oe[201],ae([0,1,10,3,7,2]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=void 0;class D extends A.$ij{constructor(E,b,l,d,p){super(b,l,d),this.r=E,this.t=p,this.B(p.listen("onDidChangeLogLevel",E)(y=>{(0,A.$_i)(y)?super.setLogLevel(y):super.setLogLevel(I.URI.revive(y[0]),y[1])})),this.B(p.listen("onDidChangeVisibility",E)(([y,f])=>super.setVisibility(I.URI.revive(y),f))),this.B(p.listen("onDidChangeLoggers",E)(({added:y,removed:f})=>{for(const c of y)super.registerLogger({...c,resource:I.URI.revive(c.resource)});for(const c of f)super.deregisterLogger(c.resource)}))}createConsoleMainLogger(){return new A.$gj({log:(E,b)=>{this.t.call("consoleLog",[E,b])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,b){super.setLogLevel(E,b),this.t.call("setLogLevel",[E,b])}setVisibility(E,b){super.setVisibility(E,b),this.t.call("setVisibility",[this.n(E),b])}s(E,b,l){return new R(this.t,E,b,l,this.r)}static setLogLevel(E,b,l){return E.call("setLogLevel",[b,l])}}e.$_q=D;class R extends A.$dj{constructor(E,b,l,d,p){super(d?.logLevel==="always"),this.r=E,this.s=b,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[b,d,p]).then(()=>{this.u(this.n),this.m=!0})}g(E,b){const l=[[E,b]];this.m?this.u(l):this.n.push(...l)}u(E){this.r.call("log",[this.s,E])}}class k{constructor(E,b){this.a=E,this.b=b}listen(E,b){const l=this.b(E);switch(b){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(p=>this.c(p,l)),removed:[...d.removed].map(p=>this.c(p,l))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,d=>[l.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,d=>(0,A.$_i)(d)?d:[l.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${b}`)}async call(E,b,l){const d=this.b(E);switch(b){case"setLogLevel":return(0,A.$_i)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(I.URI.revive(d.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,d)))}throw new Error(`Call not found: ${b}`)}c(E,b){return{...E,resource:b.transformOutgoingURI(E.resource)}}}e.$ar=k;class g extends N.$Sc{constructor(E,b){super(),b.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(l=>b.call("setLogLevel",[l]))),b.call("getRegisteredLoggers").then(l=>{for(const d of l)E.registerLogger({...d,resource:I.URI.revive(d.resource)})}),this.B(b.listen("onDidChangeVisibility")(([l,d])=>E.setVisibility(I.URI.revive(l),d))),this.B(b.listen("onDidChangeLoggers")(({added:l,removed:d})=>{for(const p of l)E.registerLogger({...p,resource:I.URI.revive(p.resource)});for(const p of d)E.deregisterLogger(p.resource)}))}}e.$br=g}),define(oe[202],ae([0,1,2,7]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;class A extends I.$Sc{constructor(D,R=[]){super(),this.a=new L.$hj([D,...R]),this.B(D.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...R){this.a.trace(D,...R)}debug(D,...R){this.a.debug(D,...R)}info(D,...R){this.a.info(D,...R)}warn(D,...R){this.a.warn(D,...R)}error(D,...R){this.a.error(D,...R)}flush(){this.a.flush()}}e.$EN=A}),define(oe[55],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=void 0,e.$X6b=(0,I.$Ph)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=void 0,e.$in=(0,N.$Ph)("policy");class D extends A.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),L.Iterable.reduce(this.g.entries(),(E,[b,l])=>({...E,[b]:l}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(g,[C,E])=>({...g,[C]:{definition:E,value:this.g.get(C)}}),{})}}e.$jn=D;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$kn=R}),define(oe[203],ae([0,1,3,2,56]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=e.$O7b=void 0;class N{constructor(k){this.b=k,this.a=new L.$Rc}listen(k,g){switch(g){case"onDidChange":return I.Event.map(this.b.onDidChange,C=>C.reduce((E,b)=>({...E,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(k,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$O7b=N;class D extends A.$jn{constructor(k,g){super(),this.a=g;for(const C in k){const{definition:E,value:b}=k[C];this.f[C]=E,b!==void 0&&this.g.set(C,b)}this.a.listen("onDidChange")(C=>{for(const E in C){const b=C[E];b===null?this.g.delete(E):this.g.set(E,b)}this.h.fire(Object.keys(C))})}async j(k){const g=await this.a.call("updatePolicyDefinitions",k);for(const C in g)this.g.set(C,g[C])}}e.$P7b=D}),define(oe[102],ae([0,1,5,37]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.context<"u"){const N=I.$h.vscode.context.configuration();if(N)A=N.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const N=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:N.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(oe[24],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,I.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"}),define(oe[204],ae([0,1,6,8,2,16,31,7,24]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D8b=void 0;let g=class extends A.$Sc{constructor(E,b,l){super(),this.b=b,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new I.$6g(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const b=Date.now(),l=(0,N.$mc)(E),d=(0,N.$nc)(E),p=await D.Promises.readdir(l);await Promise.all(p.map(async y=>{if(y===d)return;const f=(0,N.$jc)(l,y),c=await D.Promises.stat(f);if(c.isDirectory()&&b-c.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),D.Promises.rm(f)}))}catch(b){(0,L.$1)(b)}}};e.$D8b=g,e.$D8b=g=ye([Y(1,k.$pj),Y(2,R.$0i)],g)}),define(oe[205],ae([0,1,6,8,2,16,31,14,7,24]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=void 0;let C=class extends A.$Sc{constructor(b,l,d){super(),this.b=b,this.c=l,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$6g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const b=Object.create(null),l=JSON.parse(await D.Promises.readFile((0,N.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const c of Object.keys(l)){const h=l[c];b[`${h.hash}.${c}`]=!0}const d=(0,N.$jc)(this.b.userDataPath,"clp");if(!await D.Promises.exists(d))return;const y=await D.Promises.readdir(d);for(const c of y){if(b[c]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${c}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${c}`),await D.Promises.rm((0,N.$jc)(d,c))}const f=Date.now();for(const c of Object.keys(b)){const h=(0,N.$jc)(d,c),m=await D.Promises.readdir(h);for(const S of m){if(S==="tcf.json")continue;const s=(0,N.$jc)(h,S),a=await D.Promises.stat(s);a.isDirectory()&&f-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,N.$jc)(c,S)}`),await D.Promises.rm(s))}}}catch(b){(0,L.$1)(b)}}};e.$E8b=C,e.$E8b=C=ye([Y(0,R.$Xh),Y(1,k.$0i),Y(2,g.$pj)],C)}),define(oe[206],ae([0,1,16,4]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$WE=void 0,e.$WE=(0,L.$Ph)("IV8InspectProfilingService");var A;(function(N){function D(k){return!!(k.samples&&k.timeDeltas)}N.isValidProfile=D;function R(k,g="noAbsolutePaths"){for(const C of k.nodes)C.callFrame&&C.callFrame.url&&((0,I.$ic)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,I.$jc)(g,(0,I.$nc)(C.callFrame.url)));return k}N.rewriteAbsolutePaths=R})(A||(e.Utils=A={}))}),define(oe[207],ae([0,1,32]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y8b=void 0;class L{constructor(){this.a=new Map}async startProfiling(N){const R=await(await new Promise((g,C)=>{te(["v8-inspect-profiler"],g,C)})).startProfiling({port:N.port,checkForPaused:!0}),k=(0,I.$eg)();return this.a.set(k,R),k}async stopProfiling(N){const D=this.a.get(N);if(!D)throw new Error(`UNKNOWN session '${N}'`);const R=await D.stop();return this.a.delete(N),R.profile}}e.$Y8b=L}),define(oe[40],ae([0,1,127,12]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class A{constructor(){this.a=new Map}add(D,R){I.ok(L.$yf(D)),I.ok(L.$Af(R)),I.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,R)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$gn=new A}),define(oe[103],ae([0,1,3,40]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function A(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class N{constructor(){this.b=new I.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,g){this.a[A(k)]=g,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const D=new N;L.$gn.add(e.$hn.JSONContribution,D)}),define(oe[50],ae([0,1,18,3,12,149,20,103,40]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var g;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$ln={Configuration:"base.contributions.configuration"};var C;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const E=k.$gn.as(R.$hn.JSONContribution);class b{constructor(){this.h=new Set,this.i=new L.$Nd,this.onDidSchemaChange=this.i.event,this.j=new L.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(s,a=!0){this.registerConfigurations([s],a)}registerConfigurations(s,a=!0){const n=new Set;this.n(s,a,n),E.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const a=new Set;this.o(s,a),E.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:s,remove:a}){const n=new Set;this.o(a,n),this.n(s,!1,n),E.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const a=new Set;this.k(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(s,a){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(a.add(r),e.$vn.test(r)){const o=this.a.get(r),v=o?.valuesSources??new Map;if(t)for(const j of Object.keys(i[r]))v.set(j,t);const w={...o?.value||{},...i[r]};this.a.set(r,{source:t,value:w,valuesSources:v});const u=(0,D.$ti)(r),$={type:"object",default:w,description:N.localize(1,null,u),$ref:e.$sn,defaultDefaultValue:w,source:A.$yf(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.d[r]=$,this.b.properties[r]=$}else{this.a.set(r,{value:i[r],source:t});const o=this.d[r];o&&(this.w(r,o),this.r(r,o))}this.m(n)}deregisterDefaultConfigurations(s){const a=new Set;this.l(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(s,a){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),o=A.$yf(i)?i:i?.id,v=A.$yf(r?.source)?r?.source:r?.source?.id;if(o===v)if(a.add(t),this.a.delete(t),e.$vn.test(t))delete this.d[t],delete this.b.properties[t];else{const w=this.d[t];w&&(this.w(t,w),this.r(t,w))}}this.u()}deltaConfiguration(s){let a=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),a=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),a=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const a of s)this.h.add(a);this.u()}n(s,a,n){s.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,a){const n=i=>{if(i.properties)for(const t in i.properties){a.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,a=!0,n,i,t=3,r){t=A.$Hf(s.scope)?t:s.scope;const o=s.properties;if(o)for(const w in o){const u=o[w];if(a&&h(w,u)){delete o[w];continue}if(u.source=n,u.defaultDefaultValue=o[w].default,this.w(w,u),e.$vn.test(w)?u.scope=void 0:(u.scope=A.$Hf(u.scope)?t:u.scope,u.restricted=A.$Hf(u.restricted)?!!i?.includes(w):u.restricted),o[w].hasOwnProperty("included")&&!o[w].included){this.f[w]=o[w],delete o[w];continue}else this.d[w]=o[w],o[w].policy?.name&&this.e.set(o[w].policy.name,w);!o[w].deprecationMessage&&o[w].markdownDeprecationMessage&&(o[w].deprecationMessage=o[w].markdownDeprecationMessage),r.add(w)}const v=s.allOf;if(v)for(const w of v)this.p(w,a,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const a=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(a)};a(s)}r(s,a){switch(e.$mn.properties[s]=a,a.scope){case 1:e.$nn.properties[s]=a;break;case 2:e.$on.properties[s]=a;break;case 6:e.$pn.properties[s]=a;break;case 3:e.$qn.properties[s]=a;break;case 4:e.$rn.properties[s]=a;break;case 5:e.$rn.properties[s]=a,this.g.properties[s]=a;break}}s(s,a){switch(delete e.$mn.properties[s],a.scope){case 1:delete e.$nn.properties[s];break;case 2:delete e.$on.properties[s];break;case 6:delete e.$pn.properties[s];break;case 3:delete e.$qn.properties[s];break;case 4:case 5:delete e.$rn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const a=`[${s}]`,n={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$sn};this.w(a,n),e.$mn.properties[a]=n,e.$nn.properties[a]=n,e.$on.properties[a]=n,e.$pn.properties[a]=n,e.$qn.properties[a]=n,e.$rn.properties[a]=n}}v(){const s={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=s,e.$nn.patternProperties[e.$un]=s,e.$on.patternProperties[e.$un]=s,e.$pn.patternProperties[e.$un]=s,e.$qn.patternProperties[e.$un]=s,e.$rn.patternProperties[e.$un]=s,this.i.fire()}w(s,a){const n=this.a.get(s);let i=n?.value,t=n?.source;A.$Ff(i)&&(i=a.defaultDefaultValue,t=void 0),A.$Ff(i)&&(i=f(a.type)),a.default=i,a.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",d=new RegExp(l,"g");e.$un=`^(${l})+$`,e.$vn=new RegExp(e.$un);function p(S){const s=[];if(e.$vn.test(S)){let a=d.exec(S);for(;a?.length;){const n=a[1].trim();n&&s.push(n),a=d.exec(S)}}return(0,I.$Mb)(s)}e.$wn=p;function y(S){return S.reduce((s,a)=>`${s}[${a}]`,"")}e.$xn=y;function f(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=f;const c=new b;k.$gn.add(e.$ln.Configuration,c);function h(S,s){return S.trim()?e.$vn.test(S)?N.localize(7,null,S):c.getConfigurationProperties()[S]!==void 0?N.localize(8,null,S):s.policy?.name&&c.getPolicyConfigurations().get(s.policy?.name)!==void 0?N.localize(9,null,S,s.policy?.name,c.getPolicyConfigurations().get(s.policy?.name)):null:N.localize(6,null)}e.$zn=h;function m(){const S=[],s=c.getConfigurationProperties();for(const a of Object.keys(s))S.push([a,s[a].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.$An=m}),define(oe[74],ae([0,1,18,3,35,2,34,30,12,10,20,50,40]),function(te,e,I,L,A,N,D,R,k,g,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function l(a){return Object.isFrozen(a)?a:R.$8m(a)}class d{constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof d)return i;const t=new p("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$ri)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,o=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:o}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,C.$ri)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return I.$Mb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return I.$Mb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=R.$7m(this.contents),t=R.$7m(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const v of n)if(o.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const w of v.overrides){const[u]=t.filter($=>I.$ub($.identifiers,w.identifiers));u?(this.h(u.contents,w.contents),u.keys.push(...w.keys),u.keys=I.$Mb(u.keys)):t.push(R.$7m(w))}for(const w of v.keys)r.indexOf(w)===-1&&r.push(w)}return new d(i,r,t,o.every(v=>v instanceof d)?void 0:o)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of I.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[r];const v=i[r];v&&(typeof o=="object"&&typeof v=="object"?(o=R.$7m(o),this.h(o,v)):o=v),t[r]=o}return new d(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&k.$Af(n[t])&&k.$Af(i[t])){this.h(n[t],i[t]);continue}n[t]=R.$7m(i[t])}}i(n){let i=null,t=null;const r=o=>{o&&(t?this.h(t,o):t=R.$7m(o))};for(const o of this.overrides)o.identifiers.length===1&&o.identifiers[0]===n?i=o.contents:o.identifiers.includes(n)&&r(o.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,C.$qi)(this.contents,n),E.$vn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>I.$ub(t.identifiers,(0,E.$wn)(n))),1))}j(n,i,t){(0,C.$pi)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),E.$vn.test(n)&&this.overrides.push({identifiers:(0,E.$wn)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$oi)(this.contents[n],r=>console.error(r))})}}e.$Bn=d;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!k.$Hf(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:o,restricted:v,hasExcludedProperties:w}=this.h(n,i);this.b=new d(t,r,o,w?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const o=[],v=[];function w($){Array.isArray(r)?r.push($):t!==null&&(r[t]=$)}const u={onObjectBegin:()=>{const $={};w($),o.push(r),r=$,t=null},onObjectProperty:$=>{t=$},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const $=[];w($),o.push(r),r=$,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:w,onError:($,j,M)=>{v.push({error:$,offset:j,length:M})}};if(n)try{A.$4m(n,u),i=r[0]||{}}catch($){console.error(`Error while parsing settings file ${this.f}: ${$}`),this.d=[$]}return i}h(n,i){const t=b.$gn.as(E.$ln.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const o=(0,C.$oi)(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),v=Object.keys(n),w=this.j(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:o,keys:v,overrides:w,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:o};const v={},w=[];for(const u in n)if(E.$vn.test(u)&&t){const $=this.i(n[u],i,!1,r);v[u]=$.raw,o=o||$.hasExcludedProperties,w.push(...$.restricted)}else{const $=i[u],j=$?typeof $.scope<"u"?$.scope:3:void 0;$?.restricted&&w.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(j===void 0||r.scopes===void 0||r.scopes.includes(j))&&!(r.skipRestricted&&$?.restricted))?v[u]=n[u]:o=!0}return{raw:v,restricted:w,hasExcludedProperties:o}}j(n,i){const t=[];for(const r of Object.keys(n))if(E.$vn.test(r)){const o={};for(const v in n[r])o[v]=n[r][v];t.push({identifiers:(0,E.$wn)(r),keys:Object.keys(o),contents:(0,C.$oi)(o,i)})}return t}}e.$Cn=p;class y extends N.$Sc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new L.$Nd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,o=>o.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=y;class f{constructor(n,i,t,r,o,v,w,u,$,j,M,U,z){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=o,this.f=v,this.g=w,this.h=u,this.i=$,this.j=j,this.k=M,this.l=U,this.m=z}get value(){return l(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(n,i,t,r,o=new d,v=new d,w=new D.$Ac,u=new d,$=new D.$Ac){this.c=n,this.d=i,this.f=t,this.g=r,this.h=o,this.i=v,this.j=w,this.l=u,this.m=$,this.a=null,this.b=new D.$Ac,this.n=null}getValue(n,i,t){return this.q(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new d,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.q(n,i,t),o=this.u(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,w=new Set;for(const u of r.overrides)for(const $ of u.identifiers)r.getOverrideValue(n,$)!==void 0&&w.add($);return new f(n,i,r.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,o||void 0,v)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:o,removed:v}=S(this.c,n);i=[...r,...o,...v]}for(const r of i)for(const o of(0,E.$wn)(r)){const v=this.c.getKeysForOverrideIdentifier(o),w=n.getKeysForOverrideIdentifier(o),u=[...w.filter($=>v.indexOf($)===-1),...v.filter($=>w.indexOf($)===-1),...v.filter($=>!R.$$m(this.c.override(o).getValue($),n.override(o).getValue($)))];t.push([o,u])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=S(this.d,n),o=[...i,...t,...r];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(n,i){const t=this.p.get(n),{added:r,updated:o,removed:v,overrides:w}=S(t,i),u=[...r,...o,...v];return(u.length||!t)&&this.updateFolderConfiguration(n,i),{keys:u,overrides:w}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:o,overrides:v}=S(i,void 0);return{keys:[...t,...r,...o],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,t){let r=this.r(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},i){let t=this.s();if(i&&n){const r=i.getFolder(n);r&&(t=this.t(r.uri)||t);const o=this.m.get(n);o&&(t=t.merge(o))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const t=this.s(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}u(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:o}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:o}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.x(n.defaults),t=this.x(n.policy),r=this.x(n.application),o=this.x(n.user),v=this.x(n.workspace),w=n.folders.reduce((u,$)=>(u.set(g.URI.revive($[0]),this.x($[1])),u),new D.$Ac);return new c(i,t,r,o,new d,v,w,new d,new D.$Ac)}static x(n){return new d(n.contents,n.keys,n.overrides)}}e.$En=c;function h(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const r of a)r.keys.forEach(o=>n.add(o)),r.overrides.forEach(([o,v])=>{const w=(0,D.$xc)(i,o,new Set);v.forEach(u=>w.add(u))});const t=[];return i.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$Fn=h;class m{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of n.keys)this.affectedKeys.add(o);for(const[,o]of n.overrides)for(const v of o)this.affectedKeys.add(v);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const o=r+t.length;if(o>=this.d.length)return!1;const v=this.d.charCodeAt(o);if(v!==this.b&&v!==this.c)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,u=this.g.getValue(n,i,this.h);return!R.$$m(w,u)}return!0}}e.$Gn=m;function S(a,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,a?.rawConfiguration),o=[],v=a?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const u=w.filter($=>!v.includes($));for(const $ of u)o.push([$,n.getKeysForOverrideIdentifier($)])}if(a){const u=v.filter($=>!w.includes($));for(const $ of u)o.push([$,a.getKeysForOverrideIdentifier($)])}if(n&&a){for(const u of v)if(w.includes(u)){const $=s({contents:a.getOverrideValue(void 0,u)||{},keys:a.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});o.push([u,[...$.added,...$.removed,...$.updated]])}}return{added:i,removed:t,updated:r,overrides:o}}function s(a,n){const i=a?n?a.keys.filter(o=>n.keys.indexOf(o)===-1):[...a.keys]:[],t=n?a?n.keys.filter(o=>a.keys.indexOf(o)===-1):[...n.keys]:[],r=[];if(a&&n){for(const o of n.keys)if(a.keys.indexOf(o)!==-1){const v=(0,C.$ri)(n.contents,o),w=(0,C.$ri)(a.contents,o);R.$$m(v,w)||r.push(o)}}return{added:i,removed:t,updated:r}}}),define(oe[208],ae([0,1,18,3,2,30,12,74,50,7,56,40]),function(te,e,I,L,A,N,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=void 0;class b extends A.$Sc{constructor(){super(...arguments),this.a=this.B(new L.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Bn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$gn.as(k.$ln.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:f})=>this.c(Array.from(y),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(y,f){this.h(y,E.$gn.as(k.$ln.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:y})}f(){return{}}g(){this.b=new R.$Bn;const y=E.$gn.as(k.$ln.Configuration).getConfigurationProperties();this.h(Object.keys(y),y)}h(y,f){const c=this.f();for(const h of y){const m=c[h],S=f[h];m!==void 0?this.b.addValue(h,m):S?this.b.addValue(h,S.default):this.b.removeValue(h)}}}e.$Hn=b;class l{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new R.$Bn}async initialize(){return this.configurationModel}}e.$In=l;let d=class extends A.$Sc{get configurationModel(){return this.b}constructor(y,f,c){super(),this.c=y,this.f=f,this.g=c,this.a=this.B(new L.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Bn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(y=>this.j(y))),this.B(this.c.onDidChangeConfiguration(async({properties:y})=>this.m(await this.h(y),!0))),this.b}async h(y){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",y);const f={},c=[],h=E.$gn.as(k.$ln.Configuration).getConfigurationProperties();for(const m of y){const S=h[m];if(!S){c.push(m);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.g.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}c.push(m),f[S.policy.name]={type:S.type}}}return(0,D.$Lf)(f)||await this.f.updatePolicyDefinitions(f),c}j(y){this.g.trace("PolicyConfiguration#onDidChangePolicies",y);const f=E.$gn.as(k.$ln.Configuration).getPolicyConfigurations(),c=(0,I.$Hb)(y.map(h=>f.get(h)));this.m(c,!0)}m(y,f){this.g.trace("PolicyConfiguration#update",y);const c=E.$gn.as(k.$ln.Configuration).getConfigurationProperties(),h=[],m=this.b.isEmpty();for(const S of y){const s=c[S]?.policy?.name;if(s){const a=this.f.getPolicyValue(s);(m?a!==void 0:!(0,N.$$m)(this.b.getValue(S),a))&&h.push([S,a])}else this.b.getValue(S)!==void 0&&h.push([S,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const S=this.b;this.b=new R.$Bn;for(const s of S.keys)this.b.setValue(s,S.getValue(s));for(const[s,a]of h)a===void 0?this.b.removeValue(s):this.b.setValue(s,a);f&&this.a.fire(this.b)}}};e.$Jn=d,e.$Jn=d=ye([Y(1,C.$in),Y(2,g.$0i)],d)}),define(oe[209],ae([0,1,6,3,2,19,20,74,208,56]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class C extends A.$Sc{constructor(b,l,d,p){super(),this.j=b,this.h=this.B(new L.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$Hn),this.c=d instanceof g.$kn?new k.$In:this.B(new k.$Jn(this.b,d,p)),this.f=this.B(new R.$Dn(this.j,{},N.$mg,l)),this.a=new R.$En(this.b.configurationModel,this.c.configurationModel,new R.$Bn,new R.$Bn),this.g=this.B(new I.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:y,properties:f})=>this.n(y,f))),this.B(this.c.onDidChangeConfiguration(y=>this.r(y))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,l,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$En(b,l,new R.$Bn,d)}getConfigurationData(){return this.a.toData()}getValue(b,l){const d=typeof b=="string"?b:void 0,p=(0,D.$ki)(b)?b:(0,D.$ki)(l)?l:{};return this.a.getValue(d,p,void 0)}updateValue(b,l,d,p){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const l=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(b);this.s(d,l,2)}n(b,l){const d=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(b,l);this.s(p,d,7)}r(b){const l=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(b);this.s(d,l,7)}s(b,l,d){const p=new R.$Gn(b,{data:l},this.a);p.source=d,p.sourceConfig=this.t(d),this.h.fire(p)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Kn=C}),define(oe[210],ae([0,1,15,3,2,66]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckb=e.$Bkb=e.$Akb=e.$zkb=void 0;const D=(g,C,E)=>{const b=new Uint8Array(16);for(let p=0;p<16;p++)b[p]=Math.round(Math.random()*256);const l=(0,I.$ve)(I.$be.wrap(b));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$zkb=D,e.$Akb=I.$be.fromString(`\r
\r
`);async function R(g,C,E,b,l){g.write(I.$be.fromString((0,e.$zkb)(C,E,b)));const d=new A.$Rc;try{return await new Promise((p,y)=>{let f;d.add(g.onData(c=>{f?f=I.$be.concat([f,c],f.byteLength+c.byteLength):f=c;const h=f.indexOf(e.$Akb);if(h===-1)return;p(g),g.pauseData();const m=f.slice(h+e.$Akb.byteLength);m.byteLength&&l.onData.fire(m)})),d.add(g.onClose(c=>y(c??new Error("socket closed")))),d.add(g.onEnd(()=>y(new Error("socket ended"))))})}catch(p){throw g.dispose(),p}finally{d.dispose()}}e.$Bkb=R;class k extends A.$Sc{constructor(C,E){super(),this.g=C,this.a=this.B(new L.$Qd),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new L.$Nd),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(b=>this.a.fire(b))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,E){N.SocketDiagnostics.traceSocketEvent(this,this.g,C,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Ckb=k}),define(oe[211],ae([0,1,8,4]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,L.$Ph)("remoteAuthorityResolverService");var A;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class N{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=N;class D{constructor(E,b){this.host=E,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=D;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class k extends I.$bb{static isNotAvailable(E){return E instanceof k&&E._code===R.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof k&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof k&&E._code===R.NoResolverFound}static isInvalidAuthority(E){return E instanceof k&&E._code===R.InvalidAuthority}static isHandled(E){return E instanceof k&&E.isHandled}constructor(E,b=R.Unknown,l){super(E),this._message=E,this._code=b,this._detail=l,this.isHandled=b===R.NotAvailable&&l===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Sk=k;function g(C){const E=C.indexOf("+");return E===-1?C:C.substring(0,E)}e.$Tk=g}),define(oe[75],ae([0,1,23]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function L(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}e.$Uk=L;function A(g){if(!g)return;const C=g.indexOf("+");return C<0?g:g.substr(0,C)}e.$Vk=A;function N(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Wk=N;function D(g){const{host:C,port:E}=k(g);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}e.$Xk=D;function R(g,C){let{host:E,port:b}=k(g);return typeof b>"u"&&(b=C),{host:E,port:b}}e.$Yk=R;function k(g){const C=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=g.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const b=g.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:g,port:void 0}}}),define(oe[44],ae([0,1,27,4,75]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function N(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$4l=N,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(D||(e.ExtensionType=D={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class k{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,f){if(typeof y>"u"||y===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof y=="string"||typeof f=="string"){const c=typeof y=="string"?y:y.value,h=typeof f=="string"?f:f.value;return I.$2e(c,h)}return y._lower===f._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.$6l=k;class g{get size(){return this.c.size}constructor(y){if(this.c=new Set,y)for(const f of y)this.add(f)}add(y){this.c.add(k.toKey(y))}delete(y){return this.c.delete(k.toKey(y))}has(y){return this.c.has(k.toKey(y))}}e.$7l=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(y){this.c.delete(k.toKey(y))}get(y){return this.c.get(k.toKey(y))}has(y){return this.c.has(k.toKey(y))}set(y,f){this.c.set(k.toKey(y),f)}values(){return this.c.values()}forEach(y){this.c.forEach(y)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=C;function E(p){return b(p)}e.$9l=E;function b(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$0l=b;function l(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$$l=l;function d(p,y){if(y){const f=`onResolveRemoteAuthority:${(0,A.$Vk)(y)}`;return!!p.activationEvents?.includes(f)}return!1}e.$_l=d,e.$am=(0,L.$Ph)("IBuiltinExtensionsScannerService")}),define(oe[212],ae([0,1,2,44,11]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;class N extends I.$Sc{constructor(R,k,g,C,E){super(),this.a=R,this.b=k,this.c=g,this.f=E,this.B(C.onDidInstallExtensions(b=>this.g(b))),this.B(C.onDidUninstallExtension(b=>this.h(b)))}g(R){for(const k of R)k.local&&this.invalidate(k.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,R)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,L.$Zl))}catch(k){(0,A.$pk)(k)!==1&&this.f.error(k)}}}e.$Hp=N}),define(oe[213],ae([0,1,6,15,26,8,3,2,100,61,32,66,211,75]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.PersistentConnectionEventType=e.$6k=e.$5k=e.$4k=e.ConnectionType=void 0;const d=30*1e3;var p;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function y(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(B){const P=new A.$Xd;return setTimeout(()=>P.cancel(),B),P.token}function c(B,P){if(B.isCancellationRequested||P.isCancellationRequested)return A.CancellationToken.Cancelled;const O=new A.$Xd;return B.onCancellationRequested(()=>O.cancel()),P.onCancellationRequested(()=>O.cancel()),O.token}class h{get didTimeout(){return this.c==="timedout"}constructor(P){this.c="pending",this.d=new R.$Rc,this.promise=new Promise((O,T)=>{this.f=O,this.g=T}),P.isCancellationRequested?this.h():this.d.add(P.onCancellationRequested(()=>this.h()))}registerDisposable(P){this.c==="pending"?this.d.add(P):P.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(P))}reject(P){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(P))}}function m(B,P){const O=new h(P);return O.registerDisposable(B.onControlMessage(T=>{const F=JSON.parse(T.toString()),V=W(F);V?O.reject(V):O.resolve(F)})),O.promise}function S(B,P,O,T,F,V,G,re){const ce=new h(re),ue=g.$Jd.create(!1);return B.info(`Creating a socket (${G})...`),k.mark(`code/willCreateSocket/${V}`),P.connect(O,T,F,G).then(he=>{ce.didTimeout?(k.mark(`code/didCreateSocketError/${V}`),B.info(`Creating a socket (${G}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(k.mark(`code/didCreateSocketOK/${V}`),B.info(`Creating a socket (${G}) was successful after ${ue.elapsed()} ms.`),ce.resolve(he))},he=>{k.mark(`code/didCreateSocketError/${V}`),B.info(`Creating a socket (${G}) returned an error after ${ue.elapsed()} ms.`),B.error(he),ce.reject(he)}),ce.promise}function s(B,P){const O=new h(P);return B.then(T=>{O.didTimeout||O.resolve(T)},T=>{O.didTimeout||O.reject(T)}),O.promise}async function a(B,P,O,T){const F=ie(B,P);B.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let V;try{V=await S(B.logService,B.remoteSocketFactoryService,B.connectTo,(0,l.$Wk)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,y(P),`renderer-${y(P)}-${B.reconnectionToken}`,T)}catch(he){throw B.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),B.logService.error(he),he}B.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let G,re;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),G=B.reconnectionProtocol,re=!1):(G=new E.$Dh({socket:V}),re=!0),B.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const ce=await s(B.signService.createNewMessage((0,C.$eg)()),T),ue={type:"auth",auth:B.connectionToken||"00000000000000000000",data:ce.data};G.sendControl(L.$be.fromString(JSON.stringify(ue)));try{const he=await m(G,c(T,f(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(B.logService.trace(`${F} 4/6. received SignRequest control message.`),!await s(B.signService.validate(ce,he.signedData),T)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await s(B.signService.sign(he.data),T),we={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:P};return O&&(we.args=O),B.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(L.$be.fromString(JSON.stringify(we))),{protocol:G,ownsProtocol:re}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(B.logService.error(`${F} the handshake timed out. Error:`),B.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${F} received error control message when negotiating connection. Error:`),B.logService.error(he)),re&&J(G),he}}async function n(B,P,O,T){const F=Date.now(),V=ie(B,P),{protocol:G,ownsProtocol:re}=await a(B,P,O,T),ce=new h(T);return ce.registerDisposable(G.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),$e=W(he);$e?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error($e),re&&J(G),ce.reject($e)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${K(F)}!`),ce.resolve({protocol:G,firstMessage:he}))})),ce.promise}async function i(B,P){const{protocol:O}=await n(B,1,void 0,P);return{protocol:O}}async function t(B,P,O){const{protocol:T,firstMessage:F}=await n(B,2,P,O),V=F&&F.debugPort;return{protocol:T,debugPort:V}}async function r(B,P,O){const T=Date.now(),F=ie(B,3),{protocol:V}=await a(B,3,P,O);return B.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${K(T)}!`),V}async function o(B,P,O){const{connectTo:T,connectionToken:F}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,connectTo:T,connectionToken:F,reconnectionToken:P,reconnectionProtocol:O,remoteSocketFactoryService:B.remoteSocketFactoryService,signService:B.signService,logService:B.logService}}async function v(B,P,O){return u(B,async T=>{const{protocol:F}=await i(T,A.CancellationToken.None);return new H(B,P,O,T.reconnectionToken,F)})}e.$4k=v;async function w(B,P){return u(B,async O=>{const{protocol:T,debugPort:F}=await t(O,P,A.CancellationToken.None);return new Q(B,P,O.reconnectionToken,T,F)})}e.$5k=w;async function u(B,P){for(let T=1;;T++)try{const F=(0,C.$eg)(),V=await o(B,F,null);return await P(V)}catch(F){if(T<5)B.logService.error(`[remote-connection][attempt ${T}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(F);else throw B.logService.error(`[remote-connection][attempt ${T}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(F),x.triggerPermanentFailure(0,0,b.$Sk.isHandled(F)),F}}async function $(B,P,O){const T=await o(B,(0,C.$eg)(),null);return await r(T,{host:P,port:O},A.CancellationToken.None)}e.$6k=$;function j(B){return(0,I.$Hg)(P=>new Promise((O,T)=>{const F=setTimeout(O,B*1e3);P.onCancellationRequested(()=>{clearTimeout(F),O()})}))}var M;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class U{constructor(P,O){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.type=0}}e.$7k=U;class z{constructor(P,O,T,F){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.durationSeconds=T,this.c=F,this.type=1}skipWait(){this.c.cancel()}}e.$8k=z;class q{constructor(P,O,T){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.attempt=T,this.type=2}}e.$9k=q;class Z{constructor(P,O,T){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.attempt=T,this.type=4}}e.$0k=Z;class X{constructor(P,O,T,F){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.attempt=T,this.handled=F,this.type=3}}e.$$k=X;class x extends R.$Sc{static triggerPermanentFailure(P,O,T){this._permanentFailure=!0,this.f=P,this.g=O,this.h=T,this.j.forEach(F=>F.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(P=>P.y())}static debugPauseSocketWriting(){this.j.forEach(P=>P.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(P,O,T,F,V){super(),this.t=P,this.u=O,this.reconnectionToken=T,this.protocol=F,this.w=V,this.m=this.B(new D.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(F.onSocketClose(G=>{const re=_(this.t,this.reconnectionToken,!0);G?G.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(F.onSocketTimeout(G=>{const re=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Qc)(()=>{const G=x.j.indexOf(this);G>=0&&x.j.splice(G,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const P=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const F=T<O.length?O[T]:O[O.length-1];try{if(F>0){const G=j(F);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,G)),this.u.logService.info(`${P} waiting for ${F} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this.u.logService.info(`${P} resolving connection...`);const V=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${P} connecting to ${V.connectTo}...`),await this.G(V,f(d)),this.u.logService.info(`${P} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this.u.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(b.$Sk.isTemporarilyNotAvailable(V)){this.u.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this.u.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((0,N.$4)(V)){this.u.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if(V instanceof b.$Sk){this.u.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,b.$Sk.isHandled(V));break}this.u.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!this.n&&!this.s)}C(P,O,T){this.w?x.triggerPermanentFailure(P,O,T):this.D(P,O,T)}D(P,O,T){this.m.fire(new X(this.reconnectionToken,P,O,T)),J(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_k=x;class H extends x{constructor(P,O,T,F,V){super(1,P,F,V,!0),this.client=this.B(new E.$Bh(V,{remoteAuthority:O,clientId:T},P.ipcLogger))}async G(P,O){await i(P,O)}}e.$al=H;class Q extends x{constructor(P,O,T,F,V){super(2,P,T,F,!1),this.H=O,this.debugPort=V}async G(P,O){await t(P,this.H,O)}}e.$bl=Q;function J(B){try{B.acceptDisconnect();const P=B.getSocket();B.dispose(),P.dispose()}catch(P){(0,N.$1)(P)}}function W(B){if(B&&B.type==="error"){const P=new Error(`Connection error: ${B.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function ee(B,P){for(;B.length<P;)B+=" ";return B}function ne(B,P){return`[remote-connection][${ee(y(B),13)}][${P.substr(0,5)}\u2026]`}function _(B,P,O){return`${ne(B,P)}[${O?"reconnect":"initial"}]`}function ie(B,P){return`${_(P,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.connectTo}]`}function K(B){return`${Date.now()-B} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk=(0,L.$Ph)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(D,R){return this.a[D]??=[],this.a[D].push(R),(0,I.$Qc)(()=>{const k=this.a[D]?.indexOf(R);typeof k=="number"&&k>=0&&this.a[D]?.splice(k,1)})}b(D){return(this.a[D.type]||[]).find(k=>k.supports(D))}connect(D,R,k,g){const C=this.b(D);if(!C)throw new Error(`No socket factory found for ${D}`);return C.connect(D,R,k,g)}}e.$1k=A}),define(oe[214],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W8b=e.$V8b=void 0,e.$V8b=(0,I.$Ph)("sharedProcessTunnelService"),e.$W8b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,164]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$78b=e.$68b=e.$58b=e.$48b=e.$38b=e.TunnelStates=e.$28b=e.$18b=void 0,e.$18b=(0,I.$Ph)("IRemoteTunnelService"),e.$28b={active:!1};var A;(function(N){N.disconnected=D=>({type:"disconnected",onTokenFailed:D}),N.connected=(D,R)=>({type:"connected",info:D,serviceInstallFailed:R}),N.connecting=D=>({type:"connecting",progress:D}),N.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$38b="remote.tunnels.access",e.$48b=e.$38b+".hostNameOverride",e.$58b=e.$38b+".preventSleep",e.$68b="remoteTunnelService",e.$78b=(0,L.localize)(0,null)}),define(oe[57],ae([0,1,15,8,2,166,50,4,7,40]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$To=(0,R.$Ph)("requestService");class C{constructor(S){this.b=S}toJSON(){if(!this.a){const S=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?S[s]="*****":S[s]=this.b[s];this.a=S}return this.a}}class E extends A.$Sc{constructor(S){super(),this.b=0,this.a=S.createLogger("network",{name:(0,N.localize)(0,null),when:k.$oj.isEqualTo((0,k.$mj)(k.LogLevel.Trace)).serialize()})}async c(S,s,a){const n=`${S} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new C(s.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,L.$0)(i)),i}}}e.$Uo=E;function b(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.$Vo=b;function l(m){return m.res.statusCode===204}e.$Wo=l;async function d(m){return l(m)?null:(await(0,I.$ne)(m.stream)).toString()}e.$Xo=d;async function p(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);return d(m)}e.$Yo=p;async function y(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);if(l(m))return null;const s=(await(0,I.$ne)(m.stream)).toString();try{return JSON.parse(s)}catch(a){throw a.message+=`:
`+s,a}}e.$Zo=y;function f(m){h(m)}e.$1o=f;let c;function h(m){const S=g.$gn.as(D.$ln.Configuration),s=c;c={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[c],remove:s?[s]:[]})}h(1)}),define(oe[215],ae([0,1,26,23,11,57]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;let D=class{constructor(k,g){this.a=k,this.b=g}async download(k,g,C=I.CancellationToken.None){if(k.scheme===L.Schemas.file||k.scheme===L.Schemas.vscodeRemote){await this.b.copy(k,g);return}const E={type:"GET",url:k.toString(!0)},b=await this.a.request(E,C);if(b.res.statusCode===200)await this.b.writeFile(g,b.stream);else{const l=await(0,N.$Yo)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${l}`)}}};e.$TN=D,e.$TN=D=ye([Y(0,N.$To),Y(1,A.$$j)],D)}),define(oe[216],ae([0,1,15,26]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class A{constructor(R){this.a=R}listen(R,k){throw new Error("Invalid listen")}call(R,k,g,C=L.CancellationToken.None){switch(k){case"request":return this.a.request(g[0],C).then(async({res:E,stream:b})=>{const l=await(0,I.$ne)(b);return[{statusCode:E.statusCode,headers:E.headers},l]});case"resolveProxy":return this.a.resolveProxy(g[0])}throw new Error("Invalid call")}}e.$Wq=A;class N{constructor(R){this.a=R}async request(R,k){const[g,C]=await this.a.call("request",[R],k);return{res:g,stream:(0,I.$pe)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$Xq=N}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=e.$n7b=e.$m7b=void 0,e.$m7b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$n7b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$o7b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[218],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j3b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const N=await this.c();if(N){const D=String(I.a++);return this.b.set(D,N),{id:D,data:N.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,N){if(!A.id)return!0;const D=this.b.get(A.id);if(!D)return!1;this.b.delete(A.id);try{return D.validate(N)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$j3b=I}),define(oe[106],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=void 0,e.$2k="signService",e.$3k=(0,I.$Ph)(e.$2k)}),define(oe[219],ae([0,1,218]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c8b=void 0;class L extends I.$j3b{c(){return this.h().then(N=>new N.validator)}d(N){return this.h().then(D=>new D.signer().sign(N))}h(){return new Promise((N,D)=>te(["vsda"],N,D))}}e.$c8b=L}),define(oe[76],ae([0,1,3,2]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aDb=e.$_Cb=e.$$Cb=e.$0Cb=void 0;class A extends L.$Sc{constructor(E,b,l){super(),this.a=E,this.b=b,this.c=l}async getItems(){const E={profile:this.b,workspace:this.c},b=await this.a.call("getItems",E);return new Map(b)}updateItems(E){const b={profile:this.b,workspace:this.c};return E.insert&&(b.insert=Array.from(E.insert.entries())),E.delete&&(b.delete=Array.from(E.delete.values())),this.a.call("updateItems",b)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class N extends A{constructor(E,b){super(E,b,void 0),this.f=this.B(new I.$Nd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class D extends N{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$0Cb=D;class R extends N{constructor(E,b){super(E,b)}async close(){this.dispose()}}e.$$Cb=R;class k extends A{constructor(E,b){super(E,void 0,b),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$_Cb=k;class g{constructor(E){this.a=E}isUsed(E){const b={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",b)}}e.$aDb=g}),define(oe[107],ae([0,1,5,37,32]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=void 0;function N(k){if(I.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function D(k,g,C,E,b,l,d,p,y){const f=Object.create(null);f["common.machineId"]=l,f["common.sqmId"]=d,f.sessionID=(0,A.$eg)()+Date.now(),f.commitHash=E,f.version=b,f["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,I.$i)(I.$u),f["common.nodePlatform"]=L.$dc,f["common.nodeArch"]=C,f["common.product"]=y||"desktop",p&&(f["common.msftInternal"]=p);let c=0;const h=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),I.$m&&(f["common.snap"]="true");const m=N(g);return m&&(f["common.platformDetail"]=m),f}e.$io=D;function R(k){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return k.some(E=>C===E)}e.$jo=R}),define(oe[22],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,I.$Ph)("telemetryService"),e.$dl=(0,I.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var L;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var A;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(oe[220],ae([0,1,36,6,35,23,16,5,10,143,31,146,95,11,24,22]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=e.$Fr=e.$Er=void 0;const y=new Map;async function f(s,a){const n=`${s}::${a.join(":")}`,i=y.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,v=2e4;function w($,j,M,U){const z=j.substring($.length+1);return L.Promises.withAsyncBody(async q=>{let Z;try{Z=await C.Promises.readdir(j,{withFileTypes:!0})}catch{q();return}if(U.count>=v){U.count+=Z.length,U.maxReached=!0,q();return}let X=Z.length;if(X===0){q();return}let x=Z;U.count+Z.length>v&&(U.maxReached=!0,X=v-U.count,x=Z.slice(0,X)),U.count+=Z.length;for(const H of x)if(H.isDirectory()){if(M.includes(H.name)||await w($,(0,D.$jc)(j,H.name),M,U),--X===0){q();return}}else{const Q=H.name.lastIndexOf(".");if(Q>=0){const J=H.name.substring(Q+1);J&&r.set(J,(r.get(J)??0)+1)}for(const J of t)J.relativePathPattern?.test(z)!==!1&&J.filePattern.test(H.name)&&o.set(J.tag,(o.get(J.tag)??0)+1);if(--X===0){q();return}}})}const u=L.Promises.withAsyncBody(async $=>{const j={count:0,maxReached:!1};await w(s,s,a,j);const M=await m(s);$({configFiles:c(o),fileTypes:c(r),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:M})});return y.set(n,u),u}e.$Er=f;function c(s){return Array.from(s.entries(),([a,n])=>({name:a,count:n})).sort((a,n)=>n.count-a.count)}function h(){const s={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/l.$Gk.GB).toFixed(2)}GB (${(I.freemem()/l.$Gk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$Rm.value()*100)}%`},a=I.cpus();return a&&a.length>0&&(s.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),s}e.$Fr=h;async function m(s){try{const a=new Map,n=(0,D.$jc)(s,".vscode","launch.json"),i=await C.Promises.readFile(n),t=[],r=(0,A.$Wm)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,A.$6m)(r)==="object"&&r.configurations)for(const o of r.configurations){const v=o.type;v&&(a.has(v)?a.set(v,a.get(v)+1):a.set(v,1))}return c(a)}catch{return[]}}e.$Gr=m;let S=class{constructor(a,n){this.c=a,this.d=n}f(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}g(a){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const i=I.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/l.$Gk.GB).toFixed(2)}GB (${(I.freemem()/l.$Gk.GB).toFixed(2)}GB free)`),R.$j||n.push(`Load (avg):       ${I.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$Rm.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,E.$Dr)(a.mainPID),this.k(a)]).then(async i=>{let[t,r]=i,o=this.m(a,t);return n.forEach(v=>{if((0,b.$rm)(v))o+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(o+=`

Remote: ${v.hostName}`,v.processes&&(o+=`
${this.m(a,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const w of Object.keys(v.workspaceMetadata)){const u=v.workspaceMetadata[w];let $=`${u.fileCount} files`;u.maxFilesReached&&($=`more than ${$}`),r+=`|    Folder (${w}): ${$}`,r+=this.h(u)}}}),{processInfo:o,workspaceInfo:r}})}async getSystemInfo(a,n){const{memory:i,vmHint:t,os:r,cpus:o}=h(),v={os:r,memory:i,cpus:o,vmHint:t,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return R.$j||(v.load=`${I.loadavg().map(w=>Math.round(w)).join(", ")}`),R.$l&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(a,n){const i=[];return(0,E.$Dr)(a.mainPID).then(async t=>(i.push(""),i.push(this.g(a)),i.push(""),i.push(this.m(a,t)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(a))),n.forEach(r=>{if((0,b.$rm)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(a,r.processes)),r.workspaceMetadata)for(const o of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[o];let w=`${v.fileCount} files`;v.maxFilesReached&&(w=`more than ${w}`),i.push(`Folder (${o}): ${w}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(a){const n=[];let t=0;const r=(u,$)=>{const j=` ${u}(${$})`;t+j.length>60?(n.push(o),o="|                 ",t=o.length):t+=j.length,o+=j};let o="|      File types:";const v=10,w=a.fileTypes.length>v?v:a.fileTypes.length;for(let u=0;u<w;u++){const $=a.fileTypes[u];r($.name,$.count)}if(n.push(o),a.configFiles.length>=0&&(o="|      Conf files:",t=0,a.configFiles.forEach(u=>{r(u.name,u.count)}),n.push(o)),a.launchConfigFiles.length>0){let u="|      Launch Configs:";a.launchConfigFiles.forEach($=>{const j=$.count>1?` ${$.name}(${$.count})`:` ${$.name}`;u+=j}),n.push(u)}return n.join(`
`)}j(a){const n=Math.max(...Object.keys(a).map(i=>i.length));return Object.keys(a).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${a[i]}`).join(`
                  `)}k(a){const n=[],i=[];return a.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const o=k.URI.revive(r);if(o.scheme===N.Schemas.file){const v=o.fsPath;i.push(f(v,["node_modules",".git"]).then(w=>{let u=`${w.fileCount} files`;w.maxFilesReached&&(u=`more than ${u}`),n.push(`|    Folder (${(0,D.$nc)(v)}): ${u}`),n.push(this.h(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${w.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(a,n){const i=new Map;a.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:o})=>i.set(r,o));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(a.mainPID,i,t,n,0),t.join(`
`)}n(a,n,i,t,r){const o=r===0;let v;o?v=t.pid===a?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const w=process.platform==="win32"?t.mem:I.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(w/l.$Gk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(u=>this.n(a,n,i,u,r+1))}async getWorkspaceFileExtensions(a){const n=new Set;for(const{uri:i}of a.folders){const t=k.URI.revive(i);if(t.scheme!==N.Schemas.file)continue;const r=t.fsPath;try{(await f(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const i=k.URI.revive(n);if(i.scheme!==N.Schemas.file)continue;const t=i.fsPath;try{const r=await f(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};e.$Hr=S,e.$Hr=S=ye([Y(0,p.$cl),Y(1,d.$pj)],S)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=void 0;class I{constructor(N){this.b=N}listen(N,D){throw new Error(`Event not found: ${D}`)}call(N,D,{eventName:R,data:k}){return this.b.forEach(g=>g.log(R,k)),Promise.resolve(null)}}e.$r7b=I;class L{constructor(N){this.b=N}log(N,D){return this.b.call("log",{eventName:N,data:D}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$s7b=L}),define(oe[45],ae([0,1,30,12,3,20,75,107,22]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=void 0;class g{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$ko=g;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$lo=C,e.$mo=new C;class E{async publicLog(t,r,o){}async publicLogError(t,r,o){}}e.$no=E,e.$oo="telemetry",e.$po="extensionTelemetryLog",e.$qo={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,t){return A.Event.debounce(t.onDidChangeConfiguration,(o,v)=>{const w=o?new Set([...o.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:w}},1e3,!0)(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,N.$mi)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.$ro=b;function l(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$so=l;function d(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$to=d;function p(i){const t=i.getValue(k.$kl),r=i.getValue(k.$ll);if(i.getValue(k.$ml)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$uo=p;function y(i){const t={},r={},o={};h(i,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const w=o[v];typeof w=="number"?r[v]=w:typeof w=="boolean"?r[v]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${w.length}`),t[v]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(t[v]=w)}return{properties:t,measurements:r}}e.$vo=y;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(i){if(!i)return"none";const t=(0,D.$Vk)(i);return f.has(t)?t:"other"}e.$wo=c;function h(i,t,r=0,o){if(i)for(const v of Object.getOwnPropertyNames(i)){const w=i[v],u=o?o+v:v;Array.isArray(w)?t[u]=(0,I.$_m)(w):w instanceof Date?t[u]=w.toISOString():(0,L.$Af)(w)?r<2?h(w,t,r+1,u+"."):t[u]=(0,I.$_m)(w):t[u]=w}}function m(i,t){const r=i.msftInternalDomains||[],o=t.getValue("telemetry.internalTesting");return(0,R.$jo)(r)||o}e.$xo=m;function S(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$yo=S;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const o=[];for(const $ of t)for(;;){const j=$.exec(i);if(!j)break;o.push([j.index,$.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const $=w.exec(i);if(!$)break;const j=o.some(([M,U])=>$.index<U&&M<w.lastIndex);!v.test($[0])&&!j&&(r+=i.substring(u,$.index)+"<REDACTED: user-file-path>",u=w.lastIndex)}return u<i.length&&(r+=i.substr(u)),r}function a(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,I.$9m)(i,r=>{if(r instanceof g||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=s(o,t);for(const v of t)o=o.replace(v,"");return o=a(o),o}})}e.$zo=n}),define(oe[33],ae([0,1,27,29,44,5,10,8,37,45]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;function C(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,I.$We)(n.id,i.id)===0}e.$Ao=C;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,t,r)}static parse(i){const t=E.exec(i);return t&&t[1]&&t[2]?new b({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?C(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Bo=b;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(n){const i=l.exec(n);return i&&i[1]?[y(i[1]),i[2]]:[y(n),void 0]}e.$Co=d;function p(n,i){return`${n}.${i}`}e.$Do=p;function y(n){return n.toLowerCase()}e.$Eo=y;function f(n,i){return y(p(n??A.$2l,i))}e.$Fo=f;function c(n,i){const t=[],r=o=>{for(const v of t)if(v.some(w=>C(i(w),i(o))))return v;return null};for(const o of n){const v=r(o);v?v.push(o):t.push([o])}return t}e.$Go=c;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Ho=h;function m(n){return{id:new g.$ko(n.identifier.id),name:new g.$ko(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Io=m,e.$Jo=new A.$6l("pprice.better-merge");function S(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&t.every(v=>!C(v.identifier,{id:o}))){const v=n.filter(w=>C(w.identifier,{id:o}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Ko=S;async function s(n,i){if(!N.$l)return!1;let t;try{t=(await n.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){i.debug("Error while getting the os-release file.",(0,R.$0)(o))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const t=await s(n,i),r=(0,L.$6n)(t?"alpine":N.$u,k.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$Lo=a}),define(oe[221],ae([0,1,18,2,19,10,11,24,6,3,16,5,37,33]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p5b=e.$o5b=void 0;let d=class extends L.$Sc{constructor(h,m){super(),this.b=h,this.c=m,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,S])=>this.a.set(S.configPath,S))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const m=[];for(const[S,s]of this.a)if(!(s.configScheme&&s.configScheme!==h.scheme))try{const a=(await this.b.readFile((0,A.$vg)(h,S))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(a))&&m.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return m}};e.$o5b=d,e.$o5b=d=ye([Y(0,D.$$j),Y(1,R.$pj)],d);const p="extensionTips/promptedExecutableTips",y="extensionTips/lastPromptedMediumImpExeTime";class f extends d{constructor(h,m,S,s,a,n,i,t){super(i,t),this.r=h,this.s=m,this.t=S,this.u=s,this.w=a,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,o])=>{const v=[],w=[],u=[];Object.entries(o.recommendations).forEach(([$,j])=>{j.important?o.important?v.push({extensionId:$,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):w.push({extensionId:$,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):u.push({extensionId:$,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:v}),w.length&&this.h.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:w}),u.length&&this.j.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:u})}),(0,k.$Vg)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),m=await this.O(this.h);return[...h,...m]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),m=await this.O(this.h),S=await this.u.getInstalled();this.m=this.D(h,S),this.n=this.D(m,S)}D(h,m){const S=new Map;h.forEach(t=>S.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:a}=this.N([...S.keys()],m);for(const t of s){const r=S.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of a){const r=S.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of a){const r=S.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let o=i.get(r.exeName);o||(o=[],i.set(r.exeName,o)),o.push(r)}}return i}F(){if(this.m.size===0)return;const[h,m]=[...this.m.entries()][0];this.H(m).then(S=>{switch(S){case"reacted":this.M(m[0].exeName,m);break;case"ignored":this.m.delete(h);break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new L.$Tc);s.value=(0,k.$Vg)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),m=Date.now()-h,S=7*24*60*60*1e3;if(m<S){const n=this.B(new L.$Tc);n.value=(0,k.$Vg)(()=>{n.dispose(),this.G()},S-m);return}const[s,a]=[...this.n.entries()][0];this.H(a).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(a[0].exeName,a);const i=this.B(new L.$Tc);i.value=(0,k.$Vg)(()=>{i.dispose(),this.G()},S);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new L.$Tc);i.value=(0,k.$Vg)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const m=await this.u.getInstalled(1),S=h.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(a=>m.every(n=>!(0,l.$Ao)(n.identifier,{id:a})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:S,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(y,-1);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(y,h,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(h,m){const S=this.L();S[h]=m.map(({extensionId:s})=>s.toLowerCase()),this.w.store(p,JSON.stringify(S),-1,0)}N(h,m){const S=[],s=[],a=m.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return h.forEach(n=>{a.has(n.toLowerCase())?S.push(n):s.push(n)}),{installed:S,uninstalled:s}}async O(h){const m=[],S=new Map;for(const s of h.keys()){const a=h.get(s);if(!a||!(0,I.$Lb)(a.recommendations))continue;const n=[];E.$j?a.windowsPath&&n.push(a.windowsPath.replace("%USERPROFILE%",()=>b.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>b.env.ProgramFiles).replace("%APPDATA%",()=>b.env.APPDATA).replace("%WINDIR%",()=>b.env.WINDIR)):(n.push((0,C.$jc)("/usr/local/bin",s)),n.push((0,C.$jc)("/usr/bin",s)),n.push((0,C.$jc)(this.r.fsPath,s)));for(const i of n){let t=S.get(i);if(t===void 0&&(t=await this.b.exists(N.URI.file(i)),S.set(i,t)),t)for(const{extensionId:r,extensionName:o,isExtensionPack:v,whenNotInstalled:w}of a.recommendations)m.push({extensionId:r,extensionName:o,isExtensionPack:v,exeName:s,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:w})}}return m}}e.$p5b=f}),define(oe[222],ae([0,1,26,33]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XVb=void 0;async function A(N,D,R,k,g){try{const C=await N.getExtensionsControlManifest();if(!C.deprecated)return;const E=await N.getInstalled(1);for(const[b,l]of Object.entries(C.deprecated)){if(!l?.extension)continue;const{id:d,autoMigrate:p,preRelease:y}=l.extension;if(!p)continue;const f=E.find(h=>(0,L.$Ao)(h.identifier,{id:b}));if(!f)continue;const c=(await D.getExtensions([{id:d,preRelease:y}],{targetPlatform:await N.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!c){g.info(`Skipping migrating '${f.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{g.info(`Migrating '${f.identifier.id}' extension to '${d}' extension...`);const h=!k.getDisabledExtensions().some(S=>(0,L.$Ao)(S,f.identifier));await N.uninstall(f),g.info(`Uninstalled the unsupported extension '${f.identifier.id}'`);let m=E.find(S=>(0,L.$Ao)(S.identifier,{id:d}));(!m||!m.isPreReleaseVersion&&h)&&(m=await N.installFromGallery(c,{installPreReleaseVersion:!0,isMachineScoped:f.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${m.identifier.id}'`),h||(await k.disableExtension(m.identifier),g.info(`Disabled the pre-release extension '${m.identifier.id}' because the unsupported extension '${f.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,L.$Do)(f.manifest.publisher,f.manifest.name),(0,L.$Do)(m.manifest.publisher,m.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${f.identifier.id}' extension to '${d}' extension.`)}catch(h){g.error(h)}}}catch(C){g.error(C)}}e.$XVb=A}),define(oe[223],ae([0,1,3,2,34,33,44]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;class R extends L.$Sc{constructor(g,C,E,b,l,d,p){super(),this.f=g,this.g=C,this.h=E,this.j=b,this.m=l,this.n=d,this.r=p,this.a=this.B(new I.$Nd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.$1c),this.s().then(null,y=>p.error(y))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,L.$Pc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const E=this.L(C.identifier,C.version);g.error?this.J(E,g.profileLocation):this.I(E,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],E=[];for(const b of g.extensions){const l=this.L(b.identifier,b.version);g.error?this.I(l,g.profileLocation):(this.J(l,g.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),E.push(this.f.scanInstalledExtensionAtLocation(b.location).then(d=>{d?C.push(d):this.r.info("Extension not found at the location",b.location.toString())},d=>this.r.error(d)))))}try{await Promise.all(E),C.length&&await this.H(C)}catch(b){this.r.error(b)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],E=[],b=await this.j.scanProfileExtensions(g),l=new Set,d=new Set;for(const[p,y]of this.b)y.has(g)&&d.add(p);for(const p of b){const y=this.L(p.identifier,p.version);l.add(y),d.has(y)||(C.push(p.identifier),this.I(y,g))}for(const p of d)if(!l.has(p)){const y=this.M(p);y&&(E.push(y.identifier),this.J(p,g))}(C.length||E.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:E.length?{extensions:E,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const E of C)this.I(this.L(E.identifier,E.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let E=this.b.get(g);E||this.b.set(g,E=new A.$Bc(b=>this.m.extUri.getComparisonKey(b))),E.add(C)}J(g,C){const E=this.b.get(g);E&&E.delete(C),E?.size||this.b.delete(g)}L(g,C){return`${D.$6l.toKey(g.id)}@${C}`}M(g){const[C,E]=(0,N.$Co)(g);return E?{identifier:{id:C},version:E}:void 0}}e.$Ip=R}),define(oe[224],ae([0,1,43,45]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=void 0;async function A(N,D,R,k,g,C,E){const b={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${D.nameShort})`};if((0,L.$so)(D,R)&&(0,L.$uo)(k)===3){const l=await(0,I.$ap)(R,g,C);b["X-Market-User-Id"]=l,b["VSCode-SessionId"]=E.machineId||l}return b}e.$bp=A}),define(oe[225],ae([0,1,70,18,6,2,23,16,31,14,29,33,7,73,10]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let p=class extends l.$Uq{constructor(h,m,S,s){super(S),this.h=h,this.j=s,this.g=this.B(new y(m,s)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(h,m){const s=(await this.g.getLanguagePacks())[m];if(!s){this.j.warn(`No language pack found for ${m}`);return}const a=s.translations[h];return a?d.URI.file(a):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),m=Object.keys(h).map(S=>{const s=h[S];return{...this.f(S,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((S,s)=>S.label.localeCompare(s.label)),m}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const m=await this.g.getLanguagePacks();Object.keys(m).some(S=>m[S]&&m[S].extensions.some(s=>(0,E.$Ao)(s.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),S=await this.g.update(m);return!(0,L.$ub)(Object.keys(h),Object.keys(S))}};e.$Vq=p,e.$Vq=p=ye([Y(0,C.$ao),Y(1,g.$Xh),Y(2,C.$$n),Y(3,b.$0i)],p);let y=class extends N.$Sc{constructor(h,m){super(),this.j=m,this.c={},this.f=(0,R.$jc)(h.userDataPath,"languagepacks.json"),this.g=new A.$1g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(m=>{Object.keys(m).forEach(S=>delete m[S]),this.m(m,...h)}).then(()=>this.c)}m(h,...m){for(const S of m)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.n(h,S);Object.keys(h).forEach(S=>this.r(h[S]))}n(h,m){const S=m.identifier,s=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const a of s)if(m.location.scheme===D.Schemas.file&&f(a)){let n=h[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},h[a.languageId]=n);const i=n.extensions.filter(t=>(0,E.$Ao)(t.extensionIdentifier,S))[0];i?i.version=m.manifest.version:n.extensions.push({extensionIdentifier:S,version:m.manifest.version});for(const t of a.translations)n.translations[t.id]=(0,R.$jc)(m.location.fsPath,t.path)}}r(h){if(h){const m=(0,I.createHash)("md5");for(const S of h.extensions)m.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);h.hash=m.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let m=null;return k.Promises.readFile(this.f,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(m=h(S),S)).then(S=>{for(const a of Object.keys(S))S[a]||delete S[a];this.c=S,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),k.Promises.writeFile(this.f,s)}).then(()=>m,S=>this.j.error(S))})}};y=ye([Y(0,g.$Xh),Y(1,b.$0i)],y);function f(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const h of c.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(oe[226],ae([0,1,142,8,30,45]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(C,E,b){const l=await(0,I.$mC)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,I.$mC)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new l.AppInsightsCore,y=new d.PostChannel,f={instrumentationKey:C,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(b){f.extensionConfig={};const c={alwaysUseXhrOverride:!0,httpXHROverride:b};f.extensionConfig[y.identifier]=c}return p.initialize(f,[]),p.addTelemetryInitializer(c=>{E&&(c.ext=c.ext??{},c.ext.utc=c.ext.utc??{},c.ext.utc.flags=8462029)}),p}class g{constructor(E,b,l,d,p){this.e=E,this.f=b,this.g=l,this.h=p,this.c=D,this.d=R,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(b=>{E(b)},b=>{(0,L.$1)(b),console.error(b)})}}log(E,b){if(!this.a)return;b=(0,A.$0m)(b,this.g),b=(0,N.$vo)(b);const l=this.f+"/"+E;try{this.i(d=>{d.pluginVersionString=b?.properties.version??"Unknown",d.track({name:l,baseData:{name:l,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$rN=g}),define(oe[109],ae([0,1,2,167,14,7,24,45]),function(te,e,I,L,A,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P4b=void 0;let k=class extends I.$Sc{constructor(C,E,b,l,d=""){super(),this.b=d;const p=E.getLogger(R.$oo);if(p)this.a=this.B(p);else{const f=(0,R.$to)(l,b)?" (Not Sent)":"",c=()=>(0,R.$so)(l,b)&&C.getLevel()===N.LogLevel.Trace;this.a=this.B(E.createLogger(R.$oo,{name:(0,L.localize)(0,null,f),hidden:!c()})),this.B(C.onDidChangeLogLevel(()=>E.setVisibility(R.$oo,c()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,E){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$vo)(E))}};e.$P4b=k,e.$P4b=k=ye([Y(0,N.$0i),Y(1,N.$$i),Y(2,A.$Wh),Y(3,D.$pj)],k)}),define(oe[110],ae([0,1,2,30,5,27,168,20,50,102,24,40,22,45]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,c,h){this.k=c,this.l=h,this.d={},this.i=new I.$Rc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,N.$Fe)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$Fe)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(b.$kl)||m.affectsConfiguration(b.$ml)||m.affectsConfiguration(b.$ll))&&this.m()}))}setExperimentProperty(f,c){this.d[f]=c}m(){let f=(0,l.$uo)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const h=c.usage?3:c.error?2:0;f=Math.min(f,h)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,c,h){this.g<c||(h=(0,L.$0m)(h,this.d),h=(0,l.$zo)(h,this.j),h=(0,L.$0m)(h,this.c),this.b.forEach(m=>m.log(f,h)))}publicLog(f,c){this.n(f,3,c)}publicLog2(f,c){this.publicLog(f,c)}publicLogError(f,c){this.h&&this.n(f,2,c)}publicLogError2(f,c){this.publicLogError(f,c)}};e.$2q=d,e.$2q=d=ye([Y(1,R.$ji),Y(2,C.$pj)],d);function p(){const y=(0,D.localize)(0,null,g.default.nameLong),f=g.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=A.$p?"":(0,D.localize)(3,null),h=(0,D.localize)(4,null),m=(0,D.localize)(5,null),S=(0,D.localize)(6,null),s=(0,D.localize)(7,null),a=`
|       | ${h} | ${m} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,D.localize)(8,null);return`
${y} ${f} ${c}

&nbsp;

${s}
${a}

&nbsp;

${n}
`}E.$gn.as(k.$ln.Configuration).registerConfiguration({id:b.$jl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[b.$kl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$gn.as(k.$ln.Configuration).registerConfiguration({id:b.$jl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[b.$ml]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,D.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,D.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${b.$kl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[227],ae([0,1,15,26,272,226]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;async function D(C,E){const b=await E.request(C,L.CancellationToken.None),l=(await(0,I.$ne)(b.stream)).toString(),d=b.res.statusCode??200;return{headers:b.res.headers,statusCode:d,responseData:l}}async function R(C){const E={method:C.type,headers:C.headers};return new Promise((l,d)=>{const p=A.request(C.url??"",E,y=>{y.on("data",function(f){l({headers:y.headers,statusCode:y.statusCode??200,responseData:f.toString()})}),y.on("error",function(f){d(f)})});p.write(C.data,y=>{y&&d(y)}),p.end()})}async function k(C,E,b){const l=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),d={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:l};try{const p=C?await D(d,C):await R(d);b(p.statusCode,p.headers,p.responseData)}catch{b(0,{})}}class g extends N.$rN{constructor(E,b,l,d,p){const y={sendPOST:(f,c)=>{k(E,f,c)}};super(b,l,d,p,y)}}e.$sN=g}),define(oe[228],ae([0,1,23,93,20,14,7,24,22,108,109,110]),function(te,e,I,L,A,N,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K8b=void 0;let b=class{constructor(d,p,y,f,c,h){this.b=d,this.c=p,this.d=y,this.e=f,this.f=c,this.g=h,this.a=new Map}h(d){if(!this.a.has(d.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const y=[d.id,JSON.stringify(p),d.aiKey],c=new L.$4p(I.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new g.$s7b(c),new C.$P4b(this.d,this.e,this.f,this.g,`[${d.id}] `)];this.a.set(d.id,new E.$2q({appenders:h,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.g))}return this.a.get(d.id)}publicLog(d,p,y){this.h(d).publicLog(p,y)}publicLogError(d,p,y){this.h(d).publicLogError(p,y)}};e.$K8b=b,e.$K8b=b=ye([Y(0,A.$ji),Y(1,k.$cl),Y(2,D.$0i),Y(3,D.$$i),Y(4,N.$Wh),Y(5,R.$pj)],b)}),define(oe[77],ae([0,1,3,20,4,7]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.ProvidedOnAutoForward=e.$_u=e.TunnelPrivacyId=e.TunnelProtocol=e.$$u=e.$0u=void 0,e.$0u=(0,A.$Ph)("tunnelService"),e.$$u=(0,A.$Ph)("sharedTunnelsService");var D;(function(y){y.Http="http",y.Https="https"})(D||(e.TunnelProtocol=D={}));var R;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(R||(e.TunnelPrivacyId=R={}));function k(y){return!!y.forwardPort}e.$_u=k;var g;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function C(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(f)return{address:f[1],port:+f[2]}}e.$av=C,e.$bv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(y){return e.$bv.indexOf(y)>=0}e.$cv=E,e.$dv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(y){return e.$dv.indexOf(y)>=0}e.$ev=b;function l(y,f,c,h){if(c===1)return!1;if(c===2&&b(f)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(m?.length===4&&parseInt(m[1])>=18)return!1}return y<1024}e.$fv=l;class d{constructor(f,c,h){this.remoteAddress=f,this.localAddress=c,this.b=h,this.a=new I.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$gv=d;let p=class{constructor(f,c){this.j=f,this.k=c,this.a=new I.$Nd,this.onTunnelOpened=this.a.event,this.b=new I.$Nd,this.onTunnelClosed=this.b.event,this.c=new I.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const f=this.k.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this.f=f,f?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this.g=f.elevation,this.h=f.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const f=[],c=Array.from(this.e.values());for(const h of c){const m=Array.from(h.values());for(const S of m){const s=await S.value;s&&typeof s!="string"&&f.push(s)}}return f}async dispose(){for(const f of this.e.values()){for(const{value:c}of f.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);f.clear()}this.e.clear()}setEnvironmentTunnel(f,c,h,m,S){this.p(f,c,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:c,localAddress:h,privacy:m,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,c){(b(f)||E(f))&&(f=e.$bv[0]);const h=this.r(f,c);if(h)return++h.refcount,h.value}openTunnel(f,c,h,m,S,s=!1,a,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${S}.`);const i=this.f??f;if(!i)return;if(c||(c="localhost"),m||(m=this.l),this.f&&this.i.has(h)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,c,h,m,S,s,a,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,h),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,h);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.n(r);return(r.tunnelRemoteHost!==c||r.tunnelRemotePort!==h)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(o),o}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const c=this.e.get(f.tunnelRemoteHost);if(c){const h=c.get(f.tunnelRemotePort);h&&(h.refcount--,await this.o(f.tunnelRemoteHost,f.tunnelRemotePort,h))}}}}async o(f,c,h){if(h.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${c}.`);const m=h.value.then(async S=>{S&&typeof S!="string"&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.e.has(f)&&this.e.get(f).delete(c),m}}async closeTunnel(f,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${c} `);const h=this.e.get(f);if(h&&h.has(c)){const m=h.get(c);m.refcount=0,await this.o(f,c,m)}}p(f,c,h){this.e.has(f)||this.e.set(f,new Map),this.e.get(f).set(c,{refcount:1,value:h})}async q(f,c){const h=this.e.get(f);if(h){const m=h.get(c),S=m?await m.value:void 0;(!S||typeof S=="string")&&h.delete(c),h.size===0&&this.e.delete(f)}}r(f,c){const h=[f];E(f)?(h.push(...e.$bv),h.push(...e.$dv)):b(f)&&h.push(...e.$dv);const m=h.map(S=>this.e.get(S));for(const S of m){const s=S?.get(c);if(s)return s}}canTunnel(f){return!!C(f)}t(f,c,h,m,S,s,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${m}.`);const n=h;this.i.add(n);const i=m===void 0?h:m,t={elevationRequired:S?this.isPortPrivileged(i):!1},r={remoteAddress:{host:c,port:h},localAddressPort:m,privacy:s,public:s?s!==R.Private:void 0,protocol:a},o=f.forwardPort(r,t);return o?(this.p(c,h,o),o.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),o}};e.$hv=p,e.$hv=p=ye([Y(0,N.$0i),Y(1,L.$ji)],p)}),define(oe[229],ae([0,1,7,77,2,8,6]),function(te,e,I,L,A,N,D){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$X8b=void 0;class k extends A.$Sc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new D.$ch),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let g=class extends A.$Sc{static{R=this}static{this.a=0}constructor(E,b){super(),this.f=E,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(E,b,l,d,p,y,f){const c=new k,h=await Promise.resolve(this.f.openTunnel(E,c,l,d,p,y,f));if(!h||typeof h=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${d} (remote).`),c.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),c.dispose(),await h.dispose(),(0,N.$6)();return c.setTunnel(h),this.b.set(b,c),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${h.localAddress} (local) to ${l}:${d} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(E,b){const l=this.b.get(E);l&&l.setAddress(b)}async destroyTunnel(E){const b=this.b.get(E);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await b.dispose();return}this.c.add(E)}};e.$X8b=g,e.$X8b=g=R=ye([Y(0,L.$$u),Y(1,I.$0i)],g)}),define(oe[28],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,I.$Ph)("IUriIdentityService")}),define(oe[230],ae([0,1,28,185,11,19,128,3,2]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;class g{static{this._clock=0}constructor(b){this.uri=b,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(b){this.g=b,this.c=new k.$Rc,this.f=2**16;const l=new Map,d=p=>{let y=l.get(p.scheme);return y===void 0&&(y=b.hasProvider(p)&&!this.g.hasCapability(p,1024),l.set(p.scheme,y)),y};this.c.add(R.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(p=>{l.delete(p.scheme)})),this.extUri=new N.$kg(d),this.d=new D.$zr((p,y)=>this.extUri.compare(p,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,N.$wg)(b));const l=this.d.get(b);return l?l.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new g(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((d,p)=>d[1].time<p[1].time?1:d[1].time>p[1].time?-1:0);g._clock=0,this.d.clear();const l=this.f*.5;for(let d=0;d<l;d++)this.d.set(b[d][0],b[d][1].touch())}};e.$Ar=C,e.$Ar=C=ye([Y(0,A.$$j)],C),(0,L.$xr)(I.$Ik,C,1)}),define(oe[231],ae([0,1,3,2,11,47,34]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0;class R extends L.$Sc{constructor(g,C,E,b,l,d){super(),this.f=g,this.g=C,this.h=E,this.j=b,this.m=l,this.n=d,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$Nd),this.onDidChangeFile=this.a.event,this.b=N.$Vh.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,E,b,l){return this.g.read(g,C,E,b,l)}write(g,C,E,b,l){return this.g.write(g,C,E,b,l)}watch(g,C){this.b.set(g,g);const E=this.g.watch(this.t(g),C);return(0,L.$Qc)(()=>{this.b.delete(g),E.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,E){return this.g.rename(this.t(g),this.t(C),E)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,E){return this.g.readFileStream(this.t(g),C,E)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,E){return this.g.writeFile(this.t(g),C,E)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,E){if((0,A.$ck)(this.g))return this.g.copy(this.t(g),this.t(C),E);throw new Error("copy not supported")}cloneFile(g,C){if((0,A.$dk)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const E of g){if(E.resource.scheme!==this.f)continue;const b=this.u(E.resource);this.b.findSubstr(b)&&C.push({resource:b,type:E.type,cId:E.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$f8b=R}),define(oe[78],ae([0,1,86]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QCb=e.$PCb=e.edit=void 0;function L(D,R,k,g){const C=(0,I.$4S)(D,R,k,g)[0];return C&&(D=D.substring(0,C.offset)+C.content+D.substring(C.offset+C.length)),D}e.edit=L;function A(D,R,k){let g=k;for(;g>=0;){if(D.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&D.charAt(g)===R.charAt(0))return g+2}return 0}e.$PCb=A;function N(D,R,k){let g=k;for(;g>=0;)if(D.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&D.charAt(g)===R.charAt(1)))return g;return D.length-1}e.$QCb=N}),define(oe[232],ae([0,1,30,54,12]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x3b=void 0;function N(l,d,p,y,f,c){const h=[],m=[],S=[];if(!d){const q=l.filter(({identifier:Z})=>f.every(X=>X.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:h,removed:m,updated:S},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}l=l.map(E),d=d.map(E),p=p?p.map(E):null;const s=new Map,a=q=>{q.uuid&&s.set(q.id.toLowerCase(),q.uuid)};l.forEach(({identifier:q})=>a(q)),d.forEach(({identifier:q})=>a(q)),p?.forEach(({identifier:q})=>a(q)),y?.forEach(({identifier:q})=>a(q)),c?.forEach(q=>a(q));const n=q=>{const Z=q.identifier.uuid||s.get(q.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${q.identifier.id.toLowerCase()}`},i=(q,Z)=>(q.set(n(Z),Z),q),t=l.reduce(i,new Map),r=d.reduce(i,new Map),o=d.reduce((q,Z)=>i(q,(0,I.$7m)(Z)),new Map),v=p?p.reduce(i,new Map):null,w=y.reduce(i,new Map),u=f.reduce((q,Z)=>{const X=s.get(Z.toLowerCase());return q.add(X?`uuid:${X}`:`id:${Z.toLowerCase()}`)},new Set),$=c?c.reduce((q,{id:Z,uuid:X})=>(X=X??s.get(Z.toLowerCase()),q.add(X?`uuid:${X}`:`id:${Z.toLowerCase()}`)),new Set):null,j=D(t,r,u,!1);if(j.added.size>0||j.removed.size>0||j.updated.size>0){const q=D(v,t,u,!1),Z=D(v,r,u,!0),X=(x,H,Q,J)=>{let W,ee,ne;return H.installed?(W=J.pinned,ne=J.preRelease,W&&(ee=J.version)):(W=Q.pinned,ne=Q.preRelease,W&&(ee=Q.version)),W===void 0&&(W=H.pinned,W&&(ee=H.version)),ne===void 0&&(ne=H.preRelease),{...J,installed:H.installed||Q.installed,pinned:W,preRelease:ne,version:ee??(Q.version&&(!H.installed||L.gt(Q.version,H.version))?Q.version:H.version),state:k(H,Q,v?.get(x))}};for(const x of Z.removed.values()){const H=t.get(x);if(!H)continue;const Q=(0,A.$Jf)(v?.get(x)),J=$&&!$.has(x)&&Q.installed;H.installed&&J?m.push(H.identifier):o.set(x,H)}for(const x of Z.added.values()){const H=(0,A.$Jf)(r.get(x)),Q=t.get(x);if(Q){if(j.updated.has(x)){const J=X(x,Q,H,H);R(Q,H,!1,!1)||S.push(b(J,x)),o.set(x,J)}}else H.installed&&h.push(b(H,x))}for(const x of Z.updated.values()){const H=(0,A.$Jf)(r.get(x)),Q=(0,A.$Jf)(v?.get(x)),J=t.get(x);if(J)if($&&!$.has(x)&&Q.installed&&J.installed&&!H.installed)m.push(J.identifier);else{const ee=X(x,J,H,H);S.push(b(ee,x)),o.set(x,ee)}else H.installed&&h.push(b(H,x))}for(const x of q.added.values())Z.added.has(x)||o.set(x,(0,A.$Jf)(t.get(x)));for(const x of q.updated.values()){if(Z.removed.has(x)||Z.updated.has(x))continue;const H=(0,A.$Jf)(t.get(x)),Q=(0,A.$Jf)(r.get(x));o.set(x,X(x,H,Q,H))}for(const x of q.removed.values())Z.updated.has(x)||Z.removed.has(x)||w.has(x)||(0,A.$Jf)(r.get(x)).installed&&$&&($.has(x)||!(0,A.$Jf)(v?.get(x)).installed||o.delete(x))}const M=[],U=D(r,o,new Set,!0),z=U.added.size>0||U.updated.size>0||U.removed.size>0;return z&&o.forEach((q,Z)=>M.push(b(q,Z))),{local:{added:h,removed:m,updated:S},remote:z?{added:[...U.added].map(q=>o.get(q)),updated:[...U.updated].map(q=>o.get(q)),removed:[...U.removed].map(q=>r.get(q)),all:M}:null}}e.$x3b=N;function D(l,d,p,y){const f=l?[...l.keys()].filter(s=>!p.has(s)):[],c=[...d.keys()].filter(s=>!p.has(s)),h=c.filter(s=>!f.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),m=f.filter(s=>!c.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),S=new Set;for(const s of f){if(m.has(s))continue;const a=l.get(s),n=d.get(s);(!n||!R(a,n,y,!0))&&S.add(s)}return{added:h,removed:m,updated:S}}function R(l,d,p,y){return!(l.disabled!==d.disabled||!!l.isApplicationScoped!=!!d.isApplicationScoped||y&&l.installed!==d.installed||l.installed&&d.installed&&(l.preRelease!==d.preRelease||l.pinned!==d.pinned||d.pinned&&l.version!==d.version)||!C(l.state,d.state)||p&&l.version!==d.version)}function k(l,d,p){const y=l.state,f=d.state,c=p?.state;if(!d.version||y&&L.gt(l.version,d.version))return y;if(f&&L.gt(d.version,l.version)||!y)return f;if(!f)return y;const h=(0,I.$7m)(y),m=c?g(c,f):{added:Object.keys(f).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set},S=c?g(c,y):{added:Object.keys(y).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set};for(const s of[...m.added.values(),...m.updated.values()])h[s]=f[s];for(const s of m.removed.values())S.updated.has(s)||delete h[s];return h}function g(l,d){const p=Object.keys(l),y=Object.keys(d),f=y.filter(m=>!p.includes(m)).reduce((m,S)=>(m.add(S),m),new Set),c=p.filter(m=>!y.includes(m)).reduce((m,S)=>(m.add(S),m),new Set),h=new Set;for(const m of p){if(c.has(m))continue;const S=l[m],s=d[m];(0,I.$$m)(S,s)||h.add(m)}return{added:f,removed:c,updated:h}}function C(l={},d={}){const{added:p,removed:y,updated:f}=g(l,d);return p.size===0&&y.size===0&&f.size===0}function E(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function b(l,d){const p={...l,identifier:{id:l.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete p.disabled,l.installed||delete p.installed,l.state||delete p.state,l.isApplicationScoped||delete p.isApplicationScoped,p}}),define(oe[111],ae([0,1,18,20,4]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NEb=e.$MEb=void 0,e.$MEb=(0,A.$Ph)("IIgnoredExtensionsManagementService");let N=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const k=R.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),g=this.b().map(b=>b.toLowerCase()),C=[],E=[];if(Array.isArray(g))for(const b of g)b.startsWith("-")?E.push(b.substring(1)):C.push(b);return(0,I.$Mb)([...k,...C].filter(b=>!E.includes(b)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$NEb=N,e.$NEb=N=ye([Y(0,L.$ji)],N)}),define(oe[233],ae([0,1,18,35,30,94,78]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D3b=void 0;function R(m){return(0,L.$Wm)(m)||[]}async function k(m,S,s,a,n){const i=R(m),t=R(S),r=s?R(s):null,o=[...i,...t,...r||[]].map(X=>X.key),v=await n.resolveUserBindings(o),w=C(i,t,r,v);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const u=b(i),$=b(t),j=r?b(r):null,M=d(u,$,v),U=j?d(j,u,v):{added:[...u.keys()].reduce((X,x)=>(X.add(x),X),new Set),removed:new Set,updated:new Set},z=j?d(j,$,v):{added:[...$.keys()].reduce((X,x)=>(X.add(x),X),new Set),removed:new Set,updated:new Set},q=g(M,U,z);let Z=m;for(const X of q.removed.values())q.conflicts.has(X)||(Z=c(Z,X,a));for(const X of q.added.values()){if(q.conflicts.has(X))continue;const x=$.get(X);if(x.some(H=>H.command!==`-${X}`&&w.conflicts.has(v[H.key]))){q.conflicts.add(X);continue}Z=f(Z,x,a)}for(const X of q.updated.values()){if(q.conflicts.has(X))continue;const x=$.get(X);if(x.some(H=>H.command!==`-${X}`&&w.conflicts.has(v[H.key]))){q.conflicts.add(X);continue}Z=h(Z,X,x,a)}return{mergeContent:Z,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$D3b=k;function g(m,S,s){const a=new Set,n=new Set,i=new Set,t=new Set;for(const r of S.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(S.updated.has(r)?t.add(r):n.add(r));for(const r of S.added.values())t.has(r)||s.added.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(S.added.has(r)?m.updated.has(r)&&t.add(r):a.add(r));for(const r of S.updated.values())t.has(r)||s.updated.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(S.updated.has(r)?m.updated.has(r)&&t.add(r):i.add(r));return{added:a,removed:n,updated:i,conflicts:t}}function C(m,S,s,a){const n=new Set,i=E(m,a),t=E(S,a),r=s?E(s,a):null,o=l(i,t);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?l(r,i):{added:[...i.keys()].reduce((U,z)=>(U.add(z),U),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=r?l(r,t):{added:[...t.keys()].reduce((U,z)=>(U.add(z),U),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:u,removed:$,updated:j,conflicts:M}=g(o,v,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:$,updated:j,conflicts:M}}function E(m,S){const s=new Map;for(const a of m){const n=S[a.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(a)}return s}function b(m){const S=new Map;for(const s of m){const a=s.command[0]==="-"?s.command.substring(1):s.command;let n=S.get(a);n||(n=[],S.set(a,n)),n.push(s)}return S}function l(m,S){const s=[...m.keys()],a=[...S.keys()],n=a.filter(r=>!s.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),i=s.filter(r=>!a.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const o=m.get(r).map(w=>({...w,key:r})),v=S.get(r).map(w=>({...w,key:r}));(0,I.$ub)(o,v,(w,u)=>y(w,u))||t.add(r)}return{added:n,removed:i,updated:t}}function d(m,S,s){const a=[...m.keys()],n=[...S.keys()],i=n.filter(o=>!a.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),t=a.filter(o=>!n.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),r=new Set;for(const o of a){if(t.has(o))continue;const v=m.get(o).map(u=>({...u,key:s[u.key]})),w=S.get(o).map(u=>({...u,key:s[u.key]}));p(v,w)||r.add(o)}return{added:i,removed:t,updated:r}}function p(m,S){return!(!(0,I.$ub)(m.filter(({command:s})=>s[0]!=="-"),S.filter(({command:s})=>s[0]!=="-"),(s,a)=>y(s,a))||!(0,I.$ub)(m.filter(({command:s})=>s[0]==="-"),S.filter(({command:s})=>s[0]==="-"),(s,a)=>y(s,a)))}function y(m,S){if(m.command!==S.command||m.key!==S.key)return!1;const s=N.$Ni.deserialize(m.when),a=N.$Ni.deserialize(S.when);return!(s&&!a||!s&&a||s&&a&&!s.equals(a)||!A.$$m(m.args,S.args))}function f(m,S,s){for(const a of S)m=D.edit(m,[-1],a,s);return m}function c(m,S,s){const a=R(m);for(let n=a.length-1;n>=0;n--)(a[n].command===S||a[n].command===`-${S}`)&&(m=D.edit(m,[n],void 0,s));return m}function h(m,S,s,a){const n=R(m),i=n.findIndex(t=>t.command===S||t.command===`-${S}`);for(let t=n.length-1;t>=0;t--)(n[t].command===S||n[t].command===`-${S}`)&&(m=D.edit(m,[t],void 0,a));for(let t=s.length-1;t>=0;t--)m=D.edit(m,[i],s[t],a);return m}}),define(oe[234],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L3b=e.$K3b=void 0;function I(N,D,R){const k={},g={},C=new Set;if(!D)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:N,updated:{},removed:[]},conflicts:[]};const E=L(N,D);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=L(R,N),l=L(R,D),d={},p={},y=new Set,f=new Set;for(const c of b.removed.values())l.updated.has(c)?k[c]=D[c]:y.add(c);for(const c of l.removed.values())f.has(c)||(b.updated.has(c)?f.add(c):C.add(c));for(const c of b.updated.values())f.has(c)||(l.updated.has(c)?E.updated.has(c)&&f.add(c):p[c]=N[c]);for(const c of l.updated.values())f.has(c)||(b.updated.has(c)?E.updated.has(c)&&f.add(c):N[c]!==void 0&&(g[c]=D[c]));for(const c of b.added.values())f.has(c)||(l.added.has(c)?E.updated.has(c)&&f.add(c):d[c]=N[c]);for(const c of l.added.values())f.has(c)||(b.added.has(c)?E.updated.has(c)&&f.add(c):k[c]=D[c]);return{local:{added:k,removed:[...C.values()],updated:g},remote:{added:d,removed:[...y.values()],updated:p},conflicts:[...f.values()]}}e.$K3b=I;function L(N,D){const R=N?Object.keys(N):[],k=D?Object.keys(D):[],g=k.filter(b=>!R.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),C=R.filter(b=>!k.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),E=new Set;for(const b of R){if(C.has(b))continue;const l=N[b],d=D[b];l!==d&&E.add(b)}return{added:g,removed:C,updated:E}}function A(N,D){const{added:R,removed:k,updated:g}=L(N,D);return R.size===0&&k.size===0&&g.size===0}e.$L3b=A}),define(oe[235],ae([0,1,30]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s5b=void 0;function L(N,D,R,k){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!D){const b=N.filter(({id:l})=>!k.includes(l));return b.length?C.added=b:C=null,{local:g,remote:C}}const E=A(N,D,k);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const b=A(R,N,k),l=A(R,D,k);for(const d of l.removed){const p=N.find(y=>y.id===d);p&&g.removed.push(p)}for(const d of l.added){const p=D.find(y=>y.id===d);b.added.includes(d)?E.updated.includes(d)&&g.updated.push(p):g.added.push(p)}for(const d of l.updated)g.updated.push(D.find(p=>p.id===d));for(const d of b.added)l.added.includes(d)||C.added.push(N.find(p=>p.id===d));for(const d of b.updated)l.removed.includes(d)||l.updated.includes(d)||C.updated.push(N.find(p=>p.id===d));for(const d of b.removed){const p=D.find(y=>y.id===d);p&&C.removed.push(p)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}e.$s5b=L;function A(N,D,R){N=N?N.filter(({id:l})=>!R.includes(l)):[],D=D.filter(({id:l})=>!R.includes(l));const k=N.map(({id:l})=>l),g=D.map(({id:l})=>l),C=g.filter(l=>!k.includes(l)),E=k.filter(l=>!g.includes(l)),b=[];for(const{id:l,name:d,shortName:p,icon:y,useDefaultFlags:f}of N){if(E.includes(l))continue;const c=D.find(h=>h.id===l);(!c||c.name!==d||c.shortName!==p||c.icon!==y||!(0,I.$$m)(c.useDefaultFlags,f))&&b.push(l)}return{added:C,removed:E,updated:b}}}),define(oe[25],ae([0,1,18,12,174,50,29,4,103,40]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygb=e.$Xgb=e.$Wgb=e.$Vgb=e.$Ugb=e.$Tgb=e.$Sgb=e.$Rgb=e.$Qgb=e.$Pgb=e.$Ogb=e.MergeState=e.Change=e.SyncStatus=e.$Ngb=e.$Mgb=e.$Lgb=e.UserDataSyncErrorCode=e.$Kgb=e.$Jgb=e.$Igb=e.$Hgb=e.$Ggb=e.$Fgb=e.$Egb=e.$Dgb=e.$Cgb=e.SyncResource=e.$Bgb=e.$Agb=e.$zgb=e.$ygb=e.$xgb=e.$wgb=void 0;function C(){const t=g.$gn.as(N.$ln.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$wgb=C;function E(){const t=g.$gn.as(N.$ln.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(w=>!!t[w].ignoreSync),o=Object.keys(t).filter(w=>t[w].scope===2||t[w].scope===6),v=C();return(0,I.$Mb)([...r,...o,...v])}e.$xgb=E,e.$ygb="settingsSync",e.$zgb="settingsSync.keybindingsPerPlatform";function b(){const t="vscode://schemas/ignoredSettings",r=g.$gn.as(N.$ln.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.$zgb]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:D.$Xn,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=g.$gn.as(k.$hn.JSONContribution),v=()=>{const w=C(),u=E(),$=Object.keys(N.$mn.properties).filter(U=>!u.includes(U)),j=u.filter(U=>!w.includes(U)),M={items:{type:"string",enum:[...$,...j.map(U=>`-${U}`)]}};o.registerSchema(t,M)};return r.onDidUpdateConfiguration(()=>v())}e.$Agb=b;function l(t){return t&&(0,L.$Af)(t)&&(0,L.$yf)(t.id)&&Array.isArray(t.scopes)}e.$Bgb=l;var d;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(d||(e.SyncResource=d={})),e.$Cgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}e.$Dgb=p;function y(t,r,o,v){return v.joinPath(o.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.$Egb=y,e.$Fgb=(0,R.$Ph)("IUserDataSyncStoreManagementService"),e.$Ggb=(0,R.$Ph)("IUserDataSyncStoreService"),e.$Hgb=(0,R.$Ph)("IUserDataSyncLocalStoreService"),e.$Igb="x-operation-id",e.$Jgb="X-Execution-Id";function f(t){const r={};return r[e.$Jgb]=t,r}e.$Kgb=f;var c;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(c||(e.UserDataSyncErrorCode=c={}));class h extends Error{constructor(r,o,v,w){super(r),this.code=o,this.resource=v,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Lgb=h;class m extends h{constructor(r,o,v,w,u){super(r,v,void 0,u),this.url=o,this.serverCode=w}}e.$Mgb=m;class S extends h{constructor(r,o){super(r,o)}}e.$Ngb=S,function(t){function r(o){if(o instanceof t)return o;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(v&&v[1]){const w=v[2]==="unknown"?void 0:v[2],u=v[3]==="unknown"?void 0:v[3];return new t(o.message,v[1],w,u)}return new t(o.message,"Unknown")}t.toUserDataSyncError=r}(h||(e.$Lgb=h={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var a;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(a||(e.Change=a={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Ogb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$Pgb=i,e.$Qgb=(0,R.$Ph)("IUserDataSyncEnablementService"),e.$Rgb=(0,R.$Ph)("IUserDataSyncService"),e.$Sgb=(0,R.$Ph)("IUserDataSyncResourceProviderService"),e.$Tgb=(0,R.$Ph)("IUserDataAutoSyncService"),e.$Ugb=(0,R.$Ph)("IUserDataSyncUtilService"),e.$Vgb=(0,R.$Ph)("IUserDataSyncLogService"),e.$Wgb="userDataSync",e.$Xgb="vscode-userdata-sync",e.$Ygb="preview"}),define(oe[236],ae([0,1,30,25]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Db=void 0;function A(D,R,k,g,C){if(!R)return{remote:{added:Object.keys(D),removed:[],updated:[],all:Object.keys(D).length>0?D:null},local:{added:{},removed:[],updated:{}}};const E=N(D,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const b=k?N(k,R):{added:Object.keys(R).reduce((c,h)=>(c.add(h),c),new Set),removed:new Set,updated:new Set},l=k?N(k,D):{added:Object.keys(D).reduce((c,h)=>(c.add(h),c),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},p=I.$7m(R),y=!k;for(const c of l.added.values())c!==L.$Ogb&&y&&b.added.has(c)||(p[c]=D[c]);for(const c of l.updated.values())p[c]=D[c];for(const c of l.removed.values())g.unregistered.includes(c)||delete p[c];for(const c of b.added.values()){const h=R[c];if(g.machine.includes(c)){C.info(`GlobalState: Skipped adding ${c} in local storage because it is declared as machine scoped.`);continue}if(k&&l.added.has(c))continue;const m=D[c];m&&m.value===h.value||c===L.$Ogb&&y&&l.added.has(c)||(m?d.updated[c]=h:d.added[c]=h)}for(const c of b.updated.values()){const h=R[c];if(g.machine.includes(c)){C.info(`GlobalState: Skipped updating ${c} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(c)||l.removed.has(c))continue;const m=D[c];m&&m.value===h.value||(d.updated[c]=h)}for(const c of b.removed.values()){if(g.machine.includes(c)){C.trace(`GlobalState: Skipped removing ${c} in local storage because it is declared as machine scoped.`);continue}l.updated.has(c)||l.removed.has(c)||d.removed.push(c)}const f=N(R,p);return{local:d,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:p}}}e.$9Db=A;function N(D,R){const k=Object.keys(D),g=Object.keys(R),C=g.filter(l=>!k.includes(l)).reduce((l,d)=>(l.add(d),l),new Set),E=k.filter(l=>!g.includes(l)).reduce((l,d)=>(l.add(d),l),new Set),b=new Set;for(const l of k){if(E.has(l))continue;const d=D[l],p=R[l];I.$$m(d,p)||b.add(l)}return{added:C,removed:E,updated:b}}}),define(oe[237],ae([0,1,18,35,86,41,30,78,25]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WCb=e.$VCb=e.$UCb=e.$TCb=e.$SCb=e.$RCb=void 0;function g(o,v,w){let u=[];w?u=E(w):u=C(v);const $=[],j=[...(0,k.$wgb)()];if(Array.isArray(u))for(const M of u)M.startsWith("-")?j.push(M.substring(1)):$.push(M);return(0,I.$Mb)([...o,...$].filter(M=>!j.includes(M)))}e.$RCb=g;function C(o){let v=o.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=o.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const v=(0,L.$Wm)(o);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function b(o,v){const w=(0,L.$Wm)(o)||{};let u="{}";for(const $ of Object.keys(w)){const j=(0,A.$4S)(u,[$],w[$],v);u=(0,A.$7S)(u,j)}return u}e.$SCb=b;function l(o,v,w,u){if(w.length){const $=r(v),j=(0,L.$Wm)(v)||{},M=(0,L.$Wm)(o);if(!M)return o;const U=[];for(const z of w){const q=j[z],Z=M[z];q===void 0?o=R.edit(o,[z],void 0,u):Z!==void 0?o=R.edit(o,[z],q,u):U.push(s(z,$))}U.sort((z,q)=>z.startOffset-q.startOffset),U.forEach(z=>o=c(z.setting.key,v,o,u))}return o}e.$TCb=l;function d(o,v,w,u,$,j){const M=l(o,v,u,j),U=w!==M,z=w!==v;if(!U&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!z)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(z&&!U)return{conflictsSettings:[],localContent:l(v,o,u,j),remoteContent:null,hasConflicts:!1};if(w===null&&y(o)){const O=p(o,v,u)?null:l(v,o,u,j);return{conflictsSettings:[],localContent:O,remoteContent:null,hasConflicts:!1}}let q=o,Z=v;const X=(0,L.$Wm)(o),x=(0,L.$Wm)(v),H=w?(0,L.$Wm)(w):null,Q=u.reduce((O,T)=>(O.add(T),O),new Set),J=f(X,x,Q),W=f(H,X,Q),ee=f(H,x,Q),ne=new Map,_=new Set,ie=O=>{_.add(O);const T=$.filter(({key:F})=>F===O)[0];T?(q=R.edit(q,[O],T.value,j),Z=R.edit(Z,[O],T.value,j)):ne.set(O,{key:O,localValue:X[O],remoteValue:x[O]})};for(const O of W.removed.values())ee.updated.has(O)?ie(O):Z=R.edit(Z,[O],void 0,j);for(const O of ee.removed.values())_.has(O)||(W.updated.has(O)?ie(O):q=R.edit(q,[O],void 0,j));for(const O of W.updated.values())_.has(O)||(ee.updated.has(O)?J.updated.has(O)&&ie(O):Z=R.edit(Z,[O],X[O],j));for(const O of ee.updated.values())_.has(O)||(W.updated.has(O)?J.updated.has(O)&&ie(O):q=R.edit(q,[O],x[O],j));for(const O of W.added.values())_.has(O)||(ee.added.has(O)?J.updated.has(O)&&ie(O):Z=c(O,q,Z,j));for(const O of ee.added.values())_.has(O)||(W.added.has(O)?J.updated.has(O)&&ie(O):q=c(O,Z,q,j));const K=ne.size>0||!p(q,Z,u),B=K||!p(q,o,[]),P=K||!p(Z,v,[]);return{localContent:B?q:null,remoteContent:P?Z:null,conflictsSettings:[...ne.values()],hasConflicts:K}}e.$UCb=d;function p(o,v,w){if(o===v)return!0;const u=(0,L.$Wm)(o),$=(0,L.$Wm)(v),j=w.reduce((z,q)=>(z.add(q),z),new Set),M=r(o).filter(z=>!(z.setting&&j.has(z.setting.key))),U=r(v).filter(z=>!(z.setting&&j.has(z.setting.key)));if(M.length!==U.length)return!1;for(let z=0;z<M.length;z++){const q=M[z],Z=U[z];if(q.setting&&Z.setting){if(q.setting.key!==Z.setting.key||!D.$$m(u[q.setting.key],$[q.setting.key]))return!1}else if(!q.setting&&!Z.setting){if(q.value!==Z.value)return!1}else return!1}return!0}function y(o){return o?r(o).length===0:!0}e.$VCb=y;function f(o,v,w){const u=o?Object.keys(o).filter(z=>!w.has(z)):[],$=Object.keys(v).filter(z=>!w.has(z)),j=$.filter(z=>!u.includes(z)).reduce((z,q)=>(z.add(q),z),new Set),M=u.filter(z=>!$.includes(z)).reduce((z,q)=>(z.add(q),z),new Set),U=new Set;if(o)for(const z of u){if(M.has(z))continue;const q=o[z],Z=v[z];D.$$m(q,Z)||U.add(z)}return{added:j,removed:M,updated:U}}function c(o,v,w,u){const $=(0,L.$Wm)(v),j=r(v),M=r(w),U=h(o,j,M);return m(w,o,$[o],U,M,u)}e.$WCb=c;function h(o,v,w){const u=v.findIndex(j=>j.setting?.key===o),$=v[u-1];if($){if($.setting){const M=s($.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!0}}else{const M=a(u,v);if(M){const U=s(M.setting.key,w);if(U){const z=n(w.indexOf(U),w),q=i(v,M,v[u]);if(z){const Z=i(w,U,z),X=t(q,Z);return X?{index:w.indexOf(X),insertAfter:!0}:{index:w.indexOf(z),insertAfter:!1}}else{const Z=i(w,U,w[w.length-1]),X=t(q,Z);return X?{index:w.indexOf(X),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const j=v[u+1];if(j)if(j.setting){const M=s(j.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!1}}else{const M=n(u,v);if(M){const U=s(M.setting.key,w);if(U){const z=a(w.indexOf(U),w),q=i(v,v[u],M);if(z){const Z=i(w,z,U),X=t(q.reverse(),Z.reverse());return X?{index:w.indexOf(X),insertAfter:!1}:{index:w.indexOf(z),insertAfter:!0}}else{const Z=i(w,w[0],U),X=t(q.reverse(),Z.reverse());return X?{index:w.indexOf(X),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function m(o,v,w,u,$,j){let M;return u.index===-1?M=(0,A.$4S)(o,[v],w,j):M=S(o,v,w,u,$,j).map(U=>(0,A.$5S)(o,U,j)[0]),(0,A.$7S)(o,M)}function S(o,v,w,u,$,j){const M=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,U=(0,N.$1S)(j,o),z=$[u.index];if(u.insertAfter){const q=[];if(z.setting)q.push({offset:z.endOffset,length:0,content:","+M});else{const Z=n(u.index,$),X=a(u.index,$),x=X?.setting?.commaOffset;X&&x===void 0&&q.push({offset:X.endOffset,length:0,content:","});const H=x!==void 0&&x>z.endOffset;q.push({offset:H?x+1:z.endOffset,length:0,content:Z?U+M+",":U+M})}return q}else{if(z.setting)return[{offset:z.startOffset,length:0,content:M+","}];const q=($[u.index-1]&&!$[u.index-1].setting?U:"")+M+(n(u.index,$)?",":"")+U;return[{offset:z.startOffset,length:0,content:q}]}}function s(o,v){return v.filter(w=>w.setting?.key===o)[0]}function a(o,v){for(let w=o-1;w>=0;w--)if(v[w].setting)return v[w]}function n(o,v){for(let w=o+1;w<v.length;w++)if(v[w].setting)return v[w]}function i(o,v,w){const u=o.indexOf(v),$=o.indexOf(w);return o.filter((j,M)=>u<M&&M<$)}function t(o,v){if(o.length&&v.length){let w=0;for(;w<v.length&&w<o.length;w++)if(o[w].value!==v[w].value)return v[w-1];return v[w-1]}}function r(o){const v=[];let w=-1,u,$;const j={onObjectBegin:M=>{w++},onObjectProperty:(M,U,z)=>{w===0&&(u=U,$=M)},onObjectEnd:(M,U)=>{w--,w===0&&v.push({startOffset:u,endOffset:M+U,value:o.substring(u,M+U),setting:{key:$,commaOffset:void 0}})},onArrayBegin:(M,U)=>{w++},onArrayEnd:(M,U)=>{w--,w===0&&v.push({startOffset:u,endOffset:M+U,value:o.substring(u,M+U),setting:{key:$,commaOffset:void 0}})},onLiteralValue:(M,U,z)=>{w===0&&v.push({startOffset:u,endOffset:U+z,value:o.substring(u,U+z),setting:{key:$,commaOffset:void 0}})},onSeparator:(M,U,z)=>{if(w===0&&M===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const Z=v[q];Z&&v.splice(q,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:U}})}},onComment:(M,U)=>{w===0&&v.push({startOffset:M,endOffset:M+U,value:o.substring(M,M+U)})}};return(0,L.$4m)(o,j),v}}),define(oe[79],ae([0,1,3,2,4,25]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DCb=e.$CCb=void 0,e.$CCb=(0,A.$Ph)("IUserDataSyncAccountService");let D=class extends L.$Sc{get account(){return this.a}constructor(k,g){super(),this.g=k,this.h=g,this.b=this.B(new I.$Nd),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$Nd),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$DCb=D,e.$DCb=D=ye([Y(0,N.$Ggb),Y(1,N.$Vgb)],D)}),define(oe[238],ae([0,1,2,10]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R8b=e.$Q8b=e.$P8b=e.$O8b=e.$N8b=e.$M8b=e.$L8b=void 0;class A{constructor(b){this.a=b}listen(b,l){switch(l){case"onError":return this.a.onError}throw new Error(`Event not found: ${l}`)}call(b,l,d){switch(l){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.$L8b=A;class N{constructor(b){this.a=b}listen(b,l){throw new Error(`Event not found: ${l}`)}call(b,l,d){switch(l){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(L.URI.revive(d[0]))}throw new Error("Invalid call")}}e.$M8b=N;class D{constructor(b){this.a=b}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.a.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.a.call("resolveFormattingOptions",[b])}}e.$N8b=D;class R{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${l}`)}async call(b,l,d){switch(l){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.$O8b=R;class k{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${l}`)}call(b,l,d){switch(l){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.$P8b=k;class g{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${l}`)}call(b,l,d){switch(l){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Q8b=g;class C extends I.$Sc{constructor(b){super(),this.a=b,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(b){return this.a.call("switch",[b])}async getPreviousUserDataSyncStore(){const b=await this.a.call("getPreviousUserDataSyncStore");return this.b(b)}b(b){return{url:L.URI.revive(b.url),type:b.type,defaultUrl:L.URI.revive(b.defaultUrl),insidersUrl:L.URI.revive(b.insidersUrl),stableUrl:L.URI.revive(b.stableUrl),canSwitch:b.canSwitch,authenticationProviders:b.authenticationProviders}}}e.$R8b=C}),define(oe[239],ae([0,1,19,175,14,7,25]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OEb=void 0;let R=class extends N.$cj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,I.$vg)(C.logsHome,`${D.$Wgb}.log`),{id:D.$Wgb,name:(0,L.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$OEb=R,e.$OEb=R=ye([Y(0,N.$$i),Y(1,A.$Wh)],R)}),define(oe[112],ae([0,1,7,4,24]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g9b=e.$f9b=void 0,e.$f9b=(0,L.$Ph)("voiceRecognitionService");let N=class{constructor(R,k){this.a=R,this.b=k}async transcribe(R,k){const g=process.env.VSCODE_VOICE_MODULE_PATH;if(!g||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${R.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const C=Date.now();try{const E=te.__$__nodeRequire(g),b=new AbortController;k.onCancellationRequested(()=>b.abort());const l=await E.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:R},{language:"en",signal:b.signal});return this.a.info(`[voice] transcribe(${R.length}): Text "${l}", took ${Date.now()-C}ms)`),l}catch(E){throw this.a.error(`[voice] transcribe(${R.length}): Failed width "${E}", took ${Date.now()-C}ms)`),E}}};e.$g9b=N,e.$g9b=N=ye([Y(0,I.$0i),Y(1,A.$pj)],N)}),define(oe[240],ae([0,1,2,112,7,26,6]),function(te,e,I,L,A,N,D){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$h9b=void 0;let k=class extends I.$Sc{static{R=this}static{this.a=!!process.env.VSCODE_VOICE_USE_SLIDING_WINDOW}constructor(l,d,p){super(),this.b=l,this.c=d,this.f=p,this.g()}g(){this.B(this.b(l=>{this.f.info(`[voice] transcriber: new connection (sliding window: ${R.a})`),R.a?this.B(new C(l,this.c,this.f)):this.B(new E(l,this.c,this.f))}))}};e.$h9b=k,e.$h9b=k=R=ye([Y(1,L.$f9b),Y(2,A.$0i)],k);class g extends I.$Sc{static{this.a=30*16e3*16*1/8}constructor(l,d,p){super(),this.b=l,this.c=d,this.f=p,this.g()}g(){const l=new N.$Xd;this.B((0,I.$Qc)(()=>l.dispose(!0)));const d=y=>{y.data instanceof Float32Array&&this.h(y.data,l.token)};this.b.on("message",d),this.B((0,I.$Qc)(()=>this.b.off("message",d))),this.b.start();let p=!1;this.b.on("close",()=>{this.f.info("[voice] transcriber: closed connection"),p=!0,this.dispose()}),this.B((0,I.$Qc)(()=>{p||this.b.close()}))}j(l){const d=new Float32Array(l.reduce((y,f)=>y+f.length,0));let p=0;for(const y of l)d.set(y,p),p+=y.length;return d}}class C extends g{constructor(){super(...arguments),this.m=this.B(new D.$1g),this.n=[],this.r=new Float32Array(0)}async h(l,d){if(l.length>0)this.f.info("[voice] transcriber: voice detected, storing in buffer"),this.r=this.r?this.j([this.r,l]):l;else{this.f.info("[voice] transcriber: silence detected, transcribing window...");const p=this.r.slice(0);this.r=new Float32Array(0),this.m.queue(()=>this.t(p,d))}}async t(l,d){if(!d.isCancellationRequested){if(l.length>g.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}if(l.length!==0){const p=await this.c.transcribe(l,d);p&&this.n.push(p)}d.isCancellationRequested||this.b.postMessage(this.n.join(" "))}}dispose(){super.dispose(),this.r=new Float32Array(0)}}class E extends g{constructor(){super(...arguments),this.m=new D.$2g,this.n=void 0,this.r=0,this.s=""}async h(l,d){const p=this.n?this.j([this.n,l]):l;if(p.length>g.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.n=p,this.m.queue(()=>this.u(d))}async u(l){if(l.isCancellationRequested)return;const d=this.n?.slice(0);if(!d)return;let p;d.length===this.r?(this.f.info("[voice] transcriber: silence detected, reusing previous transcription result"),p=this.s):(this.f.info("[voice] transcriber: voice detected, transcribing everything..."),p=await this.c.transcribe(d,l)),this.s=p,this.r=d.length,!l.isCancellationRequested&&this.b.postMessage(p)}dispose(){super.dispose(),this.n=void 0}}}),define(oe[241],ae([0,1,6,3,2]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=void 0;class N extends A.$Sc{constructor({onDidOpenWindow:R,onDidFocusWindow:k,getActiveWindowId:g}){super(),this.a=this.B(new A.$Rc),L.Event.latch(L.Event.any(R,k))(this.f,this,this.a),this.b=(0,I.$Hg)(()=>g()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$M7b=N}),define(oe[113],ae([0,1,178,16,47,19,10,4,23]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,R.$Ph)("contextService");function g(i){const t=i;return typeof t?.id=="string"&&D.URI.isUri(t.uri)}e.$Zh=g;function C(i){return typeof i?.id=="string"&&!g(i)&&!b(i)}e.$1h=C,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function E(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.$nc)(i)}:t?e.$2h:e.$3h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$4h=E;function b(i){const t=i;return typeof t?.id=="string"&&D.URI.isUri(t.configPath)}e.$5h=b;function l(i){const t=i;if(t?.uri)return{id:t.id,uri:D.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$6h=l;var d;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function p(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$7h=p;function y(i){const t=i;return!!(t&&typeof t=="object"&&D.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$8h=y;class f{constructor(t,r,o,v,w){this.h=t,this.j=o,this.k=v,this.l=w,this.c=A.$Vh.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=A.$Vh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=f;class c{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,N.$vg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=c;function h(i){return new c({uri:i,index:0,name:(0,N.$rg)(i)},{uri:i.toString()})}e.$$h=h,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,I.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function m(i,t){return N.$mg.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$di=m;function S(i){let t;return D.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===k.Schemas.tmp}e.$ei=S,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$fi}e.$gi=s;function a(i,t){return!m(i,t)&&!S(i)}e.$hi=a;function n(i){return(typeof i=="string"?(0,L.$oc)(i):(0,N.$tg)(i))===e.$ai}e.$ii=n}),define(oe[17],ae([0,1,52,3,2,19,10,169,14,11,4,7,113,34,28,6,32,27,12]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function m(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&D.URI.isUri(t.location)&&D.URI.isUri(t.globalStorageHome)&&D.URI.isUri(t.settingsResource)&&D.URI.isUri(t.keybindingsResource)&&D.URI.isUri(t.tasksResource)&&D.URI.isUri(t.snippetsHome)&&D.URI.isUri(t.extensionsResource))}e.$Jk=m,e.$Kk=(0,C.$Ph)("IUserDataProfilesService");function S(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:t}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Lk=S;function s(i,t,r,o,v,w){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:w&&v?.useDefaultFlags?.globalState?w.globalStorageHome:(0,N.$vg)(r,"globalStorage"),settingsResource:w&&v?.useDefaultFlags?.settings?w.settingsResource:(0,N.$vg)(r,"settings.json"),keybindingsResource:w&&v?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,N.$vg)(r,"keybindings.json"),tasksResource:w&&v?.useDefaultFlags?.tasks?w.tasksResource:(0,N.$vg)(r,"tasks.json"),snippetsHome:w&&v?.useDefaultFlags?.snippets?w.snippetsHome:(0,N.$vg)(r,"snippets"),extensionsResource:w&&v?.useDefaultFlags?.extensions?w.extensionsResource:(0,N.$vg)(r,"extensions.json"),cacheHome:(0,N.$vg)(o,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Mk=s;let a=class extends A.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,o,v){super(),this.t=t,this.u=r,this.w=o,this.y=v,this.f=!0,this.h=this.B(new L.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,c.$yf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}r.push(s((0,N.$sg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},t))}}catch(w){this.y.error(w)}const o=new l.$Ac,v=new Map;if(r.length)try{const w=this.Q();if(w.workspaces)for(const[u,$]of Object.entries(w.workspaces)){const j=D.URI.parse(u),M=r.find(U=>U.id===$);M&&o.set(j,M)}if(w.emptyWindows)for(const[u,$]of Object.entries(w.emptyWindows)){const j=r.find(M=>M.id===$);j&&v.set(u,j)}}catch(w){this.y.error(w)}this.z={profiles:r,workspaces:o,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,f.$Fe)(r)}\\s(\\d+)`);let v=0;for(const u of this.profiles){const $=o.exec(u.name),j=$?parseInt($[1]):0;v=j>v?j:v}const w=`${r} ${v+1}`;return this.createProfile((0,I.$Di)((0,y.$eg)()).toString(16),w,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,I.$Di)((0,y.$eg)()).toString(16),t,r,o)}async createProfile(t,r,o,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(t,r,o);return v&&await this.setProfileForWorkspace(v,w),w}async F(t,r,o){if(!(0,c.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const w=this.profiles.find(j=>j.name===r||j.id===t);if(w)return w;const u=s(t,r,(0,N.$vg)(this.profilesHome,t),this.g,o,this.defaultProfile);await this.u.createFolder(u.location);const $=[];return this.j.fire({profile:u,join(j){$.push(j)}}),await p.Promises.settled($),this.I([u],[],[]),u}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(v=>v.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=s(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.m.fire({profile:r,join(v){o.push(v)}});try{await Promise.allSettled(o)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,g.$pk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(v=>v.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,b.$Zh)(t)?t.uri:(0,b.$5h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,o){const v=[...this.profiles,...t],w=[];this.s.profiles=[];for(let u of v)u.isDefault||r.some($=>u.id===$.id)||(u=o.find($=>u.id===$.id)??u,u.isTransient?this.s.profiles.push(u):w.push({location:u.location,name:u.name,shortName:u.shortName,icon:u.icon,useDefaultFlags:u.useDefaultFlags}));this.P(w),this.z=void 0,this.J(t,r,o)}J(t,r,o){this.h.fire({added:t,removed:r,updated:o,all:this.profiles})}L(t,r,o){o=r?.isTransient?!0:o,o||this.L(t,void 0,!0);const v=this.G(t),w=o?this.s:this.C;D.URI.isUri(v)?(w.workspaces.delete(v),r&&w.workspaces.set(v,r)):(w.emptyWindows.delete(v),r&&w.emptyWindows.set(v,r)),o||this.M()}M(){const t={};for(const[o,v]of this.C.workspaces.entries())t[o.toString()]=v.id;const r={};for(const[o,v]of this.C.emptyWindows.entries())r[o.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},o=this.D();if(t.workspaces)for(const[w,u]of Object.entries(t.workspaces)){const $=D.URI.parse(u);r[w]=this.w.extUri.isEqual($,o.location)?o.id:this.w.extUri.basename($)}const v={};if(t.emptyWindows)for(const[w,u]of Object.entries(t.emptyWindows)){const $=D.URI.parse(u);v[w]=this.w.extUri.isEqual($,o.location)?o.id:this.w.extUri.basename($)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Nk=a,e.$Nk=a=ye([Y(0,k.$Wh),Y(1,g.$$j),Y(2,d.$Ik),Y(3,E.$0i)],a);class n extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Ok=n}),define(oe[242],ae([0,1,6,2,17]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z8b=void 0;let N=class extends L.$Sc{constructor(R){super(),this.B(new I.$6g(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$Z8b=N,e.$Z8b=N=ye([Y(0,A.$Kk)],N)}),define(oe[243],ae([0,1,18,6,26,8,3,2,5,12,10,152,29,33,44,7,24,22,28,17]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=void 0;let m=class extends R.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,o,v,w,u){super(),this.z=t,this.C=r,this.D=o,this.F=v,this.G=w,this.H=u,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$Nd),this.s=this.B(new D.$Nd),this.t=this.B(new D.$Nd),this.u=this.B(new D.$Nd),this.w=this.B(new D.$Nd),this.y=[],this.B((0,R.$Qc)(()=>{this.j.forEach(({task:$})=>$.cancel()),this.m.forEach($=>$.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,b.$8n)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:w})=>(0,l.$Ao)(w,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(o){throw s(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new b.$_n(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const r=[],o=[];await Promise.allSettled(t.map(async({extension:v,options:w})=>{try{const u=await this.O(v,!!w?.installGivenVersion,!!w?.installPreReleaseVersion);o.push({...u,options:w})}catch(u){r.push({identifier:v.identifier,operation:2,source:v,error:u})}})),o.length&&r.push(...await this.I(o));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,l.$Io)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,d.$9l)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(o=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const w=(await this.getInstalled(1,v.extensionsResource)).find(u=>(0,l.$Ao)(u.identifier,t.identifier));w?this.w.fire(w):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async o=>{try{const v=await this.J(o);r.push(...v)}catch(v){r.push({identifier:{id:(0,l.$Fo)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:o}){const v=o.isApplicationScoped||o.isBuiltin||(0,d.$9l)(t),w={...o,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:v,profileLocation:v?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},u=q=>`${l.$Bo.create(q).toString()}${w.profileLocation?`-${w.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const q=this.j.get(u(r));if(q)return this.F.info("Extensions is already requested to install",r.identifier.id),await q.task.waitUntilTaskIsFinished(),[]}const $=[],j=[],M=[],U=this.Z(t,r,w);C.URI.isUri(r)||this.j.set(u(r),{task:U,waitingTasks:[]}),this.n.fire({identifier:U.identifier,source:r,profileLocation:w.profileLocation}),this.F.info("Installing extension:",U.identifier.id),$.push({task:U,manifest:t});let z=!1;try{if(w.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",U.identifier.id);else try{const Z=await this.N(U.identifier,t,!!w.installOnlyNewlyAddedFromExtensionPack,!!w.installPreReleaseVersion,w.profileLocation),X=await this.getInstalled(void 0,w.profileLocation),x={...w,donotIncludePackAndDependencies:!0,context:{...w.context,[b.$3n]:!0}};for(const{gallery:H,manifest:Q}of(0,I.$Mb)(Z,({gallery:J})=>J.identifier.id)){z=z||!!Q.extensionDependencies?.some(ee=>(0,l.$Ao)({id:ee},U.identifier));const J=u(H),W=this.j.get(J);if(W){if(this.L(U,W.task)){const ee=W.task.identifier;this.F.info("Waiting for already requested installing extension",ee.id,U.identifier.id),W.waitingTasks.push(U),j.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,ne=>ne.some(_=>(0,l.$Ao)(_.identifier,ee)))).then(ne=>{if(this.F.info("Finished waiting for already requested installing extension",ee.id,U.identifier.id),!ne.find(ie=>(0,l.$Ao)(ie.identifier,ee))?.local)throw new Error(`Extension ${ee.id} is not installed`)}))}}else if(!X.some(({identifier:ee})=>(0,l.$Ao)(ee,H.identifier))){const ee=this.Z(Q,H,x);this.j.set(J,{task:ee,waitingTasks:[U]}),this.n.fire({identifier:ee.identifier,source:H,profileLocation:w.profileLocation}),this.F.info("Installing extension:",ee.identifier.id,U.identifier.id),$.push({task:ee,manifest:Q})}}}catch(Z){if(C.URI.isUri(U.source))(0,I.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",U.identifier.id,Z.message),(0,I.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",U.identifier.id,Z.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",U.identifier.id),Z}const q=$.reduce((Z,{task:X,manifest:x})=>(Z.set(X.identifier.id.toLowerCase(),{task:X,manifest:x}),Z),new Map);for(;q.size;){let Z;const X=[...q.values()].filter(({manifest:x})=>!x.extensionDependencies?.some(H=>q.has(H.toLowerCase())));X.length?Z=q.size===1?X:X.filter(({task:x})=>!(x===U&&!z)):(this.F.info("Found extensions with circular dependencies",X.map(({task:x})=>x.identifier.id)),Z=[...q.values()]),await this.M(Z.map(async({task:x})=>{const H=new Date().getTime();try{const Q=await x.run();if(await this.M(this.y.map(J=>J.postInstall(Q,x.source,w,A.CancellationToken.None))),!C.URI.isUri(x.source)){const J=x.operation===3,W=J?void 0:(new Date().getTime()-x.source.lastUpdated)/1e3;if(a(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Io)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:W}),k.$p&&x.operation!==3)try{await this.z.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}M.push({local:Q,identifier:x.identifier,operation:x.operation,source:x.source,context:x.options.context,profileLocation:x.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw C.URI.isUri(x.source)||a(this.C,x.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Io)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-H,error:Q}),this.F.error("Error while installing the extension:",x.identifier.id),Q}finally{q.delete(x.identifier.id.toLowerCase())}}))}return j.length&&await this.M(j),M.forEach(({identifier:Z})=>this.F.info("Extension installed successfully:",Z.id)),M}catch(q){if($.forEach(({task:Z})=>Z.cancel()),M.length)try{const Z=await Promise.allSettled(M.map(({local:X})=>this.$(X,{versionOnly:!0,profileLocation:w.profileLocation}).run()));for(let X=0;X<Z.length;X++){const x=Z[X],{identifier:H}=M[X];x.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",H.id):this.F.warn("Rollback: Error while uninstalling extension",H.id,(0,N.$0)(x.reason))}}catch(Z){this.F.warn("Error while rolling back extensions",(0,N.$0)(Z),M.map(({identifier:X})=>X.id))}return $.map(({task:Z})=>({identifier:Z.identifier,operation:2,source:Z.source,context:w.context,profileLocation:w.profileLocation,error:q}))}finally{for(const{task:q}of $)q.source&&!C.URI.isUri(q.source)&&this.j.delete(u(q.source))}}L(t,r){for(const[,{task:o,waitingTasks:v}]of this.j.entries())if(o===t&&(v.includes(r)||v.some(w=>this.L(w,r)))||o===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],o=[],v=await Promise.allSettled(t);for(const w of v)w.status==="fulfilled"?r.push(w.value):o.push(w.reason);if(o.length)throw S(o);return r}async N(t,r,o,v,w){if(!this.z.isEnabled())return[];const u=await this.getInstalled(void 0,w),$=[],j=[],M=async(U,z)=>{$.push(U);const q=z.extensionDependencies||[],Z=[...q];if(z.extensionPack){const X=o?u.find(x=>(0,l.$Ao)(x.identifier,U)):void 0;for(const x of z.extensionPack)X&&X.manifest.extensionPack&&X.manifest.extensionPack.some(H=>(0,l.$Ao)({id:H},{id:x}))||Z.every(H=>!(0,l.$Ao)({id:H},{id:x}))&&Z.push(x)}if(Z.length){const X=Z.filter(x=>$.every(H=>!(0,l.$Ao)(H,{id:x})));if(X.length){const x=await this.z.getExtensions(X.map(H=>({id:H,preRelease:v})),A.CancellationToken.None);for(const H of x){if($.find(W=>(0,l.$Ao)(W,H.identifier)))continue;const Q=q.some(W=>(0,l.$Ao)({id:W},H.identifier));let J;try{J=await this.O(H,!1,v)}catch(W){if(Q)throw W;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,N.$0)(W));continue}j.push({gallery:J.extension,manifest:J.manifest}),await M(J.extension.identifier,J.manifest)}}}};return await M(t,r),j}async O(t,r,o){let v;const w=await this.getExtensionsControlManifest();if(w.malicious.some(j=>(0,l.$Ao)(t.identifier,j)))throw new b.$_n(E.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);const u=w.deprecated[t.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!v)throw new b.$_n(E.localize(2,null,t.identifier.id,u.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const j=await this.getTargetPlatform();throw new b.$_n(E.localize(3,null,t.identifier.id,this.G.nameLong,(0,b.$4n)(j)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,o),!v)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],A.CancellationToken.None))[0]?new b.$_n(E.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$_n(E.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const $=await this.z.getManifest(v,A.CancellationToken.None);if($===null)throw new b.$_n(`Missing manifest for extension ${v.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if($.version!==v.version)throw new b.$_n(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:$}}async P(t,r,o){const v=await this.getTargetPlatform();let w=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(w=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:v,compatible:!0},A.CancellationToken.None))[0]||null),!w&&await this.z.isExtensionCompatible(t,o,v)&&(w=t),w||(r?w=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},A.CancellationToken.None))[0]||null:w=await this.z.getCompatibleExtension(t,o,v)),w}async Q(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=U=>`${U.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,w=this.m.get(v(t.identifier));if(w)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),w.waitUntilTaskIsFinished();const u=U=>{const z=this.$(U,o);return this.m.set(v(z.extension.identifier),z),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${U.identifier.id}@${U.manifest.version}`),this.t.fire({identifier:U.identifier,profileLocation:o.profileLocation,applicationScoped:U.isApplicationScoped}),z},$=(U,z)=>{z?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,o.profileLocation.toString(),z.message):this.F.error("Failed to uninstall extension:",`${U.identifier.id}@${U.manifest.version}`,z.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${U.identifier.id}@${U.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Ho)(U),error:z}),this.u.fire({identifier:U.identifier,error:z?.code,profileLocation:o.profileLocation,applicationScoped:U.isApplicationScoped})},j=[],M=[];try{j.push(u(t));const U=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const z=this.U(t,U);for(const q of z)this.m.has(v(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):j.push(u(q))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(j.map(z=>z.extension),U,t),await this.M(j.map(async z=>{try{if(await z.run(),await this.M(this.y.map(q=>q.postUninstall(z.extension,o,A.CancellationToken.None))),z.extension.identifier.uuid)try{await this.z.reportStatistic(z.extension.manifest.publisher,z.extension.manifest.name,z.extension.manifest.version,"uninstall")}catch{}$(z.extension)}catch(q){const Z=q instanceof b.$_n?q:new b.$_n((0,N.$0)(q),b.ExtensionManagementErrorCode.Internal);throw $(z.extension,Z),Z}finally{M.push(z)}}))}catch(U){const z=U instanceof b.$_n?U:new b.$_n((0,N.$0)(U),b.ExtensionManagementErrorCode.Internal);for(const q of j){try{q.cancel()}catch{}M.includes(q)||$(q.extension,z)}throw z}finally{for(const U of j)this.m.delete(v(U.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}R(t,r,o){for(const v of t){const w=this.W(v,r);if(w.length){const u=w.filter($=>!t.some(j=>(0,l.$Ao)(j.identifier,$.identifier)));if(u.length)throw new Error(this.S(v,u,o))}}}S(t,r,o){return o===t?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const w=r.filter($=>!$.isBuiltin&&v.some(j=>(0,l.$Ao)({id:j},$.identifier))),u=[];for(const $ of w)u.push(...this.U($,r,o));return[...w,...u]}return[]}W(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(v=>(0,l.$Ao)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$qp=m,e.$qp=m=ye([Y(0,b.$$n),Y(1,f.$cl),Y(2,c.$Ik),Y(3,p.$0i),Y(4,y.$pj),Y(5,h.$Kk)],m);function S(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.$rp=S;function s(i){if(i instanceof b.$_n)return i;const t=new b.$_n(i.message,b.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$sp=s;function a(i,t,{extensionData:r,verificationStatus:o,duration:v,error:w,durationSinceUpdate:u}){let $,j;(0,g.$Gf)(o)&&(o===!0?o="Verified":(o===!1||($=b.ExtensionManagementErrorCode.Signature,j=o),o="Unverified")),w&&(w instanceof b.$_n?($=w.code,w.code===b.ExtensionManagementErrorCode.Signature&&(j=w.message)):$=b.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:o,success:!w,duration:v,errorcode:$,errorcodeDetail:j,durationSinceUpdate:u})}class n{constructor(){this.d=new L.$Sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.$Hg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.$Hg)(t=>new Promise((r,o)=>{const v=t.onCancellationRequested(()=>{v.dispose(),o(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$tp=n}),define(oe[51],ae([0,1,6,15,2,3,34,10,29,33,11,4,7,17,28,12,8,22]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class h extends Error{constructor(n,i){super(n),this.code=i}}e.$up=h,e.$vp=(0,E.$Ph)("IExtensionsProfileScannerService");let m=class extends A.$Sc{constructor(n,i,t,r,o,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=o,this.t=v,this.b=this.B(new N.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new N.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,o=>{const v=[];for(const w of o)n.some(([u])=>(0,g.$Ao)(u.identifier,w.identifier)&&u.manifest.version!==w.version)?t.push(w):v.push(w);for(const[w,u]of n){const $=v.findIndex(M=>(0,g.$Ao)(M.identifier,w.identifier)&&M.version===w.manifest.version),j={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:u};$===-1?(r.push(j),v.push(j)):v.splice($,1,j)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(o){throw r.length&&this.c.fire({extensions:r,error:o,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:o,profileLocation:i}),o}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const o=[];for(const v of r){const w=n.find(([u])=>(0,g.$Ao)(u.identifier,v.identifier)&&u.manifest.version===v.version);w&&(v.metadata={...v.metadata,...w[1]},t.push(v)),o.push(v)}return o}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const o=[];for(const v of r)(0,g.$Ao)(v.identifier,n.identifier)?t.push(v):o.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),o}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],o;try{const v=await this.m.readFile(n);o=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$pk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&t?.bailOutWhenFileNotFound)throw new h((0,y.$0)(v),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.w(n);let v=!1;for(const w of o){S(w)||this.w(n);let u;if((0,p.$yf)(w.relativeLocation)&&w.relativeLocation)u=this.z(w.relativeLocation);else if((0,p.$yf)(w.location))u=this.z(w.location),v=!0,w.relativeLocation=w.location,w.location=u.toJSON();else{u=R.URI.revive(w.location);const $=this.y(u);$&&(v=!0,w.relativeLocation=$)}r.push({identifier:w.identifier,location:u,version:w.version,metadata:w.metadata})}v&&await this.m.writeFile(n,L.$be.fromString(JSON.stringify(o)))}if(i){r=i(r);const v=r.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.y(w.location),metadata:w.metadata}));await this.m.writeFile(n,L.$be.fromString(JSON.stringify(v)))}return r})}w(n){const i=new h(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(o){if((0,C.$pk)(o)===1)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(t);Array.isArray(o)&&o.every(v=>S(v))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,L.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,C.$pk)(o)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,C.$pk)(o)!==1&&this.t.error(o)}try{await this.m.del(i)}catch(o){(0,C.$pk)(o)!==1&&this.t.error(o)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new I.$1g,this.h.set(n,i)),i}};e.$wp=m,e.$wp=m=ye([Y(1,C.$$j),Y(2,l.$Kk),Y(3,d.$Ik),Y(4,f.$cl),Y(5,b.$0i)],m);function S(a){return(0,p.$Af)(a)&&(0,k.$0n)(a.identifier)&&(s(a.location)||(0,p.$yf)(a.location)&&a.location)&&((0,p.$Ff)(a.relativeLocation)||(0,p.$yf)(a.relativeLocation))&&a.version&&(0,p.$yf)(a.version)}function s(a){return a?(0,p.$yf)(a.path)&&(0,p.$yf)(a.scheme):!1}}),define(oe[80],ae([0,1,18,6,30,15,8,35,138,2,23,16,5,19,54,89,12,10,155,14,33,44,68,11,4,7,24,3,64,51,17,28,183]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m,S,s,a,n,i,t,r,o,v,w,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.Translations=void 0;var j;(function(x){function H(Q,J){if(Q===J)return!0;const W=Object.keys(Q),ee=new Set;for(const ne of Object.keys(J))ee.add(ne);if(W.length!==ee.size)return!1;for(const ne of W){if(Q[ne]!==J[ne])return!1;ee.delete(ne)}return ee.size===0}x.equals=H})(j||(e.Translations=j={})),e.$zp=(0,n.$Ph)("IExtensionsScannerService");let M=class extends g.$Sc{constructor(H,Q,J,W,ee,ne,_,ie,K,B,P,O){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Q,this.r=J,this.s=W,this.t=ee,this.u=ne,this.w=_,this.y=ie,this.z=K,this.C=B,this.D=P,this.F=O,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,l.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(z,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Lo)(this.w,this.y)),this.G}async scanAllExtensions(H,Q,J){const[W,ee]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Q)]),ne=J?await this.scanExtensionsUnderDevelopment(H,[...W,...ee]):[];return this.L(W,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Q=[];Q.push(this.M(!!H.useCache,H.language)),Q.push(this.N(H.language,!!H.checkControlFile));const[J,W]=await Promise.all(Q);return this.J([...J,...W],0,H,!1)}async scanUserExtensions(H){const Q=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const J=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(Q,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,J),ee=H.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ne;try{ne=await ee.scanExtensions(W)}catch(_){if(_ instanceof v.$up&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ne=await ee.scanExtensions(W);else throw _}return ne=await this.J(ne,1,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const J=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===C.Schemas.file).map(async W=>{const ee=await this.P(W,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ee)).map(_=>(_.type=Q.find(ie=>(0,m.$Ao)(ie.identifier,_.identifier))?.type??_.type,this.n.validate(_,ee)))}))).flat();return this.J(J,"development",H,!0)}return[]}async scanExistingExtension(H,Q,J){const W=await this.P(H,!1,Q,!0,J.language,!0,void 0),ee=await this.n.scanExtension(W);return!ee||!J.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(H,Q,J){const W=await this.P(H,!1,Q,!0,J.language,!0,void 0),ee=await this.n.scanOneOrMultipleExtensions(W);return this.J(ee,Q,J,!0)}async scanMetadata(H){const Q=(0,l.$vg)(H,"package.json"),J=(await this.w.readFile(Q)).value.toString();return JSON.parse(J).__metadata}async updateMetadata(H,Q){const J=(0,l.$vg)(H,"package.json"),W=(await this.w.readFile(J)).value.toString(),ee=JSON.parse(W);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,ee.__metadata={...ee.__metadata,...Q},await this.w.writeFile((0,l.$vg)(H,"package.json"),N.$be.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof v.$up&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$be.fromString(JSON.stringify([])))}catch(Q){(0,a.$pk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Q,J,W){return J.includeAllVersions||(H=this.L(Q===0?H:void 0,Q===1?H:void 0,Q==="development"?H:void 0,await this.getTargetPlatform(),W)),J.includeInvalid||(H=H.filter(ee=>ee.isValid)),H.sort((ee,ne)=>{const _=E.$nc(ee.location.fsPath),ie=E.$nc(ne.location.fsPath);return _<ie?-1:_>ie?1:0})}L(H,Q,J,W,ee){const ne=(ie,K,B)=>{if(ie.isValid&&!K.isValid)return!1;if(ie.isValid===K.isValid){if(ee&&d.gt(ie.manifest.version,K.manifest.version))return this.y.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if(d.eq(ie.manifest.version,K.manifest.version)){if(ie.type===0)return this.y.debug(`Skipping extension ${K.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===W)return this.y.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return B?this.y.warn(`Overwriting user extension ${ie.location.path} with ${K.location.path}.`):this.y.debug(`Overwriting user extension ${ie.location.path} with ${K.location.path}.`),!0},_=new S.$8l;return H?.forEach(ie=>{const K=_.get(ie.identifier.id);(!K||ne(K,ie,!1))&&_.set(ie.identifier.id,ie)}),Q?.forEach(ie=>{const K=_.get(ie.identifier.id);if(!K&&H&&ie.type===0){this.y.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!K||ne(K,ie,!1))&&_.set(ie.identifier.id,ie)}),J?.forEach(ie=>{const K=_.get(ie.identifier.id);(!K||ne(K,ie,!0))&&_.set(ie.identifier.id,ie),_.set(ie.identifier.id,ie)}),[..._.values()]}async M(H,Q){this.y.trace("Started scanning system extensions");const J=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),ee=await(H&&!J.devMode?this.j:this.n).scanExtensions(J);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(H,Q){const J=this.z.isBuilt?[]:this.C.builtInExtensions;if(!J?.length)return[];this.y.trace("Started scanning dev system extensions");const W=Q?await this.O():{},ee=[],ne=f.URI.file(E.$hc(E.$jc(C.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ie of J){const K=W[ie.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":ee.push((0,l.$vg)(ne,ie.name));break;default:ee.push(f.URI.file(K));break}}const _=await Promise.all(ee.map(async ie=>this.n.scanExtension(await this.P(ie,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,I.$Hb)(_)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Q,J,W,ee,ne,_){const ie=await this.f(ee??b.$w),K=await this.Q(H),B=Q&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=B?await this.Q(B):void 0;return new U(H,K,B,P,Q,_,J,W,ne,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ee,ie)}async Q(H){try{const Q=await this.w.stat(H);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$Ap=M,e.$Ap=M=ye([Y(4,w.$Kk),Y(5,v.$vp),Y(6,a.$$j),Y(7,i.$0i),Y(8,h.$Wh),Y(9,t.$pj),Y(10,u.$Ik),Y(11,n.$Oh)],M);class U{constructor(H,Q,J,W,ee,ne,_,ie,K,B,P,O,T,F,V){this.location=H,this.mtime=Q,this.applicationExtensionslocation=J,this.applicationExtensionslocationMtime=W,this.profile=ee,this.profileScanOptions=ne,this.type=_,this.excludeObsolete=ie,this.validate=K,this.productVersion=B,this.productDate=P,this.productCommit=O,this.devMode=T,this.language=F,this.translations=V}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Q){return(0,l.$og)(H.location,Q.location)&&H.mtime===Q.mtime&&(0,l.$og)(H.applicationExtensionslocation,Q.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&H.profile===Q.profile&&A.$$m(H.profileScanOptions,Q.profileScanOptions)&&H.type===Q.type&&H.excludeObsolete===Q.excludeObsolete&&H.validate===Q.validate&&H.productVersion===Q.productVersion&&H.productDate===Q.productDate&&H.productCommit===Q.productCommit&&H.devMode===Q.devMode&&H.language===Q.language&&j.equals(H.translations,Q.translations)}}e.$Bp=U;let z=class extends g.$Sc{constructor(H,Q,J,W,ee){super(),this.f=H,this.g=Q,this.h=J,this.j=W,this.m=ee}async scanExtensions(H){const Q=H.profile?await this.r(H):await this.n(H);let J={};if(H.excludeObsolete&&H.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();J=JSON.parse(W)}catch{}return(0,y.$Lf)(J)?Q:Q.filter(W=>!J[m.$Bo.create(W).toString()])}async n(H){const Q=await this.j.resolve(H.location);if(!Q.children?.length)return[];const J=await Promise.all(Q.children.map(async W=>{if(!W.isDirectory||H.type===1&&(0,l.$sg)(W.resource).indexOf(".")===0)return null;const ee=new U(W.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee)}));return(0,I.$Hb)(J).sort((W,ee)=>W.location.path<ee.location.path?-1:1)}async r(H){let Q=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){Q=Q.filter(W=>!W.metadata?.isApplicationScoped);const J=await this.s(H.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,H);Q.push(...J)}return Q}async s(H,Q,J){const W=await this.g.scanProfileExtensions(H,J.profileScanOptions);if(!W.length)return[];const ee=await Promise.all(W.map(async ne=>{if(Q(ne)){const _=new U(ne.location,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(_,ne.metadata)}return null}));return(0,I.$Hb)(ee)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,l.$vg)(H.location,"package.json"))){const Q=await this.scanExtension(H);return Q?[Q]:[]}else return await this.scanExtensions(H)}catch(Q){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,D.$0)(Q)),[]}}async scanExtension(H,Q){try{let J=await this.scanExtensionManifest(H.location);if(J){J.publisher||(J.publisher=S.$2l),Q=Q??J.__metadata,delete J.__metadata;const W=(0,m.$Fo)(J.publisher,J.name),ee=Q?.id?{id:W,uuid:Q.id}:{id:W},ne=Q?.isSystem?0:H.type,_=ne===0||!!Q?.isBuiltin;J=await this.t(H.location,J,U.createNlsConfiguration(H));const ie={type:ne,identifier:ee,manifest:J,location:H.location,isBuiltin:_,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return H.validate?this.validate(ie,H):ie}}catch(J){H.type!==0&&this.m.error(J)}return null}validate(H,Q){let J=!0;const W=(0,s.$Qo)(Q.productVersion,Q.productDate,Q.location,H.manifest,H.isBuiltin);for(const[ee,ne]of W)ee===p.default.Error&&(J=!1,this.m.error(this.z(Q.location,ne)));return H.isValid=J,H.validations=W,H}async scanExtensionManifest(H){const Q=(0,l.$vg)(H,"package.json");let J;try{J=(await this.j.readFile(Q)).value.toString()}catch(ee){return(0,a.$pk)(ee)!==1&&this.m.error(this.z(H,(0,c.localize)(0,null,Q.path,ee.message))),null}let W;try{W=JSON.parse(J)}catch{const ne=[];(0,R.$Wm)(J,ne);for(const _ of ne)this.m.error(this.z(H,(0,c.localize)(1,null,Q.path,_.offset,_.length,(0,k.$xp)(_.error))));return null}return(0,R.$6m)(W)!=="object"?(this.m.error(this.z(H,(0,c.localize)(2,null,Q.path))),null):W}async t(H,Q,J){const W=await this.u(H,Q,J);if(W)try{const ee=[],ne=await this.w(W.default,ee);if(ee.length>0)return ee.forEach(ie=>{this.m.error(this.z(H,(0,c.localize)(3,null,W.default?.path,(0,k.$xp)(ie.error))))}),Q;if((0,R.$6m)(W)!=="object")return this.m.error(this.z(H,(0,c.localize)(4,null,W.default?.path))),Q;const _=W.values||Object.create(null);return(0,$.$yp)(this.m,Q,_,ne)}catch{}return Q}async u(H,Q,J){const W=(0,l.$vg)(H,"package.nls.json"),ee=(K,B)=>{B.forEach(P=>{this.m.error(this.z(H,(0,c.localize)(5,null,K?.path,(0,k.$xp)(P.error))))})},ne=K=>{this.m.error(this.z(H,(0,c.localize)(6,null,K?.path)))},_=`${Q.publisher}.${Q.name}`,ie=J.translations[_];if(ie)try{const K=f.URI.file(ie),B=(await this.j.readFile(K)).value.toString(),P=[],O=(0,R.$Wm)(B,P);return P.length>0?(ee(K,P),{values:void 0,default:W}):(0,R.$6m)(O)!=="object"?(ne(K),{values:void 0,default:W}):{values:O.contents?O.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let B;try{B=await this.y(H,J)}catch{return}if(!B.localized)return{values:void 0,default:B.original};try{const P=(await this.j.readFile(B.localized)).value.toString(),O=[],T=(0,R.$Wm)(P,O);return O.length>0?(ee(B.localized,O),{values:void 0,default:B.original}):(0,R.$6m)(T)!=="object"?(ne(B.localized),{values:void 0,default:B.original}):{values:T,default:B.original}}catch{return{values:void 0,default:B.original}}}}async w(H,Q){if(H)try{const J=(await this.j.readFile(H)).value.toString();return(0,R.$Wm)(J,Q)}catch{}}y(H,Q){return new Promise((J,W)=>{const ee=ne=>{const _=(0,l.$vg)(H,`package.nls.${ne}.json`);this.j.exists(_).then(ie=>{ie&&J({localized:_,original:(0,l.$vg)(H,"package.nls.json")});const K=ne.lastIndexOf("-");K===-1?J({localized:(0,l.$vg)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,K),ee(ne))})};if(Q.devMode||Q.pseudo||!Q.language)return J({localized:(0,l.$vg)(H,"package.nls.json"),original:null});ee(Q.language)})}z(H,Q){return`[${H.path}]: ${Q}`}};z=ye([Y(1,v.$vp),Y(2,u.$Ik),Y(3,a.$$j),Y(4,i.$0i)],z);let q=class extends z{constructor(H,Q,J,W,ee,ne,_){super(Q,W,ee,ne,_),this.G=H,this.H=J,this.D=this.B(new L.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(H){const Q=this.M(H),J=await this.I(Q);if(this.C=H,J&&J.input&&U.equals(J.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),J.result.map(ee=>(ee.location=f.URI.revive(ee.location),ee));const W=await super.scanExtensions(H);return await this.J(Q,{input:H,result:W}),W}async I(H){try{const Q=await this.j.readFile(H),J=JSON.parse(Q.value.toString());return{result:J.result,input:(0,o.$mh)(J.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",H.path,(0,D.$0)(Q))}return null}async J(H,Q){try{await this.j.writeFile(H,N.$be.fromString(JSON.stringify(Q)))}catch(J){this.m.debug("Error while writing the extension cache file:",H.path,(0,D.$0)(J))}}async L(){if(!this.C)return;const H=this.M(this.C),Q=await this.I(H);if(!Q)return;const J=Q.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$$m(W,J))try{this.m.info("Invalidating Cache",J,W),await this.j.del(H),this.F.fire()}catch(ee){this.m.error(ee)}}M(H){const Q=this.N(H);return this.h.extUri.joinPath(Q.cacheHome,H.type===0?S.$1l:S.$Zl)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(H.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};q=ye([Y(2,w.$Kk),Y(3,v.$vp),Y(4,u.$Ik),Y(5,a.$$j),Y(6,i.$0i)],q);function Z(x,H){const Q=(0,m.$Do)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new S.$6l(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Cp=Z;class X extends M{constructor(H,Q,J,W,ee,ne,_,ie,K,B,P,O){super(H,Q,(0,l.$vg)(J,".vscode-oss-dev","extensions","control.json"),W,ee,ne,_,ie,K,B,P,O),this.R=(async()=>{if(b.$z)try{const T=await this.w.readFile(f.URI.file(b.$z));return JSON.parse(T.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$Dp=X}),define(oe[244],ae([0,1,65,6,38,3,2,23,16,31,7,17]),function(te,e,I,L,A,N,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;let b=class extends D.$Sc{constructor(d,p){super(),this.b=d,this.f=p,this.a=new L.$Zg(5)}async postUninstall(d){const p=this.g(d,"uninstall");p&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(y){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(y)}}));try{await g.Promises.rm(this.m(d))}catch(y){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(y)}}g(d,p){const y=`vscode:${p}`;if(d.location.scheme===R.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[y]=="string"){const f=d.manifest.scripts[y].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${y} should be a node script`),null):{script:(0,k.$jc)(d.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(d,p,y,f,c){return new Promise((h,m)=>{const S=this.j(d,p,y,c);let s;const a=n=>{s&&(clearTimeout(s),s=null),n?m(n):h(void 0)};S.on("error",n=>{a((0,A.$Ai)(n)||"Unknown")}),S.on("exit",(n,i)=>{a(n?`post-${p} process exited with code ${n}`:void 0)}),f&&(s=setTimeout(()=>{s=null,S.kill(),m("timed out")},5e3))})}j(d,p,y,f){const c={silent:!0,execArgv:void 0},h=(0,I.fork)(d,[`--type=extension-post-${p}`,...y],c);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const m=N.Event.fromNodeEventEmitter(h.stdout,"data"),S=N.Event.fromNodeEventEmitter(h.stderr,"data");m(n=>this.f.info(f.identifier.id,f.manifest.version,`post-${p}`,n)),S(n=>this.f.error(f.identifier.id,f.manifest.version,`post-${p}`,n));const s=N.Event.any(N.Event.map(m,n=>({data:`%c${n}`,format:[""]})),N.Event.map(S,n=>({data:`%c${n}`,format:["color: red"]})));return N.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(f.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}m(d){return(0,k.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$Fp=b,e.$Fp=b=ye([Y(0,E.$Kk),Y(1,C.$0i)],b)}),define(oe[245],ae([0,1,7,17,28,22,51,11,14,10]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;let C=class extends D.$wp{constructor(b,l,d,p,y,f){super(g.URI.file(b.extensionsPath),l,d,p,y,f)}};e.$DN=C,e.$DN=C=ye([Y(0,k.$Xh),Y(1,R.$$j),Y(2,L.$Kk),Y(3,A.$Ik),Y(4,N.$cl),Y(5,I.$0i)],C)}),define(oe[246],ae([0,1,10,14,51,80,11,4,7,24,28,17]),function(te,e,I,L,A,N,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q7b=void 0;let b=class extends N.$Dp{constructor(d,p,y,f,c,h,m,S){super(I.URI.file(c.builtinExtensionsPath),I.URI.file(c.extensionsPath),c.userHome,d.defaultProfile,d,p,y,f,c,h,m,S)}};e.$Q7b=b,e.$Q7b=b=ye([Y(0,E.$Kk),Y(1,A.$vp),Y(2,D.$$j),Y(3,k.$0i),Y(4,L.$Xh),Y(5,g.$pj),Y(6,C.$Ik),Y(7,R.$Oh)],b)}),define(oe[21],ae([0,1,6,3,2,100,12,67,4,17]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7o=e.$6o=e.$5o=void 0,e.$5o="__$__isNewStorageMarker",e.$6o="__$__targetStorageMarker",e.$7o=(0,k.$Ph)("storageService");var C;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var E;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var b;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function l(c){const h=c.get(e.$6o);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$8o=l;class d extends A.$Sc{static{this.a=60*1e3}constructor(h={flushInterval:d.a}){super(),this.m=h,this.b=this.B(new L.$Qd),this.c=this.B(new L.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new I.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,m,S){return L.Event.filter(this.b.event,s=>s.scope===h&&(m===void 0||s.key===m),S)}n(){this.j.value=(0,I.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,m){const{key:S,external:s}=m;if(S===e.$6o){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:S,target:this.J(h)[S],external:s})}w(h){this.f.fire({reason:h})}get(h,m,S){return this.P(m)?.get(h,S)}getBoolean(h,m,S){return this.P(m)?.getBoolean(h,S)}getNumber(h,m,S){return this.P(m)?.getNumber(h,S)}getObject(h,m,S){return this.P(m)?.getObject(h,S)}storeAll(h,m){this.y(()=>{for(const S of h)this.store(S.key,S.value,S.scope,S.target,m)})}store(h,m,S,s,a=!1){if((0,D.$Hf)(m)){this.remove(h,S,a);return}this.y(()=>{this.z(h,S,s),this.P(S)?.set(h,m,a)})}remove(h,m,S=!1){this.y(()=>{this.z(h,m,void 0),this.P(m)?.delete(h,S)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,m){const S=[],s=this.J(h);for(const a of Object.keys(s))s[a]===m&&S.push(a);return S}z(h,m,S,s=!1){const a=this.J(m);typeof S=="number"?a[h]!==S&&(a[h]=S,this.P(m)?.set(e.$6o,JSON.stringify(a),s)):typeof a[h]=="number"&&(delete a[h],this.P(m)?.set(e.$6o,JSON.stringify(a),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const m=this.P(h);return m?l(m):Object.create(null)}isNew(h){return this.getBoolean(e.$5o,h)===!0}async flush(h=C.NONE){this.f.fire({reason:h});const m=this.P(-1),S=this.P(0),s=this.P(1);switch(h){case C.NONE:await I.Promises.settled([m?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await I.Promises.settled([m?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,S=this.P(1)?.items??new Map;return f(h,m,S,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,m){return this.w(C.NONE),(0,g.$Jk)(h)?this.R(h,m):this.S(h,m)}M(h,m){return!(h.id===m.id||p(m)&&p(h))}N(h,m,S){this.y(()=>{const s=new Set;for(const[a,n]of h)s.add(a),m.get(a)!==n&&this.u(S,{key:a,external:!0});for(const[a]of m.items)s.has(a)||this.u(S,{key:a,external:!0})})}}e.$9o=d;function p(c){return c.isDefault||!!c.useDefaultFlags?.globalState}e.$0o=p;class y extends d{constructor(){super(),this.U=this.B(new R.$3o(new R.$4o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$3o(new R.$4o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$3o(new R.$4o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$$o=y;async function f(c,h,m,S,s,a){const n=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,t=new Map;c.forEach((j,M)=>{i.set(M,j),t.set(M,n(j))});const r=new Map,o=new Map;h.forEach((j,M)=>{r.set(M,j),o.set(M,n(j))});const v=new Map,w=new Map;m.forEach((j,M)=>{v.set(M,j),w.set(M,n(j))}),console.group(S!==s?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const u=[];if(i.forEach((j,M)=>{u.push({key:M,value:j})}),console.table(u),console.groupEnd(),console.log(t),S!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const j=[];r.forEach((M,U)=>{j.push({key:U,value:M})}),console.table(j),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const $=[];v.forEach((j,M)=>{$.push({key:M,value:j})}),console.table($),console.groupEnd(),console.log(w)}e.$_o=f}),define(oe[114],ae([0,1,3,2,12,29,33,21]),function(te,e,I,L,A,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BCb=e.$ACb=void 0;let k=class extends L.$Sc{constructor(E,b){super(),this.a=new I.$Nd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(E)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(b.onDidInstallExtensions(l=>l.forEach(({local:d,operation:p})=>{d&&p===4&&this.f(d.identifier)})))}async enableExtension(E,b){return this.f(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}async disableExtension(E,b){return this.c(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}getDisabledExtensions(){return this.h(N.$bo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const b=this.getDisabledExtensions();return b.every(l=>!(0,D.$Ao)(l,E))?(b.push(E),this.g(b),!0):!1}f(E){const b=this.getDisabledExtensions();for(let l=0;l<b.length;l++){const d=b[l];if((0,D.$Ao)(d,E))return b.splice(l,1),this.g(b),!0}return!1}g(E){this.j(N.$bo,E)}h(E){return this.b.get(E,0)}j(E,b){this.b.set(E,b,0)}};e.$ACb=k,e.$ACb=k=ye([Y(0,R.$7o),Y(1,N.$ao)],k);class g extends L.$Sc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new I.$Nd),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new L.$Rc))(b=>this.f(b)))}get(E,b){let l;return b===0?((0,A.$Hf)(this.a[E])&&(this.a[E]=this.g(E,b)),l=this.a[E]):l=this.g(E,b),JSON.parse(l)}set(E,b,l){const d=JSON.stringify(b.map(({id:y,uuid:f})=>({id:y,uuid:f})));this.g(E,l)!==d&&(l===0&&(b.length?this.a[E]=d:delete this.a[E]),this.h(E,b.length?d:void 0,l))}f(E){if(!(0,A.$Hf)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const l=this.get(E.key,E.scope);delete this.a[E.key];const d=this.get(E.key,E.scope),p=l.filter(f=>!d.some(c=>(0,D.$Ao)(f,c))),y=d.filter(f=>!l.some(c=>(0,D.$Ao)(c,f)));(p.length||y.length)&&this.b.fire([...p,...y])}}g(E,b){return this.c.get(E,b,"[]")}h(E,b,l){b?this.c.store(E,b,l,1):this.c.remove(E,l)}}e.$BCb=g}),define(oe[247],ae([0,1,18,26,8,5,37,12,10,20,14,29,33,68,11,7,24,57,224,21,22,61]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=void 0;const s=N.$p?"web":(0,E.$6n)(N.$u,D.$ec),a="X-Market-Search-Activity-Id";var n;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...P){return String(P.reduce((O,T)=>O|T,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(O=w){this.d=O}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(O,T=this.d.pageSize){return new u({...this.d,pageNumber:O,pageSize:T})}withFilter(O,...T){const F=[...this.d.criteria,...T.length?T.map(V=>({filterType:O,value:V})):[{filterType:O}]];return new u({...this.d,criteria:F})}withSortBy(O){return new u({...this.d,sortBy:O})}withSortOrder(O){return new u({...this.d,sortOrder:O})}withFlags(...O){return new u({...this.d,flags:O.reduce((T,F)=>T|F,0)})}withAssetTypes(...O){return new u({...this.d,assetTypes:O})}withSource(O){return new u({...this.d,source:O})}get raw(){const{criteria:O,pageNumber:T,pageSize:F,sortBy:V,sortOrder:G,flags:re,assetTypes:ce}=this.d;return{filters:[{criteria:O,pageNumber:T,pageSize:F,sortBy:V,sortOrder:G}],assetTypes:ce,flags:re}}get searchText(){const O=this.d.criteria.filter(T=>T.filterType===t.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(O=>String(O.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function $(P,O){const T=(P||[]).filter(F=>F.statisticName===O)[0];return T?T.value:0}function j(P){const O="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(F=>F.assetType.indexOf(O)===0).reduce((F,V)=>{const G=z(P,V.assetType);return G&&F.push([V.assetType.substring(O.length),G]),F},[])}function M(P){if(P.properties){const O=P.properties.filter(V=>V.key===r.Repository),T=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=O.filter(V=>T.test(V.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return z(P,r.Repository)}function U(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function z(P,O){return P.files.filter(F=>F.assetType===O)[0]?{uri:`${P.assetUri}/${O}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${O}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function q(P,O){const T=P.properties?P.properties.filter(V=>V.key===O):[],F=T.length>0&&T[0].value;return F?F.split(",").map(V=>(0,b.$Eo)(V)):[]}function Z(P){const O=P.properties?P.properties.filter(T=>T.key===o.Engine):[];return O.length>0&&O[0].value||""}function X(P){const O=P.properties?P.properties.filter(T=>T.key===o.PreRelease):[];return O.length>0&&O[0].value==="true"}function x(P){const O=P.properties?P.properties.filter(F=>F.key===o.LocalizedLanguages):[],T=O.length>0&&O[0].value||"";return T?T.split(","):[]}function H(P){return P.properties?.find(O=>O.key===o.SponsorLink)?.value}function Q(P){return P.indexOf("preview")!==-1}function J(P){return P.targetPlatform?(0,E.$5n)(P.targetPlatform):"undefined"}function W(P){const O=(0,I.$Mb)(P.versions.map(J)),T=!!P.tags?.includes(E.$Zn),F=O.indexOf("web");return T?F===-1&&O.push("web"):F!==-1&&O.splice(F,1),O}function ee(P,O){const T=(0,E.$9n)(O);for(let F=0;F<P.length;F++){const V=P[F];if(V.version===P[F-1]?.version){let G=F;const re=J(V);if(re===O)for(;G>0&&P[G-1].version===V.version;)G--;else if(T.includes(re))for(;G>0&&P[G-1].version===V.version&&J(P[G-1])!==O;)G--;G!==F&&(P.splice(F,1),P.splice(G,0,V))}}return P}e.$cp=ee;function ne(P,O,T){P.telemetryData={index:O,querySource:T,queryActivityId:P.queryContext?.[a]}}function _(P,O,T,F){const V=P.versions[0],G={manifest:z(O,r.Manifest),readme:z(O,r.Details),changelog:z(O,r.Changelog),license:z(O,r.License),repository:M(O),download:U(O),icon:z(O,r.Icon),signature:z(O,r.Signature),coreTranslations:j(O)};return{identifier:{id:(0,b.$Fo)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:O.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(V),description:P.shortDescription||"",installCount:$(P.statistics,"install"),rating:$(P.statistics,"averagerating"),ratingCount:$(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:T,assets:G,properties:{dependencies:q(O,o.Dependency),extensionPack:q(O,o.ExtensionPack),engine:Z(O),localizedLanguages:x(O),targetPlatform:J(O),isPreReleaseVersion:X(O)},hasPreReleaseVersion:X(V),hasReleaseVersion:!0,preview:Q(P.flags),isSigned:!!G.signature,queryContext:F}}let ie=class{constructor(O,T,F,V,G,re,ce,ue){this.k=T,this.l=F,this.n=V,this.o=G,this.q=re,this.u=ce,this.w=ue;const he=ce.extensionsGallery,$e=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?he.servicePPEUrl:he?.serviceUrl,this.g=$e?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,c.$bp)(ce.version,ce,this.n,this.w,this.q,O,this.o)}x(O=""){return`${this.d}${O}`}isEnabled(){return!!this.d}async getExtensions(O,T,F){const V=L.CancellationToken.isCancellationToken(T)?{}:T,G=L.CancellationToken.isCancellationToken(T)?T:F,re=[],ce=[],ue=[],he=[];let $e=!0;for(const Ee of O){Ee.uuid?ce.push(Ee.uuid):re.push(Ee.id);const Ie=!!(Ee.version||Ee.preRelease);ue.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ie}),Ee.version&&he.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),$e=$e&&!!Ee.hasPreRelease&&!Ie}if(!ce.length&&!re.length)return[];let de=new u().withPage(1,O.length);ce.length&&(de=de.withFilter(t.ExtensionId,...ce)),re.length&&(de=de.withFilter(t.ExtensionName,...re)),(V.queryAllVersions||$e)&&(de=de.withFlags(de.flags,n.IncludeVersions)),V.source&&(de=de.withSource(V.source));const{extensions:we}=await this.z(de,{targetPlatform:V.targetPlatform??s,includePreRelease:ue,versions:he,compatible:!!V.compatible},G);return V.source&&we.forEach((Ee,Ie)=>ne(Ee,Ie,V.source)),we}async getCompatibleExtension(O,T,F){if((0,E.$7n)(O.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(O,T,F))return O;const V=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,O.identifier.uuid),{extensions:G}=await this.z(V,{targetPlatform:F,compatible:!0,includePreRelease:T},L.CancellationToken.None);return G[0]||null}async isExtensionCompatible(O,T,F){if(!(0,E.$8n)(O.properties.targetPlatform,O.allTargetPlatforms,F)||!T&&O.properties.isPreReleaseVersion)return!1;let V=O.properties.engine;if(!V){const G=await this.getManifest(O,L.CancellationToken.None);if(!G)throw new Error("Manifest was not found");V=G.engines.vscode}return(0,l.$So)(V,this.u.version,this.u.date)}async y(O,T,F,V,G){if(!(0,E.$8n)(J(O),V,G)||T!=="any"&&X(O)!==(T==="prerelease"))return!1;if(F)try{const re=await this.E(O);if(!(0,l.$So)(re,this.u.version,this.u.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${O.version}.`,(0,A.$0)(re)),!1}return!0}async query(O,T){let F=O.text||"";const V=O.pageSize??50;let G=new u().withPage(1,V);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(G=G.withFilter(t.Category,we||de),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(G=G.withFilter(t.Tag,we||de),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(t.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),G=G.withFilter(t.SearchText,F)),G=G.withSortBy(0)):O.ids?G=G.withFilter(t.ExtensionId,...O.ids):O.names?G=G.withFilter(t.ExtensionName,...O.names):G=G.withSortBy(4),typeof O.sortBy=="number"&&(G=G.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(G=G.withSortOrder(O.sortOrder)),O.source&&(G=G.withSource(O.source));const re=async($e,de)=>{const{extensions:we,total:Ee}=await this.z($e,{targetPlatform:s,compatible:!1,includePreRelease:!!O.includePreRelease},de);return we.forEach((Ie,Le)=>ne(Ie,($e.pageNumber-1)*$e.pageSize+Le,O.source)),{extensions:we,total:Ee}},{extensions:ce,total:ue}=await re(G,T),he=async($e,de)=>{if(de.isCancellationRequested)throw new A.$5;const{extensions:we}=await re(G.withPage($e+1),de);return we};return{firstPage:ce,total:ue,pageSize:G.pageSize,getPage:he}}async z(O,T,F){const V=O.flags;O.flags&n.IncludeLatestVersionOnly&&O.flags&n.IncludeVersions&&(O=O.withFlags(O.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(O.flags&n.IncludeLatestVersionOnly)&&!(O.flags&n.IncludeVersions)&&(O=O.withFlags(O.flags,n.IncludeLatestVersionOnly)),T.versions?.length&&(O=O.withFlags(O.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),O=O.withFlags(O.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:G,total:re,context:ce}=await this.B(O,F);if(!(O.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of G){const Ee=await this.A(we,T,ce);Ee&&de.push(Ee)}return{extensions:de,total:re}}const he=[],$e=new Map;for(let de=0;de<G.length;de++){const we=G[de],Ee={id:(0,b.$Fo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,R.$Ef)(T.includePreRelease)?T.includePreRelease:!!T.includePreRelease.find(Te=>(0,b.$Ao)(Te,Ee))?.includePreRelease;if(T.compatible&&(0,E.$7n)(W(we),T.targetPlatform))continue;const Le=await this.A(we,T,ce);!Le||Le.properties.isPreReleaseVersion&&(!Ie||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==T.targetPlatform&&Le.hasPreReleaseVersion?$e.set(we.extensionId,de):he.push([de,Le])}if($e.size){const de=new S.$Jd,we=new u().withFlags(V&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(t.ExtensionId,...$e.keys()),{extensions:Ee}=await this.z(we,T,F);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Ie of Ee){const Le=$e.get(Ie.identifier.uuid);he.push([Le,Ie])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:re}}async A(O,T,F){const V={id:(0,b.$Fo)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},G=T.versions?.find(he=>(0,b.$Ao)(he,V))?.version,re=(0,R.$Ef)(T.includePreRelease)?T.includePreRelease:!!T.includePreRelease.find(he=>(0,b.$Ao)(he,V))?.includePreRelease,ce=W(O),ue=ee(O.versions,T.targetPlatform);if(T.compatible&&(0,E.$7n)(ce,T.targetPlatform))return null;for(let he=0;he<ue.length;he++){const $e=ue[he];if(!(G&&$e.version!==G)){if(await this.y($e,re?"any":"release",T.compatible,ce,T.targetPlatform))return _(O,$e,ce,F);if(G&&$e.version===G)return null}}return G||T.compatible?null:_(O,O.versions[0],ce)}async B(O,T){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const F=await this.j,V=JSON.stringify(O.raw),G={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},re=new S.$Jd;let ce,ue,he=0;try{if(ce=await this.k.request({type:"POST",url:this.g&&O.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:V,headers:G},T),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:he};const $e=await(0,f.$Zo)(ce);if($e){const de=$e.results[0],we=de.extensions,Ee=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return he=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[a]:ce.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(V.length),duration:re.elapsed(),success:!!ce&&(0,f.$Vo)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:ue?(0,A.$4)(ue)?"canceled":(0,A.$0)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(O,T,F,V){if(!this.isEnabled())return;const G=N.$p?this.x(`/itemName/${O}.${T}/version/${F}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${O}/extensions/${T}/${F}/stats?statType=${V}`),re=N.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:re};try{await this.k.request({type:"POST",url:G,headers:ue},L.CancellationToken.None)}catch{}}async download(O,T,F){this.l.trace("ExtensionGalleryService#download",O.identifier.id);const V=(0,b.$Io)(O),G=new Date().getTime(),re=de=>this.o.publicLog("galleryService:downloadVSIX",{...V,duration:de}),ce=F===2?"install":F===3?"update":"",ue=ce?{uri:`${O.assets.download.uri}${k.URI.parse(O.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${O.assets.download.fallbackUri}${k.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:O.assets.download,he=O.queryContext?.[a]?{[a]:O.queryContext[a]}:void 0,$e=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(T,$e.stream),re(new Date().getTime()-G)}async downloadSignatureArchive(O,T){if(!O.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",O.identifier.id);const F=await this.D(O.assets.signature);await this.q.writeFile(T,F.stream)}async getReadme(O,T){if(O.assets.readme){const F=await this.D(O.assets.readme,{},T);return await(0,f.$Yo)(F)||""}return""}async getManifest(O,T){if(O.assets.manifest){const F=await this.D(O.assets.manifest,{},T),V=await(0,f.$Yo)(F);return V?JSON.parse(V):null}return null}async C(O,T){const F=z(O,r.Manifest);if(!F)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.D(F,{headers:V});return await(0,f.$Zo)(G)}async getCoreTranslation(O,T){const F=O.assets.coreTranslations.filter(V=>V[0]===T.toUpperCase())[0];if(F){const V=await this.D(F[1]),G=await(0,f.$Yo)(V);return G?JSON.parse(G):null}return null}async getChangelog(O,T){if(O.assets.changelog){const F=await this.D(O.assets.changelog,{},T);return await(0,f.$Yo)(F)||""}return""}async getAllCompatibleVersions(O,T,F){let V=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?V=V.withFilter(t.ExtensionId,O.identifier.uuid):V=V.withFilter(t.ExtensionName,O.identifier.id);const{galleryExtensions:G}=await this.B(V,L.CancellationToken.None);if(!G.length)return[];const re=W(G[0]);if((0,E.$7n)(re,F))return[];const ce=[];await Promise.all(G[0].versions.map(async $e=>{try{await this.y($e,T?"any":"release",!0,re,F)&&ce.push($e)}catch{}}));const ue=[],he=new Set;for(const $e of ee(ce,F))he.has($e.version)||(he.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:X($e)}));return ue}async D(O,T={},F=L.CancellationToken.None){const V=await this.j,G={type:"GET"},re={...V,...T.headers||{}};T={...T,...G,headers:re};const ce=O.uri,ue=O.fallbackUri,he={...T,url:ce};try{const $e=await this.k.request(he,F);if($e.res.statusCode===200)return $e;const de=await(0,f.$Yo)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,A.$4)($e))throw $e;const de=(0,A.$0)($e);this.o.publicLog2("galleryService:cdnFallback",{url:ce,message:de});const we={...T,url:ue};return this.k.request(we,F)}}async E(O){let T=Z(O);if(!T){const F=await this.C(O,L.CancellationToken.None);if(!F)throw new Error("Manifest was not found");T=F.engines.vscode}return T}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const O=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const T=await(0,f.$Zo)(O),F=[],V={},G=[];if(T){for(const re of T.malicious)F.push({id:re});if(T.migrateToPreRelease)for(const[re,ce]of Object.entries(T.migrateToPreRelease))(!ce.engine||(0,l.$So)(ce.engine,this.u.version,this.u.date))&&(V[re.toLowerCase()]={disallowInstall:!0,extension:{id:ce.id,displayName:ce.displayName,autoMigrate:{storage:!!ce.migrateStorage},preRelease:!0}});if(T.deprecated)for(const[re,ce]of Object.entries(T.deprecated))ce&&(V[re.toLowerCase()]=(0,R.$Ef)(ce)?{}:ce);if(T.search)for(const re of T.search)G.push(re)}return{malicious:F,deprecated:V,search:G}}};ie=ye([Y(1,f.$To),Y(2,p.$0i),Y(3,C.$Wh),Y(4,m.$cl),Y(5,d.$$j),Y(6,y.$pj),Y(7,g.$ji)],ie);let K=class extends ie{constructor(O,T,F,V,G,re,ce,ue){super(O,T,F,V,G,re,ce,ue)}};e.$dp=K,e.$dp=K=ye([Y(0,h.$7o),Y(1,f.$To),Y(2,p.$0i),Y(3,C.$Wh),Y(4,m.$cl),Y(5,d.$$j),Y(6,y.$pj),Y(7,g.$ji)],K);let B=class extends ie{constructor(O,T,F,V,G,re,ce){super(void 0,O,T,F,V,G,re,ce)}};e.$ep=B,e.$ep=B=ye([Y(0,f.$To),Y(1,p.$0i),Y(2,C.$Wh),Y(3,m.$cl),Y(4,d.$$j),Y(5,y.$pj),Y(6,g.$ji)],B)}),define(oe[81],ae([0,1,4,3,2,21,33,24,18,7,12]),function(te,e,I,L,A,N,D,R,k,g,C){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=void 0,e.$Xu=(0,I.$Ph)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends A.$Sc{static{E=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,D.$Eo)(p.id)}@${p.version}`}static c(p){const y=b.exec(p);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(p,y){const f=await p.getInstalled(),c=[];for(const[h,m]of E.f(y)){const S=f.find(s=>(0,D.$Ao)(s.identifier,{id:h}))?.manifest.version;for(const s of m)S!==s&&c.push(E.b({id:h,version:s}))}for(const h of c)y.remove(h,0)}static f(p){const y=new Map,f=p.keys(0,1);for(const c of f){const h=E.c(c);if(h){let m=y.get(h.id.toLowerCase());m||y.set(h.id.toLowerCase(),m=[]),m.push(h.version)}}return y}constructor(p,y,f){super(),this.j=p,this.m=y,this.n=f,this.g=this.B(new L.$Nd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new A.$Rc))(c=>this.r(c)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const y=E.c(p.key);if(y){if(this.j.get(p.key,0)===void 0)this.h.delete(y.id.toLowerCase());else{let f=this.h.get(y.id.toLowerCase());f||this.h.set(y.id.toLowerCase(),f=[]),f.push(y.version),this.g.fire()}return}}s(p){if((0,C.$yf)(p))return p;const y=p.manifest?p.manifest.publisher:p.publisher,f=p.manifest?p.manifest.name:p.name;return(0,D.$Do)(y,f)}getExtensionState(p,y){const f=this.s(p),c=this.getExtensionStateRaw(p,y);if(c)try{return JSON.parse(c)}catch(h){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${y}): ${h}`)}}getExtensionStateRaw(p,y){const f=this.s(p),c=this.j.get(f,y?0:1);return c&&c?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${y}): ${c.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),c}setExtensionState(p,y,f){const c=this.s(p);y===void 0?this.j.remove(c,f?0:1):this.j.store(c,JSON.stringify(y),f?0:1,1)}setKeysForSync(p,y){this.j.store(E.b(p),JSON.stringify(y),0,1)}getKeysForSync(p){const y=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],f=this.j.get(E.b(p),0),c=f?JSON.parse(f):void 0;return c&&y?(0,k.$Mb)([...c,...y]):c||y}addToMigrationList(p,y){if(p!==y){const f=this.t.filter(c=>!c.includes(p)&&!c.includes(y));f.push([p,y]),this.t=f}}getSourceExtensionToMigrate(p){const y=this.t.find(([,f])=>p===f);return y?y[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(p);if(Array.isArray(y))return y}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Yu=l,e.$Yu=l=E=ye([Y(0,N.$7o),Y(1,R.$pj),Y(2,g.$0i)],l)}),define(oe[248],ae([0,1,29,11,24,14,98,55,21,22,221]),function(te,e,I,L,A,N,D,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c9b=void 0;let E=class extends C.$p5b{constructor(l,d,p,y,f,c,h,m){super(l.userHome,f,d,p,y,c,h,m)}};e.$c9b=E,e.$c9b=E=ye([Y(0,N.$Xh),Y(1,g.$cl),Y(2,I.$ao),Y(3,k.$7o),Y(4,R.$X6b),Y(5,D.$HVb),Y(6,L.$$j),Y(7,A.$pj)],E)}),define(oe[249],ae([0,1,105,3,22,14,2,7,16,65,24,5,6,101,20,165,36,21,12,132,19]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$8b=void 0;const S=[I.$48b,I.$58b],s="remoteTunnelSession",a="remoteTunnelIsService";let n=class extends D.$Sc{constructor(o,v,w,u,$,j,M){super(),this.y=o,this.z=v,this.C=w,this.D=j,this.F=M,this.f=new L.$Nd,this.onDidTokenFailed=this.f.event,this.g=new L.$Nd,this.onDidChangeTunnelStatus=this.g.event,this.h=new L.$Nd,this.onDidChangeMode=this.h.event,this.n=I.$28b,this.w=!1,this.I=(U,z)=>{z?this.j.error(U):this.j.info(U)},this.j=this.B(u.createLogger((0,m.$vg)(w.logsHome,`${I.$68b}.log`),{id:I.$68b,name:I.$78b})),this.t=new b.$Qg(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,R.$mj)(U)))),this.B($.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(j.onDidChangeConfiguration(U=>{S.some(z=>U.affectsConfiguration(z))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){t(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let o;E.$k?o=this.C.appRoot:o=(0,k.$mc)((0,k.$mc)(this.C.appRoot)),this.u=(0,k.$jc)(o,"bin",`${this.z.tunnelApplicationName}${E.$j?".exe":""}`)}return this.u}async startTunnel(o){if(t(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const o=this.n.asService;this.H(I.$28b);try{o&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",v=!1;const w=(z,q)=>{q?this.j.error(z):o+=z,!this.C.isBuilt&&z.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,p.localize)(0,null)))},u=this.O("status",["status"],w);this.r=u;try{if(await u,this.r!==u)return;const z=JSON.parse(o.trim().split(`
`).find(q=>q.startsWith("{")));if(v=z.service_installed,this.j.info(z.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!z.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(z){this.j.error(z),this.G(I.TunnelStates.disconnected());return}finally{this.r===u&&(this.r=void 0)}const $=this.n.active?this.n.session:void 0;if($&&$.token){const z=$.token;this.G(I.TunnelStates.connecting((0,p.localize)(1,null,$.accountLabel,$.providerId)));const q=(X,x)=>{X=X.replaceAll(z,"*".repeat(4)),w(X,x)},Z=this.O("login",["user","login","--provider",$.providerId,"--access-token",z,"--log",(0,R.$mj)(this.j.getLevel())],q);this.r=Z;try{if(await Z,this.r!==Z)return}catch(X){this.j.error(X),this.r=void 0,this.f.fire($),this.G(I.TunnelStates.disconnected($));return}}const j=this.Q();j?this.G(I.TunnelStates.connecting((0,p.localize)(2,null,j))):this.G(I.TunnelStates.connecting((0,p.localize)(3,null)));const M=["--accept-server-license-terms","--log",(0,R.$mj)(this.j.getLevel())];j?M.push("--name",j):M.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!v&&(U=await this.M(M)===!1),this.N($,M,U)}async M(o){let v;try{v=await this.O("serviceInstall",["service","install",...o])}catch(w){this.j.error(w),v=1}if(v!==0){const w=(0,p.localize)(4,null);return this.j.warn(w),this.G(I.TunnelStates.connecting(w)),!1}return!0}async N(o,v,w){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let u=!1;const $=this.O("tunnel",v,(j,M)=>{M?this.j.error(j):this.j.info(j),j.includes("Connected to an existing tunnel process")&&(u=!0);const U=j.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const z={link:U[1],domain:U[2],tunnelName:U[4],isAttached:u};this.G(I.TunnelStates.connected(z,w))}else j.match(/error refreshing token/)&&($.cancel(),this.f.fire(o),this.G(I.TunnelStates.disconnected(o)))});this.r=$,$.finally(()=>{$===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$28b,this.G(I.TunnelStates.disconnected()))})}O(o,v,w=this.I){return(0,b.$Hg)(u=>new Promise(($,j)=>{u.isCancellationRequested&&$(-1);let M;const U=["ignore","pipe","pipe"];if(u.onCancellationRequested(()=>{M&&(this.j.info(`${o} terminating(${M.pid})`),M.kill())}),!this.C.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${o} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),M=(0,g.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,k.$jc)(this.C.appRoot,"cli"),stdio:U});else{w(`Running tunnel CLI
`,!1);const z=this.J();w(`${o} Spawning: ${z} tunnel ${v.join(" ")}
`,!1),M=(0,g.spawn)(z,["tunnel",...v],{cwd:(0,y.homedir)(),stdio:U})}M.stdout.pipe(new h.$fT(`
`)).on("data",z=>{if(M){const q=z.toString();w(q,!1)}}),M.stderr.pipe(new h.$fT(`
`)).on("data",z=>{if(M){const q=z.toString();w(q,!0)}}),M.on("exit",z=>{M&&(w(`${o} exit(${M.pid}): + ${z} `,!1),M=void 0,$(z||0))}),M.on("error",z=>{M&&(w(`${o} error(${M.pid}): + ${z} `,!0),M=void 0,j())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$58b)}Q(){let o=this.D.getValue(I.$48b)||(0,y.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(s,-1),v=this.F.getBoolean(a,-1,!1);if(o){const w=JSON.parse(o);if(w&&(0,c.$yf)(w.accountLabel)&&(0,c.$yf)(w.sessionId)&&(0,c.$yf)(w.providerId))return{active:!0,session:w,asService:v};this.j.error("Problems restoring session from storage, invalid format",w)}}catch(o){this.j.error("Problems restoring session from storage",o)}return I.$28b}S(o){if(o.active){const v={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(a,o.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(a,-1)}};e.$$8b=n,e.$$8b=n=ye([Y(0,A.$cl),Y(1,C.$pj),Y(2,N.$Xh),Y(3,R.$$i),Y(4,l.$98b),Y(5,d.$ji),Y(6,f.$7o)],n);function i(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const t=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&i(r.session,o.session):!0}),define(oe[250],ae([0,1,6,2,23,19,67,21,76,17]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d9b=void 0;class C extends R.$9o{constructor(b,l,d,p){super(),this.bb=b,this.cb=l,this.db=d,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new L.$Rc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new L.$Rc),this.ab=this.hb(this.bb)}fb(){const b=this.B(new k.$0Cb(this.db.getChannel("storage"))),l=this.B(new D.$3o(b));return this.B(l.onDidChangeStorage(d=>this.u(-1,d))),l}gb(b){this.X.clear(),this.W=b;let l;if((0,R.$0o)(b))l=this.U;else{const d=this.X.add(new k.$$Cb(this.db.getChannel("storage"),b));l=this.X.add(new D.$3o(d))}return this.X.add(l.onDidChangeStorage(d=>this.u(0,d))),l}hb(b){this.$.clear(),this.Z=b?.id;let l;if(b){const d=this.$.add(new k.$_Cb(this.db.getChannel("storage"),b));l=this.$.add(new D.$3o(d)),this.$.add(l.onDidChangeStorage(p=>this.u(1,p)))}return l}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(b){switch(b){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(b){switch(b){case-1:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,N.$vg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(b){if(!this.M(this.W,b))return;const l=this.Y,d=l.items;l!==this.U&&await l.close(),this.Y=this.gb(b),await this.Y.init(),this.N(d,this.Y,0)}async S(b,l){const d=this.ab,p=d?.items??new Map;await d?.close(),this.ab=this.hb(b),await this.ab.init(),this.N(p,this.ab,1)}hasScope(b){return(0,g.$Jk)(b)?this.W.id===b.id:this.Z===b.id}}e.$d9b=C}),define(oe[251],ae([0,1,3,2,17,92]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=void 0;class D{constructor(g,C){this.a=g,this.b=C}listen(g,C){const E=this.b(g);switch(C){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(l=>(0,N.$Nm)({...l},E)),added:b.added.map(l=>(0,N.$Nm)({...l},E)),removed:b.removed.map(l=>(0,N.$Nm)({...l},E)),updated:b.updated.map(l=>(0,N.$Nm)({...l},E))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,E){const b=this.b(g);switch(C){case"createProfile":{const l=await this.a.createProfile(E[0],E[1],E[2]);return(0,N.$Nm)({...l},b)}case"updateProfile":{let l=(0,A.$Lk)((0,N.$Om)(E[0],b),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,E[1]),(0,N.$Nm)({...l},b)}case"removeProfile":{const l=(0,A.$Lk)((0,N.$Om)(E[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${C}`)}}e.$KN=D;class R extends L.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,E){super(),this.profilesHome=C,this.f=E,this.a=[],this.b=this.B(new I.$Nd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(b=>(0,A.$Lk)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const l=b.added.map(y=>(0,A.$Lk)(y,this.profilesHome.scheme)),d=b.removed.map(y=>(0,A.$Lk)(y,this.profilesHome.scheme)),p=b.updated.map(y=>(0,A.$Lk)(y,this.profilesHome.scheme));this.a=b.all.map(y=>(0,A.$Lk)(y,this.profilesHome.scheme)),this.b.fire({added:l,removed:d,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,E){const b=await this.f.call("createNamedProfile",[g,C,E]);return(0,A.$Lk)(b,this.profilesHome.scheme)}async createProfile(g,C,E,b){const l=await this.f.call("createProfile",[g,C,E,b]);return(0,A.$Lk)(l,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,A.$Lk)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const E=await this.f.call("updateProfile",[g,C]);return(0,A.$Lk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$LN=R}),define(oe[58],ae([0,1,2,67,4,21,3,76,17]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dDb=e.$cDb=e.$bDb=void 0,e.$bDb=(0,A.$Ph)("IUserDataProfileStorageService");let g=class extends I.$Sc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async d=>this.b(d))}async updateStorageData(l,d,p){return this.withProfileScopedStorageService(l,async y=>this.c(y,d,p))}async withProfileScopedStorageService(l,d){if(this.a.hasScope(l))return d(this.a);const p=await this.g(l),y=new E(p);try{await y.initialize();const f=await d(y);return await y.flush(),f}finally{y.dispose(),await this.f(p)}}b(l){const d=new Map,p=y=>{for(const f of l.keys(0,y))d.set(f,{value:l.get(f,0),target:y})};return p(0),p(1),d}c(l,d,p){l.storeAll(Array.from(d.entries()).map(([y,f])=>({key:y,value:f,scope:0,target:p})),!0)}async f(l){try{await l.close()}finally{(0,I.$Mc)(l)&&l.dispose()}}};e.$cDb=g,e.$cDb=g=ye([Y(0,N.$7o)],g);class C extends g{constructor(l,d,p,y){super(p),this.j=l;const f=l.getChannel("profileStorageListener"),c=this.B(new I.$Tc);this.h=this.B(new D.$Nd({onWillAddFirstListener:()=>{c.value=f.listen("onDidChange")(h=>{y.trace("profile storage changes",h),this.h.fire({targetChanges:h.targetChanges.map(m=>(0,k.$Lk)(m,d.profilesHome.scheme)),valueChanges:h.valueChanges.map(m=>({...m,profile:(0,k.$Lk)(m.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>c.value=void 0})),this.onDidChange=this.h.event}async g(l){const d=this.j.getChannel("storage");return(0,N.$0o)(l)?new R.$0Cb(d):new R.$$Cb(d,l)}}e.$dDb=C;class E extends N.$9o{constructor(l){super({flushInterval:100}),this.s=this.B(new L.$3o(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(oe[252],ae([0,1,21,7,17,72,58]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U8b=void 0;let R=class extends D.$dDb{constructor(g,C,E,b){super(g,C,E,b)}};e.$U8b=R,e.$U8b=R=ye([Y(0,N.$g8b),Y(1,A.$Kk),Y(2,I.$7o),Y(3,L.$0i)],R)}),define(oe[39],ae([0,1,18,6,15,26,3,35,2,27,12,170,20,14,11,7,43,21,22,28,25,17]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Db=e.$7Db=e.$6Db=e.$5Db=e.$4Db=e.$3Db=e.$2Db=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||a(v.syncData)))}e.$2Db=s;function a(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$3Db=a;function n(v,w){return`${(0,g.$qf)(v)}${w.isDefault?"":` (${w.name})`}`}e.$4Db=n;let i=class extends k.$Sc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(w,u,$,j,M,U,z,q,Z,X,x,H){super(),this.syncResource=w,this.collection=u,this.G=$,this.H=j,this.I=M,this.J=U,this.L=z,this.M=q,this.N=Z,this.O=X,this.P=x,this.c=null,this.m="idle",this.n=this.B(new D.$Nd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new D.$Nd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new L.$Rg(50)),this.w=this.B(new D.$Nd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(w.syncResource,w.profile),this.h=H.extUri,this.f=this.h.joinPath(j.userDataSyncHome,...(0,m.$Dgb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,m.$Ygb),this.y=(0,m.$Egb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,j,this.h),this.j=(0,y.$ap)(j,$,M)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const u=await this.Y(w.remoteUserData,w.lastSyncUserData,!0,this.ob());this.S(u)}else{this.O.trace(`${this.D}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.ub(w):!0)&&this.w.fire()}}S(w){this.m!==w&&(this.m=w,this.n.fire(w))}async sync(w,u={}){await this.U(w,!0,this.ob(),u)}async preview(w,u,$={}){return this.U(w,!1,u,$)}async apply(w,u={}){try{this.F={...u};const $=await this.ab(w);return this.S($),this.c}finally{this.F={}}}async U(w,u,$,j){try{if(this.F={...j},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let M="idle";try{const U=await this.getLastSyncUserData(),z=await this.X(w,U);return M=await this.Y(z,U,u,$),M==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(M)}}finally{this.F={}}}async replace(w){const u=this.kb(w);if(!u)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const $=await this.getLastSyncUserData(),j=await this.X(null,$),M=await this.W(j),U=await this.qb({ref:j.ref,syncData:u},$,M,this.ob(),N.CancellationToken.None),z=[];for(const q of U){const Z=await this.sb(q,q.remoteResource,void 0,N.CancellationToken.None),{remoteChange:X}=await this.sb(q,q.previewResource,q.remoteContent,N.CancellationToken.None);z.push([q,{...Z,remoteChange:X!==0?X:2}])}await this.tb(j,$,z,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(w){const u=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===u}async X(w,u){if(u){const $=w?w[this.resource]:void 0;if(u.ref===$||$===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async Y(w,u,$,j){if(w.syncData&&w.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new m.$Lgb((0,E.localize)(0,null,this.resource,this.pb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(w,u,$,j)}catch(M){if(M instanceof m.$Lgb)switch(M.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(w,u,$,j);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.Y(w,u,$,j)}throw M}}async Z(w,u,$,j){try{const M=await this.W(w),U=!M&&u===null&&this.gb()!==void 0,z=$&&!U;this.c||(this.c=(0,L.$Hg)(Z=>this.eb(w,u,M,z,j,Z)));let q=await this.c;if($&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of q.resourcePreviews)q=await this.accept(Z.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":$?await this.ab(!1):"syncing"}catch(M){throw this.c=null,M}}async merge(w){return await this.$(w,async u=>{const $=await this.rb(u,N.CancellationToken.None);await this.G.writeFile(u.previewResource,A.$be.fromString($?.content||""));const j=$&&!$.hasConflicts?await this.sb(u,u.previewResource,void 0,N.CancellationToken.None):void 0;return u.acceptResult=j,u.mergeState=$.hasConflicts?"conflict":j?"accepted":"preview",u.localChange=j?j.localChange:$.localChange,u.remoteChange=j?j.remoteChange:$.remoteChange,u}),this.c}async accept(w,u){return await this.$(w,async $=>{const j=await this.sb($,w,u,N.CancellationToken.None);return $.acceptResult=j,$.mergeState="accepted",$.localChange=j.localChange,$.remoteChange=j.remoteChange,$}),this.c}async discard(w){return await this.$(w,async u=>{const $=await this.rb(u,N.CancellationToken.None);return await this.G.writeFile(u.previewResource,A.$be.fromString($.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=$.localChange,u.remoteChange=$.remoteChange,u}),this.c}async $(w,u){if(!this.c)return;let $=await this.c;const j=$.resourcePreviews.findIndex(({localResource:M,remoteResource:U,previewResource:z})=>this.h.isEqual(M,w)||this.h.isEqual(U,w)||this.h.isEqual(z,w));j!==-1&&(this.c=(0,L.$Hg)(async M=>{const U=[...$.resourcePreviews];return U[j]=await u(U[j]),{...$,resourcePreviews:U}}),$=await this.c,this.cb($.resourcePreviews),$.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(w){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:$})=>$==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:$})=>$!=="accepted")?"syncing":(await this.tb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map($=>[$,$.acceptResult]),w),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(w){const u=w.filter(({mergeState:$})=>$==="conflict");(0,I.$ub)(this.s,u,($,j)=>this.h.isEqual($.previewResource,j.previewResource))||(this.s=u,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async db(w){const u=this.c?await this.c:null;if(u)for(const $ of u.resourcePreviews){if(this.h.isEqual($.acceptedResource,w))return $.acceptResult?$.acceptResult.content:null;if(this.h.isEqual($.remoteResource,w))return $.remoteContent;if(this.h.isEqual($.localResource,w))return $.localContent;if(this.h.isEqual($.baseResource,w))return $.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(w){(0,d.$pk)(w)!==1&&this.O.error(w)}}async eb(w,u,$,j,M,U){const z=await this.qb(w,u,$,M,U),q=[];for(const Z of z){const X=Z.previewResource.with({scheme:m.$Xgb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)q.push({...Z,acceptedResource:X,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=j?await this.rb(Z,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(Z.previewResource,A.$be.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(Z,Z.previewResource,void 0,U):void 0;q.push({...Z,acceptResult:H,mergeState:x?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:x?x.localChange:Z.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:u,resourcePreviews:q,isLastSyncFromCurrentMachine:$}}async getLastSyncUserData(){let w=this.gb();if(w||(w=await this.jb()),!w)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const u=JSON.parse(w),$=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!u.version&&!!$&&u.version!==$,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${$}.`),await this.resetLocal(),null;let j,M=1;for(;j===void 0&&M++<6;)try{const U=await this.hb();U&&(U.ref===u.ref?j=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof d.$tk&&U.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof m.$Lgb)throw U;this.O.error(U,M)}}if(j===void 0)try{const U=await this.J.resolveResourceContent(this.resource,u.ref,this.collection,this.F);j=U===null?null:this.kb(U),await this.ib({ref:u.ref,syncData:j})}catch(U){if(U instanceof m.$Lgb&&U.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return j===void 0?null:{...u,syncData:j}}async fb(w,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const $=this.M.getResourceSyncStateVersion(this.resource),j={ref:w.ref,version:$,...u};this.I.store(this.z,JSON.stringify(j),-1,1),await this.ib(w)}gb(){return this.I.get(this.z,-1)}async hb(){const w=(await this.G.readFile(this.y)).value.toString();try{const u=w?JSON.parse(w):void 0;if(s(u))return u}catch(u){this.O.error(u)}}async ib(w){await this.G.writeFile(this.y,A.$be.fromString(JSON.stringify(w)))}async jb(){try{const w=await this.G.readFile(this.y),u=JSON.parse(w.value.toString());await this.G.del(this.y),u.ref&&u.content!==void 0?(this.I.store(this.z,JSON.stringify({...u,content:void 0}),-1,1),await this.ib({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,u)}catch(w){w instanceof d.$tk&&w.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(w)}return this.I.get(this.z,-1)}async getRemoteUserData(w){const{ref:u,content:$}=await this.lb(w);let j=null;return $!==null&&(j=this.kb($)),{ref:u,syncData:j}}kb(w){try{const u=JSON.parse(w);if(a(u))return u}catch(u){this.O.error(u)}throw new m.$Lgb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(w){const u=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.J.readResource(this.resource,u,this.collection,this.F)}async mb(w,u){const $=await this.j,j={version:this.pb,machineId:$,content:w};try{return u=await this.J.writeResource(this.resource,JSON.stringify(j),u,this.collection,this.F),{ref:u,syncData:j}}catch(M){throw M instanceof m.$Lgb&&M.code==="TooLarge"&&(M=new m.$Lgb(M.message,M.code,this.resource)),M}}async nb(w){const u={version:this.pb,content:w};return this.L.writeResource(this.resource,JSON.stringify(u),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(m.$ygb)}};e.$5Db=i,e.$5Db=i=ye([Y(2,d.$$j),Y(3,l.$Wh),Y(4,f.$7o),Y(5,m.$Ggb),Y(6,m.$Hgb),Y(7,m.$Qgb),Y(8,c.$cl),Y(9,m.$Vgb),Y(10,b.$ji),Y(11,h.$Ik)],i);let t=class extends i{constructor(w,u,$,j,M,U,z,q,Z,X,x,H,Q){super(u,$,j,M,U,z,q,Z,X,x,H,Q),this.r=w,this.B(this.G.watch(this.h.dirname(w))),this.B(this.G.onDidFilesChange(J=>this.yb(J)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(w,u,$){try{u?await this.G.writeFile(this.r,A.$be.fromString(w),$?void 0:u):await this.G.createFile(this.r,A.$be.fromString(w),{overwrite:$})}catch(j){throw j instanceof d.$tk&&j.fileOperationResult===1||j instanceof d.$tk&&j.fileOperationResult===3?new m.$Lgb(j.message,"LocalPreconditionFailed"):j}}async xb(){try{await this.G.del(this.r)}catch(w){if(!(w instanceof d.$tk&&w.fileOperationResult===1))throw w}}yb(w){w.contains(this.r)&&this.Q()}};e.$6Db=t,e.$6Db=t=ye([Y(3,d.$$j),Y(4,l.$Wh),Y(5,f.$7o),Y(6,m.$Ggb),Y(7,m.$Hgb),Y(8,m.$Qgb),Y(9,c.$cl),Y(10,m.$Vgb),Y(11,b.$ji),Y(12,h.$Ik)],t);let r=class extends t{constructor(w,u,$,j,M,U,z,q,Z,X,x,H,Q,J){super(w,u,$,j,M,U,z,q,Z,X,x,Q,J),this.zb=H,this.Bb=void 0}Ab(w,u){const $=[],j=(0,R.$Wm)(w,$,{allowEmptyContent:!0,allowTrailingComma:!0});return $.length>0||!(0,C.$Ff)(j)&&u!==Array.isArray(j)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$7Db=r,e.$7Db=r=ye([Y(3,d.$$j),Y(4,l.$Wh),Y(5,f.$7o),Y(6,m.$Ggb),Y(7,m.$Hgb),Y(8,m.$Qgb),Y(9,c.$cl),Y(10,m.$Vgb),Y(11,m.$Ugb),Y(12,b.$ji),Y(13,h.$Ik)],r);let o=class{constructor(w,u,$,j,M,U,z){this.resource=w,this.g=u,this.h=$,this.j=j,this.k=M,this.l=U,this.d=z.extUri,this.f=(0,m.$Egb)(void 0,this.resource,$,this.d)}async initialize({ref:w,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const $=this.m(u);if($)try{await this.o({ref:w,syncData:$})}catch(j){this.j.error(j)}}m(w){try{const u=JSON.parse(w);if(a(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const $={ref:w.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify($),-1,1),await this.k.writeFile(this.f,A.$be.fromString(JSON.stringify(w)))}};e.$8Db=o,e.$8Db=o=ye([Y(1,S.$Kk),Y(2,l.$Wh),Y(3,p.$0i),Y(4,d.$$j),Y(5,f.$7o),Y(6,h.$Ik)],o)}),define(oe[115],ae([0,1,6,26,8,3,41,2,27,20,14,114,29,33,81,44,11,4,71,7,21,22,28,17,39,232,111,25,58]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m,S,s,a,n,i,t,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C3b=e.$B3b=e.$A3b=e.$z3b=e.$y3b=void 0;async function v(U,z){const q=JSON.parse(U.content);if(U.version===1||U.version===2){const Z=(await z.getInstalled(0)).filter(X=>X.isBuiltin);for(const X of q)U.version===1&&(X.enabled===!1&&(X.disabled=!0),delete X.enabled),U.version===2&&Z.every(x=>!(0,l.$Ao)(x.identifier,X.identifier))&&(X.installed=!0)}return q}function w(U){return JSON.parse(U.content)}e.$y3b=w;function u(U,z){return U.sort((q,Z)=>!q.identifier.uuid&&Z.identifier.uuid?-1:q.identifier.uuid&&!Z.identifier.uuid?1:(0,k.$Ue)(q.identifier.id,Z.identifier.id)),z?(0,D.$ZS)(U,{}):JSON.stringify(U)}e.$z3b=u;let $=class extends n.$5Db{constructor(z,q,Z,X,x,H,Q,J,W,ee,ne,_,ie,K,B,P,O){super({syncResource:"extensions",profile:z},q,X,Z,x,H,Q,_,ie,ee,ne,B),this.Cb=J,this.Db=W,this.Eb=O,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Xgb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Xgb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Xgb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Xgb,authority:"accepted"}),this.Bb=this.Eb.createInstance(j),this.B(N.Event.any(N.Event.filter(this.Cb.onDidInstallExtensions,T=>T.some(({local:F})=>!!F)),N.Event.filter(this.Cb.onDidUninstallExtension,T=>!T.error),N.Event.filter(P.onDidChange,T=>T.valueChanges.some(({profile:F,changes:V})=>this.syncResource.profile.id===F.id&&V.some(G=>G.key===b.$bo))),K.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(z,q){const Z=z.syncData?await v(z.syncData,this.Cb):null,X=q?.skippedExtensions??[],x=q?.builtinExtensions??null,H=q?.syncData?await v(q.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile);Z?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:ee}=(0,i.$x3b)(Q,Z,H,X,J,x),ne={local:W,remote:ee,content:this.Hb(Q,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:ee!==null?2:0},_=this.Ob(Q,!1);return[{skippedExtensions:X,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):_,localResource:this.yb,localContent:_,localExtensions:Q,remoteResource:this.zb,remoteExtensions:Z,remoteContent:Z?this.Ob(Z,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(z){const q=z.syncData?await v(z.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:X}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$x3b)(Z,q,q,z.skippedExtensions||[],X,z.builtinExtensions||[]);return x!==null}Hb(z,q,Z,X){const x=[...q,...Z],H=new Set,Q=J=>{H.add(J.id.toLowerCase()),J.uuid&&H.add(J.uuid)};x.forEach(({identifier:J})=>Q(J)),X.forEach(Q);for(const J of z)H.has(J.identifier.id.toLowerCase())||J.identifier.uuid&&H.has(J.identifier.uuid)||x.push(J);return this.Ob(x,!1)}async rb(z,q){return{...z.previewResult,hasConflicts:!1}}async sb(z,q,Z,X){if(this.h.isEqual(q,this.yb))return this.Kb(z);if(this.h.isEqual(q,this.zb))return this.Lb(z);if(this.h.isEqual(q,this.wb))return z.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(z){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(q),X=(0,i.$x3b)(z.localExtensions,null,null,z.skippedExtensions,Z,z.builtinExtensions),{local:x,remote:H}=X;return{content:z.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(z){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(q),X=z.remoteContent?JSON.parse(z.remoteContent):null;if(X!==null){const x=(0,i.$x3b)(z.localExtensions,X,z.localExtensions,[],Z,z.builtinExtensions),{local:H,remote:Q}=x;return{content:z.remoteContent,local:H,remote:Q,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:z.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(z,q,Z,X){let{skippedExtensions:x,builtinExtensions:H,localExtensions:Q}=Z[0][0];const{local:J,remote:W,localChange:ee,remoteChange:ne}=Z[0][1];if(ee===0&&ne===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==0&&(await this.nb(JSON.stringify(Q)),x=await this.Bb.updateLocalExtensions(J.added,J.removed,J.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(W.all);z=await this.mb(_,X?null:z.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(ie=>ie.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(ie=>ie.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(ie=>ie.identifier.id))}.`:""}`)}q?.ref!==z.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(Q,H),await this.fb(z,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(z,q){const Z=new Set,X=[];for(const x of z)Z.add(x.identifier.id.toLowerCase()),x.installed||X.push(x.identifier);if(q)for(const x of q)Z.has(x.id.toLowerCase())||X.push(x);return X}async resolveContent(z){if(this.h.isEqual(this.zb,z)||this.h.isEqual(this.xb,z)||this.h.isEqual(this.yb,z)||this.h.isEqual(this.Ab,z)){const q=await this.db(z);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(z,q){return u(z,q)}async hasLocalData(){try{const{localExtensions:z}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(z.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$A3b=$,e.$A3b=$=ye([Y(2,C.$Wh),Y(3,y.$$j),Y(4,m.$7o),Y(5,r.$Ggb),Y(6,r.$Hgb),Y(7,b.$ao),Y(8,t.$MEb),Y(9,r.$Vgb),Y(10,g.$ji),Y(11,r.$Qgb),Y(12,S.$cl),Y(13,d.$Xu),Y(14,s.$Ik),Y(15,o.$bDb),Y(16,f.$Oh)],$);let j=class{constructor(z,q,Z,X,x,H){this.a=z,this.b=q,this.c=Z,this.d=X,this.f=x,this.g=H}async getLocalExtensions(z){const q=await this.a.getInstalled(void 0,z.extensionsResource),Z=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(z,async(x,H)=>{const Q=x.getDisabledExtensions();return q.map(J=>{const{identifier:W,isBuiltin:ee,manifest:ne,preRelease:_,pinned:ie,isApplicationScoped:K}=J,B={identifier:W,preRelease:_,version:ne.version,pinned:!!ie};K&&!(0,p.$9l)(ne)&&(B.isApplicationScoped=K),Q.some(P=>(0,l.$Ao)(P,W))&&(B.disabled=!0),ee||(B.installed=!0);try{const P=H.getKeysForSync({id:W.id,version:ne.version});if(P){const O=H.getExtensionState(J,!0)||{};B.state=Object.keys(O).reduce((T,F)=>(P.includes(F)&&(T[F]=O[F]),T),{})}}catch(P){this.g.info(`${(0,n.$4Db)("extensions",z)}: Error while parsing extension state`,(0,A.$0)(P))}return B})}),ignoredExtensions:Z}}async updateLocalExtensions(z,q,Z,X,x){const H=(0,n.$4Db)("extensions",x),Q=[],J=new Map,W=[],ee=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((z.length||Z.length)&&await this.j(x,async(K,B)=>{await I.Promises.settled([...z,...Z].map(async P=>{const O=ne.find(V=>(0,l.$Ao)(V.identifier,P.identifier));if(O&&O.isBuiltin){P.state&&O.manifest.version===P.version&&this.h(P.state,O,O.manifest.version,B),K.getDisabledExtensions().some(G=>(0,l.$Ao)(G,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${H}: Disabling extension...`,P.identifier.id),await K.disableExtension(P.identifier),this.g.info(`${H}: Disabled extension`,P.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,P.identifier.id),await K.enableExtension(P.identifier),this.g.info(`${H}: Enabled extension`,P.identifier.id))),W.push(P.identifier);return}const T=P.pinned?P.version:void 0,F=(await this.c.getExtensions([{...P.identifier,version:T,preRelease:T?void 0:P.preRelease}],L.CancellationToken.None))[0];if(P.state&&(O?O.manifest.version===P.version:F)&&this.h(P.state,O||F,O?.manifest.version,B),F)try{K.getDisabledExtensions().some(G=>(0,l.$Ao)(G,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${H}: Disabling extension...`,P.identifier.id,F.version),await K.disableExtension(F.identifier),this.g.info(`${H}: Disabled extension`,P.identifier.id,F.version)):(this.g.trace(`${H}: Enabling extension...`,P.identifier.id,F.version),await K.enableExtension(F.identifier),this.g.info(`${H}: Enabled extension`,P.identifier.id,F.version))),(!O||O.preRelease!==P.preRelease||O.pinned!==P.pinned||T&&O.manifest.version!==T)&&(await this.a.canInstall(F)?(Q.push({extension:F,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[b.$1n]:!0,[b.$2n]:!0}}}),J.set(F.identifier.id.toLowerCase(),P)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,F.displayName||F.identifier.id),ee.push(P)))}catch(V){ee.push(P),this.g.error(V),this.g.info(`${H}: Skipped synchronizing extension`,F.displayName||F.identifier.id)}else ee.push(P),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),q.length){const K=ne.filter(({identifier:B,isBuiltin:P})=>!P&&q.some(O=>(0,l.$Ao)(B,O)));await I.Promises.settled(K.map(async B=>{this.g.trace(`${H}: Uninstalling local extension...`,B.identifier.id),await this.a.uninstall(B,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,B.identifier.id),W.push(B.identifier)}))}const _=await this.a.installGalleryExtensions(Q);for(const{identifier:K,local:B,error:P,source:O}of _){const T=O;if(B)this.g.info(`${H}: Installed extension.`,K.id,T.version),W.push(K);else{const F=J.get(K.id.toLowerCase());F&&(ee.push(F),this.g.info(`${H}: Skipped synchronizing extension`,T.displayName||T.identifier.id)),P instanceof b.$_n&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,T.displayName||T.identifier.id):P&&this.g.error(P)}}const ie=[];for(const K of X)W.some(B=>(0,l.$Ao)(B,K.identifier))||ie.push(K);for(const K of ee)ie.some(B=>(0,l.$Ao)(B.identifier,K.identifier))||ie.push(K);return ie}h(z,q,Z,X){const x=X.getExtensionState(q,!0)||{},H=Z?X.getKeysForSync({id:q.identifier.id,version:Z}):void 0;H?H.forEach(Q=>{x[Q]=z[Q]}):Object.keys(z).forEach(Q=>x[Q]=z[Q]),X.setExtensionState(q,x,!0)}async j(z,q){return this.b.withProfileScopedStorageService(z,async Z=>{const X=new R.$Rc,x=this.f.createChild(new c.$Nh([m.$7o,Z])),H=X.add(x.createInstance(E.$ACb)),Q=X.add(x.createInstance(d.$Yu));try{return await q(H,Q)}finally{X.dispose()}})}};e.$B3b=j,e.$B3b=j=ye([Y(0,b.$ao),Y(1,o.$bDb),Y(2,b.$$n),Y(3,t.$MEb),Y(4,f.$Oh),Y(5,r.$Vgb)],j);let M=class extends n.$8Db{constructor(z,q,Z,X,x,H,Q,J){super("extensions",X,x,H,Z,Q,J),this.p=z,this.q=q}async t(z){return z.syncData?await v(z.syncData,this.p):null}u(z,q){const Z=[],X=[],x=[];for(const H of z){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const Q=q.find(J=>(0,l.$Ao)(J.identifier,H.identifier));Q?(Z.push(Q),H.disabled&&x.push(H.identifier)):H.installed&&(X.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:Z,newExtensions:X,disabledExtensions:x,remoteExtensions:z}}};e.$C3b=M,e.$C3b=M=ye([Y(0,b.$ao),Y(1,t.$MEb),Y(2,y.$$j),Y(3,a.$Kk),Y(4,C.$Wh),Y(5,h.$0i),Y(6,m.$7o),Y(7,s.$Ik)],M)}),define(oe[116],ae([0,1,15,8,3,35,41,5,32,20,14,11,7,43,21,22,28,39,78,236,25,17,58,4]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m,S,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bEb=e.$aEb=e.$_Db=e.$$Db=e.$0Db=void 0;const n="globalState.argv.",i=["locale"];function t($,j){const M=$.storage?Object.keys($.storage).sort():[],U={};return M.forEach(z=>U[z]=$.storage[z]),$.storage=U,j?(0,D.$ZS)($,{}):JSON.stringify($)}e.$0Db=t;const r=1;let o=class extends f.$5Db{constructor(j,M,U,z,q,Z,X,x,H,Q,J,W,ee,ne){super({syncResource:"globalState",profile:j},M,z,x,W,q,Z,H,Q,X,J,ee),this.Bb=U,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:m.$Xgb,authority:"base"}),this.xb=this.vb.with({scheme:m.$Xgb,authority:"local"}),this.yb=this.vb.with({scheme:m.$Xgb,authority:"remote"}),this.zb=this.vb.with({scheme:m.$Xgb,authority:"accepted"}),this.Ab=ne.createInstance(v),this.B(z.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(z.onDidFilesChange,_=>_.contains(this.H.argvResource)),A.Event.filter(U.onDidChange,_=>!!(_.targetChanges.some(ie=>this.syncResource.profile.id===ie.id)||_.valueChanges.some(({profile:ie,changes:K})=>this.syncResource.profile.id===ie.id&&K.some(B=>B.target===0)))))(()=>this.Q()))}async qb(j,M,U){const z=j.syncData?JSON.parse(j.syncData.content):null;M=M===null&&U?j:M;const q=M&&M.syncData?JSON.parse(M.syncData.content):null,Z=await this.Ab.getLocalGlobalState(this.syncResource.profile);z?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const X=await this.Jb(q),{local:x,remote:H}=(0,h.$9Db)(Z.storage,z?z.storage:null,q?q.storage:null,X,this.O),Q={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:H.all!==null?2:0},J=t(Z,!1);return[{baseResource:this.wb,baseContent:q?t(q,!1):J,localResource:this.xb,localContent:J,localUserData:Z,remoteResource:this.yb,remoteContent:z?t(z,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:X}]}async ub(j){const M=j.syncData?JSON.parse(j.syncData.content):null;if(M===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),z=await this.Jb(M),{remote:q}=(0,h.$9Db)(U.storage,M.storage,M.storage,z,this.O);return q.all!==null}async rb(j,M){return{...j.previewResult,hasConflicts:!1}}async sb(j,M,U,z){if(this.h.isEqual(M,this.xb))return this.Gb(j);if(this.h.isEqual(M,this.yb))return this.Hb(j);if(this.h.isEqual(M,this.vb))return j.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Gb(j){return{content:j.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(j.localUserData.storage),removed:[],updated:[],all:j.localUserData.storage},localChange:0,remoteChange:2}}async Hb(j){if(j.remoteContent!==null){const M=JSON.parse(j.remoteContent),{local:U,remote:z}=(0,h.$9Db)(j.localUserData.storage,M.storage,null,j.storageKeys,this.O);return{content:j.remoteContent,local:U,remote:z,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:z!==null?2:0}}else return{content:j.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(j,M,U,z){const{localUserData:q}=U[0][0],{local:Z,remote:X,localChange:x,remoteChange:H}=U[0][1];if(x===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Z,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:X.all});j=await this.mb(Q,z?null:j.ref),this.O.info(`${this.D}: Updated remote ui state.${X.added.length?` Added: ${X.added}.`:""}${X.updated.length?` Updated: ${X.updated}.`:""}${X.removed.length?` Removed: ${X.removed}.`:""}`)}M?.ref!==j.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(j),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(j){if(this.h.isEqual(this.yb,j)||this.h.isEqual(this.wb,j)||this.h.isEqual(this.xb,j)||this.h.isEqual(this.zb,j)){const M=await this.db(j);return M&&t(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:j}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(j).length>1||j[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(j){const M=await this.Bb.readStorageData(this.syncResource.profile),U=[],z=[];for(const[X,x]of M)x.target===0?U.push(X):x.target===1&&z.push(X);const q=[...U,...z],Z=j?.storage?Object.keys(j.storage).filter(X=>!X.startsWith(n)&&!q.includes(X)&&M.get(X)!==void 0):[];if(!R.$p){const X=[...m.$Cgb.map(x=>(0,m.$Pgb)(x)),m.$Ogb];Z.push(...X),z.push(...X)}return{user:U,machine:z,unregistered:Z}}};e.$$Db=o,e.$$Db=o=ye([Y(2,s.$bDb),Y(3,E.$$j),Y(4,m.$Ggb),Y(5,m.$Hgb),Y(6,m.$Vgb),Y(7,C.$Wh),Y(8,m.$Qgb),Y(9,p.$cl),Y(10,g.$ji),Y(11,d.$7o),Y(12,y.$Ik),Y(13,a.$Oh)],o);let v=class{constructor(j,M,U,z){this.a=j,this.b=M,this.c=U,this.d=z}async getLocalGlobalState(j){const M={};if(j.isDefault){const z=await this.f(),q=(0,N.$Wm)(z);for(const Z of i)q[Z]!==void 0&&(M[`${n}${Z}`]={version:1,value:q[Z]})}const U=await this.c.readStorageData(j);for(const[z,q]of U)q.value&&q.target===0&&(M[z]={version:1,value:q.value});return{storage:M}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const j=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),j.value.toString()}catch(j){this.d.debug((0,L.$0)(j))}return"{}"}async writeLocalGlobalState({added:j,removed:M,updated:U},z){const q=(0,f.$4Db)("globalState",z),Z={},X=new Map,x=await this.c.readStorageData(z),H=(Q,J)=>{for(const W of Q){if(W.startsWith(n)){Z[W.substring(n.length)]=J?J[W].value:void 0;continue}if(J){const ee=J[W];ee.value!==x.get(W)?.value&&X.set(W,ee.value)}else x.get(W)!==void 0&&X.set(W,void 0)}};if(H(Object.keys(j),j),H(Object.keys(U),U),H(M),Object.keys(Z).length){this.d.trace(`${q}: Updating locale...`);const Q=await this.f();let J=Q;for(const W of Object.keys(Z))J=(0,c.edit)(J,[W],Z[W],{});Q!==J&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$be.fromString(J)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}X.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(z,X,0),this.d.info(`${q}: Updated global state`,[...X.keys()]))}};e.$_Db=v,e.$_Db=v=ye([Y(0,E.$$j),Y(1,C.$Wh),Y(2,s.$bDb),Y(3,m.$Vgb)],v);let w=class extends f.$8Db{constructor(j,M,U,z,q,Z){super("globalState",U,z,q,M,j,Z)}async o(j){const M=j.syncData?JSON.parse(j.syncData.content):null;if(!M){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},z={};for(const q of Object.keys(M.storage))q.startsWith(n)?U[q.substring(n.length)]=M.storage[q].value:this.l.get(q,0)===void 0&&(z[q]=M.storage[q].value);if(Object.keys(U).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(U))q=(0,c.edit)(q,[Z],U[Z],{});await this.k.writeFile(this.h.argvResource,I.$be.fromString(q))}if(Object.keys(z).length){const q=[];for(const Z of Object.keys(z))q.push({key:Z,value:z[Z],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$aEb=w,e.$aEb=w=ye([Y(0,d.$7o),Y(1,E.$$j),Y(2,S.$Kk),Y(3,C.$Wh),Y(4,m.$Vgb),Y(5,y.$Ik)],w);let u=class{constructor(j,M,U,z,q){this.a=j,this.b=M,this.c=U,this.d=z,this.f=q}getSyncStoreType(j){return this.h(j)?.storage[m.$Ogb]?.value}async sync(j){const M=(0,m.$Kgb)((0,k.$eg)());try{return await this.g(j,M)}catch(U){if(U instanceof m.$Lgb)switch(U.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(j,M)}throw U}}async g(j,M){const U=await this.a.readResource("globalState",null,void 0,M),z=this.h(U)||{storage:{}};z.storage[m.$Ogb]={value:j,version:r};const q=await(0,l.$ap)(this.c,this.d,this.b),Z={version:r,machineId:q,content:t(z,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),U.ref,void 0,M)}h({content:j}){if(!j)return null;const M=JSON.parse(j);if((0,f.$3Db)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};e.$bEb=u,e.$bEb=u=ye([Y(1,d.$7o),Y(2,C.$Wh),Y(3,E.$$j),Y(4,b.$0i)],u)}),define(oe[117],ae([0,1,18,15,3,35,5,12,171,20,14,11,21,22,28,17,39,233,25]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G3b=e.$F3b=e.$E3b=void 0;function h(s,a,n){try{const i=JSON.parse(s);if(!a)return(0,R.$Ff)(i.all)?null:i.all;switch(D.OS){case 2:return(0,R.$Ff)(i.mac)?null:i.mac;case 3:return(0,R.$Ff)(i.linux)?null:i.linux;case 1:return(0,R.$Ff)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$E3b=h;let m=class extends y.$7Db{constructor(a,n,i,t,r,o,v,w,u,$,j,M,U){super(a.keybindingsResource,{syncResource:"keybindings",profile:a},n,w,u,$,i,t,v,M,r,j,o,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:c.$Xgb,authority:"base"}),this.Gb=this.Eb.with({scheme:c.$Xgb,authority:"local"}),this.Hb=this.Eb.with({scheme:c.$Xgb,authority:"remote"}),this.Ib=this.Eb.with({scheme:c.$Xgb,authority:"accepted"}),this.B(A.Event.filter(o.onDidChangeConfiguration,z=>z.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(a,n,i,t){const r=a.syncData?h(a.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?a:n;const o=n?this.Ob(n):null,v=await this.vb(),w=await this.Cb();let u=null,$=!1,j=!1,M=!1;if(r){let q=v?v.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new c.$Lgb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==q||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Z=await(0,f.$D3b)(q,r,o,w,this.zb);Z.hasChanges&&(u=Z.mergeContent,M=Z.hasConflicts,$=M||Z.mergeContent!==q,j=M||Z.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=v.value.toString(),j=!0);const U={content:M?o:u,localChange:$?v?2:1:0,remoteChange:j?2:0,hasConflicts:M},z=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:z,localChange:U.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(a){const n=this.Ob(a);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),o=await(0,f.$D3b)(t||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(a,n){return a.previewResult}async sb(a,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(a,n,i,t){const{fileContent:r}=i[0][0];let{content:o,localChange:v,remoteChange:w}=i[0][1];if(v===0&&w===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new c.$Lgb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),w!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const u=this.Pb(o||"[]",a.syncData?.content);a=await this.mb(u,t?null:a.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==a.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(a,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.vb();if(a){const n=(0,N.$Wm)(a.value.toString());if((0,I.$Lb)(n))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async resolveContent(a){return this.h.isEqual(this.Hb,a)||this.h.isEqual(this.Fb,a)||this.h.isEqual(this.Gb,a)||this.h.isEqual(this.Ib,a)?this.db(a):null}Ob(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.Qb()?null:h(a.syncData.content,this.Qb(),this.O)}Pb(a,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=a,D.OS){case 2:i.mac=a;break;case 3:i.linux=a;break;case 1:i.windows=a;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(c.$zgb)}};e.$F3b=m,e.$F3b=m=ye([Y(2,c.$Ggb),Y(3,c.$Hgb),Y(4,c.$Vgb),Y(5,g.$ji),Y(6,c.$Qgb),Y(7,E.$$j),Y(8,C.$Wh),Y(9,b.$7o),Y(10,c.$Ugb),Y(11,l.$cl),Y(12,d.$Ik)],m);let S=class extends y.$8Db{constructor(a,n,i,t,r,o){super("keybindings",n,i,t,a,r,o)}async o(a){const n=a.syncData?this.p(a.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,L.$be.fromString(n)),await this.n(a)}async i(){try{const a=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,N.$Wm)(a.value.toString());return!(0,I.$Lb)(n)}catch(a){return a.fileOperationResult===1}}p(a){try{return h(a,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$G3b=S,e.$G3b=S=ye([Y(0,E.$$j),Y(1,p.$Kk),Y(2,C.$Wh),Y(3,c.$Vgb),Y(4,b.$7o),Y(5,d.$Ik)],S)}),define(oe[118],ae([0,1,15,3,172,20,74,14,29,11,21,22,28,17,39,237,25]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J3b=e.$I3b=e.$H3b=void 0;function f(S){return S&&S.settings&&typeof S.settings=="string"&&Object.keys(S).length===1}function c(S){const s=JSON.parse(S);return f(s)?s:{settings:S}}e.$H3b=c;let h=class extends d.$7Db{constructor(s,a,n,i,t,r,o,v,w,u,$,j,M,U){super(s.settingsResource,{syncResource:"settings",profile:s},a,n,i,t,r,o,$,j,v,w,u,U),this.Eb=M,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:y.$Xgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.$Xgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.$Xgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.$Xgb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const a=await this.getLastSyncUserData(),n=await this.X(s,a),i=this.Lb(n),t=new D.$Cn(y.$ygb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(y.$ygb)||{}}async qb(s,a,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);a=a===null&&n?s:a;const o=a?this.Lb(a):null,v=await this.Pb();let w=null,u=!1,$=!1,j=!1;if(r){let q=i?i.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Z=(0,p.$UCb)(q,r.settings,o?o.settings:null,v,[],t);w=Z.localContent||Z.remoteContent,u=Z.localContent!==null,$=Z.remoteContent!==null,j=Z.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),w=i.value.toString().trim()||"{}",this.Qb(w),$=!0);const M=i?i.value.toString():null,U=o?.settings??null,z={content:j?U:w,localChange:u?2:0,remoteChange:$?2:0,hasConflicts:j};return[{fileContent:i,baseResource:this.baseResource,baseContent:U,localResource:this.localResource,localContent:M,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async ub(s){const a=this.Lb(s);if(a===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,p.$UCb)(i||"{}",a.settings,a.settings,t,[],r).remoteContent!==null}async rb(s,a){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,p.$TCb)(s.previewResult.content,"{}",i,n):null}}async sb(s,a,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(a,this.localResource))return{content:s.fileContent?(0,p.$TCb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(a,this.remoteResource))return{content:s.remoteContent!==null?(0,p.$TCb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(a,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,p.$TCb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(s,a,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:o,remoteChange:v}=n[0][1];if(o===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),o!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const w=await this.Cb(),u=this.Lb(s),$=await this.Pb(r);r=(0,p.$TCb)(r,u?u.settings:"{}",$,w),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}a?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,p.$VCb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let a=await super.db(s);if(a){const n=await this.Cb(),i=await this.Pb();a=(0,p.$TCb)(a,"{}",i,n)}return a}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return c(s)}catch(a){this.O.error(a)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(L.Event.any(L.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),L.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const a=await this.Ob;return(0,p.$RCb)(a,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new y.$Lgb((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$I3b=h,e.$I3b=h=ye([Y(2,g.$$j),Y(3,R.$Wh),Y(4,C.$7o),Y(5,y.$Ggb),Y(6,y.$Hgb),Y(7,y.$Vgb),Y(8,y.$Ugb),Y(9,N.$ji),Y(10,y.$Qgb),Y(11,E.$cl),Y(12,k.$ao),Y(13,b.$Ik)],h);let m=class extends d.$8Db{constructor(s,a,n,i,t,r){super("settings",a,n,i,s,t,r)}async o(s){const a=s.syncData?this.p(s.syncData.content):null;if(!a){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$be.fromString(a.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$VCb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return c(s)}catch(a){this.j.error(a)}return null}};e.$J3b=m,e.$J3b=m=ye([Y(0,g.$$j),Y(1,l.$Kk),Y(2,R.$Wh),Y(3,y.$Vgb),Y(4,C.$7o),Y(5,b.$Ik)],m)}),define(oe[119],ae([0,1,15,3,30,20,14,11,21,22,28,17,39,234,25]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O3b=e.$N3b=e.$M3b=void 0;function p(c){return JSON.parse(c.content)}e.$M3b=p;let y=class extends b.$5Db{constructor(h,m,S,s,a,n,i,t,r,o,v,w){super({syncResource:"snippets",profile:h},m,s,S,a,n,i,o,v,t,r,w),this.pb=1,this.vb=h.snippetsHome,this.B(this.G.watch(S.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(L.Event.filter(this.G.onDidFilesChange,u=>u.affects(this.vb))(()=>this.Q()))}async qb(h,m,S){const s=await this.Hb(),a=this.Gb(s),n=h.syncData?this.Fb(h.syncData):null;m=m===null&&S?h:m;const i=m&&m.syncData?this.Fb(m.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,l.$K3b)(a,n,i);return this.Bb(t,s,n||{},i||{})}async ub(h){const m=h.syncData?this.Fb(h.syncData):null;if(m===null)return!0;const S=await this.Hb(),s=this.Gb(S),a=(0,l.$K3b)(s,m,m);return Object.keys(a.remote.added).length>0||Object.keys(a.remote.updated).length>0||a.remote.removed.length>0||a.conflicts.length>0}async rb(h,m){return h.previewResult}async sb(h,m,S,s){if(this.h.isEqualOrParent(m,this.g.with({scheme:d.$Xgb,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(m,this.g.with({scheme:d.$Xgb,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(m,this.g))return S===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:S,localChange:S===null?h.fileContent!==null?3:0:2,remoteChange:S===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async tb(h,m,S,s){const a=S.map(([n,i])=>({...n,acceptResult:i}));a.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),a.some(({localChange:n})=>n!==0)&&(await this.Cb(a),await this.Db(a,s)),a.some(({remoteChange:n})=>n!==0)&&(h=await this.Eb(a,h,s)),m?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of a)try{await this.G.del(n)}catch{}}Bb(h,m,S,s){const a=new Map;for(const n of Object.keys(h.local.added)){const i={content:h.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"accepted"})})}for(const n of Object.keys(h.local.updated)){const i={content:h.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"accepted"})})}for(const n of h.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"accepted"})})}for(const n of Object.keys(h.remote.added)){const i={content:h.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"accepted"})})}for(const n of Object.keys(h.remote.updated)){const i={content:h.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"accepted"})})}for(const n of h.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"accepted"})})}for(const n of h.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:m[n]?2:1,remoteChange:S[n]?2:1},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"remote"}),remoteContent:S[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"accepted"})})}for(const n of Object.keys(m))if(!a.has(n)){const i={content:m[n]?m[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"remote"}),remoteContent:S[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Xgb,authority:"accepted"})})}return[...a.values()]}async resolveContent(h){return this.h.isEqualOrParent(h,this.g.with({scheme:d.$Xgb,authority:"remote"}))||this.h.isEqualOrParent(h,this.g.with({scheme:d.$Xgb,authority:"local"}))||this.h.isEqualOrParent(h,this.g.with({scheme:d.$Xgb,authority:"base"}))||this.h.isEqualOrParent(h,this.g.with({scheme:d.$Xgb,authority:"accepted"}))?this.db(h):null}async hasLocalData(){try{const h=await this.Hb();if(Object.keys(h).length)return!0}catch{}return!1}async Cb(h){const m={};for(const S of h)S.fileContent&&(m[this.h.basename(S.localResource)]=S.fileContent);await this.nb(JSON.stringify(this.Gb(m)))}async Db(h,m){for(const{fileContent:S,acceptResult:s,localResource:a,remoteResource:n,localChange:i}of h)if(i!==0){const t=n?this.h.basename(n):this.h.basename(a),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$be.fromString(s.content),{overwrite:m}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$be.fromString(s.content),m?void 0:S),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(h,m,S){const s=m.syncData?this.Fb(m.syncData):{},a=(0,A.$7m)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of h)if(r!==0){const o=i?this.h.basename(i):this.h.basename(t);r===3?delete a[o]:a[o]=n.content}return(0,l.$L3b)(s,a)||(this.O.trace(`${this.D}: Updating remote snippets...`),m=await this.mb(JSON.stringify(a),S?null:m.ref),this.O.info(`${this.D}: Updated remote snippets`)),m}Fb(h){return p(h)}Gb(h){const m={};for(const S of Object.keys(h))m[S]=h[S].value.toString();return m}async Hb(){const h={};let m;try{m=await this.G.resolve(this.vb)}catch(S){if(S instanceof R.$tk&&S.fileOperationResult===1)return h;throw S}for(const S of m.children||[]){const s=S.resource,a=this.h.extname(s);if(a===".json"||a===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);h[n]=i}}return h}};e.$N3b=y,e.$N3b=y=ye([Y(2,D.$Wh),Y(3,R.$$j),Y(4,k.$7o),Y(5,d.$Ggb),Y(6,d.$Hgb),Y(7,d.$Vgb),Y(8,N.$ji),Y(9,d.$Qgb),Y(10,g.$cl),Y(11,C.$Ik)],y);let f=class extends b.$8Db{constructor(h,m,S,s,a,n){super("snippets",m,S,s,h,a,n)}async o(h){const m=h.syncData?JSON.parse(h.syncData.content):null;if(!m){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(m)){const a=m[s];if(a){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,I.$be.fromString(a)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(h)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.$O3b=f,e.$O3b=f=ye([Y(0,R.$$j),Y(1,E.$Kk),Y(2,D.$Wh),Y(3,d.$Vgb),Y(4,k.$7o),Y(5,C.$Ik)],f)}),define(oe[120],ae([0,1,15,20,14,11,21,22,28,17,39,25]),function(te,e,I,L,A,N,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R3b=e.$Q3b=e.$P3b=void 0;function b(y,f){try{return JSON.parse(y).tasks??null}catch(c){return f.error(c),null}}e.$P3b=b;let l=class extends C.$6Db{constructor(f,c,h,m,S,s,a,n,i,t,r,o){super(f.tasksResource,{syncResource:"tasks",profile:f},c,n,i,t,h,m,a,r,S,s,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$Xgb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$Xgb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$Xgb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$Xgb,authority:"accepted"})}async qb(f,c,h,m){const S=f.syncData?b(f.syncData.content,this.O):null;c=c===null&&h?f:c;const s=c?.syncData?b(c.syncData.content,this.O):null,a=await this.vb();let n=null,i=!1,t=!1,r=!1;if(f.syncData){const w=a?a.value.toString():null;if(!s||s!==w||s!==S){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const u=p(w,S,s);n=u.content,r=u.hasConflicts,i=u.hasLocalChanged,t=u.hasRemoteChanged}}else a&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=a.value.toString(),t=!0);const o={content:r?s:n,localChange:i?a?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=a?a.value.toString():null;return[{fileContent:a,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:o.localChange,remoteResource:this.Db,remoteContent:S,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(f){const c=f?.syncData?b(f.syncData.content,this.O):null;if(c===null)return!0;const h=await this.vb(),m=h?h.value.toString():null,S=p(m,c,c);return S.hasLocalChanged||S.hasRemoteChanged}async rb(f,c){return f.previewResult}async sb(f,c,h,m){if(this.h.isEqual(c,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(c,this.Db))return{content:f.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(c,this.Ab))return h===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(f,c,h,m){const{fileContent:S}=h[0][0],{content:s,localChange:a,remoteChange:n}=h[0][1];if(a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),a!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),S&&await this.nb(JSON.stringify(this.Kb(S.value.toString()))),s?await this.wb(s,S,m):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));f=await this.mb(i,m?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}c?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$Q3b=l,e.$Q3b=l=ye([Y(2,E.$Ggb),Y(3,E.$Hgb),Y(4,E.$Vgb),Y(5,L.$ji),Y(6,E.$Qgb),Y(7,N.$$j),Y(8,A.$Wh),Y(9,D.$7o),Y(10,R.$cl),Y(11,k.$Ik)],l);let d=class extends C.$8Db{constructor(f,c,h,m,S,s){super("tasks",c,h,m,f,S,s),this.c=this.g.defaultProfile.tasksResource}async o(f){const c=f.syncData?b(f.syncData.content,this.j):null;if(!c){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$be.fromString(c)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$R3b=d,e.$R3b=d=ye([Y(0,N.$$j),Y(1,g.$Kk),Y(2,A.$Wh),Y(3,E.$Vgb),Y(4,D.$7o),Y(5,k.$Ik)],d);function p(y,f,c){if(y===null&&f===null&&c===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=c!==y,m=c!==f;return!h&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!m?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!h?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[121],ae([0,1,41,20,14,11,21,22,28,17,39,235,25]),function(te,e,I,L,A,N,D,R,k,g,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v5b=e.$u5b=e.$t5b=void 0;let l=class extends C.$5Db{constructor(f,c,h,m,S,s,a,n,i,t,r,o,v){super({syncResource:"profiles",profile:f},c,m,S,s,a,n,r,o,i,t,v),this.vb=h,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:b.$Xgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$Xgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$Xgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$Xgb,authority:"accepted"}),this.B(h.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?p(f.syncData):null}async getRemoteSyncedProfiles(f){const c=await this.getLastSyncUserData(),h=await this.X(f,c);return h?.syncData?p(h.syncData):null}async qb(f,c,h){if(!this.vb.isEnabled())throw new b.$Lgb("Cannot sync profiles because they are disabled","LocalError");const m=f.syncData?p(f.syncData):null,S=c?.syncData?p(c.syncData):null,s=this.Db(),{local:a,remote:n}=(0,E.$s5b)(s,m,S,[]),i={local:a,remote:n,content:S?this.Eb(S):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:n!==null?2:0},t=d(s,!1);return[{baseResource:this.baseResource,baseContent:S?this.Eb(S):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:m?this.Eb(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const c=f?.syncData?p(f.syncData):null,h=this.Db(),{remote:m}=(0,E.$s5b)(h,c,c,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async rb(f,c){return{...f.previewResult,hasConflicts:!1}}async sb(f,c,h,m){if(this.h.isEqual(c,this.localResource))return this.Ab(f);if(this.h.isEqual(c,this.remoteResource))return this.Bb(f);if(this.h.isEqual(c,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${c.toString()}`)}async Ab(f){const c=this.Db(),h=(0,E.$s5b)(c,null,null,[]),{local:m,remote:S}=h;return{content:f.localContent,local:m,remote:S,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?2:0,remoteChange:S!==null?2:0}}async Bb(f){const c=f.remoteContent?JSON.parse(f.remoteContent):null,h=[],m=[];for(const S of this.Db()){const s=c?.find(a=>a.id===S.id);s&&(h.push({id:S.id,name:S.name,collection:s.collection}),m.push(S))}if(c!==null){const S=(0,E.$s5b)(m,c,h,[]),{local:s,remote:a}=S;return{content:f.remoteContent,local:s,remote:a,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(f,c,h,m){const{local:S,remote:s,localChange:a,remoteChange:n}=h[0][1];a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=h[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new b.$Lgb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.nb(d(this.Db(),!1));const t=[];for(const r of S.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of S.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of S.updated){const o=this.vb.profiles.find(v=>v.id===r.id);o?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(o,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const o of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:o.id,name:o.name,collection:v,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of s?.removed||[])i.splice(i.findIndex(({id:v})=>o.id===v),1);for(const o of s?.updated||[]){const v=i.find(({id:w})=>o.id===w);v&&i.splice(i.indexOf(v),1,{...v,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{f=await this.updateRemoteProfiles(i,m?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(o=>o.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(o=>o.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(o=>o.name))}.`:""}`)}catch(o){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw o}for(const o of s?.removed||[])await this.J.deleteCollection(o.collection,this.F)}c?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,c){return this.mb(this.Eb(f),c)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const c=await this.db(f);return c&&(0,I.$ZS)(JSON.parse(c),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((c,h)=>c.name.localeCompare(h.name)))}};e.$t5b=l,e.$t5b=l=ye([Y(2,g.$Kk),Y(3,N.$$j),Y(4,A.$Wh),Y(5,D.$7o),Y(6,b.$Ggb),Y(7,b.$Hgb),Y(8,b.$Vgb),Y(9,L.$ji),Y(10,b.$Qgb),Y(11,R.$cl),Y(12,k.$Ik)],l);function d(y,f){const c=[...y].sort((h,m)=>h.name.localeCompare(m.name)).map(h=>({id:h.id,name:h.name}));return f?(0,I.$ZS)(c,{}):JSON.stringify(c)}e.$u5b=d;function p(y){return JSON.parse(y.content)}e.$v5b=p}),define(oe[253],ae([0,1,3,2,5,14,21,22,25]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=void 0;const g="sync.enable";let C=class extends L.$Sc{constructor(b,l,d,p){super(),this.c=b,this.f=l,this.g=d,this.h=p,this.a=new I.$Nd,this.onDidChangeEnablement=this.a.event,this.b=new I.$Nd,this.onDidChangeResourceEnablement=this.b.event,this.B(b.onDidChangeValue(-1,void 0,this.B(new L.$Rc))(y=>this.m(y)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(b){b&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:b}),this.c.store(g,b,-1,1))}isResourceEnabled(b){return this.c.getBoolean((0,k.$Pgb)(b),-1,!0)}setResourceEnablement(b,l){if(this.isResourceEnabled(b)!==l){const d=(0,k.$Pgb)(b);this.j(d,l)}}getResourceSyncStateVersion(b){}j(b,l){this.c.store(b,l,-1,A.$p?0:1)}m(b){if(g===b.key){this.a.fire(this.isEnabled());return}const l=k.$Cgb.filter(d=>(0,k.$Pgb)(d)===b.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$g5b=C,e.$g5b=C=ye([Y(0,D.$7o),Y(1,R.$cl),Y(2,N.$Wh),Y(3,k.$Fgb)],C)}),define(oe[254],ae([0,1,6,15,63,2,19,20,14,11,17,25]),function(te,e,I,L,A,N,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r5b=void 0;let b=class extends N.$Sc{constructor(d,p,y,f,c){super(),this.a=d,this.b=p,this.c=y,this.f=f,this.g=c,this.h()}async h(){for(const p of this.g.profiles)for(const y of E.$Cgb)try{await this.m(this.j(y,p.isDefault?void 0:p.id))}catch(f){this.f.error(f)}let d;try{d=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,g.$pk)(p)!==1&&this.f.error(p);return}if(d.children){for(const p of d.children)if(p.isDirectory&&!this.g.profiles.some(y=>y.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(y){this.f.error(y)}}}async getAllResourceRefs(d,p,y){const f=this.j(d,p,y);try{const c=await this.b.resolve(f);if(c.children)return c.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.n(m)}))}catch(c){if((0,g.$pk)(c)!==1)throw c}return[]}async resolveResourceContent(d,p,y,f){const c=this.j(d,y,f),h=(0,D.$vg)(c,p);try{return(await this.b.readFile(h)).value.toString()}catch(m){return this.f.error(m),null}}async writeResource(d,p,y,f,c){const h=this.j(d,f,c),m=(0,D.$vg)(h,`${(0,A.$em)(y).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,L.$be.fromString(p))}catch(S){this.f.error(S)}}j(d,p,y=this.a.userDataSyncHome){return(0,D.$vg)(y,...p?[p,d]:[d])}async m(d){try{try{if(!await this.b.exists(d))return}catch{return}const p=await this.b.resolve(d);if(p.children){const y=p.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let c=y.filter(m=>Date.now()-this.n(m)>f);const h=y.length-c.length;h<10&&(c=c.slice(10-h)),await I.Promises.settled(c.map(async m=>{this.f.info("Deleting from backup",m.resource.path),await this.b.del(m.resource)}))}}catch(p){this.f.error(p)}}n(d){return new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};e.$r5b=b,e.$r5b=b=ye([Y(0,k.$Wh),Y(1,g.$$j),Y(2,R.$ji),Y(3,E.$Vgb),Y(4,C.$Kk)],b)}),define(oe[82],ae([0,1,3,2,5,27,176,14,11,4,24,43,21,25]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$vgb=e.$ugb=e.$tgb=void 0,e.$tgb=(0,g.$Ph)("IUserDataSyncMachinesService");const p="sync.currentMachineName",y="Safari",f="Chrome",c="Edge",h="Firefox",m="Android";function S(n){switch(n){case y:case f:case c:case h:case m:case(0,A.$i)(0):return!0}return!1}e.$ugb=S;function s(){return A.$G?y:A.$E?f:A.$H?c:A.$F?h:A.$I?m:(0,A.$i)(A.$p?0:A.$u)}let a=class extends L.$Sc{static{d=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,o,v,w){super(),this.h=r,this.j=o,this.m=v,this.n=w,this.c=this.B(new I.$Nd),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$ap)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(o=>({...o,isCurrent:o.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:o})=>o===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),o=r.machines.filter(({id:v})=>v!==t);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(i,t,r){const o=await this.s(r),v=o.machines.find(({id:w})=>w===i);if(v){v.name=t,await this.t(o);const w=await this.f;i===w&&this.h.store(p,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,o]of i){const v=t.machines.find(w=>w.id===r);v&&(v.disabled=o?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(p,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,o=new RegExp(`${(0,N.$Fe)(r)}\\s#(\\d+)`);let v=0;for(const w of i){const u=o.exec(w.name),$=u?parseInt(u[1]):0;v=$>v?$:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==d.a)throw new Error((0,D.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource(d.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[d.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(d.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:d.a,machines:[]}}};e.$vgb=a,e.$vgb=a=d=ye([Y(0,R.$Wh),Y(1,k.$$j),Y(2,b.$7o),Y(3,l.$Ggb),Y(4,l.$Vgb),Y(5,C.$pj)],a)}),define(oe[255],ae([0,1,6,63,38,8,3,2,5,19,10,173,24,21,22,25,79,82]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=void 0;const c="sync.disableMachineEventually",h="sync.sessionId",m="sync.storeUrl",S="sync.productQuality";let s=class extends R.$Sc{get n(){const i=this.H.get(m,-1);return i?C.URI.parse(i):void 0}set n(i){i?this.H.store(m,i.toString(),-1,1):this.H.remove(m,-1)}get s(){return this.H.get(S,-1)}set s(i){i?this.H.store(S,i,-1,1):this.H.remove(S,-1)}constructor(i,t,r,o,v,w,u,$,j,M){super(),this.u=t,this.w=r,this.y=o,this.z=v,this.C=w,this.D=u,this.F=$,this.G=j,this.H=M,this.a=this.B(new R.$Tc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new D.$Nd),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$Rg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$og)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(u.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(D.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new a(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.$em)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(h,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),t)this.M(!1);else throw o}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=p.$Lgb.toUserDataSyncError(i);t instanceof p.$Ngb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$p&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(c,!0,-1,1),await(0,I.$Ug)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(c,-1,!1)}R(){this.H.remove(c,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$x5b=s,e.$x5b=s=ye([Y(0,b.$pj),Y(1,p.$Fgb),Y(2,p.$Ggb),Y(3,p.$Qgb),Y(4,p.$Rgb),Y(5,p.$Vgb),Y(6,y.$CCb),Y(7,d.$cl),Y(8,f.$tgb),Y(9,l.$7o)],s);class a extends R.$Sc{static{this.a="Interval"}constructor(i,t,r,o,v,w,u,$,j){super(),this.m=i,this.n=t,this.r=r,this.s=o,this.u=v,this.w=w,this.y=u,this.z=$,this.C=j,this.b=this.B(new R.$Tc),this.c=this.B(new D.$Nd),this.onDidStartSync=this.c.event,this.f=this.B(new D.$Nd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Qc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}D(){this.b.value=(0,I.$Vg)(()=>{this.sync(a.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,I.$Hg)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,N.$4)(v))return}return this.H(i,t,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$og)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,g.$og)(t.defaultUrl,i.defaultUrl)||!(0,g.$og)(t.insidersUrl,i.insidersUrl)||!(0,g.$og)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let o;try{await this.I(t,r)}catch(v){if(this.y.error(v),o=v,p.$Lgb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),o=void 0}catch(w){this.y.error(w),o=w}}this.f.fire(o)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$Ngb((0,E.localize)(0,null),"DefaultServiceChanged"):new p.$Ngb((0,E.localize)(1,null),"ServiceChanged"):new p.$Ngb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get(h,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$Ngb((0,E.localize)(3,null),"DefaultServiceChanged"):new p.$Ngb((0,E.localize)(4,null),"ServiceChanged"):new p.$Ngb((0,E.localize)(5,null),"SessionExpired");const o=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=o.find(u=>u.isCurrent);if(v?.disabled)throw new p.$Ngb((0,E.localize)(6,null),"TurnedOff");const w=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.g===null)try{this.g=await this.s.manifest(null)}catch(u){throw new p.$Ngb((0,A.$Ai)(u),u instanceof p.$Lgb?u.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(h,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(oe[256],ae([0,1,10,177,14,11,43,21,28,25,17,39,119,118,117,20,120,115,116,4,121,41,27]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m,S,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=void 0;let n=class{static{a=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,o,v,w,u,$,j,M,U){this.e=t,this.f=r,this.g=o,this.h=w,this.i=u,this.j=$,this.k=j,this.l=M,this.n=U,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,m.$v5b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(o){const v=this.L(o,"profiles");return(0,m.$v5b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(o)return JSON.parse(o).machines.map(w=>({...w,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:w})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(t,r,o){return(await this.f.getAllResourceRefs(t,r?.collection,o)).map(({created:w,ref:u})=>({created:w,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:u,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),o=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const o=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,o);case"keybindings":return this.u(t,o);case"tasks":return this.w(t,o);case"snippets":return this.y(t,o);case"globalState":return this.D(t,o);case"extensions":return this.A(t,o);case"profiles":return this.G(t,o);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,D.$ap)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===a.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,o,v,w){if(t){const{content:u}=await this.M(r,v,o);return u}return this.f.resolveResourceContent(r,v,o,w)}q(t,r,o){const v=this.L(r,t);switch(t){case"settings":return this.t(v,o);case"keybindings":return this.v(v,o);case"tasks":return this.x(v,o);case"snippets":return this.z(v,o);case"globalState":return this.E(v,o);case"extensions":return this.B(v,o);case"profiles":return this.H(v,o);case"workspaceState":return null}}async r(t,r){const o=this.k.profiles.find(v=>v.id===r);if(!o)return null;switch(t){case"globalState":return this.F(o);case"extensions":return this.C(o);case"profiles":return this.I(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const o=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,l.$H3b)(t.content).settings}return null}u(t,r){const o=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,d.$E3b)(t.content,!!this.l.getValue(g.$zgb),this.g)}return null}w(t,r){const o=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,y.$P3b)(t.content,this.g)}return null}async y(t,r){const o=await this.resolveContent(t);if(o){const v=this.L(o,"snippets");if(v){const w=(0,b.$M3b)(v),u=[];for(const $ of Object.keys(w)){const j=this.d.joinPath(t,$),M=r?this.d.joinPath(r.snippetsHome,$):this.d.joinPath(t,a.a);u.push({resource:j,comparableResource:M})}return u}}return[]}z(t,r){return(0,b.$M3b)(t)[r]||null}A(t,r){const o=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,f.$z3b)((0,f.$y3b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(f.$B3b).getLocalExtensions(t);return(0,f.$z3b)(r,!0)}D(t,r){const o=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,c.$0Db)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(c.$_Db).getLocalGlobalState(t);return(0,c.$0Db)(r,!0)}G(t,r){const o=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,S.$ZS)(JSON.parse(t.content),{})}return null}async I(t){return(0,m.$u5b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?a.b:a.c,o=[];return t.location&&(o.push(`scheme:${t.location.scheme}`),o.push(`authority:${t.location.authority}`),o.push((0,s.$Ie)(t.location.path,"/"))),o.push(`syncResource:${t.syncResource}`),o.push(`profile:${t.profile}`),t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(I.URI.from({scheme:g.$Xgb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...o)}K(t){if(t.scheme!==g.$Xgb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const o=t.authority===a.b;let v,w;const u=[];let $,j,M,U,z;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?v=q.substring(7):q.startsWith("authority:")?w=q.substring(10):q.startsWith("syncResource:")?$=q.substring(13):q.startsWith("profile:")?j=q.substring(8):q.startsWith("collection:")?M=q.substring(11):q.startsWith("ref:")?U=q.substring(4):$?z=q:u.push(q)}return{remote:o,syncResource:$,profile:j,collection:M,ref:U,node:z,location:v&&w!==void 0?this.d.joinPath(I.URI.from({scheme:v,authority:w,query:t.query,fragment:t.fragment,path:"/"}),...u):void 0}}L(t,r){try{const o=JSON.parse(t);if((0,E.$3Db)(o))return o}catch(o){this.g.error(o)}throw new g.$Lgb((0,L.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,o){const v=await this.e.resolveResourceContent(t,r,o);return{ref:r,content:v}}};e.$95b=n,e.$95b=n=a=ye([Y(0,g.$Ggb),Y(1,g.$Hgb),Y(2,g.$Vgb),Y(3,k.$Ik),Y(4,A.$Wh),Y(5,R.$7o),Y(6,N.$$j),Y(7,C.$Kk),Y(8,p.$ji),Y(9,h.$Oh)],n)}),define(oe[257],ae([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,115,116,117,118,119,120,121,25]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m,S,s,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w5b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Sc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor($,j,M,U,z,q,Z,X,x,H,Q){super(),this.C=$,this.D=j,this.F=M,this.G=U,this.H=z,this.I=q,this.J=Z,this.L=X,this.M=x,this.N=H,this.O=Q,this.f="uninitialized",this.g=this.B(new D.$Nd),this.onDidChangeStatus=this.g.event,this.h=this.B(new D.$Nd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new D.$Nd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new D.$Nd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new D.$Nd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new D.$Nd),this.onDidResetLocal=this.w.event,this.y=this.B(new D.$Nd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=M.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Qc)(()=>this.bb()))}async createSyncTask($,j){this.cb(),this.H.info("Sync started.");const M=new Date().getTime(),U=(0,C.$eg)();try{const X=(0,i.$Kgb)(U);j&&(X["Cache-Control"]="no-cache"),$=await this.D.manifest($,X)}catch(X){const x=i.$Lgb.toUserDataSyncError(X);throw w(x,U,this.F,this.I),x}const z=!1,q=this;let Z;return{manifest:$,async run(){if(z)throw new Error("Can run a task only once");Z=(0,L.$Hg)(X=>q.P($,!1,U,X)),await Z.finally(()=>Z=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-M}ms`),q.$()},stop(){return Z?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$Lgb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const $=new Date().getTime(),j=(0,C.$eg)(),M=(0,i.$Kgb)(j);let U;try{U=await this.D.manifest(null,M)}catch(Z){const X=i.$Lgb.toUserDataSyncError(Z);throw w(X,j,this.F,this.I),X}await this.resetLocal();const z=this,q=new A.$Xd;return{id:j,async merge(){return z.P(U,!0,j,q.token)},async apply(){try{try{await z.R(U,j,q.token)}catch(Z){if(i.$Lgb.toUserDataSyncError(Z).code==="MethodNotFound")z.H.info("Client is making invalid requests. Cleaning up data..."),await z.cleanUpRemoteData(),z.H.info("Applying manual sync again..."),await z.R(U,j,q.token);else throw Z}}catch(Z){throw z.H.error(Z),Z}z.H.info(`Sync done. Took ${new Date().getTime()-$}ms`),z.$()},async stop(){q.cancel(),await z.U(),await z.resetLocal()}}}async P($,j,M,U){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const z=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(z,$,j,M,U));const q=z.enabled.find(Z=>Z.resource==="profiles");if(q){const Z=await q.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(Z,$,j,M,U)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q($,j,M,U,z){for(const q of $){if(z.isCancellationRequested)return;const Z=this.M.profiles.find(x=>x.id===q.id);if(!Z){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const X=this.getOrCreateActiveProfileSynchronizer(Z,q);this.n.push(...await this.S(X,j,M,U,z))}for(const[q,Z]of this.z.entries())this.M.profiles.some(X=>X.id===Z[0].profile.id)||(Z[1].dispose(),this.z.delete(q))}async R($,j,M){const U=this.ab();for(const x of U){if(M.isCancellationRequested)return;await x.apply(j,M)}const z=U.find(x=>x.profile.isDefault);if(!z)return;const q=z.enabled.find(x=>x.resource==="profiles");if(!q)return;const X=(await q.getRemoteSyncedProfiles($?.latest??null)||[]).filter(x=>U.every(H=>H.profile.id!==x.id));X.length&&await this.Q(X,$,!1,j,M)}async S($,j,M,U,z){return(await $.sync(j,M,U,z)).map(([Z,X])=>({profile:$.profile,syncResource:Z,error:X}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map($=>$.stop()))}async resolveContent($){const j=await this.N.resolveContent($);if(j)return j;for(const M of this.ab())for(const U of M.enabled){const z=await U.resolveContent($);if(z)return z}return null}async replace($){this.cb();const j=this.N.resolveUserDataSyncResource($);if(!j)return;const M=await this.resolveContent($.uri);M&&await this.W(j.profile,async U=>{if(j.syncResource===U.resource)return await U.replace(M),!0})}async accept($,j,M,U){this.cb(),await this.W($.profile,async z=>{if($.syncResource===z.resource)return await z.accept(j,M),U&&await z.apply((0,g.$Ef)(U)?!1:U.force,(0,i.$Kgb)((0,C.$eg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async j=>{if(j.resource!=="globalState"&&await j.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async j=>{if(await j.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch($){this.H.error($)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[$]of this.z.values())try{await $.resetLocal()}catch(j){this.H.error(j)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const $=await this.N.getRemoteSyncedProfiles(),j=$.map(q=>q.collection),M=await this.D.getAllCollections(),U=M.filter(q=>!j.includes(q));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const z=$.filter(q=>M.includes(q.collection));if(z.length!==$.length){const q=this.G.createInstance(n.$t5b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(z,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData($){this.cb();const j=await this.D.getActivityData();await this.C.writeFile($,j)}async extractActivityData($,j){const M=(await this.C.readFile($)).value.toString(),U=JSON.parse(M);if(U.resources)for(const z in U.resources)for(const q of U.resources[z])await this.O.writeResource(z,q.content,new Date(q.created*1e3),void 0,j);if(U.collections)for(const z in U.collections)for(const q in U.collections[z].resources)for(const Z of U.collections[z].resources?.[q]??[])await this.O.writeResource(q,Z.content,new Date(Z.created*1e3),z,j)}async W($,j){const M=new R.$Rc;try{const U=this.z.get($.id);if(U){const x=await this.X(U[0],j,M);return(0,g.$Ff)(x)?null:x}if($.isDefault){const x=M.add(this.G.createInstance(o,$,void 0)),H=await this.X(x,j,M);return(0,g.$Ff)(H)?null:H}if(this.M.isEnabled())return null;const z=M.add(this.G.createInstance(n.$t5b,$,void 0)),q=await this.D.manifest(null),X=(await z.getRemoteSyncedProfiles(q?.latest??null)||[]).find(x=>x.id===$.id);if(X){const x=M.add(this.G.createInstance(o,$,X.collection)),H=await this.X(x,j,M);return(0,g.$Ff)(H)?null:H}return null}finally{M.dispose()}}async X($,j,M){const U=[...$.enabled,...$.disabled.reduce((z,q)=>(q!=="workspaceState"&&z.push(M.add($.createSynchronizer(q))),z),[])];for(const z of U){const q=await j(z);if(!(0,g.$Ff)(q))return q}}Y($){const j=this.f;this.f!==$&&(this.f=$,this.g.fire($),j==="hasConflicts"&&this.$())}Z(){const $=this.ab().map(j=>j.conflicts).flat();(0,I.$ub)(this.j,$,(j,M)=>j.profile.id===M.profile.id&&j.syncResource===M.syncResource&&(0,I.$ub)(j.conflicts,M.conflicts,(U,z)=>(0,k.$og)(U.previewResource,z.previewResource)))||(this.j=$,this.m.fire($))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer($,j){let M=this.z.get($.id);if(M&&M[0].collection!==j?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),M[1].dispose(),M=void 0,this.z.delete($.id)),!M){const U=new R.$Rc,z=U.add(this.G.createInstance(o,$,j?.collection));U.add(z.onDidChangeStatus(q=>this.Y(q))),U.add(z.onDidChangeConflicts(q=>this.Z())),U.add(z.onDidChangeLocal(q=>this.h.fire(q))),this.z.set($.id,M=[z,U])}return M[0]}ab(){const $=[];for(const[j]of this.z.values())$.push(j);return $}bb(){this.z.forEach(([,$])=>$.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$w5b=r,e.$w5b=r=ye([Y(0,l.$$j),Y(1,i.$Ggb),Y(2,i.$Fgb),Y(3,d.$Oh),Y(4,i.$Vgb),Y(5,y.$cl),Y(6,p.$7o),Y(7,i.$Qgb),Y(8,f.$Kk),Y(9,i.$Sgb),Y(10,i.$Hgb)],r);let o=class extends R.$Sc{get enabled(){return this.f.sort(($,j)=>$[1]-j[1]).map(([$])=>$)}get disabled(){return i.$Cgb.filter($=>!this.r.isResourceEnabled($))}get status(){return this.g}get conflicts(){return this.m}constructor($,j,M,U,z,q,Z,X,x,H){super(),this.profile=$,this.collection=j,this.r=M,this.t=U,this.u=z,this.w=q,this.y=Z,this.z=X,this.C=x,this.D=H,this.f=[],this.g="idle",this.h=this.B(new D.$Nd),this.onDidChangeStatus=this.h.event,this.j=this.B(new D.$Nd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new D.$Nd),this.onDidChangeConflicts=this.n.event,this.B(M.onDidChangeResourceEnablement(([Q,J])=>this.F(Q,J))),this.B((0,R.$Qc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of i.$Cgb)M.isResourceEnabled(Q)&&this.G(Q)}F($,j){j?this.G($):this.H($)}G($){if(this.f.some(([z])=>z.resource===$))return;if($==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if($==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||$==="workspaceState")return;if($!=="profiles"&&this.profile.useDefaultFlags?.[$]){this.z.debug(`Skipping syncing ${$} in ${this.profile.name} because it is already synced by default profile`);return}const j=new R.$Rc,M=j.add(this.createSynchronizer($));j.add(M.onDidChangeStatus(()=>this.L())),j.add(M.onDidChangeConflicts(()=>this.M())),j.add(M.onDidChangeLocal(()=>this.j.fire($)));const U=this.N($);this.f.push([M,U,j])}H($){const j=this.f.findIndex(([M])=>M.resource===$);if(j!==-1){const[[M,,U]]=this.f.splice(j,1);U.dispose(),this.L(),Promise.allSettled([M.stop(),M.resetLocal()]).then(null,z=>this.z.error(z))}}createSynchronizer($){switch($){case"settings":return this.t.createInstance(S.$I3b,this.profile,this.collection);case"keybindings":return this.t.createInstance(m.$F3b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$N3b,this.profile,this.collection);case"tasks":return this.t.createInstance(a.$Q3b,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$$Db,this.profile,this.collection);case"extensions":return this.t.createInstance(c.$A3b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$t5b,this.profile,this.collection)}}async sync($,j,M,U){if(U.isCancellationRequested)return[];const z=this.enabled;if(!z.length)return[];try{const q=[],Z=(0,i.$Kgb)(M),X=(this.collection?$?.collections?.[this.collection]?.latest:$?.latest)??null,x=j?await this.I(X):{};for(const H of z){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(j){const Q=await H.preview(X,x,Z);if(Q)for(const J of Q.resourcePreviews)(J.localChange!==0||J.remoteChange!==0)&&J.mergeState==="preview"&&await H.merge(J.previewResource)}else await H.sync(X,Z)}catch(Q){const J=i.$Lgb.toUserDataSyncError(Q);if(w(J,M,this.w,this.y),v(Q))throw J;this.z.error(Q),this.z.error(`${H.resource}: ${(0,N.$Ai)(Q)}`),q.push([H.resource,J])}}return q}finally{this.L()}}async apply($,j){const M=(0,i.$Kgb)($);for(const U of this.enabled){if(j.isCancellationRequested)return;try{await U.apply(!1,M)}catch(z){const q=i.$Lgb.toUserDataSyncError(z);if(w(q,$,this.w,this.y),v(z))throw q;this.z.error(z),this.z.error(`${U.resource}: ${(0,N.$Ai)(z)}`)}}}async stop(){for(const $ of this.enabled)try{$.status!=="idle"&&await $.stop()}catch(j){this.z.error(j)}}async resetLocal(){for(const $ of this.enabled)try{await $.resetLocal()}catch(j){this.z.error(`${$.resource}: ${(0,N.$Ai)(j)}`),this.z.error(j)}}async I($){if(!this.profile.isDefault)return{};const j=this.D.getValue(i.$ygb),M=this.enabled.find(U=>U instanceof S.$I3b);if(M){const U=await M.getRemoteUserDataSyncConfiguration($);return{...j,...U}}return j}J($){this.g!==$&&(this.g=$,this.h.fire($))}L(){return this.M(),this.enabled.some($=>$.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some($=>$.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const $=this.enabled.filter(j=>j.status==="hasConflicts").filter(j=>j.conflicts.conflicts.length>0).map(j=>j.conflicts);(0,I.$ub)(this.m,$,(j,M)=>j.syncResource===M.syncResource&&(0,I.$ub)(j.conflicts,M.conflicts,(U,z)=>(0,k.$og)(U.previewResource,z.previewResource)))||(this.m=$,this.n.fire($))}N($){switch($){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=ye([Y(2,i.$Qgb),Y(3,d.$Oh),Y(4,b.$$n),Y(5,i.$Fgb),Y(6,y.$cl),Y(7,i.$Vgb),Y(8,f.$Kk),Y(9,E.$ji)],o);function v(u){if(u instanceof i.$Lgb)switch(u.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(u,$,j,M){M.publicLog2("sync/error",{code:u.code,serverCode:u instanceof i.$Mgb?String(u.serverCode):void 0,url:u instanceof i.$Mgb?u.url:void 0,resource:u.resource,executionId:$,service:j.userDataSyncStore.url.toString()})}}),define(oe[258],ae([0,1,3,2,10,17,25]),function(te,e,I,L,A,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T8b=e.$S8b=void 0;function R(b,l){return{...b,profile:(0,N.$Lk)(b.profile,l.profilesHome.scheme)}}function k(b){return{created:b.created,uri:A.URI.revive(b.uri)}}class g{constructor(l,d,p){this.c=l,this.d=d,this.f=p,this.a=new Map,this.b=new I.$Nd}listen(l,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(l,d,p){try{return await this.g(l,d,p)}catch(y){throw this.f.error(y),y}}async g(l,d,p){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(p[0]));case"accept":return this.c.accept(R(p[0],this.d),A.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(k(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(p[0]),A.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const y=d.substring(11),f=p[0],c=this.h(f);switch(p=p.slice(1),y){case"merge":return c.merge();case"apply":return c.apply().then(()=>this.a.delete(this.j(c.id)));case"stop":return c.stop().finally(()=>this.a.delete(this.j(c.id)))}}throw new Error("Invalid call")}h(l){const d=this.a.get(this.j(l));if(!d)throw new Error(`Manual sync taks not found: ${l}`);return d}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$S8b=g;let C=class extends L.$Sc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,d){super(),this.n=d,this.b="uninitialized",this.c=this.B(new I.$Nd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$Nd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$Nd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$Nd),this.onSyncErrors=this.m.event,this.a={call(p,y,f){return l.call(p,y,f).then(null,c=>{throw D.$Lgb.toUserDataSyncError(c)})},listen(p,y){return l.listen(p,y)}},this.a.call("_getInitialData").then(([p,y,f])=>{this.s(p),this.t(y),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(c=>this.s(c))),this.B(this.a.listen("onDidChangeLastSyncTime")(c=>this.u(c)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(y=>({...y,error:D.$Lgb.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),d=this;return new E(l,{async call(y,f,c){return d.a.call(`manualSync/${y}`,[l,...Array.isArray(f)?f:[f]],c)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,d,p,y){return this.a.call("accept",[l,d,p,y])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,d){return this.a.call("extractActivityData",[l,d])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map(d=>({syncResource:d.syncResource,profile:(0,N.$Lk)(d.profile,this.n.profilesHome.scheme),conflicts:d.conflicts.map(p=>({...p,baseResource:A.URI.revive(p.baseResource),localResource:A.URI.revive(p.localResource),remoteResource:A.URI.revive(p.remoteResource),previewResource:A.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$T8b=C,e.$T8b=C=ye([Y(1,N.$Kk)],C);class E extends L.$Sc{constructor(l,d){super(),this.id=l,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[259],ae([0,1,6,26,8,3,2,140,5,19,12,10,32,20,14,11,24,57,43,21,25]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Db=e.$ZDb=e.$YDb=e.$XDb=e.$WDb=void 0;const S="configurationSync.store",s="sync.previous.store",a="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let o=class extends D.$Sc{get userDataSyncStore(){return this.b}get c(){return this.h.get(m.$Ogb,-1)}set c(M){this.h.store(m.$Ogb,M,-1,k.$p?0:1)}constructor(M,U,z){super(),this.f=M,this.g=U,this.h=z,this.a=this.B(new N.$Nd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new D.$Rc);this.B(N.Event.filter(z.onDidChangeValue(-1,m.$Ogb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[S]),this.a.fire()}m(M){if(M&&(M=k.$p&&M.web?{...M,...M.web}:M,(0,C.$yf)(M.url)&&(0,C.$Af)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(U=>Array.isArray(M.authenticationProviders[U].scopes)))){const U=M,z=!!U.canSwitch,q=U.url===U.insidersUrl?"insiders":"stable",Z=(z?this.c:void 0)||q,X=Z==="insiders"?U.insidersUrl:Z==="stable"?U.stableUrl:U.url;return{url:E.URI.parse(X),type:Z,defaultType:q,defaultUrl:E.URI.parse(U.url),stableUrl:E.URI.parse(U.stableUrl),insidersUrl:E.URI.parse(U.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(U.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:U.authenticationProviders[H].scopes}),x),[])}}}};e.$WDb=o,e.$WDb=o=ye([Y(0,y.$pj),Y(1,l.$ji),Y(2,h.$7o)],o);let v=class extends o{constructor(M,U,z){super(M,U,z);const q=this.h.get(s,-1);q&&(this.n=JSON.parse(q));const Z=this.f[S];Z?this.h.store(s,JSON.stringify(Z),-1,1):this.h.remove(s,-1)}async switch(M){M!==this.c&&(this.c=M,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$XDb=v,e.$XDb=v=ye([Y(0,y.$pj),Y(1,l.$ji),Y(2,h.$7o)],v);let w=class extends D.$Sc{get donotMakeRequestsUntil(){return this.j}constructor(M,U,z,q,Z,X,x){super(),this.n=z,this.r=q,this.s=x,this.g=this.B(new N.$Nd),this.onTokenFailed=this.g.event,this.h=this.B(new N.$Nd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new N.$Nd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(M),this.c=(0,c.$ap)(Z,X,x).then(H=>{const Q={"X-Client-Name":`${U.applicationName}${k.$p?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(Q["X-Client-Commit"]=U.commit),Q}),this.f=new $(t,r,this.n,this.r),this.u(),this.B((0,D.$Qc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(M,U){this.b={token:M,type:U}}t(M){this.a=M?(0,g.$vg)(M,"v1"):void 0}u(){const M=this.s.getNumber(a,-1);M&&Date.now()<M&&this.y(new Date(M))}y(M){this.j?.getTime()!==M?.getTime()&&(this.j=M,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(a,this.j.getTime(),-1,1),this.w=(0,I.$Hg)(U=>(0,I.$Ug)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(a,-1),this.m.fire())}async getAllCollections(M={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,g.$vg)(this.a,"collection").toString();M={...M},M["Content-Type"]="application/json";const z=await this.D(U,{type:"GET",headers:M},[],L.CancellationToken.None);return(await(0,f.$Zo)(z))?.map(({id:q})=>q)||[]}async createCollection(M={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,g.$vg)(this.a,"collection").toString();M={...M},M["Content-Type"]=R.$Qr.text;const z=await this.D(U,{type:"POST",headers:M},[],L.CancellationToken.None),q=await(0,f.$Yo)(z);if(!q)throw new m.$Mgb("Server did not return the collection id",U,"NoCollection",z.res.statusCode,z.res.headers[m.$Igb]);return q}async deleteCollection(M,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=M?(0,g.$vg)(this.a,"collection",M).toString():(0,g.$vg)(this.a,"collection").toString();U={...U},await this.D(z,{type:"DELETE",headers:U},[],L.CancellationToken.None)}async getAllResourceRefs(M,U){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.z(this.a,U,M),q={},Z=await this.D(z.toString(),{type:"GET",headers:q},[],L.CancellationToken.None);return(await(0,f.$Zo)(Z)||[]).map(({url:x,created:H})=>({ref:(0,g.$xg)(z,z.with({path:x})),created:H*1e3}))}async resolveResourceContent(M,U,z,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$vg)(this.z(this.a,z,M),U).toString();q={...q},q["Cache-Control"]="no-cache";const X=await this.D(Z,{type:"GET",headers:q},[],L.CancellationToken.None);return await(0,f.$Yo)(X)}async deleteResource(M,U,z){if(!this.a)throw new Error("No settings sync store url configured.");const q=U!==null?(0,g.$vg)(this.z(this.a,z,M),U).toString():this.z(this.a,z,M).toString(),Z={};await this.D(q,{type:"DELETE",headers:Z},[],L.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$vg)(this.a,"resource").toString(),U={"Content-Type":R.$Qr.text};await this.D(M,{type:"DELETE",headers:U},[],L.CancellationToken.None)}async readResource(M,U,z,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$vg)(this.z(this.a,z,M),"latest").toString();q={...q},q["Cache-Control"]="no-cache",U&&(q["If-None-Match"]=U.ref);const X=await this.D(Z,{type:"GET",headers:q},[304],L.CancellationToken.None);let x=null;if(X.res.statusCode===304&&(x=U),x===null){const H=X.res.headers.etag;if(!H)throw new m.$Mgb("Server did not return the ref",Z,"NoRef",X.res.statusCode,X.res.headers[m.$Igb]);const Q=await(0,f.$Yo)(X);if(!Q&&X.res.statusCode===304)throw new m.$Mgb("Empty response",Z,"EmptyResponse",X.res.statusCode,X.res.headers[m.$Igb]);x={ref:H,content:Q}}return x}async writeResource(M,U,z,q,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=this.z(this.a,q,M).toString();Z={...Z},Z["Content-Type"]=R.$Qr.text,z&&(Z["If-Match"]=z);const x=await this.D(X,{type:"POST",data:U,headers:Z},[],L.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new m.$Mgb("Server did not return the ref",X,"NoRef",x.res.statusCode,x.res.headers[m.$Igb]);return H}async manifest(M,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,g.$vg)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",M&&(U["If-None-Match"]=M.ref);const q=await this.D(z,{type:"GET",headers:U},[304],L.CancellationToken.None);let Z=null;if(q.res.statusCode===304&&(Z=M),!Z){const x=q.res.headers.etag;if(!x)throw new m.$Mgb("Server did not return the ref",z,"NoRef",q.res.statusCode,q.res.headers[m.$Igb]);const H=await(0,f.$Yo)(q);if(!H&&q.res.statusCode===304)throw new m.$Mgb("Empty response",z,"EmptyResponse",q.res.statusCode,q.res.headers[m.$Igb]);H&&(Z={...JSON.parse(H),ref:x})}const X=this.s.get(n,-1);return X&&Z&&X!==Z.session&&this.C(),Z===null&&X&&this.C(),Z&&this.s.store(n,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$vg)(this.a,"download").toString(),U={},z=await this.D(M,{type:"GET",headers:U},[],L.CancellationToken.None);if(!(0,f.$Vo)(z))throw new m.$Mgb("Server returned "+z.res.statusCode,M,"EmptyResponse",z.res.statusCode,z.res.headers[m.$Igb]);if((0,f.$Wo)(z))throw new m.$Mgb("Empty response",M,"EmptyResponse",z.res.statusCode,z.res.headers[m.$Igb]);return z.stream}z(M,U,z){return U?(0,g.$vg)(M,"collection",U,"resource",z):(0,g.$vg)(M,"resource",z)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(M,U,z,q){if(!this.b)throw new m.$Mgb("No Auth Token Available",M,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new m.$Mgb(`${U.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Z=await this.c;U.headers={...U.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:M,type:U.type,headers:{...U.headers,authorization:void 0}});let X;try{X=await this.f.request(M,U,q)}catch(W){if(!(W instanceof m.$Mgb)){let ee="RequestFailed";const ne=(0,A.$0)(W).toLowerCase();ne.includes("xhr timeout")?ee="RequestTimeout":ne.includes("protocol")&&ne.includes("not supported")?ee="RequestProtocolNotSupported":ne.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ne.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,A.$4)(W)&&(ee="RequestCanceled"),W=new m.$Mgb(`Connection refused for the request '${M}'.`,M,ee,void 0,void 0)}throw this.r.info("Request failed",M),W}const x=X.res.headers[m.$Igb],H={url:M,status:X.res.statusCode,"execution-id":U.headers[m.$Jgb],"operation-id":x},Q=(0,f.$Vo)(X)||X.res.statusCode&&z.includes(X.res.statusCode);let J="";if(Q?this.r.trace("Request succeeded",H):(J=await(0,f.$Xo)(X)||"",this.r.info("Request failed",H,J)),X.res.statusCode===401||X.res.statusCode===403){if(this.b=void 0,X.res.statusCode===401)throw this.g.fire("Unauthorized"),new m.$Mgb(`${U.type} request '${M}' failed because of Unauthorized (401).`,M,"Unauthorized",X.res.statusCode,x);if(X.res.statusCode===403)throw this.g.fire("Forbidden"),new m.$Mgb(`${U.type} request '${M}' failed because the access is forbidden (403).`,M,"Forbidden",X.res.statusCode,x)}if(this.h.fire(),X.res.statusCode===404)throw new m.$Mgb(`${U.type} request '${M}' failed because the requested resource is not found (404).`,M,"NotFound",X.res.statusCode,x);if(X.res.statusCode===405)throw new m.$Mgb(`${U.type} request '${M}' failed because the requested endpoint is not found (405). ${J}`,M,"MethodNotFound",X.res.statusCode,x);if(X.res.statusCode===409)throw new m.$Mgb(`${U.type} request '${M}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,M,"Conflict",X.res.statusCode,x);if(X.res.statusCode===410)throw new m.$Mgb(`${U.type} request '${M}' failed because the requested resource is not longer available (410).`,M,"Gone",X.res.statusCode,x);if(X.res.statusCode===412)throw new m.$Mgb(`${U.type} request '${M}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,M,"PreconditionFailed",X.res.statusCode,x);if(X.res.statusCode===413)throw new m.$Mgb(`${U.type} request '${M}' failed because of too large payload (413).`,M,"TooLarge",X.res.statusCode,x);if(X.res.statusCode===426)throw new m.$Mgb(`${U.type} request '${M}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,M,"UpgradeRequired",X.res.statusCode,x);if(X.res.statusCode===429){const W=X.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new m.$Mgb(`${U.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",X.res.statusCode,x)):new m.$Mgb(`${U.type} request '${M}' failed because of too many requests (429).`,M,"RemoteTooManyRequests",X.res.statusCode,x)}if(!Q)throw new m.$Mgb("Server returned "+X.res.statusCode,M,"Unknown",X.res.statusCode,x);return X}F(M){let U=this.s.get(i,-1);U===void 0&&(U=(0,b.$eg)(),this.s.store(i,U,-1,1)),M["X-Machine-Session-Id"]=U;const z=this.s.get(n,-1);z!==void 0&&(M["X-User-Session-Id"]=z)}};e.$YDb=w,e.$YDb=w=ye([Y(1,y.$pj),Y(2,f.$To),Y(3,m.$Vgb),Y(4,d.$Wh),Y(5,p.$$j),Y(6,h.$7o)],w);let u=class extends w{constructor(M,U,z,q,Z,X,x){super(M.userDataSyncStore?.url,U,z,q,Z,X,x),this.B(M.onDidChangeUserDataSyncStore(()=>this.t(M.userDataSyncStore?.url)))}};e.$ZDb=u,e.$ZDb=u=ye([Y(0,m.$Fgb),Y(1,y.$pj),Y(2,f.$To),Y(3,m.$Vgb),Y(4,d.$Wh),Y(5,p.$$j),Y(6,h.$7o)],u);class ${constructor(M,U,z,q){this.c=M,this.d=U,this.f=z,this.g=q,this.a=[],this.b=void 0}request(M,U,z){if(this.h()&&this.i(),U.url=M,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new m.$Mgb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,M,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(M),this.f.request(U,z)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$1Db=$}),define(oe[260],ae([0,1,3,55,24,21,22,255,25,79,82]),function(te,e,I,L,A,N,D,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b9b=void 0;let E=class extends R.$x5b{constructor(l,d,p,y,f,c,h,m,S,s,a){super(l,d,p,y,f,h,m,S,s,a),this.B(I.Event.debounce(I.Event.any(I.Event.map(c.onDidFocusWindow,()=>"windowFocus"),I.Event.map(c.onDidOpenWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$b9b=E,e.$b9b=E=ye([Y(0,A.$pj),Y(1,k.$Fgb),Y(2,k.$Ggb),Y(3,k.$Qgb),Y(4,k.$Rgb),Y(5,L.$X6b),Y(6,k.$Vgb),Y(7,g.$CCb),Y(8,D.$cl),Y(9,C.$tgb),Y(10,N.$7o)],E)}),define(oe[261],ae([0,1,70,23,5,19]),function(te,e,I,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=e.$y6b=e.$x6b=e.$w6b=void 0,e.$w6b=128/4;function D(g){function C(){let E=g.scheme===L.Schemas.file?(0,N.$jg)(g):g.toString();return A.$l||(E=E.toLowerCase()),(0,I.createHash)("md5").update(E).digest("hex")}return{id:C(),configPath:g}}e.$x6b=D;function R(g,C){function E(){if(g.scheme!==L.Schemas.file)return(0,I.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let l;return A.$l?l=C.ino:A.$k?l=C.birthtime.getTime():A.$j&&(typeof C.birthtimeMs=="number"?l=Math.floor(C.birthtimeMs):l=C.birthtime.getTime()),(0,I.createHash)("md5").update(g.fsPath).update(l?String(l):"").digest("hex")}const b=E();if(typeof b=="string")return{id:b,uri:g}}e.$y6b=R;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$z6b=k}),define(oe[262],ae([0,1,6,8,2,16,31,14,7,76,113,261,55,72,23]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=void 0;let p=class extends A.$Sc{constructor(f,c,h,m){super(),this.a=f,this.b=c,this.c=h,this.f=m,this.B(new I.$6g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,c=await D.Promises.readdir(f),h=new g.$aDb(this.f.getChannel("storage"));await Promise.all(c.map(async m=>{const S=(0,N.$jc)(f,m);m.length===E.$w6b||m===C.$2h.id||(await this.c.getWindows()).some(n=>n.workspace?.id===m)||await h.isUsed(S)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await D.Promises.rm(S))}))}catch(f){(0,L.$1)(f)}}};e.$H8b=p,e.$H8b=p=ye([Y(0,R.$Xh),Y(1,k.$0i),Y(2,b.$X6b),Y(3,l.$g8b)],p)}),define(oe[83],ae([0,1,53,6,16,12,31,148,273,274]),function(te,e,I,L,A,N,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.zip=e.$mp=e.$lp=void 0,e.$lp="end of central directory record signature not found";const C=new RegExp(e.$lp);class E extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.$mp=E;function b(s){const a=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function l(s){if(s instanceof E)return s;let a;return C.test(s.message)&&(a="CorruptZip"),new E(a,s)}function d(s,a,n,i,t,r){const o=A.$mc(a),v=A.$jc(i,o);if(!v.startsWith(i))return Promise.reject(new Error(R.localize(0,null,a)));const w=A.$jc(i,a);let u;return r.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(D.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise(($,j)=>{if(!r.isCancellationRequested)try{u=(0,I.createWriteStream)(w,{mode:n}),u.once("close",()=>$()),u.once("error",j),s.once("error",j),s.pipe(u)}catch(M){j(M)}}))}function p(s,a,n,i){let t=(0,L.$Hg)(()=>Promise.resolve()),r=0;const o=i.onCancellationRequested(()=>{t.cancel(),s.close()});return new Promise((v,w)=>{const u=new L.$Og,$=j=>{j.isCancellationRequested||(r++,s.readEntry())};s.once("error",w),s.once("close",()=>t.then(()=>{i.isCancellationRequested||s.entryCount===r?v():w(new E("Incomplete",new Error(R.localize(1,null,r,s.entryCount))))},w)),s.readEntry(),s.on("entry",j=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){$(i);return}const M=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(M)){const q=A.$jc(a,M);t=(0,L.$Hg)(Z=>D.Promises.mkdir(q,{recursive:!0}).then(()=>$(Z)).then(void 0,w));return}const U=f(s,j),z=b(j);t=(0,L.$Hg)(q=>u.queue(()=>U.then(Z=>d(Z,M,z,a,n,q).then(()=>$(q)))).then(null,w))})}).finally(()=>o.dispose())}function y(s,a=!1){return new Promise((n,i)=>{(0,k.open)(s,a?{lazyEntries:!0}:void 0,(t,r)=>{t?i(l(t)):n((0,N.$Jf)(r))})})}function f(s,a){return new Promise((n,i)=>{s.openReadStream(a,(t,r)=>{t?i(l(t)):n((0,N.$Jf)(r))})})}function c(s,a){return new Promise((n,i)=>{const t=new g.ZipFile;a.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const r=(0,I.createWriteStream)(s);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>n(s))})}e.zip=c;function h(s,a,n={},i){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=y(s,!0);return n.overwrite&&(r=r.then(o=>D.Promises.rm(a).then(()=>o))),r.then(o=>p(o,a,{sourcePathRegex:t},i))}e.$op=h;function m(s,a){return y(s).then(n=>new Promise((i,t)=>{n.on("entry",r=>{r.fileName===a&&f(n,r).then(o=>i(o),o=>t(o))}),n.once("close",()=>t(new Error(R.localize(2,null,a))))}))}function S(s,a){return m(s,a).then(n=>new Promise((i,t)=>{const r=[];n.once("error",t),n.on("data",o=>r.push(o)),n.on("end",()=>i(Buffer.concat(r)))}))}e.$pp=S}),define(oe[263],ae([0,1,6,8,2,23,19,54,12,32,31,83,20,14,29,33,97,11,7]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;let m=class extends A.$Sc{static{h=this}static{this.c=".sigzip"}constructor(s,a,n,i,t,r){super(),this.h=a,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,a,n){await this.g;const i=(0,D.$vg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,a))}catch(r){throw new d.$_n(r.message,d.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===c.LogLevel.Trace)}catch(o){const v=o;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new d.$_n(E.$lp,d.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(o){this.r.error(o)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,k.$Ef)(a)?a:!0}async u(s){await this.g;const a=(0,D.$vg)(this.extensionsDownloadDir,`${this.z(s)}${h.c}`);return await this.w(s,a,n=>this.j.downloadSignatureArchive(s,n)),a}async w(s,a,n){if(await this.h.exists(a))return;if(a.scheme!==N.Schemas.file){await n(a);return}const i=(0,D.$vg)(this.extensionsDownloadDir,`.${(0,g.$eg)()}`);await this.h.exists(i)||await n(i);try{await C.Promises.rename(i.fsPath,a.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,L.$0)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const a=[],n=[],i=[];for(const o of s.children)if(o.name.endsWith(h.c))i.push(o.resource);else{const v=p.$Bo.parse(o.name);v&&n.push([v,o])}const t=(0,p.$Go)(n,([o])=>o),r=[];for(const o of t)o.sort((v,w)=>R.rcompare(v[0].version,w[0].version)),a.push(...o.slice(1).map(v=>v[1].resource)),r.push(o[0][1]);r.sort((o,v)=>o.mtime-v.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),a.push(...i),await I.Promises.settled(a.map(o=>(this.r.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(s){this.r.error(s)}}z(s){return this.f?p.$Bo.create(s).toString().toLowerCase():(0,g.$eg)()}};e.$Ep=m,e.$Ep=m=h=ye([Y(0,l.$Xh),Y(1,f.$$j),Y(2,d.$$n),Y(3,b.$ji),Y(4,y.$fp),Y(5,c.$0i)],m)}),define(oe[264],ae([0,1,83,157]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;function A(N){return(0,I.$pp)(N,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.$Gp=A}),define(oe[122],ae([0,1,6,15,26,38,8,3,52,2,34,23,16,19,54,12,10,32,31,83,156,96,14,243,29,33,51,80,263,244,264,212,223,68,11,4,7,24,22,28,17]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m,S,s,a,n,i,t,r,o,v,w,u,$,j,M,U,z,q,Z,X,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Jp=(0,U.$Qh)(n.$ao);const H=".vsctmp";let Q=class extends a.$qp{constructor(K,B,P,O,T,F,V,G,re,ce,ue,he){super(K,B,ue,P,ce,he),this.fb=T,this.gb=F,this.hb=V,this.ib=re,this.eb=new Map,this.rb=new C.$Bc;const $e=this.B(G.createInstance(v.$Fp));this.bb=this.B(G.createInstance(J,we=>$e.postUninstall(we))),this.cb=this.B(new u.$Hp(he,re,ue,this,this.F)),this.db=this.B(G.createInstance(o.$Ep));const de=this.B(new $.$Ip(this,this.fb,he,F,ue,re,P));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Lo)(this.ib,this.F)),this.jb}async zip(K){this.F.trace("ExtensionManagementService#zip",K.identifier.id);const B=await this.pb(K),P=await(0,h.zip)((0,l.$vg)(this.db.extensionsDownloadDir,(0,f.$eg)()).fsPath,B);return y.URI.file(P)}async unzip(K){return this.F.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:B,cleanup:P}=await this.lb(K),O=b.$kc(B.fsPath);try{return await(0,w.$Gp)(O)}finally{await P()}}getInstalled(K,B=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(K??null,B)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.bb.scanUserExtensionAtLocation(K)}async install(K,B={}){this.F.trace("ExtensionManagementService#install",K.toString());const{location:P,cleanup:O}=await this.lb(K);try{const T=await(0,w.$Gp)(b.$kc(P.fsPath)),F=(0,i.$Fo)(T.publisher,T.name);if(T.engines&&T.engines.vscode&&!(0,j.$So)(T.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,F,this.G.version));const G=(await this.I([{manifest:T,extension:P,options:B}])).find(({identifier:re})=>(0,i.$Ao)(re,{id:F}));if(G?.local)return G.local;throw G?.error?G.error:(0,a.$sp)(new Error(`Unknown error while installing extension ${F}`))}finally{await O()}}async installFromLocation(K,B){this.F.trace("ExtensionManagementService#installFromLocation",K.toString());const P=await this.bb.scanUserExtensionAtLocation(K);if(!P)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.ub([[P,void 0]],B),this.F.info("Successfully installed extension",P.identifier.id,B.toString()),P}async installExtensionsFromProfile(K,B,P){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",K,B.toString(),P.toString());const O=(await this.bb.scanExtensions(1,B)).filter(T=>K.some(F=>(0,i.$Ao)(F,T.identifier)));if(O.length){const T=await Promise.all(O.map(F=>this.bb.scanMetadata(F,B)));await this.ub(O.map((F,V)=>[F,T[V]]),P),this.F.info("Successfully installed extensions",O.map(F=>F.identifier.id),P.toString())}return O}async updateMetadata(K,B,P=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",K.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0),B.isMachineScoped===!1&&(B.isMachineScoped=void 0),B.isBuiltin===!1&&(B.isBuiltin=void 0),B.pinned===!1&&(B.pinned=void 0),K=await this.bb.updateMetadata(K,B,P),this.cb.invalidate(P),this.w.fire(K),K}async reinstallFromGallery(K){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const B=await this.getTargetPlatform(),[P]=await this.z.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:B,compatible:!0},A.CancellationToken.None);if(!P)throw new Error(m.localize(2,null));await this.bb.setUninstalled(K);try{await this.bb.removeUninstalledExtension(K)}catch(O){throw new Error(m.localize(3,null,(0,N.$Ai)(O)))}return this.installFromGallery(P)}ab(K,B,P,O){return this.bb.copyExtension(K,B,P,O)}copyExtensions(K,B){return this.bb.copyExtensions(K,B)}markAsUninstalled(...K){return this.bb.setUninstalled(...K)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(K){this.F.error(K)}}async download(K,B,P){const{location:O}=await this.db.download(K,B,!P);return O}async lb(K){if(K.scheme===E.Schemas.file)return{location:K,async cleanup(){}};this.F.trace("Downloading extension from",K.toString());const B=(0,l.$vg)(this.db.extensionsDownloadDir,(0,f.$eg)());return await this.hb.download(K,B),this.F.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.ib.del(B)}catch(O){this.F.error(O)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(K,B,P){if(y.URI.isUri(B))return new ne(K,B,P,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const O=i.$Bo.create(B).toString();let T=this.eb.get(O);return T||(this.eb.set(O,T=new ee(K,B,P,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),T.waitUntilTaskIsFinished().finally(()=>this.eb.delete(O))),T}$(K,B){return new _(K,B.profileLocation,this.gb)}async pb(K){const B=async O=>{let T=await c.Promises.readdir(O);T=T.map(G=>b.$jc(O,G));const F=await Promise.all(T.map(G=>c.Promises.stat(G)));let V=Promise.resolve([]);return F.forEach((G,re)=>{const ce=T[re];G.isFile()&&(V=V.then(ue=>[...ue,ce])),G.isDirectory()&&(V=V.then(ue=>B(ce).then(he=>[...ue,...he])))}),V};return(await B(K.location.fsPath)).map(O=>({path:`extension/${b.$lc(K.location.fsPath,O)}`,localPath:O}))}async qb({added:K,removed:B}){if(B){const P=K&&this.D.extUri.isEqual(B.profileLocation,K.profileLocation)?B.extensions.filter(O=>K.extensions.every(T=>!(0,i.$Ao)(T,O))):B.extensions;for(const O of P)this.F.info("Extensions removed from another source",O.id,B.profileLocation.toString()),this.u.fire({identifier:O,profileLocation:B.profileLocation})}if(K){const O=(await this.bb.scanExtensions(1,K.profileLocation)).filter(T=>K.extensions.some(F=>(0,i.$Ao)(F,T.identifier)));this.s.fire(O.map(T=>(this.F.info("Extensions added from another source",T.identifier.id,K.profileLocation.toString()),{identifier:T.identifier,local:T,profileLocation:K.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(B=>this.rb.add(B)));const K=await this.ib.resolve(this.fb.userExtensionsLocation);for(const B of K.children??[])B.isDirectory&&this.rb.add(B.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(B=>this.tb(B)))}async tb(K){if(!K.affects(this.fb.userExtensionsLocation,1))return;const B=[];for(const P of K.rawAdded){if(this.rb.has(P)||!this.D.extUri.isEqual(this.D.extUri.dirname(P),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(P,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(P).startsWith(".")||!(await this.ib.stat(P)).isDirectory)continue;const O=await this.bb.scanUserExtensionAtLocation(P);O&&O.installedTimestamp===void 0&&(this.rb.add(P),B.push(O))}B.length&&(await this.ub(B.map(P=>[P,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",B.map(P=>P.identifier.id)))}async ub(K,B){const P=K.map(O=>O[0]);await this.vb(P),await this.gb.addExtensionsToProfile(K,B),this.s.fire(P.map(O=>({local:O,identifier:O.identifier,operation:1,profileLocation:B})))}async vb(K){const B=await this.bb.getUninstalledExtensions();for(const P of K){const O=i.$Bo.create(P);B[O.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",O.id),await this.bb.setInstalled(O),this.F.info("Removed the extension from uninstalled list:",O.id))}}};e.$Kp=Q,e.$Kp=Q=ye([Y(0,n.$$n),Y(1,Z.$cl),Y(2,z.$0i),Y(3,s.$Xh),Y(4,r.$zp),Y(5,t.$vp),Y(6,S.$On),Y(7,U.$Oh),Y(8,M.$$j),Y(9,q.$pj),Y(10,X.$Ik),Y(11,x.$Kk)],Q);let J=class extends g.$Sc{constructor(K,B,P,O,T,F){super(),this.j=K,this.m=B,this.n=P,this.s=O,this.t=T,this.u=F,this.h=this.B(new R.$Nd),this.onExtract=this.h.event,this.c=(0,l.$vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new I.$1g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(K,B){const P={includeInvalid:!0,profileLocation:B};let O=[];return K===null||K===0?O.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):K===1&&O.push(...await this.n.scanUserExtensions(P)),O=K!==null?O.filter(T=>T.type===K):O,Promise.all(O.map(T=>this.F(T)))}async scanAllUserExtensions(K){const B=await this.n.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(B.map(P=>this.F(P)))}async scanUserExtensionAtLocation(K){try{const B=await this.n.scanExistingExtension(K,1,{includeInvalid:!0});if(B)return await this.F(B)}catch(B){this.u.error(B)}return null}async extractUserExtension(K,B,P,O,T){const F=K.toString(),V=y.URI.file(b.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,f.$eg)()}`)),G=y.URI.file(b.$jc(this.n.userExtensionsLocation.fsPath,F));let re=await this.m.exists(G);if(re&&O){try{await this.y(K.id,G,"removeExisting")}catch{throw new n.$_n(m.localize(4,null,G.fsPath,K.id),n.ExtensionManagementErrorCode.Delete)}re=!1}if(!re)try{try{this.u.trace(`Started extracting the extension from ${B} to ${G.fsPath}`),await(0,h.$op)(B,V.fsPath,{sourcePath:"extension",overwrite:!0},T),this.u.info(`Extracted extension to ${G}:`,K.id)}catch(ce){let ue=n.ExtensionManagementErrorCode.Extract;throw ce instanceof h.$mp&&(ce.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:ce.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$_n(ce.message,ue)}await this.n.updateMetadata(V,P);try{this.u.trace(`Started renaming the extension from ${V.fsPath} to ${G.fsPath}`),await this.C(V.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ce){if(ce.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(ce)}. Deleted from extracted location`,V),ce}this.h.fire(G)}catch(ce){try{await this.m.del(V,{recursive:!0})}catch{}throw ce}return this.D(G,1)}async scanMetadata(K,B){return B?(await this.w(K,B))?.metadata:this.n.scanMetadata(K.location)}async w(K,B){return(await this.s.scanProfileExtensions(B)).find(O=>(0,i.$Ao)(O.identifier,K.identifier))}async updateMetadata(K,B,P){return P?await this.s.updateMetadata([[K,B]],P):await this.n.updateMetadata(K.location,B),this.D(K.location,K.type,P)}getUninstalledExtensions(){return this.z()}async setUninstalled(...K){const B=K.map(P=>i.$Bo.create(P));await this.z(P=>B.forEach(O=>{P[O.toString()]=!0,this.u.info("Marked extension as uninstalled",O.toString())}))}async setInstalled(K){await this.z(B=>delete B[K.toString()])}async removeExtension(K,B){if(this.t.extUri.isEqualOrParent(K.location,this.n.userExtensionsLocation))return this.y(K.identifier.id,K.location,B)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.z(B=>delete B[i.$Bo.create(K).toString()])}async copyExtension(K,B,P,O){const T=await this.w(K,B),F=await this.w(K,P);return O={...T?.metadata,...O},F?await this.s.updateMetadata([[K,{...F.metadata,...O}]],P):await this.s.addExtensionsToProfile([[K,O]],P),this.D(K.location,K.type,P)}async copyExtensions(K,B){const P=await this.scanExtensions(1,K),O=await Promise.all(P.filter(T=>!T.isApplicationScoped).map(async T=>[T,await this.scanMetadata(T,K)]));await this.s.addExtensionsToProfile(O,B)}async y(K,B,P){this.u.trace(`Deleting ${P} extension from disk`,K,B.fsPath);const O=this.t.extUri.joinPath(this.t.extUri.dirname(B),`${this.t.extUri.basename(B)}.${(0,k.$Di)((0,f.$eg)()).toString(16)}${H}`);await this.C(B.fsPath,O.fsPath),await this.m.del(O,{recursive:!0}),this.u.info(`Deleted ${P} extension from disk`,K,B.fsPath)}async z(K){return this.g.queue(async()=>{let B;try{B=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(O){if((0,M.$pk)(O)!==1)throw O}let P={};if(B)try{P=JSON.parse(B)}catch{}return K&&(K(P),Object.keys(P).length?await this.m.writeFile(this.c,L.$be.fromString(JSON.stringify(P))):await this.m.del(this.c)),P})}async C(K,B){try{await c.Promises.rename(K,B,2*60*1e3)}catch(P){throw new n.$_n(P.message||m.localize(5,null,K,B),P.code||n.ExtensionManagementErrorCode.Rename)}}async D(K,B,P){if(P){const T=(await this.n.scanUserExtensions({profileLocation:P})).find(F=>this.t.extUri.isEqual(F.location,K));if(T)return this.F(T)}else{const O=await this.n.scanExistingExtension(K,B,{includeInvalid:!0});if(O)return this.F(O)}throw new Error(m.localize(6,null,K.path))}async F(K){const B=await this.m.resolve(K.location);let P,O;return B.children&&(P=B.children.find(({name:T})=>/^readme(\.txt|\.md|)$/i.test(T))?.resource,O=B.children.find(({name:T})=>/^changelog(\.txt|\.md|)$/i.test(T))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:P,changelogUrl:O,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async G(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(K));const B=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const T of B)K[i.$Bo.create(T).toString()]||P.add(T.identifier.id.toLowerCase());try{const T=(0,i.$Go)(B,F=>F.identifier);await I.Promises.settled(T.map(async F=>{const V=F.sort((G,re)=>d.rcompare(G.manifest.version,re.manifest.version))[0];P.has(V.identifier.id.toLowerCase())||await this.j(await this.F(V))}))}catch(T){this.u.error(T)}const O=B.filter(T=>T.metadata&&K[i.$Bo.create(T).toString()]);await Promise.allSettled(O.map(T=>this.removeUninstalledExtension(T)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.m.resolve(this.n.userExtensionsLocation)}catch(B){(0,M.$pk)(B)!==1&&this.u.error(B);return}if(K?.children)try{await Promise.allSettled(K.children.map(async B=>{if(!(!B.isDirectory||!B.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",B.resource.toString());try{await this.m.del(B.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",B.resource.toString())}catch(P){(0,M.$pk)(P)!==1&&this.u.error(P)}}}))}catch{}}};e.$Lp=J,e.$Lp=J=ye([Y(1,M.$$j),Y(2,r.$zp),Y(3,t.$vp),Y(4,X.$Ik),Y(5,z.$0i)],J);class W extends a.$tp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Ff)(this.options.operation)?this.l:this.options.operation}constructor(K,B,P,O,T,F,V,G,re){super(),this.identifier=K,this.source=B,this.options=P,this.m=O,this.n=T,this.o=F,this.p=V,this.q=G,this.s=re,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(K){const[B,P]=await this.x(K);return this.j=B.isBuiltin||B.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[B,P]],this.j),B}async u({zipPath:K,key:B,metadata:P},O,T){let F=await this.v(B);return F||(this.s.trace("Extracting extension...",B.id),F=await this.m.extractUserExtension(B,K,P,O,T),this.s.info("Extracting extension completed.",B.id)),F}async v(K){return await this.w(K)?(this.s.trace("Removing the extension from uninstalled list:",K.id),await this.m.setInstalled(K),this.s.info("Removed the extension from uninstalled list:",K.id),(await this.m.scanAllUserExtensions(!0)).find(O=>i.$Bo.create(O).equals(K))):void 0}async w(K){return!!(await this.m.getUninstalledExtensions())[K.toString()]}}class ee extends W{constructor(K,B,P,O,T,F,V,G,re,ce){super(B.identifier,B,P,T,F,V,G,re,ce),this.y=B,this.z=O}async x(K){const P=(await this.m.scanExtensions(null,this.options.profileLocation)).find(V=>(0,i.$Ao)(V.identifier,this.y.identifier));P&&(this.l=3);const O={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,p.$Ef)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.y.version)return[await this.m.updateMetadata(P,O),O];const{location:T,verificationStatus:F}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=F,this.B(T.fsPath),[await this.u({zipPath:T.fsPath,key:i.$Bo.create(this.y),metadata:O},!1,K),O]}catch(V){try{await this.z.delete(T)}catch(G){this.s.warn("Error while deleting the downloaded file",T.toString(),(0,D.$0)(G))}throw V}}async B(K){try{await(0,w.$Gp)(K)}catch(B){throw new n.$_n((0,a.$rp)(B).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Mp=ee;class ne extends W{constructor(K,B,P,O,T,F,V,G,re,ce){super({id:(0,i.$Fo)(K.publisher,K.name)},B,P,T,F,V,G,re,ce),this.y=K,this.z=B,this.A=O}async h(K){const B=await super.h(K);return this.D(B,K),B}async x(K){const B=new i.$Bo(this.identifier,this.y.version),O=(await this.m.scanExtensions(1,this.options.profileLocation)).find(V=>(0,i.$Ao)(this.identifier,V.identifier)),T={isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(O)if(this.l=3,B.equals(new i.$Bo(O.identifier,O.manifest.version)))try{await this.m.removeExtension(O,"existing")}catch{throw new Error(m.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(O.manifest.version,this.y.version)&&await this.m.setUninstalled(O);else{const V=await this.v(B);if(V)try{await this.m.removeExtension(V,"existing")}catch{throw new Error(m.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:b.$kc(this.z.fsPath),key:B,metadata:T},!0,K),T]}async D(K,B){try{let[P]=await this.A.getExtensions([{id:K.identifier.id,version:K.manifest.version}],B);if(P||([P]=await this.A.getExtensions([{id:K.identifier.id}],B)),P){const O={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(K,O,this.options.profileLocation)}}catch{}}}class _ extends a.$tp{constructor(K,B,P){super(),this.extension=K,this.j=B,this.k=P}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[265],ae([0,1,2,29,81,222,122,7,21]),function(te,e,I,L,A,N,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$88b=void 0;let g=class extends I.$Sc{constructor(E,b,l,d,p,y){super(),E.cleanUp(),(0,N.$XVb)(E,b,l,d,y),A.$Yu.removeOutdatedExtensionVersions(E,p)}};e.$88b=g,e.$88b=g=ye([Y(0,D.$Jp),Y(1,L.$$n),Y(2,A.$Xu),Y(3,L.$do),Y(4,k.$7o),Y(5,R.$0i)],g)}),define(oe[123],ae([0,1,70,62,36,275,15,8,3,2,16,5,32,42,66]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;class p{traceSocketEvent(u,$){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,$)}constructor(u,$=""){this.f=!0,this.debugLabel=$,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,R.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const $=j=>{this.traceSocketEvent("read",j),u(D.$be.wrap(j))};return this.socket.on("data",$),{dispose:()=>this.socket.off("data",$)}}onClose(u){const $=j=>{u({type:0,hadError:j,error:void 0})};return this.socket.on("close",$),{dispose:()=>this.socket.off("close",$)}}onEnd(u){const $=()=>{u()};return this.socket.on("end",$),{dispose:()=>this.socket.off("end",$)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,$=>{if($){if($.code==="EPIPE")return;(0,R.$1)($)}})}catch($){if($.code==="EPIPE")return;(0,R.$1)($)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,$)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Eh=p;var y;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(y||(y={}));var f;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(f||(f={}));class c extends g.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,$){this.socket.traceSocketEvent(u,$)}constructor(u,$,j,M){super(),this.f=this.B(new k.$Nd),this.g=this.B(new k.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:$,inflateBytesLength:j?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new h(this,$,j,M,this.f,(U,z)=>this.m(U,z))),this.B(this.a.onError(U=>{console.error(U),(0,R.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new d.$zh,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let $=0;for(;$<u.byteLength;)this.a.writeMessage(u.slice($,Math.min($+262144,u.byteLength)),{compressed:!0,opcode:2}),$+=262144}m(u,{compressed:$,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let M=2;u.byteLength<126?M+=0:u.byteLength<2**16?M+=2:M+=8;const U=D.$be.alloc(M),z=$?64:0,q=j&15;if(U.writeUInt8(128|z|q,0),u.byteLength<126)U.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){U.writeUInt8(126,1);let Z=1;U.writeUInt8(u.byteLength>>>8&255,++Z),U.writeUInt8(u.byteLength>>>0&255,++Z)}else{U.writeUInt8(127,1);let Z=1;U.writeUInt8(0,++Z),U.writeUInt8(0,++Z),U.writeUInt8(0,++Z),U.writeUInt8(0,++Z),U.writeUInt8(u.byteLength>>>24&255,++Z),U.writeUInt8(u.byteLength>>>16&255,++Z),U.writeUInt8(u.byteLength>>>8&255,++Z),U.writeUInt8(u.byteLength>>>0&255,++Z)}this.socket.write(D.$be.concat([U,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const $=this.b.peek(this.j.readLen),j=$.readUInt8(0),M=(j&128)>>>7,U=(j&64)>>>6,z=j&15,q=$.readUInt8(1),Z=(q&128)>>>7,X=q&127;this.j.state=2,this.j.readLen=2+(Z?4:0)+(X===126?2:0)+(X===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!M,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const $=this.b.read(this.j.readLen),j=$.readUInt8(1),M=(j&128)>>>7;let U=j&127,z=1;U===126?U=$.readUInt8(++z)*2**8+$.readUInt8(++z):U===127&&(U=$.readUInt8(++z)*0+$.readUInt8(++z)*0+$.readUInt8(++z)*0+$.readUInt8(++z)*0+$.readUInt8(++z)*2**24+$.readUInt8(++z)*2**16+$.readUInt8(++z)*2**8+$.readUInt8(++z));let q=0;M&&(q=$.readUInt8(++z)*2**24+$.readUInt8(++z)*2**16+$.readUInt8(++z)*2**8+$.readUInt8(++z)),this.j.state=3,this.j.readLen=U,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const $=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",$),s($,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",$),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame($,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage($,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Fh=c;class h extends g.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$be.alloc(0)}constructor(u,$,j,M,U,z){super(),this.n=u,this.r=U,this.s=z,this.a=this.B(new k.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,$?(this.b=this.B(new m(this.n,M,j,{windowBits:15})),this.f=this.B(new S(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(u,$){this.g.push({data:u,options:$}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:u,options:$}=this.g.shift();if(this.f&&$.compressed){const j=await this.w(this.f,u);this.s(j,$)}else this.s(u,{...$,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,$){return new Promise((j,M)=>{u.write($),u.flush(U=>j(U))})}acceptFrame(u,$,j){this.h.push({data:u,isCompressed:$,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const $=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire($)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,$,j){return new Promise((M,U)=>{u.write($),j&&u.write(D.$be.fromByteArray([0,0,255,255])),u.flush(z=>M(z))})}}class m extends g.$Sc{get recordedInflateBytes(){return this.j?D.$be.concat(this.f):D.$be.alloc(0)}constructor(u,$,j,M){super(),this.h=u,this.j=$,this.a=this.B(new k.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,N.createInflateRaw)(M),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(D.$be.wrap(U))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const $=D.$be.concat(this.g);this.g.length=0,u($)})}}class S extends g.$Sc{constructor(u,$){super(),this.g=u,this.a=this.B(new k.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,N.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$be.wrap(j))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let $=D.$be.concat(this.f);this.f.length=0,$=$.slice(0,$.byteLength-4),u($)})}}function s(w,u){if(u===0)return;const $=w.byteLength>>>2;for(let Z=0;Z<$;Z++){const X=w.readUInt32BE(Z*4);w.writeUInt32BE(X^u,Z*4)}const j=$*4,M=w.byteLength-j,U=u>>>24&255,z=u>>>16&255,q=u>>>8&255;M>=1&&w.writeUInt8(w.readUInt8(j)^U,j),M>=2&&w.writeUInt8(w.readUInt8(j+1)^z,j+1),M>=3&&w.writeUInt8(w.readUInt8(j+2)^q,j+2)}e.$Gh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const w=(0,b.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const u=process.platform!=="darwin"&&e.$Gh?e.$Gh:(0,A.tmpdir)(),$=(0,C.$jc)(u,`vscode-ipc-${w}.sock`);return t($),$}e.$Hh=n;function i(w,u,$){const j=(0,I.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${$}-${u}-sock`;const M=$.substr(0,4),U=u.substr(0,6),z=j.substr(0,8);let q;return process.platform!=="darwin"&&e.$Gh&&!process.env.VSCODE_PORTABLE?q=(0,C.$jc)(e.$Gh,`vscode-${z}-${M}-${U}.sock`):q=(0,C.$jc)(w,`${M}-${U}.sock`),t(q),q}e.$Ih=i;function t(w){const u=a[E.$u];typeof u=="number"&&w.length>=u&&console.warn(`WARNING: IPC handle "${w}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends l.$th{static b(u){const $=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map($,j=>({protocol:new d.$Ah(new p(j,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(j,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Jh=r;function o(w){return new Promise((u,$)=>{const j=(0,L.createServer)();j.on("error",$),j.listen(w,()=>{j.removeListener("error",$),u(new r(j))})})}e.$Kh=o;function v(w,u){return new Promise(($,j)=>{const M=(0,L.createConnection)(w,()=>{M.removeListener("error",j),$(d.$Bh.fromSocket(new p(M,`ipc-client${u}`),u))});M.once("error",j)})}e.$Lh=v}),define(oe[266],ae([0,1,62,123,210]),function(te,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e9b=void 0,e.$e9b=new class{supports(N){return!0}connect({host:N,port:D},R,k,g){return new Promise((C,E)=>{const b=I.createConnection({host:N,port:D},()=>{b.removeListener("error",E),b.write((0,A.$zkb)(R,k,g));const l=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",l),C(new L.$Eh(b,g)))};b.on("data",l)});b.setNoDelay(!0),b.once("error",E)})}}}),define(oe[267],ae([0,1,62,36,133,123,6,2,5,20,7,24,213,104,106,77,15]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=e.$_7b=e.$$7b=e.$07b=void 0;async function f(s,a,n,i,t){let r;for(let o=3;o&&(r?.dispose(),r=await new c(s,a,n,i,t).waitForReady(),!(t&&A.$hg[t]||!A.$hg[r.tunnelLocalPort]));o--);return r}class c extends R.$Sc{constructor(a,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=I.createServer(),this.c=new D.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,n=(0,p.$ev)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,A.$ig)(a,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(a){a.pause();const n=(0,p.$cv)(this.tunnelRemoteHost)||(0,p.$ev)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,b.$6k)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),t.end()}),a.on("close",()=>t.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),t instanceof N.$Eh?t.socket.destroy():t.end()}),t instanceof N.$Eh?this.t(a,t):this.s(a,t),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),t.end()})}s(a,n){n.onClose(()=>a.destroy()),n.onEnd(()=>a.end()),n.onData(i=>a.write(i.buffer)),a.on("data",i=>n.write(y.$be.wrap(i))),a.resume()}t(a,n){const i=n.socket;i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),i.pipe(a),a.pipe(i)}}e.$07b=c;let h=class extends p.$hv{constructor(a,n,i,t,r){super(n,r),this.u=a,this.v=i,this.w=t}isPortPrivileged(a){return(0,p.$fv)(a,this.l,k.OS,L.release())}s(a,n,i,t,r,o,v,w){const u=this.r(n,i);if(u)return++u.refcount,u.value;if((0,p.$_u)(a))return this.t(a,n,i,r,o,v,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const $={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=f($,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,j),j}}};e.$$7b=h,e.$$7b=h=ye([Y(0,l.$Zk),Y(1,C.$0i),Y(2,d.$3k),Y(3,E.$pj),Y(4,g.$ji)],h);let m=class extends h{constructor(a,n,i,t,r){super(a,n,i,t,r)}};e.$_7b=m,e.$_7b=m=ye([Y(0,l.$Zk),Y(1,C.$0i),Y(2,d.$3k),Y(3,E.$pj),Y(4,g.$ji)],m);let S=class extends R.$Sc{constructor(a,n,i,t,r){super(),this.b=a,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(a,n,i,t,r,o,v,w,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${o}.`),!this.a.has(a)){const $=new m(this.b,this.c,this.g,this.f,this.h);this.B($),this.a.set(a,$),$.onTunnelClosed(async()=>{(await $.tunnels).length===0&&($.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(n,i,t,r,o,v,w,u)}};e.$a8b=S,e.$a8b=S=ye([Y(0,l.$Zk),Y(1,C.$0i),Y(2,E.$pj),Y(3,d.$3k),Y(4,g.$ji)],S)}),define(oe[276],ae([0,1,36,38,8,2,23,10,18,3,42,147,204,205,196,197,262,187,189,20,209,95,220,96,215,14,114,247,29,97,188,122,98,11,199,200,69,4,195,71,73,225,7,201,102,24,57,21,107,22,108,109,110,45,228,81,111,25,79,254,238,239,82,253,257,258,259,58,252,241,106,219,77,267,214,229,28,230,5,231,190,207,206,80,246,17,51,203,56,251,227,242,105,256,265,9,202,101,249,245,216,184,55,260,248,72,250,104,266,182,112,240,217]),function(te,e,I,L,A,N,D,R,k,g,C,E,b,l,d,p,y,f,c,h,m,S,s,a,n,i,t,r,o,v,w,u,$,j,M,U,z,q,Z,X,x,H,Q,J,W,ee,ne,_,ie,K,B,P,O,T,F,V,G,re,ce,ue,he,$e,de,we,Ee,Ie,Le,Te,le,ge,be,ke,Pe,Ue,je,ze,Fe,se,fe,me,pe,Se,Re,Ce,De,Oe,Ne,Me,Be,qe,Ve,_e,ut,vt,Et,St,kt,ft,Ct,Pt,Rt,It,Dt,Ot,jt,dt,At,gt,Nt,Lt,$t,Mt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends N.$Sc{constructor(ve){super(),this.f=ve,this.a=this.B(new E.$wT(this)),this.b=void 0,this.c=this.B(new g.$Nd),this.g()}g(){let ve=!1;const Ae=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,E.$xT)(process.parentPort,it.$m7b.exit,Ae)}async init(){const ve=await this.h();(0,re.$Agb)(),ve.invokeFunction(Ae=>{const Xe=Ae.get(Q.$0i),We=Ae.get(K.$cl),Ke=Ae.get(Oe.$Kk);Xe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ae),this.m(Xe),this.n(We,Ke),this.B(Ke.onDidChangeProfiles(()=>this.n(We,Ke)))}),this.B((0,N.$Pc)(ve.createInstance(b.$D8b,this.f.codeCachePath),ve.createInstance(l.$E8b),ve.createInstance(y.$H8b),ve.createInstance(p.$G8b),ve.createInstance(d.$F8b),ve.createInstance(Et.$88b),ve.createInstance(_e.$Z8b),ve.createInstance(Mt.$h9b,this.c.event)))}async h(){const ve=new X.$Nh,Ae={_serviceBrand:void 0,...W.default};ve.set(ee.$pj,Ae);const Xe=new C.$xh(He=>He==="main"),We=new dt.$h8b(this.a,Xe);ve.set(dt.$g8b,We);const Ke=this.f.policiesData?new Me.$P7b(this.f.policiesData,We.getChannel("policy")):new Be.$kn;ve.set(Be.$in,Ke);const Ge=new Lt.$jm(this.f.args,Ae);ve.set(i.$Xh,Ge);const xe=new J.$_q(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),We.getChannel("logger"));ve.set(Q.$$i,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ct=this.B(new Q.$fj(st.getLevel())),Je=this.B(new kt.$EN(st,[ct]));ve.set(Q.$0i,Je),this.b=this.B(new ft.$08b(Je)),ve.set(ft.$98b,this.b);const Qe=this.B(new M.$Op(Je));ve.set(j.$$j,Qe);const lt=this.B(new U.$bq(Je));Qe.registerProvider(D.Schemas.file,lt);const rt=new se.$Ar(Qe);ve.set(Fe.$Ik,rt);const Ye=this.B(new qe.$LN(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));ve.set(Oe.$Kk,Ye);const ht=this.B(new me.$f8b(D.Schemas.file,this.B(new pe.$nN(We.getChannel(pe.$mN),{pathCaseSensitive:fe.$l})),D.Schemas.vscodeUserData,Ye,rt,Je));Qe.registerProvider(D.Schemas.vscodeUserData,ht);const Ze=this.B(new m.$Kn(Ye.defaultProfile.settingsResource,Qe,Ke,Je));ve.set(h.$ji,Ze);const et=new At.$d9b(void 0,{defaultProfile:Ye.defaultProfile,currentProfile:Ye.defaultProfile},We,Ge);ve.set(_.$7o,et),this.B((0,N.$Qc)(()=>et.flush())),await Promise.all([Ze.initialize(),et.initialize()]);const bt=new Rt.$Xq(We.getChannel("request"));ve.set(ne.$To,bt),ve.set(f.$I8b,new z.$Mh(c.$J8b,void 0,!1)),ve.set(Re.$WE,new z.$Mh(Se.$Y8b,void 0,!1));const wt=C.ProxyChannel.toService(We.getChannel("nativeHost"));ve.set(Dt.$X6b,wt),ve.set(a.$On,new z.$Mh(n.$TN,void 0,!0));const Tt=this.B(new ge.$M7b(wt)),Ut=new C.$xh(He=>Tt.getActiveClientId().then(at=>He===at));ve.set($.$HVb,new It.$_8b(this.a.getChannel("extensionRecommendationNotification",Ut)));let ot;const tt=[],yt=(0,T.$xo)(Ae,Ze);if((0,T.$so)(Ae,Ge)){const He=new P.$P4b(Je,xe,Ge,Ae);if(tt.push(He),!(0,T.$to)(Ae,Ge)&&Ae.aiConfig?.ariaKey){const at=new Ve.$sN(bt,yt,"monacoworkbench",null,Ae.aiConfig.ariaKey);this.B((0,N.$Qc)(()=>at.flush())),tt.push(at)}ot=new O.$2q({appenders:tt,commonProperties:(0,ie.$io)((0,I.release)(),(0,I.hostname)(),process.arch,Ae.commit,Ae.version,this.f.machineId,this.f.sqmId,yt),sendErrorTelemetry:!0,piiPaths:(0,T.$yo)(Ge)},Ze,Ae)}else{ot=T.$mo;const He=T.$qo;tt.push(He)}this.a.registerChannel("telemetryAppender",new B.$r7b(tt)),ve.set(K.$cl,ot);const zt=new F.$K8b(Ze,ot,Je,xe,Ge,Ae);ve.set(K.$dl,zt),ve.set(Ne.$vp,new z.$Mh(Pt.$DN,void 0,!0)),ve.set(Ce.$zp,new z.$Mh(De.$Q7b,void 0,!0)),ve.set(v.$fp,new z.$Mh(v.$gp,void 0,!0)),ve.set(u.$Jp,new z.$Mh(u.$Kp,void 0,!0)),ve.set(o.$$n,new z.$Mh(r.$dp,void 0,!0)),ve.set(o.$eo,new z.$Mh(jt.$c9b,void 0,!1)),ve.set(x.$Tq,new z.$Mh(H.$Vq,void 0,!1)),ve.set(S.$qm,new z.$Mh(s.$Hr,void 0,!1)),ve.set(ce.$CCb,new z.$Mh(ce.$DCb,void 0,!0)),ve.set(re.$Vgb,new z.$Mh($e.$OEb,void 0,!0)),ve.set(re.$Ugb,new he.$N8b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ve.set(o.$do,new z.$Mh(t.$ACb,void 0,!1)),ve.set(G.$MEb,new z.$Mh(G.$NEb,void 0,!0)),ve.set(V.$Xu,new z.$Mh(V.$Yu)),ve.set(re.$Fgb,new z.$Mh(Le.$XDb,void 0,!0)),ve.set(re.$Ggb,new z.$Mh(Le.$ZDb,void 0,!0)),ve.set(de.$tgb,new z.$Mh(de.$vgb,void 0,!0)),ve.set(re.$Hgb,new z.$Mh(ue.$r5b,void 0,!1)),ve.set(re.$Qgb,new z.$Mh(we.$g5b,void 0,!0)),ve.set(re.$Rgb,new z.$Mh(Ee.$w5b,void 0,!1)),ve.set(Te.$bDb,new z.$Mh(le.$U8b,void 0,!0)),ve.set(re.$Sgb,new z.$Mh(vt.$95b,void 0,!0)),ve.set(be.$3k,new z.$Mh(ke.$c8b,void 0,!1));const pt=new gt.$1k;return ve.set(gt.$Zk,pt),pt.register(0,Nt.$e9b),ve.set(Pe.$$u,new z.$Mh(Ue.$a8b)),ve.set(je.$V8b,new z.$Mh(ze.$X8b)),ve.set(ut.$18b,new z.$Mh(Ct.$$8b)),ve.set($t.$f9b,new z.$Mh($t.$g9b)),new Z.$eq(ve)}j(ve){const Ae=this.B(new N.$Rc),Xe=new w.$ip(ve.get(o.$ao),()=>null);this.a.registerChannel("extensions",Xe);const We=C.ProxyChannel.fromService(ve.get(x.$Tq),Ae);this.a.registerChannel("languagePacks",We);const Ke=C.ProxyChannel.fromService(ve.get(S.$qm),Ae);this.a.registerChannel("diagnostics",Ke);const Ge=new w.$kp(ve.get(o.$eo));this.a.registerChannel("extensionTipsService",Ge);const xe=C.ProxyChannel.fromService(ve.get(f.$I8b),Ae);this.a.registerChannel("checksum",xe);const st=C.ProxyChannel.fromService(ve.get(Re.$WE),Ae);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$O8b(ve.get(de.$tgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=C.ProxyChannel.fromService(ve.get(K.$dl),Ae);this.a.registerChannel("customEndpointTelemetry",Je);const Qe=new he.$P8b(ve.get(ce.$CCb));this.a.registerChannel("userDataSyncAccount",Qe);const lt=new he.$Q8b(ve.get(re.$Fgb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$S8b(ve.get(re.$Rgb),ve.get(Oe.$Kk),ve.get(Q.$0i));this.a.registerChannel("userDataSync",rt);const Ye=this.B(ve.get(q.$Oh).createInstance(Ot.$b9b)),ht=new he.$L8b(Ye);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(ve.get(re.$Sgb),Ae));const Ze=C.ProxyChannel.fromService(ve.get(je.$V8b),Ae);this.a.registerChannel(je.$W8b,Ze);const et=C.ProxyChannel.fromService(ve.get(ut.$18b),Ae);this.a.registerChannel("remoteTunnel",et)}m(ve){process.on("uncaughtException",Ae=>(0,A.$1)(Ae)),process.on("unhandledRejection",Ae=>(0,A.$1)(Ae)),(0,A.setUnexpectedErrorHandler)(Ae=>{const Xe=(0,L.$Ai)(Ae,!0);Xe&&ve.error(`[uncaught exception in sharedProcess]: ${Xe}`)})}n(ve,Ae){ve.publicLog2("profilesInfo",{count:Ae.profiles.length})}handledClientConnection(ve){if(ve.data!==it.$o7b.response)return!1;const Ae=(0,k.$Ob)(ve.ports);return Ae?(this.c.fire(Ae),!0):!1}}async function mt(nt){const ve=new Ft(nt);process.parentPort.postMessage(it.$m7b.ipcReady),await ve.init(),process.parentPort.postMessage(it.$m7b.initDone)}e.main=mt,process.parentPort.once("message",nt=>{mt(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c36b92c82064882a228487040187cfc13669c0f/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
