/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function($e){for(var e=[],C=0,F=$e.length;C<F;C++)e[C]=De[$e[C]];return e};define(De[156],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class C{static get(){const d=new Map,L=new Map,A=new Map,$=new Map;function E(y,k){y.has(k.detail)||y.set(k.detail,-k.timestamp)}function v(y,k){const p=y.get(k.detail);p&&(p>=0||y.set(k.detail,p+k.timestamp))}let R=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(R=$e.getStats().slice(0).sort((y,k)=>y.timestamp-k.timestamp));for(const y of R)switch(y.type){case 10:E(d,y);break;case 11:case 12:v(d,y);break;case 21:E(L,y);break;case 22:v(L,y);break;case 33:E(A,y);break;case 34:v(A,y);break;case 31:E($,y);break;case 32:v($,y);break}let I=0;A.forEach(y=>I+=y);function w(y){const k=[];return y.forEach((p,u)=>k.push([u,p])),k}return{amdLoad:w(d),amdInvoke:w(L),nodeRequire:w(A),nodeEval:w($),nodeRequireTotal:I}}static toMarkdownTable(d,L){let A="";const $=[];return d.forEach((E,v)=>{$[v]=E.length}),L.forEach(E=>{E.forEach((v,R)=>{typeof v>"u"&&(v=E[R]="-");const I=v.toString().length;$[R]=Math.max(I,$[R])})}),d.forEach((E,v)=>{A+=`| ${E+" ".repeat($[v]-E.toString().length)} `}),A+=`|
`,d.forEach((E,v)=>{A+=`| ${"-".repeat($[v])} `}),A+=`|
`,L.forEach(E=>{E.forEach((v,R)=>{typeof v<"u"&&(A+=`| ${v+" ".repeat($[R]-v.toString().length)} `)}),A+=`|
`}),A}}e.$U=C}),define(De[118],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function C(p,u,o){const r=F(p,u);if(r!==-1)return p[r]}e.$fb=C;function F(p,u,o=p.length-1){for(let r=o;r>=0;r--){const s=p[r];if(u(s))return r}return-1}e.$gb=F;function d(p,u){const o=L(p,u);return o===-1?void 0:p[o]}e.$hb=d;function L(p,u,o=0,r=p.length){let s=o,m=r;for(;s<m;){const h=Math.floor((s+m)/2);u(p[h])?s=h+1:m=h}return s-1}e.$ib=L;function A(p,u){const o=$(p,u);return o===p.length?void 0:p[o]}e.$jb=A;function $(p,u,o=0,r=p.length){let s=o,m=r;for(;s<m;){const h=Math.floor((s+m)/2);u(p[h])?m=h:s=h+1}return s}e.$kb=$;function E(p,u,o=0,r=p.length){const s=$(p,u,o,r);return s===p.length?-1:s}e.$lb=E;class v{static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if(v.assertInvariants){if(this.d){for(const r of this.e)if(this.d(r)&&!u(r))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const o=L(this.e,u,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=v;function R(p,u){if(p.length===0)return;let o=p[0];for(let r=1;r<p.length;r++){const s=p[r];u(s,o)>0&&(o=s)}return o}e.$nb=R;function I(p,u){if(p.length===0)return;let o=p[0];for(let r=1;r<p.length;r++){const s=p[r];u(s,o)>=0&&(o=s)}return o}e.$ob=I;function w(p,u){return R(p,(o,r)=>-u(o,r))}e.$pb=w;function y(p,u){if(p.length===0)return-1;let o=0;for(let r=1;r<p.length;r++){const s=p[r];u(s,p[o])>0&&(o=r)}return o}e.$qb=y;function k(p,u){for(const o of p){const r=u(o);if(r!==void 0)return r}}e.$rb=k}),define(De[74],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function C(A,$){const E=Object.create(null);for(const v of A){const R=$(v);let I=E[R];I||(I=E[R]=[]),I.push(v)}return E}e.$J=C;function F(A,$){const E=[],v=[];for(const R of A)$.has(R)||E.push(R);for(const R of $)A.has(R)||v.push(R);return{removed:E,added:v}}e.$K=F;function d(A,$){const E=[],v=[];for(const[R,I]of A)$.has(R)||E.push(I);for(const[R,I]of $)A.has(R)||v.push(I);return{removed:E,added:v}}e.$L=d;function L(A,$){const E=new Set;for(const v of $)A.has(v)&&E.add(v);return E}e.$M=L}),define(De[57],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function C(A){return($,E,v)=>{let R=null,I=null;if(typeof v.value=="function"?(R="value",I=v.value):typeof v.get=="function"&&(R="get",I=v.get),!I)throw new Error("not supported");v[R]=A(I,E)}}function F(A,$,E){let v=null,R=null;if(typeof E.value=="function"?(v="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(v="get",R=E.get),!R)throw new Error("not supported");const I=`$memoize$${$}`;E[v]=function(...w){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,w)}),this[I]}}e.$hh=F;function d(A,$,E){return C((v,R)=>{const I=`$debounce$${R}`,w=`$debounce$result$${R}`;return function(...y){this[w]||(this[w]=E?E():void 0),clearTimeout(this[I]),$&&(this[w]=$(this[w],...y),y=[this[w]]),this[I]=setTimeout(()=>{v.apply(this,y),this[w]=E?E():void 0},A)}})}e.$ih=d;function L(A,$,E){return C((v,R)=>{const I=`$throttle$timer$${R}`,w=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,k=`$throttle$pending$${R}`;return function(...p){if(this[w]||(this[w]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),$&&(this[w]=$(this[w],...p)),this[k])return;const u=this[y]+A;u<=Date.now()?(this[y]=Date.now(),v.apply(this,[this[w]]),this[w]=E?E():void 0):(this[k]=!0,this[I]=setTimeout(()=>{this[k]=!1,this[y]=Date.now(),v.apply(this,[this[w]]),this[w]=E?E():void 0},u-Date.now()))}})}e.$jh=L}),define(De[9],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?s.isErrorNoTelemetry(t)?new s(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=C,e.$X=new C;function F(h){e.$X.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=F;function d(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=d;function L(h){v(h)||e.$X.onUnexpectedError(h)}e.$1=L;function A(h){v(h)||e.$X.onUnexpectedExternalError(h)}e.$2=A;function $(h){if(h instanceof Error){const{name:t,message:n}=h,c=h.stacktrace||h.stack;return{$isError:!0,name:t,message:n,stack:c,noTelemetry:s.isErrorNoTelemetry(h)}}return h}e.$3=$;const E="Canceled";function v(h){return h instanceof R?!0:h instanceof Error&&h.name===E&&h.message===E}e.$4=v;class R extends Error{constructor(){super(E),this.name=this.message}}e.$5=R;function I(){const h=new Error(E);return h.name=h.message,h}e.$6=I;function w(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$7=w;function y(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$8=y;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function p(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$0=p;class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=u;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class r extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=r;class s extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof s)return t;const n=new s;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=s;class m extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$cb=m}),define(De[19],Ce([1,0,9,118]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function d(Y,_=0){return Y[Y.length-(1+_)]}e.$sb=d;function L(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.$tb=L;function A(Y,_,x=(pe,ue)=>pe===ue){if(Y===_)return!0;if(!Y||!_||Y.length!==_.length)return!1;for(let pe=0,ue=Y.length;pe<ue;pe++)if(!x(Y[pe],_[pe]))return!1;return!0}e.$ub=A;function $(Y,_){const x=Y.length-1;_<x&&(Y[_]=Y[x]),Y.pop()}e.$vb=$;function E(Y,_,x){return v(Y.length,pe=>x(Y[pe],_))}e.$wb=E;function v(Y,_){let x=0,pe=Y-1;for(;x<=pe;){const ue=(x+pe)/2|0,fe=_(ue);if(fe<0)x=ue+1;else if(fe>0)pe=ue-1;else return ue}return-(x+1)}e.$xb=v;function R(Y,_,x){if(Y=Y|0,Y>=_.length)throw new TypeError("invalid index");const pe=_[Math.floor(_.length*Math.random())],ue=[],fe=[],te=[];for(const de of _){const be=x(de,pe);be<0?ue.push(de):be>0?fe.push(de):te.push(de)}return Y<ue.length?R(Y,ue,x):Y<ue.length+te.length?te[0]:R(Y-(ue.length+te.length),fe,x)}e.$yb=R;function I(Y,_){const x=[];let pe;for(const ue of Y.slice(0).sort(_))!pe||_(pe[0],ue)!==0?(pe=[ue],x.push(pe)):pe.push(ue);return x}e.$zb=I;function*w(Y,_){let x,pe;for(const ue of Y)pe!==void 0&&_(pe,ue)?x.push(ue):(x&&(yield x),x=[ue]),pe=ue;x&&(yield x)}e.$Ab=w;function y(Y,_){for(let x=0;x<=Y.length;x++)_(x===0?void 0:Y[x-1],x===Y.length?void 0:Y[x])}e.$Bb=y;function k(Y,_){for(let x=0;x<Y.length;x++)_(x===0?void 0:Y[x-1],Y[x],x+1===Y.length?void 0:Y[x+1])}e.$Cb=k;function p(Y,_,x){const pe=[];function ue(de,be,Pe){if(be===0&&Pe.length===0)return;const z=pe[pe.length-1];z&&z.start+z.deleteCount===de?(z.deleteCount+=be,z.toInsert.push(...Pe)):pe.push({start:de,deleteCount:be,toInsert:Pe})}let fe=0,te=0;for(;;){if(fe===Y.length){ue(fe,0,_.slice(te));break}if(te===_.length){ue(fe,Y.length-fe,[]);break}const de=Y[fe],be=_[te],Pe=x(de,be);Pe===0?(fe+=1,te+=1):Pe<0?(ue(fe,1,[]),fe+=1):Pe>0&&(ue(fe,0,[be]),te+=1)}return pe}e.$Db=p;function u(Y,_,x){const pe=p(Y,_,x),ue=[],fe=[];for(const te of pe)ue.push(...Y.slice(te.start,te.start+te.deleteCount)),fe.push(...te.toInsert);return{removed:ue,added:fe}}e.$Eb=u;function o(Y,_,x){if(x===0)return[];const pe=Y.slice(0,x).sort(_);return s(Y,_,pe,x,Y.length),pe}e.top=o;function r(Y,_,x,pe,ue){return x===0?Promise.resolve([]):new Promise((fe,te)=>{(async()=>{const de=Y.length,be=Y.slice(0,x).sort(_);for(let Pe=x,z=Math.min(x+pe,de);Pe<de;Pe=z,z=Math.min(z+pe,de)){if(Pe>x&&await new Promise(G=>setTimeout(G)),ue&&ue.isCancellationRequested)throw new C.$5;s(Y,_,be,Pe,z)}return be})().then(fe,te)})}e.$Gb=r;function s(Y,_,x,pe,ue){for(const fe=x.length;pe<ue;pe++){const te=Y[pe];if(_(te,x[fe-1])<0){x.pop();const de=(0,F.$kb)(x,be=>_(te,be)<0);x.splice(de,0,te)}}}function m(Y){return Y.filter(_=>!!_)}e.$Hb=m;function h(Y){let _=0;for(let x=0;x<Y.length;x++)Y[x]&&(Y[_]=Y[x],_+=1);Y.length=_}e.$Ib=h;function t(Y,_,x){Y.splice(x,0,Y.splice(_,1)[0])}e.$Jb=t;function n(Y){return!Array.isArray(Y)||Y.length===0}e.$Kb=n;function c(Y){return Array.isArray(Y)&&Y.length>0}e.$Lb=c;function i(Y,_=x=>x){const x=new Set;return Y.filter(pe=>{const ue=_(pe);return x.has(ue)?!1:(x.add(ue),!0)})}e.$Mb=i;function a(Y){const _=new Set;return x=>{const pe=Y(x);return _.has(pe)?!1:(_.add(pe),!0)}}e.$Nb=a;function l(Y,_){return Y.length>0?Y[0]:_}e.$Ob=l;function D(Y,_){return Y.length>0?Y[Y.length-1]:_}e.$Pb=D;function S(Y,_,x=(pe,ue)=>pe===ue){let pe=0;for(let ue=0,fe=Math.min(Y.length,_.length);ue<fe&&x(Y[ue],_[ue]);ue++)pe++;return pe}e.$Qb=S;function b(Y){return[].concat(...Y)}e.$Rb=b;function f(Y,_){let x=typeof _=="number"?Y:0;typeof _=="number"?x=Y:(x=0,_=Y);const pe=[];if(x<=_)for(let ue=x;ue<_;ue++)pe.push(ue);else for(let ue=x;ue>_;ue--)pe.push(ue);return pe}e.$Sb=f;function g(Y,_,x){return Y.reduce((pe,ue)=>(pe[_(ue)]=x?x(ue):ue,pe),Object.create(null))}e.$Tb=g;function P(Y,_){return Y.push(_),()=>N(Y,_)}e.$Ub=P;function N(Y,_){const x=Y.indexOf(_);if(x>-1)return Y.splice(x,1),_}e.$Vb=N;function O(Y,_,x){const pe=Y.slice(0,_),ue=Y.slice(_);return pe.concat(x,ue)}e.$Wb=O;function M(Y,_){let x;if(typeof _=="number"){let pe=_;x=()=>{const ue=Math.sin(pe++)*179426549;return ue-Math.floor(ue)}}else x=Math.random;for(let pe=Y.length-1;pe>0;pe-=1){const ue=Math.floor(x()*(pe+1)),fe=Y[pe];Y[pe]=Y[ue],Y[ue]=fe}}e.$Xb=M;function j(Y,_){const x=Y.indexOf(_);x>-1&&(Y.splice(x,1),Y.unshift(_))}e.$Yb=j;function U(Y,_){const x=Y.indexOf(_);x>-1&&(Y.splice(x,1),Y.push(_))}e.$Zb=U;function T(Y,_){for(const x of _)Y.push(x)}e.$1b=T;function K(Y,_){return Array.isArray(Y)?Y.map(_):_(Y)}e.$2b=K;function q(Y){return Array.isArray(Y)?Y:[Y]}e.$3b=q;function ge(Y){return Y[Math.floor(Math.random()*Y.length)]}e.$4b=ge;function ee(Y,_,x){const pe=X(Y,_),ue=Y.length,fe=x.length;Y.length=ue+fe;for(let te=ue-1;te>=pe;te--)Y[te+fe]=Y[te];for(let te=0;te<fe;te++)Y[te+pe]=x[te]}e.$5b=ee;function Q(Y,_,x,pe){const ue=X(Y,_);let fe=Y.splice(ue,x);return fe===void 0&&(fe=[]),ee(Y,ue,pe),fe}e.$6b=Q;function X(Y,_){return _<0?Math.max(_+Y.length,0):Math.min(_,Y.length)}var ae;(function(Y){function _(fe){return fe<0}Y.isLessThan=_;function x(fe){return fe<=0}Y.isLessThanOrEqual=x;function pe(fe){return fe>0}Y.isGreaterThan=pe;function ue(fe){return fe===0}Y.isNeitherLessOrGreaterThan=ue,Y.greaterThan=1,Y.lessThan=-1,Y.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function ie(Y,_){return(x,pe)=>_(Y(x),Y(pe))}e.$7b=ie;function ce(...Y){return(_,x)=>{for(const pe of Y){const ue=pe(_,x);if(!ae.isNeitherLessOrGreaterThan(ue))return ue}return ae.neitherLessOrGreaterThan}}e.$8b=ce;const we=(Y,_)=>Y-_;e.$9b=we;const H=(Y,_)=>(0,e.$9b)(Y?1:0,_?1:0);e.$0b=H;function B(Y){return(_,x)=>-Y(_,x)}e.$$b=B;class J{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let x=this.c;for(;x<this.g.length&&_(this.g[x]);)x++;const pe=x===this.c?null:this.g.slice(this.c,x);return this.c=x,pe}takeFromEndWhile(_){let x=this.d;for(;x>=0&&_(this.g[x]);)x--;const pe=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,pe}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const x=this.g.slice(this.c,this.c+_);return this.c+=_,x}}e.$_b=J;class re{static{this.empty=new re(_=>{})}constructor(_){this.iterate=_}forEach(_){this.iterate(x=>(_(x),!0))}toArray(){const _=[];return this.iterate(x=>(_.push(x),!0)),_}filter(_){return new re(x=>this.iterate(pe=>_(pe)?x(pe):!0))}map(_){return new re(x=>this.iterate(pe=>x(_(pe))))}some(_){let x=!1;return this.iterate(pe=>(x=_(pe),!x)),x}findFirst(_){let x;return this.iterate(pe=>_(pe)?(x=pe,!1):!0),x}findLast(_){let x;return this.iterate(pe=>(_(pe)&&(x=pe),!0)),x}findLastMaxBy(_){let x,pe=!0;return this.iterate(ue=>((pe||ae.isGreaterThan(_(ue,x)))&&(pe=!1,x=ue),!0)),x}}e.$ac=re}),define(De[58],Ce([1,0,9]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function F(E,v){if(!E)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=F;function d(E,v="Unreachable"){throw new Error(v)}e.$4c=d;function L(E){if(!E)throw new C.$cb("Assertion Failed")}e.$5c=L;function A(E){if(!E()){debugger;E(),(0,C.$1)(new C.$cb("Assertion Failed"))}}e.$6c=A;function $(E,v){let R=0;for(;R<E.length-1;){const I=E[R],w=E[R+1];if(!v(I,w))return!1;R++}return!0}e.$7c=$}),define(De[75],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function C(F){const d=this;let L=!1,A;return function(){return L||(L=!0,A=F.apply(d,arguments)),A}}e.$db=C}),define(De[119],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$mM=void 0;class C{constructor(d){this.a=d,this.b=0}nextId(){return this.a+ ++this.b}}e.$mM=C,e.$nM=new C("id#")}),define(De[51],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(F){function d(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}F.is=d;const L=Object.freeze([]);function A(){return L}F.empty=A;function*$(h){yield h}F.single=$;function E(h){return d(h)?h:$(h)}F.wrap=E;function v(h){return h||L}F.from=v;function*R(h){for(let t=h.length-1;t>=0;t--)yield h[t]}F.reverse=R;function I(h){return!h||h[Symbol.iterator]().next().done===!0}F.isEmpty=I;function w(h){return h[Symbol.iterator]().next().value}F.first=w;function y(h,t){for(const n of h)if(t(n))return!0;return!1}F.some=y;function k(h,t){for(const n of h)if(t(n))return n}F.find=k;function*p(h,t){for(const n of h)t(n)&&(yield n)}F.filter=p;function*u(h,t){let n=0;for(const c of h)yield t(c,n++)}F.map=u;function*o(...h){for(const t of h)for(const n of t)yield n}F.concat=o;function r(h,t,n){let c=n;for(const i of h)c=t(c,i);return c}F.reduce=r;function*s(h,t,n=h.length){for(t<0&&(t+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);t<n;t++)yield h[t]}F.slice=s;function m(h,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,h];const c=h[Symbol.iterator]();for(let i=0;i<t;i++){const a=c.next();if(a.done)return[n,F.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return c}}]}F.consume=m})(C||(e.Iterable=C={}))}),define(De[157],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var d;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(d||(e.ParseErrorCode=d={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(t,n=!1){let c=0;const i=t.length;let a="",l=0,D=16,S=0;function b(j){let U=0,T=0;for(;U<j;){const K=t.charCodeAt(c);if(K>=48&&K<=57)T=T*16+K-48;else if(K>=65&&K<=70)T=T*16+K-65+10;else if(K>=97&&K<=102)T=T*16+K-97+10;else break;c++,U++}return U<j&&(T=-1),T}function f(j){c=j,a="",l=0,D=16,S=0}function g(){const j=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&v(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&v(t.charCodeAt(c)))for(c++;c<t.length&&v(t.charCodeAt(c));)c++;else return S=3,t.substring(j,c);let U=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&v(t.charCodeAt(c))){for(c++;c<t.length&&v(t.charCodeAt(c));)c++;U=c}else S=3;return t.substring(j,U)}function P(){let j="",U=c;for(;;){if(c>=i){j+=t.substring(U,c),S=2;break}const T=t.charCodeAt(c);if(T===34){j+=t.substring(U,c),c++;break}if(T===92){if(j+=t.substring(U,c),c++,c>=i){S=2;break}switch(t.charCodeAt(c++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const q=b(4);q>=0?j+=String.fromCharCode(q):S=4;break}default:S=5}U=c;continue}if(T>=0&&T<=31)if(E(T)){j+=t.substring(U,c),S=2;break}else S=6;c++}return j}function N(){if(a="",S=0,l=c,c>=i)return l=i,D=17;let j=t.charCodeAt(c);if($(j)){do c++,a+=String.fromCharCode(j),j=t.charCodeAt(c);while($(j));return D=15}if(E(j))return c++,a+=String.fromCharCode(j),j===13&&t.charCodeAt(c)===10&&(c++,a+=`
`),D=14;switch(j){case 123:return c++,D=1;case 125:return c++,D=2;case 91:return c++,D=3;case 93:return c++,D=4;case 58:return c++,D=6;case 44:return c++,D=5;case 34:return c++,a=P(),D=10;case 47:{const U=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<i&&!E(t.charCodeAt(c));)c++;return a=t.substring(U,c),D=12}if(t.charCodeAt(c+1)===42){c+=2;const T=i-1;let K=!1;for(;c<T;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,K=!0;break}c++}return K||(c++,S=1),a=t.substring(U,c),D=13}return a+=String.fromCharCode(j),c++,D=16}case 45:if(a+=String.fromCharCode(j),c++,c===i||!v(t.charCodeAt(c)))return D=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=g(),D=11;default:for(;c<i&&O(j);)c++,j=t.charCodeAt(c);if(l!==c){switch(a=t.substring(l,c),a){case"true":return D=8;case"false":return D=9;case"null":return D=7}return D=16}return a+=String.fromCharCode(j),c++,D=16}}function O(j){if($(j)||E(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let j;do j=N();while(j>=12&&j<=15);return j}return{setPosition:f,getPosition:()=>c,scan:n?M:N,getToken:()=>D,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>c-l,getTokenError:()=>S}}e.$Um=A;function $(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,n){const c=[],i=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function S(b,f,g,P){l.value=b,l.offset=f,l.length=g,l.type=P,l.colonOffset=void 0,a=l}try{s(t,{onObjectBegin:(b,f)=>{if(n<=b)throw i;a=void 0,D=n>b,c.push("")},onObjectProperty:(b,f,g)=>{if(n<f||(S(b,f,g,"property"),c[c.length-1]=b,n<=f+g))throw i},onObjectEnd:(b,f)=>{if(n<=b)throw i;a=void 0,c.pop()},onArrayBegin:(b,f)=>{if(n<=b)throw i;a=void 0,c.push(0)},onArrayEnd:(b,f)=>{if(n<=b)throw i;a=void 0,c.pop()},onLiteralValue:(b,f,g)=>{if(n<f||(S(b,f,g,h(b)),n<=f+g))throw i},onSeparator:(b,f,g)=>{if(n<=f)throw i;if(b===":"&&a&&a.type==="property")a.colonOffset=f,D=!1,a=void 0;else if(b===","){const P=c[c.length-1];typeof P=="number"?c[c.length-1]=P+1:(D=!0,c[c.length-1]=""),a=void 0}}})}catch(b){if(b!==i)throw b}return{path:c,previousNode:a,isAtPropertyKey:D,matches:b=>{let f=0;for(let g=0;f<b.length&&g<c.length;g++)if(b[f]===c[g]||b[f]==="*")f++;else if(b[f]!=="**")return!1;return f===b.length}}}e.$Vm=I;function w(t,n=[],c=L.DEFAULT){let i=null,a=[];const l=[];function D(b){Array.isArray(a)?a.push(b):i!==null&&(a[i]=b)}return s(t,{onObjectBegin:()=>{const b={};D(b),l.push(a),a=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const b=[];D(b),l.push(a),a=b,i=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:D,onError:(b,f,g)=>{n.push({error:b,offset:f,length:g})}},c),a[0]}e.$Wm=w;function y(t,n=[],c=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(b){i.type==="property"&&(i.length=b-i.offset,i=i.parent)}function l(b){return i.children.push(b),b}s(t,{onObjectBegin:b=>{i=l({type:"object",offset:b,length:-1,parent:i,children:[]})},onObjectProperty:(b,f,g)=>{i=l({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:b,offset:f,length:g,parent:i})},onObjectEnd:(b,f)=>{i.length=b+f-i.offset,i=i.parent,a(b+f)},onArrayBegin:(b,f)=>{i=l({type:"array",offset:b,length:-1,parent:i,children:[]})},onArrayEnd:(b,f)=>{i.length=b+f-i.offset,i=i.parent,a(b+f)},onLiteralValue:(b,f,g)=>{l({type:h(b),offset:f,length:g,parent:i,value:b}),a(f+g)},onSeparator:(b,f,g)=>{i.type==="property"&&(b===":"?i.colonOffset=f:b===","&&a(f))},onError:(b,f,g)=>{n.push({error:b,offset:f,length:g})}},c);const S=i.children[0];return S&&delete S.parent,S}e.$Xm=y;function k(t,n){if(!t)return;let c=t;for(const i of n)if(typeof i=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let a=!1;for(const l of c.children)if(Array.isArray(l.children)&&l.children[0].value===i){c=l.children[1],a=!0;break}if(!a)return}else{const a=i;if(c.type!=="array"||a<0||!Array.isArray(c.children)||a>=c.children.length)return;c=c.children[a]}return c}e.$Ym=k;function p(t){if(!t.parent||!t.parent.children)return[];const n=p(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;n.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&n.push(c)}return n}e.$Zm=p;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const n=Object.create(null);for(const c of t.children){const i=c.children[1];i&&(n[c.children[0].value]=u(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$1m=u;function o(t,n,c=!1){return n>=t.offset&&n<t.offset+t.length||c&&n===t.offset+t.length}e.$2m=o;function r(t,n,c=!1){if(o(t,n,c)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const l=r(i[a],n,c);if(l)return l}return t}}e.$3m=r;function s(t,n,c=L.DEFAULT){const i=A(t,!1);function a(ie){return ie?()=>ie(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(ie){return ie?ce=>ie(ce,i.getTokenOffset(),i.getTokenLength()):()=>!0}const D=a(n.onObjectBegin),S=l(n.onObjectProperty),b=a(n.onObjectEnd),f=a(n.onArrayBegin),g=a(n.onArrayEnd),P=l(n.onLiteralValue),N=l(n.onSeparator),O=a(n.onComment),M=l(n.onError),j=c&&c.disallowComments,U=c&&c.allowTrailingComma;function T(){for(;;){const ie=i.scan();switch(i.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:j||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(ie){case 12:case 13:j?K(10):O();break;case 16:K(1);break;case 15:case 14:break;default:return ie}}}function K(ie,ce=[],we=[]){if(M(ie),ce.length+we.length>0){let H=i.getToken();for(;H!==17;){if(ce.indexOf(H)!==-1){T();break}else if(we.indexOf(H)!==-1)break;H=T()}}}function q(ie){const ce=i.getTokenValue();return ie?P(ce):S(ce),T(),!0}function ge(){switch(i.getToken()){case 11:{let ie=0;try{ie=JSON.parse(i.getTokenValue()),typeof ie!="number"&&(K(2),ie=0)}catch{K(2)}P(ie);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return T(),!0}function ee(){return i.getToken()!==10?(K(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(N(":"),T(),ae()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Q(){D(),T();let ie=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ie||K(4,[],[]),N(","),T(),i.getToken()===2&&U)break}else ie&&K(6,[],[]);ee()||K(4,[],[2,5]),ie=!0}return b(),i.getToken()!==2?K(7,[2],[]):T(),!0}function X(){f(),T();let ie=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ie||K(4,[],[]),N(","),T(),i.getToken()===4&&U)break}else ie&&K(6,[],[]);ae()||K(4,[],[4,5]),ie=!0}return g(),i.getToken()!==4?K(8,[4],[]):T(),!0}function ae(){switch(i.getToken()){case 3:return X();case 1:return Q();case 10:return q(!0);default:return ge()}}return T(),i.getToken()===17?c.allowEmptyContent?!0:(K(4,[],[]),!1):ae()?(i.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.$4m=s;function m(t,n){const c=A(t),i=[];let a,l=0,D;do switch(D=c.getPosition(),a=c.scan(),a){case 12:case 13:case 17:l!==D&&i.push(t.substring(l,D)),n!==void 0&&i.push(c.getTokenValue().replace(/[^\r\n]/g,n)),l=c.getPosition();break}while(a!==17);return i.join("")}e.$5m=m;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=h}),define(De[47],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class C{constructor(d){this.d=d,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(d){this.c=d}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=C}),define(De[76],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(L){this.element=L,this.next=C.Undefined,this.prev=C.Undefined}}class F{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let L=this.a;for(;L!==C.Undefined;){const A=L.next;L.prev=C.Undefined,L.next=C.Undefined,L=A}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,A){const $=new C(L);if(this.a===C.Undefined)this.a=$,this.b=$;else if(A){const v=this.b;this.b=$,$.prev=v,v.next=$}else{const v=this.a;this.a=$,$.next=v,v.prev=$}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e($))}}shift(){if(this.a!==C.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==C.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==C.Undefined&&L.next!==C.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===C.Undefined&&L.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):L.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):L.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==C.Undefined;)yield L.element,L=L.next}}e.$2c=F}),define(De[28],Ce([1,0]),function($e,e){"use strict";var C,F,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function L(r,s,m){let h=r.get(s);return h===void 0&&(h=m,r.set(s,h)),h}e.$xc=L;function A(r){const s=[];return r.forEach((m,h)=>{s.push(`${h} => ${m}`)}),`Map(${r.size}) {${s.join(", ")}}`}e.$yc=A;function $(r){const s=[];return r.forEach(m=>{s.push(m)}),`Set(${r.size}) {${s.join(", ")}}`}e.$zc=$;class E{constructor(s,m){this.uri=s,this.value=m}}function v(r){return Array.isArray(r)}class R{static{this.a=s=>s.toString()}constructor(s,m){if(this[C]="ResourceMap",s instanceof R)this.b=new Map(s.b),this.c=m??R.a;else if(v(s)){this.b=new Map,this.c=m??R.a;for(const[h,t]of s)this.set(h,t)}else this.b=new Map,this.c=s??R.a}set(s,m){return this.b.set(this.c(s),new E(s,m)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,m){typeof m<"u"&&(s=s.bind(m));for(const[h,t]of this.b)s(t.value,t.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}e.$Ac=R;class I{constructor(s,m){this[F]="ResourceSet",!s||typeof s=="function"?this.a=new R(s):(this.a=new R(m),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,m){this.a.forEach((h,t)=>s.call(m,t,t,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=I;var w;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class y{constructor(){this[d]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,m=0){const h=this.a.get(s);if(h)return m!==0&&this.j(h,m),h.value}set(s,m,h=0){let t=this.a.get(s);if(t)t.value=m,h!==0&&this.j(t,h);else{switch(t={key:s,value:m,next:void 0,previous:void 0},h){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(s,t),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const m=this.a.get(s);if(m)return this.a.delete(s),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,m){const h=this.e;let t=this.b;for(;t;){if(m?s.bind(m)(t.value,t.key,this):s(t.value,t.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const s=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(s.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:h.key,done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}values(){const s=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(s.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:h.value,done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}entries(){const s=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(s.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:[h.key,h.value],done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let m=this.b,h=this.size;for(;m&&h>s;)this.a.delete(m.key),m=m.next,h--;this.b=m,this.d=h,m&&(m.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const m=s.next,h=s.previous;if(!m||!h)throw new Error("Invalid list");m.previous=h,h.next=m}s.next=void 0,s.previous=void 0,this.e++}j(s,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(s===this.b)return;const h=s.next,t=s.previous;s===this.c?(t.next=void 0,this.c=t):(h.previous=t,t.next=h),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(m===2){if(s===this.c)return;const h=s.next,t=s.previous;s===this.b?(h.previous=void 0,this.b=h):(h.previous=t,t.next=h),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((m,h)=>{s.push([h,m])}),s}fromJSON(s){this.clear();for(const[m,h]of s)this.set(m,h)}}e.$Cc=y;class k extends y{constructor(s,m=1){super(),this.k=s,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,m=2){return super.get(s,m)}peek(s){return super.get(s,0)}set(s,m){return super.set(s,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=k;class p{constructor(){this.a=new Map}add(s){return this.a.set(s,(this.a.get(s)||0)+1),this}delete(s){let m=this.a.get(s)||0;return m===0?!1:(m--,m===0?this.a.delete(s):this.a.set(s,m),!0)}has(s){return this.a.has(s)}}e.$Ec=p;class u{constructor(s){if(this.a=new Map,this.b=new Map,s)for(const[m,h]of s)this.set(m,h)}clear(){this.a.clear(),this.b.clear()}set(s,m){this.a.set(s,m),this.b.set(m,s)}get(s){return this.a.get(s)}getKey(s){return this.b.get(s)}delete(s){const m=this.a.get(s);return m===void 0?!1:(this.a.delete(s),this.b.delete(m),!0)}forEach(s,m){this.a.forEach((h,t)=>{s.call(m,h,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=u;class o{constructor(){this.a=new Map}add(s,m){let h=this.a.get(s);h||(h=new Set,this.a.set(s,h)),h.add(m)}delete(s,m){const h=this.a.get(s);h&&(h.delete(m),h.size===0&&this.a.delete(s))}forEach(s,m){const h=this.a.get(s);h&&h.forEach(m)}get(s){const m=this.a.get(s);return m||new Set}}e.$Gc=o}),define(De[3],Ce([1,0,19,74,28,75,51]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const $=!1;let E=null;class v{constructor(){this.b=new Map}static{this.a=0}c(g){let P=this.b.get(g);return P||(P={parent:null,source:null,isSingleton:!1,value:g,idx:v.a++},this.b.set(g,P)),P}trackDisposable(g){const P=this.c(g);P.source||(P.source=new Error().stack)}setParent(g,P){const N=this.c(g);N.parent=P}markAsDisposed(g){this.b.delete(g)}markAsSingleton(g){this.c(g).isSingleton=!0}f(g,P){const N=P.get(g);if(N)return N;const O=g.parent?this.f(this.c(g.parent),P):g;return P.set(g,O),O}getTrackedDisposables(){const g=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,g).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(g=10,P){let N;if(P)N=P;else{const T=new Map,K=[...this.b.values()].filter(ge=>ge.source!==null&&!this.f(ge,T).isSingleton);if(K.length===0)return;const q=new Set(K.map(ge=>ge.value));if(N=K.filter(ge=>!(ge.parent&&q.has(ge.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function O(T){function K(ge,ee){for(;ge.length>0&&ee.some(Q=>typeof Q=="string"?Q===ge[0]:ge[0].match(Q));)ge.shift()}const q=T.source.split(`
`).map(ge=>ge.trim().replace("at ","")).filter(ge=>ge!=="");return K(q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),q.reverse()}const M=new d.$Gc;for(const T of N){const K=O(T);for(let q=0;q<=K.length;q++)M.add(K.slice(0,q).join(`
`),T)}N.sort((0,C.$7b)(T=>T.idx,C.$9b));let j="",U=0;for(const T of N.slice(0,g)){U++;const K=O(T),q=[];for(let ge=0;ge<K.length;ge++){let ee=K[ge];ee=`(shared with ${M.get(K.slice(0,ge+1).join(`
`)).size}/${N.length} leaks) at ${ee}`;const X=M.get(K.slice(0,ge).join(`
`)),ae=(0,F.$J)([...X].map(ie=>O(ie)[ge]),ie=>ie);delete ae[K[ge]];for(const[ie,ce]of Object.entries(ae))q.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${ie}`);q.unshift(ee)}j+=`


==================== Leaking disposable ${U}/${N.length}: ${T.value.constructor.name} ====================
${q.join(`
`)}
============================================================

`}return N.length>g&&(j+=`


... and ${N.length-g} more leaking disposables

`),{leaks:N,details:j}}}e.$Hc=v;function R(f){E=f}if(e.$Ic=R,$){const f="__is_disposable_tracked__";R(new class{trackDisposable(g){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[f]||console.log(P)},3e3)}setParent(g,P){if(g&&g!==t.None)try{g[f]=!0}catch{}}markAsDisposed(g){if(g&&g!==t.None)try{g[f]=!0}catch{}}markAsSingleton(g){}})}function I(f){return E?.trackDisposable(f),f}e.$Jc=I;function w(f){E?.markAsDisposed(f)}e.$Kc=w;function y(f,g){E?.setParent(f,g)}function k(f,g){if(E)for(const P of f)E.setParent(P,g)}function p(f){return E?.markAsSingleton(f),f}e.$Lc=p;function u(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.$Mc=u;function o(f){if(A.Iterable.is(f)){const g=[];for(const P of f)if(P)try{P.dispose()}catch(N){g.push(N)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.$Nc=o;function r(f){for(const g of f)u(g)&&g.dispose();return[]}e.$Oc=r;function s(...f){const g=m(()=>o(f));return k(f,g),g}e.$Pc=s;function m(f){const g=I({dispose:(0,L.$db)(()=>{w(g),f()})});return g}e.$Qc=m;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return y(g,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(g),g}delete(g){if(g){if(g===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(g),g.dispose()}}deleteAndLeak(g){g&&this.f.has(g)&&(this.f.delete(g),y(g,null))}}e.$Rc=h;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,I(this),y(this.q,this)}dispose(){w(this),this.q.dispose()}B(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(g)}}e.$Sc=t;class n{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(g){this.b||g===this.a||(this.a?.dispose(),g&&y(g,this),this.a=g)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const g=this.a;return this.a=void 0,g&&y(g,null),g}}e.$Tc=n;class c{constructor(g){this.b=g,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=c;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(g){let P=g;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,w(this))},this}}e.$Vc=i;class a{constructor(){this.a=new Map}acquire(g,...P){let N=this.a.get(g);N||(N={counter:0,object:this.b(g,...P)},this.a.set(g,N));const{object:O}=N,M=(0,L.$db)(()=>{--N.counter===0&&(this.c(g,N.object),this.a.delete(g))});return N.counter++,{object:O,dispose:M}}}e.$Wc=a;class l{constructor(g){this.a=g}async acquire(g,...P){const N=this.a.acquire(g,...P);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(O){throw N.dispose(),O}}}e.$Xc=l;class D{constructor(g){this.object=g}dispose(){}}e.$Yc=D;function S(f){const g=new h;try{f(g)}finally{g.dispose()}}e.$Zc=S;class b{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(g){return this.a.has(g)}get size(){return this.a.size}get(g){return this.a.get(g)}set(g,P,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(g)?.dispose(),this.a.set(g,P)}deleteAndDispose(g){this.a.get(g)?.dispose(),this.a.delete(g)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=b}),function($e,e){typeof define=="function"&&define.amd?define(De[158],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(_,x){for(var pe=0;pe<x.length;pe++){var ue=x[pe];ue.enumerable=ue.enumerable||!1,ue.configurable=!0,"value"in ue&&(ue.writable=!0),Object.defineProperty(_,ue.key,ue)}}function C(_,x,pe){return x&&e(_.prototype,x),pe&&e(_,pe),Object.defineProperty(_,"prototype",{writable:!1}),_}function F(_,x){if(_){if(typeof _=="string")return d(_,x);var pe=Object.prototype.toString.call(_).slice(8,-1);if(pe==="Object"&&_.constructor&&(pe=_.constructor.name),pe==="Map"||pe==="Set")return Array.from(_);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return d(_,x)}}function d(_,x){(x==null||x>_.length)&&(x=_.length);for(var pe=0,ue=new Array(x);pe<x;pe++)ue[pe]=_[pe];return ue}function L(_,x){var pe=typeof Symbol<"u"&&_[Symbol.iterator]||_["@@iterator"];if(pe)return(pe=pe.call(_)).next.bind(pe);if(Array.isArray(_)||(pe=F(_))||x&&_&&typeof _.length=="number"){pe&&(_=pe);var ue=0;return function(){return ue>=_.length?{done:!0}:{done:!1,value:_[ue++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=A();function $(_){$e.defaults=_}var E=/[&<>"']/,v=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(x){return w[x]};function k(_,x){if(x){if(E.test(_))return _.replace(v,y)}else if(R.test(_))return _.replace(I,y);return _}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(_){return _.replace(p,function(x,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var o=/(^|[^\[])\^/g;function r(_,x){_=typeof _=="string"?_:_.source,x=x||"";var pe={replace:function(fe,te){return te=te.source||te,te=te.replace(o,"$1"),_=_.replace(fe,te),pe},getRegex:function(){return new RegExp(_,x)}};return pe}var s=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(_,x,pe){if(_){var ue;try{ue=decodeURIComponent(u(pe)).replace(s,"").toLowerCase()}catch{return null}if(ue.indexOf("javascript:")===0||ue.indexOf("vbscript:")===0||ue.indexOf("data:")===0)return null}x&&!m.test(pe)&&(pe=a(x,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch{return null}return pe}var t={},n=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(_,x){t[" "+_]||(n.test(_)?t[" "+_]=_+"/":t[" "+_]=b(_,"/",!0)),_=t[" "+_];var pe=_.indexOf(":")===-1;return x.substring(0,2)==="//"?pe?x:_.replace(c,"$1")+x:x.charAt(0)==="/"?pe?x:_.replace(i,"$1")+x:_+x}var l={exec:function(){}};function D(_){for(var x=1,pe,ue;x<arguments.length;x++){pe=arguments[x];for(ue in pe)Object.prototype.hasOwnProperty.call(pe,ue)&&(_[ue]=pe[ue])}return _}function S(_,x){var pe=_.replace(/\|/g,function(te,de,be){for(var Pe=!1,z=de;--z>=0&&be[z]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ue=pe.split(/ \|/),fe=0;if(ue[0].trim()||ue.shift(),ue.length>0&&!ue[ue.length-1].trim()&&ue.pop(),ue.length>x)ue.splice(x);else for(;ue.length<x;)ue.push("");for(;fe<ue.length;fe++)ue[fe]=ue[fe].trim().replace(/\\\|/g,"|");return ue}function b(_,x,pe){var ue=_.length;if(ue===0)return"";for(var fe=0;fe<ue;){var te=_.charAt(ue-fe-1);if(te===x&&!pe)fe++;else if(te!==x&&pe)fe++;else break}return _.slice(0,ue-fe)}function f(_,x){if(_.indexOf(x[1])===-1)return-1;for(var pe=_.length,ue=0,fe=0;fe<pe;fe++)if(_[fe]==="\\")fe++;else if(_[fe]===x[0])ue++;else if(_[fe]===x[1]&&(ue--,ue<0))return fe;return-1}function g(_){_&&_.sanitize&&!_.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(_,x){if(x<1)return"";for(var pe="";x>1;)x&1&&(pe+=_),x>>=1,_+=_;return pe+_}function N(_,x,pe,ue){var fe=x.href,te=x.title?k(x.title):null,de=_[1].replace(/\\([\[\]])/g,"$1");if(_[0].charAt(0)!=="!"){ue.state.inLink=!0;var be={type:"link",raw:pe,href:fe,title:te,text:de,tokens:ue.inlineTokens(de)};return ue.state.inLink=!1,be}return{type:"image",raw:pe,href:fe,title:te,text:k(de)}}function O(_,x){var pe=_.match(/^(\s+)(?:```)/);if(pe===null)return x;var ue=pe[1];return x.split(`
`).map(function(fe){var te=fe.match(/^\s+/);if(te===null)return fe;var de=te[0];return de.length>=ue.length?fe.slice(ue.length):fe}).join(`
`)}var M=function(){function _(pe){this.options=pe||$e.defaults}var x=_.prototype;return x.space=function(ue){var fe=this.rules.block.newline.exec(ue);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},x.code=function(ue){var fe=this.rules.block.code.exec(ue);if(fe){var te=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?te:b(te,`
`)}}},x.fences=function(ue){var fe=this.rules.block.fences.exec(ue);if(fe){var te=fe[0],de=O(te,fe[3]||"");return{type:"code",raw:te,lang:fe[2]?fe[2].trim():fe[2],text:de}}},x.heading=function(ue){var fe=this.rules.block.heading.exec(ue);if(fe){var te=fe[2].trim();if(/#$/.test(te)){var de=b(te,"#");(this.options.pedantic||!de||/ $/.test(de))&&(te=de.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:te,tokens:this.lexer.inline(te)}}},x.hr=function(ue){var fe=this.rules.block.hr.exec(ue);if(fe)return{type:"hr",raw:fe[0]}},x.blockquote=function(ue){var fe=this.rules.block.blockquote.exec(ue);if(fe){var te=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},x.list=function(ue){var fe=this.rules.block.list.exec(ue);if(fe){var te,de,be,Pe,z,G,se,oe,Z,me,Ee,je,We=fe[1].trim(),_e=We.length>1,Ye={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ue&&(je=!1,!(!(fe=it.exec(ue))||this.rules.block.hr.test(ue)));){if(te=fe[0],ue=ue.substring(te.length),oe=fe[2].split(`
`,1)[0],Z=ue.split(`
`,1)[0],this.options.pedantic?(Pe=2,Ee=oe.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,Ee=oe.slice(Pe),Pe+=fe[1].length),G=!1,!oe&&/^ *$/.test(Z)&&(te+=Z+`
`,ue=ue.substring(Z.length+1),je=!0),!je)for(var et=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ne=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ue&&(me=ue.split(`
`,1)[0],oe=me,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ne.test(oe)||qe.test(oe)||et.test(oe)||Ae.test(ue)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())Ee+=`
`+oe.slice(Pe);else if(!G)Ee+=`
`+oe;else break;!G&&!oe.trim()&&(G=!0),te+=me+`
`,ue=ue.substring(me.length+1)}Ye.loose||(se?Ye.loose=!0:/\n *\n *$/.test(te)&&(se=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Ee),de&&(be=de[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:te,task:!!de,checked:be,loose:!1,text:Ee}),Ye.raw+=te}Ye.items[Ye.items.length-1].raw=te.trimRight(),Ye.items[Ye.items.length-1].text=Ee.trimRight(),Ye.raw=Ye.raw.trimRight();var Le=Ye.items.length;for(z=0;z<Le;z++){this.lexer.state.top=!1,Ye.items[z].tokens=this.lexer.blockTokens(Ye.items[z].text,[]);var Xe=Ye.items[z].tokens.filter(function(le){return le.type==="space"}),he=Xe.every(function(le){for(var Ie=le.raw.split(""),Ve=0,ze=L(Ie),xe;!(xe=ze()).done;){var rt=xe.value;if(rt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ye.loose&&Xe.length&&he&&(Ye.loose=!0,Ye.items[z].loose=!0)}return Ye}},x.html=function(ue){var fe=this.rules.block.html.exec(ue);if(fe){var te={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]);te.type="paragraph",te.text=de,te.tokens=this.lexer.inline(de)}return te}},x.def=function(ue){var fe=this.rules.block.def.exec(ue);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var te=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:fe[0],href:fe[2],title:fe[3]}}},x.table=function(ue){var fe=this.rules.block.table.exec(ue);if(fe){var te={type:"table",header:S(fe[1]).map(function(se){return{text:se}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=fe[0];var de=te.align.length,be,Pe,z,G;for(be=0;be<de;be++)/^ *-+: *$/.test(te.align[be])?te.align[be]="right":/^ *:-+: *$/.test(te.align[be])?te.align[be]="center":/^ *:-+ *$/.test(te.align[be])?te.align[be]="left":te.align[be]=null;for(de=te.rows.length,be=0;be<de;be++)te.rows[be]=S(te.rows[be],te.header.length).map(function(se){return{text:se}});for(de=te.header.length,Pe=0;Pe<de;Pe++)te.header[Pe].tokens=this.lexer.inline(te.header[Pe].text);for(de=te.rows.length,Pe=0;Pe<de;Pe++)for(G=te.rows[Pe],z=0;z<G.length;z++)G[z].tokens=this.lexer.inline(G[z].text);return te}}},x.lheading=function(ue){var fe=this.rules.block.lheading.exec(ue);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},x.paragraph=function(ue){var fe=this.rules.block.paragraph.exec(ue);if(fe){var te=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:te,tokens:this.lexer.inline(te)}}},x.text=function(ue){var fe=this.rules.block.text.exec(ue);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},x.escape=function(ue){var fe=this.rules.inline.escape.exec(ue);if(fe)return{type:"escape",raw:fe[0],text:k(fe[1])}},x.tag=function(ue){var fe=this.rules.inline.tag.exec(ue);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]):fe[0]}},x.link=function(ue){var fe=this.rules.inline.link.exec(ue);if(fe){var te=fe[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var de=b(te.slice(0,-1),"\\");if((te.length-de.length)%2===0)return}else{var be=f(fe[2],"()");if(be>-1){var Pe=fe[0].indexOf("!")===0?5:4,z=Pe+fe[1].length+be;fe[2]=fe[2].substring(0,be),fe[0]=fe[0].substring(0,z).trim(),fe[3]=""}}var G=fe[2],se="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(G);oe&&(G=oe[1],se=oe[3])}else se=fe[3]?fe[3].slice(1,-1):"";return G=G.trim(),/^</.test(G)&&(this.options.pedantic&&!/>$/.test(te)?G=G.slice(1):G=G.slice(1,-1)),N(fe,{href:G&&G.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},x.reflink=function(ue,fe){var te;if((te=this.rules.inline.reflink.exec(ue))||(te=this.rules.inline.nolink.exec(ue))){var de=(te[2]||te[1]).replace(/\s+/g," ");if(de=fe[de.toLowerCase()],!de||!de.href){var be=te[0].charAt(0);return{type:"text",raw:be,text:be}}return N(te,de,te[0],this.lexer)}},x.emStrong=function(ue,fe,te){te===void 0&&(te="");var de=this.rules.inline.emStrong.lDelim.exec(ue);if(de&&!(de[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=de[1]||de[2]||"";if(!be||be&&(te===""||this.rules.inline.punctuation.exec(te))){var Pe=de[0].length-1,z,G,se=Pe,oe=0,Z=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,fe=fe.slice(-1*ue.length+Pe);(de=Z.exec(fe))!=null;)if(z=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!z){if(G=z.length,de[3]||de[4]){se+=G;continue}else if((de[5]||de[6])&&Pe%3&&!((Pe+G)%3)){oe+=G;continue}if(se-=G,!(se>0)){if(G=Math.min(G,G+se+oe),Math.min(Pe,G)%2){var me=ue.slice(1,Pe+de.index+G);return{type:"em",raw:ue.slice(0,Pe+de.index+G+1),text:me,tokens:this.lexer.inlineTokens(me)}}var Ee=ue.slice(2,Pe+de.index+G-1);return{type:"strong",raw:ue.slice(0,Pe+de.index+G+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},x.codespan=function(ue){var fe=this.rules.inline.code.exec(ue);if(fe){var te=fe[2].replace(/\n/g," "),de=/[^ ]/.test(te),be=/^ /.test(te)&&/ $/.test(te);return de&&be&&(te=te.substring(1,te.length-1)),te=k(te,!0),{type:"codespan",raw:fe[0],text:te}}},x.br=function(ue){var fe=this.rules.inline.br.exec(ue);if(fe)return{type:"br",raw:fe[0]}},x.del=function(ue){var fe=this.rules.inline.del.exec(ue);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},x.autolink=function(ue,fe){var te=this.rules.inline.autolink.exec(ue);if(te){var de,be;return te[2]==="@"?(de=k(this.options.mangle?fe(te[1]):te[1]),be="mailto:"+de):(de=k(te[1]),be=de),{type:"link",raw:te[0],text:de,href:be,tokens:[{type:"text",raw:de,text:de}]}}},x.url=function(ue,fe){var te;if(te=this.rules.inline.url.exec(ue)){var de,be;if(te[2]==="@")de=k(this.options.mangle?fe(te[0]):te[0]),be="mailto:"+de;else{var Pe;do Pe=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Pe!==te[0]);de=k(te[0]),te[1]==="www."?be="http://"+de:be=de}return{type:"link",raw:te[0],text:de,href:be,tokens:[{type:"text",raw:de,text:de}]}}},x.inlineText=function(ue,fe){var te=this.rules.inline.text.exec(ue);if(te){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]):te[0]:de=k(this.options.smartypants?fe(te[0]):te[0]),{type:"text",raw:te[0],text:de}}},_}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=r(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=r(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=r(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=r(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=r(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=r(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=D({},j),j.gfm=D({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=r(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=r(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=D({},j.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:r(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=r(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=r(j._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=r(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=r(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=r(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=r(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=r(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=r(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=r(U.reflink).replace("label",U._label).replace("ref",j._label).getRegex(),U.nolink=r(U.nolink).replace("ref",j._label).getRegex(),U.reflinkSearch=r(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=D({},U),U.pedantic=D({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=D({},U.normal,{escape:r(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=r(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=D({},U.gfm,{br:r(U.br).replace("{2,}","*").getRegex(),text:r(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(_){return _.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(_){var x="",pe,ue,fe=_.length;for(pe=0;pe<fe;pe++)ue=_.charCodeAt(pe),Math.random()>.5&&(ue="x"+ue.toString(16)),x+="&#"+ue+";";return x}var q=function(){function _(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||$e.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ue={block:j.normal,inline:U.normal};this.options.pedantic?(ue.block=j.pedantic,ue.inline=U.pedantic):this.options.gfm&&(ue.block=j.gfm,this.options.breaks?ue.inline=U.breaks:ue.inline=U.gfm),this.tokenizer.rules=ue}_.lex=function(ue,fe){var te=new _(fe);return te.lex(ue)},_.lexInline=function(ue,fe){var te=new _(fe);return te.inlineTokens(ue)};var x=_.prototype;return x.lex=function(ue){ue=ue.replace(/\r\n|\r/g,`
`),this.blockTokens(ue,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},x.blockTokens=function(ue,fe){var te=this;fe===void 0&&(fe=[]),this.options.pedantic?ue=ue.replace(/\t/g,"    ").replace(/^ +$/gm,""):ue=ue.replace(/^( *)(\t+)/gm,function(se,oe,Z){return oe+"    ".repeat(Z.length)});for(var de,be,Pe,z;ue;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(de=se.call({lexer:te},ue,fe))?(ue=ue.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.space(ue)){ue=ue.substring(de.raw.length),de.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(de);continue}if(de=this.tokenizer.code(ue)){ue=ue.substring(de.raw.length),be=fe[fe.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de);continue}if(de=this.tokenizer.fences(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.heading(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.hr(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.blockquote(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.list(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.html(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.def(ue)){ue=ue.substring(de.raw.length),be=fe[fe.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+de.raw,be.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.lheading(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(Pe=ue,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,oe=ue.slice(1),Z=void 0;te.options.extensions.startBlock.forEach(function(me){Z=me.call({lexer:this},oe),typeof Z=="number"&&Z>=0&&(se=Math.min(se,Z))}),se<1/0&&se>=0&&(Pe=ue.substring(0,se+1))}(),this.state.top&&(de=this.tokenizer.paragraph(Pe))){be=fe[fe.length-1],z&&be.type==="paragraph"?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de),z=Pe.length!==ue.length,ue=ue.substring(de.raw.length);continue}if(de=this.tokenizer.text(ue)){ue=ue.substring(de.raw.length),be=fe[fe.length-1],be&&be.type==="text"?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de);continue}if(ue){var G="Infinite loop on byte: "+ue.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return this.state.top=!0,fe},x.inline=function(ue,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ue,tokens:fe}),fe},x.inlineTokens=function(ue,fe){var te=this;fe===void 0&&(fe=[]);var de,be,Pe,z=ue,G,se,oe;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(G=this.tokenizer.rules.inline.reflinkSearch.exec(z))!=null;)Z.includes(G[0].slice(G[0].lastIndexOf("[")+1,-1))&&(z=z.slice(0,G.index)+"["+P("a",G[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(G=this.tokenizer.rules.inline.blockSkip.exec(z))!=null;)z=z.slice(0,G.index)+"["+P("a",G[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(G=this.tokenizer.rules.inline.escapedEmSt.exec(z))!=null;)z=z.slice(0,G.index)+"++"+z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ue;)if(se||(oe=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(de=Ee.call({lexer:te},ue,fe))?(ue=ue.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.escape(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.tag(ue)){ue=ue.substring(de.raw.length),be=fe[fe.length-1],be&&de.type==="text"&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.link(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.reflink(ue,this.tokens.links)){ue=ue.substring(de.raw.length),be=fe[fe.length-1],be&&de.type==="text"&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.emStrong(ue,z,oe)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.codespan(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.br(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.del(ue)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.autolink(ue,K)){ue=ue.substring(de.raw.length),fe.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(ue,K))){ue=ue.substring(de.raw.length),fe.push(de);continue}if(Pe=ue,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,je=ue.slice(1),We=void 0;te.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(Ee=Math.min(Ee,We))}),Ee<1/0&&Ee>=0&&(Pe=ue.substring(0,Ee+1))}(),de=this.tokenizer.inlineText(Pe,T)){ue=ue.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(oe=de.raw.slice(-1)),se=!0,be=fe[fe.length-1],be&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(ue){var me="Infinite loop on byte: "+ue.charCodeAt(0);if(this.options.silent){console.error(me);break}else throw new Error(me)}}return fe},C(_,null,[{key:"rules",get:function(){return{block:j,inline:U}}}]),_}(),ge=function(){function _(pe){this.options=pe||$e.defaults}var x=_.prototype;return x.code=function(ue,fe,te){var de=(fe||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(ue,de);be!=null&&be!==ue&&(te=!0,ue=be)}return ue=ue.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+k(de,!0)+'">'+(te?ue:k(ue,!0))+`</code></pre>
`:"<pre><code>"+(te?ue:k(ue,!0))+`</code></pre>
`},x.blockquote=function(ue){return`<blockquote>
`+ue+`</blockquote>
`},x.html=function(ue){return ue},x.heading=function(ue,fe,te,de){if(this.options.headerIds){var be=this.options.headerPrefix+de.slug(te);return"<h"+fe+' id="'+be+'">'+ue+"</h"+fe+`>
`}return"<h"+fe+">"+ue+"</h"+fe+`>
`},x.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},x.list=function(ue,fe,te){var de=fe?"ol":"ul",be=fe&&te!==1?' start="'+te+'"':"";return"<"+de+be+`>
`+ue+"</"+de+`>
`},x.listitem=function(ue){return"<li>"+ue+`</li>
`},x.checkbox=function(ue){return"<input "+(ue?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},x.paragraph=function(ue){return"<p>"+ue+`</p>
`},x.table=function(ue,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ue+`</thead>
`+fe+`</table>
`},x.tablerow=function(ue){return`<tr>
`+ue+`</tr>
`},x.tablecell=function(ue,fe){var te=fe.header?"th":"td",de=fe.align?"<"+te+' align="'+fe.align+'">':"<"+te+">";return de+ue+("</"+te+`>
`)},x.strong=function(ue){return"<strong>"+ue+"</strong>"},x.em=function(ue){return"<em>"+ue+"</em>"},x.codespan=function(ue){return"<code>"+ue+"</code>"},x.br=function(){return this.options.xhtml?"<br/>":"<br>"},x.del=function(ue){return"<del>"+ue+"</del>"},x.link=function(ue,fe,te){if(ue=h(this.options.sanitize,this.options.baseUrl,ue),ue===null)return te;var de='<a href="'+k(ue)+'"';return fe&&(de+=' title="'+fe+'"'),de+=">"+te+"</a>",de},x.image=function(ue,fe,te){if(ue=h(this.options.sanitize,this.options.baseUrl,ue),ue===null)return te;var de='<img src="'+ue+'" alt="'+te+'"';return fe&&(de+=' title="'+fe+'"'),de+=this.options.xhtml?"/>":">",de},x.text=function(ue){return ue},_}(),ee=function(){function _(){}var x=_.prototype;return x.strong=function(ue){return ue},x.em=function(ue){return ue},x.codespan=function(ue){return ue},x.del=function(ue){return ue},x.html=function(ue){return ue},x.text=function(ue){return ue},x.link=function(ue,fe,te){return""+te},x.image=function(ue,fe,te){return""+te},x.br=function(){return""},_}(),Q=function(){function _(){this.seen={}}var x=_.prototype;return x.serialize=function(ue){return ue.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},x.getNextSafeSlug=function(ue,fe){var te=ue,de=0;if(this.seen.hasOwnProperty(te)){de=this.seen[ue];do de++,te=ue+"-"+de;while(this.seen.hasOwnProperty(te))}return fe||(this.seen[ue]=de,this.seen[te]=0),te},x.slug=function(ue,fe){fe===void 0&&(fe={});var te=this.serialize(ue);return this.getNextSafeSlug(te,fe.dryrun)},_}(),X=function(){function _(pe){this.options=pe||$e.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new Q}_.parse=function(ue,fe){var te=new _(fe);return te.parse(ue)},_.parseInline=function(ue,fe){var te=new _(fe);return te.parseInline(ue)};var x=_.prototype;return x.parse=function(ue,fe){fe===void 0&&(fe=!0);var te="",de,be,Pe,z,G,se,oe,Z,me,Ee,je,We,_e,Ye,it,et,Ae,Ne,qe,Le=ue.length;for(de=0;de<Le;de++){if(Ee=ue[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(qe=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){te+=qe||"";continue}switch(Ee.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,u(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(Z="",oe="",z=Ee.header.length,be=0;be<z;be++)oe+=this.renderer.tablecell(this.parseInline(Ee.header[be].tokens),{header:!0,align:Ee.align[be]});for(Z+=this.renderer.tablerow(oe),me="",z=Ee.rows.length,be=0;be<z;be++){for(se=Ee.rows[be],oe="",G=se.length,Pe=0;Pe<G;Pe++)oe+=this.renderer.tablecell(this.parseInline(se[Pe].tokens),{header:!1,align:Ee.align[Pe]});me+=this.renderer.tablerow(oe)}te+=this.renderer.table(Z,me);continue}case"blockquote":{me=this.parse(Ee.tokens),te+=this.renderer.blockquote(me);continue}case"list":{for(je=Ee.ordered,We=Ee.start,_e=Ee.loose,z=Ee.items.length,me="",be=0;be<z;be++)it=Ee.items[be],et=it.checked,Ae=it.task,Ye="",it.task&&(Ne=this.renderer.checkbox(et),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Ne+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Ne+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Ne}):Ye+=Ne),Ye+=this.parse(it.tokens,_e),me+=this.renderer.listitem(Ye,Ae,et);te+=this.renderer.list(me,je,We);continue}case"html":{te+=this.renderer.html(Ee.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(me=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;de+1<Le&&ue[de+1].type==="text";)Ee=ue[++de],me+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);te+=fe?this.renderer.paragraph(me):me;continue}default:{var Xe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return te},x.parseInline=function(ue,fe){fe=fe||this.renderer;var te="",de,be,Pe,z=ue.length;for(de=0;de<z;de++){if(be=ue[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Pe=this.options.extensions.renderers[be.type].call({parser:this},be),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){te+=Pe||"";continue}switch(be.type){case"escape":{te+=fe.text(be.text);break}case"html":{te+=fe.html(be.text);break}case"link":{te+=fe.link(be.href,be.title,this.parseInline(be.tokens,fe));break}case"image":{te+=fe.image(be.href,be.title,be.text);break}case"strong":{te+=fe.strong(this.parseInline(be.tokens,fe));break}case"em":{te+=fe.em(this.parseInline(be.tokens,fe));break}case"codespan":{te+=fe.codespan(be.text);break}case"br":{te+=fe.br();break}case"del":{te+=fe.del(this.parseInline(be.tokens,fe));break}case"text":{te+=fe.text(be.text);break}default:{var G='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return te},_}();function ae(_,x,pe){if(typeof _>"u"||_===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");if(typeof x=="function"&&(pe=x,x=null),x=D({},ae.defaults,x||{}),g(x),pe){var ue=x.highlight,fe;try{fe=q.lex(_,x)}catch(z){return pe(z)}var te=function(G){var se;if(!G)try{x.walkTokens&&ae.walkTokens(fe,x.walkTokens),se=X.parse(fe,x)}catch(oe){G=oe}return x.highlight=ue,G?pe(G):pe(null,se)};if(!ue||ue.length<3||(delete x.highlight,!fe.length))return te();var de=0;ae.walkTokens(fe,function(z){z.type==="code"&&(de++,setTimeout(function(){ue(z.text,z.lang,function(G,se){if(G)return te(G);se!=null&&se!==z.text&&(z.text=se,z.escaped=!0),de--,de===0&&te()})},0))}),de===0&&te();return}function be(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+k(z.message+"",!0)+"</pre>";throw z}try{var Pe=q.lex(_,x);if(x.walkTokens){if(x.async)return Promise.all(ae.walkTokens(Pe,x.walkTokens)).then(function(){return X.parse(Pe,x)}).catch(be);ae.walkTokens(Pe,x.walkTokens)}return X.parse(Pe,x)}catch(z){be(z)}}ae.options=ae.setOptions=function(_){return D(ae.defaults,_),$(ae.defaults),ae},ae.getDefaults=A,ae.defaults=$e.defaults,ae.use=function(){for(var _=arguments.length,x=new Array(_),pe=0;pe<_;pe++)x[pe]=arguments[pe];var ue=D.apply(void 0,[{}].concat(x)),fe=ae.defaults.extensions||{renderers:{},childTokens:{}},te;x.forEach(function(de){if(de.extensions&&(te=!0,de.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var z=fe.renderers?fe.renderers[Pe.name]:null;z?fe.renderers[Pe.name]=function(){for(var G=arguments.length,se=new Array(G),oe=0;oe<G;oe++)se[oe]=arguments[oe];var Z=Pe.renderer.apply(this,se);return Z===!1&&(Z=z.apply(this,se)),Z}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),de.renderer&&function(){var Pe=ae.defaults.renderer||new ge,z=function(oe){var Z=Pe[oe];Pe[oe]=function(){for(var me=arguments.length,Ee=new Array(me),je=0;je<me;je++)Ee[je]=arguments[je];var We=de.renderer[oe].apply(Pe,Ee);return We===!1&&(We=Z.apply(Pe,Ee)),We}};for(var G in de.renderer)z(G);ue.renderer=Pe}(),de.tokenizer&&function(){var Pe=ae.defaults.tokenizer||new M,z=function(oe){var Z=Pe[oe];Pe[oe]=function(){for(var me=arguments.length,Ee=new Array(me),je=0;je<me;je++)Ee[je]=arguments[je];var We=de.tokenizer[oe].apply(Pe,Ee);return We===!1&&(We=Z.apply(Pe,Ee)),We}};for(var G in de.tokenizer)z(G);ue.tokenizer=Pe}(),de.walkTokens){var be=ae.defaults.walkTokens;ue.walkTokens=function(Pe){var z=[];return z.push(de.walkTokens.call(this,Pe)),be&&(z=z.concat(be.call(this,Pe))),z}}te&&(ue.extensions=fe),ae.setOptions(ue)})},ae.walkTokens=function(_,x){for(var pe=[],ue=function(){var be=te.value;switch(pe=pe.concat(x.call(ae,be)),be.type){case"table":{for(var Pe=L(be.header),z;!(z=Pe()).done;){var G=z.value;pe=pe.concat(ae.walkTokens(G.tokens,x))}for(var se=L(be.rows),oe;!(oe=se()).done;)for(var Z=oe.value,me=L(Z),Ee;!(Ee=me()).done;){var je=Ee.value;pe=pe.concat(ae.walkTokens(je.tokens,x))}break}case"list":{pe=pe.concat(ae.walkTokens(be.items,x));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[be.type]?ae.defaults.extensions.childTokens[be.type].forEach(function(We){pe=pe.concat(ae.walkTokens(be[We],x))}):be.tokens&&(pe=pe.concat(ae.walkTokens(be.tokens,x)))}},fe=L(_),te;!(te=fe()).done;)ue();return pe},ae.parseInline=function(_,x){if(typeof _>"u"||_===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");x=D({},ae.defaults,x||{}),g(x);try{var pe=q.lexInline(_,x);return x.walkTokens&&ae.walkTokens(pe,x.walkTokens),X.parseInline(pe,x)}catch(ue){if(ue.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+k(ue.message+"",!0)+"</pre>";throw ue}},ae.Parser=X,ae.parser=X.parse,ae.Renderer=ge,ae.TextRenderer=ee,ae.Lexer=q,ae.lexer=q.lex,ae.Tokenizer=M,ae.Slugger=Q,ae.parse=ae;var ie=ae.options,ce=ae.setOptions,we=ae.use,H=ae.walkTokens,B=ae.parseInline,J=ae,re=X.parse,Y=q.lex;$e.Lexer=q,$e.Parser=X,$e.Renderer=ge,$e.Slugger=Q,$e.TextRenderer=ee,$e.Tokenizer=M,$e.getDefaults=A,$e.lexer=Y,$e.marked=ae,$e.options=ie,$e.parse=J,$e.parseInline=B,$e.parser=re,$e.setOptions=ce,$e.use=we,$e.walkTokens=H,Object.defineProperty($e,"__esModule",{value:!0})}),define(De[77],Ce([1,0,28]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=void 0;const F=new C.$Dc(1e4);function d(v){return E(v,"NFC",F)}e.$ol=d;const L=new C.$Dc(1e4);function A(v){return E(v,"NFD",L)}e.$pl=A;const $=/[^\u0000-\u0080]/;function E(v,R,I){if(!v)return v;const w=I.get(v);if(w)return w;let y;return $.test(v)?y=v.normalize(R):y=v,I.set(v,y),y}e.$ql=function(){const v=/[\u0300-\u036f]/g;return function(R){return A(R).replace(v,"")}}()}),define(De[120],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function C($,E,v){return Math.min(Math.max($,E),v)}e.$Ol=C;function F($,E){return(E+$%E)%E}e.rot=F;class d{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=d;class L{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=L;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const v=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=A}),function(){function $e(d){const L=[];typeof d=="number"&&L.push("code/timeOrigin",d);function A(E){L.push(E,Date.now())}function $(){const E=[];for(let v=0;v<L.length;v+=2)E.push({name:L[v],startTime:L[v+1]});return E}return{mark:A,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(d){performance.mark(d)},getMarks(){let d=performance.timeOrigin;typeof d!="number"&&(d=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(d)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(d+A.startTime)});return L}};if(typeof process=="object"){const d=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(d)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function C(d){return d.MonacoPerformanceMarks||(d.MonacoPerformanceMarks=e()),d.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=C(F))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var F in C)(typeof exports=="object"?exports:$e)[F]=C[F]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function C(F){if(e[F])return e[F].exports;var d=e[F]={i:F,l:!1,exports:{}};return $e[F].call(d.exports,d,d.exports,C),d.l=!0,d.exports}return C.m=$e,C.c=e,C.d=function(F,d,L){C.o(F,d)||Object.defineProperty(F,d,{enumerable:!0,get:L})},C.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},C.t=function(F,d){if(1&d&&(F=C(F)),8&d||4&d&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(C.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&d&&typeof F!="string")for(var A in F)C.d(L,A,function($){return F[$]}.bind(null,A));return L},C.n=function(F){var d=F&&F.__esModule?function(){return F.default}:function(){return F};return C.d(d,"a",d),d},C.o=function(F,d){return Object.prototype.hasOwnProperty.call(F,d)},C.p="",C(C.s=0)}([function($e,e,C){(function(F){var d;e=$e.exports=we,d=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],E=e.src=[],v=0,R=v++;E[R]="0|[1-9]\\d*";var I=v++;E[I]="[0-9]+";var w=v++;E[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=v++;E[y]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var k=v++;E[k]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var p=v++;E[p]="(?:"+E[R]+"|"+E[w]+")";var u=v++;E[u]="(?:"+E[I]+"|"+E[w]+")";var o=v++;E[o]="(?:-("+E[p]+"(?:\\."+E[p]+")*))";var r=v++;E[r]="(?:-?("+E[u]+"(?:\\."+E[u]+")*))";var s=v++;E[s]="[0-9A-Za-z-]+";var m=v++;E[m]="(?:\\+("+E[s]+"(?:\\."+E[s]+")*))";var h=v++,t="v?"+E[y]+E[o]+"?"+E[m]+"?";E[h]="^"+t+"$";var n="[v=\\s]*"+E[k]+E[r]+"?"+E[m]+"?",c=v++;E[c]="^"+n+"$";var i=v++;E[i]="((?:<|>)?=?)";var a=v++;E[a]=E[I]+"|x|X|\\*";var l=v++;E[l]=E[R]+"|x|X|\\*";var D=v++;E[D]="[v=\\s]*("+E[l]+")(?:\\.("+E[l]+")(?:\\.("+E[l]+")(?:"+E[o]+")?"+E[m]+"?)?)?";var S=v++;E[S]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[r]+")?"+E[m]+"?)?)?";var b=v++;E[b]="^"+E[i]+"\\s*"+E[D]+"$";var f=v++;E[f]="^"+E[i]+"\\s*"+E[S]+"$";var g=v++;E[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=v++;E[P]="(?:~>?)";var N=v++;E[N]="(\\s*)"+E[P]+"\\s+",$[N]=new RegExp(E[N],"g");var O=v++;E[O]="^"+E[P]+E[D]+"$";var M=v++;E[M]="^"+E[P]+E[S]+"$";var j=v++;E[j]="(?:\\^)";var U=v++;E[U]="(\\s*)"+E[j]+"\\s+",$[U]=new RegExp(E[U],"g");var T=v++;E[T]="^"+E[j]+E[D]+"$";var K=v++;E[K]="^"+E[j]+E[S]+"$";var q=v++;E[q]="^"+E[i]+"\\s*("+n+")$|^$";var ge=v++;E[ge]="^"+E[i]+"\\s*("+t+")$|^$";var ee=v++;E[ee]="(\\s*)"+E[i]+"\\s*("+n+"|"+E[D]+")",$[ee]=new RegExp(E[ee],"g");var Q=v++;E[Q]="^\\s*("+E[D]+")\\s+-\\s+("+E[D]+")\\s*$";var X=v++;E[X]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var ae=v++;E[ae]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)d(ie,E[ie]),$[ie]||($[ie]=new RegExp(E[ie]));function ce(Z,me){if(Z instanceof we)return Z;if(typeof Z!="string"||Z.length>L||!(me?$[c]:$[h]).test(Z))return null;try{return new we(Z,me)}catch{return null}}function we(Z,me){if(Z instanceof we){if(Z.loose===me)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof we))return new we(Z,me);d("SemVer",Z,me),this.loose=me;var Ee=Z.trim().match(me?$[c]:$[h]);if(!Ee)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<A)return We}return je}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Z,me){var Ee=ce(Z,me);return Ee?Ee.version:null},e.clean=function(Z,me){var Ee=ce(Z.trim().replace(/^[=v]+/,""),me);return Ee?Ee.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(Z){return d("SemVer.compare",this.version,this.loose,Z),Z instanceof we||(Z=new we(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},we.prototype.compareMain=function(Z){return Z instanceof we||(Z=new we(Z,this.loose)),B(this.major,Z.major)||B(this.minor,Z.minor)||B(this.patch,Z.patch)},we.prototype.comparePre=function(Z){if(Z instanceof we||(Z=new we(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var me=0;do{var Ee=this.prerelease[me],je=Z.prerelease[me];if(d("prerelease compare",me,Ee,je),Ee===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==je)return B(Ee,je)}while(++me)},we.prototype.inc=function(Z,me){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,me,Ee,je){typeof Ee=="string"&&(je=Ee,Ee=void 0);try{return new we(Z,Ee).inc(me,je).version}catch{return null}},e.diff=function(Z,me){if(_(Z,me))return null;var Ee=ce(Z),je=ce(me);if(Ee.prerelease.length||je.prerelease.length){for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==je[We])return We},e.compareIdentifiers=B;var H=/^[0-9]+$/;function B(Z,me){var Ee=H.test(Z),je=H.test(me);return Ee&&je&&(Z=+Z,me=+me),Ee&&!je?-1:je&&!Ee?1:Z<me?-1:Z>me?1:0}function J(Z,me,Ee){return new we(Z,Ee).compare(new we(me,Ee))}function re(Z,me,Ee){return J(Z,me,Ee)>0}function Y(Z,me,Ee){return J(Z,me,Ee)<0}function _(Z,me,Ee){return J(Z,me,Ee)===0}function x(Z,me,Ee){return J(Z,me,Ee)!==0}function pe(Z,me,Ee){return J(Z,me,Ee)>=0}function ue(Z,me,Ee){return J(Z,me,Ee)<=0}function fe(Z,me,Ee,je){var We;switch(me){case"===":typeof Z=="object"&&(Z=Z.version),typeof Ee=="object"&&(Ee=Ee.version),We=Z===Ee;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof Ee=="object"&&(Ee=Ee.version),We=Z!==Ee;break;case"":case"=":case"==":We=_(Z,Ee,je);break;case"!=":We=x(Z,Ee,je);break;case">":We=re(Z,Ee,je);break;case">=":We=pe(Z,Ee,je);break;case"<":We=Y(Z,Ee,je);break;case"<=":We=ue(Z,Ee,je);break;default:throw new TypeError("Invalid operator: "+me)}return We}function te(Z,me){if(Z instanceof te){if(Z.loose===me)return Z;Z=Z.value}if(!(this instanceof te))return new te(Z,me);d("comparator",Z,me),this.loose=me,this.parse(Z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,d("comp",this)}e.rcompareIdentifiers=function(Z,me){return B(me,Z)},e.major=function(Z,me){return new we(Z,me).major},e.minor=function(Z,me){return new we(Z,me).minor},e.patch=function(Z,me){return new we(Z,me).patch},e.compare=J,e.compareLoose=function(Z,me){return J(Z,me,!0)},e.rcompare=function(Z,me,Ee){return J(me,Z,Ee)},e.sort=function(Z,me){return Z.sort(function(Ee,je){return e.compare(Ee,je,me)})},e.rsort=function(Z,me){return Z.sort(function(Ee,je){return e.rcompare(Ee,je,me)})},e.gt=re,e.lt=Y,e.eq=_,e.neq=x,e.gte=pe,e.lte=ue,e.cmp=fe,e.Comparator=te;var de={};function be(Z,me){if(Z instanceof be)return Z.loose===me?Z:new be(Z.raw,me);if(Z instanceof te)return new be(Z.value,me);if(!(this instanceof be))return new be(Z,me);if(this.loose=me,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Pe(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function z(Z,me,Ee,je,We,_e,Ye,it,et,Ae,Ne,qe,Le){return((me=Pe(Ee)?"":Pe(je)?">="+Ee+".0.0":Pe(We)?">="+Ee+"."+je+".0":">="+me)+" "+(it=Pe(et)?"":Pe(Ae)?"<"+(+et+1)+".0.0":Pe(Ne)?"<"+et+"."+(+Ae+1)+".0":qe?"<="+et+"."+Ae+"."+Ne+"-"+qe:"<="+it)).trim()}function G(Z,me){for(var Ee=0;Ee<Z.length;Ee++)if(!Z[Ee].test(me))return!1;if(me.prerelease.length){for(Ee=0;Ee<Z.length;Ee++)if(d(Z[Ee].semver),Z[Ee].semver!==de&&Z[Ee].semver.prerelease.length>0){var je=Z[Ee].semver;if(je.major===me.major&&je.minor===me.minor&&je.patch===me.patch)return!0}return!1}return!0}function se(Z,me,Ee){try{me=new be(me,Ee)}catch{return!1}return me.test(Z)}function oe(Z,me,Ee,je){var We,_e,Ye,it,et;switch(Z=new we(Z,je),me=new be(me,je),Ee){case">":We=re,_e=ue,Ye=Y,it=">",et=">=";break;case"<":We=Y,_e=pe,Ye=re,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Z,me,je))return!1;for(var Ae=0;Ae<me.set.length;++Ae){var Ne=me.set[Ae],qe=null,Le=null;if(Ne.forEach(function(Xe){Xe.semver===de&&(Xe=new te(">=0.0.0")),qe=qe||Xe,Le=Le||Xe,We(Xe.semver,qe.semver,je)?qe=Xe:Ye(Xe.semver,Le.semver,je)&&(Le=Xe)}),qe.operator===it||qe.operator===et||(!Le.operator||Le.operator===it)&&_e(Z,Le.semver)||Le.operator===et&&Ye(Z,Le.semver))return!1}return!0}te.prototype.parse=function(Z){var me=this.loose?$[q]:$[ge],Ee=Z.match(me);if(!Ee)throw new TypeError("Invalid comparator: "+Z);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new we(Ee[2],this.loose):this.semver=de},te.prototype.toString=function(){return this.value},te.prototype.test=function(Z){return d("Comparator.test",Z,this.loose),this.semver===de||(typeof Z=="string"&&(Z=new we(Z,this.loose)),fe(Z,this.operator,this.semver,this.loose))},te.prototype.intersects=function(Z,me){if(!(Z instanceof te))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new be(Z.value,me),se(this.value,Ee,me);if(Z.operator==="")return Ee=new be(this.value,me),se(Z.semver,Ee,me);var je=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),_e=this.semver.version===Z.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),it=fe(this.semver,"<",Z.semver,me)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),et=fe(this.semver,">",Z.semver,me)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return je||We||_e&&Ye||it||et},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Z){var me=this.loose;Z=Z.trim(),d("range",Z,me);var Ee=me?$[X]:$[Q];Z=Z.replace(Ee,z),d("hyphen replace",Z),Z=Z.replace($[ee],"$1$2$3"),d("comparator trim",Z,$[ee]),Z=(Z=(Z=Z.replace($[N],"$1~")).replace($[U],"$1^")).split(/\s+/).join(" ");var je=me?$[q]:$[ge],We=Z.split(" ").map(function(_e){return function(Ye,it){return d("comp",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(qe,Le){d("caret",qe,Le);var Xe=Le?$[K]:$[T];return qe.replace(Xe,function(he,le,Ie,Ve,ze){var xe;return d("caret",qe,he,le,Ie,Ve,ze),Pe(le)?xe="":Pe(Ie)?xe=">="+le+".0.0 <"+(+le+1)+".0.0":Pe(Ve)?xe=le==="0"?">="+le+"."+Ie+".0 <"+le+"."+(+Ie+1)+".0":">="+le+"."+Ie+".0 <"+(+le+1)+".0.0":ze?(d("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),xe=le==="0"?Ie==="0"?">="+le+"."+Ie+"."+Ve+ze+" <"+le+"."+Ie+"."+(+Ve+1):">="+le+"."+Ie+"."+Ve+ze+" <"+le+"."+(+Ie+1)+".0":">="+le+"."+Ie+"."+Ve+ze+" <"+(+le+1)+".0.0"):(d("no pr"),xe=le==="0"?Ie==="0"?">="+le+"."+Ie+"."+Ve+" <"+le+"."+Ie+"."+(+Ve+1):">="+le+"."+Ie+"."+Ve+" <"+le+"."+(+Ie+1)+".0":">="+le+"."+Ie+"."+Ve+" <"+(+le+1)+".0.0"),d("caret return",xe),xe})}(Ne,Ae)}).join(" ")}(Ye,it),d("caret",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(qe,Le){var Xe=Le?$[M]:$[O];return qe.replace(Xe,function(he,le,Ie,Ve,ze){var xe;return d("tilde",qe,he,le,Ie,Ve,ze),Pe(le)?xe="":Pe(Ie)?xe=">="+le+".0.0 <"+(+le+1)+".0.0":Pe(Ve)?xe=">="+le+"."+Ie+".0 <"+le+"."+(+Ie+1)+".0":ze?(d("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),xe=">="+le+"."+Ie+"."+Ve+ze+" <"+le+"."+(+Ie+1)+".0"):xe=">="+le+"."+Ie+"."+Ve+" <"+le+"."+(+Ie+1)+".0",d("tilde return",xe),xe})}(Ne,Ae)}).join(" ")}(Ye,it),d("tildes",Ye),Ye=function(et,Ae){return d("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Ne){return function(qe,Le){qe=qe.trim();var Xe=Le?$[f]:$[b];return qe.replace(Xe,function(he,le,Ie,Ve,ze,xe){d("xRange",qe,he,le,Ie,Ve,ze,xe);var rt=Pe(Ie),ot=rt||Pe(Ve),$t=ot||Pe(ze);return le==="="&&$t&&(le=""),rt?he=le===">"||le==="<"?"<0.0.0":"*":le&&$t?(ot&&(Ve=0),$t&&(ze=0),le===">"?(le=">=",ot?(Ie=+Ie+1,Ve=0,ze=0):$t&&(Ve=+Ve+1,ze=0)):le==="<="&&(le="<",ot?Ie=+Ie+1:Ve=+Ve+1),he=le+Ie+"."+Ve+"."+ze):ot?he=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":$t&&(he=">="+Ie+"."+Ve+".0 <"+Ie+"."+(+Ve+1)+".0"),d("xRange return",he),he})}(Ne,Ae)}).join(" ")}(Ye,it),d("xrange",Ye),Ye=function(et,Ae){return d("replaceStars",et,Ae),et.trim().replace($[ae],"")}(Ye,it),d("stars",Ye),Ye}(_e,me)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new te(_e,me)})},be.prototype.intersects=function(Z,me){if(!(Z instanceof be))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(je){return Z.set.some(function(We){return We.every(function(_e){return je.intersects(_e,me)})})})})},e.toComparators=function(Z,me){return new be(Z,me).set.map(function(Ee){return Ee.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new we(Z,this.loose));for(var me=0;me<this.set.length;me++)if(G(this.set[me],Z))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Z,me,Ee){var je=null,We=null;try{var _e=new be(me,Ee)}catch{return null}return Z.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==-1||(We=new we(je=Ye,Ee)))}),je},e.minSatisfying=function(Z,me,Ee){var je=null,We=null;try{var _e=new be(me,Ee)}catch{return null}return Z.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==1||(We=new we(je=Ye,Ee)))}),je},e.validRange=function(Z,me){try{return new be(Z,me).range||"*"}catch{return null}},e.ltr=function(Z,me,Ee){return oe(Z,me,"<",Ee)},e.gtr=function(Z,me,Ee){return oe(Z,me,">",Ee)},e.outside=oe,e.prerelease=function(Z,me){var Ee=ce(Z,me);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(Z,me,Ee){return Z=new be(Z,Ee),me=new be(me,Ee),Z.intersects(me)},e.coerce=function(Z){if(Z instanceof we)return Z;if(typeof Z!="string")return null;var me=Z.match($[g]);return me==null?null:ce((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,C(1))},function($e,e){var C,F,d=$e.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function $(u){if(C===setTimeout)return setTimeout(u,0);if((C===L||!C)&&setTimeout)return C=setTimeout,setTimeout(u,0);try{return C(u,0)}catch{try{return C.call(null,u,0)}catch{return C.call(this,u,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:L}catch{C=L}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var E,v=[],R=!1,I=-1;function w(){R&&E&&(R=!1,E.length?v=E.concat(v):I=-1,v.length&&y())}function y(){if(!R){var u=$(w);R=!0;for(var o=v.length;o;){for(E=v,v=[];++I<o;)E&&E[I].run();I=-1,o=v.length}E=null,R=!1,function(r){if(F===clearTimeout)return clearTimeout(r);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(r);try{F(r)}catch{try{return F.call(null,r)}catch{return F.call(this,r)}}}(u)}}function k(u,o){this.fun=u,this.array=o}function p(){}d.nextTick=function(u){var o=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)o[r-1]=arguments[r];v.push(new k(u,o)),v.length!==1||R||$(y)},k.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=p,d.addListener=p,d.once=p,d.off=p,d.removeListener=p,d.removeAllListeners=p,d.emit=p,d.prependListener=p,d.prependOnceListener=p,d.listeners=function(u){return[]},d.binding=function(u){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(u){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}}])}),define(De[37],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=C&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=F}),define(De[4],Ce([1,0,9,75,3,76,37]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const $=!1,E=!1;var v;(function(b){b.None=()=>d.$Sc.None;function f(fe){if(E){const{onDidAddListener:te}=fe,de=k.create();let be=0;fe.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),te?.()}}}function g(fe,te){return ge(fe,()=>{},0,void 0,!0,void 0,te)}b.defer=g;function P(fe){return(te,de=null,be)=>{let Pe=!1,z;return z=fe(G=>{if(!Pe)return z?z.dispose():Pe=!0,te.call(de,G)},null,be),Pe&&z.dispose(),z}}b.once=P;function N(fe,te,de){return K((be,Pe=null,z)=>fe(G=>be.call(Pe,te(G)),null,z),de)}b.map=N;function O(fe,te,de){return K((be,Pe=null,z)=>fe(G=>{te(G),be.call(Pe,G)},null,z),de)}b.forEach=O;function M(fe,te,de){return K((be,Pe=null,z)=>fe(G=>te(G)&&be.call(Pe,G),null,z),de)}b.filter=M;function j(fe){return fe}b.signal=j;function U(...fe){return(te,de=null,be)=>{const Pe=(0,d.$Pc)(...fe.map(z=>z(G=>te.call(de,G))));return q(Pe,be)}}b.any=U;function T(fe,te,de,be){let Pe=de;return N(fe,z=>(Pe=te(Pe,z),Pe),be)}b.reduce=T;function K(fe,te){let de;const be={onWillAddFirstListener(){de=fe(Pe.fire,Pe)},onDidRemoveLastListener(){de?.dispose()}};te||f(be);const Pe=new s(be);return te?.add(Pe),Pe.event}function q(fe,te){return te instanceof Array?te.push(fe):te&&te.add(fe),fe}function ge(fe,te,de=100,be=!1,Pe=!1,z,G){let se,oe,Z,me=0,Ee;const je={leakWarningThreshold:z,onWillAddFirstListener(){se=fe(_e=>{me++,oe=te(oe,_e),be&&!Z&&(We.fire(oe),oe=void 0),Ee=()=>{const Ye=oe;oe=void 0,Z=void 0,(!be||me>1)&&We.fire(Ye),me=0},typeof de=="number"?(clearTimeout(Z),Z=setTimeout(Ee,de)):Z===void 0&&(Z=0,queueMicrotask(Ee))})},onWillRemoveListener(){Pe&&me>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,se.dispose()}};G||f(je);const We=new s(je);return G?.add(We),We.event}b.debounce=ge;function ee(fe,te=0,de){return b.debounce(fe,(be,Pe)=>be?(be.push(Pe),be):[Pe],te,void 0,!0,void 0,de)}b.accumulate=ee;function Q(fe,te=(be,Pe)=>be===Pe,de){let be=!0,Pe;return M(fe,z=>{const G=be||!te(z,Pe);return be=!1,Pe=z,G},de)}b.latch=Q;function X(fe,te,de){return[b.filter(fe,te,de),b.filter(fe,be=>!te(be),de)]}b.split=X;function ae(fe,te=!1,de=[],be){let Pe=de.slice(),z=fe(oe=>{Pe?Pe.push(oe):se.fire(oe)});be&&be.add(z);const G=()=>{Pe?.forEach(oe=>se.fire(oe)),Pe=null},se=new s({onWillAddFirstListener(){z||(z=fe(oe=>se.fire(oe)),be&&be.add(z))},onDidAddFirstListener(){Pe&&(te?setTimeout(G):G())},onDidRemoveLastListener(){z&&z.dispose(),z=null}});return be&&be.add(se),se.event}b.buffer=ae;function ie(fe,te){return(be,Pe,z)=>{const G=te(new we);return fe(function(se){const oe=G.evaluate(se);oe!==ce&&be.call(Pe,oe)},void 0,z)}}b.chain=ie;const ce=Symbol("HaltChainable");class we{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(de=>(te(de),de)),this}filter(te){return this.f.push(de=>te(de)?de:ce),this}reduce(te,de){let be=de;return this.f.push(Pe=>(be=te(be,Pe),be)),this}latch(te=(de,be)=>de===be){let de=!0,be;return this.f.push(Pe=>{const z=de||!te(Pe,be);return de=!1,be=Pe,z?Pe:ce}),this}evaluate(te){for(const de of this.f)if(te=de(te),te===ce)break;return te}}function H(fe,te,de=be=>be){const be=(...se)=>G.fire(de(...se)),Pe=()=>fe.on(te,be),z=()=>fe.removeListener(te,be),G=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:z});return G.event}b.fromNodeEventEmitter=H;function B(fe,te,de=be=>be){const be=(...se)=>G.fire(de(...se)),Pe=()=>fe.addEventListener(te,be),z=()=>fe.removeEventListener(te,be),G=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:z});return G.event}b.fromDOMEventEmitter=B;function J(fe){return new Promise(te=>P(fe)(te))}b.toPromise=J;function re(fe){const te=new s;return fe.then(de=>{te.fire(de)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}b.fromPromise=re;function Y(fe,te){return te(void 0),fe(de=>te(de))}b.runAndSubscribe=Y;function _(fe,te){let de=null;function be(z){de?.dispose(),de=new d.$Rc,te(z,de)}be(void 0);const Pe=fe(z=>be(z));return(0,d.$Qc)(()=>{Pe.dispose(),de?.dispose()})}b.runAndSubscribeWithStore=_;class x{constructor(te,de){this._observable=te,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};de||f(be),this.emitter=new s(be),de&&de.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,de){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(fe,te){return new x(fe,te).emitter.event}b.fromObservable=pe;function ue(fe){return te=>{let de=0,be=!1;const Pe={beginUpdate(){de++},endUpdate(){de--,de===0&&(fe.reportChanges(),be&&(be=!1,te()))},handlePossibleChange(){},handleChange(){be=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}b.fromObservableLight=ue})(v||(e.Event=v={}));class R{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${R.f++}`,R.all.add(this)}start(f){this.g=new A.$Jd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Ld=R;let I=-1;function w(b){const f=I;return I=b,{dispose(){I=f}}}e.$Md=w;class y{constructor(f,g=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=g,this.g=0}dispose(){this.f?.clear()}check(f,g){const P=this.threshold;if(P<=0||g<P)return;this.f||(this.f=new Map);const N=this.f.get(f.value)||0;if(this.f.set(f.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let O,M=0;for(const[j,U]of this.f)(!O||M<U)&&(O=j,M=U);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${M}):`),console.warn(O)}return()=>{const O=this.f.get(f.value)||0;this.f.set(f.value,O-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class u{constructor(f){this.value=f,this.id=p++}}const o=2,r=(b,f)=>{if(b instanceof u)f(b);else for(let g=0;g<b.length;g++){const P=b[g];P&&f(P)}};class s{constructor(f){this.w=0,this.f=f,this.g=I>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const f=this.t;queueMicrotask(()=>{r(f,g=>g.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,g,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),d.$Sc.None;if(this.m)return d.$Sc.None;g&&(f=f.bind(g));const N=new u(f);let O,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=k.create(),O=this.g.check(N.stack,this.w+1)),$&&(N.stack=M??k.create()),this.t?this.t instanceof u?(this.u??=new h,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,d.$Qc)(()=>{O?.(),this.x(N)});return P instanceof d.$Rc?P.add(j):Array.isArray(P)&&P.push(j),j},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const g=this.t,P=g.indexOf(f);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,g[P]=void 0;const N=this.u.current===this;if(this.w*o<=g.length){let O=0;for(let M=0;M<g.length;M++)g[M]?g[O++]=g[M]:N&&(this.u.end--,O<this.u.i&&this.u.i--);g.length=O}}y(f,g){if(!f)return;const P=this.f?.onListenerError||C.$1;if(!P){f.value(g);return}try{f.value(g)}catch(N){P(N)}}z(f){const g=f.current.t;for(;f.i<f.end;)this.y(g[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,f);else{const g=this.u;g.enqueue(this,f,this.t.length),this.z(g)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=s;const m=()=>new h;e.$Od=m;class h{constructor(){this.i=-1,this.end=0}enqueue(f,g,P){this.i=0,this.end=P,this.current=f,this.value=g}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends s{async fireAsync(f,g,P){if(this.t)for(this.h||(this.h=new L.$2c),r(this.t,N=>this.h.push([N.value,f]));this.h.size>0&&!g.isCancellationRequested;){const[N,O]=this.h.shift(),M=[],j={...O,token:g,waitUntil:U=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(U=P(U,N)),M.push(U)}};try{N(j)}catch(U){(0,C.$1)(U);continue}Object.freeze(M),await Promise.allSettled(M).then(U=>{for(const T of U)T.status==="rejected"&&(0,C.$1)(T.reason)})}}}e.$Pd=t;class n extends s{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new L.$2c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Qd=n;class c extends n{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Rd=c;class i extends s{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(g=>super.fire(g)),this.h=[]}))}}e.$Sd=i;class a{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const g={event:f,listener:null};this.h.push(g),this.g&&this.m(g);const P=()=>{this.g&&this.o(g);const N=this.h.indexOf(g);this.h.splice(N,1)};return(0,d.$Qc)((0,F.$db)(P))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(g=>this.f.fire(g))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Td=a;class l{constructor(f,g,P,N){this.f=new d.$Rc;const O=this.f.add(new a),M=this.f.add(new d.$1c);function j(U){M.set(U,O.add(N(U)))}for(const U of f)j(U);this.f.add(g(U=>{j(U)})),this.f.add(P(U=>{M.deleteAndDispose(U)})),this.event=O.event}dispose(){this.f.dispose()}}e.$Ud=l;class D{constructor(){this.f=[]}wrapEvent(f){return(g,P,N)=>f(O=>{const M=this.f[this.f.length-1];M?M.push(()=>g.call(P,O)):g.call(P,O)},void 0,N)}bufferEvents(f){const g=[];this.f.push(g);const P=f();return this.f.pop(),g.forEach(N=>N()),P}}e.$Vd=D;class S{constructor(){this.f=!1,this.g=v.None,this.h=d.$Sc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=S}),define(De[21],Ce([1,0,4]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const F=Object.freeze(function($,E){const v=setTimeout($.bind(E),0);return{dispose(){clearTimeout(v)}}});var d;(function($){function E(v){return v===$.None||v===$.Cancelled||v instanceof L?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}$.isCancellationToken=E,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(d||(e.CancellationToken=d={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new C.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=d.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=d.None}}e.$Xd=A}),define(De[159],Ce([1,0,21]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class F{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new C.$Xd,E=this.b($.token);return this.a={promise:E,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$we=F;class d{constructor($){this.c=$,this.a=void 0,this.b=void 0}get($){const E=JSON.stringify($);return this.b!==E&&(this.b=E,this.a=this.c($)),this.a}}e.$xe=d;class L{get cachedValues(){return this.a}constructor($){this.b=$,this.a=new Map}get($){if(this.a.has($))return this.a.get($);const E=this.b($);return this.a.set($,E),E}}e.$ye=L}),define(De[96],Ce([1,0,9,3]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function d(m){const h=m;return h?typeof h.read=="function":!1}e.$Yd=d;function L(m){const h=m;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$Zd=L;function A(m){const h=m;return h?L(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$1d=A;function $(m,h){return new E(m,h)}e.$2d=$;class E{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,C.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let n;switch(h){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const c=n.indexOf(t);c>=0&&n.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v(m,h){const t=[];let n;for(;(n=m.read())!==null;)t.push(n);return h(t)}e.$3d=v;function R(m,h,t){const n=[];let c;for(;(c=m.read())!==null&&n.length<t;)n.push(c);return c===null&&n.length>0?h(n):{read:()=>{if(n.length>0)return n.shift();if(typeof c<"u"){const i=c;return c=void 0,i}return m.read()}}}e.$4d=R;function I(m,h){return new Promise((t,n)=>{const c=[];w(m,{onData:i=>{h&&c.push(i)},onError:i=>{h?n(i):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}e.$5d=I;function w(m,h,t){m.on("error",n=>{t?.isCancellationRequested||h.onError(n)}),m.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),m.on("data",n=>{t?.isCancellationRequested||h.onData(n)})}e.$6d=w;function y(m,h){return new Promise((t,n)=>{const c=new F.$Rc,i=[],a=S=>{if(i.push(S),i.length>h)return c.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},l=S=>(c.dispose(),n(S)),D=()=>(c.dispose(),t({stream:m,buffer:i,ended:!0}));c.add((0,F.$Qc)(()=>m.removeListener("error",l))),m.on("error",l),c.add((0,F.$Qc)(()=>m.removeListener("end",D))),m.on("end",D),c.add((0,F.$Qc)(()=>m.removeListener("data",a))),m.on("data",a)})}e.$7d=y;function k(m,h){const t=$(h);return t.end(m),t}e.$8d=k;function p(){const m=$(()=>{throw new Error("not supported")});return m.end(),m}e.$9d=p;function u(m){let h=!1;return{read:()=>h?null:(h=!0,m)}}e.$0d=u;function o(m,h,t){const n=$(t);return w(m,{onData:c=>n.write(h.data(c)),onError:c=>n.error(h.error?h.error(c):c),onEnd:()=>n.end()}),n}e.$$d=o;function r(m,h,t){let n=!1;return{read:()=>{const c=h.read();return n?c:(n=!0,c!==null?t([m,c]):m)}}}e.$_d=r;function s(m,h,t){let n=!1;const c=$(t);return w(h,{onData:i=>n?c.write(i):(n=!0,c.write(t([m,i]))),onError:i=>c.error(i),onEnd:()=>{n||(n=!0,c.write(m)),c.end()}}),c}e.$ae=s}),define(De[22],Ce([1,0,47,96]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const d=typeof Buffer<"u",L=new C.$V(()=>new Uint8Array(256));let A,$;class E{static alloc(g){return d?new E(Buffer.allocUnsafe(g)):new E(new Uint8Array(g))}static wrap(g){return d&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new E(g)}static fromString(g,P){return!(P?.dontUseNodeBuffer||!1)&&d?new E(Buffer.from(g)):(A||(A=new TextEncoder),new E(A.encode(g)))}static fromByteArray(g){const P=E.alloc(g.length);for(let N=0,O=g.length;N<O;N++)P.buffer[N]=g[N];return P}static concat(g,P){if(typeof P>"u"){P=0;for(let M=0,j=g.length;M<j;M++)P+=g[M].byteLength}const N=E.alloc(P);let O=0;for(let M=0,j=g.length;M<j;M++){const U=g[M];N.set(U,O),O+=U.byteLength}return N}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=E.alloc(this.byteLength);return g.set(this),g}toString(){return d?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(g,P){return new E(this.buffer.subarray(g,P))}set(g,P){if(g instanceof E)this.buffer.set(g.buffer,P);else if(g instanceof Uint8Array)this.buffer.set(g,P);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),P);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return w(this.buffer,g)}writeUInt32BE(g,P){y(this.buffer,g,P)}readUInt32LE(g){return k(this.buffer,g)}writeUInt32LE(g,P){p(this.buffer,g,P)}readUInt8(g){return u(this.buffer,g)}writeUInt8(g,P){o(this.buffer,g,P)}indexOf(g,P=0){return v(this.buffer,g instanceof E?g.buffer:g,P)}}e.$be=E;function v(f,g,P=0){const N=g.byteLength,O=f.byteLength;if(N===0)return 0;if(N===1)return f.indexOf(g[0]);if(N>O-P)return-1;const M=L.value;M.fill(g.length);for(let K=0;K<g.length;K++)M[g[K]]=g.length-K-1;let j=P+g.length-1,U=j,T=-1;for(;j<O;)if(f[j]===g[U]){if(U===0){T=j;break}j--,U--}else j+=Math.max(g.length-U,M[f[j]]),U=g.length-1;return T}e.$ce=v;function R(f,g){return f[g+0]<<0>>>0|f[g+1]<<8>>>0}e.$de=R;function I(f,g,P){f[P+0]=g&255,g=g>>>8,f[P+1]=g&255}e.$ee=I;function w(f,g){return f[g]*2**24+f[g+1]*2**16+f[g+2]*2**8+f[g+3]}e.$fe=w;function y(f,g,P){f[P+3]=g,g=g>>>8,f[P+2]=g,g=g>>>8,f[P+1]=g,g=g>>>8,f[P]=g}e.$ge=y;function k(f,g){return f[g+0]<<0>>>0|f[g+1]<<8>>>0|f[g+2]<<16>>>0|f[g+3]<<24>>>0}e.$he=k;function p(f,g,P){f[P+0]=g&255,g=g>>>8,f[P+1]=g&255,g=g>>>8,f[P+2]=g&255,g=g>>>8,f[P+3]=g&255}e.$ie=p;function u(f,g){return f[g]}e.$je=u;function o(f,g,P){f[P]=g}e.$ke=o;function r(f){return F.$3d(f,g=>E.concat(g))}e.$le=r;function s(f){return F.$0d(f)}e.$me=s;function m(f){return F.$5d(f,g=>E.concat(g))}e.$ne=m;async function h(f){return f.ended?E.concat(f.buffer):E.concat([...f.buffer,await m(f.stream)])}e.$oe=h;function t(f){return F.$8d(f,g=>E.concat(g))}e.$pe=t;function n(f){return F.$$d(f,{data:g=>typeof g=="string"?E.fromString(g):E.wrap(g)},g=>E.concat(g))}e.$qe=n;function c(f){return F.$2d(g=>E.concat(g),f)}e.$re=c;function i(f,g){return F.$_d(f,g,P=>E.concat(P))}e.$se=i;function a(f,g){return F.$ae(f,g,P=>E.concat(P))}e.$te=a;function l(f){let g=0,P=0,N=0;const O=new Uint8Array(Math.floor(f.length/4*3)),M=U=>{switch(P){case 3:O[N++]=g|U,P=0;break;case 2:O[N++]=g|U>>>2,g=U<<6,P=3;break;case 1:O[N++]=g|U>>>4,g=U<<4,P=2;break;default:g=U<<2,P=1}};for(let U=0;U<f.length;U++){const T=f.charCodeAt(U);if(T>=65&&T<=90)M(T-65);else if(T>=97&&T<=122)M(T-97+26);else if(T>=48&&T<=57)M(T-48+52);else if(T===43||T===45)M(62);else if(T===47||T===95)M(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${f[U]}`)}}const j=N;for(;P>0;)M(0);return E.wrap(O).slice(0,j)}e.$ue=l;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:f},g=!0,P=!1){const N=P?S:D;let O="";const M=f.byteLength%3;let j=0;for(;j<f.byteLength-M;j+=3){const U=f[j+0],T=f[j+1],K=f[j+2];O+=N[U>>>2],O+=N[(U<<4|T>>>4)&63],O+=N[(T<<2|K>>>6)&63],O+=N[K&63]}if(M===1){const U=f[j+0];O+=N[U>>>2],O+=N[U<<4&63],g&&(O+="==")}else if(M===2){const U=f[j+0],T=f[j+1];O+=N[U>>>2],O+=N[(U<<4|T>>>4)&63],O+=N[T<<2&63],g&&(O+="=")}return O}e.$ve=b}),define(De[15],Ce([1,0,159,47]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function d(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Be=d;const L=/{(\d+)}/g;function A(Ae,...Ne){return Ne.length===0?Ae:Ae.replace(L,function(qe,Le){const Xe=parseInt(Le,10);return isNaN(Xe)||Xe<0||Xe>=Ne.length?qe:Ne[Xe]})}e.$Ce=A;const $=/{([^}]+)}/g;function E(Ae,Ne){return Ae.replace($,(qe,Le)=>Ne[Le]??qe)}e.$De=E;function v(Ae){return Ae.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}e.$Ee=v;function R(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=R;function I(Ae,Ne){let qe=0;const Le=Ne.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Le&&qe++;return qe}e.$Ge=I;function w(Ae,Ne,qe="\u2026"){return Ae.length<=Ne?Ae:`${Ae.substr(0,Ne)}${qe}`}e.$He=w;function y(Ae,Ne=" "){const qe=k(Ae,Ne);return p(qe,Ne)}e.$Ie=y;function k(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length;if(qe===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Ne,Le)===Le;)Le=Le+qe;return Ae.substring(Le)}e.$Je=k;function p(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length,Le=Ae.length;if(qe===0||Le===0)return Ae;let Xe=Le,he=-1;for(;he=Ae.lastIndexOf(Ne,Xe-1),!(he===-1||he+qe!==Xe);){if(he===0)return"";Xe=he}return Ae.substring(0,Xe)}e.$Ke=p;function u(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=u;function o(Ae){return Ae.replace(/\*/g,"")}e.$Me=o;function r(Ae,Ne,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ne||(Ae=R(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return qe.global&&(Le+="g"),qe.matchCase||(Le+="i"),qe.multiline&&(Le+="m"),qe.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Ne=r;function s(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Oe=s;function m(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Pe=m;function h(Ae){for(let Ne=0,qe=Ae.length;Ne<qe;Ne++){const Le=Ae.charCodeAt(Ne);if(Le!==32&&Le!==9)return Ne}return-1}e.$Qe=h;function t(Ae,Ne=0,qe=Ae.length){for(let Le=Ne;Le<qe;Le++){const Xe=Ae.charCodeAt(Le);if(Xe!==32&&Xe!==9)return Ae.substring(Ne,Le)}return Ae.substring(Ne,qe)}e.$Re=t;function n(Ae,Ne=Ae.length-1){for(let qe=Ne;qe>=0;qe--){const Le=Ae.charCodeAt(qe);if(Le!==32&&Le!==9)return qe}return-1}e.$Se=n;function c(Ae,Ne,qe){const Le=[];let Xe=0;for(const he of Ae.matchAll(Ne)){if(Le.push(Ae.slice(Xe,he.index)),he.index===void 0)throw new Error("match.index should be defined");Xe=he.index+he[0].length,Le.push(qe(he[0],...he.slice(1),he.index,Ae,he.groups))}return Le.push(Ae.slice(Xe)),Promise.all(Le).then(he=>he.join(""))}e.$Te=c;function i(Ae,Ne){return Ae<Ne?-1:Ae>Ne?1:0}e.$Ue=i;function a(Ae,Ne,qe=0,Le=Ae.length,Xe=0,he=Ne.length){for(;qe<Le&&Xe<he;qe++,Xe++){const Ve=Ae.charCodeAt(qe),ze=Ne.charCodeAt(Xe);if(Ve<ze)return-1;if(Ve>ze)return 1}const le=Le-qe,Ie=he-Xe;return le<Ie?-1:le>Ie?1:0}e.$Ve=a;function l(Ae,Ne){return D(Ae,Ne,0,Ae.length,0,Ne.length)}e.$We=l;function D(Ae,Ne,qe=0,Le=Ae.length,Xe=0,he=Ne.length){for(;qe<Le&&Xe<he;qe++,Xe++){let Ve=Ae.charCodeAt(qe),ze=Ne.charCodeAt(Xe);if(Ve===ze)continue;if(Ve>=128||ze>=128)return a(Ae.toLowerCase(),Ne.toLowerCase(),qe,Le,Xe,he);b(Ve)&&(Ve-=32),b(ze)&&(ze-=32);const xe=Ve-ze;if(xe!==0)return xe}const le=Le-qe,Ie=he-Xe;return le<Ie?-1:le>Ie?1:0}e.$Xe=D;function S(Ae){return Ae>=48&&Ae<=57}e.$Ye=S;function b(Ae){return Ae>=97&&Ae<=122}e.$Ze=b;function f(Ae){return Ae>=65&&Ae<=90}e.$1e=f;function g(Ae,Ne){return Ae.length===Ne.length&&D(Ae,Ne)===0}e.$2e=g;function P(Ae,Ne){const qe=Ne.length;return Ne.length>Ae.length?!1:D(Ae,Ne,0,qe)===0}e.$3e=P;function N(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Le;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Le)!==Ne.charCodeAt(Le))return Le;return qe}e.$4e=N;function O(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Le;const Xe=Ae.length-1,he=Ne.length-1;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Xe-Le)!==Ne.charCodeAt(he-Le))return Le;return qe}e.$5e=O;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$6e=M;function j(Ae){return 56320<=Ae&&Ae<=57343}e.$7e=j;function U(Ae,Ne){return(Ae-55296<<10)+(Ne-56320)+65536}e.$8e=U;function T(Ae,Ne,qe){const Le=Ae.charCodeAt(qe);if(M(Le)&&qe+1<Ne){const Xe=Ae.charCodeAt(qe+1);if(j(Xe))return U(Le,Xe)}return Le}e.$9e=T;function K(Ae,Ne){const qe=Ae.charCodeAt(Ne-1);if(j(qe)&&Ne>1){const Le=Ae.charCodeAt(Ne-2);if(M(Le))return U(Le,qe)}return qe}class q{get offset(){return this.e}constructor(Ne,qe=0){this.c=Ne,this.d=Ne.length,this.e=qe}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=K(this.c,this.e);return this.e-=Ne>=65536?2:1,Ne}nextCodePoint(){const Ne=T(this.c,this.d,this.e);return this.e+=Ne>=65536?2:1,Ne}eol(){return this.e>=this.d}}e.$0e=q;class ge{get offset(){return this.c.offset}constructor(Ne,qe=0){this.c=new q(Ne,qe)}nextGraphemeLength(){const Ne=me.getInstance(),qe=this.c,Le=qe.offset;let Xe=Ne.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const he=qe.offset,le=Ne.getGraphemeBreakType(qe.nextCodePoint());if(oe(Xe,le)){qe.setOffset(he);break}Xe=le}return qe.offset-Le}prevGraphemeLength(){const Ne=me.getInstance(),qe=this.c,Le=qe.offset;let Xe=Ne.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const he=qe.offset,le=Ne.getGraphemeBreakType(qe.prevCodePoint());if(oe(le,Xe)){qe.setOffset(he);break}Xe=le}return Le-qe.offset}eol(){return this.c.eol()}}e.$$e=ge;function ee(Ae,Ne){return new ge(Ae,Ne).nextGraphemeLength()}e.$_e=ee;function Q(Ae,Ne){return new ge(Ae,Ne).prevGraphemeLength()}e.$af=Q;function X(Ae,Ne){Ne>0&&j(Ae.charCodeAt(Ne))&&Ne--;const qe=Ne+ee(Ae,Ne);return[qe-Q(Ae,qe),qe]}e.$bf=X;function ae(Ae){const Ne=new ge(Ae);let qe=0;for(;!Ne.eol();)qe++,Ne.nextGraphemeLength();return qe}e.$cf=ae;let ie;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(Ae){return ie||(ie=ce()),ie.test(Ae)}e.$df=we;const H=/^[\t\n\r\x20-\x7E]*$/;function B(Ae){return H.test(Ae)}e.$ef=B,e.$ff=/[\u2028\u2029]/;function J(Ae){return e.$ff.test(Ae)}e.$gf=J;function re(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$hf=re;function Y(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$if=Y;function _(Ae,Ne){if(Ae.length<Ne)return Ae;const qe=/\b/g;let Le=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Ne);)Le=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$jf=_;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,pe=/\x1b\].*?\x07/g;function ue(Ae){return Ae&&(Ae=Ae.replace(x,"").replace(pe,"")),Ae}e.$kf=ue,e.$lf=String.fromCharCode(65279);function fe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$mf=fe;function te(Ae){return fe(Ae)?Ae.substr(1):Ae}e.$nf=te;function de(Ae,Ne){if(!Ae||!Ne||Ae.length<Ne.length)return!1;const qe=Ne.length,Le=Ae.toLowerCase();let Xe=0,he=-1;for(;Xe<qe;){const le=Le.indexOf(Ne[Xe],he+1);if(le<0)return!1;he=le,Xe++}return!0}e.$of=de;function be(Ae,Ne=!1){return Ae?(Ne&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$pf=be;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$qf=Pe;function z(Ae,Ne=1){if(Ne===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Ne--;while(Ne>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$rf=z;function G(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$sf=G;function se(Ae){return me.getInstance().getGraphemeBreakType(Ae)}e.$tf=se;function oe(Ae,Ne){return Ae===0?Ne!==5&&Ne!==7:Ae===2&&Ne===3?!1:Ae===4||Ae===2||Ae===3||Ne===4||Ne===2||Ne===3?!0:!(Ae===8&&(Ne===8||Ne===9||Ne===11||Ne===12)||(Ae===11||Ae===9)&&(Ne===9||Ne===10)||(Ae===12||Ae===10)&&Ne===10||Ne===5||Ne===13||Ne===7||Ae===1||Ae===13&&Ne===14||Ae===6&&Ne===6)}var Z;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Z||(e.GraphemeBreakType=Z={}));class me{static{this.c=null}static getInstance(){return me.c||(me.c=new me),me.c}constructor(){this.d=Ee()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===10?3:Ne===13?2:4;if(Ne<127)return 0;const qe=this.d,Le=qe.length/3;let Xe=1;for(;Xe<=Le;)if(Ne<qe[3*Xe])Xe=2*Xe;else if(Ne>qe[3*Xe+1])Xe=2*Xe+1;else return qe[3*Xe+2];return 0}}function Ee(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Ne){if(Ae===0)return 0;const qe=We(Ae,Ne);if(qe!==void 0)return qe;const Le=new q(Ne,Ae);return Le.prevCodePoint(),Le.offset}e.$uf=je;function We(Ae,Ne){const qe=new q(Ne,Ae);let Le=qe.prevCodePoint();for(;_e(Le)||Le===65039||Le===8419;){if(qe.offset===0)return;Le=qe.prevCodePoint()}if(!Y(Le))return;let Xe=qe.offset;return Xe>0&&qe.prevCodePoint()===8205&&(Xe=qe.offset),Xe}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$vf="\xA0";class it{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$xe(Ne=>{function qe(xe){const rt=new Map;for(let ot=0;ot<xe.length;ot+=2)rt.set(xe[ot],xe[ot+1]);return rt}function Le(xe,rt){const ot=new Map(xe);for(const[$t,St]of rt)ot.set($t,St);return ot}function Xe(xe,rt){if(!xe)return rt;const ot=new Map;for(const[$t,St]of xe)rt.has($t)&&ot.set($t,St);return ot}const he=this.c.value;let le=Ne.filter(xe=>!xe.startsWith("_")&&xe in he);le.length===0&&(le=["_default"]);let Ie;for(const xe of le){const rt=qe(he[xe]);Ie=Xe(Ie,rt)}const Ve=qe(he._common),ze=Le(Ve,Ie);return new it(ze)})}static getInstance(Ne){return it.d.get(Array.from(Ne))}static{this.e=new F.$V(()=>Object.keys(it.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return it.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Ne){return et.e().has(Ne)}static get codePoints(){return et.e()}}e.$xf=et}),define(De[121],Ce([1,0,28,15]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.FuzzyScore=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.or=void 0;function d(...te){return function(de,be){for(let Pe=0,z=te.length;Pe<z;Pe++){const G=te[Pe](de,be);if(G)return G}return null}}e.or=d,e.$Cj=L.bind(void 0,!1),e.$Dj=L.bind(void 0,!0);function L(te,de,be){if(!be||be.length<de.length)return null;let Pe;return te?Pe=F.$3e(be,de):Pe=be.indexOf(de)===0,Pe?de.length>0?[{start:0,end:de.length}]:[]:null}function A(te,de){const be=de.toLowerCase().indexOf(te.toLowerCase());return be===-1?null:[{start:be,end:be+te.length}]}e.$Ej=A;function $(te,de){return E(te.toLowerCase(),de.toLowerCase(),0,0)}e.$Fj=$;function E(te,de,be,Pe){if(be===te.length)return[];if(Pe===de.length)return null;if(te[be]===de[Pe]){let z=null;return(z=E(te,de,be+1,Pe+1))?o({start:Pe,end:Pe+1},z):null}return E(te,de,be,Pe+1)}function v(te){return 97<=te&&te<=122}function R(te){return 65<=te&&te<=90}e.$Gj=R;function I(te){return 48<=te&&te<=57}function w(te){return te===32||te===9||te===10||te===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>y.add(te.charCodeAt(0)));function k(te){return w(te)||y.has(te)}function p(te,de){return te===de||k(te)&&k(de)}function u(te){return v(te)||R(te)||I(te)}function o(te,de){return de.length===0?de=[te]:te.end===de[0].start?de[0].start=te.start:de.unshift(te),de}function r(te,de){for(let be=de;be<te.length;be++){const Pe=te.charCodeAt(be);if(R(Pe)||I(Pe)||be>0&&!u(te.charCodeAt(be-1)))return be}return te.length}function s(te,de,be,Pe){if(be===te.length)return[];if(Pe===de.length)return null;if(te[be]!==de[Pe].toLowerCase())return null;{let z=null,G=Pe+1;for(z=s(te,de,be+1,Pe+1);!z&&(G=r(de,G))<de.length;)z=s(te,de,be+1,G),G++;return z===null?null:o({start:Pe,end:Pe+1},z)}}function m(te){let de=0,be=0,Pe=0,z=0,G=0;for(let Ee=0;Ee<te.length;Ee++)G=te.charCodeAt(Ee),R(G)&&de++,v(G)&&be++,u(G)&&Pe++,I(G)&&z++;const se=de/te.length,oe=be/te.length,Z=Pe/te.length,me=z/te.length;return{upperPercent:se,lowerPercent:oe,alphaPercent:Z,numericPercent:me}}function h(te){const{upperPercent:de,lowerPercent:be}=te;return be===0&&de>.6}function t(te){const{upperPercent:de,lowerPercent:be,alphaPercent:Pe,numericPercent:z}=te;return be>.2&&de<.8&&Pe>.6&&z<.2}function n(te){let de=0,be=0,Pe=0,z=0;for(let G=0;G<te.length;G++)Pe=te.charCodeAt(G),R(Pe)&&de++,v(Pe)&&be++,w(Pe)&&z++;return(de===0||be===0)&&z===0?te.length<=30:de<=5}function c(te,de){if(!de||(de=de.trim(),de.length===0)||!n(te)||de.length>60)return null;const be=m(de);if(!t(be)){if(!h(be))return null;de=de.toLowerCase()}let Pe=null,z=0;for(te=te.toLowerCase();z<de.length&&(Pe=s(te,de,0,z))===null;)z=r(de,z+1);return Pe}e.$Hj=c;function i(te,de,be=!1){if(!de||de.length===0)return null;let Pe=null,z=0;for(te=te.toLowerCase(),de=de.toLowerCase();z<de.length&&(Pe=a(te,de,0,z,be))===null;)z=l(de,z+1);return Pe}e.$Ij=i;function a(te,de,be,Pe,z){if(be===te.length)return[];if(Pe===de.length)return null;if(p(te.charCodeAt(be),de.charCodeAt(Pe))){let G=null,se=Pe+1;if(G=a(te,de,be+1,Pe+1,z),!z)for(;!G&&(se=l(de,se))<de.length;)G=a(te,de,be+1,se,z),se++;return G?te.charCodeAt(be)!==de.charCodeAt(Pe)?G:o({start:Pe,end:Pe+1},G):null}else return null}function l(te,de){for(let be=de;be<te.length;be++)if(k(te.charCodeAt(be))||be>0&&k(te.charCodeAt(be-1)))return be;return te.length}const D=d(e.$Dj,c,A),S=d(e.$Dj,c,$),b=new C.$Dc(1e4);function f(te,de,be=!1){if(typeof te!="string"||typeof de!="string")return null;let Pe=b.get(te);Pe||(Pe=new RegExp(F.$Le(te),"i"),b.set(te,Pe));const z=Pe.exec(de);return z?[{start:z.index,end:z.index+z[0].length}]:be?S(te,de):D(te,de)}e.$Jj=f;function g(te,de){const be=re(te,te.toLowerCase(),0,de,de.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?N(be):null}e.$Kj=g;function P(te,de,be,Pe,z,G){const se=Math.min(13,te.length);for(;be<se;be++){const oe=re(te,de,be,Pe,z,G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,G]}e.$Lj=P;function N(te){if(typeof te>"u")return[];const de=[],be=te[1];for(let Pe=te.length-1;Pe>1;Pe--){const z=te[Pe]+be,G=de[de.length-1];G&&G.end===z?G.end=z+1:de.push({start:z,end:z+1})}return de}e.$Mj=N;const O=128;function M(){const te=[],de=[];for(let be=0;be<=O;be++)de[be]=0;for(let be=0;be<=O;be++)te.push(de.slice(0));return te}function j(te){const de=[];for(let be=0;be<=te;be++)de[be]=0;return de}const U=j(2*O),T=j(2*O),K=M(),q=M(),ge=M(),ee=!1;function Q(te,de,be,Pe,z){function G(oe,Z,me=" "){for(;oe.length<Z;)oe=me+oe;return oe}let se=` |   |${Pe.split("").map(oe=>G(oe,3)).join("|")}
`;for(let oe=0;oe<=be;oe++)oe===0?se+=" |":se+=`${de[oe-1]}|`,se+=te[oe].slice(0,z+1).map(Z=>G(Z.toString(),3)).join("|")+`
`;return se}function X(te,de,be,Pe){te=te.substr(de),be=be.substr(Pe),console.log(Q(q,te,te.length,be,be.length)),console.log(Q(ge,te,te.length,be,be.length)),console.log(Q(K,te,te.length,be,be.length))}function ae(te,de){if(de<0||de>=te.length)return!1;const be=te.codePointAt(de);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$if(be)}}function ie(te,de){if(de<0||de>=te.length)return!1;switch(te.charCodeAt(de)){case 32:case 9:return!0;default:return!1}}function ce(te,de,be){return de[te]!==be[te]}function we(te,de,be,Pe,z,G,se=!1){for(;de<be&&z<G;)te[de]===Pe[z]&&(se&&(U[de]=z),de+=1),z+=1;return de===be}e.$Nj=we;var H;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(H||(H={}));var B;(function(te){te.Default=[-100,0];function de(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}te.isDefault=de})(B||(e.FuzzyScore=B={}));class J{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(de,be){this.firstMatchCanBeWeak=de,this.boostFullMatch=be}}e.$Oj=J;function re(te,de,be,Pe,z,G,se=J.default){const oe=te.length>O?O:te.length,Z=Pe.length>O?O:Pe.length;if(be>=oe||G>=Z||oe-be>Z-G||!we(de,be,oe,z,G,Z,!0))return;Y(oe,Z,be,G,de,z);let me=1,Ee=1,je=be,We=G;const _e=[!1];for(me=1,je=be;je<oe;me++,je++){const Ne=U[je],qe=T[je],Le=je+1<oe?T[je+1]:Z;for(Ee=Ne-G+1,We=Ne;We<Le;Ee++,We++){let Xe=Number.MIN_SAFE_INTEGER,he=!1;We<=qe&&(Xe=_(te,de,je,be,Pe,z,We,Z,G,K[me-1][Ee-1]===0,_e));let le=0;Xe!==Number.MAX_SAFE_INTEGER&&(he=!0,le=Xe+q[me-1][Ee-1]);const Ie=We>Ne,Ve=Ie?q[me][Ee-1]+(K[me][Ee-1]>0?-5:0):0,ze=We>Ne+1&&K[me][Ee-1]>0,xe=ze?q[me][Ee-2]+(K[me][Ee-2]>0?-5:0):0;if(ze&&(!Ie||xe>=Ve)&&(!he||xe>=le))q[me][Ee]=xe,ge[me][Ee]=3,K[me][Ee]=0;else if(Ie&&(!he||Ve>=le))q[me][Ee]=Ve,ge[me][Ee]=2,K[me][Ee]=0;else if(he)q[me][Ee]=le,ge[me][Ee]=1,K[me][Ee]=K[me-1][Ee-1]+1;else throw new Error("not possible")}}if(ee&&X(te,be,Pe,G),!_e[0]&&!se.firstMatchCanBeWeak)return;me--,Ee--;const Ye=[q[me][Ee],G];let it=0,et=0;for(;me>=1;){let Ne=Ee;do{const qe=ge[me][Ne];if(qe===3)Ne=Ne-2;else if(qe===2)Ne=Ne-1;else break}while(Ne>=1);it>1&&de[be+me-1]===z[G+Ee-1]&&!ce(Ne+G-1,Pe,z)&&it+1>K[me][Ne]&&(Ne=Ee),Ne===Ee?it++:it=1,et||(et=Ne),me--,Ee=Ne-1,Ye.push(Ee)}Z===oe&&se.boostFullMatch&&(Ye[0]+=2);const Ae=et-oe;return Ye[0]-=Ae,Ye}e.$Pj=re;function Y(te,de,be,Pe,z,G){let se=te-1,oe=de-1;for(;se>=be&&oe>=Pe;)z[se]===G[oe]&&(T[se]=oe,se--),oe--}function _(te,de,be,Pe,z,G,se,oe,Z,me,Ee){if(de[be]!==G[se])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return se===be-Pe?je=te[be]===z[se]?7:5:ce(se,z,G)&&(se===0||!ce(se-1,z,G))?(je=te[be]===z[se]?7:5,We=!0):ae(G,se)&&(se===0||!ae(G,se-1))?je=5:(ae(G,se-1)||ie(G,se-1))&&(je=5,We=!0),je>1&&be===Pe&&(Ee[0]=!0),We||(We=ce(se,z,G)||ae(G,se-1)||ie(G,se-1)),be===Pe?se>Z&&(je-=We?3:5):me?je+=We?2:0:je+=We?0:1,se+1===oe&&(je-=We?3:5),je}function x(te,de,be,Pe,z,G,se){return ue(te,de,be,Pe,z,G,!0,se)}e.$Qj=x;function pe(te,de,be,Pe,z,G,se){return ue(te,de,be,Pe,z,G,!1,se)}e.$Rj=pe;function ue(te,de,be,Pe,z,G,se,oe){let Z=re(te,de,be,Pe,z,G,oe);if(Z&&!se)return Z;if(te.length>=3){const me=Math.min(7,te.length-1);for(let Ee=be+1;Ee<me;Ee++){const je=fe(te,Ee);if(je){const We=re(je,je.toLowerCase(),be,Pe,z,G,oe);We&&(We[0]-=3,(!Z||We[0]>Z[0])&&(Z=We))}}}return Z}function fe(te,de){if(de+1>=te.length)return;const be=te[de],Pe=te[de+1];if(be!==Pe)return te.slice(0,de)+Pe+be+te.slice(de+2)}}),define(De[52],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function F(o){return d(o,0)}e.$Di=F;function d(o,r){switch(typeof o){case"object":return o===null?L(349,r):Array.isArray(o)?E(o,r):v(o,r);case"string":return $(o,r);case"boolean":return A(o,r);case"number":return L(o,r);case"undefined":return L(937,r);default:return L(617,r)}}e.$Ei=d;function L(o,r){return(r<<5)-r+o|0}e.$Fi=L;function A(o,r){return L(o?433:863,r)}function $(o,r){r=L(149417,r);for(let s=0,m=o.length;s<m;s++)r=L(o.charCodeAt(s),r);return r}e.$Gi=$;function E(o,r){return r=L(104579,r),o.reduce((s,m)=>d(m,s),r)}function v(o,r){return r=L(181387,r),Object.keys(o).sort().reduce((s,m)=>(s=$(m,s),d(o[m],s)),r)}class R{constructor(){this.g=0}get value(){return this.g}hash(r){return this.g=d(r,this.g),this.g}}e.$Hi=R;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function w(o,r,s=32){const m=s-r,h=~((1<<m)-1);return(o<<r|(h&o)>>>m)>>>0}function y(o,r=0,s=o.byteLength,m=0){for(let h=0;h<s;h++)o[r+h]=m}function k(o,r,s="0"){for(;o.length<r;)o=s+o;return o}function p(o,r=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(s=>s.toString(16).padStart(2,"0")).join(""):k((o>>>0).toString(16),r/4)}e.$Ii=p;class u{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(r){const s=r.length;if(s===0)return;const m=this.p;let h=this.r,t=this.u,n,c;for(t!==0?(n=t,c=-1,t=0):(n=r.charCodeAt(0),c=0);;){let i=n;if(C.$6e(n))if(c+1<s){const a=r.charCodeAt(c+1);C.$7e(a)?(c++,i=C.$8e(n,a)):i=65533}else{t=n;break}else C.$7e(n)&&(i=65533);if(h=this.w(m,h,i),c++,c<s)n=r.charCodeAt(c);else break}this.r=h,this.u=t}w(r,s,m){return m<128?r[s++]=m:m<2048?(r[s++]=192|(m&1984)>>>6,r[s++]=128|(m&63)>>>0):m<65536?(r[s++]=224|(m&61440)>>>12,r[s++]=128|(m&4032)>>>6,r[s++]=128|(m&63)>>>0):(r[s++]=240|(m&1835008)>>>18,r[s++]=128|(m&258048)>>>12,r[s++]=128|(m&4032)>>>6,r[s++]=128|(m&63)>>>0),s>=64&&(this.y(),s-=64,this.t+=64,r[0]=r[64+0],r[1]=r[64+1],r[2]=r[64+2]),s}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const r=8*this.t;this.q.setUint32(56,Math.floor(r/4294967296),!1),this.q.setUint32(60,r%4294967296,!1),this.y()}y(){const r=u.g,s=this.q;for(let D=0;D<64;D+=4)r.setUint32(D,s.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)r.setUint32(D,w(r.getUint32(D-12,!1)^r.getUint32(D-32,!1)^r.getUint32(D-56,!1)^r.getUint32(D-64,!1),1),!1);let m=this.h,h=this.l,t=this.m,n=this.n,c=this.o,i,a,l;for(let D=0;D<80;D++)D<20?(i=h&t|~h&n,a=1518500249):D<40?(i=h^t^n,a=1859775393):D<60?(i=h&t|h&n|t&n,a=2400959708):(i=h^t^n,a=3395469782),l=w(m,5)+i+c+a+r.getUint32(D*4,!1)&4294967295,c=n,n=t,t=w(h,30),h=m,m=l;this.h=this.h+m&4294967295,this.l=this.l+h&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+c&4294967295}}e.$Ji=u}),define(De[38],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(d){d[d.Ignore=0]="Ignore",d[d.Info=1]="Info",d[d.Warning=2]="Warning",d[d.Error=3]="Error"})(F||(F={})),function(d){const L="error",A="warning",$="warn",E="info",v="ignore";function R(w){return w?C.$2e(L,w)?d.Error:C.$2e(A,w)||C.$2e($,w)?d.Warning:C.$2e(E,w)?d.Info:d.Ignore:d.Ignore}d.fromValue=R;function I(w){switch(w){case d.Error:return L;case d.Warning:return A;case d.Info:return E;default:return v}}d.toString=I}(F||(F={})),e.default=F}),define(De[160],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(De[78],Ce([1,0,19,15]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class d{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const k=y.charCodeAt(0),p=this.b.charCodeAt(this.c);return k-p}value(){return this.b[this.c]}}e.$Rh=d;class L{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,F.$Ve)(y,this.b,0,y.length,this.c,this.d):(0,F.$Xe)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=L;class A{constructor(y=!0,k=!0){this.f=y,this.g=k}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let k=y.length-1;k>=0;k--,this.c--){const p=this.b.charCodeAt(k);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,F.$Ve)(y,this.b,0,y.length,this.d,this.e):(0,F.$Xe)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=A;var $;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})($||($={}));class E{constructor(y,k){this.f=y,this.g=k,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,F.$We)(y,this.c.scheme);if(this.d[this.e]===2)return(0,F.$We)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,F.$Ue)(y,this.c.query);if(this.d[this.e]===5)return(0,F.$Ue)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=E;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(R||(R={}));class I{static forUris(y=()=>!1,k=()=>!1){return new I(new E(y,k))}static forPaths(y=!1){return new I(new A(void 0,!y))}static forStrings(){return new I(new d)}static forConfigKeys(){return new I(new L)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,k){if(k){const p=k.slice(0);(0,C.$Xb)(p);for(const u of p)this.set(u,y)}else{const p=y.slice(0);(0,C.$Xb)(p);for(const u of p)this.set(u[0],u[1])}}set(y,k){const p=this.b.reset(y);let u;this.c||(this.c=new v,this.c.segment=p.value());const o=[];for(u=this.c;;){const s=p.cmp(u.segment);if(s>0)u.left||(u.left=new v,u.left.segment=p.value()),o.push([-1,u]),u=u.left;else if(s<0)u.right||(u.right=new v,u.right.segment=p.value()),o.push([1,u]),u=u.right;else if(p.hasNext())p.next(),u.mid||(u.mid=new v,u.mid.segment=p.value()),o.push([0,u]),u=u.mid;else break}const r=u.value;u.value=k,u.key=y;for(let s=o.length-1;s>=0;s--){const m=o[s][1];m.updateHeight();const h=m.balanceFactor();if(h<-1||h>1){const t=o[s][0],n=o[s+1][0];if(t===1&&n===1)o[s][1]=m.rotateLeft();else if(t===-1&&n===-1)o[s][1]=m.rotateRight();else if(t===1&&n===-1)m.right=o[s+1][1]=o[s+1][1].rotateRight(),o[s][1]=m.rotateLeft();else if(t===-1&&n===1)m.left=o[s+1][1]=o[s+1][1].rotateLeft(),o[s][1]=m.rotateRight();else throw new Error;if(s>0)switch(o[s-1][0]){case-1:o[s-1][1].left=o[s][1];break;case 1:o[s-1][1].right=o[s][1];break;case 0:o[s-1][1].mid=o[s][1];break}else this.c=o[0][1]}}return r}get(y){return this.d(y)?.value}d(y){const k=this.b.reset(y);let p=this.c;for(;p;){const u=k.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(k.hasNext())k.next(),p=p.mid;else break}return p}has(y){const k=this.d(y);return!(k?.value===void 0&&k?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,k){const p=this.b.reset(y),u=[];let o=this.c;for(;o;){const r=p.cmp(o.segment);if(r>0)u.push([-1,o]),o=o.left;else if(r<0)u.push([1,o]),o=o.right;else if(p.hasNext())p.next(),u.push([0,o]),o=o.mid;else break}if(o){if(k?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const r=this.f(o.right);if(r.key){const{key:s,value:m,segment:h}=r;this.e(r.key,!1),o.key=s,o.value=m,o.segment=h}}else{const r=o.left??o.right;if(u.length>0){const[s,m]=u[u.length-1];switch(s){case-1:m.left=r;break;case 0:m.mid=r;break;case 1:m.right=r;break}}else this.c=r}for(let r=u.length-1;r>=0;r--){const s=u[r][1];s.updateHeight();const m=s.balanceFactor();if(m>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),u[r][1]=s.rotateLeft()):m<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),u[r][1]=s.rotateRight()),r>0)switch(u[r-1][0]){case-1:u[r-1][1].left=u[r][1];break;case 1:u[r-1][1].right=u[r][1];break;case 0:u[r-1][1].mid=u[r][1];break}else this.c=u[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const k=this.b.reset(y);let p=this.c,u;for(;p;){const o=k.cmp(p.segment);if(o>0)p=p.left;else if(o<0)p=p.right;else if(k.hasNext())k.next(),u=p.value||u,p=p.mid;else break}return p&&p.value||u}findSuperstr(y){return this.g(y,!1)}g(y,k){const p=this.b.reset(y);let u=this.c;for(;u;){const o=p.cmp(u.segment);if(o>0)u=u.left;else if(o<0)u=u.right;else if(p.hasNext())p.next(),u=u.mid;else return u.mid?this.h(u.mid):k?u.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[k,p]of this)y(p,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const k=[];return this.j(y,k),k[Symbol.iterator]()}j(y,k){y&&(y.left&&this.j(y.left,k),y.value&&k.push([y.key,y.value]),y.mid&&this.j(y.mid,k),y.right&&this.j(y.right,k))}_isBalanced(){const y=k=>{if(!k)return!0;const p=k.balanceFactor();return p<-1||p>1?!1:y(k.left)&&y(k.right)};return y(this.c)}}e.$Vh=I}),define(De[17],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function C(h){return typeof h=="string"}e.$yf=C;function F(h){return Array.isArray(h)&&h.every(t=>C(t))}e.$zf=F;function d(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$Af=d;function L(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}e.$Bf=L;function A(h){return typeof h=="number"&&!isNaN(h)}e.$Cf=A;function $(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Df=$;function E(h){return h===!0||h===!1}e.$Ef=E;function v(h){return typeof h>"u"}e.$Ff=v;function R(h){return!I(h)}e.$Gf=R;function I(h){return v(h)||h===null}e.$Hf=I;function w(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$If=w;function y(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$Jf=y;function k(...h){const t=[];for(let n=0;n<h.length;n++){const c=h[n];if(I(c))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(c)}return t}e.$Kf=k;const p=Object.prototype.hasOwnProperty;function u(h){if(!d(h))return!1;for(const t in h)if(p.call(h,t))return!1;return!0}e.$Lf=u;function o(h){return typeof h=="function"}e.$Mf=o;function r(...h){return h.length>0&&h.every(o)}e.$Nf=r;function s(h,t){const n=Math.min(h.length,t.length);for(let c=0;c<n;c++)m(h[c],t[c])}e.$Of=s;function m(h,t){if(C(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(h instanceof t)return}catch{}if(!I(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=m}),define(De[79],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=void 0;const F=Object.create(null);function d($,E){if((0,C.$yf)(E)){const v=F[E];if(v===void 0)throw new Error(`${$} references an unknown codicon: ${E}`);E=v}return F[$]=E,{id:$}}function L(){return F}e.$Sj=L;function A(){return Object.values(e.$Uj)}e.$Tj=A,e.$Uj={add:d("add",6e4),plus:d("plus",6e4),gistNew:d("gist-new",6e4),repoCreate:d("repo-create",6e4),lightbulb:d("lightbulb",60001),lightBulb:d("light-bulb",60001),repo:d("repo",60002),repoDelete:d("repo-delete",60002),gistFork:d("gist-fork",60003),repoForked:d("repo-forked",60003),gitPullRequest:d("git-pull-request",60004),gitPullRequestAbandoned:d("git-pull-request-abandoned",60004),recordKeys:d("record-keys",60005),keyboard:d("keyboard",60005),tag:d("tag",60006),tagAdd:d("tag-add",60006),tagRemove:d("tag-remove",60006),gitPullRequestLabel:d("git-pull-request-label",60006),person:d("person",60007),personFollow:d("person-follow",60007),personOutline:d("person-outline",60007),personFilled:d("person-filled",60007),gitBranch:d("git-branch",60008),gitBranchCreate:d("git-branch-create",60008),gitBranchDelete:d("git-branch-delete",60008),sourceControl:d("source-control",60008),mirror:d("mirror",60009),mirrorPublic:d("mirror-public",60009),star:d("star",60010),starAdd:d("star-add",60010),starDelete:d("star-delete",60010),starEmpty:d("star-empty",60010),comment:d("comment",60011),commentAdd:d("comment-add",60011),alert:d("alert",60012),warning:d("warning",60012),search:d("search",60013),searchSave:d("search-save",60013),logOut:d("log-out",60014),signOut:d("sign-out",60014),logIn:d("log-in",60015),signIn:d("sign-in",60015),eye:d("eye",60016),eyeUnwatch:d("eye-unwatch",60016),eyeWatch:d("eye-watch",60016),circleFilled:d("circle-filled",60017),primitiveDot:d("primitive-dot",60017),closeDirty:d("close-dirty",60017),debugBreakpoint:d("debug-breakpoint",60017),debugBreakpointDisabled:d("debug-breakpoint-disabled",60017),debugHint:d("debug-hint",60017),primitiveSquare:d("primitive-square",60018),edit:d("edit",60019),pencil:d("pencil",60019),info:d("info",60020),issueOpened:d("issue-opened",60020),gistPrivate:d("gist-private",60021),gitForkPrivate:d("git-fork-private",60021),lock:d("lock",60021),mirrorPrivate:d("mirror-private",60021),close:d("close",60022),removeClose:d("remove-close",60022),x:d("x",60022),repoSync:d("repo-sync",60023),sync:d("sync",60023),clone:d("clone",60024),desktopDownload:d("desktop-download",60024),beaker:d("beaker",60025),microscope:d("microscope",60025),vm:d("vm",60026),deviceDesktop:d("device-desktop",60026),file:d("file",60027),fileText:d("file-text",60027),more:d("more",60028),ellipsis:d("ellipsis",60028),kebabHorizontal:d("kebab-horizontal",60028),mailReply:d("mail-reply",60029),reply:d("reply",60029),organization:d("organization",60030),organizationFilled:d("organization-filled",60030),organizationOutline:d("organization-outline",60030),newFile:d("new-file",60031),fileAdd:d("file-add",60031),newFolder:d("new-folder",60032),fileDirectoryCreate:d("file-directory-create",60032),trash:d("trash",60033),trashcan:d("trashcan",60033),history:d("history",60034),clock:d("clock",60034),folder:d("folder",60035),fileDirectory:d("file-directory",60035),symbolFolder:d("symbol-folder",60035),logoGithub:d("logo-github",60036),markGithub:d("mark-github",60036),github:d("github",60036),terminal:d("terminal",60037),console:d("console",60037),repl:d("repl",60037),zap:d("zap",60038),symbolEvent:d("symbol-event",60038),error:d("error",60039),stop:d("stop",60039),variable:d("variable",60040),symbolVariable:d("symbol-variable",60040),array:d("array",60042),symbolArray:d("symbol-array",60042),symbolModule:d("symbol-module",60043),symbolPackage:d("symbol-package",60043),symbolNamespace:d("symbol-namespace",60043),symbolObject:d("symbol-object",60043),symbolMethod:d("symbol-method",60044),symbolFunction:d("symbol-function",60044),symbolConstructor:d("symbol-constructor",60044),symbolBoolean:d("symbol-boolean",60047),symbolNull:d("symbol-null",60047),symbolNumeric:d("symbol-numeric",60048),symbolNumber:d("symbol-number",60048),symbolStructure:d("symbol-structure",60049),symbolStruct:d("symbol-struct",60049),symbolParameter:d("symbol-parameter",60050),symbolTypeParameter:d("symbol-type-parameter",60050),symbolKey:d("symbol-key",60051),symbolText:d("symbol-text",60051),symbolReference:d("symbol-reference",60052),goToFile:d("go-to-file",60052),symbolEnum:d("symbol-enum",60053),symbolValue:d("symbol-value",60053),symbolRuler:d("symbol-ruler",60054),symbolUnit:d("symbol-unit",60054),activateBreakpoints:d("activate-breakpoints",60055),archive:d("archive",60056),arrowBoth:d("arrow-both",60057),arrowDown:d("arrow-down",60058),arrowLeft:d("arrow-left",60059),arrowRight:d("arrow-right",60060),arrowSmallDown:d("arrow-small-down",60061),arrowSmallLeft:d("arrow-small-left",60062),arrowSmallRight:d("arrow-small-right",60063),arrowSmallUp:d("arrow-small-up",60064),arrowUp:d("arrow-up",60065),bell:d("bell",60066),bold:d("bold",60067),book:d("book",60068),bookmark:d("bookmark",60069),debugBreakpointConditionalUnverified:d("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:d("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:d("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:d("debug-breakpoint-data-unverified",60072),debugBreakpointData:d("debug-breakpoint-data",60073),debugBreakpointDataDisabled:d("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:d("debug-breakpoint-log-unverified",60074),debugBreakpointLog:d("debug-breakpoint-log",60075),debugBreakpointLogDisabled:d("debug-breakpoint-log-disabled",60075),briefcase:d("briefcase",60076),broadcast:d("broadcast",60077),browser:d("browser",60078),bug:d("bug",60079),calendar:d("calendar",60080),caseSensitive:d("case-sensitive",60081),check:d("check",60082),checklist:d("checklist",60083),chevronDown:d("chevron-down",60084),dropDownButton:d("drop-down-button",60084),chevronLeft:d("chevron-left",60085),chevronRight:d("chevron-right",60086),chevronUp:d("chevron-up",60087),chromeClose:d("chrome-close",60088),chromeMaximize:d("chrome-maximize",60089),chromeMinimize:d("chrome-minimize",60090),chromeRestore:d("chrome-restore",60091),circle:d("circle",60092),circleOutline:d("circle-outline",60092),debugBreakpointUnverified:d("debug-breakpoint-unverified",60092),circleSlash:d("circle-slash",60093),circuitBoard:d("circuit-board",60094),clearAll:d("clear-all",60095),clippy:d("clippy",60096),closeAll:d("close-all",60097),cloudDownload:d("cloud-download",60098),cloudUpload:d("cloud-upload",60099),code:d("code",60100),collapseAll:d("collapse-all",60101),colorMode:d("color-mode",60102),commentDiscussion:d("comment-discussion",60103),compareChanges:d("compare-changes",60157),creditCard:d("credit-card",60105),dash:d("dash",60108),dashboard:d("dashboard",60109),database:d("database",60110),debugContinue:d("debug-continue",60111),debugDisconnect:d("debug-disconnect",60112),debugPause:d("debug-pause",60113),debugRestart:d("debug-restart",60114),debugStart:d("debug-start",60115),debugStepInto:d("debug-step-into",60116),debugStepOut:d("debug-step-out",60117),debugStepOver:d("debug-step-over",60118),debugStop:d("debug-stop",60119),debug:d("debug",60120),deviceCameraVideo:d("device-camera-video",60121),deviceCamera:d("device-camera",60122),deviceMobile:d("device-mobile",60123),diffAdded:d("diff-added",60124),diffIgnored:d("diff-ignored",60125),diffModified:d("diff-modified",60126),diffRemoved:d("diff-removed",60127),diffRenamed:d("diff-renamed",60128),diff:d("diff",60129),discard:d("discard",60130),editorLayout:d("editor-layout",60131),emptyWindow:d("empty-window",60132),exclude:d("exclude",60133),extensions:d("extensions",60134),eyeClosed:d("eye-closed",60135),fileBinary:d("file-binary",60136),fileCode:d("file-code",60137),fileMedia:d("file-media",60138),filePdf:d("file-pdf",60139),fileSubmodule:d("file-submodule",60140),fileSymlinkDirectory:d("file-symlink-directory",60141),fileSymlinkFile:d("file-symlink-file",60142),fileZip:d("file-zip",60143),files:d("files",60144),filter:d("filter",60145),flame:d("flame",60146),foldDown:d("fold-down",60147),foldUp:d("fold-up",60148),fold:d("fold",60149),folderActive:d("folder-active",60150),folderOpened:d("folder-opened",60151),gear:d("gear",60152),gift:d("gift",60153),gistSecret:d("gist-secret",60154),gist:d("gist",60155),gitCommit:d("git-commit",60156),gitCompare:d("git-compare",60157),gitMerge:d("git-merge",60158),githubAction:d("github-action",60159),githubAlt:d("github-alt",60160),globe:d("globe",60161),grabber:d("grabber",60162),graph:d("graph",60163),gripper:d("gripper",60164),heart:d("heart",60165),home:d("home",60166),horizontalRule:d("horizontal-rule",60167),hubot:d("hubot",60168),inbox:d("inbox",60169),issueClosed:d("issue-closed",60324),issueReopened:d("issue-reopened",60171),issues:d("issues",60172),italic:d("italic",60173),jersey:d("jersey",60174),json:d("json",60175),bracket:d("bracket",60175),kebabVertical:d("kebab-vertical",60176),key:d("key",60177),law:d("law",60178),lightbulbAutofix:d("lightbulb-autofix",60179),linkExternal:d("link-external",60180),link:d("link",60181),listOrdered:d("list-ordered",60182),listUnordered:d("list-unordered",60183),liveShare:d("live-share",60184),loading:d("loading",60185),location:d("location",60186),mailRead:d("mail-read",60187),mail:d("mail",60188),markdown:d("markdown",60189),megaphone:d("megaphone",60190),mention:d("mention",60191),milestone:d("milestone",60192),gitPullRequestMilestone:d("git-pull-request-milestone",60192),mortarBoard:d("mortar-board",60193),move:d("move",60194),multipleWindows:d("multiple-windows",60195),mute:d("mute",60196),noNewline:d("no-newline",60197),note:d("note",60198),octoface:d("octoface",60199),openPreview:d("open-preview",60200),package:d("package",60201),paintcan:d("paintcan",60202),pin:d("pin",60203),play:d("play",60204),run:d("run",60204),plug:d("plug",60205),preserveCase:d("preserve-case",60206),preview:d("preview",60207),project:d("project",60208),pulse:d("pulse",60209),question:d("question",60210),quote:d("quote",60211),radioTower:d("radio-tower",60212),reactions:d("reactions",60213),references:d("references",60214),refresh:d("refresh",60215),regex:d("regex",60216),remoteExplorer:d("remote-explorer",60217),remote:d("remote",60218),remove:d("remove",60219),replaceAll:d("replace-all",60220),replace:d("replace",60221),repoClone:d("repo-clone",60222),repoForcePush:d("repo-force-push",60223),repoPull:d("repo-pull",60224),repoPush:d("repo-push",60225),report:d("report",60226),requestChanges:d("request-changes",60227),rocket:d("rocket",60228),rootFolderOpened:d("root-folder-opened",60229),rootFolder:d("root-folder",60230),rss:d("rss",60231),ruby:d("ruby",60232),saveAll:d("save-all",60233),saveAs:d("save-as",60234),save:d("save",60235),screenFull:d("screen-full",60236),screenNormal:d("screen-normal",60237),searchStop:d("search-stop",60238),server:d("server",60240),settingsGear:d("settings-gear",60241),settings:d("settings",60242),shield:d("shield",60243),smiley:d("smiley",60244),sortPrecedence:d("sort-precedence",60245),splitHorizontal:d("split-horizontal",60246),splitVertical:d("split-vertical",60247),squirrel:d("squirrel",60248),starFull:d("star-full",60249),starHalf:d("star-half",60250),symbolClass:d("symbol-class",60251),symbolColor:d("symbol-color",60252),symbolCustomColor:d("symbol-customcolor",60252),symbolConstant:d("symbol-constant",60253),symbolEnumMember:d("symbol-enum-member",60254),symbolField:d("symbol-field",60255),symbolFile:d("symbol-file",60256),symbolInterface:d("symbol-interface",60257),symbolKeyword:d("symbol-keyword",60258),symbolMisc:d("symbol-misc",60259),symbolOperator:d("symbol-operator",60260),symbolProperty:d("symbol-property",60261),wrench:d("wrench",60261),wrenchSubaction:d("wrench-subaction",60261),symbolSnippet:d("symbol-snippet",60262),tasklist:d("tasklist",60263),telescope:d("telescope",60264),textSize:d("text-size",60265),threeBars:d("three-bars",60266),thumbsdown:d("thumbsdown",60267),thumbsup:d("thumbsup",60268),tools:d("tools",60269),triangleDown:d("triangle-down",60270),triangleLeft:d("triangle-left",60271),triangleRight:d("triangle-right",60272),triangleUp:d("triangle-up",60273),twitter:d("twitter",60274),unfold:d("unfold",60275),unlock:d("unlock",60276),unmute:d("unmute",60277),unverified:d("unverified",60278),verified:d("verified",60279),versions:d("versions",60280),vmActive:d("vm-active",60281),vmOutline:d("vm-outline",60282),vmRunning:d("vm-running",60283),watch:d("watch",60284),whitespace:d("whitespace",60285),wholeWord:d("whole-word",60286),window:d("window",60287),wordWrap:d("word-wrap",60288),zoomIn:d("zoom-in",60289),zoomOut:d("zoom-out",60290),listFilter:d("list-filter",60291),listFlat:d("list-flat",60292),listSelection:d("list-selection",60293),selection:d("selection",60293),listTree:d("list-tree",60294),debugBreakpointFunctionUnverified:d("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:d("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:d("debug-breakpoint-function-disabled",60296),debugStackframeActive:d("debug-stackframe-active",60297),circleSmallFilled:d("circle-small-filled",60298),debugStackframeDot:d("debug-stackframe-dot",60298),debugStackframe:d("debug-stackframe",60299),debugStackframeFocused:d("debug-stackframe-focused",60299),debugBreakpointUnsupported:d("debug-breakpoint-unsupported",60300),symbolString:d("symbol-string",60301),debugReverseContinue:d("debug-reverse-continue",60302),debugStepBack:d("debug-step-back",60303),debugRestartFrame:d("debug-restart-frame",60304),callIncoming:d("call-incoming",60306),callOutgoing:d("call-outgoing",60307),menu:d("menu",60308),expandAll:d("expand-all",60309),feedback:d("feedback",60310),gitPullRequestReviewer:d("git-pull-request-reviewer",60310),groupByRefType:d("group-by-ref-type",60311),ungroupByRefType:d("ungroup-by-ref-type",60312),account:d("account",60313),gitPullRequestAssignee:d("git-pull-request-assignee",60313),bellDot:d("bell-dot",60314),debugConsole:d("debug-console",60315),library:d("library",60316),output:d("output",60317),runAll:d("run-all",60318),syncIgnored:d("sync-ignored",60319),pinned:d("pinned",60320),githubInverted:d("github-inverted",60321),debugAlt:d("debug-alt",60305),serverProcess:d("server-process",60322),serverEnvironment:d("server-environment",60323),pass:d("pass",60324),stopCircle:d("stop-circle",60325),playCircle:d("play-circle",60326),record:d("record",60327),debugAltSmall:d("debug-alt-small",60328),vmConnect:d("vm-connect",60329),cloud:d("cloud",60330),merge:d("merge",60331),exportIcon:d("export",60332),graphLeft:d("graph-left",60333),magnet:d("magnet",60334),notebook:d("notebook",60335),redo:d("redo",60336),checkAll:d("check-all",60337),pinnedDirty:d("pinned-dirty",60338),passFilled:d("pass-filled",60339),circleLargeFilled:d("circle-large-filled",60340),circleLarge:d("circle-large",60341),circleLargeOutline:d("circle-large-outline",60341),combine:d("combine",60342),gather:d("gather",60342),table:d("table",60343),variableGroup:d("variable-group",60344),typeHierarchy:d("type-hierarchy",60345),typeHierarchySub:d("type-hierarchy-sub",60346),typeHierarchySuper:d("type-hierarchy-super",60347),gitPullRequestCreate:d("git-pull-request-create",60348),runAbove:d("run-above",60349),runBelow:d("run-below",60350),notebookTemplate:d("notebook-template",60351),debugRerun:d("debug-rerun",60352),workspaceTrusted:d("workspace-trusted",60353),workspaceUntrusted:d("workspace-untrusted",60354),workspaceUnspecified:d("workspace-unspecified",60355),terminalCmd:d("terminal-cmd",60356),terminalDebian:d("terminal-debian",60357),terminalLinux:d("terminal-linux",60358),terminalPowershell:d("terminal-powershell",60359),terminalTmux:d("terminal-tmux",60360),terminalUbuntu:d("terminal-ubuntu",60361),terminalBash:d("terminal-bash",60362),arrowSwap:d("arrow-swap",60363),copy:d("copy",60364),personAdd:d("person-add",60365),filterFilled:d("filter-filled",60366),wand:d("wand",60367),debugLineByLine:d("debug-line-by-line",60368),inspect:d("inspect",60369),layers:d("layers",60370),layersDot:d("layers-dot",60371),layersActive:d("layers-active",60372),compass:d("compass",60373),compassDot:d("compass-dot",60374),compassActive:d("compass-active",60375),azure:d("azure",60376),issueDraft:d("issue-draft",60377),gitPullRequestClosed:d("git-pull-request-closed",60378),gitPullRequestDraft:d("git-pull-request-draft",60379),debugAll:d("debug-all",60380),debugCoverage:d("debug-coverage",60381),runErrors:d("run-errors",60382),folderLibrary:d("folder-library",60383),debugContinueSmall:d("debug-continue-small",60384),beakerStop:d("beaker-stop",60385),graphLine:d("graph-line",60386),graphScatter:d("graph-scatter",60387),pieChart:d("pie-chart",60388),bracketDot:d("bracket-dot",60389),bracketError:d("bracket-error",60390),lockSmall:d("lock-small",60391),azureDevops:d("azure-devops",60392),verifiedFilled:d("verified-filled",60393),newLine:d("newline",60394),layout:d("layout",60395),layoutActivitybarLeft:d("layout-activitybar-left",60396),layoutActivitybarRight:d("layout-activitybar-right",60397),layoutPanelLeft:d("layout-panel-left",60398),layoutPanelCenter:d("layout-panel-center",60399),layoutPanelJustify:d("layout-panel-justify",60400),layoutPanelRight:d("layout-panel-right",60401),layoutPanel:d("layout-panel",60402),layoutSidebarLeft:d("layout-sidebar-left",60403),layoutSidebarRight:d("layout-sidebar-right",60404),layoutStatusbar:d("layout-statusbar",60405),layoutMenubar:d("layout-menubar",60406),layoutCentered:d("layout-centered",60407),layoutSidebarRightOff:d("layout-sidebar-right-off",60416),layoutPanelOff:d("layout-panel-off",60417),layoutSidebarLeftOff:d("layout-sidebar-left-off",60418),target:d("target",60408),indent:d("indent",60409),recordSmall:d("record-small",60410),errorSmall:d("error-small",60411),arrowCircleDown:d("arrow-circle-down",60412),arrowCircleLeft:d("arrow-circle-left",60413),arrowCircleRight:d("arrow-circle-right",60414),arrowCircleUp:d("arrow-circle-up",60415),heartFilled:d("heart-filled",60420),map:d("map",60421),mapFilled:d("map-filled",60422),circleSmall:d("circle-small",60423),bellSlash:d("bell-slash",60424),bellSlashDot:d("bell-slash-dot",60425),commentUnresolved:d("comment-unresolved",60426),gitPullRequestGoToChanges:d("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:d("git-pull-request-new-changes",60428),searchFuzzy:d("search-fuzzy",60429),commentDraft:d("comment-draft",60430),send:d("send",60431),sparkle:d("sparkle",60432),insert:d("insert",60433),mic:d("mic",60434),dialogError:d("dialog-error","error"),dialogWarning:d("dialog-warning","warning"),dialogInfo:d("dialog-info","info"),dialogClose:d("dialog-close","close"),treeItemExpanded:d("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:d("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:d("tree-filter-on-type-off","list-selection"),treeFilterClear:d("tree-filter-clear","close"),treeItemLoading:d("tree-item-loading","loading"),menuSelection:d("menu-selection","check"),menuSubmenu:d("menu-submenu","chevron-right"),menuBarMore:d("menubar-more","more"),scrollbarButtonLeft:d("scrollbar-button-left","triangle-left"),scrollbarButtonRight:d("scrollbar-button-right","triangle-right"),scrollbarButtonUp:d("scrollbar-button-up","triangle-up"),scrollbarButtonDown:d("scrollbar-button-down","triangle-down"),toolBarMore:d("toolbar-more","more"),quickInputBack:d("quick-input-back","arrow-left")}}),define(De[24],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function F(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const r=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([s,m])=>{r[s]=m&&typeof m=="object"?F(m):m}),r}e.$7m=F;function d(o){if(!o||typeof o!="object")return o;const r=[o];for(;r.length>0;){const s=r.shift();Object.freeze(s);for(const m in s)if(L.call(s,m)){const h=s[m];typeof h=="object"&&!Object.isFrozen(h)&&!(0,C.$Bf)(h)&&r.push(h)}}return o}e.$8m=d;const L=Object.prototype.hasOwnProperty;function A(o,r){return $(o,r,new Set)}e.$9m=A;function $(o,r,s){if((0,C.$Hf)(o))return o;const m=r(o);if(typeof m<"u")return m;if(Array.isArray(o)){const h=[];for(const t of o)h.push($(t,r,s));return h}if((0,C.$Af)(o)){if(s.has(o))throw new Error("Cannot clone recursive data-structure");s.add(o);const h={};for(const t in o)L.call(o,t)&&(h[t]=$(o[t],r,s));return s.delete(o),h}return o}function E(o,r,s=!0){return(0,C.$Af)(o)?((0,C.$Af)(r)&&Object.keys(r).forEach(m=>{m in o?s&&((0,C.$Af)(o[m])&&(0,C.$Af)(r[m])?E(o[m],r[m],s):o[m]=r[m]):o[m]=r[m]}),o):r}e.$0m=E;function v(o,r){if(o===r)return!0;if(o==null||r===null||r===void 0||typeof o!=typeof r||typeof o!="object"||Array.isArray(o)!==Array.isArray(r))return!1;let s,m;if(Array.isArray(o)){if(o.length!==r.length)return!1;for(s=0;s<o.length;s++)if(!v(o[s],r[s]))return!1}else{const h=[];for(m in o)h.push(m);h.sort();const t=[];for(m in r)t.push(m);if(t.sort(),!v(h,t))return!1;for(s=0;s<h.length;s++)if(!v(o[h[s]],r[h[s]]))return!1}return!0}e.$$m=v;function R(o){const r=new Set;return JSON.stringify(o,(s,m)=>{if((0,C.$Af)(m)||Array.isArray(m)){if(r.has(m))return"[Circular]";r.add(m)}return m})}e.$_m=R;function I(o,r){const s=Object.create(null);return!o||!r||Object.keys(r).forEach(h=>{const t=o[h],n=r[h];v(t,n)||(s[h]=n)}),s}e.$an=I;function w(o,r){const s=r.toLowerCase(),m=Object.keys(o).find(h=>h.toLowerCase()===s);return m?o[m]:o[r]}e.$bn=w;function y(o,r){const s=Object.create(null);for(const[m,h]of Object.entries(o))r(m,h)&&(s[m]=h);return s}e.$cn=y;function k(o){let r=[];for(;Object.prototype!==o;)r=r.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return r}e.$dn=k;function p(o){const r=[];for(const s of k(o))typeof o[s]=="function"&&r.push(s);return r}e.$en=p;function u(o,r){const s=h=>function(){const t=Array.prototype.slice.call(arguments,0);return r(h,t)},m={};for(const h of o)m[h]=s(h);return m}e.$fn=u}),define(De[59],Ce([1,0,79]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var F;(function(A){function $(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=$})(F||(e.ThemeColor=F={}));function d(A){return{id:A}}e.$Vj=d;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(r){const s=$.exec(r.id);if(!s)return E(C.$Uj.error);const[,m,h]=s,t=["codicon","codicon-"+m];return h&&t.push("codicon-modifier-"+h.substring(1)),t}A.asClassNameArray=E;function v(r){return E(r).join(" ")}A.asClassName=v;function R(r){return"."+E(r).join(".")}A.asCSSSelector=R;function I(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||F.isThemeColor(r.color))}A.isThemeIcon=I;const w=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(r){const s=w.exec(r);if(!s)return;const[,m]=s;return{id:m}}A.fromString=y;function k(r){return{id:r}}A.fromId=k;function p(r,s){let m=r.id;const h=m.lastIndexOf("~");return h!==-1&&(m=m.substring(0,h)),s&&(m=`${m}~${s}`),{id:m}}A.modify=p;function u(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}A.getModifier=u;function o(r,s){return r.id===s.id&&r.color?.id===s.color?.id}A.isEqual=o})(L||(e.ThemeIcon=L={}))}),define(De[161],Ce([1,0,121,15,59]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=void 0;const L="$(",A=new RegExp(`\\$\\(${d.ThemeIcon.iconNameExpression}(?:${d.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${A.source}`,"g");function E(o){return o.replace($,(r,s)=>s?r:`\\${r}`)}e.$Wj=E;const v=new RegExp(`\\\\${A.source}`,"g");function R(o){return o.replace(v,r=>`\\${r}`)}e.$Xj=R;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function w(o){return o.indexOf(L)===-1?o:o.replace(I,(r,s,m,h)=>m?r:s||h||"")}e.$Yj=w;function y(o){return o?o.replace(/\$\((.*?)\)/g,(r,s)=>` ${s} `).trim():""}e.$Zj=y;const k=new RegExp(`\\$\\(${d.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(o){k.lastIndex=0;let r="";const s=[];let m=0;for(;;){const h=k.lastIndex,t=k.exec(o),n=o.substring(h,t?.index);if(n.length>0){r+=n;for(let c=0;c<n.length;c++)s.push(m)}if(!t)break;m+=t[0].length}return{text:r,iconOffsets:s}}e.$1j=p;function u(o,r,s=!1){const{text:m,iconOffsets:h}=r;if(!h||h.length===0)return(0,C.$Jj)(o,m,s);const t=(0,F.$Je)(m," "),n=m.length-t.length,c=(0,C.$Jj)(o,t,s);if(c)for(const i of c){const a=h[i.start+n]+n;i.start+=a,i.end+=a}return c}e.$2j=u}),define(De[122],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.Constants=void 0;var C;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function F(L){return L<0?0:L>255?255:L|0}e.$ze=F;function d(L){return L<0?0:L>4294967295?4294967295:L|0}e.$Ae=d}),define(De[31],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(d){return C.test(d)}e.$dg=F,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let d;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?d=crypto.getRandomValues.bind(crypto):d=function($){for(let E=0;E<$.length;E++)$[E]=Math.floor(Math.random()*256);return $};const L=new Uint8Array(16),A=[];for(let $=0;$<256;$++)A.push($.toString(16).padStart(2,"0"));return function(){d(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,v="";return v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v+="-",v+=A[L[E++]],v+=A[L[E++]],v+="-",v+=A[L[E++]],v+=A[L[E++]],v+="-",v+=A[L[E++]],v+=A[L[E++]],v+="-",v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v}}()}),define(De[162],Ce([1,0,19,51,31]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=e.$2s=e.$1s=e.$Zs=void 0;function L(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Zs=L;function A(I,w,y){const k={id:(0,d.$eg)(),name:I,uri:w,data:y};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$1s=A;class ${constructor(){this.a=new Map}get size(){let w=0;for(const y of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const y=[...this.a.keys()];return F.Iterable.some(this,([k,p])=>p.asFile())&&y.push("files"),R(E(w),y)}get(w){return this.a.get(this.b(w))?.[0]}append(w,y){const k=this.a.get(w);k?k.push(y):this.a.set(this.b(w),[y])}replace(w,y){this.a.set(this.b(w),[y])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,y]of this.a)for(const k of y)yield[w,k]}b(w){return E(w)}}e.$2s=$;function E(I){return I.toLowerCase()}function v(I,w){return R(E(I),w.map(E))}e.$3s=v;function R(I,w){if(I==="*/*")return w.length>0;if(w.includes(I))return!0;const y=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[k,p,u]=y;return u==="*"?w.some(o=>o.startsWith(p+"/")):!1}e.$4s=Object.freeze({create:I=>(0,C.$Mb)(I.map(w=>w.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$4s.split(I).filter(w=>!w.startsWith("#"))})}),define(De[163],Ce([1,0,60]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function F($,E,v,R=1){let I=!1;return new Promise(w=>{const y=setTimeout(()=>{if(!I)return I=!0,w(0)},v);d($,E,R,k=>{if(!I)return I=!0,clearTimeout(y),w(k)})})}e.$gg=F;function d($,E,v,R){if(E===0)return R(0);const I=new C.Socket;I.once("connect",()=>(A(I),d($+v,E-1,v,R))),I.once("data",()=>{}),I.once("error",w=>(A(I),w.code!=="ECONNREFUSED"?d($+v,E-1,v,R):R($))),I.connect($,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L($,E,v,R="127.0.0.1"){let I=!1,w,y=1;const k=C.createServer({pauseOnConnect:!0});function p(u,o){I||(I=!0,k.removeAllListeners(),k.close(),w&&clearTimeout(w),o(u))}return new Promise(u=>{w=setTimeout(()=>{p(0,u)},v),k.on("listening",()=>{p($,u)}),k.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&y<E?($++,y++,k.listen($,R)):p(0,u)}),k.on("close",()=>{p(0,u)}),k.listen($,R)})}e.$ig=L;function A($){try{$.removeAllListeners("connect"),$.removeAllListeners("error"),$.end(),$.destroy(),$.unref()}catch(E){console.error(E)}}}),define(De[123],Ce([1,0,122]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=e.$Rs=void 0;class F{constructor($){const E=(0,C.$ze)($);this.c=E,this.a=F.d(E),this.b=new Map}static d($){const E=new Uint8Array(256);return E.fill($),E}set($,E){const v=(0,C.$ze)(E);$>=0&&$<256?this.a[$]=v:this.b.set($,v)}get($){return $>=0&&$<256?this.a[$]:this.b.get($)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Rs=F;var d;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(d||(d={}));class L{constructor(){this.a=new F(0)}add($){this.a.set($,1)}has($){return this.a.get($)===1}clear(){return this.a.clear()}}e.$Ss=L}),define(De[61],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=void 0;class C{constructor(d,L){this.lineNumber=d,this.column=L}with(d=this.lineNumber,L=this.column){return d===this.lineNumber&&L===this.column?this:new C(d,L)}delta(d=0,L=0){return this.with(this.lineNumber+d,this.column+L)}equals(d){return C.equals(this,d)}static equals(d,L){return!d&&!L?!0:!!d&&!!L&&d.lineNumber===L.lineNumber&&d.column===L.column}isBefore(d){return C.isBefore(this,d)}static isBefore(d,L){return d.lineNumber<L.lineNumber?!0:L.lineNumber<d.lineNumber?!1:d.column<L.column}isBeforeOrEqual(d){return C.isBeforeOrEqual(this,d)}static isBeforeOrEqual(d,L){return d.lineNumber<L.lineNumber?!0:L.lineNumber<d.lineNumber?!1:d.column<=L.column}static compare(d,L){const A=d.lineNumber|0,$=L.lineNumber|0;if(A===$){const E=d.column|0,v=L.column|0;return E-v}return A-$}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(d){return new C(d.lineNumber,d.column)}static isIPosition(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"}}e.$ts=C}),define(De[32],Ce([1,0,61]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;class F{constructor(L,A,$,E){L>$||L===$&&A>E?(this.startLineNumber=$,this.startColumn=E,this.endLineNumber=L,this.endColumn=A):(this.startLineNumber=L,this.startColumn=A,this.endLineNumber=$,this.endColumn=E)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<L.startColumn||A.lineNumber===L.endLineNumber&&A.column>L.endColumn)}static strictContainsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<=L.startColumn||A.lineNumber===L.endLineNumber&&A.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<=L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,A){let $,E,v,R;return A.startLineNumber<L.startLineNumber?($=A.startLineNumber,E=A.startColumn):A.startLineNumber===L.startLineNumber?($=A.startLineNumber,E=Math.min(A.startColumn,L.startColumn)):($=L.startLineNumber,E=L.startColumn),A.endLineNumber>L.endLineNumber?(v=A.endLineNumber,R=A.endColumn):A.endLineNumber===L.endLineNumber?(v=A.endLineNumber,R=Math.max(A.endColumn,L.endColumn)):(v=L.endLineNumber,R=L.endColumn),new F($,E,v,R)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,A){let $=L.startLineNumber,E=L.startColumn,v=L.endLineNumber,R=L.endColumn;const I=A.startLineNumber,w=A.startColumn,y=A.endLineNumber,k=A.endColumn;return $<I?($=I,E=w):$===I&&(E=Math.max(E,w)),v>y?(v=y,R=k):v===y&&(R=Math.min(R,k)),$>v||$===v&&E>R?null:new F($,E,v,R)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,A){return!L&&!A?!0:!!L&&!!A&&L.startLineNumber===A.startLineNumber&&L.startColumn===A.startColumn&&L.endLineNumber===A.endLineNumber&&L.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new C.$ts(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new C.$ts(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,A){return new F(this.startLineNumber,this.startColumn,L,A)}setStartPosition(L,A){return new F(L,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,A=L){return new F(L.lineNumber,L.column,A.lineNumber,A.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<L.startColumn)}static areIntersecting(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<=A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,A){if(L&&A){const v=L.startLineNumber|0,R=A.startLineNumber|0;if(v===R){const I=L.startColumn|0,w=A.startColumn|0;if(I===w){const y=L.endLineNumber|0,k=A.endLineNumber|0;if(y===k){const p=L.endColumn|0,u=A.endColumn|0;return p-u}return y-k}return I-w}return v-R}return(L?1:0)-(A?1:0)}static compareRangesUsingEnds(L,A){return L.endLineNumber===A.endLineNumber?L.endColumn===A.endColumn?L.startLineNumber===A.startLineNumber?L.startColumn-A.startColumn:L.startLineNumber-A.startLineNumber:L.endColumn-A.endColumn:L.endLineNumber-A.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$us=F}),define(De[164],Ce([1,0,32]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;class F{static insert(L,A){return{range:new C.$us(L.lineNumber,L.column,L.lineNumber,L.column),text:A,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,A){return{range:L,text:A}}static replaceMove(L,A){return{range:L,text:A,forceMoveMarkers:!0}}}e.$vs=F}),define(De[165],Ce([1,0,61,32]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=e.SelectionDirection=void 0;var d;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(d||(e.SelectionDirection=d={}));class L extends F.$us{constructor($,E,v,R){super($,E,v,R),this.selectionStartLineNumber=$,this.selectionStartColumn=E,this.positionLineNumber=v,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection($){return L.selectionsEqual(this,$)}static selectionsEqual($,E){return $.selectionStartLineNumber===E.selectionStartLineNumber&&$.selectionStartColumn===E.selectionStartColumn&&$.positionLineNumber===E.positionLineNumber&&$.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition($,E){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,$,E):new L($,E,this.startLineNumber,this.startColumn)}getPosition(){return new C.$ts(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$ts(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition($,E){return this.getDirection()===0?new L($,E,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,$,E)}static fromPositions($,E=$){return new L($.lineNumber,$.column,E.lineNumber,E.column)}static fromRange($,E){return E===0?new L($.startLineNumber,$.startColumn,$.endLineNumber,$.endColumn):new L($.endLineNumber,$.endColumn,$.startLineNumber,$.startColumn)}static liftSelection($){return new L($.selectionStartLineNumber,$.selectionStartColumn,$.positionLineNumber,$.positionColumn)}static selectionsArrEqual($,E){if($&&!E||!$&&E)return!1;if(!$&&!E)return!0;if($.length!==E.length)return!1;for(let v=0,R=$.length;v<R;v++)if(!this.selectionsEqual($[v],E[v]))return!1;return!0}static isISelection($){return $&&typeof $.selectionStartLineNumber=="number"&&typeof $.selectionStartColumn=="number"&&typeof $.positionLineNumber=="number"&&typeof $.positionColumn=="number"}static createWithDirection($,E,v,R,I){return I===0?new L($,E,v,R):new L(v,R,$,E)}}e.$ws=L}),define(De[166],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0,e.$4r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.$Ts=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class d extends C.$Rs{constructor($){super(0);for(let E=0,v=$.length;E<v;E++)this.set($.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Ts=d;function L(A){const $={};return E=>($.hasOwnProperty(E)||($[E]=A(E)),$[E])}e.$Us=L(A=>new d(A))}),define(De[124],Ce([1,0,51,3,76]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=e.$7r=e.$6r=e.$5r=void 0,e.$5r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(I=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$5r)I.indexOf(y)>=0||(w+="\\"+y);return w+="\\s]+)",new RegExp(w,"g")}e.$6r=L();function A(I){let w=e.$6r;if(I&&I instanceof RegExp)if(I.global)w=I;else{let y="g";I.ignoreCase&&(y+="i"),I.multiline&&(y+="m"),I.unicode&&(y+="u"),w=new RegExp(I.source,y)}return w.lastIndex=0,w}e.$7r=A;const $=new d.$2c;$.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const w=$.unshift(I);return(0,F.$Qc)(w)}e.$8r=E;function v(I,w,y,k,p){if(p||(p=C.Iterable.first($)),y.length>p.maxLen){let m=I-p.maxLen/2;return m<0?m=0:k+=m,y=y.substring(m,I+p.maxLen/2),v(I,w,y,k,p)}const u=Date.now(),o=I-1-k;let r=-1,s=null;for(let m=1;!(Date.now()-u>=p.timeBudget);m++){const h=o-p.windowSize*m;w.lastIndex=Math.max(0,h);const t=R(w,y,o,r);if(!t&&s||(s=t,h<=0))break;r=h}if(s){const m={word:s[0],startColumn:k+1+s.index,endColumn:k+1+s.index+s[0].length};return w.lastIndex=0,m}return null}e.$9r=v;function R(I,w,y,k){let p;for(;p=I.exec(w);){const u=p.index||0;if(u<=y&&I.lastIndex>=y)return p;if(k>0&&u>k)return null}return null}}),define(De[168],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class F{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let E=0,v=$.notIn.length;E<v;E++)switch($.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,E){if($.getTokenCount()===0)return!0;const v=$.findTokenIndexAtOffset(E-2),R=$.getStandardTokenType(v);return this.isOK(R)}g($,E){for(let v=$;v<=E;v++){const R=String.fromCharCode(v);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$qt=F;class d{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of $)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$rt=d;function L(A,$,E){A.has($)?A.get($).push(E):A.set($,[E])}}),define(De[169],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Y=e.$1Y=e.$ZY=e.State=void 0;var F;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class d{constructor(k,p,u){const o=new Uint8Array(k*p);for(let r=0,s=k*p;r<s;r++)o[r]=u;this.a=o,this.rows=k,this.cols=p}get(k,p){return this.a[k*this.cols+p]}set(k,p,u){this.a[k*this.cols+p]=u}}class L{constructor(k){let p=0,u=0;for(let r=0,s=k.length;r<s;r++){const[m,h,t]=k[r];h>p&&(p=h),m>u&&(u=m),t>u&&(u=t)}p++,u++;const o=new d(u,p,0);for(let r=0,s=k.length;r<s;r++){const[m,h,t]=k[r];o.set(m,h,t)}this.a=o,this.b=p}nextState(k,p){return p<0||p>=this.b?0:this.a.get(k,p)}}e.$ZY=L;let A=null;function $(){return A===null&&(A=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let v=null;function R(){if(v===null){v=new C.$Rs(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<y.length;p++)v.set(y.charCodeAt(p),1);const k=".,;:";for(let p=0;p<k.length;p++)v.set(k.charCodeAt(p),2)}return v}class I{static a(k,p,u,o,r){let s=r-1;do{const m=p.charCodeAt(s);if(k.get(m)!==2)break;s--}while(s>o);if(o>0){const m=p.charCodeAt(o-1),h=p.charCodeAt(s);(m===40&&h===41||m===91&&h===93||m===123&&h===125)&&s--}return{range:{startLineNumber:u,startColumn:o+1,endLineNumber:u,endColumn:s+2},url:p.substring(o,s+1)}}static computeLinks(k,p=$()){const u=R(),o=[];for(let r=1,s=k.getLineCount();r<=s;r++){const m=k.getLineContent(r),h=m.length;let t=0,n=0,c=0,i=1,a=!1,l=!1,D=!1,S=!1;for(;t<h;){let b=!1;const f=m.charCodeAt(t);if(i===13){let g;switch(f){case 40:a=!0,g=0;break;case 41:g=a?0:1;break;case 91:D=!0,l=!0,g=0;break;case 93:D=!1,g=l?0:1;break;case 123:S=!0,g=0;break;case 125:g=S?0:1;break;case 39:case 34:case 96:c===f?g=1:c===39||c===34||c===96?g=0:g=1;break;case 42:g=c===42?1:0;break;case 124:g=c===124?1:0;break;case 32:g=D?0:1;break;default:g=u.get(f)}g===1&&(o.push(I.a(u,m,r,n,t)),b=!0)}else if(i===12){let g;f===91?(l=!0,g=0):g=u.get(f),g===1?b=!0:i=13}else i=p.nextState(i,f),i===0&&(b=!0);b&&(i=1,a=!1,l=!1,S=!1,n=t+1,c=f),t++}i===13&&o.push(I.a(u,m,r,n,h))}return o}}e.$1Y=I;function w(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:I.computeLinks(y)}e.$2Y=w}),define(De[125],Ce([1,0,24]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.$Pu=e.$Ou=e.$Nu=e.ModelConstants=e.PositionAffinity=e.$Mu=e.TrackedRangeStickiness=e.$Lu=e.$Ku=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var d;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(d||(e.GlyphMarginLane=d={}));var L;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var A;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var $;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var E;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var v;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(v||(e.EndOfLineSequence=v={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),h.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,h.indentSize|0),this.a=!1),this.insertSpaces=!!h.insertSpaces,this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=!!h.trimAutoWhitespace,this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.a===h.a&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,C.$$m)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.$Ku=R;class I{constructor(h,t){this._findMatchBrand=void 0,this.range=h,this.matches=t}}e.$Lu=I;var w;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function y(m){return m&&typeof m.read=="function"}e.$Mu=y;var k;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var p;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(e.ModelConstants=p={}));class u{constructor(h,t,n,c,i,a){this.identifier=h,this.range=t,this.text=n,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=i,this._isTracked=a}}e.$Nu=u;class o{constructor(h,t,n){this.regex=h,this.wordSeparators=t,this.simpleSearch=n}}e.$Ou=o;class r{constructor(h,t,n){this.reverseEdits=h,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.$Pu=r;function s(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.$Qu=s}),define(De[170],Ce([1,0,19,122]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=e.$Uu=e.$Tu=void 0;class d{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,v){E=(0,F.$Ae)(E);const R=this.a,I=this.b,w=v.length;return w===0?!1:(this.a=new Uint32Array(R.length+w),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E),E+w),this.a.set(v,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(E,v){return E=(0,F.$Ae)(E),v=(0,F.$Ae)(v),this.a[E]===v?!1:(this.a[E]=v,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,v){E=(0,F.$Ae)(E),v=(0,F.$Ae)(v);const R=this.a,I=this.b;if(E>=R.length)return!1;const w=R.length-E;return v>=w&&(v=w),v===0?!1:(this.a=new Uint32Array(R.length-v),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E+v),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,F.$Ae)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let v=this.c[0]+1;v===0&&(this.b[0]=this.a[0],v++),E>=this.a.length&&(E=this.a.length-1);for(let R=v;R<=E;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let v=0,R=this.a.length-1,I=0,w=0,y=0;for(;v<=R;)if(I=v+(R-v)/2|0,w=this.b[I],y=w-this.a[I],E<y)R=I-1;else if(E>=w)v=I+1;else break;return new A(I,E-y)}}e.$Tu=d;class L{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const v=this.e[E],R=v>0?this.d[v-1]:0;return new A(v,E-R)}removeValues(E,v){this.a.splice(E,v),this.f(E)}insertValues(E,v){this.a=(0,C.$Wb)(this.a,E,v),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,v=this.a.length;E<v;E++){const R=this.a[E],I=E>0?this.d[E-1]:0;this.d[E]=I+R;for(let w=0;w<R;w++)this.e[I+w]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,v){this.a[E]!==v&&(this.a[E]=v,this.f(E))}}e.$Uu=L;class A{constructor(E,v){this.index=E,this.remainder=v,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=v}}e.$Vu=A}),define(De[171],Ce([1,0,15,61,170]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wu=void 0;class L{constructor($,E,v,R){this.d=$,this.f=E,this.g=v,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents($){$.eol&&$.eol!==this.g&&(this.g=$.eol,this.j=null);const E=$.changes;for(const v of E)this.o(v.range),this.p(new F.$ts(v.range.startLineNumber,v.range.startColumn),v.text);this.h=$.versionId,this.k=null}l(){if(!this.j){const $=this.g.length,E=this.f.length,v=new Uint32Array(E);for(let R=0;R<E;R++)v[R]=this.f[R].length+$;this.j=new d.$Tu(v)}}n($,E){this.f[$]=E,this.j&&this.j.setValue($,this.f[$].length+this.g.length)}o($){if($.startLineNumber===$.endLineNumber){if($.startColumn===$.endColumn)return;this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.startLineNumber-1].substring($.endColumn-1));return}this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.endLineNumber-1].substring($.endColumn-1)),this.f.splice($.startLineNumber,$.endLineNumber-$.startLineNumber),this.j&&this.j.removeValues($.startLineNumber,$.endLineNumber-$.startLineNumber)}p($,E){if(E.length===0)return;const v=(0,C.$Pe)(E);if(v.length===1){this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+v[0]+this.f[$.lineNumber-1].substring($.column-1));return}v[v.length-1]+=this.f[$.lineNumber-1].substring($.column-1),this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+v[0]);const R=new Uint32Array(v.length-1);for(let I=1;I<v.length;I++)this.f.splice($.lineNumber+I-1,0,v[I]),R[I-1]=v[I].length+this.g.length;this.j&&this.j.insertValues($.lineNumber,R)}}e.$Wu=L}),define(De[172],Ce([1,0,15,167,61,32,125]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=void 0;const $=999;class E{constructor(r,s,m,h){this.searchString=r,this.isRegex=s,this.matchCase=m,this.wordSeparators=h}parseSearchRequest(){if(this.searchString==="")return null;let r;this.isRegex?r=v(this.searchString):r=this.searchString.indexOf(`
`)>=0;let s=null;try{s=C.$Ne(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:r,global:!0,unicode:!0})}catch{return null}if(!s)return null;let m=!this.isRegex&&!r;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new A.$Ou(s,this.wordSeparators?(0,F.$Us)(this.wordSeparators):null,m?this.searchString:null)}}e.$tB=E;function v(o){if(!o||o.length===0)return!1;for(let r=0,s=o.length;r<s;r++){const m=o.charCodeAt(r);if(m===10)return!0;if(m===92){if(r++,r>=s)break;const h=o.charCodeAt(r);if(h===110||h===114||h===87)return!0}}return!1}e.$uB=v;function R(o,r,s){if(!s)return new A.$Lu(o,null);const m=[];for(let h=0,t=r.length;h<t;h++)m[h]=r[h];return new A.$Lu(o,m)}e.$vB=R;class I{constructor(r){const s=[];let m=0;for(let h=0,t=r.length;h<t;h++)r.charCodeAt(h)===10&&(s[m++]=h);this.a=s}findLineFeedCountBeforeOffset(r){const s=this.a;let m=0,h=s.length-1;if(h===-1||r<=s[0])return 0;for(;m<h;){const t=m+((h-m)/2>>0);s[t]>=r?h=t-1:s[t+1]>=r?(m=t,h=t):m=t+1}return m+1}}class w{static findMatches(r,s,m,h,t){const n=s.parseSearchRequest();return n?n.regex.multiline?this.b(r,m,new u(n.wordSeparators,n.regex),h,t):this.c(r,m,n,h,t):[]}static a(r,s,m,h,t,n){let c,i=0;h?(i=h.findLineFeedCountBeforeOffset(t),c=s+t+i):c=s+t;let a;if(h){const b=h.findLineFeedCountBeforeOffset(t+n.length)-i;a=c+n.length+b}else a=c+n.length;const l=r.getPositionAt(c),D=r.getPositionAt(a);return new L.$us(l.lineNumber,l.column,D.lineNumber,D.column)}static b(r,s,m,h,t){const n=r.getOffsetAt(s.getStartPosition()),c=r.getValueInRange(s,1),i=r.getEOL()===`\r
`?new I(c):null,a=[];let l=0,D;for(m.reset(0);D=m.next(c);)if(a[l++]=R(this.a(r,n,c,i,D.index,D[0]),D,h),l>=t)return a;return a}static c(r,s,m,h,t){const n=[];let c=0;if(s.startLineNumber===s.endLineNumber){const a=r.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return c=this.d(m,a,s.startLineNumber,s.startColumn-1,c,n,h,t),n}const i=r.getLineContent(s.startLineNumber).substring(s.startColumn-1);c=this.d(m,i,s.startLineNumber,s.startColumn-1,c,n,h,t);for(let a=s.startLineNumber+1;a<s.endLineNumber&&c<t;a++)c=this.d(m,r.getLineContent(a),a,0,c,n,h,t);if(c<t){const a=r.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);c=this.d(m,a,s.endLineNumber,0,c,n,h,t)}return n}static d(r,s,m,h,t,n,c,i){const a=r.wordSeparators;if(!c&&r.simpleSearch){const S=r.simpleSearch,b=S.length,f=s.length;let g=-b;for(;(g=s.indexOf(S,g+b))!==-1;)if((!a||p(a,s,f,g,b))&&(n[t++]=new A.$Lu(new L.$us(m,g+1+h,m,g+1+b+h),null),t>=i))return t;return t}const l=new u(r.wordSeparators,r.regex);let D;l.reset(0);do if(D=l.next(s),D&&(n[t++]=R(new L.$us(m,D.index+1+h,m,D.index+1+D[0].length+h),D,c),t>=i))return t;while(D);return t}static findNextMatch(r,s,m,h){const t=s.parseSearchRequest();if(!t)return null;const n=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.e(r,m,n,h):this.f(r,m,n,h)}static e(r,s,m,h){const t=new d.$ts(s.lineNumber,1),n=r.getOffsetAt(t),c=r.getLineCount(),i=r.getValueInRange(new L.$us(t.lineNumber,t.column,c,r.getLineMaxColumn(c)),1),a=r.getEOL()===`\r
`?new I(i):null;m.reset(s.column-1);const l=m.next(i);return l?R(this.a(r,n,i,a,l.index,l[0]),l,h):s.lineNumber!==1||s.column!==1?this.e(r,new d.$ts(1,1),m,h):null}static f(r,s,m,h){const t=r.getLineCount(),n=s.lineNumber,c=r.getLineContent(n),i=this.g(m,c,n,s.column,h);if(i)return i;for(let a=1;a<=t;a++){const l=(n+a-1)%t,D=r.getLineContent(l+1),S=this.g(m,D,l+1,1,h);if(S)return S}return null}static g(r,s,m,h,t){r.reset(h-1);const n=r.next(s);return n?R(new L.$us(m,n.index+1,m,n.index+1+n[0].length),n,t):null}static findPreviousMatch(r,s,m,h){const t=s.parseSearchRequest();if(!t)return null;const n=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.h(r,m,n,h):this.j(r,m,n,h)}static h(r,s,m,h){const t=this.b(r,new L.$us(1,1,s.lineNumber,s.column),m,h,10*$);if(t.length>0)return t[t.length-1];const n=r.getLineCount();return s.lineNumber!==n||s.column!==r.getLineMaxColumn(n)?this.h(r,new d.$ts(n,r.getLineMaxColumn(n)),m,h):null}static j(r,s,m,h){const t=r.getLineCount(),n=s.lineNumber,c=r.getLineContent(n).substring(0,s.column-1),i=this.k(m,c,n,h);if(i)return i;for(let a=1;a<=t;a++){const l=(t+n-a-1)%t,D=r.getLineContent(l+1),S=this.k(m,D,l+1,h);if(S)return S}return null}static k(r,s,m,h){let t=null,n;for(r.reset(0);n=r.next(s);)t=R(new L.$us(m,n.index+1,m,n.index+1+n[0].length),n,h);return t}}e.$wB=w;function y(o,r,s,m,h){if(m===0)return!0;const t=r.charCodeAt(m-1);if(o.get(t)!==0||t===13||t===10)return!0;if(h>0){const n=r.charCodeAt(m);if(o.get(n)!==0)return!0}return!1}function k(o,r,s,m,h){if(m+h===s)return!0;const t=r.charCodeAt(m+h);if(o.get(t)!==0||t===13||t===10)return!0;if(h>0){const n=r.charCodeAt(m+h-1);if(o.get(n)!==0)return!0}return!1}function p(o,r,s,m,h){return y(o,r,s,m,h)&&k(o,r,s,m,h)}e.$xB=p;class u{constructor(r,s){this._wordSeparators=r,this.a=s,this.b=-1,this.c=0}reset(r){this.a.lastIndex=r,this.b=-1,this.c=0}next(r){const s=r.length;let m;do{if(this.b+this.c===s||(m=this.a.exec(r),!m))return null;const h=m.index,t=m[0].length;if(h===this.b&&t===this.c){if(t===0){C.$9e(r,s,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=h,this.c=t,!this._wordSeparators||p(this._wordSeparators,r,s,h,t))return m}while(m);return null}}e.$yB=u}),define(De[173],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N7=e.$M7=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$M7=C;class F{constructor(L){this.identifier=L}}e.$N7=F}),define(De[174],Ce([1,0,4,3]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=void 0;class d{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$Nd,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,E){return this.a.set($,E),this.handleChange([$]),(0,F.$Qc)(()=>{this.a.get($)===E&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,E){this.b.get($)?.dispose();const v=new L(this,$,E);return this.b.set($,v),(0,F.$Qc)(()=>{const R=this.b.get($);!R||R!==v||(this.b.delete($),R.dispose())})}async getOrCreate($){const E=this.get($);if(E)return E;const v=this.b.get($);return!v||v.isResolved?null:(await v.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const v=this.b.get($);return!!(!v||v.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$6s=d;class L extends F.$Sc{get isResolved(){return this.c}constructor($,E,v){super(),this.f=$,this.g=E,this.h=v,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(De[175],Ce([10,11]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(De[176],Ce([1,0,4,3,175]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;class L extends F.$Sc{constructor(w,y="",k="",p=!0,u){super(),this.h=this.B(new C.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=y,this.u=k,this.w=p,this.C=u}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,y){this.C&&await this.C(w)}}e.$ui=L;class A extends F.$Sc{constructor(){super(...arguments),this.f=this.B(new C.$Nd),this.onWillRun=this.f.event,this.m=this.B(new C.$Nd),this.onDidRun=this.m.event}async run(w,y){if(!w.enabled)return;this.f.fire({action:w});let k;try{await this.u(w,y)}catch(p){k=p}this.m.fire({action:w,error:k})}async u(w,y){await w.run(y)}}e.$vi=A;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let y=[];for(const k of w)k.length&&(y.length?y=[...y,new $,...k]:y=k);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$wi=$;class E{get actions(){return this.a}constructor(w,y,k,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=y,this.class=p,this.a=k}async run(){}}e.$xi=E;class v extends L{static{this.ID="vs.actions.empty"}constructor(){super(v.ID,d.localize(0,null),void 0,!1)}}e.$yi=v;function R(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...w)=>I.run(...w),tooltip:I.label}}e.$zi=R}),define(De[177],Ce([10,11]),function($e,e){return $e.create("vs/base/common/date",e)}),define(De[178],Ce([1,0,177]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const F=60,d=F*60,L=d*24,A=L*7,$=L*30,E=L*365;function v(I,w,y,k){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,C.localize)(0,null,v(new Date().getTime()+p*1e3,!1));if(!k&&p<30)return(0,C.localize)(1,null);let u;return p<F?(u=p,w?u===1?y?(0,C.localize)(2,null,u):(0,C.localize)(3,null,u):y?(0,C.localize)(4,null,u):(0,C.localize)(5,null,u):u===1?y?(0,C.localize)(6,null,u):(0,C.localize)(7,null,u):y?(0,C.localize)(8,null,u):(0,C.localize)(9,null,u)):p<d?(u=Math.floor(p/F),w?u===1?y?(0,C.localize)(10,null,u):(0,C.localize)(11,null,u):y?(0,C.localize)(12,null,u):(0,C.localize)(13,null,u):u===1?y?(0,C.localize)(14,null,u):(0,C.localize)(15,null,u):y?(0,C.localize)(16,null,u):(0,C.localize)(17,null,u)):p<L?(u=Math.floor(p/d),w?u===1?y?(0,C.localize)(18,null,u):(0,C.localize)(19,null,u):y?(0,C.localize)(20,null,u):(0,C.localize)(21,null,u):u===1?y?(0,C.localize)(22,null,u):(0,C.localize)(23,null,u):y?(0,C.localize)(24,null,u):(0,C.localize)(25,null,u)):p<A?(u=Math.floor(p/L),w?u===1?(0,C.localize)(26,null,u):(0,C.localize)(27,null,u):u===1?(0,C.localize)(28,null,u):(0,C.localize)(29,null,u)):p<$?(u=Math.floor(p/A),w?u===1?y?(0,C.localize)(30,null,u):(0,C.localize)(31,null,u):y?(0,C.localize)(32,null,u):(0,C.localize)(33,null,u):u===1?y?(0,C.localize)(34,null,u):(0,C.localize)(35,null,u):y?(0,C.localize)(36,null,u):(0,C.localize)(37,null,u)):p<E?(u=Math.floor(p/$),w?u===1?y?(0,C.localize)(38,null,u):(0,C.localize)(39,null,u):y?(0,C.localize)(40,null,u):(0,C.localize)(41,null,u):u===1?y?(0,C.localize)(42,null,u):(0,C.localize)(43,null,u):y?(0,C.localize)(44,null,u):(0,C.localize)(45,null,u)):(u=Math.floor(p/E),w?u===1?y?(0,C.localize)(46,null,u):(0,C.localize)(47,null,u):y?(0,C.localize)(48,null,u):(0,C.localize)(49,null,u):u===1?y?(0,C.localize)(50,null,u):(0,C.localize)(51,null,u):y?(0,C.localize)(52,null,u):(0,C.localize)(53,null,u))}e.$dm=v;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=R}),define(De[179],Ce([10,11]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(De[41],Ce([1,0,19,17,179]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function L(I,w){return w&&(I.stack||I.stacktrace)?d.localize(0,null,$(I),A(I.stack)||A(I.stacktrace)):$(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function $(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?d.localize(1,null,I.message):I.message||d.localize(2,null)}function E(I=null,w=!1){if(!I)return d.localize(3,null);if(Array.isArray(I)){const y=C.$Hb(I),k=E(y[0],w);return y.length>1?d.localize(4,null,k,y.length):k}if(F.$yf(I))return I;if(I.detail){const y=I.detail;if(y.error)return L(y.error,w);if(y.exception)return L(y.exception,w)}return I.stack?L(I,w):I.message?I.message:d.localize(5,null)}e.$Ai=E;function v(I){const w=I;return w instanceof Error&&Array.isArray(w.actions)}e.$Bi=v;function R(I,w){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=w,y}e.$Ci=R}),define(De[180],Ce([10,11]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(De[12],Ce([1,0,180]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let F=!1,d=!1,L=!1,A=!1,$=!1,E=!1,v=!1,R=!1,I=!1,w=!1,y,k=e.$g,p=e.$g,u,o;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let r;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?r=e.$h.vscode.process:typeof process<"u"&&(r=process);const s=typeof r?.versions?.electron=="string",m=s&&r?.type==="renderer";if(typeof navigator=="object"&&!m)o=navigator.userAgent,F=o.indexOf("Windows")>=0,d=o.indexOf("Macintosh")>=0,R=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=o.indexOf("Linux")>=0,w=o?.indexOf("Mobi")>=0,E=!0,y=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,k=y,p=navigator.language;else if(typeof r=="object"){F=r.platform==="win32",d=r.platform==="darwin",L=r.platform==="linux",A=L&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,v=s,I=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,k=e.$g;const S=r.env.VSCODE_NLS_CONFIG;if(S)try{const b=JSON.parse(S),f=b.availableLanguages["*"];y=b.locale,p=b.osLocale,k=f||e.$g,u=b._translationsConfigFile}catch{}$=!0}else console.error("Unable to resolve platform.");var h;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(h||(e.Platform=h={}));function t(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let n=0;d?n=1:F?n=3:L&&(n=2),e.$j=F,e.$k=d,e.$l=L,e.$m=A,e.$n=$,e.$o=v,e.$p=E,e.$q=E&&typeof e.$h.importScripts=="function",e.$r=R,e.$s=w,e.$t=I,e.$u=n,e.$v=o,e.$w=k;var c;(function(S){function b(){return e.$w}S.value=b;function f(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}S.isDefaultVariant=f;function g(){return e.$w==="en"}S.isDefault=g})(c||(e.Language=c={})),e.$x=y,e.$y=p,e.$z=u,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const S=[];e.$h.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let g=0,P=S.length;g<P;g++){const N=S[g];if(N.id===f.data.vscodeScheduleAsyncWork){S.splice(g,1),N.callback();return}}});let b=0;return f=>{const g=++b;S.push({id:g,callback:f}),e.$h.postMessage({vscodeScheduleAsyncWork:g},"*")}}return S=>setTimeout(S)})();var i;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=d||R?2:F?1:3;let a=!0,l=!1;function D(){if(!l){l=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,a=new Uint16Array(S.buffer)[0]===(2<<8)+1}return a}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(De[48],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let F;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.process<"u"){const d=C.$h.vscode.process;F={get platform(){return d.platform},get arch(){return d.arch},get env(){return d.env},cwd(){return d.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return C.$j?"win32":C.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$dc=F.platform,e.$ec=F.arch}),define(De[16],Ce([1,0,48]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const F=65,d=97,L=90,A=122,$=46,E=47,v=92,R=58,I=63;class w extends Error{constructor(n,c,i){let a;typeof c=="string"&&c.indexOf("not ")===0?(a="must not be",c=c.replace(/^not /,"")):a="must be";const l=n.indexOf(".")!==-1?"property":"argument";let D=`The "${n}" ${l} ${a} of type ${c}`;D+=`. Received type ${typeof i}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,n){if(t===null||typeof t!="object")throw new w(n,"Object",t)}function k(t,n){if(typeof t!="string")throw new w(n,"string",t)}const p=C.$dc==="win32";function u(t){return t===E||t===v}function o(t){return t===E}function r(t){return t>=F&&t<=L||t>=d&&t<=A}function s(t,n,c,i){let a="",l=0,D=-1,S=0,b=0;for(let f=0;f<=t.length;++f){if(f<t.length)b=t.charCodeAt(f);else{if(i(b))break;b=E}if(i(b)){if(!(D===f-1||S===1))if(S===2){if(a.length<2||l!==2||a.charCodeAt(a.length-1)!==$||a.charCodeAt(a.length-2)!==$){if(a.length>2){const g=a.lastIndexOf(c);g===-1?(a="",l=0):(a=a.slice(0,g),l=a.length-1-a.lastIndexOf(c)),D=f,S=0;continue}else if(a.length!==0){a="",l=0,D=f,S=0;continue}}n&&(a+=a.length>0?`${c}..`:"..",l=2)}else a.length>0?a+=`${c}${t.slice(D+1,f)}`:a=t.slice(D+1,f),l=f-D-1;D=f,S=0}else b===$&&S!==-1?++S:S=-1}return a}function m(t,n){y(n,"pathObject");const c=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return c?c===n.root?`${c}${i}`:`${c}${t}${i}`:i}e.$fc={resolve(...t){let n="",c="",i=!1;for(let a=t.length-1;a>=-1;a--){let l;if(a>=0){if(l=t[a],k(l,"path"),l.length===0)continue}else n.length===0?l=C.cwd():(l=C.env[`=${n}`]||C.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==n.toLowerCase()&&l.charCodeAt(2)===v)&&(l=`${n}\\`));const D=l.length;let S=0,b="",f=!1;const g=l.charCodeAt(0);if(D===1)u(g)&&(S=1,f=!0);else if(u(g))if(f=!0,u(l.charCodeAt(1))){let P=2,N=P;for(;P<D&&!u(l.charCodeAt(P));)P++;if(P<D&&P!==N){const O=l.slice(N,P);for(N=P;P<D&&u(l.charCodeAt(P));)P++;if(P<D&&P!==N){for(N=P;P<D&&!u(l.charCodeAt(P));)P++;(P===D||P!==N)&&(b=`\\\\${O}\\${l.slice(N,P)}`,S=P)}}}else S=1;else r(g)&&l.charCodeAt(1)===R&&(b=l.slice(0,2),S=2,D>2&&u(l.charCodeAt(2))&&(f=!0,S=3));if(b.length>0)if(n.length>0){if(b.toLowerCase()!==n.toLowerCase())continue}else n=b;if(i){if(n.length>0)break}else if(c=`${l.slice(S)}\\${c}`,i=f,f&&n.length>0)break}return c=s(c,!i,"\\",u),i?`${n}\\${c}`:`${n}${c}`||"."},normalize(t){k(t,"path");const n=t.length;if(n===0)return".";let c=0,i,a=!1;const l=t.charCodeAt(0);if(n===1)return o(l)?"\\":t;if(u(l))if(a=!0,u(t.charCodeAt(1))){let S=2,b=S;for(;S<n&&!u(t.charCodeAt(S));)S++;if(S<n&&S!==b){const f=t.slice(b,S);for(b=S;S<n&&u(t.charCodeAt(S));)S++;if(S<n&&S!==b){for(b=S;S<n&&!u(t.charCodeAt(S));)S++;if(S===n)return`\\\\${f}\\${t.slice(b)}\\`;S!==b&&(i=`\\\\${f}\\${t.slice(b,S)}`,c=S)}}}else c=1;else r(l)&&t.charCodeAt(1)===R&&(i=t.slice(0,2),c=2,n>2&&u(t.charCodeAt(2))&&(a=!0,c=3));let D=c<n?s(t.slice(c),!a,"\\",u):"";return D.length===0&&!a&&(D="."),D.length>0&&u(t.charCodeAt(n-1))&&(D+="\\"),i===void 0?a?`\\${D}`:D:a?`${i}\\${D}`:`${i}${D}`},isAbsolute(t){k(t,"path");const n=t.length;if(n===0)return!1;const c=t.charCodeAt(0);return u(c)||n>2&&r(c)&&t.charCodeAt(1)===R&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,c;for(let l=0;l<t.length;++l){const D=t[l];k(D,"path"),D.length>0&&(n===void 0?n=c=D:n+=`\\${D}`)}if(n===void 0)return".";let i=!0,a=0;if(typeof c=="string"&&u(c.charCodeAt(0))){++a;const l=c.length;l>1&&u(c.charCodeAt(1))&&(++a,l>2&&(u(c.charCodeAt(2))?++a:i=!1))}if(i){for(;a<n.length&&u(n.charCodeAt(a));)a++;a>=2&&(n=`\\${n.slice(a)}`)}return e.$fc.normalize(n)},relative(t,n){if(k(t,"from"),k(n,"to"),t===n)return"";const c=e.$fc.resolve(t),i=e.$fc.resolve(n);if(c===i||(t=c.toLowerCase(),n=i.toLowerCase(),t===n))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===v;)a++;let l=t.length;for(;l-1>a&&t.charCodeAt(l-1)===v;)l--;const D=l-a;let S=0;for(;S<n.length&&n.charCodeAt(S)===v;)S++;let b=n.length;for(;b-1>S&&n.charCodeAt(b-1)===v;)b--;const f=b-S,g=D<f?D:f;let P=-1,N=0;for(;N<g;N++){const M=t.charCodeAt(a+N);if(M!==n.charCodeAt(S+N))break;M===v&&(P=N)}if(N!==g){if(P===-1)return i}else{if(f>g){if(n.charCodeAt(S+N)===v)return i.slice(S+N+1);if(N===2)return i.slice(S+N)}D>g&&(t.charCodeAt(a+N)===v?P=N:N===2&&(P=3)),P===-1&&(P=0)}let O="";for(N=a+P+1;N<=l;++N)(N===l||t.charCodeAt(N)===v)&&(O+=O.length===0?"..":"\\..");return S+=P,O.length>0?`${O}${i.slice(S,b)}`:(i.charCodeAt(S)===v&&++S,i.slice(S,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$fc.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===v){if(n.charCodeAt(1)===v){const c=n.charCodeAt(2);if(c!==I&&c!==$)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(r(n.charCodeAt(0))&&n.charCodeAt(1)===R&&n.charCodeAt(2)===v)return`\\\\?\\${n}`;return t},dirname(t){k(t,"path");const n=t.length;if(n===0)return".";let c=-1,i=0;const a=t.charCodeAt(0);if(n===1)return u(a)?t:".";if(u(a)){if(c=i=1,u(t.charCodeAt(1))){let S=2,b=S;for(;S<n&&!u(t.charCodeAt(S));)S++;if(S<n&&S!==b){for(b=S;S<n&&u(t.charCodeAt(S));)S++;if(S<n&&S!==b){for(b=S;S<n&&!u(t.charCodeAt(S));)S++;if(S===n)return t;S!==b&&(c=i=S+1)}}}}else r(a)&&t.charCodeAt(1)===R&&(c=n>2&&u(t.charCodeAt(2))?3:2,i=c);let l=-1,D=!0;for(let S=n-1;S>=i;--S)if(u(t.charCodeAt(S))){if(!D){l=S;break}}else D=!1;if(l===-1){if(c===-1)return".";l=c}return t.slice(0,l)},basename(t,n){n!==void 0&&k(n,"ext"),k(t,"path");let c=0,i=-1,a=!0,l;if(t.length>=2&&r(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(c=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let D=n.length-1,S=-1;for(l=t.length-1;l>=c;--l){const b=t.charCodeAt(l);if(u(b)){if(!a){c=l+1;break}}else S===-1&&(a=!1,S=l+1),D>=0&&(b===n.charCodeAt(D)?--D===-1&&(i=l):(D=-1,i=S))}return c===i?i=S:i===-1&&(i=t.length),t.slice(c,i)}for(l=t.length-1;l>=c;--l)if(u(t.charCodeAt(l))){if(!a){c=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(c,i)},extname(t){k(t,"path");let n=0,c=-1,i=0,a=-1,l=!0,D=0;t.length>=2&&t.charCodeAt(1)===R&&r(t.charCodeAt(0))&&(n=i=2);for(let S=t.length-1;S>=n;--S){const b=t.charCodeAt(S);if(u(b)){if(!l){i=S+1;break}continue}a===-1&&(l=!1,a=S+1),b===$?c===-1?c=S:D!==1&&(D=1):c!==-1&&(D=-1)}return c===-1||a===-1||D===0||D===1&&c===a-1&&c===i+1?"":t.slice(c,a)},format:m.bind(null,"\\"),parse(t){k(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const c=t.length;let i=0,a=t.charCodeAt(0);if(c===1)return u(a)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(u(a)){if(i=1,u(t.charCodeAt(1))){let P=2,N=P;for(;P<c&&!u(t.charCodeAt(P));)P++;if(P<c&&P!==N){for(N=P;P<c&&u(t.charCodeAt(P));)P++;if(P<c&&P!==N){for(N=P;P<c&&!u(t.charCodeAt(P));)P++;P===c?i=P:P!==N&&(i=P+1)}}}}else if(r(a)&&t.charCodeAt(1)===R){if(c<=2)return n.root=n.dir=t,n;if(i=2,u(t.charCodeAt(2))){if(c===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let l=-1,D=i,S=-1,b=!0,f=t.length-1,g=0;for(;f>=i;--f){if(a=t.charCodeAt(f),u(a)){if(!b){D=f+1;break}continue}S===-1&&(b=!1,S=f+1),a===$?l===-1?l=f:g!==1&&(g=1):l!==-1&&(g=-1)}return S!==-1&&(l===-1||g===0||g===1&&l===S-1&&l===D+1?n.base=n.name=t.slice(D,S):(n.name=t.slice(D,l),n.base=t.slice(D,S),n.ext=t.slice(l,S))),D>0&&D!==i?n.dir=t.slice(0,D-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(p){const t=/\\/g;return()=>{const n=C.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>C.cwd()})();e.$gc={resolve(...t){let n="",c=!1;for(let i=t.length-1;i>=-1&&!c;i--){const a=i>=0?t[i]:h();k(a,"path"),a.length!==0&&(n=`${a}/${n}`,c=a.charCodeAt(0)===E)}return n=s(n,!c,"/",o),c?`/${n}`:n.length>0?n:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E,c=t.charCodeAt(t.length-1)===E;return t=s(t,!n,"/",o),t.length===0?n?"/":c?"./":".":(c&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let n;for(let c=0;c<t.length;++c){const i=t[c];k(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.$gc.normalize(n)},relative(t,n){if(k(t,"from"),k(n,"to"),t===n||(t=e.$gc.resolve(t),n=e.$gc.resolve(n),t===n))return"";const c=1,i=t.length,a=i-c,l=1,D=n.length-l,S=a<D?a:D;let b=-1,f=0;for(;f<S;f++){const P=t.charCodeAt(c+f);if(P!==n.charCodeAt(l+f))break;P===E&&(b=f)}if(f===S)if(D>S){if(n.charCodeAt(l+f)===E)return n.slice(l+f+1);if(f===0)return n.slice(l+f)}else a>S&&(t.charCodeAt(c+f)===E?b=f:f===0&&(b=0));let g="";for(f=c+b+1;f<=i;++f)(f===i||t.charCodeAt(f)===E)&&(g+=g.length===0?"..":"/..");return`${g}${n.slice(l+b)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E;let c=-1,i=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===E){if(!i){c=a;break}}else i=!1;return c===-1?n?"/":".":n&&c===1?"//":t.slice(0,c)},basename(t,n){n!==void 0&&k(n,"ext"),k(t,"path");let c=0,i=-1,a=!0,l;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let D=n.length-1,S=-1;for(l=t.length-1;l>=0;--l){const b=t.charCodeAt(l);if(b===E){if(!a){c=l+1;break}}else S===-1&&(a=!1,S=l+1),D>=0&&(b===n.charCodeAt(D)?--D===-1&&(i=l):(D=-1,i=S))}return c===i?i=S:i===-1&&(i=t.length),t.slice(c,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===E){if(!a){c=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(c,i)},extname(t){k(t,"path");let n=-1,c=0,i=-1,a=!0,l=0;for(let D=t.length-1;D>=0;--D){const S=t.charCodeAt(D);if(S===E){if(!a){c=D+1;break}continue}i===-1&&(a=!1,i=D+1),S===$?n===-1?n=D:l!==1&&(l=1):n!==-1&&(l=-1)}return n===-1||i===-1||l===0||l===1&&n===i-1&&n===c+1?"":t.slice(n,i)},format:m.bind(null,"/"),parse(t){k(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const c=t.charCodeAt(0)===E;let i;c?(n.root="/",i=1):i=0;let a=-1,l=0,D=-1,S=!0,b=t.length-1,f=0;for(;b>=i;--b){const g=t.charCodeAt(b);if(g===E){if(!S){l=b+1;break}continue}D===-1&&(S=!1,D=b+1),g===$?a===-1?a=b:f!==1&&(f=1):a!==-1&&(f=-1)}if(D!==-1){const g=l===0&&c?1:l;a===-1||f===0||f===1&&a===D-1&&a===l+1?n.base=n.name=t.slice(g,D):(n.name=t.slice(g,a),n.base=t.slice(g,D),n.ext=t.slice(a,D))}return l>0?n.dir=t.slice(0,l-1):c&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(De[126],Ce([1,0,47,16]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=void 0;const d=new C.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),L=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(S,b,f=!1){const g=S||"",P=b||"",N=d.value.collator.compare(g,P);return d.value.collatorIsNumeric&&N===0&&g!==P?g<P?-1:1:N}e.$iq=$;function E(S,b){const f=L.value.collator;return S=S||"",b=b||"",m(f,S,b)}e.$jq=E;function v(S,b){const f=L.value.collator;return S=S||"",b=b||"",c(S,b)||m(f,S,b)}e.$kq=v;function R(S,b){const f=L.value.collator;return S=S||"",b=b||"",n(S,b)||m(f,S,b)}e.$lq=R;function I(S,b){return S=S||"",b=b||"",S===b?0:S<b?-1:1}e.$mq=I;function w(S,b){const[f,g]=r(S),[P,N]=r(b);let O=d.value.collator.compare(g,N);if(O===0){if(d.value.collatorIsNumeric&&g!==N)return g<N?-1:1;if(O=d.value.collator.compare(f,P),d.value.collatorIsNumeric&&O===0&&f!==P)return f<P?-1:1}return O}e.$nq=w;function y(S,b){S=S||"",b=b||"";const f=s(S),g=s(b),P=L.value.collator,N=A.value.collator;return m(N,f,g)||m(P,S,b)}e.$oq=y;function k(S,b){S=S||"",b=b||"";const f=s(S),g=s(b),P=L.value.collator,N=A.value.collator;return m(N,f,g)||c(S,b)||m(P,S,b)}e.$pq=k;function p(S,b){S=S||"",b=b||"";const f=s(S),g=s(b),P=L.value.collator,N=A.value.collator;return m(N,f,g)||n(S,b)||m(P,S,b)}e.$qq=p;function u(S,b){S=S||"",b=b||"";const f=s(S).toLowerCase(),g=s(b).toLowerCase();return f!==g?f<g?-1:1:S!==b?S<b?-1:1:0}e.$rq=u;const o=/^(.*?)(\.([^.]*))?$/;function r(S,b=!1){const f=S?o.exec(S):[];let g=[f&&f[1]||"",f&&f[3]||""];return b&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function s(S){const b=S?o.exec(S):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function m(S,b,f){const g=S.compare(b,f);return g!==0?g:b.length!==f.length?b.length<f.length?-1:1:0}function h(S){const b=S.charAt(0);return b.toLocaleUpperCase()!==b}function t(S){const b=S.charAt(0);return b.toLocaleLowerCase()!==b}function n(S,b){return h(S)&&t(b)?-1:t(S)&&h(b)?1:0}function c(S,b){return t(S)&&h(b)?-1:h(S)&&t(b)?1:0}function i(S,b,f=!1){return f||(S=S&&S.toLowerCase(),b=b&&b.toLowerCase()),S===b?0:S<b?-1:1}function a(S,b,f=!1){const g=S.split(F.sep),P=b.split(F.sep),N=g.length-1,O=P.length-1;let M,j;for(let U=0;;U++){if(M=N===U,j=O===U,M&&j)return $(g[U],P[U],f);if(M)return-1;if(j)return 1;const T=i(g[U],P[U],f);if(T!==0)return T}}e.$sq=a;function l(S,b,f){const g=S.toLowerCase(),P=b.toLowerCase(),N=D(S,b,f);if(N)return N;const O=g.endsWith(f),M=P.endsWith(f);if(O!==M)return O?-1:1;const j=$(g,P);return j!==0?j:g.localeCompare(P)}e.$tq=l;function D(S,b,f){const g=S.toLowerCase(),P=b.toLowerCase(),N=g.startsWith(f),O=P.startsWith(f);if(N!==O)return N?-1:1;if(N&&O){if(g.length<P.length)return-1;if(g.length>P.length)return 1}return 0}e.$uq=D}),define(De[33],Ce([1,0,16,12,15,17]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function A(l){return l===47||l===92}e.$Qf=A;function $(l){return l.replace(/[\\/]/g,C.$gc.sep)}e.$Rf=$;function E(l){return l.indexOf("/")===-1&&(l=$(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Sf=E;function v(l,D=C.$gc.sep){if(!l)return"";const S=l.length,b=l.charCodeAt(0);if(A(b)){if(A(l.charCodeAt(1))&&!A(l.charCodeAt(2))){let g=3;const P=g;for(;g<S&&!A(l.charCodeAt(g));g++);if(P!==g&&!A(l.charCodeAt(g+1))){for(g+=1;g<S;g++)if(A(l.charCodeAt(g)))return l.slice(0,g+1).replace(/[\\/]/g,D)}}return D}else if(o(b)&&l.charCodeAt(1)===58)return A(l.charCodeAt(2))?l.slice(0,2)+D:l.slice(0,2);let f=l.indexOf("://");if(f!==-1){for(f+=3;f<S;f++)if(A(l.charCodeAt(f)))return l.slice(0,f+1)}return""}e.$Tf=v;function R(l){if(!F.$j||!l||l.length<5)return!1;let D=l.charCodeAt(0);if(D!==92||(D=l.charCodeAt(1),D!==92))return!1;let S=2;const b=S;for(;S<l.length&&(D=l.charCodeAt(S),D!==92);S++);return!(b===S||(D=l.charCodeAt(S+1),isNaN(D)||D===92))}e.$Uf=R;const I=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(l,D=F.$j){const S=D?I:w;return!(!l||l.length===0||/^\s+$/.test(l)||(S.lastIndex=0,S.test(l))||D&&y.test(l)||l==="."||l===".."||D&&l[l.length-1]==="."||D&&l.length!==l.trim().length||l.length>255)}e.$Vf=k;function p(l,D,S){const b=l===D;return!S||b?b:!l||!D?!1:(0,d.$2e)(l,D)}e.$Wf=p;function u(l,D,S,b=C.sep){if(l===D)return!0;if(!l||!D||D.length>l.length)return!1;if(S){if(!(0,d.$3e)(l,D))return!1;if(D.length===l.length)return!0;let g=D.length;return D.charAt(D.length-1)===b&&g--,l.charAt(g)===b}return D.charAt(D.length-1)!==b&&(D+=b),l.indexOf(D)===0}e.$Xf=u;function o(l){return l>=65&&l<=90||l>=97&&l<=122}e.$Yf=o;function r(l,D){return F.$j&&l.endsWith(":")&&(l+=C.sep),(0,C.$ic)(l)||(l=(0,C.$jc)(D,l)),l=(0,C.$hc)(l),F.$j?(l=(0,d.$Ke)(l,C.sep),l.endsWith(":")&&(l+=C.sep)):(l=(0,d.$Ke)(l,C.sep),l||(l=C.sep)),l}e.$Zf=r;function s(l){const D=(0,C.$hc)(l);return F.$j?l.length>3?!1:m(D)&&(l.length===2||D.charCodeAt(2)===92):D===C.$gc.sep}e.$1f=s;function m(l,D=F.$j){return D?o(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$2f=m;function h(l,D=F.$j){return m(l,D)?l[0]:void 0}e.$3f=h;function t(l,D,S){return D.length>l.length?-1:l===D?0:(S&&(l=l.toLowerCase(),D=D.toLowerCase()),l.indexOf(D))}e.$4f=t;function n(l){const D=l.split(":");let S,b,f;for(const g of D){const P=Number(g);(0,L.$Cf)(P)?b===void 0?b=P:f===void 0&&(f=P):S=S?[S,g].join(":"):g}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:b!==void 0?b:void 0,column:f!==void 0?f:b!==void 0?1:void 0}}e.$5f=n;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(l,D,S=8){let b="";for(let g=0;g<S;g++){let P;g===0&&F.$j&&!D&&(S===3||S===4)?P=i:P=c,b+=P.charAt(Math.floor(Math.random()*P.length))}let f;return D?f=`${D}-${b}`:f=b,l?(0,C.$jc)(l,f):f}e.$6f=a}),define(De[127],Ce([1,0,126,121,52,16,12,15]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=void 0;const E=0,v=[E,[]];function R(K,q,ge,ee){if(!K||!q)return v;const Q=K.length,X=q.length;if(Q<X)return v;const ae=K.toLowerCase();return I(q,ge,X,K,ae,Q,ee)}e.$vq=R;function I(K,q,ge,ee,Q,X,ae){const ie=[],ce=[];for(let J=0;J<ge;J++){const re=J*X,Y=re-X,_=J>0,x=K[J],pe=q[J];for(let ue=0;ue<X;ue++){const fe=ue>0,te=re+ue,de=te-1,be=Y+ue-1,Pe=fe?ie[de]:0,z=_&&fe?ie[be]:0,G=_&&fe?ce[be]:0;let se;!z&&_?se=0:se=w(x,pe,ee,Q,ue,G),se&&z+se>=Pe&&(ae||_||Q.startsWith(q,ue))?(ce[te]=G+1,ie[te]=z+se):(ce[te]=E,ie[te]=Pe)}}const we=[];let H=ge-1,B=X-1;for(;H>=0&&B>=0;){const J=H*X+B;ce[J]===E||(we.push(B),H--),B--}return[ie[ge*X-1],we.reverse()]}function w(K,q,ge,ee,Q,X){let ae=0;if(!y(q,ee[Q]))return ae;if(ae+=1,X>0&&(ae+=X*5),K===ge[Q]&&(ae+=1),Q===0)ae+=8;else{const ie=k(ge.charCodeAt(Q-1));ie?ae+=ie:(0,F.$Gj)(ge.charCodeAt(Q))&&X===0&&(ae+=2)}return ae}function y(K,q){return K===q?!0:K==="/"||K==="\\"?q==="/"||q==="\\":!1}function k(K){switch(K){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function u(K,q,ge=0,ee=0){const Q=q;return Q.values&&Q.values.length>1?o(K,Q.values,ge,ee):r(K,q,ge,ee)}e.$wq=u;function o(K,q,ge,ee){let Q=0;const X=[];for(const ae of q){const[ie,ce]=r(K,ae,ge,ee);if(typeof ie!="number")return p;Q+=ie,X.push(...ce)}return[Q,S(X)]}function r(K,q,ge,ee){const Q=(0,F.$Pj)(q.original,q.originalLowercase,ge,K,K.toLowerCase(),ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,F.$Mj)(Q)]:p}const s=Object.freeze({score:0}),m=1<<18,h=1<<17,t=1<<16;function n(K,q,ge,ee){const Q=ee.values?ee.values:[ee];return(0,d.$Di)({[ee.normalized]:{values:Q.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:K,description:q,allowNonContiguousMatches:ge}})}function c(K,q,ge,ee,Q){if(!K||!q.normalized)return s;const X=ee.getItemLabel(K);if(!X)return s;const ae=ee.getItemDescription(K),ie=n(X,ae,ge,q),ce=Q[ie];if(ce)return ce;const we=i(X,ae,ee.getItemPath(K),q,ge);return Q[ie]=we,we}e.$xq=c;function i(K,q,ge,ee,Q){const X=!ge||!ee.containsPathSeparator;return ge&&(A.$l?ee.pathNormalized===ge:(0,$.$2e)(ee.pathNormalized,ge))?{score:m,labelMatch:[{start:0,end:K.length}],descriptionMatch:q?[{start:0,end:q.length}]:void 0}:ee.values&&ee.values.length>1?a(K,q,ge,ee.values,X,Q):l(K,q,ge,ee,X,Q)}function a(K,q,ge,ee,Q,X){let ae=0;const ie=[],ce=[];for(const we of ee){const{score:H,labelMatch:B,descriptionMatch:J}=l(K,q,ge,we,Q,X);if(H===E)return s;ae+=H,B&&ie.push(...B),J&&ce.push(...J)}return{score:ae,labelMatch:S(ie),descriptionMatch:S(ce)}}function l(K,q,ge,ee,Q,X){if(Q||!q){const[ae,ie]=R(K,ee.normalized,ee.normalizedLowercase,X&&!ee.expectContiguousMatch);if(ae){const ce=(0,F.$Dj)(ee.normalized,K);let we;if(ce){we=h;const H=Math.round(ee.normalized.length/K.length*100);we+=H}else we=t;return{score:we+ae,labelMatch:ce||D(ie)}}}if(q){let ae=q;ge&&(ae=`${q}${L.sep}`);const ie=ae.length,ce=`${ae}${K}`,[we,H]=R(ce,ee.normalized,ee.normalizedLowercase,X&&!ee.expectContiguousMatch);if(we){const B=D(H),J=[],re=[];return B.forEach(Y=>{Y.start<ie&&Y.end>ie?(J.push({start:0,end:Y.end-ie}),re.push({start:Y.start,end:ie})):Y.start>=ie?J.push({start:Y.start-ie,end:Y.end-ie}):re.push(Y)}),{score:we,labelMatch:J,descriptionMatch:re}}}return s}function D(K){const q=[];if(!K)return q;let ge;for(const ee of K)ge&&ge.end===ee?ge.end+=1:(ge={start:ee,end:ee+1},q.push(ge));return q}function S(K){const q=K.sort((Q,X)=>Q.start-X.start),ge=[];let ee;for(const Q of q)!ee||!b(ee,Q)?(ee=Q,ge.push(Q)):(ee.start=Math.min(ee.start,Q.start),ee.end=Math.max(ee.end,Q.end));return ge}function b(K,q){return!(K.end<q.start||q.end<K.start)}function f(K,q,ge,ee,Q,X){const ae=c(K,ge,ee,Q,X),ie=c(q,ge,ee,Q,X),ce=ae.score,we=ie.score;if((ce===m||we===m)&&ce!==we)return ce===m?-1:1;if(ce>t||we>t){if(ce!==we)return ce>we?-1:1;if(ce<h&&we<h){const x=P(ae.labelMatch,ie.labelMatch);if(x!==0)return x}const Y=Q.getItemLabel(K)||"",_=Q.getItemLabel(q)||"";if(Y.length!==_.length)return Y.length-_.length}if(ce!==we)return ce>we?-1:1;const H=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,B=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(H&&!B)return-1;if(B&&!H)return 1;const J=g(K,ae,Q),re=g(q,ie,Q);return J&&re&&J!==re?re>J?-1:1:N(K,q,ge,Q)}e.$yq=f;function g(K,q,ge){let ee=-1,Q=-1;if(q.descriptionMatch&&q.descriptionMatch.length?ee=q.descriptionMatch[0].start:q.labelMatch&&q.labelMatch.length&&(ee=q.labelMatch[0].start),q.labelMatch&&q.labelMatch.length){if(Q=q.labelMatch[q.labelMatch.length-1].end,q.descriptionMatch&&q.descriptionMatch.length){const X=ge.getItemDescription(K);X&&(Q+=X.length)}}else q.descriptionMatch&&q.descriptionMatch.length&&(Q=q.descriptionMatch[q.descriptionMatch.length-1].end);return Q-ee}function P(K,q){if(!K&&!q||(!K||!K.length)&&(!q||!q.length))return 0;if(!q||!q.length)return-1;if(!K||!K.length)return 1;const ge=K[0].start,Q=K[K.length-1].end-ge,X=q[0].start,ie=q[q.length-1].end-X;return Q===ie?0:ie<Q?1:-1}function N(K,q,ge,ee){const Q=ee.getItemLabel(K)||"",X=ee.getItemLabel(q)||"",ae=ee.getItemDescription(K),ie=ee.getItemDescription(q),ce=Q.length+(ae?ae.length:0),we=X.length+(ie?ie.length:0);if(ce!==we)return ce-we;const H=ee.getItemPath(K),B=ee.getItemPath(q);return H&&B&&H.length!==B.length?H.length-B.length:Q!==X?(0,C.$tq)(Q,X,ge.normalized):ae&&ie&&ae!==ie?(0,C.$tq)(ae,ie,ge.normalized):H&&B&&H!==B?(0,C.$tq)(H,B,ge.normalized):0}function O(K){return K.startsWith('"')&&K.endsWith('"')}const M=" ";function j(K){typeof K!="string"&&(K="");const q=K.toLowerCase(),{pathNormalized:ge,normalized:ee,normalizedLowercase:Q}=U(K),X=ge.indexOf(L.sep)>=0,ae=O(K);let ie;const ce=K.split(M);if(ce.length>1)for(const we of ce){const H=O(we),{pathNormalized:B,normalized:J,normalizedLowercase:re}=U(we);J&&(ie||(ie=[]),ie.push({original:we,originalLowercase:we.toLowerCase(),pathNormalized:B,normalized:J,normalizedLowercase:re,expectContiguousMatch:H}))}return{original:K,originalLowercase:q,pathNormalized:ge,normalized:ee,normalizedLowercase:Q,values:ie,containsPathSeparator:X,expectContiguousMatch:ae}}e.$zq=j;function U(K){let q;A.$j?q=K.replace(/\//g,L.sep):q=K.replace(/\\/g,L.sep);const ge=(0,$.$Me)(q).replace(/\s|"/g,"");return{pathNormalized:q,normalized:ge,normalizedLowercase:ge.toLowerCase()}}function T(K){return Array.isArray(K)?j(K.map(q=>q.original).join(M)):j(K.original)}e.$Aq=T}),define(De[97],Ce([1,0,16]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=e.$Rr=e.$Qr=void 0,e.$Qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const I=(0,C.$oc)(R),w=F[I.toLowerCase()];return w!==void 0?w:A(R)}e.$Rr=L;function A(R){const I=(0,C.$oc)(R);return d[I.toLowerCase()]}e.$Sr=A;function $(R){for(const I in d)if(d[I]===R)return I}e.$Tr=$;const E=/^(.+)\/(.+?)(;.+)?$/;function v(R,I){const w=E.exec(R);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:I?void 0:R}e.$Ur=v}),define(De[98],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var F;(function($){$[$.stdout=0]="stdout",$[$.stderr=1]="stderr"})(F||(e.Source=F={}));var d;(function($){$[$.Success=0]="Success",$[$.Unknown=1]="Unknown",$[$.AccessDenied=2]="AccessDenied",$[$.ProcessNotFound=3]="ProcessNotFound"})(d||(e.TerminateResponseCode=d={}));function L($,...E){const v=E.reduce((w,y)=>(w[y]=!0,w),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys($).filter(w=>!v[w]).forEach(w=>{for(let y=0;y<R.length;y++)if(w.search(R[y])!==-1){delete $[w];break}})}e.$zl=L;function A($){$&&(delete $.DEBUG,C.$k&&delete $.DYLD_LIBRARY_PATH,C.$l&&delete $.LD_PRELOAD)}e.$Al=A}),define(De[2],Ce([1,0,16,12]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const d=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function $(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!d.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,a){return!i&&!a?"file":i}function v(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const R="",I="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,l,D,S,b,f=!1){typeof a=="object"?(this.scheme=a.scheme||R,this.authority=a.authority||R,this.path=a.path||R,this.query=a.query||R,this.fragment=a.fragment||R):(this.scheme=E(a,f),this.authority=l||R,this.path=v(this.scheme,D||R),this.query=S||R,this.fragment=b||R,$(this,f))}get fsPath(){return m(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:D,path:S,query:b,fragment:f}=a;return l===void 0?l=this.scheme:l===null&&(l=R),D===void 0?D=this.authority:D===null&&(D=R),S===void 0?S=this.path:S===null&&(S=R),b===void 0?b=this.query:b===null&&(b=R),f===void 0?f=this.fragment:f===null&&(f=R),l===this.scheme&&D===this.authority&&S===this.path&&b===this.query&&f===this.fragment?this:new u(l,D,S,b,f)}static parse(a,l=!1){const D=w.exec(a);return D?new u(D[2]||R,c(D[4]||R),c(D[5]||R),c(D[7]||R),c(D[9]||R),l):new u(R,R,R,R,R)}static file(a){let l=R;if(F.$j&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const D=a.indexOf(I,2);D===-1?(l=a.substring(2),a=I):(l=a.substring(2,D),a=a.substring(D)||I)}return new u("file",l,a,R,R)}static from(a,l){return new u(a.scheme,a.authority,a.path,a.query,a.fragment,l)}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return F.$j&&a.scheme==="file"?D=y.file(C.$fc.join(m(a,!0),...l)).path:D=C.$gc.join(a.path,...l),a.with({path:D})}toString(a=!1){return h(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const l=new u(a);return l._formatted=a.external??null,l._fsPath=a._sep===p?a.fsPath??null:null,l}}else return a}}e.URI=y;function k(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=k;const p=F.$j?1:void 0;class u extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(a=!1){return a?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=p),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function r(i,a,l){let D,S=-1;for(let b=0;b<i.length;b++){const f=i.charCodeAt(b);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||a&&f===47||l&&f===91||l&&f===93||l&&f===58)S!==-1&&(D+=encodeURIComponent(i.substring(S,b)),S=-1),D!==void 0&&(D+=i.charAt(b));else{D===void 0&&(D=i.substr(0,b));const g=o[f];g!==void 0?(S!==-1&&(D+=encodeURIComponent(i.substring(S,b)),S=-1),D+=g):S===-1&&(S=b)}}return S!==-1&&(D+=encodeURIComponent(i.substring(S))),D!==void 0?D:i}function s(i){let a;for(let l=0;l<i.length;l++){const D=i.charCodeAt(l);D===35||D===63?(a===void 0&&(a=i.substr(0,l)),a+=o[D]):a!==void 0&&(a+=i[l])}return a!==void 0?a:i}function m(i,a){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,F.$j&&(l=l.replace(/\//g,"\\")),l}e.$wc=m;function h(i,a){const l=a?s:r;let D="",{scheme:S,authority:b,path:f,query:g,fragment:P}=i;if(S&&(D+=S,D+=":"),(b||S==="file")&&(D+=I,D+=I),b){let N=b.indexOf("@");if(N!==-1){const O=b.substr(0,N);b=b.substr(N+1),N=O.lastIndexOf(":"),N===-1?D+=l(O,!1,!1):(D+=l(O.substr(0,N),!1,!1),D+=":",D+=l(O.substr(N+1),!1,!0)),D+="@"}b=b.toLowerCase(),N=b.lastIndexOf(":"),N===-1?D+=l(b,!1,!0):(D+=l(b.substr(0,N),!1,!0),D+=b.substr(N))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const N=f.charCodeAt(1);N>=65&&N<=90&&(f=`/${String.fromCharCode(N+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const N=f.charCodeAt(0);N>=65&&N<=90&&(f=`${String.fromCharCode(N+32)}:${f.substr(2)}`)}D+=l(f,!0,!1)}return g&&(D+="?",D+=l(g,!1,!1)),P&&(D+="#",D+=a?P:r(P,!1,!1)),D}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(n)?i.replace(n,a=>t(a)):i}}),define(De[181],Ce([1,0,2]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$1p=e.$Zp=e.$Yp=void 0;function F(v){const R=v;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$Yp=F;function d(v){const R=[];let I;try{const w=JSON.parse(v.arguments),y=w[w.length-1];y&&y.__$stack&&(w.pop(),I=y.__$stack),R.push(...w)}catch{R.push("Unable to log remote console arguments",v.arguments)}return{args:R,stack:I}}e.$Zp=d;function L(v){if(typeof v!="string")return L(d(v).stack);const R=v;if(R){const I=A(R),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(w&&w.length===4)return{uri:C.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$1p=L;function A(v){if(!v)return v;const R=v.indexOf(`
`);return R===-1?v:v.substring(0,R)}function $(v,R){const{args:I,stack:w}=d(v),y=typeof I[0]=="string"&&I.length===1;let k=A(w);k&&(k=`(${k.trim()})`);let p=[];if(typeof I[0]=="string"?k&&y?p=[`%c[${R}] %c${I[0]} %c${k}`,E("blue"),E(""),E("grey")]:p=[`%c[${R}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:p=[`%c[${R}]%`,E("blue"),...I],k&&!y&&p.push(k),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,p)}e.log=$;function E(v){return`color: ${v}`}}),define(De[62],Ce([1,0,22,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function d(E){return JSON.stringify(E,A)}e.$kh=d;function L(E){let v=JSON.parse(E);return v=$(v),v}e.$lh=L;function A(E,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:v.flags}:v}function $(E,v=0){if(!E||v>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return F.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof C.$be||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let R=0;R<E.length;++R)E[R]=$(E[R],v+1);else for(const R in E)Object.hasOwnProperty.call(E,R)&&(E[R]=$(E[R],v+1))}return E}e.$mh=$}),define(De[18],Ce([1,0,9,12,2]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var L;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$7f="vscode-tkn",e.$8f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${L.vscodeRemoteResource}`}set(R,I,w){this.a[R]=I,this.b[R]=w}setConnectionToken(R,I){this.c[R]=I}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(u){return C.$1(u),R}const I=R.authority;let w=this.a[I];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const y=this.b[I],k=this.c[I];let p=`path=${encodeURIComponent(R.path)}`;return typeof k=="string"&&(p+=`&${e.$8f}=${encodeURIComponent(k)}`),d.URI.from({scheme:F.$p?this.d:L.vscodeRemoteResource,authority:`${w}:${y}`,path:this.f,query:p})}}e.$9f=new A,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class ${static{this.a=e.$bg}asBrowserUri(R){const I=this.b(R,$e);return this.uriToBrowserUri(I)}uriToBrowserUri(R){return R.scheme===L.vscodeRemote?e.$9f.rewrite(R):R.scheme===L.file&&(F.$n||F.$q&&F.$h.origin===`${L.vscodeFileResource}://${$.a}`)?R.with({scheme:L.vscodeFileResource,authority:R.authority||$.a,query:null,fragment:null}):R}asFileUri(R){const I=this.b(R,$e);return this.uriToFileUri(I)}uriToFileUri(R){return R.scheme===L.vscodeFileResource?R.with({scheme:L.file,authority:R.authority!==$.a?R.authority:null,query:null,fragment:null}):R}b(R,I){return d.URI.isUri(R)?R:d.URI.parse(I.toUrl(R))}}e.$cg=new $;var E;(function(v){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(R.get("3"));const I="vscode-coi";function w(k){let p;typeof k=="string"?p=new URL(k).searchParams:k instanceof URL?p=k.searchParams:d.URI.isUri(k)&&(p=new URL(k.toString(!0)).searchParams);const u=p?.get(I);if(u)return R.get(u)}v.getHeadersFromQuery=w;function y(k,p,u){if(!globalThis.crossOriginIsolated)return;const o=p&&u?"3":u?"2":"1";k instanceof URLSearchParams?k.set(I,o):k[I]=o}v.addSearchParam=y})(E||(e.COI=E={}))}),define(De[182],Ce([1,0,156,18,12,2]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=void 0;class A{constructor(w,y,k){this.id=w,this.dependencies=y,this.callback=k}}class ${static{this.INSTANCE=new $}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,y,k)=>{typeof w!="string"&&(k=y,y=w,w=null),(typeof y!="object"||!Array.isArray(y))&&(k=y,y=null),this.c.push(new A(w,y,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const y=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!y)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(w){return new Promise((y,k)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const u=()=>{p.removeEventListener("load",o),p.removeEventListener("error",r)},o=s=>{u(),y(this.c.pop())},r=s=>{u(),k(s)};p.addEventListener("load",o),p.addEventListener("error",r),this.f&&(w=this.f.createScriptURL(w)),p.setAttribute("src",w),document.getElementsByTagName("head")[0].appendChild(p)})}i(w){return new Promise((y,k)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),y(this.c.pop())}catch(p){k(p)}})}async j(w){try{const y=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,u=L.URI.parse(w).fsPath,o=y.readFileSync(u).toString(),r=p.wrap(o.replace(/^#!.*/,""));return new k.Script(r).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let v={};typeof globalThis.require=="object"&&(v=globalThis.require.paths??{});async function R(I,w,y){if(C.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),v[I]&&(I=v[I]);const k=`${I}/${w}`;if(E.has(k))return E.get(k);let p;if(/^\w[\w\d+.-]*:\/\//.test(k))p=k;else{const s=`${y&&!d.$p?F.$_f:F.$$f}/${k}`;p=F.$cg.asBrowserUri(s).toString(!0)}const u=$.INSTANCE.load(p);return E.set(k,u),u}else return await new Promise((k,p)=>{$e([I],k,p)})}e.$mC=R}),define(De[23],Ce([1,0,33,18,16,12,15,2]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function E(y){return(0,$.$wc)(y,!0)}e.$jg=E;class v{constructor(k){this.a=k}compare(k,p,u=!1){return k===p?0:(0,A.$Ue)(this.getComparisonKey(k,u),this.getComparisonKey(p,u))}isEqual(k,p,u=!1){return k===p?!0:!k||!p?!1:this.getComparisonKey(k,u)===this.getComparisonKey(p,u)}getComparisonKey(k,p=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,p,u=!1){if(k.scheme===p.scheme){if(k.scheme===F.Schemas.file)return C.$Xf(E(k),E(p),this.a(k))&&k.query===p.query&&(u||k.fragment===p.fragment);if((0,e.$Ag)(k.authority,p.authority))return C.$Xf(k.path,p.path,this.a(k),"/")&&k.query===p.query&&(u||k.fragment===p.fragment)}return!1}joinPath(k,...p){return $.URI.joinPath(k,...p)}basenameOrAuthority(k){return(0,e.$sg)(k)||k.authority}basename(k){return d.$gc.basename(k.path)}extname(k){return d.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let p;return k.scheme===F.Schemas.file?p=$.URI.file(d.$mc(E(k))).path:(p=d.$gc.dirname(k.path),k.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),p="/")),k.with({path:p})}normalizePath(k){if(!k.path.length)return k;let p;return k.scheme===F.Schemas.file?p=$.URI.file(d.$hc(E(k))).path:p=d.$gc.normalize(k.path),k.with({path:p})}relativePath(k,p){if(k.scheme!==p.scheme||!(0,e.$Ag)(k.authority,p.authority))return;if(k.scheme===F.Schemas.file){const r=d.$lc(E(k),E(p));return L.$j?C.$Rf(r):r}let u=k.path||"/";const o=p.path||"/";if(this.a(k)){let r=0;for(const s=Math.min(u.length,o.length);r<s&&!(u.charCodeAt(r)!==o.charCodeAt(r)&&u.charAt(r).toLowerCase()!==o.charAt(r).toLowerCase());r++);u=o.substr(0,r)+u.substr(r)}return d.$gc.relative(u,o)}resolvePath(k,p){if(k.scheme===F.Schemas.file){const u=$.URI.file(d.$kc(E(k),p));return k.with({authority:u.authority,path:u.path})}return p=C.$Sf(p),k.with({path:d.$gc.resolve(k.path,p)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,p){return k===p||k!==void 0&&p!==void 0&&(0,A.$2e)(k,p)}hasTrailingPathSeparator(k,p=d.sep){if(k.scheme===F.Schemas.file){const u=E(k);return u.length>C.$Tf(u).length&&u[u.length-1]===p}else{const u=k.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,p=d.sep){return(0,e.$Bg)(k,p)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,p=d.sep){let u=!1;if(k.scheme===F.Schemas.file){const o=E(k);u=o!==void 0&&o.length===C.$Tf(o).length&&o[o.length-1]===p}else{p="/";const o=k.path;u=o.length===1&&o.charCodeAt(o.length-1)===47}return!u&&!(0,e.$Bg)(k,p)?k.with({path:k.path+"/"}):k}}e.$kg=v,e.$lg=new v(()=>!1),e.$mg=new v(y=>y.scheme===F.Schemas.file?!L.$l:!0),e.$ng=new v(y=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function R(y,k){const p=[];for(let u=0;u<y.length;u++){const o=k(y[u]);y.some((r,s)=>s===u?!1:(0,e.$pg)(o,k(r)))||p.push(y[u])}return p}e.$Eg=R;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function k(p){const u=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(s=>{const[m,h]=s.split(":");m&&h&&u.set(m,h)});const r=p.path.substring(0,p.path.indexOf(";"));return r&&u.set(y.META_DATA_MIME,r),u}y.parseMetaData=k})(I||(e.DataUri=I={}));function w(y,k,p){if(k){let u=y.path;return u&&u[0]!==d.$gc.sep&&(u=d.$gc.sep+u),y.with({scheme:p,authority:k,path:u})}return y.with({scheme:p})}e.$Fg=w}),define(De[8],Ce([1,0,21,9,4,3,23,12,160]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function v(J){return!!J&&typeof J.then=="function"}e.$Gg=v;function R(J){const re=new C.$Xd,Y=J(re.token),_=new Promise((x,pe)=>{const ue=re.token.onCancellationRequested(()=>{ue.dispose(),re.dispose(),pe(new F.$5)});Promise.resolve(Y).then(fe=>{ue.dispose(),re.dispose(),x(fe)},fe=>{ue.dispose(),re.dispose(),pe(fe)})});return new class{cancel(){re.cancel()}then(x,pe){return _.then(x,pe)}catch(x){return this.then(void 0,x)}finally(x){return _.finally(x)}}}e.$Hg=R;function I(J,re,Y){return new Promise((_,x)=>{const pe=re.onCancellationRequested(()=>{pe.dispose(),_(Y)});J.then(_,x).finally(()=>pe.dispose())})}e.$Ig=I;function w(J,re){return new Promise((Y,_)=>{const x=re.onCancellationRequested(()=>{x.dispose(),_(new F.$5)});J.then(Y,_).finally(()=>x.dispose())})}e.$Jg=w;async function y(J){let re=-1;const Y=J.map((_,x)=>_.then(pe=>(re=x,pe)));try{return await Promise.race(Y)}finally{J.forEach((_,x)=>{x!==re&&_.cancel()})}}e.$Kg=y;function k(J,re,Y){let _;const x=setTimeout(()=>{_?.(void 0),Y?.()},re);return Promise.race([J.finally(()=>clearTimeout(x)),new Promise(pe=>_=pe)])}e.$Lg=k;function p(J){return new Promise((re,Y)=>{const _=J();v(_)?_.then(re,Y):re(_)})}e.$Mg=p;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(re){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=re,!this.b){const Y=()=>{if(this.b=null,this.f)return;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(Y,Y).then(_)})}return new Promise((Y,_)=>{this.b.then(Y,_)})}return this.a=re(),new Promise((Y,_)=>{this.a.then(x=>{this.a=null,Y(x)},x=>{this.a=null,_(x)})})}dispose(){this.f=!0}}e.$Ng=u;class o{constructor(){this.a=Promise.resolve(null)}queue(re){return this.a=this.a.then(()=>re(),()=>re())}}e.$Og=o;class r{constructor(){this.a=new Map}queue(re,Y){const x=(this.a.get(re)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(re)===x&&this.a.delete(re)});return this.a.set(re,x),x}}e.$Pg=r;const s=(J,re)=>{let Y=!0;const _=setTimeout(()=>{Y=!1,re()},J);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(_),Y=!1}}},m=J=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,J())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};class h{constructor(re){this.defaultDelay=re,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(re,Y=this.defaultDelay){this.g=re,this.h(),this.b||(this.b=new Promise((x,pe)=>{this.d=x,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const x=this.g;return this.g=null,x()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=Y===E.$Kd?m(_):s(Y,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=h;class t{constructor(re){this.a=new h(re),this.b=new u}trigger(re,Y){return this.a.trigger(()=>this.b.queue(re),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=t;class n{constructor(){this.a=!1,this.b=new Promise((re,Y)=>{this.d=re})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=n;class c extends n{constructor(re){super(),this.f=setTimeout(()=>this.open(),re)}open(){clearTimeout(this.f),super.open()}}e.$Tg=c;function i(J,re){return re?new Promise((Y,_)=>{const x=setTimeout(()=>{pe.dispose(),Y()},J),pe=re.onCancellationRequested(()=>{clearTimeout(x),pe.dispose(),_(new F.$5)})}):R(Y=>i(J,Y))}e.$Ug=i;function a(J,re=0,Y){const _=setTimeout(()=>{J(),Y&&x.dispose()},re),x=(0,L.$Qc)(()=>{clearTimeout(_),Y?.deleteAndLeak(x)});return Y?.add(x),x}e.$Vg=a;function l(J){const re=[];let Y=0;const _=J.length;function x(){return Y<_?J[Y++]():null}function pe(ue){ue!=null&&re.push(ue);const fe=x();return fe?fe.then(pe):Promise.resolve(re)}return Promise.resolve(null).then(pe)}e.$Wg=l;function D(J,re=_=>!!_,Y=null){let _=0;const x=J.length,pe=()=>{if(_>=x)return Promise.resolve(Y);const ue=J[_++];return Promise.resolve(ue()).then(te=>re(te)?Promise.resolve(te):pe())};return pe()}e.$Xg=D;function S(J,re=_=>!!_,Y=null){if(J.length===0)return Promise.resolve(Y);let _=J.length;const x=()=>{_=-1;for(const pe of J)pe.cancel?.()};return new Promise((pe,ue)=>{for(const fe of J)fe.then(te=>{--_>=0&&re(te)?(x(),pe(te)):_===0&&pe(Y)}).catch(te=>{--_>=0&&(x(),ue(te))})})}e.$Yg=S;class b{constructor(re){this.a=0,this.d=re,this.f=[],this.b=0,this.g=new d.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(re){return this.a++,new Promise((Y,_)=>{this.f.push({factory:re,c:Y,e:_}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const re=this.f.shift();this.b++;const Y=re.factory();Y.then(re.c,re.e),Y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=b;class f extends b{constructor(){super(1)}}e.$1g=f;class g{constructor(){this.a=new ge,this.b=0}queue(re){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,re())):this.a.run(this.b++,re())}}e.$2g=g;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const re=new X;return this.b.add(re),re.p}g(){for(const[,re]of this.a)if(re.size>0)return!1;return!0}queueFor(re,Y=A.$lg){const _=Y.getComparisonKey(re);let x=this.a.get(_);if(!x){x=new f;const pe=this.f++,ue=d.Event.once(x.onDrained)(()=>{x?.dispose(),this.a.delete(_),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$1c),this.d.set(pe,ue),this.a.set(_,x)}return x}h(){this.g()&&this.j()}j(){for(const re of this.b)re.complete();this.b.clear()}dispose(){for(const[,re]of this.a)re.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=P;class N{constructor(re,Y){this.a=-1,typeof re=="function"&&typeof Y=="number"&&this.setIfNotSet(re,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(re,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,re()},Y)}setIfNotSet(re,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,re()},Y))}}e.$4g=N;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(re,Y){this.cancel(),this.a=setInterval(()=>{re()},Y)}}e.$5g=O;class M{constructor(re,Y){this.b=-1,this.a=re,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(re=this.d){this.cancel(),this.b=setTimeout(this.f,re)}get delay(){return this.d}set delay(re){this.d=re}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=M;class j{constructor(re,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=re,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(re=this.b){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(re/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=j;class U extends M{constructor(re,Y){super(re,Y),this.j=[]}work(re){this.j.push(re),this.isScheduled()||this.schedule()}h(){const re=this.j;this.j=[],this.a?.(re)}dispose(){this.j=[],super.dispose()}}e.$8g=U;class T extends L.$Sc{constructor(re,Y){super(),this.g=re,this.h=Y,this.a=[],this.b=this.B(new L.$Tc),this.f=!1}get pending(){return this.a.length}work(re){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+re.length>this.g.maxBufferedWork)return!1}else if(this.pending+re.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of re)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=T,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=J=>{(0,$.$B)(()=>{if(re)return;const Y=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$0g=(J,re)=>{const Y=requestIdleCallback(J,typeof re=="number"?{timeout:re}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(Y))}}}}();class K{constructor(re){this.d=!1,this.a=()=>{try{this.f=re()}catch(Y){this.g=Y}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=K;async function q(J,re,Y){let _;for(let x=0;x<Y;x++)try{return await J()}catch(pe){_=pe,await i(re)}throw _}e.$_g=q;class ge{isRunning(re){return typeof re=="number"?this.a?.taskId===re:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(re,Y,_){return this.a={taskId:re,cancel:()=>_?.(),promise:Y},Y.then(()=>this.d(re),()=>this.d(re)),Y}d(re){this.a&&re===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const re=this.b;this.b=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}queue(re){if(this.b)this.b.run=re;else{let Y,_;const x=new Promise((pe,ue)=>{Y=pe,_=ue});this.b={run:re,promise:x,promiseResolve:Y,promiseReject:_}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=ge;class ee{constructor(re,Y=()=>Date.now()){this.d=re,this.f=Y,this.a=0,this.b=0}increment(){const re=this.f();return re-this.a>this.d&&(this.a=re,this.b=0),this.b++,this.b}}e.$bh=ee;var Q;(function(J){J[J.Resolved=0]="Resolved",J[J.Rejected=1]="Rejected"})(Q||(Q={}));class X{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((re,Y)=>{this.a=re,this.b=Y})}complete(re){return new Promise(Y=>{this.a(re),this.d={outcome:0,value:re},Y()})}error(re){return new Promise(Y=>{this.b(re),this.d={outcome:1,value:re},Y()})}cancel(){return this.error(new F.$5)}}e.$ch=X;var ae;(function(J){async function re(_){let x;const pe=await Promise.all(_.map(ue=>ue.then(fe=>fe,fe=>{x||(x=fe)})));if(typeof x<"u")throw x;return pe}J.settled=re;function Y(_){return new Promise(async(x,pe)=>{try{await _(x,pe)}catch(ue){pe(ue)}})}J.withAsyncBody=Y})(ae||(e.Promises=ae={}));var ie;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(ie||(ie={}));class ce{static fromArray(re){return new ce(Y=>{Y.emitMany(re)})}static fromPromise(re){return new ce(async Y=>{Y.emitMany(await re)})}static fromPromises(re){return new ce(async Y=>{await Promise.all(re.map(async _=>Y.emitOne(await _)))})}static merge(re){return new ce(async Y=>{await Promise.all(re.map(async _=>{for await(const x of _)Y.emitOne(x)}))})}static{this.EMPTY=ce.fromArray([])}constructor(re){this.a=0,this.b=[],this.d=null,this.f=new d.$Nd,queueMicrotask(async()=>{const Y={emitOne:_=>this.g(_),emitMany:_=>this.h(_),reject:_=>this.k(_)};try{await Promise.resolve(re(Y)),this.j()}catch(_){this.k(_)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(re<this.b.length)return{done:!1,value:this.b[re++]};if(this.a===1)return{done:!0,value:void 0};await d.Event.toPromise(this.f.event)}while(!0)}}}static map(re,Y){return new ce(async _=>{for await(const x of re)_.emitOne(Y(x))})}map(re){return ce.map(this,re)}static filter(re,Y){return new ce(async _=>{for await(const x of re)Y(x)&&_.emitOne(x)})}filter(re){return ce.filter(this,re)}static coalesce(re){return ce.filter(re,Y=>!!Y)}coalesce(){return ce.coalesce(this)}static async toPromise(re){const Y=[];for await(const _ of re)Y.push(_);return Y}toPromise(){return ce.toPromise(this)}g(re){this.a===0&&(this.b.push(re),this.f.fire())}h(re){this.a===0&&(this.b=this.b.concat(re),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(re){this.a===0&&(this.a=2,this.d=re,this.f.fire())}}e.$dh=ce;class we extends ce{constructor(re,Y){super(Y),this.l=re}cancel(){this.l.cancel()}}e.$eh=we;function H(J){const re=new C.$Xd,Y=J(re.token);return new we(re,async _=>{const x=re.token.onCancellationRequested(()=>{x.dispose(),re.dispose(),_.reject(new F.$5)});try{for await(const pe of Y){if(re.token.isCancellationRequested)return;_.emitOne(pe)}x.dispose(),re.dispose()}catch(pe){x.dispose(),re.dispose(),_.reject(pe)}})}e.$fh=H;class B{constructor(){this.a=new X,this.b=new ce(_=>{if(re){_.reject(re);return}return Y&&_.emitMany(Y),this.d=x=>_.reject(x),this.f=x=>_.emitOne(x),this.a.p});let re,Y;this.f=_=>{Y||(Y=[]),Y.push(_)},this.d=_=>{re||(re=_)}}get asyncIterable(){return this.b}complete(){this.a.complete()}error(re){this.d(re),this.a.complete()}emit(re){this.f(re)}}e.$gh=B}),define(De[35],Ce([1,0,19,8,33,28,16,12,15]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function v(){return Object.create(null)}e.$rj=v,e.$sj="**",e.$tj="/";const R="[/\\\\]",I="[^/\\\\]",w=/\//g;function y(ge,ee){switch(ge){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${ee?`|${R}${I}+`:""})*?`}}function k(ge,ee){if(!ge)return[];const Q=[];let X=!1,ae=!1,ie="";for(const ce of ge){switch(ce){case ee:if(!X&&!ae){Q.push(ie),ie="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}ie+=ce}return ie&&Q.push(ie),Q}e.$uj=k;function p(ge){if(!ge)return"";let ee="";const Q=k(ge,e.$tj);if(Q.every(X=>X===e.$sj))ee=".*";else{let X=!1;Q.forEach((ae,ie)=>{if(ae===e.$sj){if(X)return;ee+=y(2,ie===Q.length-1)}else{let ce=!1,we="",H=!1,B="";for(const J of ae){if(J!=="}"&&ce){we+=J;continue}if(H&&(J!=="]"||!B)){let re;J==="-"?re=J:(J==="^"||J==="!")&&!B?re="^":J===e.$tj?re="":re=(0,E.$Fe)(J),B+=re;continue}switch(J){case"{":ce=!0;continue;case"[":H=!0;continue;case"}":{const Y=`(?:${k(we,",").map(_=>p(_)).join("|")})`;ee+=Y,ce=!1,we="";break}case"]":{ee+="["+B+"]",H=!1,B="";break}case"?":ee+=I;continue;case"*":ee+=y(1);continue;default:ee+=(0,E.$Fe)(J)}}ie<Q.length-1&&(Q[ie+1]!==e.$sj||ie+2<Q.length)&&(ee+=R)}X=ae===e.$sj})}return ee}const u=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Dc(1e4),n=function(){return!1},c=function(){return null};function i(ge,ee){if(!ge)return c;let Q;typeof ge!="string"?Q=ge.pattern:Q=ge,Q=Q.trim();const X=`${Q}_${!!ee.trimForExclusions}`;let ae=t.get(X);if(ae)return a(ae,ge);let ie;return u.test(Q)?ae=D(Q.substr(4),Q):(ie=o.exec(l(Q,ee)))?ae=S(ie[1],Q):(ee.trimForExclusions?s:r).test(Q)?ae=b(Q,ee):(ie=m.exec(l(Q,ee)))?ae=f(ie[1].substr(1),Q,!0):(ie=h.exec(l(Q,ee)))?ae=f(ie[1],Q,!1):ae=g(Q),t.set(X,ae),a(ae,ge)}function a(ge,ee){if(typeof ee=="string")return ge;const Q=function(X,ae){return(0,d.$Xf)(X,ee.base,!$.$l)?ge((0,E.$Je)(X.substr(ee.base.length),A.sep),ae):null};return Q.allBasenames=ge.allBasenames,Q.allPaths=ge.allPaths,Q.basenames=ge.basenames,Q.patterns=ge.patterns,Q}function l(ge,ee){return ee.trimForExclusions&&ge.endsWith("/**")?ge.substr(0,ge.length-2):ge}function D(ge,ee){return function(Q,X){return typeof Q=="string"&&Q.endsWith(ge)?ee:null}}function S(ge,ee){const Q=`/${ge}`,X=`\\${ge}`,ae=function(ce,we){return typeof ce!="string"?null:we?we===ge?ee:null:ce===ge||ce.endsWith(Q)||ce.endsWith(X)?ee:null},ie=[ge];return ae.basenames=ie,ae.patterns=[ee],ae.allBasenames=ie,ae}function b(ge,ee){const Q=K(ge.slice(1,-1).split(",").map(we=>i(we,ee)).filter(we=>we!==c),ge),X=Q.length;if(!X)return c;if(X===1)return Q[0];const ae=function(we,H){for(let B=0,J=Q.length;B<J;B++)if(Q[B](we,H))return ge;return null},ie=Q.find(we=>!!we.allBasenames);ie&&(ae.allBasenames=ie.allBasenames);const ce=Q.reduce((we,H)=>H.allPaths?we.concat(H.allPaths):we,[]);return ce.length&&(ae.allPaths=ce),ae}function f(ge,ee,Q){const X=A.sep===A.$gc.sep,ae=X?ge:ge.replace(w,A.sep),ie=A.sep+ae,ce=A.$gc.sep+ge;let we;return Q?we=function(H,B){return typeof H=="string"&&(H===ae||H.endsWith(ie)||!X&&(H===ge||H.endsWith(ce)))?ee:null}:we=function(H,B){return typeof H=="string"&&(H===ae||!X&&H===ge)?ee:null},we.allPaths=[(Q?"*/":"./")+ge],we}function g(ge){try{const ee=new RegExp(`^${p(ge)}$`);return function(Q){return ee.lastIndex=0,typeof Q=="string"&&ee.test(Q)?ge:null}}catch{return c}}function P(ge,ee,Q){return!ge||typeof ee!="string"?!1:N(ge)(ee,void 0,Q)}e.$vj=P;function N(ge,ee={}){if(!ge)return n;if(typeof ge=="string"||O(ge)){const Q=i(ge,ee);if(Q===c)return n;const X=function(ae,ie){return!!Q(ae,ie)};return Q.allBasenames&&(X.allBasenames=Q.allBasenames),Q.allPaths&&(X.allPaths=Q.allPaths),X}return U(ge,ee)}e.$wj=N;function O(ge){const ee=ge;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.$xj=O;function M(ge){return ge.allBasenames||[]}e.$yj=M;function j(ge){return ge.allPaths||[]}e.$zj=j;function U(ge,ee){const Q=K(Object.getOwnPropertyNames(ge).map(we=>T(we,ge[we],ee)).filter(we=>we!==c)),X=Q.length;if(!X)return c;if(!Q.some(we=>!!we.requiresSiblings)){if(X===1)return Q[0];const we=function(J,re){let Y;for(let _=0,x=Q.length;_<x;_++){const pe=Q[_](J,re);if(typeof pe=="string")return pe;(0,F.$Gg)(pe)&&(Y||(Y=[]),Y.push(pe))}return Y?(async()=>{for(const _ of Y){const x=await _;if(typeof x=="string")return x}return null})():null},H=Q.find(J=>!!J.allBasenames);H&&(we.allBasenames=H.allBasenames);const B=Q.reduce((J,re)=>re.allPaths?J.concat(re.allPaths):J,[]);return B.length&&(we.allPaths=B),we}const ae=function(we,H,B){let J,re;for(let Y=0,_=Q.length;Y<_;Y++){const x=Q[Y];x.requiresSiblings&&B&&(H||(H=(0,A.$nc)(we)),J||(J=H.substr(0,H.length-(0,A.$oc)(we).length)));const pe=x(we,H,J,B);if(typeof pe=="string")return pe;(0,F.$Gg)(pe)&&(re||(re=[]),re.push(pe))}return re?(async()=>{for(const Y of re){const _=await Y;if(typeof _=="string")return _}return null})():null},ie=Q.find(we=>!!we.allBasenames);ie&&(ae.allBasenames=ie.allBasenames);const ce=Q.reduce((we,H)=>H.allPaths?we.concat(H.allPaths):we,[]);return ce.length&&(ae.allPaths=ce),ae}function T(ge,ee,Q){if(ee===!1)return c;const X=i(ge,Q);if(X===c)return c;if(typeof ee=="boolean")return X;if(ee){const ae=ee.when;if(typeof ae=="string"){const ie=(ce,we,H,B)=>{if(!B||!X(ce,we))return null;const J=ae.replace("$(basename)",()=>H),re=B(J);return(0,F.$Gg)(re)?re.then(Y=>Y?ge:null):re?ge:null};return ie.requiresSiblings=!0,ie}}return X}function K(ge,ee){const Q=ge.filter(we=>!!we.basenames);if(Q.length<2)return ge;const X=Q.reduce((we,H)=>{const B=H.basenames;return B?we.concat(B):we},[]);let ae;if(ee){ae=[];for(let we=0,H=X.length;we<H;we++)ae.push(ee)}else ae=Q.reduce((we,H)=>{const B=H.patterns;return B?we.concat(B):we},[]);const ie=function(we,H){if(typeof we!="string")return null;if(!H){let J;for(J=we.length;J>0;J--){const re=we.charCodeAt(J-1);if(re===47||re===92)break}H=we.substr(J)}const B=X.indexOf(H);return B!==-1?ae[B]:null};ie.basenames=X,ie.patterns=ae,ie.allBasenames=X;const ce=ge.filter(we=>!we.basenames);return ce.push(ie),ce}function q(ge,ee){return(0,C.$ub)(ge,ee,(Q,X)=>typeof Q=="string"&&typeof X=="string"?Q===X:typeof Q!="string"&&typeof X!="string"?Q.base===X.base&&Q.pattern===X.pattern:!1)}e.$Aj=q}),define(De[80],Ce([1,0,9,161,23,15,2]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class E{constructor(o="",r=!1){if(this.value=o,typeof this.value!="string")throw(0,C.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(o,r=0){return this.value+=w(this.supportThemeIcons?(0,F.$Wj)(o):o).replace(/([ \t]+)/g,(s,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,r){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(o,r,s){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(o),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(o,r){const s=new RegExp((0,L.$Fe)(r),"g");return o.replace(s,(m,h)=>o.charAt(h-1)!=="\\"?`\\${m}`:m)}}e.$3j=E;function v(u){return R(u)?!u.value:Array.isArray(u)?u.every(v):!0}e.$4j=v;function R(u){return u instanceof E?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.$5j=R;function I(u,o){return u===o?!0:!u||!o?!1:u.value===o.value&&u.isTrusted===o.isTrusted&&u.supportThemeIcons===o.supportThemeIcons&&u.supportHtml===o.supportHtml&&(u.baseUri===o.baseUri||!!u.baseUri&&!!o.baseUri&&(0,d.$og)(A.URI.from(u.baseUri),A.URI.from(o.baseUri)))}e.$6j=I;function w(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$7j=w;function y(u){return u.replace(/"/g,"&quot;")}e.$8j=y;function k(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$9j=k;function p(u){const o=[],r=u.split("|").map(m=>m.trim());u=r[0];const s=r[1];if(s){const m=/height=(\d+)/.exec(s),h=/width=(\d+)/.exec(s),t=m?m[1]:"",n=h?h[1]:"",c=isFinite(parseInt(n)),i=isFinite(parseInt(t));c&&o.push(`width="${n}"`),i&&o.push(`height="${t}"`)}return{href:u,dimensions:o}}e.$0j=p}),define(De[99],Ce([1,0,19,33,16,12,23,15]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=void 0;function E(i,a){const{os:l,tildify:D,relative:S}=a;if(S){const g=v(i,S,l);if(typeof g=="string")return g}let b=i.fsPath;if(l===1&&!L.$j?b=b.replace(/\//g,"\\"):l!==1&&L.$j&&(b=b.replace(/\\/g,"/")),l!==1&&D?.userHome){const g=D.userHome.fsPath;let P;i.scheme!==D.userHome.scheme&&i.path.startsWith(d.$gc.sep)?P=D.userHome.with({path:i.path}).fsPath:P=i.fsPath,b=w(P,g,l)}return(l===1?d.$fc:d.$gc).normalize(R(b,l===1))}e.$rv=E;function v(i,a,l){const D=l===1?d.$fc:d.$gc,S=l===3?A.$lg:A.$ng,b=a.getWorkspace(),f=(0,C.$Ob)(b.folders);if(!f)return;i.scheme!==f.uri.scheme&&i.path.startsWith(d.$gc.sep)&&(i=f.uri.with({path:i.path}));const g=a.getWorkspaceFolder(i);if(!g)return;let P;if(S.isEqual(g.uri,i)?P="":P=S.relativePath(g.uri,i)??"",P&&(P=D.normalize(P)),b.folders.length>1&&!a.noPrefix){const N=g.name?g.name:S.basenameOrAuthority(g.uri);P=P?`${N} \u2022 ${P}`:N}return P}function R(i,a=L.$j){return(0,F.$2f)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$sv=R;let I=Object.create(null);function w(i,a,l=L.OS){if(l===1||!i||!a)return i;let D=I.original===a?I.normalized:void 0;D||(D=a,L.$j&&(D=(0,F.$Rf)(D)),D=`${(0,$.$Ke)(D,d.$gc.sep)}${d.$gc.sep}`,I={original:a,normalized:D});let S=i;return L.$j&&(S=(0,F.$Rf)(S)),(l===3?S.startsWith(D):(0,$.$3e)(S,D))?`~/${S.substr(D.length)}`:i}e.$tv=w;function y(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.$uv=y;const k="\u2026",p="\\\\",u="~";function o(i,a=d.sep){const l=new Array(i.length);let D=!1;for(let S=0;S<i.length;S++){const b=i[S];if(b===""){l[S]=`.${a}`;continue}if(!b){l[S]=b;continue}D=!0;let f="",g=b;g.indexOf(p)===0?(f=g.substr(0,g.indexOf(p)+p.length),g=g.substr(g.indexOf(p)+p.length)):g.indexOf(a)===0?(f=g.substr(0,g.indexOf(a)+a.length),g=g.substr(g.indexOf(a)+a.length)):g.indexOf(u)===0&&(f=g.substr(0,g.indexOf(u)+u.length),g=g.substr(g.indexOf(u)+u.length));const P=g.split(a);for(let N=1;D&&N<=P.length;N++)for(let O=P.length-N;D&&O>=0;O--){D=!1;let M=P.slice(O,O+N).join(a);for(let j=0;!D&&j<i.length;j++)if(j!==S&&i[j]&&i[j].indexOf(M)>-1){const U=O+N===P.length,T=O>0&&i[j].indexOf(a)>-1?a+M:M,K=i[j].endsWith(T);D=!U||K}if(!D){let j="";(P[0].endsWith(":")||f!=="")&&(O===1&&(O=0,N++,M=P[0]+a+M),O>0&&(j=P[0]+a),j=f+j),O>0&&(j=j+k+a),j=j+M,O+N<P.length&&(j=j+a+k),l[S]=j}}D&&(l[S]=b)}return l}e.$vv=o;var r;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function s(i,a=Object.create(null)){const l=[];let D=!1,S="";for(const b of i)if(b==="$"||D&&b==="{")S&&l.push({value:S,type:r.TEXT}),S="",D=!0;else if(b==="}"&&D){const f=a[S];if(typeof f=="string")f.length&&l.push({value:f,type:r.VARIABLE});else if(f){const g=l[l.length-1];(!g||g.type!==r.SEPARATOR)&&l.push({value:f.label,type:r.SEPARATOR})}S="",D=!1}else S+=b;return S&&!D&&l.push({value:S,type:r.TEXT}),l.filter((b,f)=>{if(b.type===r.SEPARATOR){const g=l[f-1],P=l[f+1];return[g,P].every(N=>N&&(N.type===r.VARIABLE||N.type===r.TEXT)&&N.value.length>0)}return!0}).map(b=>b.value).join("")}e.$wv=s;function m(i,a){return L.$k||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$k?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$xv=m;function h(i,a){return L.$k||a?i.replace(/\(&&\w\)|&&/g,""):L.$j?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$yv=h;function t(i){return i.replace(/&/g,"&&")}e.$zv=t;function n(i){if(i.endsWith("]")){const a=i.lastIndexOf(" [",i.length-2);if(a!==-1){const l=c(i.substring(0,a));return{name:l.name,parentPath:l.parentPath+i.substring(a)}}}return c(i)}e.$Av=n;function c(i){const a=i.indexOf("/")!==-1?d.$gc:d.$fc,l=a.basename(i),D=a.dirname(i);return l.length?{name:l,parentPath:D}:{name:D,parentPath:""}}}),define(De[128],Ce([1,0,22,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function d(I){return I.toJSON()}class L{constructor(w){this.a=w}transformIncoming(w){const y=this.a.transformIncoming(w);return y===w?w:d(F.URI.from(y))}transformOutgoing(w){const y=this.a.transformOutgoing(w);return y===w?w:d(F.URI.from(y))}transformOutgoingURI(w){const y=this.a.transformOutgoing(w);return y===w?w:F.URI.from(y)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Lm=L,e.$Mm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,w,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return w.transformOutgoing(I);for(const k in I)if(Object.hasOwnProperty.call(I,k)){const p=A(I[k],w,y+1);p!==null&&(I[k]=p)}}return null}function $(I,w){const y=A(I,w,0);return y===null?I:y}e.$Nm=$;function E(I,w,y,k){if(!I||k>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?F.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);if(I instanceof C.$be)return null;for(const p in I)if(Object.hasOwnProperty.call(I,p)){const u=E(I[p],w,y,k+1);u!==null&&(I[p]=u)}}return null}function v(I,w){const y=E(I,w,!1,0);return y===null?I:y}e.$Om=v;function R(I,w){const y=E(I,w,!0,0);return y===null?I:y}e.$Pm=R}),define(De[29],Ce([1,0,53,63,373,8,33,77,16,12,23,2]),function($e,e,C,F,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function y(T,K=w.UNLINK,q){if((0,A.$1f)(T))throw new Error("rimraf - will refuse to recursively delete root");return K===w.UNLINK?p(T):k(T,q)}async function k(T,K=(0,A.$6f)((0,F.tmpdir)())){try{try{await C.promises.rename(T,K)}catch(q){return q.code==="ENOENT"?void 0:p(T)}p(K).catch(q=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function p(T){return(0,d.promisify)(C.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function u(T){if((0,A.$1f)(T))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function o(T,K){return m(await(K?r(T):(0,d.promisify)(C.readdir)(T)))}async function r(T){try{return await(0,d.promisify)(C.readdir)(T,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const K=[],q=await o(T);for(const ge of q){let ee=!1,Q=!1,X=!1;try{const ae=await e.Promises.lstat((0,E.$jc)(T,ge));ee=ae.isFile(),Q=ae.isDirectory(),X=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}K.push({name:ge,isFile:()=>ee,isDirectory:()=>Q,isSymbolicLink:()=>X})}return K}function s(T){return m(C.readdirSync(T))}e.readdirSync=s;function m(T){return T.map(K=>typeof K=="string"?v.$k?(0,$.$ol)(K):K:(K.name=v.$k?(0,$.$ol)(K.name):K.name,K))}async function h(T){const K=await o(T),q=[];for(const ge of K)await n.existsDirectory((0,E.$jc)(T,ge))&&q.push(ge);return q}function t(T,K=1e3){return new Promise(q=>{let ge=!1;const ee=setInterval(()=>{ge||(ge=!0,C.access(T,Q=>{ge=!1,Q&&(clearInterval(ee),q(void 0))}))},K)})}e.whenDeleted=t;var n;(function(T){async function K(ee){let Q;try{if(Q=await e.Promises.lstat(ee),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(v.$j&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ae}throw X}}T.stat=K;async function q(ee){try{const{stat:Q,symbolicLink:X}=await T.stat(ee);return Q.isFile()&&X?.dangling!==!0}catch{}return!1}T.existsFile=q;async function ge(ee){try{const{stat:Q,symbolicLink:X}=await T.stat(ee);return Q.isDirectory()&&X?.dangling!==!0}catch{}return!1}T.existsDirectory=ge})(n||(e.SymlinkSupport=n={}));const c=new L.$3g;function i(T,K,q){return c.queueFor(I.URI.file(T),R.$mg).queue(()=>{const ge=b(q);return new Promise((ee,Q)=>D(T,K,ge,X=>X?Q(X):ee()))})}let a=!0;function l(T){a=T}e.configureFlushOnWrite=l;function D(T,K,q,ge){if(!a)return C.writeFile(T,K,{mode:q.mode,flag:q.flag},ge);C.open(T,q.flag,q.mode,(ee,Q)=>{if(ee)return ge(ee);C.writeFile(Q,K,X=>{if(X)return C.close(Q,()=>ge(X));C.fdatasync(Q,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),l(!1)),C.close(Q,ie=>ge(ie))))})})}function S(T,K,q){const ge=b(q);if(!a)return C.writeFileSync(T,K,{mode:ge.mode,flag:ge.flag});const ee=C.openSync(T,ge.flag,ge.mode);try{C.writeFileSync(ee,K);try{C.fdatasyncSync(ee)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),l(!1)}}finally{C.closeSync(ee)}}e.writeFileSync=S;function b(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function f(T,K,q=6e4){if(T!==K)try{v.$j&&typeof q=="number"?await g(T,K,Date.now(),q):await(0,d.promisify)(C.rename)(T,K)}catch(ge){if(T.toLowerCase()!==K.toLowerCase()&&ge.code==="EXDEV"||T.endsWith("."))await P(T,K,{preserveSymlinks:!1}),await y(T,w.MOVE);else throw ge}}async function g(T,K,q,ge,ee=0){try{return await(0,d.promisify)(C.rename)(T,K)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-q>=ge)throw console.error(`[node.js fs] rename failed after ${ee} retries with error: ${Q}`),Q;if(ee===0){let X=!1;try{const{stat:ae}=await n.stat(K);ae.isFile()||(X=!0)}catch{}if(X)throw Q}return await(0,L.$Ug)(Math.min(100,ee*10)),g(T,K,q,ge,ee+1)}}async function P(T,K,q){return O(T,K,{root:{source:T,target:K},options:q,handledSourcePaths:new Set})}const N=511;async function O(T,K,q){if(q.handledSourcePaths.has(T))return;q.handledSourcePaths.add(T);const{stat:ge,symbolicLink:ee}=await n.stat(T);if(ee){if(q.options.preserveSymlinks)try{return await U(T,K,q)}catch(Q){console.warn("[node.js fs] copy of symlink failed: ",Q)}if(ee.dangling)return}return ge.isDirectory()?M(T,K,ge.mode&N,q):j(T,K,ge.mode&N)}async function M(T,K,q,ge){await e.Promises.mkdir(K,{recursive:!0,mode:q});const ee=await o(T);for(const Q of ee)await O((0,E.$jc)(T,Q),(0,E.$jc)(K,Q),ge)}async function j(T,K,q){await e.Promises.copyFile(T,K),await e.Promises.chmod(K,q)}async function U(T,K,q){let ge=await e.Promises.readlink(T);(0,A.$Xf)(ge,q.root.source,!v.$l)&&(ge=(0,E.$jc)(q.root.target,ge.substr(q.root.source.length+1))),await e.Promises.symlink(ge,K)}e.Promises=new class{get access(){return(0,d.promisify)(C.access)}get stat(){return(0,d.promisify)(C.stat)}get lstat(){return(0,d.promisify)(C.lstat)}get utimes(){return(0,d.promisify)(C.utimes)}get read(){return(T,K,q,ge,ee)=>new Promise((Q,X)=>{C.read(T,K,q,ge,ee,(ae,ie,ce)=>ae?X(ae):Q({bytesRead:ie,buffer:ce}))})}get readFile(){return(0,d.promisify)(C.readFile)}get write(){return(T,K,q,ge,ee)=>new Promise((Q,X)=>{C.write(T,K,q,ge,ee,(ae,ie,ce)=>ae?X(ae):Q({bytesWritten:ie,buffer:ce}))})}get appendFile(){return(0,d.promisify)(C.appendFile)}get fdatasync(){return(0,d.promisify)(C.fdatasync)}get truncate(){return(0,d.promisify)(C.truncate)}get copyFile(){return(0,d.promisify)(C.copyFile)}get open(){return(0,d.promisify)(C.open)}get close(){return(0,d.promisify)(C.close)}get symlink(){return(0,d.promisify)(C.symlink)}get readlink(){return(0,d.promisify)(C.readlink)}get chmod(){return(0,d.promisify)(C.chmod)}get mkdir(){return(0,d.promisify)(C.mkdir)}get unlink(){return(0,d.promisify)(C.unlink)}get rmdir(){return(0,d.promisify)(C.rmdir)}get realpath(){return(0,d.promisify)(C.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return y}get rename(){return f}get copy(){return P}}}),define(De[100],Ce([1,0,53,16,12,15,29]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=void 0;function $(w){if(d.$l)return w;const y=(0,F.$mc)(w);if(w===y)return w;const k=((0,F.$nc)(w)||w).toLowerCase();try{const u=(0,A.readdirSync)(y).filter(o=>o.toLowerCase()===k);if(u.length===1){const o=$(y);if(o)return(0,F.$jc)(o,u[0])}else if(u.length>1){const o=u.indexOf(k);if(o>=0){const r=$(y);if(r)return(0,F.$jc)(r,u[o])}}}catch{}return null}e.$6p=$;async function E(w){if(d.$l)return w;const y=(0,F.$mc)(w);if(w===y)return w;const k=((0,F.$nc)(w)||w).toLowerCase();try{const u=(await A.Promises.readdir(y)).filter(o=>o.toLowerCase()===k);if(u.length===1){const o=await E(y);if(o)return(0,F.$jc)(o,u[0])}else if(u.length>1){const o=u.indexOf(k);if(o>=0){const r=await E(y);if(r)return(0,F.$jc)(r,u[o])}}}catch{}return null}e.$7p=E;async function v(w){try{return await A.Promises.realpath(w)}catch{const k=I(w);return await A.Promises.access(k,C.constants.R_OK),k}}e.$8p=v;function R(w){try{return C.realpathSync(w)}catch{const k=I(w);return C.accessSync(k,C.constants.R_OK),k}}e.$9p=R;function I(w){return(0,L.$Ke)((0,F.$hc)(w),F.sep)}}),define(De[101],Ce([1,0,16,12,48,98,17,29]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(I=d.env){return I.comspec||"cmd.exe"}e.$Bl=E;function v(I){let w=[],y=!1;const k=function(p){if(y){w.push(p);return}(!I.send(p,o=>{if(o&&console.error(o),y=!1,w.length>0){const r=w.slice(0);w=[],r.forEach(s=>k(s))}})||F.$j)&&(y=!0)};return{send:k}}e.$Cl=v;var R;(function(I){async function w(y,k,p){if(C.$ic(y))return y;if(k===void 0&&(k=d.cwd()),C.$mc(y)!=="."||(p===void 0&&A.$yf(d.env.PATH)&&(p=d.env.PATH.split(C.$tc)),p===void 0||p.length===0))return C.$jc(k,y);async function o(r){if(await $.Promises.exists(r)){let s;try{s=await $.Promises.stat(r)}catch(m){m.message.startsWith("EACCES")&&(s=await $.Promises.lstat(r))}return s?!s.isDirectory():!1}return!1}for(const r of p){let s;if(C.$ic(r)?s=C.$jc(r,y):s=C.$jc(k,r,y),await o(s))return s;let m=s+".com";if(await o(m)||(m=s+".exe",await o(m)))return m}return C.$jc(k,y)}I.findExecutable=w})(R||(e.win32=R={}))});var He=this&&this.__decorate||function($e,e,C,F){var d=arguments.length,L=d<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,C):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($e,e,C,F);else for(var $=$e.length-1;$>=0;$--)(A=$e[$])&&(L=(d<3?A(L):d>3?A(e,C,L):A(e,C))||L);return d>3&&L&&Object.defineProperty(e,C,L),L};define(De[81],Ce([1,0,19,8,22,21,57,9,4,3,62,15,17]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var y;(function(ee){ee[ee.Promise=100]="Promise",ee[ee.PromiseCancel=101]="PromiseCancel",ee[ee.EventListen=102]="EventListen",ee[ee.EventDispose=103]="EventDispose"})(y||(y={}));function k(ee){switch(ee){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(ee){ee[ee.Initialize=200]="Initialize",ee[ee.PromiseSuccess=201]="PromiseSuccess",ee[ee.PromiseError=202]="PromiseError",ee[ee.PromiseErrorObj=203]="PromiseErrorObj",ee[ee.EventFire=204]="EventFire"})(p||(p={}));function u(ee){switch(ee){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(ee){ee[ee.Uninitialized=0]="Uninitialized",ee[ee.Idle=1]="Idle"})(o||(o={}));function r(ee){let Q=0;for(let X=0;;X+=7){const ae=ee.read(1);if(Q|=(ae.buffer[0]&127)<<X,!(ae.buffer[0]&128))return Q}}const s=c(0);function m(ee,Q){if(Q===0){ee.write(s);return}let X=0;for(let ie=Q;ie!==0;ie=ie>>>7)X++;const ae=d.$be.alloc(X);for(let ie=0;Q!==0;ie++)ae.buffer[ie]=Q&127,Q=Q>>>7,Q>0&&(ae.buffer[ie]|=128);ee.write(ae)}class h{constructor(Q){this.b=Q,this.a=0}read(Q){const X=this.b.slice(this.a,this.a+Q);return this.a+=X.byteLength,X}}e.$nh=h;class t{constructor(){this.a=[]}get buffer(){return d.$be.concat(this.a)}write(Q){this.a.push(Q)}}e.$oh=t;var n;(function(ee){ee[ee.Undefined=0]="Undefined",ee[ee.String=1]="String",ee[ee.Buffer=2]="Buffer",ee[ee.VSBuffer=3]="VSBuffer",ee[ee.Array=4]="Array",ee[ee.Object=5]="Object",ee[ee.Int=6]="Int"})(n||(n={}));function c(ee){const Q=d.$be.alloc(1);return Q.writeUInt8(ee,0),Q}const i={Undefined:c(n.Undefined),String:c(n.String),Buffer:c(n.Buffer),VSBuffer:c(n.VSBuffer),Array:c(n.Array),Object:c(n.Object),Uint:c(n.Int)},a=typeof Buffer<"u";function l(ee,Q){if(typeof Q>"u")ee.write(i.Undefined);else if(typeof Q=="string"){const X=d.$be.fromString(Q);ee.write(i.String),m(ee,X.byteLength),ee.write(X)}else if(a&&Buffer.isBuffer(Q)){const X=d.$be.wrap(Q);ee.write(i.Buffer),m(ee,X.byteLength),ee.write(X)}else if(Q instanceof d.$be)ee.write(i.VSBuffer),m(ee,Q.byteLength),ee.write(Q);else if(Array.isArray(Q)){ee.write(i.Array),m(ee,Q.length);for(const X of Q)l(ee,X)}else if(typeof Q=="number"&&(Q|0)===Q)ee.write(i.Uint),m(ee,Q);else{const X=d.$be.fromString(JSON.stringify(Q));ee.write(i.Object),m(ee,X.byteLength),ee.write(X)}}e.$ph=l;function D(ee){switch(ee.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return ee.read(r(ee)).toString();case n.Buffer:return ee.read(r(ee)).buffer;case n.VSBuffer:return ee.read(r(ee));case n.Array:{const X=r(ee),ae=[];for(let ie=0;ie<X;ie++)ae.push(D(ee));return ae}case n.Object:return JSON.parse(ee.read(r(ee)).toString());case n.Int:return r(ee)}}e.$qh=D;class S{constructor(Q,X,ae=null,ie=1e3){this.h=Q,this.j=X,this.k=ae,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(Q,X){this.b.set(Q,X),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const X=this.o([Q.type]);this.k?.logOutgoing(X,0,1,u(Q.type));return}case 201:case 202:case 204:case 203:{const X=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(X,Q.id,1,u(Q.type),Q.data);return}}}o(Q,X=void 0){const ae=new t;return l(ae,Q),l(ae,X),this.p(ae.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const X=new h(Q),ae=D(X),ie=D(X),ce=ae[0];switch(ce){case 100:return this.k?.logIncoming(Q.byteLength,ae[1],1,`${k(ce)}: ${ae[2]}.${ae[3]}`,ie),this.s({type:ce,id:ae[1],channelName:ae[2],name:ae[3],arg:ie});case 102:return this.k?.logIncoming(Q.byteLength,ae[1],1,`${k(ce)}: ${ae[2]}.${ae[3]}`,ie),this.t({type:ce,id:ae[1],channelName:ae[2],name:ae[3],arg:ie});case 101:return this.k?.logIncoming(Q.byteLength,ae[1],1,`${k(ce)}`),this.u({type:ce,id:ae[1]});case 103:return this.k?.logIncoming(Q.byteLength,ae[1],1,`${k(ce)}`),this.u({type:ce,id:ae[1]})}}s(Q){const X=this.b.get(Q.channelName);if(!X){this.v(Q);return}const ae=new L.$Xd;let ie;try{ie=X.call(this.j,Q.name,Q.arg,ae.token)}catch(H){ie=Promise.reject(H)}const ce=Q.id;ie.then(H=>{this.m({id:ce,data:H,type:201})},H=>{H instanceof Error?this.m({id:ce,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.m({id:ce,data:H,type:203})}).finally(()=>{we.dispose(),this.d.delete(Q.id)});const we=(0,v.$Qc)(()=>ae.cancel());this.d.set(Q.id,we)}t(Q){const X=this.b.get(Q.channelName);if(!X){this.v(Q);return}const ae=Q.id,ce=X.listen(this.j,Q.name,Q.arg)(we=>this.m({id:ae,data:we,type:204}));this.d.set(Q.id,ce)}u(Q){const X=this.d.get(Q.id);X&&(X.dispose(),this.d.delete(Q.id))}v(Q){let X=this.g.get(Q.channelName);X||(X=[],this.g.set(Q.channelName,X));const ae=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:Q,timeoutTimer:ae})}w(Q){const X=this.g.get(Q);if(X){for(const ae of X)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.$Nc)(this.d.values()),this.d.clear()}}e.$rh=S;var b;(function(ee){ee[ee.LocalSide=0]="LocalSide",ee[ee.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class f{constructor(Q,X=null){this.l=Q,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=X}getChannel(Q){const X=this;return{call(ae,ie,ce){return X.a?Promise.reject(new $.$5):X.m(Q,ae,ie,ce)},listen(ae,ie){return X.a?E.Event.None:X.o(Q,ae,ie)}}}m(Q,X,ae,ie=L.CancellationToken.None){const ce=this.g++,H={id:ce,type:100,channelName:Q,name:X,arg:ae};if(ie.isCancellationRequested)return Promise.reject(new $.$5);let B;return new Promise((re,Y)=>{if(ie.isCancellationRequested)return Y(new $.$5);const _=()=>{const fe=te=>{switch(te.type){case 201:this.f.delete(ce),re(te.data);break;case 202:{this.f.delete(ce);const de=new Error(te.data.message);de.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,de.name=te.data.name,Y(de);break}case 203:this.f.delete(ce),Y(te.data);break}};this.f.set(ce,fe),this.p(H)};let x=null;this.b===o.Idle?_():(x=(0,F.$Hg)(fe=>this.u()),x.then(()=>{x=null,_()}));const pe=()=>{x?(x.cancel(),x=null):this.p({id:ce,type:101}),Y(new $.$5)},ue=ie.onCancellationRequested(pe);B=(0,v.$Pc)((0,v.$Qc)(pe),ue),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(Q,X,ae){const ie=this.g++,we={id:ie,type:102,channelName:Q,name:X,arg:ae};let H=null;const B=new E.$Nd({onWillAddFirstListener:()=>{H=(0,F.$Hg)(re=>this.u()),H.then(()=>{H=null,this.d.add(B),this.p(we)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(B),this.p({id:ie,type:103}))}}),J=re=>B.fire(re.data);return this.f.set(ie,J),B.event}p(Q){switch(Q.type){case 100:case 102:{const X=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(X,Q.id,0,`${k(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const X=this.q([Q.type,Q.id]);this.j?.logOutgoing(X,Q.id,0,k(Q.type));return}}}q(Q,X=void 0){const ae=new t;return l(ae,Q),l(ae,X),this.r(ae.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const X=new h(Q),ae=D(X),ie=D(X),ce=ae[0];switch(ce){case 200:return this.j?.logIncoming(Q.byteLength,0,0,u(ce)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ae[1],0,u(ce),ie),this.t({type:ae[0],id:ae[1],data:ie})}}t(Q){if(Q.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.$Nc)(this.d.values()),this.d.clear()}}e.$sh=f,He([A.$hh],f.prototype,"onDidInitializePromise",null);class g{get connections(){const Q=[];return this.f.forEach(X=>Q.push(X)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new E.$Nd,this.onDidAddConnection=this.g.event,this.h=new E.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new v.$Rc,this.j.add(Q(({protocol:X,onDidClientDisconnect:ae})=>{const ie=E.Event.once(X.onMessage);this.j.add(ie(ce=>{const we=new h(ce),H=D(we),B=new S(X,H),J=new f(X);this.a.forEach((Y,_)=>B.registerChannel(_,Y));const re={channelServer:B,channelClient:J,ctx:H};this.f.add(re),this.g.fire(re),this.j.add(ae(()=>{B.dispose(),J.dispose(),this.f.delete(re),this.h.fire(re)}))}))}))}getChannel(Q,X){const ae=this;return{call(ie,ce,we){let H;if((0,w.$Mf)(X)){const J=(0,C.$4b)(ae.connections.filter(X));H=J?Promise.resolve(J):E.Event.toPromise(E.Event.filter(ae.onDidAddConnection,X))}else H=X.routeCall(ae,ie,ce);const B=H.then(J=>J.channelClient.getChannel(Q));return N(B).call(ie,ce,we)},listen(ie,ce){if((0,w.$Mf)(X))return ae.k(Q,X,ie,ce);const we=X.routeEvent(ae,ie,ce).then(H=>H.channelClient.getChannel(Q));return N(we).listen(ie,ce)}}}k(Q,X,ae,ie){const ce=this;let we;const H=new E.$Nd({onWillAddFirstListener:()=>{we=new v.$Rc;const B=new E.$Td,J=new Map,re=_=>{const pe=_.channelClient.getChannel(Q).listen(ae,ie),ue=B.add(pe);J.set(_,ue)},Y=_=>{const x=J.get(_);x&&(x.dispose(),J.delete(_))};ce.connections.filter(X).forEach(re),E.Event.filter(ce.onDidAddConnection,X)(re,void 0,we),ce.onDidRemoveConnection(Y,void 0,we),B.event(H.fire,H,we),we.add(B)},onDidRemoveLastListener:()=>{we?.dispose(),we=void 0}});return H.event}registerChannel(Q,X){this.a.set(Q,X);for(const ae of this.f)ae.channelServer.registerChannel(Q,X)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=g;class P{constructor(Q,X,ae=null){const ie=new t;l(ie,X),Q.send(ie.buffer),this.a=new f(Q,ae),this.d=new S(Q,X,ae)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,X){this.d.registerChannel(Q,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=P;function N(ee){return{call(Q,X,ae){return ee.then(ie=>ie.call(Q,X,ae))},listen(Q,X){const ae=new E.$Wd;return ee.then(ie=>ae.input=ie.listen(Q,X)),ae.event}}}e.$vh=N;function O(ee){let Q=!1;return{call(X,ae,ie){return Q?ee.call(X,ae,ie):(0,F.$Ug)(0).then(()=>Q=!0).then(()=>ee.call(X,ae,ie))},listen(X,ae){if(Q)return ee.listen(X,ae);const ie=new E.$Wd;return(0,F.$Ug)(0).then(()=>Q=!0).then(()=>ie.input=ee.listen(X,ae)),ie.event}}}e.$wh=O;class M{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const X of Q.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await E.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$xh=M;var j;(function(ee){function Q(ce,we,H){const B=ce,J=H&&H.disableMarshalling,re=new Map;for(const Y in B)ae(Y)&&re.set(Y,E.Event.buffer(B[Y],!0,void 0,we));return new class{listen(Y,_,x){const pe=re.get(_);if(pe)return pe;if(ie(_)){const ue=B[_];if(typeof ue=="function")return ue.call(B,x)}throw new $.$bb(`Event not found: ${_}`)}call(Y,_,x){const pe=B[_];if(typeof pe=="function"){if(!J&&Array.isArray(x))for(let fe=0;fe<x.length;fe++)x[fe]=(0,R.$mh)(x[fe]);let ue=pe.apply(B,x);return ue instanceof Promise||(ue=Promise.resolve(ue)),ue}throw new $.$bb(`Method not found: ${_}`)}}}ee.fromService=Q;function X(ce,we){const H=we&&we.disableMarshalling;return new Proxy({},{get(B,J){if(typeof J=="string")return we?.properties?.has(J)?we.properties.get(J):ie(J)?function(re){return ce.listen(J,re)}:ae(J)?ce.listen(J):async function(...re){let Y;we&&!(0,w.$Hf)(we.context)?Y=[we.context,...re]:Y=re;const _=await ce.call(J,Y);return H?_:(0,R.$mh)(_)};throw new $.$bb(`Property not found: ${String(J)}`)}})}ee.toService=X;function ae(ce){return ce[0]==="o"&&ce[1]==="n"&&I.$1e(ce.charCodeAt(2))}function ie(ce){return/^onDynamic/.test(ce)&&I.$1e(ce.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(ee){if(Array.isArray(ee))return ee;if(ee&&typeof ee=="object"&&typeof ee.toString=="function"){const Q=ee.toString();if(Q!=="[object Object]")return Q}return ee}function K(ee){return Array.isArray(ee)?ee.map(T):T(ee)}function q(ee,Q,X,ae,ie,ce,we){we=K(we);const H=U[ie],B=H[ae%H.length];let J=[`%c[${ee}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ce)?(J=J.concat(we),J.push(")")):J.push(we),console.log.apply(console,J)}class ge{constructor(Q,X){this.d=Q,this.f=X,this.a=0,this.b=0}logOutgoing(Q,X,ae,ie,ce){this.b+=Q,q(this.d,this.b,Q,X,ae,ie,ce)}logIncoming(Q,X,ae,ie,ce){this.a+=Q,q(this.f,this.a,Q,X,ae,ie,ce)}}e.$yh=ge}),define(De[82],Ce([1,0,22,4,3,81]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.ProtocolConstants=e.$zh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var $;(function(i){i.enableDiagnostics=!1,i.records=[];const a=new WeakMap;let l=0;function D(b,f){if(!a.has(b)){const g=String(++l);a.set(b,g)}return a.get(b)}function S(b,f,g,P){if(!i.enableDiagnostics)return;const N=D(b,f);if(P instanceof C.$be||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const O=C.$be.alloc(P.byteLength);O.set(P),i.records.push({timestamp:Date.now(),id:N,label:f,type:g,buff:O})}else i.records.push({timestamp:Date.now(),id:N,label:f,type:g,data:P})}i.traceSocketEvent=S})($||(e.SocketDiagnostics=$={}));var E;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let v=null;function R(){return v||(v=C.$be.alloc(0)),v}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return R();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const f=this.a[0];return l&&(this.a.shift(),this.b-=a),f}if(this.a[0].byteLength>a){const f=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),f}const D=C.$be.alloc(a);let S=0,b=0;for(;a>0;){const f=this.a[b];if(f.byteLength>a){const g=f.slice(0,a);D.set(g,S),S+=a,l&&(this.a[b]=f.slice(a),this.b-=a),a-=a}else D.set(f,S),S+=f.byteLength,l?(this.a.shift(),this.b-=f.byteLength):b++,a-=f.byteLength}return D}}e.$zh=I;var w;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(w||(w={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class p{constructor(a,l,D,S){this.type=a,this.id=l,this.ack=D,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends d.$Sc{constructor(a){super(),this.f=this.B(new F.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new I,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,S=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new p(D,S,b,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=C.$be.alloc(13);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(l,a.data)}g(a,l){const D=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,D}h(){const a=C.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class r extends d.$Sc{constructor(a){super(),this.f=new F.$Nd,this.onMessage=this.f.event,this.g=new F.$Nd,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new o(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new p(1,0,0,a))}}e.$Ah=r;class s extends L.$uh{static fromSocket(a,l){return new s(new r(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,D=null){super(a,l,D),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$Bh=s;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$Ch=m;class h{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,D=this.a;for(;D;)a[l++]=D.data,D=D.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new h(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<n.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=n.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+n.a)*1e3;let D=0;for(let S=0;S<n.a;S++)a-this.c[S]<=l&&D++;return 1-D/n.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??n.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new d.$Rc,this.o=a.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new p(5,0,0,R());this.p.write(a),this.p.flush()}sendPause(){const a=new p(7,0,0,R());this.p.write(a)}sendResume(){const a=new p(8,0,0,R());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.r.dispose(),this.r=new d.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(D=>this.z(D))),this.r.add(this.o.onClose(D=>this.x.fire(D))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new p(3,0,this.h,R());this.p.write(a);const l=this.b.toArray();for(let D=0,S=l.length;D<S;D++)this.p.write(l[D]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const l=this.b.peek();if(l&&l.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new p(6,0,0,R())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let D=0,S=l.length;D<S;D++)this.p.write(l[D]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const l=++this.c;this.h=this.g;const D=new p(1,l,this.h,a);this.b.push(D),this.a||(this.p.write(D),this.B())}sendControl(a){const l=new p(2,0,0,a);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),l=Date.now()-a.writtenTime,D=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(l>=2e4&&D>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:D});return}const b=Math.max(2e4-l,2e4-D,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new p(3,0,this.h,R());this.p.write(a)}D(){this.h=this.g;const a=new p(9,0,this.h,R());this.p.write(a)}}e.$Dh=c}),define(De[183],Ce([1,0,49,8,22,21,181,9,4,3,24,101,98,81]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;class k extends y.$rh{constructor(o){super({send:r=>{try{process.send?.(r.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",r=>d.$be.wrap(Buffer.from(r,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$3p=k;class p{constructor(o,r){this.i=o,this.j=r,this.c=new Set,this.g=new Map,this.h=new E.$Nd,this.onDidProcessExit=this.h.event;const s=r&&r.timeout?r.timeout:6e4;this.b=new F.$Qg(s),this.d=null,this.f=null}getChannel(o){const r=this;return{call(s,m,h){return r.k(o,s,m,h)},listen(s,m){return r.l(o,s,m)}}}k(o,r,s,m=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject($.$6());this.b.cancel();const h=this.n(o),t=(0,F.$Hg)(i=>h.call(r,s,i)),n=m.onCancellationRequested(()=>t.cancel()),c=(0,v.$Qc)(()=>t.cancel());return this.c.add(c),t.finally(()=>{n.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,r,s){if(!this.b)return E.Event.None;this.b.cancel();let m;const h=new E.$Nd({onWillAddFirstListener:()=>{m=this.n(o).listen(r,s)(h.fire,h),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],r=Object.create(null);r.env={...(0,R.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(r.env={...r.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(r.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(r.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(r.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),r.execArgv===void 0&&(r.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,w.$Al)(r.env),this.d=(0,C.fork)(this.i,o,r);const s=new E.$Nd;E.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,A.$Yp)(a)){(0,A.log)(a,`IPC Library: ${this.j.serverName}`);return}s.fire(d.$be.wrap(Buffer.from(a,"base64")))});const h=this.j.useQueue?(0,I.$Cl)(this.d):this.d,t=a=>this.d&&this.d.connected&&h.send(a.buffer.toString("base64")),n=s.event,c={send:t,onMessage:n};this.f=new y.$sh(c);const i=()=>this.o();process.once("exit",i),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,l)=>{process.removeListener("exit",i),this.c.forEach(D=>(0,v.$Nc)(D)),this.c.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:l})})}return this.f}n(o){let r=this.g.get(o);return r||(r=this.m.getChannel(o),this.g.set(o,r)),r}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$4p=p}),define(De[184],Ce([1,0,8,4,3,62,17]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.StorageState=e.$2o=e.StorageHint=void 0;var $;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})($||(e.StorageHint=$={}));function E(w){const y=w;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$2o=E;var v;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(v||(e.StorageState=v={}));class R extends d.$Sc{static{this.a=100}constructor(y,k=Object.create(null)){super(),this.r=y,this.s=k,this.b=this.B(new F.$Qd),this.onDidChangeStorage=this.b.event,this.c=v.None,this.f=new Map,this.g=this.B(new C.$Rg(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((k,p)=>this.w(p,k)),y.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(y,k){if(this.c===v.Closed)return;let p=!1;(0,A.$Hf)(k)?p=this.f.delete(y):this.f.get(y)!==k&&(this.f.set(y,k),p=!0),p&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===v.None&&(this.c=v.Initialized,this.s.hint!==$.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,k){const p=this.f.get(y);return(0,A.$Hf)(p)?k:p}getBoolean(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:p==="true"}getNumber(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:parseInt(p,10)}getObject(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:(0,L.$lh)(p)}async set(y,k,p=!1){if(this.c===v.Closed)return;if((0,A.$Hf)(k))return this.delete(y,p);const u=(0,A.$Af)(k)||Array.isArray(k)?(0,L.$kh)(k):String(k);if(this.f.get(y)!==u)return this.f.set(y,u),this.j.set(y,u),this.h.delete(y),this.b.fire({key:y,external:p}),this.D()}async delete(y,k=!1){if(!(this.c===v.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:k}),this.D()}async optimize(){if(this.c!==v.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=v.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===$.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===$.STORAGE_IN_MEMORY}}e.$3o=R;class I{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((k,p)=>this.a.set(p,k)),y.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$4o=I}),define(De[185],Ce([1,0,35,16]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=void 0;function d(L,A,$,E,v,R){if(Array.isArray(L)){let I=0;for(const w of L){const y=d(w,A,$,E,v,R);if(y===10)return y;y>I&&(I=y)}return I}else{if(typeof L=="string")return E?L==="*"?5:L===$?10:0:0;if(L){const{language:I,pattern:w,scheme:y,hasAccessToAllModels:k,notebookType:p}=L;if(!E&&!k)return 0;p&&v&&(A=v);let u=0;if(y)if(y===A.scheme)u=10;else if(y==="*")u=5;else return 0;if(I)if(I===$)u=10;else if(I==="*")u=Math.max(u,5);else return 0;if(p)if(p===R)u=10;else if(p==="*"&&R!==void 0)u=Math.max(u,5);else return 0;if(w){let o;if(typeof w=="string"?o=w:o={...w,base:(0,F.$hc)(w.base)},o===A.fsPath||(0,C.$vj)(o,A.fsPath))u=10;else return 0}return u}else return 0}}e.$sE=d}),define(De[129],Ce([1,0,22,12]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0=e.$W0=void 0;var d;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(d||(d={}));function L(I){for(let w=0,y=I.length;w<y;w+=4){const k=I[w+0],p=I[w+1],u=I[w+2],o=I[w+3];I[w+0]=o,I[w+1]=u,I[w+2]=p,I[w+3]=k}}function A(I){const w=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.$D()||L(w),C.$be.wrap(w)}function $(I){const w=I.buffer;if(F.$D()||L(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const y=new Uint8Array(w.byteLength);return y.set(w),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(I){const w=new Uint32Array(v(I));let y=0;if(w[y++]=I.id,I.type==="full")w[y++]=1,w[y++]=I.data.length,w.set(I.data,y),y+=I.data.length;else{w[y++]=2,w[y++]=I.deltas.length;for(const k of I.deltas)w[y++]=k.start,w[y++]=k.deleteCount,k.data?(w[y++]=k.data.length,w.set(k.data,y),y+=k.data.length):w[y++]=0}return A(w)}e.$W0=E;function v(I){let w=0;if(w+=1+1,I.type==="full")w+=1+I.data.length;else{w+=1,w+=(1+1+1)*I.deltas.length;for(const y of I.deltas)y.data&&(w+=y.data.length)}return w}function R(I){const w=$(I);let y=0;const k=w[y++];if(w[y++]===1){const r=w[y++],s=w.subarray(y,y+r);return y+=r,{id:k,type:"full",data:s}}const u=w[y++],o=[];for(let r=0;r<u;r++){const s=w[y++],m=w[y++],h=w[y++];let t;h>0&&(t=w.subarray(y,y+h),y+=h),o[r]={start:s,deleteCount:m,data:t}}return{id:k,type:"delta",deltas:o}}e.$X0=R}),define(De[186],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,24,12,166,124,186]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class v{constructor(le){this.c=le}hasChanged(le){return this.c[le]}}e.ConfigurationChangedEvent=v;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(le,Ie,Ve,ze){this.id=le,this.name=Ie,this.defaultValue=Ve,this.schema=ze}applyUpdate(le,Ie){return y(le,Ie)}compute(le,Ie,Ve){return Ve}}class w{constructor(le,Ie){this.newValue=le,this.didChange=Ie}}e.ApplyUpdateResult=w;function y(he,le){if(typeof he!="object"||typeof le!="object"||!he||!le)return new w(le,he!==le);if(Array.isArray(he)||Array.isArray(le)){const Ve=Array.isArray(he)&&Array.isArray(le)&&C.$ub(he,le);return new w(le,!Ve)}let Ie=!1;for(const Ve in le)if(le.hasOwnProperty(Ve)){const ze=y(he[Ve],le[Ve]);ze.didChange&&(he[Ve]=ze.newValue,Ie=!0)}return new w(he,Ie)}class k{constructor(le){this.schema=void 0,this.id=le,this.name="_never_",this.defaultValue=void 0}applyUpdate(le,Ie){return y(le,Ie)}validate(le){return this.defaultValue}}class p{constructor(le,Ie,Ve,ze){this.id=le,this.name=Ie,this.defaultValue=Ve,this.schema=ze}applyUpdate(le,Ie){return y(le,Ie)}validate(le){return typeof le>"u"?this.defaultValue:le}compute(le,Ie,Ve){return Ve}}function u(he,le){return typeof he>"u"?le:he==="false"?!1:!!he}e.boolean=u;class o extends p{constructor(le,Ie,Ve,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Ve),super(le,Ie,Ve,ze)}validate(le){return u(le,this.defaultValue)}}function r(he,le,Ie,Ve){if(typeof he>"u")return le;let ze=parseInt(he,10);return isNaN(ze)?le:(ze=Math.max(Ie,ze),ze=Math.min(Ve,ze),ze|0)}e.clampedInt=r;class s extends p{static clampedInt(le,Ie,Ve,ze){return r(le,Ie,Ve,ze)}constructor(le,Ie,Ve,ze,xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ve,rt.minimum=ze,rt.maximum=xe),super(le,Ie,Ve,rt),this.minimum=ze,this.maximum=xe}validate(le){return s.clampedInt(le,this.defaultValue,this.minimum,this.maximum)}}function m(he,le,Ie,Ve){if(typeof he>"u")return le;const ze=h.float(he,le);return h.clamp(ze,Ie,Ve)}e.clampedFloat=m;class h extends p{static clamp(le,Ie,Ve){return le<Ie?Ie:le>Ve?Ve:le}static float(le,Ie){if(typeof le=="number")return le;if(typeof le>"u")return Ie;const Ve=parseFloat(le);return isNaN(Ve)?Ie:Ve}constructor(le,Ie,Ve,ze,xe){typeof xe<"u"&&(xe.type="number",xe.default=Ve),super(le,Ie,Ve,xe),this.validationFn=ze}validate(le){return this.validationFn(h.float(le,this.defaultValue))}}class t extends p{static string(le,Ie){return typeof le!="string"?Ie:le}constructor(le,Ie,Ve,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Ve),super(le,Ie,Ve,ze)}validate(le){return t.string(le,this.defaultValue)}}function n(he,le,Ie,Ve){return typeof he!="string"?le:Ve&&he in Ve?Ve[he]:Ie.indexOf(he)===-1?le:he}e.stringSet=n;class c extends p{constructor(le,Ie,Ve,ze,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=ze,xe.default=Ve),super(le,Ie,Ve,xe),this.c=ze}validate(le){return n(le,this.defaultValue,this.c)}}class i extends I{constructor(le,Ie,Ve,ze,xe,rt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=xe,ot.default=ze),super(le,Ie,Ve,ot),this.c=xe,this.d=rt}validate(le){return typeof le!="string"?this.defaultValue:this.c.indexOf(le)===-1?this.defaultValue:this.d(le)}}function a(he){switch(he){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(le){switch(le){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(le,Ie,Ve){return Ve===0?le.accessibilitySupport:Ve}}class D extends I{constructor(){const le={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",le,{"editor.comments.insertSpace":{type:"boolean",default:le.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:le.ignoreEmptyLines,description:$.localize(5,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{insertSpace:u(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function b(he){switch(he){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function g(he){switch(he){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=g;function P(he){switch(he){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class N extends k{constructor(){super(140)}compute(le,Ie,Ve){const ze=["monaco-editor"];return Ie.get(39)&&ze.push(Ie.get(39)),le.extraEditorClassName&&ze.push(le.extraEditorClassName),Ie.get(73)==="default"?ze.push("mouse-default"):Ie.get(73)==="copy"&&ze.push("mouse-copy"),Ie.get(110)&&ze.push("showUnused"),Ie.get(138)&&ze.push("showDeprecated"),ze.join(" ")}}class O extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(le,Ie,Ve){return Ve&&le.emptySelectionClipboard}}class M extends I{constructor(){const le={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",le,{"editor.find.cursorMoveOnType":{type:"boolean",default:le.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:le.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:le.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:le.globalFindClipboard,description:$.localize(16,null),included:d.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:le.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:le.loop,description:$.localize(18,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{cursorMoveOnType:u(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof le.seedSearchStringFromSelection=="boolean"?le.seedSearchStringFromSelection?"always":"never":n(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof le.autoFindInSelection=="boolean"?le.autoFindInSelection?"always":"never":n(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(Ie.loop,this.defaultValue.loop)}}}class j extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?j.OFF:le==="true"?j.ON:le:le?j.ON:j.OFF}}e.EditorFontLigatures=j;class U extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?U.OFF:le==="true"?U.TRANSLATE:le:le?U.TRANSLATE:U.OFF}compute(le,Ie,Ve){return le.fontInfo.fontVariationSettings}}e.EditorFontVariations=U;class T extends k{constructor(){super(50)}compute(le,Ie,Ve){return le.fontInfo}}class K extends p{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(le){const Ie=h.float(le,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ie,6,100)}compute(le,Ie,Ve){return le.fontInfo.fontSize}}class q extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.d,maximum:q.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(le){return le==="normal"||le==="bold"?le:String(s.clampedInt(le,e.EDITOR_FONT_DEFAULTS.fontWeight,q.d,q.e))}}class ge extends I{constructor(){const le={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:le.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",le,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:le.alternativeDefinitionCommand,enum:Ve,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:le.alternativeTypeDefinitionCommand,enum:Ve,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:le.alternativeDeclarationCommand,enum:Ve,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:le.alternativeImplementationCommand,enum:Ve,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:le.alternativeReferenceCommand,enum:Ve,description:$.localize(41,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{multiple:n(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??n(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??n(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??n(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??n(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??n(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends I{constructor(){const le={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",le,{"editor.hover.enabled":{type:"boolean",default:le.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:le.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:le.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:le.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:le.above,description:$.localize(46,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),delay:s.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:u(Ie.sticky,this.defaultValue.sticky),hidingDelay:s.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:u(Ie.above,this.defaultValue.above)}}}var Q;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class X extends k{constructor(){super(143)}compute(le,Ie,Ve){return X.computeLayout(Ie,{memory:le.memory,outerWidth:le.outerWidth,outerHeight:le.outerHeight,isDominatedByLongLines:le.isDominatedByLongLines,lineHeight:le.fontInfo.lineHeight,viewLineCount:le.viewLineCount,lineNumbersDigitCount:le.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:le.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:le.fontInfo.maxDigitWidth,pixelRatio:le.pixelRatio,glyphMarginDecorationLaneCount:le.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(le){const Ie=le.height/le.lineHeight,Ve=Math.floor(le.paddingTop/le.lineHeight);let ze=Math.floor(le.paddingBottom/le.lineHeight);le.scrollBeyondLastLine&&(ze=Math.max(ze,Ie-1));const xe=(Ve+le.viewLineCount+ze)/(le.pixelRatio*le.height),rt=Math.floor(le.viewLineCount/xe);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:ze,desiredRatio:xe,minimapLineCount:rt}}static c(le,Ie){const Ve=le.outerWidth,ze=le.outerHeight,xe=le.pixelRatio;if(!le.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const rt=Ie.stableMinimapLayoutInput,ot=rt&&le.outerHeight===rt.outerHeight&&le.lineHeight===rt.lineHeight&&le.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&le.pixelRatio===rt.pixelRatio&&le.scrollBeyondLastLine===rt.scrollBeyondLastLine&&le.paddingTop===rt.paddingTop&&le.paddingBottom===rt.paddingBottom&&le.minimap.enabled===rt.minimap.enabled&&le.minimap.side===rt.minimap.side&&le.minimap.size===rt.minimap.size&&le.minimap.showSlider===rt.minimap.showSlider&&le.minimap.renderCharacters===rt.minimap.renderCharacters&&le.minimap.maxColumn===rt.minimap.maxColumn&&le.minimap.scale===rt.minimap.scale&&le.verticalScrollbarWidth===rt.verticalScrollbarWidth&&le.isViewportWrapping===rt.isViewportWrapping,$t=le.lineHeight,St=le.typicalHalfwidthCharacterWidth,Yt=le.scrollBeyondLastLine,Gt=le.minimap.renderCharacters;let vt=xe>=2?Math.round(le.minimap.scale*2):le.minimap.scale;const zt=le.minimap.maxColumn,Nt=le.minimap.size,Bt=le.minimap.side,At=le.verticalScrollbarWidth,Rt=le.viewLineCount,Ot=le.remainingWidth,Wt=le.isViewportWrapping,Jt=Gt?2:3;let qt=Math.floor(xe*ze);const Vt=qt/xe;let Lt=!1,lt=!1,ft=Jt*vt,Tt=vt/xe,Kt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Me,extraLinesBeforeFirstLine:Te,extraLinesBeyondLastLine:Se,desiredRatio:ne,minimapLineCount:Fe}=X.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Yt,paddingTop:le.paddingTop,paddingBottom:le.paddingBottom,height:ze,lineHeight:$t,pixelRatio:xe});if(Rt/Fe>1)Lt=!0,lt=!0,vt=1,ft=1,Tt=vt/xe;else{let Ze=!1,Je=vt+1;if(Nt==="fit"){const nt=Math.ceil((Te+Rt+Se)*ft);Wt&&ot&&Ot<=Ie.stableFitRemainingWidth?(Ze=!0,Je=Ie.stableFitMaxMinimapScale):Ze=nt>qt}if(Nt==="fill"||Ze){Lt=!0;const nt=vt;ft=Math.min($t*xe,Math.max(1,Math.floor(1/ne))),Wt&&ot&&Ot<=Ie.stableFitRemainingWidth&&(Je=Ie.stableFitMaxMinimapScale),vt=Math.min(Je,Math.max(1,Math.floor(ft/Jt))),vt>nt&&(Kt=Math.min(2,vt/nt)),Tt=vt/xe/Kt,qt=Math.ceil(Math.max(Me,Te+Rt+Se)*ft),Wt?(Ie.stableMinimapLayoutInput=le,Ie.stableFitRemainingWidth=Ot,Ie.stableFitMaxMinimapScale=vt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Dt=Math.floor(zt*Tt),ct=Math.min(Dt,Math.max(0,Math.floor((Ot-At-2)*Tt/(St+Tt)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(xe*ct);const Ht=wt/xe;wt=Math.floor(wt*Kt);const Pt=Gt?1:2,Ge=Bt==="left"?0:Ve-ct-At;return{renderMinimap:Pt,minimapLeft:Ge,minimapWidth:ct,minimapHeightIsEditorHeight:Lt,minimapIsSampling:lt,minimapScale:vt,minimapLineHeight:ft,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:qt,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:Vt}}static computeLayout(le,Ie){const Ve=Ie.outerWidth|0,ze=Ie.outerHeight|0,xe=Ie.lineHeight|0,rt=Ie.lineNumbersDigitCount|0,ot=Ie.typicalHalfwidthCharacterWidth,$t=Ie.maxDigitWidth,St=Ie.pixelRatio,Yt=Ie.viewLineCount,Gt=le.get(135),vt=Gt==="inherit"?le.get(134):Gt,zt=vt==="inherit"?le.get(130):vt,Nt=le.get(133),Bt=Ie.isDominatedByLongLines,At=le.get(57),Rt=le.get(67).renderType!==0,Ot=le.get(68),Wt=le.get(104),Jt=le.get(83),qt=le.get(72),Vt=le.get(102),Lt=Vt.verticalScrollbarSize,lt=Vt.verticalHasArrows,ft=Vt.arrowSize,Tt=Vt.horizontalScrollbarSize,Kt=le.get(43),Dt=le.get(109)!=="never";let ct=le.get(65);Kt&&Dt&&(ct+=16);let wt=0;if(Rt){const jt=Math.max(rt,Ot);wt=Math.round(jt*$t)}let Ht=0;At&&(Ht=xe*Ie.glyphMarginDecorationLaneCount);let Pt=0,Ge=Pt+Ht,Me=Ge+wt,Te=Me+ct;const Se=Ve-Ht-wt-ct;let ne=!1,Fe=!1,Ke=-1;vt==="inherit"&&Bt?(ne=!0,Fe=!0):zt==="on"||zt==="bounded"?Fe=!0:zt==="wordWrapColumn"&&(Ke=Nt);const Ze=X.c({outerWidth:Ve,outerHeight:ze,lineHeight:xe,typicalHalfwidthCharacterWidth:ot,pixelRatio:St,scrollBeyondLastLine:Wt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:qt,verticalScrollbarWidth:Lt,viewLineCount:Yt,remainingWidth:Se,isViewportWrapping:Fe},Ie.memory||new R);Ze.renderMinimap!==0&&Ze.minimapLeft===0&&(Pt+=Ze.minimapWidth,Ge+=Ze.minimapWidth,Me+=Ze.minimapWidth,Te+=Ze.minimapWidth);const Je=Se-Ze.minimapWidth,nt=Math.max(1,Math.floor((Je-Lt-2)/ot)),pt=lt?ft:0;return Fe&&(Ke=Math.max(1,nt),zt==="bounded"&&(Ke=Math.min(Ke,Nt))),{width:Ve,height:ze,glyphMarginLeft:Pt,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Ge,lineNumbersWidth:wt,decorationsLeft:Me,decorationsWidth:ct,contentLeft:Te,contentWidth:Je,minimap:Ze,viewportColumn:nt,isWordWrapMinified:ne,isViewportWrapping:Fe,wrappingColumn:Ke,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:Tt,overviewRuler:{top:pt,width:Lt,height:ze-2*pt,right:0}}}}e.EditorLayoutInfoComputer=X;class ae extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(le){return n(le,"simple",["simple","advanced"])}compute(le,Ie,Ve){return Ie.get(2)===2?"advanced":Ve}}class ie extends I{constructor(){const le={enabled:!0};super(64,"lightbulb",le,{"editor.lightbulb.enabled":{type:"boolean",default:le.enabled,description:$.localize(50,null)}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{enabled:u(le.enabled,this.defaultValue.enabled)}}}class ce extends I{constructor(){const le={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",le,{"editor.stickyScroll.enabled":{type:"boolean",default:le.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:le.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:le.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:le.scrollWithEditor,description:$.localize(54,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),maxLineCount:s.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:u(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class we extends I{constructor(){const le={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",le,{"editor.inlayHints.enabled":{type:"string",default:le.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,d.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,d.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:le.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:le.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:le.padding,description:$.localize(62,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:n(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:s.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:u(Ie.padding,this.defaultValue.padding)}}}class H extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(le){return typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)?-parseFloat(le.substring(0,le.length-2)):s.clampedInt(le,this.defaultValue,0,1e3)}compute(le,Ie,Ve){return Ve<0?s.clampedInt(-Ve*le.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class B extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,le=>h.clamp(le,0,150),{markdownDescription:$.localize(63,null)})}compute(le,Ie,Ve){return le.fontInfo.lineHeight}}class J extends I{constructor(){const le={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",le,{"editor.minimap.enabled":{type:"boolean",default:le.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:le.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:le.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:le.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:le.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:le.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:le.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:le.maxColumn,description:$.localize(74,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),autohide:u(Ie.autohide,this.defaultValue.autohide),size:n(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ie.side,this.defaultValue.side,["right","left"]),showSlider:n(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(Ie.scale,1,1,3),maxColumn:s.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(he){return he==="ctrlCmd"?d.$k?"metaKey":"ctrlKey":"altKey"}class Y extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{top:s.clampedInt(Ie.top,0,0,1e3),bottom:s.clampedInt(Ie.bottom,0,0,1e3)}}}class _ extends I{constructor(){const le={enabled:!0,cycle:!0};super(85,"parameterHints",le,{"editor.parameterHints.enabled":{type:"boolean",default:le.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:le.cycle,description:$.localize(78,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),cycle:u(Ie.cycle,this.defaultValue.cycle)}}}class x extends k{constructor(){super(141)}compute(le,Ie,Ve){return le.pixelRatio}}class pe extends I{constructor(){const le={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",le,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:le.strings,description:$.localize(82,null)},comments:{anyOf:Ie,default:le.comments,description:$.localize(83,null)},other:{anyOf:Ie,default:le.other,description:$.localize(84,null)}},default:le,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=le}validate(le){if(typeof le=="boolean"){const St=le?"on":"off";return{comments:St,strings:St,other:St}}if(!le||typeof le!="object")return this.defaultValue;const{other:Ie,comments:Ve,strings:ze}=le,xe=["on","inline","off"];let rt,ot,$t;return typeof Ie=="boolean"?rt=Ie?"on":"off":rt=n(Ie,this.defaultValue.other,xe),typeof Ve=="boolean"?ot=Ve?"on":"off":ot=n(Ve,this.defaultValue.comments,xe),typeof ze=="boolean"?$t=ze?"on":"off":$t=n(ze,this.defaultValue.strings,xe),{other:rt,comments:ot,strings:$t}}}var ue;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(ue||(e.RenderLineNumbersType=ue={}));class fe extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(le){let Ie=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof le<"u"&&(typeof le=="function"?(Ie=4,Ve=le):le==="interval"?Ie=3:le==="relative"?Ie=2:le==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ve}}}function te(he){const le=he.get(97);return le==="editable"?he.get(90):le!=="on"}e.filterValidationDecorations=te;class de extends I{constructor(){const le=[],Ie={type:"number",description:$.localize(91,null)};super(101,"rulers",le,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:le,description:$.localize(93,null)})}validate(le){if(Array.isArray(le)){const Ie=[];for(const Ve of le)if(typeof Ve=="number")Ie.push({column:s.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const ze=Ve;Ie.push({column:s.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Ie.sort((Ve,ze)=>Ve.column-ze.column),Ie}return this.defaultValue}}class be extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(le){return!le||typeof le!="object"?this.defaultValue:le}}function Pe(he,le){if(typeof he!="string")return le;switch(he){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends I{constructor(){const le={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",le,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:le.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:le.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:le.scrollByPage,description:$.localize(104,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le,Ve=s.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=s.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:u(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:s.clampedInt(Ie.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:s.clampedInt(Ie.verticalSliderSize,ze,0,1e3),scrollByPage:u(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends I{constructor(){const le={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",le,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.nonBasicASCII,description:$.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:le.invisibleCharacters,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:le.ambiguousCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeComments,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeStrings,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:le.allowedCharacters,description:$.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:le.allowedLocales,description:$.localize(111,null)}})}applyUpdate(le,Ie){let Ve=!1;Ie.allowedCharacters&&le&&(F.$$m(le.allowedCharacters,Ie.allowedCharacters)||(le={...le,allowedCharacters:Ie.allowedCharacters},Ve=!0)),Ie.allowedLocales&&le&&(F.$$m(le.allowedLocales,Ie.allowedLocales)||(le={...le,allowedLocales:Ie.allowedLocales},Ve=!0));const ze=super.applyUpdate(le,Ie);return Ve?new w(ze.newValue,!0):ze}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{nonBasicASCII:me(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(le.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(le.allowedLocales,this.defaultValue.allowedLocales)}}c(le,Ie){if(typeof le!="object"||!le)return Ie;const Ve={};for(const[ze,xe]of Object.entries(le))xe===!0&&(Ve[ze]=!0);return Ve}}class se extends I{constructor(){const le={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",le,{"editor.inlineSuggest.enabled":{type:"boolean",default:le.enabled,description:$.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:le.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(113,null),$.localize(114,null)],description:$.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:le.suppressSuggestions,description:$.localize(116,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),mode:n(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:u(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:u(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends I{constructor(){const le={enabled:L.$4r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$4r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",le,{"editor.bracketPairColorization.enabled":{type:"boolean",default:le.enabled,markdownDescription:$.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:le.independentColorPoolPerBracketType,description:$.localize(118,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends I{constructor(){const le={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",le,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(119,null),$.localize(120,null),$.localize(121,null)],default:le.bracketPairs,description:$.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(123,null),$.localize(124,null),$.localize(125,null)],default:le.bracketPairsHorizontal,description:$.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:le.highlightActiveBracketPair,description:$.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:le.indentation,description:$.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(129,null),$.localize(130,null),$.localize(131,null)],default:le.highlightActiveIndentation,description:$.localize(132,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{bracketPairs:me(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:me(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function me(he,le,Ie){const Ve=Ie.indexOf(he);return Ve===-1?le:Ie[Ve]}class Ee extends I{constructor(){const le={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",le,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(133,null),$.localize(134,null)],default:le.insertMode,description:$.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:le.filterGraceful,description:$.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:le.localityBonus,description:$.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:le.shareSuggestSelections,markdownDescription:$.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(139,null),$.localize(140,null),$.localize(141,null),$.localize(142,null)],default:le.selectionMode,markdownDescription:$.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:le.snippetsPreventQuickSuggestions,description:$.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:le.showIcons,description:$.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:le.showStatusBar,description:$.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:le.preview,description:$.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:le.showInlineDetails,description:$.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{insertMode:n(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:u(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:u(Ie.preview,this.defaultValue.preview),previewMode:n(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(Ie.showMethods,this.defaultValue.showMethods),showFunctions:u(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:u(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(Ie.showFields,this.defaultValue.showFields),showVariables:u(Ie.showVariables,this.defaultValue.showVariables),showClasses:u(Ie.showClasses,this.defaultValue.showClasses),showStructs:u(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:u(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:u(Ie.showModules,this.defaultValue.showModules),showProperties:u(Ie.showProperties,this.defaultValue.showProperties),showEvents:u(Ie.showEvents,this.defaultValue.showEvents),showOperators:u(Ie.showOperators,this.defaultValue.showOperators),showUnits:u(Ie.showUnits,this.defaultValue.showUnits),showValues:u(Ie.showValues,this.defaultValue.showValues),showConstants:u(Ie.showConstants,this.defaultValue.showConstants),showEnums:u(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:u(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(Ie.showKeywords,this.defaultValue.showKeywords),showWords:u(Ie.showWords,this.defaultValue.showWords),showColors:u(Ie.showColors,this.defaultValue.showColors),showFiles:u(Ie.showFiles,this.defaultValue.showFiles),showReferences:u(Ie.showReferences,this.defaultValue.showReferences),showFolders:u(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:u(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:u(Ie.showUsers,this.defaultValue.showUsers),showIssues:u(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(182,null),default:!0,type:"boolean"}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(le.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:u(le.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(183,null),$.localize(184,null),$.localize(185,null),$.localize(186,null)],description:$.localize(187,null),default:"same"}})}validate(le){switch(le){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(le,Ie,Ve){return Ie.get(2)===2?0:Ve}}class Ye extends k{constructor(){super(144)}compute(le,Ie,Ve){const ze=Ie.get(143);return{isDominatedByLongLines:le.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class it extends I{constructor(){const le={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",le,{"editor.dropIntoEditor.enabled":{type:"boolean",default:le.enabled,markdownDescription:$.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(190,null),$.localize(191,null)],default:"afterDrop"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showDropSelector:n(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const le={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",le,{"editor.pasteAs.enabled":{type:"boolean",default:le.enabled,markdownDescription:$.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(194,null),$.localize(195,null)],default:"afterPaste"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showPasteSelector:n(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:d.$k?Ne:d.$l?qe:Ae,fontWeight:"normal",fontSize:d.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(he){return e.editorOptionsRegistry[he.id]=he,he}var Xe;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.letterSpacing=63]="letterSpacing",he[he.lightbulb=64]="lightbulb",he[he.lineDecorationsWidth=65]="lineDecorationsWidth",he[he.lineHeight=66]="lineHeight",he[he.lineNumbers=67]="lineNumbers",he[he.lineNumbersMinChars=68]="lineNumbersMinChars",he[he.linkedEditing=69]="linkedEditing",he[he.links=70]="links",he[he.matchBrackets=71]="matchBrackets",he[he.minimap=72]="minimap",he[he.mouseStyle=73]="mouseStyle",he[he.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=75]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",he[he.multiCursorModifier=77]="multiCursorModifier",he[he.multiCursorPaste=78]="multiCursorPaste",he[he.multiCursorLimit=79]="multiCursorLimit",he[he.occurrencesHighlight=80]="occurrencesHighlight",he[he.overviewRulerBorder=81]="overviewRulerBorder",he[he.overviewRulerLanes=82]="overviewRulerLanes",he[he.padding=83]="padding",he[he.pasteAs=84]="pasteAs",he[he.parameterHints=85]="parameterHints",he[he.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",he[he.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",he[he.quickSuggestions=88]="quickSuggestions",he[he.quickSuggestionsDelay=89]="quickSuggestionsDelay",he[he.readOnly=90]="readOnly",he[he.readOnlyMessage=91]="readOnlyMessage",he[he.renameOnType=92]="renameOnType",he[he.renderControlCharacters=93]="renderControlCharacters",he[he.renderFinalNewline=94]="renderFinalNewline",he[he.renderLineHighlight=95]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=97]="renderValidationDecorations",he[he.renderWhitespace=98]="renderWhitespace",he[he.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",he[he.roundedSelection=100]="roundedSelection",he[he.rulers=101]="rulers",he[he.scrollbar=102]="scrollbar",he[he.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=104]="scrollBeyondLastLine",he[he.scrollPredominantAxis=105]="scrollPredominantAxis",he[he.selectionClipboard=106]="selectionClipboard",he[he.selectionHighlight=107]="selectionHighlight",he[he.selectOnLineNumbers=108]="selectOnLineNumbers",he[he.showFoldingControls=109]="showFoldingControls",he[he.showUnused=110]="showUnused",he[he.snippetSuggestions=111]="snippetSuggestions",he[he.smartSelect=112]="smartSelect",he[he.smoothScrolling=113]="smoothScrolling",he[he.stickyScroll=114]="stickyScroll",he[he.stickyTabStops=115]="stickyTabStops",he[he.stopRenderingLineAfter=116]="stopRenderingLineAfter",he[he.suggest=117]="suggest",he[he.suggestFontSize=118]="suggestFontSize",he[he.suggestLineHeight=119]="suggestLineHeight",he[he.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",he[he.suggestSelection=121]="suggestSelection",he[he.tabCompletion=122]="tabCompletion",he[he.tabIndex=123]="tabIndex",he[he.unicodeHighlighting=124]="unicodeHighlighting",he[he.unusualLineTerminators=125]="unusualLineTerminators",he[he.useShadowDOM=126]="useShadowDOM",he[he.useTabStops=127]="useTabStops",he[he.wordBreak=128]="wordBreak",he[he.wordSeparators=129]="wordSeparators",he[he.wordWrap=130]="wordWrap",he[he.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=133]="wordWrapColumn",he[he.wordWrapOverride1=134]="wordWrapOverride1",he[he.wordWrapOverride2=135]="wordWrapOverride2",he[he.wrappingIndent=136]="wrappingIndent",he[he.wrappingStrategy=137]="wrappingStrategy",he[he.showDeprecated=138]="showDeprecated",he[he.inlayHints=139]="inlayHints",he[he.editorClassName=140]="editorClassName",he[he.pixelRatio=141]="pixelRatio",he[he.tabFocusMode=142]="tabFocusMode",he[he.layoutInfo=143]="layoutInfo",he[he.wrappingInfo=144]="wrappingInfo",he[he.defaultColorDecorators=145]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(196,null)})),acceptSuggestionOnEnter:Le(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(197,null),""],markdownDescription:$.localize(198,null)})),accessibilitySupport:Le(new l),accessibilityPageSize:Le(new s(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(199,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",$.localize(200,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Le(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(202,null),$.localize(203,null),""],description:$.localize(204,null)})),autoClosingComments:Le(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(205,null),$.localize(206,null),""],description:$.localize(207,null)})),autoClosingDelete:Le(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(208,null),""],description:$.localize(209,null)})),autoClosingOvertype:Le(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(210,null),""],description:$.localize(211,null)})),autoClosingQuotes:Le(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(212,null),$.localize(213,null),""],description:$.localize(214,null)})),autoIndent:Le(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[$.localize(215,null),$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null)],description:$.localize(220,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(221,null),$.localize(222,null),$.localize(223,null),""],description:$.localize(224,null)})),bracketPairColorization:Le(new oe),bracketPairGuides:Le(new Z),stickyTabStops:Le(new o(115,"stickyTabStops",!1,{description:$.localize(225,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:$.localize(226,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:$.localize(227,null)})),codeLensFontSize:Le(new s(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(228,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:$.localize(229,null)})),colorDecoratorActivatedOn:Le(new c(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(230,null),$.localize(231,null),$.localize(232,null)],description:$.localize(233,null)})),colorDecoratorsLimit:Le(new s(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(234,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:$.localize(235,null)})),comments:Le(new D),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(236,null)})),cursorBlinking:Le(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:$.localize(237,null)})),cursorSmoothCaretAnimation:Le(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(238,null),$.localize(239,null),$.localize(240,null)],description:$.localize(241,null)})),cursorStyle:Le(new i(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:$.localize(242,null)})),cursorSurroundingLines:Le(new s(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(243,null)})),cursorSurroundingLinesStyle:Le(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(244,null),$.localize(245,null)],markdownDescription:$.localize(246,null)})),cursorWidth:Le(new s(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(247,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:$.localize(248,null)})),emptySelectionClipboard:Le(new O),dropIntoEditor:Le(new it),stickyScroll:Le(new ce),experimentalWhitespaceRendering:Le(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(249,null),$.localize(250,null),$.localize(251,null)],description:$.localize(252,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new h(40,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:$.localize(253,null)})),find:Le(new M),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:$.localize(254,null)})),foldingStrategy:Le(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:$.localize(258,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:$.localize(259,null)})),foldingMaximumRegions:Le(new s(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(260,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(261,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(262,null)})),fontInfo:Le(new T),fontLigatures2:Le(new j),fontSize:Le(new K),fontWeight:Le(new q),fontVariations:Le(new U),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:$.localize(263,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:$.localize(264,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:$.localize(265,null)})),gotoLocation:Le(new ge),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:$.localize(266,null)})),hover:Le(new ee),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>h.clamp(he,-5,20),{description:$.localize(267,null)})),lightbulb:Le(new ie),lineDecorationsWidth:Le(new H),lineHeight:Le(new B),lineNumbers:Le(new fe),lineNumbersMinChars:Le(new s(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(69,"linkedEditing",!1,{description:$.localize(268,null)})),links:Le(new o(70,"links",!0,{description:$.localize(269,null)})),matchBrackets:Le(new c(71,"matchBrackets","always",["always","near","never"],{description:$.localize(270,null)})),minimap:Le(new J),mouseStyle:Le(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new h(74,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:$.localize(271,null)})),mouseWheelZoom:Le(new o(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(272,null)})),multiCursorMergeOverlapping:Le(new o(76,"multiCursorMergeOverlapping",!0,{description:$.localize(273,null)})),multiCursorModifier:Le(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[$.localize(274,null),$.localize(275,null)],markdownDescription:$.localize(276,null)})),multiCursorPaste:Le(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(277,null),$.localize(278,null)],markdownDescription:$.localize(279,null)})),multiCursorLimit:Le(new s(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(280,null)})),occurrencesHighlight:Le(new o(80,"occurrencesHighlight",!0,{description:$.localize(281,null)})),overviewRulerBorder:Le(new o(81,"overviewRulerBorder",!0,{description:$.localize(282,null)})),overviewRulerLanes:Le(new s(82,"overviewRulerLanes",3,0,3)),padding:Le(new Y),pasteAs:Le(new et),parameterHints:Le(new _),peekWidgetDefaultFocus:Le(new c(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(283,null),$.localize(284,null)],description:$.localize(285,null)})),definitionLinkOpensInPeek:Le(new o(87,"definitionLinkOpensInPeek",!1,{description:$.localize(286,null)})),quickSuggestions:Le(new pe),quickSuggestionsDelay:Le(new s(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(287,null)})),readOnly:Le(new o(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new o(92,"renameOnType",!1,{description:$.localize(288,null),markdownDeprecationMessage:$.localize(289,null)})),renderControlCharacters:Le(new o(93,"renderControlCharacters",!0,{description:$.localize(290,null),restricted:!0})),renderFinalNewline:Le(new c(94,"renderFinalNewline",d.$l?"dimmed":"on",["off","on","dimmed"],{description:$.localize(291,null)})),renderLineHighlight:Le(new c(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(292,null)],description:$.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(294,null)})),renderValidationDecorations:Le(new c(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new c(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(295,null),$.localize(296,null),$.localize(297,null),""],description:$.localize(298,null)})),revealHorizontalRightPadding:Le(new s(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(100,"roundedSelection",!0,{description:$.localize(299,null)})),rulers:Le(new de),scrollbar:Le(new z),scrollBeyondLastColumn:Le(new s(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(300,null)})),scrollBeyondLastLine:Le(new o(104,"scrollBeyondLastLine",!0,{description:$.localize(301,null)})),scrollPredominantAxis:Le(new o(105,"scrollPredominantAxis",!0,{description:$.localize(302,null)})),selectionClipboard:Le(new o(106,"selectionClipboard",!0,{description:$.localize(303,null),included:d.$l})),selectionHighlight:Le(new o(107,"selectionHighlight",!0,{description:$.localize(304,null)})),selectOnLineNumbers:Le(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new c(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(305,null),$.localize(306,null),$.localize(307,null)],description:$.localize(308,null)})),showUnused:Le(new o(110,"showUnused",!0,{description:$.localize(309,null)})),showDeprecated:Le(new o(138,"showDeprecated",!0,{description:$.localize(310,null)})),inlayHints:Le(new we),snippetSuggestions:Le(new c(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(311,null),$.localize(312,null),$.localize(313,null),$.localize(314,null)],description:$.localize(315,null)})),smartSelect:Le(new je),smoothScrolling:Le(new o(113,"smoothScrolling",!1,{description:$.localize(316,null)})),stopRenderingLineAfter:Le(new s(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Ee),inlineSuggest:Le(new se),inlineCompletionsAccessibilityVerbose:Le(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(317,null)})),suggestFontSize:Le(new s(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new s(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(120,"suggestOnTriggerCharacters",!0,{description:$.localize(320,null)})),suggestSelection:Le(new c(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),tabCompletion:Le(new c(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(325,null),$.localize(326,null),$.localize(327,null)],description:$.localize(328,null)})),tabIndex:Le(new s(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new G),unusualLineTerminators:Le(new c(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(329,null),$.localize(330,null),$.localize(331,null)],description:$.localize(332,null)})),useShadowDOM:Le(new o(126,"useShadowDOM",!0)),useTabStops:Le(new o(127,"useTabStops",!0,{description:$.localize(333,null)})),wordBreak:Le(new c(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(334,null),$.localize(335,null)],description:$.localize(336,null)})),wordSeparators:Le(new t(129,"wordSeparators",A.$5r,{description:$.localize(337,null)})),wordWrap:Le(new c(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null),$.localize(341,null)],description:$.localize(342,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new s(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(343,null)})),wordWrapOverride1:Le(new c(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new c(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new N),defaultColorDecorators:Le(new o(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(344,null)})),pixelRatio:Le(new x),tabFocusMode:Le(new o(142,"tabFocusMode",!1,{markdownDescription:$.localize(345,null)})),layoutInfo:Le(new X),wrappingInfo:Le(new Ye),wrappingIndent:Le(new _e),wrappingStrategy:Le(new ae)}}),define(De[187],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(De[83],Ce([1,0,79,2,164,32,174,187]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$lt=e.$kt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$jt=e.$it=e.SymbolKinds=e.SymbolTag=e.$ht=e.$gt=e.SymbolKind=e.$ft=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$et=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$dt=e.$ct=e.$bt=void 0;class E{constructor(j,U,T){this.offset=j,this.type=U,this.language=T,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$bt=E;class v{constructor(j,U){this.tokens=j,this.endState=U,this._tokenizationResultBrand=void 0}}e.$ct=v;class R{constructor(j,U){this.tokens=j,this.endState=U,this._encodedTokenizationResultBrand=void 0}}e.$dt=R;var I;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var w;(function(M){const j=new Map;j.set(0,C.$Uj.symbolMethod),j.set(1,C.$Uj.symbolFunction),j.set(2,C.$Uj.symbolConstructor),j.set(3,C.$Uj.symbolField),j.set(4,C.$Uj.symbolVariable),j.set(5,C.$Uj.symbolClass),j.set(6,C.$Uj.symbolStruct),j.set(7,C.$Uj.symbolInterface),j.set(8,C.$Uj.symbolModule),j.set(9,C.$Uj.symbolProperty),j.set(10,C.$Uj.symbolEvent),j.set(11,C.$Uj.symbolOperator),j.set(12,C.$Uj.symbolUnit),j.set(13,C.$Uj.symbolValue),j.set(15,C.$Uj.symbolEnum),j.set(14,C.$Uj.symbolConstant),j.set(15,C.$Uj.symbolEnum),j.set(16,C.$Uj.symbolEnumMember),j.set(17,C.$Uj.symbolKeyword),j.set(27,C.$Uj.symbolSnippet),j.set(18,C.$Uj.symbolText),j.set(19,C.$Uj.symbolColor),j.set(20,C.$Uj.symbolFile),j.set(21,C.$Uj.symbolReference),j.set(22,C.$Uj.symbolCustomColor),j.set(23,C.$Uj.symbolFolder),j.set(24,C.$Uj.symbolTypeParameter),j.set(25,C.$Uj.account),j.set(26,C.$Uj.issues);function U(q){let ge=j.get(q);return ge||(console.info("No codicon found for CompletionItemKind "+q),ge=C.$Uj.symbolProperty),ge}M.toIcon=U;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function K(q,ge){let ee=T.get(q);return typeof ee>"u"&&!ge&&(ee=9),ee}M.fromString=K})(w||(e.CompletionItemKinds=w={}));var y;(function(M){M[M.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var k;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var p;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var u;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class o{constructor(j,U,T,K){this.range=j,this.text=U,this.completionKind=T,this.isSnippetText=K}equals(j){return L.$us.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$et=o;var r;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(r||(e.CodeActionTriggerType=r={}));var s;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var m;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(m||(e.DocumentHighlightKind=m={}));function h(M){return M&&F.URI.isUri(M.uri)&&L.$us.isIRange(M.range)&&(L.$us.isIRange(M.originSelectionRange)||L.$us.isIRange(M.targetSelectionRange))}e.$ft=h;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$gt={[17]:(0,$.localize)(0,null),[16]:(0,$.localize)(1,null),[4]:(0,$.localize)(2,null),[13]:(0,$.localize)(3,null),[8]:(0,$.localize)(4,null),[9]:(0,$.localize)(5,null),[21]:(0,$.localize)(6,null),[23]:(0,$.localize)(7,null),[7]:(0,$.localize)(8,null),[0]:(0,$.localize)(9,null),[11]:(0,$.localize)(10,null),[10]:(0,$.localize)(11,null),[19]:(0,$.localize)(12,null),[5]:(0,$.localize)(13,null),[1]:(0,$.localize)(14,null),[2]:(0,$.localize)(15,null),[20]:(0,$.localize)(16,null),[15]:(0,$.localize)(17,null),[18]:(0,$.localize)(18,null),[24]:(0,$.localize)(19,null),[3]:(0,$.localize)(20,null),[6]:(0,$.localize)(21,null),[14]:(0,$.localize)(22,null),[22]:(0,$.localize)(23,null),[25]:(0,$.localize)(24,null),[12]:(0,$.localize)(25,null)};function n(M,j){return(0,$.localize)(26,null,M,e.$gt[j])}e.$ht=n;var c;(function(M){M[M.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var i;(function(M){const j=new Map;j.set(0,C.$Uj.symbolFile),j.set(1,C.$Uj.symbolModule),j.set(2,C.$Uj.symbolNamespace),j.set(3,C.$Uj.symbolPackage),j.set(4,C.$Uj.symbolClass),j.set(5,C.$Uj.symbolMethod),j.set(6,C.$Uj.symbolProperty),j.set(7,C.$Uj.symbolField),j.set(8,C.$Uj.symbolConstructor),j.set(9,C.$Uj.symbolEnum),j.set(10,C.$Uj.symbolInterface),j.set(11,C.$Uj.symbolFunction),j.set(12,C.$Uj.symbolVariable),j.set(13,C.$Uj.symbolConstant),j.set(14,C.$Uj.symbolString),j.set(15,C.$Uj.symbolNumber),j.set(16,C.$Uj.symbolBoolean),j.set(17,C.$Uj.symbolArray),j.set(18,C.$Uj.symbolObject),j.set(19,C.$Uj.symbolKey),j.set(20,C.$Uj.symbolNull),j.set(21,C.$Uj.symbolEnumMember),j.set(22,C.$Uj.symbolStruct),j.set(23,C.$Uj.symbolEvent),j.set(24,C.$Uj.symbolOperator),j.set(25,C.$Uj.symbolTypeParameter);function U(T){let K=j.get(T);return K||(console.info("No codicon found for SymbolKind "+T),K=C.$Uj.symbolProperty),K}M.toIcon=U})(i||(e.SymbolKinds=i={}));class a{static asEditOperation(j){return d.$vs.replace(L.$us.lift(j.range),j.text)}}e.$it=a;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(j){switch(j){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(j)}constructor(j){this.value=j}}e.$jt=l;var D;(function(M){function j(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}M.is=j})(D||(e.Command=D={}));var S;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(S||(e.CommentThreadCollapsibleState=S={}));var b;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(b||(e.CommentThreadState=b={}));var f;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(f||(e.CommentMode=f={}));var g;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(g||(e.CommentState=g={}));var P;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class N{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$kt=N,e.$lt=new A.$6s;var O;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(O||(e.ExternalUriOpenerPriority=O={}))}),define(De[188],Ce([10,11]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([10,11]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([10,11]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(De[196],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(De[197],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([10,11]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([10,11]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([10,11]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([10,11]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[204],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[205],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[206],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(De[207],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[208],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(De[209],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[210],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[211],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[212],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[213],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[214],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[215],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[216],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(De[217],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(De[218],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[219],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[220],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[221],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[222],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[223],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[224],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[225],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[226],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[227],Ce([1,0,9,190]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var d;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(d||(e.TokenType=d={}));function L(...v){switch(v.length){case 1:return(0,F.localize)(0,null,v[0]);case 2:return(0,F.localize)(1,null,v[0],v[1]);case 3:return(0,F.localize)(2,null,v[0],v[1],v[2]);default:return}}const A=(0,F.localize)(3,null),$=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,w=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:w};this.g.push({offset:I,lexeme:w,additionalInfo:R}),this.f.push(y)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),w=E.b.get(I);w?this.k(w):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,w=!1;for(;;){if(R>=this.c.length){this.e=R,this.l($);return}const k=this.c.charCodeAt(R);if(I)I=!1;else if(k===47&&!w){R++;break}else k===91?w=!0:k===92?I=!0:k===93&&(w=!1);R++}for(;R<this.c.length&&E.a.has(this.c.charCodeAt(R));)R++;this.e=R;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=E}),define(De[228],Ce([1,0,23,38,193,374]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function E(o){return o=o.trim(),o==="*"||A.test(o)}e.$Mo=E;function v(o){if(!E(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=o.match(A);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$No=v;function R(o){if(!o)return null;const r=o.majorBase,s=o.majorMustEqual,m=o.minorBase;let h=o.minorMustEqual;const t=o.patchBase;let n=o.patchMustEqual;o.hasCaret&&(r===0||(h=!1),n=!1);let c=0;if(o.preRelease){const i=$.exec(o.preRelease);if(i){const[,a,l,D]=i;c=Date.UTC(Number(a),Number(l)-1,Number(D))}}return{majorBase:r,majorMustEqual:s,minorBase:m,minorMustEqual:h,patchBase:t,patchMustEqual:n,isMinimum:o.hasGreaterEquals,notBefore:c}}e.$Oo=R;function I(o,r,s){let m;typeof o=="string"?m=R(v(o)):m=o;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let t;if(typeof s=="string"?t=R(v(s)):t=s,!m||!t)return!1;const n=m.majorBase,c=m.minorBase,i=m.patchBase;let a=t.majorBase,l=t.minorBase,D=t.patchBase;const S=t.notBefore;let b=t.majorMustEqual,f=t.minorMustEqual,g=t.patchMustEqual;return t.isMinimum?n>a?!0:n<a?!1:c>l?!0:c<l||h&&h<S?!1:i>=D:(n===1&&a===0&&(!b||!f||!g)&&(a=1,l=0,D=0,b=!0,f=!1,g=!1),n<a?!1:n>a?!b:c<l?!1:c>l?!f:i<D?!1:i>D?!g:!(h&&h<S))}e.$Po=I;function w(o,r,s,m,h){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([F.default.Error,d.localize(0,null)]),t;if(typeof m.name!="string")return t.push([F.default.Error,d.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([F.default.Error,d.localize(2,null,"version")]),t;if(!m.engines)return t.push([F.default.Error,d.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([F.default.Error,d.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!u(m.extensionDependencies))return t.push([F.default.Error,d.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!u(m.activationEvents))return t.push([F.default.Error,d.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([F.default.Error,d.localize(7,null,"activationEvents","main","browser")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([F.default.Warning,d.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([F.default.Error,d.localize(9,null,"main")]),t;{const i=(0,C.$vg)(s,m.main);(0,C.$pg)(i,s)||t.push([F.default.Warning,d.localize(10,null,i.path,s.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([F.default.Error,d.localize(11,null,"browser")]),t;{const i=(0,C.$vg)(s,m.browser);(0,C.$pg)(i,s)||t.push([F.default.Warning,d.localize(12,null,i.path,s.path)])}}if(!L.valid(m.version))return t.push([F.default.Error,d.localize(13,null)]),t;const n=[];if(!y(o,r,m,h,n))for(const i of n)t.push([F.default.Error,i]);return t}e.$Qo=w;function y(o,r,s,m,h){return m||typeof s.main>"u"&&typeof s.browser>"u"?!0:p(o,r,s.engines.vscode,h)}e.$Ro=y;function k(o,r,s){return o==="*"||p(r,s,o)}e.$So=k;function p(o,r,s,m=[]){const h=R(v(s));if(!h)return m.push(d.localize(14,null,s)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return m.push(d.localize(15,null,s)),!1}else if(!h.majorMustEqual)return m.push(d.localize(16,null,s)),!1;return I(o,r,h)?!0:(m.push(d.localize(17,null,o,s)),!1)}function u(o){if(!Array.isArray(o))return!1;for(let r=0,s=o.length;r<s;r++)if(typeof o[r]!="string")return!1;return!0}}),define(De[102],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class C{constructor(d,L=[],A=!1){this.ctor=d,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$Mh=C}),define(De[103],Ce([1,0,102]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.InstantiationType=void 0;const F=[];var d;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(d||(e.InstantiationType=d={}));function L($,E,v){E instanceof C.$Mh||(E=new C.$Mh(E,[],!!v)),F.push([$,E])}e.$xr=L;function A(){return F}e.$yr=A}),define(De[229],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class C{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$cq=C;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const $=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(A);$.outgoing.set(E.key,E),E.incoming.set($.key,$)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const $ of this.a.values())$.outgoing.delete(A),$.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let $=this.a.get(A);return $||($=new C(A,L),this.a.set(A,$)),$}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,$]of this.a)L.push(`${A}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const $=new Set([L]),E=this.c(A,$);if(E)return E}}c(L,A){for(const[$,E]of L.outgoing){if(A.has($))return[...A,$].join(" -> ");A.add($);const v=this.c(E,A);if(v)return v;A.delete($)}}}e.$dq=F}),define(De[5],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function $(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=$})(C||(e._util=C={})),e.$Oh=d("instantiationService");function F(A,$,E){$[C.DI_TARGET]===$?$[C.DI_DEPENDENCIES].push({id:A,index:E}):($[C.DI_DEPENDENCIES]=[{id:A,index:E}],$[C.DI_TARGET]=$)}function d(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const $=function(E,v,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F($,E,R)};return $.toString=()=>A,C.serviceIds.set(A,$),$}e.$Ph=d;function L(A){return A}e.$Qh=L}),define(De[50],Ce([1,0,17,2,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,d.$Ph)("configurationService");function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof F.URI)}e.$ki=L;function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof F.URI)}e.$li=A;var $;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function E(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=E;function v(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$ni=v;function R(o,r){const s=Object.create(null);for(const m in o)I(s,m,o[m],r);return s}e.$oi=R;function I(o,r,s,m){const h=r.split("."),t=h.pop();let n=o;for(let c=0;c<h.length;c++){const i=h[c];let a=n[i];switch(typeof a){case"undefined":a=n[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${r} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[t]=s}catch{m(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(n)}`)}else m(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(n)}`)}e.$pi=I;function w(o,r){const s=r.split(".");y(o,s)}e.$qi=w;function y(o,r){const s=r.shift();if(r.length===0){delete o[s];return}if(Object.keys(o).indexOf(s)!==-1){const m=o[s];typeof m=="object"&&!Array.isArray(m)&&(y(m,r),Object.keys(m).length===0&&delete o[s])}}function k(o,r,s){function m(n,c){let i=n;for(const a of c){if(typeof i!="object"||i===null)return;i=i[a]}return i}const h=r.split("."),t=m(o,h);return typeof t>"u"?s:t}e.$ri=k;function p(o,r,s){Object.keys(r).forEach(m=>{m!=="__proto__"&&(m in o?C.$Af(o[m])&&C.$Af(r[m])?p(o[m],r[m],s):s&&(o[m]=r[m]):o[m]=r[m])})}e.$si=p;function u(o){return o.replace(/[\[\]]/g,"")}e.$ti=u}),define(De[42],Ce([1,0,12,15,227,5,189,9]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",C.$k),E.set("isLinux",C.$l),E.set("isWindows",C.$j),E.set("isWeb",C.$p),E.set("isMacNative",C.$k&&!C.$p),E.set("isEdge",C.$H),E.set("isFirefox",C.$F),E.set("isChrome",C.$E),E.set("isSafari",C.$G);function v(H,B){if(E.get(H)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(H,B)}e.$Li=v;const R=Object.prototype.hasOwnProperty;var I;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const w={regexParsingWithErrorRecovery:!0},y=(0,A.localize)(0,null),k=(0,A.localize)(1,null),p=(0,A.localize)(2,null),u=(0,A.localize)(3,null),o=(0,A.localize)(4,null),r=(0,A.localize)(5,null),s=(0,A.localize)(6,null),m=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=w){this.k=B,this.d=new d.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const re=this.D(),Y=re.type===17?r:void 0;throw this.h.push({message:o,offset:re.offset,lexeme:d.$Ki.getLexeme(re),additionalInfo:Y}),h.c}return J}catch(J){if(J!==h.c)throw J;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const J=this.o();B.push(J)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const J=this.s();B.push(J)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const J=this.l();return this.A(1,u),J?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const J=this.l();return this.A(1,u),J}case 17:{const J=B.lexeme;if(this.z(),this.y(9)){const Y=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Y.type!==10)throw this.B("REGEX",Y);const _=Y.lexeme,x=_.lastIndexOf("/"),pe=x===_.length-1?void 0:this.w(_.substring(x+1));let ue;try{ue=new RegExp(_.substring(1,x),pe)}catch{throw this.B("REGEX",Y)}return T.create(J,ue)}switch(Y.type){case 10:case 19:{const _=[Y.lexeme];this.z();let x=this.D(),pe=0;for(let be=0;be<Y.lexeme.length;be++)Y.lexeme.charCodeAt(be)===40?pe++:Y.lexeme.charCodeAt(be)===41&&pe--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:pe++;break;case 1:pe--;break;case 10:case 18:for(let be=0;be<x.lexeme.length;be++)x.lexeme.charCodeAt(be)===40?pe++:Y.lexeme.charCodeAt(be)===41&&pe--}if(pe<0)break;_.push(d.$Ki.getLexeme(x)),this.z(),x=this.D()}const ue=_.join(""),fe=ue.lastIndexOf("/"),te=fe===ue.length-1?void 0:this.w(ue.substring(fe+1));let de;try{de=new RegExp(ue.substring(1,fe),te)}catch{throw this.B("REGEX",Y)}return t.regex(J,de)}case 18:{const _=Y.lexeme;this.z();let x=null;if(!(0,F.$Be)(_)){const pe=_.indexOf("/"),ue=_.lastIndexOf("/");if(pe!==ue&&pe>=0){const fe=_.slice(pe+1,ue),te=_[ue+1]==="i"?"i":"";try{x=new RegExp(fe,te)}catch{throw this.B("REGEX",Y)}}}if(x===null)throw this.B("REGEX",Y);return T.create(J,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const Y=this.u();return t.notIn(J,Y)}switch(this.D().type){case 3:{this.z();const Y=this.u();if(this.x().type===18)return t.equals(J,Y);switch(Y){case"true":return t.has(J);case"false":return t.not(J);default:return t.equals(J,Y)}}case 4:{this.z();const Y=this.u();if(this.x().type===18)return t.notEquals(J,Y);switch(Y){case"true":return t.not(J);case"false":return t.has(J);default:return t.notEquals(J,Y)}}case 5:return this.z(),j.create(J,this.u());case 6:return this.z(),U.create(J,this.u());case 7:return this.z(),O.create(J,this.u());case 8:return this.z(),M.create(J,this.u());case 13:return this.z(),t.in(J,this.u());default:return t.has(J)}}case 20:throw this.h.push({message:s,offset:B.offset,lexeme:"",additionalInfo:m}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,J){if(this.C(B))return this.z();throw this.B(J,this.D())}B(B,J,re){const Y=(0,A.localize)(8,null,B,d.$Ki.getLexeme(J)),_=J.offset,x=d.$Ki.getLexeme(J);return this.h.push({message:Y,offset:_,lexeme:x,additionalInfo:re}),h.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=h;class t{static false(){return a.INSTANCE}static true(){return l.INSTANCE}static has(B){return D.create(B)}static equals(B,J){return S.create(B,J)}static notEquals(B,J){return g.create(B,J)}static regex(B,J){return T.create(B,J)}static in(B,J){return b.create(B,J)}static notIn(B,J){return f.create(B,J)}static not(B){return P.create(B)}static and(...B){return ge.create(B,null,!0)}static or(...B){return ee.create(B,null,!0)}static greater(B,J){return O.create(B,J)}static greaterEquals(B,J){return M.create(B,J)}static smaller(B,J){return j.create(B,J)}static smallerEquals(B,J){return U.create(B,J)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Ni=t;function n(H){const B=new h({regexParsingWithErrorRecovery:!1});return H.map(J=>(B.parse(J),B.lexingErrors.length>0?B.lexingErrors.map(re=>({errorMessage:re.additionalInfo?(0,A.localize)(9,null,re.additionalInfo):(0,A.localize)(10,null),offset:re.offset,length:re.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(re=>({errorMessage:re.additionalInfo?`${re.message}. ${re.additionalInfo}`:re.message,offset:re.offset,length:re.lexeme.length})):[]))}e.$Oi=n;function c(H,B){const J=H?H.substituteConstants():void 0,re=B?B.substituteConstants():void 0;return!J&&!re?!0:!J||!re?!1:J.equals(re)}e.$Pi=c;function i(H,B){return H.cmp(B)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return l.INSTANCE}}e.$Qi=a;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return a.INSTANCE}}e.$Ri=l;class D{static create(B,J=null){const re=E.get(B);return typeof re=="boolean"?re?l.INSTANCE:a.INSTANCE:new D(B,J)}constructor(B,J){this.key=B,this.c=J,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:X(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=E.get(this.key);return typeof B=="boolean"?B?l.INSTANCE:a.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Si=D;class S{static create(B,J,re=null){if(typeof J=="boolean")return J?D.create(B,re):P.create(B,re);const Y=E.get(B);return typeof Y=="boolean"?J===(Y?"true":"false")?l.INSTANCE:a.INSTANCE:new S(B,J,re)}constructor(B,J,re){this.c=B,this.d=J,this.f=re,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const J=B?"true":"false";return this.d===J?l.INSTANCE:a.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.$Ti=S;class b{static create(B,J){return new b(B,J)}constructor(B,J){this.d=B,this.f=J,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const J=B.getValue(this.f),re=B.getValue(this.d);return Array.isArray(J)?J.includes(re):typeof re=="string"&&typeof J=="object"&&J!==null?R.call(J,re):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Ui=b;class f{static create(B,J){return new f(B,J)}constructor(B,J){this.d=B,this.f=J,this.type=11,this.c=b.create(B,J)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=f;class g{static create(B,J,re=null){if(typeof J=="boolean")return J?P.create(B,re):D.create(B,re);const Y=E.get(B);return typeof Y=="boolean"?J===(Y?"true":"false")?a.INSTANCE:l.INSTANCE:new g(B,J,re)}constructor(B,J,re){this.c=B,this.d=J,this.f=re,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const J=B?"true":"false";return this.d===J?a.INSTANCE:l.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Wi=g;class P{static create(B,J=null){const re=E.get(B);return typeof re=="boolean"?re?a.INSTANCE:l.INSTANCE:new P(B,J)}constructor(B,J){this.c=B,this.d=J,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:X(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=E.get(this.c);return typeof B=="boolean"?B?a.INSTANCE:l.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$Xi=P;function N(H,B){if(typeof H=="string"){const J=parseFloat(H);isNaN(J)||(H=J)}return typeof H=="string"||typeof H=="number"?B(H):a.INSTANCE}class O{static create(B,J,re=null){return N(J,Y=>new O(B,Y,re))}constructor(B,J,re){this.c=B,this.d=J,this.f=re,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Yi=O;class M{static create(B,J,re=null){return N(J,Y=>new M(B,Y,re))}constructor(B,J,re){this.c=B,this.d=J,this.f=re,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Zi=M;class j{static create(B,J,re=null){return N(J,Y=>new j(B,Y,re))}constructor(B,J,re){this.c=B,this.d=J,this.f=re,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$1i=j;class U{static create(B,J,re=null){return N(J,Y=>new U(B,Y,re))}constructor(B,J,re){this.c=B,this.d=J,this.f=re,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$2i=U;class T{static create(B,J){return new T(B,J)}constructor(B,J){this.d=B,this.f=J,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const J=this.f?this.f.source:"",re=B.f?B.f.source:"";return J<re?-1:J>re?1:0}equals(B){if(B.type===this.type){const J=this.f?this.f.source:"",re=B.f?B.f.source:"";return this.d===B.d&&J===re}return!1}substituteConstants(){return this}evaluate(B){const J=B.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$3i=T;class K{static create(B){return new K(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new K(this.c.map(B))}negate(){return this.c}}e.$4i=K;function q(H){let B=null;for(let J=0,re=H.length;J<re;J++){const Y=H[J].substituteConstants();if(H[J]!==Y&&B===null){B=[];for(let _=0;_<J;_++)B[_]=H[_]}B!==null&&(B[J]=Y)}return B===null?H:B}class ge{static create(B,J,re){return ge.d(B,J,re)}constructor(B,J){this.expr=B,this.c=J,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let J=0,re=this.expr.length;J<re;J++){const Y=i(this.expr[J],B.expr[J]);if(Y!==0)return Y}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let J=0,re=this.expr.length;J<re;J++)if(!this.expr[J].equals(B.expr[J]))return!1;return!0}return!1}substituteConstants(){const B=q(this.expr);return B===this.expr?this:ge.create(B,this.c,!1)}evaluate(B){for(let J=0,re=this.expr.length;J<re;J++)if(!this.expr[J].evaluate(B))return!1;return!0}static d(B,J,re){const Y=[];let _=!1;for(const x of B)if(x){if(x.type===1){_=!0;continue}if(x.type===0)return a.INSTANCE;if(x.type===6){Y.push(...x.expr);continue}Y.push(x)}if(Y.length===0&&_)return l.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(i);for(let x=1;x<Y.length;x++)Y[x-1].equals(Y[x])&&(Y.splice(x,1),x--);if(Y.length===1)return Y[0];for(;Y.length>1;){const x=Y[Y.length-1];if(x.type!==9)break;Y.pop();const pe=Y.pop(),ue=Y.length===0,fe=ee.create(x.expr.map(te=>ge.create([te,pe],null,re)),null,ue);fe&&(Y.push(fe),Y.sort(i))}if(Y.length===1)return Y[0];if(re){for(let x=0;x<Y.length;x++)for(let pe=x+1;pe<Y.length;pe++)if(Y[x].negate().equals(Y[pe]))return a.INSTANCE;if(Y.length===1)return Y[0]}return new ge(Y,J)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const J of this.expr)B.push(...J.keys());return B}map(B){return new ge(this.expr.map(J=>J.map(B)),null)}negate(){if(!this.c){const B=[];for(const J of this.expr)B.push(J.negate());this.c=ee.create(B,this,!0)}return this.c}}e.$5i=ge;class ee{static create(B,J,re){return ee.d(B,J,re)}constructor(B,J){this.expr=B,this.c=J,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let J=0,re=this.expr.length;J<re;J++){const Y=i(this.expr[J],B.expr[J]);if(Y!==0)return Y}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let J=0,re=this.expr.length;J<re;J++)if(!this.expr[J].equals(B.expr[J]))return!1;return!0}return!1}substituteConstants(){const B=q(this.expr);return B===this.expr?this:ee.create(B,this.c,!1)}evaluate(B){for(let J=0,re=this.expr.length;J<re;J++)if(this.expr[J].evaluate(B))return!0;return!1}static d(B,J,re){let Y=[],_=!1;if(B){for(let x=0,pe=B.length;x<pe;x++){const ue=B[x];if(ue){if(ue.type===0){_=!0;continue}if(ue.type===1)return l.INSTANCE;if(ue.type===9){Y=Y.concat(ue.expr);continue}Y.push(ue)}}if(Y.length===0&&_)return a.INSTANCE;Y.sort(i)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let x=1;x<Y.length;x++)Y[x-1].equals(Y[x])&&(Y.splice(x,1),x--);if(Y.length===1)return Y[0];if(re){for(let x=0;x<Y.length;x++)for(let pe=x+1;pe<Y.length;pe++)if(Y[x].negate().equals(Y[pe]))return l.INSTANCE;if(Y.length===1)return Y[0]}return new ee(Y,J)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const J of this.expr)B.push(...J.keys());return B}map(B){return new ee(this.expr.map(J=>J.map(B)),null)}negate(){if(!this.c){const B=[];for(const J of this.expr)B.push(J.negate());for(;B.length>1;){const J=B.shift(),re=B.shift(),Y=[];for(const _ of we(J))for(const x of we(re))Y.push(ge.create([_,x],null,!1));B.unshift(ee.create(Y,null,!1))}this.c=ee.create(B,this,!0)}return this.c}}e.$6i=ee;class Q extends D{static{this.d=[]}static all(){return Q.d.values()}constructor(B,J,re){super(B,null),this.f=J,typeof re=="object"?Q.d.push({...re,key:B}):re!==!0&&Q.d.push({key:B,description:re,type:J!=null?typeof J:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return g.create(this.key,B)}}e.$7i=Q,e.$8i=(0,L.$Ph)("contextKeyService");function X(H,B){return H<B?-1:H>B?1:0}function ae(H,B,J,re){return H<J?-1:H>J?1:B<re?-1:B>re?1:0}function ie(H,B){if(H.type===0||B.type===1)return!0;if(H.type===9)return B.type===9?ce(H.expr,B.expr):!1;if(B.type===9){for(const J of B.expr)if(ie(H,J))return!0;return!1}if(H.type===6){if(B.type===6)return ce(B.expr,H.expr);for(const J of H.expr)if(ie(J,B))return!0;return!1}return H.equals(B)}e.$9i=ie;function ce(H,B){let J=0,re=0;for(;J<H.length&&re<B.length;){const Y=H[J].cmp(B[re]);if(Y<0)return!1;Y===0&&J++,re++}return J===H.length}function we(H){return H.type===9?H.expr:[H]}}),define(De[230],Ce([1,0,23,38,191,5,99,12,24]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.ConfirmResult=e.$Dv=e.$Cv=e.$Bv=void 0,e.$Bv=(0,L.$Ph)("dialogService");var v;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(v||(v={}));class R{a(u){return this.d(u,v.Confirmation)}b(u){return this.d(u,v.Prompt)}c(u){return this.d(u,v.Input)}d(u,o){const r=[];switch(o){case v.Confirmation:{const s=u;s.primaryButton?r.push(s.primaryButton):r.push((0,d.localize)(0,null)),s.cancelButton?r.push(s.cancelButton):r.push((0,d.localize)(1,null));break}case v.Prompt:{const s=u;Array.isArray(s.buttons)&&s.buttons.length>0&&r.push(...s.buttons.map(m=>m.label)),s.cancelButton&&(s.cancelButton===!0?r.push((0,d.localize)(2,null)):typeof s.cancelButton=="string"?r.push(s.cancelButton):s.cancelButton.label?r.push(s.cancelButton.label):r.push((0,d.localize)(3,null))),r.length===0&&r.push((0,d.localize)(4,null));break}case v.Input:{const s=u;s.primaryButton?r.push(s.primaryButton):r.push((0,d.localize)(5,null)),s.cancelButton?r.push(s.cancelButton):r.push((0,d.localize)(6,null));break}}return r}e(u){if(typeof u=="string")return u;if(typeof u=="number")return u===F.default.Info?"info":u===F.default.Error?"error":u===F.default.Warning?"warning":"none"}f(u,o,r){const s=[...u.buttons??[]];u.cancelButton&&typeof u.cancelButton!="string"&&typeof u.cancelButton!="boolean"&&s.push(u.cancelButton);let m=s[o]?.run({checkboxChecked:r});return m instanceof Promise||(m=Promise.resolve(m)),{result:m,checkboxChecked:r}}}e.$Cv=R,e.$Dv=(0,L.$Ph)("fileDialogService");var I;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const w=10;function y(p){const u=[];return u.push(...p.slice(0,w).map(o=>typeof o=="string"?o:(0,C.$sg)(o))),p.length>w&&(p.length-w===1?u.push((0,d.localize)(7,null)):u.push((0,d.localize)(8,null,p.length-w))),u.push(""),u.join(`
`)}e.$Ev=y;function k(p,u){const o=(0,E.$7m)(p);let r=(o.buttons??[]).map(t=>(0,A.$yv)(t)),s=(p.buttons||[]).map((t,n)=>n),m=0,h=o.cancelId??r.length-1;if(r.length>1){const t=typeof h=="number"?r[h]:void 0;if($.$l||$.$k){if(typeof t=="string"&&r.length>1&&h!==1){r.splice(h,1),r.splice(1,0,t);const n=s[h];s.splice(h,1),s.splice(1,0,n),h=1}$.$l&&r.length>1&&(r=r.reverse(),s=s.reverse(),m=r.length-1,typeof t=="string"&&(h=m-1))}else if($.$j&&typeof t=="string"&&r.length>1&&h!==r.length-1){r.splice(h,1),r.push(t);const n=s[h];s.splice(h,1),s.push(n),h=r.length-1}}return o.buttons=r,o.defaultId=m,o.cancelId=h,o.noLink=!0,o.title=o.title||u.nameLong,{options:o,buttonIndeces:s}}e.$Fv=k}),define(De[131],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,C.$Ph)("environmentService"),e.$Xh=(0,C.$Qh)(e.$Wh)}),define(De[132],Ce([1,0,192,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$$n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function d(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=d;function L(r){switch(r){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=L;function A(r,s){switch(r){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=A;function $(r,s){return s==="web"&&!r.includes("web")}e.$7n=$;function E(r,s,m){return $(s,m)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===m?!0:v(m).includes(r)}e.$8n=E;function v(r){switch(r){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$9n=v;function R(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$0n=R;var I;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var w;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var y;(function(r){r.Install="install",r.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var k;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(k||(e.InstallOperation=k={})),e.$$n=(0,F.$Ph)("extensionGalleryService");var p;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.Extract="Extract",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var u;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class o extends Error{constructor(s,m){super(s),this.code=m,this.name=m}}e.$_n=o,e.$ao=(0,F.$Ph)("extensionManagementService"),e.$bo="extensionsIdentifiers/disabled",e.$co="extensionsIdentifiers/enabled",e.$do=(0,F.$Ph)("IGlobalExtensionEnablementService"),e.$eo=(0,F.$Ph)("IExtensionTipsService"),e.$fo=(0,C.localize)(0,null),e.$go={value:e.$fo,original:"Extensions"},e.$ho={value:(0,C.localize)(1,null),original:"Preferences"}}),define(De[231],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Xb=e.$7Xb=void 0,e.$7Xb=(0,C.$Ph)("externalTerminal"),e.$8Xb="Terminal.app"}),define(De[232],Ce([1,0,49,18,16,12,98,29,101,194,231]),function($e,e,C,F,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=e.$U6b=e.$T6b=void 0;const I=v.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends w{static{this.b="cmd.exe"}openTerminal(m,h){return this.spawnTerminal(C,m,E.$Bl(),h)}spawnTerminal(m,h,t,n){const c=h.windowsExec||y.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=d.$nc(c,".exe").toLowerCase();if(i==="cmder")return m.spawn(c,n?[n]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return c.indexOf(" ")>=0&&a.push('""'),a.push(c),i==="wt"&&a.push("-d ."),new Promise((l,D)=>{const S=u(process),b=m.spawn(t,a,{cwd:n,env:S});b.on("error",D),b.on("exit",()=>l())})}runInTerminal(m,h,t,n,c){const i="windowsExec"in c&&c.windowsExec?c.windowsExec:y.getDefaultTerminalWindows();return new Promise((a,l)=>{const D=`"${h} - ${I}"`,S=`""${t.join('" "')}" & pause"`,b=Object.assign({},u(process),n);Object.keys(b).filter(O=>b[O]===null).forEach(O=>delete b[O]);const f={cwd:h,env:b,windowsVerbatimArguments:!0};let g,P;d.$nc(i,".exe")==="wt"?(g=i,P=["-d",".",y.b,"/c",S]):(g=y.b,P=["/c","start",D,"/wait",i,"/c",S]),C.spawn(g,P,f).on("error",O=>{l(o(O))}),a(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const m=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${m?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$T6b=y;class k extends w{static{this.b="/usr/bin/osascript"}openTerminal(m,h){return this.spawnTerminal(C,m,h)}runInTerminal(m,h,t,n,c){const i=c.osxExec||R.$8Xb;return new Promise((a,l)=>{if(i===R.$8Xb||i==="iTerm.app"){const D=i===R.$8Xb?"TerminalHelper":"iTermHelper",b=[F.$cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",m||I,"-w",h];for(const P of t)b.push("-a"),b.push(P);if(n){const P=Object.assign({},u(process),n);for(const N in P){const O=P[N];O===null?(b.push("-u"),b.push(N)):(b.push("-e"),b.push(`${N}=${O}`))}}let f="";const g=C.spawn(k.b,b);g.on("error",P=>{l(o(P))}),g.stderr.on("data",P=>{f+=P.toString()}),g.on("exit",P=>{if(P===0)a(void 0);else if(f){const N=f.split(`
`,1);l(new Error(N[0]))}else l(new Error(v.localize(1,null,D,P)))})}else l(new Error(v.localize(2,null,i)))})}spawnTerminal(m,h,t){const n=h.osxExec||R.$8Xb;return new Promise((c,i)=>{const a=["-a",n];t&&a.push(t);const l=u(process),D=m.spawn("/usr/bin/open",a,{cwd:t,env:l});D.on("error",i),D.on("exit",()=>c())})}}e.$U6b=k;class p extends w{static{this.b=v.localize(3,null)}openTerminal(m,h){return this.spawnTerminal(C,m,h)}runInTerminal(m,h,t,n,c){const i=c.linuxExec?Promise.resolve(c.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((a,l)=>{const D=[];i.then(S=>{S.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const b=`${r(t)}; echo; read -p "${p.b}" -n1;`;D.push(`''${b}''`);const f=Object.assign({},u(process),n);Object.keys(f).filter(O=>f[O]===null).forEach(O=>delete f[O]);const g={cwd:h,env:f};let P="";const N=C.spawn(S,D,g);N.on("error",O=>{l(o(O))}),N.stderr.on("data",O=>{P+=O.toString()}),N.on("exit",O=>{if(O===0)a(void 0);else if(P){const M=P.split(`
`,1);l(new Error(M[0]))}else l(new Error(v.localize(4,null,S,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!L.$l)p.d=Promise.resolve("xterm");else{const m=await $.Promises.exists("/etc/debian_version");p.d=new Promise(h=>{m?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return p.d}spawnTerminal(m,h,t){const n=h.linuxExec?Promise.resolve(h.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((c,i)=>{n.then(a=>{const l=u(process),D=m.spawn(a,[],{cwd:t,env:l});D.on("error",i),D.on("exit",()=>c())})})}}e.$V6b=p;function u(s){const m={...s.env};return(0,A.$zl)(m),m}function o(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(v.localize(5,null,s.path)):s}function r(s){let m="";for(const h of s)h.indexOf(" ")>=0?m+='"'+h+'"':m+=h,m+=" ";return m}}),define(De[30],Ce([1,0,78,16,15,17,2,195,5,12,18,47]),function($e,e,C,F,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,E.$Ph)("fileService");function w(ie){return ie.create===!0}e.$_j=w;var y;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var k;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function p(ie){const ce=ie;return!!ce&&typeof ce.onDidChange=="function"}e.$ak=p;var u;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function o(ie){return!!(ie.capabilities&2)}e.$bk=o;function r(ie){return!!(ie.capabilities&8)}e.$ck=r;function s(ie){return!!(ie.capabilities&131072)}e.$dk=s;function m(ie){return!!(ie.capabilities&4)}e.$ek=m;function h(ie){return!!(ie.capabilities&16)}e.$fk=h;function t(ie){return o(ie)?!!(ie.capabilities&16384):!1}e.$gk=t;function n(ie){return o(ie)?!!(ie.capabilities&32768):!1}e.$hk=n;function c(ie){return!!(ie.capabilities&65536)}e.$ik=c;function i(ie){return!!(ie.capabilities&2048)}e.$jk=i;var a;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class l extends Error{static create(ce,we){const H=new l(ce.toString(),we);return b(H,we),H}constructor(ce,we){super(ce),this.code=we}}e.$kk=l;function D(ie,ce){return l.create(ie,ce)}e.$lk=D;function S(ie){return ie||D((0,$.localize)(0,null),a.Unknown)}e.$mk=S;function b(ie,ce){return ie.name=ce?`${ce} (FileSystemError)`:"FileSystemError",ie}e.$nk=b;function f(ie){if(!ie)return a.Unknown;if(ie instanceof l)return ie.code;const ce=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!ce)return a.Unknown;switch(ce[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$ok=f;function g(ie){if(ie instanceof U)return ie.fileOperationResult;switch(f(ie)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$pk=g;var P;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class N{constructor(ce,we,H){this.resource=ce,this.operation=we,this.target=H}isOperation(ce){return this.operation===ce}}e.$qk=N;var O;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class M{static{this.a=null}constructor(ce,we){this.c=we,this.b=void 0,this.d=new I.$V(()=>{const H=C.$Vh.forUris(()=>this.c);return H.fill(this.rawAdded.map(B=>[B,!0])),H}),this.f=new I.$V(()=>{const H=C.$Vh.forUris(()=>this.c);return H.fill(this.rawUpdated.map(B=>[B,!0])),H}),this.g=new I.$V(()=>{const H=C.$Vh.forUris(()=>this.c);return H.fill(this.rawDeleted.map(B=>[B,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of ce){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==M.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ce,...we){return this.h(ce,{includeChildren:!1},...we)}affects(ce,...we){return this.h(ce,{includeChildren:!0},...we)}h(ce,we,...H){if(!ce)return!1;const B=H.length>0;return!!((!B||H.includes(1))&&(this.d.value.get(ce)||we.includeChildren&&this.d.value.findSuperstr(ce))||(!B||H.includes(0))&&(this.f.value.get(ce)||we.includeChildren&&this.f.value.findSuperstr(ce))||(!B||H.includes(2))&&(this.g.value.findSubstr(ce)||we.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$rk=M;function j(ie,ce,we){return!ie||!ce||ie===ce||ce.length>ie.length?!1:(ce.charAt(ce.length-1)!==F.sep&&(ce+=F.sep),we?(0,d.$3e)(ie,ce):ie.indexOf(ce)===0)}e.$sk=j;class U extends Error{constructor(ce,we,H){super(ce),this.fileOperationResult=we,this.options=H}}e.$tk=U;class T extends U{constructor(ce,we,H,B){super(ce,we,B),this.fileOperationResult=we,this.size=H}}e.$uk=T;class K extends U{constructor(ce,we,H){super(ce,2,H),this.stat=we}}e.$vk=K;var q;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(q||(e.FileOperationResult=q={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var ge;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(ge||(e.FileKind=ge={})),e.$Dk="";function ee(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$Ek=ee;async function Q(ie,ce){if(!ce.hasProvider(A.URI.from({scheme:ie.scheme})))return new Promise(we=>{const H=ce.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ie.scheme&&B.added&&(H.dispose(),we())})})}e.$Fk=Q;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(ce){return(0,L.$Cf)(ce)||(ce=0),ce<X.KB?(0,$.localize)(1,null,ce.toFixed(0)):ce<X.MB?(0,$.localize)(2,null,(ce/X.KB).toFixed(2)):ce<X.GB?(0,$.localize)(3,null,(ce/X.MB).toFixed(2)):ce<X.TB?(0,$.localize)(4,null,(ce/X.GB).toFixed(2)):(0,$.localize)(5,null,(ce/X.TB).toFixed(2))}}e.$Gk=X;function ae(ie){const ce=typeof ie=="string"||ie?.scheme===R.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===R.Schemas.file?1024*X.MB:ce?10*X.MB:v.$p?50*X.MB:1024*X.MB}e.$Hk=ae}),define(De[233],Ce([1,0,22,9,196,30]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;async function A(R,I,w,y,k,p){let u;try{await $(R,I,w,y,k,p)}catch(o){u=o}finally{u&&k.errorTransformer&&(u=k.errorTransformer(u)),typeof u<"u"&&w.error(u),w.end()}}e.$Np=A;async function $(R,I,w,y,k,p){E(p);const u=await R.open(I,{create:!1});try{E(p);let o=0,r=0,s=k&&typeof k.length=="number"?k.length:void 0,m=C.$be.alloc(Math.min(k.bufferSize,typeof s=="number"?s:k.bufferSize)),h=k&&typeof k.position=="number"?k.position:0,t=0;do r=await R.read(u,h,m.buffer,t,m.byteLength-t),h+=r,t+=r,o+=r,typeof s=="number"&&(s-=r),t===m.byteLength&&(await w.write(y(m)),m=C.$be.alloc(Math.min(k.bufferSize,typeof s=="number"?s:k.bufferSize)),t=0);while(r>0&&(typeof s!="number"||s>0)&&E(p)&&v(o,k));if(t>0){let n=t;typeof s=="number"&&(n=Math.min(t,s)),w.write(y(m.slice(0,n)))}}catch(o){throw(0,L.$mk)(o)}finally{await R.close(u)}}function E(R){if(R.isCancellationRequested)throw(0,F.$6)();return!0}function v(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,L.$lk)((0,d.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[84],Ce([1,0,35,3,16,12,2,30]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=e.$Qp=e.$Pp=void 0;function E(o){return o.recursive===!0}e.$Pp=E;class v extends F.$Sc{static{this.a=5}constructor(r,s,m,h){super(),this.h=r,this.j=s,this.m=m,this.n=h,this.c=this.B(new F.$Tc),this.f=void 0,this.g=0}s(){const r=new F.$Rc;this.c.value=r,this.b=this.r(r),this.b.setVerboseLogging(this.m),r.add(this.b.onDidChangeFile(s=>this.h(s))),r.add(this.b.onDidLogMessage(s=>this.j(s))),r.add(this.b.onDidError(s=>this.t(s)))}t(r){this.n.restartOnError?this.g<v.a&&this.f?(this.w(`restarting watcher after error: ${r}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${r}`):this.w(r)}u(r){this.g++,this.s(),this.watch(r)}async watch(r){this.f=r,await this.b?.watch(r)}async setVerboseLogging(r){this.m=r,await this.b?.setVerboseLogging(r)}w(r){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${r}`})}y(r){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${r}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Qp=v;class R extends v{constructor(r,s,m){super(r,s,m,{type:"node.js",restartOnError:!1})}}e.$Rp=R;class I extends v{constructor(r,s,m){super(r,s,m,{type:"universal",restartOnError:!0})}}e.$Sp=I;function w(o){return o.map(r=>({type:r.type,resource:A.URI.revive(r.resource),cId:r.cId}))}e.$Tp=w;function y(o){const r=new u;for(const s of o)r.processEvent(s);return r.coalesce()}e.$Up=y;function k(o,r){return typeof r=="string"&&!r.startsWith(C.$sj)&&!(0,d.$ic)(r)?{base:o,pattern:r}:r}e.$Vp=k;function p(o,r){const s=[];for(const m of r)s.push((0,C.$wj)(k(o,m)));return s}e.$Wp=p;class u{constructor(){this.a=new Set,this.b=new Map}c(r){return L.$l?r.resource.fsPath:r.resource.fsPath.toLowerCase()}processEvent(r){const s=this.b.get(this.c(r));let m=!1;if(s){const h=s.type,t=r.type;s.resource.fsPath!==r.resource.fsPath&&(r.type===2||r.type===1)?m=!0:h===1&&t===2?(this.b.delete(this.c(r)),this.a.delete(s)):h===2&&t===1?s.type=0:h===1&&t===0||(s.type=t)}else m=!0;m&&(this.a.add(r),this.b.set(this.c(r),r))}coalesce(){const r=[],s=[];return Array.from(this.a).filter(m=>m.type!==2?(r.push(m),!1):!0).sort((m,h)=>m.resource.fsPath.length-h.resource.fsPath.length).filter(m=>s.some(h=>(0,$.$sk)(m.resource.fsPath,h,!L.$l))?!1:(s.push(m.resource.fsPath),!0)).concat(r)}}}),define(De[234],Ce([1,0,53,8,21,33,3,77,16,12,23,2,100,29,84]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class p extends A.$Sc{static{this.a=100}static{this.b=75}constructor(r,s,m,h){super(),this.m=r,this.n=s,this.r=m,this.s=h,this.c=this.B(new F.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$8g(t=>this.z(t),p.b)),this.g=(0,k.$Wp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$Wp)(this.m.path,this.m.includes):void 0,this.j=new d.$Xd,this.ready=this.t()}async t(){try{const r=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const s=await y.Promises.stat(r);this.B(await this.w(r,s.isDirectory()))}catch(r){r.code!=="ENOENT"?this.D(r):this.G(r)}}async u(r){let s=r.path;try{s=await y.Promises.realpath(r.path),r.path===s&&(s=await(0,w.$7p)(r.path)??r.path),r.path!==s&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${s})`)}catch{}return s}async w(r,s){if(v.$k&&(0,L.$Xf)(r,"/Volumes/",!0))return this.D(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Sc.None;const m=new d.$Xd(this.j.token),h=new A.$Rc;try{const t=I.URI.file(this.m.path),n=(0,E.$nc)(r),c=(0,C.watch)(r);h.add((0,A.$Qc)(()=>{c.removeAllListeners(),c.close()})),this.G(`Started watching: '${r}'`);const i=new Set;if(s)try{for(const l of await y.Promises.readdir(r))i.add(l)}catch(l){this.D(l)}const a=new Map;h.add((0,A.$Qc)(()=>{for(const[,l]of a)l.dispose();a.clear()})),c.on("error",(l,D)=>{this.D(`Failed to watch ${r} for changes using fs.watch() (${l}, ${D})`),this.dispose()}),c.on("change",(l,D)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${D}`);let S="";if(D&&(S=D.toString(),v.$k&&(S=(0,$.$ol)(S))),!(!S||l!=="change"&&l!=="rename"))if(s)if(l==="rename"){a.get(S)?.dispose();const b=setTimeout(async()=>{if(a.delete(S),S===n&&!await y.Promises.exists(r)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,E.$jc)(r,S));if(m.token.isCancellationRequested)return;let g;f?i.has(S)?g=0:(g=1,i.add(S)):(i.delete(S),g=2),this.y({resource:(0,R.$vg)(t,S),type:g,cId:this.m.correlationId})},p.a);a.set(S,(0,A.$Qc)(()=>clearTimeout(b)))}else{let b;i.has(S)?b=0:(b=1,i.add(S)),this.y({resource:(0,R.$vg)(t,S),type:b,cId:this.m.correlationId})}else if(l==="rename"||S!==n){const b=setTimeout(async()=>{const f=await y.Promises.exists(r);m.token.isCancellationRequested||(f?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),h.add(await this.w(r,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);h.clear(),h.add((0,A.$Qc)(()=>clearTimeout(b)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(r)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${r} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Qc)(()=>{m.dispose(!0),h.dispose()})}y(r,s=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`),!s&&this.g.some(m=>m(r.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${r.resource.fsPath}`):!s&&this.h&&this.h.length>0&&!this.h.some(m=>m(r.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${r.resource.fsPath}`):this.f.work(r))}z(r){const s=(0,k.$Up)(r);if(s.length>0){if(this.s)for(const h of s)this.G(` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(r){if(v.$l)return y.Promises.exists(r);try{const s=(0,E.$nc)(r);return(await y.Promises.readdir((0,E.$mc)(r))).some(h=>h===s)}catch(s){return this.G(s),!1}}setVerboseLogging(r){this.s=r}D(r){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}F(r){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}G(r){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$0p=p;async function u(o,r,s,m,h=512){const t=await y.Promises.open(o,"r"),n=Buffer.allocUnsafe(h),c=new d.$Xd(m);let i,a=!1;const l={path:o,excludes:[],recursive:!1},D=new p(l,S=>{(async()=>{for(const{type:b}of S)if(b===0){if(a)return;a=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:f}=await y.Promises.read(t,n,0,h,null);if(!f||c.token.isCancellationRequested)break;r(n.slice(0,f))}}catch(f){i=new Error(f),c.dispose(!0)}finally{a=!1}}})()});return await D.ready,s(),new Promise((S,b)=>{c.token.onCancellationRequested(async()=>{D.dispose();try{await y.Promises.close(t)}catch(f){i=new Error(f)}i?b(i):S()})})}e.$$p=u}),define(De[235],Ce([1,0,4,35,3,12,234]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class $ extends d.$Sc{constructor(){super(...arguments),this.a=this.B(new C.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(v){const R=this.j(v),I=R.filter(y=>{const k=this.c.get(y.path);return k?!(0,F.$Aj)(k.request.excludes,y.excludes)||!(0,F.$Aj)(k.request.includes,y.includes):!0}),w=Array.from(this.c.values()).filter(({request:y})=>!R.find(k=>k.path===y.path&&(0,F.$Aj)(k.excludes,y.excludes)&&(0,F.$Aj)(k.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.m(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const y of w)this.h(y);for(const y of I)this.g(y)}g(v){const R=new A.$0p(v,w=>this.a.fire(w),w=>this.b.fire(w),this.f),I={request:v,instance:R};this.c.set(v.path,I)}async stop(){for(const[v]of this.c)this.h(v);this.c.clear()}h(v){const R=this.c.get(v);R&&(this.c.delete(v),R.instance.dispose())}j(v){const R=new Map;for(const I of v){const w=L.$l?I.path:I.path.toLowerCase();let y=R.get(I.correlationId);y||(y=new Map,R.set(I.correlationId,y)),y.set(w,I)}return Array.from(R.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(v){this.f=v;for(const[,R]of this.c)R.instance.setVerboseLogging(v)}m(v){this.f&&this.b.fire({type:"trace",message:this.n(v)})}n(v,R){return R?`[File Watcher (node.js)] ${v} (path: ${R.request.path})`:`[File Watcher (node.js)] ${v}`}}e.$_p=$}),define(De[236],Ce([1,0,84,235]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;class d extends C.$Rp{constructor(A,$,E){super(A,$,E),this.s()}r(A){return A.add(new F.$_p)}}e.$aq=d}),define(De[237],Ce([1,0,18,81,183,84]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;class A extends L.$Sp{constructor(E,v,R){super(E,v,R),this.s()}r(E){const v=E.add(new d.$4p(C.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(v.onDidProcessExit(({code:R,signal:I})=>this.t(`terminated by itself with code ${R}, signal: ${I}`))),F.ProxyChannel.toService((0,F.$wh)(v.getChannel("watcher")))}}e.$5p=A}),define(De[104],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class C{constructor(...d){this.a=new Map;for(const[L,A]of d)this.set(L,A)}set(d,L){const A=this.a.get(d);return this.a.set(d,L),A}has(d){return this.a.has(d)}get(d){return this.a.get(d)}}e.$Nh=C}),define(De[238],Ce([1,0,8,9,3,102,229,5,104,76]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;const R=!1;class I extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class w{constructor(u=new E.$Nh,o=!1,r,s=R){this.f=u,this.g=o,this.h=r,this.i=s,this.o=new Set,this.f.set($.$Oh,this),this._globalGraph=s?r?._globalGraph??new A.$dq(m=>m):void 0}createChild(u){return new w(u,this.g,this,this.i)}invokeFunction(u,...o){const r=k.traceInvocation(this.i,u);let s=!1;try{return u({get:h=>{if(s)throw(0,F.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,r);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...o)}finally{s=!0,r.stop()}}createInstance(u,...o){let r,s;return u instanceof L.$Mh?(r=k.traceCreation(this.i,u.ctor),s=this.j(u.ctor,u.staticArguments.concat(o),r)):(r=k.traceCreation(this.i,u),s=this.j(u,o,r)),r.stop(),s}j(u,o=[],r){const s=$._util.getServiceDependencies(u).sort((t,n)=>t.index-n.index),m=[];for(const t of s){const n=this.m(t.id,r);n||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(n)}const h=s.length>0?s[0].index:o.length;if(o.length!==h){console.trace(`[createInstance] First service dependency of ${u.name} at position ${h+1} conflicts with ${o.length} static arguments`);const t=h-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,h)}return Reflect.construct(u,o.concat(m))}k(u,o){if(this.f.get(u)instanceof L.$Mh)this.f.set(u,o);else if(this.h)this.h.k(u,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const o=this.f.get(u);return!o&&this.h?this.h.l(u):o}m(u,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const r=this.l(u);return r instanceof L.$Mh?this.q(u,r,o.branch(u,!0)):(o.branch(u,!1),r)}q(u,o,r){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,o,r)}finally{this.o.delete(u)}}r(u,o,r){const s=new A.$dq(t=>t.id.toString());let m=0;const h=[{id:u,desc:o,_trace:r}];for(;h.length;){const t=h.pop();if(s.lookupOrInsertNode(t),m++>1e3)throw new I(s);for(const n of $._util.getServiceDependencies(t.desc.ctor)){const c=this.l(n.id);if(c||this.u(`[createInstance] ${u} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),c instanceof L.$Mh){const i={id:n.id,desc:c,_trace:t._trace.branch(n.id,!0)};s.insertEdge(t,i),h.push(i)}}}for(;;){const t=s.roots();if(t.length===0){if(!s.isEmpty())throw new I(s);break}for(const{data:n}of t){if(this.l(n.id)instanceof L.$Mh){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}s.removeNode(n)}}return this.l(u)}s(u,o,r=[],s,m){if(this.f.get(u)instanceof L.$Mh)return this.t(u,o,r,s,m);if(this.h)return this.h.s(u,o,r,s,m);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(u,o,r=[],s,m){if(s){const h=new w(void 0,this.g,this,this.i);h.c=String(u);const t=new Map,n=new C.$$g(()=>{const c=h.j(o,r,m);for(const[i,a]of t){const l=c[i];if(typeof l=="function")for(const D of a)l.apply(c,D)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let D=t.get(i);return D||(D=new v.$2c,t.set(i,D)),(b,f,g)=>{const P=D.push([b,f,g]);return(0,d.$Qc)(P)}}if(i in c)return c[i];const a=n.value;let l=a[i];return typeof l!="function"||(l=l.bind(a),c[i]=l),l},set(c,i,a){return n.value[i]=a,!0},getPrototypeOf(c){return o.prototype}})}else return this.j(o,r,m)}u(u,o){if(o&&console.warn(u),this.g)throw new Error(u)}}e.$eq=w;var y;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(y||(y={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(u,o){return u?new k(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(u,o){return u?new k(1,o.name):k.c}static{this.f=0}constructor(u,o){this.type=u,this.name=o,this.g=Date.now(),this.h=[]}branch(u,o){const r=new k(3,u.toString());return this.h.push([u,o,r]),r}stop(){const u=Date.now()-this.g;k.f+=u;let o=!1;function r(m,h){const t=[],n=new Array(m+1).join("	");for(const[c,i,a]of h.h)if(i&&a){o=!0,t.push(`${n}CREATES -> ${c}`);const l=r(m+1,a);l&&t.push(l)}else t.push(`${n}uses -> ${c}`);return t.join(`
`)}const s=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(u>2||o)&&k.all.add(s.join(`
`))}}e.$fq=k}),define(De[14],Ce([1,0,41,4,52,3,28,12,23,17,2,42,5]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,w.$Ph)("logService"),e.$$i=(0,w.$Ph)("loggerService");function y(){return new Date().toISOString()}function k(b){return(0,v.$Cf)(b)}e.$_i=k;var p;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$aj=p.Info;function u(b,f,g){switch(f){case p.Trace:b.trace(g);break;case p.Debug:b.debug(g);break;case p.Info:b.info(g);break;case p.Warning:b.warn(g);break;case p.Error:b.error(g);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=u;function o(b,f=!1){let g="";for(let P=0;P<b.length;P++){let N=b[P];if(N instanceof Error&&(N=(0,C.$Ai)(N,f)),typeof N=="object")try{N=JSON.stringify(N)}catch{}g+=(P>0?" ":"")+N}return g}class r extends L.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new F.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$cj=r;class s extends r{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...g){this.f(p.Trace)&&this.g(p.Trace,o([f,...g],!0))}debug(f,...g){this.f(p.Debug)&&this.g(p.Debug,o([f,...g]))}info(f,...g){this.f(p.Info)&&this.g(p.Info,o([f,...g]))}warn(f,...g){this.f(p.Warning)&&this.g(p.Warning,o([f,...g]))}error(f,...g){if(this.f(p.Error))if(f instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=f.stack,this.g(p.Error,o(P))}else this.g(p.Error,o([f,...g]))}flush(){}}e.$dj=s;class m extends r{constructor(f=e.$aj){super(),this.setLevel(f),this.g=!$.$j}trace(f,...g){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...g):console.log(`[main ${y()}]`,f,...g))}debug(f,...g){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...g):console.log(`[main ${y()}]`,f,...g))}info(f,...g){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...g):console.log(`[main ${y()}]`,f,...g))}warn(f,...g){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,f,...g):console.warn(`[main ${y()}]`,f,...g))}error(f,...g){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,f,...g):console.error(`[main ${y()}]`,f,...g))}dispose(){}flush(){}}e.$ej=m;class h extends r{constructor(f=e.$aj,g=!0){super(),this.g=g,this.setLevel(f)}trace(f,...g){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...g):console.log(f,...g))}debug(f,...g){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...g):console.log(f,...g))}info(f,...g){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...g):console.log(f,...g))}warn(f,...g){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...g):console.log(f,...g))}error(f,...g){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...g):console.error(f,...g))}dispose(){}flush(){}}e.$fj=h;class t extends r{constructor(f,g=e.$aj){super(),this.g=f,this.setLevel(g)}trace(f,...g){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...g])}debug(f,...g){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...g])}info(f,...g){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...g])}warn(f,...g){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...g])}error(f,...g){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...g])}h(f){return typeof f=="string"?f:(0,C.$Ai)(f,this.f(p.Trace))}dispose(){}flush(){}}e.$gj=t;class n extends r{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const g of this.g)g.setLevel(f);super.setLevel(f)}trace(f,...g){for(const P of this.g)P.trace(f,...g)}debug(f,...g){for(const P of this.g)P.debug(f,...g)}info(f,...g){for(const P of this.g)P.info(f,...g)}warn(f,...g){for(const P of this.g)P.warn(f,...g)}error(f,...g){for(const P of this.g)P.error(f,...g)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$hj=n;class c extends L.$Sc{constructor(f,g,P){if(super(),this.h=f,this.j=g,this.b=new A.$Ac,this.c=this.B(new F.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Nd),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(f){return(0,v.$yf)(f)?[...this.b.values()].find(g=>g.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,g){const P=this.n(f),N=(0,v.$yf)(f)?f:g?.id??(0,d.$Di)(P.toString()).toString(16);let O=this.b.get(P)?.logger;const M=g?.logLevel==="always"?p.Trace:g?.logLevel;O||(O=this.s(P,M??this.getLogLevel(P)??this.h,{...g,id:N}));const j={logger:O,info:{resource:P,id:N,logLevel:M,name:g?.name,hidden:g?.hidden,extensionId:g?.extensionId,when:g?.when}};return this.registerLogger(j.info),this.b.set(P,j),O}n(f){return(0,v.$yf)(f)?(0,E.$vg)(this.j,`${f}.log`):f}setLogLevel(f,g){if(R.URI.isUri(f)){const P=f,N=g,O=this.b.get(P);O&&N!==O.info.logLevel&&(O.info.logLevel=N===this.h?void 0:N,O.logger?.setLevel(N),this.b.set(O.info.resource,O),this.f.fire([P,N]))}else{this.h=f;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,g){const P=this.m(f);P&&g!==!P.info.hidden&&(P.info.hidden=!g,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,g]))}getLogLevel(f){let g;return f&&(g=this.b.get(f)?.info.logLevel),g??this.h}registerLogger(f){const g=this.b.get(f.resource);g?g.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const g=this.b.get(f);g&&(g.logger&&g.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[g.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=c;class i{constructor(){this.onDidChangeLogLevel=new F.$Nd().event}setLevel(f){}getLevel(){return p.Info}trace(f,...g){}debug(f,...g){}info(f,...g){}warn(f,...g){}error(f,...g){}critical(f,...g){}dispose(){}flush(){}}e.$jj=i;class a extends i{}e.$kj=a;function l(b){if(b.verbose)return p.Trace;if(typeof b.logLevel=="string"){const f=S(b.logLevel.toLowerCase());if(f!==void 0)return f}return e.$aj}e.$lj=l;function D(b){switch(b){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$mj=D;function S(b){switch(b){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$nj=S,e.$oj=new I.$7i("logLevel",D(p.Info))}),define(De[239],Ce([1,0,19,8,9,4,3,16,84,14]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class R extends A.$Sc{constructor(w,y){super(),this.a=w,this.b=y,this.c=this.B(new L.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Rg(0)),this.w=[],this.y=this.B(new F.$Rg(0))}watch(w,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(w,y):this.z(w,y)}n(w,y){const k={path:this.H(w),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},p=(0,C.$Ub)(this.j,k);return this.r(),(0,A.$Qc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,d.$1)(w))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Tp)(y)),y=>this.G(y),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const y of this.j)(0,E.$Pp)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const y of this.j)(0,E.$Pp)(y)&&w.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,y){const k={path:this.H(w),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},p=(0,C.$Ub)(this.w,k);return this.C(),(0,A.$Qc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,d.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,E.$Tp)(w)),w=>this.G(w),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,$.$hc)(w.fsPath)}}e.$Xp=R}),define(De[240],Ce([1,0,53,375,8,28,22,4,33,3,16,12,23,96,29,197,30,233,239,41,237,236]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0,(()=>{try{(0,F.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,s.$Ai)(n)}`)}})();class t extends r.$Xp{static{this.I=!1}constructor(c,i){super(c,i),this.onDidChangeCapabilities=$.Event.None,this.N=new L.$Ac(a=>w.$mg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$l&&(this.J|=1024)),this.J}async stat(c){try{const{stat:i,symbolicLink:a}=await k.SymlinkSupport.stat(this.H(c));return{type:this.M(i,a),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:u.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(c){try{return await this.stat(c)}catch{return}}async readdir(c){try{const i=await k.Promises.readdir(this.H(c),{withFileTypes:!0}),a=[];return await Promise.all(i.map(async l=>{try{let D;l.isSymbolicLink()?D=(await this.stat((0,w.$vg)(c,l.name))).type:D=this.M(l),a.push([l.name,D])}catch(D){this.a.trace(D)}})),a}catch(i){throw this.fb(i)}}M(c,i){let a;return i?.dangling?a=u.FileType.Unknown:c.isFile()?a=u.FileType.File:c.isDirectory()?a=u.FileType.Directory:a=u.FileType.Unknown,i&&(a|=u.FileType.SymbolicLink),a}async O(c){const i=this.H(c);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let a;for(;a=this.N.get(c);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await a.wait();const l=new d.$Sg;return this.N.set(c,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,v.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(c)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(c)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(c,i){let a;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(c)})`),a=await this.O(c));const l=this.H(c);return await k.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{a?.dispose()}}P(c){t.I&&this.a.trace(c)}readFileStream(c,i,a){const l=(0,y.$2d)(D=>A.$be.concat(D.map(S=>A.$be.wrap(S))).buffer);return(0,o.$Np)(this,c,l,D=>D.buffer,{...i,bufferSize:256*1024},a),l}async writeFile(c,i,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(c)?this.R(c,(0,w.$vg)((0,w.$ug)(c),`${(0,w.$sg)(c)}${a.atomic.postfix}`),i,a):this.S(c,i,a)}async Q(c){try{const i=this.H(c),{symbolicLink:a}=await k.SymlinkSupport.stat(i);if(a)return!1}catch{}return!0}async R(c,i,a,l){const D=new v.$Rc;try{D.add(await this.O(c)),D.add(await this.O(i)),await this.S(i,a,l,!0);try{await this.rename(i,c,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{D.dispose()}}async S(c,i,a,l){let D;try{const S=this.H(c);if(!a.create||!a.overwrite){if(await k.Promises.exists(S)){if(!a.overwrite)throw(0,u.$lk)((0,p.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,u.$lk)((0,p.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}D=await this.open(c,{create:!0,unlock:a.unlock},l),await this.write(D,0,i,0,i.byteLength)}catch(S){throw await this.gb(c,S)}finally{typeof D=="number"&&await this.close(D)}}static{this.Y=!0}static configureFlushOnWrite(c){t.Y=c}async open(c,i,a){const l=this.H(c);let D;(0,u.$_j)(i)&&!a&&(D=await this.O(c));let S;try{if((0,u.$_j)(i)&&i.unlock)try{const{stat:f}=await k.SymlinkSupport.stat(l);f.mode&128||await k.Promises.chmod(l,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let b;if((0,u.$_j)(i)){if(I.$j)try{await k.Promises.truncate(l,0),b="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}b||(b="w")}else b="r";S=await k.Promises.open(l,b)}catch(b){throw D?.dispose(),(0,u.$_j)(i)?await this.gb(c,b):this.fb(b)}if(this.U.set(S,0),(0,u.$_j)(i)&&this.X.set(S,c),D){const b=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${l})`),this.W.set(S,D),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${l})`),b.dispose())}return S}async close(c){const i=this.W.get(c);try{if(this.U.delete(c),this.X.delete(c)&&t.Y)try{await k.Promises.fdatasync(c)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await k.Promises.close(c)}catch(a){throw this.fb(a)}finally{i&&(this.W.get(c)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${c}`),this.W.delete(c)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${c}`),i.dispose())}}async read(c,i,a,l,D){const S=this.Z(c,i);let b=null;try{b=(await k.Promises.read(c,a,l,D,S)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(c,S,b)}return b}Z(c,i){return i===this.U.get(c)?null:i}$(c,i,a){const l=this.U.get(c);typeof l=="number"&&(typeof i=="number"||(typeof a=="number"?this.U.set(c,l+a):this.U.delete(c)))}async write(c,i,a,l,D){return(0,d.$_g)(()=>this.ab(c,i,a,l,D),100,3)}async ab(c,i,a,l,D){const S=this.Z(c,i);let b=null;try{b=(await k.Promises.write(c,a,l,D,S)).bytesWritten}catch(f){throw await this.gb(this.X.get(c),f)}finally{this.$(c,S,b)}return b}async mkdir(c){try{await k.Promises.mkdir(this.H(c))}catch(i){throw this.fb(i)}}async delete(c,i){try{const a=this.H(c);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,R.$jc)((0,R.$mc)(a),`${(0,R.$nc)(a)}${i.atomic.postfix}`)),await k.Promises.rm(a,k.RimRafMode.MOVE,l)}else try{await k.Promises.unlink(a)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let D=!1;try{const{stat:S,symbolicLink:b}=await k.SymlinkSupport.stat(a);D=S.isDirectory()&&!b}catch{}if(D)await k.Promises.rmdir(a);else throw l}else throw l}}catch(a){throw this.fb(a)}}async rename(c,i,a){const l=this.H(c),D=this.H(i);if(l!==D)try{await this.bb(c,i,"move",a.overwrite),await k.Promises.rename(l,D)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(2,null,(0,R.$nc)(l),(0,R.$nc)((0,R.$mc)(D)),S.toString()))),this.fb(S)}}async copy(c,i,a){const l=this.H(c),D=this.H(i);if(l!==D)try{await this.bb(c,i,"copy",a.overwrite),await k.Promises.copy(l,D,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(3,null,(0,R.$nc)(l),(0,R.$nc)((0,R.$mc)(D)),S.toString()))),this.fb(S)}}async bb(c,i,a,l){const D=this.H(c),S=this.H(i);let b=!1;if(!!(this.capabilities&1024)||(b=(0,E.$Wf)(D,S,!0)),b){if(a==="copy")throw(0,u.$lk)((0,p.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const g=await this.L(c);if(!g)throw(0,u.$lk)((0,p.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(i);if(P){if(!l)throw(0,u.$lk)((0,p.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);g.type&u.FileType.File&&P.type&u.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(c,i){return this.cb(c,i,!1)}async cb(c,i,a){const l=this.H(c),D=this.H(i),S=!!(this.capabilities&1024);if((0,E.$Wf)(l,D,!S))return;const b=new v.$Rc;try{b.add(await this.O(c)),b.add(await this.O(i)),a&&await k.Promises.mkdir((0,R.$mc)(D),{recursive:!0}),await k.Promises.copyFile(l,D)}catch(f){if(f.code==="ENOENT"&&!a)return this.cb(c,i,!0);throw this.fb(f)}finally{b.dispose()}}t(c,i,a){return new m.$5p(l=>c(l),l=>i(l),a)}F(c,i,a){return new h.$aq(l=>c(l),l=>i(l),a)}fb(c){if(c instanceof u.$kk)return c;let i=c,a;switch(c.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=u.FileSystemProviderErrorCode.Unknown;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.$lk)(i,a)}async gb(c,i){let a=this.fb(i);if(c&&a.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await k.SymlinkSupport.stat(this.H(c));l.mode&128||(a=(0,u.$lk)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return a}}e.$bq=t}),define(De[241],Ce([1,0,3,14]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;class d extends C.$Sc{constructor(A,$=[]){super(),this.a=new F.$hj([A,...$]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...$){this.a.trace(A,...$)}debug(A,...$){this.a.debug(A,...$)}info(A,...$){this.a.info(A,...$)}warn(A,...$){this.a.warn(A,...$)}error(A,...$){this.a.error(A,...$)}flush(){this.a.flush()}}e.$EN=d}),define(De[242],Ce([1,0,30,14]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=void 0;var d;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(d||(d={}));async function L(v,R,I,w,y){try{const k=await new Promise((u,o)=>{$e(["@vscode/spdlog"],u,o)});k.setFlushOn(d.Trace);const p=await k.createAsyncRotatingLogger(v,R,I,w);return y?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(k){console.error(k)}return null}function A(v,R,I){switch(R){case F.LogLevel.Trace:v.trace(I);break;case F.LogLevel.Debug:v.debug(I);break;case F.LogLevel.Info:v.info(I);break;case F.LogLevel.Warning:v.warn(I);break;case F.LogLevel.Error:v.error(I);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function $(v,R){switch(R){case F.LogLevel.Trace:v.setLevel(d.Trace);break;case F.LogLevel.Debug:v.setLevel(d.Debug);break;case F.LogLevel.Info:v.setLevel(d.Info);break;case F.LogLevel.Warning:v.setLevel(d.Warning);break;case F.LogLevel.Error:v.setLevel(d.Error);break;case F.LogLevel.Off:v.setLevel(d.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class E extends F.$dj{constructor(R,I,w,y,k){super(),this.m=[],this.setLevel(k),this.n=this.s(R,I,w,y),this.B(this.onDidChangeLogLevel(p=>{this.r&&$(this.r,p)}))}async s(R,I,w,y){const k=w?6:1,p=30/k*C.$Gk.MB,u=await L(R,I,p,k,y);if(u){this.r=u,$(this.r,this.getLevel());for(const{level:o,message:r}of this.m)A(this.r,o,r);this.m=[]}}g(R,I){this.r?A(this.r,R,I):this.getLevel()<=R&&this.m.push({level:R,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$tN=E}),define(De[133],Ce([1,0,38,198,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function v(k,p){return p-k}E.compare=v;const R=Object.create(null);R[E.Error]=(0,F.localize)(0,null),R[E.Warning]=(0,F.localize)(1,null),R[E.Info]=(0,F.localize)(2,null);function I(k){return R[k]||""}E.toString=I;function w(k){switch(k){case C.default.Error:return E.Error;case C.default.Warning:return E.Warning;case C.default.Info:return E.Info;case C.default.Ignore:return E.Hint}}E.fromSeverity=w;function y(k){switch(k){case E.Error:return C.default.Error;case E.Warning:return C.default.Warning;case E.Info:return C.default.Info;case E.Hint:return C.default.Ignore}}E.toSeverity=y}(A||(e.MarkerSeverity=A={}));var $;(function(E){const v="";function R(w){return I(w,!0)}E.makeKey=R;function I(w,y){const k=[v];return w.source?k.push(w.source.replace("\xA6","\\\xA6")):k.push(v),w.code?typeof w.code=="string"?k.push(w.code.replace("\xA6","\\\xA6")):k.push(w.code.value.replace("\xA6","\\\xA6")):k.push(v),w.severity!==void 0&&w.severity!==null?k.push(A.toString(w.severity)):k.push(v),w.message&&y?k.push(w.message.replace("\xA6","\\\xA6")):k.push(v),w.startLineNumber!==void 0&&w.startLineNumber!==null?k.push(w.startLineNumber.toString()):k.push(v),w.startColumn!==void 0&&w.startColumn!==null?k.push(w.startColumn.toString()):k.push(v),w.endLineNumber!==void 0&&w.endLineNumber!==null?k.push(w.endLineNumber.toString()):k.push(v),w.endColumn!==void 0&&w.endColumn!==null?k.push(w.endColumn.toString()):k.push(v),k.push(v),k.join("\xA6")}E.makeKeyOptionalMessage=I})($||(e.IMarkerData=$={})),e.$at=(0,d.$Ph)("markerService")}),define(De[243],Ce([1,0,4,38,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3u=e.$2u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$1u=e.Severity=void 0,e.Severity=F.default,e.$1u=(0,d.$Ph)("notificationService");var L;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var $;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new v,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$2u=E;class v{infinite(){}done(){}total(I){}worked(I){}}e.$3u=v}),define(De[134],Ce([1,0,15,2,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gU=e.$fU=e.$eU=e.$dU=e.$cU=void 0,e.$cU=(0,d.$Ph)("openerService");function L(v,R){return F.URI.isUri(v)?(0,C.$2e)(v.scheme,R):(0,C.$3e)(v,R+":")}e.$dU=L;function A(v,...R){return R.some(I=>L(v,I))}e.$eU=A;function $(v,R){return v.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$fU=$;function E(v){let R;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(v.fragment);return I&&(R={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},v=v.with({fragment:""})),{selection:R,uri:v}}e.$gU=E}),define(De[244],Ce([1,0,12,48]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.context<"u"){const L=C.$h.vscode.context.configuration();if(L)d=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(d=globalThis._VSCODE_PRODUCT_JSON,F.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:L.version})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(De[135],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,C.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(C,F){e(C,F,$e)}};define(De[64],Ce([1,0,8,21,3,5]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.ProgressLocation=e.$4u=void 0,e.$4u=(0,L.$Ph)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$5u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,w){this.e=I,this.report=w?.async?this.g.bind(this):this.f.bind(this)}f(I){this.a=I,this.e(this.a)}g(I){this.b?this.b.push(I):this.b=[I],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const I=this.b.shift();this.a=I,await this.e(this.a)}}finally{this.c=!1;const I=this.d;this.d=void 0,I?.()}}drain(){return this.c?new Promise(I=>{const w=this.d;this.d=()=>{w?.(),I()}}):Promise.resolve()}}e.$6u=$;let E=class extends d.$Sc{constructor(I,w){super(),this.a=new C.$ch,w.withProgress(I,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,d.$Qc)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$7u=E,e.$7u=E=He([Be(1,e.$4u)],E);class v extends d.$Sc{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new d.$Rc)}start(I){this.stop();const w=++this.a,y=new F.$Xd;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,d.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,d.$Qc)(()=>y.cancel())),this.b.add((0,d.$Qc)(()=>this.c?this.c.done():void 0)),{id:w,token:y.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$8u=v,e.$9u=(0,L.$Ph)("editorProgressService")}),define(De[43],Ce([1,0,58,17]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class d{constructor(){this.a=new Map}add(A,$){C.ok(F.$yf(A)),C.ok(F.$Af($)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,$)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$gn=new d}),define(De[105],Ce([1,0,4,43]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function d($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class L{constructor(){this.b=new C.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,v){this.a[d(E)]=v,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;F.$gn.add(e.$hn.JSONContribution,A)}),define(De[136],Ce([1,0,19,4,17,188,50,105,43]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var v;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(v||(e.EditPresentationTypes=v={})),e.$ln={Configuration:"base.contributions.configuration"};var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const I=E.$gn.as($.$hn.JSONContribution);class w{constructor(){this.h=new Set,this.i=new F.$Nd,this.onDidSchemaChange=this.i.event,this.j=new F.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const c=new Set;this.n(t,n,c),I.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const n=new Set;this.o(t,n),I.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const c=new Set;this.o(n,c),this.n(t,!1,c),I.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const c=[];for(const{overrides:i,source:a}of t)for(const l in i)if(n.add(l),e.$vn.test(l)){const D=this.a.get(l),S=D?.valuesSources??new Map;if(a)for(const P of Object.keys(i[l]))S.set(P,a);const b={...D?.value||{},...i[l]};this.a.set(l,{source:a,value:b,valuesSources:S});const f=(0,A.$ti)(l),g={type:"object",default:b,description:L.localize(1,null,f),$ref:e.$sn,defaultDefaultValue:b,source:d.$yf(a)?void 0:a,defaultValueSource:a};c.push(...p(l)),this.d[l]=g,this.b.properties[l]=g}else{this.a.set(l,{value:i[l],source:a});const D=this.d[l];D&&(this.w(l,D),this.r(l,D))}this.m(c)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:c,source:i}of t)for(const a in c){const l=this.a.get(a),D=d.$yf(i)?i:i?.id,S=d.$yf(l?.source)?l?.source:l?.source?.id;if(D===S)if(n.add(a),this.a.delete(a),e.$vn.test(a))delete this.d[a],delete this.b.properties[a];else{const b=this.d[a];b&&(this.w(a,b),this.r(a,b))}}this.u()}deltaConfiguration(t){let n=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,c){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,c),this.c.push(i),this.q(i)})}o(t,n){const c=i=>{if(i.properties)for(const a in i.properties){n.add(a);const l=this.d[a];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[a],this.s(a,i.properties[a])}i.allOf?.forEach(a=>c(a))};for(const i of t){c(i);const a=this.c.indexOf(i);a!==-1&&this.c.splice(a,1)}}p(t,n=!0,c,i,a=3,l){a=d.$Hf(t.scope)?a:t.scope;const D=t.properties;if(D)for(const b in D){const f=D[b];if(n&&s(b,f)){delete D[b];continue}if(f.source=c,f.defaultDefaultValue=D[b].default,this.w(b,f),e.$vn.test(b)?f.scope=void 0:(f.scope=d.$Hf(f.scope)?a:f.scope,f.restricted=d.$Hf(f.restricted)?!!i?.includes(b):f.restricted),D[b].hasOwnProperty("included")&&!D[b].included){this.f[b]=D[b],delete D[b];continue}else this.d[b]=D[b],D[b].policy?.name&&this.e.set(D[b].policy.name,b);!D[b].deprecationMessage&&D[b].markdownDeprecationMessage&&(D[b].deprecationMessage=D[b].markdownDeprecationMessage),l.add(b)}const S=t.allOf;if(S)for(const b of S)this.p(b,n,c,i,a,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=c=>{const i=c.properties;if(i)for(const l in i)this.r(l,i[l]);c.allOf?.forEach(n)};n(t)}r(t,n){switch(e.$mn.properties[t]=n,n.scope){case 1:e.$nn.properties[t]=n;break;case 2:e.$on.properties[t]=n;break;case 6:e.$pn.properties[t]=n;break;case 3:e.$qn.properties[t]=n;break;case 4:e.$rn.properties[t]=n;break;case 5:e.$rn.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.$mn.properties[t],n.scope){case 1:delete e.$nn.properties[t];break;case 2:delete e.$on.properties[t];break;case 6:delete e.$pn.properties[t];break;case 3:delete e.$qn.properties[t];break;case 4:case 5:delete e.$rn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,c={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$sn};this.w(n,c),e.$mn.properties[n]=c,e.$nn.properties[n]=c,e.$on.properties[n]=c,e.$pn.properties[n]=c,e.$qn.properties[n]=c,e.$rn.properties[n]=c}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=t,e.$nn.patternProperties[e.$un]=t,e.$on.patternProperties[e.$un]=t,e.$pn.patternProperties[e.$un]=t,e.$qn.patternProperties[e.$un]=t,e.$rn.patternProperties[e.$un]=t,this.i.fire()}w(t,n){const c=this.a.get(t);let i=c?.value,a=c?.source;d.$Ff(i)&&(i=n.defaultDefaultValue,a=void 0),d.$Ff(i)&&(i=o(n.type)),n.default=i,n.defaultValueSource=a}}const y="\\[([^\\]]+)\\]",k=new RegExp(y,"g");e.$un=`^(${y})+$`,e.$vn=new RegExp(e.$un);function p(h){const t=[];if(e.$vn.test(h)){let n=k.exec(h);for(;n?.length;){const c=n[1].trim();c&&t.push(c),n=k.exec(h)}}return(0,C.$Mb)(t)}e.$wn=p;function u(h){return h.reduce((t,n)=>`${t}[${n}]`,"")}e.$xn=u;function o(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=o;const r=new w;E.$gn.add(e.$ln.Configuration,r);function s(h,t){return h.trim()?e.$vn.test(h)?L.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?L.localize(8,null,h):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,h,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$zn=s;function m(){const h=[],t=r.getConfigurationProperties();for(const n of Object.keys(t))h.push([n,t[n].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$An=m}),define(De[245],Ce([1,0,19,4,157,3,28,24,17,2,50,136,43]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function y(n){return Object.isFrozen(n)?n:$.$8m(n)}class k{constructor(c={},i=[],a=[],l){this.b=c,this.c=i,this.d=a,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(i=>{if(i instanceof k)return i;const a=new p("");return a.parseRaw(i),a.configurationModel});this.f=c.reduce((i,a)=>a===i?a:i.merge(a),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,R.$ri)(this.contents,c):this.contents}inspect(c,i){const a=this.rawConfiguration.getValue(c),l=i?this.rawConfiguration.getOverrideValue(c,i):void 0,D=i?this.rawConfiguration.override(i).getValue(c):a;return{value:a,override:l,merged:D}}getOverrideValue(c,i){const a=this.i(i);return a?c?(0,R.$ri)(a,c):a:void 0}getKeysForOverrideIdentifier(c){const i=[];for(const a of this.overrides)a.identifiers.includes(c)&&i.push(...a.keys);return C.$Mb(i)}getAllOverrideIdentifiers(){const c=[];for(const i of this.overrides)c.push(...i.identifiers);return C.$Mb(c)}override(c){let i=this.a.get(c);return i||(i=this.g(c),this.a.set(c,i)),i}merge(...c){const i=$.$7m(this.contents),a=$.$7m(this.overrides),l=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const S of c)if(D.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(i,S.contents);for(const b of S.overrides){const[f]=a.filter(g=>C.$ub(g.identifiers,b.identifiers));f?(this.h(f.contents,b.contents),f.keys.push(...b.keys),f.keys=C.$Mb(f.keys)):a.push($.$7m(b))}for(const b of S.keys)l.indexOf(b)===-1&&l.push(b)}return new k(i,l,a,D.every(S=>S instanceof k)?void 0:D)}g(c){const i=this.i(c);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const l of C.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let D=this.contents[l];const S=i[l];S&&(typeof D=="object"&&typeof S=="object"?(D=$.$7m(D),this.h(D,S)):D=S),a[l]=D}return new k(a,this.keys,this.overrides)}h(c,i){for(const a of Object.keys(i)){if(a in c&&E.$Af(c[a])&&E.$Af(i[a])){this.h(c[a],i[a]);continue}c[a]=$.$7m(i[a])}}i(c){let i=null,a=null;const l=D=>{D&&(a?this.h(a,D):a=$.$7m(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===c?i=D.contents:D.identifiers.includes(c)&&l(D.contents);return l(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,i){this.j(c,i,!0)}setValue(c,i){this.j(c,i,!1)}removeValue(c){const i=this.keys.indexOf(c);i!==-1&&(this.keys.splice(i,1),(0,R.$qi)(this.contents,c),I.$vn.test(c)&&this.overrides.splice(this.overrides.findIndex(a=>C.$ub(a.identifiers,(0,I.$wn)(c))),1))}j(c,i,a){(0,R.$pi)(this.contents,c,i,l=>console.error(l)),a=a||this.keys.indexOf(c)===-1,a&&this.keys.push(c),I.$vn.test(c)&&this.overrides.push({identifiers:(0,I.$wn)(c),keys:Object.keys(this.contents[c]),contents:(0,R.$oi)(this.contents[c],l=>console.error(l))})}}e.$Bn=k;class p{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,i){if(!E.$Hf(c)){const a=this.g(c);this.parseRaw(a,i)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,i){this.a=c;const{contents:a,keys:l,overrides:D,restricted:S,hasExcludedProperties:b}=this.h(c,i);this.b=new k(a,l,D,b?[c]:void 0),this.c=S||[]}g(c){let i={},a=null,l=[];const D=[],S=[];function b(g){Array.isArray(l)?l.push(g):a!==null&&(l[a]=g)}const f={onObjectBegin:()=>{const g={};b(g),D.push(l),l=g,a=null},onObjectProperty:g=>{a=g},onObjectEnd:()=>{l=D.pop()},onArrayBegin:()=>{const g=[];b(g),D.push(l),l=g,a=null},onArrayEnd:()=>{l=D.pop()},onLiteralValue:b,onError:(g,P,N)=>{S.push({error:g,offset:P,length:N})}};if(c)try{d.$4m(c,f),i=l[0]||{}}catch(g){console.error(`Error while parsing settings file ${this.f}: ${g}`),this.d=[g]}return i}h(c,i){const a=w.$gn.as(I.$ln.Configuration).getConfigurationProperties(),l=this.i(c,a,!0,i);c=l.raw;const D=(0,R.$oi)(c,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),S=Object.keys(c),b=this.j(c,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:D,keys:S,overrides:b,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(c,i,a,l){let D=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:D};const S={},b=[];for(const f in c)if(I.$vn.test(f)&&a){const g=this.i(c[f],i,!1,l);S[f]=g.raw,D=D||g.hasExcludedProperties,b.push(...g.restricted)}else{const g=i[f],P=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&b.push(f),!l.exclude?.includes(f)&&(l.include?.includes(f)||(P===void 0||l.scopes===void 0||l.scopes.includes(P))&&!(l.skipRestricted&&g?.restricted))?S[f]=c[f]:D=!0}return{raw:S,restricted:b,hasExcludedProperties:D}}j(c,i){const a=[];for(const l of Object.keys(c))if(I.$vn.test(l)){const D={};for(const S in c[l])D[S]=c[l][S];a.push({identifiers:(0,I.$wn)(l),keys:Object.keys(D),contents:(0,R.$oi)(D,i)})}return a}}e.$Cn=p;class u extends L.$Sc{constructor(c,i,a,l){super(),this.c=c,this.f=i,this.g=l,this.b=this.B(new F.$Nd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&a.isEqual(D.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=u;class o{constructor(c,i,a,l,D,S,b,f,g,P,N,O,M){this.a=c,this.b=i,this.c=a,this.overrideIdentifiers=l,this.d=D,this.f=S,this.g=b,this.h=f,this.i=g,this.j=P,this.k=N,this.l=O,this.m=M}get value(){return y(this.c)}n(c,i,a){const l=c.inspect(i,a);return{get value(){return y(l.value)},get override(){return y(l.override)},get merged(){return y(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(c,i,a,l,D=new k,S=new k,b=new A.$Ac,f=new k,g=new A.$Ac){this.c=c,this.d=i,this.f=a,this.g=l,this.h=D,this.i=S,this.j=b,this.l=f,this.m=g,this.a=null,this.b=new A.$Ac,this.n=null}getValue(c,i,a){return this.q(c,i,a).getValue(c)}updateValue(c,i,a={}){let l;a.resource?(l=this.m.get(a.resource),l||(l=new k,this.m.set(a.resource,l))):l=this.l,i===void 0?l.removeValue(c):l.setValue(c,i),a.resource||(this.a=null)}inspect(c,i,a){const l=this.q(c,i,a),D=this.u(i.resource,a),S=i.resource?this.m.get(i.resource)||this.l:this.l,b=new Set;for(const f of l.overrides)for(const g of f.identifiers)l.getOverrideValue(c,g)!==void 0&&b.add(g);return new o(c,i,l.getValue(c),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,D||void 0,S)}keys(c){const i=this.u(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,i){this.j.set(c,i),this.b.delete(c)}deleteFolderConfiguration(c){this.p.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,i){const a=[];if(!i){const{added:l,updated:D,removed:S}=h(this.c,c);i=[...l,...D,...S]}for(const l of i)for(const D of(0,I.$wn)(l)){const S=this.c.getKeysForOverrideIdentifier(D),b=c.getKeysForOverrideIdentifier(D),f=[...b.filter(g=>S.indexOf(g)===-1),...S.filter(g=>b.indexOf(g)===-1),...S.filter(g=>!$.$$m(this.c.override(D).getValue(g),c.override(D).getValue(g)))];a.push([D,f])}return this.updateDefaultConfiguration(c),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(c){const{added:i,updated:a,removed:l}=h(this.d,c),D=[...i,...a,...l];return D.length&&this.updatePolicyConfiguration(c),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:i,updated:a,removed:l,overrides:D}=h(this.applicationConfiguration,c),S=[...i,...a,...l];return S.length&&this.updateApplicationConfiguration(c),{keys:S,overrides:D}}compareAndUpdateLocalUserConfiguration(c){const{added:i,updated:a,removed:l,overrides:D}=h(this.localUserConfiguration,c),S=[...i,...a,...l];return S.length&&this.updateLocalUserConfiguration(c),{keys:S,overrides:D}}compareAndUpdateRemoteUserConfiguration(c){const{added:i,updated:a,removed:l,overrides:D}=h(this.remoteUserConfiguration,c),S=[...i,...a,...l];return S.length&&this.updateRemoteUserConfiguration(c),{keys:S,overrides:D}}compareAndUpdateWorkspaceConfiguration(c){const{added:i,updated:a,removed:l,overrides:D}=h(this.workspaceConfiguration,c),S=[...i,...a,...l];return S.length&&this.updateWorkspaceConfiguration(c),{keys:S,overrides:D}}compareAndUpdateFolderConfiguration(c,i){const a=this.p.get(c),{added:l,updated:D,removed:S,overrides:b}=h(a,i),f=[...l,...D,...S];return(f.length||!a)&&this.updateFolderConfiguration(c,i),{keys:f,overrides:b}}compareAndDeleteFolderConfiguration(c){const i=this.p.get(c);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:a,updated:l,removed:D,overrides:S}=h(i,void 0);return{keys:[...a,...l,...D],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(c,i,a){let l=this.r(i,a);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(l=l.merge(this.d)),l}r({resource:c},i){let a=this.s();if(i&&c){const l=i.getFolder(c);l&&(a=this.t(l.uri)||a);const D=this.m.get(c);D&&(a=a.merge(D))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(c){let i=this.b.get(c);if(!i){const a=this.s(),l=this.j.get(c);l?(i=a.merge(l),this.b.set(c,i)):i=a}return i}u(c,i){if(i&&c){const a=i.getFolder(c);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,i)=>{const{contents:a,overrides:l,keys:D}=this.j.get(i);return c.push([i,{contents:a,overrides:l,keys:D}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(i=>c.add(i)),this.userConfiguration.keys.forEach(i=>c.add(i)),this.i.keys.forEach(i=>c.add(i)),this.j.forEach(i=>i.keys.forEach(a=>c.add(a))),[...c.values()]}v(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>c.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>c.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>c.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(a=>c.add(a))),[...c.values()]}w(c){const i=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(a=>i.add(a)),this.i.getKeysForOverrideIdentifier(c).forEach(a=>i.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(c).forEach(l=>i.add(l))),[...i.values()]}static parse(c){const i=this.x(c.defaults),a=this.x(c.policy),l=this.x(c.application),D=this.x(c.user),S=this.x(c.workspace),b=c.folders.reduce((f,g)=>(f.set(v.URI.revive(g[0]),this.x(g[1])),f),new A.$Ac);return new r(i,a,l,D,new k,S,b,new k,new A.$Ac)}static x(c){return new k(c.contents,c.keys,c.overrides)}}e.$En=r;function s(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const c=new Set,i=new Map;for(const l of n)l.keys.forEach(D=>c.add(D)),l.overrides.forEach(([D,S])=>{const b=(0,A.$xc)(i,D,new Set);S.forEach(f=>b.add(f))});const a=[];return i.forEach((l,D)=>a.push([D,[...l.values()]])),{keys:[...c.values()],overrides:a}}e.$Fn=s;class m{constructor(c,i,a,l){this.change=c,this.f=i,this.g=a,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const D of c.keys)this.affectedKeys.add(D);for(const[,D]of c.overrides)for(const S of D)this.affectedKeys.add(S);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(c,i){const a=this.a+c,l=this.d.indexOf(a);if(l<0)return!1;const D=l+a.length;if(D>=this.d.length)return!1;const S=this.d.charCodeAt(D);if(S!==this.b&&S!==this.c)return!1;if(i){const b=this.previousConfiguration?this.previousConfiguration.getValue(c,i,this.f?.workspace):void 0,f=this.g.getValue(c,i,this.h);return!$.$$m(b,f)}return!0}}e.$Gn=m;function h(n,c){const{added:i,removed:a,updated:l}=t(c?.rawConfiguration,n?.rawConfiguration),D=[],S=n?.getAllOverrideIdentifiers()||[],b=c?.getAllOverrideIdentifiers()||[];if(c){const f=b.filter(g=>!S.includes(g));for(const g of f)D.push([g,c.getKeysForOverrideIdentifier(g)])}if(n){const f=S.filter(g=>!b.includes(g));for(const g of f)D.push([g,n.getKeysForOverrideIdentifier(g)])}if(c&&n){for(const f of S)if(b.includes(f)){const g=t({contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)},{contents:c.getOverrideValue(void 0,f)||{},keys:c.getKeysForOverrideIdentifier(f)});D.push([f,[...g.added,...g.removed,...g.updated]])}}return{added:i,removed:a,updated:l,overrides:D}}function t(n,c){const i=n?c?n.keys.filter(D=>c.keys.indexOf(D)===-1):[...n.keys]:[],a=c?n?c.keys.filter(D=>n.keys.indexOf(D)===-1):[...c.keys]:[],l=[];if(n&&c){for(const D of c.keys)if(n.keys.indexOf(D)!==-1){const S=(0,R.$ri)(c.contents,D),b=(0,R.$ri)(n.contents,D);$.$$m(S,b)||l.push(D)}}return{added:i,removed:a,updated:l}}}),define(De[246],Ce([1,0,22,4,3,82]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckb=e.$Bkb=e.$Akb=e.$zkb=void 0;const A=(v,R,I)=>{const w=new Uint8Array(16);for(let p=0;p<16;p++)w[p]=Math.round(Math.random()*256);const y=(0,C.$ve)(C.$be.wrap(w));return[`GET ws://localhost${v}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$zkb=A,e.$Akb=C.$be.fromString(`\r
\r
`);async function $(v,R,I,w,y){v.write(C.$be.fromString((0,e.$zkb)(R,I,w)));const k=new d.$Rc;try{return await new Promise((p,u)=>{let o;k.add(v.onData(r=>{o?o=C.$be.concat([o,r],o.byteLength+r.byteLength):o=r;const s=o.indexOf(e.$Akb);if(s===-1)return;p(v),v.pauseData();const m=o.slice(s+e.$Akb.byteLength);m.byteLength&&y.onData.fire(m)})),k.add(v.onClose(r=>u(r??new Error("socket closed")))),k.add(v.onEnd(()=>u(new Error("socket ended"))))})}catch(p){throw v.dispose(),p}finally{k.dispose()}}e.$Bkb=$;class E extends d.$Sc{constructor(R,I){super(),this.g=R,this.a=this.B(new F.$Qd),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new F.$Nd),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(w=>this.a.fire(w))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,I){L.SocketDiagnostics.traceSocketEvent(this,this.g,R,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Ckb=E}),define(De[65],Ce([1,0,9,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,F.$Ph)("remoteAuthorityResolverService");var d;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(d||(e.RemoteConnectionType=d={}));class L{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=L;class A{constructor(I,w){this.host=I,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=A;var $;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class E extends C.$bb{static isNotAvailable(I){return I instanceof E&&I._code===$.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===$.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===$.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===$.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,w=$.Unknown,y){super(I),this._message=I,this._code=w,this._detail=y,this.isHandled=w===$.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Sk=E;function v(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.$Tk=v}),define(De[66],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function F(v){return v.scheme===C.Schemas.vscodeRemote?v.authority:void 0}e.$Uk=F;function d(v){if(!v)return;const R=v.indexOf("+");return R<0?v:v.substr(0,R)}e.$Vk=d;function L(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.$Wk=L;function A(v){const{host:R,port:I}=E(v);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:I}}e.$Xk=A;function $(v,R){let{host:I,port:w}=E(v);return typeof w>"u"&&(w=R),{host:I,port:w}}e.$Yk=$;function E(v){const R=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=v.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const w=v.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:v,port:void 0}}}),define(De[25],Ce([1,0,15,5,66]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$4l=L,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A||(e.ExtensionType=A={}));var $;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class E{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,o){if(typeof u>"u"||u===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof u=="string"||typeof o=="string"){const r=typeof u=="string"?u:u.value,s=typeof o=="string"?o:o.value;return C.$2e(r,s)}return u._lower===o._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$6l=E;class v{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const o of u)this.add(o)}add(u){this.c.add(E.toKey(u))}delete(u){return this.c.delete(E.toKey(u))}has(u){return this.c.has(E.toKey(u))}}e.$7l=v;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(E.toKey(u))}get(u){return this.c.get(E.toKey(u))}has(u){return this.c.has(E.toKey(u))}set(u,o){this.c.set(E.toKey(u),o)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=R;function I(p){return w(p)}e.$9l=I;function w(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$0l=w;function y(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$$l=y;function k(p,u){if(u){const o=`onResolveRemoteAuthority:${(0,d.$Vk)(u)}`;return!!p.activationEvents?.includes(o)}return!1}e.$_l=k,e.$am=(0,F.$Ph)("IBuiltinExtensionsScannerService")}),define(De[137],Ce([1,0,9,25]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=void 0;class d{constructor(){this.a=new Map,this.b=new WeakMap}register(A,$){this.a.set(A,$)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const $=Object.create(null);for(const E of A){const v=this.readActivationEvents(E);v.length>0&&($[F.$6l.toKey(E.identifier)]=v)}return $}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const $=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return $;for(const E in A.contributes){const v=this.a.get(E);if(!v)continue;const R=A.contributes[E],I=Array.isArray(R)?R:[R];try{v(I,$)}catch(w){(0,C.$1)(w)}}return $}}e.$UE=d,e.$VE=new d}),define(De[247],Ce([1,0,8,22,21,9,4,3,54,37,31,82,65,66]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.PersistentConnectionEventType=e.$6k=e.$5k=e.$4k=e.ConnectionType=void 0;const k=30*1e3;var p;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function u(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(H){const B=new d.$Xd;return setTimeout(()=>B.cancel(),H),B.token}function r(H,B){if(H.isCancellationRequested||B.isCancellationRequested)return d.CancellationToken.Cancelled;const J=new d.$Xd;return H.onCancellationRequested(()=>J.cancel()),B.onCancellationRequested(()=>J.cancel()),J.token}class s{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new $.$Rc,this.promise=new Promise((J,re)=>{this.f=J,this.g=re}),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function m(H,B){const J=new s(B);return J.registerDisposable(H.onControlMessage(re=>{const Y=JSON.parse(re.toString()),_=Q(Y);_?J.reject(_):J.resolve(Y)})),J.promise}function h(H,B,J,re,Y,_,x,pe){const ue=new s(pe),fe=v.$Jd.create(!1);return H.info(`Creating a socket (${x})...`),E.mark(`code/willCreateSocket/${_}`),B.connect(J,re,Y,x).then(te=>{ue.didTimeout?(E.mark(`code/didCreateSocketError/${_}`),H.info(`Creating a socket (${x}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(E.mark(`code/didCreateSocketOK/${_}`),H.info(`Creating a socket (${x}) was successful after ${fe.elapsed()} ms.`),ue.resolve(te))},te=>{E.mark(`code/didCreateSocketError/${_}`),H.info(`Creating a socket (${x}) returned an error after ${fe.elapsed()} ms.`),H.error(te),ue.reject(te)}),ue.promise}function t(H,B){const J=new s(B);return H.then(re=>{J.didTimeout||J.resolve(re)},re=>{J.didTimeout||J.reject(re)}),J.promise}async function n(H,B,J,re){const Y=ce(H,B);H.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let _;try{_=await h(H.logService,H.remoteSocketFactoryService,H.connectTo,(0,y.$Wk)(H),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,u(B),`renderer-${u(B)}-${H.reconnectionToken}`,re)}catch(te){throw H.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),H.logService.error(te),te}H.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let x,pe;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(_,null),x=H.reconnectionProtocol,pe=!1):(x=new I.$Dh({socket:_}),pe=!0),H.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const ue=await t(H.signService.createNewMessage((0,R.$eg)()),re),fe={type:"auth",auth:H.connectionToken||"00000000000000000000",data:ue.data};x.sendControl(F.$be.fromString(JSON.stringify(fe)));try{const te=await m(x,r(re,o(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const z=new Error("Unexpected handshake message");throw z.code="VSCODE_CONNECTION_ERROR",z}if(H.logService.trace(`${Y} 4/6. received SignRequest control message.`),!await t(H.signService.validate(ue,te.signedData),re)){const z=new Error("Refused to connect to unsupported server");throw z.code="VSCODE_CONNECTION_ERROR",z}const be=await t(H.signService.sign(te.data),re),Pe={type:"connectionType",commit:H.commit,signedData:be,desiredConnectionType:B};return J&&(Pe.args=J),H.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(F.$be.fromString(JSON.stringify(Pe))),{protocol:x,ownsProtocol:pe}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(H.logService.error(`${Y} the handshake timed out. Error:`),H.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${Y} received error control message when negotiating connection. Error:`),H.logService.error(te)),pe&&ee(x),te}}async function c(H,B,J,re){const Y=Date.now(),_=ce(H,B),{protocol:x,ownsProtocol:pe}=await n(H,B,J,re),ue=new s(re);return ue.registerDisposable(x.onControlMessage(fe=>{const te=JSON.parse(fe.toString()),de=Q(te);de?(H.logService.error(`${_} received error control message when negotiating connection. Error:`),H.logService.error(de),pe&&ee(x),ue.reject(de)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${we(Y)}!`),ue.resolve({protocol:x,firstMessage:te}))})),ue.promise}async function i(H,B){const{protocol:J}=await c(H,1,void 0,B);return{protocol:J}}async function a(H,B,J){const{protocol:re,firstMessage:Y}=await c(H,2,B,J),_=Y&&Y.debugPort;return{protocol:re,debugPort:_}}async function l(H,B,J){const re=Date.now(),Y=ce(H,3),{protocol:_}=await n(H,3,B,J);return H.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${we(re)}!`),_}async function D(H,B,J){const{connectTo:re,connectionToken:Y}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:re,connectionToken:Y,reconnectionToken:B,reconnectionProtocol:J,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function S(H,B,J){return f(H,async re=>{const{protocol:Y}=await i(re,d.CancellationToken.None);return new q(H,B,J,re.reconnectionToken,Y)})}e.$4k=S;async function b(H,B){return f(H,async J=>{const{protocol:re,debugPort:Y}=await a(J,B,d.CancellationToken.None);return new ge(H,B,J.reconnectionToken,re,Y)})}e.$5k=b;async function f(H,B){for(let re=1;;re++)try{const Y=(0,R.$eg)(),_=await D(H,Y,null);return await B(_)}catch(Y){if(re<5)H.logService.error(`[remote-connection][attempt ${re}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(Y);else throw H.logService.error(`[remote-connection][attempt ${re}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(Y),K.triggerPermanentFailure(0,0,w.$Sk.isHandled(Y)),Y}}async function g(H,B,J){const re=await D(H,(0,R.$eg)(),null);return await l(re,{host:B,port:J},d.CancellationToken.None)}e.$6k=g;function P(H){return(0,C.$Hg)(B=>new Promise((J,re)=>{const Y=setTimeout(J,H*1e3);B.onCancellationRequested(()=>{clearTimeout(Y),J()})}))}var N;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class O{constructor(B,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.type=0}}e.$7k=O;class M{constructor(B,J,re,Y){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.durationSeconds=re,this.c=Y,this.type=1}skipWait(){this.c.cancel()}}e.$8k=M;class j{constructor(B,J,re){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.attempt=re,this.type=2}}e.$9k=j;class U{constructor(B,J,re){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.attempt=re,this.type=4}}e.$0k=U;class T{constructor(B,J,re,Y){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.attempt=re,this.handled=Y,this.type=3}}e.$$k=T;class K extends $.$Sc{static triggerPermanentFailure(B,J,re){this._permanentFailure=!0,this.f=B,this.g=J,this.h=re,this.j.forEach(Y=>Y.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||K._permanentFailure}constructor(B,J,re,Y,_){super(),this.t=B,this.u=J,this.reconnectionToken=re,this.protocol=Y,this.w=_,this.m=this.B(new A.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new U(this.reconnectionToken,0,0)),this.B(Y.onSocketClose(x=>{const pe=ie(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${pe} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${pe} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${pe} received socket close event.`),this.y()})),this.B(Y.onSocketTimeout(x=>{const pe=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${pe} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),K.j.push(this),this.B((0,$.$Qc)(()=>{const x=K.j.indexOf(this);x>=0&&K.j.splice(x,1)})),this.n&&this.D(K.f,K.g,K.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const J=[0,5,5,10,10,10,10,10,30];let re=-1;do{re++;const Y=re<J.length?J[re]:J[J.length-1];try{if(Y>0){const x=P(Y);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,x)),this.u.logService.info(`${B} waiting for ${Y} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1)),this.u.logService.info(`${B} resolving connection...`);const _=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${_.connectTo}...`),await this.G(_,o(k)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(re>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(w.$Sk.isTemporarilyNotAvailable(_)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((0,L.$4)(_)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if(_ instanceof w.$Sk){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,w.$Sk.isHandled(_));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}}while(!this.n&&!this.s)}C(B,J,re){this.w?K.triggerPermanentFailure(B,J,re):this.D(B,J,re)}D(B,J,re){this.m.fire(new T(this.reconnectionToken,B,J,re)),ee(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_k=K;class q extends K{constructor(B,J,re,Y,_){super(1,B,Y,_,!0),this.client=this.B(new I.$Bh(_,{remoteAuthority:J,clientId:re},B.ipcLogger))}async G(B,J){await i(B,J)}}e.$al=q;class ge extends K{constructor(B,J,re,Y,_){super(2,B,re,Y,!1),this.H=J,this.debugPort=_}async G(B,J){await a(B,this.H,J)}}e.$bl=ge;function ee(H){try{H.acceptDisconnect();const B=H.getSocket();H.dispose(),B.dispose()}catch(B){(0,L.$1)(B)}}function Q(H){if(H&&H.type==="error"){const B=new Error(`Connection error: ${H.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function X(H,B){for(;H.length<B;)H+=" ";return H}function ae(H,B){return`[remote-connection][${X(u(H),13)}][${B.substr(0,5)}\u2026]`}function ie(H,B,J){return`${ae(H,B)}[${J?"reconnect":"initial"}]`}function ce(H,B){return`${ie(B,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function we(H){return`${Date.now()-H} ms`}}),define(De[248],Ce([1,0,3,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk=(0,F.$Ph)("remoteSocketFactoryService");class d{constructor(){this.a={}}register(A,$){return this.a[A]??=[],this.a[A].push($),(0,C.$Qc)(()=>{const E=this.a[A]?.indexOf($);typeof E=="number"&&E>=0&&this.a[A]?.splice(E,1)})}b(A){return(this.a[A.type]||[]).find(E=>E.supports(A))}connect(A,$,E,v){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,$,E,v)}}e.$1k=d}),define(De[249],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j3b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(d){try{const L=await this.c();if(L){const A=String(C.a++);return this.b.set(A,L),{id:A,data:L.createNewMessage(d)}}}catch{}return{id:"",data:d}}async validate(d,L){if(!d.id)return!0;const A=this.b.get(d.id);if(!A)return!1;this.b.delete(d.id);try{return A.validate(L)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(d){try{return await this.d(d)}catch{}return d}}e.$j3b=C}),define(De[106],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=void 0,e.$2k="signService",e.$3k=(0,C.$Ph)(e.$2k)}),define(De[138],Ce([1,0,249]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c8b=void 0;class F extends C.$j3b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(A=>new A.signer().sign(L))}h(){return new Promise((L,A)=>$e(["vsda"],L,A))}}e.$c8b=F}),define(De[250],Ce([1,0,12,48,31]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=void 0;function L(E){if(C.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,v,R,I,w,y,k,p,u){const o=Object.create(null);o["common.machineId"]=y,o["common.sqmId"]=k,o.sessionID=(0,d.$eg)()+Date.now(),o.commitHash=I,o.version=w,o["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$i)(C.$u),o["common.nodePlatform"]=F.$dc,o["common.nodeArch"]=R,o["common.product"]=u||"desktop",p&&(o["common.msftInternal"]=p);let r=0;const s=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),C.$m&&(o["common.snap"]="true");const m=L(v);return m&&(o["common.platformDetail"]=m),o}e.$io=A;function $(E){const v=F.env.USERDNSDOMAIN;if(!v)return!1;const R=v.toLowerCase();return E.some(I=>R===I)}e.$jo=$}),define(De[251],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,C.$Ph)("telemetryService"),e.$dl=(0,C.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var d;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(d||(e.TelemetryConfiguration=d={}))}),define(De[85],Ce([1,0,24,17,4,50,66,250,251]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=void 0;class v{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$ko=v;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$lo=R,e.$mo=new R;class I{async publicLog(a,l,D){}async publicLogError(a,l,D){}}e.$no=I,e.$oo="telemetry",e.$po="extensionTelemetryLog",e.$qo={log:()=>null,flush:()=>Promise.resolve(null)};function w(i,a){return d.Event.debounce(a.onDidChangeConfiguration,(D,S)=>{const b=D?new Set([...D.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:b}},1e3,!0)(D=>{D.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,L.$mi)(D.source),configurationKeys:Array.from(D.affectedKeys)})})}e.$ro=w;function y(i,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!i.enableTelemetry)}e.$so=y;function k(i,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$to=k;function p(i){const a=i.getValue(E.$kl),l=i.getValue(E.$ll);if(i.getValue(E.$ml)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$uo=p;function u(i){const a={},l={},D={};s(i,D);for(let S in D){S=S.length>150?S.substr(S.length-149):S;const b=D[S];typeof b=="number"?l[S]=b:typeof b=="boolean"?l[S]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${b.length}`),a[S]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(a[S]=b)}return{properties:a,measurements:l}}e.$vo=u;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(i){if(!i)return"none";const a=(0,A.$Vk)(i);return o.has(a)?a:"other"}e.$wo=r;function s(i,a,l=0,D){if(i)for(const S of Object.getOwnPropertyNames(i)){const b=i[S],f=D?D+S:S;Array.isArray(b)?a[f]=(0,C.$_m)(b):b instanceof Date?a[f]=b.toISOString():(0,F.$Af)(b)?l<2?s(b,a,l+1,f+"."):a[f]=(0,C.$_m)(b):a[f]=b}}function m(i,a){const l=i.msftInternalDomains||[],D=a.getValue("telemetry.internalTesting");return(0,$.$jo)(l)||D}e.$xo=m;function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$yo=h;function t(i,a){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let l=i;const D=[];for(const g of a)for(;;){const P=g.exec(i);if(!P)break;D.push([P.index,g.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(l="";;){const g=b.exec(i);if(!g)break;const P=D.some(([N,O])=>g.index<O&&N<b.lastIndex);!S.test(g[0])&&!P&&(l+=i.substring(f,g.index)+"<REDACTED: user-file-path>",f=b.lastIndex)}return f<i.length&&(l+=i.substr(f)),l}function n(i){if(!i)return i;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of a)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return i}function c(i,a){return(0,C.$9m)(i,l=>{if(l instanceof v||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let D=l.replaceAll("%20"," ");D=t(D,a);for(const S of a)D=D.replace(S,"");return D=n(D),D}})}e.$zo=c}),define(De[252],Ce([1,0,15,132,25,12,2,9,48,85]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;function R(c,i){return c.uuid&&i.uuid?c.uuid===i.uuid:c.id===i.id?!0:(0,C.$We)(c.id,i.id)===0}e.$Ao=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(i){const a=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new w(i.identifier,a,l)}static parse(i){const a=I.exec(i);return a&&a[1]&&a[2]?new w({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,l="undefined"){this.version=a,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof w?R(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Bo=w;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(c){const i=y.exec(c);return i&&i[1]?[u(i[1]),i[2]]:[u(c),void 0]}e.$Co=k;function p(c,i){return`${c}.${i}`}e.$Do=p;function u(c){return c.toLowerCase()}e.$Eo=u;function o(c,i){return u(p(c??d.$2l,i))}e.$Fo=o;function r(c,i){const a=[],l=D=>{for(const S of a)if(S.some(b=>R(i(b),i(D))))return S;return null};for(const D of c){const S=l(D);S?S.push(D):a.push([D])}return a}e.$Go=r;function s(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$Ho=s;function m(c){return{id:new v.$ko(c.identifier.id),name:new v.$ko(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Io=m,e.$Jo=new d.$6l("pprice.better-merge");function h(c,i){const a=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const D=l.shift();if(D&&a.every(S=>!R(S.identifier,{id:D}))){const S=c.filter(b=>R(b.identifier,{id:D}));S.length===1&&(a.push(S[0]),l.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$Ko=h;async function t(c,i){if(!L.$l)return!1;let a;try{a=(await c.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await c.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){i.debug("Error while getting the os-release file.",(0,$.$0)(D))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(c,i){const a=await t(c,i),l=(0,F.$6n)(a?"alpine":L.$u,E.$ec);return i.debug("ComputeTargetPlatform:",l),l}e.$Lo=n}),define(De[253],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.$or=e.$nr=e.$mr=e.$lr=void 0;function C(E){return[...E.entries()]}e.$lr=C;function F(E){return E?[...E.entries()]:[]}e.$mr=F;function d(E){return new Map(E)}e.$nr=d;function L(E){return new Map(E??[])}e.$or=L;function A(E){return Array.from(E.entries()).map(v=>[v[0],C(v[1].map),F(v[1].descriptionMap)])}e.$pr=A;function $(E){return new Map(E.map(v=>[v[0],{map:d(v[1]),descriptionMap:L(v[2])}]))}e.$qr=$}),define(De[254],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkb=void 0;class C{constructor(d){this.b=d,this.a=new Map}dispose(){for(const d of this.a.values())d.dispose()}startBuffering(d,L,A=5){const $=L(E=>{const v=typeof E=="string"?E:E.data;let R=this.a.get(d);if(R){R.data.push(v);return}const I=setTimeout(()=>this.flushBuffer(d),A);R={data:[v],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(d),$.dispose()}},this.a.set(d,R)});return $}stopBuffering(d){this.a.get(d)?.dispose()}flushBuffer(d){const L=this.a.get(d);L&&(this.a.delete(d),this.b(d,L.data.join("")))}}e.$Tkb=C}),define(De[255],Ce([1,0,8,79,59,4,17,2,199,105,43]),function($e,e,C,F,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.IconFontDefinition=e.IconContribution=e.$5v=void 0,e.$5v={IconContribution:"base.contributions.icons"};var I;(function(m){function h(t,n){let c=t.defaults;for(;d.ThemeIcon.isThemeIcon(c);){const i=k.getIcon(c.id);if(!i)return;c=i.defaults}return c}m.getDefinition=h})(I||(e.IconContribution=I={}));var w;(function(m){function h(n){return{weight:n.weight,style:n.style,src:n.src.map(c=>({format:c.format,location:c.location.toString()}))}}m.toJSONObject=h;function t(n){const c=i=>(0,A.$yf)(i)?i:void 0;if(n&&Array.isArray(n.src)&&n.src.every(i=>(0,A.$yf)(i.format)&&(0,A.$yf)(i.location)))return{weight:c(n.weight),style:c(n.style),src:n.src.map(i=>({format:i.format,location:$.URI.parse(i.location)}))}}m.fromJSONObject=t})(w||(e.IconFontDefinition=w={}));class y{constructor(){this.a=new L.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${d.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,t,n,c){const i=this.b[h];if(i){if(n&&!i.description){i.description=n,this.d.properties[h].markdownDescription=`${n} $(${h})`;const D=this.e.enum.indexOf(h);D!==-1&&(this.e.enumDescriptions[D]=n),this.a.fire()}return i}const a={id:h,description:n,defaults:t,deprecationMessage:c};this.b[h]=a;const l={$ref:"#/definitions/icons"};return c&&(l.deprecationMessage=c),n&&(l.markdownDescription=`${n}: $(${h})`),this.d.properties[h]=l,this.e.enum.push(h),this.e.enumDescriptions.push(n||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const t=this.e.enum.indexOf(h);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,t){const n=this.f[h];return n||(this.f[h]=t,this.a.fire(),t)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(i,a)=>i.id.localeCompare(a.id),t=i=>{for(;d.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(i=>this.b[i]);for(const i of c.filter(a=>!!a.description).sort(h))n.push(`|<i class="${t(i)}"></i>|${i.id}|${d.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const i of c.filter(a=>!d.ThemeIcon.isThemeIcon(a.defaults)).sort(h))n.push(`|<i class="${t(i)}"></i>|${i.id}|`);return n.join(`
`)}}const k=new y;R.$gn.add(e.$5v.IconContribution,k);function p(m,h,t,n){return k.registerIcon(m,h,t,n)}e.$6v=p;function u(){return k}e.$7v=u;function o(){const m=(0,F.$Sj)();for(const h in m){const t="\\"+m[h].toString(16);k.registerIcon(h,{fontCharacter:t})}}o(),e.$8v="vscode://schemas/icons";const r=R.$gn.as(v.$hn.JSONContribution);r.registerSchema(e.$8v,k.getIconSchema());const s=new C.$6g(()=>r.notifySchemaChanged(e.$8v),200);k.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$9v=p("widget-close",F.$Uj.close,(0,E.localize)(2,null)),e.$0v=p("goto-previous-location",F.$Uj.arrowUp,(0,E.localize)(3,null)),e.$$v=p("goto-next-location",F.$Uj.arrowDown,(0,E.localize)(4,null)),e.$_v=d.ThemeIcon.modify(F.$Uj.sync,"spin"),e.$aw=d.ThemeIcon.modify(F.$Uj.loading,"spin")}),define(De[86],Ce([1,0,4,50,5,14]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.ProvidedOnAutoForward=e.$_u=e.TunnelPrivacyId=e.TunnelProtocol=e.$$u=e.$0u=void 0,e.$0u=(0,d.$Ph)("tunnelService"),e.$$u=(0,d.$Ph)("sharedTunnelsService");var A;(function(u){u.Http="http",u.Https="https"})(A||(e.TunnelProtocol=A={}));var $;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(u){return!!u.forwardPort}e.$_u=E;var v;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(v||(e.ProvidedOnAutoForward=v={}));function R(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(o)return{address:o[1],port:+o[2]}}e.$av=R,e.$bv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(u){return e.$bv.indexOf(u)>=0}e.$cv=I,e.$dv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(u){return e.$dv.indexOf(u)>=0}e.$ev=w;function y(u,o,r,s){if(r===1)return!1;if(r===2&&w(o)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(m?.length===4&&parseInt(m[1])>=18)return!1}return u<1024}e.$fv=y;class k{constructor(o,r,s){this.remoteAddress=o,this.localAddress=r,this.b=s,this.a=new C.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$gv=k;let p=class{constructor(o,r){this.j=o,this.k=r,this.a=new C.$Nd,this.onTunnelOpened=this.a.event,this.b=new C.$Nd,this.onTunnelClosed=this.b.event,this.c=new C.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],r=Array.from(this.e.values());for(const s of r){const m=Array.from(s.values());for(const h of m){const t=await h.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:r}of o.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,r,s,m,h){this.p(o,r,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:r,localAddress:s,privacy:m,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,r){(w(o)||I(o))&&(o=e.$bv[0]);const s=this.r(o,r);if(s)return++s.refcount,s.value}openTunnel(o,r,s,m,h,t=!1,n,c){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${h}.`);const i=this.f??o;if(!i)return;if(r||(r="localhost"),m||(m=this.l),this.f&&this.i.has(s)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.s(i,r,s,m,h,t,n,c);return a?a.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,s),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,s);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.n(l);return(l.tunnelRemoteHost!==r||l.tunnelRemotePort!==s)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&l.privacy!==n&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const r=this.e.get(o.tunnelRemoteHost);if(r){const s=r.get(o.tunnelRemotePort);s&&(s.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,s))}}}}async o(o,r,s){if(s.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${r}.`);const m=s.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(r),m}}async closeTunnel(o,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${r} `);const s=this.e.get(o);if(s&&s.has(r)){const m=s.get(r);m.refcount=0,await this.o(o,r,m)}}p(o,r,s){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(r,{refcount:1,value:s})}async q(o,r){const s=this.e.get(o);if(s){const m=s.get(r),h=m?await m.value:void 0;(!h||typeof h=="string")&&s.delete(r),s.size===0&&this.e.delete(o)}}r(o,r){const s=[o];I(o)?(s.push(...e.$bv),s.push(...e.$dv)):w(o)&&s.push(...e.$dv);const m=s.map(h=>this.e.get(h));for(const h of m){const t=h?.get(r);if(t)return t}}canTunnel(o){return!!R(o)}t(o,r,s,m,h,t,n){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${m}.`);const c=s;this.i.add(c);const i=m===void 0?s:m,a={elevationRequired:h?this.isPortPrivileged(i):!1},l={remoteAddress:{host:r,port:s},localAddressPort:m,privacy:t,public:t?t!==$.Private:void 0,protocol:n},D=o.forwardPort(l,a);return D?(this.p(r,s,D),D.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(c)})):this.i.delete(c),D}};e.$hv=p,e.$hv=p=He([Be(0,L.$0i),Be(1,F.$ji)],p)}),define(De[256],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,C.$Ph)("IUriIdentityService")}),define(De[257],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$iv=void 0,e.$iv=(0,C.$Ph)("editSessionIdentityService");var F;(function(d){d[d.Complete=100]="Complete",d[d.Partial=50]="Partial",d[d.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(De[258],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=void 0;function F(E){return E.scheme!==C.Schemas.file&&E.scheme!==C.Schemas.vscodeRemote}e.$PJ=F;function d(E){if(E.folders.length)return E.folders.every(v=>F(v.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$QJ=d;function L(E){return d(E)?.scheme}e.$RJ=L;function A(E){return d(E)?.authority}e.$SJ=A;function $(E){return d(E)!==void 0}e.$TJ=$}),define(De[44],Ce([1,0,201,16,78,23,2,5,18]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,$.$Ph)("contextService");function v(i){const a=i;return typeof a?.id=="string"&&A.URI.isUri(a.uri)}e.$Zh=v;function R(i){return typeof i?.id=="string"&&!v(i)&&!w(i)}e.$1h=R,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function I(i,a){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,F.$nc)(i)}:a?e.$2h:e.$3h;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$4h=I;function w(i){const a=i;return typeof a?.id=="string"&&A.URI.isUri(a.configPath)}e.$5h=w;function y(i){const a=i;if(a?.uri)return{id:a.id,uri:A.URI.revive(a.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:A.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.$6h=y;var k;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function p(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$7h=p;function u(i){const a=i;return!!(a&&typeof a=="object"&&A.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$8h=u;class o{constructor(a,l,D,S,b){this.h=a,this.j=D,this.k=S,this.l=b,this.c=d.$Vh.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=d.$Vh.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=o;class r{constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,L.$vg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=r;function s(i){return new r({uri:i,index:0,name:(0,L.$rg)(i)},{uri:i.toString()})}e.$$h=s,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,C.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function m(i,a){return L.$mg.isEqualOrParent(i,a.untitledWorkspacesHome)}e.$di=m;function h(i){let a;return A.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===E.Schemas.tmp}e.$ei=h,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$fi}e.$gi=t;function n(i,a){return!m(i,a)&&!h(i)}e.$hi=n;function c(i){return(typeof i=="string"?(0,F.$oc)(i):(0,L.$tg)(i))===e.$ai}e.$ii=c}),define(De[259],Ce([1,0,52,4,3,23,2,200,131,30,5,14,44,28,256,8,31,15,17]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var s;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(s||(e.ProfileResourceType=s={}));function m(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.$Jk=m,e.$Kk=(0,R.$Ph)("IUserDataProfilesService");function h(i,a){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:a}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:a}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:a}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Lk=h;function t(i,a,l,D,S,b){return{id:i,name:a,location:l,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:b&&S?.useDefaultFlags?.globalState?b.globalStorageHome:(0,L.$vg)(l,"globalStorage"),settingsResource:b&&S?.useDefaultFlags?.settings?b.settingsResource:(0,L.$vg)(l,"settings.json"),keybindingsResource:b&&S?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,L.$vg)(l,"keybindings.json"),tasksResource:b&&S?.useDefaultFlags?.tasks?b.tasksResource:(0,L.$vg)(l,"tasks.json"),snippetsHome:b&&S?.useDefaultFlags?.snippets?b.snippetsHome:(0,L.$vg)(l,"snippets"),extensionsResource:b&&S?.useDefaultFlags?.extensions?b.extensionsResource:(0,L.$vg)(l,"extensions.json"),cacheHome:(0,L.$vg)(D,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$Mk=t;let n=class extends d.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,l,D,S){super(),this.t=a,this.u=l,this.w=D,this.y=S,this.f=!0,this.h=this.B(new F.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),l=[a];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,r.$yf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}l.push(t((0,L.$sg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},a))}}catch(b){this.y.error(b)}const D=new y.$Ac,S=new Map;if(l.length)try{const b=this.Q();if(b.workspaces)for(const[f,g]of Object.entries(b.workspaces)){const P=A.URI.parse(f),N=l.find(O=>O.id===g);N&&D.set(P,N)}if(b.emptyWindows)for(const[f,g]of Object.entries(b.emptyWindows)){const P=l.find(N=>N.id===g);P&&S.set(f,P)}}catch(b){this.y.error(b)}this.z={profiles:l,workspaces:D,emptyWindows:S}}return this.z}D(){const a=t("__default__profile__",(0,$.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",D=new RegExp(`${(0,o.$Fe)(l)}\\s(\\d+)`);let S=0;for(const f of this.profiles){const g=D.exec(f.name),P=g?parseInt(g[1]):0;S=P>S?P:S}const b=`${l} ${S+1}`;return this.createProfile((0,C.$Di)((0,u.$eg)()).toString(16),b,{transient:!0},a)}async createNamedProfile(a,l,D){return this.createProfile((0,C.$Di)((0,u.$eg)()).toString(16),a,l,D)}async createProfile(a,l,D,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(a,l,D);return S&&await this.setProfileForWorkspace(S,b),b}async F(a,l,D){if(!(0,r.$yf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(l);return S||(S=(async()=>{try{const b=this.profiles.find(P=>P.name===l||P.id===a);if(b)return b;const f=t(a,l,(0,L.$vg)(this.profilesHome,a),this.g,D,this.defaultProfile);await this.u.createFolder(f.location);const g=[];return this.j.fire({profile:f,join(P){g.push(P)}}),await p.Promises.settled(g),this.I([f],[],[]),f}finally{this.r.delete(l)}})(),this.r.set(l,S)),S}async updateProfile(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(S=>S.id===a.id);if(!D)throw new Error(`Profile '${a.name}' does not exist`);return D=t(D.id,l.name??D.name,D.location,this.g,{shortName:l.shortName??D.shortName,icon:l.icon===null?void 0:l.icon??D.icon,transient:l.transient??D.isTransient,useDefaultFlags:l.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(S=>S.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const D=[];this.m.fire({profile:l,join(S){D.push(S)}});try{await Promise.allSettled(D)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(S){(0,v.$pk)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(S=>S.id===l.id);if(!D)throw new Error(`Profile '${l.name}' does not exist`);this.L(a,D)}unsetWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.G(a);return A.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(a){return(0,w.$Zh)(a)?a.uri:(0,w.$5h)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location)))}I(a,l,D){const S=[...this.profiles,...a],b=[];this.s.profiles=[];for(let f of S)f.isDefault||l.some(g=>f.id===g.id)||(f=D.find(g=>f.id===g.id)??f,f.isTransient?this.s.profiles.push(f):b.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(b),this.z=void 0,this.J(a,l,D)}J(a,l,D){this.h.fire({added:a,removed:l,updated:D,all:this.profiles})}L(a,l,D){D=l?.isTransient?!0:D,D||this.L(a,void 0,!0);const S=this.G(a),b=D?this.s:this.C;A.URI.isUri(S)?(b.workspaces.delete(S),l&&b.workspaces.set(S,l)):(b.emptyWindows.delete(S),l&&b.emptyWindows.set(S,l)),D||this.M()}M(){const a={};for(const[D,S]of this.C.workspaces.entries())a[D.toString()]=S.id;const l={};for(const[D,S]of this.C.emptyWindows.entries())l[D.toString()]=S.id;this.R({workspaces:a,emptyWindows:l}),this.z=void 0}N(a){const l={},D=this.D();if(a.workspaces)for(const[b,f]of Object.entries(a.workspaces)){const g=A.URI.parse(f);l[b]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}const S={};if(a.emptyWindows)for(const[b,f]of Object.entries(a.emptyWindows)){const g=A.URI.parse(f);S[b]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}return{workspaces:l,emptyWindows:S}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Nk=n,e.$Nk=n=He([Be(0,E.$Wh),Be(1,v.$$j),Be(2,k.$Ik),Be(3,I.$0i)],n);class c extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Ok=c}),define(De[260],Ce([1,0,8,4,3,54,17,184,5,259]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7o=e.$6o=e.$5o=void 0,e.$5o="__$__isNewStorageMarker",e.$6o="__$__targetStorageMarker",e.$7o=(0,E.$Ph)("storageService");var R;(function(r){r[r.NONE=0]="NONE",r[r.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var I;(function(r){r[r.APPLICATION=-1]="APPLICATION",r[r.PROFILE=0]="PROFILE",r[r.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var w;(function(r){r[r.USER=0]="USER",r[r.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function y(r){const s=r.get(e.$6o);if(s)try{return JSON.parse(s)}catch{}return Object.create(null)}e.$8o=y;class k extends d.$Sc{static{this.a=60*1e3}constructor(s={flushInterval:k.a}){super(),this.m=s,this.b=this.B(new F.$Qd),this.c=this.B(new F.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new C.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new d.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(s,m,h){return F.Event.filter(this.b.event,t=>t.scope===s&&(m===void 0||t.key===m),h)}n(){this.j.value=(0,C.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,d.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(s,m){const{key:h,external:t}=m;if(h===e.$6o){switch(s){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:s})}else this.b.fire({scope:s,key:h,target:this.J(s)[h],external:t})}w(s){this.f.fire({reason:s})}get(s,m,h){return this.P(m)?.get(s,h)}getBoolean(s,m,h){return this.P(m)?.getBoolean(s,h)}getNumber(s,m,h){return this.P(m)?.getNumber(s,h)}getObject(s,m,h){return this.P(m)?.getObject(s,h)}storeAll(s,m){this.y(()=>{for(const h of s)this.store(h.key,h.value,h.scope,h.target,m)})}store(s,m,h,t,n=!1){if((0,A.$Hf)(m)){this.remove(s,h,n);return}this.y(()=>{this.z(s,h,t),this.P(h)?.set(s,m,n)})}remove(s,m,h=!1){this.y(()=>{this.z(s,m,void 0),this.P(m)?.delete(s,h)})}y(s){this.b.pause(),this.c.pause();try{s()}finally{this.b.resume(),this.c.resume()}}keys(s,m){const h=[],t=this.J(s);for(const n of Object.keys(t))t[n]===m&&h.push(n);return h}z(s,m,h,t=!1){const n=this.J(m);typeof h=="number"?n[s]!==h&&(n[s]=h,this.P(m)?.set(e.$6o,JSON.stringify(n),t)):typeof n[s]=="number"&&(delete n[s],this.P(m)?.set(e.$6o,JSON.stringify(n),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(s){switch(s){case-1:return this.I;case 0:return this.G;default:return this.D}}L(s){const m=this.P(s);return m?y(m):Object.create(null)}isNew(s){return this.getBoolean(e.$5o,s)===!0}async flush(s=R.NONE){this.f.fire({reason:s});const m=this.P(-1),h=this.P(0),t=this.P(1);switch(s){case R.NONE:await C.Promises.settled([m?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await C.Promises.settled([m?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const s=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return o(s,m,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(s){return await this.flush(),this.P(s)?.optimize()}async switch(s,m){return this.w(R.NONE),(0,v.$Jk)(s)?this.R(s,m):this.S(s,m)}M(s,m){return!(s.id===m.id||p(m)&&p(s))}N(s,m,h){this.y(()=>{const t=new Set;for(const[n,c]of s)t.add(n),m.get(n)!==c&&this.u(h,{key:n,external:!0});for(const[n]of m.items)t.has(n)||this.u(h,{key:n,external:!0})})}}e.$9o=k;function p(r){return r.isDefault||!!r.useDefaultFlags?.globalState}e.$0o=p;class u extends k{constructor(){super(),this.U=this.B(new $.$3o(new $.$4o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new $.$3o(new $.$4o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new $.$3o(new $.$4o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(s=>this.u(1,s))),this.B(this.W.onDidChangeStorage(s=>this.u(0,s))),this.B(this.U.onDidChangeStorage(s=>this.u(-1,s)))}P(s){switch(s){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(s){switch(s){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(s){return!1}}e.$$o=u;async function o(r,s,m,h,t,n){const c=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,a=new Map;r.forEach((P,N)=>{i.set(N,P),a.set(N,c(P))});const l=new Map,D=new Map;s.forEach((P,N)=>{l.set(N,P),D.set(N,c(P))});const S=new Map,b=new Map;m.forEach((P,N)=>{S.set(N,P),b.set(N,c(P))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const f=[];if(i.forEach((P,N)=>{f.push({key:N,value:P})}),console.table(f),console.groupEnd(),console.log(a),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];l.forEach((N,O)=>{P.push({key:O,value:N})}),console.table(P),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${n})`);const g=[];S.forEach((P,N)=>{g.push({key:N,value:P})}),console.table(g),console.groupEnd(),console.log(b)}e.$_o=o}),define(De[107],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=void 0;class C{static{this.a=!1}constructor(d){this.d=d,this.b=new Map,this.c=1}add(d){const L=this.c++;return this.b.set(L,d),this.e(),L}get(d,L){return this.b.has(d)?this.b.get(d)[L]:void 0}delete(d){this.b.delete(d),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$9bc=C}),define(De[55],Ce([1,0,18,23,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=void 0;class L{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new F.$kg($=>{const E=this.b.get($.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos($,E){E===null?this.b.delete($.scheme):this.b.set($.scheme,E)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$$bc=L,e.$_bc=(0,d.$Ph)("IExtHostFileSystemInfo")}),define(De[27],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=void 0,e.$xM=(0,C.$Ph)("IExtHostInitDataService")}),define(De[261],Ce([1,0,206,14,241,27]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;let A=class extends d.$EN{constructor(E,v,R){const I=R.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",w=R.remote.isRemote?(0,C.localize)(0,null):E?(0,C.localize)(1,null):(0,C.localize)(2,null);super(v.createLogger(I,{name:w}))}};e.$hec=A,e.$hec=A=He([Be(1,F.$$i),Be(2,L.$xM)],A)}),define(De[262],Ce([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=e.$Bcc=void 0;class F{constructor(A,$,E){this.h=new Map,this.a=A,this.b=$,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(v=>(this.f=v,this)),this.g=this.c.onDidChangeStorage(v=>{v.shared===this.b&&v.key===this.a&&(this.f=v.value)}),this.i=new C.$6g(()=>{const v=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of v.values())R.complete()}catch(R){for(const I of v.values())I.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,$){let E=this.f[A];return typeof E>"u"&&(E=$),E}update(A,$){this.f[A]=$;const E=this.h.get(A);if(E!==void 0)return E.p;const v=new C.$ch;return this.h.set(A,v),this.i.isScheduled()||this.i.schedule(),v.p}dispose(){this.g.dispose()}}e.$Bcc=F;class d extends F{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,$){super(A.identifier.value,!0,$),this.j=A}}e.$Ccc=d}),define(De[263],Ce([1,0,4,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class d{constructor(A){this.c=A,this.a=new C.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,$,E,v){const I=this.c.getNotebookDocument(F.URI.revive(A)).acceptModelChanged($.value,E,v);this.b.fire(I)}$acceptDirtyStateChanged(A,$){this.c.getNotebookDocument(F.URI.revive(A)).acceptDirty($)}$acceptModelSaved(A){const $=this.c.getNotebookDocument(F.URI.revive(A));this.a.fire($.apiNotebook)}}e.$1dc=d}),define(De[20],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=void 0,e.$hM=(0,C.$Ph)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$iM=F}),define(De[264],Ce([1,0,25,4]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class d{#e;constructor(A,$){this.b=new F.$Nd,this.onDidChange=this.b.event,this.a=C.$6l.toKey(A.identifier),this.#e=$,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,$){return this.#e.store(this.a,A,$)}delete(A){return this.#e.delete(this.a,A)}}e.$Ncc=d}),define(De[67],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=e.$jcc=void 0,e.$jcc=(0,C.$Ph)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$kcc=F}),define(De[265],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acb=e.$zcb=void 0;class F{constructor(){this.buffers=[]}add(E){let v=this.buffers.indexOf(E);return v<0&&(v=this.buffers.length,this.buffers.push(E)),v}}function d($,E){if(E.serializeBuffersForPostMessage){const v=new F,I=JSON.stringify($,(y,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:v.add(k)};if(ArrayBuffer.isView(k)){const p=L(k);if(p)return{$$vscode_array_buffer_reference$$:!0,index:v.add(k.buffer),view:{type:p,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),w=v.buffers.map(y=>{const k=new Uint8Array(y);return C.$be.wrap(k)});return{message:I,buffers:w}}else return{message:JSON.stringify($),buffers:[]}}e.$zcb=d;function L($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A($,E){const v=E.map(w=>{const y=new ArrayBuffer(w.byteLength);return new Uint8Array(y).set(w.buffer),y}),R=E.length?(w,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const k=y,{index:p}=k,u=v[p];if(k.view)switch(k.view.type){case 1:return new Int8Array(u,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return y}:void 0;return{message:JSON.parse($,R),arrayBuffers:v}}e.$Acb=A}),define(De[266],Ce([1,0,267,376,377,60,2,14,378]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;const v=!1;function R(s,m,h,t,n,c){const i=c.environment.useHostProxy,a=typeof i=="boolean"?i:!c.remote.isRemote,l={resolveProxy:b=>s.resolveProxy(b),lookupProxyAuthorization:u.bind(void 0,t,n,m,{},c.remote.isRemote),getProxyURL:()=>m.getConfiguration("http").get("proxy"),getProxySupport:()=>m.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>w(m),getSystemCertificatesV2:()=>y(m),log:(b,f,...g)=>{switch(b){case E.LogLevel.Trace:t.trace(f,...g);break;case E.LogLevel.Debug:t.debug(f,...g);break;case E.LogLevel.Info:t.info(f,...g);break;case E.LogLevel.Warning:t.warn(f,...g);break;case E.LogLevel.Error:t.error(f,...g);break;case E.LogLevel.Critical:t.error(f,...g);break;case E.LogLevel.Off:break;default:P(b,f,g);break}function P(N,O,...M){t.error("Unknown log level",N),t.error(O,...M)}},getLogLevel:()=>{const b=t.getLevel();switch(b){case $.LogLevel.Trace:return E.LogLevel.Trace;case $.LogLevel.Debug:return E.LogLevel.Debug;case $.LogLevel.Info:return E.LogLevel.Info;case $.LogLevel.Warning:return E.LogLevel.Warning;case $.LogLevel.Error:return E.LogLevel.Error;case $.LogLevel.Off:return E.LogLevel.Off;default:return f(b)}function f(g){return t.error("Unknown log level",g),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,addCertificates:[],env:process.env},D=(0,E.createProxyResolver)(l),S=I(l,D);return p(h,S)}e.$Pec=R;function I(s,m){return{http:Object.assign(C,(0,E.createHttpPatch)(s,C,m)),https:Object.assign(F,(0,E.createHttpPatch)(s,F,m)),net:Object.assign(L,(0,E.createNetPatch)(s,L)),tls:Object.assign(d,(0,E.createTlsPatch)(s,d))}}function w(s){const m=s.getConfiguration("http");return!m.get("experimental.systemCertificatesV2",v)&&!!m.get("systemCertificates")}function y(s){const m=s.getConfiguration("http");return!!m.get("experimental.systemCertificatesV2",v)&&!!m.get("systemCertificates")}const k=new Map;function p(s,m){return s.getExtensionPathIndex().then(h=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(i,a,l){if(i==="net")return m.net;if(i==="tls")return m.tls;if(i!=="http"&&i!=="https")return n.apply(this,arguments);const D=h.findSubstr(A.URI.file(a.filename));let S=k.get(D);if(S||k.set(D,S={}),!S[i]){const b=m[i];S[i]={...b}}return S[i]}})}async function u(s,m,h,t,n,c,i,a){const l=t[c];i&&(t[c]=i),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${c}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${l}`);const D=i||l,S=Array.isArray(D)?D:typeof D=="string"?[D]:[];if(r(m,S,n),S.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const b=await new Promise((O,M)=>{$e(["kerberos"],O,M)}),f=new URL(c),g=h.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${f.hostname}`:`HTTP@${f.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${c}`,`spn:${g}`),"Negotiate "+await(await b.initializeClient(g)).step("")}catch(b){s.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let o=!1;function r(s,m,h){o||!m.length||(o=!0,s.$publicLog2("proxyAuthenticationRequest",{authenticationType:m.map(t=>t.split(" ")[0]).join(","),extensionHostType:h?"remote":"local"}))}}),define(De[268],Ce([1,0,128]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;function F(L){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:L,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function d(L){return new C.$Lm(F(L))}e.$Br=d}),define(De[139],Ce([1,0,216,17,2,3,5,43,30,18,41,176,38]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gE=e.$fE=e.$eE=e.EditorsOrder=e.$dE=e.CloseDirection=e.$cE=e.$bE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.EditorInputCapabilities=e.$5D=e.SaveReason=e.Verbosity=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=void 0,e.$SD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$TD={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$UD="workbench.editor.sidebysideEditor",e.$VD="workbench.editors.textDiffEditor",e.$WD="workbench.editors.binaryResourceDiffEditor";var y;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var k;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function p(ce){const we=ce;return!!we&&typeof we.getSelection=="function"&&!!we.onDidChangeSelection}e.$XD=p;function u(ce,we,H){for(const B of H.visibleEditorPanes)if(B.group.id===we&&ce.matches(B.input))return B.getViewState()}e.$YD=u;function o(ce){if(l(ce))return!1;const we=ce;return d.URI.isUri(we?.resource)}e.$ZD=o;function r(ce){if(l(ce))return!1;const we=ce;return we?.original!==void 0&&we.modified!==void 0}e.$1D=r;function s(ce){if(l(ce)||r(ce))return!1;const we=ce;return we?.primary!==void 0&&we.secondary!==void 0}e.$2D=s;function m(ce){if(l(ce))return!1;const we=ce;return we?we.resource===void 0||we.resource.scheme===v.Schemas.untitled||we.forceUntitled===!0:!1}e.$3D=m;function h(ce){if(l(ce))return!1;const we=ce;return d.URI.isUri(we?.base?.resource)&&d.URI.isUri(we?.input1?.resource)&&d.URI.isUri(we?.input2?.resource)&&d.URI.isUri(we?.result?.resource)}e.$4D=h;var t;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class c{constructor(){this.a=new Map}registerSource(we,H){let B=this.a.get(we);return B||(B={source:we,label:H},this.a.set(we,B)),B.source}getSourceLabel(we){return this.a.get(we)?.label??we}}e.$5D=new c;var i;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class a extends L.$Sc{}e.$6D=a;function l(ce){return ce instanceof a}e.$7D=l;function D(ce){const we=ce;return d.URI.isUri(we?.preferredResource)}function S(ce){const we=ce;return l(we?.primary)&&l(we?.secondary)}e.$8D=S;function b(ce){const we=ce;return l(we?.modified)&&l(we?.original)}e.$9D=b;function f(ce,we,H,B,J){return ie(B,[(0,I.$zi)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const re={...H,limits:{size:Number.MAX_VALUE}};ce.openEditor(we,re)}}),(0,I.$zi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>J.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$0D=f;function g(ce){return l(ce?.editor)}e.$$D=g;function P(ce){const we=ce;return g(ce)&&we?.group!==void 0}e.$_D=P;function N(ce){const we=ce;return typeof we?.groupId=="number"&&l(we.editor)}e.$aE=N;var O;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(O||(e.EditorCloseContext=O={}));var M;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var j;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class U{getOriginalUri(we,H){if(!we)return;if(h(we))return e.$cE.getOriginalUri(we.result,H);if(H?.supportSideBySide){const{primary:J,secondary:re}=this.a(we);if(J&&re){if(H?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(J,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===j.ANY)return this.getOriginalUri(J,{filterByScheme:H.filterByScheme})??this.getOriginalUri(re,{filterByScheme:H.filterByScheme});we=H.supportSideBySide===j.PRIMARY?J:re}}if(r(we)||s(we)||h(we))return;const B=D(we)?we.preferredResource:we.resource;return!B||!H||!H.filterByScheme?B:this.b(B,H.filterByScheme)}a(we){return S(we)||s(we)?{primary:we.primary,secondary:we.secondary}:b(we)||r(we)?{primary:we.modified,secondary:we.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(we,H){if(!we)return;if(h(we))return e.$cE.getCanonicalUri(we.result,H);if(H?.supportSideBySide){const{primary:J,secondary:re}=this.a(we);if(J&&re){if(H?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(J,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===j.ANY)return this.getCanonicalUri(J,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:H.filterByScheme});we=H.supportSideBySide===j.PRIMARY?J:re}}if(r(we)||s(we)||h(we))return;const B=we.resource;return!B||!H||!H.filterByScheme?B:this.b(B,H.filterByScheme)}b(we,H){if(Array.isArray(H)){if(H.some(B=>we.scheme===B))return we}else if(H===we.scheme)return we}}var T;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(T||(e.EditorCloseMethod=T={}));function K(ce,we,H,B){if(!ce.isSticky(we))return!1;switch(B.preventPinnedEditorClose){case"keyboardAndMouse":return H===T.MOUSE||H===T.KEYBOARD;case"mouse":return H===T.MOUSE;case"keyboard":return H===T.KEYBOARD}return!1}e.$bE=K,e.$cE=new U;var q;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class ge{constructor(){this.c=new Map,this.d=new Map}start(we){const H=this.a=we.get(A.$Oh);for(const[B,J]of this.c)this.e(B,J,H);this.c.clear()}e(we,H,B){const J=B.createInstance(H);this.d.set(we,J)}registerFileEditorFactory(we){if(this.b)throw new Error("Can only register one file editor factory.");this.b=we}getFileEditorFactory(){return(0,F.$Jf)(this.b)}registerEditorSerializer(we,H){if(this.c.has(we)||this.d.has(we))throw new Error(`A editor serializer with type ID '${we}' was already registered.`);return this.a?this.e(we,H,this.a):this.c.set(we,H),(0,L.$Qc)(()=>{this.c.delete(we),this.d.delete(we)})}getEditorSerializer(we){return this.d.get(typeof we=="string"?we:we.typeId)}}$.$gn.add(e.$SD.EditorFactory,new ge);async function ee(ce,we,H){return!ce||!ce.length?[]:await Promise.all(ce.map(async B=>{const J=d.URI.revive(B.fileUri);if(!J){H.info("Cannot resolve the path because it is not valid.",B);return}if(!await we.canHandleResource(J)){H.info("Cannot resolve the path because it cannot be handled",B);return}let Y=B.exists,_=B.type;if(typeof Y!="boolean"||typeof _!="number")try{_=(await we.stat(J)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Y=!0}catch(pe){H.error(pe),Y=!1}if(!Y&&B.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",B);return}if(_===E.FileType.Directory){H.info("Cannot resolve the path because it is a directory",B);return}const x={...B.options,pinned:!0};return Y?{resource:J,options:x}:{resource:J,options:x,forceUntitled:!0}}))}e.$dE=ee;var Q;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function X(ce){const we=ce;if(!we)return!1;const H=we;if(H.modified)return X(H.modified);const B=we;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.$eE=X;function ae(ce){return(0,R.$Bi)(ce)}e.$fE=ae;function ie(ce,we,H){const B=(0,R.$Ci)(ce,we);return B.forceMessage=H?.forceMessage,B.forceSeverity=H?.forceSeverity,B.allowDialog=H?.allowDialog,B}e.$gE=ie}),define(De[269],Ce([1,0,4,217,5,3,28,43,19,24,79,255]),function($e,e,C,F,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rE=e.$qE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$pE=e.$oE=e.ViewContentGroups=e.$nE=e.$mE=e.ViewContainerLocation=e.Extensions=e.$lE=e.$kE=e.$jE=void 0,e.$jE="views",e.$kE=(0,F.localize)(0,null),e.$lE=(0,I.$6v)("default-view-icon",R.$Uj.window,(0,F.localize)(1,null));var w;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var y;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$mE=[0,1,2];function k(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$nE=k;class p extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new C.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new C.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Rb)([...this.g.values()])}registerViewContainer(c,i,a){const l=this.get(c.id);if(l)return l;const D=c;return D.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:D.openCommandActionDescriptor??{id:D.id},(0,A.$xc)(this.g,i,[]).push(D),a?.isDefault&&this.h.push(D),this.c.fire({viewContainer:D,viewContainerLocation:i}),D}deregisterViewContainer(c){for(const i of this.g.keys()){const a=this.g.get(i),l=a?.indexOf(c);if(l!==-1){a?.splice(l,1),a.length===0&&this.g.delete(i),this.f.fire({viewContainer:c,viewContainerLocation:i});return}}}get(c){return this.all.filter(i=>i.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(i=>this.getViewContainers(i).filter(a=>a?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(i=>this.getViewContainerLocation(i)===c)}}$.$gn.add(w.ViewContainersRegistry,new p);var u;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(u||(e.ViewContentGroups=u={}));function o(n,c){const i=n.group??u.More,a=c.group??u.More;return i!==a?i.localeCompare(a):(n.order??5)-(c.order??5)}class r extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new C.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(c,i){this.registerViews2([{views:c,viewContainer:i}])}registerViews2(c){c.forEach(({views:i,viewContainer:a})=>this.r(i,a)),this.c.fire(c)}deregisterViews(c,i){const a=this.s(c,i);a.length&&this.f.fire({views:a,viewContainer:i})}moveViews(c,i){for(const a of this.m.keys())if(a!==i){const l=this.s(c,a);l.length&&(this.r(l,i),this.g.fire({views:l,from:a,to:i}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const i of this.j){const a=(this.m.get(i)||[]).filter(l=>l.id===c)[0];if(a)return a}return null}getViewContainer(c){for(const i of this.j)if((this.m.get(i)||[]).filter(l=>l.id===c)[0])return i;return null}registerViewWelcomeContent(c,i){return this.n.add(c,i),this.h.fire(c),(0,L.$Qc)(()=>{this.n.delete(c,i),this.h.fire(c)})}registerViewWelcomeContent2(c,i){const a=new Map;for(const[l,D]of i)this.n.add(c,D),a.set(l,(0,L.$Qc)(()=>{this.n.delete(c,D),this.h.fire(c)}));return this.h.fire(c),a}getViewWelcomeContent(c){const i=[];return this.n.forEach(c,a=>i.push(a)),i.sort(o)}r(c,i){let a=this.m.get(i);a||(a=[],this.m.set(i,a),this.j.push(i));for(const l of c){if(this.getView(l.id)!==null)throw new Error((0,F.localize)(2,null,l.id));a.push(l)}}s(c,i){const a=this.m.get(i);if(!a)return[];const l=[],D=[];for(const S of a)c.includes(S)?l.push(S):D.push(S);return l.length&&(D.length?this.m.set(i,D):(this.m.delete(i),this.j.splice(this.j.indexOf(i),1))),l}}$.$gn.add(w.ViewsRegistry,new r),e.$oE=(0,d.$Ph)("viewsService"),e.$pE=(0,d.$Ph)("viewDescriptorService");var s;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(s||(e.ViewVisibilityState=s={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.TreeItemCollapsibleState=m={}));class h{constructor(c,i){this.c=!1,this.d=!1,(0,v.$0m)(this,c),this.d=!!i,this.resolve=async a=>{if(i&&!this.c){const l=await i(a);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$qE=h;class t extends Error{constructor(c){super((0,F.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$rE=t}),define(De[270],Ce([1,0,2,32,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$QE=e.$PE=void 0;function L(v){return!!v&&typeof v=="object"&&"uri"in v&&v.uri instanceof C.URI&&"version"in v&&typeof v.version=="number"&&"ranges"in v&&Array.isArray(v.ranges)&&v.ranges.every(F.$us.isIRange)}e.$PE=L;function A(v){return!!v&&typeof v=="object"&&"documents"in v&&Array.isArray(v.documents)&&v.documents.every(L)}e.$QE=A;var $;(function(v){v[v.Up=1]="Up",v[v.Down=2]="Down"})($||(e.InteractiveSessionVoteDirection=$={}));var E;(function(v){v[v.Action=1]="Action",v[v.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$RE=(0,d.$Ph)("IChatService")}),define(De[140],Ce([1,0,4,8,218]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new C.$Nd,this.n=new C.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,E,v,R){const I={command:$};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.s("request",I),typeof R=="number"){const w=setTimeout(()=>{clearTimeout(w);const y=this.f.get(I.seq);if(y){this.f.delete(I.seq);const k={type:"response",seq:0,request_seq:I.seq,success:!1,command:$,message:(0,d.localize)(0,null,R,$)};y(k)}},R)}return v&&this.f.set(I.seq,v),I.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,E){return $.type!=="event"||E.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,F.$Ug)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const E=$,v=this.f.get(E.request_seq);v&&(this.f.delete(E.request_seq),v(E));break}}}}s($,E){E.type=$,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((E,v)=>$.set(v,E)),await(0,F.$Ug)(500),$.forEach((E,v)=>{E({type:"response",seq:0,request_seq:v,success:!1,command:"canceled",message:"canceled"}),this.f.delete(v)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$6cb=L}),define(De[271],Ce([1,0,219,42,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$4G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$3G=e.MemoryRangeType=e.$2G=e.State=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=void 0,e.$ZF="workbench.view.debug",e.$1F="workbench.debug.variablesView",e.$2F="workbench.debug.watchExpressionsView",e.$3F="workbench.debug.callStackView",e.$4F="workbench.debug.loadedScriptsView",e.$5F="workbench.debug.breakPointsView",e.$6F="workbench.debug.disassemblyView",e.$7F="workbench.panel.repl",e.$8F="workbench.panel.repl.view",e.$9F=new F.$7i("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$0F=new F.$7i("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$$F=new F.$7i("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$_F="debugUx",e.$aG=new F.$7i(e.$_F,"default",{type:"string",description:C.localize(3,null)}),e.$bG=new F.$7i("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$cG=new F.$7i("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$dG=new F.$7i("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$eG=new F.$7i("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$fG=new F.$7i("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$gG=new F.$7i("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$hG=new F.$7i("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$iG=new F.$7i("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$jG=new F.$7i("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$kG=new F.$7i("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$lG=new F.$7i("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$mG=new F.$7i("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$nG=new F.$7i("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$oG=new F.$7i("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$pG=new F.$7i("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$qG=new F.$7i("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$rG=new F.$7i("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$sG=new F.$7i("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$tG=new F.$7i("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$uG=new F.$7i("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$vG=new F.$7i("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$wG=new F.$7i("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$xG=new F.$7i("stepBackSupported",!1,{type:"boolean",description:C.localize(26,null)}),e.$yG=new F.$7i("restartFrameSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$zG=new F.$7i("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(28,null)}),e.$AG=new F.$7i("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$BG=new F.$7i("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$CG=new F.$7i("breakpointsExist",!1,{type:"boolean",description:C.localize(31,null)}),e.$DG=new F.$7i("debuggersAvailable",!1,{type:"boolean",description:C.localize(32,null)}),e.$EG=new F.$7i("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(33,null)}),e.$FG=new F.$7i("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(34,null)}),e.$GG=new F.$7i("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(35,null)}),e.$HG=new F.$7i("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$IG=new F.$7i("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$JG=new F.$7i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$KG=new F.$7i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$LG=new F.$7i("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$MG=new F.$7i("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$NG=new F.$7i("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(42,null)}),e.$OG=new F.$7i("variableIsReadonly",!1,{type:"boolean",description:C.localize(43,null)}),e.$PG=new F.$7i("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(44,null)}),e.$QG=new F.$7i("multiSessionRepl",!1,{type:"boolean",description:C.localize(45,null)}),e.$RG=new F.$7i("multiSessionDebug",!1,{type:"boolean",description:C.localize(46,null)}),e.$SG=new F.$7i("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(47,null)}),e.$TG=new F.$7i("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(48,null)}),e.$UG=new F.$7i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(49,null)}),e.$VG=new F.$7i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(50,null)});const L=w=>C.localize(51,null,w);e.$WG=L,e.$XG="editor.contrib.debug",e.$YG="editor.contrib.breakpoint",e.$ZG="debug",e.$1G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(52,null)};var A;(function(w){w[w.Inactive=0]="Inactive",w[w.Initializing=1]="Initializing",w[w.Stopped=2]="Stopped",w[w.Running=3]="Running"})(A||(e.State=A={}));function $(w){switch(w){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$2G=$;var E;(function(w){w[w.Valid=0]="Valid",w[w.Unreadable=1]="Unreadable",w[w.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$3G="vscode-debug-memory";var v;(function(w){w[w.Initial=1]="Initial",w[w.Dynamic=2]="Dynamic"})(v||(e.DebugConfigurationProviderTriggerKind=v={}));var R;(function(w){w.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$4G=(0,d.$Ph)("debugService");var I;(function(w){w[w.CONDITION=0]="CONDITION",w[w.HIT_COUNT=1]="HIT_COUNT",w[w.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[272],Ce([1,0,15,2,16,24,18,32,21,19]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=void 0;const R=/{([^}]+)}/g;function I(S,b,f){return S.replace(R,function(g,P){return b&&P.length>0&&P[0]!=="_"?g:f&&f.hasOwnProperty(P)?f[P]:g})}e.$oF=I;function w(S){const b={};for(const f of Object.keys(S))f.startsWith("!")||(b[f]=S[f]);return b}e.$pF=w;function y(S){return S.configuration.request==="attach"&&!k(S)&&(!S.parentSession||y(S.parentSession))}e.$qF=y;function k(S){let b=S.configuration.type;if(b)return b==="vslsShare"&&(b=S.configuration.adapterProxy.configuration.type),(0,C.$2e)(b,"extensionhost")||(0,C.$2e)(b,"pwa-extensionhost")?S:S.parentSession?k(S.parentSession):void 0}e.$rF=k;function p(S){return S.type&&(S.label||S.program||S.runtime)}e.$sF=p;function u(S,b,f){let g,P=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=N.exec(S);){const M=O.index+1,j=M+O[0].length;if(M<=b&&j>=f){g=O[0],P=M;break}}if(g){const M=/\w+/g;let j=null;for(;(j=M.exec(g))&&!(j.index+1+P+j[0].length>=f););j&&(g=g.substring(0,M.lastIndex))}return g?{start:P,end:P+g.length-1}:{start:0,end:0}}e.$tF=u;async function o(S,b,f,g){if(S.evaluatableExpressionProvider.has(b)){const P=S.evaluatableExpressionProvider.ordered(b),N=(0,v.$Hb)(await Promise.all(P.map(async O=>{try{return await O.provideEvaluatableExpression(b,f,g??E.CancellationToken.None)}catch{return}})));if(N.length>0){let O=N[0].expression;const M=N[0].range;return O||(O=b.getLineContent(f.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:O}}}else{const P=b.getLineContent(f.lineNumber),{start:N,end:O}=u(P,f.column,f.column),M=P.substring(N-1,O);return{matchingExpression:M,range:new $.$us(f.lineNumber,N,f.lineNumber,N+M.length)}}return null}e.$uF=o;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(S){return!!(S&&S.match(r))}e.$vF=s;function m(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(s(S.path))return F.URI.parse(S.path);if((0,d.$ic)(S.path))return F.URI.file(S.path)}return S.path}function h(S){if(typeof S.path=="object"){const b=F.URI.revive(S.path);if(b)return b.scheme===A.Schemas.file?b.fsPath:b.toString()}return S.path}function t(S,b){const f=b?m:h,g=(0,L.$7m)(S);return c(g,(P,N)=>{P&&N&&(N.path=f(N))}),g}e.$wF=t;function n(S,b){const f=b?m:h,g=(0,L.$7m)(S);return c(g,(P,N)=>{!P&&N&&(N.path=f(N))}),g}e.$xF=n;function c(S,b){switch(S.type){case"event":{const f=S;switch(f.event){case"output":b(!1,f.body.source);break;case"loadedSource":b(!1,f.body.source);break;case"breakpoint":b(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=S;switch(f.command){case"setBreakpoints":b(!0,f.arguments.source);break;case"breakpointLocations":b(!0,f.arguments.source);break;case"source":b(!0,f.arguments.source);break;case"gotoTargets":b(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(g=>b(!1,g));break;default:break}break}case"response":{const f=S;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(g=>b(!1,g.source));break;case"loadedSources":f.body.sources.forEach(g=>b(!1,g));break;case"scopes":f.body.scopes.forEach(g=>b(!1,g.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(g=>b(!1,g.source));break;case"setBreakpoints":f.body.breakpoints.forEach(g=>b(!1,g.source));break;case"disassemble":f.body?.instructions.forEach(P=>b(!1,P.location));break;default:break}break}}}function i(S){return S.filter(b=>!b.presentation?.hidden).sort((b,f)=>b.presentation?f.presentation?b.presentation.group?f.presentation.group?b.presentation.group!==f.presentation.group?b.presentation.group.localeCompare(f.presentation.group):a(b.presentation.order,f.presentation.order):-1:f.presentation.group?1:a(b.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.$yF=i;function a(S,b){return typeof S!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:S-b}async function l(S,b){const f=S.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(f!=="none"&&(await b.saveAll(),f==="allEditorsInActiveGroup")){const g=b.activeEditorPane;g&&g.input.resource?.scheme===A.Schemas.untitled&&await b.save({editor:g.input,groupId:g.group.id})}await S.reloadConfiguration()}e.$zF=l;const D=(S,b)=>!S||!b?S===b:S.name===b.name&&S.path===b.path&&S.sourceReference===b.sourceReference;e.$AF=D}),define(De[273],Ce([1,0,49,60,24,16,12,15,29,220,140]),function($e,e,C,F,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=e.$qec=e.$pec=e.$oec=e.$nec=void 0;class I extends R.$6cb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,r){this.p=r,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",s=>this.w(s))}sendMessage(o){if(this.p){const r=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(r,"utf8")}${I.a}${r}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const r=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,r.length>0)try{this.acceptMessage(JSON.parse(r))}catch(s){this.m.fire(new Error((s.message||s)+`
`+r))}continue}}else{const r=this.r.indexOf(I.a);if(r!==-1){const m=this.r.toString("utf8",0,r).split(I.b);for(const h of m){const t=h.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(r+I.a.length);continue}}break}}}e.$nec=I;class w extends I{startSession(){return new Promise((o,r)=>{let s=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),s=!0}),this.x.on("close",()=>{s?this.m.fire(new Error("connection closed")):r(new Error("connection closed"))}),this.x.on("error",m=>{s?this.m.fire(m):r(m)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$oec=w;class y extends w{constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$pec=y;class k extends w{constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.path,o)}}e.$qec=k;class p extends I{constructor(o,r){super(),this.y=o,this.z=r}async startSession(){const o=this.y.command,r=this.y.args,s=this.y.options||{};try{if(o)if(L.$ic(o)){if(!await E.Promises.exists(o))throw new Error(v.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(v.localize(1,null,this.z));let m=process.env;if(s.env&&Object.keys(s.env).length>0&&(m=d.$0m(d.$7m(process.env),s.env)),o==="node")if(Array.isArray(r)&&r.length>0){const h=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:m,execArgv:h?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(t.cwd=s.cwd);const n=C.fork(r[0],r.slice(1),t);if(!n.pid)throw new Error(v.localize(2,null,r[0]));this.x=n}else throw new Error(v.localize(3,null));else{const h={env:m};s.cwd&&(h.cwd=s.cwd),this.x=C.spawn(o,r,h)}this.x.on("error",h=>{this.m.fire(h)}),this.x.on("exit",(h,t)=>{this.n.fire(h)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",h=>{this.m.fire(h)}),this.x.stdin.on("error",h=>{this.m.fire(h)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(m){this.m.fire(m)}}async stopSession(){return this.x?(await this.u(),A.$j?new Promise((o,r)=>{const s=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(m,h,t){if(m)return r(m)});s.on("exit",o),s.on("error",r)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,r){if(!o)return;const s=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?s.runtime=L.$jc(r,o.runtime):s.runtime=o.runtime),o.runtimeArgs&&(s.runtimeArgs=o.runtimeArgs),o.program&&(L.$ic(o.program)?s.program=o.program:s.program=L.$jc(r,o.program)),o.args&&(s.args=o.args);const m=o;return m.win&&(s.win=p.A(m.win,r)),m.winx86&&(s.winx86=p.A(m.winx86,r)),m.windows&&(s.windows=p.A(m.windows,r)),m.osx&&(s.osx=p.A(m.osx,r)),m.linux&&(s.linux=p.A(m.linux,r)),s}static platformAdapterExecutable(o,r){let s=Object.create(null);r=r.toLowerCase();for(const i of o)if(i.contributes){const a=i.contributes.debuggers;a&&a.length>0&&a.filter(l=>typeof l.type=="string"&&$.$2e(l.type,r)).forEach(l=>{const D=p.A(l,i.extensionLocation.fsPath);s=d.$0m(s,D,i.isBuiltin)})}let m;A.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=s.winx86||s.win||s.windows:A.$j?m=s.win||s.windows:A.$k?m=s.osx:A.$l&&(m=s.linux),m=m||s;const h=m.program||s.program,t=m.args||s.args,n=m.runtime||s.runtime,c=m.runtimeArgs||s.runtimeArgs;if(n)return{type:"executable",command:n,args:(c||[]).concat(typeof h=="string"?[h]:[]).concat(t||[])};if(h)return{type:"executable",command:h,args:t||[]}}}e.$rec=p}),define(De[274],Ce([1,0,49,33,12]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=e.$sec=void 0;function L(v,R){return new Promise((I,w)=>{let y="";const k=C.spawn(v,R);k.pid&&k.stdout.on("data",p=>{y+=p.toString()}),k.on("error",p=>{w(p)}),k.on("close",p=>{I(y)})})}async function A(v){if(v)if(d.$j){const R=await new Promise((I,w)=>{$e(["@vscode/windows-process-tree"],I,w)});return new Promise(I=>{R.getProcessTree(v,w=>{I(!!w&&w.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(v)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$sec=A;var $;(function(v){v[v.cmd=0]="cmd",v[v.powershell=1]="powershell",v[v.bash=2]="bash"})($||($={}));function E(v,R,I,w,y){v=v.trim().toLowerCase();let k;v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0?k=1:v.indexOf("cmd.exe")>=0?k=0:v.indexOf("bash")>=0?k=2:d.$j?k=0:k=2;let p,u=" ";switch(k){case 1:if(p=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),w){const o=(0,F.$3f)(w);o&&(u+=`${o}:; `),u+=`cd ${p(w)}; `}if(y)for(const o in y){const r=y[o];r===null?u+=`Remove-Item env:${o}; `:u+=`\${env:${o}}='${r}'; `}if(R.length>0){const o=R.shift(),r=I?o:p(o);u+=r[0]==="'"?`& ${r} `:`${r} `;for(const s of R)u+=s==="<"||s===">"||I?s:p(s),u+=" "}break;case 0:if(p=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(r=>o.includes(r))||o.length===0?`"${o}"`:o),w){const o=(0,F.$3f)(w);o&&(u+=`${o}: && `),u+=`cd ${p(w)} && `}if(y){u+='cmd /C "';for(const o in y){let r=y[o];r===null?u+=`set "${o}=" && `:(r=r.replace(/[&^|<>]/g,s=>`^${s}`),u+=`set "${o}=${r}" && `)}}for(const o of R)u+=o==="<"||o===">"||I?o:p(o),u+=" ";y&&(u+='"');break;case 2:{p=r=>(r=r.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),r.length===0?'""':r);const o=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(w&&(u+=`cd ${p(w)} ; `),y){u+="/usr/bin/env";for(const r in y){const s=y[r];s===null?u+=` -u ${o(r)}`:u+=` ${o(`${r}=${s}`)}`}u+=" "}for(const r of R)u+=r==="<"||r===">"||I?r:p(r),u+=" ";break}}return u}e.$tec=E}),define(De[108],Ce([1,0,22,35,51,97,18,16,12,42]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sI=e.$rI=e.$qI=e.$pI=e.CellStatusbarAlignment=e.$oI=e.$nI=e.$mI=e.NotebookEditorPriority=e.$lI=e.$kI=e.$jI=e.$iI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$hI=e.$gI=e.$fI=e.$eI=e.CellKind=e.$dI=e.$cI=e.$bI=void 0,e.$bI="workbench.editor.notebook",e.$cI="workbench.editor.notebookTextDiffEditor",e.$dI="workbench.editor.interactive";var R;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(R||(e.CellKind=R={})),e.$eI=["application/json","application/javascript","text/html","image/svg+xml",L.$Qr.latex,L.$Qr.markdown,"image/png","image/jpeg",L.$Qr.text],e.$fI=[L.$Qr.latex,L.$Qr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Qr.text],e.$gI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$hI="_notAvailable";var I;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var w;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var y;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var k;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(k||(e.NotebookRendererMatch=k={}));var p;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var u;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var o;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var r;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var s;(function(T){T.scheme=A.Schemas.vscodeNotebookCell;const K=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${K.join("")}]+`),ge=7;function ee(we,H){const B=H.toString(ge),re=`${B.length<K.length?K[B.length-1]:"z"}${B}s${(0,C.$ve)(C.$be.fromString(we.scheme),!0,!0)}`;return we.with({scheme:T.scheme,fragment:re})}T.generate=ee;function Q(we){if(we.scheme!==T.scheme)return;const H=we.fragment.indexOf("s");if(H<0)return;const B=parseInt(we.fragment.substring(0,H).replace(q,""),ge),J=(0,C.$ue)(we.fragment.substring(H+1)).toString();if(!isNaN(B))return{handle:B,notebook:we.with({scheme:J,fragment:null})}}T.parse=Q;function X(we,H){return we.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${we.scheme!==A.Schemas.file?we.scheme:""}`})}T.generateCellOutputUri=X;function ae(we){if(we.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!H)return;const B=H[1]&&H[1]!==""?H[1]:void 0,J=H[2];return{outputId:B,notebook:we.with({scheme:J||A.Schemas.file,fragment:null})}}T.parseCellOutputUri=ae;function ie(we,H,B){return T.generate(we,H).with({scheme:B})}T.generateCellPropertyUri=ie;function ce(we,H){if(we.scheme===H)return T.parse(we.with({scheme:T.scheme}))}T.parseCellPropertyUri=ce})(s||(e.CellUri=s={}));const m=T=>E.$j?T.replace(/\//g,"\\"):T;class h{constructor(K=[],q=e.$eI){this.e=q,this.d=[...new Set(K)].map(ge=>({pattern:ge,matches:F.$wj(m(ge))}))}sort(K){const q=new Map(d.Iterable.map(K,ee=>[ee,m(ee)]));let ge=[];for(const{matches:ee}of this.d)for(const[Q,X]of q)if(ee(X)){ge.push(Q),q.delete(Q);break}return q.size&&(ge=ge.concat([...q.keys()].sort((ee,Q)=>this.e.indexOf(ee)-this.e.indexOf(Q)))),ge}prioritize(K,q){const ge=this.f(K);if(ge===-1){this.d.unshift({pattern:K,matches:F.$wj(m(K))});return}const ee=new Set(q.map(X=>this.f(X,ge)));ee.delete(-1);const Q=Array.from(ee).sort();this.d.splice(ge+1,0,...Q.map(X=>this.d[X]));for(let X=Q.length-1;X>=0;X--)this.d.splice(Q[X],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,q=this.d.length){const ge=m(K);for(let ee=0;ee<q;ee++)if(this.d[ee].matches(ge))return ee;return-1}}e.$iI=h;function t(T,K,q,ge=(ee,Q)=>ee===Q){const ee=[];function Q(ie,ce,we){if(ce===0&&we.length===0)return;const H=ee[ee.length-1];H&&H.start+H.deleteCount===ie?(H.deleteCount+=ce,H.toInsert.push(...we)):ee.push({start:ie,deleteCount:ce,toInsert:we})}let X=0,ae=0;for(;;){if(X===T.length){Q(X,0,K.slice(ae));break}if(ae===K.length){Q(X,T.length-X,[]);break}const ie=T[X],ce=K[ae];if(ge(ie,ce)){X+=1,ae+=1;continue}q(ce)?(Q(X,1,[]),X+=1):(Q(X,0,[ce]),ae+=1)}return ee}e.$jI=t,e.$kI=new v.$7i("notebookEditorCursorAtBoundary","none"),e.$lI=new v.$7i("notebookEditorCursorAtLineBoundary","none");var n;(function(T){T.default="default",T.option="option"})(n||(e.NotebookEditorPriority=n={}));function c(T){const K=T;return!!((typeof K.include=="string"||F.$xj(K.include))&&(typeof K.exclude=="string"||F.$xj(K.exclude)))}e.$mI=c;function i(T,K,q){if(Array.isArray(T.viewType)&&T.viewType.indexOf(K)>=0||T.viewType===K)return!0;if(T.filenamePattern){const ge=c(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,ee=c(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(F.$vj(ge,(0,$.$nc)(q.fsPath).toLowerCase()))return!(ee&&F.$vj(ee,(0,$.$nc)(q.fsPath).toLowerCase()))}return!1}e.$nI=i,e.$oI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var a;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class l{static{this.d="notebook/"}static create(K){return`${l.d}${K}`}static parse(K){if(K.startsWith(l.d))return K.substring(l.d.length)}}e.$pI=l;function D(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.$qI=D;const S=new TextDecoder;function b(T){const K=[];let q=!1;for(const X of T)(K.length===0||q)&&(K.push(X),q=!0);let ge=P(K);const ee=C.$be.concat(K.map(X=>C.$be.wrap(X))),Q=U(ee);return ge=ge||Q.byteLength!==ee.byteLength,{data:Q,didCompression:ge}}e.$rI=b,e.$sI=`${String.fromCharCode(27)}[A`;const f=e.$sI.split("").map(T=>T.charCodeAt(0)),g=10;function P(T){let K=!1;return T.forEach((q,ge)=>{if(ge===0||q.length<e.$sI.length)return;const ee=T[ge-1],Q=q.subarray(0,e.$sI.length);if(Q[0]===f[0]&&Q[1]===f[1]&&Q[2]===f[2]){const X=ee.lastIndexOf(g);if(X===-1)return;K=!0,T[ge-1]=ee.subarray(0,X),T[ge]=q.subarray(e.$sI.length)}}),K}function N(T){let K=T;do T=K,K=T.replace(/[^\n]\x08/gm,"");while(K.length<T.length);return T}function O(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const K=T.match(/^(.*)\r+/m)[1];let q=T.match(/\r+(.*)$/m)[1];q=q+K.slice(q.length,K.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return T}const M="\b".charCodeAt(0),j="\r".charCodeAt(0);function U(T){return!T.buffer.includes(M)&&!T.buffer.includes(j)?T:C.$be.fromString(O(N(S.decode(T.buffer))))}}),define(De[7],Ce([1,0,19,9,80,28,97,15,17,2,31,25,30,65,108]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k){"use strict";var p,u,o,r,s,m,h,t,n,c,i,a,l,D,S,b,f,g;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$9L=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.TestRunProfileKind=e.TestResultState=e.$PL=e.$OL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$NL=e.$ML=e.$LL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$KL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.ColorThemeKind=e.$EL=e.$DL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$CL=e.DebugConsoleMode=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$wL=e.$vL=e.FileChangeType=e.$uL=e.$tL=e.$sL=e.$rL=e.InlineCompletionTriggerKind=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.ConfigurationTarget=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$7K=e.ViewBadge=e.ProgressLocation=e.$6K=e.$5K=e.TaskScope=e.ShellQuoting=e.$4K=e.$3K=e.$2K=e.TaskPanelKind=e.TaskRevealKind=e.$1K=e.TerminalLocation=e.$ZK=e.$YK=e.$XK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$WK=e.$VK=e.$UK=e.$TK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$SK=e.StatusBarAlignment=e.ViewColumn=e.$RK=e.$QK=e.$PK=e.$OK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$NK=e.$MK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.LanguageStatusSeverity=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.CodeActionTriggerKind=e.$AK=e.$zK=e.SymbolTag=e.SymbolKind=e.$yK=e.DocumentHighlightKind=e.$xK=e.$wK=e.$vK=e.$uK=e.DiagnosticSeverity=e.DiagnosticTag=e.$tK=e.$sK=e.FileEditType=e.$rK=e.$qK=e.$pK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(V){return Object.assign(V,{apply:function(...ye){if(ye.length===0)return Reflect.construct(V,[]);{const Re=ye.length===1?[]:ye[1];return Reflect.construct(V,Re,ye[0].constructor)}},call:function(...ye){if(ye.length===0)return Reflect.construct(V,[]);{const[Re,...Qe]=ye;return Reflect.construct(V,Qe,Re.constructor)}}})}var N;(function(V){V[V.Top=0]="Top",V[V.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(V){V[V.TerminalCommand=0]="TerminalCommand",V[V.Opener=1]="Opener",V[V.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let M=p=class{static from(...W){let ye=W;return new p(function(){if(ye){for(const Re of ye)Re&&typeof Re.dispose=="function"&&Re.dispose();ye=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$iK=M,e.$iK=M=p=He([P],M);let j=u=class{static Min(...W){if(W.length===0)throw new TypeError;let ye=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isBefore(ye)&&(ye=Qe)}return ye}static Max(...W){if(W.length===0)throw new TypeError;let ye=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isAfter(ye)&&(ye=Qe)}return ye}static isPosition(W){if(!W)return!1;if(W instanceof u)return!0;const{line:ye,character:Re}=W;return typeof ye=="number"&&typeof Re=="number"}static of(W){if(W instanceof u)return W;if(this.isPosition(W))return new u(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ye){if(W<0)throw(0,F.$7)("line must be non-negative");if(ye<0)throw(0,F.$7)("character must be non-negative");this.c=W,this.e=ye}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ye=0){if(W===null||ye===null)throw(0,F.$7)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,ye=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&ye===0?this:new u(this.line+Re,this.character+ye)}with(W,ye=this.character){if(W===null||ye===null)throw(0,F.$7)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,ye=typeof W.character=="number"?W.character:this.character),Re===this.line&&ye===this.character?this:new u(Re,ye)}toJSON(){return{line:this.line,character:this.character}}};e.$jK=j,e.$jK=j=u=He([P],j);let U=o=class{static isRange(W){return W instanceof o?!0:W?j.isPosition(W.start)&&j.isPosition(W.end):!1}static of(W){if(W instanceof o)return W;if(this.isRange(W))return new o(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ye,Re,Qe){let tt,at;if(typeof W=="number"&&typeof ye=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,ye),at=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(ye)&&(tt=j.of(W),at=j.of(ye)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this.c=tt,this.e=at):(this.c=at,this.e=tt)}contains(W){return o.isRange(W)?this.contains(W.start)&&this.contains(W.end):j.isPosition(W)?!(j.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ye=j.Max(W.start,this.c),Re=j.Min(W.end,this.e);if(!ye.isAfter(Re))return new o(ye,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ye=j.Min(W.start,this.c),Re=j.Max(W.end,this.end);return new o(ye,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ye=this.end){if(W===null||ye===null)throw(0,F.$7)();let Re;return W?j.isPosition(W)?Re=W:(Re=W.start||this.start,ye=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&ye.isEqual(this.end)?this:new o(Re,ye)}toJSON(){return[this.start,this.end]}};e.$kK=U,e.$kK=U=o=He([P],U);let T=r=class extends U{static isSelection(W){return W instanceof r?!0:W?U.isRange(W)&&j.isPosition(W.anchor)&&j.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ye,Re,Qe){let tt,at;if(typeof W=="number"&&typeof ye=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,ye),at=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(ye)&&(tt=j.of(W),at=j.of(ye)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this.f=tt,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$lK=T,e.$lK=T=r=He([P],T);const K=V=>{if(typeof V!="string"||V.length===0||!/^[0-9A-Za-z_\-]+$/.test(V))throw(0,F.$7)("connectionToken")};class q{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ye,Re){if(typeof W!="string"||W.length===0)throw(0,F.$7)("host");if(typeof ye!="number"||ye===0||Math.round(ye)!==ye)throw(0,F.$7)("port");typeof Re<"u"&&K(Re),this.host=W,this.port=Math.round(ye),this.connectionToken=Re}}e.$mK=q;class ge{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ye){this.makeConnection=W,this.connectionToken=ye,typeof ye<"u"&&K(ye)}}e.$nK=ge;class ee extends Error{static NotAvailable(W,ye){return new ee(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,ye)}static TemporarilyNotAvailable(W){return new ee(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ye=y.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=ye,this._detail=Re,Object.setPrototypeOf(this,ee.prototype)}}e.$oK=ee;var Q;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var X;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let ae=s=class{static isTextEdit(W){return W instanceof s?!0:W?U.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ye){return new s(W,ye)}static insert(W,ye){return s.replace(new U(W,W),ye)}static delete(W){return s.replace(W,"")}static setEndOfLine(W){const ye=new s(new U(new j(0,0),new j(0,0)),"");return ye.newEol=W,ye}get range(){return this.c}set range(W){if(W&&!U.isRange(W))throw(0,F.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,F.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,F.$7)("newEol");this.f=W}constructor(W,ye){this.c=W,this.e=ye}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$pK=ae,e.$pK=ae=s=He([P],ae);let ie=m=class{static isNotebookCellEdit(W){return W instanceof m?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ye){return new m(W,ye)}static insertCells(W,ye){return new m(new xt(W,W),ye)}static deleteCells(W){return new m(W,[])}static updateCellMetadata(W,ye){const Re=new m(new xt(W,W),[]);return Re.newCellMetadata=ye,Re}static updateNotebookMetadata(W){const ye=new m(new xt(0,0),[]);return ye.newNotebookMetadata=W,ye}constructor(W,ye){this.range=W,this.newCells=ye}};e.$qK=ie,e.$qK=ie=m=He([P],ie);class ce{static isSnippetTextEdit(W){return W instanceof ce?!0:W?U.isRange(W.range)&&B.isSnippetString(W.snippet):!1}static replace(W,ye){return new ce(W,ye)}static insert(W,ye){return ce.replace(new U(W,W),ye)}constructor(W,ye){this.range=W,this.snippet=ye}}e.$rK=ce;var we;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace",V[V.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let H=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ye,Re,Qe){this.c.push({_type:1,from:W,to:ye,options:Re,metadata:Qe})}createFile(W,ye,Re){this.c.push({_type:1,from:void 0,to:W,options:ye,metadata:Re})}deleteFile(W,ye,Re){this.c.push({_type:1,from:W,to:void 0,options:ye,metadata:Re})}e(W,ye,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:ye},notebookMetadata:ye})}f(W,ye,Re,Qe){const tt=ye.start,at=ye.end;(tt!==at||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:at-tt,cells:Re,metadata:Qe})}g(W,ye,Re,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:ye,metadata:Re}})}replace(W,ye,Re,Qe){this.c.push({_type:2,uri:W,edit:new ae(ye,Re),metadata:Qe})}insert(W,ye,Re,Qe){this.replace(W,new U(ye,ye),Re,Qe)}delete(W,ye,Re){this.replace(W,ye,"",Re)}has(W){return this.c.some(ye=>ye._type===2&&ye.uri.toString()===W.toString())}set(W,ye){if(ye)for(const Re of ye){if(!Re)continue;let Qe,tt;Array.isArray(Re)?(Qe=Re[0],tt=Re[1]):Qe=Re,ie.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,tt):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,tt):this.f(W,Qe.range,Qe.newCells,tt):ce.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Qe,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Qe=this.c[Re];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,C.$Ib)(this.c)}}get(W){const ye=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&ye.push(Re.edit);return ye}entries(){const W=new L.$Ac;for(const ye of this.c)if(ye._type===2){let Re=W.get(ye.uri);Re||(Re=[ye.uri,[]],W.set(ye.uri,Re)),Re[1].push(ye.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$sK=H,e.$sK=H=He([P],H);let B=h=class{static isSnippetString(W){return W instanceof h?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=h.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ye=this.e++){if(typeof W=="function"){const Re=new h;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=h.c(W);return this.value+="${",this.value+=ye,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ye=this.e++){const Re=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ye,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,ye){if(typeof ye=="function"){const Re=new h;Re.e=this.e,ye(Re),this.e=Re.e,ye=Re.value}else typeof ye=="string"&&(ye=ye.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ye&&(this.value+=":",this.value+=ye),this.value+="}",this}};e.$tK=B,e.$tK=B=h=He([P],B);var J;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(J||(e.DiagnosticTag=J={}));var re;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let Y=t=class{static isLocation(W){return W instanceof t?!0:W?U.isRange(W.range)&&v.URI.isUri(W.uri):!1}constructor(W,ye){if(this.uri=W,ye)if(U.isRange(ye))this.range=U.of(ye);else if(j.isPosition(ye))this.range=new U(ye,ye);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$uK=Y,e.$uK=Y=t=He([P],Y);let _=class{static is(W){return W?typeof W.message=="string"&&W.location&&U.isRange(W.location.range)&&v.URI.isUri(W.location.uri):!1}constructor(W,ye){this.location=W,this.message=ye}static isEqual(W,ye){return W===ye?!0:!W||!ye?!1:W.message===ye.message&&W.location.range.isEqual(ye.location.range)&&W.location.uri.toString()===ye.location.uri.toString()}};e.$vK=_,e.$vK=_=He([P],_);let x=class{constructor(W,ye,Re=re.Error){if(!U.isRange(W))throw new TypeError("range must be set");if(!ye)throw new TypeError("message must be set");this.range=W,this.message=ye,this.severity=Re}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ye){return W===ye?!0:!W||!ye?!1:W.message===ye.message&&W.severity===ye.severity&&W.code===ye.code&&W.severity===ye.severity&&W.source===ye.source&&W.range.isEqual(ye.range)&&(0,C.$ub)(W.tags,ye.tags)&&(0,C.$ub)(W.relatedInformation,ye.relatedInformation,_.isEqual)}};e.$wK=x,e.$wK=x=He([P],x);let pe=class{constructor(W,ye){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ye}};e.$xK=pe,e.$xK=pe=He([P],pe);var ue;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ue||(e.DocumentHighlightKind=ue={}));let fe=class{constructor(W,ye=ue.Text){this.range=W,this.kind=ye}toJSON(){return{range:this.range,kind:ue[this.kind]}}};e.$yK=fe,e.$yK=fe=He([P],fe);var te;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var de;(function(V){V[V.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let be=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ye,Re,Qe,tt){this.name=W,this.kind=ye,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Qe instanceof Y?this.location=Qe:Re instanceof U&&(this.location=new Y(Qe,Re)),n.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$zK=be,e.$zK=be=n=He([P],be);let Pe=c=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(c.validate)}constructor(W,ye,Re,Qe,tt){this.name=W,this.detail=ye,this.kind=Re,this.range=Qe,this.selectionRange=tt,this.children=[],c.validate(this)}};e.$AK=Pe,e.$AK=Pe=c=He([P],Pe);var z;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(z||(e.CodeActionTriggerKind=z={}));let G=class{constructor(W,ye){this.title=W,this.kind=ye}};e.$BK=G,e.$BK=G=He([P],G);let se=class{static{i=this}static{this.c="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.c)}};e.$CK=se,e.$CK=se=i=He([P],se),se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorMove=se.Refactor.append("move"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll"),se.Notebook=se.Empty.append("notebook");let oe=class{constructor(W,ye){if(this.range=W,this.parent=ye,ye&&!ye.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$DK=oe,e.$DK=oe=He([P],oe);class Z{constructor(W,ye,Re,Qe,tt,at){this.kind=W,this.name=ye,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$EK=Z;class me{constructor(W,ye){this.fromRanges=ye,this.from=W}}e.$FK=me;class Ee{constructor(W,ye){this.fromRanges=ye,this.to=W}}e.$GK=Ee;var je;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,ye){this.range=W,this.command=ye}get isResolved(){return!!this.command}};e.$HK=We,e.$HK=We=He([P],We);let _e=a=class{#e;static isMarkdownString(W){return W instanceof a?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ye=!1){this.#e=new d.$3j(W,{supportThemeIcons:ye})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ye){return this.#e.appendCodeblock(ye??"",W),this}};e.$IK=_e,e.$IK=_e=a=He([P],_e);let Ye=class{constructor(W,ye){this.label=W,this.documentation=ye}};e.$JK=Ye,e.$JK=Ye=He([P],Ye);let it=class{constructor(W,ye){this.label=W,this.documentation=ye,this.parameters=[]}};e.$KK=it,e.$KK=it=He([P],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$LK=et,e.$LK=et=He([P],et);var Ae;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Ne;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Ne||(e.InlayHintKind=Ne={}));let qe=class{constructor(W){this.value=W}};e.$MK=qe,e.$MK=qe=He([P],qe);let Le=class{constructor(W,ye,Re){this.position=W,this.label=ye,this.kind=Re}};e.$NK=Le,e.$NK=Le=He([P],Le);var Xe;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var he;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(he||(e.CompletionItemKind=he={}));var le;(function(V){V[V.Deprecated=1]="Deprecated"})(le||(e.CompletionItemTag=le={}));let Ie=class{constructor(W,ye){this.label=W,this.kind=ye}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$OK=Ie,e.$OK=Ie=He([P],Ie);let Ve=class{constructor(W=[],ye=!1){this.items=W,this.isIncomplete=ye}};e.$PK=Ve,e.$PK=Ve=He([P],Ve);let ze=class{constructor(W,ye,Re){this.insertText=W,this.range=ye,this.command=Re}};e.$QK=ze,e.$QK=ze=He([P],ze);let xe=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$RK=xe,e.$RK=xe=He([P],xe);var rt;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ot;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function $t(V,W){return`${I.$6l.toKey(V)}.${W}`}e.$SK=$t;var St;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(St||(e.TextEditorLineNumbersStyle=St={}));var Yt;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var Gt;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var vt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var zt;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var Nt;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(V){function W(ye){switch(ye){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=W}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Bt;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(V){function W(ye){switch(ye){case V.Other:return"other";case V.Comment:return"comment";case V.String:return"string";case V.RegEx:return"regex"}return"other"}V.toString=W}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(W,ye){if(ye&&!v.URI.isUri(ye))throw(0,F.$7)("target");if(!U.isRange(W)||W.isEmpty)throw(0,F.$7)("range");this.range=W,this.target=ye}};e.$TK=At,e.$TK=At=He([P],At);let Rt=class{constructor(W,ye,Re,Qe){this.red=W,this.green=ye,this.blue=Re,this.alpha=Qe}};e.$UK=Rt,e.$UK=Rt=He([P],Rt);let Ot=class{constructor(W,ye){if(ye&&!(ye instanceof Rt))throw(0,F.$7)("color");if(!U.isRange(W)||W.isEmpty)throw(0,F.$7)("range");this.range=W,this.color=ye}};e.$VK=Ot,e.$VK=Ot=He([P],Ot);let Wt=class{constructor(W){if(!W||typeof W!="string")throw(0,F.$7)("label");this.label=W}};e.$WK=Wt,e.$WK=Wt=He([P],Wt);var Jt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var qt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var Vt;(function(V){V[V.Unknown=0]="Unknown",V[V.Shutdown=1]="Shutdown",V[V.Process=2]="Process",V[V.User=3]="User",V[V.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Lt{constructor(W,ye,Re){if(this.startIndex=W,this.length=ye,this.tooltip=Re,typeof W!="number"||W<0)throw(0,F.$7)("startIndex");if(typeof ye!="number"||ye<1)throw(0,F.$7)("length");if(Re!==void 0&&typeof Re!="string")throw(0,F.$7)("tooltip")}}e.$XK=Lt;class lt{constructor(W){this.uri=W}}e.$YK=lt;class ft{constructor(W){this.terminalCommand=W}}e.$ZK=ft;var Tt;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(Tt||(e.TerminalLocation=Tt={}));class Kt{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.$7)("options")}}e.$1K=Kt;var Dt;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Dt||(e.TaskRevealKind=Dt={}));var ct;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(ct||(e.TaskPanelKind=ct={}));let wt=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(W,ye){if(this.label=ye,typeof W!="string"||typeof ye!="string")throw(0,F.$7)("name");this.c=W}get id(){return this.c}};e.$2K=wt,e.$2K=wt=l=He([P],wt);function Ht(V){let W="";for(let ye=0;ye<V.length;ye++)W+=V[ye].replace(/,/g,",,")+",";return W}let Pt=class{constructor(W,ye,Re){if(typeof W!="string")throw(0,F.$7)("process");this.e=[],this.c=W,ye!==void 0&&(Array.isArray(ye)?(this.e=ye,this.f=Re):this.f=ye)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,F.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ye of this.e)W.push(ye);return Ht(W)}};e.$3K=Pt,e.$3K=Pt=He([P],Pt);let Ge=class{constructor(W,ye,Re){if(this.f=[],Array.isArray(ye)){if(!W)throw(0,F.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$7)("command");this.e=W,this.f=ye,this.g=Re}else{if(typeof W!="string")throw(0,F.$7)("commandLine");this.c=W,this.g=ye}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,F.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ye of this.f)W.push(typeof ye=="string"?ye:ye.value);return Ht(W)}};e.$4K=Ge,e.$4K=Ge=He([P],Ge);var Me;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(Me||(e.ShellQuoting=Me={}));var Te;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Te||(e.TaskScope=Te={}));class Se{constructor(W){this.c=W}computeId(){return"customExecution"+(0,R.$eg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$5K=Se;let ne=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ye,Re,Qe,tt,at){this.j=!1,this.k=this.definition=W;let dt;typeof ye=="string"?(this.m=this.name=ye,this.t=this.source=Re,this.execution=Qe,dt=tt,this.j=!0):ye===Te.Global||ye===Te.Workspace?(this.target=ye,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,dt=at):(this.target=ye,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Pt?this.k={type:D.e,id:this.n.computeId()}:this.n instanceof Ge?this.k={type:D.f,id:this.n.computeId()}:this.n instanceof Se?this.k={type:D.c,id:this.n.computeId()}:this.k={type:D.g,id:(0,R.$eg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,F.$7)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,F.$7)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const ye=this.k.type;(D.g===ye||D.e===ye||D.f===ye||D.c===ye)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.$7)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$6K=ne,e.$6K=ne=D=He([P],ne);var Fe;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var Ke;(function(V){function W(ye){const Re=ye;return(0,E.$Cf)(Re.value)?Re.tooltip&&!(0,E.$yf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}V.isViewBadge=W})(Ke||(e.ViewBadge=Ke={}));let Ze=S=class{static isTreeItem(W,ye){const Re=W;if(Re.checkboxState!==void 0){const Qe=(0,E.$Cf)(Re.checkboxState)?Re.checkboxState:(0,E.$Af)(Re.checkboxState)&&(0,E.$Cf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,E.$Cf)(Re.checkboxState)&&(0,E.$Af)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==nt.Checked&&Qe!==nt.Unchecked||tt!==void 0&&!(0,E.$yf)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof S)return!0;if(Re.label!==void 0&&!(0,E.$yf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,E.$yf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,E.$yf)(Re.iconPath)&&!v.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,E.$yf)(Re.iconPath.id))){const Qe=Re.iconPath;if(!Qe||!(0,E.$yf)(Qe.light)&&!v.URI.isUri(Qe.light)&&!(0,E.$yf)(Qe.dark)&&!v.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,E.$yf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!v.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,E.$yf)(Re.tooltip)&&!(Re.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<Je.None&&Re.collapsibleState>Je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,E.$yf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,ye=Je.None){this.collapsibleState=ye,v.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$7K=Ze,e.$7K=Ze=S=He([P],Ze);var Je;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(Je||(e.TreeItemCollapsibleState=Je={}));var nt;(function(V){V[V.Unchecked=0]="Unchecked",V[V.Checked=1]="Checked"})(nt||(e.TreeItemCheckboxState=nt={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$8K=pt,e.$8K=pt=He([P],pt);class jt extends pt{}e.$9K=jt;class kt extends jt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$0K=kt;class ht{constructor(W,ye,Re,Qe){this.name=W,this.uri=ye,this._itemId=Re,this.c=Qe}data(){return this.c()}}e.$$K=ht;let gt=class{#e=new Map;constructor(W){for(const[ye,Re]of W??[]){const Qe=this.#e.get(this.#t(ye));Qe?Qe.push(Re):this.#e.set(this.#t(ye),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ye){this.#e.set(this.#t(W),[ye])}forEach(W,ye){for(const[Re,Qe]of this.#e)for(const tt of Qe)W.call(ye,tt,Re,this)}*[Symbol.iterator](){for(const[W,ye]of this.#e)for(const Re of ye)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$_K=gt,e.$_K=gt=He([P],gt);let yt=class{constructor(W){this.insertText=W}};e.$aL=yt,e.$aL=yt=He([P],yt);let mi=class{constructor(W,ye){this.label=ye,this.insertText=W}};e.$bL=mi,e.$bL=mi=He([P],mi);let Ct=class{constructor(W,ye){this.id=W,this.color=ye}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$cL=Ct,e.$cL=Ct=He([P],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Di=class{constructor(W){this.id=W}};e.$dL=Di,e.$dL=Di=He([P],Di);var ui;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let $i=class{get base(){return this.c}set base(W){this.c=W,this.e=v.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ye){if(typeof W!="string"&&(!W||!v.URI.isUri(W)&&!v.URI.isUri(W.uri)))throw(0,F.$7)("base");if(typeof ye!="string")throw(0,F.$7)("pattern");typeof W=="string"?this.baseUri=v.URI.file(W):v.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ye}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eL=$i,e.$eL=$i=He([P],$i);const It=new WeakMap;function fn(V,W){It.set(V,W)}e.$fL=fn;let ri=class{constructor(W,ye,Re,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof ye=="string"&&(this.condition=ye),typeof Re=="string"&&(this.hitCondition=Re),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=It.get(this)??(0,R.$eg)()),this.c}};e.$gL=ri,e.$gL=ri=He([P],ri);let Et=class extends ri{constructor(W,ye,Re,Qe,tt){if(super(ye,Re,Qe,tt),W===null)throw(0,F.$7)("location");this.location=W}};e.$hL=Et,e.$hL=Et=He([P],Et);let bi=class extends ri{constructor(W,ye,Re,Qe,tt){super(ye,Re,Qe,tt),this.functionName=W}};e.$iL=bi,e.$iL=bi=He([P],bi);let vi=class extends ri{constructor(W,ye,Re,Qe,tt,at,dt){if(super(Qe,tt,at,dt),!ye)throw(0,F.$7)("dataId");this.label=W,this.dataId=ye,this.canPersist=Re}};e.$jL=vi,e.$jL=vi=He([P],vi);let si=class{constructor(W,ye,Re){this.command=W,this.args=ye||[],this.options=Re}};e.$kL=si,e.$kL=si=He([P],si);let Ci=class{constructor(W,ye){this.port=W,this.host=ye}};e.$lL=Ci,e.$lL=Ci=He([P],Ci);let Ii=class{constructor(W){this.path=W}};e.$mL=Ii,e.$mL=Ii=He([P],Ii);let Mt=class{constructor(W){this.implementation=W}};e.$nL=Mt,e.$nL=Mt=He([P],Mt);let wi=class{constructor(W,ye,Re){this.session=W,this.threadId=ye,this.frameId=Re}};e.$oL=wi,e.$oL=wi=He([P],wi);let Pi=class{constructor(W,ye){this.session=W,this.threadId=ye}};e.$pL=Pi,e.$pL=Pi=He([P],Pi);let oi=class{constructor(W,ye){this.range=W,this.expression=ye}};e.$qL=oi,e.$qL=oi=He([P],oi);var li;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(li||(e.InlineCompletionTriggerKind=li={}));let ut=class{constructor(W,ye){this.range=W,this.text=ye}};e.$rL=ut,e.$rL=ut=He([P],ut);let Ai=class{constructor(W,ye,Re=!0){this.range=W,this.variableName=ye,this.caseSensitiveLookup=Re}};e.$sL=Ai,e.$sL=Ai=He([P],Ai);let Zt=class{constructor(W,ye){this.range=W,this.expression=ye}};e.$tL=Zt,e.$tL=Zt=He([P],Zt);let ii=class{constructor(W,ye){this.frameId=W,this.stoppedLocation=ye}};e.$uL=ii,e.$uL=ii=He([P],ii);var Ri;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Li=b=class extends Error{static FileExists(W){return new b(W,w.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(W){return new b(W,w.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(W){return new b(W,w.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(W){return new b(W,w.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(W){return new b(W,w.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(W){return new b(W,w.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(W,ye=w.FileSystemProviderErrorCode.Unknown,Re){super(v.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,w.$nk)(this,ye),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$vL=Li,e.$vL=Li=b=He([P],Li);let Mi=class{constructor(W,ye,Re){this.start=W,this.end=ye,this.kind=Re}};e.$wL=Mi,e.$wL=Mi=He([P],Mi);var Xi;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Fi;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Yi;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Yi||(e.CommentMode=Yi={}));var Ti;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(W,ye=[]){this.tokenTypes=W,this.tokenModifiers=ye}}e.$xL=gn;function Ni(V){return typeof V>"u"||(0,E.$zf)(V)}class hi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ye=0,Re=W.tokenTypes.length;ye<Re;ye++)this.j.set(W.tokenTypes[ye],ye);for(let ye=0,Re=W.tokenModifiers.length;ye<Re;ye++)this.k.set(W.tokenModifiers[ye],ye)}}push(W,ye,Re,Qe,tt){if(typeof W=="number"&&typeof ye=="number"&&typeof Re=="number"&&typeof Qe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,ye,Re,Qe,tt);if(U.isRange(W)&&typeof ye=="string"&&Ni(Re))return this.m(W,ye,Re);throw(0,F.$7)()}m(W,ye,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ye))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,dt=this.j.get(ye);let Ut=0;if(Re)for(const Xt of Re){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);Ut|=1<<ei>>>0}this.n(Qe,tt,at,dt,Ut)}n(W,ye,Re,Qe,tt){if(this.f&&(W<this.c||W===this.c&&ye<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<Ut;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Xt,Ji+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Xt=ni,ei=Ji}}let at=W,dt=ye;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=Re,this.g[this.h++]=Qe,this.g[this.h++]=tt,this.c=W,this.e=ye}static o(W){const ye=[],Re=W.length/5|0;for(let dt=0;dt<Re;dt++)ye[dt]=dt;ye.sort((dt,Ut)=>{const Xt=W[5*dt],ei=W[5*Ut];if(Xt===ei){const ti=W[5*dt+1],ni=W[5*Ut+1];return ti-ni}return Xt-ei});const Qe=new Uint32Array(W.length);let tt=0,at=0;for(let dt=0;dt<Re;dt++){const Ut=5*ye[dt],Xt=W[Ut+0],ei=W[Ut+1],ti=W[Ut+2],ni=W[Ut+3],Ji=W[Ut+4],In=Xt-tt,Fn=In===0?ei-at:ei,Qi=5*dt;Qe[Qi+0]=In,Qe[Qi+1]=Fn,Qe[Qi+2]=ti,Qe[Qi+3]=ni,Qe[Qi+4]=Ji,tt=Xt,at=ei}return Qe}build(W){return this.f?new Oi(new Uint32Array(this.g),W):new Oi(hi.o(this.g),W)}}e.$yL=hi;class Oi{constructor(W,ye){this.resultId=ye,this.data=W}}e.$zL=Oi;class mn{constructor(W,ye,Re){this.start=W,this.deleteCount=ye,this.data=Re}}e.$AL=mn;class di{constructor(W,ye){this.resultId=ye,this.edits=W}}e.$BL=di;var Zi;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let ji=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$CL=ji,e.$CL=ji=He([P],ji);var xi;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var fi;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var _i;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(W){if(typeof W.badge=="string"){let ye=(0,$.$_e)(W.badge,0);if(ye<W.badge.length&&(ye+=(0,$.$_e)(W.badge,ye)),W.badge.length>ye)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ct.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ye,Re){this.badge=W,this.tooltip=ye,this.color=Re}}e.$DL=$n;let Ui=class{constructor(W){this.kind=W}};e.$EL=Ui,e.$EL=Ui=He([P],Ui);var gi;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(gi||(e.ColorThemeKind=gi={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ye){if(W<0)throw(0,F.$7)("start must be positive");if(ye<0)throw(0,F.$7)("end must be positive");W<=ye?(this.c=W,this.e=ye):(this.c=ye,this.e=W)}with(W){let ye=this.c,Re=this.e;return W.start!==void 0&&(ye=W.start),W.end!==void 0&&(Re=W.end),ye===this.c&&Re===this.e?this:new xt(ye,Re)}}e.$FL=xt;class pi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ye=>pi.isNotebookCellData(ye))}static isNotebookCellData(W){return!0}constructor(W,ye,Re,Qe,tt,at,dt){this.kind=W,this.value=ye,this.languageId=Re,this.mime=Qe,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,pi.validate(this)}}e.$GL=pi;class bn{constructor(W){this.cells=W}}e.$HL=bn;class Qt{static isNotebookCellOutputItem(W){return W instanceof Qt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ye={name:W.name,message:W.message,stack:W.stack};return Qt.json(ye,"application/vnd.code.notebook.error")}static stdout(W){return Qt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Qt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ye="application/octet-stream"){return new Qt(W,ye)}static#e=new TextEncoder;static text(W,ye=A.$Qr.text){const Re=Qt.#e.encode(String(W));return new Qt(Re,ye)}static json(W,ye="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Qt.text(Re,ye)}constructor(W,ye){this.data=W,this.mime=ye;const Re=(0,A.$Ur)(ye,!0);if(!Re)throw new Error(`INVALID mime type: ${ye}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$IL=Qt;class yi{static isNotebookCellOutput(W){return W instanceof yi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ye=!1){const Re=new Set,Qe=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],dt=(0,A.$Ur)(at.mime);if(!Re.has(dt)||(0,k.$qI)(dt)){Re.add(dt);continue}Qe.add(tt),ye&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Qe.size===0?W:W.filter((tt,at)=>!Qe.has(at))}constructor(W,ye,Re){this.items=yi.ensureUniqueMimeTypes(W,!0),typeof ye=="string"?(this.id=ye,this.metadata=Re):(this.id=(0,R.$eg)(),this.metadata=ye??Re)}}e.$JL=yi;var en;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var tn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ei;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class rn{constructor(W,ye){this.text=W,this.alignment=ye}}e.$KL=rn;var Ue;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Ue||(e.NotebookControllerAffinity=Ue={}));var _t;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred",V[V.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class sn{constructor(W,ye=[]){this.uri=W,this.provides=(0,C.$3b)(ye)}}e.$LL=sn;class mt{constructor(W){this.label=W}}e.$ML=mt;let zi=class{constructor(W,ye){this.label=W,this.timestamp=ye}};e.$NL=zi,e.$NL=zi=He([P],zi);var on;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Bi;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var an;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class ki{constructor(W,ye){this.ranges=W,this.wordPattern=ye}}e.$OL=ki;class vn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$PL=vn;var cn;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Si=class{constructor(W=void 0,ye=void 0,Re=void 0,Qe=!1){this.include=W,this.exclude=ye,this.profile=Re,this.continuous=Qe}};e.$QL=Si,e.$QL=Si=He([P],Si);let Wi=f=class{static diff(W,ye,Re){const Qe=new f(W);return Qe.expectedOutput=ye,Qe.actualOutput=Re,Qe}constructor(W){this.message=W}};e.$RL=Wi,e.$RL=Wi=f=He([P],Wi);let qi=class{constructor(W){this.id=W}};e.$SL=qi,e.$SL=qi=He([P],qi);let ci=class{constructor(W,ye){this.covered=W,this.total=ye}};e.$TL=ci,e.$TL=ci=He([P],ci);let Vi=g=class{static fromDetails(W,ye){const Re=new ci(0,0),Qe=new ci(0,0),tt=new ci(0,0);for(const dt of ye)if("branches"in dt){Re.total+=1,Re.covered+=dt.executionCount>0?1:0;for(const Ut of dt.branches)Qe.total+=1,Qe.covered+=Ut.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new g(W,Re,Qe.total>0?Qe:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=ye,at}constructor(W,ye,Re,Qe){this.uri=W,this.statementCoverage=ye,this.branchCoverage=Re,this.functionCoverage=Qe}};e.$UL=Vi,e.$UL=Vi=g=He([P],Vi);let Ki=class{constructor(W,ye,Re=[]){this.executionCount=W,this.location=ye,this.branches=Re}};e.$VL=Ki,e.$VL=Ki=He([P],Ki);let Hi=class{constructor(W,ye){this.executionCount=W,this.location=ye}};e.$WL=Hi,e.$WL=Hi=He([P],Hi);let Gi=class{constructor(W,ye){this.executionCount=W,this.location=ye}};e.$XL=Gi,e.$XL=Gi=He([P],Gi);var ln;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(ln||(e.ExternalUriOpenerPriority=ln={}));var hn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(hn||(e.WorkspaceTrustState=hn={}));var dn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn||(e.PortAutoForwardAction=dn={}));class ve{constructor(W,ye,Re,Qe,tt,at){this.kind=W,this.name=ye,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$YL=ve;class ke{constructor(W){this.uri=W}}e.$ZL=ke;class Oe{constructor(W,ye){this.original=W,this.modified=ye}}e.$1L=Oe;class st{constructor(W,ye,Re,Qe){this.base=W,this.input1=ye,this.input2=Re,this.result=Qe}}e.$2L=st;class bt{constructor(W,ye){this.uri=W,this.viewType=ye}}e.$3L=bt;class Ft{constructor(W){this.viewType=W}}e.$4L=Ft;class Pn{constructor(W,ye){this.uri=W,this.notebookType=ye}}e.$5L=Pn;class An{constructor(W,ye,Re){this.original=W,this.modified=ye,this.notebookType=Re}}e.$6L=An;class Rn{constructor(){}}e.$7L=Rn;class Ln{constructor(W,ye){this.uri=W,this.inputBoxUri=ye}}e.$8L=Ln;var wn;(function(V){V[V.Up=1]="Up",V[V.Down=2]="Down"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var pn;(function(V){V[V.Action=1]="Action",V[V.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var yn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful",V[V.Undone=2]="Undone",V[V.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(V){V[V.System=0]="System",V[V.User=1]="User",V[V.Assistant=2]="Assistant",V[V.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var kn;(function(V){V[V.Short=1]="Short",V[V.Medium=2]="Medium",V[V.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Mn{constructor(W,ye){this.role=W,this.content=ye}}e.$9L=Mn;var Sn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var Dn;(function(V){V[V.SymbolInformation=1]="SymbolInformation",V[V.CommandInformation=2]="CommandInformation",V[V.SearchInformation=3]="SearchInformation",V[V.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Cn;(function(V){V[V.Started=1]="Started",V[V.Recognizing=2]="Recognizing",V[V.Recognized=3]="Recognized",V[V.Stopped=4]="Stopped"})(Cn||(e.SpeechToTextStatus=Cn={}))}),define(De[141],Ce([1,0,58,18,15,171,124,7,19]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.$jM=void 0;const v=new Map;function R(k,p){p?v.set(k,p):v.delete(k)}e.$jM=R;function I(k){return v.get(k)}class w extends L.$Wu{constructor(p,u,o,r,s,m,h,t){super(u,o,r,s),this.c=p,this.m=m,this.q=h,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(p){return(0,E.$ub)(this.f,p)}get document(){if(!this.a){const p=this;this.a={get uri(){return p.d},get fileName(){return p.d.fsPath},get isUntitled(){return p.d.scheme===F.Schemas.untitled},get languageId(){return p.m},get version(){return p.h},get isClosed(){return p.b},get isDirty(){return p.q},save(){return p.r()},getText(u){return u?p.s(u):p.getText()},get eol(){return p.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return p.f.length},lineAt(u){return p.t(u)},offsetAt(u){return p.u(u)},positionAt(u){return p.v(u)},validateRange(u){return p.w(u)},validatePosition(u){return p.x(u)},getWordRangeAtPosition(u,o){return p.y(u,o)}}}return Object.freeze(this.a)}_acceptLanguageId(p){(0,C.ok)(!this.b),this.m=p}_acceptIsDirty(p){(0,C.ok)(!this.b),this.q=p}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(p){const u=this.w(p);if(u.isEmpty)return"";if(u.isSingleLine)return this.f[u.start.line].substring(u.start.character,u.end.character);const o=this.g,r=u.start.line,s=u.end.line,m=[];m.push(this.f[r].substring(u.start.character));for(let h=r+1;h<s;h++)m.push(this.f[h]);return m.push(this.f[s].substring(0,u.end.character)),m.join(o)}t(p){let u;if(p instanceof $.$jK?u=p.line:typeof p=="number"&&(u=p),typeof u!="number"||u<0||u>=this.f.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new y(u,this.f[u],u===this.f.length-1)}u(p){return p=this.x(p),this.l(),this.j.getPrefixSum(p.line-1)+p.character}v(p){p=Math.floor(p),p=Math.max(0,p),this.l();const u=this.j.getIndexOf(p),o=this.f[u.index].length;return new $.$jK(u.index,Math.min(u.remainder,o))}w(p){if(!(p instanceof $.$kK))throw new Error("Invalid argument");const u=this.x(p.start),o=this.x(p.end);return u===p.start&&o===p.end?p:new $.$kK(u.line,u.character,o.line,o.character)}x(p){if(!(p instanceof $.$jK))throw new Error("Invalid argument");if(this.f.length===0)return p.with(0,0);let{line:u,character:o}=p,r=!1;if(u<0)u=0,o=0,r=!0;else if(u>=this.f.length)u=this.f.length-1,o=this.f[u].length,r=!0;else{const s=this.f[u].length;o<0?(o=0,r=!0):o>s&&(o=s,r=!0)}return r?new $.$jK(u,o):p}y(p,u){const o=this.x(p);if(!u)u=I(this.m);else if((0,d.$Oe)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const r=(0,A.$9r)(o.character+1,(0,A.$7r)(u),this.f[o.line],0);if(r)return new $.$kK(o.line,r.startColumn-1,o.line,r.endColumn-1)}}e.$kM=w;class y{constructor(p,u,o){this.a=p,this.b=u,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$kK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$kK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$lM=y}),define(De[275],Ce([1,0,7,20,4]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;let L=class{constructor($){this.a=new C.$EL(C.ColorThemeKind.Dark),this.b=new d.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange($){let E;switch($){case"light":E=C.ColorThemeKind.Light;break;case"hcDark":E=C.ColorThemeKind.HighContrast;break;case"hcLight":E=C.ColorThemeKind.HighContrastLight;break;default:E=C.ColorThemeKind.Dark}this.a=new C.$EL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Jdc=L,e.$Jdc=L=He([Be(0,F.$hM)],L)}),define(De[276],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uI=e.CellExecutionUpdateType=void 0;var F;(function(d){d[d.Output=1]="Output",d[d.OutputItems=2]="OutputItems",d[d.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$uI=(0,C.$Ph)("INotebookExecutionService")}),define(De[68],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(L){L.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class d{static fromExtHostTestItem(A,$,E=A.parent){if(A._isRoot)return new d([$]);const v=[A.id];for(let R=E;R&&R.id!==$;R=R.parent)v.push(R.id);return v.push($),new d(v.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const $=A.indexOf("\0");return $===-1?A:A.slice(0,$)}static fromString(A){return new d(A.split("\0"))}static join(A,$){return new d([...A.path,$])}static joinToString(A,$){return A.toString()+"\0"+$}static parentId(A){const $=A.lastIndexOf("\0");return $===-1?void 0:A.slice(0,$)}static localId(A){const $=A.lastIndexOf("\0");return $===-1?A:A.slice($+1)}static isChild(A,$){return $.startsWith(A)&&$[A.length]==="\0"}static compare(A,$){return A===$?0:d.isChild(A,$)?2:d.isChild($,A)?3:1}constructor(A,$=A.length){if(this.path=A,this.d=$,A.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new d(this.path,1)}get parentId(){return this.d>1?new d(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new d(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new d(this.path,A)}compare(A){if(typeof A=="string")return d.compare(this.toString(),A);for(let $=0;$<A.d&&$<this.d;$++)if(A.path[$]!==this.path[$])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$_I=d}),define(De[87],Ce([1,0,2,32,68]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$fJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$eJ=e.$dJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$cJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$bJ=e.$aJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var $;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$aJ=[2,4,8,16,32,64];const E=S=>"runId"in S;e.$bJ=E;var v;(function(S){S.serialize=b=>({range:b.range.toJSON(),uri:b.uri.toJSON()}),S.deserialize=b=>({range:F.$us.lift(b.range),uri:C.URI.revive(b.uri)})})(v||(e.IRichLocation=v={}));var R;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(R||(e.TestMessageType=R={}));var I;(function(S){S.serialize=b=>({message:b.message,type:0,expected:b.expected,actual:b.actual,contextValue:b.contextValue,location:b.location&&v.serialize(b.location)}),S.deserialize=b=>({message:b.message,type:0,expected:b.expected,actual:b.actual,contextValue:b.contextValue,location:b.location&&v.deserialize(b.location)})})(I||(e.ITestErrorMessage=I={}));const w=(S,b)=>`${b?"s":"e"}${S}`;e.$cJ=w;var y;(function(S){S.serialize=b=>({message:b.message,type:1,offset:b.offset,length:b.length,location:b.location&&v.serialize(b.location)}),S.deserialize=b=>({message:b.message,type:1,offset:b.offset,length:b.length,location:b.location&&v.deserialize(b.location)})})(y||(e.ITestOutputMessage=y={}));var k;(function(S){S.serialize=b=>b.type===0?I.serialize(b):y.serialize(b),S.deserialize=b=>b.type===0?I.deserialize(b):y.deserialize(b)})(k||(e.ITestMessage=k={}));var p;(function(S){S.serializeWithoutMessages=b=>({state:b.state,duration:b.duration,messages:[]}),S.serialize=b=>({state:b.state,duration:b.duration,messages:b.messages.map(k.serialize)}),S.deserialize=b=>({state:b.state,duration:b.duration,messages:b.messages.map(k.deserialize)})})(p||(e.ITestTaskState=p={}));const u="\0",o=(S,b)=>S+u+b;e.$dJ=o;const r=S=>{const b=S.indexOf(u);return{ctrlId:S.slice(0,b),tagId:S.slice(b+1)}};e.$eJ=r;var s;(function(S){S.serialize=b=>({extId:b.extId,label:b.label,tags:b.tags,busy:b.busy,children:void 0,uri:b.uri?.toJSON(),range:b.range?.toJSON()||null,description:b.description,error:b.error,sortText:b.sortText}),S.deserialize=b=>({extId:b.extId,label:b.label,tags:b.tags,busy:b.busy,children:void 0,uri:b.uri?C.URI.revive(b.uri):void 0,range:b.range?F.$us.lift(b.range):null,description:b.description,error:b.error,sortText:b.sortText})})(s||(e.ITestItem=s={}));var m;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(m||(e.TestItemExpandState=m={}));var h;(function(S){S.serialize=b=>({expand:b.expand,item:s.serialize(b.item)}),S.deserialize=b=>({controllerId:d.$_I.root(b.item.extId),expand:b.expand,item:s.deserialize(b.item)})})(h||(e.InternalTestItem=h={}));var t;(function(S){S.serialize=b=>{let f;return b.item&&(f={},b.item.label!==void 0&&(f.label=b.item.label),b.item.tags!==void 0&&(f.tags=b.item.tags),b.item.busy!==void 0&&(f.busy=b.item.busy),b.item.uri!==void 0&&(f.uri=b.item.uri?.toJSON()),b.item.range!==void 0&&(f.range=b.item.range?.toJSON()),b.item.description!==void 0&&(f.description=b.item.description),b.item.error!==void 0&&(f.error=b.item.error),b.item.sortText!==void 0&&(f.sortText=b.item.sortText)),{extId:b.extId,expand:b.expand,item:f}},S.deserialize=b=>{let f;return b.item&&(f={},b.item.label!==void 0&&(f.label=b.item.label),b.item.tags!==void 0&&(f.tags=b.item.tags),b.item.busy!==void 0&&(f.busy=b.item.busy),b.item.range!==void 0&&(f.range=b.item.range?F.$us.lift(b.item.range):null),b.item.description!==void 0&&(f.description=b.item.description),b.item.error!==void 0&&(f.error=b.item.error),b.item.sortText!==void 0&&(f.sortText=b.item.sortText)),{extId:b.extId,expand:b.expand,item:f}}})(t||(e.ITestItemUpdate=t={}));const n=(S,b)=>{b.expand!==void 0&&(S.expand=b.expand),b.item!==void 0&&(S.item=S.item?Object.assign(S.item,b.item):b.item)};e.$fJ=n;var c;(function(S){S.serializeWithoutMessages=b=>({...h.serialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(p.serializeWithoutMessages)}),S.serialize=b=>({...h.serialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(p.serialize)}),S.deserialize=b=>({...h.deserialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(p.deserialize),retired:!0})})(c||(e.TestResultItem=c={}));var i;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(i||(e.DetailType=i={}));var a;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var l;(function(S){S.deserialize=b=>b.op===0?{op:b.op,item:h.deserialize(b.item)}:b.op===1?{op:b.op,item:t.deserialize(b.item)}:b.op===2?{op:b.op,uri:C.URI.revive(b.uri),docv:b.docv}:b,S.serialize=b=>b.op===0?{op:b.op,item:h.serialize(b.item)}:b.op===1?{op:b.op,item:t.serialize(b.item)}:b})(l||(e.TestsDiffOp=l={}));class D{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(b){const f=this.p();for(const g of b)switch(g.op){case 0:this.k(h.deserialize(g.item),f);break;case 1:this.l(t.deserialize(g.item),f);break;case 3:this.m(g.itemId,f);break;case 5:this.o(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.d.set(g.tag.id,g.tag);break;case 7:this.d.delete(g.id);break}f.complete?.()}k(b,f){const g=d.$_I.parentId(b.item.extId)?.toString();let P;if(!g)P=this.q(b),this.g.add(P),this.f.set(b.item.extId,P);else if(this.f.has(g)){const N=this.f.get(g);N.children.add(b.item.extId),P=this.q(b,N),this.f.set(b.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(b)}`);return}return f.add?.(P),b.expand===2&&this.h++,P}l(b,f){const g=this.f.get(b.extId);if(g)return b.expand!==void 0&&(g.expand===2&&this.h--,b.expand===2&&this.h++),(0,e.$fJ)(g,b),f.update?.(g),g}m(b,f){const g=this.f.get(b);if(!g)return;const P=d.$_I.parentId(g.item.extId)?.toString();P?this.f.get(P).children.delete(g.item.extId):this.g.delete(g);const N=[[b]];for(;N.length;)for(const O of N.pop()){const M=this.f.get(O);M&&(N.push(M.children),this.f.delete(O),f.remove?.(M,M!==g),M.expand===2&&this.h--)}}o(b){}updatePendingRoots(b){this.j+=b}p(){return{}}}e.$gJ=D}),define(De[109],Ce([1,0,8,4,3,58,87,68]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.TestItemEventOp=void 0;var E;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const v=(r,s)=>r===s,I=Object.entries({range:(r,s)=>r===s?!0:!r||!s?!1:r.equalsRange(s),busy:v,label:v,description:v,error:v,sortText:v,tags:(r,s)=>!(r.length!==s.length||r.some(m=>!s.includes(m)))}),w=(r,s)=>{let m;for(const[h,t]of I)t(r[h],s[h])||(m?m[h]=s[h]:m={[h]:s[h]});return m};class y extends d.$Sc{get root(){return this.s.root}constructor(s){super(),this.s=s,this.f=this.B(new C.$6g(()=>this.flushDiff(),200)),this.g=this.B(new F.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(s){this.h=s;for(const m of this.tree.values())this.I(m)}get resolveHandler(){return this.h}collectDiff(){const s=this.m;return this.m=[],s}pushDiff(s){switch(s.op){case 2:{for(const m of this.m)if(m.op===2&&m.uri===s.uri){m.docv=s.docv;return}break}case 1:{const m=this.m[this.m.length-1];if(m){if(m.op===1&&m.item.extId===s.item.extId){(0,A.$fJ)(m.item,s.item);return}if(m.op===0&&m.item.item.extId===s.item.extId){(0,A.$fJ)(m.item,s.item);return}}break}}this.m.push(s),this.f.isScheduled()||this.f.schedule()}expand(s,m){const h=this.tree.get(s);if(h){if((h.expandLevels===void 0||m>h.expandLevels)&&(h.expandLevels=m),h.expand===1){const t=this.L(h);return t.isOpen()?this.J(h,m-1):t.wait().then(()=>this.J(h,m-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,m-1)):this.J(h,m-1)}}dispose(){for(const s of this.tree.values())this.s.getApiFor(s.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(s,m){switch(m.op){case 3:this.N($.$_I.joinToString(s.fullId,m.id));break;case 0:this.y(m.item,s);break;case 5:for(const h of m.ops)this.u(s,h);break;case 1:this.z(m.new,m.old,s.fullId.toString());break;case 2:this.I(s);break;case 4:this.pushDiff({op:1,item:{extId:s.fullId.toString(),item:m.update}});break;case 6:this.w(s.actual.uri);break;default:(0,L.$4c)(m)}}w(s){s&&this.pushDiff({op:2,uri:s,docv:this.s.getDocumentVersion(s)})}y(s,m){const h=$.$_I.fromExtHostTestItem(s,this.root.id,m?.actual),t=this.s.getApiFor(s);t.parent&&t.parent!==m?.actual&&this.s.getChildren(t.parent).delete(s.id);let n=this.tree.get(h.toString());if(!n){n={fullId:h,actual:s,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},s.tags.forEach(this.C,this),this.tree.set(n.fullId.toString(),n),this.F(s,m),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(s)}}),this.H(s,n,m);return}if(n.actual===s){this.G(s,n,m);return}if(n.actual.uri?.toString()!==s.uri?.toString())return this.N(h.toString()),this.y(s,m);const c=this.s.getChildren(n.actual),i=n.actual,a=w(this.s.toITestItem(i),this.s.toITestItem(s));this.s.getApiFor(i).listener=void 0,n.actual=s,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.z(s.tags,i.tags,h.toString()),delete a.tags),this.u(n,{op:4,update:a})),this.H(s,n,m);for(const[l,D]of c)this.s.getChildren(s).get(D.id)||this.N($.$_I.joinToString(h,D.id));this.w(n.actual.uri)}z(s,m,h){const t=new Set(m.map(n=>n.id));for(const n of s)t.delete(n.id)||this.C(n);this.pushDiff({op:1,item:{extId:h,item:{tags:s.map(n=>(0,A.$dJ)(this.s.controllerId,n.id))}}}),t.forEach(this.D,this)}C(s){const m=this.j.get(s.id);m?m.refCount++:(this.j.set(s.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$dJ)(this.s.controllerId,s.id)}}))}D(s){const m=this.j.get(s);m&&!--m.refCount&&(this.j.delete(s),this.pushDiff({op:7,id:(0,A.$dJ)(this.s.controllerId,s)}))}F(s,m){this.s.getApiFor(s).parent=m&&m.actual!==this.root?m.actual:void 0}G(s,m,h){this.F(s,h);const t=this.s.getApiFor(s);t.parent=h?.actual,t.listener=n=>this.u(m,n),this.I(m)}H(s,m,h){this.G(s,m,h);for(const[t,n]of this.s.getChildren(s))this.y(n,m)}I(s){let m;this.h?s.resolveBarrier?m=s.resolveBarrier.isOpen()?3:2:m=s.actual.canResolveChildren?1:0:m=0,m!==s.expand&&(s.expand=m,this.pushDiff({op:1,item:{extId:s.fullId.toString(),expand:m}}),m===1&&s.expandLevels!==void 0&&this.L(s))}J(s,m){if(m<0)return;const h=[];for(const[t,n]of this.s.getChildren(s.actual)){const c=this.expand($.$_I.joinToString(s.fullId,n.id),m);(0,C.$Gg)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}L(s){if(s.resolveBarrier)return s.resolveBarrier;if(!this.h){const n=new C.$Sg;return n.open(),n}s.expand=2,this.M(s);const m=s.resolveBarrier=new C.$Sg,h=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let t;try{t=this.h(s.actual===this.root?void 0:s.actual)}catch(n){h(n)}return(0,C.$Gg)(t)?t.catch(h).then(()=>{m.open(),this.I(s)}):(m.open(),this.I(s)),s.resolveBarrier}M(s){this.pushDiff({op:1,item:{extId:s.fullId.toString(),expand:s.expand}})}N(s){const m=this.tree.get(s);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:s});const h=[m];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.D(n.id);this.tree.delete(t.fullId.toString());for(const[n,c]of this.s.getChildren(t.actual))h.push(this.tree.get($.$_I.joinToString(t.fullId,c.id)))}}}flushDiff(){const s=this.collectDiff();s.length&&this.g.fire(s)}}e.$0L=y;class k extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.$$L=k;class p extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$_L=p;class u extends Error{constructor(s,m,h){super(`TestItem with ID "${s}" is from controller "${m}" and cannot be added as a child of an item from controller "${h}".`)}}e.$aM=u;const o=(r,s,m)=>{let h=new Map;return{get size(){return h.size},forEach(t,n){for(const c of h.values())t.call(n,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const n=new Map,c=new Set(h.keys()),i={op:5,ops:[]};for(const a of t){if(!(a instanceof m))throw new p(a.id);const l=s(a).controllerId;if(l!==r.controllerId)throw new u(a.id,l,r.controllerId);if(n.has(a.id))throw new k(a.id);n.set(a.id,a),c.delete(a.id),i.ops.push({op:0,item:a})}for(const a of c.keys())i.ops.push({op:3,id:a});r.listener?.(i),h=n},add(t){if(!(t instanceof m))throw new p(t.id);h.set(t.id,t),r.listener?.({op:0,item:t})},delete(t){h.delete(t)&&r.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$bM=o}),define(De[142],Ce([1,0,109]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=void 0;const F=new WeakMap,d=(A,$)=>{const E={controllerId:$};return F.set(A,E),E};e.$cM=d;const L=A=>{const $=F.get(A);if(!$)throw new C.$_L(A?.id||"<unknown>");return $};e.$dM=L}),define(De[110],Ce([1,0,18,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ob=e.$9ob=e.$8ob=e.$7ob=e.$6ob=void 0,e.$6ob="vscode-cdn.net",e.$7ob=`vscode-resource.${e.$6ob}`,e.$8ob=`'self' https://*.${e.$6ob}`;function d($,E){return $.scheme===C.Schemas.http||$.scheme===C.Schemas.https?$:(E&&E.authority&&E.isRemote&&$.scheme===C.Schemas.file&&($=F.URI.from({scheme:C.Schemas.vscodeRemote,authority:E.authority,path:$.path})),F.URI.from({scheme:C.Schemas.https,authority:`${$.scheme}+${L($.authority)}.${e.$7ob}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$9ob=d;function L($){return $.replace(/./g,E=>{const v=E.charCodeAt(0);return v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57?E:"-"+v.toString(16).padStart(4,"0")})}function A($){return $.replace(/-([0-9a-f]{4})/g,(E,v)=>String.fromCharCode(parseInt(v,16)))}e.$0ob=A}),define(De[277],Ce([1,0,4,3,110]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class L{constructor($,E,v){this.d=$,this.e=E,this.f=v,this.a=0,this.b=new F.$Rc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const I of this.c.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,E,v,R,I){let w;for(const s of this.e.getVisibleTextEditors(!0))if(s.value===$){w=s;break}if(!w)throw new Error("not a visible editor");const y=this,k=this.a++,p=new C.$Nd,u=new C.$Nd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(s){return(0,d.$9ob)(s,y.f)}get cspSource(){return d.$8ob}set options(s){this.b=s,y.d.$setOptions(k,s)}get options(){return this.b}set html(s){this.a=s,y.d.$setHtml(k,s)}get html(){return this.a}get onDidReceiveMessage(){return p.event}postMessage(s){return y.d.$postMessage(k,s)}},r=new class{constructor(){this.editor=$,this.line=E,this.height=v,this.webview=o,this.onDidDispose=u.event}dispose(){y.c.has(k)&&(y.c.delete(k),y.d.$disposeEditorInset(k),u.fire(),u.dispose(),p.dispose())}};return this.d.$createEditorInset(k,w.id,w.value.document.uri,E+1,v,R||{},I.identifier,I.extensionLocation),this.c.set(k,{editor:$,inset:r,onDidReceiveMessage:p}),r}$onDidDispose($){const E=this.c.get($);E&&E.inset.dispose()}$onDidReceiveMessage($,E){this.c.get($)?.onDidReceiveMessage.fire(E)}}e.$hdc=L}),define(De[278],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.VariableKind=e.$6M=void 0,e.$6M=(0,C.$Ph)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class d extends Error{constructor(A,$){super($),this.variable=A}}e.$7M=d}),define(De[279],Ce([1,0,16,48,17,24,12,99,223,278,15]),function($e,e,C,F,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,k,p,u){this.h=new Map,this.a=y,this.b=k,this.g=p,u&&(this.c=u.then(o=>this.i(o)))}i(y){if(A.$j){const k=Object.create(null);return Object.keys(y).forEach(p=>{k[p.toLowerCase()]=y[p]}),k}return y}resolveWithEnvironment(y,k,p){return this.l({env:this.i(y),userHome:void 0},k?k.uri:void 0,p)}async resolveAsync(y,k){const p={env:await this.c,userHome:await this.g};return this.l(p,y?y.uri:void 0,k)}async j(y,k,p,u){const o=L.$7m(k);A.$j&&o.windows?Object.keys(o.windows).forEach(s=>o[s]=o.windows[s]):A.$k&&o.osx?Object.keys(o.osx).forEach(s=>o[s]=o.osx[s]):A.$l&&o.linux&&Object.keys(o.linux).forEach(s=>o[s]=o.linux[s]),delete o.windows,delete o.osx,delete o.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,y?y.uri:void 0,o,p,u)}async resolveAnyAsync(y,k,p){return this.j(y,k,p)}async resolveAnyMap(y,k,p){const u=new Map;return{newConfig:await this.j(y,k,p,u),resolvedVariables:u}}resolveWithInteractionReplace(y,k,p,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,k,p,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,k){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,k)}async l(y,k,p,u,o){if(d.$yf(p))return this.m(y,k,p,u,o);if(Array.isArray(p))return Promise.all(p.map(r=>this.l(y,k,r,u,o)));if(d.$Af(p)){const r=Object.create(null),s=await Promise.all(Object.keys(p).map(async m=>[await this.m(y,k,m,u,o),await this.l(y,k,p[m],u,o)]));for(const[m,h]of s)r[m]=h;return r}return p}m(y,k,p,u,o){return(0,R.$Te)(p,I.VARIABLE_REGEXP,async(r,s)=>{if(s.includes(I.VARIABLE_LHS))return r;let m=await this.o(y,r,s,k,u);return o?.set(s,m),m!==r&&d.$yf(m)&&m.match(I.VARIABLE_REGEXP)&&(m=await this.m(y,k,m,u,o)),m})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,k,p,u,o){let r;const s=p.split(":");s.length>1&&(p=s[0],r=s[1]);const m=n=>{const c=this.a.getFilePath();if(c)return(0,$.$sv)(c);throw new v.$7M(n,(0,E.localize)(0,null,k))},h=n=>{const c=m(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,$.$sv)(i)}throw new v.$7M(n,(0,E.localize)(1,null,k,C.$nc(c)))},t=n=>{if(r){const c=this.a.getFolderUri(r);if(c)return c;throw new v.$7M(n,(0,E.localize)(2,null,k,r))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new v.$7M(n,(0,E.localize)(3,null,k)):new v.$7M(n,(0,E.localize)(4,null,k))};switch(p){case"env":if(r){if(y.env){const n=y.env[A.$j?r.toLowerCase():r];if(d.$yf(n))return n}return""}throw new v.$7M(v.VariableKind.Env,(0,E.localize)(5,null,k));case"config":if(r){const n=this.a.getConfigurationValue(u,r);if(d.$Hf(n))throw new v.$7M(v.VariableKind.Config,(0,E.localize)(6,null,k,r));if(d.$Af(n))throw new v.$7M(v.VariableKind.Config,(0,E.localize)(7,null,k,r));return n}throw new v.$7M(v.VariableKind.Config,(0,E.localize)(8,null,k));case"command":return this.p(v.VariableKind.Command,k,r,o,"command");case"input":return this.p(v.VariableKind.Input,k,r,o,"input");case"extensionInstallFolder":if(r){const n=await this.a.getExtension(r);if(!n)throw new v.$7M(v.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,k,r));return this.n(n.extensionLocation)}throw new v.$7M(v.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,k));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,$.$sv)(this.n(t(v.VariableKind.WorkspaceFolder)));case"cwd":return u||r?(0,$.$sv)(this.n(t(v.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$sv)(C.$nc(this.n(t(v.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new v.$7M(v.VariableKind.UserHome,(0,E.localize)(11,null,k))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new v.$7M(v.VariableKind.LineNumber,(0,E.localize)(12,null,k))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new v.$7M(v.VariableKind.SelectedText,(0,E.localize)(13,null,k))}case"file":return m(v.VariableKind.File);case"fileWorkspaceFolder":return h(v.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||r?C.$lc(this.n(t(v.VariableKind.RelativeFile)),m(v.VariableKind.RelativeFile)):m(v.VariableKind.RelativeFile);case"relativeFileDirname":{const n=C.$mc(m(v.VariableKind.RelativeFileDirname));if(u||r){const c=C.$lc(this.n(t(v.VariableKind.RelativeFileDirname)),n);return c.length===0?".":c}return n}case"fileDirname":return C.$mc(m(v.VariableKind.FileDirname));case"fileExtname":return C.$oc(m(v.VariableKind.FileExtname));case"fileBasename":return C.$nc(m(v.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=C.$nc(m(v.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-C.$oc(n).length)}case"fileDirnameBasename":return C.$nc(C.$mc(m(v.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||k}case"execInstallFolder":{const n=this.a.getAppRoot();return n||k}case"pathSeparator":return C.sep;default:try{const n=r?`${p}:${r}`:p;return this.p(v.VariableKind.Unknown,k,n,o,void 0)}catch{return k}}}}p(y,k,p,u,o){if(p&&u){const r=o===void 0?u[p]:u[o+":"+p];if(typeof r=="string")return r;throw new v.$7M(y,(0,E.localize)(14,null,k))}return k}}e.$iN=I}),define(De[143],Ce([1,0,5,139]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=e.$gC=e.OpenEditorContext=e.GroupsOrder=e.$fC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$eC=void 0,e.$eC=(0,C.$Ph)("editorGroupsService");var d;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(d||(e.GroupDirection=d={}));var L;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var $;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EVEN=1]="EVEN",k[k.TOGGLE=2]="TOGGLE"})($||(e.GroupsArrangement=$={}));var E;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function v(k){const p=k;return(0,F.$7D)(p?.editor)&&(0,F.$7D)(p?.replacement)}e.$fC=v;var R;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var I;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function w(k){const p=k;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.$gC=w;function y(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$hC=y}),define(De[280],Ce([1,0,5,143]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lC=e.$kC=e.$jC=e.$iC=void 0,e.$iC=(0,C.$Ph)("editorService"),e.$jC=-1,e.$kC=-2;function d(L){const A=L;return typeof L=="number"||(0,F.$gC)(A)}e.$lC=d}),define(De[13],Ce([1,0,19,22,162,75,80,28,158,62,97,24,17,2,32,83,133,142,139,108,68,87,280,7]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$gM=e.$fM=e.MarkdownString=e.$eM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(Me){function Te(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:Ke,positionLineNumber:Ze,positionColumn:Je}=ne,nt=new n.$jK(Fe-1,Ke-1),pt=new n.$jK(Ze-1,Je-1);return new n.$lK(nt,pt)}Me.to=Te;function Se(ne){const{anchor:Fe,active:Ke}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Me.from=Se})(c||(e.Selection=c={}));var i;(function(Me){function Te(ne){if(!ne)return;const{start:Fe,end:Ke}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Me.from=Te;function Se(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:Ke,endLineNumber:Ze,endColumn:Je}=ne;return new n.$kK(Fe-1,Ke-1,Ze-1,Je-1)}Me.to=Se})(i||(e.Range=i={}));var a;(function(Me){function Te(Se){switch(Se){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Me.to=Te})(a||(e.TokenType=a={}));var l;(function(Me){function Te(ne){return new n.$jK(ne.lineNumber-1,ne.column-1)}Me.to=Te;function Se(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Me.from=Se})(l||(e.Position=l={}));var D;(function(Me){function Te(Fe,Ke,Ze){return(0,C.$Hb)((0,C.$3b)(Fe).map(Je=>Se(Je,Ke,Ze)))}Me.from=Te;function Se(Fe,Ke,Ze){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Ze?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,Ke),pattern:Xe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Ze?.isBuiltin}}function ne(Fe,Ke){return Ke&&typeof Fe=="string"?Ke.transformOutgoingScheme(Fe):Fe}})(D||(e.DocumentSelector=D={}));var S;(function(Me){function Te(ne){switch(ne){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Se(ne){switch(ne){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Me.to=Se})(S||(e.DiagnosticTag=S={}));var b;(function(Me){function Te(ne){let Fe;return ne.code&&((0,w.$yf)(ne.code)||(0,w.$Cf)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...i.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:g.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(f.from),tags:Array.isArray(ne.tags)?(0,C.$Hb)(ne.tags.map(S.from)):void 0}}Me.from=Te;function Se(ne){const Fe=new n.$wK(i.to(ne),ne.message,g.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,w.$yf)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(f.to),Fe.tags=ne.tags&&(0,C.$Hb)(ne.tags.map(S.to)),Fe}Me.to=Se})(b||(e.Diagnostic=b={}));var f;(function(Me){function Te(ne){return{...i.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Me.from=Te;function Se(ne){return new n.$vK(new n.$uK(ne.resource,i.to(ne)),ne.message)}Me.to=Se})(f||(e.DiagnosticRelatedInformation=f={}));var g;(function(Me){function Te(ne){switch(ne){case n.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Me.from=Te;function Se(ne){switch(ne){case u.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Me.to=Se})(g||(e.DiagnosticSeverity=g={}));var P;(function(Me){function Te(ne){return typeof ne=="number"&&ne>=n.ViewColumn.One?ne-1:ne===n.ViewColumn.Beside?t.$kC:t.$jC}Me.from=Te;function Se(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Se})(P||(e.ViewColumn=P={}));function N(Me){return typeof Me.range<"u"}function O(Me){return Me.length===0?!0:!!N(Me[0])}e.$eM=O;var M;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ne(Je){let nt;if(Se(Je)){const{language:ht,value:gt}=Je;nt={value:"```"+ht+`
`+gt+"\n```\n"}}else n.$IK.isMarkdownString(Je)?nt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?nt={value:Je}:nt={value:""};const pt=Object.create(null);nt.uris=pt;const jt=ht=>{try{let gt=y.URI.parse(ht,!0);gt=gt.with({query:Fe(gt.query,pt)}),pt[ht]=gt}catch{}return""},kt=new E.marked.Renderer;return kt.link=jt,kt.image=ht=>typeof ht=="string"?jt(A.$0j(ht).href):"",(0,E.marked)(nt.value,{renderer:kt}),nt}Me.from=ne;function Fe(Je,nt){if(!Je)return Je;let pt;try{pt=(0,v.$lh)(Je)}catch{}if(!pt)return Je;let jt=!1;return pt=(0,I.$9m)(pt,kt=>{if(y.URI.isUri(kt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[ht]=kt,jt=!0,ht}else return}),jt?JSON.stringify(pt):Je}function Ke(Je){const nt=new n.$IK(Je.value,Je.supportThemeIcons);return nt.isTrusted=Je.isTrusted,nt.supportHtml=Je.supportHtml,nt.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,nt}Me.to=Ke;function Ze(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=Ze})(M||(e.MarkdownString=M={}));function j(Me){return O(Me)?Me.map(Te=>({range:i.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?M.fromMany(Te.hoverMessage):Te.hoverMessage?M.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:i.from(Te)}))}e.$fM=j;function U(Me){return typeof Me>"u"?Me:typeof Me=="string"?y.URI.file(Me):Me}e.$gM=U;var T;(function(Me){function Te(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?U(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Me.from=Te})(T||(e.ThemableDecorationAttachmentRenderOptions=T={}));var K;(function(Me){function Te(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?U(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?T.from(Se.before):void 0,after:Se.after?T.from(Se.after):void 0}}Me.from=Te})(K||(e.ThemableDecorationRenderOptions=K={}));var q;(function(Me){function Te(Se){if(typeof Se>"u")return Se;switch(Se){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(q||(e.DecorationRangeBehavior=q={}));var ge;(function(Me){function Te(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?q.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?K.from(Se.light):void 0,dark:Se.dark?K.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?U(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?T.from(Se.before):void 0,after:Se.after?T.from(Se.after):void 0}}Me.from=Te})(ge||(e.DecorationRenderOptions=ge={}));var ee;(function(Me){function Te(ne){return{text:ne.newText,eol:ne.newEol&&et.from(ne.newEol),range:i.from(ne.range)}}Me.from=Te;function Se(ne){const Fe=new n.$pK(i.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol>"u"?void 0:et.to(ne.eol),Fe}Me.to=Se})(ee||(e.TextEdit=ee={}));var Q;(function(Me){function Te(ne,Fe){const Ke={edits:[]};if(ne instanceof n.$sK){const Ze=new $.$Bc;for(const Je of ne._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&Ze.add(Je.to);for(const Je of ne._allEntries())if(Je._type===1){let nt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?nt={type:"base64",value:(0,F.$ve)(F.$be.wrap(Je.options.contents))}:nt={type:"dataTransferItem",id:Je.options.contents._itemId}),Ke.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:nt},metadata:Je.metadata})}else Je._type===2?Ke.edits.push({resource:Je.uri,textEdit:ee.from(Je.edit),versionId:Ze.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ke.edits.push({resource:Je.uri,textEdit:{range:i.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:Ze.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ke.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ke.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ot.from)}})}return Ke}Me.from=Te;function Se(ne){const Fe=new n.$sK,Ke=new $.$Ac;for(const Ze of ne.edits)if(Ze.textEdit){const Je=Ze,nt=y.URI.revive(Je.resource),pt=i.to(Je.textEdit.range),jt=Je.textEdit.text,kt=Je.textEdit.insertAsSnippet;let ht;kt?ht=n.$rK.replace(pt,new n.$tK(jt)):ht=n.$pK.replace(pt,jt);const gt=Ke.get(nt);gt?gt.push(ht):Ke.set(nt,[ht])}else Fe.renameFile(y.URI.revive(Ze.oldResource),y.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Je]of Ke)Fe.set(Ze,Je);return Fe}Me.to=Se})(Q||(e.WorkspaceEdit=Q={}));var X;(function(Me){const Te=Object.create(null);Te[n.SymbolKind.File]=0,Te[n.SymbolKind.Module]=1,Te[n.SymbolKind.Namespace]=2,Te[n.SymbolKind.Package]=3,Te[n.SymbolKind.Class]=4,Te[n.SymbolKind.Method]=5,Te[n.SymbolKind.Property]=6,Te[n.SymbolKind.Field]=7,Te[n.SymbolKind.Constructor]=8,Te[n.SymbolKind.Enum]=9,Te[n.SymbolKind.Interface]=10,Te[n.SymbolKind.Function]=11,Te[n.SymbolKind.Variable]=12,Te[n.SymbolKind.Constant]=13,Te[n.SymbolKind.String]=14,Te[n.SymbolKind.Number]=15,Te[n.SymbolKind.Boolean]=16,Te[n.SymbolKind.Array]=17,Te[n.SymbolKind.Object]=18,Te[n.SymbolKind.Key]=19,Te[n.SymbolKind.Null]=20,Te[n.SymbolKind.EnumMember]=21,Te[n.SymbolKind.Struct]=22,Te[n.SymbolKind.Event]=23,Te[n.SymbolKind.Operator]=24,Te[n.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=Se;function ne(Fe){for(const Ke in Te)if(Te[Ke]===Fe)return Number(Ke);return n.SymbolKind.Property}Me.to=ne})(X||(e.SymbolKind=X={}));var ae;(function(Me){function Te(ne){switch(ne){case n.SymbolTag.Deprecated:return 1}}Me.from=Te;function Se(ne){switch(ne){case 1:return n.SymbolTag.Deprecated}}Me.to=Se})(ae||(e.SymbolTag=ae={}));var ie;(function(Me){function Te(ne){return{name:ne.name,kind:X.from(ne.kind),tags:ne.tags&&ne.tags.map(ae.from),containerName:ne.containerName,location:J.from(ne.location)}}Me.from=Te;function Se(ne){const Fe=new n.$zK(ne.name,X.to(ne.kind),ne.containerName,J.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(ae.to),Fe}Me.to=Se})(ie||(e.WorkspaceSymbol=ie={}));var ce;(function(Me){function Te(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),kind:X.from(ne.kind),tags:ne.tags?.map(ae.from)??[]};return ne.children&&(Fe.children=ne.children.map(Te)),Fe}Me.from=Te;function Se(ne){const Fe=new n.$AK(ne.name,ne.detail,X.to(ne.kind),i.to(ne.range),i.to(ne.selectionRange));return(0,C.$Lb)(ne.tags)&&(Fe.tags=ne.tags.map(ae.to)),ne.children&&(Fe.children=ne.children.map(Se)),Fe}Me.to=Se})(ce||(e.DocumentSymbol=ce={}));var we;(function(Me){function Te(ne){const Fe=new n.$EK(X.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),i.to(ne.range),i.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Te;function Se(ne,Fe,Ke){if(Fe=Fe??ne._sessionId,Ke=Ke??ne._itemId,Fe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ke,name:ne.name,detail:ne.detail,kind:X.from(ne.kind),uri:ne.uri,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),tags:ne.tags?.map(ae.from)}}Me.from=Se})(we||(e.CallHierarchyItem=we={}));var H;(function(Me){function Te(Se){return new n.$FK(we.to(Se.from),Se.fromRanges.map(ne=>i.to(ne)))}Me.to=Te})(H||(e.CallHierarchyIncomingCall=H={}));var B;(function(Me){function Te(Se){return new n.$GK(we.to(Se.to),Se.fromRanges.map(ne=>i.to(ne)))}Me.to=Te})(B||(e.CallHierarchyOutgoingCall=B={}));var J;(function(Me){function Te(ne){return{range:ne.range&&i.from(ne.range),uri:ne.uri}}Me.from=Te;function Se(ne){return new n.$uK(y.URI.revive(ne.uri),i.to(ne.range))}Me.to=Se})(J||(e.location=J={}));var re;(function(Me){function Te(ne){const Fe=ne,Ke=ne;return{originSelectionRange:Fe.originSelectionRange?i.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ke.uri,range:i.from(Fe.targetRange?Fe.targetRange:Ke.range),targetSelectionRange:Fe.targetSelectionRange?i.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function Se(ne){return{targetUri:y.URI.revive(ne.uri),targetRange:i.to(ne.range),targetSelectionRange:ne.targetSelectionRange?i.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?i.to(ne.originSelectionRange):void 0}}Me.to=Se})(re||(e.DefinitionLink=re={}));var Y;(function(Me){function Te(ne){return{range:i.from(ne.range),contents:M.fromMany(ne.contents)}}Me.from=Te;function Se(ne){return new n.$xK(ne.contents.map(M.to),i.to(ne.range))}Me.to=Se})(Y||(e.Hover=Y={}));var _;(function(Me){function Te(ne){return{range:i.from(ne.range),expression:ne.expression}}Me.from=Te;function Se(ne){return new n.$qL(i.to(ne.range),ne.expression)}Me.to=Se})(_||(e.EvaluatableExpression=_={}));var x;(function(Me){function Te(ne){if(ne instanceof n.$rL)return{type:"text",range:i.from(ne.range),text:ne.text};if(ne instanceof n.$sL)return{type:"variable",range:i.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof n.$tL)return{type:"expression",range:i.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Se(ne){switch(ne.type){case"text":return{range:i.to(ne.range),text:ne.text};case"variable":return{range:i.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:i.to(ne.range),expression:ne.expression}}}Me.to=Se})(x||(e.InlineValue=x={}));var pe;(function(Me){function Te(ne){return{frameId:ne.frameId,stoppedLocation:i.from(ne.stoppedLocation)}}Me.from=Te;function Se(ne){return new n.$uL(ne.frameId,i.to(ne.stoppedLocation))}Me.to=Se})(pe||(e.InlineValueContext=pe={}));var ue;(function(Me){function Te(ne){return{range:i.from(ne.range),kind:ne.kind}}Me.from=Te;function Se(ne){return new n.$yK(i.to(ne.range),ne.kind)}Me.to=Se})(ue||(e.DocumentHighlight=ue={}));var fe;(function(Me){function Te(Se){switch(Se){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Me.to=Te})(fe||(e.CompletionTriggerKind=fe={}));var te;(function(Me){function Te(Se){return{triggerKind:fe.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Me.to=Te})(te||(e.CompletionContext=te={}));var de;(function(Me){function Te(ne){switch(ne){case n.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Se(ne){switch(ne){case 1:return n.CompletionItemTag.Deprecated}}Me.to=Se})(de||(e.CompletionItemTag=de={}));var be;(function(Me){const Te=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Se(Ke){return Te.get(Ke)??9}Me.from=Se;const ne=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Fe(Ke){return ne.get(Ke)??n.CompletionItemKind.Property}Me.to=Fe})(be||(e.CompletionItemKind=be={}));var Pe;(function(Me){function Te(Se,ne){const Fe=new n.$OK(Se.label);return Fe.insertText=Se.insertText,Fe.kind=be.to(Se.kind),Fe.tags=Se.tags?.map(de.to),Fe.detail=Se.detail,Fe.documentation=A.$5j(Se.documentation)?M.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,k.$us.isIRange(Se.range)?Fe.range=i.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:i.to(Se.range.insert),replacing:i.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new n.$tK(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof n.$kK?new n.$pK(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(Ke=>ee.to(Ke))),Fe.command=ne&&Se.command?ne.fromInternal(Se.command):void 0,Fe}Me.to=Te})(Pe||(e.CompletionItem=Pe={}));var z;(function(Me){function Te(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:M.fromStrict(ne.documentation)}}Me.from=Te;function Se(ne){return{label:ne.label,documentation:A.$5j(ne.documentation)?M.to(ne.documentation):ne.documentation}}Me.to=Se})(z||(e.ParameterInformation=z={}));var G;(function(Me){function Te(ne){return{label:ne.label,documentation:M.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(z.from):[],activeParameter:ne.activeParameter}}Me.from=Te;function Se(ne){return{label:ne.label,documentation:A.$5j(ne.documentation)?M.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(z.to):[],activeParameter:ne.activeParameter}}Me.to=Se})(G||(e.SignatureInformation=G={}));var se;(function(Me){function Te(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(G.from):[]}}Me.from=Te;function Se(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(G.to):[]}}Me.to=Se})(se||(e.SignatureHelp=se={}));var oe;(function(Me){function Te(Se,ne){const Fe=new n.$NK(l.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(Z.to.bind(void 0,Se)),ne.kind&&me.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(ee.to),Fe.tooltip=A.$5j(ne.tooltip)?M.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Me.to=Te})(oe||(e.InlayHint=oe={}));var Z;(function(Me){function Te(Se,ne){const Fe=new n.$MK(ne.label);return Fe.tooltip=A.$5j(ne.tooltip)?M.to(ne.tooltip):ne.tooltip,p.Command.is(ne.command)&&(Fe.command=Se.fromInternal(ne.command)),ne.location&&(Fe.location=J.to(ne.location)),Fe}Me.to=Te})(Z||(e.InlayHintLabelPart=Z={}));var me;(function(Me){function Te(ne){return ne}Me.from=Te;function Se(ne){return ne}Me.to=Se})(me||(e.InlayHintKind=me={}));var Ee;(function(Me){function Te(ne){return{range:i.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Me.from=Te;function Se(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?y.URI.parse(ne.url,!0):y.URI.revive(ne.url)}catch{}return new n.$TK(i.to(ne.range),Fe)}Me.to=Se})(Ee||(e.DocumentLink=Ee={}));var je;(function(Me){function Te(ne){const Fe=new n.$WK(ne.label);return ne.textEdit&&(Fe.textEdit=ee.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(Ke=>ee.to(Ke))),Fe}Me.to=Te;function Se(ne){return{label:ne.label,textEdit:ne.textEdit?ee.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>ee.from(Fe)):void 0}}Me.from=Se})(je||(e.ColorPresentation=je={}));var We;(function(Me){function Te(ne){return new n.$UK(ne[0],ne[1],ne[2],ne[3])}Me.to=Te;function Se(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Me.from=Se})(We||(e.Color=We={}));var _e;(function(Me){function Te(ne){return{range:i.from(ne.range)}}Me.from=Te;function Se(ne){return new n.$DK(i.to(ne.range))}Me.to=Se})(_e||(e.SelectionRange=_e={}));var Ye;(function(Me){function Te(Se){switch(Se){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Me.to=Te})(Ye||(e.TextDocumentSaveReason=Ye={}));var it;(function(Me){function Te(ne){switch(ne){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Se(ne){switch(ne){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Me.to=Se})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Me){function Te(ne){if(ne===n.EndOfLine.CRLF)return 1;if(ne===n.EndOfLine.LF)return 0}Me.from=Te;function Se(ne){if(ne===1)return n.EndOfLine.CRLF;if(ne===0)return n.EndOfLine.LF}Me.to=Se})(et||(e.EndOfLine=et={}));var Ae;(function(Me){function Te(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ae||(e.ProgressLocation=Ae={}));var Ne;(function(Me){function Te(ne){const Fe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Fe.kind=qe.from(ne.kind)),Fe}Me.from=Te;function Se(ne){const Fe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Fe.kind=qe.to(ne.kind)),Fe}Me.to=Se})(Ne||(e.FoldingRange=Ne={}));var qe;(function(Me){function Te(ne){if(ne)switch(ne){case n.FoldingRangeKind.Comment:return p.$jt.Comment;case n.FoldingRangeKind.Imports:return p.$jt.Imports;case n.FoldingRangeKind.Region:return p.$jt.Region}}Me.from=Te;function Se(ne){if(ne)switch(ne.value){case p.$jt.Comment.value:return n.FoldingRangeKind.Comment;case p.$jt.Imports.value:return n.FoldingRangeKind.Imports;case p.$jt.Region.value:return n.FoldingRangeKind.Region}}Me.to=Se})(qe||(e.FoldingRangeKind=qe={}));var Le;(function(Me){function Te(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?i.from(Se.selection):void 0,override:typeof Se.override=="boolean"?r.$TD.id:void 0}}Me.from=Te})(Le||(e.TextEditorOpenOptions=Le={}));var Xe;(function(Me){function Te(Ke){return Ke instanceof n.$eL?Ke.toJSON():typeof Ke=="string"?Ke:Se(Ke)||ne(Ke)?new n.$eL(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Me.from=Te;function Se(Ke){const Ze=Ke;return Ze?y.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function ne(Ke){const Ze=Ke;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Fe(Ke){return typeof Ke=="string"?Ke:new n.$eL(y.URI.revive(Ke.baseUri),Ke.pattern)}Me.to=Fe})(Xe||(e.GlobPattern=Xe={}));var he;(function(Me){function Te(Se){if(Se){if(Array.isArray(Se))return Se.map(Te);if(typeof Se=="string")return Se;{const ne=Se;return{language:ne.language,scheme:ne.scheme,pattern:Xe.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Me.from=Te})(he||(e.LanguageSelector=he={}));var le;(function(Me){function Te(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&y.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(Ze=>Ze instanceof n.$kK)))}Me.is=Te;function Se(ne){return{documents:ne.documents.map(Fe=>Fe.map(Ke=>({uri:y.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(Ze=>i.from(Ze))})))}}Me.from=Se})(le||(e.MappedEditsContext=le={}));var Ie;(function(Me){function Te(ne){return{start:ne.start,end:ne.end}}Me.from=Te;function Se(ne){return new n.$FL(ne.start,ne.end)}Me.to=Se})(Ie||(e.NotebookRange=Ie={}));var Ve;(function(Me){function Te(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Me.to=Te;function Se(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Me.from=Se})(Ve||(e.NotebookCellExecutionSummary=Ve={}));var ze;(function(Me){function Te(Se){if(Se===s.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Se===s.NotebookCellExecutionState.Pending)return;if(Se===s.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Me.to=Te})(ze||(e.NotebookCellExecutionState=ze={}));var xe;(function(Me){function Te(ne){switch(ne){case n.NotebookCellKind.Markup:return s.CellKind.Markup;case n.NotebookCellKind.Code:default:return s.CellKind.Code}}Me.from=Te;function Se(ne){switch(ne){case s.CellKind.Markup:return n.NotebookCellKind.Markup;case s.CellKind.Code:default:return n.NotebookCellKind.Code}}Me.to=Se})(xe||(e.NotebookCellKind=xe={}));var rt;(function(Me){function Te(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ke of ne.cells)n.$GL.validate(Ke),Fe.cells.push(ot.from(Ke));return Fe}Me.from=Te;function Se(ne){const Fe=new n.$HL(ne.cells.map(ot.to));return(0,w.$Lf)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Me.to=Se})(rt||(e.NotebookData=rt={}));var ot;(function(Me){function Te(ne){return{cellKind:xe.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Ve.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(St.from):[]}}Me.from=Te;function Se(ne){return new n.$GL(xe.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(St.to):void 0,ne.metadata,ne.internalMetadata?Ve.to(ne.internalMetadata):void 0)}Me.to=Se})(ot||(e.NotebookCellData=ot={}));var $t;(function(Me){function Te(ne){return{mime:ne.mime,valueBytes:F.$be.wrap(ne.data)}}Me.from=Te;function Se(ne){return new n.$IL(ne.valueBytes.buffer,ne.mime)}Me.to=Se})($t||(e.NotebookCellOutputItem=$t={}));var St;(function(Me){function Te(ne){return{outputId:ne.id,items:ne.items.map($t.from),metadata:ne.metadata}}Me.from=Te;function Se(ne){const Fe=ne.items.map($t.to);return new n.$JL(Fe,ne.outputId,ne.metadata)}Me.to=Se})(St||(e.NotebookCellOutput=St={}));var Yt;(function(Me){function Te(Fe){return ne(Fe)?{include:Xe.from(Fe.include)??void 0,exclude:Xe.from(Fe.exclude)??void 0}:Xe.from(Fe)??void 0}Me.from=Te;function Se(Fe){return ne(Fe)?{include:Xe.to(Fe.include),exclude:Xe.to(Fe.exclude)}:Xe.to(Fe)}Me.to=Se;function ne(Fe){const Ke=Fe;return Ke?!(0,w.$Hf)(Ke.include)&&!(0,w.$Hf)(Ke.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var Gt;(function(Me){function Te(Se,ne,Fe){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ke,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Me.from=Te})(Gt||(e.NotebookStatusBarItem=Gt={}));var vt;(function(Me){function Te(Se,ne,Fe){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ne.toInternal(Ke,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Me.from=Te})(vt||(e.NotebookKernelSourceAction=vt={}));var zt;(function(Me){function Te(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Me.from=Te})(zt||(e.NotebookDocumentContentOptions=zt={}));var Nt;(function(Me){function Te(ne){return{uri:ne.uri,provides:ne.provides}}Me.from=Te;function Se(ne){return new n.$LL(y.URI.revive(ne.uri),ne.provides)}Me.to=Se})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Me){function Te(ne){return{message:M.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:i.from(ne.location.range),uri:ne.location.uri}}}Me.from=Te;function Se(ne){const Fe=new n.$RL(typeof ne.message=="string"?ne.message:M.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.contextValue=ne.contextValue,Fe.location=ne.location?J.to(ne.location):void 0,Fe}Me.to=Se})(Bt||(e.TestMessage=Bt={}));var At;(function(Me){Me.namespace=h.$dJ,Me.denamespace=h.$eJ})(At||(e.TestTag=At={}));var Rt;(function(Me){function Te(ne){const Fe=(0,o.$dM)(ne).controllerId;return{extId:m.$_I.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:y.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ke=>At.namespace(Fe,Ke.id)),range:k.$us.lift(i.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&M.fromStrict(ne.error)||null}}Me.from=Te;function Se(ne){return{parent:void 0,error:void 0,id:m.$_I.fromString(ne.extId).localId,label:ne.label,uri:y.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:Ke}=At.denamespace(Fe);return new n.$SL(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Me.toPlain=Se})(Rt||(e.TestItem=Rt={})),function(Me){function Te(ne){return{id:ne.id}}Me.from=Te;function Se(ne){return new n.$SL(ne.id)}Me.to=Se}(At||(e.TestTag=At={}));var Ot;(function(Me){const Te=(ne,Fe)=>{const Ke=[];for(const[Je,nt]of Fe)m.$_I.compare(nt.item.extId,Je)===2&&(Fe.delete(Je),Ke.push(nt));const Ze={...Rt.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(nt=>nt.type===0).map(Bt.to)})),children:Ke.map(Je=>Te(Je,Fe))};for(const Je of Ze.children)Je.parent=Ze;return Ze};function Se(ne){const Fe=[],Ke=new Map;for(const Ze of ne.items){Ke.set(Ze.item.extId,Ze);const Je=m.$_I.root(Ze.item.extId);ne.request.targets.some(nt=>nt.controllerId===Je&&nt.testIds.includes(Ze.item.extId))&&Fe.push(Ze)}return{completedAt:ne.completedAt,results:Fe.map(Ze=>Te(Ze,Ke))}}Me.to=Se})(Ot||(e.TestResults=Ot={}));var Wt;(function(Me){function Te(Ke){return{covered:Ke.covered,total:Ke.covered}}function Se(Ke){return"line"in Ke?l.from(Ke):i.from(Ke)}function ne(Ke){return"branches"in Ke?{count:Ke.executionCount,location:Se(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&Se(Ze.location)})):void 0}:{type:0,count:Ke.executionCount,location:Se(Ke.location)}}Me.fromDetailed=ne;function Fe(Ke){return{uri:Ke.uri,statement:Te(Ke.statementCoverage),branch:Ke.branchCoverage&&Te(Ke.branchCoverage),function:Ke.functionCoverage&&Te(Ke.functionCoverage),details:Ke.detailedCoverage?.map(ne)}}Me.fromFile=Fe})(Wt||(e.TestCoverage=Wt={}));var Jt;(function(Me){function Te(Se){switch(Se){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Me.to=Te})(Jt||(e.CodeActionTriggerKind=Jt={}));var qt;(function(Me){function Te(ne){const Fe=new n.$YL(X.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),i.to(ne.range),i.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Te;function Se(ne,Fe,Ke){if(Fe=Fe??ne._sessionId,Ke=Ke??ne._itemId,Fe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ke,kind:X.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),tags:ne.tags?.map(ae.from)}}Me.from=Se})(qt||(e.TypeHierarchyItem=qt={}));var Vt;(function(Me){function Te(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Me.from=Te})(Vt||(e.ViewBadge=Vt={}));var Lt;(function(Me){function Te(Ke,Ze,Je){const nt=Ze.fileData;return nt?new n.$0K(new n.$$K(nt.name,y.URI.revive(nt.uri),nt.id,(0,L.$db)(()=>Je(nt.id)))):Ke===R.$Qr.uriList&&Ze.uriListData?new n.$9K(Fe(Ze.uriListData)):new n.$9K(Ze.asString)}Me.to=Te;async function Se(Ke,Ze){const Je=await Ze.asString();if(Ke===R.$Qr.uriList)return{asString:Je,fileData:void 0,uriListData:ne(Je)};const nt=Ze.asFile();return{asString:Je,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Me.from=Se;function ne(Ke){return d.$4s.split(Ke).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return y.URI.parse(Ze)}catch{}return Ze})}function Fe(Ke){return d.$4s.create(Ke.map(Ze=>typeof Ze=="string"?Ze:y.URI.revive(Ze)))}})(Lt||(e.DataTransferItem=Lt={}));var lt;(function(Me){function Te(ne,Fe){const Ke=ne.items.map(([Ze,Je])=>[Ze,Lt.to(Ze,Je,Fe)]);return new n.$_K(Ke)}Me.toDataTransfer=Te;async function Se(ne){const Fe={items:[]},Ke=[];for(const[Ze,Je]of ne)Ke.push((async()=>{Fe.items.push([Ze,await Lt.from(Ze,Je)])})());return await Promise.all(Ke),Fe}Me.from=Se})(lt||(e.DataTransfer=lt={}));var ft;(function(Me){function Te(ne){return{message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.to=Te;function Se(ne){return{kind:"reply",message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.from=Se})(ft||(e.ChatReplyFollowup=ft={}));var Tt;(function(Me){function Te(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:ft.from(Se)}Me.from=Te})(Tt||(e.ChatFollowup=Tt={}));var Kt;(function(Me){function Te(ne){const Fe=new n.$9L(Dt.to(ne.role),ne.content);return Fe.name=ne.name,Fe}Me.to=Te;function Se(ne){return{role:Dt.from(ne.role),content:ne.content,name:ne.name}}Me.from=Se})(Kt||(e.ChatMessage=Kt={}));var Dt;(function(Me){function Te(ne){switch(ne){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Me.to=Te;function Se(ne){switch(ne){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Me.from=Se})(Dt||(e.ChatMessageRole=Dt={}));var ct;(function(Me){function Te(Fe){const Ke={};for(const Ze of Object.keys(Fe))Ke[Ze]=Fe[Ze].map(Me.to);return Ke}Me.objectTo=Te;function Se(Fe){return{level:wt.to(Fe.level),value:Fe.value,description:Fe.description}}Me.to=Se;function ne(Fe){return{level:wt.from(Fe.level),value:Fe.value,description:Fe.description}}Me.from=ne})(ct||(e.ChatVariable=ct={}));var wt;(function(Me){function Te(ne){switch(ne){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Me.to=Te;function Se(ne){switch(ne){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Me.from=Se})(wt||(e.ChatVariableLevel=wt={}));var Ht;(function(Me){function Te(Se){switch(Se){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Ht||(e.InteractiveEditorResponseFeedbackKind=Ht={}));var Pt;(function(Me){function Te(Se){return"placeholder"in Se&&"resolvedContent"in Se?{placeholder:Se.placeholder}:"responseId"in Se?{requestId:Se.responseId}:"content"in Se?{content:typeof Se.content=="string"?Se.content:M.from(Se.content)}:"documents"in Se?{documents:Se.documents.map(ne=>({uri:ne.uri,version:ne.version,ranges:ne.ranges.map(Fe=>i.from(Fe))}))}:"reference"in Se?{reference:"uri"in Se.reference?{uri:Se.reference.uri,range:i.from(Se.reference.range)}:Se.reference}:"inlineReference"in Se?{inlineReference:"uri"in Se.inlineReference?{uri:Se.inlineReference.uri,range:i.from(Se.inlineReference.range)}:Se.inlineReference,title:Se.title}:Se}Me.from=Te})(Pt||(e.ChatResponseProgress=Pt={}));var Ge;(function(Me){function Te(Se,ne,Fe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:ne.toInternal(Se,Fe)}Me.from=Te})(Ge||(e.TerminalQuickFix=Ge={}))}),define(De[281],Ce([1,0,2,9,7,13,76]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;class ${constructor(v,R,I,w={timeout:1500,errors:3}){this.c=v,this.d=R,this.f=I,this.g=w,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(v){return(R,I,w)=>{const k={dispose:this.a.push([R,I,v])};return Array.isArray(w)&&w.push(k),k}}async $participateInSave(v,R){const I=C.URI.revive(v);let w=!1;const y=setTimeout(()=>w=!0,this.g.timeout),k=[];try{for(const p of[...this.a]){if(w)break;const u=this.d.getDocument(I),o=await this.h(p,{document:u,reason:L.TextDocumentSaveReason.to(R)});k.push(o)}}finally{clearTimeout(y)}return k}h([v,R,I],w){const y=this.b.get(v);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(I,v,R,w).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const p=this.b.get(v);this.b.set(v,p?p+1:1),typeof p=="number"&&p>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(v,R,I,w){const y=[],k=Date.now(),{document:p,reason:u}=w,{version:o}=p,r=Object.freeze({document:p,reason:u,waitUntil(s){if(Object.isFrozen(y))throw(0,F.$8)("waitUntil can not be called async");y.push(Promise.resolve(s))}});try{R.apply(I,[r])}catch(s){return Promise.reject(s)}return Object.freeze(y),new Promise((s,m)=>{const h=setTimeout(()=>m(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(h),s(t)}).catch(t=>{clearTimeout(h),m(t)})}).then(s=>{const m={edits:[]};for(const h of s)if(Array.isArray(h)&&h.every(t=>t instanceof d.$pK))for(const{newText:t,newEol:n,range:c}of h)m.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:c&&L.Range.from(c),text:t,eol:n&&L.EndOfLine.from(n)}});if(m.edits.length!==0)return o===p.version?this.f.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.$scc=$}),define(De[282],Ce([1,0,18,2,13,7,108]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=void 0;class ${constructor(I,w,y,k){this.start=I,this.deletedCount=w,this.deletedItems=y,this.items=k}asApiEvent(){return{range:new L.$FL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,w,y){this.notebook=I,this.h=w,this.j=y,this.handle=y.handle,this.uri=F.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(d.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(d.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:d.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return I.g},set mime(k){I.g=k},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(y)}return this.f}setOutputs(I){this.a=I.map(d.NotebookCellOutput.to)}setOutputItems(I,w,y){const k=y.map(d.NotebookCellOutputItem.to),p=this.a.find(u=>u.id===I);if(p&&(w||(p.items.length=0),p.items.push(...k),p.items.length>1&&p.items.every(u=>A.$qI(u.mime)))){const u=new Map,o=[];p.items.forEach(r=>{let s;u.has(r.mime)?s=u.get(r.mime):(s=[],u.set(r.mime,s),o.push(r.mime)),s.push(r.data)}),p.items.length=0,o.forEach(r=>{const s=A.$rI(u.get(r));p.items.push({mime:r,data:s.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(d.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$Fdc=E;class v{static{this.a=0}constructor(I,w,y,k,p){this.k=I,this.l=w,this.m=y,this.uri=k,this.handle=v.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=p.viewType,this.f=Object.freeze(p.metadata??Object.create(null)),this.r([[0,0,p.cells]],!0,void 0),this.g=p.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,w={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===C.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(y){return y=I.n(y),I.b[y].apiCell},getCells(y){return(y?I.p(y):I.b).map(p=>p.apiCell)},save(){return I.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,w,y){this.g=I.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:y});const k={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},p=[];for(const o of I.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,k.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,k.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),p.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),p.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),p.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),p.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),p.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const u=new Map;for(let o=0;o<p.length;o++){const r=p[o],s=u.get(r.cell);if(s===void 0){const m=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});u.set(r.cell,m-1)}else k.cellChanges[s]={...k.cellChanges[s],...r}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let w=I.start|0,y=I.end|0;return w<0&&(w=0),y>this.b.length&&(y=this.b.length),I.with({start:w,end:y})}p(I){I=this.o(I);const w=[];for(let y=I.start;y<I.end;y++)w.push(this.b[y]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,w,y){if(this.j)return;const k=[],p=[],u=[];if(I.reverse().forEach(o=>{const s=o[2].map(t=>{const n=new E(this,this.l,t);return w||p.push(E.asModelAddData(this.apiNotebook,t)),n}),m=new $(o[0],o[1],[],s),h=this.b.splice(o[0],o[1],...s);for(const t of h)u.push(t.uri),m.deletedItems.push(t.apiCell);k.push(m)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:u}),y)for(const o of k)y.push(o.asApiEvent())}s(I,w,y,k){const p=this.b.splice(I,w);this.b.splice(y,0,...p);const u=[new $(I,w,p.map(o=>o.apiCell),[]),new $(y,0,[],p)];for(const o of u)k.push(o.asApiEvent())}t(I,w){this.b[I].setOutputs(w)}u(I,w,y,k){this.b[I].setOutputItems(w,y,k)}v(I,w){const y=this.b[I];y.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(y.uri,w)}w(I,w){const y=this.b[I];y.apiCell.mime=w}x(I,w){this.b[I].setMetadata(w)}y(I,w){this.b[I].setInternalMetadata(w)}getCellFromApiCell(I){return this.b.find(w=>w.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(w=>w.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$Gdc=v}),define(De[283],Ce([1,0,4,2,13,7]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;class A{constructor(E,v,R,I={timeout:1500,errors:3}){this.b=E,this.c=v,this.d=R,this.f=I,this.a=new C.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(v,R,I)=>{const w=function(k){v.call(R,k)};return w.extension=E,this.a.event(w,void 0,I)}}async $participateInSave(E,v,R){const I=F.URI.revive(E),w=this.c.getNotebookDocument(I);if(!w)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:d.TextDocumentSaveReason.to(v)},R,async(p,u)=>{const o=Date.now(),r=await await Promise.resolve(p);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!R.isCancellationRequested&&r&&(r instanceof L.$sK?y.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(y.length===0)return!0;const k={edits:[]};for(const p of y){const{edits:u}=d.WorkspaceEdit.from(p);k.edits=k.edits.concat(u)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$7dc=A}),define(De[144],Ce([1,0,9,13,7]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor($,E,v,R,I,w){this.id=$,this.f=E,this.notebookData=v,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=R,this.c=w}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(E){this.selections=[E]},get selections(){return $.a},set selections(E){if(!Array.isArray(E)||!E.every(d.$FL.isNotebookRange))throw(0,C.$7)("selections");$.a=E,$.g(E)},get visibleRanges(){return $.b},revealRange(E,v){$.f.$tryRevealRange($.id,F.NotebookRange.from(E),v??d.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(F.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Hdc=L}),define(De[284],Ce([1,0,9,4,14,13]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;let A=class{constructor(E,v){this.c=E,this.d=v,this.a=new F.$Nd({onListenerError:C.$2}),this.b=new F.$Nd({onListenerError:C.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,v){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,v);const R=this.d.getEditorById(E);v.visibleRanges&&R._acceptVisibleRanges(v.visibleRanges.ranges.map(L.NotebookRange.to)),v.selections&&R._acceptSelections(v.selections.selections.map(L.NotebookRange.to)),v.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),v.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const v in E)this.d.getEditorById(v)._acceptViewColumn(L.ViewColumn.to(E[v]))}};e.$Zdc=A,e.$Zdc=A=He([Be(0,d.$0i)],A)}),define(De[285],Ce([1,0,13,64,208,21,57,9]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class E{constructor(w){this.b=0,this.c=new Map,this.a=w}async withProgress(w,y,k){const p=this.b++,{title:u,location:o,cancellable:r}=y,s={label:(0,d.localize)(0,null,w.displayName||w.name),id:w.identifier.value};return this.a.$startProgress(p,{location:C.ProgressLocation.from(o),title:u,source:s,cancellable:r},w.isUnderDevelopment?void 0:w.identifier.value).catch($.$2),this.d(p,k,!!r)}d(w,y,k){let p;k&&(p=new L.$Xd,this.c.set(w,p));const u=r=>{this.a.$progressEnd(r),this.c.delete(r),p?.dispose()};let o;try{o=y(new R(this.a,w),k&&p?p.token:L.CancellationToken.None)}catch(r){throw u(w),r}return o.then(r=>u(w),r=>u(w)),o}$acceptProgressCanceled(w){const y=this.c.get(w);y&&(y.cancel(),this.c.delete(w))}}e.$4cc=E;function v(I,w){return I.message=w.message,typeof w.increment=="number"&&(typeof I.increment=="number"?I.increment+=w.increment:I.increment=w.increment),I}class R extends F.$6u{constructor(w,y){super(k=>this.throttledReport(k)),this.i=w,this.j=y}throttledReport(w){this.i.$progressReport(this.j,w)}}He([(0,A.$jh)(100,(I,w)=>v(I,w),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[145],Ce([1,0,32,142,68,109,87,13,2]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.$uM=e.$tM=void 0;const v=(s,m,h,t)=>{let n=m;return{enumerable:!0,configurable:!1,get(){return n},set(c){if(!h(n,c)){const i=n;n=c,s.listener?.(t(c,i))}}}},R=(s,m)=>s===m,I={range:(s,m)=>s===m?!0:!s||!m?!1:s.isEqual(m),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(s,m)=>!(s.length!==m.length||s.some(h=>!m.find(t=>h.id===t.id)))},w=s=>m=>({op:4,update:s(m)}),y=(s,m)=>({range:(()=>{let h;const t=w(n=>({range:C.$us.lift($.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return h},set(n){s.listener?.({op:6}),I.range(h,n)||(h=n,s.listener?.(t(n)))}}})(),label:v(s,m,I.label,w(h=>({label:h}))),description:v(s,void 0,I.description,w(h=>({description:h}))),sortText:v(s,void 0,I.sortText,w(h=>({sortText:h}))),canResolveChildren:v(s,!1,I.canResolveChildren,h=>({op:2,state:h})),busy:v(s,!1,I.busy,w(h=>({busy:h}))),error:v(s,void 0,I.error,w(h=>({error:$.MarkdownString.fromStrict(h)||null}))),tags:v(s,[],I.tags,(h,t)=>({op:1,new:h.map($.TestTag.from),old:t.map($.TestTag.from)}))}),k=s=>{const m=d.$_I.fromString(s.extId),h=new u(m.controllerId,m.localId,s.label,E.URI.revive(s.uri)||void 0);return h.range=$.Range.to(s.range||void 0),h.description=s.description||void 0,h.sortText=s.sortText||void 0,h.tags=s.tags.map(t=>$.TestTag.to({id:(0,A.$eJ)(t).tagId})),h},p=s=>{let m;for(const h of s.tests){const t=k(h.item);(0,F.$dM)(t).parent=m,m=t}return m};e.$tM=p;class u{constructor(m,h,t,n){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,F.$cM)(this,m);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof o?void 0:c.parent}},children:{value:(0,L.$bM)(c,F.$dM,u),enumerable:!0,writable:!1},...y(c,t)})}}e.$uM=u;class o extends u{constructor(m,h){super(m,m,h,void 0),this._isRoot=!0}}e.$vM=o;class r extends L.$0L{constructor(m,h,t){super({controllerId:m,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:F.$dM,getChildren:n=>n.children,root:new o(m,h),toITestItem:$.TestItem.from})}}e.$wM=r}),define(De[146],Ce([1,0,58,9,119,13,7]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=void 0;class ${static{this.c=new d.$mM("TextEditorDecorationType")}constructor(w,y,k){const p=$.c.nextId();w.$registerTextEditorDecorationType(y.identifier,p,L.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:p,dispose(){w.$removeTextEditorDecorationType(p)}})}}e.$oM=$;class E{constructor(w,y){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,y){this.k();let k=null;if(w instanceof A.$jK)k=new A.$kK(w,w);else if(w instanceof A.$kK)k=w;else throw new Error("Unrecognized location");this.l(k,y,!1)}insert(w,y){this.k(),this.l(new A.$kK(w,w),y,!0)}delete(w){this.k();let y=null;if(w instanceof A.$kK)y=w;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(w,y,k){const p=this.c.validateRange(w);this.g.push({range:p,text:y,forceMoveMarkers:k})}setEndOfLine(w){if(this.k(),w!==A.EndOfLine.LF&&w!==A.EndOfLine.CRLF)throw(0,F.$7)("endOfLine");this.h=w}}class v{constructor(w,y,k,p){this.c=w,this.d=y,this._accept(k),this.e=p;const u=this;this.value={get tabSize(){return u.f},set tabSize(o){u.m(o)},get indentSize(){return u.g},set indentSize(o){u.o(o)},get insertSpaces(){return u.h},set insertSpaces(o){u.q(o)},get cursorStyle(){return u.j},set cursorStyle(o){u.s(o)},get lineNumbers(){return u.k},set lineNumbers(o){u.t(o)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.insertSpaces,this.j=w.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(w.lineNumbers)}l(w){if(w==="auto")return"auto";if(typeof w=="number"){const y=Math.floor(w);return y>0?y:null}if(typeof w=="string"){const y=parseInt(w,10);return isNaN(y)?null:y>0?y:null}return null}m(w){const y=this.l(w);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const y=Math.floor(w);return y>0?y:null}if(typeof w=="string"){const y=parseInt(w,10);return isNaN(y)?null:y>0?y:null}return null}o(w){const y=this.n(w);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(w){return w==="auto"?"auto":w==="false"?!1:!!w}q(w){const y=this.p(w);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(w){this.j!==w&&(this.j=w,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}t(w){this.k!==w&&(this.k=w,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(w)})))}assign(w){const y={};let k=!1;if(typeof w.tabSize<"u"){const p=this.l(w.tabSize);p==="auto"?(k=!0,y.tabSize=p):typeof p=="number"&&this.f!==p&&(this.f=p,k=!0,y.tabSize=p)}if(typeof w.indentSize<"u"){const p=this.n(w.indentSize);p==="tabSize"?(k=!0,y.indentSize=p):typeof p=="number"&&this.g!==p&&(this.g=p,k=!0,y.indentSize=p)}if(typeof w.insertSpaces<"u"){const p=this.p(w.insertSpaces);p==="auto"?(k=!0,y.insertSpaces=p):this.h!==p&&(this.h=p,k=!0,y.insertSpaces=p)}typeof w.cursorStyle<"u"&&this.j!==w.cursorStyle&&(this.j=w.cursorStyle,k=!0,y.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.k!==w.lineNumbers&&(this.k=w.lineNumbers,k=!0,y.lineNumbers=L.TextEditorLineNumbersStyle.from(w.lineNumbers)),k&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(w,y){y.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(k)})}}e.$pM=v;class R{constructor(w,y,k,p,u,o,r,s){this.id=w,this.j=y,this.k=k,this.g=!1,this.h=new Set,this.c=u,this.d=new v(this.j,this.id,o,k),this.e=r,this.f=s;const m=this;this.value=Object.freeze({get document(){return p.value},set document(h){throw new F.$9("document")},get selection(){return m.c&&m.c[0]},set selection(h){if(!(h instanceof A.$lK))throw(0,F.$7)("selection");m.c=[h],m.l()},get selections(){return m.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof A.$lK)))throw(0,F.$7)("selections");m.c=h,m.l()},get visibleRanges(){return m.e},set visibleRanges(h){throw new F.$9("visibleRanges")},get options(){return m.d.value},set options(h){m.g||m.d.assign(h)},get viewColumn(){return m.f},set viewColumn(h){throw new F.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new E(p.value,t);return h(n),m.m(n)},insertSnippet(h,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=m.c.map(i=>L.Range.from(i));else if(t instanceof A.$jK){const{lineNumber:i,column:a}=L.Position.from(t);c=[{startLineNumber:i,startColumn:a,endLineNumber:i,endColumn:a}]}else if(t instanceof A.$kK)c=[L.Range.from(t)];else{c=[];for(const i of t)if(i instanceof A.$kK)c.push(L.Range.from(i));else{const{lineNumber:a,column:l}=L.Position.from(i);c.push({startLineNumber:a,startColumn:l,endLineNumber:a,endColumn:l})}}return y.$tryInsertSnippet(w,p.value.version,h.value,c,n)},setDecorations(h,t){const n=t.length===0;n&&!m.h.has(h.key)||(n?m.h.delete(h.key):m.h.add(h.key),m.n(()=>{if(L.$eM(t))return y.$trySetDecorations(w,h.key,L.$fM(t));{const c=new Array(4*t.length);for(let i=0,a=t.length;i<a;i++){const l=t[i];c[4*i]=l.start.line+1,c[4*i+1]=l.start.character+1,c[4*i+2]=l.end.line+1,c[4*i+3]=l.end.character+1}return y.$trySetDecorationsFast(w,h.key,c)}}))},revealRange(h,t){m.n(()=>y.$tryRevealRange(w,L.Range.from(h),t||A.TextEditorRevealType.Default))},show(h){y.$tryShowEditor(w,L.ViewColumn.from(h))},hide(){y.$tryHideEditor(w)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,C.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,C.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,C.ok)(!this.g),this.f=w}_acceptSelections(w){(0,C.ok)(!this.g),this.c=w}async l(){const w=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const y=w.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const k=y.edits.map(u=>u.range);k.sort((u,o)=>u.end.line===o.end.line?u.end.character===o.end.character?u.start.line===o.start.line?u.start.character-o.start.character:u.start.line-o.start.line:u.end.character-o.end.character:u.end.line-o.end.line);for(let u=0,o=k.length-1;u<o;u++){const r=k[u].end;if(k[u+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=y.edits.map(u=>({range:L.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,p,{setEndOfLine:typeof y.setEndOfLine=="number"?L.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$qM=R}),define(De[147],Ce([1,0,5,131]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DJ=void 0,e.$DJ=(0,C.$Qh)(F.$Wh)}),define(De[148],Ce([1,0,25,4,16,3]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o4b=e.$n4b=e.$m4b=e.$l4b=e.$k4b=e.$j4b=void 0;class A{constructor(o,r){this.versionId=o,this.removedDueToLooping=r}}e.$j4b=A;class ${static isHostExtension(o,r,s){if(r.getExtensionDescription(o))return!1;const m=s.getExtensionDescription(o);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(o,r){this.j=o,this.c=new F.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(k),this.f=new C.$8l,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const r=this.j.readActivationEvents(o);if(Array.isArray(r))for(let s of r)s==="onUri"&&(s=`onUri:${C.$6l.toKey(o.identifier)}`),this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,r){this.e=p(this.e,r),this.e=this.e.concat(o);const s=$.l(this.e);return this.e=p(this.e,s.map(m=>m.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,s)}static l(o){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,c){this.addNode(n),this.addNode(c),this.c.has(n)?this.c.get(n).push(c):this.c.set(n,[c])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,c){const i=r.getArcs(n);for(let a=0;a<i.length;a++)if(!c.has(i[a]))return!1;return!0}getNodes(){return this.e}},s=new C.$8l;for(const n of o)if(s.set(n.identifier,n),n.extensionDependencies)for(const c of n.extensionDependencies)r.addArc(C.$6l.toKey(n.identifier),C.$6l.toKey(c));const m=new Set;r.getNodes().filter(n=>r.getArcs(n).length===0).forEach(n=>m.add(n));const h=r.getNodes().filter(n=>!m.has(n));let t;do{t=!1;for(let n=0;n<h.length;n++){const c=h[n];r.hasOnlyGoodArcs(c,m)&&(h.splice(n,1),n--,m.add(c),t=!0)}}while(t);return h.map(n=>s.get(n))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const r=this.h.get(o);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const r=this.f.get(o);return r||void 0}getExtensionDescriptionByUUID(o){for(const r of this.g)if(r.uuid===o)return r}getExtensionDescriptionByIdOrUUID(o,r){return this.getExtensionDescription(o)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$k4b=$;class E{constructor(o,r){this.versionId=o,this.extensions=r}}e.$l4b=E,e.$m4b={readActivationEvents:u=>u.activationEvents};class v{constructor(o){this.d=new w,this.c=new $(o,[])}async acquireLock(o){const r=await this.d.acquire(o);return new R(this,r)}deltaExtensions(o,r,s){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,s)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,r){return this.c.getExtensionDescriptionByIdOrUUID(o,r)}}e.$n4b=v;class R extends L.$Sc{constructor(o,r){super(),this.f=o,this.c=!1,this.B(r)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$o4b=R;class I{constructor(o){this.name=o,this.promise=new Promise((r,s)=>{this.c=r})}resolve(o){this.c(o)}}class w{constructor(){this.c=[],this.d=!1}async acquire(o){const r=new I(o);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let r=!0;const s=setTimeout(()=>{r&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{r&&(clearTimeout(s),r=!1,this.d=!1,this.e())};o.resolve((0,L.$Qc)(m))}}var y;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(y||(y={}));function k(u,o){const r=u.isBuiltin?0:u.isUnderDevelopment?2:1,s=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(r!==s)return r-s;const m=d.$gc.basename(u.extensionLocation.path),h=d.$gc.basename(o.extensionLocation.path);return m<h?-1:m>h?1:0}function p(u,o){const r=new C.$7l(o);return u.filter(s=>!r.has(s.identifier))}}),define(De[286],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.ExtHostConnectionType=void 0;var C;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[F.ENV_KEY]=this.pipeName}}e.$xm=F;class d{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[d.ENV_KEY]="1"}}e.$ym=d;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[L.ENV_KEY]="1"}}e.$zm=L;function A(R){delete R[F.ENV_KEY],delete R[d.ENV_KEY],delete R[L.ENV_KEY]}function $(R,I){A(I),R.serialize(I)}e.$Am=$;function E(R){if(R[F.ENV_KEY])return v(R,new F(R[F.ENV_KEY]));if(R[d.ENV_KEY])return v(R,new d);if(R[L.ENV_KEY])return v(R,new L);throw new Error("No connection information defined in environment!")}e.$Bm=E;function v(R,I){return A(R),I}}),define(De[111],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$cm=e.$bm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(F||(e.UIKind=F={}));var d;(function(v){v[v.VersionMismatch=55]="VersionMismatch",v[v.UnexpectedError=81]="UnexpectedError"})(d||(e.ExtensionHostExitCode=d={}));var L;(function(v){v[v.Initialized=0]="Initialized",v[v.Ready=1]="Ready",v[v.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(v){const R=C.$be.alloc(1);switch(v){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$bm=A;function $(v,R){if(v.byteLength!==1)return!1;switch(v.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$cm=$;var E;(function(v){v.Start="START_NATIVE_LOG",v.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(De[88],Ce([1,0,5,4,14,27,111,66,85,24,2,3,210]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=e.$yM=void 0;let y=class extends I.$Sc{constructor(o,r){super(),this.s=o,this.t=r,this.a=this.B(new F.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:E.$po,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(s=>{(0,d.$_i)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===d.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,r,s){const m=this.getTelemetryDetails(),h=new k(r,s,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(o,r,s){this.f=o,this.g=r,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const r=Object.create(null);switch(r["common.extname"]=`${o.publisher}.${o.name}`,r["common.extversion"]=o.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=p(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:r["common.uikind"]="web";break;case A.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,$.$Vk)((0,E.$wo)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const r=this.getTelemetryDetails();this.r.forEach((s,m)=>{const h=s.filter(t=>!t.isDisposed);h.length===0?this.r.delete(m):this.r.set(m,h)}),this.r.forEach(s=>{for(const m of s)m.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,r){const m=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!m)return this.r.delete(o.value),!1;let h=!1;for(const t of m)t.ignoreUnhandledExtHostErrors||(t.logError(r),h=!0);return h}};e.$yM=y,e.$yM=y=He([Be(0,L.$xM),Be(1,d.$$i)],y);class k{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,r,s,m,h,t,n){this.g=s,this.h=m,this.i=h,this.j=t,this.a=new F.$Nd,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(o,r){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let r="properties"in o?o.properties??{}:o;return r=(0,E.$zo)(r,[]),this.c&&(r=(0,v.$0m)(r,this.c)),this.b||(r=(0,v.$0m)(r,this.j)),"properties"in o?o.properties=r:o=r,o}k(o,r){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(o,r),this.h.trace(o,r))}logUsage(o,r){this.d.isUsageEnabled&&this.k(o,r)}logError(o,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,r);else{const s={name:o.name,message:o.message,stack:o.stack,cause:o.cause},m=(0,E.$zo)(s,[]),h=new Error(m.message,{cause:m.cause});h.stack=m.stack,h.name=m.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const o=this,r={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$zM=k;function p(u){const o=Date.now()-new Date(u).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$AM=p,e.$BM=(0,C.$Ph)("IExtHostTelemetry")}),define(De[26],Ce([1,0,4,2,252,137,25,5]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jF=e.$iF=e.$hF=e.ActivationKind=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.ExtensionHostStartup=e.$bF=e.$aF=e.$_E=e.$$E=void 0,e.$$E=Object.freeze({identifier:new A.$6l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$_E="extensions.webWorker",e.$aF=(0,$.$Ph)("extensionService");class E{constructor(h){this.dependency=h}}e.$bF=E;var v;(function(m){m[m.EagerAutoStart=1]="EagerAutoStart",m[m.EagerManualStart=2]="EagerManualStart",m[m.Lazy=3]="Lazy"})(v||(e.ExtensionHostStartup=v={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,n){this.c=h,this.d=t.slice(0),this.e=n.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$VE.createActivationEventsMap(this.d)}}set(h,t,n){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],i=[],a=[],l=[],D=I(this.d),S=I(t),b=(O,M)=>O.extensionLocation.toString()===M.extensionLocation.toString()||O.isBuiltin===M.isBuiltin||O.isUserBuiltin===M.isUserBuiltin||O.isUnderDevelopment===M.isUnderDevelopment;for(const O of this.d){const M=S.get(O.identifier);if(!M){c.push(O.identifier),D.delete(O.identifier);continue}if(!b(O,M)){c.push(O.identifier),D.delete(O.identifier);continue}}for(const O of t){const M=D.get(O.identifier);if(!M){i.push(O);continue}if(!b(M,O)){c.push(M.identifier),D.delete(M.identifier);continue}}const f=new A.$7l(this.e),g=new A.$7l(n);for(const O of this.e)g.has(O)||a.push(O);for(const O of n)f.has(O)||l.push(O);const P=L.$VE.createActivationEventsMap(i),N={versionId:h,toRemove:c,toAdd:i,addActivationEvents:P,myToRemove:a,myToAdd:l};return this.delta(N),N}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:c,myToAdd:i}=h,a=new A.$7l(t),l=new A.$7l(c);for(let D=0;D<this.d.length;D++)a.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)l.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of n)this.d.push(D);for(const D of i)this.e.push(D);return h}containsExtension(h){for(const t of this.e)if(A.$6l.equals(t,h))return!0;return!1}}e.$cF=R;function I(m){const h=new A.$8l;for(const t of m)h.set(t.identifier,t);return h}function w(m,h){return m.enabledApiProposals?m.enabledApiProposals.includes(h):!1}e.$dF=w;function y(m,h){if(!w(m,h))throw new Error(`Extension '${m.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${m.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.$eF=y;class k{constructor(h,t,n,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=c}}e.$fF=k;class p{constructor(h,t){this.description=h,this.value=t}}e.$gF=p;var u;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function o(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,d.$Fo)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation,targetPlatform:m.targetPlatform,validations:[],isValid:!0}}e.$hF=o;function r(m,h){return{identifier:new A.$6l((0,d.$Do)(m.manifest.publisher,m.manifest.name)),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!!h,extensionLocation:m.location,...m.manifest,uuid:m.identifier.uuid,targetPlatform:m.targetPlatform}}e.$iF=r;class s{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$jF=s}),define(De[287],Ce([1,0,9,148,25,26,14,8]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=e.$wcc=e.$vcc=e.$ucc=e.$tcc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(o,r,s,m){this.startup=o,this.codeLoadingTime=r,this.activateCallTime=s,this.activateResolvedTime=m}}e.$tcc=E;class v{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,r){return o===-1||r===-1?-1:r-o}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$ucc=v;class R{constructor(o,r,s,m,h,t){this.activationFailed=o,this.activationFailedError=r,this.activationTimes=s,this.module=m,this.exports=h,this.subscriptions=t}}e.$vcc=R;class I extends R{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$wcc=I;class w extends R{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xcc=w;class y extends R{constructor(o){super(!0,o,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(o,r,s,m){this.g=m,this.a=o,this.b=r,this.c=s,this.d=new d.$8l,this.f=Object.create(null)}dispose(){for(const[o,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const o=[];for(const[r,s]of this.d)o.push(s.wait());await Promise.all(o)}isActivated(o){const r=this.d.get(o);return!!(r&&r.value)}getActivatedExtension(o){const r=this.d.get(o);if(!r||!r.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return r.value}async activateByEvent(o,r){if(this.f[o])return;const s=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(s.map(m=>({id:m.identifier,reason:{startup:r,extensionId:m.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,r){const s=this.a.getExtensionDescription(o);if(!s)throw new Error(`Extension '${o}' is not known`);return this.h([{id:s.identifier,reason:r}])}async h(o){const r=o.filter(s=>!this.isActivated(s.id)).map(s=>this.j(s));await Promise.all(r.map(s=>s.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const r=this.a.getExtensionDescription(o.id);if(!r){const h=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new y(h));return this.c.onExtensionActivationError(o.id,h,new L.$bF(o.id.value)),t}const s=[],m=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of m){if(this.m(h))continue;const t=this.d.get(h);if(t){s.push(t);continue}if(this.l(h)){s.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:o.reason}));continue}const n=this.a.getExtensionDescription(h);if(n){if(!n.main&&!n.browser)continue;s.push(this.j({id:n.identifier,reason:o.reason}));continue}const c=r.displayName||r.identifier.value,i=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),a=this.k(o,r.displayName,[],new y(i));return this.c.onExtensionActivationError(r.identifier,i,new L.$bF(h)),a}return this.k(o,r.displayName,s,null)}k(o,r,s,m){const h=new p(o.id,r,o.reason,s,m,this.c,this.g);return this.d.set(o.id,h),h}l(o){return F.$k4b.isHostExtension(o,this.a,this.b)}m(o){const r=this.b.getExtensionDescription(o);return r?!r.main&&!r.browser:!1}};e.$ycc=k,e.$ycc=k=He([Be(3,A.$0i)],k);let p=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,r,s,m,h,t,n){this.c=o,this.d=r,this.f=s,this.g=m,this.h=h,this.j=t,this.k=n,this.a=new $.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const r=this.g[o];if(r.value&&!r.value.activationFailed){this.g.splice(o,1),o--;continue}if(r.value&&r.value.activationFailed){const s=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);s.detail=r.value.activationFailedError,this.h=new y(s),this.j.onExtensionActivationError(this.c,s,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const r=new Error;if(o&&o.name&&(r.name=o.name),o&&o.message?r.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(r.stack=o.stack),this.h=new y(r),this.b&&C.$4(o))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};p=He([Be(6,A.$0i)],p)}),define(De[288],Ce([1,0,212,23,2,4,3,269,8,7,17,19,13,80,21,173,26]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;function o(m,h){if((0,R.$yf)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let t;return Array.isArray(m.highlights)&&(t=m.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:m.label,highlights:t}}}class r extends A.$Sc{constructor(h,t,n){super(),this.f=h,this.g=t,this.h=n,this.a=new Map,this.b=new p.$M7;function c(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>c(i)?this.r(i):Array.isArray(i)&&i.length>0?i.map(a=>c(a)?this.r(a):a):i})}registerTreeDataProvider(h,t,n){const c=this.createTreeView(h,{treeDataProvider:t},n);return{dispose:()=>c.dispose()}}createTreeView(h,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,D=this.m(h,t,n),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:i,hasHandleDrag:a,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(h,S),f={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,u.$eF)(n,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,u.$eF)(n,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(g){(0,y.$5j)(g)&&(0,u.$eF)(n,"treeViewMarkdownMessage"),D.message=g},get title(){return D.title},set title(g){D.title=g},get description(){return D.description},set description(g){D.description=g},get badge(){return D.badge},set badge(g){g!==void 0&&v.ViewBadge.isViewBadge(g)?D.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(D.badge=void 0)},reveal:(g,P)=>D.reveal(g,P),dispose:async()=>{await b,this.a.delete(h),D.dispose()}};return this.B(f),f}$getChildren(h,t){const n=this.a.get(h);return n?n.getChildren(t):Promise.reject(new $.$rE(h))}async $handleDrop(h,t,n,c,i,a,l,D){const S=this.a.get(h);if(!S)return Promise.reject(new $.$rE(h));const b=w.DataTransfer.toDataTransfer(n,async f=>(await this.f.$resolveDropFileData(h,t,f)).buffer);return l===h&&D&&await this.j(b,S,D,i,a),S.onDrop(b,c,i)}async j(h,t,n,c,i){const a=this.b.removeDragOperationTransfer(i);if(a)(await a)?.forEach((l,D)=>{l&&h.set(D,l)});else if(i&&t.handleDrag){const l=t.handleDrag(n,h,c);this.b.addDragOperationTransfer(i,l),await l}return h}async $handleDrag(h,t,n,c){const i=this.a.get(h);if(!i)return Promise.reject(new $.$rE(h));const a=await this.j(new v.$_K,i,t,c,n);if(!(!a||c.isCancellationRequested))return w.DataTransfer.from(a)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new $.$rE(h);return t.hasResolve}$resolve(h,t,n){const c=this.a.get(h);if(!c)throw new $.$rE(h);return c.resolveTreeItem(t,n)}$setExpanded(h,t,n){const c=this.a.get(h);if(!c)throw new $.$rE(h);c.setExpanded(t,n)}$setSelectionAndFocus(h,t,n){const c=this.a.get(h);if(!c)throw new $.$rE(h);c.setSelectionAndFocus(t,n)}$setVisible(h,t){const n=this.a.get(h);if(!n){if(!t)return;throw new $.$rE(h)}n.setVisible(t)}$changeCheckboxState(h,t){const n=this.a.get(h);if(!n)throw new $.$rE(h);n.setCheckboxState(t)}m(h,t,n){const c=this.B(new s(h,t,this.f,this.g.converter,this.h,n));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$$cc=r;class s extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.$Hf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,n,c,i,a){if(super(),this.I=h,this.J=n,this.L=c,this.M=i,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$Xd,a.contributes&&a.contributes.views)for(const b in a.contributes.views)for(const f of a.contributes.views[b])f.id===h&&(this.P=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let l,D;const S=L.Event.debounce(this.F.event,(b,f)=>(b||(b={message:!1,elements:[]}),f.element!==!1&&(l||(l=new Promise(g=>D=g),this.G=this.G.then(()=>l)),Array.isArray(f.element)?b.elements.push(...f.element):b.elements.push(f.element)),f.message&&(b.message=!0),b),200,!0);this.B(S(({message:b,elements:f})=>{f.length&&(this.H=this.H.then(()=>{const g=D;return l=null,this.$(f).then(()=>g())})),b&&this.J.$setMessage(this.I,w.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let n=this.X(h);return n||(n=await this.Y(t)),n?n.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const n=(0,R.$Hf)(t.select)?!0:t.select,c=(0,R.$Hf)(t.focus)?!1:t.focus,i=(0,R.$Hf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(a=>this.W(h,a[a.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:a.map(D=>D.item)},{select:n,focus:c,expand:i})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:n,focus:c,expand:i})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=w.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const n=this.getExtensionElement(h);n&&(t?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(h,t){const n=!(0,I.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async n=>{const c=this.getExtensionElement(n.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:n.newState?v.TreeItemCheckboxState.Checked:v.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?v.TreeItemCheckboxState.Checked:v.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(h,t,n){const c=[];for(const i of h){const a=this.getExtensionElement(i);a&&c.push(a)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,n),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,n){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,E.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const n=this.j.get(h);if(n){const c=this.m.get(n);if(c){const i=await this.f.resolveTreeItem(c.extensionItem,n,t)??c.extensionItem;return this.hb(i),c.item.tooltip=this.eb(i.tooltip),c.item.command=this.fb(c.disposableStore,i.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(n=>this.W(t,n[n.length-1]).then(c=>(n.push(c),n))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Mg)(()=>this.f.getParent(h))}W(h,t){const n=this.m.get(h);return n?Promise.resolve(n):(0,E.$Mg)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(c);if(i){const a=this.m.get(i);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const n=this.getExtensionElement(h);t=n?this.m.get(n):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new k.$Xd(this.Z.token);try{const n=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,I.$Hb)(c||[]).map(async a=>{const l=await this.f.getTreeItem(a);return l&&!t.token.isCancellationRequested?this.db(a,l,n):null}));return t.token.isCancellationRequested?void 0:(0,I.$Hb)(i)}finally{t.dispose()}}$(h){if(h.some(n=>!n))return this.Z.dispose(!0),this.Z=new k.$Xd,this.tb(),this.J.$refresh(this.I);{const n=this.ab(h);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(h){const t=new Set,n=h.map(i=>this.m.get(i));for(const i of n)if(i&&!t.has(i.item.handle)){let a=i;for(;a&&a.parent&&n.findIndex(l=>a&&a.parent&&l&&l.item.handle===a.parent.item.handle)===-1;){const l=this.j.get(a.parent.item.handle);a=l?this.m.get(l):void 0}a&&!a.parent&&t.add(i.item.handle)}const c=[];return t.forEach(i=>{const a=this.j.get(i);if(a){const l=this.m.get(a);l&&(!l.parent||!t.has(l.parent.item.handle))&&c.push(i)}}),c}bb(h){const t={};return Promise.all(h.map(n=>this.cb(n).then(c=>{c&&(t[n]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const n=this.m.get(t);if(n)return this.rb(t),(0,E.$Mg)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const i=this.ib(t,c,n.parent);return this.pb(t,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}db(h,t,n){const c=this.ib(h,t,n);if(t.id&&this.j.has(c.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,n),c}eb(h){return v.$IK.isMarkdownString(h)?w.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,n,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,n=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===v.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:c}}hb(h){if(!v.$7K.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,n){this.hb(t);const c=this.B(new A.$Rc),i=this.kb(h,t,n),a=this.lb(t);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,R.$Hf)(t.collapsibleState)?v.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:n,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof v.$cL?h.iconPath:void 0}kb(h,{id:t,label:n,resourceUri:c},i,a){if(t)return`${s.b}/${t}`;const l=o(n,this.N),D=i?i.item.handle:s.a;let S=l?l.label:c?(0,F.$sg)(c):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const b=this.m.has(h)?this.m.get(h).item.handle:void 0,f=this.X(i)||[];let g,P=0;do{if(g=`${D}/${P}:${S}`,a||!this.j.has(g)||b===g)break;P++}while(P<=f.length);return g}lb(h){if(h.iconPath&&!(h.iconPath instanceof v.$cL))return typeof h.iconPath=="string"||d.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof v.$cL)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return d.URI.isUri(h)?h:d.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,n,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(h,t);const i=this.X(c)||[],a=i.filter(l=>l.item.handle===n.item.handle)[0];a&&i.splice(i.indexOf(a),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const n of t.children){const c=this.j.get(n.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const n of t.children){const c=this.j.get(n.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(De[289],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[290],Ce([1,0,224,9,38,132,105,43,25,289,135,137]),function($e,e,C,F,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=void 0;const w=$.$gn.as(A.$hn.JSONContribution);class y{constructor(h,t,n){this.a=h,this.b=t,this.c=n}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(d.default.Error,h)}warn(h){this.d(d.default.Warning,h)}info(h){this.d(d.default.Info,h)}}e.$5E=y;class k{static a(h){const t=new E.$7l;for(let n=0,c=h.length;n<c;n++)t.add(h[n].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new k(t,[]);if(!t||!t.length)return new k([],h);const n=this.a(h),c=this.a(t),i=t.filter(l=>!n.has(l.description.identifier)),a=h.filter(l=>!c.has(l.description.identifier));return new k(i,a)}constructor(h,t){this.added=h,this.removed=t}}e.$6E=k;class p{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=k.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,F.$1)(h)}}}e.$7E=p;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$8E={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$5l},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"*",description:C.localize(42,null),body:"*"}]}},badges:{type:"array",description:C.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(44,null)},href:{type:"string",description:C.localize(45,null)},description:{type:"string",description:C.localize(46,null)}}}},markdown:{type:"string",description:C.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Xn}},extensionPack:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Xn}},extensionKind:{description:C.localize(51,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(52,null)},{body:["workspace"],description:C.localize(53,null)},{body:["ui","workspace"],description:C.localize(54,null)},{body:["workspace","ui"],description:C.localize(55,null)},{body:[],description:C.localize(56,null)}]},capabilities:{description:C.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(60,null),C.localize(61,null),C.localize(62,null)]},description:{type:"string",markdownDescription:C.localize(63,null)}}},untrustedWorkspaces:{description:C.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(66,null),C.localize(67,null),C.localize(68,null)]},restrictedConfigurations:{description:C.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(70,null)}}}}},sponsor:{description:C.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(73,null),type:"string"},"vscode:uninstall":{description:C.localize(74,null),type:"string"}}},icon:{type:"string",description:C.localize(75,null)},l10n:{type:"string",description:C.localize(76,null)},pricing:{type:"string",markdownDescription:C.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new p(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&I.$VE.register(h.extensionPoint,h.activationEventsGenerator),e.$8E.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,w.registerSchema(o,e.$8E),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$9E=r;const s={ExtensionsRegistry:"ExtensionsRegistry"};$.$gn.add(s.ExtensionsRegistry,new r),e.$0E=$.$gn.as(s.ExtensionsRegistry),w.registerSchema(o,e.$8E),w.registerSchema(R.$qj,{properties:{extensionEnabledApiProposals:{description:C.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}}]}}}})}),define(De[291],Ce([1,0,221,17,24,290,42,4]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var v;(function(w){function y(k,p,u){if(!k)return;const o=F.$yf(k.type)?k.type:void 0;if(!o||o.length===0){u.error(C.localize(3,null));return}const r=[];if(Array.isArray(k.required))for(const s of k.required)F.$yf(s)&&r.push(s);return{extensionId:p.value,taskType:o,required:r,properties:k.properties?d.$7m(k.properties):{},when:k.when?A.$Ni.deserialize(k.when):void 0}}w.from=y})(v||(v={}));const R=L.$0E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,y)=>{for(const k of w)k.type&&y.push(`onTaskType:${k.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:E}});class I{constructor(){this.d=new $.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,k)=>{R.setHandler((p,u)=>{this.c=void 0;try{for(const o of u.removed){const r=o.value;for(const s of r)this.a&&s.type&&this.a[s.type]&&delete this.a[s.type]}for(const o of u.added){const r=o.value;for(const s of r){const m=v.from(s,o.description.identifier,o.collector);m&&(this.a[m.taskType]=m)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const k of this.all()){const p={type:"object",additionalProperties:!1};k.required.length>0&&(p.required=k.required.slice(0)),k.properties!==void 0?p.properties=d.$7m(k.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[k.taskType]},y.push(p)}this.c={oneOf:y}}return this.c}}e.$OF=new I}),define(De[292],Ce([1,0,222,17,23,24,42,291]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$YF=e.JsonSchemaVersion=e.ExecutionEngine=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$SF=e.ShellQuoting=e.$RF=e.$QF=e.$PF=void 0,e.$PF="settings",e.$QF=new A.$7i("taskRunning",!1,C.localize(0,null)),e.$RF={value:C.localize(1,null),original:"Tasks"};var E;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$SF="$customized",function(U){function T(K){if(!K)return U.Strong;switch(K.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=T}(E||(e.ShellQuoting=E={}));var v;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(v||(e.CommandOptions=v={}));var R;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(R||(e.RevealKind=R={})),function(U){function T(K){switch(K.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=T}(R||(e.RevealKind=R={}));var I;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(U){function T(K){switch(K.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=T}(I||(e.RevealProblemKind=I={}));var w;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(w||(e.PanelKind=w={})),function(U){function T(K){switch(K.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=T}(w||(e.PanelKind=w={}));var y;(function(U){U.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var k;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(U){function T(q){switch(q.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=T;function K(q){switch(q){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=K}(k||(e.RuntimeType=k={}));var p;(function(U){function T(K){return F.$yf(K)?K:K.value}U.value=T})(p||(e.CommandString=p={}));var u;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function T(q){return q===U.Clean._id||q===U.Build._id||q===U.Rebuild._id||q===U.Test._id}U.is=T;function K(q){if(q!==void 0)return F.$yf(q)?T(q)?{_id:q,isDefault:!1}:void 0:q}U.from=K})(u||(e.TaskGroup=u={}));var o;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var r;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function T(K){switch(K){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=T})(r||(e.TaskSourceKind=r={}));var s;(function(U){U.parallel="parallel",U.sequence="sequence"})(s||(e.DependsOrder=s={}));var m;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(m||(e.RunOnOptions=m={}));var h;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:m.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(T,K,q,ge,ee,Q){this._label="",this._id=T,K&&(this._label=K),q&&(this.type=q),this.runOptions=ge,this.configurationProperties=ee,this._source=Q}getDefinition(T){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,K=!1){if(T===void 0)return!1;if(F.$yf(T))return T===this._label||T===this.configurationProperties.identifier||K&&T===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$TF=t;class n extends t{constructor(T,K,q,ge,ee,Q,X,ae){super(T,q,void 0,X,ae,K),this.command={},this._source=K,this.hasDefinedMatchers=Q,ee&&(this.command=ee)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case k.Shell:K="shell";break;case k.Process:K="process";break;case k.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(T){return T instanceof n}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$PF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const q={type:e.$SF,folder:T,id:K};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new n(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$UF=n;class c extends t{constructor(T,K,q,ge,ee,Q,X){super(T,q,ge,Q,X,K),this._source=K,this.configures=ee}static is(T){return T instanceof c}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$PF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const q={type:e.$SF,folder:T,id:K};return JSON.stringify(q)}}e.$VF=c;class i extends t{constructor(T,K,q,ge,ee,Q,X,ae,ie){super(T,q,ge,ae,ie,K),this.defines=ee,this.hasDefinedMatchers=X,this.command=Q,this.icon=ie.icon,this.hide=ie.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof i}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new i(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$WF=i;class a extends t{constructor(T,K,q,ge,ee,Q){super(T,q,ge,ee,Q,K),this._source=K}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new a(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$XF=a;var l;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(U){U._default=U.Terminal}(l||(e.ExecutionEngine=l={}));var D;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class S{constructor(T){this.c=new Map;for(let K=0;K<T.length;K++)this.c.set(T[K].uri.toString(),K)}compare(T,K){const q=T.getWorkspaceFolder(),ge=K.getWorkspaceFolder();if(q&&ge){let ee=this.c.get(q.uri.toString());ee=ee===void 0?0:ee+1;let Q=this.c.get(ge.uri.toString());return Q=Q===void 0?0:Q+1,ee===Q?T._label.localeCompare(K._label):ee-Q}else return!q&&ge?-1:q&&!ge?1:0}}e.$YF=S;var b;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(b||(e.TaskEventKind=b={}));var f;(function(U){U.SingleRun="singleRun",U.Background="background"})(f||(e.TaskRunType=f={}));var g;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(g||(e.TaskRunSource=g={}));var P;(function(U){function T(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function K(ae,ie,ce){return{...T(ae),kind:"start",terminalId:ie,resolvedVariables:ce}}U.start=K;function q(ae,ie,ce){return{...T(ae),kind:"processStarted",terminalId:ie,processId:ce}}U.processStarted=q;function ge(ae,ie,ce){return{...T(ae),kind:"processEnded",terminalId:ie,exitCode:ce}}U.processEnded=ge;function ee(ae,ie,ce){return{...T(ae),kind:"terminated",exitReason:ce,terminalId:ie}}U.terminated=ee;function Q(ae,ie,ce){return{...T(ie),kind:ae,terminalId:ce}}U.general=Q;function X(){return{kind:"changed"}}U.changed=X})(P||(e.TaskEvent=P={}));var N;(function(U){function T(q){const ge=Object.keys(q).sort();let ee="";for(const Q of ge){let X=q[Q];X instanceof Object?X=T(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),ee+=Q+","+X+","}return ee}function K(q){const ee={_key:T(q),type:q.taskType};return Object.assign(ee,q),ee}U.create=K})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(O||(e.TaskSettingId=O={}));var M;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var j;(function(U){function T(K,q){const ge=$.$OF.get(K.type);if(ge===void 0){const ae=L.$7m(K);return delete ae._key,N.create(ae)}const ee=Object.create(null);ee.type=ge.taskType;const Q=new Set;ge.required.forEach(ae=>Q.add(ae));const X=ge.properties;for(const ae of Object.keys(X)){const ie=K[ae];if(ie!=null)ee[ae]=ie;else if(Q.has(ae)){const ce=X[ae];if(ce.default!==void 0)ee[ae]=L.$7m(ce.default);else switch(ce.type){case"boolean":ee[ae]=!1;break;case"number":case"integer":ee[ae]=0;break;case"string":ee[ae]="";break;default:q.error(C.localize(2,null,JSON.stringify(K,void 0,0),ae));return}}}return N.create(ee)}U.createTaskIdentifier=T})(j||(e.TaskDefinition=j={}))}),define(De[293],Ce([1,0,9]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q4b=e.$p4b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,$)=>{this.b=A,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$1)(A))}then(A,$){return this.j().then(A,$)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$p4b=F;class d extends F{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$q4b=d}),define(De[69],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=e.$pv=e.$ov=e.$nv=void 0;class C{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++C.count}}e.$nv=C;const F=[];function d($){const E=new C($);return F[E.nid]=E,E}e.$ov=d;function L($){return F[$].sid}e.$pv=L;class A{constructor(E){this.value=E}}e.$qv=A}),define(De[6],Ce([1,0,69]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$gK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$fK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var d;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(d||(e.TabInputKind=d={}));var L;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var $;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var E;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var v;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(v||(e.NotebookEditorRevealType=v={}));var R;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class I{static{this.a=0}static mixin(u){return u._id=I.a++,u}}e.$fK=I;var w;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var y;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var k;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$gK={MainThreadAuthentication:(0,C.$ov)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$ov)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$ov)("MainThreadChatProvider"),MainThreadChatAgents:(0,C.$ov)("MainThreadChatAgents"),MainThreadChatAgents2:(0,C.$ov)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$ov)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$ov)("MainThreadClipboard"),MainThreadCommands:(0,C.$ov)("MainThreadCommands"),MainThreadComments:(0,C.$ov)("MainThreadComments"),MainThreadConfiguration:(0,C.$ov)("MainThreadConfiguration"),MainThreadConsole:(0,C.$ov)("MainThreadConsole"),MainThreadDebugService:(0,C.$ov)("MainThreadDebugService"),MainThreadDecorations:(0,C.$ov)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$ov)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$ov)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$ov)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$ov)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$ov)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$ov)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$ov)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$ov)("MainThreadErrors"),MainThreadTreeViews:(0,C.$ov)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$ov)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$ov)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$ov)("MainThreadLanguages"),MainThreadLogger:(0,C.$ov)("MainThreadLogger"),MainThreadMessageService:(0,C.$ov)("MainThreadMessageService"),MainThreadOutputService:(0,C.$ov)("MainThreadOutputService"),MainThreadProgress:(0,C.$ov)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$ov)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$ov)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$ov)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$ov)("MainThreadSecretState"),MainThreadStorage:(0,C.$ov)("MainThreadStorage"),MainThreadSpeech:(0,C.$ov)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$ov)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$ov)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$ov)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$ov)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$ov)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$ov)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$ov)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$ov)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$ov)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$ov)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$ov)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$ov)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$ov)("MainThreadExtensionService"),MainThreadSCM:(0,C.$ov)("MainThreadSCM"),MainThreadSearch:(0,C.$ov)("MainThreadSearch"),MainThreadShare:(0,C.$ov)("MainThreadShare"),MainThreadTask:(0,C.$ov)("MainThreadTask"),MainThreadWindow:(0,C.$ov)("MainThreadWindow"),MainThreadLabelService:(0,C.$ov)("MainThreadLabelService"),MainThreadNotebook:(0,C.$ov)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$ov)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$ov)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$ov)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$ov)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$ov)("MainThreadInteractive"),MainThreadChat:(0,C.$ov)("MainThreadChat"),MainThreadInlineChat:(0,C.$ov)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$ov)("MainThreadTheming"),MainThreadTunnelService:(0,C.$ov)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$ov)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$ov)("MainThreadTimeline"),MainThreadTesting:(0,C.$ov)("MainThreadTesting"),MainThreadLocalization:(0,C.$ov)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$ov)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$ov)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$ov)("MainThreadIssueReporter")},e.$hK={ExtHostCommands:(0,C.$ov)("ExtHostCommands"),ExtHostConfiguration:(0,C.$ov)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$ov)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$ov)("ExtHostDebugService"),ExtHostDecorations:(0,C.$ov)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$ov)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$ov)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$ov)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$ov)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$ov)("ExtHostEditors"),ExtHostTreeViews:(0,C.$ov)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$ov)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$ov)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$ov)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$ov)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$ov)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$ov)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$ov)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$ov)("ExtHostStatusBar"),ExtHostShare:(0,C.$ov)("ExtHostShare"),ExtHostExtensionService:(0,C.$ov)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$ov)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$ov)("ExtHostTerminalService"),ExtHostSCM:(0,C.$ov)("ExtHostSCM"),ExtHostSearch:(0,C.$ov)("ExtHostSearch"),ExtHostTask:(0,C.$ov)("ExtHostTask"),ExtHostWorkspace:(0,C.$ov)("ExtHostWorkspace"),ExtHostWindow:(0,C.$ov)("ExtHostWindow"),ExtHostWebviews:(0,C.$ov)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$ov)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$ov)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$ov)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$ov)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$ov)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$ov)("ExtHostProgress"),ExtHostComments:(0,C.$ov)("ExtHostComments"),ExtHostSecretState:(0,C.$ov)("ExtHostSecretState"),ExtHostStorage:(0,C.$ov)("ExtHostStorage"),ExtHostUrls:(0,C.$ov)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$ov)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$ov)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$ov)("ExtHostOutputService"),ExtHosLabelService:(0,C.$ov)("ExtHostLabelService"),ExtHostNotebook:(0,C.$ov)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$ov)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$ov)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$ov)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$ov)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$ov)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$ov)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$ov)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$ov)("ExtHostChat"),ExtHostChatAgents:(0,C.$ov)("ExtHostChatAgents"),ExtHostChatAgents2:(0,C.$ov)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$ov)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$ov)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$ov)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,C.$ov)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$ov)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$ov)("ExtHostTheming"),ExtHostTunnelService:(0,C.$ov)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$ov)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$ov)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$ov)("ExtHostTimeline"),ExtHostTesting:(0,C.$ov)("ExtHostTesting"),ExtHostTelemetry:(0,C.$ov)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$ov)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$ov)("ExtHostIssueReporter")}}),define(De[294],Ce([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$gK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,$,E){if(this.a.size===0)throw new Error("No related information providers registered");const v=this.a.get(A);if(!v)throw new Error("related information provider not found");return await v.provideRelatedInformation($,E)??[]}getRelatedInformation(A,$,E){return this.c.$getAiRelatedInformation($,E)}registerRelatedInformationProvider(A,$,E){const v=this.b;return this.b++,this.a.set(v,E),this.c.$registerAiRelatedInformationProvider(v,$),new F.$iK(()=>{this.c.$unregisterAiRelatedInformationProvider(v),this.a.delete(v)})}}e.$aec=d}),define(De[89],Ce([1,0,5,14,6,20]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=e.$ccc=void 0,e.$ccc=(0,C.$Ph)("IExtHostApiDeprecationService");let A=class{constructor(E,v){this.c=v,this.a=new Set,this.b=E.getProxy(d.$gK.MainThreadTelemetry)}report(E,v,R){const I=this.d(E,v);this.a.has(I)||(this.a.add(I),v.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:v.identifier.value,apiId:E}))}d(E,v){return`${E}-${v.identifier.value}`}};e.$dcc=A,e.$dcc=A=He([Be(0,L.$hM),Be(1,F.$0i)],A),e.$ecc=Object.freeze(new class{report($,E,v){}})}),define(De[295],Ce([1,0,4,6,7,25]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class A{constructor(v){this.b=new Map,this.c=[],this.d=new C.$Nd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=v.getProxy(F.$gK.MainThreadAuthentication)}$setProviders(v){return this.c=v,Promise.resolve()}async getSession(v,R,I,w={}){const y=L.$6l.toKey(v.identifier),k=[...I].sort().join(" ");return await this.f.getOrCreate(`${y} ${R} ${k}`,async()=>{await this.a.$ensureProvider(R);const p=v.displayName||v.name;return this.a.$getSession(R,I,y,p,w)})}async getSessions(v,R,I){const w=L.$6l.toKey(v.identifier),y=[...I].sort().join(" ");return await this.g.getOrCreate(`${w} ${y}`,async()=>{await this.a.$ensureProvider(R);const k=v.displayName||v.name;return this.a.$getSessions(R,I,w,k)})}async removeSession(v,R){const I=this.b.get(v);return I?I.provider.removeSession(R):this.a.$removeSession(v,R)}registerAuthenticationProvider(v,R,I,w){if(this.b.get(v))throw new Error(`An authentication provider with id '${v}' is already registered.`);this.b.set(v,{label:R,provider:I,options:w??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===v)||this.c.push({id:v,label:R});const y=I.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(v,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(v,R,w?.supportsMultipleAccounts??!1),new d.$iK(()=>{y.dispose(),this.b.delete(v);const k=this.c.findIndex(p=>p.id===v);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(v)})}$createSession(v,R,I){const w=this.b.get(v);if(w)return Promise.resolve(w.provider.createSession(R,I));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$removeSession(v,R){const I=this.b.get(v);if(I)return Promise.resolve(I.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$getSessions(v,R){const I=this.b.get(v);if(I)return Promise.resolve(I.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$onDidChangeAuthenticationSessions(v,R){return this.d.fire({provider:{id:v,label:R}}),Promise.resolve()}}e.$Kdc=A;class ${constructor(){this.a=new Map}getOrCreate(v,R){const I=this.a.get(v);if(I)return I;const w=R().finally(()=>this.a.delete(v));return this.a.set(v,w),w}}}),define(De[296],Ce([1,0,6,20,13]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;let L=class{constructor($,E){this.a=$.getProxy(C.$gK.MainThreadBulkEdits),this.b={getTextDocumentVersion:v=>E.getDocument(v)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,v){const R=d.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,v?.isRefactoring??!1)}};e.$Qdc=L,e.$Qdc=L=He([Be(0,F.$hM)],L)}),define(De[297],Ce([1,0,8,4,51,3,37,202,6,13]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;class R{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=R.a++}}class I{static{this.a=0}constructor(y,k){this.h=k,this.b=new Map,this.d=new Map,this.e=new F.$Nd,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$gK.MainThreadChat)}registerChatProvider(y,k,p){const u=new R(y,p);return this.b.set(u.handle,u),this.g.$registerChatProvider(u.handle,k),(0,L.$Qc)(()=>{this.g.$unregisterChatProvider(u.handle),this.b.delete(u.handle)})}transferChatSession(y,k){const p=d.Iterable.find(this.d.keys(),u=>this.d.get(u)===y)??0;typeof p=="number"&&this.g.$transferChatSession(p,k)}sendInteractiveRequestToProvider(y,k){this.g.$sendRequestToProvider(y,k)}async $prepareChat(y,k,p){const u=this.b.get(y);if(!u)return;const o=await u.provider.prepareSession(k,p);if(!o)return;const r=I.a++;return this.d.set(r,o),{id:r,requesterUsername:o.requester?.name,requesterAvatarIconUri:o.requester?.icon,responderUsername:o.responder?.name,responderAvatarIconUri:o.responder?.icon,inputPlaceholder:o.inputPlaceholder}}async $provideWelcomeMessage(y,k){const p=this.b.get(y);if(!p||!p.provider.provideWelcomeMessage)return;const u=await p.provider.provideWelcomeMessage(k);if(u)return u.map(o=>typeof o=="string"?o:o.map(r=>v.ChatReplyFollowup.from(r)))}async $provideFollowups(y,k,p){const u=this.b.get(y);if(!u)return;const o=this.d.get(k);return!o||!u.provider.provideFollowups?void 0:(await u.provider.provideFollowups(o,p))?.map(s=>v.ChatFollowup.from(s))}async $provideSampleQuestions(y,k){const p=this.b.get(y);if(!p||!p.provider.provideSampleQuestions)return;const u=await p.provider.provideSampleQuestions(k);if(u)return u?.map(o=>v.ChatReplyFollowup.from(o))}$removeRequest(y,k,p){const u=this.b.get(y);if(!u)return;const o=this.d.get(k);o&&u.provider.removeRequest&&u.provider.removeRequest(o,p)}async $provideReply(y,k,p,u){const o=this.b.get(y);if(!o)return;const r=this.d.get(k);if(!r)return;const s={session:r,message:p.message,variables:{}};if(p.variables)for(const i of Object.keys(p.variables))s.variables[i]=p.variables[i].map(v.ChatVariable.to);const m=A.$Jd.create(!1);let h;const t={report:i=>{if(u.isCancellationRequested)return;typeof h>"u"&&(h=m.elapsed());const a=v.ChatResponseProgress.from(i);if("placeholder"in i&&"resolvedContent"in i){const l=Promise.all([this.g.$acceptResponseProgress(y,k,a),i.resolvedContent]);(0,C.$Ig)(l,u).then(D=>{if(!D)return;const[S,b]=D;this.g.$acceptResponseProgress(y,k,b,S??void 0)})}else this.g.$acceptResponseProgress(y,k,a)}};let n;try{n=await o.provider.provideResponseWithProgress(s,t,u),n||(n={errorDetails:{message:(0,$.localize)(0,null)}})}catch(i){n={errorDetails:{message:(0,$.localize)(1,null,i.message),responseIsIncomplete:!0}},this.h.error(i)}try{if(r.saveState&&this.d.has(k)){const i=r.saveState();this.g.$acceptChatState(k,i)}}catch(i){this.h.warn(i)}const c={firstProgress:h??0,totalElapsed:m.elapsed()};return{errorDetails:n.errorDetails,timings:c}}async $provideSlashCommands(y,k,p){const u=this.b.get(y);if(!u)return;const o=this.d.get(k);return!o||!u.provider.provideSlashCommands?void 0:(await u.provider.provideSlashCommands(o,p))?.map(s=>({...s,kind:v.CompletionItemKind.from(s.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$5dc=I}),define(De[298],Ce([1,0,8,3,64,6,13,7]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class E{static{this.a=0}constructor(I,w,y){this.d=w,this.e=y,this.b=new Map,this.c=I.getProxy(L.$gK.MainThreadChatAgents)}registerAgent(I,w,y,k){const p=E.a++;return this.b.set(p,{extension:I,agent:y}),this.c.$registerAgent(p,w,k),(0,F.$Qc)(()=>{this.c.$unregisterAgent(p),this.b.delete(p)})}async $invokeAgent(I,w,y,k,p){const u=this.b.get(I);if(!u){this.e.warn(`[CHAT](${I}) CANNOT invoke agent because the agent is not registered`);return}let o=!1;function r(){if(o)throw new Error("Only valid while executing the command")}const s=new C.$ch;p.onCancellationRequested(()=>s.complete()),setTimeout(()=>s.complete(),10*1e3),this.d.allowListExtensionWhile(u.extension,s.p);const m=u.agent({role:$.ChatMessageRole.User,content:y},{history:k.history.map(A.ChatMessage.to)},new d.$6u(h=>{r(),this.c.$handleProgressChunk(w,{content:v(h.message)?h.message:h.message.value})}),p);try{return await(0,C.$Ig)(Promise.resolve(m).then(h=>{if(h&&"followUp"in h)return{followUp:h?.followUp?.map(n=>A.ChatFollowup.from(n))}}),p)}finally{o=!0,s.complete()}}}e.$cec=E;function v(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(De[299],Ce([1,0,8,21,41,4,17,64,6,13,7,270,26]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class y{static{this.a=0}constructor(u,o,r){this.h=o,this.i=r,this.b=new Map,this.g=new Map,this.d=u.getProxy(E.$gK.MainThreadChatAgents2)}createChatAgent(u,o,r){const s=y.a++,m=new k(u,o,this.d,s,r);return this.b.set(s,m),this.d.$registerAgent(s,o,{}),m.apiAgent}async $invokeAgent(u,o,r,s,m,h){const t=this.b.get(u);if(!t)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let n=!1;function c(){if(n)throw new Error("Only valid while executing the command")}const i=new C.$ch;h.onCancellationRequested(()=>i.complete()),setTimeout(()=>i.complete(),10*1e3),this.h.allowListExtensionWhile(t.extension.identifier,i.p);const a=s.command?await t.validateSlashCommand(s.command):void 0;try{const l=t.invoke({prompt:s.message,variables:v.ChatVariable.objectTo(s.variables),slashCommand:a},{history:m.history.map(v.ChatMessage.to)},new $.$6u(D=>{c();const S=v.ChatResponseProgress.from(D);this.d.$handleProgressChunk(r,S)}),h);return await(0,C.$Ig)(Promise.resolve(l).then(D=>{if(D)return this.g.set(o,D),{errorDetails:D.errorDetails};this.g.delete(o)}),h)}catch(l){return this.i.error(l,t.extension),{errorDetails:{message:(0,d.$Ai)(l)}}}finally{n=!0,i.complete()}}$releaseSession(u){this.g.delete(u)}async $provideSlashCommands(u,o){const r=this.b.get(u);return r?r.provideSlashCommand(o):[]}$provideFollowups(u,o,r){const s=this.b.get(u);if(!s)return Promise.resolve([]);const m=this.g.get(o);return m?s.provideFollowups(m,r):Promise.resolve([])}$acceptFeedback(u,o,r){const s=this.b.get(u);if(!s)return;const m=this.g.get(o);if(!m)return;let h;switch(r){case I.InteractiveSessionVoteDirection.Down:h=R.ChatAgentResultFeedbackKind.Unhelpful;break;case I.InteractiveSessionVoteDirection.Up:h=R.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze({result:m,kind:h}))}$acceptAction(u,o,r){const s=this.b.get(u);if(!s)return;const m=this.g.get(o);m&&r.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:r.action,result:m}))}}e.$dec=y;class k{constructor(u,o,r,s,m){this.extension=u,this.m=o,this.n=r,this.o=s,this.q=m,this.k=new L.$Nd,this.l=new L.$Nd}acceptFeedback(u){this.k.fire(u)}acceptAction(u){this.l.fire(u)}async validateSlashCommand(u){this.b||(await this.provideSlashCommand(F.CancellationToken.None),(0,A.$If)(this.b));const o=this.b.find(r=>r.name===u);if(!o)throw new Error(`Unknown slashCommand: ${u}`);return o}async provideSlashCommand(u){if(!this.a)return[];const o=await this.a.provideSlashCommands(u);return o?(this.b=o,o.map(r=>({name:r.name,description:r.description}))):[]}async provideFollowups(u,o){if(!this.d)return[];const r=await this.d.provideFollowups(u,o);return r?r.map(s=>v.ChatFollowup.from(s)):[]}get apiAgent(){let u=!1,o=!1;const r=()=>{u||o||(o=!0,queueMicrotask(()=>{this.n.$updateAgent(this.o,{description:this.g??"",fullName:this.h,icon:this.i,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j}),o=!1}))},s=this;return{get name(){return s.m},get description(){return s.g??""},set description(m){s.g=m,r()},get fullName(){return s.h??s.extension.displayName??s.extension.name},set fullName(m){s.h=m,r()},get iconPath(){return s.i},set iconPath(m){s.i=m,r()},get slashCommandProvider(){return s.a},set slashCommandProvider(m){s.a=m,r()},get followupProvider(){return s.d},set followupProvider(m){s.d=m,r()},get isDefault(){return(0,w.$eF)(s.extension,"defaultChatAgent"),s.j},set isDefault(m){(0,w.$eF)(s.extension,"defaultChatAgent"),s.j=m,r()},get onDidReceiveFeedback(){return s.k.event},onDidPerformAction:(0,w.$dF)(this.extension,"chatAgents2Additions")?this.l.event:void 0,dispose(){u=!0,s.a=void 0,s.d=void 0,s.k.dispose(),s.n.$unregisterAgent(s.o)}}}invoke(u,o,r,s){return this.q(u,o,r,s)}}}),define(De[300],Ce([1,0,21,3,6,13,64,25,8,4]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;class R{constructor(k,p){this.stream=new E.$gh,this.stream=p??new E.$gh;const u=this;this.apiObj={option:k,response:u.stream.asyncIterable}}}class I{constructor(k,p){this.a=new v.$Nd,this.b=new Map,this.c=new E.$gh,this.d=!1;const u=this;this.apiObject={result:k,response:u.c.asyncIterable,onDidStartResponseStream:u.a.event,cancel(){p.cancel()}},k.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.complete();else this.c.complete()})}handleFragment(k){if(this.d)return;let p=this.b.get(k.index);p||(this.b.size===0?p=new R(k.index,this.c):p=new R(k.index),this.b.set(k.index,p),this.a.fire(p.apiObj)),p.stream.emit(k.part)}}class w{static{this.a=1}constructor(k,p){this.d=p,this.c=new Map,this.e=new Map,this.f=new $.$8l,this.b=k.getProxy(d.$gK.MainThreadChatProvider)}registerProvider(k,p,u,o){const r=w.a++;return this.c.set(r,{extension:k,provider:u}),this.b.$registerProvider(r,p,{extension:k,displayName:o.name??k.value}),(0,F.$Qc)(()=>{this.b.$unregisterProvider(r),this.c.delete(r)})}async $provideChatResponse(k,p,u,o,r){const s=this.c.get(k);if(!s)return;const m=new A.$6u(async h=>{if(r.isCancellationRequested){this.d.warn(`[CHAT](${s.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(p,{index:h.index,part:h.part})},{async:!0});return s.provider.provideChatResponse(u.map(L.ChatMessage.to),o,m,r)}allowListExtensionWhile(k,p){this.f.set(k,p),p.finally(()=>this.f.delete(k))}async requestChatResponseProvider(k,p){if(!this.f.has(k))throw new Error("Extension is NOT allowed to make chat requests");const u=this;return{get isRevoked(){return!u.f.has(k)},makeRequest(o,r,s){if(!u.f.has(k))throw new Error("Access to chat has been revoked");const m=new C.$Xd(s),h=Math.random()*1e6|0,t=u.b.$fetchResponse(k,p,h,o.map(L.ChatMessage.from),r??{},m.token),n=new I(t,m);return u.e.set(h,{res:n}),t.finally(()=>{u.e.delete(h)}),n.apiObject}}}async $handleResponseFragment(k,p){const u=this.e.get(k);u&&u.res.handleFragment(p)}}e.$0dc=w}),define(De[301],Ce([1,0,3,6,9,13]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(F.$gK.MainThreadChatVariables)}async $resolveVariable(E,v,R){const I=this.b.get(E);if(I)try{const w=await I.resolver.resolve(I.data.name,{message:v},R);if(w)return w.map(L.ChatVariable.from)}catch(w){(0,d.$2)(w)}}registerVariableResolver(E,v,R,I){const w=A.a++;return this.b.set(w,{extension:E.identifier,data:{name:v,description:R},resolver:I}),this.c.$registerVariable(w,{name:v,description:R}),(0,C.$Qc)(()=>{this.b.delete(w),this.c.$unregisterVariable(w)})}}e.$_dc=A}),define(De[302],Ce([1,0,6]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class F{constructor(L){const A=L.getProxy(C.$gK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText($){return A.$writeText($)}})}}e.$hcc=F}),define(De[34],Ce([1,0,17,7,13,24,6,19,14,62,32,61,2,3,5,20,145,22,69,41,37,85,88]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=void 0;let n=class{#e;#t;#i;constructor(S,b,f){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$gK.MainThreadCommands),this.d=b,this.#i=f,this.#t=S.getProxy(A.$gK.MainThreadTelemetry),this.converter=new c(this,g=>{const P=this.c.get(g);return P?.result===a.Void?P:void 0},b),this.f=[{processArgument(g){return(0,v.$mh)(g)}},{processArgument(g){return(0,L.$9m)(g,function(P){if(R.$us.isIRange(P))return d.Range.to(P);if(I.$ts.isIPosition(P))return d.Position.to(P);if(R.$us.isIRange(P.range)&&w.URI.isUri(P.uri))return d.location.to(P);if(P instanceof o.$be)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const b=this.registerCommand(!1,S.id,async(...f)=>{const g=S.args.map((N,O)=>{if(!N.validate(f[O]))throw new Error(`Invalid argument '${N.name}' when running '${S.id}', received: ${typeof f[O]=="object"?JSON.stringify(f[O],null,"	"):f[O]} `);return N.convert(f[O])}),P=await this.executeCommand(S.internalId,...g);return S.result.convert(P,f,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new F.$iK(()=>{b.dispose(),this.c.delete(S.id)})}registerCommand(S,b,f,g,P,N){if(this.d.trace("ExtHostCommands#registerCommand",b),!b.trim().length)throw new Error("invalid id");if(this.b.has(b))throw new Error(`command '${b}' already exists`);return this.b.set(b,{callback:f,thisArg:g,metadata:P,extension:N}),S&&this.#e.$registerCommand(b),new F.$iK(()=>{this.b.delete(b)&&S&&this.#e.$unregisterCommand(b)})}executeCommand(S,...b){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,b,!0)}async g(S,b,f){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,b,!1);{let g=!1;const P=(0,L.$9m)(b,function(N){if(N instanceof F.$jK)return d.Position.from(N);if(N instanceof F.$kK)return d.Range.from(N);if(N instanceof F.$uK)return d.location.from(N);if(F.$FL.isNotebookRange(N))return d.NotebookRange.from(N);if(N instanceof ArrayBuffer)return g=!0,o.$be.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return g=!0,o.$be.wrap(N);if(N instanceof o.$be)return g=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(S,g?new r.$qv(P):P,f);return(0,v.$mh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(S,b,!1);throw N}}}async h(S,b,f){const g=this.b.get(S);if(!g)throw new Error("Unknown command");const{callback:P,thisArg:N,metadata:O}=g;if(O?.args)for(let j=0;j<O.args.length;j++)try{(0,C.$Pf)(b[j],O.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${O.args[j].name}' - ${O.args[j].description}`)}const M=m.$Jd.create();try{return await P.apply(N,b)}catch(j){if(S===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...b);U&&(S=U.command)}if(this.d.error(j,S,g.extension?.identifier),!f)throw j;if(g.extension?.identifier){const U=this.#i.onExtensionError(g.extension.identifier,j);this.d.trace("forwarded error to extension?",U,g.extension?.identifier)}throw new class extends Error{constructor(){super((0,s.$Ai)(j)),this.id=S,this.source=g.extension?.displayName??g.extension?.name}}}finally{this.j(g,S,M.elapsed())}}j(S,b,f){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new h.$ko(b),duration:f})}$executeContributedCommand(S,...b){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const f=this.b.get(S);return f?(b=b.map(g=>this.f.reduce((P,N)=>N.processArgument(P,f.extension?.identifier),g)),this.h(S,b,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(b=>(S&&(b=b.filter(f=>f[0]!=="_")),b))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[b,f]of this.b){const{metadata:g}=f;g&&(S[b]=g)}return Promise.resolve(S)}};e.$CM=n,e.$CM=n=He([Be(0,p.$hM),Be(1,E.$0i),Be(2,t.$BM)],n),e.$DM=(0,k.$Ph)("IExtHostCommands");class c{constructor(S,b,f){this.d=S,this.f=b,this.g=f,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,b){if(!S)return;const f={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return f;const g=this.f(S.command);if(g)f.id=g.internalId,f.arguments=g.args.map((P,N)=>P.convert(S.arguments&&S.arguments[N]));else if((0,$.$Lb)(S.arguments)){const P=`${S.command} /${++this.c}`;this.b.set(P,S),b.add((0,y.$Qc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),f.$ident=P,f.id=this.delegatingCommandId,f.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return f}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const b=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],b?b.command:"MISSING"),b?this.d.executeCommand(b.command,...b.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$EM=c;class i{static{this.Uri=new i("uri","Uri of a text document",S=>w.URI.isUri(S),S=>S)}static{this.Position=new i("position","A position in a text document",S=>F.$jK.isPosition(S),d.Position.from)}static{this.Range=new i("range","A range in a text document",S=>F.$kK.isRange(S),d.Range.from)}static{this.Selection=new i("selection","A selection in a text document",S=>F.$lK.isSelection(S),d.Selection.from)}static{this.Number=new i("number","",S=>typeof S=="number",S=>S)}static{this.String=new i("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=i.Arr(i.String)}static Arr(S){return new i(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,b=>Array.isArray(b)&&b.every(f=>S.validate(f)),b=>b.map(f=>S.convert(f)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",S=>S instanceof F.$EK,d.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",S=>S instanceof F.$YL,d.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",S=>S instanceof u.$uM,d.TestItem.from)}constructor(S,b,f,g){this.name=S,this.description=b,this.validate=f,this.convert=g}optional(){return new i(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,b){return new i(S??this.name,b??this.description,this.validate,this.convert)}}e.$FM=i;class a{static{this.Void=new a("no result",S=>S)}constructor(S,b){this.description=S,this.convert=b}}e.$GM=a;class l{constructor(S,b,f,g,P){this.id=S,this.internalId=b,this.description=f,this.args=g,this.result=P}}e.$HM=l}),define(De[303],Ce([1,0,19,18,2,83,129,42,134,34,13,7]),function($e,e,C,F,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;const w=[new v.$HM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.$FM.Uri,v.$FM.Position],new v.$GM("A promise that resolves to an array of DocumentHighlight-instances.",k(R.DocumentHighlight.to))),new v.$HM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.$FM.Uri],new v.$GM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,o)=>{if((0,C.$Kb)(u))return;class r extends I.$zK{static to(m){const h=new r(m.name,R.SymbolKind.to(m.kind),m.containerName||"",new I.$uK(o[0],R.Range.to(m.range)));return h.detail=m.detail,h.range=h.location.range,h.selectionRange=R.Range.to(m.selectionRange),h.children=m.children?m.children.map(r.to):[],h}}return u.map(r.to)})),new v.$HM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.$FM.Uri,new v.$FM("options","Formatting options",u=>!0,u=>u)],new v.$GM("A promise that resolves to an array of TextEdits.",k(R.TextEdit.to))),new v.$HM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.$FM.Uri,v.$FM.Range,new v.$FM("options","Formatting options",u=>!0,u=>u)],new v.$GM("A promise that resolves to an array of TextEdits.",k(R.TextEdit.to))),new v.$HM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.$FM.Uri,v.$FM.Position,new v.$FM("ch","Trigger character",u=>typeof u=="string",u=>u),new v.$FM("options","Formatting options",u=>!0,u=>u)],new v.$GM("A promise that resolves to an array of TextEdits.",k(R.TextEdit.to))),new v.$HM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.$FM.Uri,v.$FM.Position],new v.$GM("A promise that resolves to an array of Location or LocationLink instances.",p)),new v.$HM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.$FM.Uri,v.$FM.Position],new v.$GM("A promise that resolves to an array of Location or LocationLink instances.",p)),new v.$HM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.$FM.Uri,v.$FM.Position],new v.$GM("A promise that resolves to an array of Location or LocationLink instances.",p)),new v.$HM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.$FM.Uri,v.$FM.Position],new v.$GM("A promise that resolves to an array of Location or LocationLink instances.",p)),new v.$HM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.$FM.Uri,v.$FM.Position],new v.$GM("A promise that resolves to an array of Location-instances.",k(R.location.to))),new v.$HM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.$FM.Uri,v.$FM.Position],new v.$GM("A promise that resolves to an array of Hover-instances.",k(R.Hover.to))),new v.$HM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.$FM.Uri,new v.$FM("position","A position in a text document",u=>Array.isArray(u)&&u.every(o=>I.$jK.isPosition(o)),u=>u.map(R.Position.from))],new v.$GM("A promise that resolves to an array of ranges.",u=>u.map(o=>{let r;for(const s of o.reverse())r=new I.$DK(R.Range.to(s),r);return r}))),new v.$HM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.$FM.String.with("query","Search string")],new v.$GM("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(R.WorkspaceSymbol.to))),new v.$HM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.$FM.Uri,v.$FM.Position],new v.$GM("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(R.CallHierarchyItem.to))),new v.$HM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.$FM.CallHierarchyItem],new v.$GM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(R.CallHierarchyIncomingCall.to))),new v.$HM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.$FM.CallHierarchyItem],new v.$GM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(R.CallHierarchyOutgoingCall.to))),new v.$HM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.$FM.Uri,v.$FM.Position],new v.$GM("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:R.Range.to(u.range),placeholder:u.text}})),new v.$HM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.$FM.Uri,v.$FM.Position,v.$FM.String.with("newName","The new symbol name")],new v.$GM("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return R.WorkspaceEdit.to(u)}})),new v.$HM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.$FM.Uri,v.$FM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.$GM("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(R.DocumentLink.to))),new v.$HM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.$FM.Uri],new v.$GM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new I.$xL(u.tokenTypes,u.tokenModifiers)})),new v.$HM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.$FM.Uri],new v.$GM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const o=(0,A.$X0)(u);if(o.type==="full")return new I.$zL(o.data,void 0)})),new v.$HM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.$FM.Uri,v.$FM.Range.optional()],new v.$GM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new I.$xL(u.tokenTypes,u.tokenModifiers)})),new v.$HM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.$FM.Uri,v.$FM.Range],new v.$GM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const o=(0,A.$X0)(u);if(o.type==="full")return new I.$zL(o.data,void 0)})),new v.$HM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.$FM.Uri,v.$FM.Position,v.$FM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.$FM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.$GM("A promise that resolves to a CompletionList-instance.",(u,o,r)=>{if(!u)return new I.$PK([]);const s=u.suggestions.map(m=>R.CompletionItem.to(m,r));return new I.$PK(s,u.incomplete)})),new v.$HM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.$FM.Uri,v.$FM.Position,v.$FM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.$GM("A promise that resolves to SignatureHelp.",u=>{if(u)return R.SignatureHelp.to(u)})),new v.$HM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.$FM.Uri,v.$FM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.$GM("A promise that resolves to an array of CodeLens-instances.",(u,o,r)=>k(s=>new I.$HK(R.Range.to(s.range),s.command&&r.fromInternal(s.command)))(u))),new v.$HM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.$FM.Uri,new v.$FM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>I.$kK.isRange(u),u=>I.$lK.isSelection(u)?R.Selection.from(u):R.Range.from(u)),v.$FM.String.with("kind","Code action kind to return code actions for").optional(),v.$FM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.$GM("A promise that resolves to an array of Command-instances.",(u,o,r)=>k(s=>{if(s._isSynthetic){if(!s.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(s.command)}else{const m=new I.$BK(s.title,s.kind?new I.$CK(s.kind):void 0);return s.edit&&(m.edit=R.WorkspaceEdit.to(s.edit)),s.command&&(m.command=r.fromInternal(s.command)),m.isPreferred=s.isPreferred,m}})(u))),new v.$HM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.$FM.Uri],new v.$GM("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(o=>new I.$VK(R.Range.to(o.range),R.Color.to(o.color))):[])),new v.$HM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.$FM("color","The color to show and insert",u=>u instanceof I.$UK,R.Color.from),new v.$FM("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:R.Range.from(u.range)}))],new v.$GM("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(R.ColorPresentation.to):[])),new v.$HM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.$FM.Uri,v.$FM.Range],new v.$GM("A promise that resolves to an array of Inlay objects",(u,o,r)=>u.map(R.InlayHint.to.bind(void 0,r)))),new v.$HM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.$FM.Uri],new v.$GM("A promise that resolves to an array of FoldingRange objects",(u,o)=>{if(u)return u.map(R.FoldingRange.to)})),new v.$HM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.$GM("A promise that resolves to an array of NotebookContentProvider static info objects.",k(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(o=>R.NotebookExclusiveDocumentPattern.to(o))})))),new v.$HM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.$FM.Uri,v.$FM.Range,new v.$FM("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof I.$kK,u=>R.InlineValueContext.from(u))],new v.$GM("A promise that resolves to an array of InlineValue objects",u=>u.map(R.InlineValue.to))),new v.$HM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.$FM("uriOrString","Uri-instance or string (only http/https)",u=>d.URI.isUri(u)||typeof u=="string"&&(0,E.$eU)(u,F.Schemas.http,F.Schemas.https),u=>u),new v.$FM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[R.ViewColumn.from(u),void 0]:[R.ViewColumn.from(u.viewColumn),R.TextEditorOpenOptions.from(u)])).optional(),v.$FM.String.with("label","").optional()],v.$GM.Void),new v.$HM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.$FM.Uri.with("resource","Resource to open"),v.$FM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new v.$FM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[R.ViewColumn.from(u),void 0]:[R.ViewColumn.from(u.viewColumn),R.TextEditorOpenOptions.from(u)])).optional()],v.$GM.Void),new v.$HM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.$FM.Uri.with("left","Left-hand side resource of the diff editor"),v.$FM.Uri.with("right","Right-hand side resource of the diff editor"),v.$FM.String.with("title","Human readable title for the diff editor").optional(),new v.$FM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[R.ViewColumn.from(u.viewColumn),R.TextEditorOpenOptions.from(u)]).optional()],v.$GM.Void),new v.$HM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.$FM.Uri,v.$FM.Position],new v.$GM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(R.TypeHierarchyItem.to))),new v.$HM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.$FM.TypeHierarchyItem],new v.$GM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(R.TypeHierarchyItem.to))),new v.$HM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.$FM.TypeHierarchyItem],new v.$GM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(R.TypeHierarchyItem.to))),new v.$HM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.$FM.TestItem],v.$GM.Void),new v.$HM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.$FM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.$GM.Void),new v.$HM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.$FM.String.with("name","The context key name"),new v.$FM("value","The context key value",()=>!0,u=>u)],v.$GM.Void),new v.$HM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[v.$FM.Uri,v.$FM.StringArray,new v.$FM("MappedEditsContext","Mapped Edits Context",u=>R.MappedEditsContext.is(u),u=>R.MappedEditsContext.from(u))],new v.$GM("A promise that resolves to a workspace edit or null",u=>u?R.WorkspaceEdit.to(u):null))];class y{static register(o){w.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",$.$Oi)}}e.$gcc=y;function k(u){return o=>{if(Array.isArray(o))return o.map(u)}}function p(u){if(!Array.isArray(u))return;const o=[];for(const r of u)L.$ft(r)?o.push(R.DefinitionLink.to(r)):o.push(R.location.to(r));return o}}),define(De[304],Ce([1,0,8,57,4,3,2,83,25,13,7,6,26]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;function y(k,p,u){const o=k.getProxy(I.$gK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$8l,p.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const D=this.b.get(l.handle);return D?D.value:l}else if(l&&l.$mid===7){const D=this.b.get(l.commentControlHandle);if(!D)return l;const S=D.getCommentThread(l.commentThreadHandle);return S?S.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const S=D.getCommentThread(l.thread.commentThreadHandle);return S?l.$mid===8?S.value:{thread:S.value,text:l.text}:l}else if(l&&l.$mid===10){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const S=D.getCommentThread(l.thread.commentThreadHandle);if(!S)return l;const b=l.commentUniqueId,f=S.getCommentByUniqueId(b);return f||l}else if(l&&l.$mid===11){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const S=D.getCommentThread(l.thread.commentThreadHandle);if(!S)return l;const b=l.text,f=l.commentUniqueId,g=S.getCommentByUniqueId(f);return g?(typeof g.body=="string"?g.body=b:g.body=new R.$IK(b),g):l}return l}})}createCommentController(l,D,S){const b=r.a++,f=new m(l,b,D,S);this.b.set(f.handle,f);const g=this.c.get(l.identifier)||[];return g.push(f),this.c.set(l.identifier,g),f.value}async $createCommentThreadTemplate(l,D,S){const b=this.b.get(l);b&&b.$createCommentThreadTemplate(D,S)}async $updateCommentThreadTemplate(l,D,S){const b=this.b.get(l);b&&b.$updateCommentThreadTemplate(D,S)}$deleteCommentThread(l,D){this.b.get(l)?.$deleteCommentThread(D)}$provideCommentingRanges(l,D,S){const b=this.b.get(l);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const f=u.getDocument(A.URI.revive(D));return(0,C.$Mg)(async()=>{const g=await b.commentingRangeProvider.provideCommentingRanges(f,S);let P;return Array.isArray(g)?P={ranges:g,fileComments:!1}:g?P={ranges:g.ranges||[],fileComments:g.fileComments||!1}:P=g??void 0,P}).then(g=>{let P;return g&&(P={ranges:g.ranges.map(N=>v.Range.from(N)),fileComments:g.fileComments}),P})}$toggleReaction(l,D,S,b,f){const g=this.b.get(l);return!g||!g.reactionHandler?Promise.resolve(void 0):(0,C.$Mg)(()=>{const P=g.getCommentThread(D);if(P){const N=P.getCommentByUniqueId(b.uniqueIdInThread);if(g!==void 0&&N&&g.reactionHandler)return g.reactionHandler(N,n(f))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,D,S,b,f,g,P,N){this.m=D,this.n=S,this.o=b,this.p=f,this.q=g,this.extensionDescription=P,this.r=N,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new d.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Tc,this.l.value=new L.$Rc,this.n===void 0&&(this.n=`${l}.${this.handle}`),o.$createCommentThread(D,this.handle,this.n,this.o,v.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=g,this.i.push({dispose:()=>{o.$deleteCommentThread(D,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(M){O.range=M},get comments(){return O.comments},set comments(M){O.comments=M},get collapsibleState(){return O.collapsibleState},set collapsibleState(M){O.collapsibleState=M},get canReply(){return O.canReply},set canReply(M){O.canReply=M},get contextValue(){return O.contextValue},set contextValue(M){O.contextValue=M},get label(){return O.label},set label(M){O.label=M},get state(){return O.state},set state(M){O.state=M},dispose:()=>{O.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Rc);const l=S=>Object.prototype.hasOwnProperty.call(this.b,S),D={};l("range")&&(D.range=v.Range.from(this.p)),l("label")&&(D.label=this.label),l("contextValue")&&(D.contextValue=this.contextValue??null),l("comments")&&(D.comments=this.q.map(S=>h(this,S,this.k,this.extensionDescription))),l("collapsibleState")&&(D.collapseState=c(this.g)),l("canReply")&&(D.canReply=this.canReply),l("state")&&(D.state=i(this.h)),l("isTemplate")&&(D.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(l){for(const D of this.k){const S=D[0],b=D[1];if(l===b)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}He([(0,F.$ih)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class m{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,D,S,b){this.f=l,this.g=D,this.h=S,this.i=b,this.a=new Map,o.$registerCommentController(this.handle,S,b,this.f.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(g){f.options=g},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(g){f.commentingRangeProvider=g},get reactionHandler(){return f.reactionHandler},set reactionHandler(g){f.reactionHandler=g},createCommentThread(g,P,N){return f.createCommentThread(g,P,N).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(l,D,S){D===void 0&&(0,w.$eF)(this.f,"fileComments");const b=new s(this.id,this.handle,void 0,l,D,S,this.f,!1);return this.a.set(b.handle,b),b}$createCommentThreadTemplate(l,D){const S=new s(this.id,this.handle,void 0,A.URI.revive(l),v.Range.to(D),[],this.f,!0);return S.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(l,D){const S=this.a.get(l);S&&(S.range=v.Range.to(D))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function h(a,l,D,S){let b=D.get(l);return b||(b=++a.commentHandle,D.set(l,b)),l.state!==void 0&&(0,w.$eF)(S,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:b,body:typeof l.body=="string"?l.body:v.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(f=>t(f)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?v.$gM(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function n(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?A.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function c(a){if(a!==void 0)switch(a){case R.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function i(a){if(a!==void 0)switch(a){case R.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new r}e.$icc=y}),define(De[305],Ce([1,0,24,6,27,20]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;let A=class{constructor(R,I){this.a=R.getProxy(F.$gK.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,I){const w=this,y=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){w.e(R,I,y,arguments)}})}e(R,I,w,y){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(y,this.b)}),this.c&&this.f(R,w,y)}};e.$gec=A,e.$gec=A=He([Be(0,L.$hM),Be(1,d.$xM)],A);const $=1e5;function E(v,R){const I=[];if(v.length)for(let w=0;w<v.length;w++){let y=v[w];if(typeof y>"u")y="undefined";else if(y instanceof Error){const k=y;k.stack?y=k.stack:y=k.toString()}I.push(y)}if(R){const w=new Error().stack;w&&I.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,C.$_m)(I);return w.length>$?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(De[149],Ce([1,0,2,6,7,5,20,14,19,15,16,26]),function($e,e,C,F,d,L,A,$,E,v,R,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=e.$jdc=void 0;let y=class{static{w=this}static{this.c=0}static{this.d=250}constructor(p,u){this.h=u,this.f=new Map,this.g=p.getProxy(F.$gK.MainThreadDecorations)}registerFileDecorationProvider(p,u){const o=w.c++;this.f.set(o,{provider:p,extensionDescription:u}),this.g.$registerDecorationProvider(o,u.identifier.value);const r=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(s=>{if(!s){this.g.$onDidChange(o,null);return}const m=(0,E.$3b)(s);if(m.length<=w.d){this.g.$onDidChange(o,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,m.length);const h=m.map(c=>({uri:c,rank:(0,v.$Ge)(c.path,"/")})),t=(0,E.$zb)(h,(c,i)=>c.rank-i.rank||(0,v.$Ue)(c.uri.path,i.uri.path)),n=[];e:for(const c of t){let i;for(const a of c){const l=(0,R.$mc)(a.uri.path);if(i!==l&&(i=l,n.push(a.uri)>=w.d))break e}}this.g.$onDidChange(o,n)});return new d.$iK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(p,u,o){if(!this.f.has(p))return Object.create(null);const r=Object.create(null),{provider:s,extensionDescription:m}=this.f.get(p);return await Promise.all(u.map(async h=>{try{const{uri:t,id:n}=h,c=await Promise.resolve(s.provideFileDecoration(C.URI.revive(t),o));if(!c)return;try{d.$DL.validate(c),c.badge&&typeof c.badge!="string"&&(0,I.$eF)(m,"codiconDecoration"),r[n]=[c.propagate,c.tooltip,c.badge,c.color]}catch(i){this.h.warn(`INVALID decoration from extension '${m.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),r}};e.$jdc=y,e.$jdc=y=w=He([Be(0,A.$hM),Be(1,$.$0i)],y),e.$kdc=(0,L.$Ph)("IExtHostDecorations")}),define(De[306],Ce([1,0,203,133,2,6,7,13,4,14,28,55]),function($e,e,C,F,d,L,A,$,E,v,R,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0;class y{#e;#t;#i;constructor(u,o,r,s,m,h,t,n){this.d=u,this.e=o,this.f=r,this.g=s,this.h=m,this.c=!1,this.f=Math.max(s,r),this.#i=new R.$Ac(c=>h.getComparisonKey(c)),this.#e=t,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(u,o){if(!u){this.clear();return}this.j();let r=[];if(d.URI.isUri(u)){if(!o){this.delete(u);return}this.#i.set(u,o.slice()),r=[u]}else if(Array.isArray(u)){r=[];let h;u=[...u].sort(y.k);for(const t of u){const[n,c]=t;if((!h||n.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=n,r.push(n),this.#i.set(n,[])),c)this.#i.get(n)?.push(...c);else{const i=this.#i.get(n);i&&(i.length=0)}}}if(this.#t.fire(r),!this.#e)return;const s=[];let m=0;for(const h of r){let t=[];const n=this.#i.get(h);if(n)if(n.length>this.g){t=[];const c=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const a of n)if(a.severity===c[i]&&t.push({...$.Diagnostic.from(a),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,C.localize)(0,null,n.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(c=>({...$.Diagnostic.from(c),modelVersionId:this.h(h)}));if(s.push([h,t]),m+=t.length,m>this.f)break}this.#e.$changeMany(this.e,s)}delete(u){this.j(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this.e,[[u,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(u,o){this.j();for(const[r,s]of this)u.call(o,r,s,this)}*[Symbol.iterator](){this.j();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this.j();const o=this.#i.get(u);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(u){return this.j(),Array.isArray(this.#i.get(u))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(u,o){return u[0].toString()<o[0].toString()?-1:u[0].toString()>o[0].toString()?1:0}}e.$acc=y;let k=class{static{w=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*w.d}static _mapper(u){const o=new R.$Ac;for(const r of u)o.set(r,r);return{uris:Object.freeze(Array.from(o.values()))}}constructor(u,o,r,s){this.j=o,this.k=r,this.l=s,this.g=new Map,this.h=new E.$Rd({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,w._mapper),this.f=u.getProxy(L.$gK.MainThreadDiagnostics)}createDiagnosticCollection(u,o){const{g:r,f:s,h:m,j:h,k:t,l:n}=this,c=new class{$changeMany(l,D){s.$changeMany(l,D),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,l,D.length===0?"CLEARING":D)}$clear(l){s.$clear(l),h.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,l)}dispose(){s.dispose()}};let i;if(!o)o="_generated_diagnostic_collection_name_#"+w.c++,i=o;else if(!r.has(o))i=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do i=o+w.c++;while(r.has(i))}return new class extends y{constructor(){super(o,i,w.e,w.d,l=>n.getDocument(l)?.version,t.extUri,c,m),r.set(i,this)}dispose(){super.dispose(),r.delete(i)}}}getDiagnostics(u){if(u)return this.m(u);{const o=new Map,r=[];for(const s of this.g.values())s.forEach((m,h)=>{let t=o.get(m.toString());typeof t>"u"&&(t=r.length,o.set(m.toString(),t),r.push([m,[]])),r[t][1]=r[t][1].concat(...h)});return r}}m(u){let o=[];for(const r of this.g.values())r.has(u)&&(o=o.concat(r.get(u)));return o}$acceptMarkersChange(u){if(!this.n){const o="_generated_mirror",r=new y(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,s=>{},this.k.extUri,void 0,this.h);this.g.set(o,r),this.n=r}for(const[o,r]of u)this.n.set(d.URI.revive(o),r.map($.Diagnostic.to))}};e.$bcc=k,e.$bcc=k=w=He([Be(1,v.$0i),Be(2,I.$_bc)],k)}),define(De[307],Ce([1,0,2,6,26]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class L{constructor($){this.a=$.getProxy(F.$gK.MainThreadDialogs)}showOpenDialog($,E){return E?.allowUIResources&&(0,d.$eF)($,"showLocal"),this.a.$showOpenDialog(E).then(v=>v?v.map(R=>C.URI.revive(R)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(E=>E?C.URI.revive(E):void 0)}}e.$qcc=L}),define(De[308],Ce([1,0,9,2,7,6,18,21,15]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class v{static{this.a=0}constructor(I,w,y){this.d=w,this.e=y,this.b=new Map,this.c=I.getProxy(L.$gK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,w){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const y=v.a++;this.b.set(y,w),this.c.$registerTextContentProvider(y,I);let k;return typeof w.onDidChange=="function"&&(k=w.onDidChange(p=>{if(p.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this.d.getDocument(p)&&this.$provideTextDocumentContent(y,p).then(u=>{if(!u&&typeof u!="string")return;const o=this.d.getDocument(p);if(!o)return;const r=(0,E.$Pe)(u);if(!o.equalLines(r))return this.c.$onVirtualDocumentChange(p,u)},C.$1)})),new d.$iK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(I,w){const y=this.b.get(I);return y?Promise.resolve(y.provideTextDocumentContent(F.URI.revive(w),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.$rcc=v}),define(De[309],Ce([1,0,4,3,2,6,141,13,17,24,7,9]),function($e,e,C,F,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;class w{constructor(k,p){this.a=new C.$Nd({onListenerError:I.$2}),this.b=new C.$Nd({onListenerError:I.$2}),this.c=new C.$Nd({onListenerError:I.$2}),this.d=new C.$Nd({onListenerError:I.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Rc,this.h=new Map,this.f=k.getProxy(L.$gK.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(u=>{for(const o of u)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const o of u)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const p=this.g.getDocument(k);if(p)return p}getDocument(k){const p=this.getDocumentData(k);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return p.document}ensureDocumentData(k){const p=this.g.getDocument(k);if(p)return Promise.resolve(p);let u=this.h.get(k.toString());return u||(u=this.f.$tryOpenDocument(k).then(o=>{this.h.delete(k.toString());const r=d.URI.revive(o);return(0,E.$Jf)(this.g.getDocument(r))},o=>(this.h.delete(k.toString()),Promise.reject(o))),this.h.set(k.toString(),u)),u}createDocumentData(k){return this.f.$tryCreateDocument(k).then(p=>d.URI.revive(p))}$acceptModelLanguageChanged(k,p){const u=d.URI.revive(k),o=this.g.getDocument(u);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(p),this.a.fire(o.document)}$acceptModelSaved(k){const p=d.URI.revive(k),u=this.g.getDocument(p);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(k,p){const u=d.URI.revive(k),o=this.g.getDocument(u);if(!o)throw new Error("unknown document");o._acceptIsDirty(p),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,p,u){const o=d.URI.revive(k),r=this.g.getDocument(o);if(!r)throw new Error("unknown document");r._acceptIsDirty(u),r.onEvents(p);let s;p.isUndoing?s=R.TextDocumentChangeReason.Undo:p.isRedoing&&(s=R.TextDocumentChangeReason.Redo),this.c.fire((0,v.$8m)({document:r.document,contentChanges:p.changes.map(m=>({range:$.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:s}))}setWordDefinitionFor(k,p){(0,A.$jM)(k,p)}}e.$0bc=w}),define(De[70],Ce([1,0,58,4,3,2,5,6,141,20,146,13,14,28,18,51,47]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0;class o{constructor(m){this.value=m,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(m,h){this.h=m,this.i=h,this.a=null,this.b=new Map,this.c=new y.$Ac,this.d=new F.$Nd,this.e=new F.$Nd,this.f=new F.$Nd,this.g=new F.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const h=[],t=[],n=[];if(m.removedDocuments)for(const c of m.removedDocuments){const i=L.URI.revive(c),a=this.c.get(i);a?.unref()&&(this.c.delete(i),h.push(a.value))}if(m.addedDocuments)for(const c of m.addedDocuments){const i=L.URI.revive(c.uri);let a=this.c.get(i);if(a&&i.scheme!==k.Schemas.vscodeNotebookCell&&i.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);a||(a=new o(new E.$kM(this.h.getProxy($.$gK.MainThreadDocuments),i,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(i,a),t.push(a.value)),a.ref()}if(m.removedEditors)for(const c of m.removedEditors){const i=this.b.get(c);this.b.delete(c),i&&n.push(i)}if(m.addedEditors)for(const c of m.addedEditors){const i=L.URI.revive(c.documentUri);C.ok(this.c.has(i),`document '${i}' does not exist`),C.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const a=this.c.get(i).value,l=new R.$qM(c.id,this.h.getProxy($.$gK.MainThreadTextEditors),this.i,new u.$V(()=>a.document),c.selections.map(I.Selection.to),c.options,c.visibleRanges.map(D=>I.Range.to(D)),typeof c.editorPosition=="number"?I.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,l)}m.newActiveEditor!==void 0&&(C.ok(m.newActiveEditor===null||this.b.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this.a=m.newActiveEditor),(0,d.$Nc)(h),(0,d.$Nc)(n),m.removedDocuments&&this.e.fire(h),m.addedDocuments&&this.d.fire(t),(m.removedEditors||m.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),m.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(m){return this.c.get(m)?.value}allDocuments(){return p.Iterable.map(this.c.values(),m=>m.value)}getEditor(m){return this.b.get(m)}activeEditor(m){if(!this.a)return;const h=this.b.get(this.a);return m?h:h?.value}allEditors(){return[...this.b.values()]}};e.$rM=r,e.$rM=r=He([Be(0,v.$hM),Be(1,w.$0i)],r),e.$sM=(0,A.$Ph)("IExtHostDocumentsAndEditors")}),define(De[71],Ce([1,0,13,6,2,4,5,7,20,17,74]),function($e,e,C,F,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=void 0,e.$odc=(0,A.$Ph)("IExtHostEditorTabs");class I{constructor(u,o,r){this.e=r,this.d=o,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,o={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new $.$ZL(d.URI.revive(this.b.input.uri));case 2:return new $.$1L(d.URI.revive(this.b.input.original),d.URI.revive(this.b.input.modified));case 3:return new $.$2L(d.URI.revive(this.b.input.base),d.URI.revive(this.b.input.input1),d.URI.revive(this.b.input.input2),d.URI.revive(this.b.input.result));case 6:return new $.$3L(d.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new $.$4L(this.b.input.viewType);case 4:return new $.$5L(d.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new $.$6L(d.URI.revive(this.b.input.original),d.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new $.$7L;case 9:return new $.$8L(d.URI.revive(this.b.input.uri),d.URI.revive(this.b.input.inputBoxUri));default:return}}}class w{constructor(u,o){this.c=[],this.d="",this.b=u,this.e=o;for(const r of u.tabs)r.isActive&&(this.d=r.id),this.c.push(new I(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,o={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return C.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(r=>r.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(r=>r.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===0){const r=new I(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,r),u.tabDto.isActive&&(this.d=r.tabId),r}else if(u.kind===1){const r=this.c.splice(u.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(u.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,r),r}const o=this.c.find(r=>r.tabId===u.tabDto.id);if(!o)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(u.tabDto),o}activeTabId(){return this.d}}let y=class{constructor(u){this.b=new L.$Nd,this.c=new L.$Nd,this.e=[],this.a=u.getProxy(F.$gK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,o={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(r=>r.apiObject))},get activeTabGroup(){const r=u.d;return(0,v.$Jf)(u.e.find(m=>m.groupId===r)?.apiObject)},close:async(r,s)=>{const m=Array.isArray(r)?r:[r];return m.length?k(m[0])?this.j(m,s):this.i(m,s):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(u){const o=new Set(this.e.map(c=>c.groupId)),r=new Set(u.map(c=>c.groupId)),s=(0,R.$K)(o,r),m=this.e.filter(c=>s.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=u.map(c=>{const i=new w(c,()=>this.d);return s.added.includes(i.groupId)?h.push(i.apiObject):t.push(i.apiObject),i});const n=(0,v.$Jf)(u.find(c=>c.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:h,closed:m,changed:t}))}$acceptTabGroupUpdate(u){const o=this.e.find(r=>r.groupId===u.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const o=this.e.find(s=>s.groupId===u.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const r=o.acceptTabOperation(u);switch(u.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(u){for(const o of this.e)for(const r of o.tabs)if(r.apiObject===u)return r}h(u){return this.e.find(o=>o.apiObject===u)}async i(u,o){const r=[];for(const s of u){const m=this.g(s);if(!m)throw new Error("Tab close: Invalid tab not found!");r.push(m.tabId)}return this.a.$closeTab(r,o)}async j(u,o){const r=[];for(const s of u){const m=this.h(s);if(!m)throw new Error("Group close: Invalid group not found!");r.push(m.groupId)}return this.a.$closeGroup(r,o)}};e.$pdc=y,e.$pdc=y=He([Be(0,E.$hM)],y);function k(p){return p.tabs!==void 0}}),define(De[310],Ce([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$gK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,$,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const v=this.a.get(A);if(!v)throw new Error("Embedding vector provider not found");const R=await v.provideEmbeddingVector($,E);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,$,E){const v=this.b;return this.b++,this.a.set(v,E),this.c.$registerAiEmbeddingVectorProvider($,v),new F.$iK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(v),this.a.delete(v)})}}e.$bec=d}),define(De[311],Ce([1,0,2,6,3,7,13,169,15,22,26,80]),function($e,e,C,F,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class w{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const u=this.a.indexOf(p);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),u=[];let o,r,s=14,m=14;for(const h of p){let t=o?(0,E.$4e)(o,h):0;for(t===0?r=1:r=m;t<h.length;t++)t+1===h.length?(s=m,m=9):m+=1,u.push([r,h.toUpperCase().charCodeAt(t),m]),u.push([r,h.toLowerCase().charCodeAt(t),m]),r=m;o=h,m=s}u.push([9,58,10]),u.push([10,47,12]),this.b=new $.$ZY(u)}}provideDocumentLinks(p){this.c();const u=[],o=$.$1Y.computeLinks({getLineContent(r){return p.lineAt(r-1).text},getLineCount(){return p.lineCount}},this.b);for(const r of o){const s=A.DocumentLink.to(r);s.target&&u.push(s)}return u}}class y{constructor(p,u){this.i=u,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(F.$gK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,u,o,r={}){if(y.j(o),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const s=this.h++;this.b.add(u),this.d.add(u),this.c.set(s,o);let m=2;r.isCaseSensitive&&(m+=1024),r.isReadonly&&(m+=2048),typeof o.copy=="function"&&(m+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,R.$eF)(p,"fsChunks"),m+=4);let h;r.isReadonly&&(0,I.$5j)(r.isReadonly)&&((0,R.$eF)(p,"readonlyMessage"),h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(s,u,m,h).catch(n=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${u}`),console.error(n)});const t=o.onDidChangeFile(n=>{const c=[];for(const i of n){const{uri:a,type:l}=i;if(a.scheme!==u)continue;let D;switch(l){case L.FileChangeType.Changed:D=0;break;case L.FileChangeType.Created:D=1;break;case L.FileChangeType.Deleted:D=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:a,type:D})}this.a.$onFileSystemChange(s,c)});return(0,d.$Qc)(()=>{t.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(s),this.a.$unregisterProvider(s)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:u,ctime:o,mtime:r,size:s,permissions:m}=p;return{type:u,ctime:o,mtime:r,size:s,permissions:m}}$stat(p,u){return Promise.resolve(this.l(p).stat(C.URI.revive(u))).then(o=>y.k(o))}$readdir(p,u){return Promise.resolve(this.l(p).readDirectory(C.URI.revive(u)))}$readFile(p,u){return Promise.resolve(this.l(p).readFile(C.URI.revive(u))).then(o=>v.$be.wrap(o))}$writeFile(p,u,o,r){return Promise.resolve(this.l(p).writeFile(C.URI.revive(u),o.buffer,r))}$delete(p,u,o){return Promise.resolve(this.l(p).delete(C.URI.revive(u),o))}$rename(p,u,o,r){return Promise.resolve(this.l(p).rename(C.URI.revive(u),C.URI.revive(o),r))}$copy(p,u,o,r){const s=this.l(p);if(!s.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(s.copy(C.URI.revive(u),C.URI.revive(o),r))}$mkdir(p,u){return Promise.resolve(this.l(p).createDirectory(C.URI.revive(u)))}$watch(p,u,o,r){const s=this.l(p).watch(C.URI.revive(o),r);this.f.set(u,s)}$unwatch(p,u){const o=this.f.get(u);o&&(o.dispose(),this.f.delete(u))}$open(p,u,o){const r=this.l(p);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(C.URI.revive(u),o))}$close(p,u){const o=this.l(p);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(u))}$read(p,u,o,r){const s=this.l(p);if(!s.read)throw new Error('FileSystemProvider does not implement "read"');const m=v.$be.alloc(r);return Promise.resolve(s.read(u,o,m.buffer,0,r)).then(h=>m.slice(0,h))}$write(p,u,o,r){const s=this.l(p);if(!s.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(s.write(u,o,r.buffer,0,r.byteLength))}l(p){const u=this.c.get(p);if(!u){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return u}}e.$Xcc=y}),define(De[72],Ce([1,0,6,30,7,22,5,20,55,3,8,23,18]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=e.$Dcc=void 0;let k=y=class{constructor(u,o){this.b=new Map,this.c=new R.$3g,this.a=u.getProxy(C.$gK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(s){try{let m;const h=r.b.get(s.scheme);return h?(await r.a.$ensureActivation(s.scheme),m=await h.impl.stat(s)):m=await r.a.$stat(s),{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===F.FilePermission.Readonly?1:void 0}}catch(m){y.e(m)}},async readDirectory(s){try{const m=r.b.get(s.scheme);return m?(await r.a.$ensureActivation(s.scheme),(await m.impl.readDirectory(s)).slice()):await r.a.$readdir(s)}catch(m){return y.e(m)}},async createDirectory(s){try{const m=r.b.get(s.scheme);return m&&!m.isReadonly?(await r.a.$ensureActivation(s.scheme),await r.d(m.impl,m.extUri,s)):await r.a.$mkdir(s)}catch(m){return y.e(m)}},async readFile(s){try{const m=r.b.get(s.scheme);return m?(await r.a.$ensureActivation(s.scheme),(await m.impl.readFile(s)).slice()):(await r.a.$readFile(s)).buffer}catch(m){return y.e(m)}},async writeFile(s,m){try{const h=r.b.get(s.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(s.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(s)),await r.c.queueFor(s).queue(()=>Promise.resolve(h.impl.writeFile(s,m,{create:!0,overwrite:!0})))):await r.a.$writeFile(s,L.$be.wrap(m))}catch(h){return y.e(h)}},async delete(s,m){try{const h=r.b.get(s.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(s.scheme),await h.impl.delete(s,{recursive:!1,...m})):await r.a.$delete(s,{recursive:!1,useTrash:!1,atomic:!1,...m})}catch(h){return y.e(h)}},async rename(s,m,h){try{return await r.a.$rename(s,m,{overwrite:!1,...h})}catch(t){return y.e(t)}},async copy(s,m,h){try{return await r.a.$copy(s,m,{overwrite:!1,...h})}catch(t){return y.e(t)}},isWritableFileSystem(s){const m=o.getCapabilities(s);if(typeof m=="number")return!(m&2048)}})}async d(u,o,r){const s=[];for(;!o.isEqual(r,o.dirname(r));)try{if(!((await u.stat(r)).type&F.FileType.Directory))throw d.$vL.FileExists(`Unable to create folder '${r.scheme===w.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(m){if(F.$ok(m)!==F.FileSystemProviderErrorCode.FileNotFound)throw m;s.push(o.basename(r)),r=o.dirname(r)}for(let m=s.length-1;m>=0;m--){r=o.joinPath(r,s[m]);try{await u.createDirectory(r)}catch(h){if(F.$ok(h)!==F.FileSystemProviderErrorCode.FileExists)throw h}}}static e(u){if(u instanceof d.$vL)throw u;if(u instanceof F.$kk)switch(u.code){case F.FileSystemProviderErrorCode.FileExists:throw d.$vL.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw d.$vL.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw d.$vL.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw d.$vL.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw d.$vL.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw d.$vL.Unavailable(u.message);default:throw new d.$vL(u.message,u.name)}if(!(u instanceof Error))throw new d.$vL(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw d.$vL.Unavailable(u.message);switch(u.name){case F.FileSystemProviderErrorCode.FileExists:throw d.$vL.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw d.$vL.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw d.$vL.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw d.$vL.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw d.$vL.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw d.$vL.Unavailable(u.message);default:throw new d.$vL(u.message,u.name)}}addFileSystemProvider(u,o,r){return this.b.set(u,{impl:o,extUri:r?.isCaseSensitive?I.$lg:I.$ng,isReadonly:!!r?.isReadonly}),(0,v.$Qc)(()=>this.b.delete(u))}getFileSystemProviderExtUri(u){return this.b.get(u)?.extUri??I.$lg}};e.$Dcc=k,e.$Dcc=k=y=He([Be(0,$.$hM),Be(1,E.$_bc)],k),e.$Ecc=(0,A.$Ph)("IExtHostConsumerFileSystem")}),define(De[312],Ce([1,0,4,35,2,6,13,7,47]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class v{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,k,p,u,o,r){this.a=Math.random(),this.b=new C.$Nd,this.c=new C.$Nd,this.d=new C.$Nd,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const s=(0,F.$wj)(o),m=typeof o=="string",h=u(t=>{if(!(typeof t.session=="number"&&t.session!==this.a)){if(!r?.ignoreCreateEvents)for(const n of t.created){const c=d.URI.revive(n);s(c.fsPath)&&(!m||k.getWorkspaceFolder(c))&&this.b.fire(c)}if(!r?.ignoreChangeEvents)for(const n of t.changed){const c=d.URI.revive(n);s(c.fsPath)&&(!m||k.getWorkspaceFolder(c))&&this.c.fire(c)}if(!r?.ignoreDeleteEvents)for(const n of t.deleted){const c=d.URI.revive(n);s(c.fsPath)&&(!m||k.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=$.$iK.from(this.i(y,p,o,r),this.b,this.c,this.d,h)}i(y,k,p,u){const o=$.$iK.from();if(typeof p=="string")return o;const r=y.getProxy(L.$gK.MainThreadFileSystemEventService);let s=!1;return(p.pattern.includes(F.$sj)||p.pattern.includes(F.$tj))&&(s=!0),r.$watch(k.identifier.value,this.a,p.baseUri,{recursive:s,excludes:u?.excludes??[]}),$.$iK.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(y){this.a=y,this.session=this.a.session,this.b=new E.$V(()=>this.a.created.map(d.URI.revive)),this.c=new E.$V(()=>this.a.changed.map(d.URI.revive)),this.d=new E.$V(()=>this.a.deleted.map(d.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(y,k,p){this.j=y,this.k=k,this.l=p,this.a=new C.$Nd,this.b=new C.$Nd,this.c=new C.$Nd,this.d=new C.$Nd,this.g=new C.$Pd,this.h=new C.$Pd,this.i=new C.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,k,p,u){return new v(this.j,y,k,this.a.event,A.GlobPattern.from(p),u)}$onFileEvent(y){this.a.fire(new R(y))}$onDidRunFileOperation(y,k){switch(y){case 2:this.b.fire(Object.freeze({files:k.map(p=>({oldUri:d.URI.revive(p.source),newUri:d.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(p=>d.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(p=>d.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,k){return(p,u,o)=>{const r=function(m){p.call(u,m)};return r.extension=y,k.event(r,void 0,o)}}async $onWillRunFileOperation(y,k,p,u){switch(y){case 2:return await this.n(this.g,{files:k.map(o=>({oldUri:d.URI.revive(o.source),newUri:d.URI.revive(o.target)}))},p,u);case 1:return await this.n(this.i,{files:k.map(o=>d.URI.revive(o.target))},p,u);case 0:case 3:return await this.n(this.h,{files:k.map(o=>d.URI.revive(o.target))},p,u)}}async n(y,k,p,u){const o=new Set,r=[];if(await y.fireAsync(k,u,async(m,h)=>{const t=Date.now(),n=await Promise.resolve(m);n instanceof $.$sK&&(r.push([h.extension,n]),o.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>p&&this.k.warn("SLOW file-participant",h.extension.identifier)}),u.isCancellationRequested||r.length===0)return;const s={edits:[]};for(const[,m]of r){const{edits:h}=A.WorkspaceEdit.from(m,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(h)}return{edit:s,extensionNames:Array.from(o)}}}e.$Ycc=I}),define(De[313],Ce([1,0,3,2,6,13,7,34,8]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;class v{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=v.a++}}class R{constructor(y){this.session=y,this.responses=[]}}class I{static{this.a=0}constructor(y,k,p,u){this.f=p,this.g=u,this.b=new Map,this.d=new Map,this.e=y.getProxy(d.$gK.MainThreadInlineChat),k.registerApiCommand(new $.$HM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$FM("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?L.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?L.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?L.Position.from(o.position):void 0}})],$.$GM.Void))}registerProvider(y,k,p){const u=new v(y,k);return this.b.set(u.handle,u),this.e.$registerInteractiveEditorProvider(u.handle,p.label,y.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,C.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(u.handle),this.b.delete(u.handle)})}async $prepareSession(y,k,p,u){const o=this.b.get(y);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(F.URI.revive(k)),s=L.Selection.to(p),m=await o.provider.prepareInteractiveEditorSession({document:r,selection:s},u);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(s))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=I.a++;return this.d.set(h,new R(m)),{id:h,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:L.Range.from(m.wholeRange),message:m.message}}async $provideResponse(y,k,p,u){const o=this.b.get(y);if(!o)return;const r=this.d.get(k.id);if(!r)return;const s={prompt:p.prompt,selection:L.Selection.to(p.selection),wholeRange:L.Range.to(p.wholeRange),attempt:p.attempt,live:p.live};let m=!1;const h={report:async l=>{if(!p.live)throw new Error("Progress reporting is only supported for live sessions");m||u.isCancellationRequested||await this.e.$handleProgressChunk(p.requestId,{message:l.message,edits:l.edits?.map(L.TextEdit.from),slashCommand:l.slashCommand?.command})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(r.session,s,h,u));let n;try{n=await(0,E.$Ig)(t,u)}finally{m=!0}if(!n)return;const c=r.responses.push(n)-1,i={wholeRange:L.Range.from(n.wholeRange),placeholder:n.placeholder};if(I.h(n))return{...i,id:c,type:"message",message:L.MarkdownString.from(n.contents)};const{edits:a}=n;return a instanceof A.$sK?{...i,id:c,type:"bulkEdit",edits:L.WorkspaceEdit.from(a)}:{...i,id:c,type:"editorEdit",edits:a.map(L.TextEdit.from)}}$handleFeedback(y,k,p,u){const o=this.b.get(y),r=this.d.get(k),s=r?.responses[p];if(o&&s){const m=L.InteractiveEditorResponseFeedbackKind.to(u);o.provider.handleInteractiveEditorResponseFeedback?.(r.session,s,m)}}$releaseSession(y,k){}static h(y){return typeof y=="object"&&typeof y.contents=="object"}}e.$6dc=I}),define(De[314],Ce([1,0,2,34]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class d{constructor(A,$,E,v,R){this.a=$,this.b=E,this.c=v;const I=new F.$HM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$FM("showOptions","Show Options",w=>!0,w=>w),new F.$FM("resource","Interactive resource Uri",w=>!0,w=>w),new F.$FM("controllerId","Notebook controller Id",w=>!0,w=>w),new F.$FM("title","Interactive editor title",w=>!0,w=>w)],new F.$GM("Notebook and input URI",w=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const y=this.a.getEditorById(w.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:C.URI.revive(w.notebookUri),inputUri:C.URI.revive(w.inputUri),notebookEditor:y.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:C.URI.revive(w.notebookUri),inputUri:C.URI.revive(w.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,$,E,v){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(v))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$2dc=d}),define(De[315],Ce([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class d{constructor(A){this.a=new Map,this.b=A.getProxy(C.$gK.MainThreadIssueReporter)}async $getIssueReporterUri(A,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const v=await E.handleIssueUrlRequest();if(!v)throw new Error("Issue request handler returned no result");return v}registerIssueUriRequestHandler(A,$){const E=A.identifier.value;return this.a.set(E,$),this.b.$registerIssueUriRequestHandler(E),new F.$iK(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$8dc=d}),define(De[316],Ce([1,0,3,6]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class d{constructor(A){this.b=0,this.a=A.getProxy(F.$gK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const $=this.b++;return this.a.$registerResourceLabelFormatter($,A),(0,C.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$idc=d}),define(De[317],Ce([1,0,2,24,13,7,83,6,15,32,19,17,165,21,25,3,129,119,107,37,9,8,26,205]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class c{constructor(z,G){this.d=z,this.e=G}async provideDocumentSymbols(z,G){const se=this.d.getDocument(z),oe=await this.e.provideDocumentSymbols(se,G);if(!(0,R.$Kb)(oe))return oe[0]instanceof L.$AK?oe.map(d.DocumentSymbol.from):c.f(oe)}static f(z){z=z.slice(0).sort((oe,Z)=>{let me=oe.location.range.start.compareTo(Z.location.range.start);return me===0&&(me=Z.location.range.end.compareTo(oe.location.range.end)),me});const G=[],se=[];for(const oe of z){const Z={name:oe.name||"!!MISSING: name!!",kind:d.SymbolKind.from(oe.kind),tags:oe.tags?.map(d.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:d.Range.from(oe.location.range),selectionRange:d.Range.from(oe.location.range),children:[]};for(;;){if(se.length===0){se.push(Z),G.push(Z);break}const me=se[se.length-1];if(v.$us.containsRange(me.range,Z.range)&&!v.$us.equalsRange(me.range,Z.range)){me.children?.push(Z),se.push(Z);break}se.pop()}}return G}}class i{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(z,G,se){this.g=z,this.h=G,this.j=se,this.e=new r.$9bc("CodeLens"),this.f=new Map}async provideCodeLenses(z,G){const se=this.g.getDocument(z),oe=await this.j.provideCodeLenses(se,G);if(!oe||G.isCancellationRequested)return;const Z=this.e.add(oe),me=new p.$Rc;this.f.set(Z,me);const Ee={cacheId:Z,lenses:[]};for(let je=0;je<oe.length;je++)Ee.lenses.push({cacheId:[Z,je],range:d.Range.from(oe[je].range),command:this.h.toInternal(oe[je].command,me)});return Ee}async resolveCodeLens(z,G){const se=z.cacheId&&this.e.get(...z.cacheId);if(!se)return;let oe;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?oe=se:oe=await this.j.resolveCodeLens(se,G),oe||(oe=se),G.isCancellationRequested)return;const Z=z.cacheId&&this.f.get(z.cacheId[0]);if(Z)return z.command=this.h.toInternal(oe.command??i.d,Z),z}releaseCodeLenses(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}}function a(Pe){return Array.isArray(Pe)?Pe.map(d.DefinitionLink.from):Pe?[d.DefinitionLink.from(Pe)]:[]}class l{constructor(z,G){this.d=z,this.e=G}async provideDefinition(z,G,se){const oe=this.d.getDocument(z),Z=d.Position.to(G),me=await this.e.provideDefinition(oe,Z,se);return a(me)}}class D{constructor(z,G){this.d=z,this.e=G}async provideDeclaration(z,G,se){const oe=this.d.getDocument(z),Z=d.Position.to(G),me=await this.e.provideDeclaration(oe,Z,se);return a(me)}}class S{constructor(z,G){this.d=z,this.e=G}async provideImplementation(z,G,se){const oe=this.d.getDocument(z),Z=d.Position.to(G),me=await this.e.provideImplementation(oe,Z,se);return a(me)}}class b{constructor(z,G){this.d=z,this.e=G}async provideTypeDefinition(z,G,se){const oe=this.d.getDocument(z),Z=d.Position.to(G),me=await this.e.provideTypeDefinition(oe,Z,se);return a(me)}}class f{constructor(z,G){this.d=z,this.e=G}async provideHover(z,G,se){const oe=this.d.getDocument(z),Z=d.Position.to(G),me=await this.e.provideHover(oe,Z,se);if(!(!me||(0,R.$Kb)(me.contents)))return me.range||(me.range=oe.getWordRangeAtPosition(Z)),me.range||(me.range=new L.$kK(Z,Z)),d.Hover.from(me)}}class g{constructor(z,G){this.d=z,this.e=G}async provideEvaluatableExpression(z,G,se){const oe=this.d.getDocument(z),Z=d.Position.to(G),me=await this.e.provideEvaluatableExpression(oe,Z,se);if(me)return d.EvaluatableExpression.from(me)}}class P{constructor(z,G){this.d=z,this.e=G}async provideInlineValues(z,G,se,oe){const Z=this.d.getDocument(z),me=await this.e.provideInlineValues(Z,d.Range.to(G),d.InlineValueContext.to(se),oe);if(Array.isArray(me))return me.map(Ee=>d.InlineValue.from(Ee))}}class N{constructor(z,G){this.d=z,this.e=G}async provideDocumentHighlights(z,G,se){const oe=this.d.getDocument(z),Z=d.Position.to(G),me=await this.e.provideDocumentHighlights(oe,Z,se);if(Array.isArray(me))return me.map(d.DocumentHighlight.from)}}class O{constructor(z,G){this.d=z,this.e=G}async provideLinkedEditingRanges(z,G,se){const oe=this.d.getDocument(z),Z=d.Position.to(G),me=await this.e.provideLinkedEditingRanges(oe,Z,se);if(me&&Array.isArray(me.ranges))return{ranges:(0,R.$Hb)(me.ranges.map(d.Range.from)),wordPattern:me.wordPattern}}}class M{constructor(z,G){this.d=z,this.e=G}async provideReferences(z,G,se,oe){const Z=this.d.getDocument(z),me=d.Position.to(G),Ee=await this.e.provideReferences(Z,me,se,oe);if(Array.isArray(Ee))return Ee.map(d.location.from)}}class j{static{this.d=1e3}constructor(z,G,se,oe,Z,me,Ee){this.g=z,this.h=G,this.j=se,this.k=oe,this.l=Z,this.m=me,this.n=Ee,this.e=new r.$9bc("CodeAction"),this.f=new Map}async provideCodeActions(z,G,se,oe){const Z=this.g.getDocument(z),me=w.$ws.isISelection(G)?d.Selection.to(G):d.Range.to(G),Ee=[];for(const et of this.j.getDiagnostics(z))if(me.intersection(et.range)&&Ee.push(et)>j.d)break;const je={diagnostics:Ee,only:se.only?new L.$CK(se.only):void 0,triggerKind:d.CodeActionTriggerKind.to(se.trigger)},We=await this.k.provideCodeActions(Z,me,je,oe);if(!(0,R.$Lb)(We)||oe.isCancellationRequested)return;const _e=this.e.add(We),Ye=new p.$Rc;this.f.set(_e,Ye);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];Ae&&(j.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,et],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(d.Diagnostic.from),edit:Ae.edit&&d.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$dF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(z,G){const[se,oe]=z,Z=this.e.get(se,oe);if(!Z||j.o(Z))return{};if(!this.k.resolveCodeAction)return{};const me=await this.k.resolveCodeAction(Z,G)??Z;let Ee;me.edit&&(Ee=d.WorkspaceEdit.from(me.edit,void 0));let je;if(me.command){const We=this.f.get(se);We&&(je=this.h.toInternal(me.command,We))}return{edit:Ee,command:je}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class U{static toInternalProviderId(z,G){return z+"."+G}constructor(z,G,se,oe,Z){this.d=z,this.e=G,this.f=se,this.g=oe,this.h=Z}async prepareDocumentPaste(z,G,se,oe){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(z),me=G.map(We=>d.Range.to(We)),Ee=d.DataTransfer.toDataTransfer(se,()=>{throw new m.$$});if(await this.f.prepareDocumentPaste(Z,me,Ee,oe),oe.isCancellationRequested)return;const je=Array.from(Ee).filter(([,We])=>!(We instanceof L.$9K));return d.DataTransfer.from(je)}async providePasteEdits(z,G,se,oe,Z){if(!this.f.provideDocumentPasteEdits)return;const me=this.e.getDocument(G),Ee=se.map(_e=>d.Range.to(_e)),je=d.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolvePasteFileData(this.g,z,_e)).buffer),We=await this.f.provideDocumentPasteEdits(me,Ee,je,Z);if(We)return{label:We.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:U.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class T{constructor(z,G){this.d=z,this.e=G}async provideDocumentFormattingEdits(z,G,se){const oe=this.d.getDocument(z),Z=await this.e.provideDocumentFormattingEdits(oe,G,se);if(Array.isArray(Z))return Z.map(d.TextEdit.from)}}class K{constructor(z,G){this.d=z,this.e=G}async provideDocumentRangeFormattingEdits(z,G,se,oe){const Z=this.d.getDocument(z),me=d.Range.to(G),Ee=await this.e.provideDocumentRangeFormattingEdits(Z,me,se,oe);if(Array.isArray(Ee))return Ee.map(d.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,G,se,oe){(0,I.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(z),me=G.map(d.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Z,me,se,oe);if(Array.isArray(Ee))return Ee.map(d.TextEdit.from)}}class q{constructor(z,G){this.d=z,this.e=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,G,se,oe,Z){const me=this.d.getDocument(z),Ee=d.Position.to(G),je=await this.e.provideOnTypeFormattingEdits(me,Ee,se,oe,Z);if(Array.isArray(je))return je.map(d.TextEdit.from)}}class ge{constructor(z,G){this.e=z,this.f=G,this.d=new r.$9bc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,G){const se=await this.e.provideWorkspaceSymbols(z,G);if(!(0,R.$Lb)(se))return{symbols:[]};const oe=this.d.add(se),Z={cacheId:oe,symbols:[]};for(let me=0;me<se.length;me++){const Ee=se[me];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Z.symbols.push({...d.WorkspaceSymbol.from(Ee),cacheId:[oe,me]})}return Z}async resolveWorkspaceSymbol(z,G){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const se=this.d.get(...z.cacheId);if(se){const oe=await this.e.resolveWorkspaceSymbol(se,G);return oe&&(0,F.$0m)(z,d.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class ee{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,G,se){this.d=z,this.e=G,this.f=se}async provideRenameEdits(z,G,se,oe){const Z=this.d.getDocument(z),me=d.Position.to(G);try{const Ee=await this.e.provideRenameEdits(Z,me,se,oe);return Ee?d.WorkspaceEdit.from(Ee):void 0}catch(Ee){const je=ee.g(Ee);return je?{rejectReason:je,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(z,G,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(z),Z=d.Position.to(G);try{const me=await this.e.prepareRename(oe,Z,se);let Ee,je;if(L.$kK.isRange(me)?(Ee=me,je=oe.getText(me)):(0,I.$Af)(me)&&(Ee=me.range,je=me.placeholder),!Ee||!je)return;if(Ee.start.line>Z.line||Ee.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:d.Range.from(Ee),text:je}}catch(me){const Ee=ee.g(me);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(me)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class Q{constructor(z,G){this.resultId=z,this.tokens=G}}class X{constructor(z,G){this.f=z,this.g=G,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,G,se){const oe=this.f.getDocument(z),Z=G!==0?this.d.get(G):null;let me=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,Z.resultId,se):await this.g.provideDocumentSemanticTokens(oe,se);return Z&&this.d.delete(G),me?(me=X.h(me),this.o(X.n(Z,me),me)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return X.j(z)?X.k(z)?z:new L.$zL(new Uint32Array(z.data),z.resultId):X.l(z)?X.m(z)?z:new L.$BL(z.edits.map(G=>new L.$AL(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const G of z.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static n(z,G){if(!X.j(G)||!z||!z.tokens)return G;const se=z.tokens,oe=se.length,Z=G.data,me=Z.length;let Ee=0;const je=Math.min(oe,me);for(;Ee<je&&se[Ee]===Z[Ee];)Ee++;if(Ee===oe&&Ee===me)return new L.$BL([],G.resultId);let We=0;const _e=je-Ee;for(;We<_e&&se[oe-We-1]===Z[me-We-1];)We++;return new L.$BL([{start:Ee,deleteCount:oe-Ee-We,data:Z.subarray(Ee,me-We)}],G.resultId)}o(z,G){if(X.j(z)){const se=this.e++;return this.d.set(se,new Q(z.resultId,z.data)),(0,u.$W0)({id:se,type:"full",data:z.data})}if(X.l(z)){const se=this.e++;return X.j(G)?this.d.set(se,new Q(G.resultId,G.data)):this.d.set(se,new Q(z.resultId)),(0,u.$W0)({id:se,type:"delta",deltas:(z.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class ae{constructor(z,G){this.d=z,this.e=G}async provideDocumentRangeSemanticTokens(z,G,se){const oe=this.d.getDocument(z),Z=await this.e.provideDocumentRangeSemanticTokens(oe,d.Range.to(G),se);return Z?this.f(Z):null}f(z){return(0,u.$W0)({id:0,type:"full",data:z.data})}}class ie{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,G,se,oe,Z){this.f=z,this.g=G,this.h=se,this.j=oe,this.k=Z,this.d=new r.$9bc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,G,se,oe){const Z=this.f.getDocument(z),me=d.Position.to(G),Ee=Z.getWordRangeAtPosition(me)||new L.$kK(me,me),je=Ee.with({end:me}),We=new s.$Jd,_e=await this.h.provideCompletionItems(Z,me,oe,d.CompletionContext.to(se));if(!_e||oe.isCancellationRequested)return;const Ye=Array.isArray(_e)?new L.$PK(_e):_e,it=ie.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),et=new p.$Rc;this.e.set(it,et);const Ae=[],Ne={x:it,b:Ae,a:{replace:d.Range.from(Ee),insert:d.Range.from(je)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Ye.items.length;qe++){const Le=Ye.items[qe],Xe=this.l(Le,[it,qe],je,Ee);Ae.push(Xe)}return Ne}async resolveCompletionItem(z,G){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...z);if(!se)return;const oe=this.l(se,z),Z=await this.h.resolveCompletionItem(se,G);if(!Z)return;const me=this.l(Z,z);return(oe.h!==me.h||oe.i!==me.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==me.n||oe.o!==me.o||!(0,F.$$m)(oe.p,me.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:me.d,c:me.c,l:me.l,h:me.h,i:me.i,n:me.n,o:me.o,p:me.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,G,se,oe){const Z=this.e.get(G[0]);if(!Z)throw Error("DisposableStore is missing...");const me=this.g.toInternal(z.command,Z),Ee={x:G,a:z.label,b:z.kind!==void 0?d.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(d.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:d.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(d.TextEdit.from),n:me?.$ident,o:me?.id,p:me?.$ident?void 0:me?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=z.textEdit.newText):typeof z.insertText=="string"?Ee.h=z.insertText:z.insertText instanceof L.$tK&&(Ee.h=z.insertText.value,Ee.i|=4);let je;return z.textEdit?je=z.textEdit.range:z.range&&(je=z.range),L.$kK.isRange(je)?Ee.j=d.Range.from(je):je&&(!se?.isEqual(je.inserting)||!oe?.isEqual(je.replacing))&&(Ee.j={insert:d.Range.from(je.inserting),replace:d.Range.from(je.replacing)}),Ee}}class ce{async provideInlineCompletions(z,G,se,oe){}disposeCompletions(z){}handleDidShowCompletionItem(z,G,se){}handlePartialAccept(z,G,se){}}class we extends ce{constructor(z,G,se,oe){super(),this.f=z,this.g=G,this.h=se,this.j=oe,this.d=new H,this.e=(0,t.$dF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$dF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,G,se,oe){const Z=this.g.getDocument(z),me=d.Position.to(G),Ee=await this.h.provideInlineCompletionItems(Z,me,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:d.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},oe);if(!Ee||oe.isCancellationRequested)return;const je=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:je}),items:je.map((et,Ae)=>{let Ne;et.command&&(Ye||(Ye=new p.$Rc),Ne=this.j.toInternal(et.command,Ye));const qe=et.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:et.filterText,range:et.range?d.Range.from(et.range):void 0,command:Ne,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Ye||(Ye=new p.$Rc),this.j.toInternal(et,Ye))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,G,se){const oe=this.d.get(z)?.items[G];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,se)}handlePartialAccept(z,G,se){const oe=this.d.get(z)?.items[G];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,se)}}class H{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const G=this.e++;return this.d.set(G,z),G}disposeReferenceId(z){const G=this.d.get(z);return this.d.delete(z),G}get(z){return this.d.get(z)}}class B{constructor(z,G){this.e=z,this.f=G,this.d=new r.$9bc("SignatureHelp")}async provideSignatureHelp(z,G,se,oe){const Z=this.e.getDocument(z),me=d.Position.to(G),Ee=this.g(se),je=await this.f.provideSignatureHelp(Z,me,oe,Ee);if(je){const We=this.d.add([je]);return{...d.SignatureHelp.from(je),id:We}}}g(z){let G;if(z.activeSignatureHelp){const se=d.SignatureHelp.to(z.activeSignatureHelp),oe=this.d.get(z.activeSignatureHelp.id,0);oe?(G=oe,G.activeSignature=se.activeSignature,G.activeParameter=se.activeParameter):G=se}return{...z,activeSignatureHelp:G}}releaseSignatureHelp(z){this.d.delete(z)}}class J{constructor(z,G,se,oe,Z){this.f=z,this.g=G,this.h=se,this.j=oe,this.k=Z,this.d=new r.$9bc("InlayHints"),this.e=new Map}async provideInlayHints(z,G,se){const oe=this.f.getDocument(z),Z=d.Range.to(G),me=await this.h.provideInlayHints(oe,Z,se);if(!Array.isArray(me)||me.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${G}`);return}if(se.isCancellationRequested)return;const Ee=this.d.add(me);this.e.set(Ee,new p.$Rc);const je={hints:[],cacheId:Ee};for(let We=0;We<me.length;We++)this.l(me[We],Z)&&je.hints.push(this.m(me[We],[Ee,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${G}`),je}async resolveInlayHint(z,G){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...z);if(!se)return;const oe=await this.h.resolveInlayHint(se,G);if(oe&&this.l(oe))return this.m(oe,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,G){return z.label.length===0||Array.isArray(z.label)&&z.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(G&&!G.contains(z.position))}m(z,G){const se=this.e.get(G[0]);if(!se)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:G,tooltip:d.MarkdownString.fromStrict(z.tooltip),position:d.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(d.TextEdit.from),kind:z.kind&&d.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?oe.label=z.label:oe.label=z.label.map(Z=>{const me={label:Z.value};return me.tooltip=d.MarkdownString.fromStrict(Z.tooltip),L.$uK.isLocation(Z.location)&&(me.location=d.location.from(Z.location)),Z.command&&(me.command=this.g.toInternal(Z.command,se)),me}),oe}}class re{constructor(z,G){this.e=z,this.f=G,this.d=new r.$9bc("DocumentLink")}async provideLinks(z,G){const se=this.e.getDocument(z),oe=await this.f.provideDocumentLinks(se,G);if(!(!Array.isArray(oe)||oe.length===0)&&!G.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(re.g).map(d.DocumentLink.from)};{const Z=this.d.add(oe),me={links:[],cacheId:Z};for(let Ee=0;Ee<oe.length;Ee++){if(!re.g(oe[Ee]))continue;const je=d.DocumentLink.from(oe[Ee]);je.cacheId=[Z,Ee],me.links.push(je)}return me}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,G){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...z);if(!se)return;const oe=await this.f.resolveDocumentLink(se,G);if(!(!oe||!re.g(oe)))return d.DocumentLink.from(oe)}releaseLinks(z){this.d.delete(z)}}class Y{constructor(z,G){this.d=z,this.e=G}async provideColors(z,G){const se=this.d.getDocument(z),oe=await this.e.provideDocumentColors(se,G);return Array.isArray(oe)?oe.map(me=>({color:d.Color.from(me.color),range:d.Range.from(me.range)})):[]}async provideColorPresentations(z,G,se){const oe=this.d.getDocument(z),Z=d.Range.to(G.range),me=d.Color.to(G.color),Ee=await this.e.provideColorPresentations(me,{document:oe,range:Z},se);if(Array.isArray(Ee))return Ee.map(d.ColorPresentation.from)}}class _{constructor(z,G){this.d=z,this.e=G}async provideFoldingRanges(z,G,se){const oe=this.d.getDocument(z),Z=await this.e.provideFoldingRanges(oe,G,se);if(Array.isArray(Z))return Z.map(d.FoldingRange.from)}}class x{constructor(z,G,se){this.d=z,this.e=G,this.f=se}async provideSelectionRanges(z,G,se){const oe=this.d.getDocument(z),Z=G.map(d.Position.to),me=await this.e.provideSelectionRanges(oe,Z,se);if(!(0,R.$Lb)(me))return[];if(me.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let je=0;je<Z.length;je++){const We=[];Ee.push(We);let _e=Z[je],Ye=me[je];for(;;){if(!Ye.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(d.SelectionRange.from(Ye)),!Ye.parent)break;_e=Ye.range,Ye=Ye.parent}}return Ee}}class pe{constructor(z,G){this.f=z,this.g=G,this.d=new o.$mM(""),this.e=new Map}async prepareSession(z,G,se){const oe=this.f.getDocument(z),Z=d.Position.to(G),me=await this.g.prepareCallHierarchy(oe,Z,se);if(!me)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(me)?me.map(je=>this.h(Ee,je)):[this.h(Ee,me)]}async provideCallsTo(z,G,se){const oe=this.j(z,G);if(!oe)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(oe,se);if(Z)return Z.map(me=>({from:this.h(z,me.from),fromRanges:me.fromRanges.map(Ee=>d.Range.from(Ee))}))}async provideCallsFrom(z,G,se){const oe=this.j(z,G);if(!oe)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(oe,se);if(Z)return Z.map(me=>({to:this.h(z,me.to),fromRanges:me.fromRanges.map(Ee=>d.Range.from(Ee))}))}releaseSession(z){this.e.delete(z)}h(z,G){const se=this.e.get(z),oe=d.CallHierarchyItem.from(G,z,se.size.toString(36));return se.set(oe._itemId,G),oe}j(z,G){return this.e.get(z)?.get(G)}}class ue{constructor(z,G){this.f=z,this.g=G,this.d=new o.$mM(""),this.e=new Map}async prepareSession(z,G,se){const oe=this.f.getDocument(z),Z=d.Position.to(G),me=await this.g.prepareTypeHierarchy(oe,Z,se);if(!me)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(me)?me.map(je=>this.h(Ee,je)):[this.h(Ee,me)]}async provideSupertypes(z,G,se){const oe=this.j(z,G);if(!oe)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(oe,se);if(Z)return Z.map(me=>this.h(z,me))}async provideSubtypes(z,G,se){const oe=this.j(z,G);if(!oe)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(oe,se);if(Z)return Z.map(me=>this.h(z,me))}releaseSession(z){this.e.delete(z)}h(z,G){const se=this.e.get(z),oe=d.TypeHierarchyItem.from(G,z,se.size.toString(36));return se.set(oe._itemId,G),oe}j(z,G){return this.e.get(z)?.get(G)}}class fe{static toInternalProviderId(z,G){return z+"."+G}constructor(z,G,se,oe,Z){this.d=z,this.e=G,this.f=se,this.g=oe,this.h=Z}async provideDocumentOnDropEdits(z,G,se,oe,Z){const me=this.e.getDocument(G),Ee=d.Position.to(se),je=d.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,_e)).buffer),We=await this.f.provideDocumentDropEdits(me,Ee,je,Z);if(We)return{label:We.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:fe.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class te{constructor(z,G){this.d=z,this.e=G}async provideMappedEdits(z,G,se,oe){const Z=C.URI.revive(z),me=this.d.getDocument(Z),Ee=se.documents.map(_e=>_e.map(Ye=>({uri:C.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(it=>d.Range.to(it))}))),je={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(me,G,je,oe);return We?d.WorkspaceEdit.from(We):null}}class de{constructor(z,G){this.adapter=z,this.extension=G}}class be{static{this.d=0}constructor(z,G,se,oe,Z,me,Ee,je){this.g=G,this.h=se,this.j=oe,this.k=Z,this.l=me,this.m=Ee,this.n=je,this.f=new Map,this.e=z.getProxy($.$gK.MainThreadLanguageFeatures)}o(z,G){return d.DocumentSelector.from(z,this.g,G)}p(z){return new L.$iK(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return be.d++}async s(z,G,se,oe,Z,me=!1){const Ee=this.f.get(z);if(!Ee||!(Ee.adapter instanceof G))return oe;const je=Date.now();me||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const We=se(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(_e=>{(0,m.$4)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{me||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),y.CancellationToken.isCancellationToken(Z)?(0,h.$Jg)(We,Z):We}t(z,G){const se=this.q();return this.f.set(se,new de(z,G)),se}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,G,se,oe){const Z=this.t(new c(this.h,se),z),me=oe&&oe.label||be.u(z);return this.e.$registerDocumentSymbolProvider(Z,this.o(G,z),me),this.p(Z)}$provideDocumentSymbols(z,G,se){return this.s(z,c,oe=>oe.provideDocumentSymbols(C.URI.revive(G),se),void 0,se)}registerCodeLensProvider(z,G,se){const oe=this.q(),Z=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new de(new i(this.h,this.j.converter,se),z)),this.e.$registerCodeLensSupport(oe,this.o(G,z),Z);let me=this.p(oe);if(Z!==void 0){const Ee=se.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Z));me=L.$iK.from(me,Ee)}return me}$provideCodeLenses(z,G,se){return this.s(z,i,oe=>oe.provideCodeLenses(C.URI.revive(G),se),void 0,se)}$resolveCodeLens(z,G,se){return this.s(z,i,oe=>oe.resolveCodeLens(G,se),void 0,void 0)}$releaseCodeLenses(z,G){this.s(z,i,se=>Promise.resolve(se.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(z,G,se){const oe=this.t(new l(this.h,se),z);return this.e.$registerDefinitionSupport(oe,this.o(G,z)),this.p(oe)}$provideDefinition(z,G,se,oe){return this.s(z,l,Z=>Z.provideDefinition(C.URI.revive(G),se,oe),[],oe)}registerDeclarationProvider(z,G,se){const oe=this.t(new D(this.h,se),z);return this.e.$registerDeclarationSupport(oe,this.o(G,z)),this.p(oe)}$provideDeclaration(z,G,se,oe){return this.s(z,D,Z=>Z.provideDeclaration(C.URI.revive(G),se,oe),[],oe)}registerImplementationProvider(z,G,se){const oe=this.t(new S(this.h,se),z);return this.e.$registerImplementationSupport(oe,this.o(G,z)),this.p(oe)}$provideImplementation(z,G,se,oe){return this.s(z,S,Z=>Z.provideImplementation(C.URI.revive(G),se,oe),[],oe)}registerTypeDefinitionProvider(z,G,se){const oe=this.t(new b(this.h,se),z);return this.e.$registerTypeDefinitionSupport(oe,this.o(G,z)),this.p(oe)}$provideTypeDefinition(z,G,se,oe){return this.s(z,b,Z=>Z.provideTypeDefinition(C.URI.revive(G),se,oe),[],oe)}registerHoverProvider(z,G,se,oe){const Z=this.t(new f(this.h,se),z);return this.e.$registerHoverProvider(Z,this.o(G,z)),this.p(Z)}$provideHover(z,G,se,oe){return this.s(z,f,Z=>Z.provideHover(C.URI.revive(G),se,oe),void 0,oe)}registerEvaluatableExpressionProvider(z,G,se,oe){const Z=this.t(new g(this.h,se),z);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(G,z)),this.p(Z)}$provideEvaluatableExpression(z,G,se,oe){return this.s(z,g,Z=>Z.provideEvaluatableExpression(C.URI.revive(G),se,oe),void 0,oe)}registerInlineValuesProvider(z,G,se,oe){const Z=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,me=this.t(new P(this.h,se),z);this.e.$registerInlineValuesProvider(me,this.o(G,z),Z);let Ee=this.p(me);if(Z!==void 0){const je=se.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Z));Ee=L.$iK.from(Ee,je)}return Ee}$provideInlineValues(z,G,se,oe,Z){return this.s(z,P,me=>me.provideInlineValues(C.URI.revive(G),se,oe,Z),void 0,Z)}registerDocumentHighlightProvider(z,G,se){const oe=this.t(new N(this.h,se),z);return this.e.$registerDocumentHighlightProvider(oe,this.o(G,z)),this.p(oe)}$provideDocumentHighlights(z,G,se,oe){return this.s(z,N,Z=>Z.provideDocumentHighlights(C.URI.revive(G),se,oe),void 0,oe)}registerLinkedEditingRangeProvider(z,G,se){const oe=this.t(new O(this.h,se),z);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(G,z)),this.p(oe)}$provideLinkedEditingRanges(z,G,se,oe){return this.s(z,O,async Z=>{const me=await Z.provideLinkedEditingRanges(C.URI.revive(G),se,oe);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?be.w(me.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(z,G,se){const oe=this.t(new M(this.h,se),z);return this.e.$registerReferenceSupport(oe,this.o(G,z)),this.p(oe)}$provideReferences(z,G,se,oe,Z){return this.s(z,M,me=>me.provideReferences(C.URI.revive(G),se,oe,Z),void 0,Z)}registerCodeActionProvider(z,G,se,oe){const Z=new p.$Rc,me=this.t(new j(this.h,this.j.converter,this.k,se,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(me,this.o(G,z),{providedKinds:oe?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:oe?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Z)}))},be.u(z),!!se.resolveCodeAction),Z.add(this.p(me)),Z}$provideCodeActions(z,G,se,oe,Z){return this.s(z,j,me=>me.provideCodeActions(C.URI.revive(G),se,oe,Z),void 0,Z)}$resolveCodeAction(z,G,se){return this.s(z,j,oe=>oe.resolveCodeAction(G,se),{},void 0)}$releaseCodeActions(z,G){this.s(z,j,se=>Promise.resolve(se.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(z,G,se){const oe=this.t(new T(this.h,se),z);return this.e.$registerDocumentFormattingSupport(oe,this.o(G,z),z.identifier,z.displayName||z.name),this.p(oe)}$provideDocumentFormattingEdits(z,G,se,oe){return this.s(z,T,Z=>Z.provideDocumentFormattingEdits(C.URI.revive(G),se,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(z,G,se){const oe=typeof se.provideDocumentRangesFormattingEdits=="function",Z=this.t(new K(this.h,se),z);return this.e.$registerRangeFormattingSupport(Z,this.o(G,z),z.identifier,z.displayName||z.name,oe),this.p(Z)}$provideDocumentRangeFormattingEdits(z,G,se,oe,Z){return this.s(z,K,me=>me.provideDocumentRangeFormattingEdits(C.URI.revive(G),se,oe,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(z,G,se,oe,Z){return this.s(z,K,me=>me.provideDocumentRangesFormattingEdits(C.URI.revive(G),se,oe,Z),void 0,Z)}registerOnTypeFormattingEditProvider(z,G,se,oe){const Z=this.t(new q(this.h,se),z);return this.e.$registerOnTypeFormattingSupport(Z,this.o(G,z),oe,z.identifier),this.p(Z)}$provideOnTypeFormattingEdits(z,G,se,oe,Z,me){return this.s(z,q,Ee=>Ee.provideOnTypeFormattingEdits(C.URI.revive(G),se,oe,Z,me),void 0,me)}registerWorkspaceSymbolProvider(z,G){const se=this.t(new ge(G,this.l),z);return this.e.$registerNavigateTypeSupport(se,typeof G.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(z,G,se){return this.s(z,ge,oe=>oe.provideWorkspaceSymbols(G,se),{symbols:[]},se)}$resolveWorkspaceSymbol(z,G,se){return this.s(z,ge,oe=>oe.resolveWorkspaceSymbol(G,se),void 0,void 0)}$releaseWorkspaceSymbols(z,G){this.s(z,ge,se=>se.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(z,G,se){const oe=this.t(new ee(this.h,se,this.l),z);return this.e.$registerRenameSupport(oe,this.o(G,z),ee.supportsResolving(se)),this.p(oe)}$provideRenameEdits(z,G,se,oe,Z){return this.s(z,ee,me=>me.provideRenameEdits(C.URI.revive(G),se,oe,Z),void 0,Z)}$resolveRenameLocation(z,G,se,oe){return this.s(z,ee,Z=>Z.resolveRenameLocation(C.URI.revive(G),se,oe),void 0,oe)}registerDocumentSemanticTokensProvider(z,G,se,oe){const Z=this.t(new X(this.h,se),z),me=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(G,z),oe,me);let Ee=this.p(Z);if(me){const je=se.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(me));Ee=L.$iK.from(Ee,je)}return Ee}$provideDocumentSemanticTokens(z,G,se,oe){return this.s(z,X,Z=>Z.provideDocumentSemanticTokens(C.URI.revive(G),se,oe),null,oe)}$releaseDocumentSemanticTokens(z,G){this.s(z,X,se=>se.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,G,se,oe){const Z=this.t(new ae(this.h,se),z);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(G,z),oe),this.p(Z)}$provideDocumentRangeSemanticTokens(z,G,se,oe){return this.s(z,ae,Z=>Z.provideDocumentRangeSemanticTokens(C.URI.revive(G),se,oe),null,oe)}registerCompletionItemProvider(z,G,se,oe){const Z=this.t(new ie(this.h,this.j.converter,se,this.m,z),z);return this.e.$registerCompletionsProvider(Z,this.o(G,z),oe,ie.supportsResolving(se),z.identifier),this.p(Z)}$provideCompletionItems(z,G,se,oe,Z){return this.s(z,ie,me=>me.provideCompletionItems(C.URI.revive(G),se,oe,Z),void 0,Z)}$resolveCompletionItem(z,G,se){return this.s(z,ie,oe=>oe.resolveCompletionItem(G,se),void 0,se)}$releaseCompletionItems(z,G){this.s(z,ie,se=>se.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(z,G,se,oe){const Z=new we(z,this.h,se,this.j.converter),me=this.t(Z,z);return this.e.$registerInlineCompletionsSupport(me,this.o(G,z),Z.supportsHandleEvents,k.$6l.toKey(z.identifier.value),oe?.yieldTo?.map(Ee=>k.$6l.toKey(Ee))||[]),this.p(me)}$provideInlineCompletions(z,G,se,oe,Z){return this.s(z,ce,me=>me.provideInlineCompletions(C.URI.revive(G),se,oe,Z),void 0,Z)}$handleInlineCompletionDidShow(z,G,se,oe){this.s(z,ce,async Z=>{Z.handleDidShowCompletionItem(G,se,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,G,se,oe){this.s(z,ce,async Z=>{Z.handlePartialAccept(G,se,oe)},void 0,void 0)}$freeInlineCompletionsList(z,G){this.s(z,ce,async se=>{se.disposeCompletions(G)},void 0,void 0)}registerSignatureHelpProvider(z,G,se,oe){const Z=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,me=this.t(new B(this.h,se),z);return this.e.$registerSignatureHelpProvider(me,this.o(G,z),Z),this.p(me)}$provideSignatureHelp(z,G,se,oe,Z){return this.s(z,B,me=>me.provideSignatureHelp(C.URI.revive(G),se,oe,Z),void 0,Z)}$releaseSignatureHelp(z,G){this.s(z,B,se=>se.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(z,G,se){const oe=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new J(this.h,this.j.converter,se,this.l,z),z);this.e.$registerInlayHintsProvider(Z,this.o(G,z),typeof se.resolveInlayHint=="function",oe,be.u(z));let me=this.p(Z);if(oe!==void 0){const Ee=se.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(oe));me=L.$iK.from(me,Ee)}return me}$provideInlayHints(z,G,se,oe){return this.s(z,J,Z=>Z.provideInlayHints(C.URI.revive(G),se,oe),void 0,oe)}$resolveInlayHint(z,G,se){return this.s(z,J,oe=>oe.resolveInlayHint(G,se),void 0,se)}$releaseInlayHints(z,G){this.s(z,J,se=>se.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(z,G,se){const oe=this.t(new re(this.h,se),z);return this.e.$registerDocumentLinkProvider(oe,this.o(G,z),typeof se.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(z,G,se){return this.s(z,re,oe=>oe.provideLinks(C.URI.revive(G),se),void 0,se,G.scheme==="output")}$resolveDocumentLink(z,G,se){return this.s(z,re,oe=>oe.resolveLink(G,se),void 0,void 0,!0)}$releaseDocumentLinks(z,G){this.s(z,re,se=>se.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(z,G,se){const oe=this.t(new Y(this.h,se),z);return this.e.$registerDocumentColorProvider(oe,this.o(G,z)),this.p(oe)}$provideDocumentColors(z,G,se){return this.s(z,Y,oe=>oe.provideColors(C.URI.revive(G),se),[],se)}$provideColorPresentations(z,G,se,oe){return this.s(z,Y,Z=>Z.provideColorPresentations(C.URI.revive(G),se,oe),void 0,oe)}registerFoldingRangeProvider(z,G,se){const oe=this.q(),Z=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new de(new _(this.h,se),z)),this.e.$registerFoldingRangeProvider(oe,this.o(G,z),z.identifier,Z);let me=this.p(oe);if(Z!==void 0){const Ee=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));me=L.$iK.from(me,Ee)}return me}$provideFoldingRanges(z,G,se,oe){return this.s(z,_,Z=>Z.provideFoldingRanges(C.URI.revive(G),se,oe),void 0,oe)}registerSelectionRangeProvider(z,G,se){const oe=this.t(new x(this.h,se,this.l),z);return this.e.$registerSelectionRangeProvider(oe,this.o(G,z)),this.p(oe)}$provideSelectionRanges(z,G,se,oe){return this.s(z,x,Z=>Z.provideSelectionRanges(C.URI.revive(G),se,oe),[],oe)}registerCallHierarchyProvider(z,G,se){const oe=this.t(new pe(this.h,se),z);return this.e.$registerCallHierarchyProvider(oe,this.o(G,z)),this.p(oe)}$prepareCallHierarchy(z,G,se,oe){return this.s(z,pe,Z=>Promise.resolve(Z.prepareSession(C.URI.revive(G),se,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(z,G,se,oe){return this.s(z,pe,Z=>Z.provideCallsTo(G,se,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(z,G,se,oe){return this.s(z,pe,Z=>Z.provideCallsFrom(G,se,oe),void 0,oe)}$releaseCallHierarchy(z,G){this.s(z,pe,se=>Promise.resolve(se.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(z,G,se){const oe=this.t(new ue(this.h,se),z);return this.e.$registerTypeHierarchyProvider(oe,this.o(G,z)),this.p(oe)}$prepareTypeHierarchy(z,G,se,oe){return this.s(z,ue,Z=>Promise.resolve(Z.prepareSession(C.URI.revive(G),se,oe)),void 0,oe)}$provideTypeHierarchySupertypes(z,G,se,oe){return this.s(z,ue,Z=>Z.provideSupertypes(G,se,oe),void 0,oe)}$provideTypeHierarchySubtypes(z,G,se,oe){return this.s(z,ue,Z=>Z.provideSubtypes(G,se,oe),void 0,oe)}$releaseTypeHierarchy(z,G){this.s(z,ue,se=>Promise.resolve(se.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(z,G,se,oe){const Z=this.q();this.f.set(Z,new de(new fe(this.e,this.h,se,Z,z),z));const me=(0,t.$dF)(z,"dropMetadata")&&oe?fe.toInternalProviderId(z.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(G,z),me,(0,t.$dF)(z,"dropMetadata")?oe:void 0),this.p(Z)}$provideDocumentOnDropEdits(z,G,se,oe,Z,me){return this.s(z,fe,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(G,C.URI.revive(se),oe,Z,me)),void 0,void 0)}registerMappedEditsProvider(z,G,se){const oe=this.t(new te(this.h,se),z);return this.e.$registerMappedEditsProvider(oe,this.o(G,z)),this.p(oe)}$provideMappedEdits(z,G,se,oe,Z){return this.s(z,te,me=>Promise.resolve(me.provideMappedEdits(G,se,oe,Z)),null,Z)}registerDocumentPasteEditProvider(z,G,se,oe){const Z=this.q();this.f.set(Z,new de(new U(this.e,this.h,se,Z,z),z));const me=U.toInternalProviderId(z.identifier.value,oe.id);return this.e.$registerPasteEditProvider(Z,this.o(G,z),me,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(z,G,se,oe,Z){return this.s(z,U,me=>me.prepareDocumentPaste(C.URI.revive(G),se,oe,Z),void 0,Z)}$providePasteEdits(z,G,se,oe,Z,me){return this.s(z,U,Ee=>Ee.providePasteEdits(G,C.URI.revive(se),oe,Z,me),void 0,me)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:be.w(z.decreaseIndentPattern),increaseIndentPattern:be.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?be.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?be.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:be.w(z.beforeText),afterText:z.afterText?be.w(z.afterText):void 0,previousLineText:z.previousLineText?be.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(be.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(G=>L.SyntaxTokenType.toString(G)):void 0}}static D(z){return z.map(be.C)}setLanguageConfiguration(z,G,se){const{wordPattern:oe}=se;if(oe&&(0,E.$Oe)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(G,oe):this.h.setWordDefinitionFor(G,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const Z=this.q(),me={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?be.w(se.wordPattern):void 0,indentationRules:se.indentationRules?be.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?be.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?be.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,G,me),this.p(Z)}$setWordDefinitions(z){for(const G of z)this.h.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.$fcc=be}),define(De[318],Ce([1,0,6,13,7,38,8,3,26]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class v{constructor(I,w,y,k){this.c=w,this.d=y,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(C.$gK.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,w){await this.a.$changeLanguage(I,w);const y=this.c.getDocumentData(I);if(!y)throw new Error(`document '${I.toString()}' NOT found`);return y.document}async tokenAtPosition(I,w){const y=I.version,k=F.Position.from(w),p=await this.a.$tokensAtPosition(I.uri,k),u={type:d.StandardTokenType.Other,range:I.getWordRangeAtPosition(w)??new d.$kK(w.line,w.character,w.line,w.character)};if(!p)return u;const o={range:F.Range.to(p.range),type:F.TokenType.to(p.type)};return!o.range.contains(w)||y!==I.version?u:o}createLanguageStatusItem(I,w,y){const k=this.f++,p=this.a,u=this.g,o=`${I.identifier.value}/${w}`;if(u.has(o))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);u.add(o);const r={selector:y,id:w,name:I.displayName??I.name,severity:d.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let s;const m=new $.$Rc,h=()=>{if(s?.dispose(),!u.has(o)){console.warn(`LanguageStatusItem (${w}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}s=(0,A.$Vg)(()=>{m.clear(),this.a.$setLanguageStatus(k,{id:o,name:r.name??I.displayName??I.name,source:I.displayName??I.name,selector:F.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===d.LanguageStatusSeverity.Error?L.default.Error:r.severity===d.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:r.command&&this.d.toInternal(r.command,m),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},t={dispose(){m.dispose(),s?.dispose(),p.$removeLanguageStatus(k),u.delete(o)},get id(){return r.id},get name(){return r.name},set name(n){r.name=n,h()},get selector(){return r.selector},set selector(n){r.selector=n,h()},get text(){return r.text},set text(n){r.text=n,h()},set text2(n){(0,E.$eF)(I,"languageStatusText"),r.text=n,h()},get text2(){return(0,E.$eF)(I,"languageStatusText"),r.text},get detail(){return r.detail},set detail(n){r.detail=n,h()},get severity(){return r.severity},set severity(n){r.severity=n,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(n){r.accessibilityInformation=n,h()},get command(){return r.command},set command(n){r.command=n,h()},get busy(){return r.busy},set busy(n){r.busy=n,h()}};return h(),t}}e.$Zcc=v}),define(De[112],Ce([1,0,12,15,2,5,14,6,27,20]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0;let R=class{constructor(w,y,k){this.f=k,this.d=new Map,this.a=y.getProxy($.$gK.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===C.$g}getMessage(w,y){const{message:k,args:p,comment:u}=y;if(this.c)return(0,F.$De)(k,p??{});let o=k;u&&u.length>0&&(o+=`/${Array.isArray(u)?u.join(""):u}`);const r=this.d.get(w)?.contents[o];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,F.$De)(r??k,p??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let y;const k=await this.g(w);if(!k){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const p=await this.a.$fetchBundleContents(k),u=JSON.parse(p);y=w.isBuiltin?u.contents?.bundle:u}catch(p){this.f.error(`Failed to load translations for ${w.identifier.value} from ${k}: ${p.message}`);return}y&&this.d.set(w.identifier.value,{contents:y,uri:k})}async g(w){if(w.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(w.identifier.value,this.b);return d.URI.revive(y)}return w.l10n?d.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Occ=R,e.$Occ=R=He([Be(0,E.$xM),Be(1,v.$hM),Be(2,A.$0i)],R),e.$Pcc=(0,L.$Ph)("IExtHostLocalizationService")}),define(De[150],Ce([1,0,14,6,27,20,2,62]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;let E=class extends C.$ij{constructor(I,w){super(w.logLevel,w.logsLocation,w.loggers.map(y=>(0,$.$mh)(y))),this.r=I.getProxy(F.$gK.MainThreadLogger)}$setLogLevel(I,w){w?this.setLogLevel(A.URI.revive(w),I):this.setLogLevel(I)}setVisibility(I,w){super.setVisibility(I,w),this.r.$setVisibility(I,w)}s(I,w,y){return new v(this.r,I,w,y)}};e.$fec=E,e.$fec=E=He([Be(0,L.$hM),Be(1,d.$xM)],E);class v extends C.$dj{constructor(I,w,y,k){super(k?.logLevel==="always"),this.r=I,this.s=w,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(w,k).then(()=>{this.u(this.n),this.m=!0})}g(I,w){const y=[[I,w]];this.m?this.u(y):this.n.push(...y)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(De[113],Ce([1,0,6,5,3,20,22]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=void 0,e.$Qcc=(0,F.$Ph)("IExtHostManagedSockets");let $=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(C.$gK.MainThreadManagedSockets)}setFactory(I,w){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(I,w),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const w=++this.b,y=await this.c.makeConnection(),k=new d.$Rc;return this.d.set(w,new v(w,y,k)),k.add((0,d.$Qc)(()=>this.d.delete(w))),k.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(w),k.dispose()})),k.add(y.onDidClose(p=>{this.a.$onDidManagedSocketClose(w,p?.stack??p?.message),k.dispose()})),k.add(y.onDidReceiveMessage(p=>this.a.$onDidManagedSocketHaveData(w,A.$be.wrap(p)))),w}$remoteSocketWrite(I,w){this.d.get(I)?.actual.send(w.buffer)}$remoteSocketEnd(I){const w=this.d.get(I);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Rcc=$,e.$Rcc=$=He([Be(0,L.$hM)],$);class E{constructor(I,w){this.socketFactoryId=I,this.makeConnection=w}}class v extends d.$Sc{constructor(I,w,y){super(),this.socketId=I,this.actual=w,this.B(y)}}}),define(De[319],Ce([1,0,6,14,26]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;function L($){return $&&$.title}let A=class{constructor(E,v){this.b=v,this.a=E.getProxy(C.$gK.MainThreadMessageService)}showMessage(E,v,R,I,w){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let k;typeof I=="string"||L(I)?k=[I,...w]:(y.modal=I?.modal,y.useCustom=I?.useCustom,y.detail=I?.detail,k=w),y.useCustom&&(0,d.$eF)(E,"resolvers");const p=[];for(let u=0;u<k.length;u++){const o=k[u];if(typeof o=="string")p.push({title:o,handle:u,isCloseAffordance:!1});else if(typeof o=="object"){const{title:r,isCloseAffordance:s}=o;p.push({title:r,isCloseAffordance:!!s,handle:u})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(v,R,y,p).then(u=>{if(typeof u=="number")return k[u]})}};e.$1cc=A,e.$1cc=A=He([Be(1,F.$0i)],A)}),define(De[320],Ce([1,0,207,22,4,3,28,15,17,2,30,107,6,34,13,7,69,282,144,9,24,18]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,i,a,l,D){this.q=a,this.r=l,this.s=D,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new d.$Nd({onListenerError:s.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new d.$Nd({onListenerError:s.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new d.$Nd({onListenerError:s.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new d.$Nd({onListenerError:s.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$9bc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=c.getProxy(w.$gK.MainThreadNotebook),this.c=c.getProxy(w.$gK.MainThreadNotebookDocuments),this.d=c.getProxy(w.$gK.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const b=S.notebookEditor?.notebookUri,f=S.cell.handle,P=this.g.get(b)?.getCell(f);if(P)return P.apiCell}if(S&&S.$mid===14){const b=S.uri,f=this.g.get(b);if(f)return f.apiNotebook}return S}}),t.A(i)}getEditorById(c){const i=this.h.get(c);if(!i)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(c){for(const[i,a]of this.h)if(a.apiEditor===c)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,i){const a=this.g.get(c);if(!a&&!i)throw new Error(`NO notebook document for '${c}'`);return a}static t(c,i){if(!i)return;const a=i.filenamePattern.map(l=>k.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(i.filenamePattern&&!a){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:i.displayName,filenamePattern:a,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,i,a){const l=t.a++,D=typeof a.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(l,a),this.b.$registerNotebookCellStatusBarItemProvider(l,D,i);let S;return D!==void 0&&(S=a.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(D))),new p.$iK(()=>{this.f.delete(l),this.b.$unregisterNotebookCellStatusBarItemProvider(l,D),S?.dispose()})}async createNotebookDocument(c){const i=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&k.NotebookData.from(c.content)});return v.URI.revive(i)}async openNotebookDocument(c){const i=this.g.get(c);if(i)return i.apiNotebook;const a=await this.c.$tryOpenNotebook(c),l=this.g.get(v.URI.revive(a));return(0,E.$Jf)(l?.apiNotebook)}async showNotebookDocument(c,i){v.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let a;typeof i=="object"?a={position:k.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(k.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:a={preserveFocus:!1};const l=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,a),D=l&&this.h.get(l)?.apiEditor;if(D)return D;throw l?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,i,a,l){const D=this.f.get(c),S=v.URI.revive(i),b=this.g.get(S);if(!b||!D)return;const f=b.getCellFromIndex(a);if(!f)return;const g=await D.provideCellStatusBarItems(f.apiCell,l);if(!g)return;const P=new L.$Rc,N=this.p.add([P]),M=(Array.isArray(g)?g:[g]).map(j=>k.NotebookStatusBarItem.from(j,this.i,P));return{cacheId:N,items:M}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,i,a,l,D){if((0,$.$Be)(i))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:i,serializer:a,options:l}),this.b.$registerNotebookSerializer(S,{id:c.identifier,location:c.extensionLocation},i,k.NotebookDocumentContentOptions.from(l),t.t(c,D)),(0,L.$Qc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(c,i,a){const l=this.w.get(c);if(!l)throw new Error("NO serializer found");const D=await l.serializer.deserializeNotebook(i.buffer,a);return new u.$qv(k.NotebookData.from(D))}async $notebookToData(c,i,a){const l=this.w.get(c);if(!l)throw new Error("NO serializer found");const D=await l.serializer.serializeNotebook(k.NotebookData.to(i.value),a);return F.$be.wrap(D)}async $saveNotebook(c,i,a,l,D){const S=v.URI.revive(i),b=this.w.get(c);if(!b)throw new Error("NO serializer found");const f=this.g.get(S);if(!f)throw new Error("Document NOT found");if(f.versionId!==a)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new R.$tk((0,C.localize)(0,null,this.y(S)),6);await this.x(S,l);const g={metadata:(0,m.$cn)(f.apiNotebook.metadata,j=>!(b.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of f.apiNotebook.getCells()){const U=new p.$GL(j.kind,j.document.getText(),j.document.languageId,j.mime,b.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);U.metadata=(0,m.$cn)(j.metadata,T=>!(b.options?.transientCellMetadata??{})[T]),g.cells.push(U)}const P=await b.serializer.serializeNotebook(g,D);await this.s.value.writeFile(S,P);const N=this.s.getFileSystemProviderExtUri(S.scheme),O=await this.s.value.stat(S);return{name:N.basename(S),isFile:(O.type&R.FileType.File)!==0,isDirectory:(O.type&R.FileType.Directory)!==0,isSymbolicLink:(O.type&R.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((O.permissions??0)&R.FilePermission.Locked),etag:R.$Ek({mtime:O.mtime,size:O.size}),children:void 0}}async x(c,i){const a=await this.s.value.stat(c);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==R.$Dk&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==R.$Ek({mtime:i.mtime,size:a.size}))throw new R.$tk((0,C.localize)(1,null),3,i)}y(c){return c.scheme===h.Schemas.file?c.fsPath:c.toString()}z(c,i,a){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const l=new r.$Hdc(i,this.d,c,a.visibleRanges.map(k.NotebookRange.to),a.selections.map(k.NotebookRange.to),typeof a.viewColumn=="number"?k.ViewColumn.to(a.viewColumn):void 0);this.h.set(i,l)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const a of c.value.removedDocuments){const l=v.URI.revive(a),D=this.g.get(l);D&&(D.dispose(),this.g.delete(l),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:D.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(D.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===l.toString()&&this.h.delete(S.id)}if(c.value.addedDocuments){const a=[];for(const l of c.value.addedDocuments){const D=v.URI.revive(l.uri);if(this.g.has(D))throw new Error(`adding EXISTING notebook ${D} `);const S=new o.$Gdc(this.c,this.q,this.r,D,l);a.push(...l.cells.map(b=>o.$Fdc.asModelAddData(S.apiNotebook,b))),this.g.get(D)?.dispose(),this.g.set(D,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this.m.fire(S.apiNotebook)}}if(c.value.addedEditors)for(const a of c.value.addedEditors){if(this.h.has(a.id))return;const l=v.URI.revive(a.documentUri),D=this.g.get(l);D&&this.z(D,a.id,a)}const i=[];if(c.value.removedEditors)for(const a of c.value.removedEditors){const l=this.h.get(a);l&&(this.h.delete(a),this.k?.id===l.id&&(this.k=void 0),i.push(l))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(l=>this.h.get(l)).filter(l=>!!l);const a=new Set;this.l.forEach(l=>a.add(l.id));for(const l of this.h.values()){const D=a.has(l.id);l._acceptVisibility(D)}this.l=[...this.h.values()].map(l=>l).filter(l=>l.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(c){const i=y.$FM.String.with("notebookType","A notebook type"),a=new y.$HM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new y.$FM("data","Bytes to convert to data",D=>D instanceof Uint8Array,D=>F.$be.wrap(D))],new y.$GM("Notebook Data",D=>k.NotebookData.to(D.value))),l=new y.$HM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new y.$FM("NotebookData","Notebook data to convert to bytes",D=>!0,D=>new u.$qv(k.NotebookData.from(D)))],new y.$GM("Bytes",D=>D.buffer));c.registerApiCommand(a),c.registerApiCommand(l)}}e.$Idc=t}),define(De[321],Ce([1,0,19,8,21,4,3,28,2,25,14,6,34,13,7,110,276,26,69]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0;let s=class{constructor(l,D,S,b,f){this.l=D,this.m=S,this.n=b,this.o=f,this.b=new $.$Ac,this.c=new $.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new L.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=l.getProxy(I.$gK.MainThreadNotebookKernels);const g=new w.$HM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.$FM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const N=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:N}}else if(P&&"notebookEditor"in P){const N=this.m.getIdByEditor(P.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return P})],w.$GM.Void);this.n.registerApiCommand(g)}createNotebookController(l,D,S,b,f,g){for(const ae of this.i.values())if(ae.controller.id===D&&v.$6l.equals(l.identifier,ae.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const P=this.j++,N=this;this.o.trace(`NotebookController[${P}], CREATED by ${l.identifier.value}, ${D}`);const O=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${l.identifier}'`);let M=!1;const j=new L.$Nd,U=new L.$Nd,T={id:i(l.identifier,D),notebookType:S,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:b||l.identifier.value,preloads:g?g.map(y.NotebookRendererScript.from):[]};let K=f??O,q;this.a.$addKernel(P,T).catch(ae=>{console.log(ae),M=!0});let ge=0;const ee=()=>{if(M)return;const ae=++ge;Promise.resolve().then(()=>{ae===ge&&this.a.$updateKernel(P,T)})},Q=new $.$Ac,X={get id(){return D},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return T.label},set label(ae){T.label=ae??l.displayName??l.name,ee()},get detail(){return T.detail??""},set detail(ae){T.detail=ae,ee()},get description(){return T.description??""},set description(ae){T.description=ae,ee()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(ae){T.supportedLanguages=ae,ee()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){T.supportsExecutionOrder=ae,ee()},get rendererScripts(){return T.preloads?T.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(ae){K=ae??O},get interruptHandler(){return q},set interruptHandler(ae){q=ae,T.supportsInterrupt=!!ae,ee()},createNotebookCellExecution(ae){if(M)throw new Error("notebook controller is DISPOSED");if(!Q.has(ae.notebook.uri))throw N.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return N._createNotebookCellExecution(ae,i(l.identifier,this.id))},createNotebookExecution(ae){if((0,o.$eF)(l,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!Q.has(ae.uri))throw N.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return N._createNotebookExecution(ae,i(l.identifier,this.id))},dispose:()=>{M||(this.o.trace(`NotebookController[${P}], DISPOSED`),M=!0,this.i.delete(P),j.dispose(),U.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(ae,ie){ie===k.NotebookControllerAffinity2.Hidden&&(0,o.$eF)(l,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(P,ae.uri,ie)},onDidReceiveMessage:U.event,postMessage(ae,ie){return(0,o.$eF)(l,"notebookMessaging"),N.a.$postMessage(P,ie&&N.m.getIdByEditor(ie),ae)},asWebviewUri(ae){return(0,o.$eF)(l,"notebookMessaging"),(0,p.$9ob)(ae,N.l.remote)}};return this.i.set(P,{extensionId:l.identifier,controller:X,onDidReceiveMessage:U,onDidChangeSelection:j,associatedNotebooks:Q}),X}getIdByController(l){for(const[D,S]of this.i)if(S.controller===l)return i(S.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,D){const S=this.f++,b=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(S,D);const f={dispose:()=>{this.e.delete(S),b.a.$removeKernelDetectionTask(S)}};return this.e.set(S,f),f}registerKernelSourceActionProvider(l,D,S){const b=this.h++,f=typeof S.onDidChangeNotebookKernelSourceActions=="function"?b:void 0,g=this;this.g.set(b,S),this.o.trace(`NotebookKernelSourceActionProvider[${b}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(b,b,D);let P;return f!==void 0&&(P=S.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.g.delete(b),g.a.$removeKernelSourceActionProvider(b,b),P?.dispose()}}}async $provideKernelSourceActions(l,D){const S=this.g.get(l);if(S){const b=new A.$Rc;return(await S.provideNotebookKernelSourceActions(D)??[]).map(g=>y.NotebookKernelSourceAction.from(g,this.n.converter,b))}return[]}$acceptNotebookAssociation(l,D,S){const b=this.i.get(l);if(b){const f=this.m.getNotebookDocument(E.URI.revive(D));S?b.associatedNotebooks.set(f.uri,!0):b.associatedNotebooks.delete(f.uri),this.o.trace(`NotebookController[${l}] ASSOCIATE notebook`,f.uri.toString(),S),b.onDidChangeSelection.fire({selected:S,notebook:f.apiNotebook})}}async $executeCells(l,D,S){const b=this.i.get(l);if(!b)return;const f=this.m.getNotebookDocument(E.URI.revive(D)),g=[];for(const P of S){const N=f.getCell(P);N&&g.push(N.apiCell)}try{this.o.trace(`NotebookController[${l}] EXECUTE cells`,f.uri.toString(),g.length),await b.controller.executeHandler.call(b.controller,g,f.apiNotebook,b.controller)}catch(P){this.o.error(`NotebookController[${l}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(l,D,S){const b=this.i.get(l);if(!b)return;const f=this.m.getNotebookDocument(E.URI.revive(D));if(b.controller.interruptHandler)await b.controller.interruptHandler.call(b.controller,f.apiNotebook);else for(const g of S){const P=f.getCell(g);P&&this.b.get(P.uri)?.cancel()}if(b.controller.interruptHandler){const g=this.c.get(f.uri);S.length&&Array.isArray(g)&&g.length&&g.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(l,D,S){const b=this.i.get(l);if(!b)return;const f=this.m.getEditorById(D);b.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:S}))}$cellExecutionChanged(l,D,S){const f=this.m.getNotebookDocument(E.URI.revive(l)).getCell(D);if(f){const g=S?y.NotebookCellExecutionState.to(S):k.NotebookCellExecutionState.Idle;g!==void 0&&this.k.fire({cell:f.apiCell,state:g})}}_createNotebookCellExecution(l,D){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const b=this.m.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!b)throw new Error("invalid cell");if(this.b.has(b.uri))throw new Error(`duplicate execution for ${b.uri}`);const f=new h(D,b,this.a);this.b.set(b.uri,f);const g=f.onDidChangeState(()=>{f.state===m.Resolved&&(f.dispose(),g.dispose(),this.b.delete(b.uri))});return f.asApiObject()}_createNotebookExecution(l,D){const S=this.m.getNotebookDocument(l.uri),b=l.getCells().find(P=>{const N=S.getCellFromApiCell(P);return N&&this.b.has(N.uri)});if(b)throw new Error(`duplicate cell execution for ${b.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const f=new n(D,S,this.a),g=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),g.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[f,g]),f.asApiObject()}};e.$Wdc=s,e.$Wdc=s=He([Be(4,R.$0i)],s);var m;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(m||(m={}));class h extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(l,D,S){super(),this.m=D,this.n=S,this.b=h.a++,this.c=new L.$Nd,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.B(new d.$Xd),this.h=new c(10,b=>this.s(b)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const D=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new r.$qv(D))}t(){if(this.f===m.Init)throw new Error("Must call start before modifying cell output");if(this.f===m.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let D=this.m;if(l&&(D=this.m.notebook.getCellFromApiCell(l)),!D)throw new Error("INVALID cell");return D.handle}y(l){return l.map(D=>{const S=k.$JL.ensureUniqueMimeTypes(D.items,!0);return S===D.items?y.NotebookCellOutput.from(D):y.NotebookCellOutput.from({items:S,id:D.id,metadata:D.metadata})})}async z(l,D,S){const b=this.w(D),f=this.y((0,C.$3b)(l));return this.r({editType:u.CellExecutionUpdateType.Output,cellHandle:b,append:S,outputs:f})}async C(l,D,S){return l=k.$JL.ensureUniqueMimeTypes((0,C.$3b)(l),!0),this.r({editType:u.CellExecutionUpdateType.OutputItems,items:l.map(y.NotebookCellOutputItem.from),outputId:D.id,append:S})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(S){l.j=S,l.s([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(S){if(l.f===m.Resolved||l.f===m.Started)throw new Error("Cannot call start again");l.f=m.Started,l.c.fire(),l.s({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,b){if(l.f===m.Resolved)throw new Error("Cannot call resolve twice");l.f=m.Resolved,l.c.fire(),l.h.flush(),l.n.$completeExecution(l.b,new r.$qv({runEndTime:b,lastRunSuccess:S}))},clearOutput(S){return l.t(),l.z([],S,!1)},appendOutput(S,b){return l.t(),l.z(S,b,!0)},replaceOutput(S,b){return l.t(),l.z(S,b,!1)},appendOutputItems(S,b){return l.t(),l.C(S,b,!0)},replaceOutputItems(S,b){return l.t(),l.C(S,b,!1)}})}}var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class n extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(l,D,S){super(),this.h=D,this.j=S,this.b=n.a++,this.c=new L.$Nd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new d.$Xd),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(l,D){this.e=l,this.f=D,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new F.$ch,this.b=Date.now(),(0,F.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const D=this.a;return this.a=[],this.f(D).finally(()=>l.complete())}}function i(a,l){return`${a.value}/${l}`}e.$Xdc=i}),define(De[322],Ce([1,0,4,6,144]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class L{constructor($,E){this.c=E,this.a=new Map,this.b=$.getProxy(F.$gK.MainThreadNotebookRenderers)}$postRendererMessage($,E,v){const R=this.c.getEditorById($);this.a.get(E)?.fire({editor:R.apiEditor,message:v})}createRendererMessaging($,E){if(!$.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,I,w)=>this.d(E).event(R,I,w),postMessage:(R,I)=>{d.$Hdc.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const w=I&&d.$Hdc.apiEditorsToExtHost.get(I);return this.b.$postMessage(w?.id,E,R)}}}d($){let E=this.a.get($);return E||(E=new C.$Nd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete($)}}),this.a.set($,E),E)}}e.$Ydc=L}),define(De[323],Ce([1,0,3,17,2,26,6]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;class ${constructor(v){this.b=new Map,this.a=v.getProxy(A.$gK.MainThreadProfileContentHandlers)}registrProfileContentHandler(v,R,I){if((0,L.$eF)(v,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,I),this.a.$registerProfileContentHandler(R,I.name,I.description,v.identifier.value),(0,C.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(v,R,I,w){const y=this.b.get(v);if(!y)throw new Error(`Unknown handler with id: ${v}`);return y.saveProfile(R,I,w)}async $readProfile(v,R,I){const w=this.b.get(v);if(!w)throw new Error(`Unknown handler with id: ${v}`);return w.readProfile((0,F.$yf)(R)?R:d.URI.revive(R),I)}}e.$3dc=$}),define(De[324],Ce([1,0,2,6,8,13]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;class A{static{this.a=0}constructor(E,v){this.d=v,this.c=new Map,this.b=E.getProxy(F.$gK.MainThreadQuickDiff)}$provideOriginalResource(E,v,R){const I=C.URI.revive(v),w=this.c.get(E);return w?(0,d.$Mg)(()=>w.provideOriginalResource(I,R)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,v,R,I){const w=A.a++;return this.c.set(w,v),this.b.$registerQuickDiffProvider(w,L.DocumentSelector.from(E,this.d),R,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(w),this.c.delete(w)}}}}e.$4dc=A}),define(De[325],Ce([1,0,21,4,3,6,2,7,9,19,38,59,26,13]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;function k(p,u,o){const r=p.getProxy(L.$gK.MainThreadQuickOpen);class s{constructor(D,S){this.e=new Map,this.f=0,this.a=D,this.b=S}showQuickPick(D,S,b,f=C.CancellationToken.None){this.c=void 0;const g=Promise.resolve(S),P=++this.f,N=r.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},f),O={},M=N.then(()=>O);return Promise.race([M,g]).then(j=>{if(j===O)return;const U=(0,w.$dF)(D,"quickPickItemTooltip");return g.then(T=>{const K=[];for(let q=0;q<T.length;q++){const ge=T[q];if(typeof ge=="string")K.push({label:ge,handle:q});else if(ge.kind===$.QuickPickItemKind.Separator)K.push({type:"separator",label:ge.label});else{ge.tooltip&&!U&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const ee=ge.iconPath?c(ge.iconPath):void 0;K.push({label:ge.label,iconPath:ee?.iconPath,iconClass:ee?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:U?y.MarkdownString.fromStrict(ge.tooltip):void 0,handle:q})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=q=>{b.onDidSelectItem(T[q])}),r.$setItems(P,K),N.then(q=>{if(typeof q=="number")return T[q];if(Array.isArray(q))return q.map(ge=>T[ge])})})}).then(void 0,j=>{if(!(0,E.$4)(j))return r.$setError(P,j),Promise.reject(j)})}$onItemSelected(D){this.c?.(D)}showInput(D,S=C.CancellationToken.None){return this.d=D?.validateInput,r.$input(D,typeof this.d=="function",S).then(void 0,b=>{if(!(0,E.$4)(b))return Promise.reject(b)})}async $validateInput(D){if(!this.d)return;const S=await this.d(D);if(!S||typeof S=="string")return S;let b;switch(S.severity){case $.InputBoxValidationSeverity.Info:b=R.default.Info;break;case $.InputBoxValidationSeverity.Warning:b=R.default.Warning;break;case $.InputBoxValidationSeverity.Error:b=R.default.Error;break;default:b=S.message?R.default.Error:R.default.Ignore;break}return{content:S.message,severity:b}}async showWorkspaceFolderPick(D,S=C.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!b)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(g=>g.uri.toString()===b.uri.toString())}createQuickPick(D){const S=new i(D,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(D){const S=new a(D,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(D,S){this.e.get(D)?._fireDidChangeValue(S)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,S){const b=this.e.get(D);b instanceof i&&b._fireDidChangeActive(S)}$onDidChangeSelection(D,S){const b=this.e.get(D);b instanceof i&&b._fireDidChangeSelection(S)}$onDidTriggerButton(D,S){this.e.get(D)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(D,S,b){const f=this.e.get(D);f instanceof i&&f._fireDidTriggerItemButton(S,b)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class m{static{this.a=1}constructor(D,S){this.x=D,this.y=S,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Nd,this.q=new F.$Nd,this.r=new F.$Nd,this.s=new F.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((S,b)=>{const f=S===$.$CL.Back?-1:b;this.o.set(f,S)}),this.z({buttons:D.map((S,b)=>({...c(S.iconPath),tooltip:S.tooltip,handle:S===$.$CL.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const S=this.o.get(D);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,d.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(D){if(!this.v){for(const S of Object.keys(D)){const b=D[S];this.u[S]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function h(l){if(l instanceof $.$cL)return{id:l.id};const D=n(l),S=t(l);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof S=="string"?A.URI.file(S):S}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function n(l){return typeof l=="object"&&"dark"in l?l.dark:l}function c(l){const D=h(l);let S,b;return"id"in D?b=I.ThemeIcon.asClassName(D):S=D,{iconPath:S,iconClass:b}}class i extends m{constructor(D,S){super(D.identifier,S),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Nd,this.L=[],this.M=new F.$Nd,this.N=new F.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((f,g)=>{this.C.set(g,f),this.D.set(f,g)});const S=(0,w.$dF)(this.O,"quickPickItemTooltip"),b=[];for(let f=0;f<D.length;f++){const g=D[f];if(g.kind===$.QuickPickItemKind.Separator)b.push({type:"separator",label:g.label});else{g.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=g.iconPath?c(g.iconPath):void 0;b.push({handle:f,label:g.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:S?y.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((N,O)=>({...c(N.iconPath),tooltip:N.tooltip,handle:O}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(D){const S=(0,v.$Hb)(D.map(b=>this.C.get(b)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(D){const S=(0,v.$Hb)(D.map(b=>this.C.get(b)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(D,S){const b=this.C.get(D);if(!b||!b.buttons||!b.buttons.length)return;const f=b.buttons[S];f&&this.N.fire({button:f,item:b})}}class a extends m{constructor(D,S){super(D.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new s(u,o)}e.$5cc=k}),define(De[326],Ce([1,0,2,4,57,3,8,6,19,126,14,25,59,13,26,18]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=void 0;function o(f){if(f)return typeof f.iconPath=="string"?C.URI.file(f.iconPath):C.URI.isUri(f.iconPath)||w.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function r(f){if(f.icon){if(C.URI.isUri(f.icon))return f.icon;if(w.ThemeIcon.isThemeIcon(f.icon))return f.icon;{const g=f.icon;return{light:g.light,dark:g.dark}}}else return}function s(f,g){if(!f.iconPath&&!g.iconPath)return 0;if(f.iconPath){if(!g.iconPath)return 1}else return-1;const P=typeof f.iconPath=="string"?f.iconPath:C.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,N=typeof g.iconPath=="string"?g.iconPath:C.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,v.$sq)(P,N)}function m(f,g){let P=0;if(f.strikeThrough!==g.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==g.faded)return f.faded?1:-1;if(f.tooltip!==g.tooltip)return(f.tooltip||"").localeCompare(g.tooltip||"");if(P=s(f,g),P!==0)return P;if(f.light&&g.light)P=s(f.light,g.light);else{if(f.light)return 1;if(g.light)return-1}if(P!==0)return P;if(f.dark&&g.dark)P=s(f.dark,g.dark);else{if(f.dark)return 1;if(g.dark)return-1}return P}function h(f,g){if(f.command!==g.command)return f.command<g.command?-1:1;if(f.title!==g.title)return f.title<g.title?-1:1;if(f.tooltip!==g.tooltip){if(f.tooltip!==void 0&&g.tooltip!==void 0)return f.tooltip<g.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(f.arguments===g.arguments)return 0;if(f.arguments)if(g.arguments){if(f.arguments.length!==g.arguments.length)return f.arguments.length-g.arguments.length}else return 1;else return-1;for(let P=0;P<f.arguments.length;P++){const N=f.arguments[P],O=g.arguments[P];if(N!==O)return N<O?-1:1}return 0}function t(f,g){let P=(0,v.$sq)(f.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(P!==0)return P;if(f.command&&g.command)P=h(f.command,g.command);else{if(f.command)return 1;if(g.command)return-1}if(P!==0)return P;if(f.decorations&&g.decorations)P=m(f.decorations,g.decorations);else{if(f.decorations)return 1;if(g.decorations)return-1}return P}function n(f,g){for(let P=0;P<f.length;P++)if(f[P]!==g[P])return!1;return!0}function c(f,g){return f.command===g.command&&f.title===g.title&&f.tooltip===g.tooltip&&(f.arguments&&g.arguments?n(f.arguments,g.arguments):f.arguments===g.arguments)}function i(f,g){return(0,E.$ub)(f,g,c)}function a(f,g){return f===g?!0:!f||!g?!1:f.id===g.id&&f.label===g.label&&f.upstream?.id===g.upstream?.id&&f.upstream?.label===g.upstream?.label}class l{#e;#t;get value(){return this.d}set value(g){g=g??"",this.#e.$setInputBoxValue(this.l,g),this.n(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){this.#e.$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,k.$eF)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,k.$eF)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,this.#e.$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,this.#e.$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,this.#e.$setInputBoxVisibility(this.l,g))}get document(){return(0,k.$eF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(g,P,N,O,M){this.k=g,this.l=O,this.m=M,this.d="",this.e=new F.$Nd,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=N}showValidationMessage(g,P){(0,k.$eF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,g,P)}$onInputBoxValueChange(g){this.n(g)}n(g){this.d=g,this.e.fire(g)}}e.$6cc=l;class D{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,P,N,O,M){this.q=g,this.s=P,this.t=N,this.u=O,this.v=M,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=D.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,P){const N=this.h.get(g);return N?(0,A.$Mg)(()=>this.s.executeCommand(N.command,...N.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(t),N=(0,E.$Db)(this.o,g,t).map(j=>{const U=j.toInsert.map(T=>{const K=this.e++;this.g.set(K,T);const q=T.resourceUri;let ge;if(T.command)if(T.command.command==="vscode.open"||T.command.command==="vscode.diff"){const J=new L.$Rc;ge=this.s.converter.toInternal(T.command,J),this.j.set(K,J)}else this.h.set(K,T.command);const ee=o(T.decorations),Q=T.decorations&&o(T.decorations.light)||ee,X=T.decorations&&o(T.decorations.dark)||ee,ae=[Q,X],ie=T.decorations&&T.decorations.tooltip||"",ce=T.decorations&&!!T.decorations.strikeThrough,we=T.decorations&&!!T.decorations.faded,H=T.contextValue||"";return{rawResource:[K,q,ae,ie,ce,we,H,ge],handle:K}});return{start:j.start,deleteCount:j.deleteCount,toInsert:U}}),O=N.map(({start:j,deleteCount:U,toInsert:T})=>[j,U,T.map(K=>K.rawResource)]),M=N.reverse();for(const{start:j,deleteCount:U,toInsert:T}of M){const K=T.map(ge=>ge.handle),q=this.n.splice(j,U,...K);for(const ge of q)this.g.delete(ge),this.h.delete(ge),this.j.get(ge)?.dispose(),this.j.delete(ge)}return this.o=g,O}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,this.#e.$updateSourceControl(this.x,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g;let P;(0,k.$dF)(this.y,"quickDiffProvider")&&(P=g?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!g,quickDiffLabel:P})}get historyProvider(){return(0,k.$eF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(g){(0,k.$eF)(this.y,"scmHistoryProvider"),this.j=g,this.k.value=new L.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!g}),g&&(this.k.value.add(g.onDidChangeCurrentHistoryItemGroup(()=>{a(this.l,g?.currentHistoryItemGroup)||(this.l=g?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(g.onDidChangeActionButton(()=>{(0,k.$eF)(this.y,"scmActionButton"),this.m.value=new L.$Rc;const P=g.actionButton!==void 0?{command:this.z.converter.toInternal(g.actionButton.command,this.m.value),description:g.actionButton.description,enabled:g.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(g){g!==this.n&&(this.n=g,this.#e.$updateSourceControl(this.x,{commitTemplate:g}))}get acceptInputCommand(){return this.p}set acceptInputCommand(g){this.o.value=new L.$Rc,this.p=g;const P=this.z.converter.toInternal(g,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,k.$eF)(this.y,"scmActionButton"),this.s}set actionButton(g){(0,k.$eF)(this.y,"scmActionButton"),this.q.value=new L.$Rc,this.s=g;const P=g!==void 0?{command:this.z.converter.toInternal(g.command,this.q.value),secondaryCommands:g.secondaryCommands?.map(N=>N.map(O=>this.z.converter.toInternal(O,this.q.value))),description:g.description,enabled:g.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(g){if(this.u&&g&&i(this.u,g))return;this.t.value=new L.$Rc,this.u=g;const P=(g||[]).map(N=>this.z.converter.toInternal(N,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(g,P,N,O,M,j,U){this.y=g,this.z=O,this.A=M,this.B=j,this.C=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Tc,this.m=new L.$Tc,this.n=void 0,this.o=new L.$Tc,this.p=void 0,this.q=new L.$Tc,this.t=new L.$Tc,this.u=void 0,this.v=!1,this.w=new F.$Nd,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=N;const T=C.URI.from({scheme:p.Schemas.vscodeSourceControl,path:`${M}/scm${this.x}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new l(g,P,this.#e,this.x,T),this.#e.$registerSourceControl(this.x,M,j,U,T)}createResourceGroup(g,P){const N=new D(this.#e,this.z,this.x,g,P),O=F.Event.once(N.onDidDispose)(()=>this.D.delete(N));return this.D.set(N,O),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const g=[],P=[];for(const[N,O]of this.D){O.dispose();const M=N.onDidUpdateResourceStates(()=>{this.E.add(N),this.eventuallyUpdateResourceStates()});F.Event.once(N.onDidDispose)(()=>{this.E.delete(N),M.dispose(),this.e.delete(N.handle),this.#e.$unregisterGroup(this.x,N.handle)}),g.push([N.handle,N.id,N.label,N.features]);const j=N._takeResourceStateSnapshot();j.length>0&&P.push([N.handle,j]),this.e.set(N.handle,N)}this.#e.$registerGroups(this.x,g,P),this.D.clear()}eventuallyUpdateResourceStates(){const g=[];this.E.forEach(P=>{const N=P._takeResourceStateSnapshot();N.length!==0&&g.push([P.handle,N])}),g.length>0&&this.#e.$spliceResourceStates(this.x,g),this.E.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.v=g,this.w.fire(g)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(g=>g.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,d.$ih)(100)],S.prototype,"eventuallyAddResourceGroups",null),He([(0,d.$ih)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{u=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(g,P,N,O){this.l=P,this.m=N,this.n=O,this.g=new Map,this.h=new I.$8l,this.j=new F.$Nd,this.e=g.getProxy($.$gK.MainThreadSCM),this.f=g.getProxy($.$gK.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const j=this.g.get(M.sourceControlHandle);if(!j)return M;const U=j.getResourceGroup(M.groupHandle);return U?U.getResourceState(M.handle):M}else if(M&&M.$mid===4){const j=this.g.get(M.sourceControlHandle);return j?j.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const j=this.g.get(M.handle);return j||M}return M}})}createSourceControl(g,P,N,O){this.n.trace("ExtHostSCM#createSourceControl",g.identifier.value,P,N,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const M=u.d++,j=new S(g,this.m,this.e,this.l,P,N,O);this.g.set(M,j);const U=this.h.get(g.identifier)||[];return U.push(j),this.h.set(g.identifier,U),j}getLastInputBox(g){this.n.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const P=this.h.get(g.identifier),N=P&&P[P.length-1];return N&&N.inputBox}$provideOriginalResource(g,P,N){const O=C.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",g,O.toString());const M=this.g.get(g);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Mg)(()=>M.quickDiffProvider.provideOriginalResource(O,N)).then(j=>j||null)}$onInputBoxValueChange(g,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",g);const N=this.g.get(g);return N&&N.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(g,P,N,O){this.n.trace("ExtHostSCM#$executeResourceCommand",g,P,N);const M=this.g.get(g);if(!M)return Promise.resolve(void 0);const j=M.getResourceGroup(P);return j?j.$executeResourceCommand(N,O):Promise.resolve(void 0)}$validateInput(g,P,N){this.n.trace("ExtHostSCM#$validateInput",g);const O=this.g.get(g);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Mg)(()=>O.inputBox.validateInput(P,N)).then(M=>{if(!M)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(M.message);return j?Promise.resolve([j,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(g,P,N){return await this.g.get(g)?.historyProvider?.resolveHistoryItemGroupBase(P,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(g,P,N,O){return await this.g.get(g)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,N,O)??void 0}async $provideHistoryItems(g,P,N,O){return(await this.g.get(g)?.historyProvider?.provideHistoryItems(P,N,O))?.map(U=>({id:U.id,parentIds:U.parentIds,label:U.label,description:U.description,icon:r(U),timestamp:U.timestamp}))??void 0}async $provideHistoryItemChanges(g,P,N){return await this.g.get(g)?.historyProvider?.provideHistoryItemChanges(P,N)??void 0}};e.$7cc=b,e.$7cc=b=u=He([Be(3,R.$0i)],b)}),define(De[114],Ce([1,0,6,4,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=e.$Lcc=void 0;class L{constructor($){this.b=new F.$Nd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(C.$gK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,E){return this.a.$getPassword($,E)}store($,E,v){return this.a.$setPassword($,E,v)}delete($,E){return this.a.$deletePassword($,E)}}e.$Lcc=L,e.$Mcc=(0,d.$Ph)("IExtHostSecretState")}),define(De[327],Ce([1,0,6,13,2]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;class L{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(C.$gK.MainThreadShare)}async $provideShare($,E,v){return await this.c.get($)?.provideShare({selection:F.Range.to(E.selection),resourceUri:d.URI.revive(E.resourceUri)},v)??void 0}registerShareProvider($,E){const v=L.a++;return this.c.set(v,E),this.b.$registerShareProvider(v,F.DocumentSelector.from($,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(v),this.c.delete(v)}}}}e.$9dc=L}),define(De[328],Ce([1,0,21,3,6]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class L{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(d.$gK.MainThreadSpeech)}async $createSpeechToTextSession($,E){const v=this.c.get($);if(!v)return;const R=new F.$Rc,I=new C.$Xd;this.d.set(E,I);const w=R.add(v.provideSpeechToTextSession(I.token));R.add(w.onDidChange(y=>{I.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,y)})),R.add(I.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,E,v){const R=L.a++;return this.c.set(R,v),this.b.$registerProvider(R,E,{extension:$,displayName:$.value}),(0,F.$Qc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$$dc=L}),define(De[329],Ce([1,0,7,6,209,3,13,17]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$dL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$dL("statusBarItem.warningForeground")]])}#e;#t;constructor(w,y,k,p,u,o=C.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new L.$Rc,this.#e=w,this.#t=y,u&&p){this.c=(0,C.$SK)(p.identifier,u);const s=k.get(this.c);s&&(o=s.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,r=s.priority,this.j=!0,this.name=s.name,this.text=s.text,this.tooltip=s.tooltip,this.command=s.command,this.accessibilityInformation=s.accessibilityInformation)}else this.c=String(E.a++);this.e=p,this.f=u,this.g=o,this.h=this.u(r)}u(w){if((0,$.$Cf)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!E.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new L.$Rc,typeof w=="string"?this.r={fromApi:w,internal:this.#t.toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:this.#t.toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let y;this.m?y=this.m:y=(0,d.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=E.b.get(this.o.id));const p=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,w,this.e?.identifier.value,y,this.k,p,this.r?.internal,k,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$8cc=E;class v{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,d.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const y={message:w};return this.b.unshift(y),this.c(),new C.$iK(()=>{const k=this.b.indexOf(y);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(w,y){this.e=new Map,this.a=w.getProxy(F.$gK.MainThreadStatusBar),this.b=y,this.c=new v(this)}$acceptStaticEntries(w){for(const y of w)this.e.set(y.entryId,y)}createStatusBarEntry(w,y,k,p){return new E(this.a,this.b,this.e,w,y,k,p)}setStatusBarMessage(w,y){const k=this.c.setMessage(w);let p;return typeof y=="number"?p=setTimeout(()=>k.dispose(),y):typeof y<"u"&&y.then(()=>k.dispose(),()=>k.dispose()),new C.$iK(()=>{k.dispose(),clearTimeout(p)})}}e.$9cc=R}),define(De[115],Ce([1,0,6,4,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0;class L{constructor($,E){this.c=E,this.b=new F.$Nd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(C.$gK.MainThreadStorage)}registerExtensionStorageKeysToSync($,E){this.a.$registerExtensionStorageKeysToSync($,E)}async initializeExtensionStorage($,E,v){const R=await this.a.$initializeExtensionStorage($,E);let I;return R&&(I=this.d($,E,R)),I||v}setValue($,E,v){return this.a.$setValue($,E,v)}$acceptValue($,E,v){const R=this.d($,E,v);R&&this.b.fire({shared:$,key:E,value:R})}d($,E,v){try{return JSON.parse(v)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${$}): ${R}`)}}}e.$zcc=L,e.$Acc=(0,d.$Ph)("IExtHostStorage")}),define(De[90],Ce([1,0,5,27,14,72,2]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=e.$Fcc=void 0,e.$Fcc=(0,C.$Ph)("IExtensionStoragePaths");let $=class{constructor(v,R,I){this.d=R,this.f=I,this.a=v.workspace??void 0,this.b=v.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(v){return A.URI.joinPath(this.b.workspaceStorageHome,v)}async h(){if(!this.a)return Promise.resolve(void 0);const v=this.a.id,R=await this.g(v);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(v){if(this.c)return A.URI.joinPath(this.c,v.identifier.value)}globalValue(v){return A.URI.joinPath(this.b.globalStorageHome,v.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Gcc=$,e.$Gcc=$=He([Be(0,F.$xM),Be(1,d.$0i),Be(2,L.$Ecc)],$)}),define(De[45],Ce([1,0,4,6,5,2,20,3,7,211,9,253,21,31,254,59,8,13,34]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=e.$Icc=e.$Hcc=void 0,e.$Hcc=(0,d.$Ph)("IExtHostTerminalService");class s{constructor(b,f,g,P){this.l=b,this._id=f,this.m=g,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(O=>this.f=O);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(O,M=!0){N.q(),N.l.$sendText(N._id,O,M)},show(O){N.q(),N.l.$show(N._id,O)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(b,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??void 0,env:b.env??void 0,icon:a(b.iconPath)??void 0,color:p.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.o(b.location,f?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,f,g,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:g,color:p.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(b,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(b,f){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in b?{viewColumn:o.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.n=b}setExitStatus(b,f){this.h=Object.freeze({code:b,reason:f})}setDimensions(b,f){return b===this.d&&f===this.g||b===0||f===0?!1:(this.d=b,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(b){this.k=b}_setProcessId(b){this.f?(this.f(b),this.f=void 0):this.b.then(f=>{f!==b&&(this.b=Promise.resolve(b))})}}e.$Icc=s;class m{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new C.$Nd,this.onProcessData=this.a.event,this.b=new C.$Nd,this.d=new C.$Nd,this.onDidChangeProperty=this.d.event,this.f=new C.$Nd,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,f){this.g.setDimensions?.({columns:b,rows:f})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends $.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,f,g){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new C.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new C.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new C.$Nd,this.onDidChangeShell=this.N.event,this.O=new C.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=g.getProxy(F.$gK.MainThreadTerminalService),this.y=new k.$Tkb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:P=>{const N=O=>{const M=O;return this.W(M.instanceId)?.value};switch(P?.$mid){case 15:return N(P);default:{if(Array.isArray(P))for(let O=0;O<P.length&&P[O].$mid===15;O++)P[O]=N(P[O]);return P}}}}),this.B({dispose:()=>{for(const[P,N]of this.g)N.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,f){const g=new s(this.a,(0,y.$eg)(),b,b.name),P=new m(b.pty);return g.createExtensionTerminal(b.location,this.R(b,f).resolvedExtHostIdentifier,a(b.iconPath),l(b.color)).then(N=>{const O=this.S(N,P);this.h[N]=O}),this.f.push(g),g.value}R(b,f){if(f=f||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const g=b.location.parentTerminal;if(g){const P=this.f.find(N=>N.value===g);P&&(f.resolvedExtHostIdentifier=P._id)}}else b.location&&typeof b.location!="object"?f.location=b.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(b,f){if(!this.W(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const P=new m(f),N=this.S(b,P);this.h[b]=N}async $acceptActiveTerminalChanged(b){const f=this.b;if(b===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const g=this.W(b);g&&(this.b=g,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,f){const g=this.W(b);g&&this.O.fire({terminal:g.value,data:f})}async $acceptTerminalDimensions(b,f,g){const P=this.W(b);P&&P.setDimensions(f,g)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(b,f){const g=this.W(b);g&&this.P.fire({terminal:g.value,...f})}async $acceptTerminalMaximumDimensions(b,f,g){this.g.get(b)?.resize(f,g)}async $acceptTerminalTitleChange(b,f){const g=this.W(b);g&&(g.name=f)}async $acceptTerminalClosed(b,f,g){const P=this.Y(this.f,b);if(P!==null){const N=this.f.splice(P,1)[0];N.setExitStatus(f,g),this.H.fire(N.value)}}$acceptTerminalOpened(b,f,g,P){if(f){const M=this.Y(this.f,f);if(M!==null){this.f[M]._id=b,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},O=new s(this.a,b,N,g);this.f.push(O),this.I.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(b,f){this.W(b)?._setProcessId(f)}async $startExtensionTerminal(b,f){const g=this.W(b);if(!g)return{message:(0,v.localize)(0,null,b)};g.isOpen||await new Promise(N=>{const O=this.onDidOpenTerminal(async M=>{M===g.value&&(O.dispose(),N())})});const P=this.g.get(b);P?P.startSendingEvents(f):this.j[b]={initialDimensions:f}}S(b,f){const g=new $.$Rc;g.add(f.onProcessReady(N=>this.a.$sendProcessReady(b,N.pid,N.cwd,N.windowsPty))),g.add(f.onDidChangeProperty(N=>this.a.$sendProcessProperty(b,N))),this.y.startBuffering(b,f.onProcessData),g.add(f.onProcessExit(N=>this.U(b,N))),this.g.set(b,f);const P=this.j[b];return P&&f instanceof m&&(f.startSendingEvents(P.initialDimensions),delete this.j[b]),g}$acceptProcessAckDataEvent(b,f){this.g.get(b)?.acknowledgeDataEvent(f)}$acceptProcessInput(b,f){this.g.get(b)?.input(f)}$acceptTerminalInteraction(b){const f=this.W(b);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection(b,f){this.W(b)?.setSelection(f)}$acceptProcessResize(b,f,g){try{this.g.get(b)?.resize(f,g)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(b,f){this.g.get(b)?.shutdown(f)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(f=>this.a.$sendProcessProperty(b,{type:"cwd",value:f}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new E.$iK(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,f,g){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,g),this.a.$registerProfileProvider(f,b.identifier.value),new E.$iK(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(b,f,g){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,g),this.a.$registerQuickFixProvider(b,f),new E.$iK(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,f){const g=new w.$Xd().token;if(g.isCancellationRequested)return;const P=this.D.get(b);if(!P)return;const N=await P.provideTerminalQuickFixes(f,g);if(N===null||Array.isArray(N)&&N.length===0)return;const O=new $.$Rc;if(this.w.value=O,!Array.isArray(N))return N?o.TerminalQuickFix.from(N,this.Q.converter,O):void 0;const M=[];for(const j of N){const U=o.TerminalQuickFix.from(j,this.Q.converter,O);U&&M.push(U)}return M}async $createContributedProfileTerminal(b,f){const g=new w.$Xd().token;let P=await this.C.get(b)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,f);return}this.createTerminalFromOptions(P.options,f)}}async $provideLinks(b,f){const g=this.W(b);if(!g)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const N=new w.$Xd;this.G.set(b,N);const O=[],M={terminal:g.value,line:f},j=[];for(const K of this.z)j.push(u.Promises.withAsyncBody(async q=>{N.token.onCancellationRequested(()=>q({provider:K,links:[]}));const ge=await K.provideTerminalLinks(M,N.token)||[];N.token.isCancellationRequested||q({provider:K,links:ge})}));const U=await Promise.all(j);if(N.token.isCancellationRequested)return[];const T=new Map;for(const K of U)K&&K.links.length>0&&O.push(...K.links.map(q=>{const ge={id:h++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return T.set(ge.id,{provider:K.provider,link:q}),ge}));return this.F.set(b,T),O}$activateLink(b,f){const g=this.F.get(b)?.get(f);g&&g.provider.handleTerminalLink(g.link)}U(b,f){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const g=this.h[b];g&&(g.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,f)}W(b){return this.X(this.f,b)}X(b,f){const g=this.Y(b,f);return g!==null?b[g]:null}Y(b,f){const g=b.findIndex(P=>P._id===f);return g===-1?null:g}getEnvironmentVariableCollection(b){let f=this.n.get(b.identifier.value);return f||(f=new n,this.$(b.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Z(b,f){const g=(0,I.$lr)(f.map),P=(0,I.$mr)(f.descriptionMap);this.a.$setEnvironmentVariableCollection(b,f.persistent,g.length===0?void 0:g,P)}$initEnvironmentVariableCollections(b){b.forEach(f=>{const g=f[0],P=new n(f[1]);this.$(g,P)})}$acceptDefaultProfile(b,f){const g=this.s;this.s=b,this.u=f,g?.path!==b.path&&this.N.fire(b.path)}$(b,f){this.n.set(b,f),f.onDidChangeCollection(()=>{this.Z(b,f)})}};e.$Jcc=t,e.$Jcc=t=He([Be(1,r.$DM),Be(2,A.$hM)],t);class n{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$Nd,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const f=this.h(b);let g=this.a.get(f);return g||(g=new c(this,b),this.a.set(f,g),g.onDidChangeCollection(()=>this.d.fire())),g}replace(b,f,g,P){this.f(b,{value:f,type:E.EnvironmentVariableMutatorType.Replace,options:g??{applyAtProcessCreation:!0},scope:P})}append(b,f,g,P){this.f(b,{value:f,type:E.EnvironmentVariableMutatorType.Append,options:g??{applyAtProcessCreation:!0},scope:P})}prepend(b,f,g,P){this.f(b,{value:f,type:E.EnvironmentVariableMutatorType.Prepend,options:g??{applyAtProcessCreation:!0},scope:P})}f(b,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const g=this.g(b,f.scope),P=this.map.get(g),N=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==f.value||P.type!==f.type||P.options?.applyAtProcessCreation!==N.applyAtProcessCreation||P.options?.applyAtShellIntegration!==N.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const O=this.g(b,f.scope),M={variable:b,...f,options:N};this.map.set(O,M),this.d.fire()}}get(b,f){const g=this.g(b,f),P=this.map.get(g);return P?D(P):void 0}g(b,f){const g=this.h(f);return g.length?`${b}:::${g}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const f=new Map;for(const[g,P]of this.map)this.h(P.scope)===this.h(b)&&f.set(P.variable,D(P));return f}delete(b,f){const g=this.g(b,f);this.map.delete(g),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[f,g]of this.map)g.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(f);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,f){const g=this.h(f),P=this.descriptionMap.get(g);if(!P||P.description!==b){let N;typeof b=="string"?N=b:N=b?.value.split(`

`)[0];const O={description:N,scope:f};this.descriptionMap.set(g,O),this.d.fire()}}getDescription(b){const f=this.h(b);return this.descriptionMap.get(f)?.description}k(b){const f=this.h(b);this.descriptionMap.delete(f)}}class c{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,f){this.b=b,this.d=f,this.a=new C.$Nd}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,f,g){this.b.replace(b,f,g,this.d)}append(b,f,g){this.b.append(b,f,g,this.d)}prepend(b,f,g){this.b.prepend(b,f,g,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,f){this.b.getVariableMap(this.d).forEach((g,P)=>b.call(f,P,g,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor(b,f){super(!1,b,f)}createTerminal(b,f,g){throw new R.$_}createTerminalFromOptions(b,f){throw new R.$_}};e.$Kcc=i,e.$Kcc=i=He([Be(0,r.$DM),Be(1,A.$hM)],i);function a(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function l(S){return p.ThemeColor.isThemeColor(S)?S:void 0}function D(S){const b={...S};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(De[330],Ce([1,0,118,8,22,21,4,75,52,3,24,17,31,6,20,145,13,7,68,109,87,26]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=e.$Tdc=e.$Sdc=e.$Rdc=void 0;let t=class{constructor(M,j,U){this.k=U,this.d=new A.$Nd,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=M.getProxy(y.$gK.MainThreadTesting),this.j=new g(this.g),this.h=new a(this.g),j.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const K=T,q=K.tests[K.tests.length-1].item.extId;return this.f.get(r.$_I.root(q))?.collection.tree.get(q)?.actual??(0,p.$tM)(T)}case 18:{const{extId:K,message:q}=T;return{test:this.f.get(r.$_I.root(K))?.collection.tree.get(K)?.actual,message:u.TestMessage.to(q)}}default:return T}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await j.executeCommand("_testing.getExplorerSelection"),K=q=>{const ge=this.f.get(r.$_I.root(q));if(ge)return r.$_I.isRoot(q)?ge.controller:ge.collection.tree.get(q)?.actual};return{include:T?.include.map(K).filter(I.$Gf)||[],exclude:T?.exclude.map(K).filter(I.$Gf)||[]}})}createTestController(M,j,U,T){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const K=new v.$Rc,q=K.add(new p.$wM(j,U,this.k));q.root.label=U;const ge=new Map,ee=this.g,Q={items:q.root.children,get label(){return U},set label(ae){U=ae,q.root.label=ae,ee.$updateController(j,{label:U})},get refreshHandler(){return T},set refreshHandler(ae){T=ae,ee.$updateController(j,{canRefresh:!!ae})},get id(){return j},createRunProfile:(ae,ie,ce,we,H,B)=>{let J=(0,E.$Di)(ae);for(;ge.has(J);)J++;return new P(this.g,ge,j,J,ae,ie,ce,we,H,B)},createTestItem(ae,ie,ce){return new p.$uM(j,ae,ie,ce)},createTestRun:(ae,ie,ce=!0)=>this.h.createTestRun(M,j,q,ae,ie,ce),invalidateTestResults:ae=>{if(ae===void 0)this.g.$markTestRetired(void 0);else{const ie=ae instanceof Array?ae:[ae];this.g.$markTestRetired(ie.map(ce=>r.$_I.fromExtHostTestItem(ce,j).toString()))}},set resolveHandler(ae){q.resolveHandler=ae},get resolveHandler(){return q.resolveHandler},dispose:()=>{K.dispose()}};ee.$registerTestController(j,U,!!T),K.add((0,v.$Qc)(()=>ee.$unregisterTestController(j)));const X={controller:Q,collection:q,profiles:ge,extension:M};return this.f.set(j,X),K.add((0,v.$Qc)(()=>this.f.delete(j))),K.add(q.onDidGenerateDiff(ae=>ee.$publishDiff(j,ae.map(m.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.j.checkout()}async runTests(M,j=L.CancellationToken.None){const U=l(M);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.f.get(U.controllerId);if(!T)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(K=>r.$_I.fromExtHostTestItem(K,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:N[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:M.exclude?.map(K=>K.id)},j)}$syncTests(){for(const{collection:M}of this.f.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,j,U){return(0,C.$rb)(this.h.trackers,K=>K.id===M?K.getCoverage(j):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(M,j,U,T){return(0,C.$rb)(this.h.trackers,q=>q.id===M?q.getCoverage(j):void 0)?.resolveFileCoverage(U,T)??Promise.resolve([])}$configureRunProfile(M,j){this.f.get(M)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(M,j){await this.f.get(M)?.controller.refreshHandler?.(j)}$publishTestResults(M){this.results=Object.freeze(M.map(j=>(0,R.$8m)(u.TestResults.to(j))).concat(this.results).sort((j,U)=>U.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(M,j){const U=this.f.get(r.$_I.fromString(M).controllerId)?.collection;U&&(await U.expand(M,j<0?1/0:j),U.flushDiff())}$acceptDiff(M){this.j.applyDiff(M.map(m.TestsDiffOp.deserialize))}async $runControllerTests(M,j){return Promise.all(M.map(U=>this.l(U,!1,j)))}async $startContinuousRun(M,j){const U=new L.$Xd(j),T=await Promise.all(M.map(K=>this.l(K,!0,U.token)));return!j.isCancellationRequested&&!T.some(K=>K.error)&&await new Promise(K=>j.onCancellationRequested(K)),U.dispose(!0),T}async l(M,j,U){const T=this.f.get(M.controllerId);if(!T)return{};const{collection:K,profiles:q,extension:ge}=T,ee=q.get(M.profileId);if(!ee)return{};const Q=M.testIds.map(ce=>K.tree.get(ce)).filter(I.$Gf),X=M.excludeExtIds.map(ce=>T.collection.tree.get(ce)).filter(I.$Gf).filter(ce=>Q.some(we=>we.fullId.compare(ce.fullId)===2));if(!Q.length)return{};const ae=new o.$QL(Q.some(ce=>ce.actual instanceof p.$vM)?void 0:Q.map(ce=>ce.actual),X.map(ce=>ce.actual),ee,j),ie=(0,m.$bJ)(M)&&this.h.prepareForMainThreadTestRun(ae,D.fromInternal(M,T.collection),ge,U);try{return await ee.runHandler(ae,U),{}}catch(ce){return{error:String(ce)}}finally{ie&&(ie.hasRunningTasks&&!U.isCancellationRequested&&await A.Event.toPromise(ie.onEnd),ie.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.h.cancelAllRuns():this.h.cancelRunById(M)}};e.$Rdc=t,e.$Rdc=t=He([Be(0,k.$hM)],t);const n=1e4;var c;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(c||(c={}));class i extends v.$Sc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(M,j,U,T){super(),this.s=M,this.u=j,this.w=U,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Nd),this.onEnd=this.m.event,this.j=this.B(new L.$Xd(T));const K=this.B(new F.$6g(()=>this.y(),n));this.B(this.j.token.onCancellationRequested(()=>K.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(M){return this.g.get(M)?.coverage}createRun(M){const j=this.s.id,U=this.s.controllerId,T=(0,w.$eg)(),K=new S(this.u,j,T),q=X=>(ae,...ie)=>{if(ee){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ae)&&(this.C(ae),X(ae,...ie))},ge=(X,ae)=>{const ie=ae instanceof Array?ae.map(u.TestMessage.from):[u.TestMessage.from(ae)];if(ie.some(ce=>ce.contextValue!==void 0)&&(0,h.$eF)(this.w,"testMessageContextValue"),X.uri&&X.range){const ce={range:u.Range.from(X.range),uri:X.uri};for(const we of ie)we.location=we.location||ce}this.u.$appendTestMessagesInRun(j,T,r.$_I.fromExtHostTestItem(X,U).toString(),ie)};let ee=!1;const Q={isPersisted:this.s.isPersisted,token:this.j.token,name:M,get coverageProvider(){return K.coverageProvider},set coverageProvider(X){K.coverageProvider=X},enqueued:q(X=>{this.u.$updateTestStateInRun(j,T,r.$_I.fromExtHostTestItem(X,U).toString(),1)}),skipped:q(X=>{this.u.$updateTestStateInRun(j,T,r.$_I.fromExtHostTestItem(X,U).toString(),5)}),started:q(X=>{this.u.$updateTestStateInRun(j,T,r.$_I.fromExtHostTestItem(X,U).toString(),2)}),errored:q((X,ae,ie)=>{ge(X,ae),this.u.$updateTestStateInRun(j,T,r.$_I.fromExtHostTestItem(X,U).toString(),6,ie)}),failed:q((X,ae,ie)=>{ge(X,ae),this.u.$updateTestStateInRun(j,T,r.$_I.fromExtHostTestItem(X,U).toString(),4,ie)}),passed:q((X,ae)=>{this.u.$updateTestStateInRun(j,T,r.$_I.fromExtHostTestItem(X,this.s.controllerId).toString(),3,ae)}),appendOutput:(X,ae,ie)=>{ee||(ie&&(this.s.isIncluded(ie)?this.C(ie):ie=void 0),this.u.$appendOutputToRun(j,T,d.$be.fromString(X),ae&&u.location.from(ae),ie&&r.$_I.fromExtHostTestItem(ie,U).toString()))},end:()=>{ee||(ee=!0,this.u.$finishedTestRunTask(j,T),this.g.delete(T),this.g.size||this.z())}};return this.g.set(T,{run:Q,coverage:K}),this.u.$startedTestRunTask(j,{id:T,name:M,running:!0}),Q}y(){for(const{run:M}of this.g.values())M.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(M){if(!(M instanceof p.$uM))throw new s.$_L(M.id);if(this.h.has(r.$_I.fromExtHostTestItem(M,this.s.controllerId).toString()))return;const j=[],U=this.s.colllection.root;for(;;){const T=u.TestItem.from(M);if(j.unshift(T),this.h.has(T.extId)||(this.h.add(T.extId),M===U))break;M=M.parent||U}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class a{get trackers(){return this.d.values()}constructor(M){this.f=M,this.d=new Map}prepareForMainThreadTestRun(M,j,U,T){return this.g(M,j,U,T)}cancelRunById(M){for(const j of this.d.values())if(j.id===M){j.cancel();return}}cancelAllRuns(){for(const M of this.d.values())M.cancel()}createTestRun(M,j,U,T,K,q){const ge=this.d.get(T);if(ge)return ge.createRun(K);const ee=D.fromPublic(j,U,T,q),Q=l(T);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!T.continuous,profile:Q&&{group:N[Q.kind],id:Q.profileId},exclude:T.exclude?.map(ae=>r.$_I.fromExtHostTestItem(ae,U.root.id).toString())??[],id:ee.id,include:T.include?.map(ae=>r.$_I.fromExtHostTestItem(ae,U.root.id).toString())??[U.root.id],persist:q});const X=this.g(T,ee,M);return A.Event.once(X.onEnd)(()=>{this.f.$finishedExtensionTestRun(ee.id),X.dispose()}),X.createRun(K)}g(M,j,U,T){const K=new i(j,this.f,U,T);return this.d.set(M,K),A.Event.once(K.onEnd)(()=>this.d.delete(M)),K}}e.$Sdc=a;const l=O=>{if(O.profile){if(!(O.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class D{static fromPublic(M,j,U,T){return new D(M,(0,w.$eg)(),U.include?.map(K=>r.$_I.fromExtHostTestItem(K,M).toString())??[M],U.exclude?.map(K=>r.$_I.fromExtHostTestItem(K,M).toString())??[],T,j)}static fromInternal(M,j){return new D(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,j)}constructor(M,j,U,T,K,q){this.controllerId=M,this.id=j,this.isPersisted=K,this.colllection=q,this.d=U.map(ge=>ge+"\0"),this.f=T.map(ge=>ge+"\0")}isIncluded(M){const j=r.$_I.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const U of this.f)if(j===U||j.startsWith(U))return!1;for(const U of this.d)if(j===U||j.startsWith(U))return!0;return!1}}e.$Tdc=D;class S{set coverageProvider(M){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.d=M,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(M,j,U){this.g=M,this.h=j,this.j=U}async provideFileCoverage(M){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(M))());try{return(await this.f)?.map(u.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(M,j){const U=await this.f;let T=U?.[M];return!this.d||!U||!T?[]:(T.detailedCoverage||(T=U[M]=await this.d.resolveFileCoverage?.(T,j)??T),T.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(M){this.j=M,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(M){this.d.add(M)}update(M){Object.assign(M.revived,u.TestItem.toPlain(M.item)),this.d.has(M)||this.f.add(M)}remove(M){if(this.d.has(M)){this.d.delete(M);return}this.f.delete(M);const j=r.$_I.parentId(M.item.extId);if(j&&this.h.has(j.toString())){this.h.add(M.item.extId);return}this.g.add(M)}getChangeEvent(){const{d:M,f:j,g:U}=this;return{get added(){return[...M].map(T=>T.revived)},get updated(){return[...j].map(T=>T.revived)},get removed(){return[...U].map(T=>T.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends m.$gJ{constructor(){super(...arguments),this.s=new A.$Nd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(M){return this.f.get(M)}getMirroredTestDataByReference(M){return this.f.get(M.id)}q(M,j){return{...M,revived:u.TestItem.toPlain(M.item),depth:j?j.depth+1:0,children:new Set}}p(){return new b(this.s)}}class g{constructor(M){this.f=M}checkout(){this.d||(this.d=this.g());const M=this.d;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(j=>j.revived)},dispose:(0,$.$db)(()=>{--M.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(M){return this.d?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.d?.tests.apply(M)}g(){const M=new f;return this.f.$subscribeToDiffs(),{observers:0,tests:M}}}class P{#e;#t;get label(){return this.f}set label(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(M){M!==this.h&&(this.h=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.g}set isDefault(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?u.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.d}set configureHandler(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,j,U,T,K,q,ge,ee=!1,Q=void 0,X=!1){this.controllerId=U,this.profileId=T,this.f=K,this.kind=q,this.runHandler=ge,this.g=ee,this._tag=Q,this.h=X,this.#e=M,this.#t=j,j.set(T,this);const ae=N[q];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);this.#e.$publishTestRunProfile({profileId:T,controllerId:U,tag:Q?u.TestTag.namespace(this.controllerId,Q.id):null,label:K,group:ae,isDefault:ee,hasConfigurationHandler:!1,supportsContinuousRun:X})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Udc=P;const N={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(De[331],Ce([1,0,19,9,4,6,146,13,7]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class v{constructor(I,w){this.i=w,this.a=new d.$Nd({onListenerError:F.$2}),this.b=new d.$Nd({onListenerError:F.$2}),this.c=new d.$Nd({onListenerError:F.$2}),this.d=new d.$Nd({onListenerError:F.$2}),this.f=new d.$Nd({onListenerError:F.$2}),this.g=new d.$Nd({onListenerError:F.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(L.$gK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const w=this.i.allEditors();return I?w:w.map(y=>y.value)}async showTextDocument(I,w,y){let k;typeof w=="number"?k={position:$.ViewColumn.from(w),preserveFocus:y}:typeof w=="object"?k={position:$.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?$.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:k={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(I.uri,k),u=p&&this.i.getEditor(p);if(u)return u.value;throw p?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,w){return new A.$oM(this.h,I,w).value}$acceptEditorPropertiesChanged(I,w){const y=this.i.getEditor(I);if(!y)throw new Error("unknown text editor");if(w.options&&y._acceptOptions(w.options),w.selections){const k=w.selections.selections.map($.Selection.to);y._acceptSelections(k)}if(w.visibleRanges){const k=C.$Hb(w.visibleRanges.map($.Range.to));y._acceptVisibleRanges(k)}if(w.options&&this.b.fire({textEditor:y.value,options:{...w.options,lineNumbers:$.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const k=E.TextEditorSelectionChangeKind.fromValue(w.selections.source),p=w.selections.selections.map($.Selection.to);this.a.fire({textEditor:y.value,selections:p,kind:k})}if(w.visibleRanges){const k=C.$Hb(w.visibleRanges.map($.Range.to));this.c.fire({textEditor:y.value,visibleRanges:k})}}$acceptEditorPositionData(I){for(const w in I){const y=this.i.getEditor(w);if(!y)throw new Error("Unknown text editor");const k=$.ViewColumn.to(I[w]);y.value.viewColumn!==k&&(y._acceptViewColumn(k),this.d.fire({textEditor:y.value,viewColumn:k}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$0cc=v}),define(De[332],Ce([1,0,2,5,6,3,7,13,25,17]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=void 0,e.$Ldc=(0,F.$Ph)("IExtHostTimeline");class R{constructor(y,k){this.b=new Map,this.c=new Map,this.a=y.getProxy(d.$gK.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(p,u)=>{if(p&&p.$mid===12)if(this.b.get(p.source)&&E.$6l.equals(u,this.b.get(p.source)?.extension)){const o=p.uri===void 0?void 0:C.URI.revive(p.uri);return this.c.get(p.source)?.get(I(o))?.get(p.handle)}else return;return p}})}async $getTimeline(y,k,p,u){return this.b.get(y)?.provider.provideTimeline(C.URI.revive(k),p,u)}registerTimelineProvider(y,k,p,u){const o=new L.$Rc,r=this.d(k.id,u,o).bind(this);let s;k.onDidChange&&(s=k.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:k.id}),this));const m=this.c;return this.f({...k,scheme:y,onDidChange:void 0,async provideTimeline(h,t,n){t?.resetCache&&(o.clear(),m.get(k.id)?.clear());const c=await k.provideTimeline(h,t,n);if(c==null)return;const i=r(h,t);return{...c,source:k.id,items:c.items.map(i)}},dispose(){for(const h of m.values())h.get(k.id)?.clear();s?.dispose(),o.dispose()}},p)}d(y,k,p){return(u,o)=>{let r;if(o?.cacheResults){let s=this.c.get(y);s===void 0&&(s=new Map,this.c.set(y,s));const m=I(u);r=s.get(m),r===void 0&&(r=new Map,s.set(m,r))}return s=>{const{iconPath:m,...h}=s,t=`${y}|${s.id??s.timestamp}`;r?.set(t,s);let n,c,i;s.iconPath&&(m instanceof A.$cL?i={id:m.id,color:m.color}:C.URI.isUri(m)?(n=m,c=m):{light:n,dark:c}=m);let a;return A.$IK.isMarkdownString(h.tooltip)?a=$.MarkdownString.from(h.tooltip):(0,v.$yf)(h.tooltip)?a=h.tooltip:A.$IK.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=$.MarkdownString.from(h.detail)):(0,v.$yf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=h.detail),{...h,id:h.id??void 0,handle:t,source:y,command:s.command?k.toInternal(s.command,p):void 0,icon:n,iconDark:c,themeIcon:i,tooltip:a,accessibilityInformation:s.accessibilityInformation}}}}f(y,k){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:k}),(0,L.$Qc)(()=>{for(const u of this.c.values())u.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$Mdc=R;function I(w){return w?.toString()}}),define(De[73],Ce([1,0,21,4,3,213,5,14,86,6,27,20,7]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7vb=e.$6vb=e.TunnelDtoConverter=void 0;class y extends E.$gv{}var k;(function(u){function o(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public,privacy:s.privacy??(s.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:s.protocol}}u.fromApiTunnel=o;function r(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.privacy!==E.TunnelPrivacyId.ConstantPrivate&&s.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:s.privacy,protocol:s.protocol}}u.fromServiceTunnel=r})(k||(e.TunnelDtoConverter=k={})),e.$6vb=(0,A.$Ph)("IExtHostTunnelService");let p=class extends d.$Sc{constructor(o,r,s){super(),this.s=s,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(v.$gK.MainThreadTunnelService)}async openTunnel(o,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const s=await this.a.$openTunnel(r,o.displayName);if(s){const m=new y(s.remoteAddress,s.localAddress,()=>this.a.$closeTunnel(s.remoteAddress));return this.B(m),m}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,r){const s=this.u();return this.r.set(s,{selector:o,provider:r}),this.a.$registerPortsAttributesProvider(o,s),new w.$iK(()=>{this.r.delete(s),this.a.$unregisterPortsAttributesProvider(s)})}async $providePortAttributes(o,r,s,m,h){const t=[];for(const c of o){const i=this.r.get(c);if(!i)return[];t.push(...await Promise.all(r.map(async a=>{let l;try{l=await i.provider.providePortAttributes({port:a,pid:s,commandLine:m},h)}catch{l=await i.provider.providePortAttributes(a,s,m,h)}return{providedAttributes:l,port:a}})))}const n=t.filter(c=>!!c.providedAttributes);return n.length>0?n.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(m,h)=>await o.provideTunnel(m,h,new C.$Xd().token)??void 0;const s=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(s),Promise.resolve((0,d.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,r){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const s=o.tunnelFactory??(r?this.w(r):void 0);if(s){this.b=s;let m=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const h=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:m}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,d.$Qc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,r){if(this.g.has(o.host)){const s=this.g.get(o.host);s.has(o.port)&&(r&&s.get(o.port).disposeListener.dispose(),await s.get(o.port).tunnel.dispose(),s.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const s=this.b(o,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),s!==void 0){const m=await s;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),m===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const h=this.B(m.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(m.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:m,disposeListener:h}),k.fromApiTunnel(m)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(s){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),s instanceof Error)return s.message}}async $applyCandidateFilter(o){const r=await Promise.all(o.map(m=>this.f(m.host,m.port,m.detail??""))),s=o.filter((m,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(m=>m.port).join(", ")} to ${s.map(m=>m.port).join(", ")}`),s}};e.$7vb=p,e.$7vb=p=He([Be(0,I.$hM),Be(1,R.$xM),Be(2,$.$0i)],p)}),define(De[333],Ce([1,0,3,18,2,6]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class A{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(L.$gK.MainThreadUriOpeners)}registerExternalUriOpener(E,v,R,I){if(this.c.has(v))throw new Error(`Opener with id '${v}' already registered`);const w=I.schemes.find(y=>!A.a.has(y));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(v,R),this.b.$registerUriOpener(v,I.schemes,E,I.label),(0,C.$Qc)(()=>{this.c.delete(v),this.b.$unregisterUriOpener(v)})}async $canOpenUri(E,v,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const w=d.URI.revive(v);return I.canOpenExternalUri(w,R)}async $openUri(E,v,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(d.URI.revive(v.resolvedUri),{sourceUri:d.URI.revive(v.sourceUri)},R)}}e.$Vdc=A}),define(De[334],Ce([1,0,6,2,3,9,25]),function($e,e,C,F,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class ${static{this.a=0}constructor(v){this.c=new A.$7l,this.d=new Map,this.b=v.getProxy(C.$gK.MainThreadUrls)}registerUriHandler(v,R){const I=v.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const w=$.a++;return this.c.add(I),this.d.set(w,R),this.b.$registerUriHandler(w,I,v.displayName||v.name),(0,d.$Qc)(()=>{this.c.delete(I),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(v,R){const I=this.d.get(v);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(R))}catch(w){(0,L.$1)(w)}return Promise.resolve(void 0)}async createAppUri(v){return F.URI.revive(await this.b.$createAppUri(v))}}e.$_cc=$}),define(De[91],Ce([1,0,4,3,18,24,2,228,265,110,6]),function($e,e,C,F,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=e.$ddc=e.$cdc=e.$bdc=e.$adc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(m,h,t,n,c,i,a){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new C.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$Nd,this._onDidDispose=this.#h.event,this.#e=m,this.#t=h,this.#r=t,this.#l=n,this.#u=c,this.#n=i,this.#c=w(i),this.#d=y(i),this.#i=a}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,v.$9ob)(m,this.#l)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===d.Schemas.https||m.scheme===d.Schemas.http){let h=m.toString();return h.endsWith("/")||(h+="/"),h+" "+v.$8ob}return v.$8ob}get html(){return this.a(),this.#s}set html(m){this.a(),this.#s!==m&&(this.#s=m,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(m)))}get options(){return this.a(),this.#r}set options(m){this.a(),L.$$m(this.#r,m)||this.#t.$setOptions(this.#e,u(this.#n,this.#u,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const h=(0,E.$zcb)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(m){if(!this.#d)return m;const h=this.#n.extensionLocation?.scheme===d.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===d.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,c,i,a,l,D)=>{const S=A.URI.from({scheme:a||"file",path:decodeURIComponent(l)}),b=(0,v.$9ob)(S,{isRemote:h,authority:t}).toString();return`${c}${b}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,c,i,a,l,D)=>{const S=A.URI.from({scheme:a||"file",path:decodeURIComponent(l)}),b=(0,v.$9ob)(S,{isRemote:h,authority:t}).toString();return`${c}${b}${D}`})}}e.$adc=I;function w(s){try{const m=(0,$.$Oo)((0,$.$No)(s.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.$bdc=w;function y(s){try{const m=(0,$.$Oo)((0,$.$No)(s.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class k extends F.$Sc{constructor(m,h,t,n,c){super(),this.c=h,this.f=t,this.g=n,this.h=c,this.b=new Map,this.a=m.getProxy(R.$gK.MainThreadWebviews)}dispose(){super.dispose();for(const m of this.b.values())m.dispose();this.b.clear()}$onMessage(m,h,t){const n=this.j(m);if(n){const{message:c}=(0,E.$Acb)(h,t.value);n._onMessageEmitter.fire(c)}}$onMissingCsp(m,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,h,t){const n=new I(m,this.a,o(h),this.c,this.f,t,this.h);this.b.set(m,n);const c=n._onDidDispose(()=>{c.dispose(),this.deleteWebview(m)});return n}deleteWebview(m){this.b.delete(m)}j(m){return this.b.get(m)}}e.$cdc=k;function p(s){return{id:s.identifier,location:s.extensionLocation}}e.$ddc=p;function u(s,m,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||r(s,m)}}e.$edc=u;function o(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(m=>A.URI.from(m))}}function r(s,m){return[...(m?.getWorkspaceFolders()||[]).map(h=>h.uri),s.extensionLocation]}}),define(De[335],Ce([1,0,21,52,3,18,23,2,13,91,107,6,7]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class y{constructor(n,c){this.document=n,this.b=c,this.a=1,this.c=new R.$9bc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,c){await this.f(n).undo(),c||this.disposeBackup()}async redo(n,c){await this.f(n).redo(),c||this.disposeBackup()}disposeEdits(n){for(const c of n)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=h(this.document.uri)+this.a++;return(0,A.$vg)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const c=this.c.get(n,0);if(!c)throw new Error("No edit found");return c}}class k{constructor(){this.a=new Map}get(n,c){return this.a.get(this.b(n,c))}add(n,c,i){const a=this.b(n,c.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${n} resource:${c.uri}`);const l=new y(c,i);return this.a.set(a,l),l}delete(n,c){const i=this.b(n,c.uri);this.a.delete(i)}b(n,c){return`${n}@@@${c}`}}var p;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(p||(p={}));class u{constructor(){this.a=new Map}addTextProvider(n,c,i){return this.b(0,n,c,i)}addCustomProvider(n,c,i){return this.b(1,n,c,i)}get(n){return this.a.get(n)}b(n,c,i,a){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:n,extension:i,provider:a}),new w.$iK(()=>this.a.delete(c))}}class o{constructor(n,c,i,a,l){this.d=c,this.f=i,this.g=a,this.h=l,this.b=new u,this.c=new k,this.a=n.getProxy(I.$gK.MainThreadCustomEditors)}registerCustomEditorProvider(n,c,i,a){const l=new d.$Rc;return s(i)?(l.add(this.b.addTextProvider(c,n,i)),this.a.$registerTextEditorProvider((0,v.$ddc)(n),c,a.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,v.$bdc)(n))):(l.add(this.b.addCustomProvider(c,n,i)),r(i)&&l.add(i.onDidChangeCustomDocument(D=>{const S=this.i(c,D.document.uri);if(m(D)){const b=S.addEdit(D);this.a.$onDidEdit(D.document.uri,c,b,D.label)}else this.a.$onContentChange(D.document.uri,c)})),this.a.$registerCustomEditorProvider((0,v.$ddc)(n),c,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,v.$bdc)(n))),w.$iK.from(l,new w.$iK(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(n,c,i,a,l){const D=this.b.get(c);if(!D)throw new Error(`No provider found for '${c}'`);if(D.type!==1)throw new Error(`Invalid provide type for '${c}'`);const S=$.URI.revive(n),b=await D.provider.openCustomDocument(S,{backupId:i,untitledDocumentData:a?.buffer},l);let f;return r(D.provider)&&this.f&&(f=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(c,b,f),{editable:r(D.provider)}}async $disposeCustomDocument(n,c){const i=this.b.get(c);if(!i)throw new Error(`No provider found for '${c}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${c}'`);const a=$.URI.revive(n),{document:l}=this.i(c,a);this.c.delete(c,l),l.dispose()}async $resolveCustomEditor(n,c,i,a,l,D){const S=this.b.get(i);if(!S)throw new Error(`No provider found for '${i}'`);const b=E.ViewColumn.to(l),f=this.g.createNewWebview(c,a.contentOptions,S.extension),g=this.h.createNewWebviewPanel(c,i,a.title,b,a.options,f,a.active),P=$.URI.revive(n);switch(S.type){case 1:{const{document:N}=this.i(i,P);return S.provider.resolveCustomEditor(N,g,D)}case 0:{const N=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(N,g,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,c,i){this.i(c,n).disposeEdits(i)}async $onMoveCustomEditor(n,c,i){const a=this.b.get(i);if(!a)throw new Error(`No provider found for '${i}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const l=this.h.getWebviewPanel(n);if(!l)throw new Error("No webview found");const D=$.URI.revive(c),S=this.d.getDocument(D);await a.provider.moveCustomTextEditor(S,l,C.CancellationToken.None)}async $undo(n,c,i,a){return this.i(c,n).undo(i,a)}async $redo(n,c,i,a){return this.i(c,n).redo(i,a)}async $revert(n,c,i){const a=this.i(c,n);await this.j(c).revertCustomDocument(a.document,i),a.disposeBackup()}async $onSave(n,c,i){const a=this.i(c,n);await this.j(c).saveCustomDocument(a.document,i),a.disposeBackup()}async $onSaveAs(n,c,i,a){const l=this.i(c,n);return this.j(c).saveCustomDocumentAs(l.document,$.URI.revive(i),a)}async $backup(n,c,i){const a=this.i(c,n),D=await this.j(c).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},i);return a.updateBackup(D),D.id}i(n,c){const i=this.c.get(n,$.URI.revive(c));if(!i)throw new Error("No custom document found");return i}j(n){const i=this.b.get(n)?.provider;if(!i||!r(i))throw new Error("Custom document is not editable");return i}}e.$Pdc=o;function r(t){return!!t.onDidChangeCustomDocument}function s(t){return typeof t.resolveCustomTextEditor=="function"}function m(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const n=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Di)(n)+""}}),define(De[336],Ce([1,0,4,3,2,31,13,91,6,7]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class R extends F.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(k,p,u,o){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new C.$Nd),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$Nd),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=p,this.#l=u,this.#i=o.viewType,this.#u=o.panelOptions,this.#r=o.viewColumn,this.#n=o.title,this.#a=o.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(k){this.c(),this.#n!==k&&(this.#n=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#s}set iconPath(k){this.c(),this.#s!==k&&(this.#s=k,this.#t.$setIconPath(this.#e,d.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(k){this.#c||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#a=k.active,this.#o=k.visible,this.#r=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,p){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:A.ViewColumn.from(k),preserveFocus:!!p})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends F.$Sc{static c(){return(0,L.$eg)()}constructor(k,p,u){super(),this.j=p,this.m=u,this.g=new Map,this.h=new Map,this.f=k.getProxy(E.$gK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,p,u,o,r={}){const s=typeof o=="object"?o.viewColumn:o,m={viewColumn:A.ViewColumn.from(s),preserveFocus:typeof o=="object"&&!!o.preserveFocus},h=(0,$.$bdc)(k),t=I.c();this.f.$createWebviewPanel((0,$.$ddc)(k),t,p,{title:u,panelOptions:w(r),webviewOptions:(0,$.$edc)(k,this.m,r),serializeBuffersForPostMessage:h},m);const n=this.j.createNewWebview(t,r,k);return this.createNewWebviewPanel(t,p,u,s,r,n,!0)}$onDidChangeWebviewPanelViewStates(k){const p=Object.keys(k);p.sort((u,o)=>{const r=k[u],s=k[o];return r.active?1:s.active?-1:+r.visible-+s.visible});for(const u of p){const o=this.getWebviewPanel(u);if(!o)continue;const r=k[u];o._updateViewState({active:r.active,visible:r.visible,viewColumn:A.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,p,u){if(this.h.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.h.set(p,{serializer:u,extension:k}),this.f.$registerSerializer(p,{serializeBuffersForPostMessage:(0,$.$bdc)(k)}),new v.$iK(()=>{this.h.delete(p),this.f.$unregisterSerializer(p)})}async $deserializeWebviewPanel(k,p,u,o){const r=this.h.get(p);if(!r)throw new Error(`No serializer found for '${p}'`);const{serializer:s,extension:m}=r,h=this.j.createNewWebview(k,u.webviewOptions,m),t=this.createNewWebviewPanel(k,p,u.title,o,u.panelOptions,h,u.active);await s.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(k,p,u,o,r,s,m){const h=new R(k,this.f,s,{viewType:p,title:u,viewColumn:o,panelOptions:r,active:m});return this.g.set(k,h),h}getWebviewPanel(k){return this.g.get(k)}}e.$Odc=I;function w(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(De[337],Ce([1,0,4,3,91,13,6,7]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class E extends F.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,w,y,k,p,u){super(),this.#u=!1,this.#a=this.B(new C.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new C.$Nd),this.onDidDispose=this.#c.event,this.#i=y,this.#s=k,this.#e=I,this.#t=w,this.#l=p,this.#n=u}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class v{constructor(I,w){this.d=w,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$gK.MainThreadWebviewViews)}registerWebviewViewProvider(I,w,y,k){if(this.b.has(w))throw new Error(`View provider for '${w}' already registered`);return this.b.set(w,{provider:y,extension:I}),this.a.$registerWebviewViewProvider((0,d.$ddc)(I),w,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,d.$bdc)(I)}),new $.$iK(()=>{this.b.delete(w),this.a.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(I,w,y,k,p){const u=this.b.get(w);if(!u)throw new Error(`No view provider found for '${w}'`);const{provider:o,extension:r}=u,s=this.d.createNewWebview(I,{},r),m=new E(I,this.a,w,y,s,!0);this.c.set(I,m),await o.resolveWebviewView(m,{state:k},p)}async $onDidChangeWebviewViewVisibility(I,w){this.e(I)._setVisible(w)}async $disposeWebviewView(I){const w=this.e(I);this.c.delete(I),w.dispose(),this.d.deleteWebview(I)}e(I){const w=this.c.get(I);if(!w)throw new Error("No webview found");return w}}e.$Ndc=v}),define(De[151],Ce([1,0,4,6,2,18,15,5,20,26]),function($e,e,C,F,d,L,A,$,E,v){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=e.$fdc=void 0;let I=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(y){const k=this.d;return{get focused(){return k.focused},get active(){return(0,v.$eF)(y,"windowActivity"),k.active}}}constructor(y){this.c=new C.$Nd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=y.getProxy(F.$gK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:p})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,k){k!==this.d[y]&&(this.d={...this.d,[y]:k},this.c.fire(this.d))}openUri(y,k){let p;if(typeof y=="string"){p=y;try{y=d.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.$Be)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,p,k)}async asExternalUri(y,k){if((0,A.$Be)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(y,k);return d.URI.from(p)}};e.$fdc=I,e.$fdc=I=R=He([Be(0,E.$hM)],I),e.$gdc=(0,$.$Ph)("IExtHostWindow")}),define(De[338],Ce([1,0,305,27,20]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;const L=1024*1024;let A=class extends C.$gec{constructor(E,v){super(E,v),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,v,R){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),v.apply(console,R),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,v){const R=process[E],I=R.write;let w="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(y,k,p)=>{if(!this.g){w+=y.toString(k);const u=w.length>L?w.length:w.lastIndexOf(`
`);u!==-1&&(console[v](w.slice(0,u)),w=w.slice(u+1))}I.call(R,y,k,p)}})}};e.$Rec=A,e.$Rec=A=He([Be(0,d.$hM),Be(1,F.$xM)],A)}),define(De[339],Ce([1,0,72,18,14,240,30,12]),function($e,e,C,F,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;let E=class{constructor(I,w){I.addFileSystemProvider(F.Schemas.file,new v(w),{isCaseSensitive:$.$l})}};e.$Sec=E,e.$Sec=E=He([Be(0,C.$Ecc),Be(1,d.$0i)],E);class v{constructor(I){this.b=I,this.a=new L.$bq(this.b)}async stat(I){const w=await this.a.stat(I);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,w,y){return this.a.writeFile(I,w,{...y,unlock:!1,atomic:!1})}delete(I,w){return this.a.delete(I,{...w,useTrash:!1,atomic:!1})}rename(I,w,y){return this.a.rename(I,w,y)}copy(I,w,y){return this.a.copy(I,w,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,w){throw new Error("Method not implemented.")}}}),define(De[340],Ce([1,0,16,63,31,34,3,6,2,20]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;let R=class extends A.$Sc{constructor(w,y){super();const k=w.getProxy($.$gK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async p=>{const u=E.URI.file((0,C.$jc)((0,F.tmpdir)(),(0,d.$eg)()));return await k.$download(p,u),u})}};e.$Qec=R,e.$Qec=R=He([Be(0,v.$hM),Be(1,L.$DM)],R)}),define(De[341],Ce([1,0,150,18,242,31]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;class A extends C.$fec{s(E,v,R){return E.scheme===F.Schemas.file?new d.$tN(R?.name||(0,L.$eg)(),E.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,v):super.s(E,v,R)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$4ec=A}),define(De[342],Ce([1,0,53,16,2,90,3,18,8,29]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;class R extends L.$Gcc{constructor(){super(...arguments),this.i=null}async g(t){const n=await super.g(t);if(n.scheme!==$.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const c=n.fsPath;let i=0;do{let a;i===0?a=c:a=/[/\\]$/.test(c)?`${c.substr(0,c.length-1)}-${i}`:`${c}-${i}`,await I(a);const l=F.$jc(a,"vscode.lock"),D=await p(this.d,l,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),d.URI.file(a);i++}while(i<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$3ec=R;async function I(h){try{await v.Promises.stat(h);return}catch{}try{await v.Promises.mkdir(h,{recursive:!0})}catch{}}const w=1e3,y=10*60*1e3;class k extends A.$Sc{constructor(t,n){super(),this.b=t,this.c=n,this.a=this.B(new E.$5g),this.a.cancelAndSet(async()=>{const c=await u(t,n);(!c||c.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await v.Promises.utimes(n,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${n}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await v.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function p(h,t,n){try{const i={pid:process.pid,willReleaseAt:0};await v.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){h.error(i)}const c=await u(h,t);return!c||c.pid!==process.pid?n?(h.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),s(h,t)):(h.info(`Lock '${t}': Lock acquired.`),new k(h,t))}async function u(h,t){let n;try{n=await v.Promises.readFile(t)}catch(c){return h.error(c),null}try{return JSON.parse(String(n))}catch(c){return h.error(c),null}}async function o(h,t){let n;try{n=await v.Promises.stat(t)}catch(c){return h.error(c),0}return n.mtime.getTime()}function r(h){try{return process.kill(h,0),!0}catch{return!1}}async function s(h,t){const n=await u(h,t);if(!n)return h.info(`Lock '${t}': Could not read pid of lock holder.`),m(h,t);if(n.willReleaseAt){let D=n.willReleaseAt-Date.now();if(D<5e3){for(D>0?h.info(`Lock '${t}': The lockfile is scheduled to be released in ${D} ms.`):h.info(`Lock '${t}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,E.$Ug)(Math.min(100,D)),await o(h,t)===0)return m(h,t);D=n.willReleaseAt-Date.now()}return m(h,t)}}if(!r(n.pid))return h.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),m(h,t);const c=await o(h,t),i=Date.now()-c;if(i<=y)return h.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;h.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Ug)(2e3);const a=await o(h,t),l=Date.now()-a;return l<=y?(h.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(h.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),m(h,t))}async function m(h,t){h.info(`Lock '${t}': Deleting a stale lock.`);try{await v.Promises.unlink(t)}catch{}return p(h,t,!0)}}),define(De[343],Ce([1,0,31,20,45,34]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;let A=class extends d.$Jcc{constructor(E,v){super(!0,E,v)}createTerminal(E,v,R){return this.createTerminalFromOptions({name:E,shellPath:v,shellArgs:R})}createTerminalFromOptions(E,v){const R=new d.$Icc(this.a,(0,C.$eg)(),E,E.name);return this.f.push(R),R.create(E,this.R(E,v)),R.value}};e.$lec=A,e.$lec=A=He([Be(0,L.$DM),Be(1,F.$hM)],A)}),define(De[344],Ce([1,0,8,22,21,9,4,3,128,293,69]),function($e,e,C,F,d,L,A,$,E,v,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$t4b=e.ResponsiveState=e.RequestInitiator=e.$s4b=e.$r4b=void 0;function w(g,P){try{return JSON.stringify(g,P)}catch{return"null"}}const y="$$ref$$",k={[y]:-1};class p{constructor(P,N){this.jsonString=P,this.referencedBuffers=N}}function u(g,P=null,N=!1){const O=[];return{jsonString:(N?w:JSON.stringify)(g,(j,U)=>{if(typeof U>"u")return k;if(typeof U=="object"){if(U instanceof F.$be){const T=O.push(U)-1;return{[y]:T}}if(P)return P(j,U)}return U}),referencedBuffers:O}}e.$r4b=u;function o(g,P,N){return JSON.parse(g,(O,M)=>{if(M){const j=M[y];if(typeof j=="number")return P[j];if(N&&M.$mid===1)return N.transformIncoming(M)}return M})}e.$s4b=o;function r(g,P){return JSON.stringify(g,P)}function s(g){return g?(P,N)=>N&&N.$mid===1?g.transformOutgoing(N):N:null}var m;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));var h;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},n=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class i extends $.$Sc{static{I=n}static{this.a=3*1e3}constructor(P,N=null,O=null){super(),this[I]=!0,this.b=this.B(new A.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=N,this.g=O,this.h=s(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,j=R.$nv.count;M<j;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$6g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const N=this.w[P];delete this.w[P],N.resolveErr(L.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+i.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+i.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,E.$Om)(P,this.g):P}getProxy(P){const{nid:N,sid:O}=P;return this.s[N]||(this.s[N]=this.J(N,O)),this.s[N]}J(P,N){const O={get:(M,j)=>(typeof j=="string"&&!M[j]&&j.charCodeAt(0)===36&&(M[j]=(...U)=>this.U(P,j,U)),j===c?N:M[j])};return new Proxy(Object.create(null),O)}set(P,N){return this.m[P.nid]=N,N}assertRegistered(P){for(let N=0,O=P.length;N<O;N++){const M=P[N];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(P){if(this.j)return;const N=P.byteLength,O=l.read(P,0),M=O.readUInt8(),j=O.readUInt32();switch(M){case 1:case 2:{let{rpcId:U,method:T,args:K}=S.deserializeRequestJSONArgs(O);this.g&&(K=(0,E.$Om)(K,this.g)),this.M(N,j,U,T,K,M===2);break}case 3:case 4:{let{rpcId:U,method:T,args:K}=S.deserializeRequestMixedArgs(O);this.g&&(K=(0,E.$Om)(K,this.g)),this.M(N,j,U,T,K,M===4);break}case 5:{this.f?.logIncoming(N,j,0,"ack"),this.G(j);break}case 6:{this.N(N,j);break}case 7:{this.O(N,j,void 0);break}case 9:{let U=S.deserializeReplyOKJSON(O);this.g&&(U=(0,E.$Om)(U,this.g)),this.O(N,j,U);break}case 10:{const U=S.deserializeReplyOKJSONWithBuffers(O,this.g);this.O(N,j,U);break}case 8:{const U=S.deserializeReplyOKVSBuffer(O);this.O(N,j,U);break}case 11:{let U=S.deserializeReplyErrError(O);this.g&&(U=(0,E.$Om)(U,this.g)),this.P(N,j,U);break}case 12:{this.P(N,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,N,O,M,j,U){this.f?.logIncoming(P,N,1,`receiveRequest ${(0,R.$pv)(O)}.${M}(`,j);const T=String(N);let K,q;if(U){const ee=new d.$Xd;j.push(ee.token),K=this.Q(O,M,j),q=()=>ee.cancel()}else K=this.Q(O,M,j),q=t;this.u[T]=q;const ge=S.serializeAcknowledged(N);this.f?.logOutgoing(ge.byteLength,N,1,"ack"),this.c.send(ge),K.then(ee=>{delete this.u[T];const Q=S.serializeReplyOK(N,ee,this.h);this.f?.logOutgoing(Q.byteLength,N,1,"reply:",ee),this.c.send(Q)},ee=>{delete this.u[T];const Q=S.serializeReplyErr(N,ee);this.f?.logOutgoing(Q.byteLength,N,1,"replyErr:",ee),this.c.send(Q)})}N(P,N){this.f?.logIncoming(P,N,1,"receiveCancel");const O=String(N);this.u[O]?.()}O(P,N,O){this.f?.logIncoming(P,N,0,"receiveReply:",O);const M=String(N);if(!this.w.hasOwnProperty(M))return;const j=this.w[M];delete this.w[M],j.resolveOk(O)}P(P,N,O){this.f?.logIncoming(P,N,0,"receiveReplyErr:",O);const M=String(N);if(!this.w.hasOwnProperty(M))return;const j=this.w[M];delete this.w[M];let U;O&&(O.$isError?(U=new Error,U.name=O.name,U.message=O.message,U.stack=O.stack):U=O),j.resolveErr(U)}Q(P,N,O){try{return Promise.resolve(this.S(P,N,O))}catch(M){return Promise.reject(M)}}S(P,N,O){const M=this.m[P];if(!M)throw new Error("Unknown actor "+(0,R.$pv)(P));const j=M[N];if(typeof j!="function")throw new Error("Unknown method "+N+" on actor "+(0,R.$pv)(P));return j.apply(M,O)}U(P,N,O){if(this.j)return new v.$q4b;let M=null;if(O.length>0&&d.CancellationToken.isCancellationToken(O[O.length-1])&&(M=O.pop()),M&&M.isCancellationRequested)return Promise.reject(L.$6());const j=S.serializeRequestArguments(O,this.h),U=++this.t,T=String(U),K=new v.$p4b,q=new $.$Rc;M&&q.add(M.onCancellationRequested(()=>{const ee=S.serializeCancel(U);this.f?.logOutgoing(ee.byteLength,U,0,"cancel"),this.c.send(S.serializeCancel(U))})),this.w[T]=new a(K,q),this.F(U);const ge=S.serializeRequest(U,P,N,j,!!M);return this.f?.logOutgoing(ge.byteLength,U,0,`request: ${(0,R.$pv)(P)}.${N}(`,O),this.c.send(ge),K}}e.$t4b=i;class a{constructor(P,N){this.a=P,this.b=N}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class l{static alloc(P,N,O){const M=new l(F.$be.alloc(O+1+4),0);return M.writeUInt8(P),M.writeUInt32(N),M}static read(P,N){return new l(P,N)}get buffer(){return this.a}constructor(P,N){this.a=P,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+P).toString();return this.b+=P,O}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+P).toString();return this.b+=P,O}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P);return this.b+=P,N}static sizeMixedArray(P){let N=0;N+=1;for(let O=0,M=P.length;O<M;O++){const j=P[O];switch(N+=1,j.type){case 1:N+=this.sizeLongString(j.value);break;case 2:N+=this.sizeVSBuffer(j.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(j.value);for(let U=0;U<j.buffers.length;++U)N+=this.sizeVSBuffer(j.buffers[U]);break;case 4:break}}return N}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let N=0,O=P.length;N<O;N++){const M=P[N];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let j=0;j<M.buffers.length;++j)this.writeBuffer(M.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const N=new Array(P);for(let O=0;O<P;O++)switch(this.readUInt8()){case 1:N[O]=this.readLongString();break;case 2:N[O]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),U=this.readLongString(),T=[];for(let K=0;K<j;++K)T.push(this.readVSBuffer());N[O]=new R.$qv(o(U,T,null));break}case 4:N[O]=void 0;break}return N}}var D;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(D||(D={}));class S{static a(P){for(let N=0,O=P.length;N<O;N++)if(P[N]instanceof F.$be||P[N]instanceof R.$qv||typeof P[N]>"u")return!0;return!1}static serializeRequestArguments(P,N){if(this.a(P)){const O=[];for(let M=0,j=P.length;M<j;M++){const U=P[M];if(U instanceof F.$be)O[M]={type:2,value:U};else if(typeof U>"u")O[M]={type:4};else if(U instanceof R.$qv){const{jsonString:T,referencedBuffers:K}=u(U.value,N);O[M]={type:3,value:F.$be.fromString(T),buffers:K}}else O[M]={type:1,value:F.$be.fromString(r(U,N))}}return{type:1,args:O}}return{type:0,args:r(P,N)}}static serializeRequest(P,N,O,M,j){switch(M.type){case 0:return this.b(P,N,O,M.args,j);case 1:return this.c(P,N,O,M.args,j)}}static b(P,N,O,M,j){const U=F.$be.fromString(O),T=F.$be.fromString(M);let K=0;K+=l.sizeUInt8(),K+=l.sizeShortString(U),K+=l.sizeLongString(T);const q=l.alloc(j?2:1,P,K);return q.writeUInt8(N),q.writeShortString(U),q.writeLongString(T),q.buffer}static deserializeRequestJSONArgs(P){const N=P.readUInt8(),O=P.readShortString(),M=P.readLongString();return{rpcId:N,method:O,args:JSON.parse(M)}}static c(P,N,O,M,j){const U=F.$be.fromString(O);let T=0;T+=l.sizeUInt8(),T+=l.sizeShortString(U),T+=l.sizeMixedArray(M);const K=l.alloc(j?4:3,P,T);return K.writeUInt8(N),K.writeShortString(U),K.writeMixedArray(M),K.buffer}static deserializeRequestMixedArgs(P){const N=P.readUInt8(),O=P.readShortString(),M=P.readMixedArray(),j=new Array(M.length);for(let U=0,T=M.length;U<T;U++){const K=M[U];typeof K=="string"?j[U]=JSON.parse(K):j[U]=K}return{rpcId:N,method:O,args:j}}static serializeAcknowledged(P){return l.alloc(5,P,0).buffer}static serializeCancel(P){return l.alloc(6,P,0).buffer}static serializeReplyOK(P,N,O){if(typeof N>"u")return this.d(P);if(N instanceof F.$be)return this.e(P,N);if(N instanceof R.$qv){const{jsonString:M,referencedBuffers:j}=u(N.value,O,!0);return this.g(P,M,j)}else return this.f(P,w(N,O))}static d(P){return l.alloc(7,P,0).buffer}static e(P,N){let O=0;O+=l.sizeVSBuffer(N);const M=l.alloc(8,P,O);return M.writeVSBuffer(N),M.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,N){const O=F.$be.fromString(N);let M=0;M+=l.sizeLongString(O);const j=l.alloc(9,P,M);return j.writeLongString(O),j.buffer}static g(P,N,O){const M=F.$be.fromString(N);let j=0;j+=l.sizeUInt32,j+=l.sizeLongString(M);for(const T of O)j+=l.sizeVSBuffer(T);const U=l.alloc(10,P,j);U.writeUInt32(O.length),U.writeLongString(M);for(const T of O)U.writeBuffer(T);return U.buffer}static deserializeReplyOKJSON(P){const N=P.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(P,N){const O=P.readUInt32(),M=P.readLongString(),j=[];for(let U=0;U<O;++U)j.push(P.readVSBuffer());return new R.$qv(o(M,j,N))}static serializeReplyErr(P,N){const O=N?w(L.$3(N),null):void 0;if(typeof O!="string")return this.h(P);const M=F.$be.fromString(O);let j=0;j+=l.sizeLongString(M);const U=l.alloc(11,P,j);return U.writeLongString(M),U.buffer}static deserializeReplyErrError(P){const N=P.readLongString();return JSON.parse(N)}static h(P){return l.alloc(12,P,0).buffer}}var b;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var f;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(f||(f={}))}),define(De[345],Ce([1,0,4,43,42,5]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.$BJ=e.OutputChannelUpdateMode=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=void 0,e.$rJ="text/x-code-output",e.$sJ="output",e.$tJ="Log",e.$uJ="text/x-code-log-output",e.$vJ="log",e.$wJ="workbench.panel.output",e.$xJ=new d.$7i("inOutput",!1),e.$yJ=new d.$7i("activeLogOutput",!1),e.$zJ=new d.$7i("outputView.scrollLock",!1),e.$AJ=(0,L.$Ph)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$BJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new C.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new C.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(R=>v.push(R)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}F.$gn.add(e.$BJ.OutputChannels,new $),e.$CJ=new d.$7i("activeOutputChannel","")}),define(De[152],Ce([1,0,6,5,20,25,14,345,72,27,55,178,22,17,30,4,3]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0;class o extends A.$dj{get disposed(){return this.n}constructor(h,t,n,c,i){super(),this.id=h,this.name=t,this.r=n,this.s=c,this.extension=i,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=w.$be.fromString(t).byteLength,(0,A.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends o{appendLine(h){this.append(h)}}let s=class{constructor(h,t,n,c,i,a){this.i=t,this.j=n,this.k=c,this.l=i,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(C.$gK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$em)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,n]of this.g)n.visible=t===this.h}createOutputChannel(h,t,n){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,i=(0,y.$yf)(t)?t:void 0;if((0,y.$yf)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const l=this.i.environment.extensionLogLevel?.find(([S])=>L.$6l.equals(n.identifier,S))?.[1];l&&(a=(0,A.$nj)(l));const D=c?this.o(h,a,n):this.n(h,i,n);return D.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),c?this.r(h,a??this.m.getLevel(),D):this.q(h,D)}async n(h,t,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,i=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(h,i,t,n.identifier.value);return new o(l,h,a,this.a,n)}async o(h,t,n){const c=await this.p(n),i=h.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(c,`${i}.log`),l=`${n.identifier.value}.${i}`,D=this.l.createLogger(a,{id:l,name:h,logLevel:t,extensionId:n.identifier.value});return new r(l,h,D,this.a,n)}p(h){let t=this.d.get(h.identifier.value);if(!t){const n=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(n)}catch(c){if((0,k.$ok)(c)!==k.FileSystemProviderErrorCode.FileExists)throw c}return n})())}return t}q(h,t){let n=!1;const c=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return h},append(i){c(),t.then(a=>a.append(i))},appendLine(i){c(),t.then(a=>a.appendLine(i))},clear(){c(),t.then(i=>i.clear())},replace(i){c(),t.then(a=>a.replace(i))},show(i,a){c(),t.then(l=>l.show(i,a))},hide(){c(),t.then(i=>i.hide())},dispose(){n=!0,t.then(i=>i.dispose())}}}r(h,t,n){const c=new u.$Rc,i=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},a=c.add(new p.$Nd);function l(D){t=D,a.fire(D)}return n.then(D=>{c.add(D),D.logLevel!==t&&l(D.logLevel),c.add(D.onDidChangeLogLevel(S=>l(S)))}),{...this.q(h,n),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(D,...S){i(),n.then(b=>b.trace(D,...S))},debug(D,...S){i(),n.then(b=>b.debug(D,...S))},info(D,...S){i(),n.then(b=>b.info(D,...S))},warn(D,...S){i(),n.then(b=>b.warn(D,...S))},error(D,...S){i(),n.then(b=>b.error(D,...S))},dispose(){c.dispose()}}}};e.$2cc=s,e.$2cc=s=He([Be(0,d.$hM),Be(1,v.$xM),Be(2,E.$Ecc),Be(3,R.$_bc),Be(4,A.$$i),Be(5,A.$0i)],s),e.$3cc=(0,F.$Ph)("IExtHostOutputService")}),define(De[346],Ce([1,0,5,8]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=(0,C.$Ph)("remoteAgentService"),e.$um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(d){let L=1/0;for(let $=0;$<this.maxSampleCount;$++){const E=await d.getRoundTripTime();if(E===void 0)return;L=Math.min(L,E/2),await(0,F.$Ug)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce(($,E)=>$+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce(($,E)=>$+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[347],Ce([1,0,33,18,16,12,23,2,5,258,44,147,346]),function($e,e,C,F,d,L,A,$,E,v,R,I,w){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=e.$UJ=void 0,e.$UJ=(0,E.$Ph)("pathService");let k=y=class{constructor(u,o,r,s){this.d=u,this.e=o,this.f=r,this.g=s,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??u})()}hasValidBasename(u,o,r){return typeof o=="string"||typeof o>"u"?this.a.then(s=>this.h(u,s,o)):this.h(u,o,r)}h(u,o,r){return u.scheme===F.Schemas.file||u.scheme===F.Schemas.vscodeRemote?(0,C.$Vf)(r??(0,A.$sg)(u),o===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,o){if(u.remoteAuthority)return F.Schemas.vscodeRemote;const r=(0,v.$RJ)(o.getWorkspace());if(r)return r;const s=o.getWorkspace().folders[0];if(s)return s.uri.scheme;const m=o.getWorkspace().configuration;return m?m.scheme:F.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?d.$fc:d.$gc)}async fileURI(u){let o="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const s=u.indexOf("/",2);s===-1?(o=u.substring(2),u="/"):(o=u.substring(2,s),u=u.substring(s)||"/")}return $.URI.from({scheme:F.Schemas.file,authority:o,path:u,query:"",fragment:""})}};e.$VJ=k,e.$VJ=k=y=He([Be(1,w.$tm),Be(2,I.$DJ),Be(3,R.$Yh)],k)}),define(De[348],Ce([1,0,225,19,57,4,52,3,2,50,230,14,65,260,86,44,147,26,21,17,24,42]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OJ=e.$NJ=e.$MJ=e.OnPortForward=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.TunnelSource=e.TunnelCloseReason=e.$GJ=e.$FJ=e.$EJ=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.$EJ="onTunnel",e.$FJ=new h.$7i("forwardedPortsViewEnabled",!1,C.localize(0,null));function c(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}e.$GJ=c;var i;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var a;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$HJ={source:a.User,description:C.localize(1,null)},e.$IJ={source:a.Auto,description:C.localize(2,null)};function l(N,O,M){const j=N.get(S(O,M));if(j)return j;if((0,k.$cv)(O))for(const U of k.$bv){const T=S(U,M);if(N.has(T))return N.get(T)}else if((0,k.$ev)(O))for(const U of k.$dv){const T=S(U,M);if(N.has(T))return N.get(T)}}e.$JJ=l;function D(N,O,M){const j=l(N,O,M);if(j)return j;const U=(0,k.$ev)(O)?"localhost":(0,k.$cv)(O)?"0.0.0.0":void 0;if(U)return l(N,U,M)}e.$KJ=D;function S(N,O){return N+":"+O}e.$LJ=S;var b;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(b||(e.OnPortForward=b={}));function f(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$MJ=f;class g extends $.$Sc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new L.$Nd,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(M=>{(M.affectsConfiguration(g.c)||M.affectsConfiguration(g.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,M,j){let U=this.w(O,M,j,this.j,0);const T={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;U>=0;){const K=this.j[U];K.key===O?(T.onAutoForward=K.onAutoForward??T.onAutoForward,T.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:T.elevateIfNeeded,T.label=K.label??T.label,T.requireLocalPort=K.requireLocalPort,T.protocol=K.protocol):(T.onAutoForward=T.onAutoForward??K.onAutoForward,T.elevateIfNeeded=T.elevateIfNeeded!==void 0?T.elevateIfNeeded:K.elevateIfNeeded,T.label=T.label??K.label,T.requireLocalPort=T.requireLocalPort!==void 0?T.requireLocalPort:void 0,T.protocol=T.protocol??K.protocol),U=this.w(O,M,j,this.j,U+1)}return T.onAutoForward!==void 0||T.elevateIfNeeded!==void 0||T.label!==void 0||T.requireLocalPort!==void 0||T.protocol!==void 0?T:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,s.$yf)(O.host)&&(0,s.$Cf)(O.port)}w(O,M,j,U,T){if(T>=U.length)return-1;const K=!(0,k.$cv)(M)&&!(0,k.$ev)(M),ge=U.slice(T).findIndex(ee=>(0,s.$Cf)(ee.key)?K?!1:ee.key===O:this.t(ee.key)?K?!1:O>=ee.key.start&&O<=ee.key.end:this.u(ee.key)?O===ee.key.port&&M===ee.key.host:j?ee.key.test(j):!1);return ge>=0?ge+T:-1}y(){const O=this.r.getValue(g.c);if(!O||!(0,s.$Af)(O))return[];const M=[];for(const U in O){if(U===void 0)continue;const T=O[U];let K;if(Number(U))K=Number(U);else if((0,s.$yf)(U))if(g.g.test(U)){const q=U.match(g.g);K={start:Number(q[1]),end:Number(q[2])}}else if(g.h.test(U)){const q=U.match(g.h);K={host:q[1],port:Number(q[2])}}else{let q;try{q=RegExp(U)}catch{}q&&(K=q)}K&&M.push({key:K,elevateIfNeeded:T.elevateIfNeeded,onAutoForward:T.onAutoForward,label:T.label,requireLocalPort:T.requireLocalPort,protocol:T.protocol})}const j=this.r.getValue(g.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(M)}z(O){function M(j,U){return(0,s.$Cf)(j.key)?j.key:U.t(j.key)?j.key.start:U.u(j.key)?j.key.port:Number.MAX_VALUE}return O.sort((j,U)=>M(j,this)-M(U,this))}C(){return this.m}static providedActionToAction(O){switch(O){case k.ProvidedOnAutoForward.Notify:return b.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return b.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return b.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return b.OpenPreview;case k.ProvidedOnAutoForward.Silent:return b.Silent;case k.ProvidedOnAutoForward.Ignore:return b.Ignore;default:return}}async addAttributes(O,M,j){const T=this.r.inspect(g.c).userRemoteValue;let K;!T||!(0,s.$Af)(T)?K={}:K=(0,m.$7m)(T),K[`${O}`]||(K[`${O}`]={});for(const q in M)K[`${O}`][q]=M[q];return this.r.updateValue(g.c,K,j)}}e.$NJ=g;let P=class extends $.$Sc{constructor(O,M,j,U,T,K,q,ge,ee,Q){super(),this.H=O,this.I=M,this.J=j,this.L=U,this.M=T,this.N=K,this.O=q,this.P=ge,this.Q=ee,this.R=Q,this.c=new Map,this.g=new L.$Nd,this.onForwardPort=this.g.event,this.h=new L.$Nd,this.onClosePort=this.h.event,this.j=new L.$Nd,this.onPortName=this.j.event,this.n=new L.$Nd,this.onCandidatesChanged=this.n.event,this.t=new L.$Nd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Nd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new g(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const ae=await this.getAttributes(X.map(ie=>({port:ie.tunnelRemotePort,host:ie.tunnelRemoteHost})));for(const ie of X)if(ie.localAddress){const ce=S(ie.tunnelRemoteHost,ie.tunnelRemotePort),we=D(this.m??new Map,ie.tunnelRemoteHost,ie.tunnelRemotePort);this.forwarded.set(ce,{remotePort:ie.tunnelRemotePort,remoteHost:ie.tunnelRemoteHost,localAddress:ie.localAddress,protocol:ae?.get(ie.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ie.localAddress,ae?.get(ie.tunnelRemotePort)),localPort:ie.tunnelLocalPort,runningProcess:we?.detail,hasRunningProcess:!!we,pid:we?.pid,privacy:ie.privacy,source:e.$HJ}),this.f.set(ce,ie)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const ae=S(X.tunnelRemoteHost,X.tunnelRemotePort);if(!D(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!D(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!D(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const ie=D(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),ce=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(ae,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:ce?.protocol??k.TunnelProtocol.Http,localUri:await this.X(X.localAddress,ce),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:ie?.detail,hasRunningProcess:!!ie,pid:ie?.pid,privacy:X.privacy,source:e.$HJ})}await this.$(),this.f.set(ae,X),this.g.fire(this.forwarded.get(ae))})),this.B(this.H.onTunnelClosed(X=>this.W(X,i.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$EJ))?(this.R.createKey(e.$FJ.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,M){const j=S(O.host,O.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(O))}X(O,M){if(O.startsWith("http"))return E.URI.parse(O);const j=M?.protocol??"http";return E.URI.parse(`${j}://${O}`)}async Y(){const O=this.N.getWorkspace(),M=O.configuration?(0,A.$Di)(O.configuration.path):O.folders.length>0?(0,A.$Di)(O.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.L.remoteAuthority}.${M}`}async Z(){const O=this.I.get(n,1);if(O)return this.I.remove(n,1),await this.$(),O;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const M=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(j=>j.remotePort).join(", ")}`);for(const j of M){const U=D(this.detected,j.remoteHost,j.remotePort);j.source.source!==a.Extension&&!U||j.source.source===a.Extension&&U?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===a.Extension&&!U&&this.D.set(S(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Y();this.w=this.B(new $.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===O&&(this.s=Promise.resolve(this.I.get(O,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=JSON.stringify(Array.from(this.forwarded.values()));if(O!==this.y){this.y=O;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(O,M,j){if(!O.tunnelLocalPort||!j?.requireLocalPort||O.tunnelLocalPort===M)return;const U=new Date;if(this.ab.getTime()+t>U.getTime())return;this.ab=U;const T=C.localize(3,null,M,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(T)}async forward(O,M){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(O,M)}async cb(O,M){await this.Q.activateByEvent(e.$EJ);const j=D(this.forwarded,O.remote.host,O.remote.port);M=M??(M!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const U=O.local!==void 0?O.local:O.remote.port;let T;if(j)return this.eb(j,O,M);{const K=this.L.remoteAuthority,q=K?{getAddress:async()=>(await this.M.resolveAuthority(K)).authority}:void 0,ge=S(O.remote.host,O.remote.port);this.c.set(ge,!0),O=this.db(ge,O);const ee=await this.H.openTunnel(q,O.remote.host,O.remote.port,void 0,U,O.elevateIfNeeded?O.elevateIfNeeded:M?.elevateIfNeeded,O.privacy,M?.protocol);if(typeof ee=="string")T=ee;else if(ee&&ee.localAddress){const Q=D(this.m??new Map,O.remote.host,O.remote.port),X=ee.protocol?ee.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:M?.protocol??k.TunnelProtocol.Http,ae={remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localPort:ee.tunnelLocalPort,name:M?.label??O.name,closeable:!0,localAddress:ee.localAddress,protocol:X,localUri:await this.X(ee.localAddress,M),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:O.source??e.$HJ,privacy:ee.privacy};return this.forwarded.set(ge,ae),this.f.set(ge,ee),this.c.delete(ge),await this.$(),await this.bb(ee,U,M),this.g.fire(ae),ee}this.c.delete(ge)}return T}db(O,M){const j=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(j){const U=j.get(O);j.delete(O),U&&(M.name=U.name??M.name,M.local=("local"in U?U.local:"localPort"in U?U.localPort:void 0)??M.local,M.privacy=U.privacy??M.privacy)}return M}async eb(O,M,j){const U=j?.label??M.name;let T;(function(q){q[q.None=0]="None",q[q.Fire=1]="Fire",q[q.Reopen=2]="Reopen"})(T||(T={}));let K=T.None;switch(U!==O.name&&(O.name=U,K=T.Fire),(j?.protocol||O.protocol!==k.TunnelProtocol.Http)&&j?.protocol!==O.protocol&&(M.source=O.source,K=T.Reopen),M.privacy&&O.privacy!==M.privacy&&(K=T.Reopen),K){case T.Fire:{this.g.fire();break}case T.Reopen:await this.close(O.remoteHost,O.remotePort,i.User),await this.cb(M,j)}return D(this.f,M.remote.host,M.remote.port)}async name(O,M,j){const U=D(this.forwarded,O,M),T=S(O,M);if(U){U.name=j,await this.$(),this.j.fire({host:O,port:M});return}else this.detected.has(T)&&(this.detected.get(T).name=j,this.j.fire({host:O,port:M}))}async close(O,M,j){const U=S(O,M),T=this.forwarded.get(U);return j===i.AutoForwardEnd&&T&&T.source.source===a.Auto&&this.F.set(U,{local:T.localPort,name:T.name,privacy:T.privacy}),await this.H.closeTunnel(O,M),this.W({host:O,port:M},j)}address(O,M){const j=S(O,M);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const M of O){const j=D(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),U=typeof M.localAddress=="string"?M.localAddress:S(M.localAddress.host,M.localAddress.port);this.detected.set(S(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:U,protocol:k.TunnelProtocol.Http,localUri:this.X(U),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,U,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let M=O;this.r&&(M=await this.r(O));const j=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(U=>U.port).join(", ")}`),this.n.fire(j)}fb(O){const M=this.m??new Map,j=new Map;return this.m=j,O.forEach(U=>{const T=S(U.host,U.port);j.set(T,{host:U.host,port:U.port,detail:U.detail,pid:U.pid}),M.has(T)&&M.delete(T);const K=D(this.forwarded,U.host,U.port);K&&(K.runningProcess=U.detail,K.hasRunningProcess=!0,K.pid=U.pid)}),M.forEach((U,T)=>{const K=c(T);if(!K)return;const q=D(this.forwarded,K.host,K.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0);const ge=D(this.detected,K.host,K.port);ge&&(ge.runningProcess=void 0,ge.hasRunningProcess=!1,ge.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const O=Array.from(this.forwarded.values()),M=await this.getAttributes(O.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(M)for(const j of O){const U=M.get(j.remotePort);(U?.protocol||j.protocol!==k.TunnelProtocol.Http)&&U?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},U),U&&U.label&&U.label!==j.name&&await this.name(j.remoteHost,j.remotePort,U.label)}}async getAttributes(O,M=!0){const j=new Map,U=new Map;O.forEach(ee=>{const Q=D(this.m??new Map,k.$bv[0],ee.port)??ee;if(Q){j.set(ee.port,Q);const X=f(Q)?Q.pid:void 0;U.has(X)||U.set(X,[]),U.get(X)?.push(ee.port)}});const T=new Map;if(O.forEach(ee=>{const Q=this.configPortsAttributes.getAttributes(ee.port,ee.host,j.get(ee.port)?.detail);Q&&T.set(ee.port,Q)}),this.G.length===0||!M)return T.size>0?T:void 0;const K=await Promise.all((0,F.$Rb)(this.G.map(ee=>Array.from(U.entries()).map(Q=>{const X=Q[1],ae=j.get(X[0]);return ee.providePortAttributes(X,ae?.pid,ae?.detail,new r.$Xd().token)})))),q=new Map;if(K.forEach(ee=>ee.forEach(Q=>{Q&&q.set(Q.port,Q)})),!T&&!q)return;const ge=new Map;return O.forEach(ee=>{const Q=T.get(ee.port),X=q.get(ee.port);ge.set(ee.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??g.providedActionToAction(X?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),ge}addAttributesProvider(O){this.G.push(O)}};e.$OJ=P,He([(0,d.$ih)(1e3)],P.prototype,"$",null),e.$OJ=P=He([Be(0,k.$0u),Be(1,y.$7o),Be(2,v.$ji),Be(3,u.$DJ),Be(4,w.$Pk),Be(5,p.$Yh),Be(6,I.$0i),Be(7,R.$Bv),Be(8,o.$aF),Be(9,h.$8i)],P)}),define(De[92],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$CI=e.$BI=void 0;class C{constructor(A,$){this.line=A,this.character=$}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,$){return new C(0,0)}with(A){return new C(0,0)}}e.$BI=C;class F{constructor(A,$,E,v){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,$),this.end=new C(E,v)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.$CI=F;var d;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(d||(e.TextSearchCompleteMessageType=d={}))}),define(De[36],Ce([1,0,19,35,24,33,15,5,16,9,92,8]),function($e,e,C,F,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.SearchErrorCode=e.$RI=e.$QI=e.SearchSortOrder=e.ViewMode=e.$PI=e.$OI=e.$NI=e.$MI=e.SearchCompletionExitCode=e.$LI=e.$KI=e.$JI=e.QueryType=e.SearchProviderType=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$DI="workbench.view.search",e.$EI="workbench.panel.search",e.$FI="workbench.view.search",e.$GI="search-result",e.$HI="search.exclude";const w="\u27EA ",y=" characters skipped \u27EB",k=(w.length+y.length+5)*2;e.$II=(0,$.$Ph)("searchService");var p;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(p||(e.SearchProviderType=p={}));var u;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(u||(e.QueryType=u={}));function o(X){return!!X.preview}e.$JI=o;function r(X){return!!X.resource}e.$KI=r;function s(X){return!!X.message}e.$LI=s;var m;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(m||(e.SearchCompletionExitCode=m={}));class h{constructor(ae){this.resource=ae,this.results=[]}}e.$MI=h;class t{constructor(ae,ie,ce,we){this.ranges=ie,this.webviewIndex=we;const H=Array.isArray(ie)?ie:[ie];if(ce&&ce.matchLines===1&&n(H)){ae=(0,A.$rf)(ae,ce.matchLines);let B="",J=0,re=0;const Y=Math.floor(ce.charsPerLine/5),_=[];for(const x of H){const pe=Math.max(x.startColumn-Y,0),ue=x.startColumn+ce.charsPerLine;if(pe>re+Y+k){const fe=w+(pe-re)+y;B+=fe+ae.slice(pe,ue),J+=pe-(re+fe.length)}else B+=ae.slice(re,ue);_.push(new i(0,x.startColumn-J,x.endColumn-J)),re=ue}this.preview={text:B,matches:Array.isArray(this.ranges)?_:_[0]}}else{const B=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:ae,matches:(0,C.$2b)(ie,J=>new c(J.startLineNumber-B,J.startColumn,J.endLineNumber-B,J.endColumn))}}}}e.$NI=t;function n(X){const ae=X[0].startLineNumber;for(const ie of X)if(ie.startLineNumber!==ae||ie.endLineNumber!==ae)return!1;return!0}class c{constructor(ae,ie,ce,we){this.startLineNumber=ae,this.startColumn=ie,this.endLineNumber=ce,this.endColumn=we}}e.$OI=c;class i extends c{constructor(ae,ie,ce){super(ae,ie,ae,ce)}}e.$PI=i;var a;(function(X){X.List="list",X.Tree="tree"})(a||(e.ViewMode=a={}));var l;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function D(X,ae=!0){const ie=X&&X.files&&X.files.exclude,ce=ae&&X&&X.search&&X.search.exclude;if(!ie&&!ce)return;if(!ie||!ce)return ie||ce;let we=Object.create(null);return we=d.$0m(we,d.$7m(ie)),we=d.$0m(we,d.$7m(ce),!0),we}e.$QI=D;function S(X,ae){return X.excludePattern&&F.$vj(X.excludePattern,ae)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&F.$vj(X.includePattern,ae)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(ie=>{const ce=ie.folder.fsPath;if(L.$Xf(ae,ce)){const we=E.$lc(ce,ae);return!ie.includePattern||!!F.$vj(ie.includePattern,we)}else return!1}):!1:!0}e.$RI=S;var b;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class f extends Error{constructor(ae,ie){super(ae),this.code=ie}}e.$SI=f;function g(X){const ae=X.message;if((0,v.$4)(X))return new f(ae,b.canceled);try{const ie=JSON.parse(ae);return new f(ie.message,ie.code)}catch{return new f(ae,b.other)}}e.$TI=g;function P(X){const ae={message:X.message,code:X.code};return new Error(JSON.stringify(ae))}e.$UI=P;function N(X){return X.type==="error"?!0:X.type==="success"}e.$VI=N;function O(X){return X.type==="success"}e.$WI=O;function M(X){return!!X.path}e.$XI=M;function j(X,ae){const ie=X.searchPath?X.searchPath:X.relativePath;return(0,A.$of)(ie,ae)}e.$YI=j;class U{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$ZI=U;function T(X,ae){const ie={...X||{},...ae||{}};return Object.keys(ie).filter(ce=>{const we=ie[ce];return typeof we=="boolean"&&we})}e.$1I=T;class K{constructor(ae,ie){this.c=null,this.a={...ae.excludePattern||{},...ie.excludePattern||{}},this.b=F.$wj(this.a);let ce=ae.includePattern;ie.includePattern&&(ce?ce={...ce,...ie.includePattern}:ce=ie.includePattern),ce&&(this.c=F.$wj(ce))}matchesExcludesSync(ae,ie,ce){return!!(this.b&&this.b(ae,ie,ce))}includedInQuerySync(ae,ie,ce){return!(this.b&&this.b(ae,ie,ce)||this.c&&!this.c(ae,ie,ce))}includedInQuery(ae,ie,ce){const we=this.b(ae,ie,ce),H=()=>this.c?!!this.c(ae,ie,ce):!0;return(0,I.$Gg)(we)?we.then(B=>B?!1:H()):H()}hasSiblingExcludeClauses(){return q(this.a)}}e.$2I=K;function q(X){for(const ae in X)if(typeof X[ae]!="boolean")return!0;return!1}function ge(X){if(!X)return;let ae;return ie=>(ae||(ae=(X()||Promise.resolve([])).then(ce=>ce?Q(ce):{})),ae.then(ce=>!!ce[ie]))}e.$3I=ge;function ee(X){if(!X)return;let ae;return ie=>{if(!ae){const ce=X();ae=ce?Q(ce):{}}return!!ae[ie]}}e.$4I=ee;function Q(X){const ae={};for(const ie of X)ae[ie]=!0;return ae}}),define(De[39],Ce([1,0,19,8,21,4,3,78,18,120,23,15,2,214,5,14,243,44,55,27,20,13,7,67,36,6]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h,t,n,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=void 0;function a(N,O,M){return new R.$kg(j=>b(j,M)).isEqual(N,O)}function l(N,O,M){return a(N.uri,O.uri,M)?0:(0,I.$Ue)(N.uri.toString(),O.uri.toString())}function D(N,O,M){return N.index!==O.index?N.index<O.index?-1:1:a(N.uri,O.uri,M)?(0,I.$Ue)(N.name,O.name):(0,I.$Ue)(N.uri.toString(),O.uri.toString())}function S(N,O,M,j){const U=N.slice(0).sort((K,q)=>M(K,q,j)),T=O.slice(0).sort((K,q)=>M(K,q,j));return(0,C.$Eb)(U,T,(K,q)=>M(K,q,j))}function b(N,O){const M=O.getCapabilities(N.scheme);return!(M&&M&1024)}class f extends o.$9h{static toExtHostWorkspace(O,M,j,U){if(!O)return{workspace:null,added:[],removed:[]};const{id:T,name:K,folders:q,configuration:ge,transient:ee,isUntitled:Q}=O,X=[],ae=M;M?q.forEach((H,B)=>{const J=w.URI.revive(H.uri),re=f.o(j||M,J,U);re?(re.name=H.name,re.index=H.index,X.push(re)):X.push({uri:J,name:H.name,index:B})}):X.push(...q.map(({uri:H,name:B,index:J})=>({uri:w.URI.revive(H),name:B,index:J}))),X.sort((H,B)=>H.index<B.index?-1:1);const ie=new f(T,K,X,!!ee,ge?w.URI.revive(ge):null,!!Q,H=>b(H,U)),{added:ce,removed:we}=S(ae?ae.workspaceFolders:[],ie.workspaceFolders,l,U);return{workspace:ie,added:ce,removed:we}}static o(O,M,j){for(let U=0;U<O.folders.length;U++){const T=O.workspaceFolders[U];if(a(T.uri,M,j))return T}}constructor(O,M,j,U,T,K,q){super(O,j.map(ge=>new o.$0h(ge)),U,T,q),this.t=M,this.u=K,this.q=[],this.s=$.$Vh.forUris(q),j.forEach(ge=>{this.q.push(ge),this.s.set(ge.uri,ge)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(O,M){return M&&this.s.get(O)&&(O=(0,R.$ug)(O)),this.s.findSubstr(O)}resolveWorkspaceFolder(O){return this.s.get(O)}}let g=class{constructor(O,M,j,U,T){this.c=new L.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Pd,this.B=new Map,this.h=U,this.s=j,this.t=T,this.j=new v.$Ql,this.k=new F.$Sg,this.o=O.getProxy(i.$gK.MainThreadWorkspace),this.q=O.getProxy(i.$gK.MainThreadMessageService);const K=M.workspace;this.l=K?new f(K.id,K.name,[],!!K.transient,K.configuration?w.URI.revive(K.configuration):null,!!K.isUntitled,q=>b(q,j)):void 0}$initializeWorkspace(O,M){this.v=M,this.$acceptWorkspaceData(O),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?w.URI.from({scheme:E.Schemas.untitled,path:(0,R.$sg)((0,R.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(O,M,j,...U){const T=[];if(Array.isArray(U)&&U.forEach(Q=>{w.URI.isUri(Q.uri)&&!T.some(X=>a(X.uri,Q.uri,this.s))&&T.push({uri:Q.uri,name:Q.name||(0,R.$rg)(Q.uri)})}),this.n||[M,j].some(Q=>typeof Q!="number"||Q<0)||j===0&&T.length===0)return!1;const K=this.x?this.x.workspaceFolders:[];if(M+j>K.length)return!1;const q=K.slice(0);q.splice(M,j,...T.map(Q=>({uri:Q.uri,name:Q.name||(0,R.$rg)(Q.uri),index:void 0})));for(let Q=0;Q<q.length;Q++){const X=q[Q];if(q.some((ae,ie)=>ie!==Q&&a(X.uri,ae.uri,this.s)))return!1}q.forEach((Q,X)=>Q.index=X);const{added:ge,removed:ee}=S(K,q,D,this.s);if(ge.length===0&&ee.length===0)return!1;if(this.o){const Q=O.displayName||O.name;this.o.$updateWorkspaceFolders(Q,M,j,T).then(void 0,X=>{this.n=void 0;const ae={source:{identifier:O.identifier,label:O.displayName||O.name}};this.q.$showMessage(u.Severity.Error,(0,y.localize)(0,null,Q,X.toString()),ae,[])})}return this.y(q),!0}getWorkspaceFolder(O,M){if(this.x)return this.x.getWorkspaceFolder(O,M)}async getWorkspaceFolder2(O,M){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(O,M)}async resolveWorkspaceFolder(O){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(O)}getPath(){if(!this.x)return;const{folders:O}=this.x;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,M){let j,U="";if(typeof O=="string"?(j=w.URI.file(O),U=O):typeof O<"u"&&(j=O,U=O.fsPath),!j)return U;const T=this.getWorkspaceFolder(j,!0);if(!T)return U;typeof M>"u"&&this.x&&(M=this.x.folders.length>1);let K=(0,R.$xg)(T.uri,j);return M&&T.name&&(K=`${T.name}/${K}`),K}y(O){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:O,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:M,added:j,removed:U}=f.toExtHostWorkspace(O,this.l,this.n,this.s);this.l=M||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:U}))}findFiles(O,M,j,U,T=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let K;if(M===null?K=!1:M&&(typeof M=="string"?K=M:K=M.pattern),T&&T.isCancellationRequested)return Promise.resolve([]);const{includePattern:q,folder:ge}=P(h.GlobPattern.from(O));return this.o.$startFileSearch(q??null,ge??null,K??null,j??null,T).then(ee=>Array.isArray(ee)?ee.map(Q=>w.URI.revive(Q)):[])}async findTextInFiles(O,M,j,U,T=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const K=this.j.getNext(),q=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:ge,folder:ee}=P(h.GlobPattern.from(M.include)),Q=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,X={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:q,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:ge,excludePattern:Q},ae=!1;if(this.u[K]=ie=>{if(ae)return;const ce=w.URI.revive(ie.resource);ie.results.forEach(we=>{(0,c.$JI)(we)?j({uri:ce,preview:{text:we.preview.text,matches:(0,C.$2b)(we.preview.matches,H=>new t.$kK(H.startLineNumber,H.startColumn,H.endLineNumber,H.endColumn))},ranges:(0,C.$2b)(we.ranges,H=>new t.$kK(H.startLineNumber,H.startColumn,H.endLineNumber,H.endColumn))}):j({uri:ce,text:we.text,lineNumber:we.lineNumber})})},T.isCancellationRequested)return{};try{const ie=await this.o.$startTextSearch(O,ee??null,X,K,T);return delete this.u[K],ie||{}}catch(ie){throw delete this.u[K],ie}}$handleTextSearchResult(O,M){this.u[M]?.(O)}async save(O){const M=await this.o.$save(O,{saveAs:!1});return w.URI.revive(M)}async saveAs(O){const M=await this.o.$save(O,{saveAs:!0});return w.URI.revive(M)}saveAll(O){return this.o.$saveAll(O)}resolveProxy(O){return this.o.$resolveProxy(O)}get trusted(){return this.v}requestWorkspaceTrust(O){return this.o.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(O,M){if(this.w.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.w.set(O,M);const j=this.t.transformOutgoingScheme(O),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,j),(0,A.$Qc)(()=>{this.w.delete(O),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(O,M){this.h.info("Getting edit session identifier for workspaceFolder",O);const j=await this.resolveWorkspaceFolder(w.URI.revive(O));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const U=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!U),!U)return;const T=await U.provideEditSessionIdentity(j,M);if(this.h.info("Provider returned edit session identifier: ",T),!!T)return T}async $provideEditSessionIdentityMatch(O,M,j,U){this.h.info("Getting edit session identifier for workspaceFolder",O);const T=await this.resolveWorkspaceFolder(w.URI.revive(O));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const K=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!K),!K)return;const q=await K.provideEditSessionIdentityMatch?.(M,j,U);if(this.h.info("Provider returned edit session identifier match result: ",q),!!q)return q}getOnWillCreateEditSessionIdentityEvent(O){return(M,j,U)=>{const T=function(q){M.call(j,q)};return T.extension=O,this.A.event(T,void 0,U)}}async $onWillCreateEditSessionIdentity(O,M,j){const U=await this.resolveWorkspaceFolder(w.URI.revive(O));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},M,async(T,K)=>{const q=Date.now();await Promise.resolve(T),Date.now()-q>j&&this.h.warn("SLOW edit session create-participant",K.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(O,M){if(this.B.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.B.set(O,M);const j=this.t.transformOutgoingScheme(O),U=this.z++;return this.o.$registerCanonicalUriProvider(U,j),(0,A.$Qc)(()=>{this.B.delete(O),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(O,M,j){const U=this.B.get(O.scheme);if(!U)return;const T=await U.provideCanonicalUri?.(w.URI.revive(O),M,j);if(T)return T}async $provideCanonicalUri(O,M,j){return this.provideCanonicalUri(w.URI.revive(O),{targetScheme:M},j)}};e.$lcc=g,e.$lcc=g=He([Be(0,m.$hM),Be(1,s.$xM),Be(2,r.$_bc),Be(3,p.$0i),Be(4,n.$jcc)],g),e.$mcc=(0,k.$Ph)("IExtHostWorkspace");function P(N){let O,M;return N&&(typeof N=="string"?O=N:(O=N.pattern,M=w.URI.revive(N.baseUri))),{includePattern:O,folder:M}}}),define(De[40],Ce([1,0,24,4,39,6,7,245,136,17,8,5,20,14,2]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=e.$ncc=void 0;function p(n,c){if(c){const i=c.split(".");let a=n;for(let l=0;a&&l<i.length;l++)a=a[i[l]];return a}}function u(n){return n instanceof k.URI}function o(n){return n&&n.uri instanceof k.URI&&n.languageId&&typeof n.languageId=="string"}function r(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function s(n){return n&&n.uri instanceof k.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function m(n){if(u(n))return{resource:n};if(o(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(r(n))return{overrideIdentifier:n.languageId};if(s(n))return{resource:n.uri};if(n===null)return{resource:null}}let h=class{constructor(c,i,a){this.a=c.getProxy(L.$gK.MainThreadConfiguration),this.c=i,this.b=a,this.d=new R.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,i){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(c,i))}};e.$ncc=h,e.$ncc=h=He([Be(0,w.$hM),Be(1,d.$mcc),Be(2,y.$0i)],h);class t{constructor(c,i,a,l){this.a=new F.$Nd,this.b=c,this.f=l,this.c=i,this.e=$.$En.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,i){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$En.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(i,a))}getConfiguration(c,i,a){const l=m(i)||{},D=this.g(c?p(this.e.getValue(void 0,l,this.c.workspace),c):this.e.getValue(void 0,l,this.c.workspace));c&&this.h(c,l,a?.identifier);function S(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(f){return typeof p(D,f)<"u"},get:(f,g)=>{this.h(c?`${c}.${f}`:f,l,a?.identifier);let P=p(D,f);if(typeof P>"u")P=g;else{let N;const O=(M,j)=>{if((0,v.$Af)(M)){let U;const T=()=>{N=N||(0,C.$7m)(D),U=U||p(N,j)};return new Proxy(M,{get:(K,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return T(),()=>U;if(N)return U=U||p(N,j),U[q];const ge=K[q];return typeof q=="string"?O(ge,`${j}.${q}`):ge},set:(K,q,ge)=>(T(),U&&(U[q]=ge),!0),deleteProperty:(K,q)=>(T(),U&&delete U[q],!0),defineProperty:(K,q,ge)=>(T(),U&&Object.defineProperty(U,q,ge),!0)})}return Array.isArray(M)?(0,C.$7m)(M):M};P=O(P,f)}return P},update:(f,g,P,N)=>{f=c?`${c}.${f}`:f;const O=S(P);return g!==void 0?this.b.$updateConfigurationOption(O,f,g,l,N):this.b.$removeConfigurationOption(O,f,l,N)},inspect:f=>{f=c?`${c}.${f}`:f;const g=this.e.inspect(f,l,this.c.workspace);if(g)return{key:f,defaultValue:(0,C.$7m)(g.policy?.value??g.default?.value),globalValue:(0,C.$7m)(g.user?.value??g.application?.value),workspaceValue:(0,C.$7m)(g.workspace?.value),workspaceFolderValue:(0,C.$7m)(g.workspaceFolder?.value),defaultLanguageValue:(0,C.$7m)(g.default?.override),globalLanguageValue:(0,C.$7m)(g.user?.override??g.application?.override),workspaceLanguageValue:(0,C.$7m)(g.workspace?.override),workspaceFolderLanguageValue:(0,C.$7m)(g.workspaceFolder?.override),languageIds:(0,C.$7m)(g.overrideIdentifiers)}}};return typeof D=="object"&&(0,C.$0m)(b,D,!1),Object.freeze(b)}g(c){const i=a=>(0,v.$Af)(a)?new Proxy(a,{get:(l,D)=>i(l[D]),set:(l,D,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(l,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(l,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return i(c)}h(c,i,a){const l=E.$vn.test(c)?4:this.d.get(c),D=a?`[${a.value}] `:"";if(l===4){typeof i?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){i?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,i){const a=new $.$Gn(c,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,D)=>a.affectsConfiguration(l,m(D))})}k(c){return c.reduce((i,a)=>(i.set(a[0],a[1]),i),new Map)}}e.$occ=t,e.$pcc=(0,I.$Ph)("IExtHostConfiguration")}),define(De[93],Ce([1,0,2,8,4,6,7,39,70,40,21,45,20,27,5,18,12,14,89,292,9]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=e.$ldc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(O){function M(U){if(U!=null)return U}O.from=M;function j(U){if(U!=null)return U}O.to=j})(h||(h={}));var t;(function(O){function M(U){if(U!=null)return U}O.from=M;function j(U){if(U!=null)return U}O.to=j})(t||(t={}));var n;(function(O){function M(U){if(U!=null)return U}O.from=M;function j(U){if(U!=null)return U}O.to=j})(n||(n={}));var c;(function(O){function M(T){if(T){const K=T;return K&&!!K.process}else return!1}O.is=M;function j(T){if(T==null)return;const K={process:T.process,args:T.args};return T.options&&(K.options=n.from(T.options)),K}O.from=j;function U(T){if(T!=null)return new A.$3K(T.process,T.args,T.options)}O.to=U})(c||(c={}));var i;(function(O){function M(U){if(U!=null)return U}O.from=M;function j(U){if(U!=null)return U}O.to=j})(i||(i={}));var a;(function(O){function M(T){if(T){const K=T;return K&&(!!K.commandLine||!!K.command)}else return!1}O.is=M;function j(T){if(T==null)return;const K={};return T.commandLine!==void 0?K.commandLine=T.commandLine:(K.command=T.command,K.args=T.args),T.options&&(K.options=i.from(T.options)),K}O.from=j;function U(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new A.$4K(T.commandLine,T.options):new A.$4K(T.command,T.args?T.args:[],T.options)}O.to=U})(a||(a={}));var l;(function(O){function M(T){if(T){const K=T;return K&&K.customExecution==="customExecution"}else return!1}O.is=M;function j(T){return{customExecution:"customExecution"}}O.from=j;function U(T,K){return K.get(T)}O.to=U})(l||(e.CustomExecutionDTO=l={}));var D;(function(O){function M(j,U){let T;return j.scope!==void 0&&typeof j.scope!="number"?T=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&U&&U.workspaceFile?T=U.workspaceFile:T=s.$PF),{id:j._id,workspaceFolder:T}}O.from=M})(D||(e.TaskHandleDTO=D={}));var S;(function(O){function M(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}O.from=M})(S||(S={}));var b;(function(O){function M(T,K){if(T==null)return[];const q=[];for(const ge of T){const ee=j(ge,K);ee&&q.push(ee)}return q}O.fromMany=M;function j(T,K){if(T==null)return;let q;T.execution instanceof A.$3K?q=c.from(T.execution):T.execution instanceof A.$4K?q=a.from(T.execution):T.execution&&T.execution instanceof A.$5K&&(q=l.from(T.execution));const ge=h.from(T.definition);let ee;return T.scope?typeof T.scope=="number"?ee=T.scope:ee=T.scope.uri:ee=A.TaskScope.Workspace,!ge||!ee?void 0:{_id:T._id,definition:ge,name:T.name,source:{extensionId:K.identifier.value,label:T.source,scope:ee},execution:q,isBackground:T.isBackground,group:S.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}O.from=j;async function U(T,K,q){if(T==null)return;let ge;c.is(T.execution)?ge=c.to(T.execution):a.is(T.execution)?ge=a.to(T.execution):l.is(T.execution)&&(ge=l.to(T._id,q));const ee=h.to(T.definition);let Q;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Q=T.source.scope:Q=await K.resolveWorkspaceFolder(C.URI.revive(T.source.scope)):Q=A.TaskScope.Workspace),!ee||!Q)return;const X=new A.$6K(ee,Q,T.name,T.source.label,ge,T.problemMatchers);return T.isBackground!==void 0&&(X.isBackground=T.isBackground),T.group!==void 0&&(X.group=A.$2K.from(T.group._id),X.group&&T.group.isDefault&&(X.group=new A.$2K(X.group.id,X.group.label),T.group.isDefault===!0&&(X.group.isDefault=T.group.isDefault))),T.presentationOptions&&(X.presentationOptions=t.to(T.presentationOptions)),T._id&&(X._id=T._id),T.detail&&(X.detail=T.detail),X}O.to=U})(b||(e.TaskDTO=b={}));var f;(function(O){function M(U){return U}O.from=M;function j(U){if(U)return Object.assign(Object.create(null),U)}O.to=j})(f||(f={}));class g{#e;constructor(M,j,U){this._id=j,this.a=U,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let P=class{constructor(M,j,U,T,K,q,ge,ee){this.q=new d.$Nd,this.r=new d.$Nd,this.s=new d.$Nd,this.t=new d.$Nd,this.a=M.getProxy(L.$gK.MainThreadTask),this.b=U,this.c=T,this.d=K,this.e=q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,j,U){if(!U)return new A.$iK(()=>{});const T=this.w();return this.j.set(T,{type:j,provider:U,extension:M}),this.a.$registerTaskProvider(T,j),new A.$iK(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(M,j){this.a.$registerTaskSystem(M,j)}fetchTasks(M){return this.a.$fetchTasks(f.from(M)).then(async j=>{const U=[];for(const T of j){const K=await b.to(T,this.b,this.m);K&&U.push(K)}return U})}get taskExecutions(){const M=[];return this.k.forEach(j=>M.push(j)),M}terminateTask(M){if(!(M instanceof g))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,j,U){const T=this.m.get(M.id);T&&(this.o.set(M.id,T),this.e.attachPtyToTerminal(j,await T.callback(U))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const j=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const j=await this.y(M.id);this.s.fire({execution:j,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const j=await this.y(M.id);this.t.fire({execution:j,exitCode:M.exitCode})}$provideTasks(M,j){const U=this.j.get(M);if(!U)return Promise.reject(new Error("no handler found"));const T=[],K=(0,F.$Mg)(()=>U.provider.provideTasks(R.CancellationToken.None)).then(q=>this.u(j,T,U,q));return new Promise(q=>{K.then(ge=>{Promise.all(T).then(()=>{q(ge)})})})}async $resolveTask(M,j){const U=this.j.get(M);if(!U)return Promise.reject(new Error("no handler found"));if(j.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${U.type}].`);const T=await b.to(j,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const K=await U.provider.resolveTask(T,R.CancellationToken.None);if(!K)return;this.z(K,U);const q=b.from(K,U.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(q.execution)&&await this.x(q,K,!0),await this.v(q)}w(){return this.h++}async x(M,j,U){const T=await this.a.$createTaskId(M);!U&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,j.execution)),this.m.set(T,j.execution)}async y(M,j){if(typeof M=="string"){const K=this.l.get(M);if(!K)throw new m.$bb("Unexpected: The specified task is missing an execution");return K}const U=this.l.get(M.id);if(U)return U;const T=new Promise((K,q)=>{function ge(ee,Q,X){X?K(new g(ee,Q.id,X)):q("Unexpected: Task does not exist.")}j?ge(this,M,j):b.to(M.task,this.b,this.m).then(ee=>ge(this,M,ee))});return this.l.set(M.id,T),T.then(K=>(this.k.set(M.id,K),K),K=>Promise.reject(K))}z(M,j){M._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const U=this.n.values();let T=U.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=U.next()}};e.$ldc=P,e.$ldc=P=He([Be(0,w.$hM),Be(1,y.$xM),Be(2,$.$mcc),Be(3,E.$sM),Be(4,v.$pcc),Be(5,I.$Hcc),Be(6,o.$0i),Be(7,r.$ccc)],P);let N=class extends P{constructor(M,j,U,T,K,q,ge,ee){super(M,j,U,T,K,q,ge,ee),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:u.$i(0)})}async executeTask(M,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const U=b.from(j,M);if(U===void 0)throw new Error("Task is not valid");if(l.is(U.execution))await this.x(U,j,!1);else throw new m.$_;const T=await this.y(await this.a.$getTaskExecution(U),j);return this.a.$executeTask(U).catch(K=>{throw new Error(K)}),T}u(M,j,U,T){const K=[];if(T)for(const q of T){this.z(q,U),(!q.definition||!M[q.definition.type])&&this.f.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const ge=b.from(q,U.extension);ge&&l.is(ge.execution)?(K.push(ge),j.push(this.x(ge,q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:U.extension}}async v(M){if(l.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,j,U){}};e.$mdc=N,e.$mdc=N=He([Be(0,w.$hM),Be(1,y.$xM),Be(2,$.$mcc),Be(3,E.$sM),Be(4,v.$pcc),Be(5,I.$Hcc),Be(6,o.$0i),Be(7,r.$ccc)],N),e.$ndc=(0,k.$Ph)("IExtHostTask")}),define(De[349],Ce([1,0,16,21,41,35,23,37,36]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class v{constructor(w,y,k){this.k=w,this.l=y,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&L.$wj(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&L.$wj(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const y=this.k.folderQueries||[];return new Promise((k,p)=>{const u=o=>{this.f++,w(o)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const r=o.toString(),s=C.$nc(r);this.j&&this.j(r,s)||this.v(u,{base:o,basename:s})}),Promise.all(y.map(o=>this.p(o,u))).then(o=>{k({limitHit:this.e,stats:o[0]||void 0})},o=>{p(new Error((0,d.$Ai)(o)))})})}async p(w,y){const k=new F.$Xd,p=this.q(w),u=this.r(),o=new E.$2I(this.k,w),r=!o.hasSiblingExcludeClauses();let s;try{this.h.add(k),s=$.$Jd.create();const m=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},p,k.token),h=s.elapsed(),t=$.$Jd.create();return this.g&&!this.e||(m&&m.forEach(n=>{const c=C.$gc.relative(w.folder.path,n.path);if(r){const i=C.$nc(n.path);this.v(y,{base:w.folder,relativePath:c,basename:i});return}this.s(u,w.folder,c,y)}),this.g&&!this.e)?null:(this.u(u,o,y),{providerTime:h,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(w){const y=(0,E.$1I)(this.k.includePattern,w.includePattern),k=(0,E.$1I)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:k,includes:y,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},y,k,p){if(k===this.a){const o=C.$nc(this.a);this.v(p,{base:y,relativePath:this.a,basename:o})}function u(o){const r=C.$nc(o),s=C.$mc(o);let m=w[s];m||(m=w[s]=[],u(s)),m.push({base:y,relativePath:o,basename:r})}u(k)}u({rootEntries:w,pathToEntries:y},k,p){const u=this,o=this.a;function r(s){const m=(0,E.$4I)(()=>s.map(h=>h.basename));for(let h=0,t=s.length;h<t;h++){const n=s[h],{relativePath:c,basename:i}=n;if(k.matchesExcludesSync(c,i,o!==i?m:void 0))continue;const a=y[c];if(a)r(a);else{if(c===o)continue;u.v(p,n)}if(u.e)break}}r(w)}v(w,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(y))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(w,y,k,p){const u=this.c(w.cacheKey),o=new v(w,y,u&&u.token);let r=0;const s=m=>{r+=m.length,k(m.map(h=>this.d(h)))};return this.e(o,R.a,s,p).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:m.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(w)return this.b.has(w)||this.b.set(w,new F.$Xd),this.b.get(w)}d(w){return w.relativePath?{resource:A.$vg(w.base,w.relativePath)}:{resource:w.base}}e(w,y,k,p){const u=p.onCancellationRequested(()=>{w.cancel()}),o=s=>{s&&(r.push(s),y>0&&r.length>=y&&(k(r),r=[]))};let r=[];return w.search(o).then(s=>(r.length&&k(r),u.dispose(),s),s=>(r.length&&k(r),u.dispose(),Promise.reject(s)))}}e.$xdc=R}),define(De[350],Ce([1,0,19,74,35,99,28,18,16,23,15,17,2,172,226,50,14,44,143,347,36]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=void 0;let h=class{constructor(f,g,P,N,O){this.a=f,this.b=g,this.c=P,this.d=N,this.e=O}text(f,g,P={}){f=this.f(f,P);const N=this.a.getValue(),O=g&&g.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(g?.map(o.$$h),P),type:2,contentPattern:f,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:N.search.usePCRE2||O||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(f,g){const P=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const N={...f,wordSeparators:P.editor.wordSeparators};return this.j(f,g)&&(N.isCaseSensitive=!0),this.k(f)&&(N.isMultiline=!0),g.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=g.notebookSearchConfig.includeMarkupInput),g.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=g.notebookSearchConfig.includeMarkupPreview),g.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=g.notebookSearchConfig.includeCodeInput),g.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=g.notebookSearchConfig.includeOutput),N}file(f,g={}){return{...this.h(f,g),type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey}}g(f,g){return f?(f=Array.isArray(f)?f.map(a):a(f),g?this.parseSearchPaths(f):{pattern:n(...Array.isArray(f)?f:[f])}):{}}h(f=[],g={}){const P=this.g(g.includePattern,g.expandPatterns),N=this.g(g.excludePattern,g.expandPatterns),O=f.length>1,M=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(T=>this.q(T,g,N)):f.map(T=>this.r(T,g,N,O))).filter(T=>!!T),j={_reason:g._reason,folderQueries:M,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:N.pattern,includePattern:P.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const T=C.$Hb(C.$Rb(this.c.groups.map(ge=>ge.editors.map(ee=>ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const K=T.filter(ge=>(0,m.$RI)(j,ge.fsPath)),q=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...j,...q}}const U=g.extraFileResources&&g.extraFileResources.filter(T=>(0,m.$RI)(j,T.fsPath));return j.extraFileResources=U&&U.length?U:void 0,j}i(f){const g=[],P=new A.$Ac,N={};let O=!1;return f.forEach(M=>{if(M.scheme===$.Schemas.walkThrough)return;if((0,v.$zg)(M)){const U=this.b.getWorkspaceFolder(M)?.uri??M.with({path:E.$mc(M.fsPath)});let T=P.get(U);T||(O=!0,T={folder:U,includePattern:{}},g.push(T),P.set(U,T));const K=E.$lc(U.fsPath,M.fsPath);(0,I.$Jf)(T.includePattern)[K.replace(/\\/g,"/")]=!0}else M.fsPath&&(O=!0,N[M.fsPath]=!0)}),{folderQueries:g,includePattern:N,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(f,g){if(g.isSmartCase){if(f.isRegExp){if(R.$pf(f.pattern,!0))return!0}else if(R.$pf(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,y.$uB)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const g=q=>E.$ic(q)||/^\.\.?([\/\\]|$)/.test(q),N=(Array.isArray(f)?f:c(f)).map(q=>{const ge=this.e.resolvedUserHome;return ge?(0,L.$uv)(q,ge.scheme===$.Schemas.file?ge.fsPath:ge.path):q}),O=F.$J(N,q=>g(q)?"searchPaths":"exprSegments"),M=(O.exprSegments||[]).map(q=>R.$Ke(q,"/")).map(q=>R.$Ke(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),i(q))),j={},U=this.m(O.searchPaths||[]);U&&U.length&&(j.searchPaths=U);const T=C.$Rb(M),K=n(...T);return K&&(j.pattern=K),j}l(f,g){return g.disregardExcludeSettings?void 0:(0,m.$QI)(f,!g.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const g=f.flatMap(N=>{let{pathPortion:O,globPortion:M}=t(N);return M&&(M=l(M)),this.n(O).flatMap(U=>this.o(U,M))}),P=new Map;return g.forEach(N=>{const O=N.searchPath.toString(),M=P.get(O);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):P.set(O,{searchPath:N.searchPath,pattern:N.pattern?n(N.pattern):void 0})}),Array.from(P.values())}n(f){if(E.$ic(f)){const g=this.b.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==$.Schemas.file?[{searchPath:g[0].uri.with({path:f})}]:[{searchPath:w.URI.file(E.$hc(f))}]}if(this.b.getWorkbenchState()===2){const g=this.b.getWorkspace().folders[0].uri;if(f=a(f),f.startsWith("../")||f===".."){const N=E.$gc.resolve(g.path,f);return[{searchPath:g.with({path:N})}]}const P=l(f);return[{searchPath:g,pattern:P}]}else{if(f==="./"||f===".\\")return[];{const g=f.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(O=>{const M=g.match(new RegExp(`^${R.$Fe(O.name)}(?:/(.*)|$)`));return M?{match:M,folder:O}:null}).filter(I.$Gf);if(N.length)return N.map(O=>{const M=O.match[1];return{searchPath:O.folder.uri,pattern:M&&l(M)}});{const O=f.match(/\.[\/\\](.+)[\/\\]?/),M=O?O[1]:f,j=k.localize(0,null,M);throw new Error(j)}}}}o(f,g){const P=f.pattern&&g?`${f.pattern}/${g}`:f.pattern||g,N=[{searchPath:f.searchPath,pattern:P}];return P&&!P.endsWith("**")&&N.push({searchPath:f.searchPath,pattern:P+"/**"}),N}q(f,g,P){const N=this.r((0,o.$$h)(f.searchPath),g,P,!1);return N?{...N,includePattern:f.pattern}:null}r(f,g,P,N){let O;const M=w.URI.isUri(f)?f:f.uri;if(P.searchPaths){const q=P.searchPaths.filter(ge=>(0,v.$og)(ge.searchPath,M))[0];if(q&&!q.pattern)return null;q&&(O=q.pattern)}const j=this.a.getValue({resource:M}),T={...this.l(j,g)||{},...O||{}},K=w.URI.isUri(f)?(0,v.$sg)(f):f.name;return{folder:M,folderName:N?K:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!j.search.followSymlinks}}};e.$WJ=h,e.$WJ=h=He([Be(0,p.$ji),Be(1,o.$Yh),Be(2,r.$eC),Be(3,u.$0i),Be(4,s.$UJ)],h);function t(b){const f=b.match(/[\*\{\}\(\)\[\]\?]/);if(f){const g=f.index,P=b.substr(0,g).match(/[/|\\][^/\\]*$/);if(P){let N=b.substr(0,P.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:b.substr((P.index||0)+1)}}}return{pathPortion:b}}function n(...b){return b.length?b.reduce((f,g)=>(f[g]=!0,f),Object.create(null)):void 0}function c(b){return d.$uj(b,",").map(f=>f.trim()).filter(f=>!!f.length)}function i(b){return[`**/${b}/**`,`**/${b}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function a(b){return b.replace(/\\/g,"/")}function l(b){return a(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(b){return b.replace(/([?*[\]])/g,"[$1]")}function S(b,f){b=C.$Mb(b,N=>N.toString());const g=[],P=f.getWorkspace();return b&&b.forEach(N=>{let O;if(f.getWorkbenchState()===2)O=(0,v.$xg)(P.folders[0].uri,N),O&&O!=="."&&(O="./"+O);else{const M=f.getWorkspaceFolder(N);if(M){const j=M.name;if(P.folders.filter(T=>T.name===j).length===1){const T=(0,v.$xg)(M.uri,N);T===""?O=`./${M.name}`:O=`./${M.name}/${T}`}else O=N.fsPath}}O&&g.push(D(O))}),g}e.$XJ=S}),define(De[351],Ce([1,0,23,2,21,9,5,350,36,44]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alb=e.$zlb=void 0;const R=7e3;function I(p,u){const o=u.activationEvents;if(!o)return Promise.resolve(void 0);const r=[],s=[];for(const i of o)if(/^workspaceContains:/.test(i)){const a=i.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||p.forceUsingSearch?s.push(a):r.push(a)}if(r.length===0&&s.length===0)return Promise.resolve(void 0);let m;const h=new Promise((i,a)=>{m=i}),t=i=>m({activationEvent:i}),n=Promise.all(r.map(i=>w(p,i,t))).then(()=>{}),c=y(p,u.identifier,s,t);return Promise.all([n,c]).then(()=>{m(void 0)}),h}e.$zlb=I;async function w(p,u,o){for(const r of p.folders)if(await p.exists(C.$vg(F.URI.revive(r),u))){o(`workspaceContains:${u}`);return}}async function y(p,u,o,r){if(o.length===0)return Promise.resolve(void 0);const s=new d.$Xd,m=p.checkExists(p.folders,o,s.token),h=setTimeout(async()=>{s.cancel(),p.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},R);let t=!1;try{t=await m}catch(n){L.$4(n)||L.$1(n)}s.dispose(),clearTimeout(h),t&&r(`workspaceContains:${o.join(",")}`)}function k(p,u,o,r){const s=p.get(A.$Oh),m=p.get(E.$II),t=s.createInstance($.$WJ).file(u.map(n=>(0,v.$$h)(F.URI.revive(n))),{_reason:"checkExists",includePattern:o,exists:!0});return m.fileSearch(t,r).then(n=>!!n.limitHit,n=>L.$4(n)?!1:Promise.reject(n))}e.$Alb=k}),define(De[46],Ce([1,0,204,16,54,23,8,3,78,2,14,6,40,287,115,39,26,148,9,25,22,262,7,65,5,27,90,20,104,73,45,4,351,114,264,18,112,37,12,113]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h,t,n,c,i,a,l,D,S,b,f,g,P,N,O,M,j,U,T){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=e.$Ucc=e.$Tcc=e.$Scc=void 0,e.$Scc=(0,c.$Ph)("IHostUtils");let q=K=class extends $.$Sc{constructor(H,B,J,re,Y,_,x,pe,ue,fe,te,de){super(),this.X=de,this.a=this.B(new f.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=J,this.f=x,this.j=re,this.m=Y,this.s=_,this.t=ue,this.u=fe,this.w=te,this.y=this.g.getProxy(I.$gK.MainThreadWorkspace),this.z=this.g.getProxy(I.$gK.MainThreadTelemetry),this.C=this.g.getProxy(I.$gK.MainThreadExtensionService),this.D=new A.$Sg,this.F=new A.$Sg,this.G=new A.$Sg,this.H=new A.$Sg,this.I=new ce(this.f.extensions.activationEvents),this.L=new o.$k4b(this.I,this.f.extensions.allExtensions);const be=new s.$7l(this.f.extensions.myExtensions);this.J=new o.$k4b(this.I,ae(this.L,be)),U.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new k.$zcc(this.g,this.s),this.N=new P.$Lcc(this.g),this.O=pe,this.h=H.createChild(new D.$Nh([k.$Acc,this.M],[P.$Mcc,this.N])),this.P=this.B(new y.$ycc(this.J,this.L,{onExtensionActivationError:(Pe,z,G)=>{this.C.$onExtensionActivationError(Pe,r.$3(z),G)},actualActivateExtension:async(Pe,z)=>{if(o.$k4b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,z),new y.$xcc;const G=this.J.getExtensionDescription(Pe);return this.db(G,z)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),d.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(H){r.$1(H)}}async Y(){this.O.onWillDeactivateAll();let H=[];try{H=this.J.getAllExtensionDescriptions().map(Y=>Y.identifier).filter(Y=>this.isActivated(Y)).map(Y=>this.cb(Y))}catch{}await Promise.all(H)}terminate(H,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${H}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(re=>{this.s.error(re)}),this.g.dispose();const J=this.Y();Promise.race([(0,A.$Ug)(5e3),J]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(H){return this.G.isOpen()?this.P.isActivated(H):!1}async getExtension(H){const B=await this.C.$getExtension(H);return B&&{...B,identifier:new s.$6l(B.identifier.value),extensionLocation:v.URI.revive(B.extensionLocation)}}Z(H,B){return this.P.activateByEvent(H,B)}$(H,B){return this.P.activateById(H,B)}activateByIdWithErrors(H,B){return this.$(H,B).then(()=>{const J=this.P.getActivatedExtension(H);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(H=>this.J)}getExtensionExports(H){if(this.G.isOpen())return this.P.getActivatedExtension(H).exports;try{return this.P.getActivatedExtension(H).exports}catch{return null}}async ab(H){if(H.scheme===O.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(H.fsPath);return v.URI.file(B)}return H}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(H=>new ie(H))),this.Q}async bb(H){const B=E.$Vh.forUris(J=>L.$mg.ignorePathCasing(J));return await Promise.all(H.map(async J=>{if(this.ub(J)){const re=await this.ab(J.extensionLocation);B.set(re,J)}})),B}cb(H){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(H))return B;const J=this.P.getActivatedExtension(H);if(!J)return B;try{typeof J.module.deactivate=="function"&&(B=Promise.resolve(J.module.deactivate()).then(void 0,re=>(this.s.error(re),Promise.resolve(void 0))))}catch(re){this.s.error(`An error occurred when deactivating the extension '${H.value}':`),this.s.error(re)}try{(0,$.$Nc)(J.subscriptions)}catch(re){this.s.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.s.error(re)}return B}async db(H,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(H.identifier):await this.C.$onWillActivateExtension(H.identifier),this.fb(H,B).then(J=>{const re=J.activationTimes;return this.C.$onDidActivateExtension(H.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,B),this.eb(H,B,"success",re),J},J=>{throw this.eb(H,B,"failure"),J})}eb(H,B,J,re){const Y=ee(H,B);this.z.$publicLog2("extensionActivationTimes",{...Y,...re||{},outcome:J})}fb(H,B){const J=ee(H,B);this.z.$publicLog2("activatePlugin",J);const re=this.ub(H);if(!re)return Promise.resolve(new y.$wcc(y.$tcc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${H.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const Y=new y.$ucc(B.startup);return Promise.all([this.vb(H,(0,L.$vg)(H.extensionLocation,re),Y),this.gb(H)]).then(_=>(d.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),K.hb(this.s,H.identifier,_[0],_[1],Y))).then(_=>(d.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),_))}gb(H){const B=new h.$Ccc(H,this.M),J=new h.$Bcc(H.identifier.value,!1,this.M),re=new N.$Ncc(H,this.N),Y=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,_=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([B.whenReady,J.whenReady,this.O.whenReady]).then(()=>{const x=this;let pe,ue;const fe=(0,u.$dF)(H,"ipc")?this.f.messagePorts?.get(s.$6l.toKey(H.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:J,secrets:re,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(te){return F.$jc(H.extensionLocation.fsPath,te)},get storagePath(){return x.O.workspaceValue(H)?.fsPath},get globalStoragePath(){return x.O.globalValue(H).fsPath},get logPath(){return F.$jc(x.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return v.URI.joinPath(x.f.logsLocation,H.identifier.value)},get storageUri(){return x.O.workspaceValue(H)},get globalStorageUri(){return x.O.globalValue(H)},get extensionMode(){return Y},get extension(){return pe===void 0&&(pe=new X(x,H.identifier,H,_,!1)),pe},get extensionRuntime(){return(0,u.$eF)(H,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!ue){if(!fe)return;const te=f.Event.buffer(f.Event.fromDOMEventEmitter(fe,"message",de=>de.data));fe.start(),ue={onDidReceiveMessage:te,postMessage:fe.postMessage.bind(fe)}}return ue}})})}static hb(H,B,J,re,Y){return J=J||{activate:void 0,deactivate:void 0},this.ib(H,B,J,re,Y).then(_=>new y.$vcc(!1,null,Y.build(),J,_,re.subscriptions))}static ib(H,B,J,re,Y){if(typeof J.activate=="function")try{Y.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${B.value}`);const _=typeof global=="object"?global:self,x=J.activate.apply(_,[re]);return Y.activateCallStop(),Y.activateResolveStart(),Promise.resolve(x).then(pe=>(Y.activateResolveStop(),pe))}catch(_){return Promise.reject(_)}else return Promise.resolve(J)}jb(H,B){this.$(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:B}).then(void 0,J=>{this.s.error(J)})}kb(H,B=0){const re=Date.now();(0,U.$B)(()=>{for(let Y=B;Y<H.length;Y+=1){const _=H[Y];for(const x of _.activationEvents??[])if(x==="onStartupFinished")if(Date.now()-re>50){this.kb(H,Y);break}else this.jb(_,x)}})}lb(){this.C.$setPerformanceMarks(d.getMarks()),this.m.getConfigProvider().then(H=>{const B=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),J=this.J.getAllExtensionDescriptions();if(B)this.kb(J);else for(const re of J)if(re.activationEvents)for(const Y of re.activationEvents)Y==="onStartupFinished"&&this.jb(re,Y)})}mb(){const H=this.Z("*",!0).then(void 0,_=>{this.s.error(_)});this.B(this.j.onDidChangeWorkspace(_=>this.nb(_.added)));const B=this.j.workspace?this.j.workspace.folders:[],J=this.nb(B),re=this.pb(),Y=Promise.all([re,H,J]).then(()=>{});return Promise.race([Y,(0,A.$Ug)(1e4)]).then(()=>{this.lb()}),Y}nb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(H,B))).then(()=>{})}async ob(H,B){if(this.isActivated(B.identifier))return;const J=!this.f.remote.isRemote&&!!this.f.remote.authority,re={logService:this.s,folders:H.map(_=>_.uri),forceUsingSearch:J||!this.c.fsExists,exists:_=>this.c.fsExists(_.fsPath),checkExists:(_,x,pe)=>this.y.$checkExists(_,x,pe)},Y=await(0,g.$zlb)(re,B);if(Y)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:Y.activationEvent}).then(void 0,_=>this.s.error(_))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(H){throw console.error(H),H}}async qb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:B}=this.f.environment;if(!H||!B)throw new Error(C.localize(0,null));const J=await this.vb(null,B,new y.$ucc(!1));if(!J||typeof J.run!="function")throw new Error(C.localize(1,null,B.toString()));return new Promise((re,Y)=>{const _=(ue,fe)=>{ue?(U.$t&&this.s.error("Test runner called back with error",ue),Y(ue)):(U.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),re(typeof fe=="number"&&fe>0?1:0))},x=(0,L.$jg)(B),pe=J.run(x,_);pe&&pe.then&&pe.then(()=>{U.$t&&this.s.info("Test runner finished successfully."),re(0)}).catch(ue=>{U.$t&&this.s.error("Test runner finished with error",ue),Y(ue instanceof Error&&ue.stack?ue.stack:String(ue))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,B){return this.R[H]=B,(0,$.$Qc)(()=>{delete this.R[H]})}async getRemoteExecServer(H){const{resolver:B}=await this.sb(H);return B?.resolveExecServer?.(H,{resolveAttempt:0})}async sb(H){const B=H.indexOf("+");if(B===-1)throw new t.$oK("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const J=H.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${J}`,!1),{authorityPrefix:J,resolver:this.R[J]}}async $resolveAuthority(H,B){const J=j.$Jd.create(!1),re=()=>`[resolveAuthority(${(0,n.$Tk)(H)},${B})][${J.elapsed()}ms] `,Y=oe=>this.s.info(`${re()}${oe}`),_=oe=>this.s.warn(`${re()}${oe}`),x=(oe,Z=void 0)=>this.s.error(`${re()}${oe}`,Z),pe=oe=>{if(oe instanceof t.$oK)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},ue=async oe=>{Y(`activating resolver for ${oe}...`);const{resolver:Z,authorityPrefix:me}=await this.sb(oe);if(!Z)throw x(`no resolver for ${me}`),new t.$oK(`No remote extension installed to resolve ${me}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Z,authorityPrefix:me,remoteAuthority:oe}},fe=H.split(/@|%40/g).reverse();Y(`activating remote resolvers ${fe.join(" -> ")}`);let te;try{te=await Promise.all(fe.map(ue)).catch(async oe=>{if(!(oe instanceof t.$oK)||oe._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return _(`resolving nested authorities failed: ${oe.message}`),[await ue(H)]})}catch(oe){return pe(oe)}const de=new A.$5g;de.cancelAndSet(()=>Y("waiting..."),1e3);let be,Pe;for(const[oe,{authorityPrefix:Z,resolver:me,remoteAuthority:Ee}]of te.entries())try{if(oe===te.length-1)Y("invoking final resolve()..."),d.mark(`code/extHost/willResolveAuthority/${Z}`),be=await me.resolve(Ee,{resolveAttempt:B,execServer:Pe}),d.mark(`code/extHost/didResolveAuthorityOK/${Z}`),Y("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(me,t.$nK.isManagedResolvedAuthority(be)?be:void 0));else{if(Y(`invoking resolveExecServer() for ${Ee}`),d.mark(`code/extHost/willResolveExecServer/${Z}`),Pe=await me.resolveExecServer?.(Ee,{resolveAttempt:B,execServer:Pe}),!Pe)throw new t.$oK(`Exec server was not available for ${Ee}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);d.mark(`code/extHost/didResolveExecServerOK/${Z}`)}}catch(je){return d.mark(`code/extHost/didResolveAuthorityError/${Z}`),x("returned an error",je),de.dispose(),pe(je)}de.dispose();const z={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},G={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};Y(`returned ${t.$nK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let se;if(t.$nK.isManagedResolvedAuthority(be)){const oe=B;this.X.setFactory(oe,be.makeConnection),se={authority:H,connectTo:new n.$Qk(oe),connectionToken:be.connectionToken}}else se={authority:H,connectTo:new n.$Rk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:se,options:G,tunnelInformation:z}}}async $getCanonicalURI(H,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Tk)(H)})`);const{resolver:J}=await this.sb(H);if(!J)return null;const re=v.URI.revive(B);if(typeof J.getCanonicalURI>"u")return re;const Y=await(0,A.$Mg)(()=>J.getCanonicalURI(re));return Y||re}$startExtensionHost(H){H.toAdd.forEach(re=>re.extensionLocation=v.URI.revive(re.extensionLocation));const{globalRegistry:B,myExtensions:J}=ge(this.I,this.L,this.J,H);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(J),U.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(H,B){return B===1?this.D.wait().then(J=>this.Z(H,!1)):this.G.wait().then(J=>this.Z(H,!1))}async $activate(H,B){return await this.G.wait(),this.J.getExtensionDescription(H)?(await this.$(H,B),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(_=>_.extensionLocation=v.URI.revive(_.extensionLocation));const{globalRegistry:B,myExtensions:J}=ge(this.I,this.L,this.J,H),re=await this.bb(J);return(await this.getExtensionPathIndex()).setSearchTree(re),this.L.set(B.getAllExtensionDescriptions()),this.J.set(J),U.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const B=m.$be.alloc(H),J=Math.random()%256;for(let re=0;re<H;re++)B.writeUInt8(J,re);return B}async $updateRemoteConnectionData(H){this.W=H,this.a.fire()}};e.$Tcc=q,e.$Tcc=q=K=He([Be(0,c.$Oh),Be(1,e.$Scc),Be(2,l.$hM),Be(3,p.$mcc),Be(4,w.$pcc),Be(5,R.$0i),Be(6,i.$xM),Be(7,a.$Fcc),Be(8,S.$6vb),Be(9,b.$Hcc),Be(10,M.$Pcc),Be(11,T.$Qcc)],q);function ge(we,H,B,J){we.addActivationEvents(J.addActivationEvents);const re=new o.$k4b(we,H.getAllExtensionDescriptions());re.deltaExtensions(J.toAdd,J.toRemove);const Y=new s.$7l(B.getAllExtensionDescriptions().map(x=>x.identifier));for(const x of J.myToRemove)Y.delete(x);for(const x of J.myToAdd)Y.add(x);const _=ae(re,Y);return{globalRegistry:re,myExtensions:_}}function ee(we,H){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}function Q(we){return we.getAllExtensionDescriptions().map(H=>H.identifier.value).join(",")}e.$Ucc=(0,c.$Ph)("IExtHostExtensionService");class X{#e;#t;#i;constructor(H,B,J,re,Y){this.#e=H,this.#t=B,this.#i=J.identifier,this.id=J.identifier.value,this.extensionUri=J.extensionLocation,this.extensionPath=F.$hc((0,L.$jg)(J.extensionLocation)),this.packageJSON=J,this.extensionKind=re,this.isFromDifferentExtensionHost=Y}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Vcc=X;function ae(we,H){return we.getAllExtensionDescriptions().filter(B=>H.has(B.identifier))}class ie{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$Wcc=ie;class ce{constructor(H){this.a=new s.$8l,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)}addActivationEvents(H){for(const B of Object.keys(H))this.a.set(B,H[B])}}}),define(De[352],Ce([1,0,54,2,6,40,26,25,20,27,5,46,14,15]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;let p=class{constructor(m,h,t,n,c,i,a){this.c=m,this.d=h,this.e=t,this.f=n,this.g=c,this.h=i,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const m=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new o(this.c,h,this.d,m,this.i)),this.register(this.e.createInstance(u)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,h,this.h.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const h of m.nodeModuleName)this.a.set(h,m);else this.a.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this.b.push(h=>m.alternativeModuleName(h))}};e.$iec=p,e.$iec=p=He([Be(2,R.$Oh),Be(3,L.$pcc),Be(4,I.$Ucc),Be(5,v.$xM),Be(6,w.$0i)],p);let u=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(m){if(m.environment.appRoot&&k.a.size){const h=(0,y.$Fe)(this.c(m.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(m){if(!this.b)return;const h=this.b.exec(this.c(m));if(!h)return;const[,t,n,c]=h,i=k.a.get(n);if(i!==void 0)return console.warn(`${n} as been renamed to ${i}, please update your imports`),t+i+c}c(m){return m.replace(/\\/g,"/")}};u=k=He([Be(0,v.$xM)],u);class o{constructor(m,h,t,n,c){this.c=m,this.d=h,this.e=t,this.f=n,this.g=c,this.nodeModuleName="vscode",this.a=new $.$8l}load(m,h){const t=this.d.findSubstr(h);if(t){let n=this.a.get(t.identifier);return n||(n=this.c(t,this.e,this.f),this.a.set(t.identifier,n)),n}if(!this.b){let n="";this.d.forEach((c,i)=>n+=`	${i} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${n}`),this.b=this.c(A.$$E,this.e,this.f)}return this.b}}let r=class{constructor(m,h,t){this.e=m,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(d.$gK.MainThreadTelemetry);const n=t.getProxy(d.$gK.MainThreadWindow);this.c=(c,i)=>{const a=F.URI.parse(c);return i?this.g(c,i):a.scheme==="http"||a.scheme==="https"?n.$openUri(a,c,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?n.$openUri(a,c,{}):this.g(c,i)}}load(m,h,t){const n=this.e.findSubstr(h);return n&&(this.a=n.identifier.value,this.h()),this.b=t(m),this.c}g(m,h){return this.i(),this.b(m,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=He([Be(2,E.$hM)],r)}),define(De[56],Ce([1,0,47,3,16,48,5,70,71,46,7,39,279,40]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.$qdc=void 0,e.$qdc=(0,A.$Ph)("IExtHostVariableResolverProvider");class k extends w.$iN{constructor(o,r,s,m,h,t,n){function c(){if(s){const i=s.activeEditor();if(i)return i.document.uri;const a=m.tabGroups.all.find(l=>l.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof R.$1L||a.input instanceof R.$6L)return a.input.modified;if(a.input instanceof R.$ZL||a.input instanceof R.$5L||a.input instanceof R.$3L)return a.input.uri}}}super({getFolderUri:i=>{const a=t.folders.filter(l=>l.name===i);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,a)=>h.getConfiguration(void 0,i).get(a),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=c();if(i)return d.$hc(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const i=c();if(i){const a=r.getWorkspaceFolder(i);if(a)return d.$hc(a.uri.fsPath)}}},getSelectedText:()=>{if(s){const i=s.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(s){const i=s.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>o.getExtension(i)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(L.env))}}let p=class extends F.$Sc{constructor(o,r,s,m,h){super(),this.b=o,this.c=r,this.g=s,this.h=m,this.j=h,this.a=new C.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$rdc=p,e.$rdc=p=He([Be(0,v.$Ucc),Be(1,I.$mcc),Be(2,$.$sM),Be(3,y.$pcc),Be(4,E.$odc)],p)}),define(De[94],Ce([1,0,8,4,2,5,6,71,46,20,7,39,140,272,40,56]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=e.$udc=e.$tdc=e.$sdc=void 0,e.$sdc=(0,L.$Ph)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,c,i,a,l,D){this.E=c,this.F=i,this.G=a,this.H=l,this.I=D,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Nd,this.n=new F.$Nd,this.o=new F.$Nd,this.u=new F.$Nd,this.k=n.getProxy(A.$gK.MainThreadDebugService),this.y=new F.$Nd,this.A=new F.$Nd,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(b=>{this.J(S)}),this.J(S)})}asDebugSourceUri(n,c){const i=n;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let a=`debug:${encodeURIComponent(i.path||"")}`,l="?";return c&&(a+=`${l}session=${encodeURIComponent(c.id)}`,l="&"),a+=`${l}ref=${i.sourceReference}`,d.URI.parse(a)}else{if(i.path)return d.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const c=[];for(const i of n.getAllExtensionDescriptions())if(i.contributes){const a=i.contributes.debuggers;if(a&&a.length>0)for(const l of a)(0,y.$sF)(l)&&c.push(l.type)}this.k.$registerDebugTypes(c)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(c=>n.push(c)),n}addBreakpoints(n){const c=n.filter(l=>{const D=l.id;return this.w.has(D)?!1:(this.w.set(D,l),!0)});this.U(c,[],[]);const i=[],a=new Map;for(const l of c)if(l instanceof R.$hL){let D=a.get(l.location.uri.toString());D||(D={type:"sourceMulti",uri:l.location.uri,lines:[]},a.set(l.location.uri.toString(),D),i.push(D)),D.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof R.$iL&&i.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(n){const c=n.filter(D=>this.w.delete(D.id));this.U([],c,[]);const i=c.filter(D=>D instanceof R.$hL).map(D=>D.id),a=c.filter(D=>D instanceof R.$iL).map(D=>D.id),l=c.filter(D=>D instanceof R.$jL).map(D=>D.id);return this.k.$unregisterBreakpoints(i,a,l)}startDebugging(n,c,i){return this.k.$startDebugging(n?n.uri:void 0,c,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,c,i){if(!c)return new R.$iK(()=>{});const a=this.d++;return this.f.push({type:n,handle:a,provider:c}),this.k.$registerDebugConfigurationProvider(n,i,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,a),new R.$iK(()=>{this.f=this.f.filter(l=>l.provider!==c),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(n,c,i){if(!i)return new R.$iK(()=>{});if(!this.Q(n,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.N(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:c,handle:a,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(c,a),new R.$iK(()=>{this.h=this.h.filter(l=>l.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(n,c){if(!c)return new R.$iK(()=>{});const i=this.i++;return this.j.push({type:n,handle:i,factory:c}),new R.$iK(()=>{this.j=this.j.filter(a=>a.factory!==c)})}async $runInTerminal(n,c){return Promise.resolve(void 0)}async $substituteVariables(n,c){let i;const a=await this.W(n);return a&&(i={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,c)}K(n,c){if(n.type==="implementation")return new m(n.implementation)}L(){}async $startDASession(n,c){const i=this,a=await this.V(c);return this.S(this.N(a.type),a).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const D=this.M(l),S=this.K(D,a);if(!S)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const b=S;return this.B.set(n,b),this.R(a).then(f=>(f&&this.C.set(n,f),b.onMessage(async g=>{if(g.type==="request"&&g.command==="handshake"){const P=g,N={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(P.arguments.value);N.body={signature:O},b.sendResponse(N)}else throw new Error("no signer")}catch(O){N.success=!1,N.message=O.message,b.sendResponse(N)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(g),g=(0,y.$xF)(g,!0),i.k.$acceptDAMessage(n,g)}),b.onError(g=>{f&&f.onError&&f.onError(g),this.k.$acceptDAError(n,g.name,g.message,g.stack)}),b.onExit(g=>{f&&f.onExit&&f.onExit(g??void 0,void 0),this.k.$acceptDAExit(n,g??void 0,void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),b.startSession()))})}$sendDAMessage(n,c){c=(0,y.$wF)(c,!1);const i=this.C.get(n);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(c),this.B.get(n)?.sendMessage(c)}$stopDASession(n){const c=this.C.get(n);this.C.delete(n),c&&c.onWillStopSession&&c.onWillStopSession();const i=this.B.get(n);return this.B.delete(n),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const c=[],i=[],a=[];if(n.added)for(const l of n.added){const D=l.id;if(D&&!this.w.has(D)){let S;if(l.type==="function")S=new R.$iL(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")S=new R.$jL(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const b=d.URI.revive(l.uri);S=new R.$hL(new R.$uK(b,new R.$jK(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,R.$fL)(S,D),this.w.set(D,S),c.push(S)}}if(n.removed)for(const l of n.removed){const D=this.w.get(l);D&&(this.w.delete(l),i.push(D))}if(n.changed){for(const l of n.changed)if(l.id){const D=this.w.get(l.id);if(D){if(D instanceof R.$iL&&l.type==="function"){const S=D;S.enabled=l.enabled,S.condition=l.condition,S.hitCondition=l.hitCondition,S.logMessage=l.logMessage,S.functionName=l.functionName}else if(D instanceof R.$hL&&l.type==="source"){const S=D;S.enabled=l.enabled,S.condition=l.condition,S.hitCondition=l.hitCondition,S.logMessage=l.logMessage,S.location=new R.$uK(d.URI.revive(l.uri),new R.$jK(l.line,l.character))}a.push(D)}}}this.U(c,i,a)}async $acceptStackFrameFocus(n){let c;const i=n.sessionId?await this.V(n.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?c=new R.$pL(i,n.threadId):c=new R.$oL(i,n.threadId,n.frameId),this.z=c,this.A.fire(this.z)}$provideDebugConfigurations(n,c,i){return(0,C.$Mg)(async()=>{const a=this.P(n);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(c);return a.provideDebugConfigurations(l,i)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(n,c,i,a){return(0,C.$Mg)(async()=>{const l=this.P(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.W(c);return l.resolveDebugConfiguration(D,i,a)})}$resolveDebugConfigurationWithSubstitutedVariables(n,c,i,a){return(0,C.$Mg)(async()=>{const l=this.P(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.W(c);return l.resolveDebugConfigurationWithSubstitutedVariables(D,i,a)})}async $provideDebugAdapter(n,c){const i=this.O(n);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(c);return this.S(i,a).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(n){const c=await this.V(n);this.m.fire(c)}async $acceptDebugSessionTerminated(n){const c=await this.V(n);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,c){(await this.V(n))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(n,c){const a={session:await this.V(n),event:c.event,body:c.body};this.u.fire(a)}M(n){if(n instanceof R.$kL)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof R.$lL)return{type:"server",port:n.port,host:n.host};if(n instanceof R.$mL)return{type:"pipeServer",path:n.path};if(n instanceof R.$nL)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const c=this.h.filter(i=>i.type===n);if(c.length>0)return c[0].factory}O(n){const c=this.h.filter(i=>i.handle===n);if(c.length>0)return c[0].factory}P(n){const c=this.f.filter(i=>i.handle===n);if(c.length>0)return c[0].provider}Q(n,c){if(n.contributes){const i=n.contributes.debuggers;if(i&&i.length>0){for(const a of i)if(a.label&&a.type&&a.type===c)return!0}}return!1}R(n){const i=n.configuration.type,a=this.j.filter(l=>l.type===i||l.type==="*").map(l=>(0,C.$Mg)(()=>l.factory.createDebugAdapterTracker(n)).then(D=>D,D=>null));return Promise.race([Promise.all(a).then(l=>{const D=l.filter(S=>!!S);if(D.length>0)return new s(D)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(n,c){const i=c.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new R.$lL(i));if(n){const l=await this.F.getExtensionRegistry();return(0,C.$Mg)(()=>n.createDebugAdapterDescriptor(c,this.T(c,l))).then(D=>{if(D)return D})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(c,a))}T(n,c){}U(n,c,i){(n.length>0||c.length>0||i.length>0)&&this.y.fire(Object.freeze({added:n,removed:c,changed:i}))}async V(n){if(n)if(typeof n=="string"){const c=this.l.get(n);if(c)return c}else{let c=this.l.get(n.id);if(!c){const i=await this.W(n.folderUri),a=n.parent?this.l.get(n.parent):void 0;c=new o(this.k,n.id,n.type,n.name,i,n.configuration,a),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(n){if(n){const c=d.URI.revive(n);return this.E.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};e.$tdc=u,e.$tdc=u=He([Be(0,v.$hM),Be(1,I.$mcc),Be(2,E.$Ucc),Be(3,k.$pcc),Be(4,$.$odc),Be(5,p.$qdc)],u);class o{constructor(n,c,i,a,l,D,S){this.d=n,this.f=c,this.g=i,this.h=a,this.i=l,this.j=D,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,c){return this.d.$customDebugAdapterRequest(this.f,n,c)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$udc=o;class r{constructor(n){this.value=Object.freeze({append(c){n.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.$vdc=r;class s{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(c=>c.onError?c.onError(n):void 0)}onExit(n,c){this.d.forEach(i=>i.onExit?i.onExit(n,c):void 0)}}class m extends w.$6cb{constructor(n){super(),this.h=n,n.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends u{constructor(n,c,i,a,l,D){super(n,c,i,a,l,D)}};e.$wdc=h,e.$wdc=h=He([Be(0,v.$hM),Be(1,I.$mcc),Be(2,E.$Ucc),Be(3,k.$pcc),Be(4,$.$odc),Be(5,p.$qdc)],h)}),define(De[353],Ce([1,0,9,54,2,6,344,14,103,104,27,238,20,67,46,88]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=e.$jec=void 0;class u{static async installEarlyHandler(s){Error.stackTraceLimit=100;const m=s.get($.$0i),t=s.get(w.$hM).getProxy(L.$gK.MainThreadErrors);C.setUnexpectedErrorHandler(n=>{m.error(n);const c=C.$3(n);t.$onUnexpectedError(c)})}static async installFullHandler(s){const m=s.get($.$0i),h=s.get(w.$hM),t=s.get(k.$Ucc),n=s.get(p.$BM),c=h.getProxy(L.$gK.MainThreadExtensionService),i=h.getProxy(L.$gK.MainThreadErrors),a=await t.getExtensionPathIndex(),l=new WeakMap;function D(f,g){if(l.has(f))return l.get(f).stack;let P="",N,O;for(const j of g)P+=`
	at ${j.toString()}`,O=j.getFileName(),!N&&O&&(N=a.findSubstr(d.URI.file(O)));const M=`${f.name||"Error"}: ${f.message||""}${P}`;return l.set(f,{extensionIdentifier:N?.identifier,stack:M}),M}const S=Symbol("prepareStackTrace wrapped");let b=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(f){if(f===D||!f||f[S]){b=f||D;return}b=function(g,P){return D(g,P),f.call(Error,g,P)},Object.assign(b,{[S]:!0})}}),C.setUnexpectedErrorHandler(f=>{m.error(f);const g=C.$3(f),P=l.get(f);if(!P?.extensionIdentifier){i.$onUnexpectedError(g);return}c.$onExtensionRuntimeError(P.extensionIdentifier,g);const N=n.onExtensionError(P.extensionIdentifier,f);m.trace("forwarded error to extension?",N,P)})}}e.$jec=u;class o{constructor(s,m,h,t,n){this.a=h,this.b=new A.$t4b(s,null,t),m=o.e(m,this.b);const c=new v.$Nh(...(0,E.$yr)());c.set(R.$xM,{_serviceBrand:void 0,...m,messagePorts:n}),c.set(w.$hM,new w.$iM(this.b)),c.set(y.$jcc,new y.$kcc(t)),c.set(k.$Scc,h);const i=new I.$eq(c,!0);i.invokeFunction(u.installEarlyHandler),this.d=i.invokeFunction(a=>a.get($.$0i)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",m),this.c=i.invokeFunction(a=>a.get(k.$Ucc)),this.c.initialize(),i.invokeFunction(u.installFullHandler)}async asBrowserUri(s){const m=this.b.getProxy(L.$gK.MainThreadExtensionService);return d.URI.revive(await m.$asBrowserUri(s))}terminate(s){this.c.terminate(s)}static e(s,m){s.extensions.allExtensions.forEach(t=>{t.extensionLocation=d.URI.revive(m.transformIncomingURIs(t.extensionLocation))}),s.environment.appRoot=d.URI.revive(m.transformIncomingURIs(s.environment.appRoot));const h=s.environment.extensionDevelopmentLocationURI;return h&&(s.environment.extensionDevelopmentLocationURI=h.map(t=>d.URI.revive(m.transformIncomingURIs(t)))),s.environment.extensionTestsLocationURI=d.URI.revive(m.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=d.URI.revive(m.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=d.URI.revive(m.transformIncomingURIs(s.environment.workspaceStorageHome)),s.environment.extensionTelemetryLogResource=d.URI.revive(m.transformIncomingURIs(s.environment.extensionTelemetryLogResource)),s.nlsBaseUrl=d.URI.revive(m.transformIncomingURIs(s.nlsBaseUrl)),s.logsLocation=d.URI.revive(m.transformIncomingURIs(s.logsLocation)),s.workspace=m.transformIncomingURIs(s.workspace),s}}e.$kec=o}),define(De[354],Ce([1,0,8,12,215,232,138,94,71,46,20,45,7,56,39,273,274,40]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;let r=class extends $.$tdc{constructor(n,c,i,a,l,D,S){super(n,c,i,a,D,S),this.Z=l,this.X=new h}K(n,c){switch(n.type){case"server":return new p.$pec(n);case"pipeServer":return new p.$qec(n);case"executable":return new p.$rec(n,c.type)}return super.K(n,c)}T(n,c){const i=p.$rec.platformAdapterExecutable(c.getAllExtensionDescriptions(),n.type);if(i)return new w.$kL(i.command,i.args,i.options)}L(){return new A.$c8b}async $runInTerminal(n,c){if(n.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const i=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),l=this.Z.getDefaultShellArgs(!0),D=n.title||d.localize(0,null),S=JSON.stringify({shell:a,shellArgs:l});let b=await this.X.checkout(S,D),f,g=!1;if(b)f=n.cwd;else{const M={shellPath:a,shellArgs:l,cwd:n.cwd,name:D,iconPath:new w.$cL("debug")};g=!0,b=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(b,S)}b.show(!0);const P=await b.processId;g?await new Promise(M=>setTimeout(M,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?b.sendText("cls"):a.indexOf("bash")>=0?b.sendText("clear"):F.$j?b.sendText("cls"):b.sendText("clear"));const N=(0,u.$tec)(a,n.args,!!n.argsCanBeInterpretedByShell,f,n.env);b.sendText(N);const O=this.onDidTerminateDebugSession(M=>{M.id===c&&(this.X.free(b),O.dispose())});return P}else if(n.kind==="external")return m(n,await this.G.getConfigProvider());return super.$runInTerminal(n,c)}};e.$uec=r,e.$uec=r=He([Be(0,R.$hM),Be(1,k.$mcc),Be(2,v.$Ucc),Be(3,o.$pcc),Be(4,I.$Hcc),Be(5,E.$odc),Be(6,y.$qdc)],r);let s;function m(t,n){if(!s)if(F.$j)s=new L.$T6b;else if(F.$k)s=new L.$U6b;else if(F.$l)s=new L.$V6b;else throw new Error("external terminals not supported on this platform");const c=n.getConfiguration("terminal");return s.runInTerminal(t.title,t.cwd,t.args,t.env||{},c.external||{})}class h{constructor(){this.b=new Map}static{this.a=1e3}async checkout(n,c){const a=[...this.b.entries()].map(([l,D])=>(0,C.$Hg)(async S=>{if(l.name!==c||D.lastUsedAt!==-1&&await(0,u.$sec)(await l.processId))return null;const b=Date.now();return D.lastUsedAt+h.a>b||S.isCancellationRequested||D.config!==n?null:(D.lastUsedAt=b,l)}));return await(0,C.$Yg)(a,l=>!!l)}insert(n,c){this.b.set(n,{lastUsedAt:Date.now(),config:c})}free(n){const c=this.b.get(n);c&&(c.lastUsedAt=-1)}onTerminalClosed(n){this.b.delete(n)}}}),define(De[355],Ce([1,0,16,2,101,39,70,40,44,45,20,27,93,18,14,89,23,63,56]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;let s=class extends w.$ldc{constructor(h,t,n,c,i,a,l,D,S){super(h,t,n,c,i,a,l,D),this.B=n,this.C=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(h,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const c=w.TaskHandleDTO.from(n,this.B),i=await this.a.$getTaskExecution(c);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.y(i,t);return this.a.$executeTask(c).catch(()=>{}),a}else{const c=w.TaskDTO.from(t,h);if(c===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(c.execution)&&await this.x(c,t,!1);const i=await this.y(await this.a.$getTaskExecution(c),t);return this.a.$executeTask(c).catch(()=>{}),i}}u(h,t,n,c){const i=[];if(c)for(const a of c){this.z(a,n),(!a.definition||!h[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const l=w.TaskDTO.from(a,n.extension);l&&(i.push(l),w.CustomExecutionDTO.is(l.execution)&&t.push(this.x(l,a,!0)))}return{tasks:i,extension:n.extension}}async v(h){return h}async F(h){let t=h&&h.length>0?h[0]:void 0;if(!t){const n=F.URI.file((0,o.homedir)());t=new E.$0h({uri:n,name:u.$sg(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(h,t){const n=F.URI.revive(h),c={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(n),a=await this.b.getWorkspaceFolders2()??[],l=await this.C.getResolver(),D=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(a);for(const S of t.variables)c.variables[S]=await l.resolveAsync(D,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(C.$tc);for(let b=0;b<S.length;b++)S[b]=await l.resolveAsync(D,S[b])}c.process=await d.win32.findExecutable(await l.resolveAsync(D,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(D,t.process.cwd):void 0,S)}return c}async $jsonTasksSupported(){return!0}async $findExecutable(h,t,n){return d.win32.findExecutable(h,t,n)}};e.$mec=s,e.$mec=s=He([Be(0,R.$hM),Be(1,I.$xM),Be(2,L.$mcc),Be(3,A.$sM),Be(4,$.$pcc),Be(5,v.$Hcc),Be(6,k.$0i),Be(7,p.$ccc),Be(8,r.$qdc)],s)}),define(De[356],Ce([1,0,63,56]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class d extends F.$rdc{m(){return(0,C.homedir)()}}e.$5ec=d}),define(De[153],Ce([1,0,19,8,21,41,18,16,23,2,36]),function($e,e,C,F,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=e.$zdc=e.$ydc=void 0;class I{constructor(r,s,m,h){this.d=r,this.e=s,this.f=m,this.g=h,this.a=null,this.b=!1,this.c=0}search(r,s){const m=this.d.folderQueries||[],h=new d.$Xd(s);return new Promise((t,n)=>{this.a=new y(r);let c=!1;const i=(a,l)=>{if(!c&&!this.b){const D=this.h(a);p(a)&&typeof this.d.maxResults=="number"&&this.c+D>this.d.maxResults&&(this.b=!0,c=!0,h.cancel(),a=this.j(a,this.d.maxResults-this.c));const S=this.h(a);this.c+=S,(S>0||!p(a))&&this.a.add(a,l)}};Promise.all(m.map((a,l)=>this.k(a,D=>i(D,l),h.token))).then(a=>{h.dispose(),this.a.flush();const l=a.some(D=>!!D&&!!D.limitHit);t({limitHit:this.b||l,messages:(0,C.$Rb)(a.map(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[])),stats:{type:this.g}})},a=>{h.dispose();const l=(0,L.$Ai)(a);n(new Error(l))})})}h(r){return p(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,s){const m=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:m.slice(0,s),preview:{matches:h.slice(0,s),text:r.preview.text},uri:r.uri}}async k(r,s,m){const h=new R.$2I(this.d,r),t=[],n={report:a=>{if(!this.l(a))return;const l=r.folder.scheme===A.Schemas.file?(0,R.$3I)(()=>this.f.readdir(E.$ug(a.uri))):void 0,D=E.$xg(r.folder,a.uri);if(D){const S=h.includedInQuery(D,$.$nc(D),l);(0,F.$Gg)(S)?t.push(S.then(b=>{b&&s(a)})):S&&s(a)}}},c=this.n(r),i=await this.e.provideTextSearchResults(w(this.d.contentPattern),c,n,m);return t.length&&await Promise.all(t),i}l(r){if(p(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const s=(0,R.$1I)(this.d.includePattern,r.includePattern),m=(0,R.$1I)(this.d.excludePattern,r.excludePattern),h={folder:v.URI.from(r.folder),excludes:m,includes:s,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$ydc=I;function w(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class y{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new u(512,s=>this.g(s))}add(r,s){this.d&&(this.b!==s||!E.$og(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=s,this.d={resource:r.uri,results:[]}),this.d.results.push(k(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$zdc=y;function k(o){return p(o)?{preview:{matches:(0,C.$2b)(o.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:o.preview.text},ranges:(0,C.$2b)(o.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function p(o){return!!o.preview}e.$Adc=p;class u{static{this.a=4e3}static{this.b=50}constructor(r,s){this.g=r,this.h=s,this.c=0,this.d=[],this.e=0}addItem(r,s){r&&this.j(r,s)}addItems(r,s){r&&this.k(r,s)}j(r,s){this.d.push(r),this.e+=s,this.l()}k(r,s){this.d=this.d.concat(r),this.e+=s,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Bdc=u}),define(De[95],Ce([1,0,3,6,5,349,20,67,14,2,153]),function($e,e,C,F,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=e.$Ddc=e.$Cdc=void 0,e.$Cdc=(0,d.$Ph)("IExtHostSearch");let I=class{constructor(p,u,o){this.k=p,this.l=u,this.n=o,this.c=this.k.getProxy(F.$gK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$xdc}o(p){return this.l.transformOutgoingScheme(p)}registerTextSearchProvider(p,u){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const o=this.d++;return this.e.set(o,u),this.c.$registerTextSearchProvider(o,this.o(p)),(0,C.$Qc)(()=>{this.g.delete(p),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(p,u){if(this.i.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.i.add(p);const o=this.d++;return this.h.set(o,u),this.c.$registerFileSearchProvider(o,this.o(p)),(0,C.$Qc)(()=>{this.i.delete(p),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(p,u,o,r){const s=w(o),m=this.h.get(p);if(m)return this.j.fileSearch(s,m,h=>{this.c.$handleFileMatch(p,u,h.map(t=>t.resource))},r);throw new Error("unknown provider: "+p)}$clearCache(p){return this.j.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,u,o,r){const s=this.e.get(p);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const m=w(o);return this.q(m,s).search(t=>this.c.$handleTextMatch(p,u,t),r)}$enableExtensionHostSearch(){}q(p,u){return new R.$ydc(p,u,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$Ddc=I,e.$Ddc=I=He([Be(0,A.$hM),Be(1,$.$jcc),Be(2,E.$0i)],I);function w(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(y),extraFileResources:k.extraFileResources&&k.extraFileResources.map(p=>v.URI.revive(p))}}e.$Edc=w;function y(k){return{...k,folder:v.URI.revive(k.folder)}}}),define(De[357],Ce([1,0,21,9,4,38,2,130,125,168,185,30,6,111,303,302,34,304,40,306,307,308,281,309,70,46,311,312,317,318,319,152,285,325,326,329,115,45,331,288,13,7,85,334,91,151,39,25,277,316,66,149,93,94,95,14,67,20,27,320,275,73,89,295,332,90,72,337,335,336,296,55,330,333,114,71,88,321,92,322,18,134,284,263,314,3,26,271,112,257,323,324,297,313,283,315,113,327,300,328,301,294,310,298,299]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h,t,n,c,i,a,l,D,S,b,f,g,P,N,O,M,j,U,T,K,q,ge,ee,Q,X,ae,ie,ce,we,H,B,J,re,Y,_,x,pe,ue,fe,te,de,be,Pe,z,G,se,oe,Z,me,Ee,je,We,_e,Ye,it,et,Ae,Ne,qe,Le,Xe,he,le,Ie,Ve,ze,xe,rt,ot,$t,St,Yt,Gt,vt,zt,Nt,Bt,At,Rt,Ot,Wt,Jt,qt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;function Lt(lt){const ft=lt.get(ue.$xM),Tt=lt.get(je.$_bc),Kt=lt.get(se.$Ecc),Dt=lt.get(i.$Ucc),ct=lt.get(ae.$mcc),wt=lt.get(et.$BM),Ht=lt.get(r.$pcc),Pt=lt.get(x.$jcc),Ge=lt.get(pe.$hM),Me=lt.get(M.$Acc),Te=lt.get(G.$Fcc),Se=lt.get(_.$$i),ne=lt.get(_.$0i),Fe=lt.get(de.$6vb),Ke=lt.get(be.$ccc),Ze=lt.get(X.$gdc),Je=lt.get(Ye.$Mcc),nt=lt.get(it.$odc),pt=lt.get(Nt.$Qcc);Ge.set(w.$hK.ExtHostFileSystemInfo,Tt),Ge.set(w.$hK.ExtHostLogLevelServiceShape,Se),Ge.set(w.$hK.ExtHostWorkspace,ct),Ge.set(w.$hK.ExtHostConfiguration,Ht),Ge.set(w.$hK.ExtHostExtensionService,Dt),Ge.set(w.$hK.ExtHostStorage,Me),Ge.set(w.$hK.ExtHostTunnelService,Fe),Ge.set(w.$hK.ExtHostWindow,Ze),Ge.set(w.$hK.ExtHostSecretState,Je),Ge.set(w.$hK.ExtHostTelemetry,wt),Ge.set(w.$hK.ExtHostEditorTabs,nt),Ge.set(w.$hK.ExtHostManagedSockets,pt);const jt=Ge.set(w.$hK.ExtHostDecorations,lt.get(B.$kdc)),kt=Ge.set(w.$hK.ExtHostDocumentsAndEditors,lt.get(c.$sM)),ht=Ge.set(w.$hK.ExtHostCommands,lt.get(u.$DM)),gt=Ge.set(w.$hK.ExtHostTerminalService,lt.get(j.$Hcc)),yt=Ge.set(w.$hK.ExtHostDebugService,lt.get(re.$sdc)),mi=Ge.set(w.$hK.ExtHostSearch,lt.get(Y.$Cdc)),Ct=Ge.set(w.$hK.ExtHostTask,lt.get(J.$ndc)),Di=Ge.set(w.$hK.ExtHostOutputService,lt.get(f.$3cc)),ui=Ge.set(w.$hK.ExtHostLocalization,lt.get(rt.$Pcc)),$i=Ge.set(w.$hK.ExtHostUrls,new ee.$_cc(Ge)),It=Ge.set(w.$hK.ExtHostDocuments,new n.$0bc(Ge,kt)),fn=Ge.set(w.$hK.ExtHostDocumentContentProviders,new h.$rcc(Ge,kt,ne)),ri=Ge.set(w.$hK.ExtHostDocumentSaveParticipant,new t.$scc(ne,It,Ge.getProxy(w.$gK.MainThreadBulkEdits))),Et=Ge.set(w.$hK.ExtHostNotebook,new fe.$Idc(Ge,ht,kt,It,Kt)),bi=Ge.set(w.$hK.ExtHostNotebookDocuments,new le.$1dc(Et)),vi=Ge.set(w.$hK.ExtHostNotebookEditors,new he.$Zdc(ne,Et)),si=Ge.set(w.$hK.ExtHostNotebookKernels,new Ae.$Wdc(Ge,ft,Et,ht,ne)),Ci=Ge.set(w.$hK.ExtHostNotebookRenderers,new qe.$Ydc(Ge,Et)),Ii=Ge.set(w.$hK.ExtHostNotebookDocumentSaveParticipant,new vt.$7dc(ne,Et,Ge.getProxy(w.$gK.MainThreadBulkEdits))),Mt=Ge.set(w.$hK.ExtHostEditors,new U.$0cc(Ge,kt)),wi=Ge.set(w.$hK.ExtHostTreeViews,new T.$$cc(Ge.getProxy(w.$gK.MainThreadTreeViews),ht,ne)),Pi=Ge.set(w.$hK.ExtHostEditorInsets,new ce.$hdc(Ge.getProxy(w.$gK.MainThreadEditorInsets),Mt,ft.remote)),oi=Ge.set(w.$hK.ExtHostDiagnostics,new s.$bcc(Ge,ne,Tt,kt)),li=Ge.set(w.$hK.ExtHostLanguages,new S.$Zcc(Ge,It,ht.converter,Pt)),ut=Ge.set(w.$hK.ExtHostLanguageFeatures,new D.$fcc(Ge,Pt,It,ht,oi,ne,Ke,wt)),Ai=Ge.set(w.$hK.ExtHostFileSystem,new a.$Xcc(Ge,ut)),Zt=Ge.set(w.$hK.ExtHostFileSystemEventService,new l.$Ycc(Ge,ne,kt)),ii=Ge.set(w.$hK.ExtHostQuickOpen,(0,P.$5cc)(Ge,ct,ht)),Ri=Ge.set(w.$hK.ExtHostSCM,new N.$7cc(Ge,ht,It,ne)),Li=Ge.set(w.$hK.ExtHostQuickDiff,new St.$4dc(Ge,Pt)),Mi=Ge.set(w.$hK.ExtHostShare,new Bt.$9dc(Ge,Pt)),Xi=Ge.set(w.$hK.ExtHostComments,(0,o.$icc)(Ge,ht,It)),Fi=Ge.set(w.$hK.ExtHostProgress,new g.$4cc(Ge.getProxy(w.$gK.MainThreadProgress))),Yi=Ge.set(w.$hK.ExtHosLabelService,new we.$idc(Ge)),Ti=Ge.set(w.$hK.ExtHostTheming,new te.$Jdc(Ge)),ai=Ge.set(w.$hK.ExtHostAuthentication,new Pe.$Kdc(Ge)),gn=Ge.set(w.$hK.ExtHostTimeline,new z.$Mdc(Ge,ht)),Ni=Ge.set(w.$hK.ExtHostWebviews,new Q.$cdc(Ge,ft.remote,ct,ne,Ke)),hi=Ge.set(w.$hK.ExtHostWebviewPanels,new me.$Odc(Ge,Ni,ct)),Oi=Ge.set(w.$hK.ExtHostCustomEditors,new Z.$Pdc(Ge,It,Te,Ni,hi)),mn=Ge.set(w.$hK.ExtHostWebviewViews,new oe.$Ndc(Ge,Ni)),di=Ge.set(w.$hK.ExtHostTesting,new We.$Rdc(Ge,ht,kt)),Zi=Ge.set(w.$hK.ExtHostUriOpeners,new _e.$Vdc(Ge)),ji=Ge.set(w.$hK.ExtHostProfileContentHandlers,new $t.$3dc(Ge));Ge.set(w.$hK.ExtHostInteractive,new Ie.$2dc(Ge,Et,kt,ht,ne));const xi=Ge.set(w.$hK.ExtHostInlineChat,new Gt.$6dc(Ge,ht,It,ne)),fi=Ge.set(w.$hK.ExtHostChatProvider,new At.$0dc(Ge,ne)),_i=Ge.set(w.$hK.ExtHostChatAgents,new qt.$cec(Ge,fi,ne)),$n=Ge.set(w.$hK.ExtHostChatAgents2,new Vt.$dec(Ge,fi,ne)),Ui=Ge.set(w.$hK.ExtHostChatVariables,new Ot.$_dc(Ge)),gi=Ge.set(w.$hK.ExtHostChat,new Yt.$5dc(Ge,ne)),xt=Ge.set(w.$hK.ExtHostAiRelatedInformation,new Wt.$aec(Ge)),pi=Ge.set(w.$hK.ExtHostAiEmbeddingVector,new Jt.$bec(Ge)),bn=Ge.set(w.$hK.ExtHostIssueReporter,new zt.$8dc(Ge)),Qt=Ge.set(w.$hK.ExtHostStatusBar,new O.$9cc(Ge,ht.converter)),yi=Ge.set(w.$hK.ExtHostSpeech,new Rt.$$dc(Ge)),en=Object.values(w.$hK);Ge.assertRegistered(en);const tn=new Ee.$Qdc(Ge,kt),nn=new p.$hcc(Ge),Ei=new b.$1cc(Ge,ne),rn=new m.$qcc(Ge);return k.$gcc.register(ht),function(Ue,_t,sn){const mt=function(){let ve=!Ue.isUnderDevelopment;function ke(){ve||(ne.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ve=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ke();else{const bt=st;typeof bt.scheme>"u"&&ke(),typeof bt.exclusive=="boolean"&&(0,ze.$eF)(Ue,"documentFiltersExclusive")}return st}}(),zi={getSession(ve,ke,Oe){return ai.getSession(Ue,ve,ke,Oe)},getSessions(ve,ke){return(0,ze.$eF)(Ue,"authGetSessions"),ai.getSessions(Ue,ve,ke)},async hasSession(ve,ke){return(0,ze.$eF)(Ue,"authSession"),!!await ai.getSession(Ue,ve,ke,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(ve,ke,Oe,st){return ai.registerAuthenticationProvider(ve,ke,Oe,st)}},on={registerCommand(ve,ke,Oe){return ht.registerCommand(!0,ve,ke,Oe,void 0,Ue)},registerTextEditorCommand(ve,ke,Oe){return ht.registerCommand(!0,ve,(...st)=>{const bt=Mt.getActiveTextEditor();if(!bt){ne.warn("Cannot execute "+ve+" because there is no active text editor.");return}return bt.edit(Ft=>{ke.apply(Oe,[bt,Ft,...st])}).then(Ft=>{Ft||ne.warn("Edits from command "+ve+" were not applied.")},Ft=>{ne.warn("An error occurred while running command "+ve,Ft)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ve,ke,Oe)=>((0,ze.$eF)(Ue,"diffCommand"),ht.registerCommand(!0,ve,async(...st)=>{const bt=kt.activeEditor(!0);if(!bt){ne.warn("Cannot execute "+ve+" because there is no active text editor.");return}const Ft=await Mt.getDiffInformation(bt.id);ke.apply(Oe,[Ft,...st])},void 0,void 0,Ue)),executeCommand(ve,...ke){return ht.executeCommand(ve,...ke)},getCommands(ve=!1){return ht.getCommands(ve)}},Bi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return wt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$eF)(Ue,"telemetry"),wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$eF)(Ue,"telemetry"),wt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$AM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(ve,ke){return et.$zM.validateSender(ve),wt.instantiateLogger(Ue,ve,ke)},openExternal(ve,ke){return Ze.openUri(ve,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(ve){if(ve.scheme===ft.environment.appUriScheme)return $i.createAppUri(ve);try{return await Ze.asExternalUri(ve,{allowTunneling:!!ft.remote.authority})}catch(ke){if((0,Xe.$dU)(ve,Le.Schemas.http)||(0,Xe.$dU)(ve,Le.Schemas.https))return ve;throw ke}},get remoteName(){return(0,H.$Vk)(ft.remote.authority)},get remoteAuthority(){return(0,ze.$eF)(Ue,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return ne.getLevel()},get onDidChangeLogLevel(){return ne.onDidChangeLogLevel},registerIssueUriRequestHandler(ve){return(0,ze.$eF)(Ue,"handleIssueUri"),bn.registerIssueUriRequestHandler(Ue,ve)},get appQuality(){return(0,ze.$eF)(Ue,"resolvers"),ft.quality},get appCommit(){return(0,ze.$eF)(Ue,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Bi);const an={createTestController(ve,ke,Oe){return di.createTestController(Ue,ve,ke,Oe)},createTestObserver(){return(0,ze.$eF)(Ue,"testObserver"),di.createTestObserver()},runTests(ve){return(0,ze.$eF)(Ue,"testObserver"),di.runTests(ve)},get onDidChangeTestResults(){return(0,ze.$eF)(Ue,"testObserver"),di.onResultsChanged},get testResults(){return(0,ze.$eF)(Ue,"testObserver"),di.results}},ki=ft.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,vn={getExtension(ve,ke){(0,ze.$dF)(Ue,"extensionsAny")||(ke=!1);const Oe=_t.mine.getExtensionDescription(ve);if(Oe)return new i.$Vcc(Dt,Ue.identifier,Oe,ki,!1);if(ke){const st=_t.all.getExtensionDescription(ve);if(st)return new i.$Vcc(Dt,Ue.identifier,st,ki,!0)}},get all(){const ve=[];for(const ke of _t.mine.getAllExtensionDescriptions())ve.push(new i.$Vcc(Dt,Ue.identifier,ke,ki,!1));return ve},get allAcrossExtensionHosts(){(0,ze.$eF)(Ue,"extensionsAny");const ve=new ie.$7l(_t.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ke=[];for(const Oe of _t.all.getAllExtensionDescriptions()){const st=!ve.has(Oe.identifier);ke.push(new i.$Vcc(Dt,Ue.identifier,Oe,ki,st))}return ke},get onDidChange(){return(0,ze.$dF)(Ue,"extensionsAny")?d.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},cn={createDiagnosticCollection(ve){return oi.createDiagnosticCollection(Ue.identifier,ve)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:ve=>oi.getDiagnostics(ve),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(ve,ke){return li.changeLanguage(ve.uri,ke)},match(ve,ke){const Oe=It.getDocumentData(ke.uri)?.notebook;return(0,R.$sE)(K.LanguageSelector.from(ve),ke.uri,ke.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ve,ke,Oe){return ut.registerCodeActionProvider(Ue,mt(ve),ke,Oe)},registerDocumentPasteEditProvider(ve,ke,Oe){return(0,ze.$eF)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,mt(ve),ke,Oe)},registerCodeLensProvider(ve,ke){return ut.registerCodeLensProvider(Ue,mt(ve),ke)},registerDefinitionProvider(ve,ke){return ut.registerDefinitionProvider(Ue,mt(ve),ke)},registerDeclarationProvider(ve,ke){return ut.registerDeclarationProvider(Ue,mt(ve),ke)},registerImplementationProvider(ve,ke){return ut.registerImplementationProvider(Ue,mt(ve),ke)},registerTypeDefinitionProvider(ve,ke){return ut.registerTypeDefinitionProvider(Ue,mt(ve),ke)},registerHoverProvider(ve,ke){return ut.registerHoverProvider(Ue,mt(ve),ke,Ue.identifier)},registerEvaluatableExpressionProvider(ve,ke){return ut.registerEvaluatableExpressionProvider(Ue,mt(ve),ke,Ue.identifier)},registerInlineValuesProvider(ve,ke){return ut.registerInlineValuesProvider(Ue,mt(ve),ke,Ue.identifier)},registerDocumentHighlightProvider(ve,ke){return ut.registerDocumentHighlightProvider(Ue,mt(ve),ke)},registerLinkedEditingRangeProvider(ve,ke){return ut.registerLinkedEditingRangeProvider(Ue,mt(ve),ke)},registerReferenceProvider(ve,ke){return ut.registerReferenceProvider(Ue,mt(ve),ke)},registerRenameProvider(ve,ke){return ut.registerRenameProvider(Ue,mt(ve),ke)},registerDocumentSymbolProvider(ve,ke,Oe){return ut.registerDocumentSymbolProvider(Ue,mt(ve),ke,Oe)},registerWorkspaceSymbolProvider(ve){return ut.registerWorkspaceSymbolProvider(Ue,ve)},registerDocumentFormattingEditProvider(ve,ke){return ut.registerDocumentFormattingEditProvider(Ue,mt(ve),ke)},registerDocumentRangeFormattingEditProvider(ve,ke){return ut.registerDocumentRangeFormattingEditProvider(Ue,mt(ve),ke)},registerOnTypeFormattingEditProvider(ve,ke,Oe,...st){return ut.registerOnTypeFormattingEditProvider(Ue,mt(ve),ke,[Oe].concat(st))},registerDocumentSemanticTokensProvider(ve,ke,Oe){return ut.registerDocumentSemanticTokensProvider(Ue,mt(ve),ke,Oe)},registerDocumentRangeSemanticTokensProvider(ve,ke,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Ue,mt(ve),ke,Oe)},registerSignatureHelpProvider(ve,ke,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Ue,mt(ve),ke,Oe):ut.registerSignatureHelpProvider(Ue,mt(ve),ke,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(ve,ke,...Oe){return ut.registerCompletionItemProvider(Ue,mt(ve),ke,Oe)},registerInlineCompletionItemProvider(ve,ke,Oe){return ke.handleDidShowCompletionItem&&(0,ze.$eF)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,ze.$eF)(Ue,"inlineCompletionsAdditions"),Oe&&(0,ze.$eF)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,mt(ve),ke,Oe)},registerDocumentLinkProvider(ve,ke){return ut.registerDocumentLinkProvider(Ue,mt(ve),ke)},registerColorProvider(ve,ke){return ut.registerColorProvider(Ue,mt(ve),ke)},registerFoldingRangeProvider(ve,ke){return ut.registerFoldingRangeProvider(Ue,mt(ve),ke)},registerSelectionRangeProvider(ve,ke){return ut.registerSelectionRangeProvider(Ue,ve,ke)},registerCallHierarchyProvider(ve,ke){return ut.registerCallHierarchyProvider(Ue,ve,ke)},registerTypeHierarchyProvider(ve,ke){return ut.registerTypeHierarchyProvider(Ue,ve,ke)},setLanguageConfiguration:(ve,ke)=>ut.setLanguageConfiguration(Ue,ve,ke),getTokenInformationAtPosition(ve,ke){return(0,ze.$eF)(Ue,"tokenInformation"),li.tokenAtPosition(ve,ke)},registerInlayHintsProvider(ve,ke){return ut.registerInlayHintsProvider(Ue,ve,ke)},createLanguageStatusItem(ve,ke){return li.createLanguageStatusItem(Ue,ve,ke)},registerDocumentDropEditProvider(ve,ke,Oe){return ut.registerDocumentOnDropEditProvider(Ue,ve,ke,(0,ze.$dF)(Ue,"dropMetadata")?Oe:void 0)}},un={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(ve,ke,Oe){const st=await(A.URI.isUri(ve)?Promise.resolve(Si.openTextDocument(ve)):Promise.resolve(ve));return Mt.showTextDocument(st,ke,Oe)},createTextEditorDecorationType(ve){return Mt.createTextEditorDecorationType(Ue,ve)},onDidChangeActiveTextEditor(ve,ke,Oe){return Mt.onDidChangeActiveTextEditor(ve,ke,Oe)},onDidChangeVisibleTextEditors(ve,ke,Oe){return Mt.onDidChangeVisibleTextEditors(ve,ke,Oe)},onDidChangeTextEditorSelection(ve,ke,Oe){return Mt.onDidChangeTextEditorSelection(ve,ke,Oe)},onDidChangeTextEditorOptions(ve,ke,Oe){return Mt.onDidChangeTextEditorOptions(ve,ke,Oe)},onDidChangeTextEditorVisibleRanges(ve,ke,Oe){return Mt.onDidChangeTextEditorVisibleRanges(ve,ke,Oe)},onDidChangeTextEditorViewColumn(ve,ke,Oe){return Mt.onDidChangeTextEditorViewColumn(ve,ke,Oe)},onDidCloseTerminal(ve,ke,Oe){return gt.onDidCloseTerminal(ve,ke,Oe)},onDidOpenTerminal(ve,ke,Oe){return gt.onDidOpenTerminal(ve,ke,Oe)},onDidChangeActiveTerminal(ve,ke,Oe){return gt.onDidChangeActiveTerminal(ve,ke,Oe)},onDidChangeTerminalDimensions(ve,ke,Oe){return(0,ze.$eF)(Ue,"terminalDimensions"),gt.onDidChangeTerminalDimensions(ve,ke,Oe)},onDidChangeTerminalState(ve,ke,Oe){return gt.onDidChangeTerminalState(ve,ke,Oe)},onDidWriteTerminalData(ve,ke,Oe){return(0,ze.$eF)(Ue,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(ve,ke,Oe)},onDidExecuteTerminalCommand(ve,ke,Oe){return(0,ze.$eF)(Ue,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(ve,ke,Oe)},get state(){return Ze.getState(Ue)},onDidChangeWindowState(ve,ke,Oe){return Ze.onDidChangeWindowState(ve,ke,Oe)},showInformationMessage(ve,...ke){return Ei.showMessage(Ue,L.default.Info,ve,ke[0],ke.slice(1))},showWarningMessage(ve,...ke){return Ei.showMessage(Ue,L.default.Warning,ve,ke[0],ke.slice(1))},showErrorMessage(ve,...ke){return Ei.showMessage(Ue,L.default.Error,ve,ke[0],ke.slice(1))},showQuickPick(ve,ke,Oe){return ii.showQuickPick(Ue,ve,ke,Oe)},showWorkspaceFolderPick(ve){return ii.showWorkspaceFolderPick(ve)},showInputBox(ve,ke){return ii.showInput(ve,ke)},showOpenDialog(ve){return rn.showOpenDialog(Ue,ve)},showSaveDialog(ve){return rn.showSaveDialog(ve)},createStatusBarItem(ve,ke,Oe){let st,bt,Ft;return typeof ve=="string"?(st=ve,bt=ke,Ft=Oe):(bt=ve,Ft=ke),Qt.createStatusBarEntry(Ue,st,bt,Ft)},setStatusBarMessage(ve,ke){return Qt.setStatusBarMessage(ve,ke)},withScmProgress(ve){return Ke.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Fi.withProgress(Ue,{location:q.ProgressLocation.SourceControl},(ke,Oe)=>ve({report(st){}}))},withProgress(ve,ke){return Fi.withProgress(Ue,ve,ke)},createOutputChannel(ve,ke){return Di.createOutputChannel(ve,ke,Ue)},createWebviewPanel(ve,ke,Oe,st){return hi.createWebviewPanel(Ue,ve,ke,Oe,st)},createWebviewTextEditorInset(ve,ke,Oe,st){return(0,ze.$eF)(Ue,"editorInsets"),Pi.createWebviewEditorInset(ve,ke,Oe,st,Ue)},createTerminal(ve,ke,Oe){return typeof ve=="object"?"pty"in ve?gt.createExtensionTerminal(ve):gt.createTerminalFromOptions(ve):gt.createTerminal(ve,ke,Oe)},registerTerminalLinkProvider(ve){return gt.registerLinkProvider(ve)},registerTerminalProfileProvider(ve,ke){return gt.registerProfileProvider(Ue,ve,ke)},registerTerminalQuickFixProvider(ve,ke){return(0,ze.$eF)(Ue,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(ve,Ue.identifier.value,ke)},registerTreeDataProvider(ve,ke){return wi.registerTreeDataProvider(ve,ke,Ue)},createTreeView(ve,ke){return wi.createTreeView(ve,ke,Ue)},registerWebviewPanelSerializer:(ve,ke)=>hi.registerWebviewPanelSerializer(Ue,ve,ke),registerCustomEditorProvider:(ve,ke,Oe={})=>Oi.registerCustomEditorProvider(Ue,ve,ke,Oe),registerFileDecorationProvider(ve){return jt.registerFileDecorationProvider(ve,Ue)},registerUriHandler(ve){return $i.registerUriHandler(Ue,ve)},createQuickPick(){return ii.createQuickPick(Ue)},createInputBox(){return ii.createInputBox(Ue)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(ve,ke,Oe){return Ti.onDidChangeActiveColorTheme(ve,ke,Oe)},registerWebviewViewProvider(ve,ke,Oe){return mn.registerWebviewViewProvider(Ue,ve,ke,Oe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ve,ke,Oe){return Et.onDidChangeActiveNotebookEditor(ve,ke,Oe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ve,ke,Oe){return vi.onDidChangeNotebookEditorSelection(ve,ke,Oe)},onDidChangeNotebookEditorVisibleRanges(ve,ke,Oe){return vi.onDidChangeNotebookEditorVisibleRanges(ve,ke,Oe)},showNotebookDocument(ve,ke){return Et.showNotebookDocument(ve,ke)},registerExternalUriOpener(ve,ke,Oe){return(0,ze.$eF)(Ue,"externalUriOpener"),Zi.registerExternalUriOpener(Ue.identifier,ve,ke,Oe)},registerProfileContentHandler(ve,ke){return(0,ze.$eF)(Ue,"profileContentHandlers"),ji.registrProfileContentHandler(Ue,ve,ke)},registerQuickDiffProvider(ve,ke,Oe,st){return(0,ze.$eF)(Ue,"quickDiffProvider"),Li.registerQuickDiffProvider(mt(ve),ke,Oe,st)},get tabGroups(){return nt.tabGroups},registerShareProvider(ve,ke){return(0,ze.$eF)(Ue,"shareProvider"),Mi.registerShareProvider(mt(ve),ke)}},Si={get rootPath(){return Ke.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ct.getPath()},set rootPath(ve){throw new F.$9("rootPath")},getWorkspaceFolder(ve){return ct.getWorkspaceFolder(ve)},get workspaceFolders(){return ct.getWorkspaceFolders()},get name(){return ct.name},set name(ve){throw new F.$9("name")},get workspaceFile(){return ct.workspaceFile},set workspaceFile(ve){throw new F.$9("workspaceFile")},updateWorkspaceFolders:(ve,ke,...Oe)=>ct.updateWorkspaceFolders(Ue,ve,ke||0,...Oe),onDidChangeWorkspaceFolders:function(ve,ke,Oe){return ct.onDidChangeWorkspace(ve,ke,Oe)},asRelativePath:(ve,ke)=>ct.getRelativePath(ve,ke),findFiles:(ve,ke,Oe,st)=>ct.findFiles(ve,ke,Oe,Ue.identifier,st),findTextInFiles:(ve,ke,Oe,st)=>{(0,ze.$eF)(Ue,"findTextInFiles");let bt,Ft;return typeof ke=="object"?(bt=ke,Ft=Oe):(bt={},Ft=ke,st=Oe),ct.findTextInFiles(ve,bt||{},Ft,Ue.identifier,st)},save:ve=>((0,ze.$eF)(Ue,"saveEditor"),ct.save(ve)),saveAs:ve=>((0,ze.$eF)(Ue,"saveEditor"),ct.saveAs(ve)),saveAll:ve=>ct.saveAll(ve),applyEdit(ve,ke){return tn.applyWorkspaceEdit(ve,Ue,ke)},createFileSystemWatcher:(ve,ke,Oe,st)=>{let bt;return typeof ke=="boolean"?bt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!st}:ke&&((0,ze.$eF)(Ue,"createFileSystemWatcher"),bt=ke),Zt.createFileSystemWatcher(ct,Ue,ve,bt)},get textDocuments(){return It.getAllDocumentData().map(ve=>ve.document)},set textDocuments(ve){throw new F.$9("textDocuments")},openTextDocument(ve){let ke;const Oe=ve;if(typeof ve=="string")ke=Promise.resolve(A.URI.file(ve));else if(A.URI.isUri(ve))ke=Promise.resolve(ve);else if(!Oe||typeof Oe=="object")ke=It.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>It.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(ve,ke,Oe)=>It.onDidAddDocument(ve,ke,Oe),onDidCloseTextDocument:(ve,ke,Oe)=>It.onDidRemoveDocument(ve,ke,Oe),onDidChangeTextDocument:(ve,ke,Oe)=>It.onDidChangeDocument(ve,ke,Oe),onDidSaveTextDocument:(ve,ke,Oe)=>It.onDidSaveDocument(ve,ke,Oe),onWillSaveTextDocument:(ve,ke,Oe)=>ri.getOnWillSaveTextDocumentEvent(Ue)(ve,ke,Oe),get notebookDocuments(){return Et.notebookDocuments.map(ve=>ve.apiNotebook)},async openNotebookDocument(ve,ke){let Oe;if(A.URI.isUri(ve))Oe=ve,await Et.openNotebookDocument(ve);else if(typeof ve=="string")Oe=A.URI.revive(await Et.createNotebookDocument({viewType:ve,content:ke}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ve,ke,Oe){return bi.onDidSaveNotebookDocument(ve,ke,Oe)},onDidChangeNotebookDocument(ve,ke,Oe){return bi.onDidChangeNotebookDocument(ve,ke,Oe)},onWillSaveNotebookDocument(ve,ke,Oe){return Ii.getOnWillSaveNotebookDocumentEvent(Ue)(ve,ke,Oe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ve,ke,Oe,st){return Et.registerNotebookSerializer(Ue,ve,ke,Oe,(0,ze.$dF)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ve,ke,Oe)=>sn.onDidChangeConfiguration(ve,ke,Oe),getConfiguration(ve,ke){return ke=arguments.length===1?void 0:ke,sn.getConfiguration(ve,ke,Ue)},registerTextDocumentContentProvider(ve,ke){return fn.registerTextDocumentContentProvider(ve,ke)},registerTaskProvider:(ve,ke)=>(Ke.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Ue,ve,ke)),registerFileSystemProvider(ve,ke,Oe){return(0,Ve.$Pc)(Ai.registerFileSystemProvider(Ue,ve,ke,Oe),Kt.addFileSystemProvider(ve,ke,Oe))},get fs(){return Kt.value},registerFileSearchProvider:(ve,ke)=>((0,ze.$eF)(Ue,"fileSearchProvider"),mi.registerFileSearchProvider(ve,ke)),registerTextSearchProvider:(ve,ke)=>((0,ze.$eF)(Ue,"textSearchProvider"),mi.registerTextSearchProvider(ve,ke)),registerRemoteAuthorityResolver:(ve,ke)=>((0,ze.$eF)(Ue,"resolvers"),Dt.registerRemoteAuthorityResolver(ve,ke)),registerResourceLabelFormatter:ve=>((0,ze.$eF)(Ue,"resolvers"),Yi.$registerResourceLabelFormatter(ve)),getRemoteExecServer:ve=>((0,ze.$eF)(Ue,"resolvers"),Dt.getRemoteExecServer(ve)),onDidCreateFiles:(ve,ke,Oe)=>Zt.onDidCreateFile(ve,ke,Oe),onDidDeleteFiles:(ve,ke,Oe)=>Zt.onDidDeleteFile(ve,ke,Oe),onDidRenameFiles:(ve,ke,Oe)=>Zt.onDidRenameFile(ve,ke,Oe),onWillCreateFiles:(ve,ke,Oe)=>Zt.getOnWillCreateFileEvent(Ue)(ve,ke,Oe),onWillDeleteFiles:(ve,ke,Oe)=>Zt.getOnWillDeleteFileEvent(Ue)(ve,ke,Oe),onWillRenameFiles:(ve,ke,Oe)=>Zt.getOnWillRenameFileEvent(Ue)(ve,ke,Oe),openTunnel:ve=>((0,ze.$eF)(Ue,"tunnels"),Fe.openTunnel(Ue,ve).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,ze.$eF)(Ue,"tunnels"),Fe.getTunnels()},onDidChangeTunnels:(ve,ke,Oe)=>((0,ze.$eF)(Ue,"tunnels"),Fe.onDidChangeTunnels(ve,ke,Oe)),registerPortAttributesProvider:(ve,ke)=>((0,ze.$eF)(Ue,"portsAttributes"),Fe.registerPortsAttributesProvider(ve,ke)),registerTunnelProvider:(ve,ke)=>((0,ze.$eF)(Ue,"tunnelFactory"),Fe.registerTunnelProvider(ve,ke)),registerTimelineProvider:(ve,ke)=>((0,ze.$eF)(Ue,"timeline"),gn.registerTimelineProvider(ve,ke,Ue.identifier,ht.converter)),get isTrusted(){return ct.trusted},requestWorkspaceTrust:ve=>((0,ze.$eF)(Ue,"workspaceTrust"),ct.requestWorkspaceTrust(ve)),onDidGrantWorkspaceTrust:(ve,ke,Oe)=>ct.onDidGrantWorkspaceTrust(ve,ke,Oe),registerEditSessionIdentityProvider:(ve,ke)=>((0,ze.$eF)(Ue,"editSessionIdentityProvider"),ct.registerEditSessionIdentityProvider(ve,ke)),onWillCreateEditSessionIdentity:(ve,ke,Oe)=>((0,ze.$eF)(Ue,"editSessionIdentityProvider"),ct.getOnWillCreateEditSessionIdentityEvent(Ue)(ve,ke,Oe)),registerCanonicalUriProvider:(ve,ke)=>((0,ze.$eF)(Ue,"canonicalUriProvider"),ct.registerCanonicalUriProvider(ve,ke)),getCanonicalUri:(ve,ke,Oe)=>((0,ze.$eF)(Ue,"canonicalUriProvider"),ct.provideCanonicalUri(ve,ke,Oe))},Wi={get inputBox(){return Ke.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Ue)},createSourceControl(ve,ke,Oe){return Ri.createSourceControl(Ue,ve,ke,Oe)}},qi={createCommentController(ve,ke){return Xi.createCommentController(Ue,ve,ke)}},ci={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(ve,ke,Oe){return yt.onDidStartDebugSession(ve,ke,Oe)},onDidTerminateDebugSession(ve,ke,Oe){return yt.onDidTerminateDebugSession(ve,ke,Oe)},onDidChangeActiveDebugSession(ve,ke,Oe){return yt.onDidChangeActiveDebugSession(ve,ke,Oe)},onDidReceiveDebugSessionCustomEvent(ve,ke,Oe){return yt.onDidReceiveDebugSessionCustomEvent(ve,ke,Oe)},onDidChangeBreakpoints(ve,ke,Oe){return yt.onDidChangeBreakpoints(ve,ke,Oe)},onDidChangeStackFrameFocus(ve,ke,Oe){return(0,ze.$eF)(Ue,"debugFocus"),yt.onDidChangeStackFrameFocus(ve,ke,Oe)},registerDebugConfigurationProvider(ve,ke,Oe){return yt.registerDebugConfigurationProvider(ve,ke,Oe||xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ve,ke){return yt.registerDebugAdapterDescriptorFactory(Ue,ve,ke)},registerDebugAdapterTrackerFactory(ve,ke){return yt.registerDebugAdapterTrackerFactory(ve,ke)},startDebugging(ve,ke,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?yt.startDebugging(ve,ke,{parentSession:Oe}):yt.startDebugging(ve,ke,Oe||{})},stopDebugging(ve){return yt.stopDebugging(ve)},addBreakpoints(ve){return yt.addBreakpoints(ve)},removeBreakpoints(ve){return yt.removeBreakpoints(ve)},asDebugSourceUri(ve,ke){return yt.asDebugSourceUri(ve,ke)}},Vi={registerTaskProvider:(ve,ke)=>Ct.registerTaskProvider(Ue,ve,ke),fetchTasks:ve=>Ct.fetchTasks(ve),executeTask:ve=>Ct.executeTask(Ue,ve),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(ve,ke,Oe)=>Ct.onDidStartTask(ve,ke,Oe),onDidEndTask:(ve,ke,Oe)=>Ct.onDidEndTask(ve,ke,Oe),onDidStartTaskProcess:(ve,ke,Oe)=>Ct.onDidStartTaskProcess(ve,ke,Oe),onDidEndTaskProcess:(ve,ke,Oe)=>Ct.onDidEndTaskProcess(ve,ke,Oe)},Ki={createNotebookController(ve,ke,Oe,st,bt){return si.createNotebookController(Ue,ve,ke,Oe,st,(0,ze.$dF)(Ue,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ve,ke)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ve,ke),createRendererMessaging(ve){return Ci.createRendererMessaging(Ue,ve)},createNotebookControllerDetectionTask(ve){return(0,ze.$eF)(Ue,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Ue,ve)},registerKernelSourceActionProvider(ve,ke){return(0,ze.$eF)(Ue,"notebookKernelSource"),si.registerKernelSourceActionProvider(Ue,ve,ke)},onDidChangeNotebookCellExecutionState(ve,ke,Oe){return(0,ze.$eF)(Ue,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(ve,ke,Oe)}},Hi={t(...ve){if(typeof ve[0]=="string"){const ke=ve.shift(),Oe=!ve||typeof ve[0]!="object"?ve:ve[0];return ui.getMessage(Ue.identifier.value,{message:ke,args:Oe})}return ui.getMessage(Ue.identifier.value,ve[0])},get bundle(){return ui.getBundle(Ue.identifier.value)},get uri(){return ui.getBundleUri(Ue.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(ve,ke){return(0,ze.$eF)(Ue,"interactive"),xi.registerProvider(Ue,ve,ke={label:ke?.label??Ue.displayName??Ue.name})},registerInteractiveSessionProvider(ve,ke){return(0,ze.$eF)(Ue,"interactive"),gi.registerChatProvider(Ue,ve,ke)},sendInteractiveRequestToProvider(ve,ke){return(0,ze.$eF)(Ue,"interactive"),gi.sendInteractiveRequestToProvider(ve,ke)},get onDidPerformUserAction(){return(0,ze.$eF)(Ue,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(ve,ke){return(0,ze.$eF)(Ue,"interactive"),gi.transferChatSession(ve,ke)}},ln={getRelatedInformation(ve,ke){return(0,ze.$eF)(Ue,"aiRelatedInformation"),xt.getRelatedInformation(Ue,ve,ke)},registerRelatedInformationProvider(ve,ke){return(0,ze.$eF)(Ue,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Ue,ve,ke)},registerEmbeddingVectorProvider(ve,ke){return(0,ze.$eF)(Ue,"aiRelatedInformation"),pi.registerEmbeddingVectorProvider(Ue,ve,ke)}},hn={registerChatResponseProvider(ve,ke,Oe){return(0,ze.$eF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,ve,ke,Oe)},requestChatAccess(ve){return(0,ze.$eF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,ve)},registerVariable(ve,ke,Oe){return(0,ze.$eF)(Ue,"chatVariables"),Ui.registerVariableResolver(Ue,ve,ke,Oe)},registerMappedEditsProvider(ve,ke){return(0,ze.$eF)(Ue,"mappedEditsProvider"),ut.registerMappedEditsProvider(Ue,ve,ke)},createChatAgent(ve,ke){return(0,ze.$eF)(Ue,"chatAgents2"),$n.createChatAgent(Ue,ve,ke)},registerAgent(ve,ke,Oe){return(0,ze.$eF)(Ue,"chatAgents"),_i.registerAgent(Ue.identifier,ve,ke,Oe)}},dn={registerSpeechProvider(ve,ke){return(0,ze.$eF)(Ue,"speech"),yi.registerProvider(Ue.identifier,ve,ke)}};return{version:ft.version,ai:ln,authentication:zi,commands:on,comments:qi,chat:hn,debug:ci,env:Bi,extensions:vn,interactive:Gi,l10n:Hi,languages:cn,notebooks:Ki,scm:Wi,speech:dn,tasks:Vi,tests:an,window:un,workspace:Si,Breakpoint:q.$gL,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatAgentResultFeedbackKind:q.ChatAgentResultFeedbackKind,ChatMessage:q.$9L,ChatMessageRole:q.ChatMessageRole,ChatVariableLevel:q.ChatVariableLevel,CallHierarchyIncomingCall:q.$FK,CallHierarchyItem:q.$EK,CallHierarchyOutgoingCall:q.$GK,CancellationError:F.$5,CancellationTokenSource:C.$Xd,CandidatePortSource:w.CandidatePortSource,CodeAction:q.$BK,CodeActionKind:q.$CK,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.$HK,Color:q.$UK,ColorInformation:q.$VK,ColorPresentation:q.$WK,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.$OK,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.$PK,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.$5K,DebugAdapterExecutable:q.$kL,DebugAdapterInlineImplementation:q.$nL,DebugAdapterNamedPipeServer:q.$mL,DebugAdapterServer:q.$lL,DebugConfigurationProviderTriggerKind:xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.$wK,DiagnosticRelatedInformation:q.$vK,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.$iK,DocumentHighlight:q.$yK,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.$TK,DocumentSymbol:q.$AK,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.$qL,InlineValueText:q.$rL,InlineValueVariableLookup:q.$sL,InlineValueEvaluatableExpression:q.$tL,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:d.$Nd,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.$DL,FileDecoration2:q.$DL,FileSystemError:q.$vL,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:q.$wL,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.$iL,InlineCompletionItem:q.$QK,InlineCompletionList:q.$RK,Hover:q.$xK,IndentAction:v.IndentAction,Location:q.$uK,MarkdownString:q.$IK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:q.$JK,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.$jK,ProcessExecution:q.$3K,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.$CL,Range:q.$kK,RelativePattern:q.$eL,Selection:q.$lK,SelectionRange:q.$DK,SemanticTokens:q.$zL,SemanticTokensBuilder:q.$yL,SemanticTokensEdit:q.$AL,SemanticTokensEdits:q.$BL,SemanticTokensLegend:q.$xL,ShellExecution:q.$4K,ShellQuoting:q.ShellQuoting,SignatureHelp:q.$LK,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.$KK,SnippetString:q.$tK,SourceBreakpoint:q.$hL,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.$zK,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.$6K,TaskGroup:q.$2K,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.$XK,TerminalQuickFixExecuteTerminalCommand:q.$ZK,TerminalQuickFixOpener:q.$YK,TerminalLocation:q.TerminalLocation,TerminalProfile:q.$1K,TerminalExitReason:q.TerminalExitReason,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.$pK,SnippetTextEdit:q.$rK,TextEditorCursorStyle:$.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,SyntaxTokenType:q.SyntaxTokenType,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.$dL,ThemeIcon:q.$cL,TreeItem:q.$7K,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.$YL,UIKind:y.UIKind,Uri:A.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.$sK,DocumentDropEdit:q.$aL,DocumentPasteEdit:q.$bL,InlayHint:q.$NK,InlayHintLabelPart:q.$MK,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.$oK,ResolvedAuthority:q.$mK,ManagedResolvedAuthority:q.$nK,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.$NL,NotebookRange:q.$FL,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.$GL,NotebookData:q.$HL,NotebookRendererScript:q.$LL,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.$JL,NotebookCellOutputItem:q.$IL,NotebookCellStatusBarItem:q.$KL,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.$qK,NotebookKernelSourceAction:q.$ML,PortAttributes:q.$PL,LinkedEditingRanges:q.$OL,TestResultState:q.TestResultState,TestRunRequest:q.$QL,TestMessage:q.$RL,TestMessage2:q.$RL,TestTag:q.$SL,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,DataTransfer:q.$_K,DataTransferItem:q.$8K,CoveredCount:q.$TL,FileCoverage:q.$UL,StatementCoverage:q.$VL,BranchCoverage:q.$WL,FunctionCoverage:q.$XL,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.$ZL,TabInputTextDiff:q.$1L,TabInputTextMerge:q.$2L,TabInputCustom:q.$3L,TabInputNotebook:q.$5L,TabInputNotebookDiff:q.$6L,TabInputWebview:q.$4L,TabInputTerminal:q.$7L,TabInputInteractiveWindow:q.$8L,TelemetryTrustedValue:ge.$ko,LogLevel:_.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:q.$oL,ThreadFocus:q.$pL,RelatedInformationType:q.RelatedInformationType,SpeechToTextStatus:q.SpeechToTextStatus}}}e.$eec=Lt}),define(De[358],Ce([1,0,103,152,39,149,40,34,70,45,93,94,95,115,73,89,151,72,55,114,88,71,150,14,56,112,113]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h,t,n,c,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$xr)(i.$Pcc,i.$Occ,1),(0,C.$xr)(n.$$i,t.$fec,1),(0,C.$xr)(p.$ccc,p.$dcc,1),(0,C.$xr)($.$DM,$.$CM,0),(0,C.$xr)(A.$pcc,A.$ncc,0),(0,C.$xr)(o.$Ecc,o.$Dcc,0),(0,C.$xr)(I.$sdc,I.$wdc,0),(0,C.$xr)(L.$kdc,L.$jdc,0),(0,C.$xr)(E.$sM,E.$rM,0),(0,C.$xr)(a.$Qcc,a.$Rcc,0),(0,C.$xr)(r.$_bc,r.$$bc,0),(0,C.$xr)(F.$3cc,F.$2cc,1),(0,C.$xr)(w.$Cdc,w.$Ddc,0),(0,C.$xr)(y.$Acc,y.$zcc,0),(0,C.$xr)(R.$ndc,R.$mdc,0),(0,C.$xr)(v.$Hcc,v.$Kcc,0),(0,C.$xr)(k.$6vb,k.$7vb,0),(0,C.$xr)(u.$gdc,u.$fdc,0),(0,C.$xr)(d.$mcc,d.$lcc,0),(0,C.$xr)(s.$Mcc,s.$Lcc,0),(0,C.$xr)(m.$BM,m.$yM,0),(0,C.$xr)(h.$odc,h.$pdc,0),(0,C.$xr)(c.$qdc,c.$rdc,0)}),define(De[116],Ce([1,0,19,14,36,92]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=e.$wec=e.$vec=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$vec=A;function $(I,w,y,k){const p=(0,C.$2b)(y,E),u=new d.$NI(w,p,k),o=u.preview.matches;return{ranges:(0,C.$2b)(p,v),uri:I,preview:{text:u.preview.text,matches:(0,C.$2b)(o,v)}}}e.$wec=$;function E(I){return new d.$OI(I.start.line,I.start.character,I.end.line,I.end.character)}function v(I){return new L.$CI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(w,y){this.a=w,this.b=y}appendLine(w){this.b.debug(`${this.a}#search`,w)}};e.$xec=R,e.$xec=R=He([Be(1,F.$0i)],R)}),define(De[359],Ce([1,0,49,16,77,33,12,15,116,360]),function($e,e,C,F,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=e.$zec=e.$yec=void 0;const R=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(s,m,h,t){const n=w(s,m,h,t),c=m.folder.fsPath;return{cmd:C.spawn(R,n.args,{cwd:c}),rgDiskPath:R,siblingClauses:n.siblingClauses,rgArgs:n,cwd:c}}e.$yec=I;function w(s,m,h,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];k([m],h,!1).forEach(i=>{const a=(0,E.$vec)(i);if(n.push("-g",a),A.$k){const l=(0,d.$pl)(a);l!==a&&n.push("-g",l)}});const c=y([m],t,void 0,!1);return c.globArgs.forEach(i=>{const a=`!${(0,E.$vec)(i)}`;if(n.push("-g",a),A.$k){const l=(0,d.$pl)(a);l!==a&&n.push("-g",l)}}),m.disregardIgnoreFiles!==!1?n.push("--no-ignore"):m.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),m.ignoreSymlinks||n.push("--follow"),s.exists&&n.push("--quiet"),n.push("--no-config"),m.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:c.siblingClauses}}function y(s,m,h,t=!0){const n=[];let c={};return s.forEach(i=>{const a=Object.assign({},i.excludePattern||{},m||{}),l=p(a,t?i.folder.fsPath:void 0,h);n.push(...l.globArgs),l.siblingClauses&&(c=Object.assign(c,l.siblingClauses))}),{globArgs:n,siblingClauses:c}}function k(s,m,h=!0){const t=[];return s.forEach(n=>{const c=Object.assign({},m||{},n.includePattern||{}),i=p(c,h?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function p(s,m,h){const t=[],n={};return Object.keys(s).forEach(c=>{if(h&&h.has(c)||!c)return;const i=s[c];c=o(m?u(m,c):c),c.startsWith("\\\\")?c="\\\\"+c.substr(2).replace(/\\/g,"/"):c=c.replace(/\\/g,"/"),typeof i=="boolean"&&i?(c.startsWith("\\\\")&&(c+="**"),t.push(r(c))):i&&i.when&&(n[c]=i)}),{globArgs:t,siblingClauses:n}}function u(s,m){return F.$ic(m)?m:F.$jc(s,m)}e.$zec=u;function o(s){return s=$.$Ke(s,"\\"),$.$Ke(s,"/")}function r(s){return L.$Tf(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.$Aec=r}),define(De[361],Ce([1,0,49,53,16,362,19,41,35,77,33,12,37,15,17,29,36,359,127]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=e.$Bec=void 0;const s=new Set;process.on("exit",()=>{s.forEach(c=>c())});class m{constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&E.$wj(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,r.$zq)(this.b).normalizedLowercase),this.u=i.excludePattern&&E.$wj(i.excludePattern),this.t=new Map,i.folderQueries.forEach(a=>{const l=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),D=a.folder.fsPath;i.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==D).forEach(S=>{(0,R.$Xf)(S,D)&&(l[d.$lc(D,S)]=!0)}),this.t.set(D,new t(l,D))})}cancel(){this.l=!0,s.forEach(i=>i())}walk(i,a,l,D,S){if(this.m=w.$Jd.create(!1),this.l)return S(null,this.j);a.forEach(b=>{const f=d.$nc(b.fsPath);this.u&&this.u(b.fsPath,f)||this.J(l,{relativePath:b.fsPath,searchPath:void 0})}),this.r=w.$Jd.create(!1),this.w(i,(b,f)=>{this.x(this.y,this,b,l,D,g=>{if(g){const P=(0,$.$Ai)(g);console.error(P),this.q.push(P),f(g,void 0)}else f(null,void 0)})},(b,f)=>{this.m.stop();const g=b?A.$Hb(b)[0]:null;S(g,this.j)})}w(i,a,l){const D=new Array(i.length),S=new Array(i.length);let b=!1,f=0;if(i.length===0)return l(null,[]);i.forEach((g,P)=>{a(g,(N,O)=>{if(N?(b=!0,D[P]=null,S[P]=N):(D[P]=O,S[P]=null),++f===i.length)return l(b?S:null,D)})})}x(i,a,...l){try{i.apply(a,l)}catch(D){l[l.length-1](D)}}y(i,a,l,D){const S=i.folder.fsPath,b=I.$k,f=()=>M&&M.kill();s.add(f);let g=K=>{s.delete(f),g=()=>{},D(K)},P="";const N=this.D(),O=(0,o.$yec)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),M=O.cmd,j=!Object.keys(O.siblingClauses).length,U=O.rgArgs.args.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");let T=`${O.rgDiskPath} ${U}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),l({message:T}),this.s=0,this.z(M,"utf8",l,(K,q,ge)=>{if(K){g(K);return}if(this.j){g();return}const Q=(P+(b?v.$ol(q||""):q)).split(`
`);if(ge){const X=Q.length;Q[X-1]=Q[X-1].trim(),Q[X-1]||Q.pop()}else P=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){g(new Error("Splitting up files failed"));return}if(this.s+=Q.length,j){for(const X of Q)if(this.J(a,{base:S,relativePath:X,searchPath:this.N(i,X)}),this.j){f();break}(ge||this.j)&&g();return}this.G(i,N,S,Q,a),ge&&(this.H(N,S,a),g())})}spawnFindCmd(i){const a=this.t.get(i.folder.fsPath),l=a.getBasenameTerms(),D=a.getPathTerms(),S=["-L","."];if(l.length||D.length){S.push("-not","(","(");for(const b of l)S.push("-name",b),S.push("-o");for(const b of D)S.push("-path",b),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),C.spawn("find",S,{cwd:i.folder.fsPath})}readStdout(i,a,l){let D="";this.z(i,a,()=>{},(S,b,f)=>{if(S){l(S);return}D+=b,f&&l(null,D)})}z(i,a,l,D){let S=(g,P,N)=>{(g||N)&&(S=()=>{},this.r?.stop()),D(g,P,N)},b=!1;i.stdout?(this.A(i.stdout,a,S),i.stdout.once("data",()=>b=!0)):l({message:"stdout is null"});let f;i.stderr?f=this.B(i.stderr):l({message:"stderr is null"}),i.on("error",g=>{S(g)}),i.on("close",g=>{let P;!b&&(P=this.C(f,a))&&n(P)?S(new Error(`command failed with error code ${g}: ${this.C(f,a)}`)):(this.g&&g===0&&(this.j=!0),S(null,"",!0))})}A(i,a,l){const D=new L.StringDecoder(a);return i.on("data",S=>{l(null,D.write(S))}),D}B(i){const a=[];return i.on("data",l=>{a.push(l)}),a}C(i,a){const l=new L.StringDecoder(a);return i.map(D=>l.write(D)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:a},l,D,S){D.indexOf(this.b)!==-1&&this.J(S,{base:l,relativePath:this.b,searchPath:this.N(i,this.b)});const b=f=>{const g=d.$nc(f),P=d.$mc(f);let N=a[P];N||(N=a[P]=[],b(P)),N.push({base:l,relativePath:f,basename:g,searchPath:this.N(i,f)})};D.forEach(b)}H({rootEntries:i,pathToEntries:a},l,D){const S=this,b=this.t.get(l),f=this.b;function g(P){S.o++;const N=(0,u.$4I)(()=>P.map(O=>O.basename));for(let O=0,M=P.length;O<M;O++){const j=P[O],{relativePath:U,basename:T}=j;if(b.test(U,T,f!==T?N:void 0))continue;const K=a[U];if(K)g(K);else{if(S.p++,U===f)continue;S.J(D,j)}if(S.j)break}}g(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,a,l,D,S){const b=i.folder,f=(0,u.$4I)(()=>l);this.w(l,(g,P)=>{if(this.l||this.j)return P(null);const N=a?[a,g].join(d.sep):g;if(this.t.get(i.folder.fsPath).test(N,g,this.a.filePattern!==g?f:void 0))return P(null);const O=[b.fsPath,N].join(d.sep);F.lstat(O,(M,j)=>{if(M||this.l||this.j)return P(null);this.L(O,j,(U,T)=>U||this.l||this.j?P(null):T.isDirectory()?(this.o++,this.M(O,j,(K,q)=>K||this.l||this.j||(q=q||"",this.v[q])?P(null):(this.v[q]=!0,p.Promises.readdir(O).then(ge=>{if(this.l||this.j)return P(null);this.I(i,N,ge,D,ee=>P(ee||null))},ge=>{P(null)})))):(this.p++,N===this.b||this.h&&k.$Cf(T.size)&&T.size>this.h||this.J(D,{base:b.fsPath,relativePath:N,searchPath:this.N(i,N)}),P(null,void 0)))})},g=>{const P=g&&A.$Hb(g);return S(P&&P.length>0?P[0]:void 0)})}J(i,a){this.K(a)&&(!this.d||this.d(a.relativePath,d.$nc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(a))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,u.$YI)(i,this.c)}return!0}L(i,a,l){return a.isSymbolicLink()?F.stat(i,l):l(null,a)}M(i,a,l){return a.isSymbolicLink()?F.realpath(i,(D,S)=>D?l(D):l(null,S)):l(null,i)}N(i,a){return i.folderName?d.$jc(i.folderName,a):a}}e.$Bec=m;class h{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new m(i)}search(i,a,l){this.c.walk(this.a,this.b,i,a,(D,S)=>{l(D,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Cec=h;class t{constructor(i,a){this.expression=i,this.c=a,this.d(i)}d(i){let a,l;Object.keys(i).filter(D=>i[D]).forEach(D=>{d.$ic(D)?(a=a||E.$rj(),a[D]=i[D]):(l=l||E.$rj(),l[D]=i[D])}),this.a=a&&E.$wj(a,{trimForExclusions:!0}),this.b=l&&E.$wj(l,{trimForExclusions:!0})}test(i,a,l){return this.b&&this.b(i,a,l)||this.a&&this.a(d.$jc(this.c,i),a,l)}getBasenameTerms(){const i=[];return this.a&&i.push(...E.$yj(this.a)),this.b&&i.push(...E.$yj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...E.$zj(this.a)),this.b&&i.push(...E.$zj(this.b)),i}}function n(c){const i=c.trim().split(`
`),a=i[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return y.$qf(i[i.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(De[363],Ce([1,0,96,22,182,21]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DC=e.$CC=e.$BC=e.$AC=e.$zC=e.$yC=e.$xC=e.$wC=e.$vC=e.DecodeStreamErrorKind=e.$uC=e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=e.$oC=e.$nC=void 0,e.$nC="utf8",e.$oC="utf8bom",e.$pC="utf16be",e.$qC="utf16le";function A(a){return[e.$nC,e.$oC,e.$pC,e.$qC].some(l=>l===a)}e.$rC=A,e.$sC=[254,255],e.$tC=[255,254],e.$uC=[239,187,191];const $=512,E=512,v=512*8,R=512*128;var I;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class w extends Error{constructor(l,D){super(l),this.decodeStreamErrorKind=D}}e.$vC=w;class y{static async create(l){let D;if(l!==e.$nC)D=(await(0,d.$mC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(l));else{const S=new TextDecoder;D={write(b){return S.decode(b,{stream:!0})},end(){return S.decode()}}}return new y(D)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function k(a,l){const D=l.minBytesRequiredForDetection??l.guessEncoding?v:E;return new Promise((S,b)=>{const f=(0,C.$2d)(j=>j.join("")),g=[];let P=0,N;const O=new L.$Xd,M=async()=>{try{const j=await i({buffer:F.$be.concat(g),bytesRead:P},l.guessEncoding);if(j.seemsBinary&&l.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",1);j.encoding=await l.overwriteEncoding(j.encoding),N=await y.create(j.encoding);const U=N.write(F.$be.concat(g).buffer);f.write(U),g.length=0,P=0,S({stream:f,detected:j})}catch(j){O.cancel(),f.destroy(),b(j)}};(0,C.$6d)(a,{onData:async j=>{N?f.write(N.write(j.buffer)):(g.push(j),P+=j.byteLength,P>=D&&(a.pause(),await M(),setTimeout(()=>a.resume())))},onError:j=>f.error(j),onEnd:async()=>{N||await M(),f.end(N?.end())}},O.token)})}e.$wC=k;async function p(a,l,D){const b=(await(0,d.$mC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(l),D);let f=!1,g=!1;return{read(){if(g)return null;const P=a.read();if(typeof P!="string"){if(g=!0,!f&&D?.addBOM)switch(l){case e.$nC:case e.$oC:return F.$be.wrap(Uint8Array.from(e.$uC));case e.$pC:return F.$be.wrap(Uint8Array.from(e.$sC));case e.$qC:return F.$be.wrap(Uint8Array.from(e.$tC))}const N=b.end();return N&&N.length>0?(f=!0,F.$be.wrap(N)):null}return f=!0,F.$be.wrap(b.write(P))}}}e.$xC=p;async function u(a){return(await(0,d.$mC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(a))}e.$yC=u;function o(a){return a===e.$oC||a===null?e.$nC:a}e.$zC=o;function r(a,l){if(!a||l<e.$sC.length)return null;const D=a.readUInt8(0),S=a.readUInt8(1);if(D===e.$sC[0]&&S===e.$sC[1])return e.$pC;if(D===e.$tC[0]&&S===e.$tC[1])return e.$qC;if(l<e.$uC.length)return null;const b=a.readUInt8(2);return D===e.$uC[0]&&S===e.$uC[1]&&b===e.$uC[2]?e.$oC:null}e.$AC=r;const s=["ascii","utf-16","utf-32"];async function m(a){const l=await(0,d.$mC)("jschardet","dist/jschardet.min.js"),D=a.slice(0,R),S=n(D.buffer),b=l.detect(S);if(!b||!b.encoding)return null;const f=b.encoding.toLowerCase();return 0<=s.indexOf(f)?null:t(b.encoding)}const h={ibm866:"cp866",big5:"cp950"};function t(a){const l=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[l]||l}function n(a){let l="";for(let D=0;D<a.length;D++)l+=String.fromCharCode(a[D]);return l}function c(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=a.match(/windows(\d+)/);return l?"windows-"+l[1]:a}}}e.$BC=c;function i({buffer:a,bytesRead:l},D){let S=r(a,l),b=!1;if(S!==e.$pC&&S!==e.$qC&&a){let f=!0,g=!0,P=!1;for(let N=0;N<l&&N<$;N++){const O=N%2===1,M=a.readUInt8(N)===0;if(M&&(P=!0),f&&(O&&!M||!O&&M)&&(f=!1),g&&(O&&M||!O&&!M)&&(g=!1),M&&!f&&!g)break}P&&(f?S=e.$qC:g?S=e.$pC:b=!0)}return D&&!b&&!S&&a?m(a.slice(0,l)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:b,encoding:S}}e.$CC=i,e.$DC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ce([1,0,363,29,153]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;class L extends d.$ydc{constructor($,E,v=F,R="searchProcess"){super($,E,{readdir:I=>v.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,C.$BC)(I)},R)}}e.$Kec=L}),define(De[155],Ce([1,0,49,379,362,19,74,35,16,15,2,36,92,380,360,116]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=e.$Iec=e.$Hec=e.$Gec=e.$Fec=e.$Eec=e.$Dec=void 0;const u=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(g){this.a=g}provideTextSearchResults(g,P,N,O){return this.a.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((M,j)=>{O.onCancellationRequested(()=>X());const U=n(g,P),T=P.folder.fsPath,K=U.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");this.a.appendLine(`${u} ${K}
 - cwd: ${T}`);let q=C.spawn(u,U,{cwd:T});q.on("error",H=>{console.error(H),this.a.appendLine("Error: "+(H&&H.message)),j((0,I.$UI)(new I.$SI(H&&H.message,I.SearchErrorCode.rgProcessError)))});let ge=!1;const ee=new m(P.maxResults,T,P.previewOptions);ee.on("result",H=>{ge=!0,ie="",N.report(H)});let Q=!1;const X=()=>{Q=!0,q?.kill(),ee?.cancel()};let ae=!1;ee.on("hitLimit",()=>{ae=!0,X()});let ie="";q.stdout.on("data",H=>{ee.handleData(H),ge||(ie+=H)});let ce=!1;q.stdout.once("data",()=>ce=!0);let we="";q.stderr.on("data",H=>{const B=H.toString();this.a.appendLine(B),we.length+B.length<1e6&&(we+=B)}),q.on("close",()=>{if(this.a.appendLine(ce?"Got data from stdout":"No data from stdout"),this.a.appendLine(ge?"Got result from parser":"No result from parser"),ie&&this.a.appendLine(`Got data without result: ${ie}`),this.a.appendLine(""),Q)M({limitHit:ae});else{ee.flush(),q=null;let H;we&&!ce&&(H=r(we))?j((0,I.$UI)(new I.$SI(H.message,H.code))):M({limitHit:ae})}})})}}e.$Dec=o;function r(f){const g=f.split(`
`),P=g[0].trim();if(g.some(O=>O.startsWith("regex parse error")))return new I.$SI(s(g),I.SearchErrorCode.regexParseError);const N=P.match(/grep config error: unknown encoding: (.*)/);if(N)return new I.$SI(`Unknown encoding: ${N[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$SI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$SI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$SI(P,I.SearchErrorCode.regexParseError)}function s(f){const g=["Regex parse error"],P=f.filter(N=>N.startsWith("PCRE2:"));if(P.length>=1){const N=P[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const O=N.split(":")[1];g.push(":"+O)}}return g.join("")}class m extends F.EventEmitter{constructor(g,P,N){super(),this.g=g,this.h=P,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new d.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(g,P){return super.on(g,P),this}handleData(g){if(this.b)return;const P=typeof g=="string"?g:this.d.write(g);this.k(P)}k(g){let P=g.indexOf(`
`);const N=this.a+g;if(P>=0)P+=this.a.length;else{this.a=N;return}let O=0;for(;P>=0;)this.m(N.substring(O,P).trim()),O=P+1,P=N.indexOf(`
`,O);this.a=N.substring(O)}m(g){if(this.b||!g)return;let P;try{P=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(P.type==="match"){const N=h(P.data.path),O=R.URI.file(E.$jc(this.h,N)),M=this.n(P.data,O);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const N=h(P.data.path),O=R.URI.file(E.$jc(this.h,N));this.o(P.data,O).forEach(j=>this.p(j))}}n(g,P){const N=g.line_number-1,O=h(g.lines),M=Buffer.from(O);let j=0,U=0,T=N;g.submatches.length===0&&g.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const K=(0,L.$Hb)(g.submatches.map((q,ge)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=h(q.match),Q=M.slice(j,q.start).toString(),X=t(Q),ae=X.numLines>0?X.lastLineLength:X.lastLineLength+U,ie=t(ee),ce=X.numLines+T,we=ie.numLines+ce,H=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+ae;return j=q.end,U=H,T=we,new w.$CI(ce,ae,we,H)}));return(0,p.$wec)(P,O,K,this.j)}o(g,P){const N=h(g.lines),O=g.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,j)=>({text:M,uri:P,lineNumber:O+j}))}p(g){this.emit("result",g)}}e.$Eec=m;function h(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function t(f){const g=/\n/g;let P=0,N=-1,O;for(;O=g.exec(f);)P++,N=O.index;const M=N>=0?f.length-N-1:f.length;return{numLines:P,lastLineLength:M}}function n(f,g){const P=["--hidden","--no-require-git"];P.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:O}=(0,A.$J)(g.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const j=new Set;O.forEach(U=>{j.add(U)}),P.push("-g","!*"),j.forEach(U=>{c(U).map(p.$vec).forEach(T=>{P.push("-g",T)})})}N&&N.length&&N.forEach(j=>{P.push("-g",j)}),g.excludes.map(p.$vec).forEach(j=>P.push("-g",`!${j}`)),g.maxFileSize&&P.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),g.followSymlinks&&P.push("--follow"),g.encoding&&g.encoding!=="utf8"&&P.push("--encoding",g.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,v.$Fe)(f.pattern),f.isRegExp=!0),g.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),f.isRegExp&&(f.pattern=i(f.pattern),P.push("--engine","auto"));let M;if(f.isWordMatch){const U=(0,v.$Ne)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",U)}else if(f.isRegExp){let j=l(f.pattern);j=D(j),P.push("--regexp",j)}else M=f.pattern,P.push("--fixed-strings");return P.push("--no-config"),g.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),f.isMultiline&&P.push("--multiline"),g.beforeContext&&P.push("--before-context",g.beforeContext+""),g.afterContext&&P.push("--after-context",g.afterContext+""),P.push("--"),M&&P.push(M),P.push("."),P}e.$Fec=n;function c(f){return b(f).flatMap(P=>{const N=(0,$.$uj)(P,"/");return N.map((O,M)=>N.slice(0,M+1).join("/"))})}function i(f){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(g);)f=f.replace(g,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(P);)f=f.replace(P,"$1\\x{$2}");return f}e.$Gec=i;const a=f=>f.type==="Assertion"&&f.kind==="lookbehind";function l(f){let g;try{g=new y.RegExpParser().parsePattern(f)}catch{return f}let P="",N=0;const O=(U,T,K)=>{P+=f.slice(N,U)+K,N=T},M=[];return new y.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const T=M[0];if(!T)O(U.start,U.end,"\\r?\\n");else if(!M.some(a))if(T.type==="CharacterClass")if(T.negate){const K=f.slice(T.start+2,U.start)+f.slice(U.end,T.end-1);T.parent?.type==="Quantifier"?O(T.start,T.end,K?`[^${K}]`:"."):O(T.start,T.end,"(?!\\r?\\n"+(K?`|[${K}]`:"")+")")}else{const K=f.slice(T.start+1,U.start)+f.slice(U.end,T.end-1);O(T.start,T.end,K===""?"\\r?\\n":`(?:[${K}]|\\r?\\n)`)}else T.type==="Quantifier"&&O(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){M.unshift(U)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(U){M.unshift(U)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(U){M.unshift(U)},onCharacterClassLeave(){M.shift()},onAssertionEnter(U){a(U)&&M.push(U)},onAssertionLeave(U){M[0]===U&&M.shift()}}).visit(g),P+=f.slice(N),P}e.$Hec=l;function D(f){return f.replace(/\n/g,"\\r?\\n")}e.$Iec=D;function S(f){let g=!1,P=!1,N="",O="";for(let M=0;M<f.length;M++){const j=f[M];switch(j){case"\\":P?(g?O+="\\"+j:N+="\\"+j,P=!1):P=!0;break;case"{":if(P)g?O+=j:N+=j,P=!1;else{if(g)return{strInBraces:N+"{"+O+"{"+f.substring(M+1)};g=!0}break;case"}":if(P)g?O+=j:N+=j,P=!1;else{if(g)return{fixedStart:N,strInBraces:O,fixedEnd:f.substring(M+1)};N+=j}break;default:g?O+=(P?"\\":"")+j:N+=(P?"\\":"")+j,P=!1;break}}return{strInBraces:N+(g?"{"+O:"")}}function b(f){const{fixedStart:g,strInBraces:P,fixedEnd:N}=S(f);if(g===void 0||N===void 0)return[P];let O=(0,$.$uj)(P,",");O.length||(O=[""]);const M=b(N);return O.flatMap(j=>{const U=g+j;return M.map(T=>U+T)})}e.$Jec=b}),define(De[364],Ce([1,0,21,155,64,18]),function($e,e,C,F,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class A{constructor(v){this.b=v,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(v,R,I,w){const y=new F.$Dec(this.b);if(R.folder.scheme===L.Schemas.vscodeUserData){const k={...R,folder:R.folder.with({scheme:L.Schemas.file})},p=new d.$6u(u=>I.report({...u,uri:u.uri.with({scheme:R.folder.scheme})}));return this.c(w,u=>y.provideTextSearchResults(v,k,p,u))}else return this.c(w,k=>y.provideTextSearchResults(v,R,I,k))}async c(v,R){const I=$(v);this.a.add(I);const w=await R(I.token);return this.a.delete(I),w}d(){this.a.forEach(v=>v.cancel())}}e.$Nec=A;function $(E){const v=new C.$Xd;return E.onCancellationRequested(()=>v.cancel()),v}}),define(De[365],Ce([1,0,29,155,154]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class L{constructor(E){this.a=E}search(E,v,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(y){R({message:y})}},w=new d.$Kec(this.a,new F.$Dec(I),C);return new Promise((y,k)=>w.search(p=>{v(p.map(A))},E).then(p=>y({limitHit:p.limitHit,type:"success",stats:p.stats}),k))}}e.$Lec=L;function A($){return{path:$.resource&&$.resource.fsPath,results:$.results,numMatches:($.results||[]).reduce((E,v)=>{if(v.ranges){const R=v;return E+(Array.isArray(R.ranges)?R.ranges.length:1)}else return E+1},0)}}}),define(De[366],Ce([1,0,19,8,9,4,127,16,37,2,30,36,361,365]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;class k{static{this.a=512}constructor(m="searchProcess"){this.d=m,this.b=Object.create(null)}fileSearch(m){let h;const t=o(m),n=new L.$Nd({onDidAddFirstListener:()=>{h=(0,F.$Hg)(c=>this.doFileSearchWithEngine(w.$Cec,t,i=>n.fire(i),c)),h.then(c=>n.fire(c),c=>n.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{h.cancel()}});return n.event}textSearch(m){let h;const t=o(m),n=new L.$Nd({onDidAddFirstListener:()=>{h=(0,F.$Hg)(c=>this.f(t,i=>n.fire(i),c)),h.then(c=>n.fire(c),c=>n.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{h.cancel()}});return n.event}f(m,h,t){return m.maxFileSize=this.g().maxFileSize,new y.$Lec(m).search(t,h,h)}g(){return{maxFileSize:process.arch==="ia32"?300*R.$Gk.MB:16*R.$Gk.GB}}doFileSearch(m,h,t){return this.doFileSearchWithEngine(w.$Cec,m,h,t)}doFileSearchWithEngine(m,h,t,n,c=k.a){let i=0;const a=D=>{Array.isArray(D)?(i+=D.length,t(D.map(S=>this.h(S)))):D.relativePath?(i++,t(this.h(D))):t(D)};if(h.sortByScore){let D=this.l(h,a,n);if(!D){const S=h.maxResults?Object.assign({},h,{maxResults:null}):h,b=new m(S);D=this.j(b,h,t,a,n)}return new Promise((S,b)=>{D.then(([f,g])=>{const P=g.map(N=>this.h(N));this.o(P,t,c),S(f)},b)})}const l=new m(h);return this.r(l,a,c,n).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h(m){return{path:m.base?(0,$.$jc)(m.base,m.relativePath):m.relativePath}}j(m,h,t,n,c){const i=new L.$Nd;let a=(0,F.$Hg)(D=>{let S=[];const b=f=>{Array.isArray(f)?S=f:(n(f),i.fire(f))};return this.r(m,b,-1,D).then(f=>[f,S])}),l;if(h.cacheKey){l=this.k(h.cacheKey);const D={promise:a,event:i.event,resolved:!1};l.resultsToSearchCache[h.filePattern||""]=D,a.then(()=>{D.resolved=!0},S=>{delete l.resultsToSearchCache[h.filePattern||""]}),a=this.s(a)}return a.then(([D,S])=>{const b=l?l.scorerCache:Object.create(null),f=(typeof h.maxResults!="number"||h.maxResults>0)&&E.$Jd.create(!1);return this.n(h,S,b,c).then(g=>{const P=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:h.folderQueries.length,resultCount:g.length},messages:D.messages,limitHit:D.limitHit||typeof h.maxResults=="number"&&S.length>h.maxResults},g]})})}k(m){const h=this.b[m];return h||(this.b[m]=new p)}l(m,h,t){const n=m.cacheKey&&this.b[m.cacheKey];if(!n)return;const c=this.q(n,m.filePattern||"",h,t);if(c)return c.then(([i,a,l])=>{const D=E.$Jd.create(!1);return this.n(m,a,n.scorerCache,t).then(S=>{const b=D.elapsed(),f={fromCache:!0,detailStats:l,type:this.d,resultCount:a.length,sortingTime:b};return[{type:"success",limitHit:i.limitHit||typeof m.maxResults=="number"&&a.length>m.maxResults,stats:f},S]})})}n(m,h,t,n){const c=(0,A.$zq)(m.filePattern||""),i=(l,D)=>(0,A.$yq)(l,D,c,!0,u,t),a=typeof m.maxResults=="number"?m.maxResults:Number.MAX_VALUE;return C.$Gb(h,i,a,1e4,n)}o(m,h,t){if(t&&t>0)for(let n=0;n<m.length;n+=t)h(m.slice(n,n+t));else h(m)}q(m,h,t,n){const c=E.$Jd.create(!1),i=h.indexOf($.sep)>=0;let a;for(const b in m.resultsToSearchCache)if(h.startsWith(b)){if(i&&b.indexOf($.sep)<0&&b!=="")continue;const f=m.resultsToSearchCache[b];a={promise:this.s(f.promise),event:f.event,resolved:f.resolved};break}if(!a)return null;const l=c.elapsed(),D=E.$Jd.create(!1),S=a.event(t);return n&&n.onCancellationRequested(()=>{S.dispose()}),a.promise.then(([b,f])=>{if(n&&n.isCancellationRequested)throw(0,d.$6)();const g=[],P=(0,A.$zq)(h).normalizedLowercase;for(const N of f)(0,I.$YI)(N,P)&&g.push(N);return[b,g,{cacheWasResolved:a.resolved,cacheLookupTime:l,cacheFilterTime:D.elapsed(),cacheEntryCount:f.length}]})}r(m,h,t,n){return new Promise((c,i)=>{let a=[];n?.onCancellationRequested(()=>m.cancel()),m.search(l=>{l&&(t?(a.push(l),t>0&&a.length>=t&&(h(a),a=[])):h(l))},l=>{h(l)},(l,D)=>{a.length&&h(a),l?i(l):c(D)})})}clearCache(m){return delete this.b[m],Promise.resolve(void 0)}s(m){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(h,t){return m.then(h,t)}catch(h){return this.then(void 0,h)}finally(h){return m.finally(h)}}}}e.$Mec=k;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(s){return(0,$.$nc)(s.relativePath)}getItemDescription(s){return(0,$.$mc)(s.relativePath)}getItemPath(s){return s.relativePath}};function o(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(r),extraFileResources:s.extraFileResources&&s.extraFileResources.map(m=>v.URI.revive(m))}}function r(s){return{...s,folder:v.URI.revive(s.folder)}}}),define(De[367],Ce([1,0,3,18,2,29,14,27,20,95,67,36,366,364,116,154]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;let u=class extends v.$Ddc{constructor(r,s,m,h){super(r,m,h),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new C.$Rc;const t=new k.$xec("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new y.$Nec(t))),s.remote.isRemote&&s.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const r=new k.$xec("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new y.$Nec(r))),this.x.add(this.z(F.Schemas.file,new w.$Mec("fileSearchProvider")))}z(r,s){const m=this.d++;return this.v=s,this.t=m,this.c.$registerFileSearchProvider(m,this.o(r)),(0,C.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(m)})}$provideFileSearchResults(r,s,m,h){const t=(0,v.$Edc)(m);return r===this.t?this.A(r,s,t,h):super.$provideFileSearchResults(r,s,m,h)}A(r,s,m,h){const t=n=>{if((0,I.$XI)(n)&&(n=[n]),Array.isArray(n)){this.c.$handleFileMatch(r,s,n.map(c=>d.URI.file(c.path)));return}n.message&&this.n.debug("ExtHostSearch",n.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(m,t,h)}$clearCache(r){return this.v?.clearCache(r),super.$clearCache(r)}q(r,s){return new p.$Kec(r,s,void 0,"textSearchProvider")}};e.$Oec=u,e.$Oec=u=He([Be(0,E.$hM),Be(1,$.$xM),Be(2,R.$jcc),Be(3,A.$0i)],u)}),define(De[117],Ce([1,0,381,60,63,382,22,9,4,3,16,12,31,81,82]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;class p{traceSocketEvent(f,g){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,g)}constructor(f,g=""){this.f=!0,this.debugLabel=g,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,$.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const g=P=>{this.traceSocketEvent("read",P),f(A.$be.wrap(P))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(f){const g=P=>{f({type:0,hadError:P,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(f){const g=()=>{f()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,$.$1)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,$.$1)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Eh=p;var u;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var o;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(o||(o={}));class r extends v.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,g){this.socket.traceSocketEvent(f,g)}constructor(f,g,P,N){super(),this.f=this.B(new E.$Nd),this.g=this.B(new E.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new s(this,g,P,N,this.f,(O,M)=>this.m(O,M))),this.B(this.a.onError(O=>{console.error(O),(0,$.$1)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new k.$zh,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let g=0;for(;g<f.byteLength;)this.a.writeMessage(f.slice(g,Math.min(g+262144,f.byteLength)),{compressed:!0,opcode:2}),g+=262144}m(f,{compressed:g,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let N=2;f.byteLength<126?N+=0:f.byteLength<2**16?N+=2:N+=8;const O=A.$be.alloc(N),M=g?64:0,j=P&15;if(O.writeUInt8(128|M|j,0),f.byteLength<126)O.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){O.writeUInt8(126,1);let U=1;O.writeUInt8(f.byteLength>>>8&255,++U),O.writeUInt8(f.byteLength>>>0&255,++U)}else{O.writeUInt8(127,1);let U=1;O.writeUInt8(0,++U),O.writeUInt8(0,++U),O.writeUInt8(0,++U),O.writeUInt8(0,++U),O.writeUInt8(f.byteLength>>>24&255,++U),O.writeUInt8(f.byteLength>>>16&255,++U),O.writeUInt8(f.byteLength>>>8&255,++U),O.writeUInt8(f.byteLength>>>0&255,++U)}this.socket.write(A.$be.concat([O,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const g=this.b.peek(this.j.readLen),P=g.readUInt8(0),N=(P&128)>>>7,O=(P&64)>>>6,M=P&15,j=g.readUInt8(1),U=(j&128)>>>7,T=j&127;this.j.state=2,this.j.readLen=2+(U?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const g=this.b.read(this.j.readLen),P=g.readUInt8(1),N=(P&128)>>>7;let O=P&127,M=1;O===126?O=g.readUInt8(++M)*2**8+g.readUInt8(++M):O===127&&(O=g.readUInt8(++M)*0+g.readUInt8(++M)*0+g.readUInt8(++M)*0+g.readUInt8(++M)*0+g.readUInt8(++M)*2**24+g.readUInt8(++M)*2**16+g.readUInt8(++M)*2**8+g.readUInt8(++M));let j=0;N&&(j=g.readUInt8(++M)*2**24+g.readUInt8(++M)*2**16+g.readUInt8(++M)*2**8+g.readUInt8(++M)),this.j.state=3,this.j.readLen=O,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const g=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),t(g,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(g,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(g,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Fh=r;class s extends v.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$be.alloc(0)}constructor(f,g,P,N,O,M){super(),this.n=f,this.r=O,this.s=M,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,g?(this.b=this.B(new m(this.n,N,P,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(f,g){this.g.push({data:f,options:g}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:g}=this.g.shift();if(this.f&&g.compressed){const P=await this.w(this.f,f);this.s(P,g)}else this.s(f,{...g,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,g){return new Promise((P,N)=>{f.write(g),f.flush(O=>P(O))})}acceptFrame(f,g,P){this.h.push({data:f,isCompressed:g,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const g=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(g)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,g,P){return new Promise((N,O)=>{f.write(g),P&&f.write(A.$be.fromByteArray([0,0,255,255])),f.flush(M=>N(M))})}}class m extends v.$Sc{get recordedInflateBytes(){return this.j?A.$be.concat(this.f):A.$be.alloc(0)}constructor(f,g,P,N){super(),this.h=f,this.j=g,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(A.$be.wrap(O))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const g=A.$be.concat(this.g);this.g.length=0,f(g)})}}class h extends v.$Sc{constructor(f,g){super(),this.g=f,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(A.$be.wrap(P))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let g=A.$be.concat(this.f);this.f.length=0,g=g.slice(0,g.byteLength-4),f(g)})}}function t(b,f){if(f===0)return;const g=b.byteLength>>>2;for(let U=0;U<g;U++){const T=b.readUInt32BE(U*4);b.writeUInt32BE(T^f,U*4)}const P=g*4,N=b.byteLength-P,O=f>>>24&255,M=f>>>16&255,j=f>>>8&255;N>=1&&b.writeUInt8(b.readUInt8(P)^O,P),N>=2&&b.writeUInt8(b.readUInt8(P+1)^M,P+1),N>=3&&b.writeUInt8(b.readUInt8(P+2)^j,P+2)}e.$Gh=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function c(){const b=(0,w.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const f=process.platform!=="darwin"&&e.$Gh?e.$Gh:(0,d.tmpdir)(),g=(0,R.$jc)(f,`vscode-ipc-${b}.sock`);return a(g),g}e.$Hh=c;function i(b,f,g){const P=(0,C.createHash)("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${g}-${f}-sock`;const N=g.substr(0,4),O=f.substr(0,6),M=P.substr(0,8);let j;return process.platform!=="darwin"&&e.$Gh&&!process.env.VSCODE_PORTABLE?j=(0,R.$jc)(e.$Gh,`vscode-${M}-${N}-${O}.sock`):j=(0,R.$jc)(b,`${N}-${O}.sock`),a(j),j}e.$Ih=i;function a(b){const f=n[I.$u];typeof f=="number"&&b.length>=f&&console.warn(`WARNING: IPC handle "${b}" is longer than ${f} chars, try a shorter --user-data-dir`)}class l extends y.$th{static b(f){const g=E.Event.fromNodeEventEmitter(f,"connection");return E.Event.map(g,P=>({protocol:new k.$Ah(new p(P,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(P,"close"))}))}constructor(f){super(l.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Jh=l;function D(b){return new Promise((f,g)=>{const P=(0,F.createServer)();P.on("error",g),P.listen(b,()=>{P.removeListener("error",g),f(new l(P))})})}e.$Kh=D;function S(b,f){return new Promise((g,P)=>{const N=(0,F.createConnection)(b,()=>{N.removeListener("error",P),g(k.$Bh.fromSocket(new p(N,`ipc-client${f}`),f))});N.once("error",P)})}e.$Lh=S}),define(De[368],Ce([1,0,60,63,163,117,8,3,12,50,14,135,247,248,106,86,22]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=e.$_7b=e.$$7b=e.$07b=void 0;async function o(t,n,c,i,a){let l;for(let D=3;D&&(l?.dispose(),l=await new r(t,n,c,i,a).waitForReady(),!(a&&d.$hg[a]||!d.$hg[l.tunnelLocalPort]));D--);return l}class r extends $.$Sc{constructor(n,c,i,a,l){super(),this.m=c,this.n=l,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=C.createServer(),this.c=new A.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(c=>{c()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,c=(0,p.$ev)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,d.$ig)(n,2,1e3,c),a=null;return this.b.listen(i,this.m),await this.c.wait(),a=this.b.address(),a||(i=0,this.b.listen(i,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(n){n.pause();const c=(0,p.$cv)(this.tunnelRemoteHost)||(0,p.$ev)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,w.$6k)(this.a,c,this.tunnelRemotePort),a=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&n.write(l.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),a.end()}),n.on("close",()=>a.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),a instanceof L.$Eh?a.socket.destroy():a.end()}),a instanceof L.$Eh?this.t(n,a):this.s(n,a),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),a.end()})}s(n,c){c.onClose(()=>n.destroy()),c.onEnd(()=>n.end()),c.onData(i=>n.write(i.buffer)),n.on("data",i=>c.write(u.$be.wrap(i))),n.resume()}t(n,c){const i=c.socket;i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>{n.destroy()}),i.pipe(n),n.pipe(i)}}e.$07b=r;let s=class extends p.$hv{constructor(n,c,i,a,l){super(c,l),this.u=n,this.v=i,this.w=a}isPortPrivileged(n){return(0,p.$fv)(n,this.l,E.OS,F.release())}s(n,c,i,a,l,D,S,b){const f=this.r(c,i);if(f)return++f.refcount,f.value;if((0,p.$_u)(n))return this.t(n,c,i,l,D,S,b);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${i} on local port ${l}.`);const g={commit:this.w.commit,quality:this.w.quality,addressProvider:n,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=o(g,a,c,i,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(c,i,P),P}}};e.$$7b=s,e.$$7b=s=He([Be(0,y.$Zk),Be(1,R.$0i),Be(2,k.$3k),Be(3,I.$pj),Be(4,v.$ji)],s);let m=class extends s{constructor(n,c,i,a,l){super(n,c,i,a,l)}};e.$_7b=m,e.$_7b=m=He([Be(0,y.$Zk),Be(1,R.$0i),Be(2,k.$3k),Be(3,I.$pj),Be(4,v.$ji)],m);let h=class extends $.$Sc{constructor(n,c,i,a,l){super(),this.b=n,this.c=c,this.f=i,this.g=a,this.h=l,this.a=new Map}async openTunnel(n,c,i,a,l,D,S,b,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${a} on local port ${D}.`),!this.a.has(n)){const g=new m(this.b,this.c,this.g,this.f,this.h);this.B(g),this.a.set(n,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(c,i,a,l,D,S,b,f)}};e.$a8b=h,e.$a8b=h=He([Be(0,y.$Zk),Be(1,R.$0i),Be(2,I.$pj),Be(3,k.$3k),Be(4,v.$ji)],h)}),define(De[369],Ce([1,0,117,267,53,34,2,14,44]),function($e,e,C,F,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.$IM=void 0;class v{constructor(w,y,k){this.b=w,this.c=y,this.f=k,this.a=F.createServer((p,u)=>this.h(p,u)),this.g().catch(p=>(y.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,y){const k=(u,o)=>{y.writeHead(u,{"content-type":"application/json"}),y.end(JSON.stringify(o||null),r=>r&&this.c.error(r))},p=[];w.setEncoding("utf8"),w.on("data",u=>p.push(u)),w.on("end",async()=>{try{const u=JSON.parse(p.join(""));let o;switch(u.type){case"open":o=await this.i(u);break;case"openExternal":o=await this.j(u);break;case"status":o=await this.l(u);break;case"extensionManagement":o=await this.k(u);break;default:k(404,`Unknown message type: ${u.type}`);break}k(200,o)}catch(u){const o=u instanceof Error?u.message:JSON.stringify(u);k(500,o),this.c.error("Error while processing pipe request",u)}})}async i(w){const{fileURIs:y,folderURIs:k,forceNewWindow:p,diffMode:u,mergeMode:o,addMode:r,forceReuseWindow:s,gotoLineMode:m,waitMarkerFilePath:h,remoteAuthority:t}=w,n=[];if(Array.isArray(k))for(const l of k)try{n.push({folderUri:A.URI.parse(l)})}catch{}if(Array.isArray(y))for(const l of y)try{(0,E.$ii)(l)?n.push({workspaceUri:A.URI.parse(l)}):n.push({fileUri:A.URI.parse(l)})}catch{}const c=h?A.URI.file(h):void 0,a={forceNewWindow:p,diffMode:u,mergeMode:o,addMode:r,gotoLineMode:m,forceReuseWindow:s,preferNewWindow:!s&&!c&&!r,waitMarkerFileURI:c,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",n,a)}async j(w){for(const y of w.uris){const k=A.URI.parse(y),p=k.scheme==="file"?k:y;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(w){const y=p=>p?.map(u=>/\.vsix$/i.test(u)?A.URI.parse(u):u),k={list:w.list,install:y(w.install),uninstall:y(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&d.existsSync(this.f)&&d.unlinkSync(this.f)}}e.$IM=v;let R=class extends v{constructor(w,y){super(w,y,(0,C.$Hh)())}};e.$JM=R,e.$JM=R=He([Be(0,L.$DM),Be(1,$.$0i)],R)}),define(De[370],Ce([1,0,54,357,352,266,46,340,2,18,7,369,100,338,339]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=void 0;class p extends d.$iec{j(){const r=this,s=globalThis._VSCODE_NODE_MODULES.module,m=s._load;s._load=function(c,i,a){return c=t(c),r.a.has(c)?r.a.get(c).load(c,E.URI.file((0,w.$9p)(i.filename)),l=>m.apply(this,[l,i,a])):m.apply(this,arguments)};const h=s._resolveLookupPaths;s._resolveLookupPaths=(n,c)=>h.call(this,t(n),c);const t=n=>{for(const c of r.b){const i=c(n);if(i){n=i;break}}return n}}}class u extends A.$Tcc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$Rec);const r=this.h.invokeFunction(F.$eec);if(this.h.createInstance($.$Qec),this.f.remote.isRemote&&this.f.remote.authority){const h=this.h.createInstance(I.$JM);process.env.VSCODE_IPC_HOOK_CLI=h.ipcHandlePath}this.h.createInstance(k.$Sec),await this.h.createInstance(p,r,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const m=await this.m.getConfigProvider();await(0,L.$Pec)(this.j,m,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(r){return r.main}async vb(r,s,m){if(s.scheme!==v.Schemas.file)throw new Error(`Cannot load URI: '${s}', must be of file-scheme`);let h=null;m.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${s.toString(!0)}`),this.s.flush();const t=r?.identifier.value;r&&await this.w.initializeLocalizedMessages(r);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),h=$e.__$__nodeRequire(s.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),m.codeLoadingStop()}return h}async $setRemoteEnvironment(r){if(this.f.remote.isRemote)for(const s in r){const m=r[s];m===null?delete process.env[s]:process.env[s]=m}}}e.$Tec=u}),define(De[371],Ce([1,0,49,22,4,3,120,12,23,2,29,14,246,65,106,86,368,27,20,73,348]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=e.$1ec=e.$Zec=e.$Yec=e.$Xec=e.$Wec=e.$Vec=e.$Uec=void 0;function h(f){const g=f.trim().split(`
`),P=[];return g.forEach(O=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);M&&M.length>=3&&P.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),P.reduce((O,M)=>(O[M.socket]=M,O),{})}e.$Uec=h;function t(...f){const g=[].concat(...f.map(c));return[...new Map(g.filter(P=>P.st==="0A").map(P=>{const N=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:n(N[0]),port:parseInt(N[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Vec=t;function n(f){let g="";if(f.length===8)for(let P=f.length-2;P>=0;P-=2)g+=parseInt(f.substr(P,2),16),P!==0&&(g+=".");else for(let P=0;P<f.length;P+=8){const N=f.substring(P,P+8);let O="";for(let M=8;M>=2;M-=2)O+=N.substring(M-2,M),(M===6||M===2)&&(O=parseInt(O,16).toString(16),g+=`${O}`,O="",P+M!==f.length-6&&(g+=":"))}return g}e.$Wec=n;function c(f){const g=f.trim().split(`
`),P=g.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return g.map(O=>O.trim().split(/\s+/).reduce((M,j,U)=>(M[P[U]||U]=j,M),{}))}e.$Xec=c;function i(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/server-main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function a(f){const g=f.trim().split(`
`),P=[];return g.forEach(N=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);O&&O.length>=4&&P.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),P}e.$Yec=a;async function l(f,g,P){const N=P.reduce((M,j)=>(M[j.pid]=j,M),{}),O=[];return f.forEach(({socket:M,ip:j,port:U})=>{const T=g[M]?g[M].pid:void 0,K=T?N[T]?.cmd:void 0;T&&K&&!i(K)&&O.push({host:j,port:U,detail:K,pid:T})}),O}e.$Zec=l;function D(f,g,P){const N=new Map,O=a(g);for(const M of f){const j=P.get(M.port);if(j){N.set(M.port,j);continue}const U=O.find(T=>T.cmd.includes(`${M.port}`));if(U){let T=U,K;do K=O.find(q=>q.ppid===T.pid),K&&(T=K);while(K);N.set(M.port,{host:M.ip,port:M.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else N.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return N}e.$1ec=D;let S=class extends s.$7vb{constructor(g,P,N,O){super(g,P,N),this.D=P,this.F=O,this.y=void 0,this.z=new Map,this.C=!1,$.$l&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(g){if(g&&this.C)return;this.C=g;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new A.$Rl;let O=0;for(;this.C;){const M=new Date().getTime(),j=(await this.I()).filter(K=>(0,p.$cv)(K.host)||(0,p.$ev)(K.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(K=>K.port).join(", ")}`);const U=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${U} ms.`),O++>3&&N.update(U),(!P||JSON.stringify(P)!==JSON.stringify(j))&&(P=j,await this.a.$onFoundNewCandidates(P));const T=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(K=>setTimeout(()=>K(),T))}}G(g){return Math.max(g*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(g=>g.port).join(", ")}`)}async I(){let g="",P="";try{g=await R.Promises.readFile("/proc/net/tcp","utf8"),P=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(g,P),O=await new Promise(ee=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,X,ae)=>{ee(X)})}),M=h(O),j=await R.Promises.readdir("/proc"),U=[];for(const ee of j)try{const Q=Number(ee),X=E.$vg(v.URI.file("/proc"),ee);if((await R.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(Q)){const ie=await R.Promises.readlink(E.$vg(X,"cwd").fsPath),ce=await R.Promises.readFile(E.$vg(X,"cmdline").fsPath,"utf8");U.push({pid:Q,cwd:ie,cmd:ce})}}catch{}const T=[],K=N.filter(ee=>{const Q=M[ee.socket];return Q||T.push(ee),Q}),q=l(K,M,U);let ge;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const ee=await new Promise(Q=>{(0,C.exec)("ps -F -A -l | grep root",(X,ae,ie)=>{Q(ae)})});this.z=D(T,ee,this.z),ge=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ge.map(Q=>Q.port).join(", ")}`)}return q.then(ee=>ge?ee.concat(ge):ee)}w(g){return async P=>{const N=new u.$07b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,j,U,T){const K=await g.makeConnection();return b.connect(K,j,U,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Qk(0),connectionToken:g.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await N.waitForReady();const O=new d.$Nd;return{localAddress:(0,m.$GJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{N.dispose(),O.fire(),O.dispose()}}}}};e.$2ec=S,e.$2ec=S=He([Be(0,r.$hM),Be(1,o.$xM),Be(2,I.$0i),Be(3,k.$3k)],S);class b extends w.$Ckb{static connect(g,P,N,O){const M=new L.$Rc,j={onClose:M.add(new d.$Nd),onData:M.add(new d.$Nd),onEnd:M.add(new d.$Nd)};M.add(g.onDidReceiveMessage(T=>j.onData.fire(F.$be.wrap(T)))),M.add(g.onDidEnd(()=>j.onEnd.fire())),M.add(g.onDidClose(T=>j.onClose.fire({type:0,error:T,hadError:!!T})));const U=new b(g,O,j);return U.B(M),(0,w.$Bkb)(U,P,N,O,j)}constructor(g,P,N){super(P,N),this.n=g}write(g){this.n.send(g.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(De[372],Ce([1,0,103,343,355,354,367,370,371,94,46,95,93,45,73,90,342,341,14,356,56,261,102,106,138]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o,r,s,m,h,t,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$xr)(R.$Ucc,$.$Tec,0),(0,C.$xr)(r.$$i,o.$4ec,1),(0,C.$xr)(r.$0i,new t.$Mh(h.$hec,[!1],!0)),(0,C.$xr)(n.$3k,c.$c8b,1),(0,C.$xr)(p.$Fcc,u.$3ec,0),(0,C.$xr)(v.$sdc,L.$uec,0),(0,C.$xr)(I.$Cdc,A.$Oec,0),(0,C.$xr)(w.$ndc,d.$mec,0),(0,C.$xr)(y.$Hcc,F.$lec,0),(0,C.$xr)(k.$6vb,E.$2ec,0),(0,C.$xr)(m.$qdc,s.$5ec,0)}),define(De[383],Ce([1,0,60,384,54,9,82,117,244,111,353,22,29,100,8,130,268,286,358,372]),function($e,e,C,F,d,L,A,$,E,v,R,I,w,y,k,p,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const r=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const a=globalThis._VSCODE_NODE_MODULES.module,l=a._load;a._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const s=process.exit.bind(process);function m(a){process.exit=function(l){if(a)s(l);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let h=function(a){s()};function t(){const a=(0,o.$Bm)(process.env);if(a.type===3)return new Promise((l,D)=>{const S=b=>{const f=b[0],g=new A.$Ch;f.on("message",P=>g.fire(I.$be.wrap(P.data))),f.on("close",()=>{h("renderer closed the MessagePort")}),f.start(),l({onMessage:g.event,send:P=>f.postMessage(P.buffer)})};process.parentPort.on("message",b=>S(b.ports))});if(a.type===2)return new Promise((l,D)=>{let S=null;const b=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),f=108e5,g=3e5,P=new k.$7g(()=>h("renderer disconnected for too long (1)"),f),N=new k.$7g(()=>h("renderer disconnected for too long (2)"),g);process.on("message",(M,j)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const U=I.$be.wrap(Buffer.from(M.initialDataChunk,"base64"));let T;if(M.skipWebSocketFrames)T=new $.$Eh(j,"extHost-socket");else{const K=I.$be.wrap(Buffer.from(M.inflateBytes,"base64"));T=new $.$Fh(new $.$Eh(j,"extHost-socket"),M.permessageDeflate,K,!1)}S?(P.cancel(),N.cancel(),S.beginAcceptReconnection(T,U),S.endAcceptReconnection(),S.sendResume()):(clearTimeout(b),S=new A.$Dh({socket:T,initialChunk:U}),S.sendResume(),S.onDidDispose(()=>h("renderer disconnected")),l(S),S.onSocketClose(()=>{P.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;P.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const l=a.pipeName;return new Promise((D,S)=>{const b=C.createConnection(l,()=>{b.removeListener("error",S);const f=new A.$Dh({socket:new $.$Eh(b,"extHost-renderer")});f.sendResume(),D(f)});b.once("error",S),b.on("close",()=>{h("renderer closed the socket")})})}}async function n(){const a=await t();return new class{constructor(){this.a=new A.$Ch,this.onMessage=this.a.event,this.b=!1,a.onMessage(l=>{(0,v.$cm)(l,2)?(this.b=!0,h("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||a.send(l)}async drain(){if(a.drain)return a.drain()}}}function c(a){return new Promise(l=>{const D=a.onMessage(S=>{D.dispose();const b=JSON.parse(S.toString()),f=b.commit,g=E.default.commit;if(f&&g&&f!==g&&s(55),b.parentPid){let P=0;setInterval(function(){try{process.kill(b.parentPid,0),P=0}catch(O){O&&O.code==="EPERM"?(P++,P>=3&&h(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):h(`parent process ${b.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(b.parentPid)}catch(O){(0,L.$1)(O)}}a.send((0,v.$bm)(0)),l({protocol:a,initData:b})});a.send((0,v.$bm)(1))})}async function i(){const a=[];process.on("unhandledRejection",(P,N)=>{a.push(N),setTimeout(()=>{const O=a.indexOf(N);O>=0&&N.catch(M=>{a.splice(O,1),(0,L.$4)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),P&&(0,L.$1)(P))})},1e3)}),process.on("rejectionHandled",P=>{const N=a.indexOf(P);N>=0&&a.splice(N,1)}),process.on("uncaughtException",function(P){(0,L.$Z)(P)||(0,L.$1)(P)}),d.mark("code/extHost/willConnectToRenderer");const l=await n();d.mark("code/extHost/didConnectToRenderer");const D=await c(l);d.mark("code/extHost/didWaitForInitData");const{initData:S}=D;m(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=r.useHostProxy!==void 0?r.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,p.boolean)(r.skipWorkspaceStorageLock,!1);const b=new class{constructor(){this.pid=process.pid}exit(N){s(N)}fsExists(N){return w.Promises.exists(N)}fsRealpath(N){return(0,y.$8p)(N)}};let f=null;S.remote.authority&&r.transformURIs&&(f=(0,u.$Br)(S.remote.authority));const g=new R.$kec(D.protocol,S,b,f);h=P=>g.terminate(P)}i().catch(a=>console.log(a))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c36b92c82064882a228487040187cfc13669c0f/core/vs/workbench/api/node/extensionHostProcess.js.map
