/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/core/range","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(ye){for(var e=[],y=0,M=ye.length;y<M;y++)e[y]=Ae[ye[y]];return e};define(Ae[65],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function y(A){return(l,D,g)=>{let R=null,k=null;if(typeof g.value=="function"?(R="value",k=g.value):typeof g.get=="function"&&(R="get",k=g.get),!k)throw new Error("not supported");g[R]=A(k,D)}}function M(A,l,D){let g=null,R=null;if(typeof D.value=="function"?(g="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",R=D.get),!R)throw new Error("not supported");const k=`$memoize$${l}`;D[g]=function(...c){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,c)}),this[k]}}e.$hh=M;function C(A,l,D){return y((g,R)=>{const k=`$debounce$${R}`,c=`$debounce$result$${R}`;return function(...b){this[c]||(this[c]=D?D():void 0),clearTimeout(this[k]),l&&(this[c]=l(this[c],...b),b=[this[c]]),this[k]=setTimeout(()=>{g.apply(this,b),this[c]=D?D():void 0},A)}})}e.$ih=C;function T(A,l,D){return y((g,R)=>{const k=`$throttle$timer$${R}`,c=`$throttle$result$${R}`,b=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...f){if(this[c]||(this[c]=D?D():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),l&&(this[c]=l(this[c],...f)),this[p])return;const t=this[b]+A;t<=Date.now()?(this[b]=Date.now(),g.apply(this,[this[c]]),this[c]=D?D():void 0):(this[p]=!0,this[k]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),g.apply(this,[this[c]]),this[c]=D?D():void 0},t-Date.now()))}})}e.$jh=T}),define(Ae[88],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$mM=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$mM=y,e.$nM=new y("id#")}),define(Ae[115],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var M;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var T;(function(n){n.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(n,r=!1){let s=0;const o=n.length;let w="",d=0,I=16,S=0;function u(j){let O=0,N=0;for(;O<j;){const ie=n.charCodeAt(s);if(ie>=48&&ie<=57)N=N*16+ie-48;else if(ie>=65&&ie<=70)N=N*16+ie-65+10;else if(ie>=97&&ie<=102)N=N*16+ie-97+10;else break;s++,O++}return O<j&&(N=-1),N}function m(j){s=j,w="",d=0,I=16,S=0}function h(){const j=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&g(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&g(n.charCodeAt(s)))for(s++;s<n.length&&g(n.charCodeAt(s));)s++;else return S=3,n.substring(j,s);let O=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&g(n.charCodeAt(s))){for(s++;s<n.length&&g(n.charCodeAt(s));)s++;O=s}else S=3;return n.substring(j,O)}function P(){let j="",O=s;for(;;){if(s>=o){j+=n.substring(O,s),S=2;break}const N=n.charCodeAt(s);if(N===34){j+=n.substring(O,s),s++;break}if(N===92){if(j+=n.substring(O,s),s++,s>=o){S=2;break}switch(n.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const X=u(4);X>=0?j+=String.fromCharCode(X):S=4;break}default:S=5}O=s;continue}if(N>=0&&N<=31)if(D(N)){j+=n.substring(O,s),S=2;break}else S=6;s++}return j}function W(){if(w="",S=0,d=s,s>=o)return d=o,I=17;let j=n.charCodeAt(s);if(l(j)){do s++,w+=String.fromCharCode(j),j=n.charCodeAt(s);while(l(j));return I=15}if(D(j))return s++,w+=String.fromCharCode(j),j===13&&n.charCodeAt(s)===10&&(s++,w+=`
`),I=14;switch(j){case 123:return s++,I=1;case 125:return s++,I=2;case 91:return s++,I=3;case 93:return s++,I=4;case 58:return s++,I=6;case 44:return s++,I=5;case 34:return s++,w=P(),I=10;case 47:{const O=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<o&&!D(n.charCodeAt(s));)s++;return w=n.substring(O,s),I=12}if(n.charCodeAt(s+1)===42){s+=2;const N=o-1;let ie=!1;for(;s<N;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,ie=!0;break}s++}return ie||(s++,S=1),w=n.substring(O,s),I=13}return w+=String.fromCharCode(j),s++,I=16}case 45:if(w+=String.fromCharCode(j),s++,s===o||!g(n.charCodeAt(s)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=h(),I=11;default:for(;s<o&&K(j);)s++,j=n.charCodeAt(s);if(d!==s){switch(w=n.substring(d,s),w){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return w+=String.fromCharCode(j),s++,I=16}}function K(j){if(l(j)||D(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let j;do j=W();while(j>=12&&j<=15);return j}return{setPosition:m,getPosition:()=>s,scan:r?z:W,getToken:()=>I,getTokenValue:()=>w,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>S}}e.$Um=A;function l(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function D(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var R;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(R||(R={}));function k(n,r){const s=[],o=new Object;let w;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function S(u,m,h,P){d.value=u,d.offset=m,d.length=h,d.type=P,d.colonOffset=void 0,w=d}try{$(n,{onObjectBegin:(u,m)=>{if(r<=u)throw o;w=void 0,I=r>u,s.push("")},onObjectProperty:(u,m,h)=>{if(r<m||(S(u,m,h,"property"),s[s.length-1]=u,r<=m+h))throw o},onObjectEnd:(u,m)=>{if(r<=u)throw o;w=void 0,s.pop()},onArrayBegin:(u,m)=>{if(r<=u)throw o;w=void 0,s.push(0)},onArrayEnd:(u,m)=>{if(r<=u)throw o;w=void 0,s.pop()},onLiteralValue:(u,m,h)=>{if(r<m||(S(u,m,h,v(u)),r<=m+h))throw o},onSeparator:(u,m,h)=>{if(r<=m)throw o;if(u===":"&&w&&w.type==="property")w.colonOffset=m,I=!1,w=void 0;else if(u===","){const P=s[s.length-1];typeof P=="number"?s[s.length-1]=P+1:(I=!0,s[s.length-1]=""),w=void 0}}})}catch(u){if(u!==o)throw u}return{path:s,previousNode:w,isAtPropertyKey:I,matches:u=>{let m=0;for(let h=0;m<u.length&&h<s.length;h++)if(u[m]===s[h]||u[m]==="*")m++;else if(u[m]!=="**")return!1;return m===u.length}}}e.$Vm=k;function c(n,r=[],s=T.DEFAULT){let o=null,w=[];const d=[];function I(u){Array.isArray(w)?w.push(u):o!==null&&(w[o]=u)}return $(n,{onObjectBegin:()=>{const u={};I(u),d.push(w),w=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{w=d.pop()},onArrayBegin:()=>{const u=[];I(u),d.push(w),w=u,o=null},onArrayEnd:()=>{w=d.pop()},onLiteralValue:I,onError:(u,m,h)=>{r.push({error:u,offset:m,length:h})}},s),w[0]}e.$Wm=c;function b(n,r=[],s=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(u){o.type==="property"&&(o.length=u-o.offset,o=o.parent)}function d(u){return o.children.push(u),u}$(n,{onObjectBegin:u=>{o=d({type:"object",offset:u,length:-1,parent:o,children:[]})},onObjectProperty:(u,m,h)=>{o=d({type:"property",offset:m,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:u,offset:m,length:h,parent:o})},onObjectEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,w(u+m)},onArrayBegin:(u,m)=>{o=d({type:"array",offset:u,length:-1,parent:o,children:[]})},onArrayEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,w(u+m)},onLiteralValue:(u,m,h)=>{d({type:v(u),offset:m,length:h,parent:o,value:u}),w(m+h)},onSeparator:(u,m,h)=>{o.type==="property"&&(u===":"?o.colonOffset=m:u===","&&w(m))},onError:(u,m,h)=>{r.push({error:u,offset:m,length:h})}},s);const S=o.children[0];return S&&delete S.parent,S}e.$Xm=b;function p(n,r){if(!n)return;let s=n;for(const o of r)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let w=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===o){s=d.children[1],w=!0;break}if(!w)return}else{const w=o;if(s.type!=="array"||w<0||!Array.isArray(s.children)||w>=s.children.length)return;s=s.children[w]}return s}e.$Ym=p;function f(n){if(!n.parent||!n.parent.children)return[];const r=f(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;r.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&r.push(s)}return r}e.$Zm=f;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const r=Object.create(null);for(const s of n.children){const o=s.children[1];o&&(r[s.children[0].value]=t(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$1m=t;function i(n,r,s=!1){return r>=n.offset&&r<n.offset+n.length||s&&r===n.offset+n.length}e.$2m=i;function a(n,r,s=!1){if(i(n,r,s)){const o=n.children;if(Array.isArray(o))for(let w=0;w<o.length&&o[w].offset<=r;w++){const d=a(o[w],r,s);if(d)return d}return n}}e.$3m=a;function $(n,r,s=T.DEFAULT){const o=A(n,!1);function w(ue){return ue?()=>ue(o.getTokenOffset(),o.getTokenLength()):()=>!0}function d(ue){return ue?oe=>ue(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=w(r.onObjectBegin),S=d(r.onObjectProperty),u=w(r.onObjectEnd),m=w(r.onArrayBegin),h=w(r.onArrayEnd),P=d(r.onLiteralValue),W=d(r.onSeparator),K=w(r.onComment),z=d(r.onError),j=s&&s.disallowComments,O=s&&s.allowTrailingComma;function N(){for(;;){const ue=o.scan();switch(o.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:j||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(ue){case 12:case 13:j?ie(10):K();break;case 16:ie(1);break;case 15:case 14:break;default:return ue}}}function ie(ue,oe=[],be=[]){if(z(ue),oe.length+be.length>0){let _=o.getToken();for(;_!==17;){if(oe.indexOf(_)!==-1){N();break}else if(be.indexOf(_)!==-1)break;_=N()}}}function X(ue){const oe=o.getTokenValue();return ue?P(oe):S(oe),N(),!0}function Ee(){switch(o.getToken()){case 11:{let ue=0;try{ue=JSON.parse(o.getTokenValue()),typeof ue!="number"&&(ie(2),ue=0)}catch{ie(2)}P(ue);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return N(),!0}function Se(){return o.getToken()!==10?(ie(3,[],[2,5]),!1):(X(!1),o.getToken()===6?(W(":"),N(),pe()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function Pe(){I(),N();let ue=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ue||ie(4,[],[]),W(","),N(),o.getToken()===2&&O)break}else ue&&ie(6,[],[]);Se()||ie(4,[],[2,5]),ue=!0}return u(),o.getToken()!==2?ie(7,[2],[]):N(),!0}function $e(){m(),N();let ue=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ue||ie(4,[],[]),W(","),N(),o.getToken()===4&&O)break}else ue&&ie(6,[],[]);pe()||ie(4,[],[4,5]),ue=!0}return h(),o.getToken()!==4?ie(8,[4],[]):N(),!0}function pe(){switch(o.getToken()){case 3:return $e();case 1:return Pe();case 10:return X(!0);default:return Ee()}}return N(),o.getToken()===17?s.allowEmptyContent?!0:(ie(4,[],[]),!1):pe()?(o.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$4m=$;function E(n,r){const s=A(n),o=[];let w,d=0,I;do switch(I=s.getPosition(),w=s.scan(),w){case 12:case 13:case 17:d!==I&&o.push(n.substring(d,I)),r!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,r)),d=s.getPosition();break}while(w!==17);return o.join("")}e.$5m=E;function v(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=v}),function(ye,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ye=typeof globalThis<"u"?globalThis:ye||self,e(ye.marked={}))}(this,function(ye){"use strict";function e(ge,he){for(var De=0;De<he.length;De++){var re=he[De];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ge,re.key,re)}}function y(ge,he,De){return he&&e(ge.prototype,he),De&&e(ge,De),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function M(ge,he){if(ge){if(typeof ge=="string")return C(ge,he);var De=Object.prototype.toString.call(ge).slice(8,-1);if(De==="Object"&&ge.constructor&&(De=ge.constructor.name),De==="Map"||De==="Set")return Array.from(ge);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C(ge,he)}}function C(ge,he){(he==null||he>ge.length)&&(he=ge.length);for(var De=0,re=new Array(he);De<he;De++)re[De]=ge[De];return re}function T(ge,he){var De=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(De)return(De=De.call(ge)).next.bind(De);if(Array.isArray(ge)||(De=M(ge))||he&&ge&&typeof ge.length=="number"){De&&(ge=De);var re=0;return function(){return re>=ge.length?{done:!0}:{done:!1,value:ge[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ye.defaults=A();function l(ge){ye.defaults=ge}var D=/[&<>"']/,g=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(he){return c[he]};function p(ge,he){if(he){if(D.test(ge))return ge.replace(g,b)}else if(R.test(ge))return ge.replace(k,b);return ge}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ge){return ge.replace(f,function(he,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var i=/(^|[^\[])\^/g;function a(ge,he){ge=typeof ge=="string"?ge:ge.source,he=he||"";var De={replace:function(le,ne){return ne=ne.source||ne,ne=ne.replace(i,"$1"),ge=ge.replace(le,ne),De},getRegex:function(){return new RegExp(ge,he)}};return De}var $=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(ge,he,De){if(ge){var re;try{re=decodeURIComponent(t(De)).replace($,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}he&&!E.test(De)&&(De=w(he,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var n={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(ge,he){n[" "+ge]||(r.test(ge)?n[" "+ge]=ge+"/":n[" "+ge]=u(ge,"/",!0)),ge=n[" "+ge];var De=ge.indexOf(":")===-1;return he.substring(0,2)==="//"?De?he:ge.replace(s,"$1")+he:he.charAt(0)==="/"?De?he:ge.replace(o,"$1")+he:ge+he}var d={exec:function(){}};function I(ge){for(var he=1,De,re;he<arguments.length;he++){De=arguments[he];for(re in De)Object.prototype.hasOwnProperty.call(De,re)&&(ge[re]=De[re])}return ge}function S(ge,he){var De=ge.replace(/\|/g,function(ne,ae,fe){for(var Ie=!1,F=ae;--F>=0&&fe[F]==="\\";)Ie=!Ie;return Ie?"|":" |"}),re=De.split(/ \|/),le=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>he)re.splice(he);else for(;re.length<he;)re.push("");for(;le<re.length;le++)re[le]=re[le].trim().replace(/\\\|/g,"|");return re}function u(ge,he,De){var re=ge.length;if(re===0)return"";for(var le=0;le<re;){var ne=ge.charAt(re-le-1);if(ne===he&&!De)le++;else if(ne!==he&&De)le++;else break}return ge.slice(0,re-le)}function m(ge,he){if(ge.indexOf(he[1])===-1)return-1;for(var De=ge.length,re=0,le=0;le<De;le++)if(ge[le]==="\\")le++;else if(ge[le]===he[0])re++;else if(ge[le]===he[1]&&(re--,re<0))return le;return-1}function h(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ge,he){if(he<1)return"";for(var De="";he>1;)he&1&&(De+=ge),he>>=1,ge+=ge;return De+ge}function W(ge,he,De,re){var le=he.href,ne=he.title?p(he.title):null,ae=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){re.state.inLink=!0;var fe={type:"link",raw:De,href:le,title:ne,text:ae,tokens:re.inlineTokens(ae)};return re.state.inLink=!1,fe}return{type:"image",raw:De,href:le,title:ne,text:p(ae)}}function K(ge,he){var De=ge.match(/^(\s+)(?:```)/);if(De===null)return he;var re=De[1];return he.split(`
`).map(function(le){var ne=le.match(/^\s+/);if(ne===null)return le;var ae=ne[0];return ae.length>=re.length?le.slice(re.length):le}).join(`
`)}var z=function(){function ge(De){this.options=De||ye.defaults}var he=ge.prototype;return he.space=function(re){var le=this.rules.block.newline.exec(re);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},he.code=function(re){var le=this.rules.block.code.exec(re);if(le){var ne=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:u(ne,`
`)}}},he.fences=function(re){var le=this.rules.block.fences.exec(re);if(le){var ne=le[0],ae=K(ne,le[3]||"");return{type:"code",raw:ne,lang:le[2]?le[2].trim():le[2],text:ae}}},he.heading=function(re){var le=this.rules.block.heading.exec(re);if(le){var ne=le[2].trim();if(/#$/.test(ne)){var ae=u(ne,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(ne=ae.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:ne,tokens:this.lexer.inline(ne)}}},he.hr=function(re){var le=this.rules.block.hr.exec(re);if(le)return{type:"hr",raw:le[0]}},he.blockquote=function(re){var le=this.rules.block.blockquote.exec(re);if(le){var ne=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},he.list=function(re){var le=this.rules.block.list.exec(re);if(le){var ne,ae,fe,Ie,F,V,G,J,q,x,ce,Ne,Ue=le[1].trim(),Qe=Ue.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var xe=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Ne=!1,!(!(le=xe.exec(re))||this.rules.block.hr.test(re)));){if(ne=le[0],re=re.substring(ne.length),J=le[2].split(`
`,1)[0],q=re.split(`
`,1)[0],this.options.pedantic?(Ie=2,ce=J.trimLeft()):(Ie=le[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ce=J.slice(Ie),Ie+=le[1].length),V=!1,!J&&/^ *$/.test(q)&&(ne+=q+`
`,re=re.substring(q.length+1),Ne=!0),!Ne)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");re&&(x=re.split(`
`,1)[0],J=x,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(J)||tt.test(J)||Ye.test(J)||_e.test(re)));){if(J.search(/[^ ]/)>=Ie||!J.trim())ce+=`
`+J.slice(Ie);else if(!V)ce+=`
`+J;else break;!V&&!J.trim()&&(V=!0),ne+=x+`
`,re=re.substring(x.length+1)}Ge.loose||(G?Ge.loose=!0:/\n *\n *$/.test(ne)&&(G=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ce),ae&&(fe=ae[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ne,task:!!ae,checked:fe,loose:!1,text:ce}),Ge.raw+=ne}Ge.items[Ge.items.length-1].raw=ne.trimRight(),Ge.items[Ge.items.length-1].text=ce.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(F=0;F<ze;F++){this.lexer.state.top=!1,Ge.items[F].tokens=this.lexer.blockTokens(Ge.items[F].text,[]);var st=Ge.items[F].tokens.filter(function(Q){return Q.type==="space"}),Y=st.every(function(Q){for(var we=Q.raw.split(""),Be=0,Oe=T(we),Xe;!(Xe=Oe()).done;){var nt=Xe.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&st.length&&Y&&(Ge.loose=!0,Ge.items[F].loose=!0)}return Ge}},he.html=function(re){var le=this.rules.block.html.exec(re);if(le){var ne={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(le[0]):p(le[0]);ne.type="paragraph",ne.text=ae,ne.tokens=this.lexer.inline(ae)}return ne}},he.def=function(re){var le=this.rules.block.def.exec(re);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ne=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:le[0],href:le[2],title:le[3]}}},he.table=function(re){var le=this.rules.block.table.exec(re);if(le){var ne={type:"table",header:S(le[1]).map(function(G){return{text:G}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=le[0];var ae=ne.align.length,fe,Ie,F,V;for(fe=0;fe<ae;fe++)/^ *-+: *$/.test(ne.align[fe])?ne.align[fe]="right":/^ *:-+: *$/.test(ne.align[fe])?ne.align[fe]="center":/^ *:-+ *$/.test(ne.align[fe])?ne.align[fe]="left":ne.align[fe]=null;for(ae=ne.rows.length,fe=0;fe<ae;fe++)ne.rows[fe]=S(ne.rows[fe],ne.header.length).map(function(G){return{text:G}});for(ae=ne.header.length,Ie=0;Ie<ae;Ie++)ne.header[Ie].tokens=this.lexer.inline(ne.header[Ie].text);for(ae=ne.rows.length,Ie=0;Ie<ae;Ie++)for(V=ne.rows[Ie],F=0;F<V.length;F++)V[F].tokens=this.lexer.inline(V[F].text);return ne}}},he.lheading=function(re){var le=this.rules.block.lheading.exec(re);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},he.paragraph=function(re){var le=this.rules.block.paragraph.exec(re);if(le){var ne=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:ne,tokens:this.lexer.inline(ne)}}},he.text=function(re){var le=this.rules.block.text.exec(re);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},he.escape=function(re){var le=this.rules.inline.escape.exec(re);if(le)return{type:"escape",raw:le[0],text:p(le[1])}},he.tag=function(re){var le=this.rules.inline.tag.exec(re);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):p(le[0]):le[0]}},he.link=function(re){var le=this.rules.inline.link.exec(re);if(le){var ne=le[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ae=u(ne.slice(0,-1),"\\");if((ne.length-ae.length)%2===0)return}else{var fe=m(le[2],"()");if(fe>-1){var Ie=le[0].indexOf("!")===0?5:4,F=Ie+le[1].length+fe;le[2]=le[2].substring(0,fe),le[0]=le[0].substring(0,F).trim(),le[3]=""}}var V=le[2],G="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);J&&(V=J[1],G=J[3])}else G=le[3]?le[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(ne)?V=V.slice(1):V=V.slice(1,-1)),W(le,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},he.reflink=function(re,le){var ne;if((ne=this.rules.inline.reflink.exec(re))||(ne=this.rules.inline.nolink.exec(re))){var ae=(ne[2]||ne[1]).replace(/\s+/g," ");if(ae=le[ae.toLowerCase()],!ae||!ae.href){var fe=ne[0].charAt(0);return{type:"text",raw:fe,text:fe}}return W(ne,ae,ne[0],this.lexer)}},he.emStrong=function(re,le,ne){ne===void 0&&(ne="");var ae=this.rules.inline.emStrong.lDelim.exec(re);if(ae&&!(ae[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=ae[1]||ae[2]||"";if(!fe||fe&&(ne===""||this.rules.inline.punctuation.exec(ne))){var Ie=ae[0].length-1,F,V,G=Ie,J=0,q=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,le=le.slice(-1*re.length+Ie);(ae=q.exec(le))!=null;)if(F=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!F){if(V=F.length,ae[3]||ae[4]){G+=V;continue}else if((ae[5]||ae[6])&&Ie%3&&!((Ie+V)%3)){J+=V;continue}if(G-=V,!(G>0)){if(V=Math.min(V,V+G+J),Math.min(Ie,V)%2){var x=re.slice(1,Ie+ae.index+V);return{type:"em",raw:re.slice(0,Ie+ae.index+V+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ce=re.slice(2,Ie+ae.index+V-1);return{type:"strong",raw:re.slice(0,Ie+ae.index+V+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},he.codespan=function(re){var le=this.rules.inline.code.exec(re);if(le){var ne=le[2].replace(/\n/g," "),ae=/[^ ]/.test(ne),fe=/^ /.test(ne)&&/ $/.test(ne);return ae&&fe&&(ne=ne.substring(1,ne.length-1)),ne=p(ne,!0),{type:"codespan",raw:le[0],text:ne}}},he.br=function(re){var le=this.rules.inline.br.exec(re);if(le)return{type:"br",raw:le[0]}},he.del=function(re){var le=this.rules.inline.del.exec(re);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},he.autolink=function(re,le){var ne=this.rules.inline.autolink.exec(re);if(ne){var ae,fe;return ne[2]==="@"?(ae=p(this.options.mangle?le(ne[1]):ne[1]),fe="mailto:"+ae):(ae=p(ne[1]),fe=ae),{type:"link",raw:ne[0],text:ae,href:fe,tokens:[{type:"text",raw:ae,text:ae}]}}},he.url=function(re,le){var ne;if(ne=this.rules.inline.url.exec(re)){var ae,fe;if(ne[2]==="@")ae=p(this.options.mangle?le(ne[0]):ne[0]),fe="mailto:"+ae;else{var Ie;do Ie=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(Ie!==ne[0]);ae=p(ne[0]),ne[1]==="www."?fe="http://"+ae:fe=ae}return{type:"link",raw:ne[0],text:ae,href:fe,tokens:[{type:"text",raw:ae,text:ae}]}}},he.inlineText=function(re,le){var ne=this.rules.inline.text.exec(re);if(ne){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):p(ne[0]):ne[0]:ae=p(this.options.smartypants?le(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ae}}},ge}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=a(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=a(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=a(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=a(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=a(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=a(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=I({},j),j.gfm=I({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=a(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=a(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=I({},j.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:a(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=a(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=a(j._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=a(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=a(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=a(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=a(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=a(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=a(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=a(O.reflink).replace("label",O._label).replace("ref",j._label).getRegex(),O.nolink=a(O.nolink).replace("ref",j._label).getRegex(),O.reflinkSearch=a(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=I({},O),O.pedantic=I({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=I({},O.normal,{escape:a(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=a(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=I({},O.gfm,{br:a(O.br).replace("{2,}","*").getRegex(),text:a(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ie(ge){var he="",De,re,le=ge.length;for(De=0;De<le;De++)re=ge.charCodeAt(De),Math.random()>.5&&(re="x"+re.toString(16)),he+="&#"+re+";";return he}var X=function(){function ge(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ye.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:j.normal,inline:O.normal};this.options.pedantic?(re.block=j.pedantic,re.inline=O.pedantic):this.options.gfm&&(re.block=j.gfm,this.options.breaks?re.inline=O.breaks:re.inline=O.gfm),this.tokenizer.rules=re}ge.lex=function(re,le){var ne=new ge(le);return ne.lex(re)},ge.lexInline=function(re,le){var ne=new ge(le);return ne.inlineTokens(re)};var he=ge.prototype;return he.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},he.blockTokens=function(re,le){var ne=this;le===void 0&&(le=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(G,J,q){return J+"    ".repeat(q.length)});for(var ae,fe,Ie,F;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(ae=G.call({lexer:ne},re,le))?(re=re.substring(ae.raw.length),le.push(ae),!0):!1}))){if(ae=this.tokenizer.space(re)){re=re.substring(ae.raw.length),ae.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(ae);continue}if(ae=this.tokenizer.code(re)){re=re.substring(ae.raw.length),fe=le[le.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):le.push(ae);continue}if(ae=this.tokenizer.fences(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.heading(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.hr(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.blockquote(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.list(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.html(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.def(re)){re=re.substring(ae.raw.length),fe=le[le.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.lheading(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,J=re.slice(1),q=void 0;ne.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},J),typeof q=="number"&&q>=0&&(G=Math.min(G,q))}),G<1/0&&G>=0&&(Ie=re.substring(0,G+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ie))){fe=le[le.length-1],F&&fe.type==="paragraph"?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):le.push(ae),F=Ie.length!==re.length,re=re.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(re)){re=re.substring(ae.raw.length),fe=le[le.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):le.push(ae);continue}if(re){var V="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,le},he.inline=function(re,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:re,tokens:le}),le},he.inlineTokens=function(re,le){var ne=this;le===void 0&&(le=[]);var ae,fe,Ie,F=re,V,G,J;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(F))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(F=F.slice(0,V.index)+"["+P("a",V[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(F))!=null;)F=F.slice(0,V.index)+"["+P("a",V[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(F))!=null;)F=F.slice(0,V.index)+"++"+F.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(G||(J=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(ae=ce.call({lexer:ne},re,le))?(re=re.substring(ae.raw.length),le.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.tag(re)){re=re.substring(ae.raw.length),fe=le[le.length-1],fe&&ae.type==="text"&&fe.type==="text"?(fe.raw+=ae.raw,fe.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.link(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(ae.raw.length),fe=le[le.length-1],fe&&ae.type==="text"&&fe.type==="text"?(fe.raw+=ae.raw,fe.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.emStrong(re,F,J)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.codespan(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.br(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.del(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.autolink(re,ie)){re=re.substring(ae.raw.length),le.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(re,ie))){re=re.substring(ae.raw.length),le.push(ae);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Ne=re.slice(1),Ue=void 0;ne.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},Ne),typeof Ue=="number"&&Ue>=0&&(ce=Math.min(ce,Ue))}),ce<1/0&&ce>=0&&(Ie=re.substring(0,ce+1))}(),ae=this.tokenizer.inlineText(Ie,N)){re=re.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(J=ae.raw.slice(-1)),G=!0,fe=le[le.length-1],fe&&fe.type==="text"?(fe.raw+=ae.raw,fe.text+=ae.text):le.push(ae);continue}if(re){var x="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return le},y(ge,null,[{key:"rules",get:function(){return{block:j,inline:O}}}]),ge}(),Ee=function(){function ge(De){this.options=De||ye.defaults}var he=ge.prototype;return he.code=function(re,le,ne){var ae=(le||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(re,ae);fe!=null&&fe!==re&&(ne=!0,re=fe)}return re=re.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+p(ae,!0)+'">'+(ne?re:p(re,!0))+`</code></pre>
`:"<pre><code>"+(ne?re:p(re,!0))+`</code></pre>
`},he.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},he.html=function(re){return re},he.heading=function(re,le,ne,ae){if(this.options.headerIds){var fe=this.options.headerPrefix+ae.slug(ne);return"<h"+le+' id="'+fe+'">'+re+"</h"+le+`>
`}return"<h"+le+">"+re+"</h"+le+`>
`},he.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},he.list=function(re,le,ne){var ae=le?"ol":"ul",fe=le&&ne!==1?' start="'+ne+'"':"";return"<"+ae+fe+`>
`+re+"</"+ae+`>
`},he.listitem=function(re){return"<li>"+re+`</li>
`},he.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},he.paragraph=function(re){return"<p>"+re+`</p>
`},he.table=function(re,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+le+`</table>
`},he.tablerow=function(re){return`<tr>
`+re+`</tr>
`},he.tablecell=function(re,le){var ne=le.header?"th":"td",ae=le.align?"<"+ne+' align="'+le.align+'">':"<"+ne+">";return ae+re+("</"+ne+`>
`)},he.strong=function(re){return"<strong>"+re+"</strong>"},he.em=function(re){return"<em>"+re+"</em>"},he.codespan=function(re){return"<code>"+re+"</code>"},he.br=function(){return this.options.xhtml?"<br/>":"<br>"},he.del=function(re){return"<del>"+re+"</del>"},he.link=function(re,le,ne){if(re=v(this.options.sanitize,this.options.baseUrl,re),re===null)return ne;var ae='<a href="'+p(re)+'"';return le&&(ae+=' title="'+le+'"'),ae+=">"+ne+"</a>",ae},he.image=function(re,le,ne){if(re=v(this.options.sanitize,this.options.baseUrl,re),re===null)return ne;var ae='<img src="'+re+'" alt="'+ne+'"';return le&&(ae+=' title="'+le+'"'),ae+=this.options.xhtml?"/>":">",ae},he.text=function(re){return re},ge}(),Se=function(){function ge(){}var he=ge.prototype;return he.strong=function(re){return re},he.em=function(re){return re},he.codespan=function(re){return re},he.del=function(re){return re},he.html=function(re){return re},he.text=function(re){return re},he.link=function(re,le,ne){return""+ne},he.image=function(re,le,ne){return""+ne},he.br=function(){return""},ge}(),Pe=function(){function ge(){this.seen={}}var he=ge.prototype;return he.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},he.getNextSafeSlug=function(re,le){var ne=re,ae=0;if(this.seen.hasOwnProperty(ne)){ae=this.seen[re];do ae++,ne=re+"-"+ae;while(this.seen.hasOwnProperty(ne))}return le||(this.seen[re]=ae,this.seen[ne]=0),ne},he.slug=function(re,le){le===void 0&&(le={});var ne=this.serialize(re);return this.getNextSafeSlug(ne,le.dryrun)},ge}(),$e=function(){function ge(De){this.options=De||ye.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Se,this.slugger=new Pe}ge.parse=function(re,le){var ne=new ge(le);return ne.parse(re)},ge.parseInline=function(re,le){var ne=new ge(le);return ne.parseInline(re)};var he=ge.prototype;return he.parse=function(re,le){le===void 0&&(le=!0);var ne="",ae,fe,Ie,F,V,G,J,q,x,ce,Ne,Ue,Qe,Ge,xe,Ye,_e,it,tt,ze=re.length;for(ae=0;ae<ze;ae++){if(ce=re[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){ne+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(q="",J="",F=ce.header.length,fe=0;fe<F;fe++)J+=this.renderer.tablecell(this.parseInline(ce.header[fe].tokens),{header:!0,align:ce.align[fe]});for(q+=this.renderer.tablerow(J),x="",F=ce.rows.length,fe=0;fe<F;fe++){for(G=ce.rows[fe],J="",V=G.length,Ie=0;Ie<V;Ie++)J+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ce.align[Ie]});x+=this.renderer.tablerow(J)}ne+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(ce.tokens),ne+=this.renderer.blockquote(x);continue}case"list":{for(Ne=ce.ordered,Ue=ce.start,Qe=ce.loose,F=ce.items.length,x="",fe=0;fe<F;fe++)xe=ce.items[fe],Ye=xe.checked,_e=xe.task,Ge="",xe.task&&(it=this.renderer.checkbox(Ye),Qe?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=it+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=it+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(xe.tokens,Qe),x+=this.renderer.listitem(Ge,_e,Ye);ne+=this.renderer.list(x,Ne,Ue);continue}case"html":{ne+=this.renderer.html(ce.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(x=ce.tokens?this.parseInline(ce.tokens):ce.text;ae+1<ze&&re[ae+1].type==="text";)ce=re[++ae],x+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);ne+=le?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return ne},he.parseInline=function(re,le){le=le||this.renderer;var ne="",ae,fe,Ie,F=re.length;for(ae=0;ae<F;ae++){if(fe=re[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Ie=this.options.extensions.renderers[fe.type].call({parser:this},fe),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){ne+=Ie||"";continue}switch(fe.type){case"escape":{ne+=le.text(fe.text);break}case"html":{ne+=le.html(fe.text);break}case"link":{ne+=le.link(fe.href,fe.title,this.parseInline(fe.tokens,le));break}case"image":{ne+=le.image(fe.href,fe.title,fe.text);break}case"strong":{ne+=le.strong(this.parseInline(fe.tokens,le));break}case"em":{ne+=le.em(this.parseInline(fe.tokens,le));break}case"codespan":{ne+=le.codespan(fe.text);break}case"br":{ne+=le.br();break}case"del":{ne+=le.del(this.parseInline(fe.tokens,le));break}case"text":{ne+=le.text(fe.text);break}default:{var V='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return ne},ge}();function pe(ge,he,De){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof he=="function"&&(De=he,he=null),he=I({},pe.defaults,he||{}),h(he),De){var re=he.highlight,le;try{le=X.lex(ge,he)}catch(F){return De(F)}var ne=function(V){var G;if(!V)try{he.walkTokens&&pe.walkTokens(le,he.walkTokens),G=$e.parse(le,he)}catch(J){V=J}return he.highlight=re,V?De(V):De(null,G)};if(!re||re.length<3||(delete he.highlight,!le.length))return ne();var ae=0;pe.walkTokens(le,function(F){F.type==="code"&&(ae++,setTimeout(function(){re(F.text,F.lang,function(V,G){if(V)return ne(V);G!=null&&G!==F.text&&(F.text=G,F.escaped=!0),ae--,ae===0&&ne()})},0))}),ae===0&&ne();return}function fe(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,he.silent)return"<p>An error occurred:</p><pre>"+p(F.message+"",!0)+"</pre>";throw F}try{var Ie=X.lex(ge,he);if(he.walkTokens){if(he.async)return Promise.all(pe.walkTokens(Ie,he.walkTokens)).then(function(){return $e.parse(Ie,he)}).catch(fe);pe.walkTokens(Ie,he.walkTokens)}return $e.parse(Ie,he)}catch(F){fe(F)}}pe.options=pe.setOptions=function(ge){return I(pe.defaults,ge),l(pe.defaults),pe},pe.getDefaults=A,pe.defaults=ye.defaults,pe.use=function(){for(var ge=arguments.length,he=new Array(ge),De=0;De<ge;De++)he[De]=arguments[De];var re=I.apply(void 0,[{}].concat(he)),le=pe.defaults.extensions||{renderers:{},childTokens:{}},ne;he.forEach(function(ae){if(ae.extensions&&(ne=!0,ae.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var F=le.renderers?le.renderers[Ie.name]:null;F?le.renderers[Ie.name]=function(){for(var V=arguments.length,G=new Array(V),J=0;J<V;J++)G[J]=arguments[J];var q=Ie.renderer.apply(this,G);return q===!1&&(q=F.apply(this,G)),q}:le.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[Ie.level]?le[Ie.level].unshift(Ie.tokenizer):le[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?le.startBlock?le.startBlock.push(Ie.start):le.startBlock=[Ie.start]:Ie.level==="inline"&&(le.startInline?le.startInline.push(Ie.start):le.startInline=[Ie.start]))}Ie.childTokens&&(le.childTokens[Ie.name]=Ie.childTokens)})),ae.renderer&&function(){var Ie=pe.defaults.renderer||new Ee,F=function(J){var q=Ie[J];Ie[J]=function(){for(var x=arguments.length,ce=new Array(x),Ne=0;Ne<x;Ne++)ce[Ne]=arguments[Ne];var Ue=ae.renderer[J].apply(Ie,ce);return Ue===!1&&(Ue=q.apply(Ie,ce)),Ue}};for(var V in ae.renderer)F(V);re.renderer=Ie}(),ae.tokenizer&&function(){var Ie=pe.defaults.tokenizer||new z,F=function(J){var q=Ie[J];Ie[J]=function(){for(var x=arguments.length,ce=new Array(x),Ne=0;Ne<x;Ne++)ce[Ne]=arguments[Ne];var Ue=ae.tokenizer[J].apply(Ie,ce);return Ue===!1&&(Ue=q.apply(Ie,ce)),Ue}};for(var V in ae.tokenizer)F(V);re.tokenizer=Ie}(),ae.walkTokens){var fe=pe.defaults.walkTokens;re.walkTokens=function(Ie){var F=[];return F.push(ae.walkTokens.call(this,Ie)),fe&&(F=F.concat(fe.call(this,Ie))),F}}ne&&(re.extensions=le),pe.setOptions(re)})},pe.walkTokens=function(ge,he){for(var De=[],re=function(){var fe=ne.value;switch(De=De.concat(he.call(pe,fe)),fe.type){case"table":{for(var Ie=T(fe.header),F;!(F=Ie()).done;){var V=F.value;De=De.concat(pe.walkTokens(V.tokens,he))}for(var G=T(fe.rows),J;!(J=G()).done;)for(var q=J.value,x=T(q),ce;!(ce=x()).done;){var Ne=ce.value;De=De.concat(pe.walkTokens(Ne.tokens,he))}break}case"list":{De=De.concat(pe.walkTokens(fe.items,he));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[fe.type]?pe.defaults.extensions.childTokens[fe.type].forEach(function(Ue){De=De.concat(pe.walkTokens(fe[Ue],he))}):fe.tokens&&(De=De.concat(pe.walkTokens(fe.tokens,he)))}},le=T(ge),ne;!(ne=le()).done;)re();return De},pe.parseInline=function(ge,he){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");he=I({},pe.defaults,he||{}),h(he);try{var De=X.lexInline(ge,he);return he.walkTokens&&pe.walkTokens(De,he.walkTokens),$e.parseInline(De,he)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,he.silent)return"<p>An error occurred:</p><pre>"+p(re.message+"",!0)+"</pre>";throw re}},pe.Parser=$e,pe.parser=$e.parse,pe.Renderer=Ee,pe.TextRenderer=Se,pe.Lexer=X,pe.lexer=X.lex,pe.Tokenizer=z,pe.Slugger=Pe,pe.parse=pe;var ue=pe.options,oe=pe.setOptions,be=pe.use,_=pe.walkTokens,B=pe.parseInline,Z=pe,ee=$e.parse,ve=X.lex;ye.Lexer=X,ye.Parser=$e,ye.Renderer=Ee,ye.Slugger=Pe,ye.TextRenderer=Se,ye.Tokenizer=z,ye.getDefaults=A,ye.lexer=ve,ye.marked=pe,ye.options=ue,ye.parse=Z,ye.parseInline=B,ye.parser=ee,ye.setOptions=oe,ye.use=be,ye.walkTokens=_,Object.defineProperty(ye,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function y(l,D,g){return Math.min(Math.max(l,D),g)}e.$Ol=y;function M(l,D){return(D+l%D)%D}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=C;class T{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=T;class A{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const g=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=A}),function(){function ye(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function A(D){T.push(D,Date.now())}function l(){const D=[];for(let g=0;g<T.length;g+=2)D.push({name:T[g],startTime:T[g+1]});return D}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ye():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(C+A.startTime)});return T}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ye(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ye()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=y(M))}(),function(ye,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var M in y)(typeof exports=="object"?exports:ye)[M]=y[M]}}(typeof self<"u"?self:this,function(){return function(ye){var e={};function y(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return ye[M].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=ye,y.c=e,y.d=function(M,C,T){y.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:T})},y.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},y.t=function(M,C){if(1&C&&(M=y(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var T=Object.create(null);if(y.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var A in M)y.d(T,A,function(l){return M[l]}.bind(null,A));return T},y.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return y.d(C,"a",C),C},y.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},y.p="",y(y.s=0)}([function(ye,e,y){(function(M){var C;e=ye.exports=be,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],D=e.src=[],g=0,R=g++;D[R]="0|[1-9]\\d*";var k=g++;D[k]="[0-9]+";var c=g++;D[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=g++;D[b]="("+D[R]+")\\.("+D[R]+")\\.("+D[R]+")";var p=g++;D[p]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var f=g++;D[f]="(?:"+D[R]+"|"+D[c]+")";var t=g++;D[t]="(?:"+D[k]+"|"+D[c]+")";var i=g++;D[i]="(?:-("+D[f]+"(?:\\."+D[f]+")*))";var a=g++;D[a]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var $=g++;D[$]="[0-9A-Za-z-]+";var E=g++;D[E]="(?:\\+("+D[$]+"(?:\\."+D[$]+")*))";var v=g++,n="v?"+D[b]+D[i]+"?"+D[E]+"?";D[v]="^"+n+"$";var r="[v=\\s]*"+D[p]+D[a]+"?"+D[E]+"?",s=g++;D[s]="^"+r+"$";var o=g++;D[o]="((?:<|>)?=?)";var w=g++;D[w]=D[k]+"|x|X|\\*";var d=g++;D[d]=D[R]+"|x|X|\\*";var I=g++;D[I]="[v=\\s]*("+D[d]+")(?:\\.("+D[d]+")(?:\\.("+D[d]+")(?:"+D[i]+")?"+D[E]+"?)?)?";var S=g++;D[S]="[v=\\s]*("+D[w]+")(?:\\.("+D[w]+")(?:\\.("+D[w]+")(?:"+D[a]+")?"+D[E]+"?)?)?";var u=g++;D[u]="^"+D[o]+"\\s*"+D[I]+"$";var m=g++;D[m]="^"+D[o]+"\\s*"+D[S]+"$";var h=g++;D[h]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=g++;D[P]="(?:~>?)";var W=g++;D[W]="(\\s*)"+D[P]+"\\s+",l[W]=new RegExp(D[W],"g");var K=g++;D[K]="^"+D[P]+D[I]+"$";var z=g++;D[z]="^"+D[P]+D[S]+"$";var j=g++;D[j]="(?:\\^)";var O=g++;D[O]="(\\s*)"+D[j]+"\\s+",l[O]=new RegExp(D[O],"g");var N=g++;D[N]="^"+D[j]+D[I]+"$";var ie=g++;D[ie]="^"+D[j]+D[S]+"$";var X=g++;D[X]="^"+D[o]+"\\s*("+r+")$|^$";var Ee=g++;D[Ee]="^"+D[o]+"\\s*("+n+")$|^$";var Se=g++;D[Se]="(\\s*)"+D[o]+"\\s*("+r+"|"+D[I]+")",l[Se]=new RegExp(D[Se],"g");var Pe=g++;D[Pe]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var $e=g++;D[$e]="^\\s*("+D[S]+")\\s+-\\s+("+D[S]+")\\s*$";var pe=g++;D[pe]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)C(ue,D[ue]),l[ue]||(l[ue]=new RegExp(D[ue]));function oe(q,x){if(q instanceof be)return q;if(typeof q!="string"||q.length>T||!(x?l[s]:l[v]).test(q))return null;try{return new be(q,x)}catch{return null}}function be(q,x){if(q instanceof be){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof be))return new be(q,x);C("SemVer",q,x),this.loose=x;var ce=q.trim().match(x?l[s]:l[v]);if(!ce)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Ue=+Ne;if(Ue>=0&&Ue<A)return Ue}return Ne}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=oe,e.valid=function(q,x){var ce=oe(q,x);return ce?ce.version:null},e.clean=function(q,x){var ce=oe(q.trim().replace(/^[=v]+/,""),x);return ce?ce.version:null},e.SemVer=be,be.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},be.prototype.toString=function(){return this.version},be.prototype.compare=function(q){return C("SemVer.compare",this.version,this.loose,q),q instanceof be||(q=new be(q,this.loose)),this.compareMain(q)||this.comparePre(q)},be.prototype.compareMain=function(q){return q instanceof be||(q=new be(q,this.loose)),B(this.major,q.major)||B(this.minor,q.minor)||B(this.patch,q.patch)},be.prototype.comparePre=function(q){if(q instanceof be||(q=new be(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var ce=this.prerelease[x],Ne=q.prerelease[x];if(C("prerelease compare",x,ce,Ne),ce===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ce===void 0)return-1;if(ce!==Ne)return B(ce,Ne)}while(++x)},be.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,ce,Ne){typeof ce=="string"&&(Ne=ce,ce=void 0);try{return new be(q,ce).inc(x,Ne).version}catch{return null}},e.diff=function(q,x){if(ge(q,x))return null;var ce=oe(q),Ne=oe(x);if(ce.prerelease.length||Ne.prerelease.length){for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==Ne[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==Ne[Ue])return Ue},e.compareIdentifiers=B;var _=/^[0-9]+$/;function B(q,x){var ce=_.test(q),Ne=_.test(x);return ce&&Ne&&(q=+q,x=+x),ce&&!Ne?-1:Ne&&!ce?1:q<x?-1:q>x?1:0}function Z(q,x,ce){return new be(q,ce).compare(new be(x,ce))}function ee(q,x,ce){return Z(q,x,ce)>0}function ve(q,x,ce){return Z(q,x,ce)<0}function ge(q,x,ce){return Z(q,x,ce)===0}function he(q,x,ce){return Z(q,x,ce)!==0}function De(q,x,ce){return Z(q,x,ce)>=0}function re(q,x,ce){return Z(q,x,ce)<=0}function le(q,x,ce,Ne){var Ue;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof ce=="object"&&(ce=ce.version),Ue=q===ce;break;case"!==":typeof q=="object"&&(q=q.version),typeof ce=="object"&&(ce=ce.version),Ue=q!==ce;break;case"":case"=":case"==":Ue=ge(q,ce,Ne);break;case"!=":Ue=he(q,ce,Ne);break;case">":Ue=ee(q,ce,Ne);break;case">=":Ue=De(q,ce,Ne);break;case"<":Ue=ve(q,ce,Ne);break;case"<=":Ue=re(q,ce,Ne);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function ne(q,x){if(q instanceof ne){if(q.loose===x)return q;q=q.value}if(!(this instanceof ne))return new ne(q,x);C("comparator",q,x),this.loose=x,this.parse(q),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(q,x){return B(x,q)},e.major=function(q,x){return new be(q,x).major},e.minor=function(q,x){return new be(q,x).minor},e.patch=function(q,x){return new be(q,x).patch},e.compare=Z,e.compareLoose=function(q,x){return Z(q,x,!0)},e.rcompare=function(q,x,ce){return Z(x,q,ce)},e.sort=function(q,x){return q.sort(function(ce,Ne){return e.compare(ce,Ne,x)})},e.rsort=function(q,x){return q.sort(function(ce,Ne){return e.rcompare(ce,Ne,x)})},e.gt=ee,e.lt=ve,e.eq=ge,e.neq=he,e.gte=De,e.lte=re,e.cmp=le,e.Comparator=ne;var ae={};function fe(q,x){if(q instanceof fe)return q.loose===x?q:new fe(q.raw,x);if(q instanceof ne)return new fe(q.value,x);if(!(this instanceof fe))return new fe(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function F(q,x,ce,Ne,Ue,Qe,Ge,xe,Ye,_e,it,tt,ze){return((x=Ie(ce)?"":Ie(Ne)?">="+ce+".0.0":Ie(Ue)?">="+ce+"."+Ne+".0":">="+x)+" "+(xe=Ie(Ye)?"":Ie(_e)?"<"+(+Ye+1)+".0.0":Ie(it)?"<"+Ye+"."+(+_e+1)+".0":tt?"<="+Ye+"."+_e+"."+it+"-"+tt:"<="+xe)).trim()}function V(q,x){for(var ce=0;ce<q.length;ce++)if(!q[ce].test(x))return!1;if(x.prerelease.length){for(ce=0;ce<q.length;ce++)if(C(q[ce].semver),q[ce].semver!==ae&&q[ce].semver.prerelease.length>0){var Ne=q[ce].semver;if(Ne.major===x.major&&Ne.minor===x.minor&&Ne.patch===x.patch)return!0}return!1}return!0}function G(q,x,ce){try{x=new fe(x,ce)}catch{return!1}return x.test(q)}function J(q,x,ce,Ne){var Ue,Qe,Ge,xe,Ye;switch(q=new be(q,Ne),x=new fe(x,Ne),ce){case">":Ue=ee,Qe=re,Ge=ve,xe=">",Ye=">=";break;case"<":Ue=ve,Qe=De,Ge=ee,xe="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(q,x,Ne))return!1;for(var _e=0;_e<x.set.length;++_e){var it=x.set[_e],tt=null,ze=null;if(it.forEach(function(st){st.semver===ae&&(st=new ne(">=0.0.0")),tt=tt||st,ze=ze||st,Ue(st.semver,tt.semver,Ne)?tt=st:Ge(st.semver,ze.semver,Ne)&&(ze=st)}),tt.operator===xe||tt.operator===Ye||(!ze.operator||ze.operator===xe)&&Qe(q,ze.semver)||ze.operator===Ye&&Ge(q,ze.semver))return!1}return!0}ne.prototype.parse=function(q){var x=this.loose?l[X]:l[Ee],ce=q.match(x);if(!ce)throw new TypeError("Invalid comparator: "+q);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new be(ce[2],this.loose):this.semver=ae},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(q){return C("Comparator.test",q,this.loose),this.semver===ae||(typeof q=="string"&&(q=new be(q,this.loose)),le(q,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(q,x){if(!(q instanceof ne))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new fe(q.value,x),G(this.value,ce,x);if(q.operator==="")return ce=new fe(this.value,x),G(q.semver,ce,x);var Ne=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Qe=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),xe=le(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ye=le(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Ne||Ue||Qe&&Ge||xe||Ye},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),C("range",q,x);var ce=x?l[$e]:l[Pe];q=q.replace(ce,F),C("hyphen replace",q),q=q.replace(l[Se],"$1$2$3"),C("comparator trim",q,l[Se]),q=(q=(q=q.replace(l[W],"$1~")).replace(l[O],"$1^")).split(/\s+/).join(" ");var Ne=x?l[X]:l[Ee],Ue=q.split(" ").map(function(Qe){return function(Ge,xe){return C("comp",Ge),Ge=function(Ye,_e){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?l[ie]:l[N];return tt.replace(st,function(Y,Q,we,Be,Oe){var Xe;return C("caret",tt,Y,Q,we,Be,Oe),Ie(Q)?Xe="":Ie(we)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Be)?Xe=Q==="0"?">="+Q+"."+we+".0 <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+".0 <"+(+Q+1)+".0.0":Oe?(C("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=Q==="0"?we==="0"?">="+Q+"."+we+"."+Be+Oe+" <"+Q+"."+we+"."+(+Be+1):">="+Q+"."+we+"."+Be+Oe+" <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+"."+Be+Oe+" <"+(+Q+1)+".0.0"):(C("no pr"),Xe=Q==="0"?we==="0"?">="+Q+"."+we+"."+Be+" <"+Q+"."+we+"."+(+Be+1):">="+Q+"."+we+"."+Be+" <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+"."+Be+" <"+(+Q+1)+".0.0"),C("caret return",Xe),Xe})}(it,_e)}).join(" ")}(Ge,xe),C("caret",Ge),Ge=function(Ye,_e){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?l[z]:l[K];return tt.replace(st,function(Y,Q,we,Be,Oe){var Xe;return C("tilde",tt,Y,Q,we,Be,Oe),Ie(Q)?Xe="":Ie(we)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Be)?Xe=">="+Q+"."+we+".0 <"+Q+"."+(+we+1)+".0":Oe?(C("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=">="+Q+"."+we+"."+Be+Oe+" <"+Q+"."+(+we+1)+".0"):Xe=">="+Q+"."+we+"."+Be+" <"+Q+"."+(+we+1)+".0",C("tilde return",Xe),Xe})}(it,_e)}).join(" ")}(Ge,xe),C("tildes",Ge),Ge=function(Ye,_e){return C("replaceXRanges",Ye,_e),Ye.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?l[m]:l[u];return tt.replace(st,function(Y,Q,we,Be,Oe,Xe){C("xRange",tt,Y,Q,we,Be,Oe,Xe);var nt=Ie(we),ft=nt||Ie(Be),wt=ft||Ie(Oe);return Q==="="&&wt&&(Q=""),nt?Y=Q===">"||Q==="<"?"<0.0.0":"*":Q&&wt?(ft&&(Be=0),wt&&(Oe=0),Q===">"?(Q=">=",ft?(we=+we+1,Be=0,Oe=0):wt&&(Be=+Be+1,Oe=0)):Q==="<="&&(Q="<",ft?we=+we+1:Be=+Be+1),Y=Q+we+"."+Be+"."+Oe):ft?Y=">="+we+".0.0 <"+(+we+1)+".0.0":wt&&(Y=">="+we+"."+Be+".0 <"+we+"."+(+Be+1)+".0"),C("xRange return",Y),Y})}(it,_e)}).join(" ")}(Ge,xe),C("xrange",Ge),Ge=function(Ye,_e){return C("replaceStars",Ye,_e),Ye.trim().replace(l[pe],"")}(Ge,xe),C("stars",Ge),Ge}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(Ne)})),Ue=Ue.map(function(Qe){return new ne(Qe,x)})},fe.prototype.intersects=function(q,x){if(!(q instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Ne){return q.set.some(function(Ue){return Ue.every(function(Qe){return Ne.intersects(Qe,x)})})})})},e.toComparators=function(q,x){return new fe(q,x).set.map(function(ce){return ce.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new be(q,this.loose));for(var x=0;x<this.set.length;x++)if(V(this.set[x],q))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(q,x,ce){var Ne=null,Ue=null;try{var Qe=new fe(x,ce)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Ne&&Ue.compare(Ge)!==-1||(Ue=new be(Ne=Ge,ce)))}),Ne},e.minSatisfying=function(q,x,ce){var Ne=null,Ue=null;try{var Qe=new fe(x,ce)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Ne&&Ue.compare(Ge)!==1||(Ue=new be(Ne=Ge,ce)))}),Ne},e.validRange=function(q,x){try{return new fe(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,ce){return J(q,x,"<",ce)},e.gtr=function(q,x,ce){return J(q,x,">",ce)},e.outside=J,e.prerelease=function(q,x){var ce=oe(q,x);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(q,x,ce){return q=new fe(q,ce),x=new fe(x,ce),q.intersects(x)},e.coerce=function(q){if(q instanceof be)return q;if(typeof q!="string")return null;var x=q.match(l[h]);return x==null?null:oe((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,y(1))},function(ye,e){var y,M,C=ye.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(t){if(y===setTimeout)return setTimeout(t,0);if((y===T||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:T}catch{y=T}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var D,g=[],R=!1,k=-1;function c(){R&&D&&(R=!1,D.length?g=D.concat(g):k=-1,g.length&&b())}function b(){if(!R){var t=l(c);R=!0;for(var i=g.length;i;){for(D=g,g=[];++k<i;)D&&D[k].run();k=-1,i=g.length}D=null,R=!1,function(a){if(M===clearTimeout)return clearTimeout(a);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(a);try{M(a)}catch{try{return M.call(null,a)}catch{return M.call(this,a)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function f(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)i[a-1]=arguments[a];g.push(new p(t,i)),g.length!==1||R||l(b)},p.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=f,C.addListener=f,C.once=f,C.off=f,C.removeListener=f,C.removeAllListeners=f,C.emit=f,C.prependListener=f,C.prependOnceListener=f,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,9,6]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function C(E){const v=E;return v?typeof v.read=="function":!1}e.$Yd=C;function T(E){const v=E;return v?[v.on,v.pause,v.resume,v.destroy].every(n=>typeof n=="function"):!1}e.$Zd=T;function A(E){const v=E;return v?T(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$1d=A;function l(E,v){return new D(E,v)}e.$2d=l;class D{constructor(v,n){this.e=v,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(n=>n(v))}h(v){this.c.error.length===0?(0,y.$1)(v):this.c.error.slice(0).forEach(n=>n(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,n){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(v,n){if(this.a.destroyed)return;let r;switch(v){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(n);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(E,v){const n=[];let r;for(;(r=E.read())!==null;)n.push(r);return v(n)}e.$3d=g;function R(E,v,n){const r=[];let s;for(;(s=E.read())!==null&&r.length<n;)r.push(s);return s===null&&r.length>0?v(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return E.read()}}}e.$4d=R;function k(E,v){return new Promise((n,r)=>{const s=[];c(E,{onData:o=>{v&&s.push(o)},onError:o=>{v?r(o):n(void 0)},onEnd:()=>{n(v?v(s):void 0)}})})}e.$5d=k;function c(E,v,n){E.on("error",r=>{n?.isCancellationRequested||v.onError(r)}),E.on("end",()=>{n?.isCancellationRequested||v.onEnd()}),E.on("data",r=>{n?.isCancellationRequested||v.onData(r)})}e.$6d=c;function b(E,v){return new Promise((n,r)=>{const s=new M.$Rc,o=[],w=S=>{if(o.push(S),o.length>v)return s.dispose(),E.pause(),n({stream:E,buffer:o,ended:!1})},d=S=>(s.dispose(),r(S)),I=()=>(s.dispose(),n({stream:E,buffer:o,ended:!0}));s.add((0,M.$Qc)(()=>E.removeListener("error",d))),E.on("error",d),s.add((0,M.$Qc)(()=>E.removeListener("end",I))),E.on("end",I),s.add((0,M.$Qc)(()=>E.removeListener("data",w))),E.on("data",w)})}e.$7d=b;function p(E,v){const n=l(v);return n.end(E),n}e.$8d=p;function f(){const E=l(()=>{throw new Error("not supported")});return E.end(),E}e.$9d=f;function t(E){let v=!1;return{read:()=>v?null:(v=!0,E)}}e.$0d=t;function i(E,v,n){const r=l(n);return c(E,{onData:s=>r.write(v.data(s)),onError:s=>r.error(v.error?v.error(s):s),onEnd:()=>r.end()}),r}e.$$d=i;function a(E,v,n){let r=!1;return{read:()=>{const s=v.read();return r?s:(r=!0,s!==null?n([E,s]):E)}}}e.$_d=a;function $(E,v,n){let r=!1;const s=l(n);return c(v,{onData:o=>r?s.write(o):(r=!0,s.write(n([E,o]))),onError:o=>s.error(o),onEnd:()=>{r||(r=!0,s.write(E)),s.end()}}),s}e.$ae=$}),define(Ae[26],Re([1,0,42,118]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const C=typeof Buffer<"u",T=new y.$V(()=>new Uint8Array(256));let A,l;class D{static alloc(h){return C?new D(Buffer.allocUnsafe(h)):new D(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new D(h)}static fromString(h,P){return!(P?.dontUseNodeBuffer||!1)&&C?new D(Buffer.from(h)):(A||(A=new TextEncoder),new D(A.encode(h)))}static fromByteArray(h){const P=D.alloc(h.length);for(let W=0,K=h.length;W<K;W++)P.buffer[W]=h[W];return P}static concat(h,P){if(typeof P>"u"){P=0;for(let z=0,j=h.length;z<j;z++)P+=h[z].byteLength}const W=D.alloc(P);let K=0;for(let z=0,j=h.length;z<j;z++){const O=h[z];W.set(O,K),K+=O.byteLength}return W}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=D.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(h,P){return new D(this.buffer.subarray(h,P))}set(h,P){if(h instanceof D)this.buffer.set(h.buffer,P);else if(h instanceof Uint8Array)this.buffer.set(h,P);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),P);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return c(this.buffer,h)}writeUInt32BE(h,P){b(this.buffer,h,P)}readUInt32LE(h){return p(this.buffer,h)}writeUInt32LE(h,P){f(this.buffer,h,P)}readUInt8(h){return t(this.buffer,h)}writeUInt8(h,P){i(this.buffer,h,P)}indexOf(h,P=0){return g(this.buffer,h instanceof D?h.buffer:h,P)}}e.$be=D;function g(m,h,P=0){const W=h.byteLength,K=m.byteLength;if(W===0)return 0;if(W===1)return m.indexOf(h[0]);if(W>K-P)return-1;const z=T.value;z.fill(h.length);for(let ie=0;ie<h.length;ie++)z[h[ie]]=h.length-ie-1;let j=P+h.length-1,O=j,N=-1;for(;j<K;)if(m[j]===h[O]){if(O===0){N=j;break}j--,O--}else j+=Math.max(h.length-O,z[m[j]]),O=h.length-1;return N}e.$ce=g;function R(m,h){return m[h+0]<<0>>>0|m[h+1]<<8>>>0}e.$de=R;function k(m,h,P){m[P+0]=h&255,h=h>>>8,m[P+1]=h&255}e.$ee=k;function c(m,h){return m[h]*2**24+m[h+1]*2**16+m[h+2]*2**8+m[h+3]}e.$fe=c;function b(m,h,P){m[P+3]=h,h=h>>>8,m[P+2]=h,h=h>>>8,m[P+1]=h,h=h>>>8,m[P]=h}e.$ge=b;function p(m,h){return m[h+0]<<0>>>0|m[h+1]<<8>>>0|m[h+2]<<16>>>0|m[h+3]<<24>>>0}e.$he=p;function f(m,h,P){m[P+0]=h&255,h=h>>>8,m[P+1]=h&255,h=h>>>8,m[P+2]=h&255,h=h>>>8,m[P+3]=h&255}e.$ie=f;function t(m,h){return m[h]}e.$je=t;function i(m,h,P){m[P]=h}e.$ke=i;function a(m){return M.$3d(m,h=>D.concat(h))}e.$le=a;function $(m){return M.$0d(m)}e.$me=$;function E(m){return M.$5d(m,h=>D.concat(h))}e.$ne=E;async function v(m){return m.ended?D.concat(m.buffer):D.concat([...m.buffer,await E(m.stream)])}e.$oe=v;function n(m){return M.$8d(m,h=>D.concat(h))}e.$pe=n;function r(m){return M.$$d(m,{data:h=>typeof h=="string"?D.fromString(h):D.wrap(h)},h=>D.concat(h))}e.$qe=r;function s(m){return M.$2d(h=>D.concat(h),m)}e.$re=s;function o(m,h){return M.$_d(m,h,P=>D.concat(P))}e.$se=o;function w(m,h){return M.$ae(m,h,P=>D.concat(P))}e.$te=w;function d(m){let h=0,P=0,W=0;const K=new Uint8Array(Math.floor(m.length/4*3)),z=O=>{switch(P){case 3:K[W++]=h|O,P=0;break;case 2:K[W++]=h|O>>>2,h=O<<6,P=3;break;case 1:K[W++]=h|O>>>4,h=O<<4,P=2;break;default:h=O<<2,P=1}};for(let O=0;O<m.length;O++){const N=m.charCodeAt(O);if(N>=65&&N<=90)z(N-65);else if(N>=97&&N<=122)z(N-97+26);else if(N>=48&&N<=57)z(N-48+52);else if(N===43||N===45)z(62);else if(N===47||N===95)z(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${m[O]}`)}}const j=W;for(;P>0;)z(0);return D.wrap(K).slice(0,j)}e.$ue=d;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:m},h=!0,P=!1){const W=P?S:I;let K="";const z=m.byteLength%3;let j=0;for(;j<m.byteLength-z;j+=3){const O=m[j+0],N=m[j+1],ie=m[j+2];K+=W[O>>>2],K+=W[(O<<4|N>>>4)&63],K+=W[(N<<2|ie>>>6)&63],K+=W[ie&63]}if(z===1){const O=m[j+0];K+=W[O>>>2],K+=W[O<<4&63],h&&(K+="==")}else if(z===2){const O=m[j+0],N=m[j+1];K+=W[O>>>2],K+=W[(O<<4|N>>>4)&63],K+=W[N<<2&63],h&&(K+="=")}return K}e.$ve=u}),define(Ae[119],Re([1,0,28,16]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.FuzzyScore=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.or=void 0;function C(...ne){return function(ae,fe){for(let Ie=0,F=ne.length;Ie<F;Ie++){const V=ne[Ie](ae,fe);if(V)return V}return null}}e.or=C,e.$Cj=T.bind(void 0,!1),e.$Dj=T.bind(void 0,!0);function T(ne,ae,fe){if(!fe||fe.length<ae.length)return null;let Ie;return ne?Ie=M.$3e(fe,ae):Ie=fe.indexOf(ae)===0,Ie?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(ne,ae){const fe=ae.toLowerCase().indexOf(ne.toLowerCase());return fe===-1?null:[{start:fe,end:fe+ne.length}]}e.$Ej=A;function l(ne,ae){return D(ne.toLowerCase(),ae.toLowerCase(),0,0)}e.$Fj=l;function D(ne,ae,fe,Ie){if(fe===ne.length)return[];if(Ie===ae.length)return null;if(ne[fe]===ae[Ie]){let F=null;return(F=D(ne,ae,fe+1,Ie+1))?i({start:Ie,end:Ie+1},F):null}return D(ne,ae,fe,Ie+1)}function g(ne){return 97<=ne&&ne<=122}function R(ne){return 65<=ne&&ne<=90}e.$Gj=R;function k(ne){return 48<=ne&&ne<=57}function c(ne){return ne===32||ne===9||ne===10||ne===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>b.add(ne.charCodeAt(0)));function p(ne){return c(ne)||b.has(ne)}function f(ne,ae){return ne===ae||p(ne)&&p(ae)}function t(ne){return g(ne)||R(ne)||k(ne)}function i(ne,ae){return ae.length===0?ae=[ne]:ne.end===ae[0].start?ae[0].start=ne.start:ae.unshift(ne),ae}function a(ne,ae){for(let fe=ae;fe<ne.length;fe++){const Ie=ne.charCodeAt(fe);if(R(Ie)||k(Ie)||fe>0&&!t(ne.charCodeAt(fe-1)))return fe}return ne.length}function $(ne,ae,fe,Ie){if(fe===ne.length)return[];if(Ie===ae.length)return null;if(ne[fe]!==ae[Ie].toLowerCase())return null;{let F=null,V=Ie+1;for(F=$(ne,ae,fe+1,Ie+1);!F&&(V=a(ae,V))<ae.length;)F=$(ne,ae,fe+1,V),V++;return F===null?null:i({start:Ie,end:Ie+1},F)}}function E(ne){let ae=0,fe=0,Ie=0,F=0,V=0;for(let ce=0;ce<ne.length;ce++)V=ne.charCodeAt(ce),R(V)&&ae++,g(V)&&fe++,t(V)&&Ie++,k(V)&&F++;const G=ae/ne.length,J=fe/ne.length,q=Ie/ne.length,x=F/ne.length;return{upperPercent:G,lowerPercent:J,alphaPercent:q,numericPercent:x}}function v(ne){const{upperPercent:ae,lowerPercent:fe}=ne;return fe===0&&ae>.6}function n(ne){const{upperPercent:ae,lowerPercent:fe,alphaPercent:Ie,numericPercent:F}=ne;return fe>.2&&ae<.8&&Ie>.6&&F<.2}function r(ne){let ae=0,fe=0,Ie=0,F=0;for(let V=0;V<ne.length;V++)Ie=ne.charCodeAt(V),R(Ie)&&ae++,g(Ie)&&fe++,c(Ie)&&F++;return(ae===0||fe===0)&&F===0?ne.length<=30:ae<=5}function s(ne,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!r(ne)||ae.length>60)return null;const fe=E(ae);if(!n(fe)){if(!v(fe))return null;ae=ae.toLowerCase()}let Ie=null,F=0;for(ne=ne.toLowerCase();F<ae.length&&(Ie=$(ne,ae,0,F))===null;)F=a(ae,F+1);return Ie}e.$Hj=s;function o(ne,ae,fe=!1){if(!ae||ae.length===0)return null;let Ie=null,F=0;for(ne=ne.toLowerCase(),ae=ae.toLowerCase();F<ae.length&&(Ie=w(ne,ae,0,F,fe))===null;)F=d(ae,F+1);return Ie}e.$Ij=o;function w(ne,ae,fe,Ie,F){if(fe===ne.length)return[];if(Ie===ae.length)return null;if(f(ne.charCodeAt(fe),ae.charCodeAt(Ie))){let V=null,G=Ie+1;if(V=w(ne,ae,fe+1,Ie+1,F),!F)for(;!V&&(G=d(ae,G))<ae.length;)V=w(ne,ae,fe+1,G,F),G++;return V?ne.charCodeAt(fe)!==ae.charCodeAt(Ie)?V:i({start:Ie,end:Ie+1},V):null}else return null}function d(ne,ae){for(let fe=ae;fe<ne.length;fe++)if(p(ne.charCodeAt(fe))||fe>0&&p(ne.charCodeAt(fe-1)))return fe;return ne.length}const I=C(e.$Dj,s,A),S=C(e.$Dj,s,l),u=new y.$Dc(1e4);function m(ne,ae,fe=!1){if(typeof ne!="string"||typeof ae!="string")return null;let Ie=u.get(ne);Ie||(Ie=new RegExp(M.$Le(ne),"i"),u.set(ne,Ie));const F=Ie.exec(ae);return F?[{start:F.index,end:F.index+F[0].length}]:fe?S(ne,ae):I(ne,ae)}e.$Jj=m;function h(ne,ae){const fe=ee(ne,ne.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?W(fe):null}e.$Kj=h;function P(ne,ae,fe,Ie,F,V){const G=Math.min(13,ne.length);for(;fe<G;fe++){const J=ee(ne,ae,fe,Ie,F,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,V]}e.$Lj=P;function W(ne){if(typeof ne>"u")return[];const ae=[],fe=ne[1];for(let Ie=ne.length-1;Ie>1;Ie--){const F=ne[Ie]+fe,V=ae[ae.length-1];V&&V.end===F?V.end=F+1:ae.push({start:F,end:F+1})}return ae}e.$Mj=W;const K=128;function z(){const ne=[],ae=[];for(let fe=0;fe<=K;fe++)ae[fe]=0;for(let fe=0;fe<=K;fe++)ne.push(ae.slice(0));return ne}function j(ne){const ae=[];for(let fe=0;fe<=ne;fe++)ae[fe]=0;return ae}const O=j(2*K),N=j(2*K),ie=z(),X=z(),Ee=z(),Se=!1;function Pe(ne,ae,fe,Ie,F){function V(J,q,x=" "){for(;J.length<q;)J=x+J;return J}let G=` |   |${Ie.split("").map(J=>V(J,3)).join("|")}
`;for(let J=0;J<=fe;J++)J===0?G+=" |":G+=`${ae[J-1]}|`,G+=ne[J].slice(0,F+1).map(q=>V(q.toString(),3)).join("|")+`
`;return G}function $e(ne,ae,fe,Ie){ne=ne.substr(ae),fe=fe.substr(Ie),console.log(Pe(X,ne,ne.length,fe,fe.length)),console.log(Pe(Ee,ne,ne.length,fe,fe.length)),console.log(Pe(ie,ne,ne.length,fe,fe.length))}function pe(ne,ae){if(ae<0||ae>=ne.length)return!1;const fe=ne.codePointAt(ae);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$if(fe)}}function ue(ne,ae){if(ae<0||ae>=ne.length)return!1;switch(ne.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function oe(ne,ae,fe){return ae[ne]!==fe[ne]}function be(ne,ae,fe,Ie,F,V,G=!1){for(;ae<fe&&F<V;)ne[ae]===Ie[F]&&(G&&(O[ae]=F),ae+=1),F+=1;return ae===fe}e.$Nj=be;var _;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(_||(_={}));var B;(function(ne){ne.Default=[-100,0];function ae(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}ne.isDefault=ae})(B||(e.FuzzyScore=B={}));class Z{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,fe){this.firstMatchCanBeWeak=ae,this.boostFullMatch=fe}}e.$Oj=Z;function ee(ne,ae,fe,Ie,F,V,G=Z.default){const J=ne.length>K?K:ne.length,q=Ie.length>K?K:Ie.length;if(fe>=J||V>=q||J-fe>q-V||!be(ae,fe,J,F,V,q,!0))return;ve(J,q,fe,V,ae,F);let x=1,ce=1,Ne=fe,Ue=V;const Qe=[!1];for(x=1,Ne=fe;Ne<J;x++,Ne++){const it=O[Ne],tt=N[Ne],ze=Ne+1<J?N[Ne+1]:q;for(ce=it-V+1,Ue=it;Ue<ze;ce++,Ue++){let st=Number.MIN_SAFE_INTEGER,Y=!1;Ue<=tt&&(st=ge(ne,ae,Ne,fe,Ie,F,Ue,q,V,ie[x-1][ce-1]===0,Qe));let Q=0;st!==Number.MAX_SAFE_INTEGER&&(Y=!0,Q=st+X[x-1][ce-1]);const we=Ue>it,Be=we?X[x][ce-1]+(ie[x][ce-1]>0?-5:0):0,Oe=Ue>it+1&&ie[x][ce-1]>0,Xe=Oe?X[x][ce-2]+(ie[x][ce-2]>0?-5:0):0;if(Oe&&(!we||Xe>=Be)&&(!Y||Xe>=Q))X[x][ce]=Xe,Ee[x][ce]=3,ie[x][ce]=0;else if(we&&(!Y||Be>=Q))X[x][ce]=Be,Ee[x][ce]=2,ie[x][ce]=0;else if(Y)X[x][ce]=Q,Ee[x][ce]=1,ie[x][ce]=ie[x-1][ce-1]+1;else throw new Error("not possible")}}if(Se&&$e(ne,fe,Ie,V),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,ce--;const Ge=[X[x][ce],V];let xe=0,Ye=0;for(;x>=1;){let it=ce;do{const tt=Ee[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);xe>1&&ae[fe+x-1]===F[V+ce-1]&&!oe(it+V-1,Ie,F)&&xe+1>ie[x][it]&&(it=ce),it===ce?xe++:xe=1,Ye||(Ye=it),x--,ce=it-1,Ge.push(ce)}q===J&&G.boostFullMatch&&(Ge[0]+=2);const _e=Ye-J;return Ge[0]-=_e,Ge}e.$Pj=ee;function ve(ne,ae,fe,Ie,F,V){let G=ne-1,J=ae-1;for(;G>=fe&&J>=Ie;)F[G]===V[J]&&(N[G]=J,G--),J--}function ge(ne,ae,fe,Ie,F,V,G,J,q,x,ce){if(ae[fe]!==V[G])return Number.MIN_SAFE_INTEGER;let Ne=1,Ue=!1;return G===fe-Ie?Ne=ne[fe]===F[G]?7:5:oe(G,F,V)&&(G===0||!oe(G-1,F,V))?(Ne=ne[fe]===F[G]?7:5,Ue=!0):pe(V,G)&&(G===0||!pe(V,G-1))?Ne=5:(pe(V,G-1)||ue(V,G-1))&&(Ne=5,Ue=!0),Ne>1&&fe===Ie&&(ce[0]=!0),Ue||(Ue=oe(G,F,V)||pe(V,G-1)||ue(V,G-1)),fe===Ie?G>q&&(Ne-=Ue?3:5):x?Ne+=Ue?2:0:Ne+=Ue?0:1,G+1===J&&(Ne-=Ue?3:5),Ne}function he(ne,ae,fe,Ie,F,V,G){return re(ne,ae,fe,Ie,F,V,!0,G)}e.$Qj=he;function De(ne,ae,fe,Ie,F,V,G){return re(ne,ae,fe,Ie,F,V,!1,G)}e.$Rj=De;function re(ne,ae,fe,Ie,F,V,G,J){let q=ee(ne,ae,fe,Ie,F,V,J);if(q&&!G)return q;if(ne.length>=3){const x=Math.min(7,ne.length-1);for(let ce=fe+1;ce<x;ce++){const Ne=le(ne,ce);if(Ne){const Ue=ee(Ne,Ne.toLowerCase(),fe,Ie,F,V,J);Ue&&(Ue[0]-=3,(!q||Ue[0]>q[0])&&(q=Ue))}}}return q}function le(ne,ae){if(ae+1>=ne.length)return;const fe=ne[ae],Ie=ne[ae+1];if(fe!==Ie)return ne.slice(0,ae)+Ie+fe+ne.slice(ae+2)}}),define(Ae[29],Re([1,0,16]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const T="error",A="warning",l="warn",D="info",g="ignore";function R(c){return c?y.$2e(T,c)?C.Error:y.$2e(A,c)||y.$2e(l,c)?C.Warning:y.$2e(D,c)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function k(c){switch(c){case C.Error:return T;case C.Warning:return A;case C.Info:return D;default:return g}}C.toString=k}(M||(M={})),e.default=M}),define(Ae[120],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(Ae[49],Re([1,0,18,16]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class C{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const p=b.charCodeAt(0),f=this.b.charCodeAt(this.c);return p-f}value(){return this.b[this.c]}}e.$Rh=C;class T{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,M.$Ve)(b,this.b,0,b.length,this.c,this.d):(0,M.$Xe)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=T;class A{constructor(b=!0,p=!0){this.f=b,this.g=p}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let p=b.length-1;p>=0;p--,this.c--){const f=this.b.charCodeAt(p);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,M.$Ve)(b,this.b,0,b.length,this.d,this.e):(0,M.$Xe)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=A;var l;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(l||(l={}));class D{constructor(b,p){this.f=b,this.g=p,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,M.$We)(b,this.c.scheme);if(this.d[this.e]===2)return(0,M.$We)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,M.$Ue)(b,this.c.query);if(this.d[this.e]===5)return(0,M.$Ue)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(R||(R={}));class k{static forUris(b=()=>!1,p=()=>!1){return new k(new D(b,p))}static forPaths(b=!1){return new k(new A(void 0,!b))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new T)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,p){if(p){const f=p.slice(0);(0,y.$Xb)(f);for(const t of f)this.set(t,b)}else{const f=b.slice(0);(0,y.$Xb)(f);for(const t of f)this.set(t[0],t[1])}}set(b,p){const f=this.b.reset(b);let t;this.c||(this.c=new g,this.c.segment=f.value());const i=[];for(t=this.c;;){const $=f.cmp(t.segment);if($>0)t.left||(t.left=new g,t.left.segment=f.value()),i.push([-1,t]),t=t.left;else if($<0)t.right||(t.right=new g,t.right.segment=f.value()),i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),i.push([0,t]),t=t.mid;else break}const a=t.value;t.value=p,t.key=b;for(let $=i.length-1;$>=0;$--){const E=i[$][1];E.updateHeight();const v=E.balanceFactor();if(v<-1||v>1){const n=i[$][0],r=i[$+1][0];if(n===1&&r===1)i[$][1]=E.rotateLeft();else if(n===-1&&r===-1)i[$][1]=E.rotateRight();else if(n===1&&r===-1)E.right=i[$+1][1]=i[$+1][1].rotateRight(),i[$][1]=E.rotateLeft();else if(n===-1&&r===1)E.left=i[$+1][1]=i[$+1][1].rotateLeft(),i[$][1]=E.rotateRight();else throw new Error;if($>0)switch(i[$-1][0]){case-1:i[$-1][1].left=i[$][1];break;case 1:i[$-1][1].right=i[$][1];break;case 0:i[$-1][1].mid=i[$][1];break}else this.c=i[0][1]}}return a}get(b){return this.d(b)?.value}d(b){const p=this.b.reset(b);let f=this.c;for(;f;){const t=p.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(p.hasNext())p.next(),f=f.mid;else break}return f}has(b){const p=this.d(b);return!(p?.value===void 0&&p?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,p){const f=this.b.reset(b),t=[];let i=this.c;for(;i;){const a=f.cmp(i.segment);if(a>0)t.push([-1,i]),i=i.left;else if(a<0)t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const a=this.f(i.right);if(a.key){const{key:$,value:E,segment:v}=a;this.e(a.key,!1),i.key=$,i.value=E,i.segment=v}}else{const a=i.left??i.right;if(t.length>0){const[$,E]=t[t.length-1];switch($){case-1:E.left=a;break;case 0:E.mid=a;break;case 1:E.right=a;break}}else this.c=a}for(let a=t.length-1;a>=0;a--){const $=t[a][1];$.updateHeight();const E=$.balanceFactor();if(E>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),t[a][1]=$.rotateLeft()):E<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),t[a][1]=$.rotateRight()),a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const p=this.b.reset(b);let f=this.c,t;for(;f;){const i=p.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if(p.hasNext())p.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(b){return this.g(b,!1)}g(b,p){const f=this.b.reset(b);let t=this.c;for(;t;){const i=f.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[p,f]of this)b(f,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const p=[];return this.j(b,p),p[Symbol.iterator]()}j(b,p){b&&(b.left&&this.j(b.left,p),b.value&&p.push([b.key,b.value]),b.mid&&this.j(b.mid,p),b.right&&this.j(b.right,p))}_isBalanced(){const b=p=>{if(!p)return!0;const f=p.balanceFactor();return f<-1||f>1?!1:b(p.left)&&b(p.right)};return b(this.c)}}e.$Vh=k}),define(Ae[43],Re([1,0,89]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var M;(function(A){function l(D){return D&&typeof D=="object"&&typeof D.id=="string"}A.isThemeColor=l})(M||(e.ThemeColor=M={}));function C(A){return{id:A}}e.$Vj=C;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(a){const $=l.exec(a.id);if(!$)return D(y.$Uj.error);const[,E,v]=$,n=["codicon","codicon-"+E];return v&&n.push("codicon-modifier-"+v.substring(1)),n}A.asClassNameArray=D;function g(a){return D(a).join(" ")}A.asClassName=g;function R(a){return"."+D(a).join(".")}A.asCSSSelector=R;function k(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||M.isThemeColor(a.color))}A.isThemeIcon=k;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(a){const $=c.exec(a);if(!$)return;const[,E]=$;return{id:E}}A.fromString=b;function p(a){return{id:a}}A.fromId=p;function f(a,$){let E=a.id;const v=E.lastIndexOf("~");return v!==-1&&(E=E.substring(0,v)),$&&(E=`${E}~${$}`),{id:E}}A.modify=f;function t(a){const $=a.id.lastIndexOf("~");if($!==-1)return a.id.substring($+1)}A.getModifier=t;function i(a,$){return a.id===$.id&&a.color?.id===$.color?.id}A.isEqual=i})(T||(e.ThemeIcon=T={}))}),define(Ae[121],Re([1,0,119,16,43]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=void 0;const T="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function D(i){return i.replace(l,(a,$)=>$?a:`\\${a}`)}e.$Wj=D;const g=new RegExp(`\\\\${A.source}`,"g");function R(i){return i.replace(g,a=>`\\${a}`)}e.$Xj=R;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(i){return i.indexOf(T)===-1?i:i.replace(k,(a,$,E,v)=>E?a:$||v||"")}e.$Yj=c;function b(i){return i?i.replace(/\$\((.*?)\)/g,(a,$)=>` ${$} `).trim():""}e.$Zj=b;const p=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(i){p.lastIndex=0;let a="";const $=[];let E=0;for(;;){const v=p.lastIndex,n=p.exec(i),r=i.substring(v,n?.index);if(r.length>0){a+=r;for(let s=0;s<r.length;s++)$.push(E)}if(!n)break;E+=n[0].length}return{text:a,iconOffsets:$}}e.$1j=f;function t(i,a,$=!1){const{text:E,iconOffsets:v}=a;if(!v||v.length===0)return(0,y.$Jj)(i,E,$);const n=(0,M.$Je)(E," "),r=E.length-n.length,s=(0,y.$Jj)(i,n,$);if(s)for(const o of s){const w=v[o.start+r]+r;o.start+=w,o.end+=w}return s}e.$2j=t}),define(Ae[36],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return y.test(C)}e.$dg=M,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let D=0;D<l.length;D++)l[D]=Math.floor(Math.random()*256);return l};const T=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,g="";return g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g}}()}),define(Ae[122],Re([1,0,18,66,36]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=e.$2s=e.$1s=e.$Zs=void 0;function T(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$Zs=T;function A(k,c,b){const p={id:(0,C.$eg)(),name:k,uri:c,data:b};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$1s=A;class l{constructor(){this.a=new Map}get size(){let c=0;for(const b of this.a)c++;return c}has(c){return this.a.has(this.b(c))}matches(c){const b=[...this.a.keys()];return M.Iterable.some(this,([p,f])=>f.asFile())&&b.push("files"),R(D(c),b)}get(c){return this.a.get(this.b(c))?.[0]}append(c,b){const p=this.a.get(c);p?p.push(b):this.a.set(this.b(c),[b])}replace(c,b){this.a.set(this.b(c),[b])}delete(c){this.a.delete(this.b(c))}*[Symbol.iterator](){for(const[c,b]of this.a)for(const p of b)yield[c,p]}b(c){return D(c)}}e.$2s=l;function D(k){return k.toLowerCase()}function g(k,c){return R(D(k),c.map(D))}e.$3s=g;function R(k,c){if(k==="*/*")return c.length>0;if(c.includes(k))return!0;const b=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[p,f,t]=b;return t==="*"?c.some(i=>i.startsWith(f+"/")):!1}e.$4s=Object.freeze({create:k=>(0,y.$Mb)(k.map(c=>c.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$4s.split(k).filter(c=>!c.startsWith("#"))})}),define(Ae[123],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0,e.$4r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class M{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let D=0,g=l.notIn.length;D<g;D++)switch(l.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,D){if(l.getTokenCount()===0)return!0;const g=l.findTokenIndexAtOffset(D-2),R=l.getStandardTokenType(g);return this.isOK(R)}g(l,D){for(let g=l;g<=D;g++){const R=String.fromCharCode(g);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$qt=M;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of l)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$rt=C;function T(A,l,D){A.has(l)?A.get(l).push(D):A.set(l,[D])}}),define(Ae[125],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N7=e.$M7=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$M7=y;class M{constructor(T){this.identifier=T}}e.$N7=M}),define(Ae[126],Re([10,11]),function(ye,e){return ye.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;class T extends M.$Sc{constructor(c,b="",p="",f=!0,t){super(),this.h=this.B(new y.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=b,this.u=p,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,b){this.C&&await this.C(c)}}e.$ui=T;class A extends M.$Sc{constructor(){super(...arguments),this.f=this.B(new y.$Nd),this.onWillRun=this.f.event,this.m=this.B(new y.$Nd),this.onDidRun=this.m.event}async run(c,b){if(!c.enabled)return;this.f.fire({action:c});let p;try{await this.u(c,b)}catch(f){p=f}this.m.fire({action:c,error:p})}async u(c,b){await c.run(b)}}e.$vi=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let b=[];for(const p of c)p.length&&(b.length?b=[...b,new l,...p]:b=p);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$wi=l;class D{get actions(){return this.a}constructor(c,b,p,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=b,this.class=f,this.a=p}async run(){}}e.$xi=D;class g extends T{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,C.localize(0,null),void 0,!1)}}e.$yi=g;function R(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...c)=>k.run(...c),tooltip:k.label}}e.$zi=R}),define(Ae[128],Re([10,11]),function(ye,e){return ye.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const M=60,C=M*60,T=C*24,A=T*7,l=T*30,D=T*365;function g(k,c,b,p){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,y.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!p&&f<30)return(0,y.localize)(1,null);let t;return f<M?(t=f,c?t===1?b?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):b?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?b?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):b?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):f<C?(t=Math.floor(f/M),c?t===1?b?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):b?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?b?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):b?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):f<T?(t=Math.floor(f/C),c?t===1?b?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):b?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?b?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):b?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):f<A?(t=Math.floor(f/T),c?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):f<l?(t=Math.floor(f/A),c?t===1?b?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):b?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?b?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):b?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):f<D?(t=Math.floor(f/l),c?t===1?b?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):b?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?b?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):b?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(f/D),c?t===1?b?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):b?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?b?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):b?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$dm=g;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=R}),define(Ae[130],Re([10,11]),function(ye,e){return ye.create("vs/base/common/errorMessage",e)}),define(Ae[37],Re([1,0,18,15,130]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function T(k,c){return c&&(k.stack||k.stacktrace)?C.localize(0,null,l(k),A(k.stack)||A(k.stacktrace)):l(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function l(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function D(k=null,c=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const b=y.$Hb(k),p=D(b[0],c);return b.length>1?C.localize(4,null,p,b.length):p}if(M.$yf(k))return k;if(k.detail){const b=k.detail;if(b.error)return T(b.error,c);if(b.exception)return T(b.exception,c)}return k.stack?T(k,c):k.message?k.message:C.localize(5,null)}e.$Ai=D;function g(k){const c=k;return c instanceof Error&&Array.isArray(c.actions)}e.$Bi=g;function R(k,c){let b;return typeof k=="string"?b=new Error(k):b=k,b.actions=c,b}e.$Ci=R}),define(Ae[131],Re([1,0,42,20]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=void 0;const C=new y.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),T=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(S,u,m=!1){const h=S||"",P=u||"",W=C.value.collator.compare(h,P);return C.value.collatorIsNumeric&&W===0&&h!==P?h<P?-1:1:W}e.$iq=l;function D(S,u){const m=T.value.collator;return S=S||"",u=u||"",E(m,S,u)}e.$jq=D;function g(S,u){const m=T.value.collator;return S=S||"",u=u||"",s(S,u)||E(m,S,u)}e.$kq=g;function R(S,u){const m=T.value.collator;return S=S||"",u=u||"",r(S,u)||E(m,S,u)}e.$lq=R;function k(S,u){return S=S||"",u=u||"",S===u?0:S<u?-1:1}e.$mq=k;function c(S,u){const[m,h]=a(S),[P,W]=a(u);let K=C.value.collator.compare(h,W);if(K===0){if(C.value.collatorIsNumeric&&h!==W)return h<W?-1:1;if(K=C.value.collator.compare(m,P),C.value.collatorIsNumeric&&K===0&&m!==P)return m<P?-1:1}return K}e.$nq=c;function b(S,u){S=S||"",u=u||"";const m=$(S),h=$(u),P=T.value.collator,W=A.value.collator;return E(W,m,h)||E(P,S,u)}e.$oq=b;function p(S,u){S=S||"",u=u||"";const m=$(S),h=$(u),P=T.value.collator,W=A.value.collator;return E(W,m,h)||s(S,u)||E(P,S,u)}e.$pq=p;function f(S,u){S=S||"",u=u||"";const m=$(S),h=$(u),P=T.value.collator,W=A.value.collator;return E(W,m,h)||r(S,u)||E(P,S,u)}e.$qq=f;function t(S,u){S=S||"",u=u||"";const m=$(S).toLowerCase(),h=$(u).toLowerCase();return m!==h?m<h?-1:1:S!==u?S<u?-1:1:0}e.$rq=t;const i=/^(.*?)(\.([^.]*))?$/;function a(S,u=!1){const m=S?i.exec(S):[];let h=[m&&m[1]||"",m&&m[3]||""];return u&&(!h[0]&&h[1]||h[0]&&h[0].charAt(0)===".")&&(h=[h[0]+"."+h[1],""]),h}function $(S){const u=S?i.exec(S):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function E(S,u,m){const h=S.compare(u,m);return h!==0?h:u.length!==m.length?u.length<m.length?-1:1:0}function v(S){const u=S.charAt(0);return u.toLocaleUpperCase()!==u}function n(S){const u=S.charAt(0);return u.toLocaleLowerCase()!==u}function r(S,u){return v(S)&&n(u)?-1:n(S)&&v(u)?1:0}function s(S,u){return n(S)&&v(u)?-1:v(S)&&n(u)?1:0}function o(S,u,m=!1){return m||(S=S&&S.toLowerCase(),u=u&&u.toLowerCase()),S===u?0:S<u?-1:1}function w(S,u,m=!1){const h=S.split(M.sep),P=u.split(M.sep),W=h.length-1,K=P.length-1;let z,j;for(let O=0;;O++){if(z=W===O,j=K===O,z&&j)return l(h[O],P[O],m);if(z)return-1;if(j)return 1;const N=o(h[O],P[O],m);if(N!==0)return N}}e.$sq=w;function d(S,u,m){const h=S.toLowerCase(),P=u.toLowerCase(),W=I(S,u,m);if(W)return W;const K=h.endsWith(m),z=P.endsWith(m);if(K!==z)return K?-1:1;const j=l(h,P);return j!==0?j:h.localeCompare(P)}e.$tq=d;function I(S,u,m){const h=S.toLowerCase(),P=u.toLowerCase(),W=h.startsWith(m),K=P.startsWith(m);if(W!==K)return W?-1:1;if(W&&K){if(h.length<P.length)return-1;if(h.length>P.length)return 1}return 0}e.$uq=I}),define(Ae[44],Re([1,0,20,23,16,15]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function A(d){return d===47||d===92}e.$Qf=A;function l(d){return d.replace(/[\\/]/g,y.$gc.sep)}e.$Rf=l;function D(d){return d.indexOf("/")===-1&&(d=l(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$Sf=D;function g(d,I=y.$gc.sep){if(!d)return"";const S=d.length,u=d.charCodeAt(0);if(A(u)){if(A(d.charCodeAt(1))&&!A(d.charCodeAt(2))){let h=3;const P=h;for(;h<S&&!A(d.charCodeAt(h));h++);if(P!==h&&!A(d.charCodeAt(h+1))){for(h+=1;h<S;h++)if(A(d.charCodeAt(h)))return d.slice(0,h+1).replace(/[\\/]/g,I)}}return I}else if(i(u)&&d.charCodeAt(1)===58)return A(d.charCodeAt(2))?d.slice(0,2)+I:d.slice(0,2);let m=d.indexOf("://");if(m!==-1){for(m+=3;m<S;m++)if(A(d.charCodeAt(m)))return d.slice(0,m+1)}return""}e.$Tf=g;function R(d){if(!M.$j||!d||d.length<5)return!1;let I=d.charCodeAt(0);if(I!==92||(I=d.charCodeAt(1),I!==92))return!1;let S=2;const u=S;for(;S<d.length&&(I=d.charCodeAt(S),I!==92);S++);return!(u===S||(I=d.charCodeAt(S+1),isNaN(I)||I===92))}e.$Uf=R;const k=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(d,I=M.$j){const S=I?k:c;return!(!d||d.length===0||/^\s+$/.test(d)||(S.lastIndex=0,S.test(d))||I&&b.test(d)||d==="."||d===".."||I&&d[d.length-1]==="."||I&&d.length!==d.trim().length||d.length>255)}e.$Vf=p;function f(d,I,S){const u=d===I;return!S||u?u:!d||!I?!1:(0,C.$2e)(d,I)}e.$Wf=f;function t(d,I,S,u=y.sep){if(d===I)return!0;if(!d||!I||I.length>d.length)return!1;if(S){if(!(0,C.$3e)(d,I))return!1;if(I.length===d.length)return!0;let h=I.length;return I.charAt(I.length-1)===u&&h--,d.charAt(h)===u}return I.charAt(I.length-1)!==u&&(I+=u),d.indexOf(I)===0}e.$Xf=t;function i(d){return d>=65&&d<=90||d>=97&&d<=122}e.$Yf=i;function a(d,I){return M.$j&&d.endsWith(":")&&(d+=y.sep),(0,y.$ic)(d)||(d=(0,y.$jc)(I,d)),d=(0,y.$hc)(d),M.$j?(d=(0,C.$Ke)(d,y.sep),d.endsWith(":")&&(d+=y.sep)):(d=(0,C.$Ke)(d,y.sep),d||(d=y.sep)),d}e.$Zf=a;function $(d){const I=(0,y.$hc)(d);return M.$j?d.length>3?!1:E(I)&&(d.length===2||I.charCodeAt(2)===92):I===y.$gc.sep}e.$1f=$;function E(d,I=M.$j){return I?i(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$2f=E;function v(d,I=M.$j){return E(d,I)?d[0]:void 0}e.$3f=v;function n(d,I,S){return I.length>d.length?-1:d===I?0:(S&&(d=d.toLowerCase(),I=I.toLowerCase()),d.indexOf(I))}e.$4f=n;function r(d){const I=d.split(":");let S,u,m;for(const h of I){const P=Number(h);(0,T.$Cf)(P)?u===void 0?u=P:m===void 0&&(m=P):S=S?[S,h].join(":"):h}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.$5f=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(d,I,S=8){let u="";for(let h=0;h<S;h++){let P;h===0&&M.$j&&!I&&(S===3||S===4)?P=o:P=s,u+=P.charAt(Math.floor(Math.random()*P.length))}let m;return I?m=`${I}-${u}`:m=u,d?(0,y.$jc)(d,m):m}e.$6f=w}),define(Ae[67],Re([1,0,20]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=e.$Rr=e.$Qr=void 0,e.$Qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(R){const k=(0,y.$oc)(R),c=M[k.toLowerCase()];return c!==void 0?c:A(R)}e.$Rr=T;function A(R){const k=(0,y.$oc)(R);return C[k.toLowerCase()]}e.$Sr=A;function l(R){for(const k in C)if(C[k]===R)return k}e.$Tr=l;const D=/^(.+)\/(.+?)(;.+)?$/;function g(R,k){const c=D.exec(R);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:k?void 0:R}e.$Ur=g}),define(Ae[68],Re([1,0,26,2]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function C(D){return JSON.stringify(D,A)}e.$kh=C;function T(D){let g=JSON.parse(D);return g=l(g),g}e.$lh=T;function A(D,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function l(D,g=0){if(!D||g>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return M.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof y.$be||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let R=0;R<D.length;++R)D[R]=l(D[R],g+1);else for(const R in D)Object.hasOwnProperty.call(D,R)&&(D[R]=l(D[R],g+1))}return D}e.$mh=l}),define(Ae[13],Re([1,0,9,23,2]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var T;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$7f="vscode-tkn",e.$8f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${T.vscodeRemoteResource}`}set(R,k,c){this.a[R]=k,this.b[R]=c}setConnectionToken(R,k){this.c[R]=k}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(t){return y.$1(t),R}const k=R.authority;let c=this.a[k];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const b=this.b[k],p=this.c[k];let f=`path=${encodeURIComponent(R.path)}`;return typeof p=="string"&&(f+=`&${e.$8f}=${encodeURIComponent(p)}`),C.URI.from({scheme:M.$p?this.d:T.vscodeRemoteResource,authority:`${c}:${b}`,path:this.f,query:f})}}e.$9f=new A,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class l{static{this.a=e.$bg}asBrowserUri(R){const k=this.b(R,ye);return this.uriToBrowserUri(k)}uriToBrowserUri(R){return R.scheme===T.vscodeRemote?e.$9f.rewrite(R):R.scheme===T.file&&(M.$n||M.$q&&M.$h.origin===`${T.vscodeFileResource}://${l.a}`)?R.with({scheme:T.vscodeFileResource,authority:R.authority||l.a,query:null,fragment:null}):R}asFileUri(R){const k=this.b(R,ye);return this.uriToFileUri(k)}uriToFileUri(R){return R.scheme===T.vscodeFileResource?R.with({scheme:T.file,authority:R.authority!==l.a?R.authority:null,query:null,fragment:null}):R}b(R,k){return C.URI.isUri(R)?R:C.URI.parse(k.toUrl(R))}}e.$cg=new l;var D;(function(g){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(R.get("3"));const k="vscode-coi";function c(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:C.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const t=f?.get(k);if(t)return R.get(t)}g.getHeadersFromQuery=c;function b(p,f,t){if(!globalThis.crossOriginIsolated)return;const i=f&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(k,i):p[k]=i}g.addSearchParam=b})(D||(e.COI=D={}))}),define(Ae[24],Re([1,0,44,13,20,23,16,2]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function D(b){return(0,l.$wc)(b,!0)}e.$jg=D;class g{constructor(p){this.a=p}compare(p,f,t=!1){return p===f?0:(0,A.$Ue)(this.getComparisonKey(p,t),this.getComparisonKey(f,t))}isEqual(p,f,t=!1){return p===f?!0:!p||!f?!1:this.getComparisonKey(p,t)===this.getComparisonKey(f,t)}getComparisonKey(p,f=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,f,t=!1){if(p.scheme===f.scheme){if(p.scheme===M.Schemas.file)return y.$Xf(D(p),D(f),this.a(p))&&p.query===f.query&&(t||p.fragment===f.fragment);if((0,e.$Ag)(p.authority,f.authority))return y.$Xf(p.path,f.path,this.a(p),"/")&&p.query===f.query&&(t||p.fragment===f.fragment)}return!1}joinPath(p,...f){return l.URI.joinPath(p,...f)}basenameOrAuthority(p){return(0,e.$sg)(p)||p.authority}basename(p){return C.$gc.basename(p.path)}extname(p){return C.$gc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let f;return p.scheme===M.Schemas.file?f=l.URI.file(C.$mc(D(p))).path:(f=C.$gc.dirname(p.path),p.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),f="/")),p.with({path:f})}normalizePath(p){if(!p.path.length)return p;let f;return p.scheme===M.Schemas.file?f=l.URI.file(C.$hc(D(p))).path:f=C.$gc.normalize(p.path),p.with({path:f})}relativePath(p,f){if(p.scheme!==f.scheme||!(0,e.$Ag)(p.authority,f.authority))return;if(p.scheme===M.Schemas.file){const a=C.$lc(D(p),D(f));return T.$j?y.$Rf(a):a}let t=p.path||"/";const i=f.path||"/";if(this.a(p)){let a=0;for(const $=Math.min(t.length,i.length);a<$&&!(t.charCodeAt(a)!==i.charCodeAt(a)&&t.charAt(a).toLowerCase()!==i.charAt(a).toLowerCase());a++);t=i.substr(0,a)+t.substr(a)}return C.$gc.relative(t,i)}resolvePath(p,f){if(p.scheme===M.Schemas.file){const t=l.URI.file(C.$kc(D(p),f));return p.with({authority:t.authority,path:t.path})}return f=y.$Sf(f),p.with({path:C.$gc.resolve(p.path,f)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,f){return p===f||p!==void 0&&f!==void 0&&(0,A.$2e)(p,f)}hasTrailingPathSeparator(p,f=C.sep){if(p.scheme===M.Schemas.file){const t=D(p);return t.length>y.$Tf(t).length&&t[t.length-1]===f}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,f=C.sep){return(0,e.$Bg)(p,f)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,f=C.sep){let t=!1;if(p.scheme===M.Schemas.file){const i=D(p);t=i!==void 0&&i.length===y.$Tf(i).length&&i[i.length-1]===f}else{f="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Bg)(p,f)?p.with({path:p.path+"/"}):p}}e.$kg=g,e.$lg=new g(()=>!1),e.$mg=new g(b=>b.scheme===M.Schemas.file?!T.$l:!0),e.$ng=new g(b=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function R(b,p){const f=[];for(let t=0;t<b.length;t++){const i=p(b[t]);b.some((a,$)=>$===t?!1:(0,e.$pg)(i,p(a)))||f.push(b[t])}return f}e.$Eg=R;var k;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach($=>{const[E,v]=$.split(":");E&&v&&t.set(E,v)});const a=f.path.substring(0,f.path.indexOf(";"));return a&&t.set(b.META_DATA_MIME,a),t}b.parseMetaData=p})(k||(e.DataUri=k={}));function c(b,p,f){if(p){let t=b.path;return t&&t[0]!==C.$gc.sep&&(t=C.$gc.sep+t),b.with({scheme:f,authority:p,path:t})}return b.with({scheme:f})}e.$Fg=c}),define(Ae[12],Re([1,0,19,9,5,6,24,23,120]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function g(Z){return!!Z&&typeof Z.then=="function"}e.$Gg=g;function R(Z){const ee=new y.$Xd,ve=Z(ee.token),ge=new Promise((he,De)=>{const re=ee.token.onCancellationRequested(()=>{re.dispose(),ee.dispose(),De(new M.$5)});Promise.resolve(ve).then(le=>{re.dispose(),ee.dispose(),he(le)},le=>{re.dispose(),ee.dispose(),De(le)})});return new class{cancel(){ee.cancel()}then(he,De){return ge.then(he,De)}catch(he){return this.then(void 0,he)}finally(he){return ge.finally(he)}}}e.$Hg=R;function k(Z,ee,ve){return new Promise((ge,he)=>{const De=ee.onCancellationRequested(()=>{De.dispose(),ge(ve)});Z.then(ge,he).finally(()=>De.dispose())})}e.$Ig=k;function c(Z,ee){return new Promise((ve,ge)=>{const he=ee.onCancellationRequested(()=>{he.dispose(),ge(new M.$5)});Z.then(ve,ge).finally(()=>he.dispose())})}e.$Jg=c;async function b(Z){let ee=-1;const ve=Z.map((ge,he)=>ge.then(De=>(ee=he,De)));try{return await Promise.race(ve)}finally{Z.forEach((ge,he)=>{he!==ee&&ge.cancel()})}}e.$Kg=b;function p(Z,ee,ve){let ge;const he=setTimeout(()=>{ge?.(void 0),ve?.()},ee);return Promise.race([Z.finally(()=>clearTimeout(he)),new Promise(De=>ge=De)])}e.$Lg=p;function f(Z){return new Promise((ee,ve)=>{const ge=Z();g(ge)?ge.then(ee,ve):ee(ge)})}e.$Mg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ee){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ee,!this.b){const ve=()=>{if(this.b=null,this.f)return;const ge=this.queue(this.d);return this.d=null,ge};this.b=new Promise(ge=>{this.a.then(ve,ve).then(ge)})}return new Promise((ve,ge)=>{this.b.then(ve,ge)})}return this.a=ee(),new Promise((ve,ge)=>{this.a.then(he=>{this.a=null,ve(he)},he=>{this.a=null,ge(he)})})}dispose(){this.f=!0}}e.$Ng=t;class i{constructor(){this.a=Promise.resolve(null)}queue(ee){return this.a=this.a.then(()=>ee(),()=>ee())}}e.$Og=i;class a{constructor(){this.a=new Map}queue(ee,ve){const he=(this.a.get(ee)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.a.get(ee)===he&&this.a.delete(ee)});return this.a.set(ee,he),he}}e.$Pg=a;const $=(Z,ee)=>{let ve=!0;const ge=setTimeout(()=>{ve=!1,ee()},Z);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(ge),ve=!1}}},E=Z=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,Z())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class v{constructor(ee){this.defaultDelay=ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ee,ve=this.defaultDelay){this.g=ee,this.h(),this.b||(this.b=new Promise((he,De)=>{this.d=he,this.f=De}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const ge=()=>{this.a=null,this.d?.(null)};return this.a=ve===D.$Kd?E(ge):$(ve,ge),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=v;class n{constructor(ee){this.a=new v(ee),this.b=new t}trigger(ee,ve){return this.a.trigger(()=>this.b.queue(ee),ve)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=n;class r{constructor(){this.a=!1,this.b=new Promise((ee,ve)=>{this.d=ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=r;class s extends r{constructor(ee){super(),this.f=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this.f),super.open()}}e.$Tg=s;function o(Z,ee){return ee?new Promise((ve,ge)=>{const he=setTimeout(()=>{De.dispose(),ve()},Z),De=ee.onCancellationRequested(()=>{clearTimeout(he),De.dispose(),ge(new M.$5)})}):R(ve=>o(Z,ve))}e.$Ug=o;function w(Z,ee=0,ve){const ge=setTimeout(()=>{Z(),ve&&he.dispose()},ee),he=(0,T.$Qc)(()=>{clearTimeout(ge),ve?.deleteAndLeak(he)});return ve?.add(he),he}e.$Vg=w;function d(Z){const ee=[];let ve=0;const ge=Z.length;function he(){return ve<ge?Z[ve++]():null}function De(re){re!=null&&ee.push(re);const le=he();return le?le.then(De):Promise.resolve(ee)}return Promise.resolve(null).then(De)}e.$Wg=d;function I(Z,ee=ge=>!!ge,ve=null){let ge=0;const he=Z.length,De=()=>{if(ge>=he)return Promise.resolve(ve);const re=Z[ge++];return Promise.resolve(re()).then(ne=>ee(ne)?Promise.resolve(ne):De())};return De()}e.$Xg=I;function S(Z,ee=ge=>!!ge,ve=null){if(Z.length===0)return Promise.resolve(ve);let ge=Z.length;const he=()=>{ge=-1;for(const De of Z)De.cancel?.()};return new Promise((De,re)=>{for(const le of Z)le.then(ne=>{--ge>=0&&ee(ne)?(he(),De(ne)):ge===0&&De(ve)}).catch(ne=>{--ge>=0&&(he(),re(ne))})})}e.$Yg=S;class u{constructor(ee){this.a=0,this.d=ee,this.f=[],this.b=0,this.g=new C.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(ee){return this.a++,new Promise((ve,ge)=>{this.f.push({factory:ee,c:ve,e:ge}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ee=this.f.shift();this.b++;const ve=ee.factory();ve.then(ee.c,ee.e),ve.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=u;class m extends u{constructor(){super(1)}}e.$1g=m;class h{constructor(){this.a=new Ee,this.b=0}queue(ee){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ee())):this.a.run(this.b++,ee())}}e.$2g=h;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ee=new $e;return this.b.add(ee),ee.p}g(){for(const[,ee]of this.a)if(ee.size>0)return!1;return!0}queueFor(ee,ve=A.$lg){const ge=ve.getComparisonKey(ee);let he=this.a.get(ge);if(!he){he=new m;const De=this.f++,re=C.Event.once(he.onDrained)(()=>{he?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$1c),this.d.set(De,re),this.a.set(ge,he)}return he}h(){this.g()&&this.j()}j(){for(const ee of this.b)ee.complete();this.b.clear()}dispose(){for(const[,ee]of this.a)ee.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=P;class W{constructor(ee,ve){this.a=-1,typeof ee=="function"&&typeof ve=="number"&&this.setIfNotSet(ee,ve)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ee,ve){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ee()},ve)}setIfNotSet(ee,ve){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ee()},ve))}}e.$4g=W;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ee,ve){this.cancel(),this.a=setInterval(()=>{ee()},ve)}}e.$5g=K;class z{constructor(ee,ve){this.b=-1,this.a=ee,this.d=ve,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ee=this.d){this.cancel(),this.b=setTimeout(this.f,ee)}get delay(){return this.d}set delay(ee){this.d=ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=z;class j{constructor(ee,ve){ve%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.a=ee,this.b=ve,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ee=this.b){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=j;class O extends z{constructor(ee,ve){super(ee,ve),this.j=[]}work(ee){this.j.push(ee),this.isScheduled()||this.schedule()}h(){const ee=this.j;this.j=[],this.a?.(ee)}dispose(){this.j=[],super.dispose()}}e.$8g=O;class N extends T.$Sc{constructor(ee,ve){super(),this.g=ee,this.h=ve,this.a=[],this.b=this.B(new T.$Tc),this.f=!1}get pending(){return this.a.length}work(ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ve of ee)this.a.push(ve);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=Z=>{(0,l.$B)(()=>{if(ee)return;const ve=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$0g=(Z,ee)=>{const ve=requestIdleCallback(Z,typeof ee=="number"?{timeout:ee}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,cancelIdleCallback(ve))}}}}();class ie{constructor(ee){this.d=!1,this.a=()=>{try{this.f=ee()}catch(ve){this.g=ve}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=ie;async function X(Z,ee,ve){let ge;for(let he=0;he<ve;he++)try{return await Z()}catch(De){ge=De,await o(ee)}throw ge}e.$_g=X;class Ee{isRunning(ee){return typeof ee=="number"?this.a?.taskId===ee:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ee,ve,ge){return this.a={taskId:ee,cancel:()=>ge?.(),promise:ve},ve.then(()=>this.d(ee),()=>this.d(ee)),ve}d(ee){this.a&&ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ee=this.b;this.b=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}queue(ee){if(this.b)this.b.run=ee;else{let ve,ge;const he=new Promise((De,re)=>{ve=De,ge=re});this.b={run:ee,promise:he,promiseResolve:ve,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=Ee;class Se{constructor(ee,ve=()=>Date.now()){this.d=ee,this.f=ve,this.a=0,this.b=0}increment(){const ee=this.f();return ee-this.a>this.d&&(this.a=ee,this.b=0),this.b++,this.b}}e.$bh=Se;var Pe;(function(Z){Z[Z.Resolved=0]="Resolved",Z[Z.Rejected=1]="Rejected"})(Pe||(Pe={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ee,ve)=>{this.a=ee,this.b=ve})}complete(ee){return new Promise(ve=>{this.a(ee),this.d={outcome:0,value:ee},ve()})}error(ee){return new Promise(ve=>{this.b(ee),this.d={outcome:1,value:ee},ve()})}cancel(){return this.error(new M.$5)}}e.$ch=$e;var pe;(function(Z){async function ee(ge){let he;const De=await Promise.all(ge.map(re=>re.then(le=>le,le=>{he||(he=le)})));if(typeof he<"u")throw he;return De}Z.settled=ee;function ve(ge){return new Promise(async(he,De)=>{try{await ge(he,De)}catch(re){De(re)}})}Z.withAsyncBody=ve})(pe||(e.Promises=pe={}));var ue;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(ue||(ue={}));class oe{static fromArray(ee){return new oe(ve=>{ve.emitMany(ee)})}static fromPromise(ee){return new oe(async ve=>{ve.emitMany(await ee)})}static fromPromises(ee){return new oe(async ve=>{await Promise.all(ee.map(async ge=>ve.emitOne(await ge)))})}static merge(ee){return new oe(async ve=>{await Promise.all(ee.map(async ge=>{for await(const he of ge)ve.emitOne(he)}))})}static{this.EMPTY=oe.fromArray([])}constructor(ee){this.a=0,this.b=[],this.d=null,this.f=new C.$Nd,queueMicrotask(async()=>{const ve={emitOne:ge=>this.g(ge),emitMany:ge=>this.h(ge),reject:ge=>this.k(ge)};try{await Promise.resolve(ee(ve)),this.j()}catch(ge){this.k(ge)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ee<this.b.length)return{done:!1,value:this.b[ee++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(ee,ve){return new oe(async ge=>{for await(const he of ee)ge.emitOne(ve(he))})}map(ee){return oe.map(this,ee)}static filter(ee,ve){return new oe(async ge=>{for await(const he of ee)ve(he)&&ge.emitOne(he)})}filter(ee){return oe.filter(this,ee)}static coalesce(ee){return oe.filter(ee,ve=>!!ve)}coalesce(){return oe.coalesce(this)}static async toPromise(ee){const ve=[];for await(const ge of ee)ve.push(ge);return ve}toPromise(){return oe.toPromise(this)}g(ee){this.a===0&&(this.b.push(ee),this.f.fire())}h(ee){this.a===0&&(this.b=this.b.concat(ee),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ee){this.a===0&&(this.a=2,this.d=ee,this.f.fire())}}e.$dh=oe;class be extends oe{constructor(ee,ve){super(ve),this.l=ee}cancel(){this.l.cancel()}}e.$eh=be;function _(Z){const ee=new y.$Xd,ve=Z(ee.token);return new be(ee,async ge=>{const he=ee.token.onCancellationRequested(()=>{he.dispose(),ee.dispose(),ge.reject(new M.$5)});try{for await(const De of ve){if(ee.token.isCancellationRequested)return;ge.emitOne(De)}he.dispose(),ee.dispose()}catch(De){he.dispose(),ee.dispose(),ge.reject(De)}})}e.$fh=_;class B{constructor(){this.a=new $e,this.b=new oe(ge=>{if(ee){ge.reject(ee);return}return ve&&ge.emitMany(ve),this.d=he=>ge.reject(he),this.f=he=>ge.emitOne(he),this.a.p});let ee,ve;this.f=ge=>{ve||(ve=[]),ve.push(ge)},this.d=ge=>{ee||(ee=ge)}}get asyncIterable(){return this.b}complete(){this.a.complete()}error(ee){this.d(ee),this.a.complete()}emit(ee){this.f(ee)}}e.$gh=B}),define(Ae[38],Re([1,0,18,12,44,28,20,23,16]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function g(){return Object.create(null)}e.$rj=g,e.$sj="**",e.$tj="/";const R="[/\\\\]",k="[^/\\\\]",c=/\//g;function b(Ee,Se){switch(Ee){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${Se?`|${R}${k}+`:""})*?`}}function p(Ee,Se){if(!Ee)return[];const Pe=[];let $e=!1,pe=!1,ue="";for(const oe of Ee){switch(oe){case Se:if(!$e&&!pe){Pe.push(ue),ue="";continue}break;case"{":$e=!0;break;case"}":$e=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}ue+=oe}return ue&&Pe.push(ue),Pe}e.$uj=p;function f(Ee){if(!Ee)return"";let Se="";const Pe=p(Ee,e.$tj);if(Pe.every($e=>$e===e.$sj))Se=".*";else{let $e=!1;Pe.forEach((pe,ue)=>{if(pe===e.$sj){if($e)return;Se+=b(2,ue===Pe.length-1)}else{let oe=!1,be="",_=!1,B="";for(const Z of pe){if(Z!=="}"&&oe){be+=Z;continue}if(_&&(Z!=="]"||!B)){let ee;Z==="-"?ee=Z:(Z==="^"||Z==="!")&&!B?ee="^":Z===e.$tj?ee="":ee=(0,D.$Fe)(Z),B+=ee;continue}switch(Z){case"{":oe=!0;continue;case"[":_=!0;continue;case"}":{const ve=`(?:${p(be,",").map(ge=>f(ge)).join("|")})`;Se+=ve,oe=!1,be="";break}case"]":{Se+="["+B+"]",_=!1,B="";break}case"?":Se+=k;continue;case"*":Se+=b(1);continue;default:Se+=(0,D.$Fe)(Z)}}ue<Pe.length-1&&(Pe[ue+1]!==e.$sj||ue+2<Pe.length)&&(Se+=R)}$e=pe===e.$sj})}return Se}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new T.$Dc(1e4),r=function(){return!1},s=function(){return null};function o(Ee,Se){if(!Ee)return s;let Pe;typeof Ee!="string"?Pe=Ee.pattern:Pe=Ee,Pe=Pe.trim();const $e=`${Pe}_${!!Se.trimForExclusions}`;let pe=n.get($e);if(pe)return w(pe,Ee);let ue;return t.test(Pe)?pe=I(Pe.substr(4),Pe):(ue=i.exec(d(Pe,Se)))?pe=S(ue[1],Pe):(Se.trimForExclusions?$:a).test(Pe)?pe=u(Pe,Se):(ue=E.exec(d(Pe,Se)))?pe=m(ue[1].substr(1),Pe,!0):(ue=v.exec(d(Pe,Se)))?pe=m(ue[1],Pe,!1):pe=h(Pe),n.set($e,pe),w(pe,Ee)}function w(Ee,Se){if(typeof Se=="string")return Ee;const Pe=function($e,pe){return(0,C.$Xf)($e,Se.base,!l.$l)?Ee((0,D.$Je)($e.substr(Se.base.length),A.sep),pe):null};return Pe.allBasenames=Ee.allBasenames,Pe.allPaths=Ee.allPaths,Pe.basenames=Ee.basenames,Pe.patterns=Ee.patterns,Pe}function d(Ee,Se){return Se.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,Se){return function(Pe,$e){return typeof Pe=="string"&&Pe.endsWith(Ee)?Se:null}}function S(Ee,Se){const Pe=`/${Ee}`,$e=`\\${Ee}`,pe=function(oe,be){return typeof oe!="string"?null:be?be===Ee?Se:null:oe===Ee||oe.endsWith(Pe)||oe.endsWith($e)?Se:null},ue=[Ee];return pe.basenames=ue,pe.patterns=[Se],pe.allBasenames=ue,pe}function u(Ee,Se){const Pe=ie(Ee.slice(1,-1).split(",").map(be=>o(be,Se)).filter(be=>be!==s),Ee),$e=Pe.length;if(!$e)return s;if($e===1)return Pe[0];const pe=function(be,_){for(let B=0,Z=Pe.length;B<Z;B++)if(Pe[B](be,_))return Ee;return null},ue=Pe.find(be=>!!be.allBasenames);ue&&(pe.allBasenames=ue.allBasenames);const oe=Pe.reduce((be,_)=>_.allPaths?be.concat(_.allPaths):be,[]);return oe.length&&(pe.allPaths=oe),pe}function m(Ee,Se,Pe){const $e=A.sep===A.$gc.sep,pe=$e?Ee:Ee.replace(c,A.sep),ue=A.sep+pe,oe=A.$gc.sep+Ee;let be;return Pe?be=function(_,B){return typeof _=="string"&&(_===pe||_.endsWith(ue)||!$e&&(_===Ee||_.endsWith(oe)))?Se:null}:be=function(_,B){return typeof _=="string"&&(_===pe||!$e&&_===Ee)?Se:null},be.allPaths=[(Pe?"*/":"./")+Ee],be}function h(Ee){try{const Se=new RegExp(`^${f(Ee)}$`);return function(Pe){return Se.lastIndex=0,typeof Pe=="string"&&Se.test(Pe)?Ee:null}}catch{return s}}function P(Ee,Se,Pe){return!Ee||typeof Se!="string"?!1:W(Ee)(Se,void 0,Pe)}e.$vj=P;function W(Ee,Se={}){if(!Ee)return r;if(typeof Ee=="string"||K(Ee)){const Pe=o(Ee,Se);if(Pe===s)return r;const $e=function(pe,ue){return!!Pe(pe,ue)};return Pe.allBasenames&&($e.allBasenames=Pe.allBasenames),Pe.allPaths&&($e.allPaths=Pe.allPaths),$e}return O(Ee,Se)}e.$wj=W;function K(Ee){const Se=Ee;return Se?typeof Se.base=="string"&&typeof Se.pattern=="string":!1}e.$xj=K;function z(Ee){return Ee.allBasenames||[]}e.$yj=z;function j(Ee){return Ee.allPaths||[]}e.$zj=j;function O(Ee,Se){const Pe=ie(Object.getOwnPropertyNames(Ee).map(be=>N(be,Ee[be],Se)).filter(be=>be!==s)),$e=Pe.length;if(!$e)return s;if(!Pe.some(be=>!!be.requiresSiblings)){if($e===1)return Pe[0];const be=function(Z,ee){let ve;for(let ge=0,he=Pe.length;ge<he;ge++){const De=Pe[ge](Z,ee);if(typeof De=="string")return De;(0,M.$Gg)(De)&&(ve||(ve=[]),ve.push(De))}return ve?(async()=>{for(const ge of ve){const he=await ge;if(typeof he=="string")return he}return null})():null},_=Pe.find(Z=>!!Z.allBasenames);_&&(be.allBasenames=_.allBasenames);const B=Pe.reduce((Z,ee)=>ee.allPaths?Z.concat(ee.allPaths):Z,[]);return B.length&&(be.allPaths=B),be}const pe=function(be,_,B){let Z,ee;for(let ve=0,ge=Pe.length;ve<ge;ve++){const he=Pe[ve];he.requiresSiblings&&B&&(_||(_=(0,A.$nc)(be)),Z||(Z=_.substr(0,_.length-(0,A.$oc)(be).length)));const De=he(be,_,Z,B);if(typeof De=="string")return De;(0,M.$Gg)(De)&&(ee||(ee=[]),ee.push(De))}return ee?(async()=>{for(const ve of ee){const ge=await ve;if(typeof ge=="string")return ge}return null})():null},ue=Pe.find(be=>!!be.allBasenames);ue&&(pe.allBasenames=ue.allBasenames);const oe=Pe.reduce((be,_)=>_.allPaths?be.concat(_.allPaths):be,[]);return oe.length&&(pe.allPaths=oe),pe}function N(Ee,Se,Pe){if(Se===!1)return s;const $e=o(Ee,Pe);if($e===s)return s;if(typeof Se=="boolean")return $e;if(Se){const pe=Se.when;if(typeof pe=="string"){const ue=(oe,be,_,B)=>{if(!B||!$e(oe,be))return null;const Z=pe.replace("$(basename)",()=>_),ee=B(Z);return(0,M.$Gg)(ee)?ee.then(ve=>ve?Ee:null):ee?Ee:null};return ue.requiresSiblings=!0,ue}}return $e}function ie(Ee,Se){const Pe=Ee.filter(be=>!!be.basenames);if(Pe.length<2)return Ee;const $e=Pe.reduce((be,_)=>{const B=_.basenames;return B?be.concat(B):be},[]);let pe;if(Se){pe=[];for(let be=0,_=$e.length;be<_;be++)pe.push(Se)}else pe=Pe.reduce((be,_)=>{const B=_.patterns;return B?be.concat(B):be},[]);const ue=function(be,_){if(typeof be!="string")return null;if(!_){let Z;for(Z=be.length;Z>0;Z--){const ee=be.charCodeAt(Z-1);if(ee===47||ee===92)break}_=be.substr(Z)}const B=$e.indexOf(_);return B!==-1?pe[B]:null};ue.basenames=$e,ue.patterns=pe,ue.allBasenames=$e;const oe=Ee.filter(be=>!be.basenames);return oe.push(ue),oe}function X(Ee,Se){return(0,y.$ub)(Ee,Se,(Pe,$e)=>typeof Pe=="string"&&typeof $e=="string"?Pe===$e:typeof Pe!="string"&&typeof $e!="string"?Pe.base===$e.base&&Pe.pattern===$e.pattern:!1)}e.$Aj=X}),define(Ae[50],Re([1,0,9,121,24,16,2]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class D{constructor(i="",a=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$7)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(i,a=0){return this.value+=c(this.supportThemeIcons?(0,M.$Wj)(i):i).replace(/([ \t]+)/g,($,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,a){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(i,a,$){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(i),")"),$&&(this.value+=` "${this.c(this.c($,'"'),")")}"`),this.value+=")",this}c(i,a){const $=new RegExp((0,T.$Fe)(a),"g");return i.replace($,(E,v)=>i.charAt(v-1)!=="\\"?`\\${E}`:E)}}e.$3j=D;function g(t){return R(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$4j=g;function R(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$5j=R;function k(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$og)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$6j=k;function c(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$7j=c;function b(t){return t.replace(/"/g,"&quot;")}e.$8j=b;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$9j=p;function f(t){const i=[],a=t.split("|").map(E=>E.trim());t=a[0];const $=a[1];if($){const E=/height=(\d+)/.exec($),v=/width=(\d+)/.exec($),n=E?E[1]:"",r=v?v[1]:"",s=isFinite(parseInt(r)),o=isFinite(parseInt(n));s&&i.push(`width="${r}"`),o&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$0j=f}),define(Ae[90],Re([1,0,18,44,20,23,24,16]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=void 0;function D(o,w){const{os:d,tildify:I,relative:S}=w;if(S){const h=g(o,S,d);if(typeof h=="string")return h}let u=o.fsPath;if(d===1&&!T.$j?u=u.replace(/\//g,"\\"):d!==1&&T.$j&&(u=u.replace(/\\/g,"/")),d!==1&&I?.userHome){const h=I.userHome.fsPath;let P;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$gc.sep)?P=I.userHome.with({path:o.path}).fsPath:P=o.fsPath,u=c(P,h,d)}return(d===1?C.$fc:C.$gc).normalize(R(u,d===1))}e.$rv=D;function g(o,w,d){const I=d===1?C.$fc:C.$gc,S=d===3?A.$lg:A.$ng,u=w.getWorkspace(),m=(0,y.$Ob)(u.folders);if(!m)return;o.scheme!==m.uri.scheme&&o.path.startsWith(C.$gc.sep)&&(o=m.uri.with({path:o.path}));const h=w.getWorkspaceFolder(o);if(!h)return;let P;if(S.isEqual(h.uri,o)?P="":P=S.relativePath(h.uri,o)??"",P&&(P=I.normalize(P)),u.folders.length>1&&!w.noPrefix){const W=h.name?h.name:S.basenameOrAuthority(h.uri);P=P?`${W} \u2022 ${P}`:W}return P}function R(o,w=T.$j){return(0,M.$2f)(o,w)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$sv=R;let k=Object.create(null);function c(o,w,d=T.OS){if(d===1||!o||!w)return o;let I=k.original===w?k.normalized:void 0;I||(I=w,T.$j&&(I=(0,M.$Rf)(I)),I=`${(0,l.$Ke)(I,C.$gc.sep)}${C.$gc.sep}`,k={original:w,normalized:I});let S=o;return T.$j&&(S=(0,M.$Rf)(S)),(d===3?S.startsWith(I):(0,l.$3e)(S,I))?`~/${S.substr(I.length)}`:o}e.$tv=c;function b(o,w){return o.replace(/^~($|\/|\\)/,`${w}$1`)}e.$uv=b;const p="\u2026",f="\\\\",t="~";function i(o,w=C.sep){const d=new Array(o.length);let I=!1;for(let S=0;S<o.length;S++){const u=o[S];if(u===""){d[S]=`.${w}`;continue}if(!u){d[S]=u;continue}I=!0;let m="",h=u;h.indexOf(f)===0?(m=h.substr(0,h.indexOf(f)+f.length),h=h.substr(h.indexOf(f)+f.length)):h.indexOf(w)===0?(m=h.substr(0,h.indexOf(w)+w.length),h=h.substr(h.indexOf(w)+w.length)):h.indexOf(t)===0&&(m=h.substr(0,h.indexOf(t)+t.length),h=h.substr(h.indexOf(t)+t.length));const P=h.split(w);for(let W=1;I&&W<=P.length;W++)for(let K=P.length-W;I&&K>=0;K--){I=!1;let z=P.slice(K,K+W).join(w);for(let j=0;!I&&j<o.length;j++)if(j!==S&&o[j]&&o[j].indexOf(z)>-1){const O=K+W===P.length,N=K>0&&o[j].indexOf(w)>-1?w+z:z,ie=o[j].endsWith(N);I=!O||ie}if(!I){let j="";(P[0].endsWith(":")||m!=="")&&(K===1&&(K=0,W++,z=P[0]+w+z),K>0&&(j=P[0]+w),j=m+j),K>0&&(j=j+p+w),j=j+z,K+W<P.length&&(j=j+w+p),d[S]=j}}I&&(d[S]=u)}return d}e.$vv=i;var a;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function $(o,w=Object.create(null)){const d=[];let I=!1,S="";for(const u of o)if(u==="$"||I&&u==="{")S&&d.push({value:S,type:a.TEXT}),S="",I=!0;else if(u==="}"&&I){const m=w[S];if(typeof m=="string")m.length&&d.push({value:m,type:a.VARIABLE});else if(m){const h=d[d.length-1];(!h||h.type!==a.SEPARATOR)&&d.push({value:m.label,type:a.SEPARATOR})}S="",I=!1}else S+=u;return S&&!I&&d.push({value:S,type:a.TEXT}),d.filter((u,m)=>{if(u.type===a.SEPARATOR){const h=d[m-1],P=d[m+1];return[h,P].every(W=>W&&(W.type===a.VARIABLE||W.type===a.TEXT)&&W.value.length>0)}return!0}).map(u=>u.value).join("")}e.$wv=$;function E(o,w){return T.$k||w?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$k?"&":"&&"):o.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$xv=E;function v(o,w){return T.$k||w?o.replace(/\(&&\w\)|&&/g,""):T.$j?o.replace(/&&|&/g,d=>d==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$yv=v;function n(o){return o.replace(/&/g,"&&")}e.$zv=n;function r(o){if(o.endsWith("]")){const w=o.lastIndexOf(" [",o.length-2);if(w!==-1){const d=s(o.substring(0,w));return{name:d.name,parentPath:d.parentPath+o.substring(w)}}}return s(o)}e.$Av=r;function s(o){const w=o.indexOf("/")!==-1?C.$gc:C.$fc,d=w.basename(o),I=w.dirname(o);return d.length?{name:d,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[132],Re([1,0,26,2]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function C(k){return k.toJSON()}class T{constructor(c){this.a=c}transformIncoming(c){const b=this.a.transformIncoming(c);return b===c?c:C(M.URI.from(b))}transformOutgoing(c){const b=this.a.transformOutgoing(c);return b===c?c:C(M.URI.from(b))}transformOutgoingURI(c){const b=this.a.transformOutgoing(c);return b===c?c:M.URI.from(b)}transformOutgoingScheme(c){return this.a.transformOutgoingScheme(c)}}e.$Lm=T,e.$Mm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,c,b){if(!k||b>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return c.transformOutgoing(k);for(const p in k)if(Object.hasOwnProperty.call(k,p)){const f=A(k[p],c,b+1);f!==null&&(k[p]=f)}}return null}function l(k,c){const b=A(k,c,0);return b===null?k:b}e.$Nm=l;function D(k,c,b,p){if(!k||p>200)return null;if(typeof k=="object"){if(k.$mid===1)return b?M.URI.revive(c.transformIncoming(k)):c.transformIncoming(k);if(k instanceof y.$be)return null;for(const f in k)if(Object.hasOwnProperty.call(k,f)){const t=D(k[f],c,b,p+1);t!==null&&(k[f]=t)}}return null}function g(k,c){const b=D(k,c,!1,0);return b===null?k:b}e.$Om=g;function R(k,c){const b=D(k,c,!0,0);return b===null?k:b}e.$Pm=R}),define(Ae[133],Re([1,0,38,20]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=void 0;function C(T,A,l,D,g,R){if(Array.isArray(T)){let k=0;for(const c of T){const b=C(c,A,l,D,g,R);if(b===10)return b;b>k&&(k=b)}return k}else{if(typeof T=="string")return D?T==="*"?5:T===l?10:0:0;if(T){const{language:k,pattern:c,scheme:b,hasAccessToAllModels:p,notebookType:f}=T;if(!D&&!p)return 0;f&&g&&(A=g);let t=0;if(b)if(b===A.scheme)t=10;else if(b==="*")t=5;else return 0;if(k)if(k===l)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(f)if(f===R)t=10;else if(f==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(c){let i;if(typeof c=="string"?i=c:i={...c,base:(0,M.$hc)(c.base)},i===A.fsPath||(0,y.$vj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$sE=C}),define(Ae[91],Re([1,0,26,23]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0=e.$W0=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function T(k){for(let c=0,b=k.length;c<b;c+=4){const p=k[c+0],f=k[c+1],t=k[c+2],i=k[c+3];k[c+0]=i,k[c+1]=t,k[c+2]=f,k[c+3]=p}}function A(k){const c=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||T(c),y.$be.wrap(c)}function l(k){const c=k.buffer;if(M.$D()||T(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const b=new Uint8Array(c.byteLength);return b.set(c),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function D(k){const c=new Uint32Array(g(k));let b=0;if(c[b++]=k.id,k.type==="full")c[b++]=1,c[b++]=k.data.length,c.set(k.data,b),b+=k.data.length;else{c[b++]=2,c[b++]=k.deltas.length;for(const p of k.deltas)c[b++]=p.start,c[b++]=p.deleteCount,p.data?(c[b++]=p.data.length,c.set(p.data,b),b+=p.data.length):c[b++]=0}return A(c)}e.$W0=D;function g(k){let c=0;if(c+=1+1,k.type==="full")c+=1+k.data.length;else{c+=1,c+=(1+1+1)*k.deltas.length;for(const b of k.deltas)b.data&&(c+=b.data.length)}return c}function R(k){const c=l(k);let b=0;const p=c[b++];if(c[b++]===1){const a=c[b++],$=c.subarray(b,b+a);return b+=a,{id:p,type:"full",data:$}}const t=c[b++],i=[];for(let a=0;a<t;a++){const $=c[b++],E=c[b++],v=c[b++];let n;v>0&&(n=c.subarray(b,b+v),b+=v),i[a]={start:$,deleteCount:E,data:n}}return{id:p,type:"delta",deltas:i}}e.$X0=R}),define(Ae[134],Re([10,11]),function(ye,e){return ye.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,25,23,123,136,134]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=g;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(Q,we,Be,Oe){this.id=Q,this.name=we,this.defaultValue=Be,this.schema=Oe}applyUpdate(Q,we){return b(Q,we)}compute(Q,we,Be){return Be}}class c{constructor(Q,we){this.newValue=Q,this.didChange=we}}e.ApplyUpdateResult=c;function b(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new c(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const Be=Array.isArray(Y)&&Array.isArray(Q)&&y.$ub(Y,Q);return new c(Q,!Be)}let we=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const Oe=b(Y[Be],Q[Be]);Oe.didChange&&(Y[Be]=Oe.newValue,we=!0)}return new c(Y,we)}class p{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,we){return b(Q,we)}validate(Q){return this.defaultValue}}class f{constructor(Q,we,Be,Oe){this.id=Q,this.name=we,this.defaultValue=Be,this.schema=Oe}applyUpdate(Q,we){return b(Q,we)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,we,Be){return Be}}function t(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:!!Y}e.boolean=t;class i extends f{constructor(Q,we,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Be),super(Q,we,Be,Oe)}validate(Q){return t(Q,this.defaultValue)}}function a(Y,Q,we,Be){if(typeof Y>"u")return Q;let Oe=parseInt(Y,10);return isNaN(Oe)?Q:(Oe=Math.max(we,Oe),Oe=Math.min(Be,Oe),Oe|0)}e.clampedInt=a;class $ extends f{static clampedInt(Q,we,Be,Oe){return a(Q,we,Be,Oe)}constructor(Q,we,Be,Oe,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Oe,nt.maximum=Xe),super(Q,we,Be,nt),this.minimum=Oe,this.maximum=Xe}validate(Q){return $.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function E(Y,Q,we,Be){if(typeof Y>"u")return Q;const Oe=v.float(Y,Q);return v.clamp(Oe,we,Be)}e.clampedFloat=E;class v extends f{static clamp(Q,we,Be){return Q<we?we:Q>Be?Be:Q}static float(Q,we){if(typeof Q=="number")return Q;if(typeof Q>"u")return we;const Be=parseFloat(Q);return isNaN(Be)?we:Be}constructor(Q,we,Be,Oe,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(Q,we,Be,Xe),this.validationFn=Oe}validate(Q){return this.validationFn(v.float(Q,this.defaultValue))}}class n extends f{static string(Q,we){return typeof Q!="string"?we:Q}constructor(Q,we,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Be),super(Q,we,Be,Oe)}validate(Q){return n.string(Q,this.defaultValue)}}function r(Y,Q,we,Be){return typeof Y!="string"?Q:Be&&Y in Be?Be[Y]:we.indexOf(Y)===-1?Q:Y}e.stringSet=r;class s extends f{constructor(Q,we,Be,Oe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Oe,Xe.default=Be),super(Q,we,Be,Xe),this.c=Oe}validate(Q){return r(Q,this.defaultValue,this.c)}}class o extends k{constructor(Q,we,Be,Oe,Xe,nt,ft=void 0){typeof ft<"u"&&(ft.type="string",ft.enum=Xe,ft.default=Oe),super(Q,we,Be,ft),this.c=Xe,this.d=nt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function w(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,we,Be){return Be===0?Q.accessibilitySupport:Be}}class I extends k{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{insertSpace:t(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function u(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function h(Y){switch(Y){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function P(Y){switch(Y){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class W extends p{constructor(){super(140)}compute(Q,we,Be){const Oe=["monaco-editor"];return we.get(39)&&Oe.push(we.get(39)),Q.extraEditorClassName&&Oe.push(Q.extraEditorClassName),we.get(73)==="default"?Oe.push("mouse-default"):we.get(73)==="copy"&&Oe.push("mouse-copy"),we.get(110)&&Oe.push("showUnused"),we.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class K extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Q,we,Be){return Be&&Q.emptySelectionClipboard}}class z extends k{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:l.localize(16,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:l.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{cursorMoveOnType:t(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(we.loop,this.defaultValue.loop)}}}class j extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?j.OFF:Q==="true"?j.ON:Q:Q?j.ON:j.OFF}}e.EditorFontLigatures=j;class O extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?O.OFF:Q==="true"?O.TRANSLATE:Q:Q?O.TRANSLATE:O.OFF}compute(Q,we,Be){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends p{constructor(){super(50)}compute(Q,we,Be){return Q.fontInfo}}class ie extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Q){const we=v.float(Q,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(we,6,100)}compute(Q,we,Be){return Q.fontInfo.fontSize}}class X extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String($.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class Ee extends k{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...we},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...we},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...we},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...we},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...we},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:l.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{multiple:r(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:we.multipleDefinitions??r(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:we.multipleTypeDefinitions??r(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:we.multipleDeclarations??r(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:we.multipleImplementations??r(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:we.multipleReferences??r(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Se extends k{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:l.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),delay:$.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:t(we.sticky,this.defaultValue.sticky),hidingDelay:$.clampedInt(we.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(we.above,this.defaultValue.above)}}}var Pe;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class $e extends p{constructor(){super(143)}compute(Q,we,Be){return $e.computeLayout(we,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const we=Q.height/Q.lineHeight,Be=Math.floor(Q.paddingTop/Q.lineHeight);let Oe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Oe=Math.max(Oe,we-1));const Xe=(Be+Q.viewLineCount+Oe)/(Q.pixelRatio*Q.height),nt=Math.floor(Q.viewLineCount/Xe);return{typicalViewportLineCount:we,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Oe,desiredRatio:Xe,minimapLineCount:nt}}static c(Q,we){const Be=Q.outerWidth,Oe=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const nt=we.stableMinimapLayoutInput,ft=nt&&Q.outerHeight===nt.outerHeight&&Q.lineHeight===nt.lineHeight&&Q.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===nt.pixelRatio&&Q.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Q.paddingTop===nt.paddingTop&&Q.paddingBottom===nt.paddingBottom&&Q.minimap.enabled===nt.minimap.enabled&&Q.minimap.side===nt.minimap.side&&Q.minimap.size===nt.minimap.size&&Q.minimap.showSlider===nt.minimap.showSlider&&Q.minimap.renderCharacters===nt.minimap.renderCharacters&&Q.minimap.maxColumn===nt.minimap.maxColumn&&Q.minimap.scale===nt.minimap.scale&&Q.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Q.isViewportWrapping===nt.isViewportWrapping,wt=Q.lineHeight,Pt=Q.typicalHalfwidthCharacterWidth,Zt=Q.scrollBeyondLastLine,Gt=Q.minimap.renderCharacters;let pt=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const jt=Q.minimap.maxColumn,Nt=Q.minimap.size,Bt=Q.minimap.side,At=Q.verticalScrollbarWidth,Rt=Q.viewLineCount,Ot=Q.remainingWidth,Wt=Q.isViewportWrapping,Jt=Gt?2:3;let Kt=Math.floor(Xe*Oe);const Vt=Kt/Xe;let Mt=!1,ut=!1,dt=Jt*pt,Lt=pt/Xe,qt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Fe,extraLinesBeyondLastLine:me,desiredRatio:H,minimapLineCount:Me}=$e.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Zt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Oe,lineHeight:wt,pixelRatio:Xe});if(Rt/Me>1)Mt=!0,ut=!0,pt=1,dt=1,Lt=pt/Xe;else{let Je=!1,Ve=pt+1;if(Nt==="fit"){const et=Math.ceil((Fe+Rt+me)*dt);Wt&&ft&&Ot<=we.stableFitRemainingWidth?(Je=!0,Ve=we.stableFitMaxMinimapScale):Je=et>Kt}if(Nt==="fill"||Je){Mt=!0;const et=pt;dt=Math.min(wt*Xe,Math.max(1,Math.floor(1/H))),Wt&&ft&&Ot<=we.stableFitRemainingWidth&&(Ve=we.stableFitMaxMinimapScale),pt=Math.min(Ve,Math.max(1,Math.floor(dt/Jt))),pt>et&&(qt=Math.min(2,pt/et)),Lt=pt/Xe/qt,Kt=Math.ceil(Math.max(Ce,Fe+Rt+me)*dt),Wt?(we.stableMinimapLayoutInput=Q,we.stableFitRemainingWidth=Ot,we.stableFitMaxMinimapScale=pt):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const kt=Math.floor(jt*Lt),at=Math.min(kt,Math.max(0,Math.floor((Ot-At-2)*Lt/(Pt+Lt)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(Xe*at);const Ht=vt/Xe;vt=Math.floor(vt*qt);const Ct=Gt?1:2,We=Bt==="left"?0:Be-at-At;return{renderMinimap:Ct,minimapLeft:We,minimapWidth:at,minimapHeightIsEditorHeight:Mt,minimapIsSampling:ut,minimapScale:pt,minimapLineHeight:dt,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:Vt}}static computeLayout(Q,we){const Be=we.outerWidth|0,Oe=we.outerHeight|0,Xe=we.lineHeight|0,nt=we.lineNumbersDigitCount|0,ft=we.typicalHalfwidthCharacterWidth,wt=we.maxDigitWidth,Pt=we.pixelRatio,Zt=we.viewLineCount,Gt=Q.get(135),pt=Gt==="inherit"?Q.get(134):Gt,jt=pt==="inherit"?Q.get(130):pt,Nt=Q.get(133),Bt=we.isDominatedByLongLines,At=Q.get(57),Rt=Q.get(67).renderType!==0,Ot=Q.get(68),Wt=Q.get(104),Jt=Q.get(83),Kt=Q.get(72),Vt=Q.get(102),Mt=Vt.verticalScrollbarSize,ut=Vt.verticalHasArrows,dt=Vt.arrowSize,Lt=Vt.horizontalScrollbarSize,qt=Q.get(43),kt=Q.get(109)!=="never";let at=Q.get(65);qt&&kt&&(at+=16);let vt=0;if(Rt){const zt=Math.max(nt,Ot);vt=Math.round(zt*wt)}let Ht=0;At&&(Ht=Xe*we.glyphMarginDecorationLaneCount);let Ct=0,We=Ct+Ht,Ce=We+vt,Fe=Ce+at;const me=Be-Ht-vt-at;let H=!1,Me=!1,je=-1;pt==="inherit"&&Bt?(H=!0,Me=!0):jt==="on"||jt==="bounded"?Me=!0:jt==="wordWrapColumn"&&(je=Nt);const Je=$e.c({outerWidth:Be,outerHeight:Oe,lineHeight:Xe,typicalHalfwidthCharacterWidth:ft,pixelRatio:Pt,scrollBeyondLastLine:Wt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Kt,verticalScrollbarWidth:Mt,viewLineCount:Zt,remainingWidth:me,isViewportWrapping:Me},we.memory||new R);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ct+=Je.minimapWidth,We+=Je.minimapWidth,Ce+=Je.minimapWidth,Fe+=Je.minimapWidth);const Ve=me-Je.minimapWidth,et=Math.max(1,Math.floor((Ve-Mt-2)/ft)),bt=ut?dt:0;return Me&&(je=Math.max(1,et),jt==="bounded"&&(je=Math.min(je,Nt))),{width:Be,height:Oe,glyphMarginLeft:Ct,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:we.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:vt,decorationsLeft:Ce,decorationsWidth:at,contentLeft:Fe,contentWidth:Ve,minimap:Je,viewportColumn:et,isWordWrapMinified:H,isViewportWrapping:Me,wrappingColumn:je,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:Lt,overviewRuler:{top:bt,width:Mt,height:Oe-2*bt,right:0}}}}e.EditorLayoutInfoComputer=$e;class pe extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Q){return r(Q,"simple",["simple","advanced"])}compute(Q,we,Be){return we.get(2)===2?"advanced":Be}}class ue extends k{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:l.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class oe extends k{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:l.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),maxLineCount:$.clampedInt(we.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(we.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(we.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class be extends k{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:l.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return typeof we.enabled=="boolean"&&(we.enabled=we.enabled?"on":"off"),{enabled:r(we.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:$.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(we.fontFamily,this.defaultValue.fontFamily),padding:t(we.padding,this.defaultValue.padding)}}}class _ extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):$.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,we,Be){return Be<0?$.clampedInt(-Be*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class B extends v{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>v.clamp(Q,0,150),{markdownDescription:l.localize(63,null)})}compute(Q,we,Be){return Q.fontInfo.lineHeight}}class Z extends k{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:Q.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:l.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),autohide:t(we.autohide,this.defaultValue.autohide),size:r(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(we.side,this.defaultValue.side,["right","left"]),showSlider:r(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(we.renderCharacters,this.defaultValue.renderCharacters),scale:$.clampedInt(we.scale,1,1,3),maxColumn:$.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(Y){return Y==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class ve extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{top:$.clampedInt(we.top,0,0,1e3),bottom:$.clampedInt(we.bottom,0,0,1e3)}}}class ge extends k{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:l.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),cycle:t(we.cycle,this.defaultValue.cycle)}}}class he extends p{constructor(){super(141)}compute(Q,we,Be){return Q.pixelRatio}}class De extends k{constructor(){const Q={other:"on",comments:"off",strings:"off"},we=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:we,default:Q.strings,description:l.localize(82,null)},comments:{anyOf:we,default:Q.comments,description:l.localize(83,null)},other:{anyOf:we,default:Q.other,description:l.localize(84,null)}},default:Q,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Pt=Q?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:we,comments:Be,strings:Oe}=Q,Xe=["on","inline","off"];let nt,ft,wt;return typeof we=="boolean"?nt=we?"on":"off":nt=r(we,this.defaultValue.other,Xe),typeof Be=="boolean"?ft=Be?"on":"off":ft=r(Be,this.defaultValue.comments,Xe),typeof Oe=="boolean"?wt=Oe?"on":"off":wt=r(Oe,this.defaultValue.strings,Xe),{other:nt,comments:ft,strings:wt}}}var re;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class le extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(Q){let we=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(we=4,Be=Q):Q==="interval"?we=3:Q==="relative"?we=2:Q==="on"?we=1:we=0),{renderType:we,renderFn:Be}}}function ne(Y){const Q=Y.get(97);return Q==="editable"?Y.get(90):Q!=="on"}e.filterValidationDecorations=ne;class ae extends k{constructor(){const Q=[],we={type:"number",description:l.localize(91,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:Q,description:l.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const we=[];for(const Be of Q)if(typeof Be=="number")we.push({column:$.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Oe=Be;we.push({column:$.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return we.sort((Be,Oe)=>Be.column-Oe.column),we}return this.defaultValue}}class fe extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ie(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:l.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q,Be=$.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=$.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:$.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(we.vertical,this.defaultValue.vertical),horizontal:Ie(we.horizontal,this.defaultValue.horizontal),useShadows:t(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:$.clampedInt(we.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:$.clampedInt(we.verticalSliderSize,Oe,0,1e3),scrollByPage:t(we.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends k{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:l.localize(111,null)}})}applyUpdate(Q,we){let Be=!1;we.allowedCharacters&&Q&&(M.$$m(Q.allowedCharacters,we.allowedCharacters)||(Q={...Q,allowedCharacters:we.allowedCharacters},Be=!0)),we.allowedLocales&&Q&&(M.$$m(Q.allowedLocales,we.allowedLocales)||(Q={...Q,allowedLocales:we.allowedLocales},Be=!0));const Oe=super.applyUpdate(Q,we);return Be?new c(Oe.newValue,!0):Oe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{nonBasicASCII:x(we.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(we.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(we.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(we.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(we.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,we){if(typeof Q!="object"||!Q)return we;const Be={};for(const[Oe,Xe]of Object.entries(Q))Xe===!0&&(Be[Oe]=!0);return Be}}class G extends k{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:l.localize(116,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),mode:r(we.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(we.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(we.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(we.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends k{constructor(){const Q={enabled:T.$4r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$4r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(we.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends k{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:Q.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:Q.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:Q.highlightActiveIndentation,description:l.localize(132,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{bracketPairs:x(we.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(we.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(we.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(we.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(we.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Y,Q,we){const Be=we.indexOf(Y);return Be===-1?Q:we[Be]}class ce extends k{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:Q.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Q.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{insertMode:r(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(we.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(we.showIcons,this.defaultValue.showIcons),showStatusBar:t(we.showStatusBar,this.defaultValue.showStatusBar),preview:t(we.preview,this.defaultValue.preview),previewMode:r(we.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(we.showMethods,this.defaultValue.showMethods),showFunctions:t(we.showFunctions,this.defaultValue.showFunctions),showConstructors:t(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(we.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(we.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(we.showFields,this.defaultValue.showFields),showVariables:t(we.showVariables,this.defaultValue.showVariables),showClasses:t(we.showClasses,this.defaultValue.showClasses),showStructs:t(we.showStructs,this.defaultValue.showStructs),showInterfaces:t(we.showInterfaces,this.defaultValue.showInterfaces),showModules:t(we.showModules,this.defaultValue.showModules),showProperties:t(we.showProperties,this.defaultValue.showProperties),showEvents:t(we.showEvents,this.defaultValue.showEvents),showOperators:t(we.showOperators,this.defaultValue.showOperators),showUnits:t(we.showUnits,this.defaultValue.showUnits),showValues:t(we.showValues,this.defaultValue.showValues),showConstants:t(we.showConstants,this.defaultValue.showConstants),showEnums:t(we.showEnums,this.defaultValue.showEnums),showEnumMembers:t(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(we.showKeywords,this.defaultValue.showKeywords),showWords:t(we.showWords,this.defaultValue.showWords),showColors:t(we.showColors,this.defaultValue.showColors),showFiles:t(we.showFiles,this.defaultValue.showFiles),showReferences:t(we.showReferences,this.defaultValue.showReferences),showFolders:t(we.showFolders,this.defaultValue.showFolders),showTypeParameters:t(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(we.showSnippets,this.defaultValue.showSnippets),showUsers:t(we.showUsers,this.defaultValue.showUsers),showIssues:t(we.showIssues,this.defaultValue.showIssues)}}}class Ne extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,we,Be){return we.get(2)===2?0:Be}}class Ge extends p{constructor(){super(144)}compute(Q,we,Be){const Oe=we.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class xe extends k{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),showDropSelector:r(we.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends k{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),showPasteSelector:r(we.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?it:C.$l?tt:_e,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var st;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:ze(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:ze(new d),accessibilityPageSize:ze(new $(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new n(4,"ariaLabel",l.localize(200,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:ze(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:ze(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:ze(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:ze(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:ze(new J),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:ze(new n(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:ze(new $(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:ze(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:ze(new $(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:ze(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:l.localize(242,null)})),cursorSurroundingLines:ze(new $(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:ze(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:ze(new $(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:ze(new K),dropIntoEditor:ze(new xe),stickyScroll:ze(new oe),experimentalWhitespaceRendering:ze(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:ze(new n(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new v(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:l.localize(253,null)})),find:ze(new z),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:ze(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:ze(new $(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:ze(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new j),fontSize:ze(new ie),fontWeight:ze(new X),fontVariations:ze(new O),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:ze(new Ee),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:ze(new Se),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new v(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>v.clamp(Y,-5,20),{description:l.localize(267,null)})),lightbulb:ze(new ue),lineDecorationsWidth:ze(new _),lineHeight:ze(new B),lineNumbers:ze(new le),lineNumbersMinChars:ze(new $(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:ze(new i(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:ze(new s(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:ze(new Z),mouseStyle:ze(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new v(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:ze(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:ze(new $(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:ze(new i(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:ze(new $(82,"overviewRulerLanes",3,0,3)),padding:ze(new ve),pasteAs:ze(new Ye),parameterHints:ze(new ge),peekWidgetDefaultFocus:ze(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:ze(new De),quickSuggestionsDelay:ze(new $(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new fe),renameOnType:ze(new i(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:ze(new s(94,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:ze(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:ze(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:ze(new $(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:ze(new ae),scrollbar:ze(new F),scrollBeyondLastColumn:ze(new $(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$l})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:ze(new be),snippetSuggestions:ze(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:ze(new $(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ce),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:ze(new $(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new $(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:ze(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:ze(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:ze(new $(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new V),unusualLineTerminators:ze(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:ze(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:ze(new n(129,"wordSeparators",A.$5r,{description:l.localize(337,null)})),wordWrap:ze(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new $(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:ze(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:ze(new he),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:ze(new $e),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new pe)}}),define(Ae[137],Re([10,11]),function(ye,e){return ye.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([10,11]),function(ye,e){return ye.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([10,11]),function(ye,e){return ye.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([10,11]),function(ye,e){return ye.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([10,11]),function(ye,e){return ye.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([10,11]),function(ye,e){return ye.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([10,11]),function(ye,e){return ye.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([10,11]),function(ye,e){return ye.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([10,11]),function(ye,e){return ye.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Re([10,11]),function(ye,e){return ye.create("vs/workbench/common/editor",e)}),define(Ae[160],Re([10,11]),function(ye,e){return ye.create("vs/workbench/common/views",e)}),define(Ae[161],Re([10,11]),function(ye,e){return ye.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Re([10,11]),function(ye,e){return ye.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Re([10,11]),function(ye,e){return ye.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Re([10,11]),function(ye,e){return ye.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Re([10,11]),function(ye,e){return ye.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Re([10,11]),function(ye,e){return ye.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Re([10,11]),function(ye,e){return ye.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Re([1,0,9,139]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var C;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(C||(e.TokenType=C={}));function T(...g){switch(g.length){case 1:return(0,M.localize)(0,null,g[0]);case 2:return(0,M.localize)(1,null,g[0],g[1]);case 3:return(0,M.localize)(2,null,g[0],g[1],g[2]);default:return}}const A=(0,M.localize)(3,null),l=(0,M.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(T("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(T("&&"));break;case 124:this.h(124)?this.k(16):this.l(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const k=this.d,c=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:c};this.g.push({offset:k,lexeme:c,additionalInfo:R}),this.f.push(b)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const k=this.c.substring(this.d,this.e),c=D.b.get(k);c?this.k(c):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,k=!1,c=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(l);return}const p=this.c.charCodeAt(R);if(k)k=!1;else if(p===47&&!c){R++;break}else p===91?c=!0:p===92?k=!0:p===93&&(c=!1);R++}for(;R<this.c.length&&D.a.has(this.c.charCodeAt(R));)R++;this.e=R;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=D}),define(Ae[169],Re([1,0,24,29,141,279]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||A.test(i)}e.$Mo=D;function g(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=i.match(A);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$No=g;function R(i){if(!i)return null;const a=i.majorBase,$=i.majorMustEqual,E=i.minorBase;let v=i.minorMustEqual;const n=i.patchBase;let r=i.patchMustEqual;i.hasCaret&&(a===0||(v=!1),r=!1);let s=0;if(i.preRelease){const o=l.exec(i.preRelease);if(o){const[,w,d,I]=o;s=Date.UTC(Number(w),Number(d)-1,Number(I))}}return{majorBase:a,majorMustEqual:$,minorBase:E,minorMustEqual:v,patchBase:n,patchMustEqual:r,isMinimum:i.hasGreaterEquals,notBefore:s}}e.$Oo=R;function k(i,a,$){let E;typeof i=="string"?E=R(g(i)):E=i;let v;a instanceof Date?v=a.getTime():typeof a=="string"&&(v=new Date(a).getTime());let n;if(typeof $=="string"?n=R(g($)):n=$,!E||!n)return!1;const r=E.majorBase,s=E.minorBase,o=E.patchBase;let w=n.majorBase,d=n.minorBase,I=n.patchBase;const S=n.notBefore;let u=n.majorMustEqual,m=n.minorMustEqual,h=n.patchMustEqual;return n.isMinimum?r>w?!0:r<w?!1:s>d?!0:s<d||v&&v<S?!1:o>=I:(r===1&&w===0&&(!u||!m||!h)&&(w=1,d=0,I=0,u=!0,m=!1,h=!1),r<w?!1:r>w?!u:s<d?!1:s>d?!m:o<I?!1:o>I?!h:!(v&&v<S))}e.$Po=k;function c(i,a,$,E,v){const n=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return n.push([M.default.Error,C.localize(0,null)]),n;if(typeof E.name!="string")return n.push([M.default.Error,C.localize(1,null,"name")]),n;if(typeof E.version!="string")return n.push([M.default.Error,C.localize(2,null,"version")]),n;if(!E.engines)return n.push([M.default.Error,C.localize(3,null,"engines")]),n;if(typeof E.engines.vscode!="string")return n.push([M.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof E.extensionDependencies<"u"&&!t(E.extensionDependencies))return n.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof E.activationEvents<"u"){if(!t(E.activationEvents))return n.push([M.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof E.main>"u"&&typeof E.browser>"u")return n.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),n}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&n.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return n.push([M.default.Error,C.localize(9,null,"main")]),n;{const o=(0,y.$vg)($,E.main);(0,y.$pg)(o,$)||n.push([M.default.Warning,C.localize(10,null,o.path,$.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return n.push([M.default.Error,C.localize(11,null,"browser")]),n;{const o=(0,y.$vg)($,E.browser);(0,y.$pg)(o,$)||n.push([M.default.Warning,C.localize(12,null,o.path,$.path)])}}if(!T.valid(E.version))return n.push([M.default.Error,C.localize(13,null)]),n;const r=[];if(!b(i,a,E,v,r))for(const o of r)n.push([M.default.Error,o]);return n}e.$Qo=c;function b(i,a,$,E,v){return E||typeof $.main>"u"&&typeof $.browser>"u"?!0:f(i,a,$.engines.vscode,v)}e.$Ro=b;function p(i,a,$){return i==="*"||f(a,$,i)}e.$So=p;function f(i,a,$,E=[]){const v=R(g($));if(!v)return E.push(C.localize(14,null,$)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return E.push(C.localize(15,null,$)),!1}else if(!v.majorMustEqual)return E.push(C.localize(16,null,$)),!1;return k(i,a,v)?!0:(E.push(C.localize(17,null,i,$)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let a=0,$=i.length;a<$;a++)if(typeof i[a]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class y{constructor(C,T=[],A=!1){this.ctor=C,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$Mh=y}),define(Ae[70],Re([1,0,69]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.InstantiationType=void 0;const M=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function T(l,D,g){D instanceof y.$Mh||(D=new y.$Mh(D,[],!!g)),M.push([l,D])}e.$xr=T;function A(){return M}e.$yr=A}),define(Ae[170],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class y{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$cq=y;class M{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const l=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(A);l.outgoing.set(D.key,D),D.incoming.set(l.key,l)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let l=this.a.get(A);return l||(l=new y(A,T),this.a.set(A,l)),l}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,l]of this.a)T.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const l=new Set([T]),D=this.c(A,l);if(D)return D}}c(T,A){for(const[l,D]of T.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const g=this.c(D,A);if(g)return g;A.delete(l)}}}e.$dq=M}),define(Ae[4],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(y||(e._util=y={})),e.$Oh=C("instantiationService");function M(A,l,D){l[y.DI_TARGET]===l?l[y.DI_DEPENDENCIES].push({id:A,index:D}):(l[y.DI_DEPENDENCIES]=[{id:A,index:D}],l[y.DI_TARGET]=l)}function C(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const l=function(D,g,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(l,D,R)};return l.toString=()=>A,y.serviceIds.set(A,l),l}e.$Ph=C;function T(A){return A}e.$Qh=T}),define(Ae[45],Re([1,0,15,2,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,C.$Ph)("configurationService");function T(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof M.URI)}e.$ki=T;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof M.URI)}e.$li=A;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=D;function g(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ni=g;function R(i,a){const $=Object.create(null);for(const E in i)k($,E,i[E],a);return $}e.$oi=R;function k(i,a,$,E){const v=a.split("."),n=v.pop();let r=i;for(let s=0;s<v.length;s++){const o=v[s];let w=r[o];switch(typeof w){case"undefined":w=r[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${a} as ${v.slice(0,s+1).join(".")} is ${JSON.stringify(w)}`);return}r=w}if(typeof r=="object"&&r!==null)try{r[n]=$}catch{E(`Ignoring ${a} as ${v.join(".")} is ${JSON.stringify(r)}`)}else E(`Ignoring ${a} as ${v.join(".")} is ${JSON.stringify(r)}`)}e.$pi=k;function c(i,a){const $=a.split(".");b(i,$)}e.$qi=c;function b(i,a){const $=a.shift();if(a.length===0){delete i[$];return}if(Object.keys(i).indexOf($)!==-1){const E=i[$];typeof E=="object"&&!Array.isArray(E)&&(b(E,a),Object.keys(E).length===0&&delete i[$])}}function p(i,a,$){function E(r,s){let o=r;for(const w of s){if(typeof o!="object"||o===null)return;o=o[w]}return o}const v=a.split("."),n=E(i,v);return typeof n>"u"?$:n}e.$ri=p;function f(i,a,$){Object.keys(a).forEach(E=>{E!=="__proto__"&&(E in i?y.$Af(i[E])&&y.$Af(a[E])?f(i[E],a[E],$):$&&(i[E]=a[E]):i[E]=a[E])})}e.$si=f;function t(i){return i.replace(/[\[\]]/g,"")}e.$ti=t}),define(Ae[32],Re([1,0,23,16,168,4,138,9]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",y.$k),D.set("isLinux",y.$l),D.set("isWindows",y.$j),D.set("isWeb",y.$p),D.set("isMacNative",y.$k&&!y.$p),D.set("isEdge",y.$H),D.set("isFirefox",y.$F),D.set("isChrome",y.$E),D.set("isSafari",y.$G);function g(_,B){if(D.get(_)!==void 0)throw(0,l.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(_,B)}e.$Li=g;const R=Object.prototype.hasOwnProperty;var k;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const c={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),p=(0,A.localize)(1,null),f=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),a=(0,A.localize)(5,null),$=(0,A.localize)(6,null),E=(0,A.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=c){this.k=B,this.d=new C.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const Z=this.l();if(!this.E()){const ee=this.D(),ve=ee.type===17?a:void 0;throw this.h.push({message:i,offset:ee.offset,lexeme:C.$Ki.getLexeme(ee),additionalInfo:ve}),v.c}return Z}catch(Z){if(Z!==v.c)throw Z;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const Z=this.o();B.push(Z)}return B.length===1?B[0]:n.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const Z=this.s();B.push(Z)}return B.length===1?B[0]:n.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const Z=this.l();return this.A(1,t),Z?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const Z=this.l();return this.A(1,t),Z}case 17:{const Z=B.lexeme;if(this.z(),this.y(9)){const ve=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ve.type!==10)throw this.B("REGEX",ve);const ge=ve.lexeme,he=ge.lastIndexOf("/"),De=he===ge.length-1?void 0:this.w(ge.substring(he+1));let re;try{re=new RegExp(ge.substring(1,he),De)}catch{throw this.B("REGEX",ve)}return N.create(Z,re)}switch(ve.type){case 10:case 19:{const ge=[ve.lexeme];this.z();let he=this.D(),De=0;for(let fe=0;fe<ve.lexeme.length;fe++)ve.lexeme.charCodeAt(fe)===40?De++:ve.lexeme.charCodeAt(fe)===41&&De--;for(;!this.E()&&he.type!==15&&he.type!==16;){switch(he.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let fe=0;fe<he.lexeme.length;fe++)he.lexeme.charCodeAt(fe)===40?De++:ve.lexeme.charCodeAt(fe)===41&&De--}if(De<0)break;ge.push(C.$Ki.getLexeme(he)),this.z(),he=this.D()}const re=ge.join(""),le=re.lastIndexOf("/"),ne=le===re.length-1?void 0:this.w(re.substring(le+1));let ae;try{ae=new RegExp(re.substring(1,le),ne)}catch{throw this.B("REGEX",ve)}return n.regex(Z,ae)}case 18:{const ge=ve.lexeme;this.z();let he=null;if(!(0,M.$Be)(ge)){const De=ge.indexOf("/"),re=ge.lastIndexOf("/");if(De!==re&&De>=0){const le=ge.slice(De+1,re),ne=ge[re+1]==="i"?"i":"";try{he=new RegExp(le,ne)}catch{throw this.B("REGEX",ve)}}}if(he===null)throw this.B("REGEX",ve);return N.create(Z,he)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const ve=this.u();return n.notIn(Z,ve)}switch(this.D().type){case 3:{this.z();const ve=this.u();if(this.x().type===18)return n.equals(Z,ve);switch(ve){case"true":return n.has(Z);case"false":return n.not(Z);default:return n.equals(Z,ve)}}case 4:{this.z();const ve=this.u();if(this.x().type===18)return n.notEquals(Z,ve);switch(ve){case"true":return n.not(Z);case"false":return n.has(Z);default:return n.notEquals(Z,ve)}}case 5:return this.z(),j.create(Z,this.u());case 6:return this.z(),O.create(Z,this.u());case 7:return this.z(),K.create(Z,this.u());case 8:return this.z(),z.create(Z,this.u());case 13:return this.z(),n.in(Z,this.u());default:return n.has(Z)}}case 20:throw this.h.push({message:$,offset:B.offset,lexeme:"",additionalInfo:E}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,Z){if(this.C(B))return this.z();throw this.B(Z,this.D())}B(B,Z,ee){const ve=(0,A.localize)(8,null,B,C.$Ki.getLexeme(Z)),ge=Z.offset,he=C.$Ki.getLexeme(Z);return this.h.push({message:ve,offset:ge,lexeme:he,additionalInfo:ee}),v.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=v;class n{static false(){return w.INSTANCE}static true(){return d.INSTANCE}static has(B){return I.create(B)}static equals(B,Z){return S.create(B,Z)}static notEquals(B,Z){return h.create(B,Z)}static regex(B,Z){return N.create(B,Z)}static in(B,Z){return u.create(B,Z)}static notIn(B,Z){return m.create(B,Z)}static not(B){return P.create(B)}static and(...B){return Ee.create(B,null,!0)}static or(...B){return Se.create(B,null,!0)}static greater(B,Z){return K.create(B,Z)}static greaterEquals(B,Z){return z.create(B,Z)}static smaller(B,Z){return j.create(B,Z)}static smallerEquals(B,Z){return O.create(B,Z)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Ni=n;function r(_){const B=new v({regexParsingWithErrorRecovery:!1});return _.map(Z=>(B.parse(Z),B.lexingErrors.length>0?B.lexingErrors.map(ee=>({errorMessage:ee.additionalInfo?(0,A.localize)(9,null,ee.additionalInfo):(0,A.localize)(10,null),offset:ee.offset,length:ee.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ee=>({errorMessage:ee.additionalInfo?`${ee.message}. ${ee.additionalInfo}`:ee.message,offset:ee.offset,length:ee.lexeme.length})):[]))}e.$Oi=r;function s(_,B){const Z=_?_.substituteConstants():void 0,ee=B?B.substituteConstants():void 0;return!Z&&!ee?!0:!Z||!ee?!1:Z.equals(ee)}e.$Pi=s;function o(_,B){return _.cmp(B)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return d.INSTANCE}}e.$Qi=w;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return w.INSTANCE}}e.$Ri=d;class I{static create(B,Z=null){const ee=D.get(B);return typeof ee=="boolean"?ee?d.INSTANCE:w.INSTANCE:new I(B,Z)}constructor(B,Z){this.key=B,this.c=Z,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=D.get(this.key);return typeof B=="boolean"?B?d.INSTANCE:w.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Si=I;class S{static create(B,Z,ee=null){if(typeof Z=="boolean")return Z?I.create(B,ee):P.create(B,ee);const ve=D.get(B);return typeof ve=="boolean"?Z===(ve?"true":"false")?d.INSTANCE:w.INSTANCE:new S(B,Z,ee)}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=D.get(this.c);if(typeof B=="boolean"){const Z=B?"true":"false";return this.d===Z?d.INSTANCE:w.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.$Ti=S;class u{static create(B,Z){return new u(B,Z)}constructor(B,Z){this.d=B,this.f=Z,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const Z=B.getValue(this.f),ee=B.getValue(this.d);return Array.isArray(Z)?Z.includes(ee):typeof ee=="string"&&typeof Z=="object"&&Z!==null?R.call(Z,ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Ui=u;class m{static create(B,Z){return new m(B,Z)}constructor(B,Z){this.d=B,this.f=Z,this.type=11,this.c=u.create(B,Z)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=m;class h{static create(B,Z,ee=null){if(typeof Z=="boolean")return Z?P.create(B,ee):I.create(B,ee);const ve=D.get(B);return typeof ve=="boolean"?Z===(ve?"true":"false")?w.INSTANCE:d.INSTANCE:new h(B,Z,ee)}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=D.get(this.c);if(typeof B=="boolean"){const Z=B?"true":"false";return this.d===Z?w.INSTANCE:d.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Wi=h;class P{static create(B,Z=null){const ee=D.get(B);return typeof ee=="boolean"?ee?w.INSTANCE:d.INSTANCE:new P(B,Z)}constructor(B,Z){this.c=B,this.d=Z,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=D.get(this.c);return typeof B=="boolean"?B?w.INSTANCE:d.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Xi=P;function W(_,B){if(typeof _=="string"){const Z=parseFloat(_);isNaN(Z)||(_=Z)}return typeof _=="string"||typeof _=="number"?B(_):w.INSTANCE}class K{static create(B,Z,ee=null){return W(Z,ve=>new K(B,ve,ee))}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Yi=K;class z{static create(B,Z,ee=null){return W(Z,ve=>new z(B,ve,ee))}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Zi=z;class j{static create(B,Z,ee=null){return W(Z,ve=>new j(B,ve,ee))}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$1i=j;class O{static create(B,Z,ee=null){return W(Z,ve=>new O(B,ve,ee))}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$2i=O;class N{static create(B,Z){return new N(B,Z)}constructor(B,Z){this.d=B,this.f=Z,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const Z=this.f?this.f.source:"",ee=B.f?B.f.source:"";return Z<ee?-1:Z>ee?1:0}equals(B){if(B.type===this.type){const Z=this.f?this.f.source:"",ee=B.f?B.f.source:"";return this.d===B.d&&Z===ee}return!1}substituteConstants(){return this}evaluate(B){const Z=B.getValue(this.d);return this.f?this.f.test(Z):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$3i=N;class ie{static create(B){return new ie(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new ie(this.c.map(B))}negate(){return this.c}}e.$4i=ie;function X(_){let B=null;for(let Z=0,ee=_.length;Z<ee;Z++){const ve=_[Z].substituteConstants();if(_[Z]!==ve&&B===null){B=[];for(let ge=0;ge<Z;ge++)B[ge]=_[ge]}B!==null&&(B[Z]=ve)}return B===null?_:B}class Ee{static create(B,Z,ee){return Ee.d(B,Z,ee)}constructor(B,Z){this.expr=B,this.c=Z,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let Z=0,ee=this.expr.length;Z<ee;Z++){const ve=o(this.expr[Z],B.expr[Z]);if(ve!==0)return ve}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].equals(B.expr[Z]))return!1;return!0}return!1}substituteConstants(){const B=X(this.expr);return B===this.expr?this:Ee.create(B,this.c,!1)}evaluate(B){for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].evaluate(B))return!1;return!0}static d(B,Z,ee){const ve=[];let ge=!1;for(const he of B)if(he){if(he.type===1){ge=!0;continue}if(he.type===0)return w.INSTANCE;if(he.type===6){ve.push(...he.expr);continue}ve.push(he)}if(ve.length===0&&ge)return d.INSTANCE;if(ve.length!==0){if(ve.length===1)return ve[0];ve.sort(o);for(let he=1;he<ve.length;he++)ve[he-1].equals(ve[he])&&(ve.splice(he,1),he--);if(ve.length===1)return ve[0];for(;ve.length>1;){const he=ve[ve.length-1];if(he.type!==9)break;ve.pop();const De=ve.pop(),re=ve.length===0,le=Se.create(he.expr.map(ne=>Ee.create([ne,De],null,ee)),null,re);le&&(ve.push(le),ve.sort(o))}if(ve.length===1)return ve[0];if(ee){for(let he=0;he<ve.length;he++)for(let De=he+1;De<ve.length;De++)if(ve[he].negate().equals(ve[De]))return w.INSTANCE;if(ve.length===1)return ve[0]}return new Ee(ve,Z)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const Z of this.expr)B.push(...Z.keys());return B}map(B){return new Ee(this.expr.map(Z=>Z.map(B)),null)}negate(){if(!this.c){const B=[];for(const Z of this.expr)B.push(Z.negate());this.c=Se.create(B,this,!0)}return this.c}}e.$5i=Ee;class Se{static create(B,Z,ee){return Se.d(B,Z,ee)}constructor(B,Z){this.expr=B,this.c=Z,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let Z=0,ee=this.expr.length;Z<ee;Z++){const ve=o(this.expr[Z],B.expr[Z]);if(ve!==0)return ve}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].equals(B.expr[Z]))return!1;return!0}return!1}substituteConstants(){const B=X(this.expr);return B===this.expr?this:Se.create(B,this.c,!1)}evaluate(B){for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(this.expr[Z].evaluate(B))return!0;return!1}static d(B,Z,ee){let ve=[],ge=!1;if(B){for(let he=0,De=B.length;he<De;he++){const re=B[he];if(re){if(re.type===0){ge=!0;continue}if(re.type===1)return d.INSTANCE;if(re.type===9){ve=ve.concat(re.expr);continue}ve.push(re)}}if(ve.length===0&&ge)return w.INSTANCE;ve.sort(o)}if(ve.length!==0){if(ve.length===1)return ve[0];for(let he=1;he<ve.length;he++)ve[he-1].equals(ve[he])&&(ve.splice(he,1),he--);if(ve.length===1)return ve[0];if(ee){for(let he=0;he<ve.length;he++)for(let De=he+1;De<ve.length;De++)if(ve[he].negate().equals(ve[De]))return d.INSTANCE;if(ve.length===1)return ve[0]}return new Se(ve,Z)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const Z of this.expr)B.push(...Z.keys());return B}map(B){return new Se(this.expr.map(Z=>Z.map(B)),null)}negate(){if(!this.c){const B=[];for(const Z of this.expr)B.push(Z.negate());for(;B.length>1;){const Z=B.shift(),ee=B.shift(),ve=[];for(const ge of be(Z))for(const he of be(ee))ve.push(Ee.create([ge,he],null,!1));B.unshift(Se.create(ve,null,!1))}this.c=Se.create(B,this,!0)}return this.c}}e.$6i=Se;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(B,Z,ee){super(B,null),this.f=Z,typeof ee=="object"?Pe.d.push({...ee,key:B}):ee!==!0&&Pe.d.push({key:B,description:ee,type:Z!=null?typeof Z:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return h.create(this.key,B)}}e.$7i=Pe,e.$8i=(0,T.$Ph)("contextKeyService");function $e(_,B){return _<B?-1:_>B?1:0}function pe(_,B,Z,ee){return _<Z?-1:_>Z?1:B<ee?-1:B>ee?1:0}function ue(_,B){if(_.type===0||B.type===1)return!0;if(_.type===9)return B.type===9?oe(_.expr,B.expr):!1;if(B.type===9){for(const Z of B.expr)if(ue(_,Z))return!0;return!1}if(_.type===6){if(B.type===6)return oe(B.expr,_.expr);for(const Z of _.expr)if(ue(Z,B))return!0;return!1}return _.equals(B)}e.$9i=ue;function oe(_,B){let Z=0,ee=0;for(;Z<_.length&&ee<B.length;){const ve=_[Z].cmp(B[ee]);if(ve<0)return!1;ve===0&&Z++,ee++}return Z===_.length}function be(_){return _.type===9?_.expr:[_]}}),define(Ae[171],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,y.$Ph)("environmentService"),e.$Xh=(0,y.$Qh)(e.$Wh)}),define(Ae[92],Re([1,0,140,4]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$$n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function C(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=C;function T(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=T;function A(a,$){switch(a){case 3:return $==="x64"?"win32-x64":$==="ia32"?"win32-ia32":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=A;function l(a,$){return $==="web"&&!a.includes("web")}e.$7n=l;function D(a,$,E){return l($,E)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===E?!0:g(E).includes(a)}e.$8n=D;function g(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$9n=g;function R(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$0n=R;var k;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var c;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var b;(function(a){a.Install="install",a.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var p;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$$n=(0,M.$Ph)("extensionGalleryService");var f;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var t;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor($,E){super($),this.code=E,this.name=E}}e.$_n=i,e.$ao=(0,M.$Ph)("extensionManagementService"),e.$bo="extensionsIdentifiers/disabled",e.$co="extensionsIdentifiers/enabled",e.$do=(0,M.$Ph)("IGlobalExtensionEnablementService"),e.$eo=(0,M.$Ph)("IExtensionTipsService"),e.$fo=(0,y.localize)(0,null),e.$go={value:e.$fo,original:"Extensions"},e.$ho={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Ae[39],Re([1,0,49,20,16,15,2,142,4,23,13,42]),function(ye,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,D.$Ph)("fileService");function c(ue){return ue.create===!0}e.$_j=c;var b;(function(ue){ue[ue.Unknown=0]="Unknown",ue[ue.File=1]="File",ue[ue.Directory=2]="Directory",ue[ue.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var p;(function(ue){ue[ue.Readonly=1]="Readonly",ue[ue.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function f(ue){const oe=ue;return!!oe&&typeof oe.onDidChange=="function"}e.$ak=f;var t;(function(ue){ue[ue.None=0]="None",ue[ue.FileReadWrite=2]="FileReadWrite",ue[ue.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ue[ue.FileReadStream=16]="FileReadStream",ue[ue.FileFolderCopy=8]="FileFolderCopy",ue[ue.PathCaseSensitive=1024]="PathCaseSensitive",ue[ue.Readonly=2048]="Readonly",ue[ue.Trash=4096]="Trash",ue[ue.FileWriteUnlock=8192]="FileWriteUnlock",ue[ue.FileAtomicRead=16384]="FileAtomicRead",ue[ue.FileAtomicWrite=32768]="FileAtomicWrite",ue[ue.FileAtomicDelete=65536]="FileAtomicDelete",ue[ue.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(ue){return!!(ue.capabilities&2)}e.$bk=i;function a(ue){return!!(ue.capabilities&8)}e.$ck=a;function $(ue){return!!(ue.capabilities&131072)}e.$dk=$;function E(ue){return!!(ue.capabilities&4)}e.$ek=E;function v(ue){return!!(ue.capabilities&16)}e.$fk=v;function n(ue){return i(ue)?!!(ue.capabilities&16384):!1}e.$gk=n;function r(ue){return i(ue)?!!(ue.capabilities&32768):!1}e.$hk=r;function s(ue){return!!(ue.capabilities&65536)}e.$ik=s;function o(ue){return!!(ue.capabilities&2048)}e.$jk=o;var w;(function(ue){ue.FileExists="EntryExists",ue.FileNotFound="EntryNotFound",ue.FileNotADirectory="EntryNotADirectory",ue.FileIsADirectory="EntryIsADirectory",ue.FileExceedsStorageQuota="EntryExceedsStorageQuota",ue.FileTooLarge="EntryTooLarge",ue.FileWriteLocked="EntryWriteLocked",ue.NoPermissions="NoPermissions",ue.Unavailable="Unavailable",ue.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class d extends Error{static create(oe,be){const _=new d(oe.toString(),be);return u(_,be),_}constructor(oe,be){super(oe),this.code=be}}e.$kk=d;function I(ue,oe){return d.create(ue,oe)}e.$lk=I;function S(ue){return ue||I((0,l.localize)(0,null),w.Unknown)}e.$mk=S;function u(ue,oe){return ue.name=oe?`${oe} (FileSystemError)`:"FileSystemError",ue}e.$nk=u;function m(ue){if(!ue)return w.Unknown;if(ue instanceof d)return ue.code;const oe=/^(.+) \(FileSystemError\)$/.exec(ue.name);if(!oe)return w.Unknown;switch(oe[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.$ok=m;function h(ue){if(ue instanceof O)return ue.fileOperationResult;switch(m(ue)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}e.$pk=h;var P;(function(ue){ue[ue.CREATE=0]="CREATE",ue[ue.DELETE=1]="DELETE",ue[ue.MOVE=2]="MOVE",ue[ue.COPY=3]="COPY",ue[ue.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class W{constructor(oe,be,_){this.resource=oe,this.operation=be,this.target=_}isOperation(oe){return this.operation===oe}}e.$qk=W;var K;(function(ue){ue[ue.UPDATED=0]="UPDATED",ue[ue.ADDED=1]="ADDED",ue[ue.DELETED=2]="DELETED"})(K||(e.FileChangeType=K={}));class z{static{this.a=null}constructor(oe,be){this.c=be,this.b=void 0,this.d=new k.$V(()=>{const _=y.$Vh.forUris(()=>this.c);return _.fill(this.rawAdded.map(B=>[B,!0])),_}),this.f=new k.$V(()=>{const _=y.$Vh.forUris(()=>this.c);return _.fill(this.rawUpdated.map(B=>[B,!0])),_}),this.g=new k.$V(()=>{const _=y.$Vh.forUris(()=>this.c);return _.fill(this.rawDeleted.map(B=>[B,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of oe){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==z.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(oe,...be){return this.h(oe,{includeChildren:!1},...be)}affects(oe,...be){return this.h(oe,{includeChildren:!0},...be)}h(oe,be,..._){if(!oe)return!1;const B=_.length>0;return!!((!B||_.includes(1))&&(this.d.value.get(oe)||be.includeChildren&&this.d.value.findSuperstr(oe))||(!B||_.includes(0))&&(this.f.value.get(oe)||be.includeChildren&&this.f.value.findSuperstr(oe))||(!B||_.includes(2))&&(this.g.value.findSubstr(oe)||be.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$rk=z;function j(ue,oe,be){return!ue||!oe||ue===oe||oe.length>ue.length?!1:(oe.charAt(oe.length-1)!==M.sep&&(oe+=M.sep),be?(0,C.$3e)(ue,oe):ue.indexOf(oe)===0)}e.$sk=j;class O extends Error{constructor(oe,be,_){super(oe),this.fileOperationResult=be,this.options=_}}e.$tk=O;class N extends O{constructor(oe,be,_,B){super(oe,be,B),this.fileOperationResult=be,this.size=_}}e.$uk=N;class ie extends O{constructor(oe,be,_){super(oe,2,_),this.stat=be}}e.$vk=ie;var X;(function(ue){ue[ue.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ue[ue.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ue[ue.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ue[ue.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ue[ue.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ue[ue.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ue[ue.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ue[ue.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ue[ue.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ue[ue.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ue[ue.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var Ee;(function(ue){ue[ue.FILE=0]="FILE",ue[ue.FOLDER=1]="FOLDER",ue[ue.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ee||(e.FileKind=Ee={})),e.$Dk="";function Se(ue){if(!(typeof ue.size!="number"||typeof ue.mtime!="number"))return ue.mtime.toString(29)+ue.size.toString(31)}e.$Ek=Se;async function Pe(ue,oe){if(!oe.hasProvider(A.URI.from({scheme:ue.scheme})))return new Promise(be=>{const _=oe.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ue.scheme&&B.added&&(_.dispose(),be())})})}e.$Fk=Pe;class $e{static{this.KB=1024}static{this.MB=$e.KB*$e.KB}static{this.GB=$e.MB*$e.KB}static{this.TB=$e.GB*$e.KB}static formatSize(oe){return(0,T.$Cf)(oe)||(oe=0),oe<$e.KB?(0,l.localize)(1,null,oe.toFixed(0)):oe<$e.MB?(0,l.localize)(2,null,(oe/$e.KB).toFixed(2)):oe<$e.GB?(0,l.localize)(3,null,(oe/$e.MB).toFixed(2)):oe<$e.TB?(0,l.localize)(4,null,(oe/$e.GB).toFixed(2)):(0,l.localize)(5,null,(oe/$e.TB).toFixed(2))}}e.$Gk=$e;function pe(ue){const oe=typeof ue=="string"||ue?.scheme===R.Schemas.vscodeRemote;return typeof ue!="string"&&ue?.scheme===R.Schemas.file?1024*$e.MB:oe?10*$e.MB:g.$p?50*$e.MB:1024*$e.MB}e.$Hk=pe}),define(Ae[71],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class y{constructor(...C){this.a=new Map;for(const[T,A]of C)this.set(T,A)}set(C,T){const A=this.a.get(C);return this.a.set(C,T),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Nh=y}),define(Ae[172],Re([1,0,12,9,6,69,170,4,71,173]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;const R=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class c{constructor(t=new D.$Nh,i=!1,a,$=R){this.f=t,this.g=i,this.h=a,this.i=$,this.o=new Set,this.f.set(l.$Oh,this),this._globalGraph=$?a?._globalGraph??new A.$dq(E=>E):void 0}createChild(t){return new c(t,this.g,this,this.i)}invokeFunction(t,...i){const a=p.traceInvocation(this.i,t);let $=!1;try{return t({get:v=>{if($)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const n=this.m(v,a);if(!n)throw new Error(`[invokeFunction] unknown service '${v}'`);return n}},...i)}finally{$=!0,a.stop()}}createInstance(t,...i){let a,$;return t instanceof T.$Mh?(a=p.traceCreation(this.i,t.ctor),$=this.j(t.ctor,t.staticArguments.concat(i),a)):(a=p.traceCreation(this.i,t),$=this.j(t,i,a)),a.stop(),$}j(t,i=[],a){const $=l._util.getServiceDependencies(t).sort((n,r)=>n.index-r.index),E=[];for(const n of $){const r=this.m(n.id,a);r||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),E.push(r)}const v=$.length>0?$[0].index:i.length;if(i.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${i.length} static arguments`);const n=v-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,v)}return Reflect.construct(t,i.concat(E))}k(t,i){if(this.f.get(t)instanceof T.$Mh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const a=this.l(t);return a instanceof T.$Mh?this.q(t,a,i.branch(t,!0)):(i.branch(t,!1),a)}q(t,i,a){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,a)}finally{this.o.delete(t)}}r(t,i,a){const $=new A.$dq(n=>n.id.toString());let E=0;const v=[{id:t,desc:i,_trace:a}];for(;v.length;){const n=v.pop();if($.lookupOrInsertNode(n),E++>1e3)throw new k($);for(const r of l._util.getServiceDependencies(n.desc.ctor)){const s=this.l(r.id);if(s||this.u(`[createInstance] ${t} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),s instanceof T.$Mh){const o={id:r.id,desc:s,_trace:n._trace.branch(r.id,!0)};$.insertEdge(n,o),v.push(o)}}}for(;;){const n=$.roots();if(n.length===0){if(!$.isEmpty())throw new k($);break}for(const{data:r}of n){if(this.l(r.id)instanceof T.$Mh){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}$.removeNode(r)}}return this.l(t)}s(t,i,a=[],$,E){if(this.f.get(t)instanceof T.$Mh)return this.t(t,i,a,$,E);if(this.h)return this.h.s(t,i,a,$,E);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,a=[],$,E){if($){const v=new c(void 0,this.g,this,this.i);v.c=String(t);const n=new Map,r=new y.$$g(()=>{const s=v.j(i,a,E);for(const[o,w]of n){const d=s[o];if(typeof d=="function")for(const I of w)d.apply(s,I)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=n.get(o);return I||(I=new g.$2c,n.set(o,I)),(u,m,h)=>{const P=I.push([u,m,h]);return(0,C.$Qc)(P)}}if(o in s)return s[o];const w=r.value;let d=w[o];return typeof d!="function"||(d=d.bind(w),s[o]=d),d},set(s,o,w){return r.value[o]=w,!0},getPrototypeOf(s){return i.prototype}})}else return this.j(i,a,E)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$eq=c;var b;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(b||(b={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,i){return t?new p(1,i.name):p.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const a=new p(3,t.toString());return this.h.push([t,i,a]),a}stop(){const t=Date.now()-this.g;p.f+=t;let i=!1;function a(E,v){const n=[],r=new Array(E+1).join("	");for(const[s,o,w]of v.h)if(o&&w){i=!0,n.push(`${r}CREATES -> ${s}`);const d=a(E+1,w);d&&n.push(d)}else n.push(`${r}uses -> ${s}`);return n.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||i)&&p.all.add($.join(`
`))}}e.$fq=p}),define(Ae[14],Re([1,0,37,5,93,6,28,23,24,15,2,32,4]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,c.$Ph)("logService"),e.$$i=(0,c.$Ph)("loggerService");function b(){return new Date().toISOString()}function p(u){return(0,g.$Cf)(u)}e.$_i=p;var f;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$aj=f.Info;function t(u,m,h){switch(m){case f.Trace:u.trace(h);break;case f.Debug:u.debug(h);break;case f.Info:u.info(h);break;case f.Warning:u.warn(h);break;case f.Error:u.error(h);break;case f.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=t;function i(u,m=!1){let h="";for(let P=0;P<u.length;P++){let W=u[P];if(W instanceof Error&&(W=(0,y.$Ai)(W,m)),typeof W=="object")try{W=JSON.stringify(W)}catch{}h+=(P>0?" ":"")+W}return h}class a extends T.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new M.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==f.Off&&this.b<=m}}e.$cj=a;class $ extends a{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...h){this.f(f.Trace)&&this.g(f.Trace,i([m,...h],!0))}debug(m,...h){this.f(f.Debug)&&this.g(f.Debug,i([m,...h]))}info(m,...h){this.f(f.Info)&&this.g(f.Info,i([m,...h]))}warn(m,...h){this.f(f.Warning)&&this.g(f.Warning,i([m,...h]))}error(m,...h){if(this.f(f.Error))if(m instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=m.stack,this.g(f.Error,i(P))}else this.g(f.Error,i([m,...h]))}flush(){}}e.$dj=$;class E extends a{constructor(m=e.$aj){super(),this.setLevel(m),this.g=!l.$j}trace(m,...h){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,m,...h):console.log(`[main ${b()}]`,m,...h))}debug(m,...h){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,m,...h):console.log(`[main ${b()}]`,m,...h))}info(m,...h){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,m,...h):console.log(`[main ${b()}]`,m,...h))}warn(m,...h){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,m,...h):console.warn(`[main ${b()}]`,m,...h))}error(m,...h){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,m,...h):console.error(`[main ${b()}]`,m,...h))}dispose(){}flush(){}}e.$ej=E;class v extends a{constructor(m=e.$aj,h=!0){super(),this.g=h,this.setLevel(m)}trace(m,...h){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...h):console.log(m,...h))}debug(m,...h){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...h):console.log(m,...h))}info(m,...h){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...h):console.log(m,...h))}warn(m,...h){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...h):console.log(m,...h))}error(m,...h){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...h):console.error(m,...h))}dispose(){}flush(){}}e.$fj=v;class n extends a{constructor(m,h=e.$aj){super(),this.g=m,this.setLevel(h)}trace(m,...h){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(m),...h])}debug(m,...h){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(m),...h])}info(m,...h){this.f(f.Info)&&this.g.log(f.Info,[this.h(m),...h])}warn(m,...h){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(m),...h])}error(m,...h){this.f(f.Error)&&this.g.log(f.Error,[this.h(m),...h])}h(m){return typeof m=="string"?m:(0,y.$Ai)(m,this.f(f.Trace))}dispose(){}flush(){}}e.$gj=n;class r extends a{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const h of this.g)h.setLevel(m);super.setLevel(m)}trace(m,...h){for(const P of this.g)P.trace(m,...h)}debug(m,...h){for(const P of this.g)P.debug(m,...h)}info(m,...h){for(const P of this.g)P.info(m,...h)}warn(m,...h){for(const P of this.g)P.warn(m,...h)}error(m,...h){for(const P of this.g)P.error(m,...h)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose()}}e.$hj=r;class s extends T.$Sc{constructor(m,h,P){if(super(),this.h=m,this.j=h,this.b=new A.$Ac,this.c=this.B(new M.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Nd),this.onDidChangeVisibility=this.g.event,P)for(const W of P)this.b.set(W.resource,{logger:void 0,info:W})}m(m){return(0,g.$yf)(m)?[...this.b.values()].find(h=>h.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,h){const P=this.n(m),W=(0,g.$yf)(m)?m:h?.id??(0,C.$Di)(P.toString()).toString(16);let K=this.b.get(P)?.logger;const z=h?.logLevel==="always"?f.Trace:h?.logLevel;K||(K=this.s(P,z??this.getLogLevel(P)??this.h,{...h,id:W}));const j={logger:K,info:{resource:P,id:W,logLevel:z,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId,when:h?.when}};return this.registerLogger(j.info),this.b.set(P,j),K}n(m){return(0,g.$yf)(m)?(0,D.$vg)(this.j,`${m}.log`):m}setLogLevel(m,h){if(R.URI.isUri(m)){const P=m,W=h,K=this.b.get(P);K&&W!==K.info.logLevel&&(K.info.logLevel=W===this.h?void 0:W,K.logger?.setLevel(W),this.b.set(K.info.resource,K),this.f.fire([P,W]))}else{this.h=m;for(const[P,W]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,h){const P=this.m(m);P&&h!==!P.info.hidden&&(P.info.hidden=!h,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,h]))}getLogLevel(m){let h;return m&&(h=this.b.get(m)?.info.logLevel),h??this.h}registerLogger(m){const h=this.b.get(m.resource);h?h.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const h=this.b.get(m);h&&(h.logger&&h.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[h.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=s;class o{constructor(){this.onDidChangeLogLevel=new M.$Nd().event}setLevel(m){}getLevel(){return f.Info}trace(m,...h){}debug(m,...h){}info(m,...h){}warn(m,...h){}error(m,...h){}critical(m,...h){}dispose(){}flush(){}}e.$jj=o;class w extends o{}e.$kj=w;function d(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const m=S(u.logLevel.toLowerCase());if(m!==void 0)return m}return e.$aj}e.$lj=d;function I(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$mj=I;function S(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$nj=S,e.$oj=new k.$7i("logLevel",I(f.Info))}),define(Ae[174],Re([1,0,6,14]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;class C extends y.$Sc{constructor(A,l=[]){super(),this.a=new M.$hj([A,...l]),this.B(A.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$EN=C}),define(Ae[94],Re([1,0,29,143,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(D){function g(p,f){return f-p}D.compare=g;const R=Object.create(null);R[D.Error]=(0,M.localize)(0,null),R[D.Warning]=(0,M.localize)(1,null),R[D.Info]=(0,M.localize)(2,null);function k(p){return R[p]||""}D.toString=k;function c(p){switch(p){case y.default.Error:return D.Error;case y.default.Warning:return D.Warning;case y.default.Info:return D.Info;case y.default.Ignore:return D.Hint}}D.fromSeverity=c;function b(p){switch(p){case D.Error:return y.default.Error;case D.Warning:return y.default.Warning;case D.Info:return y.default.Info;case D.Hint:return y.default.Ignore}}D.toSeverity=b}(A||(e.MarkerSeverity=A={}));var l;(function(D){const g="";function R(c){return k(c,!0)}D.makeKey=R;function k(c,b){const p=[g];return c.source?p.push(c.source.replace("\xA6","\\\xA6")):p.push(g),c.code?typeof c.code=="string"?p.push(c.code.replace("\xA6","\\\xA6")):p.push(c.code.value.replace("\xA6","\\\xA6")):p.push(g),c.severity!==void 0&&c.severity!==null?p.push(A.toString(c.severity)):p.push(g),c.message&&b?p.push(c.message.replace("\xA6","\\\xA6")):p.push(g),c.startLineNumber!==void 0&&c.startLineNumber!==null?p.push(c.startLineNumber.toString()):p.push(g),c.startColumn!==void 0&&c.startColumn!==null?p.push(c.startColumn.toString()):p.push(g),c.endLineNumber!==void 0&&c.endLineNumber!==null?p.push(c.endLineNumber.toString()):p.push(g),c.endColumn!==void 0&&c.endColumn!==null?p.push(c.endColumn.toString()):p.push(g),p.push(g),p.join("\xA6")}D.makeKeyOptionalMessage=k})(l||(e.IMarkerData=l={})),e.$at=(0,C.$Ph)("markerService")}),define(Ae[175],Re([1,0,5,29,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3u=e.$2u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$1u=e.Severity=void 0,e.Severity=M.default,e.$1u=(0,C.$Ph)("notificationService");var T;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class D{constructor(){this.progress=new g,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$2u=D;class g{infinite(){}done(){}total(k){}worked(k){}}e.$3u=g}),define(Ae[95],Re([1,0,16,2,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gU=e.$fU=e.$eU=e.$dU=e.$cU=void 0,e.$cU=(0,C.$Ph)("openerService");function T(g,R){return M.URI.isUri(g)?(0,y.$2e)(g.scheme,R):(0,y.$3e)(g,R+":")}e.$dU=T;function A(g,...R){return R.some(k=>T(g,k))}e.$eU=A;function l(g,R){return g.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$fU=l;function D(g){let R;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return k&&(R={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},g=g.with({fragment:""})),{selection:R,uri:g}}e.$gU=D}),define(Ae[176],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,y.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ye,e,y,M){var C=arguments.length,T=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,y):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ye,e,y,M);else for(var l=ye.length-1;l>=0;l--)(A=ye[l])&&(T=(C<3?A(T):C>3?A(e,y,T):A(e,y))||T);return C>3&&T&&Object.defineProperty(e,y,T),T},Ke=this&&this.__param||function(ye,e){return function(y,M){e(y,M,ye)}};define(Ae[51],Re([1,0,12,19,6,4]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.ProgressLocation=e.$4u=void 0,e.$4u=(0,T.$Ph)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$5u=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(k,c){this.e=k,this.report=c?.async?this.g.bind(this):this.f.bind(this)}f(k){this.a=k,this.e(this.a)}g(k){this.b?this.b.push(k):this.b=[k],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const k=this.b.shift();this.a=k,await this.e(this.a)}}finally{this.c=!1;const k=this.d;this.d=void 0,k?.()}}drain(){return this.c?new Promise(k=>{const c=this.d;this.d=()=>{c?.(),k()}}):Promise.resolve()}}e.$6u=l;let D=class extends C.$Sc{constructor(k,c){super(),this.a=new y.$ch,c.withProgress(k,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,C.$Qc)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};e.$7u=D,e.$7u=D=qe([Ke(1,e.$4u)],D);class g extends C.$Sc{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new C.$Rc)}start(k){this.stop();const c=++this.a,b=new M.$Xd;return this.f=setTimeout(()=>{c===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,C.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Qc)(()=>b.cancel())),this.b.add((0,C.$Qc)(()=>this.c?this.c.done():void 0)),{id:c,token:b.token,stop:()=>this.h(c),isCurrent:()=>this.a===c}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.$8u=g,e.$9u=(0,T.$Ph)("editorProgressService")}),define(Ae[30],Re([1,0,52,15]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class C{constructor(){this.a=new Map}add(A,l){y.ok(M.$yf(A)),y.ok(M.$Af(l)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$gn=new C}),define(Ae[72],Re([1,0,5,30]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class T{constructor(){this.b=new y.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,g){this.a[C(D)]=g,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const A=new T;M.$gn.add(e.$hn.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,15,137,45,72,30]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var g;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$ln={Configuration:"base.contributions.configuration"};var R;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const k=D.$gn.as(l.$hn.JSONContribution);class c{constructor(){this.h=new Set,this.i=new M.$Nd,this.onDidSchemaChange=this.i.event,this.j=new M.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const s=new Set;this.n(n,r,s),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(n){const r=new Set;this.o(n,r),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const s=new Set;this.o(r,s),this.n(n,!1,s),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const s=[];for(const{overrides:o,source:w}of n)for(const d in o)if(r.add(d),e.$vn.test(d)){const I=this.a.get(d),S=I?.valuesSources??new Map;if(w)for(const P of Object.keys(o[d]))S.set(P,w);const u={...I?.value||{},...o[d]};this.a.set(d,{source:w,value:u,valuesSources:S});const m=(0,A.$ti)(d),h={type:"object",default:u,description:T.localize(1,null,m),$ref:e.$sn,defaultDefaultValue:u,source:C.$yf(w)?void 0:w,defaultValueSource:w};s.push(...f(d)),this.d[d]=h,this.b.properties[d]=h}else{this.a.set(d,{value:o[d],source:w});const I=this.d[d];I&&(this.w(d,I),this.r(d,I))}this.m(s)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:s,source:o}of n)for(const w in s){const d=this.a.get(w),I=C.$yf(o)?o:o?.id,S=C.$yf(d?.source)?d?.source:d?.source?.id;if(I===S)if(r.add(w),this.a.delete(w),e.$vn.test(w))delete this.d[w],delete this.b.properties[w];else{const u=this.d[w];u&&(this.w(w,u),this.r(w,u))}}this.u()}deltaConfiguration(n){let r=!1;const s=new Set;n.removedDefaults&&(this.l(n.removedDefaults,s),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,s),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,s),n.addedConfigurations&&this.n(n.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,s){n.forEach(o=>{this.p(o,r,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(n,r){const s=o=>{if(o.properties)for(const w in o.properties){r.add(w);const d=this.d[w];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[w],this.s(w,o.properties[w])}o.allOf?.forEach(w=>s(w))};for(const o of n){s(o);const w=this.c.indexOf(o);w!==-1&&this.c.splice(w,1)}}p(n,r=!0,s,o,w=3,d){w=C.$Hf(n.scope)?w:n.scope;const I=n.properties;if(I)for(const u in I){const m=I[u];if(r&&$(u,m)){delete I[u];continue}if(m.source=s,m.defaultDefaultValue=I[u].default,this.w(u,m),e.$vn.test(u)?m.scope=void 0:(m.scope=C.$Hf(m.scope)?w:m.scope,m.restricted=C.$Hf(m.restricted)?!!o?.includes(u):m.restricted),I[u].hasOwnProperty("included")&&!I[u].included){this.f[u]=I[u],delete I[u];continue}else this.d[u]=I[u],I[u].policy?.name&&this.e.set(I[u].policy.name,u);!I[u].deprecationMessage&&I[u].markdownDeprecationMessage&&(I[u].deprecationMessage=I[u].markdownDeprecationMessage),d.add(u)}const S=n.allOf;if(S)for(const u of S)this.p(u,r,s,o,w,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=s=>{const o=s.properties;if(o)for(const d in o)this.r(d,o[d]);s.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$mn.properties[n]=r,r.scope){case 1:e.$nn.properties[n]=r;break;case 2:e.$on.properties[n]=r;break;case 6:e.$pn.properties[n]=r;break;case 3:e.$qn.properties[n]=r;break;case 4:e.$rn.properties[n]=r;break;case 5:e.$rn.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$mn.properties[n],r.scope){case 1:delete e.$nn.properties[n];break;case 2:delete e.$on.properties[n];break;case 6:delete e.$pn.properties[n];break;case 3:delete e.$qn.properties[n];break;case 4:case 5:delete e.$rn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,s={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$sn};this.w(r,s),e.$mn.properties[r]=s,e.$nn.properties[r]=s,e.$on.properties[r]=s,e.$pn.properties[r]=s,e.$qn.properties[r]=s,e.$rn.properties[r]=s}}v(){const n={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=n,e.$nn.patternProperties[e.$un]=n,e.$on.patternProperties[e.$un]=n,e.$pn.patternProperties[e.$un]=n,e.$qn.patternProperties[e.$un]=n,e.$rn.patternProperties[e.$un]=n,this.i.fire()}w(n,r){const s=this.a.get(n);let o=s?.value,w=s?.source;C.$Ff(o)&&(o=r.defaultDefaultValue,w=void 0),C.$Ff(o)&&(o=i(r.type)),r.default=o,r.defaultValueSource=w}}const b="\\[([^\\]]+)\\]",p=new RegExp(b,"g");e.$un=`^(${b})+$`,e.$vn=new RegExp(e.$un);function f(v){const n=[];if(e.$vn.test(v)){let r=p.exec(v);for(;r?.length;){const s=r[1].trim();s&&n.push(s),r=p.exec(v)}}return(0,y.$Mb)(n)}e.$wn=f;function t(v){return v.reduce((n,r)=>`${n}[${r}]`,"")}e.$xn=t;function i(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=i;const a=new c;D.$gn.add(e.$ln.Configuration,a);function $(v,n){return v.trim()?e.$vn.test(v)?T.localize(7,null,v):a.getConfigurationProperties()[v]!==void 0?T.localize(8,null,v):n.policy?.name&&a.getPolicyConfigurations().get(n.policy?.name)!==void 0?T.localize(9,null,v,n.policy?.name,a.getPolicyConfigurations().get(n.policy?.name)):null:T.localize(6,null)}e.$zn=$;function E(){const v=[],n=a.getConfigurationProperties();for(const r of Object.keys(n))v.push([r,n[r].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$An=E}),define(Ae[177],Re([1,0,18,5,115,6,28,25,15,2,45,96,30]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function b(r){return Object.isFrozen(r)?r:l.$8m(r)}class p{constructor(s={},o=[],w=[],d){this.b=s,this.c=o,this.d=w,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof p)return o;const w=new f("");return w.parseRaw(o),w.configurationModel});this.f=s.reduce((o,w)=>w===o?w:o.merge(w),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$ri)(this.contents,s):this.contents}inspect(s,o){const w=this.rawConfiguration.getValue(s),d=o?this.rawConfiguration.getOverrideValue(s,o):void 0,I=o?this.rawConfiguration.override(o).getValue(s):w;return{value:w,override:d,merged:I}}getOverrideValue(s,o){const w=this.i(o);return w?s?(0,R.$ri)(w,s):w:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const w of this.overrides)w.identifiers.includes(s)&&o.push(...w.keys);return y.$Mb(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return y.$Mb(s)}override(s){let o=this.a.get(s);return o||(o=this.g(s),this.a.set(s,o)),o}merge(...s){const o=l.$7m(this.contents),w=l.$7m(this.overrides),d=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const S of s)if(I.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(o,S.contents);for(const u of S.overrides){const[m]=w.filter(h=>y.$ub(h.identifiers,u.identifiers));m?(this.h(m.contents,u.contents),m.keys.push(...u.keys),m.keys=y.$Mb(m.keys)):w.push(l.$7m(u))}for(const u of S.keys)d.indexOf(u)===-1&&d.push(u)}return new p(o,d,w,I.every(S=>S instanceof p)?void 0:I)}g(s){const o=this.i(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const w={};for(const d of y.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[d];const S=o[d];S&&(typeof I=="object"&&typeof S=="object"?(I=l.$7m(I),this.h(I,S)):I=S),w[d]=I}return new p(w,this.keys,this.overrides)}h(s,o){for(const w of Object.keys(o)){if(w in s&&D.$Af(s[w])&&D.$Af(o[w])){this.h(s[w],o[w]);continue}s[w]=l.$7m(o[w])}}i(s){let o=null,w=null;const d=I=>{I&&(w?this.h(w,I):w=l.$7m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===s?o=I.contents:I.identifiers.includes(s)&&d(I.contents);return d(o),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.j(s,o,!0)}setValue(s,o){this.j(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,R.$qi)(this.contents,s),k.$vn.test(s)&&this.overrides.splice(this.overrides.findIndex(w=>y.$ub(w.identifiers,(0,k.$wn)(s))),1))}j(s,o,w){(0,R.$pi)(this.contents,s,o,d=>console.error(d)),w=w||this.keys.indexOf(s)===-1,w&&this.keys.push(s),k.$vn.test(s)&&this.overrides.push({identifiers:(0,k.$wn)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$oi)(this.contents[s],d=>console.error(d))})}}e.$Bn=p;class f{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!D.$Hf(s)){const w=this.g(s);this.parseRaw(w,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:w,keys:d,overrides:I,restricted:S,hasExcludedProperties:u}=this.h(s,o);this.b=new p(w,d,I,u?[s]:void 0),this.c=S||[]}g(s){let o={},w=null,d=[];const I=[],S=[];function u(h){Array.isArray(d)?d.push(h):w!==null&&(d[w]=h)}const m={onObjectBegin:()=>{const h={};u(h),I.push(d),d=h,w=null},onObjectProperty:h=>{w=h},onObjectEnd:()=>{d=I.pop()},onArrayBegin:()=>{const h=[];u(h),I.push(d),d=h,w=null},onArrayEnd:()=>{d=I.pop()},onLiteralValue:u,onError:(h,P,W)=>{S.push({error:h,offset:P,length:W})}};if(s)try{C.$4m(s,m),o=d[0]||{}}catch(h){console.error(`Error while parsing settings file ${this.f}: ${h}`),this.d=[h]}return o}h(s,o){const w=c.$gn.as(k.$ln.Configuration).getConfigurationProperties(),d=this.i(s,w,!0,o);s=d.raw;const I=(0,R.$oi)(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),S=Object.keys(s),u=this.j(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:I,keys:S,overrides:u,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(s,o,w,d){let I=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:I};const S={},u=[];for(const m in s)if(k.$vn.test(m)&&w){const h=this.i(s[m],o,!1,d);S[m]=h.raw,I=I||h.hasExcludedProperties,u.push(...h.restricted)}else{const h=o[m],P=h?typeof h.scope<"u"?h.scope:3:void 0;h?.restricted&&u.push(m),!d.exclude?.includes(m)&&(d.include?.includes(m)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&h?.restricted))?S[m]=s[m]:I=!0}return{raw:S,restricted:u,hasExcludedProperties:I}}j(s,o){const w=[];for(const d of Object.keys(s))if(k.$vn.test(d)){const I={};for(const S in s[d])I[S]=s[d][S];w.push({identifiers:(0,k.$wn)(d),keys:Object.keys(I),contents:(0,R.$oi)(I,o)})}return w}}e.$Cn=f;class t extends T.$Sc{constructor(s,o,w,d){super(),this.c=s,this.f=o,this.g=d,this.b=this.B(new M.$Nd),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&w.isEqual(I.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=t;class i{constructor(s,o,w,d,I,S,u,m,h,P,W,K,z){this.a=s,this.b=o,this.c=w,this.overrideIdentifiers=d,this.d=I,this.f=S,this.g=u,this.h=m,this.i=h,this.j=P,this.k=W,this.l=K,this.m=z}get value(){return b(this.c)}n(s,o,w){const d=s.inspect(o,w);return{get value(){return b(d.value)},get override(){return b(d.override)},get merged(){return b(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(s,o,w,d,I=new p,S=new p,u=new A.$Ac,m=new p,h=new A.$Ac){this.c=s,this.d=o,this.f=w,this.g=d,this.h=I,this.i=S,this.j=u,this.l=m,this.m=h,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,o,w){return this.q(s,o,w).getValue(s)}updateValue(s,o,w={}){let d;w.resource?(d=this.m.get(w.resource),d||(d=new p,this.m.set(w.resource,d))):d=this.l,o===void 0?d.removeValue(s):d.setValue(s,o),w.resource||(this.a=null)}inspect(s,o,w){const d=this.q(s,o,w),I=this.u(o.resource,w),S=o.resource?this.m.get(o.resource)||this.l:this.l,u=new Set;for(const m of d.overrides)for(const h of m.identifiers)d.getOverrideValue(s,h)!==void 0&&u.add(h);return new i(s,o,d.getValue(s),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,I||void 0,S)}keys(s){const o=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.j.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const w=[];if(!o){const{added:d,updated:I,removed:S}=v(this.c,s);o=[...d,...I,...S]}for(const d of o)for(const I of(0,k.$wn)(d)){const S=this.c.getKeysForOverrideIdentifier(I),u=s.getKeysForOverrideIdentifier(I),m=[...u.filter(h=>S.indexOf(h)===-1),...S.filter(h=>u.indexOf(h)===-1),...S.filter(h=>!l.$$m(this.c.override(I).getValue(h),s.override(I).getValue(h)))];w.push([I,m])}return this.updateDefaultConfiguration(s),{keys:o,overrides:w}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:w,removed:d}=v(this.d,s),I=[...o,...w,...d];return I.length&&this.updatePolicyConfiguration(s),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:w,removed:d,overrides:I}=v(this.applicationConfiguration,s),S=[...o,...w,...d];return S.length&&this.updateApplicationConfiguration(s),{keys:S,overrides:I}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:w,removed:d,overrides:I}=v(this.localUserConfiguration,s),S=[...o,...w,...d];return S.length&&this.updateLocalUserConfiguration(s),{keys:S,overrides:I}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:w,removed:d,overrides:I}=v(this.remoteUserConfiguration,s),S=[...o,...w,...d];return S.length&&this.updateRemoteUserConfiguration(s),{keys:S,overrides:I}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:w,removed:d,overrides:I}=v(this.workspaceConfiguration,s),S=[...o,...w,...d];return S.length&&this.updateWorkspaceConfiguration(s),{keys:S,overrides:I}}compareAndUpdateFolderConfiguration(s,o){const w=this.p.get(s),{added:d,updated:I,removed:S,overrides:u}=v(w,o),m=[...d,...I,...S];return(m.length||!w)&&this.updateFolderConfiguration(s,o),{keys:m,overrides:u}}compareAndDeleteFolderConfiguration(s){const o=this.p.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:w,updated:d,removed:I,overrides:S}=v(o,void 0);return{keys:[...w,...d,...I],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,o,w){let d=this.r(o,w);return o.overrideIdentifier&&(d=d.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(d=d.merge(this.d)),d}r({resource:s},o){let w=this.s();if(o&&s){const d=o.getFolder(s);d&&(w=this.t(d.uri)||w);const I=this.m.get(s);I&&(w=w.merge(I))}return w}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let o=this.b.get(s);if(!o){const w=this.s(),d=this.j.get(s);d?(o=w.merge(d),this.b.set(s,o)):o=w}return o}u(s,o){if(o&&s){const w=o.getFolder(s);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,o)=>{const{contents:w,overrides:d,keys:I}=this.j.get(o);return s.push([o,{contents:w,overrides:d,keys:I}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this.i.keys.forEach(o=>s.add(o)),this.j.forEach(o=>o.keys.forEach(w=>s.add(w))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(w=>s.add(w))),[...s.values()]}w(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.i.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(s).forEach(d=>o.add(d))),[...o.values()]}static parse(s){const o=this.x(s.defaults),w=this.x(s.policy),d=this.x(s.application),I=this.x(s.user),S=this.x(s.workspace),u=s.folders.reduce((m,h)=>(m.set(g.URI.revive(h[0]),this.x(h[1])),m),new A.$Ac);return new a(o,w,d,I,new p,S,u,new p,new A.$Ac)}static x(s){return new p(s.contents,s.keys,s.overrides)}}e.$En=a;function $(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,o=new Map;for(const d of r)d.keys.forEach(I=>s.add(I)),d.overrides.forEach(([I,S])=>{const u=(0,A.$xc)(o,I,new Set);S.forEach(m=>u.add(m))});const w=[];return o.forEach((d,I)=>w.push([I,[...d.values()]])),{keys:[...s.values()],overrides:w}}e.$Fn=$;class E{constructor(s,o,w,d){this.change=s,this.f=o,this.g=w,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of s.keys)this.affectedKeys.add(I);for(const[,I]of s.overrides)for(const S of I)this.affectedKeys.add(S);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(s,o){const w=this.a+s,d=this.d.indexOf(w);if(d<0)return!1;const I=d+w.length;if(I>=this.d.length)return!1;const S=this.d.charCodeAt(I);if(S!==this.b&&S!==this.c)return!1;if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,m=this.g.getValue(s,o,this.h);return!l.$$m(u,m)}return!0}}e.$Gn=E;function v(r,s){const{added:o,removed:w,updated:d}=n(s?.rawConfiguration,r?.rawConfiguration),I=[],S=r?.getAllOverrideIdentifiers()||[],u=s?.getAllOverrideIdentifiers()||[];if(s){const m=u.filter(h=>!S.includes(h));for(const h of m)I.push([h,s.getKeysForOverrideIdentifier(h)])}if(r){const m=S.filter(h=>!u.includes(h));for(const h of m)I.push([h,r.getKeysForOverrideIdentifier(h)])}if(s&&r){for(const m of S)if(u.includes(m)){const h=n({contents:r.getOverrideValue(void 0,m)||{},keys:r.getKeysForOverrideIdentifier(m)},{contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)});I.push([m,[...h.added,...h.removed,...h.updated]])}}return{added:o,removed:w,updated:d,overrides:I}}function n(r,s){const o=r?s?r.keys.filter(I=>s.keys.indexOf(I)===-1):[...r.keys]:[],w=s?r?s.keys.filter(I=>r.keys.indexOf(I)===-1):[...s.keys]:[],d=[];if(r&&s){for(const I of s.keys)if(r.keys.indexOf(I)!==-1){const S=(0,R.$ri)(s.contents,I),u=(0,R.$ri)(r.contents,I);l.$$m(S,u)||d.push(I)}}return{added:o,removed:w,updated:d}}}),define(Ae[97],Re([1,0,9,4]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,M.$Ph)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class T{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=T;class A{constructor(k,c){this.host=k,this.port=c,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=A;var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class D extends y.$bb{static isNotAvailable(k){return k instanceof D&&k._code===l.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===l.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===l.NoResolverFound}static isInvalidAuthority(k){return k instanceof D&&k._code===l.InvalidAuthority}static isHandled(k){return k instanceof D&&k.isHandled}constructor(k,c=l.Unknown,b){super(k),this._message=k,this._code=c,this._detail=b,this.isHandled=c===l.NotAvailable&&b===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Sk=D;function g(R){const k=R.indexOf("+");return k===-1?R:R.substring(0,k)}e.$Tk=g}),define(Ae[53],Re([1,0,13]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function M(g){return g.scheme===y.Schemas.vscodeRemote?g.authority:void 0}e.$Uk=M;function C(g){if(!g)return;const R=g.indexOf("+");return R<0?g:g.substr(0,R)}e.$Vk=C;function T(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Wk=T;function A(g){const{host:R,port:k}=D(g);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.$Xk=A;function l(g,R){let{host:k,port:c}=D(g);return typeof c>"u"&&(c=R),{host:k,port:c}}e.$Yk=l;function D(g){const R=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=g.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const c=g.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:g,port:void 0}}}),define(Ae[21],Re([1,0,16,4,53]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$4l=T,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const a=typeof t=="string"?t:t.value,$=typeof i=="string"?i:i.value;return y.$2e(a,$)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$6l=D;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$7l=g;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=R;function k(f){return c(f)}e.$9l=k;function c(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$0l=c;function b(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$$l=b;function p(f,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Vk)(t)}`;return!!f.activationEvents?.includes(i)}return!1}e.$_l=p,e.$am=(0,M.$Ph)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,21]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const D of A){const g=this.readActivationEvents(D);g.length>0&&(l[M.$6l.toKey(D.identifier)]=g)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const D in A.contributes){const g=this.a.get(D);if(!g)continue;const R=A.contributes[D],k=Array.isArray(R)?R:[R];try{g(k,l)}catch(c){(0,y.$1)(c)}}return l}}e.$UE=C,e.$VE=new C}),define(Ae[178],Re([1,0,23,73,36]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=void 0;function T(D){if(y.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function A(D,g,R,k,c,b,p,f,t){const i=Object.create(null);i["common.machineId"]=b,i["common.sqmId"]=p,i.sessionID=(0,C.$eg)()+Date.now(),i.commitHash=k,i.version=c,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,y.$i)(y.$u),i["common.nodePlatform"]=M.$dc,i["common.nodeArch"]=R,i["common.product"]=t||"desktop",f&&(i["common.msftInternal"]=f);let a=0;const $=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),y.$m&&(i["common.snap"]="true");const E=T(g);return E&&(i["common.platformDetail"]=E),i}e.$io=A;function l(D){const g=M.env.USERDNSDOMAIN;if(!g)return!1;const R=g.toLowerCase();return D.some(k=>R===k)}e.$jo=l}),define(Ae[179],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,y.$Ph)("telemetryService"),e.$dl=(0,y.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var M;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[54],Re([1,0,25,15,5,45,53,178,179]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=void 0;class g{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$ko=g;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$lo=R,e.$mo=new R;class k{async publicLog(w,d,I){}async publicLogError(w,d,I){}}e.$no=k,e.$oo="telemetry",e.$po="extensionTelemetryLog",e.$qo={log:()=>null,flush:()=>Promise.resolve(null)};function c(o,w){return C.Event.debounce(w.onDidChangeConfiguration,(I,S)=>{const u=I?new Set([...I.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:u}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,T.$mi)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$ro=c;function b(o,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!o.enableTelemetry)}e.$so=b;function p(o,w){return w.extensionTestsLocationURI?!0:!(w.isBuilt||w.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$to=p;function f(o){const w=o.getValue(D.$kl),d=o.getValue(D.$ll);if(o.getValue(D.$ml)===!1||d===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$uo=f;function t(o){const w={},d={},I={};$(o,I);for(let S in I){S=S.length>150?S.substr(S.length-149):S;const u=I[S];typeof u=="number"?d[S]=u:typeof u=="boolean"?d[S]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${u.length}`),w[S]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(w[S]=u)}return{properties:w,measurements:d}}e.$vo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(o){if(!o)return"none";const w=(0,A.$Vk)(o);return i.has(w)?w:"other"}e.$wo=a;function $(o,w,d=0,I){if(o)for(const S of Object.getOwnPropertyNames(o)){const u=o[S],m=I?I+S:S;Array.isArray(u)?w[m]=(0,y.$_m)(u):u instanceof Date?w[m]=u.toISOString():(0,M.$Af)(u)?d<2?$(u,w,d+1,m+"."):w[m]=(0,y.$_m)(u):w[m]=u}}function E(o,w){const d=o.msftInternalDomains||[],I=w.getValue("telemetry.internalTesting");return(0,l.$jo)(d)||I}e.$xo=E;function v(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$yo=v;function n(o,w){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const I=[];for(const h of w)for(;;){const P=h.exec(o);if(!P)break;I.push([P.index,h.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(d="";;){const h=u.exec(o);if(!h)break;const P=I.some(([W,K])=>h.index<K&&W<u.lastIndex);!S.test(h[0])&&!P&&(d+=o.substring(m,h.index)+"<REDACTED: user-file-path>",m=u.lastIndex)}return m<o.length&&(d+=o.substr(m)),d}function r(o){if(!o)return o;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of w)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function s(o,w){return(0,y.$9m)(o,d=>{if(d instanceof g||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let I=d.replaceAll("%20"," ");I=n(I,w);for(const S of w)I=I.replace(S,"");return I=r(I),I}})}e.$zo=s}),define(Ae[180],Re([1,0,16,92,21,23,2,9,73,54]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;function R(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,y.$We)(s.id,o.id)===0}e.$Ao=R;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(o){const w=o.manifest?o.manifest.version:o.version,d=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new c(o.identifier,w,d)}static parse(o){const w=k.exec(o);return w&&w[1]&&w[2]?new c({id:w[1]},w[2],w[4]||void 0):null}constructor(o,w,d="undefined"){this.version=w,this.targetPlatform=d,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof c?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$Bo=c;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(s){const o=b.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.$Co=p;function f(s,o){return`${s}.${o}`}e.$Do=f;function t(s){return s.toLowerCase()}e.$Eo=t;function i(s,o){return t(f(s??C.$2l,o))}e.$Fo=i;function a(s,o){const w=[],d=I=>{for(const S of w)if(S.some(u=>R(o(u),o(I))))return S;return null};for(const I of s){const S=d(I);S?S.push(I):w.push([I])}return w}e.$Go=a;function $(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$Ho=$;function E(s){return{id:new g.$ko(s.identifier.id),name:new g.$ko(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Io=E,e.$Jo=new C.$6l("pprice.better-merge");function v(s,o){const w=[],d=o.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const I=d.shift();if(I&&w.every(S=>!R(S.identifier,{id:I}))){const S=s.filter(u=>R(u.identifier,{id:I}));S.length===1&&(w.push(S[0]),d.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$Ko=v;async function n(s,o){if(!T.$l)return!1;let w;try{w=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,l.$0)(I))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,o){const w=await n(s,o),d=(0,M.$6n)(w?"alpine":T.$u,D.$ec);return o.debug("ComputeTargetPlatform:",d),d}e.$Lo=r}),define(Ae[181],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.$or=e.$nr=e.$mr=e.$lr=void 0;function y(D){return[...D.entries()]}e.$lr=y;function M(D){return D?[...D.entries()]:[]}e.$mr=M;function C(D){return new Map(D)}e.$nr=C;function T(D){return new Map(D??[])}e.$or=T;function A(D){return Array.from(D.entries()).map(g=>[g[0],y(g[1].map),M(g[1].descriptionMap)])}e.$pr=A;function l(D){return new Map(D.map(g=>[g[0],{map:C(g[1]),descriptionMap:T(g[2])}]))}e.$qr=l}),define(Ae[182],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,T,A=5){const l=T(D=>{const g=typeof D=="string"?D:D.data;let R=this.a.get(C);if(R){R.data.push(g);return}const k=setTimeout(()=>this.flushBuffer(C),A);R={data:[g],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),l.dispose()}},this.a.set(C,R)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const T=this.a.get(C);T&&(this.a.delete(C),this.b(C,T.data.join("")))}}e.$Tkb=y}),define(Ae[183],Re([1,0,12,89,43,5,15,2,144,72,30]),function(ye,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.IconFontDefinition=e.IconContribution=e.$5v=void 0,e.$5v={IconContribution:"base.contributions.icons"};var k;(function(E){function v(n,r){let s=n.defaults;for(;C.ThemeIcon.isThemeIcon(s);){const o=p.getIcon(s.id);if(!o)return;s=o.defaults}return s}E.getDefinition=v})(k||(e.IconContribution=k={}));var c;(function(E){function v(r){return{weight:r.weight,style:r.style,src:r.src.map(s=>({format:s.format,location:s.location.toString()}))}}E.toJSONObject=v;function n(r){const s=o=>(0,A.$yf)(o)?o:void 0;if(r&&Array.isArray(r.src)&&r.src.every(o=>(0,A.$yf)(o.format)&&(0,A.$yf)(o.location)))return{weight:s(r.weight),style:s(r.style),src:r.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}E.fromJSONObject=n})(c||(e.IconFontDefinition=c={}));class b{constructor(){this.a=new T.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,n,r,s){const o=this.b[v];if(o){if(r&&!o.description){o.description=r,this.d.properties[v].markdownDescription=`${r} $(${v})`;const I=this.e.enum.indexOf(v);I!==-1&&(this.e.enumDescriptions[I]=r),this.a.fire()}return o}const w={id:v,description:r,defaults:n,deprecationMessage:s};this.b[v]=w;const d={$ref:"#/definitions/icons"};return s&&(d.deprecationMessage=s),r&&(d.markdownDescription=`${r}: $(${v})`),this.d.properties[v]=d,this.e.enum.push(v),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const n=this.e.enum.indexOf(v);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,n){const r=this.f[v];return r||(this.f[v]=n,this.a.fire(),n)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(o,w)=>o.id.localeCompare(w.id),n=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(o=>this.b[o]);for(const o of s.filter(w=>!!w.description).sort(v))r.push(`|<i class="${n(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const o of s.filter(w=>!C.ThemeIcon.isThemeIcon(w.defaults)).sort(v))r.push(`|<i class="${n(o)}"></i>|${o.id}|`);return r.join(`
`)}}const p=new b;R.$gn.add(e.$5v.IconContribution,p);function f(E,v,n,r){return p.registerIcon(E,v,n,r)}e.$6v=f;function t(){return p}e.$7v=t;function i(){const E=(0,M.$Sj)();for(const v in E){const n="\\"+E[v].toString(16);p.registerIcon(v,{fontCharacter:n})}}i(),e.$8v="vscode://schemas/icons";const a=R.$gn.as(g.$hn.JSONContribution);a.registerSchema(e.$8v,p.getIconSchema());const $=new y.$6g(()=>a.notifySchemaChanged(e.$8v),200);p.onDidChange(()=>{$.isScheduled()||$.schedule()}),e.$9v=f("widget-close",M.$Uj.close,(0,D.localize)(2,null)),e.$0v=f("goto-previous-location",M.$Uj.arrowUp,(0,D.localize)(3,null)),e.$$v=f("goto-next-location",M.$Uj.arrowDown,(0,D.localize)(4,null)),e.$_v=C.ThemeIcon.modify(M.$Uj.sync,"spin"),e.$aw=C.ThemeIcon.modify(M.$Uj.loading,"spin")}),define(Ae[184],Re([1,0,5,45,4,14]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.ProvidedOnAutoForward=e.$_u=e.TunnelPrivacyId=e.TunnelProtocol=e.$$u=e.$0u=void 0,e.$0u=(0,C.$Ph)("tunnelService"),e.$$u=(0,C.$Ph)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function D(t){return!!t.forwardPort}e.$_u=D;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function R(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$av=R,e.$bv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$bv.indexOf(t)>=0}e.$cv=k,e.$dv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(t){return e.$dv.indexOf(t)>=0}e.$ev=c;function b(t,i,a,$){if(a===1)return!1;if(a===2&&c(i)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.$fv=b;class p{constructor(i,a,$){this.remoteAddress=i,this.localAddress=a,this.b=$,this.a=new y.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$gv=p;let f=class{constructor(i,a){this.j=i,this.k=a,this.a=new y.$Nd,this.onTunnelOpened=this.a.event,this.b=new y.$Nd,this.onTunnelClosed=this.b.event,this.c=new y.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],a=Array.from(this.e.values());for(const $ of a){const E=Array.from($.values());for(const v of E){const n=await v.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then($=>typeof $!="string"?$?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,$,E,v){this.p(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:$,privacy:E,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(c(i)||k(i))&&(i=e.$bv[0]);const $=this.r(i,a);if($)return++$.refcount,$.value}openTunnel(i,a,$,E,v,n=!1,r,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${$} on local port ${v}.`);const o=this.f??i;if(!o)return;if(a||(a="localhost"),E||(E=this.l),this.f&&this.i.has($)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(o,a,$,E,v,n,r,s);return w?w.then(d=>{if(d){if(typeof d=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(a,$),d}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(a,$);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(d);return(d.tunnelRemoteHost!==a||d.tunnelRemotePort!==$)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&d.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const $=a.get(i.tunnelRemotePort);$&&($.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,$))}}}}async o(i,a,$){if($.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const E=$.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),E}}async closeTunnel(i,a){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const $=this.e.get(i);if($&&$.has(a)){const E=$.get(a);E.refcount=0,await this.o(i,a,E)}}p(i,a,$){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:$})}async q(i,a){const $=this.e.get(i);if($){const E=$.get(a),v=E?await E.value:void 0;(!v||typeof v=="string")&&$.delete(a),$.size===0&&this.e.delete(i)}}r(i,a){const $=[i];k(i)?($.push(...e.$bv),$.push(...e.$dv)):c(i)&&$.push(...e.$dv);const E=$.map(v=>this.e.get(v));for(const v of E){const n=v?.get(a);if(n)return n}}canTunnel(i){return!!R(i)}t(i,a,$,E,v,n,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${$} on local port ${E}.`);const s=$;this.i.add(s);const o=E===void 0?$:E,w={elevationRequired:v?this.isPortPrivileged(o):!1},d={remoteAddress:{host:a,port:$},localAddressPort:E,privacy:n,public:n?n!==l.Private:void 0,protocol:r},I=i.forwardPort(d,w);return I?(this.p(a,$,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),I}};e.$hv=f,e.$hv=f=qe([Ke(0,T.$0i),Ke(1,M.$ji)],f)}),define(Ae[185],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$iv=void 0,e.$iv=(0,y.$Ph)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Ae[186],Re([1,0,13]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=void 0;function M(D){return D.scheme!==y.Schemas.file&&D.scheme!==y.Schemas.vscodeRemote}e.$PJ=M;function C(D){if(D.folders.length)return D.folders.every(g=>M(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&M(D.configuration))return D.configuration}e.$QJ=C;function T(D){return C(D)?.scheme}e.$RJ=T;function A(D){return C(D)?.authority}e.$SJ=A;function l(D){return C(D)!==void 0}e.$TJ=l}),define(Ae[55],Re([1,0,145,20,49,24,2,4,13]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,l.$Ph)("contextService");function g(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}e.$Zh=g;function R(o){return typeof o?.id=="string"&&!g(o)&&!c(o)}e.$1h=R,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function k(o,w){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$nc)(o)}:w?e.$2h:e.$3h;const d=o;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$4h=k;function c(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}e.$5h=c;function b(o){const w=o;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const d=o;if(d?.configPath)return{id:d.id,configPath:A.URI.revive(d.configPath)};if(o?.id)return{id:o.id}}e.$6h=b;var p;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function f(o){const w=o;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$7h=f;function t(o){const w=o;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$8h=t;class i{constructor(w,d,I,S,u){this.h=w,this.j=I,this.k=S,this.l=u,this.c=C.$Vh.forUris(this.l,()=>!0),this.folders=d}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=C.$Vh.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=i;class a{constructor(w,d){this.raw=d,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,T.$vg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=a;function $(o){return new a({uri:o,index:0,name:(0,T.$rg)(o)},{uri:o.toString()})}e.$$h=$,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,y.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function E(o,w){return T.$mg.isEqualOrParent(o,w.untitledWorkspacesHome)}e.$di=E;function v(o){let w;return A.URI.isUri(o)?w=o:w=o.configuration,w?.scheme===D.Schemas.tmp}e.$ei=v,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.$fi}e.$gi=n;function r(o,w){return!E(o,w)&&!v(o)}e.$hi=r;function s(o){return(typeof o=="string"?(0,M.$oc)(o):(0,T.$tg)(o))===e.$ai}e.$ii=s}),define(Ae[74],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=void 0;class y{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const T=this.c++;return this.b.set(T,C),this.e(),T}get(C,T){return this.b.has(C)?this.b.get(C)[T]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$9bc=y}),define(Ae[40],Re([1,0,13,24,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=void 0;class T{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new M.$kg(l=>{const D=this.b.get(l.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(l,D){D===null?this.b.delete(l.scheme):this.b.set(l.scheme,D)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$$bc=T,e.$_bc=(0,C.$Ph)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=void 0,e.$xM=(0,y.$Ph)("IExtHostInitDataService")}),define(Ae[187],Re([1,0,150,14,174,27]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;let A=class extends C.$EN{constructor(D,g,R){const k=R.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",c=R.remote.isRemote?(0,y.localize)(0,null):D?(0,y.localize)(1,null):(0,y.localize)(2,null);super(g.createLogger(k,{name:c}))}};e.$hec=A,e.$hec=A=qe([Ke(1,M.$$i),Ke(2,T.$xM)],A)}),define(Ae[188],Re([1,0,12]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=e.$Bcc=void 0;class M{constructor(A,l,D){this.h=new Map,this.a=A,this.b=l,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new y.$6g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of g.values())R.complete()}catch(R){for(const k of g.values())k.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let D=this.f[A];return typeof D>"u"&&(D=l),D}update(A,l){this.f[A]=l;const D=this.h.get(A);if(D!==void 0)return D.p;const g=new y.$ch;return this.h.set(A,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$Bcc=M;class C extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$Ccc=C}),define(Ae[189],Re([1,0,5,2]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class C{constructor(A){this.c=A,this.a=new y.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,D,g){const k=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(l.value,D,g);this.b.fire(k)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$1dc=C}),define(Ae[17],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=void 0,e.$hM=(0,y.$Ph)("IExtHostRpcService");class M{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$iM=M}),define(Ae[190],Re([1,0,21,5]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class C{#e;constructor(A,l){this.b=new M.$Nd,this.onDidChange=this.b.event,this.a=y.$6l.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$Ncc=C}),define(Ae[56],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=e.$jcc=void 0,e.$jcc=(0,y.$Ph)("IURITransformerService");class M{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$kcc=M}),define(Ae[191],Re([1,0,26]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acb=e.$zcb=void 0;class M{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function C(l,D){if(D.serializeBuffersForPostMessage){const g=new M,k=JSON.stringify(l,(b,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p)};if(ArrayBuffer.isView(p)){const f=T(p);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p.buffer),view:{type:f,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),c=g.buffers.map(b=>{const p=new Uint8Array(b);return y.$be.wrap(p)});return{message:k,buffers:c}}else return{message:JSON.stringify(l),buffers:[]}}e.$zcb=C;function T(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,D){const g=D.map(c=>{const b=new ArrayBuffer(c.byteLength);return new Uint8Array(b).set(c.buffer),b}),R=D.length?(c,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:f}=p,t=g[f];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse(l,R),arrayBuffers:g}}e.$Acb=A}),define(Ae[99],Re([1,0,159,15,2,6,4,30,39,13,37,127,29]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gE=e.$fE=e.$eE=e.EditorsOrder=e.$dE=e.CloseDirection=e.$cE=e.$bE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.EditorInputCapabilities=e.$5D=e.SaveReason=e.Verbosity=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=void 0,e.$SD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$TD={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$UD="workbench.editor.sidebysideEditor",e.$VD="workbench.editors.textDiffEditor",e.$WD="workbench.editors.binaryResourceDiffEditor";var b;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var p;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function f(oe){const be=oe;return!!be&&typeof be.getSelection=="function"&&!!be.onDidChangeSelection}e.$XD=f;function t(oe,be,_){for(const B of _.visibleEditorPanes)if(B.group.id===be&&oe.matches(B.input))return B.getViewState()}e.$YD=t;function i(oe){if(d(oe))return!1;const be=oe;return C.URI.isUri(be?.resource)}e.$ZD=i;function a(oe){if(d(oe))return!1;const be=oe;return be?.original!==void 0&&be.modified!==void 0}e.$1D=a;function $(oe){if(d(oe)||a(oe))return!1;const be=oe;return be?.primary!==void 0&&be.secondary!==void 0}e.$2D=$;function E(oe){if(d(oe))return!1;const be=oe;return be?be.resource===void 0||be.resource.scheme===g.Schemas.untitled||be.forceUntitled===!0:!1}e.$3D=E;function v(oe){if(d(oe))return!1;const be=oe;return C.URI.isUri(be?.base?.resource)&&C.URI.isUri(be?.input1?.resource)&&C.URI.isUri(be?.input2?.resource)&&C.URI.isUri(be?.result?.resource)}e.$4D=v;var n;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var r;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class s{constructor(){this.a=new Map}registerSource(be,_){let B=this.a.get(be);return B||(B={source:be,label:_},this.a.set(be,B)),B.source}getSourceLabel(be){return this.a.get(be)?.label??be}}e.$5D=new s;var o;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class w extends T.$Sc{}e.$6D=w;function d(oe){return oe instanceof w}e.$7D=d;function I(oe){const be=oe;return C.URI.isUri(be?.preferredResource)}function S(oe){const be=oe;return d(be?.primary)&&d(be?.secondary)}e.$8D=S;function u(oe){const be=oe;return d(be?.modified)&&d(be?.original)}e.$9D=u;function m(oe,be,_,B,Z){return ue(B,[(0,k.$zi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const ee={..._,limits:{size:Number.MAX_VALUE}};oe.openEditor(be,ee)}}),(0,k.$zi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>Z.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}e.$0D=m;function h(oe){return d(oe?.editor)}e.$$D=h;function P(oe){const be=oe;return h(oe)&&be?.group!==void 0}e.$_D=P;function W(oe){const be=oe;return typeof be?.groupId=="number"&&d(be.editor)}e.$aE=W;var K;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(K||(e.EditorCloseContext=K={}));var z;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LOCKED=2]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=3]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=4]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=5]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=7]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=9]="EDITOR_PIN",oe[oe.EDITOR_STICKY=10]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=11]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var j;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class O{getOriginalUri(be,_){if(!be)return;if(v(be))return e.$cE.getOriginalUri(be.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ee}=this.a(be);if(Z&&ee){if(_?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===j.ANY)return this.getOriginalUri(Z,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:_.filterByScheme});be=_.supportSideBySide===j.PRIMARY?Z:ee}}if(a(be)||$(be)||v(be))return;const B=I(be)?be.preferredResource:be.resource;return!B||!_||!_.filterByScheme?B:this.b(B,_.filterByScheme)}a(be){return S(be)||$(be)?{primary:be.primary,secondary:be.secondary}:u(be)||a(be)?{primary:be.modified,secondary:be.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(be,_){if(!be)return;if(v(be))return e.$cE.getCanonicalUri(be.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ee}=this.a(be);if(Z&&ee){if(_?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===j.ANY)return this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:_.filterByScheme});be=_.supportSideBySide===j.PRIMARY?Z:ee}}if(a(be)||$(be)||v(be))return;const B=be.resource;return!B||!_||!_.filterByScheme?B:this.b(B,_.filterByScheme)}b(be,_){if(Array.isArray(_)){if(_.some(B=>be.scheme===B))return be}else if(_===be.scheme)return be}}var N;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function ie(oe,be,_,B){if(!oe.isSticky(be))return!1;switch(B.preventPinnedEditorClose){case"keyboardAndMouse":return _===N.MOUSE||_===N.KEYBOARD;case"mouse":return _===N.MOUSE;case"keyboard":return _===N.KEYBOARD}return!1}e.$bE=ie,e.$cE=new O;var X;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start(be){const _=this.a=be.get(A.$Oh);for(const[B,Z]of this.c)this.e(B,Z,_);this.c.clear()}e(be,_,B){const Z=B.createInstance(_);this.d.set(be,Z)}registerFileEditorFactory(be){if(this.b)throw new Error("Can only register one file editor factory.");this.b=be}getFileEditorFactory(){return(0,M.$Jf)(this.b)}registerEditorSerializer(be,_){if(this.c.has(be)||this.d.has(be))throw new Error(`A editor serializer with type ID '${be}' was already registered.`);return this.a?this.e(be,_,this.a):this.c.set(be,_),(0,T.$Qc)(()=>{this.c.delete(be),this.d.delete(be)})}getEditorSerializer(be){return this.d.get(typeof be=="string"?be:be.typeId)}}l.$gn.add(e.$SD.EditorFactory,new Ee);async function Se(oe,be,_){return!oe||!oe.length?[]:await Promise.all(oe.map(async B=>{const Z=C.URI.revive(B.fileUri);if(!Z){_.info("Cannot resolve the path because it is not valid.",B);return}if(!await be.canHandleResource(Z)){_.info("Cannot resolve the path because it cannot be handled",B);return}let ve=B.exists,ge=B.type;if(typeof ve!="boolean"||typeof ge!="number")try{ge=(await be.stat(Z)).isDirectory?D.FileType.Directory:D.FileType.Unknown,ve=!0}catch(De){_.error(De),ve=!1}if(!ve&&B.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",B);return}if(ge===D.FileType.Directory){_.info("Cannot resolve the path because it is a directory",B);return}const he={...B.options,pinned:!0};return ve?{resource:Z,options:he}:{resource:Z,options:he,forceUntitled:!0}}))}e.$dE=Se;var Pe;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function $e(oe){const be=oe;if(!be)return!1;const _=be;if(_.modified)return $e(_.modified);const B=be;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.$eE=$e;function pe(oe){return(0,R.$Bi)(oe)}e.$fE=pe;function ue(oe,be,_){const B=(0,R.$Ci)(oe,be);return B.forceMessage=_?.forceMessage,B.forceSeverity=_?.forceSeverity,B.allowDialog=_?.allowDialog,B}e.$gE=ue}),define(Ae[192],Re([1,0,5,160,4,6,28,30,18,25,89,183]),function(ye,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rE=e.$qE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$pE=e.$oE=e.ViewContentGroups=e.$nE=e.$mE=e.ViewContainerLocation=e.Extensions=e.$lE=e.$kE=e.$jE=void 0,e.$jE="views",e.$kE=(0,M.localize)(0,null),e.$lE=(0,k.$6v)("default-view-icon",R.$Uj.window,(0,M.localize)(1,null));var c;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(c||(e.Extensions=c={}));var b;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$mE=[0,1,2];function p(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$nE=p;class f extends T.$Sc{constructor(){super(...arguments),this.c=this.B(new y.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Rb)([...this.g.values()])}registerViewContainer(s,o,w){const d=this.get(s.id);if(d)return d;const I=s;return I.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$xc)(this.g,o,[]).push(I),w?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:o}),I}deregisterViewContainer(s){for(const o of this.g.keys()){const w=this.g.get(o),d=w?.indexOf(s);if(d!==-1){w?.splice(d,1),w.length===0&&this.g.delete(o),this.f.fire({viewContainer:s,viewContainerLocation:o});return}}}get(s){return this.all.filter(o=>o.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(w=>w?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(o=>this.getViewContainerLocation(o)===s)}}l.$gn.add(c.ViewContainersRegistry,new f);var t;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(r,s){const o=r.group??t.More,w=s.group??t.More;return o!==w?o.localeCompare(w):(r.order??5)-(s.order??5)}class a extends T.$Sc{constructor(){super(...arguments),this.c=this.B(new y.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,o){this.registerViews2([{views:s,viewContainer:o}])}registerViews2(s){s.forEach(({views:o,viewContainer:w})=>this.r(o,w)),this.c.fire(s)}deregisterViews(s,o){const w=this.s(s,o);w.length&&this.f.fire({views:w,viewContainer:o})}moveViews(s,o){for(const w of this.m.keys())if(w!==o){const d=this.s(s,w);d.length&&(this.r(d,o),this.g.fire({views:d,from:w,to:o}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const o of this.j){const w=(this.m.get(o)||[]).filter(d=>d.id===s)[0];if(w)return w}return null}getViewContainer(s){for(const o of this.j)if((this.m.get(o)||[]).filter(d=>d.id===s)[0])return o;return null}registerViewWelcomeContent(s,o){return this.n.add(s,o),this.h.fire(s),(0,T.$Qc)(()=>{this.n.delete(s,o),this.h.fire(s)})}registerViewWelcomeContent2(s,o){const w=new Map;for(const[d,I]of o)this.n.add(s,I),w.set(d,(0,T.$Qc)(()=>{this.n.delete(s,I),this.h.fire(s)}));return this.h.fire(s),w}getViewWelcomeContent(s){const o=[];return this.n.forEach(s,w=>o.push(w)),o.sort(i)}r(s,o){let w=this.m.get(o);w||(w=[],this.m.set(o,w),this.j.push(o));for(const d of s){if(this.getView(d.id)!==null)throw new Error((0,M.localize)(2,null,d.id));w.push(d)}}s(s,o){const w=this.m.get(o);if(!w)return[];const d=[],I=[];for(const S of w)s.includes(S)?d.push(S):I.push(S);return d.length&&(I.length?this.m.set(o,I):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),d}}l.$gn.add(c.ViewsRegistry,new a),e.$oE=(0,C.$Ph)("viewsService"),e.$pE=(0,C.$Ph)("viewDescriptorService");var $;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})($||(e.ViewVisibilityState=$={}));var E;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(E||(e.TreeItemCollapsibleState=E={}));class v{constructor(s,o){this.c=!1,this.d=!1,(0,g.$0m)(this,s),this.d=!!o,this.resolve=async w=>{if(o&&!this.c){const d=await o(w);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$qE=v;class n extends Error{constructor(s){super((0,M.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$rE=n}),define(Ae[193],Re([1,0,2,41,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$QE=e.$PE=void 0;function T(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof y.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(M.$us.isIRange)}e.$PE=T;function A(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(T)}e.$QE=A;var l;(function(g){g[g.Up=1]="Up",g[g.Down=2]="Down"})(l||(e.InteractiveSessionVoteDirection=l={}));var D;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(D||(e.InteractiveSessionCopyKind=D={})),e.$RE=(0,C.$Ph)("IChatService")}),define(Ae[194],Re([1,0,5,12,161]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cb=void 0;class T{constructor(){this.f=new Map,this.k=[],this.m=new y.$Nd,this.n=new y.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,D,g,R){const k={command:l};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof R=="number"){const c=setTimeout(()=>{clearTimeout(c);const b=this.f.get(k.seq);if(b){this.f.delete(k.seq);const p={type:"response",seq:0,request_seq:k.seq,success:!1,command:l,message:(0,C.localize)(0,null,R,l)};b(p)}},R)}return g&&this.f.set(k.seq,g),k.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,D){return l.type!=="event"||D.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,M.$Ug)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const D=l,g=this.f.get(D.request_seq);g&&(this.f.delete(D.request_seq),g(D));break}}}}s(l,D){D.type=l,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((D,g)=>l.set(g,D)),await(0,M.$Ug)(500),l.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$6cb=T}),define(Ae[195],Re([1,0,162,32,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$4G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$3G=e.MemoryRangeType=e.$2G=e.State=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=void 0,e.$ZF="workbench.view.debug",e.$1F="workbench.debug.variablesView",e.$2F="workbench.debug.watchExpressionsView",e.$3F="workbench.debug.callStackView",e.$4F="workbench.debug.loadedScriptsView",e.$5F="workbench.debug.breakPointsView",e.$6F="workbench.debug.disassemblyView",e.$7F="workbench.panel.repl",e.$8F="workbench.panel.repl.view",e.$9F=new M.$7i("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$0F=new M.$7i("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$$F=new M.$7i("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$_F="debugUx",e.$aG=new M.$7i(e.$_F,"default",{type:"string",description:y.localize(3,null)}),e.$bG=new M.$7i("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$cG=new M.$7i("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$dG=new M.$7i("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$eG=new M.$7i("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$fG=new M.$7i("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$gG=new M.$7i("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$hG=new M.$7i("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$iG=new M.$7i("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$jG=new M.$7i("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$kG=new M.$7i("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$lG=new M.$7i("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$mG=new M.$7i("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$nG=new M.$7i("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$oG=new M.$7i("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$pG=new M.$7i("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$qG=new M.$7i("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$rG=new M.$7i("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$sG=new M.$7i("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$tG=new M.$7i("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$uG=new M.$7i("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$vG=new M.$7i("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$wG=new M.$7i("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$xG=new M.$7i("stepBackSupported",!1,{type:"boolean",description:y.localize(26,null)}),e.$yG=new M.$7i("restartFrameSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$zG=new M.$7i("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(28,null)}),e.$AG=new M.$7i("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$BG=new M.$7i("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$CG=new M.$7i("breakpointsExist",!1,{type:"boolean",description:y.localize(31,null)}),e.$DG=new M.$7i("debuggersAvailable",!1,{type:"boolean",description:y.localize(32,null)}),e.$EG=new M.$7i("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(33,null)}),e.$FG=new M.$7i("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(34,null)}),e.$GG=new M.$7i("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(35,null)}),e.$HG=new M.$7i("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$IG=new M.$7i("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$JG=new M.$7i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$KG=new M.$7i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$LG=new M.$7i("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$MG=new M.$7i("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$NG=new M.$7i("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(42,null)}),e.$OG=new M.$7i("variableIsReadonly",!1,{type:"boolean",description:y.localize(43,null)}),e.$PG=new M.$7i("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(44,null)}),e.$QG=new M.$7i("multiSessionRepl",!1,{type:"boolean",description:y.localize(45,null)}),e.$RG=new M.$7i("multiSessionDebug",!1,{type:"boolean",description:y.localize(46,null)}),e.$SG=new M.$7i("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(47,null)}),e.$TG=new M.$7i("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(48,null)}),e.$UG=new M.$7i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(49,null)}),e.$VG=new M.$7i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(50,null)});const T=c=>y.localize(51,null,c);e.$WG=T,e.$XG="editor.contrib.debug",e.$YG="editor.contrib.breakpoint",e.$ZG="debug",e.$1G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(52,null)};var A;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(A||(e.State=A={}));function l(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$2G=l;var D;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$3G="vscode-debug-memory";var g;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var R;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$4G=(0,C.$Ph)("debugService");var k;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ae[196],Re([1,0,16,2,20,25,13,41,19,18]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=void 0;const R=/{([^}]+)}/g;function k(S,u,m){return S.replace(R,function(h,P){return u&&P.length>0&&P[0]!=="_"?h:m&&m.hasOwnProperty(P)?m[P]:h})}e.$oF=k;function c(S){const u={};for(const m of Object.keys(S))m.startsWith("!")||(u[m]=S[m]);return u}e.$pF=c;function b(S){return S.configuration.request==="attach"&&!p(S)&&(!S.parentSession||b(S.parentSession))}e.$qF=b;function p(S){let u=S.configuration.type;if(u)return u==="vslsShare"&&(u=S.configuration.adapterProxy.configuration.type),(0,y.$2e)(u,"extensionhost")||(0,y.$2e)(u,"pwa-extensionhost")?S:S.parentSession?p(S.parentSession):void 0}e.$rF=p;function f(S){return S.type&&(S.label||S.program||S.runtime)}e.$sF=f;function t(S,u,m){let h,P=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let K=null;for(;K=W.exec(S);){const z=K.index+1,j=z+K[0].length;if(z<=u&&j>=m){h=K[0],P=z;break}}if(h){const z=/\w+/g;let j=null;for(;(j=z.exec(h))&&!(j.index+1+P+j[0].length>=m););j&&(h=h.substring(0,z.lastIndex))}return h?{start:P,end:P+h.length-1}:{start:0,end:0}}e.$tF=t;async function i(S,u,m,h){if(S.evaluatableExpressionProvider.has(u)){const P=S.evaluatableExpressionProvider.ordered(u),W=(0,g.$Hb)(await Promise.all(P.map(async K=>{try{return await K.provideEvaluatableExpression(u,m,h??D.CancellationToken.None)}catch{return}})));if(W.length>0){let K=W[0].expression;const z=W[0].range;return K||(K=u.getLineContent(m.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:K}}}else{const P=u.getLineContent(m.lineNumber),{start:W,end:K}=t(P,m.column,m.column),z=P.substring(W-1,K);return{matchingExpression:z,range:new l.$us(m.lineNumber,W,m.lineNumber,W+z.length)}}return null}e.$uF=i;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function $(S){return!!(S&&S.match(a))}e.$vF=$;function E(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if($(S.path))return M.URI.parse(S.path);if((0,C.$ic)(S.path))return M.URI.file(S.path)}return S.path}function v(S){if(typeof S.path=="object"){const u=M.URI.revive(S.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return S.path}function n(S,u){const m=u?E:v,h=(0,T.$7m)(S);return s(h,(P,W)=>{P&&W&&(W.path=m(W))}),h}e.$wF=n;function r(S,u){const m=u?E:v,h=(0,T.$7m)(S);return s(h,(P,W)=>{!P&&W&&(W.path=m(W))}),h}e.$xF=r;function s(S,u){switch(S.type){case"event":{const m=S;switch(m.event){case"output":u(!1,m.body.source);break;case"loadedSource":u(!1,m.body.source);break;case"breakpoint":u(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=S;switch(m.command){case"setBreakpoints":u(!0,m.arguments.source);break;case"breakpointLocations":u(!0,m.arguments.source);break;case"source":u(!0,m.arguments.source);break;case"gotoTargets":u(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(h=>u(!1,h));break;default:break}break}case"response":{const m=S;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(h=>u(!1,h.source));break;case"loadedSources":m.body.sources.forEach(h=>u(!1,h));break;case"scopes":m.body.scopes.forEach(h=>u(!1,h.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(h=>u(!1,h.source));break;case"setBreakpoints":m.body.breakpoints.forEach(h=>u(!1,h.source));break;case"disassemble":m.body?.instructions.forEach(P=>u(!1,P.location));break;default:break}break}}}function o(S){return S.filter(u=>!u.presentation?.hidden).sort((u,m)=>u.presentation?m.presentation?u.presentation.group?m.presentation.group?u.presentation.group!==m.presentation.group?u.presentation.group.localeCompare(m.presentation.group):w(u.presentation.order,m.presentation.order):-1:m.presentation.group?1:w(u.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$yF=o;function w(S,u){return typeof S!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:S-u}async function d(S,u){const m=S.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(m!=="none"&&(await u.saveAll(),m==="allEditorsInActiveGroup")){const h=u.activeEditorPane;h&&h.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:h.input,groupId:h.group.id})}await S.reloadConfiguration()}e.$zF=d;const I=(S,u)=>!S||!u?S===u:S.name===u.name&&S.path===u.path&&S.sourceReference===u.sourceReference;e.$AF=I}),define(Ae[75],Re([1,0,26,38,66,67,13,20,23,32]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sI=e.$rI=e.$qI=e.$pI=e.CellStatusbarAlignment=e.$oI=e.$nI=e.$mI=e.NotebookEditorPriority=e.$lI=e.$kI=e.$jI=e.$iI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$hI=e.$gI=e.$fI=e.$eI=e.CellKind=e.$dI=e.$cI=e.$bI=void 0,e.$bI="workbench.editor.notebook",e.$cI="workbench.editor.notebookTextDiffEditor",e.$dI="workbench.editor.interactive";var R;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(R||(e.CellKind=R={})),e.$eI=["application/json","application/javascript","text/html","image/svg+xml",T.$Qr.latex,T.$Qr.markdown,"image/png","image/jpeg",T.$Qr.text],e.$fI=[T.$Qr.latex,T.$Qr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$Qr.text],e.$gI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$hI="_notAvailable";var k;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var c;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(c||(e.NotebookCellExecutionState=c={}));var b;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var p;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var f;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var a;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var $;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const ie=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${ie.join("")}]+`),Ee=7;function Se(be,_){const B=_.toString(Ee),ee=`${B.length<ie.length?ie[B.length-1]:"z"}${B}s${(0,y.$ve)(y.$be.fromString(be.scheme),!0,!0)}`;return be.with({scheme:N.scheme,fragment:ee})}N.generate=Se;function Pe(be){if(be.scheme!==N.scheme)return;const _=be.fragment.indexOf("s");if(_<0)return;const B=parseInt(be.fragment.substring(0,_).replace(X,""),Ee),Z=(0,y.$ue)(be.fragment.substring(_+1)).toString();if(!isNaN(B))return{handle:B,notebook:be.with({scheme:Z,fragment:null})}}N.parse=Pe;function $e(be,_){return be.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${be.scheme!==A.Schemas.file?be.scheme:""}`})}N.generateCellOutputUri=$e;function pe(be){if(be.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!_)return;const B=_[1]&&_[1]!==""?_[1]:void 0,Z=_[2];return{outputId:B,notebook:be.with({scheme:Z||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=pe;function ue(be,_,B){return N.generate(be,_).with({scheme:B})}N.generateCellPropertyUri=ue;function oe(be,_){if(be.scheme===_)return N.parse(be.with({scheme:N.scheme}))}N.parseCellPropertyUri=oe})($||(e.CellUri=$={}));const E=N=>D.$j?N.replace(/\//g,"\\"):N;class v{constructor(ie=[],X=e.$eI){this.e=X,this.d=[...new Set(ie)].map(Ee=>({pattern:Ee,matches:M.$wj(E(Ee))}))}sort(ie){const X=new Map(C.Iterable.map(ie,Se=>[Se,E(Se)]));let Ee=[];for(const{matches:Se}of this.d)for(const[Pe,$e]of X)if(Se($e)){Ee.push(Pe),X.delete(Pe);break}return X.size&&(Ee=Ee.concat([...X.keys()].sort((Se,Pe)=>this.e.indexOf(Se)-this.e.indexOf(Pe)))),Ee}prioritize(ie,X){const Ee=this.f(ie);if(Ee===-1){this.d.unshift({pattern:ie,matches:M.$wj(E(ie))});return}const Se=new Set(X.map($e=>this.f($e,Ee)));Se.delete(-1);const Pe=Array.from(Se).sort();this.d.splice(Ee+1,0,...Pe.map($e=>this.d[$e]));for(let $e=Pe.length-1;$e>=0;$e--)this.d.splice(Pe[$e],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,X=this.d.length){const Ee=E(ie);for(let Se=0;Se<X;Se++)if(this.d[Se].matches(Ee))return Se;return-1}}e.$iI=v;function n(N,ie,X,Ee=(Se,Pe)=>Se===Pe){const Se=[];function Pe(ue,oe,be){if(oe===0&&be.length===0)return;const _=Se[Se.length-1];_&&_.start+_.deleteCount===ue?(_.deleteCount+=oe,_.toInsert.push(...be)):Se.push({start:ue,deleteCount:oe,toInsert:be})}let $e=0,pe=0;for(;;){if($e===N.length){Pe($e,0,ie.slice(pe));break}if(pe===ie.length){Pe($e,N.length-$e,[]);break}const ue=N[$e],oe=ie[pe];if(Ee(ue,oe)){$e+=1,pe+=1;continue}X(oe)?(Pe($e,1,[]),$e+=1):(Pe($e,0,[oe]),pe+=1)}return Se}e.$jI=n,e.$kI=new g.$7i("notebookEditorCursorAtBoundary","none"),e.$lI=new g.$7i("notebookEditorCursorAtLineBoundary","none");var r;(function(N){N.default="default",N.option="option"})(r||(e.NotebookEditorPriority=r={}));function s(N){const ie=N;return!!((typeof ie.include=="string"||M.$xj(ie.include))&&(typeof ie.exclude=="string"||M.$xj(ie.exclude)))}e.$mI=s;function o(N,ie,X){if(Array.isArray(N.viewType)&&N.viewType.indexOf(ie)>=0||N.viewType===ie)return!0;if(N.filenamePattern){const Ee=s(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,Se=s(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(M.$vj(Ee,(0,l.$nc)(X.fsPath).toLowerCase()))return!(Se&&M.$vj(Se,(0,l.$nc)(X.fsPath).toLowerCase()))}return!1}e.$nI=o,e.$oI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var w;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class d{static{this.d="notebook/"}static create(ie){return`${d.d}${ie}`}static parse(ie){if(ie.startsWith(d.d))return ie.substring(d.d.length)}}e.$pI=d;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$qI=I;const S=new TextDecoder;function u(N){const ie=[];let X=!1;for(const $e of N)(ie.length===0||X)&&(ie.push($e),X=!0);let Ee=P(ie);const Se=y.$be.concat(ie.map($e=>y.$be.wrap($e))),Pe=O(Se);return Ee=Ee||Pe.byteLength!==Se.byteLength,{data:Pe,didCompression:Ee}}e.$rI=u,e.$sI=`${String.fromCharCode(27)}[A`;const m=e.$sI.split("").map(N=>N.charCodeAt(0)),h=10;function P(N){let ie=!1;return N.forEach((X,Ee)=>{if(Ee===0||X.length<e.$sI.length)return;const Se=N[Ee-1],Pe=X.subarray(0,e.$sI.length);if(Pe[0]===m[0]&&Pe[1]===m[1]&&Pe[2]===m[2]){const $e=Se.lastIndexOf(h);if($e===-1)return;ie=!0,N[Ee-1]=Se.subarray(0,$e),N[Ee]=X.subarray(e.$sI.length)}}),ie}function W(N){let ie=N;do N=ie,ie=N.replace(/[^\n]\x08/gm,"");while(ie.length<N.length);return N}function K(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const ie=N.match(/^(.*)\r+/m)[1];let X=N.match(/\r+(.*)$/m)[1];X=X+ie.slice(X.length,ie.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return N}const z="\b".charCodeAt(0),j="\r".charCodeAt(0);function O(N){return!N.buffer.includes(z)&&!N.buffer.includes(j)?N:y.$be.fromString(K(W(S.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,9,50,28,67,16,15,2,36,21,39,97,75]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p){"use strict";var f,t,i,a,$,E,v,n,r,s,o,w,d,I,S,u,m,h;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$9L=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.TestRunProfileKind=e.TestResultState=e.$PL=e.$OL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$NL=e.$ML=e.$LL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$KL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.ColorThemeKind=e.$EL=e.$DL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$CL=e.DebugConsoleMode=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$wL=e.$vL=e.FileChangeType=e.$uL=e.$tL=e.$sL=e.$rL=e.InlineCompletionTriggerKind=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.ConfigurationTarget=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$7K=e.ViewBadge=e.ProgressLocation=e.$6K=e.$5K=e.TaskScope=e.ShellQuoting=e.$4K=e.$3K=e.$2K=e.TaskPanelKind=e.TaskRevealKind=e.$1K=e.TerminalLocation=e.$ZK=e.$YK=e.$XK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$WK=e.$VK=e.$UK=e.$TK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$SK=e.StatusBarAlignment=e.ViewColumn=e.$RK=e.$QK=e.$PK=e.$OK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$NK=e.$MK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.LanguageStatusSeverity=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.CodeActionTriggerKind=e.$AK=e.$zK=e.SymbolTag=e.SymbolKind=e.$yK=e.DocumentHighlightKind=e.$xK=e.$wK=e.$vK=e.$uK=e.DiagnosticSeverity=e.DiagnosticTag=e.$tK=e.$sK=e.FileEditType=e.$rK=e.$qK=e.$pK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(U){return Object.assign(U,{apply:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const ke=se.length===1?[]:se[1];return Reflect.construct(U,ke,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const[ke,...He]=se;return Reflect.construct(U,He,ke.constructor)}}})}var W;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var K;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let z=f=class{static from(...L){let se=L;return new f(function(){if(se){for(const ke of se)ke&&typeof ke.dispose=="function"&&ke.dispose();se=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$iK=z,e.$iK=z=f=qe([P],z);let j=t=class{static Min(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let ke=1;ke<L.length;ke++){const He=L[ke];He.isBefore(se)&&(se=He)}return se}static Max(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let ke=1;ke<L.length;ke++){const He=L[ke];He.isAfter(se)&&(se=He)}return se}static isPosition(L){if(!L)return!1;if(L instanceof t)return!0;const{line:se,character:ke}=L;return typeof se=="number"&&typeof ke=="number"}static of(L){if(L instanceof t)return L;if(this.isPosition(L))return new t(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,se){if(L<0)throw(0,M.$7)("line must be non-negative");if(se<0)throw(0,M.$7)("character must be non-negative");this.c=L,this.e=se}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,se=0){if(L===null||se===null)throw(0,M.$7)();let ke;return typeof L>"u"?ke=0:typeof L=="number"?ke=L:(ke=typeof L.lineDelta=="number"?L.lineDelta:0,se=typeof L.characterDelta=="number"?L.characterDelta:0),ke===0&&se===0?this:new t(this.line+ke,this.character+se)}with(L,se=this.character){if(L===null||se===null)throw(0,M.$7)();let ke;return typeof L>"u"?ke=this.line:typeof L=="number"?ke=L:(ke=typeof L.line=="number"?L.line:this.line,se=typeof L.character=="number"?L.character:this.character),ke===this.line&&se===this.character?this:new t(ke,se)}toJSON(){return{line:this.line,character:this.character}}};e.$jK=j,e.$jK=j=t=qe([P],j);let O=i=class{static isRange(L){return L instanceof i?!0:L?j.isPosition(L.start)&&j.isPosition(L.end):!1}static of(L){if(L instanceof i)return L;if(this.isRange(L))return new i(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,se,ke,He){let Ze,ot;if(typeof L=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof He=="number"?(Ze=new j(L,se),ot=new j(ke,He)):j.isPosition(L)&&j.isPosition(se)&&(Ze=j.of(L),ot=j.of(se)),!Ze||!ot)throw new Error("Invalid arguments");Ze.isBefore(ot)?(this.c=Ze,this.e=ot):(this.c=ot,this.e=Ze)}contains(L){return i.isRange(L)?this.contains(L.start)&&this.contains(L.end):j.isPosition(L)?!(j.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const se=j.Max(L.start,this.c),ke=j.Min(L.end,this.e);if(!se.isAfter(ke))return new i(se,ke)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const se=j.Min(L.start,this.c),ke=j.Max(L.end,this.end);return new i(se,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,se=this.end){if(L===null||se===null)throw(0,M.$7)();let ke;return L?j.isPosition(L)?ke=L:(ke=L.start||this.start,se=L.end||this.end):ke=this.start,ke.isEqual(this.c)&&se.isEqual(this.end)?this:new i(ke,se)}toJSON(){return[this.start,this.end]}};e.$kK=O,e.$kK=O=i=qe([P],O);let N=a=class extends O{static isSelection(L){return L instanceof a?!0:L?O.isRange(L)&&j.isPosition(L.anchor)&&j.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,se,ke,He){let Ze,ot;if(typeof L=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof He=="number"?(Ze=new j(L,se),ot=new j(ke,He)):j.isPosition(L)&&j.isPosition(se)&&(Ze=j.of(L),ot=j.of(se)),!Ze||!ot)throw new Error("Invalid arguments");super(Ze,ot),this.f=Ze,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$lK=N,e.$lK=N=a=qe([P],N);const ie=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,M.$7)("connectionToken")};class X{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,se,ke){if(typeof L!="string"||L.length===0)throw(0,M.$7)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,M.$7)("port");typeof ke<"u"&&ie(ke),this.host=L,this.port=Math.round(se),this.connectionToken=ke}}e.$mK=X;class Ee{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,se){this.makeConnection=L,this.connectionToken=se,typeof se<"u"&&ie(se)}}e.$nK=Ee;class Se extends Error{static NotAvailable(L,se){return new Se(L,b.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(L){return new Se(L,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,se=b.RemoteAuthorityResolverErrorCode.Unknown,ke){super(L),this._message=L,this._code=se,this._detail=ke,Object.setPrototypeOf(this,Se.prototype)}}e.$oK=Se;var Pe;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var $e;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})($e||(e.EnvironmentVariableMutatorType=$e={}));let pe=$=class{static isTextEdit(L){return L instanceof $?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,se){return new $(L,se)}static insert(L,se){return $.replace(new O(L,L),se)}static delete(L){return $.replace(L,"")}static setEndOfLine(L){const se=new $(new O(new j(0,0),new j(0,0)),"");return se.newEol=L,se}get range(){return this.c}set range(L){if(L&&!O.isRange(L))throw(0,M.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,M.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,M.$7)("newEol");this.f=L}constructor(L,se){this.c=L,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$pK=pe,e.$pK=pe=$=qe([P],pe);let ue=E=class{static isNotebookCellEdit(L){return L instanceof E?!0:L?xt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,se){return new E(L,se)}static insertCells(L,se){return new E(new xt(L,L),se)}static deleteCells(L){return new E(L,[])}static updateCellMetadata(L,se){const ke=new E(new xt(L,L),[]);return ke.newCellMetadata=se,ke}static updateNotebookMetadata(L){const se=new E(new xt(0,0),[]);return se.newNotebookMetadata=L,se}constructor(L,se){this.range=L,this.newCells=se}};e.$qK=ue,e.$qK=ue=E=qe([P],ue);class oe{static isSnippetTextEdit(L){return L instanceof oe?!0:L?O.isRange(L.range)&&B.isSnippetString(L.snippet):!1}static replace(L,se){return new oe(L,se)}static insert(L,se){return oe.replace(new O(L,L),se)}constructor(L,se){this.range=L,this.snippet=se}}e.$rK=oe;var be;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let _=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,se,ke,He){this.c.push({_type:1,from:L,to:se,options:ke,metadata:He})}createFile(L,se,ke){this.c.push({_type:1,from:void 0,to:L,options:se,metadata:ke})}deleteFile(L,se,ke){this.c.push({_type:1,from:L,to:void 0,options:se,metadata:ke})}e(L,se,ke){this.c.push({_type:3,metadata:ke,uri:L,edit:{editType:5,metadata:se},notebookMetadata:se})}f(L,se,ke,He){const Ze=se.start,ot=se.end;(Ze!==ot||ke.length>0)&&this.c.push({_type:5,uri:L,index:Ze,count:ot-Ze,cells:ke,metadata:He})}g(L,se,ke,He){this.c.push({_type:3,metadata:He,uri:L,edit:{editType:3,index:se,metadata:ke}})}replace(L,se,ke,He){this.c.push({_type:2,uri:L,edit:new pe(se,ke),metadata:He})}insert(L,se,ke,He){this.replace(L,new O(se,se),ke,He)}delete(L,se,ke){this.replace(L,se,"",ke)}has(L){return this.c.some(se=>se._type===2&&se.uri.toString()===L.toString())}set(L,se){if(se)for(const ke of se){if(!ke)continue;let He,Ze;Array.isArray(ke)?(He=ke[0],Ze=ke[1]):He=ke,ue.isNotebookCellEdit(He)?He.newCellMetadata?this.g(L,He.range.start,He.newCellMetadata,Ze):He.newNotebookMetadata?this.e(L,He.newNotebookMetadata,Ze):this.f(L,He.range,He.newCells,Ze):oe.isSnippetTextEdit(He)?this.c.push({_type:6,uri:L,range:He.range,edit:He.snippet,metadata:Ze}):this.c.push({_type:2,uri:L,edit:He,metadata:Ze})}else{for(let ke=0;ke<this.c.length;ke++){const He=this.c[ke];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===L.toString()&&(this.c[ke]=void 0);break}}(0,y.$Ib)(this.c)}}get(L){const se=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===L.toString()&&se.push(ke.edit);return se}entries(){const L=new T.$Ac;for(const se of this.c)if(se._type===2){let ke=L.get(se.uri);ke||(ke=[se.uri,[]],L.set(se.uri,ke)),ke[1].push(se.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$sK=_,e.$sK=_=qe([P],_);let B=v=class{static isSnippetString(L){return L instanceof v?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=v.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,se=this.e++){if(typeof L=="function"){const ke=new v;ke.e=this.e,L(ke),this.e=ke.e,L=ke.value}else L=v.c(L);return this.value+="${",this.value+=se,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,se=this.e++){const ke=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(L,se){if(typeof se=="function"){const ke=new v;ke.e=this.e,se(ke),this.e=ke.e,se=ke.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$tK=B,e.$tK=B=v=qe([P],B);var Z;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var ee;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let ve=n=class{static isLocation(L){return L instanceof n?!0:L?O.isRange(L.range)&&g.URI.isUri(L.uri):!1}constructor(L,se){if(this.uri=L,se)if(O.isRange(se))this.range=O.of(se);else if(j.isPosition(se))this.range=new O(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$uK=ve,e.$uK=ve=n=qe([P],ve);let ge=class{static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&g.URI.isUri(L.location.uri):!1}constructor(L,se){this.location=L,this.message=se}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.location.range.isEqual(se.location.range)&&L.location.uri.toString()===se.location.uri.toString()}};e.$vK=ge,e.$vK=ge=qe([P],ge);let he=class{constructor(L,se,ke=ee.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=L,this.message=se,this.severity=ke}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.severity===se.severity&&L.code===se.code&&L.severity===se.severity&&L.source===se.source&&L.range.isEqual(se.range)&&(0,y.$ub)(L.tags,se.tags)&&(0,y.$ub)(L.relatedInformation,se.relatedInformation,ge.isEqual)}};e.$wK=he,e.$wK=he=qe([P],he);let De=class{constructor(L,se){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=se}};e.$xK=De,e.$xK=De=qe([P],De);var re;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let le=class{constructor(L,se=re.Text){this.range=L,this.kind=se}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$yK=le,e.$yK=le=qe([P],le);var ne;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(ne||(e.SymbolKind=ne={}));var ae;(function(U){U[U.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let fe=r=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,se,ke,He,Ze){this.name=L,this.kind=se,this.containerName=Ze,typeof ke=="string"&&(this.containerName=ke),He instanceof ve?this.location=He:ke instanceof O&&(this.location=new ve(He,ke)),r.validate(this)}toJSON(){return{name:this.name,kind:ne[this.kind],location:this.location,containerName:this.containerName}}};e.$zK=fe,e.$zK=fe=r=qe([P],fe);let Ie=s=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(s.validate)}constructor(L,se,ke,He,Ze){this.name=L,this.detail=se,this.kind=ke,this.range=He,this.selectionRange=Ze,this.children=[],s.validate(this)}};e.$AK=Ie,e.$AK=Ie=s=qe([P],Ie);var F;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(F||(e.CodeActionTriggerKind=F={}));let V=class{constructor(L,se){this.title=L,this.kind=se}};e.$BK=V,e.$BK=V=qe([P],V);let G=class{static{o=this}static{this.c="."}constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.c)}};e.$CK=G,e.$CK=G=o=qe([P],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(L,se){if(this.range=L,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$DK=J,e.$DK=J=qe([P],J);class q{constructor(L,se,ke,He,Ze,ot){this.kind=L,this.name=se,this.detail=ke,this.uri=He,this.range=Ze,this.selectionRange=ot}}e.$EK=q;class x{constructor(L,se){this.fromRanges=se,this.from=L}}e.$FK=x;class ce{constructor(L,se){this.fromRanges=se,this.to=L}}e.$GK=ce;var Ne;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ue=class{constructor(L,se){this.range=L,this.command=se}get isResolved(){return!!this.command}};e.$HK=Ue,e.$HK=Ue=qe([P],Ue);let Qe=w=class{#e;static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,se=!1){this.#e=new C.$3j(L,{supportThemeIcons:se})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,se){return this.#e.appendCodeblock(se??"",L),this}};e.$IK=Qe,e.$IK=Qe=w=qe([P],Qe);let Ge=class{constructor(L,se){this.label=L,this.documentation=se}};e.$JK=Ge,e.$JK=Ge=qe([P],Ge);let xe=class{constructor(L,se){this.label=L,this.documentation=se,this.parameters=[]}};e.$KK=xe,e.$KK=xe=qe([P],xe);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$LK=Ye,e.$LK=Ye=qe([P],Ye);var _e;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var it;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(L){this.value=L}};e.$MK=tt,e.$MK=tt=qe([P],tt);let ze=class{constructor(L,se,ke){this.position=L,this.label=se,this.kind=ke}};e.$NK=ze,e.$NK=ze=qe([P],ze);var st;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Y;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var Q;(function(U){U[U.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let we=class{constructor(L,se){this.label=L,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$OK=we,e.$OK=we=qe([P],we);let Be=class{constructor(L=[],se=!1){this.items=L,this.isIncomplete=se}};e.$PK=Be,e.$PK=Be=qe([P],Be);let Oe=class{constructor(L,se,ke){this.insertText=L,this.range=se,this.command=ke}};e.$QK=Oe,e.$QK=Oe=qe([P],Oe);let Xe=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$RK=Xe,e.$RK=Xe=qe([P],Xe);var nt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ft;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ft||(e.StatusBarAlignment=ft={}));function wt(U,L){return`${k.$6l.toKey(U)}.${L}`}e.$SK=wt;var Pt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Zt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Zt||(e.TextDocumentSaveReason=Zt={}));var Gt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var pt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var jt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Nt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(U){function L(se){switch(se){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Bt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(U){function L(se){switch(se){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=L}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(L,se){if(se&&!g.URI.isUri(se))throw(0,M.$7)("target");if(!O.isRange(L)||L.isEmpty)throw(0,M.$7)("range");this.range=L,this.target=se}};e.$TK=At,e.$TK=At=qe([P],At);let Rt=class{constructor(L,se,ke,He){this.red=L,this.green=se,this.blue=ke,this.alpha=He}};e.$UK=Rt,e.$UK=Rt=qe([P],Rt);let Ot=class{constructor(L,se){if(se&&!(se instanceof Rt))throw(0,M.$7)("color");if(!O.isRange(L)||L.isEmpty)throw(0,M.$7)("range");this.range=L,this.color=se}};e.$VK=Ot,e.$VK=Ot=qe([P],Ot);let Wt=class{constructor(L){if(!L||typeof L!="string")throw(0,M.$7)("label");this.label=L}};e.$WK=Wt,e.$WK=Wt=qe([P],Wt);var Jt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Kt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var Vt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Mt{constructor(L,se,ke){if(this.startIndex=L,this.length=se,this.tooltip=ke,typeof L!="number"||L<0)throw(0,M.$7)("startIndex");if(typeof se!="number"||se<1)throw(0,M.$7)("length");if(ke!==void 0&&typeof ke!="string")throw(0,M.$7)("tooltip")}}e.$XK=Mt;class ut{constructor(L){this.uri=L}}e.$YK=ut;class dt{constructor(L){this.terminalCommand=L}}e.$ZK=dt;var Lt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Lt||(e.TerminalLocation=Lt={}));class qt{constructor(L){if(this.options=L,typeof L!="object")throw(0,M.$7)("options")}}e.$1K=qt;var kt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var at;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(at||(e.TaskPanelKind=at={}));let vt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(L){switch(L){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(L,se){if(this.label=se,typeof L!="string"||typeof se!="string")throw(0,M.$7)("name");this.c=L}get id(){return this.c}};e.$2K=vt,e.$2K=vt=d=qe([P],vt);function Ht(U){let L="";for(let se=0;se<U.length;se++)L+=U[se].replace(/,/g,",,")+",";return L}let Ct=class{constructor(L,se,ke){if(typeof L!="string")throw(0,M.$7)("process");this.e=[],this.c=L,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=ke):this.f=se)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,M.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const se of this.e)L.push(se);return Ht(L)}};e.$3K=Ct,e.$3K=Ct=qe([P],Ct);let We=class{constructor(L,se,ke){if(this.f=[],Array.isArray(se)){if(!L)throw(0,M.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$7)("command");this.e=L,this.f=se,this.g=ke}else{if(typeof L!="string")throw(0,M.$7)("commandLine");this.c=L,this.g=se}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,M.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)L.push(typeof se=="string"?se:se.value);return Ht(L)}};e.$4K=We,e.$4K=We=qe([P],We);var Ce;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Ce||(e.ShellQuoting=Ce={}));var Fe;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Fe||(e.TaskScope=Fe={}));class me{constructor(L){this.c=L}computeId(){return"customExecution"+(0,R.$eg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$5K=me;let H=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,se,ke,He,Ze,ot){this.j=!1,this.k=this.definition=L;let ht;typeof se=="string"?(this.m=this.name=se,this.t=this.source=ke,this.execution=He,ht=Ze,this.j=!0):se===Fe.Global||se===Fe.Workspace?(this.target=se,this.m=this.name=ke,this.t=this.source=He,this.execution=Ze,ht=ot):(this.target=se,this.m=this.name=ke,this.t=this.source=He,this.execution=Ze,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ct?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof me?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,R.$eg)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,M.$7)("Kind can't be undefined or null");this.z(),this.k=L}get scope(){return this.l}set target(L){this.z(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,M.$7)("name");this.z(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.z(),this.n=L;const se=this.k.type;(I.g===se||I.e===se||I.f===se||I.c===se)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.z(),this.o=L,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.z(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.$7)("source must be a string of length > 0");this.z(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.z(),this.u=L}get detail(){return this.y}set detail(L){L===null&&(L=void 0),this.y=L}get presentationOptions(){return this.w}set presentationOptions(L){L==null&&(L=Object.create(null)),this.z(),this.w=L}get runOptions(){return this.x}set runOptions(L){L==null&&(L=Object.create(null)),this.z(),this.x=L}};e.$6K=H,e.$6K=H=I=qe([P],H);var Me;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Me||(e.ProgressLocation=Me={}));var je;(function(U){function L(se){const ke=se;return(0,D.$Cf)(ke.value)?ke.tooltip&&!(0,D.$yf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}U.isViewBadge=L})(je||(e.ViewBadge=je={}));let Je=S=class{static isTreeItem(L,se){const ke=L;if(ke.checkboxState!==void 0){const He=(0,D.$Cf)(ke.checkboxState)?ke.checkboxState:(0,D.$Af)(ke.checkboxState)&&(0,D.$Cf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ze=!(0,D.$Cf)(ke.checkboxState)&&(0,D.$Af)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(He===void 0||He!==et.Checked&&He!==et.Unchecked||Ze!==void 0&&!(0,D.$yf)(Ze))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(L instanceof S)return!0;if(ke.label!==void 0&&!(0,D.$yf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,D.$yf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,D.$yf)(ke.iconPath)&&!g.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,D.$yf)(ke.iconPath.id))){const He=ke.iconPath;if(!He||!(0,D.$yf)(He.light)&&!g.URI.isUri(He.light)&&!(0,D.$yf)(He.dark)&&!g.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,D.$yf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!g.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,D.$yf)(ke.tooltip)&&!(ke.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Ve.None&&ke.collapsibleState>Ve.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,D.$yf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(L,se=Ve.None){this.collapsibleState=se,g.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$7K=Je,e.$7K=Je=S=qe([P],Je);var Ve;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Ve||(e.TreeItemCollapsibleState=Ve={}));var et;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(et||(e.TreeItemCheckboxState=et={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$8K=bt,e.$8K=bt=qe([P],bt);class zt extends bt{}e.$9K=zt;class Dt extends zt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$0K=Dt;class lt{constructor(L,se,ke,He){this.name=L,this.uri=se,this._itemId=ke,this.c=He}data(){return this.c()}}e.$$K=lt;let gt=class{#e=new Map;constructor(L){for(const[se,ke]of L??[]){const He=this.#e.get(this.#t(se));He?He.push(ke):this.#e.set(this.#t(se),[ke])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,se){this.#e.set(this.#t(L),[se])}forEach(L,se){for(const[ke,He]of this.#e)for(const Ze of He)L.call(se,Ze,ke,this)}*[Symbol.iterator](){for(const[L,se]of this.#e)for(const ke of se)yield[L,ke]}#t(L){return L.toLowerCase()}};e.$_K=gt,e.$_K=gt=qe([P],gt);let yt=class{constructor(L){this.insertText=L}};e.$aL=yt,e.$aL=yt=qe([P],yt);let mi=class{constructor(L,se){this.label=se,this.insertText=L}};e.$bL=mi,e.$bL=mi=qe([P],mi);let St=class{constructor(L,se){this.id=L,this.color=se}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$cL=St,e.$cL=St=qe([P],St),St.File=new St("file"),St.Folder=new St("folder");let Si=class{constructor(L){this.id=L}};e.$dL=Si,e.$dL=Si=qe([P],Si);var ui;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let $i=class{get base(){return this.c}set base(L){this.c=L,this.e=g.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,se){if(typeof L!="string"&&(!L||!g.URI.isUri(L)&&!g.URI.isUri(L.uri)))throw(0,M.$7)("base");if(typeof se!="string")throw(0,M.$7)("pattern");typeof L=="string"?this.baseUri=g.URI.file(L):g.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eL=$i,e.$eL=$i=qe([P],$i);const It=new WeakMap;function fn(U,L){It.set(U,L)}e.$fL=fn;let ri=class{constructor(L,se,ke,He){this.enabled=typeof L=="boolean"?L:!0,typeof se=="string"&&(this.condition=se),typeof ke=="string"&&(this.hitCondition=ke),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=It.get(this)??(0,R.$eg)()),this.c}};e.$gL=ri,e.$gL=ri=qe([P],ri);let Et=class extends ri{constructor(L,se,ke,He,Ze){if(super(se,ke,He,Ze),L===null)throw(0,M.$7)("location");this.location=L}};e.$hL=Et,e.$hL=Et=qe([P],Et);let pi=class extends ri{constructor(L,se,ke,He,Ze){super(se,ke,He,Ze),this.functionName=L}};e.$iL=pi,e.$iL=pi=qe([P],pi);let vi=class extends ri{constructor(L,se,ke,He,Ze,ot,ht){if(super(He,Ze,ot,ht),!se)throw(0,M.$7)("dataId");this.label=L,this.dataId=se,this.canPersist=ke}};e.$jL=vi,e.$jL=vi=qe([P],vi);let si=class{constructor(L,se,ke){this.command=L,this.args=se||[],this.options=ke}};e.$kL=si,e.$kL=si=qe([P],si);let Ii=class{constructor(L,se){this.port=L,this.host=se}};e.$lL=Ii,e.$lL=Ii=qe([P],Ii);let Ci=class{constructor(L){this.path=L}};e.$mL=Ci,e.$mL=Ci=qe([P],Ci);let Ft=class{constructor(L){this.implementation=L}};e.$nL=Ft,e.$nL=Ft=qe([P],Ft);let bi=class{constructor(L,se,ke){this.session=L,this.threadId=se,this.frameId=ke}};e.$oL=bi,e.$oL=bi=qe([P],bi);let Pi=class{constructor(L,se){this.session=L,this.threadId=se}};e.$pL=Pi,e.$pL=Pi=qe([P],Pi);let oi=class{constructor(L,se){this.range=L,this.expression=se}};e.$qL=oi,e.$qL=oi=qe([P],oi);var li;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(li||(e.InlineCompletionTriggerKind=li={}));let ct=class{constructor(L,se){this.range=L,this.text=se}};e.$rL=ct,e.$rL=ct=qe([P],ct);let Ai=class{constructor(L,se,ke=!0){this.range=L,this.variableName=se,this.caseSensitiveLookup=ke}};e.$sL=Ai,e.$sL=Ai=qe([P],Ai);let Yt=class{constructor(L,se){this.range=L,this.expression=se}};e.$tL=Yt,e.$tL=Yt=qe([P],Yt);let ii=class{constructor(L,se){this.frameId=L,this.stoppedLocation=se}};e.$uL=ii,e.$uL=ii=qe([P],ii);var Ri;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=u=class extends Error{static FileExists(L){return new u(L,c.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(L){return new u(L,c.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(L){return new u(L,c.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(L){return new u(L,c.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(L){return new u(L,c.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(L){return new u(L,c.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(L,se=c.FileSystemProviderErrorCode.Unknown,ke){super(g.URI.isUri(L)?L.toString(!0):L),this.code=ke?.name??"Unknown",(0,c.$nk)(this,se),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$vL=Mi,e.$vL=Mi=u=qe([P],Mi);let Fi=class{constructor(L,se,ke){this.start=L,this.end=se,this.kind=ke}};e.$wL=Fi,e.$wL=Fi=qe([P],Fi);var Xi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Ti;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ti||(e.CommentThreadCollapsibleState=Ti={}));var Zi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Li;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var ai;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(L,se=[]){this.tokenTypes=L,this.tokenModifiers=se}}e.$xL=gn;function Ni(U){return typeof U>"u"||(0,D.$zf)(U)}class hi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let se=0,ke=L.tokenTypes.length;se<ke;se++)this.j.set(L.tokenTypes[se],se);for(let se=0,ke=L.tokenModifiers.length;se<ke;se++)this.k.set(L.tokenModifiers[se],se)}}push(L,se,ke,He,Ze){if(typeof L=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof He=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(L,se,ke,He,Ze);if(O.isRange(L)&&typeof se=="string"&&Ni(ke))return this.m(L,se,ke);throw(0,M.$7)()}m(L,se,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Ze=L.start.character,ot=L.end.character-L.start.character,ht=this.j.get(se);let Ut=0;if(ke)for(const Xt of ke){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);Ut|=1<<ei>>>0}this.n(He,Ze,ot,ht,Ut)}n(L,se,ke,He,Ze){if(this.f&&(L<this.c||L===this.c&&se<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<Ut;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Xt,Ji+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Xt=ni,ei=Ji}}let ot=L,ht=se;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=ke,this.g[this.h++]=He,this.g[this.h++]=Ze,this.c=L,this.e=se}static o(L){const se=[],ke=L.length/5|0;for(let ht=0;ht<ke;ht++)se[ht]=ht;se.sort((ht,Ut)=>{const Xt=L[5*ht],ei=L[5*Ut];if(Xt===ei){const ti=L[5*ht+1],ni=L[5*Ut+1];return ti-ni}return Xt-ei});const He=new Uint32Array(L.length);let Ze=0,ot=0;for(let ht=0;ht<ke;ht++){const Ut=5*se[ht],Xt=L[Ut+0],ei=L[Ut+1],ti=L[Ut+2],ni=L[Ut+3],Ji=L[Ut+4],Cn=Xt-Ze,Tn=Cn===0?ei-ot:ei,Qi=5*ht;He[Qi+0]=Cn,He[Qi+1]=Tn,He[Qi+2]=ti,He[Qi+3]=ni,He[Qi+4]=Ji,Ze=Xt,ot=ei}return He}build(L){return this.f?new Oi(new Uint32Array(this.g),L):new Oi(hi.o(this.g),L)}}e.$yL=hi;class Oi{constructor(L,se){this.resultId=se,this.data=L}}e.$zL=Oi;class mn{constructor(L,se,ke){this.start=L,this.deleteCount=se,this.data=ke}}e.$AL=mn;class di{constructor(L,se){this.resultId=se,this.edits=L}}e.$BL=di;var Yi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let zi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$CL=zi,e.$CL=zi=qe([P],zi);var xi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var fi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var _i;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(L){if(typeof L.badge=="string"){let se=(0,l.$_e)(L.badge,0);if(se<L.badge.length&&(se+=(0,l.$_e)(L.badge,se)),L.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!St.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,se,ke){this.badge=L,this.tooltip=se,this.color=ke}}e.$DL=$n;let Ui=class{constructor(L){this.kind=L}};e.$EL=Ui,e.$EL=Ui=qe([P],Ui);var gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(gi||(e.ColorThemeKind=gi={}));class xt{static isNotebookRange(L){return L instanceof xt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,se){if(L<0)throw(0,M.$7)("start must be positive");if(se<0)throw(0,M.$7)("end must be positive");L<=se?(this.c=L,this.e=se):(this.c=se,this.e=L)}with(L){let se=this.c,ke=this.e;return L.start!==void 0&&(se=L.start),L.end!==void 0&&(ke=L.end),se===this.c&&ke===this.e?this:new xt(se,ke)}}e.$FL=xt;class wi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(se=>wi.isNotebookCellData(se))}static isNotebookCellData(L){return!0}constructor(L,se,ke,He,Ze,ot,ht){this.kind=L,this.value=se,this.languageId=ke,this.mime=He,this.outputs=Ze??[],this.metadata=ot,this.executionSummary=ht,wi.validate(this)}}e.$GL=wi;class pn{constructor(L){this.cells=L}}e.$HL=pn;class Qt{static isNotebookCellOutputItem(L){return L instanceof Qt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const se={name:L.name,message:L.message,stack:L.stack};return Qt.json(se,"application/vnd.code.notebook.error")}static stdout(L){return Qt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Qt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,se="application/octet-stream"){return new Qt(L,se)}static#e=new TextEncoder;static text(L,se=A.$Qr.text){const ke=Qt.#e.encode(String(L));return new Qt(ke,se)}static json(L,se="text/x-json"){const ke=JSON.stringify(L,void 0,"	");return Qt.text(ke,se)}constructor(L,se){this.data=L,this.mime=se;const ke=(0,A.$Ur)(se,!0);if(!ke)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$IL=Qt;class yi{static isNotebookCellOutput(L){return L instanceof yi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,se=!1){const ke=new Set,He=new Set;for(let Ze=0;Ze<L.length;Ze++){const ot=L[Ze],ht=(0,A.$Ur)(ot.mime);if(!ke.has(ht)||(0,p.$qI)(ht)){ke.add(ht);continue}He.add(Ze),se&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return He.size===0?L:L.filter((Ze,ot)=>!He.has(ot))}constructor(L,se,ke){this.items=yi.ensureUniqueMimeTypes(L,!0),typeof se=="string"?(this.id=se,this.metadata=ke):(this.id=(0,R.$eg)(),this.metadata=se??ke)}}e.$JL=yi;var en;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var tn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ei;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class rn{constructor(L,se){this.text=L,this.alignment=se}}e.$KL=rn;var Le;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Le||(e.NotebookControllerAffinity=Le={}));var _t;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class sn{constructor(L,se=[]){this.uri=L,this.provides=(0,y.$3b)(se)}}e.$LL=sn;class mt{constructor(L){this.label=L}}e.$ML=mt;let ji=class{constructor(L,se){this.label=L,this.timestamp=se}};e.$NL=ji,e.$NL=ji=qe([P],ji);var on;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Bi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var an;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class Di{constructor(L,se){this.ranges=L,this.wordPattern=se}}e.$OL=Di;class vn{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$PL=vn;var cn;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let ki=class{constructor(L=void 0,se=void 0,ke=void 0,He=!1){this.include=L,this.exclude=se,this.profile=ke,this.continuous=He}};e.$QL=ki,e.$QL=ki=qe([P],ki);let Wi=m=class{static diff(L,se,ke){const He=new m(L);return He.expectedOutput=se,He.actualOutput=ke,He}constructor(L){this.message=L}};e.$RL=Wi,e.$RL=Wi=m=qe([P],Wi);let Ki=class{constructor(L){this.id=L}};e.$SL=Ki,e.$SL=Ki=qe([P],Ki);let ci=class{constructor(L,se){this.covered=L,this.total=se}};e.$TL=ci,e.$TL=ci=qe([P],ci);let Vi=h=class{static fromDetails(L,se){const ke=new ci(0,0),He=new ci(0,0),Ze=new ci(0,0);for(const ht of se)if("branches"in ht){ke.total+=1,ke.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)He.total+=1,He.covered+=Ut.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=ht.executionCount>0?1:0;const ot=new h(L,ke,He.total>0?He:void 0,Ze.total>0?Ze:void 0);return ot.detailedCoverage=se,ot}constructor(L,se,ke,He){this.uri=L,this.statementCoverage=se,this.branchCoverage=ke,this.functionCoverage=He}};e.$UL=Vi,e.$UL=Vi=h=qe([P],Vi);let qi=class{constructor(L,se,ke=[]){this.executionCount=L,this.location=se,this.branches=ke}};e.$VL=qi,e.$VL=qi=qe([P],qi);let Hi=class{constructor(L,se){this.executionCount=L,this.location=se}};e.$WL=Hi,e.$WL=Hi=qe([P],Hi);let Gi=class{constructor(L,se){this.executionCount=L,this.location=se}};e.$XL=Gi,e.$XL=Gi=qe([P],Gi);var ln;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(ln||(e.ExternalUriOpenerPriority=ln={}));var hn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(hn||(e.WorkspaceTrustState=hn={}));var dn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn||(e.PortAutoForwardAction=dn={}));class te{constructor(L,se,ke,He,Ze,ot){this.kind=L,this.name=se,this.detail=ke,this.uri=He,this.range=Ze,this.selectionRange=ot}}e.$YL=te;class de{constructor(L){this.uri=L}}e.$ZL=de;class Te{constructor(L,se){this.original=L,this.modified=se}}e.$1L=Te;class rt{constructor(L,se,ke,He){this.base=L,this.input1=se,this.input2=ke,this.result=He}}e.$2L=rt;class $t{constructor(L,se){this.uri=L,this.viewType=se}}e.$3L=$t;class Tt{constructor(L){this.viewType=L}}e.$4L=Tt;class Pn{constructor(L,se){this.uri=L,this.notebookType=se}}e.$5L=Pn;class An{constructor(L,se,ke){this.original=L,this.modified=se,this.notebookType=ke}}e.$6L=An;class Rn{constructor(){}}e.$7L=Rn;class Mn{constructor(L,se){this.uri=L,this.inputBoxUri=se}}e.$8L=Mn;var bn;(function(U){U[U.Up=1]="Up",U[U.Down=2]="Down"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var yn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var Dn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Fn{constructor(L,se){this.role=L,this.content=se}}e.$9L=Fn;var kn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var In;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}))}),define(Ae[100],Re([1,0,52,13,16,280,136,7,18]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.$jM=void 0;const g=new Map;function R(p,f){f?g.set(p,f):g.delete(p)}e.$jM=R;function k(p){return g.get(p)}class c extends T.$Wu{constructor(f,t,i,a,$,E,v,n){super(t,i,a,$),this.c=f,this.m=E,this.q=v,this.notebook=n,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,D.$ub)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===M.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,i){return f.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,y.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,y.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,a=t.start.line,$=t.end.line,E=[];E.push(this.f[a].substring(t.start.character));for(let v=a+1;v<$;v++)E.push(this.f[v]);return E.push(this.f[$].substring(0,t.end.character)),E.join(i)}t(f){let t;if(f instanceof l.$jK?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),i=this.f[t.index].length;return new l.$jK(t.index,Math.min(t.remainder,i))}w(f){if(!(f instanceof l.$kK))throw new Error("Invalid argument");const t=this.x(f.start),i=this.x(f.end);return t===f.start&&i===f.end?f:new l.$kK(t.line,t.character,i.line,i.character)}x(f){if(!(f instanceof l.$jK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:i}=f,a=!1;if(t<0)t=0,i=0,a=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,a=!0;else{const $=this.f[t].length;i<0?(i=0,a=!0):i>$&&(i=$,a=!0)}return a?new l.$jK(t,i):f}y(f,t){const i=this.x(f);if(!t)t=k(this.m);else if((0,C.$Oe)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const a=(0,A.$9r)(i.character+1,(0,A.$7r)(t),this.f[i.line],0);if(a)return new l.$kK(i.line,a.startColumn-1,i.line,a.endColumn-1)}}e.$kM=c;class b{constructor(f,t,i){this.a=f,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$kK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$kK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$lM=b}),define(Ae[197],Re([1,0,7,17,5]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;let T=class{constructor(l){this.a=new y.$EL(y.ColorThemeKind.Dark),this.b=new C.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange(l){let D;switch(l){case"light":D=y.ColorThemeKind.Light;break;case"hcDark":D=y.ColorThemeKind.HighContrast;break;case"hcLight":D=y.ColorThemeKind.HighContrastLight;break;default:D=y.ColorThemeKind.Dark}this.a=new y.$EL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Jdc=T,e.$Jdc=T=qe([Ke(0,M.$hM)],T)}),define(Ae[198],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uI=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$uI=(0,y.$Ph)("INotebookExecutionService")}),define(Ae[46],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(T){T.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var M;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(A,l,D=A.parent){if(A._isRoot)return new C([l]);const g=[A.id];for(let R=D;R&&R.id!==l;R=R.parent)g.push(R.id);return g.push(l),new C(g.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$_I=C}),define(Ae[57],Re([1,0,2,41,46]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$fJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$eJ=e.$dJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$cJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$bJ=e.$aJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var T;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(T||(e.TestResultState=T={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$aJ=[2,4,8,16,32,64];const D=S=>"runId"in S;e.$bJ=D;var g;(function(S){S.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),S.deserialize=u=>({range:M.$us.lift(u.range),uri:y.URI.revive(u.uri)})})(g||(e.IRichLocation=g={}));var R;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(R||(e.TestMessageType=R={}));var k;(function(S){S.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.deserialize(u.location)})})(k||(e.ITestErrorMessage=k={}));const c=(S,u)=>`${u?"s":"e"}${S}`;e.$cJ=c;var b;(function(S){S.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.deserialize(u.location)})})(b||(e.ITestOutputMessage=b={}));var p;(function(S){S.serialize=u=>u.type===0?k.serialize(u):b.serialize(u),S.deserialize=u=>u.type===0?k.deserialize(u):b.deserialize(u)})(p||(e.ITestMessage=p={}));var f;(function(S){S.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),S.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(p.serialize)}),S.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(p.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",i=(S,u)=>S+t+u;e.$dJ=i;const a=S=>{const u=S.indexOf(t);return{ctrlId:S.slice(0,u),tagId:S.slice(u+1)}};e.$eJ=a;var $;(function(S){S.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),S.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?y.URI.revive(u.uri):void 0,range:u.range?M.$us.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})($||(e.ITestItem=$={}));var E;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var v;(function(S){S.serialize=u=>({expand:u.expand,item:$.serialize(u.item)}),S.deserialize=u=>({controllerId:C.$_I.root(u.item.extId),expand:u.expand,item:$.deserialize(u.item)})})(v||(e.InternalTestItem=v={}));var n;(function(S){S.serialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.uri!==void 0&&(m.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(m.range=u.item.range?.toJSON()),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}},S.deserialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.range!==void 0&&(m.range=u.item.range?M.$us.lift(u.item.range):null),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}}})(n||(e.ITestItemUpdate=n={}));const r=(S,u)=>{u.expand!==void 0&&(S.expand=u.expand),u.item!==void 0&&(S.item=S.item?Object.assign(S.item,u.item):u.item)};e.$fJ=r;var s;(function(S){S.serializeWithoutMessages=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serializeWithoutMessages)}),S.serialize=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serialize)}),S.deserialize=u=>({...v.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var o;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(o||(e.DetailType=o={}));var w;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var d;(function(S){S.deserialize=u=>u.op===0?{op:u.op,item:v.deserialize(u.item)}:u.op===1?{op:u.op,item:n.deserialize(u.item)}:u.op===2?{op:u.op,uri:y.URI.revive(u.uri),docv:u.docv}:u,S.serialize=u=>u.op===0?{op:u.op,item:v.serialize(u.item)}:u.op===1?{op:u.op,item:n.serialize(u.item)}:u})(d||(e.TestsDiffOp=d={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const m=this.p();for(const h of u)switch(h.op){case 0:this.k(v.deserialize(h.item),m);break;case 1:this.l(n.deserialize(h.item),m);break;case 3:this.m(h.itemId,m);break;case 5:this.o(h.itemId);break;case 4:this.updatePendingRoots(h.amount);break;case 6:this.d.set(h.tag.id,h.tag);break;case 7:this.d.delete(h.id);break}m.complete?.()}k(u,m){const h=C.$_I.parentId(u.item.extId)?.toString();let P;if(!h)P=this.q(u),this.g.add(P),this.f.set(u.item.extId,P);else if(this.f.has(h)){const W=this.f.get(h);W.children.add(u.item.extId),P=this.q(u,W),this.f.set(u.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return m.add?.(P),u.expand===2&&this.h++,P}l(u,m){const h=this.f.get(u.extId);if(h)return u.expand!==void 0&&(h.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$fJ)(h,u),m.update?.(h),h}m(u,m){const h=this.f.get(u);if(!h)return;const P=C.$_I.parentId(h.item.extId)?.toString();P?this.f.get(P).children.delete(h.item.extId):this.g.delete(h);const W=[[u]];for(;W.length;)for(const K of W.pop()){const z=this.f.get(K);z&&(W.push(z.children),this.f.delete(K),m.remove?.(z,z!==h),z.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$gJ=I}),define(Ae[76],Re([1,0,12,5,6,52,57,46]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.TestItemEventOp=void 0;var D;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const g=(a,$)=>a===$,k=Object.entries({range:(a,$)=>a===$?!0:!a||!$?!1:a.equalsRange($),busy:g,label:g,description:g,error:g,sortText:g,tags:(a,$)=>!(a.length!==$.length||a.some(E=>!$.includes(E)))}),c=(a,$)=>{let E;for(const[v,n]of k)n(a[v],$[v])||(E?E[v]=$[v]:E={[v]:$[v]});return E};class b extends C.$Sc{get root(){return this.s.root}constructor($){super(),this.s=$,this.f=this.B(new y.$6g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler($){this.h=$;for(const E of this.tree.values())this.I(E)}get resolveHandler(){return this.h}collectDiff(){const $=this.m;return this.m=[],$}pushDiff($){switch($.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===$.uri){E.docv=$.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===$.item.extId){(0,A.$fJ)(E.item,$.item);return}if(E.op===0&&E.item.item.extId===$.item.extId){(0,A.$fJ)(E.item,$.item);return}}break}}this.m.push($),this.f.isScheduled()||this.f.schedule()}expand($,E){const v=this.tree.get($);if(v){if((v.expandLevels===void 0||E>v.expandLevels)&&(v.expandLevels=E),v.expand===1){const n=this.L(v);return n.isOpen()?this.J(v,E-1):n.wait().then(()=>this.J(v,E-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.J(v,E-1)):this.J(v,E-1)}}dispose(){for(const $ of this.tree.values())this.s.getApiFor($.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u($,E){switch(E.op){case 3:this.N(l.$_I.joinToString($.fullId,E.id));break;case 0:this.y(E.item,$);break;case 5:for(const v of E.ops)this.u($,v);break;case 1:this.z(E.new,E.old,$.fullId.toString());break;case 2:this.I($);break;case 4:this.pushDiff({op:1,item:{extId:$.fullId.toString(),item:E.update}});break;case 6:this.w($.actual.uri);break;default:(0,T.$4c)(E)}}w($){$&&this.pushDiff({op:2,uri:$,docv:this.s.getDocumentVersion($)})}y($,E){const v=l.$_I.fromExtHostTestItem($,this.root.id,E?.actual),n=this.s.getApiFor($);n.parent&&n.parent!==E?.actual&&this.s.getChildren(n.parent).delete($.id);let r=this.tree.get(v.toString());if(!r){r={fullId:v,actual:$,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},$.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F($,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem($)}}),this.H($,r,E);return}if(r.actual===$){this.G($,r,E);return}if(r.actual.uri?.toString()!==$.uri?.toString())return this.N(v.toString()),this.y($,E);const s=this.s.getChildren(r.actual),o=r.actual,w=c(this.s.toITestItem(o),this.s.toITestItem($));this.s.getApiFor(o).listener=void 0,r.actual=$,r.expand=0,w&&(w.hasOwnProperty("tags")&&(this.z($.tags,o.tags,v.toString()),delete w.tags),this.u(r,{op:4,update:w})),this.H($,r,E);for(const[d,I]of s)this.s.getChildren($).get(I.id)||this.N(l.$_I.joinToString(v,I.id));this.w(r.actual.uri)}z($,E,v){const n=new Set(E.map(r=>r.id));for(const r of $)n.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:v,item:{tags:$.map(r=>(0,A.$dJ)(this.s.controllerId,r.id))}}}),n.forEach(this.D,this)}C($){const E=this.j.get($.id);E?E.refCount++:(this.j.set($.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$dJ)(this.s.controllerId,$.id)}}))}D($){const E=this.j.get($);E&&!--E.refCount&&(this.j.delete($),this.pushDiff({op:7,id:(0,A.$dJ)(this.s.controllerId,$)}))}F($,E){this.s.getApiFor($).parent=E&&E.actual!==this.root?E.actual:void 0}G($,E,v){this.F($,v);const n=this.s.getApiFor($);n.parent=v?.actual,n.listener=r=>this.u(E,r),this.I(E)}H($,E,v){this.G($,E,v);for(const[n,r]of this.s.getChildren($))this.y(r,E)}I($){let E;this.h?$.resolveBarrier?E=$.resolveBarrier.isOpen()?3:2:E=$.actual.canResolveChildren?1:0:E=0,E!==$.expand&&($.expand=E,this.pushDiff({op:1,item:{extId:$.fullId.toString(),expand:E}}),E===1&&$.expandLevels!==void 0&&this.L($))}J($,E){if(E<0)return;const v=[];for(const[n,r]of this.s.getChildren($.actual)){const s=this.expand(l.$_I.joinToString($.fullId,r.id),E);(0,y.$Gg)(s)&&v.push(s)}if(v.length)return Promise.all(v).then(()=>{})}L($){if($.resolveBarrier)return $.resolveBarrier;if(!this.h){const r=new y.$Sg;return r.open(),r}$.expand=2,this.M($);const E=$.resolveBarrier=new y.$Sg,v=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let n;try{n=this.h($.actual===this.root?void 0:$.actual)}catch(r){v(r)}return(0,y.$Gg)(n)?n.catch(v).then(()=>{E.open(),this.I($)}):(E.open(),this.I($)),$.resolveBarrier}M($){this.pushDiff({op:1,item:{extId:$.fullId.toString(),expand:$.expand}})}N($){const E=this.tree.get($);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:$});const v=[E];for(;v.length;){const n=v.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const r of n.actual.tags)this.D(r.id);this.tree.delete(n.fullId.toString());for(const[r,s]of this.s.getChildren(n.actual))v.push(this.tree.get(l.$_I.joinToString(n.fullId,s.id)))}}}flushDiff(){const $=this.collectDiff();$.length&&this.g.fire($)}}e.$0L=b;class p extends Error{constructor($){super(`Attempted to insert a duplicate test item ID ${$}`)}}e.$$L=p;class f extends Error{constructor($){super(`TestItem with ID "${$}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$_L=f;class t extends Error{constructor($,E,v){super(`TestItem with ID "${$}" is from controller "${E}" and cannot be added as a child of an item from controller "${v}".`)}}e.$aM=t;const i=(a,$,E)=>{let v=new Map;return{get size(){return v.size},forEach(n,r){for(const s of v.values())n.call(r,s,this)},[Symbol.iterator](){return v.entries()},replace(n){const r=new Map,s=new Set(v.keys()),o={op:5,ops:[]};for(const w of n){if(!(w instanceof E))throw new f(w.id);const d=$(w).controllerId;if(d!==a.controllerId)throw new t(w.id,d,a.controllerId);if(r.has(w.id))throw new p(w.id);r.set(w.id,w),s.delete(w.id),o.ops.push({op:0,item:w})}for(const w of s.keys())o.ops.push({op:3,id:w});a.listener?.(o),v=r},add(n){if(!(n instanceof E))throw new f(n.id);v.set(n.id,n),a.listener?.({op:0,item:n})},delete(n){v.delete(n)&&a.listener?.({op:3,id:n})},get(n){return v.get(n)},toJSON(){return Array.from(v.values())}}};e.$bM=i}),define(Ae[101],Re([1,0,76]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=void 0;const M=new WeakMap,C=(A,l)=>{const D={controllerId:l};return M.set(A,D),D};e.$cM=C;const T=A=>{const l=M.get(A);if(!l)throw new y.$_L(A?.id||"<unknown>");return l};e.$dM=T}),define(Ae[77],Re([1,0,13,2]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ob=e.$9ob=e.$8ob=e.$7ob=e.$6ob=void 0,e.$6ob="vscode-cdn.net",e.$7ob=`vscode-resource.${e.$6ob}`,e.$8ob=`'self' https://*.${e.$6ob}`;function C(l,D){return l.scheme===y.Schemas.http||l.scheme===y.Schemas.https?l:(D&&D.authority&&D.isRemote&&l.scheme===y.Schemas.file&&(l=M.URI.from({scheme:y.Schemas.vscodeRemote,authority:D.authority,path:l.path})),M.URI.from({scheme:y.Schemas.https,authority:`${l.scheme}+${T(l.authority)}.${e.$7ob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$9ob=C;function T(l){return l.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.$0ob=A}),define(Ae[199],Re([1,0,5,6,77]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class T{constructor(l,D,g){this.d=l,this.e=D,this.f=g,this.a=0,this.b=new M.$Rc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const k of this.c.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,D,g,R,k){let c;for(const $ of this.e.getVisibleTextEditors(!0))if($.value===l){c=$;break}if(!c)throw new Error("not a visible editor");const b=this,p=this.a++,f=new y.$Nd,t=new y.$Nd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri($){return(0,C.$9ob)($,b.f)}get cspSource(){return C.$8ob}set options($){this.b=$,b.d.$setOptions(p,$)}get options(){return this.b}set html($){this.a=$,b.d.$setHtml(p,$)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage($){return b.d.$postMessage(p,$)}},a=new class{constructor(){this.editor=l,this.line=D,this.height=g,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has(p)&&(b.c.delete(p),b.d.$disposeEditorInset(p),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(p,c.id,c.value.document.uri,D+1,g,R||{},k.identifier,k.extensionLocation),this.c.set(p,{editor:l,inset:a,onDidReceiveMessage:f}),a}$onDidDispose(l){const D=this.c.get(l);D&&D.inset.dispose()}$onDidReceiveMessage(l,D){this.c.get(l)?.onDidReceiveMessage.fire(D)}}e.$hdc=T}),define(Ae[200],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.VariableKind=e.$6M=void 0,e.$6M=(0,y.$Ph)("configurationResolverService");var M;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$7M=C}),define(Ae[201],Re([1,0,20,73,15,25,23,90,165,200,16]),function(ye,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,p,f,t){this.h=new Map,this.a=b,this.b=p,this.g=f,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(A.$j){const p=Object.create(null);return Object.keys(b).forEach(f=>{p[f.toLowerCase()]=b[f]}),p}return b}resolveWithEnvironment(b,p,f){return this.l({env:this.i(b),userHome:void 0},p?p.uri:void 0,f)}async resolveAsync(b,p){const f={env:await this.c,userHome:await this.g};return this.l(f,b?b.uri:void 0,p)}async j(b,p,f,t){const i=T.$7m(p);A.$j&&i.windows?Object.keys(i.windows).forEach($=>i[$]=i.windows[$]):A.$k&&i.osx?Object.keys(i.osx).forEach($=>i[$]=i.osx[$]):A.$l&&i.linux&&Object.keys(i.linux).forEach($=>i[$]=i.linux[$]),delete i.windows,delete i.osx,delete i.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,b?b.uri:void 0,i,f,t)}async resolveAnyAsync(b,p,f){return this.j(b,p,f)}async resolveAnyMap(b,p,f){const t=new Map;return{newConfig:await this.j(b,p,f,t),resolvedVariables:t}}resolveWithInteractionReplace(b,p,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,p,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,p){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,p)}async l(b,p,f,t,i){if(C.$yf(f))return this.m(b,p,f,t,i);if(Array.isArray(f))return Promise.all(f.map(a=>this.l(b,p,a,t,i)));if(C.$Af(f)){const a=Object.create(null),$=await Promise.all(Object.keys(f).map(async E=>[await this.m(b,p,E,t,i),await this.l(b,p,f[E],t,i)]));for(const[E,v]of $)a[E]=v;return a}return f}m(b,p,f,t,i){return(0,R.$Te)(f,k.VARIABLE_REGEXP,async(a,$)=>{if($.includes(k.VARIABLE_LHS))return a;let E=await this.o(b,a,$,p,t);return i?.set($,E),E!==a&&C.$yf(E)&&E.match(k.VARIABLE_REGEXP)&&(E=await this.m(b,p,E,t,i)),E})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,p,f,t,i){let a;const $=f.split(":");$.length>1&&(f=$[0],a=$[1]);const E=r=>{const s=this.a.getFilePath();if(s)return(0,l.$sv)(s);throw new g.$7M(r,(0,D.localize)(0,null,p))},v=r=>{const s=E(r);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$sv)(o)}throw new g.$7M(r,(0,D.localize)(1,null,p,y.$nc(s)))},n=r=>{if(a){const s=this.a.getFolderUri(a);if(s)return s;throw new g.$7M(r,(0,D.localize)(2,null,p,a))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$7M(r,(0,D.localize)(3,null,p)):new g.$7M(r,(0,D.localize)(4,null,p))};switch(f){case"env":if(a){if(b.env){const r=b.env[A.$j?a.toLowerCase():a];if(C.$yf(r))return r}return""}throw new g.$7M(g.VariableKind.Env,(0,D.localize)(5,null,p));case"config":if(a){const r=this.a.getConfigurationValue(t,a);if(C.$Hf(r))throw new g.$7M(g.VariableKind.Config,(0,D.localize)(6,null,p,a));if(C.$Af(r))throw new g.$7M(g.VariableKind.Config,(0,D.localize)(7,null,p,a));return r}throw new g.$7M(g.VariableKind.Config,(0,D.localize)(8,null,p));case"command":return this.p(g.VariableKind.Command,p,a,i,"command");case"input":return this.p(g.VariableKind.Input,p,a,i,"input");case"extensionInstallFolder":if(a){const r=await this.a.getExtension(a);if(!r)throw new g.$7M(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,p,a));return this.n(r.extensionLocation)}throw new g.$7M(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,p));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,l.$sv)(this.n(n(g.VariableKind.WorkspaceFolder)));case"cwd":return t||a?(0,l.$sv)(this.n(n(g.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$sv)(y.$nc(this.n(n(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new g.$7M(g.VariableKind.UserHome,(0,D.localize)(11,null,p))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new g.$7M(g.VariableKind.LineNumber,(0,D.localize)(12,null,p))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new g.$7M(g.VariableKind.SelectedText,(0,D.localize)(13,null,p))}case"file":return E(g.VariableKind.File);case"fileWorkspaceFolder":return v(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||a?y.$lc(this.n(n(g.VariableKind.RelativeFile)),E(g.VariableKind.RelativeFile)):E(g.VariableKind.RelativeFile);case"relativeFileDirname":{const r=y.$mc(E(g.VariableKind.RelativeFileDirname));if(t||a){const s=y.$lc(this.n(n(g.VariableKind.RelativeFileDirname)),r);return s.length===0?".":s}return r}case"fileDirname":return y.$mc(E(g.VariableKind.FileDirname));case"fileExtname":return y.$oc(E(g.VariableKind.FileExtname));case"fileBasename":return y.$nc(E(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=y.$nc(E(g.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-y.$oc(r).length)}case"fileDirnameBasename":return y.$nc(y.$mc(E(g.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||p}case"execInstallFolder":{const r=this.a.getAppRoot();return r||p}case"pathSeparator":return y.sep;default:try{const r=a?`${f}:${a}`:f;return this.p(g.VariableKind.Unknown,p,r,i,void 0)}catch{return p}}}}p(b,p,f,t,i){if(f&&t){const a=i===void 0?t[f]:t[i+":"+f];if(typeof a=="string")return a;throw new g.$7M(b,(0,D.localize)(14,null,p))}return p}}e.$iN=k}),define(Ae[102],Re([1,0,4,99]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=e.$gC=e.OpenEditorContext=e.GroupsOrder=e.$fC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$eC=void 0,e.$eC=(0,y.$Ph)("editorGroupsService");var C;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var T;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var D;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function g(p){const f=p;return(0,M.$7D)(f?.editor)&&(0,M.$7D)(f?.replacement)}e.$fC=g;var R;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var k;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function c(p){const f=p;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$gC=c;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$hC=b}),define(Ae[202],Re([1,0,4,102]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lC=e.$kC=e.$jC=e.$iC=void 0,e.$iC=(0,y.$Ph)("editorService"),e.$jC=-1,e.$kC=-2;function C(T){const A=T;return typeof T=="number"||(0,M.$gC)(A)}e.$lC=C}),define(Ae[8],Re([1,0,18,26,122,203,50,28,116,68,67,25,15,2,41,78,94,101,99,75,46,57,202,7]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E,v,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$gM=e.$fM=e.MarkdownString=e.$eM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Ce){function Fe(H){const{selectionStartLineNumber:Me,selectionStartColumn:je,positionLineNumber:Je,positionColumn:Ve}=H,et=new r.$jK(Me-1,je-1),bt=new r.$jK(Je-1,Ve-1);return new r.$lK(et,bt)}Ce.to=Fe;function me(H){const{anchor:Me,active:je}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ce.from=me})(s||(e.Selection=s={}));var o;(function(Ce){function Fe(H){if(!H)return;const{start:Me,end:je}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ce.from=Fe;function me(H){if(!H)return;const{startLineNumber:Me,startColumn:je,endLineNumber:Je,endColumn:Ve}=H;return new r.$kK(Me-1,je-1,Je-1,Ve-1)}Ce.to=me})(o||(e.Range=o={}));var w;(function(Ce){function Fe(me){switch(me){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ce.to=Fe})(w||(e.TokenType=w={}));var d;(function(Ce){function Fe(H){return new r.$jK(H.lineNumber-1,H.column-1)}Ce.to=Fe;function me(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=me})(d||(e.Position=d={}));var I;(function(Ce){function Fe(Me,je,Je){return(0,y.$Hb)((0,y.$3b)(Me).map(Ve=>me(Ve,je,Je)))}Ce.from=Fe;function me(Me,je,Je){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Je?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,je),pattern:st.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Je?.isBuiltin}}function H(Me,je){return je&&typeof Me=="string"?je.transformOutgoingScheme(Me):Me}})(I||(e.DocumentSelector=I={}));var S;(function(Ce){function Fe(H){switch(H){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ce.from=Fe;function me(H){switch(H){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ce.to=me})(S||(e.DiagnosticTag=S={}));var u;(function(Ce){function Fe(H){let Me;return H.code&&((0,c.$yf)(H.code)||(0,c.$Cf)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:Me,severity:h.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(m.from),tags:Array.isArray(H.tags)?(0,y.$Hb)(H.tags.map(S.from)):void 0}}Ce.from=Fe;function me(H){const Me=new r.$wK(o.to(H),H.message,h.to(H.severity));return Me.source=H.source,Me.code=(0,c.$yf)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(m.to),Me.tags=H.tags&&(0,y.$Hb)(H.tags.map(S.to)),Me}Ce.to=me})(u||(e.Diagnostic=u={}));var m;(function(Ce){function Fe(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Fe;function me(H){return new r.$vK(new r.$uK(H.resource,o.to(H)),H.message)}Ce.to=me})(m||(e.DiagnosticRelatedInformation=m={}));var h;(function(Ce){function Fe(H){switch(H){case r.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Fe;function me(H){switch(H){case t.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ce.to=me})(h||(e.DiagnosticSeverity=h={}));var P;(function(Ce){function Fe(H){return typeof H=="number"&&H>=r.ViewColumn.One?H-1:H===r.ViewColumn.Beside?n.$kC:n.$jC}Ce.from=Fe;function me(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=me})(P||(e.ViewColumn=P={}));function W(Ce){return typeof Ce.range<"u"}function K(Ce){return Ce.length===0?!0:!!W(Ce[0])}e.$eM=K;var z;(function(Ce){function Fe(Ve){return Ve.map(Ce.from)}Ce.fromMany=Fe;function me(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function H(Ve){let et;if(me(Ve)){const{language:lt,value:gt}=Ve;et={value:"```"+lt+`
`+gt+"\n```\n"}}else r.$IK.isMarkdownString(Ve)?et={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?et={value:Ve}:et={value:""};const bt=Object.create(null);et.uris=bt;const zt=lt=>{try{let gt=b.URI.parse(lt,!0);gt=gt.with({query:Me(gt.query,bt)}),bt[lt]=gt}catch{}return""},Dt=new D.marked.Renderer;return Dt.link=zt,Dt.image=lt=>typeof lt=="string"?zt(A.$0j(lt).href):"",(0,D.marked)(et.value,{renderer:Dt}),et}Ce.from=H;function Me(Ve,et){if(!Ve)return Ve;let bt;try{bt=(0,g.$lh)(Ve)}catch{}if(!bt)return Ve;let zt=!1;return bt=(0,k.$9m)(bt,Dt=>{if(b.URI.isUri(Dt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[lt]=Dt,zt=!0,lt}else return}),zt?JSON.stringify(bt):Ve}function je(Ve){const et=new r.$IK(Ve.value,Ve.supportThemeIcons);return et.isTrusted=Ve.isTrusted,et.supportHtml=Ve.supportHtml,et.baseUri=Ve.baseUri?b.URI.from(Ve.baseUri):void 0,et}Ce.to=je;function Je(Ve){if(Ve)return typeof Ve=="string"?Ve:Ce.from(Ve)}Ce.fromStrict=Je})(z||(e.MarkdownString=z={}));function j(Ce){return K(Ce)?Ce.map(Fe=>({range:o.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?z.fromMany(Fe.hoverMessage):Fe.hoverMessage?z.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ce.map(Fe=>({range:o.from(Fe)}))}e.$fM=j;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.$gM=O;var N;(function(Ce){function Fe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?O(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ce.from=Fe})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var ie;(function(Ce){function Fe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Ce.from=Fe})(ie||(e.ThemableDecorationRenderOptions=ie={}));var X;(function(Ce){function Fe(me){if(typeof me>"u")return me;switch(me){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Fe})(X||(e.DecorationRangeBehavior=X={}));var Ee;(function(Ce){function Fe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?X.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?ie.from(me.light):void 0,dark:me.dark?ie.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Ce.from=Fe})(Ee||(e.DecorationRenderOptions=Ee={}));var Se;(function(Ce){function Fe(H){return{text:H.newText,eol:H.newEol&&Ye.from(H.newEol),range:o.from(H.range)}}Ce.from=Fe;function me(H){const Me=new r.$pK(o.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:Ye.to(H.eol),Me}Ce.to=me})(Se||(e.TextEdit=Se={}));var Pe;(function(Ce){function Fe(H,Me){const je={edits:[]};if(H instanceof r.$sK){const Je=new l.$Bc;for(const Ve of H._allEntries())Ve._type===1&&b.URI.isUri(Ve.to)&&Ve.from===void 0&&Je.add(Ve.to);for(const Ve of H._allEntries())if(Ve._type===1){let et;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?et={type:"base64",value:(0,M.$ve)(M.$be.wrap(Ve.options.contents))}:et={type:"dataTransferItem",id:Ve.options.contents._itemId}),je.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:et},metadata:Ve.metadata})}else Ve._type===2?je.edits.push({resource:Ve.uri,textEdit:Se.from(Ve.edit),versionId:Je.has(Ve.uri)?void 0:Me?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?je.edits.push({resource:Ve.uri,textEdit:{range:o.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Je.has(Ve.uri)?void 0:Me?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?je.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&je.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(ft.from)}})}return je}Ce.from=Fe;function me(H){const Me=new r.$sK,je=new l.$Ac;for(const Je of H.edits)if(Je.textEdit){const Ve=Je,et=b.URI.revive(Ve.resource),bt=o.to(Ve.textEdit.range),zt=Ve.textEdit.text,Dt=Ve.textEdit.insertAsSnippet;let lt;Dt?lt=r.$rK.replace(bt,new r.$tK(zt)):lt=r.$pK.replace(bt,zt);const gt=je.get(et);gt?gt.push(lt):je.set(et,[lt])}else Me.renameFile(b.URI.revive(Je.oldResource),b.URI.revive(Je.newResource),Je.options);for(const[Je,Ve]of je)Me.set(Je,Ve);return Me}Ce.to=me})(Pe||(e.WorkspaceEdit=Pe={}));var $e;(function(Ce){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function me(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Ce.from=me;function H(Me){for(const je in Fe)if(Fe[je]===Me)return Number(je);return r.SymbolKind.Property}Ce.to=H})($e||(e.SymbolKind=$e={}));var pe;(function(Ce){function Fe(H){switch(H){case r.SymbolTag.Deprecated:return 1}}Ce.from=Fe;function me(H){switch(H){case 1:return r.SymbolTag.Deprecated}}Ce.to=me})(pe||(e.SymbolTag=pe={}));var ue;(function(Ce){function Fe(H){return{name:H.name,kind:$e.from(H.kind),tags:H.tags&&H.tags.map(pe.from),containerName:H.containerName,location:Z.from(H.location)}}Ce.from=Fe;function me(H){const Me=new r.$zK(H.name,$e.to(H.kind),H.containerName,Z.to(H.location));return Me.tags=H.tags&&H.tags.map(pe.to),Me}Ce.to=me})(ue||(e.WorkspaceSymbol=ue={}));var oe;(function(Ce){function Fe(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:$e.from(H.kind),tags:H.tags?.map(pe.from)??[]};return H.children&&(Me.children=H.children.map(Fe)),Me}Ce.from=Fe;function me(H){const Me=new r.$AK(H.name,H.detail,$e.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,y.$Lb)(H.tags)&&(Me.tags=H.tags.map(pe.to)),H.children&&(Me.children=H.children.map(me)),Me}Ce.to=me})(oe||(e.DocumentSymbol=oe={}));var be;(function(Ce){function Fe(H){const Me=new r.$EK($e.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function me(H,Me,je){if(Me=Me??H._sessionId,je=je??H._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,name:H.name,detail:H.detail,kind:$e.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(pe.from)}}Ce.from=me})(be||(e.CallHierarchyItem=be={}));var _;(function(Ce){function Fe(me){return new r.$FK(be.to(me.from),me.fromRanges.map(H=>o.to(H)))}Ce.to=Fe})(_||(e.CallHierarchyIncomingCall=_={}));var B;(function(Ce){function Fe(me){return new r.$GK(be.to(me.to),me.fromRanges.map(H=>o.to(H)))}Ce.to=Fe})(B||(e.CallHierarchyOutgoingCall=B={}));var Z;(function(Ce){function Fe(H){return{range:H.range&&o.from(H.range),uri:H.uri}}Ce.from=Fe;function me(H){return new r.$uK(b.URI.revive(H.uri),o.to(H.range))}Ce.to=me})(Z||(e.location=Z={}));var ee;(function(Ce){function Fe(H){const Me=H,je=H;return{originSelectionRange:Me.originSelectionRange?o.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:je.uri,range:o.from(Me.targetRange?Me.targetRange:je.range),targetSelectionRange:Me.targetSelectionRange?o.from(Me.targetSelectionRange):void 0}}Ce.from=Fe;function me(H){return{targetUri:b.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}Ce.to=me})(ee||(e.DefinitionLink=ee={}));var ve;(function(Ce){function Fe(H){return{range:o.from(H.range),contents:z.fromMany(H.contents)}}Ce.from=Fe;function me(H){return new r.$xK(H.contents.map(z.to),o.to(H.range))}Ce.to=me})(ve||(e.Hover=ve={}));var ge;(function(Ce){function Fe(H){return{range:o.from(H.range),expression:H.expression}}Ce.from=Fe;function me(H){return new r.$qL(o.to(H.range),H.expression)}Ce.to=me})(ge||(e.EvaluatableExpression=ge={}));var he;(function(Ce){function Fe(H){if(H instanceof r.$rL)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof r.$sL)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof r.$tL)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Fe;function me(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}Ce.to=me})(he||(e.InlineValue=he={}));var De;(function(Ce){function Fe(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}Ce.from=Fe;function me(H){return new r.$uL(H.frameId,o.to(H.stoppedLocation))}Ce.to=me})(De||(e.InlineValueContext=De={}));var re;(function(Ce){function Fe(H){return{range:o.from(H.range),kind:H.kind}}Ce.from=Fe;function me(H){return new r.$yK(o.to(H.range),H.kind)}Ce.to=me})(re||(e.DocumentHighlight=re={}));var le;(function(Ce){function Fe(me){switch(me){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ce.to=Fe})(le||(e.CompletionTriggerKind=le={}));var ne;(function(Ce){function Fe(me){return{triggerKind:le.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ce.to=Fe})(ne||(e.CompletionContext=ne={}));var ae;(function(Ce){function Fe(H){switch(H){case r.CompletionItemTag.Deprecated:return 1}}Ce.from=Fe;function me(H){switch(H){case 1:return r.CompletionItemTag.Deprecated}}Ce.to=me})(ae||(e.CompletionItemTag=ae={}));var fe;(function(Ce){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function me(je){return Fe.get(je)??9}Ce.from=me;const H=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(je){return H.get(je)??r.CompletionItemKind.Property}Ce.to=Me})(fe||(e.CompletionItemKind=fe={}));var Ie;(function(Ce){function Fe(me,H){const Me=new r.$OK(me.label);return Me.insertText=me.insertText,Me.kind=fe.to(me.kind),Me.tags=me.tags?.map(ae.to),Me.detail=me.detail,Me.documentation=A.$5j(me.documentation)?z.to(me.documentation):me.documentation,Me.sortText=me.sortText,Me.filterText=me.filterText,Me.preselect=me.preselect,Me.commitCharacters=me.commitCharacters,p.$us.isIRange(me.range)?Me.range=o.to(me.range):typeof me.range=="object"&&(Me.range={inserting:o.to(me.range.insert),replacing:o.to(me.range.replace)}),Me.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Me.insertText=new r.$tK(me.insertText):(Me.insertText=me.insertText,Me.textEdit=Me.range instanceof r.$kK?new r.$pK(Me.range,Me.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Me.additionalTextEdits=me.additionalTextEdits.map(je=>Se.to(je))),Me.command=H&&me.command?H.fromInternal(me.command):void 0,Me}Ce.to=Fe})(Ie||(e.CompletionItem=Ie={}));var F;(function(Ce){function Fe(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:z.fromStrict(H.documentation)}}Ce.from=Fe;function me(H){return{label:H.label,documentation:A.$5j(H.documentation)?z.to(H.documentation):H.documentation}}Ce.to=me})(F||(e.ParameterInformation=F={}));var V;(function(Ce){function Fe(H){return{label:H.label,documentation:z.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(F.from):[],activeParameter:H.activeParameter}}Ce.from=Fe;function me(H){return{label:H.label,documentation:A.$5j(H.documentation)?z.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(F.to):[],activeParameter:H.activeParameter}}Ce.to=me})(V||(e.SignatureInformation=V={}));var G;(function(Ce){function Fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(V.from):[]}}Ce.from=Fe;function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(V.to):[]}}Ce.to=me})(G||(e.SignatureHelp=G={}));var J;(function(Ce){function Fe(me,H){const Me=new r.$NK(d.to(H.position),typeof H.label=="string"?H.label:H.label.map(q.to.bind(void 0,me)),H.kind&&x.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(Se.to),Me.tooltip=A.$5j(H.tooltip)?z.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}Ce.to=Fe})(J||(e.InlayHint=J={}));var q;(function(Ce){function Fe(me,H){const Me=new r.$MK(H.label);return Me.tooltip=A.$5j(H.tooltip)?z.to(H.tooltip):H.tooltip,f.Command.is(H.command)&&(Me.command=me.fromInternal(H.command)),H.location&&(Me.location=Z.to(H.location)),Me}Ce.to=Fe})(q||(e.InlayHintLabelPart=q={}));var x;(function(Ce){function Fe(H){return H}Ce.from=Fe;function me(H){return H}Ce.to=me})(x||(e.InlayHintKind=x={}));var ce;(function(Ce){function Fe(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Fe;function me(H){let Me;if(H.url)try{Me=typeof H.url=="string"?b.URI.parse(H.url,!0):b.URI.revive(H.url)}catch{}return new r.$TK(o.to(H.range),Me)}Ce.to=me})(ce||(e.DocumentLink=ce={}));var Ne;(function(Ce){function Fe(H){const Me=new r.$WK(H.label);return H.textEdit&&(Me.textEdit=Se.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(je=>Se.to(je))),Me}Ce.to=Fe;function me(H){return{label:H.label,textEdit:H.textEdit?Se.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>Se.from(Me)):void 0}}Ce.from=me})(Ne||(e.ColorPresentation=Ne={}));var Ue;(function(Ce){function Fe(H){return new r.$UK(H[0],H[1],H[2],H[3])}Ce.to=Fe;function me(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=me})(Ue||(e.Color=Ue={}));var Qe;(function(Ce){function Fe(H){return{range:o.from(H.range)}}Ce.from=Fe;function me(H){return new r.$DK(o.to(H.range))}Ce.to=me})(Qe||(e.SelectionRange=Qe={}));var Ge;(function(Ce){function Fe(me){switch(me){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ce.to=Fe})(Ge||(e.TextDocumentSaveReason=Ge={}));var xe;(function(Ce){function Fe(H){switch(H){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Fe;function me(H){switch(H){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ce.to=me})(xe||(e.TextEditorLineNumbersStyle=xe={}));var Ye;(function(Ce){function Fe(H){if(H===r.EndOfLine.CRLF)return 1;if(H===r.EndOfLine.LF)return 0}Ce.from=Fe;function me(H){if(H===1)return r.EndOfLine.CRLF;if(H===0)return r.EndOfLine.LF}Ce.to=me})(Ye||(e.EndOfLine=Ye={}));var _e;(function(Ce){function Fe(me){if(typeof me=="object")return me.viewId;switch(me){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Fe})(_e||(e.ProgressLocation=_e={}));var it;(function(Ce){function Fe(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=tt.from(H.kind)),Me}Ce.from=Fe;function me(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=tt.to(H.kind)),Me}Ce.to=me})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Fe(H){if(H)switch(H){case r.FoldingRangeKind.Comment:return f.$jt.Comment;case r.FoldingRangeKind.Imports:return f.$jt.Imports;case r.FoldingRangeKind.Region:return f.$jt.Region}}Ce.from=Fe;function me(H){if(H)switch(H.value){case f.$jt.Comment.value:return r.FoldingRangeKind.Comment;case f.$jt.Imports.value:return r.FoldingRangeKind.Imports;case f.$jt.Region.value:return r.FoldingRangeKind.Region}}Ce.to=me})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Fe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?o.from(me.selection):void 0,override:typeof me.override=="boolean"?a.$TD.id:void 0}}Ce.from=Fe})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Fe(je){return je instanceof r.$eL?je.toJSON():typeof je=="string"?je:me(je)||H(je)?new r.$eL(je.baseUri??je.base,je.pattern).toJSON():je}Ce.from=Fe;function me(je){const Je=je;return Je?b.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function H(je){const Je=je;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Me(je){return typeof je=="string"?je:new r.$eL(b.URI.revive(je.baseUri),je.pattern)}Ce.to=Me})(st||(e.GlobPattern=st={}));var Y;(function(Ce){function Fe(me){if(me){if(Array.isArray(me))return me.map(Fe);if(typeof me=="string")return me;{const H=me;return{language:H.language,scheme:H.scheme,pattern:st.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Fe})(Y||(e.LanguageSelector=Y={}));var Q;(function(Ce){function Fe(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Me=>Array.isArray(Me)&&Me.every(je=>je&&typeof je=="object"&&"uri"in je&&b.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Je=>Je instanceof r.$kK)))}Ce.is=Fe;function me(H){return{documents:H.documents.map(Me=>Me.map(je=>({uri:b.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Je=>o.from(Je))})))}}Ce.from=me})(Q||(e.MappedEditsContext=Q={}));var we;(function(Ce){function Fe(H){return{start:H.start,end:H.end}}Ce.from=Fe;function me(H){return new r.$FL(H.start,H.end)}Ce.to=me})(we||(e.NotebookRange=we={}));var Be;(function(Ce){function Fe(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Fe;function me(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=me})(Be||(e.NotebookCellExecutionSummary=Be={}));var Oe;(function(Ce){function Fe(me){if(me===$.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(me===$.NotebookCellExecutionState.Pending)return;if(me===$.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ce.to=Fe})(Oe||(e.NotebookCellExecutionState=Oe={}));var Xe;(function(Ce){function Fe(H){switch(H){case r.NotebookCellKind.Markup:return $.CellKind.Markup;case r.NotebookCellKind.Code:default:return $.CellKind.Code}}Ce.from=Fe;function me(H){switch(H){case $.CellKind.Markup:return r.NotebookCellKind.Markup;case $.CellKind.Code:default:return r.NotebookCellKind.Code}}Ce.to=me})(Xe||(e.NotebookCellKind=Xe={}));var nt;(function(Ce){function Fe(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const je of H.cells)r.$GL.validate(je),Me.cells.push(ft.from(je));return Me}Ce.from=Fe;function me(H){const Me=new r.$HL(H.cells.map(ft.to));return(0,c.$Lf)(H.metadata)||(Me.metadata=H.metadata),Me}Ce.to=me})(nt||(e.NotebookData=nt={}));var ft;(function(Ce){function Fe(H){return{cellKind:Xe.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Be.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Pt.from):[]}}Ce.from=Fe;function me(H){return new r.$GL(Xe.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Pt.to):void 0,H.metadata,H.internalMetadata?Be.to(H.internalMetadata):void 0)}Ce.to=me})(ft||(e.NotebookCellData=ft={}));var wt;(function(Ce){function Fe(H){return{mime:H.mime,valueBytes:M.$be.wrap(H.data)}}Ce.from=Fe;function me(H){return new r.$IL(H.valueBytes.buffer,H.mime)}Ce.to=me})(wt||(e.NotebookCellOutputItem=wt={}));var Pt;(function(Ce){function Fe(H){return{outputId:H.id,items:H.items.map(wt.from),metadata:H.metadata}}Ce.from=Fe;function me(H){const Me=H.items.map(wt.to);return new r.$JL(Me,H.outputId,H.metadata)}Ce.to=me})(Pt||(e.NotebookCellOutput=Pt={}));var Zt;(function(Ce){function Fe(Me){return H(Me)?{include:st.from(Me.include)??void 0,exclude:st.from(Me.exclude)??void 0}:st.from(Me)??void 0}Ce.from=Fe;function me(Me){return H(Me)?{include:st.to(Me.include),exclude:st.to(Me.exclude)}:st.to(Me)}Ce.to=me;function H(Me){const je=Me;return je?!(0,c.$Hf)(je.include)&&!(0,c.$Hf)(je.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Gt;(function(Ce){function Fe(me,H,Me){const je=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(je,Me),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ce.from=Fe})(Gt||(e.NotebookStatusBarItem=Gt={}));var pt;(function(Ce){function Fe(me,H,Me){const je=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:H.toInternal(je,Me),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ce.from=Fe})(pt||(e.NotebookKernelSourceAction=pt={}));var jt;(function(Ce){function Fe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ce.from=Fe})(jt||(e.NotebookDocumentContentOptions=jt={}));var Nt;(function(Ce){function Fe(H){return{uri:H.uri,provides:H.provides}}Ce.from=Fe;function me(H){return new r.$LL(b.URI.revive(H.uri),H.provides)}Ce.to=me})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Ce){function Fe(H){return{message:z.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:o.from(H.location.range),uri:H.location.uri}}}Ce.from=Fe;function me(H){const Me=new r.$RL(typeof H.message=="string"?H.message:z.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?Z.to(H.location):void 0,Me}Ce.to=me})(Bt||(e.TestMessage=Bt={}));var At;(function(Ce){Ce.namespace=v.$dJ,Ce.denamespace=v.$eJ})(At||(e.TestTag=At={}));var Rt;(function(Ce){function Fe(H){const Me=(0,i.$dM)(H).controllerId;return{extId:E.$_I.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:b.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(je=>At.namespace(Me,je.id)),range:p.$us.lift(o.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&z.fromStrict(H.error)||null}}Ce.from=Fe;function me(H){return{parent:void 0,error:void 0,id:E.$_I.fromString(H.extId).localId,label:H.label,uri:b.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:je}=At.denamespace(Me);return new r.$SL(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=me})(Rt||(e.TestItem=Rt={})),function(Ce){function Fe(H){return{id:H.id}}Ce.from=Fe;function me(H){return new r.$SL(H.id)}Ce.to=me}(At||(e.TestTag=At={}));var Ot;(function(Ce){const Fe=(H,Me)=>{const je=[];for(const[Ve,et]of Me)E.$_I.compare(et.item.extId,Ve)===2&&(Me.delete(Ve),je.push(et));const Je={...Rt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(et=>et.type===0).map(Bt.to)})),children:je.map(Ve=>Fe(Ve,Me))};for(const Ve of Je.children)Ve.parent=Je;return Je};function me(H){const Me=[],je=new Map;for(const Je of H.items){je.set(Je.item.extId,Je);const Ve=E.$_I.root(Je.item.extId);H.request.targets.some(et=>et.controllerId===Ve&&et.testIds.includes(Je.item.extId))&&Me.push(Je)}return{completedAt:H.completedAt,results:Me.map(Je=>Fe(Je,je))}}Ce.to=me})(Ot||(e.TestResults=Ot={}));var Wt;(function(Ce){function Fe(je){return{covered:je.covered,total:je.covered}}function me(je){return"line"in je?d.from(je):o.from(je)}function H(je){return"branches"in je?{count:je.executionCount,location:me(je.location),type:1,branches:je.branches.length?je.branches.map(Je=>({count:Je.executionCount,location:Je.location&&me(Je.location)})):void 0}:{type:0,count:je.executionCount,location:me(je.location)}}Ce.fromDetailed=H;function Me(je){return{uri:je.uri,statement:Fe(je.statementCoverage),branch:je.branchCoverage&&Fe(je.branchCoverage),function:je.functionCoverage&&Fe(je.functionCoverage),details:je.detailedCoverage?.map(H)}}Ce.fromFile=Me})(Wt||(e.TestCoverage=Wt={}));var Jt;(function(Ce){function Fe(me){switch(me){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ce.to=Fe})(Jt||(e.CodeActionTriggerKind=Jt={}));var Kt;(function(Ce){function Fe(H){const Me=new r.$YL($e.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function me(H,Me,je){if(Me=Me??H._sessionId,je=je??H._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,kind:$e.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(pe.from)}}Ce.from=me})(Kt||(e.TypeHierarchyItem=Kt={}));var Vt;(function(Ce){function Fe(me){if(me)return{value:me.value,tooltip:me.tooltip}}Ce.from=Fe})(Vt||(e.ViewBadge=Vt={}));var Mt;(function(Ce){function Fe(je,Je,Ve){const et=Je.fileData;return et?new r.$0K(new r.$$K(et.name,b.URI.revive(et.uri),et.id,(0,T.$db)(()=>Ve(et.id)))):je===R.$Qr.uriList&&Je.uriListData?new r.$9K(Me(Je.uriListData)):new r.$9K(Je.asString)}Ce.to=Fe;async function me(je,Je){const Ve=await Je.asString();if(je===R.$Qr.uriList)return{asString:Ve,fileData:void 0,uriListData:H(Ve)};const et=Je.asFile();return{asString:Ve,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ce.from=me;function H(je){return C.$4s.split(je).map(Je=>{if(Je.startsWith("#"))return Je;try{return b.URI.parse(Je)}catch{}return Je})}function Me(je){return C.$4s.create(je.map(Je=>typeof Je=="string"?Je:b.URI.revive(Je)))}})(Mt||(e.DataTransferItem=Mt={}));var ut;(function(Ce){function Fe(H,Me){const je=H.items.map(([Je,Ve])=>[Je,Mt.to(Je,Ve,Me)]);return new r.$_K(je)}Ce.toDataTransfer=Fe;async function me(H){const Me={items:[]},je=[];for(const[Je,Ve]of H)je.push((async()=>{Me.items.push([Je,await Mt.from(Je,Ve)])})());return await Promise.all(je),Me}Ce.from=me})(ut||(e.DataTransfer=ut={}));var dt;(function(Ce){function Fe(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Fe;function me(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=me})(dt||(e.ChatReplyFollowup=dt={}));var Lt;(function(Ce){function Fe(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",when:me.when??"",args:me.args}:dt.from(me)}Ce.from=Fe})(Lt||(e.ChatFollowup=Lt={}));var qt;(function(Ce){function Fe(H){const Me=new r.$9L(kt.to(H.role),H.content);return Me.name=H.name,Me}Ce.to=Fe;function me(H){return{role:kt.from(H.role),content:H.content,name:H.name}}Ce.from=me})(qt||(e.ChatMessage=qt={}));var kt;(function(Ce){function Fe(H){switch(H){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Ce.to=Fe;function me(H){switch(H){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Ce.from=me})(kt||(e.ChatMessageRole=kt={}));var at;(function(Ce){function Fe(Me){const je={};for(const Je of Object.keys(Me))je[Je]=Me[Je].map(Ce.to);return je}Ce.objectTo=Fe;function me(Me){return{level:vt.to(Me.level),value:Me.value,description:Me.description}}Ce.to=me;function H(Me){return{level:vt.from(Me.level),value:Me.value,description:Me.description}}Ce.from=H})(at||(e.ChatVariable=at={}));var vt;(function(Ce){function Fe(H){switch(H){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Ce.to=Fe;function me(H){switch(H){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Ce.from=me})(vt||(e.ChatVariableLevel=vt={}));var Ht;(function(Ce){function Fe(me){switch(me){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Fe})(Ht||(e.InteractiveEditorResponseFeedbackKind=Ht={}));var Ct;(function(Ce){function Fe(me){return"placeholder"in me&&"resolvedContent"in me?{placeholder:me.placeholder}:"responseId"in me?{requestId:me.responseId}:"content"in me?{content:typeof me.content=="string"?me.content:z.from(me.content)}:"documents"in me?{documents:me.documents.map(H=>({uri:H.uri,version:H.version,ranges:H.ranges.map(Me=>o.from(Me))}))}:"reference"in me?{reference:"uri"in me.reference?{uri:me.reference.uri,range:o.from(me.reference.range)}:me.reference}:"inlineReference"in me?{inlineReference:"uri"in me.inlineReference?{uri:me.inlineReference.uri,range:o.from(me.inlineReference.range)}:me.inlineReference,title:me.title}:me}Ce.from=Fe})(Ct||(e.ChatResponseProgress=Ct={}));var We;(function(Ce){function Fe(me,H,Me){return"terminalCommand"in me?{terminalCommand:me.terminalCommand}:"uri"in me?{uri:me.uri}:H.toInternal(me,Me)}Ce.from=Fe})(We||(e.TerminalQuickFix=We={}))}),define(Ae[204],Re([1,0,2,9,7,8,173]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;class l{constructor(g,R,k,c={timeout:1500,errors:3}){this.c=g,this.d=R,this.f=k,this.g=c,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(R,k,c)=>{const p={dispose:this.a.push([R,k,g])};return Array.isArray(c)&&c.push(p),p}}async $participateInSave(g,R){const k=y.URI.revive(g);let c=!1;const b=setTimeout(()=>c=!0,this.g.timeout),p=[];try{for(const f of[...this.a]){if(c)break;const t=this.d.getDocument(k),i=await this.h(f,{document:t,reason:T.TextDocumentSaveReason.to(R)});p.push(i)}}finally{clearTimeout(b)}return p}h([g,R,k],c){const b=this.b.get(g);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(k,g,R,c).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,R,k,c){const b=[],p=Date.now(),{document:f,reason:t}=c,{version:i}=f,a=Object.freeze({document:f,reason:t,waitUntil($){if(Object.isFrozen(b))throw(0,M.$8)("waitUntil can not be called async");b.push(Promise.resolve($))}});try{R.apply(k,[a])}catch($){return Promise.reject($)}return Object.freeze(b),new Promise(($,E)=>{const v=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(v),$(n)}).catch(n=>{clearTimeout(v),E(n)})}).then($=>{const E={edits:[]};for(const v of $)if(Array.isArray(v)&&v.every(n=>n instanceof C.$pK))for(const{newText:n,newEol:r,range:s}of v)E.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:s&&T.Range.from(s),text:n,eol:r&&T.EndOfLine.from(r)}});if(E.edits.length!==0)return i===f.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.$scc=l}),define(Ae[205],Re([1,0,13,2,8,7,75]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=void 0;class l{constructor(k,c,b,p){this.start=k,this.deletedCount=c,this.deletedItems=b,this.items=p}asApiEvent(){return{range:new T.$FL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,c,b){this.notebook=k,this.h=c,this.j=b,this.handle=b.handle,this.uri=M.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(C.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,c=this.h.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:c.document,get mime(){return k.g},set mime(p){k.g=p},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(b)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,c,b){const p=b.map(C.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===k);if(f&&(c||(f.items.length=0),f.items.push(...p),f.items.length>1&&f.items.every(t=>A.$qI(t.mime)))){const t=new Map,i=[];f.items.forEach(a=>{let $;t.has(a.mime)?$=t.get(a.mime):($=[],t.set(a.mime,$),i.push(a.mime)),$.push(a.data)}),f.items.length=0,i.forEach(a=>{const $=A.$rI(t.get(a));f.items.push({mime:a,data:$.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$Fdc=D;class g{static{this.a=0}constructor(k,c,b,p,f){this.k=k,this.l=c,this.m=b,this.uri=p,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,c={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===y.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(b){return b=k.n(b),k.b[b].apiCell},getCells(b){return(b?k.p(b):k.b).map(f=>f.apiCell)},save(){return k.q()}};this.e=Object.freeze(c)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,c,b){this.g=k.versionId,this.h=c,this.acceptDocumentPropertiesChanged({metadata:b});const p={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},f=[];for(const i of k.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,p.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,p.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),f.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),f.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<f.length;i++){const a=f[i],$=t.get(a.cell);if($===void 0){const E=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});t.set(a.cell,E-1)}else p.cellChanges[$]={...p.cellChanges[$],...a}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let c=k.start|0,b=k.end|0;return c<0&&(c=0),b>this.b.length&&(b=this.b.length),k.with({start:c,end:b})}p(k){k=this.o(k);const c=[];for(let b=k.start;b<k.end;b++)c.push(this.b[b]);return c}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,c,b){if(this.j)return;const p=[],f=[],t=[];if(k.reverse().forEach(i=>{const $=i[2].map(n=>{const r=new D(this,this.l,n);return c||f.push(D.asModelAddData(this.apiNotebook,n)),r}),E=new l(i[0],i[1],[],$),v=this.b.splice(i[0],i[1],...$);for(const n of v)t.push(n.uri),E.deletedItems.push(n.apiCell);p.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),b)for(const i of p)b.push(i.asApiEvent())}s(k,c,b,p){const f=this.b.splice(k,c);this.b.splice(b,0,...f);const t=[new l(k,c,f.map(i=>i.apiCell),[]),new l(b,0,[],f)];for(const i of t)p.push(i.asApiEvent())}t(k,c){this.b[k].setOutputs(c)}u(k,c,b,p){this.b[k].setOutputItems(c,b,p)}v(k,c){const b=this.b[k];b.apiCell.document.languageId!==c&&this.m.$acceptModelLanguageChanged(b.uri,c)}w(k,c){const b=this.b[k];b.apiCell.mime=c}x(k,c){this.b[k].setMetadata(c)}y(k,c){this.b[k].setInternalMetadata(c)}getCellFromApiCell(k){return this.b.find(c=>c.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(c=>c.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$Gdc=g}),define(Ae[206],Re([1,0,5,2,8,7]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;class A{constructor(D,g,R,k={timeout:1500,errors:3}){this.b=D,this.c=g,this.d=R,this.f=k,this.a=new y.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(g,R,k)=>{const c=function(p){g.call(R,p)};return c.extension=D,this.a.event(c,void 0,k)}}async $participateInSave(D,g,R){const k=M.URI.revive(D),c=this.c.getNotebookDocument(k);if(!c)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:c.apiNotebook,reason:C.TextDocumentSaveReason.to(g)},R,async(f,t)=>{const i=Date.now(),a=await await Promise.resolve(f);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&a&&(a instanceof T.$sK?b.push(a):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(b.length===0)return!0;const p={edits:[]};for(const f of b){const{edits:t}=C.WorkspaceEdit.from(f);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$7dc=A}),define(Ae[103],Re([1,0,9,8,7]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,D,g,R,k,c){this.id=l,this.f=D,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=R,this.c=c}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(D){this.selections=[D]},get selections(){return l.a},set selections(D){if(!Array.isArray(D)||!D.every(C.$FL.isNotebookRange))throw(0,y.$7)("selections");l.a=D,l.g(D)},get visibleRanges(){return l.b},revealRange(D,g){l.f.$tryRevealRange(l.id,M.NotebookRange.from(D),g??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(M.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$Hdc=T}),define(Ae[207],Re([1,0,9,5,14,8]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;let A=class{constructor(D,g){this.c=D,this.d=g,this.a=new M.$Nd({onListenerError:y.$2}),this.b=new M.$Nd({onListenerError:y.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const R=this.d.getEditorById(D);g.visibleRanges&&R._acceptVisibleRanges(g.visibleRanges.ranges.map(T.NotebookRange.to)),g.selections&&R._acceptSelections(g.selections.selections.map(T.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this.d.getEditorById(g)._acceptViewColumn(T.ViewColumn.to(D[g]))}};e.$Zdc=A,e.$Zdc=A=qe([Ke(0,C.$0i)],A)}),define(Ae[208],Re([1,0,8,51,152,19,65,9]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class D{constructor(c){this.b=0,this.c=new Map,this.a=c}async withProgress(c,b,p){const f=this.b++,{title:t,location:i,cancellable:a}=b,$={label:(0,C.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this.a.$startProgress(f,{location:y.ProgressLocation.from(i),title:t,source:$,cancellable:a},c.isUnderDevelopment?void 0:c.identifier.value).catch(l.$2),this.d(f,p,!!a)}d(c,b,p){let f;p&&(f=new T.$Xd,this.c.set(c,f));const t=a=>{this.a.$progressEnd(a),this.c.delete(a),f?.dispose()};let i;try{i=b(new R(this.a,c),p&&f?f.token:T.CancellationToken.None)}catch(a){throw t(c),a}return i.then(a=>t(c),a=>t(c)),i}$acceptProgressCanceled(c){const b=this.c.get(c);b&&(b.cancel(),this.c.delete(c))}}e.$4cc=D;function g(k,c){return k.message=c.message,typeof c.increment=="number"&&(typeof k.increment=="number"?k.increment+=c.increment:k.increment=c.increment),k}class R extends M.$6u{constructor(c,b){super(p=>this.throttledReport(p)),this.i=c,this.j=b}throttledReport(c){this.i.$progressReport(this.j,c)}}qe([(0,A.$jh)(100,(k,c)=>g(k,c),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,41,101,46,76,57,8,2]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.$uM=e.$tM=void 0;const g=($,E,v,n)=>{let r=E;return{enumerable:!0,configurable:!1,get(){return r},set(s){if(!v(r,s)){const o=r;r=s,$.listener?.(n(s,o))}}}},R=($,E)=>$===E,k={range:($,E)=>$===E?!0:!$||!E?!1:$.isEqual(E),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:($,E)=>!($.length!==E.length||$.some(v=>!E.find(n=>v.id===n.id)))},c=$=>E=>({op:4,update:$(E)}),b=($,E)=>({range:(()=>{let v;const n=c(r=>({range:y.$us.lift(l.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return v},set(r){$.listener?.({op:6}),k.range(v,r)||(v=r,$.listener?.(n(r)))}}})(),label:g($,E,k.label,c(v=>({label:v}))),description:g($,void 0,k.description,c(v=>({description:v}))),sortText:g($,void 0,k.sortText,c(v=>({sortText:v}))),canResolveChildren:g($,!1,k.canResolveChildren,v=>({op:2,state:v})),busy:g($,!1,k.busy,c(v=>({busy:v}))),error:g($,void 0,k.error,c(v=>({error:l.MarkdownString.fromStrict(v)||null}))),tags:g($,[],k.tags,(v,n)=>({op:1,new:v.map(l.TestTag.from),old:n.map(l.TestTag.from)}))}),p=$=>{const E=C.$_I.fromString($.extId),v=new t(E.controllerId,E.localId,$.label,D.URI.revive($.uri)||void 0);return v.range=l.Range.to($.range||void 0),v.description=$.description||void 0,v.sortText=$.sortText||void 0,v.tags=$.tags.map(n=>l.TestTag.to({id:(0,A.$eJ)(n).tagId})),v},f=$=>{let E;for(const v of $.tests){const n=p(v.item);(0,M.$dM)(n).parent=E,E=n}return E};e.$tM=f;class t{constructor(E,v,n,r){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const s=(0,M.$cM)(this,E);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof i?void 0:s.parent}},children:{value:(0,T.$bM)(s,M.$dM,t),enumerable:!0,writable:!1},...b(s,n)})}}e.$uM=t;class i extends t{constructor(E,v){super(E,E,v,void 0),this._isRoot=!0}}e.$vM=i;class a extends T.$0L{constructor(E,v,n){super({controllerId:E,getDocumentVersion:r=>r&&n.getDocument(r)?.version,getApiFor:M.$dM,getChildren:r=>r.children,root:new i(E,v),toITestItem:l.TestItem.from})}}e.$wM=a}),define(Ae[105],Re([1,0,52,9,88,8,7]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=void 0;class l{static{this.c=new C.$mM("TextEditorDecorationType")}constructor(c,b,p){const f=l.c.nextId();c.$registerTextEditorDecorationType(b.identifier,f,T.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:f,dispose(){c.$removeTextEditorDecorationType(f)}})}}e.$oM=l;class D{constructor(c,b){this.g=[],this.h=void 0,this.j=!1,this.c=c,this.d=c.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(c,b){this.k();let p=null;if(c instanceof A.$jK)p=new A.$kK(c,c);else if(c instanceof A.$kK)p=c;else throw new Error("Unrecognized location");this.l(p,b,!1)}insert(c,b){this.k(),this.l(new A.$kK(c,c),b,!0)}delete(c){this.k();let b=null;if(c instanceof A.$kK)b=c;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(c,b,p){const f=this.c.validateRange(c);this.g.push({range:f,text:b,forceMoveMarkers:p})}setEndOfLine(c){if(this.k(),c!==A.EndOfLine.LF&&c!==A.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=c}}class g{constructor(c,b,p,f){this.c=c,this.d=b,this._accept(p),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(c){this.f=c.tabSize,this.g=c.indentSize,this.h=c.insertSpaces,this.j=c.cursorStyle,this.k=T.TextEditorLineNumbersStyle.to(c.lineNumbers)}l(c){if(c==="auto")return"auto";if(typeof c=="number"){const b=Math.floor(c);return b>0?b:null}if(typeof c=="string"){const b=parseInt(c,10);return isNaN(b)?null:b>0?b:null}return null}m(c){const b=this.l(c);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const b=Math.floor(c);return b>0?b:null}if(typeof c=="string"){const b=parseInt(c,10);return isNaN(b)?null:b>0?b:null}return null}o(c){const b=this.n(c);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(c){return c==="auto"?"auto":c==="false"?!1:!!c}q(c){const b=this.p(c);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(c){this.j!==c&&(this.j=c,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:c})))}t(c){this.k!==c&&(this.k=c,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(c)})))}assign(c){const b={};let p=!1;if(typeof c.tabSize<"u"){const f=this.l(c.tabSize);f==="auto"?(p=!0,b.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,p=!0,b.tabSize=f)}if(typeof c.indentSize<"u"){const f=this.n(c.indentSize);f==="tabSize"?(p=!0,b.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,p=!0,b.indentSize=f)}if(typeof c.insertSpaces<"u"){const f=this.p(c.insertSpaces);f==="auto"?(p=!0,b.insertSpaces=f):this.h!==f&&(this.h=f,p=!0,b.insertSpaces=f)}typeof c.cursorStyle<"u"&&this.j!==c.cursorStyle&&(this.j=c.cursorStyle,p=!0,b.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this.k!==c.lineNumbers&&(this.k=c.lineNumbers,p=!0,b.lineNumbers=T.TextEditorLineNumbersStyle.from(c.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(c,b){b.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this.e.warn(p)})}}e.$pM=g;class R{constructor(c,b,p,f,t,i,a,$){this.id=c,this.j=b,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,i,p),this.e=a,this.f=$;const E=this;this.value=Object.freeze({get document(){return f.value},set document(v){throw new M.$9("document")},get selection(){return E.c&&E.c[0]},set selection(v){if(!(v instanceof A.$lK))throw(0,M.$7)("selection");E.c=[v],E.l()},get selections(){return E.c},set selections(v){if(!Array.isArray(v)||v.some(n=>!(n instanceof A.$lK)))throw(0,M.$7)("selections");E.c=v,E.l()},get visibleRanges(){return E.e},set visibleRanges(v){throw new M.$9("visibleRanges")},get options(){return E.d.value},set options(v){E.g||E.d.assign(v)},get viewColumn(){return E.f},set viewColumn(v){throw new M.$9("viewColumn")},edit(v,n={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new D(f.value,n);return v(r),E.m(r)},insertSnippet(v,n,r={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=E.c.map(o=>T.Range.from(o));else if(n instanceof A.$jK){const{lineNumber:o,column:w}=T.Position.from(n);s=[{startLineNumber:o,startColumn:w,endLineNumber:o,endColumn:w}]}else if(n instanceof A.$kK)s=[T.Range.from(n)];else{s=[];for(const o of n)if(o instanceof A.$kK)s.push(T.Range.from(o));else{const{lineNumber:w,column:d}=T.Position.from(o);s.push({startLineNumber:w,startColumn:d,endLineNumber:w,endColumn:d})}}return b.$tryInsertSnippet(c,f.value.version,v.value,s,r)},setDecorations(v,n){const r=n.length===0;r&&!E.h.has(v.key)||(r?E.h.delete(v.key):E.h.add(v.key),E.n(()=>{if(T.$eM(n))return b.$trySetDecorations(c,v.key,T.$fM(n));{const s=new Array(4*n.length);for(let o=0,w=n.length;o<w;o++){const d=n[o];s[4*o]=d.start.line+1,s[4*o+1]=d.start.character+1,s[4*o+2]=d.end.line+1,s[4*o+3]=d.end.character+1}return b.$trySetDecorationsFast(c,v.key,s)}}))},revealRange(v,n){E.n(()=>b.$tryRevealRange(c,T.Range.from(v),n||A.TextEditorRevealType.Default))},show(v){b.$tryShowEditor(c,T.ViewColumn.from(v))},hide(){b.$tryHideEditor(c)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(c){(0,y.ok)(!this.g),this.d._accept(c)}_acceptVisibleRanges(c){(0,y.ok)(!this.g),this.e=c}_acceptViewColumn(c){(0,y.ok)(!this.g),this.f=c}_acceptSelections(c){(0,y.ok)(!this.g),this.c=c}async l(){const c=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,c)),this.value}m(c){const b=c.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const a=p[t].end;if(p[t+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=b.edits.map(t=>({range:T.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,f,{setEndOfLine:typeof b.setEndOfLine=="number"?T.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(c){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$qM=R}),define(Ae[209],Re([1,0,4,171]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DJ=void 0,e.$DJ=(0,y.$Qh)(M.$Wh)}),define(Ae[106],Re([1,0,21,5,20,6]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o4b=e.$n4b=e.$m4b=e.$l4b=e.$k4b=e.$j4b=void 0;class A{constructor(i,a){this.versionId=i,this.removedDueToLooping=a}}e.$j4b=A;class l{static isHostExtension(i,a,$){if(a.getExtensionDescription(i))return!1;const E=$.getExtensionDescription(i);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(i,a){this.j=i,this.c=new M.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=a,this.k()}k(){this.e.sort(p),this.f=new y.$8l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const a=this.j.readActivationEvents(i);if(Array.isArray(a))for(let $ of a)$==="onUri"&&($=`onUri:${y.$6l.toKey(i.identifier)}`),this.h.has($)||this.h.set($,[]),this.h.get($).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,a){this.e=f(this.e,a),this.e=this.e.concat(i);const $=l.l(this.e);return this.e=f(this.e,$.map(E=>E.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,$)}static l(i){const a=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,s){this.addNode(r),this.addNode(s),this.c.has(r)?this.c.get(r).push(s):this.c.set(r,[s])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,s){const o=a.getArcs(r);for(let w=0;w<o.length;w++)if(!s.has(o[w]))return!1;return!0}getNodes(){return this.e}},$=new y.$8l;for(const r of i)if($.set(r.identifier,r),r.extensionDependencies)for(const s of r.extensionDependencies)a.addArc(y.$6l.toKey(r.identifier),y.$6l.toKey(s));const E=new Set;a.getNodes().filter(r=>a.getArcs(r).length===0).forEach(r=>E.add(r));const v=a.getNodes().filter(r=>!E.has(r));let n;do{n=!1;for(let r=0;r<v.length;r++){const s=v[r];a.hasOnlyGoodArcs(s,E)&&(v.splice(r,1),r--,E.add(s),n=!0)}}while(n);return v.map(r=>$.get(r))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const a=this.h.get(i);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const a=this.f.get(i);return a||void 0}getExtensionDescriptionByUUID(i){for(const a of this.g)if(a.uuid===i)return a}getExtensionDescriptionByIdOrUUID(i,a){return this.getExtensionDescription(i)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.$k4b=l;class D{constructor(i,a){this.versionId=i,this.extensions=a}}e.$l4b=D,e.$m4b={readActivationEvents:t=>t.activationEvents};class g{constructor(i){this.d=new c,this.c=new l(i,[])}async acquireLock(i){const a=await this.d.acquire(i);return new R(this,a)}deltaExtensions(i,a,$){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(a,$)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,a){return this.c.getExtensionDescriptionByIdOrUUID(i,a)}}e.$n4b=g;class R extends T.$Sc{constructor(i,a){super(),this.f=i,this.c=!1,this.B(a)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$o4b=R;class k{constructor(i){this.name=i,this.promise=new Promise((a,$)=>{this.c=a})}resolve(i){this.c(i)}}class c{constructor(){this.c=[],this.d=!1}async acquire(i){const a=new k(i);return this.c.push(a),this.e(),a.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let a=!0;const $=setTimeout(()=>{a&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),E=()=>{a&&(clearTimeout($),a=!1,this.d=!1,this.e())};i.resolve((0,T.$Qc)(E))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function p(t,i){const a=t.isBuiltin?0:t.isUnderDevelopment?2:1,$=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(a!==$)return a-$;const E=C.$gc.basename(t.extensionLocation.path),v=C.$gc.basename(i.extensionLocation.path);return E<v?-1:E>v?1:0}function f(t,i){const a=new y.$7l(i);return t.filter($=>!a.has($.identifier))}}),define(Ae[79],Re([1,0,26]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$cm=e.$bm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var T;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A(g){const R=y.$be.alloc(1);switch(g){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$bm=A;function l(g,R){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$cm=l;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,53,54,25,2,6,154]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=e.$yM=void 0;let b=class extends k.$Sc{constructor(i,a){super(),this.s=i,this.t=a,this.a=this.B(new M.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=a.createLogger(this.m,{id:D.$po,name:(0,c.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(a.onDidChangeLogLevel($=>{(0,C.$_i)($)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,a,$){const E=this.getTelemetryDetails(),v=new p(a,$,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(i,a,$){this.f=i,this.g=a,this.c=$??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const a=Object.create(null);switch(a["common.extname"]=`${i.publisher}.${i.name}`,a["common.extversion"]=i.version,a["common.vscodemachineid"]=this.s.telemetryInfo.machineId,a["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,a["common.vscodeversion"]=this.s.version,a["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),a["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:a["common.uikind"]="web";break;case A.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,l.$Vk)((0,D.$wo)(this.s.remote.authority)),a}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const a=this.getTelemetryDetails();this.r.forEach(($,E)=>{const v=$.filter(n=>!n.isDisposed);v.length===0?this.r.delete(E):this.r.set(E,v)}),this.r.forEach($=>{for(const E of $)E.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,a){const E=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!E)return this.r.delete(i.value),!1;let v=!1;for(const n of E)n.ignoreUnhandledExtHostErrors||(n.logError(a),v=!0);return v}};e.$yM=b,e.$yM=b=qe([Ke(0,T.$xM),Ke(1,C.$$i)],b);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,a,$,E,v,n,r){this.g=$,this.h=E,this.i=v,this.j=n,this.a=new M.$Nd,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this.b=a?.ignoreBuiltInCommonProperties??!1,this.c=a?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(i,a){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:a},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let a="properties"in i?i.properties??{}:i;return a=(0,D.$zo)(a,[]),this.c&&(a=(0,g.$0m)(a,this.c)),this.b||(a=(0,g.$0m)(a,this.j)),"properties"in i?i.properties=a:i=a,i}k(i,a){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f?.sendEventData(i,a),this.h.trace(i,a))}logUsage(i,a){this.d.isUsageEnabled&&this.k(i,a)}logError(i,a){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,a);else{const $={name:i.name,message:i.message,stack:i.stack,cause:i.cause},E=(0,D.$zo)($,[]),v=new Error(E.message,{cause:E.cause});v.stack=E.stack,v.name=E.name,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f.sendErrorData(v,a),this.h.trace("exception",a)}}get apiTelemetryLogger(){if(!this.e){const i=this,a={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(a)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$zM=p;function f(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$AM=f,e.$BM=(0,y.$Ph)("IExtHostTelemetry")}),define(Ae[22],Re([1,0,5,2,180,98,21,4]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jF=e.$iF=e.$hF=e.ActivationKind=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.ExtensionHostStartup=e.$bF=e.$aF=e.$_E=e.$$E=void 0,e.$$E=Object.freeze({identifier:new A.$6l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$_E="extensions.webWorker",e.$aF=(0,l.$Ph)("extensionService");class D{constructor(v){this.dependency=v}}e.$bF=D;var g;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(v,n,r){this.c=v,this.d=n.slice(0),this.e=r.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$VE.createActivationEventsMap(this.d)}}set(v,n,r){if(this.c>v)throw new Error(`ExtensionHostExtensions: invalid versionId ${v} (current: ${this.c})`);const s=[],o=[],w=[],d=[],I=k(this.d),S=k(n),u=(K,z)=>K.extensionLocation.toString()===z.extensionLocation.toString()||K.isBuiltin===z.isBuiltin||K.isUserBuiltin===z.isUserBuiltin||K.isUnderDevelopment===z.isUnderDevelopment;for(const K of this.d){const z=S.get(K.identifier);if(!z){s.push(K.identifier),I.delete(K.identifier);continue}if(!u(K,z)){s.push(K.identifier),I.delete(K.identifier);continue}}for(const K of n){const z=I.get(K.identifier);if(!z){o.push(K);continue}if(!u(z,K)){s.push(z.identifier),I.delete(z.identifier);continue}}const m=new A.$7l(this.e),h=new A.$7l(r);for(const K of this.e)h.has(K)||w.push(K);for(const K of r)m.has(K)||d.push(K);const P=T.$VE.createActivationEventsMap(o),W={versionId:v,toRemove:s,toAdd:o,addActivationEvents:P,myToRemove:w,myToAdd:d};return this.delta(W),W}delta(v){if(this.c>=v.versionId)return null;const{toRemove:n,toAdd:r,myToRemove:s,myToAdd:o}=v,w=new A.$7l(n),d=new A.$7l(s);for(let I=0;I<this.d.length;I++)w.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)d.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of r)this.d.push(I);for(const I of o)this.e.push(I);return v}containsExtension(v){for(const n of this.e)if(A.$6l.equals(n,v))return!0;return!1}}e.$cF=R;function k(E){const v=new A.$8l;for(const n of E)v.set(n.identifier,n);return v}function c(E,v){return E.enabledApiProposals?E.enabledApiProposals.includes(v):!1}e.$dF=c;function b(E,v){if(!c(E,v))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.$eF=b;class p{constructor(v,n,r,s){this.codeLoadingTime=v,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=s}}e.$fF=p;class f{constructor(v,n){this.description=v,this.value=n}}e.$gF=f;var t;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,C.$Fo)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.$hF=i;function a(E,v){return{identifier:new A.$6l((0,C.$Do)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!v,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.$iF=a;class ${constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$jF=$}),define(Ae[210],Re([1,0,9,106,21,22,14,12]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=e.$wcc=e.$vcc=e.$ucc=e.$tcc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,a,$,E){this.startup=i,this.codeLoadingTime=a,this.activateCallTime=$,this.activateResolvedTime=E}}e.$tcc=D;class g{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,a){return i===-1||a===-1?-1:a-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$ucc=g;class R{constructor(i,a,$,E,v,n){this.activationFailed=i,this.activationFailedError=a,this.activationTimes=$,this.module=E,this.exports=v,this.subscriptions=n}}e.$vcc=R;class k extends R{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$wcc=k;class c extends R{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xcc=c;class b extends R{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,a,$,E){this.g=E,this.a=i,this.b=a,this.c=$,this.d=new C.$8l,this.f=Object.create(null)}dispose(){for(const[i,a]of this.d)a.dispose()}async waitForActivatingExtensions(){const i=[];for(const[a,$]of this.d)i.push($.wait());await Promise.all(i)}isActivated(i){const a=this.d.get(i);return!!(a&&a.value)}getActivatedExtension(i){const a=this.d.get(i);if(!a||!a.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return a.value}async activateByEvent(i,a){if(this.f[i])return;const $=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h($.map(E=>({id:E.identifier,reason:{startup:a,extensionId:E.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,a){const $=this.a.getExtensionDescription(i);if(!$)throw new Error(`Extension '${i}' is not known`);return this.h([{id:$.identifier,reason:a}])}async h(i){const a=i.filter($=>!this.isActivated($.id)).map($=>this.j($));await Promise.all(a.map($=>$.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const a=this.a.getExtensionDescription(i.id);if(!a){const v=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new b(v));return this.c.onExtensionActivationError(i.id,v,new T.$bF(i.id.value)),n}const $=[],E=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const v of E){if(this.m(v))continue;const n=this.d.get(v);if(n){$.push(n);continue}if(this.l(v)){$.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:i.reason}));continue}const r=this.a.getExtensionDescription(v);if(r){if(!r.main&&!r.browser)continue;$.push(this.j({id:r.identifier,reason:i.reason}));continue}const s=a.displayName||a.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${v}'`),w=this.k(i,a.displayName,[],new b(o));return this.c.onExtensionActivationError(a.identifier,o,new T.$bF(v)),w}return this.k(i,a.displayName,$,null)}k(i,a,$,E){const v=new f(i.id,a,i.reason,$,E,this.c,this.g);return this.d.set(i.id,v),v}l(i){return M.$k4b.isHostExtension(i,this.a,this.b)}m(i){const a=this.b.getExtensionDescription(i);return a?!a.main&&!a.browser:!1}};e.$ycc=p,e.$ycc=p=qe([Ke(3,A.$0i)],p);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,a,$,E,v,n,r){this.c=i,this.d=a,this.f=$,this.g=E,this.h=v,this.j=n,this.k=r,this.a=new l.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const a=this.g[i];if(a.value&&!a.value.activationFailed){this.g.splice(i,1),i--;continue}if(a.value&&a.value.activationFailed){const $=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);$.detail=a.value.activationFailedError,this.h=new b($),this.j.onExtensionActivationError(this.c,$,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const a=new Error;if(i&&i.name&&(a.name=i.name),i&&i.message?a.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:a.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(a.stack=i.stack),this.h=new b(a),this.b&&y.$4(i))return;this.j.onExtensionActivationError(this.c,a,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};f=qe([Ke(6,A.$0i)],f)}),define(Ae[211],Re([1,0,156,24,2,5,6,192,12,7,15,18,8,50,19,125,22]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;function i(E,v){if((0,R.$yf)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let n;return Array.isArray(E.highlights)&&(n=E.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),n=n.length?n:void 0),{label:E.label,highlights:n}}}class a extends A.$Sc{constructor(v,n,r){super(),this.f=v,this.g=n,this.h=r,this.a=new Map,this.b=new f.$M7;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>s(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(w=>s(w)?this.r(w):w):o})}registerTreeDataProvider(v,n,r){const s=this.createTreeView(v,{treeDataProvider:n},r);return{dispose:()=>s.dispose()}}createTreeView(v,n,r){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],w=!!n.dragAndDropController?.handleDrag,d=!!n.dragAndDropController?.handleDrop,I=this.m(v,n,r),S={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:w,hasHandleDrop:d,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(v,S),m={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$eF)(r,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$eF)(r,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(h){(0,b.$5j)(h)&&(0,t.$eF)(r,"treeViewMarkdownMessage"),I.message=h},get title(){return I.title},set title(h){I.title=h},get description(){return I.description},set description(h){I.description=h},get badge(){return I.badge},set badge(h){h!==void 0&&g.ViewBadge.isViewBadge(h)?I.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(I.badge=void 0)},reveal:(h,P)=>I.reveal(h,P),dispose:async()=>{await u,this.a.delete(v),I.dispose()}};return this.B(m),m}$getChildren(v,n){const r=this.a.get(v);return r?r.getChildren(n):Promise.reject(new l.$rE(v))}async $handleDrop(v,n,r,s,o,w,d,I){const S=this.a.get(v);if(!S)return Promise.reject(new l.$rE(v));const u=c.DataTransfer.toDataTransfer(r,async m=>(await this.f.$resolveDropFileData(v,n,m)).buffer);return d===v&&I&&await this.j(u,S,I,o,w),S.onDrop(u,s,o)}async j(v,n,r,s,o){const w=this.b.removeDragOperationTransfer(o);if(w)(await w)?.forEach((d,I)=>{d&&v.set(I,d)});else if(o&&n.handleDrag){const d=n.handleDrag(r,v,s);this.b.addDragOperationTransfer(o,d),await d}return v}async $handleDrag(v,n,r,s){const o=this.a.get(v);if(!o)return Promise.reject(new l.$rE(v));const w=await this.j(new g.$_K,o,n,s,r);if(!(!w||s.isCancellationRequested))return c.DataTransfer.from(w)}async $hasResolve(v){const n=this.a.get(v);if(!n)throw new l.$rE(v);return n.hasResolve}$resolve(v,n,r){const s=this.a.get(v);if(!s)throw new l.$rE(v);return s.resolveTreeItem(n,r)}$setExpanded(v,n,r){const s=this.a.get(v);if(!s)throw new l.$rE(v);s.setExpanded(n,r)}$setSelectionAndFocus(v,n,r){const s=this.a.get(v);if(!s)throw new l.$rE(v);s.setSelectionAndFocus(n,r)}$setVisible(v,n){const r=this.a.get(v);if(!r){if(!n)return;throw new l.$rE(v)}r.setVisible(n)}$changeCheckboxState(v,n){const r=this.a.get(v);if(!r)throw new l.$rE(v);r.setCheckboxState(n)}m(v,n,r){const s=this.B(new $(v,n,this.f,this.g.converter,this.h,r));return this.a.set(v,s),s}r(v){const n=this.a.get(v.$treeViewId);return n&&"$treeItemHandle"in v?n.getExtensionElement(v.$treeItemHandle):n&&"$focusedTreeItem"in v&&v.$focusedTreeItem?n.focusedElement:null}}e.$$cc=a;class $ extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(v=>this.getExtensionElement(v)).filter(v=>!(0,R.$Hf)(v))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(v,n,r,s,o,w){if(super(),this.I=v,this.J=r,this.L=s,this.M=o,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$Xd,w.contributes&&w.contributes.views)for(const u in w.contributes.views)for(const m of w.contributes.views[u])m.id===v&&(this.P=m.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let d,I;const S=T.Event.debounce(this.F.event,(u,m)=>(u||(u={message:!1,elements:[]}),m.element!==!1&&(d||(d=new Promise(h=>I=h),this.G=this.G.then(()=>d)),Array.isArray(m.element)?u.elements.push(...m.element):u.elements.push(m.element)),m.message&&(u.message=!0),u),200,!0);this.B(S(({message:u,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const h=I;return d=null,this.$(m).then(()=>h())})),u&&this.J.$setMessage(this.I,c.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(v){const n=v?this.getExtensionElement(v):void 0;if(v&&!n)return this.M.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let r=this.X(v);return r||(r=await this.Y(n)),r?r.map(s=>s.item):void 0}getExtensionElement(v){return this.j.get(v)}reveal(v,n){n=n||{select:!0,focus:!1};const r=(0,R.$Hf)(n.select)?!0:n.select,s=(0,R.$Hf)(n.focus)?!1:n.focus,o=(0,R.$Hf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.G.then(()=>this.S(v)).then(w=>this.W(v,w[w.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:w.map(I=>I.item)},{select:r,focus:s,expand:o})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:r,focus:s,expand:o})}get message(){return this.O}set message(v){this.O=v,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(v){this.P=v,this.J.$setTitle(this.I,v,this.Q)}get description(){return this.Q}set description(v){this.Q=v,this.J.$setTitle(this.I,this.P,v)}get badge(){return this.R}set badge(v){this.R?.value===v?.value&&this.R?.tooltip===v?.tooltip||(this.R=c.ViewBadge.from(v),this.J.$setBadge(this.I,v))}setExpanded(v,n){const r=this.getExtensionElement(v);r&&(n?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(v,n){const r=!(0,k.$ub)(this.s,v);this.s=v;const s=this.t!==n;this.t=n,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(v){v!==this.r&&(this.r=v,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(v){const n=(await Promise.all(v.map(async r=>{const s=this.getExtensionElement(r.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:r.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);n.forEach(r=>{r.treeItem.checkboxState=r.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(r=>[r.extensionItem,r.newState])})}async handleDrag(v,n,r){const s=[];for(const o of v){const w=this.getExtensionElement(o);w&&s.push(w)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,n,r),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,n,r){const s=n?this.getExtensionElement(n):void 0;if(!(!s&&n||!this.g?.handleDrop))return(0,D.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(s,v,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,n){if(!this.f.resolveTreeItem)return;const r=this.j.get(v);if(r){const s=this.m.get(r);if(s){const o=await this.f.resolveTreeItem(s.extensionItem,r,n)??s.extensionItem;return this.hb(o),s.item.tooltip=this.eb(o.tooltip),s.item.command=this.fb(s.disposableStore,o.command),s.item}}}S(v){return this.U(v).then(n=>n?this.S(n).then(r=>this.W(n,r[r.length-1]).then(s=>(r.push(s),r))):Promise.resolve([]))}U(v){const n=this.m.get(v);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,D.$Mg)(()=>this.f.getParent(v))}W(v,n){const r=this.m.get(v);return r?Promise.resolve(r):(0,D.$Mg)(()=>this.f.getTreeItem(v)).then(s=>this.kb(v,s,n,!0)).then(s=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const w=this.m.get(o);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(v){if(v){let n;if(typeof v=="string"){const r=this.getExtensionElement(v);n=r?this.m.get(r):void 0}else n=v;return n&&n.children||void 0}return this.h}async Y(v){this.rb(v);const n=new p.$Xd(this.Z.token);try{const r=v?this.m.get(v):void 0,s=await this.f.getChildren(v);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,k.$Hb)(s||[]).map(async w=>{const d=await this.f.getTreeItem(w);return d&&!n.token.isCancellationRequested?this.db(w,d,r):null}));return n.token.isCancellationRequested?void 0:(0,k.$Hb)(o)}finally{n.dispose()}}$(v){if(v.some(r=>!r))return this.Z.dispose(!0),this.Z=new p.$Xd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(v);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(v){const n=new Set,r=v.map(o=>this.m.get(o));for(const o of r)if(o&&!n.has(o.item.handle)){let w=o;for(;w&&w.parent&&r.findIndex(d=>w&&w.parent&&d&&d.item.handle===w.parent.item.handle)===-1;){const d=this.j.get(w.parent.item.handle);w=d?this.m.get(d):void 0}w&&!w.parent&&n.add(o.item.handle)}const s=[];return n.forEach(o=>{const w=this.j.get(o);if(w){const d=this.m.get(w);d&&(!d.parent||!n.has(d.parent.item.handle))&&s.push(o)}}),s}bb(v){const n={};return Promise.all(v.map(r=>this.cb(r).then(s=>{s&&(n[r]=s.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(v){const n=this.getExtensionElement(v);if(n){const r=this.m.get(n);if(r)return this.rb(n),(0,D.$Mg)(()=>this.f.getTreeItem(n)).then(s=>{if(s){const o=this.ib(n,s,r.parent);return this.pb(n,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}db(v,n,r){const s=this.ib(v,n,r);if(n.id&&this.j.has(s.item.handle))throw new Error((0,y.localize)(0,null,n.id));return this.ob(v,s),this.qb(s,r),s}eb(v){return g.$IK.isMarkdownString(v)?c.MarkdownString.from(v):v}fb(v,n){return n?{...this.L.toInternal(n,v),originalId:n.command}:void 0}gb(v){if(v.checkboxState===void 0)return;let n,r,s;return typeof v.checkboxState=="number"?n=v.checkboxState:(n=v.checkboxState.state,r=v.checkboxState.tooltip,s=v.checkboxState.accessibilityInformation),{isChecked:n===g.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:s}}hb(v){if(!g.$7K.isTreeItem(v,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(v,n,r){this.hb(n);const s=this.B(new A.$Rc),o=this.kb(v,n,r),w=this.lb(n);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(s,n.command),contextValue:n.contextValue,icon:w,iconDark:this.mb(n)||w,themeIcon:this.jb(n),collapsibleState:(0,R.$Hf)(n.collapsibleState)?g.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:r,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(v){return v.iconPath instanceof g.$cL?v.iconPath:void 0}kb(v,{id:n,label:r,resourceUri:s},o,w){if(n)return`${$.b}/${n}`;const d=i(r,this.N),I=o?o.item.handle:$.a;let S=d?d.label:s?(0,M.$sg)(s):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const u=this.m.has(v)?this.m.get(v).item.handle:void 0,m=this.X(o)||[];let h,P=0;do{if(h=`${I}/${P}:${S}`,w||!this.j.has(h)||u===h)break;P++}while(P<=m.length);return h}lb(v){if(v.iconPath&&!(v.iconPath instanceof g.$cL))return typeof v.iconPath=="string"||C.URI.isUri(v.iconPath)?this.nb(v.iconPath):this.nb(v.iconPath.light)}mb(v){if(v.iconPath&&!(v.iconPath instanceof g.$cL)&&v.iconPath.dark)return this.nb(v.iconPath.dark)}nb(v){return C.URI.isUri(v)?v:C.URI.file(v)}ob(v,n){this.j.set(n.item.handle,v),this.m.set(v,n)}pb(v,n,r,s){this.j.delete(n.item.handle),this.m.delete(v),n.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(v,n);const o=this.X(s)||[],w=o.filter(d=>d.item.handle===r.item.handle)[0];w&&o.splice(o.indexOf(w),1,n)}qb(v,n){n?(n.children||(n.children=[]),n.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}rb(v){if(v){const n=this.m.get(v);if(n){if(n.children)for(const r of n.children){const s=this.j.get(r.item.handle);s&&this.sb(s)}n.children=void 0}}else this.tb()}sb(v){const n=this.m.get(v);if(n){if(n.children)for(const r of n.children){const s=this.j.get(r.item.handle);s&&this.sb(s)}this.m.delete(v),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(v=>v.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[212],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[213],Re([1,0,166,9,29,92,72,30,21,212,176,98]),function(ye,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=void 0;const c=l.$gn.as(A.$hn.JSONContribution);class b{constructor(v,n,r){this.a=v,this.b=n,this.c=r}d(v,n){this.a({type:v,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(C.default.Error,v)}warn(v){this.d(C.default.Warning,v)}info(v){this.d(C.default.Info,v)}}e.$5E=b;class p{static a(v){const n=new D.$7l;for(let r=0,s=v.length;r<s;r++)n.add(v[r].description.identifier);return n}static compute(v,n){if(!v||!v.length)return new p(n,[]);if(!n||!n.length)return new p([],v);const r=this.a(v),s=this.a(n),o=n.filter(d=>!r.has(d.description.identifier)),w=v.filter(d=>!s.has(d.description.identifier));return new p(o,w)}constructor(v,n){this.added=v,this.removed=n}}e.$6E=p;class f{constructor(v,n){this.name=v,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=p.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,M.$1)(v)}}}e.$7E=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$8E={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$5l},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"*",description:y.localize(42,null),body:"*"}]}},badges:{type:"array",description:y.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(44,null)},href:{type:"string",description:y.localize(45,null)},description:{type:"string",description:y.localize(46,null)}}}},markdown:{type:"string",description:y.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Xn}},extensionPack:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Xn}},extensionKind:{description:y.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(52,null)},{body:["workspace"],description:y.localize(53,null)},{body:["ui","workspace"],description:y.localize(54,null)},{body:["workspace","ui"],description:y.localize(55,null)},{body:[],description:y.localize(56,null)}]},capabilities:{description:y.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(60,null),y.localize(61,null),y.localize(62,null)]},description:{type:"string",markdownDescription:y.localize(63,null)}}},untrustedWorkspaces:{description:y.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(66,null),y.localize(67,null),y.localize(68,null)]},restrictedConfigurations:{description:y.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(70,null)}}}}},sponsor:{description:y.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(73,null),type:"string"},"vscode:uninstall":{description:y.localize(74,null),type:"string"}}},icon:{type:"string",description:y.localize(75,null)},l10n:{type:"string",description:y.localize(76,null)},pricing:{type:"string",markdownDescription:y.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const n=new f(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,n),v.activationEventsGenerator&&k.$VE.register(v.extensionPoint,v.activationEventsGenerator),e.$8E.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,c.registerSchema(i,e.$8E),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$9E=a;const $={ExtensionsRegistry:"ExtensionsRegistry"};l.$gn.add($.ExtensionsRegistry,new a),e.$0E=l.$gn.as($.ExtensionsRegistry),c.registerSchema(i,e.$8E),c.registerSchema(R.$qj,{properties:{extensionEnabledApiProposals:{description:y.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[214],Re([1,0,163,15,25,213,32,5]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OF=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var g;(function(c){function b(p,f,t){if(!p)return;const i=M.$yf(p.type)?p.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const a=[];if(Array.isArray(p.required))for(const $ of p.required)M.$yf($)&&a.push($);return{extensionId:f.value,taskType:i,required:a,properties:p.properties?C.$7m(p.properties):{},when:p.when?A.$Ni.deserialize(p.when):void 0}}c.from=b})(g||(g={}));const R=T.$0E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,b)=>{for(const p of c)p.type&&b.push(`onTaskType:${p.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new l.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,p)=>{R.setHandler((f,t)=>{this.c=void 0;try{for(const i of t.removed){const a=i.value;for(const $ of a)this.a&&$.type&&this.a[$.type]&&delete this.a[$.type]}for(const i of t.added){const a=i.value;for(const $ of a){const E=g.from($,i.description.identifier,i.collector);E&&(this.a[E.taskType]=E)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const p of this.all()){const f={type:"object",additionalProperties:!1};p.required.length>0&&(f.required=p.required.slice(0)),p.properties!==void 0?f.properties=C.$7m(p.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[p.taskType]},b.push(f)}this.c={oneOf:b}}return this.c}}e.$OF=new k}),define(Ae[215],Re([1,0,164,15,24,25,32,214]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$YF=e.JsonSchemaVersion=e.ExecutionEngine=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$SF=e.ShellQuoting=e.$RF=e.$QF=e.$PF=void 0,e.$PF="settings",e.$QF=new A.$7i("taskRunning",!1,y.localize(0,null)),e.$RF={value:y.localize(1,null),original:"Tasks"};var D;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$SF="$customized",function(O){function N(ie){if(!ie)return O.Strong;switch(ie.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(D||(e.ShellQuoting=D={}));var g;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R||(e.RevealKind=R={})),function(O){function N(ie){switch(ie.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(R||(e.RevealKind=R={}));var k;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(O){function N(ie){switch(ie.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(k||(e.RevealProblemKind=k={}));var c;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(c||(e.PanelKind=c={})),function(O){function N(ie){switch(ie.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(c||(e.PanelKind=c={}));var b;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:c.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var p;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(O){function N(X){switch(X.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function ie(X){switch(X){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=ie}(p||(e.RuntimeType=p={}));var f;(function(O){function N(ie){return M.$yf(ie)?ie:ie.value}O.value=N})(f||(e.CommandString=f={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(X){return X===O.Clean._id||X===O.Build._id||X===O.Rebuild._id||X===O.Test._id}O.is=N;function ie(X){if(X!==void 0)return M.$yf(X)?N(X)?{_id:X,isDefault:!1}:void 0:X}O.from=ie})(t||(e.TaskGroup=t={}));var i;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var a;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(ie){switch(ie){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(a||(e.TaskSourceKind=a={}));var $;(function(O){O.parallel="parallel",O.sequence="sequence"})($||(e.DependsOrder=$={}));var E;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var v;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class n{constructor(N,ie,X,Ee,Se,Pe){this._label="",this._id=N,ie&&(this._label=ie),X&&(this.type=X),this.runOptions=Ee,this.configurationProperties=Se,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,ie=!1){if(N===void 0)return!1;if(M.$yf(N))return N===this._label||N===this.configurationProperties.identifier||ie&&N===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$TF=n;class r extends n{constructor(N,ie,X,Ee,Se,Pe,$e,pe){super(N,X,void 0,$e,pe,ie),this.command={},this._source=ie,this.hasDefinedMatchers=Pe,Se&&(this.command=Se)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let ie;switch(this.command?this.command.runtime:void 0){case p.Shell:ie="shell";break;case p.Process:ie="process";break;case p.CustomExecution:ie="customExecution";break;case void 0:ie="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ie,_key:this._id,id:this._id}}}static is(N){return N instanceof r}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===a.User?e.$PF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ie=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(ie+=this._source.kind);const X={type:e.$SF,folder:N,id:ie};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new r(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$UF=r;class s extends n{constructor(N,ie,X,Ee,Se,Pe,$e){super(N,X,Ee,Pe,$e,ie),this._source=ie,this.configures=Se}static is(N){return N instanceof s}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===a.User?e.$PF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ie=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(ie+=this._source.kind);const X={type:e.$SF,folder:N,id:ie};return JSON.stringify(X)}}e.$VF=s;class o extends n{constructor(N,ie,X,Ee,Se,Pe,$e,pe,ue){super(N,X,Ee,pe,ue,ie),this.defines=Se,this.hasDefinedMatchers=$e,this.command=Pe,this.icon=ue.icon,this.hide=ue.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$WF=o;class w extends n{constructor(N,ie,X,Ee,Se,Pe){super(N,X,Ee,Se,Pe,ie),this._source=ie}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new w(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$XF=w;var d;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(O){O._default=O.Terminal}(d||(e.ExecutionEngine=d={}));var I;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class S{constructor(N){this.c=new Map;for(let ie=0;ie<N.length;ie++)this.c.set(N[ie].uri.toString(),ie)}compare(N,ie){const X=N.getWorkspaceFolder(),Ee=ie.getWorkspaceFolder();if(X&&Ee){let Se=this.c.get(X.uri.toString());Se=Se===void 0?0:Se+1;let Pe=this.c.get(Ee.uri.toString());return Pe=Pe===void 0?0:Pe+1,Se===Pe?N._label.localeCompare(ie._label):Se-Pe}else return!X&&Ee?-1:X&&!Ee?1:0}}e.$YF=S;var u;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(u||(e.TaskEventKind=u={}));var m;(function(O){O.SingleRun="singleRun",O.Background="background"})(m||(e.TaskRunType=m={}));var h;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(h||(e.TaskRunSource=h={}));var P;(function(O){function N(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function ie(pe,ue,oe){return{...N(pe),kind:"start",terminalId:ue,resolvedVariables:oe}}O.start=ie;function X(pe,ue,oe){return{...N(pe),kind:"processStarted",terminalId:ue,processId:oe}}O.processStarted=X;function Ee(pe,ue,oe){return{...N(pe),kind:"processEnded",terminalId:ue,exitCode:oe}}O.processEnded=Ee;function Se(pe,ue,oe){return{...N(pe),kind:"terminated",exitReason:oe,terminalId:ue}}O.terminated=Se;function Pe(pe,ue,oe){return{...N(ue),kind:pe,terminalId:oe}}O.general=Pe;function $e(){return{kind:"changed"}}O.changed=$e})(P||(e.TaskEvent=P={}));var W;(function(O){function N(X){const Ee=Object.keys(X).sort();let Se="";for(const Pe of Ee){let $e=X[Pe];$e instanceof Object?$e=N($e):typeof $e=="string"&&($e=$e.replace(/,/g,",,")),Se+=Pe+","+$e+","}return Se}function ie(X){const Se={_key:N(X),type:X.taskType};return Object.assign(Se,X),Se}O.create=ie})(W||(e.KeyedTaskIdentifier=W={}));var K;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(K||(e.TaskSettingId=K={}));var z;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var j;(function(O){function N(ie,X){const Ee=l.$OF.get(ie.type);if(Ee===void 0){const pe=T.$7m(ie);return delete pe._key,W.create(pe)}const Se=Object.create(null);Se.type=Ee.taskType;const Pe=new Set;Ee.required.forEach(pe=>Pe.add(pe));const $e=Ee.properties;for(const pe of Object.keys($e)){const ue=ie[pe];if(ue!=null)Se[pe]=ue;else if(Pe.has(pe)){const oe=$e[pe];if(oe.default!==void 0)Se[pe]=T.$7m(oe.default);else switch(oe.type){case"boolean":Se[pe]=!1;break;case"number":case"integer":Se[pe]=0;break;case"string":Se[pe]="";break;default:X.error(y.localize(2,null,JSON.stringify(ie,void 0,0),pe));return}}}return W.create(Se)}O.createTaskIdentifier=N})(j||(e.TaskDefinition=j={}))}),define(Ae[216],Re([1,0,9]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q4b=e.$p4b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$1)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$p4b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new y.$5}}e.$q4b=C}),define(Ae[47],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=e.$pv=e.$ov=e.$nv=void 0;class y{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++y.count}}e.$nv=y;const M=[];function C(l){const D=new y(l);return M[D.nid]=D,D}e.$ov=C;function T(l){return M[l].sid}e.$pv=T;class A{constructor(D){this.value=D}}e.$qv=A}),define(Ae[3],Re([1,0,47]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$gK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$fK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var T;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var D;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var R;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class k{static{this.a=0}static mixin(t){return t._id=k.a++,t}}e.$fK=k;var c;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var b;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var p;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$gK={MainThreadAuthentication:(0,y.$ov)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$ov)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$ov)("MainThreadChatProvider"),MainThreadChatAgents:(0,y.$ov)("MainThreadChatAgents"),MainThreadChatAgents2:(0,y.$ov)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$ov)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$ov)("MainThreadClipboard"),MainThreadCommands:(0,y.$ov)("MainThreadCommands"),MainThreadComments:(0,y.$ov)("MainThreadComments"),MainThreadConfiguration:(0,y.$ov)("MainThreadConfiguration"),MainThreadConsole:(0,y.$ov)("MainThreadConsole"),MainThreadDebugService:(0,y.$ov)("MainThreadDebugService"),MainThreadDecorations:(0,y.$ov)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$ov)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$ov)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$ov)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$ov)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$ov)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$ov)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$ov)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$ov)("MainThreadErrors"),MainThreadTreeViews:(0,y.$ov)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$ov)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$ov)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$ov)("MainThreadLanguages"),MainThreadLogger:(0,y.$ov)("MainThreadLogger"),MainThreadMessageService:(0,y.$ov)("MainThreadMessageService"),MainThreadOutputService:(0,y.$ov)("MainThreadOutputService"),MainThreadProgress:(0,y.$ov)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$ov)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$ov)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$ov)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$ov)("MainThreadSecretState"),MainThreadStorage:(0,y.$ov)("MainThreadStorage"),MainThreadSpeech:(0,y.$ov)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$ov)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$ov)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$ov)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$ov)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$ov)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$ov)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$ov)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$ov)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$ov)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$ov)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$ov)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$ov)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$ov)("MainThreadExtensionService"),MainThreadSCM:(0,y.$ov)("MainThreadSCM"),MainThreadSearch:(0,y.$ov)("MainThreadSearch"),MainThreadShare:(0,y.$ov)("MainThreadShare"),MainThreadTask:(0,y.$ov)("MainThreadTask"),MainThreadWindow:(0,y.$ov)("MainThreadWindow"),MainThreadLabelService:(0,y.$ov)("MainThreadLabelService"),MainThreadNotebook:(0,y.$ov)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$ov)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$ov)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$ov)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$ov)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$ov)("MainThreadInteractive"),MainThreadChat:(0,y.$ov)("MainThreadChat"),MainThreadInlineChat:(0,y.$ov)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$ov)("MainThreadTheming"),MainThreadTunnelService:(0,y.$ov)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$ov)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$ov)("MainThreadTimeline"),MainThreadTesting:(0,y.$ov)("MainThreadTesting"),MainThreadLocalization:(0,y.$ov)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$ov)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$ov)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$ov)("MainThreadIssueReporter")},e.$hK={ExtHostCommands:(0,y.$ov)("ExtHostCommands"),ExtHostConfiguration:(0,y.$ov)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$ov)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$ov)("ExtHostDebugService"),ExtHostDecorations:(0,y.$ov)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$ov)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$ov)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$ov)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$ov)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$ov)("ExtHostEditors"),ExtHostTreeViews:(0,y.$ov)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$ov)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$ov)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$ov)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$ov)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$ov)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$ov)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$ov)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$ov)("ExtHostStatusBar"),ExtHostShare:(0,y.$ov)("ExtHostShare"),ExtHostExtensionService:(0,y.$ov)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$ov)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$ov)("ExtHostTerminalService"),ExtHostSCM:(0,y.$ov)("ExtHostSCM"),ExtHostSearch:(0,y.$ov)("ExtHostSearch"),ExtHostTask:(0,y.$ov)("ExtHostTask"),ExtHostWorkspace:(0,y.$ov)("ExtHostWorkspace"),ExtHostWindow:(0,y.$ov)("ExtHostWindow"),ExtHostWebviews:(0,y.$ov)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$ov)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$ov)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$ov)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$ov)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$ov)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$ov)("ExtHostProgress"),ExtHostComments:(0,y.$ov)("ExtHostComments"),ExtHostSecretState:(0,y.$ov)("ExtHostSecretState"),ExtHostStorage:(0,y.$ov)("ExtHostStorage"),ExtHostUrls:(0,y.$ov)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$ov)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$ov)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$ov)("ExtHostOutputService"),ExtHosLabelService:(0,y.$ov)("ExtHostLabelService"),ExtHostNotebook:(0,y.$ov)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$ov)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$ov)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$ov)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$ov)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$ov)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$ov)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$ov)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$ov)("ExtHostChat"),ExtHostChatAgents:(0,y.$ov)("ExtHostChatAgents"),ExtHostChatAgents2:(0,y.$ov)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$ov)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$ov)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$ov)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$ov)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$ov)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$ov)("ExtHostTheming"),ExtHostTunnelService:(0,y.$ov)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$ov)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$ov)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$ov)("ExtHostTimeline"),ExtHostTesting:(0,y.$ov)("ExtHostTesting"),ExtHostTelemetry:(0,y.$ov)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$ov)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$ov)("ExtHostIssueReporter")}}),define(Ae[217],Re([1,0,3,7]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$gK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,D){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(A);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(l,D)??[]}getRelatedInformation(A,l,D){return this.c.$getAiRelatedInformation(l,D)}registerRelatedInformationProvider(A,l,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiRelatedInformationProvider(g,l),new M.$iK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$aec=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=e.$ccc=void 0,e.$ccc=(0,y.$Ph)("IExtHostApiDeprecationService");let A=class{constructor(D,g){this.c=g,this.a=new Set,this.b=D.getProxy(C.$gK.MainThreadTelemetry)}report(D,g,R){const k=this.d(D,g);this.a.has(k)||(this.a.add(k),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}d(D,g){return`${D}-${g.identifier.value}`}};e.$dcc=A,e.$dcc=A=qe([Ke(0,T.$hM),Ke(1,M.$0i)],A),e.$ecc=Object.freeze(new class{report(l,D,g){}})}),define(Ae[218],Re([1,0,5,3,7,21]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class A{constructor(g){this.b=new Map,this.c=[],this.d=new y.$Nd,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=g.getProxy(M.$gK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,R,k,c={}){const b=T.$6l.toKey(g.identifier),p=[...k].sort().join(" ");return await this.f.getOrCreate(`${b} ${R} ${p}`,async()=>{await this.a.$ensureProvider(R);const f=g.displayName||g.name;return this.a.$getSession(R,k,b,f,c)})}async getSessions(g,R,k){const c=T.$6l.toKey(g.identifier),b=[...k].sort().join(" ");return await this.g.getOrCreate(`${c} ${b}`,async()=>{await this.a.$ensureProvider(R);const p=g.displayName||g.name;return this.a.$getSessions(R,k,c,p)})}async removeSession(g,R){const k=this.b.get(g);return k?k.provider.removeSession(R):this.a.$removeSession(g,R)}registerAuthenticationProvider(g,R,k,c){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:R,provider:k,options:c??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===g)||this.c.push({id:g,label:R});const b=k.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(g,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(g,R,c?.supportsMultipleAccounts??!1),new C.$iK(()=>{b.dispose(),this.b.delete(g);const p=this.c.findIndex(f=>f.id===g);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,R,k){const c=this.b.get(g);if(c)return Promise.resolve(c.provider.createSession(R,k));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,R){const k=this.b.get(g);if(k)return Promise.resolve(k.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,R){const k=this.b.get(g);if(k)return Promise.resolve(k.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,R){return this.d.fire({provider:{id:g,label:R}}),Promise.resolve()}}e.$Kdc=A;class l{constructor(){this.a=new Map}getOrCreate(g,R){const k=this.a.get(g);if(k)return k;const c=R().finally(()=>this.a.delete(g));return this.a.set(g,c),c}}}),define(Ae[219],Re([1,0,3,17,8]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;let T=class{constructor(l,D){this.a=l.getProxy(y.$gK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,D,g){const R=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,g?.isRefactoring??!1)}};e.$Qdc=T,e.$Qdc=T=qe([Ke(0,M.$hM)],T)}),define(Ae[220],Re([1,0,12,5,66,6,59,146,3,8]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;class R{static{this.a=0}constructor(b,p){this.extension=b,this.provider=p,this.handle=R.a++}}class k{static{this.a=0}constructor(b,p){this.h=p,this.b=new Map,this.d=new Map,this.e=new M.$Nd,this.onDidPerformUserAction=this.e.event,this.g=b.getProxy(D.$gK.MainThreadChat)}registerChatProvider(b,p,f){const t=new R(b,f);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,p),(0,T.$Qc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(b,p){const f=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===b)??0;typeof f=="number"&&this.g.$transferChatSession(f,p)}sendInteractiveRequestToProvider(b,p){this.g.$sendRequestToProvider(b,p)}async $prepareChat(b,p,f){const t=this.b.get(b);if(!t)return;const i=await t.provider.prepareSession(p,f);if(!i)return;const a=k.a++;return this.d.set(a,i),{id:a,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(b,p){const f=this.b.get(b);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(p);if(t)return t.map(i=>typeof i=="string"?i:i.map(a=>g.ChatReplyFollowup.from(a)))}async $provideFollowups(b,p,f){const t=this.b.get(b);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,f))?.map($=>g.ChatFollowup.from($))}async $provideSampleQuestions(b,p){const f=this.b.get(b);if(!f||!f.provider.provideSampleQuestions)return;const t=await f.provider.provideSampleQuestions(p);if(t)return t?.map(i=>g.ChatReplyFollowup.from(i))}$removeRequest(b,p,f){const t=this.b.get(b);if(!t)return;const i=this.d.get(p);i&&t.provider.removeRequest&&t.provider.removeRequest(i,f)}async $provideReply(b,p,f,t){const i=this.b.get(b);if(!i)return;const a=this.d.get(p);if(!a)return;const $={session:a,message:f.message,variables:{}};if(f.variables)for(const o of Object.keys(f.variables))$.variables[o]=f.variables[o].map(g.ChatVariable.to);const E=A.$Jd.create(!1);let v;const n={report:o=>{if(t.isCancellationRequested)return;typeof v>"u"&&(v=E.elapsed());const w=g.ChatResponseProgress.from(o);if("placeholder"in o&&"resolvedContent"in o){const d=Promise.all([this.g.$acceptResponseProgress(b,p,w),o.resolvedContent]);(0,y.$Ig)(d,t).then(I=>{if(!I)return;const[S,u]=I;this.g.$acceptResponseProgress(b,p,u,S??void 0)})}else this.g.$acceptResponseProgress(b,p,w)}};let r;try{r=await i.provider.provideResponseWithProgress($,n,t),r||(r={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){r={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(a.saveState&&this.d.has(p)){const o=a.saveState();this.g.$acceptChatState(p,o)}}catch(o){this.h.warn(o)}const s={firstProgress:v??0,totalElapsed:E.elapsed()};return{errorDetails:r.errorDetails,timings:s}}async $provideSlashCommands(b,p,f){const t=this.b.get(b);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,f))?.map($=>({...$,kind:g.CompletionItemKind.from($.kind)}))}$releaseSession(b){this.d.delete(b)}async $onDidPerformUserAction(b){this.e.fire(b)}}e.$5dc=k}),define(Ae[221],Re([1,0,12,6,51,3,8,7]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class D{static{this.a=0}constructor(k,c,b){this.d=c,this.e=b,this.b=new Map,this.c=k.getProxy(T.$gK.MainThreadChatAgents)}registerAgent(k,c,b,p){const f=D.a++;return this.b.set(f,{extension:k,agent:b}),this.c.$registerAgent(f,c,p),(0,M.$Qc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(k,c,b,p,f){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function a(){if(i)throw new Error("Only valid while executing the command")}const $=new y.$ch;f.onCancellationRequested(()=>$.complete()),setTimeout(()=>$.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,$.p);const E=t.agent({role:l.ChatMessageRole.User,content:b},{history:p.history.map(A.ChatMessage.to)},new C.$6u(v=>{a(),this.c.$handleProgressChunk(c,{content:g(v.message)?v.message:v.message.value})}),f);try{return await(0,y.$Ig)(Promise.resolve(E).then(v=>{if(v&&"followUp"in v)return{followUp:v?.followUp?.map(r=>A.ChatFollowup.from(r))}}),f)}finally{i=!0,$.complete()}}}e.$cec=D;function g(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(Ae[222],Re([1,0,12,19,37,5,15,51,3,8,7,193,22]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class b{static{this.a=0}constructor(t,i,a){this.h=i,this.i=a,this.b=new Map,this.g=new Map,this.d=t.getProxy(D.$gK.MainThreadChatAgents2)}createChatAgent(t,i,a){const $=b.a++,E=new p(t,i,this.d,$,a);return this.b.set($,E),this.d.$registerAgent($,i,{}),E.apiAgent}async $invokeAgent(t,i,a,$,E,v){const n=this.b.get(t);if(!n)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let r=!1;function s(){if(r)throw new Error("Only valid while executing the command")}const o=new y.$ch;v.onCancellationRequested(()=>o.complete()),setTimeout(()=>o.complete(),10*1e3),this.h.allowListExtensionWhile(n.extension.identifier,o.p);const w=$.command?await n.validateSlashCommand($.command):void 0;try{const d=n.invoke({prompt:$.message,variables:g.ChatVariable.objectTo($.variables),slashCommand:w},{history:E.history.map(g.ChatMessage.to)},new l.$6u(I=>{s();const S=g.ChatResponseProgress.from(I);this.d.$handleProgressChunk(a,S)}),v);return await(0,y.$Ig)(Promise.resolve(d).then(I=>{if(I)return this.g.set(i,I),{errorDetails:I.errorDetails};this.g.delete(i)}),v)}catch(d){return this.i.error(d,n.extension),{errorDetails:{message:(0,C.$Ai)(d)}}}finally{r=!0,o.complete()}}$releaseSession(t){this.g.delete(t)}async $provideSlashCommands(t,i){const a=this.b.get(t);return a?a.provideSlashCommand(i):[]}$provideFollowups(t,i,a){const $=this.b.get(t);if(!$)return Promise.resolve([]);const E=this.g.get(i);return E?$.provideFollowups(E,a):Promise.resolve([])}$acceptFeedback(t,i,a){const $=this.b.get(t);if(!$)return;const E=this.g.get(i);if(!E)return;let v;switch(a){case k.InteractiveSessionVoteDirection.Down:v=R.ChatAgentResultFeedbackKind.Unhelpful;break;case k.InteractiveSessionVoteDirection.Up:v=R.ChatAgentResultFeedbackKind.Helpful;break}$.acceptFeedback(Object.freeze({result:E,kind:v}))}$acceptAction(t,i,a){const $=this.b.get(t);if(!$)return;const E=this.g.get(i);E&&a.action.kind!=="vote"&&$.acceptAction(Object.freeze({action:a.action,result:E}))}}e.$dec=b;class p{constructor(t,i,a,$,E){this.extension=t,this.m=i,this.n=a,this.o=$,this.q=E,this.k=new T.$Nd,this.l=new T.$Nd}acceptFeedback(t){this.k.fire(t)}acceptAction(t){this.l.fire(t)}async validateSlashCommand(t){this.b||(await this.provideSlashCommand(M.CancellationToken.None),(0,A.$If)(this.b));const i=this.b.find(a=>a.name===t);if(!i)throw new Error(`Unknown slashCommand: ${t}`);return i}async provideSlashCommand(t){if(!this.a)return[];const i=await this.a.provideSlashCommands(t);return i?(this.b=i,i.map(a=>({name:a.name,description:a.description}))):[]}async provideFollowups(t,i){if(!this.d)return[];const a=await this.d.provideFollowups(t,i);return a?a.map($=>g.ChatFollowup.from($)):[]}get apiAgent(){let t=!1,i=!1;const a=()=>{t||i||(i=!0,queueMicrotask(()=>{this.n.$updateAgent(this.o,{description:this.g??"",fullName:this.h,icon:this.i,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j}),i=!1}))},$=this;return{get name(){return $.m},get description(){return $.g??""},set description(E){$.g=E,a()},get fullName(){return $.h??$.extension.displayName??$.extension.name},set fullName(E){$.h=E,a()},get iconPath(){return $.i},set iconPath(E){$.i=E,a()},get slashCommandProvider(){return $.a},set slashCommandProvider(E){$.a=E,a()},get followupProvider(){return $.d},set followupProvider(E){$.d=E,a()},get isDefault(){return(0,c.$eF)($.extension,"defaultChatAgent"),$.j},set isDefault(E){(0,c.$eF)($.extension,"defaultChatAgent"),$.j=E,a()},get onDidReceiveFeedback(){return $.k.event},onDidPerformAction:(0,c.$dF)(this.extension,"chatAgents2Additions")?this.l.event:void 0,dispose(){t=!0,$.a=void 0,$.d=void 0,$.k.dispose(),$.n.$unregisterAgent($.o)}}}invoke(t,i,a,$){return this.q(t,i,a,$)}}}),define(Ae[223],Re([1,0,19,6,3,8,51,21,12,5]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;class R{constructor(p,f){this.stream=new D.$gh,this.stream=f??new D.$gh;const t=this;this.apiObj={option:p,response:t.stream.asyncIterable}}}class k{constructor(p,f){this.a=new g.$Nd,this.b=new Map,this.c=new D.$gh,this.d=!1;const t=this;this.apiObject={result:p,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){f.cancel()}},p.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.complete();else this.c.complete()})}handleFragment(p){if(this.d)return;let f=this.b.get(p.index);f||(this.b.size===0?f=new R(p.index,this.c):f=new R(p.index),this.b.set(p.index,f),this.a.fire(f.apiObj)),f.stream.emit(p.part)}}class c{static{this.a=1}constructor(p,f){this.d=f,this.c=new Map,this.e=new Map,this.f=new l.$8l,this.b=p.getProxy(C.$gK.MainThreadChatProvider)}registerProvider(p,f,t,i){const a=c.a++;return this.c.set(a,{extension:p,provider:t}),this.b.$registerProvider(a,f,{extension:p,displayName:i.name??p.value}),(0,M.$Qc)(()=>{this.b.$unregisterProvider(a),this.c.delete(a)})}async $provideChatResponse(p,f,t,i,a){const $=this.c.get(p);if(!$)return;const E=new A.$6u(async v=>{if(a.isCancellationRequested){this.d.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(f,{index:v.index,part:v.part})},{async:!0});return $.provider.provideChatResponse(t.map(T.ChatMessage.to),i,E,a)}allowListExtensionWhile(p,f){this.f.set(p,f),f.finally(()=>this.f.delete(p))}async requestChatResponseProvider(p,f){if(!this.f.has(p))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(p)},makeRequest(i,a,$){if(!t.f.has(p))throw new Error("Access to chat has been revoked");const E=new y.$Xd($),v=Math.random()*1e6|0,n=t.b.$fetchResponse(p,f,v,i.map(T.ChatMessage.from),a??{},E.token),r=new k(n,E);return t.e.set(v,{res:r}),n.finally(()=>{t.e.delete(v)}),r.apiObject}}}async $handleResponseFragment(p,f){const t=this.e.get(p);t&&t.res.handleFragment(f)}}e.$0dc=c}),define(Ae[224],Re([1,0,6,3,9,8]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;class A{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(M.$gK.MainThreadChatVariables)}async $resolveVariable(D,g,R){const k=this.b.get(D);if(k)try{const c=await k.resolver.resolve(k.data.name,{message:g},R);if(c)return c.map(T.ChatVariable.from)}catch(c){(0,C.$2)(c)}}registerVariableResolver(D,g,R,k){const c=A.a++;return this.b.set(c,{extension:D.identifier,data:{name:g,description:R},resolver:k}),this.c.$registerVariable(c,{name:g,description:R}),(0,y.$Qc)(()=>{this.b.delete(c),this.c.$unregisterVariable(c)})}}e.$_dc=A}),define(Ae[225],Re([1,0,3]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class M{constructor(T){const A=T.getProxy(y.$gK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$hcc=M}),define(Ae[31],Re([1,0,15,7,8,25,3,18,14,68,41,281,2,6,4,17,104,26,47,37,59,54,58]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=void 0;let r=class{#e;#t;#i;constructor(S,u,m){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$gK.MainThreadCommands),this.d=u,this.#i=m,this.#t=S.getProxy(A.$gK.MainThreadTelemetry),this.converter=new s(this,h=>{const P=this.c.get(h);return P?.result===w.Void?P:void 0},u),this.f=[{processArgument(h){return(0,g.$mh)(h)}},{processArgument(h){return(0,T.$9m)(h,function(P){if(R.$us.isIRange(P))return C.Range.to(P);if(k.$ts.isIPosition(P))return C.Position.to(P);if(R.$us.isIRange(P.range)&&c.URI.isUri(P.uri))return C.location.to(P);if(P instanceof i.$be)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const u=this.registerCommand(!1,S.id,async(...m)=>{const h=S.args.map((W,K)=>{if(!W.validate(m[K]))throw new Error(`Invalid argument '${W.name}' when running '${S.id}', received: ${typeof m[K]=="object"?JSON.stringify(m[K],null,"	"):m[K]} `);return W.convert(m[K])}),P=await this.executeCommand(S.internalId,...h);return S.result.convert(P,m,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new M.$iK(()=>{u.dispose(),this.c.delete(S.id)})}registerCommand(S,u,m,h,P,W){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:m,thisArg:h,metadata:P,extension:W}),S&&this.#e.$registerCommand(u),new M.$iK(()=>{this.b.delete(u)&&S&&this.#e.$unregisterCommand(u)})}executeCommand(S,...u){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,u,!0)}async g(S,u,m){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,u,!1);{let h=!1;const P=(0,T.$9m)(u,function(W){if(W instanceof M.$jK)return C.Position.from(W);if(W instanceof M.$kK)return C.Range.from(W);if(W instanceof M.$uK)return C.location.from(W);if(M.$FL.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return h=!0,i.$be.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return h=!0,i.$be.wrap(W);if(W instanceof i.$be)return h=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(S,h?new a.$qv(P):P,m);return(0,g.$mh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(S,u,!1);throw W}}}async h(S,u,m){const h=this.b.get(S);if(!h)throw new Error("Unknown command");const{callback:P,thisArg:W,metadata:K}=h;if(K?.args)for(let j=0;j<K.args.length;j++)try{(0,y.$Pf)(u[j],K.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${K.args[j].name}' - ${K.args[j].description}`)}const z=E.$Jd.create();try{return await P.apply(W,u)}catch(j){if(S===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...u);O&&(S=O.command)}if(this.d.error(j,S,h.extension?.identifier),!m)throw j;if(h.extension?.identifier){const O=this.#i.onExtensionError(h.extension.identifier,j);this.d.trace("forwarded error to extension?",O,h.extension?.identifier)}throw new class extends Error{constructor(){super((0,$.$Ai)(j)),this.id=S,this.source=h.extension?.displayName??h.extension?.name}}}finally{this.j(h,S,z.elapsed())}}j(S,u,m){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new v.$ko(u),duration:m})}$executeContributedCommand(S,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const m=this.b.get(S);return m?(u=u.map(h=>this.f.reduce((P,W)=>W.processArgument(P,m.extension?.identifier),h)),this.h(S,u,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(u=>(S&&(u=u.filter(m=>m[0]!=="_")),u))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[u,m]of this.b){const{metadata:h}=m;h&&(S[u]=h)}return Promise.resolve(S)}};e.$CM=r,e.$CM=r=qe([Ke(0,f.$hM),Ke(1,D.$0i),Ke(2,n.$BM)],r),e.$DM=(0,p.$Ph)("IExtHostCommands");class s{constructor(S,u,m){this.d=S,this.f=u,this.g=m,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,u){if(!S)return;const m={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return m;const h=this.f(S.command);if(h)m.id=h.internalId,m.arguments=h.args.map((P,W)=>P.convert(S.arguments&&S.arguments[W]));else if((0,l.$Lb)(S.arguments)){const P=`${S.command} /${++this.c}`;this.b.set(P,S),u.add((0,b.$Qc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),m.$ident=P,m.id=this.delegatingCommandId,m.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return m}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const u=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$EM=s;class o{static{this.Uri=new o("uri","Uri of a text document",S=>c.URI.isUri(S),S=>S)}static{this.Position=new o("position","A position in a text document",S=>M.$jK.isPosition(S),C.Position.from)}static{this.Range=new o("range","A range in a text document",S=>M.$kK.isRange(S),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",S=>M.$lK.isSelection(S),C.Selection.from)}static{this.Number=new o("number","",S=>typeof S=="number",S=>S)}static{this.String=new o("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=o.Arr(o.String)}static Arr(S){return new o(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,u=>Array.isArray(u)&&u.every(m=>S.validate(m)),u=>u.map(m=>S.convert(m)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",S=>S instanceof M.$EK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",S=>S instanceof M.$YL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",S=>S instanceof t.$uM,C.TestItem.from)}constructor(S,u,m,h){this.name=S,this.description=u,this.validate=m,this.convert=h}optional(){return new o(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,u){return new o(S??this.name,u??this.description,this.validate,this.convert)}}e.$FM=o;class w{static{this.Void=new w("no result",S=>S)}constructor(S,u){this.description=S,this.convert=u}}e.$GM=w;class d{constructor(S,u,m,h,P){this.id=S,this.internalId=u,this.description=m,this.args=h,this.result=P}}e.$HM=d}),define(Ae[226],Re([1,0,18,13,2,78,91,32,95,31,8,7]),function(ye,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;const c=[new g.$HM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$FM.Uri,g.$FM.Position],new g.$GM("A promise that resolves to an array of DocumentHighlight-instances.",p(R.DocumentHighlight.to))),new g.$HM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$FM.Uri],new g.$GM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Kb)(t))return;class a extends k.$zK{static to(E){const v=new a(E.name,R.SymbolKind.to(E.kind),E.containerName||"",new k.$uK(i[0],R.Range.to(E.range)));return v.detail=E.detail,v.range=v.location.range,v.selectionRange=R.Range.to(E.selectionRange),v.children=E.children?E.children.map(a.to):[],v}}return t.map(a.to)})),new g.$HM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$FM.Uri,new g.$FM("options","Formatting options",t=>!0,t=>t)],new g.$GM("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new g.$HM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$FM.Uri,g.$FM.Range,new g.$FM("options","Formatting options",t=>!0,t=>t)],new g.$GM("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new g.$HM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$FM.Uri,g.$FM.Position,new g.$FM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$FM("options","Formatting options",t=>!0,t=>t)],new g.$GM("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new g.$HM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$FM.Uri,g.$FM.Position],new g.$GM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$HM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$FM.Uri,g.$FM.Position],new g.$GM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$HM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$FM.Uri,g.$FM.Position],new g.$GM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$HM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$FM.Uri,g.$FM.Position],new g.$GM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$HM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$FM.Uri,g.$FM.Position],new g.$GM("A promise that resolves to an array of Location-instances.",p(R.location.to))),new g.$HM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$FM.Uri,g.$FM.Position],new g.$GM("A promise that resolves to an array of Hover-instances.",p(R.Hover.to))),new g.$HM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$FM.Uri,new g.$FM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>k.$jK.isPosition(i)),t=>t.map(R.Position.from))],new g.$GM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let a;for(const $ of i.reverse())a=new k.$DK(R.Range.to($),a);return a}))),new g.$HM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$FM.String.with("query","Search string")],new g.$GM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new g.$HM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$FM.Uri,g.$FM.Position],new g.$GM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new g.$HM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$FM.CallHierarchyItem],new g.$GM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new g.$HM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$FM.CallHierarchyItem],new g.$GM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new g.$HM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$FM.Uri,g.$FM.Position],new g.$GM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new g.$HM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$FM.Uri,g.$FM.Position,g.$FM.String.with("newName","The new symbol name")],new g.$GM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new g.$HM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$FM.Uri,g.$FM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$GM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new g.$HM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$FM.Uri],new g.$GM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$xL(t.tokenTypes,t.tokenModifiers)})),new g.$HM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$FM.Uri],new g.$GM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$X0)(t);if(i.type==="full")return new k.$zL(i.data,void 0)})),new g.$HM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$FM.Uri,g.$FM.Range.optional()],new g.$GM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$xL(t.tokenTypes,t.tokenModifiers)})),new g.$HM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$FM.Uri,g.$FM.Range],new g.$GM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$X0)(t);if(i.type==="full")return new k.$zL(i.data,void 0)})),new g.$HM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$FM.Uri,g.$FM.Position,g.$FM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$FM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$GM("A promise that resolves to a CompletionList-instance.",(t,i,a)=>{if(!t)return new k.$PK([]);const $=t.suggestions.map(E=>R.CompletionItem.to(E,a));return new k.$PK($,t.incomplete)})),new g.$HM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$FM.Uri,g.$FM.Position,g.$FM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$GM("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new g.$HM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$FM.Uri,g.$FM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$GM("A promise that resolves to an array of CodeLens-instances.",(t,i,a)=>p($=>new k.$HK(R.Range.to($.range),$.command&&a.fromInternal($.command)))(t))),new g.$HM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$FM.Uri,new g.$FM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$kK.isRange(t),t=>k.$lK.isSelection(t)?R.Selection.from(t):R.Range.from(t)),g.$FM.String.with("kind","Code action kind to return code actions for").optional(),g.$FM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$GM("A promise that resolves to an array of Command-instances.",(t,i,a)=>p($=>{if($._isSynthetic){if(!$.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal($.command)}else{const E=new k.$BK($.title,$.kind?new k.$CK($.kind):void 0);return $.edit&&(E.edit=R.WorkspaceEdit.to($.edit)),$.command&&(E.command=a.fromInternal($.command)),E.isPreferred=$.isPreferred,E}})(t))),new g.$HM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$FM.Uri],new g.$GM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new k.$VK(R.Range.to(i.range),R.Color.to(i.color))):[])),new g.$HM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$FM("color","The color to show and insert",t=>t instanceof k.$UK,R.Color.from),new g.$FM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new g.$GM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new g.$HM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$FM.Uri,g.$FM.Range],new g.$GM("A promise that resolves to an array of Inlay objects",(t,i,a)=>t.map(R.InlayHint.to.bind(void 0,a)))),new g.$HM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$FM.Uri],new g.$GM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(R.FoldingRange.to)})),new g.$HM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$GM("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>R.NotebookExclusiveDocumentPattern.to(i))})))),new g.$HM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$FM.Uri,g.$FM.Range,new g.$FM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$kK,t=>R.InlineValueContext.from(t))],new g.$GM("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new g.$HM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$FM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,D.$eU)(t,M.Schemas.http,M.Schemas.https),t=>t),new g.$FM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),g.$FM.String.with("label","").optional()],g.$GM.Void),new g.$HM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$FM.Uri.with("resource","Resource to open"),g.$FM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$FM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],g.$GM.Void),new g.$HM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$FM.Uri.with("left","Left-hand side resource of the diff editor"),g.$FM.Uri.with("right","Right-hand side resource of the diff editor"),g.$FM.String.with("title","Human readable title for the diff editor").optional(),new g.$FM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],g.$GM.Void),new g.$HM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$FM.Uri,g.$FM.Position],new g.$GM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new g.$HM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$FM.TypeHierarchyItem],new g.$GM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new g.$HM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$FM.TypeHierarchyItem],new g.$GM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new g.$HM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$FM.TestItem],g.$GM.Void),new g.$HM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$FM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$GM.Void),new g.$HM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$FM.String.with("name","The context key name"),new g.$FM("value","The context key value",()=>!0,t=>t)],g.$GM.Void),new g.$HM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$FM.Uri,g.$FM.StringArray,new g.$FM("MappedEditsContext","Mapped Edits Context",t=>R.MappedEditsContext.is(t),t=>R.MappedEditsContext.from(t))],new g.$GM("A promise that resolves to a workspace edit or null",t=>t?R.WorkspaceEdit.to(t):null))];class b{static register(i){c.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",l.$Oi)}}e.$gcc=b;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function f(t){if(!Array.isArray(t))return;const i=[];for(const a of t)T.$ft(a)?i.push(R.DefinitionLink.to(a)):i.push(R.location.to(a));return i}}),define(Ae[227],Re([1,0,12,65,5,6,2,78,21,8,7,3,22]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;function b(p,f,t){const i=p.getProxy(k.$gK.MainThreadComments);class a{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$8l,f.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const I=this.b.get(d.handle);return I?I.value:d}else if(d&&d.$mid===7){const I=this.b.get(d.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.commentThreadHandle);return S?S.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);return S?d.$mid===8?S.value:{thread:S.value,text:d.text}:d}else if(d&&d.$mid===10){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const u=d.commentUniqueId,m=S.getCommentByUniqueId(u);return m||d}else if(d&&d.$mid===11){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const u=d.text,m=d.commentUniqueId,h=S.getCommentByUniqueId(m);return h?(typeof h.body=="string"?h.body=u:h.body=new R.$IK(u),h):d}return d}})}createCommentController(d,I,S){const u=a.a++,m=new E(d,u,I,S);this.b.set(m.handle,m);const h=this.c.get(d.identifier)||[];return h.push(m),this.c.set(d.identifier,h),m.value}async $createCommentThreadTemplate(d,I,S){const u=this.b.get(d);u&&u.$createCommentThreadTemplate(I,S)}async $updateCommentThreadTemplate(d,I,S){const u=this.b.get(d);u&&u.$updateCommentThreadTemplate(I,S)}$deleteCommentThread(d,I){this.b.get(d)?.$deleteCommentThread(I)}$provideCommentingRanges(d,I,S){const u=this.b.get(d);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const m=t.getDocument(A.URI.revive(I));return(0,y.$Mg)(async()=>{const h=await u.commentingRangeProvider.provideCommentingRanges(m,S);let P;return Array.isArray(h)?P={ranges:h,fileComments:!1}:h?P={ranges:h.ranges||[],fileComments:h.fileComments||!1}:P=h??void 0,P}).then(h=>{let P;return h&&(P={ranges:h.ranges.map(W=>g.Range.from(W)),fileComments:h.fileComments}),P})}$toggleReaction(d,I,S,u,m){const h=this.b.get(d);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,y.$Mg)(()=>{const P=h.getCommentThread(I);if(P){const W=P.getCommentByUniqueId(u.uniqueIdInThread);if(h!==void 0&&W&&h.reactionHandler)return h.reactionHandler(W,r(m))}return Promise.resolve(void 0)})}}class ${static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,I,S,u,m,h,P,W){this.m=I,this.n=S,this.o=u,this.p=m,this.q=h,this.extensionDescription=P,this.r=W,this.handle=$.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Tc,this.l.value=new T.$Rc,this.n===void 0&&(this.n=`${d}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(z){K.range=z},get comments(){return K.comments},set comments(z){K.comments=z},get collapsibleState(){return K.collapsibleState},set collapsibleState(z){K.collapsibleState=z},get canReply(){return K.canReply},set canReply(z){K.canReply=z},get contextValue(){return K.contextValue},set contextValue(z){K.contextValue=z},get label(){return K.label},set label(z){K.label=z},get state(){return K.state},set state(z){K.state=z},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Rc);const d=S=>Object.prototype.hasOwnProperty.call(this.b,S),I={};d("range")&&(I.range=g.Range.from(this.p)),d("label")&&(I.label=this.label),d("contextValue")&&(I.contextValue=this.contextValue??null),d("comments")&&(I.comments=this.q.map(S=>v(this,S,this.k,this.extensionDescription))),d("collapsibleState")&&(I.collapseState=s(this.g)),d("canReply")&&(I.canReply=this.canReply),d("state")&&(I.state=o(this.h)),d("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(d){for(const I of this.k){const S=I[0],u=I[1];if(d===u)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}qe([(0,M.$ih)(100)],$.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,I,S,u){this.f=d,this.g=I,this.h=S,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,S,u,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(h){m.options=h},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(h){m.commentingRangeProvider=h},get reactionHandler(){return m.reactionHandler},set reactionHandler(h){m.reactionHandler=h},createCommentThread(h,P,W){return m.createCommentThread(h,P,W).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(d,I,S){I===void 0&&(0,c.$eF)(this.f,"fileComments");const u=new $(this.id,this.handle,void 0,d,I,S,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(d,I){const S=new $(this.id,this.handle,void 0,A.URI.revive(d),g.Range.to(I),[],this.f,!0);return S.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(d,I){const S=this.a.get(d);S&&(S.range=g.Range.to(I))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function v(w,d,I,S){let u=I.get(d);return u||(u=++w.commentHandle,I.set(d,u)),d.state!==void 0&&(0,c.$eF)(S,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:u,body:typeof d.body=="string"?d.body:g.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(m=>n(m)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function n(w){return{label:w.label,iconPath:w.iconPath?g.$gM(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function r(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?A.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function s(w){if(w!==void 0)switch(w){case R.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(w){if(w!==void 0)switch(w){case R.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new a}e.$icc=b}),define(Ae[228],Re([1,0,25,3,27,17]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;let A=class{constructor(R,k){this.a=R.getProxy(M.$gK.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,k){const c=this,b=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){c.e(R,k,b,arguments)}})}e(R,k,c,b){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(b,this.b)}),this.c&&this.f(R,c,b)}};e.$gec=A,e.$gec=A=qe([Ke(0,T.$hM),Ke(1,C.$xM)],A);const l=1e5;function D(g,R){const k=[];if(g.length)for(let c=0;c<g.length;c++){let b=g[c];if(typeof b>"u")b="undefined";else if(b instanceof Error){const p=b;p.stack?b=p.stack:b=p.toString()}k.push(b)}if(R){const c=new Error().stack;c&&k.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,y.$_m)(k);return c.length>l?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,16,20,22]),function(ye,e,y,M,C,T,A,l,D,g,R,k){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=e.$jdc=void 0;let b=class{static{c=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(M.$gK.MainThreadDecorations)}registerFileDecorationProvider(f,t){const i=c.c++;this.f.set(i,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const a=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations($=>{if(!$){this.g.$onDidChange(i,null);return}const E=(0,D.$3b)($);if(E.length<=c.d){this.g.$onDidChange(i,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const v=E.map(s=>({uri:s,rank:(0,g.$Ge)(s.path,"/")})),n=(0,D.$zb)(v,(s,o)=>s.rank-o.rank||(0,g.$Ue)(s.uri.path,o.uri.path)),r=[];e:for(const s of n){let o;for(const w of s){const d=(0,R.$mc)(w.uri.path);if(o!==d&&(o=d,r.push(w.uri)>=c.d))break e}}this.g.$onDidChange(i,r)});return new C.$iK(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(f,t,i){if(!this.f.has(f))return Object.create(null);const a=Object.create(null),{provider:$,extensionDescription:E}=this.f.get(f);return await Promise.all(t.map(async v=>{try{const{uri:n,id:r}=v,s=await Promise.resolve($.provideFileDecoration(y.URI.revive(n),i));if(!s)return;try{C.$DL.validate(s),s.badge&&typeof s.badge!="string"&&(0,k.$eF)(E,"codiconDecoration"),a[r]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E.identifier.value}': ${o}`)}}catch(n){this.h.error(n)}})),a}};e.$jdc=b,e.$jdc=b=c=qe([Ke(0,A.$hM),Ke(1,l.$0i)],b),e.$kdc=(0,T.$Ph)("IExtHostDecorations")}),define(Ae[229],Re([1,0,147,94,2,3,7,8,5,14,28,40]),function(ye,e,y,M,C,T,A,l,D,g,R,k){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0;class b{#e;#t;#i;constructor(t,i,a,$,E,v,n,r){this.d=t,this.e=i,this.f=a,this.g=$,this.h=E,this.c=!1,this.f=Math.max($,a),this.#i=new R.$Ac(s=>v.getComparisonKey(s)),this.#e=n,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let a=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),a=[t]}else if(Array.isArray(t)){a=[];let v;t=[...t].sort(b.k);for(const n of t){const[r,s]=n;if((!v||r.toString()!==v.toString())&&(v&&this.#i.get(v).length===0&&this.#i.delete(v),v=r,a.push(r),this.#i.set(r,[])),s)this.#i.get(r)?.push(...s);else{const o=this.#i.get(r);o&&(o.length=0)}}}if(this.#t.fire(a),!this.#e)return;const $=[];let E=0;for(const v of a){let n=[];const r=this.#i.get(v);if(r)if(r.length>this.g){n=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const w of r)if(w.severity===s[o]&&n.push({...l.Diagnostic.from(w),modelVersionId:this.h(v)})===this.g)break e;n.push({severity:M.MarkerSeverity.Info,message:(0,y.localize)(0,null,r.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=r.map(s=>({...l.Diagnostic.from(s),modelVersionId:this.h(v)}));if($.push([v,n]),E+=n.length,E>this.f)break}this.#e.$changeMany(this.e,$)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[a,$]of this)t.call(i,a,$,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$acc=b;let p=class{static{c=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*c.d}static _mapper(t){const i=new R.$Ac;for(const a of t)i.set(a,a);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,a,$){this.j=i,this.k=a,this.l=$,this.g=new Map,this.h=new D.$Rd({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,c._mapper),this.f=t.getProxy(T.$gK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:a,f:$,h:E,j:v,k:n,l:r}=this,s=new class{$changeMany(d,I){$.$changeMany(d,I),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,d,I.length===0?"CLEARING":I)}$clear(d){$.$clear(d),v.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,d)}dispose(){$.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+c.c++,o=i;else if(!a.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+c.c++;while(a.has(o))}return new class extends b{constructor(){super(i,o,c.e,c.d,d=>r.getDocument(d)?.version,n.extUri,s,E),a.set(o,this)}dispose(){super.dispose(),a.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,a=[];for(const $ of this.g.values())$.forEach((E,v)=>{let n=i.get(E.toString());typeof n>"u"&&(n=a.length,i.set(E.toString(),n),a.push([E,[]])),a[n][1]=a[n][1].concat(...v)});return a}}m(t){let i=[];for(const a of this.g.values())a.has(t)&&(i=i.concat(a.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",a=new b(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,$=>{},this.k.extUri,void 0,this.h);this.g.set(i,a),this.n=a}for(const[i,a]of t)this.n.set(C.URI.revive(i),a.map(l.Diagnostic.to))}};e.$bcc=p,e.$bcc=p=c=qe([Ke(1,g.$0i),Ke(2,k.$_bc)],p)}),define(Ae[230],Re([1,0,2,3,22]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class T{constructor(l){this.a=l.getProxy(M.$gK.MainThreadDialogs)}showOpenDialog(l,D){return D?.allowUIResources&&(0,C.$eF)(l,"showLocal"),this.a.$showOpenDialog(D).then(g=>g?g.map(R=>y.URI.revive(R)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(D=>D?y.URI.revive(D):void 0)}}e.$qcc=T}),define(Ae[231],Re([1,0,9,2,7,3,13,19,16]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class g{static{this.a=0}constructor(k,c,b){this.d=c,this.e=b,this.b=new Map,this.c=k.getProxy(T.$gK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,c){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const b=g.a++;this.b.set(b,c),this.c.$registerTextContentProvider(b,k);let p;return typeof c.onDidChange=="function"&&(p=c.onDidChange(f=>{if(f.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(b,f).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(f);if(!i)return;const a=(0,D.$Pe)(t);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(f,t)},y.$1)})),new C.$iK(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(k,c){const b=this.b.get(k);return b?Promise.resolve(b.provideTextDocumentContent(M.URI.revive(c),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.$rcc=g}),define(Ae[232],Re([1,0,5,6,2,3,100,8,15,25,7,9]),function(ye,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;class c{constructor(p,f){this.a=new y.$Nd({onListenerError:k.$2}),this.b=new y.$Nd({onListenerError:k.$2}),this.c=new y.$Nd({onListenerError:k.$2}),this.d=new y.$Nd({onListenerError:k.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Rc,this.h=new Map,this.f=p.getProxy(T.$gK.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const f=this.g.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this.g.getDocument(p);if(f)return Promise.resolve(f);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(i=>{this.h.delete(p.toString());const a=C.URI.revive(i);return(0,D.$Jf)(this.g.getDocument(a))},i=>(this.h.delete(p.toString()),Promise.reject(i))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(f=>C.URI.revive(f))}$acceptModelLanguageChanged(p,f){const t=C.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(f),this.a.fire(i.document)}$acceptModelSaved(p){const f=C.URI.revive(p),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,f){const t=C.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,t){const i=C.URI.revive(p),a=this.g.getDocument(i);if(!a)throw new Error("unknown document");a._acceptIsDirty(t),a.onEvents(f);let $;f.isUndoing?$=R.TextDocumentChangeReason.Undo:f.isRedoing&&($=R.TextDocumentChangeReason.Redo),this.c.fire((0,g.$8m)({document:a.document,contentChanges:f.changes.map(E=>({range:l.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:$}))}setWordDefinitionFor(p,f){(0,A.$jM)(p,f)}}e.$0bc=c}),define(Ae[60],Re([1,0,52,5,6,2,4,3,100,17,105,8,14,28,13,66,42]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0;class i{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(E,v){this.h=E,this.i=v,this.a=null,this.b=new Map,this.c=new b.$Ac,this.d=new M.$Nd,this.e=new M.$Nd,this.f=new M.$Nd,this.g=new M.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const v=[],n=[],r=[];if(E.removedDocuments)for(const s of E.removedDocuments){const o=T.URI.revive(s),w=this.c.get(o);w?.unref()&&(this.c.delete(o),v.push(w.value))}if(E.addedDocuments)for(const s of E.addedDocuments){const o=T.URI.revive(s.uri);let w=this.c.get(o);if(w&&o.scheme!==p.Schemas.vscodeNotebookCell&&o.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);w||(w=new i(new D.$kM(this.h.getProxy(l.$gK.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(o,w),n.push(w.value)),w.ref()}if(E.removedEditors)for(const s of E.removedEditors){const o=this.b.get(s);this.b.delete(s),o&&r.push(o)}if(E.addedEditors)for(const s of E.addedEditors){const o=T.URI.revive(s.documentUri);y.ok(this.c.has(o),`document '${o}' does not exist`),y.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const w=this.c.get(o).value,d=new R.$qM(s.id,this.h.getProxy(l.$gK.MainThreadTextEditors),this.i,new t.$V(()=>w.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(I=>k.Range.to(I)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,d)}E.newActiveEditor!==void 0&&(y.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,C.$Nc)(v),(0,C.$Nc)(r),E.removedDocuments&&this.e.fire(v),E.addedDocuments&&this.d.fire(n),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return f.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const v=this.b.get(this.a);return E?v:v?.value}allEditors(){return[...this.b.values()]}};e.$rM=a,e.$rM=a=qe([Ke(0,g.$hM),Ke(1,c.$0i)],a),e.$sM=(0,A.$Ph)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,15,233]),function(ye,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=void 0,e.$odc=(0,A.$Ph)("IExtHostEditorTabs");class k{constructor(t,i,a){this.e=a,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$ZL(C.URI.revive(this.b.input.uri));case 2:return new l.$1L(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$2L(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$3L(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$4L(this.b.input.viewType);case 4:return new l.$5L(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$6L(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$7L;case 9:return new l.$8L(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class c{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const a of t.tabs)a.isActive&&(this.d=a.id),this.c.push(new k(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return y.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(a=>a.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(a=>a.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const a=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,a),t.tabDto.isActive&&(this.d=a.tabId),a}else if(t.kind===1){const a=this.c.splice(t.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(t.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,a),a}const i=this.c.find(a=>a.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new T.$Nd,this.c=new T.$Nd,this.e=[],this.a=t.getProxy(M.$gK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(a=>a.apiObject))},get activeTabGroup(){const a=t.d;return(0,g.$Jf)(t.e.find(E=>E.groupId===a)?.apiObject)},close:async(a,$)=>{const E=Array.isArray(a)?a:[a];return E.length?p(E[0])?this.j(E,$):this.i(E,$):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(s=>s.groupId)),a=new Set(t.map(s=>s.groupId)),$=(0,R.$K)(i,a),E=this.e.filter(s=>$.removed.includes(s.groupId)).map(s=>s.apiObject),v=[],n=[];this.e=t.map(s=>{const o=new c(s,()=>this.d);return $.added.includes(o.groupId)?v.push(o.apiObject):n.push(o.apiObject),o});const r=(0,g.$Jf)(t.find(s=>s.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:v,closed:E,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(a=>a.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find($=>$.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const a=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(t){for(const i of this.e)for(const a of i.tabs)if(a.apiObject===t)return a}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const a=[];for(const $ of t){const E=this.g($);if(!E)throw new Error("Tab close: Invalid tab not found!");a.push(E.tabId)}return this.a.$closeTab(a,i)}async j(t,i){const a=[];for(const $ of t){const E=this.h($);if(!E)throw new Error("Group close: Invalid group not found!");a.push(E.groupId)}return this.a.$closeGroup(a,i)}};e.$pdc=b,e.$pdc=b=qe([Ke(0,D.$hM)],b);function p(f){return f.tabs!==void 0}}),define(Ae[234],Re([1,0,3,7]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$gK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(A);if(!g)throw new Error("Embedding vector provider not found");const R=await g.provideEmbeddingVector(l,D);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,l,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiEmbeddingVectorProvider(l,g),new M.$iK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$bec=C}),define(Ae[235],Re([1,0,2,3,6,7,8,282,16,26,22,50]),function(ye,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class c{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let i,a,$=14,E=14;for(const v of f){let n=i?(0,D.$4e)(i,v):0;for(n===0?a=1:a=E;n<v.length;n++)n+1===v.length?($=E,E=9):E+=1,t.push([a,v.toUpperCase().charCodeAt(n),E]),t.push([a,v.toLowerCase().charCodeAt(n),E]),a=E;i=v,E=$}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$ZY(t)}}provideDocumentLinks(f){this.c();const t=[],i=l.$1Y.computeLinks({getLineContent(a){return f.lineAt(a-1).text},getLineCount(){return f.lineCount}},this.b);for(const a of i){const $=A.DocumentLink.to(a);$.target&&t.push($)}return t}}class b{constructor(f,t){this.i=t,this.b=new c,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(M.$gK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,i,a={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const $=this.h++;this.b.add(t),this.d.add(t),this.c.set($,i);let E=2;a.isCaseSensitive&&(E+=1024),a.isReadonly&&(E+=2048),typeof i.copy=="function"&&(E+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,R.$eF)(f,"fsChunks"),E+=4);let v;a.isReadonly&&(0,k.$5j)(a.isReadonly)&&((0,R.$eF)(f,"readonlyMessage"),v={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this.a.$registerFileSystemProvider($,t,E,v).catch(r=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(r)});const n=i.onDidChangeFile(r=>{const s=[];for(const o of r){const{uri:w,type:d}=o;if(w.scheme!==t)continue;let I;switch(d){case T.FileChangeType.Changed:I=0;break;case T.FileChangeType.Created:I=1;break;case T.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:w,type:I})}this.a.$onFileSystemChange($,s)});return(0,C.$Qc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete($),this.a.$unregisterProvider($)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:i,mtime:a,size:$,permissions:E}=f;return{type:t,ctime:i,mtime:a,size:$,permissions:E}}$stat(f,t){return Promise.resolve(this.l(f).stat(y.URI.revive(t))).then(i=>b.k(i))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(y.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(y.URI.revive(t))).then(i=>g.$be.wrap(i))}$writeFile(f,t,i,a){return Promise.resolve(this.l(f).writeFile(y.URI.revive(t),i.buffer,a))}$delete(f,t,i){return Promise.resolve(this.l(f).delete(y.URI.revive(t),i))}$rename(f,t,i,a){return Promise.resolve(this.l(f).rename(y.URI.revive(t),y.URI.revive(i),a))}$copy(f,t,i,a){const $=this.l(f);if(!$.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve($.copy(y.URI.revive(t),y.URI.revive(i),a))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(y.URI.revive(t)))}$watch(f,t,i,a){const $=this.l(f).watch(y.URI.revive(i),a);this.f.set(t,$)}$unwatch(f,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(f,t,i){const a=this.l(f);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(y.URI.revive(t),i))}$close(f,t){const i=this.l(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(f,t,i,a){const $=this.l(f);if(!$.read)throw new Error('FileSystemProvider does not implement "read"');const E=g.$be.alloc(a);return Promise.resolve($.read(t,i,E.buffer,0,a)).then(v=>E.slice(0,v))}$write(f,t,i,a){const $=this.l(f);if(!$.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve($.write(t,i,a.buffer,0,a.byteLength))}l(f){const t=this.c.get(f);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Xcc=b}),define(Ae[62],Re([1,0,3,39,7,26,4,17,40,6,12,24,13]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=e.$Dcc=void 0;let p=b=class{constructor(t,i){this.b=new Map,this.c=new R.$3g,this.a=t.getProxy(y.$gK.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat($){try{let E;const v=a.b.get($.scheme);return v?(await a.a.$ensureActivation($.scheme),E=await v.impl.stat($)):E=await a.a.$stat($),{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===M.FilePermission.Readonly?1:void 0}}catch(E){b.e(E)}},async readDirectory($){try{const E=a.b.get($.scheme);return E?(await a.a.$ensureActivation($.scheme),(await E.impl.readDirectory($)).slice()):await a.a.$readdir($)}catch(E){return b.e(E)}},async createDirectory($){try{const E=a.b.get($.scheme);return E&&!E.isReadonly?(await a.a.$ensureActivation($.scheme),await a.d(E.impl,E.extUri,$)):await a.a.$mkdir($)}catch(E){return b.e(E)}},async readFile($){try{const E=a.b.get($.scheme);return E?(await a.a.$ensureActivation($.scheme),(await E.impl.readFile($)).slice()):(await a.a.$readFile($)).buffer}catch(E){return b.e(E)}},async writeFile($,E){try{const v=a.b.get($.scheme);return v&&!v.isReadonly?(await a.a.$ensureActivation($.scheme),await a.d(v.impl,v.extUri,v.extUri.dirname($)),await a.c.queueFor($).queue(()=>Promise.resolve(v.impl.writeFile($,E,{create:!0,overwrite:!0})))):await a.a.$writeFile($,T.$be.wrap(E))}catch(v){return b.e(v)}},async delete($,E){try{const v=a.b.get($.scheme);return v&&!v.isReadonly?(await a.a.$ensureActivation($.scheme),await v.impl.delete($,{recursive:!1,...E})):await a.a.$delete($,{recursive:!1,useTrash:!1,atomic:!1,...E})}catch(v){return b.e(v)}},async rename($,E,v){try{return await a.a.$rename($,E,{overwrite:!1,...v})}catch(n){return b.e(n)}},async copy($,E,v){try{return await a.a.$copy($,E,{overwrite:!1,...v})}catch(n){return b.e(n)}},isWritableFileSystem($){const E=i.getCapabilities($);if(typeof E=="number")return!(E&2048)}})}async d(t,i,a){const $=[];for(;!i.isEqual(a,i.dirname(a));)try{if(!((await t.stat(a)).type&M.FileType.Directory))throw C.$vL.FileExists(`Unable to create folder '${a.scheme===c.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(E){if(M.$ok(E)!==M.FileSystemProviderErrorCode.FileNotFound)throw E;$.push(i.basename(a)),a=i.dirname(a)}for(let E=$.length-1;E>=0;E--){a=i.joinPath(a,$[E]);try{await t.createDirectory(a)}catch(v){if(M.$ok(v)!==M.FileSystemProviderErrorCode.FileExists)throw v}}}static e(t){if(t instanceof C.$vL)throw t;if(t instanceof M.$kk)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$vL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$vL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$vL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$vL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$vL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$vL.Unavailable(t.message);default:throw new C.$vL(t.message,t.name)}if(!(t instanceof Error))throw new C.$vL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$vL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$vL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$vL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$vL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$vL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$vL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$vL.Unavailable(t.message);default:throw new C.$vL(t.message,t.name)}}addFileSystemProvider(t,i,a){return this.b.set(t,{impl:i,extUri:a?.isCaseSensitive?k.$lg:k.$ng,isReadonly:!!a?.isReadonly}),(0,g.$Qc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$lg}};e.$Dcc=p,e.$Dcc=p=b=qe([Ke(0,l.$hM),Ke(1,D.$_bc)],p),e.$Ecc=(0,A.$Ph)("IExtHostConsumerFileSystem")}),define(Ae[236],Re([1,0,5,38,2,3,8,7,42]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,p,f,t,i,a){this.a=Math.random(),this.b=new y.$Nd,this.c=new y.$Nd,this.d=new y.$Nd,this.h=0,a?.ignoreCreateEvents&&(this.h+=1),a?.ignoreChangeEvents&&(this.h+=2),a?.ignoreDeleteEvents&&(this.h+=4);const $=(0,M.$wj)(i),E=typeof i=="string",v=t(n=>{if(!(typeof n.session=="number"&&n.session!==this.a)){if(!a?.ignoreCreateEvents)for(const r of n.created){const s=C.URI.revive(r);$(s.fsPath)&&(!E||p.getWorkspaceFolder(s))&&this.b.fire(s)}if(!a?.ignoreChangeEvents)for(const r of n.changed){const s=C.URI.revive(r);$(s.fsPath)&&(!E||p.getWorkspaceFolder(s))&&this.c.fire(s)}if(!a?.ignoreDeleteEvents)for(const r of n.deleted){const s=C.URI.revive(r);$(s.fsPath)&&(!E||p.getWorkspaceFolder(s))&&this.d.fire(s)}}});this.g=l.$iK.from(this.i(b,f,i,a),this.b,this.c,this.d,v)}i(b,p,f,t){const i=l.$iK.from();if(typeof f=="string")return i;const a=b.getProxy(T.$gK.MainThreadFileSystemEventService);let $=!1;return(f.pattern.includes(M.$sj)||f.pattern.includes(M.$tj))&&($=!0),a.$watch(p.identifier.value,this.a,f.baseUri,{recursive:$,excludes:t?.excludes??[]}),l.$iK.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(b){this.a=b,this.session=this.a.session,this.b=new D.$V(()=>this.a.created.map(C.URI.revive)),this.c=new D.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new D.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(b,p,f){this.j=b,this.k=p,this.l=f,this.a=new y.$Nd,this.b=new y.$Nd,this.c=new y.$Nd,this.d=new y.$Nd,this.g=new y.$Pd,this.h=new y.$Pd,this.i=new y.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,p,f,t){return new g(this.j,b,p,this.a.event,A.GlobPattern.from(f),t)}$onFileEvent(b){this.a.fire(new R(b))}$onDidRunFileOperation(b,p){switch(b){case 2:this.b.fire(Object.freeze({files:p.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(f=>C.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(f=>C.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,p){return(f,t,i)=>{const a=function(E){f.call(t,E)};return a.extension=b,p.event(a,void 0,i)}}async $onWillRunFileOperation(b,p,f,t){switch(b){case 2:return await this.n(this.g,{files:p.map(i=>({oldUri:C.URI.revive(i.source),newUri:C.URI.revive(i.target)}))},f,t);case 1:return await this.n(this.i,{files:p.map(i=>C.URI.revive(i.target))},f,t);case 0:case 3:return await this.n(this.h,{files:p.map(i=>C.URI.revive(i.target))},f,t)}}async n(b,p,f,t){const i=new Set,a=[];if(await b.fireAsync(p,t,async(E,v)=>{const n=Date.now(),r=await Promise.resolve(E);r instanceof l.$sK&&(a.push([v.extension,r]),i.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-n>f&&this.k.warn("SLOW file-participant",v.extension.identifier)}),t.isCancellationRequested||a.length===0)return;const $={edits:[]};for(const[,E]of a){const{edits:v}=A.WorkspaceEdit.from(E,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});$.edits=$.edits.concat(v)}return{edit:$,extensionNames:Array.from(i)}}}e.$Ycc=k}),define(Ae[237],Re([1,0,6,2,3,8,7,31,12]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;class g{static{this.a=0}constructor(b,p){this.extension=b,this.provider=p,this.handle=g.a++}}class R{constructor(b){this.session=b,this.responses=[]}}class k{static{this.a=0}constructor(b,p,f,t){this.f=f,this.g=t,this.b=new Map,this.d=new Map,this.e=b.getProxy(C.$gK.MainThreadInlineChat),p.registerApiCommand(new l.$HM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$FM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?T.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?T.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?T.Position.from(i.position):void 0}})],l.$GM.Void))}registerProvider(b,p,f){const t=new g(b,p);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,f.label,b.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,y.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(b,p,f,t){const i=this.b.get(b);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const a=this.f.getDocument(M.URI.revive(p)),$=T.Selection.to(f),E=await i.provider.prepareInteractiveEditorSession({document:a,selection:$},t);if(!E)return;if(E.wholeRange&&!E.wholeRange.contains($))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const v=k.a++;return this.d.set(v,new R(E)),{id:v,placeholder:E.placeholder,slashCommands:E.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:T.Range.from(E.wholeRange),message:E.message}}async $provideResponse(b,p,f,t){const i=this.b.get(b);if(!i)return;const a=this.d.get(p.id);if(!a)return;const $={prompt:f.prompt,selection:T.Selection.to(f.selection),wholeRange:T.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let E=!1;const v={report:async d=>{if(!f.live)throw new Error("Progress reporting is only supported for live sessions");E||t.isCancellationRequested||await this.e.$handleProgressChunk(f.requestId,{message:d.message,edits:d.edits?.map(T.TextEdit.from),slashCommand:d.slashCommand?.command})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(a.session,$,v,t));let r;try{r=await(0,D.$Ig)(n,t)}finally{E=!0}if(!r)return;const s=a.responses.push(r)-1,o={wholeRange:T.Range.from(r.wholeRange),placeholder:r.placeholder};if(k.h(r))return{...o,id:s,type:"message",message:T.MarkdownString.from(r.contents)};const{edits:w}=r;return w instanceof A.$sK?{...o,id:s,type:"bulkEdit",edits:T.WorkspaceEdit.from(w)}:{...o,id:s,type:"editorEdit",edits:w.map(T.TextEdit.from)}}$handleFeedback(b,p,f,t){const i=this.b.get(b),a=this.d.get(p),$=a?.responses[f];if(i&&$){const E=T.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(a.session,$,E)}}$releaseSession(b,p){}static h(b){return typeof b=="object"&&typeof b.contents=="object"}}e.$6dc=k}),define(Ae[238],Re([1,0,2,31]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class C{constructor(A,l,D,g,R){this.a=l,this.b=D,this.c=g;const k=new M.$HM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$FM("showOptions","Show Options",c=>!0,c=>c),new M.$FM("resource","Interactive resource Uri",c=>!0,c=>c),new M.$FM("controllerId","Notebook controller Id",c=>!0,c=>c),new M.$FM("title","Interactive editor title",c=>!0,c=>c)],new M.$GM("Notebook and input URI",c=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const b=this.a.getEditorById(c.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:y.URI.revive(c.notebookUri),inputUri:y.URI.revive(c.inputUri),notebookEditor:b.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:y.URI.revive(c.notebookUri),inputUri:y.URI.revive(c.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(A,l,D,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$2dc=C}),define(Ae[239],Re([1,0,3,7]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(y.$gK.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(A);if(!D)throw new Error("Issue request handler not found");const g=await D.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(A,l){const D=A.identifier.value;return this.a.set(D,l),this.b.$registerIssueUriRequestHandler(D),new M.$iK(()=>{this.b.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}}e.$8dc=C}),define(Ae[240],Re([1,0,6,3]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(M.$gK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,y.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$idc=C}),define(Ae[241],Re([1,0,2,25,8,7,78,3,16,41,18,15,283,19,21,6,91,88,74,59,9,12,22,149]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E,v,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class s{constructor(F,V){this.d=F,this.e=V}async provideDocumentSymbols(F,V){const G=this.d.getDocument(F),J=await this.e.provideDocumentSymbols(G,V);if(!(0,R.$Kb)(J))return J[0]instanceof T.$AK?J.map(C.DocumentSymbol.from):s.f(J)}static f(F){F=F.slice(0).sort((J,q)=>{let x=J.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(J.location.range.end)),x});const V=[],G=[];for(const J of F){const q={name:J.name||"!!MISSING: name!!",kind:C.SymbolKind.from(J.kind),tags:J.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:C.Range.from(J.location.range),selectionRange:C.Range.from(J.location.range),children:[]};for(;;){if(G.length===0){G.push(q),V.push(q);break}const x=G[G.length-1];if(g.$us.containsRange(x.range,q.range)&&!g.$us.equalsRange(x.range,q.range)){x.children?.push(q),G.push(q);break}G.pop()}}return V}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(F,V,G){this.g=F,this.h=V,this.j=G,this.e=new a.$9bc("CodeLens"),this.f=new Map}async provideCodeLenses(F,V){const G=this.g.getDocument(F),J=await this.j.provideCodeLenses(G,V);if(!J||V.isCancellationRequested)return;const q=this.e.add(J),x=new f.$Rc;this.f.set(q,x);const ce={cacheId:q,lenses:[]};for(let Ne=0;Ne<J.length;Ne++)ce.lenses.push({cacheId:[q,Ne],range:C.Range.from(J[Ne].range),command:this.h.toInternal(J[Ne].command,x)});return ce}async resolveCodeLens(F,V){const G=F.cacheId&&this.e.get(...F.cacheId);if(!G)return;let J;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?J=G:J=await this.j.resolveCodeLens(G,V),J||(J=G),V.isCancellationRequested)return;const q=F.cacheId&&this.f.get(F.cacheId[0]);if(q)return F.command=this.h.toInternal(J.command??o.d,q),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}function w(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class d{constructor(F,V){this.d=F,this.e=V}async provideDefinition(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideDefinition(J,q,G);return w(x)}}class I{constructor(F,V){this.d=F,this.e=V}async provideDeclaration(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideDeclaration(J,q,G);return w(x)}}class S{constructor(F,V){this.d=F,this.e=V}async provideImplementation(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideImplementation(J,q,G);return w(x)}}class u{constructor(F,V){this.d=F,this.e=V}async provideTypeDefinition(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideTypeDefinition(J,q,G);return w(x)}}class m{constructor(F,V){this.d=F,this.e=V}async provideHover(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideHover(J,q,G);if(!(!x||(0,R.$Kb)(x.contents)))return x.range||(x.range=J.getWordRangeAtPosition(q)),x.range||(x.range=new T.$kK(q,q)),C.Hover.from(x)}}class h{constructor(F,V){this.d=F,this.e=V}async provideEvaluatableExpression(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideEvaluatableExpression(J,q,G);if(x)return C.EvaluatableExpression.from(x)}}class P{constructor(F,V){this.d=F,this.e=V}async provideInlineValues(F,V,G,J){const q=this.d.getDocument(F),x=await this.e.provideInlineValues(q,C.Range.to(V),C.InlineValueContext.to(G),J);if(Array.isArray(x))return x.map(ce=>C.InlineValue.from(ce))}}class W{constructor(F,V){this.d=F,this.e=V}async provideDocumentHighlights(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideDocumentHighlights(J,q,G);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class K{constructor(F,V){this.d=F,this.e=V}async provideLinkedEditingRanges(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideLinkedEditingRanges(J,q,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,R.$Hb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class z{constructor(F,V){this.d=F,this.e=V}async provideReferences(F,V,G,J){const q=this.d.getDocument(F),x=C.Position.to(V),ce=await this.e.provideReferences(q,x,G,J);if(Array.isArray(ce))return ce.map(C.location.from)}}class j{static{this.d=1e3}constructor(F,V,G,J,q,x,ce){this.g=F,this.h=V,this.j=G,this.k=J,this.l=q,this.m=x,this.n=ce,this.e=new a.$9bc("CodeAction"),this.f=new Map}async provideCodeActions(F,V,G,J){const q=this.g.getDocument(F),x=c.$ws.isISelection(V)?C.Selection.to(V):C.Range.to(V),ce=[];for(const Ye of this.j.getDiagnostics(F))if(x.intersection(Ye.range)&&ce.push(Ye)>j.d)break;const Ne={diagnostics:ce,only:G.only?new T.$CK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},Ue=await this.k.provideCodeActions(q,x,Ne,J);if(!(0,R.$Lb)(Ue)||J.isCancellationRequested)return;const Qe=this.e.add(Ue),Ge=new f.$Rc;this.f.set(Qe,Ge);const xe=[];for(let Ye=0;Ye<Ue.length;Ye++){const _e=Ue[Ye];_e&&(j.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,Ge)})):(Ne.only&&(_e.kind?Ne.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[Qe,Ye],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,Ge),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,isAI:(0,n.$dF)(this.m,"codeActionAI")?_e.isAI:!1,disabled:_e.disabled?.reason})))}return{cacheId:Qe,actions:xe}}async resolveCodeAction(F,V){const[G,J]=F,q=this.e.get(G,J);if(!q||j.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,V)??q;let ce;x.edit&&(ce=C.WorkspaceEdit.from(x.edit,void 0));let Ne;if(x.command){const Ue=this.f.get(G);Ue&&(Ne=this.h.toInternal(x.command,Ue))}return{edit:ce,command:Ne}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class O{static toInternalProviderId(F,V){return F+"."+V}constructor(F,V,G,J,q){this.d=F,this.e=V,this.f=G,this.g=J,this.h=q}async prepareDocumentPaste(F,V,G,J){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(F),x=V.map(Ue=>C.Range.to(Ue)),ce=C.DataTransfer.toDataTransfer(G,()=>{throw new E.$$});if(await this.f.prepareDocumentPaste(q,x,ce,J),J.isCancellationRequested)return;const Ne=Array.from(ce).filter(([,Ue])=>!(Ue instanceof T.$9K));return C.DataTransfer.from(Ne)}async providePasteEdits(F,V,G,J,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(V),ce=G.map(Qe=>C.Range.to(Qe)),Ne=C.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolvePasteFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ce,Ne,q);if(Ue)return{label:Ue.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class N{constructor(F,V){this.d=F,this.e=V}async provideDocumentFormattingEdits(F,V,G){const J=this.d.getDocument(F),q=await this.e.provideDocumentFormattingEdits(J,V,G);if(Array.isArray(q))return q.map(C.TextEdit.from)}}class ie{constructor(F,V){this.d=F,this.e=V}async provideDocumentRangeFormattingEdits(F,V,G,J){const q=this.d.getDocument(F),x=C.Range.to(V),ce=await this.e.provideDocumentRangeFormattingEdits(q,x,G,J);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,V,G,J){(0,k.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(F),x=V.map(C.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(q,x,G,J);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class X{constructor(F,V){this.d=F,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,V,G,J,q){const x=this.d.getDocument(F),ce=C.Position.to(V),Ne=await this.e.provideOnTypeFormattingEdits(x,ce,G,J,q);if(Array.isArray(Ne))return Ne.map(C.TextEdit.from)}}class Ee{constructor(F,V){this.e=F,this.f=V,this.d=new a.$9bc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,V){const G=await this.e.provideWorkspaceSymbols(F,V);if(!(0,R.$Lb)(G))return{symbols:[]};const J=this.d.add(G),q={cacheId:J,symbols:[]};for(let x=0;x<G.length;x++){const ce=G[x];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}q.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[J,x]})}return q}async resolveWorkspaceSymbol(F,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const G=this.d.get(...F.cacheId);if(G){const J=await this.e.resolveWorkspaceSymbol(G,V);return J&&(0,M.$0m)(F,C.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class Se{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,V,G){this.d=F,this.e=V,this.f=G}async provideRenameEdits(F,V,G,J){const q=this.d.getDocument(F),x=C.Position.to(V);try{const ce=await this.e.provideRenameEdits(q,x,G,J);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const Ne=Se.g(ce);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(F,V,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(F),q=C.Position.to(V);try{const x=await this.e.prepareRename(J,q,G);let ce,Ne;if(T.$kK.isRange(x)?(ce=x,Ne=J.getText(x)):(0,k.$Af)(x)&&(ce=x.range,Ne=x.placeholder),!ce||!Ne)return;if(ce.start.line>q.line||ce.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:Ne}}catch(x){const ce=Se.g(x);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(x)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class Pe{constructor(F,V){this.resultId=F,this.tokens=V}}class $e{constructor(F,V){this.f=F,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,V,G){const J=this.f.getDocument(F),q=V!==0?this.d.get(V):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,q.resultId,G):await this.g.provideDocumentSemanticTokens(J,G);return q&&this.d.delete(V),x?(x=$e.h(x),this.o($e.n(q,x),x)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return $e.j(F)?$e.k(F)?F:new T.$zL(new Uint32Array(F.data),F.resultId):$e.l(F)?$e.m(F)?F:new T.$BL(F.edits.map(V=>new T.$AL(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const V of F.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(F,V){if(!$e.j(V)||!F||!F.tokens)return V;const G=F.tokens,J=G.length,q=V.data,x=q.length;let ce=0;const Ne=Math.min(J,x);for(;ce<Ne&&G[ce]===q[ce];)ce++;if(ce===J&&ce===x)return new T.$BL([],V.resultId);let Ue=0;const Qe=Ne-ce;for(;Ue<Qe&&G[J-Ue-1]===q[x-Ue-1];)Ue++;return new T.$BL([{start:ce,deleteCount:J-ce-Ue,data:q.subarray(ce,x-Ue)}],V.resultId)}o(F,V){if($e.j(F)){const G=this.e++;return this.d.set(G,new Pe(F.resultId,F.data)),(0,t.$W0)({id:G,type:"full",data:F.data})}if($e.l(F)){const G=this.e++;return $e.j(V)?this.d.set(G,new Pe(V.resultId,V.data)):this.d.set(G,new Pe(F.resultId)),(0,t.$W0)({id:G,type:"delta",deltas:(F.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class pe{constructor(F,V){this.d=F,this.e=V}async provideDocumentRangeSemanticTokens(F,V,G){const J=this.d.getDocument(F),q=await this.e.provideDocumentRangeSemanticTokens(J,C.Range.to(V),G);return q?this.f(q):null}f(F){return(0,t.$W0)({id:0,type:"full",data:F.data})}}class ue{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,V,G,J,q){this.f=F,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new a.$9bc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,V,G,J){const q=this.f.getDocument(F),x=C.Position.to(V),ce=q.getWordRangeAtPosition(x)||new T.$kK(x,x),Ne=ce.with({end:x}),Ue=new $.$Jd,Qe=await this.h.provideCompletionItems(q,x,J,C.CompletionContext.to(G));if(!Qe||J.isCancellationRequested)return;const Ge=Array.isArray(Qe)?new T.$PK(Qe):Qe,xe=ue.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Ye=new f.$Rc;this.e.set(xe,Ye);const _e=[],it={x:xe,b:_e,a:{replace:C.Range.from(ce),insert:C.Range.from(Ne)},c:Ge.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],st=this.l(ze,[xe,tt],Ne,ce);_e.push(st)}return it}async resolveCompletionItem(F,V){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...F);if(!G)return;const J=this.l(G,F),q=await this.h.resolveCompletionItem(G,V);if(!q)return;const x=this.l(q,F);return(J.h!==x.h||J.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==x.n||J.o!==x.o||!(0,M.$$m)(J.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,V,G,J){const q=this.e.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(F.command,q),ce={x:V,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=F.textEdit.newText):typeof F.insertText=="string"?ce.h=F.insertText:F.insertText instanceof T.$tK&&(ce.h=F.insertText.value,ce.i|=4);let Ne;return F.textEdit?Ne=F.textEdit.range:F.range&&(Ne=F.range),T.$kK.isRange(Ne)?ce.j=C.Range.from(Ne):Ne&&(!G?.isEqual(Ne.inserting)||!J?.isEqual(Ne.replacing))&&(ce.j={insert:C.Range.from(Ne.inserting),replace:C.Range.from(Ne.replacing)}),ce}}class oe{async provideInlineCompletions(F,V,G,J){}disposeCompletions(F){}handleDidShowCompletionItem(F,V,G){}handlePartialAccept(F,V,G){}}class be extends oe{constructor(F,V,G,J){super(),this.f=F,this.g=V,this.h=G,this.j=J,this.d=new _,this.e=(0,n.$dF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:T.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:T.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$dF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,V,G,J){const q=this.g.getDocument(F),x=C.Position.to(V),ce=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},J);if(!ce||J.isCancellationRequested)return;const Ne=Array.isArray(ce)?ce:ce.items,Ue=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Qe=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Ne}),items:Ne.map((Ye,_e)=>{let it;Ye.command&&(Ge||(Ge=new f.$Rc),it=this.j.toInternal(Ye.command,Ge));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?C.Range.from(Ye.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:Ue.map(Ye=>(Ge||(Ge=new f.$Rc),this.j.toInternal(Ye,Ge))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,V,G){const J=this.d.get(F)?.items[V];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,G)}handlePartialAccept(F,V,G){const J=this.d.get(F)?.items[V];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,G)}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const V=this.e++;return this.d.set(V,F),V}disposeReferenceId(F){const V=this.d.get(F);return this.d.delete(F),V}get(F){return this.d.get(F)}}class B{constructor(F,V){this.e=F,this.f=V,this.d=new a.$9bc("SignatureHelp")}async provideSignatureHelp(F,V,G,J){const q=this.e.getDocument(F),x=C.Position.to(V),ce=this.g(G),Ne=await this.f.provideSignatureHelp(q,x,J,ce);if(Ne){const Ue=this.d.add([Ne]);return{...C.SignatureHelp.from(Ne),id:Ue}}}g(F){let V;if(F.activeSignatureHelp){const G=C.SignatureHelp.to(F.activeSignatureHelp),J=this.d.get(F.activeSignatureHelp.id,0);J?(V=J,V.activeSignature=G.activeSignature,V.activeParameter=G.activeParameter):V=G}return{...F,activeSignatureHelp:V}}releaseSignatureHelp(F){this.d.delete(F)}}class Z{constructor(F,V,G,J,q){this.f=F,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new a.$9bc("InlayHints"),this.e=new Map}async provideInlayHints(F,V,G){const J=this.f.getDocument(F),q=C.Range.to(V),x=await this.h.provideInlayHints(J,q,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${V}`);return}if(G.isCancellationRequested)return;const ce=this.d.add(x);this.e.set(ce,new f.$Rc);const Ne={hints:[],cacheId:ce};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],q)&&Ne.hints.push(this.m(x[Ue],[ce,Ue]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${V}`),Ne}async resolveInlayHint(F,V){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...F);if(!G)return;const J=await this.h.resolveInlayHint(G,V);if(J&&this.l(J))return this.m(J,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,V){return F.label.length===0||Array.isArray(F.label)&&F.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(V&&!V.contains(F.position))}m(F,V){const G=this.e.get(V[0]);if(!G)throw Error("DisposableStore is missing...");const J={label:"",cacheId:V,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?J.label=F.label:J.label=F.label.map(q=>{const x={label:q.value};return x.tooltip=C.MarkdownString.fromStrict(q.tooltip),T.$uK.isLocation(q.location)&&(x.location=C.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,G)),x}),J}}class ee{constructor(F,V){this.e=F,this.f=V,this.d=new a.$9bc("DocumentLink")}async provideLinks(F,V){const G=this.e.getDocument(F),J=await this.f.provideDocumentLinks(G,V);if(!(!Array.isArray(J)||J.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ee.g).map(C.DocumentLink.from)};{const q=this.d.add(J),x={links:[],cacheId:q};for(let ce=0;ce<J.length;ce++){if(!ee.g(J[ce]))continue;const Ne=C.DocumentLink.from(J[ce]);Ne.cacheId=[q,ce],x.links.push(Ne)}return x}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,V){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...F);if(!G)return;const J=await this.f.resolveDocumentLink(G,V);if(!(!J||!ee.g(J)))return C.DocumentLink.from(J)}releaseLinks(F){this.d.delete(F)}}class ve{constructor(F,V){this.d=F,this.e=V}async provideColors(F,V){const G=this.d.getDocument(F),J=await this.e.provideDocumentColors(G,V);return Array.isArray(J)?J.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(F,V,G){const J=this.d.getDocument(F),q=C.Range.to(V.range),x=C.Color.to(V.color),ce=await this.e.provideColorPresentations(x,{document:J,range:q},G);if(Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class ge{constructor(F,V){this.d=F,this.e=V}async provideFoldingRanges(F,V,G){const J=this.d.getDocument(F),q=await this.e.provideFoldingRanges(J,V,G);if(Array.isArray(q))return q.map(C.FoldingRange.from)}}class he{constructor(F,V,G){this.d=F,this.e=V,this.f=G}async provideSelectionRanges(F,V,G){const J=this.d.getDocument(F),q=V.map(C.Position.to),x=await this.e.provideSelectionRanges(J,q,G);if(!(0,R.$Lb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ne=0;Ne<q.length;Ne++){const Ue=[];ce.push(Ue);let Qe=q[Ne],Ge=x[Ne];for(;;){if(!Ge.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(Ge)),!Ge.parent)break;Qe=Ge.range,Ge=Ge.parent}}return ce}}class De{constructor(F,V){this.f=F,this.g=V,this.d=new i.$mM(""),this.e=new Map}async prepareSession(F,V,G){const J=this.f.getDocument(F),q=C.Position.to(V),x=await this.g.prepareCallHierarchy(J,q,G);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Ne=>this.h(ce,Ne)):[this.h(ce,x)]}async provideCallsTo(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(J,G);if(q)return q.map(x=>({from:this.h(F,x.from),fromRanges:x.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(J,G);if(q)return q.map(x=>({to:this.h(F,x.to),fromRanges:x.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(F){this.e.delete(F)}h(F,V){const G=this.e.get(F),J=C.CallHierarchyItem.from(V,F,G.size.toString(36));return G.set(J._itemId,V),J}j(F,V){return this.e.get(F)?.get(V)}}class re{constructor(F,V){this.f=F,this.g=V,this.d=new i.$mM(""),this.e=new Map}async prepareSession(F,V,G){const J=this.f.getDocument(F),q=C.Position.to(V),x=await this.g.prepareTypeHierarchy(J,q,G);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Ne=>this.h(ce,Ne)):[this.h(ce,x)]}async provideSupertypes(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(J,G);if(q)return q.map(x=>this.h(F,x))}async provideSubtypes(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(J,G);if(q)return q.map(x=>this.h(F,x))}releaseSession(F){this.e.delete(F)}h(F,V){const G=this.e.get(F),J=C.TypeHierarchyItem.from(V,F,G.size.toString(36));return G.set(J._itemId,V),J}j(F,V){return this.e.get(F)?.get(V)}}class le{static toInternalProviderId(F,V){return F+"."+V}constructor(F,V,G,J,q){this.d=F,this.e=V,this.f=G,this.g=J,this.h=q}async provideDocumentOnDropEdits(F,V,G,J,q){const x=this.e.getDocument(V),ce=C.Position.to(G),Ne=C.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ce,Ne,q);if(Ue)return{label:Ue.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:le.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class ne{constructor(F,V){this.d=F,this.e=V}async provideMappedEdits(F,V,G,J){const q=y.URI.revive(F),x=this.d.getDocument(q),ce=G.documents.map(Qe=>Qe.map(Ge=>({uri:y.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(xe=>C.Range.to(xe))}))),Ne={documents:ce,selections:ce[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(x,V,Ne,J);return Ue?C.WorkspaceEdit.from(Ue):null}}class ae{constructor(F,V){this.adapter=F,this.extension=V}}class fe{static{this.d=0}constructor(F,V,G,J,q,x,ce,Ne){this.g=V,this.h=G,this.j=J,this.k=q,this.l=x,this.m=ce,this.n=Ne,this.f=new Map,this.e=F.getProxy(l.$gK.MainThreadLanguageFeatures)}o(F,V){return C.DocumentSelector.from(F,this.g,V)}p(F){return new T.$iK(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return fe.d++}async s(F,V,G,J,q,x=!1){const ce=this.f.get(F);if(!ce||!(ce.adapter instanceof V))return J;const Ne=Date.now();x||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ce.adapter,ce.extension);return Promise.resolve(Ue).catch(Qe=>{(0,E.$4)(Qe)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ce.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),b.CancellationToken.isCancellationToken(q)?(0,v.$Jg)(Ue,q):Ue}t(F,V){const G=this.q();return this.f.set(G,new ae(F,V)),G}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,V,G,J){const q=this.t(new s(this.h,G),F),x=J&&J.label||fe.u(F);return this.e.$registerDocumentSymbolProvider(q,this.o(V,F),x),this.p(q)}$provideDocumentSymbols(F,V,G){return this.s(F,s,J=>J.provideDocumentSymbols(y.URI.revive(V),G),void 0,G)}registerCodeLensProvider(F,V,G){const J=this.q(),q=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new ae(new o(this.h,this.j.converter,G),F)),this.e.$registerCodeLensSupport(J,this.o(V,F),q);let x=this.p(J);if(q!==void 0){const ce=G.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(q));x=T.$iK.from(x,ce)}return x}$provideCodeLenses(F,V,G){return this.s(F,o,J=>J.provideCodeLenses(y.URI.revive(V),G),void 0,G)}$resolveCodeLens(F,V,G){return this.s(F,o,J=>J.resolveCodeLens(V,G),void 0,void 0)}$releaseCodeLenses(F,V){this.s(F,o,G=>Promise.resolve(G.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(F,V,G){const J=this.t(new d(this.h,G),F);return this.e.$registerDefinitionSupport(J,this.o(V,F)),this.p(J)}$provideDefinition(F,V,G,J){return this.s(F,d,q=>q.provideDefinition(y.URI.revive(V),G,J),[],J)}registerDeclarationProvider(F,V,G){const J=this.t(new I(this.h,G),F);return this.e.$registerDeclarationSupport(J,this.o(V,F)),this.p(J)}$provideDeclaration(F,V,G,J){return this.s(F,I,q=>q.provideDeclaration(y.URI.revive(V),G,J),[],J)}registerImplementationProvider(F,V,G){const J=this.t(new S(this.h,G),F);return this.e.$registerImplementationSupport(J,this.o(V,F)),this.p(J)}$provideImplementation(F,V,G,J){return this.s(F,S,q=>q.provideImplementation(y.URI.revive(V),G,J),[],J)}registerTypeDefinitionProvider(F,V,G){const J=this.t(new u(this.h,G),F);return this.e.$registerTypeDefinitionSupport(J,this.o(V,F)),this.p(J)}$provideTypeDefinition(F,V,G,J){return this.s(F,u,q=>q.provideTypeDefinition(y.URI.revive(V),G,J),[],J)}registerHoverProvider(F,V,G,J){const q=this.t(new m(this.h,G),F);return this.e.$registerHoverProvider(q,this.o(V,F)),this.p(q)}$provideHover(F,V,G,J){return this.s(F,m,q=>q.provideHover(y.URI.revive(V),G,J),void 0,J)}registerEvaluatableExpressionProvider(F,V,G,J){const q=this.t(new h(this.h,G),F);return this.e.$registerEvaluatableExpressionProvider(q,this.o(V,F)),this.p(q)}$provideEvaluatableExpression(F,V,G,J){return this.s(F,h,q=>q.provideEvaluatableExpression(y.URI.revive(V),G,J),void 0,J)}registerInlineValuesProvider(F,V,G,J){const q=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new P(this.h,G),F);this.e.$registerInlineValuesProvider(x,this.o(V,F),q);let ce=this.p(x);if(q!==void 0){const Ne=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(q));ce=T.$iK.from(ce,Ne)}return ce}$provideInlineValues(F,V,G,J,q){return this.s(F,P,x=>x.provideInlineValues(y.URI.revive(V),G,J,q),void 0,q)}registerDocumentHighlightProvider(F,V,G){const J=this.t(new W(this.h,G),F);return this.e.$registerDocumentHighlightProvider(J,this.o(V,F)),this.p(J)}$provideDocumentHighlights(F,V,G,J){return this.s(F,W,q=>q.provideDocumentHighlights(y.URI.revive(V),G,J),void 0,J)}registerLinkedEditingRangeProvider(F,V,G){const J=this.t(new K(this.h,G),F);return this.e.$registerLinkedEditingRangeProvider(J,this.o(V,F)),this.p(J)}$provideLinkedEditingRanges(F,V,G,J){return this.s(F,K,async q=>{const x=await q.provideLinkedEditingRanges(y.URI.revive(V),G,J);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?fe.w(x.wordPattern):void 0}},void 0,J)}registerReferenceProvider(F,V,G){const J=this.t(new z(this.h,G),F);return this.e.$registerReferenceSupport(J,this.o(V,F)),this.p(J)}$provideReferences(F,V,G,J,q){return this.s(F,z,x=>x.provideReferences(y.URI.revive(V),G,J,q),void 0,q)}registerCodeActionProvider(F,V,G,J){const q=new f.$Rc,x=this.t(new j(this.h,this.j.converter,this.k,G,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(x,this.o(V,F),{providedKinds:J?.providedCodeActionKinds?.map(ce=>ce.value),documentation:J?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,q)}))},fe.u(F),!!G.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(F,V,G,J,q){return this.s(F,j,x=>x.provideCodeActions(y.URI.revive(V),G,J,q),void 0,q)}$resolveCodeAction(F,V,G){return this.s(F,j,J=>J.resolveCodeAction(V,G),{},void 0)}$releaseCodeActions(F,V){this.s(F,j,G=>Promise.resolve(G.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(F,V,G){const J=this.t(new N(this.h,G),F);return this.e.$registerDocumentFormattingSupport(J,this.o(V,F),F.identifier,F.displayName||F.name),this.p(J)}$provideDocumentFormattingEdits(F,V,G,J){return this.s(F,N,q=>q.provideDocumentFormattingEdits(y.URI.revive(V),G,J),void 0,J)}registerDocumentRangeFormattingEditProvider(F,V,G){const J=typeof G.provideDocumentRangesFormattingEdits=="function",q=this.t(new ie(this.h,G),F);return this.e.$registerRangeFormattingSupport(q,this.o(V,F),F.identifier,F.displayName||F.name,J),this.p(q)}$provideDocumentRangeFormattingEdits(F,V,G,J,q){return this.s(F,ie,x=>x.provideDocumentRangeFormattingEdits(y.URI.revive(V),G,J,q),void 0,q)}$provideDocumentRangesFormattingEdits(F,V,G,J,q){return this.s(F,ie,x=>x.provideDocumentRangesFormattingEdits(y.URI.revive(V),G,J,q),void 0,q)}registerOnTypeFormattingEditProvider(F,V,G,J){const q=this.t(new X(this.h,G),F);return this.e.$registerOnTypeFormattingSupport(q,this.o(V,F),J,F.identifier),this.p(q)}$provideOnTypeFormattingEdits(F,V,G,J,q,x){return this.s(F,X,ce=>ce.provideOnTypeFormattingEdits(y.URI.revive(V),G,J,q,x),void 0,x)}registerWorkspaceSymbolProvider(F,V){const G=this.t(new Ee(V,this.l),F);return this.e.$registerNavigateTypeSupport(G,typeof V.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(F,V,G){return this.s(F,Ee,J=>J.provideWorkspaceSymbols(V,G),{symbols:[]},G)}$resolveWorkspaceSymbol(F,V,G){return this.s(F,Ee,J=>J.resolveWorkspaceSymbol(V,G),void 0,void 0)}$releaseWorkspaceSymbols(F,V){this.s(F,Ee,G=>G.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(F,V,G){const J=this.t(new Se(this.h,G,this.l),F);return this.e.$registerRenameSupport(J,this.o(V,F),Se.supportsResolving(G)),this.p(J)}$provideRenameEdits(F,V,G,J,q){return this.s(F,Se,x=>x.provideRenameEdits(y.URI.revive(V),G,J,q),void 0,q)}$resolveRenameLocation(F,V,G,J){return this.s(F,Se,q=>q.resolveRenameLocation(y.URI.revive(V),G,J),void 0,J)}registerDocumentSemanticTokensProvider(F,V,G,J){const q=this.t(new $e(this.h,G),F),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(V,F),J,x);let ce=this.p(q);if(x){const Ne=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ce=T.$iK.from(ce,Ne)}return ce}$provideDocumentSemanticTokens(F,V,G,J){return this.s(F,$e,q=>q.provideDocumentSemanticTokens(y.URI.revive(V),G,J),null,J)}$releaseDocumentSemanticTokens(F,V){this.s(F,$e,G=>G.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,V,G,J){const q=this.t(new pe(this.h,G),F);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(V,F),J),this.p(q)}$provideDocumentRangeSemanticTokens(F,V,G,J){return this.s(F,pe,q=>q.provideDocumentRangeSemanticTokens(y.URI.revive(V),G,J),null,J)}registerCompletionItemProvider(F,V,G,J){const q=this.t(new ue(this.h,this.j.converter,G,this.m,F),F);return this.e.$registerCompletionsProvider(q,this.o(V,F),J,ue.supportsResolving(G),F.identifier),this.p(q)}$provideCompletionItems(F,V,G,J,q){return this.s(F,ue,x=>x.provideCompletionItems(y.URI.revive(V),G,J,q),void 0,q)}$resolveCompletionItem(F,V,G){return this.s(F,ue,J=>J.resolveCompletionItem(V,G),void 0,G)}$releaseCompletionItems(F,V){this.s(F,ue,G=>G.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(F,V,G,J){const q=new be(F,this.h,G,this.j.converter),x=this.t(q,F);return this.e.$registerInlineCompletionsSupport(x,this.o(V,F),q.supportsHandleEvents,p.$6l.toKey(F.identifier.value),J?.yieldTo?.map(ce=>p.$6l.toKey(ce))||[]),this.p(x)}$provideInlineCompletions(F,V,G,J,q){return this.s(F,oe,x=>x.provideInlineCompletions(y.URI.revive(V),G,J,q),void 0,q)}$handleInlineCompletionDidShow(F,V,G,J){this.s(F,oe,async q=>{q.handleDidShowCompletionItem(V,G,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,V,G,J){this.s(F,oe,async q=>{q.handlePartialAccept(V,G,J)},void 0,void 0)}$freeInlineCompletionsList(F,V){this.s(F,oe,async G=>{G.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(F,V,G,J){const q=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,x=this.t(new B(this.h,G),F);return this.e.$registerSignatureHelpProvider(x,this.o(V,F),q),this.p(x)}$provideSignatureHelp(F,V,G,J,q){return this.s(F,B,x=>x.provideSignatureHelp(y.URI.revive(V),G,J,q),void 0,q)}$releaseSignatureHelp(F,V){this.s(F,B,G=>G.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(F,V,G){const J=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new Z(this.h,this.j.converter,G,this.l,F),F);this.e.$registerInlayHintsProvider(q,this.o(V,F),typeof G.resolveInlayHint=="function",J,fe.u(F));let x=this.p(q);if(J!==void 0){const ce=G.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(J));x=T.$iK.from(x,ce)}return x}$provideInlayHints(F,V,G,J){return this.s(F,Z,q=>q.provideInlayHints(y.URI.revive(V),G,J),void 0,J)}$resolveInlayHint(F,V,G){return this.s(F,Z,J=>J.resolveInlayHint(V,G),void 0,G)}$releaseInlayHints(F,V){this.s(F,Z,G=>G.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(F,V,G){const J=this.t(new ee(this.h,G),F);return this.e.$registerDocumentLinkProvider(J,this.o(V,F),typeof G.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(F,V,G){return this.s(F,ee,J=>J.provideLinks(y.URI.revive(V),G),void 0,G,V.scheme==="output")}$resolveDocumentLink(F,V,G){return this.s(F,ee,J=>J.resolveLink(V,G),void 0,void 0,!0)}$releaseDocumentLinks(F,V){this.s(F,ee,G=>G.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(F,V,G){const J=this.t(new ve(this.h,G),F);return this.e.$registerDocumentColorProvider(J,this.o(V,F)),this.p(J)}$provideDocumentColors(F,V,G){return this.s(F,ve,J=>J.provideColors(y.URI.revive(V),G),[],G)}$provideColorPresentations(F,V,G,J){return this.s(F,ve,q=>q.provideColorPresentations(y.URI.revive(V),G,J),void 0,J)}registerFoldingRangeProvider(F,V,G){const J=this.q(),q=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new ae(new ge(this.h,G),F)),this.e.$registerFoldingRangeProvider(J,this.o(V,F),F.identifier,q);let x=this.p(J);if(q!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=T.$iK.from(x,ce)}return x}$provideFoldingRanges(F,V,G,J){return this.s(F,ge,q=>q.provideFoldingRanges(y.URI.revive(V),G,J),void 0,J)}registerSelectionRangeProvider(F,V,G){const J=this.t(new he(this.h,G,this.l),F);return this.e.$registerSelectionRangeProvider(J,this.o(V,F)),this.p(J)}$provideSelectionRanges(F,V,G,J){return this.s(F,he,q=>q.provideSelectionRanges(y.URI.revive(V),G,J),[],J)}registerCallHierarchyProvider(F,V,G){const J=this.t(new De(this.h,G),F);return this.e.$registerCallHierarchyProvider(J,this.o(V,F)),this.p(J)}$prepareCallHierarchy(F,V,G,J){return this.s(F,De,q=>Promise.resolve(q.prepareSession(y.URI.revive(V),G,J)),void 0,J)}$provideCallHierarchyIncomingCalls(F,V,G,J){return this.s(F,De,q=>q.provideCallsTo(V,G,J),void 0,J)}$provideCallHierarchyOutgoingCalls(F,V,G,J){return this.s(F,De,q=>q.provideCallsFrom(V,G,J),void 0,J)}$releaseCallHierarchy(F,V){this.s(F,De,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(F,V,G){const J=this.t(new re(this.h,G),F);return this.e.$registerTypeHierarchyProvider(J,this.o(V,F)),this.p(J)}$prepareTypeHierarchy(F,V,G,J){return this.s(F,re,q=>Promise.resolve(q.prepareSession(y.URI.revive(V),G,J)),void 0,J)}$provideTypeHierarchySupertypes(F,V,G,J){return this.s(F,re,q=>q.provideSupertypes(V,G,J),void 0,J)}$provideTypeHierarchySubtypes(F,V,G,J){return this.s(F,re,q=>q.provideSubtypes(V,G,J),void 0,J)}$releaseTypeHierarchy(F,V){this.s(F,re,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(F,V,G,J){const q=this.q();this.f.set(q,new ae(new le(this.e,this.h,G,q,F),F));const x=(0,n.$dF)(F,"dropMetadata")&&J?le.toInternalProviderId(F.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(V,F),x,(0,n.$dF)(F,"dropMetadata")?J:void 0),this.p(q)}$provideDocumentOnDropEdits(F,V,G,J,q,x){return this.s(F,le,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(V,y.URI.revive(G),J,q,x)),void 0,void 0)}registerMappedEditsProvider(F,V,G){const J=this.t(new ne(this.h,G),F);return this.e.$registerMappedEditsProvider(J,this.o(V,F)),this.p(J)}$provideMappedEdits(F,V,G,J,q){return this.s(F,ne,x=>Promise.resolve(x.provideMappedEdits(V,G,J,q)),null,q)}registerDocumentPasteEditProvider(F,V,G,J){const q=this.q();this.f.set(q,new ae(new O(this.e,this.h,G,q,F),F));const x=O.toInternalProviderId(F.identifier.value,J.id);return this.e.$registerPasteEditProvider(q,this.o(V,F),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(F,V,G,J,q){return this.s(F,O,x=>x.prepareDocumentPaste(y.URI.revive(V),G,J,q),void 0,q)}$providePasteEdits(F,V,G,J,q,x){return this.s(F,O,ce=>ce.providePasteEdits(V,y.URI.revive(G),J,q,x),void 0,x)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:fe.w(F.decreaseIndentPattern),increaseIndentPattern:fe.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?fe.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?fe.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:fe.w(F.beforeText),afterText:F.afterText?fe.w(F.afterText):void 0,previousLineText:F.previousLineText?fe.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(fe.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(V=>T.SyntaxTokenType.toString(V)):void 0}}static D(F){return F.map(fe.C)}setLanguageConfiguration(F,V,G){const{wordPattern:J}=G;if(J&&(0,D.$Oe)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(V,J):this.h.setWordDefinitionFor(V,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const q=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?fe.w(G.wordPattern):void 0,indentationRules:G.indentationRules?fe.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?fe.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?fe.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,V,x),this.p(q)}$setWordDefinitions(F){for(const V of F)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$fcc=fe}),define(Ae[242],Re([1,0,3,8,7,29,12,6,22]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class g{constructor(k,c,b,p){this.c=c,this.d=b,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(y.$gK.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,c){await this.a.$changeLanguage(k,c);const b=this.c.getDocumentData(k);if(!b)throw new Error(`document '${k.toString()}' NOT found`);return b.document}async tokenAtPosition(k,c){const b=k.version,p=M.Position.from(c),f=await this.a.$tokensAtPosition(k.uri,p),t={type:C.StandardTokenType.Other,range:k.getWordRangeAtPosition(c)??new C.$kK(c.line,c.character,c.line,c.character)};if(!f)return t;const i={range:M.Range.to(f.range),type:M.TokenType.to(f.type)};return!i.range.contains(c)||b!==k.version?t:i}createLanguageStatusItem(k,c,b){const p=this.f++,f=this.a,t=this.g,i=`${k.identifier.value}/${c}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${c}' ALREADY exists`);t.add(i);const a={selector:b,id:c,name:k.displayName??k.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let $;const E=new l.$Rc,v=()=>{if($?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${c}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}$=(0,A.$Vg)(()=>{E.clear(),this.a.$setLanguageStatus(p,{id:i,name:a.name??k.displayName??k.name,source:k.displayName??k.name,selector:M.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===C.LanguageStatusSeverity.Error?T.default.Error:a.severity===C.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:a.command&&this.d.toInternal(a.command,E),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},n={dispose(){E.dispose(),$?.dispose(),f.$removeLanguageStatus(p),t.delete(i)},get id(){return a.id},get name(){return a.name},set name(r){a.name=r,v()},get selector(){return a.selector},set selector(r){a.selector=r,v()},get text(){return a.text},set text(r){a.text=r,v()},set text2(r){(0,D.$eF)(k,"languageStatusText"),a.text=r,v()},get text2(){return(0,D.$eF)(k,"languageStatusText"),a.text},get detail(){return a.detail},set detail(r){a.detail=r,v()},get severity(){return a.severity},set severity(r){a.severity=r,v()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(r){a.accessibilityInformation=r,v()},get command(){return a.command},set command(r){a.command=r,v()},get busy(){return a.busy},set busy(r){a.busy=r,v()}};return v(),n}}e.$Zcc=g}),define(Ae[81],Re([1,0,23,16,2,4,14,3,27,17]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0;let R=class{constructor(c,b,p){this.f=p,this.d=new Map,this.a=b.getProxy(l.$gK.MainThreadLocalization),this.b=c.environment.appLanguage,this.c=this.b===y.$g}getMessage(c,b){const{message:p,args:f,comment:t}=b;if(this.c)return(0,M.$De)(p,f??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const a=this.d.get(c)?.contents[i];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,M.$De)(a??p,f??{})}getBundle(c){return this.d.get(c)?.contents}getBundleUri(c){return this.d.get(c)?.uri}async initializeLocalizedMessages(c){if(this.c||!c.l10n&&!c.isBuiltin||this.d.has(c.identifier.value))return;let b;const p=await this.g(c);if(!p){this.f.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(p),t=JSON.parse(f);b=c.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${c.identifier.value} from ${p}: ${f.message}`);return}b&&this.d.set(c.identifier.value,{contents:b,uri:p})}async g(c){if(c.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(c.identifier.value,this.b);return C.URI.revive(b)}return c.l10n?C.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Occ=R,e.$Occ=R=qe([Ke(0,D.$xM),Ke(1,g.$hM),Ke(2,A.$0i)],R),e.$Pcc=(0,T.$Ph)("IExtHostLocalizationService")}),define(Ae[243],Re([1,0,14,3,27,17,2,68]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;let D=class extends y.$ij{constructor(k,c){super(c.logLevel,c.logsLocation,c.loggers.map(b=>(0,l.$mh)(b))),this.r=k.getProxy(M.$gK.MainThreadLogger)}$setLogLevel(k,c){c?this.setLogLevel(A.URI.revive(c),k):this.setLogLevel(k)}setVisibility(k,c){super.setVisibility(k,c),this.r.$setVisibility(k,c)}s(k,c,b){return new g(this.r,k,c,b)}};e.$fec=D,e.$fec=D=qe([Ke(0,T.$hM),Ke(1,C.$xM)],D);class g extends y.$dj{constructor(k,c,b,p){super(p?.logLevel==="always"),this.r=k,this.s=c,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(c,p).then(()=>{this.u(this.n),this.m=!0})}g(k,c){const b=[[k,c]];this.m?this.u(b):this.n.push(...b)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,26]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=void 0,e.$Qcc=(0,M.$Ph)("IExtHostManagedSockets");let l=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(y.$gK.MainThreadManagedSockets)}setFactory(k,c){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(k,c),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const c=++this.b,b=await this.c.makeConnection(),p=new C.$Rc;return this.d.set(c,new g(c,b,p)),p.add((0,C.$Qc)(()=>this.d.delete(c))),p.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(c),p.dispose()})),p.add(b.onDidClose(f=>{this.a.$onDidManagedSocketClose(c,f?.stack??f?.message),p.dispose()})),p.add(b.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(c,A.$be.wrap(f)))),c}$remoteSocketWrite(k,c){this.d.get(k)?.actual.send(c.buffer)}$remoteSocketEnd(k){const c=this.d.get(k);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Rcc=l,e.$Rcc=l=qe([Ke(0,T.$hM)],l);class D{constructor(k,c){this.socketFactoryId=k,this.makeConnection=c}}class g extends C.$Sc{constructor(k,c,b){super(),this.socketId=k,this.actual=c,this.B(b)}}}),define(Ae[244],Re([1,0,3,14,22]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;function T(l){return l&&l.title}let A=class{constructor(D,g){this.b=g,this.a=D.getProxy(y.$gK.MainThreadMessageService)}showMessage(D,g,R,k,c){const b={source:{identifier:D.identifier,label:D.displayName||D.name}};let p;typeof k=="string"||T(k)?p=[k,...c]:(b.modal=k?.modal,b.useCustom=k?.useCustom,b.detail=k?.detail,p=c),b.useCustom&&(0,C.$eF)(D,"resolvers");const f=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")f.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:a,isCloseAffordance:$}=i;f.push({title:a,isCloseAffordance:!!$,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(g,R,b,f).then(t=>{if(typeof t=="number")return p[t]})}};e.$1cc=A,e.$1cc=A=qe([Ke(1,M.$0i)],A)}),define(Ae[245],Re([1,0,151,26,5,6,28,16,15,2,39,74,3,31,8,7,47,205,103,9,25,13]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,o,w,d,I){this.q=w,this.r=d,this.s=I,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new C.$Nd({onListenerError:$.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Nd({onListenerError:$.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Nd({onListenerError:$.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Nd({onListenerError:$.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$9bc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy(c.$gK.MainThreadNotebook),this.c=s.getProxy(c.$gK.MainThreadNotebookDocuments),this.d=s.getProxy(c.$gK.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const u=S.notebookEditor?.notebookUri,m=S.cell.handle,P=this.g.get(u)?.getCell(m);if(P)return P.apiCell}if(S&&S.$mid===14){const u=S.uri,m=this.g.get(u);if(m)return m.apiNotebook}return S}}),n.A(o)}getEditorById(s){const o=this.h.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(s){for(const[o,w]of this.h)if(w.apiEditor===s)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,o){const w=this.g.get(s);if(!w&&!o)throw new Error(`NO notebook document for '${s}'`);return w}static t(s,o){if(!o)return;const w=o.filenamePattern.map(d=>p.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(o.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:w,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,w){const d=n.a++,I=typeof w.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(d,w),this.b.$registerNotebookCellStatusBarItemProvider(d,I,o);let S;return I!==void 0&&(S=w.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(I))),new f.$iK(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,I),S?.dispose()})}async createNotebookDocument(s){const o=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&p.NotebookData.from(s.content)});return g.URI.revive(o)}async openNotebookDocument(s){const o=this.g.get(s);if(o)return o.apiNotebook;const w=await this.c.$tryOpenNotebook(s),d=this.g.get(g.URI.revive(w));return(0,D.$Jf)(d?.apiNotebook)}async showNotebookDocument(s,o){g.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let w;typeof o=="object"?w={position:p.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(p.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:w={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,w),I=d&&this.h.get(d)?.apiEditor;if(I)return I;throw d?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,w,d){const I=this.f.get(s),S=g.URI.revive(o),u=this.g.get(S);if(!u||!I)return;const m=u.getCellFromIndex(w);if(!m)return;const h=await I.provideCellStatusBarItems(m.apiCell,d);if(!h)return;const P=new T.$Rc,W=this.p.add([P]),z=(Array.isArray(h)?h:[h]).map(j=>p.NotebookStatusBarItem.from(j,this.i,P));return{cacheId:W,items:z}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,o,w,d,I){if((0,l.$Be)(o))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:o,serializer:w,options:d}),this.b.$registerNotebookSerializer(S,{id:s.identifier,location:s.extensionLocation},o,p.NotebookDocumentContentOptions.from(d),n.t(s,I)),(0,T.$Qc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(s,o,w){const d=this.w.get(s);if(!d)throw new Error("NO serializer found");const I=await d.serializer.deserializeNotebook(o.buffer,w);return new t.$qv(p.NotebookData.from(I))}async $notebookToData(s,o,w){const d=this.w.get(s);if(!d)throw new Error("NO serializer found");const I=await d.serializer.serializeNotebook(p.NotebookData.to(o.value),w);return M.$be.wrap(I)}async $saveNotebook(s,o,w,d,I){const S=g.URI.revive(o),u=this.w.get(s);if(!u)throw new Error("NO serializer found");const m=this.g.get(S);if(!m)throw new Error("Document NOT found");if(m.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new R.$tk((0,y.localize)(0,null,this.y(S)),6);await this.x(S,d);const h={metadata:(0,E.$cn)(m.apiNotebook.metadata,j=>!(u.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of m.apiNotebook.getCells()){const O=new f.$GL(j.kind,j.document.getText(),j.document.languageId,j.mime,u.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);O.metadata=(0,E.$cn)(j.metadata,N=>!(u.options?.transientCellMetadata??{})[N]),h.cells.push(O)}const P=await u.serializer.serializeNotebook(h,I);await this.s.value.writeFile(S,P);const W=this.s.getFileSystemProviderExtUri(S.scheme),K=await this.s.value.stat(S);return{name:W.basename(S),isFile:(K.type&R.FileType.File)!==0,isDirectory:(K.type&R.FileType.Directory)!==0,isSymbolicLink:(K.type&R.FileType.SymbolicLink)!==0,mtime:K.mtime,ctime:K.ctime,size:K.size,readonly:!!((K.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((K.permissions??0)&R.FilePermission.Locked),etag:R.$Ek({mtime:K.mtime,size:K.size}),children:void 0}}async x(s,o){const w=await this.s.value.stat(s);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==R.$Dk&&typeof w.mtime=="number"&&typeof w.size=="number"&&o.mtime<w.mtime&&o.etag!==R.$Ek({mtime:o.mtime,size:w.size}))throw new R.$tk((0,y.localize)(1,null),3,o)}y(s){return s.scheme===v.Schemas.file?s.fsPath:s.toString()}z(s,o,w){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const d=new a.$Hdc(o,this.d,s,w.visibleRanges.map(p.NotebookRange.to),w.selections.map(p.NotebookRange.to),typeof w.viewColumn=="number"?p.ViewColumn.to(w.viewColumn):void 0);this.h.set(o,d)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const w of s.value.removedDocuments){const d=g.URI.revive(w),I=this.g.get(d);I&&(I.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(I.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===d.toString()&&this.h.delete(S.id)}if(s.value.addedDocuments){const w=[];for(const d of s.value.addedDocuments){const I=g.URI.revive(d.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const S=new i.$Gdc(this.c,this.q,this.r,I,d);w.push(...d.cells.map(u=>i.$Fdc.asModelAddData(S.apiNotebook,u))),this.g.get(I)?.dispose(),this.g.set(I,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(S.apiNotebook)}}if(s.value.addedEditors)for(const w of s.value.addedEditors){if(this.h.has(w.id))return;const d=g.URI.revive(w.documentUri),I=this.g.get(d);I&&this.z(I,w.id,w)}const o=[];if(s.value.removedEditors)for(const w of s.value.removedEditors){const d=this.h.get(w);d&&(this.h.delete(w),this.k?.id===d.id&&(this.k=void 0),o.push(d))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const w=new Set;this.l.forEach(d=>w.add(d.id));for(const d of this.h.values()){const I=w.has(d.id);d._acceptVisibility(I)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const o=b.$FM.String.with("notebookType","A notebook type"),w=new b.$HM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new b.$FM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>M.$be.wrap(I))],new b.$GM("Notebook Data",I=>p.NotebookData.to(I.value))),d=new b.$HM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new b.$FM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$qv(p.NotebookData.from(I)))],new b.$GM("Bytes",I=>I.buffer));s.registerApiCommand(w),s.registerApiCommand(d)}}e.$Idc=n}),define(Ae[246],Re([1,0,18,12,19,5,6,28,2,21,14,3,31,8,7,77,198,22,47]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0;let $=class{constructor(d,I,S,u,m){this.l=I,this.m=S,this.n=u,this.o=m,this.b=new l.$Ac,this.c=new l.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new T.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=d.getProxy(k.$gK.MainThreadNotebookKernels);const h=new c.$HM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.$FM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const W=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:W}}else if(P&&"notebookEditor"in P){const W=this.m.getIdByEditor(P.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return P})],c.$GM.Void);this.n.registerApiCommand(h)}createNotebookController(d,I,S,u,m,h){for(const pe of this.i.values())if(pe.controller.id===I&&g.$6l.equals(d.identifier,pe.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const P=this.j++,W=this;this.o.trace(`NotebookController[${P}], CREATED by ${d.identifier.value}, ${I}`);const K=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${d.identifier}'`);let z=!1;const j=new T.$Nd,O=new T.$Nd,N={id:o(d.identifier,I),notebookType:S,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:u||d.identifier.value,preloads:h?h.map(b.NotebookRendererScript.from):[]};let ie=m??K,X;this.a.$addKernel(P,N).catch(pe=>{console.log(pe),z=!0});let Ee=0;const Se=()=>{if(z)return;const pe=++Ee;Promise.resolve().then(()=>{pe===Ee&&this.a.$updateKernel(P,N)})},Pe=new l.$Ac,$e={get id(){return I},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return N.label},set label(pe){N.label=pe??d.displayName??d.name,Se()},get detail(){return N.detail??""},set detail(pe){N.detail=pe,Se()},get description(){return N.description??""},set description(pe){N.description=pe,Se()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(pe){N.supportedLanguages=pe,Se()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){N.supportsExecutionOrder=pe,Se()},get rendererScripts(){return N.preloads?N.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(pe){ie=pe??K},get interruptHandler(){return X},set interruptHandler(pe){X=pe,N.supportsInterrupt=!!pe,Se()},createNotebookCellExecution(pe){if(z)throw new Error("notebook controller is DISPOSED");if(!Pe.has(pe.notebook.uri))throw W.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return W._createNotebookCellExecution(pe,o(d.identifier,this.id))},createNotebookExecution(pe){if((0,i.$eF)(d,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!Pe.has(pe.uri))throw W.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return W._createNotebookExecution(pe,o(d.identifier,this.id))},dispose:()=>{z||(this.o.trace(`NotebookController[${P}], DISPOSED`),z=!0,this.i.delete(P),j.dispose(),O.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(pe,ue){ue===p.NotebookControllerAffinity2.Hidden&&(0,i.$eF)(d,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(P,pe.uri,ue)},onDidReceiveMessage:O.event,postMessage(pe,ue){return(0,i.$eF)(d,"notebookMessaging"),W.a.$postMessage(P,ue&&W.m.getIdByEditor(ue),pe)},asWebviewUri(pe){return(0,i.$eF)(d,"notebookMessaging"),(0,f.$9ob)(pe,W.l.remote)}};return this.i.set(P,{extensionId:d.identifier,controller:$e,onDidReceiveMessage:O,onDidChangeSelection:j,associatedNotebooks:Pe}),$e}getIdByController(d){for(const[I,S]of this.i)if(S.controller===d)return o(S.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,I){const S=this.f++,u=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(S,I);const m={dispose:()=>{this.e.delete(S),u.a.$removeKernelDetectionTask(S)}};return this.e.set(S,m),m}registerKernelSourceActionProvider(d,I,S){const u=this.h++,m=typeof S.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,h=this;this.g.set(u,S),this.o.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,I);let P;return m!==void 0&&(P=S.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.g.delete(u),h.a.$removeKernelSourceActionProvider(u,u),P?.dispose()}}}async $provideKernelSourceActions(d,I){const S=this.g.get(d);if(S){const u=new A.$Rc;return(await S.provideNotebookKernelSourceActions(I)??[]).map(h=>b.NotebookKernelSourceAction.from(h,this.n.converter,u))}return[]}$acceptNotebookAssociation(d,I,S){const u=this.i.get(d);if(u){const m=this.m.getNotebookDocument(D.URI.revive(I));S?u.associatedNotebooks.set(m.uri,!0):u.associatedNotebooks.delete(m.uri),this.o.trace(`NotebookController[${d}] ASSOCIATE notebook`,m.uri.toString(),S),u.onDidChangeSelection.fire({selected:S,notebook:m.apiNotebook})}}async $executeCells(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getNotebookDocument(D.URI.revive(I)),h=[];for(const P of S){const W=m.getCell(P);W&&h.push(W.apiCell)}try{this.o.trace(`NotebookController[${d}] EXECUTE cells`,m.uri.toString(),h.length),await u.controller.executeHandler.call(u.controller,h,m.apiNotebook,u.controller)}catch(P){this.o.error(`NotebookController[${d}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getNotebookDocument(D.URI.revive(I));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,m.apiNotebook);else for(const h of S){const P=m.getCell(h);P&&this.b.get(P.uri)?.cancel()}if(u.controller.interruptHandler){const h=this.c.get(m.uri);S.length&&Array.isArray(h)&&h.length&&h.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getEditorById(I);u.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:S}))}$cellExecutionChanged(d,I,S){const m=this.m.getNotebookDocument(D.URI.revive(d)).getCell(I);if(m){const h=S?b.NotebookCellExecutionState.to(S):p.NotebookCellExecutionState.Idle;h!==void 0&&this.k.fire({cell:m.apiCell,state:h})}}_createNotebookCellExecution(d,I){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.m.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const m=new v(I,u,this.a);this.b.set(u.uri,m);const h=m.onDidChangeState(()=>{m.state===E.Resolved&&(m.dispose(),h.dispose(),this.b.delete(u.uri))});return m.asApiObject()}_createNotebookExecution(d,I){const S=this.m.getNotebookDocument(d.uri),u=d.getCells().find(P=>{const W=S.getCellFromApiCell(P);return W&&this.b.has(W.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const m=new r(I,S,this.a),h=m.onDidChangeState(()=>{m.state===n.Resolved&&(m.dispose(),h.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[m,h]),m.asApiObject()}};e.$Wdc=$,e.$Wdc=$=qe([Ke(4,R.$0i)],$);var E;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(E||(E={}));class v extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(d,I,S){super(),this.m=I,this.n=S,this.b=v.a++,this.c=new T.$Nd,this.onDidChangeState=this.c.event,this.f=E.Init,this.g=this.B(new C.$Xd),this.h=new s(10,u=>this.s(u)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const I=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new a.$qv(I))}t(){if(this.f===E.Init)throw new Error("Must call start before modifying cell output");if(this.f===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let I=this.m;if(d&&(I=this.m.notebook.getCellFromApiCell(d)),!I)throw new Error("INVALID cell");return I.handle}y(d){return d.map(I=>{const S=p.$JL.ensureUniqueMimeTypes(I.items,!0);return S===I.items?b.NotebookCellOutput.from(I):b.NotebookCellOutput.from({items:S,id:I.id,metadata:I.metadata})})}async z(d,I,S){const u=this.w(I),m=this.y((0,y.$3b)(d));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:u,append:S,outputs:m})}async C(d,I,S){return d=p.$JL.ensureUniqueMimeTypes((0,y.$3b)(d),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:d.map(b.NotebookCellOutputItem.from),outputId:I.id,append:S})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(S){d.j=S,d.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(S){if(d.f===E.Resolved||d.f===E.Started)throw new Error("Cannot call start again");d.f=E.Started,d.c.fire(),d.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,u){if(d.f===E.Resolved)throw new Error("Cannot call resolve twice");d.f=E.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new a.$qv({runEndTime:u,lastRunSuccess:S}))},clearOutput(S){return d.t(),d.z([],S,!1)},appendOutput(S,u){return d.t(),d.z(S,u,!0)},replaceOutput(S,u){return d.t(),d.z(S,u,!1)},appendOutputItems(S,u){return d.t(),d.C(S,u,!0)},replaceOutputItems(S,u){return d.t(),d.C(S,u,!1)}})}}var n;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(n||(n={}));class r extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(d,I,S){super(),this.h=I,this.j=S,this.b=r.a++,this.c=new T.$Nd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new C.$Xd),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(d,I){this.e=d,this.f=I,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new M.$ch,this.b=Date.now(),(0,M.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>d.complete())}}function o(w,d){return`${w.value}/${d}`}e.$Xdc=o}),define(Ae[247],Re([1,0,5,3,103]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class T{constructor(l,D){this.c=D,this.a=new Map,this.b=l.getProxy(M.$gK.MainThreadNotebookRenderers)}$postRendererMessage(l,D,g){const R=this.c.getEditorById(l);this.a.get(D)?.fire({editor:R.apiEditor,message:g})}createRendererMessaging(l,D){if(!l.contributes?.notebookRenderer?.some(R=>R.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(R,k,c)=>this.d(D).event(R,k,c),postMessage:(R,k)=>{C.$Hdc.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const c=k&&C.$Hdc.apiEditorsToExtHost.get(k);return this.b.$postMessage(c?.id,D,R)}}}d(l){let D=this.a.get(l);return D||(D=new y.$Nd({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(l)}}),this.a.set(l,D),D)}}e.$Ydc=T}),define(Ae[248],Re([1,0,6,15,2,22,3]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;class l{constructor(g){this.b=new Map,this.a=g.getProxy(A.$gK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,R,k){if((0,T.$eF)(g,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,k),this.a.$registerProfileContentHandler(R,k.name,k.description,g.identifier.value),(0,y.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(g,R,k,c){const b=this.b.get(g);if(!b)throw new Error(`Unknown handler with id: ${g}`);return b.saveProfile(R,k,c)}async $readProfile(g,R,k){const c=this.b.get(g);if(!c)throw new Error(`Unknown handler with id: ${g}`);return c.readProfile((0,M.$yf)(R)?R:C.URI.revive(R),k)}}e.$3dc=l}),define(Ae[249],Re([1,0,2,3,12,8]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;class A{static{this.a=0}constructor(D,g){this.d=g,this.c=new Map,this.b=D.getProxy(M.$gK.MainThreadQuickDiff)}$provideOriginalResource(D,g,R){const k=y.URI.revive(g),c=this.c.get(D);return c?(0,C.$Mg)(()=>c.provideOriginalResource(k,R)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,R,k){const c=A.a++;return this.c.set(c,g),this.b.$registerQuickDiffProvider(c,T.DocumentSelector.from(D,this.d),R,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(c),this.c.delete(c)}}}}e.$4dc=A}),define(Ae[250],Re([1,0,19,5,6,3,2,7,9,18,29,43,22,8]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;function p(f,t,i){const a=f.getProxy(T.$gK.MainThreadQuickOpen);class ${constructor(I,S){this.e=new Map,this.f=0,this.a=I,this.b=S}showQuickPick(I,S,u,m=y.CancellationToken.None){this.c=void 0;const h=Promise.resolve(S),P=++this.f,W=a.$show(P,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},m),K={},z=W.then(()=>K);return Promise.race([z,h]).then(j=>{if(j===K)return;const O=(0,c.$dF)(I,"quickPickItemTooltip");return h.then(N=>{const ie=[];for(let X=0;X<N.length;X++){const Ee=N[X];if(typeof Ee=="string")ie.push({label:Ee,handle:X});else if(Ee.kind===l.QuickPickItemKind.Separator)ie.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!O&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const Se=Ee.iconPath?s(Ee.iconPath):void 0;ie.push({label:Ee.label,iconPath:Se?.iconPath,iconClass:Se?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:O?b.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:X})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=X=>{u.onDidSelectItem(N[X])}),a.$setItems(P,ie),W.then(X=>{if(typeof X=="number")return N[X];if(Array.isArray(X))return X.map(Ee=>N[Ee])})})}).then(void 0,j=>{if(!(0,D.$4)(j))return a.$setError(P,j),Promise.reject(j)})}$onItemSelected(I){this.c?.(I)}showInput(I,S=y.CancellationToken.None){return this.d=I?.validateInput,a.$input(I,typeof this.d=="function",S).then(void 0,u=>{if(!(0,D.$4)(u))return Promise.reject(u)})}async $validateInput(I){if(!this.d)return;const S=await this.d(I);if(!S||typeof S=="string")return S;let u;switch(S.severity){case l.InputBoxValidationSeverity.Info:u=R.default.Info;break;case l.InputBoxValidationSeverity.Warning:u=R.default.Warning;break;case l.InputBoxValidationSeverity.Error:u=R.default.Error;break;default:u=S.message?R.default.Error:R.default.Ignore;break}return{content:S.message,severity:u}}async showWorkspaceFolderPick(I,S=y.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!u)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(h=>h.uri.toString()===u.uri.toString())}createQuickPick(I){const S=new o(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(I){const S=new w(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(I,S){this.e.get(I)?._fireDidChangeValue(S)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeActive(S)}$onDidChangeSelection(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeSelection(S)}$onDidTriggerButton(I,S){this.e.get(I)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(I,S,u){const m=this.e.get(I);m instanceof o&&m._fireDidTriggerItemButton(S,u)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class E{static{this.a=1}constructor(I,S){this.x=I,this.y=S,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Nd,this.q=new M.$Nd,this.r=new M.$Nd,this.s=new M.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((S,u)=>{const m=S===l.$CL.Back?-1:u;this.o.set(m,S)}),this.z({buttons:I.map((S,u)=>({...s(S.iconPath),tooltip:S.tooltip,handle:S===l.$CL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const S=this.o.get(I);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(I){if(!this.v){for(const S of Object.keys(I)){const u=I[S];this.u[S]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function v(d){if(d instanceof l.$cL)return{id:d.id};const I=r(d),S=n(d);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof S=="string"?A.URI.file(S):S}}function n(d){return typeof d=="object"&&"light"in d?d.light:d}function r(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const I=v(d);let S,u;return"id"in I?u=k.ThemeIcon.asClassName(I):S=I,{iconPath:S,iconClass:u}}class o extends E{constructor(I,S){super(I.identifier,S),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Nd,this.L=[],this.M=new M.$Nd,this.N=new M.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((m,h)=>{this.C.set(h,m),this.D.set(m,h)});const S=(0,c.$dF)(this.O,"quickPickItemTooltip"),u=[];for(let m=0;m<I.length;m++){const h=I[m];if(h.kind===l.QuickPickItemKind.Separator)u.push({type:"separator",label:h.label});else{h.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=h.iconPath?s(h.iconPath):void 0;u.push({handle:m,label:h.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,tooltip:S?b.MarkdownString.fromStrict(h.tooltip):void 0,buttons:h.buttons?.map((W,K)=>({...s(W.iconPath),tooltip:W.tooltip,handle:K}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(I){const S=(0,g.$Hb)(I.map(u=>this.C.get(u)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(I){const S=(0,g.$Hb)(I.map(u=>this.C.get(u)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(I,S){const u=this.C.get(I);if(!u||!u.buttons||!u.buttons.length)return;const m=u.buttons[S];m&&this.N.fire({button:m,item:u})}}class w extends E{constructor(I,S){super(I.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:R.default.Error}):this.z({validationMessage:I.message,severity:I.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new $(t,i)}e.$5cc=p}),define(Ae[251],Re([1,0,2,5,65,6,12,3,18,131,14,21,43,8,22,13]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=void 0;function i(m){if(m)return typeof m.iconPath=="string"?y.URI.file(m.iconPath):y.URI.isUri(m.iconPath)||c.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function a(m){if(m.icon){if(y.URI.isUri(m.icon))return m.icon;if(c.ThemeIcon.isThemeIcon(m.icon))return m.icon;{const h=m.icon;return{light:h.light,dark:h.dark}}}else return}function $(m,h){if(!m.iconPath&&!h.iconPath)return 0;if(m.iconPath){if(!h.iconPath)return 1}else return-1;const P=typeof m.iconPath=="string"?m.iconPath:y.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,W=typeof h.iconPath=="string"?h.iconPath:y.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,g.$sq)(P,W)}function E(m,h){let P=0;if(m.strikeThrough!==h.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==h.faded)return m.faded?1:-1;if(m.tooltip!==h.tooltip)return(m.tooltip||"").localeCompare(h.tooltip||"");if(P=$(m,h),P!==0)return P;if(m.light&&h.light)P=$(m.light,h.light);else{if(m.light)return 1;if(h.light)return-1}if(P!==0)return P;if(m.dark&&h.dark)P=$(m.dark,h.dark);else{if(m.dark)return 1;if(h.dark)return-1}return P}function v(m,h){if(m.command!==h.command)return m.command<h.command?-1:1;if(m.title!==h.title)return m.title<h.title?-1:1;if(m.tooltip!==h.tooltip){if(m.tooltip!==void 0&&h.tooltip!==void 0)return m.tooltip<h.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(m.arguments===h.arguments)return 0;if(m.arguments)if(h.arguments){if(m.arguments.length!==h.arguments.length)return m.arguments.length-h.arguments.length}else return 1;else return-1;for(let P=0;P<m.arguments.length;P++){const W=m.arguments[P],K=h.arguments[P];if(W!==K)return W<K?-1:1}return 0}function n(m,h){let P=(0,g.$sq)(m.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(P!==0)return P;if(m.command&&h.command)P=v(m.command,h.command);else{if(m.command)return 1;if(h.command)return-1}if(P!==0)return P;if(m.decorations&&h.decorations)P=E(m.decorations,h.decorations);else{if(m.decorations)return 1;if(h.decorations)return-1}return P}function r(m,h){for(let P=0;P<m.length;P++)if(m[P]!==h[P])return!1;return!0}function s(m,h){return m.command===h.command&&m.title===h.title&&m.tooltip===h.tooltip&&(m.arguments&&h.arguments?r(m.arguments,h.arguments):m.arguments===h.arguments)}function o(m,h){return(0,D.$ub)(m,h,s)}function w(m,h){return m===h?!0:!m||!h?!1:m.id===h.id&&m.label===h.label&&m.upstream?.id===h.upstream?.id&&m.upstream?.label===h.upstream?.label}class d{#e;#t;get value(){return this.d}set value(h){h=h??"",this.#e.$setInputBoxValue(this.l,h),this.n(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){this.#e.$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,p.$eF)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,p.$eF)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,this.#e.$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,this.#e.$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,this.#e.$setInputBoxVisibility(this.l,h))}get document(){return(0,p.$eF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(h,P,W,K,z){this.k=h,this.l=K,this.m=z,this.d="",this.e=new M.$Nd,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=W}showValidationMessage(h,P){(0,p.$eF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,h,P)}$onInputBoxValueChange(h){this.n(h)}n(h){this.d=h,this.e.fire(h)}}e.$6cc=d;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,P,W,K,z){this.q=h,this.s=P,this.t=W,this.u=K,this.v=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,P){const W=this.h.get(h);return W?(0,A.$Mg)(()=>this.s.executeCommand(W.command,...W.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(n),W=(0,D.$Db)(this.o,h,n).map(j=>{const O=j.toInsert.map(N=>{const ie=this.e++;this.g.set(ie,N);const X=N.resourceUri;let Ee;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const Z=new T.$Rc;Ee=this.s.converter.toInternal(N.command,Z),this.j.set(ie,Z)}else this.h.set(ie,N.command);const Se=i(N.decorations),Pe=N.decorations&&i(N.decorations.light)||Se,$e=N.decorations&&i(N.decorations.dark)||Se,pe=[Pe,$e],ue=N.decorations&&N.decorations.tooltip||"",oe=N.decorations&&!!N.decorations.strikeThrough,be=N.decorations&&!!N.decorations.faded,_=N.contextValue||"";return{rawResource:[ie,X,pe,ue,oe,be,_,Ee],handle:ie}});return{start:j.start,deleteCount:j.deleteCount,toInsert:O}}),K=W.map(({start:j,deleteCount:O,toInsert:N})=>[j,O,N.map(ie=>ie.rawResource)]),z=W.reverse();for(const{start:j,deleteCount:O,toInsert:N}of z){const ie=N.map(Ee=>Ee.handle),X=this.n.splice(j,O,...ie);for(const Ee of X)this.g.delete(Ee),this.h.delete(Ee),this.j.get(Ee)?.dispose(),this.j.delete(Ee)}return this.o=h,K}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,this.#e.$updateSourceControl(this.x,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h;let P;(0,p.$dF)(this.y,"quickDiffProvider")&&(P=h?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!h,quickDiffLabel:P})}get historyProvider(){return(0,p.$eF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(h){(0,p.$eF)(this.y,"scmHistoryProvider"),this.j=h,this.k.value=new T.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!h}),h&&(this.k.value.add(h.onDidChangeCurrentHistoryItemGroup(()=>{w(this.l,h?.currentHistoryItemGroup)||(this.l=h?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(h.onDidChangeActionButton(()=>{(0,p.$eF)(this.y,"scmActionButton"),this.m.value=new T.$Rc;const P=h.actionButton!==void 0?{command:this.z.converter.toInternal(h.actionButton.command,this.m.value),description:h.actionButton.description,enabled:h.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(h){h!==this.n&&(this.n=h,this.#e.$updateSourceControl(this.x,{commitTemplate:h}))}get acceptInputCommand(){return this.p}set acceptInputCommand(h){this.o.value=new T.$Rc,this.p=h;const P=this.z.converter.toInternal(h,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,p.$eF)(this.y,"scmActionButton"),this.s}set actionButton(h){(0,p.$eF)(this.y,"scmActionButton"),this.q.value=new T.$Rc,this.s=h;const P=h!==void 0?{command:this.z.converter.toInternal(h.command,this.q.value),secondaryCommands:h.secondaryCommands?.map(W=>W.map(K=>this.z.converter.toInternal(K,this.q.value))),description:h.description,enabled:h.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(h){if(this.u&&h&&o(this.u,h))return;this.t.value=new T.$Rc,this.u=h;const P=(h||[]).map(W=>this.z.converter.toInternal(W,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(h,P,W,K,z,j,O){this.y=h,this.z=K,this.A=z,this.B=j,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Tc,this.m=new T.$Tc,this.n=void 0,this.o=new T.$Tc,this.p=void 0,this.q=new T.$Tc,this.t=new T.$Tc,this.u=void 0,this.v=!1,this.w=new M.$Nd,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=W;const N=y.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${z}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new d(h,P,this.#e,this.x,N),this.#e.$registerSourceControl(this.x,z,j,O,N)}createResourceGroup(h,P){const W=new I(this.#e,this.z,this.x,h,P),K=M.Event.once(W.onDidDispose)(()=>this.D.delete(W));return this.D.set(W,K),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const h=[],P=[];for(const[W,K]of this.D){K.dispose();const z=W.onDidUpdateResourceStates(()=>{this.E.add(W),this.eventuallyUpdateResourceStates()});M.Event.once(W.onDidDispose)(()=>{this.E.delete(W),z.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.x,W.handle)}),h.push([W.handle,W.id,W.label,W.features]);const j=W._takeResourceStateSnapshot();j.length>0&&P.push([W.handle,j]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.x,h,P),this.D.clear()}eventuallyUpdateResourceStates(){const h=[];this.E.forEach(P=>{const W=P._takeResourceStateSnapshot();W.length!==0&&h.push([P.handle,W])}),h.length>0&&this.#e.$spliceResourceStates(this.x,h),this.E.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.v=h,this.w.fire(h)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(h=>h.dispose()),this.#e.$unregisterSourceControl(this.x)}}qe([(0,C.$ih)(100)],S.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.$ih)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let u=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(h,P,W,K){this.l=P,this.m=W,this.n=K,this.g=new Map,this.h=new k.$8l,this.j=new M.$Nd,this.e=h.getProxy(l.$gK.MainThreadSCM),this.f=h.getProxy(l.$gK.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const j=this.g.get(z.sourceControlHandle);if(!j)return z;const O=j.getResourceGroup(z.groupHandle);return O?O.getResourceState(z.handle):z}else if(z&&z.$mid===4){const j=this.g.get(z.sourceControlHandle);return j?j.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const j=this.g.get(z.handle);return j||z}return z}})}createSourceControl(h,P,W,K){this.n.trace("ExtHostSCM#createSourceControl",h.identifier.value,P,W,K),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const z=t.d++,j=new S(h,this.m,this.e,this.l,P,W,K);this.g.set(z,j);const O=this.h.get(h.identifier)||[];return O.push(j),this.h.set(h.identifier,O),j}getLastInputBox(h){this.n.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const P=this.h.get(h.identifier),W=P&&P[P.length-1];return W&&W.inputBox}$provideOriginalResource(h,P,W){const K=y.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",h,K.toString());const z=this.g.get(h);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Mg)(()=>z.quickDiffProvider.provideOriginalResource(K,W)).then(j=>j||null)}$onInputBoxValueChange(h,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",h);const W=this.g.get(h);return W&&W.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(h,P,W,K){this.n.trace("ExtHostSCM#$executeResourceCommand",h,P,W);const z=this.g.get(h);if(!z)return Promise.resolve(void 0);const j=z.getResourceGroup(P);return j?j.$executeResourceCommand(W,K):Promise.resolve(void 0)}$validateInput(h,P,W){this.n.trace("ExtHostSCM#$validateInput",h);const K=this.g.get(h);return!K||!K.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Mg)(()=>K.inputBox.validateInput(P,W)).then(z=>{if(!z)return Promise.resolve(void 0);const j=b.MarkdownString.fromStrict(z.message);return j?Promise.resolve([j,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(h,P,W){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupBase(P,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(h,P,W,K){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,W,K)??void 0}async $provideHistoryItems(h,P,W,K){return(await this.g.get(h)?.historyProvider?.provideHistoryItems(P,W,K))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:a(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(h,P,W){return await this.g.get(h)?.historyProvider?.provideHistoryItemChanges(P,W)??void 0}};e.$7cc=u,e.$7cc=u=t=qe([Ke(3,R.$0i)],u)}),define(Ae[83],Re([1,0,3,5,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=e.$Lcc=void 0;class T{constructor(l){this.b=new M.$Nd,this.onDidChangePassword=this.b.event,this.a=l.getProxy(y.$gK.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,D){return this.a.$getPassword(l,D)}store(l,D,g){return this.a.$setPassword(l,D,g)}delete(l,D){return this.a.$deletePassword(l,D)}}e.$Lcc=T,e.$Mcc=(0,C.$Ph)("IExtHostSecretState")}),define(Ae[252],Re([1,0,3,8,2]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;class T{static{this.a=0}constructor(l,D){this.d=D,this.c=new Map,this.b=l.getProxy(y.$gK.MainThreadShare)}async $provideShare(l,D,g){return await this.c.get(l)?.provideShare({selection:M.Range.to(D.selection),resourceUri:C.URI.revive(D.resourceUri)},g)??void 0}registerShareProvider(l,D){const g=T.a++;return this.c.set(g,D),this.b.$registerShareProvider(g,M.DocumentSelector.from(l,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$9dc=T}),define(Ae[253],Re([1,0,19,6,3]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class T{static{this.a=1}constructor(l){this.c=new Map,this.d=new Map,this.b=l.getProxy(C.$gK.MainThreadSpeech)}async $createSpeechToTextSession(l,D){const g=this.c.get(l);if(!g)return;const R=new M.$Rc,k=new y.$Xd;this.d.set(D,k);const c=R.add(g.provideSpeechToTextSession(k.token));R.add(c.onDidChange(b=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(D,b)})),R.add(k.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(l){this.d.get(l)?.dispose(!0),this.d.delete(l)}registerProvider(l,D,g){const R=T.a++;return this.c.set(R,g),this.b.$registerProvider(R,D,{extension:l,displayName:l.value}),(0,M.$Qc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$$dc=T}),define(Ae[254],Re([1,0,7,3,153,6,8,15]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$dL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$dL("statusBarItem.warningForeground")]])}#e;#t;constructor(c,b,p,f,t,i=y.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new T.$Rc,this.#e=c,this.#t=b,t&&f){this.c=(0,y.$SK)(f.identifier,t);const $=p.get(this.c);$&&(i=$.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,a=$.priority,this.j=!0,this.name=$.name,this.text=$.text,this.tooltip=$.tooltip,this.command=$.command,this.accessibilityInformation=$.accessibilityInformation)}else this.c=String(D.a++);this.e=f,this.f=t,this.g=i,this.h=this.u(a)}u(c){if((0,l.$Cf)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(c){this.k=c,this.v()}set name(c){this.m=c,this.v()}set tooltip(c){this.l=c,this.v()}set color(c){this.n=c,this.v()}set backgroundColor(c){c&&!D.b.has(c.id)&&(c=void 0),this.o=c,this.v()}set command(c){this.r?.fromApi!==c&&(this.p&&this.q.add(this.p),this.p=new T.$Rc,typeof c=="string"?this.r={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this.p)}:c?this.r={fromApi:c,internal:this.#t.toInternal(c,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(c){this.t=c,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let c;this.e?this.f?c=`${this.e.identifier.value}.${this.f}`:c=this.e.identifier.value:c=this.f;let b;this.m?b=this.m:b=(0,C.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=D.b.get(this.o.id));const f=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,c,this.e?.identifier.value,b,this.k,f,this.r?.internal,p,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$8cc=D;class g{constructor(c){this.b=[],this.a=c.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(c){const b={message:c};return this.b.unshift(b),this.c(),new y.$iK(()=>{const p=this.b.indexOf(b);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(c,b){this.e=new Map,this.a=c.getProxy(M.$gK.MainThreadStatusBar),this.b=b,this.c=new g(this)}$acceptStaticEntries(c){for(const b of c)this.e.set(b.entryId,b)}createStatusBarEntry(c,b,p,f){return new D(this.a,this.b,this.e,c,b,p,f)}setStatusBarMessage(c,b){const p=this.c.setMessage(c);let f;return typeof b=="number"?f=setTimeout(()=>p.dispose(),b):typeof b<"u"&&b.then(()=>p.dispose(),()=>p.dispose()),new y.$iK(()=>{p.dispose(),clearTimeout(f)})}}e.$9cc=R}),define(Ae[84],Re([1,0,3,5,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0;class T{constructor(l,D){this.c=D,this.b=new M.$Nd,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(y.$gK.MainThreadStorage)}registerExtensionStorageKeysToSync(l,D){this.a.$registerExtensionStorageKeysToSync(l,D)}async initializeExtensionStorage(l,D,g){const R=await this.a.$initializeExtensionStorage(l,D);let k;return R&&(k=this.d(l,D,R)),k||g}setValue(l,D,g){return this.a.$setValue(l,D,g)}$acceptValue(l,D,g){const R=this.d(l,D,g);R&&this.b.fire({shared:l,key:D,value:R})}d(l,D,g){try{return JSON.parse(g)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${l}): ${R}`)}}}e.$zcc=T,e.$Acc=(0,C.$Ph)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=e.$Fcc=void 0,e.$Fcc=(0,y.$Ph)("IExtensionStoragePaths");let l=class{constructor(g,R,k){this.d=R,this.f=k,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(c=>this.c=c)}async g(g){return A.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,R=await this.g(g);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(g){if(this.c)return A.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return A.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Gcc=l,e.$Gcc=l=qe([Ke(0,M.$xM),Ke(1,C.$0i),Ke(2,T.$Ecc)],l)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,155,9,181,19,36,182,43,12,8,31]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=e.$Icc=e.$Hcc=void 0,e.$Hcc=(0,C.$Ph)("IExtHostTerminalService");class ${constructor(u,m,h,P){this.l=u,this._id=m,this.m=h,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(K=>this.f=K);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(K,z=!0){W.q(),W.l.$sendText(W._id,K,z)},show(K){W.q(),W.l.$show(W._id,K)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(u,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:w(u.iconPath)??void 0,color:f.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(u.location,m?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,m,h,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:h,color:f.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(u,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,m){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,m){this.h=Object.freeze({code:u,reason:m})}setDimensions(u,m){return u===this.d&&m===this.g||u===0||m===0?!1:(this.d=u,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(m=>{m!==u&&(this.b=Promise.resolve(u))})}}e.$Icc=$;class E{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new y.$Nd,this.onProcessData=this.a.event,this.b=new y.$Nd,this.d=new y.$Nd,this.onDidChangeProperty=this.d.event,this.f=new y.$Nd,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,m){this.g.setDimensions?.({columns:u,rows:m})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let v=1,n=class extends l.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,m,h){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Nd,this.onDidChangeShell=this.N.event,this.O=new y.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=h.getProxy(M.$gK.MainThreadTerminalService),this.y=new p.$Tkb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:P=>{const W=K=>{const z=K;return this.W(z.instanceId)?.value};switch(P?.$mid){case 15:return W(P);default:{if(Array.isArray(P))for(let K=0;K<P.length&&P[K].$mid===15;K++)P[K]=W(P[K]);return P}}}}),this.B({dispose:()=>{for(const[P,W]of this.g)W.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,m){const h=new $(this.a,(0,b.$eg)(),u,u.name),P=new E(u.pty);return h.createExtensionTerminal(u.location,this.R(u,m).resolvedExtHostIdentifier,w(u.iconPath),d(u.color)).then(W=>{const K=this.S(W,P);this.h[W]=K}),this.f.push(h),h.value}R(u,m){if(m=m||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const h=u.location.parentTerminal;if(h){const P=this.f.find(W=>W.value===h);P&&(m.resolvedExtHostIdentifier=P._id)}}else u.location&&typeof u.location!="object"?m.location=u.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(u,m){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const P=new E(m),W=this.S(u,P);this.h[u]=W}async $acceptActiveTerminalChanged(u){const m=this.b;if(u===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const h=this.W(u);h&&(this.b=h,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,m){const h=this.W(u);h&&this.O.fire({terminal:h.value,data:m})}async $acceptTerminalDimensions(u,m,h){const P=this.W(u);P&&P.setDimensions(m,h)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(u,m){const h=this.W(u);h&&this.P.fire({terminal:h.value,...m})}async $acceptTerminalMaximumDimensions(u,m,h){this.g.get(u)?.resize(m,h)}async $acceptTerminalTitleChange(u,m){const h=this.W(u);h&&(h.name=m)}async $acceptTerminalClosed(u,m,h){const P=this.Y(this.f,u);if(P!==null){const W=this.f.splice(P,1)[0];W.setExitStatus(m,h),this.H.fire(W.value)}}$acceptTerminalOpened(u,m,h,P){if(m){const z=this.Y(this.f,m);if(z!==null){this.f[z]._id=u,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const W={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:T.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},K=new $(this.a,u,W,h);this.f.push(K),this.I.fire(K.value),K.isOpen=!0}async $acceptTerminalProcessId(u,m){this.W(u)?._setProcessId(m)}async $startExtensionTerminal(u,m){const h=this.W(u);if(!h)return{message:(0,g.localize)(0,null,u)};h.isOpen||await new Promise(W=>{const K=this.onDidOpenTerminal(async z=>{z===h.value&&(K.dispose(),W())})});const P=this.g.get(u);P?P.startSendingEvents(m):this.j[u]={initialDimensions:m}}S(u,m){const h=new l.$Rc;h.add(m.onProcessReady(W=>this.a.$sendProcessReady(u,W.pid,W.cwd,W.windowsPty))),h.add(m.onDidChangeProperty(W=>this.a.$sendProcessProperty(u,W))),this.y.startBuffering(u,m.onProcessData),h.add(m.onProcessExit(W=>this.U(u,W))),this.g.set(u,m);const P=this.j[u];return P&&m instanceof E&&(m.startSendingEvents(P.initialDimensions),delete this.j[u]),h}$acceptProcessAckDataEvent(u,m){this.g.get(u)?.acknowledgeDataEvent(m)}$acceptProcessInput(u,m){this.g.get(u)?.input(m)}$acceptTerminalInteraction(u){const m=this.W(u);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(u,m){this.W(u)?.setSelection(m)}$acceptProcessResize(u,m,h){try{this.g.get(u)?.resize(m,h)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(u,m){this.g.get(u)?.shutdown(m)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(m=>this.a.$sendProcessProperty(u,{type:"cwd",value:m}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new D.$iK(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,m,h){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,h),this.a.$registerProfileProvider(m,u.identifier.value),new D.$iK(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(u,m,h){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,h),this.a.$registerQuickFixProvider(u,m),new D.$iK(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,m){const h=new c.$Xd().token;if(h.isCancellationRequested)return;const P=this.D.get(u);if(!P)return;const W=await P.provideTerminalQuickFixes(m,h);if(W===null||Array.isArray(W)&&W.length===0)return;const K=new l.$Rc;if(this.w.value=K,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.Q.converter,K):void 0;const z=[];for(const j of W){const O=i.TerminalQuickFix.from(j,this.Q.converter,K);O&&z.push(O)}return z}async $createContributedProfileTerminal(u,m){const h=new c.$Xd().token;let P=await this.C.get(u)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,m);return}this.createTerminalFromOptions(P.options,m)}}async $provideLinks(u,m){const h=this.W(u);if(!h)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const W=new c.$Xd;this.G.set(u,W);const K=[],z={terminal:h.value,line:m},j=[];for(const ie of this.z)j.push(t.Promises.withAsyncBody(async X=>{W.token.onCancellationRequested(()=>X({provider:ie,links:[]}));const Ee=await ie.provideTerminalLinks(z,W.token)||[];W.token.isCancellationRequested||X({provider:ie,links:Ee})}));const O=await Promise.all(j);if(W.token.isCancellationRequested)return[];const N=new Map;for(const ie of O)ie&&ie.links.length>0&&K.push(...ie.links.map(X=>{const Ee={id:v++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return N.set(Ee.id,{provider:ie.provider,link:X}),Ee}));return this.F.set(u,N),K}$activateLink(u,m){const h=this.F.get(u)?.get(m);h&&h.provider.handleTerminalLink(h.link)}U(u,m){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const h=this.h[u];h&&(h.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,m)}W(u){return this.X(this.f,u)}X(u,m){const h=this.Y(u,m);return h!==null?u[h]:null}Y(u,m){const h=u.findIndex(P=>P._id===m);return h===-1?null:h}getEnvironmentVariableCollection(u){let m=this.n.get(u.identifier.value);return m||(m=new r,this.$(u.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(u,m){const h=(0,k.$lr)(m.map),P=(0,k.$mr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(u,m.persistent,h.length===0?void 0:h,P)}$initEnvironmentVariableCollections(u){u.forEach(m=>{const h=m[0],P=new r(m[1]);this.$(h,P)})}$acceptDefaultProfile(u,m){const h=this.s;this.s=u,this.u=m,h?.path!==u.path&&this.N.fire(u.path)}$(u,m){this.n.set(u,m),m.onDidChangeCollection(()=>{this.Z(u,m)})}};e.$Jcc=n,e.$Jcc=n=qe([Ke(1,a.$DM),Ke(2,A.$hM)],n);class r{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Nd,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const m=this.h(u);let h=this.a.get(m);return h||(h=new s(this,u),this.a.set(m,h),h.onDidChangeCollection(()=>this.d.fire())),h}replace(u,m,h,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Replace,options:h??{applyAtProcessCreation:!0},scope:P})}append(u,m,h,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Append,options:h??{applyAtProcessCreation:!0},scope:P})}prepend(u,m,h,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Prepend,options:h??{applyAtProcessCreation:!0},scope:P})}f(u,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const h=this.g(u,m.scope),P=this.map.get(h),W=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==m.value||P.type!==m.type||P.options?.applyAtProcessCreation!==W.applyAtProcessCreation||P.options?.applyAtShellIntegration!==W.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const K=this.g(u,m.scope),z={variable:u,...m,options:W};this.map.set(K,z),this.d.fire()}}get(u,m){const h=this.g(u,m),P=this.map.get(h);return P?I(P):void 0}g(u,m){const h=this.h(m);return h.length?`${u}:::${h}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const m=new Map;for(const[h,P]of this.map)this.h(P.scope)===this.h(u)&&m.set(P.variable,I(P));return m}delete(u,m){const h=this.g(u,m);this.map.delete(h),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[m,h]of this.map)h.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(m);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,m){const h=this.h(m),P=this.descriptionMap.get(h);if(!P||P.description!==u){let W;typeof u=="string"?W=u:W=u?.value.split(`

`)[0];const K={description:W,scope:m};this.descriptionMap.set(h,K),this.d.fire()}}getDescription(u){const m=this.h(u);return this.descriptionMap.get(m)?.description}k(u){const m=this.h(u);this.descriptionMap.delete(m)}}class s{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,m){this.b=u,this.d=m,this.a=new y.$Nd}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,m,h){this.b.replace(u,m,h,this.d)}append(u,m,h){this.b.append(u,m,h,this.d)}prepend(u,m,h){this.b.prepend(u,m,h,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,m){this.b.getVariableMap(this.d).forEach((h,P)=>u.call(m,P,h,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends n{constructor(u,m){super(!1,u,m)}createTerminal(u,m,h){throw new R.$_}createTerminalFromOptions(u,m){throw new R.$_}};e.$Kcc=o,e.$Kcc=o=qe([Ke(0,a.$DM),Ke(1,A.$hM)],o);function w(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function d(S){return f.ThemeColor.isThemeColor(S)?S:void 0}function I(S){const u={...S};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Ae[255],Re([1,0,284,12,26,19,5,203,93,6,25,15,36,3,17,104,8,7,46,76,57,22]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=e.$Tdc=e.$Sdc=e.$Rdc=void 0;let n=class{constructor(z,j,O){this.k=O,this.d=new A.$Nd,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=z.getProxy(b.$gK.MainThreadTesting),this.j=new h(this.g),this.h=new w(this.g),j.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const ie=N,X=ie.tests[ie.tests.length-1].item.extId;return this.f.get(a.$_I.root(X))?.collection.tree.get(X)?.actual??(0,f.$tM)(N)}case 18:{const{extId:ie,message:X}=N;return{test:this.f.get(a.$_I.root(ie))?.collection.tree.get(ie)?.actual,message:t.TestMessage.to(X)}}default:return N}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await j.executeCommand("_testing.getExplorerSelection"),ie=X=>{const Ee=this.f.get(a.$_I.root(X));if(Ee)return a.$_I.isRoot(X)?Ee.controller:Ee.collection.tree.get(X)?.actual};return{include:N?.include.map(ie).filter(k.$Gf)||[],exclude:N?.exclude.map(ie).filter(k.$Gf)||[]}})}createTestController(z,j,O,N){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const ie=new g.$Rc,X=ie.add(new f.$wM(j,O,this.k));X.root.label=O;const Ee=new Map,Se=this.g,Pe={items:X.root.children,get label(){return O},set label(pe){O=pe,X.root.label=pe,Se.$updateController(j,{label:O})},get refreshHandler(){return N},set refreshHandler(pe){N=pe,Se.$updateController(j,{canRefresh:!!pe})},get id(){return j},createRunProfile:(pe,ue,oe,be,_,B)=>{let Z=(0,D.$Di)(pe);for(;Ee.has(Z);)Z++;return new P(this.g,Ee,j,Z,pe,ue,oe,be,_,B)},createTestItem(pe,ue,oe){return new f.$uM(j,pe,ue,oe)},createTestRun:(pe,ue,oe=!0)=>this.h.createTestRun(z,j,X,pe,ue,oe),invalidateTestResults:pe=>{if(pe===void 0)this.g.$markTestRetired(void 0);else{const ue=pe instanceof Array?pe:[pe];this.g.$markTestRetired(ue.map(oe=>a.$_I.fromExtHostTestItem(oe,j).toString()))}},set resolveHandler(pe){X.resolveHandler=pe},get resolveHandler(){return X.resolveHandler},dispose:()=>{ie.dispose()}};Se.$registerTestController(j,O,!!N),ie.add((0,g.$Qc)(()=>Se.$unregisterTestController(j)));const $e={controller:Pe,collection:X,profiles:Ee,extension:z};return this.f.set(j,$e),ie.add((0,g.$Qc)(()=>this.f.delete(j))),ie.add(X.onDidGenerateDiff(pe=>Se.$publishDiff(j,pe.map(E.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(z,j=T.CancellationToken.None){const O=d(z);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:z.include?.map(ie=>a.$_I.fromExtHostTestItem(ie,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:W[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:z.exclude?.map(ie=>ie.id)},j)}$syncTests(){for(const{collection:z}of this.f.values())z.flushDiff();return Promise.resolve()}$provideFileCoverage(z,j,O){return(0,y.$rb)(this.h.trackers,ie=>ie.id===z?ie.getCoverage(j):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(z,j,O,N){return(0,y.$rb)(this.h.trackers,X=>X.id===z?X.getCoverage(j):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(z,j){this.f.get(z)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(z,j){await this.f.get(z)?.controller.refreshHandler?.(j)}$publishTestResults(z){this.results=Object.freeze(z.map(j=>(0,R.$8m)(t.TestResults.to(j))).concat(this.results).sort((j,O)=>O.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(z,j){const O=this.f.get(a.$_I.fromString(z).controllerId)?.collection;O&&(await O.expand(z,j<0?1/0:j),O.flushDiff())}$acceptDiff(z){this.j.applyDiff(z.map(E.TestsDiffOp.deserialize))}async $runControllerTests(z,j){return Promise.all(z.map(O=>this.l(O,!1,j)))}async $startContinuousRun(z,j){const O=new T.$Xd(j),N=await Promise.all(z.map(ie=>this.l(ie,!0,O.token)));return!j.isCancellationRequested&&!N.some(ie=>ie.error)&&await new Promise(ie=>j.onCancellationRequested(ie)),O.dispose(!0),N}async l(z,j,O){const N=this.f.get(z.controllerId);if(!N)return{};const{collection:ie,profiles:X,extension:Ee}=N,Se=X.get(z.profileId);if(!Se)return{};const Pe=z.testIds.map(oe=>ie.tree.get(oe)).filter(k.$Gf),$e=z.excludeExtIds.map(oe=>N.collection.tree.get(oe)).filter(k.$Gf).filter(oe=>Pe.some(be=>be.fullId.compare(oe.fullId)===2));if(!Pe.length)return{};const pe=new i.$QL(Pe.some(oe=>oe.actual instanceof f.$vM)?void 0:Pe.map(oe=>oe.actual),$e.map(oe=>oe.actual),Se,j),ue=(0,E.$bJ)(z)&&this.h.prepareForMainThreadTestRun(pe,I.fromInternal(z,N.collection),Ee,O);try{return await Se.runHandler(pe,O),{}}catch(oe){return{error:String(oe)}}finally{ue&&(ue.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(ue.onEnd),ue.dispose())}}$cancelExtensionTestRun(z){z===void 0?this.h.cancelAllRuns():this.h.cancelRunById(z)}};e.$Rdc=n,e.$Rdc=n=qe([Ke(0,p.$hM)],n);const r=1e4;var s;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(s||(s={}));class o extends g.$Sc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(z,j,O,N){super(),this.s=z,this.u=j,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Nd),this.onEnd=this.m.event,this.j=this.B(new T.$Xd(N));const ie=this.B(new M.$6g(()=>this.y(),r));this.B(this.j.token.onCancellationRequested(()=>ie.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(z){return this.g.get(z)?.coverage}createRun(z){const j=this.s.id,O=this.s.controllerId,N=(0,c.$eg)(),ie=new S(this.u,j,N),X=$e=>(pe,...ue)=>{if(Se){console.warn(`Setting the state of test "${pe.id}" is a no-op after the run ends.`);return}this.s.isIncluded(pe)&&(this.C(pe),$e(pe,...ue))},Ee=($e,pe)=>{const ue=pe instanceof Array?pe.map(t.TestMessage.from):[t.TestMessage.from(pe)];if(ue.some(oe=>oe.contextValue!==void 0)&&(0,v.$eF)(this.w,"testMessageContextValue"),$e.uri&&$e.range){const oe={range:t.Range.from($e.range),uri:$e.uri};for(const be of ue)be.location=be.location||oe}this.u.$appendTestMessagesInRun(j,N,a.$_I.fromExtHostTestItem($e,O).toString(),ue)};let Se=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:z,get coverageProvider(){return ie.coverageProvider},set coverageProvider($e){ie.coverageProvider=$e},enqueued:X($e=>{this.u.$updateTestStateInRun(j,N,a.$_I.fromExtHostTestItem($e,O).toString(),1)}),skipped:X($e=>{this.u.$updateTestStateInRun(j,N,a.$_I.fromExtHostTestItem($e,O).toString(),5)}),started:X($e=>{this.u.$updateTestStateInRun(j,N,a.$_I.fromExtHostTestItem($e,O).toString(),2)}),errored:X(($e,pe,ue)=>{Ee($e,pe),this.u.$updateTestStateInRun(j,N,a.$_I.fromExtHostTestItem($e,O).toString(),6,ue)}),failed:X(($e,pe,ue)=>{Ee($e,pe),this.u.$updateTestStateInRun(j,N,a.$_I.fromExtHostTestItem($e,O).toString(),4,ue)}),passed:X(($e,pe)=>{this.u.$updateTestStateInRun(j,N,a.$_I.fromExtHostTestItem($e,this.s.controllerId).toString(),3,pe)}),appendOutput:($e,pe,ue)=>{Se||(ue&&(this.s.isIncluded(ue)?this.C(ue):ue=void 0),this.u.$appendOutputToRun(j,N,C.$be.fromString($e),pe&&t.location.from(pe),ue&&a.$_I.fromExtHostTestItem(ue,O).toString()))},end:()=>{Se||(Se=!0,this.u.$finishedTestRunTask(j,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:ie}),this.u.$startedTestRunTask(j,{id:N,name:z,running:!0}),Pe}y(){for(const{run:z}of this.g.values())z.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(z){if(!(z instanceof f.$uM))throw new $.$_L(z.id);if(this.h.has(a.$_I.fromExtHostTestItem(z,this.s.controllerId).toString()))return;const j=[],O=this.s.colllection.root;for(;;){const N=t.TestItem.from(z);if(j.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),z===O))break;z=z.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class w{get trackers(){return this.d.values()}constructor(z){this.f=z,this.d=new Map}prepareForMainThreadTestRun(z,j,O,N){return this.g(z,j,O,N)}cancelRunById(z){for(const j of this.d.values())if(j.id===z){j.cancel();return}}cancelAllRuns(){for(const z of this.d.values())z.cancel()}createTestRun(z,j,O,N,ie,X){const Ee=this.d.get(N);if(Ee)return Ee.createRun(ie);const Se=I.fromPublic(j,O,N,X),Pe=d(N);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!N.continuous,profile:Pe&&{group:W[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(pe=>a.$_I.fromExtHostTestItem(pe,O.root.id).toString())??[],id:Se.id,include:N.include?.map(pe=>a.$_I.fromExtHostTestItem(pe,O.root.id).toString())??[O.root.id],persist:X});const $e=this.g(N,Se,z);return A.Event.once($e.onEnd)(()=>{this.f.$finishedExtensionTestRun(Se.id),$e.dispose()}),$e.createRun(ie)}g(z,j,O,N){const ie=new o(j,this.f,O,N);return this.d.set(z,ie),A.Event.once(ie.onEnd)(()=>this.d.delete(z)),ie}}e.$Sdc=w;const d=K=>{if(K.profile){if(!(K.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class I{static fromPublic(z,j,O,N){return new I(z,(0,c.$eg)(),O.include?.map(ie=>a.$_I.fromExtHostTestItem(ie,z).toString())??[z],O.exclude?.map(ie=>a.$_I.fromExtHostTestItem(ie,z).toString())??[],N,j)}static fromInternal(z,j){return new I(z.controllerId,z.runId,z.testIds,z.excludeExtIds,!0,j)}constructor(z,j,O,N,ie,X){this.controllerId=z,this.id=j,this.isPersisted=ie,this.colllection=X,this.d=O.map(Ee=>Ee+"\0"),this.f=N.map(Ee=>Ee+"\0")}isIncluded(z){const j=a.$_I.fromExtHostTestItem(z,this.controllerId).toString()+"\0";for(const O of this.f)if(j===O||j.startsWith(O))return!1;for(const O of this.d)if(j===O||j.startsWith(O))return!0;return!1}}e.$Tdc=I;class S{set coverageProvider(z){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");z&&(this.d=z,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(z,j,O){this.g=z,this.h=j,this.j=O}async provideFileCoverage(z){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(z))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(z,j){const O=await this.f;let N=O?.[z];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[z]=await this.d.resolveFileCoverage?.(N,j)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(z){this.j=z,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(z){this.d.add(z)}update(z){Object.assign(z.revived,t.TestItem.toPlain(z.item)),this.d.has(z)||this.f.add(z)}remove(z){if(this.d.has(z)){this.d.delete(z);return}this.f.delete(z);const j=a.$_I.parentId(z.item.extId);if(j&&this.h.has(j.toString())){this.h.add(z.item.extId);return}this.g.add(z)}getChangeEvent(){const{d:z,f:j,g:O}=this;return{get added(){return[...z].map(N=>N.revived)},get updated(){return[...j].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class m extends E.$gJ{constructor(){super(...arguments),this.s=new A.$Nd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(z){return this.f.get(z)}getMirroredTestDataByReference(z){return this.f.get(z.id)}q(z,j){return{...z,revived:t.TestItem.toPlain(z.item),depth:j?j.depth+1:0,children:new Set}}p(){return new u(this.s)}}class h{constructor(z){this.f=z}checkout(){this.d||(this.d=this.g());const z=this.d;return z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,get tests(){return[...z.tests.rootTests].map(j=>j.revived)},dispose:(0,l.$db)(()=>{--z.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(z){return this.d?.tests.getMirroredTestDataByReference(z)}applyDiff(z){this.d?.tests.apply(z)}g(){const z=new m;return this.f.$subscribeToDiffs(),{observers:0,tests:z}}}class P{#e;#t;get label(){return this.f}set label(z){z!==this.f&&(this.f=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:z}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(z){z!==this.h&&(this.h=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:z}))}get isDefault(){return this.g}set isDefault(z){z!==this.g&&(this.g=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:z}))}get tag(){return this._tag}set tag(z){z?.id!==this._tag?.id&&(this._tag=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:z?t.TestTag.namespace(this.controllerId,z.id):null}))}get configureHandler(){return this.d}set configureHandler(z){z!==this.d&&(this.d=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!z}))}constructor(z,j,O,N,ie,X,Ee,Se=!1,Pe=void 0,$e=!1){this.controllerId=O,this.profileId=N,this.f=ie,this.kind=X,this.runHandler=Ee,this.g=Se,this._tag=Pe,this.h=$e,this.#e=z,this.#t=j,j.set(N,this);const pe=W[X];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:ie,group:pe,isDefault:Se,hasConfigurationHandler:!1,supportsContinuousRun:$e})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Udc=P;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[256],Re([1,0,18,9,5,3,105,8,7]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class g{constructor(k,c){this.i=c,this.a=new C.$Nd({onListenerError:M.$2}),this.b=new C.$Nd({onListenerError:M.$2}),this.c=new C.$Nd({onListenerError:M.$2}),this.d=new C.$Nd({onListenerError:M.$2}),this.f=new C.$Nd({onListenerError:M.$2}),this.g=new C.$Nd({onListenerError:M.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(T.$gK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const c=this.i.allEditors();return k?c:c.map(b=>b.value)}async showTextDocument(k,c,b){let p;typeof c=="number"?p={position:l.ViewColumn.from(c),preserveFocus:b}:typeof c=="object"?p={position:l.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?l.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:p={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(k.uri,p),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,c){return new A.$oM(this.h,k,c).value}$acceptEditorPropertiesChanged(k,c){const b=this.i.getEditor(k);if(!b)throw new Error("unknown text editor");if(c.options&&b._acceptOptions(c.options),c.selections){const p=c.selections.selections.map(l.Selection.to);b._acceptSelections(p)}if(c.visibleRanges){const p=y.$Hb(c.visibleRanges.map(l.Range.to));b._acceptVisibleRanges(p)}if(c.options&&this.b.fire({textEditor:b.value,options:{...c.options,lineNumbers:l.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const p=D.TextEditorSelectionChangeKind.fromValue(c.selections.source),f=c.selections.selections.map(l.Selection.to);this.a.fire({textEditor:b.value,selections:f,kind:p})}if(c.visibleRanges){const p=y.$Hb(c.visibleRanges.map(l.Range.to));this.c.fire({textEditor:b.value,visibleRanges:p})}}$acceptEditorPositionData(k){for(const c in k){const b=this.i.getEditor(c);if(!b)throw new Error("Unknown text editor");const p=l.ViewColumn.to(k[c]);b.value.viewColumn!==p&&(b._acceptViewColumn(p),this.d.fire({textEditor:b.value,viewColumn:p}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$0cc=g}),define(Ae[257],Re([1,0,2,4,3,6,7,8,21,15]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=void 0,e.$Ldc=(0,M.$Ph)("IExtHostTimeline");class R{constructor(b,p){this.b=new Map,this.c=new Map,this.a=b.getProxy(C.$gK.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&D.$6l.equals(t,this.b.get(f.source)?.extension)){const i=f.uri===void 0?void 0:y.URI.revive(f.uri);return this.c.get(f.source)?.get(k(i))?.get(f.handle)}else return;return f}})}async $getTimeline(b,p,f,t){return this.b.get(b)?.provider.provideTimeline(y.URI.revive(p),f,t)}registerTimelineProvider(b,p,f,t){const i=new T.$Rc,a=this.d(p.id,t,i).bind(this);let $;p.onDidChange&&($=p.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:p.id}),this));const E=this.c;return this.f({...p,scheme:b,onDidChange:void 0,async provideTimeline(v,n,r){n?.resetCache&&(i.clear(),E.get(p.id)?.clear());const s=await p.provideTimeline(v,n,r);if(s==null)return;const o=a(v,n);return{...s,source:p.id,items:s.items.map(o)}},dispose(){for(const v of E.values())v.get(p.id)?.clear();$?.dispose(),i.dispose()}},f)}d(b,p,f){return(t,i)=>{let a;if(i?.cacheResults){let $=this.c.get(b);$===void 0&&($=new Map,this.c.set(b,$));const E=k(t);a=$.get(E),a===void 0&&(a=new Map,$.set(E,a))}return $=>{const{iconPath:E,...v}=$,n=`${b}|${$.id??$.timestamp}`;a?.set(n,$);let r,s,o;$.iconPath&&(E instanceof A.$cL?o={id:E.id,color:E.color}:y.URI.isUri(E)?(r=E,s=E):{light:r,dark:s}=E);let w;return A.$IK.isMarkdownString(v.tooltip)?w=l.MarkdownString.from(v.tooltip):(0,g.$yf)(v.tooltip)?w=v.tooltip:A.$IK.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=l.MarkdownString.from(v.detail)):(0,g.$yf)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=v.detail),{...v,id:v.id??void 0,handle:n,source:b,command:$.command?p.toInternal($.command,f):void 0,icon:r,iconDark:s,themeIcon:o,tooltip:w,accessibilityInformation:$.accessibilityInformation}}}}f(b,p){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:p}),(0,T.$Qc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Mdc=R;function k(c){return c?.toString()}}),define(Ae[86],Re([1,0,19,5,6,157,4,14,184,3,27,17,7]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7vb=e.$6vb=e.TunnelDtoConverter=void 0;class b extends D.$gv{}var p;(function(t){function i($){return{remoteAddress:$.remoteAddress,localAddress:$.localAddress,public:!!$.public,privacy:$.privacy??($.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:$.protocol}}t.fromApiTunnel=i;function a($){return{remoteAddress:{host:$.tunnelRemoteHost,port:$.tunnelRemotePort},localAddress:$.localAddress,public:$.privacy!==D.TunnelPrivacyId.ConstantPrivate&&$.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:$.privacy,protocol:$.protocol}}t.fromServiceTunnel=a})(p||(e.TunnelDtoConverter=p={})),e.$6vb=(0,A.$Ph)("IExtHostTunnelService");let f=class extends C.$Sc{constructor(i,a,$){super(),this.s=$,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(g.$gK.MainThreadTunnelService)}async openTunnel(i,a){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const $=await this.a.$openTunnel(a,i.displayName);if($){const E=new b($.remoteAddress,$.localAddress,()=>this.a.$closeTunnel($.remoteAddress));return this.B(E),E}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,a){const $=this.u();return this.r.set($,{selector:i,provider:a}),this.a.$registerPortsAttributesProvider(i,$),new c.$iK(()=>{this.r.delete($),this.a.$unregisterPortsAttributesProvider($)})}async $providePortAttributes(i,a,$,E,v){const n=[];for(const s of i){const o=this.r.get(s);if(!o)return[];n.push(...await Promise.all(a.map(async w=>{let d;try{d=await o.provider.providePortAttributes({port:w,pid:$,commandLine:E},v)}catch{d=await o.provider.providePortAttributes(w,$,E,v)}return{providedAttributes:d,port:w}})))}const r=n.filter(s=>!!s.providedAttributes);return r.length>0?r.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(E,v)=>await i.provideTunnel(E,v,new y.$Xd().token)??void 0;const $=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider($),Promise.resolve((0,C.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,a){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const $=i.tunnelFactory??(a?this.w(a):void 0);if($){this.b=$;let E=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const v=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider(v)}}else this.b=void 0;return(0,C.$Qc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,a){if(this.g.has(i.host)){const $=this.g.get(i.host);$.has(i.port)&&(a&&$.get(i.port).disposeListener.dispose(),await $.get(i.port).tunnel.dispose(),$.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,a){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const $=this.b(i,a);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),$!==void 0){const E=await $;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),E===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const v=this.B(E.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(E.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:E,disposeListener:v}),p.fromApiTunnel(E)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch($){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),$ instanceof Error)return $.message}}async $applyCandidateFilter(i){const a=await Promise.all(i.map(E=>this.f(E.host,E.port,E.detail??""))),$=i.filter((E,v)=>a[v]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(E=>E.port).join(", ")} to ${$.map(E=>E.port).join(", ")}`),$}};e.$7vb=f,e.$7vb=f=qe([Ke(0,k.$hM),Ke(1,R.$xM),Ke(2,l.$0i)],f)}),define(Ae[258],Re([1,0,6,13,2,3]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(T.$gK.MainThreadUriOpeners)}registerExternalUriOpener(D,g,R,k){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const c=k.schemes.find(b=>!A.a.has(b));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this.c.set(g,R),this.b.$registerUriOpener(g,k.schemes,D,k.label),(0,y.$Qc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(D,g,R){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const c=C.URI.revive(g);return k.canOpenExternalUri(c,R)}async $openUri(D,g,R){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(C.URI.revive(g.resolvedUri),{sourceUri:C.URI.revive(g.sourceUri)},R)}}e.$Vdc=A}),define(Ae[259],Re([1,0,3,2,6,9,21]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class l{static{this.a=0}constructor(g){this.c=new A.$7l,this.d=new Map,this.b=g.getProxy(y.$gK.MainThreadUrls)}registerUriHandler(g,R){const k=g.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const c=l.a++;return this.c.add(k),this.d.set(c,R),this.b.$registerUriHandler(c,k,g.displayName||g.name),(0,C.$Qc)(()=>{this.c.delete(k),this.d.delete(c),this.b.$unregisterUriHandler(c)})}$handleExternalUri(g,R){const k=this.d.get(g);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(R))}catch(c){(0,T.$1)(c)}return Promise.resolve(void 0)}async createAppUri(g){return M.URI.revive(await this.b.$createAppUri(g))}}e.$_cc=l}),define(Ae[64],Re([1,0,5,6,13,25,2,169,191,77,3]),function(ye,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=e.$ddc=e.$cdc=e.$bdc=e.$adc=void 0;class k{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(E,v,n,r,s,o,w){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new y.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$Nd,this._onDidDispose=this.#h.event,this.#e=E,this.#t=v,this.#r=n,this.#l=r,this.#u=s,this.#n=o,this.#c=c(o),this.#d=b(o),this.#i=w}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return this.#a=!0,(0,g.$9ob)(E,this.#l)}get cspSource(){const E=this.#n.extensionLocation;if(E.scheme===C.Schemas.https||E.scheme===C.Schemas.http){let v=E.toString();return v.endsWith("/")||(v+="/"),v+" "+g.$8ob}return g.$8ob}get html(){return this.a(),this.#s}set html(E){this.a(),this.#s!==E&&(this.#s=E,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(E)))}get options(){return this.a(),this.#r}set options(E){this.a(),T.$$m(this.#r,E)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,E)),this.#r=E}async postMessage(E){if(this.#o)return!1;const v=(0,D.$zcb)(E,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,v.message,...v.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(E){if(!this.#d)return E;const v=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,s,o,w,d,I)=>{const S=A.URI.from({scheme:w||"file",path:decodeURIComponent(d)}),u=(0,g.$9ob)(S,{isRemote:v,authority:n}).toString();return`${s}${u}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,s,o,w,d,I)=>{const S=A.URI.from({scheme:w||"file",path:decodeURIComponent(d)}),u=(0,g.$9ob)(S,{isRemote:v,authority:n}).toString();return`${s}${u}${I}`})}}e.$adc=k;function c($){try{const E=(0,l.$Oo)((0,l.$No)($.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.$bdc=c;function b($){try{const E=(0,l.$Oo)((0,l.$No)($.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class p extends M.$Sc{constructor(E,v,n,r,s){super(),this.c=v,this.f=n,this.g=r,this.h=s,this.b=new Map,this.a=E.getProxy(R.$gK.MainThreadWebviews)}dispose(){super.dispose();for(const E of this.b.values())E.dispose();this.b.clear()}$onMessage(E,v,n){const r=this.j(E);if(r){const{message:s}=(0,D.$Acb)(v,n.value);r._onMessageEmitter.fire(s)}}$onMissingCsp(E,v){this.g.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,v,n){const r=new k(E,this.a,i(v),this.c,this.f,n,this.h);this.b.set(E,r);const s=r._onDidDispose(()=>{s.dispose(),this.deleteWebview(E)});return r}deleteWebview(E){this.b.delete(E)}j(E){return this.b.get(E)}}e.$cdc=p;function f($){return{id:$.identifier,location:$.extensionLocation}}e.$ddc=f;function t($,E,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||a($,E)}}e.$edc=t;function i($){return{enableCommandUris:$.enableCommandUris,enableScripts:$.enableScripts,enableForms:$.enableForms,portMapping:$.portMapping,localResourceRoots:$.localResourceRoots?.map(E=>A.URI.from(E))}}function a($,E){return[...(E?.getWorkspaceFolders()||[]).map(v=>v.uri),$.extensionLocation]}}),define(Ae[260],Re([1,0,19,93,6,13,24,2,8,64,74,3,7]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class b{constructor(r,s){this.document=r,this.b=s,this.a=1,this.c=new R.$9bc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,s){await this.f(r).undo(),s||this.disposeBackup()}async redo(r,s){await this.f(r).redo(),s||this.disposeBackup()}disposeEdits(r){for(const s of r)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=v(this.document.uri)+this.a++;return(0,A.$vg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const s=this.c.get(r,0);if(!s)throw new Error("No edit found");return s}}class p{constructor(){this.a=new Map}get(r,s){return this.a.get(this.b(r,s))}add(r,s,o){const w=this.b(r,s.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${r} resource:${s.uri}`);const d=new b(s,o);return this.a.set(w,d),d}delete(r,s){const o=this.b(r,s.uri);this.a.delete(o)}b(r,s){return`${r}@@@${s}`}}var f;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(r,s,o){return this.b(0,r,s,o)}addCustomProvider(r,s,o){return this.b(1,r,s,o)}get(r){return this.a.get(r)}b(r,s,o,w){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:r,extension:o,provider:w}),new c.$iK(()=>this.a.delete(s))}}class i{constructor(r,s,o,w,d){this.d=s,this.f=o,this.g=w,this.h=d,this.b=new t,this.c=new p,this.a=r.getProxy(k.$gK.MainThreadCustomEditors)}registerCustomEditorProvider(r,s,o,w){const d=new C.$Rc;return $(o)?(d.add(this.b.addTextProvider(s,r,o)),this.a.$registerTextEditorProvider((0,g.$ddc)(r),s,w.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,g.$bdc)(r))):(d.add(this.b.addCustomProvider(s,r,o)),a(o)&&d.add(o.onDidChangeCustomDocument(I=>{const S=this.i(s,I.document.uri);if(E(I)){const u=S.addEdit(I);this.a.$onDidEdit(I.document.uri,s,u,I.label)}else this.a.$onContentChange(I.document.uri,s)})),this.a.$registerCustomEditorProvider((0,g.$ddc)(r),s,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,g.$bdc)(r))),c.$iK.from(d,new c.$iK(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(r,s,o,w,d){const I=this.b.get(s);if(!I)throw new Error(`No provider found for '${s}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${s}'`);const S=l.URI.revive(r),u=await I.provider.openCustomDocument(S,{backupId:o,untitledDocumentData:w?.buffer},d);let m;return a(I.provider)&&this.f&&(m=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(s,u,m),{editable:a(I.provider)}}async $disposeCustomDocument(r,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const w=l.URI.revive(r),{document:d}=this.i(s,w);this.c.delete(s,d),d.dispose()}async $resolveCustomEditor(r,s,o,w,d,I){const S=this.b.get(o);if(!S)throw new Error(`No provider found for '${o}'`);const u=D.ViewColumn.to(d),m=this.g.createNewWebview(s,w.contentOptions,S.extension),h=this.h.createNewWebviewPanel(s,o,w.title,u,w.options,m,w.active),P=l.URI.revive(r);switch(S.type){case 1:{const{document:W}=this.i(o,P);return S.provider.resolveCustomEditor(W,h,I)}case 0:{const W=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(W,h,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,s,o){this.i(s,r).disposeEdits(o)}async $onMoveCustomEditor(r,s,o){const w=this.b.get(o);if(!w)throw new Error(`No provider found for '${o}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const d=this.h.getWebviewPanel(r);if(!d)throw new Error("No webview found");const I=l.URI.revive(s),S=this.d.getDocument(I);await w.provider.moveCustomTextEditor(S,d,y.CancellationToken.None)}async $undo(r,s,o,w){return this.i(s,r).undo(o,w)}async $redo(r,s,o,w){return this.i(s,r).redo(o,w)}async $revert(r,s,o){const w=this.i(s,r);await this.j(s).revertCustomDocument(w.document,o),w.disposeBackup()}async $onSave(r,s,o){const w=this.i(s,r);await this.j(s).saveCustomDocument(w.document,o),w.disposeBackup()}async $onSaveAs(r,s,o,w){const d=this.i(s,r);return this.j(s).saveCustomDocumentAs(d.document,l.URI.revive(o),w)}async $backup(r,s,o){const w=this.i(s,r),I=await this.j(s).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},o);return w.updateBackup(I),I.id}i(r,s){const o=this.c.get(r,l.URI.revive(s));if(!o)throw new Error("No custom document found");return o}j(r){const o=this.b.get(r)?.provider;if(!o||!a(o))throw new Error("Custom document is not editable");return o}}e.$Pdc=i;function a(n){return!!n.onDidChangeCustomDocument}function $(n){return typeof n.resolveCustomTextEditor=="function"}function E(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function v(n){const r=n.scheme===T.Schemas.file||n.scheme===T.Schemas.untitled?n.fsPath:n.toString();return(0,M.$Di)(r)+""}}),define(Ae[261],Re([1,0,5,6,2,36,8,64,3,7]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class R extends M.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(p,f,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new y.$Nd),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$Nd),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=f,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(p){this.c(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#s}set iconPath(p){this.c(),this.#s!==p&&(this.#s=p,this.#t.$setIconPath(this.#e,C.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(p){this.#c||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#a=p.active,this.#o=p.visible,this.#r=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:A.ViewColumn.from(p),preserveFocus:!!f})}c(){if(this.#c)throw new Error("Webview is disposed")}}class k extends M.$Sc{static c(){return(0,T.$eg)()}constructor(p,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=p.getProxy(D.$gK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,f,t,i,a={}){const $=typeof i=="object"?i.viewColumn:i,E={viewColumn:A.ViewColumn.from($),preserveFocus:typeof i=="object"&&!!i.preserveFocus},v=(0,l.$bdc)(p),n=k.c();this.f.$createWebviewPanel((0,l.$ddc)(p),n,f,{title:t,panelOptions:c(a),webviewOptions:(0,l.$edc)(p,this.m,a),serializeBuffersForPostMessage:v},E);const r=this.j.createNewWebview(n,a,p);return this.createNewWebviewPanel(n,f,t,$,a,r,!0)}$onDidChangeWebviewPanelViewStates(p){const f=Object.keys(p);f.sort((t,i)=>{const a=p[t],$=p[i];return a.active?1:$.active?-1:+a.visible-+$.visible});for(const t of f){const i=this.getWebviewPanel(t);if(!i)continue;const a=p[t];i._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:p}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,l.$bdc)(p)}),new g.$iK(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(p,f,t,i){const a=this.h.get(f);if(!a)throw new Error(`No serializer found for '${f}'`);const{serializer:$,extension:E}=a,v=this.j.createNewWebview(p,t.webviewOptions,E),n=this.createNewWebviewPanel(p,f,t.title,i,t.panelOptions,v,t.active);await $.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(p,f,t,i,a,$,E){const v=new R(p,this.f,$,{viewType:f,title:t,viewColumn:i,panelOptions:a,active:E});return this.g.set(p,v),v}getWebviewPanel(p){return this.g.get(p)}}e.$Odc=k;function c(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ae[262],Re([1,0,5,6,64,8,3,7]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class D extends M.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(k,c,b,p,f,t){super(),this.#u=!1,this.#a=this.B(new y.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new y.$Nd),this.onDidDispose=this.#c.event,this.#i=b,this.#s=p,this.#e=k,this.#t=c,this.#l=f,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#r}set description(k){this.a(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#u||(this.#n=k,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(k){this.a(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=T.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(k,c){this.d=c,this.b=new Map,this.c=new Map,this.a=k.getProxy(A.$gK.MainThreadWebviewViews)}registerWebviewViewProvider(k,c,b,p){if(this.b.has(c))throw new Error(`View provider for '${c}' already registered`);return this.b.set(c,{provider:b,extension:k}),this.a.$registerWebviewViewProvider((0,C.$ddc)(k),c,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$bdc)(k)}),new l.$iK(()=>{this.b.delete(c),this.a.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(k,c,b,p,f){const t=this.b.get(c);if(!t)throw new Error(`No view provider found for '${c}'`);const{provider:i,extension:a}=t,$=this.d.createNewWebview(k,{},a),E=new D(k,this.a,c,b,$,!0);this.c.set(k,E),await i.resolveWebviewView(E,{state:p},f)}async $onDidChangeWebviewViewVisibility(k,c){this.e(k)._setVisible(c)}async $disposeWebviewView(k){const c=this.e(k);this.c.delete(k),c.dispose(),this.d.deleteWebview(k)}e(k){const c=this.c.get(k);if(!c)throw new Error("No webview found");return c}}e.$Ndc=g}),define(Ae[108],Re([1,0,5,3,2,13,16,4,17,22]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=e.$fdc=void 0;let k=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(b){const p=this.d;return{get focused(){return p.focused},get active(){return(0,g.$eF)(b,"windowActivity"),p.active}}}constructor(b){this.c=new y.$Nd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=b.getProxy(M.$gK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:f})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,p){p!==this.d[b]&&(this.d={...this.d,[b]:p},this.c.fire(this.d))}openUri(b,p){let f;if(typeof b=="string"){f=b;try{b=C.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$Be)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,f,p)}async asExternalUri(b,p){if((0,A.$Be)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(b,p);return C.URI.from(f)}};e.$fdc=k,e.$fdc=k=R=qe([Ke(0,D.$hM)],k),e.$gdc=(0,l.$Ph)("IExtHostWindow")}),define(Ae[263],Re([1,0,228,27,17]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;let T=class extends y.$gec{constructor(l,D){super(l,D)}f(l,D,g){D.apply(console,g)}};e.$ngc=T,e.$ngc=T=qe([Ke(0,C.$hM),Ke(1,M.$xM)],T)}),define(Ae[264],Re([1,0,12,26,19,9,5,6,132,216,47]),function(ye,e,y,M,C,T,A,l,D,g,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$t4b=e.ResponsiveState=e.RequestInitiator=e.$s4b=e.$r4b=void 0;function c(h,P){try{return JSON.stringify(h,P)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class f{constructor(P,W){this.jsonString=P,this.referencedBuffers=W}}function t(h,P=null,W=!1){const K=[];return{jsonString:(W?c:JSON.stringify)(h,(j,O)=>{if(typeof O>"u")return p;if(typeof O=="object"){if(O instanceof M.$be){const N=K.push(O)-1;return{[b]:N}}if(P)return P(j,O)}return O}),referencedBuffers:K}}e.$r4b=t;function i(h,P,W){return JSON.parse(h,(K,z)=>{if(z){const j=z[b];if(typeof j=="number")return P[j];if(W&&z.$mid===1)return W.transformIncoming(z)}return z})}e.$s4b=i;function a(h,P){return JSON.stringify(h,P)}function $(h){return h?(P,W)=>W&&W.$mid===1?h.transformOutgoing(W):W:null}var E;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var v;(function(h){h[h.Responsive=0]="Responsive",h[h.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const n=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends l.$Sc{static{k=r}static{this.a=3*1e3}constructor(P,W=null,K=null){super(),this[k]=!0,this.b=this.B(new A.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=W,this.g=K,this.h=$(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,j=R.$nv.count;z<j;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$6g(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const W=this.w[P];delete this.w[P],W.resolveErr(T.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,D.$Om)(P,this.g):P}getProxy(P){const{nid:W,sid:K}=P;return this.s[W]||(this.s[W]=this.J(W,K)),this.s[W]}J(P,W){const K={get:(z,j)=>(typeof j=="string"&&!z[j]&&j.charCodeAt(0)===36&&(z[j]=(...O)=>this.U(P,j,O)),j===s?W:z[j])};return new Proxy(Object.create(null),K)}set(P,W){return this.m[P.nid]=W,W}assertRegistered(P){for(let W=0,K=P.length;W<K;W++){const z=P[W];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(P){if(this.j)return;const W=P.byteLength,K=d.read(P,0),z=K.readUInt8(),j=K.readUInt32();switch(z){case 1:case 2:{let{rpcId:O,method:N,args:ie}=S.deserializeRequestJSONArgs(K);this.g&&(ie=(0,D.$Om)(ie,this.g)),this.M(W,j,O,N,ie,z===2);break}case 3:case 4:{let{rpcId:O,method:N,args:ie}=S.deserializeRequestMixedArgs(K);this.g&&(ie=(0,D.$Om)(ie,this.g)),this.M(W,j,O,N,ie,z===4);break}case 5:{this.f?.logIncoming(W,j,0,"ack"),this.G(j);break}case 6:{this.N(W,j);break}case 7:{this.O(W,j,void 0);break}case 9:{let O=S.deserializeReplyOKJSON(K);this.g&&(O=(0,D.$Om)(O,this.g)),this.O(W,j,O);break}case 10:{const O=S.deserializeReplyOKJSONWithBuffers(K,this.g);this.O(W,j,O);break}case 8:{const O=S.deserializeReplyOKVSBuffer(K);this.O(W,j,O);break}case 11:{let O=S.deserializeReplyErrError(K);this.g&&(O=(0,D.$Om)(O,this.g)),this.P(W,j,O);break}case 12:{this.P(W,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,W,K,z,j,O){this.f?.logIncoming(P,W,1,`receiveRequest ${(0,R.$pv)(K)}.${z}(`,j);const N=String(W);let ie,X;if(O){const Se=new C.$Xd;j.push(Se.token),ie=this.Q(K,z,j),X=()=>Se.cancel()}else ie=this.Q(K,z,j),X=n;this.u[N]=X;const Ee=S.serializeAcknowledged(W);this.f?.logOutgoing(Ee.byteLength,W,1,"ack"),this.c.send(Ee),ie.then(Se=>{delete this.u[N];const Pe=S.serializeReplyOK(W,Se,this.h);this.f?.logOutgoing(Pe.byteLength,W,1,"reply:",Se),this.c.send(Pe)},Se=>{delete this.u[N];const Pe=S.serializeReplyErr(W,Se);this.f?.logOutgoing(Pe.byteLength,W,1,"replyErr:",Se),this.c.send(Pe)})}N(P,W){this.f?.logIncoming(P,W,1,"receiveCancel");const K=String(W);this.u[K]?.()}O(P,W,K){this.f?.logIncoming(P,W,0,"receiveReply:",K);const z=String(W);if(!this.w.hasOwnProperty(z))return;const j=this.w[z];delete this.w[z],j.resolveOk(K)}P(P,W,K){this.f?.logIncoming(P,W,0,"receiveReplyErr:",K);const z=String(W);if(!this.w.hasOwnProperty(z))return;const j=this.w[z];delete this.w[z];let O;K&&(K.$isError?(O=new Error,O.name=K.name,O.message=K.message,O.stack=K.stack):O=K),j.resolveErr(O)}Q(P,W,K){try{return Promise.resolve(this.S(P,W,K))}catch(z){return Promise.reject(z)}}S(P,W,K){const z=this.m[P];if(!z)throw new Error("Unknown actor "+(0,R.$pv)(P));const j=z[W];if(typeof j!="function")throw new Error("Unknown method "+W+" on actor "+(0,R.$pv)(P));return j.apply(z,K)}U(P,W,K){if(this.j)return new g.$q4b;let z=null;if(K.length>0&&C.CancellationToken.isCancellationToken(K[K.length-1])&&(z=K.pop()),z&&z.isCancellationRequested)return Promise.reject(T.$6());const j=S.serializeRequestArguments(K,this.h),O=++this.t,N=String(O),ie=new g.$p4b,X=new l.$Rc;z&&X.add(z.onCancellationRequested(()=>{const Se=S.serializeCancel(O);this.f?.logOutgoing(Se.byteLength,O,0,"cancel"),this.c.send(S.serializeCancel(O))})),this.w[N]=new w(ie,X),this.F(O);const Ee=S.serializeRequest(O,P,W,j,!!z);return this.f?.logOutgoing(Ee.byteLength,O,0,`request: ${(0,R.$pv)(P)}.${W}(`,K),this.c.send(Ee),ie}}e.$t4b=o;class w{constructor(P,W){this.a=P,this.b=W}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,W,K){const z=new d(M.$be.alloc(K+1+4),0);return z.writeUInt8(P),z.writeUInt32(W),z}static read(P,W){return new d(P,W)}get buffer(){return this.a}constructor(P,W){this.a=P,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+P).toString();return this.b+=P,K}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+P).toString();return this.b+=P,K}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+P);return this.b+=P,W}static sizeMixedArray(P){let W=0;W+=1;for(let K=0,z=P.length;K<z;K++){const j=P[K];switch(W+=1,j.type){case 1:W+=this.sizeLongString(j.value);break;case 2:W+=this.sizeVSBuffer(j.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(j.value);for(let O=0;O<j.buffers.length;++O)W+=this.sizeVSBuffer(j.buffers[O]);break;case 4:break}}return W}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let W=0,K=P.length;W<K;W++){const z=P[W];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let j=0;j<z.buffers.length;++j)this.writeBuffer(z.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const W=new Array(P);for(let K=0;K<P;K++)switch(this.readUInt8()){case 1:W[K]=this.readLongString();break;case 2:W[K]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),O=this.readLongString(),N=[];for(let ie=0;ie<j;++ie)N.push(this.readVSBuffer());W[K]=new R.$qv(i(O,N,null));break}case 4:W[K]=void 0;break}return W}}var I;(function(h){h[h.Simple=0]="Simple",h[h.Mixed=1]="Mixed"})(I||(I={}));class S{static a(P){for(let W=0,K=P.length;W<K;W++)if(P[W]instanceof M.$be||P[W]instanceof R.$qv||typeof P[W]>"u")return!0;return!1}static serializeRequestArguments(P,W){if(this.a(P)){const K=[];for(let z=0,j=P.length;z<j;z++){const O=P[z];if(O instanceof M.$be)K[z]={type:2,value:O};else if(typeof O>"u")K[z]={type:4};else if(O instanceof R.$qv){const{jsonString:N,referencedBuffers:ie}=t(O.value,W);K[z]={type:3,value:M.$be.fromString(N),buffers:ie}}else K[z]={type:1,value:M.$be.fromString(a(O,W))}}return{type:1,args:K}}return{type:0,args:a(P,W)}}static serializeRequest(P,W,K,z,j){switch(z.type){case 0:return this.b(P,W,K,z.args,j);case 1:return this.c(P,W,K,z.args,j)}}static b(P,W,K,z,j){const O=M.$be.fromString(K),N=M.$be.fromString(z);let ie=0;ie+=d.sizeUInt8(),ie+=d.sizeShortString(O),ie+=d.sizeLongString(N);const X=d.alloc(j?2:1,P,ie);return X.writeUInt8(W),X.writeShortString(O),X.writeLongString(N),X.buffer}static deserializeRequestJSONArgs(P){const W=P.readUInt8(),K=P.readShortString(),z=P.readLongString();return{rpcId:W,method:K,args:JSON.parse(z)}}static c(P,W,K,z,j){const O=M.$be.fromString(K);let N=0;N+=d.sizeUInt8(),N+=d.sizeShortString(O),N+=d.sizeMixedArray(z);const ie=d.alloc(j?4:3,P,N);return ie.writeUInt8(W),ie.writeShortString(O),ie.writeMixedArray(z),ie.buffer}static deserializeRequestMixedArgs(P){const W=P.readUInt8(),K=P.readShortString(),z=P.readMixedArray(),j=new Array(z.length);for(let O=0,N=z.length;O<N;O++){const ie=z[O];typeof ie=="string"?j[O]=JSON.parse(ie):j[O]=ie}return{rpcId:W,method:K,args:j}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,W,K){if(typeof W>"u")return this.d(P);if(W instanceof M.$be)return this.e(P,W);if(W instanceof R.$qv){const{jsonString:z,referencedBuffers:j}=t(W.value,K,!0);return this.g(P,z,j)}else return this.f(P,c(W,K))}static d(P){return d.alloc(7,P,0).buffer}static e(P,W){let K=0;K+=d.sizeVSBuffer(W);const z=d.alloc(8,P,K);return z.writeVSBuffer(W),z.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,W){const K=M.$be.fromString(W);let z=0;z+=d.sizeLongString(K);const j=d.alloc(9,P,z);return j.writeLongString(K),j.buffer}static g(P,W,K){const z=M.$be.fromString(W);let j=0;j+=d.sizeUInt32,j+=d.sizeLongString(z);for(const N of K)j+=d.sizeVSBuffer(N);const O=d.alloc(10,P,j);O.writeUInt32(K.length),O.writeLongString(z);for(const N of K)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(P){const W=P.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(P,W){const K=P.readUInt32(),z=P.readLongString(),j=[];for(let O=0;O<K;++O)j.push(P.readVSBuffer());return new R.$qv(i(z,j,W))}static serializeReplyErr(P,W){const K=W?c(T.$3(W),null):void 0;if(typeof K!="string")return this.h(P);const z=M.$be.fromString(K);let j=0;j+=d.sizeLongString(z);const O=d.alloc(11,P,j);return O.writeLongString(z),O.buffer}static deserializeReplyErrError(P){const W=P.readLongString();return JSON.parse(W)}static h(P){return d.alloc(12,P,0).buffer}}var u;(function(h){h[h.RequestJSONArgs=1]="RequestJSONArgs",h[h.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",h[h.RequestMixedArgs=3]="RequestMixedArgs",h[h.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",h[h.Acknowledged=5]="Acknowledged",h[h.Cancel=6]="Cancel",h[h.ReplyOKEmpty=7]="ReplyOKEmpty",h[h.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",h[h.ReplyOKJSON=9]="ReplyOKJSON",h[h.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",h[h.ReplyErrError=11]="ReplyErrError",h[h.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var m;(function(h){h[h.String=1]="String",h[h.VSBuffer=2]="VSBuffer",h[h.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",h[h.Undefined=4]="Undefined"})(m||(m={}))}),define(Ae[265],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;const y=function(T){const A=l=>{globalThis.removeEventListener("message",A);const D=l.data;Object.defineProperties(globalThis,{postMessage:{value(g,R){D.postMessage(g,R)}},onmessage:{get(){return D.onmessage},set(g){D.onmessage=g}}}),D.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(T,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${y})('${A}'))`,g=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL(g),k=new MessageChannel,c=R,b={type:"_newWorker",id:c,port:k.port2,url:R,options:l};T(b,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{T({type:"_terminateWorker",id:c}),URL.revokeObjectURL(R),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(p){k.port1.onmessage=p}},onmessageerror:{get(){return k.port1.onmessageerror},set(p){k.port1.onmessageerror=p}}}),k.port1.addEventListener("messageerror",p=>{const f=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(f)}),k.port1.addEventListener("message",p=>{const f=new MessageEvent("message",{data:p.data});this.dispatchEvent(f)}),k.port1.start()}}e.$pgc=M}),define(Ae[266],Re([1,0,5,30,32,4]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.$BJ=e.OutputChannelUpdateMode=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=void 0,e.$rJ="text/x-code-output",e.$sJ="output",e.$tJ="Log",e.$uJ="text/x-code-log-output",e.$vJ="log",e.$wJ="workbench.panel.output",e.$xJ=new C.$7i("inOutput",!1),e.$yJ=new C.$7i("activeLogOutput",!1),e.$zJ=new C.$7i("outputView.scrollLock",!1),e.$AJ=(0,T.$Ph)("outputService");var A;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$BJ={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new y.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(R=>g.push(R)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}M.$gn.add(e.$BJ.OutputChannels,new l),e.$CJ=new C.$7i("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,21,14,266,62,27,40,129,26,15,39,5,6]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0;class i extends A.$dj{get disposed(){return this.n}constructor(v,n,r,s,o){super(),this.id=v,this.name=n,this.r=r,this.s=s,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,v)}replace(v){const n=this.m;this.info(v),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(v,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof v=="boolean"?v:n))}hide(){this.s.$close(this.id)}g(v,n){this.m+=c.$be.fromString(n).byteLength,(0,A.log)(this.r,v,n),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class a extends i{appendLine(v){this.append(v)}}let $=class{constructor(v,n,r,s,o,w){this.i=n,this.j=r,this.k=s,this.l=o,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(y.$gK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,k.$em)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[n,r]of this.g)r.visible=n===this.h}createOutputChannel(v,n,r){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,o=(0,b.$yf)(n)?n:void 0;if((0,b.$yf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const d=this.i.environment.extensionLogLevel?.find(([S])=>T.$6l.equals(r.identifier,S))?.[1];d&&(w=(0,A.$nj)(d));const I=s?this.o(v,w,r):this.n(v,o,r);return I.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),s?this.r(v,w??this.m.getLevel(),I):this.q(v,I)}async n(v,n,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,o=this.k.extUri.joinPath(s,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(v,o,n,r.identifier.value);return new i(d,v,w,this.a,r)}async o(v,n,r){const s=await this.p(r),o=v.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(s,`${o}.log`),d=`${r.identifier.value}.${o}`,I=this.l.createLogger(w,{id:d,name:v,logLevel:n,extensionId:r.identifier.value});return new a(d,v,I,this.a,r)}p(v){let n=this.d.get(v.identifier.value);if(!n){const r=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(r)}catch(s){if((0,p.$ok)(s)!==p.FileSystemProviderErrorCode.FileExists)throw s}return r})())}return n}q(v,n){let r=!1;const s=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return v},append(o){s(),n.then(w=>w.append(o))},appendLine(o){s(),n.then(w=>w.appendLine(o))},clear(){s(),n.then(o=>o.clear())},replace(o){s(),n.then(w=>w.replace(o))},show(o,w){s(),n.then(d=>d.show(o,w))},hide(){s(),n.then(o=>o.hide())},dispose(){r=!0,n.then(o=>o.dispose())}}}r(v,n,r){const s=new t.$Rc,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},w=s.add(new f.$Nd);function d(I){n=I,w.fire(I)}return r.then(I=>{s.add(I),I.logLevel!==n&&d(I.logLevel),s.add(I.onDidChangeLogLevel(S=>d(S)))}),{...this.q(v,r),get logLevel(){return n},onDidChangeLogLevel:w.event,trace(I,...S){o(),r.then(u=>u.trace(I,...S))},debug(I,...S){o(),r.then(u=>u.debug(I,...S))},info(I,...S){o(),r.then(u=>u.info(I,...S))},warn(I,...S){o(),r.then(u=>u.warn(I,...S))},error(I,...S){o(),r.then(u=>u.error(I,...S))},dispose(){s.dispose()}}}};e.$2cc=$,e.$2cc=$=qe([Ke(0,C.$hM),Ke(1,g.$xM),Ke(2,D.$Ecc),Ke(3,R.$_bc),Ke(4,A.$$i),Ke(5,A.$0i)],$),e.$3cc=(0,M.$Ph)("IExtHostOutputService")}),define(Ae[267],Re([1,0,4,12]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=(0,y.$Ph)("remoteAgentService"),e.$um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let T=1/0;for(let l=0;l<this.maxSampleCount;l++){const D=await C.getRoundTripTime();if(D===void 0)return;T=Math.min(T,D/2),await(0,M.$Ug)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((l,D)=>l+D,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((l,D)=>l+D,0)/this.average.length,high:(()=>typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[268],Re([1,0,44,13,20,23,24,2,4,186,55,209,267]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=e.$UJ=void 0,e.$UJ=(0,D.$Ph)("pathService");let p=b=class{constructor(t,i,a,$){this.d=t,this.e=i,this.f=a,this.g=$,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,i,a){return typeof i=="string"||typeof i>"u"?this.a.then($=>this.h(t,$,i)):this.h(t,i,a)}h(t,i,a){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,y.$Vf)(a??(0,A.$sg)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const a=(0,g.$RJ)(i.getWorkspace());if(a)return a;const $=i.getWorkspace().folders[0];if($)return $.uri.scheme;const E=i.getWorkspace().configuration;return E?E.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$fc:C.$gc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const $=t.indexOf("/",2);$===-1?(i=t.substring(2),t="/"):(i=t.substring(2,$),t=t.substring($)||"/")}return l.URI.from({scheme:M.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$VJ=p,e.$VJ=p=b=qe([Ke(1,c.$tm),Ke(2,k.$DJ),Ke(3,R.$Yh)],p)}),define(Ae[110],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$CI=e.$BI=void 0;class y{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new y(0,0)}with(A){return new y(0,0)}}e.$BI=y;class M{constructor(A,l,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,l),this.end=new y(D,g)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$CI=M;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[48],Re([1,0,18,38,25,44,16,4,20,9,110,12]),function(ye,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.SearchErrorCode=e.$RI=e.$QI=e.SearchSortOrder=e.ViewMode=e.$PI=e.$OI=e.$NI=e.$MI=e.SearchCompletionExitCode=e.$LI=e.$KI=e.$JI=e.QueryType=e.SearchProviderType=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$DI="workbench.view.search",e.$EI="workbench.panel.search",e.$FI="workbench.view.search",e.$GI="search-result",e.$HI="search.exclude";const c="\u27EA ",b=" characters skipped \u27EB",p=(c.length+b.length+5)*2;e.$II=(0,l.$Ph)("searchService");var f;(function($e){$e[$e.file=0]="file",$e[$e.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function($e){$e[$e.File=1]="File",$e[$e.Text=2]="Text"})(t||(e.QueryType=t={}));function i($e){return!!$e.preview}e.$JI=i;function a($e){return!!$e.resource}e.$KI=a;function $($e){return!!$e.message}e.$LI=$;var E;(function($e){$e[$e.Normal=0]="Normal",$e[$e.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class v{constructor(pe){this.resource=pe,this.results=[]}}e.$MI=v;class n{constructor(pe,ue,oe,be){this.ranges=ue,this.webviewIndex=be;const _=Array.isArray(ue)?ue:[ue];if(oe&&oe.matchLines===1&&r(_)){pe=(0,A.$rf)(pe,oe.matchLines);let B="",Z=0,ee=0;const ve=Math.floor(oe.charsPerLine/5),ge=[];for(const he of _){const De=Math.max(he.startColumn-ve,0),re=he.startColumn+oe.charsPerLine;if(De>ee+ve+p){const le=c+(De-ee)+b;B+=le+pe.slice(De,re),Z+=De-(ee+le.length)}else B+=pe.slice(ee,re);ge.push(new o(0,he.startColumn-Z,he.endColumn-Z)),ee=re}this.preview={text:B,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const B=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:pe,matches:(0,y.$2b)(ue,Z=>new s(Z.startLineNumber-B,Z.startColumn,Z.endLineNumber-B,Z.endColumn))}}}}e.$NI=n;function r($e){const pe=$e[0].startLineNumber;for(const ue of $e)if(ue.startLineNumber!==pe||ue.endLineNumber!==pe)return!1;return!0}class s{constructor(pe,ue,oe,be){this.startLineNumber=pe,this.startColumn=ue,this.endLineNumber=oe,this.endColumn=be}}e.$OI=s;class o extends s{constructor(pe,ue,oe){super(pe,ue,pe,oe)}}e.$PI=o;var w;(function($e){$e.List="list",$e.Tree="tree"})(w||(e.ViewMode=w={}));var d;(function($e){$e.Default="default",$e.FileNames="fileNames",$e.Type="type",$e.Modified="modified",$e.CountDescending="countDescending",$e.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function I($e,pe=!0){const ue=$e&&$e.files&&$e.files.exclude,oe=pe&&$e&&$e.search&&$e.search.exclude;if(!ue&&!oe)return;if(!ue||!oe)return ue||oe;let be=Object.create(null);return be=C.$0m(be,C.$7m(ue)),be=C.$0m(be,C.$7m(oe),!0),be}e.$QI=I;function S($e,pe){return $e.excludePattern&&M.$vj($e.excludePattern,pe)?!1:$e.includePattern||$e.usingSearchPaths?$e.includePattern&&M.$vj($e.includePattern,pe)?!0:$e.usingSearchPaths?!!$e.folderQueries&&$e.folderQueries.some(ue=>{const oe=ue.folder.fsPath;if(T.$Xf(pe,oe)){const be=D.$lc(oe,pe);return!ue.includePattern||!!M.$vj(ue.includePattern,be)}else return!1}):!1:!0}e.$RI=S;var u;(function($e){$e[$e.unknownEncoding=1]="unknownEncoding",$e[$e.regexParseError=2]="regexParseError",$e[$e.globParseError=3]="globParseError",$e[$e.invalidLiteral=4]="invalidLiteral",$e[$e.rgProcessError=5]="rgProcessError",$e[$e.other=6]="other",$e[$e.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class m extends Error{constructor(pe,ue){super(pe),this.code=ue}}e.$SI=m;function h($e){const pe=$e.message;if((0,g.$4)($e))return new m(pe,u.canceled);try{const ue=JSON.parse(pe);return new m(ue.message,ue.code)}catch{return new m(pe,u.other)}}e.$TI=h;function P($e){const pe={message:$e.message,code:$e.code};return new Error(JSON.stringify(pe))}e.$UI=P;function W($e){return $e.type==="error"?!0:$e.type==="success"}e.$VI=W;function K($e){return $e.type==="success"}e.$WI=K;function z($e){return!!$e.path}e.$XI=z;function j($e,pe){const ue=$e.searchPath?$e.searchPath:$e.relativePath;return(0,A.$of)(ue,pe)}e.$YI=j;class O{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$ZI=O;function N($e,pe){const ue={...$e||{},...pe||{}};return Object.keys(ue).filter(oe=>{const be=ue[oe];return typeof be=="boolean"&&be})}e.$1I=N;class ie{constructor(pe,ue){this.c=null,this.a={...pe.excludePattern||{},...ue.excludePattern||{}},this.b=M.$wj(this.a);let oe=pe.includePattern;ue.includePattern&&(oe?oe={...oe,...ue.includePattern}:oe=ue.includePattern),oe&&(this.c=M.$wj(oe))}matchesExcludesSync(pe,ue,oe){return!!(this.b&&this.b(pe,ue,oe))}includedInQuerySync(pe,ue,oe){return!(this.b&&this.b(pe,ue,oe)||this.c&&!this.c(pe,ue,oe))}includedInQuery(pe,ue,oe){const be=this.b(pe,ue,oe),_=()=>this.c?!!this.c(pe,ue,oe):!0;return(0,k.$Gg)(be)?be.then(B=>B?!1:_()):_()}hasSiblingExcludeClauses(){return X(this.a)}}e.$2I=ie;function X($e){for(const pe in $e)if(typeof $e[pe]!="boolean")return!0;return!1}function Ee($e){if(!$e)return;let pe;return ue=>(pe||(pe=($e()||Promise.resolve([])).then(oe=>oe?Pe(oe):{})),pe.then(oe=>!!oe[ue]))}e.$3I=Ee;function Se($e){if(!$e)return;let pe;return ue=>{if(!pe){const oe=$e();pe=oe?Pe(oe):{}}return!!pe[ue]}}e.$4I=Se;function Pe($e){const pe={};for(const ue of $e)pe[ue]=!0;return pe}}),define(Ae[33],Re([1,0,18,12,19,5,6,49,13,117,24,16,2,158,4,14,175,55,40,27,17,8,7,56,48,3]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E,v,n,r,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=void 0;function w(W,K,z){return new R.$kg(j=>u(j,z)).isEqual(W,K)}function d(W,K,z){return w(W.uri,K.uri,z)?0:(0,k.$Ue)(W.uri.toString(),K.uri.toString())}function I(W,K,z){return W.index!==K.index?W.index<K.index?-1:1:w(W.uri,K.uri,z)?(0,k.$Ue)(W.name,K.name):(0,k.$Ue)(W.uri.toString(),K.uri.toString())}function S(W,K,z,j){const O=W.slice(0).sort((ie,X)=>z(ie,X,j)),N=K.slice(0).sort((ie,X)=>z(ie,X,j));return(0,y.$Eb)(O,N,(ie,X)=>z(ie,X,j))}function u(W,K){const z=K.getCapabilities(W.scheme);return!(z&&z&1024)}class m extends i.$9h{static toExtHostWorkspace(K,z,j,O){if(!K)return{workspace:null,added:[],removed:[]};const{id:N,name:ie,folders:X,configuration:Ee,transient:Se,isUntitled:Pe}=K,$e=[],pe=z;z?X.forEach((_,B)=>{const Z=c.URI.revive(_.uri),ee=m.o(j||z,Z,O);ee?(ee.name=_.name,ee.index=_.index,$e.push(ee)):$e.push({uri:Z,name:_.name,index:B})}):$e.push(...X.map(({uri:_,name:B,index:Z})=>({uri:c.URI.revive(_),name:B,index:Z}))),$e.sort((_,B)=>_.index<B.index?-1:1);const ue=new m(N,ie,$e,!!Se,Ee?c.URI.revive(Ee):null,!!Pe,_=>u(_,O)),{added:oe,removed:be}=S(pe?pe.workspaceFolders:[],ue.workspaceFolders,d,O);return{workspace:ue,added:oe,removed:be}}static o(K,z,j){for(let O=0;O<K.folders.length;O++){const N=K.workspaceFolders[O];if(w(N.uri,z,j))return N}}constructor(K,z,j,O,N,ie,X){super(K,j.map(Ee=>new i.$0h(Ee)),O,N,X),this.t=z,this.u=ie,this.q=[],this.s=l.$Vh.forUris(X),j.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(K,z){return z&&this.s.get(K)&&(K=(0,R.$ug)(K)),this.s.findSubstr(K)}resolveWorkspaceFolder(K){return this.s.get(K)}}let h=class{constructor(K,z,j,O,N){this.c=new T.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new T.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new T.$Pd,this.B=new Map,this.h=O,this.s=j,this.t=N,this.j=new g.$Ql,this.k=new M.$Sg,this.o=K.getProxy(o.$gK.MainThreadWorkspace),this.q=K.getProxy(o.$gK.MainThreadMessageService);const ie=z.workspace;this.l=ie?new m(ie.id,ie.name,[],!!ie.transient,ie.configuration?c.URI.revive(ie.configuration):null,!!ie.isUntitled,X=>u(X,j)):void 0}$initializeWorkspace(K,z){this.v=z,this.$acceptWorkspaceData(K),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?c.URI.from({scheme:D.Schemas.untitled,path:(0,R.$sg)((0,R.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(K,z,j,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{c.URI.isUri(Pe.uri)&&!N.some($e=>w($e.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,R.$rg)(Pe.uri)})}),this.n||[z,j].some(Pe=>typeof Pe!="number"||Pe<0)||j===0&&N.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(z+j>ie.length)return!1;const X=ie.slice(0);X.splice(z,j,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,R.$rg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<X.length;Pe++){const $e=X[Pe];if(X.some((pe,ue)=>ue!==Pe&&w($e.uri,pe.uri,this.s)))return!1}X.forEach((Pe,$e)=>Pe.index=$e);const{added:Ee,removed:Se}=S(ie,X,I,this.s);if(Ee.length===0&&Se.length===0)return!1;if(this.o){const Pe=K.displayName||K.name;this.o.$updateWorkspaceFolders(Pe,z,j,N).then(void 0,$e=>{this.n=void 0;const pe={source:{identifier:K.identifier,label:K.displayName||K.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,Pe,$e.toString()),pe,[])})}return this.y(X),!0}getWorkspaceFolder(K,z){if(this.x)return this.x.getWorkspaceFolder(K,z)}async getWorkspaceFolder2(K,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(K,z)}async resolveWorkspaceFolder(K){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(K)}getPath(){if(!this.x)return;const{folders:K}=this.x;if(K.length!==0)return K[0].uri.fsPath}getRelativePath(K,z){let j,O="";if(typeof K=="string"?(j=c.URI.file(K),O=K):typeof K<"u"&&(j=K,O=K.fsPath),!j)return O;const N=this.getWorkspaceFolder(j,!0);if(!N)return O;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ie=(0,R.$xg)(N.uri,j);return z&&N.name&&(ie=`${N.name}/${ie}`),ie}y(K){this.x&&(this.n=m.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:K,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(K){const{workspace:z,added:j,removed:O}=m.toExtHostWorkspace(K,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:O}))}findFiles(K,z,j,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let ie;if(z===null?ie=!1:z&&(typeof z=="string"?ie=z:ie=z.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:Ee}=P(v.GlobPattern.from(K));return this.o.$startFileSearch(X??null,Ee??null,ie??null,j??null,N).then(Se=>Array.isArray(Se)?Se.map(Pe=>c.URI.revive(Pe)):[])}async findTextInFiles(K,z,j,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),X=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:Ee,folder:Se}=P(v.GlobPattern.from(z.include)),Pe=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,$e={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:X,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:Ee,excludePattern:Pe},pe=!1;if(this.u[ie]=ue=>{if(pe)return;const oe=c.URI.revive(ue.resource);ue.results.forEach(be=>{(0,s.$JI)(be)?j({uri:oe,preview:{text:be.preview.text,matches:(0,y.$2b)(be.preview.matches,_=>new n.$kK(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,y.$2b)(be.ranges,_=>new n.$kK(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):j({uri:oe,text:be.text,lineNumber:be.lineNumber})})},N.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(K,Se??null,$e,ie,N);return delete this.u[ie],ue||{}}catch(ue){throw delete this.u[ie],ue}}$handleTextSearchResult(K,z){this.u[z]?.(K)}async save(K){const z=await this.o.$save(K,{saveAs:!1});return c.URI.revive(z)}async saveAs(K){const z=await this.o.$save(K,{saveAs:!0});return c.URI.revive(z)}saveAll(K){return this.o.$saveAll(K)}resolveProxy(K){return this.o.$resolveProxy(K)}get trusted(){return this.v}requestWorkspaceTrust(K){return this.o.$requestWorkspaceTrust(K)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(K,z){if(this.w.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this.w.set(K,z);const j=this.t.transformOutgoingScheme(K),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,j),(0,A.$Qc)(()=>{this.w.delete(K),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(K,z){this.h.info("Getting edit session identifier for workspaceFolder",K);const j=await this.resolveWorkspaceFolder(c.URI.revive(K));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const O=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(j,z);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(K,z,j,O){this.h.info("Getting edit session identifier for workspaceFolder",K);const N=await this.resolveWorkspaceFolder(c.URI.revive(K));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const ie=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!ie),!ie)return;const X=await ie.provideEditSessionIdentityMatch?.(z,j,O);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(K){return(z,j,O)=>{const N=function(X){z.call(j,X)};return N.extension=K,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(K,z,j){const O=await this.resolveWorkspaceFolder(c.URI.revive(K));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},z,async(N,ie)=>{const X=Date.now();await Promise.resolve(N),Date.now()-X>j&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(K,z){if(this.B.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this.B.set(K,z);const j=this.t.transformOutgoingScheme(K),O=this.z++;return this.o.$registerCanonicalUriProvider(O,j),(0,A.$Qc)(()=>{this.B.delete(K),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(K,z,j){const O=this.B.get(K.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(c.URI.revive(K),z,j);if(N)return N}async $provideCanonicalUri(K,z,j){return this.provideCanonicalUri(c.URI.revive(K),{targetScheme:z},j)}};e.$lcc=h,e.$lcc=h=qe([Ke(0,E.$hM),Ke(1,$.$xM),Ke(2,a.$_bc),Ke(3,f.$0i),Ke(4,r.$jcc)],h),e.$mcc=(0,p.$Ph)("IExtHostWorkspace");function P(W){let K,z;return W&&(typeof W=="string"?K=W:(K=W.pattern,z=c.URI.revive(W.baseUri))),{includePattern:K,folder:z}}}),define(Ae[34],Re([1,0,25,5,33,3,7,177,96,15,12,4,17,14,2]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=e.$ncc=void 0;function f(r,s){if(s){const o=s.split(".");let w=r;for(let d=0;w&&d<o.length;d++)w=w[o[d]];return w}}function t(r){return r instanceof p.URI}function i(r){return r&&r.uri instanceof p.URI&&r.languageId&&typeof r.languageId=="string"}function a(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function $(r){return r&&r.uri instanceof p.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function E(r){if(t(r))return{resource:r};if(i(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(a(r))return{overrideIdentifier:r.languageId};if($(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(s,o,w){this.a=s.getProxy(T.$gK.MainThreadConfiguration),this.c=o,this.b=w,this.d=new R.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new n(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(s,o))}};e.$ncc=v,e.$ncc=v=qe([Ke(0,c.$hM),Ke(1,C.$mcc),Ke(2,b.$0i)],v);class n{constructor(s,o,w,d){this.a=new M.$Nd,this.b=s,this.f=d,this.c=o,this.e=l.$En.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,o){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$En.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(o,w))}getConfiguration(s,o,w){const d=E(o)||{},I=this.g(s?f(this.e.getValue(void 0,d,this.c.workspace),s):this.e.getValue(void 0,d,this.c.workspace));s&&this.h(s,d,w?.identifier);function S(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(m){return typeof f(I,m)<"u"},get:(m,h)=>{this.h(s?`${s}.${m}`:m,d,w?.identifier);let P=f(I,m);if(typeof P>"u")P=h;else{let W;const K=(z,j)=>{if((0,g.$Af)(z)){let O;const N=()=>{W=W||(0,y.$7m)(I),O=O||f(W,j)};return new Proxy(z,{get:(ie,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return N(),()=>O;if(W)return O=O||f(W,j),O[X];const Ee=ie[X];return typeof X=="string"?K(Ee,`${j}.${X}`):Ee},set:(ie,X,Ee)=>(N(),O&&(O[X]=Ee),!0),deleteProperty:(ie,X)=>(N(),O&&delete O[X],!0),defineProperty:(ie,X,Ee)=>(N(),O&&Object.defineProperty(O,X,Ee),!0)})}return Array.isArray(z)?(0,y.$7m)(z):z};P=K(P,m)}return P},update:(m,h,P,W)=>{m=s?`${s}.${m}`:m;const K=S(P);return h!==void 0?this.b.$updateConfigurationOption(K,m,h,d,W):this.b.$removeConfigurationOption(K,m,d,W)},inspect:m=>{m=s?`${s}.${m}`:m;const h=this.e.inspect(m,d,this.c.workspace);if(h)return{key:m,defaultValue:(0,y.$7m)(h.policy?.value??h.default?.value),globalValue:(0,y.$7m)(h.user?.value??h.application?.value),workspaceValue:(0,y.$7m)(h.workspace?.value),workspaceFolderValue:(0,y.$7m)(h.workspaceFolder?.value),defaultLanguageValue:(0,y.$7m)(h.default?.override),globalLanguageValue:(0,y.$7m)(h.user?.override??h.application?.override),workspaceLanguageValue:(0,y.$7m)(h.workspace?.override),workspaceFolderLanguageValue:(0,y.$7m)(h.workspaceFolder?.override),languageIds:(0,y.$7m)(h.overrideIdentifiers)}}};return typeof I=="object"&&(0,y.$0m)(u,I,!1),Object.freeze(u)}g(s){const o=w=>(0,g.$Af)(w)?new Proxy(w,{get:(d,I)=>o(d[I]),set:(d,I,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(d,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(d,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return o(s)}h(s,o,w){const d=D.$vn.test(s)?4:this.d.get(s),I=w?`[${w.value}] `:"";if(d===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,o){const w=new l.$Gn(s,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,I)=>w.affectsConfiguration(d,E(I))})}k(s){return s.reduce((o,w)=>(o.set(w[0],w[1]),o),new Map)}}e.$occ=n,e.$pcc=(0,k.$Ph)("IExtHostConfiguration")}),define(Ae[111],Re([1,0,2,12,5,3,7,33,60,34,19,63,17,27,4,13,23,14,80,215,9]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=e.$ldc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var v;(function(K){function z(O){if(O!=null)return O}K.from=z;function j(O){if(O!=null)return O}K.to=j})(v||(v={}));var n;(function(K){function z(O){if(O!=null)return O}K.from=z;function j(O){if(O!=null)return O}K.to=j})(n||(n={}));var r;(function(K){function z(O){if(O!=null)return O}K.from=z;function j(O){if(O!=null)return O}K.to=j})(r||(r={}));var s;(function(K){function z(N){if(N){const ie=N;return ie&&!!ie.process}else return!1}K.is=z;function j(N){if(N==null)return;const ie={process:N.process,args:N.args};return N.options&&(ie.options=r.from(N.options)),ie}K.from=j;function O(N){if(N!=null)return new A.$3K(N.process,N.args,N.options)}K.to=O})(s||(s={}));var o;(function(K){function z(O){if(O!=null)return O}K.from=z;function j(O){if(O!=null)return O}K.to=j})(o||(o={}));var w;(function(K){function z(N){if(N){const ie=N;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}K.is=z;function j(N){if(N==null)return;const ie={};return N.commandLine!==void 0?ie.commandLine=N.commandLine:(ie.command=N.command,ie.args=N.args),N.options&&(ie.options=o.from(N.options)),ie}K.from=j;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$4K(N.commandLine,N.options):new A.$4K(N.command,N.args?N.args:[],N.options)}K.to=O})(w||(w={}));var d;(function(K){function z(N){if(N){const ie=N;return ie&&ie.customExecution==="customExecution"}else return!1}K.is=z;function j(N){return{customExecution:"customExecution"}}K.from=j;function O(N,ie){return ie.get(N)}K.to=O})(d||(e.CustomExecutionDTO=d={}));var I;(function(K){function z(j,O){let N;return j.scope!==void 0&&typeof j.scope!="number"?N=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=$.$PF),{id:j._id,workspaceFolder:N}}K.from=z})(I||(e.TaskHandleDTO=I={}));var S;(function(K){function z(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}K.from=z})(S||(S={}));var u;(function(K){function z(N,ie){if(N==null)return[];const X=[];for(const Ee of N){const Se=j(Ee,ie);Se&&X.push(Se)}return X}K.fromMany=z;function j(N,ie){if(N==null)return;let X;N.execution instanceof A.$3K?X=s.from(N.execution):N.execution instanceof A.$4K?X=w.from(N.execution):N.execution&&N.execution instanceof A.$5K&&(X=d.from(N.execution));const Ee=v.from(N.definition);let Se;return N.scope?typeof N.scope=="number"?Se=N.scope:Se=N.scope.uri:Se=A.TaskScope.Workspace,!Ee||!Se?void 0:{_id:N._id,definition:Ee,name:N.name,source:{extensionId:ie.identifier.value,label:N.source,scope:Se},execution:X,isBackground:N.isBackground,group:S.from(N.group),presentationOptions:n.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}K.from=j;async function O(N,ie,X){if(N==null)return;let Ee;s.is(N.execution)?Ee=s.to(N.execution):w.is(N.execution)?Ee=w.to(N.execution):d.is(N.execution)&&(Ee=d.to(N._id,X));const Se=v.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await ie.resolveWorkspaceFolder(y.URI.revive(N.source.scope)):Pe=A.TaskScope.Workspace),!Se||!Pe)return;const $e=new A.$6K(Se,Pe,N.name,N.source.label,Ee,N.problemMatchers);return N.isBackground!==void 0&&($e.isBackground=N.isBackground),N.group!==void 0&&($e.group=A.$2K.from(N.group._id),$e.group&&N.group.isDefault&&($e.group=new A.$2K($e.group.id,$e.group.label),N.group.isDefault===!0&&($e.group.isDefault=N.group.isDefault))),N.presentationOptions&&($e.presentationOptions=n.to(N.presentationOptions)),N._id&&($e._id=N._id),N.detail&&($e.detail=N.detail),$e}K.to=O})(u||(e.TaskDTO=u={}));var m;(function(K){function z(O){return O}K.from=z;function j(O){if(O)return Object.assign(Object.create(null),O)}K.to=j})(m||(m={}));class h{#e;constructor(z,j,O){this._id=j,this.a=O,this.#e=z}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}let P=class{constructor(z,j,O,N,ie,X,Ee,Se){this.q=new C.$Nd,this.r=new C.$Nd,this.s=new C.$Nd,this.t=new C.$Nd,this.a=z.getProxy(T.$gK.MainThreadTask),this.b=O,this.c=N,this.d=ie,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=Se,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,j,O){if(!O)return new A.$iK(()=>{});const N=this.w();return this.j.set(N,{type:j,provider:O,extension:z}),this.a.$registerTaskProvider(N,j),new A.$iK(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(z,j){this.a.$registerTaskSystem(z,j)}fetchTasks(z){return this.a.$fetchTasks(m.from(z)).then(async j=>{const O=[];for(const N of j){const ie=await u.to(N,this.b,this.m);ie&&O.push(ie)}return O})}get taskExecutions(){const z=[];return this.k.forEach(j=>z.push(j)),z}terminateTask(z){if(!(z instanceof h))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,j,O){const N=this.m.get(z.id);N&&(this.o.set(z.id,N),this.e.attachPtyToTerminal(j,await N.callback(O))),this.p=z.id,this.q.fire({execution:await this.y(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){const j=await this.y(z);this.l.delete(z.id),this.k.delete(z.id),this.A(z),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const j=await this.y(z.id);this.s.fire({execution:j,processId:z.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(z){const j=await this.y(z.id);this.t.fire({execution:j,exitCode:z.exitCode})}$provideTasks(z,j){const O=this.j.get(z);if(!O)return Promise.reject(new Error("no handler found"));const N=[],ie=(0,M.$Mg)(()=>O.provider.provideTasks(R.CancellationToken.None)).then(X=>this.u(j,N,O,X));return new Promise(X=>{ie.then(Ee=>{Promise.all(N).then(()=>{X(Ee)})})})}async $resolveTask(z,j){const O=this.j.get(z);if(!O)return Promise.reject(new Error("no handler found"));if(j.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await u.to(j,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const ie=await O.provider.resolveTask(N,R.CancellationToken.None);if(!ie)return;this.z(ie,O);const X=u.from(ie,O.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(X.execution)&&await this.x(X,ie,!0),await this.v(X)}w(){return this.h++}async x(z,j,O){const N=await this.a.$createTaskId(z);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,j.execution)),this.m.set(N,j.execution)}async y(z,j){if(typeof z=="string"){const ie=this.l.get(z);if(!ie)throw new E.$bb("Unexpected: The specified task is missing an execution");return ie}const O=this.l.get(z.id);if(O)return O;const N=new Promise((ie,X)=>{function Ee(Se,Pe,$e){$e?ie(new h(Se,Pe.id,$e)):X("Unexpected: Task does not exist.")}j?Ee(this,z,j):u.to(z.task,this.b,this.m).then(Se=>Ee(this,z,Se))});return this.l.set(z.id,N),N.then(ie=>(this.k.set(z.id,ie),ie),ie=>Promise.reject(ie))}z(z,j){z._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$ldc=P,e.$ldc=P=qe([Ke(0,c.$hM),Ke(1,b.$xM),Ke(2,l.$mcc),Ke(3,D.$sM),Ke(4,g.$pcc),Ke(5,k.$Hcc),Ke(6,i.$0i),Ke(7,a.$ccc)],P);let W=class extends P{constructor(z,j,O,N,ie,X,Ee,Se){super(z,j,O,N,ie,X,Ee,Se),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(z,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const O=u.from(j,z);if(O===void 0)throw new Error("Task is not valid");if(d.is(O.execution))await this.x(O,j,!1);else throw new E.$_;const N=await this.y(await this.a.$getTaskExecution(O),j);return this.a.$executeTask(O).catch(ie=>{throw new Error(ie)}),N}u(z,j,O,N){const ie=[];if(N)for(const X of N){this.z(X,O),(!X.definition||!z[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=u.from(X,O.extension);Ee&&d.is(Ee.execution)?(ie.push(Ee),j.push(this.x(Ee,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:O.extension}}async v(z){if(d.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,j,O){}};e.$mdc=W,e.$mdc=W=qe([Ke(0,c.$hM),Ke(1,b.$xM),Ke(2,l.$mcc),Ke(3,D.$sM),Ke(4,g.$pcc),Ke(5,k.$Hcc),Ke(6,i.$0i),Ke(7,a.$ccc)],W),e.$ndc=(0,p.$Ph)("IExtHostTask")}),define(Ae[269],Re([1,0,20,19,37,38,24,59,48]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class g{constructor(c,b,p){this.k=c,this.l=b,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=c.filePattern,this.b=c.includePattern&&T.$wj(c.includePattern),this.c=c.maxResults||void 0,this.d=c.exists,this.h=new Set,this.j=c.excludePattern&&T.$wj(c.excludePattern)}cancel(){this.g=!0,this.h.forEach(c=>c.cancel()),this.h=new Set}search(c){const b=this.k.folderQueries||[];return new Promise((p,f)=>{const t=i=>{this.f++,c(i)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const a=i.toString(),$=y.$nc(a);this.j&&this.j(a,$)||this.v(t,{base:i,basename:$})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{p({limitHit:this.e,stats:i[0]||void 0})},i=>{f(new Error((0,C.$Ai)(i)))})})}async p(c,b){const p=new M.$Xd,f=this.q(c),t=this.r(),i=new D.$2I(this.k,c),a=!i.hasSiblingExcludeClauses();let $;try{this.h.add(p),$=l.$Jd.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,p.token),v=$.elapsed(),n=l.$Jd.create();return this.g&&!this.e||(E&&E.forEach(r=>{const s=y.$gc.relative(c.folder.path,r.path);if(a){const o=y.$nc(r.path);this.v(b,{base:c.folder,relativePath:s,basename:o});return}this.s(t,c.folder,s,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:v,postProcessTime:n.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(c){const b=(0,D.$1I)(this.k.includePattern,c.includePattern),p=(0,D.$1I)(this.k.excludePattern,c.excludePattern);return{folder:c.folder,excludes:p,includes:b,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}s({pathToEntries:c},b,p,f){if(p===this.a){const i=y.$nc(this.a);this.v(f,{base:b,relativePath:this.a,basename:i})}function t(i){const a=y.$nc(i),$=y.$mc(i);let E=c[$];E||(E=c[$]=[],t($)),E.push({base:b,relativePath:i,basename:a})}t(p)}u({rootEntries:c,pathToEntries:b},p,f){const t=this,i=this.a;function a($){const E=(0,D.$4I)(()=>$.map(v=>v.basename));for(let v=0,n=$.length;v<n;v++){const r=$[v],{relativePath:s,basename:o}=r;if(p.matchesExcludesSync(s,o,i!==o?E:void 0))continue;const w=b[s];if(w)a(w);else{if(s===i)continue;t.v(f,r)}if(t.e)break}}a(c)}v(c,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||c(b))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(c,b,p,f){const t=this.c(c.cacheKey),i=new g(c,b,t&&t.token);let a=0;const $=E=>{a+=E.length,p(E.map(v=>this.d(v)))};return this.e(i,R.a,$,f).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:E.stats}}))}clearCache(c){this.c(c)?.cancel()}c(c){if(c)return this.b.has(c)||this.b.set(c,new M.$Xd),this.b.get(c)}d(c){return c.relativePath?{resource:A.$vg(c.base,c.relativePath)}:{resource:c.base}}e(c,b,p,f){const t=f.onCancellationRequested(()=>{c.cancel()}),i=$=>{$&&(a.push($),b>0&&a.length>=b&&(p(a),a=[]))};let a=[];return c.search(i).then($=>(a.length&&p(a),t.dispose(),$),$=>(a.length&&p(a),t.dispose(),Promise.reject($)))}}e.$xdc=R}),define(Ae[270],Re([1,0,18,233,38,90,28,13,20,24,16,15,2,285,167,45,14,55,102,268,48]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=void 0;let v=class{constructor(m,h,P,W,K){this.a=m,this.b=h,this.c=P,this.d=W,this.e=K}text(m,h,P={}){m=this.f(m,P);const W=this.a.getValue(),K=h&&h.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(h?.map(i.$$h),P),type:2,contentPattern:m,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:W.search.usePCRE2||K||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(m,h){const P=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const W={...m,wordSeparators:P.editor.wordSeparators};return this.j(m,h)&&(W.isCaseSensitive=!0),this.k(m)&&(W.isMultiline=!0),h.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=h.notebookSearchConfig.includeMarkupInput),h.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=h.notebookSearchConfig.includeMarkupPreview),h.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=h.notebookSearchConfig.includeCodeInput),h.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=h.notebookSearchConfig.includeOutput),W}file(m,h={}){return{...this.h(m,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}g(m,h){return m?(m=Array.isArray(m)?m.map(w):w(m),h?this.parseSearchPaths(m):{pattern:r(...Array.isArray(m)?m:[m])}):{}}h(m=[],h={}){const P=this.g(h.includePattern,h.expandPatterns),W=this.g(h.excludePattern,h.expandPatterns),K=m.length>1,z=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(N=>this.q(N,h,W)):m.map(N=>this.r(N,h,W,K))).filter(N=>!!N),j={_reason:h._reason,folderQueries:z,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:W.pattern,includePattern:P.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const N=y.$Hb(y.$Rb(this.c.groups.map(Ee=>Ee.editors.map(Se=>Se.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const ie=N.filter(Ee=>(0,E.$RI)(j,Ee.fsPath)),X=this.i(ie);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...j,...X}}const O=h.extraFileResources&&h.extraFileResources.filter(N=>(0,E.$RI)(j,N.fsPath));return j.extraFileResources=O&&O.length?O:void 0,j}i(m){const h=[],P=new A.$Ac,W={};let K=!1;return m.forEach(z=>{if(z.scheme===l.Schemas.walkThrough)return;if((0,g.$zg)(z)){const O=this.b.getWorkspaceFolder(z)?.uri??z.with({path:D.$mc(z.fsPath)});let N=P.get(O);N||(K=!0,N={folder:O,includePattern:{}},h.push(N),P.set(O,N));const ie=D.$lc(O.fsPath,z.fsPath);(0,k.$Jf)(N.includePattern)[ie.replace(/\\/g,"/")]=!0}else z.fsPath&&(K=!0,W[z.fsPath]=!0)}),{folderQueries:h,includePattern:W,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(m,h){if(h.isSmartCase){if(m.isRegExp){if(R.$pf(m.pattern,!0))return!0}else if(R.$pf(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,b.$uB)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const h=X=>D.$ic(X)||/^\.\.?([\/\\]|$)/.test(X),W=(Array.isArray(m)?m:s(m)).map(X=>{const Ee=this.e.resolvedUserHome;return Ee?(0,T.$uv)(X,Ee.scheme===l.Schemas.file?Ee.fsPath:Ee.path):X}),K=M.$J(W,X=>h(X)?"searchPaths":"exprSegments"),z=(K.exprSegments||[]).map(X=>R.$Ke(X,"/")).map(X=>R.$Ke(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),o(X))),j={},O=this.m(K.searchPaths||[]);O&&O.length&&(j.searchPaths=O);const N=y.$Rb(z),ie=r(...N);return ie&&(j.pattern=ie),j}l(m,h){return h.disregardExcludeSettings?void 0:(0,E.$QI)(m,!h.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const h=m.flatMap(W=>{let{pathPortion:K,globPortion:z}=n(W);return z&&(z=d(z)),this.n(K).flatMap(O=>this.o(O,z))}),P=new Map;return h.forEach(W=>{const K=W.searchPath.toString(),z=P.get(K);z?W.pattern&&(z.pattern=z.pattern||{},z.pattern[W.pattern]=!0):P.set(K,{searchPath:W.searchPath,pattern:W.pattern?r(W.pattern):void 0})}),Array.from(P.values())}n(m){if(D.$ic(m)){const h=this.b.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==l.Schemas.file?[{searchPath:h[0].uri.with({path:m})}]:[{searchPath:c.URI.file(D.$hc(m))}]}if(this.b.getWorkbenchState()===2){const h=this.b.getWorkspace().folders[0].uri;if(m=w(m),m.startsWith("../")||m===".."){const W=D.$gc.resolve(h.path,m);return[{searchPath:h.with({path:W})}]}const P=d(m);return[{searchPath:h,pattern:P}]}else{if(m==="./"||m===".\\")return[];{const h=m.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(K=>{const z=h.match(new RegExp(`^${R.$Fe(K.name)}(?:/(.*)|$)`));return z?{match:z,folder:K}:null}).filter(k.$Gf);if(W.length)return W.map(K=>{const z=K.match[1];return{searchPath:K.folder.uri,pattern:z&&d(z)}});{const K=m.match(/\.[\/\\](.+)[\/\\]?/),z=K?K[1]:m,j=p.localize(0,null,z);throw new Error(j)}}}}o(m,h){const P=m.pattern&&h?`${m.pattern}/${h}`:m.pattern||h,W=[{searchPath:m.searchPath,pattern:P}];return P&&!P.endsWith("**")&&W.push({searchPath:m.searchPath,pattern:P+"/**"}),W}q(m,h,P){const W=this.r((0,i.$$h)(m.searchPath),h,P,!1);return W?{...W,includePattern:m.pattern}:null}r(m,h,P,W){let K;const z=c.URI.isUri(m)?m:m.uri;if(P.searchPaths){const X=P.searchPaths.filter(Ee=>(0,g.$og)(Ee.searchPath,z))[0];if(X&&!X.pattern)return null;X&&(K=X.pattern)}const j=this.a.getValue({resource:z}),N={...this.l(j,h)||{},...K||{}},ie=c.URI.isUri(m)?(0,g.$sg)(m):m.name;return{folder:z,folderName:W?ie:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof h.disregardParentIgnoreFiles=="boolean"?h.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!j.search.followSymlinks}}};e.$WJ=v,e.$WJ=v=qe([Ke(0,f.$ji),Ke(1,i.$Yh),Ke(2,a.$eC),Ke(3,t.$0i),Ke(4,$.$UJ)],v);function n(u){const m=u.match(/[\*\{\}\(\)\[\]\?]/);if(m){const h=m.index,P=u.substr(0,h).match(/[/|\\][^/\\]*$/);if(P){let W=u.substr(0,P.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:u.substr((P.index||0)+1)}}}return{pathPortion:u}}function r(...u){return u.length?u.reduce((m,h)=>(m[h]=!0,m),Object.create(null)):void 0}function s(u){return C.$uj(u,",").map(m=>m.trim()).filter(m=>!!m.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function w(u){return u.replace(/\\/g,"/")}function d(u){return w(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(u){return u.replace(/([?*[\]])/g,"[$1]")}function S(u,m){u=y.$Mb(u,W=>W.toString());const h=[],P=m.getWorkspace();return u&&u.forEach(W=>{let K;if(m.getWorkbenchState()===2)K=(0,g.$xg)(P.folders[0].uri,W),K&&K!=="."&&(K="./"+K);else{const z=m.getWorkspaceFolder(W);if(z){const j=z.name;if(P.folders.filter(N=>N.name===j).length===1){const N=(0,g.$xg)(z.uri,W);N===""?K=`./${z.name}`:K=`./${z.name}/${N}`}else K=W.fsPath}}K&&h.push(I(K))}),h}e.$XJ=S}),define(Ae[271],Re([1,0,24,2,19,9,4,270,48,55]),function(ye,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alb=e.$zlb=void 0;const R=7e3;function k(f,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const a=[],$=[];for(const o of i)if(/^workspaceContains:/.test(o)){const w=o.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||f.forceUsingSearch?$.push(w):a.push(w)}if(a.length===0&&$.length===0)return Promise.resolve(void 0);let E;const v=new Promise((o,w)=>{E=o}),n=o=>E({activationEvent:o}),r=Promise.all(a.map(o=>c(f,o,n))).then(()=>{}),s=b(f,t.identifier,$,n);return Promise.all([r,s]).then(()=>{E(void 0)}),v}e.$zlb=k;async function c(f,t,i){for(const a of f.folders)if(await f.exists(y.$vg(M.URI.revive(a),t))){i(`workspaceContains:${t}`);return}}async function b(f,t,i,a){if(i.length===0)return Promise.resolve(void 0);const $=new C.$Xd,E=f.checkExists(f.folders,i,$.token),v=setTimeout(async()=>{$.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},R);let n=!1;try{n=await E}catch(r){T.$4(r)||T.$1(r)}$.dispose(),clearTimeout(v),n&&a(`workspaceContains:${i.join(",")}`)}function p(f,t,i,a){const $=f.get(A.$Oh),E=f.get(D.$II),n=$.createInstance(l.$WJ).file(t.map(r=>(0,g.$$h)(M.URI.revive(r))),{_reason:"checkExists",includePattern:i,exists:!0});return E.fileSearch(n,a).then(r=>!!r.limitHit,r=>T.$4(r)?!1:Promise.reject(r))}e.$Alb=p}),define(Ae[35],Re([1,0,148,20,87,24,12,6,49,2,14,3,34,210,84,33,22,106,9,21,26,188,7,97,4,27,85,17,71,86,63,5,271,83,190,13,81,59,23,82]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E,v,n,r,s,o,w,d,I,S,u,m,h,P,W,K,z,j,O,N){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=e.$Ucc=e.$Tcc=e.$Scc=void 0,e.$Scc=(0,s.$Ph)("IHostUtils");let X=ie=class extends l.$Sc{constructor(_,B,Z,ee,ve,ge,he,De,re,le,ne,ae){super(),this.X=ae,this.a=this.B(new m.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=Z,this.f=he,this.j=ee,this.m=ve,this.s=ge,this.t=re,this.u=le,this.w=ne,this.y=this.g.getProxy(k.$gK.MainThreadWorkspace),this.z=this.g.getProxy(k.$gK.MainThreadTelemetry),this.C=this.g.getProxy(k.$gK.MainThreadExtensionService),this.D=new A.$Sg,this.F=new A.$Sg,this.G=new A.$Sg,this.H=new A.$Sg,this.I=new oe(this.f.extensions.activationEvents),this.L=new i.$k4b(this.I,this.f.extensions.allExtensions);const fe=new $.$7l(this.f.extensions.myExtensions);this.J=new i.$k4b(this.I,pe(this.L,fe)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new p.$zcc(this.g,this.s),this.N=new P.$Lcc(this.g),this.O=De,this.h=_.createChild(new I.$Nh([p.$Acc,this.M],[P.$Mcc,this.N])),this.P=this.B(new b.$ycc(this.J,this.L,{onExtensionActivationError:(Ie,F,V)=>{this.C.$onExtensionActivationError(Ie,a.$3(F),V)},actualActivateExtension:async(Ie,F)=>{if(i.$k4b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,F),new b.$xcc;const V=this.J.getExtensionDescription(Ie);return this.db(V,F)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(_){a.$1(_)}}async Y(){this.O.onWillDeactivateAll();let _=[];try{_=this.J.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.cb(ve))}catch{}await Promise.all(_)}terminate(_,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${_}`),this.s.flush(),this.u.dispose(),this.P.dispose(),a.setUnexpectedErrorHandler(ee=>{this.s.error(ee)}),this.g.dispose();const Z=this.Y();Promise.race([(0,A.$Ug)(5e3),Z]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(_){return this.G.isOpen()?this.P.isActivated(_):!1}async getExtension(_){const B=await this.C.$getExtension(_);return B&&{...B,identifier:new $.$6l(B.identifier.value),extensionLocation:g.URI.revive(B.extensionLocation)}}Z(_,B){return this.P.activateByEvent(_,B)}$(_,B){return this.P.activateById(_,B)}activateByIdWithErrors(_,B){return this.$(_,B).then(()=>{const Z=this.P.getActivatedExtension(_);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(_=>this.J)}getExtensionExports(_){if(this.G.isOpen())return this.P.getActivatedExtension(_).exports;try{return this.P.getActivatedExtension(_).exports}catch{return null}}async ab(_){if(_.scheme===K.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(_.fsPath);return g.URI.file(B)}return _}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(_=>new ue(_))),this.Q}async bb(_){const B=D.$Vh.forUris(Z=>T.$mg.ignorePathCasing(Z));return await Promise.all(_.map(async Z=>{if(this.ub(Z)){const ee=await this.ab(Z.extensionLocation);B.set(ee,Z)}})),B}cb(_){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(_))return B;const Z=this.P.getActivatedExtension(_);if(!Z)return B;try{typeof Z.module.deactivate=="function"&&(B=Promise.resolve(Z.module.deactivate()).then(void 0,ee=>(this.s.error(ee),Promise.resolve(void 0))))}catch(ee){this.s.error(`An error occurred when deactivating the extension '${_.value}':`),this.s.error(ee)}try{(0,l.$Nc)(Z.subscriptions)}catch(ee){this.s.error(`An error occurred when deactivating the subscriptions for extension '${_.value}':`),this.s.error(ee)}return B}async db(_,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(_.identifier):await this.C.$onWillActivateExtension(_.identifier),this.fb(_,B).then(Z=>{const ee=Z.activationTimes;return this.C.$onDidActivateExtension(_.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,B),this.eb(_,B,"success",ee),Z},Z=>{throw this.eb(_,B,"failure"),Z})}eb(_,B,Z,ee){const ve=Se(_,B);this.z.$publicLog2("extensionActivationTimes",{...ve,...ee||{},outcome:Z})}fb(_,B){const Z=Se(_,B);this.z.$publicLog2("activatePlugin",Z);const ee=this.ub(_);if(!ee)return Promise.resolve(new b.$wcc(b.$tcc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${_.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${_.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const ve=new b.$ucc(B.startup);return Promise.all([this.vb(_,(0,T.$vg)(_.extensionLocation,ee),ve),this.gb(_)]).then(ge=>(C.mark(`code/extHost/willActivateExtension/${_.identifier.value}`),ie.hb(this.s,_.identifier,ge[0],ge[1],ve))).then(ge=>(C.mark(`code/extHost/didActivateExtension/${_.identifier.value}`),ge))}gb(_){const B=new v.$Ccc(_,this.M),Z=new v.$Bcc(_.identifier.value,!1,this.M),ee=new W.$Ncc(_,this.N),ve=_.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ge=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${_.identifier.value}`),Promise.all([B.whenReady,Z.whenReady,this.O.whenReady]).then(()=>{const he=this;let De,re;const le=(0,t.$dF)(_,"ipc")?this.f.messagePorts?.get($.$6l.toKey(_.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:Z,secrets:ee,subscriptions:[],get extensionUri(){return _.extensionLocation},get extensionPath(){return _.extensionLocation.fsPath},asAbsolutePath(ne){return M.$jc(_.extensionLocation.fsPath,ne)},get storagePath(){return he.O.workspaceValue(_)?.fsPath},get globalStoragePath(){return he.O.globalValue(_).fsPath},get logPath(){return M.$jc(he.f.logsLocation.fsPath,_.identifier.value)},get logUri(){return g.URI.joinPath(he.f.logsLocation,_.identifier.value)},get storageUri(){return he.O.workspaceValue(_)},get globalStorageUri(){return he.O.globalValue(_)},get extensionMode(){return ve},get extension(){return De===void 0&&(De=new $e(he,_.identifier,_,ge,!1)),De},get extensionRuntime(){return(0,t.$eF)(_,"extensionRuntime"),he.extensionRuntime},get environmentVariableCollection(){return he.u.getEnvironmentVariableCollection(_)},get messagePassingProtocol(){if(!re){if(!le)return;const ne=m.Event.buffer(m.Event.fromDOMEventEmitter(le,"message",ae=>ae.data));le.start(),re={onDidReceiveMessage:ne,postMessage:le.postMessage.bind(le)}}return re}})})}static hb(_,B,Z,ee,ve){return Z=Z||{activate:void 0,deactivate:void 0},this.ib(_,B,Z,ee,ve).then(ge=>new b.$vcc(!1,null,ve.build(),Z,ge,ee.subscriptions))}static ib(_,B,Z,ee,ve){if(typeof Z.activate=="function")try{ve.activateCallStart(),_.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ge=typeof global=="object"?global:self,he=Z.activate.apply(ge,[ee]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(he).then(De=>(ve.activateResolveStop(),De))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(Z)}jb(_,B){this.$(_.identifier,{startup:!1,extensionId:_.identifier,activationEvent:B}).then(void 0,Z=>{this.s.error(Z)})}kb(_,B=0){const ee=Date.now();(0,O.$B)(()=>{for(let ve=B;ve<_.length;ve+=1){const ge=_[ve];for(const he of ge.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-ee>50){this.kb(_,ve);break}else this.jb(ge,he)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(_=>{const B=_.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Z=this.J.getAllExtensionDescriptions();if(B)this.kb(Z);else for(const ee of Z)if(ee.activationEvents)for(const ve of ee.activationEvents)ve==="onStartupFinished"&&this.jb(ee,ve)})}mb(){const _=this.Z("*",!0).then(void 0,ge=>{this.s.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.nb(ge.added)));const B=this.j.workspace?this.j.workspace.folders:[],Z=this.nb(B),ee=this.pb(),ve=Promise.all([ee,_,Z]).then(()=>{});return Promise.race([ve,(0,A.$Ug)(1e4)]).then(()=>{this.lb()}),ve}nb(_){return _.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(_,B))).then(()=>{})}async ob(_,B){if(this.isActivated(B.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,ee={logService:this.s,folders:_.map(ge=>ge.uri),forceUsingSearch:Z||!this.c.fsExists,exists:ge=>this.c.fsExists(ge.fsPath),checkExists:(ge,he,De)=>this.y.$checkExists(ge,he,De)},ve=await(0,h.$zlb)(ee,B);if(ve)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:ve.activationEvent}).then(void 0,ge=>this.s.error(ge))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(_){throw console.error(_),_}}async qb(){const{extensionDevelopmentLocationURI:_,extensionTestsLocationURI:B}=this.f.environment;if(!_||!B)throw new Error(y.localize(0,null));const Z=await this.vb(null,B,new b.$ucc(!1));if(!Z||typeof Z.run!="function")throw new Error(y.localize(1,null,B.toString()));return new Promise((ee,ve)=>{const ge=(re,le)=>{re?(O.$t&&this.s.error("Test runner called back with error",re),ve(re)):(O.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),ee(typeof le=="number"&&le>0?1:0))},he=(0,T.$jg)(B),De=Z.run(he,ge);De&&De.then&&De.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),ee(0)}).catch(re=>{O.$t&&this.s.error("Test runner finished with error",re),ve(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(_,B){return this.R[_]=B,(0,l.$Qc)(()=>{delete this.R[_]})}async getRemoteExecServer(_){const{resolver:B}=await this.sb(_);return B?.resolveExecServer?.(_,{resolveAttempt:0})}async sb(_){const B=_.indexOf("+");if(B===-1)throw new n.$oK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Z=_.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.R[Z]}}async $resolveAuthority(_,B){const Z=j.$Jd.create(!1),ee=()=>`[resolveAuthority(${(0,r.$Tk)(_)},${B})][${Z.elapsed()}ms] `,ve=J=>this.s.info(`${ee()}${J}`),ge=J=>this.s.warn(`${ee()}${J}`),he=(J,q=void 0)=>this.s.error(`${ee()}${J}`,q),De=J=>{if(J instanceof n.$oK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},re=async J=>{ve(`activating resolver for ${J}...`);const{resolver:q,authorityPrefix:x}=await this.sb(J);if(!q)throw he(`no resolver for ${x}`),new n.$oK(`No remote extension installed to resolve ${x}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:J}},le=_.split(/@|%40/g).reverse();ve(`activating remote resolvers ${le.join(" -> ")}`);let ne;try{ne=await Promise.all(le.map(re)).catch(async J=>{if(!(J instanceof n.$oK)||J._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return ge(`resolving nested authorities failed: ${J.message}`),[await re(_)]})}catch(J){return De(J)}const ae=new A.$5g;ae.cancelAndSet(()=>ve("waiting..."),1e3);let fe,Ie;for(const[J,{authorityPrefix:q,resolver:x,remoteAuthority:ce}]of ne.entries())try{if(J===ne.length-1)ve("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${q}`),fe=await x.resolve(ce,{resolveAttempt:B,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${q}`),ve("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$nK.isManagedResolvedAuthority(fe)?fe:void 0));else{if(ve(`invoking resolveExecServer() for ${ce}`),C.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await x.resolveExecServer?.(ce,{resolveAttempt:B,execServer:Ie}),!Ie)throw new n.$oK(`Exec server was not available for ${ce}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Ne){return C.mark(`code/extHost/didResolveAuthorityError/${q}`),he("returned an error",Ne),ae.dispose(),De(Ne)}ae.dispose();const F={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},V={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};ve(`returned ${n.$nK.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let G;if(n.$nK.isManagedResolvedAuthority(fe)){const J=B;this.X.setFactory(J,fe.makeConnection),G={authority:_,connectTo:new r.$Qk(J),connectionToken:fe.connectionToken}}else G={authority:_,connectTo:new r.$Rk(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:G,options:V,tunnelInformation:F}}}async $getCanonicalURI(_,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Tk)(_)})`);const{resolver:Z}=await this.sb(_);if(!Z)return null;const ee=g.URI.revive(B);if(typeof Z.getCanonicalURI>"u")return ee;const ve=await(0,A.$Mg)(()=>Z.getCanonicalURI(ee));return ve||ee}$startExtensionHost(_){_.toAdd.forEach(ee=>ee.extensionLocation=g.URI.revive(ee.extensionLocation));const{globalRegistry:B,myExtensions:Z}=Ee(this.I,this.L,this.J,_);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(Z),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(_,B){return B===1?this.D.wait().then(Z=>this.Z(_,!1)):this.G.wait().then(Z=>this.Z(_,!1))}async $activate(_,B){return await this.G.wait(),this.J.getExtensionDescription(_)?(await this.$(_,B),!0):!1}async $deltaExtensions(_){_.toAdd.forEach(ge=>ge.extensionLocation=g.URI.revive(ge.extensionLocation));const{globalRegistry:B,myExtensions:Z}=Ee(this.I,this.L,this.J,_),ee=await this.bb(Z);return(await this.getExtensionPathIndex()).setSearchTree(ee),this.L.set(B.getAllExtensionDescriptions()),this.J.set(Z),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(_){return _}async $test_up(_){return _.byteLength}async $test_down(_){const B=E.$be.alloc(_),Z=Math.random()%256;for(let ee=0;ee<_;ee++)B.writeUInt8(Z,ee);return B}async $updateRemoteConnectionData(_){this.W=_,this.a.fire()}};e.$Tcc=X,e.$Tcc=X=ie=qe([Ke(0,s.$Oh),Ke(1,e.$Scc),Ke(2,d.$hM),Ke(3,f.$mcc),Ke(4,c.$pcc),Ke(5,R.$0i),Ke(6,o.$xM),Ke(7,w.$Fcc),Ke(8,S.$6vb),Ke(9,u.$Hcc),Ke(10,z.$Pcc),Ke(11,N.$Qcc)],X);function Ee(be,_,B,Z){be.addActivationEvents(Z.addActivationEvents);const ee=new i.$k4b(be,_.getAllExtensionDescriptions());ee.deltaExtensions(Z.toAdd,Z.toRemove);const ve=new $.$7l(B.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of Z.myToRemove)ve.delete(he);for(const he of Z.myToAdd)ve.add(he);const ge=pe(ee,ve);return{globalRegistry:ee,myExtensions:ge}}function Se(be,_){return{id:be.identifier.value,name:be.name,extensionVersion:be.version,publisherDisplayName:be.publisher,activationEvents:be.activationEvents?be.activationEvents.join(","):null,isBuiltin:be.isBuiltin,reason:_.activationEvent,reasonId:_.extensionId.value}}function Pe(be){return be.getAllExtensionDescriptions().map(_=>_.identifier.value).join(",")}e.$Ucc=(0,s.$Ph)("IExtHostExtensionService");class $e{#e;#t;#i;constructor(_,B,Z,ee,ve){this.#e=_,this.#t=B,this.#i=Z.identifier,this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=M.$hc((0,T.$jg)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=ee,this.isFromDifferentExtensionHost=ve}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Vcc=$e;function pe(be,_){return be.getAllExtensionDescriptions().filter(B=>_.has(B.identifier))}class ue{constructor(_){this.a=_}setSearchTree(_){this.a=_}findSubstr(_){return this.a.findSubstr(_)}forEach(_){return this.a.forEach(_)}}e.$Wcc=ue;class oe{constructor(_){this.a=new $.$8l,this.addActivationEvents(_)}readActivationEvents(_){return this.a.get(_.identifier)}addActivationEvents(_){for(const B of Object.keys(_))this.a.set(B,_[B])}}}),define(Ae[272],Re([1,0,87,2,3,34,22,21,17,27,4,35,14,16]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;let f=class{constructor(E,v,n,r,s,o,w){this.c=E,this.d=v,this.e=n,this.f=r,this.g=s,this.h=o,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const E=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const v=await this.g.getExtensionPathIndex();this.register(new i(this.c,v,this.d,E,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(a,v,this.h.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const v of E.nodeModuleName)this.a.set(v,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push(v=>E.alternativeModuleName(v))}};e.$iec=f,e.$iec=f=qe([Ke(2,R.$Oh),Ke(3,T.$pcc),Ke(4,k.$Ucc),Ke(5,g.$xM),Ke(6,c.$0i)],f);let t=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(E){if(E.environment.appRoot&&p.a.size){const v=(0,b.$Fe)(this.c(E.environment.appRoot.fsPath)),n="[a-z0-9_.-]",r=`@${n}+\\/${n}+|${n}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${v}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const v=this.b.exec(this.c(E));if(!v)return;const[,n,r,s]=v,o=p.a.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),n+o+s}c(E){return E.replace(/\\/g,"/")}};t=p=qe([Ke(0,g.$xM)],t);class i{constructor(E,v,n,r,s){this.c=E,this.d=v,this.e=n,this.f=r,this.g=s,this.nodeModuleName="vscode",this.a=new l.$8l}load(E,v){const n=this.d.findSubstr(v);if(n){let r=this.a.get(n.identifier);return r||(r=this.c(n,this.e,this.f),this.a.set(n.identifier,r)),r}if(!this.b){let r="";this.d.forEach((s,o)=>r+=`	${o} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${v}. These are the extension path mappings: 
${r}`),this.b=this.c(A.$$E,this.e,this.f)}return this.b}}let a=class{constructor(E,v,n){this.e=E,this.f=v,this.nodeModuleName=["open","opn"],this.d=n.getProxy(C.$gK.MainThreadTelemetry);const r=n.getProxy(C.$gK.MainThreadWindow);this.c=(s,o)=>{const w=M.URI.parse(s);return o?this.g(s,o):w.scheme==="http"||w.scheme==="https"?r.$openUri(w,s,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?r.$openUri(w,s,{}):this.g(s,o)}}load(E,v,n){const r=this.e.findSubstr(v);return r&&(this.a=r.identifier.value,this.h()),this.b=n(E),this.c}g(E,v){return this.i(),this.b(E,v)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};a=qe([Ke(2,D.$hM)],a)}),define(Ae[112],Re([1,0,42,6,20,73,4,60,61,35,7,33,201,34]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.$qdc=void 0,e.$qdc=(0,A.$Ph)("IExtHostVariableResolverProvider");class p extends c.$iN{constructor(i,a,$,E,v,n,r){function s(){if($){const o=$.activeEditor();if(o)return o.document.uri;const w=E.tabGroups.all.find(d=>d.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof R.$1L||w.input instanceof R.$6L)return w.input.modified;if(w.input instanceof R.$ZL||w.input instanceof R.$5L||w.input instanceof R.$3L)return w.input.uri}}}super({getFolderUri:o=>{const w=n.folders.filter(d=>d.name===o);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,w)=>v.getConfiguration(void 0,o).get(w),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return C.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const o=s();if(o){const w=a.getWorkspaceFolder(o);if(w)return C.$hc(w.uri.fsPath)}}},getSelectedText:()=>{if($){const o=$.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if($){const o=$.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(T.env))}}let f=class extends M.$Sc{constructor(i,a,$,E,v){super(),this.b=i,this.c=a,this.g=$,this.h=E,this.j=v,this.a=new y.$V(async()=>{const n=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,n,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$rdc=f,e.$rdc=f=qe([Ke(0,g.$Ucc),Ke(1,k.$mcc),Ke(2,l.$sM),Ke(3,b.$pcc),Ke(4,D.$odc)],f)}),define(Ae[113],Re([1,0,12,5,2,4,3,61,35,17,7,33,194,196,34,112]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=e.$udc=e.$tdc=e.$sdc=void 0,e.$sdc=(0,T.$Ph)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,s,o,w,d,I){this.E=s,this.F=o,this.G=w,this.H=d,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Nd,this.n=new M.$Nd,this.o=new M.$Nd,this.u=new M.$Nd,this.k=r.getProxy(A.$gK.MainThreadDebugService),this.y=new M.$Nd,this.A=new M.$Nd,this.v=new a(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(u=>{this.J(S)}),this.J(S)})}asDebugSourceUri(r,s){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let w=`debug:${encodeURIComponent(o.path||"")}`,d="?";return s&&(w+=`${d}session=${encodeURIComponent(s.id)}`,d="&"),w+=`${d}ref=${o.sourceReference}`,C.URI.parse(w)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const s=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const w=o.contributes.debuggers;if(w&&w.length>0)for(const d of w)(0,b.$sF)(d)&&s.push(d.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(s=>r.push(s)),r}addBreakpoints(r){const s=r.filter(d=>{const I=d.id;return this.w.has(I)?!1:(this.w.set(I,d),!0)});this.U(s,[],[]);const o=[],w=new Map;for(const d of s)if(d instanceof R.$hL){let I=w.get(d.location.uri.toString());I||(I={type:"sourceMulti",uri:d.location.uri,lines:[]},w.set(d.location.uri.toString(),I),o.push(I)),I.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof R.$iL&&o.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(r){const s=r.filter(I=>this.w.delete(I.id));this.U([],s,[]);const o=s.filter(I=>I instanceof R.$hL).map(I=>I.id),w=s.filter(I=>I instanceof R.$iL).map(I=>I.id),d=s.filter(I=>I instanceof R.$jL).map(I=>I.id);return this.k.$unregisterBreakpoints(o,w,d)}startDebugging(r,s,o){return this.k.$startDebugging(r?r.uri:void 0,s,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,o){if(!s)return new R.$iK(()=>{});const w=this.d++;return this.f.push({type:r,handle:w,provider:s}),this.k.$registerDebugConfigurationProvider(r,o,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,w),new R.$iK(()=>{this.f=this.f.filter(d=>d.provider!==s),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(r,s,o){if(!o)return new R.$iK(()=>{});if(!this.Q(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:s,handle:w,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(s,w),new R.$iK(()=>{this.h=this.h.filter(d=>d.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new R.$iK(()=>{});const o=this.i++;return this.j.push({type:r,handle:o,factory:s}),new R.$iK(()=>{this.j=this.j.filter(w=>w.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let o;const w=await this.W(r);return w&&(o={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,s)}K(r,s){if(r.type==="implementation")return new E(r.implementation)}L(){}async $startDASession(r,s){const o=this,w=await this.V(s);return this.S(this.N(w.type),w).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const I=this.M(d),S=this.K(I,w);if(!S)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const u=S;return this.B.set(r,u),this.R(w).then(m=>(m&&this.C.set(r,m),u.onMessage(async h=>{if(h.type==="request"&&h.command==="handshake"){const P=h,W={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const K=await this.D.sign(P.arguments.value);W.body={signature:K},u.sendResponse(W)}else throw new Error("no signer")}catch(K){W.success=!1,W.message=K.message,u.sendResponse(W)}}else m&&m.onDidSendMessage&&m.onDidSendMessage(h),h=(0,b.$xF)(h,!0),o.k.$acceptDAMessage(r,h)}),u.onError(h=>{m&&m.onError&&m.onError(h),this.k.$acceptDAError(r,h.name,h.message,h.stack)}),u.onExit(h=>{m&&m.onExit&&m.onExit(h??void 0,void 0),this.k.$acceptDAExit(r,h??void 0,void 0)}),m&&m.onWillStartSession&&m.onWillStartSession(),u.startSession()))})}$sendDAMessage(r,s){s=(0,b.$wF)(s,!1);const o=this.C.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(s),this.B.get(r)?.sendMessage(s)}$stopDASession(r){const s=this.C.get(r);this.C.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const o=this.B.get(r);return this.B.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],o=[],w=[];if(r.added)for(const d of r.added){const I=d.id;if(I&&!this.w.has(I)){let S;if(d.type==="function")S=new R.$iL(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")S=new R.$jL(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const u=C.URI.revive(d.uri);S=new R.$hL(new R.$uK(u,new R.$jK(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,R.$fL)(S,I),this.w.set(I,S),s.push(S)}}if(r.removed)for(const d of r.removed){const I=this.w.get(d);I&&(this.w.delete(d),o.push(I))}if(r.changed){for(const d of r.changed)if(d.id){const I=this.w.get(d.id);if(I){if(I instanceof R.$iL&&d.type==="function"){const S=I;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.functionName=d.functionName}else if(I instanceof R.$hL&&d.type==="source"){const S=I;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.location=new R.$uK(C.URI.revive(d.uri),new R.$jK(d.line,d.character))}w.push(I)}}}this.U(s,o,w)}async $acceptStackFrameFocus(r){let s;const o=r.sessionId?await this.V(r.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s=new R.$pL(o,r.threadId):s=new R.$oL(o,r.threadId,r.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(r,s,o){return(0,y.$Mg)(async()=>{const w=this.P(r);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(s);return w.provideDebugConfigurations(d,o)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(r,s,o,w){return(0,y.$Mg)(async()=>{const d=this.P(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(s);return d.resolveDebugConfiguration(I,o,w)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,o,w){return(0,y.$Mg)(async()=>{const d=this.P(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(s);return d.resolveDebugConfigurationWithSubstitutedVariables(I,o,w)})}async $provideDebugAdapter(r,s){const o=this.O(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(s);return this.S(o,w).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(r){const s=await this.V(r);this.m.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.V(r);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,s){(await this.V(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const w={session:await this.V(r),event:s.event,body:s.body};this.u.fire(w)}M(r){if(r instanceof R.$kL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof R.$lL)return{type:"server",port:r.port,host:r.host};if(r instanceof R.$mL)return{type:"pipeServer",path:r.path};if(r instanceof R.$nL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const s=this.h.filter(o=>o.type===r);if(s.length>0)return s[0].factory}O(r){const s=this.h.filter(o=>o.handle===r);if(s.length>0)return s[0].factory}P(r){const s=this.f.filter(o=>o.handle===r);if(s.length>0)return s[0].provider}Q(r,s){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const w of o)if(w.label&&w.type&&w.type===s)return!0}}return!1}R(r){const o=r.configuration.type,w=this.j.filter(d=>d.type===o||d.type==="*").map(d=>(0,y.$Mg)(()=>d.factory.createDebugAdapterTracker(r)).then(I=>I,I=>null));return Promise.race([Promise.all(w).then(d=>{const I=d.filter(S=>!!S);if(I.length>0)return new $(I)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(r,s){const o=s.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new R.$lL(o));if(r){const d=await this.F.getExtensionRegistry();return(0,y.$Mg)(()=>r.createDebugAdapterDescriptor(s,this.T(s,d))).then(I=>{if(I)return I})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,w))}T(r,s){}U(r,s,o){(r.length>0||s.length>0||o.length>0)&&this.y.fire(Object.freeze({added:r,removed:s,changed:o}))}async V(r){if(r)if(typeof r=="string"){const s=this.l.get(r);if(s)return s}else{let s=this.l.get(r.id);if(!s){const o=await this.W(r.folderUri),w=r.parent?this.l.get(r.parent):void 0;s=new i(this.k,r.id,r.type,r.name,o,r.configuration,w),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(r){if(r){const s=C.URI.revive(r);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$tdc=t,e.$tdc=t=qe([Ke(0,g.$hM),Ke(1,k.$mcc),Ke(2,D.$Ucc),Ke(3,p.$pcc),Ke(4,l.$odc),Ke(5,f.$qdc)],t);class i{constructor(r,s,o,w,d,I,S){this.d=r,this.f=s,this.g=o,this.h=w,this.i=d,this.j=I,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,s){return this.d.$customDebugAdapterRequest(this.f,r,s)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$udc=i;class a{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$vdc=a;class ${constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.d.forEach(o=>o.onExit?o.onExit(r,s):void 0)}}class E extends c.$6cb{constructor(r){super(),this.h=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends t{constructor(r,s,o,w,d,I){super(r,s,o,w,d,I)}};e.$wdc=v,e.$wdc=v=qe([Ke(0,g.$hM),Ke(1,k.$mcc),Ke(2,D.$Ucc),Ke(3,p.$pcc),Ke(4,l.$odc),Ke(5,f.$qdc)],v)}),define(Ae[273],Re([1,0,9,87,2,3,264,14,70,71,27,172,17,56,35,58]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=e.$jec=void 0;class t{static async installEarlyHandler($){Error.stackTraceLimit=100;const E=$.get(l.$0i),n=$.get(c.$hM).getProxy(T.$gK.MainThreadErrors);y.setUnexpectedErrorHandler(r=>{E.error(r);const s=y.$3(r);n.$onUnexpectedError(s)})}static async installFullHandler($){const E=$.get(l.$0i),v=$.get(c.$hM),n=$.get(p.$Ucc),r=$.get(f.$BM),s=v.getProxy(T.$gK.MainThreadExtensionService),o=v.getProxy(T.$gK.MainThreadErrors),w=await n.getExtensionPathIndex(),d=new WeakMap;function I(m,h){if(d.has(m))return d.get(m).stack;let P="",W,K;for(const j of h)P+=`
	at ${j.toString()}`,K=j.getFileName(),!W&&K&&(W=w.findSubstr(C.URI.file(K)));const z=`${m.name||"Error"}: ${m.message||""}${P}`;return d.set(m,{extensionIdentifier:W?.identifier,stack:z}),z}const S=Symbol("prepareStackTrace wrapped");let u=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(m){if(m===I||!m||m[S]){u=m||I;return}u=function(h,P){return I(h,P),m.call(Error,h,P)},Object.assign(u,{[S]:!0})}}),y.setUnexpectedErrorHandler(m=>{E.error(m);const h=y.$3(m),P=d.get(m);if(!P?.extensionIdentifier){o.$onUnexpectedError(h);return}s.$onExtensionRuntimeError(P.extensionIdentifier,h);const W=r.onExtensionError(P.extensionIdentifier,m);E.trace("forwarded error to extension?",W,P)})}}e.$jec=t;class i{constructor($,E,v,n,r){this.a=v,this.b=new A.$t4b($,null,n),E=i.e(E,this.b);const s=new g.$Nh(...(0,D.$yr)());s.set(R.$xM,{_serviceBrand:void 0,...E,messagePorts:r}),s.set(c.$hM,new c.$iM(this.b)),s.set(b.$jcc,new b.$kcc(n)),s.set(p.$Scc,v);const o=new k.$eq(s,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(w=>w.get(l.$0i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=o.invokeFunction(w=>w.get(p.$Ucc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri($){const E=this.b.getProxy(T.$gK.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri($))}terminate($){this.c.terminate($)}static e($,E){$.extensions.allExtensions.forEach(n=>{n.extensionLocation=C.URI.revive(E.transformIncomingURIs(n.extensionLocation))}),$.environment.appRoot=C.URI.revive(E.transformIncomingURIs($.environment.appRoot));const v=$.environment.extensionDevelopmentLocationURI;return v&&($.environment.extensionDevelopmentLocationURI=v.map(n=>C.URI.revive(E.transformIncomingURIs(n)))),$.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs($.environment.extensionTestsLocationURI)),$.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs($.environment.globalStorageHome)),$.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs($.environment.workspaceStorageHome)),$.environment.extensionTelemetryLogResource=C.URI.revive(E.transformIncomingURIs($.environment.extensionTelemetryLogResource)),$.nlsBaseUrl=C.URI.revive(E.transformIncomingURIs($.nlsBaseUrl)),$.logsLocation=C.URI.revive(E.transformIncomingURIs($.logsLocation)),$.workspace=E.transformIncomingURIs($.workspace),$}}e.$kec=i}),define(Ae[274],Re([1,0,18,12,19,37,13,20,24,2,48]),function(ye,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=e.$zdc=e.$ydc=void 0;class k{constructor(a,$,E,v){this.d=a,this.e=$,this.f=E,this.g=v,this.a=null,this.b=!1,this.c=0}search(a,$){const E=this.d.folderQueries||[],v=new C.$Xd($);return new Promise((n,r)=>{this.a=new b(a);let s=!1;const o=(w,d)=>{if(!s&&!this.b){const I=this.h(w);f(w)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,s=!0,v.cancel(),w=this.j(w,this.d.maxResults-this.c));const S=this.h(w);this.c+=S,(S>0||!f(w))&&this.a.add(w,d)}};Promise.all(E.map((w,d)=>this.k(w,I=>o(I,d),v.token))).then(w=>{v.dispose(),this.a.flush();const d=w.some(I=>!!I&&!!I.limitHit);n({limitHit:this.b||d,messages:(0,y.$Rb)(w.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},w=>{v.dispose();const d=(0,T.$Ai)(w);r(new Error(d))})})}h(a){return f(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}j(a,$){const E=Array.isArray(a.ranges)?a.ranges:[a.ranges],v=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:E.slice(0,$),preview:{matches:v.slice(0,$),text:a.preview.text},uri:a.uri}}async k(a,$,E){const v=new R.$2I(this.d,a),n=[],r={report:w=>{if(!this.l(w))return;const d=a.folder.scheme===A.Schemas.file?(0,R.$3I)(()=>this.f.readdir(D.$ug(w.uri))):void 0,I=D.$xg(a.folder,w.uri);if(I){const S=v.includedInQuery(I,l.$nc(I),d);(0,M.$Gg)(S)?n.push(S.then(u=>{u&&$(w)})):S&&$(w)}}},s=this.n(a),o=await this.e.provideTextSearchResults(c(this.d.contentPattern),s,r,E);return n.length&&await Promise.all(n),o}l(a){if(f(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(a){const $=(0,R.$1I)(this.d.includePattern,a.includePattern),E=(0,R.$1I)(this.d.excludePattern,a.excludePattern),v={folder:g.URI.from(a.folder),excludes:E,includes:$,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.f.toCanonicalName(a.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.$ydc=k;function c(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(a){this.e=a,this.b=-1,this.d=null,this.a=new t(512,$=>this.g($))}add(a,$){this.d&&(this.b!==$||!D.$og(this.c,a.uri))&&(this.f(),this.d=null),this.d||(this.b=$,this.d={resource:a.uri,results:[]}),this.d.results.push(p(a))}f(){const a=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,a)}flush(){this.f(),this.a.flush()}g(a){this.e(a)}}e.$zdc=b;function p(i){return f(i)?{preview:{matches:(0,y.$2b)(i.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:i.preview.text},ranges:(0,y.$2b)(i.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function f(i){return!!i.preview}e.$Adc=f;class t{static{this.a=4e3}static{this.b=50}constructor(a,$){this.g=a,this.h=$,this.c=0,this.d=[],this.e=0}addItem(a,$){a&&this.j(a,$)}addItems(a,$){a&&this.k(a,$)}j(a,$){this.d.push(a),this.e+=$,this.l()}k(a,$){this.d=this.d.concat(a),this.e+=$,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Bdc=t}),define(Ae[114],Re([1,0,6,3,4,269,17,56,14,2,274]),function(ye,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=e.$Ddc=e.$Cdc=void 0,e.$Cdc=(0,C.$Ph)("IExtHostSearch");let k=class{constructor(f,t,i){this.k=f,this.l=t,this.n=i,this.c=this.k.getProxy(M.$gK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new T.$xdc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(f)),(0,y.$Qc)(()=>{this.g.delete(f),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(f)),(0,y.$Qc)(()=>{this.i.delete(f),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(f,t,i,a){const $=c(i),E=this.h.get(f);if(E)return this.j.fileSearch($,E,v=>{this.c.$handleFileMatch(f,t,v.map(n=>n.resource))},a);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,i,a){const $=this.e.get(f);if(!$||!$.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const E=c(i);return this.q(E,$).search(n=>this.c.$handleTextMatch(f,t,n),a)}$enableExtensionHostSearch(){}q(f,t){return new R.$ydc(f,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$Ddc=k,e.$Ddc=k=qe([Ke(0,A.$hM),Ke(1,l.$jcc),Ke(2,D.$0i)],k);function c(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(f=>g.URI.revive(f))}}e.$Edc=c;function b(p){return{...p,folder:g.URI.revive(p.folder)}}}),define(Ae[275],Re([1,0,19,9,5,29,2,135,286,124,133,39,3,79,226,225,31,227,34,229,230,231,204,232,60,35,235,236,241,242,244,109,208,250,251,254,84,63,256,211,8,7,54,259,64,108,33,21,199,240,53,107,111,113,114,14,56,17,27,245,197,86,80,218,257,85,62,262,260,261,219,40,255,258,83,61,58,246,110,247,13,95,207,189,238,6,22,195,81,185,248,249,220,237,206,239,82,252,223,253,224,217,234,221,222]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E,v,n,r,s,o,w,d,I,S,u,m,h,P,W,K,z,j,O,N,ie,X,Ee,Se,Pe,$e,pe,ue,oe,be,_,B,Z,ee,ve,ge,he,De,re,le,ne,ae,fe,Ie,F,V,G,J,q,x,ce,Ne,Ue,Qe,Ge,xe,Ye,_e,it,tt,ze,st,Y,Q,we,Be,Oe,Xe,nt,ft,wt,Pt,Zt,Gt,pt,jt,Nt,Bt,At,Rt,Ot,Wt,Jt,Kt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;function Mt(ut){const dt=ut.get(re.$xM),Lt=ut.get(Ne.$_bc),qt=ut.get(G.$Ecc),kt=ut.get(o.$Ucc),at=ut.get(pe.$mcc),vt=ut.get(Ye.$BM),Ht=ut.get(a.$pcc),Ct=ut.get(he.$jcc),We=ut.get(De.$hM),Ce=ut.get(z.$Acc),Fe=ut.get(V.$Fcc),me=ut.get(ge.$$i),H=ut.get(ge.$0i),Me=ut.get(ae.$6vb),je=ut.get(fe.$ccc),Je=ut.get($e.$gdc),Ve=ut.get(Ge.$Mcc),et=ut.get(xe.$odc),bt=ut.get(Nt.$Qcc);We.set(c.$hK.ExtHostFileSystemInfo,Lt),We.set(c.$hK.ExtHostLogLevelServiceShape,me),We.set(c.$hK.ExtHostWorkspace,at),We.set(c.$hK.ExtHostConfiguration,Ht),We.set(c.$hK.ExtHostExtensionService,kt),We.set(c.$hK.ExtHostStorage,Ce),We.set(c.$hK.ExtHostTunnelService,Me),We.set(c.$hK.ExtHostWindow,Je),We.set(c.$hK.ExtHostSecretState,Ve),We.set(c.$hK.ExtHostTelemetry,vt),We.set(c.$hK.ExtHostEditorTabs,et),We.set(c.$hK.ExtHostManagedSockets,bt);const zt=We.set(c.$hK.ExtHostDecorations,ut.get(B.$kdc)),Dt=We.set(c.$hK.ExtHostDocumentsAndEditors,ut.get(s.$sM)),lt=We.set(c.$hK.ExtHostCommands,ut.get(t.$DM)),gt=We.set(c.$hK.ExtHostTerminalService,ut.get(j.$Hcc)),yt=We.set(c.$hK.ExtHostDebugService,ut.get(ee.$sdc)),mi=We.set(c.$hK.ExtHostSearch,ut.get(ve.$Cdc)),St=We.set(c.$hK.ExtHostTask,ut.get(Z.$ndc)),Si=We.set(c.$hK.ExtHostOutputService,ut.get(m.$3cc)),ui=We.set(c.$hK.ExtHostLocalization,ut.get(nt.$Pcc)),$i=We.set(c.$hK.ExtHostUrls,new Se.$_cc(We)),It=We.set(c.$hK.ExtHostDocuments,new r.$0bc(We,Dt)),fn=We.set(c.$hK.ExtHostDocumentContentProviders,new v.$rcc(We,Dt,H)),ri=We.set(c.$hK.ExtHostDocumentSaveParticipant,new n.$scc(H,It,We.getProxy(c.$gK.MainThreadBulkEdits))),Et=We.set(c.$hK.ExtHostNotebook,new le.$Idc(We,lt,Dt,It,qt)),pi=We.set(c.$hK.ExtHostNotebookDocuments,new Q.$1dc(Et)),vi=We.set(c.$hK.ExtHostNotebookEditors,new Y.$Zdc(H,Et)),si=We.set(c.$hK.ExtHostNotebookKernels,new _e.$Wdc(We,dt,Et,lt,H)),Ii=We.set(c.$hK.ExtHostNotebookRenderers,new tt.$Ydc(We,Et)),Ci=We.set(c.$hK.ExtHostNotebookDocumentSaveParticipant,new pt.$7dc(H,Et,We.getProxy(c.$gK.MainThreadBulkEdits))),Ft=We.set(c.$hK.ExtHostEditors,new O.$0cc(We,Dt)),bi=We.set(c.$hK.ExtHostTreeViews,new N.$$cc(We.getProxy(c.$gK.MainThreadTreeViews),lt,H)),Pi=We.set(c.$hK.ExtHostEditorInsets,new oe.$hdc(We.getProxy(c.$gK.MainThreadEditorInsets),Ft,dt.remote)),oi=We.set(c.$hK.ExtHostDiagnostics,new $.$bcc(We,H,Lt,Dt)),li=We.set(c.$hK.ExtHostLanguages,new S.$Zcc(We,It,lt.converter,Ct)),ct=We.set(c.$hK.ExtHostLanguageFeatures,new I.$fcc(We,Ct,It,lt,oi,H,je,vt)),Ai=We.set(c.$hK.ExtHostFileSystem,new w.$Xcc(We,ct)),Yt=We.set(c.$hK.ExtHostFileSystemEventService,new d.$Ycc(We,H,Dt)),ii=We.set(c.$hK.ExtHostQuickOpen,(0,P.$5cc)(We,at,lt)),Ri=We.set(c.$hK.ExtHostSCM,new W.$7cc(We,lt,It,H)),Mi=We.set(c.$hK.ExtHostQuickDiff,new Pt.$4dc(We,Ct)),Fi=We.set(c.$hK.ExtHostShare,new Bt.$9dc(We,Ct)),Xi=We.set(c.$hK.ExtHostComments,(0,i.$icc)(We,lt,It)),Ti=We.set(c.$hK.ExtHostProgress,new h.$4cc(We.getProxy(c.$gK.MainThreadProgress))),Zi=We.set(c.$hK.ExtHosLabelService,new be.$idc(We)),Li=We.set(c.$hK.ExtHostTheming,new ne.$Jdc(We)),ai=We.set(c.$hK.ExtHostAuthentication,new Ie.$Kdc(We)),gn=We.set(c.$hK.ExtHostTimeline,new F.$Mdc(We,lt)),Ni=We.set(c.$hK.ExtHostWebviews,new Pe.$cdc(We,dt.remote,at,H,je)),hi=We.set(c.$hK.ExtHostWebviewPanels,new x.$Odc(We,Ni,at)),Oi=We.set(c.$hK.ExtHostCustomEditors,new q.$Pdc(We,It,Fe,Ni,hi)),mn=We.set(c.$hK.ExtHostWebviewViews,new J.$Ndc(We,Ni)),di=We.set(c.$hK.ExtHostTesting,new Ue.$Rdc(We,lt,Dt)),Yi=We.set(c.$hK.ExtHostUriOpeners,new Qe.$Vdc(We)),zi=We.set(c.$hK.ExtHostProfileContentHandlers,new wt.$3dc(We));We.set(c.$hK.ExtHostInteractive,new we.$2dc(We,Et,Dt,lt,H));const xi=We.set(c.$hK.ExtHostInlineChat,new Gt.$6dc(We,lt,It,H)),fi=We.set(c.$hK.ExtHostChatProvider,new At.$0dc(We,H)),_i=We.set(c.$hK.ExtHostChatAgents,new Kt.$cec(We,fi,H)),$n=We.set(c.$hK.ExtHostChatAgents2,new Vt.$dec(We,fi,H)),Ui=We.set(c.$hK.ExtHostChatVariables,new Ot.$_dc(We)),gi=We.set(c.$hK.ExtHostChat,new Zt.$5dc(We,H)),xt=We.set(c.$hK.ExtHostAiRelatedInformation,new Wt.$aec(We)),wi=We.set(c.$hK.ExtHostAiEmbeddingVector,new Jt.$bec(We)),pn=We.set(c.$hK.ExtHostIssueReporter,new jt.$8dc(We)),Qt=We.set(c.$hK.ExtHostStatusBar,new K.$9cc(We,lt.converter)),yi=We.set(c.$hK.ExtHostSpeech,new Rt.$$dc(We)),en=Object.values(c.$hK);We.assertRegistered(en);const tn=new ce.$Qdc(We,Dt),nn=new f.$hcc(We),Ei=new u.$1cc(We,H),rn=new E.$qcc(We);return p.$gcc.register(lt),function(Le,_t,sn){const mt=function(){let te=!Le.isUnderDevelopment;function de(){te||(H.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")de();else{const $t=rt;typeof $t.scheme>"u"&&de(),typeof $t.exclusive=="boolean"&&(0,Oe.$eF)(Le,"documentFiltersExclusive")}return rt}}(),ji={getSession(te,de,Te){return ai.getSession(Le,te,de,Te)},getSessions(te,de){return(0,Oe.$eF)(Le,"authGetSessions"),ai.getSessions(Le,te,de)},async hasSession(te,de){return(0,Oe.$eF)(Le,"authSession"),!!await ai.getSession(Le,te,de,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(te,de,Te,rt){return ai.registerAuthenticationProvider(te,de,Te,rt)}},on={registerCommand(te,de,Te){return lt.registerCommand(!0,te,de,Te,void 0,Le)},registerTextEditorCommand(te,de,Te){return lt.registerCommand(!0,te,(...rt)=>{const $t=Ft.getActiveTextEditor();if(!$t){H.warn("Cannot execute "+te+" because there is no active text editor.");return}return $t.edit(Tt=>{de.apply(Te,[$t,Tt,...rt])}).then(Tt=>{Tt||H.warn("Edits from command "+te+" were not applied.")},Tt=>{H.warn("An error occurred while running command "+te,Tt)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,de,Te)=>((0,Oe.$eF)(Le,"diffCommand"),lt.registerCommand(!0,te,async(...rt)=>{const $t=Dt.activeEditor(!0);if(!$t){H.warn("Cannot execute "+te+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation($t.id);de.apply(Te,[Tt,...rt])},void 0,void 0,Le)),executeCommand(te,...de){return lt.executeCommand(te,...de)},getCommands(te=!1){return lt.getCommands(te)}},Bi={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return vt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$eF)(Le,"telemetry"),vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$eF)(Le,"telemetry"),vt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$AM)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,de){return Ye.$zM.validateSender(te),vt.instantiateLogger(Le,te,de)},openExternal(te,de){return Je.openUri(te,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===dt.environment.appUriScheme)return $i.createAppUri(te);try{return await Je.asExternalUri(te,{allowTunneling:!!dt.remote.authority})}catch(de){if((0,st.$dU)(te,ze.Schemas.http)||(0,st.$dU)(te,ze.Schemas.https))return te;throw de}},get remoteName(){return(0,_.$Vk)(dt.remote.authority)},get remoteAuthority(){return(0,Oe.$eF)(Le,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return H.getLevel()},get onDidChangeLogLevel(){return H.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Oe.$eF)(Le,"handleIssueUri"),pn.registerIssueUriRequestHandler(Le,te)},get appQuality(){return(0,Oe.$eF)(Le,"resolvers"),dt.quality},get appCommit(){return(0,Oe.$eF)(Le,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(Bi);const an={createTestController(te,de,Te){return di.createTestController(Le,te,de,Te)},createTestObserver(){return(0,Oe.$eF)(Le,"testObserver"),di.createTestObserver()},runTests(te){return(0,Oe.$eF)(Le,"testObserver"),di.runTests(te)},get onDidChangeTestResults(){return(0,Oe.$eF)(Le,"testObserver"),di.onResultsChanged},get testResults(){return(0,Oe.$eF)(Le,"testObserver"),di.results}},Di=dt.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,vn={getExtension(te,de){(0,Oe.$dF)(Le,"extensionsAny")||(de=!1);const Te=_t.mine.getExtensionDescription(te);if(Te)return new o.$Vcc(kt,Le.identifier,Te,Di,!1);if(de){const rt=_t.all.getExtensionDescription(te);if(rt)return new o.$Vcc(kt,Le.identifier,rt,Di,!0)}},get all(){const te=[];for(const de of _t.mine.getAllExtensionDescriptions())te.push(new o.$Vcc(kt,Le.identifier,de,Di,!1));return te},get allAcrossExtensionHosts(){(0,Oe.$eF)(Le,"extensionsAny");const te=new ue.$7l(_t.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),de=[];for(const Te of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Te.identifier);de.push(new o.$Vcc(kt,Le.identifier,Te,Di,rt))}return de},get onDidChange(){return(0,Oe.$dF)(Le,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},cn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(te,de){return li.changeLanguage(te.uri,de)},match(te,de){const Te=It.getDocumentData(de.uri)?.notebook;return(0,R.$sE)(ie.LanguageSelector.from(te),de.uri,de.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,de,Te){return ct.registerCodeActionProvider(Le,mt(te),de,Te)},registerDocumentPasteEditProvider(te,de,Te){return(0,Oe.$eF)(Le,"documentPaste"),ct.registerDocumentPasteEditProvider(Le,mt(te),de,Te)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Le,mt(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Le,mt(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Le,mt(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Le,mt(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Le,mt(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Le,mt(te),de,Le.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Le,mt(te),de,Le.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Le,mt(te),de,Le.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Le,mt(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Le,mt(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Le,mt(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Le,mt(te),de)},registerDocumentSymbolProvider(te,de,Te){return ct.registerDocumentSymbolProvider(Le,mt(te),de,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Le,mt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Le,mt(te),de)},registerOnTypeFormattingEditProvider(te,de,Te,...rt){return ct.registerOnTypeFormattingEditProvider(Le,mt(te),de,[Te].concat(rt))},registerDocumentSemanticTokensProvider(te,de,Te){return ct.registerDocumentSemanticTokensProvider(Le,mt(te),de,Te)},registerDocumentRangeSemanticTokensProvider(te,de,Te){return ct.registerDocumentRangeSemanticTokensProvider(Le,mt(te),de,Te)},registerSignatureHelpProvider(te,de,Te,...rt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Le,mt(te),de,Te):ct.registerSignatureHelpProvider(Le,mt(te),de,typeof Te>"u"?[]:[Te,...rt])},registerCompletionItemProvider(te,de,...Te){return ct.registerCompletionItemProvider(Le,mt(te),de,Te)},registerInlineCompletionItemProvider(te,de,Te){return de.handleDidShowCompletionItem&&(0,Oe.$eF)(Le,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$eF)(Le,"inlineCompletionsAdditions"),Te&&(0,Oe.$eF)(Le,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Le,mt(te),de,Te)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Le,mt(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Le,mt(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Le,mt(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Le,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Le,te,de)},registerTypeHierarchyProvider(te,de){return ct.registerTypeHierarchyProvider(Le,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Le,te,de),getTokenInformationAtPosition(te,de){return(0,Oe.$eF)(Le,"tokenInformation"),li.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return ct.registerInlayHintsProvider(Le,te,de)},createLanguageStatusItem(te,de){return li.createLanguageStatusItem(Le,te,de)},registerDocumentDropEditProvider(te,de,Te){return ct.registerDocumentOnDropEditProvider(Le,te,de,(0,Oe.$dF)(Le,"dropMetadata")?Te:void 0)}},un={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(te,de,Te){const rt=await(A.URI.isUri(te)?Promise.resolve(ki.openTextDocument(te)):Promise.resolve(te));return Ft.showTextDocument(rt,de,Te)},createTextEditorDecorationType(te){return Ft.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,de,Te){return Ft.onDidChangeActiveTextEditor(te,de,Te)},onDidChangeVisibleTextEditors(te,de,Te){return Ft.onDidChangeVisibleTextEditors(te,de,Te)},onDidChangeTextEditorSelection(te,de,Te){return Ft.onDidChangeTextEditorSelection(te,de,Te)},onDidChangeTextEditorOptions(te,de,Te){return Ft.onDidChangeTextEditorOptions(te,de,Te)},onDidChangeTextEditorVisibleRanges(te,de,Te){return Ft.onDidChangeTextEditorVisibleRanges(te,de,Te)},onDidChangeTextEditorViewColumn(te,de,Te){return Ft.onDidChangeTextEditorViewColumn(te,de,Te)},onDidCloseTerminal(te,de,Te){return gt.onDidCloseTerminal(te,de,Te)},onDidOpenTerminal(te,de,Te){return gt.onDidOpenTerminal(te,de,Te)},onDidChangeActiveTerminal(te,de,Te){return gt.onDidChangeActiveTerminal(te,de,Te)},onDidChangeTerminalDimensions(te,de,Te){return(0,Oe.$eF)(Le,"terminalDimensions"),gt.onDidChangeTerminalDimensions(te,de,Te)},onDidChangeTerminalState(te,de,Te){return gt.onDidChangeTerminalState(te,de,Te)},onDidWriteTerminalData(te,de,Te){return(0,Oe.$eF)(Le,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(te,de,Te)},onDidExecuteTerminalCommand(te,de,Te){return(0,Oe.$eF)(Le,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(te,de,Te)},get state(){return Je.getState(Le)},onDidChangeWindowState(te,de,Te){return Je.onDidChangeWindowState(te,de,Te)},showInformationMessage(te,...de){return Ei.showMessage(Le,T.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return Ei.showMessage(Le,T.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return Ei.showMessage(Le,T.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Te){return ii.showQuickPick(Le,te,de,Te)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,de){return ii.showInput(te,de)},showOpenDialog(te){return rn.showOpenDialog(Le,te)},showSaveDialog(te){return rn.showSaveDialog(te)},createStatusBarItem(te,de,Te){let rt,$t,Tt;return typeof te=="string"?(rt=te,$t=de,Tt=Te):($t=te,Tt=de),Qt.createStatusBarEntry(Le,rt,$t,Tt)},setStatusBarMessage(te,de){return Qt.setStatusBarMessage(te,de)},withScmProgress(te){return je.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ti.withProgress(Le,{location:X.ProgressLocation.SourceControl},(de,Te)=>te({report(rt){}}))},withProgress(te,de){return Ti.withProgress(Le,te,de)},createOutputChannel(te,de){return Si.createOutputChannel(te,de,Le)},createWebviewPanel(te,de,Te,rt){return hi.createWebviewPanel(Le,te,de,Te,rt)},createWebviewTextEditorInset(te,de,Te,rt){return(0,Oe.$eF)(Le,"editorInsets"),Pi.createWebviewEditorInset(te,de,Te,rt,Le)},createTerminal(te,de,Te){return typeof te=="object"?"pty"in te?gt.createExtensionTerminal(te):gt.createTerminalFromOptions(te):gt.createTerminal(te,de,Te)},registerTerminalLinkProvider(te){return gt.registerLinkProvider(te)},registerTerminalProfileProvider(te,de){return gt.registerProfileProvider(Le,te,de)},registerTerminalQuickFixProvider(te,de){return(0,Oe.$eF)(Le,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(te,Le.identifier.value,de)},registerTreeDataProvider(te,de){return bi.registerTreeDataProvider(te,de,Le)},createTreeView(te,de){return bi.createTreeView(te,de,Le)},registerWebviewPanelSerializer:(te,de)=>hi.registerWebviewPanelSerializer(Le,te,de),registerCustomEditorProvider:(te,de,Te={})=>Oi.registerCustomEditorProvider(Le,te,de,Te),registerFileDecorationProvider(te){return zt.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return $i.registerUriHandler(Le,te)},createQuickPick(){return ii.createQuickPick(Le)},createInputBox(){return ii.createInputBox(Le)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(te,de,Te){return Li.onDidChangeActiveColorTheme(te,de,Te)},registerWebviewViewProvider(te,de,Te){return mn.registerWebviewViewProvider(Le,te,de,Te?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Te){return Et.onDidChangeActiveNotebookEditor(te,de,Te)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Te){return vi.onDidChangeNotebookEditorSelection(te,de,Te)},onDidChangeNotebookEditorVisibleRanges(te,de,Te){return vi.onDidChangeNotebookEditorVisibleRanges(te,de,Te)},showNotebookDocument(te,de){return Et.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Te){return(0,Oe.$eF)(Le,"externalUriOpener"),Yi.registerExternalUriOpener(Le.identifier,te,de,Te)},registerProfileContentHandler(te,de){return(0,Oe.$eF)(Le,"profileContentHandlers"),zi.registrProfileContentHandler(Le,te,de)},registerQuickDiffProvider(te,de,Te,rt){return(0,Oe.$eF)(Le,"quickDiffProvider"),Mi.registerQuickDiffProvider(mt(te),de,Te,rt)},get tabGroups(){return et.tabGroups},registerShareProvider(te,de){return(0,Oe.$eF)(Le,"shareProvider"),Fi.registerShareProvider(mt(te),de)}},ki={get rootPath(){return je.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(te){throw new M.$9("rootPath")},getWorkspaceFolder(te){return at.getWorkspaceFolder(te)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(te){throw new M.$9("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(te){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(te,de,...Te)=>at.updateWorkspaceFolders(Le,te,de||0,...Te),onDidChangeWorkspaceFolders:function(te,de,Te){return at.onDidChangeWorkspace(te,de,Te)},asRelativePath:(te,de)=>at.getRelativePath(te,de),findFiles:(te,de,Te,rt)=>at.findFiles(te,de,Te,Le.identifier,rt),findTextInFiles:(te,de,Te,rt)=>{(0,Oe.$eF)(Le,"findTextInFiles");let $t,Tt;return typeof de=="object"?($t=de,Tt=Te):($t={},Tt=de,rt=Te),at.findTextInFiles(te,$t||{},Tt,Le.identifier,rt)},save:te=>((0,Oe.$eF)(Le,"saveEditor"),at.save(te)),saveAs:te=>((0,Oe.$eF)(Le,"saveEditor"),at.saveAs(te)),saveAll:te=>at.saveAll(te),applyEdit(te,de){return tn.applyWorkspaceEdit(te,Le,de)},createFileSystemWatcher:(te,de,Te,rt)=>{let $t;return typeof de=="boolean"?$t={ignoreCreateEvents:!!de,ignoreChangeEvents:!!Te,ignoreDeleteEvents:!!rt}:de&&((0,Oe.$eF)(Le,"createFileSystemWatcher"),$t=de),Yt.createFileSystemWatcher(at,Le,te,$t)},get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new M.$9("textDocuments")},openTextDocument(te){let de;const Te=te;if(typeof te=="string")de=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))de=Promise.resolve(te);else if(!Te||typeof Te=="object")de=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>It.ensureDocumentData(rt).then($t=>$t.document))},onDidOpenTextDocument:(te,de,Te)=>It.onDidAddDocument(te,de,Te),onDidCloseTextDocument:(te,de,Te)=>It.onDidRemoveDocument(te,de,Te),onDidChangeTextDocument:(te,de,Te)=>It.onDidChangeDocument(te,de,Te),onDidSaveTextDocument:(te,de,Te)=>It.onDidSaveDocument(te,de,Te),onWillSaveTextDocument:(te,de,Te)=>ri.getOnWillSaveTextDocumentEvent(Le)(te,de,Te),get notebookDocuments(){return Et.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,de){let Te;if(A.URI.isUri(te))Te=te,await Et.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await Et.createNotebookDocument({viewType:te,content:de}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,de,Te){return pi.onDidSaveNotebookDocument(te,de,Te)},onDidChangeNotebookDocument(te,de,Te){return pi.onDidChangeNotebookDocument(te,de,Te)},onWillSaveNotebookDocument(te,de,Te){return Ci.getOnWillSaveNotebookDocumentEvent(Le)(te,de,Te)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(te,de,Te,rt){return Et.registerNotebookSerializer(Le,te,de,Te,(0,Oe.$dF)(Le,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,de,Te)=>sn.onDidChangeConfiguration(te,de,Te),getConfiguration(te,de){return de=arguments.length===1?void 0:de,sn.getConfiguration(te,de,Le)},registerTextDocumentContentProvider(te,de){return fn.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(je.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Le,te,de)),registerFileSystemProvider(te,de,Te){return(0,Be.$Pc)(Ai.registerFileSystemProvider(Le,te,de,Te),qt.addFileSystemProvider(te,de,Te))},get fs(){return qt.value},registerFileSearchProvider:(te,de)=>((0,Oe.$eF)(Le,"fileSearchProvider"),mi.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Oe.$eF)(Le,"textSearchProvider"),mi.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Oe.$eF)(Le,"resolvers"),kt.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Oe.$eF)(Le,"resolvers"),Zi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Oe.$eF)(Le,"resolvers"),kt.getRemoteExecServer(te)),onDidCreateFiles:(te,de,Te)=>Yt.onDidCreateFile(te,de,Te),onDidDeleteFiles:(te,de,Te)=>Yt.onDidDeleteFile(te,de,Te),onDidRenameFiles:(te,de,Te)=>Yt.onDidRenameFile(te,de,Te),onWillCreateFiles:(te,de,Te)=>Yt.getOnWillCreateFileEvent(Le)(te,de,Te),onWillDeleteFiles:(te,de,Te)=>Yt.getOnWillDeleteFileEvent(Le)(te,de,Te),onWillRenameFiles:(te,de,Te)=>Yt.getOnWillRenameFileEvent(Le)(te,de,Te),openTunnel:te=>((0,Oe.$eF)(Le,"tunnels"),Me.openTunnel(Le,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Oe.$eF)(Le,"tunnels"),Me.getTunnels()},onDidChangeTunnels:(te,de,Te)=>((0,Oe.$eF)(Le,"tunnels"),Me.onDidChangeTunnels(te,de,Te)),registerPortAttributesProvider:(te,de)=>((0,Oe.$eF)(Le,"portsAttributes"),Me.registerPortsAttributesProvider(te,de)),registerTunnelProvider:(te,de)=>((0,Oe.$eF)(Le,"tunnelFactory"),Me.registerTunnelProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Oe.$eF)(Le,"timeline"),gn.registerTimelineProvider(te,de,Le.identifier,lt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:te=>((0,Oe.$eF)(Le,"workspaceTrust"),at.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Te)=>at.onDidGrantWorkspaceTrust(te,de,Te),registerEditSessionIdentityProvider:(te,de)=>((0,Oe.$eF)(Le,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(te,de)),onWillCreateEditSessionIdentity:(te,de,Te)=>((0,Oe.$eF)(Le,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(Le)(te,de,Te)),registerCanonicalUriProvider:(te,de)=>((0,Oe.$eF)(Le,"canonicalUriProvider"),at.registerCanonicalUriProvider(te,de)),getCanonicalUri:(te,de,Te)=>((0,Oe.$eF)(Le,"canonicalUriProvider"),at.provideCanonicalUri(te,de,Te))},Wi={get inputBox(){return je.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Le)},createSourceControl(te,de,Te){return Ri.createSourceControl(Le,te,de,Te)}},Ki={createCommentController(te,de){return Xi.createCommentController(Le,te,de)}},ci={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(te,de,Te){return yt.onDidStartDebugSession(te,de,Te)},onDidTerminateDebugSession(te,de,Te){return yt.onDidTerminateDebugSession(te,de,Te)},onDidChangeActiveDebugSession(te,de,Te){return yt.onDidChangeActiveDebugSession(te,de,Te)},onDidReceiveDebugSessionCustomEvent(te,de,Te){return yt.onDidReceiveDebugSessionCustomEvent(te,de,Te)},onDidChangeBreakpoints(te,de,Te){return yt.onDidChangeBreakpoints(te,de,Te)},onDidChangeStackFrameFocus(te,de,Te){return(0,Oe.$eF)(Le,"debugFocus"),yt.onDidChangeStackFrameFocus(te,de,Te)},registerDebugConfigurationProvider(te,de,Te){return yt.registerDebugConfigurationProvider(te,de,Te||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return yt.registerDebugAdapterDescriptorFactory(Le,te,de)},registerDebugAdapterTrackerFactory(te,de){return yt.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?yt.startDebugging(te,de,{parentSession:Te}):yt.startDebugging(te,de,Te||{})},stopDebugging(te){return yt.stopDebugging(te)},addBreakpoints(te){return yt.addBreakpoints(te)},removeBreakpoints(te){return yt.removeBreakpoints(te)},asDebugSourceUri(te,de){return yt.asDebugSourceUri(te,de)}},Vi={registerTaskProvider:(te,de)=>St.registerTaskProvider(Le,te,de),fetchTasks:te=>St.fetchTasks(te),executeTask:te=>St.executeTask(Le,te),get taskExecutions(){return St.taskExecutions},onDidStartTask:(te,de,Te)=>St.onDidStartTask(te,de,Te),onDidEndTask:(te,de,Te)=>St.onDidEndTask(te,de,Te),onDidStartTaskProcess:(te,de,Te)=>St.onDidStartTaskProcess(te,de,Te),onDidEndTaskProcess:(te,de,Te)=>St.onDidEndTaskProcess(te,de,Te)},qi={createNotebookController(te,de,Te,rt,$t){return si.createNotebookController(Le,te,de,Te,rt,(0,Oe.$dF)(Le,"notebookMessaging")?$t:void 0)},registerNotebookCellStatusBarItemProvider:(te,de)=>Et.registerNotebookCellStatusBarItemProvider(Le,te,de),createRendererMessaging(te){return Ii.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Oe.$eF)(Le,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,de){return(0,Oe.$eF)(Le,"notebookKernelSource"),si.registerKernelSourceActionProvider(Le,te,de)},onDidChangeNotebookCellExecutionState(te,de,Te){return(0,Oe.$eF)(Le,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,de,Te)}},Hi={t(...te){if(typeof te[0]=="string"){const de=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return ui.getMessage(Le.identifier.value,{message:de,args:Te})}return ui.getMessage(Le.identifier.value,te[0])},get bundle(){return ui.getBundle(Le.identifier.value)},get uri(){return ui.getBundleUri(Le.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(te,de){return(0,Oe.$eF)(Le,"interactive"),xi.registerProvider(Le,te,de={label:de?.label??Le.displayName??Le.name})},registerInteractiveSessionProvider(te,de){return(0,Oe.$eF)(Le,"interactive"),gi.registerChatProvider(Le,te,de)},sendInteractiveRequestToProvider(te,de){return(0,Oe.$eF)(Le,"interactive"),gi.sendInteractiveRequestToProvider(te,de)},get onDidPerformUserAction(){return(0,Oe.$eF)(Le,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(te,de){return(0,Oe.$eF)(Le,"interactive"),gi.transferChatSession(te,de)}},ln={getRelatedInformation(te,de){return(0,Oe.$eF)(Le,"aiRelatedInformation"),xt.getRelatedInformation(Le,te,de)},registerRelatedInformationProvider(te,de){return(0,Oe.$eF)(Le,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Le,te,de)},registerEmbeddingVectorProvider(te,de){return(0,Oe.$eF)(Le,"aiRelatedInformation"),wi.registerEmbeddingVectorProvider(Le,te,de)}},hn={registerChatResponseProvider(te,de,Te){return(0,Oe.$eF)(Le,"chatProvider"),fi.registerProvider(Le.identifier,te,de,Te)},requestChatAccess(te){return(0,Oe.$eF)(Le,"chatRequestAccess"),fi.requestChatResponseProvider(Le.identifier,te)},registerVariable(te,de,Te){return(0,Oe.$eF)(Le,"chatVariables"),Ui.registerVariableResolver(Le,te,de,Te)},registerMappedEditsProvider(te,de){return(0,Oe.$eF)(Le,"mappedEditsProvider"),ct.registerMappedEditsProvider(Le,te,de)},createChatAgent(te,de){return(0,Oe.$eF)(Le,"chatAgents2"),$n.createChatAgent(Le,te,de)},registerAgent(te,de,Te){return(0,Oe.$eF)(Le,"chatAgents"),_i.registerAgent(Le.identifier,te,de,Te)}},dn={registerSpeechProvider(te,de){return(0,Oe.$eF)(Le,"speech"),yi.registerProvider(Le.identifier,te,de)}};return{version:dt.version,ai:ln,authentication:ji,commands:on,comments:Ki,chat:hn,debug:ci,env:Bi,extensions:vn,interactive:Gi,l10n:Hi,languages:cn,notebooks:qi,scm:Wi,speech:dn,tasks:Vi,tests:an,window:un,workspace:ki,Breakpoint:X.$gL,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatAgentResultFeedbackKind:X.ChatAgentResultFeedbackKind,ChatMessage:X.$9L,ChatMessageRole:X.ChatMessageRole,ChatVariableLevel:X.ChatVariableLevel,CallHierarchyIncomingCall:X.$FK,CallHierarchyItem:X.$EK,CallHierarchyOutgoingCall:X.$GK,CancellationError:M.$5,CancellationTokenSource:y.$Xd,CandidatePortSource:c.CandidatePortSource,CodeAction:X.$BK,CodeActionKind:X.$CK,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$HK,Color:X.$UK,ColorInformation:X.$VK,ColorPresentation:X.$WK,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.$OK,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$PK,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$5K,DebugAdapterExecutable:X.$kL,DebugAdapterInlineImplementation:X.$nL,DebugAdapterNamedPipeServer:X.$mL,DebugAdapterServer:X.$lL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$wK,DiagnosticRelatedInformation:X.$vK,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$iK,DocumentHighlight:X.$yK,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.$TK,DocumentSymbol:X.$AK,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$qL,InlineValueText:X.$rL,InlineValueVariableLookup:X.$sL,InlineValueEvaluatableExpression:X.$tL,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:C.$Nd,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$DL,FileDecoration2:X.$DL,FileSystemError:X.$vL,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:X.$wL,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$iL,InlineCompletionItem:X.$QK,InlineCompletionList:X.$RK,Hover:X.$xK,IndentAction:g.IndentAction,Location:X.$uK,MarkdownString:X.$IK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:X.$JK,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$jK,ProcessExecution:X.$3K,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$CL,Range:X.$kK,RelativePattern:X.$eL,Selection:X.$lK,SelectionRange:X.$DK,SemanticTokens:X.$zL,SemanticTokensBuilder:X.$yL,SemanticTokensEdit:X.$AL,SemanticTokensEdits:X.$BL,SemanticTokensLegend:X.$xL,ShellExecution:X.$4K,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$LK,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$KK,SnippetString:X.$tK,SourceBreakpoint:X.$hL,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$zK,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$6K,TaskGroup:X.$2K,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$XK,TerminalQuickFixExecuteTerminalCommand:X.$ZK,TerminalQuickFixOpener:X.$YK,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$1K,TerminalExitReason:X.TerminalExitReason,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$pK,SnippetTextEdit:X.$rK,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$dL,ThemeIcon:X.$cL,TreeItem:X.$7K,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$YL,UIKind:b.UIKind,Uri:A.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$sK,DocumentDropEdit:X.$aL,DocumentPasteEdit:X.$bL,InlayHint:X.$NK,InlayHintLabelPart:X.$MK,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$oK,ResolvedAuthority:X.$mK,ManagedResolvedAuthority:X.$nK,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$NL,NotebookRange:X.$FL,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$GL,NotebookData:X.$HL,NotebookRendererScript:X.$LL,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$JL,NotebookCellOutputItem:X.$IL,NotebookCellStatusBarItem:X.$KL,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$qK,NotebookKernelSourceAction:X.$ML,PortAttributes:X.$PL,LinkedEditingRanges:X.$OL,TestResultState:X.TestResultState,TestRunRequest:X.$QL,TestMessage:X.$RL,TestMessage2:X.$RL,TestTag:X.$SL,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:X.$_K,DataTransferItem:X.$8K,CoveredCount:X.$TL,FileCoverage:X.$UL,StatementCoverage:X.$VL,BranchCoverage:X.$WL,FunctionCoverage:X.$XL,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$ZL,TabInputTextDiff:X.$1L,TabInputTextMerge:X.$2L,TabInputCustom:X.$3L,TabInputNotebook:X.$5L,TabInputNotebookDiff:X.$6L,TabInputWebview:X.$4L,TabInputTerminal:X.$7L,TabInputInteractiveWindow:X.$8L,TelemetryTrustedValue:Ee.$ko,LogLevel:ge.LogLevel,EditSessionIdentityMatch:ft.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.$oL,ThreadFocus:X.$pL,RelatedInformationType:X.RelatedInformationType,SpeechToTextStatus:X.SpeechToTextStatus}}}e.$eec=Mt}),define(Ae[276],Re([1,0,70,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,40,83,58,61,243,14,112,81,82]),function(ye,e,y,M,C,T,A,l,D,g,R,k,c,b,p,f,t,i,a,$,E,v,n,r,s,o,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$xr)(o.$Pcc,o.$Occ,1),(0,y.$xr)(r.$$i,n.$fec,1),(0,y.$xr)(f.$ccc,f.$dcc,1),(0,y.$xr)(l.$DM,l.$CM,0),(0,y.$xr)(A.$pcc,A.$ncc,0),(0,y.$xr)(i.$Ecc,i.$Dcc,0),(0,y.$xr)(k.$sdc,k.$wdc,0),(0,y.$xr)(T.$kdc,T.$jdc,0),(0,y.$xr)(D.$sM,D.$rM,0),(0,y.$xr)(w.$Qcc,w.$Rcc,0),(0,y.$xr)(a.$_bc,a.$$bc,0),(0,y.$xr)(M.$3cc,M.$2cc,1),(0,y.$xr)(c.$Cdc,c.$Ddc,0),(0,y.$xr)(b.$Acc,b.$zcc,0),(0,y.$xr)(R.$ndc,R.$mdc,0),(0,y.$xr)(g.$Hcc,g.$Kcc,0),(0,y.$xr)(p.$6vb,p.$7vb,0),(0,y.$xr)(t.$gdc,t.$fdc,0),(0,y.$xr)(C.$mcc,C.$lcc,0),(0,y.$xr)($.$Mcc,$.$Lcc,0),(0,y.$xr)(E.$BM,E.$yM,0),(0,y.$xr)(v.$odc,v.$pdc,0),(0,y.$xr)(s.$qdc,s.$rdc,0)}),define(Ae[277],Re([1,0,275,35,2,272,7,12,263]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class g extends T.$iec{j(){}getModule(b,p){for(const f of this.b){const t=f(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends M.$Tcc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$ngc);const b=this.h.invokeFunction(y.$eec);this.r=this.h.createInstance(g,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,p,f){p=p.with({path:k(p.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.C.$asBrowserUri(p)),a=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),a.status!==200)throw new Error(a.statusText);const $=await a.text(),E=`${p.toString(!0)}#vscode-extension`,v=`${$}
//# sourceURL=${E}`;let n;try{n=new Function("module","exports","require",v)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${p.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}b&&await this.w.initializeLocalizedMessages(b);const r={},s={exports:r},o=w=>{const d=this.r.getModule(w,p);if(d===void 0)throw new Error(`Cannot load module '${w}'`);return d};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(s,r,o),s.exports!==r?s.exports:r}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+b;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Ug)(10)}}e.$ogc=R;function k(c,b){return c.endsWith(b)?c:c+b}}),define(Ae[278],Re([1,0,69,70,14,35,187,85,277]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$xr)(C.$0i,new y.$Mh(A.$hec,[!0],!0)),(0,M.$xr)(T.$Ucc,D.$ogc,0),(0,M.$xr)(l.$Fcc,l.$Gcc,0)}),define(Ae[287],Re([1,0,26,5,79,273,265,20,87,13,2,276,278]),function(ye,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const p=fetch.bind(self);function f(n){self.fetch=async function(r,s){return r instanceof Request||b(String(r))&&(r=(await n(R.URI.parse(String(r)))).toString(!0)),p(r,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,s,o,w,d){(async()=>(b(s.toString())&&(s=(await n(R.URI.parse(s.toString()))).toString(!0)),super.open(r,s,o??!0,w,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(r,s){if(/^file:/i.test(r.toString()))r=g.$cg.uriToBrowserUri(R.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(u){function m(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const h=fetch.bind(self);self.fetch=function(W,K){return W instanceof Request?h(W,K):h(m(W),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,K,z,j,O){return super.open(W,m(K),z??!0,j,O)}};const P=importScripts.bind(self);self.importScripts=(...W)=>{P(...W.map(m))},P(u)}.toString()}('${r}'))`;s=s||{},s.name=s.name||l.$nc(r.toString());const d=new Blob([w],{type:"application/javascript"}),I=URL.createObjectURL(d);return new n(I,s)}}else self.Worker=class extends A.$pgc{constructor(n,r){super(c,n,{name:l.$nc(n.toString()),...r})}};const t=new class{constructor(){this.pid=void 0}exit(n){k()}};class i{constructor(){const r=new MessageChannel,s=new M.$Nd;let o=!1;c(r.port2,[r.port2]),r.port1.onmessage=w=>{const{data:d}=w;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const I=y.$be.wrap(new Uint8Array(d,0,d.byteLength));if((0,C.$cm)(I,2)){o=!0,$("received terminate message from renderer");return}s.fire(I)},this.protocol={onMessage:s.event,send:w=>{if(!o){const d=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);r.port1.postMessage(d,[d])}}}}}function a(n){return new Promise(r=>{const s=n.onMessage(o=>{s.dispose();const w=JSON.parse(o.toString());n.send((0,C.$bm)(0)),r({protocol:n,initData:w})});n.send((0,C.$bm)(1))})}let $=n=>k();function E(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function v(){D.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(r){E(r)&&a(n.protocol).then(s=>{D.mark("code/extHost/didWaitForInitData");const o=new T.$kec(s.protocol,s.initData,t,null,r.data);f(w=>o.asBrowserUri(w)),$=w=>o.terminate(w)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c36b92c82064882a228487040187cfc13669c0f/core/vs/workbench/api/worker/extensionHostWorker.js.map
